/*===========================================================================*/
/*   (Llib/music.scm)                                                        */
/*   Bigloo (4.3g)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu 27 Feb 2020 07:59:49 AM CET     */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo4.3g/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo4.3g/lib/bigloo/4.3g -lib-dir /builddir/build/BUILD/bigloo4.3g/lib/bigloo/4.3g -I Llib -lib-dir /builddir/build/BUILD/bigloo4.3g/lib/bigloo/4.3g -unsafe -safee -srfi alsa -copt  -copt -fPIC -copt -IClib Llib/music.scm -o objs/music.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>
#include <alsa/asoundlib.h>
#include <bglalsa.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_musicz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_onstatez00;
   obj_t BgL_onvolumez00;
   obj_t BgL_onerrorz00;
   obj_t BgL_oneventz00;
   obj_t BgL_z52mutexz52;
   struct BgL_musicstatusz00_bgl * BgL_z52statusz52;
} *BgL_musicz00_bglt;

typedef struct BgL_musicstatusz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_statez00;
   obj_t BgL_volumez00;
   bool_t BgL_repeatz00;
   bool_t BgL_randomz00;
   int BgL_playlistidz00;
   int BgL_playlistlengthz00;
   int BgL_xfadez00;
   int BgL_songz00;
   int BgL_songidz00;
   obj_t BgL_songposz00;
   int BgL_songlengthz00;
   int BgL_bitratez00;
   int BgL_khza7za7;
   obj_t BgL_errz00;
   int BgL_bufferingz00;
} *BgL_musicstatusz00_bglt;

typedef struct BgL_musicbufz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_onstatez00;
   obj_t BgL_onvolumez00;
   obj_t BgL_onerrorz00;
   obj_t BgL_oneventz00;
   obj_t BgL_z52mutexz52;
   struct BgL_musicstatusz00_bgl * BgL_z52statusz52;
   obj_t BgL_inbufz00;
   obj_t BgL_decodersz00;
   obj_t BgL_mkthreadz00;
   obj_t BgL_timeoutz00;
   obj_t BgL_z52decoderz52;
   obj_t BgL_z52bufferz52;
   obj_t BgL_z52nextbufferz52;
   obj_t BgL_z52playlistz52;
   bool_t BgL_z52areadyz52;
   obj_t BgL_z52amutexz52;
   int BgL_z52z12pidz40;
   obj_t BgL_z52acondvz52;
} *BgL_musicbufz00_bglt;

typedef struct BgL_alsazd2sndzd2pcmz00_bgl {
   header_t header;
   obj_t widening;
   snd_pcm_t * BgL_z42builtinz42;
   obj_t BgL_namez00;
   obj_t BgL_devicez00;
   obj_t BgL_streamz00;
   obj_t BgL_modez00;
   int BgL_hwbpsz00;
   int BgL_hwsratez00;
} *BgL_alsazd2sndzd2pcmz00_bglt;

typedef struct BgL_alsamusicz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_onstatez00;
   obj_t BgL_onvolumez00;
   obj_t BgL_onerrorz00;
   obj_t BgL_oneventz00;
   obj_t BgL_z52mutexz52;
   struct BgL_musicstatusz00_bgl * BgL_z52statusz52;
   obj_t BgL_inbufz00;
   obj_t BgL_decodersz00;
   obj_t BgL_mkthreadz00;
   obj_t BgL_timeoutz00;
   obj_t BgL_z52decoderz52;
   obj_t BgL_z52bufferz52;
   obj_t BgL_z52nextbufferz52;
   obj_t BgL_z52playlistz52;
   bool_t BgL_z52areadyz52;
   obj_t BgL_z52amutexz52;
   int BgL_z52z12pidz40;
   obj_t BgL_z52acondvz52;
   struct BgL_alsazd2sndzd2pcmz00_bgl * BgL_pcmz00;
} *BgL_alsamusicz00_bglt;


BGL_IMPORT obj_t BGl_classzd2nilzd2initz12z12zz__objectz00(obj_t);
static obj_t BGl_z62musicbufzd2resetz12zd2alsa1116z70zz__alsa_musicz00(obj_t, obj_t);
static obj_t BGl_z62musicbufzd2writezd2alsam1118z62zz__alsa_musicz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_objectzd2initzd2zz__alsa_musicz00();
BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_alsamusicz00zz__alsa_musicz00 = BUNSPEC;
BGL_IMPORT obj_t BGl_musicbufz00zz__multimediazd2musicbufzd2;
static obj_t BGl_methodzd2initzd2zz__alsa_musicz00();
static obj_t BGl_z62zc3z04anonymousza31146ze3ze5zz__alsa_musicz00(obj_t);
BGL_IMPORT obj_t BGl_conditionzd2variablezd2nilz00zz__threadz00();
BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_gczd2rootszd2initz00zz__alsa_musicz00();
extern obj_t BGl_alsazd2sndzd2pcmzd2openzd2zz__alsa_pcmz00(BgL_alsazd2sndzd2pcmz00_bglt);
BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_musicstatusz00zz__multimediazd2musiczd2;
extern obj_t BGl_alsazd2sndzd2pcmzd2closezd2zz__alsa_pcmz00(BgL_alsazd2sndzd2pcmz00_bglt);
static obj_t BGl_requirezd2initializa7ationz75zz__alsa_musicz00 = BUNSPEC;
extern obj_t BGl_alsazd2sndzd2pcmzd2getzd2statez00zz__alsa_pcmz00(BgL_alsazd2sndzd2pcmz00_bglt);
static obj_t BGl_z62musicbufzd2initz12zd2alsam1114z70zz__alsa_musicz00(obj_t, obj_t);
static obj_t BGl_toplevelzd2initzd2zz__alsa_musicz00();
static obj_t BGl_genericzd2initzd2zz__alsa_musicz00();
extern obj_t BGl_alsazd2sndzd2pcmzd2dropzd2zz__alsa_pcmz00(BgL_alsazd2sndzd2pcmz00_bglt);
BGL_IMPORT obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t, bool_t, bool_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31135ze3ze5zz__alsa_musicz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_mutexzd2nilzd2zz__threadz00();
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
extern obj_t BGl_alsazd2sndzd2pcmz00zz__alsa_pcmz00;
static obj_t BGl_z62musiczd2closezd2alsamusi1110z62zz__alsa_musicz00(obj_t, obj_t);
static obj_t BGl_z62musiczd2closedzf3zd2alsamu1112z91zz__alsa_musicz00(obj_t, obj_t);
static BgL_alsamusicz00_bglt BGl_z62lambda1129z62zz__alsa_musicz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_alsamusicz00_bglt BGl_z62lambda1133z62zz__alsa_musicz00(obj_t);
BGL_IMPORT obj_t BGl_classzd2constructorzd2zz__objectz00(obj_t);
static BgL_alsazd2sndzd2pcmz00_bglt BGl_z62lambda1144z62zz__alsa_musicz00(obj_t, obj_t);
static obj_t BGl_z62lambda1145z62zz__alsa_musicz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__alsa_musicz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__alsa_pcmz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__alsa_alsaz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2musicbufzd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
extern long BGl_alsazd2sndzd2pcmzd2writezd2zz__alsa_pcmz00(BgL_alsazd2sndzd2pcmz00_bglt, char *, long);
static obj_t BGl_cnstzd2initzd2zz__alsa_musicz00();
static obj_t BGl_libraryzd2moduleszd2initz00zz__alsa_musicz00();
static obj_t BGl_importedzd2moduleszd2initz00zz__alsa_musicz00();
BGL_IMPORT obj_t BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(obj_t);
extern obj_t BGl_alsazd2sndzd2pcmzd2cleanupzd2zz__alsa_pcmz00(BgL_alsazd2sndzd2pcmz00_bglt);
static obj_t __cnst[ 8 ] ;


BGL_IMPORT obj_t BGl_musiczd2initzd2envz00zz__multimediazd2musiczd2;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1203z00zz__alsa_musicz00, BgL_bgl_za762za7c3za704anonymo1244za7, BGl_z62zc3z04anonymousza31146ze3ze5zz__alsa_musicz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1204z00zz__alsa_musicz00, BgL_bgl_za762lambda1145za7621245z00, BGl_z62lambda1145z62zz__alsa_musicz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1205z00zz__alsa_musicz00, BgL_bgl_za762lambda1144za7621246z00, BGl_z62lambda1144z62zz__alsa_musicz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1206z00zz__alsa_musicz00, BgL_bgl_za762za7c3za704anonymo1247za7, BGl_z62zc3z04anonymousza31135ze3ze5zz__alsa_musicz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1207z00zz__alsa_musicz00, BgL_bgl_za762lambda1133za7621248z00, BGl_z62lambda1133z62zz__alsa_musicz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1208z00zz__alsa_musicz00, BgL_bgl_za762lambda1129za7621249z00, BGl_z62lambda1129z62zz__alsa_musicz00, 0L, BUNSPEC, 19 );
BGL_IMPORT obj_t BGl_musicbufzd2initz12zd2envz12zz__multimediazd2musicbufzd2;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1211z00zz__alsa_musicz00, BgL_bgl_za762musicza7d2close1250z00, BGl_z62musiczd2closezd2alsamusi1110z62zz__alsa_musicz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1213z00zz__alsa_musicz00, BgL_bgl_za762musicza7d2close1251z00, BGl_z62musiczd2closedzf3zd2alsamu1112z91zz__alsa_musicz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1215z00zz__alsa_musicz00, BgL_bgl_za762musicbufza7d2in1252z00, BGl_z62musicbufzd2initz12zd2alsam1114z70zz__alsa_musicz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1217z00zz__alsa_musicz00, BgL_bgl_za762musicbufza7d2re1253z00, BGl_z62musicbufzd2resetz12zd2alsa1116z70zz__alsa_musicz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1219z00zz__alsa_musicz00, BgL_bgl_za762musicbufza7d2wr1254z00, BGl_z62musicbufzd2writezd2alsam1118z62zz__alsa_musicz00, 0L, BUNSPEC, 3 );
BGL_IMPORT obj_t BGl_musicbufzd2resetz12zd2envz12zz__multimediazd2musicbufzd2;
BGL_IMPORT obj_t BGl_musiczd2closedzf3zd2envzf3zz__multimediazd2musiczd2;
BGL_IMPORT obj_t BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00;
BGL_IMPORT obj_t BGl_musiczd2closezd2envz00zz__multimediazd2musiczd2;
DEFINE_STRING( BGl_string1202z00zz__alsa_musicz00, BgL_bgl_string1202za700za7za7_1255za7, "Llib/music.scm", 14 );
DEFINE_STRING( BGl_string1209z00zz__alsa_musicz00, BgL_bgl_string1209za700za7za7_1256za7, "", 0 );
BGL_IMPORT obj_t BGl_musicbufzd2writezd2envz00zz__multimediazd2musicbufzd2;
DEFINE_STRING( BGl_string1210z00zz__alsa_musicz00, BgL_bgl_string1210za700za7za7_1257za7, "default", 7 );
DEFINE_STRING( BGl_string1212z00zz__alsa_musicz00, BgL_bgl_string1212za700za7za7_1258za7, "music-close", 11 );
DEFINE_STRING( BGl_string1214z00zz__alsa_musicz00, BgL_bgl_string1214za700za7za7_1259za7, "music-closed?", 13 );
DEFINE_STRING( BGl_string1216z00zz__alsa_musicz00, BgL_bgl_string1216za700za7za7_1260za7, "musicbuf-init!", 14 );
DEFINE_STRING( BGl_string1218z00zz__alsa_musicz00, BgL_bgl_string1218za700za7za7_1261za7, "musicbuf-reset!", 15 );
DEFINE_STRING( BGl_string1220z00zz__alsa_musicz00, BgL_bgl_string1220za700za7za7_1262za7, "musicbuf-write", 14 );
DEFINE_STRING( BGl_string1221z00zz__alsa_musicz00, BgL_bgl_string1221za700za7za7_1263za7, "__alsa_music", 12 );
DEFINE_STRING( BGl_string1222z00zz__alsa_musicz00, BgL_bgl_string1222za700za7za7_1264za7, "disconnected (running prepared) not-open default playback __alsa_music alsamusic pcm ", 85 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_alsamusicz00zz__alsa_musicz00) );
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__alsa_musicz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__alsa_musicz00(long BgL_checksumz00_286, char * BgL_fromz00_287)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__alsa_musicz00))
{ 
BGl_requirezd2initializa7ationz75zz__alsa_musicz00 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__alsa_musicz00(); 
BGl_libraryzd2moduleszd2initz00zz__alsa_musicz00(); 
BGl_cnstzd2initzd2zz__alsa_musicz00(); 
BGl_importedzd2moduleszd2initz00zz__alsa_musicz00(); 
BGl_objectzd2initzd2zz__alsa_musicz00(); 
BGl_methodzd2initzd2zz__alsa_musicz00(); 
return 
BGl_toplevelzd2initzd2zz__alsa_musicz00();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__alsa_musicz00()
{
{ /* Llib/music.scm 15 */
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__alsa_music"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "__alsa_music"); 
BGl_modulezd2initializa7ationz75zz__multimediazd2musicbufzd2(((long)0), "__alsa_music"); 
BGl_modulezd2initializa7ationz75zz__threadz00(((long)0), "__alsa_music"); 
BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(((long)0), "__alsa_music"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__alsa_music"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__alsa_music"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__alsa_music"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__alsa_music"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__alsa_musicz00()
{
{ /* Llib/music.scm 15 */
{ /* Llib/music.scm 15 */
obj_t BgL_cportz00_221;
{ /* Llib/music.scm 15 */
obj_t BgL_stringz00_229;
BgL_stringz00_229 = BGl_string1222z00zz__alsa_musicz00; 
{ /* Llib/music.scm 15 */
obj_t BgL_startz00_230;
BgL_startz00_230 = 
BINT(((long)0)); 
{ /* Llib/music.scm 15 */
obj_t BgL_endz00_231;
BgL_endz00_231 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_229))); 
{ /* Llib/music.scm 15 */

BgL_cportz00_221 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_229, BgL_startz00_230, BgL_endz00_231); } } } } 
{ 
long BgL_iz00_222;
BgL_iz00_222 = ((long)7); 
BgL_loopz00_223:
if(
(BgL_iz00_222==((long)-1)))
{ /* Llib/music.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/music.scm 15 */
{ /* Llib/music.scm 15 */
obj_t BgL_arg1242z00_225;
{ /* Llib/music.scm 15 */

{ /* Llib/music.scm 15 */
obj_t BgL_locationz00_227;
BgL_locationz00_227 = 
BBOOL(((bool_t)0)); 
{ /* Llib/music.scm 15 */

BgL_arg1242z00_225 = 
BGl_readz00zz__readerz00(BgL_cportz00_221, BgL_locationz00_227); } } } 
{ /* Llib/music.scm 15 */
int BgL_tmpz00_316;
BgL_tmpz00_316 = 
(int)(BgL_iz00_222); 
CNST_TABLE_SET(BgL_tmpz00_316, BgL_arg1242z00_225); } } 
{ /* Llib/music.scm 15 */
int BgL_auxz00_228;
BgL_auxz00_228 = 
(int)(
(BgL_iz00_222-((long)1))); 
{ 
long BgL_iz00_321;
BgL_iz00_321 = 
(long)(BgL_auxz00_228); 
BgL_iz00_222 = BgL_iz00_321; 
goto BgL_loopz00_223;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__alsa_musicz00()
{
{ /* Llib/music.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__alsa_musicz00()
{
{ /* Llib/music.scm 15 */
BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(((long)0), 
BSTRING_TO_STRING(BGl_string1202z00zz__alsa_musicz00)); 
return BUNSPEC;} 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__alsa_musicz00()
{
{ /* Llib/music.scm 15 */
{ /* Llib/music.scm 22 */
obj_t BgL_arg1127z00_21;obj_t BgL_arg1128z00_22;
{ /* Llib/music.scm 22 */
obj_t BgL_v1107z00_52;
BgL_v1107z00_52 = 
create_vector(((long)1)); 
{ /* Llib/music.scm 22 */
obj_t BgL_arg1136z00_53;
BgL_arg1136z00_53 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)0)), BGl_proc1205z00zz__alsa_musicz00, BGl_proc1204z00zz__alsa_musicz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc1203z00zz__alsa_musicz00, BGl_alsazd2sndzd2pcmz00zz__alsa_pcmz00); 
VECTOR_SET(BgL_v1107z00_52,((long)0),BgL_arg1136z00_53); } 
BgL_arg1127z00_21 = BgL_v1107z00_52; } 
{ /* Llib/music.scm 22 */
obj_t BgL_v1108z00_72;
BgL_v1108z00_72 = 
create_vector(((long)0)); 
BgL_arg1128z00_22 = BgL_v1108z00_72; } 
return ( 
BGl_alsamusicz00zz__alsa_musicz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)1)), 
CNST_TABLE_REF(((long)2)), BGl_musicbufz00zz__multimediazd2musicbufzd2, ((long)11039), BGl_proc1208z00zz__alsa_musicz00, BGl_proc1207z00zz__alsa_musicz00, BGl_musiczd2initzd2envz00zz__multimediazd2musiczd2, BGl_proc1206z00zz__alsa_musicz00, BFALSE, BgL_arg1127z00_21, BgL_arg1128z00_22), BUNSPEC) ;} } 

}



/* &<@anonymous:1135> */
obj_t BGl_z62zc3z04anonymousza31135ze3ze5zz__alsa_musicz00(obj_t BgL_envz00_161, obj_t BgL_new1096z00_162)
{
{ /* Llib/music.scm 22 */
{ 
BgL_alsamusicz00_bglt BgL_auxz00_334;
((((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)
((BgL_alsamusicz00_bglt)BgL_new1096z00_162))))->BgL_onstatez00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)
((BgL_alsamusicz00_bglt)BgL_new1096z00_162))))->BgL_onvolumez00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)
((BgL_alsamusicz00_bglt)BgL_new1096z00_162))))->BgL_onerrorz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)
((BgL_alsamusicz00_bglt)BgL_new1096z00_162))))->BgL_oneventz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)
((BgL_alsamusicz00_bglt)BgL_new1096z00_162))))->BgL_z52mutexz52)=((obj_t)
BGl_mutexzd2nilzd2zz__threadz00()),BUNSPEC); 
{ 
BgL_musicstatusz00_bglt BgL_auxz00_351;
{ /* Llib/music.scm 22 */
obj_t BgL_classz00_235;
BgL_classz00_235 = BGl_musicstatusz00zz__multimediazd2musiczd2; 
{ /* Llib/music.scm 22 */
obj_t BgL__ortest_1107z00_236;
BgL__ortest_1107z00_236 = 
BGL_CLASS_NIL(BgL_classz00_235); 
if(
CBOOL(BgL__ortest_1107z00_236))
{ /* Llib/music.scm 22 */
BgL_auxz00_351 = 
((BgL_musicstatusz00_bglt)BgL__ortest_1107z00_236)
; }  else 
{ /* Llib/music.scm 22 */
BgL_auxz00_351 = 
((BgL_musicstatusz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_235))
; } } } 
((((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)
((BgL_alsamusicz00_bglt)BgL_new1096z00_162))))->BgL_z52statusz52)=((BgL_musicstatusz00_bglt)BgL_auxz00_351),BUNSPEC); } 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_alsamusicz00_bglt)BgL_new1096z00_162))))->BgL_inbufz00)=((obj_t)BGl_string1209z00zz__alsa_musicz00),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_alsamusicz00_bglt)BgL_new1096z00_162))))->BgL_decodersz00)=((obj_t)BNIL),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_alsamusicz00_bglt)BgL_new1096z00_162))))->BgL_mkthreadz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_alsamusicz00_bglt)BgL_new1096z00_162))))->BgL_timeoutz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_alsamusicz00_bglt)BgL_new1096z00_162))))->BgL_z52decoderz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_alsamusicz00_bglt)BgL_new1096z00_162))))->BgL_z52bufferz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_alsamusicz00_bglt)BgL_new1096z00_162))))->BgL_z52nextbufferz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_alsamusicz00_bglt)BgL_new1096z00_162))))->BgL_z52playlistz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_alsamusicz00_bglt)BgL_new1096z00_162))))->BgL_z52areadyz52)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_alsamusicz00_bglt)BgL_new1096z00_162))))->BgL_z52amutexz52)=((obj_t)
BGl_mutexzd2nilzd2zz__threadz00()),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_alsamusicz00_bglt)BgL_new1096z00_162))))->BgL_z52z12pidz40)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_alsamusicz00_bglt)BgL_new1096z00_162))))->BgL_z52acondvz52)=((obj_t)
BGl_conditionzd2variablezd2nilz00zz__threadz00()),BUNSPEC); 
{ 
BgL_alsazd2sndzd2pcmz00_bglt BgL_auxz00_400;
{ /* Llib/music.scm 22 */
obj_t BgL_classz00_237;
BgL_classz00_237 = BGl_alsazd2sndzd2pcmz00zz__alsa_pcmz00; 
{ /* Llib/music.scm 22 */
obj_t BgL__ortest_1107z00_238;
BgL__ortest_1107z00_238 = 
BGL_CLASS_NIL(BgL_classz00_237); 
if(
CBOOL(BgL__ortest_1107z00_238))
{ /* Llib/music.scm 22 */
BgL_auxz00_400 = 
((BgL_alsazd2sndzd2pcmz00_bglt)BgL__ortest_1107z00_238)
; }  else 
{ /* Llib/music.scm 22 */
BgL_auxz00_400 = 
((BgL_alsazd2sndzd2pcmz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_237))
; } } } 
((((BgL_alsamusicz00_bglt)COBJECT(
((BgL_alsamusicz00_bglt)BgL_new1096z00_162)))->BgL_pcmz00)=((BgL_alsazd2sndzd2pcmz00_bglt)BgL_auxz00_400),BUNSPEC); } 
BgL_auxz00_334 = 
((BgL_alsamusicz00_bglt)BgL_new1096z00_162); 
return 
((obj_t)BgL_auxz00_334);} } 

}



/* &lambda1133 */
BgL_alsamusicz00_bglt BGl_z62lambda1133z62zz__alsa_musicz00(obj_t BgL_envz00_163)
{
{ /* Llib/music.scm 22 */
{ /* Llib/music.scm 22 */
BgL_alsamusicz00_bglt BgL_new1095z00_239;
BgL_new1095z00_239 = 
((BgL_alsamusicz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_alsamusicz00_bgl) ))); 
{ /* Llib/music.scm 22 */
long BgL_arg1134z00_240;
{ /* Llib/music.scm 22 */
long BgL_res1193z00_241;
BgL_res1193z00_241 = 
BGL_CLASS_INDEX(BGl_alsamusicz00zz__alsa_musicz00); 
BgL_arg1134z00_240 = BgL_res1193z00_241; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1095z00_239), BgL_arg1134z00_240); } 
return BgL_new1095z00_239;} } 

}



/* &lambda1129 */
BgL_alsamusicz00_bglt BGl_z62lambda1129z62zz__alsa_musicz00(obj_t BgL_envz00_164, obj_t BgL_onstate1076z00_165, obj_t BgL_onvolume1077z00_166, obj_t BgL_onerror1078z00_167, obj_t BgL_onevent1079z00_168, obj_t BgL_z52mutex1080z52_169, obj_t BgL_z52status1081z52_170, obj_t BgL_inbuf1082z00_171, obj_t BgL_decoders1083z00_172, obj_t BgL_mkthread1084z00_173, obj_t BgL_timeout1085z00_174, obj_t BgL_z52decoder1086z52_175, obj_t BgL_z52buffer1087z52_176, obj_t BgL_z52nextbuffer1088z52_177, obj_t BgL_z52playlist1089z52_178, obj_t BgL_z52aready1090z52_179, obj_t BgL_z52amutex1091z52_180, obj_t BgL_z52z12pid1092z40_181, obj_t BgL_z52acondv1093z52_182, obj_t BgL_pcm1094z00_183)
{
{ /* Llib/music.scm 22 */
{ /* Llib/music.scm 22 */
bool_t BgL_z52aready1090z52_252;int BgL_z52z12pid1092z40_254;
BgL_z52aready1090z52_252 = 
CBOOL(BgL_z52aready1090z52_179); 
BgL_z52z12pid1092z40_254 = 
CINT(BgL_z52z12pid1092z40_181); 
{ /* Llib/music.scm 22 */
BgL_alsamusicz00_bglt BgL_new1103z00_257;
{ /* Llib/music.scm 22 */
BgL_alsamusicz00_bglt BgL_new1102z00_258;
BgL_new1102z00_258 = 
((BgL_alsamusicz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_alsamusicz00_bgl) ))); 
{ /* Llib/music.scm 22 */
long BgL_arg1132z00_259;
{ /* Llib/music.scm 22 */
long BgL_res1192z00_260;
BgL_res1192z00_260 = 
BGL_CLASS_INDEX(BGl_alsamusicz00zz__alsa_musicz00); 
BgL_arg1132z00_259 = BgL_res1192z00_260; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1102z00_258), BgL_arg1132z00_259); } 
BgL_new1103z00_257 = BgL_new1102z00_258; } 
((((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)BgL_new1103z00_257)))->BgL_onstatez00)=((obj_t)
((obj_t)BgL_onstate1076z00_165)),BUNSPEC); 
((((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)BgL_new1103z00_257)))->BgL_onvolumez00)=((obj_t)
((obj_t)BgL_onvolume1077z00_166)),BUNSPEC); 
((((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)BgL_new1103z00_257)))->BgL_onerrorz00)=((obj_t)
((obj_t)BgL_onerror1078z00_167)),BUNSPEC); 
((((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)BgL_new1103z00_257)))->BgL_oneventz00)=((obj_t)
((obj_t)BgL_onevent1079z00_168)),BUNSPEC); 
((((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)BgL_new1103z00_257)))->BgL_z52mutexz52)=((obj_t)
((obj_t)BgL_z52mutex1080z52_169)),BUNSPEC); 
((((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)BgL_new1103z00_257)))->BgL_z52statusz52)=((BgL_musicstatusz00_bglt)
((BgL_musicstatusz00_bglt)BgL_z52status1081z52_170)),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)BgL_new1103z00_257)))->BgL_inbufz00)=((obj_t)
((obj_t)BgL_inbuf1082z00_171)),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)BgL_new1103z00_257)))->BgL_decodersz00)=((obj_t)
((obj_t)BgL_decoders1083z00_172)),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)BgL_new1103z00_257)))->BgL_mkthreadz00)=((obj_t)
((obj_t)BgL_mkthread1084z00_173)),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)BgL_new1103z00_257)))->BgL_timeoutz00)=((obj_t)BgL_timeout1085z00_174),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)BgL_new1103z00_257)))->BgL_z52decoderz52)=((obj_t)BgL_z52decoder1086z52_175),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)BgL_new1103z00_257)))->BgL_z52bufferz52)=((obj_t)BgL_z52buffer1087z52_176),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)BgL_new1103z00_257)))->BgL_z52nextbufferz52)=((obj_t)BgL_z52nextbuffer1088z52_177),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)BgL_new1103z00_257)))->BgL_z52playlistz52)=((obj_t)
((obj_t)BgL_z52playlist1089z52_178)),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)BgL_new1103z00_257)))->BgL_z52areadyz52)=((bool_t)BgL_z52aready1090z52_252),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)BgL_new1103z00_257)))->BgL_z52amutexz52)=((obj_t)
((obj_t)BgL_z52amutex1091z52_180)),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)BgL_new1103z00_257)))->BgL_z52z12pidz40)=((int)BgL_z52z12pid1092z40_254),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)BgL_new1103z00_257)))->BgL_z52acondvz52)=((obj_t)
((obj_t)BgL_z52acondv1093z52_182)),BUNSPEC); 
((((BgL_alsamusicz00_bglt)COBJECT(BgL_new1103z00_257))->BgL_pcmz00)=((BgL_alsazd2sndzd2pcmz00_bglt)
((BgL_alsazd2sndzd2pcmz00_bglt)BgL_pcm1094z00_183)),BUNSPEC); 
{ /* Llib/music.scm 22 */
obj_t BgL_fun1130z00_261;
BgL_fun1130z00_261 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_alsamusicz00zz__alsa_musicz00); 
PROCEDURE_ENTRY(BgL_fun1130z00_261)(BgL_fun1130z00_261, 
((obj_t)BgL_new1103z00_257), BEOA); } 
return BgL_new1103z00_257;} } } 

}



/* &<@anonymous:1146> */
obj_t BGl_z62zc3z04anonymousza31146ze3ze5zz__alsa_musicz00(obj_t BgL_envz00_184)
{
{ /* Llib/music.scm 22 */
{ 
BgL_alsazd2sndzd2pcmz00_bglt BgL_auxz00_477;
{ /* Llib/music.scm 23 */
BgL_alsazd2sndzd2pcmz00_bglt BgL_new1106z00_262;
{ /* Llib/music.scm 23 */
BgL_alsazd2sndzd2pcmz00_bglt BgL_new1105z00_263;
BgL_new1105z00_263 = 
((BgL_alsazd2sndzd2pcmz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_alsazd2sndzd2pcmz00_bgl) ))); 
{ /* Llib/music.scm 23 */
long BgL_arg1152z00_264;
{ /* Llib/music.scm 23 */
long BgL_res1190z00_265;
BgL_res1190z00_265 = 
BGL_CLASS_INDEX(BGl_alsazd2sndzd2pcmz00zz__alsa_pcmz00); 
BgL_arg1152z00_264 = BgL_res1190z00_265; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1105z00_263), BgL_arg1152z00_264); } 
BgL_new1106z00_262 = BgL_new1105z00_263; } 
{ 
void * BgL_auxz00_482;
{ /* Llib/music.scm 23 */
obj_t BgL_arg1147z00_266;
{ /* Llib/music.scm 23 */
obj_t BgL_arg1148z00_267;
{ /* Llib/music.scm 23 */
obj_t BgL_res1191z00_268;
{ /* Llib/music.scm 23 */
obj_t BgL_classz00_269;
BgL_classz00_269 = BGl_alsazd2sndzd2pcmz00zz__alsa_pcmz00; 
BgL_res1191z00_268 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_269); } 
BgL_arg1148z00_267 = BgL_res1191z00_268; } 
BgL_arg1147z00_266 = 
VECTOR_REF(BgL_arg1148z00_267,((long)0)); } 
BgL_auxz00_482 = 
FOREIGN_TO_COBJ(
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1147z00_266)); } 
((((BgL_alsazd2sndzd2pcmz00_bglt)COBJECT(BgL_new1106z00_262))->BgL_z42builtinz42)=((snd_pcm_t *)BgL_auxz00_482),BUNSPEC); } 
((((BgL_alsazd2sndzd2pcmz00_bglt)COBJECT(BgL_new1106z00_262))->BgL_namez00)=((obj_t)BGl_string1209z00zz__alsa_musicz00),BUNSPEC); 
((((BgL_alsazd2sndzd2pcmz00_bglt)COBJECT(BgL_new1106z00_262))->BgL_devicez00)=((obj_t)BGl_string1210z00zz__alsa_musicz00),BUNSPEC); 
((((BgL_alsazd2sndzd2pcmz00_bglt)COBJECT(BgL_new1106z00_262))->BgL_streamz00)=((obj_t)
CNST_TABLE_REF(((long)3))),BUNSPEC); 
((((BgL_alsazd2sndzd2pcmz00_bglt)COBJECT(BgL_new1106z00_262))->BgL_modez00)=((obj_t)
CNST_TABLE_REF(((long)4))),BUNSPEC); 
((((BgL_alsazd2sndzd2pcmz00_bglt)COBJECT(BgL_new1106z00_262))->BgL_hwbpsz00)=((int)
(int)(((long)32))),BUNSPEC); 
((((BgL_alsazd2sndzd2pcmz00_bglt)COBJECT(BgL_new1106z00_262))->BgL_hwsratez00)=((int)
(int)(((long)384000))),BUNSPEC); 
{ /* Llib/music.scm 23 */
obj_t BgL_fun1149z00_270;
BgL_fun1149z00_270 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_alsazd2sndzd2pcmz00zz__alsa_pcmz00); 
PROCEDURE_ENTRY(BgL_fun1149z00_270)(BgL_fun1149z00_270, 
((obj_t)BgL_new1106z00_262), BEOA); } 
BgL_auxz00_477 = BgL_new1106z00_262; } 
return 
((obj_t)BgL_auxz00_477);} } 

}



/* &lambda1145 */
obj_t BGl_z62lambda1145z62zz__alsa_musicz00(obj_t BgL_envz00_185, obj_t BgL_oz00_186, obj_t BgL_vz00_187)
{
{ /* Llib/music.scm 22 */
return 
((((BgL_alsamusicz00_bglt)COBJECT(
((BgL_alsamusicz00_bglt)BgL_oz00_186)))->BgL_pcmz00)=((BgL_alsazd2sndzd2pcmz00_bglt)
((BgL_alsazd2sndzd2pcmz00_bglt)BgL_vz00_187)),BUNSPEC);} 

}



/* &lambda1144 */
BgL_alsazd2sndzd2pcmz00_bglt BGl_z62lambda1144z62zz__alsa_musicz00(obj_t BgL_envz00_188, obj_t BgL_oz00_189)
{
{ /* Llib/music.scm 22 */
return 
(((BgL_alsamusicz00_bglt)COBJECT(
((BgL_alsamusicz00_bglt)BgL_oz00_189)))->BgL_pcmz00);} 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__alsa_musicz00()
{
{ /* Llib/music.scm 15 */
return BUNSPEC;} 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__alsa_musicz00()
{
{ /* Llib/music.scm 15 */
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musiczd2closezd2envz00zz__multimediazd2musiczd2, BGl_alsamusicz00zz__alsa_musicz00, BGl_proc1211z00zz__alsa_musicz00, BGl_string1212z00zz__alsa_musicz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musiczd2closedzf3zd2envzf3zz__multimediazd2musiczd2, BGl_alsamusicz00zz__alsa_musicz00, BGl_proc1213z00zz__alsa_musicz00, BGl_string1214z00zz__alsa_musicz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicbufzd2initz12zd2envz12zz__multimediazd2musicbufzd2, BGl_alsamusicz00zz__alsa_musicz00, BGl_proc1215z00zz__alsa_musicz00, BGl_string1216z00zz__alsa_musicz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicbufzd2resetz12zd2envz12zz__multimediazd2musicbufzd2, BGl_alsamusicz00zz__alsa_musicz00, BGl_proc1217z00zz__alsa_musicz00, BGl_string1218z00zz__alsa_musicz00); 
return 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicbufzd2writezd2envz00zz__multimediazd2musicbufzd2, BGl_alsamusicz00zz__alsa_musicz00, BGl_proc1219z00zz__alsa_musicz00, BGl_string1220z00zz__alsa_musicz00);} 

}



/* &musicbuf-write-alsam1118 */
obj_t BGl_z62musicbufzd2writezd2alsam1118z62zz__alsa_musicz00(obj_t BgL_envz00_197, obj_t BgL_oz00_198, obj_t BgL_outbufz00_199, obj_t BgL_siza7eza7_200)
{
{ /* Llib/music.scm 64 */
{ /* Llib/music.scm 66 */
BgL_alsazd2sndzd2pcmz00_bglt BgL_arg1189z00_275;
BgL_arg1189z00_275 = 
(((BgL_alsamusicz00_bglt)COBJECT(
((BgL_alsamusicz00_bglt)BgL_oz00_198)))->BgL_pcmz00); 
return 
BINT(
BGl_alsazd2sndzd2pcmzd2writezd2zz__alsa_pcmz00(BgL_arg1189z00_275, 
BSTRING_TO_STRING(BgL_outbufz00_199), 
(long)CINT(BgL_siza7eza7_200)));} } 

}



/* &musicbuf-reset!-alsa1116 */
obj_t BGl_z62musicbufzd2resetz12zd2alsa1116z70zz__alsa_musicz00(obj_t BgL_envz00_201, obj_t BgL_oz00_202)
{
{ /* Llib/music.scm 53 */
{ /* Llib/music.scm 55 */
obj_t BgL_pcmzd2statezd2_277;
BgL_pcmzd2statezd2_277 = 
BGl_alsazd2sndzd2pcmzd2getzd2statez00zz__alsa_pcmz00(
(((BgL_alsamusicz00_bglt)COBJECT(
((BgL_alsamusicz00_bglt)BgL_oz00_202)))->BgL_pcmz00)); 
if(
(BgL_pcmzd2statezd2_277==
CNST_TABLE_REF(((long)5))))
{ /* Llib/music.scm 56 */
return BFALSE;}  else 
{ /* Llib/music.scm 56 */
if(
CBOOL(
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_pcmzd2statezd2_277, 
CNST_TABLE_REF(((long)6)))))
{ /* Llib/music.scm 57 */
BGl_alsazd2sndzd2pcmzd2dropzd2zz__alsa_pcmz00(
(((BgL_alsamusicz00_bglt)COBJECT(
((BgL_alsamusicz00_bglt)BgL_oz00_202)))->BgL_pcmz00)); }  else 
{ /* Llib/music.scm 57 */BFALSE; } 
return 
BGl_alsazd2sndzd2pcmzd2cleanupzd2zz__alsa_pcmz00(
(((BgL_alsamusicz00_bglt)COBJECT(
((BgL_alsamusicz00_bglt)BgL_oz00_202)))->BgL_pcmz00));} } } 

}



/* &musicbuf-init!-alsam1114 */
obj_t BGl_z62musicbufzd2initz12zd2alsam1114z70zz__alsa_musicz00(obj_t BgL_envz00_203, obj_t BgL_oz00_204)
{
{ /* Llib/music.scm 45 */
{ /* Llib/music.scm 47 */
bool_t BgL_test1272z00_537;
{ /* Llib/music.scm 47 */
obj_t BgL_arg1177z00_279;
BgL_arg1177z00_279 = 
BGl_alsazd2sndzd2pcmzd2getzd2statez00zz__alsa_pcmz00(
(((BgL_alsamusicz00_bglt)COBJECT(
((BgL_alsamusicz00_bglt)BgL_oz00_204)))->BgL_pcmz00)); 
BgL_test1272z00_537 = 
(BgL_arg1177z00_279==
CNST_TABLE_REF(((long)5))); } 
if(BgL_test1272z00_537)
{ /* Llib/music.scm 47 */
return 
BGl_alsazd2sndzd2pcmzd2openzd2zz__alsa_pcmz00(
(((BgL_alsamusicz00_bglt)COBJECT(
((BgL_alsamusicz00_bglt)BgL_oz00_204)))->BgL_pcmz00));}  else 
{ /* Llib/music.scm 47 */
return BFALSE;} } } 

}



/* &music-closed?-alsamu1112 */
obj_t BGl_z62musiczd2closedzf3zd2alsamu1112z91zz__alsa_musicz00(obj_t BgL_envz00_205, obj_t BgL_oz00_206)
{
{ /* Llib/music.scm 37 */
{ /* Llib/music.scm 38 */
bool_t BgL_tmpz00_546;
{ /* Llib/music.scm 39 */
obj_t BgL_mutex1161z00_281;
BgL_mutex1161z00_281 = 
(((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_alsamusicz00_bglt)BgL_oz00_206))))->BgL_z52amutexz52); 
{ /* Llib/music.scm 39 */
obj_t BgL_top1274z00_551;
BgL_top1274z00_551 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGL_MUTEX_LOCK(BgL_mutex1161z00_281); 
BGL_EXITD_PUSH_PROTECT(BgL_top1274z00_551, BgL_mutex1161z00_281); BUNSPEC; 
{ /* Llib/music.scm 39 */
bool_t BgL_tmp1273z00_550;
{ /* Llib/music.scm 40 */
obj_t BgL_arg1167z00_282;
BgL_arg1167z00_282 = 
BGl_alsazd2sndzd2pcmzd2getzd2statez00zz__alsa_pcmz00(
(((BgL_alsamusicz00_bglt)COBJECT(
((BgL_alsamusicz00_bglt)BgL_oz00_206)))->BgL_pcmz00)); 
BgL_tmp1273z00_550 = 
(BgL_arg1167z00_282==
CNST_TABLE_REF(((long)7))); } 
BGL_EXITD_POP_PROTECT(BgL_top1274z00_551); BUNSPEC; 
BGL_MUTEX_UNLOCK(BgL_mutex1161z00_281); 
BgL_tmpz00_546 = BgL_tmp1273z00_550; } } } 
return 
BBOOL(BgL_tmpz00_546);} } 

}



/* &music-close-alsamusi1110 */
obj_t BGl_z62musiczd2closezd2alsamusi1110z62zz__alsa_musicz00(obj_t BgL_envz00_207, obj_t BgL_oz00_208)
{
{ /* Llib/music.scm 28 */
{ /* Llib/music.scm 30 */
obj_t BgL_mutex1153z00_284;
BgL_mutex1153z00_284 = 
(((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_alsamusicz00_bglt)BgL_oz00_208))))->BgL_z52amutexz52); 
{ /* Llib/music.scm 30 */
obj_t BgL_top1276z00_567;
BgL_top1276z00_567 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGL_MUTEX_LOCK(BgL_mutex1153z00_284); 
BGL_EXITD_PUSH_PROTECT(BgL_top1276z00_567, BgL_mutex1153z00_284); BUNSPEC; 
{ /* Llib/music.scm 30 */
obj_t BgL_tmp1275z00_566;
{ /* Llib/music.scm 31 */
bool_t BgL_test1277z00_571;
{ /* Llib/music.scm 31 */
obj_t BgL_arg1159z00_285;
BgL_arg1159z00_285 = 
BGl_alsazd2sndzd2pcmzd2getzd2statez00zz__alsa_pcmz00(
(((BgL_alsamusicz00_bglt)COBJECT(
((BgL_alsamusicz00_bglt)BgL_oz00_208)))->BgL_pcmz00)); 
BgL_test1277z00_571 = 
(BgL_arg1159z00_285==
CNST_TABLE_REF(((long)7))); } 
if(BgL_test1277z00_571)
{ /* Llib/music.scm 31 */
BgL_tmp1275z00_566 = BFALSE; }  else 
{ /* Llib/music.scm 31 */
BgL_tmp1275z00_566 = 
BGl_alsazd2sndzd2pcmzd2closezd2zz__alsa_pcmz00(
(((BgL_alsamusicz00_bglt)COBJECT(
((BgL_alsamusicz00_bglt)BgL_oz00_208)))->BgL_pcmz00)); } } 
BGL_EXITD_POP_PROTECT(BgL_top1276z00_567); BUNSPEC; 
BGL_MUTEX_UNLOCK(BgL_mutex1153z00_284); 
return BgL_tmp1275z00_566;} } } } 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__alsa_musicz00()
{
{ /* Llib/music.scm 15 */
BGl_modulezd2initializa7ationz75zz__alsa_alsaz00(((long)265821328), 
BSTRING_TO_STRING(BGl_string1221z00zz__alsa_musicz00)); 
return 
BGl_modulezd2initializa7ationz75zz__alsa_pcmz00(((long)493378103), 
BSTRING_TO_STRING(BGl_string1221z00zz__alsa_musicz00));} 

}

#ifdef __cplusplus
}
#endif
