/*===========================================================================*/
/*   (Llib/flac_decoder.scm)                                                 */
/*   Bigloo (4.3g)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu 27 Feb 2020 07:59:49 AM CET     */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo4.3g/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo4.3g/lib/bigloo/4.3g -lib-dir /builddir/build/BUILD/bigloo4.3g/lib/bigloo/4.3g -I Llib -lib-dir /builddir/build/BUILD/bigloo4.3g/lib/bigloo/4.3g -unsafe -safee -srfi flac -copt  -copt -fPIC -copt -IClib Llib/flac_decoder.scm -o objs/flac_decoder.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>
#include <FLAC/stream_decoder.h>
#include <bglflac.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_musicz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_onstatez00;
   obj_t BgL_onvolumez00;
   obj_t BgL_onerrorz00;
   obj_t BgL_oneventz00;
   obj_t BgL_z52mutexz52;
   struct BgL_musicstatusz00_bgl * BgL_z52statusz52;
} *BgL_musicz00_bglt;

typedef struct BgL_musicstatusz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_statez00;
   obj_t BgL_volumez00;
   bool_t BgL_repeatz00;
   bool_t BgL_randomz00;
   int BgL_playlistidz00;
   int BgL_playlistlengthz00;
   int BgL_xfadez00;
   int BgL_songz00;
   int BgL_songidz00;
   obj_t BgL_songposz00;
   int BgL_songlengthz00;
   int BgL_bitratez00;
   int BgL_khza7za7;
   obj_t BgL_errz00;
   int BgL_bufferingz00;
} *BgL_musicstatusz00_bglt;

typedef struct BgL_musicbufferz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_urlz00;
   bool_t BgL_z52eofz52;
   obj_t BgL_z52bcondvz52;
   obj_t BgL_z52bmutexz52;
   long BgL_z52inlenz52;
   char * BgL_z52inbufpz52;
   long BgL_z52headz52;
   long BgL_z52tailz52;
   bool_t BgL_z52emptyz52;
} *BgL_musicbufferz00_bglt;

typedef struct BgL_musicbufz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_onstatez00;
   obj_t BgL_onvolumez00;
   obj_t BgL_onerrorz00;
   obj_t BgL_oneventz00;
   obj_t BgL_z52mutexz52;
   struct BgL_musicstatusz00_bgl * BgL_z52statusz52;
   obj_t BgL_inbufz00;
   obj_t BgL_decodersz00;
   obj_t BgL_mkthreadz00;
   obj_t BgL_timeoutz00;
   obj_t BgL_z52decoderz52;
   obj_t BgL_z52bufferz52;
   obj_t BgL_z52nextbufferz52;
   obj_t BgL_z52playlistz52;
   bool_t BgL_z52areadyz52;
   obj_t BgL_z52amutexz52;
   int BgL_z52z12pidz40;
   obj_t BgL_z52acondvz52;
} *BgL_musicbufz00_bglt;

typedef struct BgL_musicdecoderz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_mimetypesz00;
   int BgL_bufferzd2timezd2nearz00;
   int BgL_bufferzd2siza7ezd2nearzd2ratioz75;
   int BgL_periodzd2siza7ezd2nearzd2ratioz75;
   bool_t BgL_z52z12dpausez40;
   bool_t BgL_z52z12dabortz40;
   bool_t BgL_z52z12stopz40;
   obj_t BgL_z52dmutexz52;
   obj_t BgL_z52dcondvz52;
   obj_t BgL_z52doutcondvz52;
} *BgL_musicdecoderz00_bglt;

typedef struct BgL_flaczd2decoderzd2_bgl {
   header_t header;
   obj_t widening;
   FLAC__StreamDecoder * BgL_z42builtinz42;
   obj_t BgL_z52flacbufz52;
   obj_t BgL_outbufz00;
   bool_t BgL_z52eofz52;
   long BgL_z52samplez52;
   double BgL_z52volumez52;
   bool_t BgL_md5checkz00;
   int BgL_z52bchecksumz52;
   int BgL_z52rchecksumz52;
} *BgL_flaczd2decoderzd2_bglt;

typedef struct BgL_flacdecz00_bgl {
   header_t header;
   obj_t widening;
   FLAC__StreamDecoder * BgL_z42builtinz42;
   obj_t BgL_z52flacbufz52;
   obj_t BgL_outbufz00;
   bool_t BgL_z52eofz52;
   long BgL_z52samplez52;
   double BgL_z52volumez52;
   bool_t BgL_md5checkz00;
   int BgL_z52bchecksumz52;
   int BgL_z52rchecksumz52;
   obj_t BgL_z52musicz52;
   obj_t BgL_z52bufferz52;
   obj_t BgL_z52decoderz52;
   int BgL_z52ratez52;
   int BgL_z52ratezd2maxz80;
   int BgL_z52ratezd2minz80;
   int BgL_z52lastzd2percentagez80;
} *BgL_flacdecz00_bglt;

typedef struct BgL_flacmusicdecoderz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_mimetypesz00;
   int BgL_bufferzd2timezd2nearz00;
   int BgL_bufferzd2siza7ezd2nearzd2ratioz75;
   int BgL_periodzd2siza7ezd2nearzd2ratioz75;
   bool_t BgL_z52z12dpausez40;
   bool_t BgL_z52z12dabortz40;
   bool_t BgL_z52z12stopz40;
   obj_t BgL_z52dmutexz52;
   obj_t BgL_z52dcondvz52;
   obj_t BgL_z52doutcondvz52;
   obj_t BgL_z52flacz52;
   obj_t BgL_z52inseekz52;
} *BgL_flacmusicdecoderz00_bglt;


BGL_EXPORTED_DECL int BGl_flaczd2debugzd2zz__flac_decoderz00();
static obj_t BGl_z62zc3z04anonymousza31579ze3ze5zz__flac_decoderz00(obj_t);
static obj_t BGl_z62flaczd2debugzb0zz__flac_decoderz00(obj_t);
static obj_t BGl_z62flaczd2decoderzd2seekzd2fl1149zb0zz__flac_decoderz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_musicbufzd2writezd2zz__multimediazd2musicbufzd2(BgL_musicbufz00_bglt, obj_t, long);
static obj_t BGl_objectzd2initzd2zz__flac_decoderz00();
static obj_t BGl_z62zc3z04anonymousza31304ze3ze5zz__flac_decoderz00(obj_t);
static obj_t BGl_z62musicdecoderzd2positio1137zb0zz__flac_decoderz00(obj_t, obj_t, obj_t);
BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zz__flac_decoderz00();
extern long BGl_flaczd2decoderzd2infoz00zz__flac_flacz00(BgL_flaczd2decoderzd2_bglt);
BGL_IMPORT obj_t BGl_musicbufferzd2lengthzd2zz__multimediazd2musicbufzd2(BgL_musicbufferz00_bglt);
BGL_IMPORT obj_t BGl_musicbufferz00zz__multimediazd2musicbufzd2;
static obj_t BGl_z62musicdecoderzd2initzd2fl1129z62zz__flac_decoderz00(obj_t, obj_t);
static obj_t BGl_z62flaczd2decoderzd2tellzd2fl1147zb0zz__flac_decoderz00(obj_t, obj_t);
extern obj_t BGl_flaczd2decoderzd2resetz12z12zz__flac_flacz00(BgL_flaczd2decoderzd2_bglt);
static obj_t BGl_z62zc3z04anonymousza31505ze3ze5zz__flac_decoderz00(obj_t);
static BgL_flacdecz00_bglt BGl_z62lambda1200z62zz__flac_decoderz00(obj_t);
BGL_IMPORT obj_t BGl_conditionzd2variablezd2nilz00zz__threadz00();
static obj_t BGl_z62zc3z04anonymousza31540ze3ze5zz__flac_decoderz00(obj_t, obj_t);
extern obj_t BGl_flaczd2volumezd2setz12z12zz__flac_flacz00(BgL_flaczd2decoderzd2_bglt, obj_t);
extern long BGl_flaczd2decoderzd2positionz00zz__flac_flacz00(BgL_flaczd2decoderzd2_bglt);
static obj_t BGl_z62flaczd2decoderzd2resetz12zd21131za2zz__flac_decoderz00(obj_t, obj_t);
static obj_t BGl_z62lambda1243z62zz__flac_decoderz00(obj_t, obj_t);
static obj_t BGl_z62lambda1244z62zz__flac_decoderz00(obj_t, obj_t, obj_t);
BGL_IMPORT int bgl_debug();
static obj_t BGl_z62zc3z04anonymousza31276ze3ze5zz__flac_decoderz00(obj_t);
static obj_t BGl_z62lambda1262z62zz__flac_decoderz00(obj_t, obj_t);
static obj_t BGl_z62lambda1263z62zz__flac_decoderz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_gczd2rootszd2initz00zz__flac_decoderz00();
static obj_t BGl_z62lambda1274z62zz__flac_decoderz00(obj_t, obj_t);
static obj_t BGl_z62lambda1275z62zz__flac_decoderz00(obj_t, obj_t, obj_t);
BGL_IMPORT long BGl_musicbufferzd2availablezd2zz__multimediazd2musicbufzd2(BgL_musicbufferz00_bglt);
BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1482z62zz__flac_decoderz00(obj_t, obj_t);
static obj_t BGl_z62lambda1483z62zz__flac_decoderz00(obj_t, obj_t, obj_t);
static bool_t BGl_za2debugzd2portza2zd2zz__flac_decoderz00;
BGL_IMPORT obj_t BGl_findzd2superzd2classzd2methodzd2zz__objectz00(BgL_objectz00_bglt, obj_t, obj_t);
static obj_t BGl_requirezd2initializa7ationz75zz__flac_decoderz00 = BUNSPEC;
BGL_IMPORT obj_t BGl_musicbufferzd2tellzd2zz__multimediazd2musicbufzd2(BgL_musicbufferz00_bglt);
BGL_IMPORT obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62musicdecoderzd2seekzd2fl1143z62zz__flac_decoderz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62flaczd2decoderzd2lengthzd21151zb0zz__flac_decoderz00(obj_t, obj_t);
static obj_t BGl_toplevelzd2initzd2zz__flac_decoderz00();
BGL_IMPORT obj_t BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(BgL_musicz00_bglt, obj_t);
static obj_t BGl_z62zc3z04anonymousza31205ze3ze5zz__flac_decoderz00(obj_t, obj_t);
static obj_t BGl_genericzd2initzd2zz__flac_decoderz00();
BGL_IMPORT obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t, bool_t, bool_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62flaczd2decoderzd2readzd2fl1145zb0zz__flac_decoderz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_mutexzd2nilzd2zz__threadz00();
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_musicdecoderz00zz__multimediazd2musicbufzd2;
static obj_t BGl_z62zc3z04anonymousza31245ze3ze5zz__flac_decoderz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31264ze3ze5zz__flac_decoderz00(obj_t);
static obj_t BGl_z62musicdecoderzd2resetz12zd21135z70zz__flac_decoderz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2constructorzd2zz__objectz00(obj_t);
static obj_t BGl_z62lambda1302z62zz__flac_decoderz00(obj_t, obj_t);
static obj_t BGl_z62lambda1303z62zz__flac_decoderz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__flac_decoderz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__flac_flacz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2musicbufzd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__customz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
static obj_t BGl_z62musicdecoderzd2infozd2fl1139z62zz__flac_decoderz00(obj_t, obj_t);
static obj_t BGl_z62lambda1503z62zz__flac_decoderz00(obj_t, obj_t);
static obj_t BGl_z62flaczd2checksumzd2debugz62zz__flac_decoderz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1504z62zz__flac_decoderz00(obj_t, obj_t, obj_t);
static obj_t BGl_cnstzd2initzd2zz__flac_decoderz00();
extern obj_t BGl_flaczd2decoderzd2zz__flac_flacz00;
static obj_t BGl_libraryzd2moduleszd2initz00zz__flac_decoderz00();
static obj_t BGl_importedzd2moduleszd2initz00zz__flac_decoderz00();
BGL_IMPORT long BGl_musicdecoderzd2positionzd2zz__multimediazd2musicbufzd2(BgL_musicdecoderz00_bglt, BgL_musicbufferz00_bglt);
BGL_IMPORT obj_t bgl_custom_nil();
BGL_IMPORT obj_t BGl_musicbufferzd2seekzd2zz__multimediazd2musicbufzd2(BgL_musicbufferz00_bglt, obj_t);
static obj_t BGl_z62zc3z04anonymousza31392ze3ze5zz__flac_decoderz00(obj_t);
static BgL_flacmusicdecoderz00_bglt BGl_z62lambda1524z62zz__flac_decoderz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62musicdecoderzd2volumezd21141z62zz__flac_decoderz00(obj_t, obj_t, obj_t);
static BgL_flacmusicdecoderz00_bglt BGl_z62lambda1538z62zz__flac_decoderz00(obj_t);
static obj_t BGl_z62lambda1390z62zz__flac_decoderz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31484ze3ze5zz__flac_decoderz00(obj_t);
static obj_t BGl_z62lambda1391z62zz__flac_decoderz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_flacdecz00zz__flac_decoderz00 = BUNSPEC;
static obj_t BGl_z62flaczd2decoderzd2writezd2f1133zb0zz__flac_decoderz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1577z62zz__flac_decoderz00(obj_t, obj_t);
static obj_t BGl_z62lambda1578z62zz__flac_decoderz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL int BGl_flaczd2checksumzd2debugz00zz__flac_decoderz00(long, char *, long, long);
static obj_t BGl_z62zc3z04anonymousza31593ze3ze5zz__flac_decoderz00(obj_t);
static obj_t BGl_z62lambda1591z62zz__flac_decoderz00(obj_t, obj_t);
static obj_t BGl_z62lambda1592z62zz__flac_decoderz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_flacmusicdecoderz00zz__flac_decoderz00 = BUNSPEC;
static obj_t __cnst[ 18 ] ;


DEFINE_EXPORT_BGL_PROCEDURE( BGl_flaczd2checksumzd2debugzd2envzd2zz__flac_decoderz00, BgL_bgl_za762flacza7d2checks1950z00, BGl_z62flaczd2checksumzd2debugz62zz__flac_decoderz00, 0L, BUNSPEC, 4 );
extern obj_t BGl_flaczd2decoderzd2lengthzd2envzd2zz__flac_flacz00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_flaczd2debugzd2envz00zz__flac_decoderz00, BgL_bgl_za762flacza7d2debugza71951za7, BGl_z62flaczd2debugzb0zz__flac_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1900z00zz__flac_decoderz00, BgL_bgl_za762za7c3za704anonymo1952za7, BGl_z62zc3z04anonymousza31392ze3ze5zz__flac_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1901z00zz__flac_decoderz00, BgL_bgl_za762lambda1391za7621953z00, BGl_z62lambda1391z62zz__flac_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1902z00zz__flac_decoderz00, BgL_bgl_za762lambda1390za7621954z00, BGl_z62lambda1390z62zz__flac_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1903z00zz__flac_decoderz00, BgL_bgl_za762za7c3za704anonymo1955za7, BGl_z62zc3z04anonymousza31484ze3ze5zz__flac_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1904z00zz__flac_decoderz00, BgL_bgl_za762lambda1483za7621956z00, BGl_z62lambda1483z62zz__flac_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1905z00zz__flac_decoderz00, BgL_bgl_za762lambda1482za7621957z00, BGl_z62lambda1482z62zz__flac_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1906z00zz__flac_decoderz00, BgL_bgl_za762za7c3za704anonymo1958za7, BGl_z62zc3z04anonymousza31505ze3ze5zz__flac_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1907z00zz__flac_decoderz00, BgL_bgl_za762lambda1504za7621959z00, BGl_z62lambda1504z62zz__flac_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1908z00zz__flac_decoderz00, BgL_bgl_za762lambda1503za7621960z00, BGl_z62lambda1503z62zz__flac_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1909z00zz__flac_decoderz00, BgL_bgl_za762za7c3za704anonymo1961za7, BGl_z62zc3z04anonymousza31205ze3ze5zz__flac_decoderz00, 0L, BUNSPEC, 1 );
BGL_IMPORT obj_t BGl_musicdecoderzd2volumezd2setz12zd2envzc0zz__multimediazd2musicbufzd2;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1910z00zz__flac_decoderz00, BgL_bgl_za762lambda1200za7621962z00, BGl_z62lambda1200z62zz__flac_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1911z00zz__flac_decoderz00, BgL_bgl_za762za7c3za704anonymo1963za7, BGl_z62zc3z04anonymousza31579ze3ze5zz__flac_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1912z00zz__flac_decoderz00, BgL_bgl_za762lambda1578za7621964z00, BGl_z62lambda1578z62zz__flac_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1913z00zz__flac_decoderz00, BgL_bgl_za762lambda1577za7621965z00, BGl_z62lambda1577z62zz__flac_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1914z00zz__flac_decoderz00, BgL_bgl_za762za7c3za704anonymo1966za7, BGl_z62zc3z04anonymousza31593ze3ze5zz__flac_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1915z00zz__flac_decoderz00, BgL_bgl_za762lambda1592za7621967z00, BGl_z62lambda1592z62zz__flac_decoderz00, 0L, BUNSPEC, 2 );
extern obj_t BGl_flaczd2decoderzd2seekzd2envzd2zz__flac_flacz00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1916z00zz__flac_decoderz00, BgL_bgl_za762lambda1591za7621968z00, BGl_z62lambda1591z62zz__flac_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1917z00zz__flac_decoderz00, BgL_bgl_za762za7c3za704anonymo1969za7, BGl_z62zc3z04anonymousza31540ze3ze5zz__flac_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1918z00zz__flac_decoderz00, BgL_bgl_za762lambda1538za7621970z00, BGl_z62lambda1538z62zz__flac_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1919z00zz__flac_decoderz00, BgL_bgl_za762lambda1524za7621971z00, BGl_z62lambda1524z62zz__flac_decoderz00, 0L, BUNSPEC, 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1921z00zz__flac_decoderz00, BgL_bgl_za762musicdecoderza71972z00, BGl_z62musicdecoderzd2initzd2fl1129z62zz__flac_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1923z00zz__flac_decoderz00, BgL_bgl_za762flacza7d2decode1973z00, BGl_z62flaczd2decoderzd2resetz12zd21131za2zz__flac_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1925z00zz__flac_decoderz00, BgL_bgl_za762flacza7d2decode1974z00, BGl_z62flaczd2decoderzd2writezd2f1133zb0zz__flac_decoderz00, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1927z00zz__flac_decoderz00, BgL_bgl_za762musicdecoderza71975z00, BGl_z62musicdecoderzd2resetz12zd21135z70zz__flac_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1929z00zz__flac_decoderz00, BgL_bgl_za762musicdecoderza71976z00, BGl_z62musicdecoderzd2positio1137zb0zz__flac_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1931z00zz__flac_decoderz00, BgL_bgl_za762musicdecoderza71977z00, BGl_z62musicdecoderzd2infozd2fl1139z62zz__flac_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1933z00zz__flac_decoderz00, BgL_bgl_za762musicdecoderza71978z00, BGl_z62musicdecoderzd2volumezd21141z62zz__flac_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1935z00zz__flac_decoderz00, BgL_bgl_za762musicdecoderza71979z00, BGl_z62musicdecoderzd2seekzd2fl1143z62zz__flac_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1937z00zz__flac_decoderz00, BgL_bgl_za762flacza7d2decode1980z00, BGl_z62flaczd2decoderzd2readzd2fl1145zb0zz__flac_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1939z00zz__flac_decoderz00, BgL_bgl_za762flacza7d2decode1981z00, BGl_z62flaczd2decoderzd2tellzd2fl1147zb0zz__flac_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1941z00zz__flac_decoderz00, BgL_bgl_za762flacza7d2decode1982z00, BGl_z62flaczd2decoderzd2seekzd2fl1149zb0zz__flac_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1943z00zz__flac_decoderz00, BgL_bgl_za762flacza7d2decode1983z00, BGl_z62flaczd2decoderzd2lengthzd21151zb0zz__flac_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1883z00zz__flac_decoderz00, BgL_bgl_string1883za700za7za7_1984za7, "Llib/flac_decoder.scm", 21 );
DEFINE_STRING( BGl_string1884z00zz__flac_decoderz00, BgL_bgl_string1884za700za7za7_1985za7, "/builddir/build/BUILD/bigloo4.3g/api/flac/src/Llib/flac_decoder.scm", 67 );
DEFINE_STRING( BGl_string1885z00zz__flac_decoderz00, BgL_bgl_string1885za700za7za7_1986za7, "&flac-checksum-debug", 20 );
DEFINE_STRING( BGl_string1886z00zz__flac_decoderz00, BgL_bgl_string1886za700za7za7_1987za7, "bint", 4 );
DEFINE_STRING( BGl_string1887z00zz__flac_decoderz00, BgL_bgl_string1887za700za7za7_1988za7, "bstring", 7 );
extern obj_t BGl_flaczd2decoderzd2resetz12zd2envzc0zz__flac_flacz00;
extern obj_t BGl_flaczd2decoderzd2initzd2envzd2zz__flac_flacz00;
BGL_IMPORT obj_t BGl_musicdecoderzd2infozd2envz00zz__multimediazd2musicbufzd2;
extern obj_t BGl_flaczd2decoderzd2writezd2envzd2zz__flac_flacz00;
extern obj_t BGl_flaczd2decoderzd2tellzd2envzd2zz__flac_flacz00;
DEFINE_STRING( BGl_string1920z00zz__flac_decoderz00, BgL_bgl_string1920za700za7za7_1989za7, "", 0 );
DEFINE_STRING( BGl_string1922z00zz__flac_decoderz00, BgL_bgl_string1922za700za7za7_1990za7, "musicdecoder-init", 17 );
DEFINE_STRING( BGl_string1924z00zz__flac_decoderz00, BgL_bgl_string1924za700za7za7_1991za7, "flac-decoder-reset!", 19 );
DEFINE_STRING( BGl_string1926z00zz__flac_decoderz00, BgL_bgl_string1926za700za7za7_1992za7, "flac-decoder-write", 18 );
DEFINE_STRING( BGl_string1928z00zz__flac_decoderz00, BgL_bgl_string1928za700za7za7_1993za7, "musicdecoder-reset!", 19 );
DEFINE_STRING( BGl_string1930z00zz__flac_decoderz00, BgL_bgl_string1930za700za7za7_1994za7, "musicdecoder-position", 21 );
DEFINE_STRING( BGl_string1932z00zz__flac_decoderz00, BgL_bgl_string1932za700za7za7_1995za7, "musicdecoder-info", 17 );
DEFINE_STRING( BGl_string1934z00zz__flac_decoderz00, BgL_bgl_string1934za700za7za7_1996za7, "musicdecoder-volume-set!", 24 );
DEFINE_STRING( BGl_string1936z00zz__flac_decoderz00, BgL_bgl_string1936za700za7za7_1997za7, "musicdecoder-seek", 17 );
DEFINE_STRING( BGl_string1938z00zz__flac_decoderz00, BgL_bgl_string1938za700za7za7_1998za7, "flac-decoder-read", 17 );
DEFINE_STRING( BGl_string1940z00zz__flac_decoderz00, BgL_bgl_string1940za700za7za7_1999za7, "flac-decoder-tell", 17 );
DEFINE_STRING( BGl_string1942z00zz__flac_decoderz00, BgL_bgl_string1942za700za7za7_2000za7, "flac-decoder-seek", 17 );
DEFINE_STRING( BGl_string1944z00zz__flac_decoderz00, BgL_bgl_string1944za700za7za7_2001za7, "flac-decoder-length", 19 );
DEFINE_STRING( BGl_string1945z00zz__flac_decoderz00, BgL_bgl_string1945za700za7za7_2002za7, "__flac_decoder", 14 );
DEFINE_STRING( BGl_string1946z00zz__flac_decoderz00, BgL_bgl_string1946za700za7za7_2003za7, "(\"audio/flac\" \"application/x-flac\" \"audio/x-flac\") buffering play pause flacmusicdecoder %inseek %flac __flac_decoder flacdec %last-percentage %rate-min %rate-max int %rate %decoder %buffer obj %music ", 201 );
BGL_IMPORT obj_t BGl_musicdecoderzd2seekzd2envz00zz__multimediazd2musicbufzd2;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1888z00zz__flac_decoderz00, BgL_bgl_za762za7c3za704anonymo2004za7, BGl_z62zc3z04anonymousza31245ze3ze5zz__flac_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1889z00zz__flac_decoderz00, BgL_bgl_za762lambda1244za7622005z00, BGl_z62lambda1244z62zz__flac_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1890z00zz__flac_decoderz00, BgL_bgl_za762lambda1243za7622006z00, BGl_z62lambda1243z62zz__flac_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1891z00zz__flac_decoderz00, BgL_bgl_za762za7c3za704anonymo2007za7, BGl_z62zc3z04anonymousza31264ze3ze5zz__flac_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1892z00zz__flac_decoderz00, BgL_bgl_za762lambda1263za7622008z00, BGl_z62lambda1263z62zz__flac_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1893z00zz__flac_decoderz00, BgL_bgl_za762lambda1262za7622009z00, BGl_z62lambda1262z62zz__flac_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1894z00zz__flac_decoderz00, BgL_bgl_za762za7c3za704anonymo2010za7, BGl_z62zc3z04anonymousza31276ze3ze5zz__flac_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1895z00zz__flac_decoderz00, BgL_bgl_za762lambda1275za7622011z00, BGl_z62lambda1275z62zz__flac_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1896z00zz__flac_decoderz00, BgL_bgl_za762lambda1274za7622012z00, BGl_z62lambda1274z62zz__flac_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1897z00zz__flac_decoderz00, BgL_bgl_za762za7c3za704anonymo2013za7, BGl_z62zc3z04anonymousza31304ze3ze5zz__flac_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1898z00zz__flac_decoderz00, BgL_bgl_za762lambda1303za7622014z00, BGl_z62lambda1303z62zz__flac_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1899z00zz__flac_decoderz00, BgL_bgl_za762lambda1302za7622015z00, BGl_z62lambda1302z62zz__flac_decoderz00, 0L, BUNSPEC, 1 );
BGL_IMPORT obj_t BGl_musicdecoderzd2resetz12zd2envz12zz__multimediazd2musicbufzd2;
extern obj_t BGl_flaczd2decoderzd2readzd2envzd2zz__flac_flacz00;
BGL_IMPORT obj_t BGl_musicdecoderzd2initzd2envz00zz__multimediazd2musicbufzd2;
BGL_IMPORT obj_t BGl_musicdecoderzd2positionzd2envz00zz__multimediazd2musicbufzd2;

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__flac_decoderz00) );
ADD_ROOT( (void *)(&BGl_flacdecz00zz__flac_decoderz00) );
ADD_ROOT( (void *)(&BGl_flacmusicdecoderz00zz__flac_decoderz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__flac_decoderz00(long BgL_checksumz00_1014, char * BgL_fromz00_1015)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__flac_decoderz00))
{ 
BGl_requirezd2initializa7ationz75zz__flac_decoderz00 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__flac_decoderz00(); 
BGl_libraryzd2moduleszd2initz00zz__flac_decoderz00(); 
BGl_cnstzd2initzd2zz__flac_decoderz00(); 
BGl_importedzd2moduleszd2initz00zz__flac_decoderz00(); 
BGl_objectzd2initzd2zz__flac_decoderz00(); 
BGl_methodzd2initzd2zz__flac_decoderz00(); 
return 
BGl_toplevelzd2initzd2zz__flac_decoderz00();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__flac_decoderz00()
{
{ /* Llib/flac_decoder.scm 15 */
BGl_modulezd2initializa7ationz75zz__multimediazd2musicbufzd2(((long)0), "__flac_decoder"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__flac_decoder"); 
BGl_modulezd2initializa7ationz75zz__threadz00(((long)0), "__flac_decoder"); 
BGl_modulezd2initializa7ationz75zz__paramz00(((long)0), "__flac_decoder"); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "__flac_decoder"); 
BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(((long)0), "__flac_decoder"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__flac_decoder"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__flac_decoder"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__flac_decoder"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "__flac_decoder"); 
BGl_modulezd2initializa7ationz75zz__customz00(((long)0), "__flac_decoder"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__flac_decoder"); 
BGl_modulezd2initializa7ationz75zz__bitz00(((long)0), "__flac_decoder"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__flac_decoder"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__flac_decoderz00()
{
{ /* Llib/flac_decoder.scm 15 */
{ /* Llib/flac_decoder.scm 15 */
obj_t BgL_cportz00_857;
{ /* Llib/flac_decoder.scm 15 */
obj_t BgL_stringz00_865;
BgL_stringz00_865 = BGl_string1946z00zz__flac_decoderz00; 
{ /* Llib/flac_decoder.scm 15 */
obj_t BgL_startz00_866;
BgL_startz00_866 = 
BINT(((long)0)); 
{ /* Llib/flac_decoder.scm 15 */
obj_t BgL_endz00_867;
BgL_endz00_867 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_865))); 
{ /* Llib/flac_decoder.scm 15 */

BgL_cportz00_857 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_865, BgL_startz00_866, BgL_endz00_867); } } } } 
{ 
long BgL_iz00_858;
BgL_iz00_858 = ((long)17); 
BgL_loopz00_859:
if(
(BgL_iz00_858==((long)-1)))
{ /* Llib/flac_decoder.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/flac_decoder.scm 15 */
{ /* Llib/flac_decoder.scm 15 */
obj_t BgL_arg1948z00_861;
{ /* Llib/flac_decoder.scm 15 */

{ /* Llib/flac_decoder.scm 15 */
obj_t BgL_locationz00_863;
BgL_locationz00_863 = 
BBOOL(((bool_t)0)); 
{ /* Llib/flac_decoder.scm 15 */

BgL_arg1948z00_861 = 
BGl_readz00zz__readerz00(BgL_cportz00_857, BgL_locationz00_863); } } } 
{ /* Llib/flac_decoder.scm 15 */
int BgL_tmpz00_1049;
BgL_tmpz00_1049 = 
(int)(BgL_iz00_858); 
CNST_TABLE_SET(BgL_tmpz00_1049, BgL_arg1948z00_861); } } 
{ /* Llib/flac_decoder.scm 15 */
int BgL_auxz00_864;
BgL_auxz00_864 = 
(int)(
(BgL_iz00_858-((long)1))); 
{ 
long BgL_iz00_1054;
BgL_iz00_1054 = 
(long)(BgL_auxz00_864); 
BgL_iz00_858 = BgL_iz00_1054; 
goto BgL_loopz00_859;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__flac_decoderz00()
{
{ /* Llib/flac_decoder.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__flac_decoderz00()
{
{ /* Llib/flac_decoder.scm 15 */
BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(((long)0), 
BSTRING_TO_STRING(BGl_string1883z00zz__flac_decoderz00)); 
return ( 
BGl_za2debugzd2portza2zd2zz__flac_decoderz00 = ((bool_t)0), BUNSPEC) ;} 

}



/* flac-debug */
BGL_EXPORTED_DEF int BGl_flaczd2debugzd2zz__flac_decoderz00()
{
{ /* Llib/flac_decoder.scm 53 */
if(
(((long)0)>((long)0)))
{ /* Llib/flac_decoder.scm 55 */
(long)(
bgl_debug()); }  else 
{ /* Llib/flac_decoder.scm 55 */((long)0); } 
return 
(int)(((long)1));} 

}



/* &flac-debug */
obj_t BGl_z62flaczd2debugzb0zz__flac_decoderz00(obj_t BgL_envz00_658)
{
{ /* Llib/flac_decoder.scm 53 */
return 
BINT(
BGl_flaczd2debugzd2zz__flac_decoderz00());} 

}



/* flac-checksum-debug */
BGL_EXPORTED_DEF int BGl_flaczd2checksumzd2debugz00zz__flac_decoderz00(long BgL_cz00_3, char * BgL_bufferz00_4, long BgL_iz00_5, long BgL_sz00_6)
{
{ /* Llib/flac_decoder.scm 63 */
{ 
long BgL_nz00_485;long BgL_cz00_486;
{ /* Llib/flac_decoder.scm 64 */
long BgL_tmpz00_1066;
BgL_nz00_485 = ((long)0); 
BgL_cz00_486 = BgL_cz00_3; 
BgL_loopz00_484:
if(
(BgL_nz00_485==BgL_sz00_6))
{ /* Llib/flac_decoder.scm 66 */
BgL_tmpz00_1066 = BgL_cz00_486
; }  else 
{ /* Llib/flac_decoder.scm 68 */
long BgL_arg1160z00_491;long BgL_arg1161z00_492;
BgL_arg1160z00_491 = 
(BgL_nz00_485+((long)1)); 
{ /* Llib/flac_decoder.scm 68 */
char BgL_arg1167z00_495;
{ /* Llib/flac_decoder.scm 68 */
long BgL_tmpz00_1070;
BgL_tmpz00_1070 = 
(BgL_iz00_5+BgL_nz00_485); 
BgL_arg1167z00_495 = 
BGL_FLAC_STRING_REF(BgL_bufferz00_4, BgL_tmpz00_1070); } 
BgL_arg1161z00_492 = 
(BgL_cz00_486 ^ 
(long)(BgL_arg1167z00_495)); } 
{ 
long BgL_cz00_1076;long BgL_nz00_1075;
BgL_nz00_1075 = BgL_arg1160z00_491; 
BgL_cz00_1076 = BgL_arg1161z00_492; 
BgL_cz00_486 = BgL_cz00_1076; 
BgL_nz00_485 = BgL_nz00_1075; 
goto BgL_loopz00_484;} } 
return 
(int)(BgL_tmpz00_1066);} } } 

}



/* &flac-checksum-debug */
obj_t BGl_z62flaczd2checksumzd2debugz62zz__flac_decoderz00(obj_t BgL_envz00_659, obj_t BgL_cz00_660, obj_t BgL_bufferz00_661, obj_t BgL_iz00_662, obj_t BgL_sz00_663)
{
{ /* Llib/flac_decoder.scm 63 */
{ /* Llib/flac_decoder.scm 64 */
int BgL_tmpz00_1078;
{ /* Llib/flac_decoder.scm 64 */
long BgL_auxz00_1106;long BgL_auxz00_1097;char * BgL_auxz00_1088;long BgL_auxz00_1079;
{ /* Llib/flac_decoder.scm 64 */
obj_t BgL_tmpz00_1107;
if(
INTEGERP(BgL_sz00_663))
{ /* Llib/flac_decoder.scm 64 */
BgL_tmpz00_1107 = BgL_sz00_663
; }  else 
{ 
obj_t BgL_auxz00_1110;
BgL_auxz00_1110 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1884z00zz__flac_decoderz00, 
BINT(((long)2760)), BGl_string1885z00zz__flac_decoderz00, BGl_string1886z00zz__flac_decoderz00, BgL_sz00_663); 
FAILURE(BgL_auxz00_1110,BFALSE,BFALSE);} 
BgL_auxz00_1106 = 
(long)CINT(BgL_tmpz00_1107); } 
{ /* Llib/flac_decoder.scm 64 */
obj_t BgL_tmpz00_1098;
if(
INTEGERP(BgL_iz00_662))
{ /* Llib/flac_decoder.scm 64 */
BgL_tmpz00_1098 = BgL_iz00_662
; }  else 
{ 
obj_t BgL_auxz00_1101;
BgL_auxz00_1101 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1884z00zz__flac_decoderz00, 
BINT(((long)2760)), BGl_string1885z00zz__flac_decoderz00, BGl_string1886z00zz__flac_decoderz00, BgL_iz00_662); 
FAILURE(BgL_auxz00_1101,BFALSE,BFALSE);} 
BgL_auxz00_1097 = 
(long)CINT(BgL_tmpz00_1098); } 
{ /* Llib/flac_decoder.scm 64 */
obj_t BgL_tmpz00_1089;
if(
STRINGP(BgL_bufferz00_661))
{ /* Llib/flac_decoder.scm 64 */
BgL_tmpz00_1089 = BgL_bufferz00_661
; }  else 
{ 
obj_t BgL_auxz00_1092;
BgL_auxz00_1092 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1884z00zz__flac_decoderz00, 
BINT(((long)2760)), BGl_string1885z00zz__flac_decoderz00, BGl_string1887z00zz__flac_decoderz00, BgL_bufferz00_661); 
FAILURE(BgL_auxz00_1092,BFALSE,BFALSE);} 
BgL_auxz00_1088 = 
BSTRING_TO_STRING(BgL_tmpz00_1089); } 
{ /* Llib/flac_decoder.scm 64 */
obj_t BgL_tmpz00_1080;
if(
INTEGERP(BgL_cz00_660))
{ /* Llib/flac_decoder.scm 64 */
BgL_tmpz00_1080 = BgL_cz00_660
; }  else 
{ 
obj_t BgL_auxz00_1083;
BgL_auxz00_1083 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1884z00zz__flac_decoderz00, 
BINT(((long)2760)), BGl_string1885z00zz__flac_decoderz00, BGl_string1886z00zz__flac_decoderz00, BgL_cz00_660); 
FAILURE(BgL_auxz00_1083,BFALSE,BFALSE);} 
BgL_auxz00_1079 = 
(long)CINT(BgL_tmpz00_1080); } 
BgL_tmpz00_1078 = 
BGl_flaczd2checksumzd2debugz00zz__flac_decoderz00(BgL_auxz00_1079, BgL_auxz00_1088, BgL_auxz00_1097, BgL_auxz00_1106); } 
return 
BINT(BgL_tmpz00_1078);} } 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__flac_decoderz00()
{
{ /* Llib/flac_decoder.scm 15 */
{ /* Llib/flac_decoder.scm 28 */
obj_t BgL_arg1198z00_73;obj_t BgL_arg1199z00_74;
{ /* Llib/flac_decoder.scm 28 */
obj_t BgL_v1124z00_80;
BgL_v1124z00_80 = 
create_vector(((long)7)); 
{ /* Llib/flac_decoder.scm 28 */
obj_t BgL_arg1217z00_81;
BgL_arg1217z00_81 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)0)), BGl_proc1890z00zz__flac_decoderz00, BGl_proc1889z00zz__flac_decoderz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1888z00zz__flac_decoderz00, 
CNST_TABLE_REF(((long)1))); 
VECTOR_SET(BgL_v1124z00_80,((long)0),BgL_arg1217z00_81); } 
{ /* Llib/flac_decoder.scm 28 */
obj_t BgL_arg1253z00_94;
BgL_arg1253z00_94 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)2)), BGl_proc1893z00zz__flac_decoderz00, BGl_proc1892z00zz__flac_decoderz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1891z00zz__flac_decoderz00, 
CNST_TABLE_REF(((long)1))); 
VECTOR_SET(BgL_v1124z00_80,((long)1),BgL_arg1253z00_94); } 
{ /* Llib/flac_decoder.scm 28 */
obj_t BgL_arg1267z00_107;
BgL_arg1267z00_107 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)3)), BGl_proc1896z00zz__flac_decoderz00, BGl_proc1895z00zz__flac_decoderz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1894z00zz__flac_decoderz00, 
CNST_TABLE_REF(((long)1))); 
VECTOR_SET(BgL_v1124z00_80,((long)2),BgL_arg1267z00_107); } 
{ /* Llib/flac_decoder.scm 28 */
obj_t BgL_arg1283z00_120;
BgL_arg1283z00_120 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)4)), BGl_proc1899z00zz__flac_decoderz00, BGl_proc1898z00zz__flac_decoderz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1897z00zz__flac_decoderz00, 
CNST_TABLE_REF(((long)5))); 
VECTOR_SET(BgL_v1124z00_80,((long)3),BgL_arg1283z00_120); } 
{ /* Llib/flac_decoder.scm 28 */
obj_t BgL_arg1346z00_133;
BgL_arg1346z00_133 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)6)), BGl_proc1902z00zz__flac_decoderz00, BGl_proc1901z00zz__flac_decoderz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1900z00zz__flac_decoderz00, 
CNST_TABLE_REF(((long)5))); 
VECTOR_SET(BgL_v1124z00_80,((long)4),BgL_arg1346z00_133); } 
{ /* Llib/flac_decoder.scm 28 */
obj_t BgL_arg1470z00_146;
BgL_arg1470z00_146 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)7)), BGl_proc1905z00zz__flac_decoderz00, BGl_proc1904z00zz__flac_decoderz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1903z00zz__flac_decoderz00, 
CNST_TABLE_REF(((long)5))); 
VECTOR_SET(BgL_v1124z00_80,((long)5),BgL_arg1470z00_146); } 
{ /* Llib/flac_decoder.scm 28 */
obj_t BgL_arg1487z00_159;
BgL_arg1487z00_159 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)8)), BGl_proc1908z00zz__flac_decoderz00, BGl_proc1907z00zz__flac_decoderz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1906z00zz__flac_decoderz00, 
CNST_TABLE_REF(((long)5))); 
VECTOR_SET(BgL_v1124z00_80,((long)6),BgL_arg1487z00_159); } 
BgL_arg1198z00_73 = BgL_v1124z00_80; } 
{ /* Llib/flac_decoder.scm 28 */
obj_t BgL_v1125z00_172;
BgL_v1125z00_172 = 
create_vector(((long)0)); 
BgL_arg1199z00_74 = BgL_v1125z00_172; } 
BGl_flacdecz00zz__flac_decoderz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)9)), 
CNST_TABLE_REF(((long)10)), BGl_flaczd2decoderzd2zz__flac_flacz00, ((long)58322), BFALSE, BGl_proc1910z00zz__flac_decoderz00, BGl_flaczd2decoderzd2initzd2envzd2zz__flac_flacz00, BGl_proc1909z00zz__flac_decoderz00, BFALSE, BgL_arg1198z00_73, BgL_arg1199z00_74); } 
{ /* Llib/flac_decoder.scm 37 */
obj_t BgL_arg1522z00_178;obj_t BgL_arg1523z00_179;
{ /* Llib/flac_decoder.scm 37 */
obj_t BgL_v1126z00_202;
BgL_v1126z00_202 = 
create_vector(((long)2)); 
{ /* Llib/flac_decoder.scm 37 */
obj_t BgL_arg1553z00_203;
BgL_arg1553z00_203 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)11)), BGl_proc1913z00zz__flac_decoderz00, BGl_proc1912z00zz__flac_decoderz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1911z00zz__flac_decoderz00, 
CNST_TABLE_REF(((long)1))); 
VECTOR_SET(BgL_v1126z00_202,((long)0),BgL_arg1553z00_203); } 
{ /* Llib/flac_decoder.scm 37 */
obj_t BgL_arg1580z00_216;
BgL_arg1580z00_216 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)12)), BGl_proc1916z00zz__flac_decoderz00, BGl_proc1915z00zz__flac_decoderz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1914z00zz__flac_decoderz00, 
CNST_TABLE_REF(((long)1))); 
VECTOR_SET(BgL_v1126z00_202,((long)1),BgL_arg1580z00_216); } 
BgL_arg1522z00_178 = BgL_v1126z00_202; } 
{ /* Llib/flac_decoder.scm 37 */
obj_t BgL_v1127z00_229;
BgL_v1127z00_229 = 
create_vector(((long)0)); 
BgL_arg1523z00_179 = BgL_v1127z00_229; } 
return ( 
BGl_flacmusicdecoderz00zz__flac_decoderz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)13)), 
CNST_TABLE_REF(((long)10)), BGl_musicdecoderz00zz__multimediazd2musicbufzd2, ((long)48433), BGl_proc1919z00zz__flac_decoderz00, BGl_proc1918z00zz__flac_decoderz00, BGl_musicdecoderzd2initzd2envz00zz__multimediazd2musicbufzd2, BGl_proc1917z00zz__flac_decoderz00, BFALSE, BgL_arg1522z00_178, BgL_arg1523z00_179), BUNSPEC) ;} } 

}



/* &<@anonymous:1540> */
obj_t BGl_z62zc3z04anonymousza31540ze3ze5zz__flac_decoderz00(obj_t BgL_envz00_696, obj_t BgL_new1091z00_697)
{
{ /* Llib/flac_decoder.scm 37 */
{ 
BgL_flacmusicdecoderz00_bglt BgL_auxz00_1163;
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flacmusicdecoderz00_bglt)BgL_new1091z00_697))))->BgL_mimetypesz00)=((obj_t)BNIL),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flacmusicdecoderz00_bglt)BgL_new1091z00_697))))->BgL_bufferzd2timezd2nearz00)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flacmusicdecoderz00_bglt)BgL_new1091z00_697))))->BgL_bufferzd2siza7ezd2nearzd2ratioz75)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flacmusicdecoderz00_bglt)BgL_new1091z00_697))))->BgL_periodzd2siza7ezd2nearzd2ratioz75)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flacmusicdecoderz00_bglt)BgL_new1091z00_697))))->BgL_z52z12dpausez40)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flacmusicdecoderz00_bglt)BgL_new1091z00_697))))->BgL_z52z12dabortz40)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flacmusicdecoderz00_bglt)BgL_new1091z00_697))))->BgL_z52z12stopz40)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flacmusicdecoderz00_bglt)BgL_new1091z00_697))))->BgL_z52dmutexz52)=((obj_t)
BGl_mutexzd2nilzd2zz__threadz00()),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flacmusicdecoderz00_bglt)BgL_new1091z00_697))))->BgL_z52dcondvz52)=((obj_t)
BGl_conditionzd2variablezd2nilz00zz__threadz00()),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flacmusicdecoderz00_bglt)BgL_new1091z00_697))))->BgL_z52doutcondvz52)=((obj_t)
BGl_conditionzd2variablezd2nilz00zz__threadz00()),BUNSPEC); 
((((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)BgL_new1091z00_697)))->BgL_z52flacz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)BgL_new1091z00_697)))->BgL_z52inseekz52)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_1163 = 
((BgL_flacmusicdecoderz00_bglt)BgL_new1091z00_697); 
return 
((obj_t)BgL_auxz00_1163);} } 

}



/* &lambda1538 */
BgL_flacmusicdecoderz00_bglt BGl_z62lambda1538z62zz__flac_decoderz00(obj_t BgL_envz00_698)
{
{ /* Llib/flac_decoder.scm 37 */
{ /* Llib/flac_decoder.scm 37 */
BgL_flacmusicdecoderz00_bglt BgL_new1090z00_871;
BgL_new1090z00_871 = 
((BgL_flacmusicdecoderz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_flacmusicdecoderz00_bgl) ))); 
{ /* Llib/flac_decoder.scm 37 */
long BgL_arg1539z00_872;
{ /* Llib/flac_decoder.scm 37 */
long BgL_res1793z00_873;
BgL_res1793z00_873 = 
BGL_CLASS_INDEX(BGl_flacmusicdecoderz00zz__flac_decoderz00); 
BgL_arg1539z00_872 = BgL_res1793z00_873; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1090z00_871), BgL_arg1539z00_872); } 
return BgL_new1090z00_871;} } 

}



/* &lambda1524 */
BgL_flacmusicdecoderz00_bglt BGl_z62lambda1524z62zz__flac_decoderz00(obj_t BgL_envz00_699, obj_t BgL_mimetypes1078z00_700, obj_t BgL_bufferzd2timezd2near1079z00_701, obj_t BgL_bufferzd2siza7ezd2nearzd2rat1080z75_702, obj_t BgL_periodzd2siza7ezd2nearzd2rat1081z75_703, obj_t BgL_z52z12dpause1082z40_704, obj_t BgL_z52z12dabort1083z40_705, obj_t BgL_z52z12stop1084z40_706, obj_t BgL_z52dmutex1085z52_707, obj_t BgL_z52dcondv1086z52_708, obj_t BgL_z52doutcondv1087z52_709, obj_t BgL_z52flac1088z52_710, obj_t BgL_z52inseek1089z52_711)
{
{ /* Llib/flac_decoder.scm 37 */
{ /* Llib/flac_decoder.scm 37 */
int BgL_bufferzd2timezd2near1079z00_875;int BgL_bufferzd2siza7ezd2nearzd2rat1080z75_876;int BgL_periodzd2siza7ezd2nearzd2rat1081z75_877;bool_t BgL_z52z12dpause1082z40_878;bool_t BgL_z52z12dabort1083z40_879;bool_t BgL_z52z12stop1084z40_880;
BgL_bufferzd2timezd2near1079z00_875 = 
CINT(BgL_bufferzd2timezd2near1079z00_701); 
BgL_bufferzd2siza7ezd2nearzd2rat1080z75_876 = 
CINT(BgL_bufferzd2siza7ezd2nearzd2rat1080z75_702); 
BgL_periodzd2siza7ezd2nearzd2rat1081z75_877 = 
CINT(BgL_periodzd2siza7ezd2nearzd2rat1081z75_703); 
BgL_z52z12dpause1082z40_878 = 
CBOOL(BgL_z52z12dpause1082z40_704); 
BgL_z52z12dabort1083z40_879 = 
CBOOL(BgL_z52z12dabort1083z40_705); 
BgL_z52z12stop1084z40_880 = 
CBOOL(BgL_z52z12stop1084z40_706); 
{ /* Llib/flac_decoder.scm 37 */
BgL_flacmusicdecoderz00_bglt BgL_new1121z00_884;
{ /* Llib/flac_decoder.scm 37 */
BgL_flacmusicdecoderz00_bglt BgL_new1120z00_885;
BgL_new1120z00_885 = 
((BgL_flacmusicdecoderz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_flacmusicdecoderz00_bgl) ))); 
{ /* Llib/flac_decoder.scm 37 */
long BgL_arg1537z00_886;
{ /* Llib/flac_decoder.scm 37 */
long BgL_res1792z00_887;
BgL_res1792z00_887 = 
BGL_CLASS_INDEX(BGl_flacmusicdecoderz00zz__flac_decoderz00); 
BgL_arg1537z00_886 = BgL_res1792z00_887; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1120z00_885), BgL_arg1537z00_886); } 
BgL_new1121z00_884 = BgL_new1120z00_885; } 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1121z00_884)))->BgL_mimetypesz00)=((obj_t)
((obj_t)BgL_mimetypes1078z00_700)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1121z00_884)))->BgL_bufferzd2timezd2nearz00)=((int)BgL_bufferzd2timezd2near1079z00_875),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1121z00_884)))->BgL_bufferzd2siza7ezd2nearzd2ratioz75)=((int)BgL_bufferzd2siza7ezd2nearzd2rat1080z75_876),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1121z00_884)))->BgL_periodzd2siza7ezd2nearzd2ratioz75)=((int)BgL_periodzd2siza7ezd2nearzd2rat1081z75_877),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1121z00_884)))->BgL_z52z12dpausez40)=((bool_t)BgL_z52z12dpause1082z40_878),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1121z00_884)))->BgL_z52z12dabortz40)=((bool_t)BgL_z52z12dabort1083z40_879),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1121z00_884)))->BgL_z52z12stopz40)=((bool_t)BgL_z52z12stop1084z40_880),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1121z00_884)))->BgL_z52dmutexz52)=((obj_t)
((obj_t)BgL_z52dmutex1085z52_707)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1121z00_884)))->BgL_z52dcondvz52)=((obj_t)
((obj_t)BgL_z52dcondv1086z52_708)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1121z00_884)))->BgL_z52doutcondvz52)=((obj_t)
((obj_t)BgL_z52doutcondv1087z52_709)),BUNSPEC); 
((((BgL_flacmusicdecoderz00_bglt)COBJECT(BgL_new1121z00_884))->BgL_z52flacz52)=((obj_t)BgL_z52flac1088z52_710),BUNSPEC); 
((((BgL_flacmusicdecoderz00_bglt)COBJECT(BgL_new1121z00_884))->BgL_z52inseekz52)=((obj_t)BgL_z52inseek1089z52_711),BUNSPEC); 
{ /* Llib/flac_decoder.scm 37 */
obj_t BgL_fun1525z00_888;
BgL_fun1525z00_888 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_flacmusicdecoderz00zz__flac_decoderz00); 
PROCEDURE_ENTRY(BgL_fun1525z00_888)(BgL_fun1525z00_888, 
((obj_t)BgL_new1121z00_884), BEOA); } 
return BgL_new1121z00_884;} } } 

}



/* &<@anonymous:1593> */
obj_t BGl_z62zc3z04anonymousza31593ze3ze5zz__flac_decoderz00(obj_t BgL_envz00_712)
{
{ /* Llib/flac_decoder.scm 37 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda1592 */
obj_t BGl_z62lambda1592z62zz__flac_decoderz00(obj_t BgL_envz00_713, obj_t BgL_oz00_714, obj_t BgL_vz00_715)
{
{ /* Llib/flac_decoder.scm 37 */
return 
((((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)BgL_oz00_714)))->BgL_z52inseekz52)=((obj_t)BgL_vz00_715),BUNSPEC);} 

}



/* &lambda1591 */
obj_t BGl_z62lambda1591z62zz__flac_decoderz00(obj_t BgL_envz00_716, obj_t BgL_oz00_717)
{
{ /* Llib/flac_decoder.scm 37 */
return 
(((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)BgL_oz00_717)))->BgL_z52inseekz52);} 

}



/* &<@anonymous:1579> */
obj_t BGl_z62zc3z04anonymousza31579ze3ze5zz__flac_decoderz00(obj_t BgL_envz00_718)
{
{ /* Llib/flac_decoder.scm 37 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda1578 */
obj_t BGl_z62lambda1578z62zz__flac_decoderz00(obj_t BgL_envz00_719, obj_t BgL_oz00_720, obj_t BgL_vz00_721)
{
{ /* Llib/flac_decoder.scm 37 */
return 
((((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)BgL_oz00_720)))->BgL_z52flacz52)=((obj_t)BgL_vz00_721),BUNSPEC);} 

}



/* &lambda1577 */
obj_t BGl_z62lambda1577z62zz__flac_decoderz00(obj_t BgL_envz00_722, obj_t BgL_oz00_723)
{
{ /* Llib/flac_decoder.scm 37 */
return 
(((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)BgL_oz00_723)))->BgL_z52flacz52);} 

}



/* &<@anonymous:1205> */
obj_t BGl_z62zc3z04anonymousza31205ze3ze5zz__flac_decoderz00(obj_t BgL_envz00_724, obj_t BgL_new1076z00_725)
{
{ /* Llib/flac_decoder.scm 28 */
{ 
BgL_flacdecz00_bglt BgL_auxz00_1262;
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacdecz00_bglt)BgL_new1076z00_725))))->BgL_z42builtinz42)=((FLAC__StreamDecoder *)
0L),BUNSPEC); 
{ 
obj_t BgL_auxz00_1267;
{ /* Llib/flac_decoder.scm 28 */
obj_t BgL_res1791z00_894;
BgL_res1791z00_894 = 
bgl_custom_nil(); 
BgL_auxz00_1267 = BgL_res1791z00_894; } 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacdecz00_bglt)BgL_new1076z00_725))))->BgL_z52flacbufz52)=((obj_t)BgL_auxz00_1267),BUNSPEC); } 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacdecz00_bglt)BgL_new1076z00_725))))->BgL_outbufz00)=((obj_t)BGl_string1920z00zz__flac_decoderz00),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacdecz00_bglt)BgL_new1076z00_725))))->BgL_z52eofz52)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacdecz00_bglt)BgL_new1076z00_725))))->BgL_z52samplez52)=((long)((long)0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacdecz00_bglt)BgL_new1076z00_725))))->BgL_z52volumez52)=((double)((double)0.0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacdecz00_bglt)BgL_new1076z00_725))))->BgL_md5checkz00)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacdecz00_bglt)BgL_new1076z00_725))))->BgL_z52bchecksumz52)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacdecz00_bglt)BgL_new1076z00_725))))->BgL_z52rchecksumz52)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1076z00_725)))->BgL_z52musicz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1076z00_725)))->BgL_z52bufferz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1076z00_725)))->BgL_z52decoderz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1076z00_725)))->BgL_z52ratez52)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1076z00_725)))->BgL_z52ratezd2maxz80)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1076z00_725)))->BgL_z52ratezd2minz80)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1076z00_725)))->BgL_z52lastzd2percentagez80)=((int)
(int)(((long)0))),BUNSPEC); 
BgL_auxz00_1262 = 
((BgL_flacdecz00_bglt)BgL_new1076z00_725); 
return 
((obj_t)BgL_auxz00_1262);} } 

}



/* &lambda1200 */
BgL_flacdecz00_bglt BGl_z62lambda1200z62zz__flac_decoderz00(obj_t BgL_envz00_726)
{
{ /* Llib/flac_decoder.scm 28 */
{ /* Llib/flac_decoder.scm 28 */
BgL_flacdecz00_bglt BgL_new1075z00_895;
BgL_new1075z00_895 = 
((BgL_flacdecz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_flacdecz00_bgl) ))); 
{ /* Llib/flac_decoder.scm 28 */
long BgL_arg1204z00_896;
{ /* Llib/flac_decoder.scm 28 */
long BgL_res1790z00_897;
BgL_res1790z00_897 = 
BGL_CLASS_INDEX(BGl_flacdecz00zz__flac_decoderz00); 
BgL_arg1204z00_896 = BgL_res1790z00_897; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1075z00_895), BgL_arg1204z00_896); } 
return BgL_new1075z00_895;} } 

}



/* &<@anonymous:1505> */
obj_t BGl_z62zc3z04anonymousza31505ze3ze5zz__flac_decoderz00(obj_t BgL_envz00_727)
{
{ /* Llib/flac_decoder.scm 28 */
return 
BINT(((long)0));} 

}



/* &lambda1504 */
obj_t BGl_z62lambda1504z62zz__flac_decoderz00(obj_t BgL_envz00_728, obj_t BgL_oz00_729, obj_t BgL_vz00_730)
{
{ /* Llib/flac_decoder.scm 28 */
{ /* Llib/flac_decoder.scm 28 */
int BgL_vz00_899;
BgL_vz00_899 = 
CINT(BgL_vz00_730); 
return 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_729)))->BgL_z52lastzd2percentagez80)=((int)BgL_vz00_899),BUNSPEC);} } 

}



/* &lambda1503 */
obj_t BGl_z62lambda1503z62zz__flac_decoderz00(obj_t BgL_envz00_731, obj_t BgL_oz00_732)
{
{ /* Llib/flac_decoder.scm 28 */
return 
BINT(
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_732)))->BgL_z52lastzd2percentagez80));} 

}



/* &<@anonymous:1484> */
obj_t BGl_z62zc3z04anonymousza31484ze3ze5zz__flac_decoderz00(obj_t BgL_envz00_733)
{
{ /* Llib/flac_decoder.scm 28 */
return 
BINT(((long)50));} 

}



/* &lambda1483 */
obj_t BGl_z62lambda1483z62zz__flac_decoderz00(obj_t BgL_envz00_734, obj_t BgL_oz00_735, obj_t BgL_vz00_736)
{
{ /* Llib/flac_decoder.scm 28 */
{ /* Llib/flac_decoder.scm 28 */
int BgL_vz00_902;
BgL_vz00_902 = 
CINT(BgL_vz00_736); 
return 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_735)))->BgL_z52ratezd2minz80)=((int)BgL_vz00_902),BUNSPEC);} } 

}



/* &lambda1482 */
obj_t BGl_z62lambda1482z62zz__flac_decoderz00(obj_t BgL_envz00_737, obj_t BgL_oz00_738)
{
{ /* Llib/flac_decoder.scm 28 */
return 
BINT(
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_738)))->BgL_z52ratezd2minz80));} 

}



/* &<@anonymous:1392> */
obj_t BGl_z62zc3z04anonymousza31392ze3ze5zz__flac_decoderz00(obj_t BgL_envz00_739)
{
{ /* Llib/flac_decoder.scm 28 */
return 
BINT(((long)80));} 

}



/* &lambda1391 */
obj_t BGl_z62lambda1391z62zz__flac_decoderz00(obj_t BgL_envz00_740, obj_t BgL_oz00_741, obj_t BgL_vz00_742)
{
{ /* Llib/flac_decoder.scm 28 */
{ /* Llib/flac_decoder.scm 28 */
int BgL_vz00_905;
BgL_vz00_905 = 
CINT(BgL_vz00_742); 
return 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_741)))->BgL_z52ratezd2maxz80)=((int)BgL_vz00_905),BUNSPEC);} } 

}



/* &lambda1390 */
obj_t BGl_z62lambda1390z62zz__flac_decoderz00(obj_t BgL_envz00_743, obj_t BgL_oz00_744)
{
{ /* Llib/flac_decoder.scm 28 */
return 
BINT(
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_744)))->BgL_z52ratezd2maxz80));} 

}



/* &<@anonymous:1304> */
obj_t BGl_z62zc3z04anonymousza31304ze3ze5zz__flac_decoderz00(obj_t BgL_envz00_745)
{
{ /* Llib/flac_decoder.scm 28 */
return 
BINT(((long)80));} 

}



/* &lambda1303 */
obj_t BGl_z62lambda1303z62zz__flac_decoderz00(obj_t BgL_envz00_746, obj_t BgL_oz00_747, obj_t BgL_vz00_748)
{
{ /* Llib/flac_decoder.scm 28 */
{ /* Llib/flac_decoder.scm 28 */
int BgL_vz00_908;
BgL_vz00_908 = 
CINT(BgL_vz00_748); 
return 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_747)))->BgL_z52ratez52)=((int)BgL_vz00_908),BUNSPEC);} } 

}



/* &lambda1302 */
obj_t BGl_z62lambda1302z62zz__flac_decoderz00(obj_t BgL_envz00_749, obj_t BgL_oz00_750)
{
{ /* Llib/flac_decoder.scm 28 */
return 
BINT(
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_750)))->BgL_z52ratez52));} 

}



/* &<@anonymous:1276> */
obj_t BGl_z62zc3z04anonymousza31276ze3ze5zz__flac_decoderz00(obj_t BgL_envz00_751)
{
{ /* Llib/flac_decoder.scm 28 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda1275 */
obj_t BGl_z62lambda1275z62zz__flac_decoderz00(obj_t BgL_envz00_752, obj_t BgL_oz00_753, obj_t BgL_vz00_754)
{
{ /* Llib/flac_decoder.scm 28 */
return 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_753)))->BgL_z52decoderz52)=((obj_t)BgL_vz00_754),BUNSPEC);} 

}



/* &lambda1274 */
obj_t BGl_z62lambda1274z62zz__flac_decoderz00(obj_t BgL_envz00_755, obj_t BgL_oz00_756)
{
{ /* Llib/flac_decoder.scm 28 */
return 
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_756)))->BgL_z52decoderz52);} 

}



/* &<@anonymous:1264> */
obj_t BGl_z62zc3z04anonymousza31264ze3ze5zz__flac_decoderz00(obj_t BgL_envz00_757)
{
{ /* Llib/flac_decoder.scm 28 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda1263 */
obj_t BGl_z62lambda1263z62zz__flac_decoderz00(obj_t BgL_envz00_758, obj_t BgL_oz00_759, obj_t BgL_vz00_760)
{
{ /* Llib/flac_decoder.scm 28 */
return 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_759)))->BgL_z52bufferz52)=((obj_t)BgL_vz00_760),BUNSPEC);} 

}



/* &lambda1262 */
obj_t BGl_z62lambda1262z62zz__flac_decoderz00(obj_t BgL_envz00_761, obj_t BgL_oz00_762)
{
{ /* Llib/flac_decoder.scm 28 */
return 
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_762)))->BgL_z52bufferz52);} 

}



/* &<@anonymous:1245> */
obj_t BGl_z62zc3z04anonymousza31245ze3ze5zz__flac_decoderz00(obj_t BgL_envz00_763)
{
{ /* Llib/flac_decoder.scm 28 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda1244 */
obj_t BGl_z62lambda1244z62zz__flac_decoderz00(obj_t BgL_envz00_764, obj_t BgL_oz00_765, obj_t BgL_vz00_766)
{
{ /* Llib/flac_decoder.scm 28 */
return 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_765)))->BgL_z52musicz52)=((obj_t)BgL_vz00_766),BUNSPEC);} 

}



/* &lambda1243 */
obj_t BGl_z62lambda1243z62zz__flac_decoderz00(obj_t BgL_envz00_767, obj_t BgL_oz00_768)
{
{ /* Llib/flac_decoder.scm 28 */
return 
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_768)))->BgL_z52musicz52);} 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__flac_decoderz00()
{
{ /* Llib/flac_decoder.scm 15 */
return BUNSPEC;} 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__flac_decoderz00()
{
{ /* Llib/flac_decoder.scm 15 */
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2initzd2envz00zz__multimediazd2musicbufzd2, BGl_flacmusicdecoderz00zz__flac_decoderz00, BGl_proc1921z00zz__flac_decoderz00, BGl_string1922z00zz__flac_decoderz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_flaczd2decoderzd2resetz12zd2envzc0zz__flac_flacz00, BGl_flacdecz00zz__flac_decoderz00, BGl_proc1923z00zz__flac_decoderz00, BGl_string1924z00zz__flac_decoderz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_flaczd2decoderzd2writezd2envzd2zz__flac_flacz00, BGl_flacdecz00zz__flac_decoderz00, BGl_proc1925z00zz__flac_decoderz00, BGl_string1926z00zz__flac_decoderz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2resetz12zd2envz12zz__multimediazd2musicbufzd2, BGl_flacmusicdecoderz00zz__flac_decoderz00, BGl_proc1927z00zz__flac_decoderz00, BGl_string1928z00zz__flac_decoderz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2positionzd2envz00zz__multimediazd2musicbufzd2, BGl_flacmusicdecoderz00zz__flac_decoderz00, BGl_proc1929z00zz__flac_decoderz00, BGl_string1930z00zz__flac_decoderz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2infozd2envz00zz__multimediazd2musicbufzd2, BGl_flacmusicdecoderz00zz__flac_decoderz00, BGl_proc1931z00zz__flac_decoderz00, BGl_string1932z00zz__flac_decoderz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2volumezd2setz12zd2envzc0zz__multimediazd2musicbufzd2, BGl_flacmusicdecoderz00zz__flac_decoderz00, BGl_proc1933z00zz__flac_decoderz00, BGl_string1934z00zz__flac_decoderz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2seekzd2envz00zz__multimediazd2musicbufzd2, BGl_flacmusicdecoderz00zz__flac_decoderz00, BGl_proc1935z00zz__flac_decoderz00, BGl_string1936z00zz__flac_decoderz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_flaczd2decoderzd2readzd2envzd2zz__flac_flacz00, BGl_flacdecz00zz__flac_decoderz00, BGl_proc1937z00zz__flac_decoderz00, BGl_string1938z00zz__flac_decoderz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_flaczd2decoderzd2tellzd2envzd2zz__flac_flacz00, BGl_flacdecz00zz__flac_decoderz00, BGl_proc1939z00zz__flac_decoderz00, BGl_string1940z00zz__flac_decoderz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_flaczd2decoderzd2seekzd2envzd2zz__flac_flacz00, BGl_flacdecz00zz__flac_decoderz00, BGl_proc1941z00zz__flac_decoderz00, BGl_string1942z00zz__flac_decoderz00); 
return 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_flaczd2decoderzd2lengthzd2envzd2zz__flac_flacz00, BGl_flacdecz00zz__flac_decoderz00, BGl_proc1943z00zz__flac_decoderz00, BGl_string1944z00zz__flac_decoderz00);} 

}



/* &flac-decoder-length-1151 */
obj_t BGl_z62flaczd2decoderzd2lengthzd21151zb0zz__flac_decoderz00(obj_t BgL_envz00_789, obj_t BgL_oz00_790)
{
{ /* Llib/flac_decoder.scm 274 */
{ /* Llib/flac_decoder.scm 276 */
BgL_flacmusicdecoderz00_bglt BgL_i1118z00_917;
BgL_i1118z00_917 = 
((BgL_flacmusicdecoderz00_bglt)
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_790)))->BgL_z52decoderz52)); 
{ /* Llib/flac_decoder.scm 277 */
BgL_flacdecz00_bglt BgL_i1119z00_918;
BgL_i1119z00_918 = 
((BgL_flacdecz00_bglt)
(((BgL_flacmusicdecoderz00_bglt)COBJECT(BgL_i1118z00_917))->BgL_z52flacz52)); 
{ /* Llib/flac_decoder.scm 278 */
obj_t BgL_arg1784z00_919;
BgL_arg1784z00_919 = 
(((BgL_flacdecz00_bglt)COBJECT(BgL_i1119z00_918))->BgL_z52bufferz52); 
return 
BGl_musicbufferzd2lengthzd2zz__multimediazd2musicbufzd2(
((BgL_musicbufferz00_bglt)BgL_arg1784z00_919));} } } } 

}



/* &flac-decoder-seek-fl1149 */
obj_t BGl_z62flaczd2decoderzd2seekzd2fl1149zb0zz__flac_decoderz00(obj_t BgL_envz00_791, obj_t BgL_oz00_792, obj_t BgL_offz00_793)
{
{ /* Llib/flac_decoder.scm 263 */
{ /* Llib/flac_decoder.scm 265 */
BgL_flacmusicdecoderz00_bglt BgL_i1116z00_921;
BgL_i1116z00_921 = 
((BgL_flacmusicdecoderz00_bglt)
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_792)))->BgL_z52decoderz52)); 
{ /* Llib/flac_decoder.scm 266 */
bool_t BgL_test2024z00_1385;
{ /* Llib/flac_decoder.scm 266 */
obj_t BgL_arg1783z00_922;
BgL_arg1783z00_922 = 
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_792)))->BgL_z52bufferz52); 
BgL_test2024z00_1385 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1783z00_922, BGl_musicbufferz00zz__multimediazd2musicbufzd2); } 
if(BgL_test2024z00_1385)
{ /* Llib/flac_decoder.scm 266 */
{ /* Llib/flac_decoder.scm 267 */
obj_t BgL_arg1782z00_923;
BgL_arg1782z00_923 = 
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_792)))->BgL_z52bufferz52); 
BGl_musicbufferzd2seekzd2zz__multimediazd2musicbufzd2(
((BgL_musicbufferz00_bglt)BgL_arg1782z00_923), BgL_offz00_793); } 
((((BgL_flacmusicdecoderz00_bglt)COBJECT(BgL_i1116z00_921))->BgL_z52inseekz52)=((obj_t)BFALSE),BUNSPEC); 
return BTRUE;}  else 
{ /* Llib/flac_decoder.scm 266 */
return BFALSE;} } } } 

}



/* &flac-decoder-tell-fl1147 */
obj_t BGl_z62flaczd2decoderzd2tellzd2fl1147zb0zz__flac_decoderz00(obj_t BgL_envz00_794, obj_t BgL_oz00_795)
{
{ /* Llib/flac_decoder.scm 253 */
{ /* Llib/flac_decoder.scm 255 */
BgL_flacmusicdecoderz00_bglt BgL_i1113z00_925;
BgL_i1113z00_925 = 
((BgL_flacmusicdecoderz00_bglt)
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_795)))->BgL_z52decoderz52)); 
{ /* Llib/flac_decoder.scm 256 */
BgL_flacdecz00_bglt BgL_i1114z00_926;
BgL_i1114z00_926 = 
((BgL_flacdecz00_bglt)
(((BgL_flacmusicdecoderz00_bglt)COBJECT(BgL_i1113z00_925))->BgL_z52flacz52)); 
{ /* Llib/flac_decoder.scm 257 */
bool_t BgL_test2025z00_1399;
{ /* Llib/flac_decoder.scm 257 */
obj_t BgL_arg1779z00_927;
BgL_arg1779z00_927 = 
(((BgL_flacdecz00_bglt)COBJECT(BgL_i1114z00_926))->BgL_z52bufferz52); 
BgL_test2025z00_1399 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1779z00_927, BGl_musicbufferz00zz__multimediazd2musicbufzd2); } 
if(BgL_test2025z00_1399)
{ /* Llib/flac_decoder.scm 258 */
obj_t BgL_arg1778z00_928;
BgL_arg1778z00_928 = 
(((BgL_flacdecz00_bglt)COBJECT(BgL_i1114z00_926))->BgL_z52bufferz52); 
return 
BGl_musicbufferzd2tellzd2zz__multimediazd2musicbufzd2(
((BgL_musicbufferz00_bglt)BgL_arg1778z00_928));}  else 
{ /* Llib/flac_decoder.scm 257 */
return BFALSE;} } } } } 

}



/* &flac-decoder-read-fl1145 */
obj_t BGl_z62flaczd2decoderzd2readzd2fl1145zb0zz__flac_decoderz00(obj_t BgL_envz00_796, obj_t BgL_oz00_797, obj_t BgL_siza7eza7_798)
{
{ /* Llib/flac_decoder.scm 143 */
{ /* Llib/flac_decoder.scm 144 */
long BgL_siza7eza7_930;
BgL_siza7eza7_930 = 
(long)CINT(BgL_siza7eza7_798); 
{ /* Llib/flac_decoder.scm 146 */
BgL_musicdecoderz00_bglt BgL_i1105z00_931;
BgL_i1105z00_931 = 
((BgL_musicdecoderz00_bglt)
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_797)))->BgL_z52decoderz52)); 
{ /* Llib/flac_decoder.scm 147 */
BgL_musicbufferz00_bglt BgL_i1106z00_932;
BgL_i1106z00_932 = 
((BgL_musicbufferz00_bglt)
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_797)))->BgL_z52bufferz52)); 
{ /* Llib/flac_decoder.scm 147 */
long BgL_inlenz00_933;
BgL_inlenz00_933 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1106z00_932))->BgL_z52inlenz52); 
{ /* Llib/flac_decoder.scm 155 */
char * BgL_flacbufz00_934;
{ /* Llib/flac_decoder.scm 155 */
obj_t BgL_arg1775z00_935;
BgL_arg1775z00_935 = 
(((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacdecz00_bglt)BgL_oz00_797))))->BgL_z52flacbufz52); 
BgL_flacbufz00_934 = 
CUSTOM_IDENTIFIER(BgL_arg1775z00_935); } 
{ 

{ 

{ 
long BgL_siza7eza7_952;
{ 
long BgL_siza7eza7_961;long BgL_iz00_962;
BgL_siza7eza7_961 = BgL_siza7eza7_930; 
BgL_iz00_962 = ((long)0); 
BgL_loopz00_960:
if(
(((BgL_musicdecoderz00_bglt)COBJECT(BgL_i1105z00_931))->BgL_z52z12dpausez40))
{ /* Llib/flac_decoder.scm 202 */
{ /* Llib/flac_decoder.scm 203 */
obj_t BgL_arg1635z00_963;
BgL_arg1635z00_963 = 
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_797)))->BgL_z52musicz52); 
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_arg1635z00_963), 
CNST_TABLE_REF(((long)14))); } 
{ /* Llib/flac_decoder.scm 205 */
BgL_musicz00_bglt BgL_i1108z00_964;
BgL_i1108z00_964 = 
((BgL_musicz00_bglt)
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_797)))->BgL_z52musicz52)); 
{ /* Llib/flac_decoder.scm 206 */
BgL_musicstatusz00_bglt BgL_i1109z00_965;
BgL_i1109z00_965 = 
(((BgL_musicz00_bglt)COBJECT(BgL_i1108z00_964))->BgL_z52statusz52); 
{ 
obj_t BgL_auxz00_1428;
{ /* Llib/flac_decoder.scm 208 */
obj_t BgL_arg1642z00_966;obj_t BgL_arg1643z00_967;
BgL_arg1642z00_966 = 
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_797)))->BgL_z52decoderz52); 
BgL_arg1643z00_967 = 
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_797)))->BgL_z52bufferz52); 
BgL_auxz00_1428 = 
BINT(
BGl_musicdecoderzd2positionzd2zz__multimediazd2musicbufzd2(
((BgL_musicdecoderz00_bglt)BgL_arg1642z00_966), 
((BgL_musicbufferz00_bglt)BgL_arg1643z00_967))); } 
((((BgL_musicstatusz00_bglt)COBJECT(BgL_i1109z00_965))->BgL_songposz00)=((obj_t)BgL_auxz00_1428),BUNSPEC); } } } 
{ /* Llib/flac_decoder.scm 209 */
obj_t BgL_mutex1644z00_968;
BgL_mutex1644z00_968 = 
(((BgL_musicdecoderz00_bglt)COBJECT(BgL_i1105z00_931))->BgL_z52dmutexz52); 
BGL_MUTEX_LOCK(BgL_mutex1644z00_968); 
{ /* Llib/flac_decoder.scm 209 */
bool_t BgL_tmp2027z00_1439;
{ 

BgL_liipz00_969:
if(
(((BgL_musicdecoderz00_bglt)COBJECT(BgL_i1105z00_931))->BgL_z52z12dpausez40))
{ /* Llib/flac_decoder.scm 211 */
{ /* Llib/flac_decoder.scm 212 */
obj_t BgL_arg1650z00_970;obj_t BgL_arg1651z00_971;
BgL_arg1650z00_970 = 
(((BgL_musicdecoderz00_bglt)COBJECT(BgL_i1105z00_931))->BgL_z52dcondvz52); 
BgL_arg1651z00_971 = 
(((BgL_musicdecoderz00_bglt)COBJECT(BgL_i1105z00_931))->BgL_z52dmutexz52); 
{ /* Llib/flac_decoder.scm 212 */

{ /* Llib/flac_decoder.scm 212 */
bool_t BgL_res1823z00_972;
BgL_res1823z00_972 = 
BGL_CONDVAR_WAIT(BgL_arg1650z00_970, BgL_arg1651z00_971); BgL_res1823z00_972; } } } 
goto BgL_liipz00_969;}  else 
{ /* Llib/flac_decoder.scm 211 */
BgL_tmp2027z00_1439 = ((bool_t)0); } } 
BGL_MUTEX_UNLOCK(BgL_mutex1644z00_968); BgL_tmp2027z00_1439; } } 
{ /* Llib/flac_decoder.scm 214 */
obj_t BgL_arg1652z00_973;
BgL_arg1652z00_973 = 
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_797)))->BgL_z52musicz52); 
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_arg1652z00_973), 
CNST_TABLE_REF(((long)15))); } 
{ 

goto BgL_loopz00_960;} }  else 
{ /* Llib/flac_decoder.scm 202 */
if(
(((BgL_musicdecoderz00_bglt)COBJECT(BgL_i1105z00_931))->BgL_z52z12dabortz40))
{ /* Llib/flac_decoder.scm 216 */
return 
BINT(((long)-1));}  else 
{ /* Llib/flac_decoder.scm 216 */
if(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1106z00_932))->BgL_z52emptyz52))
{ /* Llib/flac_decoder.scm 219 */
if(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1106z00_932))->BgL_z52eofz52))
{ /* Llib/flac_decoder.scm 221 */
return BEOF;}  else 
{ /* Llib/flac_decoder.scm 221 */
{ /* Llib/flac_decoder.scm 224 */
BgL_musicz00_bglt BgL_i1110z00_974;
BgL_i1110z00_974 = 
((BgL_musicz00_bglt)
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_797)))->BgL_z52musicz52)); 
{ 
int BgL_auxz00_1462;
{ /* Llib/flac_decoder.scm 227 */
long BgL_tmpz00_1464;
{ /* Llib/flac_decoder.scm 160 */
BGL_LONGLONG_T BgL_arg1769z00_937;
{ /* Llib/flac_decoder.scm 160 */
BGL_LONGLONG_T BgL_arg1770z00_938;BGL_LONGLONG_T BgL_arg1771z00_939;
{ /* Llib/flac_decoder.scm 160 */
BGL_LONGLONG_T BgL_arg1772z00_940;
{ /* Llib/flac_decoder.scm 160 */
long BgL_arg1773z00_941;
{ /* Llib/flac_decoder.scm 160 */
obj_t BgL_arg1774z00_942;
BgL_arg1774z00_942 = 
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_797)))->BgL_z52bufferz52); 
BgL_arg1773z00_941 = 
BGl_musicbufferzd2availablezd2zz__multimediazd2musicbufzd2(
((BgL_musicbufferz00_bglt)BgL_arg1774z00_942)); } 
{ /* Llib/flac_decoder.scm 160 */
BGL_LONGLONG_T BgL_res1800z00_943;
BgL_res1800z00_943 = 
LONG_TO_LLONG(BgL_arg1773z00_941); 
BgL_arg1772z00_940 = BgL_res1800z00_943; } } 
BgL_arg1770z00_938 = 
(((BGL_LONGLONG_T)100)*BgL_arg1772z00_940); } 
{ /* Llib/flac_decoder.scm 161 */
BGL_LONGLONG_T BgL_res1802z00_944;
BgL_res1802z00_944 = 
LONG_TO_LLONG(BgL_inlenz00_933); 
BgL_arg1771z00_939 = BgL_res1802z00_944; } 
{ /* Llib/flac_decoder.scm 159 */
BGL_LONGLONG_T BgL_res1803z00_945;
BgL_res1803z00_945 = 
(BgL_arg1770z00_938/BgL_arg1771z00_939); 
BgL_arg1769z00_937 = BgL_res1803z00_945; } } 
{ /* Llib/flac_decoder.scm 158 */
long BgL_res1804z00_946;
BgL_res1804z00_946 = 
LLONG_TO_LONG(BgL_arg1769z00_937); 
BgL_tmpz00_1464 = BgL_res1804z00_946; } } 
BgL_auxz00_1462 = 
(int)(BgL_tmpz00_1464); } 
((((BgL_musicstatusz00_bglt)COBJECT(
(((BgL_musicz00_bglt)COBJECT(BgL_i1110z00_974))->BgL_z52statusz52)))->BgL_bufferingz00)=((int)BgL_auxz00_1462),BUNSPEC); } } 
{ /* Llib/flac_decoder.scm 228 */
obj_t BgL_arg1661z00_975;
BgL_arg1661z00_975 = 
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_797)))->BgL_z52musicz52); 
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_arg1661z00_975), 
CNST_TABLE_REF(((long)16))); } 
{ /* Llib/flac_decoder.scm 229 */
obj_t BgL_mutex1662z00_976;
BgL_mutex1662z00_976 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1106z00_932))->BgL_z52bmutexz52); 
{ /* Llib/flac_decoder.scm 229 */
obj_t BgL_top2033z00_1483;
BgL_top2033z00_1483 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGL_MUTEX_LOCK(BgL_mutex1662z00_976); 
BGL_EXITD_PUSH_PROTECT(BgL_top2033z00_1483, BgL_mutex1662z00_976); BUNSPEC; 
{ /* Llib/flac_decoder.scm 229 */
bool_t BgL_tmp2032z00_1482;
{ /* Llib/flac_decoder.scm 231 */
bool_t BgL_test2034z00_1487;
if(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1106z00_932))->BgL_z52emptyz52))
{ /* Llib/flac_decoder.scm 231 */
if(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1106z00_932))->BgL_z52eofz52))
{ /* Llib/flac_decoder.scm 231 */
BgL_test2034z00_1487 = ((bool_t)1)
; }  else 
{ /* Llib/flac_decoder.scm 231 */
if(
(((BgL_musicdecoderz00_bglt)COBJECT(BgL_i1105z00_931))->BgL_z52z12dabortz40))
{ /* Llib/flac_decoder.scm 231 */
BgL_test2034z00_1487 = ((bool_t)1)
; }  else 
{ /* Llib/flac_decoder.scm 231 */
if(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1106z00_932))->BgL_z52emptyz52))
{ /* Llib/flac_decoder.scm 165 */
BgL_test2034z00_1487 = ((bool_t)0)
; }  else 
{ /* Llib/flac_decoder.scm 166 */
long BgL_arg1765z00_948;
{ /* Llib/flac_decoder.scm 166 */
long BgL_arg1766z00_949;
{ /* Llib/flac_decoder.scm 166 */
obj_t BgL_arg1767z00_950;
BgL_arg1767z00_950 = 
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_797)))->BgL_z52bufferz52); 
BgL_arg1766z00_949 = 
BGl_musicbufferzd2availablezd2zz__multimediazd2musicbufzd2(
((BgL_musicbufferz00_bglt)BgL_arg1767z00_950)); } 
BgL_arg1765z00_948 = 
(((long)4)*BgL_arg1766z00_949); } 
BgL_test2034z00_1487 = 
(BgL_arg1765z00_948>BgL_inlenz00_933); } } } }  else 
{ /* Llib/flac_decoder.scm 231 */
BgL_test2034z00_1487 = ((bool_t)1)
; } 
if(BgL_test2034z00_1487)
{ /* Llib/flac_decoder.scm 231 */
BgL_tmp2032z00_1482 = ((bool_t)0); }  else 
{ /* Llib/flac_decoder.scm 235 */
obj_t BgL_arg1668z00_977;obj_t BgL_arg1676z00_978;
BgL_arg1668z00_977 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1106z00_932))->BgL_z52bcondvz52); 
BgL_arg1676z00_978 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1106z00_932))->BgL_z52bmutexz52); 
{ /* Llib/flac_decoder.scm 235 */

{ /* Llib/flac_decoder.scm 235 */
bool_t BgL_res1825z00_979;
BgL_res1825z00_979 = 
BGL_CONDVAR_WAIT(BgL_arg1668z00_977, BgL_arg1676z00_978); 
BgL_tmp2032z00_1482 = BgL_res1825z00_979; } } } } 
BGL_EXITD_POP_PROTECT(BgL_top2033z00_1483); BUNSPEC; 
BGL_MUTEX_UNLOCK(BgL_mutex1662z00_976); BgL_tmp2032z00_1482; } } } 
{ /* Llib/flac_decoder.scm 236 */
obj_t BgL_arg1677z00_980;
BgL_arg1677z00_980 = 
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_797)))->BgL_z52musicz52); 
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_arg1677z00_980), 
CNST_TABLE_REF(((long)15))); } 
{ 

goto BgL_loopz00_960;} } }  else 
{ /* Llib/flac_decoder.scm 239 */
long BgL_sz00_981;
{ /* Llib/flac_decoder.scm 239 */
long BgL_bz00_982;
if(
(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1106z00_932))->BgL_z52headz52)>
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1106z00_932))->BgL_z52tailz52)))
{ /* Llib/flac_decoder.scm 240 */
BgL_bz00_982 = 
(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1106z00_932))->BgL_z52headz52)-
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1106z00_932))->BgL_z52tailz52)); }  else 
{ /* Llib/flac_decoder.scm 240 */
BgL_bz00_982 = 
(BgL_inlenz00_933-
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1106z00_932))->BgL_z52tailz52)); } 
if(
(BgL_siza7eza7_961<BgL_bz00_982))
{ /* Llib/flac_decoder.scm 240 */
BgL_sz00_981 = BgL_siza7eza7_961; }  else 
{ /* Llib/flac_decoder.scm 240 */
BgL_sz00_981 = BgL_bz00_982; } } 
if(
(BgL_sz00_981>((long)0)))
{ /* Llib/flac_decoder.scm 243 */
{ /* Llib/flac_decoder.scm 244 */
char * BgL_arg1680z00_983;long BgL_arg1686z00_984;
BgL_arg1680z00_983 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1106z00_932))->BgL_z52inbufpz52); 
BgL_arg1686z00_984 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1106z00_932))->BgL_z52tailz52); 
BGL_FLAC_BLIT_STRING(BgL_arg1680z00_983, BgL_arg1686z00_984, BgL_flacbufz00_934, BgL_iz00_962, BgL_sz00_981); BUNSPEC; } 
BgL_siza7eza7_952 = BgL_sz00_981; 
{ /* Llib/flac_decoder.scm 174 */
long BgL_ntailz00_953;
BgL_ntailz00_953 = 
(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1106z00_932))->BgL_z52tailz52)+BgL_siza7eza7_952); 
if(
(BgL_ntailz00_953==BgL_inlenz00_933))
{ /* Llib/flac_decoder.scm 175 */
BgL_ntailz00_953 = ((long)0); }  else 
{ /* Llib/flac_decoder.scm 175 */BFALSE; } 
if(
(BgL_ntailz00_953==
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1106z00_932))->BgL_z52headz52)))
{ /* Llib/flac_decoder.scm 178 */
if(
(
(long)(
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_797)))->BgL_z52ratez52))<((long)80)))
{ /* Llib/flac_decoder.scm 179 */
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_797)))->BgL_z52ratez52)=((int)
(int)(((long)80))),BUNSPEC); }  else 
{ /* Llib/flac_decoder.scm 179 */BFALSE; } 
((((BgL_musicbufferz00_bglt)COBJECT(BgL_i1106z00_932))->BgL_z52emptyz52)=((bool_t)((bool_t)1)),BUNSPEC); }  else 
{ /* Llib/flac_decoder.scm 178 */BFALSE; } 
((((BgL_musicbufferz00_bglt)COBJECT(BgL_i1106z00_932))->BgL_z52tailz52)=((long)BgL_ntailz00_953),BUNSPEC); } 
if(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1106z00_932))->BgL_z52eofz52))
{ /* Llib/flac_decoder.scm 183 */BFALSE; }  else 
{ /* Llib/flac_decoder.scm 186 */
long BgL_availz00_954;
{ /* Llib/flac_decoder.scm 186 */
obj_t BgL_arg1760z00_955;
BgL_arg1760z00_955 = 
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_797)))->BgL_z52bufferz52); 
BgL_availz00_954 = 
BGl_musicbufferzd2availablezd2zz__multimediazd2musicbufzd2(
((BgL_musicbufferz00_bglt)BgL_arg1760z00_955)); } 
{ /* Llib/flac_decoder.scm 186 */
long BgL_pz00_956;
BgL_pz00_956 = 
(
(BgL_availz00_954*((long)100))/BgL_inlenz00_933); 
{ /* Llib/flac_decoder.scm 187 */

if(
(BgL_pz00_956<
(long)(
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_797)))->BgL_z52ratez52))))
{ /* Llib/flac_decoder.scm 189 */
{ /* Llib/flac_decoder.scm 169 */
obj_t BgL_mutex1762z00_957;
BgL_mutex1762z00_957 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1106z00_932))->BgL_z52bmutexz52); 
BGL_MUTEX_LOCK(BgL_mutex1762z00_957); 
{ /* Llib/flac_decoder.scm 169 */
bool_t BgL_tmp2047z00_1559;
{ /* Llib/flac_decoder.scm 170 */
obj_t BgL_arg1763z00_958;
BgL_arg1763z00_958 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1106z00_932))->BgL_z52bcondvz52); 
{ /* Llib/flac_decoder.scm 170 */
bool_t BgL_res1815z00_959;
BgL_res1815z00_959 = 
BGL_CONDVAR_BROADCAST(BgL_arg1763z00_958); 
BgL_tmp2047z00_1559 = BgL_res1815z00_959; } } 
BGL_MUTEX_UNLOCK(BgL_mutex1762z00_957); BgL_tmp2047z00_1559; } } 
{ /* Llib/flac_decoder.scm 191 */
bool_t BgL_test2048z00_1564;
if(
(BgL_pz00_956<=
(long)(
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_797)))->BgL_z52lastzd2percentagez80))))
{ /* Llib/flac_decoder.scm 191 */
BgL_test2048z00_1564 = 
(
(long)(
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_797)))->BgL_z52ratez52))<
(long)(
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_797)))->BgL_z52ratezd2maxz80)))
; }  else 
{ /* Llib/flac_decoder.scm 191 */
BgL_test2048z00_1564 = ((bool_t)0)
; } 
if(BgL_test2048z00_1564)
{ /* Llib/flac_decoder.scm 191 */
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_797)))->BgL_z52ratez52)=((int)
(int)(
(
(long)(
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_797)))->BgL_z52ratez52))+((long)10)))),BUNSPEC); }  else 
{ /* Llib/flac_decoder.scm 191 */BFALSE; } } }  else 
{ /* Llib/flac_decoder.scm 189 */
if(
(BgL_pz00_956>
(long)(
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_797)))->BgL_z52ratezd2minz80))))
{ /* Llib/flac_decoder.scm 193 */
if(
(
(long)(
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_797)))->BgL_z52ratez52))>
(long)(
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_797)))->BgL_z52ratezd2minz80))))
{ /* Llib/flac_decoder.scm 194 */
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_797)))->BgL_z52ratez52)=((int)
(int)(
(
(long)(
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_797)))->BgL_z52ratez52))-((long)1)))),BUNSPEC); }  else 
{ /* Llib/flac_decoder.scm 194 */BFALSE; } }  else 
{ /* Llib/flac_decoder.scm 193 */BFALSE; } } 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_797)))->BgL_z52lastzd2percentagez80)=((int)
(int)(BgL_pz00_956)),BUNSPEC); BUNSPEC; } } } }  else 
{ /* Llib/flac_decoder.scm 243 */BFALSE; } 
if(
(BgL_sz00_981<BgL_siza7eza7_961))
{ 
long BgL_iz00_1611;long BgL_siza7eza7_1609;
BgL_siza7eza7_1609 = 
(BgL_siza7eza7_961-BgL_sz00_981); 
BgL_iz00_1611 = 
(BgL_iz00_962+BgL_sz00_981); 
BgL_iz00_962 = BgL_iz00_1611; 
BgL_siza7eza7_961 = BgL_siza7eza7_1609; 
goto BgL_loopz00_960;}  else 
{ /* Llib/flac_decoder.scm 246 */
return 
BINT(
(BgL_iz00_962+BgL_sz00_981));} } } } } } } } } } } } } } 

}



/* &musicdecoder-seek-fl1143 */
obj_t BGl_z62musicdecoderzd2seekzd2fl1143z62zz__flac_decoderz00(obj_t BgL_envz00_799, obj_t BgL_oz00_800, obj_t BgL_secz00_801)
{
{ /* Llib/flac_decoder.scm 130 */
if(
CBOOL(
(((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)BgL_oz00_800)))->BgL_z52inseekz52)))
{ /* Llib/flac_decoder.scm 132 */
return BFALSE;}  else 
{ /* Llib/flac_decoder.scm 132 */
((((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)BgL_oz00_800)))->BgL_z52inseekz52)=((obj_t)BTRUE),BUNSPEC); 
{ /* Llib/flac_decoder.scm 134 */
BgL_flacdecz00_bglt BgL_i1103z00_986;
BgL_i1103z00_986 = 
((BgL_flacdecz00_bglt)
(((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)BgL_oz00_800)))->BgL_z52flacz52)); 
{ /* Llib/flac_decoder.scm 135 */
unsigned long BgL_bpsz00_987;
{ /* Llib/flac_decoder.scm 135 */
FLAC__StreamDecoder * BgL_arg1629z00_988;
BgL_arg1629z00_988 = 
(((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_i1103z00_986)))->BgL_z42builtinz42); 
BgL_bpsz00_987 = 
FLAC__stream_decoder_get_bits_per_sample(BgL_arg1629z00_988); } 
{ /* Llib/flac_decoder.scm 135 */
unsigned long BgL_sratez00_989;
{ /* Llib/flac_decoder.scm 136 */
FLAC__StreamDecoder * BgL_arg1628z00_990;
BgL_arg1628z00_990 = 
(((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_i1103z00_986)))->BgL_z42builtinz42); 
BgL_sratez00_989 = 
FLAC__stream_decoder_get_sample_rate(BgL_arg1628z00_990); } 
{ /* Llib/flac_decoder.scm 136 */
BGL_LONGLONG_T BgL_offz00_991;
{ /* Llib/flac_decoder.scm 137 */
BGL_LONGLONG_T BgL_arg1626z00_992;BGL_LONGLONG_T BgL_arg1627z00_993;
{ /* Llib/flac_decoder.scm 137 */
BGL_LONGLONG_T BgL_res1796z00_994;
{ /* Llib/flac_decoder.scm 137 */
long BgL_tmpz00_1630;
BgL_tmpz00_1630 = 
(long)(BgL_sratez00_989); 
BgL_res1796z00_994 = 
LONG_TO_LLONG(BgL_tmpz00_1630); } 
BgL_arg1626z00_992 = BgL_res1796z00_994; } 
{ /* Llib/flac_decoder.scm 137 */
BGL_LONGLONG_T BgL_res1797z00_995;
{ /* Llib/flac_decoder.scm 137 */
long BgL_tmpz00_1633;
BgL_tmpz00_1633 = 
(long)CINT(BgL_secz00_801); 
BgL_res1797z00_995 = 
LONG_TO_LLONG(BgL_tmpz00_1633); } 
BgL_arg1627z00_993 = BgL_res1797z00_995; } 
BgL_offz00_991 = 
(BgL_arg1626z00_992*BgL_arg1627z00_993); } 
{ /* Llib/flac_decoder.scm 137 */

{ /* Llib/flac_decoder.scm 138 */
FLAC__StreamDecoder * BgL_arg1625z00_996;
BgL_arg1625z00_996 = 
(((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_i1103z00_986)))->BgL_z42builtinz42); 
{ /* Llib/flac_decoder.scm 138 */
long BgL_tmpz00_1639;
{ /* Llib/flac_decoder.scm 138 */
unsigned BGL_LONGLONG_T BgL_tmpz00_1640;
BgL_tmpz00_1640 = 
(unsigned BGL_LONGLONG_T)(BgL_offz00_991); 
BgL_tmpz00_1639 = 
FLAC__stream_decoder_seek_absolute(BgL_arg1625z00_996, BgL_tmpz00_1640); } 
return 
BINT(BgL_tmpz00_1639);} } } } } } } } } 

}



/* &musicdecoder-volume-1141 */
obj_t BGl_z62musicdecoderzd2volumezd21141z62zz__flac_decoderz00(obj_t BgL_envz00_802, obj_t BgL_oz00_803, obj_t BgL_volz00_804)
{
{ /* Llib/flac_decoder.scm 123 */
{ /* Llib/flac_decoder.scm 125 */
obj_t BgL_arg1619z00_998;
BgL_arg1619z00_998 = 
(((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)BgL_oz00_803)))->BgL_z52flacz52); 
return 
BGl_flaczd2volumezd2setz12z12zz__flac_flacz00(
((BgL_flaczd2decoderzd2_bglt)BgL_arg1619z00_998), BgL_volz00_804);} } 

}



/* &musicdecoder-info-fl1139 */
obj_t BGl_z62musicdecoderzd2infozd2fl1139z62zz__flac_decoderz00(obj_t BgL_envz00_805, obj_t BgL_oz00_806)
{
{ /* Llib/flac_decoder.scm 116 */
{ /* Llib/flac_decoder.scm 117 */
long BgL_tmpz00_1648;
{ /* Llib/flac_decoder.scm 118 */
obj_t BgL_arg1616z00_1000;
BgL_arg1616z00_1000 = 
(((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)BgL_oz00_806)))->BgL_z52flacz52); 
BgL_tmpz00_1648 = 
BGl_flaczd2decoderzd2infoz00zz__flac_flacz00(
((BgL_flaczd2decoderzd2_bglt)BgL_arg1616z00_1000)); } 
return 
BINT(BgL_tmpz00_1648);} } 

}



/* &musicdecoder-positio1137 */
obj_t BGl_z62musicdecoderzd2positio1137zb0zz__flac_decoderz00(obj_t BgL_envz00_807, obj_t BgL_oz00_808, obj_t BgL_abufz00_809)
{
{ /* Llib/flac_decoder.scm 109 */
{ /* Llib/flac_decoder.scm 110 */
long BgL_tmpz00_1654;
{ /* Llib/flac_decoder.scm 111 */
obj_t BgL_arg1613z00_1002;
BgL_arg1613z00_1002 = 
(((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)BgL_oz00_808)))->BgL_z52flacz52); 
BgL_tmpz00_1654 = 
BGl_flaczd2decoderzd2positionz00zz__flac_flacz00(
((BgL_flaczd2decoderzd2_bglt)BgL_arg1613z00_1002)); } 
return 
BINT(BgL_tmpz00_1654);} } 

}



/* &musicdecoder-reset!-1135 */
obj_t BGl_z62musicdecoderzd2resetz12zd21135z70zz__flac_decoderz00(obj_t BgL_envz00_810, obj_t BgL_oz00_811)
{
{ /* Llib/flac_decoder.scm 101 */
{ 

{ /* Llib/flac_decoder.scm 103 */
obj_t BgL_arg1612z00_1006;
BgL_arg1612z00_1006 = 
(((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)BgL_oz00_811)))->BgL_z52flacz52); 
BGl_flaczd2decoderzd2resetz12z12zz__flac_flacz00(
((BgL_flaczd2decoderzd2_bglt)BgL_arg1612z00_1006)); } 
{ /* Llib/flac_decoder.scm 101 */
obj_t BgL_nextzd2method1134zd2_1005;
BgL_nextzd2method1134zd2_1005 = 
BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
((BgL_objectz00_bglt)
((BgL_flacmusicdecoderz00_bglt)BgL_oz00_811)), BGl_musicdecoderzd2resetz12zd2envz12zz__multimediazd2musicbufzd2, BGl_flacmusicdecoderz00zz__flac_decoderz00); 
return 
PROCEDURE_ENTRY(BgL_nextzd2method1134zd2_1005)(BgL_nextzd2method1134zd2_1005, 
((obj_t)
((BgL_flacmusicdecoderz00_bglt)BgL_oz00_811)), BEOA);} } } 

}



/* &flac-decoder-write-f1133 */
obj_t BGl_z62flaczd2decoderzd2writezd2f1133zb0zz__flac_decoderz00(obj_t BgL_envz00_812, obj_t BgL_oz00_813, obj_t BgL_siza7eza7_814, obj_t BgL_ratez00_815, obj_t BgL_channelsz00_816, obj_t BgL_bpsz00_817)
{
{ /* Llib/flac_decoder.scm 92 */
if(
(
(long)CINT(BgL_siza7eza7_814)>((long)0)))
{ /* Llib/flac_decoder.scm 94 */
{ /* Llib/flac_decoder.scm 95 */
obj_t BgL_arg1608z00_1008;obj_t BgL_arg1609z00_1009;
BgL_arg1608z00_1008 = 
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_813)))->BgL_z52musicz52); 
BgL_arg1609z00_1009 = 
(((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacdecz00_bglt)BgL_oz00_813))))->BgL_outbufz00); 
BGl_musicbufzd2writezd2zz__multimediazd2musicbufzd2(
((BgL_musicbufz00_bglt)BgL_arg1608z00_1008), BgL_arg1609z00_1009, 
(long)CINT(BgL_siza7eza7_814)); } 
return BTRUE;}  else 
{ /* Llib/flac_decoder.scm 94 */
return BFALSE;} } 

}



/* &flac-decoder-reset!-1131 */
obj_t BGl_z62flaczd2decoderzd2resetz12zd21131za2zz__flac_decoderz00(obj_t BgL_envz00_818, obj_t BgL_oz00_819)
{
{ /* Llib/flac_decoder.scm 81 */
{ 

((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_819)))->BgL_z52ratez52)=((int)
(int)(((long)80))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_819)))->BgL_z52lastzd2percentagez80)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacdecz00_bglt)BgL_oz00_819))))->BgL_z52bchecksumz52)=((int)
(int)(((long)128))),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacdecz00_bglt)BgL_oz00_819))))->BgL_z52rchecksumz52)=((int)
(int)(((long)128))),BUNSPEC); 
{ /* Llib/flac_decoder.scm 81 */
obj_t BgL_nextzd2method1130zd2_1012;
BgL_nextzd2method1130zd2_1012 = 
BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
((BgL_objectz00_bglt)
((BgL_flacdecz00_bglt)BgL_oz00_819)), BGl_flaczd2decoderzd2resetz12zd2envzc0zz__flac_flacz00, BGl_flacdecz00zz__flac_decoderz00); 
return 
PROCEDURE_ENTRY(BgL_nextzd2method1130zd2_1012)(BgL_nextzd2method1130zd2_1012, 
((obj_t)
((BgL_flacdecz00_bglt)BgL_oz00_819)), BEOA);} } } 

}



/* &musicdecoder-init-fl1129 */
obj_t BGl_z62musicdecoderzd2initzd2fl1129z62zz__flac_decoderz00(obj_t BgL_envz00_820, obj_t BgL_decz00_821)
{
{ /* Llib/flac_decoder.scm 73 */
if(
NULLP(
(((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flacmusicdecoderz00_bglt)BgL_decz00_821))))->BgL_mimetypesz00)))
{ /* Llib/flac_decoder.scm 75 */
return 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flacmusicdecoderz00_bglt)BgL_decz00_821))))->BgL_mimetypesz00)=((obj_t)
CNST_TABLE_REF(((long)17))),BUNSPEC);}  else 
{ /* Llib/flac_decoder.scm 75 */
return BFALSE;} } 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__flac_decoderz00()
{
{ /* Llib/flac_decoder.scm 15 */
return 
BGl_modulezd2initializa7ationz75zz__flac_flacz00(((long)107017853), 
BSTRING_TO_STRING(BGl_string1945z00zz__flac_decoderz00));} 

}

#ifdef __cplusplus
}
#endif
