/*===========================================================================*/
/*   (Llib/_scheduler.scm)                                                   */
/*   Bigloo (4.3g)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu 27 Feb 2020 07:59:49 AM CET     */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo4.3g/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo4.3g/lib/bigloo/4.3g -lib-dir /builddir/build/BUILD/bigloo4.3g/lib/bigloo/4.3g -I Llib -lib-dir /builddir/build/BUILD/bigloo4.3g/lib/bigloo/4.3g -unsafe -safee -copt -fPIC -copt -IPosix Llib/_scheduler.scm -o objs/_scheduler.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_threadz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
} *BgL_threadz00_bglt;

typedef struct BgL_fthreadz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_schedulerz00;
   obj_t BgL_z52builtinz52;
   int BgL_z52timeoutz52;
   obj_t BgL_z52statez52;
   bool_t BgL_z52iszd2suspendz80;
   obj_t BgL_z52terminatez52;
   obj_t BgL_z52resultz52;
   obj_t BgL_z52exczd2resultz80;
   bool_t BgL_z52exczd2raisedz80;
   int BgL_z52identz52;
   obj_t BgL_z52signalsz52;
   obj_t BgL_z52awakezd2signalz80;
   obj_t BgL_z52awakezd2valuez80;
   obj_t BgL_z52cleanupz52;
   obj_t BgL_z52specificz52;
   obj_t BgL_bodyz00;
} *BgL_fthreadz00_bglt;

typedef struct BgL_schedulerz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_schedulerz00;
   obj_t BgL_z52builtinz52;
   int BgL_z52timeoutz52;
   obj_t BgL_z52statez52;
   bool_t BgL_z52iszd2suspendz80;
   obj_t BgL_z52terminatez52;
   obj_t BgL_z52resultz52;
   obj_t BgL_z52exczd2resultz80;
   bool_t BgL_z52exczd2raisedz80;
   int BgL_z52identz52;
   obj_t BgL_z52signalsz52;
   obj_t BgL_z52awakezd2signalz80;
   obj_t BgL_z52awakezd2valuez80;
   obj_t BgL_z52cleanupz52;
   obj_t BgL_z52specificz52;
   obj_t BgL_bodyz00;
   obj_t BgL_envzb2zb2;
   obj_t BgL_strictzd2orderzf3z21;
} *BgL_schedulerz00_bglt;

typedef struct BgL_ftenvz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_instantz00;
} *BgL_ftenvz00_bglt;

typedef struct BgL_z52schedulerz52_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_schedulerz00;
   obj_t BgL_z52builtinz52;
   int BgL_z52timeoutz52;
   obj_t BgL_z52statez52;
   bool_t BgL_z52iszd2suspendz80;
   obj_t BgL_z52terminatez52;
   obj_t BgL_z52resultz52;
   obj_t BgL_z52exczd2resultz80;
   bool_t BgL_z52exczd2raisedz80;
   int BgL_z52identz52;
   obj_t BgL_z52signalsz52;
   obj_t BgL_z52awakezd2signalz80;
   obj_t BgL_z52awakezd2valuez80;
   obj_t BgL_z52cleanupz52;
   obj_t BgL_z52specificz52;
   obj_t BgL_bodyz00;
   obj_t BgL_envzb2zb2;
   obj_t BgL_strictzd2orderzf3z21;
   obj_t BgL_nextzd2instantzd2;
   obj_t BgL_currentzd2threadzd2;
   int BgL_z52livezd2threadzd2numberz52;
   bool_t BgL_z52threadszd2readyz80;
   obj_t BgL_threadszd2runnablezd2;
   obj_t BgL_threadszd2runnablezd2lastzd2pairzd2;
   obj_t BgL_asynczd2runnablezd2;
   obj_t BgL_threadszd2timeoutzd2;
   obj_t BgL_threadszd2yieldzd2;
   obj_t BgL_tostartz00;
   obj_t BgL_toterminatez00;
   obj_t BgL_tosuspendzf2resumezf2;
   obj_t BgL_tobroadcastz00;
   obj_t BgL_tospawnz00;
   obj_t BgL_currentzd2tokenzd2;
} *BgL_z52schedulerz52_bglt;

typedef struct BgL_z52sigasyncz52_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_spawnedz00;
   obj_t BgL_idz00;
   obj_t BgL_thunkz00;
} *BgL_z52sigasyncz52_bglt;

typedef struct BgL_z52pthreadz52_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_bodyz00;
   bool_t BgL_detachedpz00;
   obj_t BgL_endzd2resultzd2;
   obj_t BgL_endzd2exceptionzd2;
   void * BgL_z42builtinz42;
   obj_t BgL_fthreadz00;
   obj_t BgL_mutexz00;
   obj_t BgL_condvarz00;
   obj_t BgL_idz00;
   obj_t BgL_parentz00;
} *BgL_z52pthreadz52_bglt;


static obj_t BGl_z52schedulerzd2getzd2asynczd2runnablez80zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt, obj_t);
static obj_t BGl_z62z52schedulerzd2addzd2asynczd2runnablez12zf0zz__ft_z52schedulerz52(obj_t, obj_t, obj_t);
extern bool_t BGl_z52threadzd2iszd2deadz52zz__ft_z52threadz52(BgL_fthreadz00_bglt, obj_t);
extern obj_t BGl_z52asynczd2synchroniza7ez27zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt);
BGL_EXPORTED_DECL obj_t BGl_z52schedulerzd2switchzd2tozd2nextzd2threadz52zz__ft_z52schedulerz52(BgL_fthreadz00_bglt, BgL_schedulerz00_bglt);
static obj_t BGl_objectzd2initzd2zz__ft_z52schedulerz52();
extern obj_t BGl_z52asynczd2spawnz80zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt, obj_t, obj_t);
static obj_t BGl_z62z52broadcastz12z22zz__ft_z52schedulerz52(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_z52schedulerz52zz__ft_z52typesz52;
BGL_EXPORTED_DECL obj_t BGl_z52schedulerzd2addzd2asynczd2runnablez12z92zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt, BgL_fthreadz00_bglt);
BGL_EXPORTED_DECL obj_t BGl_z52schedulerzd2addzd2broadcastz12z40zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt, obj_t, obj_t);
BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
static obj_t BGl_z52startzd2newzd2threadsz52zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt);
static obj_t BGl_z62zc3z04anonymousza31218ze3ze5zz__ft_z52schedulerz52(obj_t, obj_t, obj_t);
static obj_t BGl_appendzd221010zd2zz__ft_z52schedulerz52(obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zz__ft_z52schedulerz52();
BGL_EXPORTED_DECL obj_t BGl_z52schedulerzd2waitingzd2threadsz52zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt);
static obj_t BGl_z62z52schedulerzd2switchzd2tozd2nextzd2threadz30zz__ft_z52schedulerz52(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31504ze3ze5zz__ft_z52schedulerz52(obj_t, obj_t);
static obj_t BGl_z52suspendzf2resumezd2threadsz72zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt);
extern bool_t BGl_z52threadzd2iszd2terminatedz52zz__ft_z52threadz52(BgL_fthreadz00_bglt, obj_t);
BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31522ze3ze5zz__ft_z52schedulerz52(obj_t, obj_t);
static obj_t BGl_z52schedulerzd2broadcastza2z12z30zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt);
extern bool_t BGl_z52threadzd2iszd2toterminatez52zz__ft_z52threadz52(BgL_fthreadz00_bglt, obj_t);
BGL_EXPORTED_DECL obj_t BGl_z52schedulerzd2spawnzd2asyncz52zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt, BgL_z52sigasyncz52_bglt);
extern BgL_schedulerz00_bglt BGl_makezd2schedulerzd2zz__ft_schedulerz00(obj_t);
extern obj_t BGl_signalzd2emitzd2zz__ft_signalz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62z52schedulerzd2timeze2zz__ft_z52schedulerz52(obj_t, obj_t);
extern obj_t BGl_schedulerz00zz__ft_typesz00;
static obj_t BGl_gczd2rootszd2initz00zz__ft_z52schedulerz52();
extern obj_t BGl_instantzd2envz12zc0zz__ft_envz00(BgL_ftenvz00_bglt);
BGL_IMPORT obj_t BGl_filterz12z12zz__r4_control_features_6_9z00(obj_t, obj_t);
static obj_t BGl_z62ntz62zz__ft_z52schedulerz52(obj_t);
static obj_t BGl_z62z52schedulezd2instantze2zz__ft_z52schedulerz52(obj_t, obj_t);
BGL_EXPORTED_DECL BgL_schedulerz00_bglt BGl_z52getzd2optionalzd2schedulerz52zz__ft_z52schedulerz52(obj_t, obj_t);
static obj_t BGl_z62z52schedulerzd2spawnzd2asyncz30zz__ft_z52schedulerz52(obj_t, obj_t, obj_t);
extern obj_t BGl_signalzd2unbindzd2threadz12z12zz__ft_signalz00(obj_t, BgL_threadz00_bglt);
extern obj_t BGl_z52pthreadzd2waitz80zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt);
extern obj_t BGl_defaultzd2schedulerzd2zz__ft_schedulerz00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_z52schedulerzd2nextzd2threadz52zz__ft_z52schedulerz52(BgL_fthreadz00_bglt, BgL_schedulerz00_bglt);
static obj_t BGl_z62zc3z04anonymousza31497ze3ze5zz__ft_z52schedulerz52(obj_t, obj_t);
static obj_t BGl_requirezd2initializa7ationz75zz__ft_z52schedulerz52 = BUNSPEC;
BGL_IMPORT obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z52terminatezd2threadsz80zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt);
static obj_t BGl_toplevelzd2initzd2zz__ft_z52schedulerz52();
static obj_t BGl_z62z52schedulerzd2addzd2broadcastz12z22zz__ft_z52schedulerz52(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z52selectzd2threadsz12z92zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt);
static obj_t BGl_genericzd2initzd2zz__ft_z52schedulerz52();
extern obj_t BGl_z52asynczd2asynchroniza7ez27zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt);
BGL_IMPORT obj_t bgl_reverse_bang(obj_t);
static obj_t BGl_z52spawnzd2asyncz80zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt);
static obj_t BGl_z62z52schedulerzd2nextzd2threadz30zz__ft_z52schedulerz52(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
extern obj_t BGl_fthreadz00zz__ft_typesz00;
static BgL_schedulerz00_bglt BGl_z62z52getzd2optionalzd2schedulerz30zz__ft_z52schedulerz52(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31244ze3ze5zz__ft_z52schedulerz52(obj_t, obj_t);
BGL_IMPORT obj_t BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_z52schedulezd2instantz80zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt);
static obj_t BGl_z62z52schedulerzd2waitingzd2threadsz30zz__ft_z52schedulerz52(obj_t, obj_t);
static obj_t BGl_z52sortzd2threadsz80zz__ft_z52schedulerz52(obj_t);
extern obj_t BGl_ftenvzd2threadszd2zz__ft_envz00(BgL_ftenvz00_bglt);
BGL_IMPORT bool_t BGl_pairzd2orzd2nullzf3zf3zz__r4_pairs_and_lists_6_3z00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31192ze3ze5zz__ft_z52schedulerz52(obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__ft_z52schedulerz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52pthreadz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_signalz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52envz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_envz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52threadz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_schedulerz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52typesz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_typesz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__pth_threadz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
BGL_IMPORT obj_t BGl_withzd2outputzd2tozd2portzd2zz__r4_ports_6_10_1z00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_z52schedulerzd2timez80zz__ft_z52schedulerz52(BgL_schedulerz00_bglt);
BGL_IMPORT obj_t BGl_sortz00zz__r4_vectors_6_8z00(obj_t, obj_t);
extern obj_t BGl_z52pthreadzd2switchz80zz__ft_z52pthreadz52(obj_t, BgL_z52pthreadz52_bglt);
extern obj_t BGl_z52sigasyncz52zz__ft_z52typesz52;
static obj_t BGl_cnstzd2initzd2zz__ft_z52schedulerz52();
static obj_t BGl_libraryzd2moduleszd2initz00zz__ft_z52schedulerz52();
static obj_t BGl_importedzd2moduleszd2initz00zz__ft_z52schedulerz52();
static obj_t BGl_z62zc3z04anonymousza31482ze3ze5zz__ft_z52schedulerz52(obj_t, obj_t);
static bool_t BGl_z52envzd2initzd2instantz52zz__ft_z52schedulerz52(BgL_schedulerz00_bglt);
BGL_EXPORTED_DECL obj_t BGl_z52schedulerzd2addzd2asyncz12z40zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt, BgL_z52sigasyncz52_bglt);
extern obj_t BGl_z52asynczd2schedulerzd2notifyz52zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt);
static obj_t BGl_z62z52schedulerzd2addzd2asyncz12z22zz__ft_z52schedulerz52(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_z52broadcastz12z40zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt, obj_t, obj_t);
static obj_t __cnst[ 1 ] ;


DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52broadcastz12zd2envz92zz__ft_z52schedulerz52, BgL_bgl_za762za752broadcastza71760za7, BGl_z62z52broadcastz12z22zz__ft_z52schedulerz52, 0L, BUNSPEC, 3 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52schedulerzd2spawnzd2asynczd2envz80zz__ft_z52schedulerz52, BgL_bgl_za762za752schedulerza71761za7, BGl_z62z52schedulerzd2spawnzd2asyncz30zz__ft_z52schedulerz52, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52getzd2optionalzd2schedulerzd2envz80zz__ft_z52schedulerz52, BgL_bgl_za762za752getza7d2opti1762za7, BGl_z62z52getzd2optionalzd2schedulerz30zz__ft_z52schedulerz52, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1740z00zz__ft_z52schedulerz52, BgL_bgl_za762za7c3za704anonymo1763za7, BGl_z62zc3z04anonymousza31192ze3ze5zz__ft_z52schedulerz52, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1745z00zz__ft_z52schedulerz52, BgL_bgl_za762za7c3za704anonymo1764za7, BGl_z62zc3z04anonymousza31218ze3ze5zz__ft_z52schedulerz52, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1746z00zz__ft_z52schedulerz52, BgL_bgl_za762za7c3za704anonymo1765za7, BGl_z62zc3z04anonymousza31522ze3ze5zz__ft_z52schedulerz52, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1747z00zz__ft_z52schedulerz52, BgL_bgl_za762za7c3za704anonymo1766za7, BGl_z62zc3z04anonymousza31482ze3ze5zz__ft_z52schedulerz52, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1748z00zz__ft_z52schedulerz52, BgL_bgl_za762za7c3za704anonymo1767za7, BGl_z62zc3z04anonymousza31497ze3ze5zz__ft_z52schedulerz52, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1749z00zz__ft_z52schedulerz52, BgL_bgl_za762za7c3za704anonymo1768za7, BGl_z62zc3z04anonymousza31504ze3ze5zz__ft_z52schedulerz52, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52schedulezd2instantzd2envz52zz__ft_z52schedulerz52, BgL_bgl_za762za752scheduleza7d1769za7, BGl_z62z52schedulezd2instantze2zz__ft_z52schedulerz52, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52schedulerzd2addzd2asynczd2runnablez12zd2envz40zz__ft_z52schedulerz52, BgL_bgl_za762za752schedulerza71770za7, BGl_z62z52schedulerzd2addzd2asynczd2runnablez12zf0zz__ft_z52schedulerz52, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52schedulerzd2timezd2envz52zz__ft_z52schedulerz52, BgL_bgl_za762za752schedulerza71771za7, BGl_z62z52schedulerzd2timeze2zz__ft_z52schedulerz52, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52schedulerzd2nextzd2threadzd2envz80zz__ft_z52schedulerz52, BgL_bgl_za762za752schedulerza71772za7, BGl_z62z52schedulerzd2nextzd2threadz30zz__ft_z52schedulerz52, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52schedulerzd2addzd2broadcastz12zd2envz92zz__ft_z52schedulerz52, BgL_bgl_za762za752schedulerza71773za7, BGl_z62z52schedulerzd2addzd2broadcastz12z22zz__ft_z52schedulerz52, 0L, BUNSPEC, 3 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52schedulerzd2waitingzd2threadszd2envz80zz__ft_z52schedulerz52, BgL_bgl_za762za752schedulerza71774za7, BGl_z62z52schedulerzd2waitingzd2threadsz30zz__ft_z52schedulerz52, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1729z00zz__ft_z52schedulerz52, BgL_bgl_string1729za700za7za7_1775za7, "Llib/_scheduler.scm", 19 );
DEFINE_STRING( BGl_string1730z00zz__ft_z52schedulerz52, BgL_bgl_string1730za700za7za7_1776za7, "Illegal scheduler", 17 );
DEFINE_STRING( BGl_string1731z00zz__ft_z52schedulerz52, BgL_bgl_string1731za700za7za7_1777za7, "/builddir/build/BUILD/bigloo4.3g/api/fthread/src/Llib/_scheduler.scm", 68 );
DEFINE_STRING( BGl_string1732z00zz__ft_z52schedulerz52, BgL_bgl_string1732za700za7za7_1778za7, "&%get-optional-scheduler", 24 );
DEFINE_STRING( BGl_string1733z00zz__ft_z52schedulerz52, BgL_bgl_string1733za700za7za7_1779za7, "symbol", 6 );
DEFINE_STRING( BGl_string1734z00zz__ft_z52schedulerz52, BgL_bgl_string1734za700za7za7_1780za7, "pair-nil", 8 );
DEFINE_STRING( BGl_string1735z00zz__ft_z52schedulerz52, BgL_bgl_string1735za700za7za7_1781za7, "&%scheduler-add-async-runnable!", 31 );
DEFINE_STRING( BGl_string1736z00zz__ft_z52schedulerz52, BgL_bgl_string1736za700za7za7_1782za7, "%scheduler", 10 );
DEFINE_STRING( BGl_string1737z00zz__ft_z52schedulerz52, BgL_bgl_string1737za700za7za7_1783za7, "fthread", 7 );
DEFINE_STRING( BGl_string1738z00zz__ft_z52schedulerz52, BgL_bgl_string1738za700za7za7_1784za7, "&%scheduler-add-async!", 22 );
DEFINE_STRING( BGl_string1739z00zz__ft_z52schedulerz52, BgL_bgl_string1739za700za7za7_1785za7, "%sigasync", 9 );
DEFINE_STRING( BGl_string1741z00zz__ft_z52schedulerz52, BgL_bgl_string1741za700za7za7_1786za7, "&%scheduler-next-thread", 23 );
DEFINE_STRING( BGl_string1742z00zz__ft_z52schedulerz52, BgL_bgl_string1742za700za7za7_1787za7, "scheduler", 9 );
DEFINE_STRING( BGl_string1743z00zz__ft_z52schedulerz52, BgL_bgl_string1743za700za7za7_1788za7, "&%scheduler-switch-to-next-thread", 33 );
DEFINE_STRING( BGl_string1744z00zz__ft_z52schedulerz52, BgL_bgl_string1744za700za7za7_1789za7, "&%schedule-instant", 18 );
DEFINE_STRING( BGl_string1750z00zz__ft_z52schedulerz52, BgL_bgl_string1750za700za7za7_1790za7, "&%scheduler-spawn-async", 23 );
DEFINE_STRING( BGl_string1751z00zz__ft_z52schedulerz52, BgL_bgl_string1751za700za7za7_1791za7, "&%broadcast!", 12 );
DEFINE_STRING( BGl_string1752z00zz__ft_z52schedulerz52, BgL_bgl_string1752za700za7za7_1792za7, "&%scheduler-add-broadcast!", 26 );
DEFINE_STRING( BGl_string1753z00zz__ft_z52schedulerz52, BgL_bgl_string1753za700za7za7_1793za7, "&%scheduler-time", 16 );
DEFINE_STRING( BGl_string1754z00zz__ft_z52schedulerz52, BgL_bgl_string1754za700za7za7_1794za7, "&%scheduler-waiting-threads", 27 );
DEFINE_STRING( BGl_string1755z00zz__ft_z52schedulerz52, BgL_bgl_string1755za700za7za7_1795za7, "__ft_%scheduler", 15 );
DEFINE_STRING( BGl_string1756z00zz__ft_z52schedulerz52, BgL_bgl_string1756za700za7za7_1796za7, "dead ", 5 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52schedulerzd2addzd2asyncz12zd2envz92zz__ft_z52schedulerz52, BgL_bgl_za762za752schedulerza71797za7, BGl_z62z52schedulerzd2addzd2asyncz12z22zz__ft_z52schedulerz52, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52schedulerzd2switchzd2tozd2nextzd2threadzd2envz80zz__ft_z52schedulerz52, BgL_bgl_za762za752schedulerza71798za7, BGl_z62z52schedulerzd2switchzd2tozd2nextzd2threadz30zz__ft_z52schedulerz52, 0L, BUNSPEC, 2 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__ft_z52schedulerz52) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__ft_z52schedulerz52(long BgL_checksumz00_575, char * BgL_fromz00_576)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__ft_z52schedulerz52))
{ 
BGl_requirezd2initializa7ationz75zz__ft_z52schedulerz52 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__ft_z52schedulerz52(); 
BGl_libraryzd2moduleszd2initz00zz__ft_z52schedulerz52(); 
BGl_cnstzd2initzd2zz__ft_z52schedulerz52(); 
BGl_importedzd2moduleszd2initz00zz__ft_z52schedulerz52(); 
return 
BGl_toplevelzd2initzd2zz__ft_z52schedulerz52();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__ft_z52schedulerz52()
{
{ /* Llib/_scheduler.scm 15 */
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__ft_%scheduler"); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "__ft_%scheduler"); 
BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long)0), "__ft_%scheduler"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "__ft_%scheduler"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__ft_%scheduler"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__ft_%scheduler"); 
BGl_modulezd2initializa7ationz75zz__pth_threadz00(((long)0), "__ft_%scheduler"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__ft_%scheduler"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__ft_%scheduler"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__ft_%scheduler"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__ft_z52schedulerz52()
{
{ /* Llib/_scheduler.scm 15 */
{ /* Llib/_scheduler.scm 15 */
obj_t BgL_cportz00_551;
{ /* Llib/_scheduler.scm 15 */
obj_t BgL_stringz00_559;
BgL_stringz00_559 = BGl_string1756z00zz__ft_z52schedulerz52; 
{ /* Llib/_scheduler.scm 15 */
obj_t BgL_startz00_560;
BgL_startz00_560 = 
BINT(((long)0)); 
{ /* Llib/_scheduler.scm 15 */
obj_t BgL_endz00_561;
BgL_endz00_561 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_559))); 
{ /* Llib/_scheduler.scm 15 */

BgL_cportz00_551 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_559, BgL_startz00_560, BgL_endz00_561); } } } } 
{ 
long BgL_iz00_552;
BgL_iz00_552 = ((long)0); 
BgL_loopz00_553:
if(
(BgL_iz00_552==((long)-1)))
{ /* Llib/_scheduler.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/_scheduler.scm 15 */
{ /* Llib/_scheduler.scm 15 */
obj_t BgL_arg1758z00_555;
{ /* Llib/_scheduler.scm 15 */

{ /* Llib/_scheduler.scm 15 */
obj_t BgL_locationz00_557;
BgL_locationz00_557 = 
BBOOL(((bool_t)0)); 
{ /* Llib/_scheduler.scm 15 */

BgL_arg1758z00_555 = 
BGl_readz00zz__readerz00(BgL_cportz00_551, BgL_locationz00_557); } } } 
{ /* Llib/_scheduler.scm 15 */
int BgL_tmpz00_604;
BgL_tmpz00_604 = 
(int)(BgL_iz00_552); 
CNST_TABLE_SET(BgL_tmpz00_604, BgL_arg1758z00_555); } } 
{ /* Llib/_scheduler.scm 15 */
int BgL_auxz00_558;
BgL_auxz00_558 = 
(int)(
(BgL_iz00_552-((long)1))); 
{ 
long BgL_iz00_609;
BgL_iz00_609 = 
(long)(BgL_auxz00_558); 
BgL_iz00_552 = BgL_iz00_609; 
goto BgL_loopz00_553;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__ft_z52schedulerz52()
{
{ /* Llib/_scheduler.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__ft_z52schedulerz52()
{
{ /* Llib/_scheduler.scm 15 */
BGl_modulezd2initializa7ationz75zz__pth_threadz00(((long)0), 
BSTRING_TO_STRING(BGl_string1729z00zz__ft_z52schedulerz52)); 
return BFALSE;} 

}



/* append-21010 */
obj_t BGl_appendzd221010zd2zz__ft_z52schedulerz52(obj_t BgL_l1z00_1, obj_t BgL_l2z00_2)
{
{ 
{ 
obj_t BgL_headz00_40;
BgL_headz00_40 = 
MAKE_YOUNG_PAIR(BNIL, BgL_l2z00_2); 
{ 
obj_t BgL_prevz00_41;obj_t BgL_tailz00_42;
BgL_prevz00_41 = BgL_headz00_40; 
BgL_tailz00_42 = BgL_l1z00_1; 
BgL_loopz00_43:
if(
PAIRP(BgL_tailz00_42))
{ 
obj_t BgL_newzd2prevzd2_45;
BgL_newzd2prevzd2_45 = 
MAKE_YOUNG_PAIR(
CAR(BgL_tailz00_42), BgL_l2z00_2); 
SET_CDR(BgL_prevz00_41, BgL_newzd2prevzd2_45); 
{ 
obj_t BgL_tailz00_621;obj_t BgL_prevz00_620;
BgL_prevz00_620 = BgL_newzd2prevzd2_45; 
BgL_tailz00_621 = 
CDR(BgL_tailz00_42); 
BgL_tailz00_42 = BgL_tailz00_621; 
BgL_prevz00_41 = BgL_prevz00_620; 
goto BgL_loopz00_43;} }  else 
{ BNIL; } 
return 
CDR(BgL_headz00_40);} } } 

}



/* %get-optional-scheduler */
BGL_EXPORTED_DEF BgL_schedulerz00_bglt BGl_z52getzd2optionalzd2schedulerz52zz__ft_z52schedulerz52(obj_t BgL_whoz00_3, obj_t BgL_oz00_4)
{
{ /* Llib/_scheduler.scm 54 */
if(
NULLP(BgL_oz00_4))
{ /* Llib/_scheduler.scm 57 */
obj_t BgL_sz00_49;
BgL_sz00_49 = 
BGl_defaultzd2schedulerzd2zz__ft_schedulerz00(BNIL); 
if(
BGl_isazf3zf3zz__objectz00(BgL_sz00_49, BGl_schedulerz00zz__ft_typesz00))
{ /* Llib/_scheduler.scm 58 */
return 
((BgL_schedulerz00_bglt)BgL_sz00_49);}  else 
{ /* Llib/_scheduler.scm 60 */
BgL_schedulerz00_bglt BgL_arg1132z00_51;
BgL_arg1132z00_51 = 
BGl_makezd2schedulerzd2zz__ft_schedulerz00(BNIL); 
{ /* Llib/_scheduler.scm 60 */
obj_t BgL_list1133z00_52;
BgL_list1133z00_52 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1132z00_51), BNIL); 
return 
((BgL_schedulerz00_bglt)
BGl_defaultzd2schedulerzd2zz__ft_schedulerz00(BgL_list1133z00_52));} } }  else 
{ /* Llib/_scheduler.scm 61 */
bool_t BgL_test1804z00_635;
{ /* Llib/_scheduler.scm 61 */
obj_t BgL_arg1140z00_58;
BgL_arg1140z00_58 = 
CAR(BgL_oz00_4); 
BgL_test1804z00_635 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1140z00_58, BGl_schedulerz00zz__ft_typesz00); } 
if(BgL_test1804z00_635)
{ /* Llib/_scheduler.scm 61 */
return 
((BgL_schedulerz00_bglt)
CAR(BgL_oz00_4));}  else 
{ /* Llib/_scheduler.scm 64 */
obj_t BgL_arg1138z00_57;
BgL_arg1138z00_57 = 
CAR(BgL_oz00_4); 
return 
((BgL_schedulerz00_bglt)
BGl_errorz00zz__errorz00(BgL_whoz00_3, BGl_string1730z00zz__ft_z52schedulerz52, BgL_arg1138z00_57));} } } 

}



/* &%get-optional-scheduler */
BgL_schedulerz00_bglt BGl_z62z52getzd2optionalzd2schedulerz30zz__ft_z52schedulerz52(obj_t BgL_envz00_424, obj_t BgL_whoz00_425, obj_t BgL_oz00_426)
{
{ /* Llib/_scheduler.scm 54 */
{ /* Llib/_scheduler.scm 56 */
obj_t BgL_auxz00_650;obj_t BgL_auxz00_643;
if(
BGl_pairzd2orzd2nullzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_oz00_426))
{ /* Llib/_scheduler.scm 56 */
BgL_auxz00_650 = BgL_oz00_426
; }  else 
{ 
obj_t BgL_auxz00_653;
BgL_auxz00_653 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1731z00zz__ft_z52schedulerz52, 
BINT(((long)2487)), BGl_string1732z00zz__ft_z52schedulerz52, BGl_string1734z00zz__ft_z52schedulerz52, BgL_oz00_426); 
FAILURE(BgL_auxz00_653,BFALSE,BFALSE);} 
if(
SYMBOLP(BgL_whoz00_425))
{ /* Llib/_scheduler.scm 56 */
BgL_auxz00_643 = BgL_whoz00_425
; }  else 
{ 
obj_t BgL_auxz00_646;
BgL_auxz00_646 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1731z00zz__ft_z52schedulerz52, 
BINT(((long)2487)), BGl_string1732z00zz__ft_z52schedulerz52, BGl_string1733z00zz__ft_z52schedulerz52, BgL_whoz00_425); 
FAILURE(BgL_auxz00_646,BFALSE,BFALSE);} 
return 
BGl_z52getzd2optionalzd2schedulerz52zz__ft_z52schedulerz52(BgL_auxz00_643, BgL_auxz00_650);} } 

}



/* %scheduler-get-async-runnable */
obj_t BGl_z52schedulerzd2getzd2asynczd2runnablez80zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt BgL_scdlz00_5, obj_t BgL_nvz00_6)
{
{ /* Llib/_scheduler.scm 73 */
{ /* Llib/_scheduler.scm 74 */
obj_t BgL_arg1143z00_60;
BgL_arg1143z00_60 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_scdlz00_5)))->BgL_z52builtinz52); 
BGl_z52asynczd2synchroniza7ez27zz__ft_z52pthreadz52(
((BgL_z52pthreadz52_bglt)BgL_arg1143z00_60)); } 
{ /* Llib/_scheduler.scm 74 */
obj_t BgL_g1066z00_61;
{ /* Llib/_scheduler.scm 76 */
obj_t BgL_vz00_63;
BgL_vz00_63 = 
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_5))->BgL_asynczd2runnablezd2); 
if(
PAIRP(BgL_nvz00_6))
{ /* Llib/_scheduler.scm 77 */
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_5))->BgL_asynczd2runnablezd2)=((obj_t)
CAR(BgL_nvz00_6)),BUNSPEC); }  else 
{ /* Llib/_scheduler.scm 77 */BFALSE; } 
BgL_g1066z00_61 = BgL_vz00_63; } 
{ /* Llib/_scheduler.scm 74 */
obj_t BgL_arg1146z00_62;
BgL_arg1146z00_62 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_scdlz00_5)))->BgL_z52builtinz52); 
BGl_z52asynczd2asynchroniza7ez27zz__ft_z52pthreadz52(
((BgL_z52pthreadz52_bglt)BgL_arg1146z00_62)); } 
return BgL_g1066z00_61;} } 

}



/* %scheduler-add-async-runnable! */
BGL_EXPORTED_DEF obj_t BGl_z52schedulerzd2addzd2asynczd2runnablez12z92zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt BgL_scdlz00_7, BgL_fthreadz00_bglt BgL_tz00_8)
{
{ /* Llib/_scheduler.scm 88 */
{ /* Llib/_scheduler.scm 91 */
obj_t BgL_arg1148z00_68;
BgL_arg1148z00_68 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_scdlz00_7)))->BgL_z52builtinz52); 
BGl_z52asynczd2synchroniza7ez27zz__ft_z52pthreadz52(
((BgL_z52pthreadz52_bglt)BgL_arg1148z00_68)); } 
{ /* Llib/_scheduler.scm 91 */
obj_t BgL_g1069z00_69;
{ 
obj_t BgL_auxz00_675;
{ /* Llib/_scheduler.scm 94 */
obj_t BgL_arg1154z00_72;
BgL_arg1154z00_72 = 
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_7))->BgL_asynczd2runnablezd2); 
BgL_auxz00_675 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_tz00_8), BgL_arg1154z00_72); } 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_7))->BgL_asynczd2runnablezd2)=((obj_t)BgL_auxz00_675),BUNSPEC); } 
{ /* Llib/_scheduler.scm 95 */
obj_t BgL_arg1156z00_73;
BgL_arg1156z00_73 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_scdlz00_7)))->BgL_z52builtinz52); 
BGl_z52asynczd2schedulerzd2notifyz52zz__ft_z52pthreadz52(
((BgL_z52pthreadz52_bglt)BgL_arg1156z00_73)); } 
BgL_g1069z00_69 = BUNSPEC; 
{ /* Llib/_scheduler.scm 91 */
obj_t BgL_arg1152z00_70;
BgL_arg1152z00_70 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_scdlz00_7)))->BgL_z52builtinz52); 
BGl_z52asynczd2asynchroniza7ez27zz__ft_z52pthreadz52(
((BgL_z52pthreadz52_bglt)BgL_arg1152z00_70)); } 
return BgL_g1069z00_69;} } 

}



/* &%scheduler-add-async-runnable! */
obj_t BGl_z62z52schedulerzd2addzd2asynczd2runnablez12zf0zz__ft_z52schedulerz52(obj_t BgL_envz00_427, obj_t BgL_scdlz00_428, obj_t BgL_tz00_429)
{
{ /* Llib/_scheduler.scm 88 */
{ /* Llib/_scheduler.scm 91 */
BgL_fthreadz00_bglt BgL_auxz00_696;BgL_z52schedulerz52_bglt BgL_auxz00_688;
if(
BGl_isazf3zf3zz__objectz00(BgL_tz00_429, BGl_fthreadz00zz__ft_typesz00))
{ /* Llib/_scheduler.scm 91 */
BgL_auxz00_696 = 
((BgL_fthreadz00_bglt)BgL_tz00_429)
; }  else 
{ 
obj_t BgL_auxz00_700;
BgL_auxz00_700 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1731z00zz__ft_z52schedulerz52, 
BINT(((long)4155)), BGl_string1735z00zz__ft_z52schedulerz52, BGl_string1737z00zz__ft_z52schedulerz52, BgL_tz00_429); 
FAILURE(BgL_auxz00_700,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_scdlz00_428, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* Llib/_scheduler.scm 91 */
BgL_auxz00_688 = 
((BgL_z52schedulerz52_bglt)BgL_scdlz00_428)
; }  else 
{ 
obj_t BgL_auxz00_692;
BgL_auxz00_692 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1731z00zz__ft_z52schedulerz52, 
BINT(((long)4155)), BGl_string1735z00zz__ft_z52schedulerz52, BGl_string1736z00zz__ft_z52schedulerz52, BgL_scdlz00_428); 
FAILURE(BgL_auxz00_692,BFALSE,BFALSE);} 
return 
BGl_z52schedulerzd2addzd2asynczd2runnablez12z92zz__ft_z52schedulerz52(BgL_auxz00_688, BgL_auxz00_696);} } 

}



/* %scheduler-add-async! */
BGL_EXPORTED_DEF obj_t BGl_z52schedulerzd2addzd2asyncz12z40zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt BgL_scdlz00_9, BgL_z52sigasyncz52_bglt BgL_sigz00_10)
{
{ /* Llib/_scheduler.scm 101 */
{ 
obj_t BgL_auxz00_705;
{ /* Llib/_scheduler.scm 103 */
obj_t BgL_arg1157z00_325;
BgL_arg1157z00_325 = 
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_9))->BgL_tospawnz00); 
BgL_auxz00_705 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_sigz00_10), BgL_arg1157z00_325); } 
return 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_9))->BgL_tospawnz00)=((obj_t)BgL_auxz00_705),BUNSPEC);} } 

}



/* &%scheduler-add-async! */
obj_t BGl_z62z52schedulerzd2addzd2asyncz12z22zz__ft_z52schedulerz52(obj_t BgL_envz00_430, obj_t BgL_scdlz00_431, obj_t BgL_sigz00_432)
{
{ /* Llib/_scheduler.scm 101 */
{ /* Llib/_scheduler.scm 102 */
BgL_z52sigasyncz52_bglt BgL_auxz00_718;BgL_z52schedulerz52_bglt BgL_auxz00_710;
if(
BGl_isazf3zf3zz__objectz00(BgL_sigz00_432, BGl_z52sigasyncz52zz__ft_z52typesz52))
{ /* Llib/_scheduler.scm 102 */
BgL_auxz00_718 = 
((BgL_z52sigasyncz52_bglt)BgL_sigz00_432)
; }  else 
{ 
obj_t BgL_auxz00_722;
BgL_auxz00_722 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1731z00zz__ft_z52schedulerz52, 
BINT(((long)4674)), BGl_string1738z00zz__ft_z52schedulerz52, BGl_string1739z00zz__ft_z52schedulerz52, BgL_sigz00_432); 
FAILURE(BgL_auxz00_722,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_scdlz00_431, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* Llib/_scheduler.scm 102 */
BgL_auxz00_710 = 
((BgL_z52schedulerz52_bglt)BgL_scdlz00_431)
; }  else 
{ 
obj_t BgL_auxz00_714;
BgL_auxz00_714 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1731z00zz__ft_z52schedulerz52, 
BINT(((long)4674)), BGl_string1738z00zz__ft_z52schedulerz52, BGl_string1736z00zz__ft_z52schedulerz52, BgL_scdlz00_431); 
FAILURE(BgL_auxz00_714,BFALSE,BFALSE);} 
return 
BGl_z52schedulerzd2addzd2asyncz12z40zz__ft_z52schedulerz52(BgL_auxz00_710, BgL_auxz00_718);} } 

}



/* %scheduler-next-thread */
BGL_EXPORTED_DEF obj_t BGl_z52schedulerzd2nextzd2threadz52zz__ft_z52schedulerz52(BgL_fthreadz00_bglt BgL_tz00_11, BgL_schedulerz00_bglt BgL_scdlz00_12)
{
{ /* Llib/_scheduler.scm 108 */
{ /* Llib/_scheduler.scm 152 */
obj_t BgL_arg1189z00_326;
{ /* Llib/_scheduler.scm 152 */
obj_t BgL_res1665z00_329;
{ /* Llib/_scheduler.scm 152 */
obj_t BgL_tmpz00_727;
BgL_tmpz00_727 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_res1665z00_329 = 
BGL_ENV_CURRENT_ERROR_PORT(BgL_tmpz00_727); } 
BgL_arg1189z00_326 = BgL_res1665z00_329; } 
BGl_withzd2outputzd2tozd2portzd2zz__r4_ports_6_10_1z00(BgL_arg1189z00_326, BGl_proc1740z00zz__ft_z52schedulerz52); } 
{ 
obj_t BgL_runnablez00_79;
{ /* Llib/_scheduler.scm 115 */
obj_t BgL_arg1158z00_78;
BgL_arg1158z00_78 = 
(((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_12)))->BgL_threadszd2runnablezd2); 
BgL_runnablez00_79 = BgL_arg1158z00_78; 
BgL_zc3z04anonymousza31159ze3z87_80:
if(
PAIRP(BgL_runnablez00_79))
{ /* Llib/_scheduler.scm 118 */
obj_t BgL_ntz00_82;
BgL_ntz00_82 = 
CAR(BgL_runnablez00_79); 
if(
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_ntz00_82)))->BgL_z52iszd2suspendz80))
{ /* Llib/_scheduler.scm 120 */
{ 
obj_t BgL_auxz00_739;
{ /* Llib/_scheduler.scm 122 */
obj_t BgL_arg1167z00_85;
BgL_arg1167z00_85 = 
(((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_12)))->BgL_threadszd2yieldzd2); 
BgL_auxz00_739 = 
MAKE_YOUNG_PAIR(BgL_ntz00_82, BgL_arg1167z00_85); } 
((((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_12)))->BgL_threadszd2yieldzd2)=((obj_t)BgL_auxz00_739),BUNSPEC); } 
{ 
obj_t BgL_runnablez00_745;
BgL_runnablez00_745 = 
CDR(BgL_runnablez00_79); 
BgL_runnablez00_79 = BgL_runnablez00_745; 
goto BgL_zc3z04anonymousza31159ze3z87_80;} }  else 
{ /* Llib/_scheduler.scm 120 */
if(
BGl_z52threadzd2iszd2deadz52zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_ntz00_82), BNIL))
{ 
obj_t BgL_runnablez00_750;
BgL_runnablez00_750 = 
CDR(BgL_runnablez00_79); 
BgL_runnablez00_79 = BgL_runnablez00_750; 
goto BgL_zc3z04anonymousza31159ze3z87_80;}  else 
{ /* Llib/_scheduler.scm 124 */
((((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_12)))->BgL_threadszd2runnablezd2)=((obj_t)
CDR(BgL_runnablez00_79)),BUNSPEC); 
if(
NULLP(
(((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_12)))->BgL_threadszd2runnablezd2)))
{ /* Llib/_scheduler.scm 128 */
((((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_12)))->BgL_threadszd2runnablezd2lastzd2pairzd2)=((obj_t)BNIL),BUNSPEC); }  else 
{ /* Llib/_scheduler.scm 128 */BFALSE; } 
((((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_12)))->BgL_currentzd2threadzd2)=((obj_t)BgL_ntz00_82),BUNSPEC); 
return BgL_ntz00_82;} } }  else 
{ /* Llib/_scheduler.scm 133 */
obj_t BgL_asyncz00_96;
{ /* Llib/_scheduler.scm 133 */
obj_t BgL_list1187z00_104;
BgL_list1187z00_104 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_asyncz00_96 = 
BGl_z52schedulerzd2getzd2asynczd2runnablez80zz__ft_z52schedulerz52(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_12), BgL_list1187z00_104); } 
if(
NULLP(BgL_asyncz00_96))
{ /* Llib/_scheduler.scm 134 */
return 
((obj_t)BgL_scdlz00_12);}  else 
{ /* Llib/_scheduler.scm 135 */
obj_t BgL_ntz00_98;
BgL_ntz00_98 = 
CAR(BgL_asyncz00_96); 
((((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_12)))->BgL_threadszd2runnablezd2)=((obj_t)
CDR(BgL_asyncz00_96)),BUNSPEC); 
if(
NULLP(
(((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_12)))->BgL_threadszd2runnablezd2)))
{ /* Llib/_scheduler.scm 137 */
((((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_12)))->BgL_threadszd2runnablezd2lastzd2pairzd2)=((obj_t)BNIL),BUNSPEC); }  else 
{ /* Llib/_scheduler.scm 137 */
((((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_12)))->BgL_threadszd2runnablezd2lastzd2pairzd2)=((obj_t)
BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(
(((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_12)))->BgL_threadszd2runnablezd2))),BUNSPEC); } 
((((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_12)))->BgL_currentzd2threadzd2)=((obj_t)BgL_ntz00_98),BUNSPEC); 
return BgL_ntz00_98;} } } } } 

}



/* &%scheduler-next-thread */
obj_t BGl_z62z52schedulerzd2nextzd2threadz30zz__ft_z52schedulerz52(obj_t BgL_envz00_434, obj_t BgL_tz00_435, obj_t BgL_scdlz00_436)
{
{ /* Llib/_scheduler.scm 108 */
{ /* Llib/_scheduler.scm 109 */
BgL_schedulerz00_bglt BgL_auxz00_794;BgL_fthreadz00_bglt BgL_auxz00_786;
if(
BGl_isazf3zf3zz__objectz00(BgL_scdlz00_436, BGl_schedulerz00zz__ft_typesz00))
{ /* Llib/_scheduler.scm 109 */
BgL_auxz00_794 = 
((BgL_schedulerz00_bglt)BgL_scdlz00_436)
; }  else 
{ 
obj_t BgL_auxz00_798;
BgL_auxz00_798 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1731z00zz__ft_z52schedulerz52, 
BINT(((long)5042)), BGl_string1741z00zz__ft_z52schedulerz52, BGl_string1742z00zz__ft_z52schedulerz52, BgL_scdlz00_436); 
FAILURE(BgL_auxz00_798,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_tz00_435, BGl_fthreadz00zz__ft_typesz00))
{ /* Llib/_scheduler.scm 109 */
BgL_auxz00_786 = 
((BgL_fthreadz00_bglt)BgL_tz00_435)
; }  else 
{ 
obj_t BgL_auxz00_790;
BgL_auxz00_790 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1731z00zz__ft_z52schedulerz52, 
BINT(((long)5042)), BGl_string1741z00zz__ft_z52schedulerz52, BGl_string1737z00zz__ft_z52schedulerz52, BgL_tz00_435); 
FAILURE(BgL_auxz00_790,BFALSE,BFALSE);} 
return 
BGl_z52schedulerzd2nextzd2threadz52zz__ft_z52schedulerz52(BgL_auxz00_786, BgL_auxz00_794);} } 

}



/* &<@anonymous:1192> */
obj_t BGl_z62zc3z04anonymousza31192ze3ze5zz__ft_z52schedulerz52(obj_t BgL_envz00_437)
{
{ /* Llib/_scheduler.scm 153 */
return BUNSPEC;} 

}



/* %scheduler-switch-to-next-thread */
BGL_EXPORTED_DEF obj_t BGl_z52schedulerzd2switchzd2tozd2nextzd2threadz52zz__ft_z52schedulerz52(BgL_fthreadz00_bglt BgL_tz00_15, BgL_schedulerz00_bglt BgL_scdlz00_16)
{
{ /* Llib/_scheduler.scm 171 */
{ /* Llib/_scheduler.scm 174 */
obj_t BgL_ntz00_112;
BgL_ntz00_112 = 
BGl_z52schedulerzd2nextzd2threadz52zz__ft_z52schedulerz52(BgL_tz00_15, BgL_scdlz00_16); 
{ /* Llib/_scheduler.scm 177 */
obj_t BgL_arg1193z00_114;obj_t BgL_arg1194z00_115;
BgL_arg1193z00_114 = 
(((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_15))->BgL_z52builtinz52); 
BgL_arg1194z00_115 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_ntz00_112)))->BgL_z52builtinz52); 
BGl_z52pthreadzd2switchz80zz__ft_z52pthreadz52(BgL_arg1193z00_114, 
((BgL_z52pthreadz52_bglt)BgL_arg1194z00_115)); } 
if(
(
(((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_15))->BgL_z52statez52)==
CNST_TABLE_REF(((long)0))))
{ /* Llib/_scheduler.scm 178 */
return BFALSE;}  else 
{ /* Llib/_scheduler.scm 178 */
{ /* Llib/_scheduler.scm 179 */
obj_t BgL_arg1197z00_118;
BgL_arg1197z00_118 = 
(((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_15))->BgL_z52builtinz52); 
BGl_z52pthreadzd2waitz80zz__ft_z52pthreadz52(
((BgL_z52pthreadz52_bglt)BgL_arg1197z00_118)); } 
return BUNSPEC;} } } 

}



/* &%scheduler-switch-to-next-thread */
obj_t BGl_z62z52schedulerzd2switchzd2tozd2nextzd2threadz30zz__ft_z52schedulerz52(obj_t BgL_envz00_438, obj_t BgL_tz00_439, obj_t BgL_scdlz00_440)
{
{ /* Llib/_scheduler.scm 171 */
{ /* Llib/_scheduler.scm 172 */
BgL_schedulerz00_bglt BgL_auxz00_824;BgL_fthreadz00_bglt BgL_auxz00_816;
if(
BGl_isazf3zf3zz__objectz00(BgL_scdlz00_440, BGl_schedulerz00zz__ft_typesz00))
{ /* Llib/_scheduler.scm 172 */
BgL_auxz00_824 = 
((BgL_schedulerz00_bglt)BgL_scdlz00_440)
; }  else 
{ 
obj_t BgL_auxz00_828;
BgL_auxz00_828 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1731z00zz__ft_z52schedulerz52, 
BINT(((long)7677)), BGl_string1743z00zz__ft_z52schedulerz52, BGl_string1742z00zz__ft_z52schedulerz52, BgL_scdlz00_440); 
FAILURE(BgL_auxz00_828,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_tz00_439, BGl_fthreadz00zz__ft_typesz00))
{ /* Llib/_scheduler.scm 172 */
BgL_auxz00_816 = 
((BgL_fthreadz00_bglt)BgL_tz00_439)
; }  else 
{ 
obj_t BgL_auxz00_820;
BgL_auxz00_820 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1731z00zz__ft_z52schedulerz52, 
BINT(((long)7677)), BGl_string1743z00zz__ft_z52schedulerz52, BGl_string1737z00zz__ft_z52schedulerz52, BgL_tz00_439); 
FAILURE(BgL_auxz00_820,BFALSE,BFALSE);} 
return 
BGl_z52schedulerzd2switchzd2tozd2nextzd2threadz52zz__ft_z52schedulerz52(BgL_auxz00_816, BgL_auxz00_824);} } 

}



/* %schedule-instant */
BGL_EXPORTED_DEF obj_t BGl_z52schedulezd2instantz80zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt BgL_scdlz00_20)
{
{ /* Llib/_scheduler.scm 195 */
BGl_z52envzd2initzd2instantz52zz__ft_z52schedulerz52(
((BgL_schedulerz00_bglt)BgL_scdlz00_20)); 
BGl_z52terminatezd2threadsz80zz__ft_z52schedulerz52(BgL_scdlz00_20); 
BGl_z52suspendzf2resumezd2threadsz72zz__ft_z52schedulerz52(BgL_scdlz00_20); 
BGl_z52selectzd2threadsz12z92zz__ft_z52schedulerz52(BgL_scdlz00_20); 
BGl_z52startzd2newzd2threadsz52zz__ft_z52schedulerz52(BgL_scdlz00_20); 
BGl_z52schedulerzd2broadcastza2z12z30zz__ft_z52schedulerz52(BgL_scdlz00_20); 
BGl_z52schedulerzd2switchzd2tozd2nextzd2threadz52zz__ft_z52schedulerz52(
((BgL_fthreadz00_bglt)BgL_scdlz00_20), 
((BgL_schedulerz00_bglt)BgL_scdlz00_20)); 
return 
BGl_z52spawnzd2asyncz80zz__ft_z52schedulerz52(BgL_scdlz00_20);} 

}



/* &%schedule-instant */
obj_t BGl_z62z52schedulezd2instantze2zz__ft_z52schedulerz52(obj_t BgL_envz00_441, obj_t BgL_scdlz00_442)
{
{ /* Llib/_scheduler.scm 195 */
{ /* Llib/_scheduler.scm 211 */
BgL_z52schedulerz52_bglt BgL_auxz00_844;
if(
BGl_isazf3zf3zz__objectz00(BgL_scdlz00_442, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* Llib/_scheduler.scm 211 */
BgL_auxz00_844 = 
((BgL_z52schedulerz52_bglt)BgL_scdlz00_442)
; }  else 
{ 
obj_t BgL_auxz00_848;
BgL_auxz00_848 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1731z00zz__ft_z52schedulerz52, 
BINT(((long)9510)), BGl_string1744z00zz__ft_z52schedulerz52, BGl_string1736z00zz__ft_z52schedulerz52, BgL_scdlz00_442); 
FAILURE(BgL_auxz00_848,BFALSE,BFALSE);} 
return 
BGl_z52schedulezd2instantz80zz__ft_z52schedulerz52(BgL_auxz00_844);} } 

}



/* %env-init-instant */
bool_t BGl_z52envzd2initzd2instantz52zz__ft_z52schedulerz52(BgL_schedulerz00_bglt BgL_scdlz00_21)
{
{ /* Llib/_scheduler.scm 220 */
{ /* Llib/_scheduler.scm 222 */
obj_t BgL_g1113z00_121;
BgL_g1113z00_121 = 
(((BgL_schedulerz00_bglt)COBJECT(
((BgL_schedulerz00_bglt)
((BgL_z52schedulerz52_bglt)BgL_scdlz00_21))))->BgL_envzb2zb2); 
{ 
obj_t BgL_l1108z00_123;
BgL_l1108z00_123 = BgL_g1113z00_121; 
BgL_zc3z04anonymousza31199ze3z87_124:
if(
PAIRP(BgL_l1108z00_123))
{ /* Llib/_scheduler.scm 222 */
{ /* Llib/_scheduler.scm 222 */
obj_t BgL_arg1204z00_126;
BgL_arg1204z00_126 = 
CAR(BgL_l1108z00_123); 
BGl_instantzd2envz12zc0zz__ft_envz00(
((BgL_ftenvz00_bglt)BgL_arg1204z00_126)); } 
{ 
obj_t BgL_l1108z00_861;
BgL_l1108z00_861 = 
CDR(BgL_l1108z00_123); 
BgL_l1108z00_123 = BgL_l1108z00_861; 
goto BgL_zc3z04anonymousza31199ze3z87_124;} }  else 
{ /* Llib/_scheduler.scm 222 */
return ((bool_t)1);} } } } 

}



/* %sort-threads */
obj_t BGl_z52sortzd2threadsz80zz__ft_z52schedulerz52(obj_t BgL_threadsz00_22)
{
{ /* Llib/_scheduler.scm 227 */
return 
BGl_sortz00zz__r4_vectors_6_8z00(BgL_threadsz00_22, BGl_proc1745z00zz__ft_z52schedulerz52);} 

}



/* &<@anonymous:1218> */
obj_t BGl_z62zc3z04anonymousza31218ze3ze5zz__ft_z52schedulerz52(obj_t BgL_envz00_444, obj_t BgL_t1z00_445, obj_t BgL_t2z00_446)
{
{ /* Llib/_scheduler.scm 229 */
return 
BBOOL(
(
(long)(
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_t1z00_445)))->BgL_z52identz52))<
(long)(
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_t2z00_446)))->BgL_z52identz52))));} 

}



/* %select-threads! */
obj_t BGl_z52selectzd2threadsz12z92zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt BgL_scdlz00_23)
{
{ /* Llib/_scheduler.scm 240 */
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_23))->BgL_z52threadszd2readyz80)=((bool_t)((bool_t)0)),BUNSPEC); 
{ /* Llib/_scheduler.scm 264 */
obj_t BgL_runnablez00_453;
{ /* Llib/_scheduler.scm 264 */
obj_t BgL_cellvalz00_873;
BgL_cellvalz00_873 = 
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_23))->BgL_threadszd2yieldzd2); 
BgL_runnablez00_453 = 
MAKE_CELL(BgL_cellvalz00_873); } 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_23))->BgL_threadszd2yieldzd2)=((obj_t)BNIL),BUNSPEC); 
{ 
obj_t BgL_auxz00_876;
{ /* Llib/_scheduler.scm 267 */
obj_t BgL_arg1243z00_147;
BgL_arg1243z00_147 = 
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_23))->BgL_threadszd2timeoutzd2); 
{ /* Llib/_scheduler.scm 268 */
obj_t BgL_zc3z04anonymousza31244ze3z87_447;
BgL_zc3z04anonymousza31244ze3z87_447 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31244ze3ze5zz__ft_z52schedulerz52, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31244ze3z87_447, 
(int)(((long)0)), 
((obj_t)BgL_scdlz00_23)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31244ze3z87_447, 
(int)(((long)1)), 
((obj_t)BgL_runnablez00_453)); 
BgL_auxz00_876 = 
BGl_filterz12z12zz__r4_control_features_6_9z00(BgL_zc3z04anonymousza31244ze3z87_447, BgL_arg1243z00_147); } } 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_23))->BgL_threadszd2timeoutzd2)=((obj_t)BgL_auxz00_876),BUNSPEC); } 
if(
CBOOL(
(((BgL_schedulerz00_bglt)COBJECT(
((BgL_schedulerz00_bglt)BgL_scdlz00_23)))->BgL_strictzd2orderzf3z21)))
{ /* Llib/_scheduler.scm 285 */
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_23))->BgL_threadszd2runnablezd2)=((obj_t)
BGl_z52sortzd2threadsz80zz__ft_z52schedulerz52(
CELL_REF(BgL_runnablez00_453))),BUNSPEC); }  else 
{ /* Llib/_scheduler.scm 285 */
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_23))->BgL_threadszd2runnablezd2)=((obj_t)
CELL_REF(BgL_runnablez00_453)),BUNSPEC); } 
if(
NULLP(
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_23))->BgL_threadszd2runnablezd2)))
{ /* Llib/_scheduler.scm 288 */
return 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_23))->BgL_threadszd2runnablezd2lastzd2pairzd2)=((obj_t)BNIL),BUNSPEC);}  else 
{ /* Llib/_scheduler.scm 288 */
return 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_23))->BgL_threadszd2runnablezd2lastzd2pairzd2)=((obj_t)
BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_23))->BgL_threadszd2runnablezd2))),BUNSPEC);} } } 

}



/* &<@anonymous:1244> */
obj_t BGl_z62zc3z04anonymousza31244ze3ze5zz__ft_z52schedulerz52(obj_t BgL_envz00_448, obj_t BgL_tz00_451)
{
{ /* Llib/_scheduler.scm 267 */
{ /* Llib/_scheduler.scm 268 */
BgL_z52schedulerz52_bglt BgL_i1081z00_449;obj_t BgL_runnablez00_450;
BgL_i1081z00_449 = 
((BgL_z52schedulerz52_bglt)
PROCEDURE_REF(BgL_envz00_448, 
(int)(((long)0)))); 
BgL_runnablez00_450 = 
PROCEDURE_REF(BgL_envz00_448, 
(int)(((long)1))); 
{ /* Llib/_scheduler.scm 268 */
bool_t BgL_tmpz00_908;
{ 

{ /* Llib/_scheduler.scm 269 */
int BgL_aux1085z00_565;
BgL_aux1085z00_565 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_451)))->BgL_z52timeoutz52); 
{ /* Llib/_scheduler.scm 269 */
obj_t BgL_aux1087z00_566;
BgL_aux1087z00_566 = 
BINT(BgL_aux1085z00_565); 
switch( 
(long)CINT(BgL_aux1087z00_566)) { case ((long)0) : 

BgL_tmpz00_908 = ((bool_t)0); break;case ((long)1) : 

{ /* Llib/_scheduler.scm 276 */
obj_t BgL_g1125z00_567;
BgL_g1125z00_567 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_451)))->BgL_z52signalsz52); 
{ 
obj_t BgL_l1123z00_569;
BgL_l1123z00_569 = BgL_g1125z00_567; 
BgL_zc3z04anonymousza31651ze3z87_568:
if(
PAIRP(BgL_l1123z00_569))
{ /* Llib/_scheduler.scm 276 */
{ /* Llib/_scheduler.scm 276 */
obj_t BgL_sz00_570;
BgL_sz00_570 = 
CAR(BgL_l1123z00_569); 
BGl_signalzd2unbindzd2threadz12z12zz__ft_signalz00(BgL_sz00_570, 
((BgL_threadz00_bglt)
((BgL_fthreadz00_bglt)BgL_tz00_451))); } 
{ 
obj_t BgL_l1123z00_920;
BgL_l1123z00_920 = 
CDR(BgL_l1123z00_569); 
BgL_l1123z00_569 = BgL_l1123z00_920; 
goto BgL_zc3z04anonymousza31651ze3z87_568;} }  else 
{ /* Llib/_scheduler.scm 276 */((bool_t)1); } } } 
{ /* Llib/_scheduler.scm 277 */
obj_t BgL_auxz00_571;
BgL_auxz00_571 = 
MAKE_YOUNG_PAIR(BgL_tz00_451, 
CELL_REF(BgL_runnablez00_450)); 
CELL_SET(BgL_runnablez00_450, BgL_auxz00_571); } 
BgL_tmpz00_908 = ((bool_t)0); break;
default: 
((((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_451)))->BgL_z52timeoutz52)=((int)
(int)(
(
(long)(
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_451)))->BgL_z52timeoutz52))-((long)1)))),BUNSPEC); 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1081z00_449))->BgL_z52threadszd2readyz80)=((bool_t)((bool_t)1)),BUNSPEC); 
BgL_tmpz00_908 = ((bool_t)1); } } } } 
return 
BBOOL(BgL_tmpz00_908);} } } 

}



/* %start-new-threads */
obj_t BGl_z52startzd2newzd2threadsz52zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt BgL_sz00_24)
{
{ /* Llib/_scheduler.scm 297 */
if(
NULLP(
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_sz00_24))->BgL_tostartz00)))
{ /* Llib/_scheduler.scm 301 */
return BFALSE;}  else 
{ /* Llib/_scheduler.scm 301 */
if(
NULLP(
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_sz00_24))->BgL_threadszd2runnablezd2lastzd2pairzd2)))
{ /* Llib/_scheduler.scm 303 */
{ 
obj_t BgL_auxz00_940;
{ /* Llib/_scheduler.scm 309 */
obj_t BgL_arg1302z00_173;obj_t BgL_arg1346z00_174;
BgL_arg1302z00_173 = 
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_sz00_24))->BgL_threadszd2runnablezd2); 
{ /* Llib/_scheduler.scm 309 */
obj_t BgL_arg1347z00_175;
BgL_arg1347z00_175 = 
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_sz00_24))->BgL_tostartz00); 
BgL_arg1346z00_174 = 
bgl_reverse_bang(BgL_arg1347z00_175); } 
BgL_auxz00_940 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BgL_arg1302z00_173, BgL_arg1346z00_174); } 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_sz00_24))->BgL_threadszd2runnablezd2)=((obj_t)BgL_auxz00_940),BUNSPEC); } 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_sz00_24))->BgL_threadszd2runnablezd2lastzd2pairzd2)=((obj_t)
BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_sz00_24))->BgL_threadszd2runnablezd2))),BUNSPEC); }  else 
{ /* Llib/_scheduler.scm 303 */
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_sz00_24))->BgL_threadszd2runnablezd2lastzd2pairzd2), 
bgl_reverse_bang(
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_sz00_24))->BgL_tostartz00))); 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_sz00_24))->BgL_threadszd2runnablezd2lastzd2pairzd2)=((obj_t)
BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_sz00_24))->BgL_threadszd2runnablezd2lastzd2pairzd2))),BUNSPEC); } 
return 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_sz00_24))->BgL_tostartz00)=((obj_t)BNIL),BUNSPEC);} } 

}



/* %terminate-threads */
obj_t BGl_z52terminatezd2threadsz80zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt BgL_scdlz00_25)
{
{ /* Llib/_scheduler.scm 319 */
if(
NULLP(
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_25))->BgL_toterminatez00)))
{ /* Llib/_scheduler.scm 324 */
return BFALSE;}  else 
{ /* Llib/_scheduler.scm 329 */
obj_t BgL_thdsz00_182;
BgL_thdsz00_182 = 
BGl_filterz12z12zz__r4_control_features_6_9z00(BGl_proc1746z00zz__ft_z52schedulerz52, 
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_25))->BgL_toterminatez00)); 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_25))->BgL_toterminatez00)=((obj_t)BNIL),BUNSPEC); 
{ /* Llib/_scheduler.scm 340 */
obj_t BgL_runnablez00_183;obj_t BgL_yieldz00_184;obj_t BgL_timeoutz00_185;
BgL_runnablez00_183 = 
BGl_filterz12z12zz__r4_control_features_6_9z00(BGl_proc1747z00zz__ft_z52schedulerz52, 
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_25))->BgL_threadszd2runnablezd2)); 
BgL_yieldz00_184 = 
BGl_filterz12z12zz__r4_control_features_6_9z00(BGl_proc1748z00zz__ft_z52schedulerz52, 
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_25))->BgL_threadszd2yieldzd2)); 
BgL_timeoutz00_185 = 
BGl_filterz12z12zz__r4_control_features_6_9z00(BGl_proc1749z00zz__ft_z52schedulerz52, 
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_25))->BgL_threadszd2timeoutzd2)); 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_25))->BgL_threadszd2runnablezd2)=((obj_t)BgL_thdsz00_182),BUNSPEC); 
BGl_z52schedulerzd2switchzd2tozd2nextzd2threadz52zz__ft_z52schedulerz52(
((BgL_fthreadz00_bglt)BgL_scdlz00_25), 
((BgL_schedulerz00_bglt)BgL_scdlz00_25)); 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_25))->BgL_threadszd2runnablezd2)=((obj_t)BgL_runnablez00_183),BUNSPEC); 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_25))->BgL_threadszd2yieldzd2)=((obj_t)BgL_yieldz00_184),BUNSPEC); 
return 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_25))->BgL_threadszd2timeoutzd2)=((obj_t)BgL_timeoutz00_185),BUNSPEC);} } } 

}



/* &<@anonymous:1504> */
obj_t BGl_z62zc3z04anonymousza31504ze3ze5zz__ft_z52schedulerz52(obj_t BgL_envz00_459, obj_t BgL_tz00_460)
{
{ /* Llib/_scheduler.scm 346 */
{ /* Llib/_scheduler.scm 347 */
bool_t BgL_tmpz00_976;
if(
BGl_z52threadzd2iszd2toterminatez52zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_tz00_460), BNIL))
{ /* Llib/_scheduler.scm 347 */
BgL_tmpz00_976 = ((bool_t)0)
; }  else 
{ /* Llib/_scheduler.scm 347 */
BgL_tmpz00_976 = ((bool_t)1)
; } 
return 
BBOOL(BgL_tmpz00_976);} } 

}



/* &<@anonymous:1497> */
obj_t BGl_z62zc3z04anonymousza31497ze3ze5zz__ft_z52schedulerz52(obj_t BgL_envz00_461, obj_t BgL_tz00_462)
{
{ /* Llib/_scheduler.scm 343 */
{ /* Llib/_scheduler.scm 344 */
bool_t BgL_tmpz00_981;
if(
BGl_z52threadzd2iszd2toterminatez52zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_tz00_462), BNIL))
{ /* Llib/_scheduler.scm 344 */
BgL_tmpz00_981 = ((bool_t)0)
; }  else 
{ /* Llib/_scheduler.scm 344 */
BgL_tmpz00_981 = ((bool_t)1)
; } 
return 
BBOOL(BgL_tmpz00_981);} } 

}



/* &<@anonymous:1482> */
obj_t BGl_z62zc3z04anonymousza31482ze3ze5zz__ft_z52schedulerz52(obj_t BgL_envz00_463, obj_t BgL_tz00_464)
{
{ /* Llib/_scheduler.scm 340 */
{ /* Llib/_scheduler.scm 341 */
bool_t BgL_tmpz00_986;
if(
BGl_z52threadzd2iszd2toterminatez52zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_tz00_464), BNIL))
{ /* Llib/_scheduler.scm 341 */
BgL_tmpz00_986 = ((bool_t)0)
; }  else 
{ /* Llib/_scheduler.scm 341 */
BgL_tmpz00_986 = ((bool_t)1)
; } 
return 
BBOOL(BgL_tmpz00_986);} } 

}



/* &<@anonymous:1522> */
obj_t BGl_z62zc3z04anonymousza31522ze3ze5zz__ft_z52schedulerz52(obj_t BgL_envz00_465, obj_t BgL_tz00_466)
{
{ /* Llib/_scheduler.scm 329 */
{ /* Llib/_scheduler.scm 330 */
bool_t BgL_tmpz00_991;
if(
BGl_z52threadzd2iszd2toterminatez52zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_tz00_466), BNIL))
{ /* Llib/_scheduler.scm 330 */
{ /* Llib/_scheduler.scm 332 */
obj_t BgL_list1523z00_572;
BgL_list1523z00_572 = 
MAKE_YOUNG_PAIR(BTRUE, BNIL); 
BGl_z52threadzd2iszd2terminatedz52zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_tz00_466), BgL_list1523z00_572); } 
BgL_tmpz00_991 = ((bool_t)1); }  else 
{ /* Llib/_scheduler.scm 330 */
BgL_tmpz00_991 = ((bool_t)0)
; } 
return 
BBOOL(BgL_tmpz00_991);} } 

}



/* %suspend/resume-threads */
obj_t BGl_z52suspendzf2resumezd2threadsz72zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt BgL_scdlz00_26)
{
{ /* Llib/_scheduler.scm 364 */
if(
NULLP(
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_26))->BgL_tosuspendzf2resumezf2)))
{ /* Llib/_scheduler.scm 366 */
return BFALSE;}  else 
{ /* Llib/_scheduler.scm 366 */
{ /* Llib/_scheduler.scm 368 */
obj_t BgL_g1116z00_222;
BgL_g1116z00_222 = 
bgl_reverse_bang(
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_26))->BgL_tosuspendzf2resumezf2)); 
{ 
obj_t BgL_l1114z00_224;
BgL_l1114z00_224 = BgL_g1116z00_222; 
BgL_zc3z04anonymousza31542ze3z87_225:
if(
PAIRP(BgL_l1114z00_224))
{ /* Llib/_scheduler.scm 371 */
{ /* Llib/_scheduler.scm 369 */
obj_t BgL_vz00_227;
BgL_vz00_227 = 
CAR(BgL_l1114z00_224); 
{ /* Llib/_scheduler.scm 369 */
BgL_fthreadz00_bglt BgL_i1092z00_228;
BgL_i1092z00_228 = 
((BgL_fthreadz00_bglt)
CAR(
((obj_t)BgL_vz00_227))); 
((((BgL_fthreadz00_bglt)COBJECT(BgL_i1092z00_228))->BgL_z52iszd2suspendz80)=((bool_t)
CBOOL(
CDR(
((obj_t)BgL_vz00_227)))),BUNSPEC); } } 
{ 
obj_t BgL_l1114z00_1014;
BgL_l1114z00_1014 = 
CDR(BgL_l1114z00_224); 
BgL_l1114z00_224 = BgL_l1114z00_1014; 
goto BgL_zc3z04anonymousza31542ze3z87_225;} }  else 
{ /* Llib/_scheduler.scm 371 */((bool_t)1); } } } 
return 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_26))->BgL_tosuspendzf2resumezf2)=((obj_t)BNIL),BUNSPEC);} } 

}



/* %scheduler-spawn-async */
BGL_EXPORTED_DEF obj_t BGl_z52schedulerzd2spawnzd2asyncz52zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt BgL_scdlz00_27, BgL_z52sigasyncz52_bglt BgL_sigz00_28)
{
{ /* Llib/_scheduler.scm 377 */
if(
(((BgL_z52sigasyncz52_bglt)COBJECT(BgL_sigz00_28))->BgL_spawnedz00))
{ /* Llib/_scheduler.scm 379 */
return BFALSE;}  else 
{ /* Llib/_scheduler.scm 381 */
obj_t BgL_ntz00_467;
BgL_ntz00_467 = 
MAKE_FX_PROCEDURE(BGl_z62ntz62zz__ft_z52schedulerz52, 
(int)(((long)0)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_ntz00_467, 
(int)(((long)0)), 
((obj_t)BgL_sigz00_28)); 
PROCEDURE_SET(BgL_ntz00_467, 
(int)(((long)1)), 
((obj_t)BgL_scdlz00_27)); 
PROCEDURE_SET(BgL_ntz00_467, 
(int)(((long)2)), 
((obj_t)BgL_sigz00_28)); 
((((BgL_z52sigasyncz52_bglt)COBJECT(BgL_sigz00_28))->BgL_spawnedz00)=((bool_t)((bool_t)1)),BUNSPEC); 
{ /* Llib/_scheduler.scm 385 */
obj_t BgL_arg1576z00_237;obj_t BgL_arg1577z00_238;
BgL_arg1576z00_237 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_scdlz00_27)))->BgL_z52builtinz52); 
BgL_arg1577z00_238 = 
(((BgL_z52sigasyncz52_bglt)COBJECT(BgL_sigz00_28))->BgL_idz00); 
BGl_z52asynczd2spawnz80zz__ft_z52pthreadz52(
((BgL_z52pthreadz52_bglt)BgL_arg1576z00_237), BgL_ntz00_467, BgL_arg1577z00_238); } 
return BUNSPEC;} } 

}



/* &%scheduler-spawn-async */
obj_t BGl_z62z52schedulerzd2spawnzd2asyncz30zz__ft_z52schedulerz52(obj_t BgL_envz00_468, obj_t BgL_scdlz00_469, obj_t BgL_sigz00_470)
{
{ /* Llib/_scheduler.scm 377 */
{ /* Llib/_scheduler.scm 378 */
BgL_z52sigasyncz52_bglt BgL_auxz00_1045;BgL_z52schedulerz52_bglt BgL_auxz00_1037;
if(
BGl_isazf3zf3zz__objectz00(BgL_sigz00_470, BGl_z52sigasyncz52zz__ft_z52typesz52))
{ /* Llib/_scheduler.scm 378 */
BgL_auxz00_1045 = 
((BgL_z52sigasyncz52_bglt)BgL_sigz00_470)
; }  else 
{ 
obj_t BgL_auxz00_1049;
BgL_auxz00_1049 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1731z00zz__ft_z52schedulerz52, 
BINT(((long)16633)), BGl_string1750z00zz__ft_z52schedulerz52, BGl_string1739z00zz__ft_z52schedulerz52, BgL_sigz00_470); 
FAILURE(BgL_auxz00_1049,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_scdlz00_469, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* Llib/_scheduler.scm 378 */
BgL_auxz00_1037 = 
((BgL_z52schedulerz52_bglt)BgL_scdlz00_469)
; }  else 
{ 
obj_t BgL_auxz00_1041;
BgL_auxz00_1041 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1731z00zz__ft_z52schedulerz52, 
BINT(((long)16633)), BGl_string1750z00zz__ft_z52schedulerz52, BGl_string1736z00zz__ft_z52schedulerz52, BgL_scdlz00_469); 
FAILURE(BgL_auxz00_1041,BFALSE,BFALSE);} 
return 
BGl_z52schedulerzd2spawnzd2asyncz52zz__ft_z52schedulerz52(BgL_auxz00_1037, BgL_auxz00_1045);} } 

}



/* &nt */
obj_t BGl_z62ntz62zz__ft_z52schedulerz52(obj_t BgL_envz00_471)
{
{ /* Llib/_scheduler.scm 380 */
{ /* Llib/_scheduler.scm 381 */
BgL_z52sigasyncz52_bglt BgL_i1093z00_472;BgL_z52schedulerz52_bglt BgL_scdlz00_473;BgL_z52sigasyncz52_bglt BgL_sigz00_474;
BgL_i1093z00_472 = 
((BgL_z52sigasyncz52_bglt)
PROCEDURE_REF(BgL_envz00_471, 
(int)(((long)0)))); 
BgL_scdlz00_473 = 
((BgL_z52schedulerz52_bglt)
PROCEDURE_REF(BgL_envz00_471, 
(int)(((long)1)))); 
BgL_sigz00_474 = 
((BgL_z52sigasyncz52_bglt)
PROCEDURE_REF(BgL_envz00_471, 
(int)(((long)2)))); 
{ /* Llib/_scheduler.scm 381 */
obj_t BgL_arg1580z00_573;
{ /* Llib/_scheduler.scm 381 */
obj_t BgL_fun1581z00_574;
BgL_fun1581z00_574 = 
(((BgL_z52sigasyncz52_bglt)COBJECT(BgL_i1093z00_472))->BgL_thunkz00); 
BgL_arg1580z00_573 = 
PROCEDURE_ENTRY(BgL_fun1581z00_574)(BgL_fun1581z00_574, BEOA); } 
BGl_z52schedulerzd2addzd2broadcastz12z40zz__ft_z52schedulerz52(BgL_scdlz00_473, 
((obj_t)BgL_sigz00_474), BgL_arg1580z00_573); } 
return BUNSPEC;} } 

}



/* %spawn-async */
obj_t BGl_z52spawnzd2asyncz80zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt BgL_scdlz00_29)
{
{ /* Llib/_scheduler.scm 395 */
if(
NULLP(
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_29))->BgL_tospawnz00)))
{ /* Llib/_scheduler.scm 397 */
return BFALSE;}  else 
{ /* Llib/_scheduler.scm 397 */
{ /* Llib/_scheduler.scm 398 */
obj_t BgL_g1119z00_246;
BgL_g1119z00_246 = 
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_29))->BgL_tospawnz00); 
{ 
obj_t BgL_l1117z00_248;
BgL_l1117z00_248 = BgL_g1119z00_246; 
BgL_zc3z04anonymousza31588ze3z87_249:
if(
PAIRP(BgL_l1117z00_248))
{ /* Llib/_scheduler.scm 398 */
{ /* Llib/_scheduler.scm 398 */
obj_t BgL_sz00_251;
BgL_sz00_251 = 
CAR(BgL_l1117z00_248); 
BGl_z52schedulerzd2spawnzd2asyncz52zz__ft_z52schedulerz52(BgL_scdlz00_29, 
((BgL_z52sigasyncz52_bglt)BgL_sz00_251)); } 
{ 
obj_t BgL_l1117z00_1078;
BgL_l1117z00_1078 = 
CDR(BgL_l1117z00_248); 
BgL_l1117z00_248 = BgL_l1117z00_1078; 
goto BgL_zc3z04anonymousza31588ze3z87_249;} }  else 
{ /* Llib/_scheduler.scm 398 */((bool_t)1); } } } 
return 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_29))->BgL_tospawnz00)=((obj_t)BNIL),BUNSPEC);} } 

}



/* %broadcast! */
BGL_EXPORTED_DEF obj_t BGl_z52broadcastz12z40zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt BgL_scdlz00_30, obj_t BgL_sigz00_31, obj_t BgL_valz00_32)
{
{ /* Llib/_scheduler.scm 404 */
{ /* Llib/_scheduler.scm 408 */
obj_t BgL_arg1598z00_388;
BgL_arg1598z00_388 = 
(((BgL_schedulerz00_bglt)COBJECT(
((BgL_schedulerz00_bglt)BgL_scdlz00_30)))->BgL_envzb2zb2); 
return 
BGl_signalzd2emitzd2zz__ft_signalz00(BgL_sigz00_31, BgL_valz00_32, BgL_arg1598z00_388);} } 

}



/* &%broadcast! */
obj_t BGl_z62z52broadcastz12z22zz__ft_z52schedulerz52(obj_t BgL_envz00_475, obj_t BgL_scdlz00_476, obj_t BgL_sigz00_477, obj_t BgL_valz00_478)
{
{ /* Llib/_scheduler.scm 404 */
{ /* Llib/_scheduler.scm 407 */
BgL_z52schedulerz52_bglt BgL_auxz00_1084;
if(
BGl_isazf3zf3zz__objectz00(BgL_scdlz00_476, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* Llib/_scheduler.scm 407 */
BgL_auxz00_1084 = 
((BgL_z52schedulerz52_bglt)BgL_scdlz00_476)
; }  else 
{ 
obj_t BgL_auxz00_1088;
BgL_auxz00_1088 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1731z00zz__ft_z52schedulerz52, 
BINT(((long)17989)), BGl_string1751z00zz__ft_z52schedulerz52, BGl_string1736z00zz__ft_z52schedulerz52, BgL_scdlz00_476); 
FAILURE(BgL_auxz00_1088,BFALSE,BFALSE);} 
return 
BGl_z52broadcastz12z40zz__ft_z52schedulerz52(BgL_auxz00_1084, BgL_sigz00_477, BgL_valz00_478);} } 

}



/* %scheduler-broadcast*! */
obj_t BGl_z52schedulerzd2broadcastza2z12z30zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt BgL_scdlz00_33)
{
{ /* Llib/_scheduler.scm 413 */
{ /* Llib/_scheduler.scm 416 */
obj_t BgL_arg1604z00_259;
BgL_arg1604z00_259 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_scdlz00_33)))->BgL_z52builtinz52); 
BGl_z52asynczd2synchroniza7ez27zz__ft_z52pthreadz52(
((BgL_z52pthreadz52_bglt)BgL_arg1604z00_259)); } 
{ /* Llib/_scheduler.scm 416 */
obj_t BgL_g1099z00_260;
if(
NULLP(
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_33))->BgL_tobroadcastz00)))
{ /* Llib/_scheduler.scm 421 */
BgL_g1099z00_260 = BFALSE; }  else 
{ /* Llib/_scheduler.scm 421 */
{ /* Llib/_scheduler.scm 423 */
obj_t BgL_g1122z00_265;
BgL_g1122z00_265 = 
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_33))->BgL_tobroadcastz00); 
{ 
obj_t BgL_l1120z00_267;
BgL_l1120z00_267 = BgL_g1122z00_265; 
BgL_zc3z04anonymousza31608ze3z87_268:
if(
PAIRP(BgL_l1120z00_267))
{ /* Llib/_scheduler.scm 423 */
{ /* Llib/_scheduler.scm 423 */
obj_t BgL_arg1612z00_270;
BgL_arg1612z00_270 = 
CAR(BgL_l1120z00_267); 
{ /* Llib/_scheduler.scm 415 */
obj_t BgL_arg1619z00_399;obj_t BgL_arg1620z00_400;
BgL_arg1619z00_399 = 
CAR(
((obj_t)BgL_arg1612z00_270)); 
BgL_arg1620z00_400 = 
CDR(
((obj_t)BgL_arg1612z00_270)); 
{ /* Llib/_scheduler.scm 408 */
obj_t BgL_arg1598z00_405;
BgL_arg1598z00_405 = 
(((BgL_schedulerz00_bglt)COBJECT(
((BgL_schedulerz00_bglt)BgL_scdlz00_33)))->BgL_envzb2zb2); 
BGl_signalzd2emitzd2zz__ft_signalz00(BgL_arg1619z00_399, BgL_arg1620z00_400, BgL_arg1598z00_405); } } } 
{ 
obj_t BgL_l1120z00_1111;
BgL_l1120z00_1111 = 
CDR(BgL_l1120z00_267); 
BgL_l1120z00_267 = BgL_l1120z00_1111; 
goto BgL_zc3z04anonymousza31608ze3z87_268;} }  else 
{ /* Llib/_scheduler.scm 423 */((bool_t)1); } } } 
BgL_g1099z00_260 = 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_33))->BgL_tobroadcastz00)=((obj_t)BNIL),BUNSPEC); } 
{ /* Llib/_scheduler.scm 416 */
obj_t BgL_arg1605z00_261;
BgL_arg1605z00_261 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_scdlz00_33)))->BgL_z52builtinz52); 
BGl_z52asynczd2asynchroniza7ez27zz__ft_z52pthreadz52(
((BgL_z52pthreadz52_bglt)BgL_arg1605z00_261)); } 
return BgL_g1099z00_260;} } 

}



/* %scheduler-add-broadcast! */
BGL_EXPORTED_DEF obj_t BGl_z52schedulerzd2addzd2broadcastz12z40zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt BgL_scdlz00_34, obj_t BgL_sigz00_35, obj_t BgL_valz00_36)
{
{ /* Llib/_scheduler.scm 433 */
{ /* Llib/_scheduler.scm 434 */
obj_t BgL_arg1625z00_280;
BgL_arg1625z00_280 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_scdlz00_34)))->BgL_z52builtinz52); 
BGl_z52asynczd2synchroniza7ez27zz__ft_z52pthreadz52(
((BgL_z52pthreadz52_bglt)BgL_arg1625z00_280)); } 
{ /* Llib/_scheduler.scm 434 */
obj_t BgL_g1102z00_281;
{ /* Llib/_scheduler.scm 437 */
obj_t BgL_svz00_284;
BgL_svz00_284 = 
MAKE_YOUNG_PAIR(BgL_sigz00_35, BgL_valz00_36); 
{ 
obj_t BgL_auxz00_1123;
{ /* Llib/_scheduler.scm 438 */
obj_t BgL_arg1627z00_285;
BgL_arg1627z00_285 = 
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_34))->BgL_tobroadcastz00); 
BgL_auxz00_1123 = 
MAKE_YOUNG_PAIR(BgL_svz00_284, BgL_arg1627z00_285); } 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_34))->BgL_tobroadcastz00)=((obj_t)BgL_auxz00_1123),BUNSPEC); } } 
{ /* Llib/_scheduler.scm 439 */
obj_t BgL_arg1628z00_286;
BgL_arg1628z00_286 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_scdlz00_34)))->BgL_z52builtinz52); 
BGl_z52asynczd2schedulerzd2notifyz52zz__ft_z52pthreadz52(
((BgL_z52pthreadz52_bglt)BgL_arg1628z00_286)); } 
BgL_g1102z00_281 = BUNSPEC; 
{ /* Llib/_scheduler.scm 434 */
obj_t BgL_arg1626z00_282;
BgL_arg1626z00_282 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_scdlz00_34)))->BgL_z52builtinz52); 
BGl_z52asynczd2asynchroniza7ez27zz__ft_z52pthreadz52(
((BgL_z52pthreadz52_bglt)BgL_arg1626z00_282)); } 
return BgL_g1102z00_281;} } 

}



/* &%scheduler-add-broadcast! */
obj_t BGl_z62z52schedulerzd2addzd2broadcastz12z22zz__ft_z52schedulerz52(obj_t BgL_envz00_479, obj_t BgL_scdlz00_480, obj_t BgL_sigz00_481, obj_t BgL_valz00_482)
{
{ /* Llib/_scheduler.scm 433 */
{ /* Llib/_scheduler.scm 434 */
BgL_z52schedulerz52_bglt BgL_auxz00_1135;
if(
BGl_isazf3zf3zz__objectz00(BgL_scdlz00_480, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* Llib/_scheduler.scm 434 */
BgL_auxz00_1135 = 
((BgL_z52schedulerz52_bglt)BgL_scdlz00_480)
; }  else 
{ 
obj_t BgL_auxz00_1139;
BgL_auxz00_1139 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1731z00zz__ft_z52schedulerz52, 
BINT(((long)19122)), BGl_string1752z00zz__ft_z52schedulerz52, BGl_string1736z00zz__ft_z52schedulerz52, BgL_scdlz00_480); 
FAILURE(BgL_auxz00_1139,BFALSE,BFALSE);} 
return 
BGl_z52schedulerzd2addzd2broadcastz12z40zz__ft_z52schedulerz52(BgL_auxz00_1135, BgL_sigz00_481, BgL_valz00_482);} } 

}



/* %scheduler-time */
BGL_EXPORTED_DEF obj_t BGl_z52schedulerzd2timez80zz__ft_z52schedulerz52(BgL_schedulerz00_bglt BgL_scdlz00_37)
{
{ /* Llib/_scheduler.scm 445 */
return 
BINT(
(((BgL_ftenvz00_bglt)COBJECT(
((BgL_ftenvz00_bglt)
CAR(
(((BgL_schedulerz00_bglt)COBJECT(BgL_scdlz00_37))->BgL_envzb2zb2)))))->BgL_instantz00));} 

}



/* &%scheduler-time */
obj_t BGl_z62z52schedulerzd2timeze2zz__ft_z52schedulerz52(obj_t BgL_envz00_483, obj_t BgL_scdlz00_484)
{
{ /* Llib/_scheduler.scm 445 */
{ /* Llib/_scheduler.scm 447 */
BgL_schedulerz00_bglt BgL_auxz00_1149;
if(
BGl_isazf3zf3zz__objectz00(BgL_scdlz00_484, BGl_schedulerz00zz__ft_typesz00))
{ /* Llib/_scheduler.scm 447 */
BgL_auxz00_1149 = 
((BgL_schedulerz00_bglt)BgL_scdlz00_484)
; }  else 
{ 
obj_t BgL_auxz00_1153;
BgL_auxz00_1153 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1731z00zz__ft_z52schedulerz52, 
BINT(((long)19672)), BGl_string1753z00zz__ft_z52schedulerz52, BGl_string1742z00zz__ft_z52schedulerz52, BgL_scdlz00_484); 
FAILURE(BgL_auxz00_1153,BFALSE,BFALSE);} 
return 
BGl_z52schedulerzd2timez80zz__ft_z52schedulerz52(BgL_auxz00_1149);} } 

}



/* %scheduler-waiting-threads */
BGL_EXPORTED_DEF obj_t BGl_z52schedulerzd2waitingzd2threadsz52zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt BgL_scdlz00_38)
{
{ /* Llib/_scheduler.scm 453 */
{ 
obj_t BgL_envsz00_294;obj_t BgL_thsz00_295;
{ /* Llib/_scheduler.scm 455 */
obj_t BgL_arg1631z00_293;
BgL_arg1631z00_293 = 
(((BgL_schedulerz00_bglt)COBJECT(
((BgL_schedulerz00_bglt)BgL_scdlz00_38)))->BgL_envzb2zb2); 
BgL_envsz00_294 = BgL_arg1631z00_293; 
BgL_thsz00_295 = BNIL; 
BgL_zc3z04anonymousza31632ze3z87_296:
if(
PAIRP(BgL_envsz00_294))
{ /* Llib/_scheduler.scm 458 */
obj_t BgL_arg1635z00_298;obj_t BgL_arg1642z00_299;
BgL_arg1635z00_298 = 
CDR(BgL_envsz00_294); 
{ /* Llib/_scheduler.scm 458 */
obj_t BgL_arg1643z00_300;
{ /* Llib/_scheduler.scm 458 */
obj_t BgL_arg1646z00_301;
BgL_arg1646z00_301 = 
CAR(
(((BgL_schedulerz00_bglt)COBJECT(
((BgL_schedulerz00_bglt)BgL_scdlz00_38)))->BgL_envzb2zb2)); 
BgL_arg1643z00_300 = 
BGl_ftenvzd2threadszd2zz__ft_envz00(
((BgL_ftenvz00_bglt)BgL_arg1646z00_301)); } 
BgL_arg1642z00_299 = 
BGl_appendzd221010zd2zz__ft_z52schedulerz52(BgL_arg1643z00_300, BgL_thsz00_295); } 
{ 
obj_t BgL_thsz00_1170;obj_t BgL_envsz00_1169;
BgL_envsz00_1169 = BgL_arg1635z00_298; 
BgL_thsz00_1170 = BgL_arg1642z00_299; 
BgL_thsz00_295 = BgL_thsz00_1170; 
BgL_envsz00_294 = BgL_envsz00_1169; 
goto BgL_zc3z04anonymousza31632ze3z87_296;} }  else 
{ /* Llib/_scheduler.scm 457 */
return BgL_thsz00_295;} } } } 

}



/* &%scheduler-waiting-threads */
obj_t BGl_z62z52schedulerzd2waitingzd2threadsz30zz__ft_z52schedulerz52(obj_t BgL_envz00_485, obj_t BgL_scdlz00_486)
{
{ /* Llib/_scheduler.scm 453 */
{ /* Llib/_scheduler.scm 454 */
BgL_z52schedulerz52_bglt BgL_auxz00_1171;
if(
BGl_isazf3zf3zz__objectz00(BgL_scdlz00_486, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* Llib/_scheduler.scm 454 */
BgL_auxz00_1171 = 
((BgL_z52schedulerz52_bglt)BgL_scdlz00_486)
; }  else 
{ 
obj_t BgL_auxz00_1175;
BgL_auxz00_1175 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1731z00zz__ft_z52schedulerz52, 
BINT(((long)19994)), BGl_string1754z00zz__ft_z52schedulerz52, BGl_string1736z00zz__ft_z52schedulerz52, BgL_scdlz00_486); 
FAILURE(BgL_auxz00_1175,BFALSE,BFALSE);} 
return 
BGl_z52schedulerzd2waitingzd2threadsz52zz__ft_z52schedulerz52(BgL_auxz00_1171);} } 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__ft_z52schedulerz52()
{
{ /* Llib/_scheduler.scm 15 */
return BUNSPEC;} 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__ft_z52schedulerz52()
{
{ /* Llib/_scheduler.scm 15 */
return BUNSPEC;} 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__ft_z52schedulerz52()
{
{ /* Llib/_scheduler.scm 15 */
return BUNSPEC;} 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__ft_z52schedulerz52()
{
{ /* Llib/_scheduler.scm 15 */
BGl_modulezd2initializa7ationz75zz__ft_typesz00(((long)414892275), 
BSTRING_TO_STRING(BGl_string1755z00zz__ft_z52schedulerz52)); 
BGl_modulezd2initializa7ationz75zz__ft_z52typesz52(((long)0), 
BSTRING_TO_STRING(BGl_string1755z00zz__ft_z52schedulerz52)); 
BGl_modulezd2initializa7ationz75zz__ft_schedulerz00(((long)427827911), 
BSTRING_TO_STRING(BGl_string1755z00zz__ft_z52schedulerz52)); 
BGl_modulezd2initializa7ationz75zz__ft_z52threadz52(((long)536507091), 
BSTRING_TO_STRING(BGl_string1755z00zz__ft_z52schedulerz52)); 
BGl_modulezd2initializa7ationz75zz__ft_envz00(((long)360853603), 
BSTRING_TO_STRING(BGl_string1755z00zz__ft_z52schedulerz52)); 
BGl_modulezd2initializa7ationz75zz__ft_z52envz52(((long)471565054), 
BSTRING_TO_STRING(BGl_string1755z00zz__ft_z52schedulerz52)); 
BGl_modulezd2initializa7ationz75zz__ft_signalz00(((long)295111899), 
BSTRING_TO_STRING(BGl_string1755z00zz__ft_z52schedulerz52)); 
return 
BGl_modulezd2initializa7ationz75zz__ft_z52pthreadz52(((long)486293435), 
BSTRING_TO_STRING(BGl_string1755z00zz__ft_z52schedulerz52));} 

}

#ifdef __cplusplus
}
#endif
