/*===========================================================================*/
/*   (Llib/scheduler.scm)                                                    */
/*   Bigloo (4.3g)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu 27 Feb 2020 07:59:49 AM CET     */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo4.3g/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo4.3g/lib/bigloo/4.3g -lib-dir /builddir/build/BUILD/bigloo4.3g/lib/bigloo/4.3g -I Llib -lib-dir /builddir/build/BUILD/bigloo4.3g/lib/bigloo/4.3g -unsafe -safee -copt -fPIC -copt -IPosix Llib/scheduler.scm -o objs/scheduler.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_threadz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
} *BgL_threadz00_bglt;

typedef struct BgL_fthreadz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_schedulerz00;
   obj_t BgL_z52builtinz52;
   int BgL_z52timeoutz52;
   obj_t BgL_z52statez52;
   bool_t BgL_z52iszd2suspendz80;
   obj_t BgL_z52terminatez52;
   obj_t BgL_z52resultz52;
   obj_t BgL_z52exczd2resultz80;
   bool_t BgL_z52exczd2raisedz80;
   int BgL_z52identz52;
   obj_t BgL_z52signalsz52;
   obj_t BgL_z52awakezd2signalz80;
   obj_t BgL_z52awakezd2valuez80;
   obj_t BgL_z52cleanupz52;
   obj_t BgL_z52specificz52;
   obj_t BgL_bodyz00;
} *BgL_fthreadz00_bglt;

typedef struct BgL_schedulerz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_schedulerz00;
   obj_t BgL_z52builtinz52;
   int BgL_z52timeoutz52;
   obj_t BgL_z52statez52;
   bool_t BgL_z52iszd2suspendz80;
   obj_t BgL_z52terminatez52;
   obj_t BgL_z52resultz52;
   obj_t BgL_z52exczd2resultz80;
   bool_t BgL_z52exczd2raisedz80;
   int BgL_z52identz52;
   obj_t BgL_z52signalsz52;
   obj_t BgL_z52awakezd2signalz80;
   obj_t BgL_z52awakezd2valuez80;
   obj_t BgL_z52cleanupz52;
   obj_t BgL_z52specificz52;
   obj_t BgL_bodyz00;
   obj_t BgL_envzb2zb2;
   obj_t BgL_strictzd2orderzf3z21;
} *BgL_schedulerz00_bglt;

typedef struct BgL_ftenvz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_instantz00;
} *BgL_ftenvz00_bglt;

typedef struct BgL_z52schedulerz52_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_schedulerz00;
   obj_t BgL_z52builtinz52;
   int BgL_z52timeoutz52;
   obj_t BgL_z52statez52;
   bool_t BgL_z52iszd2suspendz80;
   obj_t BgL_z52terminatez52;
   obj_t BgL_z52resultz52;
   obj_t BgL_z52exczd2resultz80;
   bool_t BgL_z52exczd2raisedz80;
   int BgL_z52identz52;
   obj_t BgL_z52signalsz52;
   obj_t BgL_z52awakezd2signalz80;
   obj_t BgL_z52awakezd2valuez80;
   obj_t BgL_z52cleanupz52;
   obj_t BgL_z52specificz52;
   obj_t BgL_bodyz00;
   obj_t BgL_envzb2zb2;
   obj_t BgL_strictzd2orderzf3z21;
   obj_t BgL_nextzd2instantzd2;
   obj_t BgL_currentzd2threadzd2;
   int BgL_z52livezd2threadzd2numberz52;
   bool_t BgL_z52threadszd2readyz80;
   obj_t BgL_threadszd2runnablezd2;
   obj_t BgL_threadszd2runnablezd2lastzd2pairzd2;
   obj_t BgL_asynczd2runnablezd2;
   obj_t BgL_threadszd2timeoutzd2;
   obj_t BgL_threadszd2yieldzd2;
   obj_t BgL_tostartz00;
   obj_t BgL_toterminatez00;
   obj_t BgL_tosuspendzf2resumezf2;
   obj_t BgL_tobroadcastz00;
   obj_t BgL_tospawnz00;
   obj_t BgL_currentzd2tokenzd2;
} *BgL_z52schedulerz52_bglt;

typedef struct BgL_z52pthreadz52_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_bodyz00;
   bool_t BgL_detachedpz00;
   obj_t BgL_endzd2resultzd2;
   obj_t BgL_endzd2exceptionzd2;
   void * BgL_z42builtinz42;
   obj_t BgL_fthreadz00;
   obj_t BgL_mutexz00;
   obj_t BgL_condvarz00;
   obj_t BgL_idz00;
   obj_t BgL_parentz00;
} *BgL_z52pthreadz52_bglt;

typedef struct BgL_z52envz52_bgl {
   header_t header;
   obj_t widening;
   long BgL_instantz00;
   obj_t BgL_z52signalsz52;
   obj_t BgL_z52lastzd2signalsz80;
} *BgL_z52envz52_bglt;


BGL_EXPORTED_DECL obj_t BGl_schedulerzd2terminatez12zc0zz__ft_schedulerz00(obj_t);
extern bool_t BGl_z52threadzd2iszd2deadz52zz__ft_z52threadz52(BgL_fthreadz00_bglt, obj_t);
extern obj_t BGl_z52asynczd2synchroniza7ez27zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt);
static obj_t BGl_z62currentzd2schedulerzb0zz__ft_schedulerz00(obj_t);
static obj_t BGl_objectzd2initzd2zz__ft_schedulerz00();
BGL_IMPORT obj_t BGl_2zb2zb2zz__r4_numbers_6_5z00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31142ze3ze5zz__ft_schedulerz00(obj_t);
extern obj_t BGl_z52schedulerz52zz__ft_z52typesz52;
extern obj_t BGl_z52schedulerzd2addzd2broadcastz12z40zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31160ze3ze5zz__ft_schedulerz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31306ze3ze5zz__ft_schedulerz00(obj_t, obj_t);
static obj_t BGl_z62schedulerzd2instantzb0zz__ft_schedulerz00(obj_t, obj_t);
BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
static obj_t BGl_z62defaultzd2schedulerzb0zz__ft_schedulerz00(obj_t, obj_t);
static obj_t BGl_appendzd221010zd2zz__ft_schedulerz00(obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zz__ft_schedulerz00();
extern obj_t BGl_z52asynczd2schedulerzd2waitz52zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt);
extern obj_t BGl_z52schedulerzd2waitingzd2threadsz52zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt);
BGL_IMPORT obj_t BGl_threadzd2parameterzd2setz12z12zz__threadz00(obj_t, obj_t);
static obj_t BGl_z62busyzd2waitingzd2nextzd2instantzb0zz__ft_schedulerz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62withzd2schedulerzb0zz__ft_schedulerz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL BgL_schedulerz00_bglt BGl_makezd2schedulerzd2zz__ft_schedulerz00(obj_t);
extern obj_t BGl_z52pthreadzd2enterzd2schedulerz52zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt);
BGL_IMPORT bool_t BGl_numberzf3zf3zz__r4_numbers_6_5z00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31349ze3ze5zz__ft_schedulerz00(obj_t, obj_t);
extern obj_t BGl_schedulerz00zz__ft_typesz00;
BGL_EXPORTED_DECL obj_t BGl_currentzd2schedulerzd2setz12z12zz__ft_schedulerz00(obj_t);
static obj_t BGl_gczd2rootszd2initz00zz__ft_schedulerz00();
static obj_t BGl_z62nozd2busyzd2waitingzd2nextzd2instantz62zz__ft_schedulerz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_currentzd2schedulerzd2zz__ft_schedulerz00();
BGL_IMPORT obj_t BGl_gensymz00zz__r4_symbols_6_4z00(obj_t);
extern obj_t BGl_z52fschedulerzd2newz80zz__ft_z52pthreadz52(BgL_z52schedulerz52_bglt);
extern BgL_schedulerz00_bglt BGl_z52getzd2optionalzd2schedulerz52zz__ft_z52schedulerz52(obj_t, obj_t);
BGL_IMPORT obj_t BGl_exitdzd2popzd2protectz12z12zz__bexitz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31478ze3ze5zz__ft_schedulerz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_threadzd2parameterzd2zz__threadz00(obj_t);
BGL_EXPORTED_DECL int BGl_schedulerzd2instantzd2zz__ft_schedulerz00(obj_t);
static obj_t BGl_schedulerzd2statezd2zz__ft_schedulerz00(BgL_schedulerz00_bglt);
BGL_EXPORTED_DECL obj_t BGl_defaultzd2schedulerzd2zz__ft_schedulerz00(obj_t);
static obj_t BGl_schedulez00zz__ft_schedulerz00(BgL_z52schedulerz52_bglt);
static obj_t BGl_z62currentzd2schedulerzd2setz12z70zz__ft_schedulerz00(obj_t, obj_t);
static obj_t BGl_requirezd2initializa7ationz75zz__ft_schedulerz00 = BUNSPEC;
BGL_IMPORT obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62schedulerzd2startz12za2zz__ft_schedulerz00(obj_t, obj_t);
static obj_t BGl_z62schedulerzd2reactz12za2zz__ft_schedulerz00(obj_t, obj_t);
static obj_t BGl_toplevelzd2initzd2zz__ft_schedulerz00();
BGL_IMPORT obj_t BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(obj_t, obj_t);
static obj_t BGl_genericzd2initzd2zz__ft_schedulerz00();
static obj_t BGl_z62zc3z04anonymousza31206ze3ze5zz__ft_schedulerz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_broadcastz12z12zz__ft_schedulerz00(obj_t, obj_t);
extern obj_t BGl_z52asynczd2asynchroniza7ez27zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt);
static obj_t BGl_z62broadcastz12z70zz__ft_schedulerz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
static obj_t BGl_za2currentzd2schedulerza2zd2zz__ft_schedulerz00 = BUNSPEC;
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
extern obj_t BGl_fthreadz00zz__ft_typesz00;
static obj_t BGl_za2currentzd2scdlzd2paramzd2idza2zd2zz__ft_schedulerz00 = BUNSPEC;
static BgL_schedulerz00_bglt BGl_z62makezd2schedulerzb0zz__ft_schedulerz00(obj_t, obj_t);
extern bool_t BGl_z52threadzd2attachedzf3z73zz__ft_z52threadz52(BgL_fthreadz00_bglt);
static obj_t BGl_z62zc3z04anonymousza31155ze3ze5zz__ft_schedulerz00(obj_t);
extern obj_t BGl_z52schedulezd2instantz80zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt);
extern obj_t BGl_z52envz52zz__ft_z52envz52;
static obj_t BGl_z62schedulerzd2broadcastz12za2zz__ft_schedulerz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_za2defaultzd2schedulerza2zd2zz__ft_schedulerz00 = BUNSPEC;
BGL_EXPORTED_DECL obj_t BGl_schedulerzd2broadcastz12zc0zz__ft_schedulerz00(BgL_schedulerz00_bglt, obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2constructorzd2zz__objectz00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__ft_schedulerz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52pthreadz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_signalz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_threadz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52threadz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52envz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52schedulerz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52typesz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_typesz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__pth_threadz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
extern obj_t BGl_z52schedulerzd2timez80zz__ft_z52schedulerz52(BgL_schedulerz00_bglt);
BGL_IMPORT obj_t BGl_currentzd2threadzd2zz__threadz00();
extern obj_t BGl_z52pthreadzd2leavezd2schedulerz52zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt);
BGL_EXPORTED_DECL obj_t BGl_withzd2schedulerzd2zz__ft_schedulerz00(BgL_schedulerz00_bglt, obj_t);
static obj_t BGl_cnstzd2initzd2zz__ft_schedulerz00();
static obj_t BGl_libraryzd2moduleszd2initz00zz__ft_schedulerz00();
static obj_t BGl_importedzd2moduleszd2initz00zz__ft_schedulerz00();
BGL_IMPORT obj_t BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_schedulerzd2startz12zc0zz__ft_schedulerz00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_schedulerzd2reactz12zc0zz__ft_schedulerz00(obj_t);
BGL_IMPORT obj_t BGl_threadzd2terminatez12zc0zz__threadz00(BgL_threadz00_bglt);
BGL_IMPORT bool_t BGl_2ze3zd3z30zz__r4_numbers_6_5z00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_threadz00zz__threadz00;
extern obj_t BGl_z52broadcastz12z40zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt, obj_t, obj_t);
static obj_t BGl_z62schedulerzd2terminatez12za2zz__ft_schedulerz00(obj_t, obj_t);
static obj_t __cnst[ 11 ] ;


DEFINE_EXPORT_BGL_PROCEDURE( BGl_defaultzd2schedulerzd2envz00zz__ft_schedulerz00, BgL_bgl_za762defaultza7d2sch1678z00, va_generic_entry, BGl_z62defaultzd2schedulerzb0zz__ft_schedulerz00, BUNSPEC, -1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_schedulerzd2startz12zd2envz12zz__ft_schedulerz00, BgL_bgl_za762schedulerza7d2s1679z00, va_generic_entry, BGl_z62schedulerzd2startz12za2zz__ft_schedulerz00, BUNSPEC, -1 );
DEFINE_STRING( BGl_string1655z00zz__ft_schedulerz00, BgL_bgl_string1655za700za7za7_1680za7, "Llib/scheduler.scm", 18 );
DEFINE_STRING( BGl_string1656z00zz__ft_schedulerz00, BgL_bgl_string1656za700za7za7_1681za7, "Read-only value", 15 );
DEFINE_STRING( BGl_string1657z00zz__ft_schedulerz00, BgL_bgl_string1657za700za7za7_1682za7, "default-scheduler", 17 );
DEFINE_STRING( BGl_string1658z00zz__ft_schedulerz00, BgL_bgl_string1658za700za7za7_1683za7, "Illegal scheduler", 17 );
DEFINE_STRING( BGl_string1659z00zz__ft_schedulerz00, BgL_bgl_string1659za700za7za7_1684za7, "/builddir/build/BUILD/bigloo4.3g/api/fthread/src/Llib/scheduler.scm", 67 );
DEFINE_STRING( BGl_string1660z00zz__ft_schedulerz00, BgL_bgl_string1660za700za7za7_1685za7, "&with-scheduler", 15 );
DEFINE_STRING( BGl_string1661z00zz__ft_schedulerz00, BgL_bgl_string1661za700za7za7_1686za7, "scheduler", 9 );
DEFINE_STRING( BGl_string1662z00zz__ft_schedulerz00, BgL_bgl_string1662za700za7za7_1687za7, "procedure", 9 );
DEFINE_STRING( BGl_string1666z00zz__ft_schedulerz00, BgL_bgl_string1666za700za7za7_1688za7, "scheduler-start!", 16 );
DEFINE_STRING( BGl_string1667z00zz__ft_schedulerz00, BgL_bgl_string1667za700za7za7_1689za7, "Illegal optional parameter", 26 );
DEFINE_STRING( BGl_string1668z00zz__ft_schedulerz00, BgL_bgl_string1668za700za7za7_1690za7, "broadcast!", 10 );
DEFINE_STRING( BGl_string1669z00zz__ft_schedulerz00, BgL_bgl_string1669za700za7za7_1691za7, "Unattached thread", 17 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_schedulerzd2reactz12zd2envz12zz__ft_schedulerz00, BgL_bgl_za762schedulerza7d2r1692z00, va_generic_entry, BGl_z62schedulerzd2reactz12za2zz__ft_schedulerz00, BUNSPEC, -1 );
DEFINE_STRING( BGl_string1670z00zz__ft_schedulerz00, BgL_bgl_string1670za700za7za7_1693za7, "&scheduler-broadcast!", 21 );
DEFINE_STRING( BGl_string1671z00zz__ft_schedulerz00, BgL_bgl_string1671za700za7za7_1694za7, "scheduler-react!", 16 );
DEFINE_STRING( BGl_string1672z00zz__ft_schedulerz00, BgL_bgl_string1672za700za7za7_1695za7, "scheduler-instant", 17 );
DEFINE_STRING( BGl_string1673z00zz__ft_schedulerz00, BgL_bgl_string1673za700za7za7_1696za7, "__ft_scheduler", 14 );
DEFINE_STRING( BGl_string1674z00zz__ft_schedulerz00, BgL_bgl_string1674za700za7za7_1697za7, "scheduler-start! scheduler-react! await dead ready done unattached scheduler fthread*default-scheduler* current-scheduler-set! %current@__ft_scheduler ", 151 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_schedulerzd2broadcastz12zd2envz12zz__ft_schedulerz00, BgL_bgl_za762schedulerza7d2b1698z00, va_generic_entry, BGl_z62schedulerzd2broadcastz12za2zz__ft_schedulerz00, BUNSPEC, -3 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_broadcastz12zd2envzc0zz__ft_schedulerz00, BgL_bgl_za762broadcastza712za71699za7, va_generic_entry, BGl_z62broadcastz12z70zz__ft_schedulerz00, BUNSPEC, -2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_makezd2schedulerzd2envz00zz__ft_schedulerz00, BgL_bgl_za762makeza7d2schedu1700z00, va_generic_entry, BGl_z62makezd2schedulerzb0zz__ft_schedulerz00, BUNSPEC, -1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_currentzd2schedulerzd2setz12zd2envzc0zz__ft_schedulerz00, BgL_bgl_za762currentza7d2sch1701z00, BGl_z62currentzd2schedulerzd2setz12z70zz__ft_schedulerz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1663z00zz__ft_schedulerz00, BgL_bgl_za762za7c3za704anonymo1702za7, BGl_z62zc3z04anonymousza31160ze3ze5zz__ft_schedulerz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1664z00zz__ft_schedulerz00, BgL_bgl_za762za7c3za704anonymo1703za7, BGl_z62zc3z04anonymousza31206ze3ze5zz__ft_schedulerz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1665z00zz__ft_schedulerz00, BgL_bgl_za762za7c3za704anonymo1704za7, BGl_z62zc3z04anonymousza31306ze3ze5zz__ft_schedulerz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_schedulerzd2instantzd2envz00zz__ft_schedulerz00, BgL_bgl_za762schedulerza7d2i1705z00, va_generic_entry, BGl_z62schedulerzd2instantzb0zz__ft_schedulerz00, BUNSPEC, -1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_withzd2schedulerzd2envz00zz__ft_schedulerz00, BgL_bgl_za762withza7d2schedu1706z00, BGl_z62withzd2schedulerzb0zz__ft_schedulerz00, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_currentzd2schedulerzd2envz00zz__ft_schedulerz00, BgL_bgl_za762currentza7d2sch1707z00, BGl_z62currentzd2schedulerzb0zz__ft_schedulerz00, 0L, BUNSPEC, 0 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_schedulerzd2terminatez12zd2envz12zz__ft_schedulerz00, BgL_bgl_za762schedulerza7d2t1708z00, va_generic_entry, BGl_z62schedulerzd2terminatez12za2zz__ft_schedulerz00, BUNSPEC, -1 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__ft_schedulerz00) );
ADD_ROOT( (void *)(&BGl_za2currentzd2schedulerza2zd2zz__ft_schedulerz00) );
ADD_ROOT( (void *)(&BGl_za2currentzd2scdlzd2paramzd2idza2zd2zz__ft_schedulerz00) );
ADD_ROOT( (void *)(&BGl_za2defaultzd2schedulerza2zd2zz__ft_schedulerz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__ft_schedulerz00(long BgL_checksumz00_465, char * BgL_fromz00_466)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__ft_schedulerz00))
{ 
BGl_requirezd2initializa7ationz75zz__ft_schedulerz00 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__ft_schedulerz00(); 
BGl_libraryzd2moduleszd2initz00zz__ft_schedulerz00(); 
BGl_cnstzd2initzd2zz__ft_schedulerz00(); 
BGl_importedzd2moduleszd2initz00zz__ft_schedulerz00(); 
return 
BGl_toplevelzd2initzd2zz__ft_schedulerz00();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__ft_schedulerz00()
{
{ /* Llib/scheduler.scm 15 */
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long)0), "__ft_scheduler"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__ft_scheduler"); 
BGl_modulezd2initializa7ationz75zz__threadz00(((long)0), "__ft_scheduler"); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "__ft_scheduler"); 
BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long)0), "__ft_scheduler"); 
BGl_modulezd2initializa7ationz75zz__bexitz00(((long)0), "__ft_scheduler"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__ft_scheduler"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__ft_scheduler"); 
BGl_modulezd2initializa7ationz75zz__pth_threadz00(((long)0), "__ft_scheduler"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__ft_scheduler"); 
BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)0), "__ft_scheduler"); 
BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long)0), "__ft_scheduler"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__ft_scheduler"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__ft_scheduler"); 
BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(((long)0), "__ft_scheduler"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "__ft_scheduler"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__ft_schedulerz00()
{
{ /* Llib/scheduler.scm 15 */
{ /* Llib/scheduler.scm 15 */
obj_t BgL_cportz00_440;
{ /* Llib/scheduler.scm 15 */
obj_t BgL_stringz00_448;
BgL_stringz00_448 = BGl_string1674z00zz__ft_schedulerz00; 
{ /* Llib/scheduler.scm 15 */
obj_t BgL_startz00_449;
BgL_startz00_449 = 
BINT(((long)0)); 
{ /* Llib/scheduler.scm 15 */
obj_t BgL_endz00_450;
BgL_endz00_450 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_448))); 
{ /* Llib/scheduler.scm 15 */

BgL_cportz00_440 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_448, BgL_startz00_449, BgL_endz00_450); } } } } 
{ 
long BgL_iz00_441;
BgL_iz00_441 = ((long)10); 
BgL_loopz00_442:
if(
(BgL_iz00_441==((long)-1)))
{ /* Llib/scheduler.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/scheduler.scm 15 */
{ /* Llib/scheduler.scm 15 */
obj_t BgL_arg1676z00_444;
{ /* Llib/scheduler.scm 15 */

{ /* Llib/scheduler.scm 15 */
obj_t BgL_locationz00_446;
BgL_locationz00_446 = 
BBOOL(((bool_t)0)); 
{ /* Llib/scheduler.scm 15 */

BgL_arg1676z00_444 = 
BGl_readz00zz__readerz00(BgL_cportz00_440, BgL_locationz00_446); } } } 
{ /* Llib/scheduler.scm 15 */
int BgL_tmpz00_500;
BgL_tmpz00_500 = 
(int)(BgL_iz00_441); 
CNST_TABLE_SET(BgL_tmpz00_500, BgL_arg1676z00_444); } } 
{ /* Llib/scheduler.scm 15 */
int BgL_auxz00_447;
BgL_auxz00_447 = 
(int)(
(BgL_iz00_441-((long)1))); 
{ 
long BgL_iz00_505;
BgL_iz00_505 = 
(long)(BgL_auxz00_447); 
BgL_iz00_441 = BgL_iz00_505; 
goto BgL_loopz00_442;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__ft_schedulerz00()
{
{ /* Llib/scheduler.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__ft_schedulerz00()
{
{ /* Llib/scheduler.scm 15 */
BGl_modulezd2initializa7ationz75zz__pth_threadz00(((long)0), 
BSTRING_TO_STRING(BGl_string1655z00zz__ft_schedulerz00)); 
BGl_za2currentzd2schedulerza2zd2zz__ft_schedulerz00 = BFALSE; 
BGl_za2defaultzd2schedulerza2zd2zz__ft_schedulerz00 = BFALSE; 
return ( 
BGl_za2currentzd2scdlzd2paramzd2idza2zd2zz__ft_schedulerz00 = 
CNST_TABLE_REF(((long)0)), BUNSPEC) ;} 

}



/* append-21010 */
obj_t BGl_appendzd221010zd2zz__ft_schedulerz00(obj_t BgL_l1z00_1, obj_t BgL_l2z00_2)
{
{ 
{ 
obj_t BgL_headz00_20;
BgL_headz00_20 = 
MAKE_YOUNG_PAIR(BNIL, BgL_l2z00_2); 
{ 
obj_t BgL_prevz00_21;obj_t BgL_tailz00_22;
BgL_prevz00_21 = BgL_headz00_20; 
BgL_tailz00_22 = BgL_l1z00_1; 
BgL_loopz00_23:
if(
PAIRP(BgL_tailz00_22))
{ 
obj_t BgL_newzd2prevzd2_25;
BgL_newzd2prevzd2_25 = 
MAKE_YOUNG_PAIR(
CAR(BgL_tailz00_22), BgL_l2z00_2); 
SET_CDR(BgL_prevz00_21, BgL_newzd2prevzd2_25); 
{ 
obj_t BgL_tailz00_518;obj_t BgL_prevz00_517;
BgL_prevz00_517 = BgL_newzd2prevzd2_25; 
BgL_tailz00_518 = 
CDR(BgL_tailz00_22); 
BgL_tailz00_22 = BgL_tailz00_518; 
BgL_prevz00_21 = BgL_prevz00_517; 
goto BgL_loopz00_23;} }  else 
{ BNIL; } 
return 
CDR(BgL_headz00_20);} } } 

}



/* current-scheduler */
BGL_EXPORTED_DEF obj_t BGl_currentzd2schedulerzd2zz__ft_schedulerz00()
{
{ /* Llib/scheduler.scm 53 */
{ /* Llib/scheduler.scm 54 */
obj_t BgL_thz00_28;
BgL_thz00_28 = 
BGl_currentzd2threadzd2zz__threadz00(); 
if(
BGl_isazf3zf3zz__objectz00(BgL_thz00_28, BGl_schedulerz00zz__ft_typesz00))
{ /* Llib/scheduler.scm 56 */
return BgL_thz00_28;}  else 
{ /* Llib/scheduler.scm 56 */
if(
BGl_isazf3zf3zz__objectz00(BgL_thz00_28, BGl_fthreadz00zz__ft_typesz00))
{ /* Llib/scheduler.scm 58 */
return 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_thz00_28)))->BgL_schedulerz00);}  else 
{ /* Llib/scheduler.scm 58 */
if(
BGl_isazf3zf3zz__objectz00(BgL_thz00_28, BGl_threadz00zz__threadz00))
{ /* Llib/scheduler.scm 60 */
return 
BGl_threadzd2parameterzd2zz__threadz00(
CNST_TABLE_REF(((long)0)));}  else 
{ /* Llib/scheduler.scm 60 */
return BGl_za2currentzd2schedulerza2zd2zz__ft_schedulerz00;} } } } } 

}



/* &current-scheduler */
obj_t BGl_z62currentzd2schedulerzb0zz__ft_schedulerz00(obj_t BgL_envz00_367)
{
{ /* Llib/scheduler.scm 53 */
return 
BGl_currentzd2schedulerzd2zz__ft_schedulerz00();} 

}



/* current-scheduler-set! */
BGL_EXPORTED_DEF obj_t BGl_currentzd2schedulerzd2setz12z12zz__ft_schedulerz00(obj_t BgL_scdlz00_3)
{
{ /* Llib/scheduler.scm 65 */
{ /* Llib/scheduler.scm 66 */
obj_t BgL_thz00_33;
BgL_thz00_33 = 
BGl_currentzd2threadzd2zz__threadz00(); 
if(
BGl_isazf3zf3zz__objectz00(BgL_thz00_33, BGl_fthreadz00zz__ft_typesz00))
{ /* Llib/scheduler.scm 68 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)1)), BGl_string1656z00zz__ft_schedulerz00, BgL_thz00_33);}  else 
{ /* Llib/scheduler.scm 68 */
if(
BGl_isazf3zf3zz__objectz00(BgL_thz00_33, BGl_threadz00zz__threadz00))
{ /* Llib/scheduler.scm 70 */
return 
BGl_threadzd2parameterzd2setz12z12zz__threadz00(
CNST_TABLE_REF(((long)0)), BgL_scdlz00_3);}  else 
{ /* Llib/scheduler.scm 70 */
return ( 
BGl_za2currentzd2schedulerza2zd2zz__ft_schedulerz00 = BgL_scdlz00_3, BUNSPEC) ;} } } } 

}



/* &current-scheduler-set! */
obj_t BGl_z62currentzd2schedulerzd2setz12z70zz__ft_schedulerz00(obj_t BgL_envz00_368, obj_t BgL_scdlz00_369)
{
{ /* Llib/scheduler.scm 65 */
return 
BGl_currentzd2schedulerzd2setz12z12zz__ft_schedulerz00(BgL_scdlz00_369);} 

}



/* default-scheduler */
BGL_EXPORTED_DEF obj_t BGl_defaultzd2schedulerzd2zz__ft_schedulerz00(obj_t BgL_scdlz00_4)
{
{ /* Llib/scheduler.scm 78 */
{ /* Llib/scheduler.scm 79 */
obj_t BgL_thz00_36;
BgL_thz00_36 = 
BGl_currentzd2threadzd2zz__threadz00(); 
if(
BGl_isazf3zf3zz__objectz00(BgL_thz00_36, BGl_fthreadz00zz__ft_typesz00))
{ /* Llib/scheduler.scm 83 */
obj_t BgL_sz00_38;
if(
BGl_isazf3zf3zz__objectz00(BgL_thz00_36, BGl_schedulerz00zz__ft_typesz00))
{ /* Llib/scheduler.scm 83 */
BgL_sz00_38 = BgL_thz00_36; }  else 
{ /* Llib/scheduler.scm 85 */
BgL_fthreadz00_bglt BgL_i1063z00_42;
BgL_i1063z00_42 = 
((BgL_fthreadz00_bglt)BgL_thz00_36); 
BgL_sz00_38 = 
(((BgL_fthreadz00_bglt)COBJECT(BgL_i1063z00_42))->BgL_schedulerz00); } 
{ /* Llib/scheduler.scm 87 */
BgL_z52pthreadz52_bglt BgL_i1065z00_40;
BgL_i1065z00_40 = 
((BgL_z52pthreadz52_bglt)
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_sz00_38)))->BgL_z52builtinz52)); 
BgL_thz00_36 = 
(((BgL_z52pthreadz52_bglt)COBJECT(BgL_i1065z00_40))->BgL_parentz00); } }  else 
{ /* Llib/scheduler.scm 82 */BFALSE; } 
if(
NULLP(BgL_scdlz00_4))
{ /* Llib/scheduler.scm 91 */
if(
BGl_isazf3zf3zz__objectz00(BgL_thz00_36, BGl_threadz00zz__threadz00))
{ /* Llib/scheduler.scm 92 */
return 
BGl_threadzd2parameterzd2zz__threadz00(
CNST_TABLE_REF(((long)2)));}  else 
{ /* Llib/scheduler.scm 92 */
return BGl_za2defaultzd2schedulerza2zd2zz__ft_schedulerz00;} }  else 
{ /* Llib/scheduler.scm 95 */
bool_t BgL_test1728z00_560;
{ /* Llib/scheduler.scm 95 */
obj_t BgL_arg1140z00_50;
BgL_arg1140z00_50 = 
CAR(
((obj_t)BgL_scdlz00_4)); 
BgL_test1728z00_560 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1140z00_50, BGl_schedulerz00zz__ft_typesz00); } 
if(BgL_test1728z00_560)
{ /* Llib/scheduler.scm 95 */
if(
BGl_isazf3zf3zz__objectz00(BgL_thz00_36, BGl_threadz00zz__threadz00))
{ /* Llib/scheduler.scm 97 */
obj_t BgL_arg1136z00_48;
BgL_arg1136z00_48 = 
CAR(
((obj_t)BgL_scdlz00_4)); 
BGl_threadzd2parameterzd2setz12z12zz__threadz00(
CNST_TABLE_REF(((long)2)), BgL_arg1136z00_48); }  else 
{ /* Llib/scheduler.scm 96 */
BGl_za2defaultzd2schedulerza2zd2zz__ft_schedulerz00 = 
CAR(
((obj_t)BgL_scdlz00_4)); } 
return 
CAR(
((obj_t)BgL_scdlz00_4));}  else 
{ /* Llib/scheduler.scm 101 */
obj_t BgL_arg1138z00_49;
BgL_arg1138z00_49 = 
CAR(
((obj_t)BgL_scdlz00_4)); 
return 
BGl_errorz00zz__errorz00(BGl_string1657z00zz__ft_schedulerz00, BGl_string1658z00zz__ft_schedulerz00, BgL_arg1138z00_49);} } } } 

}



/* &default-scheduler */
obj_t BGl_z62defaultzd2schedulerzb0zz__ft_schedulerz00(obj_t BgL_envz00_370, obj_t BgL_scdlz00_371)
{
{ /* Llib/scheduler.scm 78 */
return 
BGl_defaultzd2schedulerzd2zz__ft_schedulerz00(BgL_scdlz00_371);} 

}



/* with-scheduler */
BGL_EXPORTED_DEF obj_t BGl_withzd2schedulerzd2zz__ft_schedulerz00(BgL_schedulerz00_bglt BgL_sz00_5, obj_t BgL_thunkz00_6)
{
{ /* Llib/scheduler.scm 106 */
{ /* Llib/scheduler.scm 107 */
obj_t BgL_oldz00_51;
BgL_oldz00_51 = 
BGl_defaultzd2schedulerzd2zz__ft_schedulerz00(BNIL); 
{ /* Llib/scheduler.scm 108 */
obj_t BgL_exitd1066z00_52;
BgL_exitd1066z00_52 = 
BGL_EXITD_TOP_AS_OBJ(); 
{ /* Llib/scheduler.scm 112 */
obj_t BgL_zc3z04anonymousza31142ze3z87_372;
BgL_zc3z04anonymousza31142ze3z87_372 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31142ze3ze5zz__ft_schedulerz00, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31142ze3z87_372, 
(int)(((long)0)), BgL_oldz00_51); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1066z00_52, BgL_zc3z04anonymousza31142ze3z87_372); 
{ /* Llib/scheduler.scm 110 */
obj_t BgL_tmp1068z00_54;
{ /* Llib/scheduler.scm 110 */
obj_t BgL_list1141z00_55;
BgL_list1141z00_55 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_sz00_5), BNIL); 
BGl_defaultzd2schedulerzd2zz__ft_schedulerz00(BgL_list1141z00_55); } 
BgL_tmp1068z00_54 = 
PROCEDURE_ENTRY(BgL_thunkz00_6)(BgL_thunkz00_6, BEOA); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1066z00_52); 
{ /* Llib/scheduler.scm 112 */
obj_t BgL_list1143z00_289;
BgL_list1143z00_289 = 
MAKE_YOUNG_PAIR(BgL_oldz00_51, BNIL); 
BGl_defaultzd2schedulerzd2zz__ft_schedulerz00(BgL_list1143z00_289); } 
return BgL_tmp1068z00_54;} } } } } 

}



/* &with-scheduler */
obj_t BGl_z62withzd2schedulerzb0zz__ft_schedulerz00(obj_t BgL_envz00_373, obj_t BgL_sz00_374, obj_t BgL_thunkz00_375)
{
{ /* Llib/scheduler.scm 106 */
{ /* Llib/scheduler.scm 107 */
obj_t BgL_auxz00_603;BgL_schedulerz00_bglt BgL_auxz00_595;
if(
PROCEDUREP(BgL_thunkz00_375))
{ /* Llib/scheduler.scm 107 */
BgL_auxz00_603 = BgL_thunkz00_375
; }  else 
{ 
obj_t BgL_auxz00_606;
BgL_auxz00_606 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1659z00zz__ft_schedulerz00, 
BINT(((long)3989)), BGl_string1660z00zz__ft_schedulerz00, BGl_string1662z00zz__ft_schedulerz00, BgL_thunkz00_375); 
FAILURE(BgL_auxz00_606,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_sz00_374, BGl_schedulerz00zz__ft_typesz00))
{ /* Llib/scheduler.scm 107 */
BgL_auxz00_595 = 
((BgL_schedulerz00_bglt)BgL_sz00_374)
; }  else 
{ 
obj_t BgL_auxz00_599;
BgL_auxz00_599 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1659z00zz__ft_schedulerz00, 
BINT(((long)3989)), BGl_string1660z00zz__ft_schedulerz00, BGl_string1661z00zz__ft_schedulerz00, BgL_sz00_374); 
FAILURE(BgL_auxz00_599,BFALSE,BFALSE);} 
return 
BGl_withzd2schedulerzd2zz__ft_schedulerz00(BgL_auxz00_595, BgL_auxz00_603);} } 

}



/* &<@anonymous:1142> */
obj_t BGl_z62zc3z04anonymousza31142ze3ze5zz__ft_schedulerz00(obj_t BgL_envz00_376)
{
{ /* Llib/scheduler.scm 108 */
{ /* Llib/scheduler.scm 112 */
obj_t BgL_oldz00_377;
BgL_oldz00_377 = 
PROCEDURE_REF(BgL_envz00_376, 
(int)(((long)0))); 
{ /* Llib/scheduler.scm 112 */
obj_t BgL_list1143z00_453;
BgL_list1143z00_453 = 
MAKE_YOUNG_PAIR(BgL_oldz00_377, BNIL); 
return 
BGl_defaultzd2schedulerzd2zz__ft_schedulerz00(BgL_list1143z00_453);} } } 

}



/* make-scheduler */
BGL_EXPORTED_DEF BgL_schedulerz00_bglt BGl_makezd2schedulerzd2zz__ft_schedulerz00(obj_t BgL_argsz00_7)
{
{ /* Llib/scheduler.scm 117 */
{ /* Llib/scheduler.scm 119 */
obj_t BgL_idz00_60;
BgL_idz00_60 = 
BGl_gensymz00zz__r4_symbols_6_4z00(
CNST_TABLE_REF(((long)3))); 
{ /* Llib/scheduler.scm 119 */
bool_t BgL_orderzd2setzf3z21_61;
if(
PAIRP(BgL_argsz00_7))
{ /* Llib/scheduler.scm 120 */
obj_t BgL_tmpz00_619;
BgL_tmpz00_619 = 
CAR(BgL_argsz00_7); 
BgL_orderzd2setzf3z21_61 = 
BOOLEANP(BgL_tmpz00_619); }  else 
{ /* Llib/scheduler.scm 120 */
BgL_orderzd2setzf3z21_61 = ((bool_t)0); } 
{ /* Llib/scheduler.scm 120 */
obj_t BgL_orderz00_62;
if(BgL_orderzd2setzf3z21_61)
{ /* Llib/scheduler.scm 121 */
BgL_orderz00_62 = 
CAR(BgL_argsz00_7); }  else 
{ /* Llib/scheduler.scm 121 */
BgL_orderz00_62 = BFALSE; } 
{ /* Llib/scheduler.scm 121 */
obj_t BgL_envsz00_63;
if(BgL_orderzd2setzf3z21_61)
{ /* Llib/scheduler.scm 122 */
BgL_envsz00_63 = 
CDR(BgL_argsz00_7); }  else 
{ /* Llib/scheduler.scm 122 */
BgL_envsz00_63 = BgL_argsz00_7; } 
{ /* Llib/scheduler.scm 122 */

{ /* Llib/scheduler.scm 123 */
obj_t BgL_sz00_387;
BgL_sz00_387 = 
MAKE_CELL(BUNSPEC); 
{ /* Llib/scheduler.scm 123 */
BgL_z52schedulerz52_bglt BgL_g1169z00_86;
{ /* Llib/scheduler.scm 123 */
BgL_z52schedulerz52_bglt BgL_new1071z00_70;
{ /* Llib/scheduler.scm 125 */
BgL_z52schedulerz52_bglt BgL_new1070z00_84;
BgL_new1070z00_84 = 
((BgL_z52schedulerz52_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52schedulerz52_bgl) ))); 
{ /* Llib/scheduler.scm 125 */
long BgL_arg1167z00_85;
{ /* Llib/scheduler.scm 125 */
long BgL_res1621z00_296;
BgL_res1621z00_296 = 
BGL_CLASS_INDEX(BGl_z52schedulerz52zz__ft_z52typesz52); 
BgL_arg1167z00_85 = BgL_res1621z00_296; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1070z00_84), BgL_arg1167z00_85); } 
BgL_new1071z00_70 = BgL_new1070z00_84; } 
((((BgL_threadz00_bglt)COBJECT(
((BgL_threadz00_bglt)BgL_new1071z00_70)))->BgL_namez00)=((obj_t)BgL_idz00_60),BUNSPEC); 
((((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_new1071z00_70)))->BgL_schedulerz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_new1071z00_70)))->BgL_z52builtinz52)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_new1071z00_70)))->BgL_z52timeoutz52)=((int)
(int)(((long)1))),BUNSPEC); 
((((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_new1071z00_70)))->BgL_z52statez52)=((obj_t)
CNST_TABLE_REF(((long)4))),BUNSPEC); 
((((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_new1071z00_70)))->BgL_z52iszd2suspendz80)=((bool_t)((bool_t)0)),BUNSPEC); 
{ 
obj_t BgL_auxz00_644;
{ /* Llib/types.scm 28 */
obj_t BgL_arg1152z00_71;
{ /* Llib/types.scm 28 */
obj_t BgL_arg1154z00_72;
{ /* Llib/types.scm 28 */
obj_t BgL_res1622z00_300;
{ /* Llib/types.scm 28 */
obj_t BgL_classz00_299;
BgL_classz00_299 = BGl_z52schedulerz52zz__ft_z52typesz52; 
BgL_res1622z00_300 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_299); } 
BgL_arg1154z00_72 = BgL_res1622z00_300; } 
BgL_arg1152z00_71 = 
VECTOR_REF(BgL_arg1154z00_72,((long)8)); } 
BgL_auxz00_644 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1152z00_71); } 
((((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_new1071z00_70)))->BgL_z52terminatez52)=((obj_t)BgL_auxz00_644),BUNSPEC); } 
((((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_new1071z00_70)))->BgL_z52resultz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_new1071z00_70)))->BgL_z52exczd2resultz80)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_new1071z00_70)))->BgL_z52exczd2raisedz80)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_new1071z00_70)))->BgL_z52identz52)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_new1071z00_70)))->BgL_z52signalsz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_new1071z00_70)))->BgL_z52awakezd2signalz80)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_new1071z00_70)))->BgL_z52awakezd2valuez80)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_new1071z00_70)))->BgL_z52cleanupz52)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_new1071z00_70)))->BgL_z52specificz52)=((obj_t)BUNSPEC),BUNSPEC); 
{ 
obj_t BgL_auxz00_669;
{ /* Llib/scheduler.scm 124 */
obj_t BgL_zc3z04anonymousza31155ze3z87_379;
BgL_zc3z04anonymousza31155ze3z87_379 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31155ze3ze5zz__ft_schedulerz00, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31155ze3z87_379, 
(int)(((long)0)), 
((obj_t)BgL_sz00_387)); 
BgL_auxz00_669 = BgL_zc3z04anonymousza31155ze3z87_379; } 
((((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_new1071z00_70)))->BgL_bodyz00)=((obj_t)BgL_auxz00_669),BUNSPEC); } 
{ 
obj_t BgL_auxz00_678;
{ /* Llib/scheduler.scm 126 */
obj_t BgL_arg1156z00_74;
{ /* Llib/scheduler.scm 126 */
BgL_z52envz52_bglt BgL_arg1157z00_75;
{ /* Llib/scheduler.scm 126 */
BgL_z52envz52_bglt BgL_new1073z00_77;
{ /* Llib/_env.scm 25 */
BgL_z52envz52_bglt BgL_new1072z00_78;
BgL_new1072z00_78 = 
((BgL_z52envz52_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52envz52_bgl) ))); 
{ /* Llib/_env.scm 25 */
long BgL_arg1159z00_79;
{ /* Llib/_env.scm 25 */
long BgL_res1623z00_303;
{ /* Llib/_env.scm 25 */
obj_t BgL_classz00_302;
BgL_classz00_302 = BGl_z52envz52zz__ft_z52envz52; 
BgL_res1623z00_303 = 
BGL_CLASS_INDEX(BgL_classz00_302); } 
BgL_arg1159z00_79 = BgL_res1623z00_303; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1072z00_78), BgL_arg1159z00_79); } 
BgL_new1073z00_77 = BgL_new1072z00_78; } 
((((BgL_ftenvz00_bglt)COBJECT(
((BgL_ftenvz00_bglt)BgL_new1073z00_77)))->BgL_instantz00)=((long)((long)0)),BUNSPEC); 
((((BgL_z52envz52_bglt)COBJECT(BgL_new1073z00_77))->BgL_z52signalsz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_z52envz52_bglt)COBJECT(BgL_new1073z00_77))->BgL_z52lastzd2signalsz80)=((obj_t)BNIL),BUNSPEC); 
BgL_arg1157z00_75 = BgL_new1073z00_77; } 
{ /* Llib/scheduler.scm 126 */
obj_t BgL_list1158z00_76;
BgL_list1158z00_76 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1157z00_75), BNIL); 
BgL_arg1156z00_74 = BgL_list1158z00_76; } } 
BgL_auxz00_678 = 
BGl_appendzd221010zd2zz__ft_schedulerz00(BgL_envsz00_63, BgL_arg1156z00_74); } 
((((BgL_schedulerz00_bglt)COBJECT(
((BgL_schedulerz00_bglt)BgL_new1071z00_70)))->BgL_envzb2zb2)=((obj_t)BgL_auxz00_678),BUNSPEC); } 
((((BgL_schedulerz00_bglt)COBJECT(
((BgL_schedulerz00_bglt)BgL_new1071z00_70)))->BgL_strictzd2orderzf3z21)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_new1071z00_70))->BgL_nextzd2instantzd2)=((obj_t)BGl_proc1663z00zz__ft_schedulerz00),BUNSPEC); 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_new1071z00_70))->BgL_currentzd2threadzd2)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_new1071z00_70))->BgL_z52livezd2threadzd2numberz52)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_new1071z00_70))->BgL_z52threadszd2readyz80)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_new1071z00_70))->BgL_threadszd2runnablezd2)=((obj_t)BNIL),BUNSPEC); 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_new1071z00_70))->BgL_threadszd2runnablezd2lastzd2pairzd2)=((obj_t)BNIL),BUNSPEC); 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_new1071z00_70))->BgL_asynczd2runnablezd2)=((obj_t)BNIL),BUNSPEC); 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_new1071z00_70))->BgL_threadszd2timeoutzd2)=((obj_t)BNIL),BUNSPEC); 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_new1071z00_70))->BgL_threadszd2yieldzd2)=((obj_t)BNIL),BUNSPEC); 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_new1071z00_70))->BgL_tostartz00)=((obj_t)BNIL),BUNSPEC); 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_new1071z00_70))->BgL_toterminatez00)=((obj_t)BNIL),BUNSPEC); 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_new1071z00_70))->BgL_tosuspendzf2resumezf2)=((obj_t)BNIL),BUNSPEC); 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_new1071z00_70))->BgL_tobroadcastz00)=((obj_t)BNIL),BUNSPEC); 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_new1071z00_70))->BgL_tospawnz00)=((obj_t)BNIL),BUNSPEC); 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_new1071z00_70))->BgL_currentzd2tokenzd2)=((obj_t)BFALSE),BUNSPEC); 
{ /* Llib/scheduler.scm 123 */
obj_t BgL_fun1161z00_83;
BgL_fun1161z00_83 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_z52schedulerz52zz__ft_z52typesz52); 
PROCEDURE_ENTRY(BgL_fun1161z00_83)(BgL_fun1161z00_83, 
((obj_t)BgL_new1071z00_70), BEOA); } 
BgL_g1169z00_86 = BgL_new1071z00_70; } 
CELL_SET(BgL_sz00_387, 
((obj_t)BgL_g1169z00_86)); 
{ /* Llib/scheduler.scm 130 */
BgL_z52schedulerz52_bglt BgL_i1074z00_65;
BgL_i1074z00_65 = 
((BgL_z52schedulerz52_bglt)
((BgL_z52schedulerz52_bglt)
CELL_REF(BgL_sz00_387))); 
((((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_i1074z00_65)))->BgL_z52builtinz52)=((obj_t)
BGl_z52fschedulerzd2newz80zz__ft_z52pthreadz52(
((BgL_z52schedulerz52_bglt)
((BgL_z52schedulerz52_bglt)
CELL_REF(BgL_sz00_387))))),BUNSPEC); 
((((BgL_schedulerz00_bglt)COBJECT(
((BgL_schedulerz00_bglt)BgL_i1074z00_65)))->BgL_strictzd2orderzf3z21)=((obj_t)BgL_orderz00_62),BUNSPEC); } 
if(
CBOOL(
BGl_defaultzd2schedulerzd2zz__ft_schedulerz00(BNIL)))
{ /* Llib/scheduler.scm 134 */BFALSE; }  else 
{ /* Llib/scheduler.scm 134 */
obj_t BgL_list1147z00_68;
BgL_list1147z00_68 = 
MAKE_YOUNG_PAIR(
CELL_REF(BgL_sz00_387), BNIL); 
BGl_defaultzd2schedulerzd2zz__ft_schedulerz00(BgL_list1147z00_68); } 
return 
((BgL_schedulerz00_bglt)
((BgL_schedulerz00_bglt)
CELL_REF(BgL_sz00_387)));} } } } } } } } 

}



/* &make-scheduler */
BgL_schedulerz00_bglt BGl_z62makezd2schedulerzb0zz__ft_schedulerz00(obj_t BgL_envz00_380, obj_t BgL_argsz00_381)
{
{ /* Llib/scheduler.scm 117 */
return 
BGl_makezd2schedulerzd2zz__ft_schedulerz00(BgL_argsz00_381);} 

}



/* &<@anonymous:1160> */
obj_t BGl_z62zc3z04anonymousza31160ze3ze5zz__ft_schedulerz00(obj_t BgL_envz00_382, obj_t BgL_sz00_383, obj_t BgL_iz00_384)
{
{ /* Llib/_types.scm 23 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1155> */
obj_t BGl_z62zc3z04anonymousza31155ze3ze5zz__ft_schedulerz00(obj_t BgL_envz00_385)
{
{ /* Llib/scheduler.scm 124 */
{ /* Llib/scheduler.scm 124 */
obj_t BgL_sz00_386;
BgL_sz00_386 = 
PROCEDURE_REF(BgL_envz00_385, 
(int)(((long)0))); 
return 
BGl_schedulez00zz__ft_schedulerz00(
((BgL_z52schedulerz52_bglt)
((BgL_z52schedulerz52_bglt)
CELL_REF(BgL_sz00_386))));} } 

}



/* scheduler-state */
obj_t BGl_schedulerzd2statezd2zz__ft_schedulerz00(BgL_schedulerz00_bglt BgL_sz00_8)
{
{ /* Llib/scheduler.scm 141 */
if(
(
(long)(
(((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_sz00_8)))->BgL_z52livezd2threadzd2numberz52))==((long)0)))
{ /* Llib/scheduler.scm 149 */
return 
CNST_TABLE_REF(((long)5));}  else 
{ /* Llib/scheduler.scm 151 */
bool_t BgL_test1737z00_746;
if(
(((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_sz00_8)))->BgL_z52threadszd2readyz80))
{ /* Llib/scheduler.scm 151 */
BgL_test1737z00_746 = ((bool_t)1)
; }  else 
{ /* Llib/scheduler.scm 151 */
if(
NULLP(
(((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_sz00_8)))->BgL_tostartz00)))
{ /* Llib/scheduler.scm 152 */
if(
NULLP(
(((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_sz00_8)))->BgL_toterminatez00)))
{ /* Llib/scheduler.scm 154 */
obj_t BgL_tmpz00_758;
BgL_tmpz00_758 = 
(((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_sz00_8)))->BgL_tosuspendzf2resumezf2); 
BgL_test1737z00_746 = 
PAIRP(BgL_tmpz00_758); }  else 
{ /* Llib/scheduler.scm 153 */
BgL_test1737z00_746 = ((bool_t)1)
; } }  else 
{ /* Llib/scheduler.scm 152 */
BgL_test1737z00_746 = ((bool_t)1)
; } } 
if(BgL_test1737z00_746)
{ /* Llib/scheduler.scm 151 */
return 
CNST_TABLE_REF(((long)6));}  else 
{ /* Llib/scheduler.scm 151 */
if(
BGl_z52threadzd2iszd2deadz52zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_sz00_8), BNIL))
{ /* Llib/scheduler.scm 157 */
return 
CNST_TABLE_REF(((long)7));}  else 
{ /* Llib/scheduler.scm 157 */
return 
CNST_TABLE_REF(((long)8));} } } } 

}



/* schedule */
obj_t BGl_schedulez00zz__ft_schedulerz00(BgL_z52schedulerz52_bglt BgL_scdlz00_9)
{
{ /* Llib/scheduler.scm 168 */
{ /* Llib/scheduler.scm 172 */
obj_t BgL_g1078z00_112;
BgL_g1078z00_112 = 
BGl_z52schedulerzd2timez80zz__ft_z52schedulerz52(
((BgL_schedulerz00_bglt)BgL_scdlz00_9)); 
{ 
obj_t BgL_iz00_114;
BgL_iz00_114 = BgL_g1078z00_112; 
BgL_zc3z04anonymousza31199ze3z87_115:
BGl_z52schedulezd2instantz80zz__ft_z52schedulerz52(BgL_scdlz00_9); 
{ /* Llib/scheduler.scm 174 */
bool_t BgL_test1742z00_771;
{ /* Llib/scheduler.scm 174 */
obj_t BgL_fun1205z00_119;
BgL_fun1205z00_119 = 
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_9))->BgL_nextzd2instantzd2); 
BgL_test1742z00_771 = 
CBOOL(
PROCEDURE_ENTRY(BgL_fun1205z00_119)(BgL_fun1205z00_119, 
((obj_t)BgL_scdlz00_9), BgL_iz00_114, BEOA)); } 
if(BgL_test1742z00_771)
{ /* Llib/scheduler.scm 175 */
long BgL_arg1204z00_118;
BgL_arg1204z00_118 = 
(
(long)CINT(BgL_iz00_114)+((long)1)); 
{ 
obj_t BgL_iz00_782;
BgL_iz00_782 = 
BINT(BgL_arg1204z00_118); 
BgL_iz00_114 = BgL_iz00_782; 
goto BgL_zc3z04anonymousza31199ze3z87_115;} }  else 
{ /* Llib/scheduler.scm 174 */((bool_t)0); } } } } 
return BUNSPEC;} 

}



/* scheduler-react! */
BGL_EXPORTED_DEF obj_t BGl_schedulerzd2reactz12zc0zz__ft_schedulerz00(obj_t BgL_oz00_10)
{
{ /* Llib/scheduler.scm 184 */
{ /* Llib/scheduler.scm 185 */
BgL_schedulerz00_bglt BgL_scdlz00_121;
BgL_scdlz00_121 = 
BGl_z52getzd2optionalzd2schedulerz52zz__ft_z52schedulerz52(
CNST_TABLE_REF(((long)9)), BgL_oz00_10); 
((((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_121)))->BgL_nextzd2instantzd2)=((obj_t)BGl_proc1664z00zz__ft_schedulerz00),BUNSPEC); 
{ /* Llib/scheduler.scm 193 */
obj_t BgL_arg1219z00_129;
BgL_arg1219z00_129 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_scdlz00_121)))->BgL_z52builtinz52); 
BGl_z52pthreadzd2enterzd2schedulerz52zz__ft_z52pthreadz52(
((BgL_z52pthreadz52_bglt)BgL_arg1219z00_129)); } 
return 
BGl_schedulerzd2statezd2zz__ft_schedulerz00(BgL_scdlz00_121);} } 

}



/* &scheduler-react! */
obj_t BGl_z62schedulerzd2reactz12za2zz__ft_schedulerz00(obj_t BgL_envz00_391, obj_t BgL_oz00_392)
{
{ /* Llib/scheduler.scm 184 */
return 
BGl_schedulerzd2reactz12zc0zz__ft_schedulerz00(BgL_oz00_392);} 

}



/* &<@anonymous:1206> */
obj_t BGl_z62zc3z04anonymousza31206ze3ze5zz__ft_schedulerz00(obj_t BgL_envz00_393, obj_t BgL_scdlz00_394, obj_t BgL_iz00_395)
{
{ /* Llib/scheduler.scm 188 */
{ /* Llib/scheduler.scm 190 */
obj_t BgL_arg1217z00_454;
BgL_arg1217z00_454 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)
((BgL_schedulerz00_bglt)BgL_scdlz00_394))))->BgL_z52builtinz52); 
return 
BGl_z52pthreadzd2leavezd2schedulerz52zz__ft_z52pthreadz52(
((BgL_z52pthreadz52_bglt)BgL_arg1217z00_454));} } 

}



/* scheduler-start! */
BGL_EXPORTED_DEF obj_t BGl_schedulerzd2startz12zc0zz__ft_schedulerz00(obj_t BgL_argsz00_11)
{
{ /* Llib/scheduler.scm 200 */
{ /* Llib/scheduler.scm 201 */
bool_t BgL_iterpz00_130;
if(
PAIRP(BgL_argsz00_11))
{ /* Llib/scheduler.scm 201 */
BgL_iterpz00_130 = 
BGl_numberzf3zf3zz__r4_numbers_6_5z00(
CAR(BgL_argsz00_11)); }  else 
{ /* Llib/scheduler.scm 201 */
BgL_iterpz00_130 = ((bool_t)0); } 
{ /* Llib/scheduler.scm 201 */
obj_t BgL_scdlz00_131;
if(
NULLP(BgL_argsz00_11))
{ /* Llib/scheduler.scm 202 */
BgL_scdlz00_131 = 
BGl_defaultzd2schedulerzd2zz__ft_schedulerz00(BNIL); }  else 
{ /* Llib/scheduler.scm 204 */
obj_t BgL_arg1487z00_196;
BgL_arg1487z00_196 = 
CDR(
((obj_t)BgL_argsz00_11)); 
BgL_scdlz00_131 = 
((obj_t)
BGl_z52getzd2optionalzd2schedulerz52zz__ft_z52schedulerz52(
CNST_TABLE_REF(((long)10)), BgL_arg1487z00_196)); } 
{ /* Llib/scheduler.scm 202 */
obj_t BgL_stopz00_132;
if(
NULLP(BgL_argsz00_11))
{ /* Llib/scheduler.scm 206 */
BgL_stopz00_132 = BGl_proc1665z00zz__ft_schedulerz00; }  else 
{ /* Llib/scheduler.scm 209 */
bool_t BgL_test1746z00_813;
{ /* Llib/scheduler.scm 209 */
obj_t BgL_arg1481z00_193;
BgL_arg1481z00_193 = 
CAR(
((obj_t)BgL_argsz00_11)); 
BgL_test1746z00_813 = 
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_arg1481z00_193); } 
if(BgL_test1746z00_813)
{ /* Llib/scheduler.scm 210 */
obj_t BgL_stz00_181;
{ /* Llib/scheduler.scm 210 */
obj_t BgL_arg1388z00_184;obj_t BgL_arg1389z00_185;
BgL_arg1388z00_184 = 
CAR(
((obj_t)BgL_argsz00_11)); 
{ /* Llib/scheduler.scm 210 */
obj_t BgL_arg1470z00_186;
BgL_arg1470z00_186 = 
BGl_z52schedulerzd2timez80zz__ft_z52schedulerz52(
((BgL_schedulerz00_bglt)BgL_scdlz00_131)); 
BgL_arg1389z00_185 = 
BGl_2zb2zb2zz__r4_numbers_6_5z00(BgL_arg1470z00_186, 
BINT(((long)-1))); } 
BgL_stz00_181 = 
BGl_2zb2zb2zz__r4_numbers_6_5z00(BgL_arg1388z00_184, BgL_arg1389z00_185); } 
{ /* Llib/scheduler.scm 211 */
obj_t BgL_zc3z04anonymousza31349ze3z87_399;
BgL_zc3z04anonymousza31349ze3z87_399 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31349ze3ze5zz__ft_schedulerz00, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31349ze3z87_399, 
(int)(((long)0)), BgL_stz00_181); 
BgL_stopz00_132 = BgL_zc3z04anonymousza31349ze3z87_399; } }  else 
{ /* Llib/scheduler.scm 213 */
bool_t BgL_test1747z00_829;
{ /* Llib/scheduler.scm 213 */
obj_t BgL_tmpz00_830;
BgL_tmpz00_830 = 
CAR(
((obj_t)BgL_argsz00_11)); 
BgL_test1747z00_829 = 
PROCEDUREP(BgL_tmpz00_830); } 
if(BgL_test1747z00_829)
{ /* Llib/scheduler.scm 214 */
obj_t BgL_zc3z04anonymousza31478ze3z87_400;
BgL_zc3z04anonymousza31478ze3z87_400 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31478ze3ze5zz__ft_schedulerz00, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31478ze3z87_400, 
(int)(((long)0)), BgL_argsz00_11); 
BgL_stopz00_132 = BgL_zc3z04anonymousza31478ze3z87_400; }  else 
{ /* Llib/scheduler.scm 213 */
BgL_stopz00_132 = 
BGl_errorz00zz__errorz00(BGl_string1666z00zz__ft_schedulerz00, BGl_string1667z00zz__ft_schedulerz00, BgL_argsz00_11); } } } 
{ /* Llib/scheduler.scm 205 */

{ /* Llib/scheduler.scm 221 */
obj_t BgL_nozd2busyzd2waitingzd2nextzd2instantz00_397;obj_t BgL_busyzd2waitingzd2nextzd2instantzd2_396;
BgL_nozd2busyzd2waitingzd2nextzd2instantz00_397 = 
MAKE_FX_PROCEDURE(BGl_z62nozd2busyzd2waitingzd2nextzd2instantz62zz__ft_schedulerz00, 
(int)(((long)2)), 
(int)(((long)1))); 
BgL_busyzd2waitingzd2nextzd2instantzd2_396 = 
MAKE_FX_PROCEDURE(BGl_z62busyzd2waitingzd2nextzd2instantzb0zz__ft_schedulerz00, 
(int)(((long)2)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_nozd2busyzd2waitingzd2nextzd2instantz00_397, 
(int)(((long)0)), BgL_stopz00_132); 
PROCEDURE_SET(BgL_busyzd2waitingzd2nextzd2instantzd2_396, 
(int)(((long)0)), BgL_stopz00_132); 
{ 
obj_t BgL_auxz00_850;
if(BgL_iterpz00_130)
{ /* Llib/scheduler.scm 267 */
BgL_auxz00_850 = BgL_busyzd2waitingzd2nextzd2instantzd2_396
; }  else 
{ /* Llib/scheduler.scm 267 */
BgL_auxz00_850 = BgL_nozd2busyzd2waitingzd2nextzd2instantz00_397
; } 
((((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_131)))->BgL_nextzd2instantzd2)=((obj_t)BgL_auxz00_850),BUNSPEC); } 
{ /* Llib/scheduler.scm 272 */
obj_t BgL_arg1223z00_137;
BgL_arg1223z00_137 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)
((BgL_schedulerz00_bglt)BgL_scdlz00_131))))->BgL_z52builtinz52); 
BGl_z52pthreadzd2enterzd2schedulerz52zz__ft_z52pthreadz52(
((BgL_z52pthreadz52_bglt)BgL_arg1223z00_137)); } 
return BUNSPEC;} } } } } } 

}



/* &scheduler-start! */
obj_t BGl_z62schedulerzd2startz12za2zz__ft_schedulerz00(obj_t BgL_envz00_401, obj_t BgL_argsz00_402)
{
{ /* Llib/scheduler.scm 200 */
return 
BGl_schedulerzd2startz12zc0zz__ft_schedulerz00(BgL_argsz00_402);} 

}



/* &busy-waiting-next-instant */
obj_t BGl_z62busyzd2waitingzd2nextzd2instantzb0zz__ft_schedulerz00(obj_t BgL_envz00_403, obj_t BgL_scdlz00_405, obj_t BgL_iz00_406)
{
{ /* Llib/scheduler.scm 235 */
{ /* Llib/scheduler.scm 221 */
obj_t BgL_stopz00_404;
BgL_stopz00_404 = 
PROCEDURE_REF(BgL_envz00_403, 
(int)(((long)0))); 
if(
CBOOL(
PROCEDURE_ENTRY(BgL_stopz00_404)(BgL_stopz00_404, BgL_iz00_406, BEOA)))
{ /* Llib/scheduler.scm 223 */
obj_t BgL_arg1242z00_455;
BgL_arg1242z00_455 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)
((BgL_schedulerz00_bglt)BgL_scdlz00_405))))->BgL_z52builtinz52); 
return 
BGl_z52pthreadzd2leavezd2schedulerz52zz__ft_z52pthreadz52(
((BgL_z52pthreadz52_bglt)BgL_arg1242z00_455));}  else 
{ /* Llib/scheduler.scm 224 */
obj_t BgL_statez00_456;
BgL_statez00_456 = 
BGl_schedulerzd2statezd2zz__ft_schedulerz00(
((BgL_schedulerz00_bglt)BgL_scdlz00_405)); 
if(
(BgL_statez00_456==
CNST_TABLE_REF(((long)6))))
{ /* Llib/scheduler.scm 227 */
return BTRUE;}  else 
{ /* Llib/scheduler.scm 227 */
if(
(BgL_statez00_456==
CNST_TABLE_REF(((long)8))))
{ /* Llib/scheduler.scm 227 */
return BTRUE;}  else 
{ /* Llib/scheduler.scm 235 */
obj_t BgL_arg1253z00_457;
BgL_arg1253z00_457 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)
((BgL_schedulerz00_bglt)BgL_scdlz00_405))))->BgL_z52builtinz52); 
return 
BGl_z52pthreadzd2leavezd2schedulerz52zz__ft_z52pthreadz52(
((BgL_z52pthreadz52_bglt)BgL_arg1253z00_457));} } } } } 

}



/* &no-busy-waiting-next-instant */
obj_t BGl_z62nozd2busyzd2waitingzd2nextzd2instantz62zz__ft_schedulerz00(obj_t BgL_envz00_407, obj_t BgL_scdlz00_409, obj_t BgL_iz00_410)
{
{ /* Llib/scheduler.scm 263 */
{ /* Llib/scheduler.scm 237 */
obj_t BgL_stopz00_408;
BgL_stopz00_408 = 
PROCEDURE_REF(BgL_envz00_407, 
(int)(((long)0))); 
if(
CBOOL(
PROCEDURE_ENTRY(BgL_stopz00_408)(BgL_stopz00_408, BgL_iz00_410, BEOA)))
{ /* Llib/scheduler.scm 239 */
obj_t BgL_arg1260z00_458;
BgL_arg1260z00_458 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)
((BgL_schedulerz00_bglt)BgL_scdlz00_409))))->BgL_z52builtinz52); 
return 
BGl_z52pthreadzd2leavezd2schedulerz52zz__ft_z52pthreadz52(
((BgL_z52pthreadz52_bglt)BgL_arg1260z00_458));}  else 
{ /* Llib/scheduler.scm 240 */
obj_t BgL_statez00_459;
BgL_statez00_459 = 
BGl_schedulerzd2statezd2zz__ft_schedulerz00(
((BgL_schedulerz00_bglt)BgL_scdlz00_409)); 
if(
(BgL_statez00_459==
CNST_TABLE_REF(((long)6))))
{ /* Llib/scheduler.scm 243 */
return BTRUE;}  else 
{ /* Llib/scheduler.scm 243 */
if(
(BgL_statez00_459==
CNST_TABLE_REF(((long)8))))
{ /* Llib/scheduler.scm 243 */
{ /* Llib/scheduler.scm 251 */
obj_t BgL_arg1264z00_460;
BgL_arg1264z00_460 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)
((BgL_z52schedulerz52_bglt)BgL_scdlz00_409))))->BgL_z52builtinz52); 
BGl_z52asynczd2synchroniza7ez27zz__ft_z52pthreadz52(
((BgL_z52pthreadz52_bglt)BgL_arg1264z00_460)); } 
{ /* Llib/scheduler.scm 255 */
bool_t BgL_test1755z00_912;
if(
NULLP(
(((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_409)))->BgL_tobroadcastz00)))
{ /* Llib/scheduler.scm 255 */
BgL_test1755z00_912 = 
NULLP(
(((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_409)))->BgL_asynczd2runnablezd2))
; }  else 
{ /* Llib/scheduler.scm 255 */
BgL_test1755z00_912 = ((bool_t)0)
; } 
if(BgL_test1755z00_912)
{ /* Llib/scheduler.scm 255 */
{ /* Llib/scheduler.scm 257 */
obj_t BgL_arg1283z00_461;
BgL_arg1283z00_461 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)
((BgL_z52schedulerz52_bglt)BgL_scdlz00_409))))->BgL_z52builtinz52); 
BGl_z52asynczd2schedulerzd2waitz52zz__ft_z52pthreadz52(
((BgL_z52pthreadz52_bglt)BgL_arg1283z00_461)); } BUNSPEC; }  else 
{ /* Llib/scheduler.scm 255 */BFALSE; } } 
{ /* Llib/scheduler.scm 259 */
obj_t BgL_arg1301z00_462;
BgL_arg1301z00_462 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)
((BgL_z52schedulerz52_bglt)BgL_scdlz00_409))))->BgL_z52builtinz52); 
BGl_z52asynczd2asynchroniza7ez27zz__ft_z52pthreadz52(
((BgL_z52pthreadz52_bglt)BgL_arg1301z00_462)); } 
return BTRUE;}  else 
{ /* Llib/scheduler.scm 263 */
obj_t BgL_arg1302z00_463;
BgL_arg1302z00_463 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)
((BgL_schedulerz00_bglt)BgL_scdlz00_409))))->BgL_z52builtinz52); 
return 
BGl_z52pthreadzd2leavezd2schedulerz52zz__ft_z52pthreadz52(
((BgL_z52pthreadz52_bglt)BgL_arg1302z00_463));} } } } } 

}



/* &<@anonymous:1306> */
obj_t BGl_z62zc3z04anonymousza31306ze3ze5zz__ft_schedulerz00(obj_t BgL_envz00_411, obj_t BgL_iz00_412)
{
{ /* Llib/scheduler.scm 207 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1349> */
obj_t BGl_z62zc3z04anonymousza31349ze3ze5zz__ft_schedulerz00(obj_t BgL_envz00_413, obj_t BgL_iz00_415)
{
{ /* Llib/scheduler.scm 211 */
return 
BBOOL(
BGl_2ze3zd3z30zz__r4_numbers_6_5z00(BgL_iz00_415, 
PROCEDURE_REF(BgL_envz00_413, 
(int)(((long)0)))));} 

}



/* &<@anonymous:1478> */
obj_t BGl_z62zc3z04anonymousza31478ze3ze5zz__ft_schedulerz00(obj_t BgL_envz00_416, obj_t BgL_iz00_418)
{
{ /* Llib/scheduler.scm 214 */
{ /* Llib/scheduler.scm 215 */
obj_t BgL_argsz00_417;
BgL_argsz00_417 = 
PROCEDURE_REF(BgL_envz00_416, 
(int)(((long)0))); 
{ /* Llib/scheduler.scm 215 */
obj_t BgL_fun1479z00_464;
BgL_fun1479z00_464 = 
CAR(
((obj_t)BgL_argsz00_417)); 
return 
PROCEDURE_ENTRY(BgL_fun1479z00_464)(BgL_fun1479z00_464, BgL_iz00_418, BEOA);} } } 

}



/* broadcast! */
BGL_EXPORTED_DEF obj_t BGl_broadcastz12z12zz__ft_schedulerz00(obj_t BgL_sigz00_12, obj_t BgL_valz00_13)
{
{ /* Llib/scheduler.scm 278 */
{ /* Llib/scheduler.scm 279 */
obj_t BgL_tz00_199;obj_t BgL_vz00_200;
BgL_tz00_199 = 
BGl_currentzd2threadzd2zz__threadz00(); 
if(
PAIRP(BgL_valz00_13))
{ /* Llib/scheduler.scm 280 */
BgL_vz00_200 = 
CAR(BgL_valz00_13); }  else 
{ /* Llib/scheduler.scm 280 */
BgL_vz00_200 = BUNSPEC; } 
if(
BGl_isazf3zf3zz__objectz00(BgL_tz00_199, BGl_threadz00zz__threadz00))
{ /* Llib/scheduler.scm 281 */
if(
BGl_z52threadzd2attachedzf3z73zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)
((BgL_threadz00_bglt)BgL_tz00_199))))
{ /* Llib/scheduler.scm 284 */
obj_t BgL_arg1502z00_204;
BgL_arg1502z00_204 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)
((BgL_threadz00_bglt)BgL_tz00_199))))->BgL_schedulerz00); 
return 
BGl_z52broadcastz12z40zz__ft_z52schedulerz52(
((BgL_z52schedulerz52_bglt)BgL_arg1502z00_204), BgL_sigz00_12, BgL_vz00_200);}  else 
{ /* Llib/scheduler.scm 282 */
return 
BGl_errorz00zz__errorz00(BGl_string1668z00zz__ft_schedulerz00, BGl_string1669z00zz__ft_schedulerz00, BgL_tz00_199);} }  else 
{ /* Llib/scheduler.scm 281 */
return BFALSE;} } } 

}



/* &broadcast! */
obj_t BGl_z62broadcastz12z70zz__ft_schedulerz00(obj_t BgL_envz00_419, obj_t BgL_sigz00_420, obj_t BgL_valz00_421)
{
{ /* Llib/scheduler.scm 278 */
return 
BGl_broadcastz12z12zz__ft_schedulerz00(BgL_sigz00_420, BgL_valz00_421);} 

}



/* scheduler-broadcast! */
BGL_EXPORTED_DEF obj_t BGl_schedulerzd2broadcastz12zc0zz__ft_schedulerz00(BgL_schedulerz00_bglt BgL_sz00_14, obj_t BgL_sigz00_15, obj_t BgL_valz00_16)
{
{ /* Llib/scheduler.scm 290 */
{ /* Llib/scheduler.scm 291 */
obj_t BgL_arg1504z00_339;
if(
PAIRP(BgL_valz00_16))
{ /* Llib/scheduler.scm 291 */
BgL_arg1504z00_339 = 
CAR(BgL_valz00_16); }  else 
{ /* Llib/scheduler.scm 291 */
BgL_arg1504z00_339 = BUNSPEC; } 
return 
BGl_z52schedulerzd2addzd2broadcastz12z40zz__ft_z52schedulerz52(
((BgL_z52schedulerz52_bglt)BgL_sz00_14), BgL_sigz00_15, BgL_arg1504z00_339);} } 

}



/* &scheduler-broadcast! */
obj_t BGl_z62schedulerzd2broadcastz12za2zz__ft_schedulerz00(obj_t BgL_envz00_422, obj_t BgL_sz00_423, obj_t BgL_sigz00_424, obj_t BgL_valz00_425)
{
{ /* Llib/scheduler.scm 290 */
{ /* Llib/scheduler.scm 291 */
BgL_schedulerz00_bglt BgL_auxz00_970;
if(
BGl_isazf3zf3zz__objectz00(BgL_sz00_423, BGl_schedulerz00zz__ft_typesz00))
{ /* Llib/scheduler.scm 291 */
BgL_auxz00_970 = 
((BgL_schedulerz00_bglt)BgL_sz00_423)
; }  else 
{ 
obj_t BgL_auxz00_974;
BgL_auxz00_974 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1659z00zz__ft_schedulerz00, 
BINT(((long)10938)), BGl_string1670z00zz__ft_schedulerz00, BGl_string1661z00zz__ft_schedulerz00, BgL_sz00_423); 
FAILURE(BgL_auxz00_974,BFALSE,BFALSE);} 
return 
BGl_schedulerzd2broadcastz12zc0zz__ft_schedulerz00(BgL_auxz00_970, BgL_sigz00_424, BgL_valz00_425);} } 

}



/* scheduler-terminate! */
BGL_EXPORTED_DEF obj_t BGl_schedulerzd2terminatez12zc0zz__ft_schedulerz00(obj_t BgL_sz00_17)
{
{ /* Llib/scheduler.scm 296 */
{ /* Llib/scheduler.scm 297 */
obj_t BgL_sz00_208;
if(
NULLP(BgL_sz00_17))
{ /* Llib/scheduler.scm 298 */
BgL_sz00_208 = 
BGl_defaultzd2schedulerzd2zz__ft_schedulerz00(BNIL); }  else 
{ /* Llib/scheduler.scm 300 */
bool_t BgL_test1763z00_982;
{ /* Llib/scheduler.scm 300 */
obj_t BgL_arg1598z00_257;
BgL_arg1598z00_257 = 
CAR(
((obj_t)BgL_sz00_17)); 
BgL_test1763z00_982 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1598z00_257, BGl_schedulerz00zz__ft_typesz00); } 
if(BgL_test1763z00_982)
{ /* Llib/scheduler.scm 300 */
BgL_sz00_208 = 
CAR(
((obj_t)BgL_sz00_17)); }  else 
{ /* Llib/scheduler.scm 305 */
obj_t BgL_arg1593z00_256;
BgL_arg1593z00_256 = 
CAR(
((obj_t)BgL_sz00_17)); 
BgL_sz00_208 = 
BGl_errorz00zz__errorz00(BGl_string1671z00zz__ft_schedulerz00, BGl_string1658z00zz__ft_schedulerz00, BgL_arg1593z00_256); } } 
{ /* Llib/scheduler.scm 322 */
obj_t BgL_arg1506z00_210;
BgL_arg1506z00_210 = 
(((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_sz00_208)))->BgL_currentzd2threadzd2); 
BGl_threadzd2terminatez12zc0zz__threadz00(
((BgL_threadz00_bglt)BgL_arg1506z00_210)); } 
{ /* Llib/scheduler.scm 323 */
obj_t BgL_g1097z00_211;
BgL_g1097z00_211 = 
(((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_sz00_208)))->BgL_tosuspendzf2resumezf2); 
{ 
obj_t BgL_l1095z00_213;
BgL_l1095z00_213 = BgL_g1097z00_211; 
BgL_zc3z04anonymousza31507ze3z87_214:
if(
PAIRP(BgL_l1095z00_213))
{ /* Llib/scheduler.scm 323 */
{ /* Llib/scheduler.scm 323 */
obj_t BgL_arg1520z00_216;
BgL_arg1520z00_216 = 
CAR(BgL_l1095z00_213); 
BGl_threadzd2terminatez12zc0zz__threadz00(
((BgL_threadz00_bglt)BgL_arg1520z00_216)); } 
{ 
obj_t BgL_l1095z00_1002;
BgL_l1095z00_1002 = 
CDR(BgL_l1095z00_213); 
BgL_l1095z00_213 = BgL_l1095z00_1002; 
goto BgL_zc3z04anonymousza31507ze3z87_214;} }  else 
{ /* Llib/scheduler.scm 323 */((bool_t)1); } } } 
{ /* Llib/scheduler.scm 324 */
obj_t BgL_g1100z00_219;
BgL_g1100z00_219 = 
(((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_sz00_208)))->BgL_threadszd2runnablezd2); 
{ 
obj_t BgL_l1098z00_221;
BgL_l1098z00_221 = BgL_g1100z00_219; 
BgL_zc3z04anonymousza31522ze3z87_222:
if(
PAIRP(BgL_l1098z00_221))
{ /* Llib/scheduler.scm 324 */
{ /* Llib/scheduler.scm 324 */
obj_t BgL_arg1537z00_224;
BgL_arg1537z00_224 = 
CAR(BgL_l1098z00_221); 
BGl_threadzd2terminatez12zc0zz__threadz00(
((BgL_threadz00_bglt)BgL_arg1537z00_224)); } 
{ 
obj_t BgL_l1098z00_1011;
BgL_l1098z00_1011 = 
CDR(BgL_l1098z00_221); 
BgL_l1098z00_221 = BgL_l1098z00_1011; 
goto BgL_zc3z04anonymousza31522ze3z87_222;} }  else 
{ /* Llib/scheduler.scm 324 */((bool_t)1); } } } 
{ /* Llib/scheduler.scm 325 */
obj_t BgL_g1103z00_227;
BgL_g1103z00_227 = 
(((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_sz00_208)))->BgL_threadszd2yieldzd2); 
{ 
obj_t BgL_l1101z00_229;
BgL_l1101z00_229 = BgL_g1103z00_227; 
BgL_zc3z04anonymousza31540ze3z87_230:
if(
PAIRP(BgL_l1101z00_229))
{ /* Llib/scheduler.scm 325 */
{ /* Llib/scheduler.scm 325 */
obj_t BgL_arg1553z00_232;
BgL_arg1553z00_232 = 
CAR(BgL_l1101z00_229); 
BGl_threadzd2terminatez12zc0zz__threadz00(
((BgL_threadz00_bglt)BgL_arg1553z00_232)); } 
{ 
obj_t BgL_l1101z00_1020;
BgL_l1101z00_1020 = 
CDR(BgL_l1101z00_229); 
BgL_l1101z00_229 = BgL_l1101z00_1020; 
goto BgL_zc3z04anonymousza31540ze3z87_230;} }  else 
{ /* Llib/scheduler.scm 325 */((bool_t)1); } } } 
{ /* Llib/scheduler.scm 326 */
obj_t BgL_g1106z00_235;
BgL_g1106z00_235 = 
(((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_sz00_208)))->BgL_threadszd2timeoutzd2); 
{ 
obj_t BgL_l1104z00_237;
BgL_l1104z00_237 = BgL_g1106z00_235; 
BgL_zc3z04anonymousza31555ze3z87_238:
if(
PAIRP(BgL_l1104z00_237))
{ /* Llib/scheduler.scm 326 */
{ /* Llib/scheduler.scm 326 */
obj_t BgL_arg1576z00_240;
BgL_arg1576z00_240 = 
CAR(BgL_l1104z00_237); 
BGl_threadzd2terminatez12zc0zz__threadz00(
((BgL_threadz00_bglt)BgL_arg1576z00_240)); } 
{ 
obj_t BgL_l1104z00_1029;
BgL_l1104z00_1029 = 
CDR(BgL_l1104z00_237); 
BgL_l1104z00_237 = BgL_l1104z00_1029; 
goto BgL_zc3z04anonymousza31555ze3z87_238;} }  else 
{ /* Llib/scheduler.scm 326 */((bool_t)1); } } } 
{ /* Llib/scheduler.scm 328 */
obj_t BgL_g1109z00_243;
BgL_g1109z00_243 = 
BGl_z52schedulerzd2waitingzd2threadsz52zz__ft_z52schedulerz52(
((BgL_z52schedulerz52_bglt)BgL_sz00_208)); 
{ 
obj_t BgL_l1107z00_245;
BgL_l1107z00_245 = BgL_g1109z00_243; 
BgL_zc3z04anonymousza31578ze3z87_246:
if(
PAIRP(BgL_l1107z00_245))
{ /* Llib/scheduler.scm 328 */
{ /* Llib/scheduler.scm 328 */
obj_t BgL_arg1580z00_248;
BgL_arg1580z00_248 = 
CAR(BgL_l1107z00_245); 
BGl_threadzd2terminatez12zc0zz__threadz00(
((BgL_threadz00_bglt)BgL_arg1580z00_248)); } 
{ 
obj_t BgL_l1107z00_1038;
BgL_l1107z00_1038 = 
CDR(BgL_l1107z00_245); 
BgL_l1107z00_245 = BgL_l1107z00_1038; 
goto BgL_zc3z04anonymousza31578ze3z87_246;} }  else 
{ /* Llib/scheduler.scm 328 */((bool_t)1); } } } 
((((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_sz00_208)))->BgL_tosuspendzf2resumezf2)=((obj_t)BNIL),BUNSPEC); 
((((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_sz00_208)))->BgL_tostartz00)=((obj_t)BNIL),BUNSPEC); 
{ /* Llib/scheduler.scm 333 */
obj_t BgL_list1587z00_251;
BgL_list1587z00_251 = 
MAKE_YOUNG_PAIR(BTRUE, BNIL); 
return 
BBOOL(
BGl_z52threadzd2iszd2deadz52zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_sz00_208), BgL_list1587z00_251));} } } 

}



/* &scheduler-terminate! */
obj_t BGl_z62schedulerzd2terminatez12za2zz__ft_schedulerz00(obj_t BgL_envz00_426, obj_t BgL_sz00_427)
{
{ /* Llib/scheduler.scm 296 */
return 
BGl_schedulerzd2terminatez12zc0zz__ft_schedulerz00(BgL_sz00_427);} 

}



/* scheduler-instant */
BGL_EXPORTED_DEF int BGl_schedulerzd2instantzd2zz__ft_schedulerz00(obj_t BgL_sz00_18)
{
{ /* Llib/scheduler.scm 338 */
{ /* Llib/scheduler.scm 339 */
obj_t BgL_sz00_258;
if(
NULLP(BgL_sz00_18))
{ /* Llib/scheduler.scm 340 */
BgL_sz00_258 = 
BGl_defaultzd2schedulerzd2zz__ft_schedulerz00(BNIL); }  else 
{ /* Llib/scheduler.scm 342 */
bool_t BgL_test1770z00_1052;
{ /* Llib/scheduler.scm 342 */
obj_t BgL_arg1613z00_267;
BgL_arg1613z00_267 = 
CAR(
((obj_t)BgL_sz00_18)); 
BgL_test1770z00_1052 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1613z00_267, BGl_schedulerz00zz__ft_typesz00); } 
if(BgL_test1770z00_1052)
{ /* Llib/scheduler.scm 342 */
BgL_sz00_258 = 
CAR(
((obj_t)BgL_sz00_18)); }  else 
{ /* Llib/scheduler.scm 345 */
obj_t BgL_arg1612z00_266;
BgL_arg1612z00_266 = 
CAR(
((obj_t)BgL_sz00_18)); 
BgL_sz00_258 = 
BGl_errorz00zz__errorz00(BGl_string1672z00zz__ft_schedulerz00, BGl_string1658z00zz__ft_schedulerz00, BgL_arg1612z00_266); } } 
return 
(int)(
(((BgL_ftenvz00_bglt)COBJECT(
((BgL_ftenvz00_bglt)
CAR(
(((BgL_schedulerz00_bglt)COBJECT(
((BgL_schedulerz00_bglt)
((BgL_z52schedulerz52_bglt)BgL_sz00_258))))->BgL_envzb2zb2)))))->BgL_instantz00));} } 

}



/* &scheduler-instant */
obj_t BGl_z62schedulerzd2instantzb0zz__ft_schedulerz00(obj_t BgL_envz00_428, obj_t BgL_sz00_429)
{
{ /* Llib/scheduler.scm 338 */
return 
BINT(
BGl_schedulerzd2instantzd2zz__ft_schedulerz00(BgL_sz00_429));} 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__ft_schedulerz00()
{
{ /* Llib/scheduler.scm 15 */
return BUNSPEC;} 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__ft_schedulerz00()
{
{ /* Llib/scheduler.scm 15 */
return BUNSPEC;} 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__ft_schedulerz00()
{
{ /* Llib/scheduler.scm 15 */
return BUNSPEC;} 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__ft_schedulerz00()
{
{ /* Llib/scheduler.scm 15 */
BGl_modulezd2initializa7ationz75zz__ft_typesz00(((long)414892275), 
BSTRING_TO_STRING(BGl_string1673z00zz__ft_schedulerz00)); 
BGl_modulezd2initializa7ationz75zz__ft_z52typesz52(((long)0), 
BSTRING_TO_STRING(BGl_string1673z00zz__ft_schedulerz00)); 
BGl_modulezd2initializa7ationz75zz__ft_z52schedulerz52(((long)398966270), 
BSTRING_TO_STRING(BGl_string1673z00zz__ft_schedulerz00)); 
BGl_modulezd2initializa7ationz75zz__ft_z52envz52(((long)471565054), 
BSTRING_TO_STRING(BGl_string1673z00zz__ft_schedulerz00)); 
BGl_modulezd2initializa7ationz75zz__ft_z52threadz52(((long)536507091), 
BSTRING_TO_STRING(BGl_string1673z00zz__ft_schedulerz00)); 
BGl_modulezd2initializa7ationz75zz__ft_threadz00(((long)431919647), 
BSTRING_TO_STRING(BGl_string1673z00zz__ft_schedulerz00)); 
BGl_modulezd2initializa7ationz75zz__ft_signalz00(((long)295111899), 
BSTRING_TO_STRING(BGl_string1673z00zz__ft_schedulerz00)); 
return 
BGl_modulezd2initializa7ationz75zz__ft_z52pthreadz52(((long)486293435), 
BSTRING_TO_STRING(BGl_string1673z00zz__ft_schedulerz00));} 

}

#ifdef __cplusplus
}
#endif
