/*===========================================================================*/
/*   (Llib/mpg123_alsadec.scm)                                               */
/*   Bigloo (4.3g)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu 27 Feb 2020 07:59:49 AM CET     */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo4.3g/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo4.3g/lib/bigloo/4.3g -lib-dir /builddir/build/BUILD/bigloo4.3g/lib/bigloo/4.3g -I Llib -lib-dir /builddir/build/BUILD/bigloo4.3g/lib/bigloo/4.3g -unsafe -safee -srfi mpg123 -copt  -copt -fPIC -copt -IClib Llib/mpg123_alsadec.scm -o objs/mpg123_alsadec.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>
#include <mpg123.h>
#include <alsa/asoundlib.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_musicdecoderz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_mimetypesz00;
   int BgL_bufferzd2timezd2nearz00;
   int BgL_bufferzd2siza7ezd2nearzd2ratioz75;
   int BgL_periodzd2siza7ezd2nearzd2ratioz75;
   bool_t BgL_z52z12dpausez40;
   bool_t BgL_z52z12dabortz40;
   bool_t BgL_z52z12stopz40;
   obj_t BgL_z52dmutexz52;
   obj_t BgL_z52dcondvz52;
   obj_t BgL_z52doutcondvz52;
} *BgL_musicdecoderz00_bglt;

typedef struct BgL_alsamusicz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_onstatez00;
   obj_t BgL_onvolumez00;
   obj_t BgL_onerrorz00;
   obj_t BgL_oneventz00;
   obj_t BgL_z52mutexz52;
   struct BgL_musicstatusz00_bgl * BgL_z52statusz52;
   obj_t BgL_inbufz00;
   obj_t BgL_decodersz00;
   obj_t BgL_mkthreadz00;
   obj_t BgL_timeoutz00;
   obj_t BgL_z52decoderz52;
   obj_t BgL_z52bufferz52;
   obj_t BgL_z52nextbufferz52;
   obj_t BgL_z52playlistz52;
   bool_t BgL_z52areadyz52;
   obj_t BgL_z52amutexz52;
   int BgL_z52z12pidz40;
   obj_t BgL_z52acondvz52;
   struct BgL_alsazd2sndzd2pcmz00_bgl * BgL_pcmz00;
} *BgL_alsamusicz00_bglt;

typedef struct BgL_alsazd2sndzd2pcmz00_bgl {
   header_t header;
   obj_t widening;
   snd_pcm_t * BgL_z42builtinz42;
   obj_t BgL_namez00;
   obj_t BgL_devicez00;
   obj_t BgL_streamz00;
   obj_t BgL_modez00;
   int BgL_hwbpsz00;
   int BgL_hwsratez00;
} *BgL_alsazd2sndzd2pcmz00_bglt;

typedef struct BgL_mpg123zd2decoderzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_mimetypesz00;
   int BgL_bufferzd2timezd2nearz00;
   int BgL_bufferzd2siza7ezd2nearzd2ratioz75;
   int BgL_periodzd2siza7ezd2nearzd2ratioz75;
   bool_t BgL_z52z12dpausez40;
   bool_t BgL_z52z12dabortz40;
   bool_t BgL_z52z12stopz40;
   obj_t BgL_z52dmutexz52;
   obj_t BgL_z52dcondvz52;
   obj_t BgL_z52doutcondvz52;
   obj_t BgL_outbufz00;
   obj_t BgL_z52mpg123z52;
   long BgL_z52z12dseekz40;
   int BgL_z52ratez52;
   int BgL_z52channelsz52;
   obj_t BgL_z52encodingz52;
} *BgL_mpg123zd2decoderzd2_bglt;

typedef struct BgL_mpg123zd2alsadecoderzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_mimetypesz00;
   int BgL_bufferzd2timezd2nearz00;
   int BgL_bufferzd2siza7ezd2nearzd2ratioz75;
   int BgL_periodzd2siza7ezd2nearzd2ratioz75;
   bool_t BgL_z52z12dpausez40;
   bool_t BgL_z52z12dabortz40;
   bool_t BgL_z52z12stopz40;
   obj_t BgL_z52dmutexz52;
   obj_t BgL_z52dcondvz52;
   obj_t BgL_z52doutcondvz52;
   obj_t BgL_outbufz00;
   obj_t BgL_z52mpg123z52;
   long BgL_z52z12dseekz40;
   int BgL_z52ratez52;
   int BgL_z52channelsz52;
   obj_t BgL_z52encodingz52;
} *BgL_mpg123zd2alsadecoderzd2_bglt;


extern obj_t BGl_mpg123zd2decoderzd2zz__mpg123_decoderz00;
BGL_IMPORT obj_t BGl_alsazd2sndzd2pcmzd2hwzd2setzd2paramsz12zc0zz__alsa_pcmz00(BgL_alsazd2sndzd2pcmz00_bglt, obj_t);
static obj_t BGl_objectzd2initzd2zz__mpg123_alsadecz00();
static obj_t BGl_methodzd2initzd2zz__mpg123_alsadecz00();
BGL_IMPORT obj_t BGl_conditionzd2variablezd2nilz00zz__threadz00();
BGL_IMPORT obj_t BGl_alsazd2sndzd2pcmzd2reopenzd2zz__alsa_pcmz00(BgL_alsazd2sndzd2pcmz00_bglt);
BGL_EXPORTED_DEF obj_t BGl_mpg123zd2alsadecoderzd2zz__mpg123_alsadecz00 = BUNSPEC;
BGL_IMPORT obj_t BGl_alsazd2sndzd2pcmzd2swzd2setzd2paramsz12zc0zz__alsa_pcmz00(BgL_alsazd2sndzd2pcmz00_bglt, obj_t);
BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_gczd2rootszd2initz00zz__mpg123_alsadecz00();
BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_requirezd2initializa7ationz75zz__mpg123_alsadecz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza31131ze3ze5zz__mpg123_alsadecz00(obj_t, obj_t);
static obj_t BGl_toplevelzd2initzd2zz__mpg123_alsadecz00();
static obj_t BGl_genericzd2initzd2zz__mpg123_alsadecz00();
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_mutexzd2nilzd2zz__threadz00();
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
static BgL_mpg123zd2alsadecoderzd2_bglt BGl_z62lambda1125z62zz__mpg123_alsadecz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_mpg123zd2alsadecoderzd2_bglt BGl_z62lambda1128z62zz__mpg123_alsadecz00(obj_t);
static obj_t BGl_z62musicdecoderzd2hwparam1111zb0zz__mpg123_alsadecz00(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2constructorzd2zz__objectz00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__mpg123_alsadecz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__mpg123_decoderz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__mpg123_mpg123z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__alsa_alsaz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__alsa_pcmz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2musicbufzd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
static obj_t BGl_cnstzd2initzd2zz__mpg123_alsadecz00();
static obj_t BGl_libraryzd2moduleszd2initz00zz__mpg123_alsadecz00();
static obj_t BGl_importedzd2moduleszd2initz00zz__mpg123_alsadecz00();
static obj_t __cnst[ 12 ] ;


DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1185z00zz__mpg123_alsadecz00, BgL_bgl_za762za7c3za704anonymo1196za7, BGl_z62zc3z04anonymousza31131ze3ze5zz__mpg123_alsadecz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1186z00zz__mpg123_alsadecz00, BgL_bgl_za762lambda1128za7621197z00, BGl_z62lambda1128z62zz__mpg123_alsadecz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1187z00zz__mpg123_alsadecz00, BgL_bgl_za762lambda1125za7621198z00, BGl_z62lambda1125z62zz__mpg123_alsadecz00, 0L, BUNSPEC, 16 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1189z00zz__mpg123_alsadecz00, BgL_bgl_za762musicdecoderza71199z00, BGl_z62musicdecoderzd2hwparam1111zb0zz__mpg123_alsadecz00, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string1184z00zz__mpg123_alsadecz00, BgL_bgl_string1184za700za7za7_1200za7, "Llib/mpg123_alsadec.scm", 23 );
DEFINE_STRING( BGl_string1188z00zz__mpg123_alsadecz00, BgL_bgl_string1188za700za7za7_1201za7, "", 0 );
DEFINE_STRING( BGl_string1190z00zz__mpg123_alsadecz00, BgL_bgl_string1190za700za7za7_1202za7, "musicdecoder-hwparams-set!", 26 );
DEFINE_STRING( BGl_string1191z00zz__mpg123_alsadecz00, BgL_bgl_string1191za700za7za7_1203za7, "__mpg123_alsadec", 16 );
DEFINE_STRING( BGl_string1192z00zz__mpg123_alsadecz00, BgL_bgl_string1192za700za7za7_1204za7, ":start-threshold :avail-min :access rw-interleaved :format :channels :rate-near :buffer-size-near-ratio :period-size-near-ratio _ __mpg123_alsadec mpg123-alsadecoder ", 166 );
BGL_IMPORT obj_t BGl_musicdecoderzd2initzd2envz00zz__multimediazd2musicbufzd2;
BGL_IMPORT obj_t BGl_musicdecoderzd2hwparamszd2setz12zd2envzc0zz__multimediazd2musicbufzd2;

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_mpg123zd2alsadecoderzd2zz__mpg123_alsadecz00) );
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__mpg123_alsadecz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__mpg123_alsadecz00(long BgL_checksumz00_190, char * BgL_fromz00_191)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__mpg123_alsadecz00))
{ 
BGl_requirezd2initializa7ationz75zz__mpg123_alsadecz00 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__mpg123_alsadecz00(); 
BGl_libraryzd2moduleszd2initz00zz__mpg123_alsadecz00(); 
BGl_cnstzd2initzd2zz__mpg123_alsadecz00(); 
BGl_importedzd2moduleszd2initz00zz__mpg123_alsadecz00(); 
BGl_objectzd2initzd2zz__mpg123_alsadecz00(); 
BGl_methodzd2initzd2zz__mpg123_alsadecz00(); 
return 
BGl_toplevelzd2initzd2zz__mpg123_alsadecz00();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__mpg123_alsadecz00()
{
{ /* Llib/mpg123_alsadec.scm 15 */
BGl_modulezd2initializa7ationz75zz__alsa_pcmz00(((long)0), "__mpg123_alsadec"); 
BGl_modulezd2initializa7ationz75zz__threadz00(((long)0), "__mpg123_alsadec"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__mpg123_alsadec"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__mpg123_alsadec"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__mpg123_alsadec"); 
BGl_modulezd2initializa7ationz75zz__alsa_alsaz00(((long)0), "__mpg123_alsadec"); 
BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(((long)0), "__mpg123_alsadec"); 
BGl_modulezd2initializa7ationz75zz__multimediazd2musicbufzd2(((long)0), "__mpg123_alsadec"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__mpg123_alsadec"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__mpg123_alsadecz00()
{
{ /* Llib/mpg123_alsadec.scm 15 */
{ /* Llib/mpg123_alsadec.scm 15 */
obj_t BgL_cportz00_128;
{ /* Llib/mpg123_alsadec.scm 15 */
obj_t BgL_stringz00_136;
BgL_stringz00_136 = BGl_string1192z00zz__mpg123_alsadecz00; 
{ /* Llib/mpg123_alsadec.scm 15 */
obj_t BgL_startz00_137;
BgL_startz00_137 = 
BINT(((long)0)); 
{ /* Llib/mpg123_alsadec.scm 15 */
obj_t BgL_endz00_138;
BgL_endz00_138 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_136))); 
{ /* Llib/mpg123_alsadec.scm 15 */

BgL_cportz00_128 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_136, BgL_startz00_137, BgL_endz00_138); } } } } 
{ 
long BgL_iz00_129;
BgL_iz00_129 = ((long)11); 
BgL_loopz00_130:
if(
(BgL_iz00_129==((long)-1)))
{ /* Llib/mpg123_alsadec.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/mpg123_alsadec.scm 15 */
{ /* Llib/mpg123_alsadec.scm 15 */
obj_t BgL_arg1194z00_132;
{ /* Llib/mpg123_alsadec.scm 15 */

{ /* Llib/mpg123_alsadec.scm 15 */
obj_t BgL_locationz00_134;
BgL_locationz00_134 = 
BBOOL(((bool_t)0)); 
{ /* Llib/mpg123_alsadec.scm 15 */

BgL_arg1194z00_132 = 
BGl_readz00zz__readerz00(BgL_cportz00_128, BgL_locationz00_134); } } } 
{ /* Llib/mpg123_alsadec.scm 15 */
int BgL_tmpz00_220;
BgL_tmpz00_220 = 
(int)(BgL_iz00_129); 
CNST_TABLE_SET(BgL_tmpz00_220, BgL_arg1194z00_132); } } 
{ /* Llib/mpg123_alsadec.scm 15 */
int BgL_auxz00_135;
BgL_auxz00_135 = 
(int)(
(BgL_iz00_129-((long)1))); 
{ 
long BgL_iz00_225;
BgL_iz00_225 = 
(long)(BgL_auxz00_135); 
BgL_iz00_129 = BgL_iz00_225; 
goto BgL_loopz00_130;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__mpg123_alsadecz00()
{
{ /* Llib/mpg123_alsadec.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__mpg123_alsadecz00()
{
{ /* Llib/mpg123_alsadec.scm 15 */
BGl_modulezd2initializa7ationz75zz__alsa_alsaz00(((long)0), 
BSTRING_TO_STRING(BGl_string1184z00zz__mpg123_alsadecz00)); 
BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(((long)0), 
BSTRING_TO_STRING(BGl_string1184z00zz__mpg123_alsadecz00)); 
return BUNSPEC;} 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__mpg123_alsadecz00()
{
{ /* Llib/mpg123_alsadec.scm 15 */
{ /* Llib/mpg123_alsadec.scm 28 */
obj_t BgL_arg1123z00_17;obj_t BgL_arg1124z00_18;
{ /* Llib/mpg123_alsadec.scm 28 */
obj_t BgL_v1108z00_45;
BgL_v1108z00_45 = 
create_vector(((long)0)); 
BgL_arg1123z00_17 = BgL_v1108z00_45; } 
{ /* Llib/mpg123_alsadec.scm 28 */
obj_t BgL_v1109z00_46;
BgL_v1109z00_46 = 
create_vector(((long)0)); 
BgL_arg1124z00_18 = BgL_v1109z00_46; } 
return ( 
BGl_mpg123zd2alsadecoderzd2zz__mpg123_alsadecz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)0)), 
CNST_TABLE_REF(((long)1)), BGl_mpg123zd2decoderzd2zz__mpg123_decoderz00, ((long)49408), BGl_proc1187z00zz__mpg123_alsadecz00, BGl_proc1186z00zz__mpg123_alsadecz00, BGl_musicdecoderzd2initzd2envz00zz__multimediazd2musicbufzd2, BGl_proc1185z00zz__mpg123_alsadecz00, BFALSE, BgL_arg1123z00_17, BgL_arg1124z00_18), BUNSPEC) ;} } 

}



/* &<@anonymous:1131> */
obj_t BGl_z62zc3z04anonymousza31131ze3ze5zz__mpg123_alsadecz00(obj_t BgL_envz00_97, obj_t BgL_new1103z00_98)
{
{ /* Llib/mpg123_alsadec.scm 28 */
{ 
BgL_mpg123zd2alsadecoderzd2_bglt BgL_auxz00_237;
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2alsadecoderzd2_bglt)BgL_new1103z00_98))))->BgL_mimetypesz00)=((obj_t)BNIL),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2alsadecoderzd2_bglt)BgL_new1103z00_98))))->BgL_bufferzd2timezd2nearz00)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2alsadecoderzd2_bglt)BgL_new1103z00_98))))->BgL_bufferzd2siza7ezd2nearzd2ratioz75)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2alsadecoderzd2_bglt)BgL_new1103z00_98))))->BgL_periodzd2siza7ezd2nearzd2ratioz75)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2alsadecoderzd2_bglt)BgL_new1103z00_98))))->BgL_z52z12dpausez40)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2alsadecoderzd2_bglt)BgL_new1103z00_98))))->BgL_z52z12dabortz40)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2alsadecoderzd2_bglt)BgL_new1103z00_98))))->BgL_z52z12stopz40)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2alsadecoderzd2_bglt)BgL_new1103z00_98))))->BgL_z52dmutexz52)=((obj_t)
BGl_mutexzd2nilzd2zz__threadz00()),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2alsadecoderzd2_bglt)BgL_new1103z00_98))))->BgL_z52dcondvz52)=((obj_t)
BGl_conditionzd2variablezd2nilz00zz__threadz00()),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2alsadecoderzd2_bglt)BgL_new1103z00_98))))->BgL_z52doutcondvz52)=((obj_t)
BGl_conditionzd2variablezd2nilz00zz__threadz00()),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)
((BgL_mpg123zd2alsadecoderzd2_bglt)BgL_new1103z00_98))))->BgL_outbufz00)=((obj_t)BGl_string1188z00zz__mpg123_alsadecz00),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)
((BgL_mpg123zd2alsadecoderzd2_bglt)BgL_new1103z00_98))))->BgL_z52mpg123z52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)
((BgL_mpg123zd2alsadecoderzd2_bglt)BgL_new1103z00_98))))->BgL_z52z12dseekz40)=((long)((long)0)),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)
((BgL_mpg123zd2alsadecoderzd2_bglt)BgL_new1103z00_98))))->BgL_z52ratez52)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)
((BgL_mpg123zd2alsadecoderzd2_bglt)BgL_new1103z00_98))))->BgL_z52channelsz52)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)
((BgL_mpg123zd2alsadecoderzd2_bglt)BgL_new1103z00_98))))->BgL_z52encodingz52)=((obj_t)
CNST_TABLE_REF(((long)2))),BUNSPEC); 
BgL_auxz00_237 = 
((BgL_mpg123zd2alsadecoderzd2_bglt)BgL_new1103z00_98); 
return 
((obj_t)BgL_auxz00_237);} } 

}



/* &lambda1128 */
BgL_mpg123zd2alsadecoderzd2_bglt BGl_z62lambda1128z62zz__mpg123_alsadecz00(obj_t BgL_envz00_99)
{
{ /* Llib/mpg123_alsadec.scm 28 */
{ /* Llib/mpg123_alsadec.scm 28 */
BgL_mpg123zd2alsadecoderzd2_bglt BgL_new1102z00_142;
BgL_new1102z00_142 = 
((BgL_mpg123zd2alsadecoderzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_mpg123zd2alsadecoderzd2_bgl) ))); 
{ /* Llib/mpg123_alsadec.scm 28 */
long BgL_arg1130z00_143;
{ /* Llib/mpg123_alsadec.scm 28 */
long BgL_res1179z00_144;
BgL_res1179z00_144 = 
BGL_CLASS_INDEX(BGl_mpg123zd2alsadecoderzd2zz__mpg123_alsadecz00); 
BgL_arg1130z00_143 = BgL_res1179z00_144; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1102z00_142), BgL_arg1130z00_143); } 
return BgL_new1102z00_142;} } 

}



/* &lambda1125 */
BgL_mpg123zd2alsadecoderzd2_bglt BGl_z62lambda1125z62zz__mpg123_alsadecz00(obj_t BgL_envz00_100, obj_t BgL_mimetypes1086z00_101, obj_t BgL_bufferzd2timezd2near1087z00_102, obj_t BgL_bufferzd2siza7ezd2nearzd2rat1088z75_103, obj_t BgL_periodzd2siza7ezd2nearzd2rat1089z75_104, obj_t BgL_z52z12dpause1090z40_105, obj_t BgL_z52z12dabort1091z40_106, obj_t BgL_z52z12stop1092z40_107, obj_t BgL_z52dmutex1093z52_108, obj_t BgL_z52dcondv1094z52_109, obj_t BgL_z52doutcondv1095z52_110, obj_t BgL_outbuf1096z00_111, obj_t BgL_z52mpg1231097z52_112, obj_t BgL_z52z12dseek1098z40_113, obj_t BgL_z52rate1099z52_114, obj_t BgL_z52channels1100z52_115, obj_t BgL_z52encoding1101z52_116)
{
{ /* Llib/mpg123_alsadec.scm 28 */
{ /* Llib/mpg123_alsadec.scm 28 */
int BgL_bufferzd2timezd2near1087z00_146;int BgL_bufferzd2siza7ezd2nearzd2rat1088z75_147;int BgL_periodzd2siza7ezd2nearzd2rat1089z75_148;bool_t BgL_z52z12dpause1090z40_149;bool_t BgL_z52z12dabort1091z40_150;bool_t BgL_z52z12stop1092z40_151;long BgL_z52z12dseek1098z40_156;int BgL_z52rate1099z52_157;int BgL_z52channels1100z52_158;
BgL_bufferzd2timezd2near1087z00_146 = 
CINT(BgL_bufferzd2timezd2near1087z00_102); 
BgL_bufferzd2siza7ezd2nearzd2rat1088z75_147 = 
CINT(BgL_bufferzd2siza7ezd2nearzd2rat1088z75_103); 
BgL_periodzd2siza7ezd2nearzd2rat1089z75_148 = 
CINT(BgL_periodzd2siza7ezd2nearzd2rat1089z75_104); 
BgL_z52z12dpause1090z40_149 = 
CBOOL(BgL_z52z12dpause1090z40_105); 
BgL_z52z12dabort1091z40_150 = 
CBOOL(BgL_z52z12dabort1091z40_106); 
BgL_z52z12stop1092z40_151 = 
CBOOL(BgL_z52z12stop1092z40_107); 
BgL_z52z12dseek1098z40_156 = 
(long)CINT(BgL_z52z12dseek1098z40_113); 
BgL_z52rate1099z52_157 = 
CINT(BgL_z52rate1099z52_114); 
BgL_z52channels1100z52_158 = 
CINT(BgL_z52channels1100z52_115); 
{ /* Llib/mpg123_alsadec.scm 28 */
BgL_mpg123zd2alsadecoderzd2_bglt BgL_new1107z00_160;
{ /* Llib/mpg123_alsadec.scm 28 */
BgL_mpg123zd2alsadecoderzd2_bglt BgL_new1106z00_161;
BgL_new1106z00_161 = 
((BgL_mpg123zd2alsadecoderzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_mpg123zd2alsadecoderzd2_bgl) ))); 
{ /* Llib/mpg123_alsadec.scm 28 */
long BgL_arg1127z00_162;
{ /* Llib/mpg123_alsadec.scm 28 */
long BgL_res1178z00_163;
BgL_res1178z00_163 = 
BGL_CLASS_INDEX(BGl_mpg123zd2alsadecoderzd2zz__mpg123_alsadecz00); 
BgL_arg1127z00_162 = BgL_res1178z00_163; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1106z00_161), BgL_arg1127z00_162); } 
BgL_new1107z00_160 = BgL_new1106z00_161; } 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1107z00_160)))->BgL_mimetypesz00)=((obj_t)
((obj_t)BgL_mimetypes1086z00_101)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1107z00_160)))->BgL_bufferzd2timezd2nearz00)=((int)BgL_bufferzd2timezd2near1087z00_146),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1107z00_160)))->BgL_bufferzd2siza7ezd2nearzd2ratioz75)=((int)BgL_bufferzd2siza7ezd2nearzd2rat1088z75_147),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1107z00_160)))->BgL_periodzd2siza7ezd2nearzd2ratioz75)=((int)BgL_periodzd2siza7ezd2nearzd2rat1089z75_148),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1107z00_160)))->BgL_z52z12dpausez40)=((bool_t)BgL_z52z12dpause1090z40_149),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1107z00_160)))->BgL_z52z12dabortz40)=((bool_t)BgL_z52z12dabort1091z40_150),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1107z00_160)))->BgL_z52z12stopz40)=((bool_t)BgL_z52z12stop1092z40_151),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1107z00_160)))->BgL_z52dmutexz52)=((obj_t)
((obj_t)BgL_z52dmutex1093z52_108)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1107z00_160)))->BgL_z52dcondvz52)=((obj_t)
((obj_t)BgL_z52dcondv1094z52_109)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1107z00_160)))->BgL_z52doutcondvz52)=((obj_t)
((obj_t)BgL_z52doutcondv1095z52_110)),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_new1107z00_160)))->BgL_outbufz00)=((obj_t)
((obj_t)BgL_outbuf1096z00_111)),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_new1107z00_160)))->BgL_z52mpg123z52)=((obj_t)BgL_z52mpg1231097z52_112),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_new1107z00_160)))->BgL_z52z12dseekz40)=((long)BgL_z52z12dseek1098z40_156),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_new1107z00_160)))->BgL_z52ratez52)=((int)BgL_z52rate1099z52_157),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_new1107z00_160)))->BgL_z52channelsz52)=((int)BgL_z52channels1100z52_158),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_new1107z00_160)))->BgL_z52encodingz52)=((obj_t)
((obj_t)BgL_z52encoding1101z52_116)),BUNSPEC); 
{ /* Llib/mpg123_alsadec.scm 28 */
obj_t BgL_fun1126z00_164;
BgL_fun1126z00_164 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_mpg123zd2alsadecoderzd2zz__mpg123_alsadecz00); 
PROCEDURE_ENTRY(BgL_fun1126z00_164)(BgL_fun1126z00_164, 
((obj_t)BgL_new1107z00_160), BEOA); } 
return BgL_new1107z00_160;} } } 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__mpg123_alsadecz00()
{
{ /* Llib/mpg123_alsadec.scm 15 */
return BUNSPEC;} 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__mpg123_alsadecz00()
{
{ /* Llib/mpg123_alsadec.scm 15 */
return 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2hwparamszd2setz12zd2envzc0zz__multimediazd2musicbufzd2, BGl_mpg123zd2decoderzd2zz__mpg123_decoderz00, BGl_proc1189z00zz__mpg123_alsadecz00, BGl_string1190z00zz__mpg123_alsadecz00);} 

}



/* &musicdecoder-hwparam1111 */
obj_t BGl_z62musicdecoderzd2hwparam1111zb0zz__mpg123_alsadecz00(obj_t BgL_envz00_120, obj_t BgL_decz00_121, obj_t BgL_amz00_122, obj_t BgL_bufferz00_123)
{
{ /* Llib/mpg123_alsadec.scm 40 */
{ /* Llib/mpg123_alsadec.scm 48 */
BgL_alsazd2sndzd2pcmz00_bglt BgL_arg1132z00_166;
BgL_arg1132z00_166 = 
(((BgL_alsamusicz00_bglt)COBJECT(
((BgL_alsamusicz00_bglt)BgL_amz00_122)))->BgL_pcmz00); 
BGl_alsazd2sndzd2pcmzd2reopenzd2zz__alsa_pcmz00(BgL_arg1132z00_166); } 
{ /* Llib/mpg123_alsadec.scm 49 */
BgL_alsazd2sndzd2pcmz00_bglt BgL_arg1134z00_167;obj_t BgL_arg1136z00_168;int BgL_arg1138z00_169;int BgL_arg1140z00_170;int BgL_arg1143z00_171;int BgL_arg1146z00_172;
BgL_arg1134z00_167 = 
(((BgL_alsamusicz00_bglt)COBJECT(
((BgL_alsamusicz00_bglt)BgL_amz00_122)))->BgL_pcmz00); 
BgL_arg1136z00_168 = 
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_121)))->BgL_z52encodingz52); 
BgL_arg1138z00_169 = 
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_121)))->BgL_z52channelsz52); 
BgL_arg1140z00_170 = 
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_121)))->BgL_z52ratez52); 
BgL_arg1143z00_171 = 
(((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_121))))->BgL_bufferzd2siza7ezd2nearzd2ratioz75); 
BgL_arg1146z00_172 = 
(((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_121))))->BgL_periodzd2siza7ezd2nearzd2ratioz75); 
{ /* Llib/mpg123_alsadec.scm 49 */
obj_t BgL_list1147z00_173;
{ /* Llib/mpg123_alsadec.scm 49 */
obj_t BgL_arg1148z00_174;
{ /* Llib/mpg123_alsadec.scm 49 */
obj_t BgL_arg1152z00_175;
{ /* Llib/mpg123_alsadec.scm 49 */
obj_t BgL_arg1154z00_176;
{ /* Llib/mpg123_alsadec.scm 49 */
obj_t BgL_arg1156z00_177;
{ /* Llib/mpg123_alsadec.scm 49 */
obj_t BgL_arg1157z00_178;
{ /* Llib/mpg123_alsadec.scm 49 */
obj_t BgL_arg1158z00_179;
{ /* Llib/mpg123_alsadec.scm 49 */
obj_t BgL_arg1159z00_180;
{ /* Llib/mpg123_alsadec.scm 49 */
obj_t BgL_arg1160z00_181;
{ /* Llib/mpg123_alsadec.scm 49 */
obj_t BgL_arg1161z00_182;
{ /* Llib/mpg123_alsadec.scm 49 */
obj_t BgL_arg1167z00_183;
{ /* Llib/mpg123_alsadec.scm 49 */
obj_t BgL_arg1168z00_184;
BgL_arg1168z00_184 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1146z00_172), BNIL); 
BgL_arg1167z00_183 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)3)), BgL_arg1168z00_184); } 
BgL_arg1161z00_182 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1143z00_171), BgL_arg1167z00_183); } 
BgL_arg1160z00_181 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)4)), BgL_arg1161z00_182); } 
BgL_arg1159z00_180 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1140z00_170), BgL_arg1160z00_181); } 
BgL_arg1158z00_179 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)5)), BgL_arg1159z00_180); } 
BgL_arg1157z00_178 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1138z00_169), BgL_arg1158z00_179); } 
BgL_arg1156z00_177 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)6)), BgL_arg1157z00_178); } 
BgL_arg1154z00_176 = 
MAKE_YOUNG_PAIR(BgL_arg1136z00_168, BgL_arg1156z00_177); } 
BgL_arg1152z00_175 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)7)), BgL_arg1154z00_176); } 
BgL_arg1148z00_174 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)8)), BgL_arg1152z00_175); } 
BgL_list1147z00_173 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)9)), BgL_arg1148z00_174); } 
BGl_alsazd2sndzd2pcmzd2hwzd2setzd2paramsz12zc0zz__alsa_pcmz00(BgL_arg1134z00_167, BgL_list1147z00_173); } } 
{ /* Llib/mpg123_alsadec.scm 56 */
BgL_alsazd2sndzd2pcmz00_bglt BgL_arg1171z00_185;
BgL_arg1171z00_185 = 
(((BgL_alsamusicz00_bglt)COBJECT(
((BgL_alsamusicz00_bglt)BgL_amz00_122)))->BgL_pcmz00); 
{ /* Llib/mpg123_alsadec.scm 56 */
obj_t BgL_list1172z00_186;
{ /* Llib/mpg123_alsadec.scm 56 */
obj_t BgL_arg1173z00_187;
{ /* Llib/mpg123_alsadec.scm 56 */
obj_t BgL_arg1175z00_188;
{ /* Llib/mpg123_alsadec.scm 56 */
obj_t BgL_arg1177z00_189;
BgL_arg1177z00_189 = 
MAKE_YOUNG_PAIR(
BINT(((long)1)), BNIL); 
BgL_arg1175z00_188 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)10)), BgL_arg1177z00_189); } 
BgL_arg1173z00_187 = 
MAKE_YOUNG_PAIR(
BINT(((long)1)), BgL_arg1175z00_188); } 
BgL_list1172z00_186 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)11)), BgL_arg1173z00_187); } 
return 
BGl_alsazd2sndzd2pcmzd2swzd2setzd2paramsz12zc0zz__alsa_pcmz00(BgL_arg1171z00_185, BgL_list1172z00_186);} } } 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__mpg123_alsadecz00()
{
{ /* Llib/mpg123_alsadec.scm 15 */
BGl_modulezd2initializa7ationz75zz__mpg123_mpg123z00(((long)388603996), 
BSTRING_TO_STRING(BGl_string1191z00zz__mpg123_alsadecz00)); 
return 
BGl_modulezd2initializa7ationz75zz__mpg123_decoderz00(((long)0), 
BSTRING_TO_STRING(BGl_string1191z00zz__mpg123_alsadecz00));} 

}

#ifdef __cplusplus
}
#endif
