/*===========================================================================*/
/*   (Llib/music.scm)                                                        */
/*   Bigloo (4.3g)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu 27 Feb 2020 07:59:49 AM CET     */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo4.3g/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo4.3g/lib/bigloo/4.3g -lib-dir /builddir/build/BUILD/bigloo4.3g/lib/bigloo/4.3g -I Llib -lib-dir /builddir/build/BUILD/bigloo4.3g/lib/bigloo/4.3g -unsafe -safee -srfi pulseaudio -copt -D_REENTRANT -copt -fPIC -copt -IClib Llib/music.scm -o objs/music.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>
#include <pulse/simple.h>
#include <pulse/version.h>
#include <pulse/sample.h>
#include <pulse/error.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_musicz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_onstatez00;
   obj_t BgL_onvolumez00;
   obj_t BgL_onerrorz00;
   obj_t BgL_oneventz00;
   obj_t BgL_z52mutexz52;
   struct BgL_musicstatusz00_bgl * BgL_z52statusz52;
} *BgL_musicz00_bglt;

typedef struct BgL_musicstatusz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_statez00;
   obj_t BgL_volumez00;
   bool_t BgL_repeatz00;
   bool_t BgL_randomz00;
   int BgL_playlistidz00;
   int BgL_playlistlengthz00;
   int BgL_xfadez00;
   int BgL_songz00;
   int BgL_songidz00;
   obj_t BgL_songposz00;
   int BgL_songlengthz00;
   int BgL_bitratez00;
   int BgL_khza7za7;
   obj_t BgL_errz00;
   int BgL_bufferingz00;
} *BgL_musicstatusz00_bglt;

typedef struct BgL_musicbufz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_onstatez00;
   obj_t BgL_onvolumez00;
   obj_t BgL_onerrorz00;
   obj_t BgL_oneventz00;
   obj_t BgL_z52mutexz52;
   struct BgL_musicstatusz00_bgl * BgL_z52statusz52;
   obj_t BgL_inbufz00;
   obj_t BgL_decodersz00;
   obj_t BgL_mkthreadz00;
   obj_t BgL_timeoutz00;
   obj_t BgL_z52decoderz52;
   obj_t BgL_z52bufferz52;
   obj_t BgL_z52nextbufferz52;
   obj_t BgL_z52playlistz52;
   bool_t BgL_z52areadyz52;
   obj_t BgL_z52amutexz52;
   int BgL_z52z12pidz40;
   obj_t BgL_z52acondvz52;
} *BgL_musicbufz00_bglt;

typedef struct BgL_pulseaudiozd2simplezd2_bgl {
   header_t header;
   obj_t widening;
   pa_simple * BgL_z42builtinz42;
   obj_t BgL_srvnamez00;
   obj_t BgL_namez00;
   obj_t BgL_streamz00;
   long BgL_ratez00;
   long BgL_channelsz00;
   int BgL_bpsz00;
   obj_t BgL_formatz00;
} *BgL_pulseaudiozd2simplezd2_bglt;

typedef struct BgL_pulseaudiomusicz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_onstatez00;
   obj_t BgL_onvolumez00;
   obj_t BgL_onerrorz00;
   obj_t BgL_oneventz00;
   obj_t BgL_z52mutexz52;
   struct BgL_musicstatusz00_bgl * BgL_z52statusz52;
   obj_t BgL_inbufz00;
   obj_t BgL_decodersz00;
   obj_t BgL_mkthreadz00;
   obj_t BgL_timeoutz00;
   obj_t BgL_z52decoderz52;
   obj_t BgL_z52bufferz52;
   obj_t BgL_z52nextbufferz52;
   obj_t BgL_z52playlistz52;
   bool_t BgL_z52areadyz52;
   obj_t BgL_z52amutexz52;
   int BgL_z52z12pidz40;
   obj_t BgL_z52acondvz52;
   struct BgL_pulseaudiozd2simplezd2_bgl * BgL_simplez00;
   obj_t BgL_namez00;
} *BgL_pulseaudiomusicz00_bglt;


BGL_IMPORT obj_t BGl_classzd2nilzd2initz12z12zz__objectz00(obj_t);
static obj_t BGl_z62musiczd2closezd2pulseaud1115z62zz__pulseaudio_musicz00(obj_t, obj_t);
static obj_t BGl_objectzd2initzd2zz__pulseaudio_musicz00();
BGL_IMPORT obj_t BGl_musicbufz00zz__multimediazd2musicbufzd2;
static obj_t BGl_z62musicbufzd2resetz12zd2puls1123z70zz__pulseaudio_musicz00(obj_t, obj_t);
BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_pulseaudiomusiczd2simplezd2setz12z12zz__pulseaudio_musicz00(BgL_pulseaudiomusicz00_bglt, BgL_pulseaudiozd2simplezd2_bglt);
static obj_t BGl_methodzd2initzd2zz__pulseaudio_musicz00();
static obj_t BGl_z62zc3z04anonymousza31162ze3ze5zz__pulseaudio_musicz00(obj_t);
static obj_t BGl_z62musicbufzd2writezd2pulse1119z62zz__pulseaudio_musicz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31180ze3ze5zz__pulseaudio_musicz00(obj_t);
BGL_IMPORT obj_t BGl_conditionzd2variablezd2nilz00zz__threadz00();
BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_gczd2rootszd2initz00zz__pulseaudio_musicz00();
extern int bgl_pulseaudio_error(char *, char *, obj_t);
BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_musicstatusz00zz__multimediazd2musiczd2;
static obj_t BGl_z62musiczd2closedzf3zd2pulsea1117z91zz__pulseaudio_musicz00(obj_t, obj_t);
extern obj_t BGl_pulseaudiozd2simplezd2zz__pulseaudio_simplez00;
static obj_t BGl_requirezd2initializa7ationz75zz__pulseaudio_musicz00 = BUNSPEC;
BGL_IMPORT obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62musicbufzd2drainzd2pulse1121z62zz__pulseaudio_musicz00(obj_t, obj_t);
static obj_t BGl_toplevelzd2initzd2zz__pulseaudio_musicz00();
static obj_t BGl_genericzd2initzd2zz__pulseaudio_musicz00();
BGL_IMPORT obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t, bool_t, bool_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_mutexzd2nilzd2zz__threadz00();
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31155ze3ze5zz__pulseaudio_musicz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2constructorzd2zz__objectz00(obj_t);
static BgL_pulseaudiomusicz00_bglt BGl_z62lambda1147z62zz__pulseaudio_musicz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_pulseaudiomusicz00_bglt BGl_z62lambda1153z62zz__pulseaudio_musicz00(obj_t);
static obj_t BGl_z62pulseaudiomusiczd2simplezd2setz12z70zz__pulseaudio_musicz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__pulseaudio_musicz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__pulseaudio_simplez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__pulseaudio_pulseaudioz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2musicbufzd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
static BgL_pulseaudiozd2simplezd2_bglt BGl_z62lambda1160z62zz__pulseaudio_musicz00(obj_t, obj_t);
static obj_t BGl_z62lambda1161z62zz__pulseaudio_musicz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1178z62zz__pulseaudio_musicz00(obj_t, obj_t);
static obj_t BGl_z62lambda1179z62zz__pulseaudio_musicz00(obj_t, obj_t, obj_t);
static obj_t BGl_cnstzd2initzd2zz__pulseaudio_musicz00();
static obj_t BGl_libraryzd2moduleszd2initz00zz__pulseaudio_musicz00();
static obj_t BGl_importedzd2moduleszd2initz00zz__pulseaudio_musicz00();
BGL_IMPORT obj_t BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(obj_t);
BGL_EXPORTED_DEF obj_t BGl_pulseaudiomusicz00zz__pulseaudio_musicz00 = BUNSPEC;
extern obj_t BGl_pulseaudiozd2simplezd2statez00zz__pulseaudio_simplez00(BgL_pulseaudiozd2simplezd2_bglt);
extern obj_t BGl_pulseaudiozd2simplezd2closez00zz__pulseaudio_simplez00(BgL_pulseaudiozd2simplezd2_bglt);
static obj_t __cnst[ 7 ] ;


DEFINE_STRING( BGl_string1277z00zz__pulseaudio_musicz00, BgL_bgl_string1277za700za7za7_1348za7, "Llib/music.scm", 14 );
DEFINE_STRING( BGl_string1278z00zz__pulseaudio_musicz00, BgL_bgl_string1278za700za7za7_1349za7, "/builddir/build/BUILD/bigloo4.3g/api/pulseaudio/src/Llib/music.scm", 66 );
DEFINE_STRING( BGl_string1279z00zz__pulseaudio_musicz00, BgL_bgl_string1279za700za7za7_1350za7, "&pulseaudiomusic-simple-set!", 28 );
DEFINE_STRING( BGl_string1280z00zz__pulseaudio_musicz00, BgL_bgl_string1280za700za7za7_1351za7, "pulseaudiomusic", 15 );
DEFINE_STRING( BGl_string1281z00zz__pulseaudio_musicz00, BgL_bgl_string1281za700za7za7_1352za7, "pulseaudio-simple", 17 );
DEFINE_STRING( BGl_string1291z00zz__pulseaudio_musicz00, BgL_bgl_string1291za700za7za7_1353za7, "", 0 );
DEFINE_STRING( BGl_string1292z00zz__pulseaudio_musicz00, BgL_bgl_string1292za700za7za7_1354za7, "bigloo", 6 );
DEFINE_STRING( BGl_string1294z00zz__pulseaudio_musicz00, BgL_bgl_string1294za700za7za7_1355za7, "music-close", 11 );
DEFINE_STRING( BGl_string1296z00zz__pulseaudio_musicz00, BgL_bgl_string1296za700za7za7_1356za7, "music-closed?", 13 );
DEFINE_STRING( BGl_string1298z00zz__pulseaudio_musicz00, BgL_bgl_string1298za700za7za7_1357za7, "musicbuf-write", 14 );
BGL_IMPORT obj_t BGl_musiczd2initzd2envz00zz__multimediazd2musiczd2;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_pulseaudiomusiczd2simplezd2setz12zd2envzc0zz__pulseaudio_musicz00, BgL_bgl_za762pulseaudiomus1358za7, BGl_z62pulseaudiomusiczd2simplezd2setz12z70zz__pulseaudio_musicz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string1300z00zz__pulseaudio_musicz00, BgL_bgl_string1300za700za7za7_1359za7, "musicbuf-drain", 14 );
DEFINE_STRING( BGl_string1302z00zz__pulseaudio_musicz00, BgL_bgl_string1302za700za7za7_1360za7, "musicbuf-reset!", 15 );
DEFINE_STRING( BGl_string1303z00zz__pulseaudio_musicz00, BgL_bgl_string1303za700za7za7_1361za7, "pulseaudio-simple-flush", 23 );
DEFINE_STRING( BGl_string1304z00zz__pulseaudio_musicz00, BgL_bgl_string1304za700za7za7_1362za7, "pulseaudio-simple-drain", 23 );
DEFINE_STRING( BGl_string1305z00zz__pulseaudio_musicz00, BgL_bgl_string1305za700za7za7_1363za7, "pulseaudio-simple-write", 23 );
DEFINE_STRING( BGl_string1306z00zz__pulseaudio_musicz00, BgL_bgl_string1306za700za7za7_1364za7, "__pulseaudio_music", 18 );
DEFINE_STRING( BGl_string1307z00zz__pulseaudio_musicz00, BgL_bgl_string1307za700za7za7_1365za7, "closed s16 __pulseaudio_music pulseaudiomusic bstring name simple ", 66 );
BGL_IMPORT obj_t BGl_musicbufzd2resetz12zd2envz12zz__multimediazd2musicbufzd2;
BGL_IMPORT obj_t BGl_musicbufzd2drainzd2envz00zz__multimediazd2musicbufzd2;
BGL_IMPORT obj_t BGl_musiczd2closedzf3zd2envzf3zz__multimediazd2musiczd2;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1282z00zz__pulseaudio_musicz00, BgL_bgl_za762za7c3za704anonymo1366za7, BGl_z62zc3z04anonymousza31162ze3ze5zz__pulseaudio_musicz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1283z00zz__pulseaudio_musicz00, BgL_bgl_za762lambda1161za7621367z00, BGl_z62lambda1161z62zz__pulseaudio_musicz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1284z00zz__pulseaudio_musicz00, BgL_bgl_za762lambda1160za7621368z00, BGl_z62lambda1160z62zz__pulseaudio_musicz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1285z00zz__pulseaudio_musicz00, BgL_bgl_za762za7c3za704anonymo1369za7, BGl_z62zc3z04anonymousza31180ze3ze5zz__pulseaudio_musicz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1286z00zz__pulseaudio_musicz00, BgL_bgl_za762lambda1179za7621370z00, BGl_z62lambda1179z62zz__pulseaudio_musicz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1287z00zz__pulseaudio_musicz00, BgL_bgl_za762lambda1178za7621371z00, BGl_z62lambda1178z62zz__pulseaudio_musicz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1288z00zz__pulseaudio_musicz00, BgL_bgl_za762za7c3za704anonymo1372za7, BGl_z62zc3z04anonymousza31155ze3ze5zz__pulseaudio_musicz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1289z00zz__pulseaudio_musicz00, BgL_bgl_za762lambda1153za7621373z00, BGl_z62lambda1153z62zz__pulseaudio_musicz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1290z00zz__pulseaudio_musicz00, BgL_bgl_za762lambda1147za7621374z00, BGl_z62lambda1147z62zz__pulseaudio_musicz00, 0L, BUNSPEC, 20 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1293z00zz__pulseaudio_musicz00, BgL_bgl_za762musicza7d2close1375z00, BGl_z62musiczd2closezd2pulseaud1115z62zz__pulseaudio_musicz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1295z00zz__pulseaudio_musicz00, BgL_bgl_za762musicza7d2close1376z00, BGl_z62musiczd2closedzf3zd2pulsea1117z91zz__pulseaudio_musicz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1297z00zz__pulseaudio_musicz00, BgL_bgl_za762musicbufza7d2wr1377z00, BGl_z62musicbufzd2writezd2pulse1119z62zz__pulseaudio_musicz00, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1299z00zz__pulseaudio_musicz00, BgL_bgl_za762musicbufza7d2dr1378z00, BGl_z62musicbufzd2drainzd2pulse1121z62zz__pulseaudio_musicz00, 0L, BUNSPEC, 1 );
BGL_IMPORT obj_t BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00;
BGL_IMPORT obj_t BGl_musiczd2closezd2envz00zz__multimediazd2musiczd2;
BGL_IMPORT obj_t BGl_musicbufzd2writezd2envz00zz__multimediazd2musicbufzd2;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1301z00zz__pulseaudio_musicz00, BgL_bgl_za762musicbufza7d2re1379z00, BGl_z62musicbufzd2resetz12zd2puls1123z70zz__pulseaudio_musicz00, 0L, BUNSPEC, 1 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__pulseaudio_musicz00) );
ADD_ROOT( (void *)(&BGl_pulseaudiomusicz00zz__pulseaudio_musicz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__pulseaudio_musicz00(long BgL_checksumz00_420, char * BgL_fromz00_421)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__pulseaudio_musicz00))
{ 
BGl_requirezd2initializa7ationz75zz__pulseaudio_musicz00 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__pulseaudio_musicz00(); 
BGl_libraryzd2moduleszd2initz00zz__pulseaudio_musicz00(); 
BGl_cnstzd2initzd2zz__pulseaudio_musicz00(); 
BGl_importedzd2moduleszd2initz00zz__pulseaudio_musicz00(); 
BGl_objectzd2initzd2zz__pulseaudio_musicz00(); 
BGl_methodzd2initzd2zz__pulseaudio_musicz00(); 
return 
BGl_toplevelzd2initzd2zz__pulseaudio_musicz00();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__pulseaudio_musicz00()
{
{ /* Llib/music.scm 15 */
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__pulseaudio_music"); 
BGl_modulezd2initializa7ationz75zz__multimediazd2musicbufzd2(((long)0), "__pulseaudio_music"); 
BGl_modulezd2initializa7ationz75zz__threadz00(((long)0), "__pulseaudio_music"); 
BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(((long)0), "__pulseaudio_music"); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "__pulseaudio_music"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "__pulseaudio_music"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__pulseaudio_music"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__pulseaudio_music"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__pulseaudio_music"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__pulseaudio_music"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__pulseaudio_music"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__pulseaudio_musicz00()
{
{ /* Llib/music.scm 15 */
{ /* Llib/music.scm 15 */
obj_t BgL_cportz00_338;
{ /* Llib/music.scm 15 */
obj_t BgL_stringz00_346;
BgL_stringz00_346 = BGl_string1307z00zz__pulseaudio_musicz00; 
{ /* Llib/music.scm 15 */
obj_t BgL_startz00_347;
BgL_startz00_347 = 
BINT(((long)0)); 
{ /* Llib/music.scm 15 */
obj_t BgL_endz00_348;
BgL_endz00_348 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_346))); 
{ /* Llib/music.scm 15 */

BgL_cportz00_338 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_346, BgL_startz00_347, BgL_endz00_348); } } } } 
{ 
long BgL_iz00_339;
BgL_iz00_339 = ((long)6); 
BgL_loopz00_340:
if(
(BgL_iz00_339==((long)-1)))
{ /* Llib/music.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/music.scm 15 */
{ /* Llib/music.scm 15 */
obj_t BgL_arg1346z00_342;
{ /* Llib/music.scm 15 */

{ /* Llib/music.scm 15 */
obj_t BgL_locationz00_344;
BgL_locationz00_344 = 
BBOOL(((bool_t)0)); 
{ /* Llib/music.scm 15 */

BgL_arg1346z00_342 = 
BGl_readz00zz__readerz00(BgL_cportz00_338, BgL_locationz00_344); } } } 
{ /* Llib/music.scm 15 */
int BgL_tmpz00_452;
BgL_tmpz00_452 = 
(int)(BgL_iz00_339); 
CNST_TABLE_SET(BgL_tmpz00_452, BgL_arg1346z00_342); } } 
{ /* Llib/music.scm 15 */
int BgL_auxz00_345;
BgL_auxz00_345 = 
(int)(
(BgL_iz00_339-((long)1))); 
{ 
long BgL_iz00_457;
BgL_iz00_457 = 
(long)(BgL_auxz00_345); 
BgL_iz00_339 = BgL_iz00_457; 
goto BgL_loopz00_340;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__pulseaudio_musicz00()
{
{ /* Llib/music.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__pulseaudio_musicz00()
{
{ /* Llib/music.scm 15 */
BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(((long)0), 
BSTRING_TO_STRING(BGl_string1277z00zz__pulseaudio_musicz00)); 
return BUNSPEC;} 

}



/* pulseaudiomusic-simple-set! */
BGL_EXPORTED_DEF obj_t BGl_pulseaudiomusiczd2simplezd2setz12z12zz__pulseaudio_musicz00(BgL_pulseaudiomusicz00_bglt BgL_oz00_10, BgL_pulseaudiozd2simplezd2_bglt BgL_sz00_11)
{
{ /* Llib/music.scm 69 */
BGl_pulseaudiozd2simplezd2closez00zz__pulseaudio_simplez00(
(((BgL_pulseaudiomusicz00_bglt)COBJECT(BgL_oz00_10))->BgL_simplez00)); 
((((BgL_pulseaudiomusicz00_bglt)COBJECT(BgL_oz00_10))->BgL_simplez00)=((BgL_pulseaudiozd2simplezd2_bglt)BgL_sz00_11),BUNSPEC); 
return 
((obj_t)BgL_sz00_11);} 

}



/* &pulseaudiomusic-simple-set! */
obj_t BGl_z62pulseaudiomusiczd2simplezd2setz12z70zz__pulseaudio_musicz00(obj_t BgL_envz00_248, obj_t BgL_oz00_249, obj_t BgL_sz00_250)
{
{ /* Llib/music.scm 69 */
{ /* Llib/music.scm 70 */
BgL_pulseaudiozd2simplezd2_bglt BgL_auxz00_474;BgL_pulseaudiomusicz00_bglt BgL_auxz00_466;
if(
BGl_isazf3zf3zz__objectz00(BgL_sz00_250, BGl_pulseaudiozd2simplezd2zz__pulseaudio_simplez00))
{ /* Llib/music.scm 70 */
BgL_auxz00_474 = 
((BgL_pulseaudiozd2simplezd2_bglt)BgL_sz00_250)
; }  else 
{ 
obj_t BgL_auxz00_478;
BgL_auxz00_478 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1278z00zz__pulseaudio_musicz00, 
BINT(((long)3551)), BGl_string1279z00zz__pulseaudio_musicz00, BGl_string1281z00zz__pulseaudio_musicz00, BgL_sz00_250); 
FAILURE(BgL_auxz00_478,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_249, BGl_pulseaudiomusicz00zz__pulseaudio_musicz00))
{ /* Llib/music.scm 70 */
BgL_auxz00_466 = 
((BgL_pulseaudiomusicz00_bglt)BgL_oz00_249)
; }  else 
{ 
obj_t BgL_auxz00_470;
BgL_auxz00_470 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1278z00zz__pulseaudio_musicz00, 
BINT(((long)3551)), BGl_string1279z00zz__pulseaudio_musicz00, BGl_string1280z00zz__pulseaudio_musicz00, BgL_oz00_249); 
FAILURE(BgL_auxz00_470,BFALSE,BFALSE);} 
return 
BGl_pulseaudiomusiczd2simplezd2setz12z12zz__pulseaudio_musicz00(BgL_auxz00_466, BgL_auxz00_474);} } 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__pulseaudio_musicz00()
{
{ /* Llib/music.scm 15 */
{ /* Llib/music.scm 22 */
obj_t BgL_arg1143z00_33;obj_t BgL_arg1146z00_34;
{ /* Llib/music.scm 22 */
obj_t BgL_v1112z00_65;
BgL_v1112z00_65 = 
create_vector(((long)2)); 
{ /* Llib/music.scm 22 */
obj_t BgL_arg1156z00_66;
BgL_arg1156z00_66 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)0)), BGl_proc1284z00zz__pulseaudio_musicz00, BGl_proc1283z00zz__pulseaudio_musicz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1282z00zz__pulseaudio_musicz00, BGl_pulseaudiozd2simplezd2zz__pulseaudio_simplez00); 
VECTOR_SET(BgL_v1112z00_65,((long)0),BgL_arg1156z00_66); } 
{ /* Llib/music.scm 22 */
obj_t BgL_arg1172z00_85;
BgL_arg1172z00_85 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)1)), BGl_proc1287z00zz__pulseaudio_musicz00, BGl_proc1286z00zz__pulseaudio_musicz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1285z00zz__pulseaudio_musicz00, 
CNST_TABLE_REF(((long)2))); 
VECTOR_SET(BgL_v1112z00_65,((long)1),BgL_arg1172z00_85); } 
BgL_arg1143z00_33 = BgL_v1112z00_65; } 
{ /* Llib/music.scm 22 */
obj_t BgL_v1113z00_98;
BgL_v1113z00_98 = 
create_vector(((long)0)); 
BgL_arg1146z00_34 = BgL_v1113z00_98; } 
return ( 
BGl_pulseaudiomusicz00zz__pulseaudio_musicz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)3)), 
CNST_TABLE_REF(((long)4)), BGl_musicbufz00zz__multimediazd2musicbufzd2, ((long)62652), BGl_proc1290z00zz__pulseaudio_musicz00, BGl_proc1289z00zz__pulseaudio_musicz00, BGl_musiczd2initzd2envz00zz__multimediazd2musiczd2, BGl_proc1288z00zz__pulseaudio_musicz00, BFALSE, BgL_arg1143z00_33, BgL_arg1146z00_34), BUNSPEC) ;} } 

}



/* &<@anonymous:1155> */
obj_t BGl_z62zc3z04anonymousza31155ze3ze5zz__pulseaudio_musicz00(obj_t BgL_envz00_263, obj_t BgL_new1097z00_264)
{
{ /* Llib/music.scm 22 */
{ 
BgL_pulseaudiomusicz00_bglt BgL_auxz00_495;
((((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)
((BgL_pulseaudiomusicz00_bglt)BgL_new1097z00_264))))->BgL_onstatez00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)
((BgL_pulseaudiomusicz00_bglt)BgL_new1097z00_264))))->BgL_onvolumez00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)
((BgL_pulseaudiomusicz00_bglt)BgL_new1097z00_264))))->BgL_onerrorz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)
((BgL_pulseaudiomusicz00_bglt)BgL_new1097z00_264))))->BgL_oneventz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)
((BgL_pulseaudiomusicz00_bglt)BgL_new1097z00_264))))->BgL_z52mutexz52)=((obj_t)
BGl_mutexzd2nilzd2zz__threadz00()),BUNSPEC); 
{ 
BgL_musicstatusz00_bglt BgL_auxz00_512;
{ /* Llib/music.scm 22 */
obj_t BgL_classz00_352;
BgL_classz00_352 = BGl_musicstatusz00zz__multimediazd2musiczd2; 
{ /* Llib/music.scm 22 */
obj_t BgL__ortest_1107z00_353;
BgL__ortest_1107z00_353 = 
BGL_CLASS_NIL(BgL_classz00_352); 
if(
CBOOL(BgL__ortest_1107z00_353))
{ /* Llib/music.scm 22 */
BgL_auxz00_512 = 
((BgL_musicstatusz00_bglt)BgL__ortest_1107z00_353)
; }  else 
{ /* Llib/music.scm 22 */
BgL_auxz00_512 = 
((BgL_musicstatusz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_352))
; } } } 
((((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)
((BgL_pulseaudiomusicz00_bglt)BgL_new1097z00_264))))->BgL_z52statusz52)=((BgL_musicstatusz00_bglt)BgL_auxz00_512),BUNSPEC); } 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_pulseaudiomusicz00_bglt)BgL_new1097z00_264))))->BgL_inbufz00)=((obj_t)BGl_string1291z00zz__pulseaudio_musicz00),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_pulseaudiomusicz00_bglt)BgL_new1097z00_264))))->BgL_decodersz00)=((obj_t)BNIL),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_pulseaudiomusicz00_bglt)BgL_new1097z00_264))))->BgL_mkthreadz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_pulseaudiomusicz00_bglt)BgL_new1097z00_264))))->BgL_timeoutz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_pulseaudiomusicz00_bglt)BgL_new1097z00_264))))->BgL_z52decoderz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_pulseaudiomusicz00_bglt)BgL_new1097z00_264))))->BgL_z52bufferz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_pulseaudiomusicz00_bglt)BgL_new1097z00_264))))->BgL_z52nextbufferz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_pulseaudiomusicz00_bglt)BgL_new1097z00_264))))->BgL_z52playlistz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_pulseaudiomusicz00_bglt)BgL_new1097z00_264))))->BgL_z52areadyz52)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_pulseaudiomusicz00_bglt)BgL_new1097z00_264))))->BgL_z52amutexz52)=((obj_t)
BGl_mutexzd2nilzd2zz__threadz00()),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_pulseaudiomusicz00_bglt)BgL_new1097z00_264))))->BgL_z52z12pidz40)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_pulseaudiomusicz00_bglt)BgL_new1097z00_264))))->BgL_z52acondvz52)=((obj_t)
BGl_conditionzd2variablezd2nilz00zz__threadz00()),BUNSPEC); 
{ 
BgL_pulseaudiozd2simplezd2_bglt BgL_auxz00_561;
{ /* Llib/music.scm 22 */
obj_t BgL_classz00_354;
BgL_classz00_354 = BGl_pulseaudiozd2simplezd2zz__pulseaudio_simplez00; 
{ /* Llib/music.scm 22 */
obj_t BgL__ortest_1107z00_355;
BgL__ortest_1107z00_355 = 
BGL_CLASS_NIL(BgL_classz00_354); 
if(
CBOOL(BgL__ortest_1107z00_355))
{ /* Llib/music.scm 22 */
BgL_auxz00_561 = 
((BgL_pulseaudiozd2simplezd2_bglt)BgL__ortest_1107z00_355)
; }  else 
{ /* Llib/music.scm 22 */
BgL_auxz00_561 = 
((BgL_pulseaudiozd2simplezd2_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_354))
; } } } 
((((BgL_pulseaudiomusicz00_bglt)COBJECT(
((BgL_pulseaudiomusicz00_bglt)BgL_new1097z00_264)))->BgL_simplez00)=((BgL_pulseaudiozd2simplezd2_bglt)BgL_auxz00_561),BUNSPEC); } 
((((BgL_pulseaudiomusicz00_bglt)COBJECT(
((BgL_pulseaudiomusicz00_bglt)BgL_new1097z00_264)))->BgL_namez00)=((obj_t)BGl_string1291z00zz__pulseaudio_musicz00),BUNSPEC); 
BgL_auxz00_495 = 
((BgL_pulseaudiomusicz00_bglt)BgL_new1097z00_264); 
return 
((obj_t)BgL_auxz00_495);} } 

}



/* &lambda1153 */
BgL_pulseaudiomusicz00_bglt BGl_z62lambda1153z62zz__pulseaudio_musicz00(obj_t BgL_envz00_265)
{
{ /* Llib/music.scm 22 */
{ /* Llib/music.scm 22 */
BgL_pulseaudiomusicz00_bglt BgL_new1096z00_356;
BgL_new1096z00_356 = 
((BgL_pulseaudiomusicz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pulseaudiomusicz00_bgl) ))); 
{ /* Llib/music.scm 22 */
long BgL_arg1154z00_357;
{ /* Llib/music.scm 22 */
long BgL_res1257z00_358;
BgL_res1257z00_358 = 
BGL_CLASS_INDEX(BGl_pulseaudiomusicz00zz__pulseaudio_musicz00); 
BgL_arg1154z00_357 = BgL_res1257z00_358; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1096z00_356), BgL_arg1154z00_357); } 
return BgL_new1096z00_356;} } 

}



/* &lambda1147 */
BgL_pulseaudiomusicz00_bglt BGl_z62lambda1147z62zz__pulseaudio_musicz00(obj_t BgL_envz00_266, obj_t BgL_onstate1076z00_267, obj_t BgL_onvolume1077z00_268, obj_t BgL_onerror1078z00_269, obj_t BgL_onevent1079z00_270, obj_t BgL_z52mutex1080z52_271, obj_t BgL_z52status1081z52_272, obj_t BgL_inbuf1082z00_273, obj_t BgL_decoders1083z00_274, obj_t BgL_mkthread1084z00_275, obj_t BgL_timeout1085z00_276, obj_t BgL_z52decoder1086z52_277, obj_t BgL_z52buffer1087z52_278, obj_t BgL_z52nextbuffer1088z52_279, obj_t BgL_z52playlist1089z52_280, obj_t BgL_z52aready1090z52_281, obj_t BgL_z52amutex1091z52_282, obj_t BgL_z52z12pid1092z40_283, obj_t BgL_z52acondv1093z52_284, obj_t BgL_simple1094z00_285, obj_t BgL_name1095z00_286)
{
{ /* Llib/music.scm 22 */
{ /* Llib/music.scm 22 */
bool_t BgL_z52aready1090z52_369;int BgL_z52z12pid1092z40_371;
BgL_z52aready1090z52_369 = 
CBOOL(BgL_z52aready1090z52_281); 
BgL_z52z12pid1092z40_371 = 
CINT(BgL_z52z12pid1092z40_283); 
{ /* Llib/music.scm 22 */
BgL_pulseaudiomusicz00_bglt BgL_new1106z00_375;
{ /* Llib/music.scm 22 */
BgL_pulseaudiomusicz00_bglt BgL_new1105z00_376;
BgL_new1105z00_376 = 
((BgL_pulseaudiomusicz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pulseaudiomusicz00_bgl) ))); 
{ /* Llib/music.scm 22 */
long BgL_arg1152z00_377;
{ /* Llib/music.scm 22 */
long BgL_res1256z00_378;
BgL_res1256z00_378 = 
BGL_CLASS_INDEX(BGl_pulseaudiomusicz00zz__pulseaudio_musicz00); 
BgL_arg1152z00_377 = BgL_res1256z00_378; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1105z00_376), BgL_arg1152z00_377); } 
BgL_new1106z00_375 = BgL_new1105z00_376; } 
((((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)BgL_new1106z00_375)))->BgL_onstatez00)=((obj_t)
((obj_t)BgL_onstate1076z00_267)),BUNSPEC); 
((((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)BgL_new1106z00_375)))->BgL_onvolumez00)=((obj_t)
((obj_t)BgL_onvolume1077z00_268)),BUNSPEC); 
((((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)BgL_new1106z00_375)))->BgL_onerrorz00)=((obj_t)
((obj_t)BgL_onerror1078z00_269)),BUNSPEC); 
((((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)BgL_new1106z00_375)))->BgL_oneventz00)=((obj_t)
((obj_t)BgL_onevent1079z00_270)),BUNSPEC); 
((((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)BgL_new1106z00_375)))->BgL_z52mutexz52)=((obj_t)
((obj_t)BgL_z52mutex1080z52_271)),BUNSPEC); 
((((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)BgL_new1106z00_375)))->BgL_z52statusz52)=((BgL_musicstatusz00_bglt)
((BgL_musicstatusz00_bglt)BgL_z52status1081z52_272)),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)BgL_new1106z00_375)))->BgL_inbufz00)=((obj_t)
((obj_t)BgL_inbuf1082z00_273)),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)BgL_new1106z00_375)))->BgL_decodersz00)=((obj_t)
((obj_t)BgL_decoders1083z00_274)),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)BgL_new1106z00_375)))->BgL_mkthreadz00)=((obj_t)
((obj_t)BgL_mkthread1084z00_275)),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)BgL_new1106z00_375)))->BgL_timeoutz00)=((obj_t)BgL_timeout1085z00_276),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)BgL_new1106z00_375)))->BgL_z52decoderz52)=((obj_t)BgL_z52decoder1086z52_277),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)BgL_new1106z00_375)))->BgL_z52bufferz52)=((obj_t)BgL_z52buffer1087z52_278),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)BgL_new1106z00_375)))->BgL_z52nextbufferz52)=((obj_t)BgL_z52nextbuffer1088z52_279),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)BgL_new1106z00_375)))->BgL_z52playlistz52)=((obj_t)
((obj_t)BgL_z52playlist1089z52_280)),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)BgL_new1106z00_375)))->BgL_z52areadyz52)=((bool_t)BgL_z52aready1090z52_369),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)BgL_new1106z00_375)))->BgL_z52amutexz52)=((obj_t)
((obj_t)BgL_z52amutex1091z52_282)),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)BgL_new1106z00_375)))->BgL_z52z12pidz40)=((int)BgL_z52z12pid1092z40_371),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)BgL_new1106z00_375)))->BgL_z52acondvz52)=((obj_t)
((obj_t)BgL_z52acondv1093z52_284)),BUNSPEC); 
((((BgL_pulseaudiomusicz00_bglt)COBJECT(BgL_new1106z00_375))->BgL_simplez00)=((BgL_pulseaudiozd2simplezd2_bglt)
((BgL_pulseaudiozd2simplezd2_bglt)BgL_simple1094z00_285)),BUNSPEC); 
((((BgL_pulseaudiomusicz00_bglt)COBJECT(BgL_new1106z00_375))->BgL_namez00)=((obj_t)
((obj_t)BgL_name1095z00_286)),BUNSPEC); 
{ /* Llib/music.scm 22 */
obj_t BgL_fun1148z00_379;
BgL_fun1148z00_379 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_pulseaudiomusicz00zz__pulseaudio_musicz00); 
PROCEDURE_ENTRY(BgL_fun1148z00_379)(BgL_fun1148z00_379, 
((obj_t)BgL_new1106z00_375), BEOA); } 
return BgL_new1106z00_375;} } } 

}



/* &<@anonymous:1180> */
obj_t BGl_z62zc3z04anonymousza31180ze3ze5zz__pulseaudio_musicz00(obj_t BgL_envz00_287)
{
{ /* Llib/music.scm 22 */
return BGl_string1292z00zz__pulseaudio_musicz00;} 

}



/* &lambda1179 */
obj_t BGl_z62lambda1179z62zz__pulseaudio_musicz00(obj_t BgL_envz00_288, obj_t BgL_oz00_289, obj_t BgL_vz00_290)
{
{ /* Llib/music.scm 22 */
return 
((((BgL_pulseaudiomusicz00_bglt)COBJECT(
((BgL_pulseaudiomusicz00_bglt)BgL_oz00_289)))->BgL_namez00)=((obj_t)
((obj_t)BgL_vz00_290)),BUNSPEC);} 

}



/* &lambda1178 */
obj_t BGl_z62lambda1178z62zz__pulseaudio_musicz00(obj_t BgL_envz00_291, obj_t BgL_oz00_292)
{
{ /* Llib/music.scm 22 */
return 
(((BgL_pulseaudiomusicz00_bglt)COBJECT(
((BgL_pulseaudiomusicz00_bglt)BgL_oz00_292)))->BgL_namez00);} 

}



/* &<@anonymous:1162> */
obj_t BGl_z62zc3z04anonymousza31162ze3ze5zz__pulseaudio_musicz00(obj_t BgL_envz00_293)
{
{ /* Llib/music.scm 22 */
{ 
BgL_pulseaudiozd2simplezd2_bglt BgL_auxz00_647;
{ /* Llib/music.scm 23 */
BgL_pulseaudiozd2simplezd2_bglt BgL_new1108z00_383;
{ /* Llib/music.scm 23 */
BgL_pulseaudiozd2simplezd2_bglt BgL_new1107z00_384;
BgL_new1107z00_384 = 
((BgL_pulseaudiozd2simplezd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pulseaudiozd2simplezd2_bgl) ))); 
{ /* Llib/music.scm 23 */
long BgL_arg1171z00_385;
{ /* Llib/music.scm 23 */
long BgL_res1254z00_386;
BgL_res1254z00_386 = 
BGL_CLASS_INDEX(BGl_pulseaudiozd2simplezd2zz__pulseaudio_simplez00); 
BgL_arg1171z00_385 = BgL_res1254z00_386; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1107z00_384), BgL_arg1171z00_385); } 
BgL_new1108z00_383 = BgL_new1107z00_384; } 
{ 
void * BgL_auxz00_652;
{ /* Llib/music.scm 23 */
obj_t BgL_arg1167z00_387;
{ /* Llib/music.scm 23 */
obj_t BgL_arg1168z00_388;
{ /* Llib/music.scm 23 */
obj_t BgL_res1255z00_389;
{ /* Llib/music.scm 23 */
obj_t BgL_classz00_390;
BgL_classz00_390 = BGl_pulseaudiozd2simplezd2zz__pulseaudio_simplez00; 
BgL_res1255z00_389 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_390); } 
BgL_arg1168z00_388 = BgL_res1255z00_389; } 
BgL_arg1167z00_387 = 
VECTOR_REF(BgL_arg1168z00_388,((long)0)); } 
BgL_auxz00_652 = 
FOREIGN_TO_COBJ(
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1167z00_387)); } 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1108z00_383))->BgL_z42builtinz42)=((pa_simple *)BgL_auxz00_652),BUNSPEC); } 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1108z00_383))->BgL_srvnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1108z00_383))->BgL_namez00)=((obj_t)BGl_string1292z00zz__pulseaudio_musicz00),BUNSPEC); 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1108z00_383))->BgL_streamz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1108z00_383))->BgL_ratez00)=((long)((long)44000)),BUNSPEC); 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1108z00_383))->BgL_channelsz00)=((long)((long)2)),BUNSPEC); 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1108z00_383))->BgL_bpsz00)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1108z00_383))->BgL_formatz00)=((obj_t)
CNST_TABLE_REF(((long)5))),BUNSPEC); 
{ /* Llib/music.scm 23 */
obj_t BgL_fun1169z00_391;
BgL_fun1169z00_391 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_pulseaudiozd2simplezd2zz__pulseaudio_simplez00); 
PROCEDURE_ENTRY(BgL_fun1169z00_391)(BgL_fun1169z00_391, 
((obj_t)BgL_new1108z00_383), BEOA); } 
BgL_auxz00_647 = BgL_new1108z00_383; } 
return 
((obj_t)BgL_auxz00_647);} } 

}



/* &lambda1161 */
obj_t BGl_z62lambda1161z62zz__pulseaudio_musicz00(obj_t BgL_envz00_294, obj_t BgL_oz00_295, obj_t BgL_vz00_296)
{
{ /* Llib/music.scm 22 */
return 
((((BgL_pulseaudiomusicz00_bglt)COBJECT(
((BgL_pulseaudiomusicz00_bglt)BgL_oz00_295)))->BgL_simplez00)=((BgL_pulseaudiozd2simplezd2_bglt)
((BgL_pulseaudiozd2simplezd2_bglt)BgL_vz00_296)),BUNSPEC);} 

}



/* &lambda1160 */
BgL_pulseaudiozd2simplezd2_bglt BGl_z62lambda1160z62zz__pulseaudio_musicz00(obj_t BgL_envz00_297, obj_t BgL_oz00_298)
{
{ /* Llib/music.scm 22 */
return 
(((BgL_pulseaudiomusicz00_bglt)COBJECT(
((BgL_pulseaudiomusicz00_bglt)BgL_oz00_298)))->BgL_simplez00);} 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__pulseaudio_musicz00()
{
{ /* Llib/music.scm 15 */
return BUNSPEC;} 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__pulseaudio_musicz00()
{
{ /* Llib/music.scm 15 */
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musiczd2closezd2envz00zz__multimediazd2musiczd2, BGl_pulseaudiomusicz00zz__pulseaudio_musicz00, BGl_proc1293z00zz__pulseaudio_musicz00, BGl_string1294z00zz__pulseaudio_musicz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musiczd2closedzf3zd2envzf3zz__multimediazd2musiczd2, BGl_pulseaudiomusicz00zz__pulseaudio_musicz00, BGl_proc1295z00zz__pulseaudio_musicz00, BGl_string1296z00zz__pulseaudio_musicz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicbufzd2writezd2envz00zz__multimediazd2musicbufzd2, BGl_pulseaudiomusicz00zz__pulseaudio_musicz00, BGl_proc1297z00zz__pulseaudio_musicz00, BGl_string1298z00zz__pulseaudio_musicz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicbufzd2drainzd2envz00zz__multimediazd2musicbufzd2, BGl_pulseaudiomusicz00zz__pulseaudio_musicz00, BGl_proc1299z00zz__pulseaudio_musicz00, BGl_string1300z00zz__pulseaudio_musicz00); 
return 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicbufzd2resetz12zd2envz12zz__multimediazd2musicbufzd2, BGl_pulseaudiomusicz00zz__pulseaudio_musicz00, BGl_proc1301z00zz__pulseaudio_musicz00, BGl_string1302z00zz__pulseaudio_musicz00);} 

}



/* &musicbuf-reset!-puls1123 */
obj_t BGl_z62musicbufzd2resetz12zd2puls1123z70zz__pulseaudio_musicz00(obj_t BgL_envz00_306, obj_t BgL_oz00_307)
{
{ /* Llib/music.scm 61 */
{ /* Llib/music.scm 64 */
BgL_pulseaudiozd2simplezd2_bglt BgL_arg1195z00_396;
BgL_arg1195z00_396 = 
(((BgL_pulseaudiomusicz00_bglt)COBJECT(
((BgL_pulseaudiomusicz00_bglt)BgL_oz00_307)))->BgL_simplez00); 
{ /* Llib/music.scm 64 */
int BgL_errz00_397;
BgL_errz00_397 = 
(int)(((long)0)); 
{ /* Llib/music.scm 64 */
pa_simple * BgL_arg1198z00_398;int * BgL_arg1199z00_399;
BgL_arg1198z00_398 = 
(((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_arg1195z00_396))->BgL_z42builtinz42); 
BgL_arg1199z00_399 = 
&(BgL_errz00_397); 
pa_simple_flush(BgL_arg1198z00_398, BgL_arg1199z00_399); } 
if(
(
(long)(BgL_errz00_397)<((long)0)))
{ /* Llib/music.scm 64 */
char * BgL_arg1204z00_400;
{ /* Llib/music.scm 64 */
int BgL_tmpz00_693;
BgL_tmpz00_693 = 
(int)(((long)0)); 
BgL_arg1204z00_400 = 
pa_strerror(BgL_tmpz00_693); } 
return 
BINT(
bgl_pulseaudio_error(
BSTRING_TO_STRING(BGl_string1303z00zz__pulseaudio_musicz00), BgL_arg1204z00_400, 
BINT(((long)0))));}  else 
{ /* Llib/music.scm 64 */
return BFALSE;} } } } 

}



/* &musicbuf-drain-pulse1121 */
obj_t BGl_z62musicbufzd2drainzd2pulse1121z62zz__pulseaudio_musicz00(obj_t BgL_envz00_308, obj_t BgL_oz00_309)
{
{ /* Llib/music.scm 54 */
{ /* Llib/music.scm 56 */
BgL_pulseaudiozd2simplezd2_bglt BgL_arg1191z00_402;
BgL_arg1191z00_402 = 
(((BgL_pulseaudiomusicz00_bglt)COBJECT(
((BgL_pulseaudiomusicz00_bglt)BgL_oz00_309)))->BgL_simplez00); 
{ /* Llib/music.scm 56 */
int BgL_errz00_403;
BgL_errz00_403 = 
(int)(((long)0)); 
{ /* Llib/music.scm 56 */
pa_simple * BgL_arg1205z00_404;int * BgL_arg1217z00_405;
BgL_arg1205z00_404 = 
(((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_arg1191z00_402))->BgL_z42builtinz42); 
BgL_arg1217z00_405 = 
&(BgL_errz00_403); 
pa_simple_drain(BgL_arg1205z00_404, BgL_arg1217z00_405); } 
if(
(
(long)(BgL_errz00_403)<((long)0)))
{ /* Llib/music.scm 56 */
char * BgL_arg1219z00_406;
{ /* Llib/music.scm 56 */
int BgL_tmpz00_709;
BgL_tmpz00_709 = 
(int)(((long)0)); 
BgL_arg1219z00_406 = 
pa_strerror(BgL_tmpz00_709); } 
return 
BINT(
bgl_pulseaudio_error(
BSTRING_TO_STRING(BGl_string1304z00zz__pulseaudio_musicz00), BgL_arg1219z00_406, 
BINT(((long)0))));}  else 
{ /* Llib/music.scm 56 */
return BFALSE;} } } } 

}



/* &musicbuf-write-pulse1119 */
obj_t BGl_z62musicbufzd2writezd2pulse1119z62zz__pulseaudio_musicz00(obj_t BgL_envz00_310, obj_t BgL_oz00_311, obj_t BgL_outbufz00_312, obj_t BgL_siza7eza7_313)
{
{ /* Llib/music.scm 47 */
{ /* Llib/music.scm 49 */
BgL_pulseaudiozd2simplezd2_bglt BgL_arg1189z00_408;
BgL_arg1189z00_408 = 
(((BgL_pulseaudiomusicz00_bglt)COBJECT(
((BgL_pulseaudiomusicz00_bglt)BgL_oz00_311)))->BgL_simplez00); 
{ /* Llib/music.scm 49 */
long BgL_res1259z00_409;
{ /* Llib/music.scm 49 */
long BgL_siza7eza7_410;
BgL_siza7eza7_410 = 
(long)CINT(BgL_siza7eza7_313); 
{ /* Llib/music.scm 49 */
int BgL_errz00_411;
BgL_errz00_411 = 
(int)(((long)0)); 
{ /* Llib/music.scm 49 */
pa_simple * BgL_arg1223z00_412;int * BgL_arg1242z00_413;
BgL_arg1223z00_412 = 
(((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_arg1189z00_408))->BgL_z42builtinz42); 
BgL_arg1242z00_413 = 
&(BgL_errz00_411); 
{ /* Llib/music.scm 49 */
char * BgL_tmpz00_722;
BgL_tmpz00_722 = 
BSTRING_TO_STRING(
((obj_t)BgL_outbufz00_312)); 
pa_simple_write(BgL_arg1223z00_412, BgL_tmpz00_722, BgL_siza7eza7_410, BgL_arg1242z00_413); } } 
if(
(
(long)(BgL_errz00_411)<((long)0)))
{ /* Llib/music.scm 49 */
char * BgL_arg1253z00_414;
{ /* Llib/music.scm 49 */
int BgL_tmpz00_729;
BgL_tmpz00_729 = 
(int)(((long)0)); 
BgL_arg1253z00_414 = 
pa_strerror(BgL_tmpz00_729); } 
BINT(
bgl_pulseaudio_error(
BSTRING_TO_STRING(BGl_string1305z00zz__pulseaudio_musicz00), BgL_arg1253z00_414, 
BINT(((long)0)))); }  else 
{ /* Llib/music.scm 49 */BFALSE; } 
BgL_res1259z00_409 = BgL_siza7eza7_410; } } 
return 
BINT(BgL_res1259z00_409);} } } 

}



/* &music-closed?-pulsea1117 */
obj_t BGl_z62musiczd2closedzf3zd2pulsea1117z91zz__pulseaudio_musicz00(obj_t BgL_envz00_314, obj_t BgL_oz00_315)
{
{ /* Llib/music.scm 39 */
{ /* Llib/music.scm 40 */
bool_t BgL_tmpz00_737;
{ /* Llib/music.scm 41 */
obj_t BgL_mutex1185z00_416;
BgL_mutex1185z00_416 = 
(((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_pulseaudiomusicz00_bglt)BgL_oz00_315))))->BgL_z52amutexz52); 
{ /* Llib/music.scm 41 */
obj_t BgL_top1392z00_742;
BgL_top1392z00_742 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGL_MUTEX_LOCK(BgL_mutex1185z00_416); 
BGL_EXITD_PUSH_PROTECT(BgL_top1392z00_742, BgL_mutex1185z00_416); BUNSPEC; 
{ /* Llib/music.scm 41 */
bool_t BgL_tmp1391z00_741;
{ /* Llib/music.scm 42 */
obj_t BgL_arg1186z00_417;
BgL_arg1186z00_417 = 
BGl_pulseaudiozd2simplezd2statez00zz__pulseaudio_simplez00(
(((BgL_pulseaudiomusicz00_bglt)COBJECT(
((BgL_pulseaudiomusicz00_bglt)BgL_oz00_315)))->BgL_simplez00)); 
BgL_tmp1391z00_741 = 
(BgL_arg1186z00_417==
CNST_TABLE_REF(((long)6))); } 
BGL_EXITD_POP_PROTECT(BgL_top1392z00_742); BUNSPEC; 
BGL_MUTEX_UNLOCK(BgL_mutex1185z00_416); 
BgL_tmpz00_737 = BgL_tmp1391z00_741; } } } 
return 
BBOOL(BgL_tmpz00_737);} } 

}



/* &music-close-pulseaud1115 */
obj_t BGl_z62musiczd2closezd2pulseaud1115z62zz__pulseaudio_musicz00(obj_t BgL_envz00_316, obj_t BgL_oz00_317)
{
{ /* Llib/music.scm 31 */
{ /* Llib/music.scm 33 */
obj_t BgL_mutex1181z00_419;
BgL_mutex1181z00_419 = 
(((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_pulseaudiomusicz00_bglt)BgL_oz00_317))))->BgL_z52amutexz52); 
{ /* Llib/music.scm 33 */
obj_t BgL_top1394z00_758;
BgL_top1394z00_758 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGL_MUTEX_LOCK(BgL_mutex1181z00_419); 
BGL_EXITD_PUSH_PROTECT(BgL_top1394z00_758, BgL_mutex1181z00_419); BUNSPEC; 
{ /* Llib/music.scm 33 */
obj_t BgL_tmp1393z00_757;
BgL_tmp1393z00_757 = 
BGl_pulseaudiozd2simplezd2closez00zz__pulseaudio_simplez00(
(((BgL_pulseaudiomusicz00_bglt)COBJECT(
((BgL_pulseaudiomusicz00_bglt)BgL_oz00_317)))->BgL_simplez00)); 
BGL_EXITD_POP_PROTECT(BgL_top1394z00_758); BUNSPEC; 
BGL_MUTEX_UNLOCK(BgL_mutex1181z00_419); 
return BgL_tmp1393z00_757;} } } } 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__pulseaudio_musicz00()
{
{ /* Llib/music.scm 15 */
BGl_modulezd2initializa7ationz75zz__pulseaudio_pulseaudioz00(((long)117276091), 
BSTRING_TO_STRING(BGl_string1306z00zz__pulseaudio_musicz00)); 
return 
BGl_modulezd2initializa7ationz75zz__pulseaudio_simplez00(((long)129098468), 
BSTRING_TO_STRING(BGl_string1306z00zz__pulseaudio_musicz00));} 

}

#ifdef __cplusplus
}
#endif
