/*===========================================================================*/
/*   (Ast/lvtype.scm)                                                        */
/*   Bigloo (4.3g)                                                           */
/*   Inria -- Sophia Antipolis (c)       Wed 12 Feb 2020 07:45:41 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.3g -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Ast/lvtype.scm) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		bool_t BgL_evalzf3zf3;
		obj_t BgL_libraryz00;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
		obj_t BgL_initz00;
		obj_t BgL_aliasz00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_localz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		long BgL_keyz00;
	}               *BgL_localz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
		obj_t BgL_strengthz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_atomz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}              *BgL_atomz00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_closurez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}                 *BgL_closurez00_bglt;

	typedef struct BgL_kwotez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}               *BgL_kwotez00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
		bool_t BgL_unsafez00;
		obj_t BgL_metaz00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_appzd2lyzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}                  *BgL_appzd2lyzd2_bglt;

	typedef struct BgL_funcallz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_strengthz00;
		obj_t BgL_functionsz00;
	}                 *BgL_funcallz00_bglt;

	typedef struct BgL_externz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
	}                *BgL_externz00_bglt;

	typedef struct BgL_castz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}              *BgL_castz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_failz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_procz00;
		struct BgL_nodez00_bgl *BgL_msgz00;
		struct BgL_nodez00_bgl *BgL_objz00;
	}              *BgL_failz00_bglt;

	typedef struct BgL_switchz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_switchz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;

	typedef struct BgL_setzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                       *BgL_setzd2exzd2itz00_bglt;

	typedef struct BgL_jumpzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_exitz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                        *BgL_jumpzd2exzd2itz00_bglt;

	typedef struct BgL_retblockz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                  *BgL_retblockz00_bglt;

	typedef struct BgL_returnz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_retblockz00_bgl *BgL_blockz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                *BgL_returnz00_bglt;

	typedef struct BgL_makezd2boxzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                    *BgL_makezd2boxzd2_bglt;

	typedef struct BgL_boxzd2refzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                   *BgL_boxzd2refzd2_bglt;

	typedef struct BgL_boxzd2setz12zc0_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                      *BgL_boxzd2setz12zc0_bglt;

	typedef struct BgL_syncz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_mutexz00;
		struct BgL_nodez00_bgl *BgL_prelockz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}              *BgL_syncz00_bglt;


	static obj_t
		BGl_z62lvtypezd2nodez12zd2setzd2exzd21283z70zzast_lvtypez00(obj_t, obj_t);
	extern obj_t BGl_closurez00zzast_nodez00;
	extern obj_t BGl_syncz00zzast_nodez00;
	static obj_t
		BGl_setzd2variablezd2typez12z12zzast_lvtypez00(BgL_variablez00_bglt,
		BgL_typez00_bglt);
	static obj_t BGl_z62lvtypezd2nodez12zd2letzd2var1281za2zzast_lvtypez00(obj_t,
		obj_t);
	extern obj_t BGl_sequencez00zzast_nodez00;
	static obj_t BGl_z62lvtypezd2nodez12zd2closure1255z70zzast_lvtypez00(obj_t,
		obj_t);
	static obj_t BGl_z62lvtypezd2nodez12zd2sync1259z70zzast_lvtypez00(obj_t,
		obj_t);
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	static obj_t BGl_z62lvtypezd2nodez12zd2boxzd2set1293za2zzast_lvtypez00(obj_t,
		obj_t);
	extern obj_t BGl_failz00zzast_nodez00;
	static obj_t BGl_z62lvtypezd2nodez12zd2fail1275z70zzast_lvtypez00(obj_t,
		obj_t);
	static obj_t BGl_objectzd2initzd2zzast_lvtypez00();
	extern obj_t BGl_boxzd2refzd2zzast_nodez00;
	static obj_t BGl_z62lvtypezd2nodez12zd2sequenc1257z70zzast_lvtypez00(obj_t,
		obj_t);
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_lvtypezd2nodezd2zzast_lvtypez00(BgL_nodez00_bglt);
	static obj_t BGl_z62lvtypezd2nodez12zd2switch1277z70zzast_lvtypez00(obj_t,
		obj_t);
	static obj_t BGl_methodzd2initzd2zzast_lvtypez00();
	extern obj_t BGl_externz00zzast_nodez00;
	BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_za2_za2z00zztype_cachez00;
	extern obj_t BGl_za2objza2z00zztype_cachez00;
	static BgL_nodez00_bglt BGl_z62lvtypezd2nodezb0zzast_lvtypez00(obj_t, obj_t);
	static obj_t BGl_z62lvtypezd2nodez121246za2zzast_lvtypez00(obj_t, obj_t);
	extern obj_t BGl_appzd2lyzd2zzast_nodez00;
	static obj_t BGl_z62lvtypezd2nodez12zd2jumpzd2ex1285za2zzast_lvtypez00(obj_t,
		obj_t);
	static obj_t BGl_gczd2rootszd2initz00zzast_lvtypez00();
	BGL_EXPORTED_DECL obj_t BGl_lvtypezd2astz12zc0zzast_lvtypez00(obj_t);
	BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62lvtypezd2nodez12zd2app1261z70zzast_lvtypez00(obj_t,
		obj_t);
	extern obj_t BGl_conditionalz00zzast_nodez00;
	static obj_t BGl_z62lvtypezd2astz12za2zzast_lvtypez00(obj_t, obj_t);
	extern obj_t BGl_setqz00zzast_nodez00;
	extern obj_t BGl_returnz00zzast_nodez00;
	static obj_t BGl_requirezd2initializa7ationz75zzast_lvtypez00 = BUNSPEC;
	static obj_t BGl_z62lvtypezd2nodez12zd2funcall1265z70zzast_lvtypez00(obj_t,
		obj_t);
	extern obj_t BGl_setzd2exzd2itz00zzast_nodez00;
	static obj_t BGl_z62lvtypezd2nodez12zd2conditi1273z70zzast_lvtypez00(obj_t,
		obj_t);
	static obj_t BGl_z62lvtypezd2nodez12zd2cast1269z70zzast_lvtypez00(obj_t,
		obj_t);
	static obj_t BGl_z62lvtypezd2nodez12zd2retbloc1287z70zzast_lvtypez00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_atomz00zzast_nodez00;
	static obj_t BGl_toplevelzd2initzd2zzast_lvtypez00();
	static obj_t BGl_z62lvtypezd2nodez12zd2appzd2ly1263za2zzast_lvtypez00(obj_t,
		obj_t);
	static obj_t BGl_z62lvtypezd2nodez12zd2setq1271z70zzast_lvtypez00(obj_t,
		obj_t);
	extern obj_t BGl_internalzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_lvtypezd2nodez12zc0zzast_lvtypez00(BgL_nodez00_bglt);
	static obj_t BGl_genericzd2initzd2zzast_lvtypez00();
	extern obj_t BGl_castz00zzast_nodez00;
	static obj_t BGl_z62lvtypezd2nodez12zd2boxzd2ref1295za2zzast_lvtypez00(obj_t,
		obj_t);
	extern obj_t BGl_shapez00zztools_shapez00(obj_t);
	static obj_t BGl_z62lvtypezd2nodez12zd2return1289z70zzast_lvtypez00(obj_t,
		obj_t);
	static obj_t BGl_z62lvtypezd2nodez12zd2extern1267z70zzast_lvtypez00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t,
		obj_t, obj_t);
	static bool_t BGl_lvtypezd2nodeza2z12z62zzast_lvtypez00(obj_t);
	static obj_t BGl_z62lvtypezd2nodez12zd2makezd2bo1291za2zzast_lvtypez00(obj_t,
		obj_t);
	extern obj_t BGl_varz00zzast_nodez00;
	extern BgL_typez00_bglt BGl_getzd2typezd2zztype_typeofz00(BgL_nodez00_bglt,
		bool_t);
	extern obj_t BGl_makezd2boxzd2zzast_nodez00;
	extern obj_t BGl_boxzd2setz12zc0zzast_nodez00;
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zzast_lvtypez00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_dumpz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typeofz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	extern obj_t BGl_appz00zzast_nodez00;
	static obj_t BGl_z62lvtypezd2nodez12za2zzast_lvtypez00(obj_t, obj_t);
	extern obj_t BGl_nodez00zzast_nodez00;
	extern obj_t BGl_kwotez00zzast_nodez00;
	static obj_t BGl_z62lvtypezd2nodez12zd2atom1249z70zzast_lvtypez00(obj_t,
		obj_t);
	extern obj_t BGl_jumpzd2exzd2itz00zzast_nodez00;
	static obj_t BGl_cnstzd2initzd2zzast_lvtypez00();
	static obj_t BGl_libraryzd2moduleszd2initz00zzast_lvtypez00();
	static obj_t BGl_z62lvtypezd2nodez12zd2var1253z70zzast_lvtypez00(obj_t,
		obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zzast_lvtypez00();
	static obj_t BGl_z62lvtypezd2nodez12zd2kwote1251z70zzast_lvtypez00(obj_t,
		obj_t);
	extern obj_t BGl_retblockz00zzast_nodez00;
	static obj_t BGl_z62lvtypezd2nodez12zd2letzd2fun1279za2zzast_lvtypez00(obj_t,
		obj_t);
	extern obj_t BGl_letzd2funzd2zzast_nodez00;
	extern obj_t BGl_switchz00zzast_nodez00;
	static obj_t BGl_getzd2objzd2typez00zzast_lvtypez00(BgL_nodez00_bglt);
	extern obj_t BGl_funcallz00zzast_nodez00;
	static obj_t __cnst[1];


	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_lvtypezd2nodezd2envz00zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1799z00, BGl_z62lvtypezd2nodezb0zzast_lvtypez00,
		0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1765z00zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1800z00,
		BGl_z62lvtypezd2nodez121246za2zzast_lvtypez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1768z00zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1801z00,
		BGl_z62lvtypezd2nodez12zd2atom1249z70zzast_lvtypez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1770z00zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1802z00,
		BGl_z62lvtypezd2nodez12zd2kwote1251z70zzast_lvtypez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1771z00zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1803z00,
		BGl_z62lvtypezd2nodez12zd2var1253z70zzast_lvtypez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1772z00zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1804z00,
		BGl_z62lvtypezd2nodez12zd2closure1255z70zzast_lvtypez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1773z00zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1805z00,
		BGl_z62lvtypezd2nodez12zd2sequenc1257z70zzast_lvtypez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1774z00zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1806z00,
		BGl_z62lvtypezd2nodez12zd2sync1259z70zzast_lvtypez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1775z00zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1807z00,
		BGl_z62lvtypezd2nodez12zd2app1261z70zzast_lvtypez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1776z00zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1808z00,
		BGl_z62lvtypezd2nodez12zd2appzd2ly1263za2zzast_lvtypez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1777z00zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1809z00,
		BGl_z62lvtypezd2nodez12zd2funcall1265z70zzast_lvtypez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1778z00zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1810z00,
		BGl_z62lvtypezd2nodez12zd2extern1267z70zzast_lvtypez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1779z00zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1811z00,
		BGl_z62lvtypezd2nodez12zd2cast1269z70zzast_lvtypez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1780z00zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1812z00,
		BGl_z62lvtypezd2nodez12zd2setq1271z70zzast_lvtypez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1781z00zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1813z00,
		BGl_z62lvtypezd2nodez12zd2conditi1273z70zzast_lvtypez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1782z00zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1814z00,
		BGl_z62lvtypezd2nodez12zd2fail1275z70zzast_lvtypez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1783z00zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1815z00,
		BGl_z62lvtypezd2nodez12zd2switch1277z70zzast_lvtypez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1784z00zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1816z00,
		BGl_z62lvtypezd2nodez12zd2letzd2fun1279za2zzast_lvtypez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1785z00zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1817z00,
		BGl_z62lvtypezd2nodez12zd2letzd2var1281za2zzast_lvtypez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1786z00zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1818z00,
		BGl_z62lvtypezd2nodez12zd2setzd2exzd21283z70zzast_lvtypez00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1787z00zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1819z00,
		BGl_z62lvtypezd2nodez12zd2jumpzd2ex1285za2zzast_lvtypez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1788z00zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1820z00,
		BGl_z62lvtypezd2nodez12zd2retbloc1287z70zzast_lvtypez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1789z00zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1821z00,
		BGl_z62lvtypezd2nodez12zd2return1289z70zzast_lvtypez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1790z00zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1822z00,
		BGl_z62lvtypezd2nodez12zd2makezd2bo1291za2zzast_lvtypez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1791z00zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1823z00,
		BGl_z62lvtypezd2nodez12zd2boxzd2set1293za2zzast_lvtypez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1792z00zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1824z00,
		BGl_z62lvtypezd2nodez12zd2boxzd2ref1295za2zzast_lvtypez00, 0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_lvtypezd2astz12zd2envz12zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2astza71825za7,
		BGl_z62lvtypezd2astz12za2zzast_lvtypez00, 0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_GENERIC(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00,
		BgL_bgl_za762lvtypeza7d2node1826z00,
		BGl_z62lvtypezd2nodez12za2zzast_lvtypez00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string1766z00zzast_lvtypez00,
		BgL_bgl_string1766za700za7za7a1827za7, "lvtype-node!1246", 16);
	      DEFINE_STRING(BGl_string1767z00zzast_lvtypez00,
		BgL_bgl_string1767za700za7za7a1828za7, "No method for this object", 25);
	      DEFINE_STRING(BGl_string1769z00zzast_lvtypez00,
		BgL_bgl_string1769za700za7za7a1829za7, "lvtype-node!", 12);
	      DEFINE_STRING(BGl_string1793z00zzast_lvtypez00,
		BgL_bgl_string1793za700za7za7a1830za7, "Unexpected closure", 18);
	      DEFINE_STRING(BGl_string1794z00zzast_lvtypez00,
		BgL_bgl_string1794za700za7za7a1831za7, "ast_lvtype", 10);
	      DEFINE_STRING(BGl_string1795z00zzast_lvtypez00,
		BgL_bgl_string1795za700za7za7a1832za7, "lvtype-node!1246 ", 17);

/* GC roots registration */
	static obj_t bgl_gc_roots_register()
	{
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
		void *roots_min = (void *) ULONG_MAX, *roots_max = 0;
		     ADD_ROOT((void *) (&BGl_requirezd2initializa7ationz75zzast_lvtypez00));
#undef ADD_ROOT
		if   (roots_max > 0)
			     GC_add_roots(roots_min, ((void **) roots_max) + 1);
#endif
		     return BUNSPEC;
	}



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzast_lvtypez00(long
		BgL_checksumz00_1946, char *BgL_fromz00_1947)
	{
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzast_lvtypez00))
				{
					BGl_requirezd2initializa7ationz75zzast_lvtypez00 =
						BBOOL(((bool_t) 0));
					BGl_gczd2rootszd2initz00zzast_lvtypez00();
					BGl_libraryzd2moduleszd2initz00zzast_lvtypez00();
					BGl_cnstzd2initzd2zzast_lvtypez00();
					BGl_importedzd2moduleszd2initz00zzast_lvtypez00();
					BGl_genericzd2initzd2zzast_lvtypez00();
					BGl_methodzd2initzd2zzast_lvtypez00();
					return BGl_toplevelzd2initzd2zzast_lvtypez00();
				}
			else
				{
					return BUNSPEC;
				}
		}

	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzast_lvtypez00()
	{
		{	/* Ast/lvtype.scm 16 */
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "ast_lvtype");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0), "ast_lvtype");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0), "ast_lvtype");
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 0),
				"ast_lvtype");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"ast_lvtype");
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 0),
				"ast_lvtype");
			BGl_modulezd2initializa7ationz75zz__bitz00(((long) 0), "ast_lvtype");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long) 0),
				"ast_lvtype");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"ast_lvtype");
			return BUNSPEC;
		}

	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzast_lvtypez00()
	{
		{	/* Ast/lvtype.scm 16 */
			{	/* Ast/lvtype.scm 16 */
				obj_t BgL_cportz00_1875;

				{	/* Ast/lvtype.scm 16 */
					obj_t BgL_stringz00_1883;

					BgL_stringz00_1883 = BGl_string1795z00zzast_lvtypez00;
					{	/* Ast/lvtype.scm 16 */
						obj_t BgL_startz00_1884;

						BgL_startz00_1884 = BINT(((long) 0));
						{	/* Ast/lvtype.scm 16 */
							obj_t BgL_endz00_1885;

							BgL_endz00_1885 =
								BINT(STRING_LENGTH(((obj_t) BgL_stringz00_1883)));
							{	/* Ast/lvtype.scm 16 */

								BgL_cportz00_1875 =
									BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00
									(BgL_stringz00_1883, BgL_startz00_1884, BgL_endz00_1885);
				}}}}
				{
					long BgL_iz00_1876;

					BgL_iz00_1876 = ((long) 0);
				BgL_loopz00_1877:
					if ((BgL_iz00_1876 == ((long) -1)))
						{	/* Ast/lvtype.scm 16 */
							return BUNSPEC;
						}
					else
						{	/* Ast/lvtype.scm 16 */
							{	/* Ast/lvtype.scm 16 */
								obj_t BgL_arg1797z00_1879;

								{	/* Ast/lvtype.scm 16 */

									{	/* Ast/lvtype.scm 16 */
										obj_t BgL_locationz00_1881;

										BgL_locationz00_1881 = BBOOL(((bool_t) 0));
										{	/* Ast/lvtype.scm 16 */

											BgL_arg1797z00_1879 =
												BGl_readz00zz__readerz00(BgL_cportz00_1875,
												BgL_locationz00_1881);
										}
									}
								}
								{	/* Ast/lvtype.scm 16 */
									int BgL_tmpz00_1976;

									BgL_tmpz00_1976 = (int) (BgL_iz00_1876);
									CNST_TABLE_SET(BgL_tmpz00_1976, BgL_arg1797z00_1879);
							}}
							{	/* Ast/lvtype.scm 16 */
								int BgL_auxz00_1882;

								BgL_auxz00_1882 = (int) ((BgL_iz00_1876 - ((long) 1)));
								{
									long BgL_iz00_1981;

									BgL_iz00_1981 = (long) (BgL_auxz00_1882);
									BgL_iz00_1876 = BgL_iz00_1981;
									goto BgL_loopz00_1877;
								}
							}
						}
				}
			}
		}

	}



/* gc-roots-init */
	obj_t BGl_gczd2rootszd2initz00zzast_lvtypez00()
	{
		{	/* Ast/lvtype.scm 16 */
			return bgl_gc_roots_register();
		}

	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzast_lvtypez00()
	{
		{	/* Ast/lvtype.scm 16 */
			return BUNSPEC;
		}

	}



/* lvtype-ast! */
	BGL_EXPORTED_DEF obj_t BGl_lvtypezd2astz12zc0zzast_lvtypez00(obj_t
		BgL_astz00_3)
	{
		{	/* Ast/lvtype.scm 32 */
			{
				obj_t BgL_l1233z00_1328;

				BgL_l1233z00_1328 = BgL_astz00_3;
			BgL_zc3z04anonymousza31300ze3z87_1329:
				if (PAIRP(BgL_l1233z00_1328))
					{	/* Ast/lvtype.scm 33 */
						{	/* Ast/lvtype.scm 34 */
							obj_t BgL_gz00_1331;

							BgL_gz00_1331 = CAR(BgL_l1233z00_1328);
							{	/* Ast/lvtype.scm 34 */
								obj_t BgL_arg1303z00_1332;

								BgL_arg1303z00_1332 =
									(((BgL_sfunz00_bglt) COBJECT(
											((BgL_sfunz00_bglt)
												(((BgL_variablez00_bglt) COBJECT(
															((BgL_variablez00_bglt)
																((BgL_globalz00_bglt) BgL_gz00_1331))))->
													BgL_valuez00))))->BgL_bodyz00);
								BGl_lvtypezd2nodez12zc0zzast_lvtypez00(((BgL_nodez00_bglt)
										BgL_arg1303z00_1332));
							}
						}
						{
							obj_t BgL_l1233z00_1994;

							BgL_l1233z00_1994 = CDR(BgL_l1233z00_1328);
							BgL_l1233z00_1328 = BgL_l1233z00_1994;
							goto BgL_zc3z04anonymousza31300ze3z87_1329;
						}
					}
				else
					{	/* Ast/lvtype.scm 33 */
						((bool_t) 1);
					}
			}
			return BgL_astz00_3;
		}

	}



/* &lvtype-ast! */
	obj_t BGl_z62lvtypezd2astz12za2zzast_lvtypez00(obj_t BgL_envz00_1794,
		obj_t BgL_astz00_1795)
	{
		{	/* Ast/lvtype.scm 32 */
			return BGl_lvtypezd2astz12zc0zzast_lvtypez00(BgL_astz00_1795);
		}

	}



/* get-obj-type */
	obj_t BGl_getzd2objzd2typez00zzast_lvtypez00(BgL_nodez00_bglt BgL_nodez00_4)
	{
		{	/* Ast/lvtype.scm 41 */
			{	/* Ast/lvtype.scm 42 */
				BgL_typez00_bglt BgL_tyz00_1336;

				BgL_tyz00_1336 =
					BGl_getzd2typezd2zztype_typeofz00(BgL_nodez00_4, ((bool_t) 0));
				if ((((obj_t) BgL_tyz00_1336) == BGl_za2_za2z00zztype_cachez00))
					{	/* Ast/lvtype.scm 43 */
						return BGl_za2objza2z00zztype_cachez00;
					}
				else
					{	/* Ast/lvtype.scm 43 */
						return ((obj_t) BgL_tyz00_1336);
					}
			}
		}

	}



/* lvtype-node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_lvtypezd2nodezd2zzast_lvtypez00(BgL_nodez00_bglt BgL_nodez00_5)
	{
		{	/* Ast/lvtype.scm 50 */
			BGl_lvtypezd2nodez12zc0zzast_lvtypez00(BgL_nodez00_5);
			return BgL_nodez00_5;
		}

	}



/* &lvtype-node */
	BgL_nodez00_bglt BGl_z62lvtypezd2nodezb0zzast_lvtypez00(obj_t BgL_envz00_1796,
		obj_t BgL_nodez00_1797)
	{
		{	/* Ast/lvtype.scm 50 */
			return
				BGl_lvtypezd2nodezd2zzast_lvtypez00(
				((BgL_nodez00_bglt) BgL_nodez00_1797));
		}

	}



/* lvtype-node*! */
	bool_t BGl_lvtypezd2nodeza2z12z62zzast_lvtypez00(obj_t BgL_nodeza2za2_31)
	{
		{	/* Ast/lvtype.scm 267 */
			{
				obj_t BgL_l1244z00_1339;

				BgL_l1244z00_1339 = BgL_nodeza2za2_31;
			BgL_zc3z04anonymousza31307ze3z87_1340:
				if (PAIRP(BgL_l1244z00_1339))
					{	/* Ast/lvtype.scm 268 */
						{	/* Ast/lvtype.scm 268 */
							obj_t BgL_arg1309z00_1342;

							BgL_arg1309z00_1342 = CAR(BgL_l1244z00_1339);
							BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
								((BgL_nodez00_bglt) BgL_arg1309z00_1342));
						}
						{
							obj_t BgL_l1244z00_2010;

							BgL_l1244z00_2010 = CDR(BgL_l1244z00_1339);
							BgL_l1244z00_1339 = BgL_l1244z00_2010;
							goto BgL_zc3z04anonymousza31307ze3z87_1340;
						}
					}
				else
					{	/* Ast/lvtype.scm 268 */
						return ((bool_t) 1);
					}
			}
		}

	}



/* set-variable-type! */
	obj_t BGl_setzd2variablezd2typez12z12zzast_lvtypez00(BgL_variablez00_bglt
		BgL_variablez00_32, BgL_typez00_bglt BgL_typez00_33)
	{
		{	/* Ast/lvtype.scm 273 */
			{	/* Ast/lvtype.scm 274 */
				obj_t BgL_ntypez00_1345;
				BgL_typez00_bglt BgL_otypez00_1346;

				if ((((obj_t) BgL_typez00_33) == BGl_za2_za2z00zztype_cachez00))
					{	/* Ast/lvtype.scm 274 */
						BgL_ntypez00_1345 = BGl_za2objza2z00zztype_cachez00;
					}
				else
					{	/* Ast/lvtype.scm 274 */
						BgL_ntypez00_1345 = ((obj_t) BgL_typez00_33);
					}
				BgL_otypez00_1346 =
					(((BgL_variablez00_bglt) COBJECT(BgL_variablez00_32))->BgL_typez00);
				if ((((obj_t) BgL_otypez00_1346) == BGl_za2_za2z00zztype_cachez00))
					{	/* Ast/lvtype.scm 276 */
						return
							((((BgL_variablez00_bglt) COBJECT(BgL_variablez00_32))->
								BgL_typez00) =
							((BgL_typez00_bglt) ((BgL_typez00_bglt) BgL_ntypez00_1345)),
							BUNSPEC);
					}
				else
					{	/* Ast/lvtype.scm 276 */
						return BFALSE;
					}
			}
		}

	}



/* object-init */
	obj_t BGl_objectzd2initzd2zzast_lvtypez00()
	{
		{	/* Ast/lvtype.scm 16 */
			return BUNSPEC;
		}

	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzast_lvtypez00()
	{
		{	/* Ast/lvtype.scm 16 */
			return
				BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00,
				BGl_proc1765z00zzast_lvtypez00, BGl_nodez00zzast_nodez00,
				BGl_string1766z00zzast_lvtypez00);
		}

	}



/* &lvtype-node!1246 */
	obj_t BGl_z62lvtypezd2nodez121246za2zzast_lvtypez00(obj_t BgL_envz00_1799,
		obj_t BgL_nodez00_1800)
	{
		{	/* Ast/lvtype.scm 57 */
			return
				BGl_errorz00zz__errorz00(CNST_TABLE_REF(((long) 0)),
				BGl_string1767z00zzast_lvtypez00,
				((obj_t) ((BgL_nodez00_bglt) BgL_nodez00_1800)));
		}

	}



/* lvtype-node! */
	BGL_EXPORTED_DEF obj_t BGl_lvtypezd2nodez12zc0zzast_lvtypez00(BgL_nodez00_bglt
		BgL_nodez00_6)
	{
		{	/* Ast/lvtype.scm 57 */
			{	/* Ast/lvtype.scm 57 */
				obj_t BgL_method1247z00_1353;

				{	/* Ast/lvtype.scm 57 */
					obj_t BgL_res1761z00_1767;

					{	/* Ast/lvtype.scm 57 */
						long BgL_objzd2classzd2numz00_1732;

						{	/* Ast/lvtype.scm 57 */
							long BgL_res1751z00_1735;

							BgL_res1751z00_1735 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nodez00_6));
							BgL_objzd2classzd2numz00_1732 = BgL_res1751z00_1735;
						}
						{	/* Ast/lvtype.scm 57 */
							obj_t BgL_arg1741z00_1733;

							BgL_arg1741z00_1733 =
								PROCEDURE_REF(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00,
								(int) (((long) 1)));
							{	/* Ast/lvtype.scm 57 */
								int BgL_offsetz00_1737;

								BgL_offsetz00_1737 = (int) (BgL_objzd2classzd2numz00_1732);
								{	/* Ast/lvtype.scm 57 */
									long BgL_offsetz00_1738;

									BgL_offsetz00_1738 =
										((long) (BgL_offsetz00_1737) - OBJECT_TYPE);
									{	/* Ast/lvtype.scm 57 */
										long BgL_modz00_1739;

										BgL_modz00_1739 =
											(BgL_offsetz00_1738 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Ast/lvtype.scm 57 */
											long BgL_restz00_1741;

											BgL_restz00_1741 =
												(BgL_offsetz00_1738 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Ast/lvtype.scm 57 */

												{	/* Ast/lvtype.scm 57 */
													obj_t BgL_bucketz00_1743;

													BgL_bucketz00_1743 =
														VECTOR_REF(
														((obj_t) BgL_arg1741z00_1733), BgL_modz00_1739);
													BgL_res1761z00_1767 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_1743), BgL_restz00_1741);
					}}}}}}}}
					BgL_method1247z00_1353 = BgL_res1761z00_1767;
				}
				return
					PROCEDURE_ENTRY(BgL_method1247z00_1353) (BgL_method1247z00_1353,
					((obj_t) BgL_nodez00_6), BEOA);
			}
		}

	}



/* &lvtype-node! */
	obj_t BGl_z62lvtypezd2nodez12za2zzast_lvtypez00(obj_t BgL_envz00_1801,
		obj_t BgL_nodez00_1802)
	{
		{	/* Ast/lvtype.scm 57 */
			return
				BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
				((BgL_nodez00_bglt) BgL_nodez00_1802));
		}

	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzast_lvtypez00()
	{
		{	/* Ast/lvtype.scm 16 */
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00, BGl_atomz00zzast_nodez00,
				BGl_proc1768z00zzast_lvtypez00, BGl_string1769z00zzast_lvtypez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00,
				BGl_kwotez00zzast_nodez00, BGl_proc1770z00zzast_lvtypez00,
				BGl_string1769z00zzast_lvtypez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00, BGl_varz00zzast_nodez00,
				BGl_proc1771z00zzast_lvtypez00, BGl_string1769z00zzast_lvtypez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00,
				BGl_closurez00zzast_nodez00, BGl_proc1772z00zzast_lvtypez00,
				BGl_string1769z00zzast_lvtypez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00,
				BGl_sequencez00zzast_nodez00, BGl_proc1773z00zzast_lvtypez00,
				BGl_string1769z00zzast_lvtypez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00, BGl_syncz00zzast_nodez00,
				BGl_proc1774z00zzast_lvtypez00, BGl_string1769z00zzast_lvtypez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00, BGl_appz00zzast_nodez00,
				BGl_proc1775z00zzast_lvtypez00, BGl_string1769z00zzast_lvtypez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00,
				BGl_appzd2lyzd2zzast_nodez00, BGl_proc1776z00zzast_lvtypez00,
				BGl_string1769z00zzast_lvtypez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00,
				BGl_funcallz00zzast_nodez00, BGl_proc1777z00zzast_lvtypez00,
				BGl_string1769z00zzast_lvtypez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00,
				BGl_externz00zzast_nodez00, BGl_proc1778z00zzast_lvtypez00,
				BGl_string1769z00zzast_lvtypez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00, BGl_castz00zzast_nodez00,
				BGl_proc1779z00zzast_lvtypez00, BGl_string1769z00zzast_lvtypez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00, BGl_setqz00zzast_nodez00,
				BGl_proc1780z00zzast_lvtypez00, BGl_string1769z00zzast_lvtypez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00,
				BGl_conditionalz00zzast_nodez00, BGl_proc1781z00zzast_lvtypez00,
				BGl_string1769z00zzast_lvtypez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00, BGl_failz00zzast_nodez00,
				BGl_proc1782z00zzast_lvtypez00, BGl_string1769z00zzast_lvtypez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00,
				BGl_switchz00zzast_nodez00, BGl_proc1783z00zzast_lvtypez00,
				BGl_string1769z00zzast_lvtypez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00,
				BGl_letzd2funzd2zzast_nodez00, BGl_proc1784z00zzast_lvtypez00,
				BGl_string1769z00zzast_lvtypez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc1785z00zzast_lvtypez00,
				BGl_string1769z00zzast_lvtypez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00,
				BGl_setzd2exzd2itz00zzast_nodez00, BGl_proc1786z00zzast_lvtypez00,
				BGl_string1769z00zzast_lvtypez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00,
				BGl_jumpzd2exzd2itz00zzast_nodez00, BGl_proc1787z00zzast_lvtypez00,
				BGl_string1769z00zzast_lvtypez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00,
				BGl_retblockz00zzast_nodez00, BGl_proc1788z00zzast_lvtypez00,
				BGl_string1769z00zzast_lvtypez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00,
				BGl_returnz00zzast_nodez00, BGl_proc1789z00zzast_lvtypez00,
				BGl_string1769z00zzast_lvtypez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00,
				BGl_makezd2boxzd2zzast_nodez00, BGl_proc1790z00zzast_lvtypez00,
				BGl_string1769z00zzast_lvtypez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00,
				BGl_boxzd2setz12zc0zzast_nodez00, BGl_proc1791z00zzast_lvtypez00,
				BGl_string1769z00zzast_lvtypez00);
			return
				BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_lvtypezd2nodez12zd2envz12zzast_lvtypez00,
				BGl_boxzd2refzd2zzast_nodez00, BGl_proc1792z00zzast_lvtypez00,
				BGl_string1769z00zzast_lvtypez00);
		}

	}



/* &lvtype-node!-box-ref1295 */
	obj_t BGl_z62lvtypezd2nodez12zd2boxzd2ref1295za2zzast_lvtypez00(obj_t
		BgL_envz00_1827, obj_t BgL_nodez00_1828)
	{
		{	/* Ast/lvtype.scm 260 */
			{	/* Ast/lvtype.scm 262 */
				BgL_varz00_bglt BgL_arg1602z00_1890;

				BgL_arg1602z00_1890 =
					(((BgL_boxzd2refzd2_bglt) COBJECT(
							((BgL_boxzd2refzd2_bglt) BgL_nodez00_1828)))->BgL_varz00);
				return
					BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
					((BgL_nodez00_bglt) BgL_arg1602z00_1890));
			}
		}

	}



/* &lvtype-node!-box-set1293 */
	obj_t BGl_z62lvtypezd2nodez12zd2boxzd2set1293za2zzast_lvtypez00(obj_t
		BgL_envz00_1829, obj_t BgL_nodez00_1830)
	{
		{	/* Ast/lvtype.scm 252 */
			{	/* Ast/lvtype.scm 254 */
				BgL_varz00_bglt BgL_arg1594z00_1892;

				BgL_arg1594z00_1892 =
					(((BgL_boxzd2setz12zc0_bglt) COBJECT(
							((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_1830)))->BgL_varz00);
				BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
					((BgL_nodez00_bglt) BgL_arg1594z00_1892));
			}
			return
				BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
				(((BgL_boxzd2setz12zc0_bglt) COBJECT(
							((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_1830)))->BgL_valuez00));
		}

	}



/* &lvtype-node!-make-bo1291 */
	obj_t BGl_z62lvtypezd2nodez12zd2makezd2bo1291za2zzast_lvtypez00(obj_t
		BgL_envz00_1831, obj_t BgL_nodez00_1832)
	{
		{	/* Ast/lvtype.scm 245 */
			return
				BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
				(((BgL_makezd2boxzd2_bglt) COBJECT(
							((BgL_makezd2boxzd2_bglt) BgL_nodez00_1832)))->BgL_valuez00));
		}

	}



/* &lvtype-node!-return1289 */
	obj_t BGl_z62lvtypezd2nodez12zd2return1289z70zzast_lvtypez00(obj_t
		BgL_envz00_1833, obj_t BgL_nodez00_1834)
	{
		{	/* Ast/lvtype.scm 238 */
			return
				BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
				(((BgL_returnz00_bglt) COBJECT(
							((BgL_returnz00_bglt) BgL_nodez00_1834)))->BgL_valuez00));
		}

	}



/* &lvtype-node!-retbloc1287 */
	obj_t BGl_z62lvtypezd2nodez12zd2retbloc1287z70zzast_lvtypez00(obj_t
		BgL_envz00_1835, obj_t BgL_nodez00_1836)
	{
		{	/* Ast/lvtype.scm 231 */
			return
				BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
				(((BgL_retblockz00_bglt) COBJECT(
							((BgL_retblockz00_bglt) BgL_nodez00_1836)))->BgL_bodyz00));
		}

	}



/* &lvtype-node!-jump-ex1285 */
	obj_t BGl_z62lvtypezd2nodez12zd2jumpzd2ex1285za2zzast_lvtypez00(obj_t
		BgL_envz00_1837, obj_t BgL_nodez00_1838)
	{
		{	/* Ast/lvtype.scm 223 */
			BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
				(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
							((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_1838)))->BgL_exitz00));
			return
				BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
				(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
							((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_1838)))->BgL_valuez00));
		}

	}



/* &lvtype-node!-set-ex-1283 */
	obj_t BGl_z62lvtypezd2nodez12zd2setzd2exzd21283z70zzast_lvtypez00(obj_t
		BgL_envz00_1839, obj_t BgL_nodez00_1840)
	{
		{	/* Ast/lvtype.scm 215 */
			BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
				(((BgL_setzd2exzd2itz00_bglt) COBJECT(
							((BgL_setzd2exzd2itz00_bglt) BgL_nodez00_1840)))->BgL_bodyz00));
			{	/* Ast/lvtype.scm 218 */
				BgL_varz00_bglt BgL_arg1573z00_1898;

				BgL_arg1573z00_1898 =
					(((BgL_setzd2exzd2itz00_bglt) COBJECT(
							((BgL_setzd2exzd2itz00_bglt) BgL_nodez00_1840)))->BgL_varz00);
				return
					BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
					((BgL_nodez00_bglt) BgL_arg1573z00_1898));
			}
		}

	}



/* &lvtype-node!-let-var1281 */
	obj_t BGl_z62lvtypezd2nodez12zd2letzd2var1281za2zzast_lvtypez00(obj_t
		BgL_envz00_1841, obj_t BgL_nodez00_1842)
	{
		{	/* Ast/lvtype.scm 200 */
			{	/* Ast/lvtype.scm 202 */
				obj_t BgL_g1243z00_1900;

				BgL_g1243z00_1900 =
					(((BgL_letzd2varzd2_bglt) COBJECT(
							((BgL_letzd2varzd2_bglt) BgL_nodez00_1842)))->BgL_bindingsz00);
				{
					obj_t BgL_l1241z00_1902;

					BgL_l1241z00_1902 = BgL_g1243z00_1900;
				BgL_zc3z04anonymousza31541ze3z87_1901:
					if (PAIRP(BgL_l1241z00_1902))
						{	/* Ast/lvtype.scm 202 */
							{	/* Ast/lvtype.scm 203 */
								obj_t BgL_bindingz00_1903;

								BgL_bindingz00_1903 = CAR(BgL_l1241z00_1902);
								{	/* Ast/lvtype.scm 203 */
									obj_t BgL_varz00_1904;
									obj_t BgL_valz00_1905;

									BgL_varz00_1904 = CAR(((obj_t) BgL_bindingz00_1903));
									BgL_valz00_1905 = CDR(((obj_t) BgL_bindingz00_1903));
									BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
										((BgL_nodez00_bglt) BgL_valz00_1905));
									{	/* Ast/lvtype.scm 206 */
										BgL_typez00_bglt BgL_arg1544z00_1906;

										BgL_arg1544z00_1906 =
											BGl_getzd2typezd2zztype_typeofz00(
											((BgL_nodez00_bglt) BgL_valz00_1905), ((bool_t) 0));
										BGl_setzd2variablezd2typez12z12zzast_lvtypez00(
											((BgL_variablez00_bglt) BgL_varz00_1904),
											BgL_arg1544z00_1906);
									}
								}
							}
							{
								obj_t BgL_l1241z00_2131;

								BgL_l1241z00_2131 = CDR(BgL_l1241z00_1902);
								BgL_l1241z00_1902 = BgL_l1241z00_2131;
								goto BgL_zc3z04anonymousza31541ze3z87_1901;
							}
						}
					else
						{	/* Ast/lvtype.scm 202 */
							((bool_t) 1);
						}
				}
			}
			BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
				(((BgL_letzd2varzd2_bglt) COBJECT(
							((BgL_letzd2varzd2_bglt) BgL_nodez00_1842)))->BgL_bodyz00));
			{	/* Ast/lvtype.scm 209 */
				bool_t BgL_test1841z00_2136;

				{	/* Ast/lvtype.scm 209 */
					BgL_typez00_bglt BgL_arg1564z00_1907;

					BgL_arg1564z00_1907 =
						(((BgL_nodez00_bglt) COBJECT(
								((BgL_nodez00_bglt)
									((BgL_letzd2varzd2_bglt) BgL_nodez00_1842))))->BgL_typez00);
					BgL_test1841z00_2136 =
						(((obj_t) BgL_arg1564z00_1907) == BGl_za2_za2z00zztype_cachez00);
				}
				if (BgL_test1841z00_2136)
					{
						BgL_typez00_bglt BgL_auxz00_2142;

						{	/* Ast/lvtype.scm 210 */
							BgL_nodez00_bglt BgL_arg1563z00_1908;

							BgL_arg1563z00_1908 =
								(((BgL_letzd2varzd2_bglt) COBJECT(
										((BgL_letzd2varzd2_bglt) BgL_nodez00_1842)))->BgL_bodyz00);
							BgL_auxz00_2142 =
								((BgL_typez00_bglt)
								BGl_getzd2objzd2typez00zzast_lvtypez00(BgL_arg1563z00_1908));
						}
						return
							((((BgL_nodez00_bglt) COBJECT(
										((BgL_nodez00_bglt)
											((BgL_letzd2varzd2_bglt) BgL_nodez00_1842))))->
								BgL_typez00) = ((BgL_typez00_bglt) BgL_auxz00_2142), BUNSPEC);
					}
				else
					{	/* Ast/lvtype.scm 209 */
						return BFALSE;
					}
			}
		}

	}



/* &lvtype-node!-let-fun1279 */
	obj_t BGl_z62lvtypezd2nodez12zd2letzd2fun1279za2zzast_lvtypez00(obj_t
		BgL_envz00_1843, obj_t BgL_nodez00_1844)
	{
		{	/* Ast/lvtype.scm 188 */
			{	/* Ast/lvtype.scm 190 */
				obj_t BgL_g1240z00_1910;

				BgL_g1240z00_1910 =
					(((BgL_letzd2funzd2_bglt) COBJECT(
							((BgL_letzd2funzd2_bglt) BgL_nodez00_1844)))->BgL_localsz00);
				{
					obj_t BgL_l1238z00_1912;

					BgL_l1238z00_1912 = BgL_g1240z00_1910;
				BgL_zc3z04anonymousza31515ze3z87_1911:
					if (PAIRP(BgL_l1238z00_1912))
						{	/* Ast/lvtype.scm 190 */
							{	/* Ast/lvtype.scm 191 */
								obj_t BgL_localz00_1913;

								BgL_localz00_1913 = CAR(BgL_l1238z00_1912);
								{	/* Ast/lvtype.scm 191 */
									obj_t BgL_arg1520z00_1914;

									BgL_arg1520z00_1914 =
										(((BgL_sfunz00_bglt) COBJECT(
												((BgL_sfunz00_bglt)
													(((BgL_variablez00_bglt) COBJECT(
																((BgL_variablez00_bglt)
																	((BgL_localz00_bglt) BgL_localz00_1913))))->
														BgL_valuez00))))->BgL_bodyz00);
									BGl_lvtypezd2nodez12zc0zzast_lvtypez00(((BgL_nodez00_bglt)
											BgL_arg1520z00_1914));
								}
							}
							{
								obj_t BgL_l1238z00_2162;

								BgL_l1238z00_2162 = CDR(BgL_l1238z00_1912);
								BgL_l1238z00_1912 = BgL_l1238z00_2162;
								goto BgL_zc3z04anonymousza31515ze3z87_1911;
							}
						}
					else
						{	/* Ast/lvtype.scm 190 */
							((bool_t) 1);
						}
				}
			}
			BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
				(((BgL_letzd2funzd2_bglt) COBJECT(
							((BgL_letzd2funzd2_bglt) BgL_nodez00_1844)))->BgL_bodyz00));
			{	/* Ast/lvtype.scm 194 */
				bool_t BgL_test1843z00_2167;

				{	/* Ast/lvtype.scm 194 */
					BgL_typez00_bglt BgL_arg1540z00_1915;

					BgL_arg1540z00_1915 =
						(((BgL_nodez00_bglt) COBJECT(
								((BgL_nodez00_bglt)
									((BgL_letzd2funzd2_bglt) BgL_nodez00_1844))))->BgL_typez00);
					BgL_test1843z00_2167 =
						(((obj_t) BgL_arg1540z00_1915) == BGl_za2_za2z00zztype_cachez00);
				}
				if (BgL_test1843z00_2167)
					{
						BgL_typez00_bglt BgL_auxz00_2173;

						{	/* Ast/lvtype.scm 195 */
							BgL_nodez00_bglt BgL_arg1536z00_1916;

							BgL_arg1536z00_1916 =
								(((BgL_letzd2funzd2_bglt) COBJECT(
										((BgL_letzd2funzd2_bglt) BgL_nodez00_1844)))->BgL_bodyz00);
							BgL_auxz00_2173 =
								((BgL_typez00_bglt)
								BGl_getzd2objzd2typez00zzast_lvtypez00(BgL_arg1536z00_1916));
						}
						return
							((((BgL_nodez00_bglt) COBJECT(
										((BgL_nodez00_bglt)
											((BgL_letzd2funzd2_bglt) BgL_nodez00_1844))))->
								BgL_typez00) = ((BgL_typez00_bglt) BgL_auxz00_2173), BUNSPEC);
					}
				else
					{	/* Ast/lvtype.scm 194 */
						return BFALSE;
					}
			}
		}

	}



/* &lvtype-node!-switch1277 */
	obj_t BGl_z62lvtypezd2nodez12zd2switch1277z70zzast_lvtypez00(obj_t
		BgL_envz00_1845, obj_t BgL_nodez00_1846)
	{
		{	/* Ast/lvtype.scm 178 */
			BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
				(((BgL_switchz00_bglt) COBJECT(
							((BgL_switchz00_bglt) BgL_nodez00_1846)))->BgL_testz00));
			{	/* Ast/lvtype.scm 181 */
				obj_t BgL_g1237z00_1918;

				BgL_g1237z00_1918 =
					(((BgL_switchz00_bglt) COBJECT(
							((BgL_switchz00_bglt) BgL_nodez00_1846)))->BgL_clausesz00);
				{
					obj_t BgL_l1235z00_1920;

					{	/* Ast/lvtype.scm 181 */
						bool_t BgL_tmpz00_2186;

						BgL_l1235z00_1920 = BgL_g1237z00_1918;
					BgL_zc3z04anonymousza31508ze3z87_1919:
						if (PAIRP(BgL_l1235z00_1920))
							{	/* Ast/lvtype.scm 181 */
								{	/* Ast/lvtype.scm 182 */
									obj_t BgL_clausez00_1921;

									BgL_clausez00_1921 = CAR(BgL_l1235z00_1920);
									{	/* Ast/lvtype.scm 182 */
										obj_t BgL_arg1511z00_1922;

										BgL_arg1511z00_1922 = CDR(((obj_t) BgL_clausez00_1921));
										BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
											((BgL_nodez00_bglt) BgL_arg1511z00_1922));
									}
								}
								{
									obj_t BgL_l1235z00_2194;

									BgL_l1235z00_2194 = CDR(BgL_l1235z00_1920);
									BgL_l1235z00_1920 = BgL_l1235z00_2194;
									goto BgL_zc3z04anonymousza31508ze3z87_1919;
								}
							}
						else
							{	/* Ast/lvtype.scm 181 */
								BgL_tmpz00_2186 = ((bool_t) 1);
							}
						return BBOOL(BgL_tmpz00_2186);
					}
				}
			}
		}

	}



/* &lvtype-node!-fail1275 */
	obj_t BGl_z62lvtypezd2nodez12zd2fail1275z70zzast_lvtypez00(obj_t
		BgL_envz00_1847, obj_t BgL_nodez00_1848)
	{
		{	/* Ast/lvtype.scm 169 */
			BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
				(((BgL_failz00_bglt) COBJECT(
							((BgL_failz00_bglt) BgL_nodez00_1848)))->BgL_procz00));
			BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
				(((BgL_failz00_bglt) COBJECT(
							((BgL_failz00_bglt) BgL_nodez00_1848)))->BgL_msgz00));
			return
				BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
				(((BgL_failz00_bglt) COBJECT(
							((BgL_failz00_bglt) BgL_nodez00_1848)))->BgL_objz00));
		}

	}



/* &lvtype-node!-conditi1273 */
	obj_t BGl_z62lvtypezd2nodez12zd2conditi1273z70zzast_lvtypez00(obj_t
		BgL_envz00_1849, obj_t BgL_nodez00_1850)
	{
		{	/* Ast/lvtype.scm 158 */
			BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
				(((BgL_conditionalz00_bglt) COBJECT(
							((BgL_conditionalz00_bglt) BgL_nodez00_1850)))->BgL_testz00));
			BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
				(((BgL_conditionalz00_bglt) COBJECT(
							((BgL_conditionalz00_bglt) BgL_nodez00_1850)))->BgL_truez00));
			BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
				(((BgL_conditionalz00_bglt) COBJECT(
							((BgL_conditionalz00_bglt) BgL_nodez00_1850)))->BgL_falsez00));
			{	/* Ast/lvtype.scm 163 */
				bool_t BgL_test1845z00_2215;

				{	/* Ast/lvtype.scm 163 */
					BgL_typez00_bglt BgL_arg1495z00_1925;

					BgL_arg1495z00_1925 =
						(((BgL_nodez00_bglt) COBJECT(
								((BgL_nodez00_bglt)
									((BgL_conditionalz00_bglt) BgL_nodez00_1850))))->BgL_typez00);
					BgL_test1845z00_2215 =
						(((obj_t) BgL_arg1495z00_1925) == BGl_za2_za2z00zztype_cachez00);
				}
				if (BgL_test1845z00_2215)
					{	/* Ast/lvtype.scm 163 */
						return
							((((BgL_nodez00_bglt) COBJECT(
										((BgL_nodez00_bglt)
											((BgL_conditionalz00_bglt) BgL_nodez00_1850))))->
								BgL_typez00) =
							((BgL_typez00_bglt) ((BgL_typez00_bglt)
									BGl_getzd2objzd2typez00zzast_lvtypez00(((BgL_nodez00_bglt) (
												(BgL_conditionalz00_bglt) BgL_nodez00_1850))))),
							BUNSPEC);
					}
				else
					{	/* Ast/lvtype.scm 163 */
						return BFALSE;
					}
			}
		}

	}



/* &lvtype-node!-setq1271 */
	obj_t BGl_z62lvtypezd2nodez12zd2setq1271z70zzast_lvtypez00(obj_t
		BgL_envz00_1851, obj_t BgL_nodez00_1852)
	{
		{	/* Ast/lvtype.scm 150 */
			BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
				(((BgL_setqz00_bglt) COBJECT(
							((BgL_setqz00_bglt) BgL_nodez00_1852)))->BgL_valuez00));
			{	/* Ast/lvtype.scm 153 */
				BgL_varz00_bglt BgL_arg1470z00_1927;

				BgL_arg1470z00_1927 =
					(((BgL_setqz00_bglt) COBJECT(
							((BgL_setqz00_bglt) BgL_nodez00_1852)))->BgL_varz00);
				return
					BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
					((BgL_nodez00_bglt) BgL_arg1470z00_1927));
			}
		}

	}



/* &lvtype-node!-cast1269 */
	obj_t BGl_z62lvtypezd2nodez12zd2cast1269z70zzast_lvtypez00(obj_t
		BgL_envz00_1853, obj_t BgL_nodez00_1854)
	{
		{	/* Ast/lvtype.scm 143 */
			return
				BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
				(((BgL_castz00_bglt) COBJECT(
							((BgL_castz00_bglt) BgL_nodez00_1854)))->BgL_argz00));
		}

	}



/* &lvtype-node!-extern1267 */
	obj_t BGl_z62lvtypezd2nodez12zd2extern1267z70zzast_lvtypez00(obj_t
		BgL_envz00_1855, obj_t BgL_nodez00_1856)
	{
		{	/* Ast/lvtype.scm 134 */
			BGl_lvtypezd2nodeza2z12z62zzast_lvtypez00(
				(((BgL_externz00_bglt) COBJECT(
							((BgL_externz00_bglt) BgL_nodez00_1856)))->BgL_exprza2za2));
			{	/* Ast/lvtype.scm 137 */
				bool_t BgL_test1846z00_2241;

				{	/* Ast/lvtype.scm 137 */
					BgL_typez00_bglt BgL_arg1452z00_1930;

					BgL_arg1452z00_1930 =
						(((BgL_nodez00_bglt) COBJECT(
								((BgL_nodez00_bglt)
									((BgL_externz00_bglt) BgL_nodez00_1856))))->BgL_typez00);
					BgL_test1846z00_2241 =
						(((obj_t) BgL_arg1452z00_1930) == BGl_za2_za2z00zztype_cachez00);
				}
				if (BgL_test1846z00_2241)
					{	/* Ast/lvtype.scm 137 */
						return
							((((BgL_nodez00_bglt) COBJECT(
										((BgL_nodez00_bglt)
											((BgL_externz00_bglt) BgL_nodez00_1856))))->BgL_typez00) =
							((BgL_typez00_bglt) ((BgL_typez00_bglt)
									BGl_getzd2objzd2typez00zzast_lvtypez00(((BgL_nodez00_bglt) (
												(BgL_externz00_bglt) BgL_nodez00_1856))))), BUNSPEC);
					}
				else
					{	/* Ast/lvtype.scm 137 */
						return BFALSE;
					}
			}
		}

	}



/* &lvtype-node!-funcall1265 */
	obj_t BGl_z62lvtypezd2nodez12zd2funcall1265z70zzast_lvtypez00(obj_t
		BgL_envz00_1857, obj_t BgL_nodez00_1858)
	{
		{	/* Ast/lvtype.scm 126 */
			BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
				(((BgL_funcallz00_bglt) COBJECT(
							((BgL_funcallz00_bglt) BgL_nodez00_1858)))->BgL_funz00));
			{	/* Ast/lvtype.scm 129 */
				obj_t BgL_arg1429z00_1932;

				BgL_arg1429z00_1932 =
					(((BgL_funcallz00_bglt) COBJECT(
							((BgL_funcallz00_bglt) BgL_nodez00_1858)))->BgL_argsz00);
				return
					BBOOL(BGl_lvtypezd2nodeza2z12z62zzast_lvtypez00(BgL_arg1429z00_1932));
			}
		}

	}



/* &lvtype-node!-app-ly1263 */
	obj_t BGl_z62lvtypezd2nodez12zd2appzd2ly1263za2zzast_lvtypez00(obj_t
		BgL_envz00_1859, obj_t BgL_nodez00_1860)
	{
		{	/* Ast/lvtype.scm 118 */
			BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
				(((BgL_appzd2lyzd2_bglt) COBJECT(
							((BgL_appzd2lyzd2_bglt) BgL_nodez00_1860)))->BgL_funz00));
			return
				BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
				(((BgL_appzd2lyzd2_bglt) COBJECT(
							((BgL_appzd2lyzd2_bglt) BgL_nodez00_1860)))->BgL_argz00));
		}

	}



/* &lvtype-node!-app1261 */
	obj_t BGl_z62lvtypezd2nodez12zd2app1261z70zzast_lvtypez00(obj_t
		BgL_envz00_1861, obj_t BgL_nodez00_1862)
	{
		{	/* Ast/lvtype.scm 109 */
			BGl_lvtypezd2nodeza2z12z62zzast_lvtypez00(
				(((BgL_appz00_bglt) COBJECT(
							((BgL_appz00_bglt) BgL_nodez00_1862)))->BgL_argsz00));
			{	/* Ast/lvtype.scm 112 */
				bool_t BgL_test1847z00_2270;

				{	/* Ast/lvtype.scm 112 */
					BgL_typez00_bglt BgL_arg1378z00_1935;

					BgL_arg1378z00_1935 =
						(((BgL_nodez00_bglt) COBJECT(
								((BgL_nodez00_bglt)
									((BgL_appz00_bglt) BgL_nodez00_1862))))->BgL_typez00);
					BgL_test1847z00_2270 =
						(((obj_t) BgL_arg1378z00_1935) == BGl_za2_za2z00zztype_cachez00);
				}
				if (BgL_test1847z00_2270)
					{	/* Ast/lvtype.scm 112 */
						return
							((((BgL_nodez00_bglt) COBJECT(
										((BgL_nodez00_bglt)
											((BgL_appz00_bglt) BgL_nodez00_1862))))->BgL_typez00) =
							((BgL_typez00_bglt) ((BgL_typez00_bglt)
									BGl_getzd2objzd2typez00zzast_lvtypez00(((BgL_nodez00_bglt) (
												(BgL_appz00_bglt) BgL_nodez00_1862))))), BUNSPEC);
					}
				else
					{	/* Ast/lvtype.scm 112 */
						return BFALSE;
					}
			}
		}

	}



/* &lvtype-node!-sync1259 */
	obj_t BGl_z62lvtypezd2nodez12zd2sync1259z70zzast_lvtypez00(obj_t
		BgL_envz00_1863, obj_t BgL_nodez00_1864)
	{
		{	/* Ast/lvtype.scm 98 */
			BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
				(((BgL_syncz00_bglt) COBJECT(
							((BgL_syncz00_bglt) BgL_nodez00_1864)))->BgL_mutexz00));
			BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
				(((BgL_syncz00_bglt) COBJECT(
							((BgL_syncz00_bglt) BgL_nodez00_1864)))->BgL_prelockz00));
			BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
				(((BgL_syncz00_bglt) COBJECT(
							((BgL_syncz00_bglt) BgL_nodez00_1864)))->BgL_bodyz00));
			{	/* Ast/lvtype.scm 103 */
				bool_t BgL_test1848z00_2292;

				{	/* Ast/lvtype.scm 103 */
					BgL_typez00_bglt BgL_arg1362z00_1937;

					BgL_arg1362z00_1937 =
						(((BgL_nodez00_bglt) COBJECT(
								((BgL_nodez00_bglt)
									((BgL_syncz00_bglt) BgL_nodez00_1864))))->BgL_typez00);
					BgL_test1848z00_2292 =
						(((obj_t) BgL_arg1362z00_1937) == BGl_za2_za2z00zztype_cachez00);
				}
				if (BgL_test1848z00_2292)
					{	/* Ast/lvtype.scm 103 */
						return
							((((BgL_nodez00_bglt) COBJECT(
										((BgL_nodez00_bglt)
											((BgL_syncz00_bglt) BgL_nodez00_1864))))->BgL_typez00) =
							((BgL_typez00_bglt) ((BgL_typez00_bglt)
									BGl_getzd2objzd2typez00zzast_lvtypez00(((BgL_nodez00_bglt) (
												(BgL_syncz00_bglt) BgL_nodez00_1864))))), BUNSPEC);
					}
				else
					{	/* Ast/lvtype.scm 103 */
						return BFALSE;
					}
			}
		}

	}



/* &lvtype-node!-sequenc1257 */
	obj_t BGl_z62lvtypezd2nodez12zd2sequenc1257z70zzast_lvtypez00(obj_t
		BgL_envz00_1865, obj_t BgL_nodez00_1866)
	{
		{	/* Ast/lvtype.scm 89 */
			BGl_lvtypezd2nodeza2z12z62zzast_lvtypez00(
				(((BgL_sequencez00_bglt) COBJECT(
							((BgL_sequencez00_bglt) BgL_nodez00_1866)))->BgL_nodesz00));
			{	/* Ast/lvtype.scm 92 */
				bool_t BgL_test1849z00_2308;

				{	/* Ast/lvtype.scm 92 */
					BgL_typez00_bglt BgL_arg1329z00_1939;

					BgL_arg1329z00_1939 =
						(((BgL_nodez00_bglt) COBJECT(
								((BgL_nodez00_bglt)
									((BgL_sequencez00_bglt) BgL_nodez00_1866))))->BgL_typez00);
					BgL_test1849z00_2308 =
						(((obj_t) BgL_arg1329z00_1939) == BGl_za2_za2z00zztype_cachez00);
				}
				if (BgL_test1849z00_2308)
					{	/* Ast/lvtype.scm 92 */
						return
							((((BgL_nodez00_bglt) COBJECT(
										((BgL_nodez00_bglt)
											((BgL_sequencez00_bglt) BgL_nodez00_1866))))->
								BgL_typez00) =
							((BgL_typez00_bglt) ((BgL_typez00_bglt)
									BGl_getzd2objzd2typez00zzast_lvtypez00(((BgL_nodez00_bglt) (
												(BgL_sequencez00_bglt) BgL_nodez00_1866))))), BUNSPEC);
					}
				else
					{	/* Ast/lvtype.scm 92 */
						return BFALSE;
					}
			}
		}

	}



/* &lvtype-node!-closure1255 */
	obj_t BGl_z62lvtypezd2nodez12zd2closure1255z70zzast_lvtypez00(obj_t
		BgL_envz00_1867, obj_t BgL_nodez00_1868)
	{
		{	/* Ast/lvtype.scm 83 */
			{	/* Ast/lvtype.scm 84 */
				obj_t BgL_arg1320z00_1941;

				BgL_arg1320z00_1941 =
					BGl_shapez00zztools_shapez00(
					((obj_t) ((BgL_closurez00_bglt) BgL_nodez00_1868)));
				return
					BGl_internalzd2errorzd2zztools_errorz00
					(BGl_string1769z00zzast_lvtypez00, BGl_string1793z00zzast_lvtypez00,
					BgL_arg1320z00_1941);
			}
		}

	}



/* &lvtype-node!-var1253 */
	obj_t BGl_z62lvtypezd2nodez12zd2var1253z70zzast_lvtypez00(obj_t
		BgL_envz00_1869, obj_t BgL_nodez00_1870)
	{
		{	/* Ast/lvtype.scm 74 */
			{	/* Ast/lvtype.scm 76 */
				bool_t BgL_test1850z00_2325;

				{	/* Ast/lvtype.scm 76 */
					BgL_typez00_bglt BgL_arg1319z00_1943;

					BgL_arg1319z00_1943 =
						(((BgL_nodez00_bglt) COBJECT(
								((BgL_nodez00_bglt)
									((BgL_varz00_bglt) BgL_nodez00_1870))))->BgL_typez00);
					BgL_test1850z00_2325 =
						(((obj_t) BgL_arg1319z00_1943) == BGl_za2_za2z00zztype_cachez00);
				}
				if (BgL_test1850z00_2325)
					{	/* Ast/lvtype.scm 76 */
						((((BgL_nodez00_bglt) COBJECT(
										((BgL_nodez00_bglt)
											((BgL_varz00_bglt) BgL_nodez00_1870))))->BgL_typez00) =
							((BgL_typez00_bglt) (((BgL_variablez00_bglt)
										COBJECT((((BgL_varz00_bglt) COBJECT(((BgL_varz00_bglt)
															BgL_nodez00_1870)))->BgL_variablez00)))->
									BgL_typez00)), BUNSPEC);
					}
				else
					{	/* Ast/lvtype.scm 76 */
						BFALSE;
					}
			}
			return ((obj_t) ((BgL_varz00_bglt) BgL_nodez00_1870));
		}

	}



/* &lvtype-node!-kwote1251 */
	obj_t BGl_z62lvtypezd2nodez12zd2kwote1251z70zzast_lvtypez00(obj_t
		BgL_envz00_1871, obj_t BgL_nodez00_1872)
	{
		{	/* Ast/lvtype.scm 68 */
			return ((obj_t) ((BgL_kwotez00_bglt) BgL_nodez00_1872));
		}

	}



/* &lvtype-node!-atom1249 */
	obj_t BGl_z62lvtypezd2nodez12zd2atom1249z70zzast_lvtypez00(obj_t
		BgL_envz00_1873, obj_t BgL_nodez00_1874)
	{
		{	/* Ast/lvtype.scm 62 */
			return ((obj_t) ((BgL_atomz00_bglt) BgL_nodez00_1874));
		}

	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzast_lvtypez00()
	{
		{	/* Ast/lvtype.scm 16 */
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 515343395),
				BSTRING_TO_STRING(BGl_string1794z00zzast_lvtypez00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 346491734),
				BSTRING_TO_STRING(BGl_string1794z00zzast_lvtypez00));
			BGl_modulezd2initializa7ationz75zztype_typeofz00(((long) 398780265),
				BSTRING_TO_STRING(BGl_string1794z00zzast_lvtypez00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 365925558),
				BSTRING_TO_STRING(BGl_string1794z00zzast_lvtypez00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 300504031),
				BSTRING_TO_STRING(BGl_string1794z00zzast_lvtypez00));
			BGl_modulezd2initializa7ationz75zzast_dumpz00(((long) 271707717),
				BSTRING_TO_STRING(BGl_string1794z00zzast_lvtypez00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 90839984),
				BSTRING_TO_STRING(BGl_string1794z00zzast_lvtypez00));
			return
				BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 506185397),
				BSTRING_TO_STRING(BGl_string1794z00zzast_lvtypez00));
		}

	}

#ifdef __cplusplus
}
#endif
