/*===========================================================================*/
/*   (Ast/shrinkify.scm)                                                     */
/*   Bigloo (4.3g)                                                           */
/*   Inria -- Sophia Antipolis (c)       Wed 12 Feb 2020 07:45:41 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.3g -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Ast/shrinkify.scm) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		bool_t BgL_evalzf3zf3;
		obj_t BgL_libraryz00;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
		obj_t BgL_initz00;
		obj_t BgL_aliasz00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_localz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		long BgL_keyz00;
	}               *BgL_localz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
		obj_t BgL_strengthz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
		bool_t BgL_unsafez00;
		obj_t BgL_metaz00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_appzd2lyzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}                  *BgL_appzd2lyzd2_bglt;

	typedef struct BgL_funcallz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_strengthz00;
		obj_t BgL_functionsz00;
	}                 *BgL_funcallz00_bglt;

	typedef struct BgL_externz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
	}                *BgL_externz00_bglt;

	typedef struct BgL_castz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}              *BgL_castz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_failz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_procz00;
		struct BgL_nodez00_bgl *BgL_msgz00;
		struct BgL_nodez00_bgl *BgL_objz00;
	}              *BgL_failz00_bglt;

	typedef struct BgL_switchz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_switchz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;

	typedef struct BgL_setzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                       *BgL_setzd2exzd2itz00_bglt;

	typedef struct BgL_jumpzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_exitz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                        *BgL_jumpzd2exzd2itz00_bglt;

	typedef struct BgL_makezd2boxzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                    *BgL_makezd2boxzd2_bglt;

	typedef struct BgL_boxzd2refzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                   *BgL_boxzd2refzd2_bglt;

	typedef struct BgL_boxzd2setz12zc0_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                      *BgL_boxzd2setz12zc0_bglt;

	typedef struct BgL_syncz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_mutexz00;
		struct BgL_nodez00_bgl *BgL_prelockz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}              *BgL_syncz00_bglt;


	extern obj_t BGl_syncz00zzast_nodez00;
	extern obj_t BGl_sequencez00zzast_nodez00;
	extern obj_t BGl_forzd2eachzd2globalz12z12zzast_envz00(obj_t, obj_t);
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	extern obj_t BGl_failz00zzast_nodez00;
	static obj_t BGl_z62shrinkzd2variablez12za2zzast_shrinkifyz00(obj_t, obj_t);
	static obj_t BGl_objectzd2initzd2zzast_shrinkifyz00();
	extern obj_t BGl_boxzd2refzd2zzast_nodez00;
	static obj_t BGl_z62shrinkzd2nodez12zd2switch1275z70zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(BgL_nodez00_bglt);
	BGL_EXPORTED_DECL obj_t BGl_shrinkifyz12z12zzast_shrinkifyz00(obj_t);
	static obj_t BGl_methodzd2initzd2zzast_shrinkifyz00();
	static obj_t BGl_z62shrinkzd2nodez12zd2funcall1263z70zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t BGl_z62shrinkzd2nodez12zd2conditi1271z70zzast_shrinkifyz00(obj_t,
		obj_t);
	extern obj_t BGl_externz00zzast_nodez00;
	static obj_t BGl_z62shrinkifyz12z70zzast_shrinkifyz00(obj_t, obj_t);
	static obj_t BGl_z62shrinkzd2nodez12zd2sync1257z70zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t
		BGl_z62shrinkzd2nodez12zd2boxzd2ref1279za2zzast_shrinkifyz00(obj_t, obj_t);
	static obj_t BGl_z62shrinkzd2nodez12zd2fail1273z70zzast_shrinkifyz00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62shrinkzd2variablez121244za2zzast_shrinkifyz00(obj_t,
		obj_t);
	extern obj_t BGl_appzd2lyzd2zzast_nodez00;
	static obj_t
		BGl_z62shrinkzd2nodez12zd2makezd2bo1277za2zzast_shrinkifyz00(obj_t, obj_t);
	static obj_t BGl_gczd2rootszd2initz00zzast_shrinkifyz00();
	static obj_t BGl_z62shrinkzd2nodez12zd2app1259z70zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t BGl_z62shrinkzd2nodez12za2zzast_shrinkifyz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_variablez00zzast_varz00;
	static bool_t BGl_shrinkzd2nodeza2z12z62zzast_shrinkifyz00(obj_t);
	extern obj_t BGl_conditionalz00zzast_nodez00;
	static obj_t
		BGl_shrinkzd2variablez12zc0zzast_shrinkifyz00(BgL_variablez00_bglt);
	extern obj_t BGl_setqz00zzast_nodez00;
	static obj_t
		BGl_z62shrinkzd2nodez12zd2letzd2fun1283za2zzast_shrinkifyz00(obj_t, obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzast_shrinkifyz00 = BUNSPEC;
	static obj_t BGl_z62shrinkzd2nodez121246za2zzast_shrinkifyz00(obj_t, obj_t);
	static obj_t
		BGl_z62shrinkzd2nodez12zd2appzd2ly1261za2zzast_shrinkifyz00(obj_t, obj_t);
	extern obj_t BGl_setzd2exzd2itz00zzast_nodez00;
	BGL_IMPORT obj_t BGl_za2classesza2z00zz__objectz00;
	BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_atomz00zzast_nodez00;
	static obj_t BGl_toplevelzd2initzd2zzast_shrinkifyz00();
	static obj_t BGl_genericzd2initzd2zzast_shrinkifyz00();
	static obj_t BGl_z62shrinkzd2nodez12zd2extern1265z70zzast_shrinkifyz00(obj_t,
		obj_t);
	extern obj_t BGl_castz00zzast_nodez00;
	static obj_t BGl_z62shrinkzd2nodez12zd2kwote1253z70zzast_shrinkifyz00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	static obj_t
		BGl_z62shrinkzd2nodez12zd2setzd2exzd21287z70zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t BGl_z62shrinkzd2nodez12zd2cast1267z70zzast_shrinkifyz00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62shrinkzd2nodez12zd2setq1269z70zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t
		BGl_z62shrinkzd2nodez12zd2letzd2var1285za2zzast_shrinkifyz00(obj_t, obj_t);
	static obj_t
		BGl_z62shrinkzd2nodez12zd2boxzd2set1281za2zzast_shrinkifyz00(obj_t, obj_t);
	extern obj_t BGl_varz00zzast_nodez00;
	extern obj_t BGl_makezd2boxzd2zzast_nodez00;
	static obj_t BGl_z62shrinkzd2nodez12zd2sequenc1255z70zzast_shrinkifyz00(obj_t,
		obj_t);
	extern obj_t BGl_boxzd2setz12zc0zzast_nodez00;
	static obj_t BGl_z62shrinkzd2nodez12zd2var1251z70zzast_shrinkifyz00(obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zzast_shrinkifyz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	extern obj_t BGl_appz00zzast_nodez00;
	extern obj_t BGl_nodez00zzast_nodez00;
	extern obj_t BGl_kwotez00zzast_nodez00;
	extern obj_t BGl_jumpzd2exzd2itz00zzast_nodez00;
	static obj_t BGl_cnstzd2initzd2zzast_shrinkifyz00();
	static obj_t BGl_libraryzd2moduleszd2initz00zzast_shrinkifyz00();
	static obj_t BGl_importedzd2moduleszd2initz00zzast_shrinkifyz00();
	extern obj_t BGl_letzd2funzd2zzast_nodez00;
	extern obj_t BGl_switchz00zzast_nodez00;
	static obj_t
		BGl_z62shrinkzd2nodez12zd2jumpzd2ex1289za2zzast_shrinkifyz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_classzd2superzd2zz__objectz00(obj_t);
	static obj_t BGl_z62shrinkzd2nodez12zd2atom1249z70zzast_shrinkifyz00(obj_t,
		obj_t);
	extern obj_t BGl_funcallz00zzast_nodez00;
	static obj_t __cnst[1];


	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_shrinkifyz12zd2envzc0zzast_shrinkifyz00,
		BgL_bgl_za762shrinkifyza712za71861za7,
		BGl_z62shrinkifyz12z70zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	     
		DEFINE_STATIC_BGL_GENERIC
		(BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2vari1862z00,
		BGl_z62shrinkzd2variablez12za2zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string1830z00zzast_shrinkifyz00,
		BgL_bgl_string1830za700za7za7a1863za7, "shrink-variable!1244", 20);
	      DEFINE_STRING(BGl_string1832z00zzast_shrinkifyz00,
		BgL_bgl_string1832za700za7za7a1864za7, "shrink-node!1246", 16);
	      DEFINE_STRING(BGl_string1833z00zzast_shrinkifyz00,
		BgL_bgl_string1833za700za7za7a1865za7, "No method for this object", 25);
	      DEFINE_STRING(BGl_string1835z00zzast_shrinkifyz00,
		BgL_bgl_string1835za700za7za7a1866za7, "shrink-node!", 12);
	      DEFINE_STRING(BGl_string1856z00zzast_shrinkifyz00,
		BgL_bgl_string1856za700za7za7a1867za7, "ast_shrinkify", 13);
	      DEFINE_STRING(BGl_string1857z00zzast_shrinkifyz00,
		BgL_bgl_string1857za700za7za7a1868za7, "shrink-node!1246 ", 17);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1829z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2vari1869z00,
		BGl_z62shrinkzd2variablez121244za2zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1831z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1870z00,
		BGl_z62shrinkzd2nodez121246za2zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1834z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1871z00,
		BGl_z62shrinkzd2nodez12zd2atom1249z70zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1836z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1872z00,
		BGl_z62shrinkzd2nodez12zd2var1251z70zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1837z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1873z00,
		BGl_z62shrinkzd2nodez12zd2kwote1253z70zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1838z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1874z00,
		BGl_z62shrinkzd2nodez12zd2sequenc1255z70zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1839z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1875z00,
		BGl_z62shrinkzd2nodez12zd2sync1257z70zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1840z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1876z00,
		BGl_z62shrinkzd2nodez12zd2app1259z70zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1841z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1877z00,
		BGl_z62shrinkzd2nodez12zd2appzd2ly1261za2zzast_shrinkifyz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1842z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1878z00,
		BGl_z62shrinkzd2nodez12zd2funcall1263z70zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1843z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1879z00,
		BGl_z62shrinkzd2nodez12zd2extern1265z70zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1844z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1880z00,
		BGl_z62shrinkzd2nodez12zd2cast1267z70zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1845z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1881z00,
		BGl_z62shrinkzd2nodez12zd2setq1269z70zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1846z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1882z00,
		BGl_z62shrinkzd2nodez12zd2conditi1271z70zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1847z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1883z00,
		BGl_z62shrinkzd2nodez12zd2fail1273z70zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1848z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1884z00,
		BGl_z62shrinkzd2nodez12zd2switch1275z70zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1849z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1885z00,
		BGl_z62shrinkzd2nodez12zd2makezd2bo1277za2zzast_shrinkifyz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1850z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1886z00,
		BGl_z62shrinkzd2nodez12zd2boxzd2ref1279za2zzast_shrinkifyz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1851z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1887z00,
		BGl_z62shrinkzd2nodez12zd2boxzd2set1281za2zzast_shrinkifyz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1852z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1888z00,
		BGl_z62shrinkzd2nodez12zd2letzd2fun1283za2zzast_shrinkifyz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1853z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1889z00,
		BGl_z62shrinkzd2nodez12zd2letzd2var1285za2zzast_shrinkifyz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1854z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1890z00,
		BGl_z62shrinkzd2nodez12zd2setzd2exzd21287z70zzast_shrinkifyz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1855z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1891z00,
		BGl_z62shrinkzd2nodez12zd2jumpzd2ex1289za2zzast_shrinkifyz00, 0L, BUNSPEC,
		1);
	     
		DEFINE_STATIC_BGL_GENERIC(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1892z00,
		BGl_z62shrinkzd2nodez12za2zzast_shrinkifyz00, 0L, BUNSPEC, 1);

/* GC roots registration */
	static obj_t bgl_gc_roots_register()
	{
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
		void *roots_min = (void *) ULONG_MAX, *roots_max = 0;
		   
			 ADD_ROOT((void
				*) (&BGl_requirezd2initializa7ationz75zzast_shrinkifyz00));
#undef ADD_ROOT
		if   (roots_max > 0)
			     GC_add_roots(roots_min, ((void **) roots_max) + 1);
#endif
		     return BUNSPEC;
	}



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzast_shrinkifyz00(long
		BgL_checksumz00_2236, char *BgL_fromz00_2237)
	{
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzast_shrinkifyz00))
				{
					BGl_requirezd2initializa7ationz75zzast_shrinkifyz00 =
						BBOOL(((bool_t) 0));
					BGl_gczd2rootszd2initz00zzast_shrinkifyz00();
					BGl_libraryzd2moduleszd2initz00zzast_shrinkifyz00();
					BGl_cnstzd2initzd2zzast_shrinkifyz00();
					BGl_importedzd2moduleszd2initz00zzast_shrinkifyz00();
					BGl_genericzd2initzd2zzast_shrinkifyz00();
					BGl_methodzd2initzd2zzast_shrinkifyz00();
					return BGl_toplevelzd2initzd2zzast_shrinkifyz00();
				}
			else
				{
					return BUNSPEC;
				}
		}

	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzast_shrinkifyz00()
	{
		{	/* Ast/shrinkify.scm 15 */
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "ast_shrinkify");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0),
				"ast_shrinkify");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0),
				"ast_shrinkify");
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 0),
				"ast_shrinkify");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"ast_shrinkify");
			BGl_modulezd2initializa7ationz75zz__bitz00(((long) 0), "ast_shrinkify");
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 0),
				"ast_shrinkify");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long) 0),
				"ast_shrinkify");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"ast_shrinkify");
			return BUNSPEC;
		}

	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzast_shrinkifyz00()
	{
		{	/* Ast/shrinkify.scm 15 */
			{	/* Ast/shrinkify.scm 15 */
				obj_t BgL_cportz00_2101;

				{	/* Ast/shrinkify.scm 15 */
					obj_t BgL_stringz00_2109;

					BgL_stringz00_2109 = BGl_string1857z00zzast_shrinkifyz00;
					{	/* Ast/shrinkify.scm 15 */
						obj_t BgL_startz00_2110;

						BgL_startz00_2110 = BINT(((long) 0));
						{	/* Ast/shrinkify.scm 15 */
							obj_t BgL_endz00_2111;

							BgL_endz00_2111 =
								BINT(STRING_LENGTH(((obj_t) BgL_stringz00_2109)));
							{	/* Ast/shrinkify.scm 15 */

								BgL_cportz00_2101 =
									BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00
									(BgL_stringz00_2109, BgL_startz00_2110, BgL_endz00_2111);
				}}}}
				{
					long BgL_iz00_2102;

					BgL_iz00_2102 = ((long) 0);
				BgL_loopz00_2103:
					if ((BgL_iz00_2102 == ((long) -1)))
						{	/* Ast/shrinkify.scm 15 */
							return BUNSPEC;
						}
					else
						{	/* Ast/shrinkify.scm 15 */
							{	/* Ast/shrinkify.scm 15 */
								obj_t BgL_arg1859z00_2105;

								{	/* Ast/shrinkify.scm 15 */

									{	/* Ast/shrinkify.scm 15 */
										obj_t BgL_locationz00_2107;

										BgL_locationz00_2107 = BBOOL(((bool_t) 0));
										{	/* Ast/shrinkify.scm 15 */

											BgL_arg1859z00_2105 =
												BGl_readz00zz__readerz00(BgL_cportz00_2101,
												BgL_locationz00_2107);
										}
									}
								}
								{	/* Ast/shrinkify.scm 15 */
									int BgL_tmpz00_2266;

									BgL_tmpz00_2266 = (int) (BgL_iz00_2102);
									CNST_TABLE_SET(BgL_tmpz00_2266, BgL_arg1859z00_2105);
							}}
							{	/* Ast/shrinkify.scm 15 */
								int BgL_auxz00_2108;

								BgL_auxz00_2108 = (int) ((BgL_iz00_2102 - ((long) 1)));
								{
									long BgL_iz00_2271;

									BgL_iz00_2271 = (long) (BgL_auxz00_2108);
									BgL_iz00_2102 = BgL_iz00_2271;
									goto BgL_loopz00_2103;
								}
							}
						}
				}
			}
		}

	}



/* gc-roots-init */
	obj_t BGl_gczd2rootszd2initz00zzast_shrinkifyz00()
	{
		{	/* Ast/shrinkify.scm 15 */
			return bgl_gc_roots_register();
		}

	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzast_shrinkifyz00()
	{
		{	/* Ast/shrinkify.scm 15 */
			return BUNSPEC;
		}

	}



/* shrinkify! */
	BGL_EXPORTED_DEF obj_t BGl_shrinkifyz12z12zzast_shrinkifyz00(obj_t
		BgL_globalsz00_3)
	{
		{	/* Ast/shrinkify.scm 25 */
			BGl_forzd2eachzd2globalz12z12zzast_envz00
				(BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00, BNIL);
			{
				obj_t BgL_l1228z00_1323;

				BgL_l1228z00_1323 = BgL_globalsz00_3;
			BgL_zc3z04anonymousza31297ze3z87_1324:
				if (PAIRP(BgL_l1228z00_1323))
					{	/* Ast/shrinkify.scm 27 */
						{	/* Ast/shrinkify.scm 28 */
							obj_t BgL_globalz00_1326;

							BgL_globalz00_1326 = CAR(BgL_l1228z00_1323);
							{	/* Ast/shrinkify.scm 28 */
								BgL_valuez00_bglt BgL_sfunz00_1327;

								BgL_sfunz00_1327 =
									(((BgL_variablez00_bglt) COBJECT(
											((BgL_variablez00_bglt)
												((BgL_globalz00_bglt) BgL_globalz00_1326))))->
									BgL_valuez00);
								{	/* Ast/shrinkify.scm 29 */
									obj_t BgL_g1227z00_1328;

									BgL_g1227z00_1328 =
										(((BgL_sfunz00_bglt) COBJECT(
												((BgL_sfunz00_bglt) BgL_sfunz00_1327)))->BgL_argsz00);
									{
										obj_t BgL_l1225z00_1330;

										BgL_l1225z00_1330 = BgL_g1227z00_1328;
									BgL_zc3z04anonymousza31299ze3z87_1331:
										if (PAIRP(BgL_l1225z00_1330))
											{	/* Ast/shrinkify.scm 29 */
												{	/* Ast/shrinkify.scm 29 */
													obj_t BgL_arg1303z00_1333;

													BgL_arg1303z00_1333 = CAR(BgL_l1225z00_1330);
													BGl_shrinkzd2variablez12zc0zzast_shrinkifyz00(
														((BgL_variablez00_bglt) BgL_arg1303z00_1333));
												}
												{
													obj_t BgL_l1225z00_2288;

													BgL_l1225z00_2288 = CDR(BgL_l1225z00_1330);
													BgL_l1225z00_1330 = BgL_l1225z00_2288;
													goto BgL_zc3z04anonymousza31299ze3z87_1331;
												}
											}
										else
											{	/* Ast/shrinkify.scm 29 */
												((bool_t) 1);
											}
									}
								}
								{	/* Ast/shrinkify.scm 30 */
									obj_t BgL_arg1305z00_1336;

									BgL_arg1305z00_1336 =
										(((BgL_sfunz00_bglt) COBJECT(
												((BgL_sfunz00_bglt)
													(((BgL_variablez00_bglt) COBJECT(
																((BgL_variablez00_bglt)
																	((BgL_globalz00_bglt) BgL_globalz00_1326))))->
														BgL_valuez00))))->BgL_bodyz00);
									BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(((BgL_nodez00_bglt)
											BgL_arg1305z00_1336));
								}
							}
						}
						{
							obj_t BgL_l1228z00_2297;

							BgL_l1228z00_2297 = CDR(BgL_l1228z00_1323);
							BgL_l1228z00_1323 = BgL_l1228z00_2297;
							goto BgL_zc3z04anonymousza31297ze3z87_1324;
						}
					}
				else
					{	/* Ast/shrinkify.scm 27 */
						((bool_t) 1);
					}
			}
			return BgL_globalsz00_3;
		}

	}



/* &shrinkify! */
	obj_t BGl_z62shrinkifyz12z70zzast_shrinkifyz00(obj_t BgL_envz00_2025,
		obj_t BgL_globalsz00_2026)
	{
		{	/* Ast/shrinkify.scm 25 */
			return BGl_shrinkifyz12z12zzast_shrinkifyz00(BgL_globalsz00_2026);
		}

	}



/* shrink-node*! */
	bool_t BGl_shrinkzd2nodeza2z12z62zzast_shrinkifyz00(obj_t BgL_nodeza2za2_27)
	{
		{	/* Ast/shrinkify.scm 230 */
			{
				obj_t BgL_l1242z00_1341;

				BgL_l1242z00_1341 = BgL_nodeza2za2_27;
			BgL_zc3z04anonymousza31310ze3z87_1342:
				if (PAIRP(BgL_l1242z00_1341))
					{	/* Ast/shrinkify.scm 231 */
						{	/* Ast/shrinkify.scm 231 */
							obj_t BgL_arg1314z00_1344;

							BgL_arg1314z00_1344 = CAR(BgL_l1242z00_1341);
							BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
								((BgL_nodez00_bglt) BgL_arg1314z00_1344));
						}
						{
							obj_t BgL_l1242z00_2305;

							BgL_l1242z00_2305 = CDR(BgL_l1242z00_1341);
							BgL_l1242z00_1341 = BgL_l1242z00_2305;
							goto BgL_zc3z04anonymousza31310ze3z87_1342;
						}
					}
				else
					{	/* Ast/shrinkify.scm 231 */
						return ((bool_t) 1);
					}
			}
		}

	}



/* object-init */
	obj_t BGl_objectzd2initzd2zzast_shrinkifyz00()
	{
		{	/* Ast/shrinkify.scm 15 */
			return BUNSPEC;
		}

	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzast_shrinkifyz00()
	{
		{	/* Ast/shrinkify.scm 15 */
			BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00,
				BGl_proc1829z00zzast_shrinkifyz00, BGl_variablez00zzast_varz00,
				BGl_string1830z00zzast_shrinkifyz00);
			return
				BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_proc1831z00zzast_shrinkifyz00, BGl_nodez00zzast_nodez00,
				BGl_string1832z00zzast_shrinkifyz00);
		}

	}



/* &shrink-node!1246 */
	obj_t BGl_z62shrinkzd2nodez121246za2zzast_shrinkifyz00(obj_t BgL_envz00_2031,
		obj_t BgL_nodez00_2032)
	{
		{	/* Ast/shrinkify.scm 46 */
			return
				BGl_errorz00zz__errorz00(CNST_TABLE_REF(((long) 0)),
				BGl_string1833z00zzast_shrinkifyz00,
				((obj_t) ((BgL_nodez00_bglt) BgL_nodez00_2032)));
		}

	}



/* &shrink-variable!1244 */
	obj_t BGl_z62shrinkzd2variablez121244za2zzast_shrinkifyz00(obj_t
		BgL_envz00_2033, obj_t BgL_variablez00_2034)
	{
		{	/* Ast/shrinkify.scm 37 */
			{	/* Ast/shrinkify.scm 38 */
				bool_t BgL_test1898z00_2313;

				{	/* Ast/shrinkify.scm 38 */
					bool_t BgL_res1767z00_2116;

					{	/* Ast/shrinkify.scm 38 */
						obj_t BgL_tmpz00_2314;

						{	/* Ast/shrinkify.scm 38 */
							BgL_objectz00_bglt BgL_tmpz00_2315;

							BgL_tmpz00_2315 =
								((BgL_objectz00_bglt)
								((BgL_variablez00_bglt) BgL_variablez00_2034));
							BgL_tmpz00_2314 = BGL_OBJECT_WIDENING(BgL_tmpz00_2315);
						}
						BgL_res1767z00_2116 = CBOOL(BgL_tmpz00_2314);
					}
					BgL_test1898z00_2313 = BgL_res1767z00_2116;
				}
				if (BgL_test1898z00_2313)
					{	/* Ast/shrinkify.scm 38 */
						{	/* Ast/shrinkify.scm 39 */
							long BgL_arg1318z00_2117;

							{	/* Ast/shrinkify.scm 39 */
								obj_t BgL_arg1319z00_2118;

								{	/* Ast/shrinkify.scm 39 */
									obj_t BgL_arg1320z00_2119;

									{	/* Ast/shrinkify.scm 39 */
										long BgL_arg1744z00_2120;

										{	/* Ast/shrinkify.scm 39 */
											long BgL_arg1745z00_2121;

											{	/* Ast/shrinkify.scm 39 */
												long BgL_res1768z00_2122;

												BgL_res1768z00_2122 =
													BGL_OBJECT_CLASS_NUM(
													((BgL_objectz00_bglt)
														((BgL_variablez00_bglt) BgL_variablez00_2034)));
												BgL_arg1745z00_2121 = BgL_res1768z00_2122;
											}
											BgL_arg1744z00_2120 = (BgL_arg1745z00_2121 - OBJECT_TYPE);
										}
										BgL_arg1320z00_2119 =
											VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
											BgL_arg1744z00_2120);
									}
									BgL_arg1319z00_2118 =
										BGl_classzd2superzd2zz__objectz00(BgL_arg1320z00_2119);
								}
								{	/* Ast/shrinkify.scm 39 */
									long BgL_res1770z00_2123;

									{	/* Ast/shrinkify.scm 39 */
										obj_t BgL_tmpz00_2326;

										BgL_tmpz00_2326 = ((obj_t) BgL_arg1319z00_2118);
										BgL_res1770z00_2123 = BGL_CLASS_INDEX(BgL_tmpz00_2326);
									}
									BgL_arg1318z00_2117 = BgL_res1770z00_2123;
							}}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt)
									((BgL_variablez00_bglt) BgL_variablez00_2034)),
								BgL_arg1318z00_2117);
						}
						{	/* Ast/shrinkify.scm 39 */
							BgL_objectz00_bglt BgL_tmpz00_2332;

							BgL_tmpz00_2332 =
								((BgL_objectz00_bglt)
								((BgL_variablez00_bglt) BgL_variablez00_2034));
							BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2332, BFALSE);
						}
						((BgL_objectz00_bglt)
							((BgL_variablez00_bglt) BgL_variablez00_2034));
						((obj_t) ((BgL_variablez00_bglt) BgL_variablez00_2034));
					}
				else
					{	/* Ast/shrinkify.scm 38 */
						BFALSE;
					}
			}
			{	/* Ast/shrinkify.scm 40 */
				bool_t BgL_test1899z00_2340;

				{	/* Ast/shrinkify.scm 40 */
					bool_t BgL_res1771z00_2124;

					{	/* Ast/shrinkify.scm 40 */
						BgL_objectz00_bglt BgL_oz00_2125;

						BgL_oz00_2125 =
							((BgL_objectz00_bglt)
							(((BgL_variablez00_bglt) COBJECT(
										((BgL_variablez00_bglt) BgL_variablez00_2034)))->
								BgL_valuez00));
						BgL_res1771z00_2124 = CBOOL(BGL_OBJECT_WIDENING(BgL_oz00_2125));
					}
					BgL_test1899z00_2340 = BgL_res1771z00_2124;
				}
				if (BgL_test1899z00_2340)
					{	/* Ast/shrinkify.scm 41 */
						BgL_valuez00_bglt BgL_o1101z00_2126;

						BgL_o1101z00_2126 =
							(((BgL_variablez00_bglt) COBJECT(
									((BgL_variablez00_bglt) BgL_variablez00_2034)))->
							BgL_valuez00);
						{	/* Ast/shrinkify.scm 41 */
							long BgL_arg1325z00_2127;

							{	/* Ast/shrinkify.scm 41 */
								obj_t BgL_arg1329z00_2128;

								{	/* Ast/shrinkify.scm 41 */
									obj_t BgL_arg1330z00_2129;

									{	/* Ast/shrinkify.scm 41 */
										long BgL_arg1744z00_2130;

										{	/* Ast/shrinkify.scm 41 */
											long BgL_arg1745z00_2131;

											{	/* Ast/shrinkify.scm 41 */
												long BgL_res1772z00_2132;

												BgL_res1772z00_2132 =
													BGL_OBJECT_CLASS_NUM(
													((BgL_objectz00_bglt) BgL_o1101z00_2126));
												BgL_arg1745z00_2131 = BgL_res1772z00_2132;
											}
											BgL_arg1744z00_2130 = (BgL_arg1745z00_2131 - OBJECT_TYPE);
										}
										BgL_arg1330z00_2129 =
											VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
											BgL_arg1744z00_2130);
									}
									BgL_arg1329z00_2128 =
										BGl_classzd2superzd2zz__objectz00(BgL_arg1330z00_2129);
								}
								{	/* Ast/shrinkify.scm 41 */
									long BgL_res1774z00_2133;

									{	/* Ast/shrinkify.scm 41 */
										obj_t BgL_tmpz00_2353;

										BgL_tmpz00_2353 = ((obj_t) BgL_arg1329z00_2128);
										BgL_res1774z00_2133 = BGL_CLASS_INDEX(BgL_tmpz00_2353);
									}
									BgL_arg1325z00_2127 = BgL_res1774z00_2133;
							}}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt) BgL_o1101z00_2126), BgL_arg1325z00_2127);
						}
						{	/* Ast/shrinkify.scm 41 */
							BgL_objectz00_bglt BgL_tmpz00_2358;

							BgL_tmpz00_2358 = ((BgL_objectz00_bglt) BgL_o1101z00_2126);
							BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2358, BFALSE);
						}
						((BgL_objectz00_bglt) BgL_o1101z00_2126);
						return ((obj_t) BgL_o1101z00_2126);
					}
				else
					{	/* Ast/shrinkify.scm 40 */
						return BFALSE;
					}
			}
		}

	}



/* shrink-variable! */
	obj_t BGl_shrinkzd2variablez12zc0zzast_shrinkifyz00(BgL_variablez00_bglt
		BgL_variablez00_4)
	{
		{	/* Ast/shrinkify.scm 37 */
			{	/* Ast/shrinkify.scm 37 */
				obj_t BgL_method1245z00_1367;

				{	/* Ast/shrinkify.scm 37 */
					obj_t BgL_res1785z00_1806;

					{	/* Ast/shrinkify.scm 37 */
						long BgL_objzd2classzd2numz00_1771;

						{	/* Ast/shrinkify.scm 37 */
							long BgL_res1775z00_1774;

							BgL_res1775z00_1774 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_variablez00_4));
							BgL_objzd2classzd2numz00_1771 = BgL_res1775z00_1774;
						}
						{	/* Ast/shrinkify.scm 37 */
							obj_t BgL_arg1741z00_1772;

							BgL_arg1741z00_1772 =
								PROCEDURE_REF
								(BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00,
								(int) (((long) 1)));
							{	/* Ast/shrinkify.scm 37 */
								int BgL_offsetz00_1776;

								BgL_offsetz00_1776 = (int) (BgL_objzd2classzd2numz00_1771);
								{	/* Ast/shrinkify.scm 37 */
									long BgL_offsetz00_1777;

									BgL_offsetz00_1777 =
										((long) (BgL_offsetz00_1776) - OBJECT_TYPE);
									{	/* Ast/shrinkify.scm 37 */
										long BgL_modz00_1778;

										BgL_modz00_1778 =
											(BgL_offsetz00_1777 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Ast/shrinkify.scm 37 */
											long BgL_restz00_1780;

											BgL_restz00_1780 =
												(BgL_offsetz00_1777 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Ast/shrinkify.scm 37 */

												{	/* Ast/shrinkify.scm 37 */
													obj_t BgL_bucketz00_1782;

													BgL_bucketz00_1782 =
														VECTOR_REF(
														((obj_t) BgL_arg1741z00_1772), BgL_modz00_1778);
													BgL_res1785z00_1806 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_1782), BgL_restz00_1780);
					}}}}}}}}
					BgL_method1245z00_1367 = BgL_res1785z00_1806;
				}
				return
					PROCEDURE_ENTRY(BgL_method1245z00_1367) (BgL_method1245z00_1367,
					((obj_t) BgL_variablez00_4), BEOA);
			}
		}

	}



/* &shrink-variable! */
	obj_t BGl_z62shrinkzd2variablez12za2zzast_shrinkifyz00(obj_t BgL_envz00_2027,
		obj_t BgL_variablez00_2028)
	{
		{	/* Ast/shrinkify.scm 37 */
			return
				BGl_shrinkzd2variablez12zc0zzast_shrinkifyz00(
				((BgL_variablez00_bglt) BgL_variablez00_2028));
		}

	}



/* shrink-node! */
	obj_t BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(BgL_nodez00_bglt
		BgL_nodez00_5)
	{
		{	/* Ast/shrinkify.scm 46 */
			{	/* Ast/shrinkify.scm 46 */
				obj_t BgL_method1247z00_1368;

				{	/* Ast/shrinkify.scm 46 */
					obj_t BgL_res1796z00_1843;

					{	/* Ast/shrinkify.scm 46 */
						long BgL_objzd2classzd2numz00_1808;

						{	/* Ast/shrinkify.scm 46 */
							long BgL_res1786z00_1811;

							BgL_res1786z00_1811 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nodez00_5));
							BgL_objzd2classzd2numz00_1808 = BgL_res1786z00_1811;
						}
						{	/* Ast/shrinkify.scm 46 */
							obj_t BgL_arg1741z00_1809;

							BgL_arg1741z00_1809 =
								PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
								(int) (((long) 1)));
							{	/* Ast/shrinkify.scm 46 */
								int BgL_offsetz00_1813;

								BgL_offsetz00_1813 = (int) (BgL_objzd2classzd2numz00_1808);
								{	/* Ast/shrinkify.scm 46 */
									long BgL_offsetz00_1814;

									BgL_offsetz00_1814 =
										((long) (BgL_offsetz00_1813) - OBJECT_TYPE);
									{	/* Ast/shrinkify.scm 46 */
										long BgL_modz00_1815;

										BgL_modz00_1815 =
											(BgL_offsetz00_1814 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Ast/shrinkify.scm 46 */
											long BgL_restz00_1817;

											BgL_restz00_1817 =
												(BgL_offsetz00_1814 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Ast/shrinkify.scm 46 */

												{	/* Ast/shrinkify.scm 46 */
													obj_t BgL_bucketz00_1819;

													BgL_bucketz00_1819 =
														VECTOR_REF(
														((obj_t) BgL_arg1741z00_1809), BgL_modz00_1815);
													BgL_res1796z00_1843 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_1819), BgL_restz00_1817);
					}}}}}}}}
					BgL_method1247z00_1368 = BgL_res1796z00_1843;
				}
				{	/* Ast/shrinkify.scm 46 */
					obj_t BgL_xz00_2100;

					BgL_xz00_2100 =
						PROCEDURE_ENTRY(BgL_method1247z00_1368) (BgL_method1247z00_1368,
						((obj_t) BgL_nodez00_5), BEOA);
					return BUNSPEC;
				}
			}
		}

	}



/* &shrink-node! */
	obj_t BGl_z62shrinkzd2nodez12za2zzast_shrinkifyz00(obj_t BgL_envz00_2035,
		obj_t BgL_nodez00_2036)
	{
		{	/* Ast/shrinkify.scm 46 */
			return
				BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
				((BgL_nodez00_bglt) BgL_nodez00_2036));
		}

	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzast_shrinkifyz00()
	{
		{	/* Ast/shrinkify.scm 15 */
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_atomz00zzast_nodez00, BGl_proc1834z00zzast_shrinkifyz00,
				BGl_string1835z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_varz00zzast_nodez00, BGl_proc1836z00zzast_shrinkifyz00,
				BGl_string1835z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_kwotez00zzast_nodez00, BGl_proc1837z00zzast_shrinkifyz00,
				BGl_string1835z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_sequencez00zzast_nodez00, BGl_proc1838z00zzast_shrinkifyz00,
				BGl_string1835z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_syncz00zzast_nodez00, BGl_proc1839z00zzast_shrinkifyz00,
				BGl_string1835z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_appz00zzast_nodez00, BGl_proc1840z00zzast_shrinkifyz00,
				BGl_string1835z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_appzd2lyzd2zzast_nodez00, BGl_proc1841z00zzast_shrinkifyz00,
				BGl_string1835z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_funcallz00zzast_nodez00, BGl_proc1842z00zzast_shrinkifyz00,
				BGl_string1835z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_externz00zzast_nodez00, BGl_proc1843z00zzast_shrinkifyz00,
				BGl_string1835z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_castz00zzast_nodez00, BGl_proc1844z00zzast_shrinkifyz00,
				BGl_string1835z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_setqz00zzast_nodez00, BGl_proc1845z00zzast_shrinkifyz00,
				BGl_string1835z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_conditionalz00zzast_nodez00, BGl_proc1846z00zzast_shrinkifyz00,
				BGl_string1835z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_failz00zzast_nodez00, BGl_proc1847z00zzast_shrinkifyz00,
				BGl_string1835z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_switchz00zzast_nodez00, BGl_proc1848z00zzast_shrinkifyz00,
				BGl_string1835z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_makezd2boxzd2zzast_nodez00, BGl_proc1849z00zzast_shrinkifyz00,
				BGl_string1835z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_boxzd2refzd2zzast_nodez00, BGl_proc1850z00zzast_shrinkifyz00,
				BGl_string1835z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_boxzd2setz12zc0zzast_nodez00, BGl_proc1851z00zzast_shrinkifyz00,
				BGl_string1835z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_letzd2funzd2zzast_nodez00, BGl_proc1852z00zzast_shrinkifyz00,
				BGl_string1835z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc1853z00zzast_shrinkifyz00,
				BGl_string1835z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_setzd2exzd2itz00zzast_nodez00, BGl_proc1854z00zzast_shrinkifyz00,
				BGl_string1835z00zzast_shrinkifyz00);
			return
				BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_jumpzd2exzd2itz00zzast_nodez00, BGl_proc1855z00zzast_shrinkifyz00,
				BGl_string1835z00zzast_shrinkifyz00);
		}

	}



/* &shrink-node!-jump-ex1289 */
	obj_t BGl_z62shrinkzd2nodez12zd2jumpzd2ex1289za2zzast_shrinkifyz00(obj_t
		BgL_envz00_2058, obj_t BgL_nodez00_2059)
	{
		{	/* Ast/shrinkify.scm 222 */
			BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
				(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
							((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_2059)))->BgL_exitz00));
			BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
				(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
							((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_2059)))->BgL_valuez00));
			return BUNSPEC;
		}

	}



/* &shrink-node!-set-ex-1287 */
	obj_t BGl_z62shrinkzd2nodez12zd2setzd2exzd21287z70zzast_shrinkifyz00(obj_t
		BgL_envz00_2060, obj_t BgL_nodez00_2061)
	{
		{	/* Ast/shrinkify.scm 213 */
			{	/* Ast/shrinkify.scm 215 */
				BgL_varz00_bglt BgL_arg1636z00_2136;

				BgL_arg1636z00_2136 =
					(((BgL_setzd2exzd2itz00_bglt) COBJECT(
							((BgL_setzd2exzd2itz00_bglt) BgL_nodez00_2061)))->BgL_varz00);
				BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
					((BgL_nodez00_bglt) BgL_arg1636z00_2136));
			}
			BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
				(((BgL_setzd2exzd2itz00_bglt) COBJECT(
							((BgL_setzd2exzd2itz00_bglt) BgL_nodez00_2061)))->BgL_bodyz00));
			return BUNSPEC;
		}

	}



/* &shrink-node!-let-var1285 */
	obj_t BGl_z62shrinkzd2nodez12zd2letzd2var1285za2zzast_shrinkifyz00(obj_t
		BgL_envz00_2062, obj_t BgL_nodez00_2063)
	{
		{	/* Ast/shrinkify.scm 201 */
			BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
				(((BgL_letzd2varzd2_bglt) COBJECT(
							((BgL_letzd2varzd2_bglt) BgL_nodez00_2063)))->BgL_bodyz00));
			{	/* Ast/shrinkify.scm 204 */
				obj_t BgL_g1241z00_2138;

				BgL_g1241z00_2138 =
					(((BgL_letzd2varzd2_bglt) COBJECT(
							((BgL_letzd2varzd2_bglt) BgL_nodez00_2063)))->BgL_bindingsz00);
				{
					obj_t BgL_l1239z00_2140;

					BgL_l1239z00_2140 = BgL_g1241z00_2138;
				BgL_zc3z04anonymousza31628ze3z87_2139:
					if (PAIRP(BgL_l1239z00_2140))
						{	/* Ast/shrinkify.scm 204 */
							{	/* Ast/shrinkify.scm 205 */
								obj_t BgL_bindingz00_2141;

								BgL_bindingz00_2141 = CAR(BgL_l1239z00_2140);
								{	/* Ast/shrinkify.scm 205 */
									obj_t BgL_arg1631z00_2142;

									BgL_arg1631z00_2142 = CAR(((obj_t) BgL_bindingz00_2141));
									BGl_shrinkzd2variablez12zc0zzast_shrinkifyz00(
										((BgL_variablez00_bglt) BgL_arg1631z00_2142));
								}
								{	/* Ast/shrinkify.scm 206 */
									obj_t BgL_arg1632z00_2143;

									BgL_arg1632z00_2143 = CDR(((obj_t) BgL_bindingz00_2141));
									BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
										((BgL_nodez00_bglt) BgL_arg1632z00_2143));
								}
							}
							{
								obj_t BgL_l1239z00_2477;

								BgL_l1239z00_2477 = CDR(BgL_l1239z00_2140);
								BgL_l1239z00_2140 = BgL_l1239z00_2477;
								goto BgL_zc3z04anonymousza31628ze3z87_2139;
							}
						}
					else
						{	/* Ast/shrinkify.scm 204 */
							((bool_t) 1);
						}
				}
			}
			return BUNSPEC;
		}

	}



/* &shrink-node!-let-fun1283 */
	obj_t BGl_z62shrinkzd2nodez12zd2letzd2fun1283za2zzast_shrinkifyz00(obj_t
		BgL_envz00_2064, obj_t BgL_nodez00_2065)
	{
		{	/* Ast/shrinkify.scm 187 */
			BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
				(((BgL_letzd2funzd2_bglt) COBJECT(
							((BgL_letzd2funzd2_bglt) BgL_nodez00_2065)))->BgL_bodyz00));
			{	/* Ast/shrinkify.scm 190 */
				obj_t BgL_g1238z00_2145;

				BgL_g1238z00_2145 =
					(((BgL_letzd2funzd2_bglt) COBJECT(
							((BgL_letzd2funzd2_bglt) BgL_nodez00_2065)))->BgL_localsz00);
				{
					obj_t BgL_l1236z00_2147;

					BgL_l1236z00_2147 = BgL_g1238z00_2145;
				BgL_zc3z04anonymousza31599ze3z87_2146:
					if (PAIRP(BgL_l1236z00_2147))
						{	/* Ast/shrinkify.scm 190 */
							{	/* Ast/shrinkify.scm 191 */
								obj_t BgL_localz00_2148;

								BgL_localz00_2148 = CAR(BgL_l1236z00_2147);
								{	/* Ast/shrinkify.scm 191 */
									BgL_valuez00_bglt BgL_sfunz00_2149;

									BgL_sfunz00_2149 =
										(((BgL_variablez00_bglt) COBJECT(
												((BgL_variablez00_bglt)
													((BgL_localz00_bglt) BgL_localz00_2148))))->
										BgL_valuez00);
									BGl_shrinkzd2variablez12zc0zzast_shrinkifyz00((
											(BgL_variablez00_bglt) BgL_localz00_2148));
									{	/* Ast/shrinkify.scm 193 */
										obj_t BgL_g1235z00_2150;

										BgL_g1235z00_2150 =
											(((BgL_sfunz00_bglt) COBJECT(
													((BgL_sfunz00_bglt) BgL_sfunz00_2149)))->BgL_argsz00);
										{
											obj_t BgL_l1233z00_2152;

											BgL_l1233z00_2152 = BgL_g1235z00_2150;
										BgL_zc3z04anonymousza31601ze3z87_2151:
											if (PAIRP(BgL_l1233z00_2152))
												{	/* Ast/shrinkify.scm 193 */
													{	/* Ast/shrinkify.scm 193 */
														obj_t BgL_arg1609z00_2153;

														BgL_arg1609z00_2153 = CAR(BgL_l1233z00_2152);
														BGl_shrinkzd2variablez12zc0zzast_shrinkifyz00(
															((BgL_variablez00_bglt) BgL_arg1609z00_2153));
													}
													{
														obj_t BgL_l1233z00_2499;

														BgL_l1233z00_2499 = CDR(BgL_l1233z00_2152);
														BgL_l1233z00_2152 = BgL_l1233z00_2499;
														goto BgL_zc3z04anonymousza31601ze3z87_2151;
													}
												}
											else
												{	/* Ast/shrinkify.scm 193 */
													((bool_t) 1);
												}
										}
									}
									{	/* Ast/shrinkify.scm 194 */
										obj_t BgL_arg1618z00_2154;

										BgL_arg1618z00_2154 =
											(((BgL_sfunz00_bglt) COBJECT(
													((BgL_sfunz00_bglt) BgL_sfunz00_2149)))->BgL_bodyz00);
										BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
											((BgL_nodez00_bglt) BgL_arg1618z00_2154));
									}
								}
							}
							{
								obj_t BgL_l1236z00_2505;

								BgL_l1236z00_2505 = CDR(BgL_l1236z00_2147);
								BgL_l1236z00_2147 = BgL_l1236z00_2505;
								goto BgL_zc3z04anonymousza31599ze3z87_2146;
							}
						}
					else
						{	/* Ast/shrinkify.scm 190 */
							((bool_t) 1);
						}
				}
			}
			return BUNSPEC;
		}

	}



/* &shrink-node!-box-set1281 */
	obj_t BGl_z62shrinkzd2nodez12zd2boxzd2set1281za2zzast_shrinkifyz00(obj_t
		BgL_envz00_2066, obj_t BgL_nodez00_2067)
	{
		{	/* Ast/shrinkify.scm 178 */
			{	/* Ast/shrinkify.scm 179 */
				bool_t BgL_test1903z00_2507;

				{	/* Ast/shrinkify.scm 179 */
					bool_t BgL_res1822z00_2156;

					{	/* Ast/shrinkify.scm 179 */
						obj_t BgL_tmpz00_2508;

						{	/* Ast/shrinkify.scm 179 */
							BgL_objectz00_bglt BgL_tmpz00_2509;

							BgL_tmpz00_2509 =
								((BgL_objectz00_bglt)
								((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_2067));
							BgL_tmpz00_2508 = BGL_OBJECT_WIDENING(BgL_tmpz00_2509);
						}
						BgL_res1822z00_2156 = CBOOL(BgL_tmpz00_2508);
					}
					BgL_test1903z00_2507 = BgL_res1822z00_2156;
				}
				if (BgL_test1903z00_2507)
					{	/* Ast/shrinkify.scm 179 */
						{	/* Ast/shrinkify.scm 179 */
							long BgL_arg1578z00_2157;

							{	/* Ast/shrinkify.scm 179 */
								obj_t BgL_arg1579z00_2158;

								{	/* Ast/shrinkify.scm 179 */
									obj_t BgL_arg1585z00_2159;

									{	/* Ast/shrinkify.scm 179 */
										long BgL_arg1744z00_2160;

										{	/* Ast/shrinkify.scm 179 */
											long BgL_arg1745z00_2161;

											{	/* Ast/shrinkify.scm 179 */
												long BgL_res1823z00_2162;

												BgL_res1823z00_2162 =
													BGL_OBJECT_CLASS_NUM(
													((BgL_objectz00_bglt)
														((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_2067)));
												BgL_arg1745z00_2161 = BgL_res1823z00_2162;
											}
											BgL_arg1744z00_2160 = (BgL_arg1745z00_2161 - OBJECT_TYPE);
										}
										BgL_arg1585z00_2159 =
											VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
											BgL_arg1744z00_2160);
									}
									BgL_arg1579z00_2158 =
										BGl_classzd2superzd2zz__objectz00(BgL_arg1585z00_2159);
								}
								{	/* Ast/shrinkify.scm 179 */
									long BgL_res1825z00_2163;

									{	/* Ast/shrinkify.scm 179 */
										obj_t BgL_tmpz00_2520;

										BgL_tmpz00_2520 = ((obj_t) BgL_arg1579z00_2158);
										BgL_res1825z00_2163 = BGL_CLASS_INDEX(BgL_tmpz00_2520);
									}
									BgL_arg1578z00_2157 = BgL_res1825z00_2163;
							}}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt)
									((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_2067)),
								BgL_arg1578z00_2157);
						}
						{	/* Ast/shrinkify.scm 179 */
							BgL_objectz00_bglt BgL_tmpz00_2526;

							BgL_tmpz00_2526 =
								((BgL_objectz00_bglt)
								((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_2067));
							BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2526, BFALSE);
						}
						((BgL_objectz00_bglt)
							((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_2067));
						((obj_t) ((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_2067));
					}
				else
					{	/* Ast/shrinkify.scm 179 */
						BFALSE;
					}
			}
			{	/* Ast/shrinkify.scm 180 */
				BgL_varz00_bglt BgL_arg1590z00_2164;

				BgL_arg1590z00_2164 =
					(((BgL_boxzd2setz12zc0_bglt) COBJECT(
							((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_2067)))->BgL_varz00);
				BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
					((BgL_nodez00_bglt) BgL_arg1590z00_2164));
			}
			BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
				(((BgL_boxzd2setz12zc0_bglt) COBJECT(
							((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_2067)))->BgL_valuez00));
			return BUNSPEC;
		}

	}



/* &shrink-node!-box-ref1279 */
	obj_t BGl_z62shrinkzd2nodez12zd2boxzd2ref1279za2zzast_shrinkifyz00(obj_t
		BgL_envz00_2068, obj_t BgL_nodez00_2069)
	{
		{	/* Ast/shrinkify.scm 170 */
			{	/* Ast/shrinkify.scm 171 */
				bool_t BgL_test1904z00_2541;

				{	/* Ast/shrinkify.scm 171 */
					bool_t BgL_res1818z00_2166;

					{	/* Ast/shrinkify.scm 171 */
						obj_t BgL_tmpz00_2542;

						{	/* Ast/shrinkify.scm 171 */
							BgL_objectz00_bglt BgL_tmpz00_2543;

							BgL_tmpz00_2543 =
								((BgL_objectz00_bglt)
								((BgL_boxzd2refzd2_bglt) BgL_nodez00_2069));
							BgL_tmpz00_2542 = BGL_OBJECT_WIDENING(BgL_tmpz00_2543);
						}
						BgL_res1818z00_2166 = CBOOL(BgL_tmpz00_2542);
					}
					BgL_test1904z00_2541 = BgL_res1818z00_2166;
				}
				if (BgL_test1904z00_2541)
					{	/* Ast/shrinkify.scm 171 */
						{	/* Ast/shrinkify.scm 171 */
							long BgL_arg1563z00_2167;

							{	/* Ast/shrinkify.scm 171 */
								obj_t BgL_arg1564z00_2168;

								{	/* Ast/shrinkify.scm 171 */
									obj_t BgL_arg1568z00_2169;

									{	/* Ast/shrinkify.scm 171 */
										long BgL_arg1744z00_2170;

										{	/* Ast/shrinkify.scm 171 */
											long BgL_arg1745z00_2171;

											{	/* Ast/shrinkify.scm 171 */
												long BgL_res1819z00_2172;

												BgL_res1819z00_2172 =
													BGL_OBJECT_CLASS_NUM(
													((BgL_objectz00_bglt)
														((BgL_boxzd2refzd2_bglt) BgL_nodez00_2069)));
												BgL_arg1745z00_2171 = BgL_res1819z00_2172;
											}
											BgL_arg1744z00_2170 = (BgL_arg1745z00_2171 - OBJECT_TYPE);
										}
										BgL_arg1568z00_2169 =
											VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
											BgL_arg1744z00_2170);
									}
									BgL_arg1564z00_2168 =
										BGl_classzd2superzd2zz__objectz00(BgL_arg1568z00_2169);
								}
								{	/* Ast/shrinkify.scm 171 */
									long BgL_res1821z00_2173;

									{	/* Ast/shrinkify.scm 171 */
										obj_t BgL_tmpz00_2554;

										BgL_tmpz00_2554 = ((obj_t) BgL_arg1564z00_2168);
										BgL_res1821z00_2173 = BGL_CLASS_INDEX(BgL_tmpz00_2554);
									}
									BgL_arg1563z00_2167 = BgL_res1821z00_2173;
							}}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt)
									((BgL_boxzd2refzd2_bglt) BgL_nodez00_2069)),
								BgL_arg1563z00_2167);
						}
						{	/* Ast/shrinkify.scm 171 */
							BgL_objectz00_bglt BgL_tmpz00_2560;

							BgL_tmpz00_2560 =
								((BgL_objectz00_bglt)
								((BgL_boxzd2refzd2_bglt) BgL_nodez00_2069));
							BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2560, BFALSE);
						}
						((BgL_objectz00_bglt) ((BgL_boxzd2refzd2_bglt) BgL_nodez00_2069));
						((obj_t) ((BgL_boxzd2refzd2_bglt) BgL_nodez00_2069));
					}
				else
					{	/* Ast/shrinkify.scm 171 */
						BFALSE;
					}
			}
			{	/* Ast/shrinkify.scm 172 */
				BgL_varz00_bglt BgL_arg1573z00_2174;

				BgL_arg1573z00_2174 =
					(((BgL_boxzd2refzd2_bglt) COBJECT(
							((BgL_boxzd2refzd2_bglt) BgL_nodez00_2069)))->BgL_varz00);
				BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
					((BgL_nodez00_bglt) BgL_arg1573z00_2174));
			}
			return BUNSPEC;
		}

	}



/* &shrink-node!-make-bo1277 */
	obj_t BGl_z62shrinkzd2nodez12zd2makezd2bo1277za2zzast_shrinkifyz00(obj_t
		BgL_envz00_2070, obj_t BgL_nodez00_2071)
	{
		{	/* Ast/shrinkify.scm 162 */
			{	/* Ast/shrinkify.scm 163 */
				bool_t BgL_test1905z00_2572;

				{	/* Ast/shrinkify.scm 163 */
					bool_t BgL_res1814z00_2176;

					{	/* Ast/shrinkify.scm 163 */
						obj_t BgL_tmpz00_2573;

						{	/* Ast/shrinkify.scm 163 */
							BgL_objectz00_bglt BgL_tmpz00_2574;

							BgL_tmpz00_2574 =
								((BgL_objectz00_bglt)
								((BgL_makezd2boxzd2_bglt) BgL_nodez00_2071));
							BgL_tmpz00_2573 = BGL_OBJECT_WIDENING(BgL_tmpz00_2574);
						}
						BgL_res1814z00_2176 = CBOOL(BgL_tmpz00_2573);
					}
					BgL_test1905z00_2572 = BgL_res1814z00_2176;
				}
				if (BgL_test1905z00_2572)
					{	/* Ast/shrinkify.scm 163 */
						{	/* Ast/shrinkify.scm 163 */
							long BgL_arg1544z00_2177;

							{	/* Ast/shrinkify.scm 163 */
								obj_t BgL_arg1550z00_2178;

								{	/* Ast/shrinkify.scm 163 */
									obj_t BgL_arg1554z00_2179;

									{	/* Ast/shrinkify.scm 163 */
										long BgL_arg1744z00_2180;

										{	/* Ast/shrinkify.scm 163 */
											long BgL_arg1745z00_2181;

											{	/* Ast/shrinkify.scm 163 */
												long BgL_res1815z00_2182;

												BgL_res1815z00_2182 =
													BGL_OBJECT_CLASS_NUM(
													((BgL_objectz00_bglt)
														((BgL_makezd2boxzd2_bglt) BgL_nodez00_2071)));
												BgL_arg1745z00_2181 = BgL_res1815z00_2182;
											}
											BgL_arg1744z00_2180 = (BgL_arg1745z00_2181 - OBJECT_TYPE);
										}
										BgL_arg1554z00_2179 =
											VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
											BgL_arg1744z00_2180);
									}
									BgL_arg1550z00_2178 =
										BGl_classzd2superzd2zz__objectz00(BgL_arg1554z00_2179);
								}
								{	/* Ast/shrinkify.scm 163 */
									long BgL_res1817z00_2183;

									{	/* Ast/shrinkify.scm 163 */
										obj_t BgL_tmpz00_2585;

										BgL_tmpz00_2585 = ((obj_t) BgL_arg1550z00_2178);
										BgL_res1817z00_2183 = BGL_CLASS_INDEX(BgL_tmpz00_2585);
									}
									BgL_arg1544z00_2177 = BgL_res1817z00_2183;
							}}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt)
									((BgL_makezd2boxzd2_bglt) BgL_nodez00_2071)),
								BgL_arg1544z00_2177);
						}
						{	/* Ast/shrinkify.scm 163 */
							BgL_objectz00_bglt BgL_tmpz00_2591;

							BgL_tmpz00_2591 =
								((BgL_objectz00_bglt)
								((BgL_makezd2boxzd2_bglt) BgL_nodez00_2071));
							BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2591, BFALSE);
						}
						((BgL_objectz00_bglt) ((BgL_makezd2boxzd2_bglt) BgL_nodez00_2071));
						((obj_t) ((BgL_makezd2boxzd2_bglt) BgL_nodez00_2071));
					}
				else
					{	/* Ast/shrinkify.scm 163 */
						BFALSE;
					}
			}
			BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
				(((BgL_makezd2boxzd2_bglt) COBJECT(
							((BgL_makezd2boxzd2_bglt) BgL_nodez00_2071)))->BgL_valuez00));
			return BUNSPEC;
		}

	}



/* &shrink-node!-switch1275 */
	obj_t BGl_z62shrinkzd2nodez12zd2switch1275z70zzast_shrinkifyz00(obj_t
		BgL_envz00_2072, obj_t BgL_nodez00_2073)
	{
		{	/* Ast/shrinkify.scm 152 */
			BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
				(((BgL_switchz00_bglt) COBJECT(
							((BgL_switchz00_bglt) BgL_nodez00_2073)))->BgL_testz00));
			{	/* Ast/shrinkify.scm 154 */
				obj_t BgL_g1232z00_2185;

				BgL_g1232z00_2185 =
					(((BgL_switchz00_bglt) COBJECT(
							((BgL_switchz00_bglt) BgL_nodez00_2073)))->BgL_clausesz00);
				{
					obj_t BgL_l1230z00_2187;

					BgL_l1230z00_2187 = BgL_g1232z00_2185;
				BgL_zc3z04anonymousza31531ze3z87_2186:
					if (PAIRP(BgL_l1230z00_2187))
						{	/* Ast/shrinkify.scm 156 */
							{	/* Ast/shrinkify.scm 155 */
								obj_t BgL_clausez00_2188;

								BgL_clausez00_2188 = CAR(BgL_l1230z00_2187);
								{	/* Ast/shrinkify.scm 155 */
									obj_t BgL_arg1536z00_2189;

									BgL_arg1536z00_2189 = CDR(((obj_t) BgL_clausez00_2188));
									BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
										((BgL_nodez00_bglt) BgL_arg1536z00_2189));
								}
							}
							{
								obj_t BgL_l1230z00_2614;

								BgL_l1230z00_2614 = CDR(BgL_l1230z00_2187);
								BgL_l1230z00_2187 = BgL_l1230z00_2614;
								goto BgL_zc3z04anonymousza31531ze3z87_2186;
							}
						}
					else
						{	/* Ast/shrinkify.scm 156 */
							((bool_t) 1);
						}
				}
			}
			return BUNSPEC;
		}

	}



/* &shrink-node!-fail1273 */
	obj_t BGl_z62shrinkzd2nodez12zd2fail1273z70zzast_shrinkifyz00(obj_t
		BgL_envz00_2074, obj_t BgL_nodez00_2075)
	{
		{	/* Ast/shrinkify.scm 143 */
			BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
				(((BgL_failz00_bglt) COBJECT(
							((BgL_failz00_bglt) BgL_nodez00_2075)))->BgL_procz00));
			BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
				(((BgL_failz00_bglt) COBJECT(
							((BgL_failz00_bglt) BgL_nodez00_2075)))->BgL_msgz00));
			BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
				(((BgL_failz00_bglt) COBJECT(
							((BgL_failz00_bglt) BgL_nodez00_2075)))->BgL_objz00));
			return BUNSPEC;
		}

	}



/* &shrink-node!-conditi1271 */
	obj_t BGl_z62shrinkzd2nodez12zd2conditi1271z70zzast_shrinkifyz00(obj_t
		BgL_envz00_2076, obj_t BgL_nodez00_2077)
	{
		{	/* Ast/shrinkify.scm 134 */
			BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
				(((BgL_conditionalz00_bglt) COBJECT(
							((BgL_conditionalz00_bglt) BgL_nodez00_2077)))->BgL_testz00));
			BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
				(((BgL_conditionalz00_bglt) COBJECT(
							((BgL_conditionalz00_bglt) BgL_nodez00_2077)))->BgL_truez00));
			BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
				(((BgL_conditionalz00_bglt) COBJECT(
							((BgL_conditionalz00_bglt) BgL_nodez00_2077)))->BgL_falsez00));
			return BUNSPEC;
		}

	}



/* &shrink-node!-setq1269 */
	obj_t BGl_z62shrinkzd2nodez12zd2setq1269z70zzast_shrinkifyz00(obj_t
		BgL_envz00_2078, obj_t BgL_nodez00_2079)
	{
		{	/* Ast/shrinkify.scm 127 */
			BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
				(((BgL_setqz00_bglt) COBJECT(
							((BgL_setqz00_bglt) BgL_nodez00_2079)))->BgL_valuez00));
			return BUNSPEC;
		}

	}



/* &shrink-node!-cast1267 */
	obj_t BGl_z62shrinkzd2nodez12zd2cast1267z70zzast_shrinkifyz00(obj_t
		BgL_envz00_2080, obj_t BgL_nodez00_2081)
	{
		{	/* Ast/shrinkify.scm 120 */
			BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
				(((BgL_castz00_bglt) COBJECT(
							((BgL_castz00_bglt) BgL_nodez00_2081)))->BgL_argz00));
			return BUNSPEC;
		}

	}



/* &shrink-node!-extern1265 */
	obj_t BGl_z62shrinkzd2nodez12zd2extern1265z70zzast_shrinkifyz00(obj_t
		BgL_envz00_2082, obj_t BgL_nodez00_2083)
	{
		{	/* Ast/shrinkify.scm 112 */
			{	/* Ast/shrinkify.scm 113 */
				bool_t BgL_test1907z00_2640;

				{	/* Ast/shrinkify.scm 113 */
					bool_t BgL_res1809z00_2195;

					{	/* Ast/shrinkify.scm 113 */
						obj_t BgL_tmpz00_2641;

						{	/* Ast/shrinkify.scm 113 */
							BgL_objectz00_bglt BgL_tmpz00_2642;

							BgL_tmpz00_2642 =
								((BgL_objectz00_bglt) ((BgL_externz00_bglt) BgL_nodez00_2083));
							BgL_tmpz00_2641 = BGL_OBJECT_WIDENING(BgL_tmpz00_2642);
						}
						BgL_res1809z00_2195 = CBOOL(BgL_tmpz00_2641);
					}
					BgL_test1907z00_2640 = BgL_res1809z00_2195;
				}
				if (BgL_test1907z00_2640)
					{	/* Ast/shrinkify.scm 113 */
						{	/* Ast/shrinkify.scm 113 */
							long BgL_arg1493z00_2196;

							{	/* Ast/shrinkify.scm 113 */
								obj_t BgL_arg1495z00_2197;

								{	/* Ast/shrinkify.scm 113 */
									obj_t BgL_arg1499z00_2198;

									{	/* Ast/shrinkify.scm 113 */
										long BgL_arg1744z00_2199;

										{	/* Ast/shrinkify.scm 113 */
											long BgL_arg1745z00_2200;

											{	/* Ast/shrinkify.scm 113 */
												long BgL_res1810z00_2201;

												BgL_res1810z00_2201 =
													BGL_OBJECT_CLASS_NUM(
													((BgL_objectz00_bglt)
														((BgL_externz00_bglt) BgL_nodez00_2083)));
												BgL_arg1745z00_2200 = BgL_res1810z00_2201;
											}
											BgL_arg1744z00_2199 = (BgL_arg1745z00_2200 - OBJECT_TYPE);
										}
										BgL_arg1499z00_2198 =
											VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
											BgL_arg1744z00_2199);
									}
									BgL_arg1495z00_2197 =
										BGl_classzd2superzd2zz__objectz00(BgL_arg1499z00_2198);
								}
								{	/* Ast/shrinkify.scm 113 */
									long BgL_res1812z00_2202;

									{	/* Ast/shrinkify.scm 113 */
										obj_t BgL_tmpz00_2653;

										BgL_tmpz00_2653 = ((obj_t) BgL_arg1495z00_2197);
										BgL_res1812z00_2202 = BGL_CLASS_INDEX(BgL_tmpz00_2653);
									}
									BgL_arg1493z00_2196 = BgL_res1812z00_2202;
							}}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt)
									((BgL_externz00_bglt) BgL_nodez00_2083)),
								BgL_arg1493z00_2196);
						}
						{	/* Ast/shrinkify.scm 113 */
							BgL_objectz00_bglt BgL_tmpz00_2659;

							BgL_tmpz00_2659 =
								((BgL_objectz00_bglt) ((BgL_externz00_bglt) BgL_nodez00_2083));
							BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2659, BFALSE);
						}
						((BgL_objectz00_bglt) ((BgL_externz00_bglt) BgL_nodez00_2083));
						((obj_t) ((BgL_externz00_bglt) BgL_nodez00_2083));
					}
				else
					{	/* Ast/shrinkify.scm 113 */
						BFALSE;
					}
			}
			BGl_shrinkzd2nodeza2z12z62zzast_shrinkifyz00(
				(((BgL_externz00_bglt) COBJECT(
							((BgL_externz00_bglt) BgL_nodez00_2083)))->BgL_exprza2za2));
			return BUNSPEC;
		}

	}



/* &shrink-node!-funcall1263 */
	obj_t BGl_z62shrinkzd2nodez12zd2funcall1263z70zzast_shrinkifyz00(obj_t
		BgL_envz00_2084, obj_t BgL_nodez00_2085)
	{
		{	/* Ast/shrinkify.scm 103 */
			{	/* Ast/shrinkify.scm 104 */
				bool_t BgL_test1908z00_2670;

				{	/* Ast/shrinkify.scm 104 */
					bool_t BgL_res1805z00_2204;

					{	/* Ast/shrinkify.scm 104 */
						obj_t BgL_tmpz00_2671;

						{	/* Ast/shrinkify.scm 104 */
							BgL_objectz00_bglt BgL_tmpz00_2672;

							BgL_tmpz00_2672 =
								((BgL_objectz00_bglt) ((BgL_funcallz00_bglt) BgL_nodez00_2085));
							BgL_tmpz00_2671 = BGL_OBJECT_WIDENING(BgL_tmpz00_2672);
						}
						BgL_res1805z00_2204 = CBOOL(BgL_tmpz00_2671);
					}
					BgL_test1908z00_2670 = BgL_res1805z00_2204;
				}
				if (BgL_test1908z00_2670)
					{	/* Ast/shrinkify.scm 104 */
						{	/* Ast/shrinkify.scm 104 */
							long BgL_arg1467z00_2205;

							{	/* Ast/shrinkify.scm 104 */
								obj_t BgL_arg1470z00_2206;

								{	/* Ast/shrinkify.scm 104 */
									obj_t BgL_arg1486z00_2207;

									{	/* Ast/shrinkify.scm 104 */
										long BgL_arg1744z00_2208;

										{	/* Ast/shrinkify.scm 104 */
											long BgL_arg1745z00_2209;

											{	/* Ast/shrinkify.scm 104 */
												long BgL_res1806z00_2210;

												BgL_res1806z00_2210 =
													BGL_OBJECT_CLASS_NUM(
													((BgL_objectz00_bglt)
														((BgL_funcallz00_bglt) BgL_nodez00_2085)));
												BgL_arg1745z00_2209 = BgL_res1806z00_2210;
											}
											BgL_arg1744z00_2208 = (BgL_arg1745z00_2209 - OBJECT_TYPE);
										}
										BgL_arg1486z00_2207 =
											VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
											BgL_arg1744z00_2208);
									}
									BgL_arg1470z00_2206 =
										BGl_classzd2superzd2zz__objectz00(BgL_arg1486z00_2207);
								}
								{	/* Ast/shrinkify.scm 104 */
									long BgL_res1808z00_2211;

									{	/* Ast/shrinkify.scm 104 */
										obj_t BgL_tmpz00_2683;

										BgL_tmpz00_2683 = ((obj_t) BgL_arg1470z00_2206);
										BgL_res1808z00_2211 = BGL_CLASS_INDEX(BgL_tmpz00_2683);
									}
									BgL_arg1467z00_2205 = BgL_res1808z00_2211;
							}}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt)
									((BgL_funcallz00_bglt) BgL_nodez00_2085)),
								BgL_arg1467z00_2205);
						}
						{	/* Ast/shrinkify.scm 104 */
							BgL_objectz00_bglt BgL_tmpz00_2689;

							BgL_tmpz00_2689 =
								((BgL_objectz00_bglt) ((BgL_funcallz00_bglt) BgL_nodez00_2085));
							BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2689, BFALSE);
						}
						((BgL_objectz00_bglt) ((BgL_funcallz00_bglt) BgL_nodez00_2085));
						((obj_t) ((BgL_funcallz00_bglt) BgL_nodez00_2085));
					}
				else
					{	/* Ast/shrinkify.scm 104 */
						BFALSE;
					}
			}
			BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
				(((BgL_funcallz00_bglt) COBJECT(
							((BgL_funcallz00_bglt) BgL_nodez00_2085)))->BgL_funz00));
			BGl_shrinkzd2nodeza2z12z62zzast_shrinkifyz00(
				(((BgL_funcallz00_bglt) COBJECT(
							((BgL_funcallz00_bglt) BgL_nodez00_2085)))->BgL_argsz00));
			return BUNSPEC;
		}

	}



/* &shrink-node!-app-ly1261 */
	obj_t BGl_z62shrinkzd2nodez12zd2appzd2ly1261za2zzast_shrinkifyz00(obj_t
		BgL_envz00_2086, obj_t BgL_nodez00_2087)
	{
		{	/* Ast/shrinkify.scm 94 */
			{	/* Ast/shrinkify.scm 95 */
				bool_t BgL_test1909z00_2703;

				{	/* Ast/shrinkify.scm 95 */
					bool_t BgL_res1801z00_2213;

					{	/* Ast/shrinkify.scm 95 */
						obj_t BgL_tmpz00_2704;

						{	/* Ast/shrinkify.scm 95 */
							BgL_objectz00_bglt BgL_tmpz00_2705;

							BgL_tmpz00_2705 =
								((BgL_objectz00_bglt)
								((BgL_appzd2lyzd2_bglt) BgL_nodez00_2087));
							BgL_tmpz00_2704 = BGL_OBJECT_WIDENING(BgL_tmpz00_2705);
						}
						BgL_res1801z00_2213 = CBOOL(BgL_tmpz00_2704);
					}
					BgL_test1909z00_2703 = BgL_res1801z00_2213;
				}
				if (BgL_test1909z00_2703)
					{	/* Ast/shrinkify.scm 95 */
						{	/* Ast/shrinkify.scm 95 */
							long BgL_arg1429z00_2214;

							{	/* Ast/shrinkify.scm 95 */
								obj_t BgL_arg1430z00_2215;

								{	/* Ast/shrinkify.scm 95 */
									obj_t BgL_arg1437z00_2216;

									{	/* Ast/shrinkify.scm 95 */
										long BgL_arg1744z00_2217;

										{	/* Ast/shrinkify.scm 95 */
											long BgL_arg1745z00_2218;

											{	/* Ast/shrinkify.scm 95 */
												long BgL_res1802z00_2219;

												BgL_res1802z00_2219 =
													BGL_OBJECT_CLASS_NUM(
													((BgL_objectz00_bglt)
														((BgL_appzd2lyzd2_bglt) BgL_nodez00_2087)));
												BgL_arg1745z00_2218 = BgL_res1802z00_2219;
											}
											BgL_arg1744z00_2217 = (BgL_arg1745z00_2218 - OBJECT_TYPE);
										}
										BgL_arg1437z00_2216 =
											VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
											BgL_arg1744z00_2217);
									}
									BgL_arg1430z00_2215 =
										BGl_classzd2superzd2zz__objectz00(BgL_arg1437z00_2216);
								}
								{	/* Ast/shrinkify.scm 95 */
									long BgL_res1804z00_2220;

									{	/* Ast/shrinkify.scm 95 */
										obj_t BgL_tmpz00_2716;

										BgL_tmpz00_2716 = ((obj_t) BgL_arg1430z00_2215);
										BgL_res1804z00_2220 = BGL_CLASS_INDEX(BgL_tmpz00_2716);
									}
									BgL_arg1429z00_2214 = BgL_res1804z00_2220;
							}}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt)
									((BgL_appzd2lyzd2_bglt) BgL_nodez00_2087)),
								BgL_arg1429z00_2214);
						}
						{	/* Ast/shrinkify.scm 95 */
							BgL_objectz00_bglt BgL_tmpz00_2722;

							BgL_tmpz00_2722 =
								((BgL_objectz00_bglt)
								((BgL_appzd2lyzd2_bglt) BgL_nodez00_2087));
							BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2722, BFALSE);
						}
						((BgL_objectz00_bglt) ((BgL_appzd2lyzd2_bglt) BgL_nodez00_2087));
						((obj_t) ((BgL_appzd2lyzd2_bglt) BgL_nodez00_2087));
					}
				else
					{	/* Ast/shrinkify.scm 95 */
						BFALSE;
					}
			}
			BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
				(((BgL_appzd2lyzd2_bglt) COBJECT(
							((BgL_appzd2lyzd2_bglt) BgL_nodez00_2087)))->BgL_funz00));
			BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
				(((BgL_appzd2lyzd2_bglt) COBJECT(
							((BgL_appzd2lyzd2_bglt) BgL_nodez00_2087)))->BgL_argz00));
			return BUNSPEC;
		}

	}



/* &shrink-node!-app1259 */
	obj_t BGl_z62shrinkzd2nodez12zd2app1259z70zzast_shrinkifyz00(obj_t
		BgL_envz00_2088, obj_t BgL_nodez00_2089)
	{
		{	/* Ast/shrinkify.scm 85 */
			{	/* Ast/shrinkify.scm 86 */
				bool_t BgL_test1910z00_2736;

				{	/* Ast/shrinkify.scm 86 */
					bool_t BgL_res1797z00_2222;

					{	/* Ast/shrinkify.scm 86 */
						obj_t BgL_tmpz00_2737;

						{	/* Ast/shrinkify.scm 86 */
							BgL_objectz00_bglt BgL_tmpz00_2738;

							BgL_tmpz00_2738 =
								((BgL_objectz00_bglt) ((BgL_appz00_bglt) BgL_nodez00_2089));
							BgL_tmpz00_2737 = BGL_OBJECT_WIDENING(BgL_tmpz00_2738);
						}
						BgL_res1797z00_2222 = CBOOL(BgL_tmpz00_2737);
					}
					BgL_test1910z00_2736 = BgL_res1797z00_2222;
				}
				if (BgL_test1910z00_2736)
					{	/* Ast/shrinkify.scm 86 */
						{	/* Ast/shrinkify.scm 86 */
							long BgL_arg1365z00_2223;

							{	/* Ast/shrinkify.scm 86 */
								obj_t BgL_arg1378z00_2224;

								{	/* Ast/shrinkify.scm 86 */
									obj_t BgL_arg1399z00_2225;

									{	/* Ast/shrinkify.scm 86 */
										long BgL_arg1744z00_2226;

										{	/* Ast/shrinkify.scm 86 */
											long BgL_arg1745z00_2227;

											{	/* Ast/shrinkify.scm 86 */
												long BgL_res1798z00_2228;

												BgL_res1798z00_2228 =
													BGL_OBJECT_CLASS_NUM(
													((BgL_objectz00_bglt)
														((BgL_appz00_bglt) BgL_nodez00_2089)));
												BgL_arg1745z00_2227 = BgL_res1798z00_2228;
											}
											BgL_arg1744z00_2226 = (BgL_arg1745z00_2227 - OBJECT_TYPE);
										}
										BgL_arg1399z00_2225 =
											VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
											BgL_arg1744z00_2226);
									}
									BgL_arg1378z00_2224 =
										BGl_classzd2superzd2zz__objectz00(BgL_arg1399z00_2225);
								}
								{	/* Ast/shrinkify.scm 86 */
									long BgL_res1800z00_2229;

									{	/* Ast/shrinkify.scm 86 */
										obj_t BgL_tmpz00_2749;

										BgL_tmpz00_2749 = ((obj_t) BgL_arg1378z00_2224);
										BgL_res1800z00_2229 = BGL_CLASS_INDEX(BgL_tmpz00_2749);
									}
									BgL_arg1365z00_2223 = BgL_res1800z00_2229;
							}}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt)
									((BgL_appz00_bglt) BgL_nodez00_2089)), BgL_arg1365z00_2223);
						}
						{	/* Ast/shrinkify.scm 86 */
							BgL_objectz00_bglt BgL_tmpz00_2755;

							BgL_tmpz00_2755 =
								((BgL_objectz00_bglt) ((BgL_appz00_bglt) BgL_nodez00_2089));
							BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2755, BFALSE);
						}
						((BgL_objectz00_bglt) ((BgL_appz00_bglt) BgL_nodez00_2089));
						((obj_t) ((BgL_appz00_bglt) BgL_nodez00_2089));
					}
				else
					{	/* Ast/shrinkify.scm 86 */
						BFALSE;
					}
			}
			{	/* Ast/shrinkify.scm 87 */
				BgL_varz00_bglt BgL_arg1406z00_2230;

				BgL_arg1406z00_2230 =
					(((BgL_appz00_bglt) COBJECT(
							((BgL_appz00_bglt) BgL_nodez00_2089)))->BgL_funz00);
				BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
					((BgL_nodez00_bglt) BgL_arg1406z00_2230));
			}
			BGl_shrinkzd2nodeza2z12z62zzast_shrinkifyz00(
				(((BgL_appz00_bglt) COBJECT(
							((BgL_appz00_bglt) BgL_nodez00_2089)))->BgL_argsz00));
			return BUNSPEC;
		}

	}



/* &shrink-node!-sync1257 */
	obj_t BGl_z62shrinkzd2nodez12zd2sync1257z70zzast_shrinkifyz00(obj_t
		BgL_envz00_2090, obj_t BgL_nodez00_2091)
	{
		{	/* Ast/shrinkify.scm 76 */
			BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
				(((BgL_syncz00_bglt) COBJECT(
							((BgL_syncz00_bglt) BgL_nodez00_2091)))->BgL_mutexz00));
			BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
				(((BgL_syncz00_bglt) COBJECT(
							((BgL_syncz00_bglt) BgL_nodez00_2091)))->BgL_prelockz00));
			BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
				(((BgL_syncz00_bglt) COBJECT(
							((BgL_syncz00_bglt) BgL_nodez00_2091)))->BgL_bodyz00));
			return BUNSPEC;
		}

	}



/* &shrink-node!-sequenc1255 */
	obj_t BGl_z62shrinkzd2nodez12zd2sequenc1255z70zzast_shrinkifyz00(obj_t
		BgL_envz00_2092, obj_t BgL_nodez00_2093)
	{
		{	/* Ast/shrinkify.scm 69 */
			BGl_shrinkzd2nodeza2z12z62zzast_shrinkifyz00(
				(((BgL_sequencez00_bglt) COBJECT(
							((BgL_sequencez00_bglt) BgL_nodez00_2093)))->BgL_nodesz00));
			return BUNSPEC;
		}

	}



/* &shrink-node!-kwote1253 */
	obj_t BGl_z62shrinkzd2nodez12zd2kwote1253z70zzast_shrinkifyz00(obj_t
		BgL_envz00_2094, obj_t BgL_nodez00_2095)
	{
		{	/* Ast/shrinkify.scm 63 */
			return BUNSPEC;
		}

	}



/* &shrink-node!-var1251 */
	obj_t BGl_z62shrinkzd2nodez12zd2var1251z70zzast_shrinkifyz00(obj_t
		BgL_envz00_2096, obj_t BgL_nodez00_2097)
	{
		{	/* Ast/shrinkify.scm 57 */
			return BUNSPEC;
		}

	}



/* &shrink-node!-atom1249 */
	obj_t BGl_z62shrinkzd2nodez12zd2atom1249z70zzast_shrinkifyz00(obj_t
		BgL_envz00_2098, obj_t BgL_nodez00_2099)
	{
		{	/* Ast/shrinkify.scm 51 */
			return BUNSPEC;
		}

	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzast_shrinkifyz00()
	{
		{	/* Ast/shrinkify.scm 15 */
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 515343395),
				BSTRING_TO_STRING(BGl_string1856z00zzast_shrinkifyz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 90839984),
				BSTRING_TO_STRING(BGl_string1856z00zzast_shrinkifyz00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 506185397),
				BSTRING_TO_STRING(BGl_string1856z00zzast_shrinkifyz00));
			return
				BGl_modulezd2initializa7ationz75zzast_envz00(((long) 146730773),
				BSTRING_TO_STRING(BGl_string1856z00zzast_shrinkifyz00));
		}

	}

#ifdef __cplusplus
}
#endif
