/*===========================================================================*/
/*   (Ast/venv.scm)                                                          */
/*   Bigloo (4.3g)                                                           */
/*   Inria -- Sophia Antipolis (c)       Wed 12 Feb 2020 07:45:41 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.3g -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Ast/venv.scm) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		bool_t BgL_evalzf3zf3;
		obj_t BgL_libraryz00;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
		obj_t BgL_initz00;
		obj_t BgL_aliasz00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_localz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		long BgL_keyz00;
	}               *BgL_localz00_bglt;

	typedef struct BgL_funz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
	}             *BgL_funz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
		obj_t BgL_strengthz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_cfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
		obj_t BgL_argszd2typezd2;
		bool_t BgL_macrozf3zf3;
		bool_t BgL_infixzf3zf3;
		obj_t BgL_methodz00;
	}              *BgL_cfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_backendz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_languagez00;
		obj_t BgL_srfi0z00;
		obj_t BgL_namez00;
		obj_t BgL_externzd2variableszd2;
		obj_t BgL_externzd2functionszd2;
		obj_t BgL_externzd2typeszd2;
		obj_t BgL_variablesz00;
		obj_t BgL_functionsz00;
		obj_t BgL_typesz00;
		bool_t BgL_typedz00;
		obj_t BgL_heapzd2suffixzd2;
		obj_t BgL_heapzd2compatiblezd2;
		bool_t BgL_callccz00;
		bool_t BgL_qualifiedzd2typeszd2;
		bool_t BgL_effectzb2zb2;
		bool_t BgL_removezd2emptyzd2letz00;
		bool_t BgL_foreignzd2closurezd2;
		bool_t BgL_typedzd2eqzd2;
		bool_t BgL_tracezd2supportzd2;
		obj_t BgL_foreignzd2clausezd2supportz00;
		obj_t BgL_debugzd2supportzd2;
		bool_t BgL_pragmazd2supportzd2;
		bool_t BgL_tvectorzd2descrzd2supportz00;
		bool_t BgL_requirezd2tailczd2;
		obj_t BgL_registersz00;
		obj_t BgL_pregistersz00;
		bool_t BgL_boundzd2checkzd2;
		bool_t BgL_typezd2checkzd2;
		bool_t BgL_typedzd2funcallzd2;
	}                 *BgL_backendz00_bglt;

	typedef struct BgL_isfunz00_bgl
	{
		struct BgL_nodez00_bgl *BgL_originalzd2bodyzd2;
		obj_t BgL_recursivezd2callszd2;
		bool_t BgL_tailrecz00;
	}               *BgL_isfunz00_bglt;


	static obj_t BGl_z62globalzd2bucketzd2positionz62zzast_envz00(obj_t, obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t BGl_setzd2genvz12zc0zzast_envz00(obj_t);
	extern obj_t BGl_sfunz00zzast_varz00;
	static obj_t BGl_za2Genvza2z00zzast_envz00 = BUNSPEC;
	BGL_EXPORTED_DECL obj_t BGl_forzd2eachzd2globalz12z12zzast_envz00(obj_t,
		obj_t);
	static obj_t BGl_objectzd2initzd2zzast_envz00();
	BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	extern obj_t BGl_userzd2warningzd2zztools_errorz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_thezd2backendzd2zzbackend_backendz00();
	BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	static obj_t BGl_z62unbindzd2globalz12za2zzast_envz00(obj_t, obj_t, obj_t);
	static obj_t BGl_methodzd2initzd2zzast_envz00();
	BGL_EXPORTED_DECL obj_t BGl_initializa7ezd2Genvz12z67zzast_envz00();
	static obj_t BGl_z62restorezd2valuezd2typesz12z70zzast_envz00(obj_t, obj_t);
	static obj_t BGl_restorezd2valuezd2typesz12z12zzast_envz00(BgL_valuez00_bglt);
	static obj_t BGl_z62getzd2globalzf2modulez42zzast_envz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_restorezd2globalz12zc0zzast_envz00(obj_t);
	BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_za2_za2z00zztype_cachez00;
	static obj_t BGl_z62alreadyzd2restoredzf3z43zzast_envz00(obj_t, obj_t);
	extern obj_t BGl_hrtypezd2nodez12zc0zzast_hrtypez00(BgL_nodez00_bglt);
	static obj_t BGl_z62restorezd2valuezd2typesz121298z70zzast_envz00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_makezd2hashtablezd2zz__hashz00(obj_t);
	extern obj_t BGl_findzd2locationzd2zztools_locationz00(obj_t);
	extern obj_t BGl_cfunz00zzast_varz00;
	static obj_t BGl_errorzd2rebindzd2globalz12z12zzast_envz00(BgL_globalz00_bglt,
		obj_t);
	static obj_t BGl_gczd2rootszd2initz00zzast_envz00();
	static obj_t BGl_z62zc3z04anonymousza31725ze3ze5zzast_envz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_userzd2warningzf2locationz20zztools_errorz00(obj_t, obj_t,
		obj_t, obj_t);
	BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	BGL_IMPORT obj_t
		BGl_findzd2superzd2classzd2methodzd2zz__objectz00(BgL_objectz00_bglt, obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_hashtablezd2getzd2zz__hashz00(obj_t, obj_t);
	extern obj_t BGl_modulezd2ze3qualifiedzd2typeze3zzread_jvmz00(obj_t);
	BGL_IMPORT int BGl_bigloozd2warningzd2zz__paramz00();
	static obj_t BGl_requirezd2initializa7ationz75zzast_envz00 = BUNSPEC;
	extern obj_t BGl_userzd2errorzf2locationz20zztools_errorz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_additionalzd2heapzd2restorezd2globalsz12zc0zzast_envz00();
	extern obj_t BGl_funz00zzast_varz00;
	BGL_EXPORTED_DECL obj_t BGl_getzd2globalzf2modulez20zzast_envz00(obj_t,
		obj_t);
	extern obj_t BGl_za2warningzd2overridenzd2variablesza2z00zzengine_paramz00;
	BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_alreadyzd2restoredzf3z21zzast_envz00(obj_t);
	static obj_t BGl_toplevelzd2initzd2zzast_envz00();
	static obj_t BGl_z62addzd2genvz12za2zzast_envz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
	extern obj_t BGl_internalzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL BgL_globalz00_bglt
		BGl_bindzd2globalz12zc0zzast_envz00(obj_t, obj_t, obj_t, BgL_valuez00_bglt,
		obj_t, obj_t);
	static obj_t BGl_genericzd2initzd2zzast_envz00();
	static obj_t BGl_z62zc3z04anonymousza31312ze3ze5zzast_envz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_shapez00zztools_shapez00(obj_t);
	extern obj_t BGl_typez00zztype_typez00;
	BGL_EXPORTED_DECL obj_t BGl_addzd2genvz12zc0zzast_envz00(obj_t);
	static obj_t
		BGl_z62additionalzd2heapzd2restorezd2globalsz12za2zzast_envz00(obj_t);
	extern obj_t BGl_za2libzd2modeza2zd2zzengine_paramz00;
	static obj_t BGl_z62findzd2globalzf2modulez42zzast_envz00(obj_t, obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62restorezd2valuezd2typesz121301z70zzast_envz00(obj_t,
		obj_t);
	static obj_t BGl_z62restorezd2valuezd2typesz121303z70zzast_envz00(obj_t,
		obj_t);
	static obj_t BGl_z62restorezd2valuezd2typesz121305z70zzast_envz00(obj_t,
		obj_t);
	static obj_t BGl_z62restorezd2valuezd2typesz121307z70zzast_envz00(obj_t,
		obj_t);
	static obj_t BGl_z62forzd2eachzd2globalz12z70zzast_envz00(obj_t, obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t BGl_findzd2globalzd2zzast_envz00(obj_t, obj_t);
	static obj_t BGl_z62restorezd2globalz12za2zzast_envz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_unbindzd2globalz12zc0zzast_envz00(obj_t, obj_t);
	extern obj_t BGl_isfunz00zzinline_inlinez00;
	static obj_t BGl_z62initializa7ezd2Genvz12z05zzast_envz00(obj_t);
	extern obj_t BGl_za2moduleza2z00zzmodule_modulez00;
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzinline_inlinez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_backendz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_locationz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzmodule_modulez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzread_jvmz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_dumpz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_hrtypez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__hashz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
	static obj_t BGl_z62getzd2genvzb0zzast_envz00(obj_t);
	static BgL_globalz00_bglt BGl_z62bindzd2globalz12za2zzast_envz00(obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_za2delayedzd2restoredzd2globalza2z00zzast_envz00 = BUNSPEC;
	static obj_t BGl_z62findzd2globalzb0zzast_envz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_nodez00zzast_nodez00;
	extern obj_t BGl_localz00zzast_varz00;
	static obj_t BGl_cnstzd2initzd2zzast_envz00();
	static obj_t BGl_libraryzd2moduleszd2initz00zzast_envz00();
	BGL_EXPORTED_DECL obj_t BGl_globalzd2bucketzd2positionz00zzast_envz00(obj_t,
		obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zzast_envz00();
	BGL_IMPORT obj_t BGl_hashtablezd2forzd2eachz00zz__hashz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_findzd2globalzf2modulez20zzast_envz00(obj_t,
		obj_t);
	extern obj_t BGl_valuez00zzast_varz00;
	extern BgL_typez00_bglt BGl_findzd2typezd2zztype_envz00(obj_t);
	BGL_IMPORT obj_t BGl_hashtablezd2putz12zc0zz__hashz00(obj_t, obj_t, obj_t);
	static obj_t BGl_za2restoredza2z00zzast_envz00 = BUNSPEC;
	extern obj_t BGl_addzd2qualifiedzd2typez12z12zzread_jvmz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_warningzd2overridezd2globalz12z12zzast_envz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62setzd2genvz12za2zzast_envz00(obj_t, obj_t);
	extern obj_t BGl_userzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_getzd2genvzd2zzast_envz00();
	extern obj_t BGl_modulezd2initializa7ationzd2idza7zzmodule_modulez00(obj_t);
	extern obj_t BGl_globalz00zzast_varz00;
	static obj_t
		BGl_warningzd2rebindzd2globalz12z12zzast_envz00(BgL_globalz00_bglt, obj_t);
	static obj_t __cnst[7];


	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_setzd2genvz12zd2envz12zzast_envz00,
		BgL_bgl_za762setza7d2genvza7121934za7, BGl_z62setzd2genvz12za2zzast_envz00,
		0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_findzd2globalzd2envz00zzast_envz00,
		BgL_bgl_za762findza7d2global1935z00, va_generic_entry,
		BGl_z62findzd2globalzb0zzast_envz00, BUNSPEC, -2);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_unbindzd2globalz12zd2envz12zzast_envz00,
		BgL_bgl_za762unbindza7d2glob1936z00,
		BGl_z62unbindzd2globalz12za2zzast_envz00, 0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_globalzd2bucketzd2positionzd2envzd2zzast_envz00,
		BgL_bgl_za762globalza7d2buck1937z00,
		BGl_z62globalzd2bucketzd2positionz62zzast_envz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1910z00zzast_envz00,
		BgL_bgl_za762za7c3za704anonymo1938za7,
		BGl_z62zc3z04anonymousza31312ze3ze5zzast_envz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1918z00zzast_envz00,
		BgL_bgl_za762restoreza7d2val1939z00,
		BGl_z62restorezd2valuezd2typesz121298z70zzast_envz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_getzd2globalzf2modulezd2envzf2zzast_envz00,
		BgL_bgl_za762getza7d2globalza71940za7,
		BGl_z62getzd2globalzf2modulez42zzast_envz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1920z00zzast_envz00,
		BgL_bgl_za762restoreza7d2val1941z00,
		BGl_z62restorezd2valuezd2typesz121301z70zzast_envz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1922z00zzast_envz00,
		BgL_bgl_za762restoreza7d2val1942z00,
		BGl_z62restorezd2valuezd2typesz121303z70zzast_envz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1923z00zzast_envz00,
		BgL_bgl_za762restoreza7d2val1943z00,
		BGl_z62restorezd2valuezd2typesz121305z70zzast_envz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1924z00zzast_envz00,
		BgL_bgl_za762restoreza7d2val1944z00,
		BGl_z62restorezd2valuezd2typesz121307z70zzast_envz00, 0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_getzd2genvzd2envz00zzast_envz00,
		BgL_bgl_za762getza7d2genvza7b01945za7, BGl_z62getzd2genvzb0zzast_envz00, 0L,
		BUNSPEC, 0);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_alreadyzd2restoredzf3zd2envzf3zzast_envz00,
		BgL_bgl_za762alreadyza7d2res1946z00,
		BGl_z62alreadyzd2restoredzf3z43zzast_envz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_additionalzd2heapzd2restorezd2globalsz12zd2envz12zzast_envz00,
		BgL_bgl_za762additionalza7d21947z00,
		BGl_z62additionalzd2heapzd2restorezd2globalsz12za2zzast_envz00, 0L, BUNSPEC,
		0);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_addzd2genvz12zd2envz12zzast_envz00,
		BgL_bgl_za762addza7d2genvza7121948za7, BGl_z62addzd2genvz12za2zzast_envz00,
		0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_findzd2globalzf2modulezd2envzf2zzast_envz00,
		BgL_bgl_za762findza7d2global1949z00,
		BGl_z62findzd2globalzf2modulez42zzast_envz00, 0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_initializa7ezd2Genvz12zd2envzb5zzast_envz00,
		BgL_bgl_za762initializa7a7eza71950za7,
		BGl_z62initializa7ezd2Genvz12z05zzast_envz00, 0L, BUNSPEC, 0);
	      DEFINE_STRING(BGl_string1911z00zzast_envz00,
		BgL_bgl_string1911za700za7za7a1951za7, "~a::~a", 6);
	      DEFINE_STRING(BGl_string1912z00zzast_envz00,
		BgL_bgl_string1912za700za7za7a1952za7, "Cannot find global variable", 27);
	      DEFINE_STRING(BGl_string1913z00zzast_envz00,
		BgL_bgl_string1913za700za7za7a1953za7, "Variable overridden by", 22);
	      DEFINE_STRING(BGl_string1914z00zzast_envz00,
		BgL_bgl_string1914za700za7za7a1954za7, "Duplicate definition", 20);
	      DEFINE_STRING(BGl_string1915z00zzast_envz00,
		BgL_bgl_string1915za700za7za7a1955za7, "eval", 4);
	      DEFINE_STRING(BGl_string1916z00zzast_envz00,
		BgL_bgl_string1916za700za7za7a1956za7, "unbind-global!", 14);
	      DEFINE_STRING(BGl_string1917z00zzast_envz00,
		BgL_bgl_string1917za700za7za7a1957za7, "Can't find global", 17);
	      DEFINE_STRING(BGl_string1919z00zzast_envz00,
		BgL_bgl_string1919za700za7za7a1958za7, "restore-value-types!1298", 24);
	      DEFINE_STRING(BGl_string1921z00zzast_envz00,
		BgL_bgl_string1921za700za7za7a1959za7, "restore-value-types!", 20);
	      DEFINE_STRING(BGl_string1925z00zzast_envz00,
		BgL_bgl_string1925za700za7za7a1960za7, "restore-value-types(sfun)", 25);
	      DEFINE_STRING(BGl_string1926z00zzast_envz00,
		BgL_bgl_string1926za700za7za7a1961za7, "Illegal argument", 16);
	      DEFINE_STRING(BGl_string1927z00zzast_envz00,
		BgL_bgl_string1927za700za7za7a1962za7, "restore-value-types", 19);
	      DEFINE_STRING(BGl_string1928z00zzast_envz00,
		BgL_bgl_string1928za700za7za7a1963za7, "Illegal non pair argument", 25);
	      DEFINE_STRING(BGl_string1929z00zzast_envz00,
		BgL_bgl_string1929za700za7za7a1964za7, "ast_env", 7);
	      DEFINE_STRING(BGl_string1930z00zzast_envz00,
		BgL_bgl_string1930za700za7za7a1965za7,
		"eval now read @ get-global/module foreign the-global-environment ", 65);
	     
		DEFINE_STATIC_BGL_GENERIC
		(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
		BgL_bgl_za762restoreza7d2val1966z00,
		BGl_z62restorezd2valuezd2typesz12z70zzast_envz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_forzd2eachzd2globalz12zd2envzc0zzast_envz00,
		BgL_bgl_za762forza7d2eachza7d21967za7, va_generic_entry,
		BGl_z62forzd2eachzd2globalz12z70zzast_envz00, BUNSPEC, -2);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_bindzd2globalz12zd2envz12zzast_envz00,
		BgL_bgl_za762bindza7d2global1968z00, BGl_z62bindzd2globalz12za2zzast_envz00,
		0L, BUNSPEC, 6);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_restorezd2globalz12zd2envz12zzast_envz00,
		BgL_bgl_za762restoreza7d2glo1969z00,
		BGl_z62restorezd2globalz12za2zzast_envz00, 0L, BUNSPEC, 1);

/* GC roots registration */
	static obj_t bgl_gc_roots_register()
	{
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
		void *roots_min = (void *) ULONG_MAX, *roots_max = 0;
		     ADD_ROOT((void *) (&BGl_za2Genvza2z00zzast_envz00));
		     ADD_ROOT((void *) (&BGl_requirezd2initializa7ationz75zzast_envz00));
		   
			 ADD_ROOT((void
				*) (&BGl_za2delayedzd2restoredzd2globalza2z00zzast_envz00));
		     ADD_ROOT((void *) (&BGl_za2restoredza2z00zzast_envz00));
#undef ADD_ROOT
		if   (roots_max > 0)
			     GC_add_roots(roots_min, ((void **) roots_max) + 1);
#endif
		     return BUNSPEC;
	}



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long
		BgL_checksumz00_2344, char *BgL_fromz00_2345)
	{
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzast_envz00))
				{
					BGl_requirezd2initializa7ationz75zzast_envz00 = BBOOL(((bool_t) 0));
					BGl_gczd2rootszd2initz00zzast_envz00();
					BGl_libraryzd2moduleszd2initz00zzast_envz00();
					BGl_cnstzd2initzd2zzast_envz00();
					BGl_importedzd2moduleszd2initz00zzast_envz00();
					BGl_genericzd2initzd2zzast_envz00();
					BGl_methodzd2initzd2zzast_envz00();
					return BGl_toplevelzd2initzd2zzast_envz00();
				}
			else
				{
					return BUNSPEC;
				}
		}

	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzast_envz00()
	{
		{	/* Ast/venv.scm 14 */
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"ast_env");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0), "ast_env");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "ast_env");
			BGl_modulezd2initializa7ationz75zz__hashz00(((long) 0), "ast_env");
			BGl_modulezd2initializa7ationz75zz__paramz00(((long) 0), "ast_env");
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long) 0),
				"ast_env");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0), "ast_env");
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 0),
				"ast_env");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"ast_env");
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 0),
				"ast_env");
			BGl_modulezd2initializa7ationz75zz__bitz00(((long) 0), "ast_env");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long) 0),
				"ast_env");
			return BUNSPEC;
		}

	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzast_envz00()
	{
		{	/* Ast/venv.scm 14 */
			{	/* Ast/venv.scm 14 */
				obj_t BgL_cportz00_2284;

				{	/* Ast/venv.scm 14 */
					obj_t BgL_stringz00_2292;

					BgL_stringz00_2292 = BGl_string1930z00zzast_envz00;
					{	/* Ast/venv.scm 14 */
						obj_t BgL_startz00_2293;

						BgL_startz00_2293 = BINT(((long) 0));
						{	/* Ast/venv.scm 14 */
							obj_t BgL_endz00_2294;

							BgL_endz00_2294 =
								BINT(STRING_LENGTH(((obj_t) BgL_stringz00_2292)));
							{	/* Ast/venv.scm 14 */

								BgL_cportz00_2284 =
									BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00
									(BgL_stringz00_2292, BgL_startz00_2293, BgL_endz00_2294);
				}}}}
				{
					long BgL_iz00_2285;

					BgL_iz00_2285 = ((long) 6);
				BgL_loopz00_2286:
					if ((BgL_iz00_2285 == ((long) -1)))
						{	/* Ast/venv.scm 14 */
							return BUNSPEC;
						}
					else
						{	/* Ast/venv.scm 14 */
							{	/* Ast/venv.scm 14 */
								obj_t BgL_arg1932z00_2288;

								{	/* Ast/venv.scm 14 */

									{	/* Ast/venv.scm 14 */
										obj_t BgL_locationz00_2290;

										BgL_locationz00_2290 = BBOOL(((bool_t) 0));
										{	/* Ast/venv.scm 14 */

											BgL_arg1932z00_2288 =
												BGl_readz00zz__readerz00(BgL_cportz00_2284,
												BgL_locationz00_2290);
										}
									}
								}
								{	/* Ast/venv.scm 14 */
									int BgL_tmpz00_2377;

									BgL_tmpz00_2377 = (int) (BgL_iz00_2285);
									CNST_TABLE_SET(BgL_tmpz00_2377, BgL_arg1932z00_2288);
							}}
							{	/* Ast/venv.scm 14 */
								int BgL_auxz00_2291;

								BgL_auxz00_2291 = (int) ((BgL_iz00_2285 - ((long) 1)));
								{
									long BgL_iz00_2382;

									BgL_iz00_2382 = (long) (BgL_auxz00_2291);
									BgL_iz00_2285 = BgL_iz00_2382;
									goto BgL_loopz00_2286;
								}
							}
						}
				}
			}
		}

	}



/* gc-roots-init */
	obj_t BGl_gczd2rootszd2initz00zzast_envz00()
	{
		{	/* Ast/venv.scm 14 */
			return bgl_gc_roots_register();
		}

	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzast_envz00()
	{
		{	/* Ast/venv.scm 14 */
			BGl_za2Genvza2z00zzast_envz00 = CNST_TABLE_REF(((long) 0));
			BGl_za2delayedzd2restoredzd2globalza2z00zzast_envz00 = BNIL;
			BGl_za2restoredza2z00zzast_envz00 = BNIL;
			return BUNSPEC;
		}

	}



/* set-genv! */
	BGL_EXPORTED_DEF obj_t BGl_setzd2genvz12zc0zzast_envz00(obj_t BgL_genvz00_3)
	{
		{	/* Ast/venv.scm 55 */
			return (BGl_za2Genvza2z00zzast_envz00 = BgL_genvz00_3, BUNSPEC);
		}

	}



/* &set-genv! */
	obj_t BGl_z62setzd2genvz12za2zzast_envz00(obj_t BgL_envz00_2222,
		obj_t BgL_genvz00_2223)
	{
		{	/* Ast/venv.scm 55 */
			return BGl_setzd2genvz12zc0zzast_envz00(BgL_genvz00_2223);
		}

	}



/* add-genv! */
	BGL_EXPORTED_DEF obj_t BGl_addzd2genvz12zc0zzast_envz00(obj_t BgL_genvz00_4)
	{
		{	/* Ast/venv.scm 64 */
			BGl_hashtablezd2forzd2eachz00zz__hashz00(BgL_genvz00_4,
				BGl_proc1910z00zzast_envz00);
			return (BGl_za2restoredza2z00zzast_envz00 = BNIL, BUNSPEC);
		}

	}



/* &add-genv! */
	obj_t BGl_z62addzd2genvz12za2zzast_envz00(obj_t BgL_envz00_2225,
		obj_t BgL_genvz00_2226)
	{
		{	/* Ast/venv.scm 64 */
			return BGl_addzd2genvz12zc0zzast_envz00(BgL_genvz00_2226);
		}

	}



/* &<@anonymous:1312> */
	obj_t BGl_z62zc3z04anonymousza31312ze3ze5zzast_envz00(obj_t BgL_envz00_2227,
		obj_t BgL_kz00_2228, obj_t BgL_bucketz00_2229)
	{
		{	/* Ast/venv.scm 67 */
			{	/* Ast/venv.scm 68 */
				bool_t BgL_tmpz00_2389;

				{	/* Ast/venv.scm 68 */
					obj_t BgL_g1292z00_2297;

					BgL_g1292z00_2297 = CDR(((obj_t) BgL_bucketz00_2229));
					{
						obj_t BgL_l1290z00_2299;

						BgL_l1290z00_2299 = BgL_g1292z00_2297;
					BgL_zc3z04anonymousza31313ze3z87_2298:
						if (PAIRP(BgL_l1290z00_2299))
							{	/* Ast/venv.scm 88 */
								{	/* Ast/venv.scm 69 */
									obj_t BgL_newz00_2300;

									BgL_newz00_2300 = CAR(BgL_l1290z00_2299);
									BGl_za2delayedzd2restoredzd2globalza2z00zzast_envz00 =
										MAKE_YOUNG_PAIR(BgL_newz00_2300,
										BGl_za2delayedzd2restoredzd2globalza2z00zzast_envz00);
									{	/* Ast/venv.scm 70 */
										obj_t BgL_modulez00_2301;

										BgL_modulez00_2301 =
											(((BgL_globalz00_bglt) COBJECT(
													((BgL_globalz00_bglt) BgL_newz00_2300)))->
											BgL_modulez00);
										{	/* Ast/venv.scm 70 */
											obj_t BgL_idz00_2302;

											BgL_idz00_2302 =
												(((BgL_variablez00_bglt) COBJECT(
														((BgL_variablez00_bglt)
															((BgL_globalz00_bglt) BgL_newz00_2300))))->
												BgL_idz00);
											{	/* Ast/venv.scm 71 */
												obj_t BgL_bucketz00_2303;

												BgL_bucketz00_2303 =
													BGl_hashtablezd2getzd2zz__hashz00
													(BGl_za2Genvza2z00zzast_envz00, BgL_idz00_2302);
												{	/* Ast/venv.scm 72 */

													if (PAIRP(BgL_bucketz00_2303))
														{	/* Ast/venv.scm 76 */
															bool_t BgL_test1974z00_2404;

															if (
																(BgL_modulez00_2301 ==
																	BGl_za2moduleza2z00zzmodule_modulez00))
																{	/* Ast/venv.scm 76 */
																	BgL_test1974z00_2404 = ((bool_t) 1);
																}
															else
																{	/* Ast/venv.scm 77 */
																	bool_t BgL_test1976z00_2407;

																	{	/* Ast/venv.scm 78 */
																		obj_t BgL_arg1334z00_2304;

																		{
																			BgL_globalz00_bglt BgL_auxz00_2408;

																			{	/* Ast/venv.scm 78 */
																				obj_t BgL_pairz00_2305;

																				BgL_pairz00_2305 =
																					CDR(BgL_bucketz00_2303);
																				BgL_auxz00_2408 =
																					((BgL_globalz00_bglt)
																					CAR(BgL_pairz00_2305));
																			}
																			BgL_arg1334z00_2304 =
																				(((BgL_globalz00_bglt)
																					COBJECT(BgL_auxz00_2408))->
																				BgL_modulez00);
																		}
																		BgL_test1976z00_2407 =
																			(BGl_za2moduleza2z00zzmodule_modulez00 ==
																			BgL_arg1334z00_2304);
																	}
																	if (BgL_test1976z00_2407)
																		{	/* Ast/venv.scm 77 */
																			BgL_test1974z00_2404 = ((bool_t) 0);
																		}
																	else
																		{	/* Ast/venv.scm 77 */
																			BgL_test1974z00_2404 = ((bool_t) 1);
																		}
																}
															if (BgL_test1974z00_2404)
																{	/* Ast/venv.scm 84 */
																	obj_t BgL_newzd2bucketzd2_2306;

																	BgL_newzd2bucketzd2_2306 =
																		MAKE_YOUNG_PAIR(BgL_newz00_2300,
																		CDR(BgL_bucketz00_2303));
																	SET_CDR(BgL_bucketz00_2303,
																		BgL_newzd2bucketzd2_2306);
																}
															else
																{	/* Ast/venv.scm 87 */
																	obj_t BgL_arg1330z00_2307;
																	obj_t BgL_arg1332z00_2308;

																	BgL_arg1330z00_2307 = CDR(BgL_bucketz00_2303);
																	BgL_arg1332z00_2308 =
																		MAKE_YOUNG_PAIR(BgL_newz00_2300,
																		CDR(CDR(BgL_bucketz00_2303)));
																	{	/* Ast/venv.scm 87 */
																		obj_t BgL_tmpz00_2421;

																		BgL_tmpz00_2421 =
																			((obj_t) BgL_arg1330z00_2307);
																		SET_CDR(BgL_tmpz00_2421,
																			BgL_arg1332z00_2308);
																	}
																}
														}
													else
														{	/* Ast/venv.scm 75 */
															obj_t BgL_arg1362z00_2309;

															{	/* Ast/venv.scm 75 */
																obj_t BgL_list1363z00_2310;

																{	/* Ast/venv.scm 75 */
																	obj_t BgL_arg1365z00_2311;

																	BgL_arg1365z00_2311 =
																		MAKE_YOUNG_PAIR(BgL_newz00_2300, BNIL);
																	BgL_list1363z00_2310 =
																		MAKE_YOUNG_PAIR(BgL_idz00_2302,
																		BgL_arg1365z00_2311);
																}
																BgL_arg1362z00_2309 = BgL_list1363z00_2310;
															}
															BGl_hashtablezd2putz12zc0zz__hashz00
																(BGl_za2Genvza2z00zzast_envz00, BgL_idz00_2302,
																BgL_arg1362z00_2309);
														}
												}
											}
										}
									}
								}
								{
									obj_t BgL_l1290z00_2427;

									BgL_l1290z00_2427 = CDR(BgL_l1290z00_2299);
									BgL_l1290z00_2299 = BgL_l1290z00_2427;
									goto BgL_zc3z04anonymousza31313ze3z87_2298;
								}
							}
						else
							{	/* Ast/venv.scm 88 */
								BgL_tmpz00_2389 = ((bool_t) 1);
							}
					}
				}
				return BBOOL(BgL_tmpz00_2389);
			}
		}

	}



/* additional-heap-restore-globals! */
	BGL_EXPORTED_DEF obj_t
		BGl_additionalzd2heapzd2restorezd2globalsz12zc0zzast_envz00()
	{
		{	/* Ast/venv.scm 105 */
			{
				obj_t BgL_l1293z00_1545;

				BgL_l1293z00_1545 =
					BGl_za2delayedzd2restoredzd2globalza2z00zzast_envz00;
			BgL_zc3z04anonymousza31379ze3z87_1546:
				if (PAIRP(BgL_l1293z00_1545))
					{	/* Ast/venv.scm 106 */
						BGl_restorezd2globalz12zc0zzast_envz00(CAR(BgL_l1293z00_1545));
						{
							obj_t BgL_l1293z00_2434;

							BgL_l1293z00_2434 = CDR(BgL_l1293z00_1545);
							BgL_l1293z00_1545 = BgL_l1293z00_2434;
							goto BgL_zc3z04anonymousza31379ze3z87_1546;
						}
					}
				else
					{	/* Ast/venv.scm 106 */
						((bool_t) 1);
					}
			}
			return BTRUE;
		}

	}



/* &additional-heap-restore-globals! */
	obj_t BGl_z62additionalzd2heapzd2restorezd2globalsz12za2zzast_envz00(obj_t
		BgL_envz00_2230)
	{
		{	/* Ast/venv.scm 105 */
			return BGl_additionalzd2heapzd2restorezd2globalsz12zc0zzast_envz00();
		}

	}



/* restore-global! */
	BGL_EXPORTED_DEF obj_t BGl_restorezd2globalz12zc0zzast_envz00(obj_t
		BgL_newz00_6)
	{
		{	/* Ast/venv.scm 112 */
			BGl_za2restoredza2z00zzast_envz00 =
				MAKE_YOUNG_PAIR(BgL_newz00_6, BGl_za2restoredza2z00zzast_envz00);
			{	/* Ast/venv.scm 115 */
				BgL_typez00_bglt BgL_typez00_1552;

				BgL_typez00_1552 =
					(((BgL_variablez00_bglt) COBJECT(
							((BgL_variablez00_bglt)
								((BgL_globalz00_bglt) BgL_newz00_6))))->BgL_typez00);
				{	/* Ast/venv.scm 116 */
					BgL_valuez00_bglt BgL_valuez00_1553;

					BgL_valuez00_1553 =
						(((BgL_variablez00_bglt) COBJECT(
								((BgL_variablez00_bglt)
									((BgL_globalz00_bglt) BgL_newz00_6))))->BgL_valuez00);
					{	/* Ast/venv.scm 117 */
						obj_t BgL_typeidz00_1554;

						BgL_typeidz00_1554 =
							(((BgL_typez00_bglt) COBJECT(BgL_typez00_1552))->BgL_idz00);
						{	/* Ast/venv.scm 118 */

							{	/* Ast/venv.scm 120 */
								BgL_typez00_bglt BgL_arg1408z00_1555;

								BgL_arg1408z00_1555 =
									BGl_findzd2typezd2zztype_envz00(BgL_typeidz00_1554);
								((((BgL_variablez00_bglt) COBJECT(
												((BgL_variablez00_bglt)
													((BgL_globalz00_bglt) BgL_newz00_6))))->BgL_typez00) =
									((BgL_typez00_bglt) BgL_arg1408z00_1555), BUNSPEC);
							}
							BGl_restorezd2valuezd2typesz12z12zzast_envz00(BgL_valuez00_1553);
							{	/* Ast/venv.scm 124 */
								bool_t BgL_test1978z00_2450;

								{	/* Ast/venv.scm 124 */
									bool_t BgL_test1979z00_2451;

									{	/* Ast/venv.scm 124 */
										obj_t BgL_arg1489z00_1570;

										BgL_arg1489z00_1570 =
											BGl_thezd2backendzd2zzbackend_backendz00();
										BgL_test1979z00_2451 =
											(((BgL_backendz00_bglt) COBJECT(
													((BgL_backendz00_bglt) BgL_arg1489z00_1570)))->
											BgL_qualifiedzd2typeszd2);
									}
									if (BgL_test1979z00_2451)
										{	/* Ast/venv.scm 124 */
											if (
												((((BgL_globalz00_bglt) COBJECT(
																((BgL_globalz00_bglt) BgL_newz00_6)))->
														BgL_modulez00) == CNST_TABLE_REF(((long) 1))))
												{	/* Ast/venv.scm 125 */
													BgL_test1978z00_2450 = ((bool_t) 0);
												}
											else
												{	/* Ast/venv.scm 125 */
													BgL_test1978z00_2450 = ((bool_t) 1);
												}
										}
									else
										{	/* Ast/venv.scm 124 */
											BgL_test1978z00_2450 = ((bool_t) 0);
										}
								}
								if (BgL_test1978z00_2450)
									{	/* Ast/venv.scm 126 */
										obj_t BgL_arg1467z00_1563;
										obj_t BgL_arg1470z00_1564;
										obj_t BgL_arg1486z00_1565;

										BgL_arg1467z00_1563 =
											(((BgL_globalz00_bglt) COBJECT(
													((BgL_globalz00_bglt) BgL_newz00_6)))->BgL_modulez00);
										BgL_arg1470z00_1564 =
											(((BgL_globalz00_bglt) COBJECT(
													((BgL_globalz00_bglt) BgL_newz00_6)))->
											BgL_jvmzd2typezd2namez00);
										BgL_arg1486z00_1565 =
											BGl_shapez00zztools_shapez00(BgL_newz00_6);
										{	/* Ast/venv.scm 126 */
											obj_t BgL_list1487z00_1566;

											BgL_list1487z00_1566 =
												MAKE_YOUNG_PAIR(BgL_arg1486z00_1565, BNIL);
											return
												BGl_addzd2qualifiedzd2typez12z12zzread_jvmz00
												(BgL_arg1467z00_1563, BgL_arg1470z00_1564,
												BgL_list1487z00_1566);
										}
									}
								else
									{	/* Ast/venv.scm 124 */
										return BFALSE;
									}
							}
						}
					}
				}
			}
		}

	}



/* &restore-global! */
	obj_t BGl_z62restorezd2globalz12za2zzast_envz00(obj_t BgL_envz00_2231,
		obj_t BgL_newz00_2232)
	{
		{	/* Ast/venv.scm 112 */
			return BGl_restorezd2globalz12zc0zzast_envz00(BgL_newz00_2232);
		}

	}



/* already-restored? */
	BGL_EXPORTED_DEF obj_t BGl_alreadyzd2restoredzf3z21zzast_envz00(obj_t
		BgL_funz00_8)
	{
		{	/* Ast/venv.scm 147 */
			return
				BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_funz00_8,
				BGl_za2restoredza2z00zzast_envz00);
		}

	}



/* &already-restored? */
	obj_t BGl_z62alreadyzd2restoredzf3z43zzast_envz00(obj_t BgL_envz00_2233,
		obj_t BgL_funz00_2234)
	{
		{	/* Ast/venv.scm 147 */
			return BGl_alreadyzd2restoredzf3z21zzast_envz00(BgL_funz00_2234);
		}

	}



/* get-genv */
	BGL_EXPORTED_DEF obj_t BGl_getzd2genvzd2zzast_envz00()
	{
		{	/* Ast/venv.scm 220 */
			return BGl_za2Genvza2z00zzast_envz00;
		}

	}



/* &get-genv */
	obj_t BGl_z62getzd2genvzb0zzast_envz00(obj_t BgL_envz00_2235)
	{
		{	/* Ast/venv.scm 220 */
			return BGl_getzd2genvzd2zzast_envz00();
		}

	}



/* initialize-Genv! */
	BGL_EXPORTED_DEF obj_t BGl_initializa7ezd2Genvz12z67zzast_envz00()
	{
		{	/* Ast/venv.scm 226 */
			return (BGl_za2Genvza2z00zzast_envz00 =
				BGl_makezd2hashtablezd2zz__hashz00(BNIL), BUNSPEC);
		}

	}



/* &initialize-Genv! */
	obj_t BGl_z62initializa7ezd2Genvz12z05zzast_envz00(obj_t BgL_envz00_2236)
	{
		{	/* Ast/venv.scm 226 */
			return BGl_initializa7ezd2Genvz12z67zzast_envz00();
		}

	}



/* find-global */
	BGL_EXPORTED_DEF obj_t BGl_findzd2globalzd2zzast_envz00(obj_t BgL_idz00_14,
		obj_t BgL_modulez00_15)
	{
		{	/* Ast/venv.scm 232 */
			{	/* Ast/venv.scm 234 */
				obj_t BgL_bucketz00_1572;
				obj_t BgL_modulez00_1573;

				BgL_bucketz00_1572 =
					BGl_hashtablezd2getzd2zz__hashz00(BGl_za2Genvza2z00zzast_envz00,
					BgL_idz00_14);
				if (NULLP(BgL_modulez00_15))
					{	/* Ast/venv.scm 235 */
						BgL_modulez00_1573 = BNIL;
					}
				else
					{	/* Ast/venv.scm 235 */
						BgL_modulez00_1573 = CAR(((obj_t) BgL_modulez00_15));
					}
				if (PAIRP(BgL_bucketz00_1572))
					{	/* Ast/venv.scm 237 */
						if (NULLP(CDR(BgL_bucketz00_1572)))
							{	/* Ast/venv.scm 239 */
								return BFALSE;
							}
						else
							{	/* Ast/venv.scm 239 */
								if (NULLP(BgL_modulez00_1573))
									{	/* Ast/venv.scm 241 */
										return CAR(CDR(BgL_bucketz00_1572));
									}
								else
									{	/* Ast/venv.scm 244 */
										obj_t BgL_g1106z00_1578;

										BgL_g1106z00_1578 = CDR(BgL_bucketz00_1572);
										{
											obj_t BgL_globalsz00_1580;

											BgL_globalsz00_1580 = BgL_g1106z00_1578;
										BgL_zc3z04anonymousza31497ze3z87_1581:
											if (NULLP(BgL_globalsz00_1580))
												{	/* Ast/venv.scm 246 */
													return BFALSE;
												}
											else
												{	/* Ast/venv.scm 246 */
													if (
														((((BgL_globalz00_bglt) COBJECT(
																		((BgL_globalz00_bglt)
																			CAR(
																				((obj_t) BgL_globalsz00_1580)))))->
																BgL_modulez00) == BgL_modulez00_1573))
														{	/* Ast/venv.scm 248 */
															return CAR(((obj_t) BgL_globalsz00_1580));
														}
													else
														{	/* Ast/venv.scm 251 */
															obj_t BgL_arg1506z00_1586;

															BgL_arg1506z00_1586 =
																CDR(((obj_t) BgL_globalsz00_1580));
															{
																obj_t BgL_globalsz00_2500;

																BgL_globalsz00_2500 = BgL_arg1506z00_1586;
																BgL_globalsz00_1580 = BgL_globalsz00_2500;
																goto BgL_zc3z04anonymousza31497ze3z87_1581;
															}
														}
												}
										}
									}
							}
					}
				else
					{	/* Ast/venv.scm 237 */
						return BFALSE;
					}
			}
		}

	}



/* &find-global */
	obj_t BGl_z62findzd2globalzb0zzast_envz00(obj_t BgL_envz00_2237,
		obj_t BgL_idz00_2238, obj_t BgL_modulez00_2239)
	{
		{	/* Ast/venv.scm 232 */
			return
				BGl_findzd2globalzd2zzast_envz00(BgL_idz00_2238, BgL_modulez00_2239);
		}

	}



/* find-global/module */
	BGL_EXPORTED_DEF obj_t BGl_findzd2globalzf2modulez20zzast_envz00(obj_t
		BgL_idz00_16, obj_t BgL_modulez00_17)
	{
		{	/* Ast/venv.scm 256 */
			{	/* Ast/venv.scm 257 */
				obj_t BgL_bucketz00_1592;

				BgL_bucketz00_1592 =
					BGl_hashtablezd2getzd2zz__hashz00(BGl_za2Genvza2z00zzast_envz00,
					BgL_idz00_16);
				if (PAIRP(BgL_bucketz00_1592))
					{	/* Ast/venv.scm 259 */
						if (NULLP(CDR(BgL_bucketz00_1592)))
							{	/* Ast/venv.scm 261 */
								return BFALSE;
							}
						else
							{	/* Ast/venv.scm 266 */
								obj_t BgL_g1107z00_1597;

								BgL_g1107z00_1597 = CDR(BgL_bucketz00_1592);
								{
									obj_t BgL_globalsz00_1599;

									BgL_globalsz00_1599 = BgL_g1107z00_1597;
								BgL_zc3z04anonymousza31524ze3z87_1600:
									if (NULLP(BgL_globalsz00_1599))
										{	/* Ast/venv.scm 268 */
											return BFALSE;
										}
									else
										{	/* Ast/venv.scm 268 */
											if (
												((((BgL_globalz00_bglt) COBJECT(
																((BgL_globalz00_bglt)
																	CAR(
																		((obj_t) BgL_globalsz00_1599)))))->
														BgL_modulez00) == BgL_modulez00_17))
												{	/* Ast/venv.scm 270 */
													return CAR(((obj_t) BgL_globalsz00_1599));
												}
											else
												{	/* Ast/venv.scm 273 */
													obj_t BgL_arg1540z00_1605;

													BgL_arg1540z00_1605 =
														CDR(((obj_t) BgL_globalsz00_1599));
													{
														obj_t BgL_globalsz00_2521;

														BgL_globalsz00_2521 = BgL_arg1540z00_1605;
														BgL_globalsz00_1599 = BgL_globalsz00_2521;
														goto BgL_zc3z04anonymousza31524ze3z87_1600;
													}
												}
										}
								}
							}
					}
				else
					{	/* Ast/venv.scm 259 */
						return BFALSE;
					}
			}
		}

	}



/* &find-global/module */
	obj_t BGl_z62findzd2globalzf2modulez42zzast_envz00(obj_t BgL_envz00_2240,
		obj_t BgL_idz00_2241, obj_t BgL_modulez00_2242)
	{
		{	/* Ast/venv.scm 256 */
			return
				BGl_findzd2globalzf2modulez20zzast_envz00(BgL_idz00_2241,
				BgL_modulez00_2242);
		}

	}



/* get-global/module */
	BGL_EXPORTED_DEF obj_t BGl_getzd2globalzf2modulez20zzast_envz00(obj_t
		BgL_idz00_18, obj_t BgL_modulez00_19)
	{
		{	/* Ast/venv.scm 278 */
			{	/* Ast/venv.scm 279 */
				obj_t BgL_globalz00_1610;

				BgL_globalz00_1610 =
					BGl_findzd2globalzf2modulez20zzast_envz00(BgL_idz00_18,
					BgL_modulez00_19);
				{	/* Ast/venv.scm 280 */
					bool_t BgL_test1991z00_2524;

					if (BGl_isazf3zf3zz__objectz00(BgL_globalz00_1610,
							BGl_globalz00zzast_varz00))
						{	/* Ast/venv.scm 280 */
							BgL_test1991z00_2524 = ((bool_t) 0);
						}
					else
						{	/* Ast/venv.scm 280 */
							if (CBOOL(BGl_za2libzd2modeza2zd2zzengine_paramz00))
								{	/* Ast/venv.scm 280 */
									BgL_test1991z00_2524 = ((bool_t) 0);
								}
							else
								{	/* Ast/venv.scm 280 */
									BgL_test1991z00_2524 = ((bool_t) 1);
								}
						}
					if (BgL_test1991z00_2524)
						{	/* Ast/venv.scm 283 */
							obj_t BgL_arg1554z00_1613;

							{	/* Ast/venv.scm 283 */
								obj_t BgL_list1555z00_1614;

								{	/* Ast/venv.scm 283 */
									obj_t BgL_arg1558z00_1615;

									BgL_arg1558z00_1615 = MAKE_YOUNG_PAIR(BgL_modulez00_19, BNIL);
									BgL_list1555z00_1614 =
										MAKE_YOUNG_PAIR(BgL_idz00_18, BgL_arg1558z00_1615);
								}
								BgL_arg1554z00_1613 =
									BGl_formatz00zz__r4_output_6_10_3z00
									(BGl_string1911z00zzast_envz00, BgL_list1555z00_1614);
							}
							BGl_internalzd2errorzd2zztools_errorz00(CNST_TABLE_REF(((long)
										2)), BGl_string1912z00zzast_envz00, BgL_arg1554z00_1613);
						}
					else
						{	/* Ast/venv.scm 280 */
							BFALSE;
						}
				}
				return BgL_globalz00_1610;
			}
		}

	}



/* &get-global/module */
	obj_t BGl_z62getzd2globalzf2modulez42zzast_envz00(obj_t BgL_envz00_2243,
		obj_t BgL_idz00_2244, obj_t BgL_modulez00_2245)
	{
		{	/* Ast/venv.scm 278 */
			return
				BGl_getzd2globalzf2modulez20zzast_envz00(BgL_idz00_2244,
				BgL_modulez00_2245);
		}

	}



/* warning-override-global! */
	obj_t BGl_warningzd2overridezd2globalz12z12zzast_envz00(obj_t BgL_nz00_20,
		obj_t BgL_oz00_21, obj_t BgL_srcez00_22)
	{
		{	/* Ast/venv.scm 289 */
			{	/* Ast/venv.scm 290 */
				bool_t BgL_test1994z00_2535;

				{	/* Ast/venv.scm 290 */
					bool_t BgL_test1995z00_2536;

					{	/* Ast/venv.scm 290 */
						int BgL_arg1602z00_1637;

						BgL_arg1602z00_1637 = BGl_bigloozd2warningzd2zz__paramz00();
						BgL_test1995z00_2536 = ((long) (BgL_arg1602z00_1637) > ((long) 0));
					}
					if (BgL_test1995z00_2536)
						{	/* Ast/venv.scm 290 */
							BgL_test1994z00_2535 =
								CBOOL
								(BGl_za2warningzd2overridenzd2variablesza2z00zzengine_paramz00);
						}
					else
						{	/* Ast/venv.scm 290 */
							BgL_test1994z00_2535 = ((bool_t) 0);
						}
				}
				if (BgL_test1994z00_2535)
					{	/* Ast/venv.scm 292 */
						obj_t BgL_locz00_1622;
						obj_t BgL_oldz00_1623;
						obj_t BgL_newz00_1624;

						{	/* Ast/venv.scm 292 */
							obj_t BgL__ortest_1109z00_1626;

							{	/* Ast/venv.scm 292 */
								obj_t BgL_arg1568z00_1627;

								BgL_arg1568z00_1627 =
									(((BgL_globalz00_bglt) COBJECT(
											((BgL_globalz00_bglt) BgL_oz00_21)))->BgL_srcz00);
								BgL__ortest_1109z00_1626 =
									BGl_findzd2locationzd2zztools_locationz00
									(BgL_arg1568z00_1627);
							}
							if (CBOOL(BgL__ortest_1109z00_1626))
								{	/* Ast/venv.scm 292 */
									BgL_locz00_1622 = BgL__ortest_1109z00_1626;
								}
							else
								{	/* Ast/venv.scm 292 */
									BgL_locz00_1622 =
										BGl_findzd2locationzd2zztools_locationz00(BgL_srcez00_22);
								}
						}
						{	/* Ast/venv.scm 293 */
							obj_t BgL_arg1573z00_1628;

							{	/* Ast/venv.scm 293 */
								obj_t BgL_arg1574z00_1629;
								obj_t BgL_arg1578z00_1630;

								BgL_arg1574z00_1629 =
									(((BgL_variablez00_bglt) COBJECT(
											((BgL_variablez00_bglt)
												((BgL_globalz00_bglt) BgL_oz00_21))))->BgL_idz00);
								{	/* Ast/venv.scm 293 */
									obj_t BgL_arg1579z00_1631;

									BgL_arg1579z00_1631 =
										(((BgL_globalz00_bglt) COBJECT(
												((BgL_globalz00_bglt) BgL_oz00_21)))->BgL_modulez00);
									BgL_arg1578z00_1630 =
										MAKE_YOUNG_PAIR(BgL_arg1579z00_1631, BNIL);
								}
								BgL_arg1573z00_1628 =
									MAKE_YOUNG_PAIR(BgL_arg1574z00_1629, BgL_arg1578z00_1630);
							}
							BgL_oldz00_1623 =
								MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 3)),
								BgL_arg1573z00_1628);
						}
						{	/* Ast/venv.scm 294 */
							obj_t BgL_arg1585z00_1632;

							{	/* Ast/venv.scm 294 */
								obj_t BgL_arg1590z00_1633;
								obj_t BgL_arg1594z00_1634;

								BgL_arg1590z00_1633 =
									(((BgL_variablez00_bglt) COBJECT(
											((BgL_variablez00_bglt)
												((BgL_globalz00_bglt) BgL_nz00_20))))->BgL_idz00);
								{	/* Ast/venv.scm 294 */
									obj_t BgL_arg1598z00_1635;

									BgL_arg1598z00_1635 =
										(((BgL_globalz00_bglt) COBJECT(
												((BgL_globalz00_bglt) BgL_nz00_20)))->BgL_modulez00);
									BgL_arg1594z00_1634 =
										MAKE_YOUNG_PAIR(BgL_arg1598z00_1635, BNIL);
								}
								BgL_arg1585z00_1632 =
									MAKE_YOUNG_PAIR(BgL_arg1590z00_1633, BgL_arg1594z00_1634);
							}
							BgL_newz00_1624 =
								MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 3)),
								BgL_arg1585z00_1632);
						}
						if (CBOOL(BgL_locz00_1622))
							{	/* Ast/venv.scm 296 */
								return
									BGl_userzd2warningzf2locationz20zztools_errorz00
									(BgL_locz00_1622, BgL_oldz00_1623,
									BGl_string1913z00zzast_envz00, BgL_newz00_1624);
							}
						else
							{	/* Ast/venv.scm 296 */
								return
									BGl_userzd2warningzd2zztools_errorz00(BgL_oldz00_1623,
									BGl_string1913z00zzast_envz00, BgL_newz00_1624);
							}
					}
				else
					{	/* Ast/venv.scm 290 */
						return BFALSE;
					}
			}
		}

	}



/* error-rebind-global! */
	obj_t BGl_errorzd2rebindzd2globalz12z12zzast_envz00(BgL_globalz00_bglt
		BgL_oz00_23, obj_t BgL_srcz00_24)
	{
		{	/* Ast/venv.scm 303 */
			{	/* Ast/venv.scm 305 */
				obj_t BgL_locz00_1639;

				BgL_locz00_1639 =
					BGl_findzd2locationzd2zztools_locationz00(BgL_srcz00_24);
				if (CBOOL(BgL_locz00_1639))
					{	/* Ast/venv.scm 308 */
						obj_t BgL_arg1609z00_1641;
						obj_t BgL_arg1613z00_1642;

						BgL_arg1609z00_1641 =
							(((BgL_globalz00_bglt) COBJECT(BgL_oz00_23))->BgL_modulez00);
						BgL_arg1613z00_1642 =
							BGl_shapez00zztools_shapez00(((obj_t) BgL_oz00_23));
						return
							BGl_userzd2errorzf2locationz20zztools_errorz00(BgL_locz00_1639,
							BgL_arg1609z00_1641, BGl_string1914z00zzast_envz00,
							BgL_arg1613z00_1642, BNIL);
					}
				else
					{	/* Ast/venv.scm 309 */
						obj_t BgL_arg1618z00_1644;
						obj_t BgL_arg1626z00_1645;

						BgL_arg1618z00_1644 =
							(((BgL_globalz00_bglt) COBJECT(BgL_oz00_23))->BgL_modulez00);
						BgL_arg1626z00_1645 =
							BGl_shapez00zztools_shapez00(((obj_t) BgL_oz00_23));
						return
							BGl_userzd2errorzd2zztools_errorz00(BgL_arg1618z00_1644,
							BGl_string1914z00zzast_envz00, BgL_arg1626z00_1645, BNIL);
					}
			}
		}

	}



/* warning-rebind-global! */
	obj_t BGl_warningzd2rebindzd2globalz12z12zzast_envz00(BgL_globalz00_bglt
		BgL_oz00_25, obj_t BgL_srcz00_26)
	{
		{	/* Ast/venv.scm 314 */
			{	/* Ast/venv.scm 316 */
				obj_t BgL_locz00_1648;

				BgL_locz00_1648 =
					BGl_findzd2locationzd2zztools_locationz00(BgL_srcz00_26);
				if (CBOOL(BgL_locz00_1648))
					{	/* Ast/venv.scm 319 */
						obj_t BgL_arg1631z00_1650;
						obj_t BgL_arg1632z00_1651;

						BgL_arg1631z00_1650 =
							(((BgL_globalz00_bglt) COBJECT(BgL_oz00_25))->BgL_modulez00);
						BgL_arg1632z00_1651 =
							BGl_shapez00zztools_shapez00(((obj_t) BgL_oz00_25));
						return
							BGl_userzd2warningzf2locationz20zztools_errorz00(BgL_locz00_1648,
							BgL_arg1631z00_1650, BGl_string1914z00zzast_envz00,
							BgL_arg1632z00_1651);
					}
				else
					{	/* Ast/venv.scm 320 */
						obj_t BgL_arg1633z00_1652;
						obj_t BgL_arg1636z00_1653;

						BgL_arg1633z00_1652 =
							(((BgL_globalz00_bglt) COBJECT(BgL_oz00_25))->BgL_modulez00);
						BgL_arg1636z00_1653 =
							BGl_shapez00zztools_shapez00(((obj_t) BgL_oz00_25));
						return
							BGl_userzd2warningzd2zztools_errorz00(BgL_arg1633z00_1652,
							BGl_string1914z00zzast_envz00, BgL_arg1636z00_1653);
					}
			}
		}

	}



/* bind-global! */
	BGL_EXPORTED_DEF BgL_globalz00_bglt BGl_bindzd2globalz12zc0zzast_envz00(obj_t
		BgL_idz00_27, obj_t BgL_aliasz00_28, obj_t BgL_modulez00_29,
		BgL_valuez00_bglt BgL_valuez00_30, obj_t BgL_importz00_31,
		obj_t BgL_srcz00_32)
	{
		{	/* Ast/venv.scm 337 */
			{	/* Ast/venv.scm 340 */
				obj_t BgL_identz00_1654;

				if (CBOOL(BgL_aliasz00_28))
					{	/* Ast/venv.scm 340 */
						BgL_identz00_1654 = BgL_aliasz00_28;
					}
				else
					{	/* Ast/venv.scm 340 */
						BgL_identz00_1654 = BgL_idz00_27;
					}
				{	/* Ast/venv.scm 340 */
					obj_t BgL_oldz00_1655;

					{	/* Ast/venv.scm 341 */
						obj_t BgL_list1688z00_1695;

						BgL_list1688z00_1695 = MAKE_YOUNG_PAIR(BgL_modulez00_29, BNIL);
						BgL_oldz00_1655 =
							BGl_findzd2globalzd2zzast_envz00(BgL_identz00_1654,
							BgL_list1688z00_1695);
					}
					{	/* Ast/venv.scm 341 */

						if (BGl_isazf3zf3zz__objectz00(BgL_oldz00_1655,
								BGl_globalz00zzast_varz00))
							{	/* Ast/venv.scm 342 */
								if (CBOOL(BGl_za2libzd2modeza2zd2zzengine_paramz00))
									{	/* Ast/venv.scm 344 */
										return ((BgL_globalz00_bglt) BgL_oldz00_1655);
									}
								else
									{	/* Ast/venv.scm 344 */
										if (
											(BgL_modulez00_29 ==
												(((BgL_globalz00_bglt) COBJECT(
															((BgL_globalz00_bglt) BgL_oldz00_1655)))->
													BgL_modulez00)))
											{	/* Ast/venv.scm 346 */
												BGl_warningzd2rebindzd2globalz12z12zzast_envz00(
													((BgL_globalz00_bglt) BgL_oldz00_1655),
													BgL_srcz00_32);
												return ((BgL_globalz00_bglt) BgL_oldz00_1655);
											}
										else
											{	/* Ast/venv.scm 346 */
												return
													((BgL_globalz00_bglt)
													BGl_errorzd2rebindzd2globalz12z12zzast_envz00(
														((BgL_globalz00_bglt) BgL_oldz00_1655),
														BgL_srcz00_32));
											}
									}
							}
						else
							{	/* Ast/venv.scm 351 */
								obj_t BgL_bucketz00_1660;
								BgL_globalz00_bglt BgL_newz00_1661;

								BgL_bucketz00_1660 =
									BGl_hashtablezd2getzd2zz__hashz00
									(BGl_za2Genvza2z00zzast_envz00, BgL_identz00_1654);
								{	/* Ast/venv.scm 352 */
									BgL_globalz00_bglt BgL_new1114z00_1691;

									{	/* Ast/venv.scm 358 */
										BgL_globalz00_bglt BgL_new1113z00_1693;

										BgL_new1113z00_1693 =
											((BgL_globalz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
														BgL_globalz00_bgl))));
										{	/* Ast/venv.scm 358 */
											long BgL_arg1687z00_1694;

											{	/* Ast/venv.scm 358 */
												long BgL_res1881z00_2112;

												BgL_res1881z00_2112 =
													BGL_CLASS_INDEX(BGl_globalz00zzast_varz00);
												BgL_arg1687z00_1694 = BgL_res1881z00_2112;
											}
											BGL_OBJECT_CLASS_NUM_SET(
												((BgL_objectz00_bglt) BgL_new1113z00_1693),
												BgL_arg1687z00_1694);
										}
										{	/* Ast/venv.scm 358 */
											BgL_objectz00_bglt BgL_tmpz00_2615;

											BgL_tmpz00_2615 =
												((BgL_objectz00_bglt) BgL_new1113z00_1693);
											BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2615, BFALSE);
										}
										((BgL_objectz00_bglt) BgL_new1113z00_1693);
										BgL_new1114z00_1691 = BgL_new1113z00_1693;
									}
									((((BgL_variablez00_bglt) COBJECT(
													((BgL_variablez00_bglt) BgL_new1114z00_1691)))->
											BgL_idz00) = ((obj_t) BgL_identz00_1654), BUNSPEC);
									((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
														BgL_new1114z00_1691)))->BgL_namez00) =
										((obj_t) BFALSE), BUNSPEC);
									((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
														BgL_new1114z00_1691)))->BgL_typez00) =
										((BgL_typez00_bglt) ((BgL_typez00_bglt)
												BGl_za2_za2z00zztype_cachez00)), BUNSPEC);
									((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
														BgL_new1114z00_1691)))->BgL_valuez00) =
										((BgL_valuez00_bglt) BgL_valuez00_30), BUNSPEC);
									((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
														BgL_new1114z00_1691)))->BgL_accessz00) =
										((obj_t) CNST_TABLE_REF(((long) 4))), BUNSPEC);
									((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
														BgL_new1114z00_1691)))->BgL_fastzd2alphazd2) =
										((obj_t) BUNSPEC), BUNSPEC);
									((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
														BgL_new1114z00_1691)))->BgL_removablez00) =
										((obj_t) CNST_TABLE_REF(((long) 5))), BUNSPEC);
									((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
														BgL_new1114z00_1691)))->BgL_occurrencez00) =
										((long) ((long) 0)), BUNSPEC);
									((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
														BgL_new1114z00_1691)))->BgL_occurrencewz00) =
										((long) ((long) 0)), BUNSPEC);
									((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
														BgL_new1114z00_1691)))->BgL_userzf3zf3) =
										((bool_t) ((bool_t) 1)), BUNSPEC);
									((((BgL_globalz00_bglt) COBJECT(BgL_new1114z00_1691))->
											BgL_modulez00) = ((obj_t) BgL_modulez00_29), BUNSPEC);
									((((BgL_globalz00_bglt) COBJECT(BgL_new1114z00_1691))->
											BgL_importz00) = ((obj_t) BgL_importz00_31), BUNSPEC);
									((((BgL_globalz00_bglt) COBJECT(BgL_new1114z00_1691))->
											BgL_evaluablezf3zf3) = ((bool_t) ((bool_t) 1)), BUNSPEC);
									((((BgL_globalz00_bglt) COBJECT(BgL_new1114z00_1691))->
											BgL_evalzf3zf3) = ((bool_t) ((bool_t) 0)), BUNSPEC);
									((((BgL_globalz00_bglt) COBJECT(BgL_new1114z00_1691))->
											BgL_libraryz00) = ((obj_t) BFALSE), BUNSPEC);
									((((BgL_globalz00_bglt) COBJECT(BgL_new1114z00_1691))->
											BgL_pragmaz00) = ((obj_t) BNIL), BUNSPEC);
									((((BgL_globalz00_bglt) COBJECT(BgL_new1114z00_1691))->
											BgL_srcz00) = ((obj_t) BgL_srcz00_32), BUNSPEC);
									{
										obj_t BgL_auxz00_2649;

										if ((BgL_importz00_31 == CNST_TABLE_REF(((long) 6))))
											{	/* Ast/venv.scm 355 */
												BgL_auxz00_2649 = BGl_string1915z00zzast_envz00;
											}
										else
											{	/* Ast/venv.scm 355 */
												BgL_auxz00_2649 =
													BGl_modulezd2ze3qualifiedzd2typeze3zzread_jvmz00
													(BgL_modulez00_29);
											}
										((((BgL_globalz00_bglt) COBJECT(BgL_new1114z00_1691))->
												BgL_jvmzd2typezd2namez00) =
											((obj_t) BgL_auxz00_2649), BUNSPEC);
									}
									((((BgL_globalz00_bglt) COBJECT(BgL_new1114z00_1691))->
											BgL_initz00) = ((obj_t) BUNSPEC), BUNSPEC);
									{
										obj_t BgL_auxz00_2656;

										if (CBOOL(BgL_aliasz00_28))
											{	/* Ast/venv.scm 359 */
												BgL_auxz00_2656 = BgL_idz00_27;
											}
										else
											{	/* Ast/venv.scm 359 */
												BgL_auxz00_2656 = BFALSE;
											}
										((((BgL_globalz00_bglt) COBJECT(BgL_new1114z00_1691))->
												BgL_aliasz00) = ((obj_t) BgL_auxz00_2656), BUNSPEC);
									}
									BgL_newz00_1661 = BgL_new1114z00_1691;
								}
								{	/* Ast/venv.scm 365 */
									bool_t BgL_test2006z00_2660;

									if (PAIRP(BgL_bucketz00_1660))
										{	/* Ast/venv.scm 365 */
											BgL_test2006z00_2660 = NULLP(CDR(BgL_bucketz00_1660));
										}
									else
										{	/* Ast/venv.scm 365 */
											BgL_test2006z00_2660 = ((bool_t) 1);
										}
									if (BgL_test2006z00_2660)
										{	/* Ast/venv.scm 365 */
											{	/* Ast/venv.scm 367 */
												obj_t BgL_arg1647z00_1665;

												{	/* Ast/venv.scm 367 */
													obj_t BgL_list1648z00_1666;

													{	/* Ast/venv.scm 367 */
														obj_t BgL_arg1650z00_1667;

														BgL_arg1650z00_1667 =
															MAKE_YOUNG_PAIR(((obj_t) BgL_newz00_1661), BNIL);
														BgL_list1648z00_1666 =
															MAKE_YOUNG_PAIR(BgL_identz00_1654,
															BgL_arg1650z00_1667);
													}
													BgL_arg1647z00_1665 = BgL_list1648z00_1666;
												}
												BGl_hashtablezd2putz12zc0zz__hashz00
													(BGl_za2Genvza2z00zzast_envz00, BgL_identz00_1654,
													BgL_arg1647z00_1665);
											}
											return BgL_newz00_1661;
										}
									else
										{	/* Ast/venv.scm 370 */
											obj_t BgL_oldza2za2_1668;

											BgL_oldza2za2_1668 = CDR(((obj_t) BgL_bucketz00_1660));
											{	/* Ast/venv.scm 370 */
												obj_t BgL_midz00_1669;

												{	/* Ast/venv.scm 372 */
													obj_t BgL_arg1677z00_1687;

													BgL_arg1677z00_1687 =
														(((BgL_globalz00_bglt) COBJECT(
																((BgL_globalz00_bglt)
																	CAR(
																		((obj_t) BgL_oldza2za2_1668)))))->
														BgL_modulez00);
													BgL_midz00_1669 =
														BGl_modulezd2initializa7ationzd2idza7zzmodule_modulez00
														(BgL_arg1677z00_1687);
												}
												{	/* Ast/venv.scm 371 */

													{	/* Ast/venv.scm 374 */
														bool_t BgL_test2008z00_2676;

														{	/* Ast/venv.scm 374 */
															obj_t BgL_arg1675z00_1685;

															BgL_arg1675z00_1685 =
																(((BgL_globalz00_bglt) COBJECT(
																		((BgL_globalz00_bglt)
																			CAR(
																				((obj_t) BgL_oldza2za2_1668)))))->
																BgL_modulez00);
															BgL_test2008z00_2676 =
																(BgL_arg1675z00_1685 ==
																BGl_za2moduleza2z00zzmodule_modulez00);
														}
														if (BgL_test2008z00_2676)
															{	/* Ast/venv.scm 374 */
																{	/* Ast/venv.scm 376 */
																	bool_t BgL_test2009z00_2682;

																	if ((BgL_identz00_1654 == BgL_midz00_1669))
																		{	/* Ast/venv.scm 376 */
																			BgL_test2009z00_2682 = ((bool_t) 0);
																		}
																	else
																		{	/* Ast/venv.scm 376 */
																			if (CBOOL
																				(BGl_za2libzd2modeza2zd2zzengine_paramz00))
																				{	/* Ast/venv.scm 376 */
																					BgL_test2009z00_2682 = ((bool_t) 0);
																				}
																			else
																				{	/* Ast/venv.scm 376 */
																					BgL_test2009z00_2682 = ((bool_t) 1);
																				}
																		}
																	if (BgL_test2009z00_2682)
																		{	/* Ast/venv.scm 377 */
																			obj_t BgL_arg1660z00_1675;

																			BgL_arg1660z00_1675 =
																				CAR(((obj_t) BgL_oldza2za2_1668));
																			BGl_warningzd2overridezd2globalz12z12zzast_envz00
																				(BgL_arg1660z00_1675,
																				((obj_t) BgL_newz00_1661),
																				BgL_srcz00_32);
																		}
																	else
																		{	/* Ast/venv.scm 376 */
																			BFALSE;
																		}
																}
																{	/* Ast/venv.scm 378 */
																	obj_t BgL_arg1663z00_1677;
																	obj_t BgL_arg1665z00_1678;

																	BgL_arg1663z00_1677 =
																		CDR(((obj_t) BgL_bucketz00_1660));
																	{	/* Ast/venv.scm 378 */
																		obj_t BgL_arg1668z00_1679;

																		{	/* Ast/venv.scm 378 */
																			obj_t BgL_pairz00_2130;

																			BgL_pairz00_2130 =
																				CDR(((obj_t) BgL_bucketz00_1660));
																			BgL_arg1668z00_1679 =
																				CDR(BgL_pairz00_2130);
																		}
																		BgL_arg1665z00_1678 =
																			MAKE_YOUNG_PAIR(
																			((obj_t) BgL_newz00_1661),
																			BgL_arg1668z00_1679);
																	}
																	{	/* Ast/venv.scm 378 */
																		obj_t BgL_tmpz00_2698;

																		BgL_tmpz00_2698 =
																			((obj_t) BgL_arg1663z00_1677);
																		SET_CDR(BgL_tmpz00_2698,
																			BgL_arg1665z00_1678);
																	}
																}
																return BgL_newz00_1661;
															}
														else
															{	/* Ast/venv.scm 381 */
																obj_t BgL_newza2za2_1680;

																BgL_newza2za2_1680 =
																	MAKE_YOUNG_PAIR(
																	((obj_t) BgL_newz00_1661),
																	BgL_oldza2za2_1668);
																{	/* Ast/venv.scm 382 */
																	bool_t BgL_test2012z00_2703;

																	if ((BgL_identz00_1654 == BgL_midz00_1669))
																		{	/* Ast/venv.scm 382 */
																			BgL_test2012z00_2703 = ((bool_t) 0);
																		}
																	else
																		{	/* Ast/venv.scm 382 */
																			if (CBOOL
																				(BGl_za2libzd2modeza2zd2zzengine_paramz00))
																				{	/* Ast/venv.scm 382 */
																					BgL_test2012z00_2703 = ((bool_t) 0);
																				}
																			else
																				{	/* Ast/venv.scm 382 */
																					BgL_test2012z00_2703 = ((bool_t) 1);
																				}
																		}
																	if (BgL_test2012z00_2703)
																		{	/* Ast/venv.scm 383 */
																			obj_t BgL_arg1673z00_1683;

																			BgL_arg1673z00_1683 =
																				CAR(((obj_t) BgL_oldza2za2_1668));
																			BGl_warningzd2overridezd2globalz12z12zzast_envz00
																				(((obj_t) BgL_newz00_1661),
																				BgL_arg1673z00_1683, BgL_srcz00_32);
																		}
																	else
																		{	/* Ast/venv.scm 382 */
																			BFALSE;
																		}
																}
																{	/* Ast/venv.scm 384 */
																	obj_t BgL_tmpz00_2712;

																	BgL_tmpz00_2712 =
																		((obj_t) BgL_bucketz00_1660);
																	SET_CDR(BgL_tmpz00_2712, BgL_newza2za2_1680);
																}
																return BgL_newz00_1661;
															}
													}
												}
											}
										}
								}
							}
					}
				}
			}
		}

	}



/* &bind-global! */
	BgL_globalz00_bglt BGl_z62bindzd2globalz12za2zzast_envz00(obj_t
		BgL_envz00_2246, obj_t BgL_idz00_2247, obj_t BgL_aliasz00_2248,
		obj_t BgL_modulez00_2249, obj_t BgL_valuez00_2250, obj_t BgL_importz00_2251,
		obj_t BgL_srcz00_2252)
	{
		{	/* Ast/venv.scm 337 */
			return
				BGl_bindzd2globalz12zc0zzast_envz00(BgL_idz00_2247, BgL_aliasz00_2248,
				BgL_modulez00_2249, ((BgL_valuez00_bglt) BgL_valuez00_2250),
				BgL_importz00_2251, BgL_srcz00_2252);
		}

	}



/* unbind-global! */
	BGL_EXPORTED_DEF obj_t BGl_unbindzd2globalz12zc0zzast_envz00(obj_t
		BgL_idz00_33, obj_t BgL_modulez00_34)
	{
		{	/* Ast/venv.scm 390 */
			{	/* Ast/venv.scm 391 */
				obj_t BgL_globalz00_1697;

				{	/* Ast/venv.scm 391 */
					obj_t BgL_list1714z00_1716;

					BgL_list1714z00_1716 = MAKE_YOUNG_PAIR(BgL_modulez00_34, BNIL);
					BgL_globalz00_1697 =
						BGl_findzd2globalzd2zzast_envz00(BgL_idz00_33,
						BgL_list1714z00_1716);
				}
				if (BGl_isazf3zf3zz__objectz00(BgL_globalz00_1697,
						BGl_globalz00zzast_varz00))
					{	/* Ast/venv.scm 394 */
						obj_t BgL_bucketz00_1699;

						BgL_bucketz00_1699 =
							BGl_hashtablezd2getzd2zz__hashz00(BGl_za2Genvza2z00zzast_envz00,
							BgL_idz00_33);
						{	/* Ast/venv.scm 395 */
							obj_t BgL_g1115z00_1700;

							BgL_g1115z00_1700 = CDR(((obj_t) BgL_bucketz00_1699));
							{
								obj_t BgL_curz00_1702;
								obj_t BgL_prevz00_1703;

								BgL_curz00_1702 = BgL_g1115z00_1700;
								BgL_prevz00_1703 = BgL_bucketz00_1699;
							BgL_zc3z04anonymousza31690ze3z87_1704:
								if ((CAR(((obj_t) BgL_curz00_1702)) == BgL_globalz00_1697))
									{	/* Ast/venv.scm 398 */
										obj_t BgL_arg1693z00_1707;

										BgL_arg1693z00_1707 = CDR(((obj_t) BgL_curz00_1702));
										{	/* Ast/venv.scm 398 */
											obj_t BgL_tmpz00_2730;

											BgL_tmpz00_2730 = ((obj_t) BgL_prevz00_1703);
											return SET_CDR(BgL_tmpz00_2730, BgL_arg1693z00_1707);
										}
									}
								else
									{	/* Ast/venv.scm 399 */
										obj_t BgL_arg1694z00_1708;
										obj_t BgL_arg1695z00_1709;

										BgL_arg1694z00_1708 = CDR(((obj_t) BgL_curz00_1702));
										BgL_arg1695z00_1709 = CDR(((obj_t) BgL_prevz00_1703));
										{
											obj_t BgL_prevz00_2738;
											obj_t BgL_curz00_2737;

											BgL_curz00_2737 = BgL_arg1694z00_1708;
											BgL_prevz00_2738 = BgL_arg1695z00_1709;
											BgL_prevz00_1703 = BgL_prevz00_2738;
											BgL_curz00_1702 = BgL_curz00_2737;
											goto BgL_zc3z04anonymousza31690ze3z87_1704;
										}
									}
							}
						}
					}
				else
					{	/* Ast/venv.scm 393 */
						obj_t BgL_arg1702z00_1712;

						{	/* Ast/venv.scm 393 */
							obj_t BgL_arg1710z00_1714;

							{	/* Ast/venv.scm 393 */
								obj_t BgL_arg1713z00_1715;

								BgL_arg1713z00_1715 = MAKE_YOUNG_PAIR(BgL_modulez00_34, BNIL);
								BgL_arg1710z00_1714 =
									MAKE_YOUNG_PAIR(BgL_idz00_33, BgL_arg1713z00_1715);
							}
							BgL_arg1702z00_1712 =
								MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 3)),
								BgL_arg1710z00_1714);
						}
						return
							BGl_userzd2errorzd2zztools_errorz00(BGl_string1916z00zzast_envz00,
							BGl_string1917z00zzast_envz00, BgL_arg1702z00_1712, BNIL);
					}
			}
		}

	}



/* &unbind-global! */
	obj_t BGl_z62unbindzd2globalz12za2zzast_envz00(obj_t BgL_envz00_2253,
		obj_t BgL_idz00_2254, obj_t BgL_modulez00_2255)
	{
		{	/* Ast/venv.scm 390 */
			return
				BGl_unbindzd2globalz12zc0zzast_envz00(BgL_idz00_2254,
				BgL_modulez00_2255);
		}

	}



/* for-each-global! */
	BGL_EXPORTED_DEF obj_t BGl_forzd2eachzd2globalz12z12zzast_envz00(obj_t
		BgL_procz00_35, obj_t BgL_envz00_36)
	{
		{	/* Ast/venv.scm 404 */
			{	/* Ast/venv.scm 405 */
				obj_t BgL_arg1717z00_1717;

				if (NULLP(BgL_envz00_36))
					{	/* Ast/venv.scm 405 */
						BgL_arg1717z00_1717 = BGl_za2Genvza2z00zzast_envz00;
					}
				else
					{	/* Ast/venv.scm 405 */
						BgL_arg1717z00_1717 = CAR(((obj_t) BgL_envz00_36));
					}
				{	/* Ast/venv.scm 406 */
					obj_t BgL_zc3z04anonymousza31725ze3z87_2256;

					BgL_zc3z04anonymousza31725ze3z87_2256 =
						MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31725ze3ze5zzast_envz00,
						(int) (((long) 2)), (int) (((long) 1)));
					PROCEDURE_SET(BgL_zc3z04anonymousza31725ze3z87_2256,
						(int) (((long) 0)), BgL_procz00_35);
					return
						BGl_hashtablezd2forzd2eachz00zz__hashz00(BgL_arg1717z00_1717,
						BgL_zc3z04anonymousza31725ze3z87_2256);
				}
			}
		}

	}



/* &for-each-global! */
	obj_t BGl_z62forzd2eachzd2globalz12z70zzast_envz00(obj_t BgL_envz00_2257,
		obj_t BgL_procz00_2258, obj_t BgL_envz00_2259)
	{
		{	/* Ast/venv.scm 404 */
			return
				BGl_forzd2eachzd2globalz12z12zzast_envz00(BgL_procz00_2258,
				BgL_envz00_2259);
		}

	}



/* &<@anonymous:1725> */
	obj_t BGl_z62zc3z04anonymousza31725ze3ze5zzast_envz00(obj_t BgL_envz00_2260,
		obj_t BgL_kz00_2262, obj_t BgL_bucketz00_2263)
	{
		{	/* Ast/venv.scm 406 */
			{	/* Ast/venv.scm 406 */
				obj_t BgL_procz00_2261;

				BgL_procz00_2261 =
					((obj_t) PROCEDURE_REF(BgL_envz00_2260, (int) (((long) 0))));
				{	/* Ast/venv.scm 406 */
					bool_t BgL_tmpz00_2759;

					{	/* Ast/venv.scm 406 */
						obj_t BgL_g1297z00_2312;

						BgL_g1297z00_2312 = CDR(((obj_t) BgL_bucketz00_2263));
						{
							obj_t BgL_l1295z00_2314;

							BgL_l1295z00_2314 = BgL_g1297z00_2312;
						BgL_zc3z04anonymousza31726ze3z87_2313:
							if (PAIRP(BgL_l1295z00_2314))
								{	/* Ast/venv.scm 406 */
									{	/* Ast/venv.scm 406 */
										obj_t BgL_arg1731z00_2315;

										BgL_arg1731z00_2315 = CAR(BgL_l1295z00_2314);
										PROCEDURE_ENTRY(BgL_procz00_2261) (BgL_procz00_2261,
											BgL_arg1731z00_2315, BEOA);
									}
									{
										obj_t BgL_l1295z00_2769;

										BgL_l1295z00_2769 = CDR(BgL_l1295z00_2314);
										BgL_l1295z00_2314 = BgL_l1295z00_2769;
										goto BgL_zc3z04anonymousza31726ze3z87_2313;
									}
								}
							else
								{	/* Ast/venv.scm 406 */
									BgL_tmpz00_2759 = ((bool_t) 1);
								}
						}
					}
					return BBOOL(BgL_tmpz00_2759);
				}
			}
		}

	}



/* global-bucket-position */
	BGL_EXPORTED_DEF obj_t BGl_globalzd2bucketzd2positionz00zzast_envz00(obj_t
		BgL_idz00_37, obj_t BgL_modulez00_38)
	{
		{	/* Ast/venv.scm 411 */
			{	/* Ast/venv.scm 412 */
				obj_t BgL_bucketz00_1732;

				BgL_bucketz00_1732 =
					BGl_hashtablezd2getzd2zz__hashz00(BGl_za2Genvza2z00zzast_envz00,
					BgL_idz00_37);
				if (PAIRP(BgL_bucketz00_1732))
					{	/* Ast/venv.scm 415 */
						obj_t BgL_g1116z00_1734;

						BgL_g1116z00_1734 = CDR(BgL_bucketz00_1732);
						{
							obj_t BgL_globalsz00_1736;
							long BgL_posz00_1737;

							{	/* Ast/venv.scm 415 */
								long BgL_tmpz00_2776;

								BgL_globalsz00_1736 = BgL_g1116z00_1734;
								BgL_posz00_1737 = ((long) 0);
							BgL_zc3z04anonymousza31739ze3z87_1738:
								if (NULLP(BgL_globalsz00_1736))
									{	/* Ast/venv.scm 418 */
										BgL_tmpz00_2776 = ((long) -1);
									}
								else
									{	/* Ast/venv.scm 418 */
										if (
											((((BgL_globalz00_bglt) COBJECT(
															((BgL_globalz00_bglt)
																CAR(
																	((obj_t) BgL_globalsz00_1736)))))->
													BgL_modulez00) == BgL_modulez00_38))
											{	/* Ast/venv.scm 420 */
												BgL_tmpz00_2776 = BgL_posz00_1737;
											}
										else
											{	/* Ast/venv.scm 423 */
												obj_t BgL_arg1752z00_1743;
												long BgL_arg1753z00_1744;

												BgL_arg1752z00_1743 =
													CDR(((obj_t) BgL_globalsz00_1736));
												BgL_arg1753z00_1744 = (BgL_posz00_1737 + ((long) 1));
												{
													long BgL_posz00_2789;
													obj_t BgL_globalsz00_2788;

													BgL_globalsz00_2788 = BgL_arg1752z00_1743;
													BgL_posz00_2789 = BgL_arg1753z00_1744;
													BgL_posz00_1737 = BgL_posz00_2789;
													BgL_globalsz00_1736 = BgL_globalsz00_2788;
													goto BgL_zc3z04anonymousza31739ze3z87_1738;
												}
											}
									}
								return BINT(BgL_tmpz00_2776);
							}
						}
					}
				else
					{	/* Ast/venv.scm 413 */
						return BINT(((long) -1));
		}}}

	}



/* &global-bucket-position */
	obj_t BGl_z62globalzd2bucketzd2positionz62zzast_envz00(obj_t BgL_envz00_2264,
		obj_t BgL_idz00_2265, obj_t BgL_modulez00_2266)
	{
		{	/* Ast/venv.scm 411 */
			return
				BGl_globalzd2bucketzd2positionz00zzast_envz00(BgL_idz00_2265,
				BgL_modulez00_2266);
		}

	}



/* object-init */
	obj_t BGl_objectzd2initzd2zzast_envz00()
	{
		{	/* Ast/venv.scm 14 */
			return BUNSPEC;
		}

	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzast_envz00()
	{
		{	/* Ast/venv.scm 14 */
			return
				BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
				BGl_proc1918z00zzast_envz00, BGl_valuez00zzast_varz00,
				BGl_string1919z00zzast_envz00);
		}

	}



/* &restore-value-types!1298 */
	obj_t BGl_z62restorezd2valuezd2typesz121298z70zzast_envz00(obj_t
		BgL_envz00_2268, obj_t BgL_valuez00_2269)
	{
		{	/* Ast/venv.scm 153 */
			return BUNSPEC;
		}

	}



/* restore-value-types! */
	obj_t BGl_restorezd2valuezd2typesz12z12zzast_envz00(BgL_valuez00_bglt
		BgL_valuez00_9)
	{
		{	/* Ast/venv.scm 153 */
			{	/* Ast/venv.scm 153 */
				obj_t BgL_method1299z00_1752;

				{	/* Ast/venv.scm 153 */
					obj_t BgL_res1901z00_2191;

					{	/* Ast/venv.scm 153 */
						long BgL_objzd2classzd2numz00_2156;

						{	/* Ast/venv.scm 153 */
							long BgL_res1891z00_2159;

							BgL_res1891z00_2159 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_valuez00_9));
							BgL_objzd2classzd2numz00_2156 = BgL_res1891z00_2159;
						}
						{	/* Ast/venv.scm 153 */
							obj_t BgL_arg1741z00_2157;

							BgL_arg1741z00_2157 =
								PROCEDURE_REF
								(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
								(int) (((long) 1)));
							{	/* Ast/venv.scm 153 */
								int BgL_offsetz00_2161;

								BgL_offsetz00_2161 = (int) (BgL_objzd2classzd2numz00_2156);
								{	/* Ast/venv.scm 153 */
									long BgL_offsetz00_2162;

									BgL_offsetz00_2162 =
										((long) (BgL_offsetz00_2161) - OBJECT_TYPE);
									{	/* Ast/venv.scm 153 */
										long BgL_modz00_2163;

										BgL_modz00_2163 =
											(BgL_offsetz00_2162 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Ast/venv.scm 153 */
											long BgL_restz00_2165;

											BgL_restz00_2165 =
												(BgL_offsetz00_2162 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Ast/venv.scm 153 */

												{	/* Ast/venv.scm 153 */
													obj_t BgL_bucketz00_2167;

													BgL_bucketz00_2167 =
														VECTOR_REF(
														((obj_t) BgL_arg1741z00_2157), BgL_modz00_2163);
													BgL_res1901z00_2191 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_2167), BgL_restz00_2165);
					}}}}}}}}
					BgL_method1299z00_1752 = BgL_res1901z00_2191;
				}
				return
					PROCEDURE_ENTRY(BgL_method1299z00_1752) (BgL_method1299z00_1752,
					((obj_t) BgL_valuez00_9), BEOA);
			}
		}

	}



/* &restore-value-types! */
	obj_t BGl_z62restorezd2valuezd2typesz12z70zzast_envz00(obj_t BgL_envz00_2270,
		obj_t BgL_valuez00_2271)
	{
		{	/* Ast/venv.scm 153 */
			return
				BGl_restorezd2valuezd2typesz12z12zzast_envz00(
				((BgL_valuez00_bglt) BgL_valuez00_2271));
		}

	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzast_envz00()
	{
		{	/* Ast/venv.scm 14 */
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
				BGl_funz00zzast_varz00, BGl_proc1920z00zzast_envz00,
				BGl_string1921z00zzast_envz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
				BGl_sfunz00zzast_varz00, BGl_proc1922z00zzast_envz00,
				BGl_string1921z00zzast_envz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
				BGl_isfunz00zzinline_inlinez00, BGl_proc1923z00zzast_envz00,
				BGl_string1921z00zzast_envz00);
			return
				BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
				BGl_cfunz00zzast_varz00, BGl_proc1924z00zzast_envz00,
				BGl_string1921z00zzast_envz00);
		}

	}



/* &restore-value-types!1307 */
	obj_t BGl_z62restorezd2valuezd2typesz121307z70zzast_envz00(obj_t
		BgL_envz00_2276, obj_t BgL_valuez00_2277)
	{
		{	/* Ast/venv.scm 208 */
			{	/* Ast/venv.scm 208 */
				bool_t BgL_tmpz00_2830;

				{

					{	/* Ast/venv.scm 208 */
						obj_t BgL_nextzd2method1306zd2_2319;

						BgL_nextzd2method1306zd2_2319 =
							BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
							((BgL_objectz00_bglt)
								((BgL_cfunz00_bglt) BgL_valuez00_2277)),
							BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
							BGl_cfunz00zzast_varz00);
						PROCEDURE_ENTRY(BgL_nextzd2method1306zd2_2319)
							(BgL_nextzd2method1306zd2_2319,
							((obj_t) ((BgL_cfunz00_bglt) BgL_valuez00_2277)), BEOA);
					}
					{
						obj_t BgL_argsz00_2321;

						BgL_argsz00_2321 =
							(((BgL_cfunz00_bglt) COBJECT(
									((BgL_cfunz00_bglt) BgL_valuez00_2277)))->BgL_argszd2typezd2);
					BgL_loopz00_2320:
						if (PAIRP(BgL_argsz00_2321))
							{	/* Ast/venv.scm 212 */
								{	/* Ast/venv.scm 214 */
									BgL_typez00_bglt BgL_arg1789z00_2322;

									{	/* Ast/venv.scm 214 */
										obj_t BgL_arg1790z00_2323;

										BgL_arg1790z00_2323 =
											(((BgL_typez00_bglt) COBJECT(
													((BgL_typez00_bglt)
														CAR(BgL_argsz00_2321))))->BgL_idz00);
										BgL_arg1789z00_2322 =
											BGl_findzd2typezd2zztype_envz00(BgL_arg1790z00_2323);
									}
									{	/* Ast/venv.scm 214 */
										obj_t BgL_tmpz00_2846;

										BgL_tmpz00_2846 = ((obj_t) BgL_arg1789z00_2322);
										SET_CAR(BgL_argsz00_2321, BgL_tmpz00_2846);
									}
								}
								{
									obj_t BgL_argsz00_2849;

									BgL_argsz00_2849 = CDR(BgL_argsz00_2321);
									BgL_argsz00_2321 = BgL_argsz00_2849;
									goto BgL_loopz00_2320;
								}
							}
						else
							{	/* Ast/venv.scm 212 */
								BgL_tmpz00_2830 = ((bool_t) 0);
							}
					}
				}
				return BBOOL(BgL_tmpz00_2830);
			}
		}

	}



/* &restore-value-types!1305 */
	obj_t BGl_z62restorezd2valuezd2typesz121305z70zzast_envz00(obj_t
		BgL_envz00_2278, obj_t BgL_valuez00_2279)
	{
		{	/* Ast/venv.scm 201 */
			{

				{	/* Ast/venv.scm 201 */
					obj_t BgL_nextzd2method1304zd2_2326;

					BgL_nextzd2method1304zd2_2326 =
						BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
						((BgL_objectz00_bglt)
							((BgL_sfunz00_bglt) BgL_valuez00_2279)),
						BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
						BGl_isfunz00zzinline_inlinez00);
					PROCEDURE_ENTRY(BgL_nextzd2method1304zd2_2326)
						(BgL_nextzd2method1304zd2_2326,
						((obj_t) ((BgL_sfunz00_bglt) BgL_valuez00_2279)), BEOA);
				}
				{	/* Ast/venv.scm 203 */
					BgL_nodez00_bglt BgL_arg1785z00_2327;

					{
						BgL_isfunz00_bglt BgL_auxz00_2863;

						{
							obj_t BgL_auxz00_2864;

							{	/* Ast/venv.scm 203 */
								BgL_objectz00_bglt BgL_tmpz00_2865;

								BgL_tmpz00_2865 =
									((BgL_objectz00_bglt) ((BgL_sfunz00_bglt) BgL_valuez00_2279));
								BgL_auxz00_2864 = BGL_OBJECT_WIDENING(BgL_tmpz00_2865);
							}
							BgL_auxz00_2863 = ((BgL_isfunz00_bglt) BgL_auxz00_2864);
						}
						BgL_arg1785z00_2327 =
							(((BgL_isfunz00_bglt) COBJECT(BgL_auxz00_2863))->
							BgL_originalzd2bodyzd2);
					}
					return BGl_hrtypezd2nodez12zc0zzast_hrtypez00(BgL_arg1785z00_2327);
				}
			}
		}

	}



/* &restore-value-types!1303 */
	obj_t BGl_z62restorezd2valuezd2typesz121303z70zzast_envz00(obj_t
		BgL_envz00_2280, obj_t BgL_valuez00_2281)
	{
		{	/* Ast/venv.scm 167 */
			{

				{	/* Ast/venv.scm 167 */
					obj_t BgL_nextzd2method1302zd2_2330;

					BgL_nextzd2method1302zd2_2330 =
						BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
						((BgL_objectz00_bglt)
							((BgL_sfunz00_bglt) BgL_valuez00_2281)),
						BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
						BGl_sfunz00zzast_varz00);
					PROCEDURE_ENTRY(BgL_nextzd2method1302zd2_2330)
						(BgL_nextzd2method1302zd2_2330,
						((obj_t) ((BgL_sfunz00_bglt) BgL_valuez00_2281)), BEOA);
				}
				{
					obj_t BgL_argsz00_2332;

					BgL_argsz00_2332 =
						(((BgL_sfunz00_bglt) COBJECT(
								((BgL_sfunz00_bglt) BgL_valuez00_2281)))->BgL_argsz00);
				BgL_loopz00_2331:
					if (PAIRP(BgL_argsz00_2332))
						{	/* Ast/venv.scm 173 */
							obj_t BgL_argz00_2333;

							BgL_argz00_2333 = CAR(BgL_argsz00_2332);
							if (BGl_isazf3zf3zz__objectz00(BgL_argz00_2333,
									BGl_typez00zztype_typez00))
								{	/* Ast/venv.scm 176 */
									BgL_typez00_bglt BgL_arg1771z00_2334;

									{	/* Ast/venv.scm 176 */
										obj_t BgL_arg1772z00_2335;

										BgL_arg1772z00_2335 =
											(((BgL_typez00_bglt) COBJECT(
													((BgL_typez00_bglt) BgL_argz00_2333)))->BgL_idz00);
										BgL_arg1771z00_2334 =
											BGl_findzd2typezd2zztype_envz00(BgL_arg1772z00_2335);
									}
									{	/* Ast/venv.scm 176 */
										obj_t BgL_tmpz00_2889;

										BgL_tmpz00_2889 = ((obj_t) BgL_arg1771z00_2334);
										SET_CAR(BgL_argsz00_2332, BgL_tmpz00_2889);
									}
								}
							else
								{	/* Ast/venv.scm 175 */
									if (BGl_isazf3zf3zz__objectz00(BgL_argz00_2333,
											BGl_localz00zzast_varz00))
										{	/* Ast/venv.scm 178 */
											BgL_typez00_bglt BgL_newzd2typezd2_2336;

											{	/* Ast/venv.scm 178 */
												obj_t BgL_arg1774z00_2337;

												BgL_arg1774z00_2337 =
													(((BgL_typez00_bglt) COBJECT(
															(((BgL_variablez00_bglt) COBJECT(
																		((BgL_variablez00_bglt)
																			((BgL_localz00_bglt) BgL_argz00_2333))))->
																BgL_typez00)))->BgL_idz00);
												BgL_newzd2typezd2_2336 =
													BGl_findzd2typezd2zztype_envz00(BgL_arg1774z00_2337);
											}
											((((BgL_variablez00_bglt) COBJECT(
															((BgL_variablez00_bglt)
																((BgL_localz00_bglt) BgL_argz00_2333))))->
													BgL_typez00) =
												((BgL_typez00_bglt) BgL_newzd2typezd2_2336), BUNSPEC);
										}
									else
										{	/* Ast/venv.scm 177 */
											BGl_errorz00zz__errorz00(BGl_string1925z00zzast_envz00,
												BGl_string1926z00zzast_envz00,
												BGl_shapez00zztools_shapez00(BgL_argz00_2333));
										}
								}
							{
								obj_t BgL_argsz00_2904;

								BgL_argsz00_2904 = CDR(BgL_argsz00_2332);
								BgL_argsz00_2332 = BgL_argsz00_2904;
								goto BgL_loopz00_2331;
							}
						}
					else
						{	/* Ast/venv.scm 172 */
							if (NULLP(BgL_argsz00_2332))
								{	/* Ast/venv.scm 186 */
									obj_t BgL_bodyz00_2338;

									BgL_bodyz00_2338 =
										(((BgL_sfunz00_bglt) COBJECT(
												((BgL_sfunz00_bglt) BgL_valuez00_2281)))->BgL_bodyz00);
									if (BGl_isazf3zf3zz__objectz00(BgL_bodyz00_2338,
											BGl_nodez00zzast_nodez00))
										{	/* Ast/venv.scm 189 */
											BgL_typez00_bglt BgL_tresz00_2339;

											BgL_tresz00_2339 =
												(((BgL_nodez00_bglt) COBJECT(
														((BgL_nodez00_bglt) BgL_bodyz00_2338)))->
												BgL_typez00);
											BGl_hrtypezd2nodez12zc0zzast_hrtypez00(((BgL_nodez00_bglt)
													BgL_bodyz00_2338));
											{	/* Ast/venv.scm 192 */
												BgL_typez00_bglt BgL_arg1781z00_2340;

												BgL_arg1781z00_2340 =
													BGl_findzd2typezd2zztype_envz00(
													(((BgL_typez00_bglt) COBJECT(BgL_tresz00_2339))->
														BgL_idz00));
												return ((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
																	BgL_bodyz00_2338)))->BgL_typez00) =
													((BgL_typez00_bglt) BgL_arg1781z00_2340), BUNSPEC);
											}
										}
									else
										{	/* Ast/venv.scm 188 */
											return BFALSE;
										}
								}
							else
								{	/* Ast/venv.scm 185 */
									return
										BGl_errorz00zz__errorz00(BGl_string1927z00zzast_envz00,
										BGl_string1928z00zzast_envz00,
										BGl_shapez00zztools_shapez00(BgL_argsz00_2332));
								}
						}
				}
			}
		}

	}



/* &restore-value-types!1301 */
	obj_t BGl_z62restorezd2valuezd2typesz121301z70zzast_envz00(obj_t
		BgL_envz00_2282, obj_t BgL_valuez00_2283)
	{
		{	/* Ast/venv.scm 159 */
			{	/* Ast/venv.scm 161 */
				bool_t BgL_test2028z00_2924;

				{	/* Ast/venv.scm 161 */
					obj_t BgL_arg1765z00_2342;

					BgL_arg1765z00_2342 =
						(((BgL_funz00_bglt) COBJECT(
								((BgL_funz00_bglt) BgL_valuez00_2283)))->BgL_predicatezd2ofzd2);
					BgL_test2028z00_2924 =
						BGl_isazf3zf3zz__objectz00(BgL_arg1765z00_2342,
						BGl_typez00zztype_typez00);
				}
				if (BgL_test2028z00_2924)
					{
						obj_t BgL_auxz00_2928;

						{	/* Ast/venv.scm 162 */
							obj_t BgL_arg1762z00_2343;

							BgL_arg1762z00_2343 =
								(((BgL_typez00_bglt) COBJECT(
										((BgL_typez00_bglt)
											(((BgL_funz00_bglt) COBJECT(
														((BgL_funz00_bglt) BgL_valuez00_2283)))->
												BgL_predicatezd2ofzd2))))->BgL_idz00);
							BgL_auxz00_2928 =
								((obj_t) BGl_findzd2typezd2zztype_envz00(BgL_arg1762z00_2343));
						}
						return
							((((BgL_funz00_bglt) COBJECT(
										((BgL_funz00_bglt) BgL_valuez00_2283)))->
								BgL_predicatezd2ofzd2) = ((obj_t) BgL_auxz00_2928), BUNSPEC);
					}
				else
					{	/* Ast/venv.scm 161 */
						return BFALSE;
					}
			}
		}

	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzast_envz00()
	{
		{	/* Ast/venv.scm 14 */
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 365925558),
				BSTRING_TO_STRING(BGl_string1929z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 476633989),
				BSTRING_TO_STRING(BGl_string1929z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 300504031),
				BSTRING_TO_STRING(BGl_string1929z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 515343395),
				BSTRING_TO_STRING(BGl_string1929z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 346491734),
				BSTRING_TO_STRING(BGl_string1929z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zztype_envz00(((long) 296457443),
				BSTRING_TO_STRING(BGl_string1929z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 90839984),
				BSTRING_TO_STRING(BGl_string1929z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 506185397),
				BSTRING_TO_STRING(BGl_string1929z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zzast_hrtypez00(((long) 156957722),
				BSTRING_TO_STRING(BGl_string1929z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zzast_dumpz00(((long) 271707717),
				BSTRING_TO_STRING(BGl_string1929z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zzread_jvmz00(((long) 261574382),
				BSTRING_TO_STRING(BGl_string1929z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zzmodule_modulez00(((long) 158397907),
				BSTRING_TO_STRING(BGl_string1929z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zztools_locationz00(((long) 462333240),
				BSTRING_TO_STRING(BGl_string1929z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zzbackend_backendz00(((long) 216206620),
				BSTRING_TO_STRING(BGl_string1929z00zzast_envz00));
			return
				BGl_modulezd2initializa7ationz75zzinline_inlinez00(((long) 20504962),
				BSTRING_TO_STRING(BGl_string1929z00zzast_envz00));
		}

	}

#ifdef __cplusplus
}
#endif
