/*===========================================================================*/
/*   (Coerce/convert.scm)                                                    */
/*   Bigloo (4.3g)                                                           */
/*   Inria -- Sophia Antipolis (c)       Wed 12 Feb 2020 07:45:41 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.3g -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Coerce/convert.scm) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		bool_t BgL_evalzf3zf3;
		obj_t BgL_libraryz00;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
		obj_t BgL_initz00;
		obj_t BgL_aliasz00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_localz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		long BgL_keyz00;
	}               *BgL_localz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_nodezf2effectzf2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
	}                       *BgL_nodezf2effectzf2_bglt;

	typedef struct BgL_atomz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}              *BgL_atomz00_bglt;

	typedef struct BgL_literalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}                 *BgL_literalz00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
		bool_t BgL_unsafez00;
		obj_t BgL_metaz00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_castz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}              *BgL_castz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;

	typedef struct BgL_tclassz00_bgl
	{
		obj_t BgL_itszd2superzd2;
		obj_t BgL_slotsz00;
		struct BgL_globalz00_bgl *BgL_holderz00;
		obj_t BgL_wideningz00;
		long BgL_depthz00;
		bool_t BgL_finalzf3zf3;
		obj_t BgL_constructorz00;
		obj_t BgL_virtualzd2slotszd2numberz00;
		bool_t BgL_abstractzf3zf3;
		obj_t BgL_widezd2typezd2;
		obj_t BgL_subclassesz00;
	}                *BgL_tclassz00_bglt;


	extern obj_t BGl_za2uint32za2z00zztype_cachez00;
	extern obj_t BGl_za2uint16za2z00zztype_cachez00;
	BGL_IMPORT obj_t BGl_warningz00zz__errorz00(obj_t);
	static BgL_nodez00_bglt BGl_dozd2convertzd2zzcoerce_convertz00(obj_t,
		BgL_nodez00_bglt, BgL_typez00_bglt);
	extern obj_t BGl_sequencez00zzast_nodez00;
	BGL_EXPORTED_DECL obj_t BGl_getzd2stackzd2checkz00zzcoerce_convertz00();
	static obj_t BGl_notifyzd2typezd2testz00zzcoerce_convertz00(obj_t, obj_t,
		obj_t);
	static long BGl_za2notifyzd2counterza2zd2zzcoerce_convertz00;
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	static obj_t BGl_objectzd2initzd2zzcoerce_convertz00();
	BGL_IMPORT obj_t BGl_warningzf2locationzf2zz__errorz00(obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t bstring_to_symbol(obj_t);
	static obj_t BGl_notifiedzd2locationszd2zzcoerce_convertz00 = BUNSPEC;
	extern obj_t BGl_za2stringza2z00zztype_cachez00;
	BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	static obj_t BGl_methodzd2initzd2zzcoerce_convertz00();
	static obj_t BGl_z62runtimezd2typezd2errorz62zzcoerce_convertz00(obj_t, obj_t,
		obj_t, obj_t);
	extern BgL_typez00_bglt
		BGl_strictzd2nodezd2typez00zzast_nodez00(BgL_typez00_bglt,
		BgL_typez00_bglt);
	extern obj_t BGl_za2int32za2z00zztype_cachez00;
	extern obj_t BGl_za2int16za2z00zztype_cachez00;
	extern obj_t BGl_za2uint8za2z00zztype_cachez00;
	extern obj_t BGl_za2objza2z00zztype_cachez00;
	extern obj_t BGl_findzd2coercerzd2zztype_coercionz00(BgL_typez00_bglt,
		BgL_typez00_bglt);
	extern obj_t BGl_za2scharza2z00zztype_cachez00;
	extern BgL_nodez00_bglt BGl_coercez12z12zzcoerce_coercez00(BgL_nodez00_bglt,
		obj_t, BgL_typez00_bglt, bool_t);
	static BgL_nodez00_bglt BGl_z62convertz12z70zzcoerce_convertz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_za2elongza2z00zztype_cachez00;
	extern bool_t BGl_typezd2subclasszf3z21zzobject_classz00(BgL_typez00_bglt,
		BgL_typez00_bglt);
	extern obj_t BGl_za2int8za2z00zztype_cachez00;
	static obj_t BGl_runtimezd2typezd2errorzf2idzf2zzcoerce_convertz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_gczd2rootszd2initz00zzcoerce_convertz00();
	BGL_IMPORT obj_t BGl_bigloozd2typezd2errorzd2msgzd2zz__errorz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_currentzd2functionzd2zztools_errorz00();
	extern obj_t BGl_userzd2warningzf2locationz20zztools_errorz00(obj_t, obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_runtimezd2typezd2errorz00zzcoerce_convertz00(obj_t, obj_t,
		BgL_nodez00_bglt);
	BGL_IMPORT obj_t BGl_gensymz00zz__r4_symbols_6_4z00(obj_t);
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_convertz12z12zzcoerce_convertz00(BgL_nodez00_bglt, BgL_typez00_bglt,
		BgL_typez00_bglt, bool_t);
	extern bool_t
		BGl_spreadzd2sidezd2effectz12z12zzeffect_spreadz00(BgL_nodez00_bglt);
	BGL_IMPORT obj_t
		BGl_bigloozd2tracezd2stackzd2depthzd2setz12z12zz__paramz00(int);
	extern obj_t BGl_za2warningzd2typezd2errorza2z00zzengine_paramz00;
	extern obj_t BGl_za2charza2z00zztype_cachez00;
	extern obj_t BGl_za2intza2z00zztype_cachez00;
	extern obj_t BGl_locationzd2fullzd2fnamez00zztools_locationz00(obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzcoerce_convertz00 = BUNSPEC;
	extern obj_t BGl_makezd2typedzd2identz00zzast_identz00(obj_t, obj_t);
	extern obj_t BGl_userzd2errorzf2locationz20zztools_errorz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_tclassz00zzobject_classz00;
	static obj_t BGl_toplevelzd2initzd2zzcoerce_convertz00();
	BGL_IMPORT obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
	static obj_t BGl_z62getzd2stackzd2checkz62zzcoerce_convertz00(obj_t);
	extern obj_t BGl_internalzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_lvtypezd2nodez12zc0zzast_lvtypez00(BgL_nodez00_bglt);
	static obj_t BGl_genericzd2initzd2zzcoerce_convertz00();
	BGL_IMPORT obj_t BGl_stringzd2copyzd2zz__r4_strings_6_7z00(obj_t);
	static BgL_nodez00_bglt
		BGl_makezd2onezd2conversionz00zzcoerce_convertz00(obj_t, obj_t, obj_t,
		obj_t, BgL_nodez00_bglt, bool_t);
	extern obj_t BGl_za2boolza2z00zztype_cachez00;
	extern obj_t BGl_castz00zzast_nodez00;
	static BgL_nodez00_bglt
		BGl_makezd2onezd2typezd2conversionzd2zzcoerce_convertz00(obj_t, obj_t,
		obj_t, obj_t, BgL_nodez00_bglt);
	extern obj_t BGl_shapez00zztools_shapez00(obj_t);
	extern obj_t BGl_za2longza2z00zztype_cachez00;
	static long BGl_za2checkza2z00zzcoerce_convertz00;
	extern bool_t BGl_subzd2typezf3z21zztype_envz00(BgL_typez00_bglt,
		BgL_typez00_bglt);
	extern obj_t BGl_za2uint64za2z00zztype_cachez00;
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	extern obj_t BGl_za2warningzd2typesza2zd2zzengine_paramz00;
	BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_convertzd2errorzd2zzcoerce_convertz00(BgL_typez00_bglt,
		BgL_typez00_bglt, obj_t, BgL_nodez00_bglt);
	static BgL_nodez00_bglt
		BGl_makezd2onezd2classzd2conversionzd2zzcoerce_convertz00(BgL_typez00_bglt,
		obj_t, obj_t, obj_t, BgL_nodez00_bglt);
	extern BgL_nodez00_bglt
		BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00(obj_t, obj_t);
	extern obj_t BGl_za2realza2z00zztype_cachez00;
	BGL_IMPORT obj_t string_append(obj_t, obj_t);
	extern obj_t BGl_varz00zzast_nodez00;
	BGL_EXPORTED_DEF obj_t BGl_za2notifyzd2typezd2testza2z00zzcoerce_convertz00 =
		BUNSPEC;
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zzcoerce_convertz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzeffect_spreadz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcoerce_coercez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzobject_classz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_dumpz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_lvtypez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_identz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_sexpz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_coercionz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_miscz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_locationz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_backendz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__structurez00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
	static obj_t BGl_cnstzd2initzd2zzcoerce_convertz00();
	static obj_t BGl_libraryzd2moduleszd2initz00zzcoerce_convertz00();
	static obj_t BGl_importedzd2moduleszd2initz00zzcoerce_convertz00();
	extern obj_t BGl_za2llongza2z00zztype_cachez00;
	extern obj_t BGl_za2int64za2z00zztype_cachez00;
	static BgL_nodez00_bglt
		BGl_skipzd2letzd2varz00zzcoerce_convertz00(BgL_nodez00_bglt);
	extern obj_t BGl_literalz00zzast_nodez00;
	extern obj_t BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00(obj_t);
	BGL_IMPORT int BGl_bigloozd2tracezd2stackzd2depthzd2zz__paramz00();
	extern BgL_typez00_bglt
		BGl_getzd2aliasedzd2typez00zztype_typez00(BgL_typez00_bglt);
	BGL_IMPORT obj_t BGl_memberz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	static obj_t __cnst[11];


	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_convertz12zd2envzc0zzcoerce_convertz00,
		BgL_bgl_za762convertza712za7702023za7,
		BGl_z62convertz12z70zzcoerce_convertz00, 0L, BUNSPEC, 4);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_getzd2stackzd2checkzd2envzd2zzcoerce_convertz00,
		BgL_bgl_za762getza7d2stackza7d2024za7,
		BGl_z62getzd2stackzd2checkz62zzcoerce_convertz00, 0L, BUNSPEC, 0);
	      DEFINE_STRING(BGl_string2013z00zzcoerce_convertz00,
		BgL_bgl_string2013za700za7za7c2025za7,
		" ~a. Type test inserted \"~a\" -> \"~a\"", 36);
	      DEFINE_STRING(BGl_string2014z00zzcoerce_convertz00,
		BgL_bgl_string2014za700za7za7c2026za7, "", 0);
	      DEFINE_STRING(BGl_string2015z00zzcoerce_convertz00,
		BgL_bgl_string2015za700za7za7c2027za7, "Type error", 10);
	      DEFINE_STRING(BGl_string2017z00zzcoerce_convertz00,
		BgL_bgl_string2017za700za7za7c2028za7, "Illegal conversion", 18);
	      DEFINE_STRING(BGl_string2018z00zzcoerce_convertz00,
		BgL_bgl_string2018za700za7za7c2029za7, "coerce_convert", 14);
	      DEFINE_STRING(BGl_string2019z00zzcoerce_convertz00,
		BgL_bgl_string2019za700za7za7c2030za7,
		"aux2 if coercer let ::obj aux failure @ type-error __error location ", 68);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_runtimezd2typezd2errorzd2envzd2zzcoerce_convertz00,
		BgL_bgl_za762runtimeza7d2typ2031z00,
		BGl_z62runtimezd2typezd2errorz62zzcoerce_convertz00, 0L, BUNSPEC, 3);
	      DEFINE_REAL(BGl_real2016z00zzcoerce_convertz00,
		BgL_bgl_real2016za700za7za7coe2032za7, 0.0);

/* GC roots registration */
	static obj_t bgl_gc_roots_register()
	{
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
		void *roots_min = (void *) ULONG_MAX, *roots_max = 0;
		     ADD_ROOT((void *) (&BGl_notifiedzd2locationszd2zzcoerce_convertz00));
		   
			 ADD_ROOT((void
				*) (&BGl_requirezd2initializa7ationz75zzcoerce_convertz00));
		     ADD_ROOT((void
				*) (&BGl_za2notifyzd2typezd2testza2z00zzcoerce_convertz00));
#undef ADD_ROOT
		if   (roots_max > 0)
			     GC_add_roots(roots_min, ((void **) roots_max) + 1);
#endif
		     return BUNSPEC;
	}



/* module-initialization */
	BGL_EXPORTED_DEF obj_t
		BGl_modulezd2initializa7ationz75zzcoerce_convertz00(long
		BgL_checksumz00_2564, char *BgL_fromz00_2565)
	{
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzcoerce_convertz00))
				{
					BGl_requirezd2initializa7ationz75zzcoerce_convertz00 =
						BBOOL(((bool_t) 0));
					BGl_gczd2rootszd2initz00zzcoerce_convertz00();
					BGl_libraryzd2moduleszd2initz00zzcoerce_convertz00();
					BGl_cnstzd2initzd2zzcoerce_convertz00();
					BGl_importedzd2moduleszd2initz00zzcoerce_convertz00();
					return BGl_toplevelzd2initzd2zzcoerce_convertz00();
				}
			else
				{
					return BUNSPEC;
				}
		}

	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzcoerce_convertz00()
	{
		{	/* Coerce/convert.scm 16 */
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0),
				"coerce_convert");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0),
				"coerce_convert");
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 0),
				"coerce_convert");
			BGl_modulezd2initializa7ationz75zz__paramz00(((long) 0),
				"coerce_convert");
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long) 0),
				"coerce_convert");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"coerce_convert");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0),
				"coerce_convert");
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 0),
				"coerce_convert");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"coerce_convert");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long) 0),
				"coerce_convert");
			BGl_modulezd2initializa7ationz75zz__structurez00(((long) 0),
				"coerce_convert");
			BGl_modulezd2initializa7ationz75zz__biglooz00(((long) 0),
				"coerce_convert");
			return BUNSPEC;
		}

	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzcoerce_convertz00()
	{
		{	/* Coerce/convert.scm 16 */
			{	/* Coerce/convert.scm 16 */
				obj_t BgL_cportz00_2551;

				{	/* Coerce/convert.scm 16 */
					obj_t BgL_stringz00_2559;

					BgL_stringz00_2559 = BGl_string2019z00zzcoerce_convertz00;
					{	/* Coerce/convert.scm 16 */
						obj_t BgL_startz00_2560;

						BgL_startz00_2560 = BINT(((long) 0));
						{	/* Coerce/convert.scm 16 */
							obj_t BgL_endz00_2561;

							BgL_endz00_2561 =
								BINT(STRING_LENGTH(((obj_t) BgL_stringz00_2559)));
							{	/* Coerce/convert.scm 16 */

								BgL_cportz00_2551 =
									BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00
									(BgL_stringz00_2559, BgL_startz00_2560, BgL_endz00_2561);
				}}}}
				{
					long BgL_iz00_2552;

					BgL_iz00_2552 = ((long) 10);
				BgL_loopz00_2553:
					if ((BgL_iz00_2552 == ((long) -1)))
						{	/* Coerce/convert.scm 16 */
							return BUNSPEC;
						}
					else
						{	/* Coerce/convert.scm 16 */
							{	/* Coerce/convert.scm 16 */
								obj_t BgL_arg2021z00_2555;

								{	/* Coerce/convert.scm 16 */

									{	/* Coerce/convert.scm 16 */
										obj_t BgL_locationz00_2557;

										BgL_locationz00_2557 = BBOOL(((bool_t) 0));
										{	/* Coerce/convert.scm 16 */

											BgL_arg2021z00_2555 =
												BGl_readz00zz__readerz00(BgL_cportz00_2551,
												BgL_locationz00_2557);
										}
									}
								}
								{	/* Coerce/convert.scm 16 */
									int BgL_tmpz00_2595;

									BgL_tmpz00_2595 = (int) (BgL_iz00_2552);
									CNST_TABLE_SET(BgL_tmpz00_2595, BgL_arg2021z00_2555);
							}}
							{	/* Coerce/convert.scm 16 */
								int BgL_auxz00_2558;

								BgL_auxz00_2558 = (int) ((BgL_iz00_2552 - ((long) 1)));
								{
									long BgL_iz00_2600;

									BgL_iz00_2600 = (long) (BgL_auxz00_2558);
									BgL_iz00_2552 = BgL_iz00_2600;
									goto BgL_loopz00_2553;
								}
							}
						}
				}
			}
		}

	}



/* gc-roots-init */
	obj_t BGl_gczd2rootszd2initz00zzcoerce_convertz00()
	{
		{	/* Coerce/convert.scm 16 */
			return bgl_gc_roots_register();
		}

	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzcoerce_convertz00()
	{
		{	/* Coerce/convert.scm 16 */
			BGl_za2checkza2z00zzcoerce_convertz00 = ((long) 0);
			BGl_notifiedzd2locationszd2zzcoerce_convertz00 = BNIL;
			BGl_za2notifyzd2typezd2testza2z00zzcoerce_convertz00 = BTRUE;
			return (BGl_za2notifyzd2counterza2zd2zzcoerce_convertz00 =
				((long) 0), BUNSPEC);
		}

	}



/* notify-type-test */
	obj_t BGl_notifyzd2typezd2testz00zzcoerce_convertz00(obj_t BgL_fromz00_35,
		obj_t BgL_toz00_36, obj_t BgL_locz00_37)
	{
		{	/* Coerce/convert.scm 59 */
			if (CBOOL(BGl_za2notifyzd2typezd2testza2z00zzcoerce_convertz00))
				{	/* Coerce/convert.scm 61 */
					int BgL_stz00_1705;

					BgL_stz00_1705 = BGl_bigloozd2tracezd2stackzd2depthzd2zz__paramz00();
					BGl_bigloozd2tracezd2stackzd2depthzd2setz12z12zz__paramz00(
						(int) (((long) 0)));
					if (CBOOL(BgL_locz00_37))
						{	/* Coerce/convert.scm 64 */
							if (CBOOL(BGl_memberz00zz__r4_pairs_and_lists_6_3z00
									(BgL_locz00_37,
										BGl_notifiedzd2locationszd2zzcoerce_convertz00)))
								{	/* Coerce/convert.scm 69 */
									BFALSE;
								}
							else
								{	/* Coerce/convert.scm 69 */
									BGl_za2notifyzd2counterza2zd2zzcoerce_convertz00 =
										(((long) 1) +
										BGl_za2notifyzd2counterza2zd2zzcoerce_convertz00);
									BGl_notifiedzd2locationszd2zzcoerce_convertz00 =
										MAKE_YOUNG_PAIR(BgL_locz00_37,
										BGl_notifiedzd2locationszd2zzcoerce_convertz00);
									{	/* Coerce/convert.scm 72 */
										obj_t BgL_arg1467z00_1707;
										obj_t BgL_arg1470z00_1708;
										obj_t BgL_arg1486z00_1709;

										BgL_arg1467z00_1707 =
											BGl_locationzd2fullzd2fnamez00zztools_locationz00
											(BgL_locz00_37);
										BgL_arg1470z00_1708 =
											STRUCT_REF(((obj_t) BgL_locz00_37), (int) (((long) 1)));
										{	/* Coerce/convert.scm 75 */
											obj_t BgL_arg1488z00_1711;
											obj_t BgL_arg1489z00_1712;

											BgL_arg1488z00_1711 =
												BGl_shapez00zztools_shapez00(BgL_fromz00_35);
											BgL_arg1489z00_1712 =
												BGl_shapez00zztools_shapez00(BgL_toz00_36);
											{	/* Coerce/convert.scm 74 */
												obj_t BgL_list1490z00_1713;

												{	/* Coerce/convert.scm 74 */
													obj_t BgL_arg1493z00_1714;

													{	/* Coerce/convert.scm 74 */
														obj_t BgL_arg1495z00_1715;

														BgL_arg1495z00_1715 =
															MAKE_YOUNG_PAIR(BgL_arg1489z00_1712, BNIL);
														BgL_arg1493z00_1714 =
															MAKE_YOUNG_PAIR(BgL_arg1488z00_1711,
															BgL_arg1495z00_1715);
													}
													BgL_list1490z00_1713 =
														MAKE_YOUNG_PAIR(BINT
														(BGl_za2notifyzd2counterza2zd2zzcoerce_convertz00),
														BgL_arg1493z00_1714);
												}
												BgL_arg1486z00_1709 =
													BGl_formatz00zz__r4_output_6_10_3z00
													(BGl_string2013z00zzcoerce_convertz00,
													BgL_list1490z00_1713);
										}}
										{	/* Coerce/convert.scm 72 */
											obj_t BgL_list1487z00_1710;

											BgL_list1487z00_1710 =
												MAKE_YOUNG_PAIR(BgL_arg1486z00_1709, BNIL);
											BGl_warningzf2locationzf2zz__errorz00(BgL_arg1467z00_1707,
												BgL_arg1470z00_1708, BgL_list1487z00_1710);
						}}}}
					else
						{	/* Coerce/convert.scm 64 */
							BGl_za2notifyzd2counterza2zd2zzcoerce_convertz00 =
								(((long) 1) + BGl_za2notifyzd2counterza2zd2zzcoerce_convertz00);
							{	/* Coerce/convert.scm 68 */
								obj_t BgL_arg1499z00_1716;

								{	/* Coerce/convert.scm 68 */
									obj_t BgL_arg1506z00_1718;
									obj_t BgL_arg1507z00_1719;

									BgL_arg1506z00_1718 =
										BGl_shapez00zztools_shapez00(BgL_fromz00_35);
									BgL_arg1507z00_1719 =
										BGl_shapez00zztools_shapez00(BgL_toz00_36);
									{	/* Coerce/convert.scm 67 */
										obj_t BgL_list1508z00_1720;

										{	/* Coerce/convert.scm 67 */
											obj_t BgL_arg1511z00_1721;

											{	/* Coerce/convert.scm 67 */
												obj_t BgL_arg1514z00_1722;

												BgL_arg1514z00_1722 =
													MAKE_YOUNG_PAIR(BgL_arg1507z00_1719, BNIL);
												BgL_arg1511z00_1721 =
													MAKE_YOUNG_PAIR(BgL_arg1506z00_1718,
													BgL_arg1514z00_1722);
											}
											BgL_list1508z00_1720 =
												MAKE_YOUNG_PAIR(BINT
												(BGl_za2notifyzd2counterza2zd2zzcoerce_convertz00),
												BgL_arg1511z00_1721);
										}
										BgL_arg1499z00_1716 =
											BGl_formatz00zz__r4_output_6_10_3z00
											(BGl_string2013z00zzcoerce_convertz00,
											BgL_list1508z00_1720);
								}}
								{	/* Coerce/convert.scm 66 */
									obj_t BgL_list1500z00_1717;

									BgL_list1500z00_1717 =
										MAKE_YOUNG_PAIR(BgL_arg1499z00_1716, BNIL);
									BGl_warningz00zz__errorz00(BgL_list1500z00_1717);
						}}}
					return
						BGl_bigloozd2tracezd2stackzd2depthzd2setz12z12zz__paramz00
						(BgL_stz00_1705);
				}
			else
				{	/* Coerce/convert.scm 60 */
					return BFALSE;
				}
		}

	}



/* get-stack-check */
	BGL_EXPORTED_DEF obj_t BGl_getzd2stackzd2checkz00zzcoerce_convertz00()
	{
		{	/* Coerce/convert.scm 88 */
			return BINT(BGl_za2checkza2z00zzcoerce_convertz00);
		}

	}



/* &get-stack-check */
	obj_t BGl_z62getzd2stackzd2checkz62zzcoerce_convertz00(obj_t BgL_envz00_2539)
	{
		{	/* Coerce/convert.scm 88 */
			return BGl_getzd2stackzd2checkz00zzcoerce_convertz00();
		}

	}



/* runtime-type-error/id */
	obj_t BGl_runtimezd2typezd2errorzf2idzf2zzcoerce_convertz00(obj_t
		BgL_locz00_49, obj_t BgL_tiz00_50, obj_t BgL_idz00_51)
	{
		{	/* Coerce/convert.scm 114 */
			{	/* Coerce/convert.scm 116 */
				obj_t BgL_fnamez00_1730;
				obj_t BgL_posz00_1731;

				{	/* Coerce/convert.scm 116 */
					bool_t BgL_test2038z00_2641;

					if (STRUCTP(BgL_locz00_49))
						{	/* Coerce/convert.scm 116 */
							BgL_test2038z00_2641 =
								(STRUCT_KEY(BgL_locz00_49) == CNST_TABLE_REF(((long) 0)));
						}
					else
						{	/* Coerce/convert.scm 116 */
							BgL_test2038z00_2641 = ((bool_t) 0);
						}
					if (BgL_test2038z00_2641)
						{	/* Coerce/convert.scm 116 */
							BgL_fnamez00_1730 =
								BGl_locationzd2fullzd2fnamez00zztools_locationz00
								(BgL_locz00_49);
						}
					else
						{	/* Coerce/convert.scm 116 */
							BgL_fnamez00_1730 = BFALSE;
						}
				}
				{	/* Coerce/convert.scm 117 */
					bool_t BgL_test2040z00_2648;

					if (STRUCTP(BgL_locz00_49))
						{	/* Coerce/convert.scm 117 */
							BgL_test2040z00_2648 =
								(STRUCT_KEY(BgL_locz00_49) == CNST_TABLE_REF(((long) 0)));
						}
					else
						{	/* Coerce/convert.scm 117 */
							BgL_test2040z00_2648 = ((bool_t) 0);
						}
					if (BgL_test2040z00_2648)
						{	/* Coerce/convert.scm 117 */
							BgL_posz00_1731 = STRUCT_REF(BgL_locz00_49, (int) (((long) 1)));
						}
					else
						{	/* Coerce/convert.scm 117 */
							BgL_posz00_1731 = BFALSE;
						}
				}
				{	/* Coerce/convert.scm 119 */
					obj_t BgL_arg1541z00_1732;

					{	/* Coerce/convert.scm 119 */
						obj_t BgL_arg1544z00_1733;
						obj_t BgL_arg1550z00_1734;

						{	/* Coerce/convert.scm 119 */
							obj_t BgL_arg1554z00_1735;
							obj_t BgL_arg1558z00_1736;

							{	/* Coerce/convert.scm 119 */
								obj_t BgL_arg1559z00_1737;

								{	/* Coerce/convert.scm 119 */
									obj_t BgL_arg1563z00_1738;

									BgL_arg1563z00_1738 =
										MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 1)), BNIL);
									BgL_arg1559z00_1737 =
										MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 2)),
										BgL_arg1563z00_1738);
								}
								BgL_arg1554z00_1735 =
									MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 3)),
									BgL_arg1559z00_1737);
							}
							{	/* Coerce/convert.scm 120 */
								obj_t BgL_arg1564z00_1739;

								{	/* Coerce/convert.scm 120 */
									obj_t BgL_arg1568z00_1740;

									{	/* Coerce/convert.scm 120 */
										obj_t BgL_arg1573z00_1741;
										obj_t BgL_arg1574z00_1742;

										{	/* Coerce/convert.scm 120 */
											obj_t BgL_arg1578z00_1743;

											BgL_arg1578z00_1743 =
												BGl_currentzd2functionzd2zztools_errorz00();
											{	/* Coerce/convert.scm 120 */
												obj_t BgL_res1967z00_2303;

												{	/* Coerce/convert.scm 120 */
													obj_t BgL_arg1409z00_2302;

													BgL_arg1409z00_2302 =
														SYMBOL_TO_STRING(((obj_t) BgL_arg1578z00_1743));
													BgL_res1967z00_2303 =
														BGl_stringzd2copyzd2zz__r4_strings_6_7z00
														(BgL_arg1409z00_2302);
												}
												BgL_arg1573z00_1741 = BgL_res1967z00_2303;
										}}
										{	/* Coerce/convert.scm 121 */
											obj_t BgL_arg1579z00_1744;
											obj_t BgL_arg1585z00_1745;

											{	/* Coerce/convert.scm 121 */
												obj_t BgL_res1968z00_2306;

												{	/* Coerce/convert.scm 121 */
													obj_t BgL_arg1409z00_2305;

													BgL_arg1409z00_2305 =
														SYMBOL_TO_STRING(((obj_t) BgL_tiz00_50));
													BgL_res1968z00_2306 =
														BGl_stringzd2copyzd2zz__r4_strings_6_7z00
														(BgL_arg1409z00_2305);
												}
												BgL_arg1579z00_1744 = BgL_res1968z00_2306;
											}
											BgL_arg1585z00_1745 = MAKE_YOUNG_PAIR(BgL_idz00_51, BNIL);
											BgL_arg1574z00_1742 =
												MAKE_YOUNG_PAIR(BgL_arg1579z00_1744,
												BgL_arg1585z00_1745);
										}
										BgL_arg1568z00_1740 =
											MAKE_YOUNG_PAIR(BgL_arg1573z00_1741, BgL_arg1574z00_1742);
									}
									BgL_arg1564z00_1739 =
										MAKE_YOUNG_PAIR(BgL_posz00_1731, BgL_arg1568z00_1740);
								}
								BgL_arg1558z00_1736 =
									MAKE_YOUNG_PAIR(BgL_fnamez00_1730, BgL_arg1564z00_1739);
							}
							BgL_arg1544z00_1733 =
								MAKE_YOUNG_PAIR(BgL_arg1554z00_1735, BgL_arg1558z00_1736);
						}
						{	/* Coerce/convert.scm 118 */
							obj_t BgL_arg1590z00_1746;

							BgL_arg1590z00_1746 = MAKE_YOUNG_PAIR(BFALSE, BNIL);
							BgL_arg1550z00_1734 =
								MAKE_YOUNG_PAIR(BFALSE, BgL_arg1590z00_1746);
						}
						BgL_arg1541z00_1732 =
							MAKE_YOUNG_PAIR(BgL_arg1544z00_1733, BgL_arg1550z00_1734);
					}
					return
						MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 4)), BgL_arg1541z00_1732);
		}}}

	}



/* runtime-type-error */
	BGL_EXPORTED_DEF obj_t BGl_runtimezd2typezd2errorz00zzcoerce_convertz00(obj_t
		BgL_locz00_52, obj_t BgL_tiz00_53, BgL_nodez00_bglt BgL_valuez00_54)
	{
		{	/* Coerce/convert.scm 128 */
			{	/* Coerce/convert.scm 130 */
				obj_t BgL_auxz00_1749;

				BgL_auxz00_1749 =
					BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 5)));
				{	/* Coerce/convert.scm 130 */
					BgL_nodez00_bglt BgL_uvaluez00_1750;

					{	/* Coerce/convert.scm 131 */
						bool_t BgL_test2042z00_2682;

						{	/* Coerce/convert.scm 131 */
							bool_t BgL_res1969z00_2307;

							BgL_res1969z00_2307 =
								BGl_isazf3zf3zz__objectz00(
								((obj_t) BgL_valuez00_54), BGl_varz00zzast_nodez00);
							BgL_test2042z00_2682 = BgL_res1969z00_2307;
						}
						if (BgL_test2042z00_2682)
							{	/* Coerce/convert.scm 132 */
								BgL_nodez00_bglt BgL_duplicated1110z00_1767;
								BgL_varz00_bglt BgL_new1108z00_1768;

								BgL_duplicated1110z00_1767 = BgL_valuez00_54;
								{	/* Coerce/convert.scm 132 */
									BgL_varz00_bglt BgL_new1112z00_1770;

									BgL_new1112z00_1770 =
										((BgL_varz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
													BgL_varz00_bgl))));
									{	/* Coerce/convert.scm 132 */
										long BgL_arg1641z00_1771;

										{	/* Coerce/convert.scm 132 */
											long BgL_res1970z00_2309;

											BgL_res1970z00_2309 =
												BGL_CLASS_INDEX(BGl_varz00zzast_nodez00);
											BgL_arg1641z00_1771 = BgL_res1970z00_2309;
										}
										BGL_OBJECT_CLASS_NUM_SET(
											((BgL_objectz00_bglt) BgL_new1112z00_1770),
											BgL_arg1641z00_1771);
									}
									BgL_new1108z00_1768 = BgL_new1112z00_1770;
								}
								((((BgL_nodez00_bglt) COBJECT(
												((BgL_nodez00_bglt) BgL_new1108z00_1768)))->
										BgL_locz00) =
									((obj_t) (((BgL_nodez00_bglt)
												COBJECT(BgL_duplicated1110z00_1767))->BgL_locz00)),
									BUNSPEC);
								((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
													BgL_new1108z00_1768)))->BgL_typez00) =
									((BgL_typez00_bglt) ((BgL_typez00_bglt)
											BGl_za2objza2z00zztype_cachez00)), BUNSPEC);
								((((BgL_varz00_bglt) COBJECT(BgL_new1108z00_1768))->
										BgL_variablez00) =
									((BgL_variablez00_bglt) (((BgL_varz00_bglt)
												COBJECT(((BgL_varz00_bglt)
														BgL_duplicated1110z00_1767)))->BgL_variablez00)),
									BUNSPEC);
								BgL_uvaluez00_1750 = ((BgL_nodez00_bglt) BgL_new1108z00_1768);
							}
						else
							{	/* Coerce/convert.scm 131 */
								BgL_uvaluez00_1750 = BgL_valuez00_54;
							}
					}
					{	/* Coerce/convert.scm 131 */
						BgL_nodez00_bglt BgL_resz00_1751;

						{	/* Coerce/convert.scm 136 */
							obj_t BgL_arg1602z00_1754;

							{	/* Coerce/convert.scm 136 */
								obj_t BgL_arg1609z00_1755;

								{	/* Coerce/convert.scm 136 */
									obj_t BgL_arg1613z00_1756;
									obj_t BgL_arg1618z00_1757;

									{	/* Coerce/convert.scm 136 */
										obj_t BgL_arg1626z00_1758;

										{	/* Coerce/convert.scm 136 */
											obj_t BgL_arg1627z00_1759;
											obj_t BgL_arg1631z00_1760;

											{	/* Coerce/convert.scm 136 */
												obj_t BgL_arg1632z00_1761;

												{	/* Coerce/convert.scm 136 */
													obj_t BgL_arg1633z00_1762;

													{	/* Coerce/convert.scm 136 */
														obj_t BgL_arg1636z00_1763;
														obj_t BgL_arg1637z00_1764;

														{	/* Coerce/convert.scm 136 */
															obj_t BgL_res1971z00_2314;

															{	/* Coerce/convert.scm 136 */
																obj_t BgL_arg1409z00_2313;

																BgL_arg1409z00_2313 =
																	SYMBOL_TO_STRING(BgL_auxz00_1749);
																BgL_res1971z00_2314 =
																	BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																	(BgL_arg1409z00_2313);
															}
															BgL_arg1636z00_1763 = BgL_res1971z00_2314;
														}
														{	/* Coerce/convert.scm 136 */
															obj_t BgL_res1972z00_2317;

															{	/* Coerce/convert.scm 136 */
																obj_t BgL_symbolz00_2315;

																BgL_symbolz00_2315 = CNST_TABLE_REF(((long) 6));
																{	/* Coerce/convert.scm 136 */
																	obj_t BgL_arg1409z00_2316;

																	BgL_arg1409z00_2316 =
																		SYMBOL_TO_STRING(BgL_symbolz00_2315);
																	BgL_res1972z00_2317 =
																		BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																		(BgL_arg1409z00_2316);
															}}
															BgL_arg1637z00_1764 = BgL_res1972z00_2317;
														}
														BgL_arg1633z00_1762 =
															string_append(BgL_arg1636z00_1763,
															BgL_arg1637z00_1764);
													}
													BgL_arg1632z00_1761 =
														bstring_to_symbol(BgL_arg1633z00_1762);
												}
												BgL_arg1627z00_1759 =
													BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
													(BgL_arg1632z00_1761);
											}
											BgL_arg1631z00_1760 = MAKE_YOUNG_PAIR(BUNSPEC, BNIL);
											BgL_arg1626z00_1758 =
												MAKE_YOUNG_PAIR(BgL_arg1627z00_1759,
												BgL_arg1631z00_1760);
										}
										BgL_arg1613z00_1756 =
											MAKE_YOUNG_PAIR(BgL_arg1626z00_1758, BNIL);
									}
									BgL_arg1618z00_1757 =
										MAKE_YOUNG_PAIR
										(BGl_runtimezd2typezd2errorzf2idzf2zzcoerce_convertz00
										(BgL_locz00_52, BgL_tiz00_53, BgL_auxz00_1749), BNIL);
									BgL_arg1609z00_1755 =
										MAKE_YOUNG_PAIR(BgL_arg1613z00_1756, BgL_arg1618z00_1757);
								}
								BgL_arg1602z00_1754 =
									MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 7)),
									BgL_arg1609z00_1755);
							}
							BgL_resz00_1751 =
								BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00
								(BgL_arg1602z00_1754, BgL_locz00_52);
						}
						{	/* Coerce/convert.scm 135 */

							{	/* Coerce/convert.scm 140 */
								obj_t BgL_arg1594z00_1752;

								{	/* Coerce/convert.scm 140 */
									obj_t BgL_pairz00_2321;

									BgL_pairz00_2321 =
										(((BgL_letzd2varzd2_bglt) COBJECT(
												((BgL_letzd2varzd2_bglt) BgL_resz00_1751)))->
										BgL_bindingsz00);
									BgL_arg1594z00_1752 = CAR(BgL_pairz00_2321);
								}
								{	/* Coerce/convert.scm 140 */
									obj_t BgL_auxz00_2721;
									obj_t BgL_tmpz00_2719;

									BgL_auxz00_2721 = ((obj_t) BgL_uvaluez00_1750);
									BgL_tmpz00_2719 = ((obj_t) BgL_arg1594z00_1752);
									SET_CDR(BgL_tmpz00_2719, BgL_auxz00_2721);
							}}
							return ((obj_t) BgL_resz00_1751);
						}
					}
				}
			}
		}

	}



/* &runtime-type-error */
	obj_t BGl_z62runtimezd2typezd2errorz62zzcoerce_convertz00(obj_t
		BgL_envz00_2540, obj_t BgL_locz00_2541, obj_t BgL_tiz00_2542,
		obj_t BgL_valuez00_2543)
	{
		{	/* Coerce/convert.scm 128 */
			return
				BGl_runtimezd2typezd2errorz00zzcoerce_convertz00(BgL_locz00_2541,
				BgL_tiz00_2542, ((BgL_nodez00_bglt) BgL_valuez00_2543));
		}

	}



/* convert-error */
	obj_t BGl_convertzd2errorzd2zzcoerce_convertz00(BgL_typez00_bglt
		BgL_fromz00_55, BgL_typez00_bglt BgL_toz00_56, obj_t BgL_locz00_57,
		BgL_nodez00_bglt BgL_nodez00_58)
	{
		{	/* Coerce/convert.scm 150 */
			{	/* Coerce/convert.scm 154 */
				bool_t BgL_test2043z00_2727;

				if ((((obj_t) BgL_toz00_56) == BGl_za2objza2z00zztype_cachez00))
					{	/* Coerce/convert.scm 154 */
						BgL_test2043z00_2727 = ((bool_t) 0);
					}
				else
					{	/* Coerce/convert.scm 154 */
						BgL_test2043z00_2727 =
							BGl_subzd2typezf3z21zztype_envz00(BgL_toz00_56,
							((BgL_typez00_bglt) BGl_za2objza2z00zztype_cachez00));
					}
				if (BgL_test2043z00_2727)
					{	/* Coerce/convert.scm 155 */
						obj_t BgL_nodez00_1774;

						BgL_nodez00_1774 =
							BGl_runtimezd2typezd2errorz00zzcoerce_convertz00(BgL_locz00_57,
							(((BgL_typez00_bglt) COBJECT(BgL_toz00_56))->BgL_idz00),
							BgL_nodez00_58);
						{	/* Coerce/convert.scm 156 */
							obj_t BgL_arg1644z00_1775;

							BgL_arg1644z00_1775 = BGl_currentzd2functionzd2zztools_errorz00();
							{	/* Coerce/convert.scm 108 */
								obj_t BgL_arg1530z00_2324;

								{	/* Coerce/convert.scm 108 */
									obj_t BgL_arg1536z00_2325;
									obj_t BgL_arg1540z00_2326;

									BgL_arg1536z00_2325 =
										BGl_shapez00zztools_shapez00(((obj_t) BgL_toz00_56));
									BgL_arg1540z00_2326 =
										BGl_shapez00zztools_shapez00(((obj_t) BgL_fromz00_55));
									BgL_arg1530z00_2324 =
										BGl_bigloozd2typezd2errorzd2msgzd2zz__errorz00
										(BGl_string2014z00zzcoerce_convertz00, BgL_arg1536z00_2325,
										BgL_arg1540z00_2326);
								}
								BGl_userzd2warningzf2locationz20zztools_errorz00(BgL_locz00_57,
									BgL_arg1644z00_1775, BGl_string2015z00zzcoerce_convertz00,
									BgL_arg1530z00_2324);
							}
						}
						BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
							((BgL_nodez00_bglt) BgL_nodez00_1774));
						return
							((obj_t)
							BGl_coercez12z12zzcoerce_coercez00(
								((BgL_nodez00_bglt) BgL_nodez00_1774), BUNSPEC, BgL_fromz00_55,
								((bool_t) 0)));
					}
				else
					{	/* Coerce/convert.scm 159 */
						bool_t BgL_test2045z00_2747;

						{	/* Coerce/convert.scm 159 */
							bool_t BgL_res1974z00_2327;

							BgL_res1974z00_2327 =
								BGl_isazf3zf3zz__objectz00(
								((obj_t) BgL_toz00_56), BGl_tclassz00zzobject_classz00);
							BgL_test2045z00_2747 = BgL_res1974z00_2327;
						}
						if (BgL_test2045z00_2747)
							{	/* Coerce/convert.scm 160 */
								obj_t BgL_nodez00_1778;

								BgL_nodez00_1778 =
									BGl_runtimezd2typezd2errorz00zzcoerce_convertz00
									(BgL_locz00_57,
									(((BgL_typez00_bglt) COBJECT(BgL_toz00_56))->BgL_idz00),
									BgL_nodez00_58);
								{	/* Coerce/convert.scm 161 */
									obj_t BgL_arg1647z00_1779;

									BgL_arg1647z00_1779 =
										BGl_currentzd2functionzd2zztools_errorz00();
									{	/* Coerce/convert.scm 108 */
										obj_t BgL_arg1530z00_2329;

										{	/* Coerce/convert.scm 108 */
											obj_t BgL_arg1536z00_2330;
											obj_t BgL_arg1540z00_2331;

											BgL_arg1536z00_2330 =
												BGl_shapez00zztools_shapez00(((obj_t) BgL_toz00_56));
											BgL_arg1540z00_2331 =
												BGl_shapez00zztools_shapez00(((obj_t) BgL_fromz00_55));
											BgL_arg1530z00_2329 =
												BGl_bigloozd2typezd2errorzd2msgzd2zz__errorz00
												(BGl_string2014z00zzcoerce_convertz00,
												BgL_arg1536z00_2330, BgL_arg1540z00_2331);
										}
										BGl_userzd2warningzf2locationz20zztools_errorz00
											(BgL_locz00_57, BgL_arg1647z00_1779,
											BGl_string2015z00zzcoerce_convertz00,
											BgL_arg1530z00_2329);
									}
								}
								BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
									((BgL_nodez00_bglt) BgL_nodez00_1778));
								return
									((obj_t)
									BGl_coercez12z12zzcoerce_coercez00(
										((BgL_nodez00_bglt) BgL_nodez00_1778), BUNSPEC,
										BgL_fromz00_55, ((bool_t) 0)));
							}
						else
							{	/* Coerce/convert.scm 159 */
								if (CBOOL(BGl_za2warningzd2typezd2errorza2z00zzengine_paramz00))
									{	/* Coerce/convert.scm 233 */
										obj_t BgL_arg1650z00_1781;

										BgL_arg1650z00_1781 =
											BGl_currentzd2functionzd2zztools_errorz00();
										{	/* Coerce/convert.scm 97 */
											obj_t BgL_arg1520z00_2332;

											{	/* Coerce/convert.scm 97 */
												obj_t BgL_arg1523z00_2333;
												obj_t BgL_arg1524z00_2334;

												BgL_arg1523z00_2333 =
													BGl_shapez00zztools_shapez00(((obj_t) BgL_toz00_56));
												BgL_arg1524z00_2334 =
													BGl_shapez00zztools_shapez00(
													((obj_t) BgL_fromz00_55));
												BgL_arg1520z00_2332 =
													BGl_bigloozd2typezd2errorzd2msgzd2zz__errorz00
													(BGl_string2014z00zzcoerce_convertz00,
													BgL_arg1523z00_2333, BgL_arg1524z00_2334);
											}
											return
												BGl_userzd2errorzf2locationz20zztools_errorz00
												(BgL_locz00_57, BgL_arg1650z00_1781,
												BGl_string2015z00zzcoerce_convertz00,
												BgL_arg1520z00_2332, BNIL);
										}
									}
								else
									{	/* Coerce/convert.scm 166 */
										bool_t BgL_test2047z00_2773;

										if (
											(((obj_t) BgL_toz00_56) ==
												BGl_za2intza2z00zztype_cachez00))
											{	/* Coerce/convert.scm 166 */
												BgL_test2047z00_2773 = ((bool_t) 1);
											}
										else
											{	/* Coerce/convert.scm 166 */
												if (
													(((obj_t) BgL_toz00_56) ==
														BGl_za2longza2z00zztype_cachez00))
													{	/* Coerce/convert.scm 166 */
														BgL_test2047z00_2773 = ((bool_t) 1);
													}
												else
													{	/* Coerce/convert.scm 166 */
														if (
															(((obj_t) BgL_toz00_56) ==
																BGl_za2elongza2z00zztype_cachez00))
															{	/* Coerce/convert.scm 167 */
																BgL_test2047z00_2773 = ((bool_t) 1);
															}
														else
															{	/* Coerce/convert.scm 167 */
																if (
																	(((obj_t) BgL_toz00_56) ==
																		BGl_za2llongza2z00zztype_cachez00))
																	{	/* Coerce/convert.scm 168 */
																		BgL_test2047z00_2773 = ((bool_t) 1);
																	}
																else
																	{	/* Coerce/convert.scm 168 */
																		if (
																			(((obj_t) BgL_toz00_56) ==
																				BGl_za2int8za2z00zztype_cachez00))
																			{	/* Coerce/convert.scm 169 */
																				BgL_test2047z00_2773 = ((bool_t) 1);
																			}
																		else
																			{	/* Coerce/convert.scm 169 */
																				if (
																					(((obj_t) BgL_toz00_56) ==
																						BGl_za2uint8za2z00zztype_cachez00))
																					{	/* Coerce/convert.scm 170 */
																						BgL_test2047z00_2773 = ((bool_t) 1);
																					}
																				else
																					{	/* Coerce/convert.scm 170 */
																						if (
																							(((obj_t) BgL_toz00_56) ==
																								BGl_za2int16za2z00zztype_cachez00))
																							{	/* Coerce/convert.scm 171 */
																								BgL_test2047z00_2773 =
																									((bool_t) 1);
																							}
																						else
																							{	/* Coerce/convert.scm 171 */
																								if (
																									(((obj_t) BgL_toz00_56) ==
																										BGl_za2uint16za2z00zztype_cachez00))
																									{	/* Coerce/convert.scm 172 */
																										BgL_test2047z00_2773 =
																											((bool_t) 1);
																									}
																								else
																									{	/* Coerce/convert.scm 172 */
																										if (
																											(((obj_t) BgL_toz00_56) ==
																												BGl_za2int32za2z00zztype_cachez00))
																											{	/* Coerce/convert.scm 173 */
																												BgL_test2047z00_2773 =
																													((bool_t) 1);
																											}
																										else
																											{	/* Coerce/convert.scm 173 */
																												if (
																													(((obj_t)
																															BgL_toz00_56) ==
																														BGl_za2uint32za2z00zztype_cachez00))
																													{	/* Coerce/convert.scm 174 */
																														BgL_test2047z00_2773
																															= ((bool_t) 1);
																													}
																												else
																													{	/* Coerce/convert.scm 174 */
																														if (
																															(((obj_t)
																																	BgL_toz00_56)
																																==
																																BGl_za2int64za2z00zztype_cachez00))
																															{	/* Coerce/convert.scm 175 */
																																BgL_test2047z00_2773
																																	=
																																	((bool_t) 1);
																															}
																														else
																															{	/* Coerce/convert.scm 175 */
																																BgL_test2047z00_2773
																																	=
																																	(((obj_t)
																																		BgL_toz00_56)
																																	==
																																	BGl_za2uint64za2z00zztype_cachez00);
																															}
																													}
																											}
																									}
																							}
																					}
																			}
																	}
															}
													}
											}
										if (BgL_test2047z00_2773)
											{	/* Coerce/convert.scm 177 */
												obj_t BgL_nodez00_1794;

												BgL_nodez00_1794 =
													BGl_runtimezd2typezd2errorz00zzcoerce_convertz00
													(BgL_locz00_57,
													(((BgL_typez00_bglt) COBJECT(BgL_toz00_56))->
														BgL_idz00), BgL_nodez00_58);
												{	/* Coerce/convert.scm 178 */
													obj_t BgL_arg1663z00_1795;

													BgL_arg1663z00_1795 =
														BGl_currentzd2functionzd2zztools_errorz00();
													{	/* Coerce/convert.scm 108 */
														obj_t BgL_arg1530z00_2337;

														{	/* Coerce/convert.scm 108 */
															obj_t BgL_arg1536z00_2338;
															obj_t BgL_arg1540z00_2339;

															BgL_arg1536z00_2338 =
																BGl_shapez00zztools_shapez00(
																((obj_t) BgL_toz00_56));
															BgL_arg1540z00_2339 =
																BGl_shapez00zztools_shapez00(
																((obj_t) BgL_fromz00_55));
															BgL_arg1530z00_2337 =
																BGl_bigloozd2typezd2errorzd2msgzd2zz__errorz00
																(BGl_string2014z00zzcoerce_convertz00,
																BgL_arg1536z00_2338, BgL_arg1540z00_2339);
														}
														BGl_userzd2warningzf2locationz20zztools_errorz00
															(BgL_locz00_57, BgL_arg1663z00_1795,
															BGl_string2015z00zzcoerce_convertz00,
															BgL_arg1530z00_2337);
													}
												}
												BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
													((BgL_nodez00_bglt) BgL_nodez00_1794));
												{	/* Coerce/convert.scm 180 */
													BgL_sequencez00_bglt BgL_new1114z00_1796;

													{	/* Coerce/convert.scm 180 */
														BgL_sequencez00_bglt BgL_new1113z00_1804;

														BgL_new1113z00_1804 =
															((BgL_sequencez00_bglt)
															BOBJECT(GC_MALLOC(sizeof(struct
																		BgL_sequencez00_bgl))));
														{	/* Coerce/convert.scm 180 */
															long BgL_arg1675z00_1805;

															{	/* Coerce/convert.scm 180 */
																long BgL_res1975z00_2341;

																BgL_res1975z00_2341 =
																	BGL_CLASS_INDEX(BGl_sequencez00zzast_nodez00);
																BgL_arg1675z00_1805 = BgL_res1975z00_2341;
															}
															BGL_OBJECT_CLASS_NUM_SET(
																((BgL_objectz00_bglt) BgL_new1113z00_1804),
																BgL_arg1675z00_1805);
														}
														{	/* Coerce/convert.scm 180 */
															BgL_objectz00_bglt BgL_tmpz00_2824;

															BgL_tmpz00_2824 =
																((BgL_objectz00_bglt) BgL_new1113z00_1804);
															BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2824, BFALSE);
														}
														((BgL_objectz00_bglt) BgL_new1113z00_1804);
														BgL_new1114z00_1796 = BgL_new1113z00_1804;
													}
													((((BgL_nodez00_bglt) COBJECT(
																	((BgL_nodez00_bglt) BgL_new1114z00_1796)))->
															BgL_locz00) = ((obj_t) BFALSE), BUNSPEC);
													((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
																		BgL_new1114z00_1796)))->BgL_typez00) =
														((BgL_typez00_bglt) BgL_toz00_56), BUNSPEC);
													((((BgL_nodezf2effectzf2_bglt)
																COBJECT(((BgL_nodezf2effectzf2_bglt)
																		BgL_new1114z00_1796)))->
															BgL_sidezd2effectzd2) =
														((obj_t) BUNSPEC), BUNSPEC);
													((((BgL_nodezf2effectzf2_bglt)
																COBJECT(((BgL_nodezf2effectzf2_bglt)
																		BgL_new1114z00_1796)))->BgL_keyz00) =
														((obj_t) BINT(((long) -1))), BUNSPEC);
													{
														obj_t BgL_auxz00_2837;

														{	/* Coerce/convert.scm 183 */
															BgL_nodez00_bglt BgL_arg1665z00_1797;
															BgL_literalz00_bglt BgL_arg1668z00_1798;

															BgL_arg1665z00_1797 =
																BGl_coercez12z12zzcoerce_coercez00(
																((BgL_nodez00_bglt) BgL_nodez00_1794), BUNSPEC,
																BgL_fromz00_55, ((bool_t) 0));
															{	/* Coerce/convert.scm 184 */
																BgL_literalz00_bglt BgL_new1116z00_1801;

																{	/* Coerce/convert.scm 184 */
																	BgL_literalz00_bglt BgL_new1115z00_1802;

																	BgL_new1115z00_1802 =
																		((BgL_literalz00_bglt)
																		BOBJECT(GC_MALLOC(sizeof(struct
																					BgL_literalz00_bgl))));
																	{	/* Coerce/convert.scm 184 */
																		long BgL_arg1673z00_1803;

																		{	/* Coerce/convert.scm 184 */
																			long BgL_res1976z00_2346;

																			{	/* Coerce/convert.scm 184 */
																				obj_t BgL_classz00_2345;

																				BgL_classz00_2345 =
																					BGl_literalz00zzast_nodez00;
																				BgL_res1976z00_2346 =
																					BGL_CLASS_INDEX(BgL_classz00_2345);
																			}
																			BgL_arg1673z00_1803 = BgL_res1976z00_2346;
																		}
																		BGL_OBJECT_CLASS_NUM_SET(
																			((BgL_objectz00_bglt)
																				BgL_new1115z00_1802),
																			BgL_arg1673z00_1803);
																	}
																	{	/* Coerce/convert.scm 184 */
																		BgL_objectz00_bglt BgL_tmpz00_2844;

																		BgL_tmpz00_2844 =
																			((BgL_objectz00_bglt)
																			BgL_new1115z00_1802);
																		BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2844,
																			BFALSE);
																	}
																	((BgL_objectz00_bglt) BgL_new1115z00_1802);
																	BgL_new1116z00_1801 = BgL_new1115z00_1802;
																}
																((((BgL_nodez00_bglt) COBJECT(
																				((BgL_nodez00_bglt)
																					BgL_new1116z00_1801)))->BgL_locz00) =
																	((obj_t) BFALSE), BUNSPEC);
																((((BgL_nodez00_bglt)
																			COBJECT(((BgL_nodez00_bglt)
																					BgL_new1116z00_1801)))->BgL_typez00) =
																	((BgL_typez00_bglt) BgL_toz00_56), BUNSPEC);
																((((BgL_atomz00_bglt)
																			COBJECT(((BgL_atomz00_bglt)
																					BgL_new1116z00_1801)))->
																		BgL_valuez00) =
																	((obj_t) BINT(((long) 0))), BUNSPEC);
																BgL_arg1668z00_1798 = BgL_new1116z00_1801;
															}
															{	/* Coerce/convert.scm 182 */
																obj_t BgL_list1669z00_1799;

																{	/* Coerce/convert.scm 182 */
																	obj_t BgL_arg1670z00_1800;

																	BgL_arg1670z00_1800 =
																		MAKE_YOUNG_PAIR(
																		((obj_t) BgL_arg1668z00_1798), BNIL);
																	BgL_list1669z00_1799 =
																		MAKE_YOUNG_PAIR(
																		((obj_t) BgL_arg1665z00_1797),
																		BgL_arg1670z00_1800);
																}
																BgL_auxz00_2837 = BgL_list1669z00_1799;
														}}
														((((BgL_sequencez00_bglt)
																	COBJECT(BgL_new1114z00_1796))->BgL_nodesz00) =
															((obj_t) BgL_auxz00_2837), BUNSPEC);
													}
													((((BgL_sequencez00_bglt)
																COBJECT(BgL_new1114z00_1796))->BgL_unsafez00) =
														((bool_t) ((bool_t) 0)), BUNSPEC);
													((((BgL_sequencez00_bglt)
																COBJECT(BgL_new1114z00_1796))->BgL_metaz00) =
														((obj_t) BNIL), BUNSPEC);
													return ((obj_t) BgL_new1114z00_1796);
												}
											}
										else
											{	/* Coerce/convert.scm 166 */
												if (
													(((obj_t) BgL_toz00_56) ==
														BGl_za2boolza2z00zztype_cachez00))
													{	/* Coerce/convert.scm 186 */
														obj_t BgL_nodez00_1808;

														BgL_nodez00_1808 =
															BGl_runtimezd2typezd2errorz00zzcoerce_convertz00
															(BgL_locz00_57,
															(((BgL_typez00_bglt) COBJECT(BgL_toz00_56))->
																BgL_idz00), BgL_nodez00_58);
														{	/* Coerce/convert.scm 187 */
															obj_t BgL_arg1679z00_1809;

															BgL_arg1679z00_1809 =
																BGl_currentzd2functionzd2zztools_errorz00();
															{	/* Coerce/convert.scm 108 */
																obj_t BgL_arg1530z00_2352;

																{	/* Coerce/convert.scm 108 */
																	obj_t BgL_arg1536z00_2353;
																	obj_t BgL_arg1540z00_2354;

																	BgL_arg1536z00_2353 =
																		BGl_shapez00zztools_shapez00(
																		((obj_t) BgL_toz00_56));
																	BgL_arg1540z00_2354 =
																		BGl_shapez00zztools_shapez00(
																		((obj_t) BgL_fromz00_55));
																	BgL_arg1530z00_2352 =
																		BGl_bigloozd2typezd2errorzd2msgzd2zz__errorz00
																		(BGl_string2014z00zzcoerce_convertz00,
																		BgL_arg1536z00_2353, BgL_arg1540z00_2354);
																}
																BGl_userzd2warningzf2locationz20zztools_errorz00
																	(BgL_locz00_57, BgL_arg1679z00_1809,
																	BGl_string2015z00zzcoerce_convertz00,
																	BgL_arg1530z00_2352);
															}
														}
														BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
															((BgL_nodez00_bglt) BgL_nodez00_1808));
														{	/* Coerce/convert.scm 189 */
															BgL_sequencez00_bglt BgL_new1119z00_1810;

															{	/* Coerce/convert.scm 189 */
																BgL_sequencez00_bglt BgL_new1117z00_1818;

																BgL_new1117z00_1818 =
																	((BgL_sequencez00_bglt)
																	BOBJECT(GC_MALLOC(sizeof(struct
																				BgL_sequencez00_bgl))));
																{	/* Coerce/convert.scm 189 */
																	long BgL_arg1691z00_1819;

																	{	/* Coerce/convert.scm 189 */
																		long BgL_res1978z00_2356;

																		BgL_res1978z00_2356 =
																			BGL_CLASS_INDEX
																			(BGl_sequencez00zzast_nodez00);
																		BgL_arg1691z00_1819 = BgL_res1978z00_2356;
																	}
																	BGL_OBJECT_CLASS_NUM_SET(
																		((BgL_objectz00_bglt) BgL_new1117z00_1818),
																		BgL_arg1691z00_1819);
																}
																{	/* Coerce/convert.scm 189 */
																	BgL_objectz00_bglt BgL_tmpz00_2881;

																	BgL_tmpz00_2881 =
																		((BgL_objectz00_bglt) BgL_new1117z00_1818);
																	BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2881,
																		BFALSE);
																}
																((BgL_objectz00_bglt) BgL_new1117z00_1818);
																BgL_new1119z00_1810 = BgL_new1117z00_1818;
															}
															((((BgL_nodez00_bglt) COBJECT(
																			((BgL_nodez00_bglt)
																				BgL_new1119z00_1810)))->BgL_locz00) =
																((obj_t) BFALSE), BUNSPEC);
															((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
																				BgL_new1119z00_1810)))->BgL_typez00) =
																((BgL_typez00_bglt) BgL_toz00_56), BUNSPEC);
															((((BgL_nodezf2effectzf2_bglt)
																		COBJECT(((BgL_nodezf2effectzf2_bglt)
																				BgL_new1119z00_1810)))->
																	BgL_sidezd2effectzd2) =
																((obj_t) BUNSPEC), BUNSPEC);
															((((BgL_nodezf2effectzf2_bglt)
																		COBJECT(((BgL_nodezf2effectzf2_bglt)
																				BgL_new1119z00_1810)))->BgL_keyz00) =
																((obj_t) BINT(((long) -1))), BUNSPEC);
															{
																obj_t BgL_auxz00_2894;

																{	/* Coerce/convert.scm 192 */
																	BgL_nodez00_bglt BgL_arg1680z00_1811;
																	BgL_literalz00_bglt BgL_arg1681z00_1812;

																	BgL_arg1680z00_1811 =
																		BGl_coercez12z12zzcoerce_coercez00(
																		((BgL_nodez00_bglt) BgL_nodez00_1808),
																		BUNSPEC, BgL_fromz00_55, ((bool_t) 0));
																	{	/* Coerce/convert.scm 193 */
																		BgL_literalz00_bglt BgL_new1121z00_1815;

																		{	/* Coerce/convert.scm 193 */
																			BgL_literalz00_bglt BgL_new1120z00_1816;

																			BgL_new1120z00_1816 =
																				((BgL_literalz00_bglt)
																				BOBJECT(GC_MALLOC(sizeof(struct
																							BgL_literalz00_bgl))));
																			{	/* Coerce/convert.scm 193 */
																				long BgL_arg1688z00_1817;

																				{	/* Coerce/convert.scm 193 */
																					long BgL_res1979z00_2361;

																					{	/* Coerce/convert.scm 193 */
																						obj_t BgL_classz00_2360;

																						BgL_classz00_2360 =
																							BGl_literalz00zzast_nodez00;
																						BgL_res1979z00_2361 =
																							BGL_CLASS_INDEX
																							(BgL_classz00_2360);
																					}
																					BgL_arg1688z00_1817 =
																						BgL_res1979z00_2361;
																				}
																				BGL_OBJECT_CLASS_NUM_SET(
																					((BgL_objectz00_bglt)
																						BgL_new1120z00_1816),
																					BgL_arg1688z00_1817);
																			}
																			{	/* Coerce/convert.scm 193 */
																				BgL_objectz00_bglt BgL_tmpz00_2901;

																				BgL_tmpz00_2901 =
																					((BgL_objectz00_bglt)
																					BgL_new1120z00_1816);
																				BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2901,
																					BFALSE);
																			}
																			((BgL_objectz00_bglt)
																				BgL_new1120z00_1816);
																			BgL_new1121z00_1815 = BgL_new1120z00_1816;
																		}
																		((((BgL_nodez00_bglt) COBJECT(
																						((BgL_nodez00_bglt)
																							BgL_new1121z00_1815)))->
																				BgL_locz00) =
																			((obj_t) BFALSE), BUNSPEC);
																		((((BgL_nodez00_bglt)
																					COBJECT(((BgL_nodez00_bglt)
																							BgL_new1121z00_1815)))->
																				BgL_typez00) =
																			((BgL_typez00_bglt) BgL_toz00_56),
																			BUNSPEC);
																		((((BgL_atomz00_bglt)
																					COBJECT(((BgL_atomz00_bglt)
																							BgL_new1121z00_1815)))->
																				BgL_valuez00) =
																			((obj_t) BINT(((long) 0))), BUNSPEC);
																		BgL_arg1681z00_1812 = BgL_new1121z00_1815;
																	}
																	{	/* Coerce/convert.scm 191 */
																		obj_t BgL_list1682z00_1813;

																		{	/* Coerce/convert.scm 191 */
																			obj_t BgL_arg1687z00_1814;

																			BgL_arg1687z00_1814 =
																				MAKE_YOUNG_PAIR(
																				((obj_t) BgL_arg1681z00_1812), BNIL);
																			BgL_list1682z00_1813 =
																				MAKE_YOUNG_PAIR(
																				((obj_t) BgL_arg1680z00_1811),
																				BgL_arg1687z00_1814);
																		}
																		BgL_auxz00_2894 = BgL_list1682z00_1813;
																}}
																((((BgL_sequencez00_bglt)
																			COBJECT(BgL_new1119z00_1810))->
																		BgL_nodesz00) =
																	((obj_t) BgL_auxz00_2894), BUNSPEC);
															}
															((((BgL_sequencez00_bglt)
																		COBJECT(BgL_new1119z00_1810))->
																	BgL_unsafez00) =
																((bool_t) ((bool_t) 0)), BUNSPEC);
															((((BgL_sequencez00_bglt)
																		COBJECT(BgL_new1119z00_1810))->
																	BgL_metaz00) = ((obj_t) BNIL), BUNSPEC);
															return ((obj_t) BgL_new1119z00_1810);
														}
													}
												else
													{	/* Coerce/convert.scm 185 */
														if (
															(((obj_t) BgL_toz00_56) ==
																BGl_za2realza2z00zztype_cachez00))
															{	/* Coerce/convert.scm 195 */
																obj_t BgL_nodez00_1822;

																BgL_nodez00_1822 =
																	BGl_runtimezd2typezd2errorz00zzcoerce_convertz00
																	(BgL_locz00_57,
																	(((BgL_typez00_bglt) COBJECT(BgL_toz00_56))->
																		BgL_idz00), BgL_nodez00_58);
																{	/* Coerce/convert.scm 196 */
																	obj_t BgL_arg1694z00_1823;

																	BgL_arg1694z00_1823 =
																		BGl_currentzd2functionzd2zztools_errorz00();
																	{	/* Coerce/convert.scm 108 */
																		obj_t BgL_arg1530z00_2367;

																		{	/* Coerce/convert.scm 108 */
																			obj_t BgL_arg1536z00_2368;
																			obj_t BgL_arg1540z00_2369;

																			BgL_arg1536z00_2368 =
																				BGl_shapez00zztools_shapez00(
																				((obj_t) BgL_toz00_56));
																			BgL_arg1540z00_2369 =
																				BGl_shapez00zztools_shapez00(
																				((obj_t) BgL_fromz00_55));
																			BgL_arg1530z00_2367 =
																				BGl_bigloozd2typezd2errorzd2msgzd2zz__errorz00
																				(BGl_string2014z00zzcoerce_convertz00,
																				BgL_arg1536z00_2368,
																				BgL_arg1540z00_2369);
																		}
																		BGl_userzd2warningzf2locationz20zztools_errorz00
																			(BgL_locz00_57, BgL_arg1694z00_1823,
																			BGl_string2015z00zzcoerce_convertz00,
																			BgL_arg1530z00_2367);
																	}
																}
																BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
																	((BgL_nodez00_bglt) BgL_nodez00_1822));
																{	/* Coerce/convert.scm 198 */
																	BgL_sequencez00_bglt BgL_new1123z00_1824;

																	{	/* Coerce/convert.scm 198 */
																		BgL_sequencez00_bglt BgL_new1122z00_1832;

																		BgL_new1122z00_1832 =
																			((BgL_sequencez00_bglt)
																			BOBJECT(GC_MALLOC(sizeof(struct
																						BgL_sequencez00_bgl))));
																		{	/* Coerce/convert.scm 198 */
																			long BgL_arg1710z00_1833;

																			{	/* Coerce/convert.scm 198 */
																				long BgL_res1981z00_2371;

																				BgL_res1981z00_2371 =
																					BGL_CLASS_INDEX
																					(BGl_sequencez00zzast_nodez00);
																				BgL_arg1710z00_1833 =
																					BgL_res1981z00_2371;
																			}
																			BGL_OBJECT_CLASS_NUM_SET(
																				((BgL_objectz00_bglt)
																					BgL_new1122z00_1832),
																				BgL_arg1710z00_1833);
																		}
																		{	/* Coerce/convert.scm 198 */
																			BgL_objectz00_bglt BgL_tmpz00_2938;

																			BgL_tmpz00_2938 =
																				((BgL_objectz00_bglt)
																				BgL_new1122z00_1832);
																			BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2938,
																				BFALSE);
																		}
																		((BgL_objectz00_bglt) BgL_new1122z00_1832);
																		BgL_new1123z00_1824 = BgL_new1122z00_1832;
																	}
																	((((BgL_nodez00_bglt) COBJECT(
																					((BgL_nodez00_bglt)
																						BgL_new1123z00_1824)))->
																			BgL_locz00) = ((obj_t) BFALSE), BUNSPEC);
																	((((BgL_nodez00_bglt)
																				COBJECT(((BgL_nodez00_bglt)
																						BgL_new1123z00_1824)))->
																			BgL_typez00) =
																		((BgL_typez00_bglt) BgL_toz00_56), BUNSPEC);
																	((((BgL_nodezf2effectzf2_bglt)
																				COBJECT(((BgL_nodezf2effectzf2_bglt)
																						BgL_new1123z00_1824)))->
																			BgL_sidezd2effectzd2) =
																		((obj_t) BUNSPEC), BUNSPEC);
																	((((BgL_nodezf2effectzf2_bglt)
																				COBJECT(((BgL_nodezf2effectzf2_bglt)
																						BgL_new1123z00_1824)))->
																			BgL_keyz00) =
																		((obj_t) BINT(((long) -1))), BUNSPEC);
																	{
																		obj_t BgL_auxz00_2951;

																		{	/* Coerce/convert.scm 201 */
																			BgL_nodez00_bglt BgL_arg1695z00_1825;
																			BgL_literalz00_bglt BgL_arg1697z00_1826;

																			BgL_arg1695z00_1825 =
																				BGl_coercez12z12zzcoerce_coercez00(
																				((BgL_nodez00_bglt) BgL_nodez00_1822),
																				BUNSPEC, BgL_fromz00_55, ((bool_t) 0));
																			{	/* Coerce/convert.scm 202 */
																				BgL_literalz00_bglt BgL_new1126z00_1829;

																				{	/* Coerce/convert.scm 202 */
																					BgL_literalz00_bglt
																						BgL_new1125z00_1830;
																					BgL_new1125z00_1830 =
																						((BgL_literalz00_bglt)
																						BOBJECT(GC_MALLOC(sizeof(struct
																									BgL_literalz00_bgl))));
																					{	/* Coerce/convert.scm 202 */
																						long BgL_arg1703z00_1831;

																						{	/* Coerce/convert.scm 202 */
																							long BgL_res1982z00_2376;

																							{	/* Coerce/convert.scm 202 */
																								obj_t BgL_classz00_2375;

																								BgL_classz00_2375 =
																									BGl_literalz00zzast_nodez00;
																								BgL_res1982z00_2376 =
																									BGL_CLASS_INDEX
																									(BgL_classz00_2375);
																							}
																							BgL_arg1703z00_1831 =
																								BgL_res1982z00_2376;
																						}
																						BGL_OBJECT_CLASS_NUM_SET(
																							((BgL_objectz00_bglt)
																								BgL_new1125z00_1830),
																							BgL_arg1703z00_1831);
																					}
																					{	/* Coerce/convert.scm 202 */
																						BgL_objectz00_bglt BgL_tmpz00_2958;

																						BgL_tmpz00_2958 =
																							((BgL_objectz00_bglt)
																							BgL_new1125z00_1830);
																						BGL_OBJECT_WIDENING_SET
																							(BgL_tmpz00_2958, BFALSE);
																					}
																					((BgL_objectz00_bglt)
																						BgL_new1125z00_1830);
																					BgL_new1126z00_1829 =
																						BgL_new1125z00_1830;
																				}
																				((((BgL_nodez00_bglt) COBJECT(
																								((BgL_nodez00_bglt)
																									BgL_new1126z00_1829)))->
																						BgL_locz00) =
																					((obj_t) BFALSE), BUNSPEC);
																				((((BgL_nodez00_bglt)
																							COBJECT(((BgL_nodez00_bglt)
																									BgL_new1126z00_1829)))->
																						BgL_typez00) =
																					((BgL_typez00_bglt) BgL_toz00_56),
																					BUNSPEC);
																				((((BgL_atomz00_bglt)
																							COBJECT(((BgL_atomz00_bglt)
																									BgL_new1126z00_1829)))->
																						BgL_valuez00) =
																					((obj_t)
																						BGL_REAL_CNST
																						(BGl_real2016z00zzcoerce_convertz00)),
																					BUNSPEC);
																				BgL_arg1697z00_1826 =
																					BgL_new1126z00_1829;
																			}
																			{	/* Coerce/convert.scm 200 */
																				obj_t BgL_list1698z00_1827;

																				{	/* Coerce/convert.scm 200 */
																					obj_t BgL_arg1702z00_1828;

																					BgL_arg1702z00_1828 =
																						MAKE_YOUNG_PAIR(
																						((obj_t) BgL_arg1697z00_1826),
																						BNIL);
																					BgL_list1698z00_1827 =
																						MAKE_YOUNG_PAIR(((obj_t)
																							BgL_arg1695z00_1825),
																						BgL_arg1702z00_1828);
																				}
																				BgL_auxz00_2951 = BgL_list1698z00_1827;
																		}}
																		((((BgL_sequencez00_bglt)
																					COBJECT(BgL_new1123z00_1824))->
																				BgL_nodesz00) =
																			((obj_t) BgL_auxz00_2951), BUNSPEC);
																	}
																	((((BgL_sequencez00_bglt)
																				COBJECT(BgL_new1123z00_1824))->
																			BgL_unsafez00) =
																		((bool_t) ((bool_t) 0)), BUNSPEC);
																	((((BgL_sequencez00_bglt)
																				COBJECT(BgL_new1123z00_1824))->
																			BgL_metaz00) = ((obj_t) BNIL), BUNSPEC);
																	return ((obj_t) BgL_new1123z00_1824);
																}
															}
														else
															{	/* Coerce/convert.scm 194 */
																if (
																	(((obj_t) BgL_toz00_56) ==
																		BGl_za2charza2z00zztype_cachez00))
																	{	/* Coerce/convert.scm 204 */
																		obj_t BgL_nodez00_1836;

																		BgL_nodez00_1836 =
																			BGl_runtimezd2typezd2errorz00zzcoerce_convertz00
																			(BgL_locz00_57,
																			(((BgL_typez00_bglt)
																					COBJECT(BgL_toz00_56))->BgL_idz00),
																			BgL_nodez00_58);
																		{	/* Coerce/convert.scm 205 */
																			obj_t BgL_arg1717z00_1837;

																			BgL_arg1717z00_1837 =
																				BGl_currentzd2functionzd2zztools_errorz00
																				();
																			{	/* Coerce/convert.scm 108 */
																				obj_t BgL_arg1530z00_2382;

																				{	/* Coerce/convert.scm 108 */
																					obj_t BgL_arg1536z00_2383;
																					obj_t BgL_arg1540z00_2384;

																					BgL_arg1536z00_2383 =
																						BGl_shapez00zztools_shapez00(
																						((obj_t) BgL_toz00_56));
																					BgL_arg1540z00_2384 =
																						BGl_shapez00zztools_shapez00(
																						((obj_t) BgL_fromz00_55));
																					BgL_arg1530z00_2382 =
																						BGl_bigloozd2typezd2errorzd2msgzd2zz__errorz00
																						(BGl_string2014z00zzcoerce_convertz00,
																						BgL_arg1536z00_2383,
																						BgL_arg1540z00_2384);
																				}
																				BGl_userzd2warningzf2locationz20zztools_errorz00
																					(BgL_locz00_57, BgL_arg1717z00_1837,
																					BGl_string2015z00zzcoerce_convertz00,
																					BgL_arg1530z00_2382);
																			}
																		}
																		BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
																			((BgL_nodez00_bglt) BgL_nodez00_1836));
																		{	/* Coerce/convert.scm 207 */
																			BgL_sequencez00_bglt BgL_new1129z00_1838;

																			{	/* Coerce/convert.scm 207 */
																				BgL_sequencez00_bglt
																					BgL_new1127z00_1846;
																				BgL_new1127z00_1846 =
																					((BgL_sequencez00_bglt)
																					BOBJECT(GC_MALLOC(sizeof(struct
																								BgL_sequencez00_bgl))));
																				{	/* Coerce/convert.scm 207 */
																					long BgL_arg1748z00_1847;

																					{	/* Coerce/convert.scm 207 */
																						long BgL_res1984z00_2386;

																						BgL_res1984z00_2386 =
																							BGL_CLASS_INDEX
																							(BGl_sequencez00zzast_nodez00);
																						BgL_arg1748z00_1847 =
																							BgL_res1984z00_2386;
																					}
																					BGL_OBJECT_CLASS_NUM_SET(
																						((BgL_objectz00_bglt)
																							BgL_new1127z00_1846),
																						BgL_arg1748z00_1847);
																				}
																				{	/* Coerce/convert.scm 207 */
																					BgL_objectz00_bglt BgL_tmpz00_2994;

																					BgL_tmpz00_2994 =
																						((BgL_objectz00_bglt)
																						BgL_new1127z00_1846);
																					BGL_OBJECT_WIDENING_SET
																						(BgL_tmpz00_2994, BFALSE);
																				}
																				((BgL_objectz00_bglt)
																					BgL_new1127z00_1846);
																				BgL_new1129z00_1838 =
																					BgL_new1127z00_1846;
																			}
																			((((BgL_nodez00_bglt) COBJECT(
																							((BgL_nodez00_bglt)
																								BgL_new1129z00_1838)))->
																					BgL_locz00) =
																				((obj_t) BFALSE), BUNSPEC);
																			((((BgL_nodez00_bglt)
																						COBJECT(((BgL_nodez00_bglt)
																								BgL_new1129z00_1838)))->
																					BgL_typez00) =
																				((BgL_typez00_bglt) BgL_toz00_56),
																				BUNSPEC);
																			((((BgL_nodezf2effectzf2_bglt)
																						COBJECT(((BgL_nodezf2effectzf2_bglt)
																								BgL_new1129z00_1838)))->
																					BgL_sidezd2effectzd2) =
																				((obj_t) BUNSPEC), BUNSPEC);
																			((((BgL_nodezf2effectzf2_bglt)
																						COBJECT(((BgL_nodezf2effectzf2_bglt)
																								BgL_new1129z00_1838)))->
																					BgL_keyz00) =
																				((obj_t) BINT(((long) -1))), BUNSPEC);
																			{
																				obj_t BgL_auxz00_3007;

																				{	/* Coerce/convert.scm 210 */
																					BgL_nodez00_bglt BgL_arg1723z00_1839;
																					BgL_literalz00_bglt
																						BgL_arg1731z00_1840;
																					BgL_arg1723z00_1839 =
																						BGl_coercez12z12zzcoerce_coercez00((
																							(BgL_nodez00_bglt)
																							BgL_nodez00_1836), BUNSPEC,
																						BgL_fromz00_55, ((bool_t) 0));
																					{	/* Coerce/convert.scm 211 */
																						BgL_literalz00_bglt
																							BgL_new1131z00_1843;
																						{	/* Coerce/convert.scm 211 */
																							BgL_literalz00_bglt
																								BgL_new1130z00_1844;
																							BgL_new1130z00_1844 =
																								((BgL_literalz00_bglt)
																								BOBJECT(GC_MALLOC(sizeof(struct
																											BgL_literalz00_bgl))));
																							{	/* Coerce/convert.scm 211 */
																								long BgL_arg1737z00_1845;

																								{	/* Coerce/convert.scm 211 */
																									long BgL_res1985z00_2391;

																									{	/* Coerce/convert.scm 211 */
																										obj_t BgL_classz00_2390;

																										BgL_classz00_2390 =
																											BGl_literalz00zzast_nodez00;
																										BgL_res1985z00_2391 =
																											BGL_CLASS_INDEX
																											(BgL_classz00_2390);
																									}
																									BgL_arg1737z00_1845 =
																										BgL_res1985z00_2391;
																								}
																								BGL_OBJECT_CLASS_NUM_SET(
																									((BgL_objectz00_bglt)
																										BgL_new1130z00_1844),
																									BgL_arg1737z00_1845);
																							}
																							{	/* Coerce/convert.scm 211 */
																								BgL_objectz00_bglt
																									BgL_tmpz00_3014;
																								BgL_tmpz00_3014 =
																									((BgL_objectz00_bglt)
																									BgL_new1130z00_1844);
																								BGL_OBJECT_WIDENING_SET
																									(BgL_tmpz00_3014, BFALSE);
																							}
																							((BgL_objectz00_bglt)
																								BgL_new1130z00_1844);
																							BgL_new1131z00_1843 =
																								BgL_new1130z00_1844;
																						}
																						((((BgL_nodez00_bglt) COBJECT(
																										((BgL_nodez00_bglt)
																											BgL_new1131z00_1843)))->
																								BgL_locz00) =
																							((obj_t) BFALSE), BUNSPEC);
																						((((BgL_nodez00_bglt)
																									COBJECT(((BgL_nodez00_bglt)
																											BgL_new1131z00_1843)))->
																								BgL_typez00) =
																							((BgL_typez00_bglt) BgL_toz00_56),
																							BUNSPEC);
																						((((BgL_atomz00_bglt)
																									COBJECT(((BgL_atomz00_bglt)
																											BgL_new1131z00_1843)))->
																								BgL_valuez00) =
																							((obj_t) BCHAR(((unsigned char)
																										'\000'))), BUNSPEC);
																						BgL_arg1731z00_1840 =
																							BgL_new1131z00_1843;
																					}
																					{	/* Coerce/convert.scm 209 */
																						obj_t BgL_list1732z00_1841;

																						{	/* Coerce/convert.scm 209 */
																							obj_t BgL_arg1736z00_1842;

																							BgL_arg1736z00_1842 =
																								MAKE_YOUNG_PAIR(
																								((obj_t) BgL_arg1731z00_1840),
																								BNIL);
																							BgL_list1732z00_1841 =
																								MAKE_YOUNG_PAIR(((obj_t)
																									BgL_arg1723z00_1839),
																								BgL_arg1736z00_1842);
																						}
																						BgL_auxz00_3007 =
																							BgL_list1732z00_1841;
																				}}
																				((((BgL_sequencez00_bglt)
																							COBJECT(BgL_new1129z00_1838))->
																						BgL_nodesz00) =
																					((obj_t) BgL_auxz00_3007), BUNSPEC);
																			}
																			((((BgL_sequencez00_bglt)
																						COBJECT(BgL_new1129z00_1838))->
																					BgL_unsafez00) =
																				((bool_t) ((bool_t) 0)), BUNSPEC);
																			((((BgL_sequencez00_bglt)
																						COBJECT(BgL_new1129z00_1838))->
																					BgL_metaz00) =
																				((obj_t) BNIL), BUNSPEC);
																			return ((obj_t) BgL_new1129z00_1838);
																		}
																	}
																else
																	{	/* Coerce/convert.scm 203 */
																		if (
																			(((obj_t) BgL_toz00_56) ==
																				BGl_za2scharza2z00zztype_cachez00))
																			{	/* Coerce/convert.scm 213 */
																				obj_t BgL_nodez00_1850;

																				BgL_nodez00_1850 =
																					BGl_runtimezd2typezd2errorz00zzcoerce_convertz00
																					(BgL_locz00_57,
																					(((BgL_typez00_bglt)
																							COBJECT(BgL_toz00_56))->
																						BgL_idz00), BgL_nodez00_58);
																				{	/* Coerce/convert.scm 214 */
																					obj_t BgL_arg1752z00_1851;

																					BgL_arg1752z00_1851 =
																						BGl_currentzd2functionzd2zztools_errorz00
																						();
																					{	/* Coerce/convert.scm 108 */
																						obj_t BgL_arg1530z00_2397;

																						{	/* Coerce/convert.scm 108 */
																							obj_t BgL_arg1536z00_2398;
																							obj_t BgL_arg1540z00_2399;

																							BgL_arg1536z00_2398 =
																								BGl_shapez00zztools_shapez00(
																								((obj_t) BgL_toz00_56));
																							BgL_arg1540z00_2399 =
																								BGl_shapez00zztools_shapez00(
																								((obj_t) BgL_fromz00_55));
																							BgL_arg1530z00_2397 =
																								BGl_bigloozd2typezd2errorzd2msgzd2zz__errorz00
																								(BGl_string2014z00zzcoerce_convertz00,
																								BgL_arg1536z00_2398,
																								BgL_arg1540z00_2399);
																						}
																						BGl_userzd2warningzf2locationz20zztools_errorz00
																							(BgL_locz00_57,
																							BgL_arg1752z00_1851,
																							BGl_string2015z00zzcoerce_convertz00,
																							BgL_arg1530z00_2397);
																					}
																				}
																				BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
																					((BgL_nodez00_bglt)
																						BgL_nodez00_1850));
																				{	/* Coerce/convert.scm 216 */
																					BgL_sequencez00_bglt
																						BgL_new1134z00_1852;
																					{	/* Coerce/convert.scm 216 */
																						BgL_sequencez00_bglt
																							BgL_new1133z00_1860;
																						BgL_new1133z00_1860 =
																							((BgL_sequencez00_bglt)
																							BOBJECT(GC_MALLOC(sizeof(struct
																										BgL_sequencez00_bgl))));
																						{	/* Coerce/convert.scm 216 */
																							long BgL_arg1760z00_1861;

																							{	/* Coerce/convert.scm 216 */
																								long BgL_res1987z00_2401;

																								BgL_res1987z00_2401 =
																									BGL_CLASS_INDEX
																									(BGl_sequencez00zzast_nodez00);
																								BgL_arg1760z00_1861 =
																									BgL_res1987z00_2401;
																							}
																							BGL_OBJECT_CLASS_NUM_SET(
																								((BgL_objectz00_bglt)
																									BgL_new1133z00_1860),
																								BgL_arg1760z00_1861);
																						}
																						{	/* Coerce/convert.scm 216 */
																							BgL_objectz00_bglt
																								BgL_tmpz00_3051;
																							BgL_tmpz00_3051 =
																								((BgL_objectz00_bglt)
																								BgL_new1133z00_1860);
																							BGL_OBJECT_WIDENING_SET
																								(BgL_tmpz00_3051, BFALSE);
																						}
																						((BgL_objectz00_bglt)
																							BgL_new1133z00_1860);
																						BgL_new1134z00_1852 =
																							BgL_new1133z00_1860;
																					}
																					((((BgL_nodez00_bglt) COBJECT(
																									((BgL_nodez00_bglt)
																										BgL_new1134z00_1852)))->
																							BgL_locz00) =
																						((obj_t) BFALSE), BUNSPEC);
																					((((BgL_nodez00_bglt)
																								COBJECT(((BgL_nodez00_bglt)
																										BgL_new1134z00_1852)))->
																							BgL_typez00) =
																						((BgL_typez00_bglt) (
																								(BgL_typez00_bglt)
																								BGl_za2charza2z00zztype_cachez00)),
																						BUNSPEC);
																					((((BgL_nodezf2effectzf2_bglt)
																								COBJECT((
																										(BgL_nodezf2effectzf2_bglt)
																										BgL_new1134z00_1852)))->
																							BgL_sidezd2effectzd2) =
																						((obj_t) BUNSPEC), BUNSPEC);
																					((((BgL_nodezf2effectzf2_bglt)
																								COBJECT((
																										(BgL_nodezf2effectzf2_bglt)
																										BgL_new1134z00_1852)))->
																							BgL_keyz00) =
																						((obj_t) BINT(((long) -1))),
																						BUNSPEC);
																					{
																						obj_t BgL_auxz00_3065;

																						{	/* Coerce/convert.scm 219 */
																							BgL_nodez00_bglt
																								BgL_arg1753z00_1853;
																							BgL_literalz00_bglt
																								BgL_arg1756z00_1854;
																							BgL_arg1753z00_1853 =
																								BGl_coercez12z12zzcoerce_coercez00
																								(((BgL_nodez00_bglt)
																									BgL_nodez00_1850), BUNSPEC,
																								BgL_fromz00_55, ((bool_t) 0));
																							{	/* Coerce/convert.scm 220 */
																								BgL_literalz00_bglt
																									BgL_new1136z00_1857;
																								{	/* Coerce/convert.scm 220 */
																									BgL_literalz00_bglt
																										BgL_new1135z00_1858;
																									BgL_new1135z00_1858 =
																										((BgL_literalz00_bglt)
																										BOBJECT(GC_MALLOC(sizeof
																												(struct
																													BgL_literalz00_bgl))));
																									{	/* Coerce/convert.scm 220 */
																										long BgL_arg1759z00_1859;

																										{	/* Coerce/convert.scm 220 */
																											long BgL_res1988z00_2406;

																											{	/* Coerce/convert.scm 220 */
																												obj_t BgL_classz00_2405;

																												BgL_classz00_2405 =
																													BGl_literalz00zzast_nodez00;
																												BgL_res1988z00_2406 =
																													BGL_CLASS_INDEX
																													(BgL_classz00_2405);
																											}
																											BgL_arg1759z00_1859 =
																												BgL_res1988z00_2406;
																										}
																										BGL_OBJECT_CLASS_NUM_SET(
																											((BgL_objectz00_bglt)
																												BgL_new1135z00_1858),
																											BgL_arg1759z00_1859);
																									}
																									{	/* Coerce/convert.scm 220 */
																										BgL_objectz00_bglt
																											BgL_tmpz00_3072;
																										BgL_tmpz00_3072 =
																											((BgL_objectz00_bglt)
																											BgL_new1135z00_1858);
																										BGL_OBJECT_WIDENING_SET
																											(BgL_tmpz00_3072, BFALSE);
																									}
																									((BgL_objectz00_bglt)
																										BgL_new1135z00_1858);
																									BgL_new1136z00_1857 =
																										BgL_new1135z00_1858;
																								}
																								((((BgL_nodez00_bglt) COBJECT(
																												((BgL_nodez00_bglt)
																													BgL_new1136z00_1857)))->
																										BgL_locz00) =
																									((obj_t) BFALSE), BUNSPEC);
																								((((BgL_nodez00_bglt)
																											COBJECT((
																													(BgL_nodez00_bglt)
																													BgL_new1136z00_1857)))->
																										BgL_typez00) =
																									((BgL_typez00_bglt) (
																											(BgL_typez00_bglt)
																											BGl_za2charza2z00zztype_cachez00)),
																									BUNSPEC);
																								((((BgL_atomz00_bglt)
																											COBJECT((
																													(BgL_atomz00_bglt)
																													BgL_new1136z00_1857)))->
																										BgL_valuez00) =
																									((obj_t) BCHAR(((unsigned
																													char) '\000'))),
																									BUNSPEC);
																								BgL_arg1756z00_1854 =
																									BgL_new1136z00_1857;
																							}
																							{	/* Coerce/convert.scm 218 */
																								obj_t BgL_list1757z00_1855;

																								{	/* Coerce/convert.scm 218 */
																									obj_t BgL_arg1758z00_1856;

																									BgL_arg1758z00_1856 =
																										MAKE_YOUNG_PAIR(
																										((obj_t)
																											BgL_arg1756z00_1854),
																										BNIL);
																									BgL_list1757z00_1855 =
																										MAKE_YOUNG_PAIR(((obj_t)
																											BgL_arg1753z00_1853),
																										BgL_arg1758z00_1856);
																								}
																								BgL_auxz00_3065 =
																									BgL_list1757z00_1855;
																						}}
																						((((BgL_sequencez00_bglt)
																									COBJECT
																									(BgL_new1134z00_1852))->
																								BgL_nodesz00) =
																							((obj_t) BgL_auxz00_3065),
																							BUNSPEC);
																					}
																					((((BgL_sequencez00_bglt)
																								COBJECT(BgL_new1134z00_1852))->
																							BgL_unsafez00) =
																						((bool_t) ((bool_t) 0)), BUNSPEC);
																					((((BgL_sequencez00_bglt)
																								COBJECT(BgL_new1134z00_1852))->
																							BgL_metaz00) =
																						((obj_t) BNIL), BUNSPEC);
																					return ((obj_t) BgL_new1134z00_1852);
																				}
																			}
																		else
																			{	/* Coerce/convert.scm 212 */
																				if (
																					(((obj_t) BgL_toz00_56) ==
																						BGl_za2stringza2z00zztype_cachez00))
																					{	/* Coerce/convert.scm 222 */
																						obj_t BgL_nodez00_1864;

																						BgL_nodez00_1864 =
																							BGl_runtimezd2typezd2errorz00zzcoerce_convertz00
																							(BgL_locz00_57,
																							(((BgL_typez00_bglt)
																									COBJECT(BgL_toz00_56))->
																								BgL_idz00), BgL_nodez00_58);
																						{	/* Coerce/convert.scm 223 */
																							obj_t BgL_arg1763z00_1865;

																							BgL_arg1763z00_1865 =
																								BGl_currentzd2functionzd2zztools_errorz00
																								();
																							{	/* Coerce/convert.scm 108 */
																								obj_t BgL_arg1530z00_2412;

																								{	/* Coerce/convert.scm 108 */
																									obj_t BgL_arg1536z00_2413;
																									obj_t BgL_arg1540z00_2414;

																									BgL_arg1536z00_2413 =
																										BGl_shapez00zztools_shapez00
																										(((obj_t) BgL_toz00_56));
																									BgL_arg1540z00_2414 =
																										BGl_shapez00zztools_shapez00
																										(((obj_t) BgL_fromz00_55));
																									BgL_arg1530z00_2412 =
																										BGl_bigloozd2typezd2errorzd2msgzd2zz__errorz00
																										(BGl_string2014z00zzcoerce_convertz00,
																										BgL_arg1536z00_2413,
																										BgL_arg1540z00_2414);
																								}
																								BGl_userzd2warningzf2locationz20zztools_errorz00
																									(BgL_locz00_57,
																									BgL_arg1763z00_1865,
																									BGl_string2015z00zzcoerce_convertz00,
																									BgL_arg1530z00_2412);
																							}
																						}
																						BGl_lvtypezd2nodez12zc0zzast_lvtypez00
																							(((BgL_nodez00_bglt)
																								BgL_nodez00_1864));
																						{	/* Coerce/convert.scm 225 */
																							BgL_sequencez00_bglt
																								BgL_new1138z00_1866;
																							{	/* Coerce/convert.scm 225 */
																								BgL_sequencez00_bglt
																									BgL_new1137z00_1874;
																								BgL_new1137z00_1874 =
																									((BgL_sequencez00_bglt)
																									BOBJECT(GC_MALLOC(sizeof
																											(struct
																												BgL_sequencez00_bgl))));
																								{	/* Coerce/convert.scm 225 */
																									long BgL_arg1771z00_1875;

																									{	/* Coerce/convert.scm 225 */
																										long BgL_res1990z00_2416;

																										BgL_res1990z00_2416 =
																											BGL_CLASS_INDEX
																											(BGl_sequencez00zzast_nodez00);
																										BgL_arg1771z00_1875 =
																											BgL_res1990z00_2416;
																									}
																									BGL_OBJECT_CLASS_NUM_SET(
																										((BgL_objectz00_bglt)
																											BgL_new1137z00_1874),
																										BgL_arg1771z00_1875);
																								}
																								{	/* Coerce/convert.scm 225 */
																									BgL_objectz00_bglt
																										BgL_tmpz00_3110;
																									BgL_tmpz00_3110 =
																										((BgL_objectz00_bglt)
																										BgL_new1137z00_1874);
																									BGL_OBJECT_WIDENING_SET
																										(BgL_tmpz00_3110, BFALSE);
																								}
																								((BgL_objectz00_bglt)
																									BgL_new1137z00_1874);
																								BgL_new1138z00_1866 =
																									BgL_new1137z00_1874;
																							}
																							((((BgL_nodez00_bglt) COBJECT(
																											((BgL_nodez00_bglt)
																												BgL_new1138z00_1866)))->
																									BgL_locz00) =
																								((obj_t) BFALSE), BUNSPEC);
																							((((BgL_nodez00_bglt)
																										COBJECT(((BgL_nodez00_bglt)
																												BgL_new1138z00_1866)))->
																									BgL_typez00) =
																								((BgL_typez00_bglt)
																									BgL_toz00_56), BUNSPEC);
																							((((BgL_nodezf2effectzf2_bglt)
																										COBJECT((
																												(BgL_nodezf2effectzf2_bglt)
																												BgL_new1138z00_1866)))->
																									BgL_sidezd2effectzd2) =
																								((obj_t) BUNSPEC), BUNSPEC);
																							((((BgL_nodezf2effectzf2_bglt)
																										COBJECT((
																												(BgL_nodezf2effectzf2_bglt)
																												BgL_new1138z00_1866)))->
																									BgL_keyz00) =
																								((obj_t) BINT(((long) -1))),
																								BUNSPEC);
																							{
																								obj_t BgL_auxz00_3123;

																								{	/* Coerce/convert.scm 228 */
																									BgL_nodez00_bglt
																										BgL_arg1765z00_1867;
																									BgL_literalz00_bglt
																										BgL_arg1767z00_1868;
																									BgL_arg1765z00_1867 =
																										BGl_coercez12z12zzcoerce_coercez00
																										(((BgL_nodez00_bglt)
																											BgL_nodez00_1864),
																										BUNSPEC, BgL_fromz00_55,
																										((bool_t) 0));
																									{	/* Coerce/convert.scm 229 */
																										BgL_literalz00_bglt
																											BgL_new1140z00_1871;
																										{	/* Coerce/convert.scm 229 */
																											BgL_literalz00_bglt
																												BgL_new1139z00_1872;
																											BgL_new1139z00_1872 =
																												((BgL_literalz00_bglt)
																												BOBJECT(GC_MALLOC(sizeof
																														(struct
																															BgL_literalz00_bgl))));
																											{	/* Coerce/convert.scm 229 */
																												long
																													BgL_arg1770z00_1873;
																												{	/* Coerce/convert.scm 229 */
																													long
																														BgL_res1991z00_2421;
																													{	/* Coerce/convert.scm 229 */
																														obj_t
																															BgL_classz00_2420;
																														BgL_classz00_2420 =
																															BGl_literalz00zzast_nodez00;
																														BgL_res1991z00_2421
																															=
																															BGL_CLASS_INDEX
																															(BgL_classz00_2420);
																													}
																													BgL_arg1770z00_1873 =
																														BgL_res1991z00_2421;
																												}
																												BGL_OBJECT_CLASS_NUM_SET
																													(((BgL_objectz00_bglt)
																														BgL_new1139z00_1872),
																													BgL_arg1770z00_1873);
																											}
																											{	/* Coerce/convert.scm 229 */
																												BgL_objectz00_bglt
																													BgL_tmpz00_3130;
																												BgL_tmpz00_3130 =
																													((BgL_objectz00_bglt)
																													BgL_new1139z00_1872);
																												BGL_OBJECT_WIDENING_SET
																													(BgL_tmpz00_3130,
																													BFALSE);
																											}
																											((BgL_objectz00_bglt)
																												BgL_new1139z00_1872);
																											BgL_new1140z00_1871 =
																												BgL_new1139z00_1872;
																										}
																										((((BgL_nodez00_bglt)
																													COBJECT((
																															(BgL_nodez00_bglt)
																															BgL_new1140z00_1871)))->
																												BgL_locz00) =
																											((obj_t) BFALSE),
																											BUNSPEC);
																										((((BgL_nodez00_bglt)
																													COBJECT((
																															(BgL_nodez00_bglt)
																															BgL_new1140z00_1871)))->
																												BgL_typez00) =
																											((BgL_typez00_bglt)
																												BgL_toz00_56), BUNSPEC);
																										((((BgL_atomz00_bglt)
																													COBJECT((
																															(BgL_atomz00_bglt)
																															BgL_new1140z00_1871)))->
																												BgL_valuez00) =
																											((obj_t)
																												BGl_string2014z00zzcoerce_convertz00),
																											BUNSPEC);
																										BgL_arg1767z00_1868 =
																											BgL_new1140z00_1871;
																									}
																									{	/* Coerce/convert.scm 227 */
																										obj_t BgL_list1768z00_1869;

																										{	/* Coerce/convert.scm 227 */
																											obj_t BgL_arg1769z00_1870;

																											BgL_arg1769z00_1870 =
																												MAKE_YOUNG_PAIR(
																												((obj_t)
																													BgL_arg1767z00_1868),
																												BNIL);
																											BgL_list1768z00_1869 =
																												MAKE_YOUNG_PAIR(((obj_t)
																													BgL_arg1765z00_1867),
																												BgL_arg1769z00_1870);
																										}
																										BgL_auxz00_3123 =
																											BgL_list1768z00_1869;
																								}}
																								((((BgL_sequencez00_bglt)
																											COBJECT
																											(BgL_new1138z00_1866))->
																										BgL_nodesz00) =
																									((obj_t) BgL_auxz00_3123),
																									BUNSPEC);
																							}
																							((((BgL_sequencez00_bglt)
																										COBJECT
																										(BgL_new1138z00_1866))->
																									BgL_unsafez00) =
																								((bool_t) ((bool_t) 0)),
																								BUNSPEC);
																							((((BgL_sequencez00_bglt)
																										COBJECT
																										(BgL_new1138z00_1866))->
																									BgL_metaz00) =
																								((obj_t) BNIL), BUNSPEC);
																							return ((obj_t)
																								BgL_new1138z00_1866);
																						}
																					}
																				else
																					{	/* Coerce/convert.scm 231 */
																						obj_t BgL_arg1774z00_1877;

																						BgL_arg1774z00_1877 =
																							BGl_currentzd2functionzd2zztools_errorz00
																							();
																						{	/* Coerce/convert.scm 97 */
																							obj_t BgL_arg1520z00_2426;

																							{	/* Coerce/convert.scm 97 */
																								obj_t BgL_arg1523z00_2427;
																								obj_t BgL_arg1524z00_2428;

																								BgL_arg1523z00_2427 =
																									BGl_shapez00zztools_shapez00(
																									((obj_t) BgL_toz00_56));
																								BgL_arg1524z00_2428 =
																									BGl_shapez00zztools_shapez00(
																									((obj_t) BgL_fromz00_55));
																								BgL_arg1520z00_2426 =
																									BGl_bigloozd2typezd2errorzd2msgzd2zz__errorz00
																									(BGl_string2014z00zzcoerce_convertz00,
																									BgL_arg1523z00_2427,
																									BgL_arg1524z00_2428);
																							}
																							return
																								BGl_userzd2errorzf2locationz20zztools_errorz00
																								(BgL_locz00_57,
																								BgL_arg1774z00_1877,
																								BGl_string2015z00zzcoerce_convertz00,
																								BgL_arg1520z00_2426, BNIL);
																						}
																					}
																			}
																	}
															}
													}
											}
									}
							}
					}
			}
		}

	}



/* convert! */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_convertz12z12zzcoerce_convertz00(BgL_nodez00_bglt BgL_nodez00_59,
		BgL_typez00_bglt BgL_fromz00_60, BgL_typez00_bglt BgL_toz00_61,
		bool_t BgL_safez00_62)
	{
		{	/* Coerce/convert.scm 241 */
			if ((((obj_t) BgL_fromz00_60) == ((obj_t) BgL_toz00_61)))
				{	/* Coerce/convert.scm 245 */
					return BgL_nodez00_59;
				}
			else
				{	/* Coerce/convert.scm 247 */
					BgL_typez00_bglt BgL_toz00_1891;
					BgL_typez00_bglt BgL_froz00_1892;

					BgL_toz00_1891 =
						BGl_getzd2aliasedzd2typez00zztype_typez00(BgL_toz00_61);
					BgL_froz00_1892 =
						BGl_getzd2aliasedzd2typez00zztype_typez00(BgL_fromz00_60);
					{	/* Coerce/convert.scm 249 */
						bool_t BgL_test2065z00_3161;

						if ((((obj_t) BgL_froz00_1892) == ((obj_t) BgL_toz00_1891)))
							{	/* Coerce/convert.scm 249 */
								BgL_test2065z00_3161 = ((bool_t) 1);
							}
						else
							{	/* Coerce/convert.scm 249 */
								BgL_test2065z00_3161 =
									(((BgL_typez00_bglt) COBJECT(BgL_froz00_1892))->
									BgL_magiczf3zf3);
							}
						if (BgL_test2065z00_3161)
							{	/* Coerce/convert.scm 249 */
								return BgL_nodez00_59;
							}
						else
							{	/* Coerce/convert.scm 251 */
								obj_t BgL_coercerz00_1895;
								obj_t BgL_locz00_1896;

								BgL_coercerz00_1895 =
									BGl_findzd2coercerzd2zztype_coercionz00(BgL_froz00_1892,
									BgL_toz00_1891);
								BgL_locz00_1896 =
									(((BgL_nodez00_bglt) COBJECT(BgL_nodez00_59))->BgL_locz00);
								{	/* Coerce/convert.scm 253 */
									bool_t BgL_test2067z00_3169;

									if (STRUCTP(BgL_coercerz00_1895))
										{	/* Coerce/convert.scm 253 */
											BgL_test2067z00_3169 =
												(STRUCT_KEY(BgL_coercerz00_1895) ==
												CNST_TABLE_REF(((long) 8)));
										}
									else
										{	/* Coerce/convert.scm 253 */
											BgL_test2067z00_3169 = ((bool_t) 0);
										}
									if (BgL_test2067z00_3169)
										{	/* Coerce/convert.scm 257 */
											obj_t BgL_g1141z00_1898;
											obj_t BgL_g1142z00_1899;

											BgL_g1141z00_1898 =
												STRUCT_REF(BgL_coercerz00_1895, (int) (((long) 2)));
											BgL_g1142z00_1899 =
												STRUCT_REF(BgL_coercerz00_1895, (int) (((long) 3)));
											{
												obj_t BgL_checksz00_1901;
												obj_t BgL_coercesz00_1902;
												BgL_nodez00_bglt BgL_nodez00_1903;

												{
													obj_t BgL_auxz00_3179;

													BgL_checksz00_1901 = BgL_g1141z00_1898;
													BgL_coercesz00_1902 = BgL_g1142z00_1899;
													BgL_nodez00_1903 = BgL_nodez00_59;
												BgL_zc3z04anonymousza31779ze3z87_1904:
													if (NULLP(BgL_checksz00_1901))
														{	/* Coerce/convert.scm 261 */
															if (NULLP(BgL_coercesz00_1902))
																{	/* Coerce/convert.scm 262 */
																	BgL_auxz00_3179 = ((obj_t) BgL_nodez00_1903);
																}
															else
																{	/* Coerce/convert.scm 265 */
																	obj_t BgL_arg1782z00_1907;
																	obj_t BgL_arg1784z00_1908;

																	BgL_arg1782z00_1907 =
																		BGl_shapez00zztools_shapez00(
																		((obj_t) BgL_fromz00_60));
																	BgL_arg1784z00_1908 =
																		BGl_shapez00zztools_shapez00(
																		((obj_t) BgL_toz00_1891));
																	BgL_auxz00_3179 =
																		BGl_internalzd2errorzd2zztools_errorz00
																		(BGl_string2017z00zzcoerce_convertz00,
																		BgL_arg1782z00_1907, BgL_arg1784z00_1908);
																}
														}
													else
														{	/* Coerce/convert.scm 261 */
															if (NULLP(BgL_coercesz00_1902))
																{	/* Coerce/convert.scm 269 */
																	obj_t BgL_arg1786z00_1910;
																	obj_t BgL_arg1787z00_1911;

																	BgL_arg1786z00_1910 =
																		BGl_shapez00zztools_shapez00(
																		((obj_t) BgL_fromz00_60));
																	BgL_arg1787z00_1911 =
																		BGl_shapez00zztools_shapez00(
																		((obj_t) BgL_toz00_1891));
																	BgL_auxz00_3179 =
																		BGl_internalzd2errorzd2zztools_errorz00
																		(BGl_string2017z00zzcoerce_convertz00,
																		BgL_arg1786z00_1910, BgL_arg1787z00_1911);
																}
															else
																{	/* Coerce/convert.scm 272 */
																	obj_t BgL_arg1788z00_1912;
																	obj_t BgL_arg1789z00_1913;
																	BgL_nodez00_bglt BgL_arg1790z00_1914;

																	BgL_arg1788z00_1912 =
																		CDR(((obj_t) BgL_checksz00_1901));
																	BgL_arg1789z00_1913 =
																		CDR(((obj_t) BgL_coercesz00_1902));
																	{	/* Coerce/convert.scm 274 */
																		obj_t BgL_arg1791z00_1915;
																		obj_t BgL_arg1794z00_1916;
																		obj_t BgL_arg1795z00_1917;
																		obj_t BgL_arg1796z00_1918;

																		{	/* Coerce/convert.scm 274 */
																			obj_t BgL_pairz00_2447;

																			BgL_pairz00_2447 =
																				CAR(((obj_t) BgL_checksz00_1901));
																			BgL_arg1791z00_1915 =
																				CDR(BgL_pairz00_2447);
																		}
																		{	/* Coerce/convert.scm 275 */
																			obj_t BgL_pairz00_2451;

																			BgL_pairz00_2451 =
																				CAR(((obj_t) BgL_coercesz00_1902));
																			BgL_arg1794z00_1916 =
																				CDR(BgL_pairz00_2451);
																		}
																		{	/* Coerce/convert.scm 276 */
																			obj_t BgL_pairz00_2455;

																			BgL_pairz00_2455 =
																				CAR(((obj_t) BgL_checksz00_1901));
																			BgL_arg1795z00_1917 =
																				CAR(BgL_pairz00_2455);
																		}
																		{	/* Coerce/convert.scm 277 */
																			obj_t BgL_pairz00_2459;

																			BgL_pairz00_2459 =
																				CAR(((obj_t) BgL_coercesz00_1902));
																			BgL_arg1796z00_1918 =
																				CAR(BgL_pairz00_2459);
																		}
																		BgL_arg1790z00_1914 =
																			BGl_makezd2onezd2conversionz00zzcoerce_convertz00
																			(BgL_arg1791z00_1915, BgL_arg1794z00_1916,
																			BgL_arg1795z00_1917, BgL_arg1796z00_1918,
																			BgL_nodez00_1903, BgL_safez00_62);
																	}
																	{
																		BgL_nodez00_bglt BgL_nodez00_3216;
																		obj_t BgL_coercesz00_3215;
																		obj_t BgL_checksz00_3214;

																		BgL_checksz00_3214 = BgL_arg1788z00_1912;
																		BgL_coercesz00_3215 = BgL_arg1789z00_1913;
																		BgL_nodez00_3216 = BgL_arg1790z00_1914;
																		BgL_nodez00_1903 = BgL_nodez00_3216;
																		BgL_coercesz00_1902 = BgL_coercesz00_3215;
																		BgL_checksz00_1901 = BgL_checksz00_3214;
																		goto BgL_zc3z04anonymousza31779ze3z87_1904;
																	}
																}
														}
													return ((BgL_nodez00_bglt) BgL_auxz00_3179);
												}
											}
										}
									else
										{	/* Coerce/convert.scm 253 */
											return
												((BgL_nodez00_bglt)
												BGl_convertzd2errorzd2zzcoerce_convertz00
												(BgL_froz00_1892, BgL_toz00_1891, BgL_locz00_1896,
													BgL_nodez00_59));
										}
								}
							}
					}
				}
		}

	}



/* &convert! */
	BgL_nodez00_bglt BGl_z62convertz12z70zzcoerce_convertz00(obj_t
		BgL_envz00_2544, obj_t BgL_nodez00_2545, obj_t BgL_fromz00_2546,
		obj_t BgL_toz00_2547, obj_t BgL_safez00_2548)
	{
		{	/* Coerce/convert.scm 241 */
			return
				BGl_convertz12z12zzcoerce_convertz00(
				((BgL_nodez00_bglt) BgL_nodez00_2545),
				((BgL_typez00_bglt) BgL_fromz00_2546),
				((BgL_typez00_bglt) BgL_toz00_2547), CBOOL(BgL_safez00_2548));
		}

	}



/* make-one-conversion */
	BgL_nodez00_bglt BGl_makezd2onezd2conversionz00zzcoerce_convertz00(obj_t
		BgL_fromz00_63, obj_t BgL_toz00_64, obj_t BgL_checkopz00_65,
		obj_t BgL_coerceopz00_66, BgL_nodez00_bglt BgL_nodez00_67,
		bool_t BgL_safez00_68)
	{
		{	/* Coerce/convert.scm 290 */
			{	/* Coerce/convert.scm 291 */
				bool_t BgL_test2072z00_3225;

				if ((BgL_checkopz00_65 == BTRUE))
					{	/* Coerce/convert.scm 291 */
						BgL_test2072z00_3225 = ((bool_t) 1);
					}
				else
					{	/* Coerce/convert.scm 291 */
						if (BgL_safez00_68)
							{	/* Coerce/convert.scm 291 */
								BgL_test2072z00_3225 = ((bool_t) 0);
							}
						else
							{	/* Coerce/convert.scm 291 */
								BgL_test2072z00_3225 = ((bool_t) 1);
							}
					}
				if (BgL_test2072z00_3225)
					{	/* Coerce/convert.scm 291 */
						return
							BGl_dozd2convertzd2zzcoerce_convertz00(BgL_coerceopz00_66,
							BgL_nodez00_67, ((BgL_typez00_bglt) BgL_fromz00_63));
					}
				else
					{	/* Coerce/convert.scm 291 */
						if (BGl_isazf3zf3zz__objectz00(BgL_fromz00_63,
								BGl_tclassz00zzobject_classz00))
							{	/* Coerce/convert.scm 293 */
								return
									BGl_makezd2onezd2classzd2conversionzd2zzcoerce_convertz00(
									((BgL_typez00_bglt) BgL_fromz00_63), BgL_toz00_64,
									BgL_checkopz00_65, BgL_coerceopz00_66, BgL_nodez00_67);
							}
						else
							{	/* Coerce/convert.scm 293 */
								return
									BGl_makezd2onezd2typezd2conversionzd2zzcoerce_convertz00
									(BgL_fromz00_63, BgL_toz00_64, BgL_checkopz00_65,
									BgL_coerceopz00_66, BgL_nodez00_67);
							}
					}
			}
		}

	}



/* skip-let-var */
	BgL_nodez00_bglt BGl_skipzd2letzd2varz00zzcoerce_convertz00(BgL_nodez00_bglt
		BgL_nodez00_69)
	{
		{	/* Coerce/convert.scm 300 */
		BGl_skipzd2letzd2varz00zzcoerce_convertz00:
			{	/* Coerce/convert.scm 301 */
				bool_t BgL_test2076z00_3236;

				{	/* Coerce/convert.scm 301 */
					bool_t BgL_res1999z00_2461;

					BgL_res1999z00_2461 =
						BGl_isazf3zf3zz__objectz00(
						((obj_t) BgL_nodez00_69), BGl_letzd2varzd2zzast_nodez00);
					BgL_test2076z00_3236 = BgL_res1999z00_2461;
				}
				if (BgL_test2076z00_3236)
					{	/* Coerce/convert.scm 302 */
						BgL_nodez00_bglt BgL_arg1801z00_1926;

						BgL_arg1801z00_1926 =
							(((BgL_letzd2varzd2_bglt) COBJECT(
									((BgL_letzd2varzd2_bglt) BgL_nodez00_69)))->BgL_bodyz00);
						{
							BgL_nodez00_bglt BgL_nodez00_3241;

							BgL_nodez00_3241 = BgL_arg1801z00_1926;
							BgL_nodez00_69 = BgL_nodez00_3241;
							goto BGl_skipzd2letzd2varz00zzcoerce_convertz00;
						}
					}
				else
					{	/* Coerce/convert.scm 301 */
						return BgL_nodez00_69;
					}
			}
		}

	}



/* make-one-type-conversion */
	BgL_nodez00_bglt
		BGl_makezd2onezd2typezd2conversionzd2zzcoerce_convertz00(obj_t
		BgL_fromz00_70, obj_t BgL_toz00_71, obj_t BgL_checkzd2opzd2_72,
		obj_t BgL_coercezd2opzd2_73, BgL_nodez00_bglt BgL_nodez00_74)
	{
		{	/* Coerce/convert.scm 308 */
			{	/* Coerce/convert.scm 311 */
				obj_t BgL_auxz00_1927;

				BgL_auxz00_1927 =
					BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
					(BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 5))));
				{	/* Coerce/convert.scm 311 */
					obj_t BgL_locz00_1928;

					BgL_locz00_1928 =
						(((BgL_nodez00_bglt) COBJECT(BgL_nodez00_74))->BgL_locz00);
					{	/* Coerce/convert.scm 312 */
						BgL_nodez00_bglt BgL_lnodez00_1929;

						{	/* Coerce/convert.scm 320 */
							obj_t BgL_arg1813z00_1943;

							{	/* Coerce/convert.scm 320 */
								obj_t BgL_arg1814z00_1944;

								{	/* Coerce/convert.scm 320 */
									obj_t BgL_arg1815z00_1945;
									obj_t BgL_arg1817z00_1946;

									{	/* Coerce/convert.scm 320 */
										obj_t BgL_arg1818z00_1947;

										{	/* Coerce/convert.scm 320 */
											obj_t BgL_arg1819z00_1948;
											obj_t BgL_arg1821z00_1949;

											{	/* Coerce/convert.scm 320 */
												obj_t BgL_arg1822z00_1950;

												{	/* Coerce/convert.scm 320 */
													obj_t BgL_arg1823z00_1951;

													BgL_arg1823z00_1951 =
														(((BgL_typez00_bglt) COBJECT(
																((BgL_typez00_bglt) BgL_fromz00_70)))->
														BgL_idz00);
													BgL_arg1822z00_1950 =
														BGl_makezd2typedzd2identz00zzast_identz00
														(BgL_auxz00_1927, BgL_arg1823z00_1951);
												}
												BgL_arg1819z00_1948 =
													BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
													(BgL_arg1822z00_1950);
											}
											BgL_arg1821z00_1949 = MAKE_YOUNG_PAIR(BUNSPEC, BNIL);
											BgL_arg1818z00_1947 =
												MAKE_YOUNG_PAIR(BgL_arg1819z00_1948,
												BgL_arg1821z00_1949);
										}
										BgL_arg1815z00_1945 =
											MAKE_YOUNG_PAIR(BgL_arg1818z00_1947, BNIL);
									}
									{	/* Coerce/convert.scm 322 */
										obj_t BgL_arg1824z00_1952;

										{	/* Coerce/convert.scm 322 */
											obj_t BgL_arg1825z00_1953;

											{	/* Coerce/convert.scm 322 */
												obj_t BgL_arg1826z00_1954;
												obj_t BgL_arg1827z00_1955;

												{	/* Coerce/convert.scm 322 */
													obj_t BgL_arg1829z00_1956;

													BgL_arg1829z00_1956 =
														MAKE_YOUNG_PAIR(BgL_auxz00_1927, BNIL);
													BgL_arg1826z00_1954 =
														MAKE_YOUNG_PAIR(BgL_checkzd2opzd2_72,
														BgL_arg1829z00_1956);
												}
												{	/* Coerce/convert.scm 324 */
													obj_t BgL_arg1830z00_1957;

													{	/* Coerce/convert.scm 324 */
														obj_t BgL_arg1832z00_1958;

														{	/* Coerce/convert.scm 324 */
															obj_t BgL_arg1833z00_1959;

															BgL_arg1833z00_1959 =
																(((BgL_typez00_bglt) COBJECT(
																		((BgL_typez00_bglt) BgL_toz00_71)))->
																BgL_idz00);
															BgL_arg1832z00_1958 =
																BGl_runtimezd2typezd2errorzf2idzf2zzcoerce_convertz00
																(BgL_locz00_1928, BgL_arg1833z00_1959,
																BgL_auxz00_1927);
														}
														BgL_arg1830z00_1957 =
															MAKE_YOUNG_PAIR(BgL_arg1832z00_1958, BNIL);
													}
													BgL_arg1827z00_1955 =
														MAKE_YOUNG_PAIR(BgL_auxz00_1927,
														BgL_arg1830z00_1957);
												}
												BgL_arg1825z00_1953 =
													MAKE_YOUNG_PAIR(BgL_arg1826z00_1954,
													BgL_arg1827z00_1955);
											}
											BgL_arg1824z00_1952 =
												MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 9)),
												BgL_arg1825z00_1953);
										}
										BgL_arg1817z00_1946 =
											MAKE_YOUNG_PAIR(BgL_arg1824z00_1952, BNIL);
									}
									BgL_arg1814z00_1944 =
										MAKE_YOUNG_PAIR(BgL_arg1815z00_1945, BgL_arg1817z00_1946);
								}
								BgL_arg1813z00_1943 =
									MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 7)),
									BgL_arg1814z00_1944);
							}
							BgL_lnodez00_1929 =
								BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00
								(BgL_arg1813z00_1943, BgL_locz00_1928);
						}
						{	/* Coerce/convert.scm 313 */

							BGl_za2checkza2z00zzcoerce_convertz00 =
								(((long) 1) + BGl_za2checkza2z00zzcoerce_convertz00);
							if (CBOOL(BGl_za2warningzd2typesza2zd2zzengine_paramz00))
								{	/* Coerce/convert.scm 83 */
									BGl_notifyzd2typezd2testz00zzcoerce_convertz00(BgL_fromz00_70,
										BgL_toz00_71, BgL_locz00_1928);
								}
							else
								{	/* Coerce/convert.scm 83 */
									BFALSE;
								}
							BGl_spreadzd2sidezd2effectz12z12zzeffect_spreadz00
								(BgL_lnodez00_1929);
							{	/* Coerce/convert.scm 328 */
								obj_t BgL_varz00_1930;

								{	/* Coerce/convert.scm 328 */
									obj_t BgL_pairz00_2470;

									{	/* Coerce/convert.scm 328 */
										obj_t BgL_pairz00_2469;

										BgL_pairz00_2469 =
											(((BgL_letzd2varzd2_bglt) COBJECT(
													((BgL_letzd2varzd2_bglt) BgL_lnodez00_1929)))->
											BgL_bindingsz00);
										BgL_pairz00_2470 = CAR(BgL_pairz00_2469);
									}
									BgL_varz00_1930 = CAR(BgL_pairz00_2470);
								}
								{	/* Coerce/convert.scm 328 */
									BgL_nodez00_bglt BgL_coercezd2appzd2_1931;

									{	/* Coerce/convert.scm 330 */
										BgL_varz00_bglt BgL_arg1807z00_1937;

										{	/* Coerce/convert.scm 330 */
											BgL_varz00_bglt BgL_new1144z00_1938;

											{	/* Coerce/convert.scm 331 */
												BgL_varz00_bglt BgL_new1143z00_1939;

												BgL_new1143z00_1939 =
													((BgL_varz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
																BgL_varz00_bgl))));
												{	/* Coerce/convert.scm 331 */
													long BgL_arg1809z00_1940;

													{	/* Coerce/convert.scm 331 */
														long BgL_res2001z00_2472;

														BgL_res2001z00_2472 =
															BGL_CLASS_INDEX(BGl_varz00zzast_nodez00);
														BgL_arg1809z00_1940 = BgL_res2001z00_2472;
													}
													BGL_OBJECT_CLASS_NUM_SET(
														((BgL_objectz00_bglt) BgL_new1143z00_1939),
														BgL_arg1809z00_1940);
												}
												BgL_new1144z00_1938 = BgL_new1143z00_1939;
											}
											((((BgL_nodez00_bglt) COBJECT(
															((BgL_nodez00_bglt) BgL_new1144z00_1938)))->
													BgL_locz00) = ((obj_t) BgL_locz00_1928), BUNSPEC);
											((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
																BgL_new1144z00_1938)))->BgL_typez00) =
												((BgL_typez00_bglt)
													BGl_strictzd2nodezd2typez00zzast_nodez00((
															(BgL_typez00_bglt) BgL_toz00_71),
														((BgL_typez00_bglt) BgL_fromz00_70))), BUNSPEC);
											((((BgL_varz00_bglt) COBJECT(BgL_new1144z00_1938))->
													BgL_variablez00) =
												((BgL_variablez00_bglt) ((BgL_variablez00_bglt)
														BgL_varz00_1930)), BUNSPEC);
											BgL_arg1807z00_1937 = BgL_new1144z00_1938;
										}
										BgL_coercezd2appzd2_1931 =
											BGl_dozd2convertzd2zzcoerce_convertz00
											(BgL_coercezd2opzd2_73,
											((BgL_nodez00_bglt) BgL_arg1807z00_1937),
											((BgL_typez00_bglt) BgL_fromz00_70));
									}
									{	/* Coerce/convert.scm 329 */
										BgL_nodez00_bglt BgL_condnz00_1932;

										BgL_condnz00_1932 =
											BGl_skipzd2letzd2varz00zzcoerce_convertz00
											(BgL_lnodez00_1929);
										{	/* Coerce/convert.scm 335 */

											((((BgL_variablez00_bglt) COBJECT(
															((BgL_variablez00_bglt)
																((BgL_localz00_bglt) BgL_varz00_1930))))->
													BgL_typez00) =
												((BgL_typez00_bglt) ((BgL_typez00_bglt)
														BgL_fromz00_70)), BUNSPEC);
											{	/* Coerce/convert.scm 339 */
												obj_t BgL_arg1802z00_1933;

												{	/* Coerce/convert.scm 339 */
													obj_t BgL_pairz00_2478;

													BgL_pairz00_2478 =
														(((BgL_letzd2varzd2_bglt) COBJECT(
																((BgL_letzd2varzd2_bglt) BgL_lnodez00_1929)))->
														BgL_bindingsz00);
													BgL_arg1802z00_1933 = CAR(BgL_pairz00_2478);
												}
												{	/* Coerce/convert.scm 339 */
													obj_t BgL_auxz00_3303;
													obj_t BgL_tmpz00_3301;

													BgL_auxz00_3303 = ((obj_t) BgL_nodez00_74);
													BgL_tmpz00_3301 = ((obj_t) BgL_arg1802z00_1933);
													SET_CDR(BgL_tmpz00_3301, BgL_auxz00_3303);
											}}
											((((BgL_nodez00_bglt) COBJECT(BgL_nodez00_74))->
													BgL_typez00) =
												((BgL_typez00_bglt) ((BgL_typez00_bglt)
														BgL_fromz00_70)), BUNSPEC);
											((((BgL_conditionalz00_bglt)
														COBJECT(((BgL_conditionalz00_bglt)
																BgL_condnz00_1932)))->BgL_truez00) =
												((BgL_nodez00_bglt) BgL_coercezd2appzd2_1931), BUNSPEC);
											{	/* Coerce/convert.scm 343 */
												BgL_nodez00_bglt BgL_arg1805z00_1935;

												{	/* Coerce/convert.scm 343 */
													BgL_nodez00_bglt BgL_arg1806z00_1936;

													BgL_arg1806z00_1936 =
														(((BgL_conditionalz00_bglt) COBJECT(
																((BgL_conditionalz00_bglt)
																	BgL_condnz00_1932)))->BgL_falsez00);
													BgL_arg1805z00_1935 =
														BGl_coercez12z12zzcoerce_coercez00
														(BgL_arg1806z00_1936, BUNSPEC,
														((BgL_typez00_bglt) BgL_fromz00_70), ((bool_t) 0));
												}
												((((BgL_conditionalz00_bglt) COBJECT(
																((BgL_conditionalz00_bglt)
																	BgL_condnz00_1932)))->BgL_falsez00) =
													((BgL_nodez00_bglt) BgL_arg1805z00_1935), BUNSPEC);
											}
											BGl_lvtypezd2nodez12zc0zzast_lvtypez00(BgL_lnodez00_1929);
											return BgL_lnodez00_1929;
										}
									}
								}
							}
						}
					}
				}
			}
		}

	}



/* make-one-class-conversion */
	BgL_nodez00_bglt
		BGl_makezd2onezd2classzd2conversionzd2zzcoerce_convertz00(BgL_typez00_bglt
		BgL_fromz00_75, obj_t BgL_toz00_76, obj_t BgL_checkzd2opzd2_77,
		obj_t BgL_coercezd2opzd2_78, BgL_nodez00_bglt BgL_nodez00_79)
	{
		{	/* Coerce/convert.scm 353 */
			{	/* Coerce/convert.scm 354 */
				bool_t BgL_test2078z00_3317;

				if (BGl_isazf3zf3zz__objectz00(BgL_toz00_76,
						BGl_tclassz00zzobject_classz00))
					{	/* Coerce/convert.scm 354 */
						BgL_test2078z00_3317 =
							BGl_typezd2subclasszf3z21zzobject_classz00(
							((BgL_typez00_bglt) BgL_fromz00_75),
							((BgL_typez00_bglt) ((BgL_typez00_bglt) BgL_toz00_76)));
					}
				else
					{	/* Coerce/convert.scm 354 */
						BgL_test2078z00_3317 = ((bool_t) 0);
					}
				if (BgL_test2078z00_3317)
					{	/* Coerce/convert.scm 354 */
						return
							BGl_dozd2convertzd2zzcoerce_convertz00(BgL_coercezd2opzd2_78,
							BgL_nodez00_79, ((BgL_typez00_bglt) BgL_fromz00_75));
					}
				else
					{	/* Coerce/convert.scm 356 */
						obj_t BgL_auxz00_1963;

						BgL_auxz00_1963 =
							BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 5)));
						{	/* Coerce/convert.scm 356 */
							obj_t BgL_aux2z00_1964;

							BgL_aux2z00_1964 =
								BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 10)));
							{	/* Coerce/convert.scm 357 */
								obj_t BgL_locz00_1965;

								BgL_locz00_1965 =
									(((BgL_nodez00_bglt) COBJECT(BgL_nodez00_79))->BgL_locz00);
								{	/* Coerce/convert.scm 358 */
									BgL_nodez00_bglt BgL_lnodez00_1966;

									{	/* Coerce/convert.scm 361 */
										obj_t BgL_arg1855z00_1990;

										{	/* Coerce/convert.scm 361 */
											obj_t BgL_arg1856z00_1991;

											{	/* Coerce/convert.scm 361 */
												obj_t BgL_arg1857z00_1992;
												obj_t BgL_arg1858z00_1993;

												{	/* Coerce/convert.scm 361 */
													obj_t BgL_arg1859z00_1994;

													{	/* Coerce/convert.scm 361 */
														obj_t BgL_arg1860z00_1995;
														obj_t BgL_arg1861z00_1996;

														{	/* Coerce/convert.scm 361 */
															obj_t BgL_arg1863z00_1997;

															{	/* Coerce/convert.scm 361 */
																obj_t BgL_arg1864z00_1998;

																{	/* Coerce/convert.scm 361 */
																	obj_t BgL_arg1865z00_1999;
																	obj_t BgL_arg1866z00_2000;

																	{	/* Coerce/convert.scm 361 */
																		obj_t BgL_res2003z00_2491;

																		{	/* Coerce/convert.scm 361 */
																			obj_t BgL_arg1409z00_2490;

																			BgL_arg1409z00_2490 =
																				SYMBOL_TO_STRING(BgL_auxz00_1963);
																			BgL_res2003z00_2491 =
																				BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																				(BgL_arg1409z00_2490);
																		}
																		BgL_arg1865z00_1999 = BgL_res2003z00_2491;
																	}
																	{	/* Coerce/convert.scm 361 */
																		obj_t BgL_res2004z00_2494;

																		{	/* Coerce/convert.scm 361 */
																			obj_t BgL_symbolz00_2492;

																			BgL_symbolz00_2492 =
																				CNST_TABLE_REF(((long) 6));
																			{	/* Coerce/convert.scm 361 */
																				obj_t BgL_arg1409z00_2493;

																				BgL_arg1409z00_2493 =
																					SYMBOL_TO_STRING(BgL_symbolz00_2492);
																				BgL_res2004z00_2494 =
																					BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																					(BgL_arg1409z00_2493);
																		}}
																		BgL_arg1866z00_2000 = BgL_res2004z00_2494;
																	}
																	BgL_arg1864z00_1998 =
																		string_append(BgL_arg1865z00_1999,
																		BgL_arg1866z00_2000);
																}
																BgL_arg1863z00_1997 =
																	bstring_to_symbol(BgL_arg1864z00_1998);
															}
															BgL_arg1860z00_1995 =
																BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
																(BgL_arg1863z00_1997);
														}
														BgL_arg1861z00_1996 =
															MAKE_YOUNG_PAIR(BUNSPEC, BNIL);
														BgL_arg1859z00_1994 =
															MAKE_YOUNG_PAIR(BgL_arg1860z00_1995,
															BgL_arg1861z00_1996);
													}
													BgL_arg1857z00_1992 =
														MAKE_YOUNG_PAIR(BgL_arg1859z00_1994, BNIL);
												}
												{	/* Coerce/convert.scm 363 */
													obj_t BgL_arg1867z00_2001;

													{	/* Coerce/convert.scm 363 */
														obj_t BgL_arg1868z00_2002;

														{	/* Coerce/convert.scm 363 */
															obj_t BgL_arg1870z00_2003;
															obj_t BgL_arg1871z00_2004;

															{	/* Coerce/convert.scm 363 */
																obj_t BgL_arg1872z00_2005;

																{	/* Coerce/convert.scm 363 */
																	obj_t BgL_arg1873z00_2006;
																	obj_t BgL_arg1874z00_2007;

																	{	/* Coerce/convert.scm 363 */
																		obj_t BgL_arg1875z00_2008;

																		{	/* Coerce/convert.scm 363 */
																			obj_t BgL_arg1876z00_2009;

																			{	/* Coerce/convert.scm 363 */
																				obj_t BgL_arg1877z00_2010;
																				obj_t BgL_arg1878z00_2011;

																				{	/* Coerce/convert.scm 363 */
																					obj_t BgL_res2006z00_2499;

																					{	/* Coerce/convert.scm 363 */
																						obj_t BgL_arg1409z00_2498;

																						BgL_arg1409z00_2498 =
																							SYMBOL_TO_STRING
																							(BgL_aux2z00_1964);
																						BgL_res2006z00_2499 =
																							BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																							(BgL_arg1409z00_2498);
																					}
																					BgL_arg1877z00_2010 =
																						BgL_res2006z00_2499;
																				}
																				{	/* Coerce/convert.scm 363 */
																					obj_t BgL_res2007z00_2502;

																					{	/* Coerce/convert.scm 363 */
																						obj_t BgL_symbolz00_2500;

																						BgL_symbolz00_2500 =
																							CNST_TABLE_REF(((long) 6));
																						{	/* Coerce/convert.scm 363 */
																							obj_t BgL_arg1409z00_2501;

																							BgL_arg1409z00_2501 =
																								SYMBOL_TO_STRING
																								(BgL_symbolz00_2500);
																							BgL_res2007z00_2502 =
																								BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																								(BgL_arg1409z00_2501);
																					}}
																					BgL_arg1878z00_2011 =
																						BgL_res2007z00_2502;
																				}
																				BgL_arg1876z00_2009 =
																					string_append(BgL_arg1877z00_2010,
																					BgL_arg1878z00_2011);
																			}
																			BgL_arg1875z00_2008 =
																				bstring_to_symbol(BgL_arg1876z00_2009);
																		}
																		BgL_arg1873z00_2006 =
																			BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
																			(BgL_arg1875z00_2008);
																	}
																	BgL_arg1874z00_2007 =
																		MAKE_YOUNG_PAIR(BUNSPEC, BNIL);
																	BgL_arg1872z00_2005 =
																		MAKE_YOUNG_PAIR(BgL_arg1873z00_2006,
																		BgL_arg1874z00_2007);
																}
																BgL_arg1870z00_2003 =
																	MAKE_YOUNG_PAIR(BgL_arg1872z00_2005, BNIL);
															}
															{	/* Coerce/convert.scm 364 */
																obj_t BgL_arg1879z00_2012;

																{	/* Coerce/convert.scm 364 */
																	obj_t BgL_arg1880z00_2013;

																	{	/* Coerce/convert.scm 364 */
																		obj_t BgL_arg1881z00_2014;
																		obj_t BgL_arg1882z00_2015;

																		{	/* Coerce/convert.scm 364 */
																			obj_t BgL_arg1884z00_2016;

																			BgL_arg1884z00_2016 =
																				MAKE_YOUNG_PAIR(BgL_aux2z00_1964, BNIL);
																			BgL_arg1881z00_2014 =
																				MAKE_YOUNG_PAIR(BgL_checkzd2opzd2_77,
																				BgL_arg1884z00_2016);
																		}
																		{	/* Coerce/convert.scm 366 */
																			obj_t BgL_arg1885z00_2017;

																			{	/* Coerce/convert.scm 366 */
																				obj_t BgL_arg1886z00_2018;

																				{	/* Coerce/convert.scm 366 */
																					obj_t BgL_arg1887z00_2019;

																					BgL_arg1887z00_2019 =
																						(((BgL_typez00_bglt) COBJECT(
																								((BgL_typez00_bglt)
																									BgL_toz00_76)))->BgL_idz00);
																					BgL_arg1886z00_2018 =
																						BGl_runtimezd2typezd2errorzf2idzf2zzcoerce_convertz00
																						(BgL_locz00_1965,
																						BgL_arg1887z00_2019,
																						BgL_auxz00_1963);
																				}
																				BgL_arg1885z00_2017 =
																					MAKE_YOUNG_PAIR(BgL_arg1886z00_2018,
																					BNIL);
																			}
																			BgL_arg1882z00_2015 =
																				MAKE_YOUNG_PAIR(BgL_auxz00_1963,
																				BgL_arg1885z00_2017);
																		}
																		BgL_arg1880z00_2013 =
																			MAKE_YOUNG_PAIR(BgL_arg1881z00_2014,
																			BgL_arg1882z00_2015);
																	}
																	BgL_arg1879z00_2012 =
																		MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 9)),
																		BgL_arg1880z00_2013);
																}
																BgL_arg1871z00_2004 =
																	MAKE_YOUNG_PAIR(BgL_arg1879z00_2012, BNIL);
															}
															BgL_arg1868z00_2002 =
																MAKE_YOUNG_PAIR(BgL_arg1870z00_2003,
																BgL_arg1871z00_2004);
														}
														BgL_arg1867z00_2001 =
															MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 7)),
															BgL_arg1868z00_2002);
													}
													BgL_arg1858z00_1993 =
														MAKE_YOUNG_PAIR(BgL_arg1867z00_2001, BNIL);
												}
												BgL_arg1856z00_1991 =
													MAKE_YOUNG_PAIR(BgL_arg1857z00_1992,
													BgL_arg1858z00_1993);
											}
											BgL_arg1855z00_1990 =
												MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 7)),
												BgL_arg1856z00_1991);
										}
										BgL_lnodez00_1966 =
											BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00
											(BgL_arg1855z00_1990, BgL_locz00_1965);
									}
									{	/* Coerce/convert.scm 359 */

										BGl_za2checkza2z00zzcoerce_convertz00 =
											(((long) 1) + BGl_za2checkza2z00zzcoerce_convertz00);
										if (CBOOL(BGl_za2warningzd2typesza2zd2zzengine_paramz00))
											{	/* Coerce/convert.scm 83 */
												BGl_notifyzd2typezd2testz00zzcoerce_convertz00(
													((obj_t) BgL_fromz00_75), BgL_toz00_76,
													BgL_locz00_1965);
											}
										else
											{	/* Coerce/convert.scm 83 */
												BFALSE;
											}
										BGl_spreadzd2sidezd2effectz12z12zzeffect_spreadz00
											(BgL_lnodez00_1966);
										{	/* Coerce/convert.scm 370 */
											obj_t BgL_varz00_1967;

											{	/* Coerce/convert.scm 370 */
												obj_t BgL_pairz00_2510;

												{	/* Coerce/convert.scm 370 */
													obj_t BgL_pairz00_2509;

													BgL_pairz00_2509 =
														(((BgL_letzd2varzd2_bglt) COBJECT(
																((BgL_letzd2varzd2_bglt) BgL_lnodez00_1966)))->
														BgL_bindingsz00);
													BgL_pairz00_2510 = CAR(BgL_pairz00_2509);
												}
												BgL_varz00_1967 = CAR(BgL_pairz00_2510);
											}
											{	/* Coerce/convert.scm 370 */
												BgL_nodez00_bglt BgL_coercezd2appzd2_1968;

												{	/* Coerce/convert.scm 372 */
													BgL_varz00_bglt BgL_arg1851z00_1984;

													{	/* Coerce/convert.scm 372 */
														BgL_varz00_bglt BgL_new1146z00_1985;

														{	/* Coerce/convert.scm 373 */
															BgL_varz00_bglt BgL_new1145z00_1986;

															BgL_new1145z00_1986 =
																((BgL_varz00_bglt)
																BOBJECT(GC_MALLOC(sizeof(struct
																			BgL_varz00_bgl))));
															{	/* Coerce/convert.scm 373 */
																long BgL_arg1852z00_1987;

																{	/* Coerce/convert.scm 373 */
																	long BgL_res2010z00_2512;

																	BgL_res2010z00_2512 =
																		BGL_CLASS_INDEX(BGl_varz00zzast_nodez00);
																	BgL_arg1852z00_1987 = BgL_res2010z00_2512;
																}
																BGL_OBJECT_CLASS_NUM_SET(
																	((BgL_objectz00_bglt) BgL_new1145z00_1986),
																	BgL_arg1852z00_1987);
															}
															BgL_new1146z00_1985 = BgL_new1145z00_1986;
														}
														((((BgL_nodez00_bglt) COBJECT(
																		((BgL_nodez00_bglt) BgL_new1146z00_1985)))->
																BgL_locz00) =
															((obj_t) BgL_locz00_1965), BUNSPEC);
														((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
																			BgL_new1146z00_1985)))->BgL_typez00) =
															((BgL_typez00_bglt) ((BgL_typez00_bglt)
																	BgL_fromz00_75)), BUNSPEC);
														((((BgL_varz00_bglt) COBJECT(BgL_new1146z00_1985))->
																BgL_variablez00) =
															((BgL_variablez00_bglt) ((BgL_variablez00_bglt)
																	BgL_varz00_1967)), BUNSPEC);
														BgL_arg1851z00_1984 = BgL_new1146z00_1985;
													}
													BgL_coercezd2appzd2_1968 =
														BGl_dozd2convertzd2zzcoerce_convertz00
														(BgL_coercezd2opzd2_78,
														((BgL_nodez00_bglt) BgL_arg1851z00_1984),
														((BgL_typez00_bglt) BgL_fromz00_75));
												}
												{	/* Coerce/convert.scm 371 */
													BgL_nodez00_bglt BgL_condnz00_1969;

													BgL_condnz00_1969 =
														BGl_skipzd2letzd2varz00zzcoerce_convertz00
														(BgL_lnodez00_1966);
													{	/* Coerce/convert.scm 377 */

														((((BgL_variablez00_bglt) COBJECT(
																		((BgL_variablez00_bglt)
																			((BgL_localz00_bglt) BgL_varz00_1967))))->
																BgL_typez00) =
															((BgL_typez00_bglt) ((BgL_typez00_bglt)
																	BgL_fromz00_75)), BUNSPEC);
														{	/* Coerce/convert.scm 381 */
															obj_t BgL_arg1837z00_1970;

															{	/* Coerce/convert.scm 381 */
																obj_t BgL_pairz00_2518;

																BgL_pairz00_2518 =
																	(((BgL_letzd2varzd2_bglt) COBJECT(
																			((BgL_letzd2varzd2_bglt)
																				BgL_lnodez00_1966)))->BgL_bindingsz00);
																BgL_arg1837z00_1970 = CAR(BgL_pairz00_2518);
															}
															{	/* Coerce/convert.scm 381 */
																obj_t BgL_auxz00_3406;
																obj_t BgL_tmpz00_3404;

																BgL_auxz00_3406 = ((obj_t) BgL_nodez00_79);
																BgL_tmpz00_3404 = ((obj_t) BgL_arg1837z00_1970);
																SET_CDR(BgL_tmpz00_3404, BgL_auxz00_3406);
														}}
														{	/* Coerce/convert.scm 382 */
															obj_t BgL_binding2z00_1972;

															{	/* Coerce/convert.scm 382 */
																obj_t BgL_pairz00_2522;

																BgL_pairz00_2522 =
																	(((BgL_letzd2varzd2_bglt) COBJECT(
																			((BgL_letzd2varzd2_bglt)
																				(((BgL_letzd2varzd2_bglt) COBJECT(
																							((BgL_letzd2varzd2_bglt)
																								BgL_lnodez00_1966)))->
																					BgL_bodyz00))))->BgL_bindingsz00);
																BgL_binding2z00_1972 = CAR(BgL_pairz00_2522);
															}
															{	/* Coerce/convert.scm 383 */
																BgL_castz00_bglt BgL_arg1839z00_1973;

																{	/* Coerce/convert.scm 383 */
																	BgL_castz00_bglt BgL_new1148z00_1974;

																	{	/* Coerce/convert.scm 384 */
																		BgL_castz00_bglt BgL_new1147z00_1978;

																		BgL_new1147z00_1978 =
																			((BgL_castz00_bglt)
																			BOBJECT(GC_MALLOC(sizeof(struct
																						BgL_castz00_bgl))));
																		{	/* Coerce/convert.scm 384 */
																			long BgL_arg1842z00_1979;

																			{	/* Coerce/convert.scm 384 */
																				long BgL_res2011z00_2524;

																				BgL_res2011z00_2524 =
																					BGL_CLASS_INDEX
																					(BGl_castz00zzast_nodez00);
																				BgL_arg1842z00_1979 =
																					BgL_res2011z00_2524;
																			}
																			BGL_OBJECT_CLASS_NUM_SET(
																				((BgL_objectz00_bglt)
																					BgL_new1147z00_1978),
																				BgL_arg1842z00_1979);
																		}
																		{	/* Coerce/convert.scm 384 */
																			BgL_objectz00_bglt BgL_tmpz00_3418;

																			BgL_tmpz00_3418 =
																				((BgL_objectz00_bglt)
																				BgL_new1147z00_1978);
																			BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3418,
																				BFALSE);
																		}
																		((BgL_objectz00_bglt) BgL_new1147z00_1978);
																		BgL_new1148z00_1974 = BgL_new1147z00_1978;
																	}
																	((((BgL_nodez00_bglt) COBJECT(
																					((BgL_nodez00_bglt)
																						BgL_new1148z00_1974)))->
																			BgL_locz00) =
																		((obj_t) BgL_locz00_1965), BUNSPEC);
																	((((BgL_nodez00_bglt)
																				COBJECT(((BgL_nodez00_bglt)
																						BgL_new1148z00_1974)))->
																			BgL_typez00) =
																		((BgL_typez00_bglt) ((BgL_typez00_bglt)
																				BGl_za2objza2z00zztype_cachez00)),
																		BUNSPEC);
																	{
																		BgL_nodez00_bglt BgL_auxz00_3427;

																		{	/* Coerce/convert.scm 386 */
																			BgL_varz00_bglt BgL_new1150z00_1975;

																			{	/* Coerce/convert.scm 387 */
																				BgL_varz00_bglt BgL_new1149z00_1976;

																				BgL_new1149z00_1976 =
																					((BgL_varz00_bglt)
																					BOBJECT(GC_MALLOC(sizeof(struct
																								BgL_varz00_bgl))));
																				{	/* Coerce/convert.scm 387 */
																					long BgL_arg1840z00_1977;

																					{	/* Coerce/convert.scm 387 */
																						long BgL_res2012z00_2529;

																						{	/* Coerce/convert.scm 387 */
																							obj_t BgL_classz00_2528;

																							BgL_classz00_2528 =
																								BGl_varz00zzast_nodez00;
																							BgL_res2012z00_2529 =
																								BGL_CLASS_INDEX
																								(BgL_classz00_2528);
																						}
																						BgL_arg1840z00_1977 =
																							BgL_res2012z00_2529;
																					}
																					BGL_OBJECT_CLASS_NUM_SET(
																						((BgL_objectz00_bglt)
																							BgL_new1149z00_1976),
																						BgL_arg1840z00_1977);
																				}
																				BgL_new1150z00_1975 =
																					BgL_new1149z00_1976;
																			}
																			((((BgL_nodez00_bglt) COBJECT(
																							((BgL_nodez00_bglt)
																								BgL_new1150z00_1975)))->
																					BgL_locz00) =
																				((obj_t) BgL_locz00_1965), BUNSPEC);
																			((((BgL_nodez00_bglt)
																						COBJECT(((BgL_nodez00_bglt)
																								BgL_new1150z00_1975)))->
																					BgL_typez00) =
																				((BgL_typez00_bglt) ((BgL_typez00_bglt)
																						BgL_fromz00_75)), BUNSPEC);
																			((((BgL_varz00_bglt)
																						COBJECT(BgL_new1150z00_1975))->
																					BgL_variablez00) =
																				((BgL_variablez00_bglt) (
																						(BgL_variablez00_bglt)
																						BgL_varz00_1967)), BUNSPEC);
																			BgL_auxz00_3427 =
																				((BgL_nodez00_bglt)
																				BgL_new1150z00_1975);
																		}
																		((((BgL_castz00_bglt)
																					COBJECT(BgL_new1148z00_1974))->
																				BgL_argz00) =
																			((BgL_nodez00_bglt) BgL_auxz00_3427),
																			BUNSPEC);
																	}
																	BgL_arg1839z00_1973 = BgL_new1148z00_1974;
																}
																{	/* Coerce/convert.scm 383 */
																	obj_t BgL_auxz00_3443;
																	obj_t BgL_tmpz00_3441;

																	BgL_auxz00_3443 =
																		((obj_t) BgL_arg1839z00_1973);
																	BgL_tmpz00_3441 =
																		((obj_t) BgL_binding2z00_1972);
																	SET_CDR(BgL_tmpz00_3441, BgL_auxz00_3443);
														}}}
														((((BgL_conditionalz00_bglt) COBJECT(
																		((BgL_conditionalz00_bglt)
																			BgL_condnz00_1969)))->BgL_truez00) =
															((BgL_nodez00_bglt) BgL_coercezd2appzd2_1968),
															BUNSPEC);
														{	/* Coerce/convert.scm 392 */
															BgL_nodez00_bglt BgL_arg1849z00_1982;

															{	/* Coerce/convert.scm 392 */
																BgL_nodez00_bglt BgL_arg1850z00_1983;

																BgL_arg1850z00_1983 =
																	(((BgL_conditionalz00_bglt) COBJECT(
																			((BgL_conditionalz00_bglt)
																				BgL_condnz00_1969)))->BgL_falsez00);
																BgL_arg1849z00_1982 =
																	BGl_coercez12z12zzcoerce_coercez00
																	(BgL_arg1850z00_1983, BUNSPEC,
																	((BgL_typez00_bglt) BgL_fromz00_75),
																	((bool_t) 0));
															}
															((((BgL_conditionalz00_bglt) COBJECT(
																			((BgL_conditionalz00_bglt)
																				BgL_condnz00_1969)))->BgL_falsez00) =
																((BgL_nodez00_bglt) BgL_arg1849z00_1982),
																BUNSPEC);
														}
														BGl_lvtypezd2nodez12zc0zzast_lvtypez00
															(BgL_lnodez00_1966);
														return BgL_lnodez00_1966;
													}
												}
											}
										}
									}
								}
							}
						}
					}
			}
		}

	}



/* do-convert */
	BgL_nodez00_bglt BGl_dozd2convertzd2zzcoerce_convertz00(obj_t
		BgL_coercezd2opzd2_80, BgL_nodez00_bglt BgL_nodez00_81,
		BgL_typez00_bglt BgL_fromz00_82)
	{
		{	/* Coerce/convert.scm 402 */
			if ((BgL_coercezd2opzd2_80 == BTRUE))
				{	/* Coerce/convert.scm 405 */
					return BgL_nodez00_81;
				}
			else
				{	/* Coerce/convert.scm 407 */
					BgL_nodez00_bglt BgL_nnodez00_2022;

					{	/* Coerce/convert.scm 407 */
						obj_t BgL_arg1889z00_2023;
						obj_t BgL_arg1890z00_2024;

						{	/* Coerce/convert.scm 407 */
							obj_t BgL_arg1891z00_2025;

							BgL_arg1891z00_2025 =
								MAKE_YOUNG_PAIR(((obj_t) BgL_nodez00_81), BNIL);
							BgL_arg1889z00_2023 =
								MAKE_YOUNG_PAIR(BgL_coercezd2opzd2_80, BgL_arg1891z00_2025);
						}
						BgL_arg1890z00_2024 =
							(((BgL_nodez00_bglt) COBJECT(BgL_nodez00_81))->BgL_locz00);
						BgL_nnodez00_2022 =
							BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00
							(BgL_arg1889z00_2023, BgL_arg1890z00_2024);
					}
					BGl_lvtypezd2nodez12zc0zzast_lvtypez00(BgL_nnodez00_2022);
					BGl_spreadzd2sidezd2effectz12z12zzeffect_spreadz00(BgL_nnodez00_2022);
					return BgL_nnodez00_2022;
				}
		}

	}



/* object-init */
	obj_t BGl_objectzd2initzd2zzcoerce_convertz00()
	{
		{	/* Coerce/convert.scm 16 */
			return BUNSPEC;
		}

	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzcoerce_convertz00()
	{
		{	/* Coerce/convert.scm 16 */
			return BUNSPEC;
		}

	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzcoerce_convertz00()
	{
		{	/* Coerce/convert.scm 16 */
			return BUNSPEC;
		}

	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzcoerce_convertz00()
	{
		{	/* Coerce/convert.scm 16 */
			BGl_modulezd2initializa7ationz75zztools_tracez00(((long) 54713316),
				BSTRING_TO_STRING(BGl_string2018z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 476633989),
				BSTRING_TO_STRING(BGl_string2018z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zzbackend_backendz00(((long) 216206620),
				BSTRING_TO_STRING(BGl_string2018z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 365925558),
				BSTRING_TO_STRING(BGl_string2018z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zztools_locationz00(((long) 462333240),
				BSTRING_TO_STRING(BGl_string2018z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 300504031),
				BSTRING_TO_STRING(BGl_string2018z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zztools_miscz00(((long) 9470071),
				BSTRING_TO_STRING(BGl_string2018z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 515343395),
				BSTRING_TO_STRING(BGl_string2018z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 346491734),
				BSTRING_TO_STRING(BGl_string2018z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zztype_coercionz00(((long) 116865673),
				BSTRING_TO_STRING(BGl_string2018z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zztype_envz00(((long) 296457443),
				BSTRING_TO_STRING(BGl_string2018z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zzast_sexpz00(((long) 36886173),
				BSTRING_TO_STRING(BGl_string2018z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 90839984),
				BSTRING_TO_STRING(BGl_string2018z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 506185397),
				BSTRING_TO_STRING(BGl_string2018z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zzast_identz00(((long) 174885617),
				BSTRING_TO_STRING(BGl_string2018z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zzast_lvtypez00(((long) 189769752),
				BSTRING_TO_STRING(BGl_string2018z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zzast_dumpz00(((long) 271707717),
				BSTRING_TO_STRING(BGl_string2018z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zzobject_classz00(((long) 502007119),
				BSTRING_TO_STRING(BGl_string2018z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zzcoerce_coercez00(((long) 361167184),
				BSTRING_TO_STRING(BGl_string2018z00zzcoerce_convertz00));
			return
				BGl_modulezd2initializa7ationz75zzeffect_spreadz00(((long) 348216764),
				BSTRING_TO_STRING(BGl_string2018z00zzcoerce_convertz00));
		}

	}

#ifdef __cplusplus
}
#endif
