/*===========================================================================*/
/*   (Llib/midi.scm)                                                         */
/*   Bigloo (4.3g)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu 27 Feb 2020 07:59:49 AM CET     */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo4.3g/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo4.3g/lib/bigloo/4.3g -lib-dir /builddir/build/BUILD/bigloo4.3g/lib/bigloo/4.3g -I Llib -lib-dir /builddir/build/BUILD/bigloo4.3g/lib/bigloo/4.3g -unsafe -safee -copt -fPIC -copt -IUnix Llib/midi.scm -o objs/midi.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_midiscorez00_bgl {
   header_t header;
   obj_t widening;
   long BgL_formatz00;
   long BgL_tempoz00;
   long BgL_ppqz00;
   obj_t BgL_tracksz00;
} *BgL_midiscorez00_bglt;

typedef struct BgL_miditrackz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_z52streamz52;
   struct BgL_midireaderz00_bgl * BgL_z52readerz52;
   obj_t BgL_z52closez52;
   bool_t BgL_z52eotz52;
   uint32_t BgL_z52wtickz52;
   long BgL_z52statusz52;
   int32_t BgL_lenz00;
   long BgL_tempoz00;
   obj_t BgL_ipz00;
   long BgL_startz00;
   long BgL_datastartz00;
   uint32_t BgL_wtickz00;
   long BgL_statusz00;
   bool_t BgL_eotz00;
} *BgL_miditrackz00_bglt;

typedef struct BgL_midireaderz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_peekzd2bytezd2;
   obj_t BgL_readzd2bytezd2;
   obj_t BgL_readzd2int16zd2;
   obj_t BgL_readzd2int32zd2;
   obj_t BgL_readzd2intzd2;
   obj_t BgL_readzd2vlqzd2;
   obj_t BgL_readzd2charszd2;
} *BgL_midireaderz00_bglt;

typedef struct BgL_midiplayerz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_errz00;
   obj_t BgL_cdelayz00;
   obj_t BgL_noteoffz00;
   obj_t BgL_noteonz00;
   obj_t BgL_aftertouchz00;
   obj_t BgL_ctrlchangez00;
   obj_t BgL_prgmchangez00;
   obj_t BgL_afterzd2touchzd2;
   obj_t BgL_pitchz00;
   obj_t BgL_sysexz00;
   obj_t BgL_metazd2seqnumzd2;
   obj_t BgL_metazd2textzd2;
   obj_t BgL_metazd2copyrightzd2;
   obj_t BgL_metazd2trackzd2;
   obj_t BgL_metazd2instrumentzd2;
   obj_t BgL_metazd2lyriczd2;
   obj_t BgL_metazd2markerzd2;
   obj_t BgL_metazd2cuezd2;
   obj_t BgL_metazd2prgmnamezd2;
   obj_t BgL_metazd2devnamezd2;
   obj_t BgL_metazd2channprefzd2;
   obj_t BgL_metazd2midiportzd2;
   obj_t BgL_metazd2eotzd2;
   obj_t BgL_metazd2tempozd2;
   obj_t BgL_metazd2smtpezd2;
   obj_t BgL_metazd2timesigzd2;
   obj_t BgL_metazd2keysigzd2;
   obj_t BgL_metazd2seqspeczd2;
} *BgL_midiplayerz00_bglt;

typedef struct BgL_midisinkz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_streamz00;
   obj_t BgL_usleepz00;
   obj_t BgL_writezd2bytezd2;
   obj_t BgL_writezd2stringzd2;
   obj_t BgL_flushz00;
} *BgL_midisinkz00_bglt;


static obj_t BGl_z62lambda2494z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2495z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midizd2controllerzd2namez00zz__multimediazd2midizd2(long);
static obj_t BGl_midizd2readzd2mthdz00zz__multimediazd2midizd2(obj_t);
static long BGl_readzd2intzd2zz__multimediazd2midizd2(long, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midisinkzd2initzd2zz__multimediazd2midizd2(BgL_midisinkz00_bglt);
BGL_IMPORT obj_t BGl_classzd2nilzd2initz12z12zz__objectz00(obj_t);
static obj_t BGl_z62midiplayerzd2pitchzb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT bool_t bigloo_strcicmp(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2noteoffzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, long, long, long);
static obj_t BGl_z62zc3z04anonymousza32399ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32489ze3ze5zz__multimediazd2midizd2(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_midiscorez00zz__multimediazd2midizd2 = BUNSPEC;
static BgL_midiscorez00_bglt BGl_z62midiscorezd2filezb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62stringzd2streamzd2readzd2int16zb0zz__multimediazd2midizd2(obj_t, obj_t);
BGL_IMPORT obj_t BGl_setzd2inputzd2portzd2positionz12zc0zz__r4_ports_6_10_1z00(obj_t, long);
static obj_t BGl_z62zc3z04anonymousza32104ze3ze5zz__multimediazd2midizd2(obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2ctrlchangezd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, long, long, long);
BGL_EXPORTED_DECL obj_t BGl_midizd2programzd2namez00zz__multimediazd2midizd2(long);
static obj_t BGl_objectzd2initzd2zz__multimediazd2midizd2();
static int32_t BGl_readzd2int16zd2zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62stringzd2streamzd2readzd2int32zb0zz__multimediazd2midizd2(obj_t, obj_t);
BGL_IMPORT obj_t BGl_2zb2zb2zz__r4_numbers_6_5z00(obj_t, obj_t);
static BgL_miditrackz00_bglt BGl_z62miditrackzd2filezb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_midireaderz00zz__multimediazd2midizd2 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza32301ze3ze5zz__multimediazd2midizd2(obj_t);
static int32_t BGl_readzd2int32zd2zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62readzd2int16zb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_miditrackzd2waitzd2eventz00zz__multimediazd2midizd2(BgL_miditrackz00_bglt, BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long);
BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
static obj_t BGl_z62midiplayerzd2ctrlchangezb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62midireaderzd2init1234zb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_midizd2controllerzd2namesz00zz__multimediazd2midizd2 = BUNSPEC;
static obj_t BGl_midizd2readzd2mtrkz00zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62readzd2int32zb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zz__multimediazd2midizd2();
static obj_t BGl_z62zc3z04anonymousza32216ze3ze5zz__multimediazd2midizd2(obj_t);
BGL_EXPORTED_DEF obj_t BGl_midisinkz00zz__multimediazd2midizd2 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza32160ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32322ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62midiplayerzd2cdelayzb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2afterzd2touchz00zz__multimediazd2midizd2(BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, long, long);
static obj_t BGl_z62zc3z04anonymousza32234ze3ze5zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32129ze3ze5zz__multimediazd2midizd2(obj_t, obj_t);
BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32413ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32308ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2102z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2103z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32503ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza31523ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31256ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2109z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62midiplayerzd2initzb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62stringzd2streamzd2readzd2vlqzb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62midiplayerzd2init1236zb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2110z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62midiscorezd2init1230zb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31524ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2116z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2117z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31257ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midireaderzd2initzd2zz__multimediazd2midizd2(BgL_midireaderz00_bglt);
static obj_t BGl_z62zc3z04anonymousza32181ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32343ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32092ze3ze5zz__multimediazd2midizd2(obj_t, obj_t);
static BgL_miditrackz00_bglt BGl_z62lambda2124z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_miditrackz00_bglt BGl_z62lambda2127z62zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza31258ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_openzd2inputzd2filez00zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2134z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2135z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31259ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static long BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2300z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static BgL_midireaderz00_bglt BGl_z62lambda2140z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2141z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32434ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2306z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2145z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32167ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2307z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32329ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2146z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62midisinkzd2initzb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62midiscorezd2initzb0zz__multimediazd2midizd2(obj_t, obj_t);
BGL_IMPORT obj_t create_struct(obj_t, int);
static obj_t BGl_z62lambda2151z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2313z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2152z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2314z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2158z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2159z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2320z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2321z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_gczd2rootszd2initz00zz__multimediazd2midizd2();
static obj_t BGl_z62lambda2165z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2327z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2166z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2328z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31651ze3ze5zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32364ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32526ze3ze5zz__multimediazd2midizd2(obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2aftertouchzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, long, long, long);
static obj_t BGl_z62lambda2172z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2334z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2173z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2335z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2179z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62miditrackzd2initzb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62midiplayerzd2afterzd2touchz62zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2501z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2502z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2341z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31652ze3ze5zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2180z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2342z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62midizd2programzd2indexz62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2508z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_midizd2textzd2namesz00zz__multimediazd2midizd2 = BUNSPEC;
static obj_t BGl_z62lambda2509z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62stringzd2streamzd2readzd2intzb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2186z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2348z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2187z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2349z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62stringzd2streamzd2readzd2charszb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32471ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32455ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2516z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32188ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2193z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2355z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2517z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2194z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2356z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t c_substring(obj_t, long, long);
static BgL_midireaderz00_bglt BGl_midireaderzd2stringzd2streamz00zz__multimediazd2midizd2;
static obj_t BGl_z62zc3z04anonymousza32294ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2362z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32456ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2524z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2363z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2525z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_readzd2charszd2zz__r4_input_6_10_2z00(obj_t, obj_t);
static obj_t BGl_z62lambda2369z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2370z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2pitchzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, long, long, long);
static obj_t BGl_z62midiplayerzd2aftertouchzb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2376z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2377z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_midizd2notezd2namesz00zz__multimediazd2midizd2 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza32385ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2383z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2384z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2390z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2391z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2397z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2398z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62midiplayerzd2noteonzb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT bool_t bigloo_strcmp(obj_t, obj_t);
static obj_t BGl_z62midiplayerzd2sysexzb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midizd2notezd2namez00zz__multimediazd2midizd2(long);
static obj_t BGl_z62zc3z04anonymousza32478ze3ze5zz__multimediazd2midizd2(obj_t);
static BgL_midisinkz00_bglt BGl_midisinkzd2nullzd2zz__multimediazd2midizd2;
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2cdelayzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, BgL_miditrackz00_bglt, long, long, long);
static obj_t BGl_requirezd2initializa7ationz75zz__multimediazd2midizd2 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza32496ze3ze5zz__multimediazd2midizd2(obj_t);
BGL_IMPORT obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_writezd2stringzd2zz__r4_output_6_10_3z00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2prgmchangezd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, long, long);
BGL_IMPORT obj_t BGl_listzd2ze3vectorz31zz__r4_vectors_6_8z00(obj_t);
static BgL_miditrackz00_bglt BGl_z62miditrackzd2stringzb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiscorezd2playzd2zz__multimediazd2midizd2(BgL_midiscorez00_bglt, BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt);
static obj_t BGl_z62zc3z04anonymousza32111ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62stringzd2streamzd2peekzd2bytezb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_toplevelzd2initzd2zz__multimediazd2midizd2();
BGL_EXPORTED_DEF obj_t BGl_midiplayerz00zz__multimediazd2midizd2 = BUNSPEC;
static obj_t BGl_midizd2programzd2namesz00zz__multimediazd2midizd2 = BUNSPEC;
BGL_IMPORT obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
static obj_t BGl_miditrackszd2inputzd2portz00zz__multimediazd2midizd2(obj_t, long, obj_t);
static obj_t BGl_genericzd2initzd2zz__multimediazd2midizd2();
static obj_t BGl_z62zc3z04anonymousza32202ze3ze5zz__multimediazd2midizd2(obj_t);
BGL_EXPORTED_DECL obj_t BGl_midizd2programzd2indexz00zz__multimediazd2midizd2(obj_t);
BGL_IMPORT obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t, bool_t, bool_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t bgl_reverse_bang(obj_t);
static obj_t BGl_z62midiplayerzd2prgmchangezb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_miditrackzd2playzd2eventz00zz__multimediazd2midizd2(BgL_miditrackz00_bglt, BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, long, long, BGL_LONGLONG_T);
BGL_EXPORTED_DEF obj_t BGl_miditrackz00zz__multimediazd2midizd2 = BUNSPEC;
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
static obj_t BGl_z62midiplayerzd2ignorezb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL BgL_midiscorez00_bglt BGl_midiscorezd2filezd2zz__multimediazd2midizd2(obj_t);
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_readzd2charzd2zz__r4_input_6_10_2z00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32223ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32118ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza31260ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static bool_t BGl_midiscorezd2play0zd2zz__multimediazd2midizd2(BgL_midiscorez00_bglt, BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt);
static bool_t BGl_midiscorezd2play1zd2zz__multimediazd2midizd2(BgL_midiscorez00_bglt, BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt);
BGL_EXPORTED_DECL BgL_miditrackz00_bglt BGl_miditrackzd2filezd2zz__multimediazd2midizd2(obj_t, long, long);
static obj_t BGl_z62zc3z04anonymousza31261ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32136ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32209ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32420ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32153ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32315ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza31262ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62readzd2vlqzb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32510ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza31263ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT BGL_LONGLONG_T bgl_current_microseconds();
static obj_t BGl_z62zc3z04anonymousza32511ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32406ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza31264ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2initzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt);
static BgL_midiplayerz00_bglt BGl_midiplayerzd2readzd2zz__multimediazd2midizd2;
BGL_IMPORT obj_t BGl_classzd2constructorzd2zz__objectz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32350ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62midireaderzd2initzb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2200z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2201z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static BgL_miditrackz00_bglt BGl_z62miditrackzd2inputzd2portz62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2noteonzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, long, long, long);
static obj_t BGl_z62lambda2207z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2208z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2midizd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_input_6_10_2z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__datez00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__structurez00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
static obj_t BGl_z62midizd2programzd2namez62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32441ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2214z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32174ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2215z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32336ze3ze5zz__multimediazd2midizd2(obj_t);
BGL_EXPORTED_DECL BgL_miditrackz00_bglt BGl_miditrackzd2inputzd2portz00zz__multimediazd2midizd2(obj_t, long);
static obj_t BGl_z62lambda2221z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2222z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32280ze3ze5zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62midiplayerzd2noteoffzb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_midireaderz00_bglt BGl_z62lambda2229z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62midisinkzd2init1238zb0zz__multimediazd2midizd2(obj_t, obj_t);
static BgL_midireaderz00_bglt BGl_z62lambda2232z62zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32427ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2238z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2239z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_cnstzd2initzd2zz__multimediazd2midizd2();
static obj_t BGl_libraryzd2moduleszd2initz00zz__multimediazd2midizd2();
static obj_t BGl_z62zc3z04anonymousza32371ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2404z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2243z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2405z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2244z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2248z62zz__multimediazd2midizd2(obj_t, obj_t);
static BgL_midiscorez00_bglt BGl_z62lambda2087z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2249z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62readzd2intzb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2411z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2412z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static BgL_midiscorez00_bglt BGl_z62lambda2090z62zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2253z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32518ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2254z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2418z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2419z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_objectz00zz__objectz00;
static obj_t BGl_z62lambda2096z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2258z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2097z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2259z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62miditrackzd2init1232zb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32195ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2263z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32357ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2425z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32519ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2264z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2426z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2268z62zz__multimediazd2midizd2(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2sysexzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, obj_t);
static obj_t BGl_z62lambda2269z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62stringzd2streamzd2readzd2bytezb0zz__multimediazd2midizd2(obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(obj_t);
static obj_t BGl_z62lambda2432z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32463ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2433z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31556ze3ze5zz__multimediazd2midizd2(obj_t, obj_t);
static BgL_midiplayerz00_bglt BGl_z62lambda2275z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2439z62zz__multimediazd2midizd2(obj_t, obj_t);
static BgL_midiplayerz00_bglt BGl_z62lambda2278z62zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62midizd2notezd2namez62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2440z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32464ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32448ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza31557ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2446z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2285z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2447z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2286z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiscorezd2initzd2zz__multimediazd2midizd2(BgL_midiscorez00_bglt);
BGL_IMPORT obj_t BGl_callzd2withzd2inputzd2filezd2zz__r4_ports_6_10_1z00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32392ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2453z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32287ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2292z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2454z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31558ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2293z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2299z62zz__multimediazd2midizd2(obj_t, obj_t);
static BgL_midireaderz00_bglt BGl_midireaderzd2inputzd2portz00zz__multimediazd2midizd2;
static obj_t BGl_z62lambda2461z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2462z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31559ze3ze5zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2469z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2470z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32378ze3ze5zz__multimediazd2midizd2(obj_t);
BGL_EXPORTED_DECL obj_t BGl_miditrackzd2initzd2zz__multimediazd2midizd2(BgL_miditrackz00_bglt);
static obj_t BGl_z62lambda2476z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2477z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL BgL_miditrackz00_bglt BGl_miditrackzd2stringzd2zz__multimediazd2midizd2(obj_t, long);
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2ignorezd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, obj_t);
static obj_t BGl_z62midizd2controllerzd2namez62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62midiscorezd2playzb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t);
static BgL_midisinkz00_bglt BGl_z62lambda2484z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_midisinkz00_bglt BGl_z62lambda2487z62zz__multimediazd2midizd2(obj_t);
static obj_t __cnst[ 76 ] ;


BGL_IMPORT obj_t BGl_peekzd2bytezd2envz00zz__r4_input_6_10_2z00;
DEFINE_EXPORT_BGL_GENERIC( BGl_miditrackzd2initzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762miditrackza7d2i3287z00, BGl_z62miditrackzd2initzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3100z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2134za7623288z00, BGl_z62lambda2134z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3101z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2141za7623289z00, BGl_z62lambda2141z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3102z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2140za7623290z00, BGl_z62lambda2140z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3103z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2146za7623291z00, BGl_z62lambda2146z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3104z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2145za7623292z00, BGl_z62lambda2145z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3105z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3293za7, BGl_z62zc3z04anonymousza32153ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3030z00zz__multimediazd2midizd2, BgL_bgl_string3030za700za7za7_3294za7, "midiscore-file", 14 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3106z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2152za7623295z00, BGl_z62lambda2152z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3031z00zz__multimediazd2midizd2, BgL_bgl_string3031za700za7za7_3296za7, "format not supported", 20 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3107z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2151za7623297z00, BGl_z62lambda2151z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3032z00zz__multimediazd2midizd2, BgL_bgl_string3032za700za7za7_3298za7, "midiplayer-file", 15 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3108z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3299za7, BGl_z62zc3z04anonymousza32160ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3033z00zz__multimediazd2midizd2, BgL_bgl_string3033za700za7za7_3300za7, "bad midi format", 15 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3109z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2159za7623301z00, BGl_z62lambda2159z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3034z00zz__multimediazd2midizd2, BgL_bgl_string3034za700za7za7_3302za7, "/builddir/build/BUILD/bigloo4.3g/api/multimedia/src/Llib/midi.scm", 65 );
DEFINE_STRING( BGl_string3035z00zz__multimediazd2midizd2, BgL_bgl_string3035za700za7za7_3303za7, "&midiscore-file", 15 );
DEFINE_STRING( BGl_string3036z00zz__multimediazd2midizd2, BgL_bgl_string3036za700za7za7_3304za7, "bstring", 7 );
DEFINE_STRING( BGl_string3037z00zz__multimediazd2midizd2, BgL_bgl_string3037za700za7za7_3305za7, "&miditrack-input-port", 21 );
DEFINE_STRING( BGl_string3038z00zz__multimediazd2midizd2, BgL_bgl_string3038za700za7za7_3306za7, "input-port", 10 );
DEFINE_STRING( BGl_string3039z00zz__multimediazd2midizd2, BgL_bgl_string3039za700za7za7_3307za7, "bint", 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3110z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2158za7623308z00, BGl_z62lambda2158z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3111z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3309za7, BGl_z62zc3z04anonymousza32167ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3112z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2166za7623310z00, BGl_z62lambda2166z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3113z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2165za7623311z00, BGl_z62lambda2165z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3114z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3312za7, BGl_z62zc3z04anonymousza32174ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3115z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2173za7623313z00, BGl_z62lambda2173z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3040z00zz__multimediazd2midizd2, BgL_bgl_string3040za700za7za7_3314za7, "&miditrack-file", 15 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3116z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2172za7623315z00, BGl_z62lambda2172z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3117z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3316za7, BGl_z62zc3z04anonymousza32181ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3042z00zz__multimediazd2midizd2, BgL_bgl_string3042za700za7za7_3317za7, "&miditrack-string", 17 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3118z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2180za7623318z00, BGl_z62lambda2180z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3043z00zz__multimediazd2midizd2, BgL_bgl_string3043za700za7za7_3319za7, "midiscore-play", 14 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3119z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2179za7623320z00, BGl_z62lambda2179z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3044z00zz__multimediazd2midizd2, BgL_bgl_string3044za700za7za7_3321za7, "&midiscore-play", 15 );
DEFINE_STRING( BGl_string3045z00zz__multimediazd2midizd2, BgL_bgl_string3045za700za7za7_3322za7, "midiscore", 9 );
DEFINE_STRING( BGl_string3046z00zz__multimediazd2midizd2, BgL_bgl_string3046za700za7za7_3323za7, "midiplayer", 10 );
DEFINE_STRING( BGl_string3047z00zz__multimediazd2midizd2, BgL_bgl_string3047za700za7za7_3324za7, "midisink", 8 );
DEFINE_STRING( BGl_string3048z00zz__multimediazd2midizd2, BgL_bgl_string3048za700za7za7_3325za7, "~x:~x", 5 );
DEFINE_STRING( BGl_string3049z00zz__multimediazd2midizd2, BgL_bgl_string3049za700za7za7_3326za7, "midiplay", 8 );
DEFINE_EXPORT_BGL_GENERIC( BGl_midisinkzd2initzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midisinkza7d2in3327z00, BGl_z62midisinkzd2initzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3120z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3328za7, BGl_z62zc3z04anonymousza32188ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3121z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2187za7623329z00, BGl_z62lambda2187z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3122z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2186za7623330z00, BGl_z62lambda2186z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3123z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3331za7, BGl_z62zc3z04anonymousza32195ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3124z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2194za7623332z00, BGl_z62lambda2194z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3125z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2193za7623333z00, BGl_z62lambda2193z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3050z00zz__multimediazd2midizd2, BgL_bgl_string3050za700za7za7_3334za7, "illegal meta-event", 18 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3126z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3335za7, BGl_z62zc3z04anonymousza32202ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3051z00zz__multimediazd2midizd2, BgL_bgl_string3051za700za7za7_3336za7, "illegal event", 13 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3127z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2201za7623337z00, BGl_z62lambda2201z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3052z00zz__multimediazd2midizd2, BgL_bgl_string3052za700za7za7_3338za7, "MThd", 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3128z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2200za7623339z00, BGl_z62lambda2200z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3053z00zz__multimediazd2midizd2, BgL_bgl_string3053za700za7za7_3340za7, "read-midi-mthd", 14 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3129z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3341za7, BGl_z62zc3z04anonymousza32209ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3054z00zz__multimediazd2midizd2, BgL_bgl_string3054za700za7za7_3342za7, "invalid number of SMPTE frames per second", 41 );
DEFINE_STRING( BGl_string3055z00zz__multimediazd2midizd2, BgL_bgl_string3055za700za7za7_3343za7, "Bad header", 10 );
DEFINE_STRING( BGl_string3056z00zz__multimediazd2midizd2, BgL_bgl_string3056za700za7za7_3344za7, "MTrk", 4 );
DEFINE_STRING( BGl_string3057z00zz__multimediazd2midizd2, BgL_bgl_string3057za700za7za7_3345za7, "read-midi-mtrk", 14 );
DEFINE_STRING( BGl_string3058z00zz__multimediazd2midizd2, BgL_bgl_string3058za700za7za7_3346za7, "&read-int", 9 );
DEFINE_STRING( BGl_string3059z00zz__multimediazd2midizd2, BgL_bgl_string3059za700za7za7_3347za7, "&string-stream-peek-byte", 24 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiplayerzd2ctrlchangezd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23348z00, BGl_z62midiplayerzd2ctrlchangezb0zz__multimediazd2midizd2, 0L, BUNSPEC, 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3130z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2208za7623349z00, BGl_z62lambda2208z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3131z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2207za7623350z00, BGl_z62lambda2207z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3132z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3351za7, BGl_z62zc3z04anonymousza32216ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3133z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2215za7623352z00, BGl_z62lambda2215z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3134z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2214za7623353z00, BGl_z62lambda2214z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3135z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3354za7, BGl_z62zc3z04anonymousza32223ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3060z00zz__multimediazd2midizd2, BgL_bgl_string3060za700za7za7_3355za7, "struct", 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3136z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2222za7623356z00, BGl_z62lambda2222z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3061z00zz__multimediazd2midizd2, BgL_bgl_string3061za700za7za7_3357za7, "&string-stream-read-byte", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3137z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2221za7623358z00, BGl_z62lambda2221z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3062z00zz__multimediazd2midizd2, BgL_bgl_string3062za700za7za7_3359za7, "&string-stream-read-int16", 25 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3138z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3360za7, BGl_z62zc3z04anonymousza32129ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3063z00zz__multimediazd2midizd2, BgL_bgl_string3063za700za7za7_3361za7, "&string-stream-read-int32", 25 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3139z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2127za7623362z00, BGl_z62lambda2127z62zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3064z00zz__multimediazd2midizd2, BgL_bgl_string3064za700za7za7_3363za7, "&string-stream-read-int", 23 );
DEFINE_STRING( BGl_string3065z00zz__multimediazd2midizd2, BgL_bgl_string3065za700za7za7_3364za7, "&string-stream-read-chars", 25 );
DEFINE_STRING( BGl_string3066z00zz__multimediazd2midizd2, BgL_bgl_string3066za700za7za7_3365za7, "&midiplayer-cdelay", 18 );
DEFINE_STRING( BGl_string3067z00zz__multimediazd2midizd2, BgL_bgl_string3067za700za7za7_3366za7, "miditrack", 9 );
DEFINE_STRING( BGl_string3068z00zz__multimediazd2midizd2, BgL_bgl_string3068za700za7za7_3367za7, "&midiplayer-ignore", 18 );
DEFINE_STRING( BGl_string3069z00zz__multimediazd2midizd2, BgL_bgl_string3069za700za7za7_3368za7, "&midiplayer-noteoff", 19 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3140z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2124za7623369z00, BGl_z62lambda2124z62zz__multimediazd2midizd2, 0L, BUNSPEC, 14 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3141z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2239za7623370z00, BGl_z62lambda2239z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3142z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2238za7623371z00, BGl_z62lambda2238z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3143z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2244za7623372z00, BGl_z62lambda2244z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3144z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2243za7623373z00, BGl_z62lambda2243z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3145z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2249za7623374z00, BGl_z62lambda2249z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3070z00zz__multimediazd2midizd2, BgL_bgl_string3070za700za7za7_3375za7, "&midiplayer-noteon", 18 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3146z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2248za7623376z00, BGl_z62lambda2248z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3071z00zz__multimediazd2midizd2, BgL_bgl_string3071za700za7za7_3377za7, "&midiplayer-aftertouch", 22 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3147z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2254za7623378z00, BGl_z62lambda2254z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3072z00zz__multimediazd2midizd2, BgL_bgl_string3072za700za7za7_3379za7, "&midiplayer-ctrlchange", 22 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3148z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2253za7623380z00, BGl_z62lambda2253z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3073z00zz__multimediazd2midizd2, BgL_bgl_string3073za700za7za7_3381za7, "&midiplayer-prgmchange", 22 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3149z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2259za7623382z00, BGl_z62lambda2259z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3074z00zz__multimediazd2midizd2, BgL_bgl_string3074za700za7za7_3383za7, "&midiplayer-after-touch", 23 );
DEFINE_STRING( BGl_string3075z00zz__multimediazd2midizd2, BgL_bgl_string3075za700za7za7_3384za7, "&midiplayer-pitch", 17 );
DEFINE_STRING( BGl_string3076z00zz__multimediazd2midizd2, BgL_bgl_string3076za700za7za7_3385za7, "&midiplayer-sysex", 17 );
DEFINE_STRING( BGl_string3077z00zz__multimediazd2midizd2, BgL_bgl_string3077za700za7za7_3386za7, "~a[~a]", 6 );
DEFINE_STRING( BGl_string3078z00zz__multimediazd2midizd2, BgL_bgl_string3078za700za7za7_3387za7, "&midi-note-name", 15 );
DEFINE_STRING( BGl_string3079z00zz__multimediazd2midizd2, BgL_bgl_string3079za700za7za7_3388za7, "unknown controller", 18 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3150z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2258za7623389z00, BGl_z62lambda2258z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3151z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2264za7623390z00, BGl_z62lambda2264z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3152z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2263za7623391z00, BGl_z62lambda2263z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3153z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2269za7623392z00, BGl_z62lambda2269z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3154z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2268za7623393z00, BGl_z62lambda2268z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3155z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3394za7, BGl_z62zc3z04anonymousza32234ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3080z00zz__multimediazd2midizd2, BgL_bgl_string3080za700za7za7_3395za7, "&midi-controller-name", 21 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3156z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2232za7623396z00, BGl_z62lambda2232z62zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3081z00zz__multimediazd2midizd2, BgL_bgl_string3081za700za7za7_3397za7, "unknown program", 15 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3157z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2229za7623398z00, BGl_z62lambda2229z62zz__multimediazd2midizd2, 0L, BUNSPEC, 7 );
DEFINE_STRING( BGl_string3082z00zz__multimediazd2midizd2, BgL_bgl_string3082za700za7za7_3399za7, "&midi-program-name", 18 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3158z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3400za7, BGl_z62zc3z04anonymousza32287ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3083z00zz__multimediazd2midizd2, BgL_bgl_string3083za700za7za7_3401za7, "&midi-program-index", 19 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3159z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2286za7623402z00, BGl_z62lambda2286z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_readzd2vlqzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762readza7d2vlqza7b03403za7, BGl_z62readzd2vlqzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3160z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2285za7623404z00, BGl_z62lambda2285z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3161z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3405za7, BGl_z62zc3z04anonymousza32294ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3162z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2293za7623406z00, BGl_z62lambda2293z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3163z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2292za7623407z00, BGl_z62lambda2292z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3164z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3408za7, BGl_z62zc3z04anonymousza32301ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3165z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2300za7623409z00, BGl_z62lambda2300z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3166z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2299za7623410z00, BGl_z62lambda2299z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3167z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3411za7, BGl_z62zc3z04anonymousza32308ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3168z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2307za7623412z00, BGl_z62lambda2307z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3169z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2306za7623413z00, BGl_z62lambda2306z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3170z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3414za7, BGl_z62zc3z04anonymousza32315ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3171z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2314za7623415z00, BGl_z62lambda2314z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3172z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2313za7623416z00, BGl_z62lambda2313z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3173z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3417za7, BGl_z62zc3z04anonymousza32322ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3174z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2321za7623418z00, BGl_z62lambda2321z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3175z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2320za7623419z00, BGl_z62lambda2320z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3176z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3420za7, BGl_z62zc3z04anonymousza32329ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3177z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2328za7623421z00, BGl_z62lambda2328z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3178z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2327za7623422z00, BGl_z62lambda2327z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3179z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3423za7, BGl_z62zc3z04anonymousza32336ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3268z00zz__multimediazd2midizd2, BgL_bgl_string3268za700za7za7_3424za7, "midiscore-init1230", 18 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_stringzd2streamzd2readzd2vlqzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762stringza7d2stre3425z00, BGl_z62stringzd2streamzd2readzd2vlqzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3180z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2335za7623426z00, BGl_z62lambda2335z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3181z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2334za7623427z00, BGl_z62lambda2334z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3182z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3428za7, BGl_z62zc3z04anonymousza32343ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3270z00zz__multimediazd2midizd2, BgL_bgl_string3270za700za7za7_3429za7, "miditrack-init1232", 18 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3183z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2342za7623430z00, BGl_z62lambda2342z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3184z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2341za7623431z00, BGl_z62lambda2341z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3272z00zz__multimediazd2midizd2, BgL_bgl_string3272za700za7za7_3432za7, "midireader-init1234", 19 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3185z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3433za7, BGl_z62zc3z04anonymousza32350ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3186z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2349za7623434z00, BGl_z62lambda2349z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3274z00zz__multimediazd2midizd2, BgL_bgl_string3274za700za7za7_3435za7, "midiplayer-init1236", 19 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3187z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2348za7623436z00, BGl_z62lambda2348z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3188z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3437za7, BGl_z62zc3z04anonymousza32357ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3276z00zz__multimediazd2midizd2, BgL_bgl_string3276za700za7za7_3438za7, "midisink-init1238", 17 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3189z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2356za7623439z00, BGl_z62lambda2356z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3277z00zz__multimediazd2midizd2, BgL_bgl_string3277za700za7za7_3440za7, "&midiscore-init", 15 );
DEFINE_STRING( BGl_string3278z00zz__multimediazd2midizd2, BgL_bgl_string3278za700za7za7_3441za7, "&miditrack-init", 15 );
DEFINE_STRING( BGl_string3279z00zz__multimediazd2midizd2, BgL_bgl_string3279za700za7za7_3442za7, "&midireader-init", 16 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiscorezd2playzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiscoreza7d2p3443z00, BGl_z62midiscorezd2playzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3190z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2355za7623444z00, BGl_z62lambda2355z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3191z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3445za7, BGl_z62zc3z04anonymousza32364ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3192z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2363za7623446z00, BGl_z62lambda2363z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3280z00zz__multimediazd2midizd2, BgL_bgl_string3280za700za7za7_3447za7, "midireader", 10 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3193z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2362za7623448z00, BGl_z62lambda2362z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3281z00zz__multimediazd2midizd2, BgL_bgl_string3281za700za7za7_3449za7, "&midiplayer-init", 16 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3194z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3450za7, BGl_z62zc3z04anonymousza32371ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3282z00zz__multimediazd2midizd2, BgL_bgl_string3282za700za7za7_3451za7, "&midisink-init", 14 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3195z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2370za7623452z00, BGl_z62lambda2370z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3283z00zz__multimediazd2midizd2, BgL_bgl_string3283za700za7za7_3453za7, "#() midisink flush write-string write-byte usleep stream midiplayer meta-seqspec meta-keysig meta-timesig meta-smtpe meta-tempo meta-eot meta-midiport meta-channpref meta-devname meta-prgmname meta-cue meta-marker meta-lyric meta-instrument meta-track meta-copyright meta-text meta-seqnum sysex pitch after-touch prgmchange ctrlchange aftertouch noteon noteoff cdelay err midireader read-chars read-vlq read-int read-int32 read-int16 read-byte peek-byte miditrack eot status wtick datastart start ip int32 len %status uint32 %wtick bool %eot procedure %close %reader obj %stream __multimedia-midi midiscore vector tracks ppq tempo long format string-stream #(\"C\" \"C#\" \"D\" \"D#\" \"E\" \"F\" \"F#\" \"G\" \"G#\" \"A\" \"A#\" \"B\") #(\"\" \"Acoustic Grand Piano\" \"Bright Acoustic Piano\" \"Electric Grand Piano\" \"Honky-tonk Piano\" \"Electric Piano 1\" \"Electric Piano 2\" \"Harpsichord\" \"Clavinet\" \"Celesta\" \"Glockenspiel\" \"Music Box\" \"Vibraphone\" \"Marimba\" \"Xylophone\" \"Tubular Bells\" \"Dulcimer"
"\" \"Drawbar Organ\" \"Percussive Organ\" \"Rock Organ\" \"Church Organ\" \"Reed Organ\" \"Accordion\" \"Harmonica\" \"Tango Accordion\" \"Acoustic Guitar (nylon)\" \"Acoustic Guitar (steel)\" \"Electric Guitar (jazz)\" \"Electric Guitar (clean)\" \"Electric Guitar (muted)\" \"Overdriven Guitar\" \"Distortion Guitar\" \"Guitar harmonics\" \"Acoustic Bass\" \"Electric Bass (finger)\" \"Electric Bass (pick)\" \"Fretless Bass\" \"Slap Bass 1\" \"Slap Bass 2\" \"Synth Bass 1\" \"Synth Bass 2\" \"Violin\" \"Viola\" \"Cello\" \"Contrabass\" \"Tremolo Strings\" \"Pizzicato Strings\" \"Orchestral Harp\" \"Timpani\" \"String Ensemble 1\" \"String Ensemble 2\" \"Synth Strings 1\" \"Synth Strings 2\" \"Choir Aahs\" \"Voice Oohs\" \"Synth Voice\" \"Orchestra Hit\" \"Trumpet\" \"Trombone\" \"Tuba\" \"Muted Trumpet\" \"French Horn\" \"Brass Section\" \"Synth Brass 1\" \"Synth Brass 2\" \"Soprano Sax\" \"Alto Sax\" \"Tenor Sax\" \"Baritone Sax\" \"Oboe\" \"English Horn\" \"Bassoon\" \"Clarinet\" \"Piccolo\" \"Flute\" \"Reco"
"rder\" \"Pan Flute\" \"Blown Bottle\" \"Shakuhachi\" \"Whistle\" \"Ocarina\" \"Lead 1 (square)\" \"Lead 2 (sawtooth)\" \"Lead 3 (calliope)\" \"Lead 4 (chiff)\" \"Lead 5 (charang)\" \"Lead 6 (voice)\" \"Lead 7 (fifths)\" \"Lead 8 (bass + lead)\" \"Pad 1 (new age)\" \"Pad 2 (warm)\" \"Pad 3 (polysynth)\" \"Pad 4 (choir)\" \"Pad 5 (bowed)\" \"Pad 6 (metallic)\" \"Pad 7 (halo)\" \"Pad 8 (sweep)\" \"FX 1 (rain)\" \"FX 2 (soundtrack)\" \"FX 3 (crystal)\" \"FX 4 (atmosphere)\" \"FX 5 (brightness)\" \"FX 6 (goblins)\" \"FX 7 (echoes)\" \"FX 8 (sci-fi)\" \"Sitar\" \"Banjo\" \"Shamisen\" \"Koto\" \"Kalimba\" \"Bag pipe\" \"Fiddle\" \"Shanai\" \"Tinkle Bell\" \"Agogo\" \"Steel Drums\" \"Woodblock\" \"Taiko Drum\" \"Melodic Tom\" \"Synth Drum\" \"Reverse Cymbal\" \"Guitar Fret Noise\" \"Breath Noise\" \"Seashore\" \"Bird Tweet\" \"Telephone Ring\" \"Helicopter\" \"Applause\" \"Gunshot\") #(\"Bank Select\" \"Modulation Wheel or Lever\" \"Breath Controller\" \"Undefined\" \"Foot Controller\" \"Portamento Time\" \"Data Entr"
"y MSB\" \"Channel Volume\" \"Balance\" \"Undefined\" \"Pan\" \"Expression Controller\" \"Effect Control 1\" \"Effect Control 2\" \"Undefined\" \"Undefined\" \"General Purpose Controller 1\" \"General Purpose Controller 2\" \"General Purpose Controller 3\" \"General Purpose Controller 4\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"LSB for Control 0\" \"LSB for Control 1\" \"LSB for Control 2\" \"LSB for Control 3\" \"LSB for Control 4\" \"LSB for Control 5\" \"LSB for Control 6\" \"LSB for Control 7\" \"LSB for Control 8\" \"LSB for Control 9\" \"LSB for Control 10\" \"LSB for Control 11\" \"LSB for Control 12\" \"LSB for Control 13\" \"LSB for Control 14\" \"LSB for Control 15\" \"LSB for Control 16\" \"LSB for Control 17\" \"LSB for Control 18\" \"LSB for Control 19\" \"LSB for Control 20\" \"LSB for Control 21\" \"LSB for Control 22\" \"LSB for Control 23\" \"LSB for Control 24\" \""
"LSB for Control 25\" \"LSB for Control 26\" \"LSB for Control 27\" \"LSB for Control 28\" \"LSB for Control 29\" \"LSB for Control 30\" \"LSB for Control 31\" \"Damper Pedal on/off (Sustain)\" \"Portamento On/Off\" \"Sostenuto On/Off\" \"Soft Pedal On/Off\" \"Legato Footswitch\" \"Hold 2\" \"Sound Controller 1 (default: Sound Variation)\" \"Sound Controller 2 (default: Timbre/Harmonic Intens.)\" \"Sound Controller 3 (default: Release Time)\" \"Sound Controller 4 (default: Attack Time)\" \"Sound Controller 5 (default: Brightness)\" \"Sound Controller 6 (default: Decay Time - see MMA RP-021)\" \"Sound Controller 7 (default: Vibrato Rate - see MMA RP-021)\" \"Sound Controller 8 (default: Vibrato Depth - see MMA RP-021)\" \"Sound Controller 9 (default: Vibrato Delay - see MMA RP-021)\" \"Sound Controller 10 (default undefined - see MMA RP-021)\" \"General Purpose Controller 5\" \"General Purpose Controller 6\" \"General Purpose Controller 7\" \"General Purpose Controller 8\" \"Portamento Control\" \"Undefined\" "
"\"Undefined\" \"Undefined\" \"High Resolution Velocity Prefix\" \"Undefined\" \"Undefined\" \"Effects 1 Depth\" \"Effects 2 Depth\" \"Effects 3 Depth\" \"Effects 4 Depth\" \"Effects 5 Depth\" \"Data Increment\" \"Data Decrement\" \"Non-Registered Parameter Number (NRPN)\" \"Non-Registered Parameter Number (NRPN)\" \"Registered Parameter Number (RPN)\" \"Registered Parameter Number (RPN)\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"[Channel Mode Message] All Sound Off\" \"[Channel Mode Message] Reset All Controllers\" \"[Channel Mode Message] Local Control On/Off\" \"[Channel Mode Message] All Notes Off\" \"[Channel Mode Message] Omni Mode Off (+ all notes off)\" \"[Channel Mode Message] Omni Mode On (+ all notes off)\" \"[Channel Mode Message] Mono Mode On (+ poly off, + all notes off)\" \"[Channel Mod"
"e Message] Poly Mode On (+ mono off, +all notes off)\") #(\"\" \"text\" \"copyright\" \"track\" \"instrument\" \"lyric\" \"marker\" \"cue\") ", 5730 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3196z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2369za7623454z00, BGl_z62lambda2369z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3197z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3455za7, BGl_z62zc3z04anonymousza32378ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3198z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2377za7623456z00, BGl_z62lambda2377z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3199z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2376za7623457z00, BGl_z62lambda2376z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_readzd2int32zd2envz00zz__multimediazd2midizd2, BgL_bgl_za762readza7d2int32za73458za7, BGl_z62readzd2int32zb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_midireaderzd2initzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midireaderza7d23459z00, BGl_z62midireaderzd2initzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_miditrackzd2stringzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762miditrackza7d2s3460z00, BGl_z62miditrackzd2stringzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midizd2notezd2namezd2envzd2zz__multimediazd2midizd2, BgL_bgl_za762midiza7d2noteza7d3461za7, BGl_z62midizd2notezd2namez62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiplayerzd2pitchzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23462z00, BGl_z62midiplayerzd2pitchzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 6 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiplayerzd2noteonzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23463z00, BGl_z62midiplayerzd2noteonzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_readzd2int16zd2envz00zz__multimediazd2midizd2, BgL_bgl_za762readza7d2int16za73464za7, BGl_z62readzd2int16zb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_midiplayerzd2initzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23465z00, BGl_z62midiplayerzd2initzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
BGL_IMPORT obj_t BGl_errorzd2envzd2zz__errorz00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiplayerzd2noteoffzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23466z00, BGl_z62midiplayerzd2noteoffzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 6 );
DEFINE_EXPORT_BGL_GENERIC( BGl_midiscorezd2initzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiscoreza7d2i3467z00, BGl_z62midiscorezd2initzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
BGL_IMPORT obj_t BGl_closezd2inputzd2portzd2envzd2zz__r4_ports_6_10_1z00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_miditrackzd2filezd2envz00zz__multimediazd2midizd2, BgL_bgl_za762miditrackza7d2f3468z00, BGl_z62miditrackzd2filezb0zz__multimediazd2midizd2, 0L, BUNSPEC, 3 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23469z00, BGl_z62midiplayerzd2ignorezb0zz__multimediazd2midizd2, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3015z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3470za7, BGl_z62zc3z04anonymousza31256ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3016z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3471za7, BGl_z62zc3z04anonymousza31257ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3017z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3472za7, BGl_z62zc3z04anonymousza31258ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3018z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3473za7, BGl_z62zc3z04anonymousza31259ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3019z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3474za7, BGl_z62zc3z04anonymousza31260ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 6 );
BGL_IMPORT obj_t BGl_readzd2charszd2envz00zz__r4_input_6_10_2z00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3020z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3475za7, BGl_z62zc3z04anonymousza31261ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3021z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3476za7, BGl_z62zc3z04anonymousza31262ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3022z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3477za7, BGl_z62zc3z04anonymousza31263ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3023z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3478za7, BGl_z62zc3z04anonymousza31264ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3024z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3479za7, BGl_z62zc3z04anonymousza31523ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 8 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3025z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3480za7, BGl_z62zc3z04anonymousza31524ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3026z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3481za7, BGl_z62zc3z04anonymousza31556ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3027z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3482za7, BGl_z62zc3z04anonymousza31557ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3028z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3483za7, BGl_z62zc3z04anonymousza31558ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3029z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3484za7, BGl_z62zc3z04anonymousza31559ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3200z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3485za7, BGl_z62zc3z04anonymousza32385ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3201z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2384za7623486z00, BGl_z62lambda2384z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3202z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2383za7623487z00, BGl_z62lambda2383z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3203z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3488za7, BGl_z62zc3z04anonymousza32392ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3041z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3489za7, BGl_z62zc3z04anonymousza31652ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3204z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2391za7623490z00, BGl_z62lambda2391z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3205z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2390za7623491z00, BGl_z62lambda2390z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3206z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3492za7, BGl_z62zc3z04anonymousza32399ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3207z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2398za7623493z00, BGl_z62lambda2398z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3208z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2397za7623494z00, BGl_z62lambda2397z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3209z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3495za7, BGl_z62zc3z04anonymousza32406ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3210z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2405za7623496z00, BGl_z62lambda2405z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3211z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2404za7623497z00, BGl_z62lambda2404z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3212z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3498za7, BGl_z62zc3z04anonymousza32413ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3213z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2412za7623499z00, BGl_z62lambda2412z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3214z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2411za7623500z00, BGl_z62lambda2411z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3215z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3501za7, BGl_z62zc3z04anonymousza32420ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3216z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2419za7623502z00, BGl_z62lambda2419z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3217z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2418za7623503z00, BGl_z62lambda2418z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3218z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3504za7, BGl_z62zc3z04anonymousza32427ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3219z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2426za7623505z00, BGl_z62lambda2426z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3220z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2425za7623506z00, BGl_z62lambda2425z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3221z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3507za7, BGl_z62zc3z04anonymousza32434ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3222z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2433za7623508z00, BGl_z62lambda2433z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3223z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2432za7623509z00, BGl_z62lambda2432z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3224z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3510za7, BGl_z62zc3z04anonymousza32441ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3225z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2440za7623511z00, BGl_z62lambda2440z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3226z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2439za7623512z00, BGl_z62lambda2439z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3227z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3513za7, BGl_z62zc3z04anonymousza32448ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3228z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2447za7623514z00, BGl_z62lambda2447z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3229z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2446za7623515z00, BGl_z62lambda2446z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiplayerzd2prgmchangezd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23516z00, BGl_z62midiplayerzd2prgmchangezb0zz__multimediazd2midizd2, 0L, BUNSPEC, 5 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midizd2controllerzd2namezd2envzd2zz__multimediazd2midizd2, BgL_bgl_za762midiza7d2contro3517z00, BGl_z62midizd2controllerzd2namez62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3230z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3518za7, BGl_z62zc3z04anonymousza32455ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3231z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2454za7623519z00, BGl_z62lambda2454z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3232z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2453za7623520z00, BGl_z62lambda2453z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3233z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3521za7, BGl_z62zc3z04anonymousza32463ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3234z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2462za7623522z00, BGl_z62lambda2462z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3235z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2461za7623523z00, BGl_z62lambda2461z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3236z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3524za7, BGl_z62zc3z04anonymousza32471ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3237z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2470za7623525z00, BGl_z62lambda2470z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3238z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2469za7623526z00, BGl_z62lambda2469z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3239z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3527za7, BGl_z62zc3z04anonymousza32478ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_stringzd2streamzd2readzd2int32zd2envz00zz__multimediazd2midizd2, BgL_bgl_za762stringza7d2stre3528z00, BGl_z62stringzd2streamzd2readzd2int32zb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3240z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2477za7623529z00, BGl_z62lambda2477z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3241z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2476za7623530z00, BGl_z62lambda2476z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3242z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3531za7, BGl_z62zc3z04anonymousza32280ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3243z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2278za7623532z00, BGl_z62lambda2278z62zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3244z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2275za7623533z00, BGl_z62lambda2275z62zz__multimediazd2midizd2, 0L, BUNSPEC, 28 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3245z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3534za7, BGl_z62zc3z04anonymousza32496ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3246z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2495za7623535z00, BGl_z62lambda2495z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3084z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2097za7623536z00, BGl_z62lambda2097z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3247z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2494za7623537z00, BGl_z62lambda2494z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3085z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2096za7623538z00, BGl_z62lambda2096z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3248z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3539za7, BGl_z62zc3z04anonymousza32503ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3086z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3540za7, BGl_z62zc3z04anonymousza32104ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3249z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2502za7623541z00, BGl_z62lambda2502z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3087z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2103za7623542z00, BGl_z62lambda2103z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3088z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2102za7623543z00, BGl_z62lambda2102z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3089z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3544za7, BGl_z62zc3z04anonymousza32111ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiplayerzd2afterzd2touchzd2envzd2zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23545z00, BGl_z62midiplayerzd2afterzd2touchz62zz__multimediazd2midizd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3250z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2501za7623546z00, BGl_z62lambda2501z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3251z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3547za7, BGl_z62zc3z04anonymousza32510ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3252z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2509za7623548z00, BGl_z62lambda2509z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3090z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2110za7623549z00, BGl_z62lambda2110z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3253z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2508za7623550z00, BGl_z62lambda2508z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3091z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2109za7623551z00, BGl_z62lambda2109z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3254z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3552za7, BGl_z62zc3z04anonymousza32518ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3092z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3553za7, BGl_z62zc3z04anonymousza32118ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3255z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2517za7623554z00, BGl_z62lambda2517z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3093z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2117za7623555z00, BGl_z62lambda2117z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3256z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2516za7623556z00, BGl_z62lambda2516z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3094z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2116za7623557z00, BGl_z62lambda2116z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3257z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3558za7, BGl_z62zc3z04anonymousza32526ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3095z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3559za7, BGl_z62zc3z04anonymousza32092ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3258z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2525za7623560z00, BGl_z62lambda2525z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3096z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2090za7623561z00, BGl_z62lambda2090z62zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3259z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2524za7623562z00, BGl_z62lambda2524z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3097z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2087za7623563z00, BGl_z62lambda2087z62zz__multimediazd2midizd2, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3098z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3564za7, BGl_z62zc3z04anonymousza32136ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3099z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2135za7623565z00, BGl_z62lambda2135z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
BGL_IMPORT obj_t BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3260z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3566za7, BGl_z62zc3z04anonymousza32489ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3261z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2487za7623567z00, BGl_z62lambda2487z62zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3262z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2484za7623568z00, BGl_z62lambda2484z62zz__multimediazd2midizd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3263z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3569za7, BGl_z62zc3z04anonymousza32519ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3264z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3570za7, BGl_z62zc3z04anonymousza32511ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3265z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3571za7, BGl_z62zc3z04anonymousza32464ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3266z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3572za7, BGl_z62zc3z04anonymousza32456ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 8 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3267z00zz__multimediazd2midizd2, BgL_bgl_za762midiscoreza7d2i3573z00, BGl_z62midiscorezd2init1230zb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3269z00zz__multimediazd2midizd2, BgL_bgl_za762miditrackza7d2i3574z00, BGl_z62miditrackzd2init1232zb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3271z00zz__multimediazd2midizd2, BgL_bgl_za762midireaderza7d23575z00, BGl_z62midireaderzd2init1234zb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3273z00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23576z00, BGl_z62midiplayerzd2init1236zb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3275z00zz__multimediazd2midizd2, BgL_bgl_za762midisinkza7d2in3577z00, BGl_z62midisinkzd2init1238zb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_stringzd2streamzd2readzd2int16zd2envz00zz__multimediazd2midizd2, BgL_bgl_za762stringza7d2stre3578z00, BGl_z62stringzd2streamzd2readzd2int16zb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_miditrackzd2inputzd2portzd2envzd2zz__multimediazd2midizd2, BgL_bgl_za762miditrackza7d2i3579z00, BGl_z62miditrackzd2inputzd2portz62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_readzd2intzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762readza7d2intza7b03580za7, BGl_z62readzd2intzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_stringzd2streamzd2readzd2bytezd2envz00zz__multimediazd2midizd2, BgL_bgl_za762stringza7d2stre3581z00, BGl_z62stringzd2streamzd2readzd2bytezb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
BGL_IMPORT obj_t BGl_readzd2bytezd2envz00zz__r4_input_6_10_2z00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_stringzd2streamzd2readzd2intzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762stringza7d2stre3582z00, BGl_z62stringzd2streamzd2readzd2intzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
BGL_IMPORT obj_t BGl_sleepzd2envzd2zz__osz00;
BGL_IMPORT obj_t BGl_flushzd2outputzd2portzd2envzd2zz__r4_ports_6_10_1z00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiscorezd2filezd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiscoreza7d2f3583z00, BGl_z62midiscorezd2filezb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midizd2programzd2indexzd2envzd2zz__multimediazd2midizd2, BgL_bgl_za762midiza7d2progra3584z00, BGl_z62midizd2programzd2indexz62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiplayerzd2sysexzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23585z00, BGl_z62midiplayerzd2sysexzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 4 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiplayerzd2cdelayzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23586z00, BGl_z62midiplayerzd2cdelayzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 7 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midizd2programzd2namezd2envzd2zz__multimediazd2midizd2, BgL_bgl_za762midiza7d2progra3587z00, BGl_z62midizd2programzd2namez62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_stringzd2streamzd2readzd2charszd2envz00zz__multimediazd2midizd2, BgL_bgl_za762stringza7d2stre3588z00, BGl_z62stringzd2streamzd2readzd2charszb0zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiplayerzd2aftertouchzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23589z00, BGl_z62midiplayerzd2aftertouchzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_stringzd2streamzd2peekzd2bytezd2envz00zz__multimediazd2midizd2, BgL_bgl_za762stringza7d2stre3590z00, BGl_z62stringzd2streamzd2peekzd2bytezb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_midiscorez00zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midireaderz00zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midizd2controllerzd2namesz00zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midisinkz00zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midizd2textzd2namesz00zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midireaderzd2stringzd2streamz00zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midizd2notezd2namesz00zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midisinkzd2nullzd2zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midiplayerz00zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midizd2programzd2namesz00zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_miditrackz00zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midiplayerzd2readzd2zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midireaderzd2inputzd2portz00zz__multimediazd2midizd2) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2midizd2(long BgL_checksumz00_4465, char * BgL_fromz00_4466)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__multimediazd2midizd2))
{ 
BGl_requirezd2initializa7ationz75zz__multimediazd2midizd2 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__multimediazd2midizd2(); 
BGl_libraryzd2moduleszd2initz00zz__multimediazd2midizd2(); 
BGl_cnstzd2initzd2zz__multimediazd2midizd2(); 
BGl_objectzd2initzd2zz__multimediazd2midizd2(); 
BGl_genericzd2initzd2zz__multimediazd2midizd2(); 
return 
BGl_toplevelzd2initzd2zz__multimediazd2midizd2();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__multimediazd2midizd2()
{
{ /* Llib/midi.scm 15 */
BGl_modulezd2initializa7ationz75zz__r4_input_6_10_2z00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__osz00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__bitz00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__datez00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__structurez00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__biglooz00(((long)0), "__multimedia-midi"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__multimediazd2midizd2()
{
{ /* Llib/midi.scm 15 */
{ /* Llib/midi.scm 15 */
obj_t BgL_cportz00_4098;
{ /* Llib/midi.scm 15 */
obj_t BgL_stringz00_4106;
BgL_stringz00_4106 = BGl_string3283z00zz__multimediazd2midizd2; 
{ /* Llib/midi.scm 15 */
obj_t BgL_startz00_4107;
BgL_startz00_4107 = 
BINT(((long)0)); 
{ /* Llib/midi.scm 15 */
obj_t BgL_endz00_4108;
BgL_endz00_4108 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_4106))); 
{ /* Llib/midi.scm 15 */

BgL_cportz00_4098 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_4106, BgL_startz00_4107, BgL_endz00_4108); } } } } 
{ 
long BgL_iz00_4099;
BgL_iz00_4099 = ((long)75); 
BgL_loopz00_4100:
if(
(BgL_iz00_4099==((long)-1)))
{ /* Llib/midi.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/midi.scm 15 */
{ /* Llib/midi.scm 15 */
obj_t BgL_arg3285z00_4102;
{ /* Llib/midi.scm 15 */

{ /* Llib/midi.scm 15 */
obj_t BgL_locationz00_4104;
BgL_locationz00_4104 = 
BBOOL(((bool_t)0)); 
{ /* Llib/midi.scm 15 */

BgL_arg3285z00_4102 = 
BGl_readz00zz__readerz00(BgL_cportz00_4098, BgL_locationz00_4104); } } } 
{ /* Llib/midi.scm 15 */
int BgL_tmpz00_4503;
BgL_tmpz00_4503 = 
(int)(BgL_iz00_4099); 
CNST_TABLE_SET(BgL_tmpz00_4503, BgL_arg3285z00_4102); } } 
{ /* Llib/midi.scm 15 */
int BgL_auxz00_4105;
BgL_auxz00_4105 = 
(int)(
(BgL_iz00_4099-((long)1))); 
{ 
long BgL_iz00_4508;
BgL_iz00_4508 = 
(long)(BgL_auxz00_4105); 
BgL_iz00_4099 = BgL_iz00_4508; 
goto BgL_loopz00_4100;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__multimediazd2midizd2()
{
{ /* Llib/midi.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__multimediazd2midizd2()
{
{ /* Llib/midi.scm 15 */
{ /* Llib/midi.scm 133 */
BgL_midireaderz00_bglt BgL_new1121z00_143;
{ /* Llib/midi.scm 134 */
BgL_midireaderz00_bglt BgL_new1120z00_145;
BgL_new1120z00_145 = 
((BgL_midireaderz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midireaderz00_bgl) ))); 
{ /* Llib/midi.scm 134 */
long BgL_arg1242z00_146;
{ /* Llib/midi.scm 134 */
long BgL_res2533z00_1862;
BgL_res2533z00_1862 = 
BGL_CLASS_INDEX(BGl_midireaderz00zz__multimediazd2midizd2); 
BgL_arg1242z00_146 = BgL_res2533z00_1862; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1120z00_145), BgL_arg1242z00_146); } 
BgL_new1121z00_143 = BgL_new1120z00_145; } 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1121z00_143))->BgL_peekzd2bytezd2)=((obj_t)BGl_peekzd2bytezd2envz00zz__r4_input_6_10_2z00),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1121z00_143))->BgL_readzd2bytezd2)=((obj_t)BGl_readzd2bytezd2envz00zz__r4_input_6_10_2z00),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1121z00_143))->BgL_readzd2int16zd2)=((obj_t)BGl_readzd2int16zd2envz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1121z00_143))->BgL_readzd2int32zd2)=((obj_t)BGl_readzd2int32zd2envz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1121z00_143))->BgL_readzd2intzd2)=((obj_t)BGl_readzd2intzd2envz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1121z00_143))->BgL_readzd2vlqzd2)=((obj_t)BGl_readzd2vlqzd2envz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1121z00_143))->BgL_readzd2charszd2)=((obj_t)BGl_readzd2charszd2envz00zz__r4_input_6_10_2z00),BUNSPEC); 
{ /* Llib/midi.scm 133 */
obj_t BgL_fun1240z00_144;
BgL_fun1240z00_144 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_midireaderz00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun1240z00_144)(BgL_fun1240z00_144, 
((obj_t)BgL_new1121z00_143), BEOA); } 
BGl_midireaderzd2inputzd2portz00zz__multimediazd2midizd2 = BgL_new1121z00_143; } 
{ /* Llib/midi.scm 146 */
BgL_midireaderz00_bglt BgL_new1123z00_147;
{ /* Llib/midi.scm 147 */
BgL_midireaderz00_bglt BgL_new1122z00_149;
BgL_new1122z00_149 = 
((BgL_midireaderz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midireaderz00_bgl) ))); 
{ /* Llib/midi.scm 147 */
long BgL_arg1244z00_150;
{ /* Llib/midi.scm 147 */
long BgL_res2534z00_1866;
BgL_res2534z00_1866 = 
BGL_CLASS_INDEX(BGl_midireaderz00zz__multimediazd2midizd2); 
BgL_arg1244z00_150 = BgL_res2534z00_1866; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1122z00_149), BgL_arg1244z00_150); } 
BgL_new1123z00_147 = BgL_new1122z00_149; } 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1123z00_147))->BgL_peekzd2bytezd2)=((obj_t)BGl_stringzd2streamzd2peekzd2bytezd2envz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1123z00_147))->BgL_readzd2bytezd2)=((obj_t)BGl_stringzd2streamzd2readzd2bytezd2envz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1123z00_147))->BgL_readzd2int16zd2)=((obj_t)BGl_stringzd2streamzd2readzd2int16zd2envz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1123z00_147))->BgL_readzd2int32zd2)=((obj_t)BGl_stringzd2streamzd2readzd2int32zd2envz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1123z00_147))->BgL_readzd2intzd2)=((obj_t)BGl_stringzd2streamzd2readzd2intzd2envz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1123z00_147))->BgL_readzd2vlqzd2)=((obj_t)BGl_stringzd2streamzd2readzd2vlqzd2envz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1123z00_147))->BgL_readzd2charszd2)=((obj_t)BGl_stringzd2streamzd2readzd2charszd2envz00zz__multimediazd2midizd2),BUNSPEC); 
{ /* Llib/midi.scm 146 */
obj_t BgL_fun1243z00_148;
BgL_fun1243z00_148 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_midireaderz00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun1243z00_148)(BgL_fun1243z00_148, 
((obj_t)BgL_new1123z00_147), BEOA); } 
BGl_midireaderzd2stringzd2streamz00zz__multimediazd2midizd2 = BgL_new1123z00_147; } 
{ /* Llib/midi.scm 159 */
BgL_midiplayerz00_bglt BgL_new1125z00_151;
{ /* Llib/midi.scm 159 */
BgL_midiplayerz00_bglt BgL_new1124z00_264;
BgL_new1124z00_264 = 
((BgL_midiplayerz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midiplayerz00_bgl) ))); 
{ /* Llib/midi.scm 159 */
long BgL_arg1555z00_265;
{ /* Llib/midi.scm 159 */
long BgL_res2535z00_1870;
BgL_res2535z00_1870 = 
BGL_CLASS_INDEX(BGl_midiplayerz00zz__multimediazd2midizd2); 
BgL_arg1555z00_265 = BgL_res2535z00_1870; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1124z00_264), BgL_arg1555z00_265); } 
BgL_new1125z00_151 = BgL_new1124z00_264; } 
{ 
obj_t BgL_auxz00_4549;
{ /* Llib/midi.scm 159 */
obj_t BgL_arg1253z00_152;
{ /* Llib/midi.scm 159 */
obj_t BgL_arg1255z00_153;
{ /* Llib/midi.scm 159 */
obj_t BgL_res2536z00_1874;
{ /* Llib/midi.scm 159 */
obj_t BgL_classz00_1873;
BgL_classz00_1873 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2536z00_1874 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1873); } 
BgL_arg1255z00_153 = BgL_res2536z00_1874; } 
BgL_arg1253z00_152 = 
VECTOR_REF(BgL_arg1255z00_153,((long)0)); } 
BgL_auxz00_4549 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1253z00_152); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_errz00)=((obj_t)BgL_auxz00_4549),BUNSPEC); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_cdelayz00)=((obj_t)BGl_proc3015z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_noteoffz00)=((obj_t)BGl_proc3016z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_noteonz00)=((obj_t)BGl_proc3017z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_aftertouchz00)=((obj_t)BGl_proc3018z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_ctrlchangez00)=((obj_t)BGl_proc3019z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_prgmchangez00)=((obj_t)BGl_proc3020z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_afterzd2touchzd2)=((obj_t)BGl_proc3021z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_pitchz00)=((obj_t)BGl_proc3022z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_sysexz00)=((obj_t)BGl_proc3023z00zz__multimediazd2midizd2),BUNSPEC); 
{ 
obj_t BgL_auxz00_4563;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1267z00_214;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1268z00_215;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2537z00_1877;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1876;
BgL_classz00_1876 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2537z00_1877 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1876); } 
BgL_arg1268z00_215 = BgL_res2537z00_1877; } 
BgL_arg1267z00_214 = 
VECTOR_REF(BgL_arg1268z00_215,((long)10)); } 
BgL_auxz00_4563 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1267z00_214); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2seqnumzd2)=((obj_t)BgL_auxz00_4563),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4568;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1272z00_216;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1273z00_217;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2538z00_1880;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1879;
BgL_classz00_1879 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2538z00_1880 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1879); } 
BgL_arg1273z00_217 = BgL_res2538z00_1880; } 
BgL_arg1272z00_216 = 
VECTOR_REF(BgL_arg1273z00_217,((long)11)); } 
BgL_auxz00_4568 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1272z00_216); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2textzd2)=((obj_t)BgL_auxz00_4568),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4573;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1283z00_218;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1298z00_219;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2539z00_1883;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1882;
BgL_classz00_1882 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2539z00_1883 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1882); } 
BgL_arg1298z00_219 = BgL_res2539z00_1883; } 
BgL_arg1283z00_218 = 
VECTOR_REF(BgL_arg1298z00_219,((long)12)); } 
BgL_auxz00_4573 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1283z00_218); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2copyrightzd2)=((obj_t)BgL_auxz00_4573),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4578;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1300z00_220;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1301z00_221;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2540z00_1886;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1885;
BgL_classz00_1885 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2540z00_1886 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1885); } 
BgL_arg1301z00_221 = BgL_res2540z00_1886; } 
BgL_arg1300z00_220 = 
VECTOR_REF(BgL_arg1301z00_221,((long)13)); } 
BgL_auxz00_4578 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1300z00_220); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2trackzd2)=((obj_t)BgL_auxz00_4578),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4583;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1302z00_222;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1346z00_223;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2541z00_1889;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1888;
BgL_classz00_1888 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2541z00_1889 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1888); } 
BgL_arg1346z00_223 = BgL_res2541z00_1889; } 
BgL_arg1302z00_222 = 
VECTOR_REF(BgL_arg1346z00_223,((long)14)); } 
BgL_auxz00_4583 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1302z00_222); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2instrumentzd2)=((obj_t)BgL_auxz00_4583),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4588;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1347z00_224;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1388z00_225;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2542z00_1892;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1891;
BgL_classz00_1891 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2542z00_1892 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1891); } 
BgL_arg1388z00_225 = BgL_res2542z00_1892; } 
BgL_arg1347z00_224 = 
VECTOR_REF(BgL_arg1388z00_225,((long)15)); } 
BgL_auxz00_4588 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1347z00_224); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2lyriczd2)=((obj_t)BgL_auxz00_4588),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4593;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1389z00_226;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1470z00_227;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2543z00_1895;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1894;
BgL_classz00_1894 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2543z00_1895 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1894); } 
BgL_arg1470z00_227 = BgL_res2543z00_1895; } 
BgL_arg1389z00_226 = 
VECTOR_REF(BgL_arg1470z00_227,((long)16)); } 
BgL_auxz00_4593 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1389z00_226); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2markerzd2)=((obj_t)BgL_auxz00_4593),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4598;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1476z00_228;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1480z00_229;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2544z00_1898;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1897;
BgL_classz00_1897 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2544z00_1898 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1897); } 
BgL_arg1480z00_229 = BgL_res2544z00_1898; } 
BgL_arg1476z00_228 = 
VECTOR_REF(BgL_arg1480z00_229,((long)17)); } 
BgL_auxz00_4598 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1476z00_228); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2cuezd2)=((obj_t)BgL_auxz00_4598),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4603;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1481z00_230;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1487z00_231;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2545z00_1901;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1900;
BgL_classz00_1900 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2545z00_1901 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1900); } 
BgL_arg1487z00_231 = BgL_res2545z00_1901; } 
BgL_arg1481z00_230 = 
VECTOR_REF(BgL_arg1487z00_231,((long)18)); } 
BgL_auxz00_4603 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1481z00_230); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2prgmnamezd2)=((obj_t)BgL_auxz00_4603),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4608;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1496z00_232;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1497z00_233;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2546z00_1904;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1903;
BgL_classz00_1903 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2546z00_1904 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1903); } 
BgL_arg1497z00_233 = BgL_res2546z00_1904; } 
BgL_arg1496z00_232 = 
VECTOR_REF(BgL_arg1497z00_233,((long)19)); } 
BgL_auxz00_4608 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1496z00_232); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2devnamezd2)=((obj_t)BgL_auxz00_4608),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4613;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1502z00_234;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1503z00_235;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2547z00_1907;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1906;
BgL_classz00_1906 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2547z00_1907 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1906); } 
BgL_arg1503z00_235 = BgL_res2547z00_1907; } 
BgL_arg1502z00_234 = 
VECTOR_REF(BgL_arg1503z00_235,((long)20)); } 
BgL_auxz00_4613 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1502z00_234); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2channprefzd2)=((obj_t)BgL_auxz00_4613),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4618;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1504z00_236;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1505z00_237;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2548z00_1910;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1909;
BgL_classz00_1909 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2548z00_1910 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1909); } 
BgL_arg1505z00_237 = BgL_res2548z00_1910; } 
BgL_arg1504z00_236 = 
VECTOR_REF(BgL_arg1505z00_237,((long)21)); } 
BgL_auxz00_4618 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1504z00_236); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2midiportzd2)=((obj_t)BgL_auxz00_4618),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4623;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1506z00_238;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1520z00_239;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2549z00_1913;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1912;
BgL_classz00_1912 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2549z00_1913 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1912); } 
BgL_arg1520z00_239 = BgL_res2549z00_1913; } 
BgL_arg1506z00_238 = 
VECTOR_REF(BgL_arg1520z00_239,((long)22)); } 
BgL_auxz00_4623 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1506z00_238); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2eotzd2)=((obj_t)BgL_auxz00_4623),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4628;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1521z00_240;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1522z00_241;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2550z00_1916;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1915;
BgL_classz00_1915 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2550z00_1916 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1915); } 
BgL_arg1522z00_241 = BgL_res2550z00_1916; } 
BgL_arg1521z00_240 = 
VECTOR_REF(BgL_arg1522z00_241,((long)23)); } 
BgL_auxz00_4628 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1521z00_240); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2tempozd2)=((obj_t)BgL_auxz00_4628),BUNSPEC); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2smtpezd2)=((obj_t)BGl_proc3024z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2timesigzd2)=((obj_t)BGl_proc3025z00zz__multimediazd2midizd2),BUNSPEC); 
{ 
obj_t BgL_auxz00_4635;
{ /* Llib/midi.scm 83 */
obj_t BgL_arg1537z00_259;
{ /* Llib/midi.scm 83 */
obj_t BgL_arg1539z00_260;
{ /* Llib/midi.scm 83 */
obj_t BgL_res2551z00_1919;
{ /* Llib/midi.scm 83 */
obj_t BgL_classz00_1918;
BgL_classz00_1918 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2551z00_1919 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1918); } 
BgL_arg1539z00_260 = BgL_res2551z00_1919; } 
BgL_arg1537z00_259 = 
VECTOR_REF(BgL_arg1539z00_260,((long)26)); } 
BgL_auxz00_4635 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1537z00_259); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2keysigzd2)=((obj_t)BgL_auxz00_4635),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4640;
{ /* Llib/midi.scm 83 */
obj_t BgL_arg1540z00_261;
{ /* Llib/midi.scm 83 */
obj_t BgL_arg1553z00_262;
{ /* Llib/midi.scm 83 */
obj_t BgL_res2552z00_1922;
{ /* Llib/midi.scm 83 */
obj_t BgL_classz00_1921;
BgL_classz00_1921 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2552z00_1922 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1921); } 
BgL_arg1553z00_262 = BgL_res2552z00_1922; } 
BgL_arg1540z00_261 = 
VECTOR_REF(BgL_arg1553z00_262,((long)27)); } 
BgL_auxz00_4640 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1540z00_261); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2seqspeczd2)=((obj_t)BgL_auxz00_4640),BUNSPEC); } 
{ /* Llib/midi.scm 159 */
obj_t BgL_fun1554z00_263;
BgL_fun1554z00_263 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_midiplayerz00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun1554z00_263)(BgL_fun1554z00_263, 
((obj_t)BgL_new1125z00_151), BEOA); } 
BGl_midiplayerzd2readzd2zz__multimediazd2midizd2 = BgL_new1125z00_151; } 
{ /* Llib/midi.scm 174 */
BgL_midisinkz00_bglt BgL_new1127z00_266;
{ /* Llib/midi.scm 174 */
BgL_midisinkz00_bglt BgL_new1126z00_278;
BgL_new1126z00_278 = 
((BgL_midisinkz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midisinkz00_bgl) ))); 
{ /* Llib/midi.scm 174 */
long BgL_arg1576z00_279;
{ /* Llib/midi.scm 174 */
long BgL_res2553z00_1925;
BgL_res2553z00_1925 = 
BGL_CLASS_INDEX(BGl_midisinkz00zz__multimediazd2midizd2); 
BgL_arg1576z00_279 = BgL_res2553z00_1925; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1126z00_278), BgL_arg1576z00_279); } 
BgL_new1127z00_266 = BgL_new1126z00_278; } 
((((BgL_midisinkz00_bglt)COBJECT(BgL_new1127z00_266))->BgL_streamz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(BgL_new1127z00_266))->BgL_usleepz00)=((obj_t)BGl_proc3026z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(BgL_new1127z00_266))->BgL_writezd2bytezd2)=((obj_t)BGl_proc3027z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(BgL_new1127z00_266))->BgL_writezd2stringzd2)=((obj_t)BGl_proc3028z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(BgL_new1127z00_266))->BgL_flushz00)=((obj_t)BGl_proc3029z00zz__multimediazd2midizd2),BUNSPEC); 
{ /* Llib/midi.scm 174 */
obj_t BgL_fun1560z00_277;
BgL_fun1560z00_277 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_midisinkz00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun1560z00_277)(BgL_fun1560z00_277, 
((obj_t)BgL_new1127z00_266), BEOA); } 
BGl_midisinkzd2nullzd2zz__multimediazd2midizd2 = BgL_new1127z00_266; } 
BGl_midizd2textzd2namesz00zz__multimediazd2midizd2 = 
CNST_TABLE_REF(((long)0)); 
BGl_midizd2controllerzd2namesz00zz__multimediazd2midizd2 = 
CNST_TABLE_REF(((long)1)); 
BGl_midizd2programzd2namesz00zz__multimediazd2midizd2 = 
CNST_TABLE_REF(((long)2)); 
BGl_midizd2notezd2namesz00zz__multimediazd2midizd2 = 
CNST_TABLE_REF(((long)3)); 
return BUNSPEC;} 

}



/* &<@anonymous:1559> */
obj_t BGl_z62zc3z04anonymousza31559ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_2995, obj_t BgL_opz00_2996)
{
{ /* Llib/midi.scm 178 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1558> */
obj_t BGl_z62zc3z04anonymousza31558ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_2997, obj_t BgL_opz00_2998, obj_t BgL_bz00_2999)
{
{ /* Llib/midi.scm 177 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1557> */
obj_t BGl_z62zc3z04anonymousza31557ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3000, obj_t BgL_opz00_3001, obj_t BgL_bz00_3002)
{
{ /* Llib/midi.scm 176 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1556> */
obj_t BGl_z62zc3z04anonymousza31556ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3003, obj_t BgL_sz00_3004)
{
{ /* Llib/midi.scm 175 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1524> */
obj_t BGl_z62zc3z04anonymousza31524ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3005, obj_t BgL_mpz00_3006, obj_t BgL_msz00_3007, obj_t BgL_tickz00_3008, obj_t BgL_nnz00_3009, obj_t BgL_ddz00_3010, obj_t BgL_ccz00_3011, obj_t BgL_bbz00_3012)
{
{ /* Llib/midi.scm 83 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1523> */
obj_t BGl_z62zc3z04anonymousza31523ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3013, obj_t BgL_mpz00_3014, obj_t BgL_msz00_3015, obj_t BgL_tickz00_3016, obj_t BgL_hrz00_3017, obj_t BgL_mmz00_3018, obj_t BgL_sez00_3019, obj_t BgL_frz00_3020, obj_t BgL_ffz00_3021)
{
{ /* Llib/midi.scm 82 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1264> */
obj_t BGl_z62zc3z04anonymousza31264ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3022, obj_t BgL_mpz00_3023, obj_t BgL_msz00_3024, obj_t BgL_tickz00_3025, obj_t BgL_sz00_3026)
{
{ /* Llib/midi.scm 168 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1263> */
obj_t BGl_z62zc3z04anonymousza31263ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3027, obj_t BgL_mpz00_3028, obj_t BgL_msz00_3029, obj_t BgL_tickz00_3030, obj_t BgL_xz00_3031, obj_t BgL_yz00_3032, obj_t BgL_za7za7_3033)
{
{ /* Llib/midi.scm 167 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1262> */
obj_t BGl_z62zc3z04anonymousza31262ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3034, obj_t BgL_mpz00_3035, obj_t BgL_msz00_3036, obj_t BgL_tickz00_3037, obj_t BgL_xz00_3038, obj_t BgL_yz00_3039)
{
{ /* Llib/midi.scm 166 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1261> */
obj_t BGl_z62zc3z04anonymousza31261ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3040, obj_t BgL_mpz00_3041, obj_t BgL_msz00_3042, obj_t BgL_tickz00_3043, obj_t BgL_xz00_3044, obj_t BgL_yz00_3045)
{
{ /* Llib/midi.scm 165 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1260> */
obj_t BGl_z62zc3z04anonymousza31260ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3046, obj_t BgL_mpz00_3047, obj_t BgL_msz00_3048, obj_t BgL_tickz00_3049, obj_t BgL_xz00_3050, obj_t BgL_yz00_3051, obj_t BgL_za7za7_3052)
{
{ /* Llib/midi.scm 164 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1259> */
obj_t BGl_z62zc3z04anonymousza31259ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3053, obj_t BgL_mpz00_3054, obj_t BgL_msz00_3055, obj_t BgL_tickz00_3056, obj_t BgL_xz00_3057, obj_t BgL_yz00_3058, obj_t BgL_za7za7_3059)
{
{ /* Llib/midi.scm 163 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1258> */
obj_t BGl_z62zc3z04anonymousza31258ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3060, obj_t BgL_mpz00_3061, obj_t BgL_msz00_3062, obj_t BgL_tickz00_3063, obj_t BgL_xz00_3064, obj_t BgL_yz00_3065, obj_t BgL_za7za7_3066)
{
{ /* Llib/midi.scm 162 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1257> */
obj_t BGl_z62zc3z04anonymousza31257ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3067, obj_t BgL_mpz00_3068, obj_t BgL_msz00_3069, obj_t BgL_tickz00_3070, obj_t BgL_xz00_3071, obj_t BgL_yz00_3072, obj_t BgL_za7za7_3073)
{
{ /* Llib/midi.scm 161 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1256> */
obj_t BGl_z62zc3z04anonymousza31256ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3074, obj_t BgL_mpz00_3075, obj_t BgL_msz00_3076, obj_t BgL_tickz00_3077, obj_t BgL_trackz00_3078, obj_t BgL_ppqz00_3079, obj_t BgL_dtz00_3080, obj_t BgL_usz00_3081)
{
{ /* Llib/midi.scm 160 */
return 
BBOOL(((bool_t)0));} 

}



/* midiscore-file */
BGL_EXPORTED_DEF BgL_midiscorez00_bglt BGl_midiscorezd2filezd2zz__multimediazd2midizd2(obj_t BgL_filenamez00_13)
{
{ /* Llib/midi.scm 183 */
{ /* Llib/midi.scm 184 */
obj_t BgL_ipz00_296;
{ /* Llib/midi.scm 184 */

BgL_ipz00_296 = 
BGl_openzd2inputzd2filez00zz__r4_ports_6_10_1z00(BgL_filenamez00_13, BTRUE, 
BINT(((long)5000000))); } 
{ /* Llib/midi.scm 185 */
obj_t BgL_sza7za7_297;
BgL_sza7za7_297 = 
BGl_midizd2readzd2mthdz00zz__multimediazd2midizd2(BgL_ipz00_296); 
{ /* Llib/midi.scm 186 */
obj_t BgL_fmtz00_298;obj_t BgL_tckz00_299;obj_t BgL_tempoz00_300;obj_t BgL_ppqz00_301;
{ /* Llib/midi.scm 187 */
int BgL_tmpz00_4688;
BgL_tmpz00_4688 = 
(int)(((long)1)); 
BgL_fmtz00_298 = 
BGL_MVALUES_VAL(BgL_tmpz00_4688); } 
{ /* Llib/midi.scm 187 */
int BgL_tmpz00_4691;
BgL_tmpz00_4691 = 
(int)(((long)2)); 
BgL_tckz00_299 = 
BGL_MVALUES_VAL(BgL_tmpz00_4691); } 
{ /* Llib/midi.scm 187 */
int BgL_tmpz00_4694;
BgL_tmpz00_4694 = 
(int)(((long)3)); 
BgL_tempoz00_300 = 
BGL_MVALUES_VAL(BgL_tmpz00_4694); } 
{ /* Llib/midi.scm 187 */
int BgL_tmpz00_4697;
BgL_tmpz00_4697 = 
(int)(((long)4)); 
BgL_ppqz00_301 = 
BGL_MVALUES_VAL(BgL_tmpz00_4697); } 
{ /* Llib/midi.scm 187 */
obj_t BgL_tracksz00_302;
if(
INTEGERP(BgL_fmtz00_298))
{ /* Llib/midi.scm 187 */
switch( 
(long)CINT(BgL_fmtz00_298)) { case ((long)0) : 

{ /* Llib/midi.scm 188 */
obj_t BgL_v1186z00_310;
BgL_v1186z00_310 = 
create_vector(((long)1)); 
{ /* Llib/midi.scm 188 */
BgL_miditrackz00_bglt BgL_arg1608z00_311;
BgL_arg1608z00_311 = 
BGl_miditrackzd2inputzd2portz00zz__multimediazd2midizd2(BgL_ipz00_296, 
(long)CINT(BgL_tempoz00_300)); 
VECTOR_SET(BgL_v1186z00_310,((long)0),
((obj_t)BgL_arg1608z00_311)); } 
BgL_tracksz00_302 = BgL_v1186z00_310; } break;case ((long)1) : 

BgL_tracksz00_302 = 
BGl_miditrackszd2inputzd2portz00zz__multimediazd2midizd2(BgL_ipz00_296, 
(long)CINT(BgL_tempoz00_300), BgL_tckz00_299); break;case ((long)2) : 

BgL_tracksz00_302 = 
BGl_errorz00zz__errorz00(BGl_string3030z00zz__multimediazd2midizd2, BGl_string3031z00zz__multimediazd2midizd2, BgL_fmtz00_298); break;
default: 
BgL_tracksz00_302 = 
BGl_errorz00zz__errorz00(BGl_string3032z00zz__multimediazd2midizd2, BGl_string3033z00zz__multimediazd2midizd2, BgL_fmtz00_298); } }  else 
{ /* Llib/midi.scm 187 */
BgL_tracksz00_302 = 
BGl_errorz00zz__errorz00(BGl_string3032z00zz__multimediazd2midizd2, BGl_string3033z00zz__multimediazd2midizd2, BgL_fmtz00_298); } 
{ /* Llib/midi.scm 192 */
BgL_midiscorez00_bglt BgL_new1131z00_303;
{ /* Llib/midi.scm 193 */
BgL_midiscorez00_bglt BgL_new1130z00_305;
BgL_new1130z00_305 = 
((BgL_midiscorez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midiscorez00_bgl) ))); 
{ /* Llib/midi.scm 193 */
long BgL_arg1606z00_306;
{ /* Llib/midi.scm 193 */
long BgL_res2554z00_1937;
BgL_res2554z00_1937 = 
BGL_CLASS_INDEX(BGl_midiscorez00zz__multimediazd2midizd2); 
BgL_arg1606z00_306 = BgL_res2554z00_1937; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1130z00_305), BgL_arg1606z00_306); } 
BgL_new1131z00_303 = BgL_new1130z00_305; } 
((((BgL_midiscorez00_bglt)COBJECT(BgL_new1131z00_303))->BgL_formatz00)=((long)
(long)CINT(BgL_fmtz00_298)),BUNSPEC); 
((((BgL_midiscorez00_bglt)COBJECT(BgL_new1131z00_303))->BgL_tempoz00)=((long)
(long)CINT(BgL_tempoz00_300)),BUNSPEC); 
((((BgL_midiscorez00_bglt)COBJECT(BgL_new1131z00_303))->BgL_ppqz00)=((long)
(long)CINT(BgL_ppqz00_301)),BUNSPEC); 
((((BgL_midiscorez00_bglt)COBJECT(BgL_new1131z00_303))->BgL_tracksz00)=((obj_t)BgL_tracksz00_302),BUNSPEC); 
{ /* Llib/midi.scm 192 */
obj_t BgL_fun1605z00_304;
BgL_fun1605z00_304 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_midiscorez00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun1605z00_304)(BgL_fun1605z00_304, 
((obj_t)BgL_new1131z00_303), BEOA); } 
return BgL_new1131z00_303;} } } } } } 

}



/* &midiscore-file */
BgL_midiscorez00_bglt BGl_z62midiscorezd2filezb0zz__multimediazd2midizd2(obj_t BgL_envz00_3114, obj_t BgL_filenamez00_3115)
{
{ /* Llib/midi.scm 183 */
{ /* Llib/midi.scm 184 */
obj_t BgL_auxz00_4731;
if(
STRINGP(BgL_filenamez00_3115))
{ /* Llib/midi.scm 184 */
BgL_auxz00_4731 = BgL_filenamez00_3115
; }  else 
{ 
obj_t BgL_auxz00_4734;
BgL_auxz00_4734 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)8489)), BGl_string3035z00zz__multimediazd2midizd2, BGl_string3036z00zz__multimediazd2midizd2, BgL_filenamez00_3115); 
FAILURE(BgL_auxz00_4734,BFALSE,BFALSE);} 
return 
BGl_midiscorezd2filezd2zz__multimediazd2midizd2(BgL_auxz00_4731);} } 

}



/* miditrack-input-port */
BGL_EXPORTED_DEF BgL_miditrackz00_bglt BGl_miditrackzd2inputzd2portz00zz__multimediazd2midizd2(obj_t BgL_ipz00_15, long BgL_tempoz00_16)
{
{ /* Llib/midi.scm 211 */
{ /* Llib/midi.scm 212 */
BgL_miditrackz00_bglt BgL_new1135z00_328;
{ /* Llib/midi.scm 213 */
BgL_miditrackz00_bglt BgL_new1134z00_330;
BgL_new1134z00_330 = 
((BgL_miditrackz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_miditrackz00_bgl) ))); 
{ /* Llib/midi.scm 213 */
long BgL_arg1619z00_331;
{ /* Llib/midi.scm 213 */
long BgL_res2555z00_1941;
BgL_res2555z00_1941 = 
BGL_CLASS_INDEX(BGl_miditrackz00zz__multimediazd2midizd2); 
BgL_arg1619z00_331 = BgL_res2555z00_1941; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1134z00_330), BgL_arg1619z00_331); } 
BgL_new1135z00_328 = BgL_new1134z00_330; } 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1135z00_328))->BgL_z52streamz52)=((obj_t)BgL_ipz00_15),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1135z00_328))->BgL_z52readerz52)=((BgL_midireaderz00_bglt)BGl_midireaderzd2inputzd2portz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1135z00_328))->BgL_z52closez52)=((obj_t)BGl_closezd2inputzd2portzd2envzd2zz__r4_ports_6_10_1z00),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1135z00_328))->BgL_z52eotz52)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1135z00_328))->BgL_z52wtickz52)=((uint32_t)(uint32_t)(0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1135z00_328))->BgL_z52statusz52)=((long)((long)0)),BUNSPEC); 
{ 
int32_t BgL_auxz00_4749;
{ /* Llib/midi.scm 216 */
obj_t BgL_tmpz00_4750;
BgL_tmpz00_4750 = 
BGl_midizd2readzd2mtrkz00zz__multimediazd2midizd2(BgL_ipz00_15); 
BgL_auxz00_4749 = 
BGL_BINT32_TO_INT32(BgL_tmpz00_4750); } 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1135z00_328))->BgL_lenz00)=((int32_t)BgL_auxz00_4749),BUNSPEC); } 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1135z00_328))->BgL_tempoz00)=((long)BgL_tempoz00_16),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1135z00_328))->BgL_ipz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1135z00_328))->BgL_startz00)=((long)((long)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1135z00_328))->BgL_datastartz00)=((long)((long)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1135z00_328))->BgL_wtickz00)=((uint32_t)(uint32_t)(0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1135z00_328))->BgL_statusz00)=((long)((long)-1)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1135z00_328))->BgL_eotz00)=((bool_t)((bool_t)0)),BUNSPEC); 
{ /* Llib/midi.scm 212 */
obj_t BgL_fun1617z00_329;
BgL_fun1617z00_329 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_miditrackz00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun1617z00_329)(BgL_fun1617z00_329, 
((obj_t)BgL_new1135z00_328), BEOA); } 
return BgL_new1135z00_328;} } 

}



/* &miditrack-input-port */
BgL_miditrackz00_bglt BGl_z62miditrackzd2inputzd2portz62zz__multimediazd2midizd2(obj_t BgL_envz00_3116, obj_t BgL_ipz00_3117, obj_t BgL_tempoz00_3118)
{
{ /* Llib/midi.scm 211 */
{ /* Llib/midi.scm 212 */
long BgL_auxz00_4774;obj_t BgL_auxz00_4767;
{ /* Llib/midi.scm 212 */
obj_t BgL_tmpz00_4775;
if(
INTEGERP(BgL_tempoz00_3118))
{ /* Llib/midi.scm 212 */
BgL_tmpz00_4775 = BgL_tempoz00_3118
; }  else 
{ 
obj_t BgL_auxz00_4778;
BgL_auxz00_4778 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)9695)), BGl_string3037z00zz__multimediazd2midizd2, BGl_string3039z00zz__multimediazd2midizd2, BgL_tempoz00_3118); 
FAILURE(BgL_auxz00_4778,BFALSE,BFALSE);} 
BgL_auxz00_4774 = 
(long)CINT(BgL_tmpz00_4775); } 
if(
INPUT_PORTP(BgL_ipz00_3117))
{ /* Llib/midi.scm 212 */
BgL_auxz00_4767 = BgL_ipz00_3117
; }  else 
{ 
obj_t BgL_auxz00_4770;
BgL_auxz00_4770 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)9695)), BGl_string3037z00zz__multimediazd2midizd2, BGl_string3038z00zz__multimediazd2midizd2, BgL_ipz00_3117); 
FAILURE(BgL_auxz00_4770,BFALSE,BFALSE);} 
return 
BGl_miditrackzd2inputzd2portz00zz__multimediazd2midizd2(BgL_auxz00_4767, BgL_auxz00_4774);} } 

}



/* miditracks-input-port */
obj_t BGl_miditrackszd2inputzd2portz00zz__multimediazd2midizd2(obj_t BgL_ipz00_17, long BgL_tempoz00_18, obj_t BgL_tnumz00_19)
{
{ /* Llib/midi.scm 222 */
{ 
obj_t BgL_ipz00_358;long BgL_tempoz00_359;
{ /* Llib/midi.scm 241 */
BgL_miditrackz00_bglt BgL_t0z00_334;
BgL_ipz00_358 = BgL_ipz00_17; 
BgL_tempoz00_359 = BgL_tempoz00_18; 
{ /* Llib/midi.scm 225 */
BgL_miditrackz00_bglt BgL_trackz00_361;
BgL_trackz00_361 = 
BGl_miditrackzd2inputzd2portz00zz__multimediazd2midizd2(BgL_ipz00_358, BgL_tempoz00_359); 
{ /* Llib/midi.scm 227 */
BgL_midireaderz00_bglt BgL_i1137z00_363;
BgL_i1137z00_363 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_361))->BgL_z52readerz52); 
{ 

BgL_zc3z04anonymousza31645ze3z87_365:
{ /* Llib/midi.scm 229 */
obj_t BgL_fun1647z00_366;
BgL_fun1647z00_366 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1137z00_363))->BgL_readzd2vlqzd2); 
{ /* Llib/midi.scm 229 */
obj_t BgL_arg1646z00_367;
BgL_arg1646z00_367 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_361))->BgL_z52streamz52); 
PROCEDURE_ENTRY(BgL_fun1647z00_366)(BgL_fun1647z00_366, BgL_arg1646z00_367, BEOA); } } 
BGl_miditrackzd2playzd2eventz00zz__multimediazd2midizd2(BgL_trackz00_361, BGl_midiplayerzd2readzd2zz__multimediazd2midizd2, BGl_midisinkzd2nullzd2zz__multimediazd2midizd2, ((long)0), ((long)0), ((long)0), 
LONG_TO_LLONG(((long)0))); 
if(
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_361))->BgL_z52eotz52))
{ /* Llib/midi.scm 232 */
BgL_t0z00_334 = BgL_trackz00_361; }  else 
{ /* Llib/midi.scm 232 */
goto BgL_zc3z04anonymousza31645ze3z87_365;} } } } 
{ /* Llib/midi.scm 243 */
obj_t BgL_filez00_336;
{ /* Llib/midi.scm 243 */
obj_t BgL_res2556z00_1949;
BgL_res2556z00_1949 = 
INPUT_PORT_NAME(BgL_ipz00_17); 
BgL_filez00_336 = BgL_res2556z00_1949; } 
{ /* Llib/midi.scm 244 */
long BgL_g1139z00_337;
{ /* Llib/midi.scm 245 */
long BgL_res2557z00_1951;
BgL_res2557z00_1951 = 
INPUT_PORT_FILEPOS(BgL_ipz00_17); 
BgL_g1139z00_337 = BgL_res2557z00_1951; } 
{ 
long BgL_iz00_340;long BgL_posz00_341;obj_t BgL_tksz00_342;
BgL_iz00_340 = ((long)1); 
BgL_posz00_341 = BgL_g1139z00_337; 
BgL_tksz00_342 = BNIL; 
BgL_zc3z04anonymousza31620ze3z87_343:
if(
(BgL_iz00_340==
(long)CINT(BgL_tnumz00_19)))
{ /* Llib/midi.scm 248 */
obj_t BgL_arg1625z00_345;
{ /* Llib/midi.scm 248 */
obj_t BgL_arg1626z00_346;
BgL_arg1626z00_346 = 
bgl_reverse_bang(BgL_tksz00_342); 
BgL_arg1625z00_345 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_t0z00_334), BgL_arg1626z00_346); } 
return 
BGl_listzd2ze3vectorz31zz__r4_vectors_6_8z00(BgL_arg1625z00_345);}  else 
{ /* Llib/midi.scm 249 */
obj_t BgL_ipz00_347;
{ /* Llib/midi.scm 237 */
obj_t BgL_portz00_1955;
{ /* Llib/midi.scm 237 */

BgL_portz00_1955 = 
BGl_openzd2inputzd2filez00zz__r4_ports_6_10_1z00(BgL_filez00_336, BTRUE, 
BINT(((long)5000000))); } 
BGl_setzd2inputzd2portzd2positionz12zc0zz__r4_ports_6_10_1z00(BgL_portz00_1955, BgL_posz00_341); 
BgL_ipz00_347 = BgL_portz00_1955; } 
{ /* Llib/midi.scm 249 */
BgL_miditrackz00_bglt BgL_tz00_348;
BgL_tz00_348 = 
BGl_miditrackzd2inputzd2portz00zz__multimediazd2midizd2(BgL_ipz00_347, 
(((BgL_miditrackz00_bglt)COBJECT(BgL_t0z00_334))->BgL_tempoz00)); 
{ /* Llib/midi.scm 250 */

{ /* Llib/midi.scm 252 */
long BgL_arg1627z00_350;long BgL_arg1628z00_351;obj_t BgL_arg1629z00_352;
BgL_arg1627z00_350 = 
(BgL_iz00_340+((long)1)); 
{ /* Llib/midi.scm 253 */
long BgL_arg1631z00_353;long BgL_arg1635z00_354;
{ /* Llib/midi.scm 253 */
long BgL_res2560z00_1962;
{ /* Llib/midi.scm 253 */
obj_t BgL_tmpz00_4811;
BgL_tmpz00_4811 = 
((obj_t)BgL_ipz00_347); 
BgL_res2560z00_1962 = 
INPUT_PORT_FILEPOS(BgL_tmpz00_4811); } 
BgL_arg1631z00_353 = BgL_res2560z00_1962; } 
{ /* Llib/midi.scm 253 */
int32_t BgL_arg1642z00_355;
BgL_arg1642z00_355 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_tz00_348))->BgL_lenz00); 
{ /* Llib/midi.scm 253 */
long BgL_res2562z00_1967;
{ /* Llib/midi.scm 253 */
long BgL_arg1382z00_1964;
BgL_arg1382z00_1964 = 
(long)(BgL_arg1642z00_355); 
{ /* Llib/midi.scm 253 */
long BgL_res2561z00_1966;
BgL_res2561z00_1966 = 
(long)(BgL_arg1382z00_1964); 
BgL_res2562z00_1967 = BgL_res2561z00_1966; } } 
BgL_arg1635z00_354 = BgL_res2562z00_1967; } } 
BgL_arg1628z00_351 = 
(BgL_arg1631z00_353+BgL_arg1635z00_354); } 
BgL_arg1629z00_352 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_tz00_348), BgL_tksz00_342); 
{ 
obj_t BgL_tksz00_4822;long BgL_posz00_4821;long BgL_iz00_4820;
BgL_iz00_4820 = BgL_arg1627z00_350; 
BgL_posz00_4821 = BgL_arg1628z00_351; 
BgL_tksz00_4822 = BgL_arg1629z00_352; 
BgL_tksz00_342 = BgL_tksz00_4822; 
BgL_posz00_341 = BgL_posz00_4821; 
BgL_iz00_340 = BgL_iz00_4820; 
goto BgL_zc3z04anonymousza31620ze3z87_343;} } } } } } } } } } } 

}



/* miditrack-file */
BGL_EXPORTED_DEF BgL_miditrackz00_bglt BGl_miditrackzd2filezd2zz__multimediazd2midizd2(obj_t BgL_filenamez00_20, long BgL_offsetz00_21, long BgL_tempoz00_22)
{
{ /* Llib/midi.scm 259 */
{ /* Llib/midi.scm 262 */
obj_t BgL_zc3z04anonymousza31651ze3z87_3121;
BgL_zc3z04anonymousza31651ze3z87_3121 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31651ze3ze5zz__multimediazd2midizd2, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31651ze3z87_3121, 
(int)(((long)0)), 
BINT(BgL_offsetz00_21)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31651ze3z87_3121, 
(int)(((long)1)), 
BINT(BgL_tempoz00_22)); 
return 
((BgL_miditrackz00_bglt)
BGl_callzd2withzd2inputzd2filezd2zz__r4_ports_6_10_1z00(BgL_filenamez00_20, BgL_zc3z04anonymousza31651ze3z87_3121));} } 

}



/* &miditrack-file */
BgL_miditrackz00_bglt BGl_z62miditrackzd2filezb0zz__multimediazd2midizd2(obj_t BgL_envz00_3122, obj_t BgL_filenamez00_3123, obj_t BgL_offsetz00_3124, obj_t BgL_tempoz00_3125)
{
{ /* Llib/midi.scm 259 */
{ /* Llib/midi.scm 262 */
long BgL_auxz00_4850;long BgL_auxz00_4841;obj_t BgL_auxz00_4834;
{ /* Llib/midi.scm 262 */
obj_t BgL_tmpz00_4851;
if(
INTEGERP(BgL_tempoz00_3125))
{ /* Llib/midi.scm 262 */
BgL_tmpz00_4851 = BgL_tempoz00_3125
; }  else 
{ 
obj_t BgL_auxz00_4854;
BgL_auxz00_4854 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)11501)), BGl_string3040z00zz__multimediazd2midizd2, BGl_string3039z00zz__multimediazd2midizd2, BgL_tempoz00_3125); 
FAILURE(BgL_auxz00_4854,BFALSE,BFALSE);} 
BgL_auxz00_4850 = 
(long)CINT(BgL_tmpz00_4851); } 
{ /* Llib/midi.scm 262 */
obj_t BgL_tmpz00_4842;
if(
INTEGERP(BgL_offsetz00_3124))
{ /* Llib/midi.scm 262 */
BgL_tmpz00_4842 = BgL_offsetz00_3124
; }  else 
{ 
obj_t BgL_auxz00_4845;
BgL_auxz00_4845 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)11501)), BGl_string3040z00zz__multimediazd2midizd2, BGl_string3039z00zz__multimediazd2midizd2, BgL_offsetz00_3124); 
FAILURE(BgL_auxz00_4845,BFALSE,BFALSE);} 
BgL_auxz00_4841 = 
(long)CINT(BgL_tmpz00_4842); } 
if(
STRINGP(BgL_filenamez00_3123))
{ /* Llib/midi.scm 262 */
BgL_auxz00_4834 = BgL_filenamez00_3123
; }  else 
{ 
obj_t BgL_auxz00_4837;
BgL_auxz00_4837 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)11501)), BGl_string3040z00zz__multimediazd2midizd2, BGl_string3036z00zz__multimediazd2midizd2, BgL_filenamez00_3123); 
FAILURE(BgL_auxz00_4837,BFALSE,BFALSE);} 
return 
BGl_miditrackzd2filezd2zz__multimediazd2midizd2(BgL_auxz00_4834, BgL_auxz00_4841, BgL_auxz00_4850);} } 

}



/* &<@anonymous:1651> */
obj_t BGl_z62zc3z04anonymousza31651ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3126, obj_t BgL_ipz00_3129)
{
{ /* Llib/midi.scm 261 */
{ /* Llib/midi.scm 262 */
long BgL_offsetz00_3127;long BgL_tempoz00_3128;
BgL_offsetz00_3127 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_3126, 
(int)(((long)0)))); 
BgL_tempoz00_3128 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_3126, 
(int)(((long)1)))); 
{ 
BgL_miditrackz00_bglt BgL_auxz00_4866;
BGl_setzd2inputzd2portzd2positionz12zc0zz__r4_ports_6_10_1z00(BgL_ipz00_3129, BgL_offsetz00_3127); 
BgL_auxz00_4866 = 
BGl_miditrackzd2inputzd2portz00zz__multimediazd2midizd2(BgL_ipz00_3129, BgL_tempoz00_3128); 
return 
((obj_t)BgL_auxz00_4866);} } } 

}



/* miditrack-string */
BGL_EXPORTED_DEF BgL_miditrackz00_bglt BGl_miditrackzd2stringzd2zz__multimediazd2midizd2(obj_t BgL_stringz00_23, long BgL_tempoz00_24)
{
{ /* Llib/midi.scm 268 */
{ /* Llib/midi.scm 269 */
BgL_miditrackz00_bglt BgL_new1143z00_383;
{ /* Llib/midi.scm 270 */
BgL_miditrackz00_bglt BgL_new1142z00_387;
BgL_new1142z00_387 = 
((BgL_miditrackz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_miditrackz00_bgl) ))); 
{ /* Llib/midi.scm 270 */
long BgL_arg1661z00_388;
{ /* Llib/midi.scm 270 */
long BgL_res2564z00_1974;
BgL_res2564z00_1974 = 
BGL_CLASS_INDEX(BGl_miditrackz00zz__multimediazd2midizd2); 
BgL_arg1661z00_388 = BgL_res2564z00_1974; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1142z00_387), BgL_arg1661z00_388); } 
BgL_new1143z00_383 = BgL_new1142z00_387; } 
{ 
obj_t BgL_auxz00_4874;
{ /* Llib/midi.scm 127 */
obj_t BgL_newz00_1977;
BgL_newz00_1977 = 
create_struct(
CNST_TABLE_REF(((long)4)), 
(int)(((long)2))); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_4880;int BgL_tmpz00_4878;
BgL_auxz00_4880 = 
BINT(((long)0)); 
BgL_tmpz00_4878 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_1977, BgL_tmpz00_4878, BgL_auxz00_4880); } 
{ /* Llib/midi.scm 127 */
int BgL_tmpz00_4883;
BgL_tmpz00_4883 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_1977, BgL_tmpz00_4883, BgL_stringz00_23); } 
BgL_auxz00_4874 = BgL_newz00_1977; } 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_383))->BgL_z52streamz52)=((obj_t)BgL_auxz00_4874),BUNSPEC); } 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_383))->BgL_z52readerz52)=((BgL_midireaderz00_bglt)BGl_midireaderzd2stringzd2streamz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_383))->BgL_z52closez52)=((obj_t)BGl_proc3041z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_383))->BgL_z52eotz52)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_383))->BgL_z52wtickz52)=((uint32_t)(uint32_t)(0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_383))->BgL_z52statusz52)=((long)((long)0)),BUNSPEC); 
{ 
int32_t BgL_auxz00_4892;
{ /* Llib/midi.scm 273 */
long BgL_tmpz00_4893;
BgL_tmpz00_4893 = 
STRING_LENGTH(BgL_stringz00_23); 
BgL_auxz00_4892 = 
(int32_t)(BgL_tmpz00_4893); } 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_383))->BgL_lenz00)=((int32_t)BgL_auxz00_4892),BUNSPEC); } 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_383))->BgL_tempoz00)=((long)BgL_tempoz00_24),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_383))->BgL_ipz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_383))->BgL_startz00)=((long)((long)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_383))->BgL_datastartz00)=((long)((long)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_383))->BgL_wtickz00)=((uint32_t)(uint32_t)(0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_383))->BgL_statusz00)=((long)((long)-1)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_383))->BgL_eotz00)=((bool_t)((bool_t)0)),BUNSPEC); 
{ /* Llib/midi.scm 269 */
obj_t BgL_fun1653z00_386;
BgL_fun1653z00_386 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_miditrackz00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun1653z00_386)(BgL_fun1653z00_386, 
((obj_t)BgL_new1143z00_383), BEOA); } 
return BgL_new1143z00_383;} } 

}



/* &miditrack-string */
BgL_miditrackz00_bglt BGl_z62miditrackzd2stringzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3131, obj_t BgL_stringz00_3132, obj_t BgL_tempoz00_3133)
{
{ /* Llib/midi.scm 268 */
{ /* Llib/midi.scm 269 */
long BgL_auxz00_4917;obj_t BgL_auxz00_4910;
{ /* Llib/midi.scm 269 */
obj_t BgL_tmpz00_4918;
if(
INTEGERP(BgL_tempoz00_3133))
{ /* Llib/midi.scm 269 */
BgL_tmpz00_4918 = BgL_tempoz00_3133
; }  else 
{ 
obj_t BgL_auxz00_4921;
BgL_auxz00_4921 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)11847)), BGl_string3042z00zz__multimediazd2midizd2, BGl_string3039z00zz__multimediazd2midizd2, BgL_tempoz00_3133); 
FAILURE(BgL_auxz00_4921,BFALSE,BFALSE);} 
BgL_auxz00_4917 = 
(long)CINT(BgL_tmpz00_4918); } 
if(
STRINGP(BgL_stringz00_3132))
{ /* Llib/midi.scm 269 */
BgL_auxz00_4910 = BgL_stringz00_3132
; }  else 
{ 
obj_t BgL_auxz00_4913;
BgL_auxz00_4913 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)11847)), BGl_string3042z00zz__multimediazd2midizd2, BGl_string3036z00zz__multimediazd2midizd2, BgL_stringz00_3132); 
FAILURE(BgL_auxz00_4913,BFALSE,BFALSE);} 
return 
BGl_miditrackzd2stringzd2zz__multimediazd2midizd2(BgL_auxz00_4910, BgL_auxz00_4917);} } 

}



/* &<@anonymous:1652> */
obj_t BGl_z62zc3z04anonymousza31652ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3134, obj_t BgL_sz00_3135)
{
{ /* Llib/midi.scm 272 */
return 
BBOOL(((bool_t)0));} 

}



/* midiscore-play */
BGL_EXPORTED_DEF obj_t BGl_midiscorezd2playzd2zz__multimediazd2midizd2(BgL_midiscorez00_bglt BgL_mscorez00_25, BgL_midiplayerz00_bglt BgL_mplayerz00_26, BgL_midisinkz00_bglt BgL_msinkz00_27)
{
{ /* Llib/midi.scm 279 */
{ 

{ /* Llib/midi.scm 281 */
long BgL_aux1146z00_391;
BgL_aux1146z00_391 = 
(((BgL_midiscorez00_bglt)COBJECT(BgL_mscorez00_25))->BgL_formatz00); 
switch( BgL_aux1146z00_391) { case ((long)0) : 

return 
BBOOL(
BGl_midiscorezd2play0zd2zz__multimediazd2midizd2(BgL_mscorez00_25, BgL_mplayerz00_26, BgL_msinkz00_27));break;case ((long)1) : 

return 
BBOOL(
BGl_midiscorezd2play1zd2zz__multimediazd2midizd2(BgL_mscorez00_25, BgL_mplayerz00_26, BgL_msinkz00_27));break;
default: 
{ /* Llib/midi.scm 284 */
long BgL_arg1663z00_393;
BgL_arg1663z00_393 = 
(((BgL_midiscorez00_bglt)COBJECT(BgL_mscorez00_25))->BgL_formatz00); 
return 
BGl_errorz00zz__errorz00(BGl_string3043z00zz__multimediazd2midizd2, BGl_string3033z00zz__multimediazd2midizd2, 
BINT(BgL_arg1663z00_393));} } } } } 

}



/* &midiscore-play */
obj_t BGl_z62midiscorezd2playzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3136, obj_t BgL_mscorez00_3137, obj_t BgL_mplayerz00_3138, obj_t BgL_msinkz00_3139)
{
{ /* Llib/midi.scm 279 */
{ /* Llib/midi.scm 280 */
BgL_midisinkz00_bglt BgL_auxz00_4953;BgL_midiplayerz00_bglt BgL_auxz00_4945;BgL_midiscorez00_bglt BgL_auxz00_4937;
if(
BGl_isazf3zf3zz__objectz00(BgL_msinkz00_3139, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 280 */
BgL_auxz00_4953 = 
((BgL_midisinkz00_bglt)BgL_msinkz00_3139)
; }  else 
{ 
obj_t BgL_auxz00_4957;
BgL_auxz00_4957 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)12346)), BGl_string3044z00zz__multimediazd2midizd2, BGl_string3047z00zz__multimediazd2midizd2, BgL_msinkz00_3139); 
FAILURE(BgL_auxz00_4957,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mplayerz00_3138, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 280 */
BgL_auxz00_4945 = 
((BgL_midiplayerz00_bglt)BgL_mplayerz00_3138)
; }  else 
{ 
obj_t BgL_auxz00_4949;
BgL_auxz00_4949 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)12346)), BGl_string3044z00zz__multimediazd2midizd2, BGl_string3046z00zz__multimediazd2midizd2, BgL_mplayerz00_3138); 
FAILURE(BgL_auxz00_4949,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mscorez00_3137, BGl_midiscorez00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 280 */
BgL_auxz00_4937 = 
((BgL_midiscorez00_bglt)BgL_mscorez00_3137)
; }  else 
{ 
obj_t BgL_auxz00_4941;
BgL_auxz00_4941 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)12346)), BGl_string3044z00zz__multimediazd2midizd2, BGl_string3045z00zz__multimediazd2midizd2, BgL_mscorez00_3137); 
FAILURE(BgL_auxz00_4941,BFALSE,BFALSE);} 
return 
BGl_midiscorezd2playzd2zz__multimediazd2midizd2(BgL_auxz00_4937, BgL_auxz00_4945, BgL_auxz00_4953);} } 

}



/* midiscore-play0 */
bool_t BGl_midiscorezd2play0zd2zz__multimediazd2midizd2(BgL_midiscorez00_bglt BgL_mscorez00_28, BgL_midiplayerz00_bglt BgL_mplayerz00_29, BgL_midisinkz00_bglt BgL_msinkz00_30)
{
{ /* Llib/midi.scm 289 */
{ /* Llib/midi.scm 291 */
obj_t BgL_trackz00_395;
BgL_trackz00_395 = 
VECTOR_REF(
(((BgL_midiscorez00_bglt)COBJECT(BgL_mscorez00_28))->BgL_tracksz00),((long)0)); 
{ /* Llib/midi.scm 293 */
BgL_midireaderz00_bglt BgL_i1149z00_397;
BgL_i1149z00_397 = 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_trackz00_395)))->BgL_z52readerz52); 
{ 
uint32_t BgL_tickz00_399;
BgL_tickz00_399 = (uint32_t)(0); 
BgL_zc3z04anonymousza31664ze3z87_400:
{ /* Llib/midi.scm 295 */
BGL_LONGLONG_T BgL_t0z00_401;
BgL_t0z00_401 = 
bgl_current_microseconds(); 
{ /* Llib/midi.scm 295 */
obj_t BgL_dtz00_402;
{ /* Llib/midi.scm 296 */
obj_t BgL_fun1677z00_407;
BgL_fun1677z00_407 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1149z00_397))->BgL_readzd2vlqzd2); 
{ /* Llib/midi.scm 296 */
obj_t BgL_arg1676z00_408;
BgL_arg1676z00_408 = 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_trackz00_395)))->BgL_z52streamz52); 
BgL_dtz00_402 = 
PROCEDURE_ENTRY(BgL_fun1677z00_407)(BgL_fun1677z00_407, BgL_arg1676z00_408, BEOA); } } 
{ /* Llib/midi.scm 296 */

{ /* Llib/midi.scm 298 */
long BgL_arg1665z00_403;long BgL_arg1666z00_404;
{ /* Llib/midi.scm 298 */
long BgL_res2567z00_1985;
BgL_res2567z00_1985 = 
(long)(BgL_tickz00_399); 
BgL_arg1665z00_403 = BgL_res2567z00_1985; } 
BgL_arg1666z00_404 = 
(((BgL_midiscorez00_bglt)COBJECT(BgL_mscorez00_28))->BgL_ppqz00); 
BGl_miditrackzd2playzd2eventz00zz__multimediazd2midizd2(
((BgL_miditrackz00_bglt)BgL_trackz00_395), BgL_mplayerz00_29, BgL_msinkz00_30, BgL_arg1665z00_403, BgL_arg1666z00_404, 
(long)CINT(BgL_dtz00_402), BgL_t0z00_401); } 
if(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_trackz00_395)))->BgL_z52eotz52))
{ /* Llib/midi.scm 299 */
return ((bool_t)0);}  else 
{ /* Llib/midi.scm 300 */
uint32_t BgL_arg1668z00_406;
BgL_arg1668z00_406 = 
(BgL_tickz00_399+
(uint32_t)(((long)1))); 
{ 
uint32_t BgL_tickz00_4984;
BgL_tickz00_4984 = BgL_arg1668z00_406; 
BgL_tickz00_399 = BgL_tickz00_4984; 
goto BgL_zc3z04anonymousza31664ze3z87_400;} } } } } } } } } 

}



/* midiscore-play1 */
bool_t BGl_midiscorezd2play1zd2zz__multimediazd2midizd2(BgL_midiscorez00_bglt BgL_mscorez00_31, BgL_midiplayerz00_bglt BgL_mplayerz00_32, BgL_midisinkz00_bglt BgL_msinkz00_33)
{
{ /* Llib/midi.scm 305 */
{ /* Llib/midi.scm 307 */
obj_t BgL_v1192z00_412;
BgL_v1192z00_412 = 
(((BgL_midiscorez00_bglt)COBJECT(BgL_mscorez00_31))->BgL_tracksz00); 
{ /* Llib/midi.scm 307 */

{ 
long BgL_i1191z00_415;
BgL_i1191z00_415 = ((long)0); 
BgL_zc3z04anonymousza31681ze3z87_416:
if(
(BgL_i1191z00_415<
VECTOR_LENGTH(BgL_v1192z00_412)))
{ /* Llib/midi.scm 307 */
{ /* Llib/midi.scm 308 */
obj_t BgL_trackz00_418;
BgL_trackz00_418 = 
VECTOR_REF(BgL_v1192z00_412,BgL_i1191z00_415); 
if(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_trackz00_418)))->BgL_z52eotz52))
{ /* Llib/midi.scm 309 */BFALSE; }  else 
{ /* Llib/midi.scm 310 */
BgL_midireaderz00_bglt BgL_i1152z00_421;
BgL_i1152z00_421 = 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_trackz00_418)))->BgL_z52readerz52); 
{ /* Llib/midi.scm 311 */
obj_t BgL_dtz00_422;
{ /* Llib/midi.scm 311 */
obj_t BgL_fun1687z00_423;
BgL_fun1687z00_423 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1152z00_421))->BgL_readzd2vlqzd2); 
{ /* Llib/midi.scm 311 */
obj_t BgL_arg1686z00_424;
BgL_arg1686z00_424 = 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_trackz00_418)))->BgL_z52streamz52); 
BgL_dtz00_422 = 
PROCEDURE_ENTRY(BgL_fun1687z00_423)(BgL_fun1687z00_423, BgL_arg1686z00_424, BEOA); } } 
{ 
uint32_t BgL_auxz00_5002;
{ /* Llib/midi.scm 312 */
int32_t BgL_res2570z00_1996;
{ /* Llib/midi.scm 312 */
long BgL_xz00_1995;
BgL_xz00_1995 = 
(long)CINT(BgL_dtz00_422); 
BgL_res2570z00_1996 = 
(int32_t)(BgL_xz00_1995); } 
BgL_auxz00_5002 = 
(uint32_t)(BgL_res2570z00_1996); } 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_trackz00_418)))->BgL_z52wtickz52)=((uint32_t)BgL_auxz00_5002),BUNSPEC); } } } } 
{ 
long BgL_i1191z00_5008;
BgL_i1191z00_5008 = 
(BgL_i1191z00_415+((long)1)); 
BgL_i1191z00_415 = BgL_i1191z00_5008; 
goto BgL_zc3z04anonymousza31681ze3z87_416;} }  else 
{ /* Llib/midi.scm 307 */((bool_t)0); } } } } 
{ /* Llib/midi.scm 314 */
long BgL_resz00_427;
{ /* Llib/midi.scm 314 */
BgL_miditrackz00_bglt BgL_i1153z00_456;
{ /* Llib/midi.scm 314 */
obj_t BgL_arg1732z00_459;
BgL_arg1732z00_459 = 
(((BgL_midiscorez00_bglt)COBJECT(BgL_mscorez00_31))->BgL_tracksz00); 
BgL_i1153z00_456 = 
((BgL_miditrackz00_bglt)
VECTOR_REF(BgL_arg1732z00_459,((long)0))); } 
BgL_resz00_427 = 
(
(((BgL_miditrackz00_bglt)COBJECT(BgL_i1153z00_456))->BgL_tempoz00)/
(((BgL_midiscorez00_bglt)COBJECT(BgL_mscorez00_31))->BgL_ppqz00)); } 
{ 
uint32_t BgL_tickz00_429;
BgL_tickz00_429 = (uint32_t)(0); 
BgL_zc3z04anonymousza31690ze3z87_430:
{ /* Llib/midi.scm 317 */
BGL_LONGLONG_T BgL_t0z00_431;
BgL_t0z00_431 = 
bgl_current_microseconds(); 
{ /* Llib/midi.scm 317 */
bool_t BgL_eosz00_432;
BgL_eosz00_432 = ((bool_t)1); 
{ /* Llib/midi.scm 318 */

{ /* Llib/midi.scm 319 */
long BgL_g1154z00_433;
{ /* Llib/midi.scm 319 */
long BgL_arg1713z00_446;
BgL_arg1713z00_446 = 
VECTOR_LENGTH(
(((BgL_midiscorez00_bglt)COBJECT(BgL_mscorez00_31))->BgL_tracksz00)); 
BgL_g1154z00_433 = 
(BgL_arg1713z00_446-((long)1)); } 
{ 
long BgL_iz00_435;
BgL_iz00_435 = BgL_g1154z00_433; 
BgL_zc3z04anonymousza31691ze3z87_436:
if(
(BgL_iz00_435>((long)0)))
{ /* Llib/midi.scm 320 */
{ /* Llib/midi.scm 321 */
obj_t BgL_trackz00_438;
BgL_trackz00_438 = 
VECTOR_REF(
(((BgL_midiscorez00_bglt)COBJECT(BgL_mscorez00_31))->BgL_tracksz00),BgL_iz00_435); 
if(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_trackz00_438)))->BgL_z52eotz52))
{ /* Llib/midi.scm 323 */BFALSE; }  else 
{ /* Llib/midi.scm 323 */
{ /* Llib/midi.scm 325 */
long BgL_arg1699z00_441;
{ /* Llib/midi.scm 325 */
long BgL_res2576z00_2012;
BgL_res2576z00_2012 = 
(long)(BgL_tickz00_429); 
BgL_arg1699z00_441 = BgL_res2576z00_2012; } 
BGl_miditrackzd2waitzd2eventz00zz__multimediazd2midizd2(
((BgL_miditrackz00_bglt)BgL_trackz00_438), BgL_mplayerz00_32, BgL_msinkz00_33, BgL_arg1699z00_441); } 
if(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_trackz00_438)))->BgL_z52eotz52))
{ /* Llib/midi.scm 326 */BFALSE; }  else 
{ /* Llib/midi.scm 326 */
BgL_eosz00_432 = ((bool_t)0); } } } 
{ 
long BgL_iz00_5033;
BgL_iz00_5033 = 
(BgL_iz00_435-((long)1)); 
BgL_iz00_435 = BgL_iz00_5033; 
goto BgL_zc3z04anonymousza31691ze3z87_436;} }  else 
{ /* Llib/midi.scm 320 */((bool_t)0); } } } 
if(BgL_eosz00_432)
{ /* Llib/midi.scm 328 */
return ((bool_t)0);}  else 
{ /* Llib/midi.scm 329 */
long BgL_usz00_448;
{ /* Llib/midi.scm 329 */
BGL_LONGLONG_T BgL_arg1728z00_453;
BgL_arg1728z00_453 = 
(
bgl_current_microseconds()-BgL_t0z00_431); 
{ /* Llib/midi.scm 329 */
long BgL_res2580z00_2020;
BgL_res2580z00_2020 = 
LLONG_TO_LONG(BgL_arg1728z00_453); 
BgL_usz00_448 = BgL_res2580z00_2020; } } 
{ /* Llib/midi.scm 331 */
obj_t BgL_fun1726z00_450;
BgL_fun1726z00_450 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msinkz00_33))->BgL_usleepz00); 
{ /* Llib/midi.scm 331 */
long BgL_arg1725z00_451;
BgL_arg1725z00_451 = 
(BgL_resz00_427-BgL_usz00_448); 
PROCEDURE_ENTRY(BgL_fun1726z00_450)(BgL_fun1726z00_450, 
BINT(BgL_arg1725z00_451), BEOA); } } 
{ 
uint32_t BgL_tickz00_5046;
BgL_tickz00_5046 = 
(BgL_tickz00_429+(uint32_t)(1)); 
BgL_tickz00_429 = BgL_tickz00_5046; 
goto BgL_zc3z04anonymousza31690ze3z87_430;} } } } } } } } 

}



/* miditrack-wait-event */
obj_t BGl_miditrackzd2waitzd2eventz00zz__multimediazd2midizd2(BgL_miditrackz00_bglt BgL_trackz00_34, BgL_midiplayerz00_bglt BgL_mplayerz00_35, BgL_midisinkz00_bglt BgL_msinkz00_36, long BgL_tickz00_37)
{
{ /* Llib/midi.scm 337 */
{ /* Llib/midi.scm 340 */
BgL_midireaderz00_bglt BgL_i1158z00_461;
BgL_i1158z00_461 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_34))->BgL_z52readerz52); 
{ /* Llib/midi.scm 341 */
bool_t BgL_test3614z00_5049;
{ /* Llib/midi.scm 341 */
uint32_t BgL_n2z00_2028;
BgL_n2z00_2028 = 
(uint32_t)(BgL_tickz00_37); 
BgL_test3614z00_5049 = 
(
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_34))->BgL_z52wtickz52)<=BgL_n2z00_2028); } 
if(BgL_test3614z00_5049)
{ 

BgL_zc3z04anonymousza31735ze3z87_465:
BGl_miditrackzd2playzd2eventz00zz__multimediazd2midizd2(BgL_trackz00_34, BgL_mplayerz00_35, BgL_msinkz00_36, BgL_tickz00_37, ((long)0), ((long)0), ((BGL_LONGLONG_T)0)); 
if(
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_34))->BgL_z52eotz52))
{ /* Llib/midi.scm 344 */
return BFALSE;}  else 
{ /* Llib/midi.scm 345 */
obj_t BgL_dtz00_467;
{ /* Llib/midi.scm 345 */
obj_t BgL_fun1740z00_470;
BgL_fun1740z00_470 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1158z00_461))->BgL_readzd2vlqzd2); 
{ /* Llib/midi.scm 345 */
obj_t BgL_arg1739z00_471;
BgL_arg1739z00_471 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_34))->BgL_z52streamz52); 
BgL_dtz00_467 = 
PROCEDURE_ENTRY(BgL_fun1740z00_470)(BgL_fun1740z00_470, BgL_arg1739z00_471, BEOA); } } 
if(
(
(long)CINT(BgL_dtz00_467)==((long)0)))
{ /* Llib/midi.scm 346 */
goto BgL_zc3z04anonymousza31735ze3z87_465;}  else 
{ 
uint32_t BgL_auxz00_5065;
{ /* Llib/midi.scm 348 */
int32_t BgL_arg1738z00_469;
{ /* Llib/midi.scm 348 */
int32_t BgL_res2585z00_2033;
{ /* Llib/midi.scm 348 */
long BgL_xz00_2032;
BgL_xz00_2032 = 
(long)CINT(BgL_dtz00_467); 
BgL_res2585z00_2033 = 
(int32_t)(BgL_xz00_2032); } 
BgL_arg1738z00_469 = BgL_res2585z00_2033; } 
{ /* Llib/midi.scm 348 */
uint32_t BgL_za71za7_2034;uint32_t BgL_za72za7_2035;
BgL_za71za7_2034 = 
(uint32_t)(BgL_tickz00_37); 
BgL_za72za7_2035 = 
(uint32_t)(BgL_arg1738z00_469); 
BgL_auxz00_5065 = 
(BgL_za71za7_2034+BgL_za72za7_2035); } } 
return 
((((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_34))->BgL_z52wtickz52)=((uint32_t)BgL_auxz00_5065),BUNSPEC);} } }  else 
{ /* Llib/midi.scm 341 */
return BFALSE;} } } } 

}



/* miditrack-play-event */
obj_t BGl_miditrackzd2playzd2eventz00zz__multimediazd2midizd2(BgL_miditrackz00_bglt BgL_trackz00_38, BgL_midiplayerz00_bglt BgL_mplayerz00_39, BgL_midisinkz00_bglt BgL_msinkz00_40, long BgL_tickz00_41, long BgL_ppqz00_42, long BgL_dtz00_43, BGL_LONGLONG_T BgL_t0z00_44)
{
{ /* Llib/midi.scm 353 */
{ /* Llib/midi.scm 357 */
BgL_midireaderz00_bglt BgL_i1160z00_475;
BgL_i1160z00_475 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52readerz52); 
{ /* Llib/midi.scm 372 */
obj_t BgL_statusz00_477;
{ /* Llib/midi.scm 372 */
bool_t BgL_test3617z00_5073;
{ /* Llib/midi.scm 372 */
obj_t BgL_arg1947z00_711;
{ /* Llib/midi.scm 372 */
obj_t BgL_fun1949z00_712;
BgL_fun1949z00_712 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_peekzd2bytezd2); 
{ /* Llib/midi.scm 372 */
obj_t BgL_arg1948z00_713;
BgL_arg1948z00_713 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1947z00_711 = 
PROCEDURE_ENTRY(BgL_fun1949z00_712)(BgL_fun1949z00_712, BgL_arg1948z00_713, BEOA); } } 
BgL_test3617z00_5073 = 
(
(long)CINT(BgL_arg1947z00_711)<((long)128)); } 
if(BgL_test3617z00_5073)
{ /* Llib/midi.scm 372 */
BgL_statusz00_477 = 
BINT(
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52statusz52)); }  else 
{ /* Llib/midi.scm 374 */
obj_t BgL_sz00_708;
{ /* Llib/midi.scm 374 */
obj_t BgL_fun1946z00_709;
BgL_fun1946z00_709 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 374 */
obj_t BgL_arg1945z00_710;
BgL_arg1945z00_710 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_sz00_708 = 
PROCEDURE_ENTRY(BgL_fun1946z00_709)(BgL_fun1946z00_709, BgL_arg1945z00_710, BEOA); } } 
((((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52statusz52)=((long)
(long)CINT(BgL_sz00_708)),BUNSPEC); 
BgL_statusz00_477 = BgL_sz00_708; } } 
if(
(
(
(long)CINT(BgL_statusz00_477) >> 
(int)(((long)4)))==((long)8)))
{ /* Llib/midi.scm 380 */
long BgL_kkz00_480;
{ /* Llib/midi.scm 380 */
obj_t BgL_arg1753z00_491;
{ /* Llib/midi.scm 380 */
obj_t BgL_fun1755z00_492;
BgL_fun1755z00_492 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 380 */
obj_t BgL_arg1754z00_493;
BgL_arg1754z00_493 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1753z00_491 = 
PROCEDURE_ENTRY(BgL_fun1755z00_492)(BgL_fun1755z00_492, BgL_arg1754z00_493, BEOA); } } 
BgL_kkz00_480 = 
(((long)127) & 
(long)CINT(BgL_arg1753z00_491)); } 
{ /* Llib/midi.scm 380 */
long BgL_vvz00_481;
{ /* Llib/midi.scm 381 */
obj_t BgL_arg1750z00_488;
{ /* Llib/midi.scm 381 */
obj_t BgL_fun1752z00_489;
BgL_fun1752z00_489 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 381 */
obj_t BgL_arg1751z00_490;
BgL_arg1751z00_490 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1750z00_488 = 
PROCEDURE_ENTRY(BgL_fun1752z00_489)(BgL_fun1752z00_489, BgL_arg1751z00_490, BEOA); } } 
BgL_vvz00_481 = 
(((long)127) & 
(long)CINT(BgL_arg1750z00_488)); } 
{ /* Llib/midi.scm 381 */

{ /* Llib/midi.scm 382 */
obj_t BgL_fun1745z00_482;
BgL_fun1745z00_482 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_cdelayz00); 
{ /* Llib/midi.scm 383 */
long BgL_arg1744z00_483;
{ /* Llib/midi.scm 383 */
BGL_LONGLONG_T BgL_arg1746z00_484;
BgL_arg1746z00_484 = 
(
bgl_current_microseconds()-BgL_t0z00_44); 
{ /* Llib/midi.scm 383 */
long BgL_res2594z00_2054;
BgL_res2594z00_2054 = 
LLONG_TO_LONG(BgL_arg1746z00_484); 
BgL_arg1744z00_483 = BgL_res2594z00_2054; } } 
PROCEDURE_ENTRY(BgL_fun1745z00_482)(BgL_fun1745z00_482, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
((obj_t)BgL_trackz00_38), 
BINT(BgL_ppqz00_42), 
BINT(BgL_dtz00_43), 
BINT(BgL_arg1744z00_483), BEOA); } } 
{ /* Llib/midi.scm 384 */
obj_t BgL_fun1749z00_486;
BgL_fun1749z00_486 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_noteoffz00); 
{ /* Llib/midi.scm 384 */
long BgL_arg1748z00_487;
BgL_arg1748z00_487 = 
(
(long)CINT(BgL_statusz00_477) & ((long)15)); 
PROCEDURE_ENTRY(BgL_fun1749z00_486)(BgL_fun1749z00_486, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BINT(BgL_arg1748z00_487), 
BINT(BgL_kkz00_480), 
BINT(BgL_vvz00_481), BEOA); } } } } }  else 
{ /* Llib/midi.scm 378 */
if(
(
(
(long)CINT(BgL_statusz00_477) >> 
(int)(((long)4)))==((long)9)))
{ /* Llib/midi.scm 387 */
long BgL_kkz00_496;
{ /* Llib/midi.scm 387 */
obj_t BgL_arg1767z00_507;
{ /* Llib/midi.scm 387 */
obj_t BgL_fun1769z00_508;
BgL_fun1769z00_508 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 387 */
obj_t BgL_arg1768z00_509;
BgL_arg1768z00_509 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1767z00_507 = 
PROCEDURE_ENTRY(BgL_fun1769z00_508)(BgL_fun1769z00_508, BgL_arg1768z00_509, BEOA); } } 
BgL_kkz00_496 = 
(((long)127) & 
(long)CINT(BgL_arg1767z00_507)); } 
{ /* Llib/midi.scm 387 */
long BgL_vvz00_497;
{ /* Llib/midi.scm 388 */
obj_t BgL_arg1764z00_504;
{ /* Llib/midi.scm 388 */
obj_t BgL_fun1766z00_505;
BgL_fun1766z00_505 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 388 */
obj_t BgL_arg1765z00_506;
BgL_arg1765z00_506 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1764z00_504 = 
PROCEDURE_ENTRY(BgL_fun1766z00_505)(BgL_fun1766z00_505, BgL_arg1765z00_506, BEOA); } } 
BgL_vvz00_497 = 
(((long)127) & 
(long)CINT(BgL_arg1764z00_504)); } 
{ /* Llib/midi.scm 388 */

{ /* Llib/midi.scm 389 */
obj_t BgL_fun1759z00_498;
BgL_fun1759z00_498 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_cdelayz00); 
{ /* Llib/midi.scm 390 */
long BgL_arg1758z00_499;
{ /* Llib/midi.scm 390 */
BGL_LONGLONG_T BgL_arg1760z00_500;
BgL_arg1760z00_500 = 
(
bgl_current_microseconds()-BgL_t0z00_44); 
{ /* Llib/midi.scm 390 */
long BgL_res2602z00_2072;
BgL_res2602z00_2072 = 
LLONG_TO_LONG(BgL_arg1760z00_500); 
BgL_arg1758z00_499 = BgL_res2602z00_2072; } } 
PROCEDURE_ENTRY(BgL_fun1759z00_498)(BgL_fun1759z00_498, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
((obj_t)BgL_trackz00_38), 
BINT(BgL_ppqz00_42), 
BINT(BgL_dtz00_43), 
BINT(BgL_arg1758z00_499), BEOA); } } 
{ /* Llib/midi.scm 391 */
obj_t BgL_fun1763z00_502;
BgL_fun1763z00_502 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_noteonz00); 
{ /* Llib/midi.scm 391 */
long BgL_arg1762z00_503;
BgL_arg1762z00_503 = 
(
(long)CINT(BgL_statusz00_477) & ((long)15)); 
PROCEDURE_ENTRY(BgL_fun1763z00_502)(BgL_fun1763z00_502, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BINT(BgL_arg1762z00_503), 
BINT(BgL_kkz00_496), 
BINT(BgL_vvz00_497), BEOA); } } } } }  else 
{ /* Llib/midi.scm 385 */
if(
(
(
(long)CINT(BgL_statusz00_477) >> 
(int)(((long)4)))==((long)10)))
{ /* Llib/midi.scm 394 */
long BgL_ccz00_512;
{ /* Llib/midi.scm 394 */
obj_t BgL_arg1781z00_523;
{ /* Llib/midi.scm 394 */
obj_t BgL_fun1783z00_524;
BgL_fun1783z00_524 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 394 */
obj_t BgL_arg1782z00_525;
BgL_arg1782z00_525 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1781z00_523 = 
PROCEDURE_ENTRY(BgL_fun1783z00_524)(BgL_fun1783z00_524, BgL_arg1782z00_525, BEOA); } } 
BgL_ccz00_512 = 
(((long)127) & 
(long)CINT(BgL_arg1781z00_523)); } 
{ /* Llib/midi.scm 394 */
long BgL_vvz00_513;
{ /* Llib/midi.scm 395 */
obj_t BgL_arg1778z00_520;
{ /* Llib/midi.scm 395 */
obj_t BgL_fun1780z00_521;
BgL_fun1780z00_521 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 395 */
obj_t BgL_arg1779z00_522;
BgL_arg1779z00_522 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1778z00_520 = 
PROCEDURE_ENTRY(BgL_fun1780z00_521)(BgL_fun1780z00_521, BgL_arg1779z00_522, BEOA); } } 
BgL_vvz00_513 = 
(((long)127) & 
(long)CINT(BgL_arg1778z00_520)); } 
{ /* Llib/midi.scm 395 */

{ /* Llib/midi.scm 396 */
obj_t BgL_fun1773z00_514;
BgL_fun1773z00_514 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_cdelayz00); 
{ /* Llib/midi.scm 397 */
long BgL_arg1772z00_515;
{ /* Llib/midi.scm 397 */
BGL_LONGLONG_T BgL_arg1774z00_516;
BgL_arg1774z00_516 = 
(
bgl_current_microseconds()-BgL_t0z00_44); 
{ /* Llib/midi.scm 397 */
long BgL_res2610z00_2090;
BgL_res2610z00_2090 = 
LLONG_TO_LONG(BgL_arg1774z00_516); 
BgL_arg1772z00_515 = BgL_res2610z00_2090; } } 
PROCEDURE_ENTRY(BgL_fun1773z00_514)(BgL_fun1773z00_514, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
((obj_t)BgL_trackz00_38), 
BINT(BgL_ppqz00_42), 
BINT(BgL_dtz00_43), 
BINT(BgL_arg1772z00_515), BEOA); } } 
{ /* Llib/midi.scm 398 */
obj_t BgL_fun1777z00_518;
BgL_fun1777z00_518 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_aftertouchz00); 
{ /* Llib/midi.scm 398 */
long BgL_arg1776z00_519;
BgL_arg1776z00_519 = 
(
(long)CINT(BgL_statusz00_477) & ((long)15)); 
PROCEDURE_ENTRY(BgL_fun1777z00_518)(BgL_fun1777z00_518, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BINT(BgL_arg1776z00_519), 
BINT(BgL_ccz00_512), 
BINT(BgL_vvz00_513), BEOA); } } } } }  else 
{ /* Llib/midi.scm 392 */
if(
(
(
(long)CINT(BgL_statusz00_477) >> 
(int)(((long)4)))==((long)11)))
{ /* Llib/midi.scm 401 */
long BgL_ccz00_528;
{ /* Llib/midi.scm 401 */
obj_t BgL_arg1795z00_539;
{ /* Llib/midi.scm 401 */
obj_t BgL_fun1797z00_540;
BgL_fun1797z00_540 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 401 */
obj_t BgL_arg1796z00_541;
BgL_arg1796z00_541 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1795z00_539 = 
PROCEDURE_ENTRY(BgL_fun1797z00_540)(BgL_fun1797z00_540, BgL_arg1796z00_541, BEOA); } } 
BgL_ccz00_528 = 
(((long)127) & 
(long)CINT(BgL_arg1795z00_539)); } 
{ /* Llib/midi.scm 401 */
long BgL_nnz00_529;
{ /* Llib/midi.scm 402 */
obj_t BgL_arg1792z00_536;
{ /* Llib/midi.scm 402 */
obj_t BgL_fun1794z00_537;
BgL_fun1794z00_537 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 402 */
obj_t BgL_arg1793z00_538;
BgL_arg1793z00_538 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1792z00_536 = 
PROCEDURE_ENTRY(BgL_fun1794z00_537)(BgL_fun1794z00_537, BgL_arg1793z00_538, BEOA); } } 
BgL_nnz00_529 = 
(((long)127) & 
(long)CINT(BgL_arg1792z00_536)); } 
{ /* Llib/midi.scm 402 */

{ /* Llib/midi.scm 403 */
obj_t BgL_fun1787z00_530;
BgL_fun1787z00_530 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_cdelayz00); 
{ /* Llib/midi.scm 404 */
long BgL_arg1786z00_531;
{ /* Llib/midi.scm 404 */
BGL_LONGLONG_T BgL_arg1788z00_532;
BgL_arg1788z00_532 = 
(
bgl_current_microseconds()-BgL_t0z00_44); 
{ /* Llib/midi.scm 404 */
long BgL_res2618z00_2108;
BgL_res2618z00_2108 = 
LLONG_TO_LONG(BgL_arg1788z00_532); 
BgL_arg1786z00_531 = BgL_res2618z00_2108; } } 
PROCEDURE_ENTRY(BgL_fun1787z00_530)(BgL_fun1787z00_530, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
((obj_t)BgL_trackz00_38), 
BINT(BgL_ppqz00_42), 
BINT(BgL_dtz00_43), 
BINT(BgL_arg1786z00_531), BEOA); } } 
{ /* Llib/midi.scm 405 */
obj_t BgL_fun1791z00_534;
BgL_fun1791z00_534 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_ctrlchangez00); 
{ /* Llib/midi.scm 405 */
long BgL_arg1790z00_535;
BgL_arg1790z00_535 = 
(
(long)CINT(BgL_statusz00_477) & ((long)15)); 
PROCEDURE_ENTRY(BgL_fun1791z00_534)(BgL_fun1791z00_534, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BINT(BgL_arg1790z00_535), 
BINT(BgL_ccz00_528), 
BINT(BgL_nnz00_529), BEOA); } } } } }  else 
{ /* Llib/midi.scm 399 */
if(
(
(
(long)CINT(BgL_statusz00_477) >> 
(int)(((long)4)))==((long)12)))
{ /* Llib/midi.scm 408 */
long BgL_ppz00_544;
{ /* Llib/midi.scm 408 */
obj_t BgL_arg1806z00_551;
{ /* Llib/midi.scm 408 */
obj_t BgL_fun1808z00_552;
BgL_fun1808z00_552 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 408 */
obj_t BgL_arg1807z00_553;
BgL_arg1807z00_553 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1806z00_551 = 
PROCEDURE_ENTRY(BgL_fun1808z00_552)(BgL_fun1808z00_552, BgL_arg1807z00_553, BEOA); } } 
BgL_ppz00_544 = 
(((long)127) & 
(long)CINT(BgL_arg1806z00_551)); } 
{ /* Llib/midi.scm 409 */
obj_t BgL_fun1801z00_545;
BgL_fun1801z00_545 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_cdelayz00); 
{ /* Llib/midi.scm 410 */
long BgL_arg1800z00_546;
{ /* Llib/midi.scm 410 */
BGL_LONGLONG_T BgL_arg1802z00_547;
BgL_arg1802z00_547 = 
(
bgl_current_microseconds()-BgL_t0z00_44); 
{ /* Llib/midi.scm 410 */
long BgL_res2625z00_2123;
BgL_res2625z00_2123 = 
LLONG_TO_LONG(BgL_arg1802z00_547); 
BgL_arg1800z00_546 = BgL_res2625z00_2123; } } 
PROCEDURE_ENTRY(BgL_fun1801z00_545)(BgL_fun1801z00_545, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
((obj_t)BgL_trackz00_38), 
BINT(BgL_ppqz00_42), 
BINT(BgL_dtz00_43), 
BINT(BgL_arg1800z00_546), BEOA); } } 
{ /* Llib/midi.scm 411 */
obj_t BgL_fun1805z00_549;
BgL_fun1805z00_549 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_prgmchangez00); 
{ /* Llib/midi.scm 411 */
long BgL_arg1804z00_550;
BgL_arg1804z00_550 = 
(
(long)CINT(BgL_statusz00_477) & ((long)15)); 
PROCEDURE_ENTRY(BgL_fun1805z00_549)(BgL_fun1805z00_549, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BINT(BgL_arg1804z00_550), 
BINT(BgL_ppz00_544), BEOA); } } }  else 
{ /* Llib/midi.scm 406 */
if(
(
(
(long)CINT(BgL_statusz00_477) >> 
(int)(((long)4)))==((long)13)))
{ /* Llib/midi.scm 414 */
long BgL_ppz00_556;
{ /* Llib/midi.scm 414 */
obj_t BgL_arg1817z00_563;
{ /* Llib/midi.scm 414 */
obj_t BgL_fun1819z00_564;
BgL_fun1819z00_564 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 414 */
obj_t BgL_arg1818z00_565;
BgL_arg1818z00_565 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1817z00_563 = 
PROCEDURE_ENTRY(BgL_fun1819z00_564)(BgL_fun1819z00_564, BgL_arg1818z00_565, BEOA); } } 
BgL_ppz00_556 = 
(((long)127) & 
(long)CINT(BgL_arg1817z00_563)); } 
{ /* Llib/midi.scm 415 */
obj_t BgL_fun1812z00_557;
BgL_fun1812z00_557 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_cdelayz00); 
{ /* Llib/midi.scm 416 */
long BgL_arg1811z00_558;
{ /* Llib/midi.scm 416 */
BGL_LONGLONG_T BgL_arg1813z00_559;
BgL_arg1813z00_559 = 
(
bgl_current_microseconds()-BgL_t0z00_44); 
{ /* Llib/midi.scm 416 */
long BgL_res2632z00_2138;
BgL_res2632z00_2138 = 
LLONG_TO_LONG(BgL_arg1813z00_559); 
BgL_arg1811z00_558 = BgL_res2632z00_2138; } } 
PROCEDURE_ENTRY(BgL_fun1812z00_557)(BgL_fun1812z00_557, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
((obj_t)BgL_trackz00_38), 
BINT(BgL_ppqz00_42), 
BINT(BgL_dtz00_43), 
BINT(BgL_arg1811z00_558), BEOA); } } 
{ /* Llib/midi.scm 417 */
obj_t BgL_fun1816z00_561;
BgL_fun1816z00_561 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_afterzd2touchzd2); 
{ /* Llib/midi.scm 417 */
long BgL_arg1815z00_562;
BgL_arg1815z00_562 = 
(
(long)CINT(BgL_statusz00_477) & ((long)15)); 
PROCEDURE_ENTRY(BgL_fun1816z00_561)(BgL_fun1816z00_561, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BINT(BgL_arg1815z00_562), 
BINT(BgL_ppz00_556), BEOA); } } }  else 
{ /* Llib/midi.scm 412 */
if(
(
(
(long)CINT(BgL_statusz00_477) >> 
(int)(((long)4)))==((long)14)))
{ /* Llib/midi.scm 420 */
long BgL_ccz00_568;
{ /* Llib/midi.scm 420 */
obj_t BgL_arg1831z00_579;
{ /* Llib/midi.scm 420 */
obj_t BgL_fun1833z00_580;
BgL_fun1833z00_580 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 420 */
obj_t BgL_arg1832z00_581;
BgL_arg1832z00_581 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1831z00_579 = 
PROCEDURE_ENTRY(BgL_fun1833z00_580)(BgL_fun1833z00_580, BgL_arg1832z00_581, BEOA); } } 
BgL_ccz00_568 = 
(((long)127) & 
(long)CINT(BgL_arg1831z00_579)); } 
{ /* Llib/midi.scm 420 */
long BgL_vvz00_569;
{ /* Llib/midi.scm 421 */
obj_t BgL_arg1828z00_576;
{ /* Llib/midi.scm 421 */
obj_t BgL_fun1830z00_577;
BgL_fun1830z00_577 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 421 */
obj_t BgL_arg1829z00_578;
BgL_arg1829z00_578 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1828z00_576 = 
PROCEDURE_ENTRY(BgL_fun1830z00_577)(BgL_fun1830z00_577, BgL_arg1829z00_578, BEOA); } } 
BgL_vvz00_569 = 
(((long)127) & 
(long)CINT(BgL_arg1828z00_576)); } 
{ /* Llib/midi.scm 421 */

{ /* Llib/midi.scm 422 */
obj_t BgL_fun1823z00_570;
BgL_fun1823z00_570 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_cdelayz00); 
{ /* Llib/midi.scm 423 */
long BgL_arg1822z00_571;
{ /* Llib/midi.scm 423 */
BGL_LONGLONG_T BgL_arg1824z00_572;
BgL_arg1824z00_572 = 
(
bgl_current_microseconds()-BgL_t0z00_44); 
{ /* Llib/midi.scm 423 */
long BgL_res2640z00_2156;
BgL_res2640z00_2156 = 
LLONG_TO_LONG(BgL_arg1824z00_572); 
BgL_arg1822z00_571 = BgL_res2640z00_2156; } } 
PROCEDURE_ENTRY(BgL_fun1823z00_570)(BgL_fun1823z00_570, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
((obj_t)BgL_trackz00_38), 
BINT(BgL_ppqz00_42), 
BINT(BgL_dtz00_43), 
BINT(BgL_arg1822z00_571), BEOA); } } 
{ /* Llib/midi.scm 424 */
obj_t BgL_fun1827z00_574;
BgL_fun1827z00_574 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_pitchz00); 
{ /* Llib/midi.scm 424 */
long BgL_arg1826z00_575;
BgL_arg1826z00_575 = 
(
(long)CINT(BgL_statusz00_477) & ((long)15)); 
PROCEDURE_ENTRY(BgL_fun1827z00_574)(BgL_fun1827z00_574, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BINT(BgL_arg1826z00_575), 
BINT(BgL_ccz00_568), 
BINT(BgL_vvz00_569), BEOA); } } } } }  else 
{ /* Llib/midi.scm 418 */
if(
(
(long)CINT(BgL_statusz00_477)==((long)255)))
{ /* Llib/midi.scm 427 */
obj_t BgL_cz00_583;
{ /* Llib/midi.scm 427 */
obj_t BgL_fun1920z00_680;
BgL_fun1920z00_680 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 427 */
obj_t BgL_arg1919z00_681;
BgL_arg1919z00_681 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_cz00_583 = 
PROCEDURE_ENTRY(BgL_fun1920z00_680)(BgL_fun1920z00_680, BgL_arg1919z00_681, BEOA); } } 
{ /* Llib/midi.scm 427 */
obj_t BgL_lz00_584;
{ /* Llib/midi.scm 428 */
obj_t BgL_fun1918z00_678;
BgL_fun1918z00_678 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2vlqzd2); 
{ /* Llib/midi.scm 428 */
obj_t BgL_arg1917z00_679;
BgL_arg1917z00_679 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_lz00_584 = 
PROCEDURE_ENTRY(BgL_fun1918z00_678)(BgL_fun1918z00_678, BgL_arg1917z00_679, BEOA); } } 
{ /* Llib/midi.scm 428 */

{ 

if(
INTEGERP(BgL_cz00_583))
{ /* Llib/midi.scm 429 */
switch( 
(long)CINT(BgL_cz00_583)) { case ((long)0) : 

{ /* Llib/midi.scm 432 */
obj_t BgL_fun1837z00_588;
BgL_fun1837z00_588 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2seqnumzd2); 
{ /* Llib/midi.scm 432 */
int32_t BgL_arg1836z00_589;
BgL_arg1836z00_589 = 
BGl_readzd2int16zd2zz__multimediazd2midizd2(
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52)); 
PROCEDURE_ENTRY(BgL_fun1837z00_588)(BgL_fun1837z00_588, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BGL_INT32_TO_BINT32(BgL_arg1836z00_589), BEOA); } } break;case ((long)1) : 

{ /* Llib/midi.scm 435 */
obj_t BgL_fun1840z00_591;
BgL_fun1840z00_591 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2textzd2); 
{ /* Llib/midi.scm 435 */
obj_t BgL_arg1839z00_592;
{ /* Llib/midi.scm 435 */
obj_t BgL_fun1842z00_593;
BgL_fun1842z00_593 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 435 */
obj_t BgL_arg1841z00_594;
BgL_arg1841z00_594 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1839z00_592 = 
PROCEDURE_ENTRY(BgL_fun1842z00_593)(BgL_fun1842z00_593, BgL_lz00_584, BgL_arg1841z00_594, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1840z00_591)(BgL_fun1840z00_591, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1839z00_592, BEOA); } } break;case ((long)2) : 

{ /* Llib/midi.scm 438 */
obj_t BgL_fun1844z00_595;
BgL_fun1844z00_595 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2copyrightzd2); 
{ /* Llib/midi.scm 438 */
obj_t BgL_arg1843z00_596;
{ /* Llib/midi.scm 438 */
obj_t BgL_fun1846z00_597;
BgL_fun1846z00_597 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 438 */
obj_t BgL_arg1845z00_598;
BgL_arg1845z00_598 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1843z00_596 = 
PROCEDURE_ENTRY(BgL_fun1846z00_597)(BgL_fun1846z00_597, BgL_lz00_584, BgL_arg1845z00_598, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1844z00_595)(BgL_fun1844z00_595, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1843z00_596, BEOA); } } break;case ((long)3) : 

{ /* Llib/midi.scm 441 */
obj_t BgL_fun1848z00_599;
BgL_fun1848z00_599 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2trackzd2); 
{ /* Llib/midi.scm 441 */
obj_t BgL_arg1847z00_600;
{ /* Llib/midi.scm 441 */
obj_t BgL_fun1850z00_601;
BgL_fun1850z00_601 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 441 */
obj_t BgL_arg1849z00_602;
BgL_arg1849z00_602 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1847z00_600 = 
PROCEDURE_ENTRY(BgL_fun1850z00_601)(BgL_fun1850z00_601, BgL_lz00_584, BgL_arg1849z00_602, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1848z00_599)(BgL_fun1848z00_599, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1847z00_600, BEOA); } } break;case ((long)4) : 

{ /* Llib/midi.scm 444 */
obj_t BgL_fun1852z00_603;
BgL_fun1852z00_603 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2instrumentzd2); 
{ /* Llib/midi.scm 444 */
obj_t BgL_arg1851z00_604;
{ /* Llib/midi.scm 444 */
obj_t BgL_fun1854z00_605;
BgL_fun1854z00_605 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 444 */
obj_t BgL_arg1853z00_606;
BgL_arg1853z00_606 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1851z00_604 = 
PROCEDURE_ENTRY(BgL_fun1854z00_605)(BgL_fun1854z00_605, BgL_lz00_584, BgL_arg1853z00_606, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1852z00_603)(BgL_fun1852z00_603, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1851z00_604, BEOA); } } break;case ((long)5) : 

{ /* Llib/midi.scm 447 */
obj_t BgL_fun1856z00_607;
BgL_fun1856z00_607 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2lyriczd2); 
{ /* Llib/midi.scm 447 */
obj_t BgL_arg1855z00_608;
{ /* Llib/midi.scm 447 */
obj_t BgL_fun1858z00_609;
BgL_fun1858z00_609 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 447 */
obj_t BgL_arg1857z00_610;
BgL_arg1857z00_610 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1855z00_608 = 
PROCEDURE_ENTRY(BgL_fun1858z00_609)(BgL_fun1858z00_609, BgL_lz00_584, BgL_arg1857z00_610, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1856z00_607)(BgL_fun1856z00_607, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1855z00_608, BEOA); } } break;case ((long)6) : 

{ /* Llib/midi.scm 450 */
obj_t BgL_fun1860z00_611;
BgL_fun1860z00_611 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2markerzd2); 
{ /* Llib/midi.scm 450 */
obj_t BgL_arg1859z00_612;
{ /* Llib/midi.scm 450 */
obj_t BgL_fun1862z00_613;
BgL_fun1862z00_613 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 450 */
obj_t BgL_arg1861z00_614;
BgL_arg1861z00_614 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1859z00_612 = 
PROCEDURE_ENTRY(BgL_fun1862z00_613)(BgL_fun1862z00_613, BgL_lz00_584, BgL_arg1861z00_614, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1860z00_611)(BgL_fun1860z00_611, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1859z00_612, BEOA); } } break;case ((long)7) : 

{ /* Llib/midi.scm 453 */
obj_t BgL_fun1864z00_615;
BgL_fun1864z00_615 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2cuezd2); 
{ /* Llib/midi.scm 453 */
obj_t BgL_arg1863z00_616;
{ /* Llib/midi.scm 453 */
obj_t BgL_fun1866z00_617;
BgL_fun1866z00_617 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 453 */
obj_t BgL_arg1865z00_618;
BgL_arg1865z00_618 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1863z00_616 = 
PROCEDURE_ENTRY(BgL_fun1866z00_617)(BgL_fun1866z00_617, BgL_lz00_584, BgL_arg1865z00_618, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1864z00_615)(BgL_fun1864z00_615, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1863z00_616, BEOA); } } break;case ((long)8) : 

{ /* Llib/midi.scm 456 */
obj_t BgL_fun1868z00_619;
BgL_fun1868z00_619 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2prgmnamezd2); 
{ /* Llib/midi.scm 456 */
obj_t BgL_arg1867z00_620;
{ /* Llib/midi.scm 456 */
obj_t BgL_fun1870z00_621;
BgL_fun1870z00_621 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 456 */
obj_t BgL_arg1869z00_622;
BgL_arg1869z00_622 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1867z00_620 = 
PROCEDURE_ENTRY(BgL_fun1870z00_621)(BgL_fun1870z00_621, BgL_lz00_584, BgL_arg1869z00_622, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1868z00_619)(BgL_fun1868z00_619, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1867z00_620, BEOA); } } break;case ((long)9) : 

{ /* Llib/midi.scm 459 */
obj_t BgL_fun1872z00_623;
BgL_fun1872z00_623 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2devnamezd2); 
{ /* Llib/midi.scm 459 */
obj_t BgL_arg1871z00_624;
{ /* Llib/midi.scm 459 */
obj_t BgL_fun1874z00_625;
BgL_fun1874z00_625 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 459 */
obj_t BgL_arg1873z00_626;
BgL_arg1873z00_626 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1871z00_624 = 
PROCEDURE_ENTRY(BgL_fun1874z00_625)(BgL_fun1874z00_625, BgL_lz00_584, BgL_arg1873z00_626, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1872z00_623)(BgL_fun1872z00_623, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1871z00_624, BEOA); } } break;case ((long)32) : 

{ /* Llib/midi.scm 462 */
obj_t BgL_fun1876z00_627;
BgL_fun1876z00_627 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2channprefzd2); 
{ /* Llib/midi.scm 462 */
obj_t BgL_arg1875z00_628;
{ /* Llib/midi.scm 462 */
obj_t BgL_fun1878z00_629;
BgL_fun1878z00_629 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 462 */
obj_t BgL_arg1877z00_630;
BgL_arg1877z00_630 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1875z00_628 = 
PROCEDURE_ENTRY(BgL_fun1878z00_629)(BgL_fun1878z00_629, BgL_arg1877z00_630, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1876z00_627)(BgL_fun1876z00_627, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1875z00_628, BEOA); } } break;case ((long)33) : 

{ /* Llib/midi.scm 465 */
obj_t BgL_fun1880z00_631;
BgL_fun1880z00_631 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2channprefzd2); 
{ /* Llib/midi.scm 465 */
long BgL_arg1879z00_632;
BgL_arg1879z00_632 = 
BGl_readzd2intzd2zz__multimediazd2midizd2(
(long)CINT(BgL_lz00_584), 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52)); 
PROCEDURE_ENTRY(BgL_fun1880z00_631)(BgL_fun1880z00_631, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BINT(BgL_arg1879z00_632), BEOA); } } break;case ((long)47) : 

((((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52eotz52)=((bool_t)((bool_t)1)),BUNSPEC); 
{ /* Llib/midi.scm 469 */
obj_t BgL_fun1882z00_634;
BgL_fun1882z00_634 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2eotzd2); 
PROCEDURE_ENTRY(BgL_fun1882z00_634)(BgL_fun1882z00_634, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BUNSPEC, BEOA); } break;case ((long)81) : 

{ 
long BgL_auxz00_5729;
{ /* Llib/midi.scm 472 */
obj_t BgL_arg1883z00_635;
BgL_arg1883z00_635 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_auxz00_5729 = 
BGl_readzd2intzd2zz__multimediazd2midizd2(
(long)CINT(BgL_lz00_584), BgL_arg1883z00_635); } 
((((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_tempoz00)=((long)BgL_auxz00_5729),BUNSPEC); } 
{ /* Llib/midi.scm 473 */
obj_t BgL_fun1885z00_636;
BgL_fun1885z00_636 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2tempozd2); 
{ /* Llib/midi.scm 473 */
long BgL_arg1884z00_637;
BgL_arg1884z00_637 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_tempoz00); 
PROCEDURE_ENTRY(BgL_fun1885z00_636)(BgL_fun1885z00_636, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BINT(BgL_arg1884z00_637), BEOA); } } break;case ((long)84) : 

{ /* Llib/midi.scm 476 */
obj_t BgL_hrz00_638;
{ /* Llib/midi.scm 476 */
obj_t BgL_fun1896z00_652;
BgL_fun1896z00_652 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 476 */
obj_t BgL_arg1895z00_653;
BgL_arg1895z00_653 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_hrz00_638 = 
PROCEDURE_ENTRY(BgL_fun1896z00_652)(BgL_fun1896z00_652, BgL_arg1895z00_653, BEOA); } } 
{ /* Llib/midi.scm 476 */
obj_t BgL_mmz00_639;
{ /* Llib/midi.scm 477 */
obj_t BgL_fun1894z00_650;
BgL_fun1894z00_650 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 477 */
obj_t BgL_arg1893z00_651;
BgL_arg1893z00_651 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_mmz00_639 = 
PROCEDURE_ENTRY(BgL_fun1894z00_650)(BgL_fun1894z00_650, BgL_arg1893z00_651, BEOA); } } 
{ /* Llib/midi.scm 477 */
obj_t BgL_sez00_640;
{ /* Llib/midi.scm 478 */
obj_t BgL_fun1892z00_648;
BgL_fun1892z00_648 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 478 */
obj_t BgL_arg1891z00_649;
BgL_arg1891z00_649 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_sez00_640 = 
PROCEDURE_ENTRY(BgL_fun1892z00_648)(BgL_fun1892z00_648, BgL_arg1891z00_649, BEOA); } } 
{ /* Llib/midi.scm 478 */
obj_t BgL_frz00_641;
{ /* Llib/midi.scm 479 */
obj_t BgL_fun1890z00_646;
BgL_fun1890z00_646 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 479 */
obj_t BgL_arg1889z00_647;
BgL_arg1889z00_647 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_frz00_641 = 
PROCEDURE_ENTRY(BgL_fun1890z00_646)(BgL_fun1890z00_646, BgL_arg1889z00_647, BEOA); } } 
{ /* Llib/midi.scm 479 */
obj_t BgL_ffz00_642;
{ /* Llib/midi.scm 480 */
obj_t BgL_fun1888z00_644;
BgL_fun1888z00_644 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 480 */
obj_t BgL_arg1887z00_645;
BgL_arg1887z00_645 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_ffz00_642 = 
PROCEDURE_ENTRY(BgL_fun1888z00_644)(BgL_fun1888z00_644, BgL_arg1887z00_645, BEOA); } } 
{ /* Llib/midi.scm 480 */

{ /* Llib/midi.scm 481 */
obj_t BgL_fun1886z00_643;
BgL_fun1886z00_643 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2smtpezd2); 
PROCEDURE_ENTRY(BgL_fun1886z00_643)(BgL_fun1886z00_643, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_hrz00_638, BgL_mmz00_639, BgL_sez00_640, BgL_frz00_641, BgL_ffz00_642, BEOA); } } } } } } } break;case ((long)88) : 

{ /* Llib/midi.scm 484 */
obj_t BgL_nnz00_654;
{ /* Llib/midi.scm 484 */
obj_t BgL_fun1905z00_665;
BgL_fun1905z00_665 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 484 */
obj_t BgL_arg1904z00_666;
BgL_arg1904z00_666 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_nnz00_654 = 
PROCEDURE_ENTRY(BgL_fun1905z00_665)(BgL_fun1905z00_665, BgL_arg1904z00_666, BEOA); } } 
{ /* Llib/midi.scm 484 */
obj_t BgL_ddz00_655;
{ /* Llib/midi.scm 485 */
obj_t BgL_fun1903z00_663;
BgL_fun1903z00_663 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 485 */
obj_t BgL_arg1902z00_664;
BgL_arg1902z00_664 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_ddz00_655 = 
PROCEDURE_ENTRY(BgL_fun1903z00_663)(BgL_fun1903z00_663, BgL_arg1902z00_664, BEOA); } } 
{ /* Llib/midi.scm 485 */
obj_t BgL_ccz00_656;
{ /* Llib/midi.scm 486 */
obj_t BgL_fun1901z00_661;
BgL_fun1901z00_661 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 486 */
obj_t BgL_arg1900z00_662;
BgL_arg1900z00_662 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_ccz00_656 = 
PROCEDURE_ENTRY(BgL_fun1901z00_661)(BgL_fun1901z00_661, BgL_arg1900z00_662, BEOA); } } 
{ /* Llib/midi.scm 486 */
obj_t BgL_bbz00_657;
{ /* Llib/midi.scm 487 */
obj_t BgL_fun1899z00_659;
BgL_fun1899z00_659 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 487 */
obj_t BgL_arg1898z00_660;
BgL_arg1898z00_660 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_bbz00_657 = 
PROCEDURE_ENTRY(BgL_fun1899z00_659)(BgL_fun1899z00_659, BgL_arg1898z00_660, BEOA); } } 
{ /* Llib/midi.scm 487 */

{ /* Llib/midi.scm 488 */
obj_t BgL_fun1897z00_658;
BgL_fun1897z00_658 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2timesigzd2); 
PROCEDURE_ENTRY(BgL_fun1897z00_658)(BgL_fun1897z00_658, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_nnz00_654, BgL_ddz00_655, BgL_ccz00_656, BgL_bbz00_657, BEOA); } } } } } } break;case ((long)89) : 

{ /* Llib/midi.scm 491 */
obj_t BgL_fun1907z00_667;
BgL_fun1907z00_667 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2keysigzd2); 
{ /* Llib/midi.scm 491 */
long BgL_arg1906z00_668;
BgL_arg1906z00_668 = 
BGl_readzd2intzd2zz__multimediazd2midizd2(
(long)CINT(BgL_lz00_584), 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52)); 
PROCEDURE_ENTRY(BgL_fun1907z00_667)(BgL_fun1907z00_667, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BINT(BgL_arg1906z00_668), BEOA); } } break;case ((long)127) : 

{ /* Llib/midi.scm 494 */
obj_t BgL_fun1910z00_670;
BgL_fun1910z00_670 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2seqspeczd2); 
{ /* Llib/midi.scm 494 */
obj_t BgL_arg1909z00_671;
{ /* Llib/midi.scm 494 */
obj_t BgL_fun1912z00_672;
BgL_fun1912z00_672 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 494 */
obj_t BgL_arg1911z00_673;
BgL_arg1911z00_673 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1909z00_671 = 
PROCEDURE_ENTRY(BgL_fun1912z00_672)(BgL_fun1912z00_672, BgL_lz00_584, BgL_arg1911z00_673, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1910z00_670)(BgL_fun1910z00_670, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1909z00_671, BEOA); } } break;
default: 
BgL_case_else1162z00_585:
{ /* Llib/midi.scm 496 */
obj_t BgL_fun1914z00_674;
BgL_fun1914z00_674 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_errz00); 
{ /* Llib/midi.scm 497 */
obj_t BgL_arg1913z00_675;
{ /* Llib/midi.scm 497 */
obj_t BgL_list1915z00_676;
{ /* Llib/midi.scm 497 */
obj_t BgL_arg1916z00_677;
BgL_arg1916z00_677 = 
MAKE_YOUNG_PAIR(BgL_cz00_583, BNIL); 
BgL_list1915z00_676 = 
MAKE_YOUNG_PAIR(BgL_statusz00_477, BgL_arg1916z00_677); } 
BgL_arg1913z00_675 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string3048z00zz__multimediazd2midizd2, BgL_list1915z00_676); } 
PROCEDURE_ENTRY(BgL_fun1914z00_674)(BgL_fun1914z00_674, BGl_string3049z00zz__multimediazd2midizd2, BGl_string3050z00zz__multimediazd2midizd2, BgL_arg1913z00_675, BEOA); } } } }  else 
{ /* Llib/midi.scm 429 */
goto BgL_case_else1162z00_585;} } } } }  else 
{ /* Llib/midi.scm 498 */
bool_t BgL_test3627z00_5875;
if(
(
(long)CINT(BgL_statusz00_477)==((long)240)))
{ /* Llib/midi.scm 498 */
BgL_test3627z00_5875 = ((bool_t)1)
; }  else 
{ /* Llib/midi.scm 498 */
BgL_test3627z00_5875 = 
(
(long)CINT(BgL_statusz00_477)==((long)247))
; } 
if(BgL_test3627z00_5875)
{ /* Llib/midi.scm 500 */
obj_t BgL_strz00_684;
{ /* Llib/midi.scm 500 */
obj_t BgL_fun1930z00_690;
BgL_fun1930z00_690 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 500 */
obj_t BgL_arg1928z00_691;obj_t BgL_arg1929z00_692;
{ /* Llib/midi.scm 500 */
obj_t BgL_fun1932z00_693;
BgL_fun1932z00_693 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_475))->BgL_readzd2vlqzd2); 
{ /* Llib/midi.scm 500 */
obj_t BgL_arg1931z00_694;
BgL_arg1931z00_694 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1928z00_691 = 
PROCEDURE_ENTRY(BgL_fun1932z00_693)(BgL_fun1932z00_693, BgL_arg1931z00_694, BEOA); } } 
BgL_arg1929z00_692 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_strz00_684 = 
PROCEDURE_ENTRY(BgL_fun1930z00_690)(BgL_fun1930z00_690, BgL_arg1928z00_691, BgL_arg1929z00_692, BEOA); } } 
{ /* Llib/midi.scm 501 */
obj_t BgL_fun1924z00_685;
BgL_fun1924z00_685 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_cdelayz00); 
{ /* Llib/midi.scm 502 */
long BgL_arg1923z00_686;
{ /* Llib/midi.scm 502 */
BGL_LONGLONG_T BgL_arg1925z00_687;
BgL_arg1925z00_687 = 
(
bgl_current_microseconds()-BgL_t0z00_44); 
{ /* Llib/midi.scm 502 */
long BgL_res2647z00_2170;
BgL_res2647z00_2170 = 
LLONG_TO_LONG(BgL_arg1925z00_687); 
BgL_arg1923z00_686 = BgL_res2647z00_2170; } } 
PROCEDURE_ENTRY(BgL_fun1924z00_685)(BgL_fun1924z00_685, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
((obj_t)BgL_trackz00_38), 
BINT(BgL_dtz00_43), 
BINT(BgL_ppqz00_42), 
BINT(BgL_arg1923z00_686), BEOA); } } 
{ /* Llib/midi.scm 503 */
obj_t BgL_fun1927z00_689;
BgL_fun1927z00_689 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_sysexz00); 
PROCEDURE_ENTRY(BgL_fun1927z00_689)(BgL_fun1927z00_689, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_strz00_684, BEOA); } }  else 
{ /* Llib/midi.scm 505 */
obj_t BgL_fun1933z00_695;
BgL_fun1933z00_695 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_errz00); 
PROCEDURE_ENTRY(BgL_fun1933z00_695)(BgL_fun1933z00_695, BGl_string3049z00zz__multimediazd2midizd2, BGl_string3051z00zz__multimediazd2midizd2, BgL_statusz00_477, BEOA); } } } } } } } } } } 
{ /* Llib/midi.scm 507 */
obj_t BgL_fun1951z00_715;
BgL_fun1951z00_715 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msinkz00_40))->BgL_flushz00); 
{ /* Llib/midi.scm 507 */
obj_t BgL_arg1950z00_716;
BgL_arg1950z00_716 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msinkz00_40))->BgL_streamz00); 
return 
PROCEDURE_ENTRY(BgL_fun1951z00_715)(BgL_fun1951z00_715, BgL_arg1950z00_716, BEOA);} } } } 

}



/* midi-read-mthd */
obj_t BGl_midizd2readzd2mthdz00zz__multimediazd2midizd2(obj_t BgL_ipz00_45)
{
{ /* Llib/midi.scm 512 */
{ /* Llib/midi.scm 513 */
obj_t BgL_tyz00_717;
BgL_tyz00_717 = 
BGl_readzd2charszd2zz__r4_input_6_10_2z00(
BINT(((long)4)), BgL_ipz00_45); 
if(
bigloo_strcmp(
((obj_t)BgL_tyz00_717), BGl_string3052z00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 516 */
int32_t BgL_sza7za7_719;
BgL_sza7za7_719 = 
BGl_readzd2int32zd2zz__multimediazd2midizd2(BgL_ipz00_45); 
{ /* Llib/midi.scm 516 */
long BgL_fmtz00_720;
{ /* Llib/midi.scm 517 */
int32_t BgL_arg1968z00_765;
BgL_arg1968z00_765 = 
BGl_readzd2int16zd2zz__multimediazd2midizd2(BgL_ipz00_45); 
{ /* Llib/midi.scm 517 */
long BgL_res2650z00_2178;
{ /* Llib/midi.scm 517 */
long BgL_arg1382z00_2175;
BgL_arg1382z00_2175 = 
(long)(BgL_arg1968z00_765); 
{ /* Llib/midi.scm 517 */
long BgL_res2649z00_2177;
BgL_res2649z00_2177 = 
(long)(BgL_arg1382z00_2175); 
BgL_res2650z00_2178 = BgL_res2649z00_2177; } } 
BgL_fmtz00_720 = BgL_res2650z00_2178; } } 
{ /* Llib/midi.scm 517 */
long BgL_tckz00_721;
{ /* Llib/midi.scm 518 */
int32_t BgL_arg1967z00_764;
BgL_arg1967z00_764 = 
BGl_readzd2int16zd2zz__multimediazd2midizd2(BgL_ipz00_45); 
{ /* Llib/midi.scm 518 */
long BgL_res2652z00_2183;
{ /* Llib/midi.scm 518 */
long BgL_arg1382z00_2180;
BgL_arg1382z00_2180 = 
(long)(BgL_arg1967z00_764); 
{ /* Llib/midi.scm 518 */
long BgL_res2651z00_2182;
BgL_res2651z00_2182 = 
(long)(BgL_arg1382z00_2180); 
BgL_res2652z00_2183 = BgL_res2651z00_2182; } } 
BgL_tckz00_721 = BgL_res2652z00_2183; } } 
{ /* Llib/midi.scm 518 */
long BgL_divz00_722;
{ /* Llib/midi.scm 519 */
int32_t BgL_arg1966z00_763;
BgL_arg1966z00_763 = 
BGl_readzd2int16zd2zz__multimediazd2midizd2(BgL_ipz00_45); 
{ /* Llib/midi.scm 519 */
long BgL_res2654z00_2188;
{ /* Llib/midi.scm 519 */
long BgL_arg1382z00_2185;
BgL_arg1382z00_2185 = 
(long)(BgL_arg1966z00_763); 
{ /* Llib/midi.scm 519 */
long BgL_res2653z00_2187;
BgL_res2653z00_2187 = 
(long)(BgL_arg1382z00_2185); 
BgL_res2654z00_2188 = BgL_res2653z00_2187; } } 
BgL_divz00_722 = BgL_res2654z00_2188; } } 
{ /* Llib/midi.scm 519 */

if(
(
(BgL_divz00_722 >> 
(int)(((long)15)))==((long)0)))
{ /* Llib/midi.scm 521 */
long BgL_val4_1199z00_729;
BgL_val4_1199z00_729 = 
(BgL_divz00_722 & ((long)32767)); 
{ /* Llib/midi.scm 521 */
int BgL_res2658z00_2195;
{ /* Llib/midi.scm 521 */
int BgL_tmpz00_5959;
BgL_tmpz00_5959 = 
(int)(((long)5)); 
BgL_res2658z00_2195 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_5959); } BgL_res2658z00_2195; } 
{ /* Llib/midi.scm 521 */
obj_t BgL_auxz00_5964;int BgL_tmpz00_5962;
BgL_auxz00_5964 = 
BINT(BgL_fmtz00_720); 
BgL_tmpz00_5962 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_5962, BgL_auxz00_5964); } 
{ /* Llib/midi.scm 521 */
obj_t BgL_auxz00_5969;int BgL_tmpz00_5967;
BgL_auxz00_5969 = 
BINT(BgL_tckz00_721); 
BgL_tmpz00_5967 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_5967, BgL_auxz00_5969); } 
{ /* Llib/midi.scm 521 */
obj_t BgL_auxz00_5974;int BgL_tmpz00_5972;
BgL_auxz00_5974 = 
BINT(((long)500000)); 
BgL_tmpz00_5972 = 
(int)(((long)3)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_5972, BgL_auxz00_5974); } 
{ /* Llib/midi.scm 521 */
obj_t BgL_auxz00_5979;int BgL_tmpz00_5977;
BgL_auxz00_5979 = 
BINT(BgL_val4_1199z00_729); 
BgL_tmpz00_5977 = 
(int)(((long)4)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_5977, BgL_auxz00_5979); } 
return 
BGL_INT32_TO_BINT32(BgL_sza7za7_719);}  else 
{ 

{ /* Llib/midi.scm 522 */
long BgL_aux1166z00_731;
BgL_aux1166z00_731 = 
(((long)128)-
(
(BgL_divz00_722 >> 
(int)(((long)8))) & ((long)127))); 
switch( BgL_aux1166z00_731) { case ((long)24) : 

{ /* Llib/midi.scm 524 */
long BgL_val4_1204z00_737;
BgL_val4_1204z00_737 = 
(((long)12)*
(BgL_divz00_722 & ((long)255))); 
{ /* Llib/midi.scm 524 */
int BgL_res2667z00_2212;
{ /* Llib/midi.scm 524 */
int BgL_tmpz00_5989;
BgL_tmpz00_5989 = 
(int)(((long)5)); 
BgL_res2667z00_2212 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_5989); } BgL_res2667z00_2212; } 
{ /* Llib/midi.scm 524 */
obj_t BgL_auxz00_5994;int BgL_tmpz00_5992;
BgL_auxz00_5994 = 
BINT(BgL_fmtz00_720); 
BgL_tmpz00_5992 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_5992, BgL_auxz00_5994); } 
{ /* Llib/midi.scm 524 */
obj_t BgL_auxz00_5999;int BgL_tmpz00_5997;
BgL_auxz00_5999 = 
BINT(BgL_tckz00_721); 
BgL_tmpz00_5997 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_5997, BgL_auxz00_5999); } 
{ /* Llib/midi.scm 524 */
obj_t BgL_auxz00_6004;int BgL_tmpz00_6002;
BgL_auxz00_6004 = 
BINT(((long)500000)); 
BgL_tmpz00_6002 = 
(int)(((long)3)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6002, BgL_auxz00_6004); } 
{ /* Llib/midi.scm 524 */
obj_t BgL_auxz00_6009;int BgL_tmpz00_6007;
BgL_auxz00_6009 = 
BINT(BgL_val4_1204z00_737); 
BgL_tmpz00_6007 = 
(int)(((long)4)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6007, BgL_auxz00_6009); } 
return 
BGL_INT32_TO_BINT32(BgL_sza7za7_719);} break;case ((long)25) : 

{ /* Llib/midi.scm 526 */
long BgL_val4_1209z00_743;
BgL_val4_1209z00_743 = 
(((long)10)*
(BgL_divz00_722 & ((long)255))); 
{ /* Llib/midi.scm 526 */
int BgL_res2670z00_2217;
{ /* Llib/midi.scm 526 */
int BgL_tmpz00_6015;
BgL_tmpz00_6015 = 
(int)(((long)5)); 
BgL_res2670z00_2217 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_6015); } BgL_res2670z00_2217; } 
{ /* Llib/midi.scm 526 */
obj_t BgL_auxz00_6020;int BgL_tmpz00_6018;
BgL_auxz00_6020 = 
BINT(BgL_fmtz00_720); 
BgL_tmpz00_6018 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6018, BgL_auxz00_6020); } 
{ /* Llib/midi.scm 526 */
obj_t BgL_auxz00_6025;int BgL_tmpz00_6023;
BgL_auxz00_6025 = 
BINT(BgL_tckz00_721); 
BgL_tmpz00_6023 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6023, BgL_auxz00_6025); } 
{ /* Llib/midi.scm 526 */
obj_t BgL_auxz00_6030;int BgL_tmpz00_6028;
BgL_auxz00_6030 = 
BINT(((long)400000)); 
BgL_tmpz00_6028 = 
(int)(((long)3)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6028, BgL_auxz00_6030); } 
{ /* Llib/midi.scm 526 */
obj_t BgL_auxz00_6035;int BgL_tmpz00_6033;
BgL_auxz00_6035 = 
BINT(BgL_val4_1209z00_743); 
BgL_tmpz00_6033 = 
(int)(((long)4)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6033, BgL_auxz00_6035); } 
return 
BGL_INT32_TO_BINT32(BgL_sza7za7_719);} break;case ((long)29) : 

{ /* Llib/midi.scm 528 */
long BgL_val4_1214z00_749;
BgL_val4_1214z00_749 = 
(((long)2997)*
(BgL_divz00_722 & ((long)255))); 
{ /* Llib/midi.scm 528 */
int BgL_res2673z00_2222;
{ /* Llib/midi.scm 528 */
int BgL_tmpz00_6041;
BgL_tmpz00_6041 = 
(int)(((long)5)); 
BgL_res2673z00_2222 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_6041); } BgL_res2673z00_2222; } 
{ /* Llib/midi.scm 528 */
obj_t BgL_auxz00_6046;int BgL_tmpz00_6044;
BgL_auxz00_6046 = 
BINT(BgL_fmtz00_720); 
BgL_tmpz00_6044 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6044, BgL_auxz00_6046); } 
{ /* Llib/midi.scm 528 */
obj_t BgL_auxz00_6051;int BgL_tmpz00_6049;
BgL_auxz00_6051 = 
BINT(BgL_tckz00_721); 
BgL_tmpz00_6049 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6049, BgL_auxz00_6051); } 
{ /* Llib/midi.scm 528 */
obj_t BgL_auxz00_6056;int BgL_tmpz00_6054;
BgL_auxz00_6056 = 
BINT(((long)100000000)); 
BgL_tmpz00_6054 = 
(int)(((long)3)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6054, BgL_auxz00_6056); } 
{ /* Llib/midi.scm 528 */
obj_t BgL_auxz00_6061;int BgL_tmpz00_6059;
BgL_auxz00_6061 = 
BINT(BgL_val4_1214z00_749); 
BgL_tmpz00_6059 = 
(int)(((long)4)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6059, BgL_auxz00_6061); } 
return 
BGL_INT32_TO_BINT32(BgL_sza7za7_719);} break;case ((long)30) : 

{ /* Llib/midi.scm 530 */
long BgL_val4_1219z00_755;
BgL_val4_1219z00_755 = 
(((long)15)*
(BgL_divz00_722 & ((long)255))); 
{ /* Llib/midi.scm 530 */
int BgL_res2676z00_2227;
{ /* Llib/midi.scm 530 */
int BgL_tmpz00_6067;
BgL_tmpz00_6067 = 
(int)(((long)5)); 
BgL_res2676z00_2227 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_6067); } BgL_res2676z00_2227; } 
{ /* Llib/midi.scm 530 */
obj_t BgL_auxz00_6072;int BgL_tmpz00_6070;
BgL_auxz00_6072 = 
BINT(BgL_fmtz00_720); 
BgL_tmpz00_6070 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6070, BgL_auxz00_6072); } 
{ /* Llib/midi.scm 530 */
obj_t BgL_auxz00_6077;int BgL_tmpz00_6075;
BgL_auxz00_6077 = 
BINT(BgL_tckz00_721); 
BgL_tmpz00_6075 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6075, BgL_auxz00_6077); } 
{ /* Llib/midi.scm 530 */
obj_t BgL_auxz00_6082;int BgL_tmpz00_6080;
BgL_auxz00_6082 = 
BINT(((long)500000)); 
BgL_tmpz00_6080 = 
(int)(((long)3)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6080, BgL_auxz00_6082); } 
{ /* Llib/midi.scm 530 */
obj_t BgL_auxz00_6087;int BgL_tmpz00_6085;
BgL_auxz00_6087 = 
BINT(BgL_val4_1219z00_755); 
BgL_tmpz00_6085 = 
(int)(((long)4)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6085, BgL_auxz00_6087); } 
return 
BGL_INT32_TO_BINT32(BgL_sza7za7_719);} break;
default: 
{ /* Llib/midi.scm 534 */
long BgL_arg1962z00_759;
BgL_arg1962z00_759 = 
(((long)128)-
(
(BgL_divz00_722 >> 
(int)(((long)8))) & ((long)127))); 
return 
BGl_errorz00zz__errorz00(BGl_string3053z00zz__multimediazd2midizd2, BGl_string3054z00zz__multimediazd2midizd2, 
BINT(BgL_arg1962z00_759));} } } } } } } } }  else 
{ /* Llib/midi.scm 514 */
return 
BGl_errorz00zz__errorz00(BGl_string3053z00zz__multimediazd2midizd2, BGl_string3055z00zz__multimediazd2midizd2, BgL_tyz00_717);} } } 

}



/* midi-read-mtrk */
obj_t BGl_midizd2readzd2mtrkz00zz__multimediazd2midizd2(obj_t BgL_ipz00_46)
{
{ /* Llib/midi.scm 539 */
{ /* Llib/midi.scm 540 */
obj_t BgL_tyz00_766;
BgL_tyz00_766 = 
BGl_readzd2charszd2zz__r4_input_6_10_2z00(
BINT(((long)4)), BgL_ipz00_46); 
if(
bigloo_strcmp(
((obj_t)BgL_tyz00_766), BGl_string3056z00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 543 */
int32_t BgL_tmpz00_6104;
BgL_tmpz00_6104 = 
BGl_readzd2int32zd2zz__multimediazd2midizd2(BgL_ipz00_46); 
return 
BGL_INT32_TO_BINT32(BgL_tmpz00_6104);}  else 
{ /* Llib/midi.scm 541 */
return 
BGl_errorz00zz__errorz00(BGl_string3057z00zz__multimediazd2midizd2, BGl_string3055z00zz__multimediazd2midizd2, BgL_tyz00_766);} } } 

}



/* read-int16 */
int32_t BGl_readzd2int16zd2zz__multimediazd2midizd2(obj_t BgL_ipz00_49)
{
{ /* Llib/midi.scm 560 */
{ /* Llib/midi.scm 561 */
obj_t BgL_b1z00_769;
BgL_b1z00_769 = 
BGl_readzd2charzd2zz__r4_input_6_10_2z00(BgL_ipz00_49); 
{ /* Llib/midi.scm 561 */
obj_t BgL_b0z00_770;
BgL_b0z00_770 = 
BGl_readzd2charzd2zz__r4_input_6_10_2z00(BgL_ipz00_49); 
{ /* Llib/midi.scm 562 */

{ /* Llib/midi.scm 563 */
int32_t BgL_arg1971z00_771;int32_t BgL_arg1972z00_772;
{ /* Llib/midi.scm 563 */
int32_t BgL_arg1973z00_773;
{ /* Llib/midi.scm 555 */
long BgL_arg1970z00_2238;
BgL_arg1970z00_2238 = 
(
CCHAR(BgL_b1z00_769)); 
{ /* Llib/midi.scm 555 */
int32_t BgL_res2682z00_2242;
BgL_res2682z00_2242 = 
(int32_t)(BgL_arg1970z00_2238); 
BgL_arg1973z00_773 = BgL_res2682z00_2242; } } 
BgL_arg1971z00_771 = 
(BgL_arg1973z00_773 << 
(int)(((long)8))); } 
{ /* Llib/midi.scm 555 */
long BgL_arg1970z00_2245;
BgL_arg1970z00_2245 = 
(
CCHAR(BgL_b0z00_770)); 
{ /* Llib/midi.scm 555 */
int32_t BgL_res2685z00_2249;
BgL_res2685z00_2249 = 
(int32_t)(BgL_arg1970z00_2245); 
BgL_arg1972z00_772 = BgL_res2685z00_2249; } } 
return 
(BgL_arg1971z00_771+BgL_arg1972z00_772);} } } } } 

}



/* &read-int16 */
obj_t BGl_z62readzd2int16zb0zz__multimediazd2midizd2(obj_t BgL_envz00_3086, obj_t BgL_ipz00_3087)
{
{ /* Llib/midi.scm 560 */
{ /* Llib/midi.scm 561 */
int32_t BgL_tmpz00_6119;
BgL_tmpz00_6119 = 
BGl_readzd2int16zd2zz__multimediazd2midizd2(BgL_ipz00_3087); 
return 
BGL_INT32_TO_BINT32(BgL_tmpz00_6119);} } 

}



/* read-int32 */
int32_t BGl_readzd2int32zd2zz__multimediazd2midizd2(obj_t BgL_ipz00_50)
{
{ /* Llib/midi.scm 569 */
{ /* Llib/midi.scm 570 */
obj_t BgL_b3z00_774;
BgL_b3z00_774 = 
BGl_readzd2charzd2zz__r4_input_6_10_2z00(BgL_ipz00_50); 
{ /* Llib/midi.scm 570 */
obj_t BgL_b2z00_775;
BgL_b2z00_775 = 
BGl_readzd2charzd2zz__r4_input_6_10_2z00(BgL_ipz00_50); 
{ /* Llib/midi.scm 571 */
obj_t BgL_b1z00_776;
BgL_b1z00_776 = 
BGl_readzd2charzd2zz__r4_input_6_10_2z00(BgL_ipz00_50); 
{ /* Llib/midi.scm 572 */
obj_t BgL_b0z00_777;
BgL_b0z00_777 = 
BGl_readzd2charzd2zz__r4_input_6_10_2z00(BgL_ipz00_50); 
{ /* Llib/midi.scm 573 */

{ /* Llib/midi.scm 574 */
int32_t BgL_arg1974z00_778;int32_t BgL_arg1975z00_779;
{ /* Llib/midi.scm 574 */
int32_t BgL_arg1976z00_780;
{ /* Llib/midi.scm 555 */
long BgL_arg1970z00_2253;
BgL_arg1970z00_2253 = 
(
CCHAR(BgL_b3z00_774)); 
{ /* Llib/midi.scm 555 */
int32_t BgL_res2688z00_2257;
BgL_res2688z00_2257 = 
(int32_t)(BgL_arg1970z00_2253); 
BgL_arg1976z00_780 = BgL_res2688z00_2257; } } 
BgL_arg1974z00_778 = 
(BgL_arg1976z00_780 << 
(int)(((long)24))); } 
{ /* Llib/midi.scm 575 */
int32_t BgL_arg1977z00_781;int32_t BgL_arg1978z00_782;
{ /* Llib/midi.scm 575 */
int32_t BgL_arg1979z00_783;
{ /* Llib/midi.scm 555 */
long BgL_arg1970z00_2260;
BgL_arg1970z00_2260 = 
(
CCHAR(BgL_b2z00_775)); 
{ /* Llib/midi.scm 555 */
int32_t BgL_res2691z00_2264;
BgL_res2691z00_2264 = 
(int32_t)(BgL_arg1970z00_2260); 
BgL_arg1979z00_783 = BgL_res2691z00_2264; } } 
BgL_arg1977z00_781 = 
(BgL_arg1979z00_783 << 
(int)(((long)16))); } 
{ /* Llib/midi.scm 576 */
int32_t BgL_arg1980z00_784;int32_t BgL_arg1981z00_785;
{ /* Llib/midi.scm 576 */
int32_t BgL_arg1982z00_786;
{ /* Llib/midi.scm 555 */
long BgL_arg1970z00_2267;
BgL_arg1970z00_2267 = 
(
CCHAR(BgL_b1z00_776)); 
{ /* Llib/midi.scm 555 */
int32_t BgL_res2694z00_2271;
BgL_res2694z00_2271 = 
(int32_t)(BgL_arg1970z00_2267); 
BgL_arg1982z00_786 = BgL_res2694z00_2271; } } 
BgL_arg1980z00_784 = 
(BgL_arg1982z00_786 << 
(int)(((long)8))); } 
{ /* Llib/midi.scm 555 */
long BgL_arg1970z00_2274;
BgL_arg1970z00_2274 = 
(
CCHAR(BgL_b0z00_777)); 
{ /* Llib/midi.scm 555 */
int32_t BgL_res2697z00_2278;
BgL_res2697z00_2278 = 
(int32_t)(BgL_arg1970z00_2274); 
BgL_arg1981z00_785 = BgL_res2697z00_2278; } } 
BgL_arg1978z00_782 = 
(BgL_arg1980z00_784+BgL_arg1981z00_785); } 
BgL_arg1975z00_779 = 
(BgL_arg1977z00_781+BgL_arg1978z00_782); } 
return 
(BgL_arg1974z00_778+BgL_arg1975z00_779);} } } } } } } 

}



/* &read-int32 */
obj_t BGl_z62readzd2int32zb0zz__multimediazd2midizd2(obj_t BgL_envz00_3088, obj_t BgL_ipz00_3089)
{
{ /* Llib/midi.scm 569 */
{ /* Llib/midi.scm 570 */
int32_t BgL_tmpz00_6147;
BgL_tmpz00_6147 = 
BGl_readzd2int32zd2zz__multimediazd2midizd2(BgL_ipz00_3089); 
return 
BGL_INT32_TO_BINT32(BgL_tmpz00_6147);} } 

}



/* read-int */
long BGl_readzd2intzd2zz__multimediazd2midizd2(long BgL_lenz00_51, obj_t BgL_ipz00_52)
{
{ /* Llib/midi.scm 582 */
{ /* Llib/midi.scm 583 */
long BgL_g1167z00_787;
{ /* Llib/midi.scm 583 */
obj_t BgL_arg1990z00_799;
BgL_arg1990z00_799 = 
BGl_readzd2charzd2zz__r4_input_6_10_2z00(BgL_ipz00_52); 
BgL_g1167z00_787 = 
(
CCHAR(BgL_arg1990z00_799)); } 
{ 
long BgL_valz00_789;long BgL_lenz00_790;
BgL_valz00_789 = BgL_g1167z00_787; 
BgL_lenz00_790 = BgL_lenz00_51; 
BgL_zc3z04anonymousza31983ze3z87_791:
if(
(BgL_lenz00_790==((long)1)))
{ /* Llib/midi.scm 585 */
return BgL_valz00_789;}  else 
{ /* Llib/midi.scm 587 */
long BgL_arg1985z00_793;long BgL_arg1986z00_794;
{ /* Llib/midi.scm 587 */
long BgL_arg1987z00_795;long BgL_arg1988z00_796;
BgL_arg1987z00_795 = 
(BgL_valz00_789 << 
(int)(((long)8))); 
{ /* Llib/midi.scm 587 */
obj_t BgL_arg1989z00_797;
BgL_arg1989z00_797 = 
BGl_readzd2charzd2zz__r4_input_6_10_2z00(BgL_ipz00_52); 
BgL_arg1988z00_796 = 
(
CCHAR(BgL_arg1989z00_797)); } 
BgL_arg1985z00_793 = 
(BgL_arg1987z00_795+BgL_arg1988z00_796); } 
BgL_arg1986z00_794 = 
(BgL_lenz00_790-((long)1)); 
{ 
long BgL_lenz00_6163;long BgL_valz00_6162;
BgL_valz00_6162 = BgL_arg1985z00_793; 
BgL_lenz00_6163 = BgL_arg1986z00_794; 
BgL_lenz00_790 = BgL_lenz00_6163; 
BgL_valz00_789 = BgL_valz00_6162; 
goto BgL_zc3z04anonymousza31983ze3z87_791;} } } } } 

}



/* &read-int */
obj_t BGl_z62readzd2intzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3090, obj_t BgL_lenz00_3091, obj_t BgL_ipz00_3092)
{
{ /* Llib/midi.scm 582 */
{ /* Llib/midi.scm 583 */
long BgL_tmpz00_6164;
{ /* Llib/midi.scm 583 */
obj_t BgL_auxz00_6174;long BgL_auxz00_6165;
if(
INPUT_PORTP(BgL_ipz00_3092))
{ /* Llib/midi.scm 583 */
BgL_auxz00_6174 = BgL_ipz00_3092
; }  else 
{ 
obj_t BgL_auxz00_6177;
BgL_auxz00_6177 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)24391)), BGl_string3058z00zz__multimediazd2midizd2, BGl_string3038z00zz__multimediazd2midizd2, BgL_ipz00_3092); 
FAILURE(BgL_auxz00_6177,BFALSE,BFALSE);} 
{ /* Llib/midi.scm 583 */
obj_t BgL_tmpz00_6166;
if(
INTEGERP(BgL_lenz00_3091))
{ /* Llib/midi.scm 583 */
BgL_tmpz00_6166 = BgL_lenz00_3091
; }  else 
{ 
obj_t BgL_auxz00_6169;
BgL_auxz00_6169 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)24391)), BGl_string3058z00zz__multimediazd2midizd2, BGl_string3039z00zz__multimediazd2midizd2, BgL_lenz00_3091); 
FAILURE(BgL_auxz00_6169,BFALSE,BFALSE);} 
BgL_auxz00_6165 = 
(long)CINT(BgL_tmpz00_6166); } 
BgL_tmpz00_6164 = 
BGl_readzd2intzd2zz__multimediazd2midizd2(BgL_auxz00_6165, BgL_auxz00_6174); } 
return 
BINT(BgL_tmpz00_6164);} } 

}



/* &read-vlq */
obj_t BGl_z62readzd2vlqzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3093, obj_t BgL_ipz00_3094)
{
{ /* Llib/midi.scm 593 */
{ /* Llib/midi.scm 595 */
long BgL_tmpz00_6183;
{ 
long BgL_accz00_4112;
BgL_accz00_4112 = ((long)0); 
BgL_loopz00_4111:
{ /* Llib/midi.scm 595 */
long BgL_cz00_4113;
{ /* Llib/midi.scm 595 */
obj_t BgL_arg1996z00_4114;
BgL_arg1996z00_4114 = 
BGl_readzd2charzd2zz__r4_input_6_10_2z00(BgL_ipz00_3094); 
BgL_cz00_4113 = 
(
CCHAR(BgL_arg1996z00_4114)); } 
if(
(BgL_cz00_4113<=((long)127)))
{ /* Llib/midi.scm 596 */
BgL_tmpz00_6183 = 
(BgL_cz00_4113+BgL_accz00_4112)
; }  else 
{ 
long BgL_accz00_6190;
BgL_accz00_6190 = 
(
(BgL_accz00_4112+
(BgL_cz00_4113 & ((long)127))) << 
(int)(((long)7))); 
BgL_accz00_4112 = BgL_accz00_6190; 
goto BgL_loopz00_4111;} } } 
return 
BINT(BgL_tmpz00_6183);} } 

}



/* string-stream-peek-byte */
long BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(obj_t BgL_ipz00_54)
{
{ /* Llib/midi.scm 603 */
return 
(
STRING_REF(
STRUCT_REF(BgL_ipz00_54, 
(int)(((long)0))), 
(long)CINT(
STRUCT_REF(BgL_ipz00_54, 
(int)(((long)1))))));} 

}



/* &string-stream-peek-byte */
obj_t BGl_z62stringzd2streamzd2peekzd2bytezb0zz__multimediazd2midizd2(obj_t BgL_envz00_3098, obj_t BgL_ipz00_3099)
{
{ /* Llib/midi.scm 603 */
{ /* Llib/midi.scm 605 */
long BgL_tmpz00_6203;
{ /* Llib/midi.scm 605 */
obj_t BgL_auxz00_6204;
if(
STRUCTP(BgL_ipz00_3099))
{ /* Llib/midi.scm 605 */
BgL_auxz00_6204 = BgL_ipz00_3099
; }  else 
{ 
obj_t BgL_auxz00_6207;
BgL_auxz00_6207 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)25285)), BGl_string3059z00zz__multimediazd2midizd2, BGl_string3060z00zz__multimediazd2midizd2, BgL_ipz00_3099); 
FAILURE(BgL_auxz00_6207,BFALSE,BFALSE);} 
BgL_tmpz00_6203 = 
BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(BgL_auxz00_6204); } 
return 
BINT(BgL_tmpz00_6203);} } 

}



/* &string-stream-read-byte */
obj_t BGl_z62stringzd2streamzd2readzd2bytezb0zz__multimediazd2midizd2(obj_t BgL_envz00_3100, obj_t BgL_ipz00_3101)
{
{ /* Llib/midi.scm 610 */
{ /* Llib/midi.scm 611 */
long BgL_tmpz00_6213;
{ /* Llib/midi.scm 611 */
obj_t BgL_ipz00_4115;
if(
STRUCTP(BgL_ipz00_3101))
{ /* Llib/midi.scm 611 */
BgL_ipz00_4115 = BgL_ipz00_3101; }  else 
{ 
obj_t BgL_auxz00_6216;
BgL_auxz00_6216 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)25610)), BGl_string3061z00zz__multimediazd2midizd2, BGl_string3060z00zz__multimediazd2midizd2, BgL_ipz00_3101); 
FAILURE(BgL_auxz00_6216,BFALSE,BFALSE);} 
{ /* Llib/midi.scm 611 */
long BgL_bz00_4116;
BgL_bz00_4116 = 
(
STRING_REF(
STRUCT_REF(BgL_ipz00_4115, 
(int)(((long)0))), 
(long)CINT(
STRUCT_REF(BgL_ipz00_4115, 
(int)(((long)1)))))); 
{ /* Llib/midi.scm 612 */
long BgL_arg2000z00_4117;
BgL_arg2000z00_4117 = 
(
(long)CINT(
STRUCT_REF(BgL_ipz00_4115, 
(int)(((long)1))))+((long)1)); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6233;int BgL_tmpz00_6231;
BgL_auxz00_6233 = 
BINT(BgL_arg2000z00_4117); 
BgL_tmpz00_6231 = 
(int)(((long)1)); 
STRUCT_SET(BgL_ipz00_4115, BgL_tmpz00_6231, BgL_auxz00_6233); } } 
BgL_tmpz00_6213 = BgL_bz00_4116; } } 
return 
BINT(BgL_tmpz00_6213);} } 

}



/* &string-stream-read-int16 */
obj_t BGl_z62stringzd2streamzd2readzd2int16zb0zz__multimediazd2midizd2(obj_t BgL_envz00_3102, obj_t BgL_ipz00_3103)
{
{ /* Llib/midi.scm 618 */
{ /* Llib/midi.scm 619 */
int32_t BgL_tmpz00_6237;
{ /* Llib/midi.scm 619 */
obj_t BgL_ipz00_4118;
if(
STRUCTP(BgL_ipz00_3103))
{ /* Llib/midi.scm 619 */
BgL_ipz00_4118 = BgL_ipz00_3103; }  else 
{ 
obj_t BgL_auxz00_6240;
BgL_auxz00_6240 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)26001)), BGl_string3062z00zz__multimediazd2midizd2, BGl_string3060z00zz__multimediazd2midizd2, BgL_ipz00_3103); 
FAILURE(BgL_auxz00_6240,BFALSE,BFALSE);} 
{ /* Llib/midi.scm 619 */
long BgL_b1z00_4119;
{ /* Llib/midi.scm 611 */
long BgL_bz00_4120;
BgL_bz00_4120 = 
BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(BgL_ipz00_4118); 
{ /* Llib/midi.scm 612 */
long BgL_arg2000z00_4121;
BgL_arg2000z00_4121 = 
(
(long)CINT(
STRUCT_REF(BgL_ipz00_4118, 
(int)(((long)1))))+((long)1)); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6251;int BgL_tmpz00_6249;
BgL_auxz00_6251 = 
BINT(BgL_arg2000z00_4121); 
BgL_tmpz00_6249 = 
(int)(((long)1)); 
STRUCT_SET(BgL_ipz00_4118, BgL_tmpz00_6249, BgL_auxz00_6251); } } 
BgL_b1z00_4119 = BgL_bz00_4120; } 
{ /* Llib/midi.scm 619 */
long BgL_b0z00_4122;
{ /* Llib/midi.scm 611 */
long BgL_bz00_4123;
BgL_bz00_4123 = 
BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(BgL_ipz00_4118); 
{ /* Llib/midi.scm 612 */
long BgL_arg2000z00_4124;
BgL_arg2000z00_4124 = 
(
(long)CINT(
STRUCT_REF(BgL_ipz00_4118, 
(int)(((long)1))))+((long)1)); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6261;int BgL_tmpz00_6259;
BgL_auxz00_6261 = 
BINT(BgL_arg2000z00_4124); 
BgL_tmpz00_6259 = 
(int)(((long)1)); 
STRUCT_SET(BgL_ipz00_4118, BgL_tmpz00_6259, BgL_auxz00_6261); } } 
BgL_b0z00_4122 = BgL_bz00_4123; } 
{ /* Llib/midi.scm 620 */

{ /* Llib/midi.scm 621 */
int32_t BgL_arg2002z00_4125;int32_t BgL_arg2003z00_4126;
{ /* Llib/midi.scm 621 */
int32_t BgL_arg2004z00_4127;
{ /* Llib/midi.scm 621 */
int32_t BgL_res2720z00_4128;
BgL_res2720z00_4128 = 
(int32_t)(BgL_b1z00_4119); 
BgL_arg2004z00_4127 = BgL_res2720z00_4128; } 
BgL_arg2002z00_4125 = 
(BgL_arg2004z00_4127 << 
(int)(((long)8))); } 
{ /* Llib/midi.scm 621 */
int32_t BgL_res2722z00_4129;
BgL_res2722z00_4129 = 
(int32_t)(BgL_b0z00_4122); 
BgL_arg2003z00_4126 = BgL_res2722z00_4129; } 
BgL_tmpz00_6237 = 
(BgL_arg2002z00_4125+BgL_arg2003z00_4126); } } } } } 
return 
BGL_INT32_TO_BINT32(BgL_tmpz00_6237);} } 

}



/* &string-stream-read-int32 */
obj_t BGl_z62stringzd2streamzd2readzd2int32zb0zz__multimediazd2midizd2(obj_t BgL_envz00_3104, obj_t BgL_ipz00_3105)
{
{ /* Llib/midi.scm 626 */
{ /* Llib/midi.scm 627 */
int32_t BgL_tmpz00_6270;
{ /* Llib/midi.scm 627 */
obj_t BgL_ipz00_4130;
if(
STRUCTP(BgL_ipz00_3105))
{ /* Llib/midi.scm 627 */
BgL_ipz00_4130 = BgL_ipz00_3105; }  else 
{ 
obj_t BgL_auxz00_6273;
BgL_auxz00_6273 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)26420)), BGl_string3063z00zz__multimediazd2midizd2, BGl_string3060z00zz__multimediazd2midizd2, BgL_ipz00_3105); 
FAILURE(BgL_auxz00_6273,BFALSE,BFALSE);} 
{ /* Llib/midi.scm 627 */
long BgL_b3z00_4131;
{ /* Llib/midi.scm 611 */
long BgL_bz00_4132;
BgL_bz00_4132 = 
BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(BgL_ipz00_4130); 
{ /* Llib/midi.scm 612 */
long BgL_arg2000z00_4133;
BgL_arg2000z00_4133 = 
(
(long)CINT(
STRUCT_REF(BgL_ipz00_4130, 
(int)(((long)1))))+((long)1)); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6284;int BgL_tmpz00_6282;
BgL_auxz00_6284 = 
BINT(BgL_arg2000z00_4133); 
BgL_tmpz00_6282 = 
(int)(((long)1)); 
STRUCT_SET(BgL_ipz00_4130, BgL_tmpz00_6282, BgL_auxz00_6284); } } 
BgL_b3z00_4131 = BgL_bz00_4132; } 
{ /* Llib/midi.scm 627 */
long BgL_b2z00_4134;
{ /* Llib/midi.scm 611 */
long BgL_bz00_4135;
BgL_bz00_4135 = 
BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(BgL_ipz00_4130); 
{ /* Llib/midi.scm 612 */
long BgL_arg2000z00_4136;
BgL_arg2000z00_4136 = 
(
(long)CINT(
STRUCT_REF(BgL_ipz00_4130, 
(int)(((long)1))))+((long)1)); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6294;int BgL_tmpz00_6292;
BgL_auxz00_6294 = 
BINT(BgL_arg2000z00_4136); 
BgL_tmpz00_6292 = 
(int)(((long)1)); 
STRUCT_SET(BgL_ipz00_4130, BgL_tmpz00_6292, BgL_auxz00_6294); } } 
BgL_b2z00_4134 = BgL_bz00_4135; } 
{ /* Llib/midi.scm 628 */
long BgL_b1z00_4137;
{ /* Llib/midi.scm 611 */
long BgL_bz00_4138;
BgL_bz00_4138 = 
BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(BgL_ipz00_4130); 
{ /* Llib/midi.scm 612 */
long BgL_arg2000z00_4139;
BgL_arg2000z00_4139 = 
(
(long)CINT(
STRUCT_REF(BgL_ipz00_4130, 
(int)(((long)1))))+((long)1)); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6304;int BgL_tmpz00_6302;
BgL_auxz00_6304 = 
BINT(BgL_arg2000z00_4139); 
BgL_tmpz00_6302 = 
(int)(((long)1)); 
STRUCT_SET(BgL_ipz00_4130, BgL_tmpz00_6302, BgL_auxz00_6304); } } 
BgL_b1z00_4137 = BgL_bz00_4138; } 
{ /* Llib/midi.scm 629 */
long BgL_b0z00_4140;
{ /* Llib/midi.scm 611 */
long BgL_bz00_4141;
BgL_bz00_4141 = 
BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(BgL_ipz00_4130); 
{ /* Llib/midi.scm 612 */
long BgL_arg2000z00_4142;
BgL_arg2000z00_4142 = 
(
(long)CINT(
STRUCT_REF(BgL_ipz00_4130, 
(int)(((long)1))))+((long)1)); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6314;int BgL_tmpz00_6312;
BgL_auxz00_6314 = 
BINT(BgL_arg2000z00_4142); 
BgL_tmpz00_6312 = 
(int)(((long)1)); 
STRUCT_SET(BgL_ipz00_4130, BgL_tmpz00_6312, BgL_auxz00_6314); } } 
BgL_b0z00_4140 = BgL_bz00_4141; } 
{ /* Llib/midi.scm 630 */

{ /* Llib/midi.scm 631 */
int32_t BgL_arg2005z00_4143;int32_t BgL_arg2006z00_4144;
{ /* Llib/midi.scm 631 */
int32_t BgL_arg2007z00_4145;
{ /* Llib/midi.scm 631 */
int32_t BgL_res2728z00_4146;
BgL_res2728z00_4146 = 
(int32_t)(BgL_b3z00_4131); 
BgL_arg2007z00_4145 = BgL_res2728z00_4146; } 
BgL_arg2005z00_4143 = 
(BgL_arg2007z00_4145 << 
(int)(((long)24))); } 
{ /* Llib/midi.scm 632 */
int32_t BgL_arg2008z00_4147;int32_t BgL_arg2009z00_4148;
{ /* Llib/midi.scm 632 */
int32_t BgL_arg2010z00_4149;
{ /* Llib/midi.scm 632 */
int32_t BgL_res2730z00_4150;
BgL_res2730z00_4150 = 
(int32_t)(BgL_b2z00_4134); 
BgL_arg2010z00_4149 = BgL_res2730z00_4150; } 
BgL_arg2008z00_4147 = 
(BgL_arg2010z00_4149 << 
(int)(((long)16))); } 
{ /* Llib/midi.scm 633 */
int32_t BgL_arg2011z00_4151;int32_t BgL_arg2012z00_4152;
{ /* Llib/midi.scm 633 */
int32_t BgL_arg2013z00_4153;
{ /* Llib/midi.scm 633 */
int32_t BgL_res2732z00_4154;
BgL_res2732z00_4154 = 
(int32_t)(BgL_b1z00_4137); 
BgL_arg2013z00_4153 = BgL_res2732z00_4154; } 
BgL_arg2011z00_4151 = 
(BgL_arg2013z00_4153 << 
(int)(((long)8))); } 
{ /* Llib/midi.scm 634 */
int32_t BgL_res2734z00_4155;
BgL_res2734z00_4155 = 
(int32_t)(BgL_b0z00_4140); 
BgL_arg2012z00_4152 = BgL_res2734z00_4155; } 
BgL_arg2009z00_4148 = 
(BgL_arg2011z00_4151+BgL_arg2012z00_4152); } 
BgL_arg2006z00_4144 = 
(BgL_arg2008z00_4147+BgL_arg2009z00_4148); } 
BgL_tmpz00_6270 = 
(BgL_arg2005z00_4143+BgL_arg2006z00_4144); } } } } } } } 
return 
BGL_INT32_TO_BINT32(BgL_tmpz00_6270);} } 

}



/* &string-stream-read-int */
obj_t BGl_z62stringzd2streamzd2readzd2intzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3106, obj_t BgL_lenz00_3107, obj_t BgL_ipz00_3108)
{
{ /* Llib/midi.scm 639 */
{ /* Llib/midi.scm 640 */
long BgL_tmpz00_6331;
{ /* Llib/midi.scm 640 */
long BgL_lenz00_4156;obj_t BgL_ipz00_4157;
{ /* Llib/midi.scm 640 */
obj_t BgL_tmpz00_6332;
if(
INTEGERP(BgL_lenz00_3107))
{ /* Llib/midi.scm 640 */
BgL_tmpz00_6332 = BgL_lenz00_3107
; }  else 
{ 
obj_t BgL_auxz00_6335;
BgL_auxz00_6335 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)27020)), BGl_string3064z00zz__multimediazd2midizd2, BGl_string3039z00zz__multimediazd2midizd2, BgL_lenz00_3107); 
FAILURE(BgL_auxz00_6335,BFALSE,BFALSE);} 
BgL_lenz00_4156 = 
(long)CINT(BgL_tmpz00_6332); } 
if(
STRUCTP(BgL_ipz00_3108))
{ /* Llib/midi.scm 640 */
BgL_ipz00_4157 = BgL_ipz00_3108; }  else 
{ 
obj_t BgL_auxz00_6342;
BgL_auxz00_6342 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)27020)), BGl_string3064z00zz__multimediazd2midizd2, BGl_string3060z00zz__multimediazd2midizd2, BgL_ipz00_3108); 
FAILURE(BgL_auxz00_6342,BFALSE,BFALSE);} 
{ /* Llib/midi.scm 640 */
long BgL_g1169z00_4158;
{ /* Llib/midi.scm 611 */
long BgL_bz00_4159;
BgL_bz00_4159 = 
BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(BgL_ipz00_4157); 
{ /* Llib/midi.scm 612 */
long BgL_arg2000z00_4160;
BgL_arg2000z00_4160 = 
(
(long)CINT(
STRUCT_REF(BgL_ipz00_4157, 
(int)(((long)1))))+((long)1)); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6353;int BgL_tmpz00_6351;
BgL_auxz00_6353 = 
BINT(BgL_arg2000z00_4160); 
BgL_tmpz00_6351 = 
(int)(((long)1)); 
STRUCT_SET(BgL_ipz00_4157, BgL_tmpz00_6351, BgL_auxz00_6353); } } 
BgL_g1169z00_4158 = BgL_bz00_4159; } 
{ 
long BgL_valz00_4162;long BgL_lenz00_4163;
BgL_valz00_4162 = BgL_g1169z00_4158; 
BgL_lenz00_4163 = BgL_lenz00_4156; 
BgL_loopz00_4161:
if(
(BgL_lenz00_4163==((long)1)))
{ /* Llib/midi.scm 642 */
BgL_tmpz00_6331 = BgL_valz00_4162
; }  else 
{ /* Llib/midi.scm 644 */
long BgL_arg2016z00_4164;long BgL_arg2017z00_4165;
{ /* Llib/midi.scm 644 */
long BgL_arg2018z00_4166;long BgL_arg2019z00_4167;
BgL_arg2018z00_4166 = 
(BgL_valz00_4162 << 
(int)(((long)8))); 
{ /* Llib/midi.scm 611 */
long BgL_bz00_4168;
BgL_bz00_4168 = 
BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(BgL_ipz00_4157); 
{ /* Llib/midi.scm 612 */
long BgL_arg2000z00_4169;
BgL_arg2000z00_4169 = 
(
(long)CINT(
STRUCT_REF(BgL_ipz00_4157, 
(int)(((long)1))))+((long)1)); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6367;int BgL_tmpz00_6365;
BgL_auxz00_6367 = 
BINT(BgL_arg2000z00_4169); 
BgL_tmpz00_6365 = 
(int)(((long)1)); 
STRUCT_SET(BgL_ipz00_4157, BgL_tmpz00_6365, BgL_auxz00_6367); } } 
BgL_arg2019z00_4167 = BgL_bz00_4168; } 
BgL_arg2016z00_4164 = 
(BgL_arg2018z00_4166+BgL_arg2019z00_4167); } 
BgL_arg2017z00_4165 = 
(BgL_lenz00_4163-((long)1)); 
{ 
long BgL_lenz00_6373;long BgL_valz00_6372;
BgL_valz00_6372 = BgL_arg2016z00_4164; 
BgL_lenz00_6373 = BgL_arg2017z00_4165; 
BgL_lenz00_4163 = BgL_lenz00_6373; 
BgL_valz00_4162 = BgL_valz00_6372; 
goto BgL_loopz00_4161;} } } } } 
return 
BINT(BgL_tmpz00_6331);} } 

}



/* &string-stream-read-vlq */
obj_t BGl_z62stringzd2streamzd2readzd2vlqzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3109, obj_t BgL_ipz00_3110)
{
{ /* Llib/midi.scm 650 */
{ /* Llib/midi.scm 652 */
long BgL_tmpz00_6375;
{ 
long BgL_accz00_4171;
BgL_accz00_4171 = ((long)0); 
BgL_loopz00_4170:
{ /* Llib/midi.scm 652 */
long BgL_cz00_4172;
{ /* Llib/midi.scm 611 */
long BgL_bz00_4173;
BgL_bz00_4173 = 
BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(
((obj_t)BgL_ipz00_3110)); 
{ /* Llib/midi.scm 612 */
long BgL_arg2000z00_4174;
BgL_arg2000z00_4174 = 
(
(long)CINT(
STRUCT_REF(
((obj_t)BgL_ipz00_3110), 
(int)(((long)1))))+((long)1)); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6387;int BgL_auxz00_6385;obj_t BgL_tmpz00_6383;
BgL_auxz00_6387 = 
BINT(BgL_arg2000z00_4174); 
BgL_auxz00_6385 = 
(int)(((long)1)); 
BgL_tmpz00_6383 = 
((obj_t)BgL_ipz00_3110); 
STRUCT_SET(BgL_tmpz00_6383, BgL_auxz00_6385, BgL_auxz00_6387); } } 
BgL_cz00_4172 = BgL_bz00_4173; } 
if(
(BgL_cz00_4172<=((long)127)))
{ /* Llib/midi.scm 653 */
BgL_tmpz00_6375 = 
(BgL_cz00_4172+BgL_accz00_4171)
; }  else 
{ 
long BgL_accz00_6393;
BgL_accz00_6393 = 
(
(BgL_accz00_4171+
(BgL_cz00_4172 & ((long)127))) << 
(int)(((long)7))); 
BgL_accz00_4171 = BgL_accz00_6393; 
goto BgL_loopz00_4170;} } } 
return 
BINT(BgL_tmpz00_6375);} } 

}



/* &string-stream-read-chars */
obj_t BGl_z62stringzd2streamzd2readzd2charszb0zz__multimediazd2midizd2(obj_t BgL_envz00_3111, obj_t BgL_lenz00_3112, obj_t BgL_ipz00_3113)
{
{ /* Llib/midi.scm 660 */
{ /* Llib/midi.scm 661 */
obj_t BgL_ipz00_4175;
if(
STRUCTP(BgL_ipz00_3113))
{ /* Llib/midi.scm 661 */
BgL_ipz00_4175 = BgL_ipz00_3113; }  else 
{ 
obj_t BgL_auxz00_6401;
BgL_auxz00_6401 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)27894)), BGl_string3065z00zz__multimediazd2midizd2, BGl_string3060z00zz__multimediazd2midizd2, BgL_ipz00_3113); 
FAILURE(BgL_auxz00_6401,BFALSE,BFALSE);} 
{ /* Llib/midi.scm 661 */
obj_t BgL_sz00_4176;
{ /* Llib/midi.scm 661 */
obj_t BgL_arg2027z00_4177;obj_t BgL_arg2028z00_4178;obj_t BgL_arg2029z00_4179;
BgL_arg2027z00_4177 = 
STRUCT_REF(BgL_ipz00_4175, 
(int)(((long)0))); 
BgL_arg2028z00_4178 = 
STRUCT_REF(BgL_ipz00_4175, 
(int)(((long)1))); 
BgL_arg2029z00_4179 = 
BGl_2zb2zb2zz__r4_numbers_6_5z00(
STRUCT_REF(BgL_ipz00_4175, 
(int)(((long)1))), BgL_lenz00_3112); 
{ /* Llib/midi.scm 661 */
obj_t BgL_res2750z00_4180;
{ /* Llib/midi.scm 661 */
long BgL_startz00_4181;long BgL_endz00_4182;
BgL_startz00_4181 = 
(long)CINT(BgL_arg2028z00_4178); 
BgL_endz00_4182 = 
(long)CINT(BgL_arg2029z00_4179); 
BgL_res2750z00_4180 = 
c_substring(
((obj_t)BgL_arg2027z00_4177), BgL_startz00_4181, BgL_endz00_4182); } 
BgL_sz00_4176 = BgL_res2750z00_4180; } } 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6418;int BgL_tmpz00_6416;
BgL_auxz00_6418 = 
BGl_2zb2zb2zz__r4_numbers_6_5z00(
STRUCT_REF(BgL_ipz00_4175, 
(int)(((long)1))), BgL_lenz00_3112); 
BgL_tmpz00_6416 = 
(int)(((long)1)); 
STRUCT_SET(BgL_ipz00_4175, BgL_tmpz00_6416, BgL_auxz00_6418); } 
return BgL_sz00_4176;} } } 

}



/* midiplayer-cdelay */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2cdelayzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mpz00_68, BgL_midisinkz00_bglt BgL_msz00_69, long BgL_tickz00_70, BgL_miditrackz00_bglt BgL_trackz00_71, long BgL_ppqz00_72, long BgL_dtz00_73, long BgL_usz00_74)
{
{ /* Llib/midi.scm 993 */
if(
(BgL_dtz00_73>((long)0)))
{ /* Llib/midi.scm 998 */
obj_t BgL_fun2033z00_2480;
BgL_fun2033z00_2480 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_69))->BgL_usleepz00); 
{ /* Llib/midi.scm 998 */
long BgL_arg2032z00_2481;
BgL_arg2032z00_2481 = 
(
(
(BgL_dtz00_73*
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_71))->BgL_tempoz00))/BgL_ppqz00_72)-BgL_usz00_74); 
return 
PROCEDURE_ENTRY(BgL_fun2033z00_2480)(BgL_fun2033z00_2480, 
BINT(BgL_arg2032z00_2481), BEOA);} }  else 
{ /* Llib/midi.scm 997 */
return BFALSE;} } 

}



/* &midiplayer-cdelay */
obj_t BGl_z62midiplayerzd2cdelayzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3140, obj_t BgL_mpz00_3141, obj_t BgL_msz00_3142, obj_t BgL_tickz00_3143, obj_t BgL_trackz00_3144, obj_t BgL_ppqz00_3145, obj_t BgL_dtz00_3146, obj_t BgL_usz00_3147)
{
{ /* Llib/midi.scm 993 */
{ /* Llib/midi.scm 995 */
long BgL_auxz00_6486;long BgL_auxz00_6477;long BgL_auxz00_6468;BgL_miditrackz00_bglt BgL_auxz00_6460;long BgL_auxz00_6451;BgL_midisinkz00_bglt BgL_auxz00_6443;BgL_midiplayerz00_bglt BgL_auxz00_6435;
{ /* Llib/midi.scm 995 */
obj_t BgL_tmpz00_6487;
if(
INTEGERP(BgL_usz00_3147))
{ /* Llib/midi.scm 995 */
BgL_tmpz00_6487 = BgL_usz00_3147
; }  else 
{ 
obj_t BgL_auxz00_6490;
BgL_auxz00_6490 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)37739)), BGl_string3066z00zz__multimediazd2midizd2, BGl_string3039z00zz__multimediazd2midizd2, BgL_usz00_3147); 
FAILURE(BgL_auxz00_6490,BFALSE,BFALSE);} 
BgL_auxz00_6486 = 
(long)CINT(BgL_tmpz00_6487); } 
{ /* Llib/midi.scm 995 */
obj_t BgL_tmpz00_6478;
if(
INTEGERP(BgL_dtz00_3146))
{ /* Llib/midi.scm 995 */
BgL_tmpz00_6478 = BgL_dtz00_3146
; }  else 
{ 
obj_t BgL_auxz00_6481;
BgL_auxz00_6481 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)37739)), BGl_string3066z00zz__multimediazd2midizd2, BGl_string3039z00zz__multimediazd2midizd2, BgL_dtz00_3146); 
FAILURE(BgL_auxz00_6481,BFALSE,BFALSE);} 
BgL_auxz00_6477 = 
(long)CINT(BgL_tmpz00_6478); } 
{ /* Llib/midi.scm 995 */
obj_t BgL_tmpz00_6469;
if(
INTEGERP(BgL_ppqz00_3145))
{ /* Llib/midi.scm 995 */
BgL_tmpz00_6469 = BgL_ppqz00_3145
; }  else 
{ 
obj_t BgL_auxz00_6472;
BgL_auxz00_6472 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)37739)), BGl_string3066z00zz__multimediazd2midizd2, BGl_string3039z00zz__multimediazd2midizd2, BgL_ppqz00_3145); 
FAILURE(BgL_auxz00_6472,BFALSE,BFALSE);} 
BgL_auxz00_6468 = 
(long)CINT(BgL_tmpz00_6469); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_trackz00_3144, BGl_miditrackz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 995 */
BgL_auxz00_6460 = 
((BgL_miditrackz00_bglt)BgL_trackz00_3144)
; }  else 
{ 
obj_t BgL_auxz00_6464;
BgL_auxz00_6464 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)37739)), BGl_string3066z00zz__multimediazd2midizd2, BGl_string3067z00zz__multimediazd2midizd2, BgL_trackz00_3144); 
FAILURE(BgL_auxz00_6464,BFALSE,BFALSE);} 
{ /* Llib/midi.scm 995 */
obj_t BgL_tmpz00_6452;
if(
INTEGERP(BgL_tickz00_3143))
{ /* Llib/midi.scm 995 */
BgL_tmpz00_6452 = BgL_tickz00_3143
; }  else 
{ 
obj_t BgL_auxz00_6455;
BgL_auxz00_6455 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)37739)), BGl_string3066z00zz__multimediazd2midizd2, BGl_string3039z00zz__multimediazd2midizd2, BgL_tickz00_3143); 
FAILURE(BgL_auxz00_6455,BFALSE,BFALSE);} 
BgL_auxz00_6451 = 
(long)CINT(BgL_tmpz00_6452); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_msz00_3142, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 995 */
BgL_auxz00_6443 = 
((BgL_midisinkz00_bglt)BgL_msz00_3142)
; }  else 
{ 
obj_t BgL_auxz00_6447;
BgL_auxz00_6447 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)37739)), BGl_string3066z00zz__multimediazd2midizd2, BGl_string3047z00zz__multimediazd2midizd2, BgL_msz00_3142); 
FAILURE(BgL_auxz00_6447,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mpz00_3141, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 995 */
BgL_auxz00_6435 = 
((BgL_midiplayerz00_bglt)BgL_mpz00_3141)
; }  else 
{ 
obj_t BgL_auxz00_6439;
BgL_auxz00_6439 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)37739)), BGl_string3066z00zz__multimediazd2midizd2, BGl_string3046z00zz__multimediazd2midizd2, BgL_mpz00_3141); 
FAILURE(BgL_auxz00_6439,BFALSE,BFALSE);} 
return 
BGl_midiplayerzd2cdelayzd2zz__multimediazd2midizd2(BgL_auxz00_6435, BgL_auxz00_6443, BgL_auxz00_6451, BgL_auxz00_6460, BgL_auxz00_6468, BgL_auxz00_6477, BgL_auxz00_6486);} } 

}



/* midiplayer-ignore */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2ignorezd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mpz00_75, BgL_midisinkz00_bglt BgL_msz00_76, long BgL_tickz00_77, obj_t BgL_objz00_78)
{
{ /* Llib/midi.scm 1003 */
return BUNSPEC;} 

}



/* &midiplayer-ignore */
obj_t BGl_z62midiplayerzd2ignorezb0zz__multimediazd2midizd2(obj_t BgL_envz00_3148, obj_t BgL_mpz00_3149, obj_t BgL_msz00_3150, obj_t BgL_tickz00_3151, obj_t BgL_objz00_3152)
{
{ /* Llib/midi.scm 1003 */
{ /* Llib/midi.scm 1003 */
BgL_midiplayerz00_bglt BgL_mpz00_4183;BgL_midisinkz00_bglt BgL_msz00_4184;long BgL_tickz00_4185;
if(
BGl_isazf3zf3zz__objectz00(BgL_mpz00_3149, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1003 */
BgL_mpz00_4183 = 
((BgL_midiplayerz00_bglt)BgL_mpz00_3149); }  else 
{ 
obj_t BgL_auxz00_6499;
BgL_auxz00_6499 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)38117)), BGl_string3068z00zz__multimediazd2midizd2, BGl_string3046z00zz__multimediazd2midizd2, BgL_mpz00_3149); 
FAILURE(BgL_auxz00_6499,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_msz00_3150, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1003 */
BgL_msz00_4184 = 
((BgL_midisinkz00_bglt)BgL_msz00_3150); }  else 
{ 
obj_t BgL_auxz00_6506;
BgL_auxz00_6506 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)38117)), BGl_string3068z00zz__multimediazd2midizd2, BGl_string3047z00zz__multimediazd2midizd2, BgL_msz00_3150); 
FAILURE(BgL_auxz00_6506,BFALSE,BFALSE);} 
{ /* Llib/midi.scm 1003 */
obj_t BgL_tmpz00_6510;
if(
INTEGERP(BgL_tickz00_3151))
{ /* Llib/midi.scm 1003 */
BgL_tmpz00_6510 = BgL_tickz00_3151
; }  else 
{ 
obj_t BgL_auxz00_6513;
BgL_auxz00_6513 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)38117)), BGl_string3068z00zz__multimediazd2midizd2, BGl_string3039z00zz__multimediazd2midizd2, BgL_tickz00_3151); 
FAILURE(BgL_auxz00_6513,BFALSE,BFALSE);} 
BgL_tickz00_4185 = 
(long)CINT(BgL_tmpz00_6510); } 
return BUNSPEC;} } 

}



/* midiplayer-noteoff */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2noteoffzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mpz00_88, BgL_midisinkz00_bglt BgL_msz00_89, long BgL_tickz00_90, long BgL_nnz00_91, long BgL_kkz00_92, long BgL_vvz00_93)
{
{ /* Llib/midi.scm 1026 */
{ /* Llib/midi.scm 1019 */
obj_t BgL_fun2043z00_2521;
BgL_fun2043z00_2521 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_89))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1019 */
obj_t BgL_arg2041z00_2522;long BgL_arg2042z00_2523;
BgL_arg2041z00_2522 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_89))->BgL_streamz00); 
BgL_arg2042z00_2523 = 
(((long)128) | BgL_nnz00_91); 
PROCEDURE_ENTRY(BgL_fun2043z00_2521)(BgL_fun2043z00_2521, BgL_arg2041z00_2522, 
BINT(BgL_arg2042z00_2523), BEOA); } } 
{ /* Llib/midi.scm 1020 */
obj_t BgL_fun2045z00_2524;
BgL_fun2045z00_2524 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_89))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1020 */
obj_t BgL_arg2044z00_2525;
BgL_arg2044z00_2525 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_89))->BgL_streamz00); 
PROCEDURE_ENTRY(BgL_fun2045z00_2524)(BgL_fun2045z00_2524, BgL_arg2044z00_2525, 
BINT(BgL_kkz00_92), BEOA); } } 
{ /* Llib/midi.scm 1021 */
obj_t BgL_fun2047z00_2526;
BgL_fun2047z00_2526 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_89))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1021 */
obj_t BgL_arg2046z00_2527;
BgL_arg2046z00_2527 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_89))->BgL_streamz00); 
return 
PROCEDURE_ENTRY(BgL_fun2047z00_2526)(BgL_fun2047z00_2526, BgL_arg2046z00_2527, 
BINT(BgL_vvz00_93), BEOA);} } } 

}



/* &midiplayer-noteoff */
obj_t BGl_z62midiplayerzd2noteoffzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3153, obj_t BgL_mpz00_3154, obj_t BgL_msz00_3155, obj_t BgL_tickz00_3156, obj_t BgL_nnz00_3157, obj_t BgL_kkz00_3158, obj_t BgL_vvz00_3159)
{
{ /* Llib/midi.scm 1026 */
{ /* Llib/midi.scm 1028 */
long BgL_auxz00_6586;long BgL_auxz00_6577;long BgL_auxz00_6568;long BgL_auxz00_6559;BgL_midisinkz00_bglt BgL_auxz00_6551;BgL_midiplayerz00_bglt BgL_auxz00_6543;
{ /* Llib/midi.scm 1028 */
obj_t BgL_tmpz00_6587;
if(
INTEGERP(BgL_vvz00_3159))
{ /* Llib/midi.scm 1028 */
BgL_tmpz00_6587 = BgL_vvz00_3159
; }  else 
{ 
obj_t BgL_auxz00_6590;
BgL_auxz00_6590 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)39392)), BGl_string3069z00zz__multimediazd2midizd2, BGl_string3039z00zz__multimediazd2midizd2, BgL_vvz00_3159); 
FAILURE(BgL_auxz00_6590,BFALSE,BFALSE);} 
BgL_auxz00_6586 = 
(long)CINT(BgL_tmpz00_6587); } 
{ /* Llib/midi.scm 1028 */
obj_t BgL_tmpz00_6578;
if(
INTEGERP(BgL_kkz00_3158))
{ /* Llib/midi.scm 1028 */
BgL_tmpz00_6578 = BgL_kkz00_3158
; }  else 
{ 
obj_t BgL_auxz00_6581;
BgL_auxz00_6581 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)39392)), BGl_string3069z00zz__multimediazd2midizd2, BGl_string3039z00zz__multimediazd2midizd2, BgL_kkz00_3158); 
FAILURE(BgL_auxz00_6581,BFALSE,BFALSE);} 
BgL_auxz00_6577 = 
(long)CINT(BgL_tmpz00_6578); } 
{ /* Llib/midi.scm 1028 */
obj_t BgL_tmpz00_6569;
if(
INTEGERP(BgL_nnz00_3157))
{ /* Llib/midi.scm 1028 */
BgL_tmpz00_6569 = BgL_nnz00_3157
; }  else 
{ 
obj_t BgL_auxz00_6572;
BgL_auxz00_6572 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)39392)), BGl_string3069z00zz__multimediazd2midizd2, BGl_string3039z00zz__multimediazd2midizd2, BgL_nnz00_3157); 
FAILURE(BgL_auxz00_6572,BFALSE,BFALSE);} 
BgL_auxz00_6568 = 
(long)CINT(BgL_tmpz00_6569); } 
{ /* Llib/midi.scm 1028 */
obj_t BgL_tmpz00_6560;
if(
INTEGERP(BgL_tickz00_3156))
{ /* Llib/midi.scm 1028 */
BgL_tmpz00_6560 = BgL_tickz00_3156
; }  else 
{ 
obj_t BgL_auxz00_6563;
BgL_auxz00_6563 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)39392)), BGl_string3069z00zz__multimediazd2midizd2, BGl_string3039z00zz__multimediazd2midizd2, BgL_tickz00_3156); 
FAILURE(BgL_auxz00_6563,BFALSE,BFALSE);} 
BgL_auxz00_6559 = 
(long)CINT(BgL_tmpz00_6560); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_msz00_3155, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1028 */
BgL_auxz00_6551 = 
((BgL_midisinkz00_bglt)BgL_msz00_3155)
; }  else 
{ 
obj_t BgL_auxz00_6555;
BgL_auxz00_6555 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)39392)), BGl_string3069z00zz__multimediazd2midizd2, BGl_string3047z00zz__multimediazd2midizd2, BgL_msz00_3155); 
FAILURE(BgL_auxz00_6555,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mpz00_3154, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1028 */
BgL_auxz00_6543 = 
((BgL_midiplayerz00_bglt)BgL_mpz00_3154)
; }  else 
{ 
obj_t BgL_auxz00_6547;
BgL_auxz00_6547 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)39392)), BGl_string3069z00zz__multimediazd2midizd2, BGl_string3046z00zz__multimediazd2midizd2, BgL_mpz00_3154); 
FAILURE(BgL_auxz00_6547,BFALSE,BFALSE);} 
return 
BGl_midiplayerzd2noteoffzd2zz__multimediazd2midizd2(BgL_auxz00_6543, BgL_auxz00_6551, BgL_auxz00_6559, BgL_auxz00_6568, BgL_auxz00_6577, BgL_auxz00_6586);} } 

}



/* midiplayer-noteon */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2noteonzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mpz00_94, BgL_midisinkz00_bglt BgL_msz00_95, long BgL_tickz00_96, long BgL_nnz00_97, long BgL_kkz00_98, long BgL_vvz00_99)
{
{ /* Llib/midi.scm 1033 */
{ /* Llib/midi.scm 1019 */
obj_t BgL_fun2043z00_2535;
BgL_fun2043z00_2535 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_95))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1019 */
obj_t BgL_arg2041z00_2536;long BgL_arg2042z00_2537;
BgL_arg2041z00_2536 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_95))->BgL_streamz00); 
BgL_arg2042z00_2537 = 
(((long)144) | BgL_nnz00_97); 
PROCEDURE_ENTRY(BgL_fun2043z00_2535)(BgL_fun2043z00_2535, BgL_arg2041z00_2536, 
BINT(BgL_arg2042z00_2537), BEOA); } } 
{ /* Llib/midi.scm 1020 */
obj_t BgL_fun2045z00_2538;
BgL_fun2045z00_2538 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_95))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1020 */
obj_t BgL_arg2044z00_2539;
BgL_arg2044z00_2539 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_95))->BgL_streamz00); 
PROCEDURE_ENTRY(BgL_fun2045z00_2538)(BgL_fun2045z00_2538, BgL_arg2044z00_2539, 
BINT(BgL_kkz00_98), BEOA); } } 
{ /* Llib/midi.scm 1021 */
obj_t BgL_fun2047z00_2540;
BgL_fun2047z00_2540 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_95))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1021 */
obj_t BgL_arg2046z00_2541;
BgL_arg2046z00_2541 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_95))->BgL_streamz00); 
return 
PROCEDURE_ENTRY(BgL_fun2047z00_2540)(BgL_fun2047z00_2540, BgL_arg2046z00_2541, 
BINT(BgL_vvz00_99), BEOA);} } } 

}



/* &midiplayer-noteon */
obj_t BGl_z62midiplayerzd2noteonzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3160, obj_t BgL_mpz00_3161, obj_t BgL_msz00_3162, obj_t BgL_tickz00_3163, obj_t BgL_nnz00_3164, obj_t BgL_kkz00_3165, obj_t BgL_vvz00_3166)
{
{ /* Llib/midi.scm 1033 */
{ /* Llib/midi.scm 1035 */
long BgL_auxz00_6664;long BgL_auxz00_6655;long BgL_auxz00_6646;long BgL_auxz00_6637;BgL_midisinkz00_bglt BgL_auxz00_6629;BgL_midiplayerz00_bglt BgL_auxz00_6621;
{ /* Llib/midi.scm 1035 */
obj_t BgL_tmpz00_6665;
if(
INTEGERP(BgL_vvz00_3166))
{ /* Llib/midi.scm 1035 */
BgL_tmpz00_6665 = BgL_vvz00_3166
; }  else 
{ 
obj_t BgL_auxz00_6668;
BgL_auxz00_6668 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)39752)), BGl_string3070z00zz__multimediazd2midizd2, BGl_string3039z00zz__multimediazd2midizd2, BgL_vvz00_3166); 
FAILURE(BgL_auxz00_6668,BFALSE,BFALSE);} 
BgL_auxz00_6664 = 
(long)CINT(BgL_tmpz00_6665); } 
{ /* Llib/midi.scm 1035 */
obj_t BgL_tmpz00_6656;
if(
INTEGERP(BgL_kkz00_3165))
{ /* Llib/midi.scm 1035 */
BgL_tmpz00_6656 = BgL_kkz00_3165
; }  else 
{ 
obj_t BgL_auxz00_6659;
BgL_auxz00_6659 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)39752)), BGl_string3070z00zz__multimediazd2midizd2, BGl_string3039z00zz__multimediazd2midizd2, BgL_kkz00_3165); 
FAILURE(BgL_auxz00_6659,BFALSE,BFALSE);} 
BgL_auxz00_6655 = 
(long)CINT(BgL_tmpz00_6656); } 
{ /* Llib/midi.scm 1035 */
obj_t BgL_tmpz00_6647;
if(
INTEGERP(BgL_nnz00_3164))
{ /* Llib/midi.scm 1035 */
BgL_tmpz00_6647 = BgL_nnz00_3164
; }  else 
{ 
obj_t BgL_auxz00_6650;
BgL_auxz00_6650 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)39752)), BGl_string3070z00zz__multimediazd2midizd2, BGl_string3039z00zz__multimediazd2midizd2, BgL_nnz00_3164); 
FAILURE(BgL_auxz00_6650,BFALSE,BFALSE);} 
BgL_auxz00_6646 = 
(long)CINT(BgL_tmpz00_6647); } 
{ /* Llib/midi.scm 1035 */
obj_t BgL_tmpz00_6638;
if(
INTEGERP(BgL_tickz00_3163))
{ /* Llib/midi.scm 1035 */
BgL_tmpz00_6638 = BgL_tickz00_3163
; }  else 
{ 
obj_t BgL_auxz00_6641;
BgL_auxz00_6641 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)39752)), BGl_string3070z00zz__multimediazd2midizd2, BGl_string3039z00zz__multimediazd2midizd2, BgL_tickz00_3163); 
FAILURE(BgL_auxz00_6641,BFALSE,BFALSE);} 
BgL_auxz00_6637 = 
(long)CINT(BgL_tmpz00_6638); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_msz00_3162, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1035 */
BgL_auxz00_6629 = 
((BgL_midisinkz00_bglt)BgL_msz00_3162)
; }  else 
{ 
obj_t BgL_auxz00_6633;
BgL_auxz00_6633 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)39752)), BGl_string3070z00zz__multimediazd2midizd2, BGl_string3047z00zz__multimediazd2midizd2, BgL_msz00_3162); 
FAILURE(BgL_auxz00_6633,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mpz00_3161, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1035 */
BgL_auxz00_6621 = 
((BgL_midiplayerz00_bglt)BgL_mpz00_3161)
; }  else 
{ 
obj_t BgL_auxz00_6625;
BgL_auxz00_6625 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)39752)), BGl_string3070z00zz__multimediazd2midizd2, BGl_string3046z00zz__multimediazd2midizd2, BgL_mpz00_3161); 
FAILURE(BgL_auxz00_6625,BFALSE,BFALSE);} 
return 
BGl_midiplayerzd2noteonzd2zz__multimediazd2midizd2(BgL_auxz00_6621, BgL_auxz00_6629, BgL_auxz00_6637, BgL_auxz00_6646, BgL_auxz00_6655, BgL_auxz00_6664);} } 

}



/* midiplayer-aftertouch */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2aftertouchzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mpz00_100, BgL_midisinkz00_bglt BgL_msz00_101, long BgL_tickz00_102, long BgL_nnz00_103, long BgL_kkz00_104, long BgL_vvz00_105)
{
{ /* Llib/midi.scm 1040 */
{ /* Llib/midi.scm 1019 */
obj_t BgL_fun2043z00_2549;
BgL_fun2043z00_2549 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_101))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1019 */
obj_t BgL_arg2041z00_2550;long BgL_arg2042z00_2551;
BgL_arg2041z00_2550 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_101))->BgL_streamz00); 
BgL_arg2042z00_2551 = 
(((long)160) | BgL_nnz00_103); 
PROCEDURE_ENTRY(BgL_fun2043z00_2549)(BgL_fun2043z00_2549, BgL_arg2041z00_2550, 
BINT(BgL_arg2042z00_2551), BEOA); } } 
{ /* Llib/midi.scm 1020 */
obj_t BgL_fun2045z00_2552;
BgL_fun2045z00_2552 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_101))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1020 */
obj_t BgL_arg2044z00_2553;
BgL_arg2044z00_2553 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_101))->BgL_streamz00); 
PROCEDURE_ENTRY(BgL_fun2045z00_2552)(BgL_fun2045z00_2552, BgL_arg2044z00_2553, 
BINT(BgL_kkz00_104), BEOA); } } 
{ /* Llib/midi.scm 1021 */
obj_t BgL_fun2047z00_2554;
BgL_fun2047z00_2554 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_101))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1021 */
obj_t BgL_arg2046z00_2555;
BgL_arg2046z00_2555 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_101))->BgL_streamz00); 
return 
PROCEDURE_ENTRY(BgL_fun2047z00_2554)(BgL_fun2047z00_2554, BgL_arg2046z00_2555, 
BINT(BgL_vvz00_105), BEOA);} } } 

}



/* &midiplayer-aftertouch */
obj_t BGl_z62midiplayerzd2aftertouchzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3167, obj_t BgL_mpz00_3168, obj_t BgL_msz00_3169, obj_t BgL_tickz00_3170, obj_t BgL_nnz00_3171, obj_t BgL_kkz00_3172, obj_t BgL_vvz00_3173)
{
{ /* Llib/midi.scm 1040 */
{ /* Llib/midi.scm 1042 */
long BgL_auxz00_6742;long BgL_auxz00_6733;long BgL_auxz00_6724;long BgL_auxz00_6715;BgL_midisinkz00_bglt BgL_auxz00_6707;BgL_midiplayerz00_bglt BgL_auxz00_6699;
{ /* Llib/midi.scm 1042 */
obj_t BgL_tmpz00_6743;
if(
INTEGERP(BgL_vvz00_3173))
{ /* Llib/midi.scm 1042 */
BgL_tmpz00_6743 = BgL_vvz00_3173
; }  else 
{ 
obj_t BgL_auxz00_6746;
BgL_auxz00_6746 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)40116)), BGl_string3071z00zz__multimediazd2midizd2, BGl_string3039z00zz__multimediazd2midizd2, BgL_vvz00_3173); 
FAILURE(BgL_auxz00_6746,BFALSE,BFALSE);} 
BgL_auxz00_6742 = 
(long)CINT(BgL_tmpz00_6743); } 
{ /* Llib/midi.scm 1042 */
obj_t BgL_tmpz00_6734;
if(
INTEGERP(BgL_kkz00_3172))
{ /* Llib/midi.scm 1042 */
BgL_tmpz00_6734 = BgL_kkz00_3172
; }  else 
{ 
obj_t BgL_auxz00_6737;
BgL_auxz00_6737 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)40116)), BGl_string3071z00zz__multimediazd2midizd2, BGl_string3039z00zz__multimediazd2midizd2, BgL_kkz00_3172); 
FAILURE(BgL_auxz00_6737,BFALSE,BFALSE);} 
BgL_auxz00_6733 = 
(long)CINT(BgL_tmpz00_6734); } 
{ /* Llib/midi.scm 1042 */
obj_t BgL_tmpz00_6725;
if(
INTEGERP(BgL_nnz00_3171))
{ /* Llib/midi.scm 1042 */
BgL_tmpz00_6725 = BgL_nnz00_3171
; }  else 
{ 
obj_t BgL_auxz00_6728;
BgL_auxz00_6728 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)40116)), BGl_string3071z00zz__multimediazd2midizd2, BGl_string3039z00zz__multimediazd2midizd2, BgL_nnz00_3171); 
FAILURE(BgL_auxz00_6728,BFALSE,BFALSE);} 
BgL_auxz00_6724 = 
(long)CINT(BgL_tmpz00_6725); } 
{ /* Llib/midi.scm 1042 */
obj_t BgL_tmpz00_6716;
if(
INTEGERP(BgL_tickz00_3170))
{ /* Llib/midi.scm 1042 */
BgL_tmpz00_6716 = BgL_tickz00_3170
; }  else 
{ 
obj_t BgL_auxz00_6719;
BgL_auxz00_6719 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)40116)), BGl_string3071z00zz__multimediazd2midizd2, BGl_string3039z00zz__multimediazd2midizd2, BgL_tickz00_3170); 
FAILURE(BgL_auxz00_6719,BFALSE,BFALSE);} 
BgL_auxz00_6715 = 
(long)CINT(BgL_tmpz00_6716); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_msz00_3169, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1042 */
BgL_auxz00_6707 = 
((BgL_midisinkz00_bglt)BgL_msz00_3169)
; }  else 
{ 
obj_t BgL_auxz00_6711;
BgL_auxz00_6711 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)40116)), BGl_string3071z00zz__multimediazd2midizd2, BGl_string3047z00zz__multimediazd2midizd2, BgL_msz00_3169); 
FAILURE(BgL_auxz00_6711,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mpz00_3168, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1042 */
BgL_auxz00_6699 = 
((BgL_midiplayerz00_bglt)BgL_mpz00_3168)
; }  else 
{ 
obj_t BgL_auxz00_6703;
BgL_auxz00_6703 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)40116)), BGl_string3071z00zz__multimediazd2midizd2, BGl_string3046z00zz__multimediazd2midizd2, BgL_mpz00_3168); 
FAILURE(BgL_auxz00_6703,BFALSE,BFALSE);} 
return 
BGl_midiplayerzd2aftertouchzd2zz__multimediazd2midizd2(BgL_auxz00_6699, BgL_auxz00_6707, BgL_auxz00_6715, BgL_auxz00_6724, BgL_auxz00_6733, BgL_auxz00_6742);} } 

}



/* midiplayer-ctrlchange */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2ctrlchangezd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mpz00_106, BgL_midisinkz00_bglt BgL_msz00_107, long BgL_tickz00_108, long BgL_nnz00_109, long BgL_kkz00_110, long BgL_vvz00_111)
{
{ /* Llib/midi.scm 1047 */
{ /* Llib/midi.scm 1019 */
obj_t BgL_fun2043z00_2563;
BgL_fun2043z00_2563 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_107))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1019 */
obj_t BgL_arg2041z00_2564;long BgL_arg2042z00_2565;
BgL_arg2041z00_2564 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_107))->BgL_streamz00); 
BgL_arg2042z00_2565 = 
(((long)176) | BgL_nnz00_109); 
PROCEDURE_ENTRY(BgL_fun2043z00_2563)(BgL_fun2043z00_2563, BgL_arg2041z00_2564, 
BINT(BgL_arg2042z00_2565), BEOA); } } 
{ /* Llib/midi.scm 1020 */
obj_t BgL_fun2045z00_2566;
BgL_fun2045z00_2566 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_107))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1020 */
obj_t BgL_arg2044z00_2567;
BgL_arg2044z00_2567 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_107))->BgL_streamz00); 
PROCEDURE_ENTRY(BgL_fun2045z00_2566)(BgL_fun2045z00_2566, BgL_arg2044z00_2567, 
BINT(BgL_kkz00_110), BEOA); } } 
{ /* Llib/midi.scm 1021 */
obj_t BgL_fun2047z00_2568;
BgL_fun2047z00_2568 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_107))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1021 */
obj_t BgL_arg2046z00_2569;
BgL_arg2046z00_2569 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_107))->BgL_streamz00); 
return 
PROCEDURE_ENTRY(BgL_fun2047z00_2568)(BgL_fun2047z00_2568, BgL_arg2046z00_2569, 
BINT(BgL_vvz00_111), BEOA);} } } 

}



/* &midiplayer-ctrlchange */
obj_t BGl_z62midiplayerzd2ctrlchangezb0zz__multimediazd2midizd2(obj_t BgL_envz00_3174, obj_t BgL_mpz00_3175, obj_t BgL_msz00_3176, obj_t BgL_tickz00_3177, obj_t BgL_nnz00_3178, obj_t BgL_kkz00_3179, obj_t BgL_vvz00_3180)
{
{ /* Llib/midi.scm 1047 */
{ /* Llib/midi.scm 1049 */
long BgL_auxz00_6820;long BgL_auxz00_6811;long BgL_auxz00_6802;long BgL_auxz00_6793;BgL_midisinkz00_bglt BgL_auxz00_6785;BgL_midiplayerz00_bglt BgL_auxz00_6777;
{ /* Llib/midi.scm 1049 */
obj_t BgL_tmpz00_6821;
if(
INTEGERP(BgL_vvz00_3180))
{ /* Llib/midi.scm 1049 */
BgL_tmpz00_6821 = BgL_vvz00_3180
; }  else 
{ 
obj_t BgL_auxz00_6824;
BgL_auxz00_6824 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)40480)), BGl_string3072z00zz__multimediazd2midizd2, BGl_string3039z00zz__multimediazd2midizd2, BgL_vvz00_3180); 
FAILURE(BgL_auxz00_6824,BFALSE,BFALSE);} 
BgL_auxz00_6820 = 
(long)CINT(BgL_tmpz00_6821); } 
{ /* Llib/midi.scm 1049 */
obj_t BgL_tmpz00_6812;
if(
INTEGERP(BgL_kkz00_3179))
{ /* Llib/midi.scm 1049 */
BgL_tmpz00_6812 = BgL_kkz00_3179
; }  else 
{ 
obj_t BgL_auxz00_6815;
BgL_auxz00_6815 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)40480)), BGl_string3072z00zz__multimediazd2midizd2, BGl_string3039z00zz__multimediazd2midizd2, BgL_kkz00_3179); 
FAILURE(BgL_auxz00_6815,BFALSE,BFALSE);} 
BgL_auxz00_6811 = 
(long)CINT(BgL_tmpz00_6812); } 
{ /* Llib/midi.scm 1049 */
obj_t BgL_tmpz00_6803;
if(
INTEGERP(BgL_nnz00_3178))
{ /* Llib/midi.scm 1049 */
BgL_tmpz00_6803 = BgL_nnz00_3178
; }  else 
{ 
obj_t BgL_auxz00_6806;
BgL_auxz00_6806 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)40480)), BGl_string3072z00zz__multimediazd2midizd2, BGl_string3039z00zz__multimediazd2midizd2, BgL_nnz00_3178); 
FAILURE(BgL_auxz00_6806,BFALSE,BFALSE);} 
BgL_auxz00_6802 = 
(long)CINT(BgL_tmpz00_6803); } 
{ /* Llib/midi.scm 1049 */
obj_t BgL_tmpz00_6794;
if(
INTEGERP(BgL_tickz00_3177))
{ /* Llib/midi.scm 1049 */
BgL_tmpz00_6794 = BgL_tickz00_3177
; }  else 
{ 
obj_t BgL_auxz00_6797;
BgL_auxz00_6797 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)40480)), BGl_string3072z00zz__multimediazd2midizd2, BGl_string3039z00zz__multimediazd2midizd2, BgL_tickz00_3177); 
FAILURE(BgL_auxz00_6797,BFALSE,BFALSE);} 
BgL_auxz00_6793 = 
(long)CINT(BgL_tmpz00_6794); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_msz00_3176, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1049 */
BgL_auxz00_6785 = 
((BgL_midisinkz00_bglt)BgL_msz00_3176)
; }  else 
{ 
obj_t BgL_auxz00_6789;
BgL_auxz00_6789 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)40480)), BGl_string3072z00zz__multimediazd2midizd2, BGl_string3047z00zz__multimediazd2midizd2, BgL_msz00_3176); 
FAILURE(BgL_auxz00_6789,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mpz00_3175, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1049 */
BgL_auxz00_6777 = 
((BgL_midiplayerz00_bglt)BgL_mpz00_3175)
; }  else 
{ 
obj_t BgL_auxz00_6781;
BgL_auxz00_6781 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)40480)), BGl_string3072z00zz__multimediazd2midizd2, BGl_string3046z00zz__multimediazd2midizd2, BgL_mpz00_3175); 
FAILURE(BgL_auxz00_6781,BFALSE,BFALSE);} 
return 
BGl_midiplayerzd2ctrlchangezd2zz__multimediazd2midizd2(BgL_auxz00_6777, BgL_auxz00_6785, BgL_auxz00_6793, BgL_auxz00_6802, BgL_auxz00_6811, BgL_auxz00_6820);} } 

}



/* midiplayer-prgmchange */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2prgmchangezd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mpz00_112, BgL_midisinkz00_bglt BgL_msz00_113, long BgL_tickz00_114, long BgL_nnz00_115, long BgL_ppz00_116)
{
{ /* Llib/midi.scm 1054 */
{ /* Llib/midi.scm 1011 */
obj_t BgL_fun2038z00_2576;
BgL_fun2038z00_2576 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_113))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1011 */
obj_t BgL_arg2036z00_2577;long BgL_arg2037z00_2578;
BgL_arg2036z00_2577 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_113))->BgL_streamz00); 
BgL_arg2037z00_2578 = 
(((long)192) | BgL_nnz00_115); 
PROCEDURE_ENTRY(BgL_fun2038z00_2576)(BgL_fun2038z00_2576, BgL_arg2036z00_2577, 
BINT(BgL_arg2037z00_2578), BEOA); } } 
{ /* Llib/midi.scm 1012 */
obj_t BgL_fun2040z00_2579;
BgL_fun2040z00_2579 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_113))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1012 */
obj_t BgL_arg2039z00_2580;
BgL_arg2039z00_2580 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_113))->BgL_streamz00); 
return 
PROCEDURE_ENTRY(BgL_fun2040z00_2579)(BgL_fun2040z00_2579, BgL_arg2039z00_2580, 
BINT(BgL_ppz00_116), BEOA);} } } 

}



/* &midiplayer-prgmchange */
obj_t BGl_z62midiplayerzd2prgmchangezb0zz__multimediazd2midizd2(obj_t BgL_envz00_3181, obj_t BgL_mpz00_3182, obj_t BgL_msz00_3183, obj_t BgL_tickz00_3184, obj_t BgL_nnz00_3185, obj_t BgL_ppz00_3186)
{
{ /* Llib/midi.scm 1054 */
{ /* Llib/midi.scm 1056 */
long BgL_auxz00_6881;long BgL_auxz00_6872;long BgL_auxz00_6863;BgL_midisinkz00_bglt BgL_auxz00_6855;BgL_midiplayerz00_bglt BgL_auxz00_6847;
{ /* Llib/midi.scm 1056 */
obj_t BgL_tmpz00_6882;
if(
INTEGERP(BgL_ppz00_3186))
{ /* Llib/midi.scm 1056 */
BgL_tmpz00_6882 = BgL_ppz00_3186
; }  else 
{ 
obj_t BgL_auxz00_6885;
BgL_auxz00_6885 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)40835)), BGl_string3073z00zz__multimediazd2midizd2, BGl_string3039z00zz__multimediazd2midizd2, BgL_ppz00_3186); 
FAILURE(BgL_auxz00_6885,BFALSE,BFALSE);} 
BgL_auxz00_6881 = 
(long)CINT(BgL_tmpz00_6882); } 
{ /* Llib/midi.scm 1056 */
obj_t BgL_tmpz00_6873;
if(
INTEGERP(BgL_nnz00_3185))
{ /* Llib/midi.scm 1056 */
BgL_tmpz00_6873 = BgL_nnz00_3185
; }  else 
{ 
obj_t BgL_auxz00_6876;
BgL_auxz00_6876 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)40835)), BGl_string3073z00zz__multimediazd2midizd2, BGl_string3039z00zz__multimediazd2midizd2, BgL_nnz00_3185); 
FAILURE(BgL_auxz00_6876,BFALSE,BFALSE);} 
BgL_auxz00_6872 = 
(long)CINT(BgL_tmpz00_6873); } 
{ /* Llib/midi.scm 1056 */
obj_t BgL_tmpz00_6864;
if(
INTEGERP(BgL_tickz00_3184))
{ /* Llib/midi.scm 1056 */
BgL_tmpz00_6864 = BgL_tickz00_3184
; }  else 
{ 
obj_t BgL_auxz00_6867;
BgL_auxz00_6867 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)40835)), BGl_string3073z00zz__multimediazd2midizd2, BGl_string3039z00zz__multimediazd2midizd2, BgL_tickz00_3184); 
FAILURE(BgL_auxz00_6867,BFALSE,BFALSE);} 
BgL_auxz00_6863 = 
(long)CINT(BgL_tmpz00_6864); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_msz00_3183, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1056 */
BgL_auxz00_6855 = 
((BgL_midisinkz00_bglt)BgL_msz00_3183)
; }  else 
{ 
obj_t BgL_auxz00_6859;
BgL_auxz00_6859 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)40835)), BGl_string3073z00zz__multimediazd2midizd2, BGl_string3047z00zz__multimediazd2midizd2, BgL_msz00_3183); 
FAILURE(BgL_auxz00_6859,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mpz00_3182, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1056 */
BgL_auxz00_6847 = 
((BgL_midiplayerz00_bglt)BgL_mpz00_3182)
; }  else 
{ 
obj_t BgL_auxz00_6851;
BgL_auxz00_6851 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)40835)), BGl_string3073z00zz__multimediazd2midizd2, BGl_string3046z00zz__multimediazd2midizd2, BgL_mpz00_3182); 
FAILURE(BgL_auxz00_6851,BFALSE,BFALSE);} 
return 
BGl_midiplayerzd2prgmchangezd2zz__multimediazd2midizd2(BgL_auxz00_6847, BgL_auxz00_6855, BgL_auxz00_6863, BgL_auxz00_6872, BgL_auxz00_6881);} } 

}



/* midiplayer-after-touch */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2afterzd2touchz00zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mpz00_117, BgL_midisinkz00_bglt BgL_msz00_118, long BgL_tickz00_119, long BgL_nnz00_120, long BgL_ppz00_121)
{
{ /* Llib/midi.scm 1061 */
{ /* Llib/midi.scm 1011 */
obj_t BgL_fun2038z00_2587;
BgL_fun2038z00_2587 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_118))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1011 */
obj_t BgL_arg2036z00_2588;long BgL_arg2037z00_2589;
BgL_arg2036z00_2588 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_118))->BgL_streamz00); 
BgL_arg2037z00_2589 = 
(((long)208) | BgL_nnz00_120); 
PROCEDURE_ENTRY(BgL_fun2038z00_2587)(BgL_fun2038z00_2587, BgL_arg2036z00_2588, 
BINT(BgL_arg2037z00_2589), BEOA); } } 
{ /* Llib/midi.scm 1012 */
obj_t BgL_fun2040z00_2590;
BgL_fun2040z00_2590 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_118))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1012 */
obj_t BgL_arg2039z00_2591;
BgL_arg2039z00_2591 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_118))->BgL_streamz00); 
return 
PROCEDURE_ENTRY(BgL_fun2040z00_2590)(BgL_fun2040z00_2590, BgL_arg2039z00_2591, 
BINT(BgL_ppz00_121), BEOA);} } } 

}



/* &midiplayer-after-touch */
obj_t BGl_z62midiplayerzd2afterzd2touchz62zz__multimediazd2midizd2(obj_t BgL_envz00_3187, obj_t BgL_mpz00_3188, obj_t BgL_msz00_3189, obj_t BgL_tickz00_3190, obj_t BgL_nnz00_3191, obj_t BgL_ppz00_3192)
{
{ /* Llib/midi.scm 1061 */
{ /* Llib/midi.scm 1063 */
long BgL_auxz00_6942;long BgL_auxz00_6933;long BgL_auxz00_6924;BgL_midisinkz00_bglt BgL_auxz00_6916;BgL_midiplayerz00_bglt BgL_auxz00_6908;
{ /* Llib/midi.scm 1063 */
obj_t BgL_tmpz00_6943;
if(
INTEGERP(BgL_ppz00_3192))
{ /* Llib/midi.scm 1063 */
BgL_tmpz00_6943 = BgL_ppz00_3192
; }  else 
{ 
obj_t BgL_auxz00_6946;
BgL_auxz00_6946 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)41188)), BGl_string3074z00zz__multimediazd2midizd2, BGl_string3039z00zz__multimediazd2midizd2, BgL_ppz00_3192); 
FAILURE(BgL_auxz00_6946,BFALSE,BFALSE);} 
BgL_auxz00_6942 = 
(long)CINT(BgL_tmpz00_6943); } 
{ /* Llib/midi.scm 1063 */
obj_t BgL_tmpz00_6934;
if(
INTEGERP(BgL_nnz00_3191))
{ /* Llib/midi.scm 1063 */
BgL_tmpz00_6934 = BgL_nnz00_3191
; }  else 
{ 
obj_t BgL_auxz00_6937;
BgL_auxz00_6937 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)41188)), BGl_string3074z00zz__multimediazd2midizd2, BGl_string3039z00zz__multimediazd2midizd2, BgL_nnz00_3191); 
FAILURE(BgL_auxz00_6937,BFALSE,BFALSE);} 
BgL_auxz00_6933 = 
(long)CINT(BgL_tmpz00_6934); } 
{ /* Llib/midi.scm 1063 */
obj_t BgL_tmpz00_6925;
if(
INTEGERP(BgL_tickz00_3190))
{ /* Llib/midi.scm 1063 */
BgL_tmpz00_6925 = BgL_tickz00_3190
; }  else 
{ 
obj_t BgL_auxz00_6928;
BgL_auxz00_6928 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)41188)), BGl_string3074z00zz__multimediazd2midizd2, BGl_string3039z00zz__multimediazd2midizd2, BgL_tickz00_3190); 
FAILURE(BgL_auxz00_6928,BFALSE,BFALSE);} 
BgL_auxz00_6924 = 
(long)CINT(BgL_tmpz00_6925); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_msz00_3189, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1063 */
BgL_auxz00_6916 = 
((BgL_midisinkz00_bglt)BgL_msz00_3189)
; }  else 
{ 
obj_t BgL_auxz00_6920;
BgL_auxz00_6920 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)41188)), BGl_string3074z00zz__multimediazd2midizd2, BGl_string3047z00zz__multimediazd2midizd2, BgL_msz00_3189); 
FAILURE(BgL_auxz00_6920,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mpz00_3188, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1063 */
BgL_auxz00_6908 = 
((BgL_midiplayerz00_bglt)BgL_mpz00_3188)
; }  else 
{ 
obj_t BgL_auxz00_6912;
BgL_auxz00_6912 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)41188)), BGl_string3074z00zz__multimediazd2midizd2, BGl_string3046z00zz__multimediazd2midizd2, BgL_mpz00_3188); 
FAILURE(BgL_auxz00_6912,BFALSE,BFALSE);} 
return 
BGl_midiplayerzd2afterzd2touchz00zz__multimediazd2midizd2(BgL_auxz00_6908, BgL_auxz00_6916, BgL_auxz00_6924, BgL_auxz00_6933, BgL_auxz00_6942);} } 

}



/* midiplayer-pitch */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2pitchzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mpz00_122, BgL_midisinkz00_bglt BgL_msz00_123, long BgL_tickz00_124, long BgL_nnz00_125, long BgL_ccz00_126, long BgL_vvz00_127)
{
{ /* Llib/midi.scm 1068 */
{ /* Llib/midi.scm 1019 */
obj_t BgL_fun2043z00_2599;
BgL_fun2043z00_2599 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_123))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1019 */
obj_t BgL_arg2041z00_2600;long BgL_arg2042z00_2601;
BgL_arg2041z00_2600 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_123))->BgL_streamz00); 
BgL_arg2042z00_2601 = 
(((long)224) | BgL_nnz00_125); 
PROCEDURE_ENTRY(BgL_fun2043z00_2599)(BgL_fun2043z00_2599, BgL_arg2041z00_2600, 
BINT(BgL_arg2042z00_2601), BEOA); } } 
{ /* Llib/midi.scm 1020 */
obj_t BgL_fun2045z00_2602;
BgL_fun2045z00_2602 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_123))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1020 */
obj_t BgL_arg2044z00_2603;
BgL_arg2044z00_2603 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_123))->BgL_streamz00); 
PROCEDURE_ENTRY(BgL_fun2045z00_2602)(BgL_fun2045z00_2602, BgL_arg2044z00_2603, 
BINT(BgL_ccz00_126), BEOA); } } 
{ /* Llib/midi.scm 1021 */
obj_t BgL_fun2047z00_2604;
BgL_fun2047z00_2604 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_123))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1021 */
obj_t BgL_arg2046z00_2605;
BgL_arg2046z00_2605 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_123))->BgL_streamz00); 
return 
PROCEDURE_ENTRY(BgL_fun2047z00_2604)(BgL_fun2047z00_2604, BgL_arg2046z00_2605, 
BINT(BgL_vvz00_127), BEOA);} } } 

}



/* &midiplayer-pitch */
obj_t BGl_z62midiplayerzd2pitchzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3193, obj_t BgL_mpz00_3194, obj_t BgL_msz00_3195, obj_t BgL_tickz00_3196, obj_t BgL_nnz00_3197, obj_t BgL_ccz00_3198, obj_t BgL_vvz00_3199)
{
{ /* Llib/midi.scm 1068 */
{ /* Llib/midi.scm 1070 */
long BgL_auxz00_7020;long BgL_auxz00_7011;long BgL_auxz00_7002;long BgL_auxz00_6993;BgL_midisinkz00_bglt BgL_auxz00_6985;BgL_midiplayerz00_bglt BgL_auxz00_6977;
{ /* Llib/midi.scm 1070 */
obj_t BgL_tmpz00_7021;
if(
INTEGERP(BgL_vvz00_3199))
{ /* Llib/midi.scm 1070 */
BgL_tmpz00_7021 = BgL_vvz00_3199
; }  else 
{ 
obj_t BgL_auxz00_7024;
BgL_auxz00_7024 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)41544)), BGl_string3075z00zz__multimediazd2midizd2, BGl_string3039z00zz__multimediazd2midizd2, BgL_vvz00_3199); 
FAILURE(BgL_auxz00_7024,BFALSE,BFALSE);} 
BgL_auxz00_7020 = 
(long)CINT(BgL_tmpz00_7021); } 
{ /* Llib/midi.scm 1070 */
obj_t BgL_tmpz00_7012;
if(
INTEGERP(BgL_ccz00_3198))
{ /* Llib/midi.scm 1070 */
BgL_tmpz00_7012 = BgL_ccz00_3198
; }  else 
{ 
obj_t BgL_auxz00_7015;
BgL_auxz00_7015 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)41544)), BGl_string3075z00zz__multimediazd2midizd2, BGl_string3039z00zz__multimediazd2midizd2, BgL_ccz00_3198); 
FAILURE(BgL_auxz00_7015,BFALSE,BFALSE);} 
BgL_auxz00_7011 = 
(long)CINT(BgL_tmpz00_7012); } 
{ /* Llib/midi.scm 1070 */
obj_t BgL_tmpz00_7003;
if(
INTEGERP(BgL_nnz00_3197))
{ /* Llib/midi.scm 1070 */
BgL_tmpz00_7003 = BgL_nnz00_3197
; }  else 
{ 
obj_t BgL_auxz00_7006;
BgL_auxz00_7006 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)41544)), BGl_string3075z00zz__multimediazd2midizd2, BGl_string3039z00zz__multimediazd2midizd2, BgL_nnz00_3197); 
FAILURE(BgL_auxz00_7006,BFALSE,BFALSE);} 
BgL_auxz00_7002 = 
(long)CINT(BgL_tmpz00_7003); } 
{ /* Llib/midi.scm 1070 */
obj_t BgL_tmpz00_6994;
if(
INTEGERP(BgL_tickz00_3196))
{ /* Llib/midi.scm 1070 */
BgL_tmpz00_6994 = BgL_tickz00_3196
; }  else 
{ 
obj_t BgL_auxz00_6997;
BgL_auxz00_6997 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)41544)), BGl_string3075z00zz__multimediazd2midizd2, BGl_string3039z00zz__multimediazd2midizd2, BgL_tickz00_3196); 
FAILURE(BgL_auxz00_6997,BFALSE,BFALSE);} 
BgL_auxz00_6993 = 
(long)CINT(BgL_tmpz00_6994); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_msz00_3195, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1070 */
BgL_auxz00_6985 = 
((BgL_midisinkz00_bglt)BgL_msz00_3195)
; }  else 
{ 
obj_t BgL_auxz00_6989;
BgL_auxz00_6989 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)41544)), BGl_string3075z00zz__multimediazd2midizd2, BGl_string3047z00zz__multimediazd2midizd2, BgL_msz00_3195); 
FAILURE(BgL_auxz00_6989,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mpz00_3194, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1070 */
BgL_auxz00_6977 = 
((BgL_midiplayerz00_bglt)BgL_mpz00_3194)
; }  else 
{ 
obj_t BgL_auxz00_6981;
BgL_auxz00_6981 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)41544)), BGl_string3075z00zz__multimediazd2midizd2, BGl_string3046z00zz__multimediazd2midizd2, BgL_mpz00_3194); 
FAILURE(BgL_auxz00_6981,BFALSE,BFALSE);} 
return 
BGl_midiplayerzd2pitchzd2zz__multimediazd2midizd2(BgL_auxz00_6977, BgL_auxz00_6985, BgL_auxz00_6993, BgL_auxz00_7002, BgL_auxz00_7011, BgL_auxz00_7020);} } 

}



/* midiplayer-sysex */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2sysexzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mpz00_128, BgL_midisinkz00_bglt BgL_msz00_129, long BgL_tickz00_130, obj_t BgL_dataz00_131)
{
{ /* Llib/midi.scm 1075 */
{ /* Llib/midi.scm 1077 */
obj_t BgL_fun2049z00_2609;
BgL_fun2049z00_2609 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_129))->BgL_writezd2stringzd2); 
{ /* Llib/midi.scm 1077 */
obj_t BgL_arg2048z00_2610;
BgL_arg2048z00_2610 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_129))->BgL_streamz00); 
return 
PROCEDURE_ENTRY(BgL_fun2049z00_2609)(BgL_fun2049z00_2609, BgL_arg2048z00_2610, BEOA);} } } 

}



/* &midiplayer-sysex */
obj_t BGl_z62midiplayerzd2sysexzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3200, obj_t BgL_mpz00_3201, obj_t BgL_msz00_3202, obj_t BgL_tickz00_3203, obj_t BgL_dataz00_3204)
{
{ /* Llib/midi.scm 1075 */
{ /* Llib/midi.scm 1076 */
obj_t BgL_auxz00_7061;long BgL_auxz00_7052;BgL_midisinkz00_bglt BgL_auxz00_7044;BgL_midiplayerz00_bglt BgL_auxz00_7036;
if(
STRINGP(BgL_dataz00_3204))
{ /* Llib/midi.scm 1076 */
BgL_auxz00_7061 = BgL_dataz00_3204
; }  else 
{ 
obj_t BgL_auxz00_7064;
BgL_auxz00_7064 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)41881)), BGl_string3076z00zz__multimediazd2midizd2, BGl_string3036z00zz__multimediazd2midizd2, BgL_dataz00_3204); 
FAILURE(BgL_auxz00_7064,BFALSE,BFALSE);} 
{ /* Llib/midi.scm 1076 */
obj_t BgL_tmpz00_7053;
if(
INTEGERP(BgL_tickz00_3203))
{ /* Llib/midi.scm 1076 */
BgL_tmpz00_7053 = BgL_tickz00_3203
; }  else 
{ 
obj_t BgL_auxz00_7056;
BgL_auxz00_7056 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)41881)), BGl_string3076z00zz__multimediazd2midizd2, BGl_string3039z00zz__multimediazd2midizd2, BgL_tickz00_3203); 
FAILURE(BgL_auxz00_7056,BFALSE,BFALSE);} 
BgL_auxz00_7052 = 
(long)CINT(BgL_tmpz00_7053); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_msz00_3202, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1076 */
BgL_auxz00_7044 = 
((BgL_midisinkz00_bglt)BgL_msz00_3202)
; }  else 
{ 
obj_t BgL_auxz00_7048;
BgL_auxz00_7048 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)41881)), BGl_string3076z00zz__multimediazd2midizd2, BGl_string3047z00zz__multimediazd2midizd2, BgL_msz00_3202); 
FAILURE(BgL_auxz00_7048,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mpz00_3201, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1076 */
BgL_auxz00_7036 = 
((BgL_midiplayerz00_bglt)BgL_mpz00_3201)
; }  else 
{ 
obj_t BgL_auxz00_7040;
BgL_auxz00_7040 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)41881)), BGl_string3076z00zz__multimediazd2midizd2, BGl_string3046z00zz__multimediazd2midizd2, BgL_mpz00_3201); 
FAILURE(BgL_auxz00_7040,BFALSE,BFALSE);} 
return 
BGl_midiplayerzd2sysexzd2zz__multimediazd2midizd2(BgL_auxz00_7036, BgL_auxz00_7044, BgL_auxz00_7052, BgL_auxz00_7061);} } 

}



/* midi-note-name */
BGL_EXPORTED_DEF obj_t BGl_midizd2notezd2namez00zz__multimediazd2midizd2(long BgL_kkz00_132)
{
{ /* Llib/midi.scm 1082 */
{ /* Llib/midi.scm 1083 */
long BgL_notez00_885;long BgL_octavez00_886;
{ /* Llib/midi.scm 1083 */
long BgL_arg2053z00_890;
{ /* Llib/midi.scm 1083 */
obj_t BgL_vectorz00_2611;
BgL_vectorz00_2611 = 
CNST_TABLE_REF(((long)3)); 
BgL_arg2053z00_890 = 
VECTOR_LENGTH(BgL_vectorz00_2611); } 
{ /* Llib/midi.scm 1083 */
long BgL_res2764z00_2614;
BgL_res2764z00_2614 = 
(BgL_kkz00_132%BgL_arg2053z00_890); 
BgL_notez00_885 = BgL_res2764z00_2614; } } 
{ /* Llib/midi.scm 1084 */
long BgL_arg2054z00_891;
{ /* Llib/midi.scm 1084 */
obj_t BgL_vectorz00_2615;
BgL_vectorz00_2615 = 
CNST_TABLE_REF(((long)3)); 
BgL_arg2054z00_891 = 
VECTOR_LENGTH(BgL_vectorz00_2615); } 
BgL_octavez00_886 = 
(BgL_kkz00_132/BgL_arg2054z00_891); } 
{ /* Llib/midi.scm 1085 */
obj_t BgL_arg2050z00_887;
{ /* Llib/midi.scm 1085 */
obj_t BgL_vectorz00_2619;
BgL_vectorz00_2619 = 
CNST_TABLE_REF(((long)3)); 
BgL_arg2050z00_887 = 
VECTOR_REF(BgL_vectorz00_2619,BgL_notez00_885); } 
{ /* Llib/midi.scm 1085 */
obj_t BgL_list2051z00_888;
{ /* Llib/midi.scm 1085 */
obj_t BgL_arg2052z00_889;
BgL_arg2052z00_889 = 
MAKE_YOUNG_PAIR(
BINT(BgL_octavez00_886), BNIL); 
BgL_list2051z00_888 = 
MAKE_YOUNG_PAIR(BgL_arg2050z00_887, BgL_arg2052z00_889); } 
return 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string3077z00zz__multimediazd2midizd2, BgL_list2051z00_888);} } } } 

}



/* &midi-note-name */
obj_t BGl_z62midizd2notezd2namez62zz__multimediazd2midizd2(obj_t BgL_envz00_3205, obj_t BgL_kkz00_3206)
{
{ /* Llib/midi.scm 1082 */
{ /* Llib/midi.scm 1083 */
long BgL_auxz00_7081;
{ /* Llib/midi.scm 1083 */
obj_t BgL_tmpz00_7082;
if(
INTEGERP(BgL_kkz00_3206))
{ /* Llib/midi.scm 1083 */
BgL_tmpz00_7082 = BgL_kkz00_3206
; }  else 
{ 
obj_t BgL_auxz00_7085;
BgL_auxz00_7085 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)42219)), BGl_string3078z00zz__multimediazd2midizd2, BGl_string3039z00zz__multimediazd2midizd2, BgL_kkz00_3206); 
FAILURE(BgL_auxz00_7085,BFALSE,BFALSE);} 
BgL_auxz00_7081 = 
(long)CINT(BgL_tmpz00_7082); } 
return 
BGl_midizd2notezd2namez00zz__multimediazd2midizd2(BgL_auxz00_7081);} } 

}



/* midi-controller-name */
BGL_EXPORTED_DEF obj_t BGl_midizd2controllerzd2namez00zz__multimediazd2midizd2(long BgL_ccz00_133)
{
{ /* Llib/midi.scm 1090 */
{ /* Llib/midi.scm 1091 */
bool_t BgL_test3701z00_7091;
{ /* Llib/midi.scm 1091 */
long BgL_arg2057z00_2622;
{ /* Llib/midi.scm 1091 */
obj_t BgL_vectorz00_2623;
BgL_vectorz00_2623 = 
CNST_TABLE_REF(((long)1)); 
BgL_arg2057z00_2622 = 
VECTOR_LENGTH(BgL_vectorz00_2623); } 
BgL_test3701z00_7091 = 
(BgL_ccz00_133<BgL_arg2057z00_2622); } 
if(BgL_test3701z00_7091)
{ /* Llib/midi.scm 1092 */
obj_t BgL_vectorz00_2627;
BgL_vectorz00_2627 = 
CNST_TABLE_REF(((long)1)); 
return 
VECTOR_REF(BgL_vectorz00_2627,BgL_ccz00_133);}  else 
{ /* Llib/midi.scm 1091 */
return BGl_string3079z00zz__multimediazd2midizd2;} } } 

}



/* &midi-controller-name */
obj_t BGl_z62midizd2controllerzd2namez62zz__multimediazd2midizd2(obj_t BgL_envz00_3207, obj_t BgL_ccz00_3208)
{
{ /* Llib/midi.scm 1090 */
{ /* Llib/midi.scm 1091 */
long BgL_auxz00_7097;
{ /* Llib/midi.scm 1091 */
obj_t BgL_tmpz00_7098;
if(
INTEGERP(BgL_ccz00_3208))
{ /* Llib/midi.scm 1091 */
BgL_tmpz00_7098 = BgL_ccz00_3208
; }  else 
{ 
obj_t BgL_auxz00_7101;
BgL_auxz00_7101 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)42667)), BGl_string3080z00zz__multimediazd2midizd2, BGl_string3039z00zz__multimediazd2midizd2, BgL_ccz00_3208); 
FAILURE(BgL_auxz00_7101,BFALSE,BFALSE);} 
BgL_auxz00_7097 = 
(long)CINT(BgL_tmpz00_7098); } 
return 
BGl_midizd2controllerzd2namez00zz__multimediazd2midizd2(BgL_auxz00_7097);} } 

}



/* midi-program-name */
BGL_EXPORTED_DEF obj_t BGl_midizd2programzd2namez00zz__multimediazd2midizd2(long BgL_ppz00_134)
{
{ /* Llib/midi.scm 1098 */
{ /* Llib/midi.scm 1099 */
bool_t BgL_test3703z00_7107;
{ /* Llib/midi.scm 1099 */
long BgL_arg2060z00_2630;
{ /* Llib/midi.scm 1099 */
obj_t BgL_vectorz00_2631;
BgL_vectorz00_2631 = 
CNST_TABLE_REF(((long)2)); 
BgL_arg2060z00_2630 = 
VECTOR_LENGTH(BgL_vectorz00_2631); } 
BgL_test3703z00_7107 = 
(BgL_ppz00_134<BgL_arg2060z00_2630); } 
if(BgL_test3703z00_7107)
{ /* Llib/midi.scm 1100 */
obj_t BgL_vectorz00_2635;
BgL_vectorz00_2635 = 
CNST_TABLE_REF(((long)2)); 
return 
VECTOR_REF(BgL_vectorz00_2635,BgL_ppz00_134);}  else 
{ /* Llib/midi.scm 1099 */
return BGl_string3081z00zz__multimediazd2midizd2;} } } 

}



/* &midi-program-name */
obj_t BGl_z62midizd2programzd2namez62zz__multimediazd2midizd2(obj_t BgL_envz00_3209, obj_t BgL_ppz00_3210)
{
{ /* Llib/midi.scm 1098 */
{ /* Llib/midi.scm 1099 */
long BgL_auxz00_7113;
{ /* Llib/midi.scm 1099 */
obj_t BgL_tmpz00_7114;
if(
INTEGERP(BgL_ppz00_3210))
{ /* Llib/midi.scm 1099 */
BgL_tmpz00_7114 = BgL_ppz00_3210
; }  else 
{ 
obj_t BgL_auxz00_7117;
BgL_auxz00_7117 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)43056)), BGl_string3082z00zz__multimediazd2midizd2, BGl_string3039z00zz__multimediazd2midizd2, BgL_ppz00_3210); 
FAILURE(BgL_auxz00_7117,BFALSE,BFALSE);} 
BgL_auxz00_7113 = 
(long)CINT(BgL_tmpz00_7114); } 
return 
BGl_midizd2programzd2namez00zz__multimediazd2midizd2(BgL_auxz00_7113);} } 

}



/* midi-program-index */
BGL_EXPORTED_DEF obj_t BGl_midizd2programzd2indexz00zz__multimediazd2midizd2(obj_t BgL_prgmz00_135)
{
{ /* Llib/midi.scm 1106 */
{ /* Llib/midi.scm 1107 */
long BgL_g1175z00_898;
{ /* Llib/midi.scm 1107 */
long BgL_arg2067z00_908;
{ /* Llib/midi.scm 1107 */
obj_t BgL_vectorz00_2637;
BgL_vectorz00_2637 = 
CNST_TABLE_REF(((long)2)); 
BgL_arg2067z00_908 = 
VECTOR_LENGTH(BgL_vectorz00_2637); } 
BgL_g1175z00_898 = 
(BgL_arg2067z00_908-((long)1)); } 
{ 
long BgL_iz00_900;
BgL_iz00_900 = BgL_g1175z00_898; 
BgL_zc3z04anonymousza32061ze3z87_901:
if(
(BgL_iz00_900>=((long)0)))
{ /* Llib/midi.scm 1109 */
bool_t BgL_test3706z00_7128;
{ /* Llib/midi.scm 1109 */
obj_t BgL_arg2066z00_906;
{ /* Llib/midi.scm 1109 */
obj_t BgL_vectorz00_2642;
BgL_vectorz00_2642 = 
CNST_TABLE_REF(((long)2)); 
BgL_arg2066z00_906 = 
VECTOR_REF(BgL_vectorz00_2642,BgL_iz00_900); } 
BgL_test3706z00_7128 = 
bigloo_strcicmp(BgL_arg2066z00_906, BgL_prgmz00_135); } 
if(BgL_test3706z00_7128)
{ /* Llib/midi.scm 1109 */
return 
BINT(BgL_iz00_900);}  else 
{ 
long BgL_iz00_7133;
BgL_iz00_7133 = 
(BgL_iz00_900-((long)1)); 
BgL_iz00_900 = BgL_iz00_7133; 
goto BgL_zc3z04anonymousza32061ze3z87_901;} }  else 
{ /* Llib/midi.scm 1108 */
return BFALSE;} } } } 

}



/* &midi-program-index */
obj_t BGl_z62midizd2programzd2indexz62zz__multimediazd2midizd2(obj_t BgL_envz00_3211, obj_t BgL_prgmz00_3212)
{
{ /* Llib/midi.scm 1106 */
{ /* Llib/midi.scm 1107 */
obj_t BgL_auxz00_7135;
if(
STRINGP(BgL_prgmz00_3212))
{ /* Llib/midi.scm 1107 */
BgL_auxz00_7135 = BgL_prgmz00_3212
; }  else 
{ 
obj_t BgL_auxz00_7138;
BgL_auxz00_7138 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)43433)), BGl_string3083z00zz__multimediazd2midizd2, BGl_string3036z00zz__multimediazd2midizd2, BgL_prgmz00_3212); 
FAILURE(BgL_auxz00_7138,BFALSE,BFALSE);} 
return 
BGl_midizd2programzd2indexz00zz__multimediazd2midizd2(BgL_auxz00_7135);} } 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__multimediazd2midizd2()
{
{ /* Llib/midi.scm 15 */
{ /* Llib/midi.scm 17 */
obj_t BgL_arg2085z00_933;obj_t BgL_arg2086z00_934;
{ /* Llib/midi.scm 17 */
obj_t BgL_v1220z00_949;
BgL_v1220z00_949 = 
create_vector(((long)4)); 
{ /* Llib/midi.scm 17 */
obj_t BgL_arg2093z00_950;
BgL_arg2093z00_950 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)5)), BGl_proc3085z00zz__multimediazd2midizd2, BGl_proc3084z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1220z00_949,((long)0),BgL_arg2093z00_950); } 
{ /* Llib/midi.scm 17 */
obj_t BgL_arg2098z00_960;
BgL_arg2098z00_960 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)7)), BGl_proc3088z00zz__multimediazd2midizd2, BGl_proc3087z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3086z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1220z00_949,((long)1),BgL_arg2098z00_960); } 
{ /* Llib/midi.scm 17 */
obj_t BgL_arg2105z00_973;
BgL_arg2105z00_973 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)8)), BGl_proc3091z00zz__multimediazd2midizd2, BGl_proc3090z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3089z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1220z00_949,((long)2),BgL_arg2105z00_973); } 
{ /* Llib/midi.scm 17 */
obj_t BgL_arg2112z00_986;
BgL_arg2112z00_986 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)9)), BGl_proc3094z00zz__multimediazd2midizd2, BGl_proc3093z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3092z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)10))); 
VECTOR_SET(BgL_v1220z00_949,((long)3),BgL_arg2112z00_986); } 
BgL_arg2085z00_933 = BgL_v1220z00_949; } 
{ /* Llib/midi.scm 17 */
obj_t BgL_v1221z00_999;
BgL_v1221z00_999 = 
create_vector(((long)0)); 
BgL_arg2086z00_934 = BgL_v1221z00_999; } 
BGl_midiscorez00zz__multimediazd2midizd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)11)), 
CNST_TABLE_REF(((long)12)), BGl_objectz00zz__objectz00, ((long)5450), BGl_proc3097z00zz__multimediazd2midizd2, BGl_proc3096z00zz__multimediazd2midizd2, BGl_midiscorezd2initzd2envz00zz__multimediazd2midizd2, BGl_proc3095z00zz__multimediazd2midizd2, BFALSE, BgL_arg2085z00_933, BgL_arg2086z00_934); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2122z00_1006;obj_t BgL_arg2123z00_1007;
{ /* Llib/midi.scm 24 */
obj_t BgL_v1222z00_1032;
BgL_v1222z00_1032 = 
create_vector(((long)14)); 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2130z00_1033;
BgL_arg2130z00_1033 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)13)), BGl_proc3100z00zz__multimediazd2midizd2, BGl_proc3099z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3098z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)14))); 
VECTOR_SET(BgL_v1222z00_1032,((long)0),BgL_arg2130z00_1033); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2137z00_1046;
BgL_arg2137z00_1046 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)15)), BGl_proc3102z00zz__multimediazd2midizd2, BGl_proc3101z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_midireaderz00zz__multimediazd2midizd2); 
VECTOR_SET(BgL_v1222z00_1032,((long)1),BgL_arg2137z00_1046); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2142z00_1056;
BgL_arg2142z00_1056 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)16)), BGl_proc3104z00zz__multimediazd2midizd2, BGl_proc3103z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1222z00_1032,((long)2),BgL_arg2142z00_1056); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2147z00_1066;
BgL_arg2147z00_1066 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)18)), BGl_proc3107z00zz__multimediazd2midizd2, BGl_proc3106z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3105z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)19))); 
VECTOR_SET(BgL_v1222z00_1032,((long)3),BgL_arg2147z00_1066); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2154z00_1079;
BgL_arg2154z00_1079 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)20)), BGl_proc3110z00zz__multimediazd2midizd2, BGl_proc3109z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3108z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)21))); 
VECTOR_SET(BgL_v1222z00_1032,((long)4),BgL_arg2154z00_1079); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2161z00_1092;
BgL_arg2161z00_1092 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)22)), BGl_proc3113z00zz__multimediazd2midizd2, BGl_proc3112z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3111z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1222z00_1032,((long)5),BgL_arg2161z00_1092); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2168z00_1105;
BgL_arg2168z00_1105 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)23)), BGl_proc3116z00zz__multimediazd2midizd2, BGl_proc3115z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3114z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)24))); 
VECTOR_SET(BgL_v1222z00_1032,((long)6),BgL_arg2168z00_1105); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2175z00_1118;
BgL_arg2175z00_1118 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)7)), BGl_proc3119z00zz__multimediazd2midizd2, BGl_proc3118z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3117z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1222z00_1032,((long)7),BgL_arg2175z00_1118); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2182z00_1131;
BgL_arg2182z00_1131 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)25)), BGl_proc3122z00zz__multimediazd2midizd2, BGl_proc3121z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3120z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)14))); 
VECTOR_SET(BgL_v1222z00_1032,((long)8),BgL_arg2182z00_1131); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2189z00_1144;
BgL_arg2189z00_1144 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)26)), BGl_proc3125z00zz__multimediazd2midizd2, BGl_proc3124z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3123z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1222z00_1032,((long)9),BgL_arg2189z00_1144); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2196z00_1157;
BgL_arg2196z00_1157 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)27)), BGl_proc3128z00zz__multimediazd2midizd2, BGl_proc3127z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3126z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1222z00_1032,((long)10),BgL_arg2196z00_1157); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2203z00_1170;
BgL_arg2203z00_1170 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)28)), BGl_proc3131z00zz__multimediazd2midizd2, BGl_proc3130z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3129z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)21))); 
VECTOR_SET(BgL_v1222z00_1032,((long)11),BgL_arg2203z00_1170); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2210z00_1183;
BgL_arg2210z00_1183 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)29)), BGl_proc3134z00zz__multimediazd2midizd2, BGl_proc3133z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3132z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1222z00_1032,((long)12),BgL_arg2210z00_1183); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2217z00_1196;
BgL_arg2217z00_1196 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)30)), BGl_proc3137z00zz__multimediazd2midizd2, BGl_proc3136z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3135z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)19))); 
VECTOR_SET(BgL_v1222z00_1032,((long)13),BgL_arg2217z00_1196); } 
BgL_arg2122z00_1006 = BgL_v1222z00_1032; } 
{ /* Llib/midi.scm 24 */
obj_t BgL_v1223z00_1209;
BgL_v1223z00_1209 = 
create_vector(((long)0)); 
BgL_arg2123z00_1007 = BgL_v1223z00_1209; } 
BGl_miditrackz00zz__multimediazd2midizd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)31)), 
CNST_TABLE_REF(((long)12)), BGl_objectz00zz__objectz00, ((long)26896), BGl_proc3140z00zz__multimediazd2midizd2, BGl_proc3139z00zz__multimediazd2midizd2, BGl_miditrackzd2initzd2envz00zz__multimediazd2midizd2, BGl_proc3138z00zz__multimediazd2midizd2, BFALSE, BgL_arg2122z00_1006, BgL_arg2123z00_1007); } 
{ /* Llib/midi.scm 42 */
obj_t BgL_arg2227z00_1216;obj_t BgL_arg2228z00_1217;
{ /* Llib/midi.scm 42 */
obj_t BgL_v1224z00_1235;
BgL_v1224z00_1235 = 
create_vector(((long)7)); 
{ /* Llib/midi.scm 42 */
obj_t BgL_arg2235z00_1236;
BgL_arg2235z00_1236 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)32)), BGl_proc3142z00zz__multimediazd2midizd2, BGl_proc3141z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1224z00_1235,((long)0),BgL_arg2235z00_1236); } 
{ /* Llib/midi.scm 42 */
obj_t BgL_arg2240z00_1246;
BgL_arg2240z00_1246 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)33)), BGl_proc3144z00zz__multimediazd2midizd2, BGl_proc3143z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1224z00_1235,((long)1),BgL_arg2240z00_1246); } 
{ /* Llib/midi.scm 42 */
obj_t BgL_arg2245z00_1256;
BgL_arg2245z00_1256 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)34)), BGl_proc3146z00zz__multimediazd2midizd2, BGl_proc3145z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1224z00_1235,((long)2),BgL_arg2245z00_1256); } 
{ /* Llib/midi.scm 42 */
obj_t BgL_arg2250z00_1266;
BgL_arg2250z00_1266 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)35)), BGl_proc3148z00zz__multimediazd2midizd2, BGl_proc3147z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1224z00_1235,((long)3),BgL_arg2250z00_1266); } 
{ /* Llib/midi.scm 42 */
obj_t BgL_arg2255z00_1276;
BgL_arg2255z00_1276 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)36)), BGl_proc3150z00zz__multimediazd2midizd2, BGl_proc3149z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1224z00_1235,((long)4),BgL_arg2255z00_1276); } 
{ /* Llib/midi.scm 42 */
obj_t BgL_arg2260z00_1286;
BgL_arg2260z00_1286 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)37)), BGl_proc3152z00zz__multimediazd2midizd2, BGl_proc3151z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1224z00_1235,((long)5),BgL_arg2260z00_1286); } 
{ /* Llib/midi.scm 42 */
obj_t BgL_arg2265z00_1296;
BgL_arg2265z00_1296 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)38)), BGl_proc3154z00zz__multimediazd2midizd2, BGl_proc3153z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1224z00_1235,((long)6),BgL_arg2265z00_1296); } 
BgL_arg2227z00_1216 = BgL_v1224z00_1235; } 
{ /* Llib/midi.scm 42 */
obj_t BgL_v1225z00_1306;
BgL_v1225z00_1306 = 
create_vector(((long)0)); 
BgL_arg2228z00_1217 = BgL_v1225z00_1306; } 
BGl_midireaderz00zz__multimediazd2midizd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)39)), 
CNST_TABLE_REF(((long)12)), BGl_objectz00zz__objectz00, ((long)53877), BGl_proc3157z00zz__multimediazd2midizd2, BGl_proc3156z00zz__multimediazd2midizd2, BGl_midireaderzd2initzd2envz00zz__multimediazd2midizd2, BGl_proc3155z00zz__multimediazd2midizd2, BFALSE, BgL_arg2227z00_1216, BgL_arg2228z00_1217); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2273z00_1313;obj_t BgL_arg2274z00_1314;
{ /* Llib/midi.scm 52 */
obj_t BgL_v1226z00_1353;
BgL_v1226z00_1353 = 
create_vector(((long)28)); 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2281z00_1354;
BgL_arg2281z00_1354 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)40)), BGl_proc3160z00zz__multimediazd2midizd2, BGl_proc3159z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3158z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)0),BgL_arg2281z00_1354); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2288z00_1367;
BgL_arg2288z00_1367 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)41)), BGl_proc3163z00zz__multimediazd2midizd2, BGl_proc3162z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3161z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)1),BgL_arg2288z00_1367); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2295z00_1380;
BgL_arg2295z00_1380 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)42)), BGl_proc3166z00zz__multimediazd2midizd2, BGl_proc3165z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3164z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)2),BgL_arg2295z00_1380); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2302z00_1393;
BgL_arg2302z00_1393 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)43)), BGl_proc3169z00zz__multimediazd2midizd2, BGl_proc3168z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3167z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)3),BgL_arg2302z00_1393); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2309z00_1406;
BgL_arg2309z00_1406 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)44)), BGl_proc3172z00zz__multimediazd2midizd2, BGl_proc3171z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3170z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)4),BgL_arg2309z00_1406); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2316z00_1419;
BgL_arg2316z00_1419 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)45)), BGl_proc3175z00zz__multimediazd2midizd2, BGl_proc3174z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3173z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)5),BgL_arg2316z00_1419); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2323z00_1432;
BgL_arg2323z00_1432 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)46)), BGl_proc3178z00zz__multimediazd2midizd2, BGl_proc3177z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3176z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)6),BgL_arg2323z00_1432); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2330z00_1445;
BgL_arg2330z00_1445 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)47)), BGl_proc3181z00zz__multimediazd2midizd2, BGl_proc3180z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3179z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)7),BgL_arg2330z00_1445); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2337z00_1458;
BgL_arg2337z00_1458 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)48)), BGl_proc3184z00zz__multimediazd2midizd2, BGl_proc3183z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3182z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)8),BgL_arg2337z00_1458); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2344z00_1471;
BgL_arg2344z00_1471 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)49)), BGl_proc3187z00zz__multimediazd2midizd2, BGl_proc3186z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3185z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)9),BgL_arg2344z00_1471); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2351z00_1484;
BgL_arg2351z00_1484 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)50)), BGl_proc3190z00zz__multimediazd2midizd2, BGl_proc3189z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3188z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)10),BgL_arg2351z00_1484); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2358z00_1497;
BgL_arg2358z00_1497 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)51)), BGl_proc3193z00zz__multimediazd2midizd2, BGl_proc3192z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3191z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)11),BgL_arg2358z00_1497); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2365z00_1510;
BgL_arg2365z00_1510 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)52)), BGl_proc3196z00zz__multimediazd2midizd2, BGl_proc3195z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3194z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)12),BgL_arg2365z00_1510); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2372z00_1523;
BgL_arg2372z00_1523 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)53)), BGl_proc3199z00zz__multimediazd2midizd2, BGl_proc3198z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3197z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)13),BgL_arg2372z00_1523); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2379z00_1536;
BgL_arg2379z00_1536 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)54)), BGl_proc3202z00zz__multimediazd2midizd2, BGl_proc3201z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3200z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)14),BgL_arg2379z00_1536); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2386z00_1549;
BgL_arg2386z00_1549 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)55)), BGl_proc3205z00zz__multimediazd2midizd2, BGl_proc3204z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3203z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)15),BgL_arg2386z00_1549); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2393z00_1562;
BgL_arg2393z00_1562 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)56)), BGl_proc3208z00zz__multimediazd2midizd2, BGl_proc3207z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3206z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)16),BgL_arg2393z00_1562); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2400z00_1575;
BgL_arg2400z00_1575 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)57)), BGl_proc3211z00zz__multimediazd2midizd2, BGl_proc3210z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3209z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)17),BgL_arg2400z00_1575); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2407z00_1588;
BgL_arg2407z00_1588 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)58)), BGl_proc3214z00zz__multimediazd2midizd2, BGl_proc3213z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3212z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)18),BgL_arg2407z00_1588); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2414z00_1601;
BgL_arg2414z00_1601 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)59)), BGl_proc3217z00zz__multimediazd2midizd2, BGl_proc3216z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3215z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)19),BgL_arg2414z00_1601); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2421z00_1614;
BgL_arg2421z00_1614 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)60)), BGl_proc3220z00zz__multimediazd2midizd2, BGl_proc3219z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3218z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)20),BgL_arg2421z00_1614); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2428z00_1627;
BgL_arg2428z00_1627 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)61)), BGl_proc3223z00zz__multimediazd2midizd2, BGl_proc3222z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3221z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)21),BgL_arg2428z00_1627); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2435z00_1640;
BgL_arg2435z00_1640 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)62)), BGl_proc3226z00zz__multimediazd2midizd2, BGl_proc3225z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3224z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)22),BgL_arg2435z00_1640); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2442z00_1653;
BgL_arg2442z00_1653 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)63)), BGl_proc3229z00zz__multimediazd2midizd2, BGl_proc3228z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3227z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)23),BgL_arg2442z00_1653); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2449z00_1666;
BgL_arg2449z00_1666 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)64)), BGl_proc3232z00zz__multimediazd2midizd2, BGl_proc3231z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3230z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)24),BgL_arg2449z00_1666); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2457z00_1688;
BgL_arg2457z00_1688 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)65)), BGl_proc3235z00zz__multimediazd2midizd2, BGl_proc3234z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3233z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)25),BgL_arg2457z00_1688); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2465z00_1709;
BgL_arg2465z00_1709 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)66)), BGl_proc3238z00zz__multimediazd2midizd2, BGl_proc3237z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3236z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)26),BgL_arg2465z00_1709); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2472z00_1722;
BgL_arg2472z00_1722 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)67)), BGl_proc3241z00zz__multimediazd2midizd2, BGl_proc3240z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3239z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1226z00_1353,((long)27),BgL_arg2472z00_1722); } 
BgL_arg2273z00_1313 = BgL_v1226z00_1353; } 
{ /* Llib/midi.scm 52 */
obj_t BgL_v1227z00_1735;
BgL_v1227z00_1735 = 
create_vector(((long)0)); 
BgL_arg2274z00_1314 = BgL_v1227z00_1735; } 
BGl_midiplayerz00zz__multimediazd2midizd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)68)), 
CNST_TABLE_REF(((long)12)), BGl_objectz00zz__objectz00, ((long)52705), BGl_proc3244z00zz__multimediazd2midizd2, BGl_proc3243z00zz__multimediazd2midizd2, BGl_midiplayerzd2initzd2envz00zz__multimediazd2midizd2, BGl_proc3242z00zz__multimediazd2midizd2, BFALSE, BgL_arg2273z00_1313, BgL_arg2274z00_1314); } 
{ /* Llib/midi.scm 87 */
obj_t BgL_arg2482z00_1742;obj_t BgL_arg2483z00_1743;
{ /* Llib/midi.scm 87 */
obj_t BgL_v1228z00_1759;
BgL_v1228z00_1759 = 
create_vector(((long)5)); 
{ /* Llib/midi.scm 87 */
obj_t BgL_arg2490z00_1760;
BgL_arg2490z00_1760 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)69)), BGl_proc3247z00zz__multimediazd2midizd2, BGl_proc3246z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3245z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)14))); 
VECTOR_SET(BgL_v1228z00_1759,((long)0),BgL_arg2490z00_1760); } 
{ /* Llib/midi.scm 87 */
obj_t BgL_arg2497z00_1773;
BgL_arg2497z00_1773 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)70)), BGl_proc3250z00zz__multimediazd2midizd2, BGl_proc3249z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3248z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1228z00_1759,((long)1),BgL_arg2497z00_1773); } 
{ /* Llib/midi.scm 87 */
obj_t BgL_arg2504z00_1786;
BgL_arg2504z00_1786 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)71)), BGl_proc3253z00zz__multimediazd2midizd2, BGl_proc3252z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3251z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1228z00_1759,((long)2),BgL_arg2504z00_1786); } 
{ /* Llib/midi.scm 87 */
obj_t BgL_arg2512z00_1802;
BgL_arg2512z00_1802 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)72)), BGl_proc3256z00zz__multimediazd2midizd2, BGl_proc3255z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3254z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1228z00_1759,((long)3),BgL_arg2512z00_1802); } 
{ /* Llib/midi.scm 87 */
obj_t BgL_arg2520z00_1818;
BgL_arg2520z00_1818 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)73)), BGl_proc3259z00zz__multimediazd2midizd2, BGl_proc3258z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3257z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1228z00_1759,((long)4),BgL_arg2520z00_1818); } 
BgL_arg2482z00_1742 = BgL_v1228z00_1759; } 
{ /* Llib/midi.scm 87 */
obj_t BgL_v1229z00_1831;
BgL_v1229z00_1831 = 
create_vector(((long)0)); 
BgL_arg2483z00_1743 = BgL_v1229z00_1831; } 
return ( 
BGl_midisinkz00zz__multimediazd2midizd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)74)), 
CNST_TABLE_REF(((long)12)), BGl_objectz00zz__objectz00, ((long)13783), BGl_proc3262z00zz__multimediazd2midizd2, BGl_proc3261z00zz__multimediazd2midizd2, BGl_midisinkzd2initzd2envz00zz__multimediazd2midizd2, BGl_proc3260z00zz__multimediazd2midizd2, BFALSE, BgL_arg2482z00_1742, BgL_arg2483z00_1743), BUNSPEC) ;} } 

}



/* &<@anonymous:2489> */
obj_t BGl_z62zc3z04anonymousza32489ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3407, obj_t BgL_new1119z00_3408)
{
{ /* Llib/midi.scm 87 */
{ 
BgL_midisinkz00_bglt BgL_auxz00_7399;
((((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_new1119z00_3408)))->BgL_streamz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_new1119z00_3408)))->BgL_usleepz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_new1119z00_3408)))->BgL_writezd2bytezd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_new1119z00_3408)))->BgL_writezd2stringzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_new1119z00_3408)))->BgL_flushz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
BgL_auxz00_7399 = 
((BgL_midisinkz00_bglt)BgL_new1119z00_3408); 
return 
((obj_t)BgL_auxz00_7399);} } 

}



/* &lambda2487 */
BgL_midisinkz00_bglt BGl_z62lambda2487z62zz__multimediazd2midizd2(obj_t BgL_envz00_3409)
{
{ /* Llib/midi.scm 87 */
{ /* Llib/midi.scm 87 */
BgL_midisinkz00_bglt BgL_new1118z00_4187;
BgL_new1118z00_4187 = 
((BgL_midisinkz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midisinkz00_bgl) ))); 
{ /* Llib/midi.scm 87 */
long BgL_arg2488z00_4188;
{ /* Llib/midi.scm 87 */
long BgL_res2783z00_4189;
BgL_res2783z00_4189 = 
BGL_CLASS_INDEX(BGl_midisinkz00zz__multimediazd2midizd2); 
BgL_arg2488z00_4188 = BgL_res2783z00_4189; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1118z00_4187), BgL_arg2488z00_4188); } 
return BgL_new1118z00_4187;} } 

}



/* &lambda2484 */
BgL_midisinkz00_bglt BGl_z62lambda2484z62zz__multimediazd2midizd2(obj_t BgL_envz00_3410, obj_t BgL_stream1113z00_3411, obj_t BgL_usleep1114z00_3412, obj_t BgL_writezd2byte1115zd2_3413, obj_t BgL_writezd2string1116zd2_3414, obj_t BgL_flush1117z00_3415)
{
{ /* Llib/midi.scm 87 */
{ /* Llib/midi.scm 87 */
BgL_midisinkz00_bglt BgL_new1185z00_4194;
{ /* Llib/midi.scm 87 */
BgL_midisinkz00_bglt BgL_new1184z00_4195;
BgL_new1184z00_4195 = 
((BgL_midisinkz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midisinkz00_bgl) ))); 
{ /* Llib/midi.scm 87 */
long BgL_arg2486z00_4196;
{ /* Llib/midi.scm 87 */
long BgL_res2782z00_4197;
BgL_res2782z00_4197 = 
BGL_CLASS_INDEX(BGl_midisinkz00zz__multimediazd2midizd2); 
BgL_arg2486z00_4196 = BgL_res2782z00_4197; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1184z00_4195), BgL_arg2486z00_4196); } 
BgL_new1185z00_4194 = BgL_new1184z00_4195; } 
((((BgL_midisinkz00_bglt)COBJECT(BgL_new1185z00_4194))->BgL_streamz00)=((obj_t)BgL_stream1113z00_3411),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(BgL_new1185z00_4194))->BgL_usleepz00)=((obj_t)
((obj_t)BgL_usleep1114z00_3412)),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(BgL_new1185z00_4194))->BgL_writezd2bytezd2)=((obj_t)
((obj_t)BgL_writezd2byte1115zd2_3413)),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(BgL_new1185z00_4194))->BgL_writezd2stringzd2)=((obj_t)
((obj_t)BgL_writezd2string1116zd2_3414)),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(BgL_new1185z00_4194))->BgL_flushz00)=((obj_t)
((obj_t)BgL_flush1117z00_3415)),BUNSPEC); 
{ /* Llib/midi.scm 87 */
obj_t BgL_fun2485z00_4198;
BgL_fun2485z00_4198 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_midisinkz00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun2485z00_4198)(BgL_fun2485z00_4198, 
((obj_t)BgL_new1185z00_4194), BEOA); } 
return BgL_new1185z00_4194;} } 

}



/* &<@anonymous:2526> */
obj_t BGl_z62zc3z04anonymousza32526ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3416)
{
{ /* Llib/midi.scm 87 */
return BGl_flushzd2outputzd2portzd2envzd2zz__r4_ports_6_10_1z00;} 

}



/* &lambda2525 */
obj_t BGl_z62lambda2525z62zz__multimediazd2midizd2(obj_t BgL_envz00_3417, obj_t BgL_oz00_3418, obj_t BgL_vz00_3419)
{
{ /* Llib/midi.scm 87 */
return 
((((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_oz00_3418)))->BgL_flushz00)=((obj_t)
((obj_t)BgL_vz00_3419)),BUNSPEC);} 

}



/* &lambda2524 */
obj_t BGl_z62lambda2524z62zz__multimediazd2midizd2(obj_t BgL_envz00_3420, obj_t BgL_oz00_3421)
{
{ /* Llib/midi.scm 87 */
return 
(((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_oz00_3421)))->BgL_flushz00);} 

}



/* &<@anonymous:2518> */
obj_t BGl_z62zc3z04anonymousza32518ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3422)
{
{ /* Llib/midi.scm 87 */
return BGl_proc3263z00zz__multimediazd2midizd2;} 

}



/* &lambda2517 */
obj_t BGl_z62lambda2517z62zz__multimediazd2midizd2(obj_t BgL_envz00_3423, obj_t BgL_oz00_3424, obj_t BgL_vz00_3425)
{
{ /* Llib/midi.scm 87 */
return 
((((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_oz00_3424)))->BgL_writezd2stringzd2)=((obj_t)
((obj_t)BgL_vz00_3425)),BUNSPEC);} 

}



/* &lambda2516 */
obj_t BGl_z62lambda2516z62zz__multimediazd2midizd2(obj_t BgL_envz00_3426, obj_t BgL_oz00_3427)
{
{ /* Llib/midi.scm 87 */
return 
(((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_oz00_3427)))->BgL_writezd2stringzd2);} 

}



/* &<@anonymous:2519> */
obj_t BGl_z62zc3z04anonymousza32519ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3428, obj_t BgL_opz00_3429, obj_t BgL_sz00_3430)
{
{ /* Llib/midi.scm 92 */
return 
BGl_writezd2stringzd2zz__r4_output_6_10_3z00(BgL_sz00_3430, BgL_opz00_3429);} 

}



/* &<@anonymous:2510> */
obj_t BGl_z62zc3z04anonymousza32510ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3431)
{
{ /* Llib/midi.scm 87 */
return BGl_proc3264z00zz__multimediazd2midizd2;} 

}



/* &lambda2509 */
obj_t BGl_z62lambda2509z62zz__multimediazd2midizd2(obj_t BgL_envz00_3432, obj_t BgL_oz00_3433, obj_t BgL_vz00_3434)
{
{ /* Llib/midi.scm 87 */
return 
((((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_oz00_3433)))->BgL_writezd2bytezd2)=((obj_t)
((obj_t)BgL_vz00_3434)),BUNSPEC);} 

}



/* &lambda2508 */
obj_t BGl_z62lambda2508z62zz__multimediazd2midizd2(obj_t BgL_envz00_3435, obj_t BgL_oz00_3436)
{
{ /* Llib/midi.scm 87 */
return 
(((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_oz00_3436)))->BgL_writezd2bytezd2);} 

}



/* &<@anonymous:2511> */
obj_t BGl_z62zc3z04anonymousza32511ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3437, obj_t BgL_opz00_3438, obj_t BgL_bz00_3439)
{
{ /* Llib/midi.scm 91 */
{ /* Llib/midi.scm 91 */
unsigned char BgL_bytez00_4208;
BgL_bytez00_4208 = 
(unsigned char)CINT(BgL_bz00_3439); 
{ /* Llib/midi.scm 91 */
obj_t BgL_tmpz00_7452;
BgL_tmpz00_7452 = 
((obj_t)BgL_opz00_3438); 
return 
bgl_display_char(BgL_bytez00_4208, BgL_tmpz00_7452);} } } 

}



/* &<@anonymous:2503> */
obj_t BGl_z62zc3z04anonymousza32503ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3440)
{
{ /* Llib/midi.scm 87 */
return BGl_sleepzd2envzd2zz__osz00;} 

}



/* &lambda2502 */
obj_t BGl_z62lambda2502z62zz__multimediazd2midizd2(obj_t BgL_envz00_3441, obj_t BgL_oz00_3442, obj_t BgL_vz00_3443)
{
{ /* Llib/midi.scm 87 */
return 
((((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_oz00_3442)))->BgL_usleepz00)=((obj_t)
((obj_t)BgL_vz00_3443)),BUNSPEC);} 

}



/* &lambda2501 */
obj_t BGl_z62lambda2501z62zz__multimediazd2midizd2(obj_t BgL_envz00_3444, obj_t BgL_oz00_3445)
{
{ /* Llib/midi.scm 87 */
return 
(((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_oz00_3445)))->BgL_usleepz00);} 

}



/* &<@anonymous:2496> */
obj_t BGl_z62zc3z04anonymousza32496ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3446)
{
{ /* Llib/midi.scm 87 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda2495 */
obj_t BGl_z62lambda2495z62zz__multimediazd2midizd2(obj_t BgL_envz00_3447, obj_t BgL_oz00_3448, obj_t BgL_vz00_3449)
{
{ /* Llib/midi.scm 87 */
return 
((((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_oz00_3448)))->BgL_streamz00)=((obj_t)BgL_vz00_3449),BUNSPEC);} 

}



/* &lambda2494 */
obj_t BGl_z62lambda2494z62zz__multimediazd2midizd2(obj_t BgL_envz00_3450, obj_t BgL_oz00_3451)
{
{ /* Llib/midi.scm 87 */
return 
(((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_oz00_3451)))->BgL_streamz00);} 

}



/* &<@anonymous:2280> */
obj_t BGl_z62zc3z04anonymousza32280ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3452, obj_t BgL_new1111z00_3453)
{
{ /* Llib/midi.scm 52 */
{ 
BgL_midiplayerz00_bglt BgL_auxz00_7465;
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3453)))->BgL_errz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3453)))->BgL_cdelayz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3453)))->BgL_noteoffz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3453)))->BgL_noteonz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3453)))->BgL_aftertouchz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3453)))->BgL_ctrlchangez00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3453)))->BgL_prgmchangez00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3453)))->BgL_afterzd2touchzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3453)))->BgL_pitchz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3453)))->BgL_sysexz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3453)))->BgL_metazd2seqnumzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3453)))->BgL_metazd2textzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3453)))->BgL_metazd2copyrightzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3453)))->BgL_metazd2trackzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3453)))->BgL_metazd2instrumentzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3453)))->BgL_metazd2lyriczd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3453)))->BgL_metazd2markerzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3453)))->BgL_metazd2cuezd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3453)))->BgL_metazd2prgmnamezd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3453)))->BgL_metazd2devnamezd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3453)))->BgL_metazd2channprefzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3453)))->BgL_metazd2midiportzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3453)))->BgL_metazd2eotzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3453)))->BgL_metazd2tempozd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3453)))->BgL_metazd2smtpezd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3453)))->BgL_metazd2timesigzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3453)))->BgL_metazd2keysigzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3453)))->BgL_metazd2seqspeczd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
BgL_auxz00_7465 = 
((BgL_midiplayerz00_bglt)BgL_new1111z00_3453); 
return 
((obj_t)BgL_auxz00_7465);} } 

}



/* &lambda2278 */
BgL_midiplayerz00_bglt BGl_z62lambda2278z62zz__multimediazd2midizd2(obj_t BgL_envz00_3454)
{
{ /* Llib/midi.scm 52 */
{ /* Llib/midi.scm 52 */
BgL_midiplayerz00_bglt BgL_new1110z00_4215;
BgL_new1110z00_4215 = 
((BgL_midiplayerz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midiplayerz00_bgl) ))); 
{ /* Llib/midi.scm 52 */
long BgL_arg2279z00_4216;
{ /* Llib/midi.scm 52 */
long BgL_res2781z00_4217;
BgL_res2781z00_4217 = 
BGL_CLASS_INDEX(BGl_midiplayerz00zz__multimediazd2midizd2); 
BgL_arg2279z00_4216 = BgL_res2781z00_4217; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1110z00_4215), BgL_arg2279z00_4216); } 
return BgL_new1110z00_4215;} } 

}



/* &lambda2275 */
BgL_midiplayerz00_bglt BGl_z62lambda2275z62zz__multimediazd2midizd2(obj_t BgL_envz00_3455, obj_t BgL_err1082z00_3456, obj_t BgL_cdelay1083z00_3457, obj_t BgL_noteoff1084z00_3458, obj_t BgL_noteon1085z00_3459, obj_t BgL_aftertouch1086z00_3460, obj_t BgL_ctrlchange1087z00_3461, obj_t BgL_prgmchange1088z00_3462, obj_t BgL_afterzd2touch1089zd2_3463, obj_t BgL_pitch1090z00_3464, obj_t BgL_sysex1091z00_3465, obj_t BgL_metazd2seqnum1092zd2_3466, obj_t BgL_metazd2text1093zd2_3467, obj_t BgL_metazd2copyright1094zd2_3468, obj_t BgL_metazd2track1095zd2_3469, obj_t BgL_metazd2instrument1096zd2_3470, obj_t BgL_metazd2lyric1097zd2_3471, obj_t BgL_metazd2marker1098zd2_3472, obj_t BgL_metazd2cue1099zd2_3473, obj_t BgL_metazd2prgmname1100zd2_3474, obj_t BgL_metazd2devname1101zd2_3475, obj_t BgL_metazd2channpref1102zd2_3476, obj_t BgL_metazd2midiport1103zd2_3477, obj_t BgL_metazd2eot1104zd2_3478, obj_t BgL_metazd2tempo1105zd2_3479, obj_t BgL_metazd2smtpe1106zd2_3480, obj_t BgL_metazd2timesig1107zd2_3481, obj_t BgL_metazd2keysig1108zd2_3482, obj_t BgL_metazd2seqspec1109zd2_3483)
{
{ /* Llib/midi.scm 52 */
{ /* Llib/midi.scm 52 */
BgL_midiplayerz00_bglt BgL_new1183z00_4246;
{ /* Llib/midi.scm 52 */
BgL_midiplayerz00_bglt BgL_new1182z00_4247;
BgL_new1182z00_4247 = 
((BgL_midiplayerz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midiplayerz00_bgl) ))); 
{ /* Llib/midi.scm 52 */
long BgL_arg2277z00_4248;
{ /* Llib/midi.scm 52 */
long BgL_res2780z00_4249;
BgL_res2780z00_4249 = 
BGL_CLASS_INDEX(BGl_midiplayerz00zz__multimediazd2midizd2); 
BgL_arg2277z00_4248 = BgL_res2780z00_4249; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1182z00_4247), BgL_arg2277z00_4248); } 
BgL_new1183z00_4246 = BgL_new1182z00_4247; } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4246))->BgL_errz00)=((obj_t)
((obj_t)BgL_err1082z00_3456)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4246))->BgL_cdelayz00)=((obj_t)
((obj_t)BgL_cdelay1083z00_3457)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4246))->BgL_noteoffz00)=((obj_t)
((obj_t)BgL_noteoff1084z00_3458)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4246))->BgL_noteonz00)=((obj_t)
((obj_t)BgL_noteon1085z00_3459)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4246))->BgL_aftertouchz00)=((obj_t)
((obj_t)BgL_aftertouch1086z00_3460)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4246))->BgL_ctrlchangez00)=((obj_t)
((obj_t)BgL_ctrlchange1087z00_3461)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4246))->BgL_prgmchangez00)=((obj_t)
((obj_t)BgL_prgmchange1088z00_3462)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4246))->BgL_afterzd2touchzd2)=((obj_t)
((obj_t)BgL_afterzd2touch1089zd2_3463)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4246))->BgL_pitchz00)=((obj_t)
((obj_t)BgL_pitch1090z00_3464)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4246))->BgL_sysexz00)=((obj_t)
((obj_t)BgL_sysex1091z00_3465)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4246))->BgL_metazd2seqnumzd2)=((obj_t)
((obj_t)BgL_metazd2seqnum1092zd2_3466)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4246))->BgL_metazd2textzd2)=((obj_t)
((obj_t)BgL_metazd2text1093zd2_3467)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4246))->BgL_metazd2copyrightzd2)=((obj_t)
((obj_t)BgL_metazd2copyright1094zd2_3468)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4246))->BgL_metazd2trackzd2)=((obj_t)
((obj_t)BgL_metazd2track1095zd2_3469)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4246))->BgL_metazd2instrumentzd2)=((obj_t)
((obj_t)BgL_metazd2instrument1096zd2_3470)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4246))->BgL_metazd2lyriczd2)=((obj_t)
((obj_t)BgL_metazd2lyric1097zd2_3471)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4246))->BgL_metazd2markerzd2)=((obj_t)
((obj_t)BgL_metazd2marker1098zd2_3472)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4246))->BgL_metazd2cuezd2)=((obj_t)
((obj_t)BgL_metazd2cue1099zd2_3473)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4246))->BgL_metazd2prgmnamezd2)=((obj_t)
((obj_t)BgL_metazd2prgmname1100zd2_3474)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4246))->BgL_metazd2devnamezd2)=((obj_t)
((obj_t)BgL_metazd2devname1101zd2_3475)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4246))->BgL_metazd2channprefzd2)=((obj_t)
((obj_t)BgL_metazd2channpref1102zd2_3476)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4246))->BgL_metazd2midiportzd2)=((obj_t)
((obj_t)BgL_metazd2midiport1103zd2_3477)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4246))->BgL_metazd2eotzd2)=((obj_t)
((obj_t)BgL_metazd2eot1104zd2_3478)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4246))->BgL_metazd2tempozd2)=((obj_t)
((obj_t)BgL_metazd2tempo1105zd2_3479)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4246))->BgL_metazd2smtpezd2)=((obj_t)
((obj_t)BgL_metazd2smtpe1106zd2_3480)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4246))->BgL_metazd2timesigzd2)=((obj_t)
((obj_t)BgL_metazd2timesig1107zd2_3481)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4246))->BgL_metazd2keysigzd2)=((obj_t)
((obj_t)BgL_metazd2keysig1108zd2_3482)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1183z00_4246))->BgL_metazd2seqspeczd2)=((obj_t)
((obj_t)BgL_metazd2seqspec1109zd2_3483)),BUNSPEC); 
{ /* Llib/midi.scm 52 */
obj_t BgL_fun2276z00_4250;
BgL_fun2276z00_4250 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_midiplayerz00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun2276z00_4250)(BgL_fun2276z00_4250, 
((obj_t)BgL_new1183z00_4246), BEOA); } 
return BgL_new1183z00_4246;} } 

}



/* &<@anonymous:2478> */
obj_t BGl_z62zc3z04anonymousza32478ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3484)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2477 */
obj_t BGl_z62lambda2477z62zz__multimediazd2midizd2(obj_t BgL_envz00_3485, obj_t BgL_oz00_3486, obj_t BgL_vz00_3487)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3486)))->BgL_metazd2seqspeczd2)=((obj_t)
((obj_t)BgL_vz00_3487)),BUNSPEC);} 

}



/* &lambda2476 */
obj_t BGl_z62lambda2476z62zz__multimediazd2midizd2(obj_t BgL_envz00_3488, obj_t BgL_oz00_3489)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3489)))->BgL_metazd2seqspeczd2);} 

}



/* &<@anonymous:2471> */
obj_t BGl_z62zc3z04anonymousza32471ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3490)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2470 */
obj_t BGl_z62lambda2470z62zz__multimediazd2midizd2(obj_t BgL_envz00_3491, obj_t BgL_oz00_3492, obj_t BgL_vz00_3493)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3492)))->BgL_metazd2keysigzd2)=((obj_t)
((obj_t)BgL_vz00_3493)),BUNSPEC);} 

}



/* &lambda2469 */
obj_t BGl_z62lambda2469z62zz__multimediazd2midizd2(obj_t BgL_envz00_3494, obj_t BgL_oz00_3495)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3495)))->BgL_metazd2keysigzd2);} 

}



/* &<@anonymous:2463> */
obj_t BGl_z62zc3z04anonymousza32463ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3496)
{
{ /* Llib/midi.scm 52 */
return BGl_proc3265z00zz__multimediazd2midizd2;} 

}



/* &lambda2462 */
obj_t BGl_z62lambda2462z62zz__multimediazd2midizd2(obj_t BgL_envz00_3497, obj_t BgL_oz00_3498, obj_t BgL_vz00_3499)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3498)))->BgL_metazd2timesigzd2)=((obj_t)
((obj_t)BgL_vz00_3499)),BUNSPEC);} 

}



/* &lambda2461 */
obj_t BGl_z62lambda2461z62zz__multimediazd2midizd2(obj_t BgL_envz00_3500, obj_t BgL_oz00_3501)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3501)))->BgL_metazd2timesigzd2);} 

}



/* &<@anonymous:2464> */
obj_t BGl_z62zc3z04anonymousza32464ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3502, obj_t BgL_mpz00_3503, obj_t BgL_msz00_3504, obj_t BgL_tickz00_3505, obj_t BgL_nnz00_3506, obj_t BgL_ddz00_3507, obj_t BgL_ccz00_3508, obj_t BgL_bbz00_3509)
{
{ /* Llib/midi.scm 83 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:2455> */
obj_t BGl_z62zc3z04anonymousza32455ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3510)
{
{ /* Llib/midi.scm 52 */
return BGl_proc3266z00zz__multimediazd2midizd2;} 

}



/* &lambda2454 */
obj_t BGl_z62lambda2454z62zz__multimediazd2midizd2(obj_t BgL_envz00_3511, obj_t BgL_oz00_3512, obj_t BgL_vz00_3513)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3512)))->BgL_metazd2smtpezd2)=((obj_t)
((obj_t)BgL_vz00_3513)),BUNSPEC);} 

}



/* &lambda2453 */
obj_t BGl_z62lambda2453z62zz__multimediazd2midizd2(obj_t BgL_envz00_3514, obj_t BgL_oz00_3515)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3515)))->BgL_metazd2smtpezd2);} 

}



/* &<@anonymous:2456> */
obj_t BGl_z62zc3z04anonymousza32456ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3516, obj_t BgL_mpz00_3517, obj_t BgL_msz00_3518, obj_t BgL_tickz00_3519, obj_t BgL_hrz00_3520, obj_t BgL_mmz00_3521, obj_t BgL_sez00_3522, obj_t BgL_frz00_3523, obj_t BgL_ffz00_3524)
{
{ /* Llib/midi.scm 82 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:2448> */
obj_t BGl_z62zc3z04anonymousza32448ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3525)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2447 */
obj_t BGl_z62lambda2447z62zz__multimediazd2midizd2(obj_t BgL_envz00_3526, obj_t BgL_oz00_3527, obj_t BgL_vz00_3528)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3527)))->BgL_metazd2tempozd2)=((obj_t)
((obj_t)BgL_vz00_3528)),BUNSPEC);} 

}



/* &lambda2446 */
obj_t BGl_z62lambda2446z62zz__multimediazd2midizd2(obj_t BgL_envz00_3529, obj_t BgL_oz00_3530)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3530)))->BgL_metazd2tempozd2);} 

}



/* &<@anonymous:2441> */
obj_t BGl_z62zc3z04anonymousza32441ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3531)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2440 */
obj_t BGl_z62lambda2440z62zz__multimediazd2midizd2(obj_t BgL_envz00_3532, obj_t BgL_oz00_3533, obj_t BgL_vz00_3534)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3533)))->BgL_metazd2eotzd2)=((obj_t)
((obj_t)BgL_vz00_3534)),BUNSPEC);} 

}



/* &lambda2439 */
obj_t BGl_z62lambda2439z62zz__multimediazd2midizd2(obj_t BgL_envz00_3535, obj_t BgL_oz00_3536)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3536)))->BgL_metazd2eotzd2);} 

}



/* &<@anonymous:2434> */
obj_t BGl_z62zc3z04anonymousza32434ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3537)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2433 */
obj_t BGl_z62lambda2433z62zz__multimediazd2midizd2(obj_t BgL_envz00_3538, obj_t BgL_oz00_3539, obj_t BgL_vz00_3540)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3539)))->BgL_metazd2midiportzd2)=((obj_t)
((obj_t)BgL_vz00_3540)),BUNSPEC);} 

}



/* &lambda2432 */
obj_t BGl_z62lambda2432z62zz__multimediazd2midizd2(obj_t BgL_envz00_3541, obj_t BgL_oz00_3542)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3542)))->BgL_metazd2midiportzd2);} 

}



/* &<@anonymous:2427> */
obj_t BGl_z62zc3z04anonymousza32427ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3543)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2426 */
obj_t BGl_z62lambda2426z62zz__multimediazd2midizd2(obj_t BgL_envz00_3544, obj_t BgL_oz00_3545, obj_t BgL_vz00_3546)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3545)))->BgL_metazd2channprefzd2)=((obj_t)
((obj_t)BgL_vz00_3546)),BUNSPEC);} 

}



/* &lambda2425 */
obj_t BGl_z62lambda2425z62zz__multimediazd2midizd2(obj_t BgL_envz00_3547, obj_t BgL_oz00_3548)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3548)))->BgL_metazd2channprefzd2);} 

}



/* &<@anonymous:2420> */
obj_t BGl_z62zc3z04anonymousza32420ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3549)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2419 */
obj_t BGl_z62lambda2419z62zz__multimediazd2midizd2(obj_t BgL_envz00_3550, obj_t BgL_oz00_3551, obj_t BgL_vz00_3552)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3551)))->BgL_metazd2devnamezd2)=((obj_t)
((obj_t)BgL_vz00_3552)),BUNSPEC);} 

}



/* &lambda2418 */
obj_t BGl_z62lambda2418z62zz__multimediazd2midizd2(obj_t BgL_envz00_3553, obj_t BgL_oz00_3554)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3554)))->BgL_metazd2devnamezd2);} 

}



/* &<@anonymous:2413> */
obj_t BGl_z62zc3z04anonymousza32413ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3555)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2412 */
obj_t BGl_z62lambda2412z62zz__multimediazd2midizd2(obj_t BgL_envz00_3556, obj_t BgL_oz00_3557, obj_t BgL_vz00_3558)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3557)))->BgL_metazd2prgmnamezd2)=((obj_t)
((obj_t)BgL_vz00_3558)),BUNSPEC);} 

}



/* &lambda2411 */
obj_t BGl_z62lambda2411z62zz__multimediazd2midizd2(obj_t BgL_envz00_3559, obj_t BgL_oz00_3560)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3560)))->BgL_metazd2prgmnamezd2);} 

}



/* &<@anonymous:2406> */
obj_t BGl_z62zc3z04anonymousza32406ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3561)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2405 */
obj_t BGl_z62lambda2405z62zz__multimediazd2midizd2(obj_t BgL_envz00_3562, obj_t BgL_oz00_3563, obj_t BgL_vz00_3564)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3563)))->BgL_metazd2cuezd2)=((obj_t)
((obj_t)BgL_vz00_3564)),BUNSPEC);} 

}



/* &lambda2404 */
obj_t BGl_z62lambda2404z62zz__multimediazd2midizd2(obj_t BgL_envz00_3565, obj_t BgL_oz00_3566)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3566)))->BgL_metazd2cuezd2);} 

}



/* &<@anonymous:2399> */
obj_t BGl_z62zc3z04anonymousza32399ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3567)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2398 */
obj_t BGl_z62lambda2398z62zz__multimediazd2midizd2(obj_t BgL_envz00_3568, obj_t BgL_oz00_3569, obj_t BgL_vz00_3570)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3569)))->BgL_metazd2markerzd2)=((obj_t)
((obj_t)BgL_vz00_3570)),BUNSPEC);} 

}



/* &lambda2397 */
obj_t BGl_z62lambda2397z62zz__multimediazd2midizd2(obj_t BgL_envz00_3571, obj_t BgL_oz00_3572)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3572)))->BgL_metazd2markerzd2);} 

}



/* &<@anonymous:2392> */
obj_t BGl_z62zc3z04anonymousza32392ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3573)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2391 */
obj_t BGl_z62lambda2391z62zz__multimediazd2midizd2(obj_t BgL_envz00_3574, obj_t BgL_oz00_3575, obj_t BgL_vz00_3576)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3575)))->BgL_metazd2lyriczd2)=((obj_t)
((obj_t)BgL_vz00_3576)),BUNSPEC);} 

}



/* &lambda2390 */
obj_t BGl_z62lambda2390z62zz__multimediazd2midizd2(obj_t BgL_envz00_3577, obj_t BgL_oz00_3578)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3578)))->BgL_metazd2lyriczd2);} 

}



/* &<@anonymous:2385> */
obj_t BGl_z62zc3z04anonymousza32385ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3579)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2384 */
obj_t BGl_z62lambda2384z62zz__multimediazd2midizd2(obj_t BgL_envz00_3580, obj_t BgL_oz00_3581, obj_t BgL_vz00_3582)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3581)))->BgL_metazd2instrumentzd2)=((obj_t)
((obj_t)BgL_vz00_3582)),BUNSPEC);} 

}



/* &lambda2383 */
obj_t BGl_z62lambda2383z62zz__multimediazd2midizd2(obj_t BgL_envz00_3583, obj_t BgL_oz00_3584)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3584)))->BgL_metazd2instrumentzd2);} 

}



/* &<@anonymous:2378> */
obj_t BGl_z62zc3z04anonymousza32378ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3585)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2377 */
obj_t BGl_z62lambda2377z62zz__multimediazd2midizd2(obj_t BgL_envz00_3586, obj_t BgL_oz00_3587, obj_t BgL_vz00_3588)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3587)))->BgL_metazd2trackzd2)=((obj_t)
((obj_t)BgL_vz00_3588)),BUNSPEC);} 

}



/* &lambda2376 */
obj_t BGl_z62lambda2376z62zz__multimediazd2midizd2(obj_t BgL_envz00_3589, obj_t BgL_oz00_3590)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3590)))->BgL_metazd2trackzd2);} 

}



/* &<@anonymous:2371> */
obj_t BGl_z62zc3z04anonymousza32371ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3591)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2370 */
obj_t BGl_z62lambda2370z62zz__multimediazd2midizd2(obj_t BgL_envz00_3592, obj_t BgL_oz00_3593, obj_t BgL_vz00_3594)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3593)))->BgL_metazd2copyrightzd2)=((obj_t)
((obj_t)BgL_vz00_3594)),BUNSPEC);} 

}



/* &lambda2369 */
obj_t BGl_z62lambda2369z62zz__multimediazd2midizd2(obj_t BgL_envz00_3595, obj_t BgL_oz00_3596)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3596)))->BgL_metazd2copyrightzd2);} 

}



/* &<@anonymous:2364> */
obj_t BGl_z62zc3z04anonymousza32364ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3597)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2363 */
obj_t BGl_z62lambda2363z62zz__multimediazd2midizd2(obj_t BgL_envz00_3598, obj_t BgL_oz00_3599, obj_t BgL_vz00_3600)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3599)))->BgL_metazd2textzd2)=((obj_t)
((obj_t)BgL_vz00_3600)),BUNSPEC);} 

}



/* &lambda2362 */
obj_t BGl_z62lambda2362z62zz__multimediazd2midizd2(obj_t BgL_envz00_3601, obj_t BgL_oz00_3602)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3602)))->BgL_metazd2textzd2);} 

}



/* &<@anonymous:2357> */
obj_t BGl_z62zc3z04anonymousza32357ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3603)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2356 */
obj_t BGl_z62lambda2356z62zz__multimediazd2midizd2(obj_t BgL_envz00_3604, obj_t BgL_oz00_3605, obj_t BgL_vz00_3606)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3605)))->BgL_metazd2seqnumzd2)=((obj_t)
((obj_t)BgL_vz00_3606)),BUNSPEC);} 

}



/* &lambda2355 */
obj_t BGl_z62lambda2355z62zz__multimediazd2midizd2(obj_t BgL_envz00_3607, obj_t BgL_oz00_3608)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3608)))->BgL_metazd2seqnumzd2);} 

}



/* &<@anonymous:2350> */
obj_t BGl_z62zc3z04anonymousza32350ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3609)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2sysexzd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2349 */
obj_t BGl_z62lambda2349z62zz__multimediazd2midizd2(obj_t BgL_envz00_3610, obj_t BgL_oz00_3611, obj_t BgL_vz00_3612)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3611)))->BgL_sysexz00)=((obj_t)
((obj_t)BgL_vz00_3612)),BUNSPEC);} 

}



/* &lambda2348 */
obj_t BGl_z62lambda2348z62zz__multimediazd2midizd2(obj_t BgL_envz00_3613, obj_t BgL_oz00_3614)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3614)))->BgL_sysexz00);} 

}



/* &<@anonymous:2343> */
obj_t BGl_z62zc3z04anonymousza32343ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3615)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2pitchzd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2342 */
obj_t BGl_z62lambda2342z62zz__multimediazd2midizd2(obj_t BgL_envz00_3616, obj_t BgL_oz00_3617, obj_t BgL_vz00_3618)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3617)))->BgL_pitchz00)=((obj_t)
((obj_t)BgL_vz00_3618)),BUNSPEC);} 

}



/* &lambda2341 */
obj_t BGl_z62lambda2341z62zz__multimediazd2midizd2(obj_t BgL_envz00_3619, obj_t BgL_oz00_3620)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3620)))->BgL_pitchz00);} 

}



/* &<@anonymous:2336> */
obj_t BGl_z62zc3z04anonymousza32336ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3621)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2afterzd2touchzd2envzd2zz__multimediazd2midizd2;} 

}



/* &lambda2335 */
obj_t BGl_z62lambda2335z62zz__multimediazd2midizd2(obj_t BgL_envz00_3622, obj_t BgL_oz00_3623, obj_t BgL_vz00_3624)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3623)))->BgL_afterzd2touchzd2)=((obj_t)
((obj_t)BgL_vz00_3624)),BUNSPEC);} 

}



/* &lambda2334 */
obj_t BGl_z62lambda2334z62zz__multimediazd2midizd2(obj_t BgL_envz00_3625, obj_t BgL_oz00_3626)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3626)))->BgL_afterzd2touchzd2);} 

}



/* &<@anonymous:2329> */
obj_t BGl_z62zc3z04anonymousza32329ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3627)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2prgmchangezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2328 */
obj_t BGl_z62lambda2328z62zz__multimediazd2midizd2(obj_t BgL_envz00_3628, obj_t BgL_oz00_3629, obj_t BgL_vz00_3630)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3629)))->BgL_prgmchangez00)=((obj_t)
((obj_t)BgL_vz00_3630)),BUNSPEC);} 

}



/* &lambda2327 */
obj_t BGl_z62lambda2327z62zz__multimediazd2midizd2(obj_t BgL_envz00_3631, obj_t BgL_oz00_3632)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3632)))->BgL_prgmchangez00);} 

}



/* &<@anonymous:2322> */
obj_t BGl_z62zc3z04anonymousza32322ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3633)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ctrlchangezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2321 */
obj_t BGl_z62lambda2321z62zz__multimediazd2midizd2(obj_t BgL_envz00_3634, obj_t BgL_oz00_3635, obj_t BgL_vz00_3636)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3635)))->BgL_ctrlchangez00)=((obj_t)
((obj_t)BgL_vz00_3636)),BUNSPEC);} 

}



/* &lambda2320 */
obj_t BGl_z62lambda2320z62zz__multimediazd2midizd2(obj_t BgL_envz00_3637, obj_t BgL_oz00_3638)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3638)))->BgL_ctrlchangez00);} 

}



/* &<@anonymous:2315> */
obj_t BGl_z62zc3z04anonymousza32315ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3639)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2aftertouchzd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2314 */
obj_t BGl_z62lambda2314z62zz__multimediazd2midizd2(obj_t BgL_envz00_3640, obj_t BgL_oz00_3641, obj_t BgL_vz00_3642)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3641)))->BgL_aftertouchz00)=((obj_t)
((obj_t)BgL_vz00_3642)),BUNSPEC);} 

}



/* &lambda2313 */
obj_t BGl_z62lambda2313z62zz__multimediazd2midizd2(obj_t BgL_envz00_3643, obj_t BgL_oz00_3644)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3644)))->BgL_aftertouchz00);} 

}



/* &<@anonymous:2308> */
obj_t BGl_z62zc3z04anonymousza32308ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3645)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2noteonzd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2307 */
obj_t BGl_z62lambda2307z62zz__multimediazd2midizd2(obj_t BgL_envz00_3646, obj_t BgL_oz00_3647, obj_t BgL_vz00_3648)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3647)))->BgL_noteonz00)=((obj_t)
((obj_t)BgL_vz00_3648)),BUNSPEC);} 

}



/* &lambda2306 */
obj_t BGl_z62lambda2306z62zz__multimediazd2midizd2(obj_t BgL_envz00_3649, obj_t BgL_oz00_3650)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3650)))->BgL_noteonz00);} 

}



/* &<@anonymous:2301> */
obj_t BGl_z62zc3z04anonymousza32301ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3651)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2noteoffzd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2300 */
obj_t BGl_z62lambda2300z62zz__multimediazd2midizd2(obj_t BgL_envz00_3652, obj_t BgL_oz00_3653, obj_t BgL_vz00_3654)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3653)))->BgL_noteoffz00)=((obj_t)
((obj_t)BgL_vz00_3654)),BUNSPEC);} 

}



/* &lambda2299 */
obj_t BGl_z62lambda2299z62zz__multimediazd2midizd2(obj_t BgL_envz00_3655, obj_t BgL_oz00_3656)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3656)))->BgL_noteoffz00);} 

}



/* &<@anonymous:2294> */
obj_t BGl_z62zc3z04anonymousza32294ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3657)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2cdelayzd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2293 */
obj_t BGl_z62lambda2293z62zz__multimediazd2midizd2(obj_t BgL_envz00_3658, obj_t BgL_oz00_3659, obj_t BgL_vz00_3660)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3659)))->BgL_cdelayz00)=((obj_t)
((obj_t)BgL_vz00_3660)),BUNSPEC);} 

}



/* &lambda2292 */
obj_t BGl_z62lambda2292z62zz__multimediazd2midizd2(obj_t BgL_envz00_3661, obj_t BgL_oz00_3662)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3662)))->BgL_cdelayz00);} 

}



/* &<@anonymous:2287> */
obj_t BGl_z62zc3z04anonymousza32287ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3663)
{
{ /* Llib/midi.scm 52 */
return BGl_errorzd2envzd2zz__errorz00;} 

}



/* &lambda2286 */
obj_t BGl_z62lambda2286z62zz__multimediazd2midizd2(obj_t BgL_envz00_3664, obj_t BgL_oz00_3665, obj_t BgL_vz00_3666)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3665)))->BgL_errz00)=((obj_t)
((obj_t)BgL_vz00_3666)),BUNSPEC);} 

}



/* &lambda2285 */
obj_t BGl_z62lambda2285z62zz__multimediazd2midizd2(obj_t BgL_envz00_3667, obj_t BgL_oz00_3668)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3668)))->BgL_errz00);} 

}



/* &<@anonymous:2234> */
obj_t BGl_z62zc3z04anonymousza32234ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3669, obj_t BgL_new1080z00_3670)
{
{ /* Llib/midi.scm 42 */
{ 
BgL_midireaderz00_bglt BgL_auxz00_7736;
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_new1080z00_3670)))->BgL_peekzd2bytezd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_new1080z00_3670)))->BgL_readzd2bytezd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_new1080z00_3670)))->BgL_readzd2int16zd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_new1080z00_3670)))->BgL_readzd2int32zd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_new1080z00_3670)))->BgL_readzd2intzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_new1080z00_3670)))->BgL_readzd2vlqzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_new1080z00_3670)))->BgL_readzd2charszd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
BgL_auxz00_7736 = 
((BgL_midireaderz00_bglt)BgL_new1080z00_3670); 
return 
((obj_t)BgL_auxz00_7736);} } 

}



/* &lambda2232 */
BgL_midireaderz00_bglt BGl_z62lambda2232z62zz__multimediazd2midizd2(obj_t BgL_envz00_3671)
{
{ /* Llib/midi.scm 42 */
{ /* Llib/midi.scm 42 */
BgL_midireaderz00_bglt BgL_new1079z00_4336;
BgL_new1079z00_4336 = 
((BgL_midireaderz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midireaderz00_bgl) ))); 
{ /* Llib/midi.scm 42 */
long BgL_arg2233z00_4337;
{ /* Llib/midi.scm 42 */
long BgL_res2779z00_4338;
BgL_res2779z00_4338 = 
BGL_CLASS_INDEX(BGl_midireaderz00zz__multimediazd2midizd2); 
BgL_arg2233z00_4337 = BgL_res2779z00_4338; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1079z00_4336), BgL_arg2233z00_4337); } 
return BgL_new1079z00_4336;} } 

}



/* &lambda2229 */
BgL_midireaderz00_bglt BGl_z62lambda2229z62zz__multimediazd2midizd2(obj_t BgL_envz00_3672, obj_t BgL_peekzd2byte1072zd2_3673, obj_t BgL_readzd2byte1073zd2_3674, obj_t BgL_readzd2int161074zd2_3675, obj_t BgL_readzd2int321075zd2_3676, obj_t BgL_readzd2int1076zd2_3677, obj_t BgL_readzd2vlq1077zd2_3678, obj_t BgL_readzd2chars1078zd2_3679)
{
{ /* Llib/midi.scm 42 */
{ /* Llib/midi.scm 42 */
BgL_midireaderz00_bglt BgL_new1181z00_4346;
{ /* Llib/midi.scm 42 */
BgL_midireaderz00_bglt BgL_new1180z00_4347;
BgL_new1180z00_4347 = 
((BgL_midireaderz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midireaderz00_bgl) ))); 
{ /* Llib/midi.scm 42 */
long BgL_arg2231z00_4348;
{ /* Llib/midi.scm 42 */
long BgL_res2778z00_4349;
BgL_res2778z00_4349 = 
BGL_CLASS_INDEX(BGl_midireaderz00zz__multimediazd2midizd2); 
BgL_arg2231z00_4348 = BgL_res2778z00_4349; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1180z00_4347), BgL_arg2231z00_4348); } 
BgL_new1181z00_4346 = BgL_new1180z00_4347; } 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1181z00_4346))->BgL_peekzd2bytezd2)=((obj_t)
((obj_t)BgL_peekzd2byte1072zd2_3673)),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1181z00_4346))->BgL_readzd2bytezd2)=((obj_t)
((obj_t)BgL_readzd2byte1073zd2_3674)),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1181z00_4346))->BgL_readzd2int16zd2)=((obj_t)
((obj_t)BgL_readzd2int161074zd2_3675)),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1181z00_4346))->BgL_readzd2int32zd2)=((obj_t)
((obj_t)BgL_readzd2int321075zd2_3676)),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1181z00_4346))->BgL_readzd2intzd2)=((obj_t)
((obj_t)BgL_readzd2int1076zd2_3677)),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1181z00_4346))->BgL_readzd2vlqzd2)=((obj_t)
((obj_t)BgL_readzd2vlq1077zd2_3678)),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1181z00_4346))->BgL_readzd2charszd2)=((obj_t)
((obj_t)BgL_readzd2chars1078zd2_3679)),BUNSPEC); 
{ /* Llib/midi.scm 42 */
obj_t BgL_fun2230z00_4350;
BgL_fun2230z00_4350 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_midireaderz00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun2230z00_4350)(BgL_fun2230z00_4350, 
((obj_t)BgL_new1181z00_4346), BEOA); } 
return BgL_new1181z00_4346;} } 

}



/* &lambda2269 */
obj_t BGl_z62lambda2269z62zz__multimediazd2midizd2(obj_t BgL_envz00_3680, obj_t BgL_oz00_3681, obj_t BgL_vz00_3682)
{
{ /* Llib/midi.scm 42 */
return 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3681)))->BgL_readzd2charszd2)=((obj_t)
((obj_t)BgL_vz00_3682)),BUNSPEC);} 

}



/* &lambda2268 */
obj_t BGl_z62lambda2268z62zz__multimediazd2midizd2(obj_t BgL_envz00_3683, obj_t BgL_oz00_3684)
{
{ /* Llib/midi.scm 42 */
return 
(((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3684)))->BgL_readzd2charszd2);} 

}



/* &lambda2264 */
obj_t BGl_z62lambda2264z62zz__multimediazd2midizd2(obj_t BgL_envz00_3685, obj_t BgL_oz00_3686, obj_t BgL_vz00_3687)
{
{ /* Llib/midi.scm 42 */
return 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3686)))->BgL_readzd2vlqzd2)=((obj_t)
((obj_t)BgL_vz00_3687)),BUNSPEC);} 

}



/* &lambda2263 */
obj_t BGl_z62lambda2263z62zz__multimediazd2midizd2(obj_t BgL_envz00_3688, obj_t BgL_oz00_3689)
{
{ /* Llib/midi.scm 42 */
return 
(((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3689)))->BgL_readzd2vlqzd2);} 

}



/* &lambda2259 */
obj_t BGl_z62lambda2259z62zz__multimediazd2midizd2(obj_t BgL_envz00_3690, obj_t BgL_oz00_3691, obj_t BgL_vz00_3692)
{
{ /* Llib/midi.scm 42 */
return 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3691)))->BgL_readzd2intzd2)=((obj_t)
((obj_t)BgL_vz00_3692)),BUNSPEC);} 

}



/* &lambda2258 */
obj_t BGl_z62lambda2258z62zz__multimediazd2midizd2(obj_t BgL_envz00_3693, obj_t BgL_oz00_3694)
{
{ /* Llib/midi.scm 42 */
return 
(((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3694)))->BgL_readzd2intzd2);} 

}



/* &lambda2254 */
obj_t BGl_z62lambda2254z62zz__multimediazd2midizd2(obj_t BgL_envz00_3695, obj_t BgL_oz00_3696, obj_t BgL_vz00_3697)
{
{ /* Llib/midi.scm 42 */
return 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3696)))->BgL_readzd2int32zd2)=((obj_t)
((obj_t)BgL_vz00_3697)),BUNSPEC);} 

}



/* &lambda2253 */
obj_t BGl_z62lambda2253z62zz__multimediazd2midizd2(obj_t BgL_envz00_3698, obj_t BgL_oz00_3699)
{
{ /* Llib/midi.scm 42 */
return 
(((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3699)))->BgL_readzd2int32zd2);} 

}



/* &lambda2249 */
obj_t BGl_z62lambda2249z62zz__multimediazd2midizd2(obj_t BgL_envz00_3700, obj_t BgL_oz00_3701, obj_t BgL_vz00_3702)
{
{ /* Llib/midi.scm 42 */
return 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3701)))->BgL_readzd2int16zd2)=((obj_t)
((obj_t)BgL_vz00_3702)),BUNSPEC);} 

}



/* &lambda2248 */
obj_t BGl_z62lambda2248z62zz__multimediazd2midizd2(obj_t BgL_envz00_3703, obj_t BgL_oz00_3704)
{
{ /* Llib/midi.scm 42 */
return 
(((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3704)))->BgL_readzd2int16zd2);} 

}



/* &lambda2244 */
obj_t BGl_z62lambda2244z62zz__multimediazd2midizd2(obj_t BgL_envz00_3705, obj_t BgL_oz00_3706, obj_t BgL_vz00_3707)
{
{ /* Llib/midi.scm 42 */
return 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3706)))->BgL_readzd2bytezd2)=((obj_t)
((obj_t)BgL_vz00_3707)),BUNSPEC);} 

}



/* &lambda2243 */
obj_t BGl_z62lambda2243z62zz__multimediazd2midizd2(obj_t BgL_envz00_3708, obj_t BgL_oz00_3709)
{
{ /* Llib/midi.scm 42 */
return 
(((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3709)))->BgL_readzd2bytezd2);} 

}



/* &lambda2239 */
obj_t BGl_z62lambda2239z62zz__multimediazd2midizd2(obj_t BgL_envz00_3710, obj_t BgL_oz00_3711, obj_t BgL_vz00_3712)
{
{ /* Llib/midi.scm 42 */
return 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3711)))->BgL_peekzd2bytezd2)=((obj_t)
((obj_t)BgL_vz00_3712)),BUNSPEC);} 

}



/* &lambda2238 */
obj_t BGl_z62lambda2238z62zz__multimediazd2midizd2(obj_t BgL_envz00_3713, obj_t BgL_oz00_3714)
{
{ /* Llib/midi.scm 42 */
return 
(((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3714)))->BgL_peekzd2bytezd2);} 

}



/* &<@anonymous:2129> */
obj_t BGl_z62zc3z04anonymousza32129ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3715, obj_t BgL_new1070z00_3716)
{
{ /* Llib/midi.scm 24 */
{ 
BgL_miditrackz00_bglt BgL_auxz00_7816;
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1070z00_3716)))->BgL_z52streamz52)=((obj_t)BUNSPEC),BUNSPEC); 
{ 
BgL_midireaderz00_bglt BgL_auxz00_7819;
{ /* Llib/midi.scm 24 */
obj_t BgL_classz00_4373;
BgL_classz00_4373 = BGl_midireaderz00zz__multimediazd2midizd2; 
{ /* Llib/midi.scm 24 */
obj_t BgL__ortest_1107z00_4374;
BgL__ortest_1107z00_4374 = 
BGL_CLASS_NIL(BgL_classz00_4373); 
if(
CBOOL(BgL__ortest_1107z00_4374))
{ /* Llib/midi.scm 24 */
BgL_auxz00_7819 = 
((BgL_midireaderz00_bglt)BgL__ortest_1107z00_4374)
; }  else 
{ /* Llib/midi.scm 24 */
BgL_auxz00_7819 = 
((BgL_midireaderz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4373))
; } } } 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1070z00_3716)))->BgL_z52readerz52)=((BgL_midireaderz00_bglt)BgL_auxz00_7819),BUNSPEC); } 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1070z00_3716)))->BgL_z52closez52)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1070z00_3716)))->BgL_z52eotz52)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1070z00_3716)))->BgL_z52wtickz52)=((uint32_t)
0L),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1070z00_3716)))->BgL_z52statusz52)=((long)((long)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1070z00_3716)))->BgL_lenz00)=((int32_t)
0L),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1070z00_3716)))->BgL_tempoz00)=((long)((long)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1070z00_3716)))->BgL_ipz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1070z00_3716)))->BgL_startz00)=((long)((long)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1070z00_3716)))->BgL_datastartz00)=((long)((long)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1070z00_3716)))->BgL_wtickz00)=((uint32_t)
0L),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1070z00_3716)))->BgL_statusz00)=((long)((long)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1070z00_3716)))->BgL_eotz00)=((bool_t)((bool_t)0)),BUNSPEC); 
BgL_auxz00_7816 = 
((BgL_miditrackz00_bglt)BgL_new1070z00_3716); 
return 
((obj_t)BgL_auxz00_7816);} } 

}



/* &lambda2127 */
BgL_miditrackz00_bglt BGl_z62lambda2127z62zz__multimediazd2midizd2(obj_t BgL_envz00_3717)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
BgL_miditrackz00_bglt BgL_new1069z00_4375;
BgL_new1069z00_4375 = 
((BgL_miditrackz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_miditrackz00_bgl) ))); 
{ /* Llib/midi.scm 24 */
long BgL_arg2128z00_4376;
{ /* Llib/midi.scm 24 */
long BgL_res2777z00_4377;
BgL_res2777z00_4377 = 
BGL_CLASS_INDEX(BGl_miditrackz00zz__multimediazd2midizd2); 
BgL_arg2128z00_4376 = BgL_res2777z00_4377; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1069z00_4375), BgL_arg2128z00_4376); } 
return BgL_new1069z00_4375;} } 

}



/* &lambda2124 */
BgL_miditrackz00_bglt BGl_z62lambda2124z62zz__multimediazd2midizd2(obj_t BgL_envz00_3718, obj_t BgL_z52stream1055z52_3719, obj_t BgL_z52reader1056z52_3720, obj_t BgL_z52close1057z52_3721, obj_t BgL_z52eot1058z52_3722, obj_t BgL_z52wtick1059z52_3723, obj_t BgL_z52status1060z52_3724, obj_t BgL_len1061z00_3725, obj_t BgL_tempo1062z00_3726, obj_t BgL_ip1063z00_3727, obj_t BgL_start1064z00_3728, obj_t BgL_datastart1065z00_3729, obj_t BgL_wtick1066z00_3730, obj_t BgL_status1067z00_3731, obj_t BgL_eot1068z00_3732)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
bool_t BgL_z52eot1058z52_4380;uint32_t BgL_z52wtick1059z52_4381;long BgL_z52status1060z52_4382;int32_t BgL_len1061z00_4383;long BgL_tempo1062z00_4384;long BgL_start1064z00_4385;long BgL_datastart1065z00_4386;uint32_t BgL_wtick1066z00_4387;long BgL_status1067z00_4388;bool_t BgL_eot1068z00_4389;
BgL_z52eot1058z52_4380 = 
CBOOL(BgL_z52eot1058z52_3722); 
BgL_z52wtick1059z52_4381 = 
BGL_BUINT32_TO_UINT32(BgL_z52wtick1059z52_3723); 
BgL_z52status1060z52_4382 = 
(long)CINT(BgL_z52status1060z52_3724); 
BgL_len1061z00_4383 = 
BGL_BINT32_TO_INT32(BgL_len1061z00_3725); 
BgL_tempo1062z00_4384 = 
(long)CINT(BgL_tempo1062z00_3726); 
BgL_start1064z00_4385 = 
(long)CINT(BgL_start1064z00_3728); 
BgL_datastart1065z00_4386 = 
(long)CINT(BgL_datastart1065z00_3729); 
BgL_wtick1066z00_4387 = 
BGL_BUINT32_TO_UINT32(BgL_wtick1066z00_3730); 
BgL_status1067z00_4388 = 
(long)CINT(BgL_status1067z00_3731); 
BgL_eot1068z00_4389 = 
CBOOL(BgL_eot1068z00_3732); 
{ /* Llib/midi.scm 24 */
BgL_miditrackz00_bglt BgL_new1179z00_4390;
{ /* Llib/midi.scm 24 */
BgL_miditrackz00_bglt BgL_new1178z00_4391;
BgL_new1178z00_4391 = 
((BgL_miditrackz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_miditrackz00_bgl) ))); 
{ /* Llib/midi.scm 24 */
long BgL_arg2126z00_4392;
{ /* Llib/midi.scm 24 */
long BgL_res2776z00_4393;
BgL_res2776z00_4393 = 
BGL_CLASS_INDEX(BGl_miditrackz00zz__multimediazd2midizd2); 
BgL_arg2126z00_4392 = BgL_res2776z00_4393; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1178z00_4391), BgL_arg2126z00_4392); } 
BgL_new1179z00_4390 = BgL_new1178z00_4391; } 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1179z00_4390))->BgL_z52streamz52)=((obj_t)BgL_z52stream1055z52_3719),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1179z00_4390))->BgL_z52readerz52)=((BgL_midireaderz00_bglt)
((BgL_midireaderz00_bglt)BgL_z52reader1056z52_3720)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1179z00_4390))->BgL_z52closez52)=((obj_t)
((obj_t)BgL_z52close1057z52_3721)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1179z00_4390))->BgL_z52eotz52)=((bool_t)BgL_z52eot1058z52_4380),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1179z00_4390))->BgL_z52wtickz52)=((uint32_t)BgL_z52wtick1059z52_4381),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1179z00_4390))->BgL_z52statusz52)=((long)BgL_z52status1060z52_4382),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1179z00_4390))->BgL_lenz00)=((int32_t)BgL_len1061z00_4383),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1179z00_4390))->BgL_tempoz00)=((long)BgL_tempo1062z00_4384),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1179z00_4390))->BgL_ipz00)=((obj_t)BgL_ip1063z00_3727),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1179z00_4390))->BgL_startz00)=((long)BgL_start1064z00_4385),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1179z00_4390))->BgL_datastartz00)=((long)BgL_datastart1065z00_4386),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1179z00_4390))->BgL_wtickz00)=((uint32_t)BgL_wtick1066z00_4387),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1179z00_4390))->BgL_statusz00)=((long)BgL_status1067z00_4388),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1179z00_4390))->BgL_eotz00)=((bool_t)BgL_eot1068z00_4389),BUNSPEC); 
{ /* Llib/midi.scm 24 */
obj_t BgL_fun2125z00_4394;
BgL_fun2125z00_4394 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_miditrackz00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun2125z00_4394)(BgL_fun2125z00_4394, 
((obj_t)BgL_new1179z00_4390), BEOA); } 
return BgL_new1179z00_4390;} } } 

}



/* &<@anonymous:2223> */
obj_t BGl_z62zc3z04anonymousza32223ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3733)
{
{ /* Llib/midi.scm 24 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda2222 */
obj_t BGl_z62lambda2222z62zz__multimediazd2midizd2(obj_t BgL_envz00_3734, obj_t BgL_oz00_3735, obj_t BgL_vz00_3736)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
bool_t BgL_vz00_4396;
BgL_vz00_4396 = 
CBOOL(BgL_vz00_3736); 
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3735)))->BgL_eotz00)=((bool_t)BgL_vz00_4396),BUNSPEC);} } 

}



/* &lambda2221 */
obj_t BGl_z62lambda2221z62zz__multimediazd2midizd2(obj_t BgL_envz00_3737, obj_t BgL_oz00_3738)
{
{ /* Llib/midi.scm 24 */
return 
BBOOL(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3738)))->BgL_eotz00));} 

}



/* &<@anonymous:2216> */
obj_t BGl_z62zc3z04anonymousza32216ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3739)
{
{ /* Llib/midi.scm 24 */
return 
BINT(((long)-1));} 

}



/* &lambda2215 */
obj_t BGl_z62lambda2215z62zz__multimediazd2midizd2(obj_t BgL_envz00_3740, obj_t BgL_oz00_3741, obj_t BgL_vz00_3742)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
long BgL_vz00_4399;
BgL_vz00_4399 = 
(long)CINT(BgL_vz00_3742); 
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3741)))->BgL_statusz00)=((long)BgL_vz00_4399),BUNSPEC);} } 

}



/* &lambda2214 */
obj_t BGl_z62lambda2214z62zz__multimediazd2midizd2(obj_t BgL_envz00_3743, obj_t BgL_oz00_3744)
{
{ /* Llib/midi.scm 24 */
return 
BINT(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3744)))->BgL_statusz00));} 

}



/* &<@anonymous:2209> */
obj_t BGl_z62zc3z04anonymousza32209ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3745)
{
{ /* Llib/midi.scm 24 */
return 
BGL_UINT32_TO_BUINT32((uint32_t)(0));} 

}



/* &lambda2208 */
obj_t BGl_z62lambda2208z62zz__multimediazd2midizd2(obj_t BgL_envz00_3746, obj_t BgL_oz00_3747, obj_t BgL_vz00_3748)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
uint32_t BgL_vz00_4402;
BgL_vz00_4402 = 
BGL_BUINT32_TO_UINT32(BgL_vz00_3748); 
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3747)))->BgL_wtickz00)=((uint32_t)BgL_vz00_4402),BUNSPEC);} } 

}



/* &lambda2207 */
obj_t BGl_z62lambda2207z62zz__multimediazd2midizd2(obj_t BgL_envz00_3749, obj_t BgL_oz00_3750)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
uint32_t BgL_tmpz00_7915;
BgL_tmpz00_7915 = 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3750)))->BgL_wtickz00); 
return 
BGL_UINT32_TO_BUINT32(BgL_tmpz00_7915);} } 

}



/* &<@anonymous:2202> */
obj_t BGl_z62zc3z04anonymousza32202ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3751)
{
{ /* Llib/midi.scm 24 */
return 
BINT(((long)0));} 

}



/* &lambda2201 */
obj_t BGl_z62lambda2201z62zz__multimediazd2midizd2(obj_t BgL_envz00_3752, obj_t BgL_oz00_3753, obj_t BgL_vz00_3754)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
long BgL_vz00_4405;
BgL_vz00_4405 = 
(long)CINT(BgL_vz00_3754); 
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3753)))->BgL_datastartz00)=((long)BgL_vz00_4405),BUNSPEC);} } 

}



/* &lambda2200 */
obj_t BGl_z62lambda2200z62zz__multimediazd2midizd2(obj_t BgL_envz00_3755, obj_t BgL_oz00_3756)
{
{ /* Llib/midi.scm 24 */
return 
BINT(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3756)))->BgL_datastartz00));} 

}



/* &<@anonymous:2195> */
obj_t BGl_z62zc3z04anonymousza32195ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3757)
{
{ /* Llib/midi.scm 24 */
return 
BINT(((long)0));} 

}



/* &lambda2194 */
obj_t BGl_z62lambda2194z62zz__multimediazd2midizd2(obj_t BgL_envz00_3758, obj_t BgL_oz00_3759, obj_t BgL_vz00_3760)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
long BgL_vz00_4408;
BgL_vz00_4408 = 
(long)CINT(BgL_vz00_3760); 
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3759)))->BgL_startz00)=((long)BgL_vz00_4408),BUNSPEC);} } 

}



/* &lambda2193 */
obj_t BGl_z62lambda2193z62zz__multimediazd2midizd2(obj_t BgL_envz00_3761, obj_t BgL_oz00_3762)
{
{ /* Llib/midi.scm 24 */
return 
BINT(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3762)))->BgL_startz00));} 

}



/* &<@anonymous:2188> */
obj_t BGl_z62zc3z04anonymousza32188ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3763)
{
{ /* Llib/midi.scm 24 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda2187 */
obj_t BGl_z62lambda2187z62zz__multimediazd2midizd2(obj_t BgL_envz00_3764, obj_t BgL_oz00_3765, obj_t BgL_vz00_3766)
{
{ /* Llib/midi.scm 24 */
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3765)))->BgL_ipz00)=((obj_t)BgL_vz00_3766),BUNSPEC);} 

}



/* &lambda2186 */
obj_t BGl_z62lambda2186z62zz__multimediazd2midizd2(obj_t BgL_envz00_3767, obj_t BgL_oz00_3768)
{
{ /* Llib/midi.scm 24 */
return 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3768)))->BgL_ipz00);} 

}



/* &<@anonymous:2181> */
obj_t BGl_z62zc3z04anonymousza32181ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3769)
{
{ /* Llib/midi.scm 24 */
return 
BINT(((long)500000));} 

}



/* &lambda2180 */
obj_t BGl_z62lambda2180z62zz__multimediazd2midizd2(obj_t BgL_envz00_3770, obj_t BgL_oz00_3771, obj_t BgL_vz00_3772)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
long BgL_vz00_4413;
BgL_vz00_4413 = 
(long)CINT(BgL_vz00_3772); 
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3771)))->BgL_tempoz00)=((long)BgL_vz00_4413),BUNSPEC);} } 

}



/* &lambda2179 */
obj_t BGl_z62lambda2179z62zz__multimediazd2midizd2(obj_t BgL_envz00_3773, obj_t BgL_oz00_3774)
{
{ /* Llib/midi.scm 24 */
return 
BINT(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3774)))->BgL_tempoz00));} 

}



/* &<@anonymous:2174> */
obj_t BGl_z62zc3z04anonymousza32174ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3775)
{
{ /* Llib/midi.scm 24 */
return 
BINT(((long)0));} 

}



/* &lambda2173 */
obj_t BGl_z62lambda2173z62zz__multimediazd2midizd2(obj_t BgL_envz00_3776, obj_t BgL_oz00_3777, obj_t BgL_vz00_3778)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
int32_t BgL_vz00_4416;
BgL_vz00_4416 = 
BGL_BINT32_TO_INT32(BgL_vz00_3778); 
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3777)))->BgL_lenz00)=((int32_t)BgL_vz00_4416),BUNSPEC);} } 

}



/* &lambda2172 */
obj_t BGl_z62lambda2172z62zz__multimediazd2midizd2(obj_t BgL_envz00_3779, obj_t BgL_oz00_3780)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
int32_t BgL_tmpz00_7949;
BgL_tmpz00_7949 = 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3780)))->BgL_lenz00); 
return 
BGL_INT32_TO_BINT32(BgL_tmpz00_7949);} } 

}



/* &<@anonymous:2167> */
obj_t BGl_z62zc3z04anonymousza32167ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3781)
{
{ /* Llib/midi.scm 24 */
return 
BINT(((long)0));} 

}



/* &lambda2166 */
obj_t BGl_z62lambda2166z62zz__multimediazd2midizd2(obj_t BgL_envz00_3782, obj_t BgL_oz00_3783, obj_t BgL_vz00_3784)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
long BgL_vz00_4419;
BgL_vz00_4419 = 
(long)CINT(BgL_vz00_3784); 
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3783)))->BgL_z52statusz52)=((long)BgL_vz00_4419),BUNSPEC);} } 

}



/* &lambda2165 */
obj_t BGl_z62lambda2165z62zz__multimediazd2midizd2(obj_t BgL_envz00_3785, obj_t BgL_oz00_3786)
{
{ /* Llib/midi.scm 24 */
return 
BINT(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3786)))->BgL_z52statusz52));} 

}



/* &<@anonymous:2160> */
obj_t BGl_z62zc3z04anonymousza32160ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3787)
{
{ /* Llib/midi.scm 24 */
return 
BGL_UINT32_TO_BUINT32((uint32_t)(0));} 

}



/* &lambda2159 */
obj_t BGl_z62lambda2159z62zz__multimediazd2midizd2(obj_t BgL_envz00_3788, obj_t BgL_oz00_3789, obj_t BgL_vz00_3790)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
uint32_t BgL_vz00_4422;
BgL_vz00_4422 = 
BGL_BUINT32_TO_UINT32(BgL_vz00_3790); 
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3789)))->BgL_z52wtickz52)=((uint32_t)BgL_vz00_4422),BUNSPEC);} } 

}



/* &lambda2158 */
obj_t BGl_z62lambda2158z62zz__multimediazd2midizd2(obj_t BgL_envz00_3791, obj_t BgL_oz00_3792)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
uint32_t BgL_tmpz00_7964;
BgL_tmpz00_7964 = 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3792)))->BgL_z52wtickz52); 
return 
BGL_UINT32_TO_BUINT32(BgL_tmpz00_7964);} } 

}



/* &<@anonymous:2153> */
obj_t BGl_z62zc3z04anonymousza32153ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3793)
{
{ /* Llib/midi.scm 24 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda2152 */
obj_t BGl_z62lambda2152z62zz__multimediazd2midizd2(obj_t BgL_envz00_3794, obj_t BgL_oz00_3795, obj_t BgL_vz00_3796)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
bool_t BgL_vz00_4425;
BgL_vz00_4425 = 
CBOOL(BgL_vz00_3796); 
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3795)))->BgL_z52eotz52)=((bool_t)BgL_vz00_4425),BUNSPEC);} } 

}



/* &lambda2151 */
obj_t BGl_z62lambda2151z62zz__multimediazd2midizd2(obj_t BgL_envz00_3797, obj_t BgL_oz00_3798)
{
{ /* Llib/midi.scm 24 */
return 
BBOOL(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3798)))->BgL_z52eotz52));} 

}



/* &lambda2146 */
obj_t BGl_z62lambda2146z62zz__multimediazd2midizd2(obj_t BgL_envz00_3799, obj_t BgL_oz00_3800, obj_t BgL_vz00_3801)
{
{ /* Llib/midi.scm 24 */
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3800)))->BgL_z52closez52)=((obj_t)
((obj_t)BgL_vz00_3801)),BUNSPEC);} 

}



/* &lambda2145 */
obj_t BGl_z62lambda2145z62zz__multimediazd2midizd2(obj_t BgL_envz00_3802, obj_t BgL_oz00_3803)
{
{ /* Llib/midi.scm 24 */
return 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3803)))->BgL_z52closez52);} 

}



/* &lambda2141 */
obj_t BGl_z62lambda2141z62zz__multimediazd2midizd2(obj_t BgL_envz00_3804, obj_t BgL_oz00_3805, obj_t BgL_vz00_3806)
{
{ /* Llib/midi.scm 24 */
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3805)))->BgL_z52readerz52)=((BgL_midireaderz00_bglt)
((BgL_midireaderz00_bglt)BgL_vz00_3806)),BUNSPEC);} 

}



/* &lambda2140 */
BgL_midireaderz00_bglt BGl_z62lambda2140z62zz__multimediazd2midizd2(obj_t BgL_envz00_3807, obj_t BgL_oz00_3808)
{
{ /* Llib/midi.scm 24 */
return 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3808)))->BgL_z52readerz52);} 

}



/* &<@anonymous:2136> */
obj_t BGl_z62zc3z04anonymousza32136ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3809)
{
{ /* Llib/midi.scm 24 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda2135 */
obj_t BGl_z62lambda2135z62zz__multimediazd2midizd2(obj_t BgL_envz00_3810, obj_t BgL_oz00_3811, obj_t BgL_vz00_3812)
{
{ /* Llib/midi.scm 24 */
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3811)))->BgL_z52streamz52)=((obj_t)BgL_vz00_3812),BUNSPEC);} 

}



/* &lambda2134 */
obj_t BGl_z62lambda2134z62zz__multimediazd2midizd2(obj_t BgL_envz00_3813, obj_t BgL_oz00_3814)
{
{ /* Llib/midi.scm 24 */
return 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3814)))->BgL_z52streamz52);} 

}



/* &<@anonymous:2092> */
obj_t BGl_z62zc3z04anonymousza32092ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3815, obj_t BgL_new1053z00_3816)
{
{ /* Llib/midi.scm 17 */
{ 
BgL_midiscorez00_bglt BgL_auxz00_7990;
((((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_new1053z00_3816)))->BgL_formatz00)=((long)((long)0)),BUNSPEC); 
((((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_new1053z00_3816)))->BgL_tempoz00)=((long)((long)0)),BUNSPEC); 
((((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_new1053z00_3816)))->BgL_ppqz00)=((long)((long)0)),BUNSPEC); 
((((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_new1053z00_3816)))->BgL_tracksz00)=((obj_t)
CNST_TABLE_REF(((long)75))),BUNSPEC); 
BgL_auxz00_7990 = 
((BgL_midiscorez00_bglt)BgL_new1053z00_3816); 
return 
((obj_t)BgL_auxz00_7990);} } 

}



/* &lambda2090 */
BgL_midiscorez00_bglt BGl_z62lambda2090z62zz__multimediazd2midizd2(obj_t BgL_envz00_3817)
{
{ /* Llib/midi.scm 17 */
{ /* Llib/midi.scm 17 */
BgL_midiscorez00_bglt BgL_new1052z00_4436;
BgL_new1052z00_4436 = 
((BgL_midiscorez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midiscorez00_bgl) ))); 
{ /* Llib/midi.scm 17 */
long BgL_arg2091z00_4437;
{ /* Llib/midi.scm 17 */
long BgL_res2775z00_4438;
BgL_res2775z00_4438 = 
BGL_CLASS_INDEX(BGl_midiscorez00zz__multimediazd2midizd2); 
BgL_arg2091z00_4437 = BgL_res2775z00_4438; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1052z00_4436), BgL_arg2091z00_4437); } 
return BgL_new1052z00_4436;} } 

}



/* &lambda2087 */
BgL_midiscorez00_bglt BGl_z62lambda2087z62zz__multimediazd2midizd2(obj_t BgL_envz00_3818, obj_t BgL_format1048z00_3819, obj_t BgL_tempo1049z00_3820, obj_t BgL_ppq1050z00_3821, obj_t BgL_tracks1051z00_3822)
{
{ /* Llib/midi.scm 17 */
{ /* Llib/midi.scm 17 */
long BgL_format1048z00_4439;long BgL_tempo1049z00_4440;long BgL_ppq1050z00_4441;
BgL_format1048z00_4439 = 
(long)CINT(BgL_format1048z00_3819); 
BgL_tempo1049z00_4440 = 
(long)CINT(BgL_tempo1049z00_3820); 
BgL_ppq1050z00_4441 = 
(long)CINT(BgL_ppq1050z00_3821); 
{ /* Llib/midi.scm 17 */
BgL_midiscorez00_bglt BgL_new1177z00_4443;
{ /* Llib/midi.scm 17 */
BgL_midiscorez00_bglt BgL_new1176z00_4444;
BgL_new1176z00_4444 = 
((BgL_midiscorez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midiscorez00_bgl) ))); 
{ /* Llib/midi.scm 17 */
long BgL_arg2089z00_4445;
{ /* Llib/midi.scm 17 */
long BgL_res2774z00_4446;
BgL_res2774z00_4446 = 
BGL_CLASS_INDEX(BGl_midiscorez00zz__multimediazd2midizd2); 
BgL_arg2089z00_4445 = BgL_res2774z00_4446; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1176z00_4444), BgL_arg2089z00_4445); } 
BgL_new1177z00_4443 = BgL_new1176z00_4444; } 
((((BgL_midiscorez00_bglt)COBJECT(BgL_new1177z00_4443))->BgL_formatz00)=((long)BgL_format1048z00_4439),BUNSPEC); 
((((BgL_midiscorez00_bglt)COBJECT(BgL_new1177z00_4443))->BgL_tempoz00)=((long)BgL_tempo1049z00_4440),BUNSPEC); 
((((BgL_midiscorez00_bglt)COBJECT(BgL_new1177z00_4443))->BgL_ppqz00)=((long)BgL_ppq1050z00_4441),BUNSPEC); 
((((BgL_midiscorez00_bglt)COBJECT(BgL_new1177z00_4443))->BgL_tracksz00)=((obj_t)
((obj_t)BgL_tracks1051z00_3822)),BUNSPEC); 
{ /* Llib/midi.scm 17 */
obj_t BgL_fun2088z00_4447;
BgL_fun2088z00_4447 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_midiscorez00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun2088z00_4447)(BgL_fun2088z00_4447, 
((obj_t)BgL_new1177z00_4443), BEOA); } 
return BgL_new1177z00_4443;} } } 

}



/* &<@anonymous:2118> */
obj_t BGl_z62zc3z04anonymousza32118ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3823)
{
{ /* Llib/midi.scm 17 */
return 
CNST_TABLE_REF(((long)75));} 

}



/* &lambda2117 */
obj_t BGl_z62lambda2117z62zz__multimediazd2midizd2(obj_t BgL_envz00_3824, obj_t BgL_oz00_3825, obj_t BgL_vz00_3826)
{
{ /* Llib/midi.scm 17 */
return 
((((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_oz00_3825)))->BgL_tracksz00)=((obj_t)
((obj_t)BgL_vz00_3826)),BUNSPEC);} 

}



/* &lambda2116 */
obj_t BGl_z62lambda2116z62zz__multimediazd2midizd2(obj_t BgL_envz00_3827, obj_t BgL_oz00_3828)
{
{ /* Llib/midi.scm 17 */
return 
(((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_oz00_3828)))->BgL_tracksz00);} 

}



/* &<@anonymous:2111> */
obj_t BGl_z62zc3z04anonymousza32111ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3829)
{
{ /* Llib/midi.scm 17 */
return 
BINT(((long)96));} 

}



/* &lambda2110 */
obj_t BGl_z62lambda2110z62zz__multimediazd2midizd2(obj_t BgL_envz00_3830, obj_t BgL_oz00_3831, obj_t BgL_vz00_3832)
{
{ /* Llib/midi.scm 17 */
{ /* Llib/midi.scm 17 */
long BgL_vz00_4452;
BgL_vz00_4452 = 
(long)CINT(BgL_vz00_3832); 
return 
((((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_oz00_3831)))->BgL_ppqz00)=((long)BgL_vz00_4452),BUNSPEC);} } 

}



/* &lambda2109 */
obj_t BGl_z62lambda2109z62zz__multimediazd2midizd2(obj_t BgL_envz00_3833, obj_t BgL_oz00_3834)
{
{ /* Llib/midi.scm 17 */
return 
BINT(
(((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_oz00_3834)))->BgL_ppqz00));} 

}



/* &<@anonymous:2104> */
obj_t BGl_z62zc3z04anonymousza32104ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3835)
{
{ /* Llib/midi.scm 17 */
return 
BINT(((long)500000));} 

}



/* &lambda2103 */
obj_t BGl_z62lambda2103z62zz__multimediazd2midizd2(obj_t BgL_envz00_3836, obj_t BgL_oz00_3837, obj_t BgL_vz00_3838)
{
{ /* Llib/midi.scm 17 */
{ /* Llib/midi.scm 17 */
long BgL_vz00_4455;
BgL_vz00_4455 = 
(long)CINT(BgL_vz00_3838); 
return 
((((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_oz00_3837)))->BgL_tempoz00)=((long)BgL_vz00_4455),BUNSPEC);} } 

}



/* &lambda2102 */
obj_t BGl_z62lambda2102z62zz__multimediazd2midizd2(obj_t BgL_envz00_3839, obj_t BgL_oz00_3840)
{
{ /* Llib/midi.scm 17 */
return 
BINT(
(((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_oz00_3840)))->BgL_tempoz00));} 

}



/* &lambda2097 */
obj_t BGl_z62lambda2097z62zz__multimediazd2midizd2(obj_t BgL_envz00_3841, obj_t BgL_oz00_3842, obj_t BgL_vz00_3843)
{
{ /* Llib/midi.scm 17 */
{ /* Llib/midi.scm 17 */
long BgL_vz00_4458;
BgL_vz00_4458 = 
(long)CINT(BgL_vz00_3843); 
return 
((((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_oz00_3842)))->BgL_formatz00)=((long)BgL_vz00_4458),BUNSPEC);} } 

}



/* &lambda2096 */
obj_t BGl_z62lambda2096z62zz__multimediazd2midizd2(obj_t BgL_envz00_3844, obj_t BgL_oz00_3845)
{
{ /* Llib/midi.scm 17 */
return 
BINT(
(((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_oz00_3845)))->BgL_formatz00));} 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__multimediazd2midizd2()
{
{ /* Llib/midi.scm 15 */
BGl_registerzd2genericz12zc0zz__objectz00(BGl_midiscorezd2initzd2envz00zz__multimediazd2midizd2, BGl_proc3267z00zz__multimediazd2midizd2, BGl_midiscorez00zz__multimediazd2midizd2, BGl_string3268z00zz__multimediazd2midizd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_miditrackzd2initzd2envz00zz__multimediazd2midizd2, BGl_proc3269z00zz__multimediazd2midizd2, BGl_miditrackz00zz__multimediazd2midizd2, BGl_string3270z00zz__multimediazd2midizd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_midireaderzd2initzd2envz00zz__multimediazd2midizd2, BGl_proc3271z00zz__multimediazd2midizd2, BGl_midireaderz00zz__multimediazd2midizd2, BGl_string3272z00zz__multimediazd2midizd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_midiplayerzd2initzd2envz00zz__multimediazd2midizd2, BGl_proc3273z00zz__multimediazd2midizd2, BGl_midiplayerz00zz__multimediazd2midizd2, BGl_string3274z00zz__multimediazd2midizd2); 
return 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_midisinkzd2initzd2envz00zz__multimediazd2midizd2, BGl_proc3275z00zz__multimediazd2midizd2, BGl_midisinkz00zz__multimediazd2midizd2, BGl_string3276z00zz__multimediazd2midizd2);} 

}



/* &midisink-init1238 */
obj_t BGl_z62midisinkzd2init1238zb0zz__multimediazd2midizd2(obj_t BgL_envz00_3861, obj_t BgL_msinkz00_3862)
{
{ /* Llib/midi.scm 987 */
return 
((obj_t)
((BgL_midisinkz00_bglt)BgL_msinkz00_3862));} 

}



/* &midiplayer-init1236 */
obj_t BGl_z62midiplayerzd2init1236zb0zz__multimediazd2midizd2(obj_t BgL_envz00_3863, obj_t BgL_mplayerz00_3864)
{
{ /* Llib/midi.scm 981 */
return 
((obj_t)
((BgL_midiplayerz00_bglt)BgL_mplayerz00_3864));} 

}



/* &midireader-init1234 */
obj_t BGl_z62midireaderzd2init1234zb0zz__multimediazd2midizd2(obj_t BgL_envz00_3865, obj_t BgL_mreaderz00_3866)
{
{ /* Llib/midi.scm 975 */
return 
((obj_t)
((BgL_midireaderz00_bglt)BgL_mreaderz00_3866));} 

}



/* &miditrack-init1232 */
obj_t BGl_z62miditrackzd2init1232zb0zz__multimediazd2midizd2(obj_t BgL_envz00_3867, obj_t BgL_mtrackz00_3868)
{
{ /* Llib/midi.scm 969 */
return 
((obj_t)
((BgL_miditrackz00_bglt)BgL_mtrackz00_3868));} 

}



/* &midiscore-init1230 */
obj_t BGl_z62midiscorezd2init1230zb0zz__multimediazd2midizd2(obj_t BgL_envz00_3869, obj_t BgL_mscorez00_3870)
{
{ /* Llib/midi.scm 963 */
return 
((obj_t)
((BgL_midiscorez00_bglt)BgL_mscorez00_3870));} 

}



/* midiscore-init */
BGL_EXPORTED_DEF obj_t BGl_midiscorezd2initzd2zz__multimediazd2midizd2(BgL_midiscorez00_bglt BgL_mscorez00_63)
{
{ /* Llib/midi.scm 963 */
{ /* Llib/midi.scm 963 */
obj_t BgL_method1231z00_1855;
{ /* Llib/midi.scm 963 */
obj_t BgL_res2794z00_2831;
{ /* Llib/midi.scm 963 */
long BgL_objzd2classzd2numz00_2796;
{ /* Llib/midi.scm 963 */
long BgL_res2784z00_2799;
BgL_res2784z00_2799 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_mscorez00_63)); 
BgL_objzd2classzd2numz00_2796 = BgL_res2784z00_2799; } 
{ /* Llib/midi.scm 963 */
obj_t BgL_arg1718z00_2797;
BgL_arg1718z00_2797 = 
PROCEDURE_REF(BGl_midiscorezd2initzd2envz00zz__multimediazd2midizd2, 
(int)(((long)1))); 
{ /* Llib/midi.scm 963 */
int BgL_offsetz00_2801;
BgL_offsetz00_2801 = 
(int)(BgL_objzd2classzd2numz00_2796); 
{ /* Llib/midi.scm 963 */
long BgL_offsetz00_2802;
BgL_offsetz00_2802 = 
(
(long)(BgL_offsetz00_2801)-OBJECT_TYPE); 
{ /* Llib/midi.scm 963 */
long BgL_modz00_2803;
BgL_modz00_2803 = 
(BgL_offsetz00_2802 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/midi.scm 963 */
long BgL_restz00_2805;
BgL_restz00_2805 = 
(BgL_offsetz00_2802 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/midi.scm 963 */

{ /* Llib/midi.scm 963 */
obj_t BgL_bucketz00_2807;
BgL_bucketz00_2807 = 
VECTOR_REF(
((obj_t)BgL_arg1718z00_2797),BgL_modz00_2803); 
BgL_res2794z00_2831 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2807),BgL_restz00_2805); } } } } } } } } 
BgL_method1231z00_1855 = BgL_res2794z00_2831; } 
return 
PROCEDURE_ENTRY(BgL_method1231z00_1855)(BgL_method1231z00_1855, 
((obj_t)BgL_mscorez00_63), BEOA);} } 

}



/* &midiscore-init */
obj_t BGl_z62midiscorezd2initzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3846, obj_t BgL_mscorez00_3847)
{
{ /* Llib/midi.scm 963 */
{ /* Llib/midi.scm 963 */
BgL_midiscorez00_bglt BgL_auxz00_8095;
if(
BGl_isazf3zf3zz__objectz00(BgL_mscorez00_3847, BGl_midiscorez00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 963 */
BgL_auxz00_8095 = 
((BgL_midiscorez00_bglt)BgL_mscorez00_3847)
; }  else 
{ 
obj_t BgL_auxz00_8099;
BgL_auxz00_8099 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)36209)), BGl_string3277z00zz__multimediazd2midizd2, BGl_string3045z00zz__multimediazd2midizd2, BgL_mscorez00_3847); 
FAILURE(BgL_auxz00_8099,BFALSE,BFALSE);} 
return 
BGl_midiscorezd2initzd2zz__multimediazd2midizd2(BgL_auxz00_8095);} } 

}



/* miditrack-init */
BGL_EXPORTED_DEF obj_t BGl_miditrackzd2initzd2zz__multimediazd2midizd2(BgL_miditrackz00_bglt BgL_mtrackz00_64)
{
{ /* Llib/midi.scm 969 */
{ /* Llib/midi.scm 969 */
obj_t BgL_method1233z00_1856;
{ /* Llib/midi.scm 969 */
obj_t BgL_res2805z00_2868;
{ /* Llib/midi.scm 969 */
long BgL_objzd2classzd2numz00_2833;
{ /* Llib/midi.scm 969 */
long BgL_res2795z00_2836;
BgL_res2795z00_2836 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_mtrackz00_64)); 
BgL_objzd2classzd2numz00_2833 = BgL_res2795z00_2836; } 
{ /* Llib/midi.scm 969 */
obj_t BgL_arg1718z00_2834;
BgL_arg1718z00_2834 = 
PROCEDURE_REF(BGl_miditrackzd2initzd2envz00zz__multimediazd2midizd2, 
(int)(((long)1))); 
{ /* Llib/midi.scm 969 */
int BgL_offsetz00_2838;
BgL_offsetz00_2838 = 
(int)(BgL_objzd2classzd2numz00_2833); 
{ /* Llib/midi.scm 969 */
long BgL_offsetz00_2839;
BgL_offsetz00_2839 = 
(
(long)(BgL_offsetz00_2838)-OBJECT_TYPE); 
{ /* Llib/midi.scm 969 */
long BgL_modz00_2840;
BgL_modz00_2840 = 
(BgL_offsetz00_2839 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/midi.scm 969 */
long BgL_restz00_2842;
BgL_restz00_2842 = 
(BgL_offsetz00_2839 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/midi.scm 969 */

{ /* Llib/midi.scm 969 */
obj_t BgL_bucketz00_2844;
BgL_bucketz00_2844 = 
VECTOR_REF(
((obj_t)BgL_arg1718z00_2834),BgL_modz00_2840); 
BgL_res2805z00_2868 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2844),BgL_restz00_2842); } } } } } } } } 
BgL_method1233z00_1856 = BgL_res2805z00_2868; } 
return 
PROCEDURE_ENTRY(BgL_method1233z00_1856)(BgL_method1233z00_1856, 
((obj_t)BgL_mtrackz00_64), BEOA);} } 

}



/* &miditrack-init */
obj_t BGl_z62miditrackzd2initzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3848, obj_t BgL_mtrackz00_3849)
{
{ /* Llib/midi.scm 969 */
{ /* Llib/midi.scm 969 */
BgL_miditrackz00_bglt BgL_auxz00_8134;
if(
BGl_isazf3zf3zz__objectz00(BgL_mtrackz00_3849, BGl_miditrackz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 969 */
BgL_auxz00_8134 = 
((BgL_miditrackz00_bglt)BgL_mtrackz00_3849)
; }  else 
{ 
obj_t BgL_auxz00_8138;
BgL_auxz00_8138 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)36494)), BGl_string3278z00zz__multimediazd2midizd2, BGl_string3067z00zz__multimediazd2midizd2, BgL_mtrackz00_3849); 
FAILURE(BgL_auxz00_8138,BFALSE,BFALSE);} 
return 
BGl_miditrackzd2initzd2zz__multimediazd2midizd2(BgL_auxz00_8134);} } 

}



/* midireader-init */
BGL_EXPORTED_DEF obj_t BGl_midireaderzd2initzd2zz__multimediazd2midizd2(BgL_midireaderz00_bglt BgL_mreaderz00_65)
{
{ /* Llib/midi.scm 975 */
{ /* Llib/midi.scm 975 */
obj_t BgL_method1235z00_1857;
{ /* Llib/midi.scm 975 */
obj_t BgL_res2816z00_2905;
{ /* Llib/midi.scm 975 */
long BgL_objzd2classzd2numz00_2870;
{ /* Llib/midi.scm 975 */
long BgL_res2806z00_2873;
BgL_res2806z00_2873 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_mreaderz00_65)); 
BgL_objzd2classzd2numz00_2870 = BgL_res2806z00_2873; } 
{ /* Llib/midi.scm 975 */
obj_t BgL_arg1718z00_2871;
BgL_arg1718z00_2871 = 
PROCEDURE_REF(BGl_midireaderzd2initzd2envz00zz__multimediazd2midizd2, 
(int)(((long)1))); 
{ /* Llib/midi.scm 975 */
int BgL_offsetz00_2875;
BgL_offsetz00_2875 = 
(int)(BgL_objzd2classzd2numz00_2870); 
{ /* Llib/midi.scm 975 */
long BgL_offsetz00_2876;
BgL_offsetz00_2876 = 
(
(long)(BgL_offsetz00_2875)-OBJECT_TYPE); 
{ /* Llib/midi.scm 975 */
long BgL_modz00_2877;
BgL_modz00_2877 = 
(BgL_offsetz00_2876 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/midi.scm 975 */
long BgL_restz00_2879;
BgL_restz00_2879 = 
(BgL_offsetz00_2876 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/midi.scm 975 */

{ /* Llib/midi.scm 975 */
obj_t BgL_bucketz00_2881;
BgL_bucketz00_2881 = 
VECTOR_REF(
((obj_t)BgL_arg1718z00_2871),BgL_modz00_2877); 
BgL_res2816z00_2905 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2881),BgL_restz00_2879); } } } } } } } } 
BgL_method1235z00_1857 = BgL_res2816z00_2905; } 
return 
PROCEDURE_ENTRY(BgL_method1235z00_1857)(BgL_method1235z00_1857, 
((obj_t)BgL_mreaderz00_65), BEOA);} } 

}



/* &midireader-init */
obj_t BGl_z62midireaderzd2initzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3850, obj_t BgL_mreaderz00_3851)
{
{ /* Llib/midi.scm 975 */
{ /* Llib/midi.scm 975 */
BgL_midireaderz00_bglt BgL_auxz00_8173;
if(
BGl_isazf3zf3zz__objectz00(BgL_mreaderz00_3851, BGl_midireaderz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 975 */
BgL_auxz00_8173 = 
((BgL_midireaderz00_bglt)BgL_mreaderz00_3851)
; }  else 
{ 
obj_t BgL_auxz00_8177;
BgL_auxz00_8177 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)36779)), BGl_string3279z00zz__multimediazd2midizd2, BGl_string3280z00zz__multimediazd2midizd2, BgL_mreaderz00_3851); 
FAILURE(BgL_auxz00_8177,BFALSE,BFALSE);} 
return 
BGl_midireaderzd2initzd2zz__multimediazd2midizd2(BgL_auxz00_8173);} } 

}



/* midiplayer-init */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2initzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mplayerz00_66)
{
{ /* Llib/midi.scm 981 */
{ /* Llib/midi.scm 981 */
obj_t BgL_method1237z00_1858;
{ /* Llib/midi.scm 981 */
obj_t BgL_res2827z00_2942;
{ /* Llib/midi.scm 981 */
long BgL_objzd2classzd2numz00_2907;
{ /* Llib/midi.scm 981 */
long BgL_res2817z00_2910;
BgL_res2817z00_2910 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_mplayerz00_66)); 
BgL_objzd2classzd2numz00_2907 = BgL_res2817z00_2910; } 
{ /* Llib/midi.scm 981 */
obj_t BgL_arg1718z00_2908;
BgL_arg1718z00_2908 = 
PROCEDURE_REF(BGl_midiplayerzd2initzd2envz00zz__multimediazd2midizd2, 
(int)(((long)1))); 
{ /* Llib/midi.scm 981 */
int BgL_offsetz00_2912;
BgL_offsetz00_2912 = 
(int)(BgL_objzd2classzd2numz00_2907); 
{ /* Llib/midi.scm 981 */
long BgL_offsetz00_2913;
BgL_offsetz00_2913 = 
(
(long)(BgL_offsetz00_2912)-OBJECT_TYPE); 
{ /* Llib/midi.scm 981 */
long BgL_modz00_2914;
BgL_modz00_2914 = 
(BgL_offsetz00_2913 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/midi.scm 981 */
long BgL_restz00_2916;
BgL_restz00_2916 = 
(BgL_offsetz00_2913 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/midi.scm 981 */

{ /* Llib/midi.scm 981 */
obj_t BgL_bucketz00_2918;
BgL_bucketz00_2918 = 
VECTOR_REF(
((obj_t)BgL_arg1718z00_2908),BgL_modz00_2914); 
BgL_res2827z00_2942 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2918),BgL_restz00_2916); } } } } } } } } 
BgL_method1237z00_1858 = BgL_res2827z00_2942; } 
return 
PROCEDURE_ENTRY(BgL_method1237z00_1858)(BgL_method1237z00_1858, 
((obj_t)BgL_mplayerz00_66), BEOA);} } 

}



/* &midiplayer-init */
obj_t BGl_z62midiplayerzd2initzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3852, obj_t BgL_mplayerz00_3853)
{
{ /* Llib/midi.scm 981 */
{ /* Llib/midi.scm 981 */
BgL_midiplayerz00_bglt BgL_auxz00_8212;
if(
BGl_isazf3zf3zz__objectz00(BgL_mplayerz00_3853, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 981 */
BgL_auxz00_8212 = 
((BgL_midiplayerz00_bglt)BgL_mplayerz00_3853)
; }  else 
{ 
obj_t BgL_auxz00_8216;
BgL_auxz00_8216 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)37068)), BGl_string3281z00zz__multimediazd2midizd2, BGl_string3046z00zz__multimediazd2midizd2, BgL_mplayerz00_3853); 
FAILURE(BgL_auxz00_8216,BFALSE,BFALSE);} 
return 
BGl_midiplayerzd2initzd2zz__multimediazd2midizd2(BgL_auxz00_8212);} } 

}



/* midisink-init */
BGL_EXPORTED_DEF obj_t BGl_midisinkzd2initzd2zz__multimediazd2midizd2(BgL_midisinkz00_bglt BgL_msinkz00_67)
{
{ /* Llib/midi.scm 987 */
{ /* Llib/midi.scm 987 */
obj_t BgL_method1239z00_1859;
{ /* Llib/midi.scm 987 */
obj_t BgL_res2838z00_2979;
{ /* Llib/midi.scm 987 */
long BgL_objzd2classzd2numz00_2944;
{ /* Llib/midi.scm 987 */
long BgL_res2828z00_2947;
BgL_res2828z00_2947 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_msinkz00_67)); 
BgL_objzd2classzd2numz00_2944 = BgL_res2828z00_2947; } 
{ /* Llib/midi.scm 987 */
obj_t BgL_arg1718z00_2945;
BgL_arg1718z00_2945 = 
PROCEDURE_REF(BGl_midisinkzd2initzd2envz00zz__multimediazd2midizd2, 
(int)(((long)1))); 
{ /* Llib/midi.scm 987 */
int BgL_offsetz00_2949;
BgL_offsetz00_2949 = 
(int)(BgL_objzd2classzd2numz00_2944); 
{ /* Llib/midi.scm 987 */
long BgL_offsetz00_2950;
BgL_offsetz00_2950 = 
(
(long)(BgL_offsetz00_2949)-OBJECT_TYPE); 
{ /* Llib/midi.scm 987 */
long BgL_modz00_2951;
BgL_modz00_2951 = 
(BgL_offsetz00_2950 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/midi.scm 987 */
long BgL_restz00_2953;
BgL_restz00_2953 = 
(BgL_offsetz00_2950 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/midi.scm 987 */

{ /* Llib/midi.scm 987 */
obj_t BgL_bucketz00_2955;
BgL_bucketz00_2955 = 
VECTOR_REF(
((obj_t)BgL_arg1718z00_2945),BgL_modz00_2951); 
BgL_res2838z00_2979 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2955),BgL_restz00_2953); } } } } } } } } 
BgL_method1239z00_1859 = BgL_res2838z00_2979; } 
return 
PROCEDURE_ENTRY(BgL_method1239z00_1859)(BgL_method1239z00_1859, 
((obj_t)BgL_msinkz00_67), BEOA);} } 

}



/* &midisink-init */
obj_t BGl_z62midisinkzd2initzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3854, obj_t BgL_msinkz00_3855)
{
{ /* Llib/midi.scm 987 */
{ /* Llib/midi.scm 987 */
BgL_midisinkz00_bglt BgL_auxz00_8251;
if(
BGl_isazf3zf3zz__objectz00(BgL_msinkz00_3855, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 987 */
BgL_auxz00_8251 = 
((BgL_midisinkz00_bglt)BgL_msinkz00_3855)
; }  else 
{ 
obj_t BgL_auxz00_8255;
BgL_auxz00_8255 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3034z00zz__multimediazd2midizd2, 
BINT(((long)37357)), BGl_string3282z00zz__multimediazd2midizd2, BGl_string3047z00zz__multimediazd2midizd2, BgL_msinkz00_3855); 
FAILURE(BgL_auxz00_8255,BFALSE,BFALSE);} 
return 
BGl_midisinkzd2initzd2zz__multimediazd2midizd2(BgL_auxz00_8251);} } 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__multimediazd2midizd2()
{
{ /* Llib/midi.scm 15 */
return BUNSPEC;} 

}

#ifdef __cplusplus
}
#endif
