/*===========================================================================*/
/*   (Llib/mpd.scm)                                                          */
/*   Bigloo (4.3g)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu 27 Feb 2020 07:59:49 AM CET     */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo4.3g/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo4.3g/lib/bigloo/4.3g -lib-dir /builddir/build/BUILD/bigloo4.3g/lib/bigloo/4.3g -I Llib -lib-dir /builddir/build/BUILD/bigloo4.3g/lib/bigloo/4.3g -unsafe -safee -copt -fPIC -copt -IUnix Llib/mpd.scm -o objs/mpd.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_musicz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_onstatez00;
   obj_t BgL_onvolumez00;
   obj_t BgL_onerrorz00;
   obj_t BgL_oneventz00;
   obj_t BgL_z52mutexz52;
   struct BgL_musicstatusz00_bgl * BgL_z52statusz52;
} *BgL_musicz00_bglt;

typedef struct BgL_musicstatusz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_statez00;
   obj_t BgL_volumez00;
   bool_t BgL_repeatz00;
   bool_t BgL_randomz00;
   int BgL_playlistidz00;
   int BgL_playlistlengthz00;
   int BgL_xfadez00;
   int BgL_songz00;
   int BgL_songidz00;
   obj_t BgL_songposz00;
   int BgL_songlengthz00;
   int BgL_bitratez00;
   int BgL_khza7za7;
   obj_t BgL_errz00;
   int BgL_bufferingz00;
} *BgL_musicstatusz00_bglt;

typedef struct BgL_musictagz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_titlez00;
   obj_t BgL_artistz00;
   obj_t BgL_interpretz00;
   obj_t BgL_albumz00;
   int BgL_trackz00;
   int BgL_yearz00;
   obj_t BgL_genrez00;
   obj_t BgL_commentz00;
   obj_t BgL_ufidz00;
   obj_t BgL_copyrightz00;
   obj_t BgL_picturez00;
} *BgL_musictagz00_bglt;

typedef struct BgL_musicinfoz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_formatz00;
   long BgL_sampleratez00;
   int BgL_channelsz00;
   int BgL_bpsz00;
   long BgL_durationz00;
} *BgL_musicinfoz00_bglt;

typedef struct BgL_mpdzd2databasezd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_directoriesz00;
   obj_t BgL_suffixesz00;
   obj_t BgL_z52basez52;
   obj_t BgL_z52artistsz52;
   obj_t BgL_z52albumsz52;
   obj_t BgL_z52genresz52;
   obj_t BgL_z52nartistsz52;
   int BgL_z52nalbumsz52;
   int BgL_z52nsongsz52;
   obj_t BgL_z52uptimez52;
   obj_t BgL_z52dbzd2updatez80;
} *BgL_mpdzd2databasezd2_bglt;


static obj_t BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = BUNSPEC;
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2getzd2albumzd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t);
BGL_IMPORT obj_t BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
static obj_t BGl_z62mpdzd2killzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t bgl_directory_to_list(char *);
extern obj_t BGl_musiczd2nextzd2zz__multimediazd2musiczd2(BgL_musicz00_bglt);
static obj_t BGl_currentsongzd2infozd2zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, int, obj_t, obj_t);
BGL_IMPORT obj_t BGl_raisez00zz__errorz00(obj_t);
static obj_t BGl_z62mpdzd2swapidzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2listallzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT bool_t bigloo_strcicmp(obj_t, obj_t);
static obj_t BGl_z62mpdzd2crossfadezb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t bgl_display_obj(obj_t, obj_t);
BGL_IMPORT bool_t BGl_equalzf3zf3zz__r4_equivalence_6_2z00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32013ze3ze5zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62mpdzd2repeatzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_assocz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2listgen1357z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2listalbumz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t);
static obj_t BGl_z62mpdzd2databasezd2listgen1359z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2deletezb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32014ze3ze5zz__multimediazd2mpdzd2(obj_t);
static obj_t BGl_z62mpdzd2databasezd2listgen1361z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
BGL_IMPORT bool_t BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(obj_t);
BGL_IMPORT obj_t BGl_assqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
static obj_t BGl_mpdzd2databasezd2directorieszd2scanzd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t);
static obj_t BGl_z62mpdzd2databasezd2listgenrez62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2listartistz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t);
static obj_t BGl_z62mpdzd2databasezd2listallz62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_objectzd2initzd2zz__multimediazd2mpdzd2();
BGL_IMPORT obj_t BGl_stringzd2skipzd2zz__r4_strings_6_7z00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_2zd2zd2zz__r4_numbers_6_5z00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2getgenreartistz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t);
BGL_IMPORT obj_t BGl_dirnamez00zz__osz00(obj_t);
BGL_IMPORT obj_t BGl_stringzd2containszd2zz__r4_strings_6_7z00(obj_t, obj_t, int);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2listallz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t);
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2 = BUNSPEC;
BGL_IMPORT obj_t bstring_to_symbol(obj_t);
BGL_IMPORT obj_t BGl_fprintfz00zz__r4_output_6_10_3z00(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2seekzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32125ze3ze5zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2findzd2ti1375zb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2getzd2albumzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2listgenreartistz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t);
static obj_t BGl_z62mpdzd2statuszb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2addzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdz00zz__multimediazd2mpdzd2(BgL_musicz00_bglt, obj_t, obj_t, BgL_mpdzd2databasezd2_bglt, obj_t);
static obj_t BGl_methodzd2initzd2zz__multimediazd2mpdzd2();
static obj_t BGl_z62zc3z04anonymousza32320ze3ze5zz__multimediazd2mpdzd2(obj_t);
static obj_t BGl_z62mpdzd2playzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_musiczd2pausezd2zz__multimediazd2musiczd2(BgL_musicz00_bglt);
static obj_t BGl_z62mpdzd2currentsongzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2deleteidzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32054ze3ze5zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_directoryzd2ze3sortzd2listze3zz__multimediazd2mpdzd2(obj_t);
static obj_t BGl_z62mpdzd2databasezd2getarti1381z62zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_currentsongzd2cachezd2plistz00zz__multimediazd2mpdzd2 = BUNSPEC;
static obj_t BGl_z62mpdzd2databasezd2getarti1385z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32306ze3ze5zz__multimediazd2mpdzd2(obj_t);
static obj_t BGl_z62mpdzd2databasezd2getgenr1379z62zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2listalbumz62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2findzd2ar1369zb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2getgenr1383z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2shufflezb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2getartistz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt);
BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32162ze3ze5zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2previouszb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_currentsongzd2cachezd2infoz00zz__multimediazd2mpdzd2 = BUNSPEC;
static bool_t BGl_directoryzd2scanze70z35zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_zc3z04exitza31997ze3ze70z60zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_mpdzd2listzd2beginz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, BgL_musicz00_bglt, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32341ze3ze5zz__multimediazd2mpdzd2(obj_t);
static obj_t BGl_z62mpdzd2urlhandlerszb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2filezd2ze3pathz31zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t);
static obj_t BGl_z62zc3z04anonymousza32091ze3ze5zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
extern BgL_musicstatusz00_bglt BGl_musiczd2statuszd2zz__multimediazd2musiczd2(BgL_musicz00_bglt);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2findzd2artistzd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2listalb1353z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
extern obj_t BGl_musiczd2playlistzd2getz00zz__multimediazd2musiczd2(BgL_musicz00_bglt);
static obj_t BGl_z62zc3z04anonymousza32327ze3ze5zz__multimediazd2mpdzd2(obj_t);
BGL_IMPORT obj_t BGl_filezd2namezd2ze3listze3zz__osz00(obj_t);
BGL_IMPORT obj_t BGl_makezd2hashtablezd2zz__hashz00(obj_t);
static obj_t BGl_z62mpdzd2stopzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2savezb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_getinfofilez00zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32611ze3ze5zz__multimediazd2mpdzd2(obj_t, obj_t);
BGL_IMPORT obj_t BGl_unwindzd2untilz12zc0zz__bexitz00(obj_t, obj_t);
static obj_t BGl_z62mpdzd2findzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT bool_t fexists(char *);
static obj_t BGl_z62mpdzd2databasezd2getzd2alb1389zb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2304z62zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62lambda2305z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2playlistinfozb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2311z62zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62lambda2312z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2findzd2genrezd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t);
BGL_IMPORT obj_t BGl_readzd2linezd2zz__r4_input_6_10_2z00(obj_t);
static obj_t BGl_z62lambda2318z62zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62lambda2319z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
extern obj_t BGl_musiczd2volumezd2setz12z12zz__multimediazd2musiczd2(BgL_musicz00_bglt, obj_t);
BGL_IMPORT long bgl_list_length(obj_t);
static obj_t BGl_z62mpdzd2databasezd2listartistz62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_gczd2rootszd2initz00zz__multimediazd2mpdzd2();
static obj_t BGl_z62lambda2325z62zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62lambda2326z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2listgenrealbumz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t);
static obj_t BGl_z62lambda2332z62zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62lambda2333z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32348ze3ze5zz__multimediazd2mpdzd2(obj_t);
static obj_t BGl_z62lambda2339z62zz__multimediazd2mpdzd2(obj_t, obj_t);
extern obj_t BGl_filezd2musictagzd2zz__multimediazd2id3zd2(obj_t);
static obj_t BGl_z62lambda2340z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32292ze3ze5zz__multimediazd2mpdzd2(obj_t);
extern obj_t BGl_musiczd2volumezd2getz00zz__multimediazd2musiczd2(BgL_musicz00_bglt);
static obj_t BGl_z62lambda2346z62zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62lambda2347z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
extern obj_t BGl_musictagz00zz__multimediazd2id3zd2;
static obj_t BGl_z62mpdzd2databasezd2getartistz62zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62lambda2353z62zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62lambda2354z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2randomzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_musiczd2metazd2zz__multimediazd2musiczd2(BgL_musicz00_bglt);
static obj_t BGl_z62mpdzd2outputszb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2searchzd21371zb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t c_substring(obj_t, long, long);
static obj_t BGl_z62mpdzd2commandszb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2searchzd21373zb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza32278ze3ze5zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62mpdzd2seekidzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_exitdzd2popzd2protectz12z12zz__bexitz00(obj_t);
static obj_t BGl_z62mpdzd2rmzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2findzd2titlezd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t);
static obj_t BGl_loopze70ze7zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t);
static bool_t BGl_loopze71ze7zz__multimediazd2mpdzd2(obj_t, BgL_mpdzd2databasezd2_bglt, obj_t, obj_t, obj_t);
static bool_t BGl_loopze72ze7zz__multimediazd2mpdzd2(obj_t, BgL_mpdzd2databasezd2_bglt, obj_t, obj_t, obj_t);
static obj_t BGl_loopze73ze7zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, bool_t, obj_t);
static bool_t BGl_loopze74ze7zz__multimediazd2mpdzd2(obj_t, BgL_mpdzd2databasezd2_bglt, obj_t, obj_t, obj_t);
static obj_t BGl_loopze75ze7zz__multimediazd2mpdzd2(obj_t, obj_t);
BGL_IMPORT long bgl_date_to_seconds(obj_t);
static obj_t BGl_getzd2linezd2argzd2symbolzd2nthz00zz__multimediazd2mpdzd2(obj_t, long);
extern obj_t BGl_musiczd2seekzd2zz__multimediazd2musiczd2(BgL_musicz00_bglt, obj_t, obj_t);
BGL_IMPORT obj_t BGl_stringzd2downcasez12zc0zz__r4_strings_6_7z00(obj_t);
static obj_t BGl_z62mpdzd2statszb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2statsz62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2movezb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2findzd2albumzd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t);
extern obj_t BGl_musiczd2playzd2zz__multimediazd2musiczd2(BgL_musicz00_bglt, obj_t);
static obj_t BGl_z62zc3z04anonymousza32000ze3ze5zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62mpdzd2plchangeszb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2pausezb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_musiczd2playlistzd2clearz12z12zz__multimediazd2musiczd2(BgL_musicz00_bglt);
BGL_IMPORT bool_t bigloo_strcmp(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32001ze3ze5zz__multimediazd2mpdzd2(obj_t);
static obj_t BGl_z62mpdzd2closezb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32299ze3ze5zz__multimediazd2mpdzd2(obj_t);
static obj_t BGl_z62mpdzd2lsinfozb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2volumezb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_musiczd2playlistzd2addz12z12zz__multimediazd2musiczd2(BgL_musicz00_bglt, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2getgenrez00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt);
static obj_t BGl_z62mpdzd2databasezd2filezd2ze3pathz53zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_requirezd2initializa7ationz75zz__multimediazd2mpdzd2 = BUNSPEC;
BGL_IMPORT obj_t BGl_directoryzd2ze3pathzd2listze3zz__r4_ports_6_10_1z00(obj_t);
BGL_IMPORT bool_t BGl_stringzd2suffixzf3z21zz__r4_strings_6_7z00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2lsinfoz62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2notcommandszb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_filezd2musicinfozd2zz__multimediazd2id3zd2(obj_t);
BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2playlistidzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2initz121345z70zz__multimediazd2mpdzd2(obj_t, obj_t);
BGL_IMPORT obj_t bgl_seconds_to_date(long);
static obj_t BGl_toplevelzd2initzd2zz__multimediazd2mpdzd2();
static obj_t BGl_z62mpdzd2listallinfozb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31963ze3ze5zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2getartistalbumz62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2getgenrez62zz__multimediazd2mpdzd2(obj_t, obj_t);
BGL_IMPORT obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
static obj_t BGl_z62mpdzd2setvolzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_musiczd2stopzd2zz__multimediazd2musiczd2(BgL_musicz00_bglt);
static obj_t BGl_z62mpdzd2databasezd2findzd2genrezb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2updatezb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(obj_t, obj_t);
static obj_t BGl_genericzd2initzd2zz__multimediazd2mpdzd2();
BGL_IMPORT obj_t BGl_stringzd2copyzd2zz__r4_strings_6_7z00(obj_t);
BGL_IMPORT obj_t BGl_filterzd2mapzd2zz__r4_control_features_6_9z00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t, bool_t, bool_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_listzd2ze3stringz31zz__r4_strings_6_7z00(obj_t);
static obj_t BGl_z62mpdzd2clearerrorzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern bool_t BGl_musiczd2closedzf3z21zz__multimediazd2musiczd2(BgL_musicz00_bglt);
static obj_t BGl_z62zc3z04anonymousza32130ze3ze5zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_hashtablezd2mapzd2zz__hashz00(obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2findzd2artistzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t bgl_reverse_bang(obj_t);
static obj_t BGl_mpdzd2ze3filez31zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(obj_t, long);
static obj_t BGl_z62mpdzd2tagtypeszb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_makezd2filezd2namez00zz__osz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2lsinfoz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t, bool_t);
BGL_IMPORT obj_t BGl_basenamez00zz__osz00(obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
static obj_t BGl_z62mpdzd2passwordzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2swapzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2statsz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2filezd2ze3p1347z53zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2listzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2findzd2titlezb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32313ze3ze5zz__multimediazd2mpdzd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32135ze3ze5zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2moveidzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2searchzd2artistzd2titlez00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t, obj_t);
static bool_t BGl_filezd2systemzd2rootzf3zf3zz__multimediazd2mpdzd2(obj_t);
static obj_t BGl_z62mpdzd2databasezd2findzd2albumzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2listartistalbumz62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2plconangesposidzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t string_append(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2searchzd2artistzd2albumz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t, obj_t);
extern obj_t BGl_musiczd2prevzd2zz__multimediazd2musiczd2(BgL_musicz00_bglt);
BGL_IMPORT long bgl_current_seconds();
static obj_t BGl_z62zc3z04anonymousza32064ze3ze5zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2nextzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_executezd2commandzd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, BgL_musicz00_bglt, obj_t, obj_t, obj_t);
extern obj_t BGl_musiczd2playlistzd2deletez12z12zz__multimediazd2musiczd2(BgL_musicz00_bglt, int);
BGL_IMPORT obj_t BGl_callzd2withzd2outputzd2stringzd2zz__r4_ports_6_10_1z00(obj_t);
static obj_t BGl_z62mpdzd2databasezd2lsinfo1365z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2getgenreartistz62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl__mpdz00zz__multimediazd2mpdzd2(obj_t, obj_t);
BGL_IMPORT obj_t BGl_substringz00zz__r4_strings_6_7z00(obj_t, long, long);
static long BGl_cmdnz00zz__multimediazd2mpdzd2;
BGL_IMPORT obj_t BGl_makezd2datezd2zz__datez00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2initz12z70zz__multimediazd2mpdzd2(obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2constructorzd2zz__objectz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32334ze3ze5zz__multimediazd2mpdzd2(obj_t);
BGL_IMPORT bool_t bigloo_string_lt(obj_t, obj_t);
static obj_t BGl_z62mpdzd2pingzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_directoryzd2imagezd2zz__multimediazd2mpdzd2(obj_t);
BGL_IMPORT obj_t bgl_list_ref(obj_t, long);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2mpdzd2(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2id3zd2(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_input_6_10_2z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__datez00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__hashz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
static obj_t BGl_zc3z04exitza32010ze3ze70z60zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2searchzd2artistzd2titlez62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_sortz00zz__r4_vectors_6_8z00(obj_t, obj_t);
static long BGl_currentsongzd2cachezd2numz00zz__multimediazd2mpdzd2;
extern obj_t BGl_musicz00zz__multimediazd2musiczd2;
static obj_t BGl_z62mpdzd2databasezd2searchzd2artistzd2albumz62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32265ze3ze5zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_cnstzd2initzd2zz__multimediazd2mpdzd2();
static obj_t BGl_libraryzd2moduleszd2initz00zz__multimediazd2mpdzd2();
BGL_IMPORT obj_t BGl_stringzd2indexzd2zz__r4_strings_6_7z00(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2findzd2al1367zb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_importedzd2moduleszd2initz00zz__multimediazd2mpdzd2();
static bool_t BGl_findzd2genreze70z35zz__multimediazd2mpdzd2(obj_t, obj_t, BgL_mpdzd2databasezd2_bglt, obj_t);
extern obj_t BGl_musicinfoz00zz__multimediazd2id3zd2;
BGL_IMPORT obj_t BGl_prefixz00zz__osz00(obj_t);
static bool_t BGl_imagezd2filezf3z21zz__multimediazd2mpdzd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32355ze3ze5zz__multimediazd2mpdzd2(obj_t);
BGL_IMPORT obj_t BGl_z62iozd2errorzb0zz__objectz00;
BGL_IMPORT obj_t BGl_makezd2filezd2pathz00zz__osz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2searchzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_filezd2ze3mpdz31zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32534ze3ze5zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
BGL_IMPORT bool_t bigloo_strcmp_at(obj_t, obj_t, long);
BGL_IMPORT obj_t BGl_objectz00zz__objectz00;
static obj_t BGl_z62mpdzd2databasezd2stats1349z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2playidzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2listgenreartistz62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2clearzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2findzd2ge1377zb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2listart1355z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_stringzd2capitaliza7ez75zz__r4_strings_6_7z00(obj_t);
static bool_t BGl_musiczd2filezf3z21zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32285ze3ze5zz__multimediazd2mpdzd2(obj_t);
static BgL_mpdzd2databasezd2_bglt BGl_z62lambda2273z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_mpdzd2databasezd2_bglt BGl_z62lambda2276z62zz__multimediazd2mpdzd2(obj_t);
BGL_IMPORT bool_t bgl_directoryp(char *);
extern int BGl_musiczd2songzd2zz__multimediazd2musiczd2(BgL_musicz00_bglt);
static obj_t BGl_z62mpdzd2databasezd2listart1363z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_hashtablezd2putz12zc0zz__hashz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2listall1351z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2283z62zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62lambda2284z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2290z62zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62lambda2291z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
BGL_IMPORT long bgl_last_modification_time(char *);
static obj_t BGl_z62lambda2297z62zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62lambda2298z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2listgenrez00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t);
static obj_t BGl_playlistinfoz00zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, int);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2getartistalbumz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2initz12z12zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt);
static obj_t BGl_z62mpdzd2playlistzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2addidzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static bool_t BGl_findzd2titleze70z35zz__multimediazd2mpdzd2(obj_t, obj_t, BgL_mpdzd2databasezd2_bglt, obj_t);
static obj_t BGl_getzd2linezd2commandz00zz__multimediazd2mpdzd2(obj_t);
BGL_IMPORT int BGl_stringzd2naturalzd2compare3z00zz__r4_strings_6_7z00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2listgenrealbumz62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2listartistalbumz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t);
static obj_t __cnst[ 96 ] ;


DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2getgenrezd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3475z00, BGl_z62mpdzd2databasezd2getgenrez62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2seekidzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2seekidza73476za7, BGl_z62mpdzd2seekidzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2playzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2playza7b03477za7, BGl_z62mpdzd2playzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2rmzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2rmza7b0za7za73478za7, BGl_z62mpdzd2rmzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2findzd2artistzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3479z00, BGl_z62mpdzd2databasezd2findzd2artistzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2statszd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3480z00, BGl_z62mpdzd2databasezd2statsz62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2updatezd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2updateza73481za7, BGl_z62mpdzd2updatezb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2getgenreartistzd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3482z00, BGl_z62mpdzd2databasezd2getgenreartistz62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3400z00zz__multimediazd2mpdzd2, BgL_bgl_string3400za700za7za7_3483za7, "mpd-database-file->p1347", 24 );
DEFINE_STRING( BGl_string3402z00zz__multimediazd2mpdzd2, BgL_bgl_string3402za700za7za7_3484za7, "mpd-database-stats1349", 22 );
DEFINE_STRING( BGl_string3404z00zz__multimediazd2mpdzd2, BgL_bgl_string3404za700za7za7_3485za7, "mpd-database-listall1351", 24 );
DEFINE_STRING( BGl_string3406z00zz__multimediazd2mpdzd2, BgL_bgl_string3406za700za7za7_3486za7, "mpd-database-listalb1353", 24 );
DEFINE_STRING( BGl_string3408z00zz__multimediazd2mpdzd2, BgL_bgl_string3408za700za7za7_3487za7, "mpd-database-listart1355", 24 );
DEFINE_STRING( BGl_string3410z00zz__multimediazd2mpdzd2, BgL_bgl_string3410za700za7za7_3488za7, "mpd-database-listgen1357", 24 );
DEFINE_STRING( BGl_string3412z00zz__multimediazd2mpdzd2, BgL_bgl_string3412za700za7za7_3489za7, "mpd-database-listgen1359", 24 );
DEFINE_STRING( BGl_string3414z00zz__multimediazd2mpdzd2, BgL_bgl_string3414za700za7za7_3490za7, "mpd-database-listgen1361", 24 );
DEFINE_STRING( BGl_string3416z00zz__multimediazd2mpdzd2, BgL_bgl_string3416za700za7za7_3491za7, "mpd-database-listart1363", 24 );
DEFINE_STRING( BGl_string3418z00zz__multimediazd2mpdzd2, BgL_bgl_string3418za700za7za7_3492za7, "mpd-database-lsinfo1365", 23 );
DEFINE_STRING( BGl_string3420z00zz__multimediazd2mpdzd2, BgL_bgl_string3420za700za7za7_3493za7, "mpd-database-find-al1367", 24 );
DEFINE_STRING( BGl_string3422z00zz__multimediazd2mpdzd2, BgL_bgl_string3422za700za7za7_3494za7, "mpd-database-find-ar1369", 24 );
DEFINE_STRING( BGl_string3424z00zz__multimediazd2mpdzd2, BgL_bgl_string3424za700za7za7_3495za7, "mpd-database-search-1371", 24 );
DEFINE_STRING( BGl_string3426z00zz__multimediazd2mpdzd2, BgL_bgl_string3426za700za7za7_3496za7, "mpd-database-search-1373", 24 );
DEFINE_STRING( BGl_string3428z00zz__multimediazd2mpdzd2, BgL_bgl_string3428za700za7za7_3497za7, "mpd-database-find-ti1375", 24 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2getartistzd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3498z00, BGl_z62mpdzd2databasezd2getartistz62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3430z00zz__multimediazd2mpdzd2, BgL_bgl_string3430za700za7za7_3499za7, "mpd-database-find-ge1377", 24 );
DEFINE_STRING( BGl_string3432z00zz__multimediazd2mpdzd2, BgL_bgl_string3432za700za7za7_3500za7, "mpd-database-getgenr1379", 24 );
DEFINE_STRING( BGl_string3434z00zz__multimediazd2mpdzd2, BgL_bgl_string3434za700za7za7_3501za7, "mpd-database-getarti1381", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3348z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3502za7, BGl_z62zc3z04anonymousza32054ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3436z00zz__multimediazd2mpdzd2, BgL_bgl_string3436za700za7za7_3503za7, "mpd-database-getgenr1383", 24 );
DEFINE_STRING( BGl_string3438z00zz__multimediazd2mpdzd2, BgL_bgl_string3438za700za7za7_3504za7, "mpd-database-getarti1385", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2seekzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2seekza7b03505za7, BGl_z62mpdzd2seekzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2pingzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2pingza7b03506za7, BGl_z62mpdzd2pingzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3350z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3507za7, BGl_z62zc3z04anonymousza32064ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3351z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3508za7, BGl_z62zc3z04anonymousza32091ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3440z00zz__multimediazd2mpdzd2, BgL_bgl_string3440za700za7za7_3509za7, "mpd-database-get-alb1389", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3353z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3510za7, BGl_z62zc3z04anonymousza32125ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3354z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3511za7, BGl_z62zc3z04anonymousza32130ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2nextzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2nextza7b03512za7, BGl_z62mpdzd2nextzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STRING( BGl_string3442z00zz__multimediazd2mpdzd2, BgL_bgl_string3442za700za7za7_3513za7, "directory: ", 11 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3355z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3514za7, BGl_z62zc3z04anonymousza32135ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3443z00zz__multimediazd2mpdzd2, BgL_bgl_string3443za700za7za7_3515za7, "lsinfo", 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3356z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3516za7, BGl_z62zc3z04anonymousza32162ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3444z00zz__multimediazd2mpdzd2, BgL_bgl_string3444za700za7za7_3517za7, "Genre: ", 7 );
DEFINE_STRING( BGl_string3445z00zz__multimediazd2mpdzd2, BgL_bgl_string3445za700za7za7_3518za7, "artists: ~a\nalbums: ~a\nsongs: ~a\nuptime: ~a\nplaytime: ~a\ndb_playtime: 10000000\ndb_update: ~a\n", 93 );
DEFINE_STRING( BGl_string3447z00zz__multimediazd2mpdzd2, BgL_bgl_string3447za700za7za7_3519za7, "&mpd-database-init!", 19 );
DEFINE_STRING( BGl_string3448z00zz__multimediazd2mpdzd2, BgL_bgl_string3448za700za7za7_3520za7, "&mpd-database-file->path", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2stopzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2stopza7b03521za7, BGl_z62mpdzd2stopzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STRING( BGl_string3449z00zz__multimediazd2mpdzd2, BgL_bgl_string3449za700za7za7_3522za7, "bstring", 7 );
DEFINE_STRING( BGl_string3289z00zz__multimediazd2mpdzd2, BgL_bgl_string3289za700za7za7_3523za7, "", 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3360z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3524za7, BGl_z62zc3z04anonymousza32265ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3361z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3525za7, BGl_z62zc3z04anonymousza32285ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2previouszd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2previou3526z00, BGl_z62mpdzd2previouszb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3362z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2284za7623527z00, BGl_z62lambda2284z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3450z00zz__multimediazd2mpdzd2, BgL_bgl_string3450za700za7za7_3528za7, "&mpd-database-stats", 19 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3363z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2283za7623529z00, BGl_z62lambda2283z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3451z00zz__multimediazd2mpdzd2, BgL_bgl_string3451za700za7za7_3530za7, "&mpd-database-listall", 21 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3364z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3531za7, BGl_z62zc3z04anonymousza32292ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3452z00zz__multimediazd2mpdzd2, BgL_bgl_string3452za700za7za7_3532za7, "&mpd-database-listalbum", 23 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3365z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2291za7623533z00, BGl_z62lambda2291z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3290z00zz__multimediazd2mpdzd2, BgL_bgl_string3290za700za7za7_3534za7, "wrong number of arguments: [4..5] expected, provided", 52 );
DEFINE_STRING( BGl_string3453z00zz__multimediazd2mpdzd2, BgL_bgl_string3453za700za7za7_3535za7, "&mpd-database-listartistalbum", 29 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3366z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2290za7623536z00, BGl_z62lambda2290z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3291z00zz__multimediazd2mpdzd2, BgL_bgl_string3291za700za7za7_3537za7, "Illegal keyword argument", 24 );
DEFINE_STRING( BGl_string3454z00zz__multimediazd2mpdzd2, BgL_bgl_string3454za700za7za7_3538za7, "&mpd-database-listgenrealbum", 28 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3367z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3539za7, BGl_z62zc3z04anonymousza32299ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3292z00zz__multimediazd2mpdzd2, BgL_bgl_string3292za700za7za7_3540za7, "/builddir/build/BUILD/bigloo4.3g/api/multimedia/src/Llib/mpd.scm", 64 );
DEFINE_STRING( BGl_string3455z00zz__multimediazd2mpdzd2, BgL_bgl_string3455za700za7za7_3541za7, "&mpd-database-listgenreartist", 29 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3368z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2298za7623542z00, BGl_z62lambda2298z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3293z00zz__multimediazd2mpdzd2, BgL_bgl_string3293za700za7za7_3543za7, "_mpd", 4 );
DEFINE_STRING( BGl_string3456z00zz__multimediazd2mpdzd2, BgL_bgl_string3456za700za7za7_3544za7, "&mpd-database-listgenre", 23 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3369z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2297za7623545z00, BGl_z62lambda2297z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3294z00zz__multimediazd2mpdzd2, BgL_bgl_string3294za700za7za7_3546za7, "bint", 4 );
DEFINE_STRING( BGl_string3457z00zz__multimediazd2mpdzd2, BgL_bgl_string3457za700za7za7_3547za7, "&mpd-database-listartist", 24 );
DEFINE_STRING( BGl_string3295z00zz__multimediazd2mpdzd2, BgL_bgl_string3295za700za7za7_3548za7, "music", 5 );
DEFINE_STRING( BGl_string3458z00zz__multimediazd2mpdzd2, BgL_bgl_string3458za700za7za7_3549za7, "&mpd-database-lsinfo", 20 );
DEFINE_STRING( BGl_string3296z00zz__multimediazd2mpdzd2, BgL_bgl_string3296za700za7za7_3550za7, "input-port", 10 );
DEFINE_STRING( BGl_string3459z00zz__multimediazd2mpdzd2, BgL_bgl_string3459za700za7za7_3551za7, "&mpd-database-find-album", 24 );
DEFINE_STRING( BGl_string3297z00zz__multimediazd2mpdzd2, BgL_bgl_string3297za700za7za7_3552za7, "output-port", 11 );
DEFINE_STRING( BGl_string3298z00zz__multimediazd2mpdzd2, BgL_bgl_string3298za700za7za7_3553za7, "mpd-database", 12 );
DEFINE_STRING( BGl_string3299z00zz__multimediazd2mpdzd2, BgL_bgl_string3299za700za7za7_3554za7, "OK MPD 0.16.0", 13 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3370z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3555za7, BGl_z62zc3z04anonymousza32306ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3371z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2305za7623556z00, BGl_z62lambda2305z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3372z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2304za7623557z00, BGl_z62lambda2304z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3460z00zz__multimediazd2mpdzd2, BgL_bgl_string3460za700za7za7_3558za7, "&mpd-database-find-artist", 25 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3373z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3559za7, BGl_z62zc3z04anonymousza32313ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3461z00zz__multimediazd2mpdzd2, BgL_bgl_string3461za700za7za7_3560za7, "&mpd-database-search-artist-album", 33 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3374z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2312za7623561z00, BGl_z62lambda2312z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3462z00zz__multimediazd2mpdzd2, BgL_bgl_string3462za700za7za7_3562za7, "&mpd-database-search-artist-title", 33 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3375z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2311za7623563z00, BGl_z62lambda2311z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3463z00zz__multimediazd2mpdzd2, BgL_bgl_string3463za700za7za7_3564za7, "&mpd-database-find-title", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3376z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3565za7, BGl_z62zc3z04anonymousza32320ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3464z00zz__multimediazd2mpdzd2, BgL_bgl_string3464za700za7za7_3566za7, "&mpd-database-find-genre", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3377z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2319za7623567z00, BGl_z62lambda2319z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3465z00zz__multimediazd2mpdzd2, BgL_bgl_string3465za700za7za7_3568za7, "&mpd-database-getgenre", 22 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3378z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2318za7623569z00, BGl_z62lambda2318z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3466z00zz__multimediazd2mpdzd2, BgL_bgl_string3466za700za7za7_3570za7, "&mpd-database-getartist", 23 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3379z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3571za7, BGl_z62zc3z04anonymousza32327ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3467z00zz__multimediazd2mpdzd2, BgL_bgl_string3467za700za7za7_3572za7, "&mpd-database-getgenreartist", 28 );
DEFINE_STRING( BGl_string3468z00zz__multimediazd2mpdzd2, BgL_bgl_string3468za700za7za7_3573za7, "&mpd-database-getartistalbum", 28 );
DEFINE_STRING( BGl_string3469z00zz__multimediazd2mpdzd2, BgL_bgl_string3469za700za7za7_3574za7, "&mpd-database-get-album", 23 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3380z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2326za7623575z00, BGl_z62lambda2326z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3381z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2325za7623576z00, BGl_z62lambda2325z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3382z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3577za7, BGl_z62zc3z04anonymousza32334ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3470z00zz__multimediazd2mpdzd2, BgL_bgl_string3470za700za7za7_3578za7, "__multimedia-mpd", 16 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3383z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2333za7623579z00, BGl_z62lambda2333z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3471z00zz__multimediazd2mpdzd2, BgL_bgl_string3471za700za7za7_3580za7, ":album (\"mp3\" \"flac\" \"ogg\" \"wav\") __multimedia-mpd mpd-database %db-update %uptime %nsongs int %nalbums obj %nartists %genres %albums %artists bstring %base suffixes pair-nil directories :Image :Time :Last-Modified :file :Genre :Date :Track :Album :Title :Artist (\"jpg\" \"JPG\" \"png\" \"gif\" \"GIF\") any genre disc album title artist (\"Artist\" \"Album\" \"Title\" \"Track\" \"Name\" \"Genre\" \"Date\" \"Composer\" \"Performer\" \"Disc\") (\"http://\" \"file://\") command_list_end command_list_ok_begin command_list_begin blank ok :log (:log) mpd outputs update swapid swap shuffle save rm repeat random password moveid move crossfade addid notcommands commands search find kill plconangesposid lsinfo listallinfo list listall stats close clearerror setvol volume previous next pause stop seekid seek playid play currentsong clear deleteid delete add plchanges playlistid playlistinfo playlist status tagtypes urlhandlers ping ", 901 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3384z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2332za7623581z00, BGl_z62lambda2332z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3385z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3582za7, BGl_z62zc3z04anonymousza32341ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3386z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2340za7623583z00, BGl_z62lambda2340z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3387z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2339za7623584z00, BGl_z62lambda2339z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3388z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3585za7, BGl_z62zc3z04anonymousza32348ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3389z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2347za7623586z00, BGl_z62lambda2347z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2listgenrezd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3587z00, BGl_z62mpdzd2databasezd2listgenrez62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2playlistzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2playlis3588z00, BGl_z62mpdzd2playlistzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3390z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2346za7623589z00, BGl_z62lambda2346z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3391z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3590za7, BGl_z62zc3z04anonymousza32355ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3392z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2354za7623591z00, BGl_z62lambda2354z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3393z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2353za7623592z00, BGl_z62lambda2353z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3394z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3593za7, BGl_z62zc3z04anonymousza32278ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3395z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2276za7623594z00, BGl_z62lambda2276z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3396z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2273za7623595z00, BGl_z62lambda2273z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 11 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3397z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3596z00, BGl_z62mpdzd2databasezd2initz121345z70zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3399z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3597z00, BGl_z62mpdzd2databasezd2filezd2ze3p1347z53zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2filezd2ze3pathzd2envze3zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3598z00, BGl_z62mpdzd2databasezd2filezd2ze3pathz53zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2moveidzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2moveidza73599za7, BGl_z62mpdzd2moveidzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_LLONG( BGl_llong3446z00zz__multimediazd2mpdzd2, BgL_bgl_llong3446za700za7za7__3600za7, ((BGL_LONGLONG_T)0) );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2killzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2killza7b03601za7, BGl_z62mpdzd2killzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2shufflezd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2shuffle3602z00, BGl_z62mpdzd2shufflezb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2closezd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2closeza7b3603za7, BGl_z62mpdzd2closezb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2deleteidzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2deletei3604z00, BGl_z62mpdzd2deleteidzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2volumezd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2volumeza73605za7, BGl_z62mpdzd2volumezb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2addzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2addza7b0za73606z00, BGl_z62mpdzd2addzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2listalbumzd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3607z00, BGl_z62mpdzd2databasezd2listalbumz62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2getzd2albumzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3608z00, BGl_z62mpdzd2databasezd2getzd2albumzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2urlhandlerszd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2urlhand3609z00, BGl_z62mpdzd2urlhandlerszb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2playidzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2playidza73610za7, BGl_z62mpdzd2playidzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2movezd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2moveza7b03611za7, BGl_z62mpdzd2movezb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2playlistidzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2playlis3612z00, BGl_z62mpdzd2playlistidzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2repeatzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2repeatza73613za7, BGl_z62mpdzd2repeatzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2listallinfozd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2listall3614z00, BGl_z62mpdzd2listallinfozb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2lsinfozd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2lsinfoza73615za7, BGl_z62mpdzd2lsinfozb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2searchzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2searchza73616za7, BGl_z62mpdzd2searchzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2deletezd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2deleteza73617za7, BGl_z62mpdzd2deletezb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2listallzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2listall3618z00, BGl_z62mpdzd2listallzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STRING( BGl_string3300z00zz__multimediazd2mpdzd2, BgL_bgl_string3300za700za7za7_3619za7, "OK\n", 3 );
DEFINE_STRING( BGl_string3301z00zz__multimediazd2mpdzd2, BgL_bgl_string3301za700za7za7_3620za7, "ACK [", 5 );
DEFINE_STRING( BGl_string3302z00zz__multimediazd2mpdzd2, BgL_bgl_string3302za700za7za7_3621za7, "5@0", 3 );
DEFINE_STRING( BGl_string3303z00zz__multimediazd2mpdzd2, BgL_bgl_string3303za700za7za7_3622za7, "] {", 3 );
DEFINE_STRING( BGl_string3304z00zz__multimediazd2mpdzd2, BgL_bgl_string3304za700za7za7_3623za7, "} ", 2 );
DEFINE_STRING( BGl_string3305z00zz__multimediazd2mpdzd2, BgL_bgl_string3305za700za7za7_3624za7, "\n", 1 );
DEFINE_STRING( BGl_string3306z00zz__multimediazd2mpdzd2, BgL_bgl_string3306za700za7za7_3625za7, "unknown command \"~a\"", 20 );
DEFINE_STRING( BGl_string3307z00zz__multimediazd2mpdzd2, BgL_bgl_string3307za700za7za7_3626za7, "list_OK\n", 8 );
DEFINE_STRING( BGl_string3308z00zz__multimediazd2mpdzd2, BgL_bgl_string3308za700za7za7_3627za7, "handler: ", 9 );
DEFINE_STRING( BGl_string3309z00zz__multimediazd2mpdzd2, BgL_bgl_string3309za700za7za7_3628za7, "tagtype: ", 9 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2notcommandszd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2notcomm3629z00, BGl_z62mpdzd2notcommandszb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STRING( BGl_string3310z00zz__multimediazd2mpdzd2, BgL_bgl_string3310za700za7za7_3630za7, "volume: ", 8 );
DEFINE_STRING( BGl_string3311z00zz__multimediazd2mpdzd2, BgL_bgl_string3311za700za7za7_3631za7, "state: ", 7 );
DEFINE_STRING( BGl_string3312z00zz__multimediazd2mpdzd2, BgL_bgl_string3312za700za7za7_3632za7, "playlist: ", 10 );
DEFINE_STRING( BGl_string3313z00zz__multimediazd2mpdzd2, BgL_bgl_string3313za700za7za7_3633za7, "playlistlength: ", 16 );
DEFINE_STRING( BGl_string3314z00zz__multimediazd2mpdzd2, BgL_bgl_string3314za700za7za7_3634za7, "song: ", 6 );
DEFINE_STRING( BGl_string3315z00zz__multimediazd2mpdzd2, BgL_bgl_string3315za700za7za7_3635za7, "songid: ", 8 );
DEFINE_STRING( BGl_string3316z00zz__multimediazd2mpdzd2, BgL_bgl_string3316za700za7za7_3636za7, "bitrate: ", 9 );
DEFINE_STRING( BGl_string3317z00zz__multimediazd2mpdzd2, BgL_bgl_string3317za700za7za7_3637za7, "audio: ", 7 );
DEFINE_STRING( BGl_string3318z00zz__multimediazd2mpdzd2, BgL_bgl_string3318za700za7za7_3638za7, ":16:2\n", 6 );
DEFINE_STRING( BGl_string3319z00zz__multimediazd2mpdzd2, BgL_bgl_string3319za700za7za7_3639za7, "time: ", 6 );
DEFINE_STRING( BGl_string3320z00zz__multimediazd2mpdzd2, BgL_bgl_string3320za700za7za7_3640za7, ":", 1 );
DEFINE_STRING( BGl_string3321z00zz__multimediazd2mpdzd2, BgL_bgl_string3321za700za7za7_3641za7, "repeat: 1\n", 10 );
DEFINE_STRING( BGl_string3322z00zz__multimediazd2mpdzd2, BgL_bgl_string3322za700za7za7_3642za7, "repeat: 0\n", 10 );
DEFINE_STRING( BGl_string3323z00zz__multimediazd2mpdzd2, BgL_bgl_string3323za700za7za7_3643za7, "random: 1\n", 10 );
DEFINE_STRING( BGl_string3324z00zz__multimediazd2mpdzd2, BgL_bgl_string3324za700za7za7_3644za7, "random: 0\n", 10 );
DEFINE_STRING( BGl_string3325z00zz__multimediazd2mpdzd2, BgL_bgl_string3325za700za7za7_3645za7, "xfade: ", 7 );
DEFINE_STRING( BGl_string3326z00zz__multimediazd2mpdzd2, BgL_bgl_string3326za700za7za7_3646za7, ": ", 2 );
DEFINE_STRING( BGl_string3327z00zz__multimediazd2mpdzd2, BgL_bgl_string3327za700za7za7_3647za7, "http://", 7 );
DEFINE_STRING( BGl_string3328z00zz__multimediazd2mpdzd2, BgL_bgl_string3328za700za7za7_3648za7, "add", 3 );
DEFINE_STRING( BGl_string3329z00zz__multimediazd2mpdzd2, BgL_bgl_string3329za700za7za7_3649za7, "illegal uri \"~a\"", 16 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2clearerrorzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2clearer3650z00, BGl_z62mpdzd2clearerrorzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3401z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3651z00, BGl_z62mpdzd2databasezd2stats1349z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3403z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3652z00, BGl_z62mpdzd2databasezd2listall1351z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3405z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3653z00, BGl_z62mpdzd2databasezd2listalb1353z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3330z00zz__multimediazd2mpdzd2, BgL_bgl_string3330za700za7za7_3654za7, "file: ", 6 );
DEFINE_STRING( BGl_string3331z00zz__multimediazd2mpdzd2, BgL_bgl_string3331za700za7za7_3655za7, "Pos: ", 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3407z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3656z00, BGl_z62mpdzd2databasezd2listart1355z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string3332z00zz__multimediazd2mpdzd2, BgL_bgl_string3332za700za7za7_3657za7, "Id: ", 4 );
DEFINE_STRING( BGl_string3333z00zz__multimediazd2mpdzd2, BgL_bgl_string3333za700za7za7_3658za7, "Artist: ", 8 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3409z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3659z00, BGl_z62mpdzd2databasezd2listgen1357z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string3334z00zz__multimediazd2mpdzd2, BgL_bgl_string3334za700za7za7_3660za7, "Title: ", 7 );
DEFINE_STRING( BGl_string3335z00zz__multimediazd2mpdzd2, BgL_bgl_string3335za700za7za7_3661za7, "Album: ", 7 );
DEFINE_STRING( BGl_string3336z00zz__multimediazd2mpdzd2, BgL_bgl_string3336za700za7za7_3662za7, "50@0", 4 );
DEFINE_STRING( BGl_string3337z00zz__multimediazd2mpdzd2, BgL_bgl_string3337za700za7za7_3663za7, "next", 4 );
DEFINE_STRING( BGl_string3338z00zz__multimediazd2mpdzd2, BgL_bgl_string3338za700za7za7_3664za7, "No more song", 12 );
DEFINE_STRING( BGl_string3339z00zz__multimediazd2mpdzd2, BgL_bgl_string3339za700za7za7_3665za7, "previous", 8 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3411z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3666z00, BGl_z62mpdzd2databasezd2listgen1359z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3413z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3667z00, BGl_z62mpdzd2databasezd2listgen1361z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3415z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3668z00, BGl_z62mpdzd2databasezd2listart1363z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3340z00zz__multimediazd2mpdzd2, BgL_bgl_string3340za700za7za7_3669za7, "No previous song", 16 );
DEFINE_STRING( BGl_string3341z00zz__multimediazd2mpdzd2, BgL_bgl_string3341za700za7za7_3670za7, "artist", 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3417z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3671z00, BGl_z62mpdzd2databasezd2lsinfo1365z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 4 );
DEFINE_STRING( BGl_string3342z00zz__multimediazd2mpdzd2, BgL_bgl_string3342za700za7za7_3672za7, "genre", 5 );
DEFINE_STRING( BGl_string3343z00zz__multimediazd2mpdzd2, BgL_bgl_string3343za700za7za7_3673za7, "unknown list type \"~a\"", 22 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3419z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3674z00, BGl_z62mpdzd2databasezd2findzd2al1367zb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string3344z00zz__multimediazd2mpdzd2, BgL_bgl_string3344za700za7za7_3675za7, "ACK [2@0] {list} too few arguments for \"list\"", 45 );
DEFINE_STRING( BGl_string3345z00zz__multimediazd2mpdzd2, BgL_bgl_string3345za700za7za7_3676za7, "cpos: ", 6 );
DEFINE_STRING( BGl_string3346z00zz__multimediazd2mpdzd2, BgL_bgl_string3346za700za7za7_3677za7, "unknown find type \"~a\"", 22 );
DEFINE_STRING( BGl_string3347z00zz__multimediazd2mpdzd2, BgL_bgl_string3347za700za7za7_3678za7, "unknown search type \"~a\"", 24 );
BGL_IMPORT obj_t BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00;
DEFINE_STRING( BGl_string3349z00zz__multimediazd2mpdzd2, BgL_bgl_string3349za700za7za7_3679za7, "command: ", 9 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3421z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3680z00, BGl_z62mpdzd2databasezd2findzd2ar1369zb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2currentsongzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2current3681z00, BGl_z62mpdzd2currentsongzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3423z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3682z00, BGl_z62mpdzd2databasezd2searchzd21371zb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3425z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3683z00, BGl_z62mpdzd2databasezd2searchzd21373zb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3427z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3684z00, BGl_z62mpdzd2databasezd2findzd2ti1375zb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string3352z00zz__multimediazd2mpdzd2, BgL_bgl_string3352za700za7za7_3685za7, "No such file", 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3429z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3686z00, BGl_z62mpdzd2databasezd2findzd2ge1377zb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string3357z00zz__multimediazd2mpdzd2, BgL_bgl_string3357za700za7za7_3687za7, "~a-~2,0d-~2,0dT~2,0d:~2,0d:~2,0dZ", 33 );
DEFINE_STRING( BGl_string3358z00zz__multimediazd2mpdzd2, BgL_bgl_string3358za700za7za7_3688za7, "unknown", 7 );
DEFINE_STRING( BGl_string3359z00zz__multimediazd2mpdzd2, BgL_bgl_string3359za700za7za7_3689za7, "Unknown Disc", 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2commandszd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2command3690z00, BGl_z62mpdzd2commandszb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3431z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3691z00, BGl_z62mpdzd2databasezd2getgenr1379z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3433z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3692z00, BGl_z62mpdzd2databasezd2getarti1381z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3435z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3693z00, BGl_z62mpdzd2databasezd2getgenr1383z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3437z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3694z00, BGl_z62mpdzd2databasezd2getarti1385z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3439z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3695z00, BGl_z62mpdzd2databasezd2getzd2alb1389zb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3441z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3696za7, BGl_z62zc3z04anonymousza32534ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2searchzd2artistzd2albumzd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3697z00, BGl_z62mpdzd2databasezd2searchzd2artistzd2albumz62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2crossfadezd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2crossfa3698z00, BGl_z62mpdzd2crossfadezb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_mpdzd2envzd2zz__multimediazd2mpdzd2, BgL_bgl__mpdza700za7za7__multi3699za7, opt_generic_entry, BGl__mpdz00zz__multimediazd2mpdzd2, BFALSE, -1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2setvolzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2setvolza73700za7, BGl_z62mpdzd2setvolzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2listgenrealbumzd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3701z00, BGl_z62mpdzd2databasezd2listgenrealbumz62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2listartistalbumzd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3702z00, BGl_z62mpdzd2databasezd2listartistalbumz62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string3398z00zz__multimediazd2mpdzd2, BgL_bgl_string3398za700za7za7_3703za7, "mpd-database-init!1345", 22 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2statuszd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2statusza73704za7, BGl_z62mpdzd2statuszb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2clearzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2clearza7b3705za7, BGl_z62mpdzd2clearzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2searchzd2artistzd2titlezd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3706z00, BGl_z62mpdzd2databasezd2searchzd2artistzd2titlez62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2savezd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2saveza7b03707za7, BGl_z62mpdzd2savezb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2findzd2genrezd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3708z00, BGl_z62mpdzd2databasezd2findzd2genrezb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2plconangesposidzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2plconan3709z00, BGl_z62mpdzd2plconangesposidzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2listartistzd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3710z00, BGl_z62mpdzd2databasezd2listartistz62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2addidzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2addidza7b3711za7, BGl_z62mpdzd2addidzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2initz12zd2envzc0zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3712z00, BGl_z62mpdzd2databasezd2initz12z70zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2pausezd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2pauseza7b3713za7, BGl_z62mpdzd2pausezb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2randomzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2randomza73714za7, BGl_z62mpdzd2randomzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2statszd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2statsza7b3715za7, BGl_z62mpdzd2statszb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2lsinfozd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3716z00, BGl_z62mpdzd2databasezd2lsinfoz62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2plchangeszd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2plchang3717z00, BGl_z62mpdzd2plchangeszb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2tagtypeszd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2tagtype3718z00, BGl_z62mpdzd2tagtypeszb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2swapidzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2swapidza73719za7, BGl_z62mpdzd2swapidzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2swapzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2swapza7b03720za7, BGl_z62mpdzd2swapzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2findzd2albumzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3721z00, BGl_z62mpdzd2databasezd2findzd2albumzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2findzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2findza7b03722za7, BGl_z62mpdzd2findzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2outputszd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2outputs3723z00, BGl_z62mpdzd2outputszb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2listgenreartistzd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3724z00, BGl_z62mpdzd2databasezd2listgenreartistz62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2findzd2titlezd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3725z00, BGl_z62mpdzd2databasezd2findzd2titlezb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2listallzd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3726z00, BGl_z62mpdzd2databasezd2listallz62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2getartistalbumzd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3727z00, BGl_z62mpdzd2databasezd2getartistalbumz62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2listzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2listza7b03728za7, BGl_z62mpdzd2listzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2playlistinfozd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2playlis3729z00, BGl_z62mpdzd2playlistinfozb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2passwordzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2passwor3730z00, BGl_z62mpdzd2passwordzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2) );
ADD_ROOT( (void *)(&BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2) );
ADD_ROOT( (void *)(&BGl_currentsongzd2cachezd2plistz00zz__multimediazd2mpdzd2) );
ADD_ROOT( (void *)(&BGl_currentsongzd2cachezd2infoz00zz__multimediazd2mpdzd2) );
ADD_ROOT( (void *)(&BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2) );
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__multimediazd2mpdzd2) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2mpdzd2(long BgL_checksumz00_5864, char * BgL_fromz00_5865)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__multimediazd2mpdzd2))
{ 
BGl_requirezd2initializa7ationz75zz__multimediazd2mpdzd2 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__multimediazd2mpdzd2(); 
BGl_libraryzd2moduleszd2initz00zz__multimediazd2mpdzd2(); 
BGl_cnstzd2initzd2zz__multimediazd2mpdzd2(); 
BGl_importedzd2moduleszd2initz00zz__multimediazd2mpdzd2(); 
BGl_objectzd2initzd2zz__multimediazd2mpdzd2(); 
BGl_genericzd2initzd2zz__multimediazd2mpdzd2(); 
return 
BGl_toplevelzd2initzd2zz__multimediazd2mpdzd2();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__multimediazd2mpdzd2()
{
{ /* Llib/mpd.scm 15 */
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__osz00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__hashz00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__bexitz00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__r4_input_6_10_2z00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__datez00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__bitz00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long)0), "__multimedia-mpd"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__multimediazd2mpdzd2()
{
{ /* Llib/mpd.scm 15 */
{ /* Llib/mpd.scm 15 */
obj_t BgL_cportz00_5376;
{ /* Llib/mpd.scm 15 */
obj_t BgL_stringz00_5384;
BgL_stringz00_5384 = BGl_string3471z00zz__multimediazd2mpdzd2; 
{ /* Llib/mpd.scm 15 */
obj_t BgL_startz00_5385;
BgL_startz00_5385 = 
BINT(((long)0)); 
{ /* Llib/mpd.scm 15 */
obj_t BgL_endz00_5386;
BgL_endz00_5386 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_5384))); 
{ /* Llib/mpd.scm 15 */

BgL_cportz00_5376 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_5384, BgL_startz00_5385, BgL_endz00_5386); } } } } 
{ 
long BgL_iz00_5377;
BgL_iz00_5377 = ((long)95); 
BgL_loopz00_5378:
if(
(BgL_iz00_5377==((long)-1)))
{ /* Llib/mpd.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/mpd.scm 15 */
{ /* Llib/mpd.scm 15 */
obj_t BgL_arg3473z00_5380;
{ /* Llib/mpd.scm 15 */

{ /* Llib/mpd.scm 15 */
obj_t BgL_locationz00_5382;
BgL_locationz00_5382 = 
BBOOL(((bool_t)0)); 
{ /* Llib/mpd.scm 15 */

BgL_arg3473z00_5380 = 
BGl_readz00zz__readerz00(BgL_cportz00_5376, BgL_locationz00_5382); } } } 
{ /* Llib/mpd.scm 15 */
int BgL_tmpz00_5906;
BgL_tmpz00_5906 = 
(int)(BgL_iz00_5377); 
CNST_TABLE_SET(BgL_tmpz00_5906, BgL_arg3473z00_5380); } } 
{ /* Llib/mpd.scm 15 */
int BgL_auxz00_5383;
BgL_auxz00_5383 = 
(int)(
(BgL_iz00_5377-((long)1))); 
{ 
long BgL_iz00_5911;
BgL_iz00_5911 = 
(long)(BgL_auxz00_5383); 
BgL_iz00_5377 = BgL_iz00_5911; 
goto BgL_loopz00_5378;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__multimediazd2mpdzd2()
{
{ /* Llib/mpd.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__multimediazd2mpdzd2()
{
{ /* Llib/mpd.scm 15 */
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = BNIL; 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = BNIL; 
BGl_cmdnz00zz__multimediazd2mpdzd2 = ((long)0); 
{ /* Llib/mpd.scm 338 */
obj_t BgL_arg1470z00_419;
{ /* Llib/mpd.scm 338 */
obj_t BgL_arg1476z00_420;
BgL_arg1476z00_420 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)0)), BGl_mpdzd2pingzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 338 */
obj_t BgL_list1477z00_421;
BgL_list1477z00_421 = 
MAKE_YOUNG_PAIR(BgL_arg1476z00_420, BNIL); 
BgL_arg1470z00_419 = BgL_list1477z00_421; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1470z00_419); } 
{ /* Llib/mpd.scm 344 */
obj_t BgL_arg1480z00_422;
{ /* Llib/mpd.scm 344 */
obj_t BgL_arg1481z00_423;
BgL_arg1481z00_423 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)1)), BGl_mpdzd2urlhandlerszd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 344 */
obj_t BgL_list1482z00_424;
BgL_list1482z00_424 = 
MAKE_YOUNG_PAIR(BgL_arg1481z00_423, BNIL); 
BgL_arg1480z00_422 = BgL_list1482z00_424; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1480z00_422); } 
{ /* Llib/mpd.scm 354 */
obj_t BgL_arg1487z00_425;
{ /* Llib/mpd.scm 354 */
obj_t BgL_arg1496z00_426;
BgL_arg1496z00_426 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)2)), BGl_mpdzd2tagtypeszd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 354 */
obj_t BgL_list1497z00_427;
BgL_list1497z00_427 = 
MAKE_YOUNG_PAIR(BgL_arg1496z00_426, BNIL); 
BgL_arg1487z00_425 = BgL_list1497z00_427; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1487z00_425); } 
{ /* Llib/mpd.scm 371 */
obj_t BgL_arg1502z00_428;
{ /* Llib/mpd.scm 371 */
obj_t BgL_arg1503z00_429;
BgL_arg1503z00_429 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)3)), BGl_mpdzd2statuszd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 371 */
obj_t BgL_list1504z00_430;
BgL_list1504z00_430 = 
MAKE_YOUNG_PAIR(BgL_arg1503z00_429, BNIL); 
BgL_arg1502z00_428 = BgL_list1504z00_430; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1502z00_428); } 
{ /* Llib/mpd.scm 406 */
obj_t BgL_arg1505z00_431;
{ /* Llib/mpd.scm 406 */
obj_t BgL_arg1506z00_432;
BgL_arg1506z00_432 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)4)), BGl_mpdzd2playlistzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 406 */
obj_t BgL_list1507z00_433;
BgL_list1507z00_433 = 
MAKE_YOUNG_PAIR(BgL_arg1506z00_432, BNIL); 
BgL_arg1505z00_431 = BgL_list1507z00_433; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1505z00_431); } 
{ /* Llib/mpd.scm 447 */
obj_t BgL_arg1520z00_434;
{ /* Llib/mpd.scm 447 */
obj_t BgL_arg1521z00_435;
BgL_arg1521z00_435 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)5)), BGl_mpdzd2playlistinfozd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 447 */
obj_t BgL_list1522z00_436;
BgL_list1522z00_436 = 
MAKE_YOUNG_PAIR(BgL_arg1521z00_435, BNIL); 
BgL_arg1520z00_434 = BgL_list1522z00_436; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1520z00_434); } 
{ /* Llib/mpd.scm 453 */
obj_t BgL_arg1523z00_437;
{ /* Llib/mpd.scm 453 */
obj_t BgL_arg1537z00_438;
BgL_arg1537z00_438 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)6)), BGl_mpdzd2playlistidzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 453 */
obj_t BgL_list1538z00_439;
BgL_list1538z00_439 = 
MAKE_YOUNG_PAIR(BgL_arg1537z00_438, BNIL); 
BgL_arg1523z00_437 = BgL_list1538z00_439; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1523z00_437); } 
{ /* Llib/mpd.scm 459 */
obj_t BgL_arg1539z00_440;
{ /* Llib/mpd.scm 459 */
obj_t BgL_arg1540z00_441;
BgL_arg1540z00_441 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)7)), BGl_mpdzd2plchangeszd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 459 */
obj_t BgL_list1541z00_442;
BgL_list1541z00_442 = 
MAKE_YOUNG_PAIR(BgL_arg1540z00_441, BNIL); 
BgL_arg1539z00_440 = BgL_list1541z00_442; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1539z00_440); } 
{ /* Llib/mpd.scm 477 */
obj_t BgL_arg1553z00_443;
{ /* Llib/mpd.scm 477 */
obj_t BgL_arg1554z00_444;
BgL_arg1554z00_444 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)8)), BGl_mpdzd2addzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 477 */
obj_t BgL_list1555z00_445;
BgL_list1555z00_445 = 
MAKE_YOUNG_PAIR(BgL_arg1554z00_444, BNIL); 
BgL_arg1553z00_443 = BgL_list1555z00_445; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1553z00_443); } 
{ /* Llib/mpd.scm 493 */
obj_t BgL_arg1576z00_446;
{ /* Llib/mpd.scm 493 */
obj_t BgL_arg1577z00_447;
BgL_arg1577z00_447 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)9)), BGl_mpdzd2deletezd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 493 */
obj_t BgL_list1578z00_448;
BgL_list1578z00_448 = 
MAKE_YOUNG_PAIR(BgL_arg1577z00_447, BNIL); 
BgL_arg1576z00_446 = BgL_list1578z00_448; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1576z00_446); } 
{ /* Llib/mpd.scm 500 */
obj_t BgL_arg1580z00_449;
{ /* Llib/mpd.scm 500 */
obj_t BgL_arg1586z00_450;
BgL_arg1586z00_450 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)10)), BGl_mpdzd2deleteidzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 500 */
obj_t BgL_list1587z00_451;
BgL_list1587z00_451 = 
MAKE_YOUNG_PAIR(BgL_arg1586z00_450, BNIL); 
BgL_arg1580z00_449 = BgL_list1587z00_451; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1580z00_449); } 
{ /* Llib/mpd.scm 507 */
obj_t BgL_arg1589z00_452;
{ /* Llib/mpd.scm 507 */
obj_t BgL_arg1590z00_453;
BgL_arg1590z00_453 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)11)), BGl_mpdzd2clearzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 507 */
obj_t BgL_list1591z00_454;
BgL_list1591z00_454 = 
MAKE_YOUNG_PAIR(BgL_arg1590z00_453, BNIL); 
BgL_arg1589z00_452 = BgL_list1591z00_454; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1589z00_452); } 
BGl_currentsongzd2cachezd2plistz00zz__multimediazd2mpdzd2 = BFALSE; 
BGl_currentsongzd2cachezd2numz00zz__multimediazd2mpdzd2 = ((long)-1); 
BGl_currentsongzd2cachezd2infoz00zz__multimediazd2mpdzd2 = BGl_string3289z00zz__multimediazd2mpdzd2; 
{ /* Llib/mpd.scm 579 */
obj_t BgL_arg1593z00_455;
{ /* Llib/mpd.scm 579 */
obj_t BgL_arg1598z00_456;
BgL_arg1598z00_456 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)12)), BGl_mpdzd2currentsongzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 579 */
obj_t BgL_list1599z00_457;
BgL_list1599z00_457 = 
MAKE_YOUNG_PAIR(BgL_arg1598z00_456, BNIL); 
BgL_arg1593z00_455 = BgL_list1599z00_457; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1593z00_455); } 
{ /* Llib/mpd.scm 589 */
obj_t BgL_arg1604z00_458;
{ /* Llib/mpd.scm 589 */
obj_t BgL_arg1605z00_459;
BgL_arg1605z00_459 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)13)), BGl_mpdzd2playzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 589 */
obj_t BgL_list1606z00_460;
BgL_list1606z00_460 = 
MAKE_YOUNG_PAIR(BgL_arg1605z00_459, BNIL); 
BgL_arg1604z00_458 = BgL_list1606z00_460; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1604z00_458); } 
{ /* Llib/mpd.scm 598 */
obj_t BgL_arg1608z00_461;
{ /* Llib/mpd.scm 598 */
obj_t BgL_arg1609z00_462;
BgL_arg1609z00_462 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)14)), BGl_mpdzd2playidzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 598 */
obj_t BgL_list1610z00_463;
BgL_list1610z00_463 = 
MAKE_YOUNG_PAIR(BgL_arg1609z00_462, BNIL); 
BgL_arg1608z00_461 = BgL_list1610z00_463; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1608z00_461); } 
{ /* Llib/mpd.scm 607 */
obj_t BgL_arg1612z00_464;
{ /* Llib/mpd.scm 607 */
obj_t BgL_arg1613z00_465;
BgL_arg1613z00_465 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)15)), BGl_mpdzd2seekzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 607 */
obj_t BgL_list1614z00_466;
BgL_list1614z00_466 = 
MAKE_YOUNG_PAIR(BgL_arg1613z00_465, BNIL); 
BgL_arg1612z00_464 = BgL_list1614z00_466; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1612z00_464); } 
{ /* Llib/mpd.scm 614 */
obj_t BgL_arg1616z00_467;
{ /* Llib/mpd.scm 614 */
obj_t BgL_arg1619z00_468;
BgL_arg1619z00_468 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)16)), BGl_mpdzd2seekidzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 614 */
obj_t BgL_list1620z00_469;
BgL_list1620z00_469 = 
MAKE_YOUNG_PAIR(BgL_arg1619z00_468, BNIL); 
BgL_arg1616z00_467 = BgL_list1620z00_469; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1616z00_467); } 
{ /* Llib/mpd.scm 621 */
obj_t BgL_arg1625z00_470;
{ /* Llib/mpd.scm 621 */
obj_t BgL_arg1626z00_471;
BgL_arg1626z00_471 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)17)), BGl_mpdzd2stopzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 621 */
obj_t BgL_list1627z00_472;
BgL_list1627z00_472 = 
MAKE_YOUNG_PAIR(BgL_arg1626z00_471, BNIL); 
BgL_arg1625z00_470 = BgL_list1627z00_472; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1625z00_470); } 
{ /* Llib/mpd.scm 628 */
obj_t BgL_arg1628z00_473;
{ /* Llib/mpd.scm 628 */
obj_t BgL_arg1629z00_474;
BgL_arg1629z00_474 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)18)), BGl_mpdzd2pausezd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 628 */
obj_t BgL_list1630z00_475;
BgL_list1630z00_475 = 
MAKE_YOUNG_PAIR(BgL_arg1629z00_474, BNIL); 
BgL_arg1628z00_473 = BgL_list1630z00_475; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1628z00_473); } 
{ /* Llib/mpd.scm 635 */
obj_t BgL_arg1631z00_476;
{ /* Llib/mpd.scm 635 */
obj_t BgL_arg1635z00_477;
BgL_arg1635z00_477 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)19)), BGl_mpdzd2nextzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 635 */
obj_t BgL_list1636z00_478;
BgL_list1636z00_478 = 
MAKE_YOUNG_PAIR(BgL_arg1635z00_477, BNIL); 
BgL_arg1631z00_476 = BgL_list1636z00_478; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1631z00_476); } 
{ /* Llib/mpd.scm 648 */
obj_t BgL_arg1642z00_479;
{ /* Llib/mpd.scm 648 */
obj_t BgL_arg1643z00_480;
BgL_arg1643z00_480 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)20)), BGl_mpdzd2previouszd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 648 */
obj_t BgL_list1644z00_481;
BgL_list1644z00_481 = 
MAKE_YOUNG_PAIR(BgL_arg1643z00_480, BNIL); 
BgL_arg1642z00_479 = BgL_list1644z00_481; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1642z00_479); } 
{ /* Llib/mpd.scm 661 */
obj_t BgL_arg1646z00_482;
{ /* Llib/mpd.scm 661 */
obj_t BgL_arg1650z00_483;
BgL_arg1650z00_483 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)21)), BGl_mpdzd2volumezd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 661 */
obj_t BgL_list1651z00_484;
BgL_list1651z00_484 = 
MAKE_YOUNG_PAIR(BgL_arg1650z00_483, BNIL); 
BgL_arg1646z00_482 = BgL_list1651z00_484; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1646z00_482); } 
{ /* Llib/mpd.scm 684 */
obj_t BgL_arg1652z00_485;
{ /* Llib/mpd.scm 684 */
obj_t BgL_arg1661z00_486;
BgL_arg1661z00_486 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)22)), BGl_mpdzd2setvolzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 684 */
obj_t BgL_list1662z00_487;
BgL_list1662z00_487 = 
MAKE_YOUNG_PAIR(BgL_arg1661z00_486, BNIL); 
BgL_arg1652z00_485 = BgL_list1662z00_487; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1652z00_485); } 
{ /* Llib/mpd.scm 690 */
obj_t BgL_arg1663z00_488;
{ /* Llib/mpd.scm 690 */
obj_t BgL_arg1664z00_489;
BgL_arg1664z00_489 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)23)), BGl_mpdzd2clearerrorzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 690 */
obj_t BgL_list1665z00_490;
BgL_list1665z00_490 = 
MAKE_YOUNG_PAIR(BgL_arg1664z00_489, BNIL); 
BgL_arg1663z00_488 = BgL_list1665z00_490; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1663z00_488); } 
{ /* Llib/mpd.scm 696 */
obj_t BgL_arg1666z00_491;
{ /* Llib/mpd.scm 696 */
obj_t BgL_arg1667z00_492;
BgL_arg1667z00_492 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)24)), BGl_mpdzd2closezd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 696 */
obj_t BgL_list1668z00_493;
BgL_list1668z00_493 = 
MAKE_YOUNG_PAIR(BgL_arg1667z00_492, BNIL); 
BgL_arg1666z00_491 = BgL_list1668z00_493; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1666z00_491); } 
{ /* Llib/mpd.scm 702 */
obj_t BgL_arg1676z00_494;
{ /* Llib/mpd.scm 702 */
obj_t BgL_arg1677z00_495;
BgL_arg1677z00_495 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)25)), BGl_mpdzd2statszd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 702 */
obj_t BgL_list1678z00_496;
BgL_list1678z00_496 = 
MAKE_YOUNG_PAIR(BgL_arg1677z00_495, BNIL); 
BgL_arg1676z00_494 = BgL_list1678z00_496; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1676z00_494); } 
{ /* Llib/mpd.scm 709 */
obj_t BgL_arg1680z00_497;
{ /* Llib/mpd.scm 709 */
obj_t BgL_arg1686z00_498;
BgL_arg1686z00_498 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)26)), BGl_mpdzd2listallzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 709 */
obj_t BgL_list1687z00_499;
BgL_list1687z00_499 = 
MAKE_YOUNG_PAIR(BgL_arg1686z00_498, BNIL); 
BgL_arg1680z00_497 = BgL_list1687z00_499; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1680z00_497); } 
{ /* Llib/mpd.scm 716 */
obj_t BgL_arg1689z00_500;
{ /* Llib/mpd.scm 716 */
obj_t BgL_arg1690z00_501;
BgL_arg1690z00_501 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)27)), BGl_mpdzd2listzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 716 */
obj_t BgL_list1691z00_502;
BgL_list1691z00_502 = 
MAKE_YOUNG_PAIR(BgL_arg1690z00_501, BNIL); 
BgL_arg1689z00_500 = BgL_list1691z00_502; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1689z00_500); } 
{ /* Llib/mpd.scm 745 */
obj_t BgL_arg1693z00_503;
{ /* Llib/mpd.scm 745 */
obj_t BgL_arg1699z00_504;
BgL_arg1699z00_504 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)28)), BGl_mpdzd2listallinfozd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 745 */
obj_t BgL_list1700z00_505;
BgL_list1700z00_505 = 
MAKE_YOUNG_PAIR(BgL_arg1699z00_504, BNIL); 
BgL_arg1693z00_503 = BgL_list1700z00_505; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1693z00_503); } 
{ /* Llib/mpd.scm 752 */
obj_t BgL_arg1711z00_506;
{ /* Llib/mpd.scm 752 */
obj_t BgL_arg1712z00_507;
BgL_arg1712z00_507 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)29)), BGl_mpdzd2lsinfozd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 752 */
obj_t BgL_list1713z00_508;
BgL_list1713z00_508 = 
MAKE_YOUNG_PAIR(BgL_arg1712z00_507, BNIL); 
BgL_arg1711z00_506 = BgL_list1713z00_508; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1711z00_506); } 
{ /* Llib/mpd.scm 759 */
obj_t BgL_arg1716z00_509;
{ /* Llib/mpd.scm 759 */
obj_t BgL_arg1725z00_510;
BgL_arg1725z00_510 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)30)), BGl_mpdzd2plconangesposidzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 759 */
obj_t BgL_list1726z00_511;
BgL_list1726z00_511 = 
MAKE_YOUNG_PAIR(BgL_arg1725z00_510, BNIL); 
BgL_arg1716z00_509 = BgL_list1726z00_511; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1716z00_509); } 
{ /* Llib/mpd.scm 771 */
obj_t BgL_arg1727z00_512;
{ /* Llib/mpd.scm 771 */
obj_t BgL_arg1728z00_513;
BgL_arg1728z00_513 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)31)), BGl_mpdzd2killzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 771 */
obj_t BgL_list1729z00_514;
BgL_list1729z00_514 = 
MAKE_YOUNG_PAIR(BgL_arg1728z00_513, BNIL); 
BgL_arg1727z00_512 = BgL_list1729z00_514; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1727z00_512); } 
{ /* Llib/mpd.scm 777 */
obj_t BgL_arg1730z00_515;
{ /* Llib/mpd.scm 777 */
obj_t BgL_arg1731z00_516;
BgL_arg1731z00_516 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)32)), BGl_mpdzd2findzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 777 */
obj_t BgL_list1732z00_517;
BgL_list1732z00_517 = 
MAKE_YOUNG_PAIR(BgL_arg1731z00_516, BNIL); 
BgL_arg1730z00_515 = BgL_list1732z00_517; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1730z00_515); } 
{ /* Llib/mpd.scm 797 */
obj_t BgL_arg1733z00_518;
{ /* Llib/mpd.scm 797 */
obj_t BgL_arg1734z00_519;
BgL_arg1734z00_519 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)33)), BGl_mpdzd2searchzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 797 */
obj_t BgL_list1735z00_520;
BgL_list1735z00_520 = 
MAKE_YOUNG_PAIR(BgL_arg1734z00_519, BNIL); 
BgL_arg1733z00_518 = BgL_list1735z00_520; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1733z00_518); } 
{ /* Llib/mpd.scm 825 */
obj_t BgL_arg1736z00_521;
{ /* Llib/mpd.scm 825 */
obj_t BgL_arg1737z00_522;
BgL_arg1737z00_522 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)34)), BGl_mpdzd2commandszd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 825 */
obj_t BgL_list1738z00_523;
BgL_list1738z00_523 = 
MAKE_YOUNG_PAIR(BgL_arg1737z00_522, BNIL); 
BgL_arg1736z00_521 = BgL_list1738z00_523; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1736z00_521); } 
{ /* Llib/mpd.scm 839 */
obj_t BgL_arg1739z00_524;
{ /* Llib/mpd.scm 839 */
obj_t BgL_arg1740z00_525;
BgL_arg1740z00_525 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)35)), BGl_mpdzd2notcommandszd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 839 */
obj_t BgL_list1741z00_526;
BgL_list1741z00_526 = 
MAKE_YOUNG_PAIR(BgL_arg1740z00_525, BNIL); 
BgL_arg1739z00_524 = BgL_list1741z00_526; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1739z00_524); } 
{ /* Llib/mpd.scm 853 */
obj_t BgL_arg1742z00_527;
{ /* Llib/mpd.scm 853 */
obj_t BgL_arg1743z00_528;
BgL_arg1743z00_528 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)36)), BGl_mpdzd2addidzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 853 */
obj_t BgL_list1744z00_529;
BgL_list1744z00_529 = 
MAKE_YOUNG_PAIR(BgL_arg1743z00_528, BNIL); 
BgL_arg1742z00_527 = BgL_list1744z00_529; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1742z00_527); } 
{ /* Llib/mpd.scm 858 */
obj_t BgL_arg1745z00_530;
{ /* Llib/mpd.scm 858 */
obj_t BgL_arg1746z00_531;
BgL_arg1746z00_531 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)37)), BGl_mpdzd2crossfadezd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 858 */
obj_t BgL_list1747z00_532;
BgL_list1747z00_532 = 
MAKE_YOUNG_PAIR(BgL_arg1746z00_531, BNIL); 
BgL_arg1745z00_530 = BgL_list1747z00_532; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1745z00_530); } 
{ /* Llib/mpd.scm 863 */
obj_t BgL_arg1748z00_533;
{ /* Llib/mpd.scm 863 */
obj_t BgL_arg1749z00_534;
BgL_arg1749z00_534 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)38)), BGl_mpdzd2movezd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 863 */
obj_t BgL_list1750z00_535;
BgL_list1750z00_535 = 
MAKE_YOUNG_PAIR(BgL_arg1749z00_534, BNIL); 
BgL_arg1748z00_533 = BgL_list1750z00_535; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1748z00_533); } 
{ /* Llib/mpd.scm 868 */
obj_t BgL_arg1751z00_536;
{ /* Llib/mpd.scm 868 */
obj_t BgL_arg1752z00_537;
BgL_arg1752z00_537 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)39)), BGl_mpdzd2moveidzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 868 */
obj_t BgL_list1753z00_538;
BgL_list1753z00_538 = 
MAKE_YOUNG_PAIR(BgL_arg1752z00_537, BNIL); 
BgL_arg1751z00_536 = BgL_list1753z00_538; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1751z00_536); } 
{ /* Llib/mpd.scm 873 */
obj_t BgL_arg1754z00_539;
{ /* Llib/mpd.scm 873 */
obj_t BgL_arg1755z00_540;
BgL_arg1755z00_540 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)40)), BGl_mpdzd2passwordzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 873 */
obj_t BgL_list1756z00_541;
BgL_list1756z00_541 = 
MAKE_YOUNG_PAIR(BgL_arg1755z00_540, BNIL); 
BgL_arg1754z00_539 = BgL_list1756z00_541; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1754z00_539); } 
{ /* Llib/mpd.scm 878 */
obj_t BgL_arg1757z00_542;
{ /* Llib/mpd.scm 878 */
obj_t BgL_arg1758z00_543;
BgL_arg1758z00_543 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)41)), BGl_mpdzd2randomzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 878 */
obj_t BgL_list1759z00_544;
BgL_list1759z00_544 = 
MAKE_YOUNG_PAIR(BgL_arg1758z00_543, BNIL); 
BgL_arg1757z00_542 = BgL_list1759z00_544; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1757z00_542); } 
{ /* Llib/mpd.scm 883 */
obj_t BgL_arg1760z00_545;
{ /* Llib/mpd.scm 883 */
obj_t BgL_arg1761z00_546;
BgL_arg1761z00_546 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)42)), BGl_mpdzd2repeatzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 883 */
obj_t BgL_list1762z00_547;
BgL_list1762z00_547 = 
MAKE_YOUNG_PAIR(BgL_arg1761z00_546, BNIL); 
BgL_arg1760z00_545 = BgL_list1762z00_547; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1760z00_545); } 
{ /* Llib/mpd.scm 888 */
obj_t BgL_arg1763z00_548;
{ /* Llib/mpd.scm 888 */
obj_t BgL_arg1764z00_549;
BgL_arg1764z00_549 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)43)), BGl_mpdzd2rmzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 888 */
obj_t BgL_list1765z00_550;
BgL_list1765z00_550 = 
MAKE_YOUNG_PAIR(BgL_arg1764z00_549, BNIL); 
BgL_arg1763z00_548 = BgL_list1765z00_550; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1763z00_548); } 
{ /* Llib/mpd.scm 893 */
obj_t BgL_arg1766z00_551;
{ /* Llib/mpd.scm 893 */
obj_t BgL_arg1767z00_552;
BgL_arg1767z00_552 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)44)), BGl_mpdzd2savezd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 893 */
obj_t BgL_list1768z00_553;
BgL_list1768z00_553 = 
MAKE_YOUNG_PAIR(BgL_arg1767z00_552, BNIL); 
BgL_arg1766z00_551 = BgL_list1768z00_553; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1766z00_551); } 
{ /* Llib/mpd.scm 898 */
obj_t BgL_arg1769z00_554;
{ /* Llib/mpd.scm 898 */
obj_t BgL_arg1770z00_555;
BgL_arg1770z00_555 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)45)), BGl_mpdzd2shufflezd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 898 */
obj_t BgL_list1771z00_556;
BgL_list1771z00_556 = 
MAKE_YOUNG_PAIR(BgL_arg1770z00_555, BNIL); 
BgL_arg1769z00_554 = BgL_list1771z00_556; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1769z00_554); } 
{ /* Llib/mpd.scm 903 */
obj_t BgL_arg1772z00_557;
{ /* Llib/mpd.scm 903 */
obj_t BgL_arg1773z00_558;
BgL_arg1773z00_558 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)46)), BGl_mpdzd2swapzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 903 */
obj_t BgL_list1774z00_559;
BgL_list1774z00_559 = 
MAKE_YOUNG_PAIR(BgL_arg1773z00_558, BNIL); 
BgL_arg1772z00_557 = BgL_list1774z00_559; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1772z00_557); } 
{ /* Llib/mpd.scm 908 */
obj_t BgL_arg1775z00_560;
{ /* Llib/mpd.scm 908 */
obj_t BgL_arg1776z00_561;
BgL_arg1776z00_561 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)47)), BGl_mpdzd2swapidzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 908 */
obj_t BgL_list1777z00_562;
BgL_list1777z00_562 = 
MAKE_YOUNG_PAIR(BgL_arg1776z00_561, BNIL); 
BgL_arg1775z00_560 = BgL_list1777z00_562; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1775z00_560); } 
{ /* Llib/mpd.scm 913 */
obj_t BgL_arg1778z00_563;
{ /* Llib/mpd.scm 913 */
obj_t BgL_arg1779z00_564;
BgL_arg1779z00_564 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)48)), BGl_mpdzd2updatezd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 913 */
obj_t BgL_list1780z00_565;
BgL_list1780z00_565 = 
MAKE_YOUNG_PAIR(BgL_arg1779z00_564, BNIL); 
BgL_arg1778z00_563 = BgL_list1780z00_565; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1778z00_563); } 
{ /* Llib/mpd.scm 918 */
obj_t BgL_arg1781z00_566;
{ /* Llib/mpd.scm 918 */
obj_t BgL_arg1782z00_567;
BgL_arg1782z00_567 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)49)), BGl_mpdzd2outputszd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 918 */
obj_t BgL_list1783z00_568;
BgL_list1783z00_568 = 
MAKE_YOUNG_PAIR(BgL_arg1782z00_567, BNIL); 
BgL_arg1781z00_566 = BgL_list1783z00_568; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1781z00_566); } 
return BUNSPEC;} 

}



/* get-line-command */
obj_t BGl_getzd2linezd2commandz00zz__multimediazd2mpdzd2(obj_t BgL_linez00_6)
{
{ /* Llib/mpd.scm 161 */
{ /* Llib/mpd.scm 162 */
obj_t BgL_iz00_579;
BgL_iz00_579 = 
BGl_stringzd2indexzd2zz__r4_strings_6_7z00(BgL_linez00_6, 
BCHAR(((unsigned char)' ')), 
BINT(((long)0))); 
if(
CBOOL(BgL_iz00_579))
{ /* Llib/mpd.scm 164 */
obj_t BgL_arg1787z00_580;
{ /* Llib/mpd.scm 164 */
obj_t BgL_res2680z00_2458;
{ /* Llib/mpd.scm 164 */
long BgL_endz00_2457;
BgL_endz00_2457 = 
(long)CINT(BgL_iz00_579); 
BgL_res2680z00_2458 = 
c_substring(
((obj_t)BgL_linez00_6), ((long)0), BgL_endz00_2457); } 
BgL_arg1787z00_580 = BgL_res2680z00_2458; } 
return 
bstring_to_symbol(BgL_arg1787z00_580);}  else 
{ /* Llib/mpd.scm 165 */
obj_t BgL_res2682z00_2462;
BgL_res2682z00_2462 = 
bstring_to_symbol(
((obj_t)BgL_linez00_6)); 
return BgL_res2682z00_2462;} } } 

}



/* get-line-arg-string-nth */
obj_t BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(obj_t BgL_linez00_7, long BgL_numz00_8)
{
{ /* Llib/mpd.scm 170 */
{ 
obj_t BgL_iz00_594;long BgL_lenz00_595;
{ /* Llib/mpd.scm 182 */
obj_t BgL_i0z00_582;long BgL_lenz00_583;
{ /* Llib/mpd.scm 155 */
obj_t BgL_jz00_2494;
BgL_jz00_2494 = 
BGl_stringzd2indexzd2zz__r4_strings_6_7z00(BgL_linez00_7, 
BCHAR(((unsigned char)' ')), 
BINT(((long)0))); 
if(
CBOOL(BgL_jz00_2494))
{ /* Llib/mpd.scm 156 */
obj_t BgL__ortest_1079z00_2495;
BgL__ortest_1079z00_2495 = 
BGl_stringzd2skipzd2zz__r4_strings_6_7z00(BgL_linez00_7, 
BCHAR(((unsigned char)' ')), BgL_jz00_2494); 
if(
CBOOL(BgL__ortest_1079z00_2495))
{ /* Llib/mpd.scm 156 */
BgL_i0z00_582 = BgL__ortest_1079z00_2495; }  else 
{ /* Llib/mpd.scm 156 */
BgL_i0z00_582 = BgL_jz00_2494; } }  else 
{ /* Llib/mpd.scm 156 */
BgL_i0z00_582 = BFALSE; } } 
BgL_lenz00_583 = 
STRING_LENGTH(
((obj_t)BgL_linez00_7)); 
if(
CBOOL(BgL_i0z00_582))
{ /* Llib/mpd.scm 185 */
long BgL_g1085z00_584;
BgL_g1085z00_584 = 
(BgL_numz00_8-((long)1)); 
{ 
long BgL_nz00_586;obj_t BgL_iz00_587;
BgL_nz00_586 = BgL_g1085z00_584; 
BgL_iz00_587 = BgL_i0z00_582; 
BgL_zc3z04anonymousza31788ze3z87_588:
if(
CBOOL(BgL_iz00_587))
{ /* Llib/mpd.scm 188 */
if(
(BgL_nz00_586==((long)0)))
{ /* Llib/mpd.scm 190 */
if(
CBOOL(BgL_iz00_587))
{ /* Llib/mpd.scm 191 */
BgL_iz00_594 = BgL_iz00_587; 
BgL_lenz00_595 = BgL_lenz00_583; 
if(
(
(long)CINT(BgL_iz00_594)<BgL_lenz00_595))
{ /* Llib/mpd.scm 172 */
if(
(((unsigned char)'"')==
STRING_REF(
((obj_t)BgL_linez00_7), 
(long)CINT(BgL_iz00_594))))
{ /* Llib/mpd.scm 174 */
obj_t BgL_jz00_600;
{ /* Llib/mpd.scm 174 */
long BgL_arg1799z00_603;
BgL_arg1799z00_603 = 
(
(long)CINT(BgL_iz00_594)+((long)1)); 
BgL_jz00_600 = 
BGl_stringzd2indexzd2zz__r4_strings_6_7z00(BgL_linez00_7, 
BCHAR(((unsigned char)'"')), 
BINT(BgL_arg1799z00_603)); } 
if(
CBOOL(BgL_jz00_600))
{ /* Llib/mpd.scm 176 */
long BgL_arg1797z00_601;
BgL_arg1797z00_601 = 
(
(long)CINT(BgL_iz00_594)+((long)1)); 
{ /* Llib/mpd.scm 176 */
obj_t BgL_res2688z00_2479;
{ /* Llib/mpd.scm 176 */
long BgL_endz00_2478;
BgL_endz00_2478 = 
(long)CINT(BgL_jz00_600); 
BgL_res2688z00_2479 = 
c_substring(
((obj_t)BgL_linez00_7), BgL_arg1797z00_601, BgL_endz00_2478); } 
return BgL_res2688z00_2479;} }  else 
{ /* Llib/mpd.scm 177 */
long BgL_arg1798z00_602;
BgL_arg1798z00_602 = 
(
(long)CINT(BgL_iz00_594)+((long)1)); 
{ /* Llib/mpd.scm 177 */
obj_t BgL_res2690z00_2485;
BgL_res2690z00_2485 = 
c_substring(
((obj_t)BgL_linez00_7), BgL_arg1798z00_602, BgL_lenz00_595); 
return BgL_res2690z00_2485;} } }  else 
{ /* Llib/mpd.scm 178 */
obj_t BgL_jz00_604;
BgL_jz00_604 = 
BGl_stringzd2indexzd2zz__r4_strings_6_7z00(BgL_linez00_7, 
BCHAR(((unsigned char)' ')), BgL_iz00_594); 
if(
CBOOL(BgL_jz00_604))
{ /* Llib/mpd.scm 180 */
obj_t BgL_res2691z00_2489;
{ /* Llib/mpd.scm 180 */
long BgL_startz00_2487;long BgL_endz00_2488;
BgL_startz00_2487 = 
(long)CINT(BgL_iz00_594); 
BgL_endz00_2488 = 
(long)CINT(BgL_jz00_604); 
BgL_res2691z00_2489 = 
c_substring(
((obj_t)BgL_linez00_7), BgL_startz00_2487, BgL_endz00_2488); } 
return BgL_res2691z00_2489;}  else 
{ /* Llib/mpd.scm 181 */
obj_t BgL_res2692z00_2493;
{ /* Llib/mpd.scm 181 */
long BgL_startz00_2491;
BgL_startz00_2491 = 
(long)CINT(BgL_iz00_594); 
BgL_res2692z00_2493 = 
c_substring(
((obj_t)BgL_linez00_7), BgL_startz00_2491, BgL_lenz00_595); } 
return BgL_res2692z00_2493;} } }  else 
{ /* Llib/mpd.scm 172 */
return BFALSE;} }  else 
{ /* Llib/mpd.scm 191 */
return BFALSE;} }  else 
{ /* Llib/mpd.scm 190 */
if(
(
(long)CINT(BgL_iz00_587)<BgL_lenz00_583))
{ /* Llib/mpd.scm 193 */
long BgL_arg1791z00_591;obj_t BgL_arg1792z00_592;
BgL_arg1791z00_591 = 
(BgL_nz00_586-((long)1)); 
{ /* Llib/mpd.scm 155 */
obj_t BgL_jz00_2507;
BgL_jz00_2507 = 
BGl_stringzd2indexzd2zz__r4_strings_6_7z00(BgL_linez00_7, 
BCHAR(((unsigned char)' ')), BgL_iz00_587); 
if(
CBOOL(BgL_jz00_2507))
{ /* Llib/mpd.scm 156 */
obj_t BgL__ortest_1079z00_2508;
BgL__ortest_1079z00_2508 = 
BGl_stringzd2skipzd2zz__r4_strings_6_7z00(BgL_linez00_7, 
BCHAR(((unsigned char)' ')), BgL_jz00_2507); 
if(
CBOOL(BgL__ortest_1079z00_2508))
{ /* Llib/mpd.scm 156 */
BgL_arg1792z00_592 = BgL__ortest_1079z00_2508; }  else 
{ /* Llib/mpd.scm 156 */
BgL_arg1792z00_592 = BgL_jz00_2507; } }  else 
{ /* Llib/mpd.scm 156 */
BgL_arg1792z00_592 = BFALSE; } } 
{ 
obj_t BgL_iz00_6193;long BgL_nz00_6192;
BgL_nz00_6192 = BgL_arg1791z00_591; 
BgL_iz00_6193 = BgL_arg1792z00_592; 
BgL_iz00_587 = BgL_iz00_6193; 
BgL_nz00_586 = BgL_nz00_6192; 
goto BgL_zc3z04anonymousza31788ze3z87_588;} }  else 
{ /* Llib/mpd.scm 192 */
return BFALSE;} } }  else 
{ /* Llib/mpd.scm 188 */
return BFALSE;} } }  else 
{ /* Llib/mpd.scm 184 */
return BFALSE;} } } } 

}



/* get-line-arg-symbol-nth */
obj_t BGl_getzd2linezd2argzd2symbolzd2nthz00zz__multimediazd2mpdzd2(obj_t BgL_linez00_9, long BgL_numz00_10)
{
{ /* Llib/mpd.scm 198 */
{ 
obj_t BgL_iz00_620;long BgL_lenz00_621;
{ /* Llib/mpd.scm 205 */
obj_t BgL_i0z00_608;long BgL_lenz00_609;
{ /* Llib/mpd.scm 155 */
obj_t BgL_jz00_2524;
BgL_jz00_2524 = 
BGl_stringzd2indexzd2zz__r4_strings_6_7z00(BgL_linez00_9, 
BCHAR(((unsigned char)' ')), 
BINT(((long)0))); 
if(
CBOOL(BgL_jz00_2524))
{ /* Llib/mpd.scm 156 */
obj_t BgL__ortest_1079z00_2525;
BgL__ortest_1079z00_2525 = 
BGl_stringzd2skipzd2zz__r4_strings_6_7z00(BgL_linez00_9, 
BCHAR(((unsigned char)' ')), BgL_jz00_2524); 
if(
CBOOL(BgL__ortest_1079z00_2525))
{ /* Llib/mpd.scm 156 */
BgL_i0z00_608 = BgL__ortest_1079z00_2525; }  else 
{ /* Llib/mpd.scm 156 */
BgL_i0z00_608 = BgL_jz00_2524; } }  else 
{ /* Llib/mpd.scm 156 */
BgL_i0z00_608 = BFALSE; } } 
BgL_lenz00_609 = 
STRING_LENGTH(
((obj_t)BgL_linez00_9)); 
if(
CBOOL(BgL_i0z00_608))
{ /* Llib/mpd.scm 208 */
long BgL_g1086z00_610;
BgL_g1086z00_610 = 
(BgL_numz00_10-((long)1)); 
{ 
long BgL_nz00_612;obj_t BgL_iz00_613;
BgL_nz00_612 = BgL_g1086z00_610; 
BgL_iz00_613 = BgL_i0z00_608; 
BgL_zc3z04anonymousza31801ze3z87_614:
if(
CBOOL(BgL_iz00_613))
{ /* Llib/mpd.scm 211 */
if(
(BgL_nz00_612==((long)0)))
{ /* Llib/mpd.scm 213 */
BgL_iz00_620 = BgL_iz00_613; 
BgL_lenz00_621 = BgL_lenz00_609; 
if(
(
(long)CINT(BgL_iz00_620)<BgL_lenz00_621))
{ /* Llib/mpd.scm 201 */
obj_t BgL_jz00_624;
BgL_jz00_624 = 
BGl_stringzd2indexzd2zz__r4_strings_6_7z00(BgL_linez00_9, 
BCHAR(((unsigned char)' ')), BgL_iz00_620); 
if(
CBOOL(BgL_jz00_624))
{ /* Llib/mpd.scm 203 */
obj_t BgL_arg1808z00_625;
{ /* Llib/mpd.scm 203 */
obj_t BgL_arg1809z00_626;
{ /* Llib/mpd.scm 203 */
obj_t BgL_res2699z00_2515;
{ /* Llib/mpd.scm 203 */
long BgL_startz00_2513;long BgL_endz00_2514;
BgL_startz00_2513 = 
(long)CINT(BgL_iz00_620); 
BgL_endz00_2514 = 
(long)CINT(BgL_jz00_624); 
BgL_res2699z00_2515 = 
c_substring(
((obj_t)BgL_linez00_9), BgL_startz00_2513, BgL_endz00_2514); } 
BgL_arg1809z00_626 = BgL_res2699z00_2515; } 
BgL_arg1808z00_625 = 
BGl_stringzd2downcasez12zc0zz__r4_strings_6_7z00(BgL_arg1809z00_626); } 
return 
bstring_to_symbol(BgL_arg1808z00_625);}  else 
{ /* Llib/mpd.scm 204 */
obj_t BgL_arg1810z00_627;
{ /* Llib/mpd.scm 204 */
obj_t BgL_arg1811z00_628;
{ /* Llib/mpd.scm 204 */
obj_t BgL_res2701z00_2521;
{ /* Llib/mpd.scm 204 */
long BgL_startz00_2519;
BgL_startz00_2519 = 
(long)CINT(BgL_iz00_620); 
BgL_res2701z00_2521 = 
c_substring(
((obj_t)BgL_linez00_9), BgL_startz00_2519, BgL_lenz00_621); } 
BgL_arg1811z00_628 = BgL_res2701z00_2521; } 
BgL_arg1810z00_627 = 
BGl_stringzd2downcasez12zc0zz__r4_strings_6_7z00(BgL_arg1811z00_628); } 
return 
bstring_to_symbol(BgL_arg1810z00_627);} }  else 
{ /* Llib/mpd.scm 200 */
return BFALSE;} }  else 
{ /* Llib/mpd.scm 213 */
if(
(
(long)CINT(BgL_iz00_613)<BgL_lenz00_609))
{ /* Llib/mpd.scm 216 */
long BgL_arg1804z00_617;obj_t BgL_arg1805z00_618;
BgL_arg1804z00_617 = 
(BgL_nz00_612-((long)1)); 
{ /* Llib/mpd.scm 155 */
obj_t BgL_jz00_2537;
BgL_jz00_2537 = 
BGl_stringzd2indexzd2zz__r4_strings_6_7z00(BgL_linez00_9, 
BCHAR(((unsigned char)' ')), BgL_iz00_613); 
if(
CBOOL(BgL_jz00_2537))
{ /* Llib/mpd.scm 156 */
obj_t BgL__ortest_1079z00_2538;
BgL__ortest_1079z00_2538 = 
BGl_stringzd2skipzd2zz__r4_strings_6_7z00(BgL_linez00_9, 
BCHAR(((unsigned char)' ')), BgL_jz00_2537); 
if(
CBOOL(BgL__ortest_1079z00_2538))
{ /* Llib/mpd.scm 156 */
BgL_arg1805z00_618 = BgL__ortest_1079z00_2538; }  else 
{ /* Llib/mpd.scm 156 */
BgL_arg1805z00_618 = BgL_jz00_2537; } }  else 
{ /* Llib/mpd.scm 156 */
BgL_arg1805z00_618 = BFALSE; } } 
{ 
obj_t BgL_iz00_6243;long BgL_nz00_6242;
BgL_nz00_6242 = BgL_arg1804z00_617; 
BgL_iz00_6243 = BgL_arg1805z00_618; 
BgL_iz00_613 = BgL_iz00_6243; 
BgL_nz00_612 = BgL_nz00_6242; 
goto BgL_zc3z04anonymousza31801ze3z87_614;} }  else 
{ /* Llib/mpd.scm 215 */
return BFALSE;} } }  else 
{ /* Llib/mpd.scm 211 */
return BFALSE;} } }  else 
{ /* Llib/mpd.scm 207 */
return BFALSE;} } } } 

}



/* _mpd */
obj_t BGl__mpdz00zz__multimediazd2mpdzd2(obj_t BgL_envz00_19, obj_t BgL_opt1320z00_18)
{
{ /* Llib/mpd.scm 230 */
{ 
obj_t BgL_k1z00_633;long BgL_iz00_634;
{ /* Llib/mpd.scm 230 */
obj_t BgL_g1326z00_636;obj_t BgL_g1327z00_637;obj_t BgL_g1328z00_638;obj_t BgL_g1329z00_639;
BgL_g1326z00_636 = 
VECTOR_REF(BgL_opt1320z00_18,((long)0)); 
BgL_g1327z00_637 = 
VECTOR_REF(BgL_opt1320z00_18,((long)1)); 
BgL_g1328z00_638 = 
VECTOR_REF(BgL_opt1320z00_18,((long)2)); 
BgL_g1329z00_639 = 
VECTOR_REF(BgL_opt1320z00_18,((long)3)); 
{ /* Llib/mpd.scm 230 */
obj_t BgL_logz00_640;
BgL_logz00_640 = BFALSE; 
{ /* Llib/mpd.scm 230 */

{ 
long BgL_iz00_641;
BgL_iz00_641 = ((long)4); 
BgL_check1323z00_642:
if(
(BgL_iz00_641==
VECTOR_LENGTH(BgL_opt1320z00_18)))
{ /* Llib/mpd.scm 230 */BNIL; }  else 
{ /* Llib/mpd.scm 230 */
bool_t BgL_test3758z00_6251;
{ /* Llib/mpd.scm 230 */
obj_t BgL_arg1818z00_648;
BgL_arg1818z00_648 = 
VECTOR_REF(BgL_opt1320z00_18,BgL_iz00_641); 
BgL_test3758z00_6251 = 
CBOOL(
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_arg1818z00_648, 
CNST_TABLE_REF(((long)51)))); } 
if(BgL_test3758z00_6251)
{ 
long BgL_iz00_6256;
BgL_iz00_6256 = 
(BgL_iz00_641+((long)2)); 
BgL_iz00_641 = BgL_iz00_6256; 
goto BgL_check1323z00_642;}  else 
{ /* Llib/mpd.scm 230 */
obj_t BgL_arg1817z00_647;
BgL_arg1817z00_647 = 
VECTOR_REF(BgL_opt1320z00_18,BgL_iz00_641); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)50)), BGl_string3291z00zz__multimediazd2mpdzd2, BgL_arg1817z00_647); } } } 
{ /* Llib/mpd.scm 230 */
obj_t BgL_index1325z00_649;
BgL_k1z00_633 = 
CNST_TABLE_REF(((long)52)); 
BgL_iz00_634 = ((long)4); 
BgL_search1322z00_635:
if(
(BgL_iz00_634==
VECTOR_LENGTH(BgL_opt1320z00_18)))
{ /* Llib/mpd.scm 230 */
BgL_index1325z00_649 = 
BINT(((long)-1)); }  else 
{ /* Llib/mpd.scm 230 */
if(
(BgL_iz00_634==
(
VECTOR_LENGTH(BgL_opt1320z00_18)-((long)1))))
{ /* Llib/mpd.scm 230 */
BgL_index1325z00_649 = 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)50)), BGl_string3290z00zz__multimediazd2mpdzd2, 
BINT(
VECTOR_LENGTH(BgL_opt1320z00_18))); }  else 
{ /* Llib/mpd.scm 230 */
obj_t BgL_vz00_660;
BgL_vz00_660 = 
VECTOR_REF(BgL_opt1320z00_18,BgL_iz00_634); 
if(
(BgL_vz00_660==BgL_k1z00_633))
{ /* Llib/mpd.scm 230 */
BgL_index1325z00_649 = 
BINT(
(BgL_iz00_634+((long)1))); }  else 
{ 
long BgL_iz00_6278;
BgL_iz00_6278 = 
(BgL_iz00_634+((long)2)); 
BgL_iz00_634 = BgL_iz00_6278; 
goto BgL_search1322z00_635;} } } 
{ /* Llib/mpd.scm 230 */
bool_t BgL_test3762z00_6281;
{ /* Llib/mpd.scm 230 */
long BgL_n1z00_2564;
{ /* Llib/mpd.scm 230 */
obj_t BgL_tmpz00_6282;
if(
INTEGERP(BgL_index1325z00_649))
{ /* Llib/mpd.scm 230 */
BgL_tmpz00_6282 = BgL_index1325z00_649
; }  else 
{ 
obj_t BgL_auxz00_6285;
BgL_auxz00_6285 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3292z00zz__multimediazd2mpdzd2, 
BINT(((long)9602)), BGl_string3293z00zz__multimediazd2mpdzd2, BGl_string3294z00zz__multimediazd2mpdzd2, BgL_index1325z00_649); 
FAILURE(BgL_auxz00_6285,BFALSE,BFALSE);} 
BgL_n1z00_2564 = 
(long)CINT(BgL_tmpz00_6282); } 
BgL_test3762z00_6281 = 
(BgL_n1z00_2564>=((long)0)); } 
if(BgL_test3762z00_6281)
{ 
long BgL_auxz00_6291;
{ /* Llib/mpd.scm 230 */
obj_t BgL_tmpz00_6292;
if(
INTEGERP(BgL_index1325z00_649))
{ /* Llib/mpd.scm 230 */
BgL_tmpz00_6292 = BgL_index1325z00_649
; }  else 
{ 
obj_t BgL_auxz00_6295;
BgL_auxz00_6295 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3292z00zz__multimediazd2mpdzd2, 
BINT(((long)9602)), BGl_string3293z00zz__multimediazd2mpdzd2, BGl_string3294z00zz__multimediazd2mpdzd2, BgL_index1325z00_649); 
FAILURE(BgL_auxz00_6295,BFALSE,BFALSE);} 
BgL_auxz00_6291 = 
(long)CINT(BgL_tmpz00_6292); } 
BgL_logz00_640 = 
VECTOR_REF(BgL_opt1320z00_18,BgL_auxz00_6291); }  else 
{ /* Llib/mpd.scm 230 */BFALSE; } } } 
{ /* Llib/mpd.scm 230 */
obj_t BgL_arg1820z00_651;obj_t BgL_arg1821z00_652;obj_t BgL_arg1822z00_653;obj_t BgL_arg1823z00_654;
BgL_arg1820z00_651 = 
VECTOR_REF(BgL_opt1320z00_18,((long)0)); 
BgL_arg1821z00_652 = 
VECTOR_REF(BgL_opt1320z00_18,((long)1)); 
BgL_arg1822z00_653 = 
VECTOR_REF(BgL_opt1320z00_18,((long)2)); 
BgL_arg1823z00_654 = 
VECTOR_REF(BgL_opt1320z00_18,((long)3)); 
{ /* Llib/mpd.scm 230 */
obj_t BgL_logz00_655;
BgL_logz00_655 = BgL_logz00_640; 
{ /* Llib/mpd.scm 230 */
BgL_mpdzd2databasezd2_bglt BgL_auxz00_6327;obj_t BgL_auxz00_6320;obj_t BgL_auxz00_6313;BgL_musicz00_bglt BgL_auxz00_6305;
if(
BGl_isazf3zf3zz__objectz00(BgL_arg1823z00_654, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 230 */
BgL_auxz00_6327 = 
((BgL_mpdzd2databasezd2_bglt)BgL_arg1823z00_654)
; }  else 
{ 
obj_t BgL_auxz00_6331;
BgL_auxz00_6331 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3292z00zz__multimediazd2mpdzd2, 
BINT(((long)9602)), BGl_string3293z00zz__multimediazd2mpdzd2, BGl_string3298z00zz__multimediazd2mpdzd2, BgL_arg1823z00_654); 
FAILURE(BgL_auxz00_6331,BFALSE,BFALSE);} 
if(
OUTPUT_PORTP(BgL_arg1822z00_653))
{ /* Llib/mpd.scm 230 */
BgL_auxz00_6320 = BgL_arg1822z00_653
; }  else 
{ 
obj_t BgL_auxz00_6323;
BgL_auxz00_6323 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3292z00zz__multimediazd2mpdzd2, 
BINT(((long)9602)), BGl_string3293z00zz__multimediazd2mpdzd2, BGl_string3297z00zz__multimediazd2mpdzd2, BgL_arg1822z00_653); 
FAILURE(BgL_auxz00_6323,BFALSE,BFALSE);} 
if(
INPUT_PORTP(BgL_arg1821z00_652))
{ /* Llib/mpd.scm 230 */
BgL_auxz00_6313 = BgL_arg1821z00_652
; }  else 
{ 
obj_t BgL_auxz00_6316;
BgL_auxz00_6316 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3292z00zz__multimediazd2mpdzd2, 
BINT(((long)9602)), BGl_string3293z00zz__multimediazd2mpdzd2, BGl_string3296z00zz__multimediazd2mpdzd2, BgL_arg1821z00_652); 
FAILURE(BgL_auxz00_6316,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_arg1820z00_651, BGl_musicz00zz__multimediazd2musiczd2))
{ /* Llib/mpd.scm 230 */
BgL_auxz00_6305 = 
((BgL_musicz00_bglt)BgL_arg1820z00_651)
; }  else 
{ 
obj_t BgL_auxz00_6309;
BgL_auxz00_6309 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3292z00zz__multimediazd2mpdzd2, 
BINT(((long)9602)), BGl_string3293z00zz__multimediazd2mpdzd2, BGl_string3295z00zz__multimediazd2mpdzd2, BgL_arg1820z00_651); 
FAILURE(BgL_auxz00_6309,BFALSE,BFALSE);} 
return 
BGl_mpdz00zz__multimediazd2mpdzd2(BgL_auxz00_6305, BgL_auxz00_6313, BgL_auxz00_6320, BgL_auxz00_6327, BgL_logz00_655);} } } } } } } } 

}



/* mpd */
BGL_EXPORTED_DEF obj_t BGl_mpdz00zz__multimediazd2mpdzd2(BgL_musicz00_bglt BgL_backendz00_13, obj_t BgL_ipz00_14, obj_t BgL_opz00_15, BgL_mpdzd2databasezd2_bglt BgL_dbz00_16, obj_t BgL_logz00_17)
{
{ /* Llib/mpd.scm 230 */
bgl_display_obj(BGl_string3299z00zz__multimediazd2mpdzd2, BgL_opz00_15); 
bgl_display_char(((unsigned char)10), BgL_opz00_15); 
bgl_flush_output_port(BgL_opz00_15); 
{ 

BgL_zc3z04anonymousza31832ze3z87_666:
if(
BGl_musiczd2closedzf3z21zz__multimediazd2musiczd2(BgL_backendz00_13))
{ /* Llib/mpd.scm 237 */
return BFALSE;}  else 
{ /* Llib/mpd.scm 238 */
obj_t BgL_linez00_668;
BgL_linez00_668 = 
BGl_readzd2linezd2zz__r4_input_6_10_2z00(BgL_ipz00_14); 
BGl_cmdnz00zz__multimediazd2mpdzd2 = 
(((long)1)+BGl_cmdnz00zz__multimediazd2mpdzd2); 
if(
CBOOL(BgL_logz00_17))
{ /* Llib/mpd.scm 240 */
PROCEDURE_ENTRY(BgL_logz00_17)(BgL_logz00_17, BgL_linez00_668, BEOA); }  else 
{ /* Llib/mpd.scm 240 */BFALSE; } 
{ /* Llib/mpd.scm 241 */
bool_t BgL_test3771z00_6349;
{ /* Llib/mpd.scm 241 */
bool_t BgL_res2718z00_2570;
BgL_res2718z00_2570 = 
EOF_OBJECTP(BgL_linez00_668); 
BgL_test3771z00_6349 = BgL_res2718z00_2570; } 
if(BgL_test3771z00_6349)
{ /* Llib/mpd.scm 241 */
return BFALSE;}  else 
{ /* Llib/mpd.scm 242 */
obj_t BgL_vz00_670;
BgL_vz00_670 = 
BGl_executezd2commandzd2zz__multimediazd2mpdzd2(BgL_dbz00_16, BgL_backendz00_13, BgL_ipz00_14, BgL_opz00_15, BgL_linez00_668); 
if(
(BgL_vz00_670==
CNST_TABLE_REF(((long)53))))
{ /* Llib/mpd.scm 243 */
bgl_display_string(BGl_string3300z00zz__multimediazd2mpdzd2, BgL_opz00_15); 
bgl_flush_output_port(BgL_opz00_15); 
bgl_flush_output_port(BgL_opz00_15); 
goto BgL_zc3z04anonymousza31832ze3z87_666;}  else 
{ /* Llib/mpd.scm 243 */
bool_t BgL_test3773z00_6358;
{ /* Llib/mpd.scm 243 */
bool_t BgL__ortest_1088z00_678;
BgL__ortest_1088z00_678 = 
(BgL_vz00_670==
CNST_TABLE_REF(((long)24))); 
if(BgL__ortest_1088z00_678)
{ /* Llib/mpd.scm 243 */
BgL_test3773z00_6358 = BgL__ortest_1088z00_678
; }  else 
{ /* Llib/mpd.scm 243 */
BgL_test3773z00_6358 = 
(BgL_vz00_670==
CNST_TABLE_REF(((long)31)))
; } } 
if(BgL_test3773z00_6358)
{ /* Llib/mpd.scm 243 */
return 
bgl_flush_output_port(BgL_opz00_15);}  else 
{ /* Llib/mpd.scm 243 */
if(
(BgL_vz00_670==
CNST_TABLE_REF(((long)54))))
{ /* Llib/mpd.scm 243 */
goto BgL_zc3z04anonymousza31832ze3z87_666;}  else 
{ /* Llib/mpd.scm 243 */
bgl_display_string(BGl_string3301z00zz__multimediazd2mpdzd2, BgL_opz00_15); 
bgl_display_obj(BGl_string3302z00zz__multimediazd2mpdzd2, BgL_opz00_15); 
bgl_display_string(BGl_string3303z00zz__multimediazd2mpdzd2, BgL_opz00_15); 
bgl_display_obj(BGl_string3289z00zz__multimediazd2mpdzd2, BgL_opz00_15); 
bgl_display_string(BGl_string3304z00zz__multimediazd2mpdzd2, BgL_opz00_15); 
bgl_display_obj(BgL_vz00_670, BgL_opz00_15); 
bgl_display_string(BGl_string3305z00zz__multimediazd2mpdzd2, BgL_opz00_15); 
bgl_flush_output_port(BgL_opz00_15); 
CNST_TABLE_REF(((long)54)); 
goto BgL_zc3z04anonymousza31832ze3z87_666;} } } } } } } } 

}



/* execute-command */
obj_t BGl_executezd2commandzd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_dbz00_20, BgL_musicz00_bglt BgL_backendz00_21, obj_t BgL_ipz00_22, obj_t BgL_opz00_23, obj_t BgL_linez00_24)
{
{ /* Llib/mpd.scm 259 */
{ /* Llib/mpd.scm 260 */
obj_t BgL_cmdz00_680;
BgL_cmdz00_680 = 
BGl_getzd2linezd2commandz00zz__multimediazd2mpdzd2(BgL_linez00_24); 
{ /* Llib/mpd.scm 262 */
bool_t BgL_test3776z00_6378;
if(
(BgL_cmdz00_680==
CNST_TABLE_REF(((long)55))))
{ /* Llib/mpd.scm 262 */
BgL_test3776z00_6378 = ((bool_t)1)
; }  else 
{ /* Llib/mpd.scm 262 */
BgL_test3776z00_6378 = 
(BgL_cmdz00_680==
CNST_TABLE_REF(((long)56)))
; } 
if(BgL_test3776z00_6378)
{ /* Llib/mpd.scm 262 */
return 
BGl_mpdzd2listzd2beginz00zz__multimediazd2mpdzd2(BgL_dbz00_20, BgL_backendz00_21, BgL_ipz00_22, BgL_opz00_23, BgL_cmdz00_680);}  else 
{ /* Llib/mpd.scm 265 */
obj_t BgL_g1090z00_683;
BgL_g1090z00_683 = 
BGl_assqz00zz__r4_pairs_and_lists_6_3z00(BgL_cmdz00_680, BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2); 
if(
CBOOL(BgL_g1090z00_683))
{ /* Llib/mpd.scm 267 */
obj_t BgL_fun1840z00_686;
BgL_fun1840z00_686 = 
CDR(
((obj_t)BgL_g1090z00_683)); 
return 
PROCEDURE_ENTRY(BgL_fun1840z00_686)(BgL_fun1840z00_686, 
((obj_t)BgL_dbz00_20), 
((obj_t)BgL_backendz00_21), BgL_linez00_24, BgL_ipz00_22, BgL_opz00_23, BEOA);}  else 
{ /* Llib/mpd.scm 268 */
obj_t BgL_g1092z00_687;
BgL_g1092z00_687 = 
BGl_assqz00zz__r4_pairs_and_lists_6_3z00(BgL_cmdz00_680, BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2); 
if(
CBOOL(BgL_g1092z00_687))
{ /* Llib/mpd.scm 270 */
obj_t BgL_fun1841z00_690;
BgL_fun1841z00_690 = 
CDR(
((obj_t)BgL_g1092z00_687)); 
return 
PROCEDURE_ENTRY(BgL_fun1841z00_690)(BgL_fun1841z00_690, 
((obj_t)BgL_dbz00_20), 
((obj_t)BgL_backendz00_21), BgL_linez00_24, BgL_ipz00_22, BgL_opz00_23, BEOA);}  else 
{ /* Llib/mpd.scm 268 */
if(
(
STRING_LENGTH(BgL_linez00_24)>((long)0)))
{ /* Llib/mpd.scm 273 */
obj_t BgL_list1844z00_693;
BgL_list1844z00_693 = 
MAKE_YOUNG_PAIR(BgL_linez00_24, BNIL); 
return 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string3306z00zz__multimediazd2mpdzd2, BgL_list1844z00_693);}  else 
{ /* Llib/mpd.scm 272 */
return 
CNST_TABLE_REF(((long)54));} } } } } } } 

}



/* mpd-list-begin */
obj_t BGl_mpdzd2listzd2beginz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_dbz00_25, BgL_musicz00_bglt BgL_backendz00_26, obj_t BgL_ipz00_27, obj_t BgL_opz00_28, obj_t BgL_cmdz00_29)
{
{ /* Llib/mpd.scm 279 */
{ 
obj_t BgL_linesz00_698;
BgL_linesz00_698 = BNIL; 
BgL_zc3z04anonymousza31846ze3z87_699:
{ /* Llib/mpd.scm 281 */
obj_t BgL_linez00_700;
BgL_linez00_700 = 
BGl_readzd2linezd2zz__r4_input_6_10_2z00(BgL_ipz00_27); 
{ /* Llib/mpd.scm 282 */
bool_t BgL_test3781z00_6422;
{ /* Llib/mpd.scm 282 */
bool_t BgL_res2723z00_2595;
BgL_res2723z00_2595 = 
EOF_OBJECTP(BgL_linez00_700); 
BgL_test3781z00_6422 = BgL_res2723z00_2595; } 
if(BgL_test3781z00_6422)
{ /* Llib/mpd.scm 282 */
return BFALSE;}  else 
{ /* Llib/mpd.scm 283 */
obj_t BgL_cz00_702;
BgL_cz00_702 = 
BGl_getzd2linezd2commandz00zz__multimediazd2mpdzd2(BgL_linez00_700); 
if(
(BgL_cz00_702==
CNST_TABLE_REF(((long)57))))
{ /* Llib/mpd.scm 284 */
if(
(BgL_cmdz00_29==
CNST_TABLE_REF(((long)55))))
{ /* Llib/mpd.scm 287 */
obj_t BgL_g1095z00_705;
BgL_g1095z00_705 = 
bgl_reverse_bang(BgL_linesz00_698); 
{ 
obj_t BgL_lsz00_707;
BgL_lsz00_707 = BgL_g1095z00_705; 
BgL_zc3z04anonymousza31850ze3z87_708:
if(
NULLP(BgL_lsz00_707))
{ /* Llib/mpd.scm 288 */
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 290 */
obj_t BgL_lz00_710;
BgL_lz00_710 = 
CAR(
((obj_t)BgL_lsz00_707)); 
{ /* Llib/mpd.scm 290 */
obj_t BgL_vz00_711;
BgL_vz00_711 = 
BGl_executezd2commandzd2zz__multimediazd2mpdzd2(BgL_dbz00_25, BgL_backendz00_26, BgL_ipz00_27, BgL_opz00_28, BgL_lz00_710); 
{ /* Llib/mpd.scm 291 */

if(
(BgL_vz00_711==
CNST_TABLE_REF(((long)53))))
{ /* Llib/mpd.scm 293 */
obj_t BgL_arg1853z00_713;
BgL_arg1853z00_713 = 
CDR(
((obj_t)BgL_lsz00_707)); 
{ 
obj_t BgL_lsz00_6443;
BgL_lsz00_6443 = BgL_arg1853z00_713; 
BgL_lsz00_707 = BgL_lsz00_6443; 
goto BgL_zc3z04anonymousza31850ze3z87_708;} }  else 
{ /* Llib/mpd.scm 292 */
return BgL_vz00_711;} } } } } }  else 
{ /* Llib/mpd.scm 286 */
if(
(BgL_cmdz00_29==
CNST_TABLE_REF(((long)56))))
{ /* Llib/mpd.scm 296 */
obj_t BgL_g1096z00_716;
BgL_g1096z00_716 = 
bgl_reverse_bang(BgL_linesz00_698); 
{ 
obj_t BgL_lsz00_718;
BgL_lsz00_718 = BgL_g1096z00_716; 
BgL_zc3z04anonymousza31855ze3z87_719:
if(
NULLP(BgL_lsz00_718))
{ /* Llib/mpd.scm 297 */
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 299 */
obj_t BgL_lz00_721;
BgL_lz00_721 = 
CAR(
((obj_t)BgL_lsz00_718)); 
{ /* Llib/mpd.scm 299 */
obj_t BgL_vz00_722;
BgL_vz00_722 = 
BGl_executezd2commandzd2zz__multimediazd2mpdzd2(BgL_dbz00_25, BgL_backendz00_26, BgL_ipz00_27, BgL_opz00_28, BgL_lz00_721); 
{ /* Llib/mpd.scm 300 */

if(
(BgL_vz00_722==
CNST_TABLE_REF(((long)53))))
{ /* Llib/mpd.scm 301 */
bgl_display_string(BGl_string3307z00zz__multimediazd2mpdzd2, BgL_opz00_28); 
{ /* Llib/mpd.scm 304 */
obj_t BgL_arg1858z00_724;
BgL_arg1858z00_724 = 
CDR(
((obj_t)BgL_lsz00_718)); 
{ 
obj_t BgL_lsz00_6460;
BgL_lsz00_6460 = BgL_arg1858z00_724; 
BgL_lsz00_718 = BgL_lsz00_6460; 
goto BgL_zc3z04anonymousza31855ze3z87_719;} } }  else 
{ /* Llib/mpd.scm 301 */
return BgL_vz00_722;} } } } } }  else 
{ /* Llib/mpd.scm 295 */
return BFALSE;} } }  else 
{ /* Llib/mpd.scm 306 */
obj_t BgL_arg1859z00_726;
BgL_arg1859z00_726 = 
MAKE_YOUNG_PAIR(BgL_linez00_700, BgL_linesz00_698); 
{ 
obj_t BgL_linesz00_6462;
BgL_linesz00_6462 = BgL_arg1859z00_726; 
BgL_linesz00_698 = BgL_linesz00_6462; 
goto BgL_zc3z04anonymousza31846ze3z87_699;} } } } } } } 

}



/* &mpd-ping */
obj_t BGl_z62mpdzd2pingzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4533, obj_t BgL_dbz00_4534, obj_t BgL_backendz00_4535, obj_t BgL_linez00_4536, obj_t BgL_ipz00_4537, obj_t BgL_opz00_4538)
{
{ /* Llib/mpd.scm 338 */
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-urlhandlers */
obj_t BGl_z62mpdzd2urlhandlerszb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4539, obj_t BgL_dbz00_4540, obj_t BgL_backendz00_4541, obj_t BgL_linez00_4542, obj_t BgL_ipz00_4543, obj_t BgL_opz00_4544)
{
{ /* Llib/mpd.scm 344 */
{ /* Llib/mpd.scm 345 */
bool_t BgL_tmpz00_6464;
{ /* Llib/mpd.scm 345 */
obj_t BgL_g1181z00_5389;
BgL_g1181z00_5389 = 
CNST_TABLE_REF(((long)58)); 
{ 
obj_t BgL_l1179z00_5391;
BgL_l1179z00_5391 = BgL_g1181z00_5389; 
BgL_zc3z04anonymousza31877ze3z87_5390:
if(
PAIRP(BgL_l1179z00_5391))
{ /* Llib/mpd.scm 349 */
{ /* Llib/mpd.scm 346 */
obj_t BgL_handlerz00_5392;
BgL_handlerz00_5392 = 
CAR(BgL_l1179z00_5391); 
{ /* Llib/mpd.scm 346 */
obj_t BgL_tmpz00_6469;
BgL_tmpz00_6469 = 
((obj_t)BgL_opz00_4544); 
bgl_display_string(BGl_string3308z00zz__multimediazd2mpdzd2, BgL_tmpz00_6469); } 
bgl_display_obj(BgL_handlerz00_5392, BgL_opz00_4544); 
{ /* Llib/mpd.scm 348 */
obj_t BgL_tmpz00_6473;
BgL_tmpz00_6473 = 
((obj_t)BgL_opz00_4544); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6473); } } 
{ 
obj_t BgL_l1179z00_6476;
BgL_l1179z00_6476 = 
CDR(BgL_l1179z00_5391); 
BgL_l1179z00_5391 = BgL_l1179z00_6476; 
goto BgL_zc3z04anonymousza31877ze3z87_5390;} }  else 
{ /* Llib/mpd.scm 349 */
BgL_tmpz00_6464 = ((bool_t)1)
; } } } 
return 
BBOOL(BgL_tmpz00_6464);} } 

}



/* &mpd-tagtypes */
obj_t BGl_z62mpdzd2tagtypeszb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4545, obj_t BgL_dbz00_4546, obj_t BgL_backendz00_4547, obj_t BgL_linez00_4548, obj_t BgL_ipz00_4549, obj_t BgL_opz00_4550)
{
{ /* Llib/mpd.scm 354 */
{ /* Llib/mpd.scm 355 */
bool_t BgL_tmpz00_6479;
{ /* Llib/mpd.scm 355 */
obj_t BgL_g1184z00_5393;
BgL_g1184z00_5393 = 
CNST_TABLE_REF(((long)59)); 
{ 
obj_t BgL_l1182z00_5395;
BgL_l1182z00_5395 = BgL_g1184z00_5393; 
BgL_zc3z04anonymousza31880ze3z87_5394:
if(
PAIRP(BgL_l1182z00_5395))
{ /* Llib/mpd.scm 359 */
{ /* Llib/mpd.scm 356 */
obj_t BgL_tagz00_5396;
BgL_tagz00_5396 = 
CAR(BgL_l1182z00_5395); 
{ /* Llib/mpd.scm 356 */
obj_t BgL_tmpz00_6484;
BgL_tmpz00_6484 = 
((obj_t)BgL_opz00_4550); 
bgl_display_string(BGl_string3309z00zz__multimediazd2mpdzd2, BgL_tmpz00_6484); } 
bgl_display_obj(BgL_tagz00_5396, BgL_opz00_4550); 
{ /* Llib/mpd.scm 358 */
obj_t BgL_tmpz00_6488;
BgL_tmpz00_6488 = 
((obj_t)BgL_opz00_4550); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6488); } } 
{ 
obj_t BgL_l1182z00_6491;
BgL_l1182z00_6491 = 
CDR(BgL_l1182z00_5395); 
BgL_l1182z00_5395 = BgL_l1182z00_6491; 
goto BgL_zc3z04anonymousza31880ze3z87_5394;} }  else 
{ /* Llib/mpd.scm 359 */
BgL_tmpz00_6479 = ((bool_t)1)
; } } } 
return 
BBOOL(BgL_tmpz00_6479);} } 

}



/* &mpd-status */
obj_t BGl_z62mpdzd2statuszb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4551, obj_t BgL_dbz00_4552, obj_t BgL_backendz00_4553, obj_t BgL_linez00_4554, obj_t BgL_ipz00_4555, obj_t BgL_opz00_4556)
{
{ /* Llib/mpd.scm 371 */
{ /* Llib/mpd.scm 372 */
BgL_musicstatusz00_bglt BgL_statusz00_5397;
BgL_statusz00_5397 = 
BGl_musiczd2statuszd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4553)); 
{ /* Llib/mpd.scm 376 */
obj_t BgL_volz00_5398;
{ /* Llib/mpd.scm 376 */
bool_t BgL_test3791z00_6496;
{ /* Llib/mpd.scm 376 */
obj_t BgL_tmpz00_6497;
BgL_tmpz00_6497 = 
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5397))->BgL_volumez00); 
BgL_test3791z00_6496 = 
VECTORP(BgL_tmpz00_6497); } 
if(BgL_test3791z00_6496)
{ /* Llib/mpd.scm 376 */
obj_t BgL_arg1885z00_5399;
BgL_arg1885z00_5399 = 
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5397))->BgL_volumez00); 
BgL_volz00_5398 = 
VECTOR_REF(
((obj_t)BgL_arg1885z00_5399),((long)0)); }  else 
{ /* Llib/mpd.scm 376 */
BgL_volz00_5398 = 
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5397))->BgL_volumez00); } } 
{ /* Llib/mpd.scm 377 */
obj_t BgL_tmpz00_6504;
BgL_tmpz00_6504 = 
((obj_t)BgL_opz00_4556); 
bgl_display_string(BGl_string3310z00zz__multimediazd2mpdzd2, BgL_tmpz00_6504); } 
bgl_display_obj(BgL_volz00_5398, BgL_opz00_4556); 
{ /* Llib/mpd.scm 377 */
obj_t BgL_tmpz00_6508;
BgL_tmpz00_6508 = 
((obj_t)BgL_opz00_4556); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6508); } } 
{ /* Llib/mpd.scm 378 */
obj_t BgL_tmpz00_6511;
BgL_tmpz00_6511 = 
((obj_t)BgL_opz00_4556); 
bgl_display_string(BGl_string3311z00zz__multimediazd2mpdzd2, BgL_tmpz00_6511); } 
bgl_display_obj(
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5397))->BgL_statez00), BgL_opz00_4556); 
{ /* Llib/mpd.scm 378 */
obj_t BgL_tmpz00_6516;
BgL_tmpz00_6516 = 
((obj_t)BgL_opz00_4556); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6516); } 
{ /* Llib/mpd.scm 379 */
obj_t BgL_tmpz00_6519;
BgL_tmpz00_6519 = 
((obj_t)BgL_opz00_4556); 
bgl_display_string(BGl_string3312z00zz__multimediazd2mpdzd2, BgL_tmpz00_6519); } 
{ /* Llib/mpd.scm 379 */
int BgL_arg1888z00_5400;
BgL_arg1888z00_5400 = 
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5397))->BgL_playlistidz00); 
bgl_display_obj(
BINT(BgL_arg1888z00_5400), BgL_opz00_4556); } 
{ /* Llib/mpd.scm 379 */
obj_t BgL_tmpz00_6525;
BgL_tmpz00_6525 = 
((obj_t)BgL_opz00_4556); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6525); } 
{ /* Llib/mpd.scm 380 */
obj_t BgL_tmpz00_6528;
BgL_tmpz00_6528 = 
((obj_t)BgL_opz00_4556); 
bgl_display_string(BGl_string3313z00zz__multimediazd2mpdzd2, BgL_tmpz00_6528); } 
{ /* Llib/mpd.scm 380 */
int BgL_arg1889z00_5401;
BgL_arg1889z00_5401 = 
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5397))->BgL_playlistlengthz00); 
bgl_display_obj(
BINT(BgL_arg1889z00_5401), BgL_opz00_4556); } 
{ /* Llib/mpd.scm 380 */
obj_t BgL_tmpz00_6534;
BgL_tmpz00_6534 = 
((obj_t)BgL_opz00_4556); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6534); } 
if(
(
(long)(
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5397))->BgL_songz00))>=((long)0)))
{ /* Llib/mpd.scm 381 */
{ /* Llib/mpd.scm 382 */
obj_t BgL_tmpz00_6541;
BgL_tmpz00_6541 = 
((obj_t)BgL_opz00_4556); 
bgl_display_string(BGl_string3314z00zz__multimediazd2mpdzd2, BgL_tmpz00_6541); } 
{ /* Llib/mpd.scm 382 */
int BgL_arg1892z00_5402;
BgL_arg1892z00_5402 = 
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5397))->BgL_songz00); 
bgl_display_obj(
BINT(BgL_arg1892z00_5402), BgL_opz00_4556); } 
{ /* Llib/mpd.scm 382 */
obj_t BgL_tmpz00_6547;
BgL_tmpz00_6547 = 
((obj_t)BgL_opz00_4556); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6547); } 
{ /* Llib/mpd.scm 383 */
obj_t BgL_tmpz00_6550;
BgL_tmpz00_6550 = 
((obj_t)BgL_opz00_4556); 
bgl_display_string(BGl_string3315z00zz__multimediazd2mpdzd2, BgL_tmpz00_6550); } 
{ /* Llib/mpd.scm 383 */
int BgL_arg1893z00_5403;
BgL_arg1893z00_5403 = 
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5397))->BgL_songidz00); 
bgl_display_obj(
BINT(BgL_arg1893z00_5403), BgL_opz00_4556); } 
{ /* Llib/mpd.scm 383 */
obj_t BgL_tmpz00_6556;
BgL_tmpz00_6556 = 
((obj_t)BgL_opz00_4556); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6556); } 
{ /* Llib/mpd.scm 384 */
obj_t BgL_tmpz00_6559;
BgL_tmpz00_6559 = 
((obj_t)BgL_opz00_4556); 
bgl_display_string(BGl_string3316z00zz__multimediazd2mpdzd2, BgL_tmpz00_6559); } 
{ /* Llib/mpd.scm 384 */
int BgL_arg1894z00_5404;
BgL_arg1894z00_5404 = 
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5397))->BgL_bitratez00); 
bgl_display_obj(
BINT(BgL_arg1894z00_5404), BgL_opz00_4556); } 
{ /* Llib/mpd.scm 384 */
obj_t BgL_tmpz00_6565;
BgL_tmpz00_6565 = 
((obj_t)BgL_opz00_4556); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6565); } 
{ /* Llib/mpd.scm 385 */
obj_t BgL_tmpz00_6568;
BgL_tmpz00_6568 = 
((obj_t)BgL_opz00_4556); 
bgl_display_string(BGl_string3317z00zz__multimediazd2mpdzd2, BgL_tmpz00_6568); } 
{ /* Llib/mpd.scm 386 */
int BgL_arg1895z00_5405;
BgL_arg1895z00_5405 = 
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5397))->BgL_khza7za7); 
bgl_display_obj(
BINT(BgL_arg1895z00_5405), BgL_opz00_4556); } 
{ /* Llib/mpd.scm 387 */
obj_t BgL_tmpz00_6574;
BgL_tmpz00_6574 = 
((obj_t)BgL_opz00_4556); 
bgl_display_string(BGl_string3318z00zz__multimediazd2mpdzd2, BgL_tmpz00_6574); } }  else 
{ /* Llib/mpd.scm 381 */BFALSE; } 
{ /* Llib/mpd.scm 388 */
bool_t BgL_test3793z00_6577;
if(
(
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5397))->BgL_statez00)==
CNST_TABLE_REF(((long)13))))
{ /* Llib/mpd.scm 388 */
BgL_test3793z00_6577 = ((bool_t)1)
; }  else 
{ /* Llib/mpd.scm 388 */
BgL_test3793z00_6577 = 
(
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5397))->BgL_statez00)==
CNST_TABLE_REF(((long)18)))
; } 
if(BgL_test3793z00_6577)
{ /* Llib/mpd.scm 388 */
{ /* Llib/mpd.scm 389 */
obj_t BgL_tmpz00_6585;
BgL_tmpz00_6585 = 
((obj_t)BgL_opz00_4556); 
bgl_display_string(BGl_string3319z00zz__multimediazd2mpdzd2, BgL_tmpz00_6585); } 
bgl_display_obj(
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5397))->BgL_songposz00), BgL_opz00_4556); 
{ /* Llib/mpd.scm 391 */
obj_t BgL_tmpz00_6590;
BgL_tmpz00_6590 = 
((obj_t)BgL_opz00_4556); 
bgl_display_string(BGl_string3320z00zz__multimediazd2mpdzd2, BgL_tmpz00_6590); } 
{ /* Llib/mpd.scm 392 */
int BgL_arg1903z00_5406;
BgL_arg1903z00_5406 = 
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5397))->BgL_songlengthz00); 
bgl_display_obj(
BINT(BgL_arg1903z00_5406), BgL_opz00_4556); } 
{ /* Llib/mpd.scm 393 */
obj_t BgL_tmpz00_6596;
BgL_tmpz00_6596 = 
((obj_t)BgL_opz00_4556); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6596); } }  else 
{ /* Llib/mpd.scm 388 */BFALSE; } } 
if(
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5397))->BgL_repeatz00))
{ /* Llib/mpd.scm 395 */
obj_t BgL_tmpz00_6601;
BgL_tmpz00_6601 = 
((obj_t)BgL_opz00_4556); 
bgl_display_string(BGl_string3321z00zz__multimediazd2mpdzd2, BgL_tmpz00_6601); }  else 
{ /* Llib/mpd.scm 396 */
obj_t BgL_tmpz00_6604;
BgL_tmpz00_6604 = 
((obj_t)BgL_opz00_4556); 
bgl_display_string(BGl_string3322z00zz__multimediazd2mpdzd2, BgL_tmpz00_6604); } 
if(
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5397))->BgL_randomz00))
{ /* Llib/mpd.scm 398 */
obj_t BgL_tmpz00_6609;
BgL_tmpz00_6609 = 
((obj_t)BgL_opz00_4556); 
bgl_display_string(BGl_string3323z00zz__multimediazd2mpdzd2, BgL_tmpz00_6609); }  else 
{ /* Llib/mpd.scm 399 */
obj_t BgL_tmpz00_6612;
BgL_tmpz00_6612 = 
((obj_t)BgL_opz00_4556); 
bgl_display_string(BGl_string3324z00zz__multimediazd2mpdzd2, BgL_tmpz00_6612); } 
{ /* Llib/mpd.scm 400 */
obj_t BgL_tmpz00_6615;
BgL_tmpz00_6615 = 
((obj_t)BgL_opz00_4556); 
bgl_display_string(BGl_string3325z00zz__multimediazd2mpdzd2, BgL_tmpz00_6615); } 
{ /* Llib/mpd.scm 400 */
int BgL_arg1908z00_5407;
BgL_arg1908z00_5407 = 
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5397))->BgL_xfadez00); 
bgl_display_obj(
BINT(BgL_arg1908z00_5407), BgL_opz00_4556); } 
{ /* Llib/mpd.scm 400 */
obj_t BgL_tmpz00_6621;
BgL_tmpz00_6621 = 
((obj_t)BgL_opz00_4556); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6621); } } 
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-playlist */
obj_t BGl_z62mpdzd2playlistzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4557, obj_t BgL_dbz00_4558, obj_t BgL_backendz00_4559, obj_t BgL_linez00_4560, obj_t BgL_ipz00_4561, obj_t BgL_opz00_4562)
{
{ /* Llib/mpd.scm 406 */
{ /* Llib/mpd.scm 407 */
obj_t BgL_g1102z00_5408;
BgL_g1102z00_5408 = 
BGl_musiczd2playlistzd2getz00zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4559)); 
{ 
obj_t BgL_plistz00_5410;long BgL_numz00_5411;
BgL_plistz00_5410 = BgL_g1102z00_5408; 
BgL_numz00_5411 = ((long)0); 
BgL_loopz00_5409:
if(
PAIRP(BgL_plistz00_5410))
{ /* Llib/mpd.scm 409 */
bgl_display_obj(
BINT(BgL_numz00_5411), BgL_opz00_4562); 
{ /* Llib/mpd.scm 411 */
obj_t BgL_tmpz00_6631;
BgL_tmpz00_6631 = 
((obj_t)BgL_opz00_4562); 
bgl_display_string(BGl_string3320z00zz__multimediazd2mpdzd2, BgL_tmpz00_6631); } 
bgl_display_obj(
CAR(BgL_plistz00_5410), BgL_opz00_4562); 
{ /* Llib/mpd.scm 413 */
obj_t BgL_tmpz00_6636;
BgL_tmpz00_6636 = 
((obj_t)BgL_opz00_4562); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6636); } 
{ 
long BgL_numz00_6641;obj_t BgL_plistz00_6639;
BgL_plistz00_6639 = 
CDR(BgL_plistz00_5410); 
BgL_numz00_6641 = 
(((long)1)+BgL_numz00_5411); 
BgL_numz00_5411 = BgL_numz00_6641; 
BgL_plistz00_5410 = BgL_plistz00_6639; 
goto BgL_loopz00_5409;} }  else 
{ /* Llib/mpd.scm 409 */((bool_t)0); } } } 
return 
CNST_TABLE_REF(((long)53));} 

}



/* playlistinfo */
obj_t BGl_playlistinfoz00zz__multimediazd2mpdzd2(obj_t BgL_dbz00_71, obj_t BgL_backendz00_72, obj_t BgL_linez00_73, obj_t BgL_ipz00_74, obj_t BgL_opz00_75, int BgL_numz00_76)
{
{ /* Llib/mpd.scm 432 */
{ /* Llib/mpd.scm 434 */
obj_t BgL_plistz00_867;
BgL_plistz00_867 = 
BGl_musiczd2playlistzd2getz00zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_72)); 
{ /* Llib/mpd.scm 435 */
bool_t BgL_test3798z00_6646;
if(
(
(long)(BgL_numz00_76)>=((long)0)))
{ /* Llib/mpd.scm 435 */
BgL_test3798z00_6646 = 
(
(long)(BgL_numz00_76)<
bgl_list_length(BgL_plistz00_867))
; }  else 
{ /* Llib/mpd.scm 435 */
BgL_test3798z00_6646 = ((bool_t)0)
; } 
if(BgL_test3798z00_6646)
{ /* Llib/mpd.scm 436 */
obj_t BgL_arg1942z00_871;
BgL_arg1942z00_871 = 
bgl_list_ref(BgL_plistz00_867, 
(long)(BgL_numz00_76)); 
{ /* Llib/mpd.scm 422 */
obj_t BgL_g1188z00_2813;
BgL_g1188z00_2813 = 
BGl_getinfofilez00zz__multimediazd2mpdzd2(BgL_dbz00_71, BgL_arg1942z00_871, BFALSE, BFALSE, BFALSE); 
{ 
obj_t BgL_l1186z00_2815;
BgL_l1186z00_2815 = BgL_g1188z00_2813; 
BgL_zc3z04anonymousza31933ze3z87_2814:
if(
PAIRP(BgL_l1186z00_2815))
{ /* Llib/mpd.scm 427 */
{ /* Llib/mpd.scm 423 */
obj_t BgL_kz00_2817;
BgL_kz00_2817 = 
CAR(BgL_l1186z00_2815); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1935z00_2818;
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1936z00_2819;
BgL_arg1936z00_2819 = 
CAR(
((obj_t)BgL_kz00_2817)); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_res2758z00_2826;
BgL_res2758z00_2826 = 
KEYWORD_TO_STRING(
((obj_t)BgL_arg1936z00_2819)); 
BgL_arg1935z00_2818 = BgL_res2758z00_2826; } } 
bgl_display_obj(BgL_arg1935z00_2818, BgL_opz00_75); } 
{ /* Llib/mpd.scm 424 */
obj_t BgL_tmpz00_6664;
BgL_tmpz00_6664 = 
((obj_t)BgL_opz00_75); 
bgl_display_string(BGl_string3326z00zz__multimediazd2mpdzd2, BgL_tmpz00_6664); } 
{ /* Llib/mpd.scm 425 */
obj_t BgL_arg1937z00_2820;
{ /* Llib/mpd.scm 425 */
obj_t BgL_pairz00_2832;
BgL_pairz00_2832 = 
CDR(
((obj_t)BgL_kz00_2817)); 
BgL_arg1937z00_2820 = 
CAR(BgL_pairz00_2832); } 
bgl_display_obj(BgL_arg1937z00_2820, BgL_opz00_75); } 
{ /* Llib/mpd.scm 426 */
obj_t BgL_tmpz00_6671;
BgL_tmpz00_6671 = 
((obj_t)BgL_opz00_75); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6671); } } 
{ 
obj_t BgL_l1186z00_6674;
BgL_l1186z00_6674 = 
CDR(BgL_l1186z00_2815); 
BgL_l1186z00_2815 = BgL_l1186z00_6674; 
goto BgL_zc3z04anonymousza31933ze3z87_2814;} }  else 
{ /* Llib/mpd.scm 427 */((bool_t)1); } } } }  else 
{ 
obj_t BgL_plistz00_876;long BgL_numz00_877;
BgL_plistz00_876 = BgL_plistz00_867; 
BgL_numz00_877 = ((long)0); 
BgL_zc3z04anonymousza31943ze3z87_878:
if(
PAIRP(BgL_plistz00_876))
{ /* Llib/mpd.scm 439 */
{ /* Llib/mpd.scm 440 */
obj_t BgL_arg1945z00_880;
BgL_arg1945z00_880 = 
CAR(BgL_plistz00_876); 
{ /* Llib/mpd.scm 422 */
obj_t BgL_g1188z00_2837;
BgL_g1188z00_2837 = 
BGl_getinfofilez00zz__multimediazd2mpdzd2(BgL_dbz00_71, BgL_arg1945z00_880, BFALSE, BFALSE, BFALSE); 
{ 
obj_t BgL_l1186z00_2839;
BgL_l1186z00_2839 = BgL_g1188z00_2837; 
BgL_zc3z04anonymousza31933ze3z87_2838:
if(
PAIRP(BgL_l1186z00_2839))
{ /* Llib/mpd.scm 427 */
{ /* Llib/mpd.scm 423 */
obj_t BgL_kz00_2841;
BgL_kz00_2841 = 
CAR(BgL_l1186z00_2839); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1935z00_2842;
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1936z00_2843;
BgL_arg1936z00_2843 = 
CAR(
((obj_t)BgL_kz00_2841)); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_res2761z00_2850;
BgL_res2761z00_2850 = 
KEYWORD_TO_STRING(
((obj_t)BgL_arg1936z00_2843)); 
BgL_arg1935z00_2842 = BgL_res2761z00_2850; } } 
bgl_display_obj(BgL_arg1935z00_2842, BgL_opz00_75); } 
{ /* Llib/mpd.scm 424 */
obj_t BgL_tmpz00_6688;
BgL_tmpz00_6688 = 
((obj_t)BgL_opz00_75); 
bgl_display_string(BGl_string3326z00zz__multimediazd2mpdzd2, BgL_tmpz00_6688); } 
{ /* Llib/mpd.scm 425 */
obj_t BgL_arg1937z00_2844;
{ /* Llib/mpd.scm 425 */
obj_t BgL_pairz00_2856;
BgL_pairz00_2856 = 
CDR(
((obj_t)BgL_kz00_2841)); 
BgL_arg1937z00_2844 = 
CAR(BgL_pairz00_2856); } 
bgl_display_obj(BgL_arg1937z00_2844, BgL_opz00_75); } 
{ /* Llib/mpd.scm 426 */
obj_t BgL_tmpz00_6695;
BgL_tmpz00_6695 = 
((obj_t)BgL_opz00_75); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6695); } } 
{ 
obj_t BgL_l1186z00_6698;
BgL_l1186z00_6698 = 
CDR(BgL_l1186z00_2839); 
BgL_l1186z00_2839 = BgL_l1186z00_6698; 
goto BgL_zc3z04anonymousza31933ze3z87_2838;} }  else 
{ /* Llib/mpd.scm 427 */((bool_t)1); } } } } 
{ 
long BgL_numz00_6702;obj_t BgL_plistz00_6700;
BgL_plistz00_6700 = 
CDR(BgL_plistz00_876); 
BgL_numz00_6702 = 
(((long)1)+BgL_numz00_877); 
BgL_numz00_877 = BgL_numz00_6702; 
BgL_plistz00_876 = BgL_plistz00_6700; 
goto BgL_zc3z04anonymousza31943ze3z87_878;} }  else 
{ /* Llib/mpd.scm 439 */((bool_t)0); } } } } 
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-playlistinfo */
obj_t BGl_z62mpdzd2playlistinfozb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4563, obj_t BgL_dbz00_4564, obj_t BgL_backendz00_4565, obj_t BgL_linez00_4566, obj_t BgL_ipz00_4567, obj_t BgL_opz00_4568)
{
{ /* Llib/mpd.scm 447 */
{ /* Llib/mpd.scm 447 */
obj_t BgL_numz00_5412;
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5413;
BgL_strz00_5413 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4566, ((long)1)); 
if(
STRINGP(BgL_strz00_5413))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_6708;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_6709;
BgL_tmpz00_6709 = 
BSTRING_TO_STRING(BgL_strz00_5413); 
BgL_tmpz00_6708 = 
BGL_STRTOL(BgL_tmpz00_6709, ((long)0), ((long)10)); } 
BgL_numz00_5412 = 
BINT(BgL_tmpz00_6708); }  else 
{ /* Llib/mpd.scm 223 */
BgL_numz00_5412 = BFALSE; } } 
{ /* Llib/mpd.scm 448 */
obj_t BgL_arg1949z00_5414;
if(
CBOOL(BgL_numz00_5412))
{ /* Llib/mpd.scm 448 */
BgL_arg1949z00_5414 = BgL_numz00_5412; }  else 
{ /* Llib/mpd.scm 448 */
BgL_arg1949z00_5414 = 
BINT(((long)0)); } 
return 
BGl_playlistinfoz00zz__multimediazd2mpdzd2(BgL_dbz00_4564, BgL_backendz00_4565, BgL_linez00_4566, BgL_ipz00_4567, BgL_opz00_4568, 
CINT(BgL_arg1949z00_5414));} } } 

}



/* &mpd-playlistid */
obj_t BGl_z62mpdzd2playlistidzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4569, obj_t BgL_dbz00_4570, obj_t BgL_backendz00_4571, obj_t BgL_linez00_4572, obj_t BgL_ipz00_4573, obj_t BgL_opz00_4574)
{
{ /* Llib/mpd.scm 453 */
{ /* Llib/mpd.scm 453 */
obj_t BgL_numz00_5415;
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5416;
BgL_strz00_5416 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4572, ((long)1)); 
if(
STRINGP(BgL_strz00_5416))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_6721;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_6722;
BgL_tmpz00_6722 = 
BSTRING_TO_STRING(BgL_strz00_5416); 
BgL_tmpz00_6721 = 
BGL_STRTOL(BgL_tmpz00_6722, ((long)0), ((long)10)); } 
BgL_numz00_5415 = 
BINT(BgL_tmpz00_6721); }  else 
{ /* Llib/mpd.scm 223 */
BgL_numz00_5415 = BFALSE; } } 
{ /* Llib/mpd.scm 454 */
obj_t BgL_arg1950z00_5417;
if(
CBOOL(BgL_numz00_5415))
{ /* Llib/mpd.scm 454 */
BgL_arg1950z00_5417 = BgL_numz00_5415; }  else 
{ /* Llib/mpd.scm 454 */
BgL_arg1950z00_5417 = 
BINT(((long)0)); } 
return 
BGl_playlistinfoz00zz__multimediazd2mpdzd2(BgL_dbz00_4570, BgL_backendz00_4571, BgL_linez00_4572, BgL_ipz00_4573, BgL_opz00_4574, 
CINT(BgL_arg1950z00_5417));} } } 

}



/* &mpd-plchanges */
obj_t BGl_z62mpdzd2plchangeszb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4575, obj_t BgL_dbz00_4576, obj_t BgL_backendz00_4577, obj_t BgL_linez00_4578, obj_t BgL_ipz00_4579, obj_t BgL_opz00_4580)
{
{ /* Llib/mpd.scm 459 */
{ /* Llib/mpd.scm 459 */
obj_t BgL_numz00_5418;
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5419;
BgL_strz00_5419 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4578, ((long)1)); 
if(
STRINGP(BgL_strz00_5419))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_6734;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_6735;
BgL_tmpz00_6735 = 
BSTRING_TO_STRING(BgL_strz00_5419); 
BgL_tmpz00_6734 = 
BGL_STRTOL(BgL_tmpz00_6735, ((long)0), ((long)10)); } 
BgL_numz00_5418 = 
BINT(BgL_tmpz00_6734); }  else 
{ /* Llib/mpd.scm 223 */
BgL_numz00_5418 = BFALSE; } } 
{ /* Llib/mpd.scm 460 */
BgL_musicstatusz00_bglt BgL_statusz00_5420;
BgL_statusz00_5420 = 
BGl_musiczd2statuszd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4577)); 
if(
(
(long)CINT(BgL_numz00_5418)<
(long)(
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5420))->BgL_playlistidz00))))
{ /* Llib/mpd.scm 462 */
return 
BGl_playlistinfoz00zz__multimediazd2mpdzd2(BgL_dbz00_4576, BgL_backendz00_4577, BgL_linez00_4578, BgL_ipz00_4579, BgL_opz00_4580, 
(int)(((long)0)));}  else 
{ /* Llib/mpd.scm 462 */
return 
CNST_TABLE_REF(((long)53));} } } } 

}



/* &mpd-add */
obj_t BGl_z62mpdzd2addzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4581, obj_t BgL_dbz00_4582, obj_t BgL_backendz00_4583, obj_t BgL_linez00_4584, obj_t BgL_ipz00_4585, obj_t BgL_opz00_4586)
{
{ /* Llib/mpd.scm 477 */
{ /* Llib/mpd.scm 477 */
obj_t BgL_uriz00_5421;
BgL_uriz00_5421 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4584, ((long)1)); 
if(
CBOOL(BgL_uriz00_5421))
{ /* Llib/mpd.scm 479 */
obj_t BgL_pathz00_5422;
if(
bigloo_strcmp_at(BgL_uriz00_5421, BGl_string3327z00zz__multimediazd2mpdzd2, ((long)0)))
{ /* Llib/mpd.scm 470 */
BgL_pathz00_5422 = BgL_uriz00_5421; }  else 
{ /* Llib/mpd.scm 470 */
BgL_pathz00_5422 = 
BGl_mpdzd2ze3filez31zz__multimediazd2mpdzd2(BgL_uriz00_5421, BgL_dbz00_4582, BgL_opz00_4586, BGl_string3328z00zz__multimediazd2mpdzd2); } 
if(
bgl_directoryp(
BSTRING_TO_STRING(BgL_pathz00_5422)))
{ /* Llib/mpd.scm 481 */
obj_t BgL_g1191z00_5423;
BgL_g1191z00_5423 = 
BGl_directoryzd2ze3sortzd2listze3zz__multimediazd2mpdzd2(BgL_pathz00_5422); 
{ 
obj_t BgL_l1189z00_5425;
{ /* Llib/mpd.scm 485 */
bool_t BgL_tmpz00_6759;
BgL_l1189z00_5425 = BgL_g1191z00_5423; 
BgL_zc3z04anonymousza31956ze3z87_5424:
if(
PAIRP(BgL_l1189z00_5425))
{ /* Llib/mpd.scm 485 */
{ /* Llib/mpd.scm 482 */
obj_t BgL_fz00_5426;
BgL_fz00_5426 = 
CAR(BgL_l1189z00_5425); 
if(
BGl_musiczd2filezf3z21zz__multimediazd2mpdzd2(BgL_fz00_5426, BgL_dbz00_4582))
{ /* Llib/mpd.scm 484 */
obj_t BgL_arg1959z00_5427;
BgL_arg1959z00_5427 = 
BGl_makezd2filezd2namez00zz__osz00(BgL_pathz00_5422, BgL_fz00_5426); 
BGl_musiczd2playlistzd2addz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4583), BgL_arg1959z00_5427); }  else 
{ /* Llib/mpd.scm 482 */BFALSE; } } 
{ 
obj_t BgL_l1189z00_6768;
BgL_l1189z00_6768 = 
CDR(BgL_l1189z00_5425); 
BgL_l1189z00_5425 = BgL_l1189z00_6768; 
goto BgL_zc3z04anonymousza31956ze3z87_5424;} }  else 
{ /* Llib/mpd.scm 485 */
BgL_tmpz00_6759 = ((bool_t)1)
; } 
BBOOL(BgL_tmpz00_6759); } } }  else 
{ /* Llib/mpd.scm 480 */
BGl_musiczd2playlistzd2addz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4583), BgL_pathz00_5422); } 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 488 */
obj_t BgL_list1961z00_5428;
BgL_list1961z00_5428 = 
MAKE_YOUNG_PAIR(BgL_uriz00_5421, BNIL); 
return 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string3329z00zz__multimediazd2mpdzd2, BgL_list1961z00_5428);} } } 

}



/* &mpd-delete */
obj_t BGl_z62mpdzd2deletezb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4587, obj_t BgL_dbz00_4588, obj_t BgL_backendz00_4589, obj_t BgL_linez00_4590, obj_t BgL_ipz00_4591, obj_t BgL_opz00_4592)
{
{ /* Llib/mpd.scm 493 */
{ /* Llib/mpd.scm 493 */
obj_t BgL_numz00_5429;
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5430;
BgL_strz00_5430 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4590, ((long)1)); 
if(
STRINGP(BgL_strz00_5430))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_6779;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_6780;
BgL_tmpz00_6780 = 
BSTRING_TO_STRING(BgL_strz00_5430); 
BgL_tmpz00_6779 = 
BGL_STRTOL(BgL_tmpz00_6780, ((long)0), ((long)10)); } 
BgL_numz00_5429 = 
BINT(BgL_tmpz00_6779); }  else 
{ /* Llib/mpd.scm 223 */
BgL_numz00_5429 = BFALSE; } } 
BGl_musiczd2playlistzd2deletez12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4589), 
CINT(BgL_numz00_5429)); 
return 
CNST_TABLE_REF(((long)53));} } 

}



/* &mpd-deleteid */
obj_t BGl_z62mpdzd2deleteidzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4593, obj_t BgL_dbz00_4594, obj_t BgL_backendz00_4595, obj_t BgL_linez00_4596, obj_t BgL_ipz00_4597, obj_t BgL_opz00_4598)
{
{ /* Llib/mpd.scm 500 */
{ /* Llib/mpd.scm 500 */
obj_t BgL_numz00_5431;
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5432;
BgL_strz00_5432 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4596, ((long)1)); 
if(
STRINGP(BgL_strz00_5432))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_6791;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_6792;
BgL_tmpz00_6792 = 
BSTRING_TO_STRING(BgL_strz00_5432); 
BgL_tmpz00_6791 = 
BGL_STRTOL(BgL_tmpz00_6792, ((long)0), ((long)10)); } 
BgL_numz00_5431 = 
BINT(BgL_tmpz00_6791); }  else 
{ /* Llib/mpd.scm 223 */
BgL_numz00_5431 = BFALSE; } } 
BGl_musiczd2playlistzd2deletez12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4595), 
CINT(BgL_numz00_5431)); 
{ /* Llib/mpd.scm 312 */
obj_t BgL_tmpz00_6799;
BgL_tmpz00_6799 = 
((obj_t)BgL_opz00_4598); 
bgl_display_string(BGl_string3300z00zz__multimediazd2mpdzd2, BgL_tmpz00_6799); } 
{ /* Llib/mpd.scm 313 */
obj_t BgL_tmpz00_6802;
BgL_tmpz00_6802 = 
((obj_t)BgL_opz00_4598); 
return 
bgl_flush_output_port(BgL_tmpz00_6802);} } } 

}



/* &mpd-clear */
obj_t BGl_z62mpdzd2clearzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4599, obj_t BgL_dbz00_4600, obj_t BgL_backendz00_4601, obj_t BgL_linez00_4602, obj_t BgL_ipz00_4603, obj_t BgL_opz00_4604)
{
{ /* Llib/mpd.scm 507 */
BGl_musiczd2playlistzd2clearz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4601)); 
return 
CNST_TABLE_REF(((long)53));} 

}



/* currentsong-info */
obj_t BGl_currentsongzd2infozd2zz__multimediazd2mpdzd2(obj_t BgL_dbz00_116, obj_t BgL_backendz00_117, obj_t BgL_plistz00_118, int BgL_numz00_119, obj_t BgL_linez00_120, obj_t BgL_ipz00_121)
{
{ /* Llib/mpd.scm 514 */
{ /* Llib/mpd.scm 549 */
obj_t BgL_filez00_919;
BgL_filez00_919 = 
bgl_list_ref(BgL_plistz00_118, 
(long)(BgL_numz00_119)); 
{ /* Llib/mpd.scm 549 */
obj_t BgL_pathz00_920;
if(
bigloo_strcmp_at(BgL_filez00_919, BGl_string3327z00zz__multimediazd2mpdzd2, ((long)0)))
{ /* Llib/mpd.scm 1021 */
BgL_pathz00_920 = BgL_filez00_919; }  else 
{ /* Llib/mpd.scm 1021 */
BgL_pathz00_920 = 
BGl_filezd2ze3mpdz31zz__multimediazd2mpdzd2(BgL_filez00_919, BgL_dbz00_116); } 
{ /* Llib/mpd.scm 550 */

{ /* Llib/mpd.scm 553 */
obj_t BgL_zc3z04anonymousza31963ze3z87_4833;
BgL_zc3z04anonymousza31963ze3z87_4833 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31963ze3ze5zz__multimediazd2mpdzd2, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31963ze3z87_4833, 
(int)(((long)0)), BgL_backendz00_117); 
PROCEDURE_SET(BgL_zc3z04anonymousza31963ze3z87_4833, 
(int)(((long)1)), BgL_dbz00_116); 
PROCEDURE_SET(BgL_zc3z04anonymousza31963ze3z87_4833, 
(int)(((long)2)), BgL_linez00_120); 
PROCEDURE_SET(BgL_zc3z04anonymousza31963ze3z87_4833, 
(int)(((long)3)), BgL_ipz00_121); 
PROCEDURE_SET(BgL_zc3z04anonymousza31963ze3z87_4833, 
(int)(((long)4)), BgL_filez00_919); 
PROCEDURE_SET(BgL_zc3z04anonymousza31963ze3z87_4833, 
(int)(((long)5)), BgL_pathz00_920); 
return 
BGl_callzd2withzd2outputzd2stringzd2zz__r4_ports_6_10_1z00(BgL_zc3z04anonymousza31963ze3z87_4833);} } } } } 

}



/* &<@anonymous:1963> */
obj_t BGl_z62zc3z04anonymousza31963ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4834, obj_t BgL_opz00_4841)
{
{ /* Llib/mpd.scm 552 */
{ /* Llib/mpd.scm 553 */
obj_t BgL_backendz00_4835;obj_t BgL_dbz00_4836;obj_t BgL_linez00_4837;obj_t BgL_ipz00_4838;obj_t BgL_filez00_4839;obj_t BgL_pathz00_4840;
BgL_backendz00_4835 = 
PROCEDURE_REF(BgL_envz00_4834, 
(int)(((long)0))); 
BgL_dbz00_4836 = 
PROCEDURE_REF(BgL_envz00_4834, 
(int)(((long)1))); 
BgL_linez00_4837 = 
PROCEDURE_REF(BgL_envz00_4834, 
(int)(((long)2))); 
BgL_ipz00_4838 = 
PROCEDURE_REF(BgL_envz00_4834, 
(int)(((long)3))); 
BgL_filez00_4839 = 
PROCEDURE_REF(BgL_envz00_4834, 
(int)(((long)4))); 
BgL_pathz00_4840 = 
PROCEDURE_REF(BgL_envz00_4834, 
(int)(((long)5))); 
{ 
obj_t BgL_opz00_5434;obj_t BgL_filez00_5435;obj_t BgL_pathz00_5436;
if(
fexists(
BSTRING_TO_STRING(BgL_filez00_4839)))
{ /* Llib/mpd.scm 422 */
obj_t BgL_g1188z00_5447;
BgL_g1188z00_5447 = 
BGl_getinfofilez00zz__multimediazd2mpdzd2(BgL_dbz00_4836, BgL_filez00_4839, BFALSE, BFALSE, BFALSE); 
{ 
obj_t BgL_l1186z00_5449;
{ /* Llib/mpd.scm 427 */
bool_t BgL_tmpz00_6845;
BgL_l1186z00_5449 = BgL_g1188z00_5447; 
BgL_zc3z04anonymousza31933ze3z87_5448:
if(
PAIRP(BgL_l1186z00_5449))
{ /* Llib/mpd.scm 427 */
{ /* Llib/mpd.scm 423 */
obj_t BgL_kz00_5450;
BgL_kz00_5450 = 
CAR(BgL_l1186z00_5449); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1935z00_5451;
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1936z00_5452;
BgL_arg1936z00_5452 = 
CAR(
((obj_t)BgL_kz00_5450)); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_res2777z00_5453;
BgL_res2777z00_5453 = 
KEYWORD_TO_STRING(
((obj_t)BgL_arg1936z00_5452)); 
BgL_arg1935z00_5451 = BgL_res2777z00_5453; } } 
bgl_display_obj(BgL_arg1935z00_5451, BgL_opz00_4841); } 
{ /* Llib/mpd.scm 424 */
obj_t BgL_tmpz00_6854;
BgL_tmpz00_6854 = 
((obj_t)BgL_opz00_4841); 
bgl_display_string(BGl_string3326z00zz__multimediazd2mpdzd2, BgL_tmpz00_6854); } 
{ /* Llib/mpd.scm 425 */
obj_t BgL_arg1937z00_5454;
{ /* Llib/mpd.scm 425 */
obj_t BgL_pairz00_5455;
BgL_pairz00_5455 = 
CDR(
((obj_t)BgL_kz00_5450)); 
BgL_arg1937z00_5454 = 
CAR(BgL_pairz00_5455); } 
bgl_display_obj(BgL_arg1937z00_5454, BgL_opz00_4841); } 
{ /* Llib/mpd.scm 426 */
obj_t BgL_tmpz00_6861;
BgL_tmpz00_6861 = 
((obj_t)BgL_opz00_4841); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6861); } } 
{ 
obj_t BgL_l1186z00_6864;
BgL_l1186z00_6864 = 
CDR(BgL_l1186z00_5449); 
BgL_l1186z00_5449 = BgL_l1186z00_6864; 
goto BgL_zc3z04anonymousza31933ze3z87_5448;} }  else 
{ /* Llib/mpd.scm 427 */
BgL_tmpz00_6845 = ((bool_t)1)
; } 
return 
BBOOL(BgL_tmpz00_6845);} } }  else 
{ /* Llib/mpd.scm 553 */
BgL_opz00_5434 = BgL_opz00_4841; 
BgL_filez00_5435 = BgL_filez00_4839; 
BgL_pathz00_5436 = BgL_pathz00_4840; 
{ /* Llib/mpd.scm 518 */
obj_t BgL_metaz00_5437;
BgL_metaz00_5437 = 
BGl_musiczd2metazd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4835)); 
if(
NULLP(BgL_metaz00_5437))
{ /* Llib/mpd.scm 520 */
int BgL_arg1967z00_5438;
BgL_arg1967z00_5438 = 
BGl_musiczd2songzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4835)); 
return 
BGl_playlistinfoz00zz__multimediazd2mpdzd2(BgL_dbz00_4836, BgL_backendz00_4835, BgL_linez00_4837, BgL_ipz00_4838, BgL_opz00_5434, BgL_arg1967z00_5438);}  else 
{ /* Llib/mpd.scm 521 */
int BgL_numz00_5439;obj_t BgL_dirz00_5440;
BgL_numz00_5439 = 
BGl_musiczd2songzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4835)); 
BgL_dirz00_5440 = 
BGl_dirnamez00zz__osz00(BgL_filez00_5435); 
{ /* Llib/mpd.scm 523 */
obj_t BgL_tmpz00_6877;
BgL_tmpz00_6877 = 
((obj_t)BgL_opz00_5434); 
bgl_display_string(BGl_string3330z00zz__multimediazd2mpdzd2, BgL_tmpz00_6877); } 
bgl_display_obj(BgL_pathz00_5436, BgL_opz00_5434); 
{ /* Llib/mpd.scm 525 */
obj_t BgL_tmpz00_6881;
BgL_tmpz00_6881 = 
((obj_t)BgL_opz00_5434); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6881); } 
{ /* Llib/mpd.scm 527 */
obj_t BgL_tmpz00_6884;
BgL_tmpz00_6884 = 
((obj_t)BgL_opz00_5434); 
bgl_display_string(BGl_string3331z00zz__multimediazd2mpdzd2, BgL_tmpz00_6884); } 
bgl_display_obj(
BINT(BgL_numz00_5439), BgL_opz00_5434); 
{ /* Llib/mpd.scm 529 */
obj_t BgL_tmpz00_6889;
BgL_tmpz00_6889 = 
((obj_t)BgL_opz00_5434); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6889); } 
{ /* Llib/mpd.scm 530 */
obj_t BgL_tmpz00_6892;
BgL_tmpz00_6892 = 
((obj_t)BgL_opz00_5434); 
bgl_display_string(BGl_string3332z00zz__multimediazd2mpdzd2, BgL_tmpz00_6892); } 
bgl_display_obj(
BINT(BgL_numz00_5439), BgL_opz00_5434); 
{ /* Llib/mpd.scm 532 */
obj_t BgL_tmpz00_6897;
BgL_tmpz00_6897 = 
((obj_t)BgL_opz00_5434); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6897); } 
{ /* Llib/mpd.scm 533 */
obj_t BgL_caz00_5441;
BgL_caz00_5441 = 
BGl_assqz00zz__r4_pairs_and_lists_6_3z00(
CNST_TABLE_REF(((long)60)), BgL_metaz00_5437); 
{ /* Llib/mpd.scm 533 */
obj_t BgL_ctz00_5442;
BgL_ctz00_5442 = 
BGl_assqz00zz__r4_pairs_and_lists_6_3z00(
CNST_TABLE_REF(((long)61)), BgL_metaz00_5437); 
{ /* Llib/mpd.scm 534 */
obj_t BgL_cbz00_5443;
BgL_cbz00_5443 = 
BGl_assqz00zz__r4_pairs_and_lists_6_3z00(
CNST_TABLE_REF(((long)62)), BgL_metaz00_5437); 
{ /* Llib/mpd.scm 535 */
obj_t BgL_az00_5444;
if(
PAIRP(BgL_caz00_5441))
{ /* Llib/mpd.scm 536 */
BgL_az00_5444 = 
CDR(BgL_caz00_5441); }  else 
{ /* Llib/mpd.scm 536 */
BgL_az00_5444 = 
BGl_stringzd2capitaliza7ez75zz__r4_strings_6_7z00(
BGl_basenamez00zz__osz00(
BGl_dirnamez00zz__osz00(BgL_dirz00_5440))); } 
{ /* Llib/mpd.scm 536 */
obj_t BgL_tz00_5445;
if(
PAIRP(BgL_ctz00_5442))
{ /* Llib/mpd.scm 539 */
BgL_tz00_5445 = 
CDR(BgL_ctz00_5442); }  else 
{ /* Llib/mpd.scm 539 */
BgL_tz00_5445 = 
BGl_stringzd2capitaliza7ez75zz__r4_strings_6_7z00(
BGl_basenamez00zz__osz00(BgL_filez00_5435)); } 
{ /* Llib/mpd.scm 539 */
obj_t BgL_bz00_5446;
if(
PAIRP(BgL_cbz00_5443))
{ /* Llib/mpd.scm 542 */
BgL_bz00_5446 = 
CDR(BgL_cbz00_5443); }  else 
{ /* Llib/mpd.scm 542 */
BgL_bz00_5446 = 
BGl_stringzd2capitaliza7ez75zz__r4_strings_6_7z00(
BGl_basenamez00zz__osz00(BgL_dirz00_5440)); } 
{ /* Llib/mpd.scm 542 */

{ /* Llib/mpd.scm 545 */
obj_t BgL_tmpz00_6922;
BgL_tmpz00_6922 = 
((obj_t)BgL_opz00_5434); 
bgl_display_string(BGl_string3333z00zz__multimediazd2mpdzd2, BgL_tmpz00_6922); } 
bgl_display_obj(BgL_az00_5444, BgL_opz00_5434); 
{ /* Llib/mpd.scm 545 */
obj_t BgL_tmpz00_6926;
BgL_tmpz00_6926 = 
((obj_t)BgL_opz00_5434); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6926); } 
{ /* Llib/mpd.scm 546 */
obj_t BgL_tmpz00_6929;
BgL_tmpz00_6929 = 
((obj_t)BgL_opz00_5434); 
bgl_display_string(BGl_string3334z00zz__multimediazd2mpdzd2, BgL_tmpz00_6929); } 
bgl_display_obj(BgL_tz00_5445, BgL_opz00_5434); 
{ /* Llib/mpd.scm 546 */
obj_t BgL_tmpz00_6933;
BgL_tmpz00_6933 = 
((obj_t)BgL_opz00_5434); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6933); } 
{ /* Llib/mpd.scm 547 */
obj_t BgL_tmpz00_6936;
BgL_tmpz00_6936 = 
((obj_t)BgL_opz00_5434); 
bgl_display_string(BGl_string3335z00zz__multimediazd2mpdzd2, BgL_tmpz00_6936); } 
bgl_display_obj(BgL_bz00_5446, BgL_opz00_5434); 
{ /* Llib/mpd.scm 547 */
obj_t BgL_tmpz00_6940;
BgL_tmpz00_6940 = 
((obj_t)BgL_opz00_5434); 
return 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6940);} } } } } } } } } } } } } } 

}



/* &mpd-currentsong */
obj_t BGl_z62mpdzd2currentsongzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4605, obj_t BgL_dbz00_4606, obj_t BgL_backendz00_4607, obj_t BgL_linez00_4608, obj_t BgL_ipz00_4609, obj_t BgL_opz00_4610)
{
{ /* Llib/mpd.scm 579 */
{ /* Llib/mpd.scm 580 */
obj_t BgL_plistz00_5456;int BgL_numz00_5457;
BgL_plistz00_5456 = 
BGl_musiczd2playlistzd2getz00zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4607)); 
BgL_numz00_5457 = 
BGl_musiczd2songzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4607)); 
{ /* Llib/mpd.scm 582 */
bool_t BgL_test3823z00_6947;
if(
(
(long)(BgL_numz00_5457)>=((long)0)))
{ /* Llib/mpd.scm 582 */
BgL_test3823z00_6947 = 
(
(long)(BgL_numz00_5457)<
bgl_list_length(BgL_plistz00_5456))
; }  else 
{ /* Llib/mpd.scm 582 */
BgL_test3823z00_6947 = ((bool_t)0)
; } 
if(BgL_test3823z00_6947)
{ /* Llib/mpd.scm 568 */
bool_t BgL_test3825z00_6954;
if(
(BgL_plistz00_5456==BGl_currentsongzd2cachezd2plistz00zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 568 */
BgL_test3825z00_6954 = 
(BGl_currentsongzd2cachezd2numz00zz__multimediazd2mpdzd2==
(long)(BgL_numz00_5457))
; }  else 
{ /* Llib/mpd.scm 568 */
BgL_test3825z00_6954 = ((bool_t)0)
; } 
if(BgL_test3825z00_6954)
{ /* Llib/mpd.scm 568 */
bgl_display_obj(BGl_currentsongzd2cachezd2infoz00zz__multimediazd2mpdzd2, BgL_opz00_4610); }  else 
{ /* Llib/mpd.scm 570 */
obj_t BgL_infoz00_5458;
BgL_infoz00_5458 = 
BGl_currentsongzd2infozd2zz__multimediazd2mpdzd2(BgL_dbz00_4606, BgL_backendz00_4607, BgL_plistz00_5456, BgL_numz00_5457, BgL_linez00_4608, BgL_ipz00_4609); 
BGl_currentsongzd2cachezd2plistz00zz__multimediazd2mpdzd2 = BgL_plistz00_5456; 
BGl_currentsongzd2cachezd2numz00zz__multimediazd2mpdzd2 = 
(long)(BgL_numz00_5457); 
BGl_currentsongzd2cachezd2infoz00zz__multimediazd2mpdzd2 = BgL_infoz00_5458; 
bgl_display_obj(BgL_infoz00_5458, BgL_opz00_4610); } }  else 
{ /* Llib/mpd.scm 582 */BFALSE; } } 
return 
CNST_TABLE_REF(((long)53));} } 

}



/* &mpd-play */
obj_t BGl_z62mpdzd2playzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4611, obj_t BgL_dbz00_4612, obj_t BgL_backendz00_4613, obj_t BgL_linez00_4614, obj_t BgL_ipz00_4615, obj_t BgL_opz00_4616)
{
{ /* Llib/mpd.scm 589 */
{ /* Llib/mpd.scm 589 */
obj_t BgL_numz00_5459;
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5460;
BgL_strz00_5460 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4614, ((long)1)); 
if(
STRINGP(BgL_strz00_5460))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_6967;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_6968;
BgL_tmpz00_6968 = 
BSTRING_TO_STRING(BgL_strz00_5460); 
BgL_tmpz00_6967 = 
BGL_STRTOL(BgL_tmpz00_6968, ((long)0), ((long)10)); } 
BgL_numz00_5459 = 
BINT(BgL_tmpz00_6967); }  else 
{ /* Llib/mpd.scm 223 */
BgL_numz00_5459 = BFALSE; } } 
{ /* Llib/mpd.scm 590 */
bool_t BgL_test3828z00_6972;
if(
BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(BgL_numz00_5459))
{ /* Llib/mpd.scm 590 */
BgL_test3828z00_6972 = 
(
(long)CINT(BgL_numz00_5459)>=((long)0))
; }  else 
{ /* Llib/mpd.scm 590 */
BgL_test3828z00_6972 = ((bool_t)0)
; } 
if(BgL_test3828z00_6972)
{ /* Llib/mpd.scm 591 */
obj_t BgL_list1983z00_5461;
BgL_list1983z00_5461 = 
MAKE_YOUNG_PAIR(BgL_numz00_5459, BNIL); 
BGl_musiczd2playzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4613), BgL_list1983z00_5461); }  else 
{ /* Llib/mpd.scm 590 */
BGl_musiczd2playzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4613), BNIL); } } 
return 
CNST_TABLE_REF(((long)53));} } 

}



/* &mpd-playid */
obj_t BGl_z62mpdzd2playidzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4617, obj_t BgL_dbz00_4618, obj_t BgL_backendz00_4619, obj_t BgL_linez00_4620, obj_t BgL_ipz00_4621, obj_t BgL_opz00_4622)
{
{ /* Llib/mpd.scm 598 */
{ /* Llib/mpd.scm 598 */
obj_t BgL_numz00_5462;
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5463;
BgL_strz00_5463 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4620, ((long)1)); 
if(
STRINGP(BgL_strz00_5463))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_6986;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_6987;
BgL_tmpz00_6987 = 
BSTRING_TO_STRING(BgL_strz00_5463); 
BgL_tmpz00_6986 = 
BGL_STRTOL(BgL_tmpz00_6987, ((long)0), ((long)10)); } 
BgL_numz00_5462 = 
BINT(BgL_tmpz00_6986); }  else 
{ /* Llib/mpd.scm 223 */
BgL_numz00_5462 = BFALSE; } } 
{ /* Llib/mpd.scm 599 */
bool_t BgL_test3831z00_6991;
if(
BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(BgL_numz00_5462))
{ /* Llib/mpd.scm 599 */
BgL_test3831z00_6991 = 
(
(long)CINT(BgL_numz00_5462)>=((long)0))
; }  else 
{ /* Llib/mpd.scm 599 */
BgL_test3831z00_6991 = ((bool_t)0)
; } 
if(BgL_test3831z00_6991)
{ /* Llib/mpd.scm 600 */
obj_t BgL_list1987z00_5464;
BgL_list1987z00_5464 = 
MAKE_YOUNG_PAIR(BgL_numz00_5462, BNIL); 
BGl_musiczd2playzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4619), BgL_list1987z00_5464); }  else 
{ /* Llib/mpd.scm 599 */
BGl_musiczd2playzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4619), BNIL); } } 
return 
CNST_TABLE_REF(((long)53));} } 

}



/* &mpd-seek */
obj_t BGl_z62mpdzd2seekzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4623, obj_t BgL_dbz00_4624, obj_t BgL_backendz00_4625, obj_t BgL_linez00_4626, obj_t BgL_ipz00_4627, obj_t BgL_opz00_4628)
{
{ /* Llib/mpd.scm 607 */
{ /* Llib/mpd.scm 607 */
obj_t BgL_num1z00_5465;obj_t BgL_num2z00_5466;
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5467;
BgL_strz00_5467 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4626, ((long)1)); 
if(
STRINGP(BgL_strz00_5467))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_7005;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_7006;
BgL_tmpz00_7006 = 
BSTRING_TO_STRING(BgL_strz00_5467); 
BgL_tmpz00_7005 = 
BGL_STRTOL(BgL_tmpz00_7006, ((long)0), ((long)10)); } 
BgL_num1z00_5465 = 
BINT(BgL_tmpz00_7005); }  else 
{ /* Llib/mpd.scm 223 */
BgL_num1z00_5465 = BFALSE; } } 
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5468;
BgL_strz00_5468 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4626, ((long)2)); 
if(
STRINGP(BgL_strz00_5468))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_7013;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_7014;
BgL_tmpz00_7014 = 
BSTRING_TO_STRING(BgL_strz00_5468); 
BgL_tmpz00_7013 = 
BGL_STRTOL(BgL_tmpz00_7014, ((long)0), ((long)10)); } 
BgL_num2z00_5466 = 
BINT(BgL_tmpz00_7013); }  else 
{ /* Llib/mpd.scm 223 */
BgL_num2z00_5466 = BFALSE; } } 
{ /* Llib/mpd.scm 608 */
obj_t BgL_list1989z00_5469;
BgL_list1989z00_5469 = 
MAKE_YOUNG_PAIR(BgL_num1z00_5465, BNIL); 
BGl_musiczd2seekzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4625), BgL_num2z00_5466, BgL_list1989z00_5469); } 
return 
CNST_TABLE_REF(((long)53));} } 

}



/* &mpd-seekid */
obj_t BGl_z62mpdzd2seekidzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4629, obj_t BgL_dbz00_4630, obj_t BgL_backendz00_4631, obj_t BgL_linez00_4632, obj_t BgL_ipz00_4633, obj_t BgL_opz00_4634)
{
{ /* Llib/mpd.scm 614 */
{ /* Llib/mpd.scm 614 */
obj_t BgL_num1z00_5470;obj_t BgL_num2z00_5471;
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5472;
BgL_strz00_5472 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4632, ((long)1)); 
if(
STRINGP(BgL_strz00_5472))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_7025;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_7026;
BgL_tmpz00_7026 = 
BSTRING_TO_STRING(BgL_strz00_5472); 
BgL_tmpz00_7025 = 
BGL_STRTOL(BgL_tmpz00_7026, ((long)0), ((long)10)); } 
BgL_num1z00_5470 = 
BINT(BgL_tmpz00_7025); }  else 
{ /* Llib/mpd.scm 223 */
BgL_num1z00_5470 = BFALSE; } } 
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5473;
BgL_strz00_5473 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4632, ((long)2)); 
if(
STRINGP(BgL_strz00_5473))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_7033;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_7034;
BgL_tmpz00_7034 = 
BSTRING_TO_STRING(BgL_strz00_5473); 
BgL_tmpz00_7033 = 
BGL_STRTOL(BgL_tmpz00_7034, ((long)0), ((long)10)); } 
BgL_num2z00_5471 = 
BINT(BgL_tmpz00_7033); }  else 
{ /* Llib/mpd.scm 223 */
BgL_num2z00_5471 = BFALSE; } } 
{ /* Llib/mpd.scm 615 */
obj_t BgL_list1990z00_5474;
BgL_list1990z00_5474 = 
MAKE_YOUNG_PAIR(BgL_num1z00_5470, BNIL); 
BGl_musiczd2seekzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4631), BgL_num2z00_5471, BgL_list1990z00_5474); } 
return 
CNST_TABLE_REF(((long)53));} } 

}



/* &mpd-stop */
obj_t BGl_z62mpdzd2stopzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4635, obj_t BgL_dbz00_4636, obj_t BgL_backendz00_4637, obj_t BgL_linez00_4638, obj_t BgL_ipz00_4639, obj_t BgL_opz00_4640)
{
{ /* Llib/mpd.scm 621 */
BGl_musiczd2stopzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4637)); 
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-pause */
obj_t BGl_z62mpdzd2pausezb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4641, obj_t BgL_dbz00_4642, obj_t BgL_backendz00_4643, obj_t BgL_linez00_4644, obj_t BgL_ipz00_4645, obj_t BgL_opz00_4646)
{
{ /* Llib/mpd.scm 628 */
BGl_musiczd2pausezd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4643)); 
return 
CNST_TABLE_REF(((long)53));} 

}



/* <@exit:1997>~0 */
obj_t BGl_zc3z04exitza31997ze3ze70z60zz__multimediazd2mpdzd2(obj_t BgL_backendz00_5238, obj_t BgL_res1112z00_5237)
{
{ /* Llib/mpd.scm 636 */
jmp_buf_t jmpbuf; 
void * BgL_an_exit1118z00_1005;
if( SET_EXIT(BgL_an_exit1118z00_1005) ) { 
return 
BGL_EXIT_VALUE();
} else {
#if( SIGSETJMP_SAVESIGS == 0 )
  bgl_restore_signal_handlers();
#endif

BgL_an_exit1118z00_1005 = 
(void *)jmpbuf; 
{ /* Llib/mpd.scm 636 */

PUSH_EXIT(BgL_an_exit1118z00_1005, ((long)1)); 
{ /* Llib/mpd.scm 636 */
obj_t BgL_an_exitd1119z00_1006;
BgL_an_exitd1119z00_1006 = 
((obj_t)(&exitd)); 
{ /* Llib/mpd.scm 636 */
bool_t BgL_res1121z00_1009;
{ /* Llib/mpd.scm 636 */
obj_t BgL_ohs1110z00_1010;
BgL_ohs1110z00_1010 = 
BGL_ERROR_HANDLER_GET(); 
{ /* Llib/mpd.scm 636 */
obj_t BgL_exitd1115z00_1011;
BgL_exitd1115z00_1011 = 
((obj_t)(&exitd)); 
{ 
obj_t BgL_zc3z04anonymousza32001ze3z87_4843;
BgL_zc3z04anonymousza32001ze3z87_4843 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32001ze3ze5zz__multimediazd2mpdzd2, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32001ze3z87_4843, 
(int)(((long)0)), BgL_ohs1110z00_1010); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1115z00_1011, BgL_zc3z04anonymousza32001ze3z87_4843); 
{ /* Llib/mpd.scm 636 */
bool_t BgL_tmp1117z00_1013;
{ /* Llib/mpd.scm 636 */
obj_t BgL_arg1998z00_1014;
{ /* Llib/mpd.scm 636 */
obj_t BgL_zc3z04anonymousza32000ze3z87_4842;
BgL_zc3z04anonymousza32000ze3z87_4842 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32000ze3ze5zz__multimediazd2mpdzd2, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32000ze3z87_4842, 
(int)(((long)0)), 
((obj_t)BgL_res1112z00_5237)); 
PROCEDURE_SET(BgL_zc3z04anonymousza32000ze3z87_4842, 
(int)(((long)1)), BgL_an_exitd1119z00_1006); 
BgL_arg1998z00_1014 = 
MAKE_YOUNG_PAIR(BgL_zc3z04anonymousza32000ze3z87_4842, BgL_ohs1110z00_1010); } 
BGL_ERROR_HANDLER_SET(BgL_arg1998z00_1014); BUNSPEC; } 
{ /* Llib/mpd.scm 636 */
obj_t BgL_auxz00_4852;
BGl_musiczd2nextzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_5238)); 
BgL_auxz00_4852 = 
CNST_TABLE_REF(((long)53)); 
CELL_SET(BgL_res1112z00_5237, BgL_auxz00_4852); } 
BgL_tmp1117z00_1013 = ((bool_t)0); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1115z00_1011); 
BGL_ERROR_HANDLER_SET(BgL_ohs1110z00_1010); BUNSPEC; 
BgL_res1121z00_1009 = BgL_tmp1117z00_1013; } } } } 
POP_EXIT(); 
return 
BBOOL(BgL_res1121z00_1009);} } } 
} } 

}



/* &mpd-next */
obj_t BGl_z62mpdzd2nextzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4647, obj_t BgL_dbz00_4648, obj_t BgL_backendz00_4649, obj_t BgL_linez00_4650, obj_t BgL_ipz00_4651, obj_t BgL_opz00_4652)
{
{ /* Llib/mpd.scm 635 */
{ /* Llib/mpd.scm 636 */
obj_t BgL_res1112z00_5475;
BgL_res1112z00_5475 = 
MAKE_CELL(BUNSPEC); 
{ 
obj_t BgL_ez00_5477;
if(
CBOOL(
BGl_zc3z04exitza31997ze3ze70z60zz__multimediazd2mpdzd2(BgL_backendz00_4649, BgL_res1112z00_5475)))
{ /* Llib/mpd.scm 636 */
BgL_ez00_5477 = 
CELL_REF(BgL_res1112z00_5475); 
if(
BGl_isazf3zf3zz__objectz00(BgL_ez00_5477, BGl_z62iozd2errorzb0zz__objectz00))
{ /* Llib/mpd.scm 638 */
{ /* Llib/mpd.scm 325 */
obj_t BgL_tmpz00_7080;
BgL_tmpz00_7080 = 
((obj_t)BgL_opz00_4652); 
bgl_display_string(BGl_string3301z00zz__multimediazd2mpdzd2, BgL_tmpz00_7080); } 
bgl_display_obj(BGl_string3336z00zz__multimediazd2mpdzd2, BgL_opz00_4652); 
{ /* Llib/mpd.scm 327 */
obj_t BgL_tmpz00_7084;
BgL_tmpz00_7084 = 
((obj_t)BgL_opz00_4652); 
bgl_display_string(BGl_string3303z00zz__multimediazd2mpdzd2, BgL_tmpz00_7084); } 
bgl_display_obj(BGl_string3337z00zz__multimediazd2mpdzd2, BgL_opz00_4652); 
{ /* Llib/mpd.scm 329 */
obj_t BgL_tmpz00_7088;
BgL_tmpz00_7088 = 
((obj_t)BgL_opz00_4652); 
bgl_display_string(BGl_string3304z00zz__multimediazd2mpdzd2, BgL_tmpz00_7088); } 
bgl_display_obj(BGl_string3338z00zz__multimediazd2mpdzd2, BgL_opz00_4652); 
{ /* Llib/mpd.scm 331 */
obj_t BgL_tmpz00_7092;
BgL_tmpz00_7092 = 
((obj_t)BgL_opz00_4652); 
bgl_display_string(BGl_string3305z00zz__multimediazd2mpdzd2, BgL_tmpz00_7092); } 
{ /* Llib/mpd.scm 332 */
obj_t BgL_tmpz00_7095;
BgL_tmpz00_7095 = 
((obj_t)BgL_opz00_4652); 
bgl_flush_output_port(BgL_tmpz00_7095); } 
return 
CNST_TABLE_REF(((long)54));}  else 
{ /* Llib/mpd.scm 638 */
return 
BGl_raisez00zz__errorz00(BgL_ez00_5477);} }  else 
{ /* Llib/mpd.scm 636 */
return 
CELL_REF(BgL_res1112z00_5475);} } } } 

}



/* &<@anonymous:2000> */
obj_t BGl_z62zc3z04anonymousza32000ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4844, obj_t BgL_ez00_4847)
{
{ /* Llib/mpd.scm 636 */
{ /* Llib/mpd.scm 636 */
obj_t BgL_res1112z00_4845;obj_t BgL_an_exitd1119z00_4846;
BgL_res1112z00_4845 = 
PROCEDURE_REF(BgL_envz00_4844, 
(int)(((long)0))); 
BgL_an_exitd1119z00_4846 = 
PROCEDURE_REF(BgL_envz00_4844, 
(int)(((long)1))); 
CELL_SET(BgL_res1112z00_4845, BgL_ez00_4847); 
return 
BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd1119z00_4846, BTRUE);} } 

}



/* &<@anonymous:2001> */
obj_t BGl_z62zc3z04anonymousza32001ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4849)
{
{ /* Llib/mpd.scm 636 */
{ 
obj_t BgL_ohs1110z00_4850;
BgL_ohs1110z00_4850 = 
PROCEDURE_REF(BgL_envz00_4849, 
(int)(((long)0))); 
BGL_ERROR_HANDLER_SET(BgL_ohs1110z00_4850); 
return BUNSPEC;} } 

}



/* <@exit:2010>~0 */
obj_t BGl_zc3z04exitza32010ze3ze70z60zz__multimediazd2mpdzd2(obj_t BgL_backendz00_5236, obj_t BgL_res1124z00_5235)
{
{ /* Llib/mpd.scm 649 */
jmp_buf_t jmpbuf; 
void * BgL_an_exit1130z00_1048;
if( SET_EXIT(BgL_an_exit1130z00_1048) ) { 
return 
BGL_EXIT_VALUE();
} else {
#if( SIGSETJMP_SAVESIGS == 0 )
  bgl_restore_signal_handlers();
#endif

BgL_an_exit1130z00_1048 = 
(void *)jmpbuf; 
{ /* Llib/mpd.scm 649 */

PUSH_EXIT(BgL_an_exit1130z00_1048, ((long)1)); 
{ /* Llib/mpd.scm 649 */
obj_t BgL_an_exitd1131z00_1049;
BgL_an_exitd1131z00_1049 = 
((obj_t)(&exitd)); 
{ /* Llib/mpd.scm 649 */
bool_t BgL_res1133z00_1052;
{ /* Llib/mpd.scm 649 */
obj_t BgL_ohs1122z00_1053;
BgL_ohs1122z00_1053 = 
BGL_ERROR_HANDLER_GET(); 
{ /* Llib/mpd.scm 649 */
obj_t BgL_exitd1127z00_1054;
BgL_exitd1127z00_1054 = 
((obj_t)(&exitd)); 
{ 
obj_t BgL_zc3z04anonymousza32014ze3z87_4855;
BgL_zc3z04anonymousza32014ze3z87_4855 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32014ze3ze5zz__multimediazd2mpdzd2, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32014ze3z87_4855, 
(int)(((long)0)), BgL_ohs1122z00_1053); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1127z00_1054, BgL_zc3z04anonymousza32014ze3z87_4855); 
{ /* Llib/mpd.scm 649 */
bool_t BgL_tmp1129z00_1056;
{ /* Llib/mpd.scm 649 */
obj_t BgL_arg2011z00_1057;
{ /* Llib/mpd.scm 649 */
obj_t BgL_zc3z04anonymousza32013ze3z87_4854;
BgL_zc3z04anonymousza32013ze3z87_4854 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32013ze3ze5zz__multimediazd2mpdzd2, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32013ze3z87_4854, 
(int)(((long)0)), 
((obj_t)BgL_res1124z00_5235)); 
PROCEDURE_SET(BgL_zc3z04anonymousza32013ze3z87_4854, 
(int)(((long)1)), BgL_an_exitd1131z00_1049); 
BgL_arg2011z00_1057 = 
MAKE_YOUNG_PAIR(BgL_zc3z04anonymousza32013ze3z87_4854, BgL_ohs1122z00_1053); } 
BGL_ERROR_HANDLER_SET(BgL_arg2011z00_1057); BUNSPEC; } 
{ /* Llib/mpd.scm 649 */
obj_t BgL_auxz00_4864;
BGl_musiczd2prevzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_5236)); 
BgL_auxz00_4864 = 
CNST_TABLE_REF(((long)53)); 
CELL_SET(BgL_res1124z00_5235, BgL_auxz00_4864); } 
BgL_tmp1129z00_1056 = ((bool_t)0); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1127z00_1054); 
BGL_ERROR_HANDLER_SET(BgL_ohs1122z00_1053); BUNSPEC; 
BgL_res1133z00_1052 = BgL_tmp1129z00_1056; } } } } 
POP_EXIT(); 
return 
BBOOL(BgL_res1133z00_1052);} } } 
} } 

}



/* &mpd-previous */
obj_t BGl_z62mpdzd2previouszb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4653, obj_t BgL_dbz00_4654, obj_t BgL_backendz00_4655, obj_t BgL_linez00_4656, obj_t BgL_ipz00_4657, obj_t BgL_opz00_4658)
{
{ /* Llib/mpd.scm 648 */
{ /* Llib/mpd.scm 649 */
obj_t BgL_res1124z00_5478;
BgL_res1124z00_5478 = 
MAKE_CELL(BUNSPEC); 
{ 
obj_t BgL_ez00_5480;
if(
CBOOL(
BGl_zc3z04exitza32010ze3ze70z60zz__multimediazd2mpdzd2(BgL_backendz00_4655, BgL_res1124z00_5478)))
{ /* Llib/mpd.scm 649 */
BgL_ez00_5480 = 
CELL_REF(BgL_res1124z00_5478); 
if(
BGl_isazf3zf3zz__objectz00(BgL_ez00_5480, BGl_z62iozd2errorzb0zz__objectz00))
{ /* Llib/mpd.scm 651 */
{ /* Llib/mpd.scm 325 */
obj_t BgL_tmpz00_7140;
BgL_tmpz00_7140 = 
((obj_t)BgL_opz00_4658); 
bgl_display_string(BGl_string3301z00zz__multimediazd2mpdzd2, BgL_tmpz00_7140); } 
bgl_display_obj(BGl_string3336z00zz__multimediazd2mpdzd2, BgL_opz00_4658); 
{ /* Llib/mpd.scm 327 */
obj_t BgL_tmpz00_7144;
BgL_tmpz00_7144 = 
((obj_t)BgL_opz00_4658); 
bgl_display_string(BGl_string3303z00zz__multimediazd2mpdzd2, BgL_tmpz00_7144); } 
bgl_display_obj(BGl_string3339z00zz__multimediazd2mpdzd2, BgL_opz00_4658); 
{ /* Llib/mpd.scm 329 */
obj_t BgL_tmpz00_7148;
BgL_tmpz00_7148 = 
((obj_t)BgL_opz00_4658); 
bgl_display_string(BGl_string3304z00zz__multimediazd2mpdzd2, BgL_tmpz00_7148); } 
bgl_display_obj(BGl_string3340z00zz__multimediazd2mpdzd2, BgL_opz00_4658); 
{ /* Llib/mpd.scm 331 */
obj_t BgL_tmpz00_7152;
BgL_tmpz00_7152 = 
((obj_t)BgL_opz00_4658); 
bgl_display_string(BGl_string3305z00zz__multimediazd2mpdzd2, BgL_tmpz00_7152); } 
{ /* Llib/mpd.scm 332 */
obj_t BgL_tmpz00_7155;
BgL_tmpz00_7155 = 
((obj_t)BgL_opz00_4658); 
bgl_flush_output_port(BgL_tmpz00_7155); } 
return 
CNST_TABLE_REF(((long)54));}  else 
{ /* Llib/mpd.scm 651 */
return 
BGl_raisez00zz__errorz00(BgL_ez00_5480);} }  else 
{ /* Llib/mpd.scm 649 */
return 
CELL_REF(BgL_res1124z00_5478);} } } } 

}



/* &<@anonymous:2013> */
obj_t BGl_z62zc3z04anonymousza32013ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4856, obj_t BgL_ez00_4859)
{
{ /* Llib/mpd.scm 649 */
{ /* Llib/mpd.scm 649 */
obj_t BgL_res1124z00_4857;obj_t BgL_an_exitd1131z00_4858;
BgL_res1124z00_4857 = 
PROCEDURE_REF(BgL_envz00_4856, 
(int)(((long)0))); 
BgL_an_exitd1131z00_4858 = 
PROCEDURE_REF(BgL_envz00_4856, 
(int)(((long)1))); 
CELL_SET(BgL_res1124z00_4857, BgL_ez00_4859); 
return 
BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd1131z00_4858, BTRUE);} } 

}



/* &<@anonymous:2014> */
obj_t BGl_z62zc3z04anonymousza32014ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4861)
{
{ /* Llib/mpd.scm 649 */
{ 
obj_t BgL_ohs1122z00_4862;
BgL_ohs1122z00_4862 = 
PROCEDURE_REF(BgL_envz00_4861, 
(int)(((long)0))); 
BGL_ERROR_HANDLER_SET(BgL_ohs1122z00_4862); 
return BUNSPEC;} } 

}



/* &mpd-volume */
obj_t BGl_z62mpdzd2volumezb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4659, obj_t BgL_dbz00_4660, obj_t BgL_backendz00_4661, obj_t BgL_linez00_4662, obj_t BgL_ipz00_4663, obj_t BgL_opz00_4664)
{
{ /* Llib/mpd.scm 661 */
{ /* Llib/mpd.scm 661 */
obj_t BgL_intz00_5481;
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5482;
BgL_strz00_5482 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4662, ((long)1)); 
if(
STRINGP(BgL_strz00_5482))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_7171;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_7172;
BgL_tmpz00_7172 = 
BSTRING_TO_STRING(BgL_strz00_5482); 
BgL_tmpz00_7171 = 
BGL_STRTOL(BgL_tmpz00_7172, ((long)0), ((long)10)); } 
BgL_intz00_5481 = 
BINT(BgL_tmpz00_7171); }  else 
{ /* Llib/mpd.scm 223 */
BgL_intz00_5481 = BFALSE; } } 
if(
BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(BgL_intz00_5481))
{ /* Llib/mpd.scm 662 */
BGl_musiczd2volumezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4661), BgL_intz00_5481); 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 662 */
{ /* Llib/mpd.scm 670 */
obj_t BgL_arg2018z00_5483;
BgL_arg2018z00_5483 = 
BGl_musiczd2volumezd2getz00zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4661)); 
bgl_display_obj(BgL_arg2018z00_5483, BgL_opz00_4664); } 
{ /* Llib/mpd.scm 671 */
obj_t BgL_tmpz00_7184;
BgL_tmpz00_7184 = 
((obj_t)BgL_opz00_4664); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_7184); } 
return 
CNST_TABLE_REF(((long)53));} } } 

}



/* &mpd-setvol */
obj_t BGl_z62mpdzd2setvolzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4665, obj_t BgL_dbz00_4666, obj_t BgL_backendz00_4667, obj_t BgL_linez00_4668, obj_t BgL_ipz00_4669, obj_t BgL_opz00_4670)
{
{ /* Llib/mpd.scm 684 */
{ /* Llib/mpd.scm 684 */
obj_t BgL_intz00_5484;
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5485;
BgL_strz00_5485 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4668, ((long)1)); 
if(
STRINGP(BgL_strz00_5485))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_7191;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_7192;
BgL_tmpz00_7192 = 
BSTRING_TO_STRING(BgL_strz00_5485); 
BgL_tmpz00_7191 = 
BGL_STRTOL(BgL_tmpz00_7192, ((long)0), ((long)10)); } 
BgL_intz00_5484 = 
BINT(BgL_tmpz00_7191); }  else 
{ /* Llib/mpd.scm 223 */
BgL_intz00_5484 = BFALSE; } } 
BGl_musiczd2volumezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4667), BgL_intz00_5484); 
return 
CNST_TABLE_REF(((long)53));} } 

}



/* &mpd-clearerror */
obj_t BGl_z62mpdzd2clearerrorzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4671, obj_t BgL_dbz00_4672, obj_t BgL_backendz00_4673, obj_t BgL_linez00_4674, obj_t BgL_ipz00_4675, obj_t BgL_opz00_4676)
{
{ /* Llib/mpd.scm 690 */
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-close */
obj_t BGl_z62mpdzd2closezb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4677, obj_t BgL_dbz00_4678, obj_t BgL_backendz00_4679, obj_t BgL_linez00_4680, obj_t BgL_ipz00_4681, obj_t BgL_opz00_4682)
{
{ /* Llib/mpd.scm 696 */
return 
CNST_TABLE_REF(((long)24));} 

}



/* &mpd-stats */
obj_t BGl_z62mpdzd2statszb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4683, obj_t BgL_dbz00_4684, obj_t BgL_backendz00_4685, obj_t BgL_linez00_4686, obj_t BgL_ipz00_4687, obj_t BgL_opz00_4688)
{
{ /* Llib/mpd.scm 702 */
BGl_mpdzd2databasezd2statsz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4684), BgL_backendz00_4685, BgL_opz00_4688); 
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-listall */
obj_t BGl_z62mpdzd2listallzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4689, obj_t BgL_dbz00_4690, obj_t BgL_backendz00_4691, obj_t BgL_linez00_4692, obj_t BgL_ipz00_4693, obj_t BgL_opz00_4694)
{
{ /* Llib/mpd.scm 709 */
BGl_mpdzd2databasezd2listallz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4690), BgL_opz00_4694); 
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-list */
obj_t BGl_z62mpdzd2listzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4695, obj_t BgL_dbz00_4696, obj_t BgL_backendz00_4697, obj_t BgL_linez00_4698, obj_t BgL_ipz00_4699, obj_t BgL_opz00_4700)
{
{ /* Llib/mpd.scm 716 */
{ /* Llib/mpd.scm 716 */
obj_t BgL_symz00_5486;obj_t BgL_string2z00_5487;obj_t BgL_string3z00_5488;
BgL_symz00_5486 = 
BGl_getzd2linezd2argzd2symbolzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4698, ((long)1)); 
BgL_string2z00_5487 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4698, ((long)2)); 
BgL_string3z00_5488 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4698, ((long)3)); 
if(
(BgL_symz00_5486==
CNST_TABLE_REF(((long)62))))
{ /* Llib/mpd.scm 717 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(BgL_string2z00_5487, BGl_string3341z00zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 720 */
BGl_mpdzd2databasezd2listartistalbumz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4696), BgL_opz00_4700, BgL_string3z00_5488); }  else 
{ /* Llib/mpd.scm 720 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(BgL_string2z00_5487, BGl_string3342z00zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 722 */
BGl_mpdzd2databasezd2listgenrealbumz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4696), BgL_opz00_4700, BgL_string3z00_5488); }  else 
{ /* Llib/mpd.scm 722 */
BGl_mpdzd2databasezd2listartistalbumz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4696), BgL_opz00_4700, BgL_string2z00_5487); } } 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 717 */
if(
(BgL_symz00_5486==
CNST_TABLE_REF(((long)60))))
{ /* Llib/mpd.scm 717 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(BgL_string2z00_5487, BGl_string3342z00zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 728 */
BGl_mpdzd2databasezd2listgenreartistz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4696), BgL_opz00_4700, BgL_string3z00_5488); }  else 
{ /* Llib/mpd.scm 728 */
BGl_mpdzd2databasezd2listartistz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4696), BgL_opz00_4700); } 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 717 */
if(
(BgL_symz00_5486==
CNST_TABLE_REF(((long)63))))
{ /* Llib/mpd.scm 717 */
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 717 */
if(
(BgL_symz00_5486==
CNST_TABLE_REF(((long)64))))
{ /* Llib/mpd.scm 717 */
BGl_mpdzd2databasezd2listgenrez00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4696), BgL_opz00_4700); 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 717 */
if(
CBOOL(BgL_symz00_5486))
{ /* Llib/mpd.scm 740 */
obj_t BgL_list2026z00_5489;
BgL_list2026z00_5489 = 
MAKE_YOUNG_PAIR(BgL_symz00_5486, BNIL); 
return 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string3343z00zz__multimediazd2mpdzd2, BgL_list2026z00_5489);}  else 
{ /* Llib/mpd.scm 738 */
return BGl_string3344z00zz__multimediazd2mpdzd2;} } } } } } } 

}



/* &mpd-listallinfo */
obj_t BGl_z62mpdzd2listallinfozb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4701, obj_t BgL_dbz00_4702, obj_t BgL_backendz00_4703, obj_t BgL_linez00_4704, obj_t BgL_ipz00_4705, obj_t BgL_opz00_4706)
{
{ /* Llib/mpd.scm 745 */
{ /* Llib/mpd.scm 745 */
obj_t BgL_dirz00_5490;
BgL_dirz00_5490 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4704, ((long)1)); 
{ /* Llib/mpd.scm 746 */
obj_t BgL_arg2027z00_5491;
if(
CBOOL(BgL_dirz00_5490))
{ /* Llib/mpd.scm 746 */
BgL_arg2027z00_5491 = BgL_dirz00_5490; }  else 
{ /* Llib/mpd.scm 746 */
obj_t BgL_list2029z00_5492;
BgL_list2029z00_5492 = 
MAKE_YOUNG_PAIR(
BCHAR(FILE_SEPARATOR), BNIL); 
BgL_arg2027z00_5491 = 
BGl_listzd2ze3stringz31zz__r4_strings_6_7z00(BgL_list2029z00_5492); } 
BGl_mpdzd2databasezd2lsinfoz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4702), BgL_opz00_4706, BgL_arg2027z00_5491, ((bool_t)1)); } 
return 
CNST_TABLE_REF(((long)53));} } 

}



/* &mpd-lsinfo */
obj_t BGl_z62mpdzd2lsinfozb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4707, obj_t BgL_dbz00_4708, obj_t BgL_backendz00_4709, obj_t BgL_linez00_4710, obj_t BgL_ipz00_4711, obj_t BgL_opz00_4712)
{
{ /* Llib/mpd.scm 752 */
{ /* Llib/mpd.scm 752 */
obj_t BgL_dirz00_5493;
BgL_dirz00_5493 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4710, ((long)1)); 
{ /* Llib/mpd.scm 753 */
obj_t BgL_arg2030z00_5494;
if(
CBOOL(BgL_dirz00_5493))
{ /* Llib/mpd.scm 753 */
BgL_arg2030z00_5494 = BgL_dirz00_5493; }  else 
{ /* Llib/mpd.scm 753 */
obj_t BgL_list2032z00_5495;
BgL_list2032z00_5495 = 
MAKE_YOUNG_PAIR(
BCHAR(FILE_SEPARATOR), BNIL); 
BgL_arg2030z00_5494 = 
BGl_listzd2ze3stringz31zz__r4_strings_6_7z00(BgL_list2032z00_5495); } 
BGl_mpdzd2databasezd2lsinfoz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4708), BgL_opz00_4712, BgL_arg2030z00_5494, ((bool_t)0)); } 
return 
CNST_TABLE_REF(((long)53));} } 

}



/* &mpd-plconangesposid */
obj_t BGl_z62mpdzd2plconangesposidzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4713, obj_t BgL_dbz00_4714, obj_t BgL_backendz00_4715, obj_t BgL_linez00_4716, obj_t BgL_ipz00_4717, obj_t BgL_opz00_4718)
{
{ /* Llib/mpd.scm 759 */
{ /* Llib/mpd.scm 759 */
obj_t BgL_intz00_5496;
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5497;
BgL_strz00_5497 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4716, ((long)1)); 
if(
STRINGP(BgL_strz00_5497))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_7269;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_7270;
BgL_tmpz00_7270 = 
BSTRING_TO_STRING(BgL_strz00_5497); 
BgL_tmpz00_7269 = 
BGL_STRTOL(BgL_tmpz00_7270, ((long)0), ((long)10)); } 
BgL_intz00_5496 = 
BINT(BgL_tmpz00_7269); }  else 
{ /* Llib/mpd.scm 223 */
BgL_intz00_5496 = BFALSE; } } 
{ /* Llib/mpd.scm 760 */
long BgL_numz00_5498;
BgL_numz00_5498 = ((long)0); 
{ /* Llib/mpd.scm 761 */
obj_t BgL_g1199z00_5499;
BgL_g1199z00_5499 = 
BGl_musiczd2playlistzd2getz00zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4715)); 
{ 
obj_t BgL_l1197z00_5501;
BgL_l1197z00_5501 = BgL_g1199z00_5499; 
BgL_zc3z04anonymousza32033ze3z87_5500:
if(
PAIRP(BgL_l1197z00_5501))
{ /* Llib/mpd.scm 765 */
{ /* Llib/mpd.scm 762 */
obj_t BgL_tmpz00_7278;
BgL_tmpz00_7278 = 
((obj_t)BgL_opz00_4718); 
bgl_display_string(BGl_string3345z00zz__multimediazd2mpdzd2, BgL_tmpz00_7278); } 
bgl_display_obj(
BINT(BgL_numz00_5498), BgL_opz00_4718); 
{ /* Llib/mpd.scm 762 */
obj_t BgL_tmpz00_7283;
BgL_tmpz00_7283 = 
((obj_t)BgL_opz00_4718); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_7283); } 
{ /* Llib/mpd.scm 763 */
obj_t BgL_tmpz00_7286;
BgL_tmpz00_7286 = 
((obj_t)BgL_opz00_4718); 
bgl_display_string(BGl_string3332z00zz__multimediazd2mpdzd2, BgL_tmpz00_7286); } 
bgl_display_obj(
BINT(BgL_numz00_5498), BgL_opz00_4718); 
{ /* Llib/mpd.scm 763 */
obj_t BgL_tmpz00_7291;
BgL_tmpz00_7291 = 
((obj_t)BgL_opz00_4718); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_7291); } 
BgL_numz00_5498 = 
(BgL_numz00_5498+((long)1)); 
{ 
obj_t BgL_l1197z00_7295;
BgL_l1197z00_7295 = 
CDR(BgL_l1197z00_5501); 
BgL_l1197z00_5501 = BgL_l1197z00_7295; 
goto BgL_zc3z04anonymousza32033ze3z87_5500;} }  else 
{ /* Llib/mpd.scm 765 */((bool_t)1); } } } } 
return 
CNST_TABLE_REF(((long)53));} } 

}



/* &mpd-kill */
obj_t BGl_z62mpdzd2killzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4719, obj_t BgL_dbz00_4720, obj_t BgL_backendz00_4721, obj_t BgL_linez00_4722, obj_t BgL_ipz00_4723, obj_t BgL_opz00_4724)
{
{ /* Llib/mpd.scm 771 */
return 
CNST_TABLE_REF(((long)31));} 

}



/* &mpd-find */
obj_t BGl_z62mpdzd2findzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4725, obj_t BgL_dbz00_4726, obj_t BgL_backendz00_4727, obj_t BgL_linez00_4728, obj_t BgL_ipz00_4729, obj_t BgL_opz00_4730)
{
{ /* Llib/mpd.scm 777 */
{ /* Llib/mpd.scm 777 */
obj_t BgL_symbolz00_5502;obj_t BgL_string2z00_5503;
BgL_symbolz00_5502 = 
BGl_getzd2linezd2argzd2symbolzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4728, ((long)1)); 
BgL_string2z00_5503 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4728, ((long)2)); 
if(
(BgL_symbolz00_5502==
CNST_TABLE_REF(((long)62))))
{ /* Llib/mpd.scm 778 */
BGl_mpdzd2databasezd2findzd2albumzd2zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4726), BgL_opz00_4730, BgL_string2z00_5503); 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 778 */
if(
(BgL_symbolz00_5502==
CNST_TABLE_REF(((long)60))))
{ /* Llib/mpd.scm 778 */
BGl_mpdzd2databasezd2findzd2artistzd2zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4726), BgL_opz00_4730, BgL_string2z00_5503); 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 778 */
if(
(BgL_symbolz00_5502==
CNST_TABLE_REF(((long)61))))
{ /* Llib/mpd.scm 778 */
BGl_mpdzd2databasezd2findzd2titlezd2zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4726), BgL_opz00_4730, BgL_string2z00_5503); 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 778 */
if(
(BgL_symbolz00_5502==
CNST_TABLE_REF(((long)64))))
{ /* Llib/mpd.scm 778 */
BGl_mpdzd2databasezd2findzd2genrezd2zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4726), BgL_opz00_4730, BgL_string2z00_5503); 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 792 */
obj_t BgL_list2040z00_5504;
BgL_list2040z00_5504 = 
MAKE_YOUNG_PAIR(BgL_symbolz00_5502, BNIL); 
return 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string3346z00zz__multimediazd2mpdzd2, BgL_list2040z00_5504);} } } } } } 

}



/* &mpd-search */
obj_t BGl_z62mpdzd2searchzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4731, obj_t BgL_dbz00_4732, obj_t BgL_backendz00_4733, obj_t BgL_linez00_4734, obj_t BgL_ipz00_4735, obj_t BgL_opz00_4736)
{
{ /* Llib/mpd.scm 797 */
{ /* Llib/mpd.scm 797 */
obj_t BgL_symbol1z00_5505;obj_t BgL_string2z00_5506;obj_t BgL_symbol3z00_5507;obj_t BgL_string4z00_5508;
BgL_symbol1z00_5505 = 
BGl_getzd2linezd2argzd2symbolzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4734, ((long)1)); 
BgL_string2z00_5506 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4734, ((long)2)); 
BgL_symbol3z00_5507 = 
BGl_getzd2linezd2argzd2symbolzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4734, ((long)3)); 
BgL_string4z00_5508 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4734, ((long)4)); 
if(
(BgL_symbol1z00_5505==
CNST_TABLE_REF(((long)62))))
{ /* Llib/mpd.scm 798 */
BGl_mpdzd2databasezd2findzd2albumzd2zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4732), BgL_opz00_4736, BgL_string2z00_5506); 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 798 */
if(
(BgL_symbol1z00_5505==
CNST_TABLE_REF(((long)60))))
{ /* Llib/mpd.scm 798 */
if(
(BgL_symbol3z00_5507==
CNST_TABLE_REF(((long)62))))
{ /* Llib/mpd.scm 803 */
BGl_mpdzd2databasezd2searchzd2artistzd2albumz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4732), BgL_opz00_4736, BgL_string2z00_5506, BgL_string4z00_5508); }  else 
{ /* Llib/mpd.scm 803 */
if(
(BgL_symbol3z00_5507==
CNST_TABLE_REF(((long)61))))
{ /* Llib/mpd.scm 803 */
BGl_mpdzd2databasezd2searchzd2artistzd2titlez00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4732), BgL_opz00_4736, BgL_string2z00_5506, BgL_string4z00_5508); }  else 
{ /* Llib/mpd.scm 803 */
BGl_mpdzd2databasezd2findzd2artistzd2zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4732), BgL_opz00_4736, BgL_string2z00_5506); } } 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 798 */
if(
(BgL_symbol1z00_5505==
CNST_TABLE_REF(((long)61))))
{ /* Llib/mpd.scm 798 */
BGl_mpdzd2databasezd2findzd2titlezd2zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4732), BgL_opz00_4736, BgL_string2z00_5506); 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 798 */
if(
(BgL_symbol1z00_5505==
CNST_TABLE_REF(((long)64))))
{ /* Llib/mpd.scm 798 */
BGl_mpdzd2databasezd2findzd2genrezd2zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4732), BgL_opz00_4736, BgL_string2z00_5506); 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 798 */
if(
(BgL_symbol1z00_5505==
CNST_TABLE_REF(((long)65))))
{ /* Llib/mpd.scm 798 */
BGl_mpdzd2databasezd2listallz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4732), BgL_opz00_4736); 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 820 */
obj_t BgL_list2048z00_5509;
BgL_list2048z00_5509 = 
MAKE_YOUNG_PAIR(BgL_symbol1z00_5505, BNIL); 
return 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string3347z00zz__multimediazd2mpdzd2, BgL_list2048z00_5509);} } } } } } } 

}



/* &mpd-commands */
obj_t BGl_z62mpdzd2commandszb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4737, obj_t BgL_dbz00_4738, obj_t BgL_backendz00_4739, obj_t BgL_linez00_4740, obj_t BgL_ipz00_4741, obj_t BgL_opz00_4742)
{
{ /* Llib/mpd.scm 825 */
{ /* Llib/mpd.scm 826 */
obj_t BgL_g1202z00_5510;
BgL_g1202z00_5510 = 
BGl_sortz00zz__r4_vectors_6_8z00(BGl_proc3348z00zz__multimediazd2mpdzd2, BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2); 
{ 
obj_t BgL_l1200z00_5513;
BgL_l1200z00_5513 = BgL_g1202z00_5510; 
BgL_zc3z04anonymousza32049ze3z87_5512:
if(
PAIRP(BgL_l1200z00_5513))
{ /* Llib/mpd.scm 830 */
{ /* Llib/mpd.scm 827 */
obj_t BgL_cz00_5514;
BgL_cz00_5514 = 
CAR(BgL_l1200z00_5513); 
{ /* Llib/mpd.scm 827 */
obj_t BgL_tmpz00_7377;
BgL_tmpz00_7377 = 
((obj_t)BgL_opz00_4742); 
bgl_display_string(BGl_string3349z00zz__multimediazd2mpdzd2, BgL_tmpz00_7377); } 
{ /* Llib/mpd.scm 828 */
obj_t BgL_arg2051z00_5515;
BgL_arg2051z00_5515 = 
CAR(
((obj_t)BgL_cz00_5514)); 
bgl_display_obj(BgL_arg2051z00_5515, BgL_opz00_4742); } 
{ /* Llib/mpd.scm 829 */
obj_t BgL_tmpz00_7383;
BgL_tmpz00_7383 = 
((obj_t)BgL_opz00_4742); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_7383); } } 
{ 
obj_t BgL_l1200z00_7386;
BgL_l1200z00_7386 = 
CDR(BgL_l1200z00_5513); 
BgL_l1200z00_5513 = BgL_l1200z00_7386; 
goto BgL_zc3z04anonymousza32049ze3z87_5512;} }  else 
{ /* Llib/mpd.scm 830 */((bool_t)1); } } } 
return 
CNST_TABLE_REF(((long)53));} 

}



/* &<@anonymous:2054> */
obj_t BGl_z62zc3z04anonymousza32054ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4867, obj_t BgL_c1z00_4868, obj_t BgL_c2z00_4869)
{
{ /* Llib/mpd.scm 830 */
{ /* Llib/mpd.scm 831 */
bool_t BgL_tmpz00_7389;
{ /* Llib/mpd.scm 831 */
obj_t BgL_arg2055z00_5516;obj_t BgL_arg2056z00_5517;
{ /* Llib/mpd.scm 831 */
obj_t BgL_arg2057z00_5518;
BgL_arg2057z00_5518 = 
CAR(
((obj_t)BgL_c1z00_4868)); 
{ /* Llib/mpd.scm 831 */
obj_t BgL_res2812z00_5519;
{ /* Llib/mpd.scm 831 */
obj_t BgL_arg1390z00_5520;
BgL_arg1390z00_5520 = 
SYMBOL_TO_STRING(
((obj_t)BgL_arg2057z00_5518)); 
BgL_res2812z00_5519 = 
BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg1390z00_5520); } 
BgL_arg2055z00_5516 = BgL_res2812z00_5519; } } 
{ /* Llib/mpd.scm 832 */
obj_t BgL_arg2058z00_5521;
BgL_arg2058z00_5521 = 
CAR(
((obj_t)BgL_c2z00_4869)); 
{ /* Llib/mpd.scm 832 */
obj_t BgL_res2813z00_5522;
{ /* Llib/mpd.scm 832 */
obj_t BgL_arg1390z00_5523;
BgL_arg1390z00_5523 = 
SYMBOL_TO_STRING(
((obj_t)BgL_arg2058z00_5521)); 
BgL_res2813z00_5522 = 
BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg1390z00_5523); } 
BgL_arg2056z00_5517 = BgL_res2813z00_5522; } } 
BgL_tmpz00_7389 = 
bigloo_string_lt(BgL_arg2055z00_5516, BgL_arg2056z00_5517); } 
return 
BBOOL(BgL_tmpz00_7389);} } 

}



/* &mpd-notcommands */
obj_t BGl_z62mpdzd2notcommandszb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4743, obj_t BgL_dbz00_4744, obj_t BgL_backendz00_4745, obj_t BgL_linez00_4746, obj_t BgL_ipz00_4747, obj_t BgL_opz00_4748)
{
{ /* Llib/mpd.scm 839 */
{ /* Llib/mpd.scm 840 */
obj_t BgL_g1205z00_5524;
BgL_g1205z00_5524 = 
BGl_sortz00zz__r4_vectors_6_8z00(BGl_proc3350z00zz__multimediazd2mpdzd2, BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2); 
{ 
obj_t BgL_l1203z00_5527;
BgL_l1203z00_5527 = BgL_g1205z00_5524; 
BgL_zc3z04anonymousza32059ze3z87_5526:
if(
PAIRP(BgL_l1203z00_5527))
{ /* Llib/mpd.scm 844 */
{ /* Llib/mpd.scm 841 */
obj_t BgL_cz00_5528;
BgL_cz00_5528 = 
CAR(BgL_l1203z00_5527); 
{ /* Llib/mpd.scm 841 */
obj_t BgL_tmpz00_7406;
BgL_tmpz00_7406 = 
((obj_t)BgL_opz00_4748); 
bgl_display_string(BGl_string3349z00zz__multimediazd2mpdzd2, BgL_tmpz00_7406); } 
{ /* Llib/mpd.scm 842 */
obj_t BgL_arg2061z00_5529;
BgL_arg2061z00_5529 = 
CAR(
((obj_t)BgL_cz00_5528)); 
bgl_display_obj(BgL_arg2061z00_5529, BgL_opz00_4748); } 
{ /* Llib/mpd.scm 843 */
obj_t BgL_tmpz00_7412;
BgL_tmpz00_7412 = 
((obj_t)BgL_opz00_4748); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_7412); } } 
{ 
obj_t BgL_l1203z00_7415;
BgL_l1203z00_7415 = 
CDR(BgL_l1203z00_5527); 
BgL_l1203z00_5527 = BgL_l1203z00_7415; 
goto BgL_zc3z04anonymousza32059ze3z87_5526;} }  else 
{ /* Llib/mpd.scm 844 */((bool_t)1); } } } 
return 
CNST_TABLE_REF(((long)53));} 

}



/* &<@anonymous:2064> */
obj_t BGl_z62zc3z04anonymousza32064ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4871, obj_t BgL_c1z00_4872, obj_t BgL_c2z00_4873)
{
{ /* Llib/mpd.scm 844 */
{ /* Llib/mpd.scm 845 */
bool_t BgL_tmpz00_7418;
{ /* Llib/mpd.scm 845 */
obj_t BgL_arg2065z00_5530;obj_t BgL_arg2066z00_5531;
{ /* Llib/mpd.scm 845 */
obj_t BgL_arg2067z00_5532;
BgL_arg2067z00_5532 = 
CAR(
((obj_t)BgL_c1z00_4872)); 
{ /* Llib/mpd.scm 845 */
obj_t BgL_res2816z00_5533;
{ /* Llib/mpd.scm 845 */
obj_t BgL_arg1390z00_5534;
BgL_arg1390z00_5534 = 
SYMBOL_TO_STRING(
((obj_t)BgL_arg2067z00_5532)); 
BgL_res2816z00_5533 = 
BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg1390z00_5534); } 
BgL_arg2065z00_5530 = BgL_res2816z00_5533; } } 
{ /* Llib/mpd.scm 846 */
obj_t BgL_arg2068z00_5535;
BgL_arg2068z00_5535 = 
CAR(
((obj_t)BgL_c2z00_4873)); 
{ /* Llib/mpd.scm 846 */
obj_t BgL_res2817z00_5536;
{ /* Llib/mpd.scm 846 */
obj_t BgL_arg1390z00_5537;
BgL_arg1390z00_5537 = 
SYMBOL_TO_STRING(
((obj_t)BgL_arg2068z00_5535)); 
BgL_res2817z00_5536 = 
BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg1390z00_5537); } 
BgL_arg2066z00_5531 = BgL_res2817z00_5536; } } 
BgL_tmpz00_7418 = 
bigloo_string_lt(BgL_arg2065z00_5530, BgL_arg2066z00_5531); } 
return 
BBOOL(BgL_tmpz00_7418);} } 

}



/* &mpd-addid */
obj_t BGl_z62mpdzd2addidzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4749, obj_t BgL_dbz00_4750, obj_t BgL_backendz00_4751, obj_t BgL_linez00_4752, obj_t BgL_ipz00_4753, obj_t BgL_opz00_4754)
{
{ /* Llib/mpd.scm 853 */
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-crossfade */
obj_t BGl_z62mpdzd2crossfadezb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4755, obj_t BgL_dbz00_4756, obj_t BgL_backendz00_4757, obj_t BgL_linez00_4758, obj_t BgL_ipz00_4759, obj_t BgL_opz00_4760)
{
{ /* Llib/mpd.scm 858 */
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-move */
obj_t BGl_z62mpdzd2movezb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4761, obj_t BgL_dbz00_4762, obj_t BgL_backendz00_4763, obj_t BgL_linez00_4764, obj_t BgL_ipz00_4765, obj_t BgL_opz00_4766)
{
{ /* Llib/mpd.scm 863 */
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-moveid */
obj_t BGl_z62mpdzd2moveidzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4767, obj_t BgL_dbz00_4768, obj_t BgL_backendz00_4769, obj_t BgL_linez00_4770, obj_t BgL_ipz00_4771, obj_t BgL_opz00_4772)
{
{ /* Llib/mpd.scm 868 */
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-password */
obj_t BGl_z62mpdzd2passwordzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4773, obj_t BgL_dbz00_4774, obj_t BgL_backendz00_4775, obj_t BgL_linez00_4776, obj_t BgL_ipz00_4777, obj_t BgL_opz00_4778)
{
{ /* Llib/mpd.scm 873 */
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-random */
obj_t BGl_z62mpdzd2randomzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4779, obj_t BgL_dbz00_4780, obj_t BgL_backendz00_4781, obj_t BgL_linez00_4782, obj_t BgL_ipz00_4783, obj_t BgL_opz00_4784)
{
{ /* Llib/mpd.scm 878 */
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-repeat */
obj_t BGl_z62mpdzd2repeatzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4785, obj_t BgL_dbz00_4786, obj_t BgL_backendz00_4787, obj_t BgL_linez00_4788, obj_t BgL_ipz00_4789, obj_t BgL_opz00_4790)
{
{ /* Llib/mpd.scm 883 */
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-rm */
obj_t BGl_z62mpdzd2rmzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4791, obj_t BgL_dbz00_4792, obj_t BgL_backendz00_4793, obj_t BgL_linez00_4794, obj_t BgL_ipz00_4795, obj_t BgL_opz00_4796)
{
{ /* Llib/mpd.scm 888 */
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-save */
obj_t BGl_z62mpdzd2savezb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4797, obj_t BgL_dbz00_4798, obj_t BgL_backendz00_4799, obj_t BgL_linez00_4800, obj_t BgL_ipz00_4801, obj_t BgL_opz00_4802)
{
{ /* Llib/mpd.scm 893 */
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-shuffle */
obj_t BGl_z62mpdzd2shufflezb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4803, obj_t BgL_dbz00_4804, obj_t BgL_backendz00_4805, obj_t BgL_linez00_4806, obj_t BgL_ipz00_4807, obj_t BgL_opz00_4808)
{
{ /* Llib/mpd.scm 898 */
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-swap */
obj_t BGl_z62mpdzd2swapzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4809, obj_t BgL_dbz00_4810, obj_t BgL_backendz00_4811, obj_t BgL_linez00_4812, obj_t BgL_ipz00_4813, obj_t BgL_opz00_4814)
{
{ /* Llib/mpd.scm 903 */
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-swapid */
obj_t BGl_z62mpdzd2swapidzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4815, obj_t BgL_dbz00_4816, obj_t BgL_backendz00_4817, obj_t BgL_linez00_4818, obj_t BgL_ipz00_4819, obj_t BgL_opz00_4820)
{
{ /* Llib/mpd.scm 908 */
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-update */
obj_t BGl_z62mpdzd2updatezb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4821, obj_t BgL_dbz00_4822, obj_t BgL_backendz00_4823, obj_t BgL_linez00_4824, obj_t BgL_ipz00_4825, obj_t BgL_opz00_4826)
{
{ /* Llib/mpd.scm 913 */
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-outputs */
obj_t BGl_z62mpdzd2outputszb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4827, obj_t BgL_dbz00_4828, obj_t BgL_backendz00_4829, obj_t BgL_linez00_4830, obj_t BgL_ipz00_4831, obj_t BgL_opz00_4832)
{
{ /* Llib/mpd.scm 918 */
return 
CNST_TABLE_REF(((long)53));} 

}



/* loop~5 */
obj_t BGl_loopze75ze7zz__multimediazd2mpdzd2(obj_t BgL_l1z00_1167, obj_t BgL_l2z00_1168)
{
{ /* Llib/mpd.scm 924 */
{ /* Llib/mpd.scm 927 */
bool_t BgL_test3869z00_7445;
if(
NULLP(BgL_l1z00_1167))
{ /* Llib/mpd.scm 927 */
BgL_test3869z00_7445 = ((bool_t)1)
; }  else 
{ /* Llib/mpd.scm 927 */
BgL_test3869z00_7445 = 
NULLP(BgL_l2z00_1168)
; } 
if(BgL_test3869z00_7445)
{ /* Llib/mpd.scm 927 */
return BNIL;}  else 
{ /* Llib/mpd.scm 929 */
bool_t BgL_test3871z00_7449;
{ /* Llib/mpd.scm 929 */
obj_t BgL_string1z00_3148;obj_t BgL_string2z00_3149;
BgL_string1z00_3148 = 
CAR(
((obj_t)BgL_l1z00_1167)); 
BgL_string2z00_3149 = 
CAR(
((obj_t)BgL_l2z00_1168)); 
BgL_test3871z00_7449 = 
bigloo_strcmp(BgL_string1z00_3148, BgL_string2z00_3149); } 
if(BgL_test3871z00_7449)
{ /* Llib/mpd.scm 930 */
obj_t BgL_arg2075z00_1175;obj_t BgL_arg2076z00_1176;
BgL_arg2075z00_1175 = 
CAR(
((obj_t)BgL_l1z00_1167)); 
{ /* Llib/mpd.scm 930 */
obj_t BgL_arg2077z00_1177;obj_t BgL_arg2078z00_1178;
BgL_arg2077z00_1177 = 
CDR(
((obj_t)BgL_l1z00_1167)); 
BgL_arg2078z00_1178 = 
CDR(
((obj_t)BgL_l2z00_1168)); 
BgL_arg2076z00_1176 = 
BGl_loopze75ze7zz__multimediazd2mpdzd2(BgL_arg2077z00_1177, BgL_arg2078z00_1178); } 
return 
MAKE_YOUNG_PAIR(BgL_arg2075z00_1175, BgL_arg2076z00_1176);}  else 
{ /* Llib/mpd.scm 929 */
return BNIL;} } } } 

}



/* file-system-root? */
bool_t BGl_filezd2systemzd2rootzf3zf3zz__multimediazd2mpdzd2(obj_t BgL_dirz00_330)
{
{ /* Llib/mpd.scm 949 */
if(
(
STRING_LENGTH(BgL_dirz00_330)==((long)1)))
{ /* Llib/mpd.scm 950 */
return 
(
STRING_REF(BgL_dirz00_330, ((long)0))==
(unsigned char)(FILE_SEPARATOR));}  else 
{ /* Llib/mpd.scm 950 */
return ((bool_t)0);} } 

}



/* directory->sort-list */
obj_t BGl_directoryzd2ze3sortzd2listze3zz__multimediazd2mpdzd2(obj_t BgL_dirz00_332)
{
{ /* Llib/mpd.scm 988 */
return 
BGl_sortz00zz__r4_vectors_6_8z00(BGl_proc3351z00zz__multimediazd2mpdzd2, 
bgl_directory_to_list(
BSTRING_TO_STRING(BgL_dirz00_332)));} 

}



/* &<@anonymous:2091> */
obj_t BGl_z62zc3z04anonymousza32091ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4875, obj_t BgL_s1z00_4876, obj_t BgL_s2z00_4877)
{
{ /* Llib/mpd.scm 989 */
{ /* Llib/mpd.scm 990 */
bool_t BgL_tmpz00_7472;
{ /* Llib/mpd.scm 990 */
int BgL_arg2092z00_5538;
{ /* Llib/mpd.scm 990 */

BgL_arg2092z00_5538 = 
BGl_stringzd2naturalzd2compare3z00zz__r4_strings_6_7z00(BgL_s1z00_4876, BgL_s2z00_4877, 
BINT(((long)0)), 
BINT(((long)0))); } 
BgL_tmpz00_7472 = 
(
(long)(BgL_arg2092z00_5538)<((long)0)); } 
return 
BBOOL(BgL_tmpz00_7472);} } 

}



/* mpd->file */
obj_t BGl_mpdzd2ze3filez31zz__multimediazd2mpdzd2(obj_t BgL_filez00_333, obj_t BgL_dbz00_334, obj_t BgL_opz00_335, obj_t BgL_cmdz00_336)
{
{ /* Llib/mpd.scm 996 */
{ /* Llib/mpd.scm 998 */
obj_t BgL_fz00_1220;
{ /* Llib/mpd.scm 998 */
obj_t BgL_g1208z00_1224;
BgL_g1208z00_1224 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_334)))->BgL_directoriesz00); 
{ 
obj_t BgL_l1206z00_1226;
BgL_l1206z00_1226 = BgL_g1208z00_1224; 
BgL_zc3z04anonymousza32094ze3z87_1227:
if(
NULLP(BgL_l1206z00_1226))
{ /* Llib/mpd.scm 998 */
BgL_fz00_1220 = BFALSE; }  else 
{ /* Llib/mpd.scm 999 */
obj_t BgL__ortest_1209z00_1229;
{ /* Llib/mpd.scm 999 */
obj_t BgL_dirz00_1231;
BgL_dirz00_1231 = 
CAR(
((obj_t)BgL_l1206z00_1226)); 
{ /* Llib/mpd.scm 999 */
obj_t BgL_pz00_1232;
BgL_pz00_1232 = 
BGl_makezd2filezd2namez00zz__osz00(BgL_dirz00_1231, BgL_filez00_333); 
if(
fexists(
BSTRING_TO_STRING(BgL_pz00_1232)))
{ /* Llib/mpd.scm 1000 */
BgL__ortest_1209z00_1229 = BgL_pz00_1232; }  else 
{ /* Llib/mpd.scm 1000 */
BgL__ortest_1209z00_1229 = BFALSE; } } } 
if(
CBOOL(BgL__ortest_1209z00_1229))
{ /* Llib/mpd.scm 998 */
BgL_fz00_1220 = BgL__ortest_1209z00_1229; }  else 
{ /* Llib/mpd.scm 998 */
obj_t BgL_arg2096z00_1230;
BgL_arg2096z00_1230 = 
CDR(
((obj_t)BgL_l1206z00_1226)); 
{ 
obj_t BgL_l1206z00_7493;
BgL_l1206z00_7493 = BgL_arg2096z00_1230; 
BgL_l1206z00_1226 = BgL_l1206z00_7493; 
goto BgL_zc3z04anonymousza32094ze3z87_1227;} } } } } 
if(
STRINGP(BgL_fz00_1220))
{ /* Llib/mpd.scm 1003 */
return BgL_fz00_1220;}  else 
{ /* Llib/mpd.scm 1003 */
{ /* Llib/mpd.scm 325 */
obj_t BgL_tmpz00_7496;
BgL_tmpz00_7496 = 
((obj_t)BgL_opz00_335); 
bgl_display_string(BGl_string3301z00zz__multimediazd2mpdzd2, BgL_tmpz00_7496); } 
bgl_display_obj(BGl_string3336z00zz__multimediazd2mpdzd2, BgL_opz00_335); 
{ /* Llib/mpd.scm 327 */
obj_t BgL_tmpz00_7500;
BgL_tmpz00_7500 = 
((obj_t)BgL_opz00_335); 
bgl_display_string(BGl_string3303z00zz__multimediazd2mpdzd2, BgL_tmpz00_7500); } 
bgl_display_obj(BgL_cmdz00_336, BgL_opz00_335); 
{ /* Llib/mpd.scm 329 */
obj_t BgL_tmpz00_7504;
BgL_tmpz00_7504 = 
((obj_t)BgL_opz00_335); 
bgl_display_string(BGl_string3304z00zz__multimediazd2mpdzd2, BgL_tmpz00_7504); } 
bgl_display_obj(BGl_string3352z00zz__multimediazd2mpdzd2, BgL_opz00_335); 
{ /* Llib/mpd.scm 331 */
obj_t BgL_tmpz00_7508;
BgL_tmpz00_7508 = 
((obj_t)BgL_opz00_335); 
bgl_display_string(BGl_string3305z00zz__multimediazd2mpdzd2, BgL_tmpz00_7508); } 
{ /* Llib/mpd.scm 332 */
obj_t BgL_tmpz00_7511;
BgL_tmpz00_7511 = 
((obj_t)BgL_opz00_335); 
bgl_flush_output_port(BgL_tmpz00_7511); } 
return 
CNST_TABLE_REF(((long)54));} } } 

}



/* file->mpd */
obj_t BGl_filezd2ze3mpdz31zz__multimediazd2mpdzd2(obj_t BgL_filez00_337, obj_t BgL_dbz00_338)
{
{ /* Llib/mpd.scm 1010 */
{ /* Llib/mpd.scm 1012 */
long BgL_blenz00_1236;
BgL_blenz00_1236 = 
STRING_LENGTH(
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_338)))->BgL_z52basez52)); 
if(
(
STRING_LENGTH(
((obj_t)BgL_filez00_337))>BgL_blenz00_1236))
{ /* Llib/mpd.scm 1014 */
long BgL_arg2100z00_1239;
BgL_arg2100z00_1239 = 
(BgL_blenz00_1236+((long)1)); 
{ /* Llib/mpd.scm 1014 */
long BgL_endz00_1242;
BgL_endz00_1242 = 
STRING_LENGTH(
((obj_t)BgL_filez00_337)); 
{ /* Llib/mpd.scm 1014 */

return 
BGl_substringz00zz__r4_strings_6_7z00(BgL_filez00_337, BgL_arg2100z00_1239, BgL_endz00_1242);} } }  else 
{ /* Llib/mpd.scm 1013 */
return BGl_string3289z00zz__multimediazd2mpdzd2;} } } 

}



/* image-file? */
bool_t BGl_imagezd2filezf3z21zz__multimediazd2mpdzd2(obj_t BgL_fz00_341)
{
{ /* Llib/mpd.scm 1028 */
{ 
obj_t BgL_l1210z00_1248;
BgL_l1210z00_1248 = 
CNST_TABLE_REF(((long)66)); 
BgL_zc3z04anonymousza32104ze3z87_1249:
if(
NULLP(BgL_l1210z00_1248))
{ /* Llib/mpd.scm 1029 */
return ((bool_t)0);}  else 
{ /* Llib/mpd.scm 1029 */
bool_t BgL__ortest_1213z00_1251;
{ /* Llib/mpd.scm 1029 */

BgL__ortest_1213z00_1251 = 
BGl_stringzd2suffixzf3z21zz__r4_strings_6_7z00(
CAR(
((obj_t)BgL_l1210z00_1248)), BgL_fz00_341, BFALSE, BFALSE, BFALSE, BFALSE); } 
if(BgL__ortest_1213z00_1251)
{ /* Llib/mpd.scm 1029 */
return BgL__ortest_1213z00_1251;}  else 
{ 
obj_t BgL_l1210z00_7532;
BgL_l1210z00_7532 = 
CDR(
((obj_t)BgL_l1210z00_1248)); 
BgL_l1210z00_1248 = BgL_l1210z00_7532; 
goto BgL_zc3z04anonymousza32104ze3z87_1249;} } } } 

}



/* directory-image */
obj_t BGl_directoryzd2imagezd2zz__multimediazd2mpdzd2(obj_t BgL_dirz00_342)
{
{ /* Llib/mpd.scm 1034 */
{ /* Llib/mpd.scm 1035 */
obj_t BgL_fz00_1261;
{ /* Llib/mpd.scm 1035 */
obj_t BgL_g1216z00_1263;
BgL_g1216z00_1263 = 
bgl_directory_to_list(
BSTRING_TO_STRING(BgL_dirz00_342)); 
{ 
obj_t BgL_list1215z00_1265;
BgL_list1215z00_1265 = BgL_g1216z00_1263; 
BgL_zc3z04anonymousza32108ze3z87_1266:
if(
PAIRP(BgL_list1215z00_1265))
{ /* Llib/mpd.scm 1035 */
if(
BGl_imagezd2filezf3z21zz__multimediazd2mpdzd2(
CAR(BgL_list1215z00_1265)))
{ /* Llib/mpd.scm 1035 */
BgL_fz00_1261 = 
CAR(BgL_list1215z00_1265); }  else 
{ 
obj_t BgL_list1215z00_7544;
BgL_list1215z00_7544 = 
CDR(BgL_list1215z00_1265); 
BgL_list1215z00_1265 = BgL_list1215z00_7544; 
goto BgL_zc3z04anonymousza32108ze3z87_1266;} }  else 
{ /* Llib/mpd.scm 1035 */
BgL_fz00_1261 = BFALSE; } } } 
if(
STRINGP(BgL_fz00_1261))
{ /* Llib/mpd.scm 1036 */
return 
BGl_makezd2filezd2namez00zz__osz00(BgL_dirz00_342, BgL_fz00_1261);}  else 
{ /* Llib/mpd.scm 1036 */
return BFALSE;} } } 

}



/* music-file? */
bool_t BGl_musiczd2filezf3z21zz__multimediazd2mpdzd2(obj_t BgL_fz00_343, obj_t BgL_dbz00_344)
{
{ /* Llib/mpd.scm 1042 */
{ 
obj_t BgL_l1217z00_1276;
BgL_l1217z00_1276 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_344)))->BgL_suffixesz00); 
BgL_zc3z04anonymousza32114ze3z87_1277:
if(
NULLP(BgL_l1217z00_1276))
{ /* Llib/mpd.scm 1044 */
return ((bool_t)0);}  else 
{ /* Llib/mpd.scm 1044 */
bool_t BgL__ortest_1220z00_1279;
{ /* Llib/mpd.scm 1044 */

BgL__ortest_1220z00_1279 = 
BGl_stringzd2suffixzf3z21zz__r4_strings_6_7z00(
CAR(
((obj_t)BgL_l1217z00_1276)), BgL_fz00_343, BFALSE, BFALSE, BFALSE, BFALSE); } 
if(BgL__ortest_1220z00_1279)
{ /* Llib/mpd.scm 1044 */
return BgL__ortest_1220z00_1279;}  else 
{ 
obj_t BgL_l1217z00_7555;
BgL_l1217z00_7555 = 
CDR(
((obj_t)BgL_l1217z00_1276)); 
BgL_l1217z00_1276 = BgL_l1217z00_7555; 
goto BgL_zc3z04anonymousza32114ze3z87_1277;} } } } 

}



/* mpd-database-directories-scan */
obj_t BGl_mpdzd2databasezd2directorieszd2scanzd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_dbz00_347, obj_t BgL_directoriesz00_348)
{
{ /* Llib/mpd.scm 1055 */
{ /* Llib/mpd.scm 1055 */
obj_t BgL_nsongsz00_5233;
{ /* Llib/mpd.scm 1055 */
obj_t BgL_cellvalz00_7560;
BgL_cellvalz00_7560 = 
BINT(((long)0)); 
BgL_nsongsz00_5233 = 
MAKE_CELL(BgL_cellvalz00_7560); } 
{ /* Llib/mpd.scm 1057 */
obj_t BgL_artistsz00_1295;
BgL_artistsz00_1295 = 
BGl_makezd2hashtablezd2zz__hashz00(BNIL); 
{ /* Llib/mpd.scm 1058 */
obj_t BgL_albumsz00_1296;
BgL_albumsz00_1296 = 
BGl_makezd2hashtablezd2zz__hashz00(BNIL); 
{ /* Llib/mpd.scm 1059 */
obj_t BgL_genresz00_1297;
BgL_genresz00_1297 = 
BGl_makezd2hashtablezd2zz__hashz00(BNIL); 
{ 
obj_t BgL_l1224z00_1300;
BgL_l1224z00_1300 = BgL_directoriesz00_348; 
BgL_zc3z04anonymousza32120ze3z87_1301:
if(
PAIRP(BgL_l1224z00_1300))
{ /* Llib/mpd.scm 1082 */
{ /* Llib/mpd.scm 1082 */
obj_t BgL_dz00_1303;
BgL_dz00_1303 = 
CAR(BgL_l1224z00_1300); 
BGl_directoryzd2scanze70z35zz__multimediazd2mpdzd2(BgL_dbz00_347, BgL_genresz00_1297, BgL_albumsz00_1296, BgL_artistsz00_1295, BgL_nsongsz00_5233, BgL_dz00_1303, BgL_dz00_1303); } 
{ 
obj_t BgL_l1224z00_7569;
BgL_l1224z00_7569 = 
CDR(BgL_l1224z00_1300); 
BgL_l1224z00_1300 = BgL_l1224z00_7569; 
goto BgL_zc3z04anonymousza32120ze3z87_1301;} }  else 
{ /* Llib/mpd.scm 1082 */((bool_t)1); } } 
{ /* Llib/mpd.scm 1084 */
obj_t BgL_val0_1226z00_1306;obj_t BgL_val1_1227z00_1307;obj_t BgL_val2_1228z00_1308;long BgL_val3_1229z00_1309;
BgL_val0_1226z00_1306 = 
BGl_sortz00zz__r4_vectors_6_8z00(BGl_proc3353z00zz__multimediazd2mpdzd2, 
BGl_hashtablezd2mapzd2zz__hashz00(BgL_artistsz00_1295, BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00)); 
BgL_val1_1227z00_1307 = 
BGl_sortz00zz__r4_vectors_6_8z00(BGl_proc3354z00zz__multimediazd2mpdzd2, 
BGl_hashtablezd2mapzd2zz__hashz00(BgL_albumsz00_1296, BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00)); 
BgL_val2_1228z00_1308 = 
BGl_sortz00zz__r4_vectors_6_8z00(BGl_proc3355z00zz__multimediazd2mpdzd2, 
BGl_hashtablezd2mapzd2zz__hashz00(BgL_genresz00_1297, BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00)); 
BgL_val3_1229z00_1309 = 
(long)CINT(
CELL_REF(BgL_nsongsz00_5233)); 
{ /* Llib/mpd.scm 1084 */
int BgL_res2847z00_3241;
{ /* Llib/mpd.scm 1084 */
int BgL_tmpz00_7578;
BgL_tmpz00_7578 = 
(int)(((long)4)); 
BgL_res2847z00_3241 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_7578); } BgL_res2847z00_3241; } 
{ /* Llib/mpd.scm 1084 */
int BgL_tmpz00_7581;
BgL_tmpz00_7581 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_7581, BgL_val1_1227z00_1307); } 
{ /* Llib/mpd.scm 1084 */
int BgL_tmpz00_7584;
BgL_tmpz00_7584 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_7584, BgL_val2_1228z00_1308); } 
{ /* Llib/mpd.scm 1084 */
obj_t BgL_auxz00_7589;int BgL_tmpz00_7587;
BgL_auxz00_7589 = 
BINT(BgL_val3_1229z00_1309); 
BgL_tmpz00_7587 = 
(int)(((long)3)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_7587, BgL_auxz00_7589); } 
return BgL_val0_1226z00_1306;} } } } } } 

}



/* directory-scan~0 */
bool_t BGl_directoryzd2scanze70z35zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_dbz00_5231, obj_t BgL_genresz00_5230, obj_t BgL_albumsz00_5229, obj_t BgL_artistsz00_5228, obj_t BgL_nsongsz00_5227, obj_t BgL_dirz00_1334, obj_t BgL_repoz00_1335)
{
{ /* Llib/mpd.scm 1080 */
{ /* Llib/mpd.scm 1063 */
obj_t BgL_albumz00_1337;
BgL_albumz00_1337 = 
BGl_basenamez00zz__osz00(BgL_dirz00_1334); 
{ /* Llib/mpd.scm 1063 */
obj_t BgL_dir2z00_1338;
BgL_dir2z00_1338 = 
BGl_dirnamez00zz__osz00(BgL_dirz00_1334); 
{ /* Llib/mpd.scm 1064 */
obj_t BgL_artistz00_1339;
BgL_artistz00_1339 = 
BGl_basenamez00zz__osz00(BgL_dir2z00_1338); 
{ /* Llib/mpd.scm 1065 */
obj_t BgL_dir3z00_1340;
BgL_dir3z00_1340 = 
BGl_dirnamez00zz__osz00(BgL_dir2z00_1338); 
{ /* Llib/mpd.scm 1066 */
obj_t BgL_genrez00_1341;
BgL_genrez00_1341 = 
BGl_basenamez00zz__osz00(BgL_dir3z00_1340); 
{ /* Llib/mpd.scm 1067 */
bool_t BgL_addz00_1342;
BgL_addz00_1342 = ((bool_t)0); 
{ /* Llib/mpd.scm 1068 */

{ /* Llib/mpd.scm 1069 */
obj_t BgL_g1223z00_1343;
BgL_g1223z00_1343 = 
BGl_directoryzd2ze3pathzd2listze3zz__r4_ports_6_10_1z00(BgL_dirz00_1334); 
{ 
obj_t BgL_l1221z00_1345;
BgL_l1221z00_1345 = BgL_g1223z00_1343; 
BgL_zc3z04anonymousza32139ze3z87_1346:
if(
PAIRP(BgL_l1221z00_1345))
{ /* Llib/mpd.scm 1080 */
{ /* Llib/mpd.scm 1071 */
obj_t BgL_pz00_1348;
BgL_pz00_1348 = 
CAR(BgL_l1221z00_1345); 
if(
bgl_directoryp(
BSTRING_TO_STRING(BgL_pz00_1348)))
{ /* Llib/mpd.scm 1071 */
BBOOL(
BGl_directoryzd2scanze70z35zz__multimediazd2mpdzd2(BgL_dbz00_5231, BgL_genresz00_5230, BgL_albumsz00_5229, BgL_artistsz00_5228, BgL_nsongsz00_5227, BgL_pz00_1348, BgL_repoz00_1335)); }  else 
{ /* Llib/mpd.scm 1071 */
if(
BGl_musiczd2filezf3z21zz__multimediazd2mpdzd2(BgL_pz00_1348, 
((obj_t)BgL_dbz00_5231)))
{ /* Llib/mpd.scm 1073 */
{ /* Llib/mpd.scm 1074 */
obj_t BgL_auxz00_5232;
BgL_auxz00_5232 = 
ADDFX(
CELL_REF(BgL_nsongsz00_5227), 
BINT(((long)1))); 
CELL_SET(BgL_nsongsz00_5227, BgL_auxz00_5232); } 
if(BgL_addz00_1342)
{ /* Llib/mpd.scm 1075 */BFALSE; }  else 
{ /* Llib/mpd.scm 1075 */
BgL_addz00_1342 = ((bool_t)1); 
BGl_hashtablezd2putz12zc0zz__hashz00(BgL_artistsz00_5228, BgL_artistz00_1339, BgL_dir2z00_1338); 
BGl_hashtablezd2putz12zc0zz__hashz00(BgL_albumsz00_5229, BgL_albumz00_1337, BgL_dirz00_1334); 
BGl_hashtablezd2putz12zc0zz__hashz00(BgL_genresz00_5230, BgL_genrez00_1341, BgL_dir3z00_1340); } }  else 
{ /* Llib/mpd.scm 1073 */BFALSE; } } } 
{ 
obj_t BgL_l1221z00_7615;
BgL_l1221z00_7615 = 
CDR(BgL_l1221z00_1345); 
BgL_l1221z00_1345 = BgL_l1221z00_7615; 
goto BgL_zc3z04anonymousza32139ze3z87_1346;} }  else 
{ /* Llib/mpd.scm 1080 */
return ((bool_t)1);} } } } } } } } } } } 

}



/* &<@anonymous:2135> */
obj_t BGl_z62zc3z04anonymousza32135ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4881, obj_t BgL_e1z00_4882, obj_t BgL_e2z00_4883)
{
{ /* Llib/mpd.scm 1088 */
{ /* Llib/mpd.scm 1088 */
bool_t BgL_tmpz00_7617;
{ /* Llib/mpd.scm 1088 */
obj_t BgL_string1z00_5539;obj_t BgL_string2z00_5540;
BgL_string1z00_5539 = 
CAR(
((obj_t)BgL_e1z00_4882)); 
BgL_string2z00_5540 = 
CAR(
((obj_t)BgL_e2z00_4883)); 
BgL_tmpz00_7617 = 
bigloo_string_lt(BgL_string1z00_5539, BgL_string2z00_5540); } 
return 
BBOOL(BgL_tmpz00_7617);} } 

}



/* &<@anonymous:2130> */
obj_t BGl_z62zc3z04anonymousza32130ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4884, obj_t BgL_e1z00_4885, obj_t BgL_e2z00_4886)
{
{ /* Llib/mpd.scm 1086 */
{ /* Llib/mpd.scm 1086 */
bool_t BgL_tmpz00_7624;
{ /* Llib/mpd.scm 1086 */
obj_t BgL_string1z00_5541;obj_t BgL_string2z00_5542;
BgL_string1z00_5541 = 
CAR(
((obj_t)BgL_e1z00_4885)); 
BgL_string2z00_5542 = 
CAR(
((obj_t)BgL_e2z00_4886)); 
BgL_tmpz00_7624 = 
bigloo_string_lt(BgL_string1z00_5541, BgL_string2z00_5542); } 
return 
BBOOL(BgL_tmpz00_7624);} } 

}



/* &<@anonymous:2125> */
obj_t BGl_z62zc3z04anonymousza32125ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4887, obj_t BgL_e1z00_4888, obj_t BgL_e2z00_4889)
{
{ /* Llib/mpd.scm 1084 */
{ /* Llib/mpd.scm 1084 */
bool_t BgL_tmpz00_7631;
{ /* Llib/mpd.scm 1084 */
obj_t BgL_string1z00_5543;obj_t BgL_string2z00_5544;
BgL_string1z00_5543 = 
CAR(
((obj_t)BgL_e1z00_4888)); 
BgL_string2z00_5544 = 
CAR(
((obj_t)BgL_e2z00_4889)); 
BgL_tmpz00_7631 = 
bigloo_string_lt(BgL_string1z00_5543, BgL_string2z00_5544); } 
return 
BBOOL(BgL_tmpz00_7631);} } 

}



/* loop~4 */
bool_t BGl_loopze74ze7zz__multimediazd2mpdzd2(obj_t BgL_opz00_5226, BgL_mpdzd2databasezd2_bglt BgL_dbz00_5225, obj_t BgL_albumz00_5224, obj_t BgL_artistz00_5223, obj_t BgL_dirz00_1358)
{
{ /* Llib/mpd.scm 1270 */
{ /* Llib/mpd.scm 1271 */
obj_t BgL_artistz00_1360;
if(
CBOOL(BgL_artistz00_5223))
{ /* Llib/mpd.scm 1271 */
BgL_artistz00_1360 = BgL_artistz00_5223; }  else 
{ /* Llib/mpd.scm 1271 */
BgL_artistz00_1360 = 
BGl_basenamez00zz__osz00(
BGl_dirnamez00zz__osz00(BgL_dirz00_1358)); } 
{ /* Llib/mpd.scm 1271 */
obj_t BgL_albumz00_1361;
if(
CBOOL(BgL_albumz00_5224))
{ /* Llib/mpd.scm 1272 */
BgL_albumz00_1361 = BgL_albumz00_5224; }  else 
{ /* Llib/mpd.scm 1272 */
BgL_albumz00_1361 = 
BGl_basenamez00zz__osz00(BgL_dirz00_1358); } 
{ /* Llib/mpd.scm 1272 */
obj_t BgL_filesz00_1362;
BgL_filesz00_1362 = 
BGl_sortz00zz__r4_vectors_6_8z00(BGl_proc3356z00zz__multimediazd2mpdzd2, 
bgl_directory_to_list(
BSTRING_TO_STRING(BgL_dirz00_1358))); 
{ /* Llib/mpd.scm 1273 */
obj_t BgL_imgz00_1363;
{ /* Llib/mpd.scm 1276 */
obj_t BgL_fz00_1377;
{ 
obj_t BgL_list1271z00_1380;
BgL_list1271z00_1380 = BgL_filesz00_1362; 
BgL_zc3z04anonymousza32154ze3z87_1381:
if(
PAIRP(BgL_list1271z00_1380))
{ /* Llib/mpd.scm 1276 */
if(
BGl_imagezd2filezf3z21zz__multimediazd2mpdzd2(
CAR(BgL_list1271z00_1380)))
{ /* Llib/mpd.scm 1276 */
BgL_fz00_1377 = 
CAR(BgL_list1271z00_1380); }  else 
{ 
obj_t BgL_list1271z00_7654;
BgL_list1271z00_7654 = 
CDR(BgL_list1271z00_1380); 
BgL_list1271z00_1380 = BgL_list1271z00_7654; 
goto BgL_zc3z04anonymousza32154ze3z87_1381;} }  else 
{ /* Llib/mpd.scm 1276 */
BgL_fz00_1377 = BFALSE; } } 
if(
STRINGP(BgL_fz00_1377))
{ /* Llib/mpd.scm 1277 */
BgL_imgz00_1363 = 
BGl_makezd2filezd2namez00zz__osz00(BgL_dirz00_1358, BgL_fz00_1377); }  else 
{ /* Llib/mpd.scm 1277 */
BgL_imgz00_1363 = BFALSE; } } 
{ /* Llib/mpd.scm 1276 */

{ 
obj_t BgL_l1272z00_1365;
BgL_l1272z00_1365 = BgL_filesz00_1362; 
BgL_zc3z04anonymousza32148ze3z87_1366:
if(
PAIRP(BgL_l1272z00_1365))
{ /* Llib/mpd.scm 1279 */
{ /* Llib/mpd.scm 1280 */
obj_t BgL_fz00_1368;
BgL_fz00_1368 = 
CAR(BgL_l1272z00_1365); 
{ /* Llib/mpd.scm 1280 */
obj_t BgL_pz00_1369;
BgL_pz00_1369 = 
BGl_makezd2filezd2namez00zz__osz00(BgL_dirz00_1358, BgL_fz00_1368); 
if(
bgl_directoryp(
BSTRING_TO_STRING(BgL_pz00_1369)))
{ /* Llib/mpd.scm 1282 */
BGl_loopze74ze7zz__multimediazd2mpdzd2(BgL_opz00_5226, BgL_dbz00_5225, BgL_albumz00_5224, BgL_artistz00_5223, BgL_pz00_1369); }  else 
{ /* Llib/mpd.scm 1282 */
if(
BGl_musiczd2filezf3z21zz__multimediazd2mpdzd2(BgL_pz00_1369, 
((obj_t)BgL_dbz00_5225)))
{ /* Llib/mpd.scm 422 */
obj_t BgL_g1188z00_3259;
BgL_g1188z00_3259 = 
BGl_getinfofilez00zz__multimediazd2mpdzd2(
((obj_t)BgL_dbz00_5225), BgL_pz00_1369, BgL_artistz00_1360, BgL_albumz00_1361, BgL_imgz00_1363); 
{ 
obj_t BgL_l1186z00_3261;
BgL_l1186z00_3261 = BgL_g1188z00_3259; 
BgL_zc3z04anonymousza31933ze3z87_3260:
if(
PAIRP(BgL_l1186z00_3261))
{ /* Llib/mpd.scm 427 */
{ /* Llib/mpd.scm 423 */
obj_t BgL_kz00_3263;
BgL_kz00_3263 = 
CAR(BgL_l1186z00_3261); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1935z00_3264;
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1936z00_3265;
BgL_arg1936z00_3265 = 
CAR(
((obj_t)BgL_kz00_3263)); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_res2854z00_3272;
BgL_res2854z00_3272 = 
KEYWORD_TO_STRING(
((obj_t)BgL_arg1936z00_3265)); 
BgL_arg1935z00_3264 = BgL_res2854z00_3272; } } 
bgl_display_obj(BgL_arg1935z00_3264, BgL_opz00_5226); } 
bgl_display_string(BGl_string3326z00zz__multimediazd2mpdzd2, BgL_opz00_5226); 
{ /* Llib/mpd.scm 425 */
obj_t BgL_arg1937z00_3266;
{ /* Llib/mpd.scm 425 */
obj_t BgL_pairz00_3278;
BgL_pairz00_3278 = 
CDR(
((obj_t)BgL_kz00_3263)); 
BgL_arg1937z00_3266 = 
CAR(BgL_pairz00_3278); } 
bgl_display_obj(BgL_arg1937z00_3266, BgL_opz00_5226); } 
bgl_display_char(((unsigned char)10), BgL_opz00_5226); } 
{ 
obj_t BgL_l1186z00_7686;
BgL_l1186z00_7686 = 
CDR(BgL_l1186z00_3261); 
BgL_l1186z00_3261 = BgL_l1186z00_7686; 
goto BgL_zc3z04anonymousza31933ze3z87_3260;} }  else 
{ /* Llib/mpd.scm 427 */((bool_t)1); } } }  else 
{ /* Llib/mpd.scm 1284 */((bool_t)0); } } } } 
{ 
obj_t BgL_l1272z00_7688;
BgL_l1272z00_7688 = 
CDR(BgL_l1272z00_1365); 
BgL_l1272z00_1365 = BgL_l1272z00_7688; 
goto BgL_zc3z04anonymousza32148ze3z87_1366;} }  else 
{ /* Llib/mpd.scm 1279 */
return ((bool_t)1);} } } } } } } } 

}



/* &<@anonymous:2162> */
obj_t BGl_z62zc3z04anonymousza32162ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4894, obj_t BgL_s1z00_4895, obj_t BgL_s2z00_4896)
{
{ /* Llib/mpd.scm 1273 */
{ /* Llib/mpd.scm 1274 */
bool_t BgL_tmpz00_7690;
{ /* Llib/mpd.scm 1274 */
int BgL_arg2163z00_5545;
{ /* Llib/mpd.scm 1274 */

BgL_arg2163z00_5545 = 
BGl_stringzd2naturalzd2compare3z00zz__r4_strings_6_7z00(BgL_s1z00_4895, BgL_s2z00_4896, 
BINT(((long)0)), 
BINT(((long)0))); } 
BgL_tmpz00_7690 = 
(
(long)(BgL_arg2163z00_5545)<((long)0)); } 
return 
BBOOL(BgL_tmpz00_7690);} } 

}



/* getinfofile */
obj_t BGl_getinfofilez00zz__multimediazd2mpdzd2(obj_t BgL_dbz00_406, obj_t BgL_filez00_407, obj_t BgL_artistz00_408, obj_t BgL_albumz00_409, obj_t BgL_imagez00_410)
{
{ /* Llib/mpd.scm 1444 */
{ 
obj_t BgL_filez00_1492;BgL_musictagz00_bglt BgL_tagz00_1493;obj_t BgL_filez00_1472;obj_t BgL_dtz00_1458;
{ /* Llib/mpd.scm 1477 */
bool_t BgL_test3899z00_7697;
if(
fexists(
BSTRING_TO_STRING(BgL_filez00_407)))
{ /* Llib/mpd.scm 1477 */
BgL_test3899z00_7697 = 
bgl_directoryp(
BSTRING_TO_STRING(BgL_filez00_407))
; }  else 
{ /* Llib/mpd.scm 1477 */
BgL_test3899z00_7697 = ((bool_t)1)
; } 
if(BgL_test3899z00_7697)
{ /* Llib/mpd.scm 1478 */
obj_t BgL_arg2168z00_1425;
{ /* Llib/mpd.scm 1478 */
obj_t BgL_arg2169z00_1426;
{ /* Llib/mpd.scm 1478 */
obj_t BgL_arg2170z00_1427;
if(
bigloo_strcmp_at(BgL_filez00_407, BGl_string3327z00zz__multimediazd2mpdzd2, ((long)0)))
{ /* Llib/mpd.scm 1021 */
BgL_arg2170z00_1427 = BgL_filez00_407; }  else 
{ /* Llib/mpd.scm 1021 */
BgL_arg2170z00_1427 = 
BGl_filezd2ze3mpdz31zz__multimediazd2mpdzd2(BgL_filez00_407, BgL_dbz00_406); } 
BgL_arg2169z00_1426 = 
MAKE_YOUNG_PAIR(BgL_arg2170z00_1427, BNIL); } 
BgL_arg2168z00_1425 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)73)), BgL_arg2169z00_1426); } 
return 
MAKE_YOUNG_PAIR(BgL_arg2168z00_1425, BNIL);}  else 
{ /* Llib/mpd.scm 1479 */
obj_t BgL_tagz00_1428;obj_t BgL_infoz00_1429;obj_t BgL_dtz00_1430;obj_t BgL_imgz00_1431;
BgL_tagz00_1428 = 
BGl_filezd2musictagzd2zz__multimediazd2id3zd2(BgL_filez00_407); 
BgL_infoz00_1429 = 
BGl_filezd2musicinfozd2zz__multimediazd2id3zd2(BgL_filez00_407); 
BgL_dtz00_1430 = 
bgl_seconds_to_date(
bgl_last_modification_time(
BSTRING_TO_STRING(BgL_filez00_407))); 
if(
STRINGP(BgL_imagez00_410))
{ /* Llib/mpd.scm 1482 */
BgL_imgz00_1431 = 
BGl_directoryzd2imagezd2zz__multimediazd2mpdzd2(
BGl_dirnamez00zz__osz00(BgL_filez00_407)); }  else 
{ /* Llib/mpd.scm 1482 */
BgL_imgz00_1431 = BFALSE; } 
{ /* Llib/mpd.scm 1483 */
obj_t BgL_arg2171z00_1432;obj_t BgL_arg2172z00_1433;
{ /* Llib/mpd.scm 1483 */
obj_t BgL_arg2173z00_1434;
{ /* Llib/mpd.scm 1483 */
obj_t BgL_arg2174z00_1435;
if(
bigloo_strcmp_at(BgL_filez00_407, BGl_string3327z00zz__multimediazd2mpdzd2, ((long)0)))
{ /* Llib/mpd.scm 1021 */
BgL_arg2174z00_1435 = BgL_filez00_407; }  else 
{ /* Llib/mpd.scm 1021 */
BgL_arg2174z00_1435 = 
BGl_filezd2ze3mpdz31zz__multimediazd2mpdzd2(BgL_filez00_407, BgL_dbz00_406); } 
BgL_arg2173z00_1434 = 
MAKE_YOUNG_PAIR(BgL_arg2174z00_1435, BNIL); } 
BgL_arg2171z00_1432 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)73)), BgL_arg2173z00_1434); } 
{ /* Llib/mpd.scm 1484 */
obj_t BgL_arg2175z00_1436;obj_t BgL_arg2176z00_1437;
{ /* Llib/mpd.scm 1484 */
obj_t BgL_arg2177z00_1438;
{ /* Llib/mpd.scm 1484 */
obj_t BgL_tmpz00_7725;
BgL_dtz00_1458 = BgL_dtz00_1430; 
{ /* Llib/mpd.scm 1448 */
int BgL_arg2196z00_1460;int BgL_arg2197z00_1461;int BgL_arg2198z00_1462;int BgL_arg2199z00_1463;int BgL_arg2200z00_1464;int BgL_arg2201z00_1465;
{ /* Llib/mpd.scm 1448 */
int BgL_res2855z00_3283;
BgL_res2855z00_3283 = 
BGL_DATE_YEAR(BgL_dtz00_1458); 
BgL_arg2196z00_1460 = BgL_res2855z00_3283; } 
{ /* Llib/mpd.scm 1448 */
int BgL_res2856z00_3285;
BgL_res2856z00_3285 = 
BGL_DATE_MONTH(BgL_dtz00_1458); 
BgL_arg2197z00_1461 = BgL_res2856z00_3285; } 
{ /* Llib/mpd.scm 1448 */
int BgL_res2857z00_3287;
BgL_res2857z00_3287 = 
BGL_DATE_DAY(BgL_dtz00_1458); 
BgL_arg2198z00_1462 = BgL_res2857z00_3287; } 
{ /* Llib/mpd.scm 1449 */
int BgL_res2858z00_3289;
BgL_res2858z00_3289 = 
BGL_DATE_HOUR(BgL_dtz00_1458); 
BgL_arg2199z00_1463 = BgL_res2858z00_3289; } 
{ /* Llib/mpd.scm 1449 */
int BgL_res2859z00_3291;
BgL_res2859z00_3291 = 
BGL_DATE_MINUTE(BgL_dtz00_1458); 
BgL_arg2200z00_1464 = BgL_res2859z00_3291; } 
{ /* Llib/mpd.scm 1449 */
int BgL_res2860z00_3293;
BgL_res2860z00_3293 = 
BGL_DATE_SECOND(BgL_dtz00_1458); 
BgL_arg2201z00_1465 = BgL_res2860z00_3293; } 
{ /* Llib/mpd.scm 1447 */
obj_t BgL_list2202z00_1466;
{ /* Llib/mpd.scm 1447 */
obj_t BgL_arg2203z00_1467;
{ /* Llib/mpd.scm 1447 */
obj_t BgL_arg2204z00_1468;
{ /* Llib/mpd.scm 1447 */
obj_t BgL_arg2205z00_1469;
{ /* Llib/mpd.scm 1447 */
obj_t BgL_arg2206z00_1470;
{ /* Llib/mpd.scm 1447 */
obj_t BgL_arg2207z00_1471;
BgL_arg2207z00_1471 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2201z00_1465), BNIL); 
BgL_arg2206z00_1470 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2200z00_1464), BgL_arg2207z00_1471); } 
BgL_arg2205z00_1469 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2199z00_1463), BgL_arg2206z00_1470); } 
BgL_arg2204z00_1468 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2198z00_1462), BgL_arg2205z00_1469); } 
BgL_arg2203z00_1467 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2197z00_1461), BgL_arg2204z00_1468); } 
BgL_list2202z00_1466 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2196z00_1460), BgL_arg2203z00_1467); } 
BgL_tmpz00_7725 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string3357z00zz__multimediazd2mpdzd2, BgL_list2202z00_1466); } } 
BgL_arg2177z00_1438 = 
MAKE_YOUNG_PAIR(BgL_tmpz00_7725, BNIL); } 
BgL_arg2175z00_1436 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)74)), BgL_arg2177z00_1438); } 
{ /* Llib/mpd.scm 1485 */
obj_t BgL_arg2179z00_1440;obj_t BgL_arg2180z00_1441;
if(
BGl_isazf3zf3zz__objectz00(BgL_infoz00_1429, BGl_musicinfoz00zz__multimediazd2id3zd2))
{ /* Llib/mpd.scm 1487 */
obj_t BgL_arg2182z00_1444;
{ /* Llib/mpd.scm 1487 */
obj_t BgL_arg2183z00_1445;
{ /* Llib/mpd.scm 1487 */
long BgL_arg2184z00_1446;
BgL_arg2184z00_1446 = 
(((BgL_musicinfoz00_bglt)COBJECT(
((BgL_musicinfoz00_bglt)BgL_infoz00_1429)))->BgL_durationz00); 
BgL_arg2183z00_1445 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2184z00_1446), BNIL); } 
BgL_arg2182z00_1444 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)75)), BgL_arg2183z00_1445); } 
BgL_arg2179z00_1440 = 
MAKE_YOUNG_PAIR(BgL_arg2182z00_1444, BNIL); }  else 
{ /* Llib/mpd.scm 1485 */
BgL_arg2179z00_1440 = BNIL; } 
{ /* Llib/mpd.scm 1489 */
obj_t BgL_arg2185z00_1447;obj_t BgL_arg2186z00_1448;
if(
BGl_isazf3zf3zz__objectz00(BgL_tagz00_1428, BGl_musictagz00zz__multimediazd2id3zd2))
{ /* Llib/mpd.scm 1489 */
BgL_filez00_1492 = BgL_filez00_407; 
BgL_tagz00_1493 = 
((BgL_musictagz00_bglt)BgL_tagz00_1428); 
{ /* Llib/mpd.scm 1461 */
obj_t BgL_dirz00_1496;
BgL_dirz00_1496 = 
BGl_dirnamez00zz__osz00(BgL_filez00_1492); 
{ /* Llib/mpd.scm 1461 */
obj_t BgL_atz00_1497;
if(
CBOOL(BgL_artistz00_408))
{ /* Llib/mpd.scm 1462 */
BgL_atz00_1497 = BgL_artistz00_408; }  else 
{ /* Llib/mpd.scm 1462 */
if(
bigloo_strcicmp(
(((BgL_musictagz00_bglt)COBJECT(BgL_tagz00_1493))->BgL_artistz00), BGl_string3358z00zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1463 */
BgL_atz00_1497 = 
BGl_stringzd2capitaliza7ez75zz__r4_strings_6_7z00(
BGl_basenamez00zz__osz00(
BGl_dirnamez00zz__osz00(BgL_dirz00_1496))); }  else 
{ /* Llib/mpd.scm 1463 */
BgL_atz00_1497 = 
(((BgL_musictagz00_bglt)COBJECT(BgL_tagz00_1493))->BgL_artistz00); } } 
{ /* Llib/mpd.scm 1462 */
obj_t BgL_alz00_1498;
if(
CBOOL(BgL_albumz00_409))
{ /* Llib/mpd.scm 1466 */
BgL_alz00_1498 = BgL_albumz00_409; }  else 
{ /* Llib/mpd.scm 1466 */
if(
bigloo_strcicmp(
(((BgL_musictagz00_bglt)COBJECT(BgL_tagz00_1493))->BgL_albumz00), BGl_string3359z00zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1467 */
BgL_alz00_1498 = 
BGl_stringzd2capitaliza7ez75zz__r4_strings_6_7z00(
BGl_basenamez00zz__osz00(BgL_dirz00_1496)); }  else 
{ /* Llib/mpd.scm 1467 */
BgL_alz00_1498 = 
(((BgL_musictagz00_bglt)COBJECT(BgL_tagz00_1493))->BgL_albumz00); } } 
{ /* Llib/mpd.scm 1466 */

{ /* Llib/mpd.scm 1470 */
obj_t BgL_arg2225z00_1499;obj_t BgL_arg2226z00_1500;
{ /* Llib/mpd.scm 1470 */
obj_t BgL_arg2227z00_1501;
BgL_arg2227z00_1501 = 
MAKE_YOUNG_PAIR(BgL_atz00_1497, BNIL); 
BgL_arg2225z00_1499 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)67)), BgL_arg2227z00_1501); } 
{ /* Llib/mpd.scm 1471 */
obj_t BgL_arg2228z00_1502;obj_t BgL_arg2229z00_1503;
{ /* Llib/mpd.scm 1471 */
obj_t BgL_arg2230z00_1504;
BgL_arg2230z00_1504 = 
MAKE_YOUNG_PAIR(
(((BgL_musictagz00_bglt)COBJECT(BgL_tagz00_1493))->BgL_titlez00), BNIL); 
BgL_arg2228z00_1502 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)68)), BgL_arg2230z00_1504); } 
{ /* Llib/mpd.scm 1472 */
obj_t BgL_arg2232z00_1506;obj_t BgL_arg2233z00_1507;
{ /* Llib/mpd.scm 1472 */
obj_t BgL_arg2234z00_1508;
BgL_arg2234z00_1508 = 
MAKE_YOUNG_PAIR(BgL_alz00_1498, BNIL); 
BgL_arg2232z00_1506 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)69)), BgL_arg2234z00_1508); } 
{ /* Llib/mpd.scm 1473 */
obj_t BgL_arg2235z00_1509;obj_t BgL_arg2236z00_1510;
{ /* Llib/mpd.scm 1473 */
obj_t BgL_arg2237z00_1511;
{ /* Llib/mpd.scm 1473 */
int BgL_arg2238z00_1512;
BgL_arg2238z00_1512 = 
(((BgL_musictagz00_bglt)COBJECT(BgL_tagz00_1493))->BgL_trackz00); 
BgL_arg2237z00_1511 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2238z00_1512), BNIL); } 
BgL_arg2235z00_1509 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)70)), BgL_arg2237z00_1511); } 
{ /* Llib/mpd.scm 1474 */
obj_t BgL_arg2239z00_1513;obj_t BgL_arg2240z00_1514;
{ /* Llib/mpd.scm 1474 */
obj_t BgL_arg2241z00_1515;
{ /* Llib/mpd.scm 1474 */
int BgL_arg2242z00_1516;
BgL_arg2242z00_1516 = 
(((BgL_musictagz00_bglt)COBJECT(BgL_tagz00_1493))->BgL_yearz00); 
BgL_arg2241z00_1515 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2242z00_1516), BNIL); } 
BgL_arg2239z00_1513 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)71)), BgL_arg2241z00_1515); } 
{ /* Llib/mpd.scm 1475 */
obj_t BgL_arg2243z00_1517;
{ /* Llib/mpd.scm 1475 */
obj_t BgL_arg2244z00_1518;
BgL_arg2244z00_1518 = 
MAKE_YOUNG_PAIR(
(((BgL_musictagz00_bglt)COBJECT(BgL_tagz00_1493))->BgL_genrez00), BNIL); 
BgL_arg2243z00_1517 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)72)), BgL_arg2244z00_1518); } 
BgL_arg2240z00_1514 = 
MAKE_YOUNG_PAIR(BgL_arg2243z00_1517, BNIL); } 
BgL_arg2236z00_1510 = 
MAKE_YOUNG_PAIR(BgL_arg2239z00_1513, BgL_arg2240z00_1514); } 
BgL_arg2233z00_1507 = 
MAKE_YOUNG_PAIR(BgL_arg2235z00_1509, BgL_arg2236z00_1510); } 
BgL_arg2229z00_1503 = 
MAKE_YOUNG_PAIR(BgL_arg2232z00_1506, BgL_arg2233z00_1507); } 
BgL_arg2226z00_1500 = 
MAKE_YOUNG_PAIR(BgL_arg2228z00_1502, BgL_arg2229z00_1503); } 
BgL_arg2185z00_1447 = 
MAKE_YOUNG_PAIR(BgL_arg2225z00_1499, BgL_arg2226z00_1500); } } } } } }  else 
{ /* Llib/mpd.scm 1489 */
BgL_filez00_1472 = BgL_filez00_407; 
{ /* Llib/mpd.scm 1452 */
obj_t BgL_dirz00_1474;
BgL_dirz00_1474 = 
BGl_dirnamez00zz__osz00(BgL_filez00_1472); 
{ /* Llib/mpd.scm 1453 */
obj_t BgL_arg2209z00_1475;obj_t BgL_arg2210z00_1476;
{ /* Llib/mpd.scm 1453 */
obj_t BgL_arg2211z00_1477;
{ /* Llib/mpd.scm 1453 */
obj_t BgL_arg2212z00_1478;
if(
CBOOL(BgL_artistz00_408))
{ /* Llib/mpd.scm 1453 */
BgL_arg2212z00_1478 = BgL_artistz00_408; }  else 
{ /* Llib/mpd.scm 1453 */
BgL_arg2212z00_1478 = 
BGl_stringzd2capitaliza7ez75zz__r4_strings_6_7z00(
BGl_basenamez00zz__osz00(
BGl_dirnamez00zz__osz00(BgL_dirz00_1474))); } 
BgL_arg2211z00_1477 = 
MAKE_YOUNG_PAIR(BgL_arg2212z00_1478, BNIL); } 
BgL_arg2209z00_1475 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)67)), BgL_arg2211z00_1477); } 
{ /* Llib/mpd.scm 1454 */
obj_t BgL_arg2215z00_1482;obj_t BgL_arg2216z00_1483;
{ /* Llib/mpd.scm 1454 */
obj_t BgL_arg2217z00_1484;
BgL_arg2217z00_1484 = 
MAKE_YOUNG_PAIR(
BGl_prefixz00zz__osz00(
BGl_basenamez00zz__osz00(BgL_filez00_1472)), BNIL); 
BgL_arg2215z00_1482 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)68)), BgL_arg2217z00_1484); } 
{ /* Llib/mpd.scm 1455 */
obj_t BgL_arg2220z00_1487;
{ /* Llib/mpd.scm 1455 */
obj_t BgL_arg2221z00_1488;
{ /* Llib/mpd.scm 1455 */
obj_t BgL_arg2222z00_1489;
if(
CBOOL(BgL_albumz00_409))
{ /* Llib/mpd.scm 1455 */
BgL_arg2222z00_1489 = BgL_albumz00_409; }  else 
{ /* Llib/mpd.scm 1455 */
BgL_arg2222z00_1489 = 
BGl_stringzd2capitaliza7ez75zz__r4_strings_6_7z00(
BGl_basenamez00zz__osz00(BgL_dirz00_1474)); } 
BgL_arg2221z00_1488 = 
MAKE_YOUNG_PAIR(BgL_arg2222z00_1489, BNIL); } 
BgL_arg2220z00_1487 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)69)), BgL_arg2221z00_1488); } 
BgL_arg2216z00_1483 = 
MAKE_YOUNG_PAIR(BgL_arg2220z00_1487, BNIL); } 
BgL_arg2210z00_1476 = 
MAKE_YOUNG_PAIR(BgL_arg2215z00_1482, BgL_arg2216z00_1483); } 
BgL_arg2185z00_1447 = 
MAKE_YOUNG_PAIR(BgL_arg2209z00_1475, BgL_arg2210z00_1476); } } } 
{ /* Llib/mpd.scm 1492 */
obj_t BgL_arg2188z00_1450;
if(
STRINGP(BgL_imgz00_1431))
{ /* Llib/mpd.scm 1493 */
obj_t BgL_arg2190z00_1452;
{ /* Llib/mpd.scm 1493 */
obj_t BgL_arg2191z00_1453;
BgL_arg2191z00_1453 = 
MAKE_YOUNG_PAIR(BgL_imgz00_1431, BNIL); 
BgL_arg2190z00_1452 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)76)), BgL_arg2191z00_1453); } 
BgL_arg2188z00_1450 = 
MAKE_YOUNG_PAIR(BgL_arg2190z00_1452, BNIL); }  else 
{ /* Llib/mpd.scm 1492 */
BgL_arg2188z00_1450 = BNIL; } 
BgL_arg2186z00_1448 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_arg2188z00_1450, BNIL); } 
BgL_arg2180z00_1441 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_arg2185z00_1447, BgL_arg2186z00_1448); } 
BgL_arg2176z00_1437 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_arg2179z00_1440, BgL_arg2180z00_1441); } 
BgL_arg2172z00_1433 = 
MAKE_YOUNG_PAIR(BgL_arg2175z00_1436, BgL_arg2176z00_1437); } 
return 
MAKE_YOUNG_PAIR(BgL_arg2171z00_1432, BgL_arg2172z00_1433);} } } } } 

}



/* loop~3 */
obj_t BGl_loopze73ze7zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_dbz00_5222, obj_t BgL_albumz00_5221, bool_t BgL_artistz00_5220, obj_t BgL_dirz00_1535)
{
{ /* Llib/mpd.scm 1500 */
{ /* Llib/mpd.scm 1501 */
obj_t BgL_artistz00_1537;obj_t BgL_albumz00_1538;
if(BgL_artistz00_5220)
{ /* Llib/mpd.scm 1501 */
BgL_artistz00_1537 = 
BBOOL(BgL_artistz00_5220); }  else 
{ /* Llib/mpd.scm 1501 */
BgL_artistz00_1537 = 
BGl_basenamez00zz__osz00(
BGl_dirnamez00zz__osz00(BgL_dirz00_1535)); } 
if(
CBOOL(BgL_albumz00_5221))
{ /* Llib/mpd.scm 1502 */
BgL_albumz00_1538 = BgL_albumz00_5221; }  else 
{ /* Llib/mpd.scm 1502 */
BgL_albumz00_1538 = 
BGl_basenamez00zz__osz00(BgL_dirz00_1535); } 
{ /* Llib/mpd.scm 1503 */
obj_t BgL_l1313z00_1539;
BgL_l1313z00_1539 = 
BGl_sortz00zz__r4_vectors_6_8z00(BGl_proc3360z00zz__multimediazd2mpdzd2, 
bgl_directory_to_list(
BSTRING_TO_STRING(BgL_dirz00_1535))); 
if(
NULLP(BgL_l1313z00_1539))
{ /* Llib/mpd.scm 1503 */
return BNIL;}  else 
{ /* Llib/mpd.scm 1503 */
obj_t BgL_head1315z00_1541;
{ /* Llib/mpd.scm 1503 */
obj_t BgL_res2871z00_3321;
BgL_res2871z00_3321 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1315z00_1541 = BgL_res2871z00_3321; } 
{ 
obj_t BgL_l1313z00_1543;obj_t BgL_tail1316z00_1544;
BgL_l1313z00_1543 = BgL_l1313z00_1539; 
BgL_tail1316z00_1544 = BgL_head1315z00_1541; 
BgL_zc3z04anonymousza32257ze3z87_1545:
if(
NULLP(BgL_l1313z00_1543))
{ /* Llib/mpd.scm 1503 */
return 
CDR(BgL_head1315z00_1541);}  else 
{ /* Llib/mpd.scm 1503 */
obj_t BgL_newtail1317z00_1547;
{ /* Llib/mpd.scm 1503 */
obj_t BgL_arg2260z00_1549;
{ /* Llib/mpd.scm 1503 */
obj_t BgL_fz00_1550;
BgL_fz00_1550 = 
CAR(
((obj_t)BgL_l1313z00_1543)); 
{ /* Llib/mpd.scm 1504 */
obj_t BgL_pz00_1551;
BgL_pz00_1551 = 
BGl_makezd2filezd2namez00zz__osz00(BgL_dirz00_1535, BgL_fz00_1550); 
if(
bgl_directoryp(
BSTRING_TO_STRING(BgL_pz00_1551)))
{ /* Llib/mpd.scm 1506 */
BgL_arg2260z00_1549 = 
BGl_loopze73ze7zz__multimediazd2mpdzd2(BgL_dbz00_5222, BgL_albumz00_5221, BgL_artistz00_5220, BgL_pz00_1551); }  else 
{ /* Llib/mpd.scm 1506 */
if(
BGl_musiczd2filezf3z21zz__multimediazd2mpdzd2(BgL_pz00_1551, 
((obj_t)BgL_dbz00_5222)))
{ /* Llib/mpd.scm 1509 */

BgL_arg2260z00_1549 = 
BGl_getinfofilez00zz__multimediazd2mpdzd2(
((obj_t)BgL_dbz00_5222), BgL_pz00_1551, BgL_artistz00_1537, BgL_albumz00_1538, BFALSE); }  else 
{ /* Llib/mpd.scm 1508 */
BgL_arg2260z00_1549 = BFALSE; } } } } 
{ /* Llib/mpd.scm 1503 */
obj_t BgL_res2874z00_3327;
BgL_res2874z00_3327 = 
MAKE_YOUNG_PAIR(BgL_arg2260z00_1549, BNIL); 
BgL_newtail1317z00_1547 = BgL_res2874z00_3327; } } 
SET_CDR(BgL_tail1316z00_1544, BgL_newtail1317z00_1547); 
{ /* Llib/mpd.scm 1503 */
obj_t BgL_arg2259z00_1548;
BgL_arg2259z00_1548 = 
CDR(
((obj_t)BgL_l1313z00_1543)); 
{ 
obj_t BgL_tail1316z00_7876;obj_t BgL_l1313z00_7875;
BgL_l1313z00_7875 = BgL_arg2259z00_1548; 
BgL_tail1316z00_7876 = BgL_newtail1317z00_1547; 
BgL_tail1316z00_1544 = BgL_tail1316z00_7876; 
BgL_l1313z00_1543 = BgL_l1313z00_7875; 
goto BgL_zc3z04anonymousza32257ze3z87_1545;} } } } } } } } 

}



/* &<@anonymous:2265> */
obj_t BGl_z62zc3z04anonymousza32265ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4898, obj_t BgL_s1z00_4899, obj_t BgL_s2z00_4900)
{
{ /* Llib/mpd.scm 1510 */
{ /* Llib/mpd.scm 1511 */
bool_t BgL_tmpz00_7877;
{ /* Llib/mpd.scm 1511 */
int BgL_arg2266z00_5546;
{ /* Llib/mpd.scm 1511 */

BgL_arg2266z00_5546 = 
BGl_stringzd2naturalzd2compare3z00zz__r4_strings_6_7z00(BgL_s1z00_4899, BgL_s2z00_4900, 
BINT(((long)0)), 
BINT(((long)0))); } 
BgL_tmpz00_7877 = 
(
(long)(BgL_arg2266z00_5546)<((long)0)); } 
return 
BBOOL(BgL_tmpz00_7877);} } 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__multimediazd2mpdzd2()
{
{ /* Llib/mpd.scm 15 */
{ /* Llib/mpd.scm 20 */
obj_t BgL_arg2271z00_1578;obj_t BgL_arg2272z00_1579;
{ /* Llib/mpd.scm 20 */
obj_t BgL_v1318z00_1601;
BgL_v1318z00_1601 = 
create_vector(((long)11)); 
{ /* Llib/mpd.scm 20 */
obj_t BgL_arg2279z00_1602;
BgL_arg2279z00_1602 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)77)), BGl_proc3363z00zz__multimediazd2mpdzd2, BGl_proc3362z00zz__multimediazd2mpdzd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3361z00zz__multimediazd2mpdzd2, 
CNST_TABLE_REF(((long)78))); 
VECTOR_SET(BgL_v1318z00_1601,((long)0),BgL_arg2279z00_1602); } 
{ /* Llib/mpd.scm 20 */
obj_t BgL_arg2286z00_1615;
BgL_arg2286z00_1615 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)79)), BGl_proc3366z00zz__multimediazd2mpdzd2, BGl_proc3365z00zz__multimediazd2mpdzd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3364z00zz__multimediazd2mpdzd2, 
CNST_TABLE_REF(((long)78))); 
VECTOR_SET(BgL_v1318z00_1601,((long)1),BgL_arg2286z00_1615); } 
{ /* Llib/mpd.scm 20 */
obj_t BgL_arg2293z00_1628;
BgL_arg2293z00_1628 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)80)), BGl_proc3369z00zz__multimediazd2mpdzd2, BGl_proc3368z00zz__multimediazd2mpdzd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3367z00zz__multimediazd2mpdzd2, 
CNST_TABLE_REF(((long)81))); 
VECTOR_SET(BgL_v1318z00_1601,((long)2),BgL_arg2293z00_1628); } 
{ /* Llib/mpd.scm 20 */
obj_t BgL_arg2300z00_1641;
BgL_arg2300z00_1641 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)82)), BGl_proc3372z00zz__multimediazd2mpdzd2, BGl_proc3371z00zz__multimediazd2mpdzd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3370z00zz__multimediazd2mpdzd2, 
CNST_TABLE_REF(((long)78))); 
VECTOR_SET(BgL_v1318z00_1601,((long)3),BgL_arg2300z00_1641); } 
{ /* Llib/mpd.scm 20 */
obj_t BgL_arg2307z00_1654;
BgL_arg2307z00_1654 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)83)), BGl_proc3375z00zz__multimediazd2mpdzd2, BGl_proc3374z00zz__multimediazd2mpdzd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3373z00zz__multimediazd2mpdzd2, 
CNST_TABLE_REF(((long)78))); 
VECTOR_SET(BgL_v1318z00_1601,((long)4),BgL_arg2307z00_1654); } 
{ /* Llib/mpd.scm 20 */
obj_t BgL_arg2314z00_1667;
BgL_arg2314z00_1667 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)84)), BGl_proc3378z00zz__multimediazd2mpdzd2, BGl_proc3377z00zz__multimediazd2mpdzd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3376z00zz__multimediazd2mpdzd2, 
CNST_TABLE_REF(((long)78))); 
VECTOR_SET(BgL_v1318z00_1601,((long)5),BgL_arg2314z00_1667); } 
{ /* Llib/mpd.scm 20 */
obj_t BgL_arg2321z00_1680;
BgL_arg2321z00_1680 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)85)), BGl_proc3381z00zz__multimediazd2mpdzd2, BGl_proc3380z00zz__multimediazd2mpdzd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3379z00zz__multimediazd2mpdzd2, 
CNST_TABLE_REF(((long)86))); 
VECTOR_SET(BgL_v1318z00_1601,((long)6),BgL_arg2321z00_1680); } 
{ /* Llib/mpd.scm 20 */
obj_t BgL_arg2328z00_1693;
BgL_arg2328z00_1693 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)87)), BGl_proc3384z00zz__multimediazd2mpdzd2, BGl_proc3383z00zz__multimediazd2mpdzd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3382z00zz__multimediazd2mpdzd2, 
CNST_TABLE_REF(((long)88))); 
VECTOR_SET(BgL_v1318z00_1601,((long)7),BgL_arg2328z00_1693); } 
{ /* Llib/mpd.scm 20 */
obj_t BgL_arg2335z00_1706;
BgL_arg2335z00_1706 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)89)), BGl_proc3387z00zz__multimediazd2mpdzd2, BGl_proc3386z00zz__multimediazd2mpdzd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3385z00zz__multimediazd2mpdzd2, 
CNST_TABLE_REF(((long)88))); 
VECTOR_SET(BgL_v1318z00_1601,((long)8),BgL_arg2335z00_1706); } 
{ /* Llib/mpd.scm 20 */
obj_t BgL_arg2342z00_1719;
BgL_arg2342z00_1719 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)90)), BGl_proc3390z00zz__multimediazd2mpdzd2, BGl_proc3389z00zz__multimediazd2mpdzd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3388z00zz__multimediazd2mpdzd2, 
CNST_TABLE_REF(((long)86))); 
VECTOR_SET(BgL_v1318z00_1601,((long)9),BgL_arg2342z00_1719); } 
{ /* Llib/mpd.scm 20 */
obj_t BgL_arg2349z00_1732;
BgL_arg2349z00_1732 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)91)), BGl_proc3393z00zz__multimediazd2mpdzd2, BGl_proc3392z00zz__multimediazd2mpdzd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3391z00zz__multimediazd2mpdzd2, 
CNST_TABLE_REF(((long)86))); 
VECTOR_SET(BgL_v1318z00_1601,((long)10),BgL_arg2349z00_1732); } 
BgL_arg2271z00_1578 = BgL_v1318z00_1601; } 
{ /* Llib/mpd.scm 20 */
obj_t BgL_v1319z00_1745;
BgL_v1319z00_1745 = 
create_vector(((long)0)); 
BgL_arg2272z00_1579 = BgL_v1319z00_1745; } 
return ( 
BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)92)), 
CNST_TABLE_REF(((long)93)), BGl_objectz00zz__objectz00, ((long)35653), BGl_proc3396z00zz__multimediazd2mpdzd2, BGl_proc3395z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2initz12zd2envzc0zz__multimediazd2mpdzd2, BGl_proc3394z00zz__multimediazd2mpdzd2, BFALSE, BgL_arg2271z00_1578, BgL_arg2272z00_1579), BUNSPEC) ;} } 

}



/* &<@anonymous:2278> */
obj_t BGl_z62zc3z04anonymousza32278ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4937, obj_t BgL_new1066z00_4938)
{
{ /* Llib/mpd.scm 20 */
{ 
BgL_mpdzd2databasezd2_bglt BgL_auxz00_7933;
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_new1066z00_4938)))->BgL_directoriesz00)=((obj_t)BNIL),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_new1066z00_4938)))->BgL_suffixesz00)=((obj_t)BNIL),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_new1066z00_4938)))->BgL_z52basez52)=((obj_t)BGl_string3289z00zz__multimediazd2mpdzd2),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_new1066z00_4938)))->BgL_z52artistsz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_new1066z00_4938)))->BgL_z52albumsz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_new1066z00_4938)))->BgL_z52genresz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_new1066z00_4938)))->BgL_z52nartistsz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_new1066z00_4938)))->BgL_z52nalbumsz52)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_new1066z00_4938)))->BgL_z52nsongsz52)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_new1066z00_4938)))->BgL_z52uptimez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_new1066z00_4938)))->BgL_z52dbzd2updatez80)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_7933 = 
((BgL_mpdzd2databasezd2_bglt)BgL_new1066z00_4938); 
return 
((obj_t)BgL_auxz00_7933);} } 

}



/* &lambda2276 */
BgL_mpdzd2databasezd2_bglt BGl_z62lambda2276z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4939)
{
{ /* Llib/mpd.scm 20 */
{ /* Llib/mpd.scm 20 */
BgL_mpdzd2databasezd2_bglt BgL_new1065z00_5548;
BgL_new1065z00_5548 = 
((BgL_mpdzd2databasezd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_mpdzd2databasezd2_bgl) ))); 
{ /* Llib/mpd.scm 20 */
long BgL_arg2277z00_5549;
{ /* Llib/mpd.scm 20 */
long BgL_res2876z00_5550;
BgL_res2876z00_5550 = 
BGL_CLASS_INDEX(BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2); 
BgL_arg2277z00_5549 = BgL_res2876z00_5550; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1065z00_5548), BgL_arg2277z00_5549); } 
return BgL_new1065z00_5548;} } 

}



/* &lambda2273 */
BgL_mpdzd2databasezd2_bglt BGl_z62lambda2273z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4940, obj_t BgL_directories1054z00_4941, obj_t BgL_suffixes1055z00_4942, obj_t BgL_z52base1056z52_4943, obj_t BgL_z52artists1057z52_4944, obj_t BgL_z52albums1058z52_4945, obj_t BgL_z52genres1059z52_4946, obj_t BgL_z52nartists1060z52_4947, obj_t BgL_z52nalbums1061z52_4948, obj_t BgL_z52nsongs1062z52_4949, obj_t BgL_z52uptime1063z52_4950, obj_t BgL_z52dbzd2update1064z80_4951)
{
{ /* Llib/mpd.scm 20 */
{ /* Llib/mpd.scm 20 */
int BgL_z52nalbums1061z52_5557;int BgL_z52nsongs1062z52_5558;
BgL_z52nalbums1061z52_5557 = 
CINT(BgL_z52nalbums1061z52_4948); 
BgL_z52nsongs1062z52_5558 = 
CINT(BgL_z52nsongs1062z52_4949); 
{ /* Llib/mpd.scm 20 */
BgL_mpdzd2databasezd2_bglt BgL_new1176z00_5559;
{ /* Llib/mpd.scm 20 */
BgL_mpdzd2databasezd2_bglt BgL_new1175z00_5560;
BgL_new1175z00_5560 = 
((BgL_mpdzd2databasezd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_mpdzd2databasezd2_bgl) ))); 
{ /* Llib/mpd.scm 20 */
long BgL_arg2275z00_5561;
{ /* Llib/mpd.scm 20 */
long BgL_res2875z00_5562;
BgL_res2875z00_5562 = 
BGL_CLASS_INDEX(BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2); 
BgL_arg2275z00_5561 = BgL_res2875z00_5562; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1175z00_5560), BgL_arg2275z00_5561); } 
BgL_new1176z00_5559 = BgL_new1175z00_5560; } 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(BgL_new1176z00_5559))->BgL_directoriesz00)=((obj_t)
((obj_t)BgL_directories1054z00_4941)),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(BgL_new1176z00_5559))->BgL_suffixesz00)=((obj_t)
((obj_t)BgL_suffixes1055z00_4942)),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(BgL_new1176z00_5559))->BgL_z52basez52)=((obj_t)
((obj_t)BgL_z52base1056z52_4943)),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(BgL_new1176z00_5559))->BgL_z52artistsz52)=((obj_t)
((obj_t)BgL_z52artists1057z52_4944)),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(BgL_new1176z00_5559))->BgL_z52albumsz52)=((obj_t)
((obj_t)BgL_z52albums1058z52_4945)),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(BgL_new1176z00_5559))->BgL_z52genresz52)=((obj_t)
((obj_t)BgL_z52genres1059z52_4946)),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(BgL_new1176z00_5559))->BgL_z52nartistsz52)=((obj_t)BgL_z52nartists1060z52_4947),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(BgL_new1176z00_5559))->BgL_z52nalbumsz52)=((int)BgL_z52nalbums1061z52_5557),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(BgL_new1176z00_5559))->BgL_z52nsongsz52)=((int)BgL_z52nsongs1062z52_5558),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(BgL_new1176z00_5559))->BgL_z52uptimez52)=((obj_t)BgL_z52uptime1063z52_4950),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(BgL_new1176z00_5559))->BgL_z52dbzd2updatez80)=((obj_t)BgL_z52dbzd2update1064z80_4951),BUNSPEC); 
{ /* Llib/mpd.scm 20 */
obj_t BgL_fun2274z00_5563;
BgL_fun2274z00_5563 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2); 
PROCEDURE_ENTRY(BgL_fun2274z00_5563)(BgL_fun2274z00_5563, 
((obj_t)BgL_new1176z00_5559), BEOA); } 
return BgL_new1176z00_5559;} } } 

}



/* &<@anonymous:2355> */
obj_t BGl_z62zc3z04anonymousza32355ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4952)
{
{ /* Llib/mpd.scm 20 */
return BUNSPEC;} 

}



/* &lambda2354 */
obj_t BGl_z62lambda2354z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4953, obj_t BgL_oz00_4954, obj_t BgL_vz00_4955)
{
{ /* Llib/mpd.scm 20 */
return 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4954)))->BgL_z52dbzd2updatez80)=((obj_t)BgL_vz00_4955),BUNSPEC);} 

}



/* &lambda2353 */
obj_t BGl_z62lambda2353z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4956, obj_t BgL_oz00_4957)
{
{ /* Llib/mpd.scm 20 */
return 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4957)))->BgL_z52dbzd2updatez80);} 

}



/* &<@anonymous:2348> */
obj_t BGl_z62zc3z04anonymousza32348ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4958)
{
{ /* Llib/mpd.scm 20 */
return BUNSPEC;} 

}



/* &lambda2347 */
obj_t BGl_z62lambda2347z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4959, obj_t BgL_oz00_4960, obj_t BgL_vz00_4961)
{
{ /* Llib/mpd.scm 20 */
return 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4960)))->BgL_z52uptimez52)=((obj_t)BgL_vz00_4961),BUNSPEC);} 

}



/* &lambda2346 */
obj_t BGl_z62lambda2346z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4962, obj_t BgL_oz00_4963)
{
{ /* Llib/mpd.scm 20 */
return 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4963)))->BgL_z52uptimez52);} 

}



/* &<@anonymous:2341> */
obj_t BGl_z62zc3z04anonymousza32341ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4964)
{
{ /* Llib/mpd.scm 20 */
return 
BINT(((long)0));} 

}



/* &lambda2340 */
obj_t BGl_z62lambda2340z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4965, obj_t BgL_oz00_4966, obj_t BgL_vz00_4967)
{
{ /* Llib/mpd.scm 20 */
{ /* Llib/mpd.scm 20 */
int BgL_vz00_5569;
BgL_vz00_5569 = 
CINT(BgL_vz00_4967); 
return 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4966)))->BgL_z52nsongsz52)=((int)BgL_vz00_5569),BUNSPEC);} } 

}



/* &lambda2339 */
obj_t BGl_z62lambda2339z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4968, obj_t BgL_oz00_4969)
{
{ /* Llib/mpd.scm 20 */
return 
BINT(
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4969)))->BgL_z52nsongsz52));} 

}



/* &<@anonymous:2334> */
obj_t BGl_z62zc3z04anonymousza32334ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4970)
{
{ /* Llib/mpd.scm 20 */
return 
BINT(((long)0));} 

}



/* &lambda2333 */
obj_t BGl_z62lambda2333z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4971, obj_t BgL_oz00_4972, obj_t BgL_vz00_4973)
{
{ /* Llib/mpd.scm 20 */
{ /* Llib/mpd.scm 20 */
int BgL_vz00_5572;
BgL_vz00_5572 = 
CINT(BgL_vz00_4973); 
return 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4972)))->BgL_z52nalbumsz52)=((int)BgL_vz00_5572),BUNSPEC);} } 

}



/* &lambda2332 */
obj_t BGl_z62lambda2332z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4974, obj_t BgL_oz00_4975)
{
{ /* Llib/mpd.scm 20 */
return 
BINT(
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4975)))->BgL_z52nalbumsz52));} 

}



/* &<@anonymous:2327> */
obj_t BGl_z62zc3z04anonymousza32327ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4976)
{
{ /* Llib/mpd.scm 20 */
return 
BINT(((long)0));} 

}



/* &lambda2326 */
obj_t BGl_z62lambda2326z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4977, obj_t BgL_oz00_4978, obj_t BgL_vz00_4979)
{
{ /* Llib/mpd.scm 20 */
return 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4978)))->BgL_z52nartistsz52)=((obj_t)BgL_vz00_4979),BUNSPEC);} 

}



/* &lambda2325 */
obj_t BGl_z62lambda2325z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4980, obj_t BgL_oz00_4981)
{
{ /* Llib/mpd.scm 20 */
return 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4981)))->BgL_z52nartistsz52);} 

}



/* &<@anonymous:2320> */
obj_t BGl_z62zc3z04anonymousza32320ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4982)
{
{ /* Llib/mpd.scm 20 */
return BNIL;} 

}



/* &lambda2319 */
obj_t BGl_z62lambda2319z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4983, obj_t BgL_oz00_4984, obj_t BgL_vz00_4985)
{
{ /* Llib/mpd.scm 20 */
return 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4984)))->BgL_z52genresz52)=((obj_t)
((obj_t)BgL_vz00_4985)),BUNSPEC);} 

}



/* &lambda2318 */
obj_t BGl_z62lambda2318z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4986, obj_t BgL_oz00_4987)
{
{ /* Llib/mpd.scm 20 */
return 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4987)))->BgL_z52genresz52);} 

}



/* &<@anonymous:2313> */
obj_t BGl_z62zc3z04anonymousza32313ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4988)
{
{ /* Llib/mpd.scm 20 */
return BNIL;} 

}



/* &lambda2312 */
obj_t BGl_z62lambda2312z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4989, obj_t BgL_oz00_4990, obj_t BgL_vz00_4991)
{
{ /* Llib/mpd.scm 20 */
return 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4990)))->BgL_z52albumsz52)=((obj_t)
((obj_t)BgL_vz00_4991)),BUNSPEC);} 

}



/* &lambda2311 */
obj_t BGl_z62lambda2311z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4992, obj_t BgL_oz00_4993)
{
{ /* Llib/mpd.scm 20 */
return 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4993)))->BgL_z52albumsz52);} 

}



/* &<@anonymous:2306> */
obj_t BGl_z62zc3z04anonymousza32306ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4994)
{
{ /* Llib/mpd.scm 20 */
return BNIL;} 

}



/* &lambda2305 */
obj_t BGl_z62lambda2305z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4995, obj_t BgL_oz00_4996, obj_t BgL_vz00_4997)
{
{ /* Llib/mpd.scm 20 */
return 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4996)))->BgL_z52artistsz52)=((obj_t)
((obj_t)BgL_vz00_4997)),BUNSPEC);} 

}



/* &lambda2304 */
obj_t BGl_z62lambda2304z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4998, obj_t BgL_oz00_4999)
{
{ /* Llib/mpd.scm 20 */
return 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4999)))->BgL_z52artistsz52);} 

}



/* &<@anonymous:2299> */
obj_t BGl_z62zc3z04anonymousza32299ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_5000)
{
{ /* Llib/mpd.scm 20 */
return BGl_string3295z00zz__multimediazd2mpdzd2;} 

}



/* &lambda2298 */
obj_t BGl_z62lambda2298z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5001, obj_t BgL_oz00_5002, obj_t BgL_vz00_5003)
{
{ /* Llib/mpd.scm 20 */
return 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5002)))->BgL_z52basez52)=((obj_t)
((obj_t)BgL_vz00_5003)),BUNSPEC);} 

}



/* &lambda2297 */
obj_t BGl_z62lambda2297z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5004, obj_t BgL_oz00_5005)
{
{ /* Llib/mpd.scm 20 */
return 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5005)))->BgL_z52basez52);} 

}



/* &<@anonymous:2292> */
obj_t BGl_z62zc3z04anonymousza32292ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_5006)
{
{ /* Llib/mpd.scm 20 */
return 
CNST_TABLE_REF(((long)94));} 

}



/* &lambda2291 */
obj_t BGl_z62lambda2291z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5007, obj_t BgL_oz00_5008, obj_t BgL_vz00_5009)
{
{ /* Llib/mpd.scm 20 */
return 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5008)))->BgL_suffixesz00)=((obj_t)
((obj_t)BgL_vz00_5009)),BUNSPEC);} 

}



/* &lambda2290 */
obj_t BGl_z62lambda2290z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5010, obj_t BgL_oz00_5011)
{
{ /* Llib/mpd.scm 20 */
return 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5011)))->BgL_suffixesz00);} 

}



/* &<@anonymous:2285> */
obj_t BGl_z62zc3z04anonymousza32285ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_5012)
{
{ /* Llib/mpd.scm 20 */
return BNIL;} 

}



/* &lambda2284 */
obj_t BGl_z62lambda2284z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5013, obj_t BgL_oz00_5014, obj_t BgL_vz00_5015)
{
{ /* Llib/mpd.scm 20 */
return 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5014)))->BgL_directoriesz00)=((obj_t)
((obj_t)BgL_vz00_5015)),BUNSPEC);} 

}



/* &lambda2283 */
obj_t BGl_z62lambda2283z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5016, obj_t BgL_oz00_5017)
{
{ /* Llib/mpd.scm 20 */
return 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5017)))->BgL_directoriesz00);} 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__multimediazd2mpdzd2()
{
{ /* Llib/mpd.scm 15 */
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2initz12zd2envzc0zz__multimediazd2mpdzd2, BGl_proc3397z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3398z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2filezd2ze3pathzd2envze3zz__multimediazd2mpdzd2, BGl_proc3399z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3400z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2statszd2envzd2zz__multimediazd2mpdzd2, BGl_proc3401z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3402z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2listallzd2envzd2zz__multimediazd2mpdzd2, BGl_proc3403z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3404z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2listalbumzd2envzd2zz__multimediazd2mpdzd2, BGl_proc3405z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3406z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2listartistalbumzd2envzd2zz__multimediazd2mpdzd2, BGl_proc3407z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3408z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2listgenrealbumzd2envzd2zz__multimediazd2mpdzd2, BGl_proc3409z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3410z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2listgenreartistzd2envzd2zz__multimediazd2mpdzd2, BGl_proc3411z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3412z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2listgenrezd2envzd2zz__multimediazd2mpdzd2, BGl_proc3413z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3414z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2listartistzd2envzd2zz__multimediazd2mpdzd2, BGl_proc3415z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3416z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2lsinfozd2envzd2zz__multimediazd2mpdzd2, BGl_proc3417z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3418z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2findzd2albumzd2envz00zz__multimediazd2mpdzd2, BGl_proc3419z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3420z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2findzd2artistzd2envz00zz__multimediazd2mpdzd2, BGl_proc3421z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3422z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2searchzd2artistzd2albumzd2envzd2zz__multimediazd2mpdzd2, BGl_proc3423z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3424z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2searchzd2artistzd2titlezd2envzd2zz__multimediazd2mpdzd2, BGl_proc3425z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3426z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2findzd2titlezd2envz00zz__multimediazd2mpdzd2, BGl_proc3427z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3428z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2findzd2genrezd2envz00zz__multimediazd2mpdzd2, BGl_proc3429z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3430z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2getgenrezd2envzd2zz__multimediazd2mpdzd2, BGl_proc3431z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3432z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2getartistzd2envzd2zz__multimediazd2mpdzd2, BGl_proc3433z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3434z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2getgenreartistzd2envzd2zz__multimediazd2mpdzd2, BGl_proc3435z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3436z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2getartistalbumzd2envzd2zz__multimediazd2mpdzd2, BGl_proc3437z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3438z00zz__multimediazd2mpdzd2); 
return 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2getzd2albumzd2envz00zz__multimediazd2mpdzd2, BGl_proc3439z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3440z00zz__multimediazd2mpdzd2);} 

}



/* &mpd-database-get-alb1389 */
obj_t BGl_z62mpdzd2databasezd2getzd2alb1389zb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_5044, obj_t BgL_oz00_5045, obj_t BgL_albumz00_5046)
{
{ /* Llib/mpd.scm 1517 */
{ /* Llib/mpd.scm 1519 */
obj_t BgL_cz00_5598;
BgL_cz00_5598 = 
BGl_assocz00zz__r4_pairs_and_lists_6_3z00(BgL_albumz00_5046, 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5045)))->BgL_z52albumsz52)); 
if(
PAIRP(BgL_cz00_5598))
{ /* Llib/mpd.scm 1521 */
obj_t BgL_dirz00_5600;
BgL_dirz00_5600 = 
CDR(BgL_cz00_5598); 
return 
BGl_loopze73ze7zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5045), BgL_albumz00_5046, ((bool_t)0), BgL_dirz00_5600);}  else 
{ /* Llib/mpd.scm 1520 */
return BFALSE;} } } 

}



/* &mpd-database-getarti1385 */
obj_t BGl_z62mpdzd2databasezd2getarti1385z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5047, obj_t BgL_oz00_5048, obj_t BgL_artistz00_5049)
{
{ /* Llib/mpd.scm 1431 */
if(
STRINGP(BgL_artistz00_5049))
{ /* Llib/mpd.scm 1434 */
obj_t BgL_arg2609z00_5603;
BgL_arg2609z00_5603 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5048)))->BgL_z52albumsz52); 
{ /* Llib/mpd.scm 1435 */
obj_t BgL_zc3z04anonymousza32611ze3z87_5604;
BgL_zc3z04anonymousza32611ze3z87_5604 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32611ze3ze5zz__multimediazd2mpdzd2, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32611ze3z87_5604, 
(int)(((long)0)), BgL_artistz00_5049); 
{ /* Llib/mpd.scm 1434 */
obj_t BgL_list2610z00_5605;
BgL_list2610z00_5605 = 
MAKE_YOUNG_PAIR(BgL_arg2609z00_5603, BNIL); 
return 
BGl_filterzd2mapzd2zz__r4_control_features_6_9z00(BgL_zc3z04anonymousza32611ze3z87_5604, BgL_list2610z00_5605);} } }  else 
{ /* Llib/mpd.scm 1439 */
obj_t BgL_l1307z00_5606;
BgL_l1307z00_5606 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5048)))->BgL_z52albumsz52); 
if(
NULLP(BgL_l1307z00_5606))
{ /* Llib/mpd.scm 1439 */
return BNIL;}  else 
{ /* Llib/mpd.scm 1439 */
obj_t BgL_head1309z00_5607;
{ /* Llib/mpd.scm 1439 */
obj_t BgL_res2955z00_5608;
BgL_res2955z00_5608 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1309z00_5607 = BgL_res2955z00_5608; } 
{ 
obj_t BgL_l1307z00_5610;obj_t BgL_tail1310z00_5611;
BgL_l1307z00_5610 = BgL_l1307z00_5606; 
BgL_tail1310z00_5611 = BgL_head1309z00_5607; 
BgL_zc3z04anonymousza32620ze3z87_5609:
if(
NULLP(BgL_l1307z00_5610))
{ /* Llib/mpd.scm 1439 */
return 
CDR(BgL_head1309z00_5607);}  else 
{ /* Llib/mpd.scm 1439 */
obj_t BgL_newtail1311z00_5612;
{ /* Llib/mpd.scm 1439 */
obj_t BgL_arg2623z00_5613;
{ /* Llib/mpd.scm 1439 */
obj_t BgL_az00_5614;
BgL_az00_5614 = 
CAR(
((obj_t)BgL_l1307z00_5610)); 
{ /* Llib/mpd.scm 1439 */
obj_t BgL_arg2624z00_5615;
{ /* Llib/mpd.scm 1439 */
obj_t BgL_arg2625z00_5616;
BgL_arg2625z00_5616 = 
CAR(
((obj_t)BgL_az00_5614)); 
BgL_arg2624z00_5615 = 
MAKE_YOUNG_PAIR(BgL_arg2625z00_5616, BNIL); } 
BgL_arg2623z00_5613 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)95)), BgL_arg2624z00_5615); } } 
{ /* Llib/mpd.scm 1439 */
obj_t BgL_res2957z00_5617;
BgL_res2957z00_5617 = 
MAKE_YOUNG_PAIR(BgL_arg2623z00_5613, BNIL); 
BgL_newtail1311z00_5612 = BgL_res2957z00_5617; } } 
SET_CDR(BgL_tail1310z00_5611, BgL_newtail1311z00_5612); 
{ /* Llib/mpd.scm 1439 */
obj_t BgL_arg2622z00_5618;
BgL_arg2622z00_5618 = 
CDR(
((obj_t)BgL_l1307z00_5610)); 
{ 
obj_t BgL_tail1310z00_8112;obj_t BgL_l1307z00_8111;
BgL_l1307z00_8111 = BgL_arg2622z00_5618; 
BgL_tail1310z00_8112 = BgL_newtail1311z00_5612; 
BgL_tail1310z00_5611 = BgL_tail1310z00_8112; 
BgL_l1307z00_5610 = BgL_l1307z00_8111; 
goto BgL_zc3z04anonymousza32620ze3z87_5609;} } } } } } } 

}



/* &<@anonymous:2611> */
obj_t BGl_z62zc3z04anonymousza32611ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_5050, obj_t BgL_cz00_5052)
{
{ /* Llib/mpd.scm 1434 */
{ /* Llib/mpd.scm 1435 */
obj_t BgL_artistz00_5051;
BgL_artistz00_5051 = 
PROCEDURE_REF(BgL_envz00_5050, 
(int)(((long)0))); 
{ /* Llib/mpd.scm 1435 */
obj_t BgL_dirz00_5619;
BgL_dirz00_5619 = 
CDR(
((obj_t)BgL_cz00_5052)); 
{ /* Llib/mpd.scm 1436 */
bool_t BgL_test3923z00_8117;
{ /* Llib/mpd.scm 1436 */
obj_t BgL_arg2617z00_5620;
BgL_arg2617z00_5620 = 
BGl_basenamez00zz__osz00(
BGl_dirnamez00zz__osz00(BgL_dirz00_5619)); 
BgL_test3923z00_8117 = 
bigloo_strcmp(BgL_arg2617z00_5620, 
((obj_t)BgL_artistz00_5051)); } 
if(BgL_test3923z00_8117)
{ /* Llib/mpd.scm 1437 */
obj_t BgL_arg2615z00_5621;
{ /* Llib/mpd.scm 1437 */
obj_t BgL_arg2616z00_5622;
BgL_arg2616z00_5622 = 
CAR(
((obj_t)BgL_cz00_5052)); 
BgL_arg2615z00_5621 = 
MAKE_YOUNG_PAIR(BgL_arg2616z00_5622, BNIL); } 
return 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)95)), BgL_arg2615z00_5621);}  else 
{ /* Llib/mpd.scm 1436 */
return BFALSE;} } } } } 

}



/* &mpd-database-getgenr1383 */
obj_t BGl_z62mpdzd2databasezd2getgenr1383z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5053, obj_t BgL_oz00_5054, obj_t BgL_genrez00_5055)
{
{ /* Llib/mpd.scm 1421 */
{ /* Llib/mpd.scm 1423 */
obj_t BgL_hook1305z00_5624;
BgL_hook1305z00_5624 = 
MAKE_YOUNG_PAIR(BFALSE, BNIL); 
{ /* Llib/mpd.scm 1423 */
obj_t BgL_g1306z00_5625;
BgL_g1306z00_5625 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5054)))->BgL_z52artistsz52); 
{ 
obj_t BgL_l1302z00_5627;obj_t BgL_h1303z00_5628;
BgL_l1302z00_5627 = BgL_g1306z00_5625; 
BgL_h1303z00_5628 = BgL_hook1305z00_5624; 
BgL_zc3z04anonymousza32596ze3z87_5626:
if(
NULLP(BgL_l1302z00_5627))
{ /* Llib/mpd.scm 1423 */
return 
CDR(BgL_hook1305z00_5624);}  else 
{ /* Llib/mpd.scm 1423 */
bool_t BgL_test3925z00_8133;
{ /* Llib/mpd.scm 1424 */
obj_t BgL_cz00_5629;
BgL_cz00_5629 = 
CAR(
((obj_t)BgL_l1302z00_5627)); 
{ /* Llib/mpd.scm 1424 */
obj_t BgL_dirz00_5630;
BgL_dirz00_5630 = 
CDR(
((obj_t)BgL_cz00_5629)); 
{ /* Llib/mpd.scm 1425 */
obj_t BgL_arg2604z00_5631;
BgL_arg2604z00_5631 = 
BGl_basenamez00zz__osz00(
BGl_dirnamez00zz__osz00(BgL_dirz00_5630)); 
BgL_test3925z00_8133 = 
bigloo_strcmp(BgL_arg2604z00_5631, 
((obj_t)BgL_genrez00_5055)); } } } 
if(BgL_test3925z00_8133)
{ /* Llib/mpd.scm 1423 */
obj_t BgL_nh1304z00_5632;
{ /* Llib/mpd.scm 1423 */
obj_t BgL_arg2602z00_5633;
BgL_arg2602z00_5633 = 
CAR(
((obj_t)BgL_l1302z00_5627)); 
{ /* Llib/mpd.scm 1423 */
obj_t BgL_res2951z00_5634;
BgL_res2951z00_5634 = 
MAKE_YOUNG_PAIR(BgL_arg2602z00_5633, BNIL); 
BgL_nh1304z00_5632 = BgL_res2951z00_5634; } } 
SET_CDR(BgL_h1303z00_5628, BgL_nh1304z00_5632); 
{ /* Llib/mpd.scm 1423 */
obj_t BgL_arg2601z00_5635;
BgL_arg2601z00_5635 = 
CDR(
((obj_t)BgL_l1302z00_5627)); 
{ 
obj_t BgL_h1303z00_8149;obj_t BgL_l1302z00_8148;
BgL_l1302z00_8148 = BgL_arg2601z00_5635; 
BgL_h1303z00_8149 = BgL_nh1304z00_5632; 
BgL_h1303z00_5628 = BgL_h1303z00_8149; 
BgL_l1302z00_5627 = BgL_l1302z00_8148; 
goto BgL_zc3z04anonymousza32596ze3z87_5626;} } }  else 
{ /* Llib/mpd.scm 1423 */
obj_t BgL_arg2603z00_5636;
BgL_arg2603z00_5636 = 
CDR(
((obj_t)BgL_l1302z00_5627)); 
{ 
obj_t BgL_l1302z00_8152;
BgL_l1302z00_8152 = BgL_arg2603z00_5636; 
BgL_l1302z00_5627 = BgL_l1302z00_8152; 
goto BgL_zc3z04anonymousza32596ze3z87_5626;} } } } } } } 

}



/* &mpd-database-getarti1381 */
obj_t BGl_z62mpdzd2databasezd2getarti1381z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5056, obj_t BgL_oz00_5057)
{
{ /* Llib/mpd.scm 1414 */
return 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5057)))->BgL_z52artistsz52);} 

}



/* &mpd-database-getgenr1379 */
obj_t BGl_z62mpdzd2databasezd2getgenr1379z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5058, obj_t BgL_oz00_5059)
{
{ /* Llib/mpd.scm 1407 */
return 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5059)))->BgL_z52genresz52);} 

}



/* &mpd-database-find-ge1377 */
obj_t BGl_z62mpdzd2databasezd2findzd2ge1377zb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_5060, obj_t BgL_oz00_5061, obj_t BgL_opz00_5062, obj_t BgL_genrez00_5063)
{
{ /* Llib/mpd.scm 1389 */
{ /* Llib/mpd.scm 1393 */
bool_t BgL_tmpz00_8157;
{ /* Llib/mpd.scm 1402 */
obj_t BgL_g1299z00_5641;
BgL_g1299z00_5641 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5061)))->BgL_directoriesz00); 
{ 
obj_t BgL_l1297z00_5643;
BgL_l1297z00_5643 = BgL_g1299z00_5641; 
BgL_zc3z04anonymousza32578ze3z87_5642:
if(
NULLP(BgL_l1297z00_5643))
{ /* Llib/mpd.scm 1402 */
BgL_tmpz00_8157 = ((bool_t)0)
; }  else 
{ /* Llib/mpd.scm 1402 */
bool_t BgL__ortest_1300z00_5644;
{ /* Llib/mpd.scm 1402 */
obj_t BgL_arg2581z00_5645;
BgL_arg2581z00_5645 = 
CAR(
((obj_t)BgL_l1297z00_5643)); 
BgL__ortest_1300z00_5644 = 
BGl_findzd2genreze70z35zz__multimediazd2mpdzd2(BgL_genrez00_5063, 
((obj_t)BgL_opz00_5062), 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5061), BgL_arg2581z00_5645); } 
if(BgL__ortest_1300z00_5644)
{ /* Llib/mpd.scm 1402 */
BgL_tmpz00_8157 = BgL__ortest_1300z00_5644
; }  else 
{ /* Llib/mpd.scm 1402 */
obj_t BgL_arg2580z00_5646;
BgL_arg2580z00_5646 = 
CDR(
((obj_t)BgL_l1297z00_5643)); 
{ 
obj_t BgL_l1297z00_8170;
BgL_l1297z00_8170 = BgL_arg2580z00_5646; 
BgL_l1297z00_5643 = BgL_l1297z00_8170; 
goto BgL_zc3z04anonymousza32578ze3z87_5642;} } } } } 
return 
BBOOL(BgL_tmpz00_8157);} } 

}



/* find-genre~0 */
bool_t BGl_findzd2genreze70z35zz__multimediazd2mpdzd2(obj_t BgL_genrez00_5219, obj_t BgL_opz00_5218, BgL_mpdzd2databasezd2_bglt BgL_oz00_5217, obj_t BgL_dirz00_2277)
{
{ /* Llib/mpd.scm 1399 */
if(
bgl_directoryp(
BSTRING_TO_STRING(BgL_dirz00_2277)))
{ /* Llib/mpd.scm 1394 */
obj_t BgL_g1295z00_2280;
BgL_g1295z00_2280 = 
BGl_directoryzd2ze3pathzd2listze3zz__r4_ports_6_10_1z00(BgL_dirz00_2277); 
{ 
obj_t BgL_l1293z00_2282;
BgL_l1293z00_2282 = BgL_g1295z00_2280; 
BgL_zc3z04anonymousza32584ze3z87_2283:
if(
NULLP(BgL_l1293z00_2282))
{ /* Llib/mpd.scm 1394 */
return ((bool_t)0);}  else 
{ /* Llib/mpd.scm 1394 */
bool_t BgL__ortest_1296z00_2285;
{ /* Llib/mpd.scm 1394 */
obj_t BgL_arg2587z00_2287;
BgL_arg2587z00_2287 = 
CAR(
((obj_t)BgL_l1293z00_2282)); 
BgL__ortest_1296z00_2285 = 
BGl_findzd2genreze70z35zz__multimediazd2mpdzd2(BgL_genrez00_5219, BgL_opz00_5218, BgL_oz00_5217, BgL_arg2587z00_2287); } 
if(BgL__ortest_1296z00_2285)
{ /* Llib/mpd.scm 1394 */
return BgL__ortest_1296z00_2285;}  else 
{ /* Llib/mpd.scm 1394 */
obj_t BgL_arg2586z00_2286;
BgL_arg2586z00_2286 = 
CDR(
((obj_t)BgL_l1293z00_2282)); 
{ 
obj_t BgL_l1293z00_8184;
BgL_l1293z00_8184 = BgL_arg2586z00_2286; 
BgL_l1293z00_2282 = BgL_l1293z00_8184; 
goto BgL_zc3z04anonymousza32584ze3z87_2283;} } } } }  else 
{ /* Llib/mpd.scm 1395 */
bool_t BgL_test3931z00_8185;
{ /* Llib/mpd.scm 1395 */
obj_t BgL_arg2591z00_2295;
BgL_arg2591z00_2295 = 
BGl_basenamez00zz__osz00(
BGl_dirnamez00zz__osz00(BgL_dirz00_2277)); 
BgL_test3931z00_8185 = 
bigloo_strcmp(BgL_arg2591z00_2295, 
((obj_t)BgL_genrez00_5219)); } 
if(BgL_test3931z00_8185)
{ /* Llib/mpd.scm 1395 */
{ /* Llib/mpd.scm 422 */
obj_t BgL_g1188z00_3663;
BgL_g1188z00_3663 = 
BGl_getinfofilez00zz__multimediazd2mpdzd2(
((obj_t)BgL_oz00_5217), BgL_dirz00_2277, BFALSE, BFALSE, BFALSE); 
{ 
obj_t BgL_l1186z00_3665;
BgL_l1186z00_3665 = BgL_g1188z00_3663; 
BgL_zc3z04anonymousza31933ze3z87_3664:
if(
PAIRP(BgL_l1186z00_3665))
{ /* Llib/mpd.scm 427 */
{ /* Llib/mpd.scm 423 */
obj_t BgL_kz00_3667;
BgL_kz00_3667 = 
CAR(BgL_l1186z00_3665); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1935z00_3668;
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1936z00_3669;
BgL_arg1936z00_3669 = 
CAR(
((obj_t)BgL_kz00_3667)); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_res2947z00_3676;
BgL_res2947z00_3676 = 
KEYWORD_TO_STRING(
((obj_t)BgL_arg1936z00_3669)); 
BgL_arg1935z00_3668 = BgL_res2947z00_3676; } } 
bgl_display_obj(BgL_arg1935z00_3668, BgL_opz00_5218); } 
bgl_display_string(BGl_string3326z00zz__multimediazd2mpdzd2, BgL_opz00_5218); 
{ /* Llib/mpd.scm 425 */
obj_t BgL_arg1937z00_3670;
{ /* Llib/mpd.scm 425 */
obj_t BgL_pairz00_3682;
BgL_pairz00_3682 = 
CDR(
((obj_t)BgL_kz00_3667)); 
BgL_arg1937z00_3670 = 
CAR(BgL_pairz00_3682); } 
bgl_display_obj(BgL_arg1937z00_3670, BgL_opz00_5218); } 
bgl_display_char(((unsigned char)10), BgL_opz00_5218); } 
{ 
obj_t BgL_l1186z00_8206;
BgL_l1186z00_8206 = 
CDR(BgL_l1186z00_3665); 
BgL_l1186z00_3665 = BgL_l1186z00_8206; 
goto BgL_zc3z04anonymousza31933ze3z87_3664;} }  else 
{ /* Llib/mpd.scm 427 */((bool_t)1); } } } 
return ((bool_t)1);}  else 
{ /* Llib/mpd.scm 1395 */
return ((bool_t)0);} } } 

}



/* &mpd-database-find-ti1375 */
obj_t BGl_z62mpdzd2databasezd2findzd2ti1375zb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_5064, obj_t BgL_oz00_5065, obj_t BgL_opz00_5066, obj_t BgL_titlez00_5067)
{
{ /* Llib/mpd.scm 1371 */
{ /* Llib/mpd.scm 1375 */
bool_t BgL_tmpz00_8208;
{ /* Llib/mpd.scm 1384 */
obj_t BgL_g1291z00_5649;
BgL_g1291z00_5649 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5065)))->BgL_directoriesz00); 
{ 
obj_t BgL_l1289z00_5651;
BgL_l1289z00_5651 = BgL_g1291z00_5649; 
BgL_zc3z04anonymousza32562ze3z87_5650:
if(
NULLP(BgL_l1289z00_5651))
{ /* Llib/mpd.scm 1384 */
BgL_tmpz00_8208 = ((bool_t)0)
; }  else 
{ /* Llib/mpd.scm 1384 */
bool_t BgL__ortest_1292z00_5652;
{ /* Llib/mpd.scm 1384 */
obj_t BgL_arg2565z00_5653;
BgL_arg2565z00_5653 = 
CAR(
((obj_t)BgL_l1289z00_5651)); 
BgL__ortest_1292z00_5652 = 
BGl_findzd2titleze70z35zz__multimediazd2mpdzd2(BgL_titlez00_5067, 
((obj_t)BgL_opz00_5066), 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5065), BgL_arg2565z00_5653); } 
if(BgL__ortest_1292z00_5652)
{ /* Llib/mpd.scm 1384 */
BgL_tmpz00_8208 = BgL__ortest_1292z00_5652
; }  else 
{ /* Llib/mpd.scm 1384 */
obj_t BgL_arg2564z00_5654;
BgL_arg2564z00_5654 = 
CDR(
((obj_t)BgL_l1289z00_5651)); 
{ 
obj_t BgL_l1289z00_8221;
BgL_l1289z00_8221 = BgL_arg2564z00_5654; 
BgL_l1289z00_5651 = BgL_l1289z00_8221; 
goto BgL_zc3z04anonymousza32562ze3z87_5650;} } } } } 
return 
BBOOL(BgL_tmpz00_8208);} } 

}



/* find-title~0 */
bool_t BGl_findzd2titleze70z35zz__multimediazd2mpdzd2(obj_t BgL_titlez00_5216, obj_t BgL_opz00_5215, BgL_mpdzd2databasezd2_bglt BgL_oz00_5214, obj_t BgL_dirz00_2239)
{
{ /* Llib/mpd.scm 1381 */
if(
bgl_directoryp(
BSTRING_TO_STRING(BgL_dirz00_2239)))
{ /* Llib/mpd.scm 1376 */
obj_t BgL_g1287z00_2242;
BgL_g1287z00_2242 = 
BGl_directoryzd2ze3pathzd2listze3zz__r4_ports_6_10_1z00(BgL_dirz00_2239); 
{ 
obj_t BgL_l1285z00_2244;
BgL_l1285z00_2244 = BgL_g1287z00_2242; 
BgL_zc3z04anonymousza32568ze3z87_2245:
if(
NULLP(BgL_l1285z00_2244))
{ /* Llib/mpd.scm 1376 */
return ((bool_t)0);}  else 
{ /* Llib/mpd.scm 1376 */
bool_t BgL__ortest_1288z00_2247;
{ /* Llib/mpd.scm 1376 */
obj_t BgL_arg2571z00_2249;
BgL_arg2571z00_2249 = 
CAR(
((obj_t)BgL_l1285z00_2244)); 
BgL__ortest_1288z00_2247 = 
BGl_findzd2titleze70z35zz__multimediazd2mpdzd2(BgL_titlez00_5216, BgL_opz00_5215, BgL_oz00_5214, BgL_arg2571z00_2249); } 
if(BgL__ortest_1288z00_2247)
{ /* Llib/mpd.scm 1376 */
return BgL__ortest_1288z00_2247;}  else 
{ /* Llib/mpd.scm 1376 */
obj_t BgL_arg2570z00_2248;
BgL_arg2570z00_2248 = 
CDR(
((obj_t)BgL_l1285z00_2244)); 
{ 
obj_t BgL_l1285z00_8235;
BgL_l1285z00_8235 = BgL_arg2570z00_2248; 
BgL_l1285z00_2244 = BgL_l1285z00_8235; 
goto BgL_zc3z04anonymousza32568ze3z87_2245;} } } } }  else 
{ /* Llib/mpd.scm 1377 */
bool_t BgL_test3938z00_8236;
{ /* Llib/mpd.scm 1377 */
obj_t BgL_arg2575z00_2257;
BgL_arg2575z00_2257 = 
BGl_prefixz00zz__osz00(
BGl_basenamez00zz__osz00(BgL_dirz00_2239)); 
BgL_test3938z00_8236 = 
bigloo_strcmp(BgL_arg2575z00_2257, 
((obj_t)BgL_titlez00_5216)); } 
if(BgL_test3938z00_8236)
{ /* Llib/mpd.scm 1377 */
{ /* Llib/mpd.scm 422 */
obj_t BgL_g1188z00_3630;
BgL_g1188z00_3630 = 
BGl_getinfofilez00zz__multimediazd2mpdzd2(
((obj_t)BgL_oz00_5214), BgL_dirz00_2239, BFALSE, BFALSE, BFALSE); 
{ 
obj_t BgL_l1186z00_3632;
BgL_l1186z00_3632 = BgL_g1188z00_3630; 
BgL_zc3z04anonymousza31933ze3z87_3631:
if(
PAIRP(BgL_l1186z00_3632))
{ /* Llib/mpd.scm 427 */
{ /* Llib/mpd.scm 423 */
obj_t BgL_kz00_3634;
BgL_kz00_3634 = 
CAR(BgL_l1186z00_3632); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1935z00_3635;
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1936z00_3636;
BgL_arg1936z00_3636 = 
CAR(
((obj_t)BgL_kz00_3634)); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_res2941z00_3643;
BgL_res2941z00_3643 = 
KEYWORD_TO_STRING(
((obj_t)BgL_arg1936z00_3636)); 
BgL_arg1935z00_3635 = BgL_res2941z00_3643; } } 
bgl_display_obj(BgL_arg1935z00_3635, BgL_opz00_5215); } 
bgl_display_string(BGl_string3326z00zz__multimediazd2mpdzd2, BgL_opz00_5215); 
{ /* Llib/mpd.scm 425 */
obj_t BgL_arg1937z00_3637;
{ /* Llib/mpd.scm 425 */
obj_t BgL_pairz00_3649;
BgL_pairz00_3649 = 
CDR(
((obj_t)BgL_kz00_3634)); 
BgL_arg1937z00_3637 = 
CAR(BgL_pairz00_3649); } 
bgl_display_obj(BgL_arg1937z00_3637, BgL_opz00_5215); } 
bgl_display_char(((unsigned char)10), BgL_opz00_5215); } 
{ 
obj_t BgL_l1186z00_8257;
BgL_l1186z00_8257 = 
CDR(BgL_l1186z00_3632); 
BgL_l1186z00_3632 = BgL_l1186z00_8257; 
goto BgL_zc3z04anonymousza31933ze3z87_3631;} }  else 
{ /* Llib/mpd.scm 427 */((bool_t)1); } } } 
return ((bool_t)1);}  else 
{ /* Llib/mpd.scm 1377 */
return ((bool_t)0);} } } 

}



/* &mpd-database-search-1373 */
obj_t BGl_z62mpdzd2databasezd2searchzd21373zb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_5068, obj_t BgL_oz00_5069, obj_t BgL_opz00_5070, obj_t BgL_artistz00_5071, obj_t BgL_titlez00_5072)
{
{ /* Llib/mpd.scm 1345 */
{ /* Llib/mpd.scm 1349 */
bool_t BgL_tmpz00_8259;
{ 
BgL_mpdzd2databasezd2_bglt BgL_dbz00_5658;obj_t BgL_dirz00_5659;obj_t BgL_opz00_5660;
{ /* Llib/mpd.scm 1364 */
obj_t BgL_cz00_5661;
BgL_cz00_5661 = 
BGl_assocz00zz__r4_pairs_and_lists_6_3z00(BgL_artistz00_5071, 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5069)))->BgL_z52artistsz52)); 
if(
PAIRP(BgL_cz00_5661))
{ /* Llib/mpd.scm 1365 */
BgL_dbz00_5658 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5069); 
BgL_dirz00_5659 = 
CDR(BgL_cz00_5661); 
BgL_opz00_5660 = 
((obj_t)BgL_opz00_5070); 
BgL_tmpz00_8259 = 
BGl_loopze72ze7zz__multimediazd2mpdzd2(BgL_opz00_5660, BgL_dbz00_5658, BgL_artistz00_5071, BgL_titlez00_5072, BgL_dirz00_5659); }  else 
{ /* Llib/mpd.scm 1365 */
BgL_tmpz00_8259 = ((bool_t)0)
; } } } 
return 
BBOOL(BgL_tmpz00_8259);} } 

}



/* loop~2 */
bool_t BGl_loopze72ze7zz__multimediazd2mpdzd2(obj_t BgL_opz00_5213, BgL_mpdzd2databasezd2_bglt BgL_dbz00_5212, obj_t BgL_artistz00_5211, obj_t BgL_titlez00_5210, obj_t BgL_dirz00_2190)
{
{ /* Llib/mpd.scm 1348 */
{ /* Llib/mpd.scm 1349 */
obj_t BgL_filesz00_2192;
BgL_filesz00_2192 = 
BGl_directoryzd2ze3pathzd2listze3zz__r4_ports_6_10_1z00(BgL_dirz00_2190); 
{ /* Llib/mpd.scm 1349 */
obj_t BgL_imgz00_2193;
{ 
obj_t BgL_list1282z00_2212;
BgL_list1282z00_2212 = BgL_filesz00_2192; 
BgL_zc3z04anonymousza32555ze3z87_2213:
if(
PAIRP(BgL_list1282z00_2212))
{ /* Llib/mpd.scm 1350 */
if(
BGl_imagezd2filezf3z21zz__multimediazd2mpdzd2(
CAR(BgL_list1282z00_2212)))
{ /* Llib/mpd.scm 1350 */
BgL_imgz00_2193 = 
CAR(BgL_list1282z00_2212); }  else 
{ 
obj_t BgL_list1282z00_8277;
BgL_list1282z00_8277 = 
CDR(BgL_list1282z00_2212); 
BgL_list1282z00_2212 = BgL_list1282z00_8277; 
goto BgL_zc3z04anonymousza32555ze3z87_2213;} }  else 
{ /* Llib/mpd.scm 1350 */
BgL_imgz00_2193 = BFALSE; } } 
{ /* Llib/mpd.scm 1350 */

{ 
obj_t BgL_l1283z00_2195;
BgL_l1283z00_2195 = BgL_filesz00_2192; 
BgL_zc3z04anonymousza32547ze3z87_2196:
if(
PAIRP(BgL_l1283z00_2195))
{ /* Llib/mpd.scm 1351 */
{ /* Llib/mpd.scm 1352 */
obj_t BgL_fz00_2198;
BgL_fz00_2198 = 
CAR(BgL_l1283z00_2195); 
{ /* Llib/mpd.scm 1352 */
obj_t BgL_pz00_2199;
BgL_pz00_2199 = 
BGl_makezd2filezd2namez00zz__osz00(BgL_dirz00_2190, BgL_fz00_2198); 
if(
bgl_directoryp(
BSTRING_TO_STRING(BgL_pz00_2199)))
{ /* Llib/mpd.scm 1354 */
BGl_loopze72ze7zz__multimediazd2mpdzd2(BgL_opz00_5213, BgL_dbz00_5212, BgL_artistz00_5211, BgL_titlez00_5210, BgL_pz00_2199); }  else 
{ /* Llib/mpd.scm 1356 */
bool_t BgL_test3945z00_8287;
if(
BGl_musiczd2filezf3z21zz__multimediazd2mpdzd2(BgL_pz00_2199, 
((obj_t)BgL_dbz00_5212)))
{ /* Llib/mpd.scm 1356 */
obj_t BgL_arg2553z00_2208;
BgL_arg2553z00_2208 = 
BGl_prefixz00zz__osz00(BgL_fz00_2198); 
BgL_test3945z00_8287 = 
bigloo_strcmp(
((obj_t)BgL_titlez00_5210), BgL_arg2553z00_2208); }  else 
{ /* Llib/mpd.scm 1356 */
BgL_test3945z00_8287 = ((bool_t)0)
; } 
if(BgL_test3945z00_8287)
{ /* Llib/mpd.scm 422 */
obj_t BgL_g1188z00_3597;
BgL_g1188z00_3597 = 
BGl_getinfofilez00zz__multimediazd2mpdzd2(
((obj_t)BgL_dbz00_5212), BgL_pz00_2199, BgL_artistz00_5211, BgL_titlez00_5210, BgL_imgz00_2193); 
{ 
obj_t BgL_l1186z00_3599;
BgL_l1186z00_3599 = BgL_g1188z00_3597; 
BgL_zc3z04anonymousza31933ze3z87_3598:
if(
PAIRP(BgL_l1186z00_3599))
{ /* Llib/mpd.scm 427 */
{ /* Llib/mpd.scm 423 */
obj_t BgL_kz00_3601;
BgL_kz00_3601 = 
CAR(BgL_l1186z00_3599); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1935z00_3602;
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1936z00_3603;
BgL_arg1936z00_3603 = 
CAR(
((obj_t)BgL_kz00_3601)); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_res2935z00_3610;
BgL_res2935z00_3610 = 
KEYWORD_TO_STRING(
((obj_t)BgL_arg1936z00_3603)); 
BgL_arg1935z00_3602 = BgL_res2935z00_3610; } } 
bgl_display_obj(BgL_arg1935z00_3602, BgL_opz00_5213); } 
bgl_display_string(BGl_string3326z00zz__multimediazd2mpdzd2, BgL_opz00_5213); 
{ /* Llib/mpd.scm 425 */
obj_t BgL_arg1937z00_3604;
{ /* Llib/mpd.scm 425 */
obj_t BgL_pairz00_3616;
BgL_pairz00_3616 = 
CDR(
((obj_t)BgL_kz00_3601)); 
BgL_arg1937z00_3604 = 
CAR(BgL_pairz00_3616); } 
bgl_display_obj(BgL_arg1937z00_3604, BgL_opz00_5213); } 
bgl_display_char(((unsigned char)10), BgL_opz00_5213); } 
{ 
obj_t BgL_l1186z00_8310;
BgL_l1186z00_8310 = 
CDR(BgL_l1186z00_3599); 
BgL_l1186z00_3599 = BgL_l1186z00_8310; 
goto BgL_zc3z04anonymousza31933ze3z87_3598;} }  else 
{ /* Llib/mpd.scm 427 */((bool_t)1); } } }  else 
{ /* Llib/mpd.scm 1356 */((bool_t)0); } } } } 
{ 
obj_t BgL_l1283z00_8312;
BgL_l1283z00_8312 = 
CDR(BgL_l1283z00_2195); 
BgL_l1283z00_2195 = BgL_l1283z00_8312; 
goto BgL_zc3z04anonymousza32547ze3z87_2196;} }  else 
{ /* Llib/mpd.scm 1351 */
return ((bool_t)1);} } } } } } 

}



/* &mpd-database-search-1371 */
obj_t BGl_z62mpdzd2databasezd2searchzd21371zb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_5073, obj_t BgL_oz00_5074, obj_t BgL_opz00_5075, obj_t BgL_artistz00_5076, obj_t BgL_albumz00_5077)
{
{ /* Llib/mpd.scm 1312 */
{ /* Llib/mpd.scm 1315 */
bool_t BgL_tmpz00_8314;
{ 
BgL_mpdzd2databasezd2_bglt BgL_dbz00_5665;obj_t BgL_dirz00_5666;obj_t BgL_opz00_5667;
{ /* Llib/mpd.scm 1338 */
obj_t BgL_cz00_5668;
BgL_cz00_5668 = 
BGl_assocz00zz__r4_pairs_and_lists_6_3z00(BgL_artistz00_5076, 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5074)))->BgL_z52artistsz52)); 
if(
PAIRP(BgL_cz00_5668))
{ /* Llib/mpd.scm 1339 */
BgL_dbz00_5665 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5074); 
BgL_dirz00_5666 = 
CDR(BgL_cz00_5668); 
BgL_opz00_5667 = 
((obj_t)BgL_opz00_5075); 
BgL_tmpz00_8314 = 
BGl_loopze71ze7zz__multimediazd2mpdzd2(BgL_opz00_5667, BgL_dbz00_5665, BgL_artistz00_5076, BgL_albumz00_5077, BgL_dirz00_5666); }  else 
{ /* Llib/mpd.scm 1339 */
BgL_tmpz00_8314 = ((bool_t)0)
; } } } 
return 
BBOOL(BgL_tmpz00_8314);} } 

}



/* loop~1 */
bool_t BGl_loopze71ze7zz__multimediazd2mpdzd2(obj_t BgL_opz00_5209, BgL_mpdzd2databasezd2_bglt BgL_dbz00_5208, obj_t BgL_artistz00_5207, obj_t BgL_albumz00_5206, obj_t BgL_dirz00_2119)
{
{ /* Llib/mpd.scm 1314 */
{ /* Llib/mpd.scm 1315 */
bool_t BgL_test3949z00_8325;
{ /* Llib/mpd.scm 1315 */
obj_t BgL_arg2540z00_2169;
BgL_arg2540z00_2169 = 
BGl_basenamez00zz__osz00(BgL_dirz00_2119); 
BgL_test3949z00_8325 = 
bigloo_strcmp(BgL_arg2540z00_2169, 
((obj_t)BgL_albumz00_5206)); } 
if(BgL_test3949z00_8325)
{ /* Llib/mpd.scm 1316 */
obj_t BgL_filesz00_2123;
BgL_filesz00_2123 = 
BGl_sortz00zz__r4_vectors_6_8z00(BGl_proc3441z00zz__multimediazd2mpdzd2, 
bgl_directory_to_list(
BSTRING_TO_STRING(BgL_dirz00_2119))); 
{ /* Llib/mpd.scm 1316 */
obj_t BgL_imgz00_2124;
{ /* Llib/mpd.scm 1319 */
obj_t BgL_fz00_2138;
{ 
obj_t BgL_list1275z00_2141;
BgL_list1275z00_2141 = BgL_filesz00_2123; 
BgL_zc3z04anonymousza32526ze3z87_2142:
if(
PAIRP(BgL_list1275z00_2141))
{ /* Llib/mpd.scm 1319 */
if(
BGl_imagezd2filezf3z21zz__multimediazd2mpdzd2(
CAR(BgL_list1275z00_2141)))
{ /* Llib/mpd.scm 1319 */
BgL_fz00_2138 = 
CAR(BgL_list1275z00_2141); }  else 
{ 
obj_t BgL_list1275z00_8338;
BgL_list1275z00_8338 = 
CDR(BgL_list1275z00_2141); 
BgL_list1275z00_2141 = BgL_list1275z00_8338; 
goto BgL_zc3z04anonymousza32526ze3z87_2142;} }  else 
{ /* Llib/mpd.scm 1319 */
BgL_fz00_2138 = BFALSE; } } 
if(
STRINGP(BgL_fz00_2138))
{ /* Llib/mpd.scm 1320 */
BgL_imgz00_2124 = 
BGl_makezd2filezd2namez00zz__osz00(BgL_dirz00_2119, BgL_fz00_2138); }  else 
{ /* Llib/mpd.scm 1320 */
BgL_imgz00_2124 = BFALSE; } } 
{ /* Llib/mpd.scm 1319 */

{ 
obj_t BgL_l1276z00_2126;
BgL_l1276z00_2126 = BgL_filesz00_2123; 
BgL_zc3z04anonymousza32520ze3z87_2127:
if(
PAIRP(BgL_l1276z00_2126))
{ /* Llib/mpd.scm 1322 */
{ /* Llib/mpd.scm 1323 */
obj_t BgL_fz00_2129;
BgL_fz00_2129 = 
CAR(BgL_l1276z00_2126); 
{ /* Llib/mpd.scm 1323 */
obj_t BgL_pz00_2130;
BgL_pz00_2130 = 
BGl_makezd2filezd2namez00zz__osz00(BgL_dirz00_2119, BgL_fz00_2129); 
if(
bgl_directoryp(
BSTRING_TO_STRING(BgL_pz00_2130)))
{ /* Llib/mpd.scm 1325 */
BGl_loopze71ze7zz__multimediazd2mpdzd2(BgL_opz00_5209, BgL_dbz00_5208, BgL_artistz00_5207, BgL_albumz00_5206, BgL_pz00_2130); }  else 
{ /* Llib/mpd.scm 1325 */
if(
BGl_musiczd2filezf3z21zz__multimediazd2mpdzd2(BgL_pz00_2130, 
((obj_t)BgL_dbz00_5208)))
{ /* Llib/mpd.scm 422 */
obj_t BgL_g1188z00_3556;
BgL_g1188z00_3556 = 
BGl_getinfofilez00zz__multimediazd2mpdzd2(
((obj_t)BgL_dbz00_5208), BgL_pz00_2130, BgL_artistz00_5207, BgL_albumz00_5206, BgL_imgz00_2124); 
{ 
obj_t BgL_l1186z00_3558;
BgL_l1186z00_3558 = BgL_g1188z00_3556; 
BgL_zc3z04anonymousza31933ze3z87_3557:
if(
PAIRP(BgL_l1186z00_3558))
{ /* Llib/mpd.scm 427 */
{ /* Llib/mpd.scm 423 */
obj_t BgL_kz00_3560;
BgL_kz00_3560 = 
CAR(BgL_l1186z00_3558); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1935z00_3561;
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1936z00_3562;
BgL_arg1936z00_3562 = 
CAR(
((obj_t)BgL_kz00_3560)); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_res2926z00_3569;
BgL_res2926z00_3569 = 
KEYWORD_TO_STRING(
((obj_t)BgL_arg1936z00_3562)); 
BgL_arg1935z00_3561 = BgL_res2926z00_3569; } } 
bgl_display_obj(BgL_arg1935z00_3561, BgL_opz00_5209); } 
bgl_display_string(BGl_string3326z00zz__multimediazd2mpdzd2, BgL_opz00_5209); 
{ /* Llib/mpd.scm 425 */
obj_t BgL_arg1937z00_3563;
{ /* Llib/mpd.scm 425 */
obj_t BgL_pairz00_3575;
BgL_pairz00_3575 = 
CDR(
((obj_t)BgL_kz00_3560)); 
BgL_arg1937z00_3563 = 
CAR(BgL_pairz00_3575); } 
bgl_display_obj(BgL_arg1937z00_3563, BgL_opz00_5209); } 
bgl_display_char(((unsigned char)10), BgL_opz00_5209); } 
{ 
obj_t BgL_l1186z00_8370;
BgL_l1186z00_8370 = 
CDR(BgL_l1186z00_3558); 
BgL_l1186z00_3558 = BgL_l1186z00_8370; 
goto BgL_zc3z04anonymousza31933ze3z87_3557;} }  else 
{ /* Llib/mpd.scm 427 */((bool_t)1); } } }  else 
{ /* Llib/mpd.scm 1327 */((bool_t)0); } } } } 
{ 
obj_t BgL_l1276z00_8372;
BgL_l1276z00_8372 = 
CDR(BgL_l1276z00_2126); 
BgL_l1276z00_2126 = BgL_l1276z00_8372; 
goto BgL_zc3z04anonymousza32520ze3z87_2127;} }  else 
{ /* Llib/mpd.scm 1322 */
return ((bool_t)1);} } } } }  else 
{ /* Llib/mpd.scm 1333 */
obj_t BgL_g1280z00_2160;
BgL_g1280z00_2160 = 
BGl_directoryzd2ze3pathzd2listze3zz__r4_ports_6_10_1z00(BgL_dirz00_2119); 
{ 
obj_t BgL_l1278z00_2162;
BgL_l1278z00_2162 = BgL_g1280z00_2160; 
BgL_zc3z04anonymousza32536ze3z87_2163:
if(
PAIRP(BgL_l1278z00_2162))
{ /* Llib/mpd.scm 1336 */
{ /* Llib/mpd.scm 1334 */
obj_t BgL_pz00_2165;
BgL_pz00_2165 = 
CAR(BgL_l1278z00_2162); 
if(
bgl_directoryp(
BSTRING_TO_STRING(BgL_pz00_2165)))
{ /* Llib/mpd.scm 1334 */
BGl_loopze71ze7zz__multimediazd2mpdzd2(BgL_opz00_5209, BgL_dbz00_5208, BgL_artistz00_5207, BgL_albumz00_5206, BgL_pz00_2165); }  else 
{ /* Llib/mpd.scm 1334 */((bool_t)0); } } 
{ 
obj_t BgL_l1278z00_8382;
BgL_l1278z00_8382 = 
CDR(BgL_l1278z00_2162); 
BgL_l1278z00_2162 = BgL_l1278z00_8382; 
goto BgL_zc3z04anonymousza32536ze3z87_2163;} }  else 
{ /* Llib/mpd.scm 1336 */
return ((bool_t)1);} } } } } 

}



/* &<@anonymous:2534> */
obj_t BGl_z62zc3z04anonymousza32534ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_5078, obj_t BgL_s1z00_5079, obj_t BgL_s2z00_5080)
{
{ /* Llib/mpd.scm 1316 */
{ /* Llib/mpd.scm 1317 */
bool_t BgL_tmpz00_8384;
{ /* Llib/mpd.scm 1317 */
int BgL_arg2535z00_5669;
{ /* Llib/mpd.scm 1317 */

BgL_arg2535z00_5669 = 
BGl_stringzd2naturalzd2compare3z00zz__r4_strings_6_7z00(BgL_s1z00_5079, BgL_s2z00_5080, 
BINT(((long)0)), 
BINT(((long)0))); } 
BgL_tmpz00_8384 = 
(
(long)(BgL_arg2535z00_5669)<((long)0)); } 
return 
BBOOL(BgL_tmpz00_8384);} } 

}



/* &mpd-database-find-ar1369 */
obj_t BGl_z62mpdzd2databasezd2findzd2ar1369zb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_5081, obj_t BgL_oz00_5082, obj_t BgL_opz00_5083, obj_t BgL_artistz00_5084)
{
{ /* Llib/mpd.scm 1303 */
{ /* Llib/mpd.scm 1304 */
bool_t BgL_tmpz00_8391;
{ /* Llib/mpd.scm 1305 */
obj_t BgL_cz00_5675;
BgL_cz00_5675 = 
BGl_assocz00zz__r4_pairs_and_lists_6_3z00(BgL_artistz00_5084, 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5082)))->BgL_z52artistsz52)); 
if(
PAIRP(BgL_cz00_5675))
{ /* Llib/mpd.scm 1307 */
obj_t BgL_dirz00_5677;
BgL_dirz00_5677 = 
CDR(BgL_cz00_5675); 
BgL_tmpz00_8391 = 
BGl_loopze74ze7zz__multimediazd2mpdzd2(
((obj_t)BgL_opz00_5083), 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5082), BFALSE, BgL_artistz00_5084, BgL_dirz00_5677); }  else 
{ /* Llib/mpd.scm 1306 */
BgL_tmpz00_8391 = ((bool_t)0)
; } } 
return 
BBOOL(BgL_tmpz00_8391);} } 

}



/* &mpd-database-find-al1367 */
obj_t BGl_z62mpdzd2databasezd2findzd2al1367zb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_5085, obj_t BgL_oz00_5086, obj_t BgL_opz00_5087, obj_t BgL_albumz00_5088)
{
{ /* Llib/mpd.scm 1294 */
{ /* Llib/mpd.scm 1295 */
bool_t BgL_tmpz00_8402;
{ /* Llib/mpd.scm 1296 */
obj_t BgL_cz00_5684;
BgL_cz00_5684 = 
BGl_assocz00zz__r4_pairs_and_lists_6_3z00(BgL_albumz00_5088, 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5086)))->BgL_z52albumsz52)); 
if(
PAIRP(BgL_cz00_5684))
{ /* Llib/mpd.scm 1298 */
obj_t BgL_dirz00_5686;
BgL_dirz00_5686 = 
CDR(BgL_cz00_5684); 
BgL_tmpz00_8402 = 
BGl_loopze74ze7zz__multimediazd2mpdzd2(
((obj_t)BgL_opz00_5087), 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5086), BgL_albumz00_5088, BFALSE, BgL_dirz00_5686); }  else 
{ /* Llib/mpd.scm 1297 */
BgL_tmpz00_8402 = ((bool_t)0)
; } } 
return 
BBOOL(BgL_tmpz00_8402);} } 

}



/* &mpd-database-lsinfo1365 */
obj_t BGl_z62mpdzd2databasezd2lsinfo1365z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5089, obj_t BgL_oz00_5090, obj_t BgL_opz00_5091, obj_t BgL_dirz00_5092, obj_t BgL_recz00_5093)
{
{ /* Llib/mpd.scm 1233 */
{ /* Llib/mpd.scm 1234 */
bool_t BgL_tmpz00_8413;
{ /* Llib/mpd.scm 1234 */
bool_t BgL_recz00_5691;
BgL_recz00_5691 = 
CBOOL(BgL_recz00_5093); 
{ /* Llib/mpd.scm 1235 */
bool_t BgL_test3961z00_8415;
if(
BGl_filezd2systemzd2rootzf3zf3zz__multimediazd2mpdzd2(
((obj_t)BgL_dirz00_5092)))
{ /* Llib/mpd.scm 1235 */
BgL_test3961z00_8415 = ((bool_t)1)
; }  else 
{ /* Llib/mpd.scm 1235 */
BgL_test3961z00_8415 = 
bigloo_strcmp(
((obj_t)BgL_dirz00_5092), 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5090)))->BgL_z52basez52))
; } 
if(BgL_test3961z00_8415)
{ /* Llib/mpd.scm 1236 */
obj_t BgL_g1265z00_5692;
BgL_g1265z00_5692 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5090)))->BgL_directoriesz00); 
{ 
obj_t BgL_l1263z00_5694;
BgL_l1263z00_5694 = BgL_g1265z00_5692; 
BgL_zc3z04anonymousza32484ze3z87_5693:
if(
PAIRP(BgL_l1263z00_5694))
{ /* Llib/mpd.scm 1236 */
{ /* Llib/mpd.scm 1237 */
obj_t BgL_dirz00_5695;
BgL_dirz00_5695 = 
CAR(BgL_l1263z00_5694); 
{ /* Llib/mpd.scm 1237 */
obj_t BgL_g1262z00_5696;
BgL_g1262z00_5696 = 
BGl_directoryzd2ze3pathzd2listze3zz__r4_ports_6_10_1z00(BgL_dirz00_5695); 
{ 
obj_t BgL_l1260z00_5698;
BgL_l1260z00_5698 = BgL_g1262z00_5696; 
BgL_zc3z04anonymousza32486ze3z87_5697:
if(
PAIRP(BgL_l1260z00_5698))
{ /* Llib/mpd.scm 1244 */
{ /* Llib/mpd.scm 1238 */
obj_t BgL_dirz00_5699;
BgL_dirz00_5699 = 
CAR(BgL_l1260z00_5698); 
{ /* Llib/mpd.scm 1238 */
obj_t BgL_mdz00_5700;
BgL_mdz00_5700 = 
BGl_filezd2ze3mpdz31zz__multimediazd2mpdzd2(BgL_dirz00_5699, 
((obj_t)
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5090))); 
{ /* Llib/mpd.scm 1239 */
obj_t BgL_tmpz00_8435;
BgL_tmpz00_8435 = 
((obj_t)BgL_opz00_5091); 
bgl_display_string(BGl_string3442z00zz__multimediazd2mpdzd2, BgL_tmpz00_8435); } 
bgl_display_obj(BgL_mdz00_5700, 
((obj_t)BgL_opz00_5091)); 
{ /* Llib/mpd.scm 1241 */
obj_t BgL_tmpz00_8440;
BgL_tmpz00_8440 = 
((obj_t)BgL_opz00_5091); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_8440); } 
if(BgL_recz00_5691)
{ /* Llib/mpd.scm 1242 */
BGl_mpdzd2databasezd2lsinfoz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5090), 
((obj_t)BgL_opz00_5091), BgL_mdz00_5700, BgL_recz00_5691); }  else 
{ /* Llib/mpd.scm 1242 */BFALSE; } } } 
{ 
obj_t BgL_l1260z00_8447;
BgL_l1260z00_8447 = 
CDR(BgL_l1260z00_5698); 
BgL_l1260z00_5698 = BgL_l1260z00_8447; 
goto BgL_zc3z04anonymousza32486ze3z87_5697;} }  else 
{ /* Llib/mpd.scm 1244 */((bool_t)1); } } } } 
{ 
obj_t BgL_l1263z00_8449;
BgL_l1263z00_8449 = 
CDR(BgL_l1263z00_5694); 
BgL_l1263z00_5694 = BgL_l1263z00_8449; 
goto BgL_zc3z04anonymousza32484ze3z87_5693;} }  else 
{ /* Llib/mpd.scm 1236 */
BgL_tmpz00_8413 = ((bool_t)1)
; } } }  else 
{ /* Llib/mpd.scm 1246 */
obj_t BgL_pathz00_5701;
BgL_pathz00_5701 = 
BGl_mpdzd2ze3filez31zz__multimediazd2mpdzd2(
((obj_t)BgL_dirz00_5092), 
((obj_t)
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5090)), 
((obj_t)BgL_opz00_5091), BGl_string3443z00zz__multimediazd2mpdzd2); 
if(
bgl_directoryp(
BSTRING_TO_STRING(BgL_pathz00_5701)))
{ /* Llib/mpd.scm 1248 */
obj_t BgL_filesz00_5702;
BgL_filesz00_5702 = 
BGl_directoryzd2ze3sortzd2listze3zz__multimediazd2mpdzd2(BgL_pathz00_5701); 
{ /* Llib/mpd.scm 1248 */
obj_t BgL_imgz00_5703;
{ /* Llib/mpd.scm 1249 */
obj_t BgL_fz00_5704;
{ 
obj_t BgL_list1267z00_5706;
BgL_list1267z00_5706 = BgL_filesz00_5702; 
BgL_zc3z04anonymousza32497ze3z87_5705:
if(
PAIRP(BgL_list1267z00_5706))
{ /* Llib/mpd.scm 1249 */
if(
BGl_imagezd2filezf3z21zz__multimediazd2mpdzd2(
CAR(BgL_list1267z00_5706)))
{ /* Llib/mpd.scm 1249 */
BgL_fz00_5704 = 
CAR(BgL_list1267z00_5706); }  else 
{ 
obj_t BgL_list1267z00_8466;
BgL_list1267z00_8466 = 
CDR(BgL_list1267z00_5706); 
BgL_list1267z00_5706 = BgL_list1267z00_8466; 
goto BgL_zc3z04anonymousza32497ze3z87_5705;} }  else 
{ /* Llib/mpd.scm 1249 */
BgL_fz00_5704 = BFALSE; } } 
if(
STRINGP(BgL_fz00_5704))
{ /* Llib/mpd.scm 1250 */
BgL_imgz00_5703 = 
BGl_makezd2filezd2namez00zz__osz00(BgL_pathz00_5701, BgL_fz00_5704); }  else 
{ /* Llib/mpd.scm 1250 */
BgL_imgz00_5703 = BFALSE; } } 
{ /* Llib/mpd.scm 1249 */

{ 
obj_t BgL_l1268z00_5708;
BgL_l1268z00_5708 = BgL_filesz00_5702; 
BgL_zc3z04anonymousza32491ze3z87_5707:
if(
PAIRP(BgL_l1268z00_5708))
{ /* Llib/mpd.scm 1252 */
{ /* Llib/mpd.scm 1253 */
obj_t BgL_fz00_5709;
BgL_fz00_5709 = 
CAR(BgL_l1268z00_5708); 
{ /* Llib/mpd.scm 1253 */
obj_t BgL_pz00_5710;
BgL_pz00_5710 = 
BGl_makezd2filezd2namez00zz__osz00(BgL_pathz00_5701, BgL_fz00_5709); 
if(
bgl_directoryp(
BSTRING_TO_STRING(BgL_pz00_5710)))
{ /* Llib/mpd.scm 1256 */
obj_t BgL_mdz00_5711;
BgL_mdz00_5711 = 
BGl_filezd2ze3mpdz31zz__multimediazd2mpdzd2(BgL_pz00_5710, 
((obj_t)
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5090))); 
{ /* Llib/mpd.scm 1257 */
obj_t BgL_tmpz00_8481;
BgL_tmpz00_8481 = 
((obj_t)BgL_opz00_5091); 
bgl_display_string(BGl_string3442z00zz__multimediazd2mpdzd2, BgL_tmpz00_8481); } 
bgl_display_obj(BgL_mdz00_5711, 
((obj_t)BgL_opz00_5091)); 
{ /* Llib/mpd.scm 1259 */
obj_t BgL_tmpz00_8486;
BgL_tmpz00_8486 = 
((obj_t)BgL_opz00_5091); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_8486); } 
if(BgL_recz00_5691)
{ /* Llib/mpd.scm 1260 */
BGl_mpdzd2databasezd2lsinfoz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5090), 
((obj_t)BgL_opz00_5091), BgL_mdz00_5711, BgL_recz00_5691); }  else 
{ /* Llib/mpd.scm 1260 */BFALSE; } }  else 
{ /* Llib/mpd.scm 1255 */
if(
BGl_musiczd2filezf3z21zz__multimediazd2mpdzd2(BgL_fz00_5709, 
((obj_t)
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5090))))
{ /* Llib/mpd.scm 422 */
obj_t BgL_g1188z00_5712;
BgL_g1188z00_5712 = 
BGl_getinfofilez00zz__multimediazd2mpdzd2(
((obj_t)
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5090)), BgL_pz00_5710, BFALSE, BFALSE, BgL_imgz00_5703); 
{ 
obj_t BgL_l1186z00_5714;
{ /* Llib/mpd.scm 427 */
bool_t BgL_tmpz00_8500;
BgL_l1186z00_5714 = BgL_g1188z00_5712; 
BgL_zc3z04anonymousza31933ze3z87_5713:
if(
PAIRP(BgL_l1186z00_5714))
{ /* Llib/mpd.scm 427 */
{ /* Llib/mpd.scm 423 */
obj_t BgL_kz00_5715;
BgL_kz00_5715 = 
CAR(BgL_l1186z00_5714); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1935z00_5716;
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1936z00_5717;
BgL_arg1936z00_5717 = 
CAR(
((obj_t)BgL_kz00_5715)); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_res2916z00_5718;
BgL_res2916z00_5718 = 
KEYWORD_TO_STRING(
((obj_t)BgL_arg1936z00_5717)); 
BgL_arg1935z00_5716 = BgL_res2916z00_5718; } } 
bgl_display_obj(BgL_arg1935z00_5716, 
((obj_t)BgL_opz00_5091)); } 
{ /* Llib/mpd.scm 424 */
obj_t BgL_tmpz00_8510;
BgL_tmpz00_8510 = 
((obj_t)BgL_opz00_5091); 
bgl_display_string(BGl_string3326z00zz__multimediazd2mpdzd2, BgL_tmpz00_8510); } 
{ /* Llib/mpd.scm 425 */
obj_t BgL_arg1937z00_5719;
{ /* Llib/mpd.scm 425 */
obj_t BgL_pairz00_5720;
BgL_pairz00_5720 = 
CDR(
((obj_t)BgL_kz00_5715)); 
BgL_arg1937z00_5719 = 
CAR(BgL_pairz00_5720); } 
bgl_display_obj(BgL_arg1937z00_5719, 
((obj_t)BgL_opz00_5091)); } 
{ /* Llib/mpd.scm 426 */
obj_t BgL_tmpz00_8518;
BgL_tmpz00_8518 = 
((obj_t)BgL_opz00_5091); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_8518); } } 
{ 
obj_t BgL_l1186z00_8521;
BgL_l1186z00_8521 = 
CDR(BgL_l1186z00_5714); 
BgL_l1186z00_5714 = BgL_l1186z00_8521; 
goto BgL_zc3z04anonymousza31933ze3z87_5713;} }  else 
{ /* Llib/mpd.scm 427 */
BgL_tmpz00_8500 = ((bool_t)1)
; } 
BBOOL(BgL_tmpz00_8500); } } }  else 
{ /* Llib/mpd.scm 1262 */BFALSE; } } } } 
{ 
obj_t BgL_l1268z00_8524;
BgL_l1268z00_8524 = 
CDR(BgL_l1268z00_5708); 
BgL_l1268z00_5708 = BgL_l1268z00_8524; 
goto BgL_zc3z04anonymousza32491ze3z87_5707;} }  else 
{ /* Llib/mpd.scm 1252 */
BgL_tmpz00_8413 = ((bool_t)1)
; } } } } }  else 
{ /* Llib/mpd.scm 1247 */
BgL_tmpz00_8413 = ((bool_t)0)
; } } } } 
return 
BBOOL(BgL_tmpz00_8413);} } 

}



/* &mpd-database-listart1363 */
obj_t BGl_z62mpdzd2databasezd2listart1363z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5094, obj_t BgL_oz00_5095, obj_t BgL_opz00_5096)
{
{ /* Llib/mpd.scm 1223 */
{ /* Llib/mpd.scm 1224 */
bool_t BgL_tmpz00_8527;
{ /* Llib/mpd.scm 1224 */
obj_t BgL_g1259z00_5723;
BgL_g1259z00_5723 = 
BGl_mpdzd2databasezd2getartistz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5095)); 
{ 
obj_t BgL_l1257z00_5725;
BgL_l1257z00_5725 = BgL_g1259z00_5723; 
BgL_zc3z04anonymousza32476ze3z87_5724:
if(
PAIRP(BgL_l1257z00_5725))
{ /* Llib/mpd.scm 1228 */
{ /* Llib/mpd.scm 1225 */
obj_t BgL_az00_5726;
BgL_az00_5726 = 
CAR(BgL_l1257z00_5725); 
{ /* Llib/mpd.scm 1225 */
obj_t BgL_tmpz00_8533;
BgL_tmpz00_8533 = 
((obj_t)BgL_opz00_5096); 
bgl_display_string(BGl_string3333z00zz__multimediazd2mpdzd2, BgL_tmpz00_8533); } 
{ /* Llib/mpd.scm 1226 */
obj_t BgL_arg2478z00_5727;
BgL_arg2478z00_5727 = 
CAR(
((obj_t)BgL_az00_5726)); 
bgl_display_obj(BgL_arg2478z00_5727, 
((obj_t)BgL_opz00_5096)); } 
{ /* Llib/mpd.scm 1227 */
obj_t BgL_tmpz00_8540;
BgL_tmpz00_8540 = 
((obj_t)BgL_opz00_5096); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_8540); } } 
{ 
obj_t BgL_l1257z00_8543;
BgL_l1257z00_8543 = 
CDR(BgL_l1257z00_5725); 
BgL_l1257z00_5725 = BgL_l1257z00_8543; 
goto BgL_zc3z04anonymousza32476ze3z87_5724;} }  else 
{ /* Llib/mpd.scm 1228 */
BgL_tmpz00_8527 = ((bool_t)1)
; } } } 
return 
BBOOL(BgL_tmpz00_8527);} } 

}



/* &mpd-database-listgen1361 */
obj_t BGl_z62mpdzd2databasezd2listgen1361z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5097, obj_t BgL_oz00_5098, obj_t BgL_opz00_5099)
{
{ /* Llib/mpd.scm 1213 */
{ /* Llib/mpd.scm 1214 */
bool_t BgL_tmpz00_8546;
{ /* Llib/mpd.scm 1214 */
obj_t BgL_g1256z00_5730;
BgL_g1256z00_5730 = 
BGl_mpdzd2databasezd2getgenrez00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5098)); 
{ 
obj_t BgL_l1254z00_5732;
BgL_l1254z00_5732 = BgL_g1256z00_5730; 
BgL_zc3z04anonymousza32471ze3z87_5731:
if(
PAIRP(BgL_l1254z00_5732))
{ /* Llib/mpd.scm 1218 */
{ /* Llib/mpd.scm 1215 */
obj_t BgL_az00_5733;
BgL_az00_5733 = 
CAR(BgL_l1254z00_5732); 
{ /* Llib/mpd.scm 1215 */
obj_t BgL_tmpz00_8552;
BgL_tmpz00_8552 = 
((obj_t)BgL_opz00_5099); 
bgl_display_string(BGl_string3444z00zz__multimediazd2mpdzd2, BgL_tmpz00_8552); } 
{ /* Llib/mpd.scm 1216 */
obj_t BgL_arg2473z00_5734;
BgL_arg2473z00_5734 = 
CAR(
((obj_t)BgL_az00_5733)); 
bgl_display_obj(BgL_arg2473z00_5734, 
((obj_t)BgL_opz00_5099)); } 
{ /* Llib/mpd.scm 1217 */
obj_t BgL_tmpz00_8559;
BgL_tmpz00_8559 = 
((obj_t)BgL_opz00_5099); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_8559); } } 
{ 
obj_t BgL_l1254z00_8562;
BgL_l1254z00_8562 = 
CDR(BgL_l1254z00_5732); 
BgL_l1254z00_5732 = BgL_l1254z00_8562; 
goto BgL_zc3z04anonymousza32471ze3z87_5731;} }  else 
{ /* Llib/mpd.scm 1218 */
BgL_tmpz00_8546 = ((bool_t)1)
; } } } 
return 
BBOOL(BgL_tmpz00_8546);} } 

}



/* &mpd-database-listgen1359 */
obj_t BGl_z62mpdzd2databasezd2listgen1359z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5100, obj_t BgL_oz00_5101, obj_t BgL_opz00_5102, obj_t BgL_genrez00_5103)
{
{ /* Llib/mpd.scm 1203 */
{ /* Llib/mpd.scm 1204 */
bool_t BgL_tmpz00_8565;
{ /* Llib/mpd.scm 1204 */
obj_t BgL_g1253z00_5737;
BgL_g1253z00_5737 = 
BGl_mpdzd2databasezd2getgenreartistz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5101), BgL_genrez00_5103); 
{ 
obj_t BgL_l1251z00_5739;
BgL_l1251z00_5739 = BgL_g1253z00_5737; 
BgL_zc3z04anonymousza32466ze3z87_5738:
if(
PAIRP(BgL_l1251z00_5739))
{ /* Llib/mpd.scm 1208 */
{ /* Llib/mpd.scm 1205 */
obj_t BgL_az00_5740;
BgL_az00_5740 = 
CAR(BgL_l1251z00_5739); 
{ /* Llib/mpd.scm 1205 */
obj_t BgL_tmpz00_8571;
BgL_tmpz00_8571 = 
((obj_t)BgL_opz00_5102); 
bgl_display_string(BGl_string3333z00zz__multimediazd2mpdzd2, BgL_tmpz00_8571); } 
{ /* Llib/mpd.scm 1206 */
obj_t BgL_arg2468z00_5741;
BgL_arg2468z00_5741 = 
CAR(
((obj_t)BgL_az00_5740)); 
bgl_display_obj(BgL_arg2468z00_5741, 
((obj_t)BgL_opz00_5102)); } 
{ /* Llib/mpd.scm 1207 */
obj_t BgL_tmpz00_8578;
BgL_tmpz00_8578 = 
((obj_t)BgL_opz00_5102); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_8578); } } 
{ 
obj_t BgL_l1251z00_8581;
BgL_l1251z00_8581 = 
CDR(BgL_l1251z00_5739); 
BgL_l1251z00_5739 = BgL_l1251z00_8581; 
goto BgL_zc3z04anonymousza32466ze3z87_5738;} }  else 
{ /* Llib/mpd.scm 1208 */
BgL_tmpz00_8565 = ((bool_t)1)
; } } } 
return 
BBOOL(BgL_tmpz00_8565);} } 

}



/* &mpd-database-listgen1357 */
obj_t BGl_z62mpdzd2databasezd2listgen1357z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5104, obj_t BgL_oz00_5105, obj_t BgL_opz00_5106, obj_t BgL_genrez00_5107)
{
{ /* Llib/mpd.scm 1189 */
{ /* Llib/mpd.scm 1190 */
bool_t BgL_tmpz00_8584;
{ /* Llib/mpd.scm 1190 */
obj_t BgL_g1250z00_5744;
{ /* Llib/mpd.scm 1194 */
obj_t BgL_hook1246z00_5745;
BgL_hook1246z00_5745 = 
MAKE_YOUNG_PAIR(BFALSE, BNIL); 
{ /* Llib/mpd.scm 1197 */
obj_t BgL_g1247z00_5746;
BgL_g1247z00_5746 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5105)))->BgL_z52albumsz52); 
{ 
obj_t BgL_l1243z00_5748;obj_t BgL_h1244z00_5749;
BgL_l1243z00_5748 = BgL_g1247z00_5746; 
BgL_h1244z00_5749 = BgL_hook1246z00_5745; 
BgL_zc3z04anonymousza32453ze3z87_5747:
if(
NULLP(BgL_l1243z00_5748))
{ /* Llib/mpd.scm 1197 */
BgL_g1250z00_5744 = 
CDR(BgL_hook1246z00_5745); }  else 
{ /* Llib/mpd.scm 1197 */
bool_t BgL_test3979z00_8591;
{ /* Llib/mpd.scm 1195 */
obj_t BgL_cz00_5750;
BgL_cz00_5750 = 
CAR(
((obj_t)BgL_l1243z00_5748)); 
{ /* Llib/mpd.scm 1195 */
obj_t BgL_dirz00_5751;
BgL_dirz00_5751 = 
CDR(
((obj_t)BgL_cz00_5750)); 
{ /* Llib/mpd.scm 1196 */
obj_t BgL_arg2462z00_5752;
BgL_arg2462z00_5752 = 
BGl_basenamez00zz__osz00(
BGl_dirnamez00zz__osz00(
BGl_dirnamez00zz__osz00(BgL_dirz00_5751))); 
BgL_test3979z00_8591 = 
bigloo_strcmp(BgL_arg2462z00_5752, 
((obj_t)BgL_genrez00_5107)); } } } 
if(BgL_test3979z00_8591)
{ /* Llib/mpd.scm 1197 */
obj_t BgL_nh1245z00_5753;
{ /* Llib/mpd.scm 1197 */
obj_t BgL_arg2460z00_5754;
BgL_arg2460z00_5754 = 
CAR(
((obj_t)BgL_l1243z00_5748)); 
{ /* Llib/mpd.scm 1197 */
obj_t BgL_res2902z00_5755;
BgL_res2902z00_5755 = 
MAKE_YOUNG_PAIR(BgL_arg2460z00_5754, BNIL); 
BgL_nh1245z00_5753 = BgL_res2902z00_5755; } } 
SET_CDR(BgL_h1244z00_5749, BgL_nh1245z00_5753); 
{ /* Llib/mpd.scm 1197 */
obj_t BgL_arg2459z00_5756;
BgL_arg2459z00_5756 = 
CDR(
((obj_t)BgL_l1243z00_5748)); 
{ 
obj_t BgL_h1244z00_8608;obj_t BgL_l1243z00_8607;
BgL_l1243z00_8607 = BgL_arg2459z00_5756; 
BgL_h1244z00_8608 = BgL_nh1245z00_5753; 
BgL_h1244z00_5749 = BgL_h1244z00_8608; 
BgL_l1243z00_5748 = BgL_l1243z00_8607; 
goto BgL_zc3z04anonymousza32453ze3z87_5747;} } }  else 
{ /* Llib/mpd.scm 1197 */
obj_t BgL_arg2461z00_5757;
BgL_arg2461z00_5757 = 
CDR(
((obj_t)BgL_l1243z00_5748)); 
{ 
obj_t BgL_l1243z00_8611;
BgL_l1243z00_8611 = BgL_arg2461z00_5757; 
BgL_l1243z00_5748 = BgL_l1243z00_8611; 
goto BgL_zc3z04anonymousza32453ze3z87_5747;} } } } } } 
{ 
obj_t BgL_l1248z00_5759;
BgL_l1248z00_5759 = BgL_g1250z00_5744; 
BgL_zc3z04anonymousza32449ze3z87_5758:
if(
PAIRP(BgL_l1248z00_5759))
{ /* Llib/mpd.scm 1194 */
{ /* Llib/mpd.scm 1191 */
obj_t BgL_az00_5760;
BgL_az00_5760 = 
CAR(BgL_l1248z00_5759); 
{ /* Llib/mpd.scm 1191 */
obj_t BgL_tmpz00_8615;
BgL_tmpz00_8615 = 
((obj_t)BgL_opz00_5106); 
bgl_display_string(BGl_string3335z00zz__multimediazd2mpdzd2, BgL_tmpz00_8615); } 
{ /* Llib/mpd.scm 1192 */
obj_t BgL_arg2451z00_5761;
BgL_arg2451z00_5761 = 
CAR(
((obj_t)BgL_az00_5760)); 
bgl_display_obj(BgL_arg2451z00_5761, 
((obj_t)BgL_opz00_5106)); } 
{ /* Llib/mpd.scm 1193 */
obj_t BgL_tmpz00_8622;
BgL_tmpz00_8622 = 
((obj_t)BgL_opz00_5106); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_8622); } } 
{ 
obj_t BgL_l1248z00_8625;
BgL_l1248z00_8625 = 
CDR(BgL_l1248z00_5759); 
BgL_l1248z00_5759 = BgL_l1248z00_8625; 
goto BgL_zc3z04anonymousza32449ze3z87_5758;} }  else 
{ /* Llib/mpd.scm 1194 */
BgL_tmpz00_8584 = ((bool_t)1)
; } } } 
return 
BBOOL(BgL_tmpz00_8584);} } 

}



/* &mpd-database-listart1355 */
obj_t BGl_z62mpdzd2databasezd2listart1355z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5108, obj_t BgL_oz00_5109, obj_t BgL_opz00_5110, obj_t BgL_artistz00_5111)
{
{ /* Llib/mpd.scm 1179 */
{ /* Llib/mpd.scm 1180 */
bool_t BgL_tmpz00_8628;
{ /* Llib/mpd.scm 1180 */
obj_t BgL_g1241z00_5764;
BgL_g1241z00_5764 = 
BGl_mpdzd2databasezd2getartistalbumz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5109), BgL_artistz00_5111); 
{ 
obj_t BgL_l1239z00_5766;
BgL_l1239z00_5766 = BgL_g1241z00_5764; 
BgL_zc3z04anonymousza32444ze3z87_5765:
if(
PAIRP(BgL_l1239z00_5766))
{ /* Llib/mpd.scm 1184 */
{ /* Llib/mpd.scm 1181 */
obj_t BgL_az00_5767;
BgL_az00_5767 = 
CAR(BgL_l1239z00_5766); 
{ /* Llib/mpd.scm 1181 */
obj_t BgL_tmpz00_8634;
BgL_tmpz00_8634 = 
((obj_t)BgL_opz00_5110); 
bgl_display_string(BGl_string3335z00zz__multimediazd2mpdzd2, BgL_tmpz00_8634); } 
{ /* Llib/mpd.scm 1182 */
obj_t BgL_arg2446z00_5768;
{ /* Llib/mpd.scm 1182 */
obj_t BgL_pairz00_5769;
BgL_pairz00_5769 = 
CDR(
((obj_t)BgL_az00_5767)); 
BgL_arg2446z00_5768 = 
CAR(BgL_pairz00_5769); } 
bgl_display_obj(BgL_arg2446z00_5768, 
((obj_t)BgL_opz00_5110)); } 
{ /* Llib/mpd.scm 1183 */
obj_t BgL_tmpz00_8642;
BgL_tmpz00_8642 = 
((obj_t)BgL_opz00_5110); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_8642); } } 
{ 
obj_t BgL_l1239z00_8645;
BgL_l1239z00_8645 = 
CDR(BgL_l1239z00_5766); 
BgL_l1239z00_5766 = BgL_l1239z00_8645; 
goto BgL_zc3z04anonymousza32444ze3z87_5765;} }  else 
{ /* Llib/mpd.scm 1184 */
BgL_tmpz00_8628 = ((bool_t)1)
; } } } 
return 
BBOOL(BgL_tmpz00_8628);} } 

}



/* &mpd-database-listalb1353 */
obj_t BGl_z62mpdzd2databasezd2listalb1353z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5112, obj_t BgL_oz00_5113, obj_t BgL_opz00_5114)
{
{ /* Llib/mpd.scm 1168 */
{ /* Llib/mpd.scm 1169 */
bool_t BgL_tmpz00_8648;
{ /* Llib/mpd.scm 1169 */
obj_t BgL_g1238z00_5772;
BgL_g1238z00_5772 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5113)))->BgL_z52albumsz52); 
{ 
obj_t BgL_l1236z00_5774;
BgL_l1236z00_5774 = BgL_g1238z00_5772; 
BgL_zc3z04anonymousza32439ze3z87_5773:
if(
PAIRP(BgL_l1236z00_5774))
{ /* Llib/mpd.scm 1173 */
{ /* Llib/mpd.scm 1170 */
obj_t BgL_az00_5775;
BgL_az00_5775 = 
CAR(BgL_l1236z00_5774); 
{ /* Llib/mpd.scm 1170 */
obj_t BgL_tmpz00_8654;
BgL_tmpz00_8654 = 
((obj_t)BgL_opz00_5114); 
bgl_display_string(BGl_string3335z00zz__multimediazd2mpdzd2, BgL_tmpz00_8654); } 
{ /* Llib/mpd.scm 1171 */
obj_t BgL_arg2441z00_5776;
BgL_arg2441z00_5776 = 
CAR(
((obj_t)BgL_az00_5775)); 
bgl_display_obj(BgL_arg2441z00_5776, 
((obj_t)BgL_opz00_5114)); } 
{ /* Llib/mpd.scm 1172 */
obj_t BgL_tmpz00_8661;
BgL_tmpz00_8661 = 
((obj_t)BgL_opz00_5114); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_8661); } } 
{ 
obj_t BgL_l1236z00_8664;
BgL_l1236z00_8664 = 
CDR(BgL_l1236z00_5774); 
BgL_l1236z00_5774 = BgL_l1236z00_8664; 
goto BgL_zc3z04anonymousza32439ze3z87_5773;} }  else 
{ /* Llib/mpd.scm 1173 */
BgL_tmpz00_8648 = ((bool_t)1)
; } } } 
return 
BBOOL(BgL_tmpz00_8648);} } 

}



/* &mpd-database-listall1351 */
obj_t BGl_z62mpdzd2databasezd2listall1351z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5115, obj_t BgL_oz00_5116, obj_t BgL_opz00_5117)
{
{ /* Llib/mpd.scm 1142 */
{ /* Llib/mpd.scm 1146 */
bool_t BgL_tmpz00_8667;
{ /* Llib/mpd.scm 1160 */
obj_t BgL_tmpz00_8668;
BgL_tmpz00_8668 = 
((obj_t)BgL_opz00_5117); 
bgl_display_string(BGl_string3442z00zz__multimediazd2mpdzd2, BgL_tmpz00_8668); } 
bgl_display_obj(
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5116)))->BgL_z52basez52), 
((obj_t)BgL_opz00_5117)); 
{ /* Llib/mpd.scm 1162 */
obj_t BgL_tmpz00_8675;
BgL_tmpz00_8675 = 
((obj_t)BgL_opz00_5117); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_8675); } 
{ /* Llib/mpd.scm 1163 */
obj_t BgL_g1235z00_5782;
BgL_g1235z00_5782 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5116)))->BgL_directoriesz00); 
{ 
obj_t BgL_l1233z00_5784;
BgL_l1233z00_5784 = BgL_g1235z00_5782; 
BgL_zc3z04anonymousza32425ze3z87_5783:
if(
PAIRP(BgL_l1233z00_5784))
{ /* Llib/mpd.scm 1163 */
{ /* Llib/mpd.scm 1163 */
obj_t BgL_pathz00_5787;
BgL_pathz00_5787 = 
CAR(BgL_l1233z00_5784); 
BGl_loopze70ze7zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5116), 
((obj_t)BgL_opz00_5117), BgL_pathz00_5787); } 
{ 
obj_t BgL_l1233z00_8686;
BgL_l1233z00_8686 = 
CDR(BgL_l1233z00_5784); 
BgL_l1233z00_5784 = BgL_l1233z00_8686; 
goto BgL_zc3z04anonymousza32425ze3z87_5783;} }  else 
{ /* Llib/mpd.scm 1163 */
BgL_tmpz00_8667 = ((bool_t)1)
; } } } 
return 
BBOOL(BgL_tmpz00_8667);} } 

}



/* loop~0 */
obj_t BGl_loopze70ze7zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_5203, obj_t BgL_opz00_5202, obj_t BgL_pathz00_1892)
{
{ /* Llib/mpd.scm 1145 */
if(
bgl_directoryp(
BSTRING_TO_STRING(BgL_pathz00_1892)))
{ /* Llib/mpd.scm 1146 */
bgl_display_string(BGl_string3442z00zz__multimediazd2mpdzd2, BgL_opz00_5202); 
{ /* Llib/mpd.scm 1149 */
obj_t BgL_arg2432z00_1895;
BgL_arg2432z00_1895 = 
BGl_filezd2ze3mpdz31zz__multimediazd2mpdzd2(BgL_pathz00_1892, 
((obj_t)BgL_oz00_5203)); 
bgl_display_obj(BgL_arg2432z00_1895, BgL_opz00_5202); } 
bgl_display_char(((unsigned char)10), BgL_opz00_5202); 
{ /* Llib/mpd.scm 1151 */
obj_t BgL_g1232z00_1896;
BgL_g1232z00_1896 = 
BGl_directoryzd2ze3sortzd2listze3zz__multimediazd2mpdzd2(BgL_pathz00_1892); 
{ 
obj_t BgL_l1230z00_1898;
{ /* Llib/mpd.scm 1153 */
bool_t BgL_tmpz00_8698;
BgL_l1230z00_1898 = BgL_g1232z00_1896; 
BgL_zc3z04anonymousza32433ze3z87_1899:
if(
PAIRP(BgL_l1230z00_1898))
{ /* Llib/mpd.scm 1153 */
{ /* Llib/mpd.scm 1152 */
obj_t BgL_fz00_1901;
BgL_fz00_1901 = 
CAR(BgL_l1230z00_1898); 
BGl_loopze70ze7zz__multimediazd2mpdzd2(BgL_oz00_5203, BgL_opz00_5202, 
BGl_makezd2filezd2namez00zz__osz00(BgL_pathz00_1892, BgL_fz00_1901)); } 
{ 
obj_t BgL_l1230z00_8704;
BgL_l1230z00_8704 = 
CDR(BgL_l1230z00_1898); 
BgL_l1230z00_1898 = BgL_l1230z00_8704; 
goto BgL_zc3z04anonymousza32433ze3z87_1899;} }  else 
{ /* Llib/mpd.scm 1153 */
BgL_tmpz00_8698 = ((bool_t)1)
; } 
return 
BBOOL(BgL_tmpz00_8698);} } } }  else 
{ /* Llib/mpd.scm 1146 */
bgl_display_string(BGl_string3330z00zz__multimediazd2mpdzd2, BgL_opz00_5202); 
{ /* Llib/mpd.scm 1156 */
obj_t BgL_arg2437z00_1905;
BgL_arg2437z00_1905 = 
BGl_filezd2ze3mpdz31zz__multimediazd2mpdzd2(BgL_pathz00_1892, 
((obj_t)BgL_oz00_5203)); 
bgl_display_obj(BgL_arg2437z00_1905, BgL_opz00_5202); } 
return 
bgl_display_char(((unsigned char)10), BgL_opz00_5202);} } 

}



/* &mpd-database-stats1349 */
obj_t BGl_z62mpdzd2databasezd2stats1349z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5118, obj_t BgL_oz00_5119, obj_t BgL_backendz00_5120, obj_t BgL_opz00_5121)
{
{ /* Llib/mpd.scm 1108 */
{ 

{ /* Llib/mpd.scm 1125 */
obj_t BgL_arg2398z00_5795;int BgL_arg2399z00_5796;int BgL_arg2400z00_5797;long BgL_arg2401z00_5798;obj_t BgL_arg2402z00_5799;long BgL_arg2403z00_5800;
BgL_arg2398z00_5795 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5119)))->BgL_z52nartistsz52); 
BgL_arg2399z00_5796 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5119)))->BgL_z52nalbumsz52); 
BgL_arg2400z00_5797 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5119)))->BgL_z52nsongsz52); 
{ /* Llib/mpd.scm 1135 */
long BgL_arg2410z00_5801;
{ /* Llib/mpd.scm 1135 */
long BgL_arg2411z00_5802;obj_t BgL_arg2412z00_5803;
BgL_arg2411z00_5802 = 
bgl_current_seconds(); 
BgL_arg2412z00_5803 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5119)))->BgL_z52uptimez52); 
{ /* Llib/mpd.scm 1135 */
long BgL_res2890z00_5804;
{ /* Llib/mpd.scm 1135 */
long BgL_za72za7_5805;
BgL_za72za7_5805 = 
BELONG_TO_LONG(BgL_arg2412z00_5803); 
{ /* Llib/mpd.scm 1135 */
long BgL_tmpz00_8722;
BgL_tmpz00_8722 = 
(BgL_arg2411z00_5802-BgL_za72za7_5805); 
BgL_res2890z00_5804 = 
(long)(BgL_tmpz00_8722); } } 
BgL_arg2410z00_5801 = BgL_res2890z00_5804; } } 
{ /* Llib/mpd.scm 1135 */
long BgL_res2891z00_5806;
BgL_res2891z00_5806 = 
(long)(BgL_arg2410z00_5801); 
BgL_arg2401z00_5798 = BgL_res2891z00_5806; } } 
{ /* Llib/mpd.scm 1111 */
obj_t BgL_plistz00_5790;int BgL_numz00_5791;
BgL_plistz00_5790 = 
BGl_musiczd2playlistzd2getz00zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_5120)); 
BgL_numz00_5791 = 
BGl_musiczd2songzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_5120)); 
{ /* Llib/mpd.scm 1113 */
bool_t BgL_test3986z00_8730;
if(
(
(long)(BgL_numz00_5791)>=((long)0)))
{ /* Llib/mpd.scm 1113 */
BgL_test3986z00_8730 = 
(
(long)(BgL_numz00_5791)<
bgl_list_length(BgL_plistz00_5790))
; }  else 
{ /* Llib/mpd.scm 1113 */
BgL_test3986z00_8730 = ((bool_t)0)
; } 
if(BgL_test3986z00_8730)
{ /* Llib/mpd.scm 1114 */
obj_t BgL_filez00_5792;
BgL_filez00_5792 = 
bgl_list_ref(BgL_plistz00_5790, 
(long)(BgL_numz00_5791)); 
{ /* Llib/mpd.scm 1114 */
obj_t BgL_pathz00_5793;
if(
bigloo_strcmp_at(BgL_filez00_5792, BGl_string3327z00zz__multimediazd2mpdzd2, ((long)0)))
{ /* Llib/mpd.scm 1021 */
BgL_pathz00_5793 = BgL_filez00_5792; }  else 
{ /* Llib/mpd.scm 1021 */
BgL_pathz00_5793 = 
BGl_filezd2ze3mpdz31zz__multimediazd2mpdzd2(BgL_filez00_5792, 
((obj_t)
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5119))); } 
{ /* Llib/mpd.scm 1115 */

if(
fexists(
BSTRING_TO_STRING(BgL_filez00_5792)))
{ /* Llib/mpd.scm 1117 */
obj_t BgL_infoz00_5794;
BgL_infoz00_5794 = 
BGl_filezd2musicinfozd2zz__multimediazd2id3zd2(BgL_filez00_5792); 
if(
BGl_isazf3zf3zz__objectz00(BgL_infoz00_5794, BGl_musicinfoz00zz__multimediazd2id3zd2))
{ /* Llib/mpd.scm 1118 */
BgL_arg2402z00_5799 = 
BINT(
(((BgL_musicinfoz00_bglt)COBJECT(
((BgL_musicinfoz00_bglt)BgL_infoz00_5794)))->BgL_durationz00)); }  else 
{ /* Llib/mpd.scm 1118 */
BgL_arg2402z00_5799 = 
BINT(((long)1000000)); } }  else 
{ /* Llib/mpd.scm 1116 */
BgL_arg2402z00_5799 = 
BINT(((long)1000000)); } } } }  else 
{ /* Llib/mpd.scm 1113 */
BgL_arg2402z00_5799 = BFALSE; } } } 
{ /* Llib/mpd.scm 1137 */
long BgL_arg2413z00_5807;
{ /* Llib/mpd.scm 1137 */
long BgL_arg2414z00_5808;obj_t BgL_arg2415z00_5809;
BgL_arg2414z00_5808 = 
bgl_current_seconds(); 
BgL_arg2415z00_5809 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5119)))->BgL_z52dbzd2updatez80); 
{ /* Llib/mpd.scm 1137 */
long BgL_res2893z00_5810;
{ /* Llib/mpd.scm 1137 */
long BgL_za72za7_5811;
BgL_za72za7_5811 = 
BELONG_TO_LONG(BgL_arg2415z00_5809); 
{ /* Llib/mpd.scm 1137 */
long BgL_tmpz00_8759;
BgL_tmpz00_8759 = 
(BgL_arg2414z00_5808-BgL_za72za7_5811); 
BgL_res2893z00_5810 = 
(long)(BgL_tmpz00_8759); } } 
BgL_arg2413z00_5807 = BgL_res2893z00_5810; } } 
{ /* Llib/mpd.scm 1137 */
long BgL_res2894z00_5812;
BgL_res2894z00_5812 = 
(long)(BgL_arg2413z00_5807); 
BgL_arg2403z00_5800 = BgL_res2894z00_5812; } } 
{ /* Llib/mpd.scm 1125 */
obj_t BgL_list2404z00_5813;
{ /* Llib/mpd.scm 1125 */
obj_t BgL_arg2405z00_5814;
{ /* Llib/mpd.scm 1125 */
obj_t BgL_arg2406z00_5815;
{ /* Llib/mpd.scm 1125 */
obj_t BgL_arg2407z00_5816;
{ /* Llib/mpd.scm 1125 */
obj_t BgL_arg2408z00_5817;
{ /* Llib/mpd.scm 1125 */
obj_t BgL_arg2409z00_5818;
BgL_arg2409z00_5818 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2403z00_5800), BNIL); 
BgL_arg2408z00_5817 = 
MAKE_YOUNG_PAIR(BgL_arg2402z00_5799, BgL_arg2409z00_5818); } 
BgL_arg2407z00_5816 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2401z00_5798), BgL_arg2408z00_5817); } 
BgL_arg2406z00_5815 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2400z00_5797), BgL_arg2407z00_5816); } 
BgL_arg2405z00_5814 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2399z00_5796), BgL_arg2406z00_5815); } 
BgL_list2404z00_5813 = 
MAKE_YOUNG_PAIR(BgL_arg2398z00_5795, BgL_arg2405z00_5814); } 
return 
BGl_fprintfz00zz__r4_output_6_10_3z00(BgL_opz00_5121, BGl_string3445z00zz__multimediazd2mpdzd2, BgL_list2404z00_5813);} } } } 

}



/* &mpd-database-file->p1347 */
obj_t BGl_z62mpdzd2databasezd2filezd2ze3p1347z53zz__multimediazd2mpdzd2(obj_t BgL_envz00_5122, obj_t BgL_oz00_5123, obj_t BgL_filez00_5124)
{
{ /* Llib/mpd.scm 1095 */
if(
NULLP(
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5123)))->BgL_directoriesz00)))
{ /* Llib/mpd.scm 1097 */
return 
((obj_t)BgL_filez00_5124);}  else 
{ /* Llib/mpd.scm 1099 */
obj_t BgL_dirz00_5821;
{ /* Llib/mpd.scm 1099 */
obj_t BgL_arg2395z00_5822;
BgL_arg2395z00_5822 = 
BGl_filezd2namezd2ze3listze3zz__osz00(
((obj_t)BgL_filez00_5124)); 
BgL_dirz00_5821 = 
CAR(
((obj_t)BgL_arg2395z00_5822)); } 
{ /* Llib/mpd.scm 1099 */
obj_t BgL_nz00_5823;
{ /* Llib/mpd.scm 1100 */
obj_t BgL_arg2393z00_5824;
BgL_arg2393z00_5824 = 
CAR(
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5123)))->BgL_directoriesz00)); 
{ /* Llib/mpd.scm 1100 */

BgL_nz00_5823 = 
BGl_stringzd2containszd2zz__r4_strings_6_7z00(BgL_arg2393z00_5824, BgL_dirz00_5821, 
(int)(((long)0))); } } 
{ /* Llib/mpd.scm 1100 */

if(
BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(BgL_nz00_5823))
{ /* Llib/mpd.scm 1102 */
obj_t BgL_arg2390z00_5825;
{ /* Llib/mpd.scm 1102 */
obj_t BgL_arg2391z00_5826;
BgL_arg2391z00_5826 = 
CAR(
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5123)))->BgL_directoriesz00)); 
{ /* Llib/mpd.scm 1102 */
obj_t BgL_res2885z00_5827;
{ /* Llib/mpd.scm 1102 */
long BgL_endz00_5828;
BgL_endz00_5828 = 
(long)CINT(BgL_nz00_5823); 
BgL_res2885z00_5827 = 
c_substring(
((obj_t)BgL_arg2391z00_5826), ((long)0), BgL_endz00_5828); } 
BgL_arg2390z00_5825 = BgL_res2885z00_5827; } } 
return 
string_append(BgL_arg2390z00_5825, 
((obj_t)BgL_filez00_5124));}  else 
{ /* Llib/mpd.scm 1101 */
return 
((obj_t)BgL_filez00_5124);} } } } } 

}



/* &mpd-database-init!1345 */
obj_t BGl_z62mpdzd2databasezd2initz121345z70zz__multimediazd2mpdzd2(obj_t BgL_envz00_5125, obj_t BgL_oz00_5126)
{
{ /* Llib/mpd.scm 956 */
{ 
BgL_mpdzd2databasezd2_bglt BgL_auxz00_8799;
if(
NULLP(
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5126)))->BgL_directoriesz00)))
{ /* Llib/mpd.scm 962 */BFALSE; }  else 
{ /* Llib/mpd.scm 962 */
if(
NULLP(
CDR(
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5126)))->BgL_directoriesz00))))
{ 
obj_t BgL_auxz00_8809;
{ /* Llib/mpd.scm 964 */
obj_t BgL_pairz00_5832;
BgL_pairz00_5832 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5126)))->BgL_directoriesz00); 
BgL_auxz00_8809 = 
CAR(BgL_pairz00_5832); } 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5126)))->BgL_z52basez52)=((obj_t)BgL_auxz00_8809),BUNSPEC); }  else 
{ /* Llib/mpd.scm 965 */
obj_t BgL_g1140z00_5833;obj_t BgL_g1142z00_5834;
BgL_g1140z00_5833 = 
CDR(
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5126)))->BgL_directoriesz00)); 
BgL_g1142z00_5834 = 
BGl_filezd2namezd2ze3listze3zz__osz00(
CAR(
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5126)))->BgL_directoriesz00))); 
{ 
obj_t BgL_dirsz00_5836;obj_t BgL_lz00_5837;
BgL_dirsz00_5836 = BgL_g1140z00_5833; 
BgL_lz00_5837 = BgL_g1142z00_5834; 
BgL_loopz00_5835:
if(
NULLP(BgL_dirsz00_5836))
{ 
obj_t BgL_auxz00_8824;
{ /* Llib/mpd.scm 968 */
obj_t BgL_runner2367z00_5838;
BgL_runner2367z00_5838 = BgL_lz00_5837; 
{ /* Llib/mpd.scm 968 */
obj_t BgL_aux2365z00_5839;
{ /* Llib/mpd.scm 968 */
obj_t BgL_pairz00_5840;
BgL_pairz00_5840 = BgL_runner2367z00_5838; 
BgL_aux2365z00_5839 = 
CAR(BgL_pairz00_5840); } 
{ /* Llib/mpd.scm 968 */
obj_t BgL_pairz00_5841;
BgL_pairz00_5841 = BgL_runner2367z00_5838; 
BgL_runner2367z00_5838 = 
CDR(BgL_pairz00_5841); } 
{ /* Llib/mpd.scm 968 */
obj_t BgL_aux2366z00_5842;
{ /* Llib/mpd.scm 968 */
obj_t BgL_pairz00_5843;
BgL_pairz00_5843 = BgL_runner2367z00_5838; 
BgL_aux2366z00_5842 = 
CAR(BgL_pairz00_5843); } 
{ /* Llib/mpd.scm 968 */
obj_t BgL_pairz00_5844;
BgL_pairz00_5844 = BgL_runner2367z00_5838; 
BgL_runner2367z00_5838 = 
CDR(BgL_pairz00_5844); } 
BgL_auxz00_8824 = 
BGl_makezd2filezd2pathz00zz__osz00(BgL_aux2365z00_5839, BgL_aux2366z00_5842, BgL_runner2367z00_5838); } } } 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5126)))->BgL_z52basez52)=((obj_t)BgL_auxz00_8824),BUNSPEC); }  else 
{ /* Llib/mpd.scm 969 */
obj_t BgL_nlz00_5845;
BgL_nlz00_5845 = 
BGl_filezd2namezd2ze3listze3zz__osz00(
BGl_dirnamez00zz__osz00(
CAR(
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5126)))->BgL_directoriesz00)))); 
{ /* Llib/mpd.scm 970 */
obj_t BgL_arg2368z00_5846;obj_t BgL_arg2369z00_5847;
BgL_arg2368z00_5846 = 
CDR(
((obj_t)BgL_dirsz00_5836)); 
BgL_arg2369z00_5847 = 
BGl_loopze75ze7zz__multimediazd2mpdzd2(BgL_lz00_5837, BgL_nlz00_5845); 
{ 
obj_t BgL_lz00_8841;obj_t BgL_dirsz00_8840;
BgL_dirsz00_8840 = BgL_arg2368z00_5846; 
BgL_lz00_8841 = BgL_arg2369z00_5847; 
BgL_lz00_5837 = BgL_lz00_8841; 
BgL_dirsz00_5836 = BgL_dirsz00_8840; 
goto BgL_loopz00_5835;} } } } } } 
{ 
obj_t BgL_auxz00_8842;
{ /* Llib/mpd.scm 972 */
long BgL_arg2379z00_5850;long BgL_arg2380z00_5851;
{ /* Llib/mpd.scm 972 */
long BgL_res2880z00_5852;
BgL_res2880z00_5852 = 
bgl_current_seconds(); 
BgL_arg2379z00_5850 = BgL_res2880z00_5852; } 
{ /* Llib/mpd.scm 972 */
obj_t BgL_arg2381z00_5853;
BgL_arg2381z00_5853 = 
BGl_makezd2datezd2zz__datez00(
BINT(((long)1)), 
BINT(((long)-1)), 
BINT(((long)0)), 
BINT(((long)0)), 
BINT(((long)1)), BGl_llong3446z00zz__multimediazd2mpdzd2, 
BINT(((long)0)), BFALSE, 
BINT(((long)1970))); 
{ /* Llib/mpd.scm 972 */
long BgL_res2881z00_5854;
BgL_res2881z00_5854 = 
bgl_date_to_seconds(
((obj_t)BgL_arg2381z00_5853)); 
BgL_arg2380z00_5851 = BgL_res2881z00_5854; } } 
BgL_auxz00_8842 = 
BGl_2zd2zd2zz__r4_numbers_6_5z00(
make_belong(BgL_arg2379z00_5850), 
make_belong(BgL_arg2380z00_5851)); } 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5126)))->BgL_z52dbzd2updatez80)=((obj_t)BgL_auxz00_8842),BUNSPEC); } 
{ 
obj_t BgL_auxz00_8859;
{ /* Llib/mpd.scm 973 */
long BgL_arg2382z00_5855;long BgL_arg2383z00_5856;
{ /* Llib/mpd.scm 973 */
long BgL_res2882z00_5857;
BgL_res2882z00_5857 = 
bgl_current_seconds(); 
BgL_arg2382z00_5855 = BgL_res2882z00_5857; } 
{ /* Llib/mpd.scm 973 */
obj_t BgL_arg2384z00_5858;
BgL_arg2384z00_5858 = 
BGl_makezd2datezd2zz__datez00(
BINT(((long)1)), 
BINT(((long)-1)), 
BINT(((long)0)), 
BINT(((long)0)), 
BINT(((long)1)), BGl_llong3446z00zz__multimediazd2mpdzd2, 
BINT(((long)0)), BFALSE, 
BINT(((long)1970))); 
{ /* Llib/mpd.scm 973 */
long BgL_res2883z00_5859;
BgL_res2883z00_5859 = 
bgl_date_to_seconds(
((obj_t)BgL_arg2384z00_5858)); 
BgL_arg2383z00_5856 = BgL_res2883z00_5859; } } 
BgL_auxz00_8859 = 
BGl_2zd2zd2zz__r4_numbers_6_5z00(
make_belong(BgL_arg2382z00_5855), 
make_belong(BgL_arg2383z00_5856)); } 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5126)))->BgL_z52uptimez52)=((obj_t)BgL_auxz00_8859),BUNSPEC); } 
{ /* Llib/mpd.scm 975 */
obj_t BgL_artistsz00_5860;
BgL_artistsz00_5860 = 
BGl_mpdzd2databasezd2directorieszd2scanzd2zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5126), 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5126)))->BgL_directoriesz00)); 
{ /* Llib/mpd.scm 976 */
obj_t BgL_albumsz00_5861;obj_t BgL_genresz00_5862;obj_t BgL_nsongz00_5863;
{ /* Llib/mpd.scm 977 */
int BgL_tmpz00_8880;
BgL_tmpz00_8880 = 
(int)(((long)1)); 
BgL_albumsz00_5861 = 
BGL_MVALUES_VAL(BgL_tmpz00_8880); } 
{ /* Llib/mpd.scm 977 */
int BgL_tmpz00_8883;
BgL_tmpz00_8883 = 
(int)(((long)2)); 
BgL_genresz00_5862 = 
BGL_MVALUES_VAL(BgL_tmpz00_8883); } 
{ /* Llib/mpd.scm 977 */
int BgL_tmpz00_8886;
BgL_tmpz00_8886 = 
(int)(((long)3)); 
BgL_nsongz00_5863 = 
BGL_MVALUES_VAL(BgL_tmpz00_8886); } 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5126)))->BgL_z52artistsz52)=((obj_t)BgL_artistsz00_5860),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5126)))->BgL_z52nartistsz52)=((obj_t)
BINT(
bgl_list_length(BgL_artistsz00_5860))),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5126)))->BgL_z52albumsz52)=((obj_t)BgL_albumsz00_5861),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5126)))->BgL_z52genresz52)=((obj_t)BgL_genresz00_5862),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5126)))->BgL_z52nalbumsz52)=((int)
(int)(
bgl_list_length(BgL_albumsz00_5861))),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5126)))->BgL_z52nsongsz52)=((int)
CINT(BgL_nsongz00_5863)),BUNSPEC); } } 
BgL_auxz00_8799 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5126); 
return 
((obj_t)BgL_auxz00_8799);} } 

}



/* mpd-database-init! */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2initz12z12zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_331)
{
{ /* Llib/mpd.scm 956 */
{ /* Llib/mpd.scm 956 */
obj_t BgL_method1346z00_2382;
{ /* Llib/mpd.scm 956 */
obj_t BgL_res2969z00_3755;
{ /* Llib/mpd.scm 956 */
long BgL_objzd2classzd2numz00_3720;
{ /* Llib/mpd.scm 956 */
long BgL_res2959z00_3723;
BgL_res2959z00_3723 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_331)); 
BgL_objzd2classzd2numz00_3720 = BgL_res2959z00_3723; } 
{ /* Llib/mpd.scm 956 */
obj_t BgL_arg1718z00_3721;
BgL_arg1718z00_3721 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2initz12zd2envzc0zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 956 */
int BgL_offsetz00_3725;
BgL_offsetz00_3725 = 
(int)(BgL_objzd2classzd2numz00_3720); 
{ /* Llib/mpd.scm 956 */
long BgL_offsetz00_3726;
BgL_offsetz00_3726 = 
(
(long)(BgL_offsetz00_3725)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 956 */
long BgL_modz00_3727;
BgL_modz00_3727 = 
(BgL_offsetz00_3726 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 956 */
long BgL_restz00_3729;
BgL_restz00_3729 = 
(BgL_offsetz00_3726 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 956 */

{ /* Llib/mpd.scm 956 */
obj_t BgL_bucketz00_3731;
BgL_bucketz00_3731 = 
VECTOR_REF(
((obj_t)BgL_arg1718z00_3721),BgL_modz00_3727); 
BgL_res2969z00_3755 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3731),BgL_restz00_3729); } } } } } } } } 
BgL_method1346z00_2382 = BgL_res2969z00_3755; } 
return 
PROCEDURE_ENTRY(BgL_method1346z00_2382)(BgL_method1346z00_2382, 
((obj_t)BgL_oz00_331), BEOA);} } 

}



/* &mpd-database-init! */
obj_t BGl_z62mpdzd2databasezd2initz12z70zz__multimediazd2mpdzd2(obj_t BgL_envz00_5018, obj_t BgL_oz00_5019)
{
{ /* Llib/mpd.scm 956 */
{ /* Llib/mpd.scm 956 */
BgL_mpdzd2databasezd2_bglt BgL_auxz00_8938;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5019, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 956 */
BgL_auxz00_8938 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5019)
; }  else 
{ 
obj_t BgL_auxz00_8942;
BgL_auxz00_8942 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3292z00zz__multimediazd2mpdzd2, 
BINT(((long)37998)), BGl_string3447z00zz__multimediazd2mpdzd2, BGl_string3298z00zz__multimediazd2mpdzd2, BgL_oz00_5019); 
FAILURE(BgL_auxz00_8942,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2initz12z12zz__multimediazd2mpdzd2(BgL_auxz00_8938);} } 

}



/* mpd-database-file->path */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2filezd2ze3pathz31zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_349, obj_t BgL_filez00_350)
{
{ /* Llib/mpd.scm 1095 */
{ /* Llib/mpd.scm 1095 */
obj_t BgL_method1348z00_2383;
{ /* Llib/mpd.scm 1095 */
obj_t BgL_res2980z00_3792;
{ /* Llib/mpd.scm 1095 */
long BgL_objzd2classzd2numz00_3757;
{ /* Llib/mpd.scm 1095 */
long BgL_res2970z00_3760;
BgL_res2970z00_3760 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_349)); 
BgL_objzd2classzd2numz00_3757 = BgL_res2970z00_3760; } 
{ /* Llib/mpd.scm 1095 */
obj_t BgL_arg1718z00_3758;
BgL_arg1718z00_3758 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2filezd2ze3pathzd2envze3zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1095 */
int BgL_offsetz00_3762;
BgL_offsetz00_3762 = 
(int)(BgL_objzd2classzd2numz00_3757); 
{ /* Llib/mpd.scm 1095 */
long BgL_offsetz00_3763;
BgL_offsetz00_3763 = 
(
(long)(BgL_offsetz00_3762)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1095 */
long BgL_modz00_3764;
BgL_modz00_3764 = 
(BgL_offsetz00_3763 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1095 */
long BgL_restz00_3766;
BgL_restz00_3766 = 
(BgL_offsetz00_3763 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1095 */

{ /* Llib/mpd.scm 1095 */
obj_t BgL_bucketz00_3768;
BgL_bucketz00_3768 = 
VECTOR_REF(
((obj_t)BgL_arg1718z00_3758),BgL_modz00_3764); 
BgL_res2980z00_3792 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3768),BgL_restz00_3766); } } } } } } } } 
BgL_method1348z00_2383 = BgL_res2980z00_3792; } 
return 
PROCEDURE_ENTRY(BgL_method1348z00_2383)(BgL_method1348z00_2383, 
((obj_t)BgL_oz00_349), BgL_filez00_350, BEOA);} } 

}



/* &mpd-database-file->path */
obj_t BGl_z62mpdzd2databasezd2filezd2ze3pathz53zz__multimediazd2mpdzd2(obj_t BgL_envz00_5127, obj_t BgL_oz00_5128, obj_t BgL_filez00_5129)
{
{ /* Llib/mpd.scm 1095 */
{ /* Llib/mpd.scm 1095 */
obj_t BgL_auxz00_8986;BgL_mpdzd2databasezd2_bglt BgL_auxz00_8978;
if(
STRINGP(BgL_filez00_5129))
{ /* Llib/mpd.scm 1095 */
BgL_auxz00_8986 = BgL_filez00_5129
; }  else 
{ 
obj_t BgL_auxz00_8989;
BgL_auxz00_8989 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3292z00zz__multimediazd2mpdzd2, 
BINT(((long)43641)), BGl_string3448z00zz__multimediazd2mpdzd2, BGl_string3449z00zz__multimediazd2mpdzd2, BgL_filez00_5129); 
FAILURE(BgL_auxz00_8989,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5128, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1095 */
BgL_auxz00_8978 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5128)
; }  else 
{ 
obj_t BgL_auxz00_8982;
BgL_auxz00_8982 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3292z00zz__multimediazd2mpdzd2, 
BINT(((long)43641)), BGl_string3448z00zz__multimediazd2mpdzd2, BGl_string3298z00zz__multimediazd2mpdzd2, BgL_oz00_5128); 
FAILURE(BgL_auxz00_8982,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2filezd2ze3pathz31zz__multimediazd2mpdzd2(BgL_auxz00_8978, BgL_auxz00_8986);} } 

}



/* mpd-database-stats */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2statsz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_351, obj_t BgL_backendz00_352, obj_t BgL_opz00_353)
{
{ /* Llib/mpd.scm 1108 */
{ /* Llib/mpd.scm 1108 */
obj_t BgL_method1350z00_2384;
{ /* Llib/mpd.scm 1108 */
obj_t BgL_res2991z00_3829;
{ /* Llib/mpd.scm 1108 */
long BgL_objzd2classzd2numz00_3794;
{ /* Llib/mpd.scm 1108 */
long BgL_res2981z00_3797;
BgL_res2981z00_3797 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_351)); 
BgL_objzd2classzd2numz00_3794 = BgL_res2981z00_3797; } 
{ /* Llib/mpd.scm 1108 */
obj_t BgL_arg1718z00_3795;
BgL_arg1718z00_3795 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2statszd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1108 */
int BgL_offsetz00_3799;
BgL_offsetz00_3799 = 
(int)(BgL_objzd2classzd2numz00_3794); 
{ /* Llib/mpd.scm 1108 */
long BgL_offsetz00_3800;
BgL_offsetz00_3800 = 
(
(long)(BgL_offsetz00_3799)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1108 */
long BgL_modz00_3801;
BgL_modz00_3801 = 
(BgL_offsetz00_3800 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1108 */
long BgL_restz00_3803;
BgL_restz00_3803 = 
(BgL_offsetz00_3800 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1108 */

{ /* Llib/mpd.scm 1108 */
obj_t BgL_bucketz00_3805;
BgL_bucketz00_3805 = 
VECTOR_REF(
((obj_t)BgL_arg1718z00_3795),BgL_modz00_3801); 
BgL_res2991z00_3829 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3805),BgL_restz00_3803); } } } } } } } } 
BgL_method1350z00_2384 = BgL_res2991z00_3829; } 
return 
PROCEDURE_ENTRY(BgL_method1350z00_2384)(BgL_method1350z00_2384, 
((obj_t)BgL_oz00_351), BgL_backendz00_352, BgL_opz00_353, BEOA);} } 

}



/* &mpd-database-stats */
obj_t BGl_z62mpdzd2databasezd2statsz62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5130, obj_t BgL_oz00_5131, obj_t BgL_backendz00_5132, obj_t BgL_opz00_5133)
{
{ /* Llib/mpd.scm 1108 */
{ /* Llib/mpd.scm 1108 */
BgL_mpdzd2databasezd2_bglt BgL_auxz00_9026;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5131, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1108 */
BgL_auxz00_9026 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5131)
; }  else 
{ 
obj_t BgL_auxz00_9030;
BgL_auxz00_9030 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3292z00zz__multimediazd2mpdzd2, 
BINT(((long)44204)), BGl_string3450z00zz__multimediazd2mpdzd2, BGl_string3298z00zz__multimediazd2mpdzd2, BgL_oz00_5131); 
FAILURE(BgL_auxz00_9030,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2statsz00zz__multimediazd2mpdzd2(BgL_auxz00_9026, BgL_backendz00_5132, BgL_opz00_5133);} } 

}



/* mpd-database-listall */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2listallz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_354, obj_t BgL_opz00_355)
{
{ /* Llib/mpd.scm 1142 */
{ /* Llib/mpd.scm 1142 */
obj_t BgL_method1352z00_2385;
{ /* Llib/mpd.scm 1142 */
obj_t BgL_res3002z00_3866;
{ /* Llib/mpd.scm 1142 */
long BgL_objzd2classzd2numz00_3831;
{ /* Llib/mpd.scm 1142 */
long BgL_res2992z00_3834;
BgL_res2992z00_3834 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_354)); 
BgL_objzd2classzd2numz00_3831 = BgL_res2992z00_3834; } 
{ /* Llib/mpd.scm 1142 */
obj_t BgL_arg1718z00_3832;
BgL_arg1718z00_3832 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2listallzd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1142 */
int BgL_offsetz00_3836;
BgL_offsetz00_3836 = 
(int)(BgL_objzd2classzd2numz00_3831); 
{ /* Llib/mpd.scm 1142 */
long BgL_offsetz00_3837;
BgL_offsetz00_3837 = 
(
(long)(BgL_offsetz00_3836)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1142 */
long BgL_modz00_3838;
BgL_modz00_3838 = 
(BgL_offsetz00_3837 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1142 */
long BgL_restz00_3840;
BgL_restz00_3840 = 
(BgL_offsetz00_3837 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1142 */

{ /* Llib/mpd.scm 1142 */
obj_t BgL_bucketz00_3842;
BgL_bucketz00_3842 = 
VECTOR_REF(
((obj_t)BgL_arg1718z00_3832),BgL_modz00_3838); 
BgL_res3002z00_3866 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3842),BgL_restz00_3840); } } } } } } } } 
BgL_method1352z00_2385 = BgL_res3002z00_3866; } 
return 
PROCEDURE_ENTRY(BgL_method1352z00_2385)(BgL_method1352z00_2385, 
((obj_t)BgL_oz00_354), BgL_opz00_355, BEOA);} } 

}



/* &mpd-database-listall */
obj_t BGl_z62mpdzd2databasezd2listallz62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5134, obj_t BgL_oz00_5135, obj_t BgL_opz00_5136)
{
{ /* Llib/mpd.scm 1142 */
{ /* Llib/mpd.scm 1142 */
obj_t BgL_auxz00_9074;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9066;
if(
OUTPUT_PORTP(BgL_opz00_5136))
{ /* Llib/mpd.scm 1142 */
BgL_auxz00_9074 = BgL_opz00_5136
; }  else 
{ 
obj_t BgL_auxz00_9077;
BgL_auxz00_9077 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3292z00zz__multimediazd2mpdzd2, 
BINT(((long)45279)), BGl_string3451z00zz__multimediazd2mpdzd2, BGl_string3297z00zz__multimediazd2mpdzd2, BgL_opz00_5136); 
FAILURE(BgL_auxz00_9077,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5135, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1142 */
BgL_auxz00_9066 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5135)
; }  else 
{ 
obj_t BgL_auxz00_9070;
BgL_auxz00_9070 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3292z00zz__multimediazd2mpdzd2, 
BINT(((long)45279)), BGl_string3451z00zz__multimediazd2mpdzd2, BGl_string3298z00zz__multimediazd2mpdzd2, BgL_oz00_5135); 
FAILURE(BgL_auxz00_9070,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2listallz00zz__multimediazd2mpdzd2(BgL_auxz00_9066, BgL_auxz00_9074);} } 

}



/* mpd-database-listalbum */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2listalbumz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_356, obj_t BgL_opz00_357)
{
{ /* Llib/mpd.scm 1168 */
{ /* Llib/mpd.scm 1168 */
obj_t BgL_method1354z00_2386;
{ /* Llib/mpd.scm 1168 */
obj_t BgL_res3013z00_3903;
{ /* Llib/mpd.scm 1168 */
long BgL_objzd2classzd2numz00_3868;
{ /* Llib/mpd.scm 1168 */
long BgL_res3003z00_3871;
BgL_res3003z00_3871 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_356)); 
BgL_objzd2classzd2numz00_3868 = BgL_res3003z00_3871; } 
{ /* Llib/mpd.scm 1168 */
obj_t BgL_arg1718z00_3869;
BgL_arg1718z00_3869 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2listalbumzd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1168 */
int BgL_offsetz00_3873;
BgL_offsetz00_3873 = 
(int)(BgL_objzd2classzd2numz00_3868); 
{ /* Llib/mpd.scm 1168 */
long BgL_offsetz00_3874;
BgL_offsetz00_3874 = 
(
(long)(BgL_offsetz00_3873)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1168 */
long BgL_modz00_3875;
BgL_modz00_3875 = 
(BgL_offsetz00_3874 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1168 */
long BgL_restz00_3877;
BgL_restz00_3877 = 
(BgL_offsetz00_3874 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1168 */

{ /* Llib/mpd.scm 1168 */
obj_t BgL_bucketz00_3879;
BgL_bucketz00_3879 = 
VECTOR_REF(
((obj_t)BgL_arg1718z00_3869),BgL_modz00_3875); 
BgL_res3013z00_3903 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3879),BgL_restz00_3877); } } } } } } } } 
BgL_method1354z00_2386 = BgL_res3013z00_3903; } 
return 
PROCEDURE_ENTRY(BgL_method1354z00_2386)(BgL_method1354z00_2386, 
((obj_t)BgL_oz00_356), BgL_opz00_357, BEOA);} } 

}



/* &mpd-database-listalbum */
obj_t BGl_z62mpdzd2databasezd2listalbumz62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5137, obj_t BgL_oz00_5138, obj_t BgL_opz00_5139)
{
{ /* Llib/mpd.scm 1168 */
{ /* Llib/mpd.scm 1168 */
obj_t BgL_auxz00_9121;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9113;
if(
OUTPUT_PORTP(BgL_opz00_5139))
{ /* Llib/mpd.scm 1168 */
BgL_auxz00_9121 = BgL_opz00_5139
; }  else 
{ 
obj_t BgL_auxz00_9124;
BgL_auxz00_9124 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3292z00zz__multimediazd2mpdzd2, 
BINT(((long)46110)), BGl_string3452z00zz__multimediazd2mpdzd2, BGl_string3297z00zz__multimediazd2mpdzd2, BgL_opz00_5139); 
FAILURE(BgL_auxz00_9124,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5138, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1168 */
BgL_auxz00_9113 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5138)
; }  else 
{ 
obj_t BgL_auxz00_9117;
BgL_auxz00_9117 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3292z00zz__multimediazd2mpdzd2, 
BINT(((long)46110)), BGl_string3452z00zz__multimediazd2mpdzd2, BGl_string3298z00zz__multimediazd2mpdzd2, BgL_oz00_5138); 
FAILURE(BgL_auxz00_9117,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2listalbumz00zz__multimediazd2mpdzd2(BgL_auxz00_9113, BgL_auxz00_9121);} } 

}



/* mpd-database-listartistalbum */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2listartistalbumz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_358, obj_t BgL_opz00_359, obj_t BgL_artistz00_360)
{
{ /* Llib/mpd.scm 1179 */
{ /* Llib/mpd.scm 1179 */
obj_t BgL_method1356z00_2387;
{ /* Llib/mpd.scm 1179 */
obj_t BgL_res3024z00_3940;
{ /* Llib/mpd.scm 1179 */
long BgL_objzd2classzd2numz00_3905;
{ /* Llib/mpd.scm 1179 */
long BgL_res3014z00_3908;
BgL_res3014z00_3908 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_358)); 
BgL_objzd2classzd2numz00_3905 = BgL_res3014z00_3908; } 
{ /* Llib/mpd.scm 1179 */
obj_t BgL_arg1718z00_3906;
BgL_arg1718z00_3906 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2listartistalbumzd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1179 */
int BgL_offsetz00_3910;
BgL_offsetz00_3910 = 
(int)(BgL_objzd2classzd2numz00_3905); 
{ /* Llib/mpd.scm 1179 */
long BgL_offsetz00_3911;
BgL_offsetz00_3911 = 
(
(long)(BgL_offsetz00_3910)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1179 */
long BgL_modz00_3912;
BgL_modz00_3912 = 
(BgL_offsetz00_3911 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1179 */
long BgL_restz00_3914;
BgL_restz00_3914 = 
(BgL_offsetz00_3911 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1179 */

{ /* Llib/mpd.scm 1179 */
obj_t BgL_bucketz00_3916;
BgL_bucketz00_3916 = 
VECTOR_REF(
((obj_t)BgL_arg1718z00_3906),BgL_modz00_3912); 
BgL_res3024z00_3940 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3916),BgL_restz00_3914); } } } } } } } } 
BgL_method1356z00_2387 = BgL_res3024z00_3940; } 
return 
PROCEDURE_ENTRY(BgL_method1356z00_2387)(BgL_method1356z00_2387, 
((obj_t)BgL_oz00_358), BgL_opz00_359, BgL_artistz00_360, BEOA);} } 

}



/* &mpd-database-listartistalbum */
obj_t BGl_z62mpdzd2databasezd2listartistalbumz62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5140, obj_t BgL_oz00_5141, obj_t BgL_opz00_5142, obj_t BgL_artistz00_5143)
{
{ /* Llib/mpd.scm 1179 */
{ /* Llib/mpd.scm 1179 */
obj_t BgL_auxz00_9169;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9161;
if(
OUTPUT_PORTP(BgL_opz00_5142))
{ /* Llib/mpd.scm 1179 */
BgL_auxz00_9169 = BgL_opz00_5142
; }  else 
{ 
obj_t BgL_auxz00_9172;
BgL_auxz00_9172 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3292z00zz__multimediazd2mpdzd2, 
BINT(((long)46540)), BGl_string3453z00zz__multimediazd2mpdzd2, BGl_string3297z00zz__multimediazd2mpdzd2, BgL_opz00_5142); 
FAILURE(BgL_auxz00_9172,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5141, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1179 */
BgL_auxz00_9161 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5141)
; }  else 
{ 
obj_t BgL_auxz00_9165;
BgL_auxz00_9165 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3292z00zz__multimediazd2mpdzd2, 
BINT(((long)46540)), BGl_string3453z00zz__multimediazd2mpdzd2, BGl_string3298z00zz__multimediazd2mpdzd2, BgL_oz00_5141); 
FAILURE(BgL_auxz00_9165,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2listartistalbumz00zz__multimediazd2mpdzd2(BgL_auxz00_9161, BgL_auxz00_9169, BgL_artistz00_5143);} } 

}



/* mpd-database-listgenrealbum */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2listgenrealbumz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_361, obj_t BgL_opz00_362, obj_t BgL_genrez00_363)
{
{ /* Llib/mpd.scm 1189 */
{ /* Llib/mpd.scm 1189 */
obj_t BgL_method1358z00_2388;
{ /* Llib/mpd.scm 1189 */
obj_t BgL_res3035z00_3977;
{ /* Llib/mpd.scm 1189 */
long BgL_objzd2classzd2numz00_3942;
{ /* Llib/mpd.scm 1189 */
long BgL_res3025z00_3945;
BgL_res3025z00_3945 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_361)); 
BgL_objzd2classzd2numz00_3942 = BgL_res3025z00_3945; } 
{ /* Llib/mpd.scm 1189 */
obj_t BgL_arg1718z00_3943;
BgL_arg1718z00_3943 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2listgenrealbumzd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1189 */
int BgL_offsetz00_3947;
BgL_offsetz00_3947 = 
(int)(BgL_objzd2classzd2numz00_3942); 
{ /* Llib/mpd.scm 1189 */
long BgL_offsetz00_3948;
BgL_offsetz00_3948 = 
(
(long)(BgL_offsetz00_3947)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1189 */
long BgL_modz00_3949;
BgL_modz00_3949 = 
(BgL_offsetz00_3948 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1189 */
long BgL_restz00_3951;
BgL_restz00_3951 = 
(BgL_offsetz00_3948 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1189 */

{ /* Llib/mpd.scm 1189 */
obj_t BgL_bucketz00_3953;
BgL_bucketz00_3953 = 
VECTOR_REF(
((obj_t)BgL_arg1718z00_3943),BgL_modz00_3949); 
BgL_res3035z00_3977 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3953),BgL_restz00_3951); } } } } } } } } 
BgL_method1358z00_2388 = BgL_res3035z00_3977; } 
return 
PROCEDURE_ENTRY(BgL_method1358z00_2388)(BgL_method1358z00_2388, 
((obj_t)BgL_oz00_361), BgL_opz00_362, BgL_genrez00_363, BEOA);} } 

}



/* &mpd-database-listgenrealbum */
obj_t BGl_z62mpdzd2databasezd2listgenrealbumz62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5144, obj_t BgL_oz00_5145, obj_t BgL_opz00_5146, obj_t BgL_genrez00_5147)
{
{ /* Llib/mpd.scm 1189 */
{ /* Llib/mpd.scm 1189 */
obj_t BgL_auxz00_9217;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9209;
if(
OUTPUT_PORTP(BgL_opz00_5146))
{ /* Llib/mpd.scm 1189 */
BgL_auxz00_9217 = BgL_opz00_5146
; }  else 
{ 
obj_t BgL_auxz00_9220;
BgL_auxz00_9220 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3292z00zz__multimediazd2mpdzd2, 
BINT(((long)46973)), BGl_string3454z00zz__multimediazd2mpdzd2, BGl_string3297z00zz__multimediazd2mpdzd2, BgL_opz00_5146); 
FAILURE(BgL_auxz00_9220,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5145, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1189 */
BgL_auxz00_9209 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5145)
; }  else 
{ 
obj_t BgL_auxz00_9213;
BgL_auxz00_9213 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3292z00zz__multimediazd2mpdzd2, 
BINT(((long)46973)), BGl_string3454z00zz__multimediazd2mpdzd2, BGl_string3298z00zz__multimediazd2mpdzd2, BgL_oz00_5145); 
FAILURE(BgL_auxz00_9213,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2listgenrealbumz00zz__multimediazd2mpdzd2(BgL_auxz00_9209, BgL_auxz00_9217, BgL_genrez00_5147);} } 

}



/* mpd-database-listgenreartist */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2listgenreartistz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_364, obj_t BgL_opz00_365, obj_t BgL_genrez00_366)
{
{ /* Llib/mpd.scm 1203 */
{ /* Llib/mpd.scm 1203 */
obj_t BgL_method1360z00_2389;
{ /* Llib/mpd.scm 1203 */
obj_t BgL_res3046z00_4014;
{ /* Llib/mpd.scm 1203 */
long BgL_objzd2classzd2numz00_3979;
{ /* Llib/mpd.scm 1203 */
long BgL_res3036z00_3982;
BgL_res3036z00_3982 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_364)); 
BgL_objzd2classzd2numz00_3979 = BgL_res3036z00_3982; } 
{ /* Llib/mpd.scm 1203 */
obj_t BgL_arg1718z00_3980;
BgL_arg1718z00_3980 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2listgenreartistzd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1203 */
int BgL_offsetz00_3984;
BgL_offsetz00_3984 = 
(int)(BgL_objzd2classzd2numz00_3979); 
{ /* Llib/mpd.scm 1203 */
long BgL_offsetz00_3985;
BgL_offsetz00_3985 = 
(
(long)(BgL_offsetz00_3984)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1203 */
long BgL_modz00_3986;
BgL_modz00_3986 = 
(BgL_offsetz00_3985 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1203 */
long BgL_restz00_3988;
BgL_restz00_3988 = 
(BgL_offsetz00_3985 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1203 */

{ /* Llib/mpd.scm 1203 */
obj_t BgL_bucketz00_3990;
BgL_bucketz00_3990 = 
VECTOR_REF(
((obj_t)BgL_arg1718z00_3980),BgL_modz00_3986); 
BgL_res3046z00_4014 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3990),BgL_restz00_3988); } } } } } } } } 
BgL_method1360z00_2389 = BgL_res3046z00_4014; } 
return 
PROCEDURE_ENTRY(BgL_method1360z00_2389)(BgL_method1360z00_2389, 
((obj_t)BgL_oz00_364), BgL_opz00_365, BgL_genrez00_366, BEOA);} } 

}



/* &mpd-database-listgenreartist */
obj_t BGl_z62mpdzd2databasezd2listgenreartistz62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5148, obj_t BgL_oz00_5149, obj_t BgL_opz00_5150, obj_t BgL_genrez00_5151)
{
{ /* Llib/mpd.scm 1203 */
{ /* Llib/mpd.scm 1203 */
obj_t BgL_auxz00_9265;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9257;
if(
OUTPUT_PORTP(BgL_opz00_5150))
{ /* Llib/mpd.scm 1203 */
BgL_auxz00_9265 = BgL_opz00_5150
; }  else 
{ 
obj_t BgL_auxz00_9268;
BgL_auxz00_9268 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3292z00zz__multimediazd2mpdzd2, 
BINT(((long)47524)), BGl_string3455z00zz__multimediazd2mpdzd2, BGl_string3297z00zz__multimediazd2mpdzd2, BgL_opz00_5150); 
FAILURE(BgL_auxz00_9268,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5149, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1203 */
BgL_auxz00_9257 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5149)
; }  else 
{ 
obj_t BgL_auxz00_9261;
BgL_auxz00_9261 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3292z00zz__multimediazd2mpdzd2, 
BINT(((long)47524)), BGl_string3455z00zz__multimediazd2mpdzd2, BGl_string3298z00zz__multimediazd2mpdzd2, BgL_oz00_5149); 
FAILURE(BgL_auxz00_9261,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2listgenreartistz00zz__multimediazd2mpdzd2(BgL_auxz00_9257, BgL_auxz00_9265, BgL_genrez00_5151);} } 

}



/* mpd-database-listgenre */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2listgenrez00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_367, obj_t BgL_opz00_368)
{
{ /* Llib/mpd.scm 1213 */
{ /* Llib/mpd.scm 1213 */
obj_t BgL_method1362z00_2390;
{ /* Llib/mpd.scm 1213 */
obj_t BgL_res3057z00_4051;
{ /* Llib/mpd.scm 1213 */
long BgL_objzd2classzd2numz00_4016;
{ /* Llib/mpd.scm 1213 */
long BgL_res3047z00_4019;
BgL_res3047z00_4019 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_367)); 
BgL_objzd2classzd2numz00_4016 = BgL_res3047z00_4019; } 
{ /* Llib/mpd.scm 1213 */
obj_t BgL_arg1718z00_4017;
BgL_arg1718z00_4017 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2listgenrezd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1213 */
int BgL_offsetz00_4021;
BgL_offsetz00_4021 = 
(int)(BgL_objzd2classzd2numz00_4016); 
{ /* Llib/mpd.scm 1213 */
long BgL_offsetz00_4022;
BgL_offsetz00_4022 = 
(
(long)(BgL_offsetz00_4021)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1213 */
long BgL_modz00_4023;
BgL_modz00_4023 = 
(BgL_offsetz00_4022 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1213 */
long BgL_restz00_4025;
BgL_restz00_4025 = 
(BgL_offsetz00_4022 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1213 */

{ /* Llib/mpd.scm 1213 */
obj_t BgL_bucketz00_4027;
BgL_bucketz00_4027 = 
VECTOR_REF(
((obj_t)BgL_arg1718z00_4017),BgL_modz00_4023); 
BgL_res3057z00_4051 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4027),BgL_restz00_4025); } } } } } } } } 
BgL_method1362z00_2390 = BgL_res3057z00_4051; } 
return 
PROCEDURE_ENTRY(BgL_method1362z00_2390)(BgL_method1362z00_2390, 
((obj_t)BgL_oz00_367), BgL_opz00_368, BEOA);} } 

}



/* &mpd-database-listgenre */
obj_t BGl_z62mpdzd2databasezd2listgenrez62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5152, obj_t BgL_oz00_5153, obj_t BgL_opz00_5154)
{
{ /* Llib/mpd.scm 1213 */
{ /* Llib/mpd.scm 1213 */
obj_t BgL_auxz00_9312;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9304;
if(
OUTPUT_PORTP(BgL_opz00_5154))
{ /* Llib/mpd.scm 1213 */
BgL_auxz00_9312 = BgL_opz00_5154
; }  else 
{ 
obj_t BgL_auxz00_9315;
BgL_auxz00_9315 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3292z00zz__multimediazd2mpdzd2, 
BINT(((long)47955)), BGl_string3456z00zz__multimediazd2mpdzd2, BGl_string3297z00zz__multimediazd2mpdzd2, BgL_opz00_5154); 
FAILURE(BgL_auxz00_9315,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5153, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1213 */
BgL_auxz00_9304 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5153)
; }  else 
{ 
obj_t BgL_auxz00_9308;
BgL_auxz00_9308 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3292z00zz__multimediazd2mpdzd2, 
BINT(((long)47955)), BGl_string3456z00zz__multimediazd2mpdzd2, BGl_string3298z00zz__multimediazd2mpdzd2, BgL_oz00_5153); 
FAILURE(BgL_auxz00_9308,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2listgenrez00zz__multimediazd2mpdzd2(BgL_auxz00_9304, BgL_auxz00_9312);} } 

}



/* mpd-database-listartist */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2listartistz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_369, obj_t BgL_opz00_370)
{
{ /* Llib/mpd.scm 1223 */
{ /* Llib/mpd.scm 1223 */
obj_t BgL_method1364z00_2391;
{ /* Llib/mpd.scm 1223 */
obj_t BgL_res3068z00_4088;
{ /* Llib/mpd.scm 1223 */
long BgL_objzd2classzd2numz00_4053;
{ /* Llib/mpd.scm 1223 */
long BgL_res3058z00_4056;
BgL_res3058z00_4056 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_369)); 
BgL_objzd2classzd2numz00_4053 = BgL_res3058z00_4056; } 
{ /* Llib/mpd.scm 1223 */
obj_t BgL_arg1718z00_4054;
BgL_arg1718z00_4054 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2listartistzd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1223 */
int BgL_offsetz00_4058;
BgL_offsetz00_4058 = 
(int)(BgL_objzd2classzd2numz00_4053); 
{ /* Llib/mpd.scm 1223 */
long BgL_offsetz00_4059;
BgL_offsetz00_4059 = 
(
(long)(BgL_offsetz00_4058)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1223 */
long BgL_modz00_4060;
BgL_modz00_4060 = 
(BgL_offsetz00_4059 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1223 */
long BgL_restz00_4062;
BgL_restz00_4062 = 
(BgL_offsetz00_4059 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1223 */

{ /* Llib/mpd.scm 1223 */
obj_t BgL_bucketz00_4064;
BgL_bucketz00_4064 = 
VECTOR_REF(
((obj_t)BgL_arg1718z00_4054),BgL_modz00_4060); 
BgL_res3068z00_4088 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4064),BgL_restz00_4062); } } } } } } } } 
BgL_method1364z00_2391 = BgL_res3068z00_4088; } 
return 
PROCEDURE_ENTRY(BgL_method1364z00_2391)(BgL_method1364z00_2391, 
((obj_t)BgL_oz00_369), BgL_opz00_370, BEOA);} } 

}



/* &mpd-database-listartist */
obj_t BGl_z62mpdzd2databasezd2listartistz62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5155, obj_t BgL_oz00_5156, obj_t BgL_opz00_5157)
{
{ /* Llib/mpd.scm 1223 */
{ /* Llib/mpd.scm 1223 */
obj_t BgL_auxz00_9359;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9351;
if(
OUTPUT_PORTP(BgL_opz00_5157))
{ /* Llib/mpd.scm 1223 */
BgL_auxz00_9359 = BgL_opz00_5157
; }  else 
{ 
obj_t BgL_auxz00_9362;
BgL_auxz00_9362 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3292z00zz__multimediazd2mpdzd2, 
BINT(((long)48361)), BGl_string3457z00zz__multimediazd2mpdzd2, BGl_string3297z00zz__multimediazd2mpdzd2, BgL_opz00_5157); 
FAILURE(BgL_auxz00_9362,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5156, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1223 */
BgL_auxz00_9351 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5156)
; }  else 
{ 
obj_t BgL_auxz00_9355;
BgL_auxz00_9355 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3292z00zz__multimediazd2mpdzd2, 
BINT(((long)48361)), BGl_string3457z00zz__multimediazd2mpdzd2, BGl_string3298z00zz__multimediazd2mpdzd2, BgL_oz00_5156); 
FAILURE(BgL_auxz00_9355,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2listartistz00zz__multimediazd2mpdzd2(BgL_auxz00_9351, BgL_auxz00_9359);} } 

}



/* mpd-database-lsinfo */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2lsinfoz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_371, obj_t BgL_opz00_372, obj_t BgL_dirz00_373, bool_t BgL_recz00_374)
{
{ /* Llib/mpd.scm 1233 */
{ /* Llib/mpd.scm 1233 */
obj_t BgL_method1366z00_2392;
{ /* Llib/mpd.scm 1233 */
obj_t BgL_res3079z00_4125;
{ /* Llib/mpd.scm 1233 */
long BgL_objzd2classzd2numz00_4090;
{ /* Llib/mpd.scm 1233 */
long BgL_res3069z00_4093;
BgL_res3069z00_4093 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_371)); 
BgL_objzd2classzd2numz00_4090 = BgL_res3069z00_4093; } 
{ /* Llib/mpd.scm 1233 */
obj_t BgL_arg1718z00_4091;
BgL_arg1718z00_4091 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2lsinfozd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1233 */
int BgL_offsetz00_4095;
BgL_offsetz00_4095 = 
(int)(BgL_objzd2classzd2numz00_4090); 
{ /* Llib/mpd.scm 1233 */
long BgL_offsetz00_4096;
BgL_offsetz00_4096 = 
(
(long)(BgL_offsetz00_4095)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1233 */
long BgL_modz00_4097;
BgL_modz00_4097 = 
(BgL_offsetz00_4096 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1233 */
long BgL_restz00_4099;
BgL_restz00_4099 = 
(BgL_offsetz00_4096 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1233 */

{ /* Llib/mpd.scm 1233 */
obj_t BgL_bucketz00_4101;
BgL_bucketz00_4101 = 
VECTOR_REF(
((obj_t)BgL_arg1718z00_4091),BgL_modz00_4097); 
BgL_res3079z00_4125 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4101),BgL_restz00_4099); } } } } } } } } 
BgL_method1366z00_2392 = BgL_res3079z00_4125; } 
return 
PROCEDURE_ENTRY(BgL_method1366z00_2392)(BgL_method1366z00_2392, 
((obj_t)BgL_oz00_371), BgL_opz00_372, BgL_dirz00_373, 
BBOOL(BgL_recz00_374), BEOA);} } 

}



/* &mpd-database-lsinfo */
obj_t BGl_z62mpdzd2databasezd2lsinfoz62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5158, obj_t BgL_oz00_5159, obj_t BgL_opz00_5160, obj_t BgL_dirz00_5161, obj_t BgL_recz00_5162)
{
{ /* Llib/mpd.scm 1233 */
{ /* Llib/mpd.scm 1233 */
obj_t BgL_auxz00_9416;obj_t BgL_auxz00_9409;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9401;
if(
STRINGP(BgL_dirz00_5161))
{ /* Llib/mpd.scm 1233 */
BgL_auxz00_9416 = BgL_dirz00_5161
; }  else 
{ 
obj_t BgL_auxz00_9419;
BgL_auxz00_9419 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3292z00zz__multimediazd2mpdzd2, 
BINT(((long)48770)), BGl_string3458z00zz__multimediazd2mpdzd2, BGl_string3449z00zz__multimediazd2mpdzd2, BgL_dirz00_5161); 
FAILURE(BgL_auxz00_9419,BFALSE,BFALSE);} 
if(
OUTPUT_PORTP(BgL_opz00_5160))
{ /* Llib/mpd.scm 1233 */
BgL_auxz00_9409 = BgL_opz00_5160
; }  else 
{ 
obj_t BgL_auxz00_9412;
BgL_auxz00_9412 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3292z00zz__multimediazd2mpdzd2, 
BINT(((long)48770)), BGl_string3458z00zz__multimediazd2mpdzd2, BGl_string3297z00zz__multimediazd2mpdzd2, BgL_opz00_5160); 
FAILURE(BgL_auxz00_9412,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5159, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1233 */
BgL_auxz00_9401 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5159)
; }  else 
{ 
obj_t BgL_auxz00_9405;
BgL_auxz00_9405 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3292z00zz__multimediazd2mpdzd2, 
BINT(((long)48770)), BGl_string3458z00zz__multimediazd2mpdzd2, BGl_string3298z00zz__multimediazd2mpdzd2, BgL_oz00_5159); 
FAILURE(BgL_auxz00_9405,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2lsinfoz00zz__multimediazd2mpdzd2(BgL_auxz00_9401, BgL_auxz00_9409, BgL_auxz00_9416, 
CBOOL(BgL_recz00_5162));} } 

}



/* mpd-database-find-album */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2findzd2albumzd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_380, obj_t BgL_opz00_381, obj_t BgL_albumz00_382)
{
{ /* Llib/mpd.scm 1294 */
{ /* Llib/mpd.scm 1294 */
obj_t BgL_method1368z00_2393;
{ /* Llib/mpd.scm 1294 */
obj_t BgL_res3090z00_4162;
{ /* Llib/mpd.scm 1294 */
long BgL_objzd2classzd2numz00_4127;
{ /* Llib/mpd.scm 1294 */
long BgL_res3080z00_4130;
BgL_res3080z00_4130 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_380)); 
BgL_objzd2classzd2numz00_4127 = BgL_res3080z00_4130; } 
{ /* Llib/mpd.scm 1294 */
obj_t BgL_arg1718z00_4128;
BgL_arg1718z00_4128 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2findzd2albumzd2envz00zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1294 */
int BgL_offsetz00_4132;
BgL_offsetz00_4132 = 
(int)(BgL_objzd2classzd2numz00_4127); 
{ /* Llib/mpd.scm 1294 */
long BgL_offsetz00_4133;
BgL_offsetz00_4133 = 
(
(long)(BgL_offsetz00_4132)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1294 */
long BgL_modz00_4134;
BgL_modz00_4134 = 
(BgL_offsetz00_4133 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1294 */
long BgL_restz00_4136;
BgL_restz00_4136 = 
(BgL_offsetz00_4133 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1294 */

{ /* Llib/mpd.scm 1294 */
obj_t BgL_bucketz00_4138;
BgL_bucketz00_4138 = 
VECTOR_REF(
((obj_t)BgL_arg1718z00_4128),BgL_modz00_4134); 
BgL_res3090z00_4162 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4138),BgL_restz00_4136); } } } } } } } } 
BgL_method1368z00_2393 = BgL_res3090z00_4162; } 
return 
PROCEDURE_ENTRY(BgL_method1368z00_2393)(BgL_method1368z00_2393, 
((obj_t)BgL_oz00_380), BgL_opz00_381, BgL_albumz00_382, BEOA);} } 

}



/* &mpd-database-find-album */
obj_t BGl_z62mpdzd2databasezd2findzd2albumzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_5163, obj_t BgL_oz00_5164, obj_t BgL_opz00_5165, obj_t BgL_albumz00_5166)
{
{ /* Llib/mpd.scm 1294 */
{ /* Llib/mpd.scm 1294 */
obj_t BgL_auxz00_9465;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9457;
if(
OUTPUT_PORTP(BgL_opz00_5165))
{ /* Llib/mpd.scm 1294 */
BgL_auxz00_9465 = BgL_opz00_5165
; }  else 
{ 
obj_t BgL_auxz00_9468;
BgL_auxz00_9468 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3292z00zz__multimediazd2mpdzd2, 
BINT(((long)50979)), BGl_string3459z00zz__multimediazd2mpdzd2, BGl_string3297z00zz__multimediazd2mpdzd2, BgL_opz00_5165); 
FAILURE(BgL_auxz00_9468,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5164, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1294 */
BgL_auxz00_9457 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5164)
; }  else 
{ 
obj_t BgL_auxz00_9461;
BgL_auxz00_9461 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3292z00zz__multimediazd2mpdzd2, 
BINT(((long)50979)), BGl_string3459z00zz__multimediazd2mpdzd2, BGl_string3298z00zz__multimediazd2mpdzd2, BgL_oz00_5164); 
FAILURE(BgL_auxz00_9461,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2findzd2albumzd2zz__multimediazd2mpdzd2(BgL_auxz00_9457, BgL_auxz00_9465, BgL_albumz00_5166);} } 

}



/* mpd-database-find-artist */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2findzd2artistzd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_383, obj_t BgL_opz00_384, obj_t BgL_artistz00_385)
{
{ /* Llib/mpd.scm 1303 */
{ /* Llib/mpd.scm 1303 */
obj_t BgL_method1370z00_2394;
{ /* Llib/mpd.scm 1303 */
obj_t BgL_res3101z00_4199;
{ /* Llib/mpd.scm 1303 */
long BgL_objzd2classzd2numz00_4164;
{ /* Llib/mpd.scm 1303 */
long BgL_res3091z00_4167;
BgL_res3091z00_4167 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_383)); 
BgL_objzd2classzd2numz00_4164 = BgL_res3091z00_4167; } 
{ /* Llib/mpd.scm 1303 */
obj_t BgL_arg1718z00_4165;
BgL_arg1718z00_4165 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2findzd2artistzd2envz00zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1303 */
int BgL_offsetz00_4169;
BgL_offsetz00_4169 = 
(int)(BgL_objzd2classzd2numz00_4164); 
{ /* Llib/mpd.scm 1303 */
long BgL_offsetz00_4170;
BgL_offsetz00_4170 = 
(
(long)(BgL_offsetz00_4169)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1303 */
long BgL_modz00_4171;
BgL_modz00_4171 = 
(BgL_offsetz00_4170 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1303 */
long BgL_restz00_4173;
BgL_restz00_4173 = 
(BgL_offsetz00_4170 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1303 */

{ /* Llib/mpd.scm 1303 */
obj_t BgL_bucketz00_4175;
BgL_bucketz00_4175 = 
VECTOR_REF(
((obj_t)BgL_arg1718z00_4165),BgL_modz00_4171); 
BgL_res3101z00_4199 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4175),BgL_restz00_4173); } } } } } } } } 
BgL_method1370z00_2394 = BgL_res3101z00_4199; } 
return 
PROCEDURE_ENTRY(BgL_method1370z00_2394)(BgL_method1370z00_2394, 
((obj_t)BgL_oz00_383), BgL_opz00_384, BgL_artistz00_385, BEOA);} } 

}



/* &mpd-database-find-artist */
obj_t BGl_z62mpdzd2databasezd2findzd2artistzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_5167, obj_t BgL_oz00_5168, obj_t BgL_opz00_5169, obj_t BgL_artistz00_5170)
{
{ /* Llib/mpd.scm 1303 */
{ /* Llib/mpd.scm 1303 */
obj_t BgL_auxz00_9513;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9505;
if(
OUTPUT_PORTP(BgL_opz00_5169))
{ /* Llib/mpd.scm 1303 */
BgL_auxz00_9513 = BgL_opz00_5169
; }  else 
{ 
obj_t BgL_auxz00_9516;
BgL_auxz00_9516 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3292z00zz__multimediazd2mpdzd2, 
BINT(((long)51417)), BGl_string3460z00zz__multimediazd2mpdzd2, BGl_string3297z00zz__multimediazd2mpdzd2, BgL_opz00_5169); 
FAILURE(BgL_auxz00_9516,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5168, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1303 */
BgL_auxz00_9505 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5168)
; }  else 
{ 
obj_t BgL_auxz00_9509;
BgL_auxz00_9509 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3292z00zz__multimediazd2mpdzd2, 
BINT(((long)51417)), BGl_string3460z00zz__multimediazd2mpdzd2, BGl_string3298z00zz__multimediazd2mpdzd2, BgL_oz00_5168); 
FAILURE(BgL_auxz00_9509,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2findzd2artistzd2zz__multimediazd2mpdzd2(BgL_auxz00_9505, BgL_auxz00_9513, BgL_artistz00_5170);} } 

}



/* mpd-database-search-artist-album */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2searchzd2artistzd2albumz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_386, obj_t BgL_opz00_387, obj_t BgL_artistz00_388, obj_t BgL_albumz00_389)
{
{ /* Llib/mpd.scm 1312 */
{ /* Llib/mpd.scm 1312 */
obj_t BgL_method1372z00_2395;
{ /* Llib/mpd.scm 1312 */
obj_t BgL_res3112z00_4236;
{ /* Llib/mpd.scm 1312 */
long BgL_objzd2classzd2numz00_4201;
{ /* Llib/mpd.scm 1312 */
long BgL_res3102z00_4204;
BgL_res3102z00_4204 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_386)); 
BgL_objzd2classzd2numz00_4201 = BgL_res3102z00_4204; } 
{ /* Llib/mpd.scm 1312 */
obj_t BgL_arg1718z00_4202;
BgL_arg1718z00_4202 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2searchzd2artistzd2albumzd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1312 */
int BgL_offsetz00_4206;
BgL_offsetz00_4206 = 
(int)(BgL_objzd2classzd2numz00_4201); 
{ /* Llib/mpd.scm 1312 */
long BgL_offsetz00_4207;
BgL_offsetz00_4207 = 
(
(long)(BgL_offsetz00_4206)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1312 */
long BgL_modz00_4208;
BgL_modz00_4208 = 
(BgL_offsetz00_4207 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1312 */
long BgL_restz00_4210;
BgL_restz00_4210 = 
(BgL_offsetz00_4207 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1312 */

{ /* Llib/mpd.scm 1312 */
obj_t BgL_bucketz00_4212;
BgL_bucketz00_4212 = 
VECTOR_REF(
((obj_t)BgL_arg1718z00_4202),BgL_modz00_4208); 
BgL_res3112z00_4236 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4212),BgL_restz00_4210); } } } } } } } } 
BgL_method1372z00_2395 = BgL_res3112z00_4236; } 
return 
PROCEDURE_ENTRY(BgL_method1372z00_2395)(BgL_method1372z00_2395, 
((obj_t)BgL_oz00_386), BgL_opz00_387, BgL_artistz00_388, BgL_albumz00_389, BEOA);} } 

}



/* &mpd-database-search-artist-album */
obj_t BGl_z62mpdzd2databasezd2searchzd2artistzd2albumz62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5171, obj_t BgL_oz00_5172, obj_t BgL_opz00_5173, obj_t BgL_artistz00_5174, obj_t BgL_albumz00_5175)
{
{ /* Llib/mpd.scm 1312 */
{ /* Llib/mpd.scm 1312 */
obj_t BgL_auxz00_9562;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9554;
if(
OUTPUT_PORTP(BgL_opz00_5173))
{ /* Llib/mpd.scm 1312 */
BgL_auxz00_9562 = BgL_opz00_5173
; }  else 
{ 
obj_t BgL_auxz00_9565;
BgL_auxz00_9565 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3292z00zz__multimediazd2mpdzd2, 
BINT(((long)51861)), BGl_string3461z00zz__multimediazd2mpdzd2, BGl_string3297z00zz__multimediazd2mpdzd2, BgL_opz00_5173); 
FAILURE(BgL_auxz00_9565,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5172, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1312 */
BgL_auxz00_9554 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5172)
; }  else 
{ 
obj_t BgL_auxz00_9558;
BgL_auxz00_9558 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3292z00zz__multimediazd2mpdzd2, 
BINT(((long)51861)), BGl_string3461z00zz__multimediazd2mpdzd2, BGl_string3298z00zz__multimediazd2mpdzd2, BgL_oz00_5172); 
FAILURE(BgL_auxz00_9558,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2searchzd2artistzd2albumz00zz__multimediazd2mpdzd2(BgL_auxz00_9554, BgL_auxz00_9562, BgL_artistz00_5174, BgL_albumz00_5175);} } 

}



/* mpd-database-search-artist-title */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2searchzd2artistzd2titlez00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_390, obj_t BgL_opz00_391, obj_t BgL_artistz00_392, obj_t BgL_titlez00_393)
{
{ /* Llib/mpd.scm 1345 */
{ /* Llib/mpd.scm 1345 */
obj_t BgL_method1374z00_2396;
{ /* Llib/mpd.scm 1345 */
obj_t BgL_res3123z00_4273;
{ /* Llib/mpd.scm 1345 */
long BgL_objzd2classzd2numz00_4238;
{ /* Llib/mpd.scm 1345 */
long BgL_res3113z00_4241;
BgL_res3113z00_4241 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_390)); 
BgL_objzd2classzd2numz00_4238 = BgL_res3113z00_4241; } 
{ /* Llib/mpd.scm 1345 */
obj_t BgL_arg1718z00_4239;
BgL_arg1718z00_4239 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2searchzd2artistzd2titlezd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1345 */
int BgL_offsetz00_4243;
BgL_offsetz00_4243 = 
(int)(BgL_objzd2classzd2numz00_4238); 
{ /* Llib/mpd.scm 1345 */
long BgL_offsetz00_4244;
BgL_offsetz00_4244 = 
(
(long)(BgL_offsetz00_4243)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1345 */
long BgL_modz00_4245;
BgL_modz00_4245 = 
(BgL_offsetz00_4244 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1345 */
long BgL_restz00_4247;
BgL_restz00_4247 = 
(BgL_offsetz00_4244 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1345 */

{ /* Llib/mpd.scm 1345 */
obj_t BgL_bucketz00_4249;
BgL_bucketz00_4249 = 
VECTOR_REF(
((obj_t)BgL_arg1718z00_4239),BgL_modz00_4245); 
BgL_res3123z00_4273 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4249),BgL_restz00_4247); } } } } } } } } 
BgL_method1374z00_2396 = BgL_res3123z00_4273; } 
return 
PROCEDURE_ENTRY(BgL_method1374z00_2396)(BgL_method1374z00_2396, 
((obj_t)BgL_oz00_390), BgL_opz00_391, BgL_artistz00_392, BgL_titlez00_393, BEOA);} } 

}



/* &mpd-database-search-artist-title */
obj_t BGl_z62mpdzd2databasezd2searchzd2artistzd2titlez62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5176, obj_t BgL_oz00_5177, obj_t BgL_opz00_5178, obj_t BgL_artistz00_5179, obj_t BgL_titlez00_5180)
{
{ /* Llib/mpd.scm 1345 */
{ /* Llib/mpd.scm 1345 */
obj_t BgL_auxz00_9611;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9603;
if(
OUTPUT_PORTP(BgL_opz00_5178))
{ /* Llib/mpd.scm 1345 */
BgL_auxz00_9611 = BgL_opz00_5178
; }  else 
{ 
obj_t BgL_auxz00_9614;
BgL_auxz00_9614 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3292z00zz__multimediazd2mpdzd2, 
BINT(((long)53036)), BGl_string3462z00zz__multimediazd2mpdzd2, BGl_string3297z00zz__multimediazd2mpdzd2, BgL_opz00_5178); 
FAILURE(BgL_auxz00_9614,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5177, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1345 */
BgL_auxz00_9603 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5177)
; }  else 
{ 
obj_t BgL_auxz00_9607;
BgL_auxz00_9607 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3292z00zz__multimediazd2mpdzd2, 
BINT(((long)53036)), BGl_string3462z00zz__multimediazd2mpdzd2, BGl_string3298z00zz__multimediazd2mpdzd2, BgL_oz00_5177); 
FAILURE(BgL_auxz00_9607,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2searchzd2artistzd2titlez00zz__multimediazd2mpdzd2(BgL_auxz00_9603, BgL_auxz00_9611, BgL_artistz00_5179, BgL_titlez00_5180);} } 

}



/* mpd-database-find-title */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2findzd2titlezd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_394, obj_t BgL_opz00_395, obj_t BgL_titlez00_396)
{
{ /* Llib/mpd.scm 1371 */
{ /* Llib/mpd.scm 1371 */
obj_t BgL_method1376z00_2397;
{ /* Llib/mpd.scm 1371 */
obj_t BgL_res3134z00_4310;
{ /* Llib/mpd.scm 1371 */
long BgL_objzd2classzd2numz00_4275;
{ /* Llib/mpd.scm 1371 */
long BgL_res3124z00_4278;
BgL_res3124z00_4278 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_394)); 
BgL_objzd2classzd2numz00_4275 = BgL_res3124z00_4278; } 
{ /* Llib/mpd.scm 1371 */
obj_t BgL_arg1718z00_4276;
BgL_arg1718z00_4276 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2findzd2titlezd2envz00zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1371 */
int BgL_offsetz00_4280;
BgL_offsetz00_4280 = 
(int)(BgL_objzd2classzd2numz00_4275); 
{ /* Llib/mpd.scm 1371 */
long BgL_offsetz00_4281;
BgL_offsetz00_4281 = 
(
(long)(BgL_offsetz00_4280)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1371 */
long BgL_modz00_4282;
BgL_modz00_4282 = 
(BgL_offsetz00_4281 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1371 */
long BgL_restz00_4284;
BgL_restz00_4284 = 
(BgL_offsetz00_4281 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1371 */

{ /* Llib/mpd.scm 1371 */
obj_t BgL_bucketz00_4286;
BgL_bucketz00_4286 = 
VECTOR_REF(
((obj_t)BgL_arg1718z00_4276),BgL_modz00_4282); 
BgL_res3134z00_4310 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4286),BgL_restz00_4284); } } } } } } } } 
BgL_method1376z00_2397 = BgL_res3134z00_4310; } 
return 
PROCEDURE_ENTRY(BgL_method1376z00_2397)(BgL_method1376z00_2397, 
((obj_t)BgL_oz00_394), BgL_opz00_395, BgL_titlez00_396, BEOA);} } 

}



/* &mpd-database-find-title */
obj_t BGl_z62mpdzd2databasezd2findzd2titlezb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_5181, obj_t BgL_oz00_5182, obj_t BgL_opz00_5183, obj_t BgL_titlez00_5184)
{
{ /* Llib/mpd.scm 1371 */
{ /* Llib/mpd.scm 1371 */
obj_t BgL_auxz00_9659;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9651;
if(
OUTPUT_PORTP(BgL_opz00_5183))
{ /* Llib/mpd.scm 1371 */
BgL_auxz00_9659 = BgL_opz00_5183
; }  else 
{ 
obj_t BgL_auxz00_9662;
BgL_auxz00_9662 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3292z00zz__multimediazd2mpdzd2, 
BINT(((long)53940)), BGl_string3463z00zz__multimediazd2mpdzd2, BGl_string3297z00zz__multimediazd2mpdzd2, BgL_opz00_5183); 
FAILURE(BgL_auxz00_9662,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5182, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1371 */
BgL_auxz00_9651 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5182)
; }  else 
{ 
obj_t BgL_auxz00_9655;
BgL_auxz00_9655 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3292z00zz__multimediazd2mpdzd2, 
BINT(((long)53940)), BGl_string3463z00zz__multimediazd2mpdzd2, BGl_string3298z00zz__multimediazd2mpdzd2, BgL_oz00_5182); 
FAILURE(BgL_auxz00_9655,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2findzd2titlezd2zz__multimediazd2mpdzd2(BgL_auxz00_9651, BgL_auxz00_9659, BgL_titlez00_5184);} } 

}



/* mpd-database-find-genre */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2findzd2genrezd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_397, obj_t BgL_opz00_398, obj_t BgL_genrez00_399)
{
{ /* Llib/mpd.scm 1389 */
{ /* Llib/mpd.scm 1389 */
obj_t BgL_method1378z00_2398;
{ /* Llib/mpd.scm 1389 */
obj_t BgL_res3145z00_4347;
{ /* Llib/mpd.scm 1389 */
long BgL_objzd2classzd2numz00_4312;
{ /* Llib/mpd.scm 1389 */
long BgL_res3135z00_4315;
BgL_res3135z00_4315 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_397)); 
BgL_objzd2classzd2numz00_4312 = BgL_res3135z00_4315; } 
{ /* Llib/mpd.scm 1389 */
obj_t BgL_arg1718z00_4313;
BgL_arg1718z00_4313 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2findzd2genrezd2envz00zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1389 */
int BgL_offsetz00_4317;
BgL_offsetz00_4317 = 
(int)(BgL_objzd2classzd2numz00_4312); 
{ /* Llib/mpd.scm 1389 */
long BgL_offsetz00_4318;
BgL_offsetz00_4318 = 
(
(long)(BgL_offsetz00_4317)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1389 */
long BgL_modz00_4319;
BgL_modz00_4319 = 
(BgL_offsetz00_4318 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1389 */
long BgL_restz00_4321;
BgL_restz00_4321 = 
(BgL_offsetz00_4318 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1389 */

{ /* Llib/mpd.scm 1389 */
obj_t BgL_bucketz00_4323;
BgL_bucketz00_4323 = 
VECTOR_REF(
((obj_t)BgL_arg1718z00_4313),BgL_modz00_4319); 
BgL_res3145z00_4347 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4323),BgL_restz00_4321); } } } } } } } } 
BgL_method1378z00_2398 = BgL_res3145z00_4347; } 
return 
PROCEDURE_ENTRY(BgL_method1378z00_2398)(BgL_method1378z00_2398, 
((obj_t)BgL_oz00_397), BgL_opz00_398, BgL_genrez00_399, BEOA);} } 

}



/* &mpd-database-find-genre */
obj_t BGl_z62mpdzd2databasezd2findzd2genrezb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_5185, obj_t BgL_oz00_5186, obj_t BgL_opz00_5187, obj_t BgL_genrez00_5188)
{
{ /* Llib/mpd.scm 1389 */
{ /* Llib/mpd.scm 1389 */
obj_t BgL_auxz00_9707;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9699;
if(
OUTPUT_PORTP(BgL_opz00_5187))
{ /* Llib/mpd.scm 1389 */
BgL_auxz00_9707 = BgL_opz00_5187
; }  else 
{ 
obj_t BgL_auxz00_9710;
BgL_auxz00_9710 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3292z00zz__multimediazd2mpdzd2, 
BINT(((long)54520)), BGl_string3464z00zz__multimediazd2mpdzd2, BGl_string3297z00zz__multimediazd2mpdzd2, BgL_opz00_5187); 
FAILURE(BgL_auxz00_9710,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5186, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1389 */
BgL_auxz00_9699 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5186)
; }  else 
{ 
obj_t BgL_auxz00_9703;
BgL_auxz00_9703 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3292z00zz__multimediazd2mpdzd2, 
BINT(((long)54520)), BGl_string3464z00zz__multimediazd2mpdzd2, BGl_string3298z00zz__multimediazd2mpdzd2, BgL_oz00_5186); 
FAILURE(BgL_auxz00_9703,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2findzd2genrezd2zz__multimediazd2mpdzd2(BgL_auxz00_9699, BgL_auxz00_9707, BgL_genrez00_5188);} } 

}



/* mpd-database-getgenre */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2getgenrez00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_400)
{
{ /* Llib/mpd.scm 1407 */
{ /* Llib/mpd.scm 1407 */
obj_t BgL_method1380z00_2399;
{ /* Llib/mpd.scm 1407 */
obj_t BgL_res3156z00_4384;
{ /* Llib/mpd.scm 1407 */
long BgL_objzd2classzd2numz00_4349;
{ /* Llib/mpd.scm 1407 */
long BgL_res3146z00_4352;
BgL_res3146z00_4352 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_400)); 
BgL_objzd2classzd2numz00_4349 = BgL_res3146z00_4352; } 
{ /* Llib/mpd.scm 1407 */
obj_t BgL_arg1718z00_4350;
BgL_arg1718z00_4350 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2getgenrezd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1407 */
int BgL_offsetz00_4354;
BgL_offsetz00_4354 = 
(int)(BgL_objzd2classzd2numz00_4349); 
{ /* Llib/mpd.scm 1407 */
long BgL_offsetz00_4355;
BgL_offsetz00_4355 = 
(
(long)(BgL_offsetz00_4354)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1407 */
long BgL_modz00_4356;
BgL_modz00_4356 = 
(BgL_offsetz00_4355 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1407 */
long BgL_restz00_4358;
BgL_restz00_4358 = 
(BgL_offsetz00_4355 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1407 */

{ /* Llib/mpd.scm 1407 */
obj_t BgL_bucketz00_4360;
BgL_bucketz00_4360 = 
VECTOR_REF(
((obj_t)BgL_arg1718z00_4350),BgL_modz00_4356); 
BgL_res3156z00_4384 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4360),BgL_restz00_4358); } } } } } } } } 
BgL_method1380z00_2399 = BgL_res3156z00_4384; } 
return 
PROCEDURE_ENTRY(BgL_method1380z00_2399)(BgL_method1380z00_2399, 
((obj_t)BgL_oz00_400), BEOA);} } 

}



/* &mpd-database-getgenre */
obj_t BGl_z62mpdzd2databasezd2getgenrez62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5189, obj_t BgL_oz00_5190)
{
{ /* Llib/mpd.scm 1407 */
{ /* Llib/mpd.scm 1407 */
BgL_mpdzd2databasezd2_bglt BgL_auxz00_9745;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5190, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1407 */
BgL_auxz00_9745 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5190)
; }  else 
{ 
obj_t BgL_auxz00_9749;
BgL_auxz00_9749 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3292z00zz__multimediazd2mpdzd2, 
BINT(((long)55101)), BGl_string3465z00zz__multimediazd2mpdzd2, BGl_string3298z00zz__multimediazd2mpdzd2, BgL_oz00_5190); 
FAILURE(BgL_auxz00_9749,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2getgenrez00zz__multimediazd2mpdzd2(BgL_auxz00_9745);} } 

}



/* mpd-database-getartist */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2getartistz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_401)
{
{ /* Llib/mpd.scm 1414 */
{ /* Llib/mpd.scm 1414 */
obj_t BgL_method1382z00_2400;
{ /* Llib/mpd.scm 1414 */
obj_t BgL_res3167z00_4421;
{ /* Llib/mpd.scm 1414 */
long BgL_objzd2classzd2numz00_4386;
{ /* Llib/mpd.scm 1414 */
long BgL_res3157z00_4389;
BgL_res3157z00_4389 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_401)); 
BgL_objzd2classzd2numz00_4386 = BgL_res3157z00_4389; } 
{ /* Llib/mpd.scm 1414 */
obj_t BgL_arg1718z00_4387;
BgL_arg1718z00_4387 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2getartistzd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1414 */
int BgL_offsetz00_4391;
BgL_offsetz00_4391 = 
(int)(BgL_objzd2classzd2numz00_4386); 
{ /* Llib/mpd.scm 1414 */
long BgL_offsetz00_4392;
BgL_offsetz00_4392 = 
(
(long)(BgL_offsetz00_4391)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1414 */
long BgL_modz00_4393;
BgL_modz00_4393 = 
(BgL_offsetz00_4392 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1414 */
long BgL_restz00_4395;
BgL_restz00_4395 = 
(BgL_offsetz00_4392 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1414 */

{ /* Llib/mpd.scm 1414 */
obj_t BgL_bucketz00_4397;
BgL_bucketz00_4397 = 
VECTOR_REF(
((obj_t)BgL_arg1718z00_4387),BgL_modz00_4393); 
BgL_res3167z00_4421 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4397),BgL_restz00_4395); } } } } } } } } 
BgL_method1382z00_2400 = BgL_res3167z00_4421; } 
return 
PROCEDURE_ENTRY(BgL_method1382z00_2400)(BgL_method1382z00_2400, 
((obj_t)BgL_oz00_401), BEOA);} } 

}



/* &mpd-database-getartist */
obj_t BGl_z62mpdzd2databasezd2getartistz62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5191, obj_t BgL_oz00_5192)
{
{ /* Llib/mpd.scm 1414 */
{ /* Llib/mpd.scm 1414 */
BgL_mpdzd2databasezd2_bglt BgL_auxz00_9784;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5192, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1414 */
BgL_auxz00_9784 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5192)
; }  else 
{ 
obj_t BgL_auxz00_9788;
BgL_auxz00_9788 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3292z00zz__multimediazd2mpdzd2, 
BINT(((long)55438)), BGl_string3466z00zz__multimediazd2mpdzd2, BGl_string3298z00zz__multimediazd2mpdzd2, BgL_oz00_5192); 
FAILURE(BgL_auxz00_9788,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2getartistz00zz__multimediazd2mpdzd2(BgL_auxz00_9784);} } 

}



/* mpd-database-getgenreartist */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2getgenreartistz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_402, obj_t BgL_genrez00_403)
{
{ /* Llib/mpd.scm 1421 */
{ /* Llib/mpd.scm 1421 */
obj_t BgL_method1384z00_2401;
{ /* Llib/mpd.scm 1421 */
obj_t BgL_res3178z00_4458;
{ /* Llib/mpd.scm 1421 */
long BgL_objzd2classzd2numz00_4423;
{ /* Llib/mpd.scm 1421 */
long BgL_res3168z00_4426;
BgL_res3168z00_4426 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_402)); 
BgL_objzd2classzd2numz00_4423 = BgL_res3168z00_4426; } 
{ /* Llib/mpd.scm 1421 */
obj_t BgL_arg1718z00_4424;
BgL_arg1718z00_4424 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2getgenreartistzd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1421 */
int BgL_offsetz00_4428;
BgL_offsetz00_4428 = 
(int)(BgL_objzd2classzd2numz00_4423); 
{ /* Llib/mpd.scm 1421 */
long BgL_offsetz00_4429;
BgL_offsetz00_4429 = 
(
(long)(BgL_offsetz00_4428)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1421 */
long BgL_modz00_4430;
BgL_modz00_4430 = 
(BgL_offsetz00_4429 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1421 */
long BgL_restz00_4432;
BgL_restz00_4432 = 
(BgL_offsetz00_4429 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1421 */

{ /* Llib/mpd.scm 1421 */
obj_t BgL_bucketz00_4434;
BgL_bucketz00_4434 = 
VECTOR_REF(
((obj_t)BgL_arg1718z00_4424),BgL_modz00_4430); 
BgL_res3178z00_4458 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4434),BgL_restz00_4432); } } } } } } } } 
BgL_method1384z00_2401 = BgL_res3178z00_4458; } 
return 
PROCEDURE_ENTRY(BgL_method1384z00_2401)(BgL_method1384z00_2401, 
((obj_t)BgL_oz00_402), BgL_genrez00_403, BEOA);} } 

}



/* &mpd-database-getgenreartist */
obj_t BGl_z62mpdzd2databasezd2getgenreartistz62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5193, obj_t BgL_oz00_5194, obj_t BgL_genrez00_5195)
{
{ /* Llib/mpd.scm 1421 */
{ /* Llib/mpd.scm 1421 */
BgL_mpdzd2databasezd2_bglt BgL_auxz00_9824;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5194, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1421 */
BgL_auxz00_9824 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5194)
; }  else 
{ 
obj_t BgL_auxz00_9828;
BgL_auxz00_9828 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3292z00zz__multimediazd2mpdzd2, 
BINT(((long)55778)), BGl_string3467z00zz__multimediazd2mpdzd2, BGl_string3298z00zz__multimediazd2mpdzd2, BgL_oz00_5194); 
FAILURE(BgL_auxz00_9828,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2getgenreartistz00zz__multimediazd2mpdzd2(BgL_auxz00_9824, BgL_genrez00_5195);} } 

}



/* mpd-database-getartistalbum */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2getartistalbumz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_404, obj_t BgL_artistz00_405)
{
{ /* Llib/mpd.scm 1431 */
{ /* Llib/mpd.scm 1431 */
obj_t BgL_method1386z00_2402;
{ /* Llib/mpd.scm 1431 */
obj_t BgL_res3189z00_4495;
{ /* Llib/mpd.scm 1431 */
long BgL_objzd2classzd2numz00_4460;
{ /* Llib/mpd.scm 1431 */
long BgL_res3179z00_4463;
BgL_res3179z00_4463 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_404)); 
BgL_objzd2classzd2numz00_4460 = BgL_res3179z00_4463; } 
{ /* Llib/mpd.scm 1431 */
obj_t BgL_arg1718z00_4461;
BgL_arg1718z00_4461 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2getartistalbumzd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1431 */
int BgL_offsetz00_4465;
BgL_offsetz00_4465 = 
(int)(BgL_objzd2classzd2numz00_4460); 
{ /* Llib/mpd.scm 1431 */
long BgL_offsetz00_4466;
BgL_offsetz00_4466 = 
(
(long)(BgL_offsetz00_4465)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1431 */
long BgL_modz00_4467;
BgL_modz00_4467 = 
(BgL_offsetz00_4466 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1431 */
long BgL_restz00_4469;
BgL_restz00_4469 = 
(BgL_offsetz00_4466 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1431 */

{ /* Llib/mpd.scm 1431 */
obj_t BgL_bucketz00_4471;
BgL_bucketz00_4471 = 
VECTOR_REF(
((obj_t)BgL_arg1718z00_4461),BgL_modz00_4467); 
BgL_res3189z00_4495 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4471),BgL_restz00_4469); } } } } } } } } 
BgL_method1386z00_2402 = BgL_res3189z00_4495; } 
return 
PROCEDURE_ENTRY(BgL_method1386z00_2402)(BgL_method1386z00_2402, 
((obj_t)BgL_oz00_404), BgL_artistz00_405, BEOA);} } 

}



/* &mpd-database-getartistalbum */
obj_t BGl_z62mpdzd2databasezd2getartistalbumz62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5196, obj_t BgL_oz00_5197, obj_t BgL_artistz00_5198)
{
{ /* Llib/mpd.scm 1431 */
{ /* Llib/mpd.scm 1431 */
BgL_mpdzd2databasezd2_bglt BgL_auxz00_9864;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5197, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1431 */
BgL_auxz00_9864 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5197)
; }  else 
{ 
obj_t BgL_auxz00_9868;
BgL_auxz00_9868 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3292z00zz__multimediazd2mpdzd2, 
BINT(((long)56226)), BGl_string3468z00zz__multimediazd2mpdzd2, BGl_string3298z00zz__multimediazd2mpdzd2, BgL_oz00_5197); 
FAILURE(BgL_auxz00_9868,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2getartistalbumz00zz__multimediazd2mpdzd2(BgL_auxz00_9864, BgL_artistz00_5198);} } 

}



/* mpd-database-get-album */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2getzd2albumzd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_417, obj_t BgL_albumz00_418)
{
{ /* Llib/mpd.scm 1517 */
{ /* Llib/mpd.scm 1517 */
obj_t BgL_method1390z00_2403;
{ /* Llib/mpd.scm 1517 */
obj_t BgL_res3200z00_4532;
{ /* Llib/mpd.scm 1517 */
long BgL_objzd2classzd2numz00_4497;
{ /* Llib/mpd.scm 1517 */
long BgL_res3190z00_4500;
BgL_res3190z00_4500 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_417)); 
BgL_objzd2classzd2numz00_4497 = BgL_res3190z00_4500; } 
{ /* Llib/mpd.scm 1517 */
obj_t BgL_arg1718z00_4498;
BgL_arg1718z00_4498 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2getzd2albumzd2envz00zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1517 */
int BgL_offsetz00_4502;
BgL_offsetz00_4502 = 
(int)(BgL_objzd2classzd2numz00_4497); 
{ /* Llib/mpd.scm 1517 */
long BgL_offsetz00_4503;
BgL_offsetz00_4503 = 
(
(long)(BgL_offsetz00_4502)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1517 */
long BgL_modz00_4504;
BgL_modz00_4504 = 
(BgL_offsetz00_4503 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1517 */
long BgL_restz00_4506;
BgL_restz00_4506 = 
(BgL_offsetz00_4503 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1517 */

{ /* Llib/mpd.scm 1517 */
obj_t BgL_bucketz00_4508;
BgL_bucketz00_4508 = 
VECTOR_REF(
((obj_t)BgL_arg1718z00_4498),BgL_modz00_4504); 
BgL_res3200z00_4532 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4508),BgL_restz00_4506); } } } } } } } } 
BgL_method1390z00_2403 = BgL_res3200z00_4532; } 
return 
PROCEDURE_ENTRY(BgL_method1390z00_2403)(BgL_method1390z00_2403, 
((obj_t)BgL_oz00_417), BgL_albumz00_418, BEOA);} } 

}



/* &mpd-database-get-album */
obj_t BGl_z62mpdzd2databasezd2getzd2albumzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_5199, obj_t BgL_oz00_5200, obj_t BgL_albumz00_5201)
{
{ /* Llib/mpd.scm 1517 */
{ /* Llib/mpd.scm 1517 */
BgL_mpdzd2databasezd2_bglt BgL_auxz00_9904;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5200, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1517 */
BgL_auxz00_9904 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5200)
; }  else 
{ 
obj_t BgL_auxz00_9908;
BgL_auxz00_9908 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3292z00zz__multimediazd2mpdzd2, 
BINT(((long)59323)), BGl_string3469z00zz__multimediazd2mpdzd2, BGl_string3298z00zz__multimediazd2mpdzd2, BgL_oz00_5200); 
FAILURE(BgL_auxz00_9908,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2getzd2albumzd2zz__multimediazd2mpdzd2(BgL_auxz00_9904, BgL_albumz00_5201);} } 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__multimediazd2mpdzd2()
{
{ /* Llib/mpd.scm 15 */
return BUNSPEC;} 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__multimediazd2mpdzd2()
{
{ /* Llib/mpd.scm 15 */
BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(((long)95358739), 
BSTRING_TO_STRING(BGl_string3470z00zz__multimediazd2mpdzd2)); 
return 
BGl_modulezd2initializa7ationz75zz__multimediazd2id3zd2(((long)299260312), 
BSTRING_TO_STRING(BGl_string3470z00zz__multimediazd2mpdzd2));} 

}

#ifdef __cplusplus
}
#endif
