/*===========================================================================*/
/*   (Ast/sexp.scm)                                                          */
/*   Bigloo (4.3g)                                                           */
/*   Inria -- Sophia Antipolis (c)       Wed 12 Feb 2020 07:45:41 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.3g -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Ast/sexp.scm) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_backendz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_languagez00;
		obj_t BgL_srfi0z00;
		obj_t BgL_namez00;
		obj_t BgL_externzd2variableszd2;
		obj_t BgL_externzd2functionszd2;
		obj_t BgL_externzd2typeszd2;
		obj_t BgL_variablesz00;
		obj_t BgL_functionsz00;
		obj_t BgL_typesz00;
		bool_t BgL_typedz00;
		obj_t BgL_heapzd2suffixzd2;
		obj_t BgL_heapzd2compatiblezd2;
		bool_t BgL_callccz00;
		bool_t BgL_qualifiedzd2typeszd2;
		bool_t BgL_effectzb2zb2;
		bool_t BgL_removezd2emptyzd2letz00;
		bool_t BgL_foreignzd2closurezd2;
		bool_t BgL_typedzd2eqzd2;
		bool_t BgL_tracezd2supportzd2;
		obj_t BgL_foreignzd2clausezd2supportz00;
		obj_t BgL_debugzd2supportzd2;
		bool_t BgL_pragmazd2supportzd2;
		bool_t BgL_tvectorzd2descrzd2supportz00;
		bool_t BgL_requirezd2tailczd2;
		obj_t BgL_registersz00;
		obj_t BgL_pregistersz00;
		bool_t BgL_boundzd2checkzd2;
		bool_t BgL_typezd2checkzd2;
		bool_t BgL_typedzd2funcallzd2;
	}                 *BgL_backendz00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		bool_t BgL_evalzf3zf3;
		obj_t BgL_libraryz00;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
		obj_t BgL_initz00;
		obj_t BgL_aliasz00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_localz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		long BgL_keyz00;
	}               *BgL_localz00_bglt;

	typedef struct BgL_feffectz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_readz00;
		obj_t BgL_writez00;
	}                 *BgL_feffectz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_nodezf2effectzf2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
	}                       *BgL_nodezf2effectzf2_bglt;

	typedef struct BgL_atomz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}              *BgL_atomz00_bglt;

	typedef struct BgL_literalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}                 *BgL_literalz00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_closurez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}                 *BgL_closurez00_bglt;

	typedef struct BgL_kwotez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}               *BgL_kwotez00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
		bool_t BgL_unsafez00;
		obj_t BgL_metaz00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_externz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
	}                *BgL_externz00_bglt;

	typedef struct BgL_castz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}              *BgL_castz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_failz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_procz00;
		struct BgL_nodez00_bgl *BgL_msgz00;
		struct BgL_nodez00_bgl *BgL_objz00;
	}              *BgL_failz00_bglt;

	typedef struct BgL_switchz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_switchz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_jumpzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_exitz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                        *BgL_jumpzd2exzd2itz00_bglt;

	typedef struct BgL_syncz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_mutexz00;
		struct BgL_nodez00_bgl *BgL_prelockz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}              *BgL_syncz00_bglt;


	extern obj_t BGl_normaliza7ezd2prognz75zztools_prognz00(obj_t);
	BGL_IMPORT obj_t BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_stringzd2replacezd2zz__r4_strings_6_7z00(obj_t,
		unsigned char, unsigned char);
	extern obj_t BGl_closurez00zzast_nodez00;
	extern obj_t BGl_findzd2locationzf2locz20zztools_locationz00(obj_t, obj_t);
	BGL_IMPORT bool_t BGl_equalzf3zf3zz__r4_equivalence_6_2z00(obj_t, obj_t);
	extern obj_t BGl_syncz00zzast_nodez00;
	extern BgL_nodez00_bglt BGl_applicationzd2ze3nodez31zzast_appz00(obj_t, obj_t,
		obj_t, obj_t);
	extern BgL_nodez00_bglt BGl_applycationzd2ze3nodez31zzast_applyz00(obj_t,
		obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_ifzd2symzd2zzast_sexpz00();
	extern obj_t BGl_sequencez00zzast_nodez00;
	extern obj_t BGl_failz00zzast_nodez00;
	extern obj_t BGl_addzd2staticzd2pragmaz12z12zzast_pragmaz00(BgL_nodez00_bglt);
	static obj_t BGl_objectzd2initzd2zzast_sexpz00();
	extern obj_t BGl_privatezd2nodezd2zzast_privatez00(obj_t, obj_t, obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	BGL_IMPORT obj_t string_append_3(obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_stringzd2containszd2zz__r4_strings_6_7z00(obj_t, obj_t,
		int);
	extern obj_t BGl_castzd2sexpzd2typez00zzast_privatez00(obj_t);
	static BgL_nodez00_bglt
		BGl_z62definezd2primopzd2refzd2ze3nodez53zzast_sexpz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_za2magicza2z00zztype_cachez00;
	BGL_IMPORT obj_t bstring_to_symbol(obj_t);
	extern obj_t BGl_thezd2backendzd2zzbackend_backendz00();
	BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	extern obj_t BGl_letzd2symzf3z21zzast_letz00(obj_t);
	static obj_t BGl_methodzd2initzd2zzast_sexpz00();
	extern obj_t BGl_externz00zzast_nodez00;
	extern obj_t BGl_za2bdbzd2debugza2zd2zzengine_paramz00;
	extern obj_t BGl_za2compilerzd2debugza2zd2zzengine_paramz00;
	extern obj_t BGl_za2_za2z00zztype_cachez00;
	extern BgL_typez00_bglt
		BGl_strictzd2nodezd2typez00zzast_nodez00(BgL_typez00_bglt,
		BgL_typez00_bglt);
	extern obj_t BGl_za2objza2z00zztype_cachez00;
	BGL_IMPORT obj_t BGl_exceptionzd2notifyzd2zz__objectz00(obj_t);
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_locationzd2ze3nodez31zzast_sexpz00(BgL_globalz00_bglt);
	static BgL_nodez00_bglt BGl_variablezd2ze3nodez31zzast_sexpz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_cfunz00zzast_varz00;
	BGL_IMPORT obj_t BGl_unwindzd2untilz12zc0zz__bexitz00(obj_t, obj_t);
	extern BgL_nodez00_bglt BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00(bool_t,
		obj_t, BgL_typez00_bglt, obj_t, obj_t, obj_t, obj_t);
	BGL_IMPORT bool_t BGl_numberzf3zf3zz__r4_numbers_6_5z00(obj_t);
	extern BgL_jumpzd2exzd2itz00_bglt
		BGl_jumpzd2exitzd2ze3nodeze3zzast_exitz00(obj_t, obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_makezd2dssslzd2functionzd2preludezd2zz__dssslz00(obj_t,
		obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_findzd2localzd2zzast_sexpz00(obj_t, obj_t);
	BGL_IMPORT bool_t BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(obj_t);
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(obj_t, obj_t, obj_t);
	static obj_t BGl_gczd2rootszd2initz00zzast_sexpz00();
	extern obj_t BGl_parsezd2idzd2zzast_identz00(obj_t, obj_t);
	static obj_t BGl_za2sitesza2z00zzast_sexpz00 = BUNSPEC;
	static obj_t BGl_notzd2testzd2zzast_sexpz00(obj_t);
	static obj_t BGl_zc3z04exitza31507ze3ze70z60zzast_sexpz00(obj_t, obj_t);
	extern obj_t BGl_currentzd2functionzd2zztools_errorz00();
	static obj_t BGl_z62findzd2localzb0zzast_sexpz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_epairifyzd2reczd2zztools_miscz00(obj_t, obj_t);
	extern obj_t BGl_dssslzd2findzd2firstzd2formalzd2zztools_dssslz00(obj_t);
	BGL_IMPORT obj_t c_substring(obj_t, long, long);
	BGL_IMPORT obj_t BGl_gensymz00zz__r4_symbols_6_4z00(obj_t);
	BGL_EXPORTED_DECL obj_t BGl_sexpza2zd2ze3nodez93zzast_sexpz00(obj_t, obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_usezd2variablez12zc0zzast_sexpz00(BgL_variablez00_bglt, obj_t, obj_t);
	static obj_t BGl_za2ifza2z00zzast_sexpz00 = BUNSPEC;
	static BgL_nodez00_bglt BGl_callzd2ze3nodez31zzast_sexpz00(obj_t, obj_t,
		obj_t, obj_t);
	extern BgL_typez00_bglt BGl_usezd2typez12zc0zztype_envz00(obj_t, obj_t);
	static obj_t BGl_loopze70ze7zzast_sexpz00(obj_t, obj_t, obj_t, obj_t);
	extern bool_t BGl_bigloozd2typezf3z21zztype_typez00(BgL_typez00_bglt);
	static bool_t BGl_usedzd2inzf3z21zzast_sexpz00(obj_t, obj_t);
	extern obj_t BGl_conditionalz00zzast_nodez00;
	extern BgL_nodez00_bglt BGl_letrecza2zd2ze3nodez93zzast_letz00(obj_t, obj_t,
		obj_t, obj_t);
	BGL_IMPORT bool_t BGl_dssslzd2namedzd2constantzf3zf3zz__dssslz00(obj_t);
	BGL_IMPORT obj_t BGl_numberzd2ze3stringz31zz__r4_numbers_6_5z00(obj_t, obj_t);
	static BgL_nodez00_bglt BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
	extern obj_t BGl_setqz00zzast_nodez00;
	extern BgL_nodez00_bglt BGl_fieldzd2refzd2ze3nodeze3zzast_objectz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	extern obj_t BGl_locationzd2fullzd2fnamez00zztools_locationz00(obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzast_sexpz00 = BUNSPEC;
	static BgL_nodez00_bglt BGl_lambdazd2ze3nodez31zzast_sexpz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_makezd2typedzd2identz00zzast_identz00(obj_t, obj_t);
	extern obj_t BGl_userzd2errorzf2locationz20zztools_errorz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_funz00zzast_varz00;
	static bool_t BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(obj_t);
	static obj_t BGl_za2cachezd2nameza2zd2zzast_sexpz00 = BUNSPEC;
	static obj_t BGl_z62sexpza2zd2ze3nodezf1zzast_sexpz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_atomz00zzast_nodez00;
	static obj_t BGl_toplevelzd2initzd2zzast_sexpz00();
	extern obj_t BGl_epairifyz00zztools_miscz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
	static obj_t BGl_genericzd2initzd2zzast_sexpz00();
	BGL_IMPORT obj_t BGl_stringzd2copyzd2zz__r4_strings_6_7z00(obj_t);
	extern bool_t BGl_privatezd2sexpzf3z21zzast_privatez00(obj_t);
	extern obj_t BGl_castz00zzast_nodez00;
	extern obj_t BGl_shapez00zztools_shapez00(obj_t);
	extern obj_t BGl_labelszd2symzf3z21zzast_labelsz00(obj_t);
	extern obj_t BGl_labelszd2symzd2zzast_labelsz00();
	BGL_IMPORT obj_t bgl_reverse_bang(obj_t);
	static obj_t BGl_za2cachezd2resza2zd2zzast_sexpz00 = BUNSPEC;
	static BgL_nodez00_bglt
		BGl_z62definezd2primopzd2ze3nodez81zzast_sexpz00(obj_t, obj_t);
	static obj_t BGl_z62makezd2anonymouszd2namez62zzast_sexpz00(obj_t, obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t,
		obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62topzd2levelzd2sexpzd2ze3nodez53zzast_sexpz00(obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62locationzd2ze3nodez53zzast_sexpz00(obj_t,
		obj_t);
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00(obj_t, obj_t);
	extern obj_t BGl_findzd2globalzd2zzast_envz00(obj_t, obj_t);
	static obj_t BGl_z62ifzd2symzb0zzast_sexpz00(obj_t);
	BGL_IMPORT obj_t string_append(obj_t, obj_t);
	extern obj_t BGl_varz00zzast_nodez00;
	BGL_IMPORT bool_t bigloo_strncmp(obj_t, obj_t, long);
	static obj_t BGl_z62usezd2variablez12za2zzast_sexpz00(obj_t, obj_t, obj_t,
		obj_t);
	extern BgL_typez00_bglt BGl_getzd2typezd2atomz00zztype_typeofz00(obj_t);
	extern BgL_nodez00_bglt BGl_letzd2ze3nodez31zzast_letz00(obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_za2procedureza2z00zztype_cachez00;
	static obj_t BGl_z62zc3z04anonymousza31515ze3ze5zzast_sexpz00(obj_t, obj_t);
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_definezd2primopzd2ze3nodeze3zzast_sexpz00(BgL_globalz00_bglt);
	BGL_EXPORTED_DECL obj_t BGl_makezd2anonymouszd2namez00zzast_sexpz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza31516ze3ze5zzast_sexpz00(obj_t);
	static obj_t BGl_liipze70ze7zzast_sexpz00(obj_t);
	extern obj_t BGl_replacez12z12zztools_miscz00(obj_t, obj_t);
	extern BgL_letzd2funzd2_bglt BGl_setzd2exitzd2ze3nodeze3zzast_exitz00(obj_t,
		obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zzast_sexpz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzeffect_feffectz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_dumpz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_objectz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_privatez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_applyz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_appz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_exitz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_letz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_labelsz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_pragmaz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_buildz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_identz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_backendz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typeofz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzobject_classz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_miscz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_dssslz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_miscz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_locationz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_prognz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__srfi4z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__dssslz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__structurez00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
	extern obj_t BGl_appz00zzast_nodez00;
	extern bool_t BGl_globalzd2readzd2onlyzf3zf3zzast_varz00(BgL_globalz00_bglt);
	BGL_IMPORT obj_t BGl_stringzd2appendzd2zz__r4_strings_6_7z00(obj_t);
	extern bool_t BGl_castzd2sexpzf3z21zzast_privatez00(obj_t);
	extern obj_t BGl_nodez00zzast_nodez00;
	extern obj_t BGl_kwotez00zzast_nodez00;
	extern obj_t BGl_localz00zzast_varz00;
	static obj_t BGl_cnstzd2initzd2zzast_sexpz00();
	static obj_t BGl_libraryzd2moduleszd2initz00zzast_sexpz00();
	static obj_t BGl_importedzd2moduleszd2initz00zzast_sexpz00();
	extern obj_t BGl_findzd2globalzf2modulez20zzast_envz00(obj_t, obj_t);
	extern obj_t BGl_za2bnilza2z00zztype_cachez00;
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_definezd2primopzd2refzd2ze3nodez31zzast_sexpz00(BgL_globalz00_bglt,
		BgL_nodez00_bglt);
	extern obj_t BGl_letzd2symzd2zzast_letz00();
	BGL_EXPORTED_DECL BgL_nodez00_bglt BGl_sexpzd2ze3nodez31zzast_sexpz00(obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza36890ze3ze5zzast_sexpz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_za2unspecza2z00zztype_cachez00;
	static BgL_nodez00_bglt BGl_z62sexpzd2ze3nodez53zzast_sexpz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern BgL_letzd2funzd2_bglt BGl_labelszd2ze3nodez31zzast_labelsz00(obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_literalz00zzast_nodez00;
	extern obj_t BGl_switchz00zzast_nodez00;
	extern obj_t BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00(obj_t);
	static BgL_nodez00_bglt BGl_z62errorzd2sexpzd2ze3nodez81zzast_sexpz00(obj_t,
		obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_withzd2exceptionzd2handlerz00zz__errorz00(obj_t, obj_t);
	extern BgL_typez00_bglt BGl_getzd2typezd2kwotez00zztype_typeofz00(obj_t);
	extern BgL_nodez00_bglt BGl_fieldzd2setzd2ze3nodeze3zzast_objectz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t);
	extern obj_t BGl_globalz00zzast_varz00;
	extern BgL_feffectz00_bglt BGl_parsezd2effectzd2zzeffect_feffectz00(obj_t);
	static obj_t BGl_za2cachezd2stackza2zd2zzast_sexpz00 = BUNSPEC;
	static obj_t __cnst[47];


	   
		 
		DEFINE_STRING(BGl_string7988z00zzast_sexpz00,
		BgL_bgl_string7988za700za7za7a8026za7, "Illegal `application' form", 26);
	      DEFINE_STRING(BGl_string7989z00zzast_sexpz00,
		BgL_bgl_string7989za700za7za7a8027za7, "Illegal `case' form", 19);
	      DEFINE_STRING(BGl_string7990z00zzast_sexpz00,
		BgL_bgl_string7990za700za7za7a8028za7, "Illegal `failure' form", 22);
	      DEFINE_STRING(BGl_string7991z00zzast_sexpz00,
		BgL_bgl_string7991za700za7za7a8029za7, "Illegal `static-pragma' expression",
		34);
	      DEFINE_STRING(BGl_string7992z00zzast_sexpz00,
		BgL_bgl_string7992za700za7za7a8030za7, "anonymous", 9);
	      DEFINE_STRING(BGl_string7993z00zzast_sexpz00,
		BgL_bgl_string7993za700za7za7a8031za7, "Illegal `define' form", 21);
	      DEFINE_STRING(BGl_string7994z00zzast_sexpz00,
		BgL_bgl_string7994za700za7za7a8032za7, "illegal `define' expression", 27);
	      DEFINE_STRING(BGl_string7995z00zzast_sexpz00,
		BgL_bgl_string7995za700za7za7a8033za7, "Illegal `set!' form", 19);
	      DEFINE_STRING(BGl_string7996z00zzast_sexpz00,
		BgL_bgl_string7996za700za7za7a8034za7, "Read-only variable", 18);
	      DEFINE_STRING(BGl_string7997z00zzast_sexpz00,
		BgL_bgl_string7997za700za7za7a8035za7, "illegal `set!' expression", 25);
	      DEFINE_STRING(BGl_string7998z00zzast_sexpz00,
		BgL_bgl_string7998za700za7za7a8036za7, "Illegal ->", 10);
	      DEFINE_STRING(BGl_string7999z00zzast_sexpz00,
		BgL_bgl_string7999za700za7za7a8037za7, "Illegal `if' form", 17);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_definezd2primopzd2ze3nodezd2envz31zzast_sexpz00,
		BgL_bgl_za762defineza7d2prim8038z00,
		BGl_z62definezd2primopzd2ze3nodez81zzast_sexpz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_errorzd2sexpzd2ze3nodezd2envz31zzast_sexpz00,
		BgL_bgl_za762errorza7d2sexpza78039za7,
		BGl_z62errorzd2sexpzd2ze3nodez81zzast_sexpz00, 0L, BUNSPEC, 3);
	BGL_IMPORT obj_t BGl_expzd2envzd2zz__r4_numbers_6_5z00;
	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_makezd2anonymouszd2namezd2envzd2zzast_sexpz00,
		BgL_bgl_za762makeza7d2anonym8040z00, va_generic_entry,
		BGl_z62makezd2anonymouszd2namez62zzast_sexpz00, BUNSPEC, -2);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_findzd2localzd2envz00zzast_sexpz00,
		BgL_bgl_za762findza7d2localza78041za7, BGl_z62findzd2localzb0zzast_sexpz00,
		0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_locationzd2ze3nodezd2envze3zzast_sexpz00,
		BgL_bgl_za762locationza7d2za7e8042za7,
		BGl_z62locationzd2ze3nodez53zzast_sexpz00, 0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_sexpzd2ze3nodezd2envze3zzast_sexpz00,
		BgL_bgl_za762sexpza7d2za7e3nod8043za7,
		BGl_z62sexpzd2ze3nodez53zzast_sexpz00, 0L, BUNSPEC, 4);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_topzd2levelzd2sexpzd2ze3nodezd2envze3zzast_sexpz00,
		BgL_bgl_za762topza7d2levelza7d8044za7,
		BGl_z62topzd2levelzd2sexpzd2ze3nodez53zzast_sexpz00, 0L, BUNSPEC, 2);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_sexpza2zd2ze3nodezd2envz41zzast_sexpz00,
		BgL_bgl_za762sexpza7a2za7d2za7e38045z00,
		BGl_z62sexpza2zd2ze3nodezf1zzast_sexpz00, 0L, BUNSPEC, 4);
	      DEFINE_STRING(BGl_string8000z00zzast_sexpz00,
		BgL_bgl_string8000za700za7za7a8046za7, "Illegal `quote' expression", 26);
	      DEFINE_STRING(BGl_string8001z00zzast_sexpz00,
		BgL_bgl_string8001za700za7za7a8047za7, "Illegal `@' expression", 22);
	      DEFINE_STRING(BGl_string8002z00zzast_sexpz00,
		BgL_bgl_string8002za700za7za7a8048za7, "Unbound variable", 16);
	      DEFINE_STRING(BGl_string8003z00zzast_sexpz00,
		BgL_bgl_string8003za700za7za7a8049za7, "Illegal atom in s-expression", 28);
	      DEFINE_STRING(BGl_string8004z00zzast_sexpz00,
		BgL_bgl_string8004za700za7za7a8050za7, "Illegal `()' expression", 23);
	      DEFINE_STRING(BGl_string8005z00zzast_sexpz00,
		BgL_bgl_string8005za700za7za7a8051za7, "wrong number of argument", 24);
	      DEFINE_STRING(BGl_string8006z00zzast_sexpz00,
		BgL_bgl_string8006za700za7za7a8052za7, "Illegal formal argument", 23);
	      DEFINE_STRING(BGl_string8007z00zzast_sexpz00,
		BgL_bgl_string8007za700za7za7a8053za7, "Illegal `lambda' form", 21);
	      DEFINE_STRING(BGl_string8008z00zzast_sexpz00,
		BgL_bgl_string8008za700za7za7a8054za7,
		"Backend (~a) does not support external first class function", 59);
	      DEFINE_STRING(BGl_string8009z00zzast_sexpz00,
		BgL_bgl_string8009za700za7za7a8055za7, "Illegal pragma/effect", 21);
	      DEFINE_STRING(BGl_string8010z00zzast_sexpz00,
		BgL_bgl_string8010za700za7za7a8056za7, "Illegal free-pragma/effect", 26);
	      DEFINE_STRING(BGl_string8011z00zzast_sexpz00,
		BgL_bgl_string8011za700za7za7a8057za7, "Illegal lambda", 14);
	      DEFINE_STRING(BGl_string8012z00zzast_sexpz00,
		BgL_bgl_string8012za700za7za7a8058za7, "Illegal empty sequence", 22);
	      DEFINE_STRING(BGl_string8013z00zzast_sexpz00,
		BgL_bgl_string8013za700za7za7a8059za7, "Illegal mutation", 16);
	      DEFINE_STRING(BGl_string8014z00zzast_sexpz00,
		BgL_bgl_string8014za700za7za7a8060za7, "($1)", 4);
	      DEFINE_STRING(BGl_string8015z00zzast_sexpz00,
		BgL_bgl_string8015za700za7za7a8061za7, "<@", 2);
	      DEFINE_STRING(BGl_string8016z00zzast_sexpz00,
		BgL_bgl_string8016za700za7za7a8062za7, ":", 1);
	      DEFINE_STRING(BGl_string8017z00zzast_sexpz00,
		BgL_bgl_string8017za700za7za7a8063za7, "./", 2);
	      DEFINE_STRING(BGl_string8018z00zzast_sexpz00,
		BgL_bgl_string8018za700za7za7a8064za7, "@>", 2);
	      DEFINE_STRING(BGl_string8019z00zzast_sexpz00,
		BgL_bgl_string8019za700za7za7a8065za7, ">", 1);
	      DEFINE_STRING(BGl_string8020z00zzast_sexpz00,
		BgL_bgl_string8020za700za7za7a8066za7, "-", 1);
	      DEFINE_STRING(BGl_string8021z00zzast_sexpz00,
		BgL_bgl_string8021za700za7za7a8067za7, "ast_sexp", 8);
	      DEFINE_STRING(BGl_string8022z00zzast_sexpz00,
		BgL_bgl_string8022za700za7za7a8068za7,
		"not mutex @> bdb anonymous location pragma::obj (@ __evmeaning_address foreign) (@ define-primop! __evenv) (@ define-primop-ref! __evenv) write car exp app cons :prelock apply synchronize jump-exit set-exit case failure free-pragma/effect static-pragma free-pragma pragma/effect letrec* labels letrec let define begin -> __r4_control_features_6_9 quote @ eval bool test set! pragma else (quote ()) lambda value if (value apply app set! test) ",
		442);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_ifzd2symzd2envz00zzast_sexpz00,
		BgL_bgl_za762ifza7d2symza7b0za7za78069za7, BGl_z62ifzd2symzb0zzast_sexpz00,
		0L, BUNSPEC, 0);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_usezd2variablez12zd2envz12zzast_sexpz00,
		BgL_bgl_za762useza7d2variabl8070z00,
		BGl_z62usezd2variablez12za2zzast_sexpz00, 0L, BUNSPEC, 3);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_definezd2primopzd2refzd2ze3nodezd2envze3zzast_sexpz00,
		BgL_bgl_za762defineza7d2prim8071z00,
		BGl_z62definezd2primopzd2refzd2ze3nodez53zzast_sexpz00, 0L, BUNSPEC, 2);

/* GC roots registration */
	static obj_t bgl_gc_roots_register()
	{
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
		void *roots_min = (void *) ULONG_MAX, *roots_max = 0;
		     ADD_ROOT((void *) (&BGl_za2sitesza2z00zzast_sexpz00));
		     ADD_ROOT((void *) (&BGl_za2ifza2z00zzast_sexpz00));
		     ADD_ROOT((void *) (&BGl_requirezd2initializa7ationz75zzast_sexpz00));
		     ADD_ROOT((void *) (&BGl_za2cachezd2nameza2zd2zzast_sexpz00));
		     ADD_ROOT((void *) (&BGl_za2cachezd2resza2zd2zzast_sexpz00));
		     ADD_ROOT((void *) (&BGl_za2cachezd2stackza2zd2zzast_sexpz00));
#undef ADD_ROOT
		if   (roots_max > 0)
			     GC_add_roots(roots_min, ((void **) roots_max) + 1);
#endif
		     return BUNSPEC;
	}



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzast_sexpz00(long
		BgL_checksumz00_13809, char *BgL_fromz00_13810)
	{
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzast_sexpz00))
				{
					BGl_requirezd2initializa7ationz75zzast_sexpz00 = BBOOL(((bool_t) 0));
					BGl_gczd2rootszd2initz00zzast_sexpz00();
					BGl_libraryzd2moduleszd2initz00zzast_sexpz00();
					BGl_cnstzd2initzd2zzast_sexpz00();
					BGl_importedzd2moduleszd2initz00zzast_sexpz00();
					return BGl_toplevelzd2initzd2zzast_sexpz00();
				}
			else
				{
					return BUNSPEC;
				}
		}

	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzast_sexpz00()
	{
		{	/* Ast/sexp.scm 14 */
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__bexitz00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__dssslz00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__srfi4z00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__structurez00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__biglooz00(((long) 0), "ast_sexp");
			return BUNSPEC;
		}

	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzast_sexpz00()
	{
		{	/* Ast/sexp.scm 14 */
			{	/* Ast/sexp.scm 14 */
				obj_t BgL_cportz00_13796;

				{	/* Ast/sexp.scm 14 */
					obj_t BgL_stringz00_13804;

					BgL_stringz00_13804 = BGl_string8022z00zzast_sexpz00;
					{	/* Ast/sexp.scm 14 */
						obj_t BgL_startz00_13805;

						BgL_startz00_13805 = BINT(((long) 0));
						{	/* Ast/sexp.scm 14 */
							obj_t BgL_endz00_13806;

							BgL_endz00_13806 =
								BINT(STRING_LENGTH(((obj_t) BgL_stringz00_13804)));
							{	/* Ast/sexp.scm 14 */

								BgL_cportz00_13796 =
									BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00
									(BgL_stringz00_13804, BgL_startz00_13805, BgL_endz00_13806);
				}}}}
				{
					long BgL_iz00_13797;

					BgL_iz00_13797 = ((long) 46);
				BgL_loopz00_13798:
					if ((BgL_iz00_13797 == ((long) -1)))
						{	/* Ast/sexp.scm 14 */
							return BUNSPEC;
						}
					else
						{	/* Ast/sexp.scm 14 */
							{	/* Ast/sexp.scm 14 */
								obj_t BgL_arg8024z00_13800;

								{	/* Ast/sexp.scm 14 */

									{	/* Ast/sexp.scm 14 */
										obj_t BgL_locationz00_13802;

										BgL_locationz00_13802 = BBOOL(((bool_t) 0));
										{	/* Ast/sexp.scm 14 */

											BgL_arg8024z00_13800 =
												BGl_readz00zz__readerz00(BgL_cportz00_13796,
												BgL_locationz00_13802);
										}
									}
								}
								{	/* Ast/sexp.scm 14 */
									int BgL_tmpz00_13848;

									BgL_tmpz00_13848 = (int) (BgL_iz00_13797);
									CNST_TABLE_SET(BgL_tmpz00_13848, BgL_arg8024z00_13800);
							}}
							{	/* Ast/sexp.scm 14 */
								int BgL_auxz00_13803;

								BgL_auxz00_13803 = (int) ((BgL_iz00_13797 - ((long) 1)));
								{
									long BgL_iz00_13853;

									BgL_iz00_13853 = (long) (BgL_auxz00_13803);
									BgL_iz00_13797 = BgL_iz00_13853;
									goto BgL_loopz00_13798;
								}
							}
						}
				}
			}
		}

	}



/* gc-roots-init */
	obj_t BGl_gczd2rootszd2initz00zzast_sexpz00()
	{
		{	/* Ast/sexp.scm 14 */
			return bgl_gc_roots_register();
		}

	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzast_sexpz00()
	{
		{	/* Ast/sexp.scm 14 */
			BGl_za2sitesza2z00zzast_sexpz00 = CNST_TABLE_REF(((long) 0));
			BGl_za2ifza2z00zzast_sexpz00 =
				BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 1)));
			BGl_za2cachezd2nameza2zd2zzast_sexpz00 = BFALSE;
			BGl_za2cachezd2stackza2zd2zzast_sexpz00 = BFALSE;
			return (BGl_za2cachezd2resza2zd2zzast_sexpz00 = BFALSE, BUNSPEC);
		}

	}



/* top-level-sexp->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00(obj_t BgL_expz00_17,
		obj_t BgL_locz00_18)
	{
		{	/* Ast/sexp.scm 65 */
			return
				((BgL_nodez00_bglt)
				BGl_zc3z04exitza31507ze3ze70z60zzast_sexpz00(BgL_locz00_18,
					BgL_expz00_17));
		}

	}



/* <@exit:1507>~0 */
	obj_t BGl_zc3z04exitza31507ze3ze70z60zzast_sexpz00(obj_t BgL_locz00_13794,
		obj_t BgL_expz00_13793)
	{
		{	/* Ast/sexp.scm 66 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1108z00_1680;

			if (SET_EXIT(BgL_an_exit1108z00_1680))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1108z00_1680 = (void *) jmpbuf;
					{	/* Ast/sexp.scm 66 */

						PUSH_EXIT(BgL_an_exit1108z00_1680, ((long) 1));
						{	/* Ast/sexp.scm 66 */
							obj_t BgL_an_exitd1109z00_1681;

							BgL_an_exitd1109z00_1681 = ((obj_t) (&exitd));
							{	/* Ast/sexp.scm 66 */
								obj_t BgL_res1111z00_1684;

								{	/* Ast/sexp.scm 69 */
									obj_t BgL_zc3z04anonymousza31516ze3z87_13740;
									obj_t BgL_zc3z04anonymousza31515ze3z87_13741;

									BgL_zc3z04anonymousza31516ze3z87_13740 =
										MAKE_FX_PROCEDURE
										(BGl_z62zc3z04anonymousza31516ze3ze5zzast_sexpz00,
										(int) (((long) 0)), (int) (((long) 2)));
									BgL_zc3z04anonymousza31515ze3z87_13741 =
										MAKE_FX_PROCEDURE
										(BGl_z62zc3z04anonymousza31515ze3ze5zzast_sexpz00,
										(int) (((long) 1)), (int) (((long) 1)));
									PROCEDURE_SET(BgL_zc3z04anonymousza31516ze3z87_13740,
										(int) (((long) 0)), BgL_expz00_13793);
									PROCEDURE_SET(BgL_zc3z04anonymousza31516ze3z87_13740,
										(int) (((long) 1)), BgL_locz00_13794);
									PROCEDURE_SET(BgL_zc3z04anonymousza31515ze3z87_13741,
										(int) (((long) 0)), BgL_an_exitd1109z00_1681);
									BgL_res1111z00_1684 =
										BGl_withzd2exceptionzd2handlerz00zz__errorz00
										(BgL_zc3z04anonymousza31515ze3z87_13741,
										BgL_zc3z04anonymousza31516ze3z87_13740);
								}
								POP_EXIT();
								return BgL_res1111z00_1684;
							}
						}
					}
				}
		}

	}



/* &top-level-sexp->node */
	BgL_nodez00_bglt BGl_z62topzd2levelzd2sexpzd2ze3nodez53zzast_sexpz00(obj_t
		BgL_envz00_13742, obj_t BgL_expz00_13743, obj_t BgL_locz00_13744)
	{
		{	/* Ast/sexp.scm 65 */
			return
				BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00(BgL_expz00_13743,
				BgL_locz00_13744);
		}

	}



/* &<@anonymous:1516> */
	obj_t BGl_z62zc3z04anonymousza31516ze3ze5zzast_sexpz00(obj_t BgL_envz00_13745)
	{
		{	/* Ast/sexp.scm 71 */
			{	/* Ast/sexp.scm 72 */
				obj_t BgL_expz00_13746;
				obj_t BgL_locz00_13747;

				BgL_expz00_13746 = PROCEDURE_REF(BgL_envz00_13745, (int) (((long) 0)));
				BgL_locz00_13747 = PROCEDURE_REF(BgL_envz00_13745, (int) (((long) 1)));
				return
					((obj_t)
					BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_expz00_13746, BNIL,
						BgL_locz00_13747, CNST_TABLE_REF(((long) 2))));
		}}

	}



/* &<@anonymous:1515> */
	obj_t BGl_z62zc3z04anonymousza31515ze3ze5zzast_sexpz00(obj_t BgL_envz00_13748,
		obj_t BgL_ez00_13750)
	{
		{	/* Ast/sexp.scm 68 */
			{	/* Ast/sexp.scm 69 */
				obj_t BgL_an_exitd1109z00_13749;

				BgL_an_exitd1109z00_13749 =
					PROCEDURE_REF(BgL_envz00_13748, (int) (((long) 0)));
				BGl_exceptionzd2notifyzd2zz__objectz00(BgL_ez00_13750);
				return
					BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd1109z00_13749,
					BUNSPEC);
			}
		}

	}



/* if-sym */
	BGL_EXPORTED_DEF obj_t BGl_ifzd2symzd2zzast_sexpz00()
	{
		{	/* Ast/sexp.scm 87 */
			return BGl_za2ifza2z00zzast_sexpz00;
		}

	}



/* &if-sym */
	obj_t BGl_z62ifzd2symzb0zzast_sexpz00(obj_t BgL_envz00_13751)
	{
		{	/* Ast/sexp.scm 87 */
			return BGl_ifzd2symzd2zzast_sexpz00();
		}

	}



/* proc-or-lambda? */
	bool_t BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(obj_t BgL_ez00_20)
	{
		{	/* Ast/sexp.scm 99 */
			if (SYMBOLP(BgL_ez00_20))
				{	/* Ast/sexp.scm 100 */
					return ((bool_t) 1);
				}
			else
				{	/* Ast/sexp.scm 100 */
					if (PAIRP(BgL_ez00_20))
						{	/* Ast/sexp.scm 100 */
							if ((CAR(BgL_ez00_20) == CNST_TABLE_REF(((long) 3))))
								{	/* Ast/sexp.scm 100 */
									obj_t BgL_tmpz00_13899;

									BgL_tmpz00_13899 = CDR(BgL_ez00_20);
									return PAIRP(BgL_tmpz00_13899);
								}
							else
								{	/* Ast/sexp.scm 100 */
									return ((bool_t) 0);
								}
						}
					else
						{	/* Ast/sexp.scm 100 */
							return ((bool_t) 0);
						}
				}
		}

	}



/* sexp->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt BGl_sexpzd2ze3nodez31zzast_sexpz00(obj_t
		BgL_expz00_21, obj_t BgL_stackz00_22, obj_t BgL_locz00_23,
		obj_t BgL_sitez00_24)
	{
		{	/* Ast/sexp.scm 113 */
		BGl_sexpzd2ze3nodez31zzast_sexpz00:
			{
				obj_t BgL_atomz00_1706;
				obj_t BgL_lz00_1711;
				obj_t BgL_bodyz00_1715;
				obj_t BgL_lz00_1720;
				obj_t BgL_valz00_1721;
				obj_t BgL_bodyz00_1725;
				obj_t BgL_argsz00_1726;
				obj_t BgL_bindingsz00_1728;
				obj_t BgL_exprz00_1729;
				obj_t BgL_varz00_1733;
				obj_t BgL_bodyz00_1734;
				obj_t BgL_argz00_1735;
				obj_t BgL_varsz00_1737;
				obj_t BgL_bodyz00_1738;
				obj_t BgL_argsz00_1739;
				obj_t BgL_testz00_1741;
				obj_t BgL_proc1z00_1742;
				obj_t BgL_proc2z00_1743;
				obj_t BgL_argsz00_1744;
				obj_t BgL_testz00_1746;
				obj_t BgL_proc1z00_1747;
				obj_t BgL_proc2z00_1748;
				obj_t BgL_argsz00_1749;
				obj_t BgL_effectz00_1753;
				obj_t BgL_restz00_1754;
				obj_t BgL_effectz00_1758;
				obj_t BgL_restz00_1759;

				if (NULLP(BgL_expz00_21))
					{	/* Ast/sexp.scm 118 */
						{	/* Ast/sexp.scm 121 */
							BgL_nodez00_bglt BgL_res7304z00_9584;

							{	/* Ast/sexp.scm 722 */
								obj_t BgL_arg7104z00_9580;
								BgL_nodez00_bglt BgL_arg7105z00_9581;

								BgL_arg7104z00_9580 =
									BGl_shapez00zztools_shapez00
									(BGl_currentzd2functionzd2zztools_errorz00());
								BgL_arg7105z00_9581 =
									BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 4)),
									BNIL, BgL_locz00_23, CNST_TABLE_REF(((long) 2)));
								{	/* Ast/sexp.scm 721 */
									obj_t BgL_list7106z00_9583;

									BgL_list7106z00_9583 =
										MAKE_YOUNG_PAIR(((obj_t) BgL_arg7105z00_9581), BNIL);
									BgL_res7304z00_9584 =
										((BgL_nodez00_bglt)
										BGl_userzd2errorzf2locationz20zztools_errorz00
										(BgL_locz00_23, BgL_arg7104z00_9580,
											BGl_string8004z00zzast_sexpz00, BgL_expz00_21,
											BgL_list7106z00_9583));
							}}
							return BgL_res7304z00_9584;
						}
					}
				else
					{	/* Ast/sexp.scm 118 */
						if (BGl_isazf3zf3zz__objectz00(BgL_expz00_21,
								BGl_nodez00zzast_nodez00))
							{
								obj_t BgL_auxz00_13915;

								if (BGl_isazf3zf3zz__objectz00(BgL_expz00_21,
										BGl_externz00zzast_nodez00))
									{	/* Ast/sexp.scm 126 */
										obj_t BgL_l01341z00_8335;

										BgL_l01341z00_8335 =
											(((BgL_externz00_bglt) COBJECT(
													((BgL_externz00_bglt) BgL_expz00_21)))->
											BgL_exprza2za2);
										{
											obj_t BgL_l1340z00_8337;

											BgL_l1340z00_8337 = BgL_l01341z00_8335;
										BgL_zc3z04anonymousza36610ze3z87_8338:
											if (NULLP(BgL_l1340z00_8337))
												{	/* Ast/sexp.scm 126 */
													BgL_l01341z00_8335;
												}
											else
												{	/* Ast/sexp.scm 126 */
													{	/* Ast/sexp.scm 126 */
														BgL_nodez00_bglt BgL_arg6612z00_8340;

														{	/* Ast/sexp.scm 126 */
															obj_t BgL_ez00_8341;

															BgL_ez00_8341 = CAR(((obj_t) BgL_l1340z00_8337));
															{	/* Ast/sexp.scm 126 */
																obj_t BgL_arg6613z00_8342;

																BgL_arg6613z00_8342 =
																	(((BgL_nodez00_bglt) COBJECT(
																			((BgL_nodez00_bglt)
																				((BgL_externz00_bglt)
																					BgL_expz00_21))))->BgL_locz00);
																BgL_arg6612z00_8340 =
																	BGl_sexpzd2ze3nodez31zzast_sexpz00
																	(BgL_ez00_8341, BgL_stackz00_22,
																	BgL_arg6613z00_8342,
																	CNST_TABLE_REF(((long) 2)));
														}}
														{	/* Ast/sexp.scm 126 */
															obj_t BgL_auxz00_13931;
															obj_t BgL_tmpz00_13929;

															BgL_auxz00_13931 = ((obj_t) BgL_arg6612z00_8340);
															BgL_tmpz00_13929 = ((obj_t) BgL_l1340z00_8337);
															SET_CAR(BgL_tmpz00_13929, BgL_auxz00_13931);
													}}
													{	/* Ast/sexp.scm 126 */
														obj_t BgL_arg6614z00_8343;

														BgL_arg6614z00_8343 =
															CDR(((obj_t) BgL_l1340z00_8337));
														{
															obj_t BgL_l1340z00_13936;

															BgL_l1340z00_13936 = BgL_arg6614z00_8343;
															BgL_l1340z00_8337 = BgL_l1340z00_13936;
															goto BgL_zc3z04anonymousza36610ze3z87_8338;
														}
													}
												}
										}
									}
								else
									{	/* Ast/sexp.scm 124 */
										BFALSE;
									}
								if (BGl_isazf3zf3zz__objectz00(BgL_expz00_21,
										BGl_appz00zzast_nodez00))
									{	/* Ast/sexp.scm 129 */
										obj_t BgL_l01344z00_8347;

										BgL_l01344z00_8347 =
											(((BgL_appz00_bglt) COBJECT(
													((BgL_appz00_bglt) BgL_expz00_21)))->BgL_argsz00);
										{
											obj_t BgL_l1343z00_8349;

											BgL_l1343z00_8349 = BgL_l01344z00_8347;
										BgL_zc3z04anonymousza36616ze3z87_8350:
											if (NULLP(BgL_l1343z00_8349))
												{	/* Ast/sexp.scm 129 */
													BgL_l01344z00_8347;
												}
											else
												{	/* Ast/sexp.scm 129 */
													{	/* Ast/sexp.scm 129 */
														BgL_nodez00_bglt BgL_arg6618z00_8352;

														{	/* Ast/sexp.scm 129 */
															obj_t BgL_ez00_8353;

															BgL_ez00_8353 = CAR(((obj_t) BgL_l1343z00_8349));
															{	/* Ast/sexp.scm 129 */
																obj_t BgL_arg6619z00_8354;

																BgL_arg6619z00_8354 =
																	(((BgL_nodez00_bglt) COBJECT(
																			((BgL_nodez00_bglt)
																				((BgL_appz00_bglt) BgL_expz00_21))))->
																	BgL_locz00);
																BgL_arg6618z00_8352 =
																	BGl_sexpzd2ze3nodez31zzast_sexpz00
																	(BgL_ez00_8353, BgL_stackz00_22,
																	BgL_arg6619z00_8354,
																	CNST_TABLE_REF(((long) 2)));
														}}
														{	/* Ast/sexp.scm 129 */
															obj_t BgL_auxz00_13952;
															obj_t BgL_tmpz00_13950;

															BgL_auxz00_13952 = ((obj_t) BgL_arg6618z00_8352);
															BgL_tmpz00_13950 = ((obj_t) BgL_l1343z00_8349);
															SET_CAR(BgL_tmpz00_13950, BgL_auxz00_13952);
													}}
													{	/* Ast/sexp.scm 129 */
														obj_t BgL_arg6620z00_8355;

														BgL_arg6620z00_8355 =
															CDR(((obj_t) BgL_l1343z00_8349));
														{
															obj_t BgL_l1343z00_13957;

															BgL_l1343z00_13957 = BgL_arg6620z00_8355;
															BgL_l1343z00_8349 = BgL_l1343z00_13957;
															goto BgL_zc3z04anonymousza36616ze3z87_8350;
														}
													}
												}
										}
									}
								else
									{	/* Ast/sexp.scm 127 */
										BFALSE;
									}
								BgL_auxz00_13915 = BgL_expz00_21;
								return ((BgL_nodez00_bglt) BgL_auxz00_13915);
							}
						else
							{	/* Ast/sexp.scm 118 */
								if (PAIRP(BgL_expz00_21))
									{	/* Ast/sexp.scm 118 */
										obj_t BgL_carzd2478zd2_1780;

										BgL_carzd2478zd2_1780 = CAR(BgL_expz00_21);
										if (SYMBOLP(BgL_carzd2478zd2_1780))
											{	/* Ast/sexp.scm 118 */
												bool_t BgL_test8085z00_13964;

												{	/* Ast/sexp.scm 118 */
													obj_t BgL__ortest_1144z00_5060;

													BgL__ortest_1144z00_5060 =
														BGl_findzd2localzd2zzast_sexpz00
														(BgL_carzd2478zd2_1780, BgL_stackz00_22);
													if (CBOOL(BgL__ortest_1144z00_5060))
														{	/* Ast/sexp.scm 118 */
															BgL_test8085z00_13964 =
																CBOOL(BgL__ortest_1144z00_5060);
														}
													else
														{	/* Ast/sexp.scm 118 */
															obj_t BgL_gz00_5061;

															BgL_gz00_5061 =
																BGl_findzd2globalzd2zzast_envz00
																(BgL_carzd2478zd2_1780, BNIL);
															if (CBOOL(BgL_gz00_5061))
																{	/* Ast/sexp.scm 118 */
																	if (
																		((((BgL_globalz00_bglt) COBJECT(
																						((BgL_globalz00_bglt)
																							BgL_gz00_5061)))->
																				BgL_modulez00) ==
																			CNST_TABLE_REF(((long) 13))))
																		{	/* Ast/sexp.scm 118 */
																			BgL_test8085z00_13964 = ((bool_t) 0);
																		}
																	else
																		{	/* Ast/sexp.scm 118 */
																			BgL_test8085z00_13964 = ((bool_t) 1);
																		}
																}
															else
																{	/* Ast/sexp.scm 118 */
																	BgL_test8085z00_13964 = ((bool_t) 0);
																}
														}
												}
												if (BgL_test8085z00_13964)
													{	/* Ast/sexp.scm 118 */
														return
															BGl_callzd2ze3nodez31zzast_sexpz00(BgL_expz00_21,
															BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
													}
												else
													{	/* Ast/sexp.scm 118 */
														if (
															(CAR(BgL_expz00_21) ==
																CNST_TABLE_REF(((long) 11))))
															{	/* Ast/sexp.scm 118 */
															BgL_tagzd2371zd2_1710:
																{	/* Ast/sexp.scm 170 */
																	obj_t BgL_locz00_8385;

																	BgL_locz00_8385 =
																		BGl_findzd2locationzf2locz20zztools_locationz00
																		(BgL_expz00_21, BgL_locz00_23);
																	{
																		obj_t BgL_namez00_8386;
																		obj_t BgL_modulez00_8387;

																		if (PAIRP(BgL_expz00_21))
																			{	/* Ast/sexp.scm 171 */
																				obj_t BgL_cdrzd262164zd2_8392;

																				BgL_cdrzd262164zd2_8392 =
																					CDR(BgL_expz00_21);
																				if (
																					(CAR(BgL_expz00_21) ==
																						CNST_TABLE_REF(((long) 11))))
																					{	/* Ast/sexp.scm 171 */
																						if (PAIRP(BgL_cdrzd262164zd2_8392))
																							{	/* Ast/sexp.scm 171 */
																								obj_t BgL_carzd262167zd2_8396;
																								obj_t BgL_cdrzd262168zd2_8397;

																								BgL_carzd262167zd2_8396 =
																									CAR(BgL_cdrzd262164zd2_8392);
																								BgL_cdrzd262168zd2_8397 =
																									CDR(BgL_cdrzd262164zd2_8392);
																								if (SYMBOLP
																									(BgL_carzd262167zd2_8396))
																									{	/* Ast/sexp.scm 171 */
																										if (PAIRP
																											(BgL_cdrzd262168zd2_8397))
																											{	/* Ast/sexp.scm 171 */
																												obj_t
																													BgL_carzd262173zd2_8400;
																												BgL_carzd262173zd2_8400
																													=
																													CAR
																													(BgL_cdrzd262168zd2_8397);
																												if (SYMBOLP
																													(BgL_carzd262173zd2_8400))
																													{	/* Ast/sexp.scm 171 */
																														if (NULLP(CDR
																																(BgL_cdrzd262168zd2_8397)))
																															{	/* Ast/sexp.scm 171 */
																																BgL_namez00_8386
																																	=
																																	BgL_carzd262167zd2_8396;
																																BgL_modulez00_8387
																																	=
																																	BgL_carzd262173zd2_8400;
																																{	/* Ast/sexp.scm 173 */
																																	obj_t
																																		BgL_globalz00_8406;
																																	obj_t
																																		BgL_locz00_8407;
																																	BgL_globalz00_8406
																																		=
																																		BGl_findzd2globalzf2modulez20zzast_envz00
																																		(BgL_namez00_8386,
																																		BgL_modulez00_8387);
																																	BgL_locz00_8407
																																		=
																																		BGl_findzd2locationzf2locz20zztools_locationz00
																																		(BgL_namez00_8386,
																																		BgL_locz00_8385);
																																	if (BGl_isazf3zf3zz__objectz00(BgL_globalz00_8406, BGl_globalz00zzast_varz00))
																																		{	/* Ast/sexp.scm 176 */
																																			if (
																																				((((BgL_globalz00_bglt) COBJECT(((BgL_globalz00_bglt) BgL_globalz00_8406)))->BgL_importz00) == CNST_TABLE_REF(((long) 10))))
																																				{	/* Ast/sexp.scm 179 */
																																					obj_t
																																						BgL_arg6652z00_8411;
																																					{	/* Ast/sexp.scm 179 */
																																						obj_t
																																							BgL_arg6653z00_8412;
																																						BgL_arg6653z00_8412
																																							=
																																							MAKE_YOUNG_PAIR
																																							(BGl_atomz00zzast_nodez00,
																																							BNIL);
																																						BgL_arg6652z00_8411
																																							=
																																							MAKE_YOUNG_PAIR
																																							(CNST_TABLE_REF
																																							(((long) 10)), BgL_arg6653z00_8412);
																																					}
																																					{
																																						obj_t
																																							BgL_locz00_14017;
																																						obj_t
																																							BgL_expz00_14016;
																																						BgL_expz00_14016
																																							=
																																							BgL_arg6652z00_8411;
																																						BgL_locz00_14017
																																							=
																																							BgL_locz00_8407;
																																						BgL_locz00_23
																																							=
																																							BgL_locz00_14017;
																																						BgL_expz00_21
																																							=
																																							BgL_expz00_14016;
																																						goto
																																							BGl_sexpzd2ze3nodez31zzast_sexpz00;
																																					}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 178 */
																																					return
																																						BGl_variablezd2ze3nodez31zzast_sexpz00
																																						(BgL_globalz00_8406,
																																						BgL_locz00_8407,
																																						BgL_sitez00_24);
																																				}
																																		}
																																	else
																																		{	/* Ast/sexp.scm 177 */
																																			BgL_nodez00_bglt
																																				BgL_res7321z00_9628;
																																			{	/* Ast/sexp.scm 722 */
																																				obj_t
																																					BgL_arg7104z00_9624;
																																				BgL_nodez00_bglt
																																					BgL_arg7105z00_9625;
																																				BgL_arg7104z00_9624
																																					=
																																					BGl_shapez00zztools_shapez00
																																					(BGl_currentzd2functionzd2zztools_errorz00
																																					());
																																				BgL_arg7105z00_9625
																																					=
																																					BGl_sexpzd2ze3nodez31zzast_sexpz00
																																					(CNST_TABLE_REF
																																					(((long) 4)), BNIL, BgL_locz00_8407, CNST_TABLE_REF(((long) 2)));
																																				{	/* Ast/sexp.scm 721 */
																																					obj_t
																																						BgL_list7106z00_9627;
																																					BgL_list7106z00_9627
																																						=
																																						MAKE_YOUNG_PAIR
																																						(((obj_t) BgL_arg7105z00_9625), BNIL);
																																					BgL_res7321z00_9628
																																						=
																																						(
																																						(BgL_nodez00_bglt)
																																						BGl_userzd2errorzf2locationz20zztools_errorz00
																																						(BgL_locz00_8407,
																																							BgL_arg7104z00_9624,
																																							BGl_string8002z00zzast_sexpz00,
																																							BgL_expz00_21,
																																							BgL_list7106z00_9627));
																																			}}
																																			return
																																				BgL_res7321z00_9628;
																																		}
																																}
																															}
																														else
																															{	/* Ast/sexp.scm 171 */
																															BgL_tagzd262157zd2_8389:
																																{	/* Ast/sexp.scm 183 */
																																	BgL_nodez00_bglt
																																		BgL_res7322z00_9634;
																																	{	/* Ast/sexp.scm 722 */
																																		obj_t
																																			BgL_arg7104z00_9630;
																																		BgL_nodez00_bglt
																																			BgL_arg7105z00_9631;
																																		BgL_arg7104z00_9630
																																			=
																																			BGl_shapez00zztools_shapez00
																																			(BGl_currentzd2functionzd2zztools_errorz00
																																			());
																																		BgL_arg7105z00_9631
																																			=
																																			BGl_sexpzd2ze3nodez31zzast_sexpz00
																																			(CNST_TABLE_REF
																																			(((long)
																																					4)),
																																			BNIL,
																																			BgL_locz00_8385,
																																			CNST_TABLE_REF
																																			(((long)
																																					2)));
																																		{	/* Ast/sexp.scm 721 */
																																			obj_t
																																				BgL_list7106z00_9633;
																																			BgL_list7106z00_9633
																																				=
																																				MAKE_YOUNG_PAIR
																																				(((obj_t) BgL_arg7105z00_9631), BNIL);
																																			BgL_res7322z00_9634
																																				=
																																				(
																																				(BgL_nodez00_bglt)
																																				BGl_userzd2errorzf2locationz20zztools_errorz00
																																				(BgL_locz00_8385,
																																					BgL_arg7104z00_9630,
																																					BGl_string8001z00zzast_sexpz00,
																																					BgL_expz00_21,
																																					BgL_list7106z00_9633));
																																	}}
																																	return
																																		BgL_res7322z00_9634;
																																}
																															}
																													}
																												else
																													{	/* Ast/sexp.scm 171 */
																														goto
																															BgL_tagzd262157zd2_8389;
																													}
																											}
																										else
																											{	/* Ast/sexp.scm 171 */
																												goto
																													BgL_tagzd262157zd2_8389;
																											}
																									}
																								else
																									{	/* Ast/sexp.scm 171 */
																										goto
																											BgL_tagzd262157zd2_8389;
																									}
																							}
																						else
																							{	/* Ast/sexp.scm 171 */
																								goto BgL_tagzd262157zd2_8389;
																							}
																					}
																				else
																					{	/* Ast/sexp.scm 171 */
																						goto BgL_tagzd262157zd2_8389;
																					}
																			}
																		else
																			{	/* Ast/sexp.scm 171 */
																				goto BgL_tagzd262157zd2_8389;
																			}
																	}
																}
															}
														else
															{	/* Ast/sexp.scm 118 */
																if (
																	(CAR(BgL_expz00_21) ==
																		CNST_TABLE_REF(((long) 14))))
																	{	/* Ast/sexp.scm 118 */
																		BgL_lz00_1711 = CDR(BgL_expz00_21);
																	BgL_tagzd2372zd2_1712:
																		{	/* Ast/sexp.scm 186 */
																			bool_t BgL_test8100z00_14041;

																			if (PAIRP(BgL_lz00_1711))
																				{	/* Ast/sexp.scm 186 */
																					bool_t BgL_test8102z00_14044;

																					{	/* Ast/sexp.scm 186 */
																						obj_t BgL_tmpz00_14045;

																						BgL_tmpz00_14045 =
																							CDR(BgL_lz00_1711);
																						BgL_test8102z00_14044 =
																							PAIRP(BgL_tmpz00_14045);
																					}
																					if (BgL_test8102z00_14044)
																						{
																							obj_t BgL_l1345z00_8431;

																							BgL_l1345z00_8431 = BgL_lz00_1711;
																						BgL_zc3z04anonymousza36664ze3z87_8432:
																							if (NULLP
																								(BgL_l1345z00_8431))
																								{	/* Ast/sexp.scm 186 */
																									BgL_test8100z00_14041 =
																										((bool_t) 1);
																								}
																							else
																								{	/* Ast/sexp.scm 186 */
																									bool_t BgL_test8104z00_14050;

																									{	/* Ast/sexp.scm 186 */
																										obj_t BgL_tmpz00_14051;

																										BgL_tmpz00_14051 =
																											CAR(
																											((obj_t)
																												BgL_l1345z00_8431));
																										BgL_test8104z00_14050 =
																											SYMBOLP(BgL_tmpz00_14051);
																									}
																									if (BgL_test8104z00_14050)
																										{
																											obj_t BgL_l1345z00_14055;

																											BgL_l1345z00_14055 =
																												CDR(
																												((obj_t)
																													BgL_l1345z00_8431));
																											BgL_l1345z00_8431 =
																												BgL_l1345z00_14055;
																											goto
																												BgL_zc3z04anonymousza36664ze3z87_8432;
																										}
																									else
																										{	/* Ast/sexp.scm 186 */
																											BgL_test8100z00_14041 =
																												((bool_t) 0);
																										}
																								}
																						}
																					else
																						{	/* Ast/sexp.scm 186 */
																							BgL_test8100z00_14041 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Ast/sexp.scm 186 */
																					BgL_test8100z00_14041 = ((bool_t) 0);
																				}
																			if (BgL_test8100z00_14041)
																				{	/* Ast/sexp.scm 186 */
																					return
																						BGl_fieldzd2refzd2ze3nodeze3zzast_objectz00
																						(BgL_lz00_1711, BgL_expz00_21,
																						BgL_stackz00_22, BgL_locz00_23,
																						BgL_sitez00_24);
																				}
																			else
																				{	/* Ast/sexp.scm 188 */
																					BgL_nodez00_bglt BgL_res7333z00_9659;

																					{	/* Ast/sexp.scm 722 */
																						obj_t BgL_arg7104z00_9655;
																						BgL_nodez00_bglt
																							BgL_arg7105z00_9656;
																						BgL_arg7104z00_9655 =
																							BGl_shapez00zztools_shapez00
																							(BGl_currentzd2functionzd2zztools_errorz00
																							());
																						BgL_arg7105z00_9656 =
																							BGl_sexpzd2ze3nodez31zzast_sexpz00
																							(CNST_TABLE_REF(((long) 4)), BNIL,
																							BgL_locz00_23,
																							CNST_TABLE_REF(((long) 2)));
																						{	/* Ast/sexp.scm 721 */
																							obj_t BgL_list7106z00_9658;

																							BgL_list7106z00_9658 =
																								MAKE_YOUNG_PAIR(
																								((obj_t) BgL_arg7105z00_9656),
																								BNIL);
																							BgL_res7333z00_9659 =
																								((BgL_nodez00_bglt)
																								BGl_userzd2errorzf2locationz20zztools_errorz00
																								(BgL_locz00_23,
																									BgL_arg7104z00_9655,
																									BGl_string7998z00zzast_sexpz00,
																									BgL_expz00_21,
																									BgL_list7106z00_9658));
																					}}
																					return BgL_res7333z00_9659;
																				}
																		}
																	}
																else
																	{	/* Ast/sexp.scm 118 */
																		if (
																			(CAR(BgL_expz00_21) ==
																				CNST_TABLE_REF(((long) 12))))
																			{	/* Ast/sexp.scm 118 */
																			BgL_tagzd2373zd2_1713:
																				{
																					obj_t BgL_valuez00_8440;

																					if (PAIRP(BgL_expz00_21))
																						{	/* Ast/sexp.scm 118 */
																							obj_t BgL_cdrzd262184zd2_8445;

																							BgL_cdrzd262184zd2_8445 =
																								CDR(BgL_expz00_21);
																							if (PAIRP
																								(BgL_cdrzd262184zd2_8445))
																								{	/* Ast/sexp.scm 118 */
																									if (NULLP(CDR
																											(BgL_cdrzd262184zd2_8445)))
																										{	/* Ast/sexp.scm 118 */
																											BgL_valuez00_8440 =
																												CAR
																												(BgL_cdrzd262184zd2_8445);
																											{	/* Ast/sexp.scm 193 */
																												obj_t BgL_locz00_8451;

																												BgL_locz00_8451 =
																													BGl_findzd2locationzf2locz20zztools_locationz00
																													(BgL_expz00_21,
																													BgL_locz00_23);
																												if (NULLP
																													(BgL_valuez00_8440))
																													{	/* Ast/sexp.scm 196 */
																														BgL_literalz00_bglt
																															BgL_new1120z00_8453;
																														{	/* Ast/sexp.scm 197 */
																															BgL_literalz00_bglt
																																BgL_new1119z00_8455;
																															BgL_new1119z00_8455
																																=
																																(
																																(BgL_literalz00_bglt)
																																BOBJECT
																																(GC_MALLOC
																																	(sizeof(struct
																																			BgL_literalz00_bgl))));
																															{	/* Ast/sexp.scm 197 */
																																long
																																	BgL_arg6676z00_8456;
																																{	/* Ast/sexp.scm 197 */
																																	long
																																		BgL_res7335z00_9662;
																																	BgL_res7335z00_9662
																																		=
																																		BGL_CLASS_INDEX
																																		(BGl_literalz00zzast_nodez00);
																																	BgL_arg6676z00_8456
																																		=
																																		BgL_res7335z00_9662;
																																}
																																BGL_OBJECT_CLASS_NUM_SET
																																	(((BgL_objectz00_bglt) BgL_new1119z00_8455), BgL_arg6676z00_8456);
																															}
																															{	/* Ast/sexp.scm 197 */
																																BgL_objectz00_bglt
																																	BgL_tmpz00_14088;
																																BgL_tmpz00_14088
																																	=
																																	(
																																	(BgL_objectz00_bglt)
																																	BgL_new1119z00_8455);
																																BGL_OBJECT_WIDENING_SET
																																	(BgL_tmpz00_14088,
																																	BFALSE);
																															}
																															((BgL_objectz00_bglt) BgL_new1119z00_8455);
																															BgL_new1120z00_8453
																																=
																																BgL_new1119z00_8455;
																														}
																														((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1120z00_8453)))->BgL_locz00) = ((obj_t) BgL_locz00_8451), BUNSPEC);
																														{
																															BgL_typez00_bglt
																																BgL_auxz00_14094;
																															{	/* Ast/sexp.scm 198 */
																																BgL_typez00_bglt
																																	BgL_arg6675z00_8454;
																																BgL_arg6675z00_8454
																																	=
																																	BGl_getzd2typezd2kwotez00zztype_typeofz00
																																	(BgL_valuez00_8440);
																																BgL_auxz00_14094
																																	=
																																	BGl_strictzd2nodezd2typez00zzast_nodez00
																																	(BgL_arg6675z00_8454,
																																	((BgL_typez00_bglt) BGl_za2bnilza2z00zztype_cachez00));
																															}
																															((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1120z00_8453)))->BgL_typez00) = ((BgL_typez00_bglt) BgL_auxz00_14094), BUNSPEC);
																														}
																														((((BgL_atomz00_bglt) COBJECT(((BgL_atomz00_bglt) BgL_new1120z00_8453)))->BgL_valuez00) = ((obj_t) BNIL), BUNSPEC);
																														return
																															(
																															(BgL_nodez00_bglt)
																															BgL_new1120z00_8453);
																													}
																												else
																													{	/* Ast/sexp.scm 200 */
																														bool_t
																															BgL_test8110z00_14103;
																														if (PAIRP
																															(BgL_valuez00_8440))
																															{	/* Ast/sexp.scm 200 */
																																BgL_test8110z00_14103
																																	=
																																	((bool_t) 1);
																															}
																														else
																															{	/* Ast/sexp.scm 200 */
																																if (VECTORP
																																	(BgL_valuez00_8440))
																																	{	/* Ast/sexp.scm 201 */
																																		BgL_test8110z00_14103
																																			=
																																			((bool_t)
																																			1);
																																	}
																																else
																																	{	/* Ast/sexp.scm 201 */
																																		if (BGL_HVECTORP(BgL_valuez00_8440))
																																			{	/* Ast/sexp.scm 202 */
																																				BgL_test8110z00_14103
																																					=
																																					(
																																					(bool_t)
																																					1);
																																			}
																																		else
																																			{	/* Ast/sexp.scm 202 */
																																				if (STRUCTP(BgL_valuez00_8440))
																																					{	/* Ast/sexp.scm 203 */
																																						BgL_test8110z00_14103
																																							=
																																							(
																																							(bool_t)
																																							1);
																																					}
																																				else
																																					{	/* Ast/sexp.scm 203 */
																																						if (SYMBOLP(BgL_valuez00_8440))
																																							{	/* Ast/sexp.scm 204 */
																																								BgL_test8110z00_14103
																																									=
																																									(
																																									(bool_t)
																																									1);
																																							}
																																						else
																																							{	/* Ast/sexp.scm 204 */
																																								BgL_test8110z00_14103
																																									=
																																									KEYWORDP
																																									(BgL_valuez00_8440);
																																							}
																																					}
																																			}
																																	}
																															}
																														if (BgL_test8110z00_14103)
																															{	/* Ast/sexp.scm 206 */
																																BgL_kwotez00_bglt
																																	BgL_new1122z00_8463;
																																{	/* Ast/sexp.scm 207 */
																																	BgL_kwotez00_bglt
																																		BgL_new1121z00_8465;
																																	BgL_new1121z00_8465
																																		=
																																		(
																																		(BgL_kwotez00_bglt)
																																		BOBJECT
																																		(GC_MALLOC
																																			(sizeof
																																				(struct
																																					BgL_kwotez00_bgl))));
																																	{	/* Ast/sexp.scm 207 */
																																		long
																																			BgL_arg6684z00_8466;
																																		{	/* Ast/sexp.scm 207 */
																																			long
																																				BgL_res7341z00_9672;
																																			BgL_res7341z00_9672
																																				=
																																				BGL_CLASS_INDEX
																																				(BGl_kwotez00zzast_nodez00);
																																			BgL_arg6684z00_8466
																																				=
																																				BgL_res7341z00_9672;
																																		}
																																		BGL_OBJECT_CLASS_NUM_SET
																																			(((BgL_objectz00_bglt) BgL_new1121z00_8465), BgL_arg6684z00_8466);
																																	}
																																	{	/* Ast/sexp.scm 207 */
																																		BgL_objectz00_bglt
																																			BgL_tmpz00_14119;
																																		BgL_tmpz00_14119
																																			=
																																			(
																																			(BgL_objectz00_bglt)
																																			BgL_new1121z00_8465);
																																		BGL_OBJECT_WIDENING_SET
																																			(BgL_tmpz00_14119,
																																			BFALSE);
																																	}
																																	((BgL_objectz00_bglt) BgL_new1121z00_8465);
																																	BgL_new1122z00_8463
																																		=
																																		BgL_new1121z00_8465;
																																}
																																((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1122z00_8463)))->BgL_locz00) = ((obj_t) BgL_locz00_8451), BUNSPEC);
																																{
																																	BgL_typez00_bglt
																																		BgL_auxz00_14125;
																																	{	/* Ast/sexp.scm 208 */
																																		BgL_typez00_bglt
																																			BgL_arg6683z00_8464;
																																		BgL_arg6683z00_8464
																																			=
																																			BGl_getzd2typezd2kwotez00zztype_typeofz00
																																			(BgL_valuez00_8440);
																																		BgL_auxz00_14125
																																			=
																																			BGl_strictzd2nodezd2typez00zzast_nodez00
																																			(BgL_arg6683z00_8464,
																																			((BgL_typez00_bglt) BGl_za2_za2z00zztype_cachez00));
																																	}
																																	((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1122z00_8463)))->BgL_typez00) = ((BgL_typez00_bglt) BgL_auxz00_14125), BUNSPEC);
																																}
																																((((BgL_kwotez00_bglt) COBJECT(BgL_new1122z00_8463))->BgL_valuez00) = ((obj_t) BgL_valuez00_8440), BUNSPEC);
																																return
																																	(
																																	(BgL_nodez00_bglt)
																																	BgL_new1122z00_8463);
																															}
																														else
																															{	/* Ast/sexp.scm 210 */
																																bool_t
																																	BgL_test8116z00_14133;
																																if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_valuez00_8440))
																																	{	/* Ast/sexp.scm 210 */
																																		BgL_test8116z00_14133
																																			=
																																			((bool_t)
																																			1);
																																	}
																																else
																																	{	/* Ast/sexp.scm 210 */
																																		if (STRINGP
																																			(BgL_valuez00_8440))
																																			{	/* Ast/sexp.scm 211 */
																																				BgL_test8116z00_14133
																																					=
																																					(
																																					(bool_t)
																																					1);
																																			}
																																		else
																																			{	/* Ast/sexp.scm 211 */
																																				if (CNSTP(BgL_valuez00_8440))
																																					{	/* Ast/sexp.scm 212 */
																																						BgL_test8116z00_14133
																																							=
																																							(
																																							(bool_t)
																																							1);
																																					}
																																				else
																																					{	/* Ast/sexp.scm 212 */
																																						if (CHARP(BgL_valuez00_8440))
																																							{	/* Ast/sexp.scm 216 */
																																								BgL_test8116z00_14133
																																									=
																																									(
																																									(bool_t)
																																									1);
																																							}
																																						else
																																							{	/* Ast/sexp.scm 216 */
																																								BgL_test8116z00_14133
																																									=
																																									BOOLEANP
																																									(BgL_valuez00_8440);
																																							}
																																					}
																																			}
																																	}
																																if (BgL_test8116z00_14133)
																																	{
																																		obj_t
																																			BgL_locz00_14144;
																																		obj_t
																																			BgL_expz00_14143;
																																		BgL_expz00_14143
																																			=
																																			BgL_valuez00_8440;
																																		BgL_locz00_14144
																																			=
																																			BgL_locz00_8451;
																																		BgL_locz00_23
																																			=
																																			BgL_locz00_14144;
																																		BgL_expz00_21
																																			=
																																			BgL_expz00_14143;
																																		goto
																																			BGl_sexpzd2ze3nodez31zzast_sexpz00;
																																	}
																																else
																																	{	/* Ast/sexp.scm 220 */
																																		BgL_nodez00_bglt
																																			BgL_res7346z00_9685;
																																		{	/* Ast/sexp.scm 722 */
																																			obj_t
																																				BgL_arg7104z00_9681;
																																			BgL_nodez00_bglt
																																				BgL_arg7105z00_9682;
																																			BgL_arg7104z00_9681
																																				=
																																				BGl_shapez00zztools_shapez00
																																				(BGl_currentzd2functionzd2zztools_errorz00
																																				());
																																			BgL_arg7105z00_9682
																																				=
																																				BGl_sexpzd2ze3nodez31zzast_sexpz00
																																				(CNST_TABLE_REF
																																				(((long)
																																						4)),
																																				BNIL,
																																				BgL_locz00_8451,
																																				CNST_TABLE_REF
																																				(((long)
																																						2)));
																																			{	/* Ast/sexp.scm 721 */
																																				obj_t
																																					BgL_list7106z00_9684;
																																				BgL_list7106z00_9684
																																					=
																																					MAKE_YOUNG_PAIR
																																					(((obj_t) BgL_arg7105z00_9682), BNIL);
																																				BgL_res7346z00_9685
																																					=
																																					(
																																					(BgL_nodez00_bglt)
																																					BGl_userzd2errorzf2locationz20zztools_errorz00
																																					(BgL_locz00_8451,
																																						BgL_arg7104z00_9681,
																																						BGl_string8000z00zzast_sexpz00,
																																						BgL_expz00_21,
																																						BgL_list7106z00_9684));
																																		}}
																																		return
																																			BgL_res7346z00_9685;
																																	}
																															}
																													}
																											}
																										}
																									else
																										{	/* Ast/sexp.scm 118 */
																										BgL_tagzd262179zd2_8442:
																											{	/* Ast/sexp.scm 222 */
																												BgL_nodez00_bglt
																													BgL_res7347z00_9691;
																												{	/* Ast/sexp.scm 722 */
																													obj_t
																														BgL_arg7104z00_9687;
																													BgL_nodez00_bglt
																														BgL_arg7105z00_9688;
																													BgL_arg7104z00_9687 =
																														BGl_shapez00zztools_shapez00
																														(BGl_currentzd2functionzd2zztools_errorz00
																														());
																													BgL_arg7105z00_9688 =
																														BGl_sexpzd2ze3nodez31zzast_sexpz00
																														(CNST_TABLE_REF((
																																(long) 4)),
																														BNIL, BgL_locz00_23,
																														CNST_TABLE_REF((
																																(long) 2)));
																													{	/* Ast/sexp.scm 721 */
																														obj_t
																															BgL_list7106z00_9690;
																														BgL_list7106z00_9690
																															=
																															MAKE_YOUNG_PAIR((
																																(obj_t)
																																BgL_arg7105z00_9688),
																															BNIL);
																														BgL_res7347z00_9691
																															=
																															(
																															(BgL_nodez00_bglt)
																															BGl_userzd2errorzf2locationz20zztools_errorz00
																															(BgL_locz00_23,
																																BgL_arg7104z00_9687,
																																BGl_string8000z00zzast_sexpz00,
																																BgL_expz00_21,
																																BgL_list7106z00_9690));
																												}}
																												return
																													BgL_res7347z00_9691;
																											}
																										}
																								}
																							else
																								{	/* Ast/sexp.scm 118 */
																									goto BgL_tagzd262179zd2_8442;
																								}
																						}
																					else
																						{	/* Ast/sexp.scm 118 */
																							goto BgL_tagzd262179zd2_8442;
																						}
																				}
																			}
																		else
																			{	/* Ast/sexp.scm 118 */
																				if (
																					(CAR(BgL_expz00_21) ==
																						CNST_TABLE_REF(((long) 15))))
																					{	/* Ast/sexp.scm 118 */
																						if (NULLP(CDR(BgL_expz00_21)))
																							{	/* Ast/sexp.scm 118 */
																							BgL_tagzd2374zd2_1714:
																								{
																									obj_t BgL_locz00_14172;
																									obj_t BgL_expz00_14171;

																									BgL_expz00_14171 = BUNSPEC;
																									BgL_locz00_14172 =
																										BGl_findzd2locationzf2locz20zztools_locationz00
																										(BgL_expz00_21,
																										BgL_locz00_23);
																									BgL_locz00_23 =
																										BgL_locz00_14172;
																									BgL_expz00_21 =
																										BgL_expz00_14171;
																									goto
																										BGl_sexpzd2ze3nodez31zzast_sexpz00;
																								}
																							}
																						else
																							{	/* Ast/sexp.scm 118 */
																								obj_t BgL_arg1590z00_1802;

																								BgL_arg1590z00_1802 =
																									CDR(BgL_expz00_21);
																								{
																									BgL_sequencez00_bglt
																										BgL_auxz00_14175;
																									BgL_bodyz00_1715 =
																										BgL_arg1590z00_1802;
																								BgL_tagzd2375zd2_1716:
																									{	/* Ast/sexp.scm 227 */
																										obj_t BgL_locz00_8482;

																										BgL_locz00_8482 =
																											BGl_findzd2locationzf2locz20zztools_locationz00
																											(BgL_expz00_21,
																											BgL_locz00_23);
																										{	/* Ast/sexp.scm 227 */
																											obj_t BgL_nodesz00_8483;

																											BgL_nodesz00_8483 =
																												BGl_sexpza2zd2ze3nodez93zzast_sexpz00
																												(BgL_bodyz00_1715,
																												BgL_stackz00_22,
																												BgL_locz00_8482,
																												BgL_sitez00_24);
																											{	/* Ast/sexp.scm 228 */

																												{	/* Ast/sexp.scm 229 */
																													BgL_sequencez00_bglt
																														BgL_new1125z00_8484;
																													{	/* Ast/sexp.scm 230 */
																														BgL_sequencez00_bglt
																															BgL_new1123z00_8485;
																														BgL_new1123z00_8485
																															=
																															(
																															(BgL_sequencez00_bglt)
																															BOBJECT(GC_MALLOC
																																(sizeof(struct
																																		BgL_sequencez00_bgl))));
																														{	/* Ast/sexp.scm 230 */
																															long
																																BgL_arg6691z00_8486;
																															{	/* Ast/sexp.scm 230 */
																																long
																																	BgL_res7351z00_9699;
																																BgL_res7351z00_9699
																																	=
																																	BGL_CLASS_INDEX
																																	(BGl_sequencez00zzast_nodez00);
																																BgL_arg6691z00_8486
																																	=
																																	BgL_res7351z00_9699;
																															}
																															BGL_OBJECT_CLASS_NUM_SET
																																(((BgL_objectz00_bglt) BgL_new1123z00_8485), BgL_arg6691z00_8486);
																														}
																														{	/* Ast/sexp.scm 230 */
																															BgL_objectz00_bglt
																																BgL_tmpz00_14182;
																															BgL_tmpz00_14182 =
																																(
																																(BgL_objectz00_bglt)
																																BgL_new1123z00_8485);
																															BGL_OBJECT_WIDENING_SET
																																(BgL_tmpz00_14182,
																																BFALSE);
																														}
																														((BgL_objectz00_bglt) BgL_new1123z00_8485);
																														BgL_new1125z00_8484
																															=
																															BgL_new1123z00_8485;
																													}
																													((((BgL_nodez00_bglt)
																																COBJECT((
																																		(BgL_nodez00_bglt)
																																		BgL_new1125z00_8484)))->
																															BgL_locz00) =
																														((obj_t)
																															BgL_locz00_8482),
																														BUNSPEC);
																													((((BgL_nodez00_bglt)
																																COBJECT((
																																		(BgL_nodez00_bglt)
																																		BgL_new1125z00_8484)))->
																															BgL_typez00) =
																														((BgL_typez00_bglt)
																															((BgL_typez00_bglt) BGl_za2_za2z00zztype_cachez00)), BUNSPEC);
																													((((BgL_nodezf2effectzf2_bglt) COBJECT(((BgL_nodezf2effectzf2_bglt) BgL_new1125z00_8484)))->BgL_sidezd2effectzd2) = ((obj_t) BUNSPEC), BUNSPEC);
																													((((BgL_nodezf2effectzf2_bglt) COBJECT(((BgL_nodezf2effectzf2_bglt) BgL_new1125z00_8484)))->BgL_keyz00) = ((obj_t) BINT(((long) -1))), BUNSPEC);
																													((((BgL_sequencez00_bglt) COBJECT(BgL_new1125z00_8484))->BgL_nodesz00) = ((obj_t) BgL_nodesz00_8483), BUNSPEC);
																													((((BgL_sequencez00_bglt) COBJECT(BgL_new1125z00_8484))->BgL_unsafez00) = ((bool_t) ((bool_t) 0)), BUNSPEC);
																													((((BgL_sequencez00_bglt) COBJECT(BgL_new1125z00_8484))->BgL_metaz00) = ((obj_t) BNIL), BUNSPEC);
																													BgL_auxz00_14175 =
																														BgL_new1125z00_8484;
																									}}}}
																									return
																										((BgL_nodez00_bglt)
																										BgL_auxz00_14175);
																								}
																							}
																					}
																				else
																					{	/* Ast/sexp.scm 118 */
																						obj_t BgL_carzd2610zd2_1804;
																						obj_t BgL_cdrzd2611zd2_1805;

																						BgL_carzd2610zd2_1804 =
																							CAR(BgL_expz00_21);
																						BgL_cdrzd2611zd2_1805 =
																							CDR(BgL_expz00_21);
																						{

																							if (
																								(BgL_carzd2610zd2_1804 ==
																									CNST_TABLE_REF(((long) 1))))
																								{
																									obj_t BgL_auxz00_14205;

																								BgL_kapzd2612zd2_1806:
																									if (PAIRP
																										(BgL_cdrzd2611zd2_1805))
																										{	/* Ast/sexp.scm 118 */
																											obj_t
																												BgL_cdrzd2615zd2_2553;
																											BgL_cdrzd2615zd2_2553 =
																												CDR
																												(BgL_cdrzd2611zd2_1805);
																											if (PAIRP
																												(BgL_cdrzd2615zd2_2553))
																												{	/* Ast/sexp.scm 118 */
																													obj_t
																														BgL_cdrzd2618zd2_2555;
																													BgL_cdrzd2618zd2_2555
																														=
																														CDR
																														(BgL_cdrzd2615zd2_2553);
																													if ((CAR
																															(BgL_cdrzd2615zd2_2553)
																															== BTRUE))
																														{	/* Ast/sexp.scm 118 */
																															if (PAIRP
																																(BgL_cdrzd2618zd2_2555))
																																{	/* Ast/sexp.scm 118 */
																																	if (
																																		(CAR
																																			(BgL_cdrzd2618zd2_2555)
																																			==
																																			BFALSE))
																																		{	/* Ast/sexp.scm 118 */
																																			if (NULLP
																																				(CDR
																																					(BgL_cdrzd2618zd2_2555)))
																																				{	/* Ast/sexp.scm 118 */
																																					if (
																																						(BgL_sitez00_24
																																							==
																																							CNST_TABLE_REF
																																							(((long) 8))))
																																						{	/* Ast/sexp.scm 118 */
																																							obj_t
																																								BgL_arg2246z00_2565;
																																							BgL_arg2246z00_2565
																																								=
																																								CAR
																																								(BgL_cdrzd2611zd2_1805);
																																							BgL_auxz00_14205
																																								=
																																								(
																																								(obj_t)
																																								BGl_sexpzd2ze3nodez31zzast_sexpz00
																																								(BgL_arg2246z00_2565,
																																									BgL_stackz00_22,
																																									BgL_locz00_23,
																																									BgL_sitez00_24));
																																						}
																																					else
																																						{	/* Ast/sexp.scm 118 */
																																							obj_t
																																								BgL_carzd2637zd2_2566;
																																							BgL_carzd2637zd2_2566
																																								=
																																								CAR
																																								(
																																								((obj_t) BgL_expz00_21));
																																							if ((BgL_carzd2637zd2_2566 == CNST_TABLE_REF(((long) 1))))
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_14234;
																																								BgL_tagzd2377zd2_1719:
																																									{
																																										obj_t
																																											BgL_siz00_8487;
																																										obj_t
																																											BgL_alorsz00_8488;
																																										obj_t
																																											BgL_sinonz00_8489;
																																										obj_t
																																											BgL_siz00_8491;
																																										obj_t
																																											BgL_alorsz00_8492;
																																										if (PAIRP(BgL_expz00_21))
																																											{	/* Ast/sexp.scm 118 */
																																												obj_t
																																													BgL_cdrzd262200zd2_8497;
																																												BgL_cdrzd262200zd2_8497
																																													=
																																													CDR
																																													(BgL_expz00_21);
																																												if (PAIRP(BgL_cdrzd262200zd2_8497))
																																													{	/* Ast/sexp.scm 118 */
																																														obj_t
																																															BgL_cdrzd262205zd2_8499;
																																														BgL_cdrzd262205zd2_8499
																																															=
																																															CDR
																																															(BgL_cdrzd262200zd2_8497);
																																														if (PAIRP(BgL_cdrzd262205zd2_8499))
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_cdrzd262210zd2_8501;
																																																BgL_cdrzd262210zd2_8501
																																																	=
																																																	CDR
																																																	(BgL_cdrzd262205zd2_8499);
																																																if (PAIRP(BgL_cdrzd262210zd2_8501))
																																																	{	/* Ast/sexp.scm 118 */
																																																		if (NULLP(CDR(BgL_cdrzd262210zd2_8501)))
																																																			{	/* Ast/sexp.scm 118 */
																																																				BgL_siz00_8487
																																																					=
																																																					CAR
																																																					(BgL_cdrzd262200zd2_8497);
																																																				BgL_alorsz00_8488
																																																					=
																																																					CAR
																																																					(BgL_cdrzd262205zd2_8499);
																																																				BgL_sinonz00_8489
																																																					=
																																																					CAR
																																																					(BgL_cdrzd262210zd2_8501);
																																																				{	/* Ast/sexp.scm 240 */
																																																					obj_t
																																																						BgL_ntz00_8516;
																																																					BgL_ntz00_8516
																																																						=
																																																						BGl_notzd2testzd2zzast_sexpz00
																																																						(BgL_siz00_8487);
																																																					if (CBOOL(BgL_ntz00_8516))
																																																						{	/* Ast/sexp.scm 241 */
																																																							{	/* Ast/sexp.scm 243 */
																																																								obj_t
																																																									BgL_arg6707z00_8517;
																																																								BgL_arg6707z00_8517
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{	/* Ast/sexp.scm 243 */
																																																									obj_t
																																																										BgL_tmpz00_14254;
																																																									BgL_tmpz00_14254
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_arg6707z00_8517);
																																																									SET_CAR
																																																										(BgL_tmpz00_14254,
																																																										BgL_ntz00_8516);
																																																								}
																																																							}
																																																							{	/* Ast/sexp.scm 244 */
																																																								obj_t
																																																									BgL_arg6708z00_8518;
																																																								{	/* Ast/sexp.scm 244 */
																																																									obj_t
																																																										BgL_pairz00_9708;
																																																									BgL_pairz00_9708
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									BgL_arg6708z00_8518
																																																										=
																																																										CDR
																																																										(BgL_pairz00_9708);
																																																								}
																																																								{	/* Ast/sexp.scm 244 */
																																																									obj_t
																																																										BgL_tmpz00_14260;
																																																									BgL_tmpz00_14260
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_arg6708z00_8518);
																																																									SET_CAR
																																																										(BgL_tmpz00_14260,
																																																										BgL_sinonz00_8489);
																																																								}
																																																							}
																																																							{	/* Ast/sexp.scm 245 */
																																																								obj_t
																																																									BgL_arg6709z00_8519;
																																																								{	/* Ast/sexp.scm 245 */
																																																									obj_t
																																																										BgL_pairz00_9715;
																																																									{	/* Ast/sexp.scm 245 */
																																																										obj_t
																																																											BgL_pairz00_9714;
																																																										BgL_pairz00_9714
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_pairz00_9715
																																																											=
																																																											CDR
																																																											(BgL_pairz00_9714);
																																																									}
																																																									BgL_arg6709z00_8519
																																																										=
																																																										CDR
																																																										(BgL_pairz00_9715);
																																																								}
																																																								{	/* Ast/sexp.scm 245 */
																																																									obj_t
																																																										BgL_tmpz00_14267;
																																																									BgL_tmpz00_14267
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_arg6709z00_8519);
																																																									SET_CAR
																																																										(BgL_tmpz00_14267,
																																																										BgL_alorsz00_8488);
																																																								}
																																																							}
																																																							BgL_auxz00_14234
																																																								=
																																																								BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																								(BgL_expz00_21,
																																																								BgL_stackz00_22,
																																																								BgL_locz00_23,
																																																								BgL_sitez00_24);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 247 */
																																																							obj_t
																																																								BgL_locz00_8520;
																																																							BgL_locz00_8520
																																																								=
																																																								BGl_findzd2locationzf2locz20zztools_locationz00
																																																								(BgL_expz00_21,
																																																								BgL_locz00_23);
																																																							{	/* Ast/sexp.scm 247 */
																																																								obj_t
																																																									BgL_cdlocz00_8521;
																																																								{	/* Ast/sexp.scm 248 */
																																																									obj_t
																																																										BgL_arg6729z00_8555;
																																																									BgL_arg6729z00_8555
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									BgL_cdlocz00_8521
																																																										=
																																																										BGl_findzd2locationzf2locz20zztools_locationz00
																																																										(BgL_arg6729z00_8555,
																																																										BgL_locz00_8520);
																																																								}
																																																								{	/* Ast/sexp.scm 248 */
																																																									obj_t
																																																										BgL_cddlocz00_8522;
																																																									{	/* Ast/sexp.scm 249 */
																																																										obj_t
																																																											BgL_arg6728z00_8554;
																																																										{	/* Ast/sexp.scm 249 */
																																																											obj_t
																																																												BgL_pairz00_9721;
																																																											BgL_pairz00_9721
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											BgL_arg6728z00_8554
																																																												=
																																																												CDR
																																																												(BgL_pairz00_9721);
																																																										}
																																																										BgL_cddlocz00_8522
																																																											=
																																																											BGl_findzd2locationzf2locz20zztools_locationz00
																																																											(BgL_arg6728z00_8554,
																																																											BgL_locz00_8520);
																																																									}
																																																									{	/* Ast/sexp.scm 249 */
																																																										obj_t
																																																											BgL_cdddlocz00_8523;
																																																										{	/* Ast/sexp.scm 250 */
																																																											obj_t
																																																												BgL_arg6727z00_8553;
																																																											{	/* Ast/sexp.scm 250 */
																																																												obj_t
																																																													BgL_pairz00_9727;
																																																												{	/* Ast/sexp.scm 250 */
																																																													obj_t
																																																														BgL_pairz00_9726;
																																																													BgL_pairz00_9726
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													BgL_pairz00_9727
																																																														=
																																																														CDR
																																																														(BgL_pairz00_9726);
																																																												}
																																																												BgL_arg6727z00_8553
																																																													=
																																																													CDR
																																																													(BgL_pairz00_9727);
																																																											}
																																																											BgL_cdddlocz00_8523
																																																												=
																																																												BGl_findzd2locationzf2locz20zztools_locationz00
																																																												(BgL_arg6727z00_8553,
																																																												BgL_locz00_8520);
																																																										}
																																																										{	/* Ast/sexp.scm 250 */
																																																											obj_t
																																																												BgL_lzd2sizd2_8524;
																																																											BgL_lzd2sizd2_8524
																																																												=
																																																												BGl_findzd2locationzf2locz20zztools_locationz00
																																																												(BgL_siz00_8487,
																																																												BgL_cdlocz00_8521);
																																																											{	/* Ast/sexp.scm 251 */
																																																												obj_t
																																																													BgL_lzd2alorszd2_8525;
																																																												BgL_lzd2alorszd2_8525
																																																													=
																																																													BGl_findzd2locationzf2locz20zztools_locationz00
																																																													(BgL_alorsz00_8488,
																																																													BgL_cddlocz00_8522);
																																																												{	/* Ast/sexp.scm 252 */
																																																													obj_t
																																																														BgL_lzd2sinonzd2_8526;
																																																													BgL_lzd2sinonzd2_8526
																																																														=
																																																														BGl_findzd2locationzf2locz20zztools_locationz00
																																																														(BgL_sinonz00_8489,
																																																														BgL_cdddlocz00_8523);
																																																													{	/* Ast/sexp.scm 253 */
																																																														BgL_nodez00_bglt
																																																															BgL_testz00_8527;
																																																														BgL_testz00_8527
																																																															=
																																																															BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																															(BgL_siz00_8487,
																																																															BgL_stackz00_22,
																																																															BgL_locz00_8520,
																																																															CNST_TABLE_REF
																																																															(((long) 8)));
																																																														{	/* Ast/sexp.scm 254 */

																																																															{	/* Ast/sexp.scm 256 */
																																																																bool_t
																																																																	BgL_test8138z00_14289;
																																																																{	/* Ast/sexp.scm 256 */
																																																																	bool_t
																																																																		BgL_res7352z00_9728;
																																																																	BgL_res7352z00_9728
																																																																		=
																																																																		BGl_isazf3zf3zz__objectz00
																																																																		(
																																																																		((obj_t) BgL_testz00_8527), BGl_atomz00zzast_nodez00);
																																																																	BgL_test8138z00_14289
																																																																		=
																																																																		BgL_res7352z00_9728;
																																																																}
																																																																if (BgL_test8138z00_14289)
																																																																	{	/* Ast/sexp.scm 256 */
																																																																		if (CBOOL((((BgL_atomz00_bglt) COBJECT(((BgL_atomz00_bglt) BgL_testz00_8527)))->BgL_valuez00)))
																																																																			{	/* Ast/sexp.scm 258 */
																																																																				BgL_auxz00_14234
																																																																					=
																																																																					BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																					(BgL_alorsz00_8488,
																																																																					BgL_stackz00_22,
																																																																					BgL_lzd2alorszd2_8525,
																																																																					CNST_TABLE_REF
																																																																					(((long) 2)));
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 258 */
																																																																				BgL_auxz00_14234
																																																																					=
																																																																					BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																					(BgL_sinonz00_8489,
																																																																					BgL_stackz00_22,
																																																																					BgL_lzd2sinonzd2_8526,
																																																																					CNST_TABLE_REF
																																																																					(((long) 2)));
																																																																	}}
																																																																else
																																																																	{	/* Ast/sexp.scm 261 */
																																																																		bool_t
																																																																			BgL_test8140z00_14300;
																																																																		{	/* Ast/sexp.scm 261 */
																																																																			bool_t
																																																																				BgL_res7353z00_9729;
																																																																			BgL_res7353z00_9729
																																																																				=
																																																																				BGl_isazf3zf3zz__objectz00
																																																																				(
																																																																				((obj_t) BgL_testz00_8527), BGl_kwotez00zzast_nodez00);
																																																																			BgL_test8140z00_14300
																																																																				=
																																																																				BgL_res7353z00_9729;
																																																																		}
																																																																		if (BgL_test8140z00_14300)
																																																																			{	/* Ast/sexp.scm 261 */
																																																																				BgL_auxz00_14234
																																																																					=
																																																																					BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																					(BgL_alorsz00_8488,
																																																																					BgL_stackz00_22,
																																																																					BgL_lzd2alorszd2_8525,
																																																																					CNST_TABLE_REF
																																																																					(((long) 2)));
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 263 */
																																																																				bool_t
																																																																					BgL_test8141z00_14305;
																																																																				{	/* Ast/sexp.scm 263 */
																																																																					bool_t
																																																																						BgL_res7354z00_9730;
																																																																					BgL_res7354z00_9730
																																																																						=
																																																																						BGl_isazf3zf3zz__objectz00
																																																																						(
																																																																						((obj_t) BgL_testz00_8527), BGl_varz00zzast_nodez00);
																																																																					BgL_test8141z00_14305
																																																																						=
																																																																						BgL_res7354z00_9730;
																																																																				}
																																																																				if (BgL_test8141z00_14305)
																																																																					{	/* Ast/sexp.scm 264 */
																																																																						BgL_nodez00_bglt
																																																																							BgL_alorsz00_8533;
																																																																						BgL_nodez00_bglt
																																																																							BgL_sinonz00_8534;
																																																																						BgL_alorsz00_8533
																																																																							=
																																																																							BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																							(BgL_alorsz00_8488,
																																																																							BgL_stackz00_22,
																																																																							BgL_lzd2alorszd2_8525,
																																																																							CNST_TABLE_REF
																																																																							(((long) 2)));
																																																																						BgL_sinonz00_8534
																																																																							=
																																																																							BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																							(BgL_sinonz00_8489,
																																																																							BgL_stackz00_22,
																																																																							BgL_lzd2sinonzd2_8526,
																																																																							CNST_TABLE_REF
																																																																							(((long) 2)));
																																																																						{	/* Ast/sexp.scm 266 */
																																																																							BgL_conditionalz00_bglt
																																																																								BgL_new1129z00_8535;
																																																																							{	/* Ast/sexp.scm 267 */
																																																																								BgL_conditionalz00_bglt
																																																																									BgL_new1127z00_8536;
																																																																								BgL_new1127z00_8536
																																																																									=
																																																																									(
																																																																									(BgL_conditionalz00_bglt)
																																																																									BOBJECT
																																																																									(GC_MALLOC
																																																																										(sizeof
																																																																											(struct
																																																																												BgL_conditionalz00_bgl))));
																																																																								{	/* Ast/sexp.scm 267 */
																																																																									long
																																																																										BgL_arg6714z00_8537;
																																																																									{	/* Ast/sexp.scm 267 */
																																																																										long
																																																																											BgL_res7355z00_9732;
																																																																										BgL_res7355z00_9732
																																																																											=
																																																																											BGL_CLASS_INDEX
																																																																											(BGl_conditionalz00zzast_nodez00);
																																																																										BgL_arg6714z00_8537
																																																																											=
																																																																											BgL_res7355z00_9732;
																																																																									}
																																																																									BGL_OBJECT_CLASS_NUM_SET
																																																																										(
																																																																										((BgL_objectz00_bglt) BgL_new1127z00_8536), BgL_arg6714z00_8537);
																																																																								}
																																																																								{	/* Ast/sexp.scm 267 */
																																																																									BgL_objectz00_bglt
																																																																										BgL_tmpz00_14316;
																																																																									BgL_tmpz00_14316
																																																																										=
																																																																										(
																																																																										(BgL_objectz00_bglt)
																																																																										BgL_new1127z00_8536);
																																																																									BGL_OBJECT_WIDENING_SET
																																																																										(BgL_tmpz00_14316,
																																																																										BFALSE);
																																																																								}
																																																																								((BgL_objectz00_bglt) BgL_new1127z00_8536);
																																																																								BgL_new1129z00_8535
																																																																									=
																																																																									BgL_new1127z00_8536;
																																																																							}
																																																																							((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1129z00_8535)))->BgL_locz00) = ((obj_t) BgL_locz00_8520), BUNSPEC);
																																																																							((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1129z00_8535)))->BgL_typez00) = ((BgL_typez00_bglt) ((BgL_typez00_bglt) BGl_za2_za2z00zztype_cachez00)), BUNSPEC);
																																																																							((((BgL_nodezf2effectzf2_bglt) COBJECT(((BgL_nodezf2effectzf2_bglt) BgL_new1129z00_8535)))->BgL_sidezd2effectzd2) = ((obj_t) BUNSPEC), BUNSPEC);
																																																																							((((BgL_nodezf2effectzf2_bglt) COBJECT(((BgL_nodezf2effectzf2_bglt) BgL_new1129z00_8535)))->BgL_keyz00) = ((obj_t) BINT(((long) -1))), BUNSPEC);
																																																																							((((BgL_conditionalz00_bglt) COBJECT(BgL_new1129z00_8535))->BgL_testz00) = ((BgL_nodez00_bglt) BgL_testz00_8527), BUNSPEC);
																																																																							((((BgL_conditionalz00_bglt) COBJECT(BgL_new1129z00_8535))->BgL_truez00) = ((BgL_nodez00_bglt) BgL_alorsz00_8533), BUNSPEC);
																																																																							((((BgL_conditionalz00_bglt) COBJECT(BgL_new1129z00_8535))->BgL_falsez00) = ((BgL_nodez00_bglt) BgL_sinonz00_8534), BUNSPEC);
																																																																							BgL_auxz00_14234
																																																																								=
																																																																								(
																																																																								(BgL_nodez00_bglt)
																																																																								BgL_new1129z00_8535);
																																																																					}}
																																																																				else
																																																																					{	/* Ast/sexp.scm 273 */
																																																																						obj_t
																																																																							BgL_vz00_8538;
																																																																						BgL_vz00_8538
																																																																							=
																																																																							BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
																																																																							(BGl_gensymz00zz__r4_symbols_6_4z00
																																																																							(CNST_TABLE_REF
																																																																								(((long) 8))));
																																																																						{	/* Ast/sexp.scm 273 */
																																																																							obj_t
																																																																								BgL_varz00_8539;
																																																																							BgL_varz00_8539
																																																																								=
																																																																								BGl_makezd2typedzd2identz00zzast_identz00
																																																																								(BgL_vz00_8538,
																																																																								CNST_TABLE_REF
																																																																								(((long) 9)));
																																																																							{	/* Ast/sexp.scm 274 */
																																																																								obj_t
																																																																									BgL_nexpz00_8540;
																																																																								{	/* Ast/sexp.scm 275 */
																																																																									obj_t
																																																																										BgL_arg6722z00_8548;
																																																																									{	/* Ast/sexp.scm 275 */
																																																																										obj_t
																																																																											BgL_arg6723z00_8549;
																																																																										{	/* Ast/sexp.scm 275 */
																																																																											obj_t
																																																																												BgL_arg6724z00_8550;
																																																																											{	/* Ast/sexp.scm 275 */
																																																																												obj_t
																																																																													BgL_arg6725z00_8551;
																																																																												BgL_arg6725z00_8551
																																																																													=
																																																																													MAKE_YOUNG_PAIR
																																																																													(BgL_sinonz00_8489,
																																																																													BNIL);
																																																																												BgL_arg6724z00_8550
																																																																													=
																																																																													MAKE_YOUNG_PAIR
																																																																													(BgL_alorsz00_8488,
																																																																													BgL_arg6725z00_8551);
																																																																											}
																																																																											BgL_arg6723z00_8549
																																																																												=
																																																																												MAKE_YOUNG_PAIR
																																																																												(BgL_vz00_8538,
																																																																												BgL_arg6724z00_8550);
																																																																										}
																																																																										BgL_arg6722z00_8548
																																																																											=
																																																																											MAKE_YOUNG_PAIR
																																																																											(CNST_TABLE_REF
																																																																											(((long) 1)), BgL_arg6723z00_8549);
																																																																									}
																																																																									BgL_nexpz00_8540
																																																																										=
																																																																										BGl_epairifyzd2reczd2zztools_miscz00
																																																																										(BgL_arg6722z00_8548,
																																																																										BgL_expz00_21);
																																																																								}
																																																																								{	/* Ast/sexp.scm 275 */

																																																																									{	/* Ast/sexp.scm 276 */
																																																																										obj_t
																																																																											BgL_arg6715z00_8541;
																																																																										{	/* Ast/sexp.scm 276 */
																																																																											obj_t
																																																																												BgL_arg6716z00_8542;
																																																																											obj_t
																																																																												BgL_arg6717z00_8543;
																																																																											BgL_arg6716z00_8542
																																																																												=
																																																																												BGl_letzd2symzd2zzast_letz00
																																																																												();
																																																																											{	/* Ast/sexp.scm 276 */
																																																																												obj_t
																																																																													BgL_arg6718z00_8544;
																																																																												obj_t
																																																																													BgL_arg6719z00_8545;
																																																																												{	/* Ast/sexp.scm 276 */
																																																																													obj_t
																																																																														BgL_arg6720z00_8546;
																																																																													{	/* Ast/sexp.scm 276 */
																																																																														obj_t
																																																																															BgL_arg6721z00_8547;
																																																																														BgL_arg6721z00_8547
																																																																															=
																																																																															MAKE_YOUNG_PAIR
																																																																															(BgL_siz00_8487,
																																																																															BNIL);
																																																																														BgL_arg6720z00_8546
																																																																															=
																																																																															MAKE_YOUNG_PAIR
																																																																															(BgL_varz00_8539,
																																																																															BgL_arg6721z00_8547);
																																																																													}
																																																																													BgL_arg6718z00_8544
																																																																														=
																																																																														MAKE_YOUNG_PAIR
																																																																														(BgL_arg6720z00_8546,
																																																																														BNIL);
																																																																												}
																																																																												BgL_arg6719z00_8545
																																																																													=
																																																																													MAKE_YOUNG_PAIR
																																																																													(BgL_nexpz00_8540,
																																																																													BNIL);
																																																																												BgL_arg6717z00_8543
																																																																													=
																																																																													MAKE_YOUNG_PAIR
																																																																													(BgL_arg6718z00_8544,
																																																																													BgL_arg6719z00_8545);
																																																																											}
																																																																											BgL_arg6715z00_8541
																																																																												=
																																																																												MAKE_YOUNG_PAIR
																																																																												(BgL_arg6716z00_8542,
																																																																												BgL_arg6717z00_8543);
																																																																										}
																																																																										BGl_replacez12z12zztools_miscz00
																																																																											(BgL_expz00_21,
																																																																											BgL_arg6715z00_8541);
																																																																									}
																																																																									BgL_auxz00_14234
																																																																										=
																																																																										BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																										(BgL_expz00_21,
																																																																										BgL_stackz00_22,
																																																																										BgL_locz00_8520,
																																																																										BgL_sitez00_24);
																																																			}}}}}}}}}}}}}}}}}}
																																																		else
																																																			{	/* Ast/sexp.scm 118 */
																																																			BgL_tagzd262191zd2_8494:
																																																				{	/* Ast/sexp.scm 282 */
																																																					BgL_nodez00_bglt
																																																						BgL_res7357z00_9747;
																																																					{	/* Ast/sexp.scm 722 */
																																																						obj_t
																																																							BgL_arg7104z00_9743;
																																																						BgL_nodez00_bglt
																																																							BgL_arg7105z00_9744;
																																																						BgL_arg7104z00_9743
																																																							=
																																																							BGl_shapez00zztools_shapez00
																																																							(BGl_currentzd2functionzd2zztools_errorz00
																																																							());
																																																						BgL_arg7105z00_9744
																																																							=
																																																							BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																							(CNST_TABLE_REF
																																																							(((long) 4)), BNIL, BgL_locz00_23, CNST_TABLE_REF(((long) 2)));
																																																						{	/* Ast/sexp.scm 721 */
																																																							obj_t
																																																								BgL_list7106z00_9746;
																																																							BgL_list7106z00_9746
																																																								=
																																																								MAKE_YOUNG_PAIR
																																																								(
																																																								((obj_t) BgL_arg7105z00_9744), BNIL);
																																																							BgL_res7357z00_9747
																																																								=
																																																								(
																																																								(BgL_nodez00_bglt)
																																																								BGl_userzd2errorzf2locationz20zztools_errorz00
																																																								(BgL_locz00_23,
																																																									BgL_arg7104z00_9743,
																																																									BGl_string7999z00zzast_sexpz00,
																																																									BgL_expz00_21,
																																																									BgL_list7106z00_9746));
																																																					}}
																																																					BgL_auxz00_14234
																																																						=
																																																						BgL_res7357z00_9747;
																																																	}}}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_cdrzd262235zd2_8510;
																																																		BgL_cdrzd262235zd2_8510
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_cdrzd262200zd2_8497));
																																																		if (NULLP(CDR(((obj_t) BgL_cdrzd262235zd2_8510))))
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_arg6704z00_8513;
																																																				obj_t
																																																					BgL_arg6705z00_8514;
																																																				BgL_arg6704z00_8513
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_cdrzd262200zd2_8497));
																																																				BgL_arg6705z00_8514
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_cdrzd262235zd2_8510));
																																																				BgL_siz00_8491
																																																					=
																																																					BgL_arg6704z00_8513;
																																																				BgL_alorsz00_8492
																																																					=
																																																					BgL_arg6705z00_8514;
																																																				{	/* Ast/sexp.scm 279 */
																																																					obj_t
																																																						BgL_arg6730z00_8556;
																																																					obj_t
																																																						BgL_arg6731z00_8557;
																																																					{	/* Ast/sexp.scm 279 */
																																																						obj_t
																																																							BgL_pairz00_9739;
																																																						BgL_pairz00_9739
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_arg6730z00_8556
																																																							=
																																																							CDR
																																																							(BgL_pairz00_9739);
																																																					}
																																																					{	/* Ast/sexp.scm 279 */
																																																						obj_t
																																																							BgL_list6732z00_8558;
																																																						BgL_list6732z00_8558
																																																							=
																																																							MAKE_YOUNG_PAIR
																																																							(BUNSPEC,
																																																							BNIL);
																																																						BgL_arg6731z00_8557
																																																							=
																																																							BgL_list6732z00_8558;
																																																					}
																																																					{	/* Ast/sexp.scm 279 */
																																																						obj_t
																																																							BgL_tmpz00_14380;
																																																						BgL_tmpz00_14380
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_arg6730z00_8556);
																																																						SET_CDR
																																																							(BgL_tmpz00_14380,
																																																							BgL_arg6731z00_8557);
																																																					}
																																																				}
																																																				BgL_auxz00_14234
																																																					=
																																																					BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																					(BgL_expz00_21,
																																																					BgL_stackz00_22,
																																																					BgL_locz00_23,
																																																					BgL_sitez00_24);
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 118 */
																																																				goto
																																																					BgL_tagzd262191zd2_8494;
																																																			}
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																goto
																																																	BgL_tagzd262191zd2_8494;
																																															}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														goto
																																															BgL_tagzd262191zd2_8494;
																																													}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 118 */
																																												goto
																																													BgL_tagzd262191zd2_8494;
																																											}
																																									}
																																									BgL_auxz00_14205
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_14234);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 118 */
																																									if ((BgL_carzd2637zd2_2566 == BGl_za2ifza2z00zzast_sexpz00))
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_14387;
																																											goto
																																												BgL_tagzd2377zd2_1719;
																																											BgL_auxz00_14205
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_14387);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 118 */
																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 7))))
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_14394;
																																												BgL_tagzd2379zd2_1723:
																																													{
																																														obj_t
																																															BgL_varz00_8585;
																																														obj_t
																																															BgL_valz00_8586;
																																														if (PAIRP(BgL_expz00_21))
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_cdrzd262265zd2_8591;
																																																BgL_cdrzd262265zd2_8591
																																																	=
																																																	CDR
																																																	(BgL_expz00_21);
																																																if (PAIRP(BgL_cdrzd262265zd2_8591))
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_cdrzd262269zd2_8593;
																																																		BgL_cdrzd262269zd2_8593
																																																			=
																																																			CDR
																																																			(BgL_cdrzd262265zd2_8591);
																																																		if (PAIRP(BgL_cdrzd262269zd2_8593))
																																																			{	/* Ast/sexp.scm 118 */
																																																				if (NULLP(CDR(BgL_cdrzd262269zd2_8593)))
																																																					{	/* Ast/sexp.scm 118 */
																																																						BgL_varz00_8585
																																																							=
																																																							CAR
																																																							(BgL_cdrzd262265zd2_8591);
																																																						BgL_valz00_8586
																																																							=
																																																							CAR
																																																							(BgL_cdrzd262269zd2_8593);
																																																						{	/* Ast/sexp.scm 291 */
																																																							obj_t
																																																								BgL_locz00_8600;
																																																							BgL_locz00_8600
																																																								=
																																																								BGl_findzd2locationzf2locz20zztools_locationz00
																																																								(BgL_expz00_21,
																																																								BgL_locz00_23);
																																																							{	/* Ast/sexp.scm 291 */
																																																								obj_t
																																																									BgL_cdlocz00_8601;
																																																								{	/* Ast/sexp.scm 292 */
																																																									obj_t
																																																										BgL_arg6769z00_8628;
																																																									BgL_arg6769z00_8628
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									BgL_cdlocz00_8601
																																																										=
																																																										BGl_findzd2locationzf2locz20zztools_locationz00
																																																										(BgL_arg6769z00_8628,
																																																										BgL_locz00_8600);
																																																								}
																																																								{	/* Ast/sexp.scm 292 */
																																																									obj_t
																																																										BgL_cddlocz00_8602;
																																																									{	/* Ast/sexp.scm 293 */
																																																										obj_t
																																																											BgL_arg6768z00_8627;
																																																										{	/* Ast/sexp.scm 293 */
																																																											obj_t
																																																												BgL_pairz00_9783;
																																																											BgL_pairz00_9783
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											BgL_arg6768z00_8627
																																																												=
																																																												CDR
																																																												(BgL_pairz00_9783);
																																																										}
																																																										BgL_cddlocz00_8602
																																																											=
																																																											BGl_findzd2locationzf2locz20zztools_locationz00
																																																											(BgL_arg6768z00_8627,
																																																											BgL_locz00_8600);
																																																									}
																																																									{	/* Ast/sexp.scm 293 */
																																																										obj_t
																																																											BgL_valzd2loczd2_8603;
																																																										BgL_valzd2loczd2_8603
																																																											=
																																																											BGl_findzd2locationzf2locz20zztools_locationz00
																																																											(BgL_valz00_8586,
																																																											BgL_cddlocz00_8602);
																																																										{	/* Ast/sexp.scm 294 */
																																																											BgL_nodez00_bglt
																																																												BgL_valz00_8604;
																																																											{

																																																												if (PAIRP(BgL_valz00_8586))
																																																													{	/* Ast/sexp.scm 295 */
																																																														if ((CAR(BgL_valz00_8586) == CNST_TABLE_REF(((long) 3))))
																																																															{	/* Ast/sexp.scm 295 */
																																																																{	/* Ast/sexp.scm 298 */
																																																																	obj_t
																																																																		BgL_arg6767z00_8626;
																																																																	{	/* Ast/sexp.scm 298 */
																																																																		obj_t
																																																																			BgL_res7369z00_9786;
																																																																		{	/* Ast/sexp.scm 298 */
																																																																			obj_t
																																																																				BgL_arg1409z00_9785;
																																																																			BgL_arg1409z00_9785
																																																																				=
																																																																				SYMBOL_TO_STRING
																																																																				(
																																																																				((obj_t) BgL_varz00_8585));
																																																																			BgL_res7369z00_9786
																																																																				=
																																																																				BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																																																																				(BgL_arg1409z00_9785);
																																																																		}
																																																																		BgL_arg6767z00_8626
																																																																			=
																																																																			BgL_res7369z00_9786;
																																																																	}
																																																																	BgL_valz00_8604
																																																																		=
																																																																		BGl_lambdazd2ze3nodez31zzast_sexpz00
																																																																		(BgL_valz00_8586,
																																																																		BgL_stackz00_22,
																																																																		BgL_valzd2loczd2_8603,
																																																																		CNST_TABLE_REF
																																																																		(((long) 2)), BgL_arg6767z00_8626);
																																																															}}
																																																														else
																																																															{	/* Ast/sexp.scm 295 */
																																																															BgL_tagzd262276zd2_8620:
																																																																BgL_valz00_8604 = BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_valz00_8586, BgL_stackz00_22, BgL_valzd2loczd2_8603, CNST_TABLE_REF(((long) 2)));
																																																													}}
																																																												else
																																																													{	/* Ast/sexp.scm 295 */
																																																														goto
																																																															BgL_tagzd262276zd2_8620;
																																																													}
																																																											}
																																																											{	/* Ast/sexp.scm 295 */

																																																												{	/* Ast/sexp.scm 301 */
																																																													BgL_nodez00_bglt
																																																														BgL_astz00_8605;
																																																													BgL_astz00_8605
																																																														=
																																																														BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																														(BgL_varz00_8585,
																																																														BgL_stackz00_22,
																																																														BgL_cdlocz00_8601,
																																																														CNST_TABLE_REF
																																																														(((long) 7)));
																																																													{	/* Ast/sexp.scm 302 */
																																																														bool_t
																																																															BgL_test8151z00_14430;
																																																														{	/* Ast/sexp.scm 302 */
																																																															bool_t
																																																																BgL_res7371z00_9789;
																																																															BgL_res7371z00_9789
																																																																=
																																																																BGl_isazf3zf3zz__objectz00
																																																																(
																																																																((obj_t) BgL_astz00_8605), BGl_varz00zzast_nodez00);
																																																															BgL_test8151z00_14430
																																																																=
																																																																BgL_res7371z00_9789;
																																																														}
																																																														if (BgL_test8151z00_14430)
																																																															{	/* Ast/sexp.scm 304 */
																																																																bool_t
																																																																	BgL_test8152z00_14433;
																																																																{	/* Ast/sexp.scm 304 */
																																																																	bool_t
																																																																		BgL_test8153z00_14434;
																																																																	{	/* Ast/sexp.scm 304 */
																																																																		BgL_variablez00_bglt
																																																																			BgL_arg6762z00_8618;
																																																																		BgL_arg6762z00_8618
																																																																			=
																																																																			(
																																																																			((BgL_varz00_bglt) COBJECT(((BgL_varz00_bglt) BgL_astz00_8605)))->BgL_variablez00);
																																																																		{	/* Ast/sexp.scm 304 */
																																																																			bool_t
																																																																				BgL_res7372z00_9790;
																																																																			BgL_res7372z00_9790
																																																																				=
																																																																				BGl_isazf3zf3zz__objectz00
																																																																				(
																																																																				((obj_t) BgL_arg6762z00_8618), BGl_globalz00zzast_varz00);
																																																																			BgL_test8153z00_14434
																																																																				=
																																																																				BgL_res7372z00_9790;
																																																																		}
																																																																	}
																																																																	if (BgL_test8153z00_14434)
																																																																		{	/* Ast/sexp.scm 305 */
																																																																			BgL_variablez00_bglt
																																																																				BgL_arg6761z00_8617;
																																																																			BgL_arg6761z00_8617
																																																																				=
																																																																				(
																																																																				((BgL_varz00_bglt) COBJECT(((BgL_varz00_bglt) BgL_astz00_8605)))->BgL_variablez00);
																																																																			BgL_test8152z00_14433
																																																																				=
																																																																				BGl_globalzd2readzd2onlyzf3zf3zzast_varz00
																																																																				(
																																																																				((BgL_globalz00_bglt) BgL_arg6761z00_8617));
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 304 */
																																																																			BgL_test8152z00_14433
																																																																				=
																																																																				(
																																																																				(bool_t)
																																																																				0);
																																																																		}
																																																																}
																																																																if (BgL_test8152z00_14433)
																																																																	{	/* Ast/sexp.scm 306 */
																																																																		BgL_nodez00_bglt
																																																																			BgL_res7373z00_9796;
																																																																		{	/* Ast/sexp.scm 722 */
																																																																			obj_t
																																																																				BgL_arg7104z00_9792;
																																																																			BgL_nodez00_bglt
																																																																				BgL_arg7105z00_9793;
																																																																			BgL_arg7104z00_9792
																																																																				=
																																																																				BGl_shapez00zztools_shapez00
																																																																				(BGl_currentzd2functionzd2zztools_errorz00
																																																																				());
																																																																			BgL_arg7105z00_9793
																																																																				=
																																																																				BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																				(CNST_TABLE_REF
																																																																				(((long) 4)), BNIL, BgL_cdlocz00_8601, CNST_TABLE_REF(((long) 2)));
																																																																			{	/* Ast/sexp.scm 721 */
																																																																				obj_t
																																																																					BgL_list7106z00_9795;
																																																																				BgL_list7106z00_9795
																																																																					=
																																																																					MAKE_YOUNG_PAIR
																																																																					(
																																																																					((obj_t) BgL_arg7105z00_9793), BNIL);
																																																																				BgL_res7373z00_9796
																																																																					=
																																																																					(
																																																																					(BgL_nodez00_bglt)
																																																																					BGl_userzd2errorzf2locationz20zztools_errorz00
																																																																					(BgL_cdlocz00_8601,
																																																																						BgL_arg7104z00_9792,
																																																																						BGl_string7996z00zzast_sexpz00,
																																																																						BgL_expz00_21,
																																																																						BgL_list7106z00_9795));
																																																																		}}
																																																																		BgL_auxz00_14394
																																																																			=
																																																																			BgL_res7373z00_9796;
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 308 */
																																																																		BgL_setqz00_bglt
																																																																			BgL_new1133z00_8613;
																																																																		{	/* Ast/sexp.scm 309 */
																																																																			BgL_setqz00_bglt
																																																																				BgL_new1131z00_8614;
																																																																			BgL_new1131z00_8614
																																																																				=
																																																																				(
																																																																				(BgL_setqz00_bglt)
																																																																				BOBJECT
																																																																				(GC_MALLOC
																																																																					(sizeof
																																																																						(struct
																																																																							BgL_setqz00_bgl))));
																																																																			{	/* Ast/sexp.scm 309 */
																																																																				long
																																																																					BgL_arg6760z00_8615;
																																																																				{	/* Ast/sexp.scm 309 */
																																																																					long
																																																																						BgL_res7374z00_9798;
																																																																					BgL_res7374z00_9798
																																																																						=
																																																																						BGL_CLASS_INDEX
																																																																						(BGl_setqz00zzast_nodez00);
																																																																					BgL_arg6760z00_8615
																																																																						=
																																																																						BgL_res7374z00_9798;
																																																																				}
																																																																				BGL_OBJECT_CLASS_NUM_SET
																																																																					(
																																																																					((BgL_objectz00_bglt) BgL_new1131z00_8614), BgL_arg6760z00_8615);
																																																																			}
																																																																			{	/* Ast/sexp.scm 309 */
																																																																				BgL_objectz00_bglt
																																																																					BgL_tmpz00_14456;
																																																																				BgL_tmpz00_14456
																																																																					=
																																																																					(
																																																																					(BgL_objectz00_bglt)
																																																																					BgL_new1131z00_8614);
																																																																				BGL_OBJECT_WIDENING_SET
																																																																					(BgL_tmpz00_14456,
																																																																					BFALSE);
																																																																			}
																																																																			((BgL_objectz00_bglt) BgL_new1131z00_8614);
																																																																			BgL_new1133z00_8613
																																																																				=
																																																																				BgL_new1131z00_8614;
																																																																		}
																																																																		((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1133z00_8613)))->BgL_locz00) = ((obj_t) BgL_locz00_8600), BUNSPEC);
																																																																		((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1133z00_8613)))->BgL_typez00) = ((BgL_typez00_bglt) ((BgL_typez00_bglt) BGl_za2unspecza2z00zztype_cachez00)), BUNSPEC);
																																																																		((((BgL_setqz00_bglt) COBJECT(BgL_new1133z00_8613))->BgL_varz00) = ((BgL_varz00_bglt) ((BgL_varz00_bglt) BgL_astz00_8605)), BUNSPEC);
																																																																		((((BgL_setqz00_bglt) COBJECT(BgL_new1133z00_8613))->BgL_valuez00) = ((BgL_nodez00_bglt) BgL_valz00_8604), BUNSPEC);
																																																																		BgL_auxz00_14394
																																																																			=
																																																																			(
																																																																			(BgL_nodez00_bglt)
																																																																			BgL_new1133z00_8613);
																																																															}}
																																																														else
																																																															{	/* Ast/sexp.scm 313 */
																																																																BgL_nodez00_bglt
																																																																	BgL_res7375z00_9807;
																																																																{	/* Ast/sexp.scm 722 */
																																																																	obj_t
																																																																		BgL_arg7104z00_9803;
																																																																	BgL_nodez00_bglt
																																																																		BgL_arg7105z00_9804;
																																																																	BgL_arg7104z00_9803
																																																																		=
																																																																		BGl_shapez00zztools_shapez00
																																																																		(BGl_currentzd2functionzd2zztools_errorz00
																																																																		());
																																																																	BgL_arg7105z00_9804
																																																																		=
																																																																		BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																		(CNST_TABLE_REF
																																																																		(((long) 4)), BNIL, BgL_locz00_8600, CNST_TABLE_REF(((long) 2)));
																																																																	{	/* Ast/sexp.scm 721 */
																																																																		obj_t
																																																																			BgL_list7106z00_9806;
																																																																		BgL_list7106z00_9806
																																																																			=
																																																																			MAKE_YOUNG_PAIR
																																																																			(
																																																																			((obj_t) BgL_arg7105z00_9804), BNIL);
																																																																		BgL_res7375z00_9807
																																																																			=
																																																																			(
																																																																			(BgL_nodez00_bglt)
																																																																			BGl_userzd2errorzf2locationz20zztools_errorz00
																																																																			(BgL_locz00_8600,
																																																																				BgL_arg7104z00_9803,
																																																																				BGl_string7997z00zzast_sexpz00,
																																																																				BgL_expz00_21,
																																																																				BgL_list7106z00_9806));
																																																																}}
																																																																BgL_auxz00_14394
																																																																	=
																																																																	BgL_res7375z00_9807;
																																																					}}}}}}}}}}
																																																				else
																																																					{	/* Ast/sexp.scm 118 */
																																																					BgL_tagzd262258zd2_8588:
																																																						{	/* Ast/sexp.scm 317 */
																																																							obj_t
																																																								BgL_arg6770z00_8629;
																																																							BgL_arg6770z00_8629
																																																								=
																																																								BGl_findzd2locationzf2locz20zztools_locationz00
																																																								(BgL_expz00_21,
																																																								BgL_locz00_23);
																																																							{	/* Ast/sexp.scm 316 */
																																																								BgL_nodez00_bglt
																																																									BgL_res7376z00_9813;
																																																								{	/* Ast/sexp.scm 722 */
																																																									obj_t
																																																										BgL_arg7104z00_9809;
																																																									BgL_nodez00_bglt
																																																										BgL_arg7105z00_9810;
																																																									BgL_arg7104z00_9809
																																																										=
																																																										BGl_shapez00zztools_shapez00
																																																										(BGl_currentzd2functionzd2zztools_errorz00
																																																										());
																																																									BgL_arg7105z00_9810
																																																										=
																																																										BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																										(CNST_TABLE_REF
																																																										(((long) 4)), BNIL, BgL_arg6770z00_8629, CNST_TABLE_REF(((long) 2)));
																																																									{	/* Ast/sexp.scm 721 */
																																																										obj_t
																																																											BgL_list7106z00_9812;
																																																										BgL_list7106z00_9812
																																																											=
																																																											MAKE_YOUNG_PAIR
																																																											(
																																																											((obj_t) BgL_arg7105z00_9810), BNIL);
																																																										BgL_res7376z00_9813
																																																											=
																																																											(
																																																											(BgL_nodez00_bglt)
																																																											BGl_userzd2errorzf2locationz20zztools_errorz00
																																																											(BgL_arg6770z00_8629,
																																																												BgL_arg7104z00_9809,
																																																												BGl_string7995z00zzast_sexpz00,
																																																												BgL_expz00_21,
																																																												BgL_list7106z00_9812));
																																																								}}
																																																								BgL_auxz00_14394
																																																									=
																																																									BgL_res7376z00_9813;
																																																			}}}}
																																																		else
																																																			{	/* Ast/sexp.scm 118 */
																																																				goto
																																																					BgL_tagzd262258zd2_8588;
																																																			}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		goto
																																																			BgL_tagzd262258zd2_8588;
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																goto
																																																	BgL_tagzd262258zd2_8588;
																																															}
																																													}
																																													BgL_auxz00_14205
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_14394);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 118 */
																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_14496;
																																														BgL_tagzd2380zd2_1724:
																																															{
																																																obj_t
																																																	BgL_varz00_8630;
																																																obj_t
																																																	BgL_valz00_8631;
																																																if (PAIRP(BgL_expz00_21))
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_cdrzd262288zd2_8636;
																																																		BgL_cdrzd262288zd2_8636
																																																			=
																																																			CDR
																																																			(BgL_expz00_21);
																																																		if (PAIRP(BgL_cdrzd262288zd2_8636))
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_cdrzd262292zd2_8638;
																																																				BgL_cdrzd262292zd2_8638
																																																					=
																																																					CDR
																																																					(BgL_cdrzd262288zd2_8636);
																																																				if (PAIRP(BgL_cdrzd262292zd2_8638))
																																																					{	/* Ast/sexp.scm 118 */
																																																						if (NULLP(CDR(BgL_cdrzd262292zd2_8638)))
																																																							{	/* Ast/sexp.scm 118 */
																																																								BgL_varz00_8630
																																																									=
																																																									CAR
																																																									(BgL_cdrzd262288zd2_8636);
																																																								BgL_valz00_8631
																																																									=
																																																									CAR
																																																									(BgL_cdrzd262292zd2_8638);
																																																								{	/* Ast/sexp.scm 324 */
																																																									obj_t
																																																										BgL_locz00_8645;
																																																									BgL_locz00_8645
																																																										=
																																																										BGl_findzd2locationzf2locz20zztools_locationz00
																																																										(BgL_expz00_21,
																																																										BgL_locz00_23);
																																																									{	/* Ast/sexp.scm 324 */
																																																										obj_t
																																																											BgL_cdlocz00_8646;
																																																										{	/* Ast/sexp.scm 325 */
																																																											obj_t
																																																												BgL_arg6786z00_8661;
																																																											BgL_arg6786z00_8661
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											BgL_cdlocz00_8646
																																																												=
																																																												BGl_findzd2locationzf2locz20zztools_locationz00
																																																												(BgL_arg6786z00_8661,
																																																												BgL_locz00_8645);
																																																										}
																																																										{	/* Ast/sexp.scm 325 */
																																																											obj_t
																																																												BgL_cddlocz00_8647;
																																																											{	/* Ast/sexp.scm 326 */
																																																												obj_t
																																																													BgL_arg6785z00_8660;
																																																												{	/* Ast/sexp.scm 326 */
																																																													obj_t
																																																														BgL_pairz00_9827;
																																																													BgL_pairz00_9827
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													BgL_arg6785z00_8660
																																																														=
																																																														CDR
																																																														(BgL_pairz00_9827);
																																																												}
																																																												BgL_cddlocz00_8647
																																																													=
																																																													BGl_findzd2locationzf2locz20zztools_locationz00
																																																													(BgL_arg6785z00_8660,
																																																													BgL_locz00_8645);
																																																											}
																																																											{	/* Ast/sexp.scm 326 */
																																																												obj_t
																																																													BgL_valzd2loczd2_8648;
																																																												BgL_valzd2loczd2_8648
																																																													=
																																																													BGl_findzd2locationzf2locz20zztools_locationz00
																																																													(BgL_valz00_8631,
																																																													BgL_cddlocz00_8647);
																																																												{	/* Ast/sexp.scm 327 */
																																																													BgL_nodez00_bglt
																																																														BgL_valz00_8649;
																																																													BgL_valz00_8649
																																																														=
																																																														BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																														(BgL_valz00_8631,
																																																														BgL_stackz00_22,
																																																														BgL_valzd2loczd2_8648,
																																																														CNST_TABLE_REF
																																																														(((long) 2)));
																																																													{	/* Ast/sexp.scm 328 */

																																																														{	/* Ast/sexp.scm 329 */
																																																															BgL_nodez00_bglt
																																																																BgL_astz00_8650;
																																																															BgL_astz00_8650
																																																																=
																																																																BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																(BgL_varz00_8630,
																																																																BgL_stackz00_22,
																																																																BgL_cdlocz00_8646,
																																																																CNST_TABLE_REF
																																																																(((long) 2)));
																																																															{	/* Ast/sexp.scm 330 */
																																																																bool_t
																																																																	BgL_test8159z00_14521;
																																																																{	/* Ast/sexp.scm 330 */
																																																																	bool_t
																																																																		BgL_test8160z00_14522;
																																																																	{	/* Ast/sexp.scm 330 */
																																																																		bool_t
																																																																			BgL_res7381z00_9828;
																																																																		BgL_res7381z00_9828
																																																																			=
																																																																			BGl_isazf3zf3zz__objectz00
																																																																			(
																																																																			((obj_t) BgL_astz00_8650), BGl_varz00zzast_nodez00);
																																																																		BgL_test8160z00_14522
																																																																			=
																																																																			BgL_res7381z00_9828;
																																																																	}
																																																																	if (BgL_test8160z00_14522)
																																																																		{	/* Ast/sexp.scm 330 */
																																																																			BgL_variablez00_bglt
																																																																				BgL_arg6784z00_8659;
																																																																			BgL_arg6784z00_8659
																																																																				=
																																																																				(
																																																																				((BgL_varz00_bglt) COBJECT(((BgL_varz00_bglt) BgL_astz00_8650)))->BgL_variablez00);
																																																																			{	/* Ast/sexp.scm 330 */
																																																																				bool_t
																																																																					BgL_res7382z00_9830;
																																																																				BgL_res7382z00_9830
																																																																					=
																																																																					BGl_isazf3zf3zz__objectz00
																																																																					(
																																																																					((obj_t) BgL_arg6784z00_8659), BGl_globalz00zzast_varz00);
																																																																				BgL_test8159z00_14521
																																																																					=
																																																																					BgL_res7382z00_9830;
																																																																			}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 330 */
																																																																			BgL_test8159z00_14521
																																																																				=
																																																																				(
																																																																				(bool_t)
																																																																				0);
																																																																		}
																																																																}
																																																																if (BgL_test8159z00_14521)
																																																																	{	/* Ast/sexp.scm 330 */
																																																																		{	/* Ast/sexp.scm 332 */
																																																																			BgL_variablez00_bglt
																																																																				BgL_arg6782z00_8654;
																																																																			BgL_arg6782z00_8654
																																																																				=
																																																																				(
																																																																				((BgL_varz00_bglt) COBJECT(((BgL_varz00_bglt) BgL_astz00_8650)))->BgL_variablez00);
																																																																			((((BgL_globalz00_bglt) COBJECT(((BgL_globalz00_bglt) BgL_arg6782z00_8654)))->BgL_srcz00) = ((obj_t) ((obj_t) BgL_valz00_8649)), BUNSPEC);
																																																																		}
																																																																		{	/* Ast/sexp.scm 333 */
																																																																			BgL_setqz00_bglt
																																																																				BgL_new1135z00_8655;
																																																																			{	/* Ast/sexp.scm 334 */
																																																																				BgL_setqz00_bglt
																																																																					BgL_new1134z00_8656;
																																																																				BgL_new1134z00_8656
																																																																					=
																																																																					(
																																																																					(BgL_setqz00_bglt)
																																																																					BOBJECT
																																																																					(GC_MALLOC
																																																																						(sizeof
																																																																							(struct
																																																																								BgL_setqz00_bgl))));
																																																																				{	/* Ast/sexp.scm 334 */
																																																																					long
																																																																						BgL_arg6783z00_8657;
																																																																					{	/* Ast/sexp.scm 334 */
																																																																						long
																																																																							BgL_res7383z00_9834;
																																																																						BgL_res7383z00_9834
																																																																							=
																																																																							BGL_CLASS_INDEX
																																																																							(BGl_setqz00zzast_nodez00);
																																																																						BgL_arg6783z00_8657
																																																																							=
																																																																							BgL_res7383z00_9834;
																																																																					}
																																																																					BGL_OBJECT_CLASS_NUM_SET
																																																																						(
																																																																						((BgL_objectz00_bglt) BgL_new1134z00_8656), BgL_arg6783z00_8657);
																																																																				}
																																																																				{	/* Ast/sexp.scm 334 */
																																																																					BgL_objectz00_bglt
																																																																						BgL_tmpz00_14538;
																																																																					BgL_tmpz00_14538
																																																																						=
																																																																						(
																																																																						(BgL_objectz00_bglt)
																																																																						BgL_new1134z00_8656);
																																																																					BGL_OBJECT_WIDENING_SET
																																																																						(BgL_tmpz00_14538,
																																																																						BFALSE);
																																																																				}
																																																																				((BgL_objectz00_bglt) BgL_new1134z00_8656);
																																																																				BgL_new1135z00_8655
																																																																					=
																																																																					BgL_new1134z00_8656;
																																																																			}
																																																																			((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1135z00_8655)))->BgL_locz00) = ((obj_t) BgL_locz00_8645), BUNSPEC);
																																																																			((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1135z00_8655)))->BgL_typez00) = ((BgL_typez00_bglt) ((BgL_typez00_bglt) BGl_za2unspecza2z00zztype_cachez00)), BUNSPEC);
																																																																			((((BgL_setqz00_bglt) COBJECT(BgL_new1135z00_8655))->BgL_varz00) = ((BgL_varz00_bglt) ((BgL_varz00_bglt) BgL_astz00_8650)), BUNSPEC);
																																																																			((((BgL_setqz00_bglt) COBJECT(BgL_new1135z00_8655))->BgL_valuez00) = ((BgL_nodez00_bglt) BgL_valz00_8649), BUNSPEC);
																																																																			BgL_auxz00_14496
																																																																				=
																																																																				(
																																																																				(BgL_nodez00_bglt)
																																																																				BgL_new1135z00_8655);
																																																																	}}
																																																																else
																																																																	{	/* Ast/sexp.scm 338 */
																																																																		BgL_nodez00_bglt
																																																																			BgL_res7384z00_9843;
																																																																		{	/* Ast/sexp.scm 722 */
																																																																			obj_t
																																																																				BgL_arg7104z00_9839;
																																																																			BgL_nodez00_bglt
																																																																				BgL_arg7105z00_9840;
																																																																			BgL_arg7104z00_9839
																																																																				=
																																																																				BGl_shapez00zztools_shapez00
																																																																				(BGl_currentzd2functionzd2zztools_errorz00
																																																																				());
																																																																			BgL_arg7105z00_9840
																																																																				=
																																																																				BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																				(CNST_TABLE_REF
																																																																				(((long) 4)), BNIL, BgL_locz00_8645, CNST_TABLE_REF(((long) 2)));
																																																																			{	/* Ast/sexp.scm 721 */
																																																																				obj_t
																																																																					BgL_list7106z00_9842;
																																																																				BgL_list7106z00_9842
																																																																					=
																																																																					MAKE_YOUNG_PAIR
																																																																					(
																																																																					((obj_t) BgL_arg7105z00_9840), BNIL);
																																																																				BgL_res7384z00_9843
																																																																					=
																																																																					(
																																																																					(BgL_nodez00_bglt)
																																																																					BGl_userzd2errorzf2locationz20zztools_errorz00
																																																																					(BgL_locz00_8645,
																																																																						BgL_arg7104z00_9839,
																																																																						BGl_string7994z00zzast_sexpz00,
																																																																						BgL_expz00_21,
																																																																						BgL_list7106z00_9842));
																																																																		}}
																																																																		BgL_auxz00_14496
																																																																			=
																																																																			BgL_res7384z00_9843;
																																																							}}}}}}}}}}
																																																						else
																																																							{	/* Ast/sexp.scm 118 */
																																																							BgL_tagzd262281zd2_8633:
																																																								{	/* Ast/sexp.scm 342 */
																																																									obj_t
																																																										BgL_arg6787z00_8662;
																																																									BgL_arg6787z00_8662
																																																										=
																																																										BGl_findzd2locationzf2locz20zztools_locationz00
																																																										(BgL_expz00_21,
																																																										BgL_locz00_23);
																																																									{	/* Ast/sexp.scm 341 */
																																																										BgL_nodez00_bglt
																																																											BgL_res7385z00_9849;
																																																										{	/* Ast/sexp.scm 722 */
																																																											obj_t
																																																												BgL_arg7104z00_9845;
																																																											BgL_nodez00_bglt
																																																												BgL_arg7105z00_9846;
																																																											BgL_arg7104z00_9845
																																																												=
																																																												BGl_shapez00zztools_shapez00
																																																												(BGl_currentzd2functionzd2zztools_errorz00
																																																												());
																																																											BgL_arg7105z00_9846
																																																												=
																																																												BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																												(CNST_TABLE_REF
																																																												(((long) 4)), BNIL, BgL_arg6787z00_8662, CNST_TABLE_REF(((long) 2)));
																																																											{	/* Ast/sexp.scm 721 */
																																																												obj_t
																																																													BgL_list7106z00_9848;
																																																												BgL_list7106z00_9848
																																																													=
																																																													MAKE_YOUNG_PAIR
																																																													(
																																																													((obj_t) BgL_arg7105z00_9846), BNIL);
																																																												BgL_res7385z00_9849
																																																													=
																																																													(
																																																													(BgL_nodez00_bglt)
																																																													BGl_userzd2errorzf2locationz20zztools_errorz00
																																																													(BgL_arg6787z00_8662,
																																																														BgL_arg7104z00_9845,
																																																														BGl_string7993z00zzast_sexpz00,
																																																														BgL_expz00_21,
																																																														BgL_list7106z00_9848));
																																																										}}
																																																										BgL_auxz00_14496
																																																											=
																																																											BgL_res7385z00_9849;
																																																					}}}}
																																																				else
																																																					{	/* Ast/sexp.scm 118 */
																																																						goto
																																																							BgL_tagzd262281zd2_8633;
																																																					}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 118 */
																																																				goto
																																																					BgL_tagzd262281zd2_8633;
																																																			}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		goto
																																																			BgL_tagzd262281zd2_8633;
																																																	}
																																															}
																																															BgL_auxz00_14205
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_14496);
																																														}
																																													else
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_carzd2706zd2_2573;
																																															BgL_carzd2706zd2_2573
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															if (PAIRP(BgL_carzd2706zd2_2573))
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_carzd2709zd2_2575;
																																																	obj_t
																																																		BgL_cdrzd2710zd2_2576;
																																																	BgL_carzd2709zd2_2575
																																																		=
																																																		CAR
																																																		(BgL_carzd2706zd2_2573);
																																																	BgL_cdrzd2710zd2_2576
																																																		=
																																																		CDR
																																																		(BgL_carzd2706zd2_2573);
																																																	{

																																																		if ((BgL_carzd2709zd2_2575 == CNST_TABLE_REF(((long) 17))))
																																																			{	/* Ast/sexp.scm 118 */
																																																			BgL_kapzd2711zd2_2577:
																																																				if (PAIRP(BgL_cdrzd2710zd2_2576))
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_cdrzd2714zd2_2702;
																																																						BgL_cdrzd2714zd2_2702
																																																							=
																																																							CDR
																																																							(BgL_cdrzd2710zd2_2576);
																																																						if (PAIRP(BgL_cdrzd2714zd2_2702))
																																																							{	/* Ast/sexp.scm 118 */
																																																								if (NULLP(CDR(BgL_cdrzd2714zd2_2702)))
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_arg2342z00_2706;
																																																										obj_t
																																																											BgL_arg2343z00_2707;
																																																										BgL_arg2342z00_2706
																																																											=
																																																											CAR
																																																											(BgL_cdrzd2714zd2_2702);
																																																										BgL_arg2343z00_2707
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_14593;
																																																											BgL_bodyz00_1725
																																																												=
																																																												BgL_arg2342z00_2706;
																																																											BgL_argsz00_1726
																																																												=
																																																												BgL_arg2343z00_2707;
																																																										BgL_tagzd2381zd2_1727:
																																																											{	/* Ast/sexp.scm 345 */
																																																												obj_t
																																																													BgL_letzd2partzd2_8663;
																																																												BgL_letzd2partzd2_8663
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{	/* Ast/sexp.scm 345 */
																																																													obj_t
																																																														BgL_nexpz00_8664;
																																																													{	/* Ast/sexp.scm 346 */
																																																														obj_t
																																																															BgL_arg6788z00_8665;
																																																														obj_t
																																																															BgL_arg6789z00_8666;
																																																														BgL_arg6788z00_8665
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_letzd2partzd2_8663));
																																																														{	/* Ast/sexp.scm 346 */
																																																															obj_t
																																																																BgL_arg6790z00_8667;
																																																															obj_t
																																																																BgL_arg6791z00_8668;
																																																															{	/* Ast/sexp.scm 346 */
																																																																obj_t
																																																																	BgL_pairz00_9864;
																																																																BgL_pairz00_9864
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_letzd2partzd2_8663));
																																																																BgL_arg6790z00_8667
																																																																	=
																																																																	CAR
																																																																	(BgL_pairz00_9864);
																																																															}
																																																															{	/* Ast/sexp.scm 346 */
																																																																obj_t
																																																																	BgL_arg6792z00_8669;
																																																																BgL_arg6792z00_8669
																																																																	=
																																																																	MAKE_YOUNG_PAIR
																																																																	(BgL_bodyz00_1725,
																																																																	BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																																																	(BgL_argsz00_1726,
																																																																		BNIL));
																																																																BgL_arg6791z00_8668
																																																																	=
																																																																	MAKE_YOUNG_PAIR
																																																																	(BgL_arg6792z00_8669,
																																																																	BNIL);
																																																															}
																																																															BgL_arg6789z00_8666
																																																																=
																																																																MAKE_YOUNG_PAIR
																																																																(BgL_arg6790z00_8667,
																																																																BgL_arg6791z00_8668);
																																																														}
																																																														BgL_nexpz00_8664
																																																															=
																																																															MAKE_YOUNG_PAIR
																																																															(BgL_arg6788z00_8665,
																																																															BgL_arg6789z00_8666);
																																																													}
																																																													{	/* Ast/sexp.scm 346 */

																																																														BgL_auxz00_14593
																																																															=
																																																															BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																															(BgL_nexpz00_8664,
																																																															BgL_stackz00_22,
																																																															BgL_locz00_23,
																																																															BgL_sitez00_24);
																																																													}
																																																												}
																																																											}
																																																											BgL_auxz00_14205
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_14593);
																																																										}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_cdrzd2738zd2_2708;
																																																										BgL_cdrzd2738zd2_2708
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{	/* Ast/sexp.scm 118 */
																																																											bool_t
																																																												BgL_test8166z00_14610;
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_arg2419z00_2819;
																																																												BgL_arg2419z00_2819
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												BgL_test8166z00_14610
																																																													=
																																																													CBOOL
																																																													(BGl_letzd2symzf3z21zzast_letz00
																																																													(BgL_arg2419z00_2819));
																																																											}
																																																											if (BgL_test8166z00_14610)
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_arg2346z00_2711;
																																																													obj_t
																																																														BgL_arg2347z00_2712;
																																																													BgL_arg2346z00_2711
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_cdrzd2738zd2_2708));
																																																													BgL_arg2347z00_2712
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd2738zd2_2708));
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_14619;
																																																														BgL_bindingsz00_1728
																																																															=
																																																															BgL_arg2346z00_2711;
																																																														BgL_exprz00_1729
																																																															=
																																																															BgL_arg2347z00_2712;
																																																													BgL_tagzd2382zd2_1730:
																																																														{	/* Ast/sexp.scm 350 */
																																																															bool_t
																																																																BgL_test8167z00_14620;
																																																															if (PAIRP(BgL_bindingsz00_1728))
																																																																{	/* Ast/sexp.scm 350 */
																																																																	if (NULLP(CDR(BgL_bindingsz00_1728)))
																																																																		{	/* Ast/sexp.scm 350 */
																																																																			if (PAIRP(BgL_exprz00_1729))
																																																																				{	/* Ast/sexp.scm 351 */
																																																																					BgL_test8167z00_14620
																																																																						=
																																																																						NULLP
																																																																						(CDR
																																																																						(BgL_exprz00_1729));
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 351 */
																																																																					BgL_test8167z00_14620
																																																																						=
																																																																						(
																																																																						(bool_t)
																																																																						0);
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 350 */
																																																																			BgL_test8167z00_14620
																																																																				=
																																																																				(
																																																																				(bool_t)
																																																																				0);
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 350 */
																																																																	BgL_test8167z00_14620
																																																																		=
																																																																		(
																																																																		(bool_t)
																																																																		0);
																																																																}
																																																															if (BgL_test8167z00_14620)
																																																																{
																																																																	obj_t
																																																																		BgL_varz00_8678;
																																																																	obj_t
																																																																		BgL_exprz00_8679;
																																																																	obj_t
																																																																		BgL_idz00_8680;
																																																																	obj_t
																																																																		BgL_thenz00_8681;
																																																																	obj_t
																																																																		BgL_otherwisez00_8682;
																																																																	if (PAIRP(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 352 */
																																																																			obj_t
																																																																				BgL_cdrzd262311zd2_8686;
																																																																			BgL_cdrzd262311zd2_8686
																																																																				=
																																																																				CDR
																																																																				(BgL_expz00_21);
																																																																			if (PAIRP(BgL_cdrzd262311zd2_8686))
																																																																				{	/* Ast/sexp.scm 352 */
																																																																					obj_t
																																																																						BgL_carzd262317zd2_8688;
																																																																					obj_t
																																																																						BgL_cdrzd262318zd2_8689;
																																																																					BgL_carzd262317zd2_8688
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd262311zd2_8686);
																																																																					BgL_cdrzd262318zd2_8689
																																																																						=
																																																																						CDR
																																																																						(BgL_cdrzd262311zd2_8686);
																																																																					if (PAIRP(BgL_carzd262317zd2_8688))
																																																																						{	/* Ast/sexp.scm 352 */
																																																																							obj_t
																																																																								BgL_carzd262321zd2_8691;
																																																																							BgL_carzd262321zd2_8691
																																																																								=
																																																																								CAR
																																																																								(BgL_carzd262317zd2_8688);
																																																																							if (PAIRP(BgL_carzd262321zd2_8691))
																																																																								{	/* Ast/sexp.scm 352 */
																																																																									obj_t
																																																																										BgL_cdrzd262326zd2_8693;
																																																																									BgL_cdrzd262326zd2_8693
																																																																										=
																																																																										CDR
																																																																										(BgL_carzd262321zd2_8691);
																																																																									if (PAIRP(BgL_cdrzd262326zd2_8693))
																																																																										{	/* Ast/sexp.scm 352 */
																																																																											if (NULLP(CDR(BgL_cdrzd262326zd2_8693)))
																																																																												{	/* Ast/sexp.scm 352 */
																																																																													if (NULLP(CDR(BgL_carzd262317zd2_8688)))
																																																																														{	/* Ast/sexp.scm 352 */
																																																																															if (PAIRP(BgL_cdrzd262318zd2_8689))
																																																																																{	/* Ast/sexp.scm 352 */
																																																																																	obj_t
																																																																																		BgL_carzd262335zd2_8700;
																																																																																	BgL_carzd262335zd2_8700
																																																																																		=
																																																																																		CAR
																																																																																		(BgL_cdrzd262318zd2_8689);
																																																																																	if (PAIRP(BgL_carzd262335zd2_8700))
																																																																																		{	/* Ast/sexp.scm 352 */
																																																																																			obj_t
																																																																																				BgL_cdrzd262341zd2_8702;
																																																																																			BgL_cdrzd262341zd2_8702
																																																																																				=
																																																																																				CDR
																																																																																				(BgL_carzd262335zd2_8700);
																																																																																			if ((CAR(BgL_carzd262335zd2_8700) == CNST_TABLE_REF(((long) 1))))
																																																																																				{	/* Ast/sexp.scm 352 */
																																																																																					if (PAIRP(BgL_cdrzd262341zd2_8702))
																																																																																						{	/* Ast/sexp.scm 352 */
																																																																																							obj_t
																																																																																								BgL_carzd262345zd2_8706;
																																																																																							obj_t
																																																																																								BgL_cdrzd262346zd2_8707;
																																																																																							BgL_carzd262345zd2_8706
																																																																																								=
																																																																																								CAR
																																																																																								(BgL_cdrzd262341zd2_8702);
																																																																																							BgL_cdrzd262346zd2_8707
																																																																																								=
																																																																																								CDR
																																																																																								(BgL_cdrzd262341zd2_8702);
																																																																																							if (SYMBOLP(BgL_carzd262345zd2_8706))
																																																																																								{	/* Ast/sexp.scm 352 */
																																																																																									if (PAIRP(BgL_cdrzd262346zd2_8707))
																																																																																										{	/* Ast/sexp.scm 352 */
																																																																																											obj_t
																																																																																												BgL_cdrzd262353zd2_8710;
																																																																																											BgL_cdrzd262353zd2_8710
																																																																																												=
																																																																																												CDR
																																																																																												(BgL_cdrzd262346zd2_8707);
																																																																																											if (PAIRP(BgL_cdrzd262353zd2_8710))
																																																																																												{	/* Ast/sexp.scm 352 */
																																																																																													if (NULLP(CDR(BgL_cdrzd262353zd2_8710)))
																																																																																														{	/* Ast/sexp.scm 352 */
																																																																																															if (NULLP(CDR(BgL_cdrzd262318zd2_8689)))
																																																																																																{	/* Ast/sexp.scm 352 */
																																																																																																	BgL_varz00_8678
																																																																																																		=
																																																																																																		CAR
																																																																																																		(BgL_carzd262321zd2_8691);
																																																																																																	BgL_exprz00_8679
																																																																																																		=
																																																																																																		CAR
																																																																																																		(BgL_cdrzd262326zd2_8693);
																																																																																																	BgL_idz00_8680
																																																																																																		=
																																																																																																		BgL_carzd262345zd2_8706;
																																																																																																	BgL_thenz00_8681
																																																																																																		=
																																																																																																		CAR
																																																																																																		(BgL_cdrzd262346zd2_8707);
																																																																																																	BgL_otherwisez00_8682
																																																																																																		=
																																																																																																		CAR
																																																																																																		(BgL_cdrzd262353zd2_8710);
																																																																																																	{	/* Ast/sexp.scm 357 */
																																																																																																		obj_t
																																																																																																			BgL_ntz00_8725;
																																																																																																		BgL_ntz00_8725
																																																																																																			=
																																																																																																			BGl_notzd2testzd2zzast_sexpz00
																																																																																																			(BgL_exprz00_8679);
																																																																																																		{	/* Ast/sexp.scm 358 */
																																																																																																			bool_t
																																																																																																				BgL_test8187z00_14679;
																																																																																																			if (CBOOL(BgL_ntz00_8725))
																																																																																																				{	/* Ast/sexp.scm 358 */
																																																																																																					if (BGl_usedzd2inzf3z21zzast_sexpz00(BgL_idz00_8680, BgL_otherwisez00_8682))
																																																																																																						{	/* Ast/sexp.scm 359 */
																																																																																																							BgL_test8187z00_14679
																																																																																																								=
																																																																																																								(
																																																																																																								(bool_t)
																																																																																																								0);
																																																																																																						}
																																																																																																					else
																																																																																																						{	/* Ast/sexp.scm 359 */
																																																																																																							if (BGl_usedzd2inzf3z21zzast_sexpz00(BgL_idz00_8680, BgL_thenz00_8681))
																																																																																																								{	/* Ast/sexp.scm 360 */
																																																																																																									BgL_test8187z00_14679
																																																																																																										=
																																																																																																										(
																																																																																																										(bool_t)
																																																																																																										0);
																																																																																																								}
																																																																																																							else
																																																																																																								{	/* Ast/sexp.scm 360 */
																																																																																																									BgL_test8187z00_14679
																																																																																																										=
																																																																																																										(
																																																																																																										(bool_t)
																																																																																																										1);
																																																																																																								}
																																																																																																						}
																																																																																																				}
																																																																																																			else
																																																																																																				{	/* Ast/sexp.scm 358 */
																																																																																																					BgL_test8187z00_14679
																																																																																																						=
																																																																																																						(
																																																																																																						(bool_t)
																																																																																																						0);
																																																																																																				}
																																																																																																			if (BgL_test8187z00_14679)
																																																																																																				{	/* Ast/sexp.scm 361 */
																																																																																																					obj_t
																																																																																																						BgL_bindingz00_8729;
																																																																																																					obj_t
																																																																																																						BgL_bodyz00_8730;
																																																																																																					BgL_bindingz00_8729
																																																																																																						=
																																																																																																						CAR
																																																																																																						(
																																																																																																						((obj_t) BgL_bindingsz00_1728));
																																																																																																					{	/* Ast/sexp.scm 362 */
																																																																																																						obj_t
																																																																																																							BgL_pairz00_9877;
																																																																																																						{	/* Ast/sexp.scm 362 */
																																																																																																							obj_t
																																																																																																								BgL_pairz00_9876;
																																																																																																							BgL_pairz00_9876
																																																																																																								=
																																																																																																								CDR
																																																																																																								(
																																																																																																								((obj_t) BgL_expz00_21));
																																																																																																							BgL_pairz00_9877
																																																																																																								=
																																																																																																								CDR
																																																																																																								(BgL_pairz00_9876);
																																																																																																						}
																																																																																																						BgL_bodyz00_8730
																																																																																																							=
																																																																																																							CAR
																																																																																																							(BgL_pairz00_9877);
																																																																																																					}
																																																																																																					{	/* Ast/sexp.scm 363 */
																																																																																																						obj_t
																																																																																																							BgL_arg6833z00_8731;
																																																																																																						BgL_arg6833z00_8731
																																																																																																							=
																																																																																																							CDR
																																																																																																							(
																																																																																																							((obj_t) BgL_bindingz00_8729));
																																																																																																						{	/* Ast/sexp.scm 363 */
																																																																																																							obj_t
																																																																																																								BgL_tmpz00_14694;
																																																																																																							BgL_tmpz00_14694
																																																																																																								=
																																																																																																								(
																																																																																																								(obj_t)
																																																																																																								BgL_arg6833z00_8731);
																																																																																																							SET_CAR
																																																																																																								(BgL_tmpz00_14694,
																																																																																																								BgL_ntz00_8725);
																																																																																																						}
																																																																																																					}
																																																																																																					{	/* Ast/sexp.scm 364 */
																																																																																																						obj_t
																																																																																																							BgL_arg6834z00_8732;
																																																																																																						{	/* Ast/sexp.scm 364 */
																																																																																																							obj_t
																																																																																																								BgL_pairz00_9883;
																																																																																																							BgL_pairz00_9883
																																																																																																								=
																																																																																																								CDR
																																																																																																								(
																																																																																																								((obj_t) BgL_bodyz00_8730));
																																																																																																							BgL_arg6834z00_8732
																																																																																																								=
																																																																																																								CDR
																																																																																																								(BgL_pairz00_9883);
																																																																																																						}
																																																																																																						{	/* Ast/sexp.scm 364 */
																																																																																																							obj_t
																																																																																																								BgL_tmpz00_14700;
																																																																																																							BgL_tmpz00_14700
																																																																																																								=
																																																																																																								(
																																																																																																								(obj_t)
																																																																																																								BgL_arg6834z00_8732);
																																																																																																							SET_CAR
																																																																																																								(BgL_tmpz00_14700,
																																																																																																								BgL_otherwisez00_8682);
																																																																																																						}
																																																																																																					}
																																																																																																					{	/* Ast/sexp.scm 365 */
																																																																																																						obj_t
																																																																																																							BgL_arg6835z00_8733;
																																																																																																						{	/* Ast/sexp.scm 365 */
																																																																																																							obj_t
																																																																																																								BgL_pairz00_9890;
																																																																																																							{	/* Ast/sexp.scm 365 */
																																																																																																								obj_t
																																																																																																									BgL_pairz00_9889;
																																																																																																								BgL_pairz00_9889
																																																																																																									=
																																																																																																									CDR
																																																																																																									(
																																																																																																									((obj_t) BgL_bodyz00_8730));
																																																																																																								BgL_pairz00_9890
																																																																																																									=
																																																																																																									CDR
																																																																																																									(BgL_pairz00_9889);
																																																																																																							}
																																																																																																							BgL_arg6835z00_8733
																																																																																																								=
																																																																																																								CDR
																																																																																																								(BgL_pairz00_9890);
																																																																																																						}
																																																																																																						{	/* Ast/sexp.scm 365 */
																																																																																																							obj_t
																																																																																																								BgL_tmpz00_14707;
																																																																																																							BgL_tmpz00_14707
																																																																																																								=
																																																																																																								(
																																																																																																								(obj_t)
																																																																																																								BgL_arg6835z00_8733);
																																																																																																							SET_CAR
																																																																																																								(BgL_tmpz00_14707,
																																																																																																								BgL_thenz00_8681);
																																																																																																						}
																																																																																																					}
																																																																																																				}
																																																																																																			else
																																																																																																				{	/* Ast/sexp.scm 358 */
																																																																																																					BFALSE;
																																																																																																				}
																																																																																																		}
																																																																																																	}
																																																																																																}
																																																																																															else
																																																																																																{	/* Ast/sexp.scm 352 */
																																																																																																	BFALSE;
																																																																																																}
																																																																																														}
																																																																																													else
																																																																																														{	/* Ast/sexp.scm 352 */
																																																																																															BFALSE;
																																																																																														}
																																																																																												}
																																																																																											else
																																																																																												{	/* Ast/sexp.scm 352 */
																																																																																													BFALSE;
																																																																																												}
																																																																																										}
																																																																																									else
																																																																																										{	/* Ast/sexp.scm 352 */
																																																																																											BFALSE;
																																																																																										}
																																																																																								}
																																																																																							else
																																																																																								{	/* Ast/sexp.scm 352 */
																																																																																									BFALSE;
																																																																																								}
																																																																																						}
																																																																																					else
																																																																																						{	/* Ast/sexp.scm 352 */
																																																																																							BFALSE;
																																																																																						}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 352 */
																																																																																					BFALSE;
																																																																																				}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 352 */
																																																																																			BFALSE;
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 352 */
																																																																																	BFALSE;
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 352 */
																																																																															BFALSE;
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 352 */
																																																																													BFALSE;
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 352 */
																																																																											BFALSE;
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 352 */
																																																																									BFALSE;
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 352 */
																																																																							BFALSE;
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 352 */
																																																																					BFALSE;
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 352 */
																																																																			BFALSE;
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 350 */
																																																																	BFALSE;
																																																																}
																																																														}
																																																														BgL_auxz00_14619
																																																															=
																																																															BGl_letzd2ze3nodez31zzast_letz00
																																																															(BgL_expz00_21,
																																																															BgL_stackz00_22,
																																																															BgL_locz00_23,
																																																															CNST_TABLE_REF
																																																															(((long) 2)));
																																																														BgL_auxz00_14205
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_14619);
																																																												}}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													bool_t
																																																														BgL_test8191z00_14717;
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_arg2418z00_2818;
																																																														BgL_arg2418z00_2818
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														BgL_test8191z00_14717
																																																															=
																																																															CBOOL
																																																															(BGl_labelszd2symzf3z21zzast_labelsz00
																																																															(BgL_arg2418z00_2818));
																																																													}
																																																													if (BgL_test8191z00_14717)
																																																														{
																																																															BgL_letzd2funzd2_bglt
																																																																BgL_auxz00_14722;
																																																														BgL_tagzd2384zd2_1732:
																																																															BgL_auxz00_14722 = BGl_labelszd2ze3nodez31zzast_labelsz00(BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, CNST_TABLE_REF(((long) 2)));
																																																															BgL_auxz00_14205
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_14722);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_carzd2805zd2_2715;
																																																															BgL_carzd2805zd2_2715
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_cdrzd2810zd2_2716;
																																																																BgL_cdrzd2810zd2_2716
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_carzd2805zd2_2715));
																																																																if ((CAR(((obj_t) BgL_carzd2805zd2_2715)) == CNST_TABLE_REF(((long) 3))))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_arg2353z00_2719;
																																																																		obj_t
																																																																			BgL_arg2354z00_2720;
																																																																		obj_t
																																																																			BgL_arg2356z00_2721;
																																																																		BgL_arg2353z00_2719
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd2810zd2_2716));
																																																																		BgL_arg2354z00_2720
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd2810zd2_2716));
																																																																		BgL_arg2356z00_2721
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_14741;
																																																																			BgL_varsz00_1737
																																																																				=
																																																																				BgL_arg2353z00_2719;
																																																																			BgL_bodyz00_1738
																																																																				=
																																																																				BgL_arg2354z00_2720;
																																																																			BgL_argsz00_1739
																																																																				=
																																																																				BgL_arg2356z00_2721;
																																																																		BgL_tagzd2386zd2_1740:
																																																																			{	/* Ast/sexp.scm 379 */
																																																																				obj_t
																																																																					BgL_locz00_8745;
																																																																				obj_t
																																																																					BgL_nexpz00_8746;
																																																																				BgL_locz00_8745
																																																																					=
																																																																					BGl_findzd2locationzf2locz20zztools_locationz00
																																																																					(BgL_expz00_21,
																																																																					BgL_locz00_23);
																																																																				{	/* Ast/sexp.scm 380 */
																																																																					obj_t
																																																																						BgL_arg6840z00_8747;
																																																																					obj_t
																																																																						BgL_arg6841z00_8748;
																																																																					BgL_arg6840z00_8747
																																																																						=
																																																																						BGl_letzd2symzd2zzast_letz00
																																																																						();
																																																																					{	/* Ast/sexp.scm 383 */
																																																																						obj_t
																																																																							BgL_arg6842z00_8749;
																																																																						obj_t
																																																																							BgL_arg6843z00_8750;
																																																																						BgL_arg6842z00_8749
																																																																							=
																																																																							BGl_loopze70ze7zzast_sexpz00
																																																																							(BgL_expz00_21,
																																																																							BgL_locz00_23,
																																																																							BgL_varsz00_1737,
																																																																							BgL_argsz00_1739);
																																																																						{	/* Ast/sexp.scm 422 */
																																																																							obj_t
																																																																								BgL_arg6885z00_8800;
																																																																							{	/* Ast/sexp.scm 422 */
																																																																								obj_t
																																																																									BgL_arg6886z00_8801;
																																																																								obj_t
																																																																									BgL_arg6887z00_8802;
																																																																								BgL_arg6886z00_8801
																																																																									=
																																																																									BGl_shapez00zztools_shapez00
																																																																									(BGl_currentzd2functionzd2zztools_errorz00
																																																																									());
																																																																								BgL_arg6887z00_8802
																																																																									=
																																																																									BGl_normaliza7ezd2prognz75zztools_prognz00
																																																																									(BgL_bodyz00_1738);
																																																																								{	/* Ast/sexp.scm 426 */
																																																																									obj_t
																																																																										BgL_zc3z04anonymousza36890ze3z87_13752;
																																																																									BgL_zc3z04anonymousza36890ze3z87_13752
																																																																										=
																																																																										MAKE_FX_PROCEDURE
																																																																										(BGl_z62zc3z04anonymousza36890ze3ze5zzast_sexpz00,
																																																																										(int)
																																																																										(((long) 3)), (int) (((long) 1)));
																																																																									PROCEDURE_SET
																																																																										(BgL_zc3z04anonymousza36890ze3z87_13752,
																																																																										(int)
																																																																										(((long) 0)), BgL_locz00_23);
																																																																									BgL_arg6885z00_8800
																																																																										=
																																																																										BGl_makezd2dssslzd2functionzd2preludezd2zz__dssslz00
																																																																										(BgL_arg6886z00_8801,
																																																																										BgL_varsz00_1737,
																																																																										BgL_arg6887z00_8802,
																																																																										BgL_zc3z04anonymousza36890ze3z87_13752);
																																																																							}}
																																																																							BgL_arg6843z00_8750
																																																																								=
																																																																								MAKE_YOUNG_PAIR
																																																																								(BgL_arg6885z00_8800,
																																																																								BNIL);
																																																																						}
																																																																						BgL_arg6841z00_8748
																																																																							=
																																																																							MAKE_YOUNG_PAIR
																																																																							(BgL_arg6842z00_8749,
																																																																							BgL_arg6843z00_8750);
																																																																					}
																																																																					BgL_nexpz00_8746
																																																																						=
																																																																						MAKE_YOUNG_PAIR
																																																																						(BgL_arg6840z00_8747,
																																																																						BgL_arg6841z00_8748);
																																																																				}
																																																																				BgL_auxz00_14741
																																																																					=
																																																																					BGl_letzd2ze3nodez31zzast_letz00
																																																																					(BgL_nexpz00_8746,
																																																																					BgL_stackz00_22,
																																																																					BgL_locz00_8745,
																																																																					CNST_TABLE_REF
																																																																					(((long) 2)));
																																																																			}
																																																																			BgL_auxz00_14205
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_14741);
																																																																	}}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_cdrzd2833zd2_2723;
																																																																		BgL_cdrzd2833zd2_2723
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_cdrzd2839zd2_2724;
																																																																			BgL_cdrzd2839zd2_2724
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_carzd2805zd2_2715));
																																																																			if ((CAR(((obj_t) BgL_carzd2805zd2_2715)) == CNST_TABLE_REF(((long) 1))))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_cdrzd2845zd2_2727;
																																																																					BgL_cdrzd2845zd2_2727
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd2839zd2_2724));
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_carzd2850zd2_2728;
																																																																						obj_t
																																																																							BgL_cdrzd2851zd2_2729;
																																																																						BgL_carzd2850zd2_2728
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd2845zd2_2727));
																																																																						BgL_cdrzd2851zd2_2729
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd2845zd2_2727));
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd2850zd2_2728))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (PAIRP(BgL_cdrzd2851zd2_2729))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_carzd2858zd2_2732;
																																																																										BgL_carzd2858zd2_2732
																																																																											=
																																																																											CAR
																																																																											(BgL_cdrzd2851zd2_2729);
																																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd2858zd2_2732))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												if (NULLP(CDR(BgL_cdrzd2851zd2_2729)))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														bool_t
																																																																															BgL_test8198z00_14785;
																																																																														{
																																																																															obj_t
																																																																																BgL_l1364z00_2765;
																																																																															BgL_l1364z00_2765
																																																																																=
																																																																																BgL_cdrzd2833zd2_2723;
																																																																														BgL_zc3z04anonymousza32379ze3z87_2766:
																																																																															if (NULLP(BgL_l1364z00_2765))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	BgL_test8198z00_14785
																																																																																		=
																																																																																		(
																																																																																		(bool_t)
																																																																																		1);
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	bool_t
																																																																																		BgL_test8200z00_14788;
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		bool_t
																																																																																			BgL_test8201z00_14789;
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			obj_t
																																																																																				BgL_tmpz00_14790;
																																																																																			BgL_tmpz00_14790
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_l1364z00_2765));
																																																																																			BgL_test8201z00_14789
																																																																																				=
																																																																																				PAIRP
																																																																																				(BgL_tmpz00_14790);
																																																																																		}
																																																																																		if (BgL_test8201z00_14789)
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				BgL_test8200z00_14788
																																																																																					=
																																																																																					(
																																																																																					(bool_t)
																																																																																					0);
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				BgL_test8200z00_14788
																																																																																					=
																																																																																					(
																																																																																					(bool_t)
																																																																																					1);
																																																																																			}
																																																																																	}
																																																																																	if (BgL_test8200z00_14788)
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_l1364z00_14794;
																																																																																			BgL_l1364z00_14794
																																																																																				=
																																																																																				CDR
																																																																																				(
																																																																																				((obj_t) BgL_l1364z00_2765));
																																																																																			BgL_l1364z00_2765
																																																																																				=
																																																																																				BgL_l1364z00_14794;
																																																																																			goto
																																																																																				BgL_zc3z04anonymousza32379ze3z87_2766;
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			BgL_test8198z00_14785
																																																																																				=
																																																																																				(
																																																																																				(bool_t)
																																																																																				0);
																																																																																		}
																																																																																}
																																																																														}
																																																																														if (BgL_test8198z00_14785)
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_arg2369z00_2748;
																																																																																BgL_arg2369z00_2748
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd2839zd2_2724));
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_14799;
																																																																																	BgL_testz00_1741
																																																																																		=
																																																																																		BgL_arg2369z00_2748;
																																																																																	BgL_proc1z00_1742
																																																																																		=
																																																																																		BgL_carzd2850zd2_2728;
																																																																																	BgL_proc2z00_1743
																																																																																		=
																																																																																		BgL_carzd2858zd2_2732;
																																																																																	BgL_argsz00_1744
																																																																																		=
																																																																																		BgL_cdrzd2833zd2_2723;
																																																																																BgL_tagzd2387zd2_1745:
																																																																																	{	/* Ast/sexp.scm 433 */
																																																																																		obj_t
																																																																																			BgL_nexpz00_8811;
																																																																																		{	/* Ast/sexp.scm 433 */
																																																																																			obj_t
																																																																																				BgL_arg6893z00_8813;
																																																																																			{	/* Ast/sexp.scm 433 */
																																																																																				obj_t
																																																																																					BgL_arg6894z00_8814;
																																																																																				{	/* Ast/sexp.scm 433 */
																																																																																					obj_t
																																																																																						BgL_arg6895z00_8815;
																																																																																					obj_t
																																																																																						BgL_arg6896z00_8816;
																																																																																					BgL_arg6895z00_8815
																																																																																						=
																																																																																						MAKE_YOUNG_PAIR
																																																																																						(BgL_proc1z00_1742,
																																																																																						BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																																																																						(BgL_argsz00_1744,
																																																																																							BNIL));
																																																																																					{	/* Ast/sexp.scm 433 */
																																																																																						obj_t
																																																																																							BgL_arg6898z00_8818;
																																																																																						BgL_arg6898z00_8818
																																																																																							=
																																																																																							MAKE_YOUNG_PAIR
																																																																																							(BgL_proc2z00_1743,
																																																																																							BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																																																																							(BgL_argsz00_1744,
																																																																																								BNIL));
																																																																																						BgL_arg6896z00_8816
																																																																																							=
																																																																																							MAKE_YOUNG_PAIR
																																																																																							(BgL_arg6898z00_8818,
																																																																																							BNIL);
																																																																																					}
																																																																																					BgL_arg6894z00_8814
																																																																																						=
																																																																																						MAKE_YOUNG_PAIR
																																																																																						(BgL_arg6895z00_8815,
																																																																																						BgL_arg6896z00_8816);
																																																																																				}
																																																																																				BgL_arg6893z00_8813
																																																																																					=
																																																																																					MAKE_YOUNG_PAIR
																																																																																					(BgL_testz00_1741,
																																																																																					BgL_arg6894z00_8814);
																																																																																			}
																																																																																			BgL_nexpz00_8811
																																																																																				=
																																																																																				MAKE_YOUNG_PAIR
																																																																																				(CNST_TABLE_REF
																																																																																				(((long) 1)), BgL_arg6893z00_8813);
																																																																																		}
																																																																																		BgL_auxz00_14799
																																																																																			=
																																																																																			BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																																			(BgL_nexpz00_8811,
																																																																																			BgL_stackz00_22,
																																																																																			BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																			(BgL_expz00_21,
																																																																																				BgL_locz00_23),
																																																																																			BgL_sitez00_24);
																																																																																	}
																																																																																	BgL_auxz00_14205
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_14799);
																																																																															}}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_cdrzd2882zd2_2749;
																																																																																BgL_cdrzd2882zd2_2749
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_expz00_21));
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_cdrzd2889zd2_2750;
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		obj_t
																																																																																			BgL_pairz00_10127;
																																																																																		BgL_pairz00_10127
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_expz00_21));
																																																																																		BgL_cdrzd2889zd2_2750
																																																																																			=
																																																																																			CDR
																																																																																			(BgL_pairz00_10127);
																																																																																	}
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		obj_t
																																																																																			BgL_cdrzd2896zd2_2751;
																																																																																		BgL_cdrzd2896zd2_2751
																																																																																			=
																																																																																			CDR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd2889zd2_2750));
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			obj_t
																																																																																				BgL_carzd2902zd2_2752;
																																																																																			BgL_carzd2902zd2_2752
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd2896zd2_2751));
																																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd2902zd2_2752))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					obj_t
																																																																																						BgL_carzd2909zd2_2754;
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						obj_t
																																																																																							BgL_pairz00_10131;
																																																																																						BgL_pairz00_10131
																																																																																							=
																																																																																							CDR
																																																																																							(
																																																																																							((obj_t) BgL_cdrzd2896zd2_2751));
																																																																																						BgL_carzd2909zd2_2754
																																																																																							=
																																																																																							CAR
																																																																																							(BgL_pairz00_10131);
																																																																																					}
																																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd2909zd2_2754))
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd2882zd2_2749))
																																																																																								{	/* Ast/sexp.scm 118 */
																																																																																									obj_t
																																																																																										BgL_arg2373z00_2757;
																																																																																									BgL_arg2373z00_2757
																																																																																										=
																																																																																										CAR
																																																																																										(
																																																																																										((obj_t) BgL_cdrzd2889zd2_2750));
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_14832;
																																																																																										BgL_testz00_1746
																																																																																											=
																																																																																											BgL_arg2373z00_2757;
																																																																																										BgL_proc1z00_1747
																																																																																											=
																																																																																											BgL_carzd2902zd2_2752;
																																																																																										BgL_proc2z00_1748
																																																																																											=
																																																																																											BgL_carzd2909zd2_2754;
																																																																																										BgL_argsz00_1749
																																																																																											=
																																																																																											BgL_cdrzd2882zd2_2749;
																																																																																									BgL_tagzd2388zd2_1750:
																																																																																										{	/* Ast/sexp.scm 439 */
																																																																																											obj_t
																																																																																												BgL_tmpsz00_8820;
																																																																																											if (NULLP(BgL_argsz00_1749))
																																																																																												{	/* Ast/sexp.scm 439 */
																																																																																													BgL_tmpsz00_8820
																																																																																														=
																																																																																														BNIL;
																																																																																												}
																																																																																											else
																																																																																												{	/* Ast/sexp.scm 439 */
																																																																																													obj_t
																																																																																														BgL_head1353z00_8864;
																																																																																													{	/* Ast/sexp.scm 439 */
																																																																																														obj_t
																																																																																															BgL_res7420z00_9951;
																																																																																														BgL_res7420z00_9951
																																																																																															=
																																																																																															MAKE_YOUNG_PAIR
																																																																																															(BNIL,
																																																																																															BNIL);
																																																																																														BgL_head1353z00_8864
																																																																																															=
																																																																																															BgL_res7420z00_9951;
																																																																																													}
																																																																																													{
																																																																																														obj_t
																																																																																															BgL_l1351z00_8866;
																																																																																														obj_t
																																																																																															BgL_tail1354z00_8867;
																																																																																														BgL_l1351z00_8866
																																																																																															=
																																																																																															BgL_argsz00_1749;
																																																																																														BgL_tail1354z00_8867
																																																																																															=
																																																																																															BgL_head1353z00_8864;
																																																																																													BgL_zc3z04anonymousza36929ze3z87_8868:
																																																																																														if (NULLP(BgL_l1351z00_8866))
																																																																																															{	/* Ast/sexp.scm 439 */
																																																																																																BgL_tmpsz00_8820
																																																																																																	=
																																																																																																	CDR
																																																																																																	(BgL_head1353z00_8864);
																																																																																															}
																																																																																														else
																																																																																															{	/* Ast/sexp.scm 439 */
																																																																																																obj_t
																																																																																																	BgL_newtail1355z00_8870;
																																																																																																{	/* Ast/sexp.scm 439 */
																																																																																																	obj_t
																																																																																																		BgL_arg6932z00_8872;
																																																																																																	{	/* Ast/sexp.scm 439 */

																																																																																																		{	/* Ast/sexp.scm 439 */

																																																																																																			BgL_arg6932z00_8872
																																																																																																				=
																																																																																																				BGl_gensymz00zz__r4_symbols_6_4z00
																																																																																																				(BFALSE);
																																																																																																		}
																																																																																																	}
																																																																																																	{	/* Ast/sexp.scm 439 */
																																																																																																		obj_t
																																																																																																			BgL_res7422z00_9955;
																																																																																																		BgL_res7422z00_9955
																																																																																																			=
																																																																																																			MAKE_YOUNG_PAIR
																																																																																																			(BgL_arg6932z00_8872,
																																																																																																			BNIL);
																																																																																																		BgL_newtail1355z00_8870
																																																																																																			=
																																																																																																			BgL_res7422z00_9955;
																																																																																																	}
																																																																																																}
																																																																																																SET_CDR
																																																																																																	(BgL_tail1354z00_8867,
																																																																																																	BgL_newtail1355z00_8870);
																																																																																																{	/* Ast/sexp.scm 439 */
																																																																																																	obj_t
																																																																																																		BgL_arg6931z00_8871;
																																																																																																	BgL_arg6931z00_8871
																																																																																																		=
																																																																																																		CDR
																																																																																																		(
																																																																																																		((obj_t) BgL_l1351z00_8866));
																																																																																																	{
																																																																																																		obj_t
																																																																																																			BgL_tail1354z00_14845;
																																																																																																		obj_t
																																																																																																			BgL_l1351z00_14844;
																																																																																																		BgL_l1351z00_14844
																																																																																																			=
																																																																																																			BgL_arg6931z00_8871;
																																																																																																		BgL_tail1354z00_14845
																																																																																																			=
																																																																																																			BgL_newtail1355z00_8870;
																																																																																																		BgL_tail1354z00_8867
																																																																																																			=
																																																																																																			BgL_tail1354z00_14845;
																																																																																																		BgL_l1351z00_8866
																																																																																																			=
																																																																																																			BgL_l1351z00_14844;
																																																																																																		goto
																																																																																																			BgL_zc3z04anonymousza36929ze3z87_8868;
																																																																																																	}
																																																																																																}
																																																																																															}
																																																																																													}
																																																																																												}
																																																																																											{	/* Ast/sexp.scm 439 */
																																																																																												obj_t
																																																																																													BgL_locz00_8821;
																																																																																												BgL_locz00_8821
																																																																																													=
																																																																																													BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																													(BgL_expz00_21,
																																																																																													BgL_locz00_23);
																																																																																												{	/* Ast/sexp.scm 440 */
																																																																																													obj_t
																																																																																														BgL_nexpz00_8822;
																																																																																													{	/* Ast/sexp.scm 441 */
																																																																																														obj_t
																																																																																															BgL_arg6901z00_8824;
																																																																																														obj_t
																																																																																															BgL_arg6902z00_8825;
																																																																																														BgL_arg6901z00_8824
																																																																																															=
																																																																																															BGl_letzd2symzd2zzast_letz00
																																																																																															();
																																																																																														{	/* Ast/sexp.scm 441 */
																																																																																															obj_t
																																																																																																BgL_arg6903z00_8826;
																																																																																															obj_t
																																																																																																BgL_arg6904z00_8827;
																																																																																															if (NULLP(BgL_tmpsz00_8820))
																																																																																																{	/* Ast/sexp.scm 441 */
																																																																																																	BgL_arg6903z00_8826
																																																																																																		=
																																																																																																		BNIL;
																																																																																																}
																																																																																															else
																																																																																																{	/* Ast/sexp.scm 441 */
																																																																																																	obj_t
																																																																																																		BgL_head1358z00_8831;
																																																																																																	{	/* Ast/sexp.scm 441 */
																																																																																																		obj_t
																																																																																																			BgL_arg6915z00_8849;
																																																																																																		{	/* Ast/sexp.scm 441 */
																																																																																																			obj_t
																																																																																																				BgL_arg6916z00_8850;
																																																																																																			obj_t
																																																																																																				BgL_arg6917z00_8851;
																																																																																																			BgL_arg6916z00_8850
																																																																																																				=
																																																																																																				CAR
																																																																																																				(
																																																																																																				((obj_t) BgL_tmpsz00_8820));
																																																																																																			BgL_arg6917z00_8851
																																																																																																				=
																																																																																																				CAR
																																																																																																				(
																																																																																																				((obj_t) BgL_argsz00_1749));
																																																																																																			{	/* Ast/sexp.scm 441 */
																																																																																																				obj_t
																																																																																																					BgL_list6918z00_8852;
																																																																																																				{	/* Ast/sexp.scm 441 */
																																																																																																					obj_t
																																																																																																						BgL_arg6919z00_8853;
																																																																																																					BgL_arg6919z00_8853
																																																																																																						=
																																																																																																						MAKE_YOUNG_PAIR
																																																																																																						(BgL_arg6917z00_8851,
																																																																																																						BNIL);
																																																																																																					BgL_list6918z00_8852
																																																																																																						=
																																																																																																						MAKE_YOUNG_PAIR
																																																																																																						(BgL_arg6916z00_8850,
																																																																																																						BgL_arg6919z00_8853);
																																																																																																				}
																																																																																																				BgL_arg6915z00_8849
																																																																																																					=
																																																																																																					BgL_list6918z00_8852;
																																																																																																			}
																																																																																																		}
																																																																																																		{	/* Ast/sexp.scm 441 */
																																																																																																			obj_t
																																																																																																				BgL_res7425z00_9962;
																																																																																																			BgL_res7425z00_9962
																																																																																																				=
																																																																																																				MAKE_YOUNG_PAIR
																																																																																																				(BgL_arg6915z00_8849,
																																																																																																				BNIL);
																																																																																																			BgL_head1358z00_8831
																																																																																																				=
																																																																																																				BgL_res7425z00_9962;
																																																																																																		}
																																																																																																	}
																																																																																																	{	/* Ast/sexp.scm 441 */
																																																																																																		obj_t
																																																																																																			BgL_g1362z00_8832;
																																																																																																		obj_t
																																																																																																			BgL_g1363z00_8833;
																																																																																																		BgL_g1362z00_8832
																																																																																																			=
																																																																																																			CDR
																																																																																																			(
																																																																																																			((obj_t) BgL_tmpsz00_8820));
																																																																																																		BgL_g1363z00_8833
																																																																																																			=
																																																																																																			CDR
																																																																																																			(
																																																																																																			((obj_t) BgL_argsz00_1749));
																																																																																																		{
																																																																																																			obj_t
																																																																																																				BgL_ll1356z00_8835;
																																																																																																			obj_t
																																																																																																				BgL_ll1357z00_8836;
																																																																																																			obj_t
																																																																																																				BgL_tail1359z00_8837;
																																																																																																			BgL_ll1356z00_8835
																																																																																																				=
																																																																																																				BgL_g1362z00_8832;
																																																																																																			BgL_ll1357z00_8836
																																																																																																				=
																																																																																																				BgL_g1363z00_8833;
																																																																																																			BgL_tail1359z00_8837
																																																																																																				=
																																																																																																				BgL_head1358z00_8831;
																																																																																																		BgL_zc3z04anonymousza36906ze3z87_8838:
																																																																																																			if (NULLP(BgL_ll1356z00_8835))
																																																																																																				{	/* Ast/sexp.scm 441 */
																																																																																																					BgL_arg6903z00_8826
																																																																																																						=
																																																																																																						BgL_head1358z00_8831;
																																																																																																				}
																																																																																																			else
																																																																																																				{	/* Ast/sexp.scm 441 */
																																																																																																					obj_t
																																																																																																						BgL_newtail1360z00_8840;
																																																																																																					{	/* Ast/sexp.scm 441 */
																																																																																																						obj_t
																																																																																																							BgL_arg6910z00_8843;
																																																																																																						{	/* Ast/sexp.scm 441 */
																																																																																																							obj_t
																																																																																																								BgL_arg6911z00_8844;
																																																																																																							obj_t
																																																																																																								BgL_arg6912z00_8845;
																																																																																																							BgL_arg6911z00_8844
																																																																																																								=
																																																																																																								CAR
																																																																																																								(
																																																																																																								((obj_t) BgL_ll1356z00_8835));
																																																																																																							BgL_arg6912z00_8845
																																																																																																								=
																																																																																																								CAR
																																																																																																								(
																																																																																																								((obj_t) BgL_ll1357z00_8836));
																																																																																																							{	/* Ast/sexp.scm 441 */
																																																																																																								obj_t
																																																																																																									BgL_list6913z00_8846;
																																																																																																								{	/* Ast/sexp.scm 441 */
																																																																																																									obj_t
																																																																																																										BgL_arg6914z00_8847;
																																																																																																									BgL_arg6914z00_8847
																																																																																																										=
																																																																																																										MAKE_YOUNG_PAIR
																																																																																																										(BgL_arg6912z00_8845,
																																																																																																										BNIL);
																																																																																																									BgL_list6913z00_8846
																																																																																																										=
																																																																																																										MAKE_YOUNG_PAIR
																																																																																																										(BgL_arg6911z00_8844,
																																																																																																										BgL_arg6914z00_8847);
																																																																																																								}
																																																																																																								BgL_arg6910z00_8843
																																																																																																									=
																																																																																																									BgL_list6913z00_8846;
																																																																																																							}
																																																																																																						}
																																																																																																						{	/* Ast/sexp.scm 441 */
																																																																																																							obj_t
																																																																																																								BgL_res7428z00_9969;
																																																																																																							BgL_res7428z00_9969
																																																																																																								=
																																																																																																								MAKE_YOUNG_PAIR
																																																																																																								(BgL_arg6910z00_8843,
																																																																																																								BNIL);
																																																																																																							BgL_newtail1360z00_8840
																																																																																																								=
																																																																																																								BgL_res7428z00_9969;
																																																																																																						}
																																																																																																					}
																																																																																																					SET_CDR
																																																																																																						(BgL_tail1359z00_8837,
																																																																																																						BgL_newtail1360z00_8840);
																																																																																																					{	/* Ast/sexp.scm 441 */
																																																																																																						obj_t
																																																																																																							BgL_arg6908z00_8841;
																																																																																																						obj_t
																																																																																																							BgL_arg6909z00_8842;
																																																																																																						BgL_arg6908z00_8841
																																																																																																							=
																																																																																																							CDR
																																																																																																							(
																																																																																																							((obj_t) BgL_ll1356z00_8835));
																																																																																																						BgL_arg6909z00_8842
																																																																																																							=
																																																																																																							CDR
																																																																																																							(
																																																																																																							((obj_t) BgL_ll1357z00_8836));
																																																																																																						{
																																																																																																							obj_t
																																																																																																								BgL_tail1359z00_14877;
																																																																																																							obj_t
																																																																																																								BgL_ll1357z00_14876;
																																																																																																							obj_t
																																																																																																								BgL_ll1356z00_14875;
																																																																																																							BgL_ll1356z00_14875
																																																																																																								=
																																																																																																								BgL_arg6908z00_8841;
																																																																																																							BgL_ll1357z00_14876
																																																																																																								=
																																																																																																								BgL_arg6909z00_8842;
																																																																																																							BgL_tail1359z00_14877
																																																																																																								=
																																																																																																								BgL_newtail1360z00_8840;
																																																																																																							BgL_tail1359z00_8837
																																																																																																								=
																																																																																																								BgL_tail1359z00_14877;
																																																																																																							BgL_ll1357z00_8836
																																																																																																								=
																																																																																																								BgL_ll1357z00_14876;
																																																																																																							BgL_ll1356z00_8835
																																																																																																								=
																																																																																																								BgL_ll1356z00_14875;
																																																																																																							goto
																																																																																																								BgL_zc3z04anonymousza36906ze3z87_8838;
																																																																																																						}
																																																																																																					}
																																																																																																				}
																																																																																																		}
																																																																																																	}
																																																																																																}
																																																																																															{	/* Ast/sexp.scm 442 */
																																																																																																obj_t
																																																																																																	BgL_arg6920z00_8854;
																																																																																																{	/* Ast/sexp.scm 442 */
																																																																																																	obj_t
																																																																																																		BgL_arg6921z00_8855;
																																																																																																	{	/* Ast/sexp.scm 442 */
																																																																																																		obj_t
																																																																																																			BgL_arg6922z00_8856;
																																																																																																		{	/* Ast/sexp.scm 442 */
																																																																																																			obj_t
																																																																																																				BgL_arg6923z00_8857;
																																																																																																			obj_t
																																																																																																				BgL_arg6924z00_8858;
																																																																																																			BgL_arg6923z00_8857
																																																																																																				=
																																																																																																				MAKE_YOUNG_PAIR
																																																																																																				(BgL_proc1z00_1747,
																																																																																																				BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																																																																																				(BgL_tmpsz00_8820,
																																																																																																					BNIL));
																																																																																																			{	/* Ast/sexp.scm 442 */
																																																																																																				obj_t
																																																																																																					BgL_arg6926z00_8860;
																																																																																																				BgL_arg6926z00_8860
																																																																																																					=
																																																																																																					MAKE_YOUNG_PAIR
																																																																																																					(BgL_proc2z00_1748,
																																																																																																					BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																																																																																					(BgL_tmpsz00_8820,
																																																																																																						BNIL));
																																																																																																				BgL_arg6924z00_8858
																																																																																																					=
																																																																																																					MAKE_YOUNG_PAIR
																																																																																																					(BgL_arg6926z00_8860,
																																																																																																					BNIL);
																																																																																																			}
																																																																																																			BgL_arg6922z00_8856
																																																																																																				=
																																																																																																				MAKE_YOUNG_PAIR
																																																																																																				(BgL_arg6923z00_8857,
																																																																																																				BgL_arg6924z00_8858);
																																																																																																		}
																																																																																																		BgL_arg6921z00_8855
																																																																																																			=
																																																																																																			MAKE_YOUNG_PAIR
																																																																																																			(BgL_testz00_1746,
																																																																																																			BgL_arg6922z00_8856);
																																																																																																	}
																																																																																																	BgL_arg6920z00_8854
																																																																																																		=
																																																																																																		MAKE_YOUNG_PAIR
																																																																																																		(CNST_TABLE_REF
																																																																																																		(((long) 1)), BgL_arg6921z00_8855);
																																																																																																}
																																																																																																BgL_arg6904z00_8827
																																																																																																	=
																																																																																																	MAKE_YOUNG_PAIR
																																																																																																	(BgL_arg6920z00_8854,
																																																																																																	BNIL);
																																																																																															}
																																																																																															BgL_arg6902z00_8825
																																																																																																=
																																																																																																MAKE_YOUNG_PAIR
																																																																																																(BgL_arg6903z00_8826,
																																																																																																BgL_arg6904z00_8827);
																																																																																														}
																																																																																														BgL_nexpz00_8822
																																																																																															=
																																																																																															MAKE_YOUNG_PAIR
																																																																																															(BgL_arg6901z00_8824,
																																																																																															BgL_arg6902z00_8825);
																																																																																													}
																																																																																													{	/* Ast/sexp.scm 441 */

																																																																																														BgL_auxz00_14832
																																																																																															=
																																																																																															BGl_letzd2ze3nodez31zzast_letz00
																																																																																															(BgL_nexpz00_8822,
																																																																																															BgL_stackz00_22,
																																																																																															BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																															(BgL_expz00_21,
																																																																																																BgL_locz00_8821),
																																																																																															BgL_sitez00_24);
																																																																																										}}}}
																																																																																										BgL_auxz00_14205
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_14832);
																																																																																								}}
																																																																																							else
																																																																																								{	/* Ast/sexp.scm 118 */
																																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																										{	/* Ast/sexp.scm 118 */
																																																																																										BgL_tagzd2403zd2_1774:
																																																																																											BgL_auxz00_14205 = BGl_privatezd2nodezd2zzast_privatez00(BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																																										}
																																																																																									else
																																																																																										{
																																																																																											BgL_nodez00_bglt
																																																																																												BgL_auxz00_14896;
																																																																																										BgL_tagzd2404zd2_1775:
																																																																																											BgL_auxz00_14896 = BGl_callzd2ze3nodez31zzast_sexpz00(BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																																											BgL_auxz00_14205
																																																																																												=
																																																																																												(
																																																																																												(obj_t)
																																																																																												BgL_auxz00_14896);
																																																																																										}
																																																																																								}
																																																																																						}
																																																																																					else
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																								{	/* Ast/sexp.scm 118 */
																																																																																									goto
																																																																																										BgL_tagzd2403zd2_1774;
																																																																																								}
																																																																																							else
																																																																																								{
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_auxz00_14901;
																																																																																									goto
																																																																																										BgL_tagzd2404zd2_1775;
																																																																																									BgL_auxz00_14205
																																																																																										=
																																																																																										(
																																																																																										(obj_t)
																																																																																										BgL_auxz00_14901);
																																																																																								}
																																																																																						}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							goto
																																																																																								BgL_tagzd2403zd2_1774;
																																																																																						}
																																																																																					else
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_14905;
																																																																																							goto
																																																																																								BgL_tagzd2404zd2_1775;
																																																																																							BgL_auxz00_14205
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_14905);
																																																																																						}
																																																																																				}
																																																																																		}
																																																																																	}
																																																																																}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1774;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_14909;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1775;
																																																																																BgL_auxz00_14205
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_14909);
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_cdrzd21185zd2_2776;
																																																																												BgL_cdrzd21185zd2_2776
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_expz00_21));
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_cdrzd21191zd2_2777;
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_pairz00_10135;
																																																																														BgL_pairz00_10135
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_expz00_21));
																																																																														BgL_cdrzd21191zd2_2777
																																																																															=
																																																																															CDR
																																																																															(BgL_pairz00_10135);
																																																																													}
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_cdrzd21197zd2_2778;
																																																																														BgL_cdrzd21197zd2_2778
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd21191zd2_2777));
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_carzd21202zd2_2779;
																																																																															obj_t
																																																																																BgL_cdrzd21203zd2_2780;
																																																																															BgL_carzd21202zd2_2779
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd21197zd2_2778));
																																																																															BgL_cdrzd21203zd2_2780
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_cdrzd21197zd2_2778));
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd21202zd2_2779))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_carzd21208zd2_2782;
																																																																																	BgL_carzd21208zd2_2782
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd21203zd2_2780));
																																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd21208zd2_2782))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			if (NULLP(CDR(((obj_t) BgL_cdrzd21203zd2_2780))))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd21185zd2_2776))
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							obj_t
																																																																																								BgL_arg2389z00_2787;
																																																																																							BgL_arg2389z00_2787
																																																																																								=
																																																																																								CAR
																																																																																								(
																																																																																								((obj_t) BgL_cdrzd21191zd2_2777));
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_14936;
																																																																																								{
																																																																																									obj_t
																																																																																										BgL_argsz00_14940;
																																																																																									obj_t
																																																																																										BgL_proc2z00_14939;
																																																																																									obj_t
																																																																																										BgL_proc1z00_14938;
																																																																																									obj_t
																																																																																										BgL_testz00_14937;
																																																																																									BgL_testz00_14937
																																																																																										=
																																																																																										BgL_arg2389z00_2787;
																																																																																									BgL_proc1z00_14938
																																																																																										=
																																																																																										BgL_carzd21202zd2_2779;
																																																																																									BgL_proc2z00_14939
																																																																																										=
																																																																																										BgL_carzd21208zd2_2782;
																																																																																									BgL_argsz00_14940
																																																																																										=
																																																																																										BgL_cdrzd21185zd2_2776;
																																																																																									BgL_argsz00_1749
																																																																																										=
																																																																																										BgL_argsz00_14940;
																																																																																									BgL_proc2z00_1748
																																																																																										=
																																																																																										BgL_proc2z00_14939;
																																																																																									BgL_proc1z00_1747
																																																																																										=
																																																																																										BgL_proc1z00_14938;
																																																																																									BgL_testz00_1746
																																																																																										=
																																																																																										BgL_testz00_14937;
																																																																																									goto
																																																																																										BgL_tagzd2388zd2_1750;
																																																																																								}
																																																																																								BgL_auxz00_14205
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_14936);
																																																																																							}
																																																																																						}
																																																																																					else
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																								{	/* Ast/sexp.scm 118 */
																																																																																									goto
																																																																																										BgL_tagzd2403zd2_1774;
																																																																																								}
																																																																																							else
																																																																																								{
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_auxz00_14944;
																																																																																									goto
																																																																																										BgL_tagzd2404zd2_1775;
																																																																																									BgL_auxz00_14205
																																																																																										=
																																																																																										(
																																																																																										(obj_t)
																																																																																										BgL_auxz00_14944);
																																																																																								}
																																																																																						}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							goto
																																																																																								BgL_tagzd2403zd2_1774;
																																																																																						}
																																																																																					else
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_14948;
																																																																																							goto
																																																																																								BgL_tagzd2404zd2_1775;
																																																																																							BgL_auxz00_14205
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_14948);
																																																																																						}
																																																																																				}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1774;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_14952;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1775;
																																																																																					BgL_auxz00_14205
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_14952);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1774;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_14956;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1775;
																																																																																			BgL_auxz00_14205
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_14956);
																																																																																		}
																																																																																}
																																																																														}
																																																																													}
																																																																												}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1774;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_14960;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1775;
																																																																												BgL_auxz00_14205
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_14960);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_cdrzd21541zd2_2795;
																																																																								BgL_cdrzd21541zd2_2795
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_cdrzd21548zd2_2796;
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_pairz00_10145;
																																																																										BgL_pairz00_10145
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										BgL_cdrzd21548zd2_2796
																																																																											=
																																																																											CDR
																																																																											(BgL_pairz00_10145);
																																																																									}
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_cdrzd21555zd2_2797;
																																																																										BgL_cdrzd21555zd2_2797
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd21548zd2_2796));
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_carzd21561zd2_2798;
																																																																											obj_t
																																																																												BgL_cdrzd21562zd2_2799;
																																																																											BgL_carzd21561zd2_2798
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd21555zd2_2797));
																																																																											BgL_cdrzd21562zd2_2799
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd21555zd2_2797));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd21561zd2_2798))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (PAIRP(BgL_cdrzd21562zd2_2799))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_carzd21569zd2_2802;
																																																																															BgL_carzd21569zd2_2802
																																																																																=
																																																																																CAR
																																																																																(BgL_cdrzd21562zd2_2799);
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd21569zd2_2802))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (NULLP(CDR(BgL_cdrzd21562zd2_2799)))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd21541zd2_2795))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					obj_t
																																																																																						BgL_arg2404z00_2807;
																																																																																					BgL_arg2404z00_2807
																																																																																						=
																																																																																						CAR
																																																																																						(
																																																																																						((obj_t) BgL_cdrzd21548zd2_2796));
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_14987;
																																																																																						{
																																																																																							obj_t
																																																																																								BgL_argsz00_14991;
																																																																																							obj_t
																																																																																								BgL_proc2z00_14990;
																																																																																							obj_t
																																																																																								BgL_proc1z00_14989;
																																																																																							obj_t
																																																																																								BgL_testz00_14988;
																																																																																							BgL_testz00_14988
																																																																																								=
																																																																																								BgL_arg2404z00_2807;
																																																																																							BgL_proc1z00_14989
																																																																																								=
																																																																																								BgL_carzd21561zd2_2798;
																																																																																							BgL_proc2z00_14990
																																																																																								=
																																																																																								BgL_carzd21569zd2_2802;
																																																																																							BgL_argsz00_14991
																																																																																								=
																																																																																								BgL_cdrzd21541zd2_2795;
																																																																																							BgL_argsz00_1749
																																																																																								=
																																																																																								BgL_argsz00_14991;
																																																																																							BgL_proc2z00_1748
																																																																																								=
																																																																																								BgL_proc2z00_14990;
																																																																																							BgL_proc1z00_1747
																																																																																								=
																																																																																								BgL_proc1z00_14989;
																																																																																							BgL_testz00_1746
																																																																																								=
																																																																																								BgL_testz00_14988;
																																																																																							goto
																																																																																								BgL_tagzd2388zd2_1750;
																																																																																						}
																																																																																						BgL_auxz00_14205
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_14987);
																																																																																					}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							goto
																																																																																								BgL_tagzd2403zd2_1774;
																																																																																						}
																																																																																					else
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_14995;
																																																																																							goto
																																																																																								BgL_tagzd2404zd2_1775;
																																																																																							BgL_auxz00_14205
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_14995);
																																																																																						}
																																																																																				}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1774;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_14999;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1775;
																																																																																					BgL_auxz00_14205
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_14999);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1774;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_15003;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1775;
																																																																																			BgL_auxz00_14205
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_15003);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1774;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_15007;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1775;
																																																																																	BgL_auxz00_14205
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_15007);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1774;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_15011;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1775;
																																																																															BgL_auxz00_14205
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_15011);
																																																																														}
																																																																												}
																																																																										}
																																																																									}
																																																																								}
																																																																							}
																																																																					}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1774;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_15015;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1775;
																																																																							BgL_auxz00_14205
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_15015);
																																																																						}
																																																																				}
																																																																		}
																																																																	}
																																																															}
																																																														}
																																																												}
																																																										}
																																																									}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_cdrzd21962zd2_2821;
																																																								BgL_cdrzd21962zd2_2821
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{	/* Ast/sexp.scm 118 */
																																																									bool_t
																																																										BgL_test8233z00_15019;
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_arg2437z00_2838;
																																																										BgL_arg2437z00_2838
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_test8233z00_15019
																																																											=
																																																											CBOOL
																																																											(BGl_letzd2symzf3z21zzast_letz00
																																																											(BgL_arg2437z00_2838));
																																																									}
																																																									if (BgL_test8233z00_15019)
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_arg2423z00_2824;
																																																											obj_t
																																																												BgL_arg2424z00_2825;
																																																											BgL_arg2423z00_2824
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_cdrzd21962zd2_2821));
																																																											BgL_arg2424z00_2825
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd21962zd2_2821));
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_15028;
																																																												{
																																																													obj_t
																																																														BgL_exprz00_15030;
																																																													obj_t
																																																														BgL_bindingsz00_15029;
																																																													BgL_bindingsz00_15029
																																																														=
																																																														BgL_arg2423z00_2824;
																																																													BgL_exprz00_15030
																																																														=
																																																														BgL_arg2424z00_2825;
																																																													BgL_exprz00_1729
																																																														=
																																																														BgL_exprz00_15030;
																																																													BgL_bindingsz00_1728
																																																														=
																																																														BgL_bindingsz00_15029;
																																																													goto
																																																														BgL_tagzd2382zd2_1730;
																																																												}
																																																												BgL_auxz00_14205
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_15028);
																																																											}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											bool_t
																																																												BgL_test8234z00_15032;
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_arg2436z00_2837;
																																																												BgL_arg2436z00_2837
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												BgL_test8234z00_15032
																																																													=
																																																													CBOOL
																																																													(BGl_labelszd2symzf3z21zzast_labelsz00
																																																													(BgL_arg2436z00_2837));
																																																											}
																																																											if (BgL_test8234z00_15032)
																																																												{
																																																													BgL_letzd2funzd2_bglt
																																																														BgL_auxz00_15037;
																																																													goto
																																																														BgL_tagzd2384zd2_1732;
																																																													BgL_auxz00_14205
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_15037);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_carzd22028zd2_2828;
																																																													BgL_carzd22028zd2_2828
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_cdrzd22033zd2_2829;
																																																														BgL_cdrzd22033zd2_2829
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_carzd22028zd2_2828));
																																																														if ((CAR(((obj_t) BgL_carzd22028zd2_2828)) == CNST_TABLE_REF(((long) 3))))
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_arg2430z00_2832;
																																																																obj_t
																																																																	BgL_arg2431z00_2833;
																																																																obj_t
																																																																	BgL_arg2433z00_2834;
																																																																BgL_arg2430z00_2832
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd22033zd2_2829));
																																																																BgL_arg2431z00_2833
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd22033zd2_2829));
																																																																BgL_arg2433z00_2834
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_15054;
																																																																	{
																																																																		obj_t
																																																																			BgL_argsz00_15057;
																																																																		obj_t
																																																																			BgL_bodyz00_15056;
																																																																		obj_t
																																																																			BgL_varsz00_15055;
																																																																		BgL_varsz00_15055
																																																																			=
																																																																			BgL_arg2430z00_2832;
																																																																		BgL_bodyz00_15056
																																																																			=
																																																																			BgL_arg2431z00_2833;
																																																																		BgL_argsz00_15057
																																																																			=
																																																																			BgL_arg2433z00_2834;
																																																																		BgL_argsz00_1739
																																																																			=
																																																																			BgL_argsz00_15057;
																																																																		BgL_bodyz00_1738
																																																																			=
																																																																			BgL_bodyz00_15056;
																																																																		BgL_varsz00_1737
																																																																			=
																																																																			BgL_varsz00_15055;
																																																																		goto
																																																																			BgL_tagzd2386zd2_1740;
																																																																	}
																																																																	BgL_auxz00_14205
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_15054);
																																																																}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1774;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_15061;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1775;
																																																																		BgL_auxz00_14205
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_15061);
																																																																	}
																																																															}
																																																													}
																																																												}
																																																										}
																																																								}
																																																							}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_cdrzd22144zd2_2839;
																																																						BgL_cdrzd22144zd2_2839
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{	/* Ast/sexp.scm 118 */
																																																							bool_t
																																																								BgL_test8237z00_15065;
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_arg2448z00_2848;
																																																								BgL_arg2448z00_2848
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test8237z00_15065
																																																									=
																																																									CBOOL
																																																									(BGl_letzd2symzf3z21zzast_letz00
																																																									(BgL_arg2448z00_2848));
																																																							}
																																																							if (BgL_test8237z00_15065)
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_arg2441z00_2842;
																																																									obj_t
																																																										BgL_arg2442z00_2843;
																																																									BgL_arg2441z00_2842
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd22144zd2_2839));
																																																									BgL_arg2442z00_2843
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd22144zd2_2839));
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_15074;
																																																										{
																																																											obj_t
																																																												BgL_exprz00_15076;
																																																											obj_t
																																																												BgL_bindingsz00_15075;
																																																											BgL_bindingsz00_15075
																																																												=
																																																												BgL_arg2441z00_2842;
																																																											BgL_exprz00_15076
																																																												=
																																																												BgL_arg2442z00_2843;
																																																											BgL_exprz00_1729
																																																												=
																																																												BgL_exprz00_15076;
																																																											BgL_bindingsz00_1728
																																																												=
																																																												BgL_bindingsz00_15075;
																																																											goto
																																																												BgL_tagzd2382zd2_1730;
																																																										}
																																																										BgL_auxz00_14205
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_15074);
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									bool_t
																																																										BgL_test8238z00_15078;
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_arg2447z00_2847;
																																																										BgL_arg2447z00_2847
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_test8238z00_15078
																																																											=
																																																											CBOOL
																																																											(BGl_labelszd2symzf3z21zzast_labelsz00
																																																											(BgL_arg2447z00_2847));
																																																									}
																																																									if (BgL_test8238z00_15078)
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_15083;
																																																											goto
																																																												BgL_tagzd2384zd2_1732;
																																																											BgL_auxz00_14205
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_15083);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{	/* Ast/sexp.scm 118 */
																																																													goto
																																																														BgL_tagzd2403zd2_1774;
																																																												}
																																																											else
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_15087;
																																																													goto
																																																														BgL_tagzd2404zd2_1775;
																																																													BgL_auxz00_14205
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_15087);
																																																												}
																																																										}
																																																								}
																																																						}
																																																					}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 118 */
																																																				if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd2709zd2_2575)))
																																																					{	/* Ast/sexp.scm 118 */
																																																						goto
																																																							BgL_kapzd2711zd2_2577;
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 118 */
																																																						if ((BgL_carzd2709zd2_2575 == CNST_TABLE_REF(((long) 18))))
																																																							{	/* Ast/sexp.scm 118 */
																																																								goto
																																																									BgL_kapzd2711zd2_2577;
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 118 */
																																																								if ((BgL_carzd2709zd2_2575 == CNST_TABLE_REF(((long) 19))))
																																																									{	/* Ast/sexp.scm 118 */
																																																										goto
																																																											BgL_kapzd2711zd2_2577;
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 118 */
																																																										if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd2709zd2_2575)))
																																																											{	/* Ast/sexp.scm 118 */
																																																												goto
																																																													BgL_kapzd2711zd2_2577;
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_cdrzd22316zd2_2583;
																																																												BgL_cdrzd22316zd2_2583
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{	/* Ast/sexp.scm 118 */
																																																													bool_t
																																																														BgL_test8244z00_15103;
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_arg2337z00_2700;
																																																														BgL_arg2337z00_2700
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														BgL_test8244z00_15103
																																																															=
																																																															CBOOL
																																																															(BGl_letzd2symzf3z21zzast_letz00
																																																															(BgL_arg2337z00_2700));
																																																													}
																																																													if (BgL_test8244z00_15103)
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_arg2262z00_2586;
																																																															obj_t
																																																																BgL_arg2263z00_2587;
																																																															BgL_arg2262z00_2586
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_cdrzd22316zd2_2583));
																																																															BgL_arg2263z00_2587
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd22316zd2_2583));
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_15112;
																																																																{
																																																																	obj_t
																																																																		BgL_exprz00_15114;
																																																																	obj_t
																																																																		BgL_bindingsz00_15113;
																																																																	BgL_bindingsz00_15113
																																																																		=
																																																																		BgL_arg2262z00_2586;
																																																																	BgL_exprz00_15114
																																																																		=
																																																																		BgL_arg2263z00_2587;
																																																																	BgL_exprz00_1729
																																																																		=
																																																																		BgL_exprz00_15114;
																																																																	BgL_bindingsz00_1728
																																																																		=
																																																																		BgL_bindingsz00_15113;
																																																																	goto
																																																																		BgL_tagzd2382zd2_1730;
																																																																}
																																																																BgL_auxz00_14205
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_15112);
																																																															}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															bool_t
																																																																BgL_test8245z00_15116;
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_arg2335z00_2699;
																																																																BgL_arg2335z00_2699
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																BgL_test8245z00_15116
																																																																	=
																																																																	CBOOL
																																																																	(BGl_labelszd2symzf3z21zzast_labelsz00
																																																																	(BgL_arg2335z00_2699));
																																																															}
																																																															if (BgL_test8245z00_15116)
																																																																{
																																																																	BgL_letzd2funzd2_bglt
																																																																		BgL_auxz00_15121;
																																																																	goto
																																																																		BgL_tagzd2384zd2_1732;
																																																																	BgL_auxz00_14205
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_15121);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_carzd22382zd2_2590;
																																																																	BgL_carzd22382zd2_2590
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_expz00_21));
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_cdrzd22387zd2_2591;
																																																																		BgL_cdrzd22387zd2_2591
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_carzd22382zd2_2590));
																																																																		if ((CAR(((obj_t) BgL_carzd22382zd2_2590)) == CNST_TABLE_REF(((long) 3))))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (PAIRP(BgL_cdrzd22387zd2_2591))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_arg2269z00_2595;
																																																																						obj_t
																																																																							BgL_arg2270z00_2596;
																																																																						obj_t
																																																																							BgL_arg2271z00_2597;
																																																																						BgL_arg2269z00_2595
																																																																							=
																																																																							CAR
																																																																							(BgL_cdrzd22387zd2_2591);
																																																																						BgL_arg2270z00_2596
																																																																							=
																																																																							CDR
																																																																							(BgL_cdrzd22387zd2_2591);
																																																																						BgL_arg2271z00_2597
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_15138;
																																																																							{
																																																																								obj_t
																																																																									BgL_argsz00_15141;
																																																																								obj_t
																																																																									BgL_bodyz00_15140;
																																																																								obj_t
																																																																									BgL_varsz00_15139;
																																																																								BgL_varsz00_15139
																																																																									=
																																																																									BgL_arg2269z00_2595;
																																																																								BgL_bodyz00_15140
																																																																									=
																																																																									BgL_arg2270z00_2596;
																																																																								BgL_argsz00_15141
																																																																									=
																																																																									BgL_arg2271z00_2597;
																																																																								BgL_argsz00_1739
																																																																									=
																																																																									BgL_argsz00_15141;
																																																																								BgL_bodyz00_1738
																																																																									=
																																																																									BgL_bodyz00_15140;
																																																																								BgL_varsz00_1737
																																																																									=
																																																																									BgL_varsz00_15139;
																																																																								goto
																																																																									BgL_tagzd2386zd2_1740;
																																																																							}
																																																																							BgL_auxz00_14205
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_15138);
																																																																						}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1774;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_15145;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1775;
																																																																								BgL_auxz00_14205
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_15145);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_cdrzd22494zd2_2600;
																																																																				BgL_cdrzd22494zd2_2600
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_cdrzd22499zd2_2601;
																																																																					BgL_cdrzd22499zd2_2601
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_carzd22382zd2_2590));
																																																																					if ((CAR(((obj_t) BgL_carzd22382zd2_2590)) == CNST_TABLE_REF(((long) 1))))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (PAIRP(BgL_cdrzd22499zd2_2601))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_cdrzd22504zd2_2605;
																																																																									BgL_cdrzd22504zd2_2605
																																																																										=
																																																																										CDR
																																																																										(BgL_cdrzd22499zd2_2601);
																																																																									if (PAIRP(BgL_cdrzd22504zd2_2605))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_carzd22508zd2_2607;
																																																																											obj_t
																																																																												BgL_cdrzd22509zd2_2608;
																																																																											BgL_carzd22508zd2_2607
																																																																												=
																																																																												CAR
																																																																												(BgL_cdrzd22504zd2_2605);
																																																																											BgL_cdrzd22509zd2_2608
																																																																												=
																																																																												CDR
																																																																												(BgL_cdrzd22504zd2_2605);
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd22508zd2_2607))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (PAIRP(BgL_cdrzd22509zd2_2608))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_carzd22514zd2_2611;
																																																																															BgL_carzd22514zd2_2611
																																																																																=
																																																																																CAR
																																																																																(BgL_cdrzd22509zd2_2608);
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd22514zd2_2611))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (NULLP(CDR(BgL_cdrzd22509zd2_2608)))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			bool_t
																																																																																				BgL_test8256z00_15173;
																																																																																			{
																																																																																				obj_t
																																																																																					BgL_l1367z00_2644;
																																																																																				BgL_l1367z00_2644
																																																																																					=
																																																																																					BgL_cdrzd22494zd2_2600;
																																																																																			BgL_zc3z04anonymousza32299ze3z87_2645:
																																																																																				if (NULLP(BgL_l1367z00_2644))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						BgL_test8256z00_15173
																																																																																							=
																																																																																							(
																																																																																							(bool_t)
																																																																																							1);
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						bool_t
																																																																																							BgL_test8258z00_15176;
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							bool_t
																																																																																								BgL_test8259z00_15177;
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								obj_t
																																																																																									BgL_tmpz00_15178;
																																																																																								BgL_tmpz00_15178
																																																																																									=
																																																																																									CAR
																																																																																									(
																																																																																									((obj_t) BgL_l1367z00_2644));
																																																																																								BgL_test8259z00_15177
																																																																																									=
																																																																																									PAIRP
																																																																																									(BgL_tmpz00_15178);
																																																																																							}
																																																																																							if (BgL_test8259z00_15177)
																																																																																								{	/* Ast/sexp.scm 118 */
																																																																																									BgL_test8258z00_15176
																																																																																										=
																																																																																										(
																																																																																										(bool_t)
																																																																																										0);
																																																																																								}
																																																																																							else
																																																																																								{	/* Ast/sexp.scm 118 */
																																																																																									BgL_test8258z00_15176
																																																																																										=
																																																																																										(
																																																																																										(bool_t)
																																																																																										1);
																																																																																								}
																																																																																						}
																																																																																						if (BgL_test8258z00_15176)
																																																																																							{
																																																																																								obj_t
																																																																																									BgL_l1367z00_15182;
																																																																																								BgL_l1367z00_15182
																																																																																									=
																																																																																									CDR
																																																																																									(
																																																																																									((obj_t) BgL_l1367z00_2644));
																																																																																								BgL_l1367z00_2644
																																																																																									=
																																																																																									BgL_l1367z00_15182;
																																																																																								goto
																																																																																									BgL_zc3z04anonymousza32299ze3z87_2645;
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								BgL_test8256z00_15173
																																																																																									=
																																																																																									(
																																																																																									(bool_t)
																																																																																									0);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																			if (BgL_test8256z00_15173)
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					obj_t
																																																																																						BgL_arg2288z00_2627;
																																																																																					BgL_arg2288z00_2627
																																																																																						=
																																																																																						CAR
																																																																																						(BgL_cdrzd22499zd2_2601);
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_15186;
																																																																																						{
																																																																																							obj_t
																																																																																								BgL_argsz00_15190;
																																																																																							obj_t
																																																																																								BgL_proc2z00_15189;
																																																																																							obj_t
																																																																																								BgL_proc1z00_15188;
																																																																																							obj_t
																																																																																								BgL_testz00_15187;
																																																																																							BgL_testz00_15187
																																																																																								=
																																																																																								BgL_arg2288z00_2627;
																																																																																							BgL_proc1z00_15188
																																																																																								=
																																																																																								BgL_carzd22508zd2_2607;
																																																																																							BgL_proc2z00_15189
																																																																																								=
																																																																																								BgL_carzd22514zd2_2611;
																																																																																							BgL_argsz00_15190
																																																																																								=
																																																																																								BgL_cdrzd22494zd2_2600;
																																																																																							BgL_argsz00_1744
																																																																																								=
																																																																																								BgL_argsz00_15190;
																																																																																							BgL_proc2z00_1743
																																																																																								=
																																																																																								BgL_proc2z00_15189;
																																																																																							BgL_proc1z00_1742
																																																																																								=
																																																																																								BgL_proc1z00_15188;
																																																																																							BgL_testz00_1741
																																																																																								=
																																																																																								BgL_testz00_15187;
																																																																																							goto
																																																																																								BgL_tagzd2387zd2_1745;
																																																																																						}
																																																																																						BgL_auxz00_14205
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_15186);
																																																																																					}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					obj_t
																																																																																						BgL_cdrzd22539zd2_2628;
																																																																																					BgL_cdrzd22539zd2_2628
																																																																																						=
																																																																																						CDR
																																																																																						(
																																																																																						((obj_t) BgL_expz00_21));
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						obj_t
																																																																																							BgL_cdrzd22547zd2_2629;
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							obj_t
																																																																																								BgL_pairz00_10202;
																																																																																							BgL_pairz00_10202
																																																																																								=
																																																																																								CAR
																																																																																								(
																																																																																								((obj_t) BgL_expz00_21));
																																																																																							BgL_cdrzd22547zd2_2629
																																																																																								=
																																																																																								CDR
																																																																																								(BgL_pairz00_10202);
																																																																																						}
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							obj_t
																																																																																								BgL_cdrzd22555zd2_2630;
																																																																																							BgL_cdrzd22555zd2_2630
																																																																																								=
																																																																																								CDR
																																																																																								(
																																																																																								((obj_t) BgL_cdrzd22547zd2_2629));
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								obj_t
																																																																																									BgL_carzd22562zd2_2631;
																																																																																								BgL_carzd22562zd2_2631
																																																																																									=
																																																																																									CAR
																																																																																									(
																																																																																									((obj_t) BgL_cdrzd22555zd2_2630));
																																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd22562zd2_2631))
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										obj_t
																																																																																											BgL_carzd22571zd2_2633;
																																																																																										{	/* Ast/sexp.scm 118 */
																																																																																											obj_t
																																																																																												BgL_pairz00_10206;
																																																																																											BgL_pairz00_10206
																																																																																												=
																																																																																												CDR
																																																																																												(
																																																																																												((obj_t) BgL_cdrzd22555zd2_2630));
																																																																																											BgL_carzd22571zd2_2633
																																																																																												=
																																																																																												CAR
																																																																																												(BgL_pairz00_10206);
																																																																																										}
																																																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd22571zd2_2633))
																																																																																											{	/* Ast/sexp.scm 118 */
																																																																																												if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd22539zd2_2628))
																																																																																													{	/* Ast/sexp.scm 118 */
																																																																																														obj_t
																																																																																															BgL_arg2292z00_2636;
																																																																																														BgL_arg2292z00_2636
																																																																																															=
																																																																																															CAR
																																																																																															(
																																																																																															((obj_t) BgL_cdrzd22547zd2_2629));
																																																																																														{
																																																																																															BgL_nodez00_bglt
																																																																																																BgL_auxz00_15212;
																																																																																															{
																																																																																																obj_t
																																																																																																	BgL_argsz00_15216;
																																																																																																obj_t
																																																																																																	BgL_proc2z00_15215;
																																																																																																obj_t
																																																																																																	BgL_proc1z00_15214;
																																																																																																obj_t
																																																																																																	BgL_testz00_15213;
																																																																																																BgL_testz00_15213
																																																																																																	=
																																																																																																	BgL_arg2292z00_2636;
																																																																																																BgL_proc1z00_15214
																																																																																																	=
																																																																																																	BgL_carzd22562zd2_2631;
																																																																																																BgL_proc2z00_15215
																																																																																																	=
																																																																																																	BgL_carzd22571zd2_2633;
																																																																																																BgL_argsz00_15216
																																																																																																	=
																																																																																																	BgL_cdrzd22539zd2_2628;
																																																																																																BgL_argsz00_1749
																																																																																																	=
																																																																																																	BgL_argsz00_15216;
																																																																																																BgL_proc2z00_1748
																																																																																																	=
																																																																																																	BgL_proc2z00_15215;
																																																																																																BgL_proc1z00_1747
																																																																																																	=
																																																																																																	BgL_proc1z00_15214;
																																																																																																BgL_testz00_1746
																																																																																																	=
																																																																																																	BgL_testz00_15213;
																																																																																																goto
																																																																																																	BgL_tagzd2388zd2_1750;
																																																																																															}
																																																																																															BgL_auxz00_14205
																																																																																																=
																																																																																																(
																																																																																																(obj_t)
																																																																																																BgL_auxz00_15212);
																																																																																														}
																																																																																													}
																																																																																												else
																																																																																													{	/* Ast/sexp.scm 118 */
																																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																															{	/* Ast/sexp.scm 118 */
																																																																																																goto
																																																																																																	BgL_tagzd2403zd2_1774;
																																																																																															}
																																																																																														else
																																																																																															{
																																																																																																BgL_nodez00_bglt
																																																																																																	BgL_auxz00_15220;
																																																																																																goto
																																																																																																	BgL_tagzd2404zd2_1775;
																																																																																																BgL_auxz00_14205
																																																																																																	=
																																																																																																	(
																																																																																																	(obj_t)
																																																																																																	BgL_auxz00_15220);
																																																																																															}
																																																																																													}
																																																																																											}
																																																																																										else
																																																																																											{	/* Ast/sexp.scm 118 */
																																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																													{	/* Ast/sexp.scm 118 */
																																																																																														goto
																																																																																															BgL_tagzd2403zd2_1774;
																																																																																													}
																																																																																												else
																																																																																													{
																																																																																														BgL_nodez00_bglt
																																																																																															BgL_auxz00_15224;
																																																																																														goto
																																																																																															BgL_tagzd2404zd2_1775;
																																																																																														BgL_auxz00_14205
																																																																																															=
																																																																																															(
																																																																																															(obj_t)
																																																																																															BgL_auxz00_15224);
																																																																																													}
																																																																																											}
																																																																																									}
																																																																																								else
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																											{	/* Ast/sexp.scm 118 */
																																																																																												goto
																																																																																													BgL_tagzd2403zd2_1774;
																																																																																											}
																																																																																										else
																																																																																											{
																																																																																												BgL_nodez00_bglt
																																																																																													BgL_auxz00_15228;
																																																																																												goto
																																																																																													BgL_tagzd2404zd2_1775;
																																																																																												BgL_auxz00_14205
																																																																																													=
																																																																																													(
																																																																																													(obj_t)
																																																																																													BgL_auxz00_15228);
																																																																																											}
																																																																																									}
																																																																																							}
																																																																																						}
																																																																																					}
																																																																																				}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1774;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_15232;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1775;
																																																																																					BgL_auxz00_14205
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_15232);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_cdrzd22849zd2_2655;
																																																																																	BgL_cdrzd22849zd2_2655
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_expz00_21));
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		obj_t
																																																																																			BgL_cdrzd22856zd2_2656;
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			obj_t
																																																																																				BgL_pairz00_10210;
																																																																																			BgL_pairz00_10210
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_expz00_21));
																																																																																			BgL_cdrzd22856zd2_2656
																																																																																				=
																																																																																				CDR
																																																																																				(BgL_pairz00_10210);
																																																																																		}
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			obj_t
																																																																																				BgL_cdrzd22863zd2_2657;
																																																																																			BgL_cdrzd22863zd2_2657
																																																																																				=
																																																																																				CDR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd22856zd2_2656));
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				obj_t
																																																																																					BgL_carzd22869zd2_2658;
																																																																																				obj_t
																																																																																					BgL_cdrzd22870zd2_2659;
																																																																																				BgL_carzd22869zd2_2658
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd22863zd2_2657));
																																																																																				BgL_cdrzd22870zd2_2659
																																																																																					=
																																																																																					CDR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd22863zd2_2657));
																																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd22869zd2_2658))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						obj_t
																																																																																							BgL_carzd22877zd2_2661;
																																																																																						BgL_carzd22877zd2_2661
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_cdrzd22870zd2_2659));
																																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd22877zd2_2661))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								if (NULLP(CDR(((obj_t) BgL_cdrzd22870zd2_2659))))
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd22849zd2_2655))
																																																																																											{	/* Ast/sexp.scm 118 */
																																																																																												obj_t
																																																																																													BgL_arg2308z00_2666;
																																																																																												BgL_arg2308z00_2666
																																																																																													=
																																																																																													CAR
																																																																																													(
																																																																																													((obj_t) BgL_cdrzd22856zd2_2656));
																																																																																												{
																																																																																													BgL_nodez00_bglt
																																																																																														BgL_auxz00_15259;
																																																																																													{
																																																																																														obj_t
																																																																																															BgL_argsz00_15263;
																																																																																														obj_t
																																																																																															BgL_proc2z00_15262;
																																																																																														obj_t
																																																																																															BgL_proc1z00_15261;
																																																																																														obj_t
																																																																																															BgL_testz00_15260;
																																																																																														BgL_testz00_15260
																																																																																															=
																																																																																															BgL_arg2308z00_2666;
																																																																																														BgL_proc1z00_15261
																																																																																															=
																																																																																															BgL_carzd22869zd2_2658;
																																																																																														BgL_proc2z00_15262
																																																																																															=
																																																																																															BgL_carzd22877zd2_2661;
																																																																																														BgL_argsz00_15263
																																																																																															=
																																																																																															BgL_cdrzd22849zd2_2655;
																																																																																														BgL_argsz00_1749
																																																																																															=
																																																																																															BgL_argsz00_15263;
																																																																																														BgL_proc2z00_1748
																																																																																															=
																																																																																															BgL_proc2z00_15262;
																																																																																														BgL_proc1z00_1747
																																																																																															=
																																																																																															BgL_proc1z00_15261;
																																																																																														BgL_testz00_1746
																																																																																															=
																																																																																															BgL_testz00_15260;
																																																																																														goto
																																																																																															BgL_tagzd2388zd2_1750;
																																																																																													}
																																																																																													BgL_auxz00_14205
																																																																																														=
																																																																																														(
																																																																																														(obj_t)
																																																																																														BgL_auxz00_15259);
																																																																																												}
																																																																																											}
																																																																																										else
																																																																																											{	/* Ast/sexp.scm 118 */
																																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																													{	/* Ast/sexp.scm 118 */
																																																																																														goto
																																																																																															BgL_tagzd2403zd2_1774;
																																																																																													}
																																																																																												else
																																																																																													{
																																																																																														BgL_nodez00_bglt
																																																																																															BgL_auxz00_15267;
																																																																																														goto
																																																																																															BgL_tagzd2404zd2_1775;
																																																																																														BgL_auxz00_14205
																																																																																															=
																																																																																															(
																																																																																															(obj_t)
																																																																																															BgL_auxz00_15267);
																																																																																													}
																																																																																											}
																																																																																									}
																																																																																								else
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																											{	/* Ast/sexp.scm 118 */
																																																																																												goto
																																																																																													BgL_tagzd2403zd2_1774;
																																																																																											}
																																																																																										else
																																																																																											{
																																																																																												BgL_nodez00_bglt
																																																																																													BgL_auxz00_15271;
																																																																																												goto
																																																																																													BgL_tagzd2404zd2_1775;
																																																																																												BgL_auxz00_14205
																																																																																													=
																																																																																													(
																																																																																													(obj_t)
																																																																																													BgL_auxz00_15271);
																																																																																											}
																																																																																									}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1774;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_15275;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1775;
																																																																																										BgL_auxz00_14205
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_15275);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1774;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_15279;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1775;
																																																																																								BgL_auxz00_14205
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_15279);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		}
																																																																																	}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1774;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_15283;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1775;
																																																																																	BgL_auxz00_14205
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_15283);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_cdrzd23210zd2_2674;
																																																																													BgL_cdrzd23210zd2_2674
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_cdrzd23216zd2_2675;
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_pairz00_10220;
																																																																															BgL_pairz00_10220
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															BgL_cdrzd23216zd2_2675
																																																																																=
																																																																																CDR
																																																																																(BgL_pairz00_10220);
																																																																														}
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_cdrzd23222zd2_2676;
																																																																															BgL_cdrzd23222zd2_2676
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_cdrzd23216zd2_2675));
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_carzd23227zd2_2677;
																																																																																obj_t
																																																																																	BgL_cdrzd23228zd2_2678;
																																																																																BgL_carzd23227zd2_2677
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd23222zd2_2676));
																																																																																BgL_cdrzd23228zd2_2678
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd23222zd2_2676));
																																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd23227zd2_2677))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (PAIRP(BgL_cdrzd23228zd2_2678))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				obj_t
																																																																																					BgL_carzd23233zd2_2681;
																																																																																				BgL_carzd23233zd2_2681
																																																																																					=
																																																																																					CAR
																																																																																					(BgL_cdrzd23228zd2_2678);
																																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd23233zd2_2681))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (NULLP(CDR(BgL_cdrzd23228zd2_2678)))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd23210zd2_2674))
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										obj_t
																																																																																											BgL_arg2322z00_2686;
																																																																																										BgL_arg2322z00_2686
																																																																																											=
																																																																																											CAR
																																																																																											(
																																																																																											((obj_t) BgL_cdrzd23216zd2_2675));
																																																																																										{
																																																																																											BgL_nodez00_bglt
																																																																																												BgL_auxz00_15310;
																																																																																											{
																																																																																												obj_t
																																																																																													BgL_argsz00_15314;
																																																																																												obj_t
																																																																																													BgL_proc2z00_15313;
																																																																																												obj_t
																																																																																													BgL_proc1z00_15312;
																																																																																												obj_t
																																																																																													BgL_testz00_15311;
																																																																																												BgL_testz00_15311
																																																																																													=
																																																																																													BgL_arg2322z00_2686;
																																																																																												BgL_proc1z00_15312
																																																																																													=
																																																																																													BgL_carzd23227zd2_2677;
																																																																																												BgL_proc2z00_15313
																																																																																													=
																																																																																													BgL_carzd23233zd2_2681;
																																																																																												BgL_argsz00_15314
																																																																																													=
																																																																																													BgL_cdrzd23210zd2_2674;
																																																																																												BgL_argsz00_1749
																																																																																													=
																																																																																													BgL_argsz00_15314;
																																																																																												BgL_proc2z00_1748
																																																																																													=
																																																																																													BgL_proc2z00_15313;
																																																																																												BgL_proc1z00_1747
																																																																																													=
																																																																																													BgL_proc1z00_15312;
																																																																																												BgL_testz00_1746
																																																																																													=
																																																																																													BgL_testz00_15311;
																																																																																												goto
																																																																																													BgL_tagzd2388zd2_1750;
																																																																																											}
																																																																																											BgL_auxz00_14205
																																																																																												=
																																																																																												(
																																																																																												(obj_t)
																																																																																												BgL_auxz00_15310);
																																																																																										}
																																																																																									}
																																																																																								else
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																											{	/* Ast/sexp.scm 118 */
																																																																																												goto
																																																																																													BgL_tagzd2403zd2_1774;
																																																																																											}
																																																																																										else
																																																																																											{
																																																																																												BgL_nodez00_bglt
																																																																																													BgL_auxz00_15318;
																																																																																												goto
																																																																																													BgL_tagzd2404zd2_1775;
																																																																																												BgL_auxz00_14205
																																																																																													=
																																																																																													(
																																																																																													(obj_t)
																																																																																													BgL_auxz00_15318);
																																																																																											}
																																																																																									}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1774;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_15322;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1775;
																																																																																										BgL_auxz00_14205
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_15322);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1774;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_15326;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1775;
																																																																																								BgL_auxz00_14205
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_15326);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1774;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_15330;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1775;
																																																																																						BgL_auxz00_14205
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_15330);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1774;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_15334;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1775;
																																																																																				BgL_auxz00_14205
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_15334);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														}
																																																																													}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1774;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_15338;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1775;
																																																																													BgL_auxz00_14205
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_15338);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1774;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_15342;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1775;
																																																																											BgL_auxz00_14205
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_15342);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1774;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_15346;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1775;
																																																																									BgL_auxz00_14205
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_15346);
																																																																								}
																																																																						}
																																																																				}
																																																																			}
																																																																	}
																																																																}
																																																														}
																																																												}
																																																											}
																																																									}
																																																							}
																																																					}
																																																			}
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_cdrzd23771zd2_2850;
																																																	BgL_cdrzd23771zd2_2850
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	if ((BgL_carzd2706zd2_2573 == CNST_TABLE_REF(((long) 17))))
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_arg2451z00_2852;
																																																			obj_t
																																																				BgL_arg2452z00_2853;
																																																			BgL_arg2451z00_2852
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd23771zd2_2850));
																																																			BgL_arg2452z00_2853
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd23771zd2_2850));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_15357;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_15359;
																																																					obj_t
																																																						BgL_bindingsz00_15358;
																																																					BgL_bindingsz00_15358
																																																						=
																																																						BgL_arg2451z00_2852;
																																																					BgL_exprz00_15359
																																																						=
																																																						BgL_arg2452z00_2853;
																																																					BgL_exprz00_1729
																																																						=
																																																						BgL_exprz00_15359;
																																																					BgL_bindingsz00_1728
																																																						=
																																																						BgL_bindingsz00_15358;
																																																					goto
																																																						BgL_tagzd2382zd2_1730;
																																																				}
																																																				BgL_auxz00_14205
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_15357);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd2706zd2_2573)))
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_arg2454z00_2855;
																																																					obj_t
																																																						BgL_arg2455z00_2856;
																																																					BgL_arg2454z00_2855
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd23771zd2_2850));
																																																					BgL_arg2455z00_2856
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd23771zd2_2850));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_15368;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_15370;
																																																							obj_t
																																																								BgL_bindingsz00_15369;
																																																							BgL_bindingsz00_15369
																																																								=
																																																								BgL_arg2454z00_2855;
																																																							BgL_exprz00_15370
																																																								=
																																																								BgL_arg2455z00_2856;
																																																							BgL_exprz00_1729
																																																								=
																																																								BgL_exprz00_15370;
																																																							BgL_bindingsz00_1728
																																																								=
																																																								BgL_bindingsz00_15369;
																																																							goto
																																																								BgL_tagzd2382zd2_1730;
																																																						}
																																																						BgL_auxz00_14205
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_15368);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					if ((BgL_carzd2706zd2_2573 == CNST_TABLE_REF(((long) 18))))
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_arg2457z00_2858;
																																																							obj_t
																																																								BgL_arg2458z00_2859;
																																																							BgL_arg2457z00_2858
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd23771zd2_2850));
																																																							BgL_arg2458z00_2859
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd23771zd2_2850));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_15379;
																																																								{
																																																									obj_t
																																																										BgL_exprz00_15381;
																																																									obj_t
																																																										BgL_bindingsz00_15380;
																																																									BgL_bindingsz00_15380
																																																										=
																																																										BgL_arg2457z00_2858;
																																																									BgL_exprz00_15381
																																																										=
																																																										BgL_arg2458z00_2859;
																																																									BgL_exprz00_1729
																																																										=
																																																										BgL_exprz00_15381;
																																																									BgL_bindingsz00_1728
																																																										=
																																																										BgL_bindingsz00_15380;
																																																									goto
																																																										BgL_tagzd2382zd2_1730;
																																																								}
																																																								BgL_auxz00_14205
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_15379);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_15388;
																																																								BgL_tagzd2383zd2_1731:
																																																									BgL_auxz00_15388 = BGl_letrecza2zd2ze3nodez93zzast_letz00(BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, CNST_TABLE_REF(((long) 2)));
																																																									BgL_auxz00_14205
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_15388);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_carzd23808zd2_2862;
																																																									BgL_carzd23808zd2_2862
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									if ((BgL_carzd23808zd2_2862 == CNST_TABLE_REF(((long) 19))))
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_15397;
																																																											goto
																																																												BgL_tagzd2384zd2_1732;
																																																											BgL_auxz00_14205
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_15397);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd23808zd2_2862)))
																																																												{
																																																													BgL_letzd2funzd2_bglt
																																																														BgL_auxz00_15402;
																																																													goto
																																																														BgL_tagzd2384zd2_1732;
																																																													BgL_auxz00_14205
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_15402);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_15409;
																																																														BgL_tagzd2389zd2_1751:
																																																															BgL_auxz00_15409 = BGl_lambdazd2ze3nodez31zzast_sexpz00(BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24, BGl_string7992z00zzast_sexpz00);
																																																															BgL_auxz00_14205
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_15409);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_15417;
																																																																BgL_tagzd2390zd2_1752:
																																																																	BgL_auxz00_15417 = BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00(((bool_t) 0), BFALSE, ((BgL_typez00_bglt) BGl_za2unspecza2z00zztype_cachez00), BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																	BgL_auxz00_14205
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_15417);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd23888zd2_2869;
																																																																	BgL_cdrzd23888zd2_2869
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_expz00_21));
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_arg2469z00_2872;
																																																																			obj_t
																																																																				BgL_arg2470z00_2873;
																																																																			BgL_arg2469z00_2872
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd23888zd2_2869));
																																																																			BgL_arg2470z00_2873
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd23888zd2_2869));
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_15432;
																																																																				BgL_effectz00_1753
																																																																					=
																																																																					BgL_arg2469z00_2872;
																																																																				BgL_restz00_1754
																																																																					=
																																																																					BgL_arg2470z00_2873;
																																																																			BgL_tagzd2391zd2_1755:
																																																																				{	/* Ast/sexp.scm 454 */
																																																																					BgL_feffectz00_bglt
																																																																						BgL_arg6933z00_8876;
																																																																					obj_t
																																																																						BgL_arg6934z00_8877;
																																																																					BgL_arg6933z00_8876
																																																																						=
																																																																						BGl_parsezd2effectzd2zzeffect_feffectz00
																																																																						(BgL_effectz00_1753);
																																																																					{	/* Ast/sexp.scm 455 */
																																																																						obj_t
																																																																							BgL_arg6935z00_8878;
																																																																						BgL_arg6935z00_8878
																																																																							=
																																																																							BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																																																							(BgL_restz00_1754,
																																																																							BNIL);
																																																																						BgL_arg6934z00_8877
																																																																							=
																																																																							MAKE_YOUNG_PAIR
																																																																							(CNST_TABLE_REF
																																																																							(((long) 6)), BgL_arg6935z00_8878);
																																																																					}
																																																																					BgL_auxz00_15432
																																																																						=
																																																																						BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00
																																																																						(
																																																																						((bool_t) 0), ((obj_t) BgL_arg6933z00_8876), ((BgL_typez00_bglt) BGl_za2unspecza2z00zztype_cachez00), BgL_arg6934z00_8877, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																				}
																																																																				BgL_auxz00_14205
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_15432);
																																																																		}}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_15446;
																																																																				BgL_tagzd2392zd2_1756:
																																																																					BgL_auxz00_15446 = BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00(((bool_t) 1), BFALSE, ((BgL_typez00_bglt) BGl_za2unspecza2z00zztype_cachez00), BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																					BgL_auxz00_14205
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_15446);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_15455;
																																																																						BgL_tagzd2393zd2_1757:
																																																																							{	/* Ast/sexp.scm 461 */
																																																																								bool_t
																																																																									BgL_test8300z00_15456;
																																																																								if (NULLP(BgL_stackz00_22))
																																																																									{	/* Ast/sexp.scm 461 */
																																																																										BgL_test8300z00_15456
																																																																											=
																																																																											(BgL_sitez00_24
																																																																											==
																																																																											CNST_TABLE_REF
																																																																											(((long) 2)));
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 461 */
																																																																										BgL_test8300z00_15456
																																																																											=
																																																																											(
																																																																											(bool_t)
																																																																											0);
																																																																									}
																																																																								if (BgL_test8300z00_15456)
																																																																									{	/* Ast/sexp.scm 461 */
																																																																										{	/* Ast/sexp.scm 465 */
																																																																											BgL_nodez00_bglt
																																																																												BgL_arg6938z00_8881;
																																																																											BgL_arg6938z00_8881
																																																																												=
																																																																												BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00
																																																																												(
																																																																												((bool_t) 1), BFALSE, ((BgL_typez00_bglt) BGl_za2unspecza2z00zztype_cachez00), BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																											BGl_addzd2staticzd2pragmaz12z12zzast_pragmaz00
																																																																												(BgL_arg6938z00_8881);
																																																																										}
																																																																										BgL_auxz00_15455
																																																																											=
																																																																											BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																											(BUNSPEC,
																																																																											BgL_stackz00_22,
																																																																											BgL_locz00_23,
																																																																											BgL_sitez00_24);
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 462 */
																																																																										BgL_nodez00_bglt
																																																																											BgL_res7430z00_9979;
																																																																										{	/* Ast/sexp.scm 722 */
																																																																											obj_t
																																																																												BgL_arg7104z00_9975;
																																																																											BgL_nodez00_bglt
																																																																												BgL_arg7105z00_9976;
																																																																											BgL_arg7104z00_9975
																																																																												=
																																																																												BGl_shapez00zztools_shapez00
																																																																												(BGl_currentzd2functionzd2zztools_errorz00
																																																																												());
																																																																											BgL_arg7105z00_9976
																																																																												=
																																																																												BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																												(CNST_TABLE_REF
																																																																												(((long) 4)), BNIL, BgL_locz00_23, CNST_TABLE_REF(((long) 2)));
																																																																											{	/* Ast/sexp.scm 721 */
																																																																												obj_t
																																																																													BgL_list7106z00_9978;
																																																																												BgL_list7106z00_9978
																																																																													=
																																																																													MAKE_YOUNG_PAIR
																																																																													(
																																																																													((obj_t) BgL_arg7105z00_9976), BNIL);
																																																																												BgL_res7430z00_9979
																																																																													=
																																																																													(
																																																																													(BgL_nodez00_bglt)
																																																																													BGl_userzd2errorzf2locationz20zztools_errorz00
																																																																													(BgL_locz00_23,
																																																																														BgL_arg7104z00_9975,
																																																																														BGl_string7991z00zzast_sexpz00,
																																																																														BgL_expz00_21,
																																																																														BgL_list7106z00_9978));
																																																																										}}
																																																																										BgL_auxz00_15455
																																																																											=
																																																																											BgL_res7430z00_9979;
																																																																							}}
																																																																							BgL_auxz00_14205
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_15455);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_arg2478z00_2881;
																																																																									obj_t
																																																																										BgL_arg2479z00_2882;
																																																																									BgL_arg2478z00_2881
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd23888zd2_2869));
																																																																									BgL_arg2479z00_2882
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd23888zd2_2869));
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_15484;
																																																																										BgL_effectz00_1758
																																																																											=
																																																																											BgL_arg2478z00_2881;
																																																																										BgL_restz00_1759
																																																																											=
																																																																											BgL_arg2479z00_2882;
																																																																									BgL_tagzd2394zd2_1760:
																																																																										{	/* Ast/sexp.scm 470 */
																																																																											BgL_feffectz00_bglt
																																																																												BgL_arg6939z00_8883;
																																																																											obj_t
																																																																												BgL_arg6940z00_8884;
																																																																											BgL_arg6939z00_8883
																																																																												=
																																																																												BGl_parsezd2effectzd2zzeffect_feffectz00
																																																																												(BgL_effectz00_1758);
																																																																											{	/* Ast/sexp.scm 471 */
																																																																												obj_t
																																																																													BgL_arg6941z00_8885;
																																																																												BgL_arg6941z00_8885
																																																																													=
																																																																													BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																																																													(BgL_restz00_1759,
																																																																													BNIL);
																																																																												BgL_arg6940z00_8884
																																																																													=
																																																																													MAKE_YOUNG_PAIR
																																																																													(CNST_TABLE_REF
																																																																													(((long) 6)), BgL_arg6941z00_8885);
																																																																											}
																																																																											BgL_auxz00_15484
																																																																												=
																																																																												BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00
																																																																												(
																																																																												((bool_t) 1), ((obj_t) BgL_arg6939z00_8883), ((BgL_typez00_bglt) BGl_za2unspecza2z00zztype_cachez00), BgL_arg6940z00_8884, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																										}
																																																																										BgL_auxz00_14205
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_15484);
																																																																								}}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_15498;
																																																																										BgL_tagzd2395zd2_1761:
																																																																											{
																																																																												obj_t
																																																																													BgL_procz00_8886;
																																																																												obj_t
																																																																													BgL_msgz00_8887;
																																																																												obj_t
																																																																													BgL_objz00_8888;
																																																																												if (PAIRP(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_cdrzd262369zd2_8893;
																																																																														BgL_cdrzd262369zd2_8893
																																																																															=
																																																																															CDR
																																																																															(BgL_expz00_21);
																																																																														if (PAIRP(BgL_cdrzd262369zd2_8893))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_cdrzd262374zd2_8895;
																																																																																BgL_cdrzd262374zd2_8895
																																																																																	=
																																																																																	CDR
																																																																																	(BgL_cdrzd262369zd2_8893);
																																																																																if (PAIRP(BgL_cdrzd262374zd2_8895))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		obj_t
																																																																																			BgL_cdrzd262379zd2_8897;
																																																																																		BgL_cdrzd262379zd2_8897
																																																																																			=
																																																																																			CDR
																																																																																			(BgL_cdrzd262374zd2_8895);
																																																																																		if (PAIRP(BgL_cdrzd262379zd2_8897))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (NULLP(CDR(BgL_cdrzd262379zd2_8897)))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						obj_t
																																																																																							BgL_arg6948z00_8901;
																																																																																						obj_t
																																																																																							BgL_arg6949z00_8902;
																																																																																						obj_t
																																																																																							BgL_arg6950z00_8903;
																																																																																						BgL_arg6948z00_8901
																																																																																							=
																																																																																							CAR
																																																																																							(BgL_cdrzd262369zd2_8893);
																																																																																						BgL_arg6949z00_8902
																																																																																							=
																																																																																							CAR
																																																																																							(BgL_cdrzd262374zd2_8895);
																																																																																						BgL_arg6950z00_8903
																																																																																							=
																																																																																							CAR
																																																																																							(BgL_cdrzd262379zd2_8897);
																																																																																						{
																																																																																							BgL_failz00_bglt
																																																																																								BgL_auxz00_15516;
																																																																																							BgL_procz00_8886
																																																																																								=
																																																																																								BgL_arg6948z00_8901;
																																																																																							BgL_msgz00_8887
																																																																																								=
																																																																																								BgL_arg6949z00_8902;
																																																																																							BgL_objz00_8888
																																																																																								=
																																																																																								BgL_arg6950z00_8903;
																																																																																							{	/* Ast/sexp.scm 476 */
																																																																																								obj_t
																																																																																									BgL_locz00_8905;
																																																																																								BgL_locz00_8905
																																																																																									=
																																																																																									BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																									(BgL_expz00_21,
																																																																																									BgL_locz00_23);
																																																																																								{	/* Ast/sexp.scm 476 */
																																																																																									obj_t
																																																																																										BgL_cdlocz00_8906;
																																																																																									{	/* Ast/sexp.scm 477 */
																																																																																										obj_t
																																																																																											BgL_arg6955z00_8920;
																																																																																										BgL_arg6955z00_8920
																																																																																											=
																																																																																											CDR
																																																																																											(
																																																																																											((obj_t) BgL_expz00_21));
																																																																																										BgL_cdlocz00_8906
																																																																																											=
																																																																																											BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																											(BgL_arg6955z00_8920,
																																																																																											BgL_locz00_8905);
																																																																																									}
																																																																																									{	/* Ast/sexp.scm 477 */
																																																																																										obj_t
																																																																																											BgL_cddlocz00_8907;
																																																																																										{	/* Ast/sexp.scm 478 */
																																																																																											obj_t
																																																																																												BgL_arg6954z00_8919;
																																																																																											{	/* Ast/sexp.scm 478 */
																																																																																												obj_t
																																																																																													BgL_pairz00_9984;
																																																																																												BgL_pairz00_9984
																																																																																													=
																																																																																													CDR
																																																																																													(
																																																																																													((obj_t) BgL_expz00_21));
																																																																																												BgL_arg6954z00_8919
																																																																																													=
																																																																																													CDR
																																																																																													(BgL_pairz00_9984);
																																																																																											}
																																																																																											BgL_cddlocz00_8907
																																																																																												=
																																																																																												BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																												(BgL_arg6954z00_8919,
																																																																																												BgL_locz00_8905);
																																																																																										}
																																																																																										{	/* Ast/sexp.scm 478 */
																																																																																											obj_t
																																																																																												BgL_cdddlocz00_8908;
																																																																																											{	/* Ast/sexp.scm 479 */
																																																																																												obj_t
																																																																																													BgL_arg6953z00_8918;
																																																																																												{	/* Ast/sexp.scm 479 */
																																																																																													obj_t
																																																																																														BgL_pairz00_9990;
																																																																																													{	/* Ast/sexp.scm 479 */
																																																																																														obj_t
																																																																																															BgL_pairz00_9989;
																																																																																														BgL_pairz00_9989
																																																																																															=
																																																																																															CDR
																																																																																															(
																																																																																															((obj_t) BgL_expz00_21));
																																																																																														BgL_pairz00_9990
																																																																																															=
																																																																																															CDR
																																																																																															(BgL_pairz00_9989);
																																																																																													}
																																																																																													BgL_arg6953z00_8918
																																																																																														=
																																																																																														CDR
																																																																																														(BgL_pairz00_9990);
																																																																																												}
																																																																																												BgL_cdddlocz00_8908
																																																																																													=
																																																																																													BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																													(BgL_arg6953z00_8918,
																																																																																													BgL_locz00_8905);
																																																																																											}
																																																																																											{	/* Ast/sexp.scm 479 */
																																																																																												obj_t
																																																																																													BgL_loczd2proczd2_8909;
																																																																																												BgL_loczd2proczd2_8909
																																																																																													=
																																																																																													BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																													(BgL_procz00_8886,
																																																																																													BgL_cdlocz00_8906);
																																																																																												{	/* Ast/sexp.scm 480 */
																																																																																													obj_t
																																																																																														BgL_loczd2msgzd2_8910;
																																																																																													BgL_loczd2msgzd2_8910
																																																																																														=
																																																																																														BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																														(BgL_msgz00_8887,
																																																																																														BgL_cddlocz00_8907);
																																																																																													{	/* Ast/sexp.scm 481 */
																																																																																														obj_t
																																																																																															BgL_loczd2objzd2_8911;
																																																																																														BgL_loczd2objzd2_8911
																																																																																															=
																																																																																															BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																															(BgL_objz00_8888,
																																																																																															BgL_cdddlocz00_8908);
																																																																																														{	/* Ast/sexp.scm 482 */
																																																																																															BgL_nodez00_bglt
																																																																																																BgL_procz00_8912;
																																																																																															BgL_procz00_8912
																																																																																																=
																																																																																																BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																																																(BgL_procz00_8886,
																																																																																																BgL_stackz00_22,
																																																																																																BgL_loczd2proczd2_8909,
																																																																																																CNST_TABLE_REF
																																																																																																(((long) 2)));
																																																																																															{	/* Ast/sexp.scm 483 */
																																																																																																BgL_nodez00_bglt
																																																																																																	BgL_msgz00_8913;
																																																																																																BgL_msgz00_8913
																																																																																																	=
																																																																																																	BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																																																	(BgL_msgz00_8887,
																																																																																																	BgL_stackz00_22,
																																																																																																	BgL_loczd2msgzd2_8910,
																																																																																																	CNST_TABLE_REF
																																																																																																	(((long) 2)));
																																																																																																{	/* Ast/sexp.scm 484 */
																																																																																																	BgL_nodez00_bglt
																																																																																																		BgL_objz00_8914;
																																																																																																	BgL_objz00_8914
																																																																																																		=
																																																																																																		BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																																																		(BgL_objz00_8888,
																																																																																																		BgL_stackz00_22,
																																																																																																		BgL_loczd2objzd2_8911,
																																																																																																		CNST_TABLE_REF
																																																																																																		(((long) 2)));
																																																																																																	{	/* Ast/sexp.scm 485 */

																																																																																																		{	/* Ast/sexp.scm 486 */
																																																																																																			BgL_failz00_bglt
																																																																																																				BgL_new1140z00_8915;
																																																																																																			{	/* Ast/sexp.scm 487 */
																																																																																																				BgL_failz00_bglt
																																																																																																					BgL_new1139z00_8916;
																																																																																																				BgL_new1139z00_8916
																																																																																																					=
																																																																																																					(
																																																																																																					(BgL_failz00_bglt)
																																																																																																					BOBJECT
																																																																																																					(GC_MALLOC
																																																																																																						(sizeof
																																																																																																							(struct
																																																																																																								BgL_failz00_bgl))));
																																																																																																				{	/* Ast/sexp.scm 487 */
																																																																																																					long
																																																																																																						BgL_arg6952z00_8917;
																																																																																																					{	/* Ast/sexp.scm 487 */
																																																																																																						long
																																																																																																							BgL_res7431z00_9992;
																																																																																																						BgL_res7431z00_9992
																																																																																																							=
																																																																																																							BGL_CLASS_INDEX
																																																																																																							(BGl_failz00zzast_nodez00);
																																																																																																						BgL_arg6952z00_8917
																																																																																																							=
																																																																																																							BgL_res7431z00_9992;
																																																																																																					}
																																																																																																					BGL_OBJECT_CLASS_NUM_SET
																																																																																																						(
																																																																																																						((BgL_objectz00_bglt) BgL_new1139z00_8916), BgL_arg6952z00_8917);
																																																																																																				}
																																																																																																				{	/* Ast/sexp.scm 487 */
																																																																																																					BgL_objectz00_bglt
																																																																																																						BgL_tmpz00_15543;
																																																																																																					BgL_tmpz00_15543
																																																																																																						=
																																																																																																						(
																																																																																																						(BgL_objectz00_bglt)
																																																																																																						BgL_new1139z00_8916);
																																																																																																					BGL_OBJECT_WIDENING_SET
																																																																																																						(BgL_tmpz00_15543,
																																																																																																						BFALSE);
																																																																																																				}
																																																																																																				((BgL_objectz00_bglt) BgL_new1139z00_8916);
																																																																																																				BgL_new1140z00_8915
																																																																																																					=
																																																																																																					BgL_new1139z00_8916;
																																																																																																			}
																																																																																																			((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1140z00_8915)))->BgL_locz00) = ((obj_t) BgL_locz00_8905), BUNSPEC);
																																																																																																			((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1140z00_8915)))->BgL_typez00) = ((BgL_typez00_bglt) ((BgL_typez00_bglt) BGl_za2magicza2z00zztype_cachez00)), BUNSPEC);
																																																																																																			((((BgL_failz00_bglt) COBJECT(BgL_new1140z00_8915))->BgL_procz00) = ((BgL_nodez00_bglt) BgL_procz00_8912), BUNSPEC);
																																																																																																			((((BgL_failz00_bglt) COBJECT(BgL_new1140z00_8915))->BgL_msgz00) = ((BgL_nodez00_bglt) BgL_msgz00_8913), BUNSPEC);
																																																																																																			((((BgL_failz00_bglt) COBJECT(BgL_new1140z00_8915))->BgL_objz00) = ((BgL_nodez00_bglt) BgL_objz00_8914), BUNSPEC);
																																																																																																			BgL_auxz00_15516
																																																																																																				=
																																																																																																				BgL_new1140z00_8915;
																																																																																							}}}}}}}}}}}}
																																																																																							BgL_auxz00_15498
																																																																																								=
																																																																																								(
																																																																																								(BgL_nodez00_bglt)
																																																																																								BgL_auxz00_15516);
																																																																																					}}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																					BgL_tagzd262360zd2_8890:
																																																																																						{	/* Ast/sexp.scm 494 */
																																																																																							obj_t
																																																																																								BgL_arg6956z00_8921;
																																																																																							BgL_arg6956z00_8921
																																																																																								=
																																																																																								BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																								(BgL_expz00_21,
																																																																																								BgL_locz00_23);
																																																																																							{	/* Ast/sexp.scm 493 */
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_res7432z00_10001;
																																																																																								{	/* Ast/sexp.scm 722 */
																																																																																									obj_t
																																																																																										BgL_arg7104z00_9997;
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_arg7105z00_9998;
																																																																																									BgL_arg7104z00_9997
																																																																																										=
																																																																																										BGl_shapez00zztools_shapez00
																																																																																										(BGl_currentzd2functionzd2zztools_errorz00
																																																																																										());
																																																																																									BgL_arg7105z00_9998
																																																																																										=
																																																																																										BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																																										(CNST_TABLE_REF
																																																																																										(((long) 4)), BNIL, BgL_arg6956z00_8921, CNST_TABLE_REF(((long) 2)));
																																																																																									{	/* Ast/sexp.scm 721 */
																																																																																										obj_t
																																																																																											BgL_list7106z00_10000;
																																																																																										BgL_list7106z00_10000
																																																																																											=
																																																																																											MAKE_YOUNG_PAIR
																																																																																											(
																																																																																											((obj_t) BgL_arg7105z00_9998), BNIL);
																																																																																										BgL_res7432z00_10001
																																																																																											=
																																																																																											(
																																																																																											(BgL_nodez00_bglt)
																																																																																											BGl_userzd2errorzf2locationz20zztools_errorz00
																																																																																											(BgL_arg6956z00_8921,
																																																																																												BgL_arg7104z00_9997,
																																																																																												BGl_string7990z00zzast_sexpz00,
																																																																																												BgL_expz00_21,
																																																																																												BgL_list7106z00_10000));
																																																																																								}}
																																																																																								BgL_auxz00_15498
																																																																																									=
																																																																																									BgL_res7432z00_10001;
																																																																																			}}}}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				goto
																																																																																					BgL_tagzd262360zd2_8890;
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		goto
																																																																																			BgL_tagzd262360zd2_8890;
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																goto
																																																																																	BgL_tagzd262360zd2_8890;
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														goto
																																																																															BgL_tagzd262360zd2_8890;
																																																																													}
																																																																											}
																																																																											BgL_auxz00_14205
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_15498);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_15572;
																																																																												BgL_tagzd2396zd2_1762:
																																																																													{
																																																																														obj_t
																																																																															BgL_testz00_8922;
																																																																														obj_t
																																																																															BgL_clausesz00_8923;
																																																																														if (PAIRP(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_cdrzd262393zd2_8928;
																																																																																BgL_cdrzd262393zd2_8928
																																																																																	=
																																																																																	CDR
																																																																																	(BgL_expz00_21);
																																																																																if (PAIRP(BgL_cdrzd262393zd2_8928))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		BgL_testz00_8922
																																																																																			=
																																																																																			CAR
																																																																																			(BgL_cdrzd262393zd2_8928);
																																																																																		BgL_clausesz00_8923
																																																																																			=
																																																																																			CDR
																																																																																			(BgL_cdrzd262393zd2_8928);
																																																																																		{	/* Ast/sexp.scm 505 */
																																																																																			obj_t
																																																																																				BgL_locz00_8932;
																																																																																			BgL_locz00_8932
																																																																																				=
																																																																																				BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																				(BgL_expz00_21,
																																																																																				BgL_locz00_23);
																																																																																			{	/* Ast/sexp.scm 505 */
																																																																																				obj_t
																																																																																					BgL_cdlocz00_8933;
																																																																																				{	/* Ast/sexp.scm 506 */
																																																																																					obj_t
																																																																																						BgL_arg6986z00_8973;
																																																																																					BgL_arg6986z00_8973
																																																																																						=
																																																																																						CDR
																																																																																						(
																																																																																						((obj_t) BgL_expz00_21));
																																																																																					BgL_cdlocz00_8933
																																																																																						=
																																																																																						BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																						(BgL_arg6986z00_8973,
																																																																																						BgL_locz00_8932);
																																																																																				}
																																																																																				{	/* Ast/sexp.scm 506 */
																																																																																					obj_t
																																																																																						BgL_cddlocz00_8934;
																																																																																					{	/* Ast/sexp.scm 507 */
																																																																																						obj_t
																																																																																							BgL_arg6985z00_8972;
																																																																																						BgL_arg6985z00_8972
																																																																																							=
																																																																																							CDR
																																																																																							(
																																																																																							((obj_t) BgL_expz00_21));
																																																																																						BgL_cddlocz00_8934
																																																																																							=
																																																																																							BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																							(BgL_arg6985z00_8972,
																																																																																							BgL_locz00_8932);
																																																																																					}
																																																																																					{	/* Ast/sexp.scm 507 */
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_testz00_8935;
																																																																																						{	/* Ast/sexp.scm 510 */
																																																																																							obj_t
																																																																																								BgL_arg6984z00_8971;
																																																																																							BgL_arg6984z00_8971
																																																																																								=
																																																																																								BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																								(BgL_testz00_8922,
																																																																																								BgL_cdlocz00_8933);
																																																																																							BgL_testz00_8935
																																																																																								=
																																																																																								BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																																								(BgL_testz00_8922,
																																																																																								BgL_stackz00_22,
																																																																																								BgL_arg6984z00_8971,
																																																																																								CNST_TABLE_REF
																																																																																								(((long) 2)));
																																																																																						}
																																																																																						{	/* Ast/sexp.scm 508 */

																																																																																							{
																																																																																								obj_t
																																																																																									BgL_clsz00_8938;
																																																																																								obj_t
																																																																																									BgL_nclausesz00_8939;
																																																																																								BgL_clsz00_8938
																																																																																									=
																																																																																									BgL_clausesz00_8923;
																																																																																								BgL_nclausesz00_8939
																																																																																									=
																																																																																									BNIL;
																																																																																							BgL_zc3z04anonymousza36961ze3z87_8940:
																																																																																								if (NULLP(BgL_clsz00_8938))
																																																																																									{	/* Ast/sexp.scm 515 */
																																																																																										BgL_switchz00_bglt
																																																																																											BgL_new1143z00_8942;
																																																																																										{	/* Ast/sexp.scm 516 */
																																																																																											BgL_switchz00_bglt
																																																																																												BgL_new1142z00_8946;
																																																																																											BgL_new1142z00_8946
																																																																																												=
																																																																																												(
																																																																																												(BgL_switchz00_bglt)
																																																																																												BOBJECT
																																																																																												(GC_MALLOC
																																																																																													(sizeof
																																																																																														(struct
																																																																																															BgL_switchz00_bgl))));
																																																																																											{	/* Ast/sexp.scm 516 */
																																																																																												long
																																																																																													BgL_arg6966z00_8947;
																																																																																												{	/* Ast/sexp.scm 516 */
																																																																																													long
																																																																																														BgL_res7439z00_10018;
																																																																																													BgL_res7439z00_10018
																																																																																														=
																																																																																														BGL_CLASS_INDEX
																																																																																														(BGl_switchz00zzast_nodez00);
																																																																																													BgL_arg6966z00_8947
																																																																																														=
																																																																																														BgL_res7439z00_10018;
																																																																																												}
																																																																																												BGL_OBJECT_CLASS_NUM_SET
																																																																																													(
																																																																																													((BgL_objectz00_bglt) BgL_new1142z00_8946), BgL_arg6966z00_8947);
																																																																																											}
																																																																																											{	/* Ast/sexp.scm 516 */
																																																																																												BgL_objectz00_bglt
																																																																																													BgL_tmpz00_15594;
																																																																																												BgL_tmpz00_15594
																																																																																													=
																																																																																													(
																																																																																													(BgL_objectz00_bglt)
																																																																																													BgL_new1142z00_8946);
																																																																																												BGL_OBJECT_WIDENING_SET
																																																																																													(BgL_tmpz00_15594,
																																																																																													BFALSE);
																																																																																											}
																																																																																											((BgL_objectz00_bglt) BgL_new1142z00_8946);
																																																																																											BgL_new1143z00_8942
																																																																																												=
																																																																																												BgL_new1142z00_8946;
																																																																																										}
																																																																																										((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1143z00_8942)))->BgL_locz00) = ((obj_t) BgL_locz00_8932), BUNSPEC);
																																																																																										((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1143z00_8942)))->BgL_typez00) = ((BgL_typez00_bglt) ((BgL_typez00_bglt) BGl_za2_za2z00zztype_cachez00)), BUNSPEC);
																																																																																										((((BgL_nodezf2effectzf2_bglt) COBJECT(((BgL_nodezf2effectzf2_bglt) BgL_new1143z00_8942)))->BgL_sidezd2effectzd2) = ((obj_t) BUNSPEC), BUNSPEC);
																																																																																										((((BgL_nodezf2effectzf2_bglt) COBJECT(((BgL_nodezf2effectzf2_bglt) BgL_new1143z00_8942)))->BgL_keyz00) = ((obj_t) BINT(((long) -1))), BUNSPEC);
																																																																																										((((BgL_switchz00_bglt) COBJECT(BgL_new1143z00_8942))->BgL_testz00) = ((BgL_nodez00_bglt) BgL_testz00_8935), BUNSPEC);
																																																																																										((((BgL_switchz00_bglt) COBJECT(BgL_new1143z00_8942))->BgL_clausesz00) = ((obj_t) bgl_reverse_bang(BgL_nclausesz00_8939)), BUNSPEC);
																																																																																										{
																																																																																											BgL_typez00_bglt
																																																																																												BgL_auxz00_15611;
																																																																																											{	/* Ast/sexp.scm 519 */
																																																																																												obj_t
																																																																																													BgL_arg6963z00_8943;
																																																																																												{	/* Ast/sexp.scm 519 */
																																																																																													obj_t
																																																																																														BgL_pairz00_10024;
																																																																																													{	/* Ast/sexp.scm 519 */
																																																																																														obj_t
																																																																																															BgL_pairz00_10023;
																																																																																														BgL_pairz00_10023
																																																																																															=
																																																																																															CAR
																																																																																															(
																																																																																															((obj_t) BgL_clausesz00_8923));
																																																																																														BgL_pairz00_10024
																																																																																															=
																																																																																															CAR
																																																																																															(BgL_pairz00_10023);
																																																																																													}
																																																																																													BgL_arg6963z00_8943
																																																																																														=
																																																																																														CAR
																																																																																														(BgL_pairz00_10024);
																																																																																												}
																																																																																												BgL_auxz00_15611
																																																																																													=
																																																																																													BGl_getzd2typezd2atomz00zztype_typeofz00
																																																																																													(BgL_arg6963z00_8943);
																																																																																											}
																																																																																											((((BgL_switchz00_bglt) COBJECT(BgL_new1143z00_8942))->BgL_itemzd2typezd2) = ((BgL_typez00_bglt) BgL_auxz00_15611), BUNSPEC);
																																																																																										}
																																																																																										BgL_auxz00_15572
																																																																																											=
																																																																																											(
																																																																																											(BgL_nodez00_bglt)
																																																																																											BgL_new1143z00_8942);
																																																																																									}
																																																																																								else
																																																																																									{	/* Ast/sexp.scm 521 */
																																																																																										obj_t
																																																																																											BgL_clausez00_8948;
																																																																																										BgL_clausez00_8948
																																																																																											=
																																																																																											CAR
																																																																																											(
																																																																																											((obj_t) BgL_clsz00_8938));
																																																																																										{	/* Ast/sexp.scm 521 */
																																																																																											BgL_nodez00_bglt
																																																																																												BgL_bodyz00_8949;
																																																																																											{	/* Ast/sexp.scm 522 */
																																																																																												obj_t
																																																																																													BgL_arg6981z00_8967;
																																																																																												obj_t
																																																																																													BgL_arg6982z00_8968;
																																																																																												{	/* Ast/sexp.scm 522 */
																																																																																													obj_t
																																																																																														BgL_arg6983z00_8969;
																																																																																													BgL_arg6983z00_8969
																																																																																														=
																																																																																														CDR
																																																																																														(
																																																																																														((obj_t) BgL_clausez00_8948));
																																																																																													BgL_arg6981z00_8967
																																																																																														=
																																																																																														BGl_normaliza7ezd2prognz75zztools_prognz00
																																																																																														(BgL_arg6983z00_8969);
																																																																																												}
																																																																																												BgL_arg6982z00_8968
																																																																																													=
																																																																																													BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																													(BgL_clausez00_8948,
																																																																																													BgL_cddlocz00_8934);
																																																																																												BgL_bodyz00_8949
																																																																																													=
																																																																																													BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																																													(BgL_arg6981z00_8967,
																																																																																													BgL_stackz00_22,
																																																																																													BgL_arg6982z00_8968,
																																																																																													CNST_TABLE_REF
																																																																																													(((long) 2)));
																																																																																											}
																																																																																											{	/* Ast/sexp.scm 522 */
																																																																																												obj_t
																																																																																													BgL_nclausez00_8950;
																																																																																												{	/* Ast/sexp.scm 526 */
																																																																																													obj_t
																																																																																														BgL_arg6980z00_8966;
																																																																																													BgL_arg6980z00_8966
																																																																																														=
																																																																																														CAR
																																																																																														(
																																																																																														((obj_t) BgL_clausez00_8948));
																																																																																													BgL_nclausez00_8950
																																																																																														=
																																																																																														MAKE_YOUNG_PAIR
																																																																																														(BgL_arg6980z00_8966,
																																																																																														((obj_t) BgL_bodyz00_8949));
																																																																																												}
																																																																																												{	/* Ast/sexp.scm 526 */

																																																																																													{	/* Ast/sexp.scm 528 */
																																																																																														bool_t
																																																																																															BgL_test8313z00_15631;
																																																																																														if ((CAR(((obj_t) BgL_clausez00_8948)) == CNST_TABLE_REF(((long) 5))))
																																																																																															{	/* Ast/sexp.scm 528 */
																																																																																																if (NULLP(CDR(((obj_t) BgL_clsz00_8938))))
																																																																																																	{	/* Ast/sexp.scm 529 */
																																																																																																		BgL_test8313z00_15631
																																																																																																			=
																																																																																																			(
																																																																																																			(bool_t)
																																																																																																			0);
																																																																																																	}
																																																																																																else
																																																																																																	{	/* Ast/sexp.scm 529 */
																																																																																																		BgL_test8313z00_15631
																																																																																																			=
																																																																																																			(
																																																																																																			(bool_t)
																																																																																																			1);
																																																																																																	}
																																																																																															}
																																																																																														else
																																																																																															{	/* Ast/sexp.scm 528 */
																																																																																																BgL_test8313z00_15631
																																																																																																	=
																																																																																																	(
																																																																																																	(bool_t)
																																																																																																	0);
																																																																																															}
																																																																																														if (BgL_test8313z00_15631)
																																																																																															{	/* Ast/sexp.scm 531 */
																																																																																																obj_t
																																																																																																	BgL_arg6974z00_8958;
																																																																																																BgL_arg6974z00_8958
																																																																																																	=
																																																																																																	BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																																	(BgL_expz00_21,
																																																																																																	BgL_locz00_8932);
																																																																																																{	/* Ast/sexp.scm 530 */
																																																																																																	BgL_nodez00_bglt
																																																																																																		BgL_res7441z00_10036;
																																																																																																	{	/* Ast/sexp.scm 722 */
																																																																																																		obj_t
																																																																																																			BgL_arg7104z00_10032;
																																																																																																		BgL_nodez00_bglt
																																																																																																			BgL_arg7105z00_10033;
																																																																																																		BgL_arg7104z00_10032
																																																																																																			=
																																																																																																			BGl_shapez00zztools_shapez00
																																																																																																			(BGl_currentzd2functionzd2zztools_errorz00
																																																																																																			());
																																																																																																		BgL_arg7105z00_10033
																																																																																																			=
																																																																																																			BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																																																			(CNST_TABLE_REF
																																																																																																			(((long) 4)), BNIL, BgL_arg6974z00_8958, CNST_TABLE_REF(((long) 2)));
																																																																																																		{	/* Ast/sexp.scm 721 */
																																																																																																			obj_t
																																																																																																				BgL_list7106z00_10035;
																																																																																																			BgL_list7106z00_10035
																																																																																																				=
																																																																																																				MAKE_YOUNG_PAIR
																																																																																																				(
																																																																																																				((obj_t) BgL_arg7105z00_10033), BNIL);
																																																																																																			BgL_res7441z00_10036
																																																																																																				=
																																																																																																				(
																																																																																																				(BgL_nodez00_bglt)
																																																																																																				BGl_userzd2errorzf2locationz20zztools_errorz00
																																																																																																				(BgL_arg6974z00_8958,
																																																																																																					BgL_arg7104z00_10032,
																																																																																																					BGl_string7989z00zzast_sexpz00,
																																																																																																					BgL_expz00_21,
																																																																																																					BgL_list7106z00_10035));
																																																																																																	}}
																																																																																																	BgL_auxz00_15572
																																																																																																		=
																																																																																																		BgL_res7441z00_10036;
																																																																																															}}
																																																																																														else
																																																																																															{	/* Ast/sexp.scm 532 */
																																																																																																obj_t
																																																																																																	BgL_arg6975z00_8959;
																																																																																																obj_t
																																																																																																	BgL_arg6976z00_8960;
																																																																																																BgL_arg6975z00_8959
																																																																																																	=
																																																																																																	CDR
																																																																																																	(
																																																																																																	((obj_t) BgL_clsz00_8938));
																																																																																																BgL_arg6976z00_8960
																																																																																																	=
																																																																																																	MAKE_YOUNG_PAIR
																																																																																																	(BGl_epairifyz00zztools_miscz00
																																																																																																	(BgL_nclausez00_8950,
																																																																																																		BgL_clausez00_8948),
																																																																																																	BgL_nclausesz00_8939);
																																																																																																{
																																																																																																	obj_t
																																																																																																		BgL_nclausesz00_15656;
																																																																																																	obj_t
																																																																																																		BgL_clsz00_15655;
																																																																																																	BgL_clsz00_15655
																																																																																																		=
																																																																																																		BgL_arg6975z00_8959;
																																																																																																	BgL_nclausesz00_15656
																																																																																																		=
																																																																																																		BgL_arg6976z00_8960;
																																																																																																	BgL_nclausesz00_8939
																																																																																																		=
																																																																																																		BgL_nclausesz00_15656;
																																																																																																	BgL_clsz00_8938
																																																																																																		=
																																																																																																		BgL_clsz00_15655;
																																																																																																	goto
																																																																																																		BgL_zc3z04anonymousza36961ze3z87_8940;
																																																																																																}
																																																																																															}
																																																																																													}
																																																																																												}
																																																																																											}
																																																																																										}
																																																																																									}
																																																																																							}
																																																																																						}
																																																																																					}
																																																																																				}
																																																																																			}
																																																																																		}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																	BgL_tagzd262386zd2_8925:
																																																																																		{	/* Ast/sexp.scm 537 */
																																																																																			obj_t
																																																																																				BgL_arg6987z00_8974;
																																																																																			BgL_arg6987z00_8974
																																																																																				=
																																																																																				BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																				(BgL_expz00_21,
																																																																																				BgL_locz00_23);
																																																																																			{	/* Ast/sexp.scm 536 */
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_res7442z00_10043;
																																																																																				{	/* Ast/sexp.scm 722 */
																																																																																					obj_t
																																																																																						BgL_arg7104z00_10039;
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_arg7105z00_10040;
																																																																																					BgL_arg7104z00_10039
																																																																																						=
																																																																																						BGl_shapez00zztools_shapez00
																																																																																						(BGl_currentzd2functionzd2zztools_errorz00
																																																																																						());
																																																																																					BgL_arg7105z00_10040
																																																																																						=
																																																																																						BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																																						(CNST_TABLE_REF
																																																																																						(((long) 4)), BNIL, BgL_arg6987z00_8974, CNST_TABLE_REF(((long) 2)));
																																																																																					{	/* Ast/sexp.scm 721 */
																																																																																						obj_t
																																																																																							BgL_list7106z00_10042;
																																																																																						BgL_list7106z00_10042
																																																																																							=
																																																																																							MAKE_YOUNG_PAIR
																																																																																							(
																																																																																							((obj_t) BgL_arg7105z00_10040), BNIL);
																																																																																						BgL_res7442z00_10043
																																																																																							=
																																																																																							(
																																																																																							(BgL_nodez00_bglt)
																																																																																							BGl_userzd2errorzf2locationz20zztools_errorz00
																																																																																							(BgL_arg6987z00_8974,
																																																																																								BgL_arg7104z00_10039,
																																																																																								BGl_string7989z00zzast_sexpz00,
																																																																																								BgL_expz00_21,
																																																																																								BgL_list7106z00_10042));
																																																																																				}}
																																																																																				BgL_auxz00_15572
																																																																																					=
																																																																																					BgL_res7442z00_10043;
																																																																															}}}}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																goto
																																																																																	BgL_tagzd262386zd2_8925;
																																																																															}
																																																																													}
																																																																													BgL_auxz00_14205
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_15572);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																														{
																																																																															BgL_letzd2funzd2_bglt
																																																																																BgL_auxz00_15675;
																																																																														BgL_tagzd2397zd2_1763:
																																																																															BgL_auxz00_15675 = BGl_setzd2exitzd2ze3nodeze3zzast_exitz00(BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																															BgL_auxz00_14205
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_15675);
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																																{
																																																																																	BgL_jumpzd2exzd2itz00_bglt
																																																																																		BgL_auxz00_15683;
																																																																																BgL_tagzd2398zd2_1764:
																																																																																	BgL_auxz00_15683 = BGl_jumpzd2exitzd2ze3nodeze3zzast_exitz00(BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																																	BgL_auxz00_14205
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_15683);
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_cdrzd23965zd2_2891;
																																																																																	BgL_cdrzd23965zd2_2891
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_expz00_21));
																																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			obj_t
																																																																																				BgL_arg2491z00_2894;
																																																																																			obj_t
																																																																																				BgL_arg2492z00_2895;
																																																																																			BgL_arg2491z00_2894
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd23965zd2_2891));
																																																																																			BgL_arg2492z00_2895
																																																																																				=
																																																																																				CDR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd23965zd2_2891));
																																																																																			{	/* Ast/sexp.scm 551 */
																																																																																				obj_t
																																																																																					BgL_arg6989z00_10259;
																																																																																				BgL_arg6989z00_10259
																																																																																					=
																																																																																					BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																					(BgL_expz00_21,
																																																																																					BgL_locz00_23);
																																																																																				BgL_auxz00_14205
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																					(BgL_expz00_21,
																																																																																						BgL_arg2491z00_2894,
																																																																																						CNST_TABLE_REF
																																																																																						(((long) 4)), BgL_arg2492z00_2895, BgL_stackz00_22, BgL_arg6989z00_10259, BgL_sitez00_24));
																																																																																		}}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1774;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_15703;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1775;
																																																																																					BgL_auxz00_14205
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_15703);
																																																																																				}
																																																																																		}
																																																																																}
																																																																														}
																																																																												}
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 118 */
																																					obj_t
																																						BgL_carzd23990zd2_2912;
																																					BgL_carzd23990zd2_2912
																																						=
																																						CAR(
																																						((obj_t) BgL_expz00_21));
																																					if (
																																						(BgL_carzd23990zd2_2912
																																							==
																																							CNST_TABLE_REF
																																							(((long) 1))))
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_15710;
																																							goto
																																								BgL_tagzd2377zd2_1719;
																																							BgL_auxz00_14205
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_15710);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 118 */
																																							if ((BgL_carzd23990zd2_2912 == BGl_za2ifza2z00zzast_sexpz00))
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_15714;
																																									goto
																																										BgL_tagzd2377zd2_1719;
																																									BgL_auxz00_14205
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_15714);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 118 */
																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 7))))
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_15721;
																																											goto
																																												BgL_tagzd2379zd2_1723;
																																											BgL_auxz00_14205
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_15721);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 118 */
																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_15728;
																																													goto
																																														BgL_tagzd2380zd2_1724;
																																													BgL_auxz00_14205
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_15728);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 118 */
																																													obj_t
																																														BgL_carzd24059zd2_2919;
																																													BgL_carzd24059zd2_2919
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													if (PAIRP(BgL_carzd24059zd2_2919))
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_carzd24062zd2_2921;
																																															obj_t
																																																BgL_cdrzd24063zd2_2922;
																																															BgL_carzd24062zd2_2921
																																																=
																																																CAR
																																																(BgL_carzd24059zd2_2919);
																																															BgL_cdrzd24063zd2_2922
																																																=
																																																CDR
																																																(BgL_carzd24059zd2_2919);
																																															{

																																																if ((BgL_carzd24062zd2_2921 == CNST_TABLE_REF(((long) 17))))
																																																	{	/* Ast/sexp.scm 118 */
																																																	BgL_kapzd24064zd2_2923:
																																																		if (PAIRP(BgL_cdrzd24063zd2_2922))
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_cdrzd24067zd2_3048;
																																																				BgL_cdrzd24067zd2_3048
																																																					=
																																																					CDR
																																																					(BgL_cdrzd24063zd2_2922);
																																																				if (PAIRP(BgL_cdrzd24067zd2_3048))
																																																					{	/* Ast/sexp.scm 118 */
																																																						if (NULLP(CDR(BgL_cdrzd24067zd2_3048)))
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_arg2619z00_3052;
																																																								obj_t
																																																									BgL_arg2620z00_3053;
																																																								BgL_arg2619z00_3052
																																																									=
																																																									CAR
																																																									(BgL_cdrzd24067zd2_3048);
																																																								BgL_arg2620z00_3053
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_15750;
																																																									{
																																																										obj_t
																																																											BgL_argsz00_15752;
																																																										obj_t
																																																											BgL_bodyz00_15751;
																																																										BgL_bodyz00_15751
																																																											=
																																																											BgL_arg2619z00_3052;
																																																										BgL_argsz00_15752
																																																											=
																																																											BgL_arg2620z00_3053;
																																																										BgL_argsz00_1726
																																																											=
																																																											BgL_argsz00_15752;
																																																										BgL_bodyz00_1725
																																																											=
																																																											BgL_bodyz00_15751;
																																																										goto
																																																											BgL_tagzd2381zd2_1727;
																																																									}
																																																									BgL_auxz00_14205
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_15750);
																																																								}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_cdrzd24091zd2_3054;
																																																								BgL_cdrzd24091zd2_3054
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{	/* Ast/sexp.scm 118 */
																																																									bool_t
																																																										BgL_test8329z00_15756;
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_arg2694z00_3165;
																																																										BgL_arg2694z00_3165
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_test8329z00_15756
																																																											=
																																																											CBOOL
																																																											(BGl_letzd2symzf3z21zzast_letz00
																																																											(BgL_arg2694z00_3165));
																																																									}
																																																									if (BgL_test8329z00_15756)
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_arg2624z00_3057;
																																																											obj_t
																																																												BgL_arg2625z00_3058;
																																																											BgL_arg2624z00_3057
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_cdrzd24091zd2_3054));
																																																											BgL_arg2625z00_3058
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd24091zd2_3054));
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_15765;
																																																												{
																																																													obj_t
																																																														BgL_exprz00_15767;
																																																													obj_t
																																																														BgL_bindingsz00_15766;
																																																													BgL_bindingsz00_15766
																																																														=
																																																														BgL_arg2624z00_3057;
																																																													BgL_exprz00_15767
																																																														=
																																																														BgL_arg2625z00_3058;
																																																													BgL_exprz00_1729
																																																														=
																																																														BgL_exprz00_15767;
																																																													BgL_bindingsz00_1728
																																																														=
																																																														BgL_bindingsz00_15766;
																																																													goto
																																																														BgL_tagzd2382zd2_1730;
																																																												}
																																																												BgL_auxz00_14205
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_15765);
																																																											}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											bool_t
																																																												BgL_test8330z00_15769;
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_arg2693z00_3164;
																																																												BgL_arg2693z00_3164
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												BgL_test8330z00_15769
																																																													=
																																																													CBOOL
																																																													(BGl_labelszd2symzf3z21zzast_labelsz00
																																																													(BgL_arg2693z00_3164));
																																																											}
																																																											if (BgL_test8330z00_15769)
																																																												{
																																																													BgL_letzd2funzd2_bglt
																																																														BgL_auxz00_15774;
																																																													goto
																																																														BgL_tagzd2384zd2_1732;
																																																													BgL_auxz00_14205
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_15774);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_carzd24158zd2_3061;
																																																													BgL_carzd24158zd2_3061
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_cdrzd24163zd2_3062;
																																																														BgL_cdrzd24163zd2_3062
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_carzd24158zd2_3061));
																																																														if ((CAR(((obj_t) BgL_carzd24158zd2_3061)) == CNST_TABLE_REF(((long) 3))))
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_arg2631z00_3065;
																																																																obj_t
																																																																	BgL_arg2632z00_3066;
																																																																obj_t
																																																																	BgL_arg2633z00_3067;
																																																																BgL_arg2631z00_3065
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd24163zd2_3062));
																																																																BgL_arg2632z00_3066
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd24163zd2_3062));
																																																																BgL_arg2633z00_3067
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_15791;
																																																																	{
																																																																		obj_t
																																																																			BgL_argsz00_15794;
																																																																		obj_t
																																																																			BgL_bodyz00_15793;
																																																																		obj_t
																																																																			BgL_varsz00_15792;
																																																																		BgL_varsz00_15792
																																																																			=
																																																																			BgL_arg2631z00_3065;
																																																																		BgL_bodyz00_15793
																																																																			=
																																																																			BgL_arg2632z00_3066;
																																																																		BgL_argsz00_15794
																																																																			=
																																																																			BgL_arg2633z00_3067;
																																																																		BgL_argsz00_1739
																																																																			=
																																																																			BgL_argsz00_15794;
																																																																		BgL_bodyz00_1738
																																																																			=
																																																																			BgL_bodyz00_15793;
																																																																		BgL_varsz00_1737
																																																																			=
																																																																			BgL_varsz00_15792;
																																																																		goto
																																																																			BgL_tagzd2386zd2_1740;
																																																																	}
																																																																	BgL_auxz00_14205
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_15791);
																																																																}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_cdrzd24186zd2_3069;
																																																																BgL_cdrzd24186zd2_3069
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd24192zd2_3070;
																																																																	BgL_cdrzd24192zd2_3070
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_carzd24158zd2_3061));
																																																																	if ((CAR(((obj_t) BgL_carzd24158zd2_3061)) == CNST_TABLE_REF(((long) 1))))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_cdrzd24198zd2_3073;
																																																																			BgL_cdrzd24198zd2_3073
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd24192zd2_3070));
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_carzd24203zd2_3074;
																																																																				obj_t
																																																																					BgL_cdrzd24204zd2_3075;
																																																																				BgL_carzd24203zd2_3074
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd24198zd2_3073));
																																																																				BgL_cdrzd24204zd2_3075
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd24198zd2_3073));
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd24203zd2_3074))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (PAIRP(BgL_cdrzd24204zd2_3075))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_carzd24211zd2_3078;
																																																																								BgL_carzd24211zd2_3078
																																																																									=
																																																																									CAR
																																																																									(BgL_cdrzd24204zd2_3075);
																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd24211zd2_3078))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (NULLP(CDR(BgL_cdrzd24204zd2_3075)))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												bool_t
																																																																													BgL_test8337z00_15821;
																																																																												{
																																																																													obj_t
																																																																														BgL_l1370z00_3111;
																																																																													BgL_l1370z00_3111
																																																																														=
																																																																														BgL_cdrzd24186zd2_3069;
																																																																												BgL_zc3z04anonymousza32659ze3z87_3112:
																																																																													if (NULLP(BgL_l1370z00_3111))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															BgL_test8337z00_15821
																																																																																=
																																																																																(
																																																																																(bool_t)
																																																																																1);
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															bool_t
																																																																																BgL_test8339z00_15824;
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																bool_t
																																																																																	BgL_test8340z00_15825;
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_tmpz00_15826;
																																																																																	BgL_tmpz00_15826
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_l1370z00_3111));
																																																																																	BgL_test8340z00_15825
																																																																																		=
																																																																																		PAIRP
																																																																																		(BgL_tmpz00_15826);
																																																																																}
																																																																																if (BgL_test8340z00_15825)
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		BgL_test8339z00_15824
																																																																																			=
																																																																																			(
																																																																																			(bool_t)
																																																																																			0);
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		BgL_test8339z00_15824
																																																																																			=
																																																																																			(
																																																																																			(bool_t)
																																																																																			1);
																																																																																	}
																																																																															}
																																																																															if (BgL_test8339z00_15824)
																																																																																{
																																																																																	obj_t
																																																																																		BgL_l1370z00_15830;
																																																																																	BgL_l1370z00_15830
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_l1370z00_3111));
																																																																																	BgL_l1370z00_3111
																																																																																		=
																																																																																		BgL_l1370z00_15830;
																																																																																	goto
																																																																																		BgL_zc3z04anonymousza32659ze3z87_3112;
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	BgL_test8337z00_15821
																																																																																		=
																																																																																		(
																																																																																		(bool_t)
																																																																																		0);
																																																																																}
																																																																														}
																																																																												}
																																																																												if (BgL_test8337z00_15821)
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_arg2649z00_3094;
																																																																														BgL_arg2649z00_3094
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd24192zd2_3070));
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_15835;
																																																																															{
																																																																																obj_t
																																																																																	BgL_argsz00_15839;
																																																																																obj_t
																																																																																	BgL_proc2z00_15838;
																																																																																obj_t
																																																																																	BgL_proc1z00_15837;
																																																																																obj_t
																																																																																	BgL_testz00_15836;
																																																																																BgL_testz00_15836
																																																																																	=
																																																																																	BgL_arg2649z00_3094;
																																																																																BgL_proc1z00_15837
																																																																																	=
																																																																																	BgL_carzd24203zd2_3074;
																																																																																BgL_proc2z00_15838
																																																																																	=
																																																																																	BgL_carzd24211zd2_3078;
																																																																																BgL_argsz00_15839
																																																																																	=
																																																																																	BgL_cdrzd24186zd2_3069;
																																																																																BgL_argsz00_1744
																																																																																	=
																																																																																	BgL_argsz00_15839;
																																																																																BgL_proc2z00_1743
																																																																																	=
																																																																																	BgL_proc2z00_15838;
																																																																																BgL_proc1z00_1742
																																																																																	=
																																																																																	BgL_proc1z00_15837;
																																																																																BgL_testz00_1741
																																																																																	=
																																																																																	BgL_testz00_15836;
																																																																																goto
																																																																																	BgL_tagzd2387zd2_1745;
																																																																															}
																																																																															BgL_auxz00_14205
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_15835);
																																																																														}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_cdrzd24235zd2_3095;
																																																																														BgL_cdrzd24235zd2_3095
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_expz00_21));
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_cdrzd24242zd2_3096;
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_pairz00_10303;
																																																																																BgL_pairz00_10303
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_expz00_21));
																																																																																BgL_cdrzd24242zd2_3096
																																																																																	=
																																																																																	CDR
																																																																																	(BgL_pairz00_10303);
																																																																															}
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_cdrzd24249zd2_3097;
																																																																																BgL_cdrzd24249zd2_3097
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd24242zd2_3096));
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_carzd24255zd2_3098;
																																																																																	BgL_carzd24255zd2_3098
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd24249zd2_3097));
																																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd24255zd2_3098))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			obj_t
																																																																																				BgL_carzd24262zd2_3100;
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				obj_t
																																																																																					BgL_pairz00_10307;
																																																																																				BgL_pairz00_10307
																																																																																					=
																																																																																					CDR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd24249zd2_3097));
																																																																																				BgL_carzd24262zd2_3100
																																																																																					=
																																																																																					CAR
																																																																																					(BgL_pairz00_10307);
																																																																																			}
																																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd24262zd2_3100))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd24235zd2_3095))
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							obj_t
																																																																																								BgL_arg2653z00_3103;
																																																																																							BgL_arg2653z00_3103
																																																																																								=
																																																																																								CAR
																																																																																								(
																																																																																								((obj_t) BgL_cdrzd24242zd2_3096));
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_15861;
																																																																																								{
																																																																																									obj_t
																																																																																										BgL_argsz00_15865;
																																																																																									obj_t
																																																																																										BgL_proc2z00_15864;
																																																																																									obj_t
																																																																																										BgL_proc1z00_15863;
																																																																																									obj_t
																																																																																										BgL_testz00_15862;
																																																																																									BgL_testz00_15862
																																																																																										=
																																																																																										BgL_arg2653z00_3103;
																																																																																									BgL_proc1z00_15863
																																																																																										=
																																																																																										BgL_carzd24255zd2_3098;
																																																																																									BgL_proc2z00_15864
																																																																																										=
																																																																																										BgL_carzd24262zd2_3100;
																																																																																									BgL_argsz00_15865
																																																																																										=
																																																																																										BgL_cdrzd24235zd2_3095;
																																																																																									BgL_argsz00_1749
																																																																																										=
																																																																																										BgL_argsz00_15865;
																																																																																									BgL_proc2z00_1748
																																																																																										=
																																																																																										BgL_proc2z00_15864;
																																																																																									BgL_proc1z00_1747
																																																																																										=
																																																																																										BgL_proc1z00_15863;
																																																																																									BgL_testz00_1746
																																																																																										=
																																																																																										BgL_testz00_15862;
																																																																																									goto
																																																																																										BgL_tagzd2388zd2_1750;
																																																																																								}
																																																																																								BgL_auxz00_14205
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_15861);
																																																																																							}
																																																																																						}
																																																																																					else
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																								{	/* Ast/sexp.scm 118 */
																																																																																									goto
																																																																																										BgL_tagzd2403zd2_1774;
																																																																																								}
																																																																																							else
																																																																																								{
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_auxz00_15869;
																																																																																									goto
																																																																																										BgL_tagzd2404zd2_1775;
																																																																																									BgL_auxz00_14205
																																																																																										=
																																																																																										(
																																																																																										(obj_t)
																																																																																										BgL_auxz00_15869);
																																																																																								}
																																																																																						}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							goto
																																																																																								BgL_tagzd2403zd2_1774;
																																																																																						}
																																																																																					else
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_15873;
																																																																																							goto
																																																																																								BgL_tagzd2404zd2_1775;
																																																																																							BgL_auxz00_14205
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_15873);
																																																																																						}
																																																																																				}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1774;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_15877;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1775;
																																																																																					BgL_auxz00_14205
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_15877);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															}
																																																																														}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1774;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_15881;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1775;
																																																																														BgL_auxz00_14205
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_15881);
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_cdrzd24538zd2_3122;
																																																																										BgL_cdrzd24538zd2_3122
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_cdrzd24544zd2_3123;
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_pairz00_10311;
																																																																												BgL_pairz00_10311
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_expz00_21));
																																																																												BgL_cdrzd24544zd2_3123
																																																																													=
																																																																													CDR
																																																																													(BgL_pairz00_10311);
																																																																											}
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_cdrzd24550zd2_3124;
																																																																												BgL_cdrzd24550zd2_3124
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd24544zd2_3123));
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_carzd24555zd2_3125;
																																																																													obj_t
																																																																														BgL_cdrzd24556zd2_3126;
																																																																													BgL_carzd24555zd2_3125
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd24550zd2_3124));
																																																																													BgL_cdrzd24556zd2_3126
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd24550zd2_3124));
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd24555zd2_3125))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_carzd24561zd2_3128;
																																																																															BgL_carzd24561zd2_3128
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd24556zd2_3126));
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd24561zd2_3128))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (NULLP(CDR(((obj_t) BgL_cdrzd24556zd2_3126))))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd24538zd2_3122))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					obj_t
																																																																																						BgL_arg2668z00_3133;
																																																																																					BgL_arg2668z00_3133
																																																																																						=
																																																																																						CAR
																																																																																						(
																																																																																						((obj_t) BgL_cdrzd24544zd2_3123));
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_15908;
																																																																																						{
																																																																																							obj_t
																																																																																								BgL_argsz00_15912;
																																																																																							obj_t
																																																																																								BgL_proc2z00_15911;
																																																																																							obj_t
																																																																																								BgL_proc1z00_15910;
																																																																																							obj_t
																																																																																								BgL_testz00_15909;
																																																																																							BgL_testz00_15909
																																																																																								=
																																																																																								BgL_arg2668z00_3133;
																																																																																							BgL_proc1z00_15910
																																																																																								=
																																																																																								BgL_carzd24555zd2_3125;
																																																																																							BgL_proc2z00_15911
																																																																																								=
																																																																																								BgL_carzd24561zd2_3128;
																																																																																							BgL_argsz00_15912
																																																																																								=
																																																																																								BgL_cdrzd24538zd2_3122;
																																																																																							BgL_argsz00_1749
																																																																																								=
																																																																																								BgL_argsz00_15912;
																																																																																							BgL_proc2z00_1748
																																																																																								=
																																																																																								BgL_proc2z00_15911;
																																																																																							BgL_proc1z00_1747
																																																																																								=
																																																																																								BgL_proc1z00_15910;
																																																																																							BgL_testz00_1746
																																																																																								=
																																																																																								BgL_testz00_15909;
																																																																																							goto
																																																																																								BgL_tagzd2388zd2_1750;
																																																																																						}
																																																																																						BgL_auxz00_14205
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_15908);
																																																																																					}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							goto
																																																																																								BgL_tagzd2403zd2_1774;
																																																																																						}
																																																																																					else
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_15916;
																																																																																							goto
																																																																																								BgL_tagzd2404zd2_1775;
																																																																																							BgL_auxz00_14205
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_15916);
																																																																																						}
																																																																																				}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1774;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_15920;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1775;
																																																																																					BgL_auxz00_14205
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_15920);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1774;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_15924;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1775;
																																																																																			BgL_auxz00_14205
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_15924);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1774;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_15928;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1775;
																																																																																	BgL_auxz00_14205
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_15928);
																																																																																}
																																																																														}
																																																																												}
																																																																											}
																																																																										}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1774;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_15932;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1775;
																																																																										BgL_auxz00_14205
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_15932);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_cdrzd24894zd2_3141;
																																																																						BgL_cdrzd24894zd2_3141
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_cdrzd24901zd2_3142;
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_pairz00_10321;
																																																																								BgL_pairz00_10321
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								BgL_cdrzd24901zd2_3142
																																																																									=
																																																																									CDR
																																																																									(BgL_pairz00_10321);
																																																																							}
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_cdrzd24908zd2_3143;
																																																																								BgL_cdrzd24908zd2_3143
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd24901zd2_3142));
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_carzd24914zd2_3144;
																																																																									obj_t
																																																																										BgL_cdrzd24915zd2_3145;
																																																																									BgL_carzd24914zd2_3144
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd24908zd2_3143));
																																																																									BgL_cdrzd24915zd2_3145
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd24908zd2_3143));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd24914zd2_3144))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (PAIRP(BgL_cdrzd24915zd2_3145))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_carzd24922zd2_3148;
																																																																													BgL_carzd24922zd2_3148
																																																																														=
																																																																														CAR
																																																																														(BgL_cdrzd24915zd2_3145);
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd24922zd2_3148))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (NULLP(CDR(BgL_cdrzd24915zd2_3145)))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd24894zd2_3141))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			obj_t
																																																																																				BgL_arg2682z00_3153;
																																																																																			BgL_arg2682z00_3153
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd24901zd2_3142));
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_15959;
																																																																																				{
																																																																																					obj_t
																																																																																						BgL_argsz00_15963;
																																																																																					obj_t
																																																																																						BgL_proc2z00_15962;
																																																																																					obj_t
																																																																																						BgL_proc1z00_15961;
																																																																																					obj_t
																																																																																						BgL_testz00_15960;
																																																																																					BgL_testz00_15960
																																																																																						=
																																																																																						BgL_arg2682z00_3153;
																																																																																					BgL_proc1z00_15961
																																																																																						=
																																																																																						BgL_carzd24914zd2_3144;
																																																																																					BgL_proc2z00_15962
																																																																																						=
																																																																																						BgL_carzd24922zd2_3148;
																																																																																					BgL_argsz00_15963
																																																																																						=
																																																																																						BgL_cdrzd24894zd2_3141;
																																																																																					BgL_argsz00_1749
																																																																																						=
																																																																																						BgL_argsz00_15963;
																																																																																					BgL_proc2z00_1748
																																																																																						=
																																																																																						BgL_proc2z00_15962;
																																																																																					BgL_proc1z00_1747
																																																																																						=
																																																																																						BgL_proc1z00_15961;
																																																																																					BgL_testz00_1746
																																																																																						=
																																																																																						BgL_testz00_15960;
																																																																																					goto
																																																																																						BgL_tagzd2388zd2_1750;
																																																																																				}
																																																																																				BgL_auxz00_14205
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_15959);
																																																																																			}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1774;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_15967;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1775;
																																																																																					BgL_auxz00_14205
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_15967);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1774;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_15971;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1775;
																																																																																			BgL_auxz00_14205
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_15971);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1774;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_15975;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1775;
																																																																																	BgL_auxz00_14205
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_15975);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1774;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_15979;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1775;
																																																																															BgL_auxz00_14205
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_15979);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1774;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_15983;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1775;
																																																																													BgL_auxz00_14205
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_15983);
																																																																												}
																																																																										}
																																																																								}
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1774;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_15987;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1775;
																																																																					BgL_auxz00_14205
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_15987);
																																																																				}
																																																																		}
																																																																}
																																																															}
																																																													}
																																																												}
																																																										}
																																																								}
																																																							}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_cdrzd25315zd2_3167;
																																																						BgL_cdrzd25315zd2_3167
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{	/* Ast/sexp.scm 118 */
																																																							bool_t
																																																								BgL_test8368z00_15991;
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_arg2714z00_3184;
																																																								BgL_arg2714z00_3184
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test8368z00_15991
																																																									=
																																																									CBOOL
																																																									(BGl_letzd2symzf3z21zzast_letz00
																																																									(BgL_arg2714z00_3184));
																																																							}
																																																							if (BgL_test8368z00_15991)
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_arg2698z00_3170;
																																																									obj_t
																																																										BgL_arg2699z00_3171;
																																																									BgL_arg2698z00_3170
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd25315zd2_3167));
																																																									BgL_arg2699z00_3171
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd25315zd2_3167));
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_16000;
																																																										{
																																																											obj_t
																																																												BgL_exprz00_16002;
																																																											obj_t
																																																												BgL_bindingsz00_16001;
																																																											BgL_bindingsz00_16001
																																																												=
																																																												BgL_arg2698z00_3170;
																																																											BgL_exprz00_16002
																																																												=
																																																												BgL_arg2699z00_3171;
																																																											BgL_exprz00_1729
																																																												=
																																																												BgL_exprz00_16002;
																																																											BgL_bindingsz00_1728
																																																												=
																																																												BgL_bindingsz00_16001;
																																																											goto
																																																												BgL_tagzd2382zd2_1730;
																																																										}
																																																										BgL_auxz00_14205
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_16000);
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									bool_t
																																																										BgL_test8369z00_16004;
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_arg2713z00_3183;
																																																										BgL_arg2713z00_3183
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_test8369z00_16004
																																																											=
																																																											CBOOL
																																																											(BGl_labelszd2symzf3z21zzast_labelsz00
																																																											(BgL_arg2713z00_3183));
																																																									}
																																																									if (BgL_test8369z00_16004)
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_16009;
																																																											goto
																																																												BgL_tagzd2384zd2_1732;
																																																											BgL_auxz00_14205
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_16009);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_carzd25381zd2_3174;
																																																											BgL_carzd25381zd2_3174
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_cdrzd25386zd2_3175;
																																																												BgL_cdrzd25386zd2_3175
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_carzd25381zd2_3174));
																																																												if ((CAR(((obj_t) BgL_carzd25381zd2_3174)) == CNST_TABLE_REF(((long) 3))))
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_arg2704z00_3178;
																																																														obj_t
																																																															BgL_arg2706z00_3179;
																																																														obj_t
																																																															BgL_arg2708z00_3180;
																																																														BgL_arg2704z00_3178
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd25386zd2_3175));
																																																														BgL_arg2706z00_3179
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd25386zd2_3175));
																																																														BgL_arg2708z00_3180
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_16026;
																																																															{
																																																																obj_t
																																																																	BgL_argsz00_16029;
																																																																obj_t
																																																																	BgL_bodyz00_16028;
																																																																obj_t
																																																																	BgL_varsz00_16027;
																																																																BgL_varsz00_16027
																																																																	=
																																																																	BgL_arg2704z00_3178;
																																																																BgL_bodyz00_16028
																																																																	=
																																																																	BgL_arg2706z00_3179;
																																																																BgL_argsz00_16029
																																																																	=
																																																																	BgL_arg2708z00_3180;
																																																																BgL_argsz00_1739
																																																																	=
																																																																	BgL_argsz00_16029;
																																																																BgL_bodyz00_1738
																																																																	=
																																																																	BgL_bodyz00_16028;
																																																																BgL_varsz00_1737
																																																																	=
																																																																	BgL_varsz00_16027;
																																																																goto
																																																																	BgL_tagzd2386zd2_1740;
																																																															}
																																																															BgL_auxz00_14205
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_16026);
																																																														}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 118 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 118 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1774;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_16033;
																																																																goto
																																																																	BgL_tagzd2404zd2_1775;
																																																																BgL_auxz00_14205
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_16033);
																																																															}
																																																													}
																																																											}
																																																										}
																																																								}
																																																						}
																																																					}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_cdrzd25497zd2_3185;
																																																				BgL_cdrzd25497zd2_3185
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{	/* Ast/sexp.scm 118 */
																																																					bool_t
																																																						BgL_test8372z00_16037;
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_arg2725z00_3194;
																																																						BgL_arg2725z00_3194
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test8372z00_16037
																																																							=
																																																							CBOOL
																																																							(BGl_letzd2symzf3z21zzast_letz00
																																																							(BgL_arg2725z00_3194));
																																																					}
																																																					if (BgL_test8372z00_16037)
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_arg2719z00_3188;
																																																							obj_t
																																																								BgL_arg2720z00_3189;
																																																							BgL_arg2719z00_3188
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd25497zd2_3185));
																																																							BgL_arg2720z00_3189
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd25497zd2_3185));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_16046;
																																																								{
																																																									obj_t
																																																										BgL_exprz00_16048;
																																																									obj_t
																																																										BgL_bindingsz00_16047;
																																																									BgL_bindingsz00_16047
																																																										=
																																																										BgL_arg2719z00_3188;
																																																									BgL_exprz00_16048
																																																										=
																																																										BgL_arg2720z00_3189;
																																																									BgL_exprz00_1729
																																																										=
																																																										BgL_exprz00_16048;
																																																									BgL_bindingsz00_1728
																																																										=
																																																										BgL_bindingsz00_16047;
																																																									goto
																																																										BgL_tagzd2382zd2_1730;
																																																								}
																																																								BgL_auxz00_14205
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_16046);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							bool_t
																																																								BgL_test8373z00_16050;
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_arg2724z00_3193;
																																																								BgL_arg2724z00_3193
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test8373z00_16050
																																																									=
																																																									CBOOL
																																																									(BGl_labelszd2symzf3z21zzast_labelsz00
																																																									(BgL_arg2724z00_3193));
																																																							}
																																																							if (BgL_test8373z00_16050)
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_16055;
																																																									goto
																																																										BgL_tagzd2384zd2_1732;
																																																									BgL_auxz00_14205
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_16055);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																										{	/* Ast/sexp.scm 118 */
																																																											goto
																																																												BgL_tagzd2403zd2_1774;
																																																										}
																																																									else
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_16059;
																																																											goto
																																																												BgL_tagzd2404zd2_1775;
																																																											BgL_auxz00_14205
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_16059);
																																																										}
																																																								}
																																																						}
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd24062zd2_2921)))
																																																			{	/* Ast/sexp.scm 118 */
																																																				goto
																																																					BgL_kapzd24064zd2_2923;
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 118 */
																																																				if ((BgL_carzd24062zd2_2921 == CNST_TABLE_REF(((long) 18))))
																																																					{	/* Ast/sexp.scm 118 */
																																																						goto
																																																							BgL_kapzd24064zd2_2923;
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 118 */
																																																						if ((BgL_carzd24062zd2_2921 == CNST_TABLE_REF(((long) 19))))
																																																							{	/* Ast/sexp.scm 118 */
																																																								goto
																																																									BgL_kapzd24064zd2_2923;
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 118 */
																																																								if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd24062zd2_2921)))
																																																									{	/* Ast/sexp.scm 118 */
																																																										goto
																																																											BgL_kapzd24064zd2_2923;
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_cdrzd25669zd2_2929;
																																																										BgL_cdrzd25669zd2_2929
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{	/* Ast/sexp.scm 118 */
																																																											bool_t
																																																												BgL_test8379z00_16075;
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_arg2614z00_3046;
																																																												BgL_arg2614z00_3046
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												BgL_test8379z00_16075
																																																													=
																																																													CBOOL
																																																													(BGl_letzd2symzf3z21zzast_letz00
																																																													(BgL_arg2614z00_3046));
																																																											}
																																																											if (BgL_test8379z00_16075)
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_arg2528z00_2932;
																																																													obj_t
																																																														BgL_arg2531z00_2933;
																																																													BgL_arg2528z00_2932
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_cdrzd25669zd2_2929));
																																																													BgL_arg2531z00_2933
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd25669zd2_2929));
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_16084;
																																																														{
																																																															obj_t
																																																																BgL_exprz00_16086;
																																																															obj_t
																																																																BgL_bindingsz00_16085;
																																																															BgL_bindingsz00_16085
																																																																=
																																																																BgL_arg2528z00_2932;
																																																															BgL_exprz00_16086
																																																																=
																																																																BgL_arg2531z00_2933;
																																																															BgL_exprz00_1729
																																																																=
																																																																BgL_exprz00_16086;
																																																															BgL_bindingsz00_1728
																																																																=
																																																																BgL_bindingsz00_16085;
																																																															goto
																																																																BgL_tagzd2382zd2_1730;
																																																														}
																																																														BgL_auxz00_14205
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_16084);
																																																													}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													bool_t
																																																														BgL_test8380z00_16088;
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_arg2613z00_3045;
																																																														BgL_arg2613z00_3045
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														BgL_test8380z00_16088
																																																															=
																																																															CBOOL
																																																															(BGl_labelszd2symzf3z21zzast_labelsz00
																																																															(BgL_arg2613z00_3045));
																																																													}
																																																													if (BgL_test8380z00_16088)
																																																														{
																																																															BgL_letzd2funzd2_bglt
																																																																BgL_auxz00_16093;
																																																															goto
																																																																BgL_tagzd2384zd2_1732;
																																																															BgL_auxz00_14205
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_16093);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_carzd25735zd2_2936;
																																																															BgL_carzd25735zd2_2936
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_cdrzd25740zd2_2937;
																																																																BgL_cdrzd25740zd2_2937
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_carzd25735zd2_2936));
																																																																if ((CAR(((obj_t) BgL_carzd25735zd2_2936)) == CNST_TABLE_REF(((long) 3))))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (PAIRP(BgL_cdrzd25740zd2_2937))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_arg2540z00_2941;
																																																																				obj_t
																																																																					BgL_arg2543z00_2942;
																																																																				obj_t
																																																																					BgL_arg2544z00_2943;
																																																																				BgL_arg2540z00_2941
																																																																					=
																																																																					CAR
																																																																					(BgL_cdrzd25740zd2_2937);
																																																																				BgL_arg2543z00_2942
																																																																					=
																																																																					CDR
																																																																					(BgL_cdrzd25740zd2_2937);
																																																																				BgL_arg2544z00_2943
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_16110;
																																																																					{
																																																																						obj_t
																																																																							BgL_argsz00_16113;
																																																																						obj_t
																																																																							BgL_bodyz00_16112;
																																																																						obj_t
																																																																							BgL_varsz00_16111;
																																																																						BgL_varsz00_16111
																																																																							=
																																																																							BgL_arg2540z00_2941;
																																																																						BgL_bodyz00_16112
																																																																							=
																																																																							BgL_arg2543z00_2942;
																																																																						BgL_argsz00_16113
																																																																							=
																																																																							BgL_arg2544z00_2943;
																																																																						BgL_argsz00_1739
																																																																							=
																																																																							BgL_argsz00_16113;
																																																																						BgL_bodyz00_1738
																																																																							=
																																																																							BgL_bodyz00_16112;
																																																																						BgL_varsz00_1737
																																																																							=
																																																																							BgL_varsz00_16111;
																																																																						goto
																																																																							BgL_tagzd2386zd2_1740;
																																																																					}
																																																																					BgL_auxz00_14205
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_16110);
																																																																				}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1774;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_16117;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1775;
																																																																						BgL_auxz00_14205
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_16117);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_cdrzd25847zd2_2946;
																																																																		BgL_cdrzd25847zd2_2946
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_cdrzd25852zd2_2947;
																																																																			BgL_cdrzd25852zd2_2947
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_carzd25735zd2_2936));
																																																																			if ((CAR(((obj_t) BgL_carzd25735zd2_2936)) == CNST_TABLE_REF(((long) 1))))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (PAIRP(BgL_cdrzd25852zd2_2947))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_cdrzd25857zd2_2951;
																																																																							BgL_cdrzd25857zd2_2951
																																																																								=
																																																																								CDR
																																																																								(BgL_cdrzd25852zd2_2947);
																																																																							if (PAIRP(BgL_cdrzd25857zd2_2951))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_carzd25861zd2_2953;
																																																																									obj_t
																																																																										BgL_cdrzd25862zd2_2954;
																																																																									BgL_carzd25861zd2_2953
																																																																										=
																																																																										CAR
																																																																										(BgL_cdrzd25857zd2_2951);
																																																																									BgL_cdrzd25862zd2_2954
																																																																										=
																																																																										CDR
																																																																										(BgL_cdrzd25857zd2_2951);
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd25861zd2_2953))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (PAIRP(BgL_cdrzd25862zd2_2954))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_carzd25867zd2_2957;
																																																																													BgL_carzd25867zd2_2957
																																																																														=
																																																																														CAR
																																																																														(BgL_cdrzd25862zd2_2954);
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd25867zd2_2957))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (NULLP(CDR(BgL_cdrzd25862zd2_2954)))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	bool_t
																																																																																		BgL_test8391z00_16145;
																																																																																	{
																																																																																		obj_t
																																																																																			BgL_l1373z00_2990;
																																																																																		BgL_l1373z00_2990
																																																																																			=
																																																																																			BgL_cdrzd25847zd2_2946;
																																																																																	BgL_zc3z04anonymousza32572ze3z87_2991:
																																																																																		if (NULLP(BgL_l1373z00_2990))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				BgL_test8391z00_16145
																																																																																					=
																																																																																					(
																																																																																					(bool_t)
																																																																																					1);
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				bool_t
																																																																																					BgL_test8393z00_16148;
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					bool_t
																																																																																						BgL_test8394z00_16149;
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						obj_t
																																																																																							BgL_tmpz00_16150;
																																																																																						BgL_tmpz00_16150
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_l1373z00_2990));
																																																																																						BgL_test8394z00_16149
																																																																																							=
																																																																																							PAIRP
																																																																																							(BgL_tmpz00_16150);
																																																																																					}
																																																																																					if (BgL_test8394z00_16149)
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							BgL_test8393z00_16148
																																																																																								=
																																																																																								(
																																																																																								(bool_t)
																																																																																								0);
																																																																																						}
																																																																																					else
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							BgL_test8393z00_16148
																																																																																								=
																																																																																								(
																																																																																								(bool_t)
																																																																																								1);
																																																																																						}
																																																																																				}
																																																																																				if (BgL_test8393z00_16148)
																																																																																					{
																																																																																						obj_t
																																																																																							BgL_l1373z00_16154;
																																																																																						BgL_l1373z00_16154
																																																																																							=
																																																																																							CDR
																																																																																							(
																																																																																							((obj_t) BgL_l1373z00_2990));
																																																																																						BgL_l1373z00_2990
																																																																																							=
																																																																																							BgL_l1373z00_16154;
																																																																																						goto
																																																																																							BgL_zc3z04anonymousza32572ze3z87_2991;
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						BgL_test8391z00_16145
																																																																																							=
																																																																																							(
																																																																																							(bool_t)
																																																																																							0);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																	if (BgL_test8391z00_16145)
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			obj_t
																																																																																				BgL_arg2562z00_2973;
																																																																																			BgL_arg2562z00_2973
																																																																																				=
																																																																																				CAR
																																																																																				(BgL_cdrzd25852zd2_2947);
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_16158;
																																																																																				{
																																																																																					obj_t
																																																																																						BgL_argsz00_16162;
																																																																																					obj_t
																																																																																						BgL_proc2z00_16161;
																																																																																					obj_t
																																																																																						BgL_proc1z00_16160;
																																																																																					obj_t
																																																																																						BgL_testz00_16159;
																																																																																					BgL_testz00_16159
																																																																																						=
																																																																																						BgL_arg2562z00_2973;
																																																																																					BgL_proc1z00_16160
																																																																																						=
																																																																																						BgL_carzd25861zd2_2953;
																																																																																					BgL_proc2z00_16161
																																																																																						=
																																																																																						BgL_carzd25867zd2_2957;
																																																																																					BgL_argsz00_16162
																																																																																						=
																																																																																						BgL_cdrzd25847zd2_2946;
																																																																																					BgL_argsz00_1744
																																																																																						=
																																																																																						BgL_argsz00_16162;
																																																																																					BgL_proc2z00_1743
																																																																																						=
																																																																																						BgL_proc2z00_16161;
																																																																																					BgL_proc1z00_1742
																																																																																						=
																																																																																						BgL_proc1z00_16160;
																																																																																					BgL_testz00_1741
																																																																																						=
																																																																																						BgL_testz00_16159;
																																																																																					goto
																																																																																						BgL_tagzd2387zd2_1745;
																																																																																				}
																																																																																				BgL_auxz00_14205
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_16158);
																																																																																			}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			obj_t
																																																																																				BgL_cdrzd25892zd2_2974;
																																																																																			BgL_cdrzd25892zd2_2974
																																																																																				=
																																																																																				CDR
																																																																																				(
																																																																																				((obj_t) BgL_expz00_21));
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				obj_t
																																																																																					BgL_cdrzd25900zd2_2975;
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					obj_t
																																																																																						BgL_pairz00_10378;
																																																																																					BgL_pairz00_10378
																																																																																						=
																																																																																						CAR
																																																																																						(
																																																																																						((obj_t) BgL_expz00_21));
																																																																																					BgL_cdrzd25900zd2_2975
																																																																																						=
																																																																																						CDR
																																																																																						(BgL_pairz00_10378);
																																																																																				}
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					obj_t
																																																																																						BgL_cdrzd25908zd2_2976;
																																																																																					BgL_cdrzd25908zd2_2976
																																																																																						=
																																																																																						CDR
																																																																																						(
																																																																																						((obj_t) BgL_cdrzd25900zd2_2975));
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						obj_t
																																																																																							BgL_carzd25915zd2_2977;
																																																																																						BgL_carzd25915zd2_2977
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_cdrzd25908zd2_2976));
																																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd25915zd2_2977))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								obj_t
																																																																																									BgL_carzd25924zd2_2979;
																																																																																								{	/* Ast/sexp.scm 118 */
																																																																																									obj_t
																																																																																										BgL_pairz00_10382;
																																																																																									BgL_pairz00_10382
																																																																																										=
																																																																																										CDR
																																																																																										(
																																																																																										((obj_t) BgL_cdrzd25908zd2_2976));
																																																																																									BgL_carzd25924zd2_2979
																																																																																										=
																																																																																										CAR
																																																																																										(BgL_pairz00_10382);
																																																																																								}
																																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd25924zd2_2979))
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd25892zd2_2974))
																																																																																											{	/* Ast/sexp.scm 118 */
																																																																																												obj_t
																																																																																													BgL_arg2566z00_2982;
																																																																																												BgL_arg2566z00_2982
																																																																																													=
																																																																																													CAR
																																																																																													(
																																																																																													((obj_t) BgL_cdrzd25900zd2_2975));
																																																																																												{
																																																																																													BgL_nodez00_bglt
																																																																																														BgL_auxz00_16184;
																																																																																													{
																																																																																														obj_t
																																																																																															BgL_argsz00_16188;
																																																																																														obj_t
																																																																																															BgL_proc2z00_16187;
																																																																																														obj_t
																																																																																															BgL_proc1z00_16186;
																																																																																														obj_t
																																																																																															BgL_testz00_16185;
																																																																																														BgL_testz00_16185
																																																																																															=
																																																																																															BgL_arg2566z00_2982;
																																																																																														BgL_proc1z00_16186
																																																																																															=
																																																																																															BgL_carzd25915zd2_2977;
																																																																																														BgL_proc2z00_16187
																																																																																															=
																																																																																															BgL_carzd25924zd2_2979;
																																																																																														BgL_argsz00_16188
																																																																																															=
																																																																																															BgL_cdrzd25892zd2_2974;
																																																																																														BgL_argsz00_1749
																																																																																															=
																																																																																															BgL_argsz00_16188;
																																																																																														BgL_proc2z00_1748
																																																																																															=
																																																																																															BgL_proc2z00_16187;
																																																																																														BgL_proc1z00_1747
																																																																																															=
																																																																																															BgL_proc1z00_16186;
																																																																																														BgL_testz00_1746
																																																																																															=
																																																																																															BgL_testz00_16185;
																																																																																														goto
																																																																																															BgL_tagzd2388zd2_1750;
																																																																																													}
																																																																																													BgL_auxz00_14205
																																																																																														=
																																																																																														(
																																																																																														(obj_t)
																																																																																														BgL_auxz00_16184);
																																																																																												}
																																																																																											}
																																																																																										else
																																																																																											{	/* Ast/sexp.scm 118 */
																																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																													{	/* Ast/sexp.scm 118 */
																																																																																														goto
																																																																																															BgL_tagzd2403zd2_1774;
																																																																																													}
																																																																																												else
																																																																																													{
																																																																																														BgL_nodez00_bglt
																																																																																															BgL_auxz00_16192;
																																																																																														goto
																																																																																															BgL_tagzd2404zd2_1775;
																																																																																														BgL_auxz00_14205
																																																																																															=
																																																																																															(
																																																																																															(obj_t)
																																																																																															BgL_auxz00_16192);
																																																																																													}
																																																																																											}
																																																																																									}
																																																																																								else
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																											{	/* Ast/sexp.scm 118 */
																																																																																												goto
																																																																																													BgL_tagzd2403zd2_1774;
																																																																																											}
																																																																																										else
																																																																																											{
																																																																																												BgL_nodez00_bglt
																																																																																													BgL_auxz00_16196;
																																																																																												goto
																																																																																													BgL_tagzd2404zd2_1775;
																																																																																												BgL_auxz00_14205
																																																																																													=
																																																																																													(
																																																																																													(obj_t)
																																																																																													BgL_auxz00_16196);
																																																																																											}
																																																																																									}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1774;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_16200;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1775;
																																																																																										BgL_auxz00_14205
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_16200);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				}
																																																																																			}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1774;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_16204;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1775;
																																																																																			BgL_auxz00_14205
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_16204);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_cdrzd26202zd2_3001;
																																																																															BgL_cdrzd26202zd2_3001
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_cdrzd26209zd2_3002;
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_pairz00_10386;
																																																																																	BgL_pairz00_10386
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_expz00_21));
																																																																																	BgL_cdrzd26209zd2_3002
																																																																																		=
																																																																																		CDR
																																																																																		(BgL_pairz00_10386);
																																																																																}
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_cdrzd26216zd2_3003;
																																																																																	BgL_cdrzd26216zd2_3003
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd26209zd2_3002));
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		obj_t
																																																																																			BgL_carzd26222zd2_3004;
																																																																																		obj_t
																																																																																			BgL_cdrzd26223zd2_3005;
																																																																																		BgL_carzd26222zd2_3004
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd26216zd2_3003));
																																																																																		BgL_cdrzd26223zd2_3005
																																																																																			=
																																																																																			CDR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd26216zd2_3003));
																																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd26222zd2_3004))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				obj_t
																																																																																					BgL_carzd26230zd2_3007;
																																																																																				BgL_carzd26230zd2_3007
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd26223zd2_3005));
																																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd26230zd2_3007))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (NULLP(CDR(((obj_t) BgL_cdrzd26223zd2_3005))))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd26202zd2_3001))
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										obj_t
																																																																																											BgL_arg2582z00_3012;
																																																																																										BgL_arg2582z00_3012
																																																																																											=
																																																																																											CAR
																																																																																											(
																																																																																											((obj_t) BgL_cdrzd26209zd2_3002));
																																																																																										{
																																																																																											BgL_nodez00_bglt
																																																																																												BgL_auxz00_16231;
																																																																																											{
																																																																																												obj_t
																																																																																													BgL_argsz00_16235;
																																																																																												obj_t
																																																																																													BgL_proc2z00_16234;
																																																																																												obj_t
																																																																																													BgL_proc1z00_16233;
																																																																																												obj_t
																																																																																													BgL_testz00_16232;
																																																																																												BgL_testz00_16232
																																																																																													=
																																																																																													BgL_arg2582z00_3012;
																																																																																												BgL_proc1z00_16233
																																																																																													=
																																																																																													BgL_carzd26222zd2_3004;
																																																																																												BgL_proc2z00_16234
																																																																																													=
																																																																																													BgL_carzd26230zd2_3007;
																																																																																												BgL_argsz00_16235
																																																																																													=
																																																																																													BgL_cdrzd26202zd2_3001;
																																																																																												BgL_argsz00_1749
																																																																																													=
																																																																																													BgL_argsz00_16235;
																																																																																												BgL_proc2z00_1748
																																																																																													=
																																																																																													BgL_proc2z00_16234;
																																																																																												BgL_proc1z00_1747
																																																																																													=
																																																																																													BgL_proc1z00_16233;
																																																																																												BgL_testz00_1746
																																																																																													=
																																																																																													BgL_testz00_16232;
																																																																																												goto
																																																																																													BgL_tagzd2388zd2_1750;
																																																																																											}
																																																																																											BgL_auxz00_14205
																																																																																												=
																																																																																												(
																																																																																												(obj_t)
																																																																																												BgL_auxz00_16231);
																																																																																										}
																																																																																									}
																																																																																								else
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																											{	/* Ast/sexp.scm 118 */
																																																																																												goto
																																																																																													BgL_tagzd2403zd2_1774;
																																																																																											}
																																																																																										else
																																																																																											{
																																																																																												BgL_nodez00_bglt
																																																																																													BgL_auxz00_16239;
																																																																																												goto
																																																																																													BgL_tagzd2404zd2_1775;
																																																																																												BgL_auxz00_14205
																																																																																													=
																																																																																													(
																																																																																													(obj_t)
																																																																																													BgL_auxz00_16239);
																																																																																											}
																																																																																									}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1774;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_16243;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1775;
																																																																																										BgL_auxz00_14205
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_16243);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1774;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_16247;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1775;
																																																																																								BgL_auxz00_14205
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_16247);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1774;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_16251;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1775;
																																																																																						BgL_auxz00_14205
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_16251);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																}
																																																																															}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1774;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_16255;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1775;
																																																																															BgL_auxz00_14205
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_16255);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_cdrzd26563zd2_3020;
																																																																											BgL_cdrzd26563zd2_3020
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_cdrzd26569zd2_3021;
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_pairz00_10396;
																																																																													BgL_pairz00_10396
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													BgL_cdrzd26569zd2_3021
																																																																														=
																																																																														CDR
																																																																														(BgL_pairz00_10396);
																																																																												}
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_cdrzd26575zd2_3022;
																																																																													BgL_cdrzd26575zd2_3022
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd26569zd2_3021));
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_carzd26580zd2_3023;
																																																																														obj_t
																																																																															BgL_cdrzd26581zd2_3024;
																																																																														BgL_carzd26580zd2_3023
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd26575zd2_3022));
																																																																														BgL_cdrzd26581zd2_3024
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd26575zd2_3022));
																																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd26580zd2_3023))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (PAIRP(BgL_cdrzd26581zd2_3024))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		obj_t
																																																																																			BgL_carzd26586zd2_3027;
																																																																																		BgL_carzd26586zd2_3027
																																																																																			=
																																																																																			CAR
																																																																																			(BgL_cdrzd26581zd2_3024);
																																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd26586zd2_3027))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (NULLP(CDR(BgL_cdrzd26581zd2_3024)))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd26563zd2_3020))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								obj_t
																																																																																									BgL_arg2598z00_3032;
																																																																																								BgL_arg2598z00_3032
																																																																																									=
																																																																																									CAR
																																																																																									(
																																																																																									((obj_t) BgL_cdrzd26569zd2_3021));
																																																																																								{
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_auxz00_16282;
																																																																																									{
																																																																																										obj_t
																																																																																											BgL_argsz00_16286;
																																																																																										obj_t
																																																																																											BgL_proc2z00_16285;
																																																																																										obj_t
																																																																																											BgL_proc1z00_16284;
																																																																																										obj_t
																																																																																											BgL_testz00_16283;
																																																																																										BgL_testz00_16283
																																																																																											=
																																																																																											BgL_arg2598z00_3032;
																																																																																										BgL_proc1z00_16284
																																																																																											=
																																																																																											BgL_carzd26580zd2_3023;
																																																																																										BgL_proc2z00_16285
																																																																																											=
																																																																																											BgL_carzd26586zd2_3027;
																																																																																										BgL_argsz00_16286
																																																																																											=
																																																																																											BgL_cdrzd26563zd2_3020;
																																																																																										BgL_argsz00_1749
																																																																																											=
																																																																																											BgL_argsz00_16286;
																																																																																										BgL_proc2z00_1748
																																																																																											=
																																																																																											BgL_proc2z00_16285;
																																																																																										BgL_proc1z00_1747
																																																																																											=
																																																																																											BgL_proc1z00_16284;
																																																																																										BgL_testz00_1746
																																																																																											=
																																																																																											BgL_testz00_16283;
																																																																																										goto
																																																																																											BgL_tagzd2388zd2_1750;
																																																																																									}
																																																																																									BgL_auxz00_14205
																																																																																										=
																																																																																										(
																																																																																										(obj_t)
																																																																																										BgL_auxz00_16282);
																																																																																								}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1774;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_16290;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1775;
																																																																																										BgL_auxz00_14205
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_16290);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1774;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_16294;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1775;
																																																																																								BgL_auxz00_14205
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_16294);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1774;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_16298;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1775;
																																																																																						BgL_auxz00_14205
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_16298);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1774;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_16302;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1775;
																																																																																				BgL_auxz00_14205
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_16302);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1774;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_16306;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1775;
																																																																																		BgL_auxz00_14205
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_16306);
																																																																																	}
																																																																															}
																																																																													}
																																																																												}
																																																																											}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1774;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_16310;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1775;
																																																																											BgL_auxz00_14205
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_16310);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1774;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_16314;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1775;
																																																																									BgL_auxz00_14205
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_16314);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1774;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_16318;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1775;
																																																																							BgL_auxz00_14205
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_16318);
																																																																						}
																																																																				}
																																																																		}
																																																																	}
																																																															}
																																																														}
																																																												}
																																																										}
																																																									}
																																																							}
																																																					}
																																																			}
																																																	}
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_cdrzd27124zd2_3196;
																																															BgL_cdrzd27124zd2_3196
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															if ((BgL_carzd24059zd2_2919 == CNST_TABLE_REF(((long) 17))))
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_arg2727z00_3198;
																																																	obj_t
																																																		BgL_arg2731z00_3199;
																																																	BgL_arg2727z00_3198
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd27124zd2_3196));
																																																	BgL_arg2731z00_3199
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd27124zd2_3196));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_16329;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_16331;
																																																			obj_t
																																																				BgL_bindingsz00_16330;
																																																			BgL_bindingsz00_16330
																																																				=
																																																				BgL_arg2727z00_3198;
																																																			BgL_exprz00_16331
																																																				=
																																																				BgL_arg2731z00_3199;
																																																			BgL_exprz00_1729
																																																				=
																																																				BgL_exprz00_16331;
																																																			BgL_bindingsz00_1728
																																																				=
																																																				BgL_bindingsz00_16330;
																																																			goto
																																																				BgL_tagzd2382zd2_1730;
																																																		}
																																																		BgL_auxz00_14205
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_16329);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd24059zd2_2919)))
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_arg2733z00_3201;
																																																			obj_t
																																																				BgL_arg2734z00_3202;
																																																			BgL_arg2733z00_3201
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd27124zd2_3196));
																																																			BgL_arg2734z00_3202
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd27124zd2_3196));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_16340;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_16342;
																																																					obj_t
																																																						BgL_bindingsz00_16341;
																																																					BgL_bindingsz00_16341
																																																						=
																																																						BgL_arg2733z00_3201;
																																																					BgL_exprz00_16342
																																																						=
																																																						BgL_arg2734z00_3202;
																																																					BgL_exprz00_1729
																																																						=
																																																						BgL_exprz00_16342;
																																																					BgL_bindingsz00_1728
																																																						=
																																																						BgL_bindingsz00_16341;
																																																					goto
																																																						BgL_tagzd2382zd2_1730;
																																																				}
																																																				BgL_auxz00_14205
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_16340);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			if ((BgL_carzd24059zd2_2919 == CNST_TABLE_REF(((long) 18))))
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_arg2736z00_3204;
																																																					obj_t
																																																						BgL_arg2737z00_3205;
																																																					BgL_arg2736z00_3204
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd27124zd2_3196));
																																																					BgL_arg2737z00_3205
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd27124zd2_3196));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_16351;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_16353;
																																																							obj_t
																																																								BgL_bindingsz00_16352;
																																																							BgL_bindingsz00_16352
																																																								=
																																																								BgL_arg2736z00_3204;
																																																							BgL_exprz00_16353
																																																								=
																																																								BgL_arg2737z00_3205;
																																																							BgL_exprz00_1729
																																																								=
																																																								BgL_exprz00_16353;
																																																							BgL_bindingsz00_1728
																																																								=
																																																								BgL_bindingsz00_16352;
																																																							goto
																																																								BgL_tagzd2382zd2_1730;
																																																						}
																																																						BgL_auxz00_14205
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_16351);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_16360;
																																																							goto
																																																								BgL_tagzd2383zd2_1731;
																																																							BgL_auxz00_14205
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_16360);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_carzd27161zd2_3208;
																																																							BgL_carzd27161zd2_3208
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							if ((BgL_carzd27161zd2_3208 == CNST_TABLE_REF(((long) 19))))
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_16367;
																																																									goto
																																																										BgL_tagzd2384zd2_1732;
																																																									BgL_auxz00_14205
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_16367);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd27161zd2_3208)))
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_16372;
																																																											goto
																																																												BgL_tagzd2384zd2_1732;
																																																											BgL_auxz00_14205
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_16372);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_16379;
																																																													goto
																																																														BgL_tagzd2389zd2_1751;
																																																													BgL_auxz00_14205
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_16379);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_16386;
																																																															goto
																																																																BgL_tagzd2390zd2_1752;
																																																															BgL_auxz00_14205
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_16386);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_cdrzd27241zd2_3215;
																																																															BgL_cdrzd27241zd2_3215
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_arg2748z00_3218;
																																																																	obj_t
																																																																		BgL_arg2750z00_3219;
																																																																	BgL_arg2748z00_3218
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd27241zd2_3215));
																																																																	BgL_arg2750z00_3219
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd27241zd2_3215));
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_16399;
																																																																		{
																																																																			obj_t
																																																																				BgL_restz00_16401;
																																																																			obj_t
																																																																				BgL_effectz00_16400;
																																																																			BgL_effectz00_16400
																																																																				=
																																																																				BgL_arg2748z00_3218;
																																																																			BgL_restz00_16401
																																																																				=
																																																																				BgL_arg2750z00_3219;
																																																																			BgL_restz00_1754
																																																																				=
																																																																				BgL_restz00_16401;
																																																																			BgL_effectz00_1753
																																																																				=
																																																																				BgL_effectz00_16400;
																																																																			goto
																																																																				BgL_tagzd2391zd2_1755;
																																																																		}
																																																																		BgL_auxz00_14205
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_16399);
																																																																	}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_16408;
																																																																			goto
																																																																				BgL_tagzd2392zd2_1756;
																																																																			BgL_auxz00_14205
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_16408);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_16415;
																																																																					goto
																																																																						BgL_tagzd2393zd2_1757;
																																																																					BgL_auxz00_14205
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_16415);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_arg2758z00_3227;
																																																																							obj_t
																																																																								BgL_arg2759z00_3228;
																																																																							BgL_arg2758z00_3227
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd27241zd2_3215));
																																																																							BgL_arg2759z00_3228
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd27241zd2_3215));
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_16426;
																																																																								{
																																																																									obj_t
																																																																										BgL_restz00_16428;
																																																																									obj_t
																																																																										BgL_effectz00_16427;
																																																																									BgL_effectz00_16427
																																																																										=
																																																																										BgL_arg2758z00_3227;
																																																																									BgL_restz00_16428
																																																																										=
																																																																										BgL_arg2759z00_3228;
																																																																									BgL_restz00_1759
																																																																										=
																																																																										BgL_restz00_16428;
																																																																									BgL_effectz00_1758
																																																																										=
																																																																										BgL_effectz00_16427;
																																																																									goto
																																																																										BgL_tagzd2394zd2_1760;
																																																																								}
																																																																								BgL_auxz00_14205
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_16426);
																																																																							}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_16435;
																																																																									goto
																																																																										BgL_tagzd2395zd2_1761;
																																																																									BgL_auxz00_14205
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_16435);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_16442;
																																																																											goto
																																																																												BgL_tagzd2396zd2_1762;
																																																																											BgL_auxz00_14205
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_16442);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																												{
																																																																													BgL_letzd2funzd2_bglt
																																																																														BgL_auxz00_16449;
																																																																													goto
																																																																														BgL_tagzd2397zd2_1763;
																																																																													BgL_auxz00_14205
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_16449);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																														{
																																																																															BgL_jumpzd2exzd2itz00_bglt
																																																																																BgL_auxz00_16456;
																																																																															goto
																																																																																BgL_tagzd2398zd2_1764;
																																																																															BgL_auxz00_14205
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_16456);
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_cdrzd27318zd2_3237;
																																																																															BgL_cdrzd27318zd2_3237
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_arg2779z00_3240;
																																																																																	obj_t
																																																																																		BgL_arg2780z00_3241;
																																																																																	BgL_arg2779z00_3240
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd27318zd2_3237));
																																																																																	BgL_arg2780z00_3241
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd27318zd2_3237));
																																																																																	{	/* Ast/sexp.scm 551 */
																																																																																		obj_t
																																																																																			BgL_arg6989z00_10435;
																																																																																		BgL_arg6989z00_10435
																																																																																			=
																																																																																			BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																			(BgL_expz00_21,
																																																																																			BgL_locz00_23);
																																																																																		BgL_auxz00_14205
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																			(BgL_expz00_21,
																																																																																				BgL_arg2779z00_3240,
																																																																																				CNST_TABLE_REF
																																																																																				(((long) 4)), BgL_arg2780z00_3241, BgL_stackz00_22, BgL_arg6989z00_10435, BgL_sitez00_24));
																																																																																}}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1774;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_16475;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1775;
																																																																																			BgL_auxz00_14205
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_16475);
																																																																																		}
																																																																																}
																																																																														}
																																																																												}
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																	else
																																		{	/* Ast/sexp.scm 118 */
																																			obj_t
																																				BgL_carzd27343zd2_3258;
																																			BgL_carzd27343zd2_3258
																																				=
																																				CAR((
																																					(obj_t)
																																					BgL_expz00_21));
																																			if (
																																				(BgL_carzd27343zd2_3258
																																					==
																																					CNST_TABLE_REF
																																					(((long) 1))))
																																				{
																																					BgL_nodez00_bglt
																																						BgL_auxz00_16482;
																																					goto
																																						BgL_tagzd2377zd2_1719;
																																					BgL_auxz00_14205
																																						=
																																						(
																																						(obj_t)
																																						BgL_auxz00_16482);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 118 */
																																					if (
																																						(BgL_carzd27343zd2_3258
																																							==
																																							BGl_za2ifza2z00zzast_sexpz00))
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_16486;
																																							goto
																																								BgL_tagzd2377zd2_1719;
																																							BgL_auxz00_14205
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_16486);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 118 */
																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 7))))
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_16493;
																																									goto
																																										BgL_tagzd2379zd2_1723;
																																									BgL_auxz00_14205
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_16493);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 118 */
																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_16500;
																																											goto
																																												BgL_tagzd2380zd2_1724;
																																											BgL_auxz00_14205
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_16500);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 118 */
																																											obj_t
																																												BgL_carzd27412zd2_3265;
																																											BgL_carzd27412zd2_3265
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_expz00_21));
																																											if (PAIRP(BgL_carzd27412zd2_3265))
																																												{	/* Ast/sexp.scm 118 */
																																													obj_t
																																														BgL_carzd27415zd2_3267;
																																													obj_t
																																														BgL_cdrzd27416zd2_3268;
																																													BgL_carzd27415zd2_3267
																																														=
																																														CAR
																																														(BgL_carzd27412zd2_3265);
																																													BgL_cdrzd27416zd2_3268
																																														=
																																														CDR
																																														(BgL_carzd27412zd2_3265);
																																													{

																																														if ((BgL_carzd27415zd2_3267 == CNST_TABLE_REF(((long) 17))))
																																															{	/* Ast/sexp.scm 118 */
																																															BgL_kapzd27417zd2_3269:
																																																if (PAIRP(BgL_cdrzd27416zd2_3268))
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_cdrzd27420zd2_3394;
																																																		BgL_cdrzd27420zd2_3394
																																																			=
																																																			CDR
																																																			(BgL_cdrzd27416zd2_3268);
																																																		if (PAIRP(BgL_cdrzd27420zd2_3394))
																																																			{	/* Ast/sexp.scm 118 */
																																																				if (NULLP(CDR(BgL_cdrzd27420zd2_3394)))
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_arg2943z00_3398;
																																																						obj_t
																																																							BgL_arg2944z00_3399;
																																																						BgL_arg2943z00_3398
																																																							=
																																																							CAR
																																																							(BgL_cdrzd27420zd2_3394);
																																																						BgL_arg2944z00_3399
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_16522;
																																																							{
																																																								obj_t
																																																									BgL_argsz00_16524;
																																																								obj_t
																																																									BgL_bodyz00_16523;
																																																								BgL_bodyz00_16523
																																																									=
																																																									BgL_arg2943z00_3398;
																																																								BgL_argsz00_16524
																																																									=
																																																									BgL_arg2944z00_3399;
																																																								BgL_argsz00_1726
																																																									=
																																																									BgL_argsz00_16524;
																																																								BgL_bodyz00_1725
																																																									=
																																																									BgL_bodyz00_16523;
																																																								goto
																																																									BgL_tagzd2381zd2_1727;
																																																							}
																																																							BgL_auxz00_14205
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_16522);
																																																						}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_cdrzd27444zd2_3400;
																																																						BgL_cdrzd27444zd2_3400
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{	/* Ast/sexp.scm 118 */
																																																							bool_t
																																																								BgL_test8451z00_16528;
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_arg3028z00_3511;
																																																								BgL_arg3028z00_3511
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test8451z00_16528
																																																									=
																																																									CBOOL
																																																									(BGl_letzd2symzf3z21zzast_letz00
																																																									(BgL_arg3028z00_3511));
																																																							}
																																																							if (BgL_test8451z00_16528)
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_arg2947z00_3403;
																																																									obj_t
																																																										BgL_arg2948z00_3404;
																																																									BgL_arg2947z00_3403
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd27444zd2_3400));
																																																									BgL_arg2948z00_3404
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd27444zd2_3400));
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_16537;
																																																										{
																																																											obj_t
																																																												BgL_exprz00_16539;
																																																											obj_t
																																																												BgL_bindingsz00_16538;
																																																											BgL_bindingsz00_16538
																																																												=
																																																												BgL_arg2947z00_3403;
																																																											BgL_exprz00_16539
																																																												=
																																																												BgL_arg2948z00_3404;
																																																											BgL_exprz00_1729
																																																												=
																																																												BgL_exprz00_16539;
																																																											BgL_bindingsz00_1728
																																																												=
																																																												BgL_bindingsz00_16538;
																																																											goto
																																																												BgL_tagzd2382zd2_1730;
																																																										}
																																																										BgL_auxz00_14205
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_16537);
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									bool_t
																																																										BgL_test8452z00_16541;
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_arg3027z00_3510;
																																																										BgL_arg3027z00_3510
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_test8452z00_16541
																																																											=
																																																											CBOOL
																																																											(BGl_labelszd2symzf3z21zzast_labelsz00
																																																											(BgL_arg3027z00_3510));
																																																									}
																																																									if (BgL_test8452z00_16541)
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_16546;
																																																											goto
																																																												BgL_tagzd2384zd2_1732;
																																																											BgL_auxz00_14205
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_16546);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_carzd27511zd2_3407;
																																																											BgL_carzd27511zd2_3407
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_cdrzd27516zd2_3408;
																																																												BgL_cdrzd27516zd2_3408
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_carzd27511zd2_3407));
																																																												if ((CAR(((obj_t) BgL_carzd27511zd2_3407)) == CNST_TABLE_REF(((long) 3))))
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_arg2955z00_3411;
																																																														obj_t
																																																															BgL_arg2956z00_3412;
																																																														obj_t
																																																															BgL_arg2957z00_3413;
																																																														BgL_arg2955z00_3411
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd27516zd2_3408));
																																																														BgL_arg2956z00_3412
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd27516zd2_3408));
																																																														BgL_arg2957z00_3413
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_16563;
																																																															{
																																																																obj_t
																																																																	BgL_argsz00_16566;
																																																																obj_t
																																																																	BgL_bodyz00_16565;
																																																																obj_t
																																																																	BgL_varsz00_16564;
																																																																BgL_varsz00_16564
																																																																	=
																																																																	BgL_arg2955z00_3411;
																																																																BgL_bodyz00_16565
																																																																	=
																																																																	BgL_arg2956z00_3412;
																																																																BgL_argsz00_16566
																																																																	=
																																																																	BgL_arg2957z00_3413;
																																																																BgL_argsz00_1739
																																																																	=
																																																																	BgL_argsz00_16566;
																																																																BgL_bodyz00_1738
																																																																	=
																																																																	BgL_bodyz00_16565;
																																																																BgL_varsz00_1737
																																																																	=
																																																																	BgL_varsz00_16564;
																																																																goto
																																																																	BgL_tagzd2386zd2_1740;
																																																															}
																																																															BgL_auxz00_14205
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_16563);
																																																														}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_cdrzd27539zd2_3415;
																																																														BgL_cdrzd27539zd2_3415
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_cdrzd27545zd2_3416;
																																																															BgL_cdrzd27545zd2_3416
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_carzd27511zd2_3407));
																																																															if ((CAR(((obj_t) BgL_carzd27511zd2_3407)) == CNST_TABLE_REF(((long) 1))))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd27551zd2_3419;
																																																																	BgL_cdrzd27551zd2_3419
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd27545zd2_3416));
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_carzd27556zd2_3420;
																																																																		obj_t
																																																																			BgL_cdrzd27557zd2_3421;
																																																																		BgL_carzd27556zd2_3420
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd27551zd2_3419));
																																																																		BgL_cdrzd27557zd2_3421
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd27551zd2_3419));
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd27556zd2_3420))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (PAIRP(BgL_cdrzd27557zd2_3421))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_carzd27564zd2_3424;
																																																																						BgL_carzd27564zd2_3424
																																																																							=
																																																																							CAR
																																																																							(BgL_cdrzd27557zd2_3421);
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd27564zd2_3424))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (NULLP(CDR(BgL_cdrzd27557zd2_3421)))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										bool_t
																																																																											BgL_test8459z00_16593;
																																																																										{
																																																																											obj_t
																																																																												BgL_l1376z00_3457;
																																																																											BgL_l1376z00_3457
																																																																												=
																																																																												BgL_cdrzd27539zd2_3415;
																																																																										BgL_zc3z04anonymousza32983ze3z87_3458:
																																																																											if (NULLP(BgL_l1376z00_3457))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													BgL_test8459z00_16593
																																																																														=
																																																																														(
																																																																														(bool_t)
																																																																														1);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													bool_t
																																																																														BgL_test8461z00_16596;
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														bool_t
																																																																															BgL_test8462z00_16597;
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_tmpz00_16598;
																																																																															BgL_tmpz00_16598
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_l1376z00_3457));
																																																																															BgL_test8462z00_16597
																																																																																=
																																																																																PAIRP
																																																																																(BgL_tmpz00_16598);
																																																																														}
																																																																														if (BgL_test8462z00_16597)
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																BgL_test8461z00_16596
																																																																																	=
																																																																																	(
																																																																																	(bool_t)
																																																																																	0);
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																BgL_test8461z00_16596
																																																																																	=
																																																																																	(
																																																																																	(bool_t)
																																																																																	1);
																																																																															}
																																																																													}
																																																																													if (BgL_test8461z00_16596)
																																																																														{
																																																																															obj_t
																																																																																BgL_l1376z00_16602;
																																																																															BgL_l1376z00_16602
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_l1376z00_3457));
																																																																															BgL_l1376z00_3457
																																																																																=
																																																																																BgL_l1376z00_16602;
																																																																															goto
																																																																																BgL_zc3z04anonymousza32983ze3z87_3458;
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															BgL_test8459z00_16593
																																																																																=
																																																																																(
																																																																																(bool_t)
																																																																																0);
																																																																														}
																																																																												}
																																																																										}
																																																																										if (BgL_test8459z00_16593)
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_arg2972z00_3440;
																																																																												BgL_arg2972z00_3440
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd27545zd2_3416));
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_16607;
																																																																													{
																																																																														obj_t
																																																																															BgL_argsz00_16611;
																																																																														obj_t
																																																																															BgL_proc2z00_16610;
																																																																														obj_t
																																																																															BgL_proc1z00_16609;
																																																																														obj_t
																																																																															BgL_testz00_16608;
																																																																														BgL_testz00_16608
																																																																															=
																																																																															BgL_arg2972z00_3440;
																																																																														BgL_proc1z00_16609
																																																																															=
																																																																															BgL_carzd27556zd2_3420;
																																																																														BgL_proc2z00_16610
																																																																															=
																																																																															BgL_carzd27564zd2_3424;
																																																																														BgL_argsz00_16611
																																																																															=
																																																																															BgL_cdrzd27539zd2_3415;
																																																																														BgL_argsz00_1744
																																																																															=
																																																																															BgL_argsz00_16611;
																																																																														BgL_proc2z00_1743
																																																																															=
																																																																															BgL_proc2z00_16610;
																																																																														BgL_proc1z00_1742
																																																																															=
																																																																															BgL_proc1z00_16609;
																																																																														BgL_testz00_1741
																																																																															=
																																																																															BgL_testz00_16608;
																																																																														goto
																																																																															BgL_tagzd2387zd2_1745;
																																																																													}
																																																																													BgL_auxz00_14205
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_16607);
																																																																												}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_cdrzd27588zd2_3441;
																																																																												BgL_cdrzd27588zd2_3441
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_expz00_21));
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_cdrzd27595zd2_3442;
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_pairz00_10479;
																																																																														BgL_pairz00_10479
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_expz00_21));
																																																																														BgL_cdrzd27595zd2_3442
																																																																															=
																																																																															CDR
																																																																															(BgL_pairz00_10479);
																																																																													}
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_cdrzd27602zd2_3443;
																																																																														BgL_cdrzd27602zd2_3443
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd27595zd2_3442));
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_carzd27608zd2_3444;
																																																																															BgL_carzd27608zd2_3444
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd27602zd2_3443));
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd27608zd2_3444))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_carzd27615zd2_3446;
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		obj_t
																																																																																			BgL_pairz00_10483;
																																																																																		BgL_pairz00_10483
																																																																																			=
																																																																																			CDR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd27602zd2_3443));
																																																																																		BgL_carzd27615zd2_3446
																																																																																			=
																																																																																			CAR
																																																																																			(BgL_pairz00_10483);
																																																																																	}
																																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd27615zd2_3446))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd27588zd2_3441))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					obj_t
																																																																																						BgL_arg2976z00_3449;
																																																																																					BgL_arg2976z00_3449
																																																																																						=
																																																																																						CAR
																																																																																						(
																																																																																						((obj_t) BgL_cdrzd27595zd2_3442));
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_16633;
																																																																																						{
																																																																																							obj_t
																																																																																								BgL_argsz00_16637;
																																																																																							obj_t
																																																																																								BgL_proc2z00_16636;
																																																																																							obj_t
																																																																																								BgL_proc1z00_16635;
																																																																																							obj_t
																																																																																								BgL_testz00_16634;
																																																																																							BgL_testz00_16634
																																																																																								=
																																																																																								BgL_arg2976z00_3449;
																																																																																							BgL_proc1z00_16635
																																																																																								=
																																																																																								BgL_carzd27608zd2_3444;
																																																																																							BgL_proc2z00_16636
																																																																																								=
																																																																																								BgL_carzd27615zd2_3446;
																																																																																							BgL_argsz00_16637
																																																																																								=
																																																																																								BgL_cdrzd27588zd2_3441;
																																																																																							BgL_argsz00_1749
																																																																																								=
																																																																																								BgL_argsz00_16637;
																																																																																							BgL_proc2z00_1748
																																																																																								=
																																																																																								BgL_proc2z00_16636;
																																																																																							BgL_proc1z00_1747
																																																																																								=
																																																																																								BgL_proc1z00_16635;
																																																																																							BgL_testz00_1746
																																																																																								=
																																																																																								BgL_testz00_16634;
																																																																																							goto
																																																																																								BgL_tagzd2388zd2_1750;
																																																																																						}
																																																																																						BgL_auxz00_14205
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_16633);
																																																																																					}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							goto
																																																																																								BgL_tagzd2403zd2_1774;
																																																																																						}
																																																																																					else
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_16641;
																																																																																							goto
																																																																																								BgL_tagzd2404zd2_1775;
																																																																																							BgL_auxz00_14205
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_16641);
																																																																																						}
																																																																																				}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1774;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_16645;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1775;
																																																																																					BgL_auxz00_14205
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_16645);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1774;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_16649;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1775;
																																																																																			BgL_auxz00_14205
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_16649);
																																																																																		}
																																																																																}
																																																																														}
																																																																													}
																																																																												}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1774;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_16653;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1775;
																																																																												BgL_auxz00_14205
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_16653);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_cdrzd27891zd2_3468;
																																																																								BgL_cdrzd27891zd2_3468
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_cdrzd27897zd2_3469;
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_pairz00_10487;
																																																																										BgL_pairz00_10487
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										BgL_cdrzd27897zd2_3469
																																																																											=
																																																																											CDR
																																																																											(BgL_pairz00_10487);
																																																																									}
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_cdrzd27903zd2_3470;
																																																																										BgL_cdrzd27903zd2_3470
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd27897zd2_3469));
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_carzd27908zd2_3471;
																																																																											obj_t
																																																																												BgL_cdrzd27909zd2_3472;
																																																																											BgL_carzd27908zd2_3471
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd27903zd2_3470));
																																																																											BgL_cdrzd27909zd2_3472
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd27903zd2_3470));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd27908zd2_3471))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_carzd27914zd2_3474;
																																																																													BgL_carzd27914zd2_3474
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd27909zd2_3472));
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd27914zd2_3474))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (NULLP(CDR(((obj_t) BgL_cdrzd27909zd2_3472))))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd27891zd2_3468))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			obj_t
																																																																																				BgL_arg2992z00_3479;
																																																																																			BgL_arg2992z00_3479
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd27897zd2_3469));
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_16680;
																																																																																				{
																																																																																					obj_t
																																																																																						BgL_argsz00_16684;
																																																																																					obj_t
																																																																																						BgL_proc2z00_16683;
																																																																																					obj_t
																																																																																						BgL_proc1z00_16682;
																																																																																					obj_t
																																																																																						BgL_testz00_16681;
																																																																																					BgL_testz00_16681
																																																																																						=
																																																																																						BgL_arg2992z00_3479;
																																																																																					BgL_proc1z00_16682
																																																																																						=
																																																																																						BgL_carzd27908zd2_3471;
																																																																																					BgL_proc2z00_16683
																																																																																						=
																																																																																						BgL_carzd27914zd2_3474;
																																																																																					BgL_argsz00_16684
																																																																																						=
																																																																																						BgL_cdrzd27891zd2_3468;
																																																																																					BgL_argsz00_1749
																																																																																						=
																																																																																						BgL_argsz00_16684;
																																																																																					BgL_proc2z00_1748
																																																																																						=
																																																																																						BgL_proc2z00_16683;
																																																																																					BgL_proc1z00_1747
																																																																																						=
																																																																																						BgL_proc1z00_16682;
																																																																																					BgL_testz00_1746
																																																																																						=
																																																																																						BgL_testz00_16681;
																																																																																					goto
																																																																																						BgL_tagzd2388zd2_1750;
																																																																																				}
																																																																																				BgL_auxz00_14205
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_16680);
																																																																																			}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1774;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_16688;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1775;
																																																																																					BgL_auxz00_14205
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_16688);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1774;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_16692;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1775;
																																																																																			BgL_auxz00_14205
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_16692);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1774;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_16696;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1775;
																																																																																	BgL_auxz00_14205
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_16696);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1774;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_16700;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1775;
																																																																															BgL_auxz00_14205
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_16700);
																																																																														}
																																																																												}
																																																																										}
																																																																									}
																																																																								}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1774;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_16704;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1775;
																																																																								BgL_auxz00_14205
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_16704);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_cdrzd28247zd2_3487;
																																																																				BgL_cdrzd28247zd2_3487
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_cdrzd28254zd2_3488;
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_pairz00_10497;
																																																																						BgL_pairz00_10497
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						BgL_cdrzd28254zd2_3488
																																																																							=
																																																																							CDR
																																																																							(BgL_pairz00_10497);
																																																																					}
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_cdrzd28261zd2_3489;
																																																																						BgL_cdrzd28261zd2_3489
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd28254zd2_3488));
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_carzd28267zd2_3490;
																																																																							obj_t
																																																																								BgL_cdrzd28268zd2_3491;
																																																																							BgL_carzd28267zd2_3490
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd28261zd2_3489));
																																																																							BgL_cdrzd28268zd2_3491
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd28261zd2_3489));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd28267zd2_3490))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (PAIRP(BgL_cdrzd28268zd2_3491))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_carzd28275zd2_3494;
																																																																											BgL_carzd28275zd2_3494
																																																																												=
																																																																												CAR
																																																																												(BgL_cdrzd28268zd2_3491);
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd28275zd2_3494))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (NULLP(CDR(BgL_cdrzd28268zd2_3491)))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd28247zd2_3487))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_arg3014z00_3499;
																																																																																	BgL_arg3014z00_3499
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd28254zd2_3488));
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_16731;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_16735;
																																																																																			obj_t
																																																																																				BgL_proc2z00_16734;
																																																																																			obj_t
																																																																																				BgL_proc1z00_16733;
																																																																																			obj_t
																																																																																				BgL_testz00_16732;
																																																																																			BgL_testz00_16732
																																																																																				=
																																																																																				BgL_arg3014z00_3499;
																																																																																			BgL_proc1z00_16733
																																																																																				=
																																																																																				BgL_carzd28267zd2_3490;
																																																																																			BgL_proc2z00_16734
																																																																																				=
																																																																																				BgL_carzd28275zd2_3494;
																																																																																			BgL_argsz00_16735
																																																																																				=
																																																																																				BgL_cdrzd28247zd2_3487;
																																																																																			BgL_argsz00_1749
																																																																																				=
																																																																																				BgL_argsz00_16735;
																																																																																			BgL_proc2z00_1748
																																																																																				=
																																																																																				BgL_proc2z00_16734;
																																																																																			BgL_proc1z00_1747
																																																																																				=
																																																																																				BgL_proc1z00_16733;
																																																																																			BgL_testz00_1746
																																																																																				=
																																																																																				BgL_testz00_16732;
																																																																																			goto
																																																																																				BgL_tagzd2388zd2_1750;
																																																																																		}
																																																																																		BgL_auxz00_14205
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_16731);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1774;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_16739;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1775;
																																																																																			BgL_auxz00_14205
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_16739);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1774;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_16743;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1775;
																																																																																	BgL_auxz00_14205
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_16743);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1774;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_16747;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1775;
																																																																															BgL_auxz00_14205
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_16747);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1774;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_16751;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1775;
																																																																													BgL_auxz00_14205
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_16751);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1774;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_16755;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1775;
																																																																											BgL_auxz00_14205
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_16755);
																																																																										}
																																																																								}
																																																																						}
																																																																					}
																																																																				}
																																																																			}
																																																																	}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1774;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_16759;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1775;
																																																																			BgL_auxz00_14205
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_16759);
																																																																		}
																																																																}
																																																														}
																																																													}
																																																											}
																																																										}
																																																								}
																																																						}
																																																					}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_cdrzd28668zd2_3513;
																																																				BgL_cdrzd28668zd2_3513
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{	/* Ast/sexp.scm 118 */
																																																					bool_t
																																																						BgL_test8490z00_16763;
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_arg3050z00_3530;
																																																						BgL_arg3050z00_3530
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test8490z00_16763
																																																							=
																																																							CBOOL
																																																							(BGl_letzd2symzf3z21zzast_letz00
																																																							(BgL_arg3050z00_3530));
																																																					}
																																																					if (BgL_test8490z00_16763)
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_arg3033z00_3516;
																																																							obj_t
																																																								BgL_arg3035z00_3517;
																																																							BgL_arg3033z00_3516
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd28668zd2_3513));
																																																							BgL_arg3035z00_3517
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd28668zd2_3513));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_16772;
																																																								{
																																																									obj_t
																																																										BgL_exprz00_16774;
																																																									obj_t
																																																										BgL_bindingsz00_16773;
																																																									BgL_bindingsz00_16773
																																																										=
																																																										BgL_arg3033z00_3516;
																																																									BgL_exprz00_16774
																																																										=
																																																										BgL_arg3035z00_3517;
																																																									BgL_exprz00_1729
																																																										=
																																																										BgL_exprz00_16774;
																																																									BgL_bindingsz00_1728
																																																										=
																																																										BgL_bindingsz00_16773;
																																																									goto
																																																										BgL_tagzd2382zd2_1730;
																																																								}
																																																								BgL_auxz00_14205
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_16772);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							bool_t
																																																								BgL_test8491z00_16776;
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_arg3049z00_3529;
																																																								BgL_arg3049z00_3529
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test8491z00_16776
																																																									=
																																																									CBOOL
																																																									(BGl_labelszd2symzf3z21zzast_labelsz00
																																																									(BgL_arg3049z00_3529));
																																																							}
																																																							if (BgL_test8491z00_16776)
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_16781;
																																																									goto
																																																										BgL_tagzd2384zd2_1732;
																																																									BgL_auxz00_14205
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_16781);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_carzd28734zd2_3520;
																																																									BgL_carzd28734zd2_3520
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_cdrzd28739zd2_3521;
																																																										BgL_cdrzd28739zd2_3521
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_carzd28734zd2_3520));
																																																										if ((CAR(((obj_t) BgL_carzd28734zd2_3520)) == CNST_TABLE_REF(((long) 3))))
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_arg3040z00_3524;
																																																												obj_t
																																																													BgL_arg3043z00_3525;
																																																												obj_t
																																																													BgL_arg3044z00_3526;
																																																												BgL_arg3040z00_3524
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_cdrzd28739zd2_3521));
																																																												BgL_arg3043z00_3525
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_cdrzd28739zd2_3521));
																																																												BgL_arg3044z00_3526
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_16798;
																																																													{
																																																														obj_t
																																																															BgL_argsz00_16801;
																																																														obj_t
																																																															BgL_bodyz00_16800;
																																																														obj_t
																																																															BgL_varsz00_16799;
																																																														BgL_varsz00_16799
																																																															=
																																																															BgL_arg3040z00_3524;
																																																														BgL_bodyz00_16800
																																																															=
																																																															BgL_arg3043z00_3525;
																																																														BgL_argsz00_16801
																																																															=
																																																															BgL_arg3044z00_3526;
																																																														BgL_argsz00_1739
																																																															=
																																																															BgL_argsz00_16801;
																																																														BgL_bodyz00_1738
																																																															=
																																																															BgL_bodyz00_16800;
																																																														BgL_varsz00_1737
																																																															=
																																																															BgL_varsz00_16799;
																																																														goto
																																																															BgL_tagzd2386zd2_1740;
																																																													}
																																																													BgL_auxz00_14205
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_16798);
																																																												}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 118 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{	/* Ast/sexp.scm 118 */
																																																														goto
																																																															BgL_tagzd2403zd2_1774;
																																																													}
																																																												else
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_16805;
																																																														goto
																																																															BgL_tagzd2404zd2_1775;
																																																														BgL_auxz00_14205
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_16805);
																																																													}
																																																											}
																																																									}
																																																								}
																																																						}
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_cdrzd28850zd2_3531;
																																																		BgL_cdrzd28850zd2_3531
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 118 */
																																																			bool_t
																																																				BgL_test8494z00_16809;
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_arg3069z00_3540;
																																																				BgL_arg3069z00_3540
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test8494z00_16809
																																																					=
																																																					CBOOL
																																																					(BGl_letzd2symzf3z21zzast_letz00
																																																					(BgL_arg3069z00_3540));
																																																			}
																																																			if (BgL_test8494z00_16809)
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_arg3059z00_3534;
																																																					obj_t
																																																						BgL_arg3060z00_3535;
																																																					BgL_arg3059z00_3534
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd28850zd2_3531));
																																																					BgL_arg3060z00_3535
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd28850zd2_3531));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_16818;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_16820;
																																																							obj_t
																																																								BgL_bindingsz00_16819;
																																																							BgL_bindingsz00_16819
																																																								=
																																																								BgL_arg3059z00_3534;
																																																							BgL_exprz00_16820
																																																								=
																																																								BgL_arg3060z00_3535;
																																																							BgL_exprz00_1729
																																																								=
																																																								BgL_exprz00_16820;
																																																							BgL_bindingsz00_1728
																																																								=
																																																								BgL_bindingsz00_16819;
																																																							goto
																																																								BgL_tagzd2382zd2_1730;
																																																						}
																																																						BgL_auxz00_14205
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_16818);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					bool_t
																																																						BgL_test8495z00_16822;
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_arg3066z00_3539;
																																																						BgL_arg3066z00_3539
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test8495z00_16822
																																																							=
																																																							CBOOL
																																																							(BGl_labelszd2symzf3z21zzast_labelsz00
																																																							(BgL_arg3066z00_3539));
																																																					}
																																																					if (BgL_test8495z00_16822)
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_16827;
																																																							goto
																																																								BgL_tagzd2384zd2_1732;
																																																							BgL_auxz00_14205
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_16827);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																								{	/* Ast/sexp.scm 118 */
																																																									goto
																																																										BgL_tagzd2403zd2_1774;
																																																								}
																																																							else
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_16831;
																																																									goto
																																																										BgL_tagzd2404zd2_1775;
																																																									BgL_auxz00_14205
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_16831);
																																																								}
																																																						}
																																																				}
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd27415zd2_3267)))
																																																	{	/* Ast/sexp.scm 118 */
																																																		goto
																																																			BgL_kapzd27417zd2_3269;
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		if ((BgL_carzd27415zd2_3267 == CNST_TABLE_REF(((long) 18))))
																																																			{	/* Ast/sexp.scm 118 */
																																																				goto
																																																					BgL_kapzd27417zd2_3269;
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 118 */
																																																				if ((BgL_carzd27415zd2_3267 == CNST_TABLE_REF(((long) 19))))
																																																					{	/* Ast/sexp.scm 118 */
																																																						goto
																																																							BgL_kapzd27417zd2_3269;
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 118 */
																																																						if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd27415zd2_3267)))
																																																							{	/* Ast/sexp.scm 118 */
																																																								goto
																																																									BgL_kapzd27417zd2_3269;
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_cdrzd29022zd2_3275;
																																																								BgL_cdrzd29022zd2_3275
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{	/* Ast/sexp.scm 118 */
																																																									bool_t
																																																										BgL_test8501z00_16847;
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_arg2933z00_3392;
																																																										BgL_arg2933z00_3392
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_test8501z00_16847
																																																											=
																																																											CBOOL
																																																											(BGl_letzd2symzf3z21zzast_letz00
																																																											(BgL_arg2933z00_3392));
																																																									}
																																																									if (BgL_test8501z00_16847)
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_arg2822z00_3278;
																																																											obj_t
																																																												BgL_arg2824z00_3279;
																																																											BgL_arg2822z00_3278
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_cdrzd29022zd2_3275));
																																																											BgL_arg2824z00_3279
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd29022zd2_3275));
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_16856;
																																																												{
																																																													obj_t
																																																														BgL_exprz00_16858;
																																																													obj_t
																																																														BgL_bindingsz00_16857;
																																																													BgL_bindingsz00_16857
																																																														=
																																																														BgL_arg2822z00_3278;
																																																													BgL_exprz00_16858
																																																														=
																																																														BgL_arg2824z00_3279;
																																																													BgL_exprz00_1729
																																																														=
																																																														BgL_exprz00_16858;
																																																													BgL_bindingsz00_1728
																																																														=
																																																														BgL_bindingsz00_16857;
																																																													goto
																																																														BgL_tagzd2382zd2_1730;
																																																												}
																																																												BgL_auxz00_14205
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_16856);
																																																											}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											bool_t
																																																												BgL_test8502z00_16860;
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_arg2914z00_3391;
																																																												BgL_arg2914z00_3391
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												BgL_test8502z00_16860
																																																													=
																																																													CBOOL
																																																													(BGl_labelszd2symzf3z21zzast_labelsz00
																																																													(BgL_arg2914z00_3391));
																																																											}
																																																											if (BgL_test8502z00_16860)
																																																												{
																																																													BgL_letzd2funzd2_bglt
																																																														BgL_auxz00_16865;
																																																													goto
																																																														BgL_tagzd2384zd2_1732;
																																																													BgL_auxz00_14205
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_16865);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_carzd29088zd2_3282;
																																																													BgL_carzd29088zd2_3282
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_cdrzd29093zd2_3283;
																																																														BgL_cdrzd29093zd2_3283
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_carzd29088zd2_3282));
																																																														if ((CAR(((obj_t) BgL_carzd29088zd2_3282)) == CNST_TABLE_REF(((long) 3))))
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (PAIRP(BgL_cdrzd29093zd2_3283))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_arg2843z00_3287;
																																																																		obj_t
																																																																			BgL_arg2844z00_3288;
																																																																		obj_t
																																																																			BgL_arg2845z00_3289;
																																																																		BgL_arg2843z00_3287
																																																																			=
																																																																			CAR
																																																																			(BgL_cdrzd29093zd2_3283);
																																																																		BgL_arg2844z00_3288
																																																																			=
																																																																			CDR
																																																																			(BgL_cdrzd29093zd2_3283);
																																																																		BgL_arg2845z00_3289
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_16882;
																																																																			{
																																																																				obj_t
																																																																					BgL_argsz00_16885;
																																																																				obj_t
																																																																					BgL_bodyz00_16884;
																																																																				obj_t
																																																																					BgL_varsz00_16883;
																																																																				BgL_varsz00_16883
																																																																					=
																																																																					BgL_arg2843z00_3287;
																																																																				BgL_bodyz00_16884
																																																																					=
																																																																					BgL_arg2844z00_3288;
																																																																				BgL_argsz00_16885
																																																																					=
																																																																					BgL_arg2845z00_3289;
																																																																				BgL_argsz00_1739
																																																																					=
																																																																					BgL_argsz00_16885;
																																																																				BgL_bodyz00_1738
																																																																					=
																																																																					BgL_bodyz00_16884;
																																																																				BgL_varsz00_1737
																																																																					=
																																																																					BgL_varsz00_16883;
																																																																				goto
																																																																					BgL_tagzd2386zd2_1740;
																																																																			}
																																																																			BgL_auxz00_14205
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_16882);
																																																																		}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1774;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_16889;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1775;
																																																																				BgL_auxz00_14205
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_16889);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_cdrzd29200zd2_3292;
																																																																BgL_cdrzd29200zd2_3292
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd29205zd2_3293;
																																																																	BgL_cdrzd29205zd2_3293
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_carzd29088zd2_3282));
																																																																	if ((CAR(((obj_t) BgL_carzd29088zd2_3282)) == CNST_TABLE_REF(((long) 1))))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if (PAIRP(BgL_cdrzd29205zd2_3293))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_cdrzd29210zd2_3297;
																																																																					BgL_cdrzd29210zd2_3297
																																																																						=
																																																																						CDR
																																																																						(BgL_cdrzd29205zd2_3293);
																																																																					if (PAIRP(BgL_cdrzd29210zd2_3297))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_carzd29214zd2_3299;
																																																																							obj_t
																																																																								BgL_cdrzd29215zd2_3300;
																																																																							BgL_carzd29214zd2_3299
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd29210zd2_3297);
																																																																							BgL_cdrzd29215zd2_3300
																																																																								=
																																																																								CDR
																																																																								(BgL_cdrzd29210zd2_3297);
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd29214zd2_3299))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (PAIRP(BgL_cdrzd29215zd2_3300))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_carzd29220zd2_3303;
																																																																											BgL_carzd29220zd2_3303
																																																																												=
																																																																												CAR
																																																																												(BgL_cdrzd29215zd2_3300);
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd29220zd2_3303))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (NULLP(CDR(BgL_cdrzd29215zd2_3300)))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															bool_t
																																																																																BgL_test8513z00_16917;
																																																																															{
																																																																																obj_t
																																																																																	BgL_l1379z00_3336;
																																																																																BgL_l1379z00_3336
																																																																																	=
																																																																																	BgL_cdrzd29200zd2_3292;
																																																																															BgL_zc3z04anonymousza32874ze3z87_3337:
																																																																																if (NULLP(BgL_l1379z00_3336))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		BgL_test8513z00_16917
																																																																																			=
																																																																																			(
																																																																																			(bool_t)
																																																																																			1);
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		bool_t
																																																																																			BgL_test8515z00_16920;
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			bool_t
																																																																																				BgL_test8516z00_16921;
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				obj_t
																																																																																					BgL_tmpz00_16922;
																																																																																				BgL_tmpz00_16922
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_l1379z00_3336));
																																																																																				BgL_test8516z00_16921
																																																																																					=
																																																																																					PAIRP
																																																																																					(BgL_tmpz00_16922);
																																																																																			}
																																																																																			if (BgL_test8516z00_16921)
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					BgL_test8515z00_16920
																																																																																						=
																																																																																						(
																																																																																						(bool_t)
																																																																																						0);
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					BgL_test8515z00_16920
																																																																																						=
																																																																																						(
																																																																																						(bool_t)
																																																																																						1);
																																																																																				}
																																																																																		}
																																																																																		if (BgL_test8515z00_16920)
																																																																																			{
																																																																																				obj_t
																																																																																					BgL_l1379z00_16926;
																																																																																				BgL_l1379z00_16926
																																																																																					=
																																																																																					CDR
																																																																																					(
																																																																																					((obj_t) BgL_l1379z00_3336));
																																																																																				BgL_l1379z00_3336
																																																																																					=
																																																																																					BgL_l1379z00_16926;
																																																																																				goto
																																																																																					BgL_zc3z04anonymousza32874ze3z87_3337;
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				BgL_test8513z00_16917
																																																																																					=
																																																																																					(
																																																																																					(bool_t)
																																																																																					0);
																																																																																			}
																																																																																	}
																																																																															}
																																																																															if (BgL_test8513z00_16917)
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_arg2863z00_3319;
																																																																																	BgL_arg2863z00_3319
																																																																																		=
																																																																																		CAR
																																																																																		(BgL_cdrzd29205zd2_3293);
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_16930;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_16934;
																																																																																			obj_t
																																																																																				BgL_proc2z00_16933;
																																																																																			obj_t
																																																																																				BgL_proc1z00_16932;
																																																																																			obj_t
																																																																																				BgL_testz00_16931;
																																																																																			BgL_testz00_16931
																																																																																				=
																																																																																				BgL_arg2863z00_3319;
																																																																																			BgL_proc1z00_16932
																																																																																				=
																																																																																				BgL_carzd29214zd2_3299;
																																																																																			BgL_proc2z00_16933
																																																																																				=
																																																																																				BgL_carzd29220zd2_3303;
																																																																																			BgL_argsz00_16934
																																																																																				=
																																																																																				BgL_cdrzd29200zd2_3292;
																																																																																			BgL_argsz00_1744
																																																																																				=
																																																																																				BgL_argsz00_16934;
																																																																																			BgL_proc2z00_1743
																																																																																				=
																																																																																				BgL_proc2z00_16933;
																																																																																			BgL_proc1z00_1742
																																																																																				=
																																																																																				BgL_proc1z00_16932;
																																																																																			BgL_testz00_1741
																																																																																				=
																																																																																				BgL_testz00_16931;
																																																																																			goto
																																																																																				BgL_tagzd2387zd2_1745;
																																																																																		}
																																																																																		BgL_auxz00_14205
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_16930);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_cdrzd29245zd2_3320;
																																																																																	BgL_cdrzd29245zd2_3320
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_expz00_21));
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		obj_t
																																																																																			BgL_cdrzd29253zd2_3321;
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			obj_t
																																																																																				BgL_pairz00_10554;
																																																																																			BgL_pairz00_10554
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_expz00_21));
																																																																																			BgL_cdrzd29253zd2_3321
																																																																																				=
																																																																																				CDR
																																																																																				(BgL_pairz00_10554);
																																																																																		}
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			obj_t
																																																																																				BgL_cdrzd29261zd2_3322;
																																																																																			BgL_cdrzd29261zd2_3322
																																																																																				=
																																																																																				CDR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd29253zd2_3321));
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				obj_t
																																																																																					BgL_carzd29268zd2_3323;
																																																																																				BgL_carzd29268zd2_3323
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd29261zd2_3322));
																																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd29268zd2_3323))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						obj_t
																																																																																							BgL_carzd29277zd2_3325;
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							obj_t
																																																																																								BgL_pairz00_10558;
																																																																																							BgL_pairz00_10558
																																																																																								=
																																																																																								CDR
																																																																																								(
																																																																																								((obj_t) BgL_cdrzd29261zd2_3322));
																																																																																							BgL_carzd29277zd2_3325
																																																																																								=
																																																																																								CAR
																																																																																								(BgL_pairz00_10558);
																																																																																						}
																																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd29277zd2_3325))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd29245zd2_3320))
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										obj_t
																																																																																											BgL_arg2867z00_3328;
																																																																																										BgL_arg2867z00_3328
																																																																																											=
																																																																																											CAR
																																																																																											(
																																																																																											((obj_t) BgL_cdrzd29253zd2_3321));
																																																																																										{
																																																																																											BgL_nodez00_bglt
																																																																																												BgL_auxz00_16956;
																																																																																											{
																																																																																												obj_t
																																																																																													BgL_argsz00_16960;
																																																																																												obj_t
																																																																																													BgL_proc2z00_16959;
																																																																																												obj_t
																																																																																													BgL_proc1z00_16958;
																																																																																												obj_t
																																																																																													BgL_testz00_16957;
																																																																																												BgL_testz00_16957
																																																																																													=
																																																																																													BgL_arg2867z00_3328;
																																																																																												BgL_proc1z00_16958
																																																																																													=
																																																																																													BgL_carzd29268zd2_3323;
																																																																																												BgL_proc2z00_16959
																																																																																													=
																																																																																													BgL_carzd29277zd2_3325;
																																																																																												BgL_argsz00_16960
																																																																																													=
																																																																																													BgL_cdrzd29245zd2_3320;
																																																																																												BgL_argsz00_1749
																																																																																													=
																																																																																													BgL_argsz00_16960;
																																																																																												BgL_proc2z00_1748
																																																																																													=
																																																																																													BgL_proc2z00_16959;
																																																																																												BgL_proc1z00_1747
																																																																																													=
																																																																																													BgL_proc1z00_16958;
																																																																																												BgL_testz00_1746
																																																																																													=
																																																																																													BgL_testz00_16957;
																																																																																												goto
																																																																																													BgL_tagzd2388zd2_1750;
																																																																																											}
																																																																																											BgL_auxz00_14205
																																																																																												=
																																																																																												(
																																																																																												(obj_t)
																																																																																												BgL_auxz00_16956);
																																																																																										}
																																																																																									}
																																																																																								else
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																											{	/* Ast/sexp.scm 118 */
																																																																																												goto
																																																																																													BgL_tagzd2403zd2_1774;
																																																																																											}
																																																																																										else
																																																																																											{
																																																																																												BgL_nodez00_bglt
																																																																																													BgL_auxz00_16964;
																																																																																												goto
																																																																																													BgL_tagzd2404zd2_1775;
																																																																																												BgL_auxz00_14205
																																																																																													=
																																																																																													(
																																																																																													(obj_t)
																																																																																													BgL_auxz00_16964);
																																																																																											}
																																																																																									}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1774;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_16968;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1775;
																																																																																										BgL_auxz00_14205
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_16968);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1774;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_16972;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1775;
																																																																																								BgL_auxz00_14205
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_16972);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		}
																																																																																	}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1774;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_16976;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1775;
																																																																																	BgL_auxz00_14205
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_16976);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_cdrzd29555zd2_3347;
																																																																													BgL_cdrzd29555zd2_3347
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_cdrzd29562zd2_3348;
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_pairz00_10562;
																																																																															BgL_pairz00_10562
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															BgL_cdrzd29562zd2_3348
																																																																																=
																																																																																CDR
																																																																																(BgL_pairz00_10562);
																																																																														}
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_cdrzd29569zd2_3349;
																																																																															BgL_cdrzd29569zd2_3349
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_cdrzd29562zd2_3348));
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_carzd29575zd2_3350;
																																																																																obj_t
																																																																																	BgL_cdrzd29576zd2_3351;
																																																																																BgL_carzd29575zd2_3350
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd29569zd2_3349));
																																																																																BgL_cdrzd29576zd2_3351
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd29569zd2_3349));
																																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd29575zd2_3350))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		obj_t
																																																																																			BgL_carzd29583zd2_3353;
																																																																																		BgL_carzd29583zd2_3353
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd29576zd2_3351));
																																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd29583zd2_3353))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (NULLP(CDR(((obj_t) BgL_cdrzd29576zd2_3351))))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd29555zd2_3347))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								obj_t
																																																																																									BgL_arg2884z00_3358;
																																																																																								BgL_arg2884z00_3358
																																																																																									=
																																																																																									CAR
																																																																																									(
																																																																																									((obj_t) BgL_cdrzd29562zd2_3348));
																																																																																								{
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_auxz00_17003;
																																																																																									{
																																																																																										obj_t
																																																																																											BgL_argsz00_17007;
																																																																																										obj_t
																																																																																											BgL_proc2z00_17006;
																																																																																										obj_t
																																																																																											BgL_proc1z00_17005;
																																																																																										obj_t
																																																																																											BgL_testz00_17004;
																																																																																										BgL_testz00_17004
																																																																																											=
																																																																																											BgL_arg2884z00_3358;
																																																																																										BgL_proc1z00_17005
																																																																																											=
																																																																																											BgL_carzd29575zd2_3350;
																																																																																										BgL_proc2z00_17006
																																																																																											=
																																																																																											BgL_carzd29583zd2_3353;
																																																																																										BgL_argsz00_17007
																																																																																											=
																																																																																											BgL_cdrzd29555zd2_3347;
																																																																																										BgL_argsz00_1749
																																																																																											=
																																																																																											BgL_argsz00_17007;
																																																																																										BgL_proc2z00_1748
																																																																																											=
																																																																																											BgL_proc2z00_17006;
																																																																																										BgL_proc1z00_1747
																																																																																											=
																																																																																											BgL_proc1z00_17005;
																																																																																										BgL_testz00_1746
																																																																																											=
																																																																																											BgL_testz00_17004;
																																																																																										goto
																																																																																											BgL_tagzd2388zd2_1750;
																																																																																									}
																																																																																									BgL_auxz00_14205
																																																																																										=
																																																																																										(
																																																																																										(obj_t)
																																																																																										BgL_auxz00_17003);
																																																																																								}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1774;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_17011;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1775;
																																																																																										BgL_auxz00_14205
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_17011);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1774;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_17015;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1775;
																																																																																								BgL_auxz00_14205
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_17015);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1774;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_17019;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1775;
																																																																																						BgL_auxz00_14205
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_17019);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1774;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_17023;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1775;
																																																																																				BgL_auxz00_14205
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_17023);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														}
																																																																													}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1774;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_17027;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1775;
																																																																													BgL_auxz00_14205
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_17027);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_cdrzd29916zd2_3366;
																																																																									BgL_cdrzd29916zd2_3366
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_cdrzd29922zd2_3367;
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_pairz00_10572;
																																																																											BgL_pairz00_10572
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											BgL_cdrzd29922zd2_3367
																																																																												=
																																																																												CDR
																																																																												(BgL_pairz00_10572);
																																																																										}
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_cdrzd29928zd2_3368;
																																																																											BgL_cdrzd29928zd2_3368
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd29922zd2_3367));
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_carzd29933zd2_3369;
																																																																												obj_t
																																																																													BgL_cdrzd29934zd2_3370;
																																																																												BgL_carzd29933zd2_3369
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd29928zd2_3368));
																																																																												BgL_cdrzd29934zd2_3370
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd29928zd2_3368));
																																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd29933zd2_3369))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														if (PAIRP(BgL_cdrzd29934zd2_3370))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_carzd29939zd2_3373;
																																																																																BgL_carzd29939zd2_3373
																																																																																	=
																																																																																	CAR
																																																																																	(BgL_cdrzd29934zd2_3370);
																																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd29939zd2_3373))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (NULLP(CDR(BgL_cdrzd29934zd2_3370)))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd29916zd2_3366))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						obj_t
																																																																																							BgL_arg2901z00_3378;
																																																																																						BgL_arg2901z00_3378
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_cdrzd29922zd2_3367));
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_17054;
																																																																																							{
																																																																																								obj_t
																																																																																									BgL_argsz00_17058;
																																																																																								obj_t
																																																																																									BgL_proc2z00_17057;
																																																																																								obj_t
																																																																																									BgL_proc1z00_17056;
																																																																																								obj_t
																																																																																									BgL_testz00_17055;
																																																																																								BgL_testz00_17055
																																																																																									=
																																																																																									BgL_arg2901z00_3378;
																																																																																								BgL_proc1z00_17056
																																																																																									=
																																																																																									BgL_carzd29933zd2_3369;
																																																																																								BgL_proc2z00_17057
																																																																																									=
																																																																																									BgL_carzd29939zd2_3373;
																																																																																								BgL_argsz00_17058
																																																																																									=
																																																																																									BgL_cdrzd29916zd2_3366;
																																																																																								BgL_argsz00_1749
																																																																																									=
																																																																																									BgL_argsz00_17058;
																																																																																								BgL_proc2z00_1748
																																																																																									=
																																																																																									BgL_proc2z00_17057;
																																																																																								BgL_proc1z00_1747
																																																																																									=
																																																																																									BgL_proc1z00_17056;
																																																																																								BgL_testz00_1746
																																																																																									=
																																																																																									BgL_testz00_17055;
																																																																																								goto
																																																																																									BgL_tagzd2388zd2_1750;
																																																																																							}
																																																																																							BgL_auxz00_14205
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_17054);
																																																																																						}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1774;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_17062;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1775;
																																																																																								BgL_auxz00_14205
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_17062);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1774;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_17066;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1775;
																																																																																						BgL_auxz00_14205
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_17066);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1774;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_17070;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1775;
																																																																																				BgL_auxz00_14205
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_17070);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1774;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_17074;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1775;
																																																																																		BgL_auxz00_14205
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_17074);
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1774;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_17078;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1775;
																																																																																BgL_auxz00_14205
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_17078);
																																																																															}
																																																																													}
																																																																											}
																																																																										}
																																																																									}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1774;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_17082;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1775;
																																																																									BgL_auxz00_14205
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_17082);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1774;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_17086;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1775;
																																																																							BgL_auxz00_14205
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_17086);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1774;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_17090;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1775;
																																																																					BgL_auxz00_14205
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_17090);
																																																																				}
																																																																		}
																																																																}
																																																															}
																																																													}
																																																												}
																																																										}
																																																								}
																																																							}
																																																					}
																																																			}
																																																	}
																																															}
																																													}
																																												}
																																											else
																																												{	/* Ast/sexp.scm 118 */
																																													obj_t
																																														BgL_cdrzd210477zd2_3542;
																																													BgL_cdrzd210477zd2_3542
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													if ((BgL_carzd27412zd2_3265 == CNST_TABLE_REF(((long) 17))))
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_arg3071z00_3544;
																																															obj_t
																																																BgL_arg3072z00_3545;
																																															BgL_arg3071z00_3544
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd210477zd2_3542));
																																															BgL_arg3072z00_3545
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd210477zd2_3542));
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_17101;
																																																{
																																																	obj_t
																																																		BgL_exprz00_17103;
																																																	obj_t
																																																		BgL_bindingsz00_17102;
																																																	BgL_bindingsz00_17102
																																																		=
																																																		BgL_arg3071z00_3544;
																																																	BgL_exprz00_17103
																																																		=
																																																		BgL_arg3072z00_3545;
																																																	BgL_exprz00_1729
																																																		=
																																																		BgL_exprz00_17103;
																																																	BgL_bindingsz00_1728
																																																		=
																																																		BgL_bindingsz00_17102;
																																																	goto
																																																		BgL_tagzd2382zd2_1730;
																																																}
																																																BgL_auxz00_14205
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_17101);
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 118 */
																																															if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd27412zd2_3265)))
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_arg3075z00_3547;
																																																	obj_t
																																																		BgL_arg3076z00_3548;
																																																	BgL_arg3075z00_3547
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd210477zd2_3542));
																																																	BgL_arg3076z00_3548
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd210477zd2_3542));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_17112;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_17114;
																																																			obj_t
																																																				BgL_bindingsz00_17113;
																																																			BgL_bindingsz00_17113
																																																				=
																																																				BgL_arg3075z00_3547;
																																																			BgL_exprz00_17114
																																																				=
																																																				BgL_arg3076z00_3548;
																																																			BgL_exprz00_1729
																																																				=
																																																				BgL_exprz00_17114;
																																																			BgL_bindingsz00_1728
																																																				=
																																																				BgL_bindingsz00_17113;
																																																			goto
																																																				BgL_tagzd2382zd2_1730;
																																																		}
																																																		BgL_auxz00_14205
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_17112);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	if ((BgL_carzd27412zd2_3265 == CNST_TABLE_REF(((long) 18))))
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_arg3078z00_3550;
																																																			obj_t
																																																				BgL_arg3079z00_3551;
																																																			BgL_arg3078z00_3550
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd210477zd2_3542));
																																																			BgL_arg3079z00_3551
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd210477zd2_3542));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_17123;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_17125;
																																																					obj_t
																																																						BgL_bindingsz00_17124;
																																																					BgL_bindingsz00_17124
																																																						=
																																																						BgL_arg3078z00_3550;
																																																					BgL_exprz00_17125
																																																						=
																																																						BgL_arg3079z00_3551;
																																																					BgL_exprz00_1729
																																																						=
																																																						BgL_exprz00_17125;
																																																					BgL_bindingsz00_1728
																																																						=
																																																						BgL_bindingsz00_17124;
																																																					goto
																																																						BgL_tagzd2382zd2_1730;
																																																				}
																																																				BgL_auxz00_14205
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_17123);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_17132;
																																																					goto
																																																						BgL_tagzd2383zd2_1731;
																																																					BgL_auxz00_14205
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_17132);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_carzd210514zd2_3554;
																																																					BgL_carzd210514zd2_3554
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					if ((BgL_carzd210514zd2_3554 == CNST_TABLE_REF(((long) 19))))
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_17139;
																																																							goto
																																																								BgL_tagzd2384zd2_1732;
																																																							BgL_auxz00_14205
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_17139);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd210514zd2_3554)))
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_17144;
																																																									goto
																																																										BgL_tagzd2384zd2_1732;
																																																									BgL_auxz00_14205
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_17144);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_17151;
																																																											goto
																																																												BgL_tagzd2389zd2_1751;
																																																											BgL_auxz00_14205
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_17151);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_17158;
																																																													goto
																																																														BgL_tagzd2390zd2_1752;
																																																													BgL_auxz00_14205
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_17158);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_cdrzd210594zd2_3561;
																																																													BgL_cdrzd210594zd2_3561
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_arg3092z00_3564;
																																																															obj_t
																																																																BgL_arg3093z00_3565;
																																																															BgL_arg3092z00_3564
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_cdrzd210594zd2_3561));
																																																															BgL_arg3093z00_3565
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd210594zd2_3561));
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_17171;
																																																																{
																																																																	obj_t
																																																																		BgL_restz00_17173;
																																																																	obj_t
																																																																		BgL_effectz00_17172;
																																																																	BgL_effectz00_17172
																																																																		=
																																																																		BgL_arg3092z00_3564;
																																																																	BgL_restz00_17173
																																																																		=
																																																																		BgL_arg3093z00_3565;
																																																																	BgL_restz00_1754
																																																																		=
																																																																		BgL_restz00_17173;
																																																																	BgL_effectz00_1753
																																																																		=
																																																																		BgL_effectz00_17172;
																																																																	goto
																																																																		BgL_tagzd2391zd2_1755;
																																																																}
																																																																BgL_auxz00_14205
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_17171);
																																																															}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_17180;
																																																																	goto
																																																																		BgL_tagzd2392zd2_1756;
																																																																	BgL_auxz00_14205
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_17180);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_17187;
																																																																			goto
																																																																				BgL_tagzd2393zd2_1757;
																																																																			BgL_auxz00_14205
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_17187);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_arg3113z00_3573;
																																																																					obj_t
																																																																						BgL_arg3114z00_3574;
																																																																					BgL_arg3113z00_3573
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd210594zd2_3561));
																																																																					BgL_arg3114z00_3574
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd210594zd2_3561));
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_17198;
																																																																						{
																																																																							obj_t
																																																																								BgL_restz00_17200;
																																																																							obj_t
																																																																								BgL_effectz00_17199;
																																																																							BgL_effectz00_17199
																																																																								=
																																																																								BgL_arg3113z00_3573;
																																																																							BgL_restz00_17200
																																																																								=
																																																																								BgL_arg3114z00_3574;
																																																																							BgL_restz00_1759
																																																																								=
																																																																								BgL_restz00_17200;
																																																																							BgL_effectz00_1758
																																																																								=
																																																																								BgL_effectz00_17199;
																																																																							goto
																																																																								BgL_tagzd2394zd2_1760;
																																																																						}
																																																																						BgL_auxz00_14205
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_17198);
																																																																					}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_17207;
																																																																							goto
																																																																								BgL_tagzd2395zd2_1761;
																																																																							BgL_auxz00_14205
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_17207);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_17214;
																																																																									goto
																																																																										BgL_tagzd2396zd2_1762;
																																																																									BgL_auxz00_14205
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_17214);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																										{
																																																																											BgL_letzd2funzd2_bglt
																																																																												BgL_auxz00_17221;
																																																																											goto
																																																																												BgL_tagzd2397zd2_1763;
																																																																											BgL_auxz00_14205
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_17221);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																												{
																																																																													BgL_jumpzd2exzd2itz00_bglt
																																																																														BgL_auxz00_17228;
																																																																													goto
																																																																														BgL_tagzd2398zd2_1764;
																																																																													BgL_auxz00_14205
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_17228);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_cdrzd210671zd2_3583;
																																																																													BgL_cdrzd210671zd2_3583
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_arg3133z00_3586;
																																																																															obj_t
																																																																																BgL_arg3134z00_3587;
																																																																															BgL_arg3133z00_3586
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd210671zd2_3583));
																																																																															BgL_arg3134z00_3587
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_cdrzd210671zd2_3583));
																																																																															{	/* Ast/sexp.scm 551 */
																																																																																obj_t
																																																																																	BgL_arg6989z00_10611;
																																																																																BgL_arg6989z00_10611
																																																																																	=
																																																																																	BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																	(BgL_expz00_21,
																																																																																	BgL_locz00_23);
																																																																																BgL_auxz00_14205
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																	(BgL_expz00_21,
																																																																																		BgL_arg3133z00_3586,
																																																																																		CNST_TABLE_REF
																																																																																		(((long) 4)), BgL_arg3134z00_3587, BgL_stackz00_22, BgL_arg6989z00_10611, BgL_sitez00_24));
																																																																														}}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1774;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_17247;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1775;
																																																																																	BgL_auxz00_14205
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_17247);
																																																																																}
																																																																														}
																																																																												}
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																															else
																																{	/* Ast/sexp.scm 118 */
																																	obj_t
																																		BgL_carzd210696zd2_3604;
																																	BgL_carzd210696zd2_3604
																																		=
																																		CAR(((obj_t)
																																			BgL_expz00_21));
																																	if (
																																		(BgL_carzd210696zd2_3604
																																			==
																																			CNST_TABLE_REF
																																			(((long)
																																					1))))
																																		{
																																			BgL_nodez00_bglt
																																				BgL_auxz00_17254;
																																			goto
																																				BgL_tagzd2377zd2_1719;
																																			BgL_auxz00_14205
																																				=
																																				((obj_t)
																																				BgL_auxz00_17254);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 118 */
																																			if (
																																				(BgL_carzd210696zd2_3604
																																					==
																																					BGl_za2ifza2z00zzast_sexpz00))
																																				{
																																					BgL_nodez00_bglt
																																						BgL_auxz00_17258;
																																					goto
																																						BgL_tagzd2377zd2_1719;
																																					BgL_auxz00_14205
																																						=
																																						(
																																						(obj_t)
																																						BgL_auxz00_17258);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 118 */
																																					obj_t
																																						BgL_cdrzd210718zd2_3607;
																																					BgL_cdrzd210718zd2_3607
																																						=
																																						CDR(
																																						((obj_t) BgL_expz00_21));
																																					if (
																																						(CAR
																																							(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 7))))
																																						{	/* Ast/sexp.scm 118 */
																																							obj_t
																																								BgL_carzd210721zd2_3610;
																																							obj_t
																																								BgL_cdrzd210722zd2_3611;
																																							BgL_carzd210721zd2_3610
																																								=
																																								CAR
																																								(
																																								((obj_t) BgL_cdrzd210718zd2_3607));
																																							BgL_cdrzd210722zd2_3611
																																								=
																																								CDR
																																								(
																																								((obj_t) BgL_cdrzd210718zd2_3607));
																																							if (PAIRP(BgL_carzd210721zd2_3610))
																																								{	/* Ast/sexp.scm 118 */
																																									if ((CAR(BgL_carzd210721zd2_3610) == CNST_TABLE_REF(((long) 14))))
																																										{	/* Ast/sexp.scm 118 */
																																											if (NULLP(CDR(((obj_t) BgL_cdrzd210722zd2_3611))))
																																												{	/* Ast/sexp.scm 118 */
																																													obj_t
																																														BgL_arg3170z00_3617;
																																													obj_t
																																														BgL_arg3171z00_3618;
																																													BgL_arg3170z00_3617
																																														=
																																														CDR
																																														(BgL_carzd210721zd2_3610);
																																													BgL_arg3171z00_3618
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_cdrzd210722zd2_3611));
																																													{
																																														BgL_nodez00_bglt
																																															BgL_auxz00_17284;
																																														BgL_lz00_1720
																																															=
																																															BgL_arg3170z00_3617;
																																														BgL_valz00_1721
																																															=
																																															BgL_arg3171z00_3618;
																																													BgL_tagzd2378zd2_1722:
																																														{	/* Ast/sexp.scm 285 */
																																															bool_t
																																																BgL_test8570z00_17285;
																																															if (PAIRP(BgL_lz00_1720))
																																																{	/* Ast/sexp.scm 285 */
																																																	bool_t
																																																		BgL_test8572z00_17288;
																																																	{	/* Ast/sexp.scm 285 */
																																																		obj_t
																																																			BgL_tmpz00_17289;
																																																		BgL_tmpz00_17289
																																																			=
																																																			CDR
																																																			(BgL_lz00_1720);
																																																		BgL_test8572z00_17288
																																																			=
																																																			PAIRP
																																																			(BgL_tmpz00_17289);
																																																	}
																																																	if (BgL_test8572z00_17288)
																																																		{
																																																			obj_t
																																																				BgL_l1348z00_8576;
																																																			BgL_l1348z00_8576
																																																				=
																																																				BgL_lz00_1720;
																																																		BgL_zc3z04anonymousza36742ze3z87_8577:
																																																			if (NULLP(BgL_l1348z00_8576))
																																																				{	/* Ast/sexp.scm 285 */
																																																					BgL_test8570z00_17285
																																																						=
																																																						(
																																																						(bool_t)
																																																						1);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 285 */
																																																					bool_t
																																																						BgL_test8574z00_17294;
																																																					{	/* Ast/sexp.scm 285 */
																																																						obj_t
																																																							BgL_tmpz00_17295;
																																																						BgL_tmpz00_17295
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_l1348z00_8576));
																																																						BgL_test8574z00_17294
																																																							=
																																																							SYMBOLP
																																																							(BgL_tmpz00_17295);
																																																					}
																																																					if (BgL_test8574z00_17294)
																																																						{
																																																							obj_t
																																																								BgL_l1348z00_17299;
																																																							BgL_l1348z00_17299
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_l1348z00_8576));
																																																							BgL_l1348z00_8576
																																																								=
																																																								BgL_l1348z00_17299;
																																																							goto
																																																								BgL_zc3z04anonymousza36742ze3z87_8577;
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 285 */
																																																							BgL_test8570z00_17285
																																																								=
																																																								(
																																																								(bool_t)
																																																								0);
																																																						}
																																																				}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 285 */
																																																			BgL_test8570z00_17285
																																																				=
																																																				(
																																																				(bool_t)
																																																				0);
																																																		}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 285 */
																																																	BgL_test8570z00_17285
																																																		=
																																																		(
																																																		(bool_t)
																																																		0);
																																																}
																																															if (BgL_test8570z00_17285)
																																																{	/* Ast/sexp.scm 285 */
																																																	BgL_auxz00_17284
																																																		=
																																																		BGl_fieldzd2setzd2ze3nodeze3zzast_objectz00
																																																		(BgL_lz00_1720,
																																																		BgL_valz00_1721,
																																																		BgL_expz00_21,
																																																		BgL_stackz00_22,
																																																		BgL_locz00_23,
																																																		BgL_sitez00_24);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 287 */
																																																	BgL_nodez00_bglt
																																																		BgL_res7368z00_9778;
																																																	{	/* Ast/sexp.scm 722 */
																																																		obj_t
																																																			BgL_arg7104z00_9774;
																																																		BgL_nodez00_bglt
																																																			BgL_arg7105z00_9775;
																																																		BgL_arg7104z00_9774
																																																			=
																																																			BGl_shapez00zztools_shapez00
																																																			(BGl_currentzd2functionzd2zztools_errorz00
																																																			());
																																																		BgL_arg7105z00_9775
																																																			=
																																																			BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																			(CNST_TABLE_REF
																																																			(((long) 4)), BNIL, BgL_locz00_23, CNST_TABLE_REF(((long) 2)));
																																																		{	/* Ast/sexp.scm 721 */
																																																			obj_t
																																																				BgL_list7106z00_9777;
																																																			BgL_list7106z00_9777
																																																				=
																																																				MAKE_YOUNG_PAIR
																																																				(
																																																				((obj_t) BgL_arg7105z00_9775), BNIL);
																																																			BgL_res7368z00_9778
																																																				=
																																																				(
																																																				(BgL_nodez00_bglt)
																																																				BGl_userzd2errorzf2locationz20zztools_errorz00
																																																				(BgL_locz00_23,
																																																					BgL_arg7104z00_9774,
																																																					BGl_string7998z00zzast_sexpz00,
																																																					BgL_expz00_21,
																																																					BgL_list7106z00_9777));
																																																	}}
																																																	BgL_auxz00_17284
																																																		=
																																																		BgL_res7368z00_9778;
																																														}}
																																														BgL_auxz00_14205
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_17284);
																																												}}
																																											else
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_17313;
																																													goto
																																														BgL_tagzd2379zd2_1723;
																																													BgL_auxz00_14205
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_17313);
																																												}
																																										}
																																									else
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_17315;
																																											goto
																																												BgL_tagzd2379zd2_1723;
																																											BgL_auxz00_14205
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_17315);
																																										}
																																								}
																																							else
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_17317;
																																									goto
																																										BgL_tagzd2379zd2_1723;
																																									BgL_auxz00_14205
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_17317);
																																								}
																																						}
																																					else
																																						{	/* Ast/sexp.scm 118 */
																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_17324;
																																									goto
																																										BgL_tagzd2380zd2_1724;
																																									BgL_auxz00_14205
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_17324);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 118 */
																																									obj_t
																																										BgL_carzd210819zd2_3623;
																																									BgL_carzd210819zd2_3623
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_expz00_21));
																																									if (PAIRP(BgL_carzd210819zd2_3623))
																																										{	/* Ast/sexp.scm 118 */
																																											obj_t
																																												BgL_carzd210822zd2_3625;
																																											obj_t
																																												BgL_cdrzd210823zd2_3626;
																																											BgL_carzd210822zd2_3625
																																												=
																																												CAR
																																												(BgL_carzd210819zd2_3623);
																																											BgL_cdrzd210823zd2_3626
																																												=
																																												CDR
																																												(BgL_carzd210819zd2_3623);
																																											{

																																												if ((BgL_carzd210822zd2_3625 == CNST_TABLE_REF(((long) 17))))
																																													{	/* Ast/sexp.scm 118 */
																																													BgL_kapzd210824zd2_3627:
																																														if (PAIRP(BgL_cdrzd210823zd2_3626))
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_cdrzd210827zd2_3752;
																																																BgL_cdrzd210827zd2_3752
																																																	=
																																																	CDR
																																																	(BgL_cdrzd210823zd2_3626);
																																																if (PAIRP(BgL_cdrzd210827zd2_3752))
																																																	{	/* Ast/sexp.scm 118 */
																																																		if (NULLP(CDR(BgL_cdrzd210827zd2_3752)))
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_arg3297z00_3756;
																																																				obj_t
																																																					BgL_arg3298z00_3757;
																																																				BgL_arg3297z00_3756
																																																					=
																																																					CAR
																																																					(BgL_cdrzd210827zd2_3752);
																																																				BgL_arg3298z00_3757
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_17346;
																																																					{
																																																						obj_t
																																																							BgL_argsz00_17348;
																																																						obj_t
																																																							BgL_bodyz00_17347;
																																																						BgL_bodyz00_17347
																																																							=
																																																							BgL_arg3297z00_3756;
																																																						BgL_argsz00_17348
																																																							=
																																																							BgL_arg3298z00_3757;
																																																						BgL_argsz00_1726
																																																							=
																																																							BgL_argsz00_17348;
																																																						BgL_bodyz00_1725
																																																							=
																																																							BgL_bodyz00_17347;
																																																						goto
																																																							BgL_tagzd2381zd2_1727;
																																																					}
																																																					BgL_auxz00_14205
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_17346);
																																																				}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_cdrzd210851zd2_3758;
																																																				BgL_cdrzd210851zd2_3758
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{	/* Ast/sexp.scm 118 */
																																																					bool_t
																																																						BgL_test8581z00_17352;
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_arg3387z00_3869;
																																																						BgL_arg3387z00_3869
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test8581z00_17352
																																																							=
																																																							CBOOL
																																																							(BGl_letzd2symzf3z21zzast_letz00
																																																							(BgL_arg3387z00_3869));
																																																					}
																																																					if (BgL_test8581z00_17352)
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_arg3301z00_3761;
																																																							obj_t
																																																								BgL_arg3302z00_3762;
																																																							BgL_arg3301z00_3761
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd210851zd2_3758));
																																																							BgL_arg3302z00_3762
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd210851zd2_3758));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_17361;
																																																								{
																																																									obj_t
																																																										BgL_exprz00_17363;
																																																									obj_t
																																																										BgL_bindingsz00_17362;
																																																									BgL_bindingsz00_17362
																																																										=
																																																										BgL_arg3301z00_3761;
																																																									BgL_exprz00_17363
																																																										=
																																																										BgL_arg3302z00_3762;
																																																									BgL_exprz00_1729
																																																										=
																																																										BgL_exprz00_17363;
																																																									BgL_bindingsz00_1728
																																																										=
																																																										BgL_bindingsz00_17362;
																																																									goto
																																																										BgL_tagzd2382zd2_1730;
																																																								}
																																																								BgL_auxz00_14205
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_17361);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							bool_t
																																																								BgL_test8582z00_17365;
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_arg3385z00_3868;
																																																								BgL_arg3385z00_3868
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test8582z00_17365
																																																									=
																																																									CBOOL
																																																									(BGl_labelszd2symzf3z21zzast_labelsz00
																																																									(BgL_arg3385z00_3868));
																																																							}
																																																							if (BgL_test8582z00_17365)
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_17370;
																																																									goto
																																																										BgL_tagzd2384zd2_1732;
																																																									BgL_auxz00_14205
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_17370);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_carzd210918zd2_3765;
																																																									BgL_carzd210918zd2_3765
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_cdrzd210923zd2_3766;
																																																										BgL_cdrzd210923zd2_3766
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_carzd210918zd2_3765));
																																																										if ((CAR(((obj_t) BgL_carzd210918zd2_3765)) == CNST_TABLE_REF(((long) 3))))
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_arg3307z00_3769;
																																																												obj_t
																																																													BgL_arg3310z00_3770;
																																																												obj_t
																																																													BgL_arg3311z00_3771;
																																																												BgL_arg3307z00_3769
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_cdrzd210923zd2_3766));
																																																												BgL_arg3310z00_3770
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_cdrzd210923zd2_3766));
																																																												BgL_arg3311z00_3771
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_17387;
																																																													{
																																																														obj_t
																																																															BgL_argsz00_17390;
																																																														obj_t
																																																															BgL_bodyz00_17389;
																																																														obj_t
																																																															BgL_varsz00_17388;
																																																														BgL_varsz00_17388
																																																															=
																																																															BgL_arg3307z00_3769;
																																																														BgL_bodyz00_17389
																																																															=
																																																															BgL_arg3310z00_3770;
																																																														BgL_argsz00_17390
																																																															=
																																																															BgL_arg3311z00_3771;
																																																														BgL_argsz00_1739
																																																															=
																																																															BgL_argsz00_17390;
																																																														BgL_bodyz00_1738
																																																															=
																																																															BgL_bodyz00_17389;
																																																														BgL_varsz00_1737
																																																															=
																																																															BgL_varsz00_17388;
																																																														goto
																																																															BgL_tagzd2386zd2_1740;
																																																													}
																																																													BgL_auxz00_14205
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_17387);
																																																												}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_cdrzd210946zd2_3773;
																																																												BgL_cdrzd210946zd2_3773
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_cdrzd210952zd2_3774;
																																																													BgL_cdrzd210952zd2_3774
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_carzd210918zd2_3765));
																																																													if ((CAR(((obj_t) BgL_carzd210918zd2_3765)) == CNST_TABLE_REF(((long) 1))))
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_cdrzd210958zd2_3777;
																																																															BgL_cdrzd210958zd2_3777
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd210952zd2_3774));
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_carzd210963zd2_3778;
																																																																obj_t
																																																																	BgL_cdrzd210964zd2_3779;
																																																																BgL_carzd210963zd2_3778
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd210958zd2_3777));
																																																																BgL_cdrzd210964zd2_3779
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd210958zd2_3777));
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd210963zd2_3778))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (PAIRP(BgL_cdrzd210964zd2_3779))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_carzd210971zd2_3782;
																																																																				BgL_carzd210971zd2_3782
																																																																					=
																																																																					CAR
																																																																					(BgL_cdrzd210964zd2_3779);
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd210971zd2_3782))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (NULLP(CDR(BgL_cdrzd210964zd2_3779)))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								bool_t
																																																																									BgL_test8589z00_17417;
																																																																								{
																																																																									obj_t
																																																																										BgL_l1382z00_3815;
																																																																									BgL_l1382z00_3815
																																																																										=
																																																																										BgL_cdrzd210946zd2_3773;
																																																																								BgL_zc3z04anonymousza33337ze3z87_3816:
																																																																									if (NULLP(BgL_l1382z00_3815))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											BgL_test8589z00_17417
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												1);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											bool_t
																																																																												BgL_test8591z00_17420;
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												bool_t
																																																																													BgL_test8592z00_17421;
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_tmpz00_17422;
																																																																													BgL_tmpz00_17422
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_l1382z00_3815));
																																																																													BgL_test8592z00_17421
																																																																														=
																																																																														PAIRP
																																																																														(BgL_tmpz00_17422);
																																																																												}
																																																																												if (BgL_test8592z00_17421)
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														BgL_test8591z00_17420
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															0);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														BgL_test8591z00_17420
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															1);
																																																																													}
																																																																											}
																																																																											if (BgL_test8591z00_17420)
																																																																												{
																																																																													obj_t
																																																																														BgL_l1382z00_17426;
																																																																													BgL_l1382z00_17426
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_l1382z00_3815));
																																																																													BgL_l1382z00_3815
																																																																														=
																																																																														BgL_l1382z00_17426;
																																																																													goto
																																																																														BgL_zc3z04anonymousza33337ze3z87_3816;
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													BgL_test8589z00_17417
																																																																														=
																																																																														(
																																																																														(bool_t)
																																																																														0);
																																																																												}
																																																																										}
																																																																								}
																																																																								if (BgL_test8589z00_17417)
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_arg3325z00_3798;
																																																																										BgL_arg3325z00_3798
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd210952zd2_3774));
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_17431;
																																																																											{
																																																																												obj_t
																																																																													BgL_argsz00_17435;
																																																																												obj_t
																																																																													BgL_proc2z00_17434;
																																																																												obj_t
																																																																													BgL_proc1z00_17433;
																																																																												obj_t
																																																																													BgL_testz00_17432;
																																																																												BgL_testz00_17432
																																																																													=
																																																																													BgL_arg3325z00_3798;
																																																																												BgL_proc1z00_17433
																																																																													=
																																																																													BgL_carzd210963zd2_3778;
																																																																												BgL_proc2z00_17434
																																																																													=
																																																																													BgL_carzd210971zd2_3782;
																																																																												BgL_argsz00_17435
																																																																													=
																																																																													BgL_cdrzd210946zd2_3773;
																																																																												BgL_argsz00_1744
																																																																													=
																																																																													BgL_argsz00_17435;
																																																																												BgL_proc2z00_1743
																																																																													=
																																																																													BgL_proc2z00_17434;
																																																																												BgL_proc1z00_1742
																																																																													=
																																																																													BgL_proc1z00_17433;
																																																																												BgL_testz00_1741
																																																																													=
																																																																													BgL_testz00_17432;
																																																																												goto
																																																																													BgL_tagzd2387zd2_1745;
																																																																											}
																																																																											BgL_auxz00_14205
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_17431);
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_cdrzd210995zd2_3799;
																																																																										BgL_cdrzd210995zd2_3799
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_cdrzd211002zd2_3800;
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_pairz00_10664;
																																																																												BgL_pairz00_10664
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_expz00_21));
																																																																												BgL_cdrzd211002zd2_3800
																																																																													=
																																																																													CDR
																																																																													(BgL_pairz00_10664);
																																																																											}
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_cdrzd211009zd2_3801;
																																																																												BgL_cdrzd211009zd2_3801
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd211002zd2_3800));
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_carzd211015zd2_3802;
																																																																													BgL_carzd211015zd2_3802
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd211009zd2_3801));
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd211015zd2_3802))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_carzd211022zd2_3804;
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_pairz00_10668;
																																																																																BgL_pairz00_10668
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd211009zd2_3801));
																																																																																BgL_carzd211022zd2_3804
																																																																																	=
																																																																																	CAR
																																																																																	(BgL_pairz00_10668);
																																																																															}
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd211022zd2_3804))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd210995zd2_3799))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			obj_t
																																																																																				BgL_arg3329z00_3807;
																																																																																			BgL_arg3329z00_3807
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd211002zd2_3800));
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_17457;
																																																																																				{
																																																																																					obj_t
																																																																																						BgL_argsz00_17461;
																																																																																					obj_t
																																																																																						BgL_proc2z00_17460;
																																																																																					obj_t
																																																																																						BgL_proc1z00_17459;
																																																																																					obj_t
																																																																																						BgL_testz00_17458;
																																																																																					BgL_testz00_17458
																																																																																						=
																																																																																						BgL_arg3329z00_3807;
																																																																																					BgL_proc1z00_17459
																																																																																						=
																																																																																						BgL_carzd211015zd2_3802;
																																																																																					BgL_proc2z00_17460
																																																																																						=
																																																																																						BgL_carzd211022zd2_3804;
																																																																																					BgL_argsz00_17461
																																																																																						=
																																																																																						BgL_cdrzd210995zd2_3799;
																																																																																					BgL_argsz00_1749
																																																																																						=
																																																																																						BgL_argsz00_17461;
																																																																																					BgL_proc2z00_1748
																																																																																						=
																																																																																						BgL_proc2z00_17460;
																																																																																					BgL_proc1z00_1747
																																																																																						=
																																																																																						BgL_proc1z00_17459;
																																																																																					BgL_testz00_1746
																																																																																						=
																																																																																						BgL_testz00_17458;
																																																																																					goto
																																																																																						BgL_tagzd2388zd2_1750;
																																																																																				}
																																																																																				BgL_auxz00_14205
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_17457);
																																																																																			}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1774;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_17465;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1775;
																																																																																					BgL_auxz00_14205
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_17465);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1774;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_17469;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1775;
																																																																																			BgL_auxz00_14205
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_17469);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1774;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_17473;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1775;
																																																																																	BgL_auxz00_14205
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_17473);
																																																																																}
																																																																														}
																																																																												}
																																																																											}
																																																																										}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1774;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_17477;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1775;
																																																																										BgL_auxz00_14205
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_17477);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_cdrzd211298zd2_3826;
																																																																						BgL_cdrzd211298zd2_3826
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_cdrzd211304zd2_3827;
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_pairz00_10672;
																																																																								BgL_pairz00_10672
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								BgL_cdrzd211304zd2_3827
																																																																									=
																																																																									CDR
																																																																									(BgL_pairz00_10672);
																																																																							}
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_cdrzd211310zd2_3828;
																																																																								BgL_cdrzd211310zd2_3828
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd211304zd2_3827));
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_carzd211315zd2_3829;
																																																																									obj_t
																																																																										BgL_cdrzd211316zd2_3830;
																																																																									BgL_carzd211315zd2_3829
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd211310zd2_3828));
																																																																									BgL_cdrzd211316zd2_3830
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd211310zd2_3828));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd211315zd2_3829))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_carzd211321zd2_3832;
																																																																											BgL_carzd211321zd2_3832
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd211316zd2_3830));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd211321zd2_3832))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (NULLP(CDR(((obj_t) BgL_cdrzd211316zd2_3830))))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd211298zd2_3826))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_arg3348z00_3837;
																																																																																	BgL_arg3348z00_3837
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd211304zd2_3827));
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_17504;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_17508;
																																																																																			obj_t
																																																																																				BgL_proc2z00_17507;
																																																																																			obj_t
																																																																																				BgL_proc1z00_17506;
																																																																																			obj_t
																																																																																				BgL_testz00_17505;
																																																																																			BgL_testz00_17505
																																																																																				=
																																																																																				BgL_arg3348z00_3837;
																																																																																			BgL_proc1z00_17506
																																																																																				=
																																																																																				BgL_carzd211315zd2_3829;
																																																																																			BgL_proc2z00_17507
																																																																																				=
																																																																																				BgL_carzd211321zd2_3832;
																																																																																			BgL_argsz00_17508
																																																																																				=
																																																																																				BgL_cdrzd211298zd2_3826;
																																																																																			BgL_argsz00_1749
																																																																																				=
																																																																																				BgL_argsz00_17508;
																																																																																			BgL_proc2z00_1748
																																																																																				=
																																																																																				BgL_proc2z00_17507;
																																																																																			BgL_proc1z00_1747
																																																																																				=
																																																																																				BgL_proc1z00_17506;
																																																																																			BgL_testz00_1746
																																																																																				=
																																																																																				BgL_testz00_17505;
																																																																																			goto
																																																																																				BgL_tagzd2388zd2_1750;
																																																																																		}
																																																																																		BgL_auxz00_14205
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_17504);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1774;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_17512;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1775;
																																																																																			BgL_auxz00_14205
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_17512);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1774;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_17516;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1775;
																																																																																	BgL_auxz00_14205
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_17516);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1774;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_17520;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1775;
																																																																															BgL_auxz00_14205
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_17520);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1774;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_17524;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1775;
																																																																													BgL_auxz00_14205
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_17524);
																																																																												}
																																																																										}
																																																																								}
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1774;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_17528;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1775;
																																																																						BgL_auxz00_14205
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_17528);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_cdrzd211654zd2_3845;
																																																																		BgL_cdrzd211654zd2_3845
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_cdrzd211661zd2_3846;
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_pairz00_10682;
																																																																				BgL_pairz00_10682
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				BgL_cdrzd211661zd2_3846
																																																																					=
																																																																					CDR
																																																																					(BgL_pairz00_10682);
																																																																			}
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_cdrzd211668zd2_3847;
																																																																				BgL_cdrzd211668zd2_3847
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd211661zd2_3846));
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_carzd211674zd2_3848;
																																																																					obj_t
																																																																						BgL_cdrzd211675zd2_3849;
																																																																					BgL_carzd211674zd2_3848
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd211668zd2_3847));
																																																																					BgL_cdrzd211675zd2_3849
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd211668zd2_3847));
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd211674zd2_3848))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (PAIRP(BgL_cdrzd211675zd2_3849))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_carzd211682zd2_3852;
																																																																									BgL_carzd211682zd2_3852
																																																																										=
																																																																										CAR
																																																																										(BgL_cdrzd211675zd2_3849);
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd211682zd2_3852))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (NULLP(CDR(BgL_cdrzd211675zd2_3849)))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd211654zd2_3845))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_arg3372z00_3857;
																																																																															BgL_arg3372z00_3857
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd211661zd2_3846));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_17555;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_17559;
																																																																																	obj_t
																																																																																		BgL_proc2z00_17558;
																																																																																	obj_t
																																																																																		BgL_proc1z00_17557;
																																																																																	obj_t
																																																																																		BgL_testz00_17556;
																																																																																	BgL_testz00_17556
																																																																																		=
																																																																																		BgL_arg3372z00_3857;
																																																																																	BgL_proc1z00_17557
																																																																																		=
																																																																																		BgL_carzd211674zd2_3848;
																																																																																	BgL_proc2z00_17558
																																																																																		=
																																																																																		BgL_carzd211682zd2_3852;
																																																																																	BgL_argsz00_17559
																																																																																		=
																																																																																		BgL_cdrzd211654zd2_3845;
																																																																																	BgL_argsz00_1749
																																																																																		=
																																																																																		BgL_argsz00_17559;
																																																																																	BgL_proc2z00_1748
																																																																																		=
																																																																																		BgL_proc2z00_17558;
																																																																																	BgL_proc1z00_1747
																																																																																		=
																																																																																		BgL_proc1z00_17557;
																																																																																	BgL_testz00_1746
																																																																																		=
																																																																																		BgL_testz00_17556;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1750;
																																																																																}
																																																																																BgL_auxz00_14205
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_17555);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1774;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_17563;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1775;
																																																																																	BgL_auxz00_14205
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_17563);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1774;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_17567;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1775;
																																																																															BgL_auxz00_14205
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_17567);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1774;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_17571;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1775;
																																																																													BgL_auxz00_14205
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_17571);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1774;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_17575;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1775;
																																																																											BgL_auxz00_14205
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_17575);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1774;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_17579;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1775;
																																																																									BgL_auxz00_14205
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_17579);
																																																																								}
																																																																						}
																																																																				}
																																																																			}
																																																																		}
																																																																	}
																																																															}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1774;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_17583;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1775;
																																																																	BgL_auxz00_14205
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_17583);
																																																																}
																																																														}
																																																												}
																																																											}
																																																									}
																																																								}
																																																						}
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_cdrzd212075zd2_3871;
																																																		BgL_cdrzd212075zd2_3871
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 118 */
																																																			bool_t
																																																				BgL_test8620z00_17587;
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_arg3407z00_3888;
																																																				BgL_arg3407z00_3888
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test8620z00_17587
																																																					=
																																																					CBOOL
																																																					(BGl_letzd2symzf3z21zzast_letz00
																																																					(BgL_arg3407z00_3888));
																																																			}
																																																			if (BgL_test8620z00_17587)
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_arg3392z00_3874;
																																																					obj_t
																																																						BgL_arg3393z00_3875;
																																																					BgL_arg3392z00_3874
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd212075zd2_3871));
																																																					BgL_arg3393z00_3875
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd212075zd2_3871));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_17596;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_17598;
																																																							obj_t
																																																								BgL_bindingsz00_17597;
																																																							BgL_bindingsz00_17597
																																																								=
																																																								BgL_arg3392z00_3874;
																																																							BgL_exprz00_17598
																																																								=
																																																								BgL_arg3393z00_3875;
																																																							BgL_exprz00_1729
																																																								=
																																																								BgL_exprz00_17598;
																																																							BgL_bindingsz00_1728
																																																								=
																																																								BgL_bindingsz00_17597;
																																																							goto
																																																								BgL_tagzd2382zd2_1730;
																																																						}
																																																						BgL_auxz00_14205
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_17596);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					bool_t
																																																						BgL_test8621z00_17600;
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_arg3406z00_3887;
																																																						BgL_arg3406z00_3887
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test8621z00_17600
																																																							=
																																																							CBOOL
																																																							(BGl_labelszd2symzf3z21zzast_labelsz00
																																																							(BgL_arg3406z00_3887));
																																																					}
																																																					if (BgL_test8621z00_17600)
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_17605;
																																																							goto
																																																								BgL_tagzd2384zd2_1732;
																																																							BgL_auxz00_14205
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_17605);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_carzd212141zd2_3878;
																																																							BgL_carzd212141zd2_3878
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_cdrzd212146zd2_3879;
																																																								BgL_cdrzd212146zd2_3879
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_carzd212141zd2_3878));
																																																								if ((CAR(((obj_t) BgL_carzd212141zd2_3878)) == CNST_TABLE_REF(((long) 3))))
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_arg3400z00_3882;
																																																										obj_t
																																																											BgL_arg3401z00_3883;
																																																										obj_t
																																																											BgL_arg3402z00_3884;
																																																										BgL_arg3400z00_3882
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_cdrzd212146zd2_3879));
																																																										BgL_arg3401z00_3883
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_cdrzd212146zd2_3879));
																																																										BgL_arg3402z00_3884
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_17622;
																																																											{
																																																												obj_t
																																																													BgL_argsz00_17625;
																																																												obj_t
																																																													BgL_bodyz00_17624;
																																																												obj_t
																																																													BgL_varsz00_17623;
																																																												BgL_varsz00_17623
																																																													=
																																																													BgL_arg3400z00_3882;
																																																												BgL_bodyz00_17624
																																																													=
																																																													BgL_arg3401z00_3883;
																																																												BgL_argsz00_17625
																																																													=
																																																													BgL_arg3402z00_3884;
																																																												BgL_argsz00_1739
																																																													=
																																																													BgL_argsz00_17625;
																																																												BgL_bodyz00_1738
																																																													=
																																																													BgL_bodyz00_17624;
																																																												BgL_varsz00_1737
																																																													=
																																																													BgL_varsz00_17623;
																																																												goto
																																																													BgL_tagzd2386zd2_1740;
																																																											}
																																																											BgL_auxz00_14205
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_17622);
																																																										}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 118 */
																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																											{	/* Ast/sexp.scm 118 */
																																																												goto
																																																													BgL_tagzd2403zd2_1774;
																																																											}
																																																										else
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_17629;
																																																												goto
																																																													BgL_tagzd2404zd2_1775;
																																																												BgL_auxz00_14205
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_17629);
																																																											}
																																																									}
																																																							}
																																																						}
																																																				}
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_cdrzd212257zd2_3889;
																																																BgL_cdrzd212257zd2_3889
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 118 */
																																																	bool_t
																																																		BgL_test8624z00_17633;
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_arg3418z00_3898;
																																																		BgL_arg3418z00_3898
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_test8624z00_17633
																																																			=
																																																			CBOOL
																																																			(BGl_letzd2symzf3z21zzast_letz00
																																																			(BgL_arg3418z00_3898));
																																																	}
																																																	if (BgL_test8624z00_17633)
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_arg3411z00_3892;
																																																			obj_t
																																																				BgL_arg3412z00_3893;
																																																			BgL_arg3411z00_3892
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd212257zd2_3889));
																																																			BgL_arg3412z00_3893
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd212257zd2_3889));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_17642;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_17644;
																																																					obj_t
																																																						BgL_bindingsz00_17643;
																																																					BgL_bindingsz00_17643
																																																						=
																																																						BgL_arg3411z00_3892;
																																																					BgL_exprz00_17644
																																																						=
																																																						BgL_arg3412z00_3893;
																																																					BgL_exprz00_1729
																																																						=
																																																						BgL_exprz00_17644;
																																																					BgL_bindingsz00_1728
																																																						=
																																																						BgL_bindingsz00_17643;
																																																					goto
																																																						BgL_tagzd2382zd2_1730;
																																																				}
																																																				BgL_auxz00_14205
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_17642);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			bool_t
																																																				BgL_test8625z00_17646;
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_arg3417z00_3897;
																																																				BgL_arg3417z00_3897
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test8625z00_17646
																																																					=
																																																					CBOOL
																																																					(BGl_labelszd2symzf3z21zzast_labelsz00
																																																					(BgL_arg3417z00_3897));
																																																			}
																																																			if (BgL_test8625z00_17646)
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_17651;
																																																					goto
																																																						BgL_tagzd2384zd2_1732;
																																																					BgL_auxz00_14205
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_17651);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																						{	/* Ast/sexp.scm 118 */
																																																							goto
																																																								BgL_tagzd2403zd2_1774;
																																																						}
																																																					else
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_17655;
																																																							goto
																																																								BgL_tagzd2404zd2_1775;
																																																							BgL_auxz00_14205
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_17655);
																																																						}
																																																				}
																																																		}
																																																}
																																															}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd210822zd2_3625)))
																																															{	/* Ast/sexp.scm 118 */
																																																goto
																																																	BgL_kapzd210824zd2_3627;
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																if ((BgL_carzd210822zd2_3625 == CNST_TABLE_REF(((long) 18))))
																																																	{	/* Ast/sexp.scm 118 */
																																																		goto
																																																			BgL_kapzd210824zd2_3627;
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		if ((BgL_carzd210822zd2_3625 == CNST_TABLE_REF(((long) 19))))
																																																			{	/* Ast/sexp.scm 118 */
																																																				goto
																																																					BgL_kapzd210824zd2_3627;
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 118 */
																																																				if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd210822zd2_3625)))
																																																					{	/* Ast/sexp.scm 118 */
																																																						goto
																																																							BgL_kapzd210824zd2_3627;
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_cdrzd212429zd2_3633;
																																																						BgL_cdrzd212429zd2_3633
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{	/* Ast/sexp.scm 118 */
																																																							bool_t
																																																								BgL_test8631z00_17671;
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_arg3291z00_3750;
																																																								BgL_arg3291z00_3750
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test8631z00_17671
																																																									=
																																																									CBOOL
																																																									(BGl_letzd2symzf3z21zzast_letz00
																																																									(BgL_arg3291z00_3750));
																																																							}
																																																							if (BgL_test8631z00_17671)
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_arg3193z00_3636;
																																																									obj_t
																																																										BgL_arg3194z00_3637;
																																																									BgL_arg3193z00_3636
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd212429zd2_3633));
																																																									BgL_arg3194z00_3637
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd212429zd2_3633));
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_17680;
																																																										{
																																																											obj_t
																																																												BgL_exprz00_17682;
																																																											obj_t
																																																												BgL_bindingsz00_17681;
																																																											BgL_bindingsz00_17681
																																																												=
																																																												BgL_arg3193z00_3636;
																																																											BgL_exprz00_17682
																																																												=
																																																												BgL_arg3194z00_3637;
																																																											BgL_exprz00_1729
																																																												=
																																																												BgL_exprz00_17682;
																																																											BgL_bindingsz00_1728
																																																												=
																																																												BgL_bindingsz00_17681;
																																																											goto
																																																												BgL_tagzd2382zd2_1730;
																																																										}
																																																										BgL_auxz00_14205
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_17680);
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									bool_t
																																																										BgL_test8632z00_17684;
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_arg3285z00_3749;
																																																										BgL_arg3285z00_3749
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_test8632z00_17684
																																																											=
																																																											CBOOL
																																																											(BGl_labelszd2symzf3z21zzast_labelsz00
																																																											(BgL_arg3285z00_3749));
																																																									}
																																																									if (BgL_test8632z00_17684)
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_17689;
																																																											goto
																																																												BgL_tagzd2384zd2_1732;
																																																											BgL_auxz00_14205
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_17689);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_carzd212495zd2_3640;
																																																											BgL_carzd212495zd2_3640
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_cdrzd212500zd2_3641;
																																																												BgL_cdrzd212500zd2_3641
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_carzd212495zd2_3640));
																																																												if ((CAR(((obj_t) BgL_carzd212495zd2_3640)) == CNST_TABLE_REF(((long) 3))))
																																																													{	/* Ast/sexp.scm 118 */
																																																														if (PAIRP(BgL_cdrzd212500zd2_3641))
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_arg3203z00_3645;
																																																																obj_t
																																																																	BgL_arg3204z00_3646;
																																																																obj_t
																																																																	BgL_arg3206z00_3647;
																																																																BgL_arg3203z00_3645
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd212500zd2_3641);
																																																																BgL_arg3204z00_3646
																																																																	=
																																																																	CDR
																																																																	(BgL_cdrzd212500zd2_3641);
																																																																BgL_arg3206z00_3647
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_17706;
																																																																	{
																																																																		obj_t
																																																																			BgL_argsz00_17709;
																																																																		obj_t
																																																																			BgL_bodyz00_17708;
																																																																		obj_t
																																																																			BgL_varsz00_17707;
																																																																		BgL_varsz00_17707
																																																																			=
																																																																			BgL_arg3203z00_3645;
																																																																		BgL_bodyz00_17708
																																																																			=
																																																																			BgL_arg3204z00_3646;
																																																																		BgL_argsz00_17709
																																																																			=
																																																																			BgL_arg3206z00_3647;
																																																																		BgL_argsz00_1739
																																																																			=
																																																																			BgL_argsz00_17709;
																																																																		BgL_bodyz00_1738
																																																																			=
																																																																			BgL_bodyz00_17708;
																																																																		BgL_varsz00_1737
																																																																			=
																																																																			BgL_varsz00_17707;
																																																																		goto
																																																																			BgL_tagzd2386zd2_1740;
																																																																	}
																																																																	BgL_auxz00_14205
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_17706);
																																																																}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1774;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_17713;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1775;
																																																																		BgL_auxz00_14205
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_17713);
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_cdrzd212607zd2_3650;
																																																														BgL_cdrzd212607zd2_3650
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_cdrzd212612zd2_3651;
																																																															BgL_cdrzd212612zd2_3651
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_carzd212495zd2_3640));
																																																															if ((CAR(((obj_t) BgL_carzd212495zd2_3640)) == CNST_TABLE_REF(((long) 1))))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if (PAIRP(BgL_cdrzd212612zd2_3651))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_cdrzd212617zd2_3655;
																																																																			BgL_cdrzd212617zd2_3655
																																																																				=
																																																																				CDR
																																																																				(BgL_cdrzd212612zd2_3651);
																																																																			if (PAIRP(BgL_cdrzd212617zd2_3655))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_carzd212621zd2_3657;
																																																																					obj_t
																																																																						BgL_cdrzd212622zd2_3658;
																																																																					BgL_carzd212621zd2_3657
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd212617zd2_3655);
																																																																					BgL_cdrzd212622zd2_3658
																																																																						=
																																																																						CDR
																																																																						(BgL_cdrzd212617zd2_3655);
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd212621zd2_3657))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (PAIRP(BgL_cdrzd212622zd2_3658))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_carzd212627zd2_3661;
																																																																									BgL_carzd212627zd2_3661
																																																																										=
																																																																										CAR
																																																																										(BgL_cdrzd212622zd2_3658);
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd212627zd2_3661))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (NULLP(CDR(BgL_cdrzd212622zd2_3658)))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													bool_t
																																																																														BgL_test8643z00_17741;
																																																																													{
																																																																														obj_t
																																																																															BgL_l1385z00_3694;
																																																																														BgL_l1385z00_3694
																																																																															=
																																																																															BgL_cdrzd212607zd2_3650;
																																																																													BgL_zc3z04anonymousza33241ze3z87_3695:
																																																																														if (NULLP(BgL_l1385z00_3694))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																BgL_test8643z00_17741
																																																																																	=
																																																																																	(
																																																																																	(bool_t)
																																																																																	1);
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																bool_t
																																																																																	BgL_test8645z00_17744;
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	bool_t
																																																																																		BgL_test8646z00_17745;
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		obj_t
																																																																																			BgL_tmpz00_17746;
																																																																																		BgL_tmpz00_17746
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_l1385z00_3694));
																																																																																		BgL_test8646z00_17745
																																																																																			=
																																																																																			PAIRP
																																																																																			(BgL_tmpz00_17746);
																																																																																	}
																																																																																	if (BgL_test8646z00_17745)
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			BgL_test8645z00_17744
																																																																																				=
																																																																																				(
																																																																																				(bool_t)
																																																																																				0);
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			BgL_test8645z00_17744
																																																																																				=
																																																																																				(
																																																																																				(bool_t)
																																																																																				1);
																																																																																		}
																																																																																}
																																																																																if (BgL_test8645z00_17744)
																																																																																	{
																																																																																		obj_t
																																																																																			BgL_l1385z00_17750;
																																																																																		BgL_l1385z00_17750
																																																																																			=
																																																																																			CDR
																																																																																			(
																																																																																			((obj_t) BgL_l1385z00_3694));
																																																																																		BgL_l1385z00_3694
																																																																																			=
																																																																																			BgL_l1385z00_17750;
																																																																																		goto
																																																																																			BgL_zc3z04anonymousza33241ze3z87_3695;
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		BgL_test8643z00_17741
																																																																																			=
																																																																																			(
																																																																																			(bool_t)
																																																																																			0);
																																																																																	}
																																																																															}
																																																																													}
																																																																													if (BgL_test8643z00_17741)
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_arg3231z00_3677;
																																																																															BgL_arg3231z00_3677
																																																																																=
																																																																																CAR
																																																																																(BgL_cdrzd212612zd2_3651);
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_17754;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_17758;
																																																																																	obj_t
																																																																																		BgL_proc2z00_17757;
																																																																																	obj_t
																																																																																		BgL_proc1z00_17756;
																																																																																	obj_t
																																																																																		BgL_testz00_17755;
																																																																																	BgL_testz00_17755
																																																																																		=
																																																																																		BgL_arg3231z00_3677;
																																																																																	BgL_proc1z00_17756
																																																																																		=
																																																																																		BgL_carzd212621zd2_3657;
																																																																																	BgL_proc2z00_17757
																																																																																		=
																																																																																		BgL_carzd212627zd2_3661;
																																																																																	BgL_argsz00_17758
																																																																																		=
																																																																																		BgL_cdrzd212607zd2_3650;
																																																																																	BgL_argsz00_1744
																																																																																		=
																																																																																		BgL_argsz00_17758;
																																																																																	BgL_proc2z00_1743
																																																																																		=
																																																																																		BgL_proc2z00_17757;
																																																																																	BgL_proc1z00_1742
																																																																																		=
																																																																																		BgL_proc1z00_17756;
																																																																																	BgL_testz00_1741
																																																																																		=
																																																																																		BgL_testz00_17755;
																																																																																	goto
																																																																																		BgL_tagzd2387zd2_1745;
																																																																																}
																																																																																BgL_auxz00_14205
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_17754);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_cdrzd212652zd2_3678;
																																																																															BgL_cdrzd212652zd2_3678
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_cdrzd212660zd2_3679;
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_pairz00_10739;
																																																																																	BgL_pairz00_10739
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_expz00_21));
																																																																																	BgL_cdrzd212660zd2_3679
																																																																																		=
																																																																																		CDR
																																																																																		(BgL_pairz00_10739);
																																																																																}
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_cdrzd212668zd2_3680;
																																																																																	BgL_cdrzd212668zd2_3680
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd212660zd2_3679));
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		obj_t
																																																																																			BgL_carzd212675zd2_3681;
																																																																																		BgL_carzd212675zd2_3681
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd212668zd2_3680));
																																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd212675zd2_3681))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				obj_t
																																																																																					BgL_carzd212684zd2_3683;
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					obj_t
																																																																																						BgL_pairz00_10743;
																																																																																					BgL_pairz00_10743
																																																																																						=
																																																																																						CDR
																																																																																						(
																																																																																						((obj_t) BgL_cdrzd212668zd2_3680));
																																																																																					BgL_carzd212684zd2_3683
																																																																																						=
																																																																																						CAR
																																																																																						(BgL_pairz00_10743);
																																																																																				}
																																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd212684zd2_3683))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd212652zd2_3678))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								obj_t
																																																																																									BgL_arg3235z00_3686;
																																																																																								BgL_arg3235z00_3686
																																																																																									=
																																																																																									CAR
																																																																																									(
																																																																																									((obj_t) BgL_cdrzd212660zd2_3679));
																																																																																								{
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_auxz00_17780;
																																																																																									{
																																																																																										obj_t
																																																																																											BgL_argsz00_17784;
																																																																																										obj_t
																																																																																											BgL_proc2z00_17783;
																																																																																										obj_t
																																																																																											BgL_proc1z00_17782;
																																																																																										obj_t
																																																																																											BgL_testz00_17781;
																																																																																										BgL_testz00_17781
																																																																																											=
																																																																																											BgL_arg3235z00_3686;
																																																																																										BgL_proc1z00_17782
																																																																																											=
																																																																																											BgL_carzd212675zd2_3681;
																																																																																										BgL_proc2z00_17783
																																																																																											=
																																																																																											BgL_carzd212684zd2_3683;
																																																																																										BgL_argsz00_17784
																																																																																											=
																																																																																											BgL_cdrzd212652zd2_3678;
																																																																																										BgL_argsz00_1749
																																																																																											=
																																																																																											BgL_argsz00_17784;
																																																																																										BgL_proc2z00_1748
																																																																																											=
																																																																																											BgL_proc2z00_17783;
																																																																																										BgL_proc1z00_1747
																																																																																											=
																																																																																											BgL_proc1z00_17782;
																																																																																										BgL_testz00_1746
																																																																																											=
																																																																																											BgL_testz00_17781;
																																																																																										goto
																																																																																											BgL_tagzd2388zd2_1750;
																																																																																									}
																																																																																									BgL_auxz00_14205
																																																																																										=
																																																																																										(
																																																																																										(obj_t)
																																																																																										BgL_auxz00_17780);
																																																																																								}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1774;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_17788;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1775;
																																																																																										BgL_auxz00_14205
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_17788);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1774;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_17792;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1775;
																																																																																								BgL_auxz00_14205
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_17792);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1774;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_17796;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1775;
																																																																																						BgL_auxz00_14205
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_17796);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																}
																																																																															}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1774;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_17800;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1775;
																																																																															BgL_auxz00_14205
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_17800);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_cdrzd212962zd2_3705;
																																																																											BgL_cdrzd212962zd2_3705
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_cdrzd212969zd2_3706;
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_pairz00_10747;
																																																																													BgL_pairz00_10747
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													BgL_cdrzd212969zd2_3706
																																																																														=
																																																																														CDR
																																																																														(BgL_pairz00_10747);
																																																																												}
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_cdrzd212976zd2_3707;
																																																																													BgL_cdrzd212976zd2_3707
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd212969zd2_3706));
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_carzd212982zd2_3708;
																																																																														obj_t
																																																																															BgL_cdrzd212983zd2_3709;
																																																																														BgL_carzd212982zd2_3708
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd212976zd2_3707));
																																																																														BgL_cdrzd212983zd2_3709
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd212976zd2_3707));
																																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd212982zd2_3708))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_carzd212990zd2_3711;
																																																																																BgL_carzd212990zd2_3711
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd212983zd2_3709));
																																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd212990zd2_3711))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (NULLP(CDR(((obj_t) BgL_cdrzd212983zd2_3709))))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd212962zd2_3705))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						obj_t
																																																																																							BgL_arg3250z00_3716;
																																																																																						BgL_arg3250z00_3716
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_cdrzd212969zd2_3706));
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_17827;
																																																																																							{
																																																																																								obj_t
																																																																																									BgL_argsz00_17831;
																																																																																								obj_t
																																																																																									BgL_proc2z00_17830;
																																																																																								obj_t
																																																																																									BgL_proc1z00_17829;
																																																																																								obj_t
																																																																																									BgL_testz00_17828;
																																																																																								BgL_testz00_17828
																																																																																									=
																																																																																									BgL_arg3250z00_3716;
																																																																																								BgL_proc1z00_17829
																																																																																									=
																																																																																									BgL_carzd212982zd2_3708;
																																																																																								BgL_proc2z00_17830
																																																																																									=
																																																																																									BgL_carzd212990zd2_3711;
																																																																																								BgL_argsz00_17831
																																																																																									=
																																																																																									BgL_cdrzd212962zd2_3705;
																																																																																								BgL_argsz00_1749
																																																																																									=
																																																																																									BgL_argsz00_17831;
																																																																																								BgL_proc2z00_1748
																																																																																									=
																																																																																									BgL_proc2z00_17830;
																																																																																								BgL_proc1z00_1747
																																																																																									=
																																																																																									BgL_proc1z00_17829;
																																																																																								BgL_testz00_1746
																																																																																									=
																																																																																									BgL_testz00_17828;
																																																																																								goto
																																																																																									BgL_tagzd2388zd2_1750;
																																																																																							}
																																																																																							BgL_auxz00_14205
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_17827);
																																																																																						}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1774;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_17835;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1775;
																																																																																								BgL_auxz00_14205
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_17835);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1774;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_17839;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1775;
																																																																																						BgL_auxz00_14205
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_17839);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1774;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_17843;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1775;
																																																																																				BgL_auxz00_14205
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_17843);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1774;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_17847;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1775;
																																																																																		BgL_auxz00_14205
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_17847);
																																																																																	}
																																																																															}
																																																																													}
																																																																												}
																																																																											}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1774;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_17851;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1775;
																																																																											BgL_auxz00_14205
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_17851);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_cdrzd213323zd2_3724;
																																																																							BgL_cdrzd213323zd2_3724
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_cdrzd213329zd2_3725;
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_pairz00_10757;
																																																																									BgL_pairz00_10757
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									BgL_cdrzd213329zd2_3725
																																																																										=
																																																																										CDR
																																																																										(BgL_pairz00_10757);
																																																																								}
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_cdrzd213335zd2_3726;
																																																																									BgL_cdrzd213335zd2_3726
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd213329zd2_3725));
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_carzd213340zd2_3727;
																																																																										obj_t
																																																																											BgL_cdrzd213341zd2_3728;
																																																																										BgL_carzd213340zd2_3727
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd213335zd2_3726));
																																																																										BgL_cdrzd213341zd2_3728
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd213335zd2_3726));
																																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd213340zd2_3727))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												if (PAIRP(BgL_cdrzd213341zd2_3728))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_carzd213346zd2_3731;
																																																																														BgL_carzd213346zd2_3731
																																																																															=
																																																																															CAR
																																																																															(BgL_cdrzd213341zd2_3728);
																																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd213346zd2_3731))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (NULLP(CDR(BgL_cdrzd213341zd2_3728)))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd213323zd2_3724))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				obj_t
																																																																																					BgL_arg3272z00_3736;
																																																																																				BgL_arg3272z00_3736
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd213329zd2_3725));
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_17878;
																																																																																					{
																																																																																						obj_t
																																																																																							BgL_argsz00_17882;
																																																																																						obj_t
																																																																																							BgL_proc2z00_17881;
																																																																																						obj_t
																																																																																							BgL_proc1z00_17880;
																																																																																						obj_t
																																																																																							BgL_testz00_17879;
																																																																																						BgL_testz00_17879
																																																																																							=
																																																																																							BgL_arg3272z00_3736;
																																																																																						BgL_proc1z00_17880
																																																																																							=
																																																																																							BgL_carzd213340zd2_3727;
																																																																																						BgL_proc2z00_17881
																																																																																							=
																																																																																							BgL_carzd213346zd2_3731;
																																																																																						BgL_argsz00_17882
																																																																																							=
																																																																																							BgL_cdrzd213323zd2_3724;
																																																																																						BgL_argsz00_1749
																																																																																							=
																																																																																							BgL_argsz00_17882;
																																																																																						BgL_proc2z00_1748
																																																																																							=
																																																																																							BgL_proc2z00_17881;
																																																																																						BgL_proc1z00_1747
																																																																																							=
																																																																																							BgL_proc1z00_17880;
																																																																																						BgL_testz00_1746
																																																																																							=
																																																																																							BgL_testz00_17879;
																																																																																						goto
																																																																																							BgL_tagzd2388zd2_1750;
																																																																																					}
																																																																																					BgL_auxz00_14205
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_17878);
																																																																																				}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1774;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_17886;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1775;
																																																																																						BgL_auxz00_14205
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_17886);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1774;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_17890;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1775;
																																																																																				BgL_auxz00_14205
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_17890);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1774;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_17894;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1775;
																																																																																		BgL_auxz00_14205
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_17894);
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1774;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_17898;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1775;
																																																																																BgL_auxz00_14205
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_17898);
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1774;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_17902;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1775;
																																																																														BgL_auxz00_14205
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_17902);
																																																																													}
																																																																											}
																																																																									}
																																																																								}
																																																																							}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1774;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_17906;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1775;
																																																																							BgL_auxz00_14205
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_17906);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1774;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_17910;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1775;
																																																																					BgL_auxz00_14205
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_17910);
																																																																				}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1774;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_17914;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1775;
																																																																			BgL_auxz00_14205
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_17914);
																																																																		}
																																																																}
																																																														}
																																																													}
																																																											}
																																																										}
																																																								}
																																																						}
																																																					}
																																																			}
																																																	}
																																															}
																																													}
																																											}
																																										}
																																									else
																																										{	/* Ast/sexp.scm 118 */
																																											if ((BgL_carzd210819zd2_3623 == CNST_TABLE_REF(((long) 17))))
																																												{	/* Ast/sexp.scm 118 */
																																													obj_t
																																														BgL_arg3420z00_3902;
																																													obj_t
																																														BgL_arg3422z00_3903;
																																													BgL_arg3420z00_3902
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_cdrzd210718zd2_3607));
																																													BgL_arg3422z00_3903
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_cdrzd210718zd2_3607));
																																													{
																																														BgL_nodez00_bglt
																																															BgL_auxz00_17923;
																																														{
																																															obj_t
																																																BgL_exprz00_17925;
																																															obj_t
																																																BgL_bindingsz00_17924;
																																															BgL_bindingsz00_17924
																																																=
																																																BgL_arg3420z00_3902;
																																															BgL_exprz00_17925
																																																=
																																																BgL_arg3422z00_3903;
																																															BgL_exprz00_1729
																																																=
																																																BgL_exprz00_17925;
																																															BgL_bindingsz00_1728
																																																=
																																																BgL_bindingsz00_17924;
																																															goto
																																																BgL_tagzd2382zd2_1730;
																																														}
																																														BgL_auxz00_14205
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_17923);
																																													}
																																												}
																																											else
																																												{	/* Ast/sexp.scm 118 */
																																													if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd210819zd2_3623)))
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_arg3424z00_3905;
																																															obj_t
																																																BgL_arg3425z00_3906;
																																															BgL_arg3424z00_3905
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd210718zd2_3607));
																																															BgL_arg3425z00_3906
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd210718zd2_3607));
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_17934;
																																																{
																																																	obj_t
																																																		BgL_exprz00_17936;
																																																	obj_t
																																																		BgL_bindingsz00_17935;
																																																	BgL_bindingsz00_17935
																																																		=
																																																		BgL_arg3424z00_3905;
																																																	BgL_exprz00_17936
																																																		=
																																																		BgL_arg3425z00_3906;
																																																	BgL_exprz00_1729
																																																		=
																																																		BgL_exprz00_17936;
																																																	BgL_bindingsz00_1728
																																																		=
																																																		BgL_bindingsz00_17935;
																																																	goto
																																																		BgL_tagzd2382zd2_1730;
																																																}
																																																BgL_auxz00_14205
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_17934);
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 118 */
																																															if ((BgL_carzd210819zd2_3623 == CNST_TABLE_REF(((long) 18))))
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_arg3427z00_3908;
																																																	obj_t
																																																		BgL_arg3429z00_3909;
																																																	BgL_arg3427z00_3908
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd210718zd2_3607));
																																																	BgL_arg3429z00_3909
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd210718zd2_3607));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_17945;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_17947;
																																																			obj_t
																																																				BgL_bindingsz00_17946;
																																																			BgL_bindingsz00_17946
																																																				=
																																																				BgL_arg3427z00_3908;
																																																			BgL_exprz00_17947
																																																				=
																																																				BgL_arg3429z00_3909;
																																																			BgL_exprz00_1729
																																																				=
																																																				BgL_exprz00_17947;
																																																			BgL_bindingsz00_1728
																																																				=
																																																				BgL_bindingsz00_17946;
																																																			goto
																																																				BgL_tagzd2382zd2_1730;
																																																		}
																																																		BgL_auxz00_14205
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_17945);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_17954;
																																																			goto
																																																				BgL_tagzd2383zd2_1731;
																																																			BgL_auxz00_14205
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_17954);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_carzd213921zd2_3912;
																																																			BgL_carzd213921zd2_3912
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			if ((BgL_carzd213921zd2_3912 == CNST_TABLE_REF(((long) 19))))
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_17961;
																																																					goto
																																																						BgL_tagzd2384zd2_1732;
																																																					BgL_auxz00_14205
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_17961);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd213921zd2_3912)))
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_17966;
																																																							goto
																																																								BgL_tagzd2384zd2_1732;
																																																							BgL_auxz00_14205
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_17966);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_17973;
																																																									goto
																																																										BgL_tagzd2389zd2_1751;
																																																									BgL_auxz00_14205
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_17973);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_17980;
																																																											goto
																																																												BgL_tagzd2390zd2_1752;
																																																											BgL_auxz00_14205
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_17980);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_cdrzd214001zd2_3919;
																																																											BgL_cdrzd214001zd2_3919
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_arg3440z00_3922;
																																																													obj_t
																																																														BgL_arg3442z00_3923;
																																																													BgL_arg3440z00_3922
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_cdrzd214001zd2_3919));
																																																													BgL_arg3442z00_3923
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd214001zd2_3919));
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_17993;
																																																														{
																																																															obj_t
																																																																BgL_restz00_17995;
																																																															obj_t
																																																																BgL_effectz00_17994;
																																																															BgL_effectz00_17994
																																																																=
																																																																BgL_arg3440z00_3922;
																																																															BgL_restz00_17995
																																																																=
																																																																BgL_arg3442z00_3923;
																																																															BgL_restz00_1754
																																																																=
																																																																BgL_restz00_17995;
																																																															BgL_effectz00_1753
																																																																=
																																																																BgL_effectz00_17994;
																																																															goto
																																																																BgL_tagzd2391zd2_1755;
																																																														}
																																																														BgL_auxz00_14205
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_17993);
																																																													}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_18002;
																																																															goto
																																																																BgL_tagzd2392zd2_1756;
																																																															BgL_auxz00_14205
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_18002);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_18009;
																																																																	goto
																																																																		BgL_tagzd2393zd2_1757;
																																																																	BgL_auxz00_14205
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_18009);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_arg3449z00_3931;
																																																																			obj_t
																																																																				BgL_arg3450z00_3932;
																																																																			BgL_arg3449z00_3931
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd214001zd2_3919));
																																																																			BgL_arg3450z00_3932
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd214001zd2_3919));
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_18020;
																																																																				{
																																																																					obj_t
																																																																						BgL_restz00_18022;
																																																																					obj_t
																																																																						BgL_effectz00_18021;
																																																																					BgL_effectz00_18021
																																																																						=
																																																																						BgL_arg3449z00_3931;
																																																																					BgL_restz00_18022
																																																																						=
																																																																						BgL_arg3450z00_3932;
																																																																					BgL_restz00_1759
																																																																						=
																																																																						BgL_restz00_18022;
																																																																					BgL_effectz00_1758
																																																																						=
																																																																						BgL_effectz00_18021;
																																																																					goto
																																																																						BgL_tagzd2394zd2_1760;
																																																																				}
																																																																				BgL_auxz00_14205
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_18020);
																																																																			}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_18029;
																																																																					goto
																																																																						BgL_tagzd2395zd2_1761;
																																																																					BgL_auxz00_14205
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_18029);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_18036;
																																																																							goto
																																																																								BgL_tagzd2396zd2_1762;
																																																																							BgL_auxz00_14205
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_18036);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																								{
																																																																									BgL_letzd2funzd2_bglt
																																																																										BgL_auxz00_18043;
																																																																									goto
																																																																										BgL_tagzd2397zd2_1763;
																																																																									BgL_auxz00_14205
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_18043);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																										{
																																																																											BgL_jumpzd2exzd2itz00_bglt
																																																																												BgL_auxz00_18050;
																																																																											goto
																																																																												BgL_tagzd2398zd2_1764;
																																																																											BgL_auxz00_14205
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_18050);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 30))))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													bool_t
																																																																														BgL_test8693z00_18057;
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_tmpz00_18058;
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_pairz00_10795;
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_pairz00_10794;
																																																																																BgL_pairz00_10794
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_expz00_21));
																																																																																BgL_pairz00_10795
																																																																																	=
																																																																																	CDR
																																																																																	(BgL_pairz00_10794);
																																																																															}
																																																																															BgL_tmpz00_18058
																																																																																=
																																																																																CDR
																																																																																(BgL_pairz00_10795);
																																																																														}
																																																																														BgL_test8693z00_18057
																																																																															=
																																																																															NULLP
																																																																															(BgL_tmpz00_18058);
																																																																													}
																																																																													if (BgL_test8693z00_18057)
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_18064;
																																																																														BgL_tagzd2399zd2_1765:
																																																																															BgL_auxz00_18064 = BGl_applycationzd2ze3nodez31zzast_applyz00(BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																															BgL_auxz00_14205
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_18064);
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1774;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_18069;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1775;
																																																																																	BgL_auxz00_14205
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_18069);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_cdrzd214094zd2_3951;
																																																																													BgL_cdrzd214094zd2_3951
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_arg3474z00_3954;
																																																																															obj_t
																																																																																BgL_arg3476z00_3955;
																																																																															BgL_arg3474z00_3954
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd214094zd2_3951));
																																																																															BgL_arg3476z00_3955
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_cdrzd214094zd2_3951));
																																																																															{	/* Ast/sexp.scm 551 */
																																																																																obj_t
																																																																																	BgL_arg6989z00_10801;
																																																																																BgL_arg6989z00_10801
																																																																																	=
																																																																																	BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																	(BgL_expz00_21,
																																																																																	BgL_locz00_23);
																																																																																BgL_auxz00_14205
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																	(BgL_expz00_21,
																																																																																		BgL_arg3474z00_3954,
																																																																																		CNST_TABLE_REF
																																																																																		(((long) 4)), BgL_arg3476z00_3955, BgL_stackz00_22, BgL_arg6989z00_10801, BgL_sitez00_24));
																																																																														}}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1774;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_18088;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1775;
																																																																																	BgL_auxz00_14205
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_18088);
																																																																																}
																																																																														}
																																																																												}
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																													else
																														{	/* Ast/sexp.scm 118 */
																															obj_t
																																BgL_carzd214119zd2_3972;
																															BgL_carzd214119zd2_3972
																																=
																																CAR(((obj_t)
																																	BgL_expz00_21));
																															if (
																																(BgL_carzd214119zd2_3972
																																	==
																																	CNST_TABLE_REF
																																	(((long) 1))))
																																{
																																	BgL_nodez00_bglt
																																		BgL_auxz00_18095;
																																	goto
																																		BgL_tagzd2377zd2_1719;
																																	BgL_auxz00_14205
																																		=
																																		((obj_t)
																																		BgL_auxz00_18095);
																																}
																															else
																																{	/* Ast/sexp.scm 118 */
																																	if (
																																		(BgL_carzd214119zd2_3972
																																			==
																																			BGl_za2ifza2z00zzast_sexpz00))
																																		{
																																			BgL_nodez00_bglt
																																				BgL_auxz00_18099;
																																			goto
																																				BgL_tagzd2377zd2_1719;
																																			BgL_auxz00_14205
																																				=
																																				((obj_t)
																																				BgL_auxz00_18099);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 118 */
																																			obj_t
																																				BgL_cdrzd214141zd2_3975;
																																			BgL_cdrzd214141zd2_3975
																																				=
																																				CDR((
																																					(obj_t)
																																					BgL_expz00_21));
																																			if ((CAR((
																																							(obj_t)
																																							BgL_expz00_21))
																																					==
																																					CNST_TABLE_REF
																																					(((long) 7))))
																																				{	/* Ast/sexp.scm 118 */
																																					obj_t
																																						BgL_carzd214144zd2_3978;
																																					obj_t
																																						BgL_cdrzd214145zd2_3979;
																																					BgL_carzd214144zd2_3978
																																						=
																																						CAR(
																																						((obj_t) BgL_cdrzd214141zd2_3975));
																																					BgL_cdrzd214145zd2_3979
																																						=
																																						CDR(
																																						((obj_t) BgL_cdrzd214141zd2_3975));
																																					if (PAIRP(BgL_carzd214144zd2_3978))
																																						{	/* Ast/sexp.scm 118 */
																																							if ((CAR(BgL_carzd214144zd2_3978) == CNST_TABLE_REF(((long) 14))))
																																								{	/* Ast/sexp.scm 118 */
																																									if (NULLP(CDR(((obj_t) BgL_cdrzd214145zd2_3979))))
																																										{	/* Ast/sexp.scm 118 */
																																											obj_t
																																												BgL_arg3509z00_3985;
																																											obj_t
																																												BgL_arg3510z00_3986;
																																											BgL_arg3509z00_3985
																																												=
																																												CDR
																																												(BgL_carzd214144zd2_3978);
																																											BgL_arg3510z00_3986
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_cdrzd214145zd2_3979));
																																											{
																																												BgL_nodez00_bglt
																																													BgL_auxz00_18125;
																																												{
																																													obj_t
																																														BgL_valz00_18127;
																																													obj_t
																																														BgL_lz00_18126;
																																													BgL_lz00_18126
																																														=
																																														BgL_arg3509z00_3985;
																																													BgL_valz00_18127
																																														=
																																														BgL_arg3510z00_3986;
																																													BgL_valz00_1721
																																														=
																																														BgL_valz00_18127;
																																													BgL_lz00_1720
																																														=
																																														BgL_lz00_18126;
																																													goto
																																														BgL_tagzd2378zd2_1722;
																																												}
																																												BgL_auxz00_14205
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_18125);
																																											}
																																										}
																																									else
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_18129;
																																											goto
																																												BgL_tagzd2379zd2_1723;
																																											BgL_auxz00_14205
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_18129);
																																										}
																																								}
																																							else
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_18131;
																																									goto
																																										BgL_tagzd2379zd2_1723;
																																									BgL_auxz00_14205
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_18131);
																																								}
																																						}
																																					else
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_18133;
																																							goto
																																								BgL_tagzd2379zd2_1723;
																																							BgL_auxz00_14205
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_18133);
																																						}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 118 */
																																					if (
																																						(CAR
																																							(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_18140;
																																							goto
																																								BgL_tagzd2380zd2_1724;
																																							BgL_auxz00_14205
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_18140);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 118 */
																																							obj_t
																																								BgL_carzd214242zd2_3991;
																																							BgL_carzd214242zd2_3991
																																								=
																																								CAR
																																								(
																																								((obj_t) BgL_expz00_21));
																																							if (PAIRP(BgL_carzd214242zd2_3991))
																																								{	/* Ast/sexp.scm 118 */
																																									obj_t
																																										BgL_carzd214245zd2_3993;
																																									obj_t
																																										BgL_cdrzd214246zd2_3994;
																																									BgL_carzd214245zd2_3993
																																										=
																																										CAR
																																										(BgL_carzd214242zd2_3991);
																																									BgL_cdrzd214246zd2_3994
																																										=
																																										CDR
																																										(BgL_carzd214242zd2_3991);
																																									{

																																										if ((BgL_carzd214245zd2_3993 == CNST_TABLE_REF(((long) 17))))
																																											{	/* Ast/sexp.scm 118 */
																																											BgL_kapzd214247zd2_3995:
																																												if (PAIRP(BgL_cdrzd214246zd2_3994))
																																													{	/* Ast/sexp.scm 118 */
																																														obj_t
																																															BgL_cdrzd214250zd2_4120;
																																														BgL_cdrzd214250zd2_4120
																																															=
																																															CDR
																																															(BgL_cdrzd214246zd2_3994);
																																														if (PAIRP(BgL_cdrzd214250zd2_4120))
																																															{	/* Ast/sexp.scm 118 */
																																																if (NULLP(CDR(BgL_cdrzd214250zd2_4120)))
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_arg3610z00_4124;
																																																		obj_t
																																																			BgL_arg3611z00_4125;
																																																		BgL_arg3610z00_4124
																																																			=
																																																			CAR
																																																			(BgL_cdrzd214250zd2_4120);
																																																		BgL_arg3611z00_4125
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_18162;
																																																			{
																																																				obj_t
																																																					BgL_argsz00_18164;
																																																				obj_t
																																																					BgL_bodyz00_18163;
																																																				BgL_bodyz00_18163
																																																					=
																																																					BgL_arg3610z00_4124;
																																																				BgL_argsz00_18164
																																																					=
																																																					BgL_arg3611z00_4125;
																																																				BgL_argsz00_1726
																																																					=
																																																					BgL_argsz00_18164;
																																																				BgL_bodyz00_1725
																																																					=
																																																					BgL_bodyz00_18163;
																																																				goto
																																																					BgL_tagzd2381zd2_1727;
																																																			}
																																																			BgL_auxz00_14205
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_18162);
																																																		}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_cdrzd214274zd2_4126;
																																																		BgL_cdrzd214274zd2_4126
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 118 */
																																																			bool_t
																																																				BgL_test8709z00_18168;
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_arg3688z00_4237;
																																																				BgL_arg3688z00_4237
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test8709z00_18168
																																																					=
																																																					CBOOL
																																																					(BGl_letzd2symzf3z21zzast_letz00
																																																					(BgL_arg3688z00_4237));
																																																			}
																																																			if (BgL_test8709z00_18168)
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_arg3615z00_4129;
																																																					obj_t
																																																						BgL_arg3616z00_4130;
																																																					BgL_arg3615z00_4129
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd214274zd2_4126));
																																																					BgL_arg3616z00_4130
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd214274zd2_4126));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_18177;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_18179;
																																																							obj_t
																																																								BgL_bindingsz00_18178;
																																																							BgL_bindingsz00_18178
																																																								=
																																																								BgL_arg3615z00_4129;
																																																							BgL_exprz00_18179
																																																								=
																																																								BgL_arg3616z00_4130;
																																																							BgL_exprz00_1729
																																																								=
																																																								BgL_exprz00_18179;
																																																							BgL_bindingsz00_1728
																																																								=
																																																								BgL_bindingsz00_18178;
																																																							goto
																																																								BgL_tagzd2382zd2_1730;
																																																						}
																																																						BgL_auxz00_14205
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_18177);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					bool_t
																																																						BgL_test8710z00_18181;
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_arg3687z00_4236;
																																																						BgL_arg3687z00_4236
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test8710z00_18181
																																																							=
																																																							CBOOL
																																																							(BGl_labelszd2symzf3z21zzast_labelsz00
																																																							(BgL_arg3687z00_4236));
																																																					}
																																																					if (BgL_test8710z00_18181)
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_18186;
																																																							goto
																																																								BgL_tagzd2384zd2_1732;
																																																							BgL_auxz00_14205
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_18186);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_carzd214341zd2_4133;
																																																							BgL_carzd214341zd2_4133
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_cdrzd214346zd2_4134;
																																																								BgL_cdrzd214346zd2_4134
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_carzd214341zd2_4133));
																																																								if ((CAR(((obj_t) BgL_carzd214341zd2_4133)) == CNST_TABLE_REF(((long) 3))))
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_arg3624z00_4137;
																																																										obj_t
																																																											BgL_arg3625z00_4138;
																																																										obj_t
																																																											BgL_arg3626z00_4139;
																																																										BgL_arg3624z00_4137
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_cdrzd214346zd2_4134));
																																																										BgL_arg3625z00_4138
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_cdrzd214346zd2_4134));
																																																										BgL_arg3626z00_4139
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_18203;
																																																											{
																																																												obj_t
																																																													BgL_argsz00_18206;
																																																												obj_t
																																																													BgL_bodyz00_18205;
																																																												obj_t
																																																													BgL_varsz00_18204;
																																																												BgL_varsz00_18204
																																																													=
																																																													BgL_arg3624z00_4137;
																																																												BgL_bodyz00_18205
																																																													=
																																																													BgL_arg3625z00_4138;
																																																												BgL_argsz00_18206
																																																													=
																																																													BgL_arg3626z00_4139;
																																																												BgL_argsz00_1739
																																																													=
																																																													BgL_argsz00_18206;
																																																												BgL_bodyz00_1738
																																																													=
																																																													BgL_bodyz00_18205;
																																																												BgL_varsz00_1737
																																																													=
																																																													BgL_varsz00_18204;
																																																												goto
																																																													BgL_tagzd2386zd2_1740;
																																																											}
																																																											BgL_auxz00_14205
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_18203);
																																																										}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_cdrzd214369zd2_4141;
																																																										BgL_cdrzd214369zd2_4141
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_cdrzd214375zd2_4142;
																																																											BgL_cdrzd214375zd2_4142
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_carzd214341zd2_4133));
																																																											if ((CAR(((obj_t) BgL_carzd214341zd2_4133)) == CNST_TABLE_REF(((long) 1))))
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_cdrzd214381zd2_4145;
																																																													BgL_cdrzd214381zd2_4145
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd214375zd2_4142));
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_carzd214386zd2_4146;
																																																														obj_t
																																																															BgL_cdrzd214387zd2_4147;
																																																														BgL_carzd214386zd2_4146
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd214381zd2_4145));
																																																														BgL_cdrzd214387zd2_4147
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd214381zd2_4145));
																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd214386zd2_4146))
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (PAIRP(BgL_cdrzd214387zd2_4147))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_carzd214394zd2_4150;
																																																																		BgL_carzd214394zd2_4150
																																																																			=
																																																																			CAR
																																																																			(BgL_cdrzd214387zd2_4147);
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd214394zd2_4150))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (NULLP(CDR(BgL_cdrzd214387zd2_4147)))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						bool_t
																																																																							BgL_test8717z00_18233;
																																																																						{
																																																																							obj_t
																																																																								BgL_l1388z00_4183;
																																																																							BgL_l1388z00_4183
																																																																								=
																																																																								BgL_cdrzd214369zd2_4141;
																																																																						BgL_zc3z04anonymousza33652ze3z87_4184:
																																																																							if (NULLP(BgL_l1388z00_4183))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									BgL_test8717z00_18233
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										1);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									bool_t
																																																																										BgL_test8719z00_18236;
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										bool_t
																																																																											BgL_test8720z00_18237;
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_tmpz00_18238;
																																																																											BgL_tmpz00_18238
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_l1388z00_4183));
																																																																											BgL_test8720z00_18237
																																																																												=
																																																																												PAIRP
																																																																												(BgL_tmpz00_18238);
																																																																										}
																																																																										if (BgL_test8720z00_18237)
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												BgL_test8719z00_18236
																																																																													=
																																																																													(
																																																																													(bool_t)
																																																																													0);
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												BgL_test8719z00_18236
																																																																													=
																																																																													(
																																																																													(bool_t)
																																																																													1);
																																																																											}
																																																																									}
																																																																									if (BgL_test8719z00_18236)
																																																																										{
																																																																											obj_t
																																																																												BgL_l1388z00_18242;
																																																																											BgL_l1388z00_18242
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_l1388z00_4183));
																																																																											BgL_l1388z00_4183
																																																																												=
																																																																												BgL_l1388z00_18242;
																																																																											goto
																																																																												BgL_zc3z04anonymousza33652ze3z87_4184;
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											BgL_test8717z00_18233
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												0);
																																																																										}
																																																																								}
																																																																						}
																																																																						if (BgL_test8717z00_18233)
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_arg3640z00_4166;
																																																																								BgL_arg3640z00_4166
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd214375zd2_4142));
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_18247;
																																																																									{
																																																																										obj_t
																																																																											BgL_argsz00_18251;
																																																																										obj_t
																																																																											BgL_proc2z00_18250;
																																																																										obj_t
																																																																											BgL_proc1z00_18249;
																																																																										obj_t
																																																																											BgL_testz00_18248;
																																																																										BgL_testz00_18248
																																																																											=
																																																																											BgL_arg3640z00_4166;
																																																																										BgL_proc1z00_18249
																																																																											=
																																																																											BgL_carzd214386zd2_4146;
																																																																										BgL_proc2z00_18250
																																																																											=
																																																																											BgL_carzd214394zd2_4150;
																																																																										BgL_argsz00_18251
																																																																											=
																																																																											BgL_cdrzd214369zd2_4141;
																																																																										BgL_argsz00_1744
																																																																											=
																																																																											BgL_argsz00_18251;
																																																																										BgL_proc2z00_1743
																																																																											=
																																																																											BgL_proc2z00_18250;
																																																																										BgL_proc1z00_1742
																																																																											=
																																																																											BgL_proc1z00_18249;
																																																																										BgL_testz00_1741
																																																																											=
																																																																											BgL_testz00_18248;
																																																																										goto
																																																																											BgL_tagzd2387zd2_1745;
																																																																									}
																																																																									BgL_auxz00_14205
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_18247);
																																																																								}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_cdrzd214418zd2_4167;
																																																																								BgL_cdrzd214418zd2_4167
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_cdrzd214425zd2_4168;
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_pairz00_10854;
																																																																										BgL_pairz00_10854
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										BgL_cdrzd214425zd2_4168
																																																																											=
																																																																											CDR
																																																																											(BgL_pairz00_10854);
																																																																									}
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_cdrzd214432zd2_4169;
																																																																										BgL_cdrzd214432zd2_4169
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd214425zd2_4168));
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_carzd214438zd2_4170;
																																																																											BgL_carzd214438zd2_4170
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd214432zd2_4169));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd214438zd2_4170))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_carzd214445zd2_4172;
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_pairz00_10858;
																																																																														BgL_pairz00_10858
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd214432zd2_4169));
																																																																														BgL_carzd214445zd2_4172
																																																																															=
																																																																															CAR
																																																																															(BgL_pairz00_10858);
																																																																													}
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd214445zd2_4172))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd214418zd2_4167))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_arg3644z00_4175;
																																																																																	BgL_arg3644z00_4175
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd214425zd2_4168));
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_18273;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_18277;
																																																																																			obj_t
																																																																																				BgL_proc2z00_18276;
																																																																																			obj_t
																																																																																				BgL_proc1z00_18275;
																																																																																			obj_t
																																																																																				BgL_testz00_18274;
																																																																																			BgL_testz00_18274
																																																																																				=
																																																																																				BgL_arg3644z00_4175;
																																																																																			BgL_proc1z00_18275
																																																																																				=
																																																																																				BgL_carzd214438zd2_4170;
																																																																																			BgL_proc2z00_18276
																																																																																				=
																																																																																				BgL_carzd214445zd2_4172;
																																																																																			BgL_argsz00_18277
																																																																																				=
																																																																																				BgL_cdrzd214418zd2_4167;
																																																																																			BgL_argsz00_1749
																																																																																				=
																																																																																				BgL_argsz00_18277;
																																																																																			BgL_proc2z00_1748
																																																																																				=
																																																																																				BgL_proc2z00_18276;
																																																																																			BgL_proc1z00_1747
																																																																																				=
																																																																																				BgL_proc1z00_18275;
																																																																																			BgL_testz00_1746
																																																																																				=
																																																																																				BgL_testz00_18274;
																																																																																			goto
																																																																																				BgL_tagzd2388zd2_1750;
																																																																																		}
																																																																																		BgL_auxz00_14205
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_18273);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1774;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_18281;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1775;
																																																																																			BgL_auxz00_14205
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_18281);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1774;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_18285;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1775;
																																																																																	BgL_auxz00_14205
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_18285);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1774;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_18289;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1775;
																																																																															BgL_auxz00_14205
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_18289);
																																																																														}
																																																																												}
																																																																										}
																																																																									}
																																																																								}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1774;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_18293;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1775;
																																																																								BgL_auxz00_14205
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_18293);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_cdrzd214721zd2_4194;
																																																																				BgL_cdrzd214721zd2_4194
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_cdrzd214727zd2_4195;
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_pairz00_10862;
																																																																						BgL_pairz00_10862
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						BgL_cdrzd214727zd2_4195
																																																																							=
																																																																							CDR
																																																																							(BgL_pairz00_10862);
																																																																					}
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_cdrzd214733zd2_4196;
																																																																						BgL_cdrzd214733zd2_4196
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd214727zd2_4195));
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_carzd214738zd2_4197;
																																																																							obj_t
																																																																								BgL_cdrzd214739zd2_4198;
																																																																							BgL_carzd214738zd2_4197
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd214733zd2_4196));
																																																																							BgL_cdrzd214739zd2_4198
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd214733zd2_4196));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd214738zd2_4197))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_carzd214744zd2_4200;
																																																																									BgL_carzd214744zd2_4200
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd214739zd2_4198));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd214744zd2_4200))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (NULLP(CDR(((obj_t) BgL_cdrzd214739zd2_4198))))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd214721zd2_4194))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_arg3662z00_4205;
																																																																															BgL_arg3662z00_4205
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd214727zd2_4195));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_18320;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_18324;
																																																																																	obj_t
																																																																																		BgL_proc2z00_18323;
																																																																																	obj_t
																																																																																		BgL_proc1z00_18322;
																																																																																	obj_t
																																																																																		BgL_testz00_18321;
																																																																																	BgL_testz00_18321
																																																																																		=
																																																																																		BgL_arg3662z00_4205;
																																																																																	BgL_proc1z00_18322
																																																																																		=
																																																																																		BgL_carzd214738zd2_4197;
																																																																																	BgL_proc2z00_18323
																																																																																		=
																																																																																		BgL_carzd214744zd2_4200;
																																																																																	BgL_argsz00_18324
																																																																																		=
																																																																																		BgL_cdrzd214721zd2_4194;
																																																																																	BgL_argsz00_1749
																																																																																		=
																																																																																		BgL_argsz00_18324;
																																																																																	BgL_proc2z00_1748
																																																																																		=
																																																																																		BgL_proc2z00_18323;
																																																																																	BgL_proc1z00_1747
																																																																																		=
																																																																																		BgL_proc1z00_18322;
																																																																																	BgL_testz00_1746
																																																																																		=
																																																																																		BgL_testz00_18321;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1750;
																																																																																}
																																																																																BgL_auxz00_14205
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_18320);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1774;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_18328;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1775;
																																																																																	BgL_auxz00_14205
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_18328);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1774;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_18332;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1775;
																																																																															BgL_auxz00_14205
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_18332);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1774;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_18336;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1775;
																																																																													BgL_auxz00_14205
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_18336);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1774;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_18340;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1775;
																																																																											BgL_auxz00_14205
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_18340);
																																																																										}
																																																																								}
																																																																						}
																																																																					}
																																																																				}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1774;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_18344;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1775;
																																																																				BgL_auxz00_14205
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_18344);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_cdrzd215077zd2_4213;
																																																																BgL_cdrzd215077zd2_4213
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd215084zd2_4214;
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_pairz00_10872;
																																																																		BgL_pairz00_10872
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		BgL_cdrzd215084zd2_4214
																																																																			=
																																																																			CDR
																																																																			(BgL_pairz00_10872);
																																																																	}
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_cdrzd215091zd2_4215;
																																																																		BgL_cdrzd215091zd2_4215
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd215084zd2_4214));
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_carzd215097zd2_4216;
																																																																			obj_t
																																																																				BgL_cdrzd215098zd2_4217;
																																																																			BgL_carzd215097zd2_4216
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd215091zd2_4215));
																																																																			BgL_cdrzd215098zd2_4217
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd215091zd2_4215));
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd215097zd2_4216))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (PAIRP(BgL_cdrzd215098zd2_4217))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_carzd215105zd2_4220;
																																																																							BgL_carzd215105zd2_4220
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd215098zd2_4217);
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd215105zd2_4220))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (NULLP(CDR(BgL_cdrzd215098zd2_4217)))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd215077zd2_4213))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_arg3676z00_4225;
																																																																													BgL_arg3676z00_4225
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd215084zd2_4214));
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_18371;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_18375;
																																																																															obj_t
																																																																																BgL_proc2z00_18374;
																																																																															obj_t
																																																																																BgL_proc1z00_18373;
																																																																															obj_t
																																																																																BgL_testz00_18372;
																																																																															BgL_testz00_18372
																																																																																=
																																																																																BgL_arg3676z00_4225;
																																																																															BgL_proc1z00_18373
																																																																																=
																																																																																BgL_carzd215097zd2_4216;
																																																																															BgL_proc2z00_18374
																																																																																=
																																																																																BgL_carzd215105zd2_4220;
																																																																															BgL_argsz00_18375
																																																																																=
																																																																																BgL_cdrzd215077zd2_4213;
																																																																															BgL_argsz00_1749
																																																																																=
																																																																																BgL_argsz00_18375;
																																																																															BgL_proc2z00_1748
																																																																																=
																																																																																BgL_proc2z00_18374;
																																																																															BgL_proc1z00_1747
																																																																																=
																																																																																BgL_proc1z00_18373;
																																																																															BgL_testz00_1746
																																																																																=
																																																																																BgL_testz00_18372;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1750;
																																																																														}
																																																																														BgL_auxz00_14205
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_18371);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1774;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_18379;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1775;
																																																																															BgL_auxz00_14205
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_18379);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1774;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_18383;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1775;
																																																																													BgL_auxz00_14205
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_18383);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1774;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_18387;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1775;
																																																																											BgL_auxz00_14205
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_18387);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1774;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_18391;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1775;
																																																																									BgL_auxz00_14205
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_18391);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1774;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_18395;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1775;
																																																																							BgL_auxz00_14205
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_18395);
																																																																						}
																																																																				}
																																																																		}
																																																																	}
																																																																}
																																																															}
																																																													}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{	/* Ast/sexp.scm 118 */
																																																															goto
																																																																BgL_tagzd2403zd2_1774;
																																																														}
																																																													else
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_18399;
																																																															goto
																																																																BgL_tagzd2404zd2_1775;
																																																															BgL_auxz00_14205
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_18399);
																																																														}
																																																												}
																																																										}
																																																									}
																																																							}
																																																						}
																																																				}
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_cdrzd215498zd2_4239;
																																																BgL_cdrzd215498zd2_4239
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 118 */
																																																	bool_t
																																																		BgL_test8748z00_18403;
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_arg3705z00_4256;
																																																		BgL_arg3705z00_4256
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_test8748z00_18403
																																																			=
																																																			CBOOL
																																																			(BGl_letzd2symzf3z21zzast_letz00
																																																			(BgL_arg3705z00_4256));
																																																	}
																																																	if (BgL_test8748z00_18403)
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_arg3692z00_4242;
																																																			obj_t
																																																				BgL_arg3693z00_4243;
																																																			BgL_arg3692z00_4242
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd215498zd2_4239));
																																																			BgL_arg3693z00_4243
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd215498zd2_4239));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_18412;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_18414;
																																																					obj_t
																																																						BgL_bindingsz00_18413;
																																																					BgL_bindingsz00_18413
																																																						=
																																																						BgL_arg3692z00_4242;
																																																					BgL_exprz00_18414
																																																						=
																																																						BgL_arg3693z00_4243;
																																																					BgL_exprz00_1729
																																																						=
																																																						BgL_exprz00_18414;
																																																					BgL_bindingsz00_1728
																																																						=
																																																						BgL_bindingsz00_18413;
																																																					goto
																																																						BgL_tagzd2382zd2_1730;
																																																				}
																																																				BgL_auxz00_14205
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_18412);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			bool_t
																																																				BgL_test8749z00_18416;
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_arg3704z00_4255;
																																																				BgL_arg3704z00_4255
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test8749z00_18416
																																																					=
																																																					CBOOL
																																																					(BGl_labelszd2symzf3z21zzast_labelsz00
																																																					(BgL_arg3704z00_4255));
																																																			}
																																																			if (BgL_test8749z00_18416)
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_18421;
																																																					goto
																																																						BgL_tagzd2384zd2_1732;
																																																					BgL_auxz00_14205
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_18421);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_carzd215564zd2_4246;
																																																					BgL_carzd215564zd2_4246
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_cdrzd215569zd2_4247;
																																																						BgL_cdrzd215569zd2_4247
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_carzd215564zd2_4246));
																																																						if ((CAR(((obj_t) BgL_carzd215564zd2_4246)) == CNST_TABLE_REF(((long) 3))))
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_arg3698z00_4250;
																																																								obj_t
																																																									BgL_arg3699z00_4251;
																																																								obj_t
																																																									BgL_arg3700z00_4252;
																																																								BgL_arg3698z00_4250
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_cdrzd215569zd2_4247));
																																																								BgL_arg3699z00_4251
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_cdrzd215569zd2_4247));
																																																								BgL_arg3700z00_4252
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_18438;
																																																									{
																																																										obj_t
																																																											BgL_argsz00_18441;
																																																										obj_t
																																																											BgL_bodyz00_18440;
																																																										obj_t
																																																											BgL_varsz00_18439;
																																																										BgL_varsz00_18439
																																																											=
																																																											BgL_arg3698z00_4250;
																																																										BgL_bodyz00_18440
																																																											=
																																																											BgL_arg3699z00_4251;
																																																										BgL_argsz00_18441
																																																											=
																																																											BgL_arg3700z00_4252;
																																																										BgL_argsz00_1739
																																																											=
																																																											BgL_argsz00_18441;
																																																										BgL_bodyz00_1738
																																																											=
																																																											BgL_bodyz00_18440;
																																																										BgL_varsz00_1737
																																																											=
																																																											BgL_varsz00_18439;
																																																										goto
																																																											BgL_tagzd2386zd2_1740;
																																																									}
																																																									BgL_auxz00_14205
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_18438);
																																																								}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 118 */
																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																									{	/* Ast/sexp.scm 118 */
																																																										goto
																																																											BgL_tagzd2403zd2_1774;
																																																									}
																																																								else
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_18445;
																																																										goto
																																																											BgL_tagzd2404zd2_1775;
																																																										BgL_auxz00_14205
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_18445);
																																																									}
																																																							}
																																																					}
																																																				}
																																																		}
																																																}
																																															}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														obj_t
																																															BgL_cdrzd215680zd2_4257;
																																														BgL_cdrzd215680zd2_4257
																																															=
																																															CDR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														{	/* Ast/sexp.scm 118 */
																																															bool_t
																																																BgL_test8752z00_18449;
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_arg3715z00_4266;
																																																BgL_arg3715z00_4266
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																BgL_test8752z00_18449
																																																	=
																																																	CBOOL
																																																	(BGl_letzd2symzf3z21zzast_letz00
																																																	(BgL_arg3715z00_4266));
																																															}
																																															if (BgL_test8752z00_18449)
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_arg3709z00_4260;
																																																	obj_t
																																																		BgL_arg3710z00_4261;
																																																	BgL_arg3709z00_4260
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd215680zd2_4257));
																																																	BgL_arg3710z00_4261
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd215680zd2_4257));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_18458;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_18460;
																																																			obj_t
																																																				BgL_bindingsz00_18459;
																																																			BgL_bindingsz00_18459
																																																				=
																																																				BgL_arg3709z00_4260;
																																																			BgL_exprz00_18460
																																																				=
																																																				BgL_arg3710z00_4261;
																																																			BgL_exprz00_1729
																																																				=
																																																				BgL_exprz00_18460;
																																																			BgL_bindingsz00_1728
																																																				=
																																																				BgL_bindingsz00_18459;
																																																			goto
																																																				BgL_tagzd2382zd2_1730;
																																																		}
																																																		BgL_auxz00_14205
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_18458);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	bool_t
																																																		BgL_test8753z00_18462;
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_arg3714z00_4265;
																																																		BgL_arg3714z00_4265
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_test8753z00_18462
																																																			=
																																																			CBOOL
																																																			(BGl_labelszd2symzf3z21zzast_labelsz00
																																																			(BgL_arg3714z00_4265));
																																																	}
																																																	if (BgL_test8753z00_18462)
																																																		{
																																																			BgL_letzd2funzd2_bglt
																																																				BgL_auxz00_18467;
																																																			goto
																																																				BgL_tagzd2384zd2_1732;
																																																			BgL_auxz00_14205
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_18467);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																				{	/* Ast/sexp.scm 118 */
																																																					goto
																																																						BgL_tagzd2403zd2_1774;
																																																				}
																																																			else
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_18471;
																																																					goto
																																																						BgL_tagzd2404zd2_1775;
																																																					BgL_auxz00_14205
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_18471);
																																																				}
																																																		}
																																																}
																																														}
																																													}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 118 */
																																												if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd214245zd2_3993)))
																																													{	/* Ast/sexp.scm 118 */
																																														goto
																																															BgL_kapzd214247zd2_3995;
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														if ((BgL_carzd214245zd2_3993 == CNST_TABLE_REF(((long) 18))))
																																															{	/* Ast/sexp.scm 118 */
																																																goto
																																																	BgL_kapzd214247zd2_3995;
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																if ((BgL_carzd214245zd2_3993 == CNST_TABLE_REF(((long) 19))))
																																																	{	/* Ast/sexp.scm 118 */
																																																		goto
																																																			BgL_kapzd214247zd2_3995;
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd214245zd2_3993)))
																																																			{	/* Ast/sexp.scm 118 */
																																																				goto
																																																					BgL_kapzd214247zd2_3995;
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_cdrzd215852zd2_4001;
																																																				BgL_cdrzd215852zd2_4001
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{	/* Ast/sexp.scm 118 */
																																																					bool_t
																																																						BgL_test8759z00_18487;
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_arg3605z00_4118;
																																																						BgL_arg3605z00_4118
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test8759z00_18487
																																																							=
																																																							CBOOL
																																																							(BGl_letzd2symzf3z21zzast_letz00
																																																							(BgL_arg3605z00_4118));
																																																					}
																																																					if (BgL_test8759z00_18487)
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_arg3524z00_4004;
																																																							obj_t
																																																								BgL_arg3526z00_4005;
																																																							BgL_arg3524z00_4004
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd215852zd2_4001));
																																																							BgL_arg3526z00_4005
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd215852zd2_4001));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_18496;
																																																								{
																																																									obj_t
																																																										BgL_exprz00_18498;
																																																									obj_t
																																																										BgL_bindingsz00_18497;
																																																									BgL_bindingsz00_18497
																																																										=
																																																										BgL_arg3524z00_4004;
																																																									BgL_exprz00_18498
																																																										=
																																																										BgL_arg3526z00_4005;
																																																									BgL_exprz00_1729
																																																										=
																																																										BgL_exprz00_18498;
																																																									BgL_bindingsz00_1728
																																																										=
																																																										BgL_bindingsz00_18497;
																																																									goto
																																																										BgL_tagzd2382zd2_1730;
																																																								}
																																																								BgL_auxz00_14205
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_18496);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							bool_t
																																																								BgL_test8760z00_18500;
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_arg3604z00_4117;
																																																								BgL_arg3604z00_4117
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test8760z00_18500
																																																									=
																																																									CBOOL
																																																									(BGl_labelszd2symzf3z21zzast_labelsz00
																																																									(BgL_arg3604z00_4117));
																																																							}
																																																							if (BgL_test8760z00_18500)
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_18505;
																																																									goto
																																																										BgL_tagzd2384zd2_1732;
																																																									BgL_auxz00_14205
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_18505);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_carzd215918zd2_4008;
																																																									BgL_carzd215918zd2_4008
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_cdrzd215923zd2_4009;
																																																										BgL_cdrzd215923zd2_4009
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_carzd215918zd2_4008));
																																																										if ((CAR(((obj_t) BgL_carzd215918zd2_4008)) == CNST_TABLE_REF(((long) 3))))
																																																											{	/* Ast/sexp.scm 118 */
																																																												if (PAIRP(BgL_cdrzd215923zd2_4009))
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_arg3532z00_4013;
																																																														obj_t
																																																															BgL_arg3534z00_4014;
																																																														obj_t
																																																															BgL_arg3535z00_4015;
																																																														BgL_arg3532z00_4013
																																																															=
																																																															CAR
																																																															(BgL_cdrzd215923zd2_4009);
																																																														BgL_arg3534z00_4014
																																																															=
																																																															CDR
																																																															(BgL_cdrzd215923zd2_4009);
																																																														BgL_arg3535z00_4015
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_18522;
																																																															{
																																																																obj_t
																																																																	BgL_argsz00_18525;
																																																																obj_t
																																																																	BgL_bodyz00_18524;
																																																																obj_t
																																																																	BgL_varsz00_18523;
																																																																BgL_varsz00_18523
																																																																	=
																																																																	BgL_arg3532z00_4013;
																																																																BgL_bodyz00_18524
																																																																	=
																																																																	BgL_arg3534z00_4014;
																																																																BgL_argsz00_18525
																																																																	=
																																																																	BgL_arg3535z00_4015;
																																																																BgL_argsz00_1739
																																																																	=
																																																																	BgL_argsz00_18525;
																																																																BgL_bodyz00_1738
																																																																	=
																																																																	BgL_bodyz00_18524;
																																																																BgL_varsz00_1737
																																																																	=
																																																																	BgL_varsz00_18523;
																																																																goto
																																																																	BgL_tagzd2386zd2_1740;
																																																															}
																																																															BgL_auxz00_14205
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_18522);
																																																														}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 118 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 118 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1774;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_18529;
																																																																goto
																																																																	BgL_tagzd2404zd2_1775;
																																																																BgL_auxz00_14205
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_18529);
																																																															}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_cdrzd216030zd2_4018;
																																																												BgL_cdrzd216030zd2_4018
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_cdrzd216035zd2_4019;
																																																													BgL_cdrzd216035zd2_4019
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_carzd215918zd2_4008));
																																																													if ((CAR(((obj_t) BgL_carzd215918zd2_4008)) == CNST_TABLE_REF(((long) 1))))
																																																														{	/* Ast/sexp.scm 118 */
																																																															if (PAIRP(BgL_cdrzd216035zd2_4019))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd216040zd2_4023;
																																																																	BgL_cdrzd216040zd2_4023
																																																																		=
																																																																		CDR
																																																																		(BgL_cdrzd216035zd2_4019);
																																																																	if (PAIRP(BgL_cdrzd216040zd2_4023))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_carzd216044zd2_4025;
																																																																			obj_t
																																																																				BgL_cdrzd216045zd2_4026;
																																																																			BgL_carzd216044zd2_4025
																																																																				=
																																																																				CAR
																																																																				(BgL_cdrzd216040zd2_4023);
																																																																			BgL_cdrzd216045zd2_4026
																																																																				=
																																																																				CDR
																																																																				(BgL_cdrzd216040zd2_4023);
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd216044zd2_4025))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (PAIRP(BgL_cdrzd216045zd2_4026))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_carzd216050zd2_4029;
																																																																							BgL_carzd216050zd2_4029
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd216045zd2_4026);
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd216050zd2_4029))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (NULLP(CDR(BgL_cdrzd216045zd2_4026)))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											bool_t
																																																																												BgL_test8771z00_18557;
																																																																											{
																																																																												obj_t
																																																																													BgL_l1391z00_4062;
																																																																												BgL_l1391z00_4062
																																																																													=
																																																																													BgL_cdrzd216030zd2_4018;
																																																																											BgL_zc3z04anonymousza33565ze3z87_4063:
																																																																												if (NULLP(BgL_l1391z00_4062))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														BgL_test8771z00_18557
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															1);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														bool_t
																																																																															BgL_test8773z00_18560;
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															bool_t
																																																																																BgL_test8774z00_18561;
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_tmpz00_18562;
																																																																																BgL_tmpz00_18562
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_l1391z00_4062));
																																																																																BgL_test8774z00_18561
																																																																																	=
																																																																																	PAIRP
																																																																																	(BgL_tmpz00_18562);
																																																																															}
																																																																															if (BgL_test8774z00_18561)
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	BgL_test8773z00_18560
																																																																																		=
																																																																																		(
																																																																																		(bool_t)
																																																																																		0);
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	BgL_test8773z00_18560
																																																																																		=
																																																																																		(
																																																																																		(bool_t)
																																																																																		1);
																																																																																}
																																																																														}
																																																																														if (BgL_test8773z00_18560)
																																																																															{
																																																																																obj_t
																																																																																	BgL_l1391z00_18566;
																																																																																BgL_l1391z00_18566
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_l1391z00_4062));
																																																																																BgL_l1391z00_4062
																																																																																	=
																																																																																	BgL_l1391z00_18566;
																																																																																goto
																																																																																	BgL_zc3z04anonymousza33565ze3z87_4063;
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																BgL_test8771z00_18557
																																																																																	=
																																																																																	(
																																																																																	(bool_t)
																																																																																	0);
																																																																															}
																																																																													}
																																																																											}
																																																																											if (BgL_test8771z00_18557)
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_arg3553z00_4045;
																																																																													BgL_arg3553z00_4045
																																																																														=
																																																																														CAR
																																																																														(BgL_cdrzd216035zd2_4019);
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_18570;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_18574;
																																																																															obj_t
																																																																																BgL_proc2z00_18573;
																																																																															obj_t
																																																																																BgL_proc1z00_18572;
																																																																															obj_t
																																																																																BgL_testz00_18571;
																																																																															BgL_testz00_18571
																																																																																=
																																																																																BgL_arg3553z00_4045;
																																																																															BgL_proc1z00_18572
																																																																																=
																																																																																BgL_carzd216044zd2_4025;
																																																																															BgL_proc2z00_18573
																																																																																=
																																																																																BgL_carzd216050zd2_4029;
																																																																															BgL_argsz00_18574
																																																																																=
																																																																																BgL_cdrzd216030zd2_4018;
																																																																															BgL_argsz00_1744
																																																																																=
																																																																																BgL_argsz00_18574;
																																																																															BgL_proc2z00_1743
																																																																																=
																																																																																BgL_proc2z00_18573;
																																																																															BgL_proc1z00_1742
																																																																																=
																																																																																BgL_proc1z00_18572;
																																																																															BgL_testz00_1741
																																																																																=
																																																																																BgL_testz00_18571;
																																																																															goto
																																																																																BgL_tagzd2387zd2_1745;
																																																																														}
																																																																														BgL_auxz00_14205
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_18570);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_cdrzd216075zd2_4046;
																																																																													BgL_cdrzd216075zd2_4046
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_cdrzd216083zd2_4047;
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_pairz00_10929;
																																																																															BgL_pairz00_10929
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															BgL_cdrzd216083zd2_4047
																																																																																=
																																																																																CDR
																																																																																(BgL_pairz00_10929);
																																																																														}
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_cdrzd216091zd2_4048;
																																																																															BgL_cdrzd216091zd2_4048
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_cdrzd216083zd2_4047));
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_carzd216098zd2_4049;
																																																																																BgL_carzd216098zd2_4049
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd216091zd2_4048));
																																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd216098zd2_4049))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		obj_t
																																																																																			BgL_carzd216107zd2_4051;
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			obj_t
																																																																																				BgL_pairz00_10933;
																																																																																			BgL_pairz00_10933
																																																																																				=
																																																																																				CDR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd216091zd2_4048));
																																																																																			BgL_carzd216107zd2_4051
																																																																																				=
																																																																																				CAR
																																																																																				(BgL_pairz00_10933);
																																																																																		}
																																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd216107zd2_4051))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd216075zd2_4046))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						obj_t
																																																																																							BgL_arg3558z00_4054;
																																																																																						BgL_arg3558z00_4054
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_cdrzd216083zd2_4047));
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_18596;
																																																																																							{
																																																																																								obj_t
																																																																																									BgL_argsz00_18600;
																																																																																								obj_t
																																																																																									BgL_proc2z00_18599;
																																																																																								obj_t
																																																																																									BgL_proc1z00_18598;
																																																																																								obj_t
																																																																																									BgL_testz00_18597;
																																																																																								BgL_testz00_18597
																																																																																									=
																																																																																									BgL_arg3558z00_4054;
																																																																																								BgL_proc1z00_18598
																																																																																									=
																																																																																									BgL_carzd216098zd2_4049;
																																																																																								BgL_proc2z00_18599
																																																																																									=
																																																																																									BgL_carzd216107zd2_4051;
																																																																																								BgL_argsz00_18600
																																																																																									=
																																																																																									BgL_cdrzd216075zd2_4046;
																																																																																								BgL_argsz00_1749
																																																																																									=
																																																																																									BgL_argsz00_18600;
																																																																																								BgL_proc2z00_1748
																																																																																									=
																																																																																									BgL_proc2z00_18599;
																																																																																								BgL_proc1z00_1747
																																																																																									=
																																																																																									BgL_proc1z00_18598;
																																																																																								BgL_testz00_1746
																																																																																									=
																																																																																									BgL_testz00_18597;
																																																																																								goto
																																																																																									BgL_tagzd2388zd2_1750;
																																																																																							}
																																																																																							BgL_auxz00_14205
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_18596);
																																																																																						}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1774;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_18604;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1775;
																																																																																								BgL_auxz00_14205
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_18604);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1774;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_18608;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1775;
																																																																																						BgL_auxz00_14205
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_18608);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1774;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_18612;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1775;
																																																																																				BgL_auxz00_14205
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_18612);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														}
																																																																													}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1774;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_18616;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1775;
																																																																													BgL_auxz00_14205
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_18616);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_cdrzd216385zd2_4073;
																																																																									BgL_cdrzd216385zd2_4073
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_cdrzd216392zd2_4074;
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_pairz00_10937;
																																																																											BgL_pairz00_10937
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											BgL_cdrzd216392zd2_4074
																																																																												=
																																																																												CDR
																																																																												(BgL_pairz00_10937);
																																																																										}
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_cdrzd216399zd2_4075;
																																																																											BgL_cdrzd216399zd2_4075
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd216392zd2_4074));
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_carzd216405zd2_4076;
																																																																												obj_t
																																																																													BgL_cdrzd216406zd2_4077;
																																																																												BgL_carzd216405zd2_4076
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd216399zd2_4075));
																																																																												BgL_cdrzd216406zd2_4077
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd216399zd2_4075));
																																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd216405zd2_4076))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_carzd216413zd2_4079;
																																																																														BgL_carzd216413zd2_4079
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd216406zd2_4077));
																																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd216413zd2_4079))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (NULLP(CDR(((obj_t) BgL_cdrzd216406zd2_4077))))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd216385zd2_4073))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				obj_t
																																																																																					BgL_arg3576z00_4084;
																																																																																				BgL_arg3576z00_4084
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd216392zd2_4074));
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_18643;
																																																																																					{
																																																																																						obj_t
																																																																																							BgL_argsz00_18647;
																																																																																						obj_t
																																																																																							BgL_proc2z00_18646;
																																																																																						obj_t
																																																																																							BgL_proc1z00_18645;
																																																																																						obj_t
																																																																																							BgL_testz00_18644;
																																																																																						BgL_testz00_18644
																																																																																							=
																																																																																							BgL_arg3576z00_4084;
																																																																																						BgL_proc1z00_18645
																																																																																							=
																																																																																							BgL_carzd216405zd2_4076;
																																																																																						BgL_proc2z00_18646
																																																																																							=
																																																																																							BgL_carzd216413zd2_4079;
																																																																																						BgL_argsz00_18647
																																																																																							=
																																																																																							BgL_cdrzd216385zd2_4073;
																																																																																						BgL_argsz00_1749
																																																																																							=
																																																																																							BgL_argsz00_18647;
																																																																																						BgL_proc2z00_1748
																																																																																							=
																																																																																							BgL_proc2z00_18646;
																																																																																						BgL_proc1z00_1747
																																																																																							=
																																																																																							BgL_proc1z00_18645;
																																																																																						BgL_testz00_1746
																																																																																							=
																																																																																							BgL_testz00_18644;
																																																																																						goto
																																																																																							BgL_tagzd2388zd2_1750;
																																																																																					}
																																																																																					BgL_auxz00_14205
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_18643);
																																																																																				}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1774;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_18651;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1775;
																																																																																						BgL_auxz00_14205
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_18651);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1774;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_18655;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1775;
																																																																																				BgL_auxz00_14205
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_18655);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1774;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_18659;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1775;
																																																																																		BgL_auxz00_14205
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_18659);
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1774;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_18663;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1775;
																																																																																BgL_auxz00_14205
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_18663);
																																																																															}
																																																																													}
																																																																											}
																																																																										}
																																																																									}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1774;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_18667;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1775;
																																																																									BgL_auxz00_14205
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_18667);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_cdrzd216746zd2_4092;
																																																																					BgL_cdrzd216746zd2_4092
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_expz00_21));
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_cdrzd216752zd2_4093;
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_pairz00_10947;
																																																																							BgL_pairz00_10947
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							BgL_cdrzd216752zd2_4093
																																																																								=
																																																																								CDR
																																																																								(BgL_pairz00_10947);
																																																																						}
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_cdrzd216758zd2_4094;
																																																																							BgL_cdrzd216758zd2_4094
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd216752zd2_4093));
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_carzd216763zd2_4095;
																																																																								obj_t
																																																																									BgL_cdrzd216764zd2_4096;
																																																																								BgL_carzd216763zd2_4095
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd216758zd2_4094));
																																																																								BgL_cdrzd216764zd2_4096
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd216758zd2_4094));
																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd216763zd2_4095))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (PAIRP(BgL_cdrzd216764zd2_4096))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_carzd216769zd2_4099;
																																																																												BgL_carzd216769zd2_4099
																																																																													=
																																																																													CAR
																																																																													(BgL_cdrzd216764zd2_4096);
																																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd216769zd2_4099))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														if (NULLP(CDR(BgL_cdrzd216764zd2_4096)))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd216746zd2_4092))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		obj_t
																																																																																			BgL_arg3590z00_4104;
																																																																																		BgL_arg3590z00_4104
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd216752zd2_4093));
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_18694;
																																																																																			{
																																																																																				obj_t
																																																																																					BgL_argsz00_18698;
																																																																																				obj_t
																																																																																					BgL_proc2z00_18697;
																																																																																				obj_t
																																																																																					BgL_proc1z00_18696;
																																																																																				obj_t
																																																																																					BgL_testz00_18695;
																																																																																				BgL_testz00_18695
																																																																																					=
																																																																																					BgL_arg3590z00_4104;
																																																																																				BgL_proc1z00_18696
																																																																																					=
																																																																																					BgL_carzd216763zd2_4095;
																																																																																				BgL_proc2z00_18697
																																																																																					=
																																																																																					BgL_carzd216769zd2_4099;
																																																																																				BgL_argsz00_18698
																																																																																					=
																																																																																					BgL_cdrzd216746zd2_4092;
																																																																																				BgL_argsz00_1749
																																																																																					=
																																																																																					BgL_argsz00_18698;
																																																																																				BgL_proc2z00_1748
																																																																																					=
																																																																																					BgL_proc2z00_18697;
																																																																																				BgL_proc1z00_1747
																																																																																					=
																																																																																					BgL_proc1z00_18696;
																																																																																				BgL_testz00_1746
																																																																																					=
																																																																																					BgL_testz00_18695;
																																																																																				goto
																																																																																					BgL_tagzd2388zd2_1750;
																																																																																			}
																																																																																			BgL_auxz00_14205
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_18694);
																																																																																		}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1774;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_18702;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1775;
																																																																																				BgL_auxz00_14205
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_18702);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1774;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_18706;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1775;
																																																																																		BgL_auxz00_14205
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_18706);
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1774;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_18710;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1775;
																																																																																BgL_auxz00_14205
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_18710);
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1774;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_18714;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1775;
																																																																														BgL_auxz00_14205
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_18714);
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1774;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_18718;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1775;
																																																																												BgL_auxz00_14205
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_18718);
																																																																											}
																																																																									}
																																																																							}
																																																																						}
																																																																					}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1774;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_18722;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1775;
																																																																					BgL_auxz00_14205
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_18722);
																																																																				}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1774;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_18726;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1775;
																																																																			BgL_auxz00_14205
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_18726);
																																																																		}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1774;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_18730;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1775;
																																																																	BgL_auxz00_14205
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_18730);
																																																																}
																																																														}
																																																												}
																																																											}
																																																									}
																																																								}
																																																						}
																																																				}
																																																			}
																																																	}
																																															}
																																													}
																																											}
																																									}
																																								}
																																							else
																																								{	/* Ast/sexp.scm 118 */
																																									if ((BgL_carzd214242zd2_3991 == CNST_TABLE_REF(((long) 17))))
																																										{	/* Ast/sexp.scm 118 */
																																											obj_t
																																												BgL_arg3718z00_4270;
																																											obj_t
																																												BgL_arg3719z00_4271;
																																											BgL_arg3718z00_4270
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_cdrzd214141zd2_3975));
																																											BgL_arg3719z00_4271
																																												=
																																												CDR
																																												(
																																												((obj_t) BgL_cdrzd214141zd2_3975));
																																											{
																																												BgL_nodez00_bglt
																																													BgL_auxz00_18739;
																																												{
																																													obj_t
																																														BgL_exprz00_18741;
																																													obj_t
																																														BgL_bindingsz00_18740;
																																													BgL_bindingsz00_18740
																																														=
																																														BgL_arg3718z00_4270;
																																													BgL_exprz00_18741
																																														=
																																														BgL_arg3719z00_4271;
																																													BgL_exprz00_1729
																																														=
																																														BgL_exprz00_18741;
																																													BgL_bindingsz00_1728
																																														=
																																														BgL_bindingsz00_18740;
																																													goto
																																														BgL_tagzd2382zd2_1730;
																																												}
																																												BgL_auxz00_14205
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_18739);
																																											}
																																										}
																																									else
																																										{	/* Ast/sexp.scm 118 */
																																											if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd214242zd2_3991)))
																																												{	/* Ast/sexp.scm 118 */
																																													obj_t
																																														BgL_arg3721z00_4273;
																																													obj_t
																																														BgL_arg3722z00_4274;
																																													BgL_arg3721z00_4273
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_cdrzd214141zd2_3975));
																																													BgL_arg3722z00_4274
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_cdrzd214141zd2_3975));
																																													{
																																														BgL_nodez00_bglt
																																															BgL_auxz00_18750;
																																														{
																																															obj_t
																																																BgL_exprz00_18752;
																																															obj_t
																																																BgL_bindingsz00_18751;
																																															BgL_bindingsz00_18751
																																																=
																																																BgL_arg3721z00_4273;
																																															BgL_exprz00_18752
																																																=
																																																BgL_arg3722z00_4274;
																																															BgL_exprz00_1729
																																																=
																																																BgL_exprz00_18752;
																																															BgL_bindingsz00_1728
																																																=
																																																BgL_bindingsz00_18751;
																																															goto
																																																BgL_tagzd2382zd2_1730;
																																														}
																																														BgL_auxz00_14205
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_18750);
																																													}
																																												}
																																											else
																																												{	/* Ast/sexp.scm 118 */
																																													if ((BgL_carzd214242zd2_3991 == CNST_TABLE_REF(((long) 18))))
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_arg3724z00_4276;
																																															obj_t
																																																BgL_arg3725z00_4277;
																																															BgL_arg3724z00_4276
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd214141zd2_3975));
																																															BgL_arg3725z00_4277
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd214141zd2_3975));
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_18761;
																																																{
																																																	obj_t
																																																		BgL_exprz00_18763;
																																																	obj_t
																																																		BgL_bindingsz00_18762;
																																																	BgL_bindingsz00_18762
																																																		=
																																																		BgL_arg3724z00_4276;
																																																	BgL_exprz00_18763
																																																		=
																																																		BgL_arg3725z00_4277;
																																																	BgL_exprz00_1729
																																																		=
																																																		BgL_exprz00_18763;
																																																	BgL_bindingsz00_1728
																																																		=
																																																		BgL_bindingsz00_18762;
																																																	goto
																																																		BgL_tagzd2382zd2_1730;
																																																}
																																																BgL_auxz00_14205
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_18761);
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 118 */
																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_18770;
																																																	goto
																																																		BgL_tagzd2383zd2_1731;
																																																	BgL_auxz00_14205
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_18770);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_carzd217344zd2_4280;
																																																	BgL_carzd217344zd2_4280
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	if ((BgL_carzd217344zd2_4280 == CNST_TABLE_REF(((long) 19))))
																																																		{
																																																			BgL_letzd2funzd2_bglt
																																																				BgL_auxz00_18777;
																																																			goto
																																																				BgL_tagzd2384zd2_1732;
																																																			BgL_auxz00_14205
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_18777);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd217344zd2_4280)))
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_18782;
																																																					goto
																																																						BgL_tagzd2384zd2_1732;
																																																					BgL_auxz00_14205
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_18782);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_18789;
																																																							goto
																																																								BgL_tagzd2389zd2_1751;
																																																							BgL_auxz00_14205
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_18789);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_18796;
																																																									goto
																																																										BgL_tagzd2390zd2_1752;
																																																									BgL_auxz00_14205
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_18796);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_cdrzd217424zd2_4287;
																																																									BgL_cdrzd217424zd2_4287
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_arg3736z00_4290;
																																																											obj_t
																																																												BgL_arg3737z00_4291;
																																																											BgL_arg3736z00_4290
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_cdrzd217424zd2_4287));
																																																											BgL_arg3737z00_4291
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd217424zd2_4287));
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_18809;
																																																												{
																																																													obj_t
																																																														BgL_restz00_18811;
																																																													obj_t
																																																														BgL_effectz00_18810;
																																																													BgL_effectz00_18810
																																																														=
																																																														BgL_arg3736z00_4290;
																																																													BgL_restz00_18811
																																																														=
																																																														BgL_arg3737z00_4291;
																																																													BgL_restz00_1754
																																																														=
																																																														BgL_restz00_18811;
																																																													BgL_effectz00_1753
																																																														=
																																																														BgL_effectz00_18810;
																																																													goto
																																																														BgL_tagzd2391zd2_1755;
																																																												}
																																																												BgL_auxz00_14205
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_18809);
																																																											}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_18818;
																																																													goto
																																																														BgL_tagzd2392zd2_1756;
																																																													BgL_auxz00_14205
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_18818);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_18825;
																																																															goto
																																																																BgL_tagzd2393zd2_1757;
																																																															BgL_auxz00_14205
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_18825);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_arg3744z00_4299;
																																																																	obj_t
																																																																		BgL_arg3745z00_4300;
																																																																	BgL_arg3744z00_4299
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd217424zd2_4287));
																																																																	BgL_arg3745z00_4300
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd217424zd2_4287));
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_18836;
																																																																		{
																																																																			obj_t
																																																																				BgL_restz00_18838;
																																																																			obj_t
																																																																				BgL_effectz00_18837;
																																																																			BgL_effectz00_18837
																																																																				=
																																																																				BgL_arg3744z00_4299;
																																																																			BgL_restz00_18838
																																																																				=
																																																																				BgL_arg3745z00_4300;
																																																																			BgL_restz00_1759
																																																																				=
																																																																				BgL_restz00_18838;
																																																																			BgL_effectz00_1758
																																																																				=
																																																																				BgL_effectz00_18837;
																																																																			goto
																																																																				BgL_tagzd2394zd2_1760;
																																																																		}
																																																																		BgL_auxz00_14205
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_18836);
																																																																	}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_18845;
																																																																			goto
																																																																				BgL_tagzd2395zd2_1761;
																																																																			BgL_auxz00_14205
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_18845);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_18852;
																																																																					goto
																																																																						BgL_tagzd2396zd2_1762;
																																																																					BgL_auxz00_14205
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_18852);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																						{
																																																																							BgL_letzd2funzd2_bglt
																																																																								BgL_auxz00_18859;
																																																																							goto
																																																																								BgL_tagzd2397zd2_1763;
																																																																							BgL_auxz00_14205
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_18859);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																								{
																																																																									BgL_jumpzd2exzd2itz00_bglt
																																																																										BgL_auxz00_18866;
																																																																									goto
																																																																										BgL_tagzd2398zd2_1764;
																																																																									BgL_auxz00_14205
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_18866);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 30))))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											bool_t
																																																																												BgL_test8821z00_18873;
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_tmpz00_18874;
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_pairz00_10985;
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_pairz00_10984;
																																																																														BgL_pairz00_10984
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_expz00_21));
																																																																														BgL_pairz00_10985
																																																																															=
																																																																															CDR
																																																																															(BgL_pairz00_10984);
																																																																													}
																																																																													BgL_tmpz00_18874
																																																																														=
																																																																														CDR
																																																																														(BgL_pairz00_10985);
																																																																												}
																																																																												BgL_test8821z00_18873
																																																																													=
																																																																													NULLP
																																																																													(BgL_tmpz00_18874);
																																																																											}
																																																																											if (BgL_test8821z00_18873)
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_18880;
																																																																													goto
																																																																														BgL_tagzd2399zd2_1765;
																																																																													BgL_auxz00_14205
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_18880);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1774;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_18884;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1775;
																																																																															BgL_auxz00_14205
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_18884);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_cdrzd217512zd2_4319;
																																																																											BgL_cdrzd217512zd2_4319
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_cdrzd217518zd2_4322;
																																																																													BgL_cdrzd217518zd2_4322
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd217512zd2_4319));
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_cdrzd217524zd2_4323;
																																																																														BgL_cdrzd217524zd2_4323
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd217518zd2_4322));
																																																																														if ((CAR(((obj_t) BgL_cdrzd217518zd2_4322)) == CNST_TABLE_REF(((long) 31))))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (PAIRP(BgL_cdrzd217524zd2_4323))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		obj_t
																																																																																			BgL_arg3769z00_4327;
																																																																																		obj_t
																																																																																			BgL_arg3770z00_4328;
																																																																																		obj_t
																																																																																			BgL_arg3771z00_4329;
																																																																																		BgL_arg3769z00_4327
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd217512zd2_4319));
																																																																																		BgL_arg3770z00_4328
																																																																																			=
																																																																																			CAR
																																																																																			(BgL_cdrzd217524zd2_4323);
																																																																																		BgL_arg3771z00_4329
																																																																																			=
																																																																																			CDR
																																																																																			(BgL_cdrzd217524zd2_4323);
																																																																																		{	/* Ast/sexp.scm 549 */
																																																																																			obj_t
																																																																																				BgL_arg6988z00_10996;
																																																																																			BgL_arg6988z00_10996
																																																																																				=
																																																																																				BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																				(BgL_expz00_21,
																																																																																				BgL_locz00_23);
																																																																																			BgL_auxz00_14205
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																				(BgL_expz00_21,
																																																																																					BgL_arg3769z00_4327,
																																																																																					BgL_arg3770z00_4328,
																																																																																					BgL_arg3771z00_4329,
																																																																																					BgL_stackz00_22,
																																																																																					BgL_arg6988z00_10996,
																																																																																					BgL_sitez00_24));
																																																																																		}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		obj_t
																																																																																			BgL_arg3772z00_4331;
																																																																																		obj_t
																																																																																			BgL_arg3773z00_4332;
																																																																																		BgL_arg3772z00_4331
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd217512zd2_4319));
																																																																																		BgL_arg3773z00_4332
																																																																																			=
																																																																																			CDR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd217512zd2_4319));
																																																																																		{	/* Ast/sexp.scm 551 */
																																																																																			obj_t
																																																																																				BgL_arg6989z00_11000;
																																																																																			BgL_arg6989z00_11000
																																																																																				=
																																																																																				BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																				(BgL_expz00_21,
																																																																																				BgL_locz00_23);
																																																																																			BgL_auxz00_14205
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																				(BgL_expz00_21,
																																																																																					BgL_arg3772z00_4331,
																																																																																					CNST_TABLE_REF
																																																																																					(((long) 4)), BgL_arg3773z00_4332, BgL_stackz00_22, BgL_arg6989z00_11000, BgL_sitez00_24));
																																																																															}}}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_arg3774z00_4334;
																																																																																obj_t
																																																																																	BgL_arg3775z00_4335;
																																																																																BgL_arg3774z00_4334
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd217512zd2_4319));
																																																																																BgL_arg3775z00_4335
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd217512zd2_4319));
																																																																																{	/* Ast/sexp.scm 551 */
																																																																																	obj_t
																																																																																		BgL_arg6989z00_11004;
																																																																																	BgL_arg6989z00_11004
																																																																																		=
																																																																																		BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																		(BgL_expz00_21,
																																																																																		BgL_locz00_23);
																																																																																	BgL_auxz00_14205
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																		(BgL_expz00_21,
																																																																																			BgL_arg3774z00_4334,
																																																																																			CNST_TABLE_REF
																																																																																			(((long) 4)), BgL_arg3775z00_4335, BgL_stackz00_22, BgL_arg6989z00_11004, BgL_sitez00_24));
																																																																												}}}}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1774;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_18929;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1775;
																																																																															BgL_auxz00_14205
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_18929);
																																																																														}
																																																																												}
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																											else
																												{	/* Ast/sexp.scm 118 */
																													obj_t
																														BgL_carzd217575zd2_4354;
																													BgL_carzd217575zd2_4354
																														=
																														CAR(((obj_t)
																															BgL_expz00_21));
																													if (
																														(BgL_carzd217575zd2_4354
																															==
																															CNST_TABLE_REF((
																																	(long) 1))))
																														{
																															BgL_nodez00_bglt
																																BgL_auxz00_18936;
																															goto
																																BgL_tagzd2377zd2_1719;
																															BgL_auxz00_14205 =
																																((obj_t)
																																BgL_auxz00_18936);
																														}
																													else
																														{	/* Ast/sexp.scm 118 */
																															if (
																																(BgL_carzd217575zd2_4354
																																	==
																																	BGl_za2ifza2z00zzast_sexpz00))
																																{
																																	BgL_nodez00_bglt
																																		BgL_auxz00_18940;
																																	goto
																																		BgL_tagzd2377zd2_1719;
																																	BgL_auxz00_14205
																																		=
																																		((obj_t)
																																		BgL_auxz00_18940);
																																}
																															else
																																{	/* Ast/sexp.scm 118 */
																																	if (
																																		(CAR(
																																				((obj_t)
																																					BgL_expz00_21))
																																			==
																																			CNST_TABLE_REF
																																			(((long)
																																					7))))
																																		{
																																			BgL_nodez00_bglt
																																				BgL_auxz00_18947;
																																			goto
																																				BgL_tagzd2379zd2_1723;
																																			BgL_auxz00_14205
																																				=
																																				((obj_t)
																																				BgL_auxz00_18947);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 118 */
																																			if (
																																				(CAR(
																																						((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																				{
																																					BgL_nodez00_bglt
																																						BgL_auxz00_18954;
																																					goto
																																						BgL_tagzd2380zd2_1724;
																																					BgL_auxz00_14205
																																						=
																																						(
																																						(obj_t)
																																						BgL_auxz00_18954);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 118 */
																																					obj_t
																																						BgL_carzd217644zd2_4361;
																																					BgL_carzd217644zd2_4361
																																						=
																																						CAR(
																																						((obj_t) BgL_expz00_21));
																																					if (PAIRP(BgL_carzd217644zd2_4361))
																																						{	/* Ast/sexp.scm 118 */
																																							obj_t
																																								BgL_carzd217647zd2_4363;
																																							obj_t
																																								BgL_cdrzd217648zd2_4364;
																																							BgL_carzd217647zd2_4363
																																								=
																																								CAR
																																								(BgL_carzd217644zd2_4361);
																																							BgL_cdrzd217648zd2_4364
																																								=
																																								CDR
																																								(BgL_carzd217644zd2_4361);
																																							{

																																								if ((BgL_carzd217647zd2_4363 == CNST_TABLE_REF(((long) 17))))
																																									{	/* Ast/sexp.scm 118 */
																																									BgL_kapzd217649zd2_4365:
																																										if (PAIRP(BgL_cdrzd217648zd2_4364))
																																											{	/* Ast/sexp.scm 118 */
																																												obj_t
																																													BgL_cdrzd217652zd2_4547;
																																												BgL_cdrzd217652zd2_4547
																																													=
																																													CDR
																																													(BgL_cdrzd217648zd2_4364);
																																												if (PAIRP(BgL_cdrzd217652zd2_4547))
																																													{	/* Ast/sexp.scm 118 */
																																														if (NULLP(CDR(BgL_cdrzd217652zd2_4547)))
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_arg3929z00_4551;
																																																obj_t
																																																	BgL_arg3930z00_4552;
																																																BgL_arg3929z00_4551
																																																	=
																																																	CAR
																																																	(BgL_cdrzd217652zd2_4547);
																																																BgL_arg3930z00_4552
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_18976;
																																																	{
																																																		obj_t
																																																			BgL_argsz00_18978;
																																																		obj_t
																																																			BgL_bodyz00_18977;
																																																		BgL_bodyz00_18977
																																																			=
																																																			BgL_arg3929z00_4551;
																																																		BgL_argsz00_18978
																																																			=
																																																			BgL_arg3930z00_4552;
																																																		BgL_argsz00_1726
																																																			=
																																																			BgL_argsz00_18978;
																																																		BgL_bodyz00_1725
																																																			=
																																																			BgL_bodyz00_18977;
																																																		goto
																																																			BgL_tagzd2381zd2_1727;
																																																	}
																																																	BgL_auxz00_14205
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_18976);
																																																}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_cdrzd217676zd2_4553;
																																																BgL_cdrzd217676zd2_4553
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 118 */
																																																	bool_t
																																																		BgL_test8836z00_18982;
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_arg3999z00_4664;
																																																		BgL_arg3999z00_4664
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_test8836z00_18982
																																																			=
																																																			CBOOL
																																																			(BGl_letzd2symzf3z21zzast_letz00
																																																			(BgL_arg3999z00_4664));
																																																	}
																																																	if (BgL_test8836z00_18982)
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_arg3933z00_4556;
																																																			obj_t
																																																				BgL_arg3934z00_4557;
																																																			BgL_arg3933z00_4556
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd217676zd2_4553));
																																																			BgL_arg3934z00_4557
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd217676zd2_4553));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_18991;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_18993;
																																																					obj_t
																																																						BgL_bindingsz00_18992;
																																																					BgL_bindingsz00_18992
																																																						=
																																																						BgL_arg3933z00_4556;
																																																					BgL_exprz00_18993
																																																						=
																																																						BgL_arg3934z00_4557;
																																																					BgL_exprz00_1729
																																																						=
																																																						BgL_exprz00_18993;
																																																					BgL_bindingsz00_1728
																																																						=
																																																						BgL_bindingsz00_18992;
																																																					goto
																																																						BgL_tagzd2382zd2_1730;
																																																				}
																																																				BgL_auxz00_14205
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_18991);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			bool_t
																																																				BgL_test8837z00_18995;
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_arg3998z00_4663;
																																																				BgL_arg3998z00_4663
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test8837z00_18995
																																																					=
																																																					CBOOL
																																																					(BGl_labelszd2symzf3z21zzast_labelsz00
																																																					(BgL_arg3998z00_4663));
																																																			}
																																																			if (BgL_test8837z00_18995)
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_19000;
																																																					goto
																																																						BgL_tagzd2384zd2_1732;
																																																					BgL_auxz00_14205
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_19000);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_carzd217743zd2_4560;
																																																					BgL_carzd217743zd2_4560
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_cdrzd217748zd2_4561;
																																																						BgL_cdrzd217748zd2_4561
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_carzd217743zd2_4560));
																																																						if ((CAR(((obj_t) BgL_carzd217743zd2_4560)) == CNST_TABLE_REF(((long) 3))))
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_arg3939z00_4564;
																																																								obj_t
																																																									BgL_arg3940z00_4565;
																																																								obj_t
																																																									BgL_arg3941z00_4566;
																																																								BgL_arg3939z00_4564
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_cdrzd217748zd2_4561));
																																																								BgL_arg3940z00_4565
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_cdrzd217748zd2_4561));
																																																								BgL_arg3941z00_4566
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_19017;
																																																									{
																																																										obj_t
																																																											BgL_argsz00_19020;
																																																										obj_t
																																																											BgL_bodyz00_19019;
																																																										obj_t
																																																											BgL_varsz00_19018;
																																																										BgL_varsz00_19018
																																																											=
																																																											BgL_arg3939z00_4564;
																																																										BgL_bodyz00_19019
																																																											=
																																																											BgL_arg3940z00_4565;
																																																										BgL_argsz00_19020
																																																											=
																																																											BgL_arg3941z00_4566;
																																																										BgL_argsz00_1739
																																																											=
																																																											BgL_argsz00_19020;
																																																										BgL_bodyz00_1738
																																																											=
																																																											BgL_bodyz00_19019;
																																																										BgL_varsz00_1737
																																																											=
																																																											BgL_varsz00_19018;
																																																										goto
																																																											BgL_tagzd2386zd2_1740;
																																																									}
																																																									BgL_auxz00_14205
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_19017);
																																																								}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_cdrzd217771zd2_4568;
																																																								BgL_cdrzd217771zd2_4568
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_cdrzd217777zd2_4569;
																																																									BgL_cdrzd217777zd2_4569
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_carzd217743zd2_4560));
																																																									if ((CAR(((obj_t) BgL_carzd217743zd2_4560)) == CNST_TABLE_REF(((long) 1))))
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_cdrzd217783zd2_4572;
																																																											BgL_cdrzd217783zd2_4572
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd217777zd2_4569));
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_carzd217788zd2_4573;
																																																												obj_t
																																																													BgL_cdrzd217789zd2_4574;
																																																												BgL_carzd217788zd2_4573
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_cdrzd217783zd2_4572));
																																																												BgL_cdrzd217789zd2_4574
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_cdrzd217783zd2_4572));
																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd217788zd2_4573))
																																																													{	/* Ast/sexp.scm 118 */
																																																														if (PAIRP(BgL_cdrzd217789zd2_4574))
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_carzd217796zd2_4577;
																																																																BgL_carzd217796zd2_4577
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd217789zd2_4574);
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd217796zd2_4577))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (NULLP(CDR(BgL_cdrzd217789zd2_4574)))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				bool_t
																																																																					BgL_test8844z00_19047;
																																																																				{
																																																																					obj_t
																																																																						BgL_l1394z00_4610;
																																																																					BgL_l1394z00_4610
																																																																						=
																																																																						BgL_cdrzd217771zd2_4568;
																																																																				BgL_zc3z04anonymousza33964ze3z87_4611:
																																																																					if (NULLP(BgL_l1394z00_4610))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							BgL_test8844z00_19047
																																																																								=
																																																																								(
																																																																								(bool_t)
																																																																								1);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							bool_t
																																																																								BgL_test8846z00_19050;
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								bool_t
																																																																									BgL_test8847z00_19051;
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_tmpz00_19052;
																																																																									BgL_tmpz00_19052
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_l1394z00_4610));
																																																																									BgL_test8847z00_19051
																																																																										=
																																																																										PAIRP
																																																																										(BgL_tmpz00_19052);
																																																																								}
																																																																								if (BgL_test8847z00_19051)
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										BgL_test8846z00_19050
																																																																											=
																																																																											(
																																																																											(bool_t)
																																																																											0);
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										BgL_test8846z00_19050
																																																																											=
																																																																											(
																																																																											(bool_t)
																																																																											1);
																																																																									}
																																																																							}
																																																																							if (BgL_test8846z00_19050)
																																																																								{
																																																																									obj_t
																																																																										BgL_l1394z00_19056;
																																																																									BgL_l1394z00_19056
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_l1394z00_4610));
																																																																									BgL_l1394z00_4610
																																																																										=
																																																																										BgL_l1394z00_19056;
																																																																									goto
																																																																										BgL_zc3z04anonymousza33964ze3z87_4611;
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									BgL_test8844z00_19047
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										0);
																																																																								}
																																																																						}
																																																																				}
																																																																				if (BgL_test8844z00_19047)
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_arg3954z00_4593;
																																																																						BgL_arg3954z00_4593
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd217777zd2_4569));
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_19061;
																																																																							{
																																																																								obj_t
																																																																									BgL_argsz00_19065;
																																																																								obj_t
																																																																									BgL_proc2z00_19064;
																																																																								obj_t
																																																																									BgL_proc1z00_19063;
																																																																								obj_t
																																																																									BgL_testz00_19062;
																																																																								BgL_testz00_19062
																																																																									=
																																																																									BgL_arg3954z00_4593;
																																																																								BgL_proc1z00_19063
																																																																									=
																																																																									BgL_carzd217788zd2_4573;
																																																																								BgL_proc2z00_19064
																																																																									=
																																																																									BgL_carzd217796zd2_4577;
																																																																								BgL_argsz00_19065
																																																																									=
																																																																									BgL_cdrzd217771zd2_4568;
																																																																								BgL_argsz00_1744
																																																																									=
																																																																									BgL_argsz00_19065;
																																																																								BgL_proc2z00_1743
																																																																									=
																																																																									BgL_proc2z00_19064;
																																																																								BgL_proc1z00_1742
																																																																									=
																																																																									BgL_proc1z00_19063;
																																																																								BgL_testz00_1741
																																																																									=
																																																																									BgL_testz00_19062;
																																																																								goto
																																																																									BgL_tagzd2387zd2_1745;
																																																																							}
																																																																							BgL_auxz00_14205
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_19061);
																																																																						}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_cdrzd217820zd2_4594;
																																																																						BgL_cdrzd217820zd2_4594
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_cdrzd217827zd2_4595;
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_pairz00_11048;
																																																																								BgL_pairz00_11048
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								BgL_cdrzd217827zd2_4595
																																																																									=
																																																																									CDR
																																																																									(BgL_pairz00_11048);
																																																																							}
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_cdrzd217834zd2_4596;
																																																																								BgL_cdrzd217834zd2_4596
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd217827zd2_4595));
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_carzd217840zd2_4597;
																																																																									BgL_carzd217840zd2_4597
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd217834zd2_4596));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd217840zd2_4597))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_carzd217847zd2_4599;
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_pairz00_11052;
																																																																												BgL_pairz00_11052
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd217834zd2_4596));
																																																																												BgL_carzd217847zd2_4599
																																																																													=
																																																																													CAR
																																																																													(BgL_pairz00_11052);
																																																																											}
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd217847zd2_4599))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd217820zd2_4594))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_arg3958z00_4602;
																																																																															BgL_arg3958z00_4602
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd217827zd2_4595));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_19087;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_19091;
																																																																																	obj_t
																																																																																		BgL_proc2z00_19090;
																																																																																	obj_t
																																																																																		BgL_proc1z00_19089;
																																																																																	obj_t
																																																																																		BgL_testz00_19088;
																																																																																	BgL_testz00_19088
																																																																																		=
																																																																																		BgL_arg3958z00_4602;
																																																																																	BgL_proc1z00_19089
																																																																																		=
																																																																																		BgL_carzd217840zd2_4597;
																																																																																	BgL_proc2z00_19090
																																																																																		=
																																																																																		BgL_carzd217847zd2_4599;
																																																																																	BgL_argsz00_19091
																																																																																		=
																																																																																		BgL_cdrzd217820zd2_4594;
																																																																																	BgL_argsz00_1749
																																																																																		=
																																																																																		BgL_argsz00_19091;
																																																																																	BgL_proc2z00_1748
																																																																																		=
																																																																																		BgL_proc2z00_19090;
																																																																																	BgL_proc1z00_1747
																																																																																		=
																																																																																		BgL_proc1z00_19089;
																																																																																	BgL_testz00_1746
																																																																																		=
																																																																																		BgL_testz00_19088;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1750;
																																																																																}
																																																																																BgL_auxz00_14205
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_19087);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1774;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_19095;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1775;
																																																																																	BgL_auxz00_14205
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_19095);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1774;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_19099;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1775;
																																																																															BgL_auxz00_14205
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_19099);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1774;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_19103;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1775;
																																																																													BgL_auxz00_14205
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_19103);
																																																																												}
																																																																										}
																																																																								}
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1774;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_19107;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1775;
																																																																						BgL_auxz00_14205
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_19107);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_cdrzd218123zd2_4621;
																																																																		BgL_cdrzd218123zd2_4621
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_cdrzd218129zd2_4622;
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_pairz00_11056;
																																																																				BgL_pairz00_11056
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				BgL_cdrzd218129zd2_4622
																																																																					=
																																																																					CDR
																																																																					(BgL_pairz00_11056);
																																																																			}
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_cdrzd218135zd2_4623;
																																																																				BgL_cdrzd218135zd2_4623
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd218129zd2_4622));
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_carzd218140zd2_4624;
																																																																					obj_t
																																																																						BgL_cdrzd218141zd2_4625;
																																																																					BgL_carzd218140zd2_4624
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd218135zd2_4623));
																																																																					BgL_cdrzd218141zd2_4625
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd218135zd2_4623));
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd218140zd2_4624))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_carzd218146zd2_4627;
																																																																							BgL_carzd218146zd2_4627
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd218141zd2_4625));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd218146zd2_4627))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (NULLP(CDR(((obj_t) BgL_cdrzd218141zd2_4625))))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd218123zd2_4621))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_arg3973z00_4632;
																																																																													BgL_arg3973z00_4632
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd218129zd2_4622));
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_19134;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_19138;
																																																																															obj_t
																																																																																BgL_proc2z00_19137;
																																																																															obj_t
																																																																																BgL_proc1z00_19136;
																																																																															obj_t
																																																																																BgL_testz00_19135;
																																																																															BgL_testz00_19135
																																																																																=
																																																																																BgL_arg3973z00_4632;
																																																																															BgL_proc1z00_19136
																																																																																=
																																																																																BgL_carzd218140zd2_4624;
																																																																															BgL_proc2z00_19137
																																																																																=
																																																																																BgL_carzd218146zd2_4627;
																																																																															BgL_argsz00_19138
																																																																																=
																																																																																BgL_cdrzd218123zd2_4621;
																																																																															BgL_argsz00_1749
																																																																																=
																																																																																BgL_argsz00_19138;
																																																																															BgL_proc2z00_1748
																																																																																=
																																																																																BgL_proc2z00_19137;
																																																																															BgL_proc1z00_1747
																																																																																=
																																																																																BgL_proc1z00_19136;
																																																																															BgL_testz00_1746
																																																																																=
																																																																																BgL_testz00_19135;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1750;
																																																																														}
																																																																														BgL_auxz00_14205
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_19134);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1774;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_19142;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1775;
																																																																															BgL_auxz00_14205
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_19142);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1774;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_19146;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1775;
																																																																													BgL_auxz00_14205
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_19146);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1774;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_19150;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1775;
																																																																											BgL_auxz00_14205
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_19150);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1774;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_19154;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1775;
																																																																									BgL_auxz00_14205
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_19154);
																																																																								}
																																																																						}
																																																																				}
																																																																			}
																																																																		}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1774;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_19158;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1775;
																																																																		BgL_auxz00_14205
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_19158);
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_cdrzd218479zd2_4640;
																																																														BgL_cdrzd218479zd2_4640
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_cdrzd218486zd2_4641;
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_pairz00_11066;
																																																																BgL_pairz00_11066
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																BgL_cdrzd218486zd2_4641
																																																																	=
																																																																	CDR
																																																																	(BgL_pairz00_11066);
																																																															}
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_cdrzd218493zd2_4642;
																																																																BgL_cdrzd218493zd2_4642
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd218486zd2_4641));
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_carzd218499zd2_4643;
																																																																	obj_t
																																																																		BgL_cdrzd218500zd2_4644;
																																																																	BgL_carzd218499zd2_4643
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd218493zd2_4642));
																																																																	BgL_cdrzd218500zd2_4644
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd218493zd2_4642));
																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd218499zd2_4643))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if (PAIRP(BgL_cdrzd218500zd2_4644))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_carzd218507zd2_4647;
																																																																					BgL_carzd218507zd2_4647
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd218500zd2_4644);
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd218507zd2_4647))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (NULLP(CDR(BgL_cdrzd218500zd2_4644)))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd218479zd2_4640))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_arg3987z00_4652;
																																																																											BgL_arg3987z00_4652
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd218486zd2_4641));
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_19185;
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_19189;
																																																																													obj_t
																																																																														BgL_proc2z00_19188;
																																																																													obj_t
																																																																														BgL_proc1z00_19187;
																																																																													obj_t
																																																																														BgL_testz00_19186;
																																																																													BgL_testz00_19186
																																																																														=
																																																																														BgL_arg3987z00_4652;
																																																																													BgL_proc1z00_19187
																																																																														=
																																																																														BgL_carzd218499zd2_4643;
																																																																													BgL_proc2z00_19188
																																																																														=
																																																																														BgL_carzd218507zd2_4647;
																																																																													BgL_argsz00_19189
																																																																														=
																																																																														BgL_cdrzd218479zd2_4640;
																																																																													BgL_argsz00_1749
																																																																														=
																																																																														BgL_argsz00_19189;
																																																																													BgL_proc2z00_1748
																																																																														=
																																																																														BgL_proc2z00_19188;
																																																																													BgL_proc1z00_1747
																																																																														=
																																																																														BgL_proc1z00_19187;
																																																																													BgL_testz00_1746
																																																																														=
																																																																														BgL_testz00_19186;
																																																																													goto
																																																																														BgL_tagzd2388zd2_1750;
																																																																												}
																																																																												BgL_auxz00_14205
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_19185);
																																																																											}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1774;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_19193;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1775;
																																																																													BgL_auxz00_14205
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_19193);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1774;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_19197;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1775;
																																																																											BgL_auxz00_14205
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_19197);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1774;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_19201;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1775;
																																																																									BgL_auxz00_14205
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_19201);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1774;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_19205;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1775;
																																																																							BgL_auxz00_14205
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_19205);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1774;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_19209;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1775;
																																																																					BgL_auxz00_14205
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_19209);
																																																																				}
																																																																		}
																																																																}
																																																															}
																																																														}
																																																													}
																																																											}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{	/* Ast/sexp.scm 118 */
																																																													goto
																																																														BgL_tagzd2403zd2_1774;
																																																												}
																																																											else
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_19213;
																																																													goto
																																																														BgL_tagzd2404zd2_1775;
																																																													BgL_auxz00_14205
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_19213);
																																																												}
																																																										}
																																																								}
																																																							}
																																																					}
																																																				}
																																																		}
																																																}
																																															}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														obj_t
																																															BgL_cdrzd218900zd2_4666;
																																														BgL_cdrzd218900zd2_4666
																																															=
																																															CDR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														{	/* Ast/sexp.scm 118 */
																																															bool_t
																																																BgL_test8875z00_19217;
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_arg4015z00_4683;
																																																BgL_arg4015z00_4683
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																BgL_test8875z00_19217
																																																	=
																																																	CBOOL
																																																	(BGl_letzd2symzf3z21zzast_letz00
																																																	(BgL_arg4015z00_4683));
																																															}
																																															if (BgL_test8875z00_19217)
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_arg4003z00_4669;
																																																	obj_t
																																																		BgL_arg4004z00_4670;
																																																	BgL_arg4003z00_4669
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd218900zd2_4666));
																																																	BgL_arg4004z00_4670
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd218900zd2_4666));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_19226;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_19228;
																																																			obj_t
																																																				BgL_bindingsz00_19227;
																																																			BgL_bindingsz00_19227
																																																				=
																																																				BgL_arg4003z00_4669;
																																																			BgL_exprz00_19228
																																																				=
																																																				BgL_arg4004z00_4670;
																																																			BgL_exprz00_1729
																																																				=
																																																				BgL_exprz00_19228;
																																																			BgL_bindingsz00_1728
																																																				=
																																																				BgL_bindingsz00_19227;
																																																			goto
																																																				BgL_tagzd2382zd2_1730;
																																																		}
																																																		BgL_auxz00_14205
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_19226);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	bool_t
																																																		BgL_test8876z00_19230;
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_arg4014z00_4682;
																																																		BgL_arg4014z00_4682
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_test8876z00_19230
																																																			=
																																																			CBOOL
																																																			(BGl_labelszd2symzf3z21zzast_labelsz00
																																																			(BgL_arg4014z00_4682));
																																																	}
																																																	if (BgL_test8876z00_19230)
																																																		{
																																																			BgL_letzd2funzd2_bglt
																																																				BgL_auxz00_19235;
																																																			goto
																																																				BgL_tagzd2384zd2_1732;
																																																			BgL_auxz00_14205
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_19235);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_carzd218966zd2_4673;
																																																			BgL_carzd218966zd2_4673
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_cdrzd218971zd2_4674;
																																																				BgL_cdrzd218971zd2_4674
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_carzd218966zd2_4673));
																																																				if ((CAR(((obj_t) BgL_carzd218966zd2_4673)) == CNST_TABLE_REF(((long) 3))))
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_arg4009z00_4677;
																																																						obj_t
																																																							BgL_arg4010z00_4678;
																																																						obj_t
																																																							BgL_arg4011z00_4679;
																																																						BgL_arg4009z00_4677
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_cdrzd218971zd2_4674));
																																																						BgL_arg4010z00_4678
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_cdrzd218971zd2_4674));
																																																						BgL_arg4011z00_4679
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_19252;
																																																							{
																																																								obj_t
																																																									BgL_argsz00_19255;
																																																								obj_t
																																																									BgL_bodyz00_19254;
																																																								obj_t
																																																									BgL_varsz00_19253;
																																																								BgL_varsz00_19253
																																																									=
																																																									BgL_arg4009z00_4677;
																																																								BgL_bodyz00_19254
																																																									=
																																																									BgL_arg4010z00_4678;
																																																								BgL_argsz00_19255
																																																									=
																																																									BgL_arg4011z00_4679;
																																																								BgL_argsz00_1739
																																																									=
																																																									BgL_argsz00_19255;
																																																								BgL_bodyz00_1738
																																																									=
																																																									BgL_bodyz00_19254;
																																																								BgL_varsz00_1737
																																																									=
																																																									BgL_varsz00_19253;
																																																								goto
																																																									BgL_tagzd2386zd2_1740;
																																																							}
																																																							BgL_auxz00_14205
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_19252);
																																																						}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 118 */
																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																							{	/* Ast/sexp.scm 118 */
																																																								goto
																																																									BgL_tagzd2403zd2_1774;
																																																							}
																																																						else
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_19259;
																																																								goto
																																																									BgL_tagzd2404zd2_1775;
																																																								BgL_auxz00_14205
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_19259);
																																																							}
																																																					}
																																																			}
																																																		}
																																																}
																																														}
																																													}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 118 */
																																												obj_t
																																													BgL_cdrzd219082zd2_4684;
																																												BgL_cdrzd219082zd2_4684
																																													=
																																													CDR
																																													(
																																													((obj_t) BgL_expz00_21));
																																												{	/* Ast/sexp.scm 118 */
																																													bool_t
																																														BgL_test8879z00_19263;
																																													{	/* Ast/sexp.scm 118 */
																																														obj_t
																																															BgL_arg4024z00_4693;
																																														BgL_arg4024z00_4693
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														BgL_test8879z00_19263
																																															=
																																															CBOOL
																																															(BGl_letzd2symzf3z21zzast_letz00
																																															(BgL_arg4024z00_4693));
																																													}
																																													if (BgL_test8879z00_19263)
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_arg4018z00_4687;
																																															obj_t
																																																BgL_arg4019z00_4688;
																																															BgL_arg4018z00_4687
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd219082zd2_4684));
																																															BgL_arg4019z00_4688
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd219082zd2_4684));
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_19272;
																																																{
																																																	obj_t
																																																		BgL_exprz00_19274;
																																																	obj_t
																																																		BgL_bindingsz00_19273;
																																																	BgL_bindingsz00_19273
																																																		=
																																																		BgL_arg4018z00_4687;
																																																	BgL_exprz00_19274
																																																		=
																																																		BgL_arg4019z00_4688;
																																																	BgL_exprz00_1729
																																																		=
																																																		BgL_exprz00_19274;
																																																	BgL_bindingsz00_1728
																																																		=
																																																		BgL_bindingsz00_19273;
																																																	goto
																																																		BgL_tagzd2382zd2_1730;
																																																}
																																																BgL_auxz00_14205
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_19272);
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 118 */
																																															bool_t
																																																BgL_test8880z00_19276;
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_arg4023z00_4692;
																																																BgL_arg4023z00_4692
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																BgL_test8880z00_19276
																																																	=
																																																	CBOOL
																																																	(BGl_labelszd2symzf3z21zzast_labelsz00
																																																	(BgL_arg4023z00_4692));
																																															}
																																															if (BgL_test8880z00_19276)
																																																{
																																																	BgL_letzd2funzd2_bglt
																																																		BgL_auxz00_19281;
																																																	goto
																																																		BgL_tagzd2384zd2_1732;
																																																	BgL_auxz00_14205
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_19281);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																		{	/* Ast/sexp.scm 118 */
																																																			goto
																																																				BgL_tagzd2403zd2_1774;
																																																		}
																																																	else
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_19285;
																																																			goto
																																																				BgL_tagzd2404zd2_1775;
																																																			BgL_auxz00_14205
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_19285);
																																																		}
																																																}
																																														}
																																												}
																																											}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 118 */
																																										if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd217647zd2_4363)))
																																											{	/* Ast/sexp.scm 118 */
																																												goto
																																													BgL_kapzd217649zd2_4365;
																																											}
																																										else
																																											{	/* Ast/sexp.scm 118 */
																																												if ((BgL_carzd217647zd2_4363 == CNST_TABLE_REF(((long) 18))))
																																													{	/* Ast/sexp.scm 118 */
																																														goto
																																															BgL_kapzd217649zd2_4365;
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														if ((BgL_carzd217647zd2_4363 == CNST_TABLE_REF(((long) 19))))
																																															{	/* Ast/sexp.scm 118 */
																																																goto
																																																	BgL_kapzd217649zd2_4365;
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd217647zd2_4363)))
																																																	{	/* Ast/sexp.scm 118 */
																																																		goto
																																																			BgL_kapzd217649zd2_4365;
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_cdrzd219254zd2_4371;
																																																		BgL_cdrzd219254zd2_4371
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 118 */
																																																			bool_t
																																																				BgL_test8886z00_19301;
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_arg3924z00_4545;
																																																				BgL_arg3924z00_4545
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test8886z00_19301
																																																					=
																																																					CBOOL
																																																					(BGl_letzd2symzf3z21zzast_letz00
																																																					(BgL_arg3924z00_4545));
																																																			}
																																																			if (BgL_test8886z00_19301)
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_arg3808z00_4374;
																																																					obj_t
																																																						BgL_arg3809z00_4375;
																																																					BgL_arg3808z00_4374
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd219254zd2_4371));
																																																					BgL_arg3809z00_4375
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd219254zd2_4371));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_19310;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_19312;
																																																							obj_t
																																																								BgL_bindingsz00_19311;
																																																							BgL_bindingsz00_19311
																																																								=
																																																								BgL_arg3808z00_4374;
																																																							BgL_exprz00_19312
																																																								=
																																																								BgL_arg3809z00_4375;
																																																							BgL_exprz00_1729
																																																								=
																																																								BgL_exprz00_19312;
																																																							BgL_bindingsz00_1728
																																																								=
																																																								BgL_bindingsz00_19311;
																																																							goto
																																																								BgL_tagzd2382zd2_1730;
																																																						}
																																																						BgL_auxz00_14205
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_19310);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					bool_t
																																																						BgL_test8887z00_19314;
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_arg3923z00_4544;
																																																						BgL_arg3923z00_4544
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test8887z00_19314
																																																							=
																																																							CBOOL
																																																							(BGl_labelszd2symzf3z21zzast_labelsz00
																																																							(BgL_arg3923z00_4544));
																																																					}
																																																					if (BgL_test8887z00_19314)
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_19319;
																																																							goto
																																																								BgL_tagzd2384zd2_1732;
																																																							BgL_auxz00_14205
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_19319);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_carzd219307zd2_4378;
																																																							obj_t
																																																								BgL_cdrzd219308zd2_4379;
																																																							BgL_carzd219307zd2_4378
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							BgL_cdrzd219308zd2_4379
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_cdrzd219312zd2_4380;
																																																								BgL_cdrzd219312zd2_4380
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_carzd219307zd2_4378));
																																																								if ((CAR(((obj_t) BgL_carzd219307zd2_4378)) == CNST_TABLE_REF(((long) 3))))
																																																									{	/* Ast/sexp.scm 118 */
																																																										if (PAIRP(BgL_cdrzd219312zd2_4380))
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_carzd219315zd2_4384;
																																																												obj_t
																																																													BgL_cdrzd219316zd2_4385;
																																																												BgL_carzd219315zd2_4384
																																																													=
																																																													CAR
																																																													(BgL_cdrzd219312zd2_4380);
																																																												BgL_cdrzd219316zd2_4385
																																																													=
																																																													CDR
																																																													(BgL_cdrzd219312zd2_4380);
																																																												if (PAIRP(BgL_carzd219315zd2_4384))
																																																													{	/* Ast/sexp.scm 118 */
																																																														if (NULLP(CDR(BgL_carzd219315zd2_4384)))
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (PAIRP(BgL_cdrzd219316zd2_4385))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_carzd219322zd2_4390;
																																																																		BgL_carzd219322zd2_4390
																																																																			=
																																																																			CAR
																																																																			(BgL_cdrzd219316zd2_4385);
																																																																		if (PAIRP(BgL_carzd219322zd2_4390))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_castzd2sexpzf3z21zzast_privatez00(BgL_carzd219322zd2_4390))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (NULLP(CDR(BgL_cdrzd219316zd2_4385)))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_carzd219329zd2_4395;
																																																																								BgL_carzd219329zd2_4395
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd219308zd2_4379));
																																																																								if (PAIRP(BgL_carzd219329zd2_4395))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_cdrzd219354zd2_4397;
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_pairz00_11114;
																																																																											BgL_pairz00_11114
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											BgL_cdrzd219354zd2_4397
																																																																												=
																																																																												CDR
																																																																												(BgL_pairz00_11114);
																																																																										}
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_arg3824z00_4398;
																																																																											obj_t
																																																																												BgL_arg3825z00_4399;
																																																																											obj_t
																																																																												BgL_arg3826z00_4400;
																																																																											BgL_arg3824z00_4398
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd219354zd2_4397));
																																																																											BgL_arg3825z00_4399
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd219354zd2_4397));
																																																																											BgL_arg3826z00_4400
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_19364;
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_19367;
																																																																													obj_t
																																																																														BgL_bodyz00_19366;
																																																																													obj_t
																																																																														BgL_varsz00_19365;
																																																																													BgL_varsz00_19365
																																																																														=
																																																																														BgL_arg3824z00_4398;
																																																																													BgL_bodyz00_19366
																																																																														=
																																																																														BgL_arg3825z00_4399;
																																																																													BgL_argsz00_19367
																																																																														=
																																																																														BgL_arg3826z00_4400;
																																																																													BgL_argsz00_1739
																																																																														=
																																																																														BgL_argsz00_19367;
																																																																													BgL_bodyz00_1738
																																																																														=
																																																																														BgL_bodyz00_19366;
																																																																													BgL_varsz00_1737
																																																																														=
																																																																														BgL_varsz00_19365;
																																																																													goto
																																																																														BgL_tagzd2386zd2_1740;
																																																																												}
																																																																												BgL_auxz00_14205
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_19364);
																																																																											}
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (NULLP(CDR(((obj_t) BgL_cdrzd219308zd2_4379))))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_arg3830z00_4404;
																																																																												BgL_arg3830z00_4404
																																																																													=
																																																																													CAR
																																																																													(BgL_carzd219315zd2_4384);
																																																																												{
																																																																													BgL_castz00_bglt
																																																																														BgL_auxz00_19374;
																																																																													BgL_varz00_1733
																																																																														=
																																																																														BgL_arg3830z00_4404;
																																																																													BgL_bodyz00_1734
																																																																														=
																																																																														BgL_carzd219322zd2_4390;
																																																																													BgL_argz00_1735
																																																																														=
																																																																														BgL_carzd219329zd2_4395;
																																																																												BgL_tagzd2385zd2_1736:
																																																																													{	/* Ast/sexp.scm 374 */
																																																																														BgL_castz00_bglt
																																																																															BgL_new1138z00_8741;
																																																																														{	/* Ast/sexp.scm 375 */
																																																																															BgL_castz00_bglt
																																																																																BgL_new1137z00_8743;
																																																																															BgL_new1137z00_8743
																																																																																=
																																																																																(
																																																																																(BgL_castz00_bglt)
																																																																																BOBJECT
																																																																																(GC_MALLOC
																																																																																	(sizeof
																																																																																		(struct
																																																																																			BgL_castz00_bgl))));
																																																																															{	/* Ast/sexp.scm 375 */
																																																																																long
																																																																																	BgL_arg6839z00_8744;
																																																																																{	/* Ast/sexp.scm 375 */
																																																																																	long
																																																																																		BgL_res7409z00_9927;
																																																																																	BgL_res7409z00_9927
																																																																																		=
																																																																																		BGL_CLASS_INDEX
																																																																																		(BGl_castz00zzast_nodez00);
																																																																																	BgL_arg6839z00_8744
																																																																																		=
																																																																																		BgL_res7409z00_9927;
																																																																																}
																																																																																BGL_OBJECT_CLASS_NUM_SET
																																																																																	(
																																																																																	((BgL_objectz00_bglt) BgL_new1137z00_8743), BgL_arg6839z00_8744);
																																																																															}
																																																																															{	/* Ast/sexp.scm 375 */
																																																																																BgL_objectz00_bglt
																																																																																	BgL_tmpz00_19379;
																																																																																BgL_tmpz00_19379
																																																																																	=
																																																																																	(
																																																																																	(BgL_objectz00_bglt)
																																																																																	BgL_new1137z00_8743);
																																																																																BGL_OBJECT_WIDENING_SET
																																																																																	(BgL_tmpz00_19379,
																																																																																	BFALSE);
																																																																															}
																																																																															((BgL_objectz00_bglt) BgL_new1137z00_8743);
																																																																															BgL_new1138z00_8741
																																																																																=
																																																																																BgL_new1137z00_8743;
																																																																														}
																																																																														((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1138z00_8741)))->BgL_locz00) = ((obj_t) BgL_locz00_23), BUNSPEC);
																																																																														{
																																																																															BgL_typez00_bglt
																																																																																BgL_auxz00_19385;
																																																																															{	/* Ast/sexp.scm 376 */
																																																																																obj_t
																																																																																	BgL_arg6838z00_8742;
																																																																																BgL_arg6838z00_8742
																																																																																	=
																																																																																	BGl_castzd2sexpzd2typez00zzast_privatez00
																																																																																	(BgL_bodyz00_1734);
																																																																																BgL_auxz00_19385
																																																																																	=
																																																																																	BGl_usezd2typez12zc0zztype_envz00
																																																																																	(BgL_arg6838z00_8742,
																																																																																	BgL_locz00_23);
																																																																															}
																																																																															((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1138z00_8741)))->BgL_typez00) = ((BgL_typez00_bglt) BgL_auxz00_19385), BUNSPEC);
																																																																														}
																																																																														((((BgL_castz00_bglt) COBJECT(BgL_new1138z00_8741))->BgL_argz00) = ((BgL_nodez00_bglt) BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_argz00_1735, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24)), BUNSPEC);
																																																																														BgL_auxz00_19374
																																																																															=
																																																																															BgL_new1138z00_8741;
																																																																													}
																																																																													BgL_auxz00_14205
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_19374);
																																																																											}}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_cdrzd219382zd2_4405;
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_pairz00_11122;
																																																																													BgL_pairz00_11122
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													BgL_cdrzd219382zd2_4405
																																																																														=
																																																																														CDR
																																																																														(BgL_pairz00_11122);
																																																																												}
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_arg3831z00_4406;
																																																																													obj_t
																																																																														BgL_arg3832z00_4407;
																																																																													obj_t
																																																																														BgL_arg3833z00_4408;
																																																																													BgL_arg3831z00_4406
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd219382zd2_4405));
																																																																													BgL_arg3832z00_4407
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd219382zd2_4405));
																																																																													BgL_arg3833z00_4408
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_19402;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_19405;
																																																																															obj_t
																																																																																BgL_bodyz00_19404;
																																																																															obj_t
																																																																																BgL_varsz00_19403;
																																																																															BgL_varsz00_19403
																																																																																=
																																																																																BgL_arg3831z00_4406;
																																																																															BgL_bodyz00_19404
																																																																																=
																																																																																BgL_arg3832z00_4407;
																																																																															BgL_argsz00_19405
																																																																																=
																																																																																BgL_arg3833z00_4408;
																																																																															BgL_argsz00_1739
																																																																																=
																																																																																BgL_argsz00_19405;
																																																																															BgL_bodyz00_1738
																																																																																=
																																																																																BgL_bodyz00_19404;
																																																																															BgL_varsz00_1737
																																																																																=
																																																																																BgL_varsz00_19403;
																																																																															goto
																																																																																BgL_tagzd2386zd2_1740;
																																																																														}
																																																																														BgL_auxz00_14205
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_19402);
																																																																													}
																																																																												}
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_cdrzd219408zd2_4411;
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_pairz00_11127;
																																																																									BgL_pairz00_11127
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									BgL_cdrzd219408zd2_4411
																																																																										=
																																																																										CDR
																																																																										(BgL_pairz00_11127);
																																																																								}
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_arg3836z00_4412;
																																																																									obj_t
																																																																										BgL_arg3837z00_4413;
																																																																									obj_t
																																																																										BgL_arg3838z00_4414;
																																																																									BgL_arg3836z00_4412
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd219408zd2_4411));
																																																																									BgL_arg3837z00_4413
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd219408zd2_4411));
																																																																									BgL_arg3838z00_4414
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_19416;
																																																																										{
																																																																											obj_t
																																																																												BgL_argsz00_19419;
																																																																											obj_t
																																																																												BgL_bodyz00_19418;
																																																																											obj_t
																																																																												BgL_varsz00_19417;
																																																																											BgL_varsz00_19417
																																																																												=
																																																																												BgL_arg3836z00_4412;
																																																																											BgL_bodyz00_19418
																																																																												=
																																																																												BgL_arg3837z00_4413;
																																																																											BgL_argsz00_19419
																																																																												=
																																																																												BgL_arg3838z00_4414;
																																																																											BgL_argsz00_1739
																																																																												=
																																																																												BgL_argsz00_19419;
																																																																											BgL_bodyz00_1738
																																																																												=
																																																																												BgL_bodyz00_19418;
																																																																											BgL_varsz00_1737
																																																																												=
																																																																												BgL_varsz00_19417;
																																																																											goto
																																																																												BgL_tagzd2386zd2_1740;
																																																																										}
																																																																										BgL_auxz00_14205
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_19416);
																																																																									}
																																																																								}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_cdrzd219434zd2_4417;
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_pairz00_11132;
																																																																							BgL_pairz00_11132
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							BgL_cdrzd219434zd2_4417
																																																																								=
																																																																								CDR
																																																																								(BgL_pairz00_11132);
																																																																						}
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_arg3841z00_4418;
																																																																							obj_t
																																																																								BgL_arg3842z00_4419;
																																																																							obj_t
																																																																								BgL_arg3843z00_4420;
																																																																							BgL_arg3841z00_4418
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd219434zd2_4417));
																																																																							BgL_arg3842z00_4419
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd219434zd2_4417));
																																																																							BgL_arg3843z00_4420
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_19430;
																																																																								{
																																																																									obj_t
																																																																										BgL_argsz00_19433;
																																																																									obj_t
																																																																										BgL_bodyz00_19432;
																																																																									obj_t
																																																																										BgL_varsz00_19431;
																																																																									BgL_varsz00_19431
																																																																										=
																																																																										BgL_arg3841z00_4418;
																																																																									BgL_bodyz00_19432
																																																																										=
																																																																										BgL_arg3842z00_4419;
																																																																									BgL_argsz00_19433
																																																																										=
																																																																										BgL_arg3843z00_4420;
																																																																									BgL_argsz00_1739
																																																																										=
																																																																										BgL_argsz00_19433;
																																																																									BgL_bodyz00_1738
																																																																										=
																																																																										BgL_bodyz00_19432;
																																																																									BgL_varsz00_1737
																																																																										=
																																																																										BgL_varsz00_19431;
																																																																									goto
																																																																										BgL_tagzd2386zd2_1740;
																																																																								}
																																																																								BgL_auxz00_14205
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_19430);
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_cdrzd219460zd2_4422;
																																																																				BgL_cdrzd219460zd2_4422
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_carzd219307zd2_4378));
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_arg3845z00_4423;
																																																																					obj_t
																																																																						BgL_arg3846z00_4424;
																																																																					obj_t
																																																																						BgL_arg3847z00_4425;
																																																																					BgL_arg3845z00_4423
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd219460zd2_4422));
																																																																					BgL_arg3846z00_4424
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd219460zd2_4422));
																																																																					BgL_arg3847z00_4425
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_expz00_21));
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_19443;
																																																																						{
																																																																							obj_t
																																																																								BgL_argsz00_19446;
																																																																							obj_t
																																																																								BgL_bodyz00_19445;
																																																																							obj_t
																																																																								BgL_varsz00_19444;
																																																																							BgL_varsz00_19444
																																																																								=
																																																																								BgL_arg3845z00_4423;
																																																																							BgL_bodyz00_19445
																																																																								=
																																																																								BgL_arg3846z00_4424;
																																																																							BgL_argsz00_19446
																																																																								=
																																																																								BgL_arg3847z00_4425;
																																																																							BgL_argsz00_1739
																																																																								=
																																																																								BgL_argsz00_19446;
																																																																							BgL_bodyz00_1738
																																																																								=
																																																																								BgL_bodyz00_19445;
																																																																							BgL_varsz00_1737
																																																																								=
																																																																								BgL_varsz00_19444;
																																																																							goto
																																																																								BgL_tagzd2386zd2_1740;
																																																																						}
																																																																						BgL_auxz00_14205
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_19443);
																																																																					}
																																																																				}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_cdrzd219486zd2_4427;
																																																																		BgL_cdrzd219486zd2_4427
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_carzd219307zd2_4378));
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_arg3849z00_4428;
																																																																			obj_t
																																																																				BgL_arg3850z00_4429;
																																																																			obj_t
																																																																				BgL_arg3851z00_4430;
																																																																			BgL_arg3849z00_4428
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd219486zd2_4427));
																																																																			BgL_arg3850z00_4429
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd219486zd2_4427));
																																																																			BgL_arg3851z00_4430
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_expz00_21));
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_19456;
																																																																				{
																																																																					obj_t
																																																																						BgL_argsz00_19459;
																																																																					obj_t
																																																																						BgL_bodyz00_19458;
																																																																					obj_t
																																																																						BgL_varsz00_19457;
																																																																					BgL_varsz00_19457
																																																																						=
																																																																						BgL_arg3849z00_4428;
																																																																					BgL_bodyz00_19458
																																																																						=
																																																																						BgL_arg3850z00_4429;
																																																																					BgL_argsz00_19459
																																																																						=
																																																																						BgL_arg3851z00_4430;
																																																																					BgL_argsz00_1739
																																																																						=
																																																																						BgL_argsz00_19459;
																																																																					BgL_bodyz00_1738
																																																																						=
																																																																						BgL_bodyz00_19458;
																																																																					BgL_varsz00_1737
																																																																						=
																																																																						BgL_varsz00_19457;
																																																																					goto
																																																																						BgL_tagzd2386zd2_1740;
																																																																				}
																																																																				BgL_auxz00_14205
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_19456);
																																																																			}
																																																																		}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_cdrzd219512zd2_4432;
																																																																BgL_cdrzd219512zd2_4432
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_carzd219307zd2_4378));
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_arg3853z00_4433;
																																																																	obj_t
																																																																		BgL_arg3854z00_4434;
																																																																	obj_t
																																																																		BgL_arg3855z00_4435;
																																																																	BgL_arg3853z00_4433
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd219512zd2_4432));
																																																																	BgL_arg3854z00_4434
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd219512zd2_4432));
																																																																	BgL_arg3855z00_4435
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_expz00_21));
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_19469;
																																																																		{
																																																																			obj_t
																																																																				BgL_argsz00_19472;
																																																																			obj_t
																																																																				BgL_bodyz00_19471;
																																																																			obj_t
																																																																				BgL_varsz00_19470;
																																																																			BgL_varsz00_19470
																																																																				=
																																																																				BgL_arg3853z00_4433;
																																																																			BgL_bodyz00_19471
																																																																				=
																																																																				BgL_arg3854z00_4434;
																																																																			BgL_argsz00_19472
																																																																				=
																																																																				BgL_arg3855z00_4435;
																																																																			BgL_argsz00_1739
																																																																				=
																																																																				BgL_argsz00_19472;
																																																																			BgL_bodyz00_1738
																																																																				=
																																																																				BgL_bodyz00_19471;
																																																																			BgL_varsz00_1737
																																																																				=
																																																																				BgL_varsz00_19470;
																																																																			goto
																																																																				BgL_tagzd2386zd2_1740;
																																																																		}
																																																																		BgL_auxz00_14205
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_19469);
																																																																	}
																																																																}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_cdrzd219538zd2_4438;
																																																														BgL_cdrzd219538zd2_4438
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_carzd219307zd2_4378));
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_arg3858z00_4439;
																																																															obj_t
																																																																BgL_arg3859z00_4440;
																																																															obj_t
																																																																BgL_arg3860z00_4441;
																																																															BgL_arg3858z00_4439
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_cdrzd219538zd2_4438));
																																																															BgL_arg3859z00_4440
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd219538zd2_4438));
																																																															BgL_arg3860z00_4441
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_19482;
																																																																{
																																																																	obj_t
																																																																		BgL_argsz00_19485;
																																																																	obj_t
																																																																		BgL_bodyz00_19484;
																																																																	obj_t
																																																																		BgL_varsz00_19483;
																																																																	BgL_varsz00_19483
																																																																		=
																																																																		BgL_arg3858z00_4439;
																																																																	BgL_bodyz00_19484
																																																																		=
																																																																		BgL_arg3859z00_4440;
																																																																	BgL_argsz00_19485
																																																																		=
																																																																		BgL_arg3860z00_4441;
																																																																	BgL_argsz00_1739
																																																																		=
																																																																		BgL_argsz00_19485;
																																																																	BgL_bodyz00_1738
																																																																		=
																																																																		BgL_bodyz00_19484;
																																																																	BgL_varsz00_1737
																																																																		=
																																																																		BgL_varsz00_19483;
																																																																	goto
																																																																		BgL_tagzd2386zd2_1740;
																																																																}
																																																																BgL_auxz00_14205
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_19482);
																																																															}
																																																														}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 118 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{	/* Ast/sexp.scm 118 */
																																																														goto
																																																															BgL_tagzd2403zd2_1774;
																																																													}
																																																												else
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_19489;
																																																														goto
																																																															BgL_tagzd2404zd2_1775;
																																																														BgL_auxz00_14205
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_19489);
																																																													}
																																																											}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_cdrzd219676zd2_4446;
																																																										BgL_cdrzd219676zd2_4446
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_carzd219307zd2_4378));
																																																										if ((CAR(((obj_t) BgL_carzd219307zd2_4378)) == CNST_TABLE_REF(((long) 1))))
																																																											{	/* Ast/sexp.scm 118 */
																																																												if (PAIRP(BgL_cdrzd219676zd2_4446))
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_cdrzd219681zd2_4450;
																																																														BgL_cdrzd219681zd2_4450
																																																															=
																																																															CDR
																																																															(BgL_cdrzd219676zd2_4446);
																																																														if (PAIRP(BgL_cdrzd219681zd2_4450))
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_carzd219685zd2_4452;
																																																																obj_t
																																																																	BgL_cdrzd219686zd2_4453;
																																																																BgL_carzd219685zd2_4452
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd219681zd2_4450);
																																																																BgL_cdrzd219686zd2_4453
																																																																	=
																																																																	CDR
																																																																	(BgL_cdrzd219681zd2_4450);
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd219685zd2_4452))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (PAIRP(BgL_cdrzd219686zd2_4453))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_carzd219691zd2_4456;
																																																																				BgL_carzd219691zd2_4456
																																																																					=
																																																																					CAR
																																																																					(BgL_cdrzd219686zd2_4453);
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd219691zd2_4456))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (NULLP(CDR(BgL_cdrzd219686zd2_4453)))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								bool_t
																																																																									BgL_test8906z00_19515;
																																																																								{
																																																																									obj_t
																																																																										BgL_l1397z00_4489;
																																																																									BgL_l1397z00_4489
																																																																										=
																																																																										BgL_cdrzd219308zd2_4379;
																																																																								BgL_zc3z04anonymousza33887ze3z87_4490:
																																																																									if (NULLP(BgL_l1397z00_4489))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											BgL_test8906z00_19515
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												1);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											bool_t
																																																																												BgL_test8908z00_19518;
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												bool_t
																																																																													BgL_test8909z00_19519;
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_tmpz00_19520;
																																																																													BgL_tmpz00_19520
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_l1397z00_4489));
																																																																													BgL_test8909z00_19519
																																																																														=
																																																																														PAIRP
																																																																														(BgL_tmpz00_19520);
																																																																												}
																																																																												if (BgL_test8909z00_19519)
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														BgL_test8908z00_19518
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															0);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														BgL_test8908z00_19518
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															1);
																																																																													}
																																																																											}
																																																																											if (BgL_test8908z00_19518)
																																																																												{
																																																																													obj_t
																																																																														BgL_l1397z00_19524;
																																																																													BgL_l1397z00_19524
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_l1397z00_4489));
																																																																													BgL_l1397z00_4489
																																																																														=
																																																																														BgL_l1397z00_19524;
																																																																													goto
																																																																														BgL_zc3z04anonymousza33887ze3z87_4490;
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													BgL_test8906z00_19515
																																																																														=
																																																																														(
																																																																														(bool_t)
																																																																														0);
																																																																												}
																																																																										}
																																																																								}
																																																																								if (BgL_test8906z00_19515)
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_arg3877z00_4472;
																																																																										BgL_arg3877z00_4472
																																																																											=
																																																																											CAR
																																																																											(BgL_cdrzd219676zd2_4446);
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_19528;
																																																																											{
																																																																												obj_t
																																																																													BgL_argsz00_19532;
																																																																												obj_t
																																																																													BgL_proc2z00_19531;
																																																																												obj_t
																																																																													BgL_proc1z00_19530;
																																																																												obj_t
																																																																													BgL_testz00_19529;
																																																																												BgL_testz00_19529
																																																																													=
																																																																													BgL_arg3877z00_4472;
																																																																												BgL_proc1z00_19530
																																																																													=
																																																																													BgL_carzd219685zd2_4452;
																																																																												BgL_proc2z00_19531
																																																																													=
																																																																													BgL_carzd219691zd2_4456;
																																																																												BgL_argsz00_19532
																																																																													=
																																																																													BgL_cdrzd219308zd2_4379;
																																																																												BgL_argsz00_1744
																																																																													=
																																																																													BgL_argsz00_19532;
																																																																												BgL_proc2z00_1743
																																																																													=
																																																																													BgL_proc2z00_19531;
																																																																												BgL_proc1z00_1742
																																																																													=
																																																																													BgL_proc1z00_19530;
																																																																												BgL_testz00_1741
																																																																													=
																																																																													BgL_testz00_19529;
																																																																												goto
																																																																													BgL_tagzd2387zd2_1745;
																																																																											}
																																																																											BgL_auxz00_14205
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_19528);
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_cdrzd219716zd2_4473;
																																																																										BgL_cdrzd219716zd2_4473
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_cdrzd219724zd2_4474;
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_pairz00_11176;
																																																																												BgL_pairz00_11176
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_expz00_21));
																																																																												BgL_cdrzd219724zd2_4474
																																																																													=
																																																																													CDR
																																																																													(BgL_pairz00_11176);
																																																																											}
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_cdrzd219732zd2_4475;
																																																																												BgL_cdrzd219732zd2_4475
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd219724zd2_4474));
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_carzd219739zd2_4476;
																																																																													BgL_carzd219739zd2_4476
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd219732zd2_4475));
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd219739zd2_4476))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_carzd219748zd2_4478;
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_pairz00_11180;
																																																																																BgL_pairz00_11180
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd219732zd2_4475));
																																																																																BgL_carzd219748zd2_4478
																																																																																	=
																																																																																	CAR
																																																																																	(BgL_pairz00_11180);
																																																																															}
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd219748zd2_4478))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd219716zd2_4473))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			obj_t
																																																																																				BgL_arg3881z00_4481;
																																																																																			BgL_arg3881z00_4481
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd219724zd2_4474));
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_19554;
																																																																																				{
																																																																																					obj_t
																																																																																						BgL_argsz00_19558;
																																																																																					obj_t
																																																																																						BgL_proc2z00_19557;
																																																																																					obj_t
																																																																																						BgL_proc1z00_19556;
																																																																																					obj_t
																																																																																						BgL_testz00_19555;
																																																																																					BgL_testz00_19555
																																																																																						=
																																																																																						BgL_arg3881z00_4481;
																																																																																					BgL_proc1z00_19556
																																																																																						=
																																																																																						BgL_carzd219739zd2_4476;
																																																																																					BgL_proc2z00_19557
																																																																																						=
																																																																																						BgL_carzd219748zd2_4478;
																																																																																					BgL_argsz00_19558
																																																																																						=
																																																																																						BgL_cdrzd219716zd2_4473;
																																																																																					BgL_argsz00_1749
																																																																																						=
																																																																																						BgL_argsz00_19558;
																																																																																					BgL_proc2z00_1748
																																																																																						=
																																																																																						BgL_proc2z00_19557;
																																																																																					BgL_proc1z00_1747
																																																																																						=
																																																																																						BgL_proc1z00_19556;
																																																																																					BgL_testz00_1746
																																																																																						=
																																																																																						BgL_testz00_19555;
																																																																																					goto
																																																																																						BgL_tagzd2388zd2_1750;
																																																																																				}
																																																																																				BgL_auxz00_14205
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_19554);
																																																																																			}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1774;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_19562;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1775;
																																																																																					BgL_auxz00_14205
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_19562);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1774;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_19566;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1775;
																																																																																			BgL_auxz00_14205
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_19566);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1774;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_19570;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1775;
																																																																																	BgL_auxz00_14205
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_19570);
																																																																																}
																																																																														}
																																																																												}
																																																																											}
																																																																										}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1774;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_19574;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1775;
																																																																										BgL_auxz00_14205
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_19574);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_cdrzd220026zd2_4500;
																																																																						BgL_cdrzd220026zd2_4500
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_cdrzd220033zd2_4501;
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_pairz00_11184;
																																																																								BgL_pairz00_11184
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								BgL_cdrzd220033zd2_4501
																																																																									=
																																																																									CDR
																																																																									(BgL_pairz00_11184);
																																																																							}
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_cdrzd220040zd2_4502;
																																																																								BgL_cdrzd220040zd2_4502
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd220033zd2_4501));
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_carzd220046zd2_4503;
																																																																									obj_t
																																																																										BgL_cdrzd220047zd2_4504;
																																																																									BgL_carzd220046zd2_4503
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd220040zd2_4502));
																																																																									BgL_cdrzd220047zd2_4504
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd220040zd2_4502));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd220046zd2_4503))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_carzd220054zd2_4506;
																																																																											BgL_carzd220054zd2_4506
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd220047zd2_4504));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd220054zd2_4506))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (NULLP(CDR(((obj_t) BgL_cdrzd220047zd2_4504))))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd220026zd2_4500))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_arg3896z00_4511;
																																																																																	BgL_arg3896z00_4511
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd220033zd2_4501));
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_19601;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_19605;
																																																																																			obj_t
																																																																																				BgL_proc2z00_19604;
																																																																																			obj_t
																																																																																				BgL_proc1z00_19603;
																																																																																			obj_t
																																																																																				BgL_testz00_19602;
																																																																																			BgL_testz00_19602
																																																																																				=
																																																																																				BgL_arg3896z00_4511;
																																																																																			BgL_proc1z00_19603
																																																																																				=
																																																																																				BgL_carzd220046zd2_4503;
																																																																																			BgL_proc2z00_19604
																																																																																				=
																																																																																				BgL_carzd220054zd2_4506;
																																																																																			BgL_argsz00_19605
																																																																																				=
																																																																																				BgL_cdrzd220026zd2_4500;
																																																																																			BgL_argsz00_1749
																																																																																				=
																																																																																				BgL_argsz00_19605;
																																																																																			BgL_proc2z00_1748
																																																																																				=
																																																																																				BgL_proc2z00_19604;
																																																																																			BgL_proc1z00_1747
																																																																																				=
																																																																																				BgL_proc1z00_19603;
																																																																																			BgL_testz00_1746
																																																																																				=
																																																																																				BgL_testz00_19602;
																																																																																			goto
																																																																																				BgL_tagzd2388zd2_1750;
																																																																																		}
																																																																																		BgL_auxz00_14205
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_19601);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1774;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_19609;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1775;
																																																																																			BgL_auxz00_14205
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_19609);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1774;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_19613;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1775;
																																																																																	BgL_auxz00_14205
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_19613);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1774;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_19617;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1775;
																																																																															BgL_auxz00_14205
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_19617);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1774;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_19621;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1775;
																																																																													BgL_auxz00_14205
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_19621);
																																																																												}
																																																																										}
																																																																								}
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1774;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_19625;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1775;
																																																																						BgL_auxz00_14205
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_19625);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_cdrzd220387zd2_4519;
																																																																		BgL_cdrzd220387zd2_4519
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_cdrzd220393zd2_4520;
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_pairz00_11194;
																																																																				BgL_pairz00_11194
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				BgL_cdrzd220393zd2_4520
																																																																					=
																																																																					CDR
																																																																					(BgL_pairz00_11194);
																																																																			}
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_cdrzd220399zd2_4521;
																																																																				BgL_cdrzd220399zd2_4521
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd220393zd2_4520));
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_carzd220404zd2_4522;
																																																																					obj_t
																																																																						BgL_cdrzd220405zd2_4523;
																																																																					BgL_carzd220404zd2_4522
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd220399zd2_4521));
																																																																					BgL_cdrzd220405zd2_4523
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd220399zd2_4521));
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd220404zd2_4522))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (PAIRP(BgL_cdrzd220405zd2_4523))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_carzd220410zd2_4526;
																																																																									BgL_carzd220410zd2_4526
																																																																										=
																																																																										CAR
																																																																										(BgL_cdrzd220405zd2_4523);
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd220410zd2_4526))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (NULLP(CDR(BgL_cdrzd220405zd2_4523)))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd220387zd2_4519))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_arg3910z00_4531;
																																																																															BgL_arg3910z00_4531
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd220393zd2_4520));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_19652;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_19656;
																																																																																	obj_t
																																																																																		BgL_proc2z00_19655;
																																																																																	obj_t
																																																																																		BgL_proc1z00_19654;
																																																																																	obj_t
																																																																																		BgL_testz00_19653;
																																																																																	BgL_testz00_19653
																																																																																		=
																																																																																		BgL_arg3910z00_4531;
																																																																																	BgL_proc1z00_19654
																																																																																		=
																																																																																		BgL_carzd220404zd2_4522;
																																																																																	BgL_proc2z00_19655
																																																																																		=
																																																																																		BgL_carzd220410zd2_4526;
																																																																																	BgL_argsz00_19656
																																																																																		=
																																																																																		BgL_cdrzd220387zd2_4519;
																																																																																	BgL_argsz00_1749
																																																																																		=
																																																																																		BgL_argsz00_19656;
																																																																																	BgL_proc2z00_1748
																																																																																		=
																																																																																		BgL_proc2z00_19655;
																																																																																	BgL_proc1z00_1747
																																																																																		=
																																																																																		BgL_proc1z00_19654;
																																																																																	BgL_testz00_1746
																																																																																		=
																																																																																		BgL_testz00_19653;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1750;
																																																																																}
																																																																																BgL_auxz00_14205
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_19652);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1774;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_19660;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1775;
																																																																																	BgL_auxz00_14205
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_19660);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1774;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_19664;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1775;
																																																																															BgL_auxz00_14205
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_19664);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1774;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_19668;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1775;
																																																																													BgL_auxz00_14205
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_19668);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1774;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_19672;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1775;
																																																																											BgL_auxz00_14205
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_19672);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1774;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_19676;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1775;
																																																																									BgL_auxz00_14205
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_19676);
																																																																								}
																																																																						}
																																																																				}
																																																																			}
																																																																		}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1774;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_19680;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1775;
																																																																		BgL_auxz00_14205
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_19680);
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 118 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 118 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1774;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_19684;
																																																																goto
																																																																	BgL_tagzd2404zd2_1775;
																																																																BgL_auxz00_14205
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_19684);
																																																															}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 118 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{	/* Ast/sexp.scm 118 */
																																																														goto
																																																															BgL_tagzd2403zd2_1774;
																																																													}
																																																												else
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_19688;
																																																														goto
																																																															BgL_tagzd2404zd2_1775;
																																																														BgL_auxz00_14205
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_19688);
																																																													}
																																																											}
																																																									}
																																																							}
																																																						}
																																																				}
																																																		}
																																																	}
																																															}
																																													}
																																											}
																																									}
																																							}
																																						}
																																					else
																																						{	/* Ast/sexp.scm 118 */
																																							obj_t
																																								BgL_cdrzd220948zd2_4695;
																																							BgL_cdrzd220948zd2_4695
																																								=
																																								CDR
																																								(
																																								((obj_t) BgL_expz00_21));
																																							if ((BgL_carzd217644zd2_4361 == CNST_TABLE_REF(((long) 17))))
																																								{	/* Ast/sexp.scm 118 */
																																									obj_t
																																										BgL_arg4026z00_4697;
																																									obj_t
																																										BgL_arg4027z00_4698;
																																									BgL_arg4026z00_4697
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_cdrzd220948zd2_4695));
																																									BgL_arg4027z00_4698
																																										=
																																										CDR
																																										(
																																										((obj_t) BgL_cdrzd220948zd2_4695));
																																									{
																																										BgL_nodez00_bglt
																																											BgL_auxz00_19699;
																																										{
																																											obj_t
																																												BgL_exprz00_19701;
																																											obj_t
																																												BgL_bindingsz00_19700;
																																											BgL_bindingsz00_19700
																																												=
																																												BgL_arg4026z00_4697;
																																											BgL_exprz00_19701
																																												=
																																												BgL_arg4027z00_4698;
																																											BgL_exprz00_1729
																																												=
																																												BgL_exprz00_19701;
																																											BgL_bindingsz00_1728
																																												=
																																												BgL_bindingsz00_19700;
																																											goto
																																												BgL_tagzd2382zd2_1730;
																																										}
																																										BgL_auxz00_14205
																																											=
																																											(
																																											(obj_t)
																																											BgL_auxz00_19699);
																																									}
																																								}
																																							else
																																								{	/* Ast/sexp.scm 118 */
																																									if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd217644zd2_4361)))
																																										{	/* Ast/sexp.scm 118 */
																																											obj_t
																																												BgL_arg4029z00_4700;
																																											obj_t
																																												BgL_arg4030z00_4701;
																																											BgL_arg4029z00_4700
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_cdrzd220948zd2_4695));
																																											BgL_arg4030z00_4701
																																												=
																																												CDR
																																												(
																																												((obj_t) BgL_cdrzd220948zd2_4695));
																																											{
																																												BgL_nodez00_bglt
																																													BgL_auxz00_19710;
																																												{
																																													obj_t
																																														BgL_exprz00_19712;
																																													obj_t
																																														BgL_bindingsz00_19711;
																																													BgL_bindingsz00_19711
																																														=
																																														BgL_arg4029z00_4700;
																																													BgL_exprz00_19712
																																														=
																																														BgL_arg4030z00_4701;
																																													BgL_exprz00_1729
																																														=
																																														BgL_exprz00_19712;
																																													BgL_bindingsz00_1728
																																														=
																																														BgL_bindingsz00_19711;
																																													goto
																																														BgL_tagzd2382zd2_1730;
																																												}
																																												BgL_auxz00_14205
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_19710);
																																											}
																																										}
																																									else
																																										{	/* Ast/sexp.scm 118 */
																																											if ((BgL_carzd217644zd2_4361 == CNST_TABLE_REF(((long) 18))))
																																												{	/* Ast/sexp.scm 118 */
																																													obj_t
																																														BgL_arg4032z00_4703;
																																													obj_t
																																														BgL_arg4033z00_4704;
																																													BgL_arg4032z00_4703
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_cdrzd220948zd2_4695));
																																													BgL_arg4033z00_4704
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_cdrzd220948zd2_4695));
																																													{
																																														BgL_nodez00_bglt
																																															BgL_auxz00_19721;
																																														{
																																															obj_t
																																																BgL_exprz00_19723;
																																															obj_t
																																																BgL_bindingsz00_19722;
																																															BgL_bindingsz00_19722
																																																=
																																																BgL_arg4032z00_4703;
																																															BgL_exprz00_19723
																																																=
																																																BgL_arg4033z00_4704;
																																															BgL_exprz00_1729
																																																=
																																																BgL_exprz00_19723;
																																															BgL_bindingsz00_1728
																																																=
																																																BgL_bindingsz00_19722;
																																															goto
																																																BgL_tagzd2382zd2_1730;
																																														}
																																														BgL_auxz00_14205
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_19721);
																																													}
																																												}
																																											else
																																												{	/* Ast/sexp.scm 118 */
																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_19730;
																																															goto
																																																BgL_tagzd2383zd2_1731;
																																															BgL_auxz00_14205
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_19730);
																																														}
																																													else
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_carzd220985zd2_4707;
																																															BgL_carzd220985zd2_4707
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															if ((BgL_carzd220985zd2_4707 == CNST_TABLE_REF(((long) 19))))
																																																{
																																																	BgL_letzd2funzd2_bglt
																																																		BgL_auxz00_19737;
																																																	goto
																																																		BgL_tagzd2384zd2_1732;
																																																	BgL_auxz00_14205
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_19737);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd220985zd2_4707)))
																																																		{
																																																			BgL_letzd2funzd2_bglt
																																																				BgL_auxz00_19742;
																																																			goto
																																																				BgL_tagzd2384zd2_1732;
																																																			BgL_auxz00_14205
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_19742);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_19749;
																																																					goto
																																																						BgL_tagzd2389zd2_1751;
																																																					BgL_auxz00_14205
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_19749);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_19756;
																																																							goto
																																																								BgL_tagzd2390zd2_1752;
																																																							BgL_auxz00_14205
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_19756);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_cdrzd221065zd2_4714;
																																																							BgL_cdrzd221065zd2_4714
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_arg4044z00_4717;
																																																									obj_t
																																																										BgL_arg4045z00_4718;
																																																									BgL_arg4044z00_4717
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd221065zd2_4714));
																																																									BgL_arg4045z00_4718
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd221065zd2_4714));
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_19769;
																																																										{
																																																											obj_t
																																																												BgL_restz00_19771;
																																																											obj_t
																																																												BgL_effectz00_19770;
																																																											BgL_effectz00_19770
																																																												=
																																																												BgL_arg4044z00_4717;
																																																											BgL_restz00_19771
																																																												=
																																																												BgL_arg4045z00_4718;
																																																											BgL_restz00_1754
																																																												=
																																																												BgL_restz00_19771;
																																																											BgL_effectz00_1753
																																																												=
																																																												BgL_effectz00_19770;
																																																											goto
																																																												BgL_tagzd2391zd2_1755;
																																																										}
																																																										BgL_auxz00_14205
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_19769);
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_19778;
																																																											goto
																																																												BgL_tagzd2392zd2_1756;
																																																											BgL_auxz00_14205
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_19778);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_19785;
																																																													goto
																																																														BgL_tagzd2393zd2_1757;
																																																													BgL_auxz00_14205
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_19785);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_arg4052z00_4726;
																																																															obj_t
																																																																BgL_arg4053z00_4727;
																																																															BgL_arg4052z00_4726
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_cdrzd221065zd2_4714));
																																																															BgL_arg4053z00_4727
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd221065zd2_4714));
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_19796;
																																																																{
																																																																	obj_t
																																																																		BgL_restz00_19798;
																																																																	obj_t
																																																																		BgL_effectz00_19797;
																																																																	BgL_effectz00_19797
																																																																		=
																																																																		BgL_arg4052z00_4726;
																																																																	BgL_restz00_19798
																																																																		=
																																																																		BgL_arg4053z00_4727;
																																																																	BgL_restz00_1759
																																																																		=
																																																																		BgL_restz00_19798;
																																																																	BgL_effectz00_1758
																																																																		=
																																																																		BgL_effectz00_19797;
																																																																	goto
																																																																		BgL_tagzd2394zd2_1760;
																																																																}
																																																																BgL_auxz00_14205
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_19796);
																																																															}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_19805;
																																																																	goto
																																																																		BgL_tagzd2395zd2_1761;
																																																																	BgL_auxz00_14205
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_19805);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_19812;
																																																																			goto
																																																																				BgL_tagzd2396zd2_1762;
																																																																			BgL_auxz00_14205
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_19812);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																				{
																																																																					BgL_letzd2funzd2_bglt
																																																																						BgL_auxz00_19819;
																																																																					goto
																																																																						BgL_tagzd2397zd2_1763;
																																																																					BgL_auxz00_14205
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_19819);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																						{
																																																																							BgL_jumpzd2exzd2itz00_bglt
																																																																								BgL_auxz00_19826;
																																																																							goto
																																																																								BgL_tagzd2398zd2_1764;
																																																																							BgL_auxz00_14205
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_19826);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_cdrzd221142zd2_4736;
																																																																							BgL_cdrzd221142zd2_4736
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_arg4064z00_4739;
																																																																									obj_t
																																																																										BgL_arg4065z00_4740;
																																																																									BgL_arg4064z00_4739
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd221142zd2_4736));
																																																																									BgL_arg4065z00_4740
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd221142zd2_4736));
																																																																									{	/* Ast/sexp.scm 551 */
																																																																										obj_t
																																																																											BgL_arg6989z00_11233;
																																																																										BgL_arg6989z00_11233
																																																																											=
																																																																											BGl_findzd2locationzf2locz20zztools_locationz00
																																																																											(BgL_expz00_21,
																																																																											BgL_locz00_23);
																																																																										BgL_auxz00_14205
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																											(BgL_expz00_21,
																																																																												BgL_arg4064z00_4739,
																																																																												CNST_TABLE_REF
																																																																												(((long) 4)), BgL_arg4065z00_4740, BgL_stackz00_22, BgL_arg6989z00_11233, BgL_sitez00_24));
																																																																								}}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1774;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_19845;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1775;
																																																																											BgL_auxz00_14205
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_19845);
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																										}
																									else
																										{	/* Ast/sexp.scm 118 */
																											obj_t
																												BgL_carzd221167zd2_4756;
																											BgL_carzd221167zd2_4756 =
																												CAR(((obj_t)
																													BgL_expz00_21));
																											if (
																												(BgL_carzd221167zd2_4756
																													==
																													CNST_TABLE_REF(((long)
																															1))))
																												{
																													BgL_nodez00_bglt
																														BgL_auxz00_19852;
																													goto
																														BgL_tagzd2377zd2_1719;
																													BgL_auxz00_14205 =
																														((obj_t)
																														BgL_auxz00_19852);
																												}
																											else
																												{	/* Ast/sexp.scm 118 */
																													if (
																														(BgL_carzd221167zd2_4756
																															==
																															BGl_za2ifza2z00zzast_sexpz00))
																														{
																															BgL_nodez00_bglt
																																BgL_auxz00_19856;
																															goto
																																BgL_tagzd2377zd2_1719;
																															BgL_auxz00_14205 =
																																((obj_t)
																																BgL_auxz00_19856);
																														}
																													else
																														{	/* Ast/sexp.scm 118 */
																															if (
																																(CAR(
																																		((obj_t)
																																			BgL_expz00_21))
																																	==
																																	CNST_TABLE_REF
																																	(((long) 7))))
																																{
																																	BgL_nodez00_bglt
																																		BgL_auxz00_19863;
																																	goto
																																		BgL_tagzd2379zd2_1723;
																																	BgL_auxz00_14205
																																		=
																																		((obj_t)
																																		BgL_auxz00_19863);
																																}
																															else
																																{	/* Ast/sexp.scm 118 */
																																	if (
																																		(CAR(
																																				((obj_t)
																																					BgL_expz00_21))
																																			==
																																			CNST_TABLE_REF
																																			(((long)
																																					16))))
																																		{
																																			BgL_nodez00_bglt
																																				BgL_auxz00_19870;
																																			goto
																																				BgL_tagzd2380zd2_1724;
																																			BgL_auxz00_14205
																																				=
																																				((obj_t)
																																				BgL_auxz00_19870);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 118 */
																																			obj_t
																																				BgL_carzd221236zd2_4763;
																																			BgL_carzd221236zd2_4763
																																				=
																																				CAR((
																																					(obj_t)
																																					BgL_expz00_21));
																																			if (PAIRP
																																				(BgL_carzd221236zd2_4763))
																																				{	/* Ast/sexp.scm 118 */
																																					obj_t
																																						BgL_carzd221239zd2_4765;
																																					obj_t
																																						BgL_cdrzd221240zd2_4766;
																																					BgL_carzd221239zd2_4765
																																						=
																																						CAR
																																						(BgL_carzd221236zd2_4763);
																																					BgL_cdrzd221240zd2_4766
																																						=
																																						CDR
																																						(BgL_carzd221236zd2_4763);
																																					{

																																						if (
																																							(BgL_carzd221239zd2_4765
																																								==
																																								CNST_TABLE_REF
																																								(((long) 17))))
																																							{	/* Ast/sexp.scm 118 */
																																							BgL_kapzd221241zd2_4767:
																																								if (PAIRP(BgL_cdrzd221240zd2_4766))
																																									{	/* Ast/sexp.scm 118 */
																																										obj_t
																																											BgL_cdrzd221244zd2_4886;
																																										BgL_cdrzd221244zd2_4886
																																											=
																																											CDR
																																											(BgL_cdrzd221240zd2_4766);
																																										if (PAIRP(BgL_cdrzd221244zd2_4886))
																																											{	/* Ast/sexp.scm 118 */
																																												if (NULLP(CDR(BgL_cdrzd221244zd2_4886)))
																																													{	/* Ast/sexp.scm 118 */
																																														obj_t
																																															BgL_arg4167z00_4890;
																																														obj_t
																																															BgL_arg4168z00_4891;
																																														BgL_arg4167z00_4890
																																															=
																																															CAR
																																															(BgL_cdrzd221244zd2_4886);
																																														BgL_arg4168z00_4891
																																															=
																																															CDR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_19892;
																																															{
																																																obj_t
																																																	BgL_argsz00_19894;
																																																obj_t
																																																	BgL_bodyz00_19893;
																																																BgL_bodyz00_19893
																																																	=
																																																	BgL_arg4167z00_4890;
																																																BgL_argsz00_19894
																																																	=
																																																	BgL_arg4168z00_4891;
																																																BgL_argsz00_1726
																																																	=
																																																	BgL_argsz00_19894;
																																																BgL_bodyz00_1725
																																																	=
																																																	BgL_bodyz00_19893;
																																																goto
																																																	BgL_tagzd2381zd2_1727;
																																															}
																																															BgL_auxz00_14205
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_19892);
																																														}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														bool_t
																																															BgL_test8966z00_19896;
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_arg4232z00_4997;
																																															BgL_arg4232z00_4997
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															BgL_test8966z00_19896
																																																=
																																																CBOOL
																																																(BGl_labelszd2symzf3z21zzast_labelsz00
																																																(BgL_arg4232z00_4997));
																																														}
																																														if (BgL_test8966z00_19896)
																																															{
																																																BgL_letzd2funzd2_bglt
																																																	BgL_auxz00_19901;
																																																goto
																																																	BgL_tagzd2384zd2_1732;
																																																BgL_auxz00_14205
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_19901);
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_carzd221322zd2_4894;
																																																BgL_carzd221322zd2_4894
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_cdrzd221327zd2_4895;
																																																	BgL_cdrzd221327zd2_4895
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_carzd221322zd2_4894));
																																																	if ((CAR(((obj_t) BgL_carzd221322zd2_4894)) == CNST_TABLE_REF(((long) 3))))
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_arg4173z00_4898;
																																																			obj_t
																																																				BgL_arg4174z00_4899;
																																																			obj_t
																																																				BgL_arg4175z00_4900;
																																																			BgL_arg4173z00_4898
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd221327zd2_4895));
																																																			BgL_arg4174z00_4899
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd221327zd2_4895));
																																																			BgL_arg4175z00_4900
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_19918;
																																																				{
																																																					obj_t
																																																						BgL_argsz00_19921;
																																																					obj_t
																																																						BgL_bodyz00_19920;
																																																					obj_t
																																																						BgL_varsz00_19919;
																																																					BgL_varsz00_19919
																																																						=
																																																						BgL_arg4173z00_4898;
																																																					BgL_bodyz00_19920
																																																						=
																																																						BgL_arg4174z00_4899;
																																																					BgL_argsz00_19921
																																																						=
																																																						BgL_arg4175z00_4900;
																																																					BgL_argsz00_1739
																																																						=
																																																						BgL_argsz00_19921;
																																																					BgL_bodyz00_1738
																																																						=
																																																						BgL_bodyz00_19920;
																																																					BgL_varsz00_1737
																																																						=
																																																						BgL_varsz00_19919;
																																																					goto
																																																						BgL_tagzd2386zd2_1740;
																																																				}
																																																				BgL_auxz00_14205
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_19918);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_cdrzd221350zd2_4902;
																																																			BgL_cdrzd221350zd2_4902
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_cdrzd221356zd2_4903;
																																																				BgL_cdrzd221356zd2_4903
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_carzd221322zd2_4894));
																																																				if ((CAR(((obj_t) BgL_carzd221322zd2_4894)) == CNST_TABLE_REF(((long) 1))))
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_cdrzd221362zd2_4906;
																																																						BgL_cdrzd221362zd2_4906
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_cdrzd221356zd2_4903));
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_carzd221367zd2_4907;
																																																							obj_t
																																																								BgL_cdrzd221368zd2_4908;
																																																							BgL_carzd221367zd2_4907
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd221362zd2_4906));
																																																							BgL_cdrzd221368zd2_4908
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd221362zd2_4906));
																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd221367zd2_4907))
																																																								{	/* Ast/sexp.scm 118 */
																																																									if (PAIRP(BgL_cdrzd221368zd2_4908))
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_carzd221375zd2_4911;
																																																											BgL_carzd221375zd2_4911
																																																												=
																																																												CAR
																																																												(BgL_cdrzd221368zd2_4908);
																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd221375zd2_4911))
																																																												{	/* Ast/sexp.scm 118 */
																																																													if (NULLP(CDR(BgL_cdrzd221368zd2_4908)))
																																																														{	/* Ast/sexp.scm 118 */
																																																															bool_t
																																																																BgL_test8973z00_19948;
																																																															{
																																																																obj_t
																																																																	BgL_l1400z00_4944;
																																																																BgL_l1400z00_4944
																																																																	=
																																																																	BgL_cdrzd221350zd2_4902;
																																																															BgL_zc3z04anonymousza34198ze3z87_4945:
																																																																if (NULLP(BgL_l1400z00_4944))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		BgL_test8973z00_19948
																																																																			=
																																																																			(
																																																																			(bool_t)
																																																																			1);
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		bool_t
																																																																			BgL_test8975z00_19951;
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			bool_t
																																																																				BgL_test8976z00_19952;
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_tmpz00_19953;
																																																																				BgL_tmpz00_19953
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_l1400z00_4944));
																																																																				BgL_test8976z00_19952
																																																																					=
																																																																					PAIRP
																																																																					(BgL_tmpz00_19953);
																																																																			}
																																																																			if (BgL_test8976z00_19952)
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					BgL_test8975z00_19951
																																																																						=
																																																																						(
																																																																						(bool_t)
																																																																						0);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					BgL_test8975z00_19951
																																																																						=
																																																																						(
																																																																						(bool_t)
																																																																						1);
																																																																				}
																																																																		}
																																																																		if (BgL_test8975z00_19951)
																																																																			{
																																																																				obj_t
																																																																					BgL_l1400z00_19957;
																																																																				BgL_l1400z00_19957
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_l1400z00_4944));
																																																																				BgL_l1400z00_4944
																																																																					=
																																																																					BgL_l1400z00_19957;
																																																																				goto
																																																																					BgL_zc3z04anonymousza34198ze3z87_4945;
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				BgL_test8973z00_19948
																																																																					=
																																																																					(
																																																																					(bool_t)
																																																																					0);
																																																																			}
																																																																	}
																																																															}
																																																															if (BgL_test8973z00_19948)
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_arg4188z00_4927;
																																																																	BgL_arg4188z00_4927
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd221356zd2_4903));
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_19962;
																																																																		{
																																																																			obj_t
																																																																				BgL_argsz00_19966;
																																																																			obj_t
																																																																				BgL_proc2z00_19965;
																																																																			obj_t
																																																																				BgL_proc1z00_19964;
																																																																			obj_t
																																																																				BgL_testz00_19963;
																																																																			BgL_testz00_19963
																																																																				=
																																																																				BgL_arg4188z00_4927;
																																																																			BgL_proc1z00_19964
																																																																				=
																																																																				BgL_carzd221367zd2_4907;
																																																																			BgL_proc2z00_19965
																																																																				=
																																																																				BgL_carzd221375zd2_4911;
																																																																			BgL_argsz00_19966
																																																																				=
																																																																				BgL_cdrzd221350zd2_4902;
																																																																			BgL_argsz00_1744
																																																																				=
																																																																				BgL_argsz00_19966;
																																																																			BgL_proc2z00_1743
																																																																				=
																																																																				BgL_proc2z00_19965;
																																																																			BgL_proc1z00_1742
																																																																				=
																																																																				BgL_proc1z00_19964;
																																																																			BgL_testz00_1741
																																																																				=
																																																																				BgL_testz00_19963;
																																																																			goto
																																																																				BgL_tagzd2387zd2_1745;
																																																																		}
																																																																		BgL_auxz00_14205
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_19962);
																																																																	}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd221399zd2_4928;
																																																																	BgL_cdrzd221399zd2_4928
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_expz00_21));
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_cdrzd221406zd2_4929;
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_pairz00_11273;
																																																																			BgL_pairz00_11273
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_expz00_21));
																																																																			BgL_cdrzd221406zd2_4929
																																																																				=
																																																																				CDR
																																																																				(BgL_pairz00_11273);
																																																																		}
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_cdrzd221413zd2_4930;
																																																																			BgL_cdrzd221413zd2_4930
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd221406zd2_4929));
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_carzd221419zd2_4931;
																																																																				BgL_carzd221419zd2_4931
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd221413zd2_4930));
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd221419zd2_4931))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_carzd221426zd2_4933;
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_pairz00_11277;
																																																																							BgL_pairz00_11277
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd221413zd2_4930));
																																																																							BgL_carzd221426zd2_4933
																																																																								=
																																																																								CAR
																																																																								(BgL_pairz00_11277);
																																																																						}
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd221426zd2_4933))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd221399zd2_4928))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_arg4192z00_4936;
																																																																										BgL_arg4192z00_4936
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd221406zd2_4929));
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_19988;
																																																																											{
																																																																												obj_t
																																																																													BgL_argsz00_19992;
																																																																												obj_t
																																																																													BgL_proc2z00_19991;
																																																																												obj_t
																																																																													BgL_proc1z00_19990;
																																																																												obj_t
																																																																													BgL_testz00_19989;
																																																																												BgL_testz00_19989
																																																																													=
																																																																													BgL_arg4192z00_4936;
																																																																												BgL_proc1z00_19990
																																																																													=
																																																																													BgL_carzd221419zd2_4931;
																																																																												BgL_proc2z00_19991
																																																																													=
																																																																													BgL_carzd221426zd2_4933;
																																																																												BgL_argsz00_19992
																																																																													=
																																																																													BgL_cdrzd221399zd2_4928;
																																																																												BgL_argsz00_1749
																																																																													=
																																																																													BgL_argsz00_19992;
																																																																												BgL_proc2z00_1748
																																																																													=
																																																																													BgL_proc2z00_19991;
																																																																												BgL_proc1z00_1747
																																																																													=
																																																																													BgL_proc1z00_19990;
																																																																												BgL_testz00_1746
																																																																													=
																																																																													BgL_testz00_19989;
																																																																												goto
																																																																													BgL_tagzd2388zd2_1750;
																																																																											}
																																																																											BgL_auxz00_14205
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_19988);
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1774;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_19996;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1775;
																																																																												BgL_auxz00_14205
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_19996);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1774;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_20000;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1775;
																																																																										BgL_auxz00_14205
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_20000);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1774;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_20004;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1775;
																																																																								BgL_auxz00_14205
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_20004);
																																																																							}
																																																																					}
																																																																			}
																																																																		}
																																																																	}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1774;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_20008;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1775;
																																																																	BgL_auxz00_14205
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_20008);
																																																																}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_cdrzd221702zd2_4955;
																																																													BgL_cdrzd221702zd2_4955
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_cdrzd221708zd2_4956;
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_pairz00_11281;
																																																															BgL_pairz00_11281
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															BgL_cdrzd221708zd2_4956
																																																																=
																																																																CDR
																																																																(BgL_pairz00_11281);
																																																														}
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_cdrzd221714zd2_4957;
																																																															BgL_cdrzd221714zd2_4957
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd221708zd2_4956));
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_carzd221719zd2_4958;
																																																																obj_t
																																																																	BgL_cdrzd221720zd2_4959;
																																																																BgL_carzd221719zd2_4958
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd221714zd2_4957));
																																																																BgL_cdrzd221720zd2_4959
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd221714zd2_4957));
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd221719zd2_4958))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_carzd221725zd2_4961;
																																																																		BgL_carzd221725zd2_4961
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd221720zd2_4959));
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd221725zd2_4961))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (NULLP(CDR(((obj_t) BgL_cdrzd221720zd2_4959))))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd221702zd2_4955))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_arg4207z00_4966;
																																																																								BgL_arg4207z00_4966
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd221708zd2_4956));
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_20035;
																																																																									{
																																																																										obj_t
																																																																											BgL_argsz00_20039;
																																																																										obj_t
																																																																											BgL_proc2z00_20038;
																																																																										obj_t
																																																																											BgL_proc1z00_20037;
																																																																										obj_t
																																																																											BgL_testz00_20036;
																																																																										BgL_testz00_20036
																																																																											=
																																																																											BgL_arg4207z00_4966;
																																																																										BgL_proc1z00_20037
																																																																											=
																																																																											BgL_carzd221719zd2_4958;
																																																																										BgL_proc2z00_20038
																																																																											=
																																																																											BgL_carzd221725zd2_4961;
																																																																										BgL_argsz00_20039
																																																																											=
																																																																											BgL_cdrzd221702zd2_4955;
																																																																										BgL_argsz00_1749
																																																																											=
																																																																											BgL_argsz00_20039;
																																																																										BgL_proc2z00_1748
																																																																											=
																																																																											BgL_proc2z00_20038;
																																																																										BgL_proc1z00_1747
																																																																											=
																																																																											BgL_proc1z00_20037;
																																																																										BgL_testz00_1746
																																																																											=
																																																																											BgL_testz00_20036;
																																																																										goto
																																																																											BgL_tagzd2388zd2_1750;
																																																																									}
																																																																									BgL_auxz00_14205
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_20035);
																																																																								}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1774;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_20043;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1775;
																																																																										BgL_auxz00_14205
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_20043);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1774;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_20047;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1775;
																																																																								BgL_auxz00_14205
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_20047);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1774;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_20051;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1775;
																																																																						BgL_auxz00_14205
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_20051);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1774;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_20055;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1775;
																																																																				BgL_auxz00_14205
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_20055);
																																																																			}
																																																																	}
																																																															}
																																																														}
																																																													}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{	/* Ast/sexp.scm 118 */
																																																													goto
																																																														BgL_tagzd2403zd2_1774;
																																																												}
																																																											else
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_20059;
																																																													goto
																																																														BgL_tagzd2404zd2_1775;
																																																													BgL_auxz00_14205
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_20059);
																																																												}
																																																										}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_cdrzd222058zd2_4974;
																																																									BgL_cdrzd222058zd2_4974
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_cdrzd222065zd2_4975;
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_pairz00_11291;
																																																											BgL_pairz00_11291
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											BgL_cdrzd222065zd2_4975
																																																												=
																																																												CDR
																																																												(BgL_pairz00_11291);
																																																										}
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_cdrzd222072zd2_4976;
																																																											BgL_cdrzd222072zd2_4976
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd222065zd2_4975));
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_carzd222078zd2_4977;
																																																												obj_t
																																																													BgL_cdrzd222079zd2_4978;
																																																												BgL_carzd222078zd2_4977
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_cdrzd222072zd2_4976));
																																																												BgL_cdrzd222079zd2_4978
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_cdrzd222072zd2_4976));
																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd222078zd2_4977))
																																																													{	/* Ast/sexp.scm 118 */
																																																														if (PAIRP(BgL_cdrzd222079zd2_4978))
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_carzd222086zd2_4981;
																																																																BgL_carzd222086zd2_4981
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd222079zd2_4978);
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd222086zd2_4981))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (NULLP(CDR(BgL_cdrzd222079zd2_4978)))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd222058zd2_4974))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_arg4221z00_4986;
																																																																						BgL_arg4221z00_4986
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd222065zd2_4975));
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_20086;
																																																																							{
																																																																								obj_t
																																																																									BgL_argsz00_20090;
																																																																								obj_t
																																																																									BgL_proc2z00_20089;
																																																																								obj_t
																																																																									BgL_proc1z00_20088;
																																																																								obj_t
																																																																									BgL_testz00_20087;
																																																																								BgL_testz00_20087
																																																																									=
																																																																									BgL_arg4221z00_4986;
																																																																								BgL_proc1z00_20088
																																																																									=
																																																																									BgL_carzd222078zd2_4977;
																																																																								BgL_proc2z00_20089
																																																																									=
																																																																									BgL_carzd222086zd2_4981;
																																																																								BgL_argsz00_20090
																																																																									=
																																																																									BgL_cdrzd222058zd2_4974;
																																																																								BgL_argsz00_1749
																																																																									=
																																																																									BgL_argsz00_20090;
																																																																								BgL_proc2z00_1748
																																																																									=
																																																																									BgL_proc2z00_20089;
																																																																								BgL_proc1z00_1747
																																																																									=
																																																																									BgL_proc1z00_20088;
																																																																								BgL_testz00_1746
																																																																									=
																																																																									BgL_testz00_20087;
																																																																								goto
																																																																									BgL_tagzd2388zd2_1750;
																																																																							}
																																																																							BgL_auxz00_14205
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_20086);
																																																																						}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1774;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_20094;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1775;
																																																																								BgL_auxz00_14205
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_20094);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1774;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_20098;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1775;
																																																																						BgL_auxz00_14205
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_20098);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1774;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_20102;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1775;
																																																																				BgL_auxz00_14205
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_20102);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1774;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_20106;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1775;
																																																																		BgL_auxz00_14205
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_20106);
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 118 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 118 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1774;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_20110;
																																																																goto
																																																																	BgL_tagzd2404zd2_1775;
																																																																BgL_auxz00_14205
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_20110);
																																																															}
																																																													}
																																																											}
																																																										}
																																																									}
																																																								}
																																																						}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 118 */
																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																							{	/* Ast/sexp.scm 118 */
																																																								goto
																																																									BgL_tagzd2403zd2_1774;
																																																							}
																																																						else
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_20114;
																																																								goto
																																																									BgL_tagzd2404zd2_1775;
																																																								BgL_auxz00_14205
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_20114);
																																																							}
																																																					}
																																																			}
																																																		}
																																																}
																																															}
																																													}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 118 */
																																												bool_t
																																													BgL_test9004z00_20116;
																																												{	/* Ast/sexp.scm 118 */
																																													obj_t
																																														BgL_arg4243z00_5010;
																																													BgL_arg4243z00_5010
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													BgL_test9004z00_20116
																																														=
																																														CBOOL
																																														(BGl_labelszd2symzf3z21zzast_labelsz00
																																														(BgL_arg4243z00_5010));
																																												}
																																												if (BgL_test9004z00_20116)
																																													{
																																														BgL_letzd2funzd2_bglt
																																															BgL_auxz00_20121;
																																														goto
																																															BgL_tagzd2384zd2_1732;
																																														BgL_auxz00_14205
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_20121);
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														obj_t
																																															BgL_carzd222532zd2_5001;
																																														BgL_carzd222532zd2_5001
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_cdrzd222537zd2_5002;
																																															BgL_cdrzd222537zd2_5002
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_carzd222532zd2_5001));
																																															if ((CAR(((obj_t) BgL_carzd222532zd2_5001)) == CNST_TABLE_REF(((long) 3))))
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_arg4238z00_5005;
																																																	obj_t
																																																		BgL_arg4239z00_5006;
																																																	obj_t
																																																		BgL_arg4240z00_5007;
																																																	BgL_arg4238z00_5005
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd222537zd2_5002));
																																																	BgL_arg4239z00_5006
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd222537zd2_5002));
																																																	BgL_arg4240z00_5007
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_20138;
																																																		{
																																																			obj_t
																																																				BgL_argsz00_20141;
																																																			obj_t
																																																				BgL_bodyz00_20140;
																																																			obj_t
																																																				BgL_varsz00_20139;
																																																			BgL_varsz00_20139
																																																				=
																																																				BgL_arg4238z00_5005;
																																																			BgL_bodyz00_20140
																																																				=
																																																				BgL_arg4239z00_5006;
																																																			BgL_argsz00_20141
																																																				=
																																																				BgL_arg4240z00_5007;
																																																			BgL_argsz00_1739
																																																				=
																																																				BgL_argsz00_20141;
																																																			BgL_bodyz00_1738
																																																				=
																																																				BgL_bodyz00_20140;
																																																			BgL_varsz00_1737
																																																				=
																																																				BgL_varsz00_20139;
																																																			goto
																																																				BgL_tagzd2386zd2_1740;
																																																		}
																																																		BgL_auxz00_14205
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_20138);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																		{	/* Ast/sexp.scm 118 */
																																																			goto
																																																				BgL_tagzd2403zd2_1774;
																																																		}
																																																	else
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_20145;
																																																			goto
																																																				BgL_tagzd2404zd2_1775;
																																																			BgL_auxz00_14205
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_20145);
																																																		}
																																																}
																																														}
																																													}
																																											}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 118 */
																																										bool_t
																																											BgL_test9007z00_20147;
																																										{	/* Ast/sexp.scm 118 */
																																											obj_t
																																												BgL_arg4247z00_5014;
																																											BgL_arg4247z00_5014
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_expz00_21));
																																											BgL_test9007z00_20147
																																												=
																																												CBOOL
																																												(BGl_labelszd2symzf3z21zzast_labelsz00
																																												(BgL_arg4247z00_5014));
																																										}
																																										if (BgL_test9007z00_20147)
																																											{
																																												BgL_letzd2funzd2_bglt
																																													BgL_auxz00_20152;
																																												goto
																																													BgL_tagzd2384zd2_1732;
																																												BgL_auxz00_14205
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_20152);
																																											}
																																										else
																																											{	/* Ast/sexp.scm 118 */
																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																													{	/* Ast/sexp.scm 118 */
																																														goto
																																															BgL_tagzd2403zd2_1774;
																																													}
																																												else
																																													{
																																														BgL_nodez00_bglt
																																															BgL_auxz00_20156;
																																														goto
																																															BgL_tagzd2404zd2_1775;
																																														BgL_auxz00_14205
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_20156);
																																													}
																																											}
																																									}
																																							}
																																						else
																																							{	/* Ast/sexp.scm 118 */
																																								if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd221239zd2_4765)))
																																									{	/* Ast/sexp.scm 118 */
																																										goto
																																											BgL_kapzd221241zd2_4767;
																																									}
																																								else
																																									{	/* Ast/sexp.scm 118 */
																																										if ((BgL_carzd221239zd2_4765 == CNST_TABLE_REF(((long) 18))))
																																											{	/* Ast/sexp.scm 118 */
																																												goto
																																													BgL_kapzd221241zd2_4767;
																																											}
																																										else
																																											{	/* Ast/sexp.scm 118 */
																																												if ((BgL_carzd221239zd2_4765 == CNST_TABLE_REF(((long) 19))))
																																													{	/* Ast/sexp.scm 118 */
																																														goto
																																															BgL_kapzd221241zd2_4767;
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd221239zd2_4765)))
																																															{	/* Ast/sexp.scm 118 */
																																																goto
																																																	BgL_kapzd221241zd2_4767;
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																bool_t
																																																	BgL_test9013z00_20170;
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_arg4162z00_4884;
																																																	BgL_arg4162z00_4884
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	BgL_test9013z00_20170
																																																		=
																																																		CBOOL
																																																		(BGl_labelszd2symzf3z21zzast_labelsz00
																																																		(BgL_arg4162z00_4884));
																																																}
																																																if (BgL_test9013z00_20170)
																																																	{
																																																		BgL_letzd2funzd2_bglt
																																																			BgL_auxz00_20175;
																																																		goto
																																																			BgL_tagzd2384zd2_1732;
																																																		BgL_auxz00_14205
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_20175);
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_carzd222860zd2_4775;
																																																		BgL_carzd222860zd2_4775
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_cdrzd222865zd2_4776;
																																																			BgL_cdrzd222865zd2_4776
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_carzd222860zd2_4775));
																																																			if ((CAR(((obj_t) BgL_carzd222860zd2_4775)) == CNST_TABLE_REF(((long) 3))))
																																																				{	/* Ast/sexp.scm 118 */
																																																					if (PAIRP(BgL_cdrzd222865zd2_4776))
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_arg4098z00_4780;
																																																							obj_t
																																																								BgL_arg4099z00_4781;
																																																							obj_t
																																																								BgL_arg4100z00_4782;
																																																							BgL_arg4098z00_4780
																																																								=
																																																								CAR
																																																								(BgL_cdrzd222865zd2_4776);
																																																							BgL_arg4099z00_4781
																																																								=
																																																								CDR
																																																								(BgL_cdrzd222865zd2_4776);
																																																							BgL_arg4100z00_4782
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_20192;
																																																								{
																																																									obj_t
																																																										BgL_argsz00_20195;
																																																									obj_t
																																																										BgL_bodyz00_20194;
																																																									obj_t
																																																										BgL_varsz00_20193;
																																																									BgL_varsz00_20193
																																																										=
																																																										BgL_arg4098z00_4780;
																																																									BgL_bodyz00_20194
																																																										=
																																																										BgL_arg4099z00_4781;
																																																									BgL_argsz00_20195
																																																										=
																																																										BgL_arg4100z00_4782;
																																																									BgL_argsz00_1739
																																																										=
																																																										BgL_argsz00_20195;
																																																									BgL_bodyz00_1738
																																																										=
																																																										BgL_bodyz00_20194;
																																																									BgL_varsz00_1737
																																																										=
																																																										BgL_varsz00_20193;
																																																									goto
																																																										BgL_tagzd2386zd2_1740;
																																																								}
																																																								BgL_auxz00_14205
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_20192);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																								{	/* Ast/sexp.scm 118 */
																																																									goto
																																																										BgL_tagzd2403zd2_1774;
																																																								}
																																																							else
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_20199;
																																																									goto
																																																										BgL_tagzd2404zd2_1775;
																																																									BgL_auxz00_14205
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_20199);
																																																								}
																																																						}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_cdrzd222972zd2_4785;
																																																					BgL_cdrzd222972zd2_4785
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_cdrzd222977zd2_4786;
																																																						BgL_cdrzd222977zd2_4786
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_carzd222860zd2_4775));
																																																						if ((CAR(((obj_t) BgL_carzd222860zd2_4775)) == CNST_TABLE_REF(((long) 1))))
																																																							{	/* Ast/sexp.scm 118 */
																																																								if (PAIRP(BgL_cdrzd222977zd2_4786))
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_cdrzd222982zd2_4790;
																																																										BgL_cdrzd222982zd2_4790
																																																											=
																																																											CDR
																																																											(BgL_cdrzd222977zd2_4786);
																																																										if (PAIRP(BgL_cdrzd222982zd2_4790))
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_carzd222986zd2_4792;
																																																												obj_t
																																																													BgL_cdrzd222987zd2_4793;
																																																												BgL_carzd222986zd2_4792
																																																													=
																																																													CAR
																																																													(BgL_cdrzd222982zd2_4790);
																																																												BgL_cdrzd222987zd2_4793
																																																													=
																																																													CDR
																																																													(BgL_cdrzd222982zd2_4790);
																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd222986zd2_4792))
																																																													{	/* Ast/sexp.scm 118 */
																																																														if (PAIRP(BgL_cdrzd222987zd2_4793))
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_carzd222992zd2_4796;
																																																																BgL_carzd222992zd2_4796
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd222987zd2_4793);
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd222992zd2_4796))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (NULLP(CDR(BgL_cdrzd222987zd2_4793)))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				bool_t
																																																																					BgL_test9024z00_20227;
																																																																				{
																																																																					obj_t
																																																																						BgL_l1403z00_4829;
																																																																					BgL_l1403z00_4829
																																																																						=
																																																																						BgL_cdrzd222972zd2_4785;
																																																																				BgL_zc3z04anonymousza34126ze3z87_4830:
																																																																					if (NULLP(BgL_l1403z00_4829))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							BgL_test9024z00_20227
																																																																								=
																																																																								(
																																																																								(bool_t)
																																																																								1);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							bool_t
																																																																								BgL_test9026z00_20230;
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								bool_t
																																																																									BgL_test9027z00_20231;
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_tmpz00_20232;
																																																																									BgL_tmpz00_20232
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_l1403z00_4829));
																																																																									BgL_test9027z00_20231
																																																																										=
																																																																										PAIRP
																																																																										(BgL_tmpz00_20232);
																																																																								}
																																																																								if (BgL_test9027z00_20231)
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										BgL_test9026z00_20230
																																																																											=
																																																																											(
																																																																											(bool_t)
																																																																											0);
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										BgL_test9026z00_20230
																																																																											=
																																																																											(
																																																																											(bool_t)
																																																																											1);
																																																																									}
																																																																							}
																																																																							if (BgL_test9026z00_20230)
																																																																								{
																																																																									obj_t
																																																																										BgL_l1403z00_20236;
																																																																									BgL_l1403z00_20236
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_l1403z00_4829));
																																																																									BgL_l1403z00_4829
																																																																										=
																																																																										BgL_l1403z00_20236;
																																																																									goto
																																																																										BgL_zc3z04anonymousza34126ze3z87_4830;
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									BgL_test9024z00_20227
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										0);
																																																																								}
																																																																						}
																																																																				}
																																																																				if (BgL_test9024z00_20227)
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_arg4116z00_4812;
																																																																						BgL_arg4116z00_4812
																																																																							=
																																																																							CAR
																																																																							(BgL_cdrzd222977zd2_4786);
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_20240;
																																																																							{
																																																																								obj_t
																																																																									BgL_argsz00_20244;
																																																																								obj_t
																																																																									BgL_proc2z00_20243;
																																																																								obj_t
																																																																									BgL_proc1z00_20242;
																																																																								obj_t
																																																																									BgL_testz00_20241;
																																																																								BgL_testz00_20241
																																																																									=
																																																																									BgL_arg4116z00_4812;
																																																																								BgL_proc1z00_20242
																																																																									=
																																																																									BgL_carzd222986zd2_4792;
																																																																								BgL_proc2z00_20243
																																																																									=
																																																																									BgL_carzd222992zd2_4796;
																																																																								BgL_argsz00_20244
																																																																									=
																																																																									BgL_cdrzd222972zd2_4785;
																																																																								BgL_argsz00_1744
																																																																									=
																																																																									BgL_argsz00_20244;
																																																																								BgL_proc2z00_1743
																																																																									=
																																																																									BgL_proc2z00_20243;
																																																																								BgL_proc1z00_1742
																																																																									=
																																																																									BgL_proc1z00_20242;
																																																																								BgL_testz00_1741
																																																																									=
																																																																									BgL_testz00_20241;
																																																																								goto
																																																																									BgL_tagzd2387zd2_1745;
																																																																							}
																																																																							BgL_auxz00_14205
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_20240);
																																																																						}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_cdrzd223017zd2_4813;
																																																																						BgL_cdrzd223017zd2_4813
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_cdrzd223025zd2_4814;
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_pairz00_11336;
																																																																								BgL_pairz00_11336
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								BgL_cdrzd223025zd2_4814
																																																																									=
																																																																									CDR
																																																																									(BgL_pairz00_11336);
																																																																							}
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_cdrzd223033zd2_4815;
																																																																								BgL_cdrzd223033zd2_4815
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd223025zd2_4814));
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_carzd223040zd2_4816;
																																																																									BgL_carzd223040zd2_4816
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd223033zd2_4815));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd223040zd2_4816))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_carzd223049zd2_4818;
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_pairz00_11340;
																																																																												BgL_pairz00_11340
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd223033zd2_4815));
																																																																												BgL_carzd223049zd2_4818
																																																																													=
																																																																													CAR
																																																																													(BgL_pairz00_11340);
																																																																											}
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd223049zd2_4818))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd223017zd2_4813))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_arg4120z00_4821;
																																																																															BgL_arg4120z00_4821
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd223025zd2_4814));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_20266;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_20270;
																																																																																	obj_t
																																																																																		BgL_proc2z00_20269;
																																																																																	obj_t
																																																																																		BgL_proc1z00_20268;
																																																																																	obj_t
																																																																																		BgL_testz00_20267;
																																																																																	BgL_testz00_20267
																																																																																		=
																																																																																		BgL_arg4120z00_4821;
																																																																																	BgL_proc1z00_20268
																																																																																		=
																																																																																		BgL_carzd223040zd2_4816;
																																																																																	BgL_proc2z00_20269
																																																																																		=
																																																																																		BgL_carzd223049zd2_4818;
																																																																																	BgL_argsz00_20270
																																																																																		=
																																																																																		BgL_cdrzd223017zd2_4813;
																																																																																	BgL_argsz00_1749
																																																																																		=
																																																																																		BgL_argsz00_20270;
																																																																																	BgL_proc2z00_1748
																																																																																		=
																																																																																		BgL_proc2z00_20269;
																																																																																	BgL_proc1z00_1747
																																																																																		=
																																																																																		BgL_proc1z00_20268;
																																																																																	BgL_testz00_1746
																																																																																		=
																																																																																		BgL_testz00_20267;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1750;
																																																																																}
																																																																																BgL_auxz00_14205
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_20266);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1774;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_20274;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1775;
																																																																																	BgL_auxz00_14205
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_20274);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1774;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_20278;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1775;
																																																																															BgL_auxz00_14205
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_20278);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1774;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_20282;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1775;
																																																																													BgL_auxz00_14205
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_20282);
																																																																												}
																																																																										}
																																																																								}
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1774;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_20286;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1775;
																																																																						BgL_auxz00_14205
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_20286);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_cdrzd223327zd2_4840;
																																																																		BgL_cdrzd223327zd2_4840
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_cdrzd223334zd2_4841;
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_pairz00_11344;
																																																																				BgL_pairz00_11344
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				BgL_cdrzd223334zd2_4841
																																																																					=
																																																																					CDR
																																																																					(BgL_pairz00_11344);
																																																																			}
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_cdrzd223341zd2_4842;
																																																																				BgL_cdrzd223341zd2_4842
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd223334zd2_4841));
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_carzd223347zd2_4843;
																																																																					obj_t
																																																																						BgL_cdrzd223348zd2_4844;
																																																																					BgL_carzd223347zd2_4843
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd223341zd2_4842));
																																																																					BgL_cdrzd223348zd2_4844
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd223341zd2_4842));
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd223347zd2_4843))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_carzd223355zd2_4846;
																																																																							BgL_carzd223355zd2_4846
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd223348zd2_4844));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd223355zd2_4846))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (NULLP(CDR(((obj_t) BgL_cdrzd223348zd2_4844))))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd223327zd2_4840))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_arg4135z00_4851;
																																																																													BgL_arg4135z00_4851
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd223334zd2_4841));
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_20313;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_20317;
																																																																															obj_t
																																																																																BgL_proc2z00_20316;
																																																																															obj_t
																																																																																BgL_proc1z00_20315;
																																																																															obj_t
																																																																																BgL_testz00_20314;
																																																																															BgL_testz00_20314
																																																																																=
																																																																																BgL_arg4135z00_4851;
																																																																															BgL_proc1z00_20315
																																																																																=
																																																																																BgL_carzd223347zd2_4843;
																																																																															BgL_proc2z00_20316
																																																																																=
																																																																																BgL_carzd223355zd2_4846;
																																																																															BgL_argsz00_20317
																																																																																=
																																																																																BgL_cdrzd223327zd2_4840;
																																																																															BgL_argsz00_1749
																																																																																=
																																																																																BgL_argsz00_20317;
																																																																															BgL_proc2z00_1748
																																																																																=
																																																																																BgL_proc2z00_20316;
																																																																															BgL_proc1z00_1747
																																																																																=
																																																																																BgL_proc1z00_20315;
																																																																															BgL_testz00_1746
																																																																																=
																																																																																BgL_testz00_20314;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1750;
																																																																														}
																																																																														BgL_auxz00_14205
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_20313);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1774;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_20321;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1775;
																																																																															BgL_auxz00_14205
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_20321);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1774;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_20325;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1775;
																																																																													BgL_auxz00_14205
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_20325);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1774;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_20329;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1775;
																																																																											BgL_auxz00_14205
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_20329);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1774;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_20333;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1775;
																																																																									BgL_auxz00_14205
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_20333);
																																																																								}
																																																																						}
																																																																				}
																																																																			}
																																																																		}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1774;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_20337;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1775;
																																																																		BgL_auxz00_14205
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_20337);
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_cdrzd223688zd2_4859;
																																																														BgL_cdrzd223688zd2_4859
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_cdrzd223694zd2_4860;
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_pairz00_11354;
																																																																BgL_pairz00_11354
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																BgL_cdrzd223694zd2_4860
																																																																	=
																																																																	CDR
																																																																	(BgL_pairz00_11354);
																																																															}
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_cdrzd223700zd2_4861;
																																																																BgL_cdrzd223700zd2_4861
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd223694zd2_4860));
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_carzd223705zd2_4862;
																																																																	obj_t
																																																																		BgL_cdrzd223706zd2_4863;
																																																																	BgL_carzd223705zd2_4862
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd223700zd2_4861));
																																																																	BgL_cdrzd223706zd2_4863
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd223700zd2_4861));
																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd223705zd2_4862))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if (PAIRP(BgL_cdrzd223706zd2_4863))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_carzd223711zd2_4866;
																																																																					BgL_carzd223711zd2_4866
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd223706zd2_4863);
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd223711zd2_4866))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (NULLP(CDR(BgL_cdrzd223706zd2_4863)))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd223688zd2_4859))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_arg4149z00_4871;
																																																																											BgL_arg4149z00_4871
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd223694zd2_4860));
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_20364;
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_20368;
																																																																													obj_t
																																																																														BgL_proc2z00_20367;
																																																																													obj_t
																																																																														BgL_proc1z00_20366;
																																																																													obj_t
																																																																														BgL_testz00_20365;
																																																																													BgL_testz00_20365
																																																																														=
																																																																														BgL_arg4149z00_4871;
																																																																													BgL_proc1z00_20366
																																																																														=
																																																																														BgL_carzd223705zd2_4862;
																																																																													BgL_proc2z00_20367
																																																																														=
																																																																														BgL_carzd223711zd2_4866;
																																																																													BgL_argsz00_20368
																																																																														=
																																																																														BgL_cdrzd223688zd2_4859;
																																																																													BgL_argsz00_1749
																																																																														=
																																																																														BgL_argsz00_20368;
																																																																													BgL_proc2z00_1748
																																																																														=
																																																																														BgL_proc2z00_20367;
																																																																													BgL_proc1z00_1747
																																																																														=
																																																																														BgL_proc1z00_20366;
																																																																													BgL_testz00_1746
																																																																														=
																																																																														BgL_testz00_20365;
																																																																													goto
																																																																														BgL_tagzd2388zd2_1750;
																																																																												}
																																																																												BgL_auxz00_14205
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_20364);
																																																																											}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1774;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_20372;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1775;
																																																																													BgL_auxz00_14205
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_20372);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1774;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_20376;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1775;
																																																																											BgL_auxz00_14205
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_20376);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1774;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_20380;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1775;
																																																																									BgL_auxz00_14205
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_20380);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1774;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_20384;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1775;
																																																																							BgL_auxz00_14205
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_20384);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1774;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_20388;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1775;
																																																																					BgL_auxz00_14205
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_20388);
																																																																				}
																																																																		}
																																																																}
																																																															}
																																																														}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 118 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{	/* Ast/sexp.scm 118 */
																																																														goto
																																																															BgL_tagzd2403zd2_1774;
																																																													}
																																																												else
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_20392;
																																																														goto
																																																															BgL_tagzd2404zd2_1775;
																																																														BgL_auxz00_14205
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_20392);
																																																													}
																																																											}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 118 */
																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																											{	/* Ast/sexp.scm 118 */
																																																												goto
																																																													BgL_tagzd2403zd2_1774;
																																																											}
																																																										else
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_20396;
																																																												goto
																																																													BgL_tagzd2404zd2_1775;
																																																												BgL_auxz00_14205
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_20396);
																																																											}
																																																									}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 118 */
																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																									{	/* Ast/sexp.scm 118 */
																																																										goto
																																																											BgL_tagzd2403zd2_1774;
																																																									}
																																																								else
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_20400;
																																																										goto
																																																											BgL_tagzd2404zd2_1775;
																																																										BgL_auxz00_14205
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_20400);
																																																									}
																																																							}
																																																					}
																																																				}
																																																		}
																																																	}
																																															}
																																													}
																																											}
																																									}
																																							}
																																					}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 118 */
																																					if (
																																						(BgL_carzd221236zd2_4763
																																							==
																																							CNST_TABLE_REF
																																							(((long) 20))))
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_20405;
																																							goto
																																								BgL_tagzd2383zd2_1731;
																																							BgL_auxz00_14205
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_20405);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 118 */
																																							obj_t
																																								BgL_carzd224273zd2_5017;
																																							BgL_carzd224273zd2_5017
																																								=
																																								CAR
																																								(
																																								((obj_t) BgL_expz00_21));
																																							if ((BgL_carzd224273zd2_5017 == CNST_TABLE_REF(((long) 19))))
																																								{
																																									BgL_letzd2funzd2_bglt
																																										BgL_auxz00_20412;
																																									goto
																																										BgL_tagzd2384zd2_1732;
																																									BgL_auxz00_14205
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_20412);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 118 */
																																									if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd224273zd2_5017)))
																																										{
																																											BgL_letzd2funzd2_bglt
																																												BgL_auxz00_20417;
																																											goto
																																												BgL_tagzd2384zd2_1732;
																																											BgL_auxz00_14205
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_20417);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 118 */
																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_20424;
																																													goto
																																														BgL_tagzd2389zd2_1751;
																																													BgL_auxz00_14205
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_20424);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 118 */
																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_20431;
																																															goto
																																																BgL_tagzd2390zd2_1752;
																																															BgL_auxz00_14205
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_20431);
																																														}
																																													else
																																														{	/* Ast/sexp.scm 118 */
																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_20438;
																																																	goto
																																																		BgL_tagzd2392zd2_1756;
																																																	BgL_auxz00_14205
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_20438);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_20445;
																																																			goto
																																																				BgL_tagzd2393zd2_1757;
																																																			BgL_auxz00_14205
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_20445);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_20452;
																																																					goto
																																																						BgL_tagzd2395zd2_1761;
																																																					BgL_auxz00_14205
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_20452);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_20459;
																																																							goto
																																																								BgL_tagzd2396zd2_1762;
																																																							BgL_auxz00_14205
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_20459);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_20466;
																																																									goto
																																																										BgL_tagzd2397zd2_1763;
																																																									BgL_auxz00_14205
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_20466);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																										{
																																																											BgL_jumpzd2exzd2itz00_bglt
																																																												BgL_auxz00_20473;
																																																											goto
																																																												BgL_tagzd2398zd2_1764;
																																																											BgL_auxz00_14205
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_20473);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											if (BGl_equalzf3zf3zz__r4_equivalence_6_2z00(CAR(((obj_t) BgL_expz00_21)), BUNSPEC))
																																																												{	/* Ast/sexp.scm 118 */
																																																													if (NULLP(CDR(((obj_t) BgL_expz00_21))))
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_20483;
																																																														BgL_tagzd2402zd2_1773:
																																																															{	/* Ast/sexp.scm 555 */
																																																																obj_t
																																																																	BgL_arg6990z00_8977;
																																																																BgL_arg6990z00_8977
																																																																	=
																																																																	BGl_findzd2locationzf2locz20zztools_locationz00
																																																																	(BgL_expz00_21,
																																																																	BgL_locz00_23);
																																																																{	/* Ast/sexp.scm 554 */
																																																																	BgL_nodez00_bglt
																																																																		BgL_res7445z00_10056;
																																																																	{	/* Ast/sexp.scm 722 */
																																																																		obj_t
																																																																			BgL_arg7104z00_10052;
																																																																		BgL_nodez00_bglt
																																																																			BgL_arg7105z00_10053;
																																																																		BgL_arg7104z00_10052
																																																																			=
																																																																			BGl_shapez00zztools_shapez00
																																																																			(BGl_currentzd2functionzd2zztools_errorz00
																																																																			());
																																																																		BgL_arg7105z00_10053
																																																																			=
																																																																			BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																			(CNST_TABLE_REF
																																																																			(((long) 4)), BNIL, BgL_arg6990z00_8977, CNST_TABLE_REF(((long) 2)));
																																																																		{	/* Ast/sexp.scm 721 */
																																																																			obj_t
																																																																				BgL_list7106z00_10055;
																																																																			BgL_list7106z00_10055
																																																																				=
																																																																				MAKE_YOUNG_PAIR
																																																																				(
																																																																				((obj_t) BgL_arg7105z00_10053), BNIL);
																																																																			BgL_res7445z00_10056
																																																																				=
																																																																				(
																																																																				(BgL_nodez00_bglt)
																																																																				BGl_userzd2errorzf2locationz20zztools_errorz00
																																																																				(BgL_arg6990z00_8977,
																																																																					BgL_arg7104z00_10052,
																																																																					BGl_string7988z00zzast_sexpz00,
																																																																					BgL_expz00_21,
																																																																					BgL_list7106z00_10055));
																																																																	}}
																																																																	BgL_auxz00_20483
																																																																		=
																																																																		BgL_res7445z00_10056;
																																																															}}
																																																															BgL_auxz00_14205
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_20483);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1774;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_20497;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1775;
																																																																	BgL_auxz00_14205
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_20497);
																																																																}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{	/* Ast/sexp.scm 118 */
																																																															goto
																																																																BgL_tagzd2403zd2_1774;
																																																														}
																																																													else
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_20501;
																																																															goto
																																																																BgL_tagzd2404zd2_1775;
																																																															BgL_auxz00_14205
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_20501);
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																										}
																									return
																										((BgL_nodez00_bglt)
																										BgL_auxz00_14205);
																								}
																							else
																								{	/* Ast/sexp.scm 118 */
																									if (
																										(BgL_carzd2610zd2_1804 ==
																											BGl_za2ifza2z00zzast_sexpz00))
																										{
																											obj_t BgL_auxz00_20506;

																											goto
																												BgL_kapzd2612zd2_1806;
																											return ((BgL_nodez00_bglt)
																												BgL_auxz00_20506);
																										}
																									else
																										{	/* Ast/sexp.scm 118 */
																											bool_t
																												BgL_test9073z00_20508;
																											{	/* Ast/sexp.scm 118 */
																												obj_t
																													BgL_arg2235z00_2551;
																												BgL_arg2235z00_2551 =
																													CAR(BgL_expz00_21);
																												BgL_test9073z00_20508 =
																													(BgL_arg2235z00_2551
																													==
																													BGl_za2ifza2z00zzast_sexpz00);
																											}
																											if (BgL_test9073z00_20508)
																												{	/* Ast/sexp.scm 118 */
																													goto
																														BgL_tagzd2377zd2_1719;
																												}
																											else
																												{	/* Ast/sexp.scm 118 */
																													obj_t
																														BgL_cdrzd224445zd2_1811;
																													BgL_cdrzd224445zd2_1811
																														=
																														CDR(BgL_expz00_21);
																													if ((CAR
																															(BgL_expz00_21) ==
																															CNST_TABLE_REF((
																																	(long) 7))))
																														{	/* Ast/sexp.scm 118 */
																															if (PAIRP
																																(BgL_cdrzd224445zd2_1811))
																																{	/* Ast/sexp.scm 118 */
																																	obj_t
																																		BgL_carzd224448zd2_1815;
																																	obj_t
																																		BgL_cdrzd224449zd2_1816;
																																	BgL_carzd224448zd2_1815
																																		=
																																		CAR
																																		(BgL_cdrzd224445zd2_1811);
																																	BgL_cdrzd224449zd2_1816
																																		=
																																		CDR
																																		(BgL_cdrzd224445zd2_1811);
																																	if (PAIRP
																																		(BgL_carzd224448zd2_1815))
																																		{	/* Ast/sexp.scm 118 */
																																			if (
																																				(CAR
																																					(BgL_carzd224448zd2_1815)
																																					==
																																					CNST_TABLE_REF
																																					(((long) 14))))
																																				{	/* Ast/sexp.scm 118 */
																																					if (PAIRP(BgL_cdrzd224449zd2_1816))
																																						{	/* Ast/sexp.scm 118 */
																																							if (NULLP(CDR(BgL_cdrzd224449zd2_1816)))
																																								{
																																									obj_t
																																										BgL_valz00_20533;
																																									obj_t
																																										BgL_lz00_20531;
																																									BgL_lz00_20531
																																										=
																																										CDR
																																										(BgL_carzd224448zd2_1815);
																																									BgL_valz00_20533
																																										=
																																										CAR
																																										(BgL_cdrzd224449zd2_1816);
																																									BgL_valz00_1721
																																										=
																																										BgL_valz00_20533;
																																									BgL_lz00_1720
																																										=
																																										BgL_lz00_20531;
																																									goto
																																										BgL_tagzd2378zd2_1722;
																																								}
																																							else
																																								{	/* Ast/sexp.scm 118 */
																																									goto
																																										BgL_tagzd2379zd2_1723;
																																								}
																																						}
																																					else
																																						{	/* Ast/sexp.scm 118 */
																																							goto
																																								BgL_tagzd2379zd2_1723;
																																						}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 118 */
																																					goto
																																						BgL_tagzd2379zd2_1723;
																																				}
																																		}
																																	else
																																		{	/* Ast/sexp.scm 118 */
																																			goto
																																				BgL_tagzd2379zd2_1723;
																																		}
																																}
																															else
																																{	/* Ast/sexp.scm 118 */
																																	goto
																																		BgL_tagzd2379zd2_1723;
																																}
																														}
																													else
																														{	/* Ast/sexp.scm 118 */
																															if (
																																(CAR
																																	(BgL_expz00_21)
																																	==
																																	CNST_TABLE_REF
																																	(((long)
																																			16))))
																																{	/* Ast/sexp.scm 118 */
																																	goto
																																		BgL_tagzd2380zd2_1724;
																																}
																															else
																																{	/* Ast/sexp.scm 118 */
																																	obj_t
																																		BgL_carzd224574zd2_1829;
																																	BgL_carzd224574zd2_1829
																																		=
																																		CAR
																																		(BgL_expz00_21);
																																	if (PAIRP
																																		(BgL_carzd224574zd2_1829))
																																		{	/* Ast/sexp.scm 118 */
																																			obj_t
																																				BgL_carzd224577zd2_1831;
																																			obj_t
																																				BgL_cdrzd224578zd2_1832;
																																			BgL_carzd224577zd2_1831
																																				=
																																				CAR
																																				(BgL_carzd224574zd2_1829);
																																			BgL_cdrzd224578zd2_1832
																																				=
																																				CDR
																																				(BgL_carzd224574zd2_1829);
																																			{

																																				if (
																																					(BgL_carzd224577zd2_1831
																																						==
																																						CNST_TABLE_REF
																																						(((long) 17))))
																																					{
																																						obj_t
																																							BgL_auxz00_20547;
																																					BgL_kapzd224579zd2_1833:
																																						if (PAIRP(BgL_cdrzd224578zd2_1832))
																																							{	/* Ast/sexp.scm 118 */
																																								obj_t
																																									BgL_cdrzd224582zd2_2135;
																																								BgL_cdrzd224582zd2_2135
																																									=
																																									CDR
																																									(BgL_cdrzd224578zd2_1832);
																																								if (PAIRP(BgL_cdrzd224582zd2_2135))
																																									{	/* Ast/sexp.scm 118 */
																																										if (NULLP(CDR(BgL_cdrzd224582zd2_2135)))
																																											{	/* Ast/sexp.scm 118 */
																																												obj_t
																																													BgL_arg1913z00_2139;
																																												obj_t
																																													BgL_arg1914z00_2140;
																																												BgL_arg1913z00_2139
																																													=
																																													CAR
																																													(BgL_cdrzd224582zd2_2135);
																																												BgL_arg1914z00_2140
																																													=
																																													CDR
																																													(
																																													((obj_t) BgL_expz00_21));
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_20559;
																																													{
																																														obj_t
																																															BgL_argsz00_20561;
																																														obj_t
																																															BgL_bodyz00_20560;
																																														BgL_bodyz00_20560
																																															=
																																															BgL_arg1913z00_2139;
																																														BgL_argsz00_20561
																																															=
																																															BgL_arg1914z00_2140;
																																														BgL_argsz00_1726
																																															=
																																															BgL_argsz00_20561;
																																														BgL_bodyz00_1725
																																															=
																																															BgL_bodyz00_20560;
																																														goto
																																															BgL_tagzd2381zd2_1727;
																																													}
																																													BgL_auxz00_20547
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_20559);
																																												}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 118 */
																																												obj_t
																																													BgL_cdrzd224605zd2_2141;
																																												BgL_cdrzd224605zd2_2141
																																													=
																																													CDR
																																													(
																																													((obj_t) BgL_expz00_21));
																																												{

																																													{	/* Ast/sexp.scm 118 */
																																														bool_t
																																															BgL_test9086z00_20565;
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_arg1986z00_2251;
																																															BgL_arg1986z00_2251
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															BgL_test9086z00_20565
																																																=
																																																CBOOL
																																																(BGl_letzd2symzf3z21zzast_letz00
																																																(BgL_arg1986z00_2251));
																																														}
																																														if (BgL_test9086z00_20565)
																																															{	/* Ast/sexp.scm 118 */
																																																if (PAIRP(BgL_cdrzd224605zd2_2141))
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_arg1988z00_2253;
																																																		obj_t
																																																			BgL_arg1989z00_2254;
																																																		BgL_arg1988z00_2253
																																																			=
																																																			CAR
																																																			(BgL_cdrzd224605zd2_2141);
																																																		BgL_arg1989z00_2254
																																																			=
																																																			CDR
																																																			(BgL_cdrzd224605zd2_2141);
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_20574;
																																																			{
																																																				obj_t
																																																					BgL_exprz00_20576;
																																																				obj_t
																																																					BgL_bindingsz00_20575;
																																																				BgL_bindingsz00_20575
																																																					=
																																																					BgL_arg1988z00_2253;
																																																				BgL_exprz00_20576
																																																					=
																																																					BgL_arg1989z00_2254;
																																																				BgL_exprz00_1729
																																																					=
																																																					BgL_exprz00_20576;
																																																				BgL_bindingsz00_1728
																																																					=
																																																					BgL_bindingsz00_20575;
																																																				goto
																																																					BgL_tagzd2382zd2_1730;
																																																			}
																																																			BgL_auxz00_20547
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_20574);
																																																		}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		bool_t
																																																			BgL_test9088z00_20578;
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_arg2057z00_2360;
																																																			BgL_arg2057z00_2360
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			BgL_test9088z00_20578
																																																				=
																																																				CBOOL
																																																				(BGl_labelszd2symzf3z21zzast_labelsz00
																																																				(BgL_arg2057z00_2360));
																																																		}
																																																		if (BgL_test9088z00_20578)
																																																			{
																																																				BgL_letzd2funzd2_bglt
																																																					BgL_auxz00_20583;
																																																				goto
																																																					BgL_tagzd2384zd2_1732;
																																																				BgL_auxz00_20547
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_20583);
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_carzd224669zd2_2257;
																																																				BgL_carzd224669zd2_2257
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_cdrzd224674zd2_2258;
																																																					BgL_cdrzd224674zd2_2258
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_carzd224669zd2_2257));
																																																					if ((CAR(((obj_t) BgL_carzd224669zd2_2257)) == CNST_TABLE_REF(((long) 3))))
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_arg1994z00_2261;
																																																							obj_t
																																																								BgL_arg1995z00_2262;
																																																							obj_t
																																																								BgL_arg1998z00_2263;
																																																							BgL_arg1994z00_2261
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd224674zd2_2258));
																																																							BgL_arg1995z00_2262
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd224674zd2_2258));
																																																							BgL_arg1998z00_2263
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_20600;
																																																								{
																																																									obj_t
																																																										BgL_argsz00_20603;
																																																									obj_t
																																																										BgL_bodyz00_20602;
																																																									obj_t
																																																										BgL_varsz00_20601;
																																																									BgL_varsz00_20601
																																																										=
																																																										BgL_arg1994z00_2261;
																																																									BgL_bodyz00_20602
																																																										=
																																																										BgL_arg1995z00_2262;
																																																									BgL_argsz00_20603
																																																										=
																																																										BgL_arg1998z00_2263;
																																																									BgL_argsz00_1739
																																																										=
																																																										BgL_argsz00_20603;
																																																									BgL_bodyz00_1738
																																																										=
																																																										BgL_bodyz00_20602;
																																																									BgL_varsz00_1737
																																																										=
																																																										BgL_varsz00_20601;
																																																									goto
																																																										BgL_tagzd2386zd2_1740;
																																																								}
																																																								BgL_auxz00_20547
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_20600);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_cdrzd224697zd2_2265;
																																																							BgL_cdrzd224697zd2_2265
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_cdrzd224703zd2_2266;
																																																								BgL_cdrzd224703zd2_2266
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_carzd224669zd2_2257));
																																																								if ((CAR(((obj_t) BgL_carzd224669zd2_2257)) == CNST_TABLE_REF(((long) 1))))
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_cdrzd224709zd2_2269;
																																																										BgL_cdrzd224709zd2_2269
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_cdrzd224703zd2_2266));
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_carzd224714zd2_2270;
																																																											obj_t
																																																												BgL_cdrzd224715zd2_2271;
																																																											BgL_carzd224714zd2_2270
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_cdrzd224709zd2_2269));
																																																											BgL_cdrzd224715zd2_2271
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd224709zd2_2269));
																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd224714zd2_2270))
																																																												{	/* Ast/sexp.scm 118 */
																																																													if (PAIRP(BgL_cdrzd224715zd2_2271))
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_carzd224722zd2_2274;
																																																															BgL_carzd224722zd2_2274
																																																																=
																																																																CAR
																																																																(BgL_cdrzd224715zd2_2271);
																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd224722zd2_2274))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if (NULLP(CDR(BgL_cdrzd224715zd2_2271)))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			bool_t
																																																																				BgL_test9095z00_20630;
																																																																			{
																																																																				obj_t
																																																																					BgL_l1406z00_2307;
																																																																				BgL_l1406z00_2307
																																																																					=
																																																																					BgL_cdrzd224697zd2_2265;
																																																																			BgL_zc3z04anonymousza32022ze3z87_2308:
																																																																				if (NULLP(BgL_l1406z00_2307))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						BgL_test9095z00_20630
																																																																							=
																																																																							(
																																																																							(bool_t)
																																																																							1);
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						bool_t
																																																																							BgL_test9097z00_20633;
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							bool_t
																																																																								BgL_test9098z00_20634;
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_tmpz00_20635;
																																																																								BgL_tmpz00_20635
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_l1406z00_2307));
																																																																								BgL_test9098z00_20634
																																																																									=
																																																																									PAIRP
																																																																									(BgL_tmpz00_20635);
																																																																							}
																																																																							if (BgL_test9098z00_20634)
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									BgL_test9097z00_20633
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										0);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									BgL_test9097z00_20633
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										1);
																																																																								}
																																																																						}
																																																																						if (BgL_test9097z00_20633)
																																																																							{
																																																																								obj_t
																																																																									BgL_l1406z00_20639;
																																																																								BgL_l1406z00_20639
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_l1406z00_2307));
																																																																								BgL_l1406z00_2307
																																																																									=
																																																																									BgL_l1406z00_20639;
																																																																								goto
																																																																									BgL_zc3z04anonymousza32022ze3z87_2308;
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								BgL_test9095z00_20630
																																																																									=
																																																																									(
																																																																									(bool_t)
																																																																									0);
																																																																							}
																																																																					}
																																																																			}
																																																																			if (BgL_test9095z00_20630)
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_arg2011z00_2290;
																																																																					BgL_arg2011z00_2290
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd224703zd2_2266));
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_20644;
																																																																						{
																																																																							obj_t
																																																																								BgL_argsz00_20648;
																																																																							obj_t
																																																																								BgL_proc2z00_20647;
																																																																							obj_t
																																																																								BgL_proc1z00_20646;
																																																																							obj_t
																																																																								BgL_testz00_20645;
																																																																							BgL_testz00_20645
																																																																								=
																																																																								BgL_arg2011z00_2290;
																																																																							BgL_proc1z00_20646
																																																																								=
																																																																								BgL_carzd224714zd2_2270;
																																																																							BgL_proc2z00_20647
																																																																								=
																																																																								BgL_carzd224722zd2_2274;
																																																																							BgL_argsz00_20648
																																																																								=
																																																																								BgL_cdrzd224697zd2_2265;
																																																																							BgL_argsz00_1744
																																																																								=
																																																																								BgL_argsz00_20648;
																																																																							BgL_proc2z00_1743
																																																																								=
																																																																								BgL_proc2z00_20647;
																																																																							BgL_proc1z00_1742
																																																																								=
																																																																								BgL_proc1z00_20646;
																																																																							BgL_testz00_1741
																																																																								=
																																																																								BgL_testz00_20645;
																																																																							goto
																																																																								BgL_tagzd2387zd2_1745;
																																																																						}
																																																																						BgL_auxz00_20547
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_20644);
																																																																					}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_cdrzd224746zd2_2291;
																																																																					BgL_cdrzd224746zd2_2291
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_expz00_21));
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_cdrzd224753zd2_2292;
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_pairz00_11430;
																																																																							BgL_pairz00_11430
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							BgL_cdrzd224753zd2_2292
																																																																								=
																																																																								CDR
																																																																								(BgL_pairz00_11430);
																																																																						}
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_cdrzd224760zd2_2293;
																																																																							BgL_cdrzd224760zd2_2293
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd224753zd2_2292));
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_carzd224766zd2_2294;
																																																																								BgL_carzd224766zd2_2294
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd224760zd2_2293));
																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd224766zd2_2294))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_carzd224773zd2_2296;
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_pairz00_11434;
																																																																											BgL_pairz00_11434
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd224760zd2_2293));
																																																																											BgL_carzd224773zd2_2296
																																																																												=
																																																																												CAR
																																																																												(BgL_pairz00_11434);
																																																																										}
																																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd224773zd2_2296))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd224746zd2_2291))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_arg2016z00_2299;
																																																																														BgL_arg2016z00_2299
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd224753zd2_2292));
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_20670;
																																																																															{
																																																																																obj_t
																																																																																	BgL_argsz00_20674;
																																																																																obj_t
																																																																																	BgL_proc2z00_20673;
																																																																																obj_t
																																																																																	BgL_proc1z00_20672;
																																																																																obj_t
																																																																																	BgL_testz00_20671;
																																																																																BgL_testz00_20671
																																																																																	=
																																																																																	BgL_arg2016z00_2299;
																																																																																BgL_proc1z00_20672
																																																																																	=
																																																																																	BgL_carzd224766zd2_2294;
																																																																																BgL_proc2z00_20673
																																																																																	=
																																																																																	BgL_carzd224773zd2_2296;
																																																																																BgL_argsz00_20674
																																																																																	=
																																																																																	BgL_cdrzd224746zd2_2291;
																																																																																BgL_argsz00_1749
																																																																																	=
																																																																																	BgL_argsz00_20674;
																																																																																BgL_proc2z00_1748
																																																																																	=
																																																																																	BgL_proc2z00_20673;
																																																																																BgL_proc1z00_1747
																																																																																	=
																																																																																	BgL_proc1z00_20672;
																																																																																BgL_testz00_1746
																																																																																	=
																																																																																	BgL_testz00_20671;
																																																																																goto
																																																																																	BgL_tagzd2388zd2_1750;
																																																																															}
																																																																															BgL_auxz00_20547
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_20670);
																																																																														}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1774;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_20678;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1775;
																																																																																BgL_auxz00_20547
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_20678);
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1774;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_20682;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1775;
																																																																														BgL_auxz00_20547
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_20682);
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1774;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_20686;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1775;
																																																																												BgL_auxz00_20547
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_20686);
																																																																											}
																																																																									}
																																																																							}
																																																																						}
																																																																					}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1774;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_20690;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1775;
																																																																					BgL_auxz00_20547
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_20690);
																																																																				}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd225049zd2_2318;
																																																																	BgL_cdrzd225049zd2_2318
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_expz00_21));
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_cdrzd225055zd2_2319;
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_pairz00_11438;
																																																																			BgL_pairz00_11438
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_expz00_21));
																																																																			BgL_cdrzd225055zd2_2319
																																																																				=
																																																																				CDR
																																																																				(BgL_pairz00_11438);
																																																																		}
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_cdrzd225061zd2_2320;
																																																																			BgL_cdrzd225061zd2_2320
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd225055zd2_2319));
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_carzd225066zd2_2321;
																																																																				obj_t
																																																																					BgL_cdrzd225067zd2_2322;
																																																																				BgL_carzd225066zd2_2321
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd225061zd2_2320));
																																																																				BgL_cdrzd225067zd2_2322
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd225061zd2_2320));
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd225066zd2_2321))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_carzd225072zd2_2324;
																																																																						BgL_carzd225072zd2_2324
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd225067zd2_2322));
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd225072zd2_2324))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (NULLP(CDR(((obj_t) BgL_cdrzd225067zd2_2322))))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd225049zd2_2318))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_arg2031z00_2329;
																																																																												BgL_arg2031z00_2329
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd225055zd2_2319));
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_20717;
																																																																													{
																																																																														obj_t
																																																																															BgL_argsz00_20721;
																																																																														obj_t
																																																																															BgL_proc2z00_20720;
																																																																														obj_t
																																																																															BgL_proc1z00_20719;
																																																																														obj_t
																																																																															BgL_testz00_20718;
																																																																														BgL_testz00_20718
																																																																															=
																																																																															BgL_arg2031z00_2329;
																																																																														BgL_proc1z00_20719
																																																																															=
																																																																															BgL_carzd225066zd2_2321;
																																																																														BgL_proc2z00_20720
																																																																															=
																																																																															BgL_carzd225072zd2_2324;
																																																																														BgL_argsz00_20721
																																																																															=
																																																																															BgL_cdrzd225049zd2_2318;
																																																																														BgL_argsz00_1749
																																																																															=
																																																																															BgL_argsz00_20721;
																																																																														BgL_proc2z00_1748
																																																																															=
																																																																															BgL_proc2z00_20720;
																																																																														BgL_proc1z00_1747
																																																																															=
																																																																															BgL_proc1z00_20719;
																																																																														BgL_testz00_1746
																																																																															=
																																																																															BgL_testz00_20718;
																																																																														goto
																																																																															BgL_tagzd2388zd2_1750;
																																																																													}
																																																																													BgL_auxz00_20547
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_20717);
																																																																												}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1774;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_20725;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1775;
																																																																														BgL_auxz00_20547
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_20725);
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1774;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_20729;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1775;
																																																																												BgL_auxz00_20547
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_20729);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1774;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_20733;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1775;
																																																																										BgL_auxz00_20547
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_20733);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1774;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_20737;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1775;
																																																																								BgL_auxz00_20547
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_20737);
																																																																							}
																																																																					}
																																																																			}
																																																																		}
																																																																	}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1774;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_20741;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1775;
																																																																	BgL_auxz00_20547
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_20741);
																																																																}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_cdrzd225405zd2_2337;
																																																													BgL_cdrzd225405zd2_2337
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_cdrzd225412zd2_2338;
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_pairz00_11448;
																																																															BgL_pairz00_11448
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															BgL_cdrzd225412zd2_2338
																																																																=
																																																																CDR
																																																																(BgL_pairz00_11448);
																																																														}
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_cdrzd225419zd2_2339;
																																																															BgL_cdrzd225419zd2_2339
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd225412zd2_2338));
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_carzd225425zd2_2340;
																																																																obj_t
																																																																	BgL_cdrzd225426zd2_2341;
																																																																BgL_carzd225425zd2_2340
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd225419zd2_2339));
																																																																BgL_cdrzd225426zd2_2341
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd225419zd2_2339));
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd225425zd2_2340))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (PAIRP(BgL_cdrzd225426zd2_2341))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_carzd225433zd2_2344;
																																																																				BgL_carzd225433zd2_2344
																																																																					=
																																																																					CAR
																																																																					(BgL_cdrzd225426zd2_2341);
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd225433zd2_2344))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (NULLP(CDR(BgL_cdrzd225426zd2_2341)))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd225405zd2_2337))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_arg2046z00_2349;
																																																																										BgL_arg2046z00_2349
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd225412zd2_2338));
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_20768;
																																																																											{
																																																																												obj_t
																																																																													BgL_argsz00_20772;
																																																																												obj_t
																																																																													BgL_proc2z00_20771;
																																																																												obj_t
																																																																													BgL_proc1z00_20770;
																																																																												obj_t
																																																																													BgL_testz00_20769;
																																																																												BgL_testz00_20769
																																																																													=
																																																																													BgL_arg2046z00_2349;
																																																																												BgL_proc1z00_20770
																																																																													=
																																																																													BgL_carzd225425zd2_2340;
																																																																												BgL_proc2z00_20771
																																																																													=
																																																																													BgL_carzd225433zd2_2344;
																																																																												BgL_argsz00_20772
																																																																													=
																																																																													BgL_cdrzd225405zd2_2337;
																																																																												BgL_argsz00_1749
																																																																													=
																																																																													BgL_argsz00_20772;
																																																																												BgL_proc2z00_1748
																																																																													=
																																																																													BgL_proc2z00_20771;
																																																																												BgL_proc1z00_1747
																																																																													=
																																																																													BgL_proc1z00_20770;
																																																																												BgL_testz00_1746
																																																																													=
																																																																													BgL_testz00_20769;
																																																																												goto
																																																																													BgL_tagzd2388zd2_1750;
																																																																											}
																																																																											BgL_auxz00_20547
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_20768);
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1774;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_20776;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1775;
																																																																												BgL_auxz00_20547
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_20776);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1774;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_20780;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1775;
																																																																										BgL_auxz00_20547
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_20780);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1774;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_20784;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1775;
																																																																								BgL_auxz00_20547
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_20784);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1774;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_20788;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1775;
																																																																						BgL_auxz00_20547
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_20788);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1774;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_20792;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1775;
																																																																				BgL_auxz00_20547
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_20792);
																																																																			}
																																																																	}
																																																															}
																																																														}
																																																													}
																																																												}
																																																										}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 118 */
																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																											{	/* Ast/sexp.scm 118 */
																																																												goto
																																																													BgL_tagzd2403zd2_1774;
																																																											}
																																																										else
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_20796;
																																																												goto
																																																													BgL_tagzd2404zd2_1775;
																																																												BgL_auxz00_20547
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_20796);
																																																											}
																																																									}
																																																							}
																																																						}
																																																				}
																																																			}
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																bool_t
																																																	BgL_test9126z00_20798;
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_arg1985z00_2250;
																																																	BgL_arg1985z00_2250
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	BgL_test9126z00_20798
																																																		=
																																																		CBOOL
																																																		(BGl_labelszd2symzf3z21zzast_labelsz00
																																																		(BgL_arg1985z00_2250));
																																																}
																																																if (BgL_test9126z00_20798)
																																																	{
																																																		BgL_letzd2funzd2_bglt
																																																			BgL_auxz00_20803;
																																																		goto
																																																			BgL_tagzd2384zd2_1732;
																																																		BgL_auxz00_20547
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_20803);
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_carzd225865zd2_2147;
																																																		BgL_carzd225865zd2_2147
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_cdrzd225870zd2_2148;
																																																			BgL_cdrzd225870zd2_2148
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_carzd225865zd2_2147));
																																																			if ((CAR(((obj_t) BgL_carzd225865zd2_2147)) == CNST_TABLE_REF(((long) 3))))
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_arg1921z00_2151;
																																																					obj_t
																																																						BgL_arg1922z00_2152;
																																																					obj_t
																																																						BgL_arg1923z00_2153;
																																																					BgL_arg1921z00_2151
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd225870zd2_2148));
																																																					BgL_arg1922z00_2152
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd225870zd2_2148));
																																																					BgL_arg1923z00_2153
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_20820;
																																																						{
																																																							obj_t
																																																								BgL_argsz00_20823;
																																																							obj_t
																																																								BgL_bodyz00_20822;
																																																							obj_t
																																																								BgL_varsz00_20821;
																																																							BgL_varsz00_20821
																																																								=
																																																								BgL_arg1921z00_2151;
																																																							BgL_bodyz00_20822
																																																								=
																																																								BgL_arg1922z00_2152;
																																																							BgL_argsz00_20823
																																																								=
																																																								BgL_arg1923z00_2153;
																																																							BgL_argsz00_1739
																																																								=
																																																								BgL_argsz00_20823;
																																																							BgL_bodyz00_1738
																																																								=
																																																								BgL_bodyz00_20822;
																																																							BgL_varsz00_1737
																																																								=
																																																								BgL_varsz00_20821;
																																																							goto
																																																								BgL_tagzd2386zd2_1740;
																																																						}
																																																						BgL_auxz00_20547
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_20820);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_cdrzd225893zd2_2155;
																																																					BgL_cdrzd225893zd2_2155
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_cdrzd225899zd2_2156;
																																																						BgL_cdrzd225899zd2_2156
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_carzd225865zd2_2147));
																																																						if ((CAR(((obj_t) BgL_carzd225865zd2_2147)) == CNST_TABLE_REF(((long) 1))))
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_cdrzd225905zd2_2159;
																																																								BgL_cdrzd225905zd2_2159
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_cdrzd225899zd2_2156));
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_carzd225910zd2_2160;
																																																									obj_t
																																																										BgL_cdrzd225911zd2_2161;
																																																									BgL_carzd225910zd2_2160
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd225905zd2_2159));
																																																									BgL_cdrzd225911zd2_2161
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd225905zd2_2159));
																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd225910zd2_2160))
																																																										{	/* Ast/sexp.scm 118 */
																																																											if (PAIRP(BgL_cdrzd225911zd2_2161))
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_carzd225918zd2_2164;
																																																													BgL_carzd225918zd2_2164
																																																														=
																																																														CAR
																																																														(BgL_cdrzd225911zd2_2161);
																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd225918zd2_2164))
																																																														{	/* Ast/sexp.scm 118 */
																																																															if (NULLP(CDR(BgL_cdrzd225911zd2_2161)))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	bool_t
																																																																		BgL_test9133z00_20850;
																																																																	{
																																																																		obj_t
																																																																			BgL_l1409z00_2197;
																																																																		BgL_l1409z00_2197
																																																																			=
																																																																			BgL_cdrzd225893zd2_2155;
																																																																	BgL_zc3z04anonymousza31946ze3z87_2198:
																																																																		if (NULLP(BgL_l1409z00_2197))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				BgL_test9133z00_20850
																																																																					=
																																																																					(
																																																																					(bool_t)
																																																																					1);
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				bool_t
																																																																					BgL_test9135z00_20853;
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					bool_t
																																																																						BgL_test9136z00_20854;
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_tmpz00_20855;
																																																																						BgL_tmpz00_20855
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_l1409z00_2197));
																																																																						BgL_test9136z00_20854
																																																																							=
																																																																							PAIRP
																																																																							(BgL_tmpz00_20855);
																																																																					}
																																																																					if (BgL_test9136z00_20854)
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							BgL_test9135z00_20853
																																																																								=
																																																																								(
																																																																								(bool_t)
																																																																								0);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							BgL_test9135z00_20853
																																																																								=
																																																																								(
																																																																								(bool_t)
																																																																								1);
																																																																						}
																																																																				}
																																																																				if (BgL_test9135z00_20853)
																																																																					{
																																																																						obj_t
																																																																							BgL_l1409z00_20859;
																																																																						BgL_l1409z00_20859
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_l1409z00_2197));
																																																																						BgL_l1409z00_2197
																																																																							=
																																																																							BgL_l1409z00_20859;
																																																																						goto
																																																																							BgL_zc3z04anonymousza31946ze3z87_2198;
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						BgL_test9133z00_20850
																																																																							=
																																																																							(
																																																																							(bool_t)
																																																																							0);
																																																																					}
																																																																			}
																																																																	}
																																																																	if (BgL_test9133z00_20850)
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_arg1936z00_2180;
																																																																			BgL_arg1936z00_2180
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd225899zd2_2156));
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_20864;
																																																																				{
																																																																					obj_t
																																																																						BgL_argsz00_20868;
																																																																					obj_t
																																																																						BgL_proc2z00_20867;
																																																																					obj_t
																																																																						BgL_proc1z00_20866;
																																																																					obj_t
																																																																						BgL_testz00_20865;
																																																																					BgL_testz00_20865
																																																																						=
																																																																						BgL_arg1936z00_2180;
																																																																					BgL_proc1z00_20866
																																																																						=
																																																																						BgL_carzd225910zd2_2160;
																																																																					BgL_proc2z00_20867
																																																																						=
																																																																						BgL_carzd225918zd2_2164;
																																																																					BgL_argsz00_20868
																																																																						=
																																																																						BgL_cdrzd225893zd2_2155;
																																																																					BgL_argsz00_1744
																																																																						=
																																																																						BgL_argsz00_20868;
																																																																					BgL_proc2z00_1743
																																																																						=
																																																																						BgL_proc2z00_20867;
																																																																					BgL_proc1z00_1742
																																																																						=
																																																																						BgL_proc1z00_20866;
																																																																					BgL_testz00_1741
																																																																						=
																																																																						BgL_testz00_20865;
																																																																					goto
																																																																						BgL_tagzd2387zd2_1745;
																																																																				}
																																																																				BgL_auxz00_20547
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_20864);
																																																																			}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_cdrzd225942zd2_2181;
																																																																			BgL_cdrzd225942zd2_2181
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_expz00_21));
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_cdrzd225949zd2_2182;
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_pairz00_11483;
																																																																					BgL_pairz00_11483
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_expz00_21));
																																																																					BgL_cdrzd225949zd2_2182
																																																																						=
																																																																						CDR
																																																																						(BgL_pairz00_11483);
																																																																				}
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_cdrzd225956zd2_2183;
																																																																					BgL_cdrzd225956zd2_2183
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd225949zd2_2182));
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_carzd225962zd2_2184;
																																																																						BgL_carzd225962zd2_2184
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd225956zd2_2183));
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd225962zd2_2184))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_carzd225969zd2_2186;
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_pairz00_11487;
																																																																									BgL_pairz00_11487
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd225956zd2_2183));
																																																																									BgL_carzd225969zd2_2186
																																																																										=
																																																																										CAR
																																																																										(BgL_pairz00_11487);
																																																																								}
																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd225969zd2_2186))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd225942zd2_2181))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_arg1940z00_2189;
																																																																												BgL_arg1940z00_2189
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd225949zd2_2182));
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_20890;
																																																																													{
																																																																														obj_t
																																																																															BgL_argsz00_20894;
																																																																														obj_t
																																																																															BgL_proc2z00_20893;
																																																																														obj_t
																																																																															BgL_proc1z00_20892;
																																																																														obj_t
																																																																															BgL_testz00_20891;
																																																																														BgL_testz00_20891
																																																																															=
																																																																															BgL_arg1940z00_2189;
																																																																														BgL_proc1z00_20892
																																																																															=
																																																																															BgL_carzd225962zd2_2184;
																																																																														BgL_proc2z00_20893
																																																																															=
																																																																															BgL_carzd225969zd2_2186;
																																																																														BgL_argsz00_20894
																																																																															=
																																																																															BgL_cdrzd225942zd2_2181;
																																																																														BgL_argsz00_1749
																																																																															=
																																																																															BgL_argsz00_20894;
																																																																														BgL_proc2z00_1748
																																																																															=
																																																																															BgL_proc2z00_20893;
																																																																														BgL_proc1z00_1747
																																																																															=
																																																																															BgL_proc1z00_20892;
																																																																														BgL_testz00_1746
																																																																															=
																																																																															BgL_testz00_20891;
																																																																														goto
																																																																															BgL_tagzd2388zd2_1750;
																																																																													}
																																																																													BgL_auxz00_20547
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_20890);
																																																																												}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1774;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_20898;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1775;
																																																																														BgL_auxz00_20547
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_20898);
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1774;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_20902;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1775;
																																																																												BgL_auxz00_20547
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_20902);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1774;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_20906;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1775;
																																																																										BgL_auxz00_20547
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_20906);
																																																																									}
																																																																							}
																																																																					}
																																																																				}
																																																																			}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1774;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_20910;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1775;
																																																																			BgL_auxz00_20547
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_20910);
																																																																		}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_cdrzd226245zd2_2208;
																																																															BgL_cdrzd226245zd2_2208
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_cdrzd226251zd2_2209;
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_pairz00_11491;
																																																																	BgL_pairz00_11491
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_expz00_21));
																																																																	BgL_cdrzd226251zd2_2209
																																																																		=
																																																																		CDR
																																																																		(BgL_pairz00_11491);
																																																																}
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd226257zd2_2210;
																																																																	BgL_cdrzd226257zd2_2210
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd226251zd2_2209));
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_carzd226262zd2_2211;
																																																																		obj_t
																																																																			BgL_cdrzd226263zd2_2212;
																																																																		BgL_carzd226262zd2_2211
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd226257zd2_2210));
																																																																		BgL_cdrzd226263zd2_2212
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd226257zd2_2210));
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd226262zd2_2211))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_carzd226268zd2_2214;
																																																																				BgL_carzd226268zd2_2214
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd226263zd2_2212));
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd226268zd2_2214))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (NULLP(CDR(((obj_t) BgL_cdrzd226263zd2_2212))))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd226245zd2_2208))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_arg1956z00_2219;
																																																																										BgL_arg1956z00_2219
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd226251zd2_2209));
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_20937;
																																																																											{
																																																																												obj_t
																																																																													BgL_argsz00_20941;
																																																																												obj_t
																																																																													BgL_proc2z00_20940;
																																																																												obj_t
																																																																													BgL_proc1z00_20939;
																																																																												obj_t
																																																																													BgL_testz00_20938;
																																																																												BgL_testz00_20938
																																																																													=
																																																																													BgL_arg1956z00_2219;
																																																																												BgL_proc1z00_20939
																																																																													=
																																																																													BgL_carzd226262zd2_2211;
																																																																												BgL_proc2z00_20940
																																																																													=
																																																																													BgL_carzd226268zd2_2214;
																																																																												BgL_argsz00_20941
																																																																													=
																																																																													BgL_cdrzd226245zd2_2208;
																																																																												BgL_argsz00_1749
																																																																													=
																																																																													BgL_argsz00_20941;
																																																																												BgL_proc2z00_1748
																																																																													=
																																																																													BgL_proc2z00_20940;
																																																																												BgL_proc1z00_1747
																																																																													=
																																																																													BgL_proc1z00_20939;
																																																																												BgL_testz00_1746
																																																																													=
																																																																													BgL_testz00_20938;
																																																																												goto
																																																																													BgL_tagzd2388zd2_1750;
																																																																											}
																																																																											BgL_auxz00_20547
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_20937);
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1774;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_20945;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1775;
																																																																												BgL_auxz00_20547
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_20945);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1774;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_20949;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1775;
																																																																										BgL_auxz00_20547
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_20949);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1774;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_20953;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1775;
																																																																								BgL_auxz00_20547
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_20953);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1774;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_20957;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1775;
																																																																						BgL_auxz00_20547
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_20957);
																																																																					}
																																																																			}
																																																																	}
																																																																}
																																																															}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{	/* Ast/sexp.scm 118 */
																																																															goto
																																																																BgL_tagzd2403zd2_1774;
																																																														}
																																																													else
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_20961;
																																																															goto
																																																																BgL_tagzd2404zd2_1775;
																																																															BgL_auxz00_20547
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_20961);
																																																														}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_cdrzd226601zd2_2227;
																																																											BgL_cdrzd226601zd2_2227
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_cdrzd226608zd2_2228;
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_pairz00_11501;
																																																													BgL_pairz00_11501
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													BgL_cdrzd226608zd2_2228
																																																														=
																																																														CDR
																																																														(BgL_pairz00_11501);
																																																												}
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_cdrzd226615zd2_2229;
																																																													BgL_cdrzd226615zd2_2229
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd226608zd2_2228));
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_carzd226621zd2_2230;
																																																														obj_t
																																																															BgL_cdrzd226622zd2_2231;
																																																														BgL_carzd226621zd2_2230
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd226615zd2_2229));
																																																														BgL_cdrzd226622zd2_2231
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd226615zd2_2229));
																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd226621zd2_2230))
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (PAIRP(BgL_cdrzd226622zd2_2231))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_carzd226629zd2_2234;
																																																																		BgL_carzd226629zd2_2234
																																																																			=
																																																																			CAR
																																																																			(BgL_cdrzd226622zd2_2231);
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd226629zd2_2234))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (NULLP(CDR(BgL_cdrzd226622zd2_2231)))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd226601zd2_2227))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_arg1970z00_2239;
																																																																								BgL_arg1970z00_2239
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd226608zd2_2228));
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_20988;
																																																																									{
																																																																										obj_t
																																																																											BgL_argsz00_20992;
																																																																										obj_t
																																																																											BgL_proc2z00_20991;
																																																																										obj_t
																																																																											BgL_proc1z00_20990;
																																																																										obj_t
																																																																											BgL_testz00_20989;
																																																																										BgL_testz00_20989
																																																																											=
																																																																											BgL_arg1970z00_2239;
																																																																										BgL_proc1z00_20990
																																																																											=
																																																																											BgL_carzd226621zd2_2230;
																																																																										BgL_proc2z00_20991
																																																																											=
																																																																											BgL_carzd226629zd2_2234;
																																																																										BgL_argsz00_20992
																																																																											=
																																																																											BgL_cdrzd226601zd2_2227;
																																																																										BgL_argsz00_1749
																																																																											=
																																																																											BgL_argsz00_20992;
																																																																										BgL_proc2z00_1748
																																																																											=
																																																																											BgL_proc2z00_20991;
																																																																										BgL_proc1z00_1747
																																																																											=
																																																																											BgL_proc1z00_20990;
																																																																										BgL_testz00_1746
																																																																											=
																																																																											BgL_testz00_20989;
																																																																										goto
																																																																											BgL_tagzd2388zd2_1750;
																																																																									}
																																																																									BgL_auxz00_20547
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_20988);
																																																																								}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1774;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_20996;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1775;
																																																																										BgL_auxz00_20547
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_20996);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1774;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_21000;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1775;
																																																																								BgL_auxz00_20547
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_21000);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1774;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_21004;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1775;
																																																																						BgL_auxz00_20547
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_21004);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1774;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_21008;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1775;
																																																																				BgL_auxz00_20547
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_21008);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1774;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_21012;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1775;
																																																																		BgL_auxz00_20547
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_21012);
																																																																	}
																																																															}
																																																													}
																																																												}
																																																											}
																																																										}
																																																								}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 118 */
																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																									{	/* Ast/sexp.scm 118 */
																																																										goto
																																																											BgL_tagzd2403zd2_1774;
																																																									}
																																																								else
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_21016;
																																																										goto
																																																											BgL_tagzd2404zd2_1775;
																																																										BgL_auxz00_20547
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_21016);
																																																									}
																																																							}
																																																					}
																																																				}
																																																		}
																																																	}
																																															}
																																													}
																																												}
																																											}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 118 */
																																										obj_t
																																											BgL_cdrzd227021zd2_2362;
																																										BgL_cdrzd227021zd2_2362
																																											=
																																											CDR
																																											(
																																											((obj_t) BgL_expz00_21));
																																										{

																																											{	/* Ast/sexp.scm 118 */
																																												bool_t
																																													BgL_test9164z00_21020;
																																												{	/* Ast/sexp.scm 118 */
																																													obj_t
																																														BgL_arg2072z00_2378;
																																													BgL_arg2072z00_2378
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													BgL_test9164z00_21020
																																														=
																																														CBOOL
																																														(BGl_letzd2symzf3z21zzast_letz00
																																														(BgL_arg2072z00_2378));
																																												}
																																												if (BgL_test9164z00_21020)
																																													{	/* Ast/sexp.scm 118 */
																																														if (PAIRP(BgL_cdrzd227021zd2_2362))
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_arg2074z00_2380;
																																																obj_t
																																																	BgL_arg2076z00_2381;
																																																BgL_arg2074z00_2380
																																																	=
																																																	CAR
																																																	(BgL_cdrzd227021zd2_2362);
																																																BgL_arg2076z00_2381
																																																	=
																																																	CDR
																																																	(BgL_cdrzd227021zd2_2362);
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_21029;
																																																	{
																																																		obj_t
																																																			BgL_exprz00_21031;
																																																		obj_t
																																																			BgL_bindingsz00_21030;
																																																		BgL_bindingsz00_21030
																																																			=
																																																			BgL_arg2074z00_2380;
																																																		BgL_exprz00_21031
																																																			=
																																																			BgL_arg2076z00_2381;
																																																		BgL_exprz00_1729
																																																			=
																																																			BgL_exprz00_21031;
																																																		BgL_bindingsz00_1728
																																																			=
																																																			BgL_bindingsz00_21030;
																																																		goto
																																																			BgL_tagzd2382zd2_1730;
																																																	}
																																																	BgL_auxz00_20547
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_21029);
																																																}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																bool_t
																																																	BgL_test9166z00_21033;
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_arg2088z00_2393;
																																																	BgL_arg2088z00_2393
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	BgL_test9166z00_21033
																																																		=
																																																		CBOOL
																																																		(BGl_labelszd2symzf3z21zzast_labelsz00
																																																		(BgL_arg2088z00_2393));
																																																}
																																																if (BgL_test9166z00_21033)
																																																	{
																																																		BgL_letzd2funzd2_bglt
																																																			BgL_auxz00_21038;
																																																		goto
																																																			BgL_tagzd2384zd2_1732;
																																																		BgL_auxz00_20547
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_21038);
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_carzd227084zd2_2384;
																																																		BgL_carzd227084zd2_2384
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_cdrzd227089zd2_2385;
																																																			BgL_cdrzd227089zd2_2385
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_carzd227084zd2_2384));
																																																			if ((CAR(((obj_t) BgL_carzd227084zd2_2384)) == CNST_TABLE_REF(((long) 3))))
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_arg2082z00_2388;
																																																					obj_t
																																																						BgL_arg2083z00_2389;
																																																					obj_t
																																																						BgL_arg2084z00_2390;
																																																					BgL_arg2082z00_2388
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd227089zd2_2385));
																																																					BgL_arg2083z00_2389
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd227089zd2_2385));
																																																					BgL_arg2084z00_2390
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_21055;
																																																						{
																																																							obj_t
																																																								BgL_argsz00_21058;
																																																							obj_t
																																																								BgL_bodyz00_21057;
																																																							obj_t
																																																								BgL_varsz00_21056;
																																																							BgL_varsz00_21056
																																																								=
																																																								BgL_arg2082z00_2388;
																																																							BgL_bodyz00_21057
																																																								=
																																																								BgL_arg2083z00_2389;
																																																							BgL_argsz00_21058
																																																								=
																																																								BgL_arg2084z00_2390;
																																																							BgL_argsz00_1739
																																																								=
																																																								BgL_argsz00_21058;
																																																							BgL_bodyz00_1738
																																																								=
																																																								BgL_bodyz00_21057;
																																																							BgL_varsz00_1737
																																																								=
																																																								BgL_varsz00_21056;
																																																							goto
																																																								BgL_tagzd2386zd2_1740;
																																																						}
																																																						BgL_auxz00_20547
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_21055);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																						{	/* Ast/sexp.scm 118 */
																																																							goto
																																																								BgL_tagzd2403zd2_1774;
																																																						}
																																																					else
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_21062;
																																																							goto
																																																								BgL_tagzd2404zd2_1775;
																																																							BgL_auxz00_20547
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_21062);
																																																						}
																																																				}
																																																		}
																																																	}
																																															}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														bool_t
																																															BgL_test9169z00_21064;
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_arg2071z00_2377;
																																															BgL_arg2071z00_2377
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															BgL_test9169z00_21064
																																																=
																																																CBOOL
																																																(BGl_labelszd2symzf3z21zzast_labelsz00
																																																(BgL_arg2071z00_2377));
																																														}
																																														if (BgL_test9169z00_21064)
																																															{
																																																BgL_letzd2funzd2_bglt
																																																	BgL_auxz00_21069;
																																																goto
																																																	BgL_tagzd2384zd2_1732;
																																																BgL_auxz00_20547
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_21069);
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_carzd227238zd2_2368;
																																																BgL_carzd227238zd2_2368
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_cdrzd227243zd2_2369;
																																																	BgL_cdrzd227243zd2_2369
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_carzd227238zd2_2368));
																																																	if ((CAR(((obj_t) BgL_carzd227238zd2_2368)) == CNST_TABLE_REF(((long) 3))))
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_arg2065z00_2372;
																																																			obj_t
																																																				BgL_arg2067z00_2373;
																																																			obj_t
																																																				BgL_arg2068z00_2374;
																																																			BgL_arg2065z00_2372
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd227243zd2_2369));
																																																			BgL_arg2067z00_2373
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd227243zd2_2369));
																																																			BgL_arg2068z00_2374
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_21086;
																																																				{
																																																					obj_t
																																																						BgL_argsz00_21089;
																																																					obj_t
																																																						BgL_bodyz00_21088;
																																																					obj_t
																																																						BgL_varsz00_21087;
																																																					BgL_varsz00_21087
																																																						=
																																																						BgL_arg2065z00_2372;
																																																					BgL_bodyz00_21088
																																																						=
																																																						BgL_arg2067z00_2373;
																																																					BgL_argsz00_21089
																																																						=
																																																						BgL_arg2068z00_2374;
																																																					BgL_argsz00_1739
																																																						=
																																																						BgL_argsz00_21089;
																																																					BgL_bodyz00_1738
																																																						=
																																																						BgL_bodyz00_21088;
																																																					BgL_varsz00_1737
																																																						=
																																																						BgL_varsz00_21087;
																																																					goto
																																																						BgL_tagzd2386zd2_1740;
																																																				}
																																																				BgL_auxz00_20547
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_21086);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																				{	/* Ast/sexp.scm 118 */
																																																					goto
																																																						BgL_tagzd2403zd2_1774;
																																																				}
																																																			else
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_21093;
																																																					goto
																																																						BgL_tagzd2404zd2_1775;
																																																					BgL_auxz00_20547
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_21093);
																																																				}
																																																		}
																																																}
																																															}
																																													}
																																											}
																																										}
																																									}
																																							}
																																						else
																																							{	/* Ast/sexp.scm 118 */
																																								obj_t
																																									BgL_cdrzd227353zd2_2394;
																																								BgL_cdrzd227353zd2_2394
																																									=
																																									CDR
																																									(
																																									((obj_t) BgL_expz00_21));
																																								{

																																									{	/* Ast/sexp.scm 118 */
																																										bool_t
																																											BgL_test9172z00_21097;
																																										{	/* Ast/sexp.scm 118 */
																																											obj_t
																																												BgL_arg2097z00_2402;
																																											BgL_arg2097z00_2402
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_expz00_21));
																																											BgL_test9172z00_21097
																																												=
																																												CBOOL
																																												(BGl_letzd2symzf3z21zzast_letz00
																																												(BgL_arg2097z00_2402));
																																										}
																																										if (BgL_test9172z00_21097)
																																											{	/* Ast/sexp.scm 118 */
																																												if (PAIRP(BgL_cdrzd227353zd2_2394))
																																													{	/* Ast/sexp.scm 118 */
																																														obj_t
																																															BgL_arg2099z00_2404;
																																														obj_t
																																															BgL_arg2100z00_2405;
																																														BgL_arg2099z00_2404
																																															=
																																															CAR
																																															(BgL_cdrzd227353zd2_2394);
																																														BgL_arg2100z00_2405
																																															=
																																															CDR
																																															(BgL_cdrzd227353zd2_2394);
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_21106;
																																															{
																																																obj_t
																																																	BgL_exprz00_21108;
																																																obj_t
																																																	BgL_bindingsz00_21107;
																																																BgL_bindingsz00_21107
																																																	=
																																																	BgL_arg2099z00_2404;
																																																BgL_exprz00_21108
																																																	=
																																																	BgL_arg2100z00_2405;
																																																BgL_exprz00_1729
																																																	=
																																																	BgL_exprz00_21108;
																																																BgL_bindingsz00_1728
																																																	=
																																																	BgL_bindingsz00_21107;
																																																goto
																																																	BgL_tagzd2382zd2_1730;
																																															}
																																															BgL_auxz00_20547
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_21106);
																																														}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														bool_t
																																															BgL_test9174z00_21110;
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_arg2105z00_2409;
																																															BgL_arg2105z00_2409
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															BgL_test9174z00_21110
																																																=
																																																CBOOL
																																																(BGl_labelszd2symzf3z21zzast_labelsz00
																																																(BgL_arg2105z00_2409));
																																														}
																																														if (BgL_test9174z00_21110)
																																															{
																																																BgL_letzd2funzd2_bglt
																																																	BgL_auxz00_21115;
																																																goto
																																																	BgL_tagzd2384zd2_1732;
																																																BgL_auxz00_20547
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_21115);
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																	{	/* Ast/sexp.scm 118 */
																																																		goto
																																																			BgL_tagzd2403zd2_1774;
																																																	}
																																																else
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_21119;
																																																		goto
																																																			BgL_tagzd2404zd2_1775;
																																																		BgL_auxz00_20547
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_21119);
																																																	}
																																															}
																																													}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 118 */
																																												bool_t
																																													BgL_test9176z00_21121;
																																												{	/* Ast/sexp.scm 118 */
																																													obj_t
																																														BgL_arg2096z00_2401;
																																													BgL_arg2096z00_2401
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													BgL_test9176z00_21121
																																														=
																																														CBOOL
																																														(BGl_labelszd2symzf3z21zzast_labelsz00
																																														(BgL_arg2096z00_2401));
																																												}
																																												if (BgL_test9176z00_21121)
																																													{
																																														BgL_letzd2funzd2_bglt
																																															BgL_auxz00_21126;
																																														goto
																																															BgL_tagzd2384zd2_1732;
																																														BgL_auxz00_20547
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_21126);
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																															{	/* Ast/sexp.scm 118 */
																																																goto
																																																	BgL_tagzd2403zd2_1774;
																																															}
																																														else
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_21130;
																																																goto
																																																	BgL_tagzd2404zd2_1775;
																																																BgL_auxz00_20547
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_21130);
																																															}
																																													}
																																											}
																																									}
																																								}
																																							}
																																						return
																																							(
																																							(BgL_nodez00_bglt)
																																							BgL_auxz00_20547);
																																					}
																																				else
																																					{	/* Ast/sexp.scm 118 */
																																						if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd224577zd2_1831)))
																																							{
																																								obj_t
																																									BgL_auxz00_21136;
																																								goto
																																									BgL_kapzd224579zd2_1833;
																																								return
																																									(
																																									(BgL_nodez00_bglt)
																																									BgL_auxz00_21136);
																																							}
																																						else
																																							{	/* Ast/sexp.scm 118 */
																																								if ((BgL_carzd224577zd2_1831 == CNST_TABLE_REF(((long) 18))))
																																									{
																																										obj_t
																																											BgL_auxz00_21141;
																																										goto
																																											BgL_kapzd224579zd2_1833;
																																										return
																																											(
																																											(BgL_nodez00_bglt)
																																											BgL_auxz00_21141);
																																									}
																																								else
																																									{	/* Ast/sexp.scm 118 */
																																										if ((BgL_carzd224577zd2_1831 == CNST_TABLE_REF(((long) 19))))
																																											{
																																												obj_t
																																													BgL_auxz00_21146;
																																												goto
																																													BgL_kapzd224579zd2_1833;
																																												return
																																													(
																																													(BgL_nodez00_bglt)
																																													BgL_auxz00_21146);
																																											}
																																										else
																																											{	/* Ast/sexp.scm 118 */
																																												if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd224577zd2_1831)))
																																													{
																																														obj_t
																																															BgL_auxz00_21151;
																																														goto
																																															BgL_kapzd224579zd2_1833;
																																														return
																																															(
																																															(BgL_nodez00_bglt)
																																															BgL_auxz00_21151);
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														obj_t
																																															BgL_cdrzd227662zd2_1839;
																																														BgL_cdrzd227662zd2_1839
																																															=
																																															CDR
																																															(BgL_expz00_21);
																																														{

																																															{	/* Ast/sexp.scm 118 */
																																																bool_t
																																																	BgL_test9182z00_21154;
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_arg1830z00_2018;
																																																	BgL_arg1830z00_2018
																																																		=
																																																		CAR
																																																		(BgL_expz00_21);
																																																	BgL_test9182z00_21154
																																																		=
																																																		CBOOL
																																																		(BGl_letzd2symzf3z21zzast_letz00
																																																		(BgL_arg1830z00_2018));
																																																}
																																																if (BgL_test9182z00_21154)
																																																	{
																																																		obj_t
																																																			BgL_auxz00_21158;
																																																		if (PAIRP(BgL_cdrzd227662zd2_1839))
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_arg1832z00_2020;
																																																				obj_t
																																																					BgL_arg1833z00_2021;
																																																				BgL_arg1832z00_2020
																																																					=
																																																					CAR
																																																					(BgL_cdrzd227662zd2_1839);
																																																				BgL_arg1833z00_2021
																																																					=
																																																					CDR
																																																					(BgL_cdrzd227662zd2_1839);
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_21163;
																																																					{
																																																						obj_t
																																																							BgL_exprz00_21165;
																																																						obj_t
																																																							BgL_bindingsz00_21164;
																																																						BgL_bindingsz00_21164
																																																							=
																																																							BgL_arg1832z00_2020;
																																																						BgL_exprz00_21165
																																																							=
																																																							BgL_arg1833z00_2021;
																																																						BgL_exprz00_1729
																																																							=
																																																							BgL_exprz00_21165;
																																																						BgL_bindingsz00_1728
																																																							=
																																																							BgL_bindingsz00_21164;
																																																						goto
																																																							BgL_tagzd2382zd2_1730;
																																																					}
																																																					BgL_auxz00_21158
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_21163);
																																																				}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 118 */
																																																				bool_t
																																																					BgL_test9184z00_21167;
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_arg1908z00_2133;
																																																					BgL_arg1908z00_2133
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					BgL_test9184z00_21167
																																																						=
																																																						CBOOL
																																																						(BGl_labelszd2symzf3z21zzast_labelsz00
																																																						(BgL_arg1908z00_2133));
																																																				}
																																																				if (BgL_test9184z00_21167)
																																																					{
																																																						BgL_letzd2funzd2_bglt
																																																							BgL_auxz00_21172;
																																																						goto
																																																							BgL_tagzd2384zd2_1732;
																																																						BgL_auxz00_21158
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_21172);
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_carzd227725zd2_2024;
																																																						BgL_carzd227725zd2_2024
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_cdrzd227730zd2_2025;
																																																							BgL_cdrzd227730zd2_2025
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_carzd227725zd2_2024));
																																																							if ((CAR(((obj_t) BgL_carzd227725zd2_2024)) == CNST_TABLE_REF(((long) 3))))
																																																								{	/* Ast/sexp.scm 118 */
																																																									if (PAIRP(BgL_cdrzd227730zd2_2025))
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_arg1839z00_2029;
																																																											obj_t
																																																												BgL_arg1840z00_2030;
																																																											obj_t
																																																												BgL_arg1842z00_2031;
																																																											BgL_arg1839z00_2029
																																																												=
																																																												CAR
																																																												(BgL_cdrzd227730zd2_2025);
																																																											BgL_arg1840z00_2030
																																																												=
																																																												CDR
																																																												(BgL_cdrzd227730zd2_2025);
																																																											BgL_arg1842z00_2031
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_21189;
																																																												{
																																																													obj_t
																																																														BgL_argsz00_21192;
																																																													obj_t
																																																														BgL_bodyz00_21191;
																																																													obj_t
																																																														BgL_varsz00_21190;
																																																													BgL_varsz00_21190
																																																														=
																																																														BgL_arg1839z00_2029;
																																																													BgL_bodyz00_21191
																																																														=
																																																														BgL_arg1840z00_2030;
																																																													BgL_argsz00_21192
																																																														=
																																																														BgL_arg1842z00_2031;
																																																													BgL_argsz00_1739
																																																														=
																																																														BgL_argsz00_21192;
																																																													BgL_bodyz00_1738
																																																														=
																																																														BgL_bodyz00_21191;
																																																													BgL_varsz00_1737
																																																														=
																																																														BgL_varsz00_21190;
																																																													goto
																																																														BgL_tagzd2386zd2_1740;
																																																												}
																																																												BgL_auxz00_21158
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_21189);
																																																											}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{	/* Ast/sexp.scm 118 */
																																																													goto
																																																														BgL_tagzd2403zd2_1774;
																																																												}
																																																											else
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_21196;
																																																													goto
																																																														BgL_tagzd2404zd2_1775;
																																																													BgL_auxz00_21158
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_21196);
																																																												}
																																																										}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_cdrzd227837zd2_2034;
																																																									BgL_cdrzd227837zd2_2034
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_cdrzd227842zd2_2035;
																																																										BgL_cdrzd227842zd2_2035
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_carzd227725zd2_2024));
																																																										if ((CAR(((obj_t) BgL_carzd227725zd2_2024)) == CNST_TABLE_REF(((long) 1))))
																																																											{	/* Ast/sexp.scm 118 */
																																																												if (PAIRP(BgL_cdrzd227842zd2_2035))
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_cdrzd227847zd2_2039;
																																																														BgL_cdrzd227847zd2_2039
																																																															=
																																																															CDR
																																																															(BgL_cdrzd227842zd2_2035);
																																																														if (PAIRP(BgL_cdrzd227847zd2_2039))
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_carzd227851zd2_2041;
																																																																obj_t
																																																																	BgL_cdrzd227852zd2_2042;
																																																																BgL_carzd227851zd2_2041
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd227847zd2_2039);
																																																																BgL_cdrzd227852zd2_2042
																																																																	=
																																																																	CDR
																																																																	(BgL_cdrzd227847zd2_2039);
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd227851zd2_2041))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (PAIRP(BgL_cdrzd227852zd2_2042))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_carzd227857zd2_2045;
																																																																				BgL_carzd227857zd2_2045
																																																																					=
																																																																					CAR
																																																																					(BgL_cdrzd227852zd2_2042);
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd227857zd2_2045))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (NULLP(CDR(BgL_cdrzd227852zd2_2042)))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								bool_t
																																																																									BgL_test9195z00_21224;
																																																																								{
																																																																									obj_t
																																																																										BgL_l1412z00_2078;
																																																																									BgL_l1412z00_2078
																																																																										=
																																																																										BgL_cdrzd227837zd2_2034;
																																																																								BgL_zc3z04anonymousza31871ze3z87_2079:
																																																																									if (NULLP(BgL_l1412z00_2078))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											BgL_test9195z00_21224
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												1);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											bool_t
																																																																												BgL_test9197z00_21227;
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												bool_t
																																																																													BgL_test9198z00_21228;
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_tmpz00_21229;
																																																																													BgL_tmpz00_21229
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_l1412z00_2078));
																																																																													BgL_test9198z00_21228
																																																																														=
																																																																														PAIRP
																																																																														(BgL_tmpz00_21229);
																																																																												}
																																																																												if (BgL_test9198z00_21228)
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														BgL_test9197z00_21227
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															0);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														BgL_test9197z00_21227
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															1);
																																																																													}
																																																																											}
																																																																											if (BgL_test9197z00_21227)
																																																																												{
																																																																													obj_t
																																																																														BgL_l1412z00_21233;
																																																																													BgL_l1412z00_21233
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_l1412z00_2078));
																																																																													BgL_l1412z00_2078
																																																																														=
																																																																														BgL_l1412z00_21233;
																																																																													goto
																																																																														BgL_zc3z04anonymousza31871ze3z87_2079;
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													BgL_test9195z00_21224
																																																																														=
																																																																														(
																																																																														(bool_t)
																																																																														0);
																																																																												}
																																																																										}
																																																																								}
																																																																								if (BgL_test9195z00_21224)
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_arg1860z00_2061;
																																																																										BgL_arg1860z00_2061
																																																																											=
																																																																											CAR
																																																																											(BgL_cdrzd227842zd2_2035);
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_21237;
																																																																											{
																																																																												obj_t
																																																																													BgL_argsz00_21241;
																																																																												obj_t
																																																																													BgL_proc2z00_21240;
																																																																												obj_t
																																																																													BgL_proc1z00_21239;
																																																																												obj_t
																																																																													BgL_testz00_21238;
																																																																												BgL_testz00_21238
																																																																													=
																																																																													BgL_arg1860z00_2061;
																																																																												BgL_proc1z00_21239
																																																																													=
																																																																													BgL_carzd227851zd2_2041;
																																																																												BgL_proc2z00_21240
																																																																													=
																																																																													BgL_carzd227857zd2_2045;
																																																																												BgL_argsz00_21241
																																																																													=
																																																																													BgL_cdrzd227837zd2_2034;
																																																																												BgL_argsz00_1744
																																																																													=
																																																																													BgL_argsz00_21241;
																																																																												BgL_proc2z00_1743
																																																																													=
																																																																													BgL_proc2z00_21240;
																																																																												BgL_proc1z00_1742
																																																																													=
																																																																													BgL_proc1z00_21239;
																																																																												BgL_testz00_1741
																																																																													=
																																																																													BgL_testz00_21238;
																																																																												goto
																																																																													BgL_tagzd2387zd2_1745;
																																																																											}
																																																																											BgL_auxz00_21158
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_21237);
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_cdrzd227882zd2_2062;
																																																																										BgL_cdrzd227882zd2_2062
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_cdrzd227890zd2_2063;
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_pairz00_11568;
																																																																												BgL_pairz00_11568
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_expz00_21));
																																																																												BgL_cdrzd227890zd2_2063
																																																																													=
																																																																													CDR
																																																																													(BgL_pairz00_11568);
																																																																											}
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_cdrzd227898zd2_2064;
																																																																												BgL_cdrzd227898zd2_2064
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd227890zd2_2063));
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_carzd227905zd2_2065;
																																																																													BgL_carzd227905zd2_2065
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd227898zd2_2064));
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd227905zd2_2065))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_carzd227914zd2_2067;
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_pairz00_11572;
																																																																																BgL_pairz00_11572
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd227898zd2_2064));
																																																																																BgL_carzd227914zd2_2067
																																																																																	=
																																																																																	CAR
																																																																																	(BgL_pairz00_11572);
																																																																															}
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd227914zd2_2067))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd227882zd2_2062))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			obj_t
																																																																																				BgL_arg1864z00_2070;
																																																																																			BgL_arg1864z00_2070
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd227890zd2_2063));
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_21263;
																																																																																				{
																																																																																					obj_t
																																																																																						BgL_argsz00_21267;
																																																																																					obj_t
																																																																																						BgL_proc2z00_21266;
																																																																																					obj_t
																																																																																						BgL_proc1z00_21265;
																																																																																					obj_t
																																																																																						BgL_testz00_21264;
																																																																																					BgL_testz00_21264
																																																																																						=
																																																																																						BgL_arg1864z00_2070;
																																																																																					BgL_proc1z00_21265
																																																																																						=
																																																																																						BgL_carzd227905zd2_2065;
																																																																																					BgL_proc2z00_21266
																																																																																						=
																																																																																						BgL_carzd227914zd2_2067;
																																																																																					BgL_argsz00_21267
																																																																																						=
																																																																																						BgL_cdrzd227882zd2_2062;
																																																																																					BgL_argsz00_1749
																																																																																						=
																																																																																						BgL_argsz00_21267;
																																																																																					BgL_proc2z00_1748
																																																																																						=
																																																																																						BgL_proc2z00_21266;
																																																																																					BgL_proc1z00_1747
																																																																																						=
																																																																																						BgL_proc1z00_21265;
																																																																																					BgL_testz00_1746
																																																																																						=
																																																																																						BgL_testz00_21264;
																																																																																					goto
																																																																																						BgL_tagzd2388zd2_1750;
																																																																																				}
																																																																																				BgL_auxz00_21158
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_21263);
																																																																																			}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1774;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_21271;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1775;
																																																																																					BgL_auxz00_21158
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_21271);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1774;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_21275;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1775;
																																																																																			BgL_auxz00_21158
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_21275);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1774;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_21279;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1775;
																																																																																	BgL_auxz00_21158
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_21279);
																																																																																}
																																																																														}
																																																																												}
																																																																											}
																																																																										}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1774;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_21283;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1775;
																																																																										BgL_auxz00_21158
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_21283);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_cdrzd228192zd2_2089;
																																																																						BgL_cdrzd228192zd2_2089
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_cdrzd228199zd2_2090;
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_pairz00_11576;
																																																																								BgL_pairz00_11576
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								BgL_cdrzd228199zd2_2090
																																																																									=
																																																																									CDR
																																																																									(BgL_pairz00_11576);
																																																																							}
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_cdrzd228206zd2_2091;
																																																																								BgL_cdrzd228206zd2_2091
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd228199zd2_2090));
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_carzd228212zd2_2092;
																																																																									obj_t
																																																																										BgL_cdrzd228213zd2_2093;
																																																																									BgL_carzd228212zd2_2092
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd228206zd2_2091));
																																																																									BgL_cdrzd228213zd2_2093
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd228206zd2_2091));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd228212zd2_2092))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_carzd228220zd2_2095;
																																																																											BgL_carzd228220zd2_2095
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd228213zd2_2093));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd228220zd2_2095))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (NULLP(CDR(((obj_t) BgL_cdrzd228213zd2_2093))))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd228192zd2_2089))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_arg1880z00_2100;
																																																																																	BgL_arg1880z00_2100
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd228199zd2_2090));
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_21310;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_21314;
																																																																																			obj_t
																																																																																				BgL_proc2z00_21313;
																																																																																			obj_t
																																																																																				BgL_proc1z00_21312;
																																																																																			obj_t
																																																																																				BgL_testz00_21311;
																																																																																			BgL_testz00_21311
																																																																																				=
																																																																																				BgL_arg1880z00_2100;
																																																																																			BgL_proc1z00_21312
																																																																																				=
																																																																																				BgL_carzd228212zd2_2092;
																																																																																			BgL_proc2z00_21313
																																																																																				=
																																																																																				BgL_carzd228220zd2_2095;
																																																																																			BgL_argsz00_21314
																																																																																				=
																																																																																				BgL_cdrzd228192zd2_2089;
																																																																																			BgL_argsz00_1749
																																																																																				=
																																																																																				BgL_argsz00_21314;
																																																																																			BgL_proc2z00_1748
																																																																																				=
																																																																																				BgL_proc2z00_21313;
																																																																																			BgL_proc1z00_1747
																																																																																				=
																																																																																				BgL_proc1z00_21312;
																																																																																			BgL_testz00_1746
																																																																																				=
																																																																																				BgL_testz00_21311;
																																																																																			goto
																																																																																				BgL_tagzd2388zd2_1750;
																																																																																		}
																																																																																		BgL_auxz00_21158
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_21310);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1774;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_21318;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1775;
																																																																																			BgL_auxz00_21158
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_21318);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1774;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_21322;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1775;
																																																																																	BgL_auxz00_21158
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_21322);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1774;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_21326;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1775;
																																																																															BgL_auxz00_21158
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_21326);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1774;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_21330;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1775;
																																																																													BgL_auxz00_21158
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_21330);
																																																																												}
																																																																										}
																																																																								}
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1774;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_21334;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1775;
																																																																						BgL_auxz00_21158
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_21334);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_cdrzd228553zd2_2108;
																																																																		BgL_cdrzd228553zd2_2108
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_cdrzd228559zd2_2109;
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_pairz00_11586;
																																																																				BgL_pairz00_11586
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				BgL_cdrzd228559zd2_2109
																																																																					=
																																																																					CDR
																																																																					(BgL_pairz00_11586);
																																																																			}
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_cdrzd228565zd2_2110;
																																																																				BgL_cdrzd228565zd2_2110
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd228559zd2_2109));
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_carzd228570zd2_2111;
																																																																					obj_t
																																																																						BgL_cdrzd228571zd2_2112;
																																																																					BgL_carzd228570zd2_2111
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd228565zd2_2110));
																																																																					BgL_cdrzd228571zd2_2112
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd228565zd2_2110));
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd228570zd2_2111))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (PAIRP(BgL_cdrzd228571zd2_2112))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_carzd228576zd2_2115;
																																																																									BgL_carzd228576zd2_2115
																																																																										=
																																																																										CAR
																																																																										(BgL_cdrzd228571zd2_2112);
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd228576zd2_2115))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (NULLP(CDR(BgL_cdrzd228571zd2_2112)))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd228553zd2_2108))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_arg1895z00_2120;
																																																																															BgL_arg1895z00_2120
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd228559zd2_2109));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_21361;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_21365;
																																																																																	obj_t
																																																																																		BgL_proc2z00_21364;
																																																																																	obj_t
																																																																																		BgL_proc1z00_21363;
																																																																																	obj_t
																																																																																		BgL_testz00_21362;
																																																																																	BgL_testz00_21362
																																																																																		=
																																																																																		BgL_arg1895z00_2120;
																																																																																	BgL_proc1z00_21363
																																																																																		=
																																																																																		BgL_carzd228570zd2_2111;
																																																																																	BgL_proc2z00_21364
																																																																																		=
																																																																																		BgL_carzd228576zd2_2115;
																																																																																	BgL_argsz00_21365
																																																																																		=
																																																																																		BgL_cdrzd228553zd2_2108;
																																																																																	BgL_argsz00_1749
																																																																																		=
																																																																																		BgL_argsz00_21365;
																																																																																	BgL_proc2z00_1748
																																																																																		=
																																																																																		BgL_proc2z00_21364;
																																																																																	BgL_proc1z00_1747
																																																																																		=
																																																																																		BgL_proc1z00_21363;
																																																																																	BgL_testz00_1746
																																																																																		=
																																																																																		BgL_testz00_21362;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1750;
																																																																																}
																																																																																BgL_auxz00_21158
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_21361);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1774;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_21369;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1775;
																																																																																	BgL_auxz00_21158
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_21369);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1774;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_21373;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1775;
																																																																															BgL_auxz00_21158
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_21373);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1774;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_21377;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1775;
																																																																													BgL_auxz00_21158
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_21377);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1774;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_21381;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1775;
																																																																											BgL_auxz00_21158
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_21381);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1774;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_21385;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1775;
																																																																									BgL_auxz00_21158
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_21385);
																																																																								}
																																																																						}
																																																																				}
																																																																			}
																																																																		}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1774;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_21389;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1775;
																																																																		BgL_auxz00_21158
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_21389);
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 118 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 118 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1774;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_21393;
																																																																goto
																																																																	BgL_tagzd2404zd2_1775;
																																																																BgL_auxz00_21158
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_21393);
																																																															}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 118 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{	/* Ast/sexp.scm 118 */
																																																														goto
																																																															BgL_tagzd2403zd2_1774;
																																																													}
																																																												else
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_21397;
																																																														goto
																																																															BgL_tagzd2404zd2_1775;
																																																														BgL_auxz00_21158
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_21397);
																																																													}
																																																											}
																																																									}
																																																								}
																																																						}
																																																					}
																																																			}
																																																		return
																																																			(
																																																			(BgL_nodez00_bglt)
																																																			BgL_auxz00_21158);
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		bool_t
																																																			BgL_test9228z00_21400;
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_arg1829z00_2017;
																																																			BgL_arg1829z00_2017
																																																				=
																																																				CAR
																																																				(BgL_expz00_21);
																																																			BgL_test9228z00_21400
																																																				=
																																																				CBOOL
																																																				(BGl_labelszd2symzf3z21zzast_labelsz00
																																																				(BgL_arg1829z00_2017));
																																																		}
																																																		if (BgL_test9228z00_21400)
																																																			{
																																																				BgL_letzd2funzd2_bglt
																																																					BgL_auxz00_21404;
																																																				goto
																																																					BgL_tagzd2384zd2_1732;
																																																				return
																																																					(
																																																					(BgL_nodez00_bglt)
																																																					BgL_auxz00_21404);
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_carzd229139zd2_1845;
																																																				obj_t
																																																					BgL_cdrzd229140zd2_1846;
																																																				BgL_carzd229139zd2_1845
																																																					=
																																																					CAR
																																																					(BgL_expz00_21);
																																																				BgL_cdrzd229140zd2_1846
																																																					=
																																																					CDR
																																																					(BgL_expz00_21);
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_cdrzd229144zd2_1847;
																																																					BgL_cdrzd229144zd2_1847
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_carzd229139zd2_1845));
																																																					if ((CAR(((obj_t) BgL_carzd229139zd2_1845)) == CNST_TABLE_REF(((long) 3))))
																																																						{	/* Ast/sexp.scm 118 */
																																																							if (PAIRP(BgL_cdrzd229144zd2_1847))
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_carzd229147zd2_1851;
																																																									obj_t
																																																										BgL_cdrzd229148zd2_1852;
																																																									BgL_carzd229147zd2_1851
																																																										=
																																																										CAR
																																																										(BgL_cdrzd229144zd2_1847);
																																																									BgL_cdrzd229148zd2_1852
																																																										=
																																																										CDR
																																																										(BgL_cdrzd229144zd2_1847);
																																																									if (PAIRP(BgL_carzd229147zd2_1851))
																																																										{	/* Ast/sexp.scm 118 */
																																																											if (NULLP(CDR(BgL_carzd229147zd2_1851)))
																																																												{	/* Ast/sexp.scm 118 */
																																																													if (PAIRP(BgL_cdrzd229148zd2_1852))
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_carzd229154zd2_1857;
																																																															BgL_carzd229154zd2_1857
																																																																=
																																																																CAR
																																																																(BgL_cdrzd229148zd2_1852);
																																																															if (PAIRP(BgL_carzd229154zd2_1857))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if (BGl_castzd2sexpzf3z21zzast_privatez00(BgL_carzd229154zd2_1857))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if (NULLP(CDR(BgL_cdrzd229148zd2_1852)))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (PAIRP(BgL_cdrzd229140zd2_1846))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_carzd229161zd2_1863;
																																																																							BgL_carzd229161zd2_1863
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd229140zd2_1846);
																																																																							if (PAIRP(BgL_carzd229161zd2_1863))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_cdrzd229185zd2_1865;
																																																																									BgL_cdrzd229185zd2_1865
																																																																										=
																																																																										CDR
																																																																										(CAR
																																																																										(BgL_expz00_21));
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_arg1665z00_1866;
																																																																										obj_t
																																																																											BgL_arg1668z00_1867;
																																																																										obj_t
																																																																											BgL_arg1669z00_1868;
																																																																										BgL_arg1665z00_1866
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd229185zd2_1865));
																																																																										BgL_arg1668z00_1867
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd229185zd2_1865));
																																																																										BgL_arg1669z00_1868
																																																																											=
																																																																											CDR
																																																																											(BgL_expz00_21);
																																																																										{
																																																																											obj_t
																																																																												BgL_argsz00_21448;
																																																																											obj_t
																																																																												BgL_bodyz00_21447;
																																																																											obj_t
																																																																												BgL_varsz00_21446;
																																																																											BgL_varsz00_21446
																																																																												=
																																																																												BgL_arg1665z00_1866;
																																																																											BgL_bodyz00_21447
																																																																												=
																																																																												BgL_arg1668z00_1867;
																																																																											BgL_argsz00_21448
																																																																												=
																																																																												BgL_arg1669z00_1868;
																																																																											BgL_argsz00_1739
																																																																												=
																																																																												BgL_argsz00_21448;
																																																																											BgL_bodyz00_1738
																																																																												=
																																																																												BgL_bodyz00_21447;
																																																																											BgL_varsz00_1737
																																																																												=
																																																																												BgL_varsz00_21446;
																																																																											goto
																																																																												BgL_tagzd2386zd2_1740;
																																																																										}
																																																																									}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (NULLP(CDR(BgL_cdrzd229140zd2_1846)))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_arg1675z00_1872;
																																																																											BgL_arg1675z00_1872
																																																																												=
																																																																												CAR
																																																																												(BgL_carzd229147zd2_1851);
																																																																											{
																																																																												BgL_castz00_bglt
																																																																													BgL_auxz00_21453;
																																																																												{
																																																																													obj_t
																																																																														BgL_argz00_21456;
																																																																													obj_t
																																																																														BgL_bodyz00_21455;
																																																																													obj_t
																																																																														BgL_varz00_21454;
																																																																													BgL_varz00_21454
																																																																														=
																																																																														BgL_arg1675z00_1872;
																																																																													BgL_bodyz00_21455
																																																																														=
																																																																														BgL_carzd229154zd2_1857;
																																																																													BgL_argz00_21456
																																																																														=
																																																																														BgL_carzd229161zd2_1863;
																																																																													BgL_argz00_1735
																																																																														=
																																																																														BgL_argz00_21456;
																																																																													BgL_bodyz00_1734
																																																																														=
																																																																														BgL_bodyz00_21455;
																																																																													BgL_varz00_1733
																																																																														=
																																																																														BgL_varz00_21454;
																																																																													goto
																																																																														BgL_tagzd2385zd2_1736;
																																																																												}
																																																																												return
																																																																													(
																																																																													(BgL_nodez00_bglt)
																																																																													BgL_auxz00_21453);
																																																																											}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_cdrzd229212zd2_1873;
																																																																											BgL_cdrzd229212zd2_1873
																																																																												=
																																																																												CDR
																																																																												(CAR
																																																																												(BgL_expz00_21));
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_arg1676z00_1874;
																																																																												obj_t
																																																																													BgL_arg1677z00_1875;
																																																																												obj_t
																																																																													BgL_arg1679z00_1876;
																																																																												BgL_arg1676z00_1874
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd229212zd2_1873));
																																																																												BgL_arg1677z00_1875
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd229212zd2_1873));
																																																																												BgL_arg1679z00_1876
																																																																													=
																																																																													CDR
																																																																													(BgL_expz00_21);
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_21467;
																																																																													obj_t
																																																																														BgL_bodyz00_21466;
																																																																													obj_t
																																																																														BgL_varsz00_21465;
																																																																													BgL_varsz00_21465
																																																																														=
																																																																														BgL_arg1676z00_1874;
																																																																													BgL_bodyz00_21466
																																																																														=
																																																																														BgL_arg1677z00_1875;
																																																																													BgL_argsz00_21467
																																																																														=
																																																																														BgL_arg1679z00_1876;
																																																																													BgL_argsz00_1739
																																																																														=
																																																																														BgL_argsz00_21467;
																																																																													BgL_bodyz00_1738
																																																																														=
																																																																														BgL_bodyz00_21466;
																																																																													BgL_varsz00_1737
																																																																														=
																																																																														BgL_varsz00_21465;
																																																																													goto
																																																																														BgL_tagzd2386zd2_1740;
																																																																												}
																																																																											}
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_cdrzd229238zd2_1879;
																																																																							BgL_cdrzd229238zd2_1879
																																																																								=
																																																																								CDR
																																																																								(CAR
																																																																								(BgL_expz00_21));
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_arg1687z00_1880;
																																																																								obj_t
																																																																									BgL_arg1688z00_1881;
																																																																								obj_t
																																																																									BgL_arg1691z00_1882;
																																																																								BgL_arg1687z00_1880
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd229238zd2_1879));
																																																																								BgL_arg1688z00_1881
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd229238zd2_1879));
																																																																								BgL_arg1691z00_1882
																																																																									=
																																																																									CDR
																																																																									(BgL_expz00_21);
																																																																								{
																																																																									obj_t
																																																																										BgL_argsz00_21477;
																																																																									obj_t
																																																																										BgL_bodyz00_21476;
																																																																									obj_t
																																																																										BgL_varsz00_21475;
																																																																									BgL_varsz00_21475
																																																																										=
																																																																										BgL_arg1687z00_1880;
																																																																									BgL_bodyz00_21476
																																																																										=
																																																																										BgL_arg1688z00_1881;
																																																																									BgL_argsz00_21477
																																																																										=
																																																																										BgL_arg1691z00_1882;
																																																																									BgL_argsz00_1739
																																																																										=
																																																																										BgL_argsz00_21477;
																																																																									BgL_bodyz00_1738
																																																																										=
																																																																										BgL_bodyz00_21476;
																																																																									BgL_varsz00_1737
																																																																										=
																																																																										BgL_varsz00_21475;
																																																																									goto
																																																																										BgL_tagzd2386zd2_1740;
																																																																								}
																																																																							}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_cdrzd229264zd2_1884;
																																																																					BgL_cdrzd229264zd2_1884
																																																																						=
																																																																						CDR
																																																																						(CAR
																																																																						(BgL_expz00_21));
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_arg1693z00_1885;
																																																																						obj_t
																																																																							BgL_arg1694z00_1886;
																																																																						obj_t
																																																																							BgL_arg1695z00_1887;
																																																																						BgL_arg1693z00_1885
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd229264zd2_1884));
																																																																						BgL_arg1694z00_1886
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd229264zd2_1884));
																																																																						BgL_arg1695z00_1887
																																																																							=
																																																																							CDR
																																																																							(BgL_expz00_21);
																																																																						{
																																																																							obj_t
																																																																								BgL_argsz00_21487;
																																																																							obj_t
																																																																								BgL_bodyz00_21486;
																																																																							obj_t
																																																																								BgL_varsz00_21485;
																																																																							BgL_varsz00_21485
																																																																								=
																																																																								BgL_arg1693z00_1885;
																																																																							BgL_bodyz00_21486
																																																																								=
																																																																								BgL_arg1694z00_1886;
																																																																							BgL_argsz00_21487
																																																																								=
																																																																								BgL_arg1695z00_1887;
																																																																							BgL_argsz00_1739
																																																																								=
																																																																								BgL_argsz00_21487;
																																																																							BgL_bodyz00_1738
																																																																								=
																																																																								BgL_bodyz00_21486;
																																																																							BgL_varsz00_1737
																																																																								=
																																																																								BgL_varsz00_21485;
																																																																							goto
																																																																								BgL_tagzd2386zd2_1740;
																																																																						}
																																																																					}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_cdrzd229290zd2_1890;
																																																																			BgL_cdrzd229290zd2_1890
																																																																				=
																																																																				CDR
																																																																				(CAR
																																																																				(BgL_expz00_21));
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_arg1703z00_1891;
																																																																				obj_t
																																																																					BgL_arg1710z00_1892;
																																																																				obj_t
																																																																					BgL_arg1713z00_1893;
																																																																				BgL_arg1703z00_1891
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd229290zd2_1890));
																																																																				BgL_arg1710z00_1892
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd229290zd2_1890));
																																																																				BgL_arg1713z00_1893
																																																																					=
																																																																					CDR
																																																																					(BgL_expz00_21);
																																																																				{
																																																																					obj_t
																																																																						BgL_argsz00_21497;
																																																																					obj_t
																																																																						BgL_bodyz00_21496;
																																																																					obj_t
																																																																						BgL_varsz00_21495;
																																																																					BgL_varsz00_21495
																																																																						=
																																																																						BgL_arg1703z00_1891;
																																																																					BgL_bodyz00_21496
																																																																						=
																																																																						BgL_arg1710z00_1892;
																																																																					BgL_argsz00_21497
																																																																						=
																																																																						BgL_arg1713z00_1893;
																																																																					BgL_argsz00_1739
																																																																						=
																																																																						BgL_argsz00_21497;
																																																																					BgL_bodyz00_1738
																																																																						=
																																																																						BgL_bodyz00_21496;
																																																																					BgL_varsz00_1737
																																																																						=
																																																																						BgL_varsz00_21495;
																																																																					goto
																																																																						BgL_tagzd2386zd2_1740;
																																																																				}
																																																																			}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd229316zd2_1895;
																																																																	BgL_cdrzd229316zd2_1895
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_carzd229139zd2_1845));
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_arg1717z00_1896;
																																																																		obj_t
																																																																			BgL_arg1723z00_1897;
																																																																		obj_t
																																																																			BgL_arg1731z00_1898;
																																																																		BgL_arg1717z00_1896
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd229316zd2_1895));
																																																																		BgL_arg1723z00_1897
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd229316zd2_1895));
																																																																		BgL_arg1731z00_1898
																																																																			=
																																																																			CDR
																																																																			(BgL_expz00_21);
																																																																		{
																																																																			obj_t
																																																																				BgL_argsz00_21507;
																																																																			obj_t
																																																																				BgL_bodyz00_21506;
																																																																			obj_t
																																																																				BgL_varsz00_21505;
																																																																			BgL_varsz00_21505
																																																																				=
																																																																				BgL_arg1717z00_1896;
																																																																			BgL_bodyz00_21506
																																																																				=
																																																																				BgL_arg1723z00_1897;
																																																																			BgL_argsz00_21507
																																																																				=
																																																																				BgL_arg1731z00_1898;
																																																																			BgL_argsz00_1739
																																																																				=
																																																																				BgL_argsz00_21507;
																																																																			BgL_bodyz00_1738
																																																																				=
																																																																				BgL_bodyz00_21506;
																																																																			BgL_varsz00_1737
																																																																				=
																																																																				BgL_varsz00_21505;
																																																																			goto
																																																																				BgL_tagzd2386zd2_1740;
																																																																		}
																																																																	}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_cdrzd229342zd2_1900;
																																																															BgL_cdrzd229342zd2_1900
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_carzd229139zd2_1845));
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_arg1737z00_1901;
																																																																obj_t
																																																																	BgL_arg1748z00_1902;
																																																																obj_t
																																																																	BgL_arg1749z00_1903;
																																																																BgL_arg1737z00_1901
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd229342zd2_1900));
																																																																BgL_arg1748z00_1902
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd229342zd2_1900));
																																																																BgL_arg1749z00_1903
																																																																	=
																																																																	CDR
																																																																	(BgL_expz00_21);
																																																																{
																																																																	obj_t
																																																																		BgL_argsz00_21517;
																																																																	obj_t
																																																																		BgL_bodyz00_21516;
																																																																	obj_t
																																																																		BgL_varsz00_21515;
																																																																	BgL_varsz00_21515
																																																																		=
																																																																		BgL_arg1737z00_1901;
																																																																	BgL_bodyz00_21516
																																																																		=
																																																																		BgL_arg1748z00_1902;
																																																																	BgL_argsz00_21517
																																																																		=
																																																																		BgL_arg1749z00_1903;
																																																																	BgL_argsz00_1739
																																																																		=
																																																																		BgL_argsz00_21517;
																																																																	BgL_bodyz00_1738
																																																																		=
																																																																		BgL_bodyz00_21516;
																																																																	BgL_varsz00_1737
																																																																		=
																																																																		BgL_varsz00_21515;
																																																																	goto
																																																																		BgL_tagzd2386zd2_1740;
																																																																}
																																																															}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_cdrzd229368zd2_1905;
																																																													BgL_cdrzd229368zd2_1905
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_carzd229139zd2_1845));
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_arg1751z00_1906;
																																																														obj_t
																																																															BgL_arg1752z00_1907;
																																																														obj_t
																																																															BgL_arg1753z00_1908;
																																																														BgL_arg1751z00_1906
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd229368zd2_1905));
																																																														BgL_arg1752z00_1907
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd229368zd2_1905));
																																																														BgL_arg1753z00_1908
																																																															=
																																																															CDR
																																																															(BgL_expz00_21);
																																																														{
																																																															obj_t
																																																																BgL_argsz00_21527;
																																																															obj_t
																																																																BgL_bodyz00_21526;
																																																															obj_t
																																																																BgL_varsz00_21525;
																																																															BgL_varsz00_21525
																																																																=
																																																																BgL_arg1751z00_1906;
																																																															BgL_bodyz00_21526
																																																																=
																																																																BgL_arg1752z00_1907;
																																																															BgL_argsz00_21527
																																																																=
																																																																BgL_arg1753z00_1908;
																																																															BgL_argsz00_1739
																																																																=
																																																																BgL_argsz00_21527;
																																																															BgL_bodyz00_1738
																																																																=
																																																																BgL_bodyz00_21526;
																																																															BgL_varsz00_1737
																																																																=
																																																																BgL_varsz00_21525;
																																																															goto
																																																																BgL_tagzd2386zd2_1740;
																																																														}
																																																													}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_cdrzd229394zd2_1911;
																																																											BgL_cdrzd229394zd2_1911
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_carzd229139zd2_1845));
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_arg1759z00_1912;
																																																												obj_t
																																																													BgL_arg1760z00_1913;
																																																												obj_t
																																																													BgL_arg1761z00_1914;
																																																												BgL_arg1759z00_1912
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_cdrzd229394zd2_1911));
																																																												BgL_arg1760z00_1913
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_cdrzd229394zd2_1911));
																																																												BgL_arg1761z00_1914
																																																													=
																																																													CDR
																																																													(BgL_expz00_21);
																																																												{
																																																													obj_t
																																																														BgL_argsz00_21537;
																																																													obj_t
																																																														BgL_bodyz00_21536;
																																																													obj_t
																																																														BgL_varsz00_21535;
																																																													BgL_varsz00_21535
																																																														=
																																																														BgL_arg1759z00_1912;
																																																													BgL_bodyz00_21536
																																																														=
																																																														BgL_arg1760z00_1913;
																																																													BgL_argsz00_21537
																																																														=
																																																														BgL_arg1761z00_1914;
																																																													BgL_argsz00_1739
																																																														=
																																																														BgL_argsz00_21537;
																																																													BgL_bodyz00_1738
																																																														=
																																																														BgL_bodyz00_21536;
																																																													BgL_varsz00_1737
																																																														=
																																																														BgL_varsz00_21535;
																																																													goto
																																																														BgL_tagzd2386zd2_1740;
																																																												}
																																																											}
																																																										}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																										{
																																																											obj_t
																																																												BgL_auxz00_21540;
																																																											goto
																																																												BgL_tagzd2403zd2_1774;
																																																											return
																																																												(
																																																												(BgL_nodez00_bglt)
																																																												BgL_auxz00_21540);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											goto
																																																												BgL_tagzd2404zd2_1775;
																																																										}
																																																								}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_cdrzd229532zd2_1919;
																																																							BgL_cdrzd229532zd2_1919
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_carzd229139zd2_1845));
																																																							if ((CAR(((obj_t) BgL_carzd229139zd2_1845)) == CNST_TABLE_REF(((long) 1))))
																																																								{	/* Ast/sexp.scm 118 */
																																																									if (PAIRP(BgL_cdrzd229532zd2_1919))
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_cdrzd229537zd2_1923;
																																																											BgL_cdrzd229537zd2_1923
																																																												=
																																																												CDR
																																																												(BgL_cdrzd229532zd2_1919);
																																																											if (PAIRP(BgL_cdrzd229537zd2_1923))
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_carzd229541zd2_1925;
																																																													obj_t
																																																														BgL_cdrzd229542zd2_1926;
																																																													BgL_carzd229541zd2_1925
																																																														=
																																																														CAR
																																																														(BgL_cdrzd229537zd2_1923);
																																																													BgL_cdrzd229542zd2_1926
																																																														=
																																																														CDR
																																																														(BgL_cdrzd229537zd2_1923);
																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd229541zd2_1925))
																																																														{	/* Ast/sexp.scm 118 */
																																																															if (PAIRP(BgL_cdrzd229542zd2_1926))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_carzd229547zd2_1929;
																																																																	BgL_carzd229547zd2_1929
																																																																		=
																																																																		CAR
																																																																		(BgL_cdrzd229542zd2_1926);
																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd229547zd2_1929))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if (NULLP(CDR(BgL_cdrzd229542zd2_1926)))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					bool_t
																																																																						BgL_test9248z00_21566;
																																																																					{
																																																																						obj_t
																																																																							BgL_l1415z00_1962;
																																																																						BgL_l1415z00_1962
																																																																							=
																																																																							BgL_cdrzd229140zd2_1846;
																																																																					BgL_zc3z04anonymousza31790ze3z87_1963:
																																																																						if (NULLP(BgL_l1415z00_1962))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								BgL_test9248z00_21566
																																																																									=
																																																																									(
																																																																									(bool_t)
																																																																									1);
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								bool_t
																																																																									BgL_test9250z00_21569;
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									bool_t
																																																																										BgL_test9251z00_21570;
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_tmpz00_21571;
																																																																										BgL_tmpz00_21571
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_l1415z00_1962));
																																																																										BgL_test9251z00_21570
																																																																											=
																																																																											PAIRP
																																																																											(BgL_tmpz00_21571);
																																																																									}
																																																																									if (BgL_test9251z00_21570)
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											BgL_test9250z00_21569
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												0);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											BgL_test9250z00_21569
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												1);
																																																																										}
																																																																								}
																																																																								if (BgL_test9250z00_21569)
																																																																									{
																																																																										obj_t
																																																																											BgL_l1415z00_21575;
																																																																										BgL_l1415z00_21575
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_l1415z00_1962));
																																																																										BgL_l1415z00_1962
																																																																											=
																																																																											BgL_l1415z00_21575;
																																																																										goto
																																																																											BgL_zc3z04anonymousza31790ze3z87_1963;
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										BgL_test9248z00_21566
																																																																											=
																																																																											(
																																																																											(bool_t)
																																																																											0);
																																																																									}
																																																																							}
																																																																					}
																																																																					if (BgL_test9248z00_21566)
																																																																						{
																																																																							obj_t
																																																																								BgL_argsz00_21582;
																																																																							obj_t
																																																																								BgL_proc2z00_21581;
																																																																							obj_t
																																																																								BgL_proc1z00_21580;
																																																																							obj_t
																																																																								BgL_testz00_21578;
																																																																							BgL_testz00_21578
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd229532zd2_1919);
																																																																							BgL_proc1z00_21580
																																																																								=
																																																																								BgL_carzd229541zd2_1925;
																																																																							BgL_proc2z00_21581
																																																																								=
																																																																								BgL_carzd229547zd2_1929;
																																																																							BgL_argsz00_21582
																																																																								=
																																																																								BgL_cdrzd229140zd2_1846;
																																																																							BgL_argsz00_1744
																																																																								=
																																																																								BgL_argsz00_21582;
																																																																							BgL_proc2z00_1743
																																																																								=
																																																																								BgL_proc2z00_21581;
																																																																							BgL_proc1z00_1742
																																																																								=
																																																																								BgL_proc1z00_21580;
																																																																							BgL_testz00_1741
																																																																								=
																																																																								BgL_testz00_21578;
																																																																							goto
																																																																								BgL_tagzd2387zd2_1745;
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_cdrzd229572zd2_1946;
																																																																							BgL_cdrzd229572zd2_1946
																																																																								=
																																																																								CDR
																																																																								(BgL_expz00_21);
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_cdrzd229580zd2_1947;
																																																																								BgL_cdrzd229580zd2_1947
																																																																									=
																																																																									CDR
																																																																									(CAR
																																																																									(BgL_expz00_21));
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_cdrzd229588zd2_1948;
																																																																									BgL_cdrzd229588zd2_1948
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd229580zd2_1947));
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_carzd229595zd2_1949;
																																																																										BgL_carzd229595zd2_1949
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd229588zd2_1948));
																																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd229595zd2_1949))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_carzd229604zd2_1951;
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_pairz00_11687;
																																																																													BgL_pairz00_11687
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd229588zd2_1948));
																																																																													BgL_carzd229604zd2_1951
																																																																														=
																																																																														CAR
																																																																														(BgL_pairz00_11687);
																																																																												}
																																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd229604zd2_1951))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd229572zd2_1946))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_arg1784z00_1954;
																																																																																BgL_arg1784z00_1954
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd229580zd2_1947));
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_21604;
																																																																																	obj_t
																																																																																		BgL_proc2z00_21603;
																																																																																	obj_t
																																																																																		BgL_proc1z00_21602;
																																																																																	obj_t
																																																																																		BgL_testz00_21601;
																																																																																	BgL_testz00_21601
																																																																																		=
																																																																																		BgL_arg1784z00_1954;
																																																																																	BgL_proc1z00_21602
																																																																																		=
																																																																																		BgL_carzd229595zd2_1949;
																																																																																	BgL_proc2z00_21603
																																																																																		=
																																																																																		BgL_carzd229604zd2_1951;
																																																																																	BgL_argsz00_21604
																																																																																		=
																																																																																		BgL_cdrzd229572zd2_1946;
																																																																																	BgL_argsz00_1749
																																																																																		=
																																																																																		BgL_argsz00_21604;
																																																																																	BgL_proc2z00_1748
																																																																																		=
																																																																																		BgL_proc2z00_21603;
																																																																																	BgL_proc1z00_1747
																																																																																		=
																																																																																		BgL_proc1z00_21602;
																																																																																	BgL_testz00_1746
																																																																																		=
																																																																																		BgL_testz00_21601;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1750;
																																																																																}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{
																																																																																		obj_t
																																																																																			BgL_auxz00_21607;
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1774;
																																																																																		return
																																																																																			(
																																																																																			(BgL_nodez00_bglt)
																																																																																			BgL_auxz00_21607);
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1775;
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{
																																																																																obj_t
																																																																																	BgL_auxz00_21611;
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1774;
																																																																																return
																																																																																	(
																																																																																	(BgL_nodez00_bglt)
																																																																																	BgL_auxz00_21611);
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1775;
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{
																																																																														obj_t
																																																																															BgL_auxz00_21615;
																																																																														goto
																																																																															BgL_tagzd2403zd2_1774;
																																																																														return
																																																																															(
																																																																															(BgL_nodez00_bglt)
																																																																															BgL_auxz00_21615);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														goto
																																																																															BgL_tagzd2404zd2_1775;
																																																																													}
																																																																											}
																																																																									}
																																																																								}
																																																																							}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{
																																																																							obj_t
																																																																								BgL_auxz00_21619;
																																																																							goto
																																																																								BgL_tagzd2403zd2_1774;
																																																																							return
																																																																								(
																																																																								(BgL_nodez00_bglt)
																																																																								BgL_auxz00_21619);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							goto
																																																																								BgL_tagzd2404zd2_1775;
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_cdrzd229882zd2_1973;
																																																																			BgL_cdrzd229882zd2_1973
																																																																				=
																																																																				CDR
																																																																				(BgL_expz00_21);
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_cdrzd229889zd2_1974;
																																																																				BgL_cdrzd229889zd2_1974
																																																																					=
																																																																					CDR
																																																																					(CAR
																																																																					(BgL_expz00_21));
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_cdrzd229896zd2_1975;
																																																																					BgL_cdrzd229896zd2_1975
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd229889zd2_1974));
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_carzd229902zd2_1976;
																																																																						obj_t
																																																																							BgL_cdrzd229903zd2_1977;
																																																																						BgL_carzd229902zd2_1976
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd229896zd2_1975));
																																																																						BgL_cdrzd229903zd2_1977
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd229896zd2_1975));
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd229902zd2_1976))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_carzd229910zd2_1979;
																																																																								BgL_carzd229910zd2_1979
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd229903zd2_1977));
																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd229910zd2_1979))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (NULLP(CDR(((obj_t) BgL_cdrzd229903zd2_1977))))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd229882zd2_1973))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_arg1800z00_1984;
																																																																														BgL_arg1800z00_1984
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd229889zd2_1974));
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_21647;
																																																																															obj_t
																																																																																BgL_proc2z00_21646;
																																																																															obj_t
																																																																																BgL_proc1z00_21645;
																																																																															obj_t
																																																																																BgL_testz00_21644;
																																																																															BgL_testz00_21644
																																																																																=
																																																																																BgL_arg1800z00_1984;
																																																																															BgL_proc1z00_21645
																																																																																=
																																																																																BgL_carzd229902zd2_1976;
																																																																															BgL_proc2z00_21646
																																																																																=
																																																																																BgL_carzd229910zd2_1979;
																																																																															BgL_argsz00_21647
																																																																																=
																																																																																BgL_cdrzd229882zd2_1973;
																																																																															BgL_argsz00_1749
																																																																																=
																																																																																BgL_argsz00_21647;
																																																																															BgL_proc2z00_1748
																																																																																=
																																																																																BgL_proc2z00_21646;
																																																																															BgL_proc1z00_1747
																																																																																=
																																																																																BgL_proc1z00_21645;
																																																																															BgL_testz00_1746
																																																																																=
																																																																																BgL_testz00_21644;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1750;
																																																																														}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{
																																																																																obj_t
																																																																																	BgL_auxz00_21650;
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1774;
																																																																																return
																																																																																	(
																																																																																	(BgL_nodez00_bglt)
																																																																																	BgL_auxz00_21650);
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1775;
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{
																																																																														obj_t
																																																																															BgL_auxz00_21654;
																																																																														goto
																																																																															BgL_tagzd2403zd2_1774;
																																																																														return
																																																																															(
																																																																															(BgL_nodez00_bglt)
																																																																															BgL_auxz00_21654);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														goto
																																																																															BgL_tagzd2404zd2_1775;
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{
																																																																												obj_t
																																																																													BgL_auxz00_21658;
																																																																												goto
																																																																													BgL_tagzd2403zd2_1774;
																																																																												return
																																																																													(
																																																																													(BgL_nodez00_bglt)
																																																																													BgL_auxz00_21658);
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												goto
																																																																													BgL_tagzd2404zd2_1775;
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{
																																																																										obj_t
																																																																											BgL_auxz00_21662;
																																																																										goto
																																																																											BgL_tagzd2403zd2_1774;
																																																																										return
																																																																											(
																																																																											(BgL_nodez00_bglt)
																																																																											BgL_auxz00_21662);
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										goto
																																																																											BgL_tagzd2404zd2_1775;
																																																																									}
																																																																							}
																																																																					}
																																																																				}
																																																																			}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{
																																																																			obj_t
																																																																				BgL_auxz00_21666;
																																																																			goto
																																																																				BgL_tagzd2403zd2_1774;
																																																																			return
																																																																				(
																																																																				(BgL_nodez00_bglt)
																																																																				BgL_auxz00_21666);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			goto
																																																																				BgL_tagzd2404zd2_1775;
																																																																		}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_cdrzd230243zd2_1992;
																																																															BgL_cdrzd230243zd2_1992
																																																																=
																																																																CDR
																																																																(BgL_expz00_21);
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_cdrzd230249zd2_1993;
																																																																BgL_cdrzd230249zd2_1993
																																																																	=
																																																																	CDR
																																																																	(CAR
																																																																	(BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd230255zd2_1994;
																																																																	BgL_cdrzd230255zd2_1994
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd230249zd2_1993));
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_carzd230260zd2_1995;
																																																																		obj_t
																																																																			BgL_cdrzd230261zd2_1996;
																																																																		BgL_carzd230260zd2_1995
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd230255zd2_1994));
																																																																		BgL_cdrzd230261zd2_1996
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd230255zd2_1994));
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd230260zd2_1995))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (PAIRP(BgL_cdrzd230261zd2_1996))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_carzd230266zd2_1999;
																																																																						BgL_carzd230266zd2_1999
																																																																							=
																																																																							CAR
																																																																							(BgL_cdrzd230261zd2_1996);
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd230266zd2_1999))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (NULLP(CDR(BgL_cdrzd230261zd2_1996)))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd230243zd2_1992))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_arg1815z00_2004;
																																																																												BgL_arg1815z00_2004
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd230249zd2_1993));
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_21694;
																																																																													obj_t
																																																																														BgL_proc2z00_21693;
																																																																													obj_t
																																																																														BgL_proc1z00_21692;
																																																																													obj_t
																																																																														BgL_testz00_21691;
																																																																													BgL_testz00_21691
																																																																														=
																																																																														BgL_arg1815z00_2004;
																																																																													BgL_proc1z00_21692
																																																																														=
																																																																														BgL_carzd230260zd2_1995;
																																																																													BgL_proc2z00_21693
																																																																														=
																																																																														BgL_carzd230266zd2_1999;
																																																																													BgL_argsz00_21694
																																																																														=
																																																																														BgL_cdrzd230243zd2_1992;
																																																																													BgL_argsz00_1749
																																																																														=
																																																																														BgL_argsz00_21694;
																																																																													BgL_proc2z00_1748
																																																																														=
																																																																														BgL_proc2z00_21693;
																																																																													BgL_proc1z00_1747
																																																																														=
																																																																														BgL_proc1z00_21692;
																																																																													BgL_testz00_1746
																																																																														=
																																																																														BgL_testz00_21691;
																																																																													goto
																																																																														BgL_tagzd2388zd2_1750;
																																																																												}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{
																																																																														obj_t
																																																																															BgL_auxz00_21697;
																																																																														goto
																																																																															BgL_tagzd2403zd2_1774;
																																																																														return
																																																																															(
																																																																															(BgL_nodez00_bglt)
																																																																															BgL_auxz00_21697);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														goto
																																																																															BgL_tagzd2404zd2_1775;
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{
																																																																												obj_t
																																																																													BgL_auxz00_21701;
																																																																												goto
																																																																													BgL_tagzd2403zd2_1774;
																																																																												return
																																																																													(
																																																																													(BgL_nodez00_bglt)
																																																																													BgL_auxz00_21701);
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												goto
																																																																													BgL_tagzd2404zd2_1775;
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{
																																																																										obj_t
																																																																											BgL_auxz00_21705;
																																																																										goto
																																																																											BgL_tagzd2403zd2_1774;
																																																																										return
																																																																											(
																																																																											(BgL_nodez00_bglt)
																																																																											BgL_auxz00_21705);
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										goto
																																																																											BgL_tagzd2404zd2_1775;
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{
																																																																								obj_t
																																																																									BgL_auxz00_21709;
																																																																								goto
																																																																									BgL_tagzd2403zd2_1774;
																																																																								return
																																																																									(
																																																																									(BgL_nodez00_bglt)
																																																																									BgL_auxz00_21709);
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								goto
																																																																									BgL_tagzd2404zd2_1775;
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{
																																																																						obj_t
																																																																							BgL_auxz00_21713;
																																																																						goto
																																																																							BgL_tagzd2403zd2_1774;
																																																																						return
																																																																							(
																																																																							(BgL_nodez00_bglt)
																																																																							BgL_auxz00_21713);
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						goto
																																																																							BgL_tagzd2404zd2_1775;
																																																																					}
																																																																			}
																																																																	}
																																																																}
																																																															}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{
																																																															obj_t
																																																																BgL_auxz00_21717;
																																																															goto
																																																																BgL_tagzd2403zd2_1774;
																																																															return
																																																																(
																																																																(BgL_nodez00_bglt)
																																																																BgL_auxz00_21717);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															goto
																																																																BgL_tagzd2404zd2_1775;
																																																														}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{
																																																													obj_t
																																																														BgL_auxz00_21721;
																																																													goto
																																																														BgL_tagzd2403zd2_1774;
																																																													return
																																																														(
																																																														(BgL_nodez00_bglt)
																																																														BgL_auxz00_21721);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													goto
																																																														BgL_tagzd2404zd2_1775;
																																																												}
																																																										}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																										{
																																																											obj_t
																																																												BgL_auxz00_21725;
																																																											goto
																																																												BgL_tagzd2403zd2_1774;
																																																											return
																																																												(
																																																												(BgL_nodez00_bglt)
																																																												BgL_auxz00_21725);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											goto
																																																												BgL_tagzd2404zd2_1775;
																																																										}
																																																								}
																																																						}
																																																				}
																																																			}
																																																	}
																																															}
																																														}
																																													}
																																											}
																																									}
																																							}
																																					}
																																			}
																																		}
																																	else
																																		{

																																			if (
																																				(BgL_carzd224574zd2_1829
																																					==
																																					CNST_TABLE_REF
																																					(((long) 17))))
																																				{
																																					obj_t
																																						BgL_auxz00_21730;
																																				BgL_kapzd230804zd2_2412:
																																					if (PAIRP(BgL_cdrzd224445zd2_1811))
																																						{	/* Ast/sexp.scm 118 */
																																							obj_t
																																								BgL_arg2193z00_2509;
																																							obj_t
																																								BgL_arg2195z00_2510;
																																							BgL_arg2193z00_2509
																																								=
																																								CAR
																																								(BgL_cdrzd224445zd2_1811);
																																							BgL_arg2195z00_2510
																																								=
																																								CDR
																																								(BgL_cdrzd224445zd2_1811);
																																							{
																																								BgL_nodez00_bglt
																																									BgL_auxz00_21735;
																																								{
																																									obj_t
																																										BgL_exprz00_21737;
																																									obj_t
																																										BgL_bindingsz00_21736;
																																									BgL_bindingsz00_21736
																																										=
																																										BgL_arg2193z00_2509;
																																									BgL_exprz00_21737
																																										=
																																										BgL_arg2195z00_2510;
																																									BgL_exprz00_1729
																																										=
																																										BgL_exprz00_21737;
																																									BgL_bindingsz00_1728
																																										=
																																										BgL_bindingsz00_21736;
																																									goto
																																										BgL_tagzd2382zd2_1730;
																																								}
																																								BgL_auxz00_21730
																																									=
																																									(
																																									(obj_t)
																																									BgL_auxz00_21735);
																																							}
																																						}
																																					else
																																						{	/* Ast/sexp.scm 118 */
																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_21744;
																																									goto
																																										BgL_tagzd2383zd2_1731;
																																									BgL_auxz00_21730
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_21744);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 118 */
																																									obj_t
																																										BgL_carzd230837zd2_2513;
																																									BgL_carzd230837zd2_2513
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_expz00_21));
																																									if ((BgL_carzd230837zd2_2513 == CNST_TABLE_REF(((long) 19))))
																																										{
																																											BgL_letzd2funzd2_bglt
																																												BgL_auxz00_21751;
																																											goto
																																												BgL_tagzd2384zd2_1732;
																																											BgL_auxz00_21730
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_21751);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 118 */
																																											if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd230837zd2_2513)))
																																												{
																																													BgL_letzd2funzd2_bglt
																																														BgL_auxz00_21756;
																																													goto
																																														BgL_tagzd2384zd2_1732;
																																													BgL_auxz00_21730
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_21756);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 118 */
																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_21763;
																																															goto
																																																BgL_tagzd2389zd2_1751;
																																															BgL_auxz00_21730
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_21763);
																																														}
																																													else
																																														{	/* Ast/sexp.scm 118 */
																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_21770;
																																																	goto
																																																		BgL_tagzd2390zd2_1752;
																																																	BgL_auxz00_21730
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_21770);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_21777;
																																																			goto
																																																				BgL_tagzd2392zd2_1756;
																																																			BgL_auxz00_21730
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_21777);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_21784;
																																																					goto
																																																						BgL_tagzd2393zd2_1757;
																																																					BgL_auxz00_21730
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_21784);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_21791;
																																																							goto
																																																								BgL_tagzd2395zd2_1761;
																																																							BgL_auxz00_21730
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_21791);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_21798;
																																																									goto
																																																										BgL_tagzd2396zd2_1762;
																																																									BgL_auxz00_21730
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_21798);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_21805;
																																																											goto
																																																												BgL_tagzd2397zd2_1763;
																																																											BgL_auxz00_21730
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_21805);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																												{
																																																													BgL_jumpzd2exzd2itz00_bglt
																																																														BgL_auxz00_21812;
																																																													goto
																																																														BgL_tagzd2398zd2_1764;
																																																													BgL_auxz00_21730
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_21812);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													if (BGl_equalzf3zf3zz__r4_equivalence_6_2z00(CAR(((obj_t) BgL_expz00_21)), BUNSPEC))
																																																														{	/* Ast/sexp.scm 118 */
																																																															if (NULLP(CDR(((obj_t) BgL_expz00_21))))
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_21822;
																																																																	goto
																																																																		BgL_tagzd2402zd2_1773;
																																																																	BgL_auxz00_21730
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_21822);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1774;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_21826;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1775;
																																																																			BgL_auxz00_21730
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_21826);
																																																																		}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1774;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_21830;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1775;
																																																																	BgL_auxz00_21730
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_21830);
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																					return
																																						(
																																						(BgL_nodez00_bglt)
																																						BgL_auxz00_21730);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 118 */
																																					if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd224574zd2_1829)))
																																						{
																																							obj_t
																																								BgL_auxz00_21836;
																																							goto
																																								BgL_kapzd230804zd2_2412;
																																							return
																																								(
																																								(BgL_nodez00_bglt)
																																								BgL_auxz00_21836);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 118 */
																																							if ((BgL_carzd224574zd2_1829 == CNST_TABLE_REF(((long) 18))))
																																								{
																																									obj_t
																																										BgL_auxz00_21841;
																																									goto
																																										BgL_kapzd230804zd2_2412;
																																									return
																																										(
																																										(BgL_nodez00_bglt)
																																										BgL_auxz00_21841);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 118 */
																																									if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 20))))
																																										{	/* Ast/sexp.scm 118 */
																																											goto
																																												BgL_tagzd2383zd2_1731;
																																										}
																																									else
																																										{	/* Ast/sexp.scm 118 */
																																											obj_t
																																												BgL_carzd230998zd2_2418;
																																											BgL_carzd230998zd2_2418
																																												=
																																												CAR
																																												(BgL_expz00_21);
																																											if ((BgL_carzd230998zd2_2418 == CNST_TABLE_REF(((long) 19))))
																																												{
																																													BgL_letzd2funzd2_bglt
																																														BgL_auxz00_21851;
																																													goto
																																														BgL_tagzd2384zd2_1732;
																																													return
																																														(
																																														(BgL_nodez00_bglt)
																																														BgL_auxz00_21851);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 118 */
																																													if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd230998zd2_2418)))
																																														{
																																															BgL_letzd2funzd2_bglt
																																																BgL_auxz00_21856;
																																															goto
																																																BgL_tagzd2384zd2_1732;
																																															return
																																																(
																																																(BgL_nodez00_bglt)
																																																BgL_auxz00_21856);
																																														}
																																													else
																																														{	/* Ast/sexp.scm 118 */
																																															if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 3))))
																																																{	/* Ast/sexp.scm 118 */
																																																	goto
																																																		BgL_tagzd2389zd2_1751;
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 6))))
																																																		{	/* Ast/sexp.scm 118 */
																																																			goto
																																																				BgL_tagzd2390zd2_1752;
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_cdrzd231077zd2_2425;
																																																			BgL_cdrzd231077zd2_2425
																																																				=
																																																				CDR
																																																				(BgL_expz00_21);
																																																			if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 21))))
																																																				{	/* Ast/sexp.scm 118 */
																																																					if (PAIRP(BgL_cdrzd231077zd2_2425))
																																																						{
																																																							obj_t
																																																								BgL_restz00_21875;
																																																							obj_t
																																																								BgL_effectz00_21873;
																																																							BgL_effectz00_21873
																																																								=
																																																								CAR
																																																								(BgL_cdrzd231077zd2_2425);
																																																							BgL_restz00_21875
																																																								=
																																																								CDR
																																																								(BgL_cdrzd231077zd2_2425);
																																																							BgL_restz00_1754
																																																								=
																																																								BgL_restz00_21875;
																																																							BgL_effectz00_1753
																																																								=
																																																								BgL_effectz00_21873;
																																																							goto
																																																								BgL_tagzd2391zd2_1755;
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																								{
																																																									obj_t
																																																										BgL_auxz00_21879;
																																																									goto
																																																										BgL_tagzd2403zd2_1774;
																																																									return
																																																										(
																																																										(BgL_nodez00_bglt)
																																																										BgL_auxz00_21879);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									goto
																																																										BgL_tagzd2404zd2_1775;
																																																								}
																																																						}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 22))))
																																																						{	/* Ast/sexp.scm 118 */
																																																							goto
																																																								BgL_tagzd2392zd2_1756;
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 23))))
																																																								{	/* Ast/sexp.scm 118 */
																																																									goto
																																																										BgL_tagzd2393zd2_1757;
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 24))))
																																																										{	/* Ast/sexp.scm 118 */
																																																											if (PAIRP(BgL_cdrzd231077zd2_2425))
																																																												{
																																																													obj_t
																																																														BgL_restz00_21897;
																																																													obj_t
																																																														BgL_effectz00_21895;
																																																													BgL_effectz00_21895
																																																														=
																																																														CAR
																																																														(BgL_cdrzd231077zd2_2425);
																																																													BgL_restz00_21897
																																																														=
																																																														CDR
																																																														(BgL_cdrzd231077zd2_2425);
																																																													BgL_restz00_1759
																																																														=
																																																														BgL_restz00_21897;
																																																													BgL_effectz00_1758
																																																														=
																																																														BgL_effectz00_21895;
																																																													goto
																																																														BgL_tagzd2394zd2_1760;
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{
																																																															obj_t
																																																																BgL_auxz00_21901;
																																																															goto
																																																																BgL_tagzd2403zd2_1774;
																																																															return
																																																																(
																																																																(BgL_nodez00_bglt)
																																																																BgL_auxz00_21901);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															goto
																																																																BgL_tagzd2404zd2_1775;
																																																														}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 25))))
																																																												{	/* Ast/sexp.scm 118 */
																																																													goto
																																																														BgL_tagzd2395zd2_1761;
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 26))))
																																																														{	/* Ast/sexp.scm 118 */
																																																															goto
																																																																BgL_tagzd2396zd2_1762;
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 27))))
																																																																{
																																																																	BgL_letzd2funzd2_bglt
																																																																		BgL_auxz00_21915;
																																																																	goto
																																																																		BgL_tagzd2397zd2_1763;
																																																																	return
																																																																		(
																																																																		(BgL_nodez00_bglt)
																																																																		BgL_auxz00_21915);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 28))))
																																																																		{
																																																																			BgL_jumpzd2exzd2itz00_bglt
																																																																				BgL_auxz00_21921;
																																																																			goto
																																																																				BgL_tagzd2398zd2_1764;
																																																																			return
																																																																				(
																																																																				(BgL_nodez00_bglt)
																																																																				BgL_auxz00_21921);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_cdrzd231204zd2_2451;
																																																																			BgL_cdrzd231204zd2_2451
																																																																				=
																																																																				CDR
																																																																				(BgL_expz00_21);
																																																																			if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 30))))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (PAIRP(BgL_cdrzd231204zd2_2451))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_cdrzd231206zd2_2455;
																																																																							BgL_cdrzd231206zd2_2455
																																																																								=
																																																																								CDR
																																																																								(BgL_cdrzd231204zd2_2451);
																																																																							if (PAIRP(BgL_cdrzd231206zd2_2455))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (NULLP(CDR(BgL_cdrzd231206zd2_2455)))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2399zd2_1765;
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{
																																																																													obj_t
																																																																														BgL_auxz00_21938;
																																																																													goto
																																																																														BgL_tagzd2403zd2_1774;
																																																																													return
																																																																														(
																																																																														(BgL_nodez00_bglt)
																																																																														BgL_auxz00_21938);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2404zd2_1775;
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{
																																																																											obj_t
																																																																												BgL_auxz00_21942;
																																																																											goto
																																																																												BgL_tagzd2403zd2_1774;
																																																																											return
																																																																												(
																																																																												(BgL_nodez00_bglt)
																																																																												BgL_auxz00_21942);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2404zd2_1775;
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{
																																																																									obj_t
																																																																										BgL_auxz00_21946;
																																																																									goto
																																																																										BgL_tagzd2403zd2_1774;
																																																																									return
																																																																										(
																																																																										(BgL_nodez00_bglt)
																																																																										BgL_auxz00_21946);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2404zd2_1775;
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 29))))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (PAIRP(BgL_cdrzd231204zd2_2451))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_cdrzd231251zd2_2467;
																																																																									BgL_cdrzd231251zd2_2467
																																																																										=
																																																																										CDR
																																																																										(BgL_cdrzd231204zd2_2451);
																																																																									if (PAIRP(BgL_cdrzd231251zd2_2467))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_cdrzd231256zd2_2469;
																																																																											BgL_cdrzd231256zd2_2469
																																																																												=
																																																																												CDR
																																																																												(BgL_cdrzd231251zd2_2467);
																																																																											if ((CAR(BgL_cdrzd231251zd2_2467) == CNST_TABLE_REF(((long) 31))))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (PAIRP(BgL_cdrzd231256zd2_2469))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_arg2159z00_2473;
																																																																															obj_t
																																																																																BgL_arg2160z00_2474;
																																																																															obj_t
																																																																																BgL_arg2161z00_2475;
																																																																															BgL_arg2159z00_2473
																																																																																=
																																																																																CAR
																																																																																(BgL_cdrzd231204zd2_2451);
																																																																															BgL_arg2160z00_2474
																																																																																=
																																																																																CAR
																																																																																(BgL_cdrzd231256zd2_2469);
																																																																															BgL_arg2161z00_2475
																																																																																=
																																																																																CDR
																																																																																(BgL_cdrzd231256zd2_2469);
																																																																															return
																																																																																BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																(BgL_expz00_21,
																																																																																BgL_arg2159z00_2473,
																																																																																BgL_arg2160z00_2474,
																																																																																BgL_arg2161z00_2475,
																																																																																BgL_stackz00_22,
																																																																																BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																(BgL_expz00_21,
																																																																																	BgL_locz00_23),
																																																																																BgL_sitez00_24);
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_cdrzd231269zd2_2476;
																																																																															BgL_cdrzd231269zd2_2476
																																																																																=
																																																																																CDR
																																																																																(BgL_expz00_21);
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_arg2163z00_2477;
																																																																																obj_t
																																																																																	BgL_arg2164z00_2478;
																																																																																BgL_arg2163z00_2477
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd231269zd2_2476));
																																																																																BgL_arg2164z00_2478
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd231269zd2_2476));
																																																																																{	/* Ast/sexp.scm 551 */
																																																																																	obj_t
																																																																																		BgL_arg6989z00_11770;
																																																																																	BgL_arg6989z00_11770
																																																																																		=
																																																																																		BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																		(BgL_expz00_21,
																																																																																		BgL_locz00_23);
																																																																																	return
																																																																																		BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																		(BgL_expz00_21,
																																																																																		BgL_arg2163z00_2477,
																																																																																		CNST_TABLE_REF
																																																																																		(((long) 4)), BgL_arg2164z00_2478, BgL_stackz00_22, BgL_arg6989z00_11770, BgL_sitez00_24);
																																																																												}}}}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_cdrzd231284zd2_2479;
																																																																													BgL_cdrzd231284zd2_2479
																																																																														=
																																																																														CDR
																																																																														(BgL_expz00_21);
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_arg2165z00_2480;
																																																																														obj_t
																																																																															BgL_arg2166z00_2481;
																																																																														BgL_arg2165z00_2480
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd231284zd2_2479));
																																																																														BgL_arg2166z00_2481
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd231284zd2_2479));
																																																																														{	/* Ast/sexp.scm 551 */
																																																																															obj_t
																																																																																BgL_arg6989z00_11774;
																																																																															BgL_arg6989z00_11774
																																																																																=
																																																																																BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																(BgL_expz00_21,
																																																																																BgL_locz00_23);
																																																																															return
																																																																																BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																(BgL_expz00_21,
																																																																																BgL_arg2165z00_2480,
																																																																																CNST_TABLE_REF
																																																																																(((long) 4)), BgL_arg2166z00_2481, BgL_stackz00_22, BgL_arg6989z00_11774, BgL_sitez00_24);
																																																																										}}}}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_cdrzd231299zd2_2483;
																																																																											BgL_cdrzd231299zd2_2483
																																																																												=
																																																																												CDR
																																																																												(BgL_expz00_21);
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_arg2168z00_2484;
																																																																												obj_t
																																																																													BgL_arg2169z00_2485;
																																																																												BgL_arg2168z00_2484
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd231299zd2_2483));
																																																																												BgL_arg2169z00_2485
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd231299zd2_2483));
																																																																												{	/* Ast/sexp.scm 551 */
																																																																													obj_t
																																																																														BgL_arg6989z00_11778;
																																																																													BgL_arg6989z00_11778
																																																																														=
																																																																														BGl_findzd2locationzf2locz20zztools_locationz00
																																																																														(BgL_expz00_21,
																																																																														BgL_locz00_23);
																																																																													return
																																																																														BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																														(BgL_expz00_21,
																																																																														BgL_arg2168z00_2484,
																																																																														CNST_TABLE_REF
																																																																														(((long) 4)), BgL_arg2169z00_2485, BgL_stackz00_22, BgL_arg6989z00_11778, BgL_sitez00_24);
																																																																								}}}}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{
																																																																											obj_t
																																																																												BgL_auxz00_21995;
																																																																											goto
																																																																												BgL_tagzd2403zd2_1774;
																																																																											return
																																																																												(
																																																																												(BgL_nodez00_bglt)
																																																																												BgL_auxz00_21995);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2404zd2_1775;
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_equalzf3zf3zz__r4_equivalence_6_2z00(CAR(BgL_expz00_21), BUNSPEC))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (NULLP(CDR(BgL_expz00_21)))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2402zd2_1773;
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{
																																																																													obj_t
																																																																														BgL_auxz00_22005;
																																																																													goto
																																																																														BgL_tagzd2403zd2_1774;
																																																																													return
																																																																														(
																																																																														(BgL_nodez00_bglt)
																																																																														BgL_auxz00_22005);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2404zd2_1775;
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{
																																																																											obj_t
																																																																												BgL_auxz00_22009;
																																																																											goto
																																																																												BgL_tagzd2403zd2_1774;
																																																																											return
																																																																												(
																																																																												(BgL_nodez00_bglt)
																																																																												BgL_auxz00_22009);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2404zd2_1775;
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																										}
																								}
																						}
																					}
																			}
																	}
															}
													}
											}
										else
											{	/* Ast/sexp.scm 118 */
												if (
													(BgL_carzd2478zd2_1780 ==
														CNST_TABLE_REF(((long) 11))))
													{	/* Ast/sexp.scm 118 */
														goto BgL_tagzd2371zd2_1710;
													}
												else
													{	/* Ast/sexp.scm 118 */
														if (
															(CAR(BgL_expz00_21) ==
																CNST_TABLE_REF(((long) 14))))
															{
																obj_t BgL_lz00_22018;

																BgL_lz00_22018 = CDR(BgL_expz00_21);
																BgL_lz00_1711 = BgL_lz00_22018;
																goto BgL_tagzd2372zd2_1712;
															}
														else
															{	/* Ast/sexp.scm 118 */
																if (
																	(CAR(BgL_expz00_21) ==
																		CNST_TABLE_REF(((long) 12))))
																	{	/* Ast/sexp.scm 118 */
																		goto BgL_tagzd2373zd2_1713;
																	}
																else
																	{	/* Ast/sexp.scm 118 */
																		if (
																			(CAR(BgL_expz00_21) ==
																				CNST_TABLE_REF(((long) 15))))
																			{	/* Ast/sexp.scm 118 */
																				if (NULLP(CDR(BgL_expz00_21)))
																					{	/* Ast/sexp.scm 118 */
																						goto BgL_tagzd2374zd2_1714;
																					}
																				else
																					{	/* Ast/sexp.scm 118 */
																						obj_t BgL_arg4304z00_5076;

																						BgL_arg4304z00_5076 =
																							CDR(BgL_expz00_21);
																						{
																							BgL_sequencez00_bglt
																								BgL_auxz00_22032;
																							{
																								obj_t BgL_bodyz00_22033;

																								BgL_bodyz00_22033 =
																									BgL_arg4304z00_5076;
																								BgL_bodyz00_1715 =
																									BgL_bodyz00_22033;
																								goto BgL_tagzd2375zd2_1716;
																							}
																							return
																								((BgL_nodez00_bglt)
																								BgL_auxz00_22032);
																						}
																					}
																			}
																		else
																			{	/* Ast/sexp.scm 118 */
																				obj_t BgL_carzd231447zd2_5078;
																				obj_t BgL_cdrzd231448zd2_5079;

																				BgL_carzd231447zd2_5078 =
																					CAR(BgL_expz00_21);
																				BgL_cdrzd231448zd2_5079 =
																					CDR(BgL_expz00_21);
																				{

																					if (
																						(BgL_carzd231447zd2_5078 ==
																							CNST_TABLE_REF(((long) 1))))
																						{
																							obj_t BgL_auxz00_22040;

																						BgL_kapzd231449zd2_5080:
																							if (PAIRP
																								(BgL_cdrzd231448zd2_5079))
																								{	/* Ast/sexp.scm 118 */
																									obj_t BgL_cdrzd231452zd2_5827;

																									BgL_cdrzd231452zd2_5827 =
																										CDR
																										(BgL_cdrzd231448zd2_5079);
																									if (PAIRP
																										(BgL_cdrzd231452zd2_5827))
																										{	/* Ast/sexp.scm 118 */
																											obj_t
																												BgL_cdrzd231455zd2_5829;
																											BgL_cdrzd231455zd2_5829 =
																												CDR
																												(BgL_cdrzd231452zd2_5827);
																											if ((CAR
																													(BgL_cdrzd231452zd2_5827)
																													== BTRUE))
																												{	/* Ast/sexp.scm 118 */
																													if (PAIRP
																														(BgL_cdrzd231455zd2_5829))
																														{	/* Ast/sexp.scm 118 */
																															if (
																																(CAR
																																	(BgL_cdrzd231455zd2_5829)
																																	== BFALSE))
																																{	/* Ast/sexp.scm 118 */
																																	if (NULLP(CDR
																																			(BgL_cdrzd231455zd2_5829)))
																																		{	/* Ast/sexp.scm 118 */
																																			if (
																																				(BgL_sitez00_24
																																					==
																																					CNST_TABLE_REF
																																					(((long) 8))))
																																				{	/* Ast/sexp.scm 118 */
																																					obj_t
																																						BgL_arg4844z00_5839;
																																					BgL_arg4844z00_5839
																																						=
																																						CAR
																																						(BgL_cdrzd231448zd2_5079);
																																					BgL_auxz00_22040
																																						=
																																						(
																																						(obj_t)
																																						BGl_sexpzd2ze3nodez31zzast_sexpz00
																																						(BgL_arg4844z00_5839,
																																							BgL_stackz00_22,
																																							BgL_locz00_23,
																																							BgL_sitez00_24));
																																				}
																																			else
																																				{	/* Ast/sexp.scm 118 */
																																					obj_t
																																						BgL_carzd231474zd2_5840;
																																					BgL_carzd231474zd2_5840
																																						=
																																						CAR(
																																						((obj_t) BgL_expz00_21));
																																					if (
																																						(BgL_carzd231474zd2_5840
																																							==
																																							CNST_TABLE_REF
																																							(((long) 1))))
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_22069;
																																							goto
																																								BgL_tagzd2377zd2_1719;
																																							BgL_auxz00_22040
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_22069);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 118 */
																																							if ((BgL_carzd231474zd2_5840 == BGl_za2ifza2z00zzast_sexpz00))
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_22073;
																																									goto
																																										BgL_tagzd2377zd2_1719;
																																									BgL_auxz00_22040
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_22073);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 118 */
																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 7))))
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_22080;
																																											goto
																																												BgL_tagzd2379zd2_1723;
																																											BgL_auxz00_22040
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_22080);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 118 */
																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_22087;
																																													goto
																																														BgL_tagzd2380zd2_1724;
																																													BgL_auxz00_22040
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_22087);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 118 */
																																													obj_t
																																														BgL_carzd231543zd2_5847;
																																													BgL_carzd231543zd2_5847
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													if (PAIRP(BgL_carzd231543zd2_5847))
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_carzd231546zd2_5849;
																																															obj_t
																																																BgL_cdrzd231547zd2_5850;
																																															BgL_carzd231546zd2_5849
																																																=
																																																CAR
																																																(BgL_carzd231543zd2_5847);
																																															BgL_cdrzd231547zd2_5850
																																																=
																																																CDR
																																																(BgL_carzd231543zd2_5847);
																																															{

																																																if ((BgL_carzd231546zd2_5849 == CNST_TABLE_REF(((long) 17))))
																																																	{	/* Ast/sexp.scm 118 */
																																																	BgL_kapzd231548zd2_5851:
																																																		if (PAIRP(BgL_cdrzd231547zd2_5850))
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_cdrzd231551zd2_5976;
																																																				BgL_cdrzd231551zd2_5976
																																																					=
																																																					CDR
																																																					(BgL_cdrzd231547zd2_5850);
																																																				if (PAIRP(BgL_cdrzd231551zd2_5976))
																																																					{	/* Ast/sexp.scm 118 */
																																																						if (NULLP(CDR(BgL_cdrzd231551zd2_5976)))
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_arg4936z00_5980;
																																																								obj_t
																																																									BgL_arg4937z00_5981;
																																																								BgL_arg4936z00_5980
																																																									=
																																																									CAR
																																																									(BgL_cdrzd231551zd2_5976);
																																																								BgL_arg4937z00_5981
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_22109;
																																																									{
																																																										obj_t
																																																											BgL_argsz00_22111;
																																																										obj_t
																																																											BgL_bodyz00_22110;
																																																										BgL_bodyz00_22110
																																																											=
																																																											BgL_arg4936z00_5980;
																																																										BgL_argsz00_22111
																																																											=
																																																											BgL_arg4937z00_5981;
																																																										BgL_argsz00_1726
																																																											=
																																																											BgL_argsz00_22111;
																																																										BgL_bodyz00_1725
																																																											=
																																																											BgL_bodyz00_22110;
																																																										goto
																																																											BgL_tagzd2381zd2_1727;
																																																									}
																																																									BgL_auxz00_22040
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_22109);
																																																								}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_cdrzd231575zd2_5982;
																																																								BgL_cdrzd231575zd2_5982
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{	/* Ast/sexp.scm 118 */
																																																									bool_t
																																																										BgL_test9356z00_22115;
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_arg5006z00_6093;
																																																										BgL_arg5006z00_6093
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_test9356z00_22115
																																																											=
																																																											CBOOL
																																																											(BGl_letzd2symzf3z21zzast_letz00
																																																											(BgL_arg5006z00_6093));
																																																									}
																																																									if (BgL_test9356z00_22115)
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_arg4940z00_5985;
																																																											obj_t
																																																												BgL_arg4941z00_5986;
																																																											BgL_arg4940z00_5985
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_cdrzd231575zd2_5982));
																																																											BgL_arg4941z00_5986
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd231575zd2_5982));
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_22124;
																																																												{
																																																													obj_t
																																																														BgL_exprz00_22126;
																																																													obj_t
																																																														BgL_bindingsz00_22125;
																																																													BgL_bindingsz00_22125
																																																														=
																																																														BgL_arg4940z00_5985;
																																																													BgL_exprz00_22126
																																																														=
																																																														BgL_arg4941z00_5986;
																																																													BgL_exprz00_1729
																																																														=
																																																														BgL_exprz00_22126;
																																																													BgL_bindingsz00_1728
																																																														=
																																																														BgL_bindingsz00_22125;
																																																													goto
																																																														BgL_tagzd2382zd2_1730;
																																																												}
																																																												BgL_auxz00_22040
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_22124);
																																																											}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											bool_t
																																																												BgL_test9357z00_22128;
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_arg5005z00_6092;
																																																												BgL_arg5005z00_6092
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												BgL_test9357z00_22128
																																																													=
																																																													CBOOL
																																																													(BGl_labelszd2symzf3z21zzast_labelsz00
																																																													(BgL_arg5005z00_6092));
																																																											}
																																																											if (BgL_test9357z00_22128)
																																																												{
																																																													BgL_letzd2funzd2_bglt
																																																														BgL_auxz00_22133;
																																																													goto
																																																														BgL_tagzd2384zd2_1732;
																																																													BgL_auxz00_22040
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_22133);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_carzd231642zd2_5989;
																																																													BgL_carzd231642zd2_5989
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_cdrzd231647zd2_5990;
																																																														BgL_cdrzd231647zd2_5990
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_carzd231642zd2_5989));
																																																														if ((CAR(((obj_t) BgL_carzd231642zd2_5989)) == CNST_TABLE_REF(((long) 3))))
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_arg4946z00_5993;
																																																																obj_t
																																																																	BgL_arg4947z00_5994;
																																																																obj_t
																																																																	BgL_arg4948z00_5995;
																																																																BgL_arg4946z00_5993
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd231647zd2_5990));
																																																																BgL_arg4947z00_5994
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd231647zd2_5990));
																																																																BgL_arg4948z00_5995
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_22150;
																																																																	{
																																																																		obj_t
																																																																			BgL_argsz00_22153;
																																																																		obj_t
																																																																			BgL_bodyz00_22152;
																																																																		obj_t
																																																																			BgL_varsz00_22151;
																																																																		BgL_varsz00_22151
																																																																			=
																																																																			BgL_arg4946z00_5993;
																																																																		BgL_bodyz00_22152
																																																																			=
																																																																			BgL_arg4947z00_5994;
																																																																		BgL_argsz00_22153
																																																																			=
																																																																			BgL_arg4948z00_5995;
																																																																		BgL_argsz00_1739
																																																																			=
																																																																			BgL_argsz00_22153;
																																																																		BgL_bodyz00_1738
																																																																			=
																																																																			BgL_bodyz00_22152;
																																																																		BgL_varsz00_1737
																																																																			=
																																																																			BgL_varsz00_22151;
																																																																		goto
																																																																			BgL_tagzd2386zd2_1740;
																																																																	}
																																																																	BgL_auxz00_22040
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_22150);
																																																																}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_cdrzd231670zd2_5997;
																																																																BgL_cdrzd231670zd2_5997
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd231676zd2_5998;
																																																																	BgL_cdrzd231676zd2_5998
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_carzd231642zd2_5989));
																																																																	if ((CAR(((obj_t) BgL_carzd231642zd2_5989)) == CNST_TABLE_REF(((long) 1))))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_cdrzd231682zd2_6001;
																																																																			BgL_cdrzd231682zd2_6001
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd231676zd2_5998));
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_carzd231687zd2_6002;
																																																																				obj_t
																																																																					BgL_cdrzd231688zd2_6003;
																																																																				BgL_carzd231687zd2_6002
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd231682zd2_6001));
																																																																				BgL_cdrzd231688zd2_6003
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd231682zd2_6001));
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd231687zd2_6002))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (PAIRP(BgL_cdrzd231688zd2_6003))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_carzd231695zd2_6006;
																																																																								BgL_carzd231695zd2_6006
																																																																									=
																																																																									CAR
																																																																									(BgL_cdrzd231688zd2_6003);
																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd231695zd2_6006))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (NULLP(CDR(BgL_cdrzd231688zd2_6003)))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												bool_t
																																																																													BgL_test9364z00_22180;
																																																																												{
																																																																													obj_t
																																																																														BgL_l1418z00_6039;
																																																																													BgL_l1418z00_6039
																																																																														=
																																																																														BgL_cdrzd231670zd2_5997;
																																																																												BgL_zc3z04anonymousza34971ze3z87_6040:
																																																																													if (NULLP(BgL_l1418z00_6039))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															BgL_test9364z00_22180
																																																																																=
																																																																																(
																																																																																(bool_t)
																																																																																1);
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															bool_t
																																																																																BgL_test9366z00_22183;
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																bool_t
																																																																																	BgL_test9367z00_22184;
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_tmpz00_22185;
																																																																																	BgL_tmpz00_22185
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_l1418z00_6039));
																																																																																	BgL_test9367z00_22184
																																																																																		=
																																																																																		PAIRP
																																																																																		(BgL_tmpz00_22185);
																																																																																}
																																																																																if (BgL_test9367z00_22184)
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		BgL_test9366z00_22183
																																																																																			=
																																																																																			(
																																																																																			(bool_t)
																																																																																			0);
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		BgL_test9366z00_22183
																																																																																			=
																																																																																			(
																																																																																			(bool_t)
																																																																																			1);
																																																																																	}
																																																																															}
																																																																															if (BgL_test9366z00_22183)
																																																																																{
																																																																																	obj_t
																																																																																		BgL_l1418z00_22189;
																																																																																	BgL_l1418z00_22189
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_l1418z00_6039));
																																																																																	BgL_l1418z00_6039
																																																																																		=
																																																																																		BgL_l1418z00_22189;
																																																																																	goto
																																																																																		BgL_zc3z04anonymousza34971ze3z87_6040;
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	BgL_test9364z00_22180
																																																																																		=
																																																																																		(
																																																																																		(bool_t)
																																																																																		0);
																																																																																}
																																																																														}
																																																																												}
																																																																												if (BgL_test9364z00_22180)
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_arg4961z00_6022;
																																																																														BgL_arg4961z00_6022
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd231676zd2_5998));
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_22194;
																																																																															{
																																																																																obj_t
																																																																																	BgL_argsz00_22198;
																																																																																obj_t
																																																																																	BgL_proc2z00_22197;
																																																																																obj_t
																																																																																	BgL_proc1z00_22196;
																																																																																obj_t
																																																																																	BgL_testz00_22195;
																																																																																BgL_testz00_22195
																																																																																	=
																																																																																	BgL_arg4961z00_6022;
																																																																																BgL_proc1z00_22196
																																																																																	=
																																																																																	BgL_carzd231687zd2_6002;
																																																																																BgL_proc2z00_22197
																																																																																	=
																																																																																	BgL_carzd231695zd2_6006;
																																																																																BgL_argsz00_22198
																																																																																	=
																																																																																	BgL_cdrzd231670zd2_5997;
																																																																																BgL_argsz00_1744
																																																																																	=
																																																																																	BgL_argsz00_22198;
																																																																																BgL_proc2z00_1743
																																																																																	=
																																																																																	BgL_proc2z00_22197;
																																																																																BgL_proc1z00_1742
																																																																																	=
																																																																																	BgL_proc1z00_22196;
																																																																																BgL_testz00_1741
																																																																																	=
																																																																																	BgL_testz00_22195;
																																																																																goto
																																																																																	BgL_tagzd2387zd2_1745;
																																																																															}
																																																																															BgL_auxz00_22040
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_22194);
																																																																														}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_cdrzd231719zd2_6023;
																																																																														BgL_cdrzd231719zd2_6023
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_expz00_21));
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_cdrzd231726zd2_6024;
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_pairz00_11845;
																																																																																BgL_pairz00_11845
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_expz00_21));
																																																																																BgL_cdrzd231726zd2_6024
																																																																																	=
																																																																																	CDR
																																																																																	(BgL_pairz00_11845);
																																																																															}
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_cdrzd231733zd2_6025;
																																																																																BgL_cdrzd231733zd2_6025
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd231726zd2_6024));
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_carzd231739zd2_6026;
																																																																																	BgL_carzd231739zd2_6026
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd231733zd2_6025));
																																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd231739zd2_6026))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			obj_t
																																																																																				BgL_carzd231746zd2_6028;
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				obj_t
																																																																																					BgL_pairz00_11849;
																																																																																				BgL_pairz00_11849
																																																																																					=
																																																																																					CDR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd231733zd2_6025));
																																																																																				BgL_carzd231746zd2_6028
																																																																																					=
																																																																																					CAR
																																																																																					(BgL_pairz00_11849);
																																																																																			}
																																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd231746zd2_6028))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd231719zd2_6023))
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							obj_t
																																																																																								BgL_arg4965z00_6031;
																																																																																							BgL_arg4965z00_6031
																																																																																								=
																																																																																								CAR
																																																																																								(
																																																																																								((obj_t) BgL_cdrzd231726zd2_6024));
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_22220;
																																																																																								{
																																																																																									obj_t
																																																																																										BgL_argsz00_22224;
																																																																																									obj_t
																																																																																										BgL_proc2z00_22223;
																																																																																									obj_t
																																																																																										BgL_proc1z00_22222;
																																																																																									obj_t
																																																																																										BgL_testz00_22221;
																																																																																									BgL_testz00_22221
																																																																																										=
																																																																																										BgL_arg4965z00_6031;
																																																																																									BgL_proc1z00_22222
																																																																																										=
																																																																																										BgL_carzd231739zd2_6026;
																																																																																									BgL_proc2z00_22223
																																																																																										=
																																																																																										BgL_carzd231746zd2_6028;
																																																																																									BgL_argsz00_22224
																																																																																										=
																																																																																										BgL_cdrzd231719zd2_6023;
																																																																																									BgL_argsz00_1749
																																																																																										=
																																																																																										BgL_argsz00_22224;
																																																																																									BgL_proc2z00_1748
																																																																																										=
																																																																																										BgL_proc2z00_22223;
																																																																																									BgL_proc1z00_1747
																																																																																										=
																																																																																										BgL_proc1z00_22222;
																																																																																									BgL_testz00_1746
																																																																																										=
																																																																																										BgL_testz00_22221;
																																																																																									goto
																																																																																										BgL_tagzd2388zd2_1750;
																																																																																								}
																																																																																								BgL_auxz00_22040
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_22220);
																																																																																							}
																																																																																						}
																																																																																					else
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																								{	/* Ast/sexp.scm 118 */
																																																																																									goto
																																																																																										BgL_tagzd2403zd2_1774;
																																																																																								}
																																																																																							else
																																																																																								{
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_auxz00_22228;
																																																																																									goto
																																																																																										BgL_tagzd2404zd2_1775;
																																																																																									BgL_auxz00_22040
																																																																																										=
																																																																																										(
																																																																																										(obj_t)
																																																																																										BgL_auxz00_22228);
																																																																																								}
																																																																																						}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							goto
																																																																																								BgL_tagzd2403zd2_1774;
																																																																																						}
																																																																																					else
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_22232;
																																																																																							goto
																																																																																								BgL_tagzd2404zd2_1775;
																																																																																							BgL_auxz00_22040
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_22232);
																																																																																						}
																																																																																				}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1774;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_22236;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1775;
																																																																																					BgL_auxz00_22040
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_22236);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															}
																																																																														}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1774;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_22240;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1775;
																																																																														BgL_auxz00_22040
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_22240);
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_cdrzd232022zd2_6050;
																																																																										BgL_cdrzd232022zd2_6050
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_cdrzd232028zd2_6051;
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_pairz00_11853;
																																																																												BgL_pairz00_11853
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_expz00_21));
																																																																												BgL_cdrzd232028zd2_6051
																																																																													=
																																																																													CDR
																																																																													(BgL_pairz00_11853);
																																																																											}
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_cdrzd232034zd2_6052;
																																																																												BgL_cdrzd232034zd2_6052
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd232028zd2_6051));
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_carzd232039zd2_6053;
																																																																													obj_t
																																																																														BgL_cdrzd232040zd2_6054;
																																																																													BgL_carzd232039zd2_6053
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd232034zd2_6052));
																																																																													BgL_cdrzd232040zd2_6054
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd232034zd2_6052));
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd232039zd2_6053))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_carzd232045zd2_6056;
																																																																															BgL_carzd232045zd2_6056
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd232040zd2_6054));
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd232045zd2_6056))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (NULLP(CDR(((obj_t) BgL_cdrzd232040zd2_6054))))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd232022zd2_6050))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					obj_t
																																																																																						BgL_arg4980z00_6061;
																																																																																					BgL_arg4980z00_6061
																																																																																						=
																																																																																						CAR
																																																																																						(
																																																																																						((obj_t) BgL_cdrzd232028zd2_6051));
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_22267;
																																																																																						{
																																																																																							obj_t
																																																																																								BgL_argsz00_22271;
																																																																																							obj_t
																																																																																								BgL_proc2z00_22270;
																																																																																							obj_t
																																																																																								BgL_proc1z00_22269;
																																																																																							obj_t
																																																																																								BgL_testz00_22268;
																																																																																							BgL_testz00_22268
																																																																																								=
																																																																																								BgL_arg4980z00_6061;
																																																																																							BgL_proc1z00_22269
																																																																																								=
																																																																																								BgL_carzd232039zd2_6053;
																																																																																							BgL_proc2z00_22270
																																																																																								=
																																																																																								BgL_carzd232045zd2_6056;
																																																																																							BgL_argsz00_22271
																																																																																								=
																																																																																								BgL_cdrzd232022zd2_6050;
																																																																																							BgL_argsz00_1749
																																																																																								=
																																																																																								BgL_argsz00_22271;
																																																																																							BgL_proc2z00_1748
																																																																																								=
																																																																																								BgL_proc2z00_22270;
																																																																																							BgL_proc1z00_1747
																																																																																								=
																																																																																								BgL_proc1z00_22269;
																																																																																							BgL_testz00_1746
																																																																																								=
																																																																																								BgL_testz00_22268;
																																																																																							goto
																																																																																								BgL_tagzd2388zd2_1750;
																																																																																						}
																																																																																						BgL_auxz00_22040
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_22267);
																																																																																					}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							goto
																																																																																								BgL_tagzd2403zd2_1774;
																																																																																						}
																																																																																					else
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_22275;
																																																																																							goto
																																																																																								BgL_tagzd2404zd2_1775;
																																																																																							BgL_auxz00_22040
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_22275);
																																																																																						}
																																																																																				}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1774;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_22279;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1775;
																																																																																					BgL_auxz00_22040
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_22279);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1774;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_22283;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1775;
																																																																																			BgL_auxz00_22040
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_22283);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1774;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_22287;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1775;
																																																																																	BgL_auxz00_22040
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_22287);
																																																																																}
																																																																														}
																																																																												}
																																																																											}
																																																																										}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1774;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_22291;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1775;
																																																																										BgL_auxz00_22040
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_22291);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_cdrzd232378zd2_6069;
																																																																						BgL_cdrzd232378zd2_6069
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_cdrzd232385zd2_6070;
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_pairz00_11863;
																																																																								BgL_pairz00_11863
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								BgL_cdrzd232385zd2_6070
																																																																									=
																																																																									CDR
																																																																									(BgL_pairz00_11863);
																																																																							}
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_cdrzd232392zd2_6071;
																																																																								BgL_cdrzd232392zd2_6071
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd232385zd2_6070));
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_carzd232398zd2_6072;
																																																																									obj_t
																																																																										BgL_cdrzd232399zd2_6073;
																																																																									BgL_carzd232398zd2_6072
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd232392zd2_6071));
																																																																									BgL_cdrzd232399zd2_6073
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd232392zd2_6071));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd232398zd2_6072))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (PAIRP(BgL_cdrzd232399zd2_6073))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_carzd232406zd2_6076;
																																																																													BgL_carzd232406zd2_6076
																																																																														=
																																																																														CAR
																																																																														(BgL_cdrzd232399zd2_6073);
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd232406zd2_6076))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (NULLP(CDR(BgL_cdrzd232399zd2_6073)))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd232378zd2_6069))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			obj_t
																																																																																				BgL_arg4994z00_6081;
																																																																																			BgL_arg4994z00_6081
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd232385zd2_6070));
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_22318;
																																																																																				{
																																																																																					obj_t
																																																																																						BgL_argsz00_22322;
																																																																																					obj_t
																																																																																						BgL_proc2z00_22321;
																																																																																					obj_t
																																																																																						BgL_proc1z00_22320;
																																																																																					obj_t
																																																																																						BgL_testz00_22319;
																																																																																					BgL_testz00_22319
																																																																																						=
																																																																																						BgL_arg4994z00_6081;
																																																																																					BgL_proc1z00_22320
																																																																																						=
																																																																																						BgL_carzd232398zd2_6072;
																																																																																					BgL_proc2z00_22321
																																																																																						=
																																																																																						BgL_carzd232406zd2_6076;
																																																																																					BgL_argsz00_22322
																																																																																						=
																																																																																						BgL_cdrzd232378zd2_6069;
																																																																																					BgL_argsz00_1749
																																																																																						=
																																																																																						BgL_argsz00_22322;
																																																																																					BgL_proc2z00_1748
																																																																																						=
																																																																																						BgL_proc2z00_22321;
																																																																																					BgL_proc1z00_1747
																																																																																						=
																																																																																						BgL_proc1z00_22320;
																																																																																					BgL_testz00_1746
																																																																																						=
																																																																																						BgL_testz00_22319;
																																																																																					goto
																																																																																						BgL_tagzd2388zd2_1750;
																																																																																				}
																																																																																				BgL_auxz00_22040
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_22318);
																																																																																			}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1774;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_22326;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1775;
																																																																																					BgL_auxz00_22040
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_22326);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1774;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_22330;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1775;
																																																																																			BgL_auxz00_22040
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_22330);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1774;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_22334;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1775;
																																																																																	BgL_auxz00_22040
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_22334);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1774;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_22338;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1775;
																																																																															BgL_auxz00_22040
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_22338);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1774;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_22342;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1775;
																																																																													BgL_auxz00_22040
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_22342);
																																																																												}
																																																																										}
																																																																								}
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1774;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_22346;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1775;
																																																																					BgL_auxz00_22040
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_22346);
																																																																				}
																																																																		}
																																																																}
																																																															}
																																																													}
																																																												}
																																																										}
																																																								}
																																																							}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_cdrzd232799zd2_6095;
																																																						BgL_cdrzd232799zd2_6095
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{	/* Ast/sexp.scm 118 */
																																																							bool_t
																																																								BgL_test9395z00_22350;
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_arg5022z00_6112;
																																																								BgL_arg5022z00_6112
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test9395z00_22350
																																																									=
																																																									CBOOL
																																																									(BGl_letzd2symzf3z21zzast_letz00
																																																									(BgL_arg5022z00_6112));
																																																							}
																																																							if (BgL_test9395z00_22350)
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_arg5010z00_6098;
																																																									obj_t
																																																										BgL_arg5011z00_6099;
																																																									BgL_arg5010z00_6098
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd232799zd2_6095));
																																																									BgL_arg5011z00_6099
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd232799zd2_6095));
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_22359;
																																																										{
																																																											obj_t
																																																												BgL_exprz00_22361;
																																																											obj_t
																																																												BgL_bindingsz00_22360;
																																																											BgL_bindingsz00_22360
																																																												=
																																																												BgL_arg5010z00_6098;
																																																											BgL_exprz00_22361
																																																												=
																																																												BgL_arg5011z00_6099;
																																																											BgL_exprz00_1729
																																																												=
																																																												BgL_exprz00_22361;
																																																											BgL_bindingsz00_1728
																																																												=
																																																												BgL_bindingsz00_22360;
																																																											goto
																																																												BgL_tagzd2382zd2_1730;
																																																										}
																																																										BgL_auxz00_22040
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_22359);
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									bool_t
																																																										BgL_test9396z00_22363;
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_arg5021z00_6111;
																																																										BgL_arg5021z00_6111
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_test9396z00_22363
																																																											=
																																																											CBOOL
																																																											(BGl_labelszd2symzf3z21zzast_labelsz00
																																																											(BgL_arg5021z00_6111));
																																																									}
																																																									if (BgL_test9396z00_22363)
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_22368;
																																																											goto
																																																												BgL_tagzd2384zd2_1732;
																																																											BgL_auxz00_22040
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_22368);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_carzd232865zd2_6102;
																																																											BgL_carzd232865zd2_6102
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_cdrzd232870zd2_6103;
																																																												BgL_cdrzd232870zd2_6103
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_carzd232865zd2_6102));
																																																												if ((CAR(((obj_t) BgL_carzd232865zd2_6102)) == CNST_TABLE_REF(((long) 3))))
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_arg5016z00_6106;
																																																														obj_t
																																																															BgL_arg5017z00_6107;
																																																														obj_t
																																																															BgL_arg5018z00_6108;
																																																														BgL_arg5016z00_6106
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd232870zd2_6103));
																																																														BgL_arg5017z00_6107
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd232870zd2_6103));
																																																														BgL_arg5018z00_6108
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_22385;
																																																															{
																																																																obj_t
																																																																	BgL_argsz00_22388;
																																																																obj_t
																																																																	BgL_bodyz00_22387;
																																																																obj_t
																																																																	BgL_varsz00_22386;
																																																																BgL_varsz00_22386
																																																																	=
																																																																	BgL_arg5016z00_6106;
																																																																BgL_bodyz00_22387
																																																																	=
																																																																	BgL_arg5017z00_6107;
																																																																BgL_argsz00_22388
																																																																	=
																																																																	BgL_arg5018z00_6108;
																																																																BgL_argsz00_1739
																																																																	=
																																																																	BgL_argsz00_22388;
																																																																BgL_bodyz00_1738
																																																																	=
																																																																	BgL_bodyz00_22387;
																																																																BgL_varsz00_1737
																																																																	=
																																																																	BgL_varsz00_22386;
																																																																goto
																																																																	BgL_tagzd2386zd2_1740;
																																																															}
																																																															BgL_auxz00_22040
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_22385);
																																																														}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 118 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 118 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1774;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_22392;
																																																																goto
																																																																	BgL_tagzd2404zd2_1775;
																																																																BgL_auxz00_22040
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_22392);
																																																															}
																																																													}
																																																											}
																																																										}
																																																								}
																																																						}
																																																					}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_cdrzd232981zd2_6113;
																																																				BgL_cdrzd232981zd2_6113
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{	/* Ast/sexp.scm 118 */
																																																					bool_t
																																																						BgL_test9399z00_22396;
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_arg5031z00_6122;
																																																						BgL_arg5031z00_6122
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test9399z00_22396
																																																							=
																																																							CBOOL
																																																							(BGl_letzd2symzf3z21zzast_letz00
																																																							(BgL_arg5031z00_6122));
																																																					}
																																																					if (BgL_test9399z00_22396)
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_arg5025z00_6116;
																																																							obj_t
																																																								BgL_arg5026z00_6117;
																																																							BgL_arg5025z00_6116
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd232981zd2_6113));
																																																							BgL_arg5026z00_6117
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd232981zd2_6113));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_22405;
																																																								{
																																																									obj_t
																																																										BgL_exprz00_22407;
																																																									obj_t
																																																										BgL_bindingsz00_22406;
																																																									BgL_bindingsz00_22406
																																																										=
																																																										BgL_arg5025z00_6116;
																																																									BgL_exprz00_22407
																																																										=
																																																										BgL_arg5026z00_6117;
																																																									BgL_exprz00_1729
																																																										=
																																																										BgL_exprz00_22407;
																																																									BgL_bindingsz00_1728
																																																										=
																																																										BgL_bindingsz00_22406;
																																																									goto
																																																										BgL_tagzd2382zd2_1730;
																																																								}
																																																								BgL_auxz00_22040
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_22405);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							bool_t
																																																								BgL_test9400z00_22409;
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_arg5030z00_6121;
																																																								BgL_arg5030z00_6121
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test9400z00_22409
																																																									=
																																																									CBOOL
																																																									(BGl_labelszd2symzf3z21zzast_labelsz00
																																																									(BgL_arg5030z00_6121));
																																																							}
																																																							if (BgL_test9400z00_22409)
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_22414;
																																																									goto
																																																										BgL_tagzd2384zd2_1732;
																																																									BgL_auxz00_22040
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_22414);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																										{	/* Ast/sexp.scm 118 */
																																																											goto
																																																												BgL_tagzd2403zd2_1774;
																																																										}
																																																									else
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_22418;
																																																											goto
																																																												BgL_tagzd2404zd2_1775;
																																																											BgL_auxz00_22040
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_22418);
																																																										}
																																																								}
																																																						}
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd231546zd2_5849)))
																																																			{	/* Ast/sexp.scm 118 */
																																																				goto
																																																					BgL_kapzd231548zd2_5851;
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 118 */
																																																				if ((BgL_carzd231546zd2_5849 == CNST_TABLE_REF(((long) 18))))
																																																					{	/* Ast/sexp.scm 118 */
																																																						goto
																																																							BgL_kapzd231548zd2_5851;
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 118 */
																																																						if ((BgL_carzd231546zd2_5849 == CNST_TABLE_REF(((long) 19))))
																																																							{	/* Ast/sexp.scm 118 */
																																																								goto
																																																									BgL_kapzd231548zd2_5851;
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 118 */
																																																								if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd231546zd2_5849)))
																																																									{	/* Ast/sexp.scm 118 */
																																																										goto
																																																											BgL_kapzd231548zd2_5851;
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_cdrzd233153zd2_5857;
																																																										BgL_cdrzd233153zd2_5857
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{	/* Ast/sexp.scm 118 */
																																																											bool_t
																																																												BgL_test9406z00_22434;
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_arg4931z00_5974;
																																																												BgL_arg4931z00_5974
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												BgL_test9406z00_22434
																																																													=
																																																													CBOOL
																																																													(BGl_letzd2symzf3z21zzast_letz00
																																																													(BgL_arg4931z00_5974));
																																																											}
																																																											if (BgL_test9406z00_22434)
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_arg4859z00_5860;
																																																													obj_t
																																																														BgL_arg4860z00_5861;
																																																													BgL_arg4859z00_5860
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_cdrzd233153zd2_5857));
																																																													BgL_arg4860z00_5861
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd233153zd2_5857));
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_22443;
																																																														{
																																																															obj_t
																																																																BgL_exprz00_22445;
																																																															obj_t
																																																																BgL_bindingsz00_22444;
																																																															BgL_bindingsz00_22444
																																																																=
																																																																BgL_arg4859z00_5860;
																																																															BgL_exprz00_22445
																																																																=
																																																																BgL_arg4860z00_5861;
																																																															BgL_exprz00_1729
																																																																=
																																																																BgL_exprz00_22445;
																																																															BgL_bindingsz00_1728
																																																																=
																																																																BgL_bindingsz00_22444;
																																																															goto
																																																																BgL_tagzd2382zd2_1730;
																																																														}
																																																														BgL_auxz00_22040
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_22443);
																																																													}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													bool_t
																																																														BgL_test9407z00_22447;
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_arg4930z00_5973;
																																																														BgL_arg4930z00_5973
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														BgL_test9407z00_22447
																																																															=
																																																															CBOOL
																																																															(BGl_labelszd2symzf3z21zzast_labelsz00
																																																															(BgL_arg4930z00_5973));
																																																													}
																																																													if (BgL_test9407z00_22447)
																																																														{
																																																															BgL_letzd2funzd2_bglt
																																																																BgL_auxz00_22452;
																																																															goto
																																																																BgL_tagzd2384zd2_1732;
																																																															BgL_auxz00_22040
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_22452);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_carzd233219zd2_5864;
																																																															BgL_carzd233219zd2_5864
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_cdrzd233224zd2_5865;
																																																																BgL_cdrzd233224zd2_5865
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_carzd233219zd2_5864));
																																																																if ((CAR(((obj_t) BgL_carzd233219zd2_5864)) == CNST_TABLE_REF(((long) 3))))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (PAIRP(BgL_cdrzd233224zd2_5865))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_arg4866z00_5869;
																																																																				obj_t
																																																																					BgL_arg4867z00_5870;
																																																																				obj_t
																																																																					BgL_arg4868z00_5871;
																																																																				BgL_arg4866z00_5869
																																																																					=
																																																																					CAR
																																																																					(BgL_cdrzd233224zd2_5865);
																																																																				BgL_arg4867z00_5870
																																																																					=
																																																																					CDR
																																																																					(BgL_cdrzd233224zd2_5865);
																																																																				BgL_arg4868z00_5871
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_22469;
																																																																					{
																																																																						obj_t
																																																																							BgL_argsz00_22472;
																																																																						obj_t
																																																																							BgL_bodyz00_22471;
																																																																						obj_t
																																																																							BgL_varsz00_22470;
																																																																						BgL_varsz00_22470
																																																																							=
																																																																							BgL_arg4866z00_5869;
																																																																						BgL_bodyz00_22471
																																																																							=
																																																																							BgL_arg4867z00_5870;
																																																																						BgL_argsz00_22472
																																																																							=
																																																																							BgL_arg4868z00_5871;
																																																																						BgL_argsz00_1739
																																																																							=
																																																																							BgL_argsz00_22472;
																																																																						BgL_bodyz00_1738
																																																																							=
																																																																							BgL_bodyz00_22471;
																																																																						BgL_varsz00_1737
																																																																							=
																																																																							BgL_varsz00_22470;
																																																																						goto
																																																																							BgL_tagzd2386zd2_1740;
																																																																					}
																																																																					BgL_auxz00_22040
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_22469);
																																																																				}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1774;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_22476;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1775;
																																																																						BgL_auxz00_22040
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_22476);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_cdrzd233331zd2_5874;
																																																																		BgL_cdrzd233331zd2_5874
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_cdrzd233336zd2_5875;
																																																																			BgL_cdrzd233336zd2_5875
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_carzd233219zd2_5864));
																																																																			if ((CAR(((obj_t) BgL_carzd233219zd2_5864)) == CNST_TABLE_REF(((long) 1))))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (PAIRP(BgL_cdrzd233336zd2_5875))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_cdrzd233341zd2_5879;
																																																																							BgL_cdrzd233341zd2_5879
																																																																								=
																																																																								CDR
																																																																								(BgL_cdrzd233336zd2_5875);
																																																																							if (PAIRP(BgL_cdrzd233341zd2_5879))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_carzd233345zd2_5881;
																																																																									obj_t
																																																																										BgL_cdrzd233346zd2_5882;
																																																																									BgL_carzd233345zd2_5881
																																																																										=
																																																																										CAR
																																																																										(BgL_cdrzd233341zd2_5879);
																																																																									BgL_cdrzd233346zd2_5882
																																																																										=
																																																																										CDR
																																																																										(BgL_cdrzd233341zd2_5879);
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd233345zd2_5881))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (PAIRP(BgL_cdrzd233346zd2_5882))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_carzd233351zd2_5885;
																																																																													BgL_carzd233351zd2_5885
																																																																														=
																																																																														CAR
																																																																														(BgL_cdrzd233346zd2_5882);
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd233351zd2_5885))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (NULLP(CDR(BgL_cdrzd233346zd2_5882)))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	bool_t
																																																																																		BgL_test9418z00_22504;
																																																																																	{
																																																																																		obj_t
																																																																																			BgL_l1421z00_5918;
																																																																																		BgL_l1421z00_5918
																																																																																			=
																																																																																			BgL_cdrzd233331zd2_5874;
																																																																																	BgL_zc3z04anonymousza34894ze3z87_5919:
																																																																																		if (NULLP(BgL_l1421z00_5918))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				BgL_test9418z00_22504
																																																																																					=
																																																																																					(
																																																																																					(bool_t)
																																																																																					1);
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				bool_t
																																																																																					BgL_test9420z00_22507;
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					bool_t
																																																																																						BgL_test9421z00_22508;
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						obj_t
																																																																																							BgL_tmpz00_22509;
																																																																																						BgL_tmpz00_22509
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_l1421z00_5918));
																																																																																						BgL_test9421z00_22508
																																																																																							=
																																																																																							PAIRP
																																																																																							(BgL_tmpz00_22509);
																																																																																					}
																																																																																					if (BgL_test9421z00_22508)
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							BgL_test9420z00_22507
																																																																																								=
																																																																																								(
																																																																																								(bool_t)
																																																																																								0);
																																																																																						}
																																																																																					else
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							BgL_test9420z00_22507
																																																																																								=
																																																																																								(
																																																																																								(bool_t)
																																																																																								1);
																																																																																						}
																																																																																				}
																																																																																				if (BgL_test9420z00_22507)
																																																																																					{
																																																																																						obj_t
																																																																																							BgL_l1421z00_22513;
																																																																																						BgL_l1421z00_22513
																																																																																							=
																																																																																							CDR
																																																																																							(
																																																																																							((obj_t) BgL_l1421z00_5918));
																																																																																						BgL_l1421z00_5918
																																																																																							=
																																																																																							BgL_l1421z00_22513;
																																																																																						goto
																																																																																							BgL_zc3z04anonymousza34894ze3z87_5919;
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						BgL_test9418z00_22504
																																																																																							=
																																																																																							(
																																																																																							(bool_t)
																																																																																							0);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																	if (BgL_test9418z00_22504)
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			obj_t
																																																																																				BgL_arg4884z00_5901;
																																																																																			BgL_arg4884z00_5901
																																																																																				=
																																																																																				CAR
																																																																																				(BgL_cdrzd233336zd2_5875);
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_22517;
																																																																																				{
																																																																																					obj_t
																																																																																						BgL_argsz00_22521;
																																																																																					obj_t
																																																																																						BgL_proc2z00_22520;
																																																																																					obj_t
																																																																																						BgL_proc1z00_22519;
																																																																																					obj_t
																																																																																						BgL_testz00_22518;
																																																																																					BgL_testz00_22518
																																																																																						=
																																																																																						BgL_arg4884z00_5901;
																																																																																					BgL_proc1z00_22519
																																																																																						=
																																																																																						BgL_carzd233345zd2_5881;
																																																																																					BgL_proc2z00_22520
																																																																																						=
																																																																																						BgL_carzd233351zd2_5885;
																																																																																					BgL_argsz00_22521
																																																																																						=
																																																																																						BgL_cdrzd233331zd2_5874;
																																																																																					BgL_argsz00_1744
																																																																																						=
																																																																																						BgL_argsz00_22521;
																																																																																					BgL_proc2z00_1743
																																																																																						=
																																																																																						BgL_proc2z00_22520;
																																																																																					BgL_proc1z00_1742
																																																																																						=
																																																																																						BgL_proc1z00_22519;
																																																																																					BgL_testz00_1741
																																																																																						=
																																																																																						BgL_testz00_22518;
																																																																																					goto
																																																																																						BgL_tagzd2387zd2_1745;
																																																																																				}
																																																																																				BgL_auxz00_22040
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_22517);
																																																																																			}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			obj_t
																																																																																				BgL_cdrzd233376zd2_5902;
																																																																																			BgL_cdrzd233376zd2_5902
																																																																																				=
																																																																																				CDR
																																																																																				(
																																																																																				((obj_t) BgL_expz00_21));
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				obj_t
																																																																																					BgL_cdrzd233384zd2_5903;
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					obj_t
																																																																																						BgL_pairz00_11920;
																																																																																					BgL_pairz00_11920
																																																																																						=
																																																																																						CAR
																																																																																						(
																																																																																						((obj_t) BgL_expz00_21));
																																																																																					BgL_cdrzd233384zd2_5903
																																																																																						=
																																																																																						CDR
																																																																																						(BgL_pairz00_11920);
																																																																																				}
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					obj_t
																																																																																						BgL_cdrzd233392zd2_5904;
																																																																																					BgL_cdrzd233392zd2_5904
																																																																																						=
																																																																																						CDR
																																																																																						(
																																																																																						((obj_t) BgL_cdrzd233384zd2_5903));
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						obj_t
																																																																																							BgL_carzd233399zd2_5905;
																																																																																						BgL_carzd233399zd2_5905
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_cdrzd233392zd2_5904));
																																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd233399zd2_5905))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								obj_t
																																																																																									BgL_carzd233408zd2_5907;
																																																																																								{	/* Ast/sexp.scm 118 */
																																																																																									obj_t
																																																																																										BgL_pairz00_11924;
																																																																																									BgL_pairz00_11924
																																																																																										=
																																																																																										CDR
																																																																																										(
																																																																																										((obj_t) BgL_cdrzd233392zd2_5904));
																																																																																									BgL_carzd233408zd2_5907
																																																																																										=
																																																																																										CAR
																																																																																										(BgL_pairz00_11924);
																																																																																								}
																																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd233408zd2_5907))
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd233376zd2_5902))
																																																																																											{	/* Ast/sexp.scm 118 */
																																																																																												obj_t
																																																																																													BgL_arg4888z00_5910;
																																																																																												BgL_arg4888z00_5910
																																																																																													=
																																																																																													CAR
																																																																																													(
																																																																																													((obj_t) BgL_cdrzd233384zd2_5903));
																																																																																												{
																																																																																													BgL_nodez00_bglt
																																																																																														BgL_auxz00_22543;
																																																																																													{
																																																																																														obj_t
																																																																																															BgL_argsz00_22547;
																																																																																														obj_t
																																																																																															BgL_proc2z00_22546;
																																																																																														obj_t
																																																																																															BgL_proc1z00_22545;
																																																																																														obj_t
																																																																																															BgL_testz00_22544;
																																																																																														BgL_testz00_22544
																																																																																															=
																																																																																															BgL_arg4888z00_5910;
																																																																																														BgL_proc1z00_22545
																																																																																															=
																																																																																															BgL_carzd233399zd2_5905;
																																																																																														BgL_proc2z00_22546
																																																																																															=
																																																																																															BgL_carzd233408zd2_5907;
																																																																																														BgL_argsz00_22547
																																																																																															=
																																																																																															BgL_cdrzd233376zd2_5902;
																																																																																														BgL_argsz00_1749
																																																																																															=
																																																																																															BgL_argsz00_22547;
																																																																																														BgL_proc2z00_1748
																																																																																															=
																																																																																															BgL_proc2z00_22546;
																																																																																														BgL_proc1z00_1747
																																																																																															=
																																																																																															BgL_proc1z00_22545;
																																																																																														BgL_testz00_1746
																																																																																															=
																																																																																															BgL_testz00_22544;
																																																																																														goto
																																																																																															BgL_tagzd2388zd2_1750;
																																																																																													}
																																																																																													BgL_auxz00_22040
																																																																																														=
																																																																																														(
																																																																																														(obj_t)
																																																																																														BgL_auxz00_22543);
																																																																																												}
																																																																																											}
																																																																																										else
																																																																																											{	/* Ast/sexp.scm 118 */
																																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																													{	/* Ast/sexp.scm 118 */
																																																																																														goto
																																																																																															BgL_tagzd2403zd2_1774;
																																																																																													}
																																																																																												else
																																																																																													{
																																																																																														BgL_nodez00_bglt
																																																																																															BgL_auxz00_22551;
																																																																																														goto
																																																																																															BgL_tagzd2404zd2_1775;
																																																																																														BgL_auxz00_22040
																																																																																															=
																																																																																															(
																																																																																															(obj_t)
																																																																																															BgL_auxz00_22551);
																																																																																													}
																																																																																											}
																																																																																									}
																																																																																								else
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																											{	/* Ast/sexp.scm 118 */
																																																																																												goto
																																																																																													BgL_tagzd2403zd2_1774;
																																																																																											}
																																																																																										else
																																																																																											{
																																																																																												BgL_nodez00_bglt
																																																																																													BgL_auxz00_22555;
																																																																																												goto
																																																																																													BgL_tagzd2404zd2_1775;
																																																																																												BgL_auxz00_22040
																																																																																													=
																																																																																													(
																																																																																													(obj_t)
																																																																																													BgL_auxz00_22555);
																																																																																											}
																																																																																									}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1774;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_22559;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1775;
																																																																																										BgL_auxz00_22040
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_22559);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				}
																																																																																			}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1774;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_22563;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1775;
																																																																																			BgL_auxz00_22040
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_22563);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_cdrzd233686zd2_5929;
																																																																															BgL_cdrzd233686zd2_5929
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_cdrzd233693zd2_5930;
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_pairz00_11928;
																																																																																	BgL_pairz00_11928
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_expz00_21));
																																																																																	BgL_cdrzd233693zd2_5930
																																																																																		=
																																																																																		CDR
																																																																																		(BgL_pairz00_11928);
																																																																																}
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_cdrzd233700zd2_5931;
																																																																																	BgL_cdrzd233700zd2_5931
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd233693zd2_5930));
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		obj_t
																																																																																			BgL_carzd233706zd2_5932;
																																																																																		obj_t
																																																																																			BgL_cdrzd233707zd2_5933;
																																																																																		BgL_carzd233706zd2_5932
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd233700zd2_5931));
																																																																																		BgL_cdrzd233707zd2_5933
																																																																																			=
																																																																																			CDR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd233700zd2_5931));
																																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd233706zd2_5932))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				obj_t
																																																																																					BgL_carzd233714zd2_5935;
																																																																																				BgL_carzd233714zd2_5935
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd233707zd2_5933));
																																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd233714zd2_5935))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (NULLP(CDR(((obj_t) BgL_cdrzd233707zd2_5933))))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd233686zd2_5929))
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										obj_t
																																																																																											BgL_arg4903z00_5940;
																																																																																										BgL_arg4903z00_5940
																																																																																											=
																																																																																											CAR
																																																																																											(
																																																																																											((obj_t) BgL_cdrzd233693zd2_5930));
																																																																																										{
																																																																																											BgL_nodez00_bglt
																																																																																												BgL_auxz00_22590;
																																																																																											{
																																																																																												obj_t
																																																																																													BgL_argsz00_22594;
																																																																																												obj_t
																																																																																													BgL_proc2z00_22593;
																																																																																												obj_t
																																																																																													BgL_proc1z00_22592;
																																																																																												obj_t
																																																																																													BgL_testz00_22591;
																																																																																												BgL_testz00_22591
																																																																																													=
																																																																																													BgL_arg4903z00_5940;
																																																																																												BgL_proc1z00_22592
																																																																																													=
																																																																																													BgL_carzd233706zd2_5932;
																																																																																												BgL_proc2z00_22593
																																																																																													=
																																																																																													BgL_carzd233714zd2_5935;
																																																																																												BgL_argsz00_22594
																																																																																													=
																																																																																													BgL_cdrzd233686zd2_5929;
																																																																																												BgL_argsz00_1749
																																																																																													=
																																																																																													BgL_argsz00_22594;
																																																																																												BgL_proc2z00_1748
																																																																																													=
																																																																																													BgL_proc2z00_22593;
																																																																																												BgL_proc1z00_1747
																																																																																													=
																																																																																													BgL_proc1z00_22592;
																																																																																												BgL_testz00_1746
																																																																																													=
																																																																																													BgL_testz00_22591;
																																																																																												goto
																																																																																													BgL_tagzd2388zd2_1750;
																																																																																											}
																																																																																											BgL_auxz00_22040
																																																																																												=
																																																																																												(
																																																																																												(obj_t)
																																																																																												BgL_auxz00_22590);
																																																																																										}
																																																																																									}
																																																																																								else
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																											{	/* Ast/sexp.scm 118 */
																																																																																												goto
																																																																																													BgL_tagzd2403zd2_1774;
																																																																																											}
																																																																																										else
																																																																																											{
																																																																																												BgL_nodez00_bglt
																																																																																													BgL_auxz00_22598;
																																																																																												goto
																																																																																													BgL_tagzd2404zd2_1775;
																																																																																												BgL_auxz00_22040
																																																																																													=
																																																																																													(
																																																																																													(obj_t)
																																																																																													BgL_auxz00_22598);
																																																																																											}
																																																																																									}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1774;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_22602;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1775;
																																																																																										BgL_auxz00_22040
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_22602);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1774;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_22606;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1775;
																																																																																								BgL_auxz00_22040
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_22606);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1774;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_22610;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1775;
																																																																																						BgL_auxz00_22040
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_22610);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																}
																																																																															}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1774;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_22614;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1775;
																																																																															BgL_auxz00_22040
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_22614);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_cdrzd234047zd2_5948;
																																																																											BgL_cdrzd234047zd2_5948
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_cdrzd234053zd2_5949;
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_pairz00_11938;
																																																																													BgL_pairz00_11938
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													BgL_cdrzd234053zd2_5949
																																																																														=
																																																																														CDR
																																																																														(BgL_pairz00_11938);
																																																																												}
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_cdrzd234059zd2_5950;
																																																																													BgL_cdrzd234059zd2_5950
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd234053zd2_5949));
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_carzd234064zd2_5951;
																																																																														obj_t
																																																																															BgL_cdrzd234065zd2_5952;
																																																																														BgL_carzd234064zd2_5951
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd234059zd2_5950));
																																																																														BgL_cdrzd234065zd2_5952
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd234059zd2_5950));
																																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd234064zd2_5951))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (PAIRP(BgL_cdrzd234065zd2_5952))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		obj_t
																																																																																			BgL_carzd234070zd2_5955;
																																																																																		BgL_carzd234070zd2_5955
																																																																																			=
																																																																																			CAR
																																																																																			(BgL_cdrzd234065zd2_5952);
																																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd234070zd2_5955))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (NULLP(CDR(BgL_cdrzd234065zd2_5952)))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd234047zd2_5948))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								obj_t
																																																																																									BgL_arg4917z00_5960;
																																																																																								BgL_arg4917z00_5960
																																																																																									=
																																																																																									CAR
																																																																																									(
																																																																																									((obj_t) BgL_cdrzd234053zd2_5949));
																																																																																								{
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_auxz00_22641;
																																																																																									{
																																																																																										obj_t
																																																																																											BgL_argsz00_22645;
																																																																																										obj_t
																																																																																											BgL_proc2z00_22644;
																																																																																										obj_t
																																																																																											BgL_proc1z00_22643;
																																																																																										obj_t
																																																																																											BgL_testz00_22642;
																																																																																										BgL_testz00_22642
																																																																																											=
																																																																																											BgL_arg4917z00_5960;
																																																																																										BgL_proc1z00_22643
																																																																																											=
																																																																																											BgL_carzd234064zd2_5951;
																																																																																										BgL_proc2z00_22644
																																																																																											=
																																																																																											BgL_carzd234070zd2_5955;
																																																																																										BgL_argsz00_22645
																																																																																											=
																																																																																											BgL_cdrzd234047zd2_5948;
																																																																																										BgL_argsz00_1749
																																																																																											=
																																																																																											BgL_argsz00_22645;
																																																																																										BgL_proc2z00_1748
																																																																																											=
																																																																																											BgL_proc2z00_22644;
																																																																																										BgL_proc1z00_1747
																																																																																											=
																																																																																											BgL_proc1z00_22643;
																																																																																										BgL_testz00_1746
																																																																																											=
																																																																																											BgL_testz00_22642;
																																																																																										goto
																																																																																											BgL_tagzd2388zd2_1750;
																																																																																									}
																																																																																									BgL_auxz00_22040
																																																																																										=
																																																																																										(
																																																																																										(obj_t)
																																																																																										BgL_auxz00_22641);
																																																																																								}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1774;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_22649;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1775;
																																																																																										BgL_auxz00_22040
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_22649);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1774;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_22653;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1775;
																																																																																								BgL_auxz00_22040
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_22653);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1774;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_22657;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1775;
																																																																																						BgL_auxz00_22040
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_22657);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1774;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_22661;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1775;
																																																																																				BgL_auxz00_22040
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_22661);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1774;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_22665;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1775;
																																																																																		BgL_auxz00_22040
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_22665);
																																																																																	}
																																																																															}
																																																																													}
																																																																												}
																																																																											}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1774;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_22669;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1775;
																																																																											BgL_auxz00_22040
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_22669);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1774;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_22673;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1775;
																																																																									BgL_auxz00_22040
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_22673);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1774;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_22677;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1775;
																																																																							BgL_auxz00_22040
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_22677);
																																																																						}
																																																																				}
																																																																		}
																																																																	}
																																																															}
																																																														}
																																																												}
																																																										}
																																																									}
																																																							}
																																																					}
																																																			}
																																																	}
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_cdrzd234608zd2_6124;
																																															BgL_cdrzd234608zd2_6124
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															if ((BgL_carzd231543zd2_5847 == CNST_TABLE_REF(((long) 17))))
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_arg5033z00_6126;
																																																	obj_t
																																																		BgL_arg5034z00_6127;
																																																	BgL_arg5033z00_6126
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd234608zd2_6124));
																																																	BgL_arg5034z00_6127
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd234608zd2_6124));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_22688;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_22690;
																																																			obj_t
																																																				BgL_bindingsz00_22689;
																																																			BgL_bindingsz00_22689
																																																				=
																																																				BgL_arg5033z00_6126;
																																																			BgL_exprz00_22690
																																																				=
																																																				BgL_arg5034z00_6127;
																																																			BgL_exprz00_1729
																																																				=
																																																				BgL_exprz00_22690;
																																																			BgL_bindingsz00_1728
																																																				=
																																																				BgL_bindingsz00_22689;
																																																			goto
																																																				BgL_tagzd2382zd2_1730;
																																																		}
																																																		BgL_auxz00_22040
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_22688);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd231543zd2_5847)))
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_arg5036z00_6129;
																																																			obj_t
																																																				BgL_arg5037z00_6130;
																																																			BgL_arg5036z00_6129
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd234608zd2_6124));
																																																			BgL_arg5037z00_6130
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd234608zd2_6124));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_22699;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_22701;
																																																					obj_t
																																																						BgL_bindingsz00_22700;
																																																					BgL_bindingsz00_22700
																																																						=
																																																						BgL_arg5036z00_6129;
																																																					BgL_exprz00_22701
																																																						=
																																																						BgL_arg5037z00_6130;
																																																					BgL_exprz00_1729
																																																						=
																																																						BgL_exprz00_22701;
																																																					BgL_bindingsz00_1728
																																																						=
																																																						BgL_bindingsz00_22700;
																																																					goto
																																																						BgL_tagzd2382zd2_1730;
																																																				}
																																																				BgL_auxz00_22040
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_22699);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			if ((BgL_carzd231543zd2_5847 == CNST_TABLE_REF(((long) 18))))
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_arg5039z00_6132;
																																																					obj_t
																																																						BgL_arg5040z00_6133;
																																																					BgL_arg5039z00_6132
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd234608zd2_6124));
																																																					BgL_arg5040z00_6133
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd234608zd2_6124));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_22710;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_22712;
																																																							obj_t
																																																								BgL_bindingsz00_22711;
																																																							BgL_bindingsz00_22711
																																																								=
																																																								BgL_arg5039z00_6132;
																																																							BgL_exprz00_22712
																																																								=
																																																								BgL_arg5040z00_6133;
																																																							BgL_exprz00_1729
																																																								=
																																																								BgL_exprz00_22712;
																																																							BgL_bindingsz00_1728
																																																								=
																																																								BgL_bindingsz00_22711;
																																																							goto
																																																								BgL_tagzd2382zd2_1730;
																																																						}
																																																						BgL_auxz00_22040
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_22710);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_22719;
																																																							goto
																																																								BgL_tagzd2383zd2_1731;
																																																							BgL_auxz00_22040
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_22719);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_carzd234645zd2_6136;
																																																							BgL_carzd234645zd2_6136
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							if ((BgL_carzd234645zd2_6136 == CNST_TABLE_REF(((long) 19))))
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_22726;
																																																									goto
																																																										BgL_tagzd2384zd2_1732;
																																																									BgL_auxz00_22040
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_22726);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd234645zd2_6136)))
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_22731;
																																																											goto
																																																												BgL_tagzd2384zd2_1732;
																																																											BgL_auxz00_22040
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_22731);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_22738;
																																																													goto
																																																														BgL_tagzd2389zd2_1751;
																																																													BgL_auxz00_22040
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_22738);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_22745;
																																																															goto
																																																																BgL_tagzd2390zd2_1752;
																																																															BgL_auxz00_22040
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_22745);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_cdrzd234725zd2_6143;
																																																															BgL_cdrzd234725zd2_6143
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_arg5051z00_6146;
																																																																	obj_t
																																																																		BgL_arg5052z00_6147;
																																																																	BgL_arg5051z00_6146
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd234725zd2_6143));
																																																																	BgL_arg5052z00_6147
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd234725zd2_6143));
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_22758;
																																																																		{
																																																																			obj_t
																																																																				BgL_restz00_22760;
																																																																			obj_t
																																																																				BgL_effectz00_22759;
																																																																			BgL_effectz00_22759
																																																																				=
																																																																				BgL_arg5051z00_6146;
																																																																			BgL_restz00_22760
																																																																				=
																																																																				BgL_arg5052z00_6147;
																																																																			BgL_restz00_1754
																																																																				=
																																																																				BgL_restz00_22760;
																																																																			BgL_effectz00_1753
																																																																				=
																																																																				BgL_effectz00_22759;
																																																																			goto
																																																																				BgL_tagzd2391zd2_1755;
																																																																		}
																																																																		BgL_auxz00_22040
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_22758);
																																																																	}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_22767;
																																																																			goto
																																																																				BgL_tagzd2392zd2_1756;
																																																																			BgL_auxz00_22040
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_22767);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_22774;
																																																																					goto
																																																																						BgL_tagzd2393zd2_1757;
																																																																					BgL_auxz00_22040
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_22774);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_arg5059z00_6155;
																																																																							obj_t
																																																																								BgL_arg5060z00_6156;
																																																																							BgL_arg5059z00_6155
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd234725zd2_6143));
																																																																							BgL_arg5060z00_6156
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd234725zd2_6143));
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_22785;
																																																																								{
																																																																									obj_t
																																																																										BgL_restz00_22787;
																																																																									obj_t
																																																																										BgL_effectz00_22786;
																																																																									BgL_effectz00_22786
																																																																										=
																																																																										BgL_arg5059z00_6155;
																																																																									BgL_restz00_22787
																																																																										=
																																																																										BgL_arg5060z00_6156;
																																																																									BgL_restz00_1759
																																																																										=
																																																																										BgL_restz00_22787;
																																																																									BgL_effectz00_1758
																																																																										=
																																																																										BgL_effectz00_22786;
																																																																									goto
																																																																										BgL_tagzd2394zd2_1760;
																																																																								}
																																																																								BgL_auxz00_22040
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_22785);
																																																																							}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_22794;
																																																																									goto
																																																																										BgL_tagzd2395zd2_1761;
																																																																									BgL_auxz00_22040
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_22794);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_22801;
																																																																											goto
																																																																												BgL_tagzd2396zd2_1762;
																																																																											BgL_auxz00_22040
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_22801);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																												{
																																																																													BgL_letzd2funzd2_bglt
																																																																														BgL_auxz00_22808;
																																																																													goto
																																																																														BgL_tagzd2397zd2_1763;
																																																																													BgL_auxz00_22040
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_22808);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																														{
																																																																															BgL_jumpzd2exzd2itz00_bglt
																																																																																BgL_auxz00_22815;
																																																																															goto
																																																																																BgL_tagzd2398zd2_1764;
																																																																															BgL_auxz00_22040
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_22815);
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_cdrzd234802zd2_6165;
																																																																															BgL_cdrzd234802zd2_6165
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_arg5071z00_6168;
																																																																																	obj_t
																																																																																		BgL_arg5072z00_6169;
																																																																																	BgL_arg5071z00_6168
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd234802zd2_6165));
																																																																																	BgL_arg5072z00_6169
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd234802zd2_6165));
																																																																																	{	/* Ast/sexp.scm 551 */
																																																																																		obj_t
																																																																																			BgL_arg6989z00_11977;
																																																																																		BgL_arg6989z00_11977
																																																																																			=
																																																																																			BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																			(BgL_expz00_21,
																																																																																			BgL_locz00_23);
																																																																																		BgL_auxz00_22040
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																			(BgL_expz00_21,
																																																																																				BgL_arg5071z00_6168,
																																																																																				CNST_TABLE_REF
																																																																																				(((long) 4)), BgL_arg5072z00_6169, BgL_stackz00_22, BgL_arg6989z00_11977, BgL_sitez00_24));
																																																																																}}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1774;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_22834;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1775;
																																																																																			BgL_auxz00_22040
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_22834);
																																																																																		}
																																																																																}
																																																																														}
																																																																												}
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																	else
																																		{	/* Ast/sexp.scm 118 */
																																			obj_t
																																				BgL_carzd234827zd2_6186;
																																			BgL_carzd234827zd2_6186
																																				=
																																				CAR((
																																					(obj_t)
																																					BgL_expz00_21));
																																			if (
																																				(BgL_carzd234827zd2_6186
																																					==
																																					CNST_TABLE_REF
																																					(((long) 1))))
																																				{
																																					BgL_nodez00_bglt
																																						BgL_auxz00_22841;
																																					goto
																																						BgL_tagzd2377zd2_1719;
																																					BgL_auxz00_22040
																																						=
																																						(
																																						(obj_t)
																																						BgL_auxz00_22841);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 118 */
																																					if (
																																						(BgL_carzd234827zd2_6186
																																							==
																																							BGl_za2ifza2z00zzast_sexpz00))
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_22845;
																																							goto
																																								BgL_tagzd2377zd2_1719;
																																							BgL_auxz00_22040
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_22845);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 118 */
																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 7))))
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_22852;
																																									goto
																																										BgL_tagzd2379zd2_1723;
																																									BgL_auxz00_22040
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_22852);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 118 */
																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_22859;
																																											goto
																																												BgL_tagzd2380zd2_1724;
																																											BgL_auxz00_22040
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_22859);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 118 */
																																											obj_t
																																												BgL_carzd234896zd2_6193;
																																											BgL_carzd234896zd2_6193
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_expz00_21));
																																											if (PAIRP(BgL_carzd234896zd2_6193))
																																												{	/* Ast/sexp.scm 118 */
																																													obj_t
																																														BgL_carzd234899zd2_6195;
																																													obj_t
																																														BgL_cdrzd234900zd2_6196;
																																													BgL_carzd234899zd2_6195
																																														=
																																														CAR
																																														(BgL_carzd234896zd2_6193);
																																													BgL_cdrzd234900zd2_6196
																																														=
																																														CDR
																																														(BgL_carzd234896zd2_6193);
																																													{

																																														if ((BgL_carzd234899zd2_6195 == CNST_TABLE_REF(((long) 17))))
																																															{	/* Ast/sexp.scm 118 */
																																															BgL_kapzd234901zd2_6197:
																																																if (PAIRP(BgL_cdrzd234900zd2_6196))
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_cdrzd234904zd2_6322;
																																																		BgL_cdrzd234904zd2_6322
																																																			=
																																																			CDR
																																																			(BgL_cdrzd234900zd2_6196);
																																																		if (PAIRP(BgL_cdrzd234904zd2_6322))
																																																			{	/* Ast/sexp.scm 118 */
																																																				if (NULLP(CDR(BgL_cdrzd234904zd2_6322)))
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_arg5179z00_6326;
																																																						obj_t
																																																							BgL_arg5180z00_6327;
																																																						BgL_arg5179z00_6326
																																																							=
																																																							CAR
																																																							(BgL_cdrzd234904zd2_6322);
																																																						BgL_arg5180z00_6327
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_22881;
																																																							{
																																																								obj_t
																																																									BgL_argsz00_22883;
																																																								obj_t
																																																									BgL_bodyz00_22882;
																																																								BgL_bodyz00_22882
																																																									=
																																																									BgL_arg5179z00_6326;
																																																								BgL_argsz00_22883
																																																									=
																																																									BgL_arg5180z00_6327;
																																																								BgL_argsz00_1726
																																																									=
																																																									BgL_argsz00_22883;
																																																								BgL_bodyz00_1725
																																																									=
																																																									BgL_bodyz00_22882;
																																																								goto
																																																									BgL_tagzd2381zd2_1727;
																																																							}
																																																							BgL_auxz00_22040
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_22881);
																																																						}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_cdrzd234928zd2_6328;
																																																						BgL_cdrzd234928zd2_6328
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{	/* Ast/sexp.scm 118 */
																																																							bool_t
																																																								BgL_test9478z00_22887;
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_arg5249z00_6439;
																																																								BgL_arg5249z00_6439
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test9478z00_22887
																																																									=
																																																									CBOOL
																																																									(BGl_letzd2symzf3z21zzast_letz00
																																																									(BgL_arg5249z00_6439));
																																																							}
																																																							if (BgL_test9478z00_22887)
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_arg5183z00_6331;
																																																									obj_t
																																																										BgL_arg5184z00_6332;
																																																									BgL_arg5183z00_6331
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd234928zd2_6328));
																																																									BgL_arg5184z00_6332
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd234928zd2_6328));
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_22896;
																																																										{
																																																											obj_t
																																																												BgL_exprz00_22898;
																																																											obj_t
																																																												BgL_bindingsz00_22897;
																																																											BgL_bindingsz00_22897
																																																												=
																																																												BgL_arg5183z00_6331;
																																																											BgL_exprz00_22898
																																																												=
																																																												BgL_arg5184z00_6332;
																																																											BgL_exprz00_1729
																																																												=
																																																												BgL_exprz00_22898;
																																																											BgL_bindingsz00_1728
																																																												=
																																																												BgL_bindingsz00_22897;
																																																											goto
																																																												BgL_tagzd2382zd2_1730;
																																																										}
																																																										BgL_auxz00_22040
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_22896);
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									bool_t
																																																										BgL_test9479z00_22900;
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_arg5248z00_6438;
																																																										BgL_arg5248z00_6438
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_test9479z00_22900
																																																											=
																																																											CBOOL
																																																											(BGl_labelszd2symzf3z21zzast_labelsz00
																																																											(BgL_arg5248z00_6438));
																																																									}
																																																									if (BgL_test9479z00_22900)
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_22905;
																																																											goto
																																																												BgL_tagzd2384zd2_1732;
																																																											BgL_auxz00_22040
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_22905);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_carzd234995zd2_6335;
																																																											BgL_carzd234995zd2_6335
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_cdrzd235000zd2_6336;
																																																												BgL_cdrzd235000zd2_6336
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_carzd234995zd2_6335));
																																																												if ((CAR(((obj_t) BgL_carzd234995zd2_6335)) == CNST_TABLE_REF(((long) 3))))
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_arg5189z00_6339;
																																																														obj_t
																																																															BgL_arg5190z00_6340;
																																																														obj_t
																																																															BgL_arg5191z00_6341;
																																																														BgL_arg5189z00_6339
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd235000zd2_6336));
																																																														BgL_arg5190z00_6340
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd235000zd2_6336));
																																																														BgL_arg5191z00_6341
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_22922;
																																																															{
																																																																obj_t
																																																																	BgL_argsz00_22925;
																																																																obj_t
																																																																	BgL_bodyz00_22924;
																																																																obj_t
																																																																	BgL_varsz00_22923;
																																																																BgL_varsz00_22923
																																																																	=
																																																																	BgL_arg5189z00_6339;
																																																																BgL_bodyz00_22924
																																																																	=
																																																																	BgL_arg5190z00_6340;
																																																																BgL_argsz00_22925
																																																																	=
																																																																	BgL_arg5191z00_6341;
																																																																BgL_argsz00_1739
																																																																	=
																																																																	BgL_argsz00_22925;
																																																																BgL_bodyz00_1738
																																																																	=
																																																																	BgL_bodyz00_22924;
																																																																BgL_varsz00_1737
																																																																	=
																																																																	BgL_varsz00_22923;
																																																																goto
																																																																	BgL_tagzd2386zd2_1740;
																																																															}
																																																															BgL_auxz00_22040
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_22922);
																																																														}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_cdrzd235023zd2_6343;
																																																														BgL_cdrzd235023zd2_6343
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_cdrzd235029zd2_6344;
																																																															BgL_cdrzd235029zd2_6344
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_carzd234995zd2_6335));
																																																															if ((CAR(((obj_t) BgL_carzd234995zd2_6335)) == CNST_TABLE_REF(((long) 1))))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd235035zd2_6347;
																																																																	BgL_cdrzd235035zd2_6347
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd235029zd2_6344));
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_carzd235040zd2_6348;
																																																																		obj_t
																																																																			BgL_cdrzd235041zd2_6349;
																																																																		BgL_carzd235040zd2_6348
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd235035zd2_6347));
																																																																		BgL_cdrzd235041zd2_6349
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd235035zd2_6347));
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd235040zd2_6348))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (PAIRP(BgL_cdrzd235041zd2_6349))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_carzd235048zd2_6352;
																																																																						BgL_carzd235048zd2_6352
																																																																							=
																																																																							CAR
																																																																							(BgL_cdrzd235041zd2_6349);
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd235048zd2_6352))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (NULLP(CDR(BgL_cdrzd235041zd2_6349)))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										bool_t
																																																																											BgL_test9486z00_22952;
																																																																										{
																																																																											obj_t
																																																																												BgL_l1424z00_6385;
																																																																											BgL_l1424z00_6385
																																																																												=
																																																																												BgL_cdrzd235023zd2_6343;
																																																																										BgL_zc3z04anonymousza35214ze3z87_6386:
																																																																											if (NULLP(BgL_l1424z00_6385))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													BgL_test9486z00_22952
																																																																														=
																																																																														(
																																																																														(bool_t)
																																																																														1);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													bool_t
																																																																														BgL_test9488z00_22955;
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														bool_t
																																																																															BgL_test9489z00_22956;
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_tmpz00_22957;
																																																																															BgL_tmpz00_22957
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_l1424z00_6385));
																																																																															BgL_test9489z00_22956
																																																																																=
																																																																																PAIRP
																																																																																(BgL_tmpz00_22957);
																																																																														}
																																																																														if (BgL_test9489z00_22956)
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																BgL_test9488z00_22955
																																																																																	=
																																																																																	(
																																																																																	(bool_t)
																																																																																	0);
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																BgL_test9488z00_22955
																																																																																	=
																																																																																	(
																																																																																	(bool_t)
																																																																																	1);
																																																																															}
																																																																													}
																																																																													if (BgL_test9488z00_22955)
																																																																														{
																																																																															obj_t
																																																																																BgL_l1424z00_22961;
																																																																															BgL_l1424z00_22961
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_l1424z00_6385));
																																																																															BgL_l1424z00_6385
																																																																																=
																																																																																BgL_l1424z00_22961;
																																																																															goto
																																																																																BgL_zc3z04anonymousza35214ze3z87_6386;
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															BgL_test9486z00_22952
																																																																																=
																																																																																(
																																																																																(bool_t)
																																																																																0);
																																																																														}
																																																																												}
																																																																										}
																																																																										if (BgL_test9486z00_22952)
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_arg5204z00_6368;
																																																																												BgL_arg5204z00_6368
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd235029zd2_6344));
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_22966;
																																																																													{
																																																																														obj_t
																																																																															BgL_argsz00_22970;
																																																																														obj_t
																																																																															BgL_proc2z00_22969;
																																																																														obj_t
																																																																															BgL_proc1z00_22968;
																																																																														obj_t
																																																																															BgL_testz00_22967;
																																																																														BgL_testz00_22967
																																																																															=
																																																																															BgL_arg5204z00_6368;
																																																																														BgL_proc1z00_22968
																																																																															=
																																																																															BgL_carzd235040zd2_6348;
																																																																														BgL_proc2z00_22969
																																																																															=
																																																																															BgL_carzd235048zd2_6352;
																																																																														BgL_argsz00_22970
																																																																															=
																																																																															BgL_cdrzd235023zd2_6343;
																																																																														BgL_argsz00_1744
																																																																															=
																																																																															BgL_argsz00_22970;
																																																																														BgL_proc2z00_1743
																																																																															=
																																																																															BgL_proc2z00_22969;
																																																																														BgL_proc1z00_1742
																																																																															=
																																																																															BgL_proc1z00_22968;
																																																																														BgL_testz00_1741
																																																																															=
																																																																															BgL_testz00_22967;
																																																																														goto
																																																																															BgL_tagzd2387zd2_1745;
																																																																													}
																																																																													BgL_auxz00_22040
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_22966);
																																																																												}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_cdrzd235072zd2_6369;
																																																																												BgL_cdrzd235072zd2_6369
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_expz00_21));
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_cdrzd235079zd2_6370;
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_pairz00_12021;
																																																																														BgL_pairz00_12021
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_expz00_21));
																																																																														BgL_cdrzd235079zd2_6370
																																																																															=
																																																																															CDR
																																																																															(BgL_pairz00_12021);
																																																																													}
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_cdrzd235086zd2_6371;
																																																																														BgL_cdrzd235086zd2_6371
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd235079zd2_6370));
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_carzd235092zd2_6372;
																																																																															BgL_carzd235092zd2_6372
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd235086zd2_6371));
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd235092zd2_6372))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_carzd235099zd2_6374;
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		obj_t
																																																																																			BgL_pairz00_12025;
																																																																																		BgL_pairz00_12025
																																																																																			=
																																																																																			CDR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd235086zd2_6371));
																																																																																		BgL_carzd235099zd2_6374
																																																																																			=
																																																																																			CAR
																																																																																			(BgL_pairz00_12025);
																																																																																	}
																																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd235099zd2_6374))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd235072zd2_6369))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					obj_t
																																																																																						BgL_arg5208z00_6377;
																																																																																					BgL_arg5208z00_6377
																																																																																						=
																																																																																						CAR
																																																																																						(
																																																																																						((obj_t) BgL_cdrzd235079zd2_6370));
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_22992;
																																																																																						{
																																																																																							obj_t
																																																																																								BgL_argsz00_22996;
																																																																																							obj_t
																																																																																								BgL_proc2z00_22995;
																																																																																							obj_t
																																																																																								BgL_proc1z00_22994;
																																																																																							obj_t
																																																																																								BgL_testz00_22993;
																																																																																							BgL_testz00_22993
																																																																																								=
																																																																																								BgL_arg5208z00_6377;
																																																																																							BgL_proc1z00_22994
																																																																																								=
																																																																																								BgL_carzd235092zd2_6372;
																																																																																							BgL_proc2z00_22995
																																																																																								=
																																																																																								BgL_carzd235099zd2_6374;
																																																																																							BgL_argsz00_22996
																																																																																								=
																																																																																								BgL_cdrzd235072zd2_6369;
																																																																																							BgL_argsz00_1749
																																																																																								=
																																																																																								BgL_argsz00_22996;
																																																																																							BgL_proc2z00_1748
																																																																																								=
																																																																																								BgL_proc2z00_22995;
																																																																																							BgL_proc1z00_1747
																																																																																								=
																																																																																								BgL_proc1z00_22994;
																																																																																							BgL_testz00_1746
																																																																																								=
																																																																																								BgL_testz00_22993;
																																																																																							goto
																																																																																								BgL_tagzd2388zd2_1750;
																																																																																						}
																																																																																						BgL_auxz00_22040
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_22992);
																																																																																					}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							goto
																																																																																								BgL_tagzd2403zd2_1774;
																																																																																						}
																																																																																					else
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_23000;
																																																																																							goto
																																																																																								BgL_tagzd2404zd2_1775;
																																																																																							BgL_auxz00_22040
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_23000);
																																																																																						}
																																																																																				}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1774;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_23004;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1775;
																																																																																					BgL_auxz00_22040
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_23004);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1774;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_23008;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1775;
																																																																																			BgL_auxz00_22040
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_23008);
																																																																																		}
																																																																																}
																																																																														}
																																																																													}
																																																																												}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1774;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_23012;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1775;
																																																																												BgL_auxz00_22040
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_23012);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_cdrzd235375zd2_6396;
																																																																								BgL_cdrzd235375zd2_6396
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_cdrzd235381zd2_6397;
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_pairz00_12029;
																																																																										BgL_pairz00_12029
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										BgL_cdrzd235381zd2_6397
																																																																											=
																																																																											CDR
																																																																											(BgL_pairz00_12029);
																																																																									}
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_cdrzd235387zd2_6398;
																																																																										BgL_cdrzd235387zd2_6398
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd235381zd2_6397));
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_carzd235392zd2_6399;
																																																																											obj_t
																																																																												BgL_cdrzd235393zd2_6400;
																																																																											BgL_carzd235392zd2_6399
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd235387zd2_6398));
																																																																											BgL_cdrzd235393zd2_6400
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd235387zd2_6398));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd235392zd2_6399))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_carzd235398zd2_6402;
																																																																													BgL_carzd235398zd2_6402
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd235393zd2_6400));
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd235398zd2_6402))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (NULLP(CDR(((obj_t) BgL_cdrzd235393zd2_6400))))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd235375zd2_6396))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			obj_t
																																																																																				BgL_arg5223z00_6407;
																																																																																			BgL_arg5223z00_6407
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd235381zd2_6397));
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_23039;
																																																																																				{
																																																																																					obj_t
																																																																																						BgL_argsz00_23043;
																																																																																					obj_t
																																																																																						BgL_proc2z00_23042;
																																																																																					obj_t
																																																																																						BgL_proc1z00_23041;
																																																																																					obj_t
																																																																																						BgL_testz00_23040;
																																																																																					BgL_testz00_23040
																																																																																						=
																																																																																						BgL_arg5223z00_6407;
																																																																																					BgL_proc1z00_23041
																																																																																						=
																																																																																						BgL_carzd235392zd2_6399;
																																																																																					BgL_proc2z00_23042
																																																																																						=
																																																																																						BgL_carzd235398zd2_6402;
																																																																																					BgL_argsz00_23043
																																																																																						=
																																																																																						BgL_cdrzd235375zd2_6396;
																																																																																					BgL_argsz00_1749
																																																																																						=
																																																																																						BgL_argsz00_23043;
																																																																																					BgL_proc2z00_1748
																																																																																						=
																																																																																						BgL_proc2z00_23042;
																																																																																					BgL_proc1z00_1747
																																																																																						=
																																																																																						BgL_proc1z00_23041;
																																																																																					BgL_testz00_1746
																																																																																						=
																																																																																						BgL_testz00_23040;
																																																																																					goto
																																																																																						BgL_tagzd2388zd2_1750;
																																																																																				}
																																																																																				BgL_auxz00_22040
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_23039);
																																																																																			}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1774;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_23047;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1775;
																																																																																					BgL_auxz00_22040
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_23047);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1774;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_23051;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1775;
																																																																																			BgL_auxz00_22040
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_23051);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1774;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_23055;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1775;
																																																																																	BgL_auxz00_22040
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_23055);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1774;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_23059;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1775;
																																																																															BgL_auxz00_22040
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_23059);
																																																																														}
																																																																												}
																																																																										}
																																																																									}
																																																																								}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1774;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_23063;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1775;
																																																																								BgL_auxz00_22040
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_23063);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_cdrzd235731zd2_6415;
																																																																				BgL_cdrzd235731zd2_6415
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_cdrzd235738zd2_6416;
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_pairz00_12039;
																																																																						BgL_pairz00_12039
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						BgL_cdrzd235738zd2_6416
																																																																							=
																																																																							CDR
																																																																							(BgL_pairz00_12039);
																																																																					}
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_cdrzd235745zd2_6417;
																																																																						BgL_cdrzd235745zd2_6417
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd235738zd2_6416));
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_carzd235751zd2_6418;
																																																																							obj_t
																																																																								BgL_cdrzd235752zd2_6419;
																																																																							BgL_carzd235751zd2_6418
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd235745zd2_6417));
																																																																							BgL_cdrzd235752zd2_6419
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd235745zd2_6417));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd235751zd2_6418))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (PAIRP(BgL_cdrzd235752zd2_6419))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_carzd235759zd2_6422;
																																																																											BgL_carzd235759zd2_6422
																																																																												=
																																																																												CAR
																																																																												(BgL_cdrzd235752zd2_6419);
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd235759zd2_6422))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (NULLP(CDR(BgL_cdrzd235752zd2_6419)))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd235731zd2_6415))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_arg5237z00_6427;
																																																																																	BgL_arg5237z00_6427
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd235738zd2_6416));
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_23090;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_23094;
																																																																																			obj_t
																																																																																				BgL_proc2z00_23093;
																																																																																			obj_t
																																																																																				BgL_proc1z00_23092;
																																																																																			obj_t
																																																																																				BgL_testz00_23091;
																																																																																			BgL_testz00_23091
																																																																																				=
																																																																																				BgL_arg5237z00_6427;
																																																																																			BgL_proc1z00_23092
																																																																																				=
																																																																																				BgL_carzd235751zd2_6418;
																																																																																			BgL_proc2z00_23093
																																																																																				=
																																																																																				BgL_carzd235759zd2_6422;
																																																																																			BgL_argsz00_23094
																																																																																				=
																																																																																				BgL_cdrzd235731zd2_6415;
																																																																																			BgL_argsz00_1749
																																																																																				=
																																																																																				BgL_argsz00_23094;
																																																																																			BgL_proc2z00_1748
																																																																																				=
																																																																																				BgL_proc2z00_23093;
																																																																																			BgL_proc1z00_1747
																																																																																				=
																																																																																				BgL_proc1z00_23092;
																																																																																			BgL_testz00_1746
																																																																																				=
																																																																																				BgL_testz00_23091;
																																																																																			goto
																																																																																				BgL_tagzd2388zd2_1750;
																																																																																		}
																																																																																		BgL_auxz00_22040
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_23090);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1774;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_23098;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1775;
																																																																																			BgL_auxz00_22040
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_23098);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1774;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_23102;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1775;
																																																																																	BgL_auxz00_22040
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_23102);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1774;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_23106;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1775;
																																																																															BgL_auxz00_22040
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_23106);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1774;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_23110;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1775;
																																																																													BgL_auxz00_22040
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_23110);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1774;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_23114;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1775;
																																																																											BgL_auxz00_22040
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_23114);
																																																																										}
																																																																								}
																																																																						}
																																																																					}
																																																																				}
																																																																			}
																																																																	}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1774;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_23118;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1775;
																																																																			BgL_auxz00_22040
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_23118);
																																																																		}
																																																																}
																																																														}
																																																													}
																																																											}
																																																										}
																																																								}
																																																						}
																																																					}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_cdrzd236152zd2_6441;
																																																				BgL_cdrzd236152zd2_6441
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{	/* Ast/sexp.scm 118 */
																																																					bool_t
																																																						BgL_test9517z00_23122;
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_arg5265z00_6458;
																																																						BgL_arg5265z00_6458
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test9517z00_23122
																																																							=
																																																							CBOOL
																																																							(BGl_letzd2symzf3z21zzast_letz00
																																																							(BgL_arg5265z00_6458));
																																																					}
																																																					if (BgL_test9517z00_23122)
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_arg5253z00_6444;
																																																							obj_t
																																																								BgL_arg5254z00_6445;
																																																							BgL_arg5253z00_6444
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd236152zd2_6441));
																																																							BgL_arg5254z00_6445
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd236152zd2_6441));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_23131;
																																																								{
																																																									obj_t
																																																										BgL_exprz00_23133;
																																																									obj_t
																																																										BgL_bindingsz00_23132;
																																																									BgL_bindingsz00_23132
																																																										=
																																																										BgL_arg5253z00_6444;
																																																									BgL_exprz00_23133
																																																										=
																																																										BgL_arg5254z00_6445;
																																																									BgL_exprz00_1729
																																																										=
																																																										BgL_exprz00_23133;
																																																									BgL_bindingsz00_1728
																																																										=
																																																										BgL_bindingsz00_23132;
																																																									goto
																																																										BgL_tagzd2382zd2_1730;
																																																								}
																																																								BgL_auxz00_22040
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_23131);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							bool_t
																																																								BgL_test9518z00_23135;
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_arg5264z00_6457;
																																																								BgL_arg5264z00_6457
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test9518z00_23135
																																																									=
																																																									CBOOL
																																																									(BGl_labelszd2symzf3z21zzast_labelsz00
																																																									(BgL_arg5264z00_6457));
																																																							}
																																																							if (BgL_test9518z00_23135)
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_23140;
																																																									goto
																																																										BgL_tagzd2384zd2_1732;
																																																									BgL_auxz00_22040
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_23140);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_carzd236218zd2_6448;
																																																									BgL_carzd236218zd2_6448
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_cdrzd236223zd2_6449;
																																																										BgL_cdrzd236223zd2_6449
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_carzd236218zd2_6448));
																																																										if ((CAR(((obj_t) BgL_carzd236218zd2_6448)) == CNST_TABLE_REF(((long) 3))))
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_arg5259z00_6452;
																																																												obj_t
																																																													BgL_arg5260z00_6453;
																																																												obj_t
																																																													BgL_arg5261z00_6454;
																																																												BgL_arg5259z00_6452
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_cdrzd236223zd2_6449));
																																																												BgL_arg5260z00_6453
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_cdrzd236223zd2_6449));
																																																												BgL_arg5261z00_6454
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_23157;
																																																													{
																																																														obj_t
																																																															BgL_argsz00_23160;
																																																														obj_t
																																																															BgL_bodyz00_23159;
																																																														obj_t
																																																															BgL_varsz00_23158;
																																																														BgL_varsz00_23158
																																																															=
																																																															BgL_arg5259z00_6452;
																																																														BgL_bodyz00_23159
																																																															=
																																																															BgL_arg5260z00_6453;
																																																														BgL_argsz00_23160
																																																															=
																																																															BgL_arg5261z00_6454;
																																																														BgL_argsz00_1739
																																																															=
																																																															BgL_argsz00_23160;
																																																														BgL_bodyz00_1738
																																																															=
																																																															BgL_bodyz00_23159;
																																																														BgL_varsz00_1737
																																																															=
																																																															BgL_varsz00_23158;
																																																														goto
																																																															BgL_tagzd2386zd2_1740;
																																																													}
																																																													BgL_auxz00_22040
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_23157);
																																																												}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 118 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{	/* Ast/sexp.scm 118 */
																																																														goto
																																																															BgL_tagzd2403zd2_1774;
																																																													}
																																																												else
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_23164;
																																																														goto
																																																															BgL_tagzd2404zd2_1775;
																																																														BgL_auxz00_22040
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_23164);
																																																													}
																																																											}
																																																									}
																																																								}
																																																						}
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_cdrzd236334zd2_6459;
																																																		BgL_cdrzd236334zd2_6459
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 118 */
																																																			bool_t
																																																				BgL_test9521z00_23168;
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_arg5274z00_6468;
																																																				BgL_arg5274z00_6468
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test9521z00_23168
																																																					=
																																																					CBOOL
																																																					(BGl_letzd2symzf3z21zzast_letz00
																																																					(BgL_arg5274z00_6468));
																																																			}
																																																			if (BgL_test9521z00_23168)
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_arg5268z00_6462;
																																																					obj_t
																																																						BgL_arg5269z00_6463;
																																																					BgL_arg5268z00_6462
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd236334zd2_6459));
																																																					BgL_arg5269z00_6463
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd236334zd2_6459));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_23177;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_23179;
																																																							obj_t
																																																								BgL_bindingsz00_23178;
																																																							BgL_bindingsz00_23178
																																																								=
																																																								BgL_arg5268z00_6462;
																																																							BgL_exprz00_23179
																																																								=
																																																								BgL_arg5269z00_6463;
																																																							BgL_exprz00_1729
																																																								=
																																																								BgL_exprz00_23179;
																																																							BgL_bindingsz00_1728
																																																								=
																																																								BgL_bindingsz00_23178;
																																																							goto
																																																								BgL_tagzd2382zd2_1730;
																																																						}
																																																						BgL_auxz00_22040
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_23177);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					bool_t
																																																						BgL_test9522z00_23181;
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_arg5273z00_6467;
																																																						BgL_arg5273z00_6467
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test9522z00_23181
																																																							=
																																																							CBOOL
																																																							(BGl_labelszd2symzf3z21zzast_labelsz00
																																																							(BgL_arg5273z00_6467));
																																																					}
																																																					if (BgL_test9522z00_23181)
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_23186;
																																																							goto
																																																								BgL_tagzd2384zd2_1732;
																																																							BgL_auxz00_22040
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_23186);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																								{	/* Ast/sexp.scm 118 */
																																																									goto
																																																										BgL_tagzd2403zd2_1774;
																																																								}
																																																							else
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_23190;
																																																									goto
																																																										BgL_tagzd2404zd2_1775;
																																																									BgL_auxz00_22040
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_23190);
																																																								}
																																																						}
																																																				}
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd234899zd2_6195)))
																																																	{	/* Ast/sexp.scm 118 */
																																																		goto
																																																			BgL_kapzd234901zd2_6197;
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		if ((BgL_carzd234899zd2_6195 == CNST_TABLE_REF(((long) 18))))
																																																			{	/* Ast/sexp.scm 118 */
																																																				goto
																																																					BgL_kapzd234901zd2_6197;
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 118 */
																																																				if ((BgL_carzd234899zd2_6195 == CNST_TABLE_REF(((long) 19))))
																																																					{	/* Ast/sexp.scm 118 */
																																																						goto
																																																							BgL_kapzd234901zd2_6197;
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 118 */
																																																						if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd234899zd2_6195)))
																																																							{	/* Ast/sexp.scm 118 */
																																																								goto
																																																									BgL_kapzd234901zd2_6197;
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_cdrzd236506zd2_6203;
																																																								BgL_cdrzd236506zd2_6203
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{	/* Ast/sexp.scm 118 */
																																																									bool_t
																																																										BgL_test9528z00_23206;
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_arg5174z00_6320;
																																																										BgL_arg5174z00_6320
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_test9528z00_23206
																																																											=
																																																											CBOOL
																																																											(BGl_letzd2symzf3z21zzast_letz00
																																																											(BgL_arg5174z00_6320));
																																																									}
																																																									if (BgL_test9528z00_23206)
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_arg5102z00_6206;
																																																											obj_t
																																																												BgL_arg5103z00_6207;
																																																											BgL_arg5102z00_6206
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_cdrzd236506zd2_6203));
																																																											BgL_arg5103z00_6207
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd236506zd2_6203));
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_23215;
																																																												{
																																																													obj_t
																																																														BgL_exprz00_23217;
																																																													obj_t
																																																														BgL_bindingsz00_23216;
																																																													BgL_bindingsz00_23216
																																																														=
																																																														BgL_arg5102z00_6206;
																																																													BgL_exprz00_23217
																																																														=
																																																														BgL_arg5103z00_6207;
																																																													BgL_exprz00_1729
																																																														=
																																																														BgL_exprz00_23217;
																																																													BgL_bindingsz00_1728
																																																														=
																																																														BgL_bindingsz00_23216;
																																																													goto
																																																														BgL_tagzd2382zd2_1730;
																																																												}
																																																												BgL_auxz00_22040
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_23215);
																																																											}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											bool_t
																																																												BgL_test9529z00_23219;
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_arg5173z00_6319;
																																																												BgL_arg5173z00_6319
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												BgL_test9529z00_23219
																																																													=
																																																													CBOOL
																																																													(BGl_labelszd2symzf3z21zzast_labelsz00
																																																													(BgL_arg5173z00_6319));
																																																											}
																																																											if (BgL_test9529z00_23219)
																																																												{
																																																													BgL_letzd2funzd2_bglt
																																																														BgL_auxz00_23224;
																																																													goto
																																																														BgL_tagzd2384zd2_1732;
																																																													BgL_auxz00_22040
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_23224);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_carzd236572zd2_6210;
																																																													BgL_carzd236572zd2_6210
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_cdrzd236577zd2_6211;
																																																														BgL_cdrzd236577zd2_6211
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_carzd236572zd2_6210));
																																																														if ((CAR(((obj_t) BgL_carzd236572zd2_6210)) == CNST_TABLE_REF(((long) 3))))
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (PAIRP(BgL_cdrzd236577zd2_6211))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_arg5109z00_6215;
																																																																		obj_t
																																																																			BgL_arg5110z00_6216;
																																																																		obj_t
																																																																			BgL_arg5111z00_6217;
																																																																		BgL_arg5109z00_6215
																																																																			=
																																																																			CAR
																																																																			(BgL_cdrzd236577zd2_6211);
																																																																		BgL_arg5110z00_6216
																																																																			=
																																																																			CDR
																																																																			(BgL_cdrzd236577zd2_6211);
																																																																		BgL_arg5111z00_6217
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_23241;
																																																																			{
																																																																				obj_t
																																																																					BgL_argsz00_23244;
																																																																				obj_t
																																																																					BgL_bodyz00_23243;
																																																																				obj_t
																																																																					BgL_varsz00_23242;
																																																																				BgL_varsz00_23242
																																																																					=
																																																																					BgL_arg5109z00_6215;
																																																																				BgL_bodyz00_23243
																																																																					=
																																																																					BgL_arg5110z00_6216;
																																																																				BgL_argsz00_23244
																																																																					=
																																																																					BgL_arg5111z00_6217;
																																																																				BgL_argsz00_1739
																																																																					=
																																																																					BgL_argsz00_23244;
																																																																				BgL_bodyz00_1738
																																																																					=
																																																																					BgL_bodyz00_23243;
																																																																				BgL_varsz00_1737
																																																																					=
																																																																					BgL_varsz00_23242;
																																																																				goto
																																																																					BgL_tagzd2386zd2_1740;
																																																																			}
																																																																			BgL_auxz00_22040
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_23241);
																																																																		}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1774;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_23248;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1775;
																																																																				BgL_auxz00_22040
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_23248);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_cdrzd236684zd2_6220;
																																																																BgL_cdrzd236684zd2_6220
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd236689zd2_6221;
																																																																	BgL_cdrzd236689zd2_6221
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_carzd236572zd2_6210));
																																																																	if ((CAR(((obj_t) BgL_carzd236572zd2_6210)) == CNST_TABLE_REF(((long) 1))))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if (PAIRP(BgL_cdrzd236689zd2_6221))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_cdrzd236694zd2_6225;
																																																																					BgL_cdrzd236694zd2_6225
																																																																						=
																																																																						CDR
																																																																						(BgL_cdrzd236689zd2_6221);
																																																																					if (PAIRP(BgL_cdrzd236694zd2_6225))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_carzd236698zd2_6227;
																																																																							obj_t
																																																																								BgL_cdrzd236699zd2_6228;
																																																																							BgL_carzd236698zd2_6227
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd236694zd2_6225);
																																																																							BgL_cdrzd236699zd2_6228
																																																																								=
																																																																								CDR
																																																																								(BgL_cdrzd236694zd2_6225);
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd236698zd2_6227))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (PAIRP(BgL_cdrzd236699zd2_6228))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_carzd236704zd2_6231;
																																																																											BgL_carzd236704zd2_6231
																																																																												=
																																																																												CAR
																																																																												(BgL_cdrzd236699zd2_6228);
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd236704zd2_6231))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (NULLP(CDR(BgL_cdrzd236699zd2_6228)))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															bool_t
																																																																																BgL_test9540z00_23276;
																																																																															{
																																																																																obj_t
																																																																																	BgL_l1427z00_6264;
																																																																																BgL_l1427z00_6264
																																																																																	=
																																																																																	BgL_cdrzd236684zd2_6220;
																																																																															BgL_zc3z04anonymousza35137ze3z87_6265:
																																																																																if (NULLP(BgL_l1427z00_6264))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		BgL_test9540z00_23276
																																																																																			=
																																																																																			(
																																																																																			(bool_t)
																																																																																			1);
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		bool_t
																																																																																			BgL_test9542z00_23279;
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			bool_t
																																																																																				BgL_test9543z00_23280;
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				obj_t
																																																																																					BgL_tmpz00_23281;
																																																																																				BgL_tmpz00_23281
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_l1427z00_6264));
																																																																																				BgL_test9543z00_23280
																																																																																					=
																																																																																					PAIRP
																																																																																					(BgL_tmpz00_23281);
																																																																																			}
																																																																																			if (BgL_test9543z00_23280)
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					BgL_test9542z00_23279
																																																																																						=
																																																																																						(
																																																																																						(bool_t)
																																																																																						0);
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					BgL_test9542z00_23279
																																																																																						=
																																																																																						(
																																																																																						(bool_t)
																																																																																						1);
																																																																																				}
																																																																																		}
																																																																																		if (BgL_test9542z00_23279)
																																																																																			{
																																																																																				obj_t
																																																																																					BgL_l1427z00_23285;
																																																																																				BgL_l1427z00_23285
																																																																																					=
																																																																																					CDR
																																																																																					(
																																																																																					((obj_t) BgL_l1427z00_6264));
																																																																																				BgL_l1427z00_6264
																																																																																					=
																																																																																					BgL_l1427z00_23285;
																																																																																				goto
																																																																																					BgL_zc3z04anonymousza35137ze3z87_6265;
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				BgL_test9540z00_23276
																																																																																					=
																																																																																					(
																																																																																					(bool_t)
																																																																																					0);
																																																																																			}
																																																																																	}
																																																																															}
																																																																															if (BgL_test9540z00_23276)
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_arg5127z00_6247;
																																																																																	BgL_arg5127z00_6247
																																																																																		=
																																																																																		CAR
																																																																																		(BgL_cdrzd236689zd2_6221);
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_23289;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_23293;
																																																																																			obj_t
																																																																																				BgL_proc2z00_23292;
																																																																																			obj_t
																																																																																				BgL_proc1z00_23291;
																																																																																			obj_t
																																																																																				BgL_testz00_23290;
																																																																																			BgL_testz00_23290
																																																																																				=
																																																																																				BgL_arg5127z00_6247;
																																																																																			BgL_proc1z00_23291
																																																																																				=
																																																																																				BgL_carzd236698zd2_6227;
																																																																																			BgL_proc2z00_23292
																																																																																				=
																																																																																				BgL_carzd236704zd2_6231;
																																																																																			BgL_argsz00_23293
																																																																																				=
																																																																																				BgL_cdrzd236684zd2_6220;
																																																																																			BgL_argsz00_1744
																																																																																				=
																																																																																				BgL_argsz00_23293;
																																																																																			BgL_proc2z00_1743
																																																																																				=
																																																																																				BgL_proc2z00_23292;
																																																																																			BgL_proc1z00_1742
																																																																																				=
																																																																																				BgL_proc1z00_23291;
																																																																																			BgL_testz00_1741
																																																																																				=
																																																																																				BgL_testz00_23290;
																																																																																			goto
																																																																																				BgL_tagzd2387zd2_1745;
																																																																																		}
																																																																																		BgL_auxz00_22040
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_23289);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_cdrzd236729zd2_6248;
																																																																																	BgL_cdrzd236729zd2_6248
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_expz00_21));
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		obj_t
																																																																																			BgL_cdrzd236737zd2_6249;
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			obj_t
																																																																																				BgL_pairz00_12096;
																																																																																			BgL_pairz00_12096
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_expz00_21));
																																																																																			BgL_cdrzd236737zd2_6249
																																																																																				=
																																																																																				CDR
																																																																																				(BgL_pairz00_12096);
																																																																																		}
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			obj_t
																																																																																				BgL_cdrzd236745zd2_6250;
																																																																																			BgL_cdrzd236745zd2_6250
																																																																																				=
																																																																																				CDR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd236737zd2_6249));
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				obj_t
																																																																																					BgL_carzd236752zd2_6251;
																																																																																				BgL_carzd236752zd2_6251
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd236745zd2_6250));
																																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd236752zd2_6251))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						obj_t
																																																																																							BgL_carzd236761zd2_6253;
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							obj_t
																																																																																								BgL_pairz00_12100;
																																																																																							BgL_pairz00_12100
																																																																																								=
																																																																																								CDR
																																																																																								(
																																																																																								((obj_t) BgL_cdrzd236745zd2_6250));
																																																																																							BgL_carzd236761zd2_6253
																																																																																								=
																																																																																								CAR
																																																																																								(BgL_pairz00_12100);
																																																																																						}
																																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd236761zd2_6253))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd236729zd2_6248))
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										obj_t
																																																																																											BgL_arg5131z00_6256;
																																																																																										BgL_arg5131z00_6256
																																																																																											=
																																																																																											CAR
																																																																																											(
																																																																																											((obj_t) BgL_cdrzd236737zd2_6249));
																																																																																										{
																																																																																											BgL_nodez00_bglt
																																																																																												BgL_auxz00_23315;
																																																																																											{
																																																																																												obj_t
																																																																																													BgL_argsz00_23319;
																																																																																												obj_t
																																																																																													BgL_proc2z00_23318;
																																																																																												obj_t
																																																																																													BgL_proc1z00_23317;
																																																																																												obj_t
																																																																																													BgL_testz00_23316;
																																																																																												BgL_testz00_23316
																																																																																													=
																																																																																													BgL_arg5131z00_6256;
																																																																																												BgL_proc1z00_23317
																																																																																													=
																																																																																													BgL_carzd236752zd2_6251;
																																																																																												BgL_proc2z00_23318
																																																																																													=
																																																																																													BgL_carzd236761zd2_6253;
																																																																																												BgL_argsz00_23319
																																																																																													=
																																																																																													BgL_cdrzd236729zd2_6248;
																																																																																												BgL_argsz00_1749
																																																																																													=
																																																																																													BgL_argsz00_23319;
																																																																																												BgL_proc2z00_1748
																																																																																													=
																																																																																													BgL_proc2z00_23318;
																																																																																												BgL_proc1z00_1747
																																																																																													=
																																																																																													BgL_proc1z00_23317;
																																																																																												BgL_testz00_1746
																																																																																													=
																																																																																													BgL_testz00_23316;
																																																																																												goto
																																																																																													BgL_tagzd2388zd2_1750;
																																																																																											}
																																																																																											BgL_auxz00_22040
																																																																																												=
																																																																																												(
																																																																																												(obj_t)
																																																																																												BgL_auxz00_23315);
																																																																																										}
																																																																																									}
																																																																																								else
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																											{	/* Ast/sexp.scm 118 */
																																																																																												goto
																																																																																													BgL_tagzd2403zd2_1774;
																																																																																											}
																																																																																										else
																																																																																											{
																																																																																												BgL_nodez00_bglt
																																																																																													BgL_auxz00_23323;
																																																																																												goto
																																																																																													BgL_tagzd2404zd2_1775;
																																																																																												BgL_auxz00_22040
																																																																																													=
																																																																																													(
																																																																																													(obj_t)
																																																																																													BgL_auxz00_23323);
																																																																																											}
																																																																																									}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1774;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_23327;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1775;
																																																																																										BgL_auxz00_22040
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_23327);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1774;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_23331;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1775;
																																																																																								BgL_auxz00_22040
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_23331);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		}
																																																																																	}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1774;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_23335;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1775;
																																																																																	BgL_auxz00_22040
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_23335);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_cdrzd237039zd2_6275;
																																																																													BgL_cdrzd237039zd2_6275
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_cdrzd237046zd2_6276;
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_pairz00_12104;
																																																																															BgL_pairz00_12104
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															BgL_cdrzd237046zd2_6276
																																																																																=
																																																																																CDR
																																																																																(BgL_pairz00_12104);
																																																																														}
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_cdrzd237053zd2_6277;
																																																																															BgL_cdrzd237053zd2_6277
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_cdrzd237046zd2_6276));
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_carzd237059zd2_6278;
																																																																																obj_t
																																																																																	BgL_cdrzd237060zd2_6279;
																																																																																BgL_carzd237059zd2_6278
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd237053zd2_6277));
																																																																																BgL_cdrzd237060zd2_6279
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd237053zd2_6277));
																																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd237059zd2_6278))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		obj_t
																																																																																			BgL_carzd237067zd2_6281;
																																																																																		BgL_carzd237067zd2_6281
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd237060zd2_6279));
																																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd237067zd2_6281))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (NULLP(CDR(((obj_t) BgL_cdrzd237060zd2_6279))))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd237039zd2_6275))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								obj_t
																																																																																									BgL_arg5146z00_6286;
																																																																																								BgL_arg5146z00_6286
																																																																																									=
																																																																																									CAR
																																																																																									(
																																																																																									((obj_t) BgL_cdrzd237046zd2_6276));
																																																																																								{
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_auxz00_23362;
																																																																																									{
																																																																																										obj_t
																																																																																											BgL_argsz00_23366;
																																																																																										obj_t
																																																																																											BgL_proc2z00_23365;
																																																																																										obj_t
																																																																																											BgL_proc1z00_23364;
																																																																																										obj_t
																																																																																											BgL_testz00_23363;
																																																																																										BgL_testz00_23363
																																																																																											=
																																																																																											BgL_arg5146z00_6286;
																																																																																										BgL_proc1z00_23364
																																																																																											=
																																																																																											BgL_carzd237059zd2_6278;
																																																																																										BgL_proc2z00_23365
																																																																																											=
																																																																																											BgL_carzd237067zd2_6281;
																																																																																										BgL_argsz00_23366
																																																																																											=
																																																																																											BgL_cdrzd237039zd2_6275;
																																																																																										BgL_argsz00_1749
																																																																																											=
																																																																																											BgL_argsz00_23366;
																																																																																										BgL_proc2z00_1748
																																																																																											=
																																																																																											BgL_proc2z00_23365;
																																																																																										BgL_proc1z00_1747
																																																																																											=
																																																																																											BgL_proc1z00_23364;
																																																																																										BgL_testz00_1746
																																																																																											=
																																																																																											BgL_testz00_23363;
																																																																																										goto
																																																																																											BgL_tagzd2388zd2_1750;
																																																																																									}
																																																																																									BgL_auxz00_22040
																																																																																										=
																																																																																										(
																																																																																										(obj_t)
																																																																																										BgL_auxz00_23362);
																																																																																								}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1774;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_23370;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1775;
																																																																																										BgL_auxz00_22040
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_23370);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1774;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_23374;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1775;
																																																																																								BgL_auxz00_22040
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_23374);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1774;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_23378;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1775;
																																																																																						BgL_auxz00_22040
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_23378);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1774;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_23382;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1775;
																																																																																				BgL_auxz00_22040
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_23382);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														}
																																																																													}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1774;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_23386;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1775;
																																																																													BgL_auxz00_22040
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_23386);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_cdrzd237400zd2_6294;
																																																																									BgL_cdrzd237400zd2_6294
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_cdrzd237406zd2_6295;
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_pairz00_12114;
																																																																											BgL_pairz00_12114
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											BgL_cdrzd237406zd2_6295
																																																																												=
																																																																												CDR
																																																																												(BgL_pairz00_12114);
																																																																										}
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_cdrzd237412zd2_6296;
																																																																											BgL_cdrzd237412zd2_6296
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd237406zd2_6295));
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_carzd237417zd2_6297;
																																																																												obj_t
																																																																													BgL_cdrzd237418zd2_6298;
																																																																												BgL_carzd237417zd2_6297
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd237412zd2_6296));
																																																																												BgL_cdrzd237418zd2_6298
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd237412zd2_6296));
																																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd237417zd2_6297))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														if (PAIRP(BgL_cdrzd237418zd2_6298))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_carzd237423zd2_6301;
																																																																																BgL_carzd237423zd2_6301
																																																																																	=
																																																																																	CAR
																																																																																	(BgL_cdrzd237418zd2_6298);
																																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd237423zd2_6301))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (NULLP(CDR(BgL_cdrzd237418zd2_6298)))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd237400zd2_6294))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						obj_t
																																																																																							BgL_arg5160z00_6306;
																																																																																						BgL_arg5160z00_6306
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_cdrzd237406zd2_6295));
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_23413;
																																																																																							{
																																																																																								obj_t
																																																																																									BgL_argsz00_23417;
																																																																																								obj_t
																																																																																									BgL_proc2z00_23416;
																																																																																								obj_t
																																																																																									BgL_proc1z00_23415;
																																																																																								obj_t
																																																																																									BgL_testz00_23414;
																																																																																								BgL_testz00_23414
																																																																																									=
																																																																																									BgL_arg5160z00_6306;
																																																																																								BgL_proc1z00_23415
																																																																																									=
																																																																																									BgL_carzd237417zd2_6297;
																																																																																								BgL_proc2z00_23416
																																																																																									=
																																																																																									BgL_carzd237423zd2_6301;
																																																																																								BgL_argsz00_23417
																																																																																									=
																																																																																									BgL_cdrzd237400zd2_6294;
																																																																																								BgL_argsz00_1749
																																																																																									=
																																																																																									BgL_argsz00_23417;
																																																																																								BgL_proc2z00_1748
																																																																																									=
																																																																																									BgL_proc2z00_23416;
																																																																																								BgL_proc1z00_1747
																																																																																									=
																																																																																									BgL_proc1z00_23415;
																																																																																								BgL_testz00_1746
																																																																																									=
																																																																																									BgL_testz00_23414;
																																																																																								goto
																																																																																									BgL_tagzd2388zd2_1750;
																																																																																							}
																																																																																							BgL_auxz00_22040
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_23413);
																																																																																						}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1774;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_23421;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1775;
																																																																																								BgL_auxz00_22040
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_23421);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1774;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_23425;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1775;
																																																																																						BgL_auxz00_22040
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_23425);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1774;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_23429;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1775;
																																																																																				BgL_auxz00_22040
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_23429);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1774;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_23433;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1775;
																																																																																		BgL_auxz00_22040
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_23433);
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1774;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_23437;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1775;
																																																																																BgL_auxz00_22040
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_23437);
																																																																															}
																																																																													}
																																																																											}
																																																																										}
																																																																									}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1774;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_23441;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1775;
																																																																									BgL_auxz00_22040
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_23441);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1774;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_23445;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1775;
																																																																							BgL_auxz00_22040
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_23445);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1774;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_23449;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1775;
																																																																					BgL_auxz00_22040
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_23449);
																																																																				}
																																																																		}
																																																																}
																																																															}
																																																													}
																																																												}
																																																										}
																																																								}
																																																							}
																																																					}
																																																			}
																																																	}
																																															}
																																													}
																																												}
																																											else
																																												{	/* Ast/sexp.scm 118 */
																																													obj_t
																																														BgL_cdrzd237961zd2_6470;
																																													BgL_cdrzd237961zd2_6470
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													if ((BgL_carzd234896zd2_6193 == CNST_TABLE_REF(((long) 17))))
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_arg5276z00_6472;
																																															obj_t
																																																BgL_arg5277z00_6473;
																																															BgL_arg5276z00_6472
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd237961zd2_6470));
																																															BgL_arg5277z00_6473
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd237961zd2_6470));
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_23460;
																																																{
																																																	obj_t
																																																		BgL_exprz00_23462;
																																																	obj_t
																																																		BgL_bindingsz00_23461;
																																																	BgL_bindingsz00_23461
																																																		=
																																																		BgL_arg5276z00_6472;
																																																	BgL_exprz00_23462
																																																		=
																																																		BgL_arg5277z00_6473;
																																																	BgL_exprz00_1729
																																																		=
																																																		BgL_exprz00_23462;
																																																	BgL_bindingsz00_1728
																																																		=
																																																		BgL_bindingsz00_23461;
																																																	goto
																																																		BgL_tagzd2382zd2_1730;
																																																}
																																																BgL_auxz00_22040
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_23460);
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 118 */
																																															if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd234896zd2_6193)))
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_arg5279z00_6475;
																																																	obj_t
																																																		BgL_arg5280z00_6476;
																																																	BgL_arg5279z00_6475
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd237961zd2_6470));
																																																	BgL_arg5280z00_6476
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd237961zd2_6470));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_23471;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_23473;
																																																			obj_t
																																																				BgL_bindingsz00_23472;
																																																			BgL_bindingsz00_23472
																																																				=
																																																				BgL_arg5279z00_6475;
																																																			BgL_exprz00_23473
																																																				=
																																																				BgL_arg5280z00_6476;
																																																			BgL_exprz00_1729
																																																				=
																																																				BgL_exprz00_23473;
																																																			BgL_bindingsz00_1728
																																																				=
																																																				BgL_bindingsz00_23472;
																																																			goto
																																																				BgL_tagzd2382zd2_1730;
																																																		}
																																																		BgL_auxz00_22040
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_23471);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	if ((BgL_carzd234896zd2_6193 == CNST_TABLE_REF(((long) 18))))
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_arg5282z00_6478;
																																																			obj_t
																																																				BgL_arg5283z00_6479;
																																																			BgL_arg5282z00_6478
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd237961zd2_6470));
																																																			BgL_arg5283z00_6479
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd237961zd2_6470));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_23482;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_23484;
																																																					obj_t
																																																						BgL_bindingsz00_23483;
																																																					BgL_bindingsz00_23483
																																																						=
																																																						BgL_arg5282z00_6478;
																																																					BgL_exprz00_23484
																																																						=
																																																						BgL_arg5283z00_6479;
																																																					BgL_exprz00_1729
																																																						=
																																																						BgL_exprz00_23484;
																																																					BgL_bindingsz00_1728
																																																						=
																																																						BgL_bindingsz00_23483;
																																																					goto
																																																						BgL_tagzd2382zd2_1730;
																																																				}
																																																				BgL_auxz00_22040
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_23482);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_23491;
																																																					goto
																																																						BgL_tagzd2383zd2_1731;
																																																					BgL_auxz00_22040
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_23491);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_carzd237998zd2_6482;
																																																					BgL_carzd237998zd2_6482
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					if ((BgL_carzd237998zd2_6482 == CNST_TABLE_REF(((long) 19))))
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_23498;
																																																							goto
																																																								BgL_tagzd2384zd2_1732;
																																																							BgL_auxz00_22040
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_23498);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd237998zd2_6482)))
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_23503;
																																																									goto
																																																										BgL_tagzd2384zd2_1732;
																																																									BgL_auxz00_22040
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_23503);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_23510;
																																																											goto
																																																												BgL_tagzd2389zd2_1751;
																																																											BgL_auxz00_22040
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_23510);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_23517;
																																																													goto
																																																														BgL_tagzd2390zd2_1752;
																																																													BgL_auxz00_22040
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_23517);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_cdrzd238078zd2_6489;
																																																													BgL_cdrzd238078zd2_6489
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_arg5294z00_6492;
																																																															obj_t
																																																																BgL_arg5295z00_6493;
																																																															BgL_arg5294z00_6492
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_cdrzd238078zd2_6489));
																																																															BgL_arg5295z00_6493
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd238078zd2_6489));
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_23530;
																																																																{
																																																																	obj_t
																																																																		BgL_restz00_23532;
																																																																	obj_t
																																																																		BgL_effectz00_23531;
																																																																	BgL_effectz00_23531
																																																																		=
																																																																		BgL_arg5294z00_6492;
																																																																	BgL_restz00_23532
																																																																		=
																																																																		BgL_arg5295z00_6493;
																																																																	BgL_restz00_1754
																																																																		=
																																																																		BgL_restz00_23532;
																																																																	BgL_effectz00_1753
																																																																		=
																																																																		BgL_effectz00_23531;
																																																																	goto
																																																																		BgL_tagzd2391zd2_1755;
																																																																}
																																																																BgL_auxz00_22040
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_23530);
																																																															}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_23539;
																																																																	goto
																																																																		BgL_tagzd2392zd2_1756;
																																																																	BgL_auxz00_22040
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_23539);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_23546;
																																																																			goto
																																																																				BgL_tagzd2393zd2_1757;
																																																																			BgL_auxz00_22040
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_23546);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_arg5302z00_6501;
																																																																					obj_t
																																																																						BgL_arg5303z00_6502;
																																																																					BgL_arg5302z00_6501
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd238078zd2_6489));
																																																																					BgL_arg5303z00_6502
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd238078zd2_6489));
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_23557;
																																																																						{
																																																																							obj_t
																																																																								BgL_restz00_23559;
																																																																							obj_t
																																																																								BgL_effectz00_23558;
																																																																							BgL_effectz00_23558
																																																																								=
																																																																								BgL_arg5302z00_6501;
																																																																							BgL_restz00_23559
																																																																								=
																																																																								BgL_arg5303z00_6502;
																																																																							BgL_restz00_1759
																																																																								=
																																																																								BgL_restz00_23559;
																																																																							BgL_effectz00_1758
																																																																								=
																																																																								BgL_effectz00_23558;
																																																																							goto
																																																																								BgL_tagzd2394zd2_1760;
																																																																						}
																																																																						BgL_auxz00_22040
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_23557);
																																																																					}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_23566;
																																																																							goto
																																																																								BgL_tagzd2395zd2_1761;
																																																																							BgL_auxz00_22040
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_23566);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_23573;
																																																																									goto
																																																																										BgL_tagzd2396zd2_1762;
																																																																									BgL_auxz00_22040
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_23573);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																										{
																																																																											BgL_letzd2funzd2_bglt
																																																																												BgL_auxz00_23580;
																																																																											goto
																																																																												BgL_tagzd2397zd2_1763;
																																																																											BgL_auxz00_22040
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_23580);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																												{
																																																																													BgL_jumpzd2exzd2itz00_bglt
																																																																														BgL_auxz00_23587;
																																																																													goto
																																																																														BgL_tagzd2398zd2_1764;
																																																																													BgL_auxz00_22040
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_23587);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_cdrzd238155zd2_6511;
																																																																													BgL_cdrzd238155zd2_6511
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_arg5314z00_6514;
																																																																															obj_t
																																																																																BgL_arg5315z00_6515;
																																																																															BgL_arg5314z00_6514
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd238155zd2_6511));
																																																																															BgL_arg5315z00_6515
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_cdrzd238155zd2_6511));
																																																																															{	/* Ast/sexp.scm 551 */
																																																																																obj_t
																																																																																	BgL_arg6989z00_12153;
																																																																																BgL_arg6989z00_12153
																																																																																	=
																																																																																	BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																	(BgL_expz00_21,
																																																																																	BgL_locz00_23);
																																																																																BgL_auxz00_22040
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																	(BgL_expz00_21,
																																																																																		BgL_arg5314z00_6514,
																																																																																		CNST_TABLE_REF
																																																																																		(((long) 4)), BgL_arg5315z00_6515, BgL_stackz00_22, BgL_arg6989z00_12153, BgL_sitez00_24));
																																																																														}}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1774;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_23606;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1775;
																																																																																	BgL_auxz00_22040
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_23606);
																																																																																}
																																																																														}
																																																																												}
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																															else
																																{	/* Ast/sexp.scm 118 */
																																	obj_t
																																		BgL_carzd238180zd2_6532;
																																	BgL_carzd238180zd2_6532
																																		=
																																		CAR(((obj_t)
																																			BgL_expz00_21));
																																	if (
																																		(BgL_carzd238180zd2_6532
																																			==
																																			CNST_TABLE_REF
																																			(((long)
																																					1))))
																																		{
																																			BgL_nodez00_bglt
																																				BgL_auxz00_23613;
																																			goto
																																				BgL_tagzd2377zd2_1719;
																																			BgL_auxz00_22040
																																				=
																																				((obj_t)
																																				BgL_auxz00_23613);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 118 */
																																			if (
																																				(BgL_carzd238180zd2_6532
																																					==
																																					BGl_za2ifza2z00zzast_sexpz00))
																																				{
																																					BgL_nodez00_bglt
																																						BgL_auxz00_23617;
																																					goto
																																						BgL_tagzd2377zd2_1719;
																																					BgL_auxz00_22040
																																						=
																																						(
																																						(obj_t)
																																						BgL_auxz00_23617);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 118 */
																																					if (
																																						(CAR
																																							(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 7))))
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_23624;
																																							goto
																																								BgL_tagzd2379zd2_1723;
																																							BgL_auxz00_22040
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_23624);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 118 */
																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_23631;
																																									goto
																																										BgL_tagzd2380zd2_1724;
																																									BgL_auxz00_22040
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_23631);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 118 */
																																									obj_t
																																										BgL_carzd238249zd2_6539;
																																									BgL_carzd238249zd2_6539
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_expz00_21));
																																									if (PAIRP(BgL_carzd238249zd2_6539))
																																										{	/* Ast/sexp.scm 118 */
																																											obj_t
																																												BgL_carzd238252zd2_6541;
																																											obj_t
																																												BgL_cdrzd238253zd2_6542;
																																											BgL_carzd238252zd2_6541
																																												=
																																												CAR
																																												(BgL_carzd238249zd2_6539);
																																											BgL_cdrzd238253zd2_6542
																																												=
																																												CDR
																																												(BgL_carzd238249zd2_6539);
																																											{

																																												if ((BgL_carzd238252zd2_6541 == CNST_TABLE_REF(((long) 17))))
																																													{	/* Ast/sexp.scm 118 */
																																													BgL_kapzd238254zd2_6543:
																																														if (PAIRP(BgL_cdrzd238253zd2_6542))
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_cdrzd238257zd2_6668;
																																																BgL_cdrzd238257zd2_6668
																																																	=
																																																	CDR
																																																	(BgL_cdrzd238253zd2_6542);
																																																if (PAIRP(BgL_cdrzd238257zd2_6668))
																																																	{	/* Ast/sexp.scm 118 */
																																																		if (NULLP(CDR(BgL_cdrzd238257zd2_6668)))
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_arg5423z00_6672;
																																																				obj_t
																																																					BgL_arg5424z00_6673;
																																																				BgL_arg5423z00_6672
																																																					=
																																																					CAR
																																																					(BgL_cdrzd238257zd2_6668);
																																																				BgL_arg5424z00_6673
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_23653;
																																																					{
																																																						obj_t
																																																							BgL_argsz00_23655;
																																																						obj_t
																																																							BgL_bodyz00_23654;
																																																						BgL_bodyz00_23654
																																																							=
																																																							BgL_arg5423z00_6672;
																																																						BgL_argsz00_23655
																																																							=
																																																							BgL_arg5424z00_6673;
																																																						BgL_argsz00_1726
																																																							=
																																																							BgL_argsz00_23655;
																																																						BgL_bodyz00_1725
																																																							=
																																																							BgL_bodyz00_23654;
																																																						goto
																																																							BgL_tagzd2381zd2_1727;
																																																					}
																																																					BgL_auxz00_22040
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_23653);
																																																				}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_cdrzd238281zd2_6674;
																																																				BgL_cdrzd238281zd2_6674
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{	/* Ast/sexp.scm 118 */
																																																					bool_t
																																																						BgL_test9600z00_23659;
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_arg5493z00_6785;
																																																						BgL_arg5493z00_6785
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test9600z00_23659
																																																							=
																																																							CBOOL
																																																							(BGl_letzd2symzf3z21zzast_letz00
																																																							(BgL_arg5493z00_6785));
																																																					}
																																																					if (BgL_test9600z00_23659)
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_arg5427z00_6677;
																																																							obj_t
																																																								BgL_arg5428z00_6678;
																																																							BgL_arg5427z00_6677
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd238281zd2_6674));
																																																							BgL_arg5428z00_6678
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd238281zd2_6674));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_23668;
																																																								{
																																																									obj_t
																																																										BgL_exprz00_23670;
																																																									obj_t
																																																										BgL_bindingsz00_23669;
																																																									BgL_bindingsz00_23669
																																																										=
																																																										BgL_arg5427z00_6677;
																																																									BgL_exprz00_23670
																																																										=
																																																										BgL_arg5428z00_6678;
																																																									BgL_exprz00_1729
																																																										=
																																																										BgL_exprz00_23670;
																																																									BgL_bindingsz00_1728
																																																										=
																																																										BgL_bindingsz00_23669;
																																																									goto
																																																										BgL_tagzd2382zd2_1730;
																																																								}
																																																								BgL_auxz00_22040
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_23668);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							bool_t
																																																								BgL_test9601z00_23672;
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_arg5492z00_6784;
																																																								BgL_arg5492z00_6784
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test9601z00_23672
																																																									=
																																																									CBOOL
																																																									(BGl_labelszd2symzf3z21zzast_labelsz00
																																																									(BgL_arg5492z00_6784));
																																																							}
																																																							if (BgL_test9601z00_23672)
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_23677;
																																																									goto
																																																										BgL_tagzd2384zd2_1732;
																																																									BgL_auxz00_22040
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_23677);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_carzd238348zd2_6681;
																																																									BgL_carzd238348zd2_6681
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_cdrzd238353zd2_6682;
																																																										BgL_cdrzd238353zd2_6682
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_carzd238348zd2_6681));
																																																										if ((CAR(((obj_t) BgL_carzd238348zd2_6681)) == CNST_TABLE_REF(((long) 3))))
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_arg5433z00_6685;
																																																												obj_t
																																																													BgL_arg5434z00_6686;
																																																												obj_t
																																																													BgL_arg5435z00_6687;
																																																												BgL_arg5433z00_6685
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_cdrzd238353zd2_6682));
																																																												BgL_arg5434z00_6686
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_cdrzd238353zd2_6682));
																																																												BgL_arg5435z00_6687
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_23694;
																																																													{
																																																														obj_t
																																																															BgL_argsz00_23697;
																																																														obj_t
																																																															BgL_bodyz00_23696;
																																																														obj_t
																																																															BgL_varsz00_23695;
																																																														BgL_varsz00_23695
																																																															=
																																																															BgL_arg5433z00_6685;
																																																														BgL_bodyz00_23696
																																																															=
																																																															BgL_arg5434z00_6686;
																																																														BgL_argsz00_23697
																																																															=
																																																															BgL_arg5435z00_6687;
																																																														BgL_argsz00_1739
																																																															=
																																																															BgL_argsz00_23697;
																																																														BgL_bodyz00_1738
																																																															=
																																																															BgL_bodyz00_23696;
																																																														BgL_varsz00_1737
																																																															=
																																																															BgL_varsz00_23695;
																																																														goto
																																																															BgL_tagzd2386zd2_1740;
																																																													}
																																																													BgL_auxz00_22040
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_23694);
																																																												}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_cdrzd238376zd2_6689;
																																																												BgL_cdrzd238376zd2_6689
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_cdrzd238382zd2_6690;
																																																													BgL_cdrzd238382zd2_6690
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_carzd238348zd2_6681));
																																																													if ((CAR(((obj_t) BgL_carzd238348zd2_6681)) == CNST_TABLE_REF(((long) 1))))
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_cdrzd238388zd2_6693;
																																																															BgL_cdrzd238388zd2_6693
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd238382zd2_6690));
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_carzd238393zd2_6694;
																																																																obj_t
																																																																	BgL_cdrzd238394zd2_6695;
																																																																BgL_carzd238393zd2_6694
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd238388zd2_6693));
																																																																BgL_cdrzd238394zd2_6695
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd238388zd2_6693));
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd238393zd2_6694))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (PAIRP(BgL_cdrzd238394zd2_6695))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_carzd238401zd2_6698;
																																																																				BgL_carzd238401zd2_6698
																																																																					=
																																																																					CAR
																																																																					(BgL_cdrzd238394zd2_6695);
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd238401zd2_6698))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (NULLP(CDR(BgL_cdrzd238394zd2_6695)))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								bool_t
																																																																									BgL_test9608z00_23724;
																																																																								{
																																																																									obj_t
																																																																										BgL_l1430z00_6731;
																																																																									BgL_l1430z00_6731
																																																																										=
																																																																										BgL_cdrzd238376zd2_6689;
																																																																								BgL_zc3z04anonymousza35458ze3z87_6732:
																																																																									if (NULLP(BgL_l1430z00_6731))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											BgL_test9608z00_23724
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												1);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											bool_t
																																																																												BgL_test9610z00_23727;
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												bool_t
																																																																													BgL_test9611z00_23728;
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_tmpz00_23729;
																																																																													BgL_tmpz00_23729
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_l1430z00_6731));
																																																																													BgL_test9611z00_23728
																																																																														=
																																																																														PAIRP
																																																																														(BgL_tmpz00_23729);
																																																																												}
																																																																												if (BgL_test9611z00_23728)
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														BgL_test9610z00_23727
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															0);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														BgL_test9610z00_23727
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															1);
																																																																													}
																																																																											}
																																																																											if (BgL_test9610z00_23727)
																																																																												{
																																																																													obj_t
																																																																														BgL_l1430z00_23733;
																																																																													BgL_l1430z00_23733
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_l1430z00_6731));
																																																																													BgL_l1430z00_6731
																																																																														=
																																																																														BgL_l1430z00_23733;
																																																																													goto
																																																																														BgL_zc3z04anonymousza35458ze3z87_6732;
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													BgL_test9608z00_23724
																																																																														=
																																																																														(
																																																																														(bool_t)
																																																																														0);
																																																																												}
																																																																										}
																																																																								}
																																																																								if (BgL_test9608z00_23724)
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_arg5448z00_6714;
																																																																										BgL_arg5448z00_6714
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd238382zd2_6690));
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_23738;
																																																																											{
																																																																												obj_t
																																																																													BgL_argsz00_23742;
																																																																												obj_t
																																																																													BgL_proc2z00_23741;
																																																																												obj_t
																																																																													BgL_proc1z00_23740;
																																																																												obj_t
																																																																													BgL_testz00_23739;
																																																																												BgL_testz00_23739
																																																																													=
																																																																													BgL_arg5448z00_6714;
																																																																												BgL_proc1z00_23740
																																																																													=
																																																																													BgL_carzd238393zd2_6694;
																																																																												BgL_proc2z00_23741
																																																																													=
																																																																													BgL_carzd238401zd2_6698;
																																																																												BgL_argsz00_23742
																																																																													=
																																																																													BgL_cdrzd238376zd2_6689;
																																																																												BgL_argsz00_1744
																																																																													=
																																																																													BgL_argsz00_23742;
																																																																												BgL_proc2z00_1743
																																																																													=
																																																																													BgL_proc2z00_23741;
																																																																												BgL_proc1z00_1742
																																																																													=
																																																																													BgL_proc1z00_23740;
																																																																												BgL_testz00_1741
																																																																													=
																																																																													BgL_testz00_23739;
																																																																												goto
																																																																													BgL_tagzd2387zd2_1745;
																																																																											}
																																																																											BgL_auxz00_22040
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_23738);
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_cdrzd238425zd2_6715;
																																																																										BgL_cdrzd238425zd2_6715
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_cdrzd238432zd2_6716;
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_pairz00_12197;
																																																																												BgL_pairz00_12197
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_expz00_21));
																																																																												BgL_cdrzd238432zd2_6716
																																																																													=
																																																																													CDR
																																																																													(BgL_pairz00_12197);
																																																																											}
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_cdrzd238439zd2_6717;
																																																																												BgL_cdrzd238439zd2_6717
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd238432zd2_6716));
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_carzd238445zd2_6718;
																																																																													BgL_carzd238445zd2_6718
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd238439zd2_6717));
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd238445zd2_6718))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_carzd238452zd2_6720;
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_pairz00_12201;
																																																																																BgL_pairz00_12201
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd238439zd2_6717));
																																																																																BgL_carzd238452zd2_6720
																																																																																	=
																																																																																	CAR
																																																																																	(BgL_pairz00_12201);
																																																																															}
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd238452zd2_6720))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd238425zd2_6715))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			obj_t
																																																																																				BgL_arg5452z00_6723;
																																																																																			BgL_arg5452z00_6723
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd238432zd2_6716));
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_23764;
																																																																																				{
																																																																																					obj_t
																																																																																						BgL_argsz00_23768;
																																																																																					obj_t
																																																																																						BgL_proc2z00_23767;
																																																																																					obj_t
																																																																																						BgL_proc1z00_23766;
																																																																																					obj_t
																																																																																						BgL_testz00_23765;
																																																																																					BgL_testz00_23765
																																																																																						=
																																																																																						BgL_arg5452z00_6723;
																																																																																					BgL_proc1z00_23766
																																																																																						=
																																																																																						BgL_carzd238445zd2_6718;
																																																																																					BgL_proc2z00_23767
																																																																																						=
																																																																																						BgL_carzd238452zd2_6720;
																																																																																					BgL_argsz00_23768
																																																																																						=
																																																																																						BgL_cdrzd238425zd2_6715;
																																																																																					BgL_argsz00_1749
																																																																																						=
																																																																																						BgL_argsz00_23768;
																																																																																					BgL_proc2z00_1748
																																																																																						=
																																																																																						BgL_proc2z00_23767;
																																																																																					BgL_proc1z00_1747
																																																																																						=
																																																																																						BgL_proc1z00_23766;
																																																																																					BgL_testz00_1746
																																																																																						=
																																																																																						BgL_testz00_23765;
																																																																																					goto
																																																																																						BgL_tagzd2388zd2_1750;
																																																																																				}
																																																																																				BgL_auxz00_22040
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_23764);
																																																																																			}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1774;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_23772;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1775;
																																																																																					BgL_auxz00_22040
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_23772);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1774;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_23776;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1775;
																																																																																			BgL_auxz00_22040
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_23776);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1774;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_23780;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1775;
																																																																																	BgL_auxz00_22040
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_23780);
																																																																																}
																																																																														}
																																																																												}
																																																																											}
																																																																										}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1774;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_23784;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1775;
																																																																										BgL_auxz00_22040
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_23784);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_cdrzd238728zd2_6742;
																																																																						BgL_cdrzd238728zd2_6742
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_cdrzd238734zd2_6743;
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_pairz00_12205;
																																																																								BgL_pairz00_12205
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								BgL_cdrzd238734zd2_6743
																																																																									=
																																																																									CDR
																																																																									(BgL_pairz00_12205);
																																																																							}
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_cdrzd238740zd2_6744;
																																																																								BgL_cdrzd238740zd2_6744
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd238734zd2_6743));
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_carzd238745zd2_6745;
																																																																									obj_t
																																																																										BgL_cdrzd238746zd2_6746;
																																																																									BgL_carzd238745zd2_6745
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd238740zd2_6744));
																																																																									BgL_cdrzd238746zd2_6746
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd238740zd2_6744));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd238745zd2_6745))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_carzd238751zd2_6748;
																																																																											BgL_carzd238751zd2_6748
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd238746zd2_6746));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd238751zd2_6748))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (NULLP(CDR(((obj_t) BgL_cdrzd238746zd2_6746))))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd238728zd2_6742))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_arg5467z00_6753;
																																																																																	BgL_arg5467z00_6753
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd238734zd2_6743));
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_23811;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_23815;
																																																																																			obj_t
																																																																																				BgL_proc2z00_23814;
																																																																																			obj_t
																																																																																				BgL_proc1z00_23813;
																																																																																			obj_t
																																																																																				BgL_testz00_23812;
																																																																																			BgL_testz00_23812
																																																																																				=
																																																																																				BgL_arg5467z00_6753;
																																																																																			BgL_proc1z00_23813
																																																																																				=
																																																																																				BgL_carzd238745zd2_6745;
																																																																																			BgL_proc2z00_23814
																																																																																				=
																																																																																				BgL_carzd238751zd2_6748;
																																																																																			BgL_argsz00_23815
																																																																																				=
																																																																																				BgL_cdrzd238728zd2_6742;
																																																																																			BgL_argsz00_1749
																																																																																				=
																																																																																				BgL_argsz00_23815;
																																																																																			BgL_proc2z00_1748
																																																																																				=
																																																																																				BgL_proc2z00_23814;
																																																																																			BgL_proc1z00_1747
																																																																																				=
																																																																																				BgL_proc1z00_23813;
																																																																																			BgL_testz00_1746
																																																																																				=
																																																																																				BgL_testz00_23812;
																																																																																			goto
																																																																																				BgL_tagzd2388zd2_1750;
																																																																																		}
																																																																																		BgL_auxz00_22040
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_23811);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1774;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_23819;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1775;
																																																																																			BgL_auxz00_22040
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_23819);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1774;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_23823;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1775;
																																																																																	BgL_auxz00_22040
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_23823);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1774;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_23827;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1775;
																																																																															BgL_auxz00_22040
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_23827);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1774;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_23831;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1775;
																																																																													BgL_auxz00_22040
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_23831);
																																																																												}
																																																																										}
																																																																								}
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1774;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_23835;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1775;
																																																																						BgL_auxz00_22040
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_23835);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_cdrzd239084zd2_6761;
																																																																		BgL_cdrzd239084zd2_6761
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_cdrzd239091zd2_6762;
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_pairz00_12215;
																																																																				BgL_pairz00_12215
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				BgL_cdrzd239091zd2_6762
																																																																					=
																																																																					CDR
																																																																					(BgL_pairz00_12215);
																																																																			}
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_cdrzd239098zd2_6763;
																																																																				BgL_cdrzd239098zd2_6763
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd239091zd2_6762));
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_carzd239104zd2_6764;
																																																																					obj_t
																																																																						BgL_cdrzd239105zd2_6765;
																																																																					BgL_carzd239104zd2_6764
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd239098zd2_6763));
																																																																					BgL_cdrzd239105zd2_6765
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd239098zd2_6763));
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd239104zd2_6764))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (PAIRP(BgL_cdrzd239105zd2_6765))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_carzd239112zd2_6768;
																																																																									BgL_carzd239112zd2_6768
																																																																										=
																																																																										CAR
																																																																										(BgL_cdrzd239105zd2_6765);
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd239112zd2_6768))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (NULLP(CDR(BgL_cdrzd239105zd2_6765)))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd239084zd2_6761))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_arg5481z00_6773;
																																																																															BgL_arg5481z00_6773
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd239091zd2_6762));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_23862;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_23866;
																																																																																	obj_t
																																																																																		BgL_proc2z00_23865;
																																																																																	obj_t
																																																																																		BgL_proc1z00_23864;
																																																																																	obj_t
																																																																																		BgL_testz00_23863;
																																																																																	BgL_testz00_23863
																																																																																		=
																																																																																		BgL_arg5481z00_6773;
																																																																																	BgL_proc1z00_23864
																																																																																		=
																																																																																		BgL_carzd239104zd2_6764;
																																																																																	BgL_proc2z00_23865
																																																																																		=
																																																																																		BgL_carzd239112zd2_6768;
																																																																																	BgL_argsz00_23866
																																																																																		=
																																																																																		BgL_cdrzd239084zd2_6761;
																																																																																	BgL_argsz00_1749
																																																																																		=
																																																																																		BgL_argsz00_23866;
																																																																																	BgL_proc2z00_1748
																																																																																		=
																																																																																		BgL_proc2z00_23865;
																																																																																	BgL_proc1z00_1747
																																																																																		=
																																																																																		BgL_proc1z00_23864;
																																																																																	BgL_testz00_1746
																																																																																		=
																																																																																		BgL_testz00_23863;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1750;
																																																																																}
																																																																																BgL_auxz00_22040
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_23862);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1774;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_23870;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1775;
																																																																																	BgL_auxz00_22040
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_23870);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1774;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_23874;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1775;
																																																																															BgL_auxz00_22040
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_23874);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1774;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_23878;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1775;
																																																																													BgL_auxz00_22040
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_23878);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1774;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_23882;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1775;
																																																																											BgL_auxz00_22040
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_23882);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1774;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_23886;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1775;
																																																																									BgL_auxz00_22040
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_23886);
																																																																								}
																																																																						}
																																																																				}
																																																																			}
																																																																		}
																																																																	}
																																																															}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1774;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_23890;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1775;
																																																																	BgL_auxz00_22040
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_23890);
																																																																}
																																																														}
																																																												}
																																																											}
																																																									}
																																																								}
																																																						}
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_cdrzd239505zd2_6787;
																																																		BgL_cdrzd239505zd2_6787
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 118 */
																																																			bool_t
																																																				BgL_test9639z00_23894;
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_arg5509z00_6804;
																																																				BgL_arg5509z00_6804
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test9639z00_23894
																																																					=
																																																					CBOOL
																																																					(BGl_letzd2symzf3z21zzast_letz00
																																																					(BgL_arg5509z00_6804));
																																																			}
																																																			if (BgL_test9639z00_23894)
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_arg5497z00_6790;
																																																					obj_t
																																																						BgL_arg5498z00_6791;
																																																					BgL_arg5497z00_6790
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd239505zd2_6787));
																																																					BgL_arg5498z00_6791
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd239505zd2_6787));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_23903;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_23905;
																																																							obj_t
																																																								BgL_bindingsz00_23904;
																																																							BgL_bindingsz00_23904
																																																								=
																																																								BgL_arg5497z00_6790;
																																																							BgL_exprz00_23905
																																																								=
																																																								BgL_arg5498z00_6791;
																																																							BgL_exprz00_1729
																																																								=
																																																								BgL_exprz00_23905;
																																																							BgL_bindingsz00_1728
																																																								=
																																																								BgL_bindingsz00_23904;
																																																							goto
																																																								BgL_tagzd2382zd2_1730;
																																																						}
																																																						BgL_auxz00_22040
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_23903);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					bool_t
																																																						BgL_test9640z00_23907;
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_arg5508z00_6803;
																																																						BgL_arg5508z00_6803
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test9640z00_23907
																																																							=
																																																							CBOOL
																																																							(BGl_labelszd2symzf3z21zzast_labelsz00
																																																							(BgL_arg5508z00_6803));
																																																					}
																																																					if (BgL_test9640z00_23907)
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_23912;
																																																							goto
																																																								BgL_tagzd2384zd2_1732;
																																																							BgL_auxz00_22040
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_23912);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_carzd239571zd2_6794;
																																																							BgL_carzd239571zd2_6794
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_cdrzd239576zd2_6795;
																																																								BgL_cdrzd239576zd2_6795
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_carzd239571zd2_6794));
																																																								if ((CAR(((obj_t) BgL_carzd239571zd2_6794)) == CNST_TABLE_REF(((long) 3))))
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_arg5503z00_6798;
																																																										obj_t
																																																											BgL_arg5504z00_6799;
																																																										obj_t
																																																											BgL_arg5505z00_6800;
																																																										BgL_arg5503z00_6798
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_cdrzd239576zd2_6795));
																																																										BgL_arg5504z00_6799
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_cdrzd239576zd2_6795));
																																																										BgL_arg5505z00_6800
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_23929;
																																																											{
																																																												obj_t
																																																													BgL_argsz00_23932;
																																																												obj_t
																																																													BgL_bodyz00_23931;
																																																												obj_t
																																																													BgL_varsz00_23930;
																																																												BgL_varsz00_23930
																																																													=
																																																													BgL_arg5503z00_6798;
																																																												BgL_bodyz00_23931
																																																													=
																																																													BgL_arg5504z00_6799;
																																																												BgL_argsz00_23932
																																																													=
																																																													BgL_arg5505z00_6800;
																																																												BgL_argsz00_1739
																																																													=
																																																													BgL_argsz00_23932;
																																																												BgL_bodyz00_1738
																																																													=
																																																													BgL_bodyz00_23931;
																																																												BgL_varsz00_1737
																																																													=
																																																													BgL_varsz00_23930;
																																																												goto
																																																													BgL_tagzd2386zd2_1740;
																																																											}
																																																											BgL_auxz00_22040
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_23929);
																																																										}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 118 */
																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																											{	/* Ast/sexp.scm 118 */
																																																												goto
																																																													BgL_tagzd2403zd2_1774;
																																																											}
																																																										else
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_23936;
																																																												goto
																																																													BgL_tagzd2404zd2_1775;
																																																												BgL_auxz00_22040
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_23936);
																																																											}
																																																									}
																																																							}
																																																						}
																																																				}
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_cdrzd239687zd2_6805;
																																																BgL_cdrzd239687zd2_6805
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 118 */
																																																	bool_t
																																																		BgL_test9643z00_23940;
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_arg5518z00_6814;
																																																		BgL_arg5518z00_6814
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_test9643z00_23940
																																																			=
																																																			CBOOL
																																																			(BGl_letzd2symzf3z21zzast_letz00
																																																			(BgL_arg5518z00_6814));
																																																	}
																																																	if (BgL_test9643z00_23940)
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_arg5512z00_6808;
																																																			obj_t
																																																				BgL_arg5513z00_6809;
																																																			BgL_arg5512z00_6808
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd239687zd2_6805));
																																																			BgL_arg5513z00_6809
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd239687zd2_6805));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_23949;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_23951;
																																																					obj_t
																																																						BgL_bindingsz00_23950;
																																																					BgL_bindingsz00_23950
																																																						=
																																																						BgL_arg5512z00_6808;
																																																					BgL_exprz00_23951
																																																						=
																																																						BgL_arg5513z00_6809;
																																																					BgL_exprz00_1729
																																																						=
																																																						BgL_exprz00_23951;
																																																					BgL_bindingsz00_1728
																																																						=
																																																						BgL_bindingsz00_23950;
																																																					goto
																																																						BgL_tagzd2382zd2_1730;
																																																				}
																																																				BgL_auxz00_22040
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_23949);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			bool_t
																																																				BgL_test9644z00_23953;
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_arg5517z00_6813;
																																																				BgL_arg5517z00_6813
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test9644z00_23953
																																																					=
																																																					CBOOL
																																																					(BGl_labelszd2symzf3z21zzast_labelsz00
																																																					(BgL_arg5517z00_6813));
																																																			}
																																																			if (BgL_test9644z00_23953)
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_23958;
																																																					goto
																																																						BgL_tagzd2384zd2_1732;
																																																					BgL_auxz00_22040
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_23958);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																						{	/* Ast/sexp.scm 118 */
																																																							goto
																																																								BgL_tagzd2403zd2_1774;
																																																						}
																																																					else
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_23962;
																																																							goto
																																																								BgL_tagzd2404zd2_1775;
																																																							BgL_auxz00_22040
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_23962);
																																																						}
																																																				}
																																																		}
																																																}
																																															}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd238252zd2_6541)))
																																															{	/* Ast/sexp.scm 118 */
																																																goto
																																																	BgL_kapzd238254zd2_6543;
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																if ((BgL_carzd238252zd2_6541 == CNST_TABLE_REF(((long) 18))))
																																																	{	/* Ast/sexp.scm 118 */
																																																		goto
																																																			BgL_kapzd238254zd2_6543;
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		if ((BgL_carzd238252zd2_6541 == CNST_TABLE_REF(((long) 19))))
																																																			{	/* Ast/sexp.scm 118 */
																																																				goto
																																																					BgL_kapzd238254zd2_6543;
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 118 */
																																																				if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd238252zd2_6541)))
																																																					{	/* Ast/sexp.scm 118 */
																																																						goto
																																																							BgL_kapzd238254zd2_6543;
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_cdrzd239859zd2_6549;
																																																						BgL_cdrzd239859zd2_6549
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{	/* Ast/sexp.scm 118 */
																																																							bool_t
																																																								BgL_test9650z00_23978;
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_arg5418z00_6666;
																																																								BgL_arg5418z00_6666
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test9650z00_23978
																																																									=
																																																									CBOOL
																																																									(BGl_letzd2symzf3z21zzast_letz00
																																																									(BgL_arg5418z00_6666));
																																																							}
																																																							if (BgL_test9650z00_23978)
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_arg5346z00_6552;
																																																									obj_t
																																																										BgL_arg5347z00_6553;
																																																									BgL_arg5346z00_6552
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd239859zd2_6549));
																																																									BgL_arg5347z00_6553
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd239859zd2_6549));
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_23987;
																																																										{
																																																											obj_t
																																																												BgL_exprz00_23989;
																																																											obj_t
																																																												BgL_bindingsz00_23988;
																																																											BgL_bindingsz00_23988
																																																												=
																																																												BgL_arg5346z00_6552;
																																																											BgL_exprz00_23989
																																																												=
																																																												BgL_arg5347z00_6553;
																																																											BgL_exprz00_1729
																																																												=
																																																												BgL_exprz00_23989;
																																																											BgL_bindingsz00_1728
																																																												=
																																																												BgL_bindingsz00_23988;
																																																											goto
																																																												BgL_tagzd2382zd2_1730;
																																																										}
																																																										BgL_auxz00_22040
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_23987);
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									bool_t
																																																										BgL_test9651z00_23991;
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_arg5417z00_6665;
																																																										BgL_arg5417z00_6665
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_test9651z00_23991
																																																											=
																																																											CBOOL
																																																											(BGl_labelszd2symzf3z21zzast_labelsz00
																																																											(BgL_arg5417z00_6665));
																																																									}
																																																									if (BgL_test9651z00_23991)
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_23996;
																																																											goto
																																																												BgL_tagzd2384zd2_1732;
																																																											BgL_auxz00_22040
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_23996);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_carzd239925zd2_6556;
																																																											BgL_carzd239925zd2_6556
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_cdrzd239930zd2_6557;
																																																												BgL_cdrzd239930zd2_6557
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_carzd239925zd2_6556));
																																																												if ((CAR(((obj_t) BgL_carzd239925zd2_6556)) == CNST_TABLE_REF(((long) 3))))
																																																													{	/* Ast/sexp.scm 118 */
																																																														if (PAIRP(BgL_cdrzd239930zd2_6557))
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_arg5353z00_6561;
																																																																obj_t
																																																																	BgL_arg5354z00_6562;
																																																																obj_t
																																																																	BgL_arg5355z00_6563;
																																																																BgL_arg5353z00_6561
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd239930zd2_6557);
																																																																BgL_arg5354z00_6562
																																																																	=
																																																																	CDR
																																																																	(BgL_cdrzd239930zd2_6557);
																																																																BgL_arg5355z00_6563
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_24013;
																																																																	{
																																																																		obj_t
																																																																			BgL_argsz00_24016;
																																																																		obj_t
																																																																			BgL_bodyz00_24015;
																																																																		obj_t
																																																																			BgL_varsz00_24014;
																																																																		BgL_varsz00_24014
																																																																			=
																																																																			BgL_arg5353z00_6561;
																																																																		BgL_bodyz00_24015
																																																																			=
																																																																			BgL_arg5354z00_6562;
																																																																		BgL_argsz00_24016
																																																																			=
																																																																			BgL_arg5355z00_6563;
																																																																		BgL_argsz00_1739
																																																																			=
																																																																			BgL_argsz00_24016;
																																																																		BgL_bodyz00_1738
																																																																			=
																																																																			BgL_bodyz00_24015;
																																																																		BgL_varsz00_1737
																																																																			=
																																																																			BgL_varsz00_24014;
																																																																		goto
																																																																			BgL_tagzd2386zd2_1740;
																																																																	}
																																																																	BgL_auxz00_22040
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_24013);
																																																																}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1774;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_24020;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1775;
																																																																		BgL_auxz00_22040
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_24020);
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_cdrzd240037zd2_6566;
																																																														BgL_cdrzd240037zd2_6566
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_cdrzd240042zd2_6567;
																																																															BgL_cdrzd240042zd2_6567
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_carzd239925zd2_6556));
																																																															if ((CAR(((obj_t) BgL_carzd239925zd2_6556)) == CNST_TABLE_REF(((long) 1))))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if (PAIRP(BgL_cdrzd240042zd2_6567))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_cdrzd240047zd2_6571;
																																																																			BgL_cdrzd240047zd2_6571
																																																																				=
																																																																				CDR
																																																																				(BgL_cdrzd240042zd2_6567);
																																																																			if (PAIRP(BgL_cdrzd240047zd2_6571))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_carzd240051zd2_6573;
																																																																					obj_t
																																																																						BgL_cdrzd240052zd2_6574;
																																																																					BgL_carzd240051zd2_6573
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd240047zd2_6571);
																																																																					BgL_cdrzd240052zd2_6574
																																																																						=
																																																																						CDR
																																																																						(BgL_cdrzd240047zd2_6571);
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd240051zd2_6573))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (PAIRP(BgL_cdrzd240052zd2_6574))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_carzd240057zd2_6577;
																																																																									BgL_carzd240057zd2_6577
																																																																										=
																																																																										CAR
																																																																										(BgL_cdrzd240052zd2_6574);
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd240057zd2_6577))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (NULLP(CDR(BgL_cdrzd240052zd2_6574)))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													bool_t
																																																																														BgL_test9662z00_24048;
																																																																													{
																																																																														obj_t
																																																																															BgL_l1433z00_6610;
																																																																														BgL_l1433z00_6610
																																																																															=
																																																																															BgL_cdrzd240037zd2_6566;
																																																																													BgL_zc3z04anonymousza35381ze3z87_6611:
																																																																														if (NULLP(BgL_l1433z00_6610))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																BgL_test9662z00_24048
																																																																																	=
																																																																																	(
																																																																																	(bool_t)
																																																																																	1);
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																bool_t
																																																																																	BgL_test9664z00_24051;
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	bool_t
																																																																																		BgL_test9665z00_24052;
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		obj_t
																																																																																			BgL_tmpz00_24053;
																																																																																		BgL_tmpz00_24053
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_l1433z00_6610));
																																																																																		BgL_test9665z00_24052
																																																																																			=
																																																																																			PAIRP
																																																																																			(BgL_tmpz00_24053);
																																																																																	}
																																																																																	if (BgL_test9665z00_24052)
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			BgL_test9664z00_24051
																																																																																				=
																																																																																				(
																																																																																				(bool_t)
																																																																																				0);
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			BgL_test9664z00_24051
																																																																																				=
																																																																																				(
																																																																																				(bool_t)
																																																																																				1);
																																																																																		}
																																																																																}
																																																																																if (BgL_test9664z00_24051)
																																																																																	{
																																																																																		obj_t
																																																																																			BgL_l1433z00_24057;
																																																																																		BgL_l1433z00_24057
																																																																																			=
																																																																																			CDR
																																																																																			(
																																																																																			((obj_t) BgL_l1433z00_6610));
																																																																																		BgL_l1433z00_6610
																																																																																			=
																																																																																			BgL_l1433z00_24057;
																																																																																		goto
																																																																																			BgL_zc3z04anonymousza35381ze3z87_6611;
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		BgL_test9662z00_24048
																																																																																			=
																																																																																			(
																																																																																			(bool_t)
																																																																																			0);
																																																																																	}
																																																																															}
																																																																													}
																																																																													if (BgL_test9662z00_24048)
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_arg5371z00_6593;
																																																																															BgL_arg5371z00_6593
																																																																																=
																																																																																CAR
																																																																																(BgL_cdrzd240042zd2_6567);
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_24061;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_24065;
																																																																																	obj_t
																																																																																		BgL_proc2z00_24064;
																																																																																	obj_t
																																																																																		BgL_proc1z00_24063;
																																																																																	obj_t
																																																																																		BgL_testz00_24062;
																																																																																	BgL_testz00_24062
																																																																																		=
																																																																																		BgL_arg5371z00_6593;
																																																																																	BgL_proc1z00_24063
																																																																																		=
																																																																																		BgL_carzd240051zd2_6573;
																																																																																	BgL_proc2z00_24064
																																																																																		=
																																																																																		BgL_carzd240057zd2_6577;
																																																																																	BgL_argsz00_24065
																																																																																		=
																																																																																		BgL_cdrzd240037zd2_6566;
																																																																																	BgL_argsz00_1744
																																																																																		=
																																																																																		BgL_argsz00_24065;
																																																																																	BgL_proc2z00_1743
																																																																																		=
																																																																																		BgL_proc2z00_24064;
																																																																																	BgL_proc1z00_1742
																																																																																		=
																																																																																		BgL_proc1z00_24063;
																																																																																	BgL_testz00_1741
																																																																																		=
																																																																																		BgL_testz00_24062;
																																																																																	goto
																																																																																		BgL_tagzd2387zd2_1745;
																																																																																}
																																																																																BgL_auxz00_22040
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_24061);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_cdrzd240082zd2_6594;
																																																																															BgL_cdrzd240082zd2_6594
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_cdrzd240090zd2_6595;
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_pairz00_12272;
																																																																																	BgL_pairz00_12272
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_expz00_21));
																																																																																	BgL_cdrzd240090zd2_6595
																																																																																		=
																																																																																		CDR
																																																																																		(BgL_pairz00_12272);
																																																																																}
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_cdrzd240098zd2_6596;
																																																																																	BgL_cdrzd240098zd2_6596
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd240090zd2_6595));
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		obj_t
																																																																																			BgL_carzd240105zd2_6597;
																																																																																		BgL_carzd240105zd2_6597
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd240098zd2_6596));
																																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd240105zd2_6597))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				obj_t
																																																																																					BgL_carzd240114zd2_6599;
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					obj_t
																																																																																						BgL_pairz00_12276;
																																																																																					BgL_pairz00_12276
																																																																																						=
																																																																																						CDR
																																																																																						(
																																																																																						((obj_t) BgL_cdrzd240098zd2_6596));
																																																																																					BgL_carzd240114zd2_6599
																																																																																						=
																																																																																						CAR
																																																																																						(BgL_pairz00_12276);
																																																																																				}
																																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd240114zd2_6599))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd240082zd2_6594))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								obj_t
																																																																																									BgL_arg5375z00_6602;
																																																																																								BgL_arg5375z00_6602
																																																																																									=
																																																																																									CAR
																																																																																									(
																																																																																									((obj_t) BgL_cdrzd240090zd2_6595));
																																																																																								{
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_auxz00_24087;
																																																																																									{
																																																																																										obj_t
																																																																																											BgL_argsz00_24091;
																																																																																										obj_t
																																																																																											BgL_proc2z00_24090;
																																																																																										obj_t
																																																																																											BgL_proc1z00_24089;
																																																																																										obj_t
																																																																																											BgL_testz00_24088;
																																																																																										BgL_testz00_24088
																																																																																											=
																																																																																											BgL_arg5375z00_6602;
																																																																																										BgL_proc1z00_24089
																																																																																											=
																																																																																											BgL_carzd240105zd2_6597;
																																																																																										BgL_proc2z00_24090
																																																																																											=
																																																																																											BgL_carzd240114zd2_6599;
																																																																																										BgL_argsz00_24091
																																																																																											=
																																																																																											BgL_cdrzd240082zd2_6594;
																																																																																										BgL_argsz00_1749
																																																																																											=
																																																																																											BgL_argsz00_24091;
																																																																																										BgL_proc2z00_1748
																																																																																											=
																																																																																											BgL_proc2z00_24090;
																																																																																										BgL_proc1z00_1747
																																																																																											=
																																																																																											BgL_proc1z00_24089;
																																																																																										BgL_testz00_1746
																																																																																											=
																																																																																											BgL_testz00_24088;
																																																																																										goto
																																																																																											BgL_tagzd2388zd2_1750;
																																																																																									}
																																																																																									BgL_auxz00_22040
																																																																																										=
																																																																																										(
																																																																																										(obj_t)
																																																																																										BgL_auxz00_24087);
																																																																																								}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1774;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_24095;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1775;
																																																																																										BgL_auxz00_22040
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_24095);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1774;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_24099;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1775;
																																																																																								BgL_auxz00_22040
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_24099);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1774;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_24103;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1775;
																																																																																						BgL_auxz00_22040
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_24103);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																}
																																																																															}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1774;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_24107;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1775;
																																																																															BgL_auxz00_22040
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_24107);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_cdrzd240392zd2_6621;
																																																																											BgL_cdrzd240392zd2_6621
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_cdrzd240399zd2_6622;
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_pairz00_12280;
																																																																													BgL_pairz00_12280
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													BgL_cdrzd240399zd2_6622
																																																																														=
																																																																														CDR
																																																																														(BgL_pairz00_12280);
																																																																												}
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_cdrzd240406zd2_6623;
																																																																													BgL_cdrzd240406zd2_6623
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd240399zd2_6622));
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_carzd240412zd2_6624;
																																																																														obj_t
																																																																															BgL_cdrzd240413zd2_6625;
																																																																														BgL_carzd240412zd2_6624
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd240406zd2_6623));
																																																																														BgL_cdrzd240413zd2_6625
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd240406zd2_6623));
																																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd240412zd2_6624))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_carzd240420zd2_6627;
																																																																																BgL_carzd240420zd2_6627
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd240413zd2_6625));
																																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd240420zd2_6627))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (NULLP(CDR(((obj_t) BgL_cdrzd240413zd2_6625))))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd240392zd2_6621))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						obj_t
																																																																																							BgL_arg5390z00_6632;
																																																																																						BgL_arg5390z00_6632
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_cdrzd240399zd2_6622));
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_24134;
																																																																																							{
																																																																																								obj_t
																																																																																									BgL_argsz00_24138;
																																																																																								obj_t
																																																																																									BgL_proc2z00_24137;
																																																																																								obj_t
																																																																																									BgL_proc1z00_24136;
																																																																																								obj_t
																																																																																									BgL_testz00_24135;
																																																																																								BgL_testz00_24135
																																																																																									=
																																																																																									BgL_arg5390z00_6632;
																																																																																								BgL_proc1z00_24136
																																																																																									=
																																																																																									BgL_carzd240412zd2_6624;
																																																																																								BgL_proc2z00_24137
																																																																																									=
																																																																																									BgL_carzd240420zd2_6627;
																																																																																								BgL_argsz00_24138
																																																																																									=
																																																																																									BgL_cdrzd240392zd2_6621;
																																																																																								BgL_argsz00_1749
																																																																																									=
																																																																																									BgL_argsz00_24138;
																																																																																								BgL_proc2z00_1748
																																																																																									=
																																																																																									BgL_proc2z00_24137;
																																																																																								BgL_proc1z00_1747
																																																																																									=
																																																																																									BgL_proc1z00_24136;
																																																																																								BgL_testz00_1746
																																																																																									=
																																																																																									BgL_testz00_24135;
																																																																																								goto
																																																																																									BgL_tagzd2388zd2_1750;
																																																																																							}
																																																																																							BgL_auxz00_22040
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_24134);
																																																																																						}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1774;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_24142;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1775;
																																																																																								BgL_auxz00_22040
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_24142);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1774;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_24146;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1775;
																																																																																						BgL_auxz00_22040
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_24146);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1774;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_24150;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1775;
																																																																																				BgL_auxz00_22040
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_24150);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1774;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_24154;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1775;
																																																																																		BgL_auxz00_22040
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_24154);
																																																																																	}
																																																																															}
																																																																													}
																																																																												}
																																																																											}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1774;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_24158;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1775;
																																																																											BgL_auxz00_22040
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_24158);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_cdrzd240753zd2_6640;
																																																																							BgL_cdrzd240753zd2_6640
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_cdrzd240759zd2_6641;
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_pairz00_12290;
																																																																									BgL_pairz00_12290
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									BgL_cdrzd240759zd2_6641
																																																																										=
																																																																										CDR
																																																																										(BgL_pairz00_12290);
																																																																								}
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_cdrzd240765zd2_6642;
																																																																									BgL_cdrzd240765zd2_6642
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd240759zd2_6641));
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_carzd240770zd2_6643;
																																																																										obj_t
																																																																											BgL_cdrzd240771zd2_6644;
																																																																										BgL_carzd240770zd2_6643
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd240765zd2_6642));
																																																																										BgL_cdrzd240771zd2_6644
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd240765zd2_6642));
																																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd240770zd2_6643))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												if (PAIRP(BgL_cdrzd240771zd2_6644))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_carzd240776zd2_6647;
																																																																														BgL_carzd240776zd2_6647
																																																																															=
																																																																															CAR
																																																																															(BgL_cdrzd240771zd2_6644);
																																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd240776zd2_6647))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (NULLP(CDR(BgL_cdrzd240771zd2_6644)))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd240753zd2_6640))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				obj_t
																																																																																					BgL_arg5404z00_6652;
																																																																																				BgL_arg5404z00_6652
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd240759zd2_6641));
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_24185;
																																																																																					{
																																																																																						obj_t
																																																																																							BgL_argsz00_24189;
																																																																																						obj_t
																																																																																							BgL_proc2z00_24188;
																																																																																						obj_t
																																																																																							BgL_proc1z00_24187;
																																																																																						obj_t
																																																																																							BgL_testz00_24186;
																																																																																						BgL_testz00_24186
																																																																																							=
																																																																																							BgL_arg5404z00_6652;
																																																																																						BgL_proc1z00_24187
																																																																																							=
																																																																																							BgL_carzd240770zd2_6643;
																																																																																						BgL_proc2z00_24188
																																																																																							=
																																																																																							BgL_carzd240776zd2_6647;
																																																																																						BgL_argsz00_24189
																																																																																							=
																																																																																							BgL_cdrzd240753zd2_6640;
																																																																																						BgL_argsz00_1749
																																																																																							=
																																																																																							BgL_argsz00_24189;
																																																																																						BgL_proc2z00_1748
																																																																																							=
																																																																																							BgL_proc2z00_24188;
																																																																																						BgL_proc1z00_1747
																																																																																							=
																																																																																							BgL_proc1z00_24187;
																																																																																						BgL_testz00_1746
																																																																																							=
																																																																																							BgL_testz00_24186;
																																																																																						goto
																																																																																							BgL_tagzd2388zd2_1750;
																																																																																					}
																																																																																					BgL_auxz00_22040
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_24185);
																																																																																				}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1774;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_24193;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1775;
																																																																																						BgL_auxz00_22040
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_24193);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1774;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_24197;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1775;
																																																																																				BgL_auxz00_22040
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_24197);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1774;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_24201;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1775;
																																																																																		BgL_auxz00_22040
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_24201);
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1774;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_24205;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1775;
																																																																																BgL_auxz00_22040
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_24205);
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1774;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_24209;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1775;
																																																																														BgL_auxz00_22040
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_24209);
																																																																													}
																																																																											}
																																																																									}
																																																																								}
																																																																							}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1774;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_24213;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1775;
																																																																							BgL_auxz00_22040
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_24213);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1774;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_24217;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1775;
																																																																					BgL_auxz00_22040
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_24217);
																																																																				}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1774;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_24221;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1775;
																																																																			BgL_auxz00_22040
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_24221);
																																																																		}
																																																																}
																																																														}
																																																													}
																																																											}
																																																										}
																																																								}
																																																						}
																																																					}
																																																			}
																																																	}
																																															}
																																													}
																																											}
																																										}
																																									else
																																										{	/* Ast/sexp.scm 118 */
																																											obj_t
																																												BgL_cdrzd241314zd2_6816;
																																											BgL_cdrzd241314zd2_6816
																																												=
																																												CDR
																																												(
																																												((obj_t) BgL_expz00_21));
																																											if ((BgL_carzd238249zd2_6539 == CNST_TABLE_REF(((long) 17))))
																																												{	/* Ast/sexp.scm 118 */
																																													obj_t
																																														BgL_arg5520z00_6818;
																																													obj_t
																																														BgL_arg5521z00_6819;
																																													BgL_arg5520z00_6818
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_cdrzd241314zd2_6816));
																																													BgL_arg5521z00_6819
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_cdrzd241314zd2_6816));
																																													{
																																														BgL_nodez00_bglt
																																															BgL_auxz00_24232;
																																														{
																																															obj_t
																																																BgL_exprz00_24234;
																																															obj_t
																																																BgL_bindingsz00_24233;
																																															BgL_bindingsz00_24233
																																																=
																																																BgL_arg5520z00_6818;
																																															BgL_exprz00_24234
																																																=
																																																BgL_arg5521z00_6819;
																																															BgL_exprz00_1729
																																																=
																																																BgL_exprz00_24234;
																																															BgL_bindingsz00_1728
																																																=
																																																BgL_bindingsz00_24233;
																																															goto
																																																BgL_tagzd2382zd2_1730;
																																														}
																																														BgL_auxz00_22040
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_24232);
																																													}
																																												}
																																											else
																																												{	/* Ast/sexp.scm 118 */
																																													if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd238249zd2_6539)))
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_arg5523z00_6821;
																																															obj_t
																																																BgL_arg5524z00_6822;
																																															BgL_arg5523z00_6821
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd241314zd2_6816));
																																															BgL_arg5524z00_6822
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd241314zd2_6816));
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_24243;
																																																{
																																																	obj_t
																																																		BgL_exprz00_24245;
																																																	obj_t
																																																		BgL_bindingsz00_24244;
																																																	BgL_bindingsz00_24244
																																																		=
																																																		BgL_arg5523z00_6821;
																																																	BgL_exprz00_24245
																																																		=
																																																		BgL_arg5524z00_6822;
																																																	BgL_exprz00_1729
																																																		=
																																																		BgL_exprz00_24245;
																																																	BgL_bindingsz00_1728
																																																		=
																																																		BgL_bindingsz00_24244;
																																																	goto
																																																		BgL_tagzd2382zd2_1730;
																																																}
																																																BgL_auxz00_22040
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_24243);
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 118 */
																																															if ((BgL_carzd238249zd2_6539 == CNST_TABLE_REF(((long) 18))))
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_arg5526z00_6824;
																																																	obj_t
																																																		BgL_arg5527z00_6825;
																																																	BgL_arg5526z00_6824
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd241314zd2_6816));
																																																	BgL_arg5527z00_6825
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd241314zd2_6816));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_24254;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_24256;
																																																			obj_t
																																																				BgL_bindingsz00_24255;
																																																			BgL_bindingsz00_24255
																																																				=
																																																				BgL_arg5526z00_6824;
																																																			BgL_exprz00_24256
																																																				=
																																																				BgL_arg5527z00_6825;
																																																			BgL_exprz00_1729
																																																				=
																																																				BgL_exprz00_24256;
																																																			BgL_bindingsz00_1728
																																																				=
																																																				BgL_bindingsz00_24255;
																																																			goto
																																																				BgL_tagzd2382zd2_1730;
																																																		}
																																																		BgL_auxz00_22040
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_24254);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_24263;
																																																			goto
																																																				BgL_tagzd2383zd2_1731;
																																																			BgL_auxz00_22040
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_24263);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_carzd241351zd2_6828;
																																																			BgL_carzd241351zd2_6828
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			if ((BgL_carzd241351zd2_6828 == CNST_TABLE_REF(((long) 19))))
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_24270;
																																																					goto
																																																						BgL_tagzd2384zd2_1732;
																																																					BgL_auxz00_22040
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_24270);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd241351zd2_6828)))
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_24275;
																																																							goto
																																																								BgL_tagzd2384zd2_1732;
																																																							BgL_auxz00_22040
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_24275);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_24282;
																																																									goto
																																																										BgL_tagzd2389zd2_1751;
																																																									BgL_auxz00_22040
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_24282);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_24289;
																																																											goto
																																																												BgL_tagzd2390zd2_1752;
																																																											BgL_auxz00_22040
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_24289);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_cdrzd241431zd2_6835;
																																																											BgL_cdrzd241431zd2_6835
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_arg5538z00_6838;
																																																													obj_t
																																																														BgL_arg5539z00_6839;
																																																													BgL_arg5538z00_6838
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_cdrzd241431zd2_6835));
																																																													BgL_arg5539z00_6839
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd241431zd2_6835));
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_24302;
																																																														{
																																																															obj_t
																																																																BgL_restz00_24304;
																																																															obj_t
																																																																BgL_effectz00_24303;
																																																															BgL_effectz00_24303
																																																																=
																																																																BgL_arg5538z00_6838;
																																																															BgL_restz00_24304
																																																																=
																																																																BgL_arg5539z00_6839;
																																																															BgL_restz00_1754
																																																																=
																																																																BgL_restz00_24304;
																																																															BgL_effectz00_1753
																																																																=
																																																																BgL_effectz00_24303;
																																																															goto
																																																																BgL_tagzd2391zd2_1755;
																																																														}
																																																														BgL_auxz00_22040
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_24302);
																																																													}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_24311;
																																																															goto
																																																																BgL_tagzd2392zd2_1756;
																																																															BgL_auxz00_22040
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_24311);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_24318;
																																																																	goto
																																																																		BgL_tagzd2393zd2_1757;
																																																																	BgL_auxz00_22040
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_24318);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_arg5546z00_6847;
																																																																			obj_t
																																																																				BgL_arg5547z00_6848;
																																																																			BgL_arg5546z00_6847
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd241431zd2_6835));
																																																																			BgL_arg5547z00_6848
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd241431zd2_6835));
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_24329;
																																																																				{
																																																																					obj_t
																																																																						BgL_restz00_24331;
																																																																					obj_t
																																																																						BgL_effectz00_24330;
																																																																					BgL_effectz00_24330
																																																																						=
																																																																						BgL_arg5546z00_6847;
																																																																					BgL_restz00_24331
																																																																						=
																																																																						BgL_arg5547z00_6848;
																																																																					BgL_restz00_1759
																																																																						=
																																																																						BgL_restz00_24331;
																																																																					BgL_effectz00_1758
																																																																						=
																																																																						BgL_effectz00_24330;
																																																																					goto
																																																																						BgL_tagzd2394zd2_1760;
																																																																				}
																																																																				BgL_auxz00_22040
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_24329);
																																																																			}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_24338;
																																																																					goto
																																																																						BgL_tagzd2395zd2_1761;
																																																																					BgL_auxz00_22040
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_24338);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_24345;
																																																																							goto
																																																																								BgL_tagzd2396zd2_1762;
																																																																							BgL_auxz00_22040
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_24345);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																								{
																																																																									BgL_letzd2funzd2_bglt
																																																																										BgL_auxz00_24352;
																																																																									goto
																																																																										BgL_tagzd2397zd2_1763;
																																																																									BgL_auxz00_22040
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_24352);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																										{
																																																																											BgL_jumpzd2exzd2itz00_bglt
																																																																												BgL_auxz00_24359;
																																																																											goto
																																																																												BgL_tagzd2398zd2_1764;
																																																																											BgL_auxz00_22040
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_24359);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_cdrzd241508zd2_6857;
																																																																											BgL_cdrzd241508zd2_6857
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_arg5558z00_6860;
																																																																													obj_t
																																																																														BgL_arg5559z00_6861;
																																																																													BgL_arg5558z00_6860
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd241508zd2_6857));
																																																																													BgL_arg5559z00_6861
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd241508zd2_6857));
																																																																													{	/* Ast/sexp.scm 551 */
																																																																														obj_t
																																																																															BgL_arg6989z00_12329;
																																																																														BgL_arg6989z00_12329
																																																																															=
																																																																															BGl_findzd2locationzf2locz20zztools_locationz00
																																																																															(BgL_expz00_21,
																																																																															BgL_locz00_23);
																																																																														BgL_auxz00_22040
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																															(BgL_expz00_21,
																																																																																BgL_arg5558z00_6860,
																																																																																CNST_TABLE_REF
																																																																																(((long) 4)), BgL_arg5559z00_6861, BgL_stackz00_22, BgL_arg6989z00_12329, BgL_sitez00_24));
																																																																												}}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1774;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_24378;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1775;
																																																																															BgL_auxz00_22040
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_24378);
																																																																														}
																																																																												}
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																													else
																														{	/* Ast/sexp.scm 118 */
																															obj_t
																																BgL_carzd241533zd2_6878;
																															BgL_carzd241533zd2_6878
																																=
																																CAR(((obj_t)
																																	BgL_expz00_21));
																															if (
																																(BgL_carzd241533zd2_6878
																																	==
																																	CNST_TABLE_REF
																																	(((long) 1))))
																																{
																																	BgL_nodez00_bglt
																																		BgL_auxz00_24385;
																																	goto
																																		BgL_tagzd2377zd2_1719;
																																	BgL_auxz00_22040
																																		=
																																		((obj_t)
																																		BgL_auxz00_24385);
																																}
																															else
																																{	/* Ast/sexp.scm 118 */
																																	if (
																																		(BgL_carzd241533zd2_6878
																																			==
																																			BGl_za2ifza2z00zzast_sexpz00))
																																		{
																																			BgL_nodez00_bglt
																																				BgL_auxz00_24389;
																																			goto
																																				BgL_tagzd2377zd2_1719;
																																			BgL_auxz00_22040
																																				=
																																				((obj_t)
																																				BgL_auxz00_24389);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 118 */
																																			obj_t
																																				BgL_cdrzd241555zd2_6881;
																																			BgL_cdrzd241555zd2_6881
																																				=
																																				CDR((
																																					(obj_t)
																																					BgL_expz00_21));
																																			if ((CAR((
																																							(obj_t)
																																							BgL_expz00_21))
																																					==
																																					CNST_TABLE_REF
																																					(((long) 7))))
																																				{	/* Ast/sexp.scm 118 */
																																					obj_t
																																						BgL_carzd241558zd2_6884;
																																					obj_t
																																						BgL_cdrzd241559zd2_6885;
																																					BgL_carzd241558zd2_6884
																																						=
																																						CAR(
																																						((obj_t) BgL_cdrzd241555zd2_6881));
																																					BgL_cdrzd241559zd2_6885
																																						=
																																						CDR(
																																						((obj_t) BgL_cdrzd241555zd2_6881));
																																					if (PAIRP(BgL_carzd241558zd2_6884))
																																						{	/* Ast/sexp.scm 118 */
																																							if ((CAR(BgL_carzd241558zd2_6884) == CNST_TABLE_REF(((long) 14))))
																																								{	/* Ast/sexp.scm 118 */
																																									if (NULLP(CDR(((obj_t) BgL_cdrzd241559zd2_6885))))
																																										{	/* Ast/sexp.scm 118 */
																																											obj_t
																																												BgL_arg5585z00_6891;
																																											obj_t
																																												BgL_arg5586z00_6892;
																																											BgL_arg5585z00_6891
																																												=
																																												CDR
																																												(BgL_carzd241558zd2_6884);
																																											BgL_arg5586z00_6892
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_cdrzd241559zd2_6885));
																																											{
																																												BgL_nodez00_bglt
																																													BgL_auxz00_24415;
																																												{
																																													obj_t
																																														BgL_valz00_24417;
																																													obj_t
																																														BgL_lz00_24416;
																																													BgL_lz00_24416
																																														=
																																														BgL_arg5585z00_6891;
																																													BgL_valz00_24417
																																														=
																																														BgL_arg5586z00_6892;
																																													BgL_valz00_1721
																																														=
																																														BgL_valz00_24417;
																																													BgL_lz00_1720
																																														=
																																														BgL_lz00_24416;
																																													goto
																																														BgL_tagzd2378zd2_1722;
																																												}
																																												BgL_auxz00_22040
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_24415);
																																											}
																																										}
																																									else
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_24419;
																																											goto
																																												BgL_tagzd2379zd2_1723;
																																											BgL_auxz00_22040
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_24419);
																																										}
																																								}
																																							else
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_24421;
																																									goto
																																										BgL_tagzd2379zd2_1723;
																																									BgL_auxz00_22040
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_24421);
																																								}
																																						}
																																					else
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_24423;
																																							goto
																																								BgL_tagzd2379zd2_1723;
																																							BgL_auxz00_22040
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_24423);
																																						}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 118 */
																																					if (
																																						(CAR
																																							(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_24430;
																																							goto
																																								BgL_tagzd2380zd2_1724;
																																							BgL_auxz00_22040
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_24430);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 118 */
																																							obj_t
																																								BgL_carzd241656zd2_6897;
																																							BgL_carzd241656zd2_6897
																																								=
																																								CAR
																																								(
																																								((obj_t) BgL_expz00_21));
																																							if (PAIRP(BgL_carzd241656zd2_6897))
																																								{	/* Ast/sexp.scm 118 */
																																									obj_t
																																										BgL_carzd241659zd2_6899;
																																									obj_t
																																										BgL_cdrzd241660zd2_6900;
																																									BgL_carzd241659zd2_6899
																																										=
																																										CAR
																																										(BgL_carzd241656zd2_6897);
																																									BgL_cdrzd241660zd2_6900
																																										=
																																										CDR
																																										(BgL_carzd241656zd2_6897);
																																									{

																																										if ((BgL_carzd241659zd2_6899 == CNST_TABLE_REF(((long) 17))))
																																											{	/* Ast/sexp.scm 118 */
																																											BgL_kapzd241661zd2_6901:
																																												if (PAIRP(BgL_cdrzd241660zd2_6900))
																																													{	/* Ast/sexp.scm 118 */
																																														obj_t
																																															BgL_cdrzd241664zd2_7026;
																																														BgL_cdrzd241664zd2_7026
																																															=
																																															CDR
																																															(BgL_cdrzd241660zd2_6900);
																																														if (PAIRP(BgL_cdrzd241664zd2_7026))
																																															{	/* Ast/sexp.scm 118 */
																																																if (NULLP(CDR(BgL_cdrzd241664zd2_7026)))
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_arg5676z00_7030;
																																																		obj_t
																																																			BgL_arg5677z00_7031;
																																																		BgL_arg5676z00_7030
																																																			=
																																																			CAR
																																																			(BgL_cdrzd241664zd2_7026);
																																																		BgL_arg5677z00_7031
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_24452;
																																																			{
																																																				obj_t
																																																					BgL_argsz00_24454;
																																																				obj_t
																																																					BgL_bodyz00_24453;
																																																				BgL_bodyz00_24453
																																																					=
																																																					BgL_arg5676z00_7030;
																																																				BgL_argsz00_24454
																																																					=
																																																					BgL_arg5677z00_7031;
																																																				BgL_argsz00_1726
																																																					=
																																																					BgL_argsz00_24454;
																																																				BgL_bodyz00_1725
																																																					=
																																																					BgL_bodyz00_24453;
																																																				goto
																																																					BgL_tagzd2381zd2_1727;
																																																			}
																																																			BgL_auxz00_22040
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_24452);
																																																		}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_cdrzd241688zd2_7032;
																																																		BgL_cdrzd241688zd2_7032
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 118 */
																																																			bool_t
																																																				BgL_test9725z00_24458;
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_arg5746z00_7143;
																																																				BgL_arg5746z00_7143
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test9725z00_24458
																																																					=
																																																					CBOOL
																																																					(BGl_letzd2symzf3z21zzast_letz00
																																																					(BgL_arg5746z00_7143));
																																																			}
																																																			if (BgL_test9725z00_24458)
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_arg5680z00_7035;
																																																					obj_t
																																																						BgL_arg5681z00_7036;
																																																					BgL_arg5680z00_7035
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd241688zd2_7032));
																																																					BgL_arg5681z00_7036
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd241688zd2_7032));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_24467;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_24469;
																																																							obj_t
																																																								BgL_bindingsz00_24468;
																																																							BgL_bindingsz00_24468
																																																								=
																																																								BgL_arg5680z00_7035;
																																																							BgL_exprz00_24469
																																																								=
																																																								BgL_arg5681z00_7036;
																																																							BgL_exprz00_1729
																																																								=
																																																								BgL_exprz00_24469;
																																																							BgL_bindingsz00_1728
																																																								=
																																																								BgL_bindingsz00_24468;
																																																							goto
																																																								BgL_tagzd2382zd2_1730;
																																																						}
																																																						BgL_auxz00_22040
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_24467);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					bool_t
																																																						BgL_test9726z00_24471;
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_arg5745z00_7142;
																																																						BgL_arg5745z00_7142
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test9726z00_24471
																																																							=
																																																							CBOOL
																																																							(BGl_labelszd2symzf3z21zzast_labelsz00
																																																							(BgL_arg5745z00_7142));
																																																					}
																																																					if (BgL_test9726z00_24471)
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_24476;
																																																							goto
																																																								BgL_tagzd2384zd2_1732;
																																																							BgL_auxz00_22040
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_24476);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_carzd241755zd2_7039;
																																																							BgL_carzd241755zd2_7039
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_cdrzd241760zd2_7040;
																																																								BgL_cdrzd241760zd2_7040
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_carzd241755zd2_7039));
																																																								if ((CAR(((obj_t) BgL_carzd241755zd2_7039)) == CNST_TABLE_REF(((long) 3))))
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_arg5686z00_7043;
																																																										obj_t
																																																											BgL_arg5687z00_7044;
																																																										obj_t
																																																											BgL_arg5688z00_7045;
																																																										BgL_arg5686z00_7043
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_cdrzd241760zd2_7040));
																																																										BgL_arg5687z00_7044
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_cdrzd241760zd2_7040));
																																																										BgL_arg5688z00_7045
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_24493;
																																																											{
																																																												obj_t
																																																													BgL_argsz00_24496;
																																																												obj_t
																																																													BgL_bodyz00_24495;
																																																												obj_t
																																																													BgL_varsz00_24494;
																																																												BgL_varsz00_24494
																																																													=
																																																													BgL_arg5686z00_7043;
																																																												BgL_bodyz00_24495
																																																													=
																																																													BgL_arg5687z00_7044;
																																																												BgL_argsz00_24496
																																																													=
																																																													BgL_arg5688z00_7045;
																																																												BgL_argsz00_1739
																																																													=
																																																													BgL_argsz00_24496;
																																																												BgL_bodyz00_1738
																																																													=
																																																													BgL_bodyz00_24495;
																																																												BgL_varsz00_1737
																																																													=
																																																													BgL_varsz00_24494;
																																																												goto
																																																													BgL_tagzd2386zd2_1740;
																																																											}
																																																											BgL_auxz00_22040
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_24493);
																																																										}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_cdrzd241783zd2_7047;
																																																										BgL_cdrzd241783zd2_7047
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_cdrzd241789zd2_7048;
																																																											BgL_cdrzd241789zd2_7048
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_carzd241755zd2_7039));
																																																											if ((CAR(((obj_t) BgL_carzd241755zd2_7039)) == CNST_TABLE_REF(((long) 1))))
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_cdrzd241795zd2_7051;
																																																													BgL_cdrzd241795zd2_7051
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd241789zd2_7048));
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_carzd241800zd2_7052;
																																																														obj_t
																																																															BgL_cdrzd241801zd2_7053;
																																																														BgL_carzd241800zd2_7052
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd241795zd2_7051));
																																																														BgL_cdrzd241801zd2_7053
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd241795zd2_7051));
																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd241800zd2_7052))
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (PAIRP(BgL_cdrzd241801zd2_7053))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_carzd241808zd2_7056;
																																																																		BgL_carzd241808zd2_7056
																																																																			=
																																																																			CAR
																																																																			(BgL_cdrzd241801zd2_7053);
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd241808zd2_7056))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (NULLP(CDR(BgL_cdrzd241801zd2_7053)))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						bool_t
																																																																							BgL_test9733z00_24523;
																																																																						{
																																																																							obj_t
																																																																								BgL_l1436z00_7089;
																																																																							BgL_l1436z00_7089
																																																																								=
																																																																								BgL_cdrzd241783zd2_7047;
																																																																						BgL_zc3z04anonymousza35711ze3z87_7090:
																																																																							if (NULLP(BgL_l1436z00_7089))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									BgL_test9733z00_24523
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										1);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									bool_t
																																																																										BgL_test9735z00_24526;
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										bool_t
																																																																											BgL_test9736z00_24527;
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_tmpz00_24528;
																																																																											BgL_tmpz00_24528
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_l1436z00_7089));
																																																																											BgL_test9736z00_24527
																																																																												=
																																																																												PAIRP
																																																																												(BgL_tmpz00_24528);
																																																																										}
																																																																										if (BgL_test9736z00_24527)
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												BgL_test9735z00_24526
																																																																													=
																																																																													(
																																																																													(bool_t)
																																																																													0);
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												BgL_test9735z00_24526
																																																																													=
																																																																													(
																																																																													(bool_t)
																																																																													1);
																																																																											}
																																																																									}
																																																																									if (BgL_test9735z00_24526)
																																																																										{
																																																																											obj_t
																																																																												BgL_l1436z00_24532;
																																																																											BgL_l1436z00_24532
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_l1436z00_7089));
																																																																											BgL_l1436z00_7089
																																																																												=
																																																																												BgL_l1436z00_24532;
																																																																											goto
																																																																												BgL_zc3z04anonymousza35711ze3z87_7090;
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											BgL_test9733z00_24523
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												0);
																																																																										}
																																																																								}
																																																																						}
																																																																						if (BgL_test9733z00_24523)
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_arg5701z00_7072;
																																																																								BgL_arg5701z00_7072
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd241789zd2_7048));
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_24537;
																																																																									{
																																																																										obj_t
																																																																											BgL_argsz00_24541;
																																																																										obj_t
																																																																											BgL_proc2z00_24540;
																																																																										obj_t
																																																																											BgL_proc1z00_24539;
																																																																										obj_t
																																																																											BgL_testz00_24538;
																																																																										BgL_testz00_24538
																																																																											=
																																																																											BgL_arg5701z00_7072;
																																																																										BgL_proc1z00_24539
																																																																											=
																																																																											BgL_carzd241800zd2_7052;
																																																																										BgL_proc2z00_24540
																																																																											=
																																																																											BgL_carzd241808zd2_7056;
																																																																										BgL_argsz00_24541
																																																																											=
																																																																											BgL_cdrzd241783zd2_7047;
																																																																										BgL_argsz00_1744
																																																																											=
																																																																											BgL_argsz00_24541;
																																																																										BgL_proc2z00_1743
																																																																											=
																																																																											BgL_proc2z00_24540;
																																																																										BgL_proc1z00_1742
																																																																											=
																																																																											BgL_proc1z00_24539;
																																																																										BgL_testz00_1741
																																																																											=
																																																																											BgL_testz00_24538;
																																																																										goto
																																																																											BgL_tagzd2387zd2_1745;
																																																																									}
																																																																									BgL_auxz00_22040
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_24537);
																																																																								}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_cdrzd241832zd2_7073;
																																																																								BgL_cdrzd241832zd2_7073
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_cdrzd241839zd2_7074;
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_pairz00_12382;
																																																																										BgL_pairz00_12382
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										BgL_cdrzd241839zd2_7074
																																																																											=
																																																																											CDR
																																																																											(BgL_pairz00_12382);
																																																																									}
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_cdrzd241846zd2_7075;
																																																																										BgL_cdrzd241846zd2_7075
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd241839zd2_7074));
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_carzd241852zd2_7076;
																																																																											BgL_carzd241852zd2_7076
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd241846zd2_7075));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd241852zd2_7076))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_carzd241859zd2_7078;
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_pairz00_12386;
																																																																														BgL_pairz00_12386
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd241846zd2_7075));
																																																																														BgL_carzd241859zd2_7078
																																																																															=
																																																																															CAR
																																																																															(BgL_pairz00_12386);
																																																																													}
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd241859zd2_7078))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd241832zd2_7073))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_arg5705z00_7081;
																																																																																	BgL_arg5705z00_7081
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd241839zd2_7074));
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_24563;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_24567;
																																																																																			obj_t
																																																																																				BgL_proc2z00_24566;
																																																																																			obj_t
																																																																																				BgL_proc1z00_24565;
																																																																																			obj_t
																																																																																				BgL_testz00_24564;
																																																																																			BgL_testz00_24564
																																																																																				=
																																																																																				BgL_arg5705z00_7081;
																																																																																			BgL_proc1z00_24565
																																																																																				=
																																																																																				BgL_carzd241852zd2_7076;
																																																																																			BgL_proc2z00_24566
																																																																																				=
																																																																																				BgL_carzd241859zd2_7078;
																																																																																			BgL_argsz00_24567
																																																																																				=
																																																																																				BgL_cdrzd241832zd2_7073;
																																																																																			BgL_argsz00_1749
																																																																																				=
																																																																																				BgL_argsz00_24567;
																																																																																			BgL_proc2z00_1748
																																																																																				=
																																																																																				BgL_proc2z00_24566;
																																																																																			BgL_proc1z00_1747
																																																																																				=
																																																																																				BgL_proc1z00_24565;
																																																																																			BgL_testz00_1746
																																																																																				=
																																																																																				BgL_testz00_24564;
																																																																																			goto
																																																																																				BgL_tagzd2388zd2_1750;
																																																																																		}
																																																																																		BgL_auxz00_22040
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_24563);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1774;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_24571;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1775;
																																																																																			BgL_auxz00_22040
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_24571);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1774;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_24575;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1775;
																																																																																	BgL_auxz00_22040
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_24575);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1774;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_24579;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1775;
																																																																															BgL_auxz00_22040
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_24579);
																																																																														}
																																																																												}
																																																																										}
																																																																									}
																																																																								}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1774;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_24583;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1775;
																																																																								BgL_auxz00_22040
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_24583);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_cdrzd242135zd2_7100;
																																																																				BgL_cdrzd242135zd2_7100
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_cdrzd242141zd2_7101;
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_pairz00_12390;
																																																																						BgL_pairz00_12390
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						BgL_cdrzd242141zd2_7101
																																																																							=
																																																																							CDR
																																																																							(BgL_pairz00_12390);
																																																																					}
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_cdrzd242147zd2_7102;
																																																																						BgL_cdrzd242147zd2_7102
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd242141zd2_7101));
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_carzd242152zd2_7103;
																																																																							obj_t
																																																																								BgL_cdrzd242153zd2_7104;
																																																																							BgL_carzd242152zd2_7103
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd242147zd2_7102));
																																																																							BgL_cdrzd242153zd2_7104
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd242147zd2_7102));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd242152zd2_7103))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_carzd242158zd2_7106;
																																																																									BgL_carzd242158zd2_7106
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd242153zd2_7104));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd242158zd2_7106))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (NULLP(CDR(((obj_t) BgL_cdrzd242153zd2_7104))))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd242135zd2_7100))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_arg5720z00_7111;
																																																																															BgL_arg5720z00_7111
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd242141zd2_7101));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_24610;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_24614;
																																																																																	obj_t
																																																																																		BgL_proc2z00_24613;
																																																																																	obj_t
																																																																																		BgL_proc1z00_24612;
																																																																																	obj_t
																																																																																		BgL_testz00_24611;
																																																																																	BgL_testz00_24611
																																																																																		=
																																																																																		BgL_arg5720z00_7111;
																																																																																	BgL_proc1z00_24612
																																																																																		=
																																																																																		BgL_carzd242152zd2_7103;
																																																																																	BgL_proc2z00_24613
																																																																																		=
																																																																																		BgL_carzd242158zd2_7106;
																																																																																	BgL_argsz00_24614
																																																																																		=
																																																																																		BgL_cdrzd242135zd2_7100;
																																																																																	BgL_argsz00_1749
																																																																																		=
																																																																																		BgL_argsz00_24614;
																																																																																	BgL_proc2z00_1748
																																																																																		=
																																																																																		BgL_proc2z00_24613;
																																																																																	BgL_proc1z00_1747
																																																																																		=
																																																																																		BgL_proc1z00_24612;
																																																																																	BgL_testz00_1746
																																																																																		=
																																																																																		BgL_testz00_24611;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1750;
																																																																																}
																																																																																BgL_auxz00_22040
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_24610);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1774;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_24618;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1775;
																																																																																	BgL_auxz00_22040
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_24618);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1774;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_24622;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1775;
																																																																															BgL_auxz00_22040
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_24622);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1774;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_24626;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1775;
																																																																													BgL_auxz00_22040
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_24626);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1774;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_24630;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1775;
																																																																											BgL_auxz00_22040
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_24630);
																																																																										}
																																																																								}
																																																																						}
																																																																					}
																																																																				}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1774;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_24634;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1775;
																																																																				BgL_auxz00_22040
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_24634);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_cdrzd242491zd2_7119;
																																																																BgL_cdrzd242491zd2_7119
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd242498zd2_7120;
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_pairz00_12400;
																																																																		BgL_pairz00_12400
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		BgL_cdrzd242498zd2_7120
																																																																			=
																																																																			CDR
																																																																			(BgL_pairz00_12400);
																																																																	}
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_cdrzd242505zd2_7121;
																																																																		BgL_cdrzd242505zd2_7121
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd242498zd2_7120));
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_carzd242511zd2_7122;
																																																																			obj_t
																																																																				BgL_cdrzd242512zd2_7123;
																																																																			BgL_carzd242511zd2_7122
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd242505zd2_7121));
																																																																			BgL_cdrzd242512zd2_7123
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd242505zd2_7121));
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd242511zd2_7122))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (PAIRP(BgL_cdrzd242512zd2_7123))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_carzd242519zd2_7126;
																																																																							BgL_carzd242519zd2_7126
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd242512zd2_7123);
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd242519zd2_7126))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (NULLP(CDR(BgL_cdrzd242512zd2_7123)))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd242491zd2_7119))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_arg5734z00_7131;
																																																																													BgL_arg5734z00_7131
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd242498zd2_7120));
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_24661;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_24665;
																																																																															obj_t
																																																																																BgL_proc2z00_24664;
																																																																															obj_t
																																																																																BgL_proc1z00_24663;
																																																																															obj_t
																																																																																BgL_testz00_24662;
																																																																															BgL_testz00_24662
																																																																																=
																																																																																BgL_arg5734z00_7131;
																																																																															BgL_proc1z00_24663
																																																																																=
																																																																																BgL_carzd242511zd2_7122;
																																																																															BgL_proc2z00_24664
																																																																																=
																																																																																BgL_carzd242519zd2_7126;
																																																																															BgL_argsz00_24665
																																																																																=
																																																																																BgL_cdrzd242491zd2_7119;
																																																																															BgL_argsz00_1749
																																																																																=
																																																																																BgL_argsz00_24665;
																																																																															BgL_proc2z00_1748
																																																																																=
																																																																																BgL_proc2z00_24664;
																																																																															BgL_proc1z00_1747
																																																																																=
																																																																																BgL_proc1z00_24663;
																																																																															BgL_testz00_1746
																																																																																=
																																																																																BgL_testz00_24662;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1750;
																																																																														}
																																																																														BgL_auxz00_22040
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_24661);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1774;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_24669;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1775;
																																																																															BgL_auxz00_22040
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_24669);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1774;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_24673;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1775;
																																																																													BgL_auxz00_22040
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_24673);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1774;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_24677;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1775;
																																																																											BgL_auxz00_22040
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_24677);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1774;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_24681;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1775;
																																																																									BgL_auxz00_22040
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_24681);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1774;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_24685;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1775;
																																																																							BgL_auxz00_22040
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_24685);
																																																																						}
																																																																				}
																																																																		}
																																																																	}
																																																																}
																																																															}
																																																													}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{	/* Ast/sexp.scm 118 */
																																																															goto
																																																																BgL_tagzd2403zd2_1774;
																																																														}
																																																													else
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_24689;
																																																															goto
																																																																BgL_tagzd2404zd2_1775;
																																																															BgL_auxz00_22040
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_24689);
																																																														}
																																																												}
																																																										}
																																																									}
																																																							}
																																																						}
																																																				}
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_cdrzd242912zd2_7145;
																																																BgL_cdrzd242912zd2_7145
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 118 */
																																																	bool_t
																																																		BgL_test9764z00_24693;
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_arg5762z00_7162;
																																																		BgL_arg5762z00_7162
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_test9764z00_24693
																																																			=
																																																			CBOOL
																																																			(BGl_letzd2symzf3z21zzast_letz00
																																																			(BgL_arg5762z00_7162));
																																																	}
																																																	if (BgL_test9764z00_24693)
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_arg5750z00_7148;
																																																			obj_t
																																																				BgL_arg5751z00_7149;
																																																			BgL_arg5750z00_7148
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd242912zd2_7145));
																																																			BgL_arg5751z00_7149
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd242912zd2_7145));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_24702;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_24704;
																																																					obj_t
																																																						BgL_bindingsz00_24703;
																																																					BgL_bindingsz00_24703
																																																						=
																																																						BgL_arg5750z00_7148;
																																																					BgL_exprz00_24704
																																																						=
																																																						BgL_arg5751z00_7149;
																																																					BgL_exprz00_1729
																																																						=
																																																						BgL_exprz00_24704;
																																																					BgL_bindingsz00_1728
																																																						=
																																																						BgL_bindingsz00_24703;
																																																					goto
																																																						BgL_tagzd2382zd2_1730;
																																																				}
																																																				BgL_auxz00_22040
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_24702);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			bool_t
																																																				BgL_test9765z00_24706;
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_arg5761z00_7161;
																																																				BgL_arg5761z00_7161
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test9765z00_24706
																																																					=
																																																					CBOOL
																																																					(BGl_labelszd2symzf3z21zzast_labelsz00
																																																					(BgL_arg5761z00_7161));
																																																			}
																																																			if (BgL_test9765z00_24706)
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_24711;
																																																					goto
																																																						BgL_tagzd2384zd2_1732;
																																																					BgL_auxz00_22040
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_24711);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_carzd242978zd2_7152;
																																																					BgL_carzd242978zd2_7152
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_cdrzd242983zd2_7153;
																																																						BgL_cdrzd242983zd2_7153
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_carzd242978zd2_7152));
																																																						if ((CAR(((obj_t) BgL_carzd242978zd2_7152)) == CNST_TABLE_REF(((long) 3))))
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_arg5756z00_7156;
																																																								obj_t
																																																									BgL_arg5757z00_7157;
																																																								obj_t
																																																									BgL_arg5758z00_7158;
																																																								BgL_arg5756z00_7156
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_cdrzd242983zd2_7153));
																																																								BgL_arg5757z00_7157
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_cdrzd242983zd2_7153));
																																																								BgL_arg5758z00_7158
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_24728;
																																																									{
																																																										obj_t
																																																											BgL_argsz00_24731;
																																																										obj_t
																																																											BgL_bodyz00_24730;
																																																										obj_t
																																																											BgL_varsz00_24729;
																																																										BgL_varsz00_24729
																																																											=
																																																											BgL_arg5756z00_7156;
																																																										BgL_bodyz00_24730
																																																											=
																																																											BgL_arg5757z00_7157;
																																																										BgL_argsz00_24731
																																																											=
																																																											BgL_arg5758z00_7158;
																																																										BgL_argsz00_1739
																																																											=
																																																											BgL_argsz00_24731;
																																																										BgL_bodyz00_1738
																																																											=
																																																											BgL_bodyz00_24730;
																																																										BgL_varsz00_1737
																																																											=
																																																											BgL_varsz00_24729;
																																																										goto
																																																											BgL_tagzd2386zd2_1740;
																																																									}
																																																									BgL_auxz00_22040
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_24728);
																																																								}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 118 */
																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																									{	/* Ast/sexp.scm 118 */
																																																										goto
																																																											BgL_tagzd2403zd2_1774;
																																																									}
																																																								else
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_24735;
																																																										goto
																																																											BgL_tagzd2404zd2_1775;
																																																										BgL_auxz00_22040
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_24735);
																																																									}
																																																							}
																																																					}
																																																				}
																																																		}
																																																}
																																															}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														obj_t
																																															BgL_cdrzd243094zd2_7163;
																																														BgL_cdrzd243094zd2_7163
																																															=
																																															CDR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														{	/* Ast/sexp.scm 118 */
																																															bool_t
																																																BgL_test9768z00_24739;
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_arg5771z00_7172;
																																																BgL_arg5771z00_7172
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																BgL_test9768z00_24739
																																																	=
																																																	CBOOL
																																																	(BGl_letzd2symzf3z21zzast_letz00
																																																	(BgL_arg5771z00_7172));
																																															}
																																															if (BgL_test9768z00_24739)
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_arg5765z00_7166;
																																																	obj_t
																																																		BgL_arg5766z00_7167;
																																																	BgL_arg5765z00_7166
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd243094zd2_7163));
																																																	BgL_arg5766z00_7167
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd243094zd2_7163));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_24748;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_24750;
																																																			obj_t
																																																				BgL_bindingsz00_24749;
																																																			BgL_bindingsz00_24749
																																																				=
																																																				BgL_arg5765z00_7166;
																																																			BgL_exprz00_24750
																																																				=
																																																				BgL_arg5766z00_7167;
																																																			BgL_exprz00_1729
																																																				=
																																																				BgL_exprz00_24750;
																																																			BgL_bindingsz00_1728
																																																				=
																																																				BgL_bindingsz00_24749;
																																																			goto
																																																				BgL_tagzd2382zd2_1730;
																																																		}
																																																		BgL_auxz00_22040
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_24748);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	bool_t
																																																		BgL_test9769z00_24752;
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_arg5770z00_7171;
																																																		BgL_arg5770z00_7171
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_test9769z00_24752
																																																			=
																																																			CBOOL
																																																			(BGl_labelszd2symzf3z21zzast_labelsz00
																																																			(BgL_arg5770z00_7171));
																																																	}
																																																	if (BgL_test9769z00_24752)
																																																		{
																																																			BgL_letzd2funzd2_bglt
																																																				BgL_auxz00_24757;
																																																			goto
																																																				BgL_tagzd2384zd2_1732;
																																																			BgL_auxz00_22040
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_24757);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																				{	/* Ast/sexp.scm 118 */
																																																					goto
																																																						BgL_tagzd2403zd2_1774;
																																																				}
																																																			else
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_24761;
																																																					goto
																																																						BgL_tagzd2404zd2_1775;
																																																					BgL_auxz00_22040
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_24761);
																																																				}
																																																		}
																																																}
																																														}
																																													}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 118 */
																																												if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd241659zd2_6899)))
																																													{	/* Ast/sexp.scm 118 */
																																														goto
																																															BgL_kapzd241661zd2_6901;
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														if ((BgL_carzd241659zd2_6899 == CNST_TABLE_REF(((long) 18))))
																																															{	/* Ast/sexp.scm 118 */
																																																goto
																																																	BgL_kapzd241661zd2_6901;
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																if ((BgL_carzd241659zd2_6899 == CNST_TABLE_REF(((long) 19))))
																																																	{	/* Ast/sexp.scm 118 */
																																																		goto
																																																			BgL_kapzd241661zd2_6901;
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd241659zd2_6899)))
																																																			{	/* Ast/sexp.scm 118 */
																																																				goto
																																																					BgL_kapzd241661zd2_6901;
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_cdrzd243266zd2_6907;
																																																				BgL_cdrzd243266zd2_6907
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{	/* Ast/sexp.scm 118 */
																																																					bool_t
																																																						BgL_test9775z00_24777;
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_arg5671z00_7024;
																																																						BgL_arg5671z00_7024
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test9775z00_24777
																																																							=
																																																							CBOOL
																																																							(BGl_letzd2symzf3z21zzast_letz00
																																																							(BgL_arg5671z00_7024));
																																																					}
																																																					if (BgL_test9775z00_24777)
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_arg5599z00_6910;
																																																							obj_t
																																																								BgL_arg5600z00_6911;
																																																							BgL_arg5599z00_6910
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd243266zd2_6907));
																																																							BgL_arg5600z00_6911
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd243266zd2_6907));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_24786;
																																																								{
																																																									obj_t
																																																										BgL_exprz00_24788;
																																																									obj_t
																																																										BgL_bindingsz00_24787;
																																																									BgL_bindingsz00_24787
																																																										=
																																																										BgL_arg5599z00_6910;
																																																									BgL_exprz00_24788
																																																										=
																																																										BgL_arg5600z00_6911;
																																																									BgL_exprz00_1729
																																																										=
																																																										BgL_exprz00_24788;
																																																									BgL_bindingsz00_1728
																																																										=
																																																										BgL_bindingsz00_24787;
																																																									goto
																																																										BgL_tagzd2382zd2_1730;
																																																								}
																																																								BgL_auxz00_22040
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_24786);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							bool_t
																																																								BgL_test9776z00_24790;
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_arg5670z00_7023;
																																																								BgL_arg5670z00_7023
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test9776z00_24790
																																																									=
																																																									CBOOL
																																																									(BGl_labelszd2symzf3z21zzast_labelsz00
																																																									(BgL_arg5670z00_7023));
																																																							}
																																																							if (BgL_test9776z00_24790)
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_24795;
																																																									goto
																																																										BgL_tagzd2384zd2_1732;
																																																									BgL_auxz00_22040
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_24795);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_carzd243332zd2_6914;
																																																									BgL_carzd243332zd2_6914
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_cdrzd243337zd2_6915;
																																																										BgL_cdrzd243337zd2_6915
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_carzd243332zd2_6914));
																																																										if ((CAR(((obj_t) BgL_carzd243332zd2_6914)) == CNST_TABLE_REF(((long) 3))))
																																																											{	/* Ast/sexp.scm 118 */
																																																												if (PAIRP(BgL_cdrzd243337zd2_6915))
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_arg5606z00_6919;
																																																														obj_t
																																																															BgL_arg5607z00_6920;
																																																														obj_t
																																																															BgL_arg5608z00_6921;
																																																														BgL_arg5606z00_6919
																																																															=
																																																															CAR
																																																															(BgL_cdrzd243337zd2_6915);
																																																														BgL_arg5607z00_6920
																																																															=
																																																															CDR
																																																															(BgL_cdrzd243337zd2_6915);
																																																														BgL_arg5608z00_6921
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_24812;
																																																															{
																																																																obj_t
																																																																	BgL_argsz00_24815;
																																																																obj_t
																																																																	BgL_bodyz00_24814;
																																																																obj_t
																																																																	BgL_varsz00_24813;
																																																																BgL_varsz00_24813
																																																																	=
																																																																	BgL_arg5606z00_6919;
																																																																BgL_bodyz00_24814
																																																																	=
																																																																	BgL_arg5607z00_6920;
																																																																BgL_argsz00_24815
																																																																	=
																																																																	BgL_arg5608z00_6921;
																																																																BgL_argsz00_1739
																																																																	=
																																																																	BgL_argsz00_24815;
																																																																BgL_bodyz00_1738
																																																																	=
																																																																	BgL_bodyz00_24814;
																																																																BgL_varsz00_1737
																																																																	=
																																																																	BgL_varsz00_24813;
																																																																goto
																																																																	BgL_tagzd2386zd2_1740;
																																																															}
																																																															BgL_auxz00_22040
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_24812);
																																																														}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 118 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 118 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1774;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_24819;
																																																																goto
																																																																	BgL_tagzd2404zd2_1775;
																																																																BgL_auxz00_22040
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_24819);
																																																															}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_cdrzd243444zd2_6924;
																																																												BgL_cdrzd243444zd2_6924
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_cdrzd243449zd2_6925;
																																																													BgL_cdrzd243449zd2_6925
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_carzd243332zd2_6914));
																																																													if ((CAR(((obj_t) BgL_carzd243332zd2_6914)) == CNST_TABLE_REF(((long) 1))))
																																																														{	/* Ast/sexp.scm 118 */
																																																															if (PAIRP(BgL_cdrzd243449zd2_6925))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd243454zd2_6929;
																																																																	BgL_cdrzd243454zd2_6929
																																																																		=
																																																																		CDR
																																																																		(BgL_cdrzd243449zd2_6925);
																																																																	if (PAIRP(BgL_cdrzd243454zd2_6929))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_carzd243458zd2_6931;
																																																																			obj_t
																																																																				BgL_cdrzd243459zd2_6932;
																																																																			BgL_carzd243458zd2_6931
																																																																				=
																																																																				CAR
																																																																				(BgL_cdrzd243454zd2_6929);
																																																																			BgL_cdrzd243459zd2_6932
																																																																				=
																																																																				CDR
																																																																				(BgL_cdrzd243454zd2_6929);
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd243458zd2_6931))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (PAIRP(BgL_cdrzd243459zd2_6932))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_carzd243464zd2_6935;
																																																																							BgL_carzd243464zd2_6935
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd243459zd2_6932);
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd243464zd2_6935))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (NULLP(CDR(BgL_cdrzd243459zd2_6932)))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											bool_t
																																																																												BgL_test9787z00_24847;
																																																																											{
																																																																												obj_t
																																																																													BgL_l1439z00_6968;
																																																																												BgL_l1439z00_6968
																																																																													=
																																																																													BgL_cdrzd243444zd2_6924;
																																																																											BgL_zc3z04anonymousza35634ze3z87_6969:
																																																																												if (NULLP(BgL_l1439z00_6968))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														BgL_test9787z00_24847
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															1);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														bool_t
																																																																															BgL_test9789z00_24850;
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															bool_t
																																																																																BgL_test9790z00_24851;
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_tmpz00_24852;
																																																																																BgL_tmpz00_24852
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_l1439z00_6968));
																																																																																BgL_test9790z00_24851
																																																																																	=
																																																																																	PAIRP
																																																																																	(BgL_tmpz00_24852);
																																																																															}
																																																																															if (BgL_test9790z00_24851)
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	BgL_test9789z00_24850
																																																																																		=
																																																																																		(
																																																																																		(bool_t)
																																																																																		0);
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	BgL_test9789z00_24850
																																																																																		=
																																																																																		(
																																																																																		(bool_t)
																																																																																		1);
																																																																																}
																																																																														}
																																																																														if (BgL_test9789z00_24850)
																																																																															{
																																																																																obj_t
																																																																																	BgL_l1439z00_24856;
																																																																																BgL_l1439z00_24856
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_l1439z00_6968));
																																																																																BgL_l1439z00_6968
																																																																																	=
																																																																																	BgL_l1439z00_24856;
																																																																																goto
																																																																																	BgL_zc3z04anonymousza35634ze3z87_6969;
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																BgL_test9787z00_24847
																																																																																	=
																																																																																	(
																																																																																	(bool_t)
																																																																																	0);
																																																																															}
																																																																													}
																																																																											}
																																																																											if (BgL_test9787z00_24847)
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_arg5624z00_6951;
																																																																													BgL_arg5624z00_6951
																																																																														=
																																																																														CAR
																																																																														(BgL_cdrzd243449zd2_6925);
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_24860;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_24864;
																																																																															obj_t
																																																																																BgL_proc2z00_24863;
																																																																															obj_t
																																																																																BgL_proc1z00_24862;
																																																																															obj_t
																																																																																BgL_testz00_24861;
																																																																															BgL_testz00_24861
																																																																																=
																																																																																BgL_arg5624z00_6951;
																																																																															BgL_proc1z00_24862
																																																																																=
																																																																																BgL_carzd243458zd2_6931;
																																																																															BgL_proc2z00_24863
																																																																																=
																																																																																BgL_carzd243464zd2_6935;
																																																																															BgL_argsz00_24864
																																																																																=
																																																																																BgL_cdrzd243444zd2_6924;
																																																																															BgL_argsz00_1744
																																																																																=
																																																																																BgL_argsz00_24864;
																																																																															BgL_proc2z00_1743
																																																																																=
																																																																																BgL_proc2z00_24863;
																																																																															BgL_proc1z00_1742
																																																																																=
																																																																																BgL_proc1z00_24862;
																																																																															BgL_testz00_1741
																																																																																=
																																																																																BgL_testz00_24861;
																																																																															goto
																																																																																BgL_tagzd2387zd2_1745;
																																																																														}
																																																																														BgL_auxz00_22040
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_24860);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_cdrzd243489zd2_6952;
																																																																													BgL_cdrzd243489zd2_6952
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_cdrzd243497zd2_6953;
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_pairz00_12457;
																																																																															BgL_pairz00_12457
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															BgL_cdrzd243497zd2_6953
																																																																																=
																																																																																CDR
																																																																																(BgL_pairz00_12457);
																																																																														}
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_cdrzd243505zd2_6954;
																																																																															BgL_cdrzd243505zd2_6954
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_cdrzd243497zd2_6953));
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_carzd243512zd2_6955;
																																																																																BgL_carzd243512zd2_6955
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd243505zd2_6954));
																																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd243512zd2_6955))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		obj_t
																																																																																			BgL_carzd243521zd2_6957;
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			obj_t
																																																																																				BgL_pairz00_12461;
																																																																																			BgL_pairz00_12461
																																																																																				=
																																																																																				CDR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd243505zd2_6954));
																																																																																			BgL_carzd243521zd2_6957
																																																																																				=
																																																																																				CAR
																																																																																				(BgL_pairz00_12461);
																																																																																		}
																																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd243521zd2_6957))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd243489zd2_6952))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						obj_t
																																																																																							BgL_arg5628z00_6960;
																																																																																						BgL_arg5628z00_6960
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_cdrzd243497zd2_6953));
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_24886;
																																																																																							{
																																																																																								obj_t
																																																																																									BgL_argsz00_24890;
																																																																																								obj_t
																																																																																									BgL_proc2z00_24889;
																																																																																								obj_t
																																																																																									BgL_proc1z00_24888;
																																																																																								obj_t
																																																																																									BgL_testz00_24887;
																																																																																								BgL_testz00_24887
																																																																																									=
																																																																																									BgL_arg5628z00_6960;
																																																																																								BgL_proc1z00_24888
																																																																																									=
																																																																																									BgL_carzd243512zd2_6955;
																																																																																								BgL_proc2z00_24889
																																																																																									=
																																																																																									BgL_carzd243521zd2_6957;
																																																																																								BgL_argsz00_24890
																																																																																									=
																																																																																									BgL_cdrzd243489zd2_6952;
																																																																																								BgL_argsz00_1749
																																																																																									=
																																																																																									BgL_argsz00_24890;
																																																																																								BgL_proc2z00_1748
																																																																																									=
																																																																																									BgL_proc2z00_24889;
																																																																																								BgL_proc1z00_1747
																																																																																									=
																																																																																									BgL_proc1z00_24888;
																																																																																								BgL_testz00_1746
																																																																																									=
																																																																																									BgL_testz00_24887;
																																																																																								goto
																																																																																									BgL_tagzd2388zd2_1750;
																																																																																							}
																																																																																							BgL_auxz00_22040
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_24886);
																																																																																						}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1774;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_24894;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1775;
																																																																																								BgL_auxz00_22040
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_24894);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1774;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_24898;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1775;
																																																																																						BgL_auxz00_22040
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_24898);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1774;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_24902;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1775;
																																																																																				BgL_auxz00_22040
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_24902);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														}
																																																																													}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1774;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_24906;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1775;
																																																																													BgL_auxz00_22040
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_24906);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_cdrzd243799zd2_6979;
																																																																									BgL_cdrzd243799zd2_6979
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_cdrzd243806zd2_6980;
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_pairz00_12465;
																																																																											BgL_pairz00_12465
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											BgL_cdrzd243806zd2_6980
																																																																												=
																																																																												CDR
																																																																												(BgL_pairz00_12465);
																																																																										}
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_cdrzd243813zd2_6981;
																																																																											BgL_cdrzd243813zd2_6981
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd243806zd2_6980));
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_carzd243819zd2_6982;
																																																																												obj_t
																																																																													BgL_cdrzd243820zd2_6983;
																																																																												BgL_carzd243819zd2_6982
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd243813zd2_6981));
																																																																												BgL_cdrzd243820zd2_6983
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd243813zd2_6981));
																																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd243819zd2_6982))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_carzd243827zd2_6985;
																																																																														BgL_carzd243827zd2_6985
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd243820zd2_6983));
																																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd243827zd2_6985))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (NULLP(CDR(((obj_t) BgL_cdrzd243820zd2_6983))))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd243799zd2_6979))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				obj_t
																																																																																					BgL_arg5643z00_6990;
																																																																																				BgL_arg5643z00_6990
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd243806zd2_6980));
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_24933;
																																																																																					{
																																																																																						obj_t
																																																																																							BgL_argsz00_24937;
																																																																																						obj_t
																																																																																							BgL_proc2z00_24936;
																																																																																						obj_t
																																																																																							BgL_proc1z00_24935;
																																																																																						obj_t
																																																																																							BgL_testz00_24934;
																																																																																						BgL_testz00_24934
																																																																																							=
																																																																																							BgL_arg5643z00_6990;
																																																																																						BgL_proc1z00_24935
																																																																																							=
																																																																																							BgL_carzd243819zd2_6982;
																																																																																						BgL_proc2z00_24936
																																																																																							=
																																																																																							BgL_carzd243827zd2_6985;
																																																																																						BgL_argsz00_24937
																																																																																							=
																																																																																							BgL_cdrzd243799zd2_6979;
																																																																																						BgL_argsz00_1749
																																																																																							=
																																																																																							BgL_argsz00_24937;
																																																																																						BgL_proc2z00_1748
																																																																																							=
																																																																																							BgL_proc2z00_24936;
																																																																																						BgL_proc1z00_1747
																																																																																							=
																																																																																							BgL_proc1z00_24935;
																																																																																						BgL_testz00_1746
																																																																																							=
																																																																																							BgL_testz00_24934;
																																																																																						goto
																																																																																							BgL_tagzd2388zd2_1750;
																																																																																					}
																																																																																					BgL_auxz00_22040
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_24933);
																																																																																				}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1774;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_24941;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1775;
																																																																																						BgL_auxz00_22040
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_24941);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1774;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_24945;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1775;
																																																																																				BgL_auxz00_22040
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_24945);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1774;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_24949;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1775;
																																																																																		BgL_auxz00_22040
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_24949);
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1774;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_24953;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1775;
																																																																																BgL_auxz00_22040
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_24953);
																																																																															}
																																																																													}
																																																																											}
																																																																										}
																																																																									}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1774;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_24957;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1775;
																																																																									BgL_auxz00_22040
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_24957);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_cdrzd244160zd2_6998;
																																																																					BgL_cdrzd244160zd2_6998
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_expz00_21));
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_cdrzd244166zd2_6999;
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_pairz00_12475;
																																																																							BgL_pairz00_12475
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							BgL_cdrzd244166zd2_6999
																																																																								=
																																																																								CDR
																																																																								(BgL_pairz00_12475);
																																																																						}
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_cdrzd244172zd2_7000;
																																																																							BgL_cdrzd244172zd2_7000
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd244166zd2_6999));
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_carzd244177zd2_7001;
																																																																								obj_t
																																																																									BgL_cdrzd244178zd2_7002;
																																																																								BgL_carzd244177zd2_7001
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd244172zd2_7000));
																																																																								BgL_cdrzd244178zd2_7002
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd244172zd2_7000));
																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd244177zd2_7001))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (PAIRP(BgL_cdrzd244178zd2_7002))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_carzd244183zd2_7005;
																																																																												BgL_carzd244183zd2_7005
																																																																													=
																																																																													CAR
																																																																													(BgL_cdrzd244178zd2_7002);
																																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd244183zd2_7005))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														if (NULLP(CDR(BgL_cdrzd244178zd2_7002)))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd244160zd2_6998))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		obj_t
																																																																																			BgL_arg5657z00_7010;
																																																																																		BgL_arg5657z00_7010
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd244166zd2_6999));
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_24984;
																																																																																			{
																																																																																				obj_t
																																																																																					BgL_argsz00_24988;
																																																																																				obj_t
																																																																																					BgL_proc2z00_24987;
																																																																																				obj_t
																																																																																					BgL_proc1z00_24986;
																																																																																				obj_t
																																																																																					BgL_testz00_24985;
																																																																																				BgL_testz00_24985
																																																																																					=
																																																																																					BgL_arg5657z00_7010;
																																																																																				BgL_proc1z00_24986
																																																																																					=
																																																																																					BgL_carzd244177zd2_7001;
																																																																																				BgL_proc2z00_24987
																																																																																					=
																																																																																					BgL_carzd244183zd2_7005;
																																																																																				BgL_argsz00_24988
																																																																																					=
																																																																																					BgL_cdrzd244160zd2_6998;
																																																																																				BgL_argsz00_1749
																																																																																					=
																																																																																					BgL_argsz00_24988;
																																																																																				BgL_proc2z00_1748
																																																																																					=
																																																																																					BgL_proc2z00_24987;
																																																																																				BgL_proc1z00_1747
																																																																																					=
																																																																																					BgL_proc1z00_24986;
																																																																																				BgL_testz00_1746
																																																																																					=
																																																																																					BgL_testz00_24985;
																																																																																				goto
																																																																																					BgL_tagzd2388zd2_1750;
																																																																																			}
																																																																																			BgL_auxz00_22040
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_24984);
																																																																																		}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1774;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_24992;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1775;
																																																																																				BgL_auxz00_22040
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_24992);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1774;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_24996;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1775;
																																																																																		BgL_auxz00_22040
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_24996);
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1774;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_25000;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1775;
																																																																																BgL_auxz00_22040
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_25000);
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1774;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_25004;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1775;
																																																																														BgL_auxz00_22040
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_25004);
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1774;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_25008;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1775;
																																																																												BgL_auxz00_22040
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_25008);
																																																																											}
																																																																									}
																																																																							}
																																																																						}
																																																																					}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1774;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_25012;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1775;
																																																																					BgL_auxz00_22040
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_25012);
																																																																				}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1774;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_25016;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1775;
																																																																			BgL_auxz00_22040
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_25016);
																																																																		}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1774;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_25020;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1775;
																																																																	BgL_auxz00_22040
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_25020);
																																																																}
																																																														}
																																																												}
																																																											}
																																																									}
																																																								}
																																																						}
																																																				}
																																																			}
																																																	}
																																															}
																																													}
																																											}
																																									}
																																								}
																																							else
																																								{	/* Ast/sexp.scm 118 */
																																									if ((BgL_carzd241656zd2_6897 == CNST_TABLE_REF(((long) 17))))
																																										{	/* Ast/sexp.scm 118 */
																																											obj_t
																																												BgL_arg5773z00_7176;
																																											obj_t
																																												BgL_arg5774z00_7177;
																																											BgL_arg5773z00_7176
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_cdrzd241555zd2_6881));
																																											BgL_arg5774z00_7177
																																												=
																																												CDR
																																												(
																																												((obj_t) BgL_cdrzd241555zd2_6881));
																																											{
																																												BgL_nodez00_bglt
																																													BgL_auxz00_25029;
																																												{
																																													obj_t
																																														BgL_exprz00_25031;
																																													obj_t
																																														BgL_bindingsz00_25030;
																																													BgL_bindingsz00_25030
																																														=
																																														BgL_arg5773z00_7176;
																																													BgL_exprz00_25031
																																														=
																																														BgL_arg5774z00_7177;
																																													BgL_exprz00_1729
																																														=
																																														BgL_exprz00_25031;
																																													BgL_bindingsz00_1728
																																														=
																																														BgL_bindingsz00_25030;
																																													goto
																																														BgL_tagzd2382zd2_1730;
																																												}
																																												BgL_auxz00_22040
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_25029);
																																											}
																																										}
																																									else
																																										{	/* Ast/sexp.scm 118 */
																																											if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd241656zd2_6897)))
																																												{	/* Ast/sexp.scm 118 */
																																													obj_t
																																														BgL_arg5776z00_7179;
																																													obj_t
																																														BgL_arg5777z00_7180;
																																													BgL_arg5776z00_7179
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_cdrzd241555zd2_6881));
																																													BgL_arg5777z00_7180
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_cdrzd241555zd2_6881));
																																													{
																																														BgL_nodez00_bglt
																																															BgL_auxz00_25040;
																																														{
																																															obj_t
																																																BgL_exprz00_25042;
																																															obj_t
																																																BgL_bindingsz00_25041;
																																															BgL_bindingsz00_25041
																																																=
																																																BgL_arg5776z00_7179;
																																															BgL_exprz00_25042
																																																=
																																																BgL_arg5777z00_7180;
																																															BgL_exprz00_1729
																																																=
																																																BgL_exprz00_25042;
																																															BgL_bindingsz00_1728
																																																=
																																																BgL_bindingsz00_25041;
																																															goto
																																																BgL_tagzd2382zd2_1730;
																																														}
																																														BgL_auxz00_22040
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_25040);
																																													}
																																												}
																																											else
																																												{	/* Ast/sexp.scm 118 */
																																													if ((BgL_carzd241656zd2_6897 == CNST_TABLE_REF(((long) 18))))
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_arg5779z00_7182;
																																															obj_t
																																																BgL_arg5780z00_7183;
																																															BgL_arg5779z00_7182
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd241555zd2_6881));
																																															BgL_arg5780z00_7183
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd241555zd2_6881));
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_25051;
																																																{
																																																	obj_t
																																																		BgL_exprz00_25053;
																																																	obj_t
																																																		BgL_bindingsz00_25052;
																																																	BgL_bindingsz00_25052
																																																		=
																																																		BgL_arg5779z00_7182;
																																																	BgL_exprz00_25053
																																																		=
																																																		BgL_arg5780z00_7183;
																																																	BgL_exprz00_1729
																																																		=
																																																		BgL_exprz00_25053;
																																																	BgL_bindingsz00_1728
																																																		=
																																																		BgL_bindingsz00_25052;
																																																	goto
																																																		BgL_tagzd2382zd2_1730;
																																																}
																																																BgL_auxz00_22040
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_25051);
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 118 */
																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_25060;
																																																	goto
																																																		BgL_tagzd2383zd2_1731;
																																																	BgL_auxz00_22040
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_25060);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_carzd244758zd2_7186;
																																																	BgL_carzd244758zd2_7186
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	if ((BgL_carzd244758zd2_7186 == CNST_TABLE_REF(((long) 19))))
																																																		{
																																																			BgL_letzd2funzd2_bglt
																																																				BgL_auxz00_25067;
																																																			goto
																																																				BgL_tagzd2384zd2_1732;
																																																			BgL_auxz00_22040
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_25067);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd244758zd2_7186)))
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_25072;
																																																					goto
																																																						BgL_tagzd2384zd2_1732;
																																																					BgL_auxz00_22040
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_25072);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_25079;
																																																							goto
																																																								BgL_tagzd2389zd2_1751;
																																																							BgL_auxz00_22040
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_25079);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_25086;
																																																									goto
																																																										BgL_tagzd2390zd2_1752;
																																																									BgL_auxz00_22040
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_25086);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_cdrzd244838zd2_7193;
																																																									BgL_cdrzd244838zd2_7193
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_arg5791z00_7196;
																																																											obj_t
																																																												BgL_arg5792z00_7197;
																																																											BgL_arg5791z00_7196
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_cdrzd244838zd2_7193));
																																																											BgL_arg5792z00_7197
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd244838zd2_7193));
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_25099;
																																																												{
																																																													obj_t
																																																														BgL_restz00_25101;
																																																													obj_t
																																																														BgL_effectz00_25100;
																																																													BgL_effectz00_25100
																																																														=
																																																														BgL_arg5791z00_7196;
																																																													BgL_restz00_25101
																																																														=
																																																														BgL_arg5792z00_7197;
																																																													BgL_restz00_1754
																																																														=
																																																														BgL_restz00_25101;
																																																													BgL_effectz00_1753
																																																														=
																																																														BgL_effectz00_25100;
																																																													goto
																																																														BgL_tagzd2391zd2_1755;
																																																												}
																																																												BgL_auxz00_22040
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_25099);
																																																											}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_25108;
																																																													goto
																																																														BgL_tagzd2392zd2_1756;
																																																													BgL_auxz00_22040
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_25108);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_25115;
																																																															goto
																																																																BgL_tagzd2393zd2_1757;
																																																															BgL_auxz00_22040
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_25115);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_arg5799z00_7205;
																																																																	obj_t
																																																																		BgL_arg5800z00_7206;
																																																																	BgL_arg5799z00_7205
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd244838zd2_7193));
																																																																	BgL_arg5800z00_7206
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd244838zd2_7193));
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_25126;
																																																																		{
																																																																			obj_t
																																																																				BgL_restz00_25128;
																																																																			obj_t
																																																																				BgL_effectz00_25127;
																																																																			BgL_effectz00_25127
																																																																				=
																																																																				BgL_arg5799z00_7205;
																																																																			BgL_restz00_25128
																																																																				=
																																																																				BgL_arg5800z00_7206;
																																																																			BgL_restz00_1759
																																																																				=
																																																																				BgL_restz00_25128;
																																																																			BgL_effectz00_1758
																																																																				=
																																																																				BgL_effectz00_25127;
																																																																			goto
																																																																				BgL_tagzd2394zd2_1760;
																																																																		}
																																																																		BgL_auxz00_22040
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_25126);
																																																																	}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_25135;
																																																																			goto
																																																																				BgL_tagzd2395zd2_1761;
																																																																			BgL_auxz00_22040
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_25135);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_25142;
																																																																					goto
																																																																						BgL_tagzd2396zd2_1762;
																																																																					BgL_auxz00_22040
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_25142);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																						{
																																																																							BgL_letzd2funzd2_bglt
																																																																								BgL_auxz00_25149;
																																																																							goto
																																																																								BgL_tagzd2397zd2_1763;
																																																																							BgL_auxz00_22040
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_25149);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																								{
																																																																									BgL_jumpzd2exzd2itz00_bglt
																																																																										BgL_auxz00_25156;
																																																																									goto
																																																																										BgL_tagzd2398zd2_1764;
																																																																									BgL_auxz00_22040
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_25156);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 30))))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											bool_t
																																																																												BgL_test9837z00_25163;
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_tmpz00_25164;
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_pairz00_12513;
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_pairz00_12512;
																																																																														BgL_pairz00_12512
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_expz00_21));
																																																																														BgL_pairz00_12513
																																																																															=
																																																																															CDR
																																																																															(BgL_pairz00_12512);
																																																																													}
																																																																													BgL_tmpz00_25164
																																																																														=
																																																																														CDR
																																																																														(BgL_pairz00_12513);
																																																																												}
																																																																												BgL_test9837z00_25163
																																																																													=
																																																																													NULLP
																																																																													(BgL_tmpz00_25164);
																																																																											}
																																																																											if (BgL_test9837z00_25163)
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_25170;
																																																																													goto
																																																																														BgL_tagzd2399zd2_1765;
																																																																													BgL_auxz00_22040
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_25170);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1774;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_25174;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1775;
																																																																															BgL_auxz00_22040
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_25174);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_cdrzd244931zd2_7225;
																																																																											BgL_cdrzd244931zd2_7225
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_arg5821z00_7228;
																																																																													obj_t
																																																																														BgL_arg5822z00_7229;
																																																																													BgL_arg5821z00_7228
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd244931zd2_7225));
																																																																													BgL_arg5822z00_7229
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd244931zd2_7225));
																																																																													{	/* Ast/sexp.scm 551 */
																																																																														obj_t
																																																																															BgL_arg6989z00_12519;
																																																																														BgL_arg6989z00_12519
																																																																															=
																																																																															BGl_findzd2locationzf2locz20zztools_locationz00
																																																																															(BgL_expz00_21,
																																																																															BgL_locz00_23);
																																																																														BgL_auxz00_22040
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																															(BgL_expz00_21,
																																																																																BgL_arg5821z00_7228,
																																																																																CNST_TABLE_REF
																																																																																(((long) 4)), BgL_arg5822z00_7229, BgL_stackz00_22, BgL_arg6989z00_12519, BgL_sitez00_24));
																																																																												}}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1774;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_25193;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1775;
																																																																															BgL_auxz00_22040
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_25193);
																																																																														}
																																																																												}
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																											else
																												{	/* Ast/sexp.scm 118 */
																													obj_t
																														BgL_carzd244956zd2_7246;
																													BgL_carzd244956zd2_7246
																														=
																														CAR(((obj_t)
																															BgL_expz00_21));
																													if (
																														(BgL_carzd244956zd2_7246
																															==
																															CNST_TABLE_REF((
																																	(long) 1))))
																														{
																															BgL_nodez00_bglt
																																BgL_auxz00_25200;
																															goto
																																BgL_tagzd2377zd2_1719;
																															BgL_auxz00_22040 =
																																((obj_t)
																																BgL_auxz00_25200);
																														}
																													else
																														{	/* Ast/sexp.scm 118 */
																															if (
																																(BgL_carzd244956zd2_7246
																																	==
																																	BGl_za2ifza2z00zzast_sexpz00))
																																{
																																	BgL_nodez00_bglt
																																		BgL_auxz00_25204;
																																	goto
																																		BgL_tagzd2377zd2_1719;
																																	BgL_auxz00_22040
																																		=
																																		((obj_t)
																																		BgL_auxz00_25204);
																																}
																															else
																																{	/* Ast/sexp.scm 118 */
																																	obj_t
																																		BgL_cdrzd244978zd2_7249;
																																	BgL_cdrzd244978zd2_7249
																																		=
																																		CDR(((obj_t)
																																			BgL_expz00_21));
																																	if ((CAR((
																																					(obj_t)
																																					BgL_expz00_21))
																																			==
																																			CNST_TABLE_REF
																																			(((long)
																																					7))))
																																		{	/* Ast/sexp.scm 118 */
																																			obj_t
																																				BgL_carzd244981zd2_7252;
																																			obj_t
																																				BgL_cdrzd244982zd2_7253;
																																			BgL_carzd244981zd2_7252
																																				=
																																				CAR((
																																					(obj_t)
																																					BgL_cdrzd244978zd2_7249));
																																			BgL_cdrzd244982zd2_7253
																																				=
																																				CDR((
																																					(obj_t)
																																					BgL_cdrzd244978zd2_7249));
																																			if (PAIRP
																																				(BgL_carzd244981zd2_7252))
																																				{	/* Ast/sexp.scm 118 */
																																					if (
																																						(CAR
																																							(BgL_carzd244981zd2_7252)
																																							==
																																							CNST_TABLE_REF
																																							(((long) 14))))
																																						{	/* Ast/sexp.scm 118 */
																																							if (NULLP(CDR(((obj_t) BgL_cdrzd244982zd2_7253))))
																																								{	/* Ast/sexp.scm 118 */
																																									obj_t
																																										BgL_arg5848z00_7259;
																																									obj_t
																																										BgL_arg5849z00_7260;
																																									BgL_arg5848z00_7259
																																										=
																																										CDR
																																										(BgL_carzd244981zd2_7252);
																																									BgL_arg5849z00_7260
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_cdrzd244982zd2_7253));
																																									{
																																										BgL_nodez00_bglt
																																											BgL_auxz00_25230;
																																										{
																																											obj_t
																																												BgL_valz00_25232;
																																											obj_t
																																												BgL_lz00_25231;
																																											BgL_lz00_25231
																																												=
																																												BgL_arg5848z00_7259;
																																											BgL_valz00_25232
																																												=
																																												BgL_arg5849z00_7260;
																																											BgL_valz00_1721
																																												=
																																												BgL_valz00_25232;
																																											BgL_lz00_1720
																																												=
																																												BgL_lz00_25231;
																																											goto
																																												BgL_tagzd2378zd2_1722;
																																										}
																																										BgL_auxz00_22040
																																											=
																																											(
																																											(obj_t)
																																											BgL_auxz00_25230);
																																									}
																																								}
																																							else
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_25234;
																																									goto
																																										BgL_tagzd2379zd2_1723;
																																									BgL_auxz00_22040
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_25234);
																																								}
																																						}
																																					else
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_25236;
																																							goto
																																								BgL_tagzd2379zd2_1723;
																																							BgL_auxz00_22040
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_25236);
																																						}
																																				}
																																			else
																																				{
																																					BgL_nodez00_bglt
																																						BgL_auxz00_25238;
																																					goto
																																						BgL_tagzd2379zd2_1723;
																																					BgL_auxz00_22040
																																						=
																																						(
																																						(obj_t)
																																						BgL_auxz00_25238);
																																				}
																																		}
																																	else
																																		{	/* Ast/sexp.scm 118 */
																																			if (
																																				(CAR(
																																						((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																				{
																																					BgL_nodez00_bglt
																																						BgL_auxz00_25245;
																																					goto
																																						BgL_tagzd2380zd2_1724;
																																					BgL_auxz00_22040
																																						=
																																						(
																																						(obj_t)
																																						BgL_auxz00_25245);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 118 */
																																					obj_t
																																						BgL_carzd245079zd2_7265;
																																					BgL_carzd245079zd2_7265
																																						=
																																						CAR(
																																						((obj_t) BgL_expz00_21));
																																					if (PAIRP(BgL_carzd245079zd2_7265))
																																						{	/* Ast/sexp.scm 118 */
																																							obj_t
																																								BgL_carzd245082zd2_7267;
																																							obj_t
																																								BgL_cdrzd245083zd2_7268;
																																							BgL_carzd245082zd2_7267
																																								=
																																								CAR
																																								(BgL_carzd245079zd2_7265);
																																							BgL_cdrzd245083zd2_7268
																																								=
																																								CDR
																																								(BgL_carzd245079zd2_7265);
																																							{

																																								if ((BgL_carzd245082zd2_7267 == CNST_TABLE_REF(((long) 17))))
																																									{	/* Ast/sexp.scm 118 */
																																									BgL_kapzd245084zd2_7269:
																																										if (PAIRP(BgL_cdrzd245083zd2_7268))
																																											{	/* Ast/sexp.scm 118 */
																																												obj_t
																																													BgL_cdrzd245087zd2_7394;
																																												BgL_cdrzd245087zd2_7394
																																													=
																																													CDR
																																													(BgL_cdrzd245083zd2_7268);
																																												if (PAIRP(BgL_cdrzd245087zd2_7394))
																																													{	/* Ast/sexp.scm 118 */
																																														if (NULLP(CDR(BgL_cdrzd245087zd2_7394)))
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_arg5939z00_7398;
																																																obj_t
																																																	BgL_arg5940z00_7399;
																																																BgL_arg5939z00_7398
																																																	=
																																																	CAR
																																																	(BgL_cdrzd245087zd2_7394);
																																																BgL_arg5940z00_7399
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_25267;
																																																	{
																																																		obj_t
																																																			BgL_argsz00_25269;
																																																		obj_t
																																																			BgL_bodyz00_25268;
																																																		BgL_bodyz00_25268
																																																			=
																																																			BgL_arg5939z00_7398;
																																																		BgL_argsz00_25269
																																																			=
																																																			BgL_arg5940z00_7399;
																																																		BgL_argsz00_1726
																																																			=
																																																			BgL_argsz00_25269;
																																																		BgL_bodyz00_1725
																																																			=
																																																			BgL_bodyz00_25268;
																																																		goto
																																																			BgL_tagzd2381zd2_1727;
																																																	}
																																																	BgL_auxz00_22040
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_25267);
																																																}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_cdrzd245111zd2_7400;
																																																BgL_cdrzd245111zd2_7400
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 118 */
																																																	bool_t
																																																		BgL_test9853z00_25273;
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_arg6009z00_7511;
																																																		BgL_arg6009z00_7511
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_test9853z00_25273
																																																			=
																																																			CBOOL
																																																			(BGl_letzd2symzf3z21zzast_letz00
																																																			(BgL_arg6009z00_7511));
																																																	}
																																																	if (BgL_test9853z00_25273)
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_arg5943z00_7403;
																																																			obj_t
																																																				BgL_arg5944z00_7404;
																																																			BgL_arg5943z00_7403
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd245111zd2_7400));
																																																			BgL_arg5944z00_7404
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd245111zd2_7400));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_25282;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_25284;
																																																					obj_t
																																																						BgL_bindingsz00_25283;
																																																					BgL_bindingsz00_25283
																																																						=
																																																						BgL_arg5943z00_7403;
																																																					BgL_exprz00_25284
																																																						=
																																																						BgL_arg5944z00_7404;
																																																					BgL_exprz00_1729
																																																						=
																																																						BgL_exprz00_25284;
																																																					BgL_bindingsz00_1728
																																																						=
																																																						BgL_bindingsz00_25283;
																																																					goto
																																																						BgL_tagzd2382zd2_1730;
																																																				}
																																																				BgL_auxz00_22040
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_25282);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			bool_t
																																																				BgL_test9854z00_25286;
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_arg6008z00_7510;
																																																				BgL_arg6008z00_7510
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test9854z00_25286
																																																					=
																																																					CBOOL
																																																					(BGl_labelszd2symzf3z21zzast_labelsz00
																																																					(BgL_arg6008z00_7510));
																																																			}
																																																			if (BgL_test9854z00_25286)
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_25291;
																																																					goto
																																																						BgL_tagzd2384zd2_1732;
																																																					BgL_auxz00_22040
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_25291);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_carzd245178zd2_7407;
																																																					BgL_carzd245178zd2_7407
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_cdrzd245183zd2_7408;
																																																						BgL_cdrzd245183zd2_7408
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_carzd245178zd2_7407));
																																																						if ((CAR(((obj_t) BgL_carzd245178zd2_7407)) == CNST_TABLE_REF(((long) 3))))
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_arg5949z00_7411;
																																																								obj_t
																																																									BgL_arg5950z00_7412;
																																																								obj_t
																																																									BgL_arg5951z00_7413;
																																																								BgL_arg5949z00_7411
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_cdrzd245183zd2_7408));
																																																								BgL_arg5950z00_7412
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_cdrzd245183zd2_7408));
																																																								BgL_arg5951z00_7413
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_25308;
																																																									{
																																																										obj_t
																																																											BgL_argsz00_25311;
																																																										obj_t
																																																											BgL_bodyz00_25310;
																																																										obj_t
																																																											BgL_varsz00_25309;
																																																										BgL_varsz00_25309
																																																											=
																																																											BgL_arg5949z00_7411;
																																																										BgL_bodyz00_25310
																																																											=
																																																											BgL_arg5950z00_7412;
																																																										BgL_argsz00_25311
																																																											=
																																																											BgL_arg5951z00_7413;
																																																										BgL_argsz00_1739
																																																											=
																																																											BgL_argsz00_25311;
																																																										BgL_bodyz00_1738
																																																											=
																																																											BgL_bodyz00_25310;
																																																										BgL_varsz00_1737
																																																											=
																																																											BgL_varsz00_25309;
																																																										goto
																																																											BgL_tagzd2386zd2_1740;
																																																									}
																																																									BgL_auxz00_22040
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_25308);
																																																								}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_cdrzd245206zd2_7415;
																																																								BgL_cdrzd245206zd2_7415
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_cdrzd245212zd2_7416;
																																																									BgL_cdrzd245212zd2_7416
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_carzd245178zd2_7407));
																																																									if ((CAR(((obj_t) BgL_carzd245178zd2_7407)) == CNST_TABLE_REF(((long) 1))))
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_cdrzd245218zd2_7419;
																																																											BgL_cdrzd245218zd2_7419
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd245212zd2_7416));
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_carzd245223zd2_7420;
																																																												obj_t
																																																													BgL_cdrzd245224zd2_7421;
																																																												BgL_carzd245223zd2_7420
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_cdrzd245218zd2_7419));
																																																												BgL_cdrzd245224zd2_7421
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_cdrzd245218zd2_7419));
																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd245223zd2_7420))
																																																													{	/* Ast/sexp.scm 118 */
																																																														if (PAIRP(BgL_cdrzd245224zd2_7421))
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_carzd245231zd2_7424;
																																																																BgL_carzd245231zd2_7424
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd245224zd2_7421);
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd245231zd2_7424))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (NULLP(CDR(BgL_cdrzd245224zd2_7421)))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				bool_t
																																																																					BgL_test9861z00_25338;
																																																																				{
																																																																					obj_t
																																																																						BgL_l1442z00_7457;
																																																																					BgL_l1442z00_7457
																																																																						=
																																																																						BgL_cdrzd245206zd2_7415;
																																																																				BgL_zc3z04anonymousza35974ze3z87_7458:
																																																																					if (NULLP(BgL_l1442z00_7457))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							BgL_test9861z00_25338
																																																																								=
																																																																								(
																																																																								(bool_t)
																																																																								1);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							bool_t
																																																																								BgL_test9863z00_25341;
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								bool_t
																																																																									BgL_test9864z00_25342;
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_tmpz00_25343;
																																																																									BgL_tmpz00_25343
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_l1442z00_7457));
																																																																									BgL_test9864z00_25342
																																																																										=
																																																																										PAIRP
																																																																										(BgL_tmpz00_25343);
																																																																								}
																																																																								if (BgL_test9864z00_25342)
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										BgL_test9863z00_25341
																																																																											=
																																																																											(
																																																																											(bool_t)
																																																																											0);
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										BgL_test9863z00_25341
																																																																											=
																																																																											(
																																																																											(bool_t)
																																																																											1);
																																																																									}
																																																																							}
																																																																							if (BgL_test9863z00_25341)
																																																																								{
																																																																									obj_t
																																																																										BgL_l1442z00_25347;
																																																																									BgL_l1442z00_25347
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_l1442z00_7457));
																																																																									BgL_l1442z00_7457
																																																																										=
																																																																										BgL_l1442z00_25347;
																																																																									goto
																																																																										BgL_zc3z04anonymousza35974ze3z87_7458;
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									BgL_test9861z00_25338
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										0);
																																																																								}
																																																																						}
																																																																				}
																																																																				if (BgL_test9861z00_25338)
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_arg5964z00_7440;
																																																																						BgL_arg5964z00_7440
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd245212zd2_7416));
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_25352;
																																																																							{
																																																																								obj_t
																																																																									BgL_argsz00_25356;
																																																																								obj_t
																																																																									BgL_proc2z00_25355;
																																																																								obj_t
																																																																									BgL_proc1z00_25354;
																																																																								obj_t
																																																																									BgL_testz00_25353;
																																																																								BgL_testz00_25353
																																																																									=
																																																																									BgL_arg5964z00_7440;
																																																																								BgL_proc1z00_25354
																																																																									=
																																																																									BgL_carzd245223zd2_7420;
																																																																								BgL_proc2z00_25355
																																																																									=
																																																																									BgL_carzd245231zd2_7424;
																																																																								BgL_argsz00_25356
																																																																									=
																																																																									BgL_cdrzd245206zd2_7415;
																																																																								BgL_argsz00_1744
																																																																									=
																																																																									BgL_argsz00_25356;
																																																																								BgL_proc2z00_1743
																																																																									=
																																																																									BgL_proc2z00_25355;
																																																																								BgL_proc1z00_1742
																																																																									=
																																																																									BgL_proc1z00_25354;
																																																																								BgL_testz00_1741
																																																																									=
																																																																									BgL_testz00_25353;
																																																																								goto
																																																																									BgL_tagzd2387zd2_1745;
																																																																							}
																																																																							BgL_auxz00_22040
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_25352);
																																																																						}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_cdrzd245255zd2_7441;
																																																																						BgL_cdrzd245255zd2_7441
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_cdrzd245262zd2_7442;
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_pairz00_12572;
																																																																								BgL_pairz00_12572
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								BgL_cdrzd245262zd2_7442
																																																																									=
																																																																									CDR
																																																																									(BgL_pairz00_12572);
																																																																							}
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_cdrzd245269zd2_7443;
																																																																								BgL_cdrzd245269zd2_7443
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd245262zd2_7442));
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_carzd245275zd2_7444;
																																																																									BgL_carzd245275zd2_7444
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd245269zd2_7443));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd245275zd2_7444))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_carzd245282zd2_7446;
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_pairz00_12576;
																																																																												BgL_pairz00_12576
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd245269zd2_7443));
																																																																												BgL_carzd245282zd2_7446
																																																																													=
																																																																													CAR
																																																																													(BgL_pairz00_12576);
																																																																											}
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd245282zd2_7446))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd245255zd2_7441))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_arg5968z00_7449;
																																																																															BgL_arg5968z00_7449
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd245262zd2_7442));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_25378;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_25382;
																																																																																	obj_t
																																																																																		BgL_proc2z00_25381;
																																																																																	obj_t
																																																																																		BgL_proc1z00_25380;
																																																																																	obj_t
																																																																																		BgL_testz00_25379;
																																																																																	BgL_testz00_25379
																																																																																		=
																																																																																		BgL_arg5968z00_7449;
																																																																																	BgL_proc1z00_25380
																																																																																		=
																																																																																		BgL_carzd245275zd2_7444;
																																																																																	BgL_proc2z00_25381
																																																																																		=
																																																																																		BgL_carzd245282zd2_7446;
																																																																																	BgL_argsz00_25382
																																																																																		=
																																																																																		BgL_cdrzd245255zd2_7441;
																																																																																	BgL_argsz00_1749
																																																																																		=
																																																																																		BgL_argsz00_25382;
																																																																																	BgL_proc2z00_1748
																																																																																		=
																																																																																		BgL_proc2z00_25381;
																																																																																	BgL_proc1z00_1747
																																																																																		=
																																																																																		BgL_proc1z00_25380;
																																																																																	BgL_testz00_1746
																																																																																		=
																																																																																		BgL_testz00_25379;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1750;
																																																																																}
																																																																																BgL_auxz00_22040
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_25378);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1774;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_25386;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1775;
																																																																																	BgL_auxz00_22040
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_25386);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1774;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_25390;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1775;
																																																																															BgL_auxz00_22040
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_25390);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1774;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_25394;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1775;
																																																																													BgL_auxz00_22040
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_25394);
																																																																												}
																																																																										}
																																																																								}
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1774;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_25398;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1775;
																																																																						BgL_auxz00_22040
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_25398);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_cdrzd245558zd2_7468;
																																																																		BgL_cdrzd245558zd2_7468
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_cdrzd245564zd2_7469;
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_pairz00_12580;
																																																																				BgL_pairz00_12580
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				BgL_cdrzd245564zd2_7469
																																																																					=
																																																																					CDR
																																																																					(BgL_pairz00_12580);
																																																																			}
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_cdrzd245570zd2_7470;
																																																																				BgL_cdrzd245570zd2_7470
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd245564zd2_7469));
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_carzd245575zd2_7471;
																																																																					obj_t
																																																																						BgL_cdrzd245576zd2_7472;
																																																																					BgL_carzd245575zd2_7471
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd245570zd2_7470));
																																																																					BgL_cdrzd245576zd2_7472
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd245570zd2_7470));
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd245575zd2_7471))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_carzd245581zd2_7474;
																																																																							BgL_carzd245581zd2_7474
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd245576zd2_7472));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd245581zd2_7474))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (NULLP(CDR(((obj_t) BgL_cdrzd245576zd2_7472))))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd245558zd2_7468))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_arg5983z00_7479;
																																																																													BgL_arg5983z00_7479
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd245564zd2_7469));
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_25425;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_25429;
																																																																															obj_t
																																																																																BgL_proc2z00_25428;
																																																																															obj_t
																																																																																BgL_proc1z00_25427;
																																																																															obj_t
																																																																																BgL_testz00_25426;
																																																																															BgL_testz00_25426
																																																																																=
																																																																																BgL_arg5983z00_7479;
																																																																															BgL_proc1z00_25427
																																																																																=
																																																																																BgL_carzd245575zd2_7471;
																																																																															BgL_proc2z00_25428
																																																																																=
																																																																																BgL_carzd245581zd2_7474;
																																																																															BgL_argsz00_25429
																																																																																=
																																																																																BgL_cdrzd245558zd2_7468;
																																																																															BgL_argsz00_1749
																																																																																=
																																																																																BgL_argsz00_25429;
																																																																															BgL_proc2z00_1748
																																																																																=
																																																																																BgL_proc2z00_25428;
																																																																															BgL_proc1z00_1747
																																																																																=
																																																																																BgL_proc1z00_25427;
																																																																															BgL_testz00_1746
																																																																																=
																																																																																BgL_testz00_25426;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1750;
																																																																														}
																																																																														BgL_auxz00_22040
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_25425);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1774;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_25433;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1775;
																																																																															BgL_auxz00_22040
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_25433);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1774;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_25437;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1775;
																																																																													BgL_auxz00_22040
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_25437);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1774;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_25441;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1775;
																																																																											BgL_auxz00_22040
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_25441);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1774;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_25445;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1775;
																																																																									BgL_auxz00_22040
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_25445);
																																																																								}
																																																																						}
																																																																				}
																																																																			}
																																																																		}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1774;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_25449;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1775;
																																																																		BgL_auxz00_22040
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_25449);
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_cdrzd245914zd2_7487;
																																																														BgL_cdrzd245914zd2_7487
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_cdrzd245921zd2_7488;
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_pairz00_12590;
																																																																BgL_pairz00_12590
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																BgL_cdrzd245921zd2_7488
																																																																	=
																																																																	CDR
																																																																	(BgL_pairz00_12590);
																																																															}
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_cdrzd245928zd2_7489;
																																																																BgL_cdrzd245928zd2_7489
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd245921zd2_7488));
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_carzd245934zd2_7490;
																																																																	obj_t
																																																																		BgL_cdrzd245935zd2_7491;
																																																																	BgL_carzd245934zd2_7490
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd245928zd2_7489));
																																																																	BgL_cdrzd245935zd2_7491
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd245928zd2_7489));
																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd245934zd2_7490))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if (PAIRP(BgL_cdrzd245935zd2_7491))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_carzd245942zd2_7494;
																																																																					BgL_carzd245942zd2_7494
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd245935zd2_7491);
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd245942zd2_7494))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (NULLP(CDR(BgL_cdrzd245935zd2_7491)))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd245914zd2_7487))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_arg5997z00_7499;
																																																																											BgL_arg5997z00_7499
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd245921zd2_7488));
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_25476;
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_25480;
																																																																													obj_t
																																																																														BgL_proc2z00_25479;
																																																																													obj_t
																																																																														BgL_proc1z00_25478;
																																																																													obj_t
																																																																														BgL_testz00_25477;
																																																																													BgL_testz00_25477
																																																																														=
																																																																														BgL_arg5997z00_7499;
																																																																													BgL_proc1z00_25478
																																																																														=
																																																																														BgL_carzd245934zd2_7490;
																																																																													BgL_proc2z00_25479
																																																																														=
																																																																														BgL_carzd245942zd2_7494;
																																																																													BgL_argsz00_25480
																																																																														=
																																																																														BgL_cdrzd245914zd2_7487;
																																																																													BgL_argsz00_1749
																																																																														=
																																																																														BgL_argsz00_25480;
																																																																													BgL_proc2z00_1748
																																																																														=
																																																																														BgL_proc2z00_25479;
																																																																													BgL_proc1z00_1747
																																																																														=
																																																																														BgL_proc1z00_25478;
																																																																													BgL_testz00_1746
																																																																														=
																																																																														BgL_testz00_25477;
																																																																													goto
																																																																														BgL_tagzd2388zd2_1750;
																																																																												}
																																																																												BgL_auxz00_22040
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_25476);
																																																																											}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1774;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_25484;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1775;
																																																																													BgL_auxz00_22040
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_25484);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1774;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_25488;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1775;
																																																																											BgL_auxz00_22040
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_25488);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1774;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_25492;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1775;
																																																																									BgL_auxz00_22040
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_25492);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1774;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_25496;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1775;
																																																																							BgL_auxz00_22040
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_25496);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1774;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_25500;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1775;
																																																																					BgL_auxz00_22040
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_25500);
																																																																				}
																																																																		}
																																																																}
																																																															}
																																																														}
																																																													}
																																																											}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{	/* Ast/sexp.scm 118 */
																																																													goto
																																																														BgL_tagzd2403zd2_1774;
																																																												}
																																																											else
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_25504;
																																																													goto
																																																														BgL_tagzd2404zd2_1775;
																																																													BgL_auxz00_22040
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_25504);
																																																												}
																																																										}
																																																								}
																																																							}
																																																					}
																																																				}
																																																		}
																																																}
																																															}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														obj_t
																																															BgL_cdrzd246335zd2_7513;
																																														BgL_cdrzd246335zd2_7513
																																															=
																																															CDR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														{	/* Ast/sexp.scm 118 */
																																															bool_t
																																																BgL_test9892z00_25508;
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_arg6025z00_7530;
																																																BgL_arg6025z00_7530
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																BgL_test9892z00_25508
																																																	=
																																																	CBOOL
																																																	(BGl_letzd2symzf3z21zzast_letz00
																																																	(BgL_arg6025z00_7530));
																																															}
																																															if (BgL_test9892z00_25508)
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_arg6013z00_7516;
																																																	obj_t
																																																		BgL_arg6014z00_7517;
																																																	BgL_arg6013z00_7516
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd246335zd2_7513));
																																																	BgL_arg6014z00_7517
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd246335zd2_7513));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_25517;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_25519;
																																																			obj_t
																																																				BgL_bindingsz00_25518;
																																																			BgL_bindingsz00_25518
																																																				=
																																																				BgL_arg6013z00_7516;
																																																			BgL_exprz00_25519
																																																				=
																																																				BgL_arg6014z00_7517;
																																																			BgL_exprz00_1729
																																																				=
																																																				BgL_exprz00_25519;
																																																			BgL_bindingsz00_1728
																																																				=
																																																				BgL_bindingsz00_25518;
																																																			goto
																																																				BgL_tagzd2382zd2_1730;
																																																		}
																																																		BgL_auxz00_22040
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_25517);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	bool_t
																																																		BgL_test9893z00_25521;
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_arg6024z00_7529;
																																																		BgL_arg6024z00_7529
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_test9893z00_25521
																																																			=
																																																			CBOOL
																																																			(BGl_labelszd2symzf3z21zzast_labelsz00
																																																			(BgL_arg6024z00_7529));
																																																	}
																																																	if (BgL_test9893z00_25521)
																																																		{
																																																			BgL_letzd2funzd2_bglt
																																																				BgL_auxz00_25526;
																																																			goto
																																																				BgL_tagzd2384zd2_1732;
																																																			BgL_auxz00_22040
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_25526);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_carzd246401zd2_7520;
																																																			BgL_carzd246401zd2_7520
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_cdrzd246406zd2_7521;
																																																				BgL_cdrzd246406zd2_7521
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_carzd246401zd2_7520));
																																																				if ((CAR(((obj_t) BgL_carzd246401zd2_7520)) == CNST_TABLE_REF(((long) 3))))
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_arg6019z00_7524;
																																																						obj_t
																																																							BgL_arg6020z00_7525;
																																																						obj_t
																																																							BgL_arg6021z00_7526;
																																																						BgL_arg6019z00_7524
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_cdrzd246406zd2_7521));
																																																						BgL_arg6020z00_7525
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_cdrzd246406zd2_7521));
																																																						BgL_arg6021z00_7526
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_25543;
																																																							{
																																																								obj_t
																																																									BgL_argsz00_25546;
																																																								obj_t
																																																									BgL_bodyz00_25545;
																																																								obj_t
																																																									BgL_varsz00_25544;
																																																								BgL_varsz00_25544
																																																									=
																																																									BgL_arg6019z00_7524;
																																																								BgL_bodyz00_25545
																																																									=
																																																									BgL_arg6020z00_7525;
																																																								BgL_argsz00_25546
																																																									=
																																																									BgL_arg6021z00_7526;
																																																								BgL_argsz00_1739
																																																									=
																																																									BgL_argsz00_25546;
																																																								BgL_bodyz00_1738
																																																									=
																																																									BgL_bodyz00_25545;
																																																								BgL_varsz00_1737
																																																									=
																																																									BgL_varsz00_25544;
																																																								goto
																																																									BgL_tagzd2386zd2_1740;
																																																							}
																																																							BgL_auxz00_22040
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_25543);
																																																						}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 118 */
																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																							{	/* Ast/sexp.scm 118 */
																																																								goto
																																																									BgL_tagzd2403zd2_1774;
																																																							}
																																																						else
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_25550;
																																																								goto
																																																									BgL_tagzd2404zd2_1775;
																																																								BgL_auxz00_22040
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_25550);
																																																							}
																																																					}
																																																			}
																																																		}
																																																}
																																														}
																																													}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 118 */
																																												obj_t
																																													BgL_cdrzd246517zd2_7531;
																																												BgL_cdrzd246517zd2_7531
																																													=
																																													CDR
																																													(
																																													((obj_t) BgL_expz00_21));
																																												{	/* Ast/sexp.scm 118 */
																																													bool_t
																																														BgL_test9896z00_25554;
																																													{	/* Ast/sexp.scm 118 */
																																														obj_t
																																															BgL_arg6034z00_7540;
																																														BgL_arg6034z00_7540
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														BgL_test9896z00_25554
																																															=
																																															CBOOL
																																															(BGl_letzd2symzf3z21zzast_letz00
																																															(BgL_arg6034z00_7540));
																																													}
																																													if (BgL_test9896z00_25554)
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_arg6028z00_7534;
																																															obj_t
																																																BgL_arg6029z00_7535;
																																															BgL_arg6028z00_7534
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd246517zd2_7531));
																																															BgL_arg6029z00_7535
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd246517zd2_7531));
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_25563;
																																																{
																																																	obj_t
																																																		BgL_exprz00_25565;
																																																	obj_t
																																																		BgL_bindingsz00_25564;
																																																	BgL_bindingsz00_25564
																																																		=
																																																		BgL_arg6028z00_7534;
																																																	BgL_exprz00_25565
																																																		=
																																																		BgL_arg6029z00_7535;
																																																	BgL_exprz00_1729
																																																		=
																																																		BgL_exprz00_25565;
																																																	BgL_bindingsz00_1728
																																																		=
																																																		BgL_bindingsz00_25564;
																																																	goto
																																																		BgL_tagzd2382zd2_1730;
																																																}
																																																BgL_auxz00_22040
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_25563);
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 118 */
																																															bool_t
																																																BgL_test9897z00_25567;
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_arg6033z00_7539;
																																																BgL_arg6033z00_7539
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																BgL_test9897z00_25567
																																																	=
																																																	CBOOL
																																																	(BGl_labelszd2symzf3z21zzast_labelsz00
																																																	(BgL_arg6033z00_7539));
																																															}
																																															if (BgL_test9897z00_25567)
																																																{
																																																	BgL_letzd2funzd2_bglt
																																																		BgL_auxz00_25572;
																																																	goto
																																																		BgL_tagzd2384zd2_1732;
																																																	BgL_auxz00_22040
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_25572);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																		{	/* Ast/sexp.scm 118 */
																																																			goto
																																																				BgL_tagzd2403zd2_1774;
																																																		}
																																																	else
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_25576;
																																																			goto
																																																				BgL_tagzd2404zd2_1775;
																																																			BgL_auxz00_22040
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_25576);
																																																		}
																																																}
																																														}
																																												}
																																											}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 118 */
																																										if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd245082zd2_7267)))
																																											{	/* Ast/sexp.scm 118 */
																																												goto
																																													BgL_kapzd245084zd2_7269;
																																											}
																																										else
																																											{	/* Ast/sexp.scm 118 */
																																												if ((BgL_carzd245082zd2_7267 == CNST_TABLE_REF(((long) 18))))
																																													{	/* Ast/sexp.scm 118 */
																																														goto
																																															BgL_kapzd245084zd2_7269;
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														if ((BgL_carzd245082zd2_7267 == CNST_TABLE_REF(((long) 19))))
																																															{	/* Ast/sexp.scm 118 */
																																																goto
																																																	BgL_kapzd245084zd2_7269;
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd245082zd2_7267)))
																																																	{	/* Ast/sexp.scm 118 */
																																																		goto
																																																			BgL_kapzd245084zd2_7269;
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_cdrzd246689zd2_7275;
																																																		BgL_cdrzd246689zd2_7275
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 118 */
																																																			bool_t
																																																				BgL_test9903z00_25592;
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_arg5934z00_7392;
																																																				BgL_arg5934z00_7392
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test9903z00_25592
																																																					=
																																																					CBOOL
																																																					(BGl_letzd2symzf3z21zzast_letz00
																																																					(BgL_arg5934z00_7392));
																																																			}
																																																			if (BgL_test9903z00_25592)
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_arg5862z00_7278;
																																																					obj_t
																																																						BgL_arg5863z00_7279;
																																																					BgL_arg5862z00_7278
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd246689zd2_7275));
																																																					BgL_arg5863z00_7279
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd246689zd2_7275));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_25601;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_25603;
																																																							obj_t
																																																								BgL_bindingsz00_25602;
																																																							BgL_bindingsz00_25602
																																																								=
																																																								BgL_arg5862z00_7278;
																																																							BgL_exprz00_25603
																																																								=
																																																								BgL_arg5863z00_7279;
																																																							BgL_exprz00_1729
																																																								=
																																																								BgL_exprz00_25603;
																																																							BgL_bindingsz00_1728
																																																								=
																																																								BgL_bindingsz00_25602;
																																																							goto
																																																								BgL_tagzd2382zd2_1730;
																																																						}
																																																						BgL_auxz00_22040
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_25601);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					bool_t
																																																						BgL_test9904z00_25605;
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_arg5933z00_7391;
																																																						BgL_arg5933z00_7391
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test9904z00_25605
																																																							=
																																																							CBOOL
																																																							(BGl_labelszd2symzf3z21zzast_labelsz00
																																																							(BgL_arg5933z00_7391));
																																																					}
																																																					if (BgL_test9904z00_25605)
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_25610;
																																																							goto
																																																								BgL_tagzd2384zd2_1732;
																																																							BgL_auxz00_22040
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_25610);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_carzd246755zd2_7282;
																																																							BgL_carzd246755zd2_7282
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_cdrzd246760zd2_7283;
																																																								BgL_cdrzd246760zd2_7283
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_carzd246755zd2_7282));
																																																								if ((CAR(((obj_t) BgL_carzd246755zd2_7282)) == CNST_TABLE_REF(((long) 3))))
																																																									{	/* Ast/sexp.scm 118 */
																																																										if (PAIRP(BgL_cdrzd246760zd2_7283))
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_arg5869z00_7287;
																																																												obj_t
																																																													BgL_arg5870z00_7288;
																																																												obj_t
																																																													BgL_arg5871z00_7289;
																																																												BgL_arg5869z00_7287
																																																													=
																																																													CAR
																																																													(BgL_cdrzd246760zd2_7283);
																																																												BgL_arg5870z00_7288
																																																													=
																																																													CDR
																																																													(BgL_cdrzd246760zd2_7283);
																																																												BgL_arg5871z00_7289
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_25627;
																																																													{
																																																														obj_t
																																																															BgL_argsz00_25630;
																																																														obj_t
																																																															BgL_bodyz00_25629;
																																																														obj_t
																																																															BgL_varsz00_25628;
																																																														BgL_varsz00_25628
																																																															=
																																																															BgL_arg5869z00_7287;
																																																														BgL_bodyz00_25629
																																																															=
																																																															BgL_arg5870z00_7288;
																																																														BgL_argsz00_25630
																																																															=
																																																															BgL_arg5871z00_7289;
																																																														BgL_argsz00_1739
																																																															=
																																																															BgL_argsz00_25630;
																																																														BgL_bodyz00_1738
																																																															=
																																																															BgL_bodyz00_25629;
																																																														BgL_varsz00_1737
																																																															=
																																																															BgL_varsz00_25628;
																																																														goto
																																																															BgL_tagzd2386zd2_1740;
																																																													}
																																																													BgL_auxz00_22040
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_25627);
																																																												}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 118 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{	/* Ast/sexp.scm 118 */
																																																														goto
																																																															BgL_tagzd2403zd2_1774;
																																																													}
																																																												else
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_25634;
																																																														goto
																																																															BgL_tagzd2404zd2_1775;
																																																														BgL_auxz00_22040
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_25634);
																																																													}
																																																											}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_cdrzd246867zd2_7292;
																																																										BgL_cdrzd246867zd2_7292
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_cdrzd246872zd2_7293;
																																																											BgL_cdrzd246872zd2_7293
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_carzd246755zd2_7282));
																																																											if ((CAR(((obj_t) BgL_carzd246755zd2_7282)) == CNST_TABLE_REF(((long) 1))))
																																																												{	/* Ast/sexp.scm 118 */
																																																													if (PAIRP(BgL_cdrzd246872zd2_7293))
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_cdrzd246877zd2_7297;
																																																															BgL_cdrzd246877zd2_7297
																																																																=
																																																																CDR
																																																																(BgL_cdrzd246872zd2_7293);
																																																															if (PAIRP(BgL_cdrzd246877zd2_7297))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_carzd246881zd2_7299;
																																																																	obj_t
																																																																		BgL_cdrzd246882zd2_7300;
																																																																	BgL_carzd246881zd2_7299
																																																																		=
																																																																		CAR
																																																																		(BgL_cdrzd246877zd2_7297);
																																																																	BgL_cdrzd246882zd2_7300
																																																																		=
																																																																		CDR
																																																																		(BgL_cdrzd246877zd2_7297);
																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd246881zd2_7299))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if (PAIRP(BgL_cdrzd246882zd2_7300))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_carzd246887zd2_7303;
																																																																					BgL_carzd246887zd2_7303
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd246882zd2_7300);
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd246887zd2_7303))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (NULLP(CDR(BgL_cdrzd246882zd2_7300)))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									bool_t
																																																																										BgL_test9915z00_25662;
																																																																									{
																																																																										obj_t
																																																																											BgL_l1445z00_7336;
																																																																										BgL_l1445z00_7336
																																																																											=
																																																																											BgL_cdrzd246867zd2_7292;
																																																																									BgL_zc3z04anonymousza35897ze3z87_7337:
																																																																										if (NULLP(BgL_l1445z00_7336))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												BgL_test9915z00_25662
																																																																													=
																																																																													(
																																																																													(bool_t)
																																																																													1);
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												bool_t
																																																																													BgL_test9917z00_25665;
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													bool_t
																																																																														BgL_test9918z00_25666;
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_tmpz00_25667;
																																																																														BgL_tmpz00_25667
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_l1445z00_7336));
																																																																														BgL_test9918z00_25666
																																																																															=
																																																																															PAIRP
																																																																															(BgL_tmpz00_25667);
																																																																													}
																																																																													if (BgL_test9918z00_25666)
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															BgL_test9917z00_25665
																																																																																=
																																																																																(
																																																																																(bool_t)
																																																																																0);
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															BgL_test9917z00_25665
																																																																																=
																																																																																(
																																																																																(bool_t)
																																																																																1);
																																																																														}
																																																																												}
																																																																												if (BgL_test9917z00_25665)
																																																																													{
																																																																														obj_t
																																																																															BgL_l1445z00_25671;
																																																																														BgL_l1445z00_25671
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_l1445z00_7336));
																																																																														BgL_l1445z00_7336
																																																																															=
																																																																															BgL_l1445z00_25671;
																																																																														goto
																																																																															BgL_zc3z04anonymousza35897ze3z87_7337;
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														BgL_test9915z00_25662
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															0);
																																																																													}
																																																																											}
																																																																									}
																																																																									if (BgL_test9915z00_25662)
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_arg5887z00_7319;
																																																																											BgL_arg5887z00_7319
																																																																												=
																																																																												CAR
																																																																												(BgL_cdrzd246872zd2_7293);
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_25675;
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_25679;
																																																																													obj_t
																																																																														BgL_proc2z00_25678;
																																																																													obj_t
																																																																														BgL_proc1z00_25677;
																																																																													obj_t
																																																																														BgL_testz00_25676;
																																																																													BgL_testz00_25676
																																																																														=
																																																																														BgL_arg5887z00_7319;
																																																																													BgL_proc1z00_25677
																																																																														=
																																																																														BgL_carzd246881zd2_7299;
																																																																													BgL_proc2z00_25678
																																																																														=
																																																																														BgL_carzd246887zd2_7303;
																																																																													BgL_argsz00_25679
																																																																														=
																																																																														BgL_cdrzd246867zd2_7292;
																																																																													BgL_argsz00_1744
																																																																														=
																																																																														BgL_argsz00_25679;
																																																																													BgL_proc2z00_1743
																																																																														=
																																																																														BgL_proc2z00_25678;
																																																																													BgL_proc1z00_1742
																																																																														=
																																																																														BgL_proc1z00_25677;
																																																																													BgL_testz00_1741
																																																																														=
																																																																														BgL_testz00_25676;
																																																																													goto
																																																																														BgL_tagzd2387zd2_1745;
																																																																												}
																																																																												BgL_auxz00_22040
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_25675);
																																																																											}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_cdrzd246912zd2_7320;
																																																																											BgL_cdrzd246912zd2_7320
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_cdrzd246920zd2_7321;
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_pairz00_12647;
																																																																													BgL_pairz00_12647
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													BgL_cdrzd246920zd2_7321
																																																																														=
																																																																														CDR
																																																																														(BgL_pairz00_12647);
																																																																												}
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_cdrzd246928zd2_7322;
																																																																													BgL_cdrzd246928zd2_7322
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd246920zd2_7321));
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_carzd246935zd2_7323;
																																																																														BgL_carzd246935zd2_7323
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd246928zd2_7322));
																																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd246935zd2_7323))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_carzd246944zd2_7325;
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_pairz00_12651;
																																																																																	BgL_pairz00_12651
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd246928zd2_7322));
																																																																																	BgL_carzd246944zd2_7325
																																																																																		=
																																																																																		CAR
																																																																																		(BgL_pairz00_12651);
																																																																																}
																																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd246944zd2_7325))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd246912zd2_7320))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				obj_t
																																																																																					BgL_arg5891z00_7328;
																																																																																				BgL_arg5891z00_7328
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd246920zd2_7321));
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_25701;
																																																																																					{
																																																																																						obj_t
																																																																																							BgL_argsz00_25705;
																																																																																						obj_t
																																																																																							BgL_proc2z00_25704;
																																																																																						obj_t
																																																																																							BgL_proc1z00_25703;
																																																																																						obj_t
																																																																																							BgL_testz00_25702;
																																																																																						BgL_testz00_25702
																																																																																							=
																																																																																							BgL_arg5891z00_7328;
																																																																																						BgL_proc1z00_25703
																																																																																							=
																																																																																							BgL_carzd246935zd2_7323;
																																																																																						BgL_proc2z00_25704
																																																																																							=
																																																																																							BgL_carzd246944zd2_7325;
																																																																																						BgL_argsz00_25705
																																																																																							=
																																																																																							BgL_cdrzd246912zd2_7320;
																																																																																						BgL_argsz00_1749
																																																																																							=
																																																																																							BgL_argsz00_25705;
																																																																																						BgL_proc2z00_1748
																																																																																							=
																																																																																							BgL_proc2z00_25704;
																																																																																						BgL_proc1z00_1747
																																																																																							=
																																																																																							BgL_proc1z00_25703;
																																																																																						BgL_testz00_1746
																																																																																							=
																																																																																							BgL_testz00_25702;
																																																																																						goto
																																																																																							BgL_tagzd2388zd2_1750;
																																																																																					}
																																																																																					BgL_auxz00_22040
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_25701);
																																																																																				}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1774;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_25709;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1775;
																																																																																						BgL_auxz00_22040
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_25709);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1774;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_25713;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1775;
																																																																																				BgL_auxz00_22040
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_25713);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1774;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_25717;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1775;
																																																																																		BgL_auxz00_22040
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_25717);
																																																																																	}
																																																																															}
																																																																													}
																																																																												}
																																																																											}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1774;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_25721;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1775;
																																																																											BgL_auxz00_22040
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_25721);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_cdrzd247222zd2_7347;
																																																																							BgL_cdrzd247222zd2_7347
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_cdrzd247229zd2_7348;
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_pairz00_12655;
																																																																									BgL_pairz00_12655
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									BgL_cdrzd247229zd2_7348
																																																																										=
																																																																										CDR
																																																																										(BgL_pairz00_12655);
																																																																								}
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_cdrzd247236zd2_7349;
																																																																									BgL_cdrzd247236zd2_7349
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd247229zd2_7348));
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_carzd247242zd2_7350;
																																																																										obj_t
																																																																											BgL_cdrzd247243zd2_7351;
																																																																										BgL_carzd247242zd2_7350
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd247236zd2_7349));
																																																																										BgL_cdrzd247243zd2_7351
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd247236zd2_7349));
																																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd247242zd2_7350))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_carzd247250zd2_7353;
																																																																												BgL_carzd247250zd2_7353
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd247243zd2_7351));
																																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd247250zd2_7353))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														if (NULLP(CDR(((obj_t) BgL_cdrzd247243zd2_7351))))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd247222zd2_7347))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		obj_t
																																																																																			BgL_arg5906z00_7358;
																																																																																		BgL_arg5906z00_7358
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd247229zd2_7348));
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_25748;
																																																																																			{
																																																																																				obj_t
																																																																																					BgL_argsz00_25752;
																																																																																				obj_t
																																																																																					BgL_proc2z00_25751;
																																																																																				obj_t
																																																																																					BgL_proc1z00_25750;
																																																																																				obj_t
																																																																																					BgL_testz00_25749;
																																																																																				BgL_testz00_25749
																																																																																					=
																																																																																					BgL_arg5906z00_7358;
																																																																																				BgL_proc1z00_25750
																																																																																					=
																																																																																					BgL_carzd247242zd2_7350;
																																																																																				BgL_proc2z00_25751
																																																																																					=
																																																																																					BgL_carzd247250zd2_7353;
																																																																																				BgL_argsz00_25752
																																																																																					=
																																																																																					BgL_cdrzd247222zd2_7347;
																																																																																				BgL_argsz00_1749
																																																																																					=
																																																																																					BgL_argsz00_25752;
																																																																																				BgL_proc2z00_1748
																																																																																					=
																																																																																					BgL_proc2z00_25751;
																																																																																				BgL_proc1z00_1747
																																																																																					=
																																																																																					BgL_proc1z00_25750;
																																																																																				BgL_testz00_1746
																																																																																					=
																																																																																					BgL_testz00_25749;
																																																																																				goto
																																																																																					BgL_tagzd2388zd2_1750;
																																																																																			}
																																																																																			BgL_auxz00_22040
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_25748);
																																																																																		}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1774;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_25756;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1775;
																																																																																				BgL_auxz00_22040
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_25756);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1774;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_25760;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1775;
																																																																																		BgL_auxz00_22040
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_25760);
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1774;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_25764;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1775;
																																																																																BgL_auxz00_22040
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_25764);
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1774;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_25768;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1775;
																																																																														BgL_auxz00_22040
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_25768);
																																																																													}
																																																																											}
																																																																									}
																																																																								}
																																																																							}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1774;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_25772;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1775;
																																																																							BgL_auxz00_22040
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_25772);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_cdrzd247583zd2_7366;
																																																																			BgL_cdrzd247583zd2_7366
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_expz00_21));
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_cdrzd247589zd2_7367;
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_pairz00_12665;
																																																																					BgL_pairz00_12665
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_expz00_21));
																																																																					BgL_cdrzd247589zd2_7367
																																																																						=
																																																																						CDR
																																																																						(BgL_pairz00_12665);
																																																																				}
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_cdrzd247595zd2_7368;
																																																																					BgL_cdrzd247595zd2_7368
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd247589zd2_7367));
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_carzd247600zd2_7369;
																																																																						obj_t
																																																																							BgL_cdrzd247601zd2_7370;
																																																																						BgL_carzd247600zd2_7369
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd247595zd2_7368));
																																																																						BgL_cdrzd247601zd2_7370
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd247595zd2_7368));
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd247600zd2_7369))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (PAIRP(BgL_cdrzd247601zd2_7370))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_carzd247606zd2_7373;
																																																																										BgL_carzd247606zd2_7373
																																																																											=
																																																																											CAR
																																																																											(BgL_cdrzd247601zd2_7370);
																																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd247606zd2_7373))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												if (NULLP(CDR(BgL_cdrzd247601zd2_7370)))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd247583zd2_7366))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_arg5920z00_7378;
																																																																																BgL_arg5920z00_7378
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd247589zd2_7367));
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_25799;
																																																																																	{
																																																																																		obj_t
																																																																																			BgL_argsz00_25803;
																																																																																		obj_t
																																																																																			BgL_proc2z00_25802;
																																																																																		obj_t
																																																																																			BgL_proc1z00_25801;
																																																																																		obj_t
																																																																																			BgL_testz00_25800;
																																																																																		BgL_testz00_25800
																																																																																			=
																																																																																			BgL_arg5920z00_7378;
																																																																																		BgL_proc1z00_25801
																																																																																			=
																																																																																			BgL_carzd247600zd2_7369;
																																																																																		BgL_proc2z00_25802
																																																																																			=
																																																																																			BgL_carzd247606zd2_7373;
																																																																																		BgL_argsz00_25803
																																																																																			=
																																																																																			BgL_cdrzd247583zd2_7366;
																																																																																		BgL_argsz00_1749
																																																																																			=
																																																																																			BgL_argsz00_25803;
																																																																																		BgL_proc2z00_1748
																																																																																			=
																																																																																			BgL_proc2z00_25802;
																																																																																		BgL_proc1z00_1747
																																																																																			=
																																																																																			BgL_proc1z00_25801;
																																																																																		BgL_testz00_1746
																																																																																			=
																																																																																			BgL_testz00_25800;
																																																																																		goto
																																																																																			BgL_tagzd2388zd2_1750;
																																																																																	}
																																																																																	BgL_auxz00_22040
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_25799);
																																																																																}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1774;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_25807;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1775;
																																																																																		BgL_auxz00_22040
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_25807);
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1774;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_25811;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1775;
																																																																																BgL_auxz00_22040
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_25811);
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1774;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_25815;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1775;
																																																																														BgL_auxz00_22040
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_25815);
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1774;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_25819;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1775;
																																																																												BgL_auxz00_22040
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_25819);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1774;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_25823;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1775;
																																																																										BgL_auxz00_22040
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_25823);
																																																																									}
																																																																							}
																																																																					}
																																																																				}
																																																																			}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1774;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_25827;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1775;
																																																																			BgL_auxz00_22040
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_25827);
																																																																		}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1774;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_25831;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1775;
																																																																	BgL_auxz00_22040
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_25831);
																																																																}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{	/* Ast/sexp.scm 118 */
																																																															goto
																																																																BgL_tagzd2403zd2_1774;
																																																														}
																																																													else
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_25835;
																																																															goto
																																																																BgL_tagzd2404zd2_1775;
																																																															BgL_auxz00_22040
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_25835);
																																																														}
																																																												}
																																																										}
																																																									}
																																																							}
																																																						}
																																																				}
																																																		}
																																																	}
																																															}
																																													}
																																											}
																																									}
																																							}
																																						}
																																					else
																																						{	/* Ast/sexp.scm 118 */
																																							if ((BgL_carzd245079zd2_7265 == CNST_TABLE_REF(((long) 17))))
																																								{	/* Ast/sexp.scm 118 */
																																									obj_t
																																										BgL_arg6036z00_7544;
																																									obj_t
																																										BgL_arg6037z00_7545;
																																									BgL_arg6036z00_7544
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_cdrzd244978zd2_7249));
																																									BgL_arg6037z00_7545
																																										=
																																										CDR
																																										(
																																										((obj_t) BgL_cdrzd244978zd2_7249));
																																									{
																																										BgL_nodez00_bglt
																																											BgL_auxz00_25844;
																																										{
																																											obj_t
																																												BgL_exprz00_25846;
																																											obj_t
																																												BgL_bindingsz00_25845;
																																											BgL_bindingsz00_25845
																																												=
																																												BgL_arg6036z00_7544;
																																											BgL_exprz00_25846
																																												=
																																												BgL_arg6037z00_7545;
																																											BgL_exprz00_1729
																																												=
																																												BgL_exprz00_25846;
																																											BgL_bindingsz00_1728
																																												=
																																												BgL_bindingsz00_25845;
																																											goto
																																												BgL_tagzd2382zd2_1730;
																																										}
																																										BgL_auxz00_22040
																																											=
																																											(
																																											(obj_t)
																																											BgL_auxz00_25844);
																																									}
																																								}
																																							else
																																								{	/* Ast/sexp.scm 118 */
																																									if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd245079zd2_7265)))
																																										{	/* Ast/sexp.scm 118 */
																																											obj_t
																																												BgL_arg6039z00_7547;
																																											obj_t
																																												BgL_arg6040z00_7548;
																																											BgL_arg6039z00_7547
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_cdrzd244978zd2_7249));
																																											BgL_arg6040z00_7548
																																												=
																																												CDR
																																												(
																																												((obj_t) BgL_cdrzd244978zd2_7249));
																																											{
																																												BgL_nodez00_bglt
																																													BgL_auxz00_25855;
																																												{
																																													obj_t
																																														BgL_exprz00_25857;
																																													obj_t
																																														BgL_bindingsz00_25856;
																																													BgL_bindingsz00_25856
																																														=
																																														BgL_arg6039z00_7547;
																																													BgL_exprz00_25857
																																														=
																																														BgL_arg6040z00_7548;
																																													BgL_exprz00_1729
																																														=
																																														BgL_exprz00_25857;
																																													BgL_bindingsz00_1728
																																														=
																																														BgL_bindingsz00_25856;
																																													goto
																																														BgL_tagzd2382zd2_1730;
																																												}
																																												BgL_auxz00_22040
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_25855);
																																											}
																																										}
																																									else
																																										{	/* Ast/sexp.scm 118 */
																																											if ((BgL_carzd245079zd2_7265 == CNST_TABLE_REF(((long) 18))))
																																												{	/* Ast/sexp.scm 118 */
																																													obj_t
																																														BgL_arg6042z00_7550;
																																													obj_t
																																														BgL_arg6043z00_7551;
																																													BgL_arg6042z00_7550
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_cdrzd244978zd2_7249));
																																													BgL_arg6043z00_7551
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_cdrzd244978zd2_7249));
																																													{
																																														BgL_nodez00_bglt
																																															BgL_auxz00_25866;
																																														{
																																															obj_t
																																																BgL_exprz00_25868;
																																															obj_t
																																																BgL_bindingsz00_25867;
																																															BgL_bindingsz00_25867
																																																=
																																																BgL_arg6042z00_7550;
																																															BgL_exprz00_25868
																																																=
																																																BgL_arg6043z00_7551;
																																															BgL_exprz00_1729
																																																=
																																																BgL_exprz00_25868;
																																															BgL_bindingsz00_1728
																																																=
																																																BgL_bindingsz00_25867;
																																															goto
																																																BgL_tagzd2382zd2_1730;
																																														}
																																														BgL_auxz00_22040
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_25866);
																																													}
																																												}
																																											else
																																												{	/* Ast/sexp.scm 118 */
																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_25875;
																																															goto
																																																BgL_tagzd2383zd2_1731;
																																															BgL_auxz00_22040
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_25875);
																																														}
																																													else
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_carzd248181zd2_7554;
																																															BgL_carzd248181zd2_7554
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															if ((BgL_carzd248181zd2_7554 == CNST_TABLE_REF(((long) 19))))
																																																{
																																																	BgL_letzd2funzd2_bglt
																																																		BgL_auxz00_25882;
																																																	goto
																																																		BgL_tagzd2384zd2_1732;
																																																	BgL_auxz00_22040
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_25882);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd248181zd2_7554)))
																																																		{
																																																			BgL_letzd2funzd2_bglt
																																																				BgL_auxz00_25887;
																																																			goto
																																																				BgL_tagzd2384zd2_1732;
																																																			BgL_auxz00_22040
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_25887);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_25894;
																																																					goto
																																																						BgL_tagzd2389zd2_1751;
																																																					BgL_auxz00_22040
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_25894);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_25901;
																																																							goto
																																																								BgL_tagzd2390zd2_1752;
																																																							BgL_auxz00_22040
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_25901);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_cdrzd248261zd2_7561;
																																																							BgL_cdrzd248261zd2_7561
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_arg6054z00_7564;
																																																									obj_t
																																																										BgL_arg6055z00_7565;
																																																									BgL_arg6054z00_7564
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd248261zd2_7561));
																																																									BgL_arg6055z00_7565
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd248261zd2_7561));
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_25914;
																																																										{
																																																											obj_t
																																																												BgL_restz00_25916;
																																																											obj_t
																																																												BgL_effectz00_25915;
																																																											BgL_effectz00_25915
																																																												=
																																																												BgL_arg6054z00_7564;
																																																											BgL_restz00_25916
																																																												=
																																																												BgL_arg6055z00_7565;
																																																											BgL_restz00_1754
																																																												=
																																																												BgL_restz00_25916;
																																																											BgL_effectz00_1753
																																																												=
																																																												BgL_effectz00_25915;
																																																											goto
																																																												BgL_tagzd2391zd2_1755;
																																																										}
																																																										BgL_auxz00_22040
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_25914);
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_25923;
																																																											goto
																																																												BgL_tagzd2392zd2_1756;
																																																											BgL_auxz00_22040
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_25923);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_25930;
																																																													goto
																																																														BgL_tagzd2393zd2_1757;
																																																													BgL_auxz00_22040
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_25930);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_arg6062z00_7573;
																																																															obj_t
																																																																BgL_arg6063z00_7574;
																																																															BgL_arg6062z00_7573
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_cdrzd248261zd2_7561));
																																																															BgL_arg6063z00_7574
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd248261zd2_7561));
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_25941;
																																																																{
																																																																	obj_t
																																																																		BgL_restz00_25943;
																																																																	obj_t
																																																																		BgL_effectz00_25942;
																																																																	BgL_effectz00_25942
																																																																		=
																																																																		BgL_arg6062z00_7573;
																																																																	BgL_restz00_25943
																																																																		=
																																																																		BgL_arg6063z00_7574;
																																																																	BgL_restz00_1759
																																																																		=
																																																																		BgL_restz00_25943;
																																																																	BgL_effectz00_1758
																																																																		=
																																																																		BgL_effectz00_25942;
																																																																	goto
																																																																		BgL_tagzd2394zd2_1760;
																																																																}
																																																																BgL_auxz00_22040
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_25941);
																																																															}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_25950;
																																																																	goto
																																																																		BgL_tagzd2395zd2_1761;
																																																																	BgL_auxz00_22040
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_25950);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_25957;
																																																																			goto
																																																																				BgL_tagzd2396zd2_1762;
																																																																			BgL_auxz00_22040
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_25957);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																				{
																																																																					BgL_letzd2funzd2_bglt
																																																																						BgL_auxz00_25964;
																																																																					goto
																																																																						BgL_tagzd2397zd2_1763;
																																																																					BgL_auxz00_22040
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_25964);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																						{
																																																																							BgL_jumpzd2exzd2itz00_bglt
																																																																								BgL_auxz00_25971;
																																																																							goto
																																																																								BgL_tagzd2398zd2_1764;
																																																																							BgL_auxz00_22040
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_25971);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 30))))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									bool_t
																																																																										BgL_test9965z00_25978;
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_tmpz00_25979;
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_pairz00_12703;
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_pairz00_12702;
																																																																												BgL_pairz00_12702
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_expz00_21));
																																																																												BgL_pairz00_12703
																																																																													=
																																																																													CDR
																																																																													(BgL_pairz00_12702);
																																																																											}
																																																																											BgL_tmpz00_25979
																																																																												=
																																																																												CDR
																																																																												(BgL_pairz00_12703);
																																																																										}
																																																																										BgL_test9965z00_25978
																																																																											=
																																																																											NULLP
																																																																											(BgL_tmpz00_25979);
																																																																									}
																																																																									if (BgL_test9965z00_25978)
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_25985;
																																																																											goto
																																																																												BgL_tagzd2399zd2_1765;
																																																																											BgL_auxz00_22040
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_25985);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1774;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_25989;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1775;
																																																																													BgL_auxz00_22040
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_25989);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_cdrzd248349zd2_7593;
																																																																									BgL_cdrzd248349zd2_7593
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_cdrzd248355zd2_7596;
																																																																											BgL_cdrzd248355zd2_7596
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd248349zd2_7593));
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_cdrzd248361zd2_7597;
																																																																												BgL_cdrzd248361zd2_7597
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd248355zd2_7596));
																																																																												if ((CAR(((obj_t) BgL_cdrzd248355zd2_7596)) == CNST_TABLE_REF(((long) 31))))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														if (PAIRP(BgL_cdrzd248361zd2_7597))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_arg6087z00_7601;
																																																																																obj_t
																																																																																	BgL_arg6088z00_7602;
																																																																																obj_t
																																																																																	BgL_arg6089z00_7603;
																																																																																BgL_arg6087z00_7601
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd248349zd2_7593));
																																																																																BgL_arg6088z00_7602
																																																																																	=
																																																																																	CAR
																																																																																	(BgL_cdrzd248361zd2_7597);
																																																																																BgL_arg6089z00_7603
																																																																																	=
																																																																																	CDR
																																																																																	(BgL_cdrzd248361zd2_7597);
																																																																																{	/* Ast/sexp.scm 549 */
																																																																																	obj_t
																																																																																		BgL_arg6988z00_12714;
																																																																																	BgL_arg6988z00_12714
																																																																																		=
																																																																																		BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																		(BgL_expz00_21,
																																																																																		BgL_locz00_23);
																																																																																	BgL_auxz00_22040
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																		(BgL_expz00_21,
																																																																																			BgL_arg6087z00_7601,
																																																																																			BgL_arg6088z00_7602,
																																																																																			BgL_arg6089z00_7603,
																																																																																			BgL_stackz00_22,
																																																																																			BgL_arg6988z00_12714,
																																																																																			BgL_sitez00_24));
																																																																																}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_arg6090z00_7605;
																																																																																obj_t
																																																																																	BgL_arg6091z00_7606;
																																																																																BgL_arg6090z00_7605
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd248349zd2_7593));
																																																																																BgL_arg6091z00_7606
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd248349zd2_7593));
																																																																																{	/* Ast/sexp.scm 551 */
																																																																																	obj_t
																																																																																		BgL_arg6989z00_12718;
																																																																																	BgL_arg6989z00_12718
																																																																																		=
																																																																																		BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																		(BgL_expz00_21,
																																																																																		BgL_locz00_23);
																																																																																	BgL_auxz00_22040
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																		(BgL_expz00_21,
																																																																																			BgL_arg6090z00_7605,
																																																																																			CNST_TABLE_REF
																																																																																			(((long) 4)), BgL_arg6091z00_7606, BgL_stackz00_22, BgL_arg6989z00_12718, BgL_sitez00_24));
																																																																													}}}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_arg6092z00_7608;
																																																																														obj_t
																																																																															BgL_arg6093z00_7609;
																																																																														BgL_arg6092z00_7608
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd248349zd2_7593));
																																																																														BgL_arg6093z00_7609
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd248349zd2_7593));
																																																																														{	/* Ast/sexp.scm 551 */
																																																																															obj_t
																																																																																BgL_arg6989z00_12722;
																																																																															BgL_arg6989z00_12722
																																																																																=
																																																																																BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																(BgL_expz00_21,
																																																																																BgL_locz00_23);
																																																																															BgL_auxz00_22040
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																(BgL_expz00_21,
																																																																																	BgL_arg6092z00_7608,
																																																																																	CNST_TABLE_REF
																																																																																	(((long) 4)), BgL_arg6093z00_7609, BgL_stackz00_22, BgL_arg6989z00_12722, BgL_sitez00_24));
																																																																										}}}}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1774;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_26034;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1775;
																																																																													BgL_auxz00_22040
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_26034);
																																																																												}
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																										}
																									else
																										{	/* Ast/sexp.scm 118 */
																											obj_t
																												BgL_carzd248412zd2_7628;
																											BgL_carzd248412zd2_7628 =
																												CAR(((obj_t)
																													BgL_expz00_21));
																											if (
																												(BgL_carzd248412zd2_7628
																													==
																													CNST_TABLE_REF(((long)
																															1))))
																												{
																													BgL_nodez00_bglt
																														BgL_auxz00_26041;
																													goto
																														BgL_tagzd2377zd2_1719;
																													BgL_auxz00_22040 =
																														((obj_t)
																														BgL_auxz00_26041);
																												}
																											else
																												{	/* Ast/sexp.scm 118 */
																													if (
																														(BgL_carzd248412zd2_7628
																															==
																															BGl_za2ifza2z00zzast_sexpz00))
																														{
																															BgL_nodez00_bglt
																																BgL_auxz00_26045;
																															goto
																																BgL_tagzd2377zd2_1719;
																															BgL_auxz00_22040 =
																																((obj_t)
																																BgL_auxz00_26045);
																														}
																													else
																														{	/* Ast/sexp.scm 118 */
																															if (
																																(CAR(
																																		((obj_t)
																																			BgL_expz00_21))
																																	==
																																	CNST_TABLE_REF
																																	(((long) 7))))
																																{
																																	BgL_nodez00_bglt
																																		BgL_auxz00_26052;
																																	goto
																																		BgL_tagzd2379zd2_1723;
																																	BgL_auxz00_22040
																																		=
																																		((obj_t)
																																		BgL_auxz00_26052);
																																}
																															else
																																{	/* Ast/sexp.scm 118 */
																																	if (
																																		(CAR(
																																				((obj_t)
																																					BgL_expz00_21))
																																			==
																																			CNST_TABLE_REF
																																			(((long)
																																					16))))
																																		{
																																			BgL_nodez00_bglt
																																				BgL_auxz00_26059;
																																			goto
																																				BgL_tagzd2380zd2_1724;
																																			BgL_auxz00_22040
																																				=
																																				((obj_t)
																																				BgL_auxz00_26059);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 118 */
																																			obj_t
																																				BgL_carzd248481zd2_7635;
																																			BgL_carzd248481zd2_7635
																																				=
																																				CAR((
																																					(obj_t)
																																					BgL_expz00_21));
																																			if (PAIRP
																																				(BgL_carzd248481zd2_7635))
																																				{	/* Ast/sexp.scm 118 */
																																					obj_t
																																						BgL_carzd248484zd2_7637;
																																					obj_t
																																						BgL_cdrzd248485zd2_7638;
																																					BgL_carzd248484zd2_7637
																																						=
																																						CAR
																																						(BgL_carzd248481zd2_7635);
																																					BgL_cdrzd248485zd2_7638
																																						=
																																						CDR
																																						(BgL_carzd248481zd2_7635);
																																					{

																																						if (
																																							(BgL_carzd248484zd2_7637
																																								==
																																								CNST_TABLE_REF
																																								(((long) 17))))
																																							{	/* Ast/sexp.scm 118 */
																																							BgL_kapzd248486zd2_7639:
																																								if (PAIRP(BgL_cdrzd248485zd2_7638))
																																									{	/* Ast/sexp.scm 118 */
																																										obj_t
																																											BgL_cdrzd248489zd2_7821;
																																										BgL_cdrzd248489zd2_7821
																																											=
																																											CDR
																																											(BgL_cdrzd248485zd2_7638);
																																										if (PAIRP(BgL_cdrzd248489zd2_7821))
																																											{	/* Ast/sexp.scm 118 */
																																												if (NULLP(CDR(BgL_cdrzd248489zd2_7821)))
																																													{	/* Ast/sexp.scm 118 */
																																														obj_t
																																															BgL_arg6247z00_7825;
																																														obj_t
																																															BgL_arg6248z00_7826;
																																														BgL_arg6247z00_7825
																																															=
																																															CAR
																																															(BgL_cdrzd248489zd2_7821);
																																														BgL_arg6248z00_7826
																																															=
																																															CDR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_26081;
																																															{
																																																obj_t
																																																	BgL_argsz00_26083;
																																																obj_t
																																																	BgL_bodyz00_26082;
																																																BgL_bodyz00_26082
																																																	=
																																																	BgL_arg6247z00_7825;
																																																BgL_argsz00_26083
																																																	=
																																																	BgL_arg6248z00_7826;
																																																BgL_argsz00_1726
																																																	=
																																																	BgL_argsz00_26083;
																																																BgL_bodyz00_1725
																																																	=
																																																	BgL_bodyz00_26082;
																																																goto
																																																	BgL_tagzd2381zd2_1727;
																																															}
																																															BgL_auxz00_22040
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_26081);
																																														}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														obj_t
																																															BgL_cdrzd248513zd2_7827;
																																														BgL_cdrzd248513zd2_7827
																																															=
																																															CDR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														{	/* Ast/sexp.scm 118 */
																																															bool_t
																																																BgL_test9980z00_26087;
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_arg6317z00_7938;
																																																BgL_arg6317z00_7938
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																BgL_test9980z00_26087
																																																	=
																																																	CBOOL
																																																	(BGl_letzd2symzf3z21zzast_letz00
																																																	(BgL_arg6317z00_7938));
																																															}
																																															if (BgL_test9980z00_26087)
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_arg6251z00_7830;
																																																	obj_t
																																																		BgL_arg6252z00_7831;
																																																	BgL_arg6251z00_7830
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd248513zd2_7827));
																																																	BgL_arg6252z00_7831
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd248513zd2_7827));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_26096;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_26098;
																																																			obj_t
																																																				BgL_bindingsz00_26097;
																																																			BgL_bindingsz00_26097
																																																				=
																																																				BgL_arg6251z00_7830;
																																																			BgL_exprz00_26098
																																																				=
																																																				BgL_arg6252z00_7831;
																																																			BgL_exprz00_1729
																																																				=
																																																				BgL_exprz00_26098;
																																																			BgL_bindingsz00_1728
																																																				=
																																																				BgL_bindingsz00_26097;
																																																			goto
																																																				BgL_tagzd2382zd2_1730;
																																																		}
																																																		BgL_auxz00_22040
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_26096);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	bool_t
																																																		BgL_test9981z00_26100;
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_arg6316z00_7937;
																																																		BgL_arg6316z00_7937
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_test9981z00_26100
																																																			=
																																																			CBOOL
																																																			(BGl_labelszd2symzf3z21zzast_labelsz00
																																																			(BgL_arg6316z00_7937));
																																																	}
																																																	if (BgL_test9981z00_26100)
																																																		{
																																																			BgL_letzd2funzd2_bglt
																																																				BgL_auxz00_26105;
																																																			goto
																																																				BgL_tagzd2384zd2_1732;
																																																			BgL_auxz00_22040
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_26105);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_carzd248580zd2_7834;
																																																			BgL_carzd248580zd2_7834
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_cdrzd248585zd2_7835;
																																																				BgL_cdrzd248585zd2_7835
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_carzd248580zd2_7834));
																																																				if ((CAR(((obj_t) BgL_carzd248580zd2_7834)) == CNST_TABLE_REF(((long) 3))))
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_arg6257z00_7838;
																																																						obj_t
																																																							BgL_arg6258z00_7839;
																																																						obj_t
																																																							BgL_arg6259z00_7840;
																																																						BgL_arg6257z00_7838
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_cdrzd248585zd2_7835));
																																																						BgL_arg6258z00_7839
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_cdrzd248585zd2_7835));
																																																						BgL_arg6259z00_7840
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_26122;
																																																							{
																																																								obj_t
																																																									BgL_argsz00_26125;
																																																								obj_t
																																																									BgL_bodyz00_26124;
																																																								obj_t
																																																									BgL_varsz00_26123;
																																																								BgL_varsz00_26123
																																																									=
																																																									BgL_arg6257z00_7838;
																																																								BgL_bodyz00_26124
																																																									=
																																																									BgL_arg6258z00_7839;
																																																								BgL_argsz00_26125
																																																									=
																																																									BgL_arg6259z00_7840;
																																																								BgL_argsz00_1739
																																																									=
																																																									BgL_argsz00_26125;
																																																								BgL_bodyz00_1738
																																																									=
																																																									BgL_bodyz00_26124;
																																																								BgL_varsz00_1737
																																																									=
																																																									BgL_varsz00_26123;
																																																								goto
																																																									BgL_tagzd2386zd2_1740;
																																																							}
																																																							BgL_auxz00_22040
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_26122);
																																																						}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_cdrzd248608zd2_7842;
																																																						BgL_cdrzd248608zd2_7842
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_cdrzd248614zd2_7843;
																																																							BgL_cdrzd248614zd2_7843
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_carzd248580zd2_7834));
																																																							if ((CAR(((obj_t) BgL_carzd248580zd2_7834)) == CNST_TABLE_REF(((long) 1))))
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_cdrzd248620zd2_7846;
																																																									BgL_cdrzd248620zd2_7846
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd248614zd2_7843));
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_carzd248625zd2_7847;
																																																										obj_t
																																																											BgL_cdrzd248626zd2_7848;
																																																										BgL_carzd248625zd2_7847
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_cdrzd248620zd2_7846));
																																																										BgL_cdrzd248626zd2_7848
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_cdrzd248620zd2_7846));
																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd248625zd2_7847))
																																																											{	/* Ast/sexp.scm 118 */
																																																												if (PAIRP(BgL_cdrzd248626zd2_7848))
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_carzd248633zd2_7851;
																																																														BgL_carzd248633zd2_7851
																																																															=
																																																															CAR
																																																															(BgL_cdrzd248626zd2_7848);
																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd248633zd2_7851))
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (NULLP(CDR(BgL_cdrzd248626zd2_7848)))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		bool_t
																																																																			BgL_test9988z00_26152;
																																																																		{
																																																																			obj_t
																																																																				BgL_l1448z00_7884;
																																																																			BgL_l1448z00_7884
																																																																				=
																																																																				BgL_cdrzd248608zd2_7842;
																																																																		BgL_zc3z04anonymousza36282ze3z87_7885:
																																																																			if (NULLP(BgL_l1448z00_7884))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					BgL_test9988z00_26152
																																																																						=
																																																																						(
																																																																						(bool_t)
																																																																						1);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					bool_t
																																																																						BgL_test9990z00_26155;
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						bool_t
																																																																							BgL_test9991z00_26156;
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_tmpz00_26157;
																																																																							BgL_tmpz00_26157
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_l1448z00_7884));
																																																																							BgL_test9991z00_26156
																																																																								=
																																																																								PAIRP
																																																																								(BgL_tmpz00_26157);
																																																																						}
																																																																						if (BgL_test9991z00_26156)
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								BgL_test9990z00_26155
																																																																									=
																																																																									(
																																																																									(bool_t)
																																																																									0);
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								BgL_test9990z00_26155
																																																																									=
																																																																									(
																																																																									(bool_t)
																																																																									1);
																																																																							}
																																																																					}
																																																																					if (BgL_test9990z00_26155)
																																																																						{
																																																																							obj_t
																																																																								BgL_l1448z00_26161;
																																																																							BgL_l1448z00_26161
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_l1448z00_7884));
																																																																							BgL_l1448z00_7884
																																																																								=
																																																																								BgL_l1448z00_26161;
																																																																							goto
																																																																								BgL_zc3z04anonymousza36282ze3z87_7885;
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							BgL_test9988z00_26152
																																																																								=
																																																																								(
																																																																								(bool_t)
																																																																								0);
																																																																						}
																																																																				}
																																																																		}
																																																																		if (BgL_test9988z00_26152)
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_arg6272z00_7867;
																																																																				BgL_arg6272z00_7867
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd248614zd2_7843));
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_26166;
																																																																					{
																																																																						obj_t
																																																																							BgL_argsz00_26170;
																																																																						obj_t
																																																																							BgL_proc2z00_26169;
																																																																						obj_t
																																																																							BgL_proc1z00_26168;
																																																																						obj_t
																																																																							BgL_testz00_26167;
																																																																						BgL_testz00_26167
																																																																							=
																																																																							BgL_arg6272z00_7867;
																																																																						BgL_proc1z00_26168
																																																																							=
																																																																							BgL_carzd248625zd2_7847;
																																																																						BgL_proc2z00_26169
																																																																							=
																																																																							BgL_carzd248633zd2_7851;
																																																																						BgL_argsz00_26170
																																																																							=
																																																																							BgL_cdrzd248608zd2_7842;
																																																																						BgL_argsz00_1744
																																																																							=
																																																																							BgL_argsz00_26170;
																																																																						BgL_proc2z00_1743
																																																																							=
																																																																							BgL_proc2z00_26169;
																																																																						BgL_proc1z00_1742
																																																																							=
																																																																							BgL_proc1z00_26168;
																																																																						BgL_testz00_1741
																																																																							=
																																																																							BgL_testz00_26167;
																																																																						goto
																																																																							BgL_tagzd2387zd2_1745;
																																																																					}
																																																																					BgL_auxz00_22040
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_26166);
																																																																				}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_cdrzd248657zd2_7868;
																																																																				BgL_cdrzd248657zd2_7868
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_cdrzd248664zd2_7869;
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_pairz00_12766;
																																																																						BgL_pairz00_12766
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						BgL_cdrzd248664zd2_7869
																																																																							=
																																																																							CDR
																																																																							(BgL_pairz00_12766);
																																																																					}
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_cdrzd248671zd2_7870;
																																																																						BgL_cdrzd248671zd2_7870
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd248664zd2_7869));
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_carzd248677zd2_7871;
																																																																							BgL_carzd248677zd2_7871
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd248671zd2_7870));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd248677zd2_7871))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_carzd248684zd2_7873;
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_pairz00_12770;
																																																																										BgL_pairz00_12770
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd248671zd2_7870));
																																																																										BgL_carzd248684zd2_7873
																																																																											=
																																																																											CAR
																																																																											(BgL_pairz00_12770);
																																																																									}
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd248684zd2_7873))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd248657zd2_7868))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_arg6276z00_7876;
																																																																													BgL_arg6276z00_7876
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd248664zd2_7869));
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_26192;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_26196;
																																																																															obj_t
																																																																																BgL_proc2z00_26195;
																																																																															obj_t
																																																																																BgL_proc1z00_26194;
																																																																															obj_t
																																																																																BgL_testz00_26193;
																																																																															BgL_testz00_26193
																																																																																=
																																																																																BgL_arg6276z00_7876;
																																																																															BgL_proc1z00_26194
																																																																																=
																																																																																BgL_carzd248677zd2_7871;
																																																																															BgL_proc2z00_26195
																																																																																=
																																																																																BgL_carzd248684zd2_7873;
																																																																															BgL_argsz00_26196
																																																																																=
																																																																																BgL_cdrzd248657zd2_7868;
																																																																															BgL_argsz00_1749
																																																																																=
																																																																																BgL_argsz00_26196;
																																																																															BgL_proc2z00_1748
																																																																																=
																																																																																BgL_proc2z00_26195;
																																																																															BgL_proc1z00_1747
																																																																																=
																																																																																BgL_proc1z00_26194;
																																																																															BgL_testz00_1746
																																																																																=
																																																																																BgL_testz00_26193;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1750;
																																																																														}
																																																																														BgL_auxz00_22040
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_26192);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1774;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_26200;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1775;
																																																																															BgL_auxz00_22040
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_26200);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1774;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_26204;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1775;
																																																																													BgL_auxz00_22040
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_26204);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1774;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_26208;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1775;
																																																																											BgL_auxz00_22040
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_26208);
																																																																										}
																																																																								}
																																																																						}
																																																																					}
																																																																				}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1774;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_26212;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1775;
																																																																				BgL_auxz00_22040
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_26212);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_cdrzd248960zd2_7895;
																																																																BgL_cdrzd248960zd2_7895
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd248966zd2_7896;
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_pairz00_12774;
																																																																		BgL_pairz00_12774
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		BgL_cdrzd248966zd2_7896
																																																																			=
																																																																			CDR
																																																																			(BgL_pairz00_12774);
																																																																	}
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_cdrzd248972zd2_7897;
																																																																		BgL_cdrzd248972zd2_7897
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd248966zd2_7896));
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_carzd248977zd2_7898;
																																																																			obj_t
																																																																				BgL_cdrzd248978zd2_7899;
																																																																			BgL_carzd248977zd2_7898
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd248972zd2_7897));
																																																																			BgL_cdrzd248978zd2_7899
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd248972zd2_7897));
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd248977zd2_7898))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_carzd248983zd2_7901;
																																																																					BgL_carzd248983zd2_7901
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd248978zd2_7899));
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd248983zd2_7901))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (NULLP(CDR(((obj_t) BgL_cdrzd248978zd2_7899))))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd248960zd2_7895))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_arg6291z00_7906;
																																																																											BgL_arg6291z00_7906
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd248966zd2_7896));
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_26239;
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_26243;
																																																																													obj_t
																																																																														BgL_proc2z00_26242;
																																																																													obj_t
																																																																														BgL_proc1z00_26241;
																																																																													obj_t
																																																																														BgL_testz00_26240;
																																																																													BgL_testz00_26240
																																																																														=
																																																																														BgL_arg6291z00_7906;
																																																																													BgL_proc1z00_26241
																																																																														=
																																																																														BgL_carzd248977zd2_7898;
																																																																													BgL_proc2z00_26242
																																																																														=
																																																																														BgL_carzd248983zd2_7901;
																																																																													BgL_argsz00_26243
																																																																														=
																																																																														BgL_cdrzd248960zd2_7895;
																																																																													BgL_argsz00_1749
																																																																														=
																																																																														BgL_argsz00_26243;
																																																																													BgL_proc2z00_1748
																																																																														=
																																																																														BgL_proc2z00_26242;
																																																																													BgL_proc1z00_1747
																																																																														=
																																																																														BgL_proc1z00_26241;
																																																																													BgL_testz00_1746
																																																																														=
																																																																														BgL_testz00_26240;
																																																																													goto
																																																																														BgL_tagzd2388zd2_1750;
																																																																												}
																																																																												BgL_auxz00_22040
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_26239);
																																																																											}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1774;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_26247;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1775;
																																																																													BgL_auxz00_22040
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_26247);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1774;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_26251;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1775;
																																																																											BgL_auxz00_22040
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_26251);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1774;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_26255;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1775;
																																																																									BgL_auxz00_22040
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_26255);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1774;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_26259;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1775;
																																																																							BgL_auxz00_22040
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_26259);
																																																																						}
																																																																				}
																																																																		}
																																																																	}
																																																																}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 118 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 118 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1774;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_26263;
																																																																goto
																																																																	BgL_tagzd2404zd2_1775;
																																																																BgL_auxz00_22040
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_26263);
																																																															}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_cdrzd249316zd2_7914;
																																																												BgL_cdrzd249316zd2_7914
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_cdrzd249323zd2_7915;
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_pairz00_12784;
																																																														BgL_pairz00_12784
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														BgL_cdrzd249323zd2_7915
																																																															=
																																																															CDR
																																																															(BgL_pairz00_12784);
																																																													}
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_cdrzd249330zd2_7916;
																																																														BgL_cdrzd249330zd2_7916
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd249323zd2_7915));
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_carzd249336zd2_7917;
																																																															obj_t
																																																																BgL_cdrzd249337zd2_7918;
																																																															BgL_carzd249336zd2_7917
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_cdrzd249330zd2_7916));
																																																															BgL_cdrzd249337zd2_7918
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd249330zd2_7916));
																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd249336zd2_7917))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if (PAIRP(BgL_cdrzd249337zd2_7918))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_carzd249344zd2_7921;
																																																																			BgL_carzd249344zd2_7921
																																																																				=
																																																																				CAR
																																																																				(BgL_cdrzd249337zd2_7918);
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd249344zd2_7921))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (NULLP(CDR(BgL_cdrzd249337zd2_7918)))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd249316zd2_7914))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_arg6305z00_7926;
																																																																									BgL_arg6305z00_7926
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd249323zd2_7915));
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_26290;
																																																																										{
																																																																											obj_t
																																																																												BgL_argsz00_26294;
																																																																											obj_t
																																																																												BgL_proc2z00_26293;
																																																																											obj_t
																																																																												BgL_proc1z00_26292;
																																																																											obj_t
																																																																												BgL_testz00_26291;
																																																																											BgL_testz00_26291
																																																																												=
																																																																												BgL_arg6305z00_7926;
																																																																											BgL_proc1z00_26292
																																																																												=
																																																																												BgL_carzd249336zd2_7917;
																																																																											BgL_proc2z00_26293
																																																																												=
																																																																												BgL_carzd249344zd2_7921;
																																																																											BgL_argsz00_26294
																																																																												=
																																																																												BgL_cdrzd249316zd2_7914;
																																																																											BgL_argsz00_1749
																																																																												=
																																																																												BgL_argsz00_26294;
																																																																											BgL_proc2z00_1748
																																																																												=
																																																																												BgL_proc2z00_26293;
																																																																											BgL_proc1z00_1747
																																																																												=
																																																																												BgL_proc1z00_26292;
																																																																											BgL_testz00_1746
																																																																												=
																																																																												BgL_testz00_26291;
																																																																											goto
																																																																												BgL_tagzd2388zd2_1750;
																																																																										}
																																																																										BgL_auxz00_22040
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_26290);
																																																																									}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1774;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_26298;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1775;
																																																																											BgL_auxz00_22040
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_26298);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1774;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_26302;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1775;
																																																																									BgL_auxz00_22040
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_26302);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1774;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_26306;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1775;
																																																																							BgL_auxz00_22040
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_26306);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1774;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_26310;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1775;
																																																																					BgL_auxz00_22040
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_26310);
																																																																				}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1774;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_26314;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1775;
																																																																			BgL_auxz00_22040
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_26314);
																																																																		}
																																																																}
																																																														}
																																																													}
																																																												}
																																																											}
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																										{	/* Ast/sexp.scm 118 */
																																																											goto
																																																												BgL_tagzd2403zd2_1774;
																																																										}
																																																									else
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_26318;
																																																											goto
																																																												BgL_tagzd2404zd2_1775;
																																																											BgL_auxz00_22040
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_26318);
																																																										}
																																																								}
																																																						}
																																																					}
																																																			}
																																																		}
																																																}
																																														}
																																													}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 118 */
																																												obj_t
																																													BgL_cdrzd249737zd2_7940;
																																												BgL_cdrzd249737zd2_7940
																																													=
																																													CDR
																																													(
																																													((obj_t) BgL_expz00_21));
																																												{	/* Ast/sexp.scm 118 */
																																													bool_t
																																														BgL_test10019z00_26322;
																																													{	/* Ast/sexp.scm 118 */
																																														obj_t
																																															BgL_arg6333z00_7957;
																																														BgL_arg6333z00_7957
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														BgL_test10019z00_26322
																																															=
																																															CBOOL
																																															(BGl_letzd2symzf3z21zzast_letz00
																																															(BgL_arg6333z00_7957));
																																													}
																																													if (BgL_test10019z00_26322)
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_arg6321z00_7943;
																																															obj_t
																																																BgL_arg6322z00_7944;
																																															BgL_arg6321z00_7943
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd249737zd2_7940));
																																															BgL_arg6322z00_7944
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd249737zd2_7940));
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_26331;
																																																{
																																																	obj_t
																																																		BgL_exprz00_26333;
																																																	obj_t
																																																		BgL_bindingsz00_26332;
																																																	BgL_bindingsz00_26332
																																																		=
																																																		BgL_arg6321z00_7943;
																																																	BgL_exprz00_26333
																																																		=
																																																		BgL_arg6322z00_7944;
																																																	BgL_exprz00_1729
																																																		=
																																																		BgL_exprz00_26333;
																																																	BgL_bindingsz00_1728
																																																		=
																																																		BgL_bindingsz00_26332;
																																																	goto
																																																		BgL_tagzd2382zd2_1730;
																																																}
																																																BgL_auxz00_22040
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_26331);
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 118 */
																																															bool_t
																																																BgL_test10020z00_26335;
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_arg6332z00_7956;
																																																BgL_arg6332z00_7956
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																BgL_test10020z00_26335
																																																	=
																																																	CBOOL
																																																	(BGl_labelszd2symzf3z21zzast_labelsz00
																																																	(BgL_arg6332z00_7956));
																																															}
																																															if (BgL_test10020z00_26335)
																																																{
																																																	BgL_letzd2funzd2_bglt
																																																		BgL_auxz00_26340;
																																																	goto
																																																		BgL_tagzd2384zd2_1732;
																																																	BgL_auxz00_22040
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_26340);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_carzd249803zd2_7947;
																																																	BgL_carzd249803zd2_7947
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_cdrzd249808zd2_7948;
																																																		BgL_cdrzd249808zd2_7948
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_carzd249803zd2_7947));
																																																		if ((CAR(((obj_t) BgL_carzd249803zd2_7947)) == CNST_TABLE_REF(((long) 3))))
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_arg6327z00_7951;
																																																				obj_t
																																																					BgL_arg6328z00_7952;
																																																				obj_t
																																																					BgL_arg6329z00_7953;
																																																				BgL_arg6327z00_7951
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_cdrzd249808zd2_7948));
																																																				BgL_arg6328z00_7952
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_cdrzd249808zd2_7948));
																																																				BgL_arg6329z00_7953
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_26357;
																																																					{
																																																						obj_t
																																																							BgL_argsz00_26360;
																																																						obj_t
																																																							BgL_bodyz00_26359;
																																																						obj_t
																																																							BgL_varsz00_26358;
																																																						BgL_varsz00_26358
																																																							=
																																																							BgL_arg6327z00_7951;
																																																						BgL_bodyz00_26359
																																																							=
																																																							BgL_arg6328z00_7952;
																																																						BgL_argsz00_26360
																																																							=
																																																							BgL_arg6329z00_7953;
																																																						BgL_argsz00_1739
																																																							=
																																																							BgL_argsz00_26360;
																																																						BgL_bodyz00_1738
																																																							=
																																																							BgL_bodyz00_26359;
																																																						BgL_varsz00_1737
																																																							=
																																																							BgL_varsz00_26358;
																																																						goto
																																																							BgL_tagzd2386zd2_1740;
																																																					}
																																																					BgL_auxz00_22040
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_26357);
																																																				}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 118 */
																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																					{	/* Ast/sexp.scm 118 */
																																																						goto
																																																							BgL_tagzd2403zd2_1774;
																																																					}
																																																				else
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_26364;
																																																						goto
																																																							BgL_tagzd2404zd2_1775;
																																																						BgL_auxz00_22040
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_26364);
																																																					}
																																																			}
																																																	}
																																																}
																																														}
																																												}
																																											}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 118 */
																																										obj_t
																																											BgL_cdrzd249919zd2_7958;
																																										BgL_cdrzd249919zd2_7958
																																											=
																																											CDR
																																											(
																																											((obj_t) BgL_expz00_21));
																																										{	/* Ast/sexp.scm 118 */
																																											bool_t
																																												BgL_test10023z00_26368;
																																											{	/* Ast/sexp.scm 118 */
																																												obj_t
																																													BgL_arg6342z00_7967;
																																												BgL_arg6342z00_7967
																																													=
																																													CAR
																																													(
																																													((obj_t) BgL_expz00_21));
																																												BgL_test10023z00_26368
																																													=
																																													CBOOL
																																													(BGl_letzd2symzf3z21zzast_letz00
																																													(BgL_arg6342z00_7967));
																																											}
																																											if (BgL_test10023z00_26368)
																																												{	/* Ast/sexp.scm 118 */
																																													obj_t
																																														BgL_arg6336z00_7961;
																																													obj_t
																																														BgL_arg6337z00_7962;
																																													BgL_arg6336z00_7961
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_cdrzd249919zd2_7958));
																																													BgL_arg6337z00_7962
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_cdrzd249919zd2_7958));
																																													{
																																														BgL_nodez00_bglt
																																															BgL_auxz00_26377;
																																														{
																																															obj_t
																																																BgL_exprz00_26379;
																																															obj_t
																																																BgL_bindingsz00_26378;
																																															BgL_bindingsz00_26378
																																																=
																																																BgL_arg6336z00_7961;
																																															BgL_exprz00_26379
																																																=
																																																BgL_arg6337z00_7962;
																																															BgL_exprz00_1729
																																																=
																																																BgL_exprz00_26379;
																																															BgL_bindingsz00_1728
																																																=
																																																BgL_bindingsz00_26378;
																																															goto
																																																BgL_tagzd2382zd2_1730;
																																														}
																																														BgL_auxz00_22040
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_26377);
																																													}
																																												}
																																											else
																																												{	/* Ast/sexp.scm 118 */
																																													bool_t
																																														BgL_test10024z00_26381;
																																													{	/* Ast/sexp.scm 118 */
																																														obj_t
																																															BgL_arg6341z00_7966;
																																														BgL_arg6341z00_7966
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														BgL_test10024z00_26381
																																															=
																																															CBOOL
																																															(BGl_labelszd2symzf3z21zzast_labelsz00
																																															(BgL_arg6341z00_7966));
																																													}
																																													if (BgL_test10024z00_26381)
																																														{
																																															BgL_letzd2funzd2_bglt
																																																BgL_auxz00_26386;
																																															goto
																																																BgL_tagzd2384zd2_1732;
																																															BgL_auxz00_22040
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_26386);
																																														}
																																													else
																																														{	/* Ast/sexp.scm 118 */
																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																{	/* Ast/sexp.scm 118 */
																																																	goto
																																																		BgL_tagzd2403zd2_1774;
																																																}
																																															else
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_26390;
																																																	goto
																																																		BgL_tagzd2404zd2_1775;
																																																	BgL_auxz00_22040
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_26390);
																																																}
																																														}
																																												}
																																										}
																																									}
																																							}
																																						else
																																							{	/* Ast/sexp.scm 118 */
																																								if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd248484zd2_7637)))
																																									{	/* Ast/sexp.scm 118 */
																																										goto
																																											BgL_kapzd248486zd2_7639;
																																									}
																																								else
																																									{	/* Ast/sexp.scm 118 */
																																										if ((BgL_carzd248484zd2_7637 == CNST_TABLE_REF(((long) 18))))
																																											{	/* Ast/sexp.scm 118 */
																																												goto
																																													BgL_kapzd248486zd2_7639;
																																											}
																																										else
																																											{	/* Ast/sexp.scm 118 */
																																												if ((BgL_carzd248484zd2_7637 == CNST_TABLE_REF(((long) 19))))
																																													{	/* Ast/sexp.scm 118 */
																																														goto
																																															BgL_kapzd248486zd2_7639;
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd248484zd2_7637)))
																																															{	/* Ast/sexp.scm 118 */
																																																goto
																																																	BgL_kapzd248486zd2_7639;
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_cdrzd250091zd2_7645;
																																																BgL_cdrzd250091zd2_7645
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 118 */
																																																	bool_t
																																																		BgL_test10030z00_26406;
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_arg6242z00_7819;
																																																		BgL_arg6242z00_7819
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_test10030z00_26406
																																																			=
																																																			CBOOL
																																																			(BGl_letzd2symzf3z21zzast_letz00
																																																			(BgL_arg6242z00_7819));
																																																	}
																																																	if (BgL_test10030z00_26406)
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_arg6126z00_7648;
																																																			obj_t
																																																				BgL_arg6127z00_7649;
																																																			BgL_arg6126z00_7648
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd250091zd2_7645));
																																																			BgL_arg6127z00_7649
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd250091zd2_7645));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_26415;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_26417;
																																																					obj_t
																																																						BgL_bindingsz00_26416;
																																																					BgL_bindingsz00_26416
																																																						=
																																																						BgL_arg6126z00_7648;
																																																					BgL_exprz00_26417
																																																						=
																																																						BgL_arg6127z00_7649;
																																																					BgL_exprz00_1729
																																																						=
																																																						BgL_exprz00_26417;
																																																					BgL_bindingsz00_1728
																																																						=
																																																						BgL_bindingsz00_26416;
																																																					goto
																																																						BgL_tagzd2382zd2_1730;
																																																				}
																																																				BgL_auxz00_22040
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_26415);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			bool_t
																																																				BgL_test10031z00_26419;
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_arg6241z00_7818;
																																																				BgL_arg6241z00_7818
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test10031z00_26419
																																																					=
																																																					CBOOL
																																																					(BGl_labelszd2symzf3z21zzast_labelsz00
																																																					(BgL_arg6241z00_7818));
																																																			}
																																																			if (BgL_test10031z00_26419)
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_26424;
																																																					goto
																																																						BgL_tagzd2384zd2_1732;
																																																					BgL_auxz00_22040
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_26424);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_carzd250144zd2_7652;
																																																					obj_t
																																																						BgL_cdrzd250145zd2_7653;
																																																					BgL_carzd250144zd2_7652
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					BgL_cdrzd250145zd2_7653
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_cdrzd250149zd2_7654;
																																																						BgL_cdrzd250149zd2_7654
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_carzd250144zd2_7652));
																																																						if ((CAR(((obj_t) BgL_carzd250144zd2_7652)) == CNST_TABLE_REF(((long) 3))))
																																																							{	/* Ast/sexp.scm 118 */
																																																								if (PAIRP(BgL_cdrzd250149zd2_7654))
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_carzd250152zd2_7658;
																																																										obj_t
																																																											BgL_cdrzd250153zd2_7659;
																																																										BgL_carzd250152zd2_7658
																																																											=
																																																											CAR
																																																											(BgL_cdrzd250149zd2_7654);
																																																										BgL_cdrzd250153zd2_7659
																																																											=
																																																											CDR
																																																											(BgL_cdrzd250149zd2_7654);
																																																										if (PAIRP(BgL_carzd250152zd2_7658))
																																																											{	/* Ast/sexp.scm 118 */
																																																												if (NULLP(CDR(BgL_carzd250152zd2_7658)))
																																																													{	/* Ast/sexp.scm 118 */
																																																														if (PAIRP(BgL_cdrzd250153zd2_7659))
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_carzd250159zd2_7664;
																																																																BgL_carzd250159zd2_7664
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd250153zd2_7659);
																																																																if (PAIRP(BgL_carzd250159zd2_7664))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (BGl_castzd2sexpzf3z21zzast_privatez00(BgL_carzd250159zd2_7664))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (NULLP(CDR(BgL_cdrzd250153zd2_7659)))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_carzd250166zd2_7669;
																																																																						BgL_carzd250166zd2_7669
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd250145zd2_7653));
																																																																						if (PAIRP(BgL_carzd250166zd2_7669))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_cdrzd250191zd2_7671;
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_pairz00_12832;
																																																																									BgL_pairz00_12832
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									BgL_cdrzd250191zd2_7671
																																																																										=
																																																																										CDR
																																																																										(BgL_pairz00_12832);
																																																																								}
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_arg6142z00_7672;
																																																																									obj_t
																																																																										BgL_arg6143z00_7673;
																																																																									obj_t
																																																																										BgL_arg6144z00_7674;
																																																																									BgL_arg6142z00_7672
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd250191zd2_7671));
																																																																									BgL_arg6143z00_7673
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd250191zd2_7671));
																																																																									BgL_arg6144z00_7674
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_26469;
																																																																										{
																																																																											obj_t
																																																																												BgL_argsz00_26472;
																																																																											obj_t
																																																																												BgL_bodyz00_26471;
																																																																											obj_t
																																																																												BgL_varsz00_26470;
																																																																											BgL_varsz00_26470
																																																																												=
																																																																												BgL_arg6142z00_7672;
																																																																											BgL_bodyz00_26471
																																																																												=
																																																																												BgL_arg6143z00_7673;
																																																																											BgL_argsz00_26472
																																																																												=
																																																																												BgL_arg6144z00_7674;
																																																																											BgL_argsz00_1739
																																																																												=
																																																																												BgL_argsz00_26472;
																																																																											BgL_bodyz00_1738
																																																																												=
																																																																												BgL_bodyz00_26471;
																																																																											BgL_varsz00_1737
																																																																												=
																																																																												BgL_varsz00_26470;
																																																																											goto
																																																																												BgL_tagzd2386zd2_1740;
																																																																										}
																																																																										BgL_auxz00_22040
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_26469);
																																																																									}
																																																																								}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (NULLP(CDR(((obj_t) BgL_cdrzd250145zd2_7653))))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_arg6148z00_7678;
																																																																										BgL_arg6148z00_7678
																																																																											=
																																																																											CAR
																																																																											(BgL_carzd250152zd2_7658);
																																																																										{
																																																																											BgL_castz00_bglt
																																																																												BgL_auxz00_26479;
																																																																											{
																																																																												obj_t
																																																																													BgL_argz00_26482;
																																																																												obj_t
																																																																													BgL_bodyz00_26481;
																																																																												obj_t
																																																																													BgL_varz00_26480;
																																																																												BgL_varz00_26480
																																																																													=
																																																																													BgL_arg6148z00_7678;
																																																																												BgL_bodyz00_26481
																																																																													=
																																																																													BgL_carzd250159zd2_7664;
																																																																												BgL_argz00_26482
																																																																													=
																																																																													BgL_carzd250166zd2_7669;
																																																																												BgL_argz00_1735
																																																																													=
																																																																													BgL_argz00_26482;
																																																																												BgL_bodyz00_1734
																																																																													=
																																																																													BgL_bodyz00_26481;
																																																																												BgL_varz00_1733
																																																																													=
																																																																													BgL_varz00_26480;
																																																																												goto
																																																																													BgL_tagzd2385zd2_1736;
																																																																											}
																																																																											BgL_auxz00_22040
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_26479);
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_cdrzd250219zd2_7679;
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_pairz00_12840;
																																																																											BgL_pairz00_12840
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											BgL_cdrzd250219zd2_7679
																																																																												=
																																																																												CDR
																																																																												(BgL_pairz00_12840);
																																																																										}
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_arg6149z00_7680;
																																																																											obj_t
																																																																												BgL_arg6150z00_7681;
																																																																											obj_t
																																																																												BgL_arg6151z00_7682;
																																																																											BgL_arg6149z00_7680
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd250219zd2_7679));
																																																																											BgL_arg6150z00_7681
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd250219zd2_7679));
																																																																											BgL_arg6151z00_7682
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_26493;
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_26496;
																																																																													obj_t
																																																																														BgL_bodyz00_26495;
																																																																													obj_t
																																																																														BgL_varsz00_26494;
																																																																													BgL_varsz00_26494
																																																																														=
																																																																														BgL_arg6149z00_7680;
																																																																													BgL_bodyz00_26495
																																																																														=
																																																																														BgL_arg6150z00_7681;
																																																																													BgL_argsz00_26496
																																																																														=
																																																																														BgL_arg6151z00_7682;
																																																																													BgL_argsz00_1739
																																																																														=
																																																																														BgL_argsz00_26496;
																																																																													BgL_bodyz00_1738
																																																																														=
																																																																														BgL_bodyz00_26495;
																																																																													BgL_varsz00_1737
																																																																														=
																																																																														BgL_varsz00_26494;
																																																																													goto
																																																																														BgL_tagzd2386zd2_1740;
																																																																												}
																																																																												BgL_auxz00_22040
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_26493);
																																																																											}
																																																																										}
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_cdrzd250245zd2_7685;
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_pairz00_12845;
																																																																							BgL_pairz00_12845
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							BgL_cdrzd250245zd2_7685
																																																																								=
																																																																								CDR
																																																																								(BgL_pairz00_12845);
																																																																						}
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_arg6154z00_7686;
																																																																							obj_t
																																																																								BgL_arg6155z00_7687;
																																																																							obj_t
																																																																								BgL_arg6156z00_7688;
																																																																							BgL_arg6154z00_7686
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd250245zd2_7685));
																																																																							BgL_arg6155z00_7687
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd250245zd2_7685));
																																																																							BgL_arg6156z00_7688
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_26507;
																																																																								{
																																																																									obj_t
																																																																										BgL_argsz00_26510;
																																																																									obj_t
																																																																										BgL_bodyz00_26509;
																																																																									obj_t
																																																																										BgL_varsz00_26508;
																																																																									BgL_varsz00_26508
																																																																										=
																																																																										BgL_arg6154z00_7686;
																																																																									BgL_bodyz00_26509
																																																																										=
																																																																										BgL_arg6155z00_7687;
																																																																									BgL_argsz00_26510
																																																																										=
																																																																										BgL_arg6156z00_7688;
																																																																									BgL_argsz00_1739
																																																																										=
																																																																										BgL_argsz00_26510;
																																																																									BgL_bodyz00_1738
																																																																										=
																																																																										BgL_bodyz00_26509;
																																																																									BgL_varsz00_1737
																																																																										=
																																																																										BgL_varsz00_26508;
																																																																									goto
																																																																										BgL_tagzd2386zd2_1740;
																																																																								}
																																																																								BgL_auxz00_22040
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_26507);
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_cdrzd250271zd2_7691;
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_pairz00_12850;
																																																																					BgL_pairz00_12850
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_expz00_21));
																																																																					BgL_cdrzd250271zd2_7691
																																																																						=
																																																																						CDR
																																																																						(BgL_pairz00_12850);
																																																																				}
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_arg6159z00_7692;
																																																																					obj_t
																																																																						BgL_arg6160z00_7693;
																																																																					obj_t
																																																																						BgL_arg6161z00_7694;
																																																																					BgL_arg6159z00_7692
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd250271zd2_7691));
																																																																					BgL_arg6160z00_7693
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd250271zd2_7691));
																																																																					BgL_arg6161z00_7694
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_expz00_21));
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_26521;
																																																																						{
																																																																							obj_t
																																																																								BgL_argsz00_26524;
																																																																							obj_t
																																																																								BgL_bodyz00_26523;
																																																																							obj_t
																																																																								BgL_varsz00_26522;
																																																																							BgL_varsz00_26522
																																																																								=
																																																																								BgL_arg6159z00_7692;
																																																																							BgL_bodyz00_26523
																																																																								=
																																																																								BgL_arg6160z00_7693;
																																																																							BgL_argsz00_26524
																																																																								=
																																																																								BgL_arg6161z00_7694;
																																																																							BgL_argsz00_1739
																																																																								=
																																																																								BgL_argsz00_26524;
																																																																							BgL_bodyz00_1738
																																																																								=
																																																																								BgL_bodyz00_26523;
																																																																							BgL_varsz00_1737
																																																																								=
																																																																								BgL_varsz00_26522;
																																																																							goto
																																																																								BgL_tagzd2386zd2_1740;
																																																																						}
																																																																						BgL_auxz00_22040
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_26521);
																																																																					}
																																																																				}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_cdrzd250297zd2_7696;
																																																																		BgL_cdrzd250297zd2_7696
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_carzd250144zd2_7652));
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_arg6163z00_7697;
																																																																			obj_t
																																																																				BgL_arg6164z00_7698;
																																																																			obj_t
																																																																				BgL_arg6165z00_7699;
																																																																			BgL_arg6163z00_7697
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd250297zd2_7696));
																																																																			BgL_arg6164z00_7698
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd250297zd2_7696));
																																																																			BgL_arg6165z00_7699
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_expz00_21));
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_26534;
																																																																				{
																																																																					obj_t
																																																																						BgL_argsz00_26537;
																																																																					obj_t
																																																																						BgL_bodyz00_26536;
																																																																					obj_t
																																																																						BgL_varsz00_26535;
																																																																					BgL_varsz00_26535
																																																																						=
																																																																						BgL_arg6163z00_7697;
																																																																					BgL_bodyz00_26536
																																																																						=
																																																																						BgL_arg6164z00_7698;
																																																																					BgL_argsz00_26537
																																																																						=
																																																																						BgL_arg6165z00_7699;
																																																																					BgL_argsz00_1739
																																																																						=
																																																																						BgL_argsz00_26537;
																																																																					BgL_bodyz00_1738
																																																																						=
																																																																						BgL_bodyz00_26536;
																																																																					BgL_varsz00_1737
																																																																						=
																																																																						BgL_varsz00_26535;
																																																																					goto
																																																																						BgL_tagzd2386zd2_1740;
																																																																				}
																																																																				BgL_auxz00_22040
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_26534);
																																																																			}
																																																																		}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_cdrzd250323zd2_7701;
																																																																BgL_cdrzd250323zd2_7701
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_carzd250144zd2_7652));
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_arg6167z00_7702;
																																																																	obj_t
																																																																		BgL_arg6168z00_7703;
																																																																	obj_t
																																																																		BgL_arg6169z00_7704;
																																																																	BgL_arg6167z00_7702
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd250323zd2_7701));
																																																																	BgL_arg6168z00_7703
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd250323zd2_7701));
																																																																	BgL_arg6169z00_7704
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_expz00_21));
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_26547;
																																																																		{
																																																																			obj_t
																																																																				BgL_argsz00_26550;
																																																																			obj_t
																																																																				BgL_bodyz00_26549;
																																																																			obj_t
																																																																				BgL_varsz00_26548;
																																																																			BgL_varsz00_26548
																																																																				=
																																																																				BgL_arg6167z00_7702;
																																																																			BgL_bodyz00_26549
																																																																				=
																																																																				BgL_arg6168z00_7703;
																																																																			BgL_argsz00_26550
																																																																				=
																																																																				BgL_arg6169z00_7704;
																																																																			BgL_argsz00_1739
																																																																				=
																																																																				BgL_argsz00_26550;
																																																																			BgL_bodyz00_1738
																																																																				=
																																																																				BgL_bodyz00_26549;
																																																																			BgL_varsz00_1737
																																																																				=
																																																																				BgL_varsz00_26548;
																																																																			goto
																																																																				BgL_tagzd2386zd2_1740;
																																																																		}
																																																																		BgL_auxz00_22040
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_26547);
																																																																	}
																																																																}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_cdrzd250349zd2_7706;
																																																														BgL_cdrzd250349zd2_7706
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_carzd250144zd2_7652));
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_arg6171z00_7707;
																																																															obj_t
																																																																BgL_arg6172z00_7708;
																																																															obj_t
																																																																BgL_arg6173z00_7709;
																																																															BgL_arg6171z00_7707
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_cdrzd250349zd2_7706));
																																																															BgL_arg6172z00_7708
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd250349zd2_7706));
																																																															BgL_arg6173z00_7709
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_26560;
																																																																{
																																																																	obj_t
																																																																		BgL_argsz00_26563;
																																																																	obj_t
																																																																		BgL_bodyz00_26562;
																																																																	obj_t
																																																																		BgL_varsz00_26561;
																																																																	BgL_varsz00_26561
																																																																		=
																																																																		BgL_arg6171z00_7707;
																																																																	BgL_bodyz00_26562
																																																																		=
																																																																		BgL_arg6172z00_7708;
																																																																	BgL_argsz00_26563
																																																																		=
																																																																		BgL_arg6173z00_7709;
																																																																	BgL_argsz00_1739
																																																																		=
																																																																		BgL_argsz00_26563;
																																																																	BgL_bodyz00_1738
																																																																		=
																																																																		BgL_bodyz00_26562;
																																																																	BgL_varsz00_1737
																																																																		=
																																																																		BgL_varsz00_26561;
																																																																	goto
																																																																		BgL_tagzd2386zd2_1740;
																																																																}
																																																																BgL_auxz00_22040
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_26560);
																																																															}
																																																														}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_cdrzd250375zd2_7712;
																																																												BgL_cdrzd250375zd2_7712
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_carzd250144zd2_7652));
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_arg6176z00_7713;
																																																													obj_t
																																																														BgL_arg6177z00_7714;
																																																													obj_t
																																																														BgL_arg6178z00_7715;
																																																													BgL_arg6176z00_7713
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_cdrzd250375zd2_7712));
																																																													BgL_arg6177z00_7714
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd250375zd2_7712));
																																																													BgL_arg6178z00_7715
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_26573;
																																																														{
																																																															obj_t
																																																																BgL_argsz00_26576;
																																																															obj_t
																																																																BgL_bodyz00_26575;
																																																															obj_t
																																																																BgL_varsz00_26574;
																																																															BgL_varsz00_26574
																																																																=
																																																																BgL_arg6176z00_7713;
																																																															BgL_bodyz00_26575
																																																																=
																																																																BgL_arg6177z00_7714;
																																																															BgL_argsz00_26576
																																																																=
																																																																BgL_arg6178z00_7715;
																																																															BgL_argsz00_1739
																																																																=
																																																																BgL_argsz00_26576;
																																																															BgL_bodyz00_1738
																																																																=
																																																																BgL_bodyz00_26575;
																																																															BgL_varsz00_1737
																																																																=
																																																																BgL_varsz00_26574;
																																																															goto
																																																																BgL_tagzd2386zd2_1740;
																																																														}
																																																														BgL_auxz00_22040
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_26573);
																																																													}
																																																												}
																																																											}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 118 */
																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																											{	/* Ast/sexp.scm 118 */
																																																												goto
																																																													BgL_tagzd2403zd2_1774;
																																																											}
																																																										else
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_26580;
																																																												goto
																																																													BgL_tagzd2404zd2_1775;
																																																												BgL_auxz00_22040
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_26580);
																																																											}
																																																									}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_cdrzd250513zd2_7720;
																																																								BgL_cdrzd250513zd2_7720
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_carzd250144zd2_7652));
																																																								if ((CAR(((obj_t) BgL_carzd250144zd2_7652)) == CNST_TABLE_REF(((long) 1))))
																																																									{	/* Ast/sexp.scm 118 */
																																																										if (PAIRP(BgL_cdrzd250513zd2_7720))
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_cdrzd250518zd2_7724;
																																																												BgL_cdrzd250518zd2_7724
																																																													=
																																																													CDR
																																																													(BgL_cdrzd250513zd2_7720);
																																																												if (PAIRP(BgL_cdrzd250518zd2_7724))
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_carzd250522zd2_7726;
																																																														obj_t
																																																															BgL_cdrzd250523zd2_7727;
																																																														BgL_carzd250522zd2_7726
																																																															=
																																																															CAR
																																																															(BgL_cdrzd250518zd2_7724);
																																																														BgL_cdrzd250523zd2_7727
																																																															=
																																																															CDR
																																																															(BgL_cdrzd250518zd2_7724);
																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd250522zd2_7726))
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (PAIRP(BgL_cdrzd250523zd2_7727))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_carzd250528zd2_7730;
																																																																		BgL_carzd250528zd2_7730
																																																																			=
																																																																			CAR
																																																																			(BgL_cdrzd250523zd2_7727);
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd250528zd2_7730))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (NULLP(CDR(BgL_cdrzd250523zd2_7727)))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						bool_t
																																																																							BgL_test10050z00_26606;
																																																																						{
																																																																							obj_t
																																																																								BgL_l1451z00_7763;
																																																																							BgL_l1451z00_7763
																																																																								=
																																																																								BgL_cdrzd250145zd2_7653;
																																																																						BgL_zc3z04anonymousza36205ze3z87_7764:
																																																																							if (NULLP(BgL_l1451z00_7763))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									BgL_test10050z00_26606
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										1);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									bool_t
																																																																										BgL_test10052z00_26609;
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										bool_t
																																																																											BgL_test10053z00_26610;
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_tmpz00_26611;
																																																																											BgL_tmpz00_26611
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_l1451z00_7763));
																																																																											BgL_test10053z00_26610
																																																																												=
																																																																												PAIRP
																																																																												(BgL_tmpz00_26611);
																																																																										}
																																																																										if (BgL_test10053z00_26610)
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												BgL_test10052z00_26609
																																																																													=
																																																																													(
																																																																													(bool_t)
																																																																													0);
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												BgL_test10052z00_26609
																																																																													=
																																																																													(
																																																																													(bool_t)
																																																																													1);
																																																																											}
																																																																									}
																																																																									if (BgL_test10052z00_26609)
																																																																										{
																																																																											obj_t
																																																																												BgL_l1451z00_26615;
																																																																											BgL_l1451z00_26615
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_l1451z00_7763));
																																																																											BgL_l1451z00_7763
																																																																												=
																																																																												BgL_l1451z00_26615;
																																																																											goto
																																																																												BgL_zc3z04anonymousza36205ze3z87_7764;
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											BgL_test10050z00_26606
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												0);
																																																																										}
																																																																								}
																																																																						}
																																																																						if (BgL_test10050z00_26606)
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_arg6195z00_7746;
																																																																								BgL_arg6195z00_7746
																																																																									=
																																																																									CAR
																																																																									(BgL_cdrzd250513zd2_7720);
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_26619;
																																																																									{
																																																																										obj_t
																																																																											BgL_argsz00_26623;
																																																																										obj_t
																																																																											BgL_proc2z00_26622;
																																																																										obj_t
																																																																											BgL_proc1z00_26621;
																																																																										obj_t
																																																																											BgL_testz00_26620;
																																																																										BgL_testz00_26620
																																																																											=
																																																																											BgL_arg6195z00_7746;
																																																																										BgL_proc1z00_26621
																																																																											=
																																																																											BgL_carzd250522zd2_7726;
																																																																										BgL_proc2z00_26622
																																																																											=
																																																																											BgL_carzd250528zd2_7730;
																																																																										BgL_argsz00_26623
																																																																											=
																																																																											BgL_cdrzd250145zd2_7653;
																																																																										BgL_argsz00_1744
																																																																											=
																																																																											BgL_argsz00_26623;
																																																																										BgL_proc2z00_1743
																																																																											=
																																																																											BgL_proc2z00_26622;
																																																																										BgL_proc1z00_1742
																																																																											=
																																																																											BgL_proc1z00_26621;
																																																																										BgL_testz00_1741
																																																																											=
																																																																											BgL_testz00_26620;
																																																																										goto
																																																																											BgL_tagzd2387zd2_1745;
																																																																									}
																																																																									BgL_auxz00_22040
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_26619);
																																																																								}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_cdrzd250553zd2_7747;
																																																																								BgL_cdrzd250553zd2_7747
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_cdrzd250561zd2_7748;
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_pairz00_12894;
																																																																										BgL_pairz00_12894
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										BgL_cdrzd250561zd2_7748
																																																																											=
																																																																											CDR
																																																																											(BgL_pairz00_12894);
																																																																									}
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_cdrzd250569zd2_7749;
																																																																										BgL_cdrzd250569zd2_7749
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd250561zd2_7748));
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_carzd250576zd2_7750;
																																																																											BgL_carzd250576zd2_7750
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd250569zd2_7749));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd250576zd2_7750))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_carzd250585zd2_7752;
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_pairz00_12898;
																																																																														BgL_pairz00_12898
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd250569zd2_7749));
																																																																														BgL_carzd250585zd2_7752
																																																																															=
																																																																															CAR
																																																																															(BgL_pairz00_12898);
																																																																													}
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd250585zd2_7752))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd250553zd2_7747))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_arg6199z00_7755;
																																																																																	BgL_arg6199z00_7755
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd250561zd2_7748));
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_26645;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_26649;
																																																																																			obj_t
																																																																																				BgL_proc2z00_26648;
																																																																																			obj_t
																																																																																				BgL_proc1z00_26647;
																																																																																			obj_t
																																																																																				BgL_testz00_26646;
																																																																																			BgL_testz00_26646
																																																																																				=
																																																																																				BgL_arg6199z00_7755;
																																																																																			BgL_proc1z00_26647
																																																																																				=
																																																																																				BgL_carzd250576zd2_7750;
																																																																																			BgL_proc2z00_26648
																																																																																				=
																																																																																				BgL_carzd250585zd2_7752;
																																																																																			BgL_argsz00_26649
																																																																																				=
																																																																																				BgL_cdrzd250553zd2_7747;
																																																																																			BgL_argsz00_1749
																																																																																				=
																																																																																				BgL_argsz00_26649;
																																																																																			BgL_proc2z00_1748
																																																																																				=
																																																																																				BgL_proc2z00_26648;
																																																																																			BgL_proc1z00_1747
																																																																																				=
																																																																																				BgL_proc1z00_26647;
																																																																																			BgL_testz00_1746
																																																																																				=
																																																																																				BgL_testz00_26646;
																																																																																			goto
																																																																																				BgL_tagzd2388zd2_1750;
																																																																																		}
																																																																																		BgL_auxz00_22040
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_26645);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1774;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_26653;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1775;
																																																																																			BgL_auxz00_22040
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_26653);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1774;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_26657;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1775;
																																																																																	BgL_auxz00_22040
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_26657);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1774;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_26661;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1775;
																																																																															BgL_auxz00_22040
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_26661);
																																																																														}
																																																																												}
																																																																										}
																																																																									}
																																																																								}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1774;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_26665;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1775;
																																																																								BgL_auxz00_22040
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_26665);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_cdrzd250863zd2_7774;
																																																																				BgL_cdrzd250863zd2_7774
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_cdrzd250870zd2_7775;
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_pairz00_12902;
																																																																						BgL_pairz00_12902
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						BgL_cdrzd250870zd2_7775
																																																																							=
																																																																							CDR
																																																																							(BgL_pairz00_12902);
																																																																					}
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_cdrzd250877zd2_7776;
																																																																						BgL_cdrzd250877zd2_7776
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd250870zd2_7775));
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_carzd250883zd2_7777;
																																																																							obj_t
																																																																								BgL_cdrzd250884zd2_7778;
																																																																							BgL_carzd250883zd2_7777
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd250877zd2_7776));
																																																																							BgL_cdrzd250884zd2_7778
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd250877zd2_7776));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd250883zd2_7777))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_carzd250891zd2_7780;
																																																																									BgL_carzd250891zd2_7780
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd250884zd2_7778));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd250891zd2_7780))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (NULLP(CDR(((obj_t) BgL_cdrzd250884zd2_7778))))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd250863zd2_7774))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_arg6214z00_7785;
																																																																															BgL_arg6214z00_7785
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd250870zd2_7775));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_26692;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_26696;
																																																																																	obj_t
																																																																																		BgL_proc2z00_26695;
																																																																																	obj_t
																																																																																		BgL_proc1z00_26694;
																																																																																	obj_t
																																																																																		BgL_testz00_26693;
																																																																																	BgL_testz00_26693
																																																																																		=
																																																																																		BgL_arg6214z00_7785;
																																																																																	BgL_proc1z00_26694
																																																																																		=
																																																																																		BgL_carzd250883zd2_7777;
																																																																																	BgL_proc2z00_26695
																																																																																		=
																																																																																		BgL_carzd250891zd2_7780;
																																																																																	BgL_argsz00_26696
																																																																																		=
																																																																																		BgL_cdrzd250863zd2_7774;
																																																																																	BgL_argsz00_1749
																																																																																		=
																																																																																		BgL_argsz00_26696;
																																																																																	BgL_proc2z00_1748
																																																																																		=
																																																																																		BgL_proc2z00_26695;
																																																																																	BgL_proc1z00_1747
																																																																																		=
																																																																																		BgL_proc1z00_26694;
																																																																																	BgL_testz00_1746
																																																																																		=
																																																																																		BgL_testz00_26693;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1750;
																																																																																}
																																																																																BgL_auxz00_22040
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_26692);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1774;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_26700;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1775;
																																																																																	BgL_auxz00_22040
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_26700);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1774;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_26704;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1775;
																																																																															BgL_auxz00_22040
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_26704);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1774;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_26708;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1775;
																																																																													BgL_auxz00_22040
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_26708);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1774;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_26712;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1775;
																																																																											BgL_auxz00_22040
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_26712);
																																																																										}
																																																																								}
																																																																						}
																																																																					}
																																																																				}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1774;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_26716;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1775;
																																																																				BgL_auxz00_22040
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_26716);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_cdrzd251224zd2_7793;
																																																																BgL_cdrzd251224zd2_7793
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd251230zd2_7794;
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_pairz00_12912;
																																																																		BgL_pairz00_12912
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		BgL_cdrzd251230zd2_7794
																																																																			=
																																																																			CDR
																																																																			(BgL_pairz00_12912);
																																																																	}
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_cdrzd251236zd2_7795;
																																																																		BgL_cdrzd251236zd2_7795
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd251230zd2_7794));
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_carzd251241zd2_7796;
																																																																			obj_t
																																																																				BgL_cdrzd251242zd2_7797;
																																																																			BgL_carzd251241zd2_7796
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd251236zd2_7795));
																																																																			BgL_cdrzd251242zd2_7797
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd251236zd2_7795));
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd251241zd2_7796))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (PAIRP(BgL_cdrzd251242zd2_7797))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_carzd251247zd2_7800;
																																																																							BgL_carzd251247zd2_7800
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd251242zd2_7797);
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd251247zd2_7800))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (NULLP(CDR(BgL_cdrzd251242zd2_7797)))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd251224zd2_7793))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_arg6228z00_7805;
																																																																													BgL_arg6228z00_7805
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd251230zd2_7794));
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_26743;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_26747;
																																																																															obj_t
																																																																																BgL_proc2z00_26746;
																																																																															obj_t
																																																																																BgL_proc1z00_26745;
																																																																															obj_t
																																																																																BgL_testz00_26744;
																																																																															BgL_testz00_26744
																																																																																=
																																																																																BgL_arg6228z00_7805;
																																																																															BgL_proc1z00_26745
																																																																																=
																																																																																BgL_carzd251241zd2_7796;
																																																																															BgL_proc2z00_26746
																																																																																=
																																																																																BgL_carzd251247zd2_7800;
																																																																															BgL_argsz00_26747
																																																																																=
																																																																																BgL_cdrzd251224zd2_7793;
																																																																															BgL_argsz00_1749
																																																																																=
																																																																																BgL_argsz00_26747;
																																																																															BgL_proc2z00_1748
																																																																																=
																																																																																BgL_proc2z00_26746;
																																																																															BgL_proc1z00_1747
																																																																																=
																																																																																BgL_proc1z00_26745;
																																																																															BgL_testz00_1746
																																																																																=
																																																																																BgL_testz00_26744;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1750;
																																																																														}
																																																																														BgL_auxz00_22040
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_26743);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1774;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_26751;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1775;
																																																																															BgL_auxz00_22040
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_26751);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1774;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_26755;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1775;
																																																																													BgL_auxz00_22040
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_26755);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1774;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_26759;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1775;
																																																																											BgL_auxz00_22040
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_26759);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1774;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_26763;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1775;
																																																																									BgL_auxz00_22040
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_26763);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1774;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_26767;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1775;
																																																																							BgL_auxz00_22040
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_26767);
																																																																						}
																																																																				}
																																																																		}
																																																																	}
																																																																}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 118 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 118 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1774;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_26771;
																																																																goto
																																																																	BgL_tagzd2404zd2_1775;
																																																																BgL_auxz00_22040
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_26771);
																																																															}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 118 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{	/* Ast/sexp.scm 118 */
																																																														goto
																																																															BgL_tagzd2403zd2_1774;
																																																													}
																																																												else
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_26775;
																																																														goto
																																																															BgL_tagzd2404zd2_1775;
																																																														BgL_auxz00_22040
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_26775);
																																																													}
																																																											}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 118 */
																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																											{	/* Ast/sexp.scm 118 */
																																																												goto
																																																													BgL_tagzd2403zd2_1774;
																																																											}
																																																										else
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_26779;
																																																												goto
																																																													BgL_tagzd2404zd2_1775;
																																																												BgL_auxz00_22040
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_26779);
																																																											}
																																																									}
																																																							}
																																																					}
																																																				}
																																																		}
																																																}
																																															}
																																													}
																																											}
																																									}
																																							}
																																					}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 118 */
																																					obj_t
																																						BgL_cdrzd251785zd2_7969;
																																					BgL_cdrzd251785zd2_7969
																																						=
																																						CDR(
																																						((obj_t) BgL_expz00_21));
																																					if (
																																						(BgL_carzd248481zd2_7635
																																							==
																																							CNST_TABLE_REF
																																							(((long) 17))))
																																						{	/* Ast/sexp.scm 118 */
																																							obj_t
																																								BgL_arg6344z00_7971;
																																							obj_t
																																								BgL_arg6345z00_7972;
																																							BgL_arg6344z00_7971
																																								=
																																								CAR
																																								(
																																								((obj_t) BgL_cdrzd251785zd2_7969));
																																							BgL_arg6345z00_7972
																																								=
																																								CDR
																																								(
																																								((obj_t) BgL_cdrzd251785zd2_7969));
																																							{
																																								BgL_nodez00_bglt
																																									BgL_auxz00_26790;
																																								{
																																									obj_t
																																										BgL_exprz00_26792;
																																									obj_t
																																										BgL_bindingsz00_26791;
																																									BgL_bindingsz00_26791
																																										=
																																										BgL_arg6344z00_7971;
																																									BgL_exprz00_26792
																																										=
																																										BgL_arg6345z00_7972;
																																									BgL_exprz00_1729
																																										=
																																										BgL_exprz00_26792;
																																									BgL_bindingsz00_1728
																																										=
																																										BgL_bindingsz00_26791;
																																									goto
																																										BgL_tagzd2382zd2_1730;
																																								}
																																								BgL_auxz00_22040
																																									=
																																									(
																																									(obj_t)
																																									BgL_auxz00_26790);
																																							}
																																						}
																																					else
																																						{	/* Ast/sexp.scm 118 */
																																							if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd248481zd2_7635)))
																																								{	/* Ast/sexp.scm 118 */
																																									obj_t
																																										BgL_arg6347z00_7974;
																																									obj_t
																																										BgL_arg6348z00_7975;
																																									BgL_arg6347z00_7974
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_cdrzd251785zd2_7969));
																																									BgL_arg6348z00_7975
																																										=
																																										CDR
																																										(
																																										((obj_t) BgL_cdrzd251785zd2_7969));
																																									{
																																										BgL_nodez00_bglt
																																											BgL_auxz00_26801;
																																										{
																																											obj_t
																																												BgL_exprz00_26803;
																																											obj_t
																																												BgL_bindingsz00_26802;
																																											BgL_bindingsz00_26802
																																												=
																																												BgL_arg6347z00_7974;
																																											BgL_exprz00_26803
																																												=
																																												BgL_arg6348z00_7975;
																																											BgL_exprz00_1729
																																												=
																																												BgL_exprz00_26803;
																																											BgL_bindingsz00_1728
																																												=
																																												BgL_bindingsz00_26802;
																																											goto
																																												BgL_tagzd2382zd2_1730;
																																										}
																																										BgL_auxz00_22040
																																											=
																																											(
																																											(obj_t)
																																											BgL_auxz00_26801);
																																									}
																																								}
																																							else
																																								{	/* Ast/sexp.scm 118 */
																																									if ((BgL_carzd248481zd2_7635 == CNST_TABLE_REF(((long) 18))))
																																										{	/* Ast/sexp.scm 118 */
																																											obj_t
																																												BgL_arg6350z00_7977;
																																											obj_t
																																												BgL_arg6351z00_7978;
																																											BgL_arg6350z00_7977
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_cdrzd251785zd2_7969));
																																											BgL_arg6351z00_7978
																																												=
																																												CDR
																																												(
																																												((obj_t) BgL_cdrzd251785zd2_7969));
																																											{
																																												BgL_nodez00_bglt
																																													BgL_auxz00_26812;
																																												{
																																													obj_t
																																														BgL_exprz00_26814;
																																													obj_t
																																														BgL_bindingsz00_26813;
																																													BgL_bindingsz00_26813
																																														=
																																														BgL_arg6350z00_7977;
																																													BgL_exprz00_26814
																																														=
																																														BgL_arg6351z00_7978;
																																													BgL_exprz00_1729
																																														=
																																														BgL_exprz00_26814;
																																													BgL_bindingsz00_1728
																																														=
																																														BgL_bindingsz00_26813;
																																													goto
																																														BgL_tagzd2382zd2_1730;
																																												}
																																												BgL_auxz00_22040
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_26812);
																																											}
																																										}
																																									else
																																										{	/* Ast/sexp.scm 118 */
																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_26821;
																																													goto
																																														BgL_tagzd2383zd2_1731;
																																													BgL_auxz00_22040
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_26821);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 118 */
																																													obj_t
																																														BgL_carzd251822zd2_7981;
																																													BgL_carzd251822zd2_7981
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													if ((BgL_carzd251822zd2_7981 == CNST_TABLE_REF(((long) 19))))
																																														{
																																															BgL_letzd2funzd2_bglt
																																																BgL_auxz00_26828;
																																															goto
																																																BgL_tagzd2384zd2_1732;
																																															BgL_auxz00_22040
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_26828);
																																														}
																																													else
																																														{	/* Ast/sexp.scm 118 */
																																															if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd251822zd2_7981)))
																																																{
																																																	BgL_letzd2funzd2_bglt
																																																		BgL_auxz00_26833;
																																																	goto
																																																		BgL_tagzd2384zd2_1732;
																																																	BgL_auxz00_22040
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_26833);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_26840;
																																																			goto
																																																				BgL_tagzd2389zd2_1751;
																																																			BgL_auxz00_22040
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_26840);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_26847;
																																																					goto
																																																						BgL_tagzd2390zd2_1752;
																																																					BgL_auxz00_22040
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_26847);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_cdrzd251902zd2_7988;
																																																					BgL_cdrzd251902zd2_7988
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_arg6362z00_7991;
																																																							obj_t
																																																								BgL_arg6363z00_7992;
																																																							BgL_arg6362z00_7991
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd251902zd2_7988));
																																																							BgL_arg6363z00_7992
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd251902zd2_7988));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_26860;
																																																								{
																																																									obj_t
																																																										BgL_restz00_26862;
																																																									obj_t
																																																										BgL_effectz00_26861;
																																																									BgL_effectz00_26861
																																																										=
																																																										BgL_arg6362z00_7991;
																																																									BgL_restz00_26862
																																																										=
																																																										BgL_arg6363z00_7992;
																																																									BgL_restz00_1754
																																																										=
																																																										BgL_restz00_26862;
																																																									BgL_effectz00_1753
																																																										=
																																																										BgL_effectz00_26861;
																																																									goto
																																																										BgL_tagzd2391zd2_1755;
																																																								}
																																																								BgL_auxz00_22040
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_26860);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_26869;
																																																									goto
																																																										BgL_tagzd2392zd2_1756;
																																																									BgL_auxz00_22040
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_26869);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_26876;
																																																											goto
																																																												BgL_tagzd2393zd2_1757;
																																																											BgL_auxz00_22040
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_26876);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_arg6370z00_8000;
																																																													obj_t
																																																														BgL_arg6371z00_8001;
																																																													BgL_arg6370z00_8000
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_cdrzd251902zd2_7988));
																																																													BgL_arg6371z00_8001
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd251902zd2_7988));
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_26887;
																																																														{
																																																															obj_t
																																																																BgL_restz00_26889;
																																																															obj_t
																																																																BgL_effectz00_26888;
																																																															BgL_effectz00_26888
																																																																=
																																																																BgL_arg6370z00_8000;
																																																															BgL_restz00_26889
																																																																=
																																																																BgL_arg6371z00_8001;
																																																															BgL_restz00_1759
																																																																=
																																																																BgL_restz00_26889;
																																																															BgL_effectz00_1758
																																																																=
																																																																BgL_effectz00_26888;
																																																															goto
																																																																BgL_tagzd2394zd2_1760;
																																																														}
																																																														BgL_auxz00_22040
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_26887);
																																																													}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_26896;
																																																															goto
																																																																BgL_tagzd2395zd2_1761;
																																																															BgL_auxz00_22040
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_26896);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_26903;
																																																																	goto
																																																																		BgL_tagzd2396zd2_1762;
																																																																	BgL_auxz00_22040
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_26903);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																		{
																																																																			BgL_letzd2funzd2_bglt
																																																																				BgL_auxz00_26910;
																																																																			goto
																																																																				BgL_tagzd2397zd2_1763;
																																																																			BgL_auxz00_22040
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_26910);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																				{
																																																																					BgL_jumpzd2exzd2itz00_bglt
																																																																						BgL_auxz00_26917;
																																																																					goto
																																																																						BgL_tagzd2398zd2_1764;
																																																																					BgL_auxz00_22040
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_26917);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_cdrzd251979zd2_8010;
																																																																					BgL_cdrzd251979zd2_8010
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_expz00_21));
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_arg6382z00_8013;
																																																																							obj_t
																																																																								BgL_arg6383z00_8014;
																																																																							BgL_arg6382z00_8013
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd251979zd2_8010));
																																																																							BgL_arg6383z00_8014
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd251979zd2_8010));
																																																																							{	/* Ast/sexp.scm 551 */
																																																																								obj_t
																																																																									BgL_arg6989z00_12951;
																																																																								BgL_arg6989z00_12951
																																																																									=
																																																																									BGl_findzd2locationzf2locz20zztools_locationz00
																																																																									(BgL_expz00_21,
																																																																									BgL_locz00_23);
																																																																								BgL_auxz00_22040
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																									(BgL_expz00_21,
																																																																										BgL_arg6382z00_8013,
																																																																										CNST_TABLE_REF
																																																																										(((long) 4)), BgL_arg6383z00_8014, BgL_stackz00_22, BgL_arg6989z00_12951, BgL_sitez00_24));
																																																																						}}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1774;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_26936;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1775;
																																																																									BgL_auxz00_22040
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_26936);
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																										}
																								}
																							else
																								{	/* Ast/sexp.scm 118 */
																									obj_t BgL_carzd252004zd2_8030;

																									BgL_carzd252004zd2_8030 =
																										CAR(
																										((obj_t) BgL_expz00_21));
																									if (
																										(BgL_carzd252004zd2_8030 ==
																											CNST_TABLE_REF(((long)
																													1))))
																										{
																											BgL_nodez00_bglt
																												BgL_auxz00_26943;
																											goto
																												BgL_tagzd2377zd2_1719;
																											BgL_auxz00_22040 =
																												((obj_t)
																												BgL_auxz00_26943);
																										}
																									else
																										{	/* Ast/sexp.scm 118 */
																											if (
																												(BgL_carzd252004zd2_8030
																													==
																													BGl_za2ifza2z00zzast_sexpz00))
																												{
																													BgL_nodez00_bglt
																														BgL_auxz00_26947;
																													goto
																														BgL_tagzd2377zd2_1719;
																													BgL_auxz00_22040 =
																														((obj_t)
																														BgL_auxz00_26947);
																												}
																											else
																												{	/* Ast/sexp.scm 118 */
																													if (
																														(CAR(
																																((obj_t)
																																	BgL_expz00_21))
																															==
																															CNST_TABLE_REF((
																																	(long) 7))))
																														{
																															BgL_nodez00_bglt
																																BgL_auxz00_26954;
																															goto
																																BgL_tagzd2379zd2_1723;
																															BgL_auxz00_22040 =
																																((obj_t)
																																BgL_auxz00_26954);
																														}
																													else
																														{	/* Ast/sexp.scm 118 */
																															if (
																																(CAR(
																																		((obj_t)
																																			BgL_expz00_21))
																																	==
																																	CNST_TABLE_REF
																																	(((long)
																																			16))))
																																{
																																	BgL_nodez00_bglt
																																		BgL_auxz00_26961;
																																	goto
																																		BgL_tagzd2380zd2_1724;
																																	BgL_auxz00_22040
																																		=
																																		((obj_t)
																																		BgL_auxz00_26961);
																																}
																															else
																																{	/* Ast/sexp.scm 118 */
																																	obj_t
																																		BgL_carzd252073zd2_8037;
																																	BgL_carzd252073zd2_8037
																																		=
																																		CAR(((obj_t)
																																			BgL_expz00_21));
																																	if (PAIRP
																																		(BgL_carzd252073zd2_8037))
																																		{	/* Ast/sexp.scm 118 */
																																			obj_t
																																				BgL_carzd252076zd2_8039;
																																			obj_t
																																				BgL_cdrzd252077zd2_8040;
																																			BgL_carzd252076zd2_8039
																																				=
																																				CAR
																																				(BgL_carzd252073zd2_8037);
																																			BgL_cdrzd252077zd2_8040
																																				=
																																				CDR
																																				(BgL_carzd252073zd2_8037);
																																			{

																																				if (
																																					(BgL_carzd252076zd2_8039
																																						==
																																						CNST_TABLE_REF
																																						(((long) 17))))
																																					{	/* Ast/sexp.scm 118 */
																																					BgL_kapzd252078zd2_8041:
																																						if (PAIRP(BgL_cdrzd252077zd2_8040))
																																							{	/* Ast/sexp.scm 118 */
																																								obj_t
																																									BgL_cdrzd252081zd2_8160;
																																								BgL_cdrzd252081zd2_8160
																																									=
																																									CDR
																																									(BgL_cdrzd252077zd2_8040);
																																								if (PAIRP(BgL_cdrzd252081zd2_8160))
																																									{	/* Ast/sexp.scm 118 */
																																										if (NULLP(CDR(BgL_cdrzd252081zd2_8160)))
																																											{	/* Ast/sexp.scm 118 */
																																												obj_t
																																													BgL_arg6485z00_8164;
																																												obj_t
																																													BgL_arg6486z00_8165;
																																												BgL_arg6485z00_8164
																																													=
																																													CAR
																																													(BgL_cdrzd252081zd2_8160);
																																												BgL_arg6486z00_8165
																																													=
																																													CDR
																																													(
																																													((obj_t) BgL_expz00_21));
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_26983;
																																													{
																																														obj_t
																																															BgL_argsz00_26985;
																																														obj_t
																																															BgL_bodyz00_26984;
																																														BgL_bodyz00_26984
																																															=
																																															BgL_arg6485z00_8164;
																																														BgL_argsz00_26985
																																															=
																																															BgL_arg6486z00_8165;
																																														BgL_argsz00_1726
																																															=
																																															BgL_argsz00_26985;
																																														BgL_bodyz00_1725
																																															=
																																															BgL_bodyz00_26984;
																																														goto
																																															BgL_tagzd2381zd2_1727;
																																													}
																																													BgL_auxz00_22040
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_26983);
																																												}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 118 */
																																												bool_t
																																													BgL_test10110z00_26987;
																																												{	/* Ast/sexp.scm 118 */
																																													obj_t
																																														BgL_arg6550z00_8271;
																																													BgL_arg6550z00_8271
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													BgL_test10110z00_26987
																																														=
																																														CBOOL
																																														(BGl_labelszd2symzf3z21zzast_labelsz00
																																														(BgL_arg6550z00_8271));
																																												}
																																												if (BgL_test10110z00_26987)
																																													{
																																														BgL_letzd2funzd2_bglt
																																															BgL_auxz00_26992;
																																														goto
																																															BgL_tagzd2384zd2_1732;
																																														BgL_auxz00_22040
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_26992);
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														obj_t
																																															BgL_carzd252159zd2_8168;
																																														BgL_carzd252159zd2_8168
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_cdrzd252164zd2_8169;
																																															BgL_cdrzd252164zd2_8169
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_carzd252159zd2_8168));
																																															if ((CAR(((obj_t) BgL_carzd252159zd2_8168)) == CNST_TABLE_REF(((long) 3))))
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_arg6491z00_8172;
																																																	obj_t
																																																		BgL_arg6492z00_8173;
																																																	obj_t
																																																		BgL_arg6493z00_8174;
																																																	BgL_arg6491z00_8172
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd252164zd2_8169));
																																																	BgL_arg6492z00_8173
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd252164zd2_8169));
																																																	BgL_arg6493z00_8174
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_27009;
																																																		{
																																																			obj_t
																																																				BgL_argsz00_27012;
																																																			obj_t
																																																				BgL_bodyz00_27011;
																																																			obj_t
																																																				BgL_varsz00_27010;
																																																			BgL_varsz00_27010
																																																				=
																																																				BgL_arg6491z00_8172;
																																																			BgL_bodyz00_27011
																																																				=
																																																				BgL_arg6492z00_8173;
																																																			BgL_argsz00_27012
																																																				=
																																																				BgL_arg6493z00_8174;
																																																			BgL_argsz00_1739
																																																				=
																																																				BgL_argsz00_27012;
																																																			BgL_bodyz00_1738
																																																				=
																																																				BgL_bodyz00_27011;
																																																			BgL_varsz00_1737
																																																				=
																																																				BgL_varsz00_27010;
																																																			goto
																																																				BgL_tagzd2386zd2_1740;
																																																		}
																																																		BgL_auxz00_22040
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_27009);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_cdrzd252187zd2_8176;
																																																	BgL_cdrzd252187zd2_8176
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_cdrzd252193zd2_8177;
																																																		BgL_cdrzd252193zd2_8177
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_carzd252159zd2_8168));
																																																		if ((CAR(((obj_t) BgL_carzd252159zd2_8168)) == CNST_TABLE_REF(((long) 1))))
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_cdrzd252199zd2_8180;
																																																				BgL_cdrzd252199zd2_8180
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_cdrzd252193zd2_8177));
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_carzd252204zd2_8181;
																																																					obj_t
																																																						BgL_cdrzd252205zd2_8182;
																																																					BgL_carzd252204zd2_8181
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd252199zd2_8180));
																																																					BgL_cdrzd252205zd2_8182
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd252199zd2_8180));
																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd252204zd2_8181))
																																																						{	/* Ast/sexp.scm 118 */
																																																							if (PAIRP(BgL_cdrzd252205zd2_8182))
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_carzd252212zd2_8185;
																																																									BgL_carzd252212zd2_8185
																																																										=
																																																										CAR
																																																										(BgL_cdrzd252205zd2_8182);
																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd252212zd2_8185))
																																																										{	/* Ast/sexp.scm 118 */
																																																											if (NULLP(CDR(BgL_cdrzd252205zd2_8182)))
																																																												{	/* Ast/sexp.scm 118 */
																																																													bool_t
																																																														BgL_test10117z00_27039;
																																																													{
																																																														obj_t
																																																															BgL_l1454z00_8218;
																																																														BgL_l1454z00_8218
																																																															=
																																																															BgL_cdrzd252187zd2_8176;
																																																													BgL_zc3z04anonymousza36516ze3z87_8219:
																																																														if (NULLP(BgL_l1454z00_8218))
																																																															{	/* Ast/sexp.scm 118 */
																																																																BgL_test10117z00_27039
																																																																	=
																																																																	(
																																																																	(bool_t)
																																																																	1);
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																bool_t
																																																																	BgL_test10119z00_27042;
																																																																{	/* Ast/sexp.scm 118 */
																																																																	bool_t
																																																																		BgL_test10120z00_27043;
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_tmpz00_27044;
																																																																		BgL_tmpz00_27044
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_l1454z00_8218));
																																																																		BgL_test10120z00_27043
																																																																			=
																																																																			PAIRP
																																																																			(BgL_tmpz00_27044);
																																																																	}
																																																																	if (BgL_test10120z00_27043)
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			BgL_test10119z00_27042
																																																																				=
																																																																				(
																																																																				(bool_t)
																																																																				0);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			BgL_test10119z00_27042
																																																																				=
																																																																				(
																																																																				(bool_t)
																																																																				1);
																																																																		}
																																																																}
																																																																if (BgL_test10119z00_27042)
																																																																	{
																																																																		obj_t
																																																																			BgL_l1454z00_27048;
																																																																		BgL_l1454z00_27048
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_l1454z00_8218));
																																																																		BgL_l1454z00_8218
																																																																			=
																																																																			BgL_l1454z00_27048;
																																																																		goto
																																																																			BgL_zc3z04anonymousza36516ze3z87_8219;
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		BgL_test10117z00_27039
																																																																			=
																																																																			(
																																																																			(bool_t)
																																																																			0);
																																																																	}
																																																															}
																																																													}
																																																													if (BgL_test10117z00_27039)
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_arg6506z00_8201;
																																																															BgL_arg6506z00_8201
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_cdrzd252193zd2_8177));
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_27053;
																																																																{
																																																																	obj_t
																																																																		BgL_argsz00_27057;
																																																																	obj_t
																																																																		BgL_proc2z00_27056;
																																																																	obj_t
																																																																		BgL_proc1z00_27055;
																																																																	obj_t
																																																																		BgL_testz00_27054;
																																																																	BgL_testz00_27054
																																																																		=
																																																																		BgL_arg6506z00_8201;
																																																																	BgL_proc1z00_27055
																																																																		=
																																																																		BgL_carzd252204zd2_8181;
																																																																	BgL_proc2z00_27056
																																																																		=
																																																																		BgL_carzd252212zd2_8185;
																																																																	BgL_argsz00_27057
																																																																		=
																																																																		BgL_cdrzd252187zd2_8176;
																																																																	BgL_argsz00_1744
																																																																		=
																																																																		BgL_argsz00_27057;
																																																																	BgL_proc2z00_1743
																																																																		=
																																																																		BgL_proc2z00_27056;
																																																																	BgL_proc1z00_1742
																																																																		=
																																																																		BgL_proc1z00_27055;
																																																																	BgL_testz00_1741
																																																																		=
																																																																		BgL_testz00_27054;
																																																																	goto
																																																																		BgL_tagzd2387zd2_1745;
																																																																}
																																																																BgL_auxz00_22040
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_27053);
																																																															}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_cdrzd252236zd2_8202;
																																																															BgL_cdrzd252236zd2_8202
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_cdrzd252243zd2_8203;
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_pairz00_12991;
																																																																	BgL_pairz00_12991
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_expz00_21));
																																																																	BgL_cdrzd252243zd2_8203
																																																																		=
																																																																		CDR
																																																																		(BgL_pairz00_12991);
																																																																}
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd252250zd2_8204;
																																																																	BgL_cdrzd252250zd2_8204
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd252243zd2_8203));
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_carzd252256zd2_8205;
																																																																		BgL_carzd252256zd2_8205
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd252250zd2_8204));
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd252256zd2_8205))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_carzd252263zd2_8207;
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_pairz00_12995;
																																																																					BgL_pairz00_12995
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd252250zd2_8204));
																																																																					BgL_carzd252263zd2_8207
																																																																						=
																																																																						CAR
																																																																						(BgL_pairz00_12995);
																																																																				}
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd252263zd2_8207))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd252236zd2_8202))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_arg6510z00_8210;
																																																																								BgL_arg6510z00_8210
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd252243zd2_8203));
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_27079;
																																																																									{
																																																																										obj_t
																																																																											BgL_argsz00_27083;
																																																																										obj_t
																																																																											BgL_proc2z00_27082;
																																																																										obj_t
																																																																											BgL_proc1z00_27081;
																																																																										obj_t
																																																																											BgL_testz00_27080;
																																																																										BgL_testz00_27080
																																																																											=
																																																																											BgL_arg6510z00_8210;
																																																																										BgL_proc1z00_27081
																																																																											=
																																																																											BgL_carzd252256zd2_8205;
																																																																										BgL_proc2z00_27082
																																																																											=
																																																																											BgL_carzd252263zd2_8207;
																																																																										BgL_argsz00_27083
																																																																											=
																																																																											BgL_cdrzd252236zd2_8202;
																																																																										BgL_argsz00_1749
																																																																											=
																																																																											BgL_argsz00_27083;
																																																																										BgL_proc2z00_1748
																																																																											=
																																																																											BgL_proc2z00_27082;
																																																																										BgL_proc1z00_1747
																																																																											=
																																																																											BgL_proc1z00_27081;
																																																																										BgL_testz00_1746
																																																																											=
																																																																											BgL_testz00_27080;
																																																																										goto
																																																																											BgL_tagzd2388zd2_1750;
																																																																									}
																																																																									BgL_auxz00_22040
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_27079);
																																																																								}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1774;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_27087;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1775;
																																																																										BgL_auxz00_22040
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_27087);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1774;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_27091;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1775;
																																																																								BgL_auxz00_22040
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_27091);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1774;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_27095;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1775;
																																																																						BgL_auxz00_22040
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_27095);
																																																																					}
																																																																			}
																																																																	}
																																																																}
																																																															}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{	/* Ast/sexp.scm 118 */
																																																															goto
																																																																BgL_tagzd2403zd2_1774;
																																																														}
																																																													else
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_27099;
																																																															goto
																																																																BgL_tagzd2404zd2_1775;
																																																															BgL_auxz00_22040
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_27099);
																																																														}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_cdrzd252539zd2_8229;
																																																											BgL_cdrzd252539zd2_8229
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_cdrzd252545zd2_8230;
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_pairz00_12999;
																																																													BgL_pairz00_12999
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													BgL_cdrzd252545zd2_8230
																																																														=
																																																														CDR
																																																														(BgL_pairz00_12999);
																																																												}
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_cdrzd252551zd2_8231;
																																																													BgL_cdrzd252551zd2_8231
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd252545zd2_8230));
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_carzd252556zd2_8232;
																																																														obj_t
																																																															BgL_cdrzd252557zd2_8233;
																																																														BgL_carzd252556zd2_8232
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd252551zd2_8231));
																																																														BgL_cdrzd252557zd2_8233
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd252551zd2_8231));
																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd252556zd2_8232))
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_carzd252562zd2_8235;
																																																																BgL_carzd252562zd2_8235
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd252557zd2_8233));
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd252562zd2_8235))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (NULLP(CDR(((obj_t) BgL_cdrzd252557zd2_8233))))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd252539zd2_8229))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_arg6525z00_8240;
																																																																						BgL_arg6525z00_8240
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd252545zd2_8230));
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_27126;
																																																																							{
																																																																								obj_t
																																																																									BgL_argsz00_27130;
																																																																								obj_t
																																																																									BgL_proc2z00_27129;
																																																																								obj_t
																																																																									BgL_proc1z00_27128;
																																																																								obj_t
																																																																									BgL_testz00_27127;
																																																																								BgL_testz00_27127
																																																																									=
																																																																									BgL_arg6525z00_8240;
																																																																								BgL_proc1z00_27128
																																																																									=
																																																																									BgL_carzd252556zd2_8232;
																																																																								BgL_proc2z00_27129
																																																																									=
																																																																									BgL_carzd252562zd2_8235;
																																																																								BgL_argsz00_27130
																																																																									=
																																																																									BgL_cdrzd252539zd2_8229;
																																																																								BgL_argsz00_1749
																																																																									=
																																																																									BgL_argsz00_27130;
																																																																								BgL_proc2z00_1748
																																																																									=
																																																																									BgL_proc2z00_27129;
																																																																								BgL_proc1z00_1747
																																																																									=
																																																																									BgL_proc1z00_27128;
																																																																								BgL_testz00_1746
																																																																									=
																																																																									BgL_testz00_27127;
																																																																								goto
																																																																									BgL_tagzd2388zd2_1750;
																																																																							}
																																																																							BgL_auxz00_22040
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_27126);
																																																																						}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1774;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_27134;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1775;
																																																																								BgL_auxz00_22040
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_27134);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1774;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_27138;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1775;
																																																																						BgL_auxz00_22040
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_27138);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1774;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_27142;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1775;
																																																																				BgL_auxz00_22040
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_27142);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1774;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_27146;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1775;
																																																																		BgL_auxz00_22040
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_27146);
																																																																	}
																																																															}
																																																													}
																																																												}
																																																											}
																																																										}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																										{	/* Ast/sexp.scm 118 */
																																																											goto
																																																												BgL_tagzd2403zd2_1774;
																																																										}
																																																									else
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_27150;
																																																											goto
																																																												BgL_tagzd2404zd2_1775;
																																																											BgL_auxz00_22040
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_27150);
																																																										}
																																																								}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_cdrzd252895zd2_8248;
																																																							BgL_cdrzd252895zd2_8248
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_cdrzd252902zd2_8249;
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_pairz00_13009;
																																																									BgL_pairz00_13009
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									BgL_cdrzd252902zd2_8249
																																																										=
																																																										CDR
																																																										(BgL_pairz00_13009);
																																																								}
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_cdrzd252909zd2_8250;
																																																									BgL_cdrzd252909zd2_8250
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd252902zd2_8249));
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_carzd252915zd2_8251;
																																																										obj_t
																																																											BgL_cdrzd252916zd2_8252;
																																																										BgL_carzd252915zd2_8251
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_cdrzd252909zd2_8250));
																																																										BgL_cdrzd252916zd2_8252
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_cdrzd252909zd2_8250));
																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd252915zd2_8251))
																																																											{	/* Ast/sexp.scm 118 */
																																																												if (PAIRP(BgL_cdrzd252916zd2_8252))
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_carzd252923zd2_8255;
																																																														BgL_carzd252923zd2_8255
																																																															=
																																																															CAR
																																																															(BgL_cdrzd252916zd2_8252);
																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd252923zd2_8255))
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (NULLP(CDR(BgL_cdrzd252916zd2_8252)))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd252895zd2_8248))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_arg6539z00_8260;
																																																																				BgL_arg6539z00_8260
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd252902zd2_8249));
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_27177;
																																																																					{
																																																																						obj_t
																																																																							BgL_argsz00_27181;
																																																																						obj_t
																																																																							BgL_proc2z00_27180;
																																																																						obj_t
																																																																							BgL_proc1z00_27179;
																																																																						obj_t
																																																																							BgL_testz00_27178;
																																																																						BgL_testz00_27178
																																																																							=
																																																																							BgL_arg6539z00_8260;
																																																																						BgL_proc1z00_27179
																																																																							=
																																																																							BgL_carzd252915zd2_8251;
																																																																						BgL_proc2z00_27180
																																																																							=
																																																																							BgL_carzd252923zd2_8255;
																																																																						BgL_argsz00_27181
																																																																							=
																																																																							BgL_cdrzd252895zd2_8248;
																																																																						BgL_argsz00_1749
																																																																							=
																																																																							BgL_argsz00_27181;
																																																																						BgL_proc2z00_1748
																																																																							=
																																																																							BgL_proc2z00_27180;
																																																																						BgL_proc1z00_1747
																																																																							=
																																																																							BgL_proc1z00_27179;
																																																																						BgL_testz00_1746
																																																																							=
																																																																							BgL_testz00_27178;
																																																																						goto
																																																																							BgL_tagzd2388zd2_1750;
																																																																					}
																																																																					BgL_auxz00_22040
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_27177);
																																																																				}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1774;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_27185;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1775;
																																																																						BgL_auxz00_22040
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_27185);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1774;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_27189;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1775;
																																																																				BgL_auxz00_22040
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_27189);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1774;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_27193;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1775;
																																																																		BgL_auxz00_22040
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_27193);
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 118 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 118 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1774;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_27197;
																																																																goto
																																																																	BgL_tagzd2404zd2_1775;
																																																																BgL_auxz00_22040
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_27197);
																																																															}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 118 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{	/* Ast/sexp.scm 118 */
																																																														goto
																																																															BgL_tagzd2403zd2_1774;
																																																													}
																																																												else
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_27201;
																																																														goto
																																																															BgL_tagzd2404zd2_1775;
																																																														BgL_auxz00_22040
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_27201);
																																																													}
																																																											}
																																																									}
																																																								}
																																																							}
																																																						}
																																																				}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 118 */
																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																					{	/* Ast/sexp.scm 118 */
																																																						goto
																																																							BgL_tagzd2403zd2_1774;
																																																					}
																																																				else
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_27205;
																																																						goto
																																																							BgL_tagzd2404zd2_1775;
																																																						BgL_auxz00_22040
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_27205);
																																																					}
																																																			}
																																																	}
																																																}
																																														}
																																													}
																																											}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 118 */
																																										bool_t
																																											BgL_test10148z00_27207;
																																										{	/* Ast/sexp.scm 118 */
																																											obj_t
																																												BgL_arg6561z00_8284;
																																											BgL_arg6561z00_8284
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_expz00_21));
																																											BgL_test10148z00_27207
																																												=
																																												CBOOL
																																												(BGl_labelszd2symzf3z21zzast_labelsz00
																																												(BgL_arg6561z00_8284));
																																										}
																																										if (BgL_test10148z00_27207)
																																											{
																																												BgL_letzd2funzd2_bglt
																																													BgL_auxz00_27212;
																																												goto
																																													BgL_tagzd2384zd2_1732;
																																												BgL_auxz00_22040
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_27212);
																																											}
																																										else
																																											{	/* Ast/sexp.scm 118 */
																																												obj_t
																																													BgL_carzd253369zd2_8275;
																																												BgL_carzd253369zd2_8275
																																													=
																																													CAR
																																													(
																																													((obj_t) BgL_expz00_21));
																																												{	/* Ast/sexp.scm 118 */
																																													obj_t
																																														BgL_cdrzd253374zd2_8276;
																																													BgL_cdrzd253374zd2_8276
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_carzd253369zd2_8275));
																																													if ((CAR(((obj_t) BgL_carzd253369zd2_8275)) == CNST_TABLE_REF(((long) 3))))
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_arg6556z00_8279;
																																															obj_t
																																																BgL_arg6557z00_8280;
																																															obj_t
																																																BgL_arg6558z00_8281;
																																															BgL_arg6556z00_8279
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd253374zd2_8276));
																																															BgL_arg6557z00_8280
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd253374zd2_8276));
																																															BgL_arg6558z00_8281
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_27229;
																																																{
																																																	obj_t
																																																		BgL_argsz00_27232;
																																																	obj_t
																																																		BgL_bodyz00_27231;
																																																	obj_t
																																																		BgL_varsz00_27230;
																																																	BgL_varsz00_27230
																																																		=
																																																		BgL_arg6556z00_8279;
																																																	BgL_bodyz00_27231
																																																		=
																																																		BgL_arg6557z00_8280;
																																																	BgL_argsz00_27232
																																																		=
																																																		BgL_arg6558z00_8281;
																																																	BgL_argsz00_1739
																																																		=
																																																		BgL_argsz00_27232;
																																																	BgL_bodyz00_1738
																																																		=
																																																		BgL_bodyz00_27231;
																																																	BgL_varsz00_1737
																																																		=
																																																		BgL_varsz00_27230;
																																																	goto
																																																		BgL_tagzd2386zd2_1740;
																																																}
																																																BgL_auxz00_22040
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_27229);
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 118 */
																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																{	/* Ast/sexp.scm 118 */
																																																	goto
																																																		BgL_tagzd2403zd2_1774;
																																																}
																																															else
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_27236;
																																																	goto
																																																		BgL_tagzd2404zd2_1775;
																																																	BgL_auxz00_22040
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_27236);
																																																}
																																														}
																																												}
																																											}
																																									}
																																							}
																																						else
																																							{	/* Ast/sexp.scm 118 */
																																								bool_t
																																									BgL_test10151z00_27238;
																																								{	/* Ast/sexp.scm 118 */
																																									obj_t
																																										BgL_arg6565z00_8288;
																																									BgL_arg6565z00_8288
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_expz00_21));
																																									BgL_test10151z00_27238
																																										=
																																										CBOOL
																																										(BGl_labelszd2symzf3z21zzast_labelsz00
																																										(BgL_arg6565z00_8288));
																																								}
																																								if (BgL_test10151z00_27238)
																																									{
																																										BgL_letzd2funzd2_bglt
																																											BgL_auxz00_27243;
																																										goto
																																											BgL_tagzd2384zd2_1732;
																																										BgL_auxz00_22040
																																											=
																																											(
																																											(obj_t)
																																											BgL_auxz00_27243);
																																									}
																																								else
																																									{	/* Ast/sexp.scm 118 */
																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																											{	/* Ast/sexp.scm 118 */
																																												goto
																																													BgL_tagzd2403zd2_1774;
																																											}
																																										else
																																											{
																																												BgL_nodez00_bglt
																																													BgL_auxz00_27247;
																																												goto
																																													BgL_tagzd2404zd2_1775;
																																												BgL_auxz00_22040
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_27247);
																																											}
																																									}
																																							}
																																					}
																																				else
																																					{	/* Ast/sexp.scm 118 */
																																						if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd252076zd2_8039)))
																																							{	/* Ast/sexp.scm 118 */
																																								goto
																																									BgL_kapzd252078zd2_8041;
																																							}
																																						else
																																							{	/* Ast/sexp.scm 118 */
																																								if ((BgL_carzd252076zd2_8039 == CNST_TABLE_REF(((long) 18))))
																																									{	/* Ast/sexp.scm 118 */
																																										goto
																																											BgL_kapzd252078zd2_8041;
																																									}
																																								else
																																									{	/* Ast/sexp.scm 118 */
																																										if ((BgL_carzd252076zd2_8039 == CNST_TABLE_REF(((long) 19))))
																																											{	/* Ast/sexp.scm 118 */
																																												goto
																																													BgL_kapzd252078zd2_8041;
																																											}
																																										else
																																											{	/* Ast/sexp.scm 118 */
																																												if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd252076zd2_8039)))
																																													{	/* Ast/sexp.scm 118 */
																																														goto
																																															BgL_kapzd252078zd2_8041;
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														bool_t
																																															BgL_test10157z00_27261;
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_arg6480z00_8158;
																																															BgL_arg6480z00_8158
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															BgL_test10157z00_27261
																																																=
																																																CBOOL
																																																(BGl_labelszd2symzf3z21zzast_labelsz00
																																																(BgL_arg6480z00_8158));
																																														}
																																														if (BgL_test10157z00_27261)
																																															{
																																																BgL_letzd2funzd2_bglt
																																																	BgL_auxz00_27266;
																																																goto
																																																	BgL_tagzd2384zd2_1732;
																																																BgL_auxz00_22040
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_27266);
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_carzd253697zd2_8049;
																																																BgL_carzd253697zd2_8049
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_cdrzd253702zd2_8050;
																																																	BgL_cdrzd253702zd2_8050
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_carzd253697zd2_8049));
																																																	if ((CAR(((obj_t) BgL_carzd253697zd2_8049)) == CNST_TABLE_REF(((long) 3))))
																																																		{	/* Ast/sexp.scm 118 */
																																																			if (PAIRP(BgL_cdrzd253702zd2_8050))
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_arg6416z00_8054;
																																																					obj_t
																																																						BgL_arg6417z00_8055;
																																																					obj_t
																																																						BgL_arg6418z00_8056;
																																																					BgL_arg6416z00_8054
																																																						=
																																																						CAR
																																																						(BgL_cdrzd253702zd2_8050);
																																																					BgL_arg6417z00_8055
																																																						=
																																																						CDR
																																																						(BgL_cdrzd253702zd2_8050);
																																																					BgL_arg6418z00_8056
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_27283;
																																																						{
																																																							obj_t
																																																								BgL_argsz00_27286;
																																																							obj_t
																																																								BgL_bodyz00_27285;
																																																							obj_t
																																																								BgL_varsz00_27284;
																																																							BgL_varsz00_27284
																																																								=
																																																								BgL_arg6416z00_8054;
																																																							BgL_bodyz00_27285
																																																								=
																																																								BgL_arg6417z00_8055;
																																																							BgL_argsz00_27286
																																																								=
																																																								BgL_arg6418z00_8056;
																																																							BgL_argsz00_1739
																																																								=
																																																								BgL_argsz00_27286;
																																																							BgL_bodyz00_1738
																																																								=
																																																								BgL_bodyz00_27285;
																																																							BgL_varsz00_1737
																																																								=
																																																								BgL_varsz00_27284;
																																																							goto
																																																								BgL_tagzd2386zd2_1740;
																																																						}
																																																						BgL_auxz00_22040
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_27283);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																						{	/* Ast/sexp.scm 118 */
																																																							goto
																																																								BgL_tagzd2403zd2_1774;
																																																						}
																																																					else
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_27290;
																																																							goto
																																																								BgL_tagzd2404zd2_1775;
																																																							BgL_auxz00_22040
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_27290);
																																																						}
																																																				}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_cdrzd253809zd2_8059;
																																																			BgL_cdrzd253809zd2_8059
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_cdrzd253814zd2_8060;
																																																				BgL_cdrzd253814zd2_8060
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_carzd253697zd2_8049));
																																																				if ((CAR(((obj_t) BgL_carzd253697zd2_8049)) == CNST_TABLE_REF(((long) 1))))
																																																					{	/* Ast/sexp.scm 118 */
																																																						if (PAIRP(BgL_cdrzd253814zd2_8060))
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_cdrzd253819zd2_8064;
																																																								BgL_cdrzd253819zd2_8064
																																																									=
																																																									CDR
																																																									(BgL_cdrzd253814zd2_8060);
																																																								if (PAIRP(BgL_cdrzd253819zd2_8064))
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_carzd253823zd2_8066;
																																																										obj_t
																																																											BgL_cdrzd253824zd2_8067;
																																																										BgL_carzd253823zd2_8066
																																																											=
																																																											CAR
																																																											(BgL_cdrzd253819zd2_8064);
																																																										BgL_cdrzd253824zd2_8067
																																																											=
																																																											CDR
																																																											(BgL_cdrzd253819zd2_8064);
																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd253823zd2_8066))
																																																											{	/* Ast/sexp.scm 118 */
																																																												if (PAIRP(BgL_cdrzd253824zd2_8067))
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_carzd253829zd2_8070;
																																																														BgL_carzd253829zd2_8070
																																																															=
																																																															CAR
																																																															(BgL_cdrzd253824zd2_8067);
																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd253829zd2_8070))
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (NULLP(CDR(BgL_cdrzd253824zd2_8067)))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		bool_t
																																																																			BgL_test10168z00_27318;
																																																																		{
																																																																			obj_t
																																																																				BgL_l1457z00_8103;
																																																																			BgL_l1457z00_8103
																																																																				=
																																																																				BgL_cdrzd253809zd2_8059;
																																																																		BgL_zc3z04anonymousza36444ze3z87_8104:
																																																																			if (NULLP(BgL_l1457z00_8103))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					BgL_test10168z00_27318
																																																																						=
																																																																						(
																																																																						(bool_t)
																																																																						1);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					bool_t
																																																																						BgL_test10170z00_27321;
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						bool_t
																																																																							BgL_test10171z00_27322;
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_tmpz00_27323;
																																																																							BgL_tmpz00_27323
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_l1457z00_8103));
																																																																							BgL_test10171z00_27322
																																																																								=
																																																																								PAIRP
																																																																								(BgL_tmpz00_27323);
																																																																						}
																																																																						if (BgL_test10171z00_27322)
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								BgL_test10170z00_27321
																																																																									=
																																																																									(
																																																																									(bool_t)
																																																																									0);
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								BgL_test10170z00_27321
																																																																									=
																																																																									(
																																																																									(bool_t)
																																																																									1);
																																																																							}
																																																																					}
																																																																					if (BgL_test10170z00_27321)
																																																																						{
																																																																							obj_t
																																																																								BgL_l1457z00_27327;
																																																																							BgL_l1457z00_27327
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_l1457z00_8103));
																																																																							BgL_l1457z00_8103
																																																																								=
																																																																								BgL_l1457z00_27327;
																																																																							goto
																																																																								BgL_zc3z04anonymousza36444ze3z87_8104;
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							BgL_test10168z00_27318
																																																																								=
																																																																								(
																																																																								(bool_t)
																																																																								0);
																																																																						}
																																																																				}
																																																																		}
																																																																		if (BgL_test10168z00_27318)
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_arg6434z00_8086;
																																																																				BgL_arg6434z00_8086
																																																																					=
																																																																					CAR
																																																																					(BgL_cdrzd253814zd2_8060);
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_27331;
																																																																					{
																																																																						obj_t
																																																																							BgL_argsz00_27335;
																																																																						obj_t
																																																																							BgL_proc2z00_27334;
																																																																						obj_t
																																																																							BgL_proc1z00_27333;
																																																																						obj_t
																																																																							BgL_testz00_27332;
																																																																						BgL_testz00_27332
																																																																							=
																																																																							BgL_arg6434z00_8086;
																																																																						BgL_proc1z00_27333
																																																																							=
																																																																							BgL_carzd253823zd2_8066;
																																																																						BgL_proc2z00_27334
																																																																							=
																																																																							BgL_carzd253829zd2_8070;
																																																																						BgL_argsz00_27335
																																																																							=
																																																																							BgL_cdrzd253809zd2_8059;
																																																																						BgL_argsz00_1744
																																																																							=
																																																																							BgL_argsz00_27335;
																																																																						BgL_proc2z00_1743
																																																																							=
																																																																							BgL_proc2z00_27334;
																																																																						BgL_proc1z00_1742
																																																																							=
																																																																							BgL_proc1z00_27333;
																																																																						BgL_testz00_1741
																																																																							=
																																																																							BgL_testz00_27332;
																																																																						goto
																																																																							BgL_tagzd2387zd2_1745;
																																																																					}
																																																																					BgL_auxz00_22040
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_27331);
																																																																				}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_cdrzd253854zd2_8087;
																																																																				BgL_cdrzd253854zd2_8087
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_cdrzd253862zd2_8088;
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_pairz00_13054;
																																																																						BgL_pairz00_13054
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						BgL_cdrzd253862zd2_8088
																																																																							=
																																																																							CDR
																																																																							(BgL_pairz00_13054);
																																																																					}
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_cdrzd253870zd2_8089;
																																																																						BgL_cdrzd253870zd2_8089
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd253862zd2_8088));
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_carzd253877zd2_8090;
																																																																							BgL_carzd253877zd2_8090
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd253870zd2_8089));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd253877zd2_8090))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_carzd253886zd2_8092;
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_pairz00_13058;
																																																																										BgL_pairz00_13058
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd253870zd2_8089));
																																																																										BgL_carzd253886zd2_8092
																																																																											=
																																																																											CAR
																																																																											(BgL_pairz00_13058);
																																																																									}
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd253886zd2_8092))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd253854zd2_8087))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_arg6438z00_8095;
																																																																													BgL_arg6438z00_8095
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd253862zd2_8088));
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_27357;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_27361;
																																																																															obj_t
																																																																																BgL_proc2z00_27360;
																																																																															obj_t
																																																																																BgL_proc1z00_27359;
																																																																															obj_t
																																																																																BgL_testz00_27358;
																																																																															BgL_testz00_27358
																																																																																=
																																																																																BgL_arg6438z00_8095;
																																																																															BgL_proc1z00_27359
																																																																																=
																																																																																BgL_carzd253877zd2_8090;
																																																																															BgL_proc2z00_27360
																																																																																=
																																																																																BgL_carzd253886zd2_8092;
																																																																															BgL_argsz00_27361
																																																																																=
																																																																																BgL_cdrzd253854zd2_8087;
																																																																															BgL_argsz00_1749
																																																																																=
																																																																																BgL_argsz00_27361;
																																																																															BgL_proc2z00_1748
																																																																																=
																																																																																BgL_proc2z00_27360;
																																																																															BgL_proc1z00_1747
																																																																																=
																																																																																BgL_proc1z00_27359;
																																																																															BgL_testz00_1746
																																																																																=
																																																																																BgL_testz00_27358;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1750;
																																																																														}
																																																																														BgL_auxz00_22040
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_27357);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1774;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_27365;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1775;
																																																																															BgL_auxz00_22040
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_27365);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1774;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_27369;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1775;
																																																																													BgL_auxz00_22040
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_27369);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1774;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_27373;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1775;
																																																																											BgL_auxz00_22040
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_27373);
																																																																										}
																																																																								}
																																																																						}
																																																																					}
																																																																				}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1774;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_27377;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1775;
																																																																				BgL_auxz00_22040
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_27377);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_cdrzd254164zd2_8114;
																																																																BgL_cdrzd254164zd2_8114
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd254171zd2_8115;
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_pairz00_13062;
																																																																		BgL_pairz00_13062
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		BgL_cdrzd254171zd2_8115
																																																																			=
																																																																			CDR
																																																																			(BgL_pairz00_13062);
																																																																	}
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_cdrzd254178zd2_8116;
																																																																		BgL_cdrzd254178zd2_8116
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd254171zd2_8115));
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_carzd254184zd2_8117;
																																																																			obj_t
																																																																				BgL_cdrzd254185zd2_8118;
																																																																			BgL_carzd254184zd2_8117
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd254178zd2_8116));
																																																																			BgL_cdrzd254185zd2_8118
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd254178zd2_8116));
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd254184zd2_8117))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_carzd254192zd2_8120;
																																																																					BgL_carzd254192zd2_8120
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd254185zd2_8118));
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd254192zd2_8120))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (NULLP(CDR(((obj_t) BgL_cdrzd254185zd2_8118))))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd254164zd2_8114))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_arg6453z00_8125;
																																																																											BgL_arg6453z00_8125
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd254171zd2_8115));
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_27404;
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_27408;
																																																																													obj_t
																																																																														BgL_proc2z00_27407;
																																																																													obj_t
																																																																														BgL_proc1z00_27406;
																																																																													obj_t
																																																																														BgL_testz00_27405;
																																																																													BgL_testz00_27405
																																																																														=
																																																																														BgL_arg6453z00_8125;
																																																																													BgL_proc1z00_27406
																																																																														=
																																																																														BgL_carzd254184zd2_8117;
																																																																													BgL_proc2z00_27407
																																																																														=
																																																																														BgL_carzd254192zd2_8120;
																																																																													BgL_argsz00_27408
																																																																														=
																																																																														BgL_cdrzd254164zd2_8114;
																																																																													BgL_argsz00_1749
																																																																														=
																																																																														BgL_argsz00_27408;
																																																																													BgL_proc2z00_1748
																																																																														=
																																																																														BgL_proc2z00_27407;
																																																																													BgL_proc1z00_1747
																																																																														=
																																																																														BgL_proc1z00_27406;
																																																																													BgL_testz00_1746
																																																																														=
																																																																														BgL_testz00_27405;
																																																																													goto
																																																																														BgL_tagzd2388zd2_1750;
																																																																												}
																																																																												BgL_auxz00_22040
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_27404);
																																																																											}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1774;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_27412;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1775;
																																																																													BgL_auxz00_22040
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_27412);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1774;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_27416;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1775;
																																																																											BgL_auxz00_22040
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_27416);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1774;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_27420;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1775;
																																																																									BgL_auxz00_22040
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_27420);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1774;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_27424;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1775;
																																																																							BgL_auxz00_22040
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_27424);
																																																																						}
																																																																				}
																																																																		}
																																																																	}
																																																																}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 118 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 118 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1774;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_27428;
																																																																goto
																																																																	BgL_tagzd2404zd2_1775;
																																																																BgL_auxz00_22040
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_27428);
																																																															}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_cdrzd254525zd2_8133;
																																																												BgL_cdrzd254525zd2_8133
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_cdrzd254531zd2_8134;
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_pairz00_13072;
																																																														BgL_pairz00_13072
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														BgL_cdrzd254531zd2_8134
																																																															=
																																																															CDR
																																																															(BgL_pairz00_13072);
																																																													}
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_cdrzd254537zd2_8135;
																																																														BgL_cdrzd254537zd2_8135
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd254531zd2_8134));
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_carzd254542zd2_8136;
																																																															obj_t
																																																																BgL_cdrzd254543zd2_8137;
																																																															BgL_carzd254542zd2_8136
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_cdrzd254537zd2_8135));
																																																															BgL_cdrzd254543zd2_8137
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd254537zd2_8135));
																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd254542zd2_8136))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if (PAIRP(BgL_cdrzd254543zd2_8137))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_carzd254548zd2_8140;
																																																																			BgL_carzd254548zd2_8140
																																																																				=
																																																																				CAR
																																																																				(BgL_cdrzd254543zd2_8137);
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd254548zd2_8140))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (NULLP(CDR(BgL_cdrzd254543zd2_8137)))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd254525zd2_8133))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_arg6467z00_8145;
																																																																									BgL_arg6467z00_8145
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd254531zd2_8134));
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_27455;
																																																																										{
																																																																											obj_t
																																																																												BgL_argsz00_27459;
																																																																											obj_t
																																																																												BgL_proc2z00_27458;
																																																																											obj_t
																																																																												BgL_proc1z00_27457;
																																																																											obj_t
																																																																												BgL_testz00_27456;
																																																																											BgL_testz00_27456
																																																																												=
																																																																												BgL_arg6467z00_8145;
																																																																											BgL_proc1z00_27457
																																																																												=
																																																																												BgL_carzd254542zd2_8136;
																																																																											BgL_proc2z00_27458
																																																																												=
																																																																												BgL_carzd254548zd2_8140;
																																																																											BgL_argsz00_27459
																																																																												=
																																																																												BgL_cdrzd254525zd2_8133;
																																																																											BgL_argsz00_1749
																																																																												=
																																																																												BgL_argsz00_27459;
																																																																											BgL_proc2z00_1748
																																																																												=
																																																																												BgL_proc2z00_27458;
																																																																											BgL_proc1z00_1747
																																																																												=
																																																																												BgL_proc1z00_27457;
																																																																											BgL_testz00_1746
																																																																												=
																																																																												BgL_testz00_27456;
																																																																											goto
																																																																												BgL_tagzd2388zd2_1750;
																																																																										}
																																																																										BgL_auxz00_22040
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_27455);
																																																																									}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1774;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_27463;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1775;
																																																																											BgL_auxz00_22040
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_27463);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1774;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_27467;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1775;
																																																																									BgL_auxz00_22040
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_27467);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1774;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_27471;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1775;
																																																																							BgL_auxz00_22040
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_27471);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1774;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_27475;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1775;
																																																																					BgL_auxz00_22040
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_27475);
																																																																				}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1774;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_27479;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1775;
																																																																			BgL_auxz00_22040
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_27479);
																																																																		}
																																																																}
																																																														}
																																																													}
																																																												}
																																																											}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 118 */
																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																											{	/* Ast/sexp.scm 118 */
																																																												goto
																																																													BgL_tagzd2403zd2_1774;
																																																											}
																																																										else
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_27483;
																																																												goto
																																																													BgL_tagzd2404zd2_1775;
																																																												BgL_auxz00_22040
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_27483);
																																																											}
																																																									}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 118 */
																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																									{	/* Ast/sexp.scm 118 */
																																																										goto
																																																											BgL_tagzd2403zd2_1774;
																																																									}
																																																								else
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_27487;
																																																										goto
																																																											BgL_tagzd2404zd2_1775;
																																																										BgL_auxz00_22040
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_27487);
																																																									}
																																																							}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 118 */
																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																							{	/* Ast/sexp.scm 118 */
																																																								goto
																																																									BgL_tagzd2403zd2_1774;
																																																							}
																																																						else
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_27491;
																																																								goto
																																																									BgL_tagzd2404zd2_1775;
																																																								BgL_auxz00_22040
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_27491);
																																																							}
																																																					}
																																																			}
																																																		}
																																																}
																																															}
																																													}
																																											}
																																									}
																																							}
																																					}
																																			}
																																		}
																																	else
																																		{	/* Ast/sexp.scm 118 */
																																			if (
																																				(BgL_carzd252073zd2_8037
																																					==
																																					CNST_TABLE_REF
																																					(((long) 20))))
																																				{
																																					BgL_nodez00_bglt
																																						BgL_auxz00_27496;
																																					goto
																																						BgL_tagzd2383zd2_1731;
																																					BgL_auxz00_22040
																																						=
																																						(
																																						(obj_t)
																																						BgL_auxz00_27496);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 118 */
																																					obj_t
																																						BgL_carzd255110zd2_8291;
																																					BgL_carzd255110zd2_8291
																																						=
																																						CAR(
																																						((obj_t) BgL_expz00_21));
																																					if (
																																						(BgL_carzd255110zd2_8291
																																							==
																																							CNST_TABLE_REF
																																							(((long) 19))))
																																						{
																																							BgL_letzd2funzd2_bglt
																																								BgL_auxz00_27503;
																																							goto
																																								BgL_tagzd2384zd2_1732;
																																							BgL_auxz00_22040
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_27503);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 118 */
																																							if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd255110zd2_8291)))
																																								{
																																									BgL_letzd2funzd2_bglt
																																										BgL_auxz00_27508;
																																									goto
																																										BgL_tagzd2384zd2_1732;
																																									BgL_auxz00_22040
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_27508);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 118 */
																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_27515;
																																											goto
																																												BgL_tagzd2389zd2_1751;
																																											BgL_auxz00_22040
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_27515);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 118 */
																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_27522;
																																													goto
																																														BgL_tagzd2390zd2_1752;
																																													BgL_auxz00_22040
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_27522);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 118 */
																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_27529;
																																															goto
																																																BgL_tagzd2392zd2_1756;
																																															BgL_auxz00_22040
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_27529);
																																														}
																																													else
																																														{	/* Ast/sexp.scm 118 */
																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_27536;
																																																	goto
																																																		BgL_tagzd2393zd2_1757;
																																																	BgL_auxz00_22040
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_27536);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_27543;
																																																			goto
																																																				BgL_tagzd2395zd2_1761;
																																																			BgL_auxz00_22040
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_27543);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_27550;
																																																					goto
																																																						BgL_tagzd2396zd2_1762;
																																																					BgL_auxz00_22040
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_27550);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_27557;
																																																							goto
																																																								BgL_tagzd2397zd2_1763;
																																																							BgL_auxz00_22040
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_27557);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																								{
																																																									BgL_jumpzd2exzd2itz00_bglt
																																																										BgL_auxz00_27564;
																																																									goto
																																																										BgL_tagzd2398zd2_1764;
																																																									BgL_auxz00_22040
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_27564);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									if (BGl_equalzf3zf3zz__r4_equivalence_6_2z00(CAR(((obj_t) BgL_expz00_21)), BUNSPEC))
																																																										{	/* Ast/sexp.scm 118 */
																																																											if (NULLP(CDR(((obj_t) BgL_expz00_21))))
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_27574;
																																																													goto
																																																														BgL_tagzd2402zd2_1773;
																																																													BgL_auxz00_22040
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_27574);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{	/* Ast/sexp.scm 118 */
																																																															goto
																																																																BgL_tagzd2403zd2_1774;
																																																														}
																																																													else
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_27578;
																																																															goto
																																																																BgL_tagzd2404zd2_1775;
																																																															BgL_auxz00_22040
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_27578);
																																																														}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{	/* Ast/sexp.scm 118 */
																																																													goto
																																																														BgL_tagzd2403zd2_1774;
																																																												}
																																																											else
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_27582;
																																																													goto
																																																														BgL_tagzd2404zd2_1775;
																																																													BgL_auxz00_22040
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_27582);
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																										}
																								}
																							return
																								((BgL_nodez00_bglt)
																								BgL_auxz00_22040);
																						}
																					else
																						{	/* Ast/sexp.scm 118 */
																							if (
																								(BgL_carzd231447zd2_5078 ==
																									BGl_za2ifza2z00zzast_sexpz00))
																								{
																									obj_t BgL_auxz00_27587;

																									goto BgL_kapzd231449zd2_5080;
																									return
																										((BgL_nodez00_bglt)
																										BgL_auxz00_27587);
																								}
																							else
																								{	/* Ast/sexp.scm 118 */
																									bool_t BgL_test10217z00_27589;

																									{	/* Ast/sexp.scm 118 */
																										obj_t BgL_arg4833z00_5825;

																										BgL_arg4833z00_5825 =
																											CAR(BgL_expz00_21);
																										BgL_test10217z00_27589 =
																											(BgL_arg4833z00_5825 ==
																											BGl_za2ifza2z00zzast_sexpz00);
																									}
																									if (BgL_test10217z00_27589)
																										{	/* Ast/sexp.scm 118 */
																											goto
																												BgL_tagzd2377zd2_1719;
																										}
																									else
																										{	/* Ast/sexp.scm 118 */
																											obj_t
																												BgL_cdrzd255282zd2_5085;
																											BgL_cdrzd255282zd2_5085 =
																												CDR(BgL_expz00_21);
																											if ((CAR(BgL_expz00_21) ==
																													CNST_TABLE_REF(((long)
																															7))))
																												{	/* Ast/sexp.scm 118 */
																													if (PAIRP
																														(BgL_cdrzd255282zd2_5085))
																														{	/* Ast/sexp.scm 118 */
																															obj_t
																																BgL_carzd255285zd2_5089;
																															obj_t
																																BgL_cdrzd255286zd2_5090;
																															BgL_carzd255285zd2_5089
																																=
																																CAR
																																(BgL_cdrzd255282zd2_5085);
																															BgL_cdrzd255286zd2_5090
																																=
																																CDR
																																(BgL_cdrzd255282zd2_5085);
																															if (PAIRP
																																(BgL_carzd255285zd2_5089))
																																{	/* Ast/sexp.scm 118 */
																																	if (
																																		(CAR
																																			(BgL_carzd255285zd2_5089)
																																			==
																																			CNST_TABLE_REF
																																			(((long)
																																					14))))
																																		{	/* Ast/sexp.scm 118 */
																																			if (PAIRP
																																				(BgL_cdrzd255286zd2_5090))
																																				{	/* Ast/sexp.scm 118 */
																																					if (NULLP(CDR(BgL_cdrzd255286zd2_5090)))
																																						{
																																							obj_t
																																								BgL_valz00_27614;
																																							obj_t
																																								BgL_lz00_27612;
																																							BgL_lz00_27612
																																								=
																																								CDR
																																								(BgL_carzd255285zd2_5089);
																																							BgL_valz00_27614
																																								=
																																								CAR
																																								(BgL_cdrzd255286zd2_5090);
																																							BgL_valz00_1721
																																								=
																																								BgL_valz00_27614;
																																							BgL_lz00_1720
																																								=
																																								BgL_lz00_27612;
																																							goto
																																								BgL_tagzd2378zd2_1722;
																																						}
																																					else
																																						{	/* Ast/sexp.scm 118 */
																																							goto
																																								BgL_tagzd2379zd2_1723;
																																						}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 118 */
																																					goto
																																						BgL_tagzd2379zd2_1723;
																																				}
																																		}
																																	else
																																		{	/* Ast/sexp.scm 118 */
																																			goto
																																				BgL_tagzd2379zd2_1723;
																																		}
																																}
																															else
																																{	/* Ast/sexp.scm 118 */
																																	goto
																																		BgL_tagzd2379zd2_1723;
																																}
																														}
																													else
																														{	/* Ast/sexp.scm 118 */
																															goto
																																BgL_tagzd2379zd2_1723;
																														}
																												}
																											else
																												{	/* Ast/sexp.scm 118 */
																													if (
																														(CAR(BgL_expz00_21)
																															==
																															CNST_TABLE_REF((
																																	(long) 16))))
																														{	/* Ast/sexp.scm 118 */
																															goto
																																BgL_tagzd2380zd2_1724;
																														}
																													else
																														{	/* Ast/sexp.scm 118 */
																															obj_t
																																BgL_carzd255411zd2_5103;
																															BgL_carzd255411zd2_5103
																																=
																																CAR
																																(BgL_expz00_21);
																															if (PAIRP
																																(BgL_carzd255411zd2_5103))
																																{	/* Ast/sexp.scm 118 */
																																	obj_t
																																		BgL_carzd255414zd2_5105;
																																	obj_t
																																		BgL_cdrzd255415zd2_5106;
																																	BgL_carzd255414zd2_5105
																																		=
																																		CAR
																																		(BgL_carzd255411zd2_5103);
																																	BgL_cdrzd255415zd2_5106
																																		=
																																		CDR
																																		(BgL_carzd255411zd2_5103);
																																	{

																																		if (
																																			(BgL_carzd255414zd2_5105
																																				==
																																				CNST_TABLE_REF
																																				(((long)
																																						17))))
																																			{
																																				obj_t
																																					BgL_auxz00_27628;
																																			BgL_kapzd255416zd2_5107:
																																				if (PAIRP(BgL_cdrzd255415zd2_5106))
																																					{	/* Ast/sexp.scm 118 */
																																						obj_t
																																							BgL_cdrzd255419zd2_5409;
																																						BgL_cdrzd255419zd2_5409
																																							=
																																							CDR
																																							(BgL_cdrzd255415zd2_5106);
																																						if (PAIRP(BgL_cdrzd255419zd2_5409))
																																							{	/* Ast/sexp.scm 118 */
																																								if (NULLP(CDR(BgL_cdrzd255419zd2_5409)))
																																									{	/* Ast/sexp.scm 118 */
																																										obj_t
																																											BgL_arg4530z00_5413;
																																										obj_t
																																											BgL_arg4531z00_5414;
																																										BgL_arg4530z00_5413
																																											=
																																											CAR
																																											(BgL_cdrzd255419zd2_5409);
																																										BgL_arg4531z00_5414
																																											=
																																											CDR
																																											(
																																											((obj_t) BgL_expz00_21));
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_27640;
																																											{
																																												obj_t
																																													BgL_argsz00_27642;
																																												obj_t
																																													BgL_bodyz00_27641;
																																												BgL_bodyz00_27641
																																													=
																																													BgL_arg4530z00_5413;
																																												BgL_argsz00_27642
																																													=
																																													BgL_arg4531z00_5414;
																																												BgL_argsz00_1726
																																													=
																																													BgL_argsz00_27642;
																																												BgL_bodyz00_1725
																																													=
																																													BgL_bodyz00_27641;
																																												goto
																																													BgL_tagzd2381zd2_1727;
																																											}
																																											BgL_auxz00_27628
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_27640);
																																										}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 118 */
																																										obj_t
																																											BgL_cdrzd255442zd2_5415;
																																										BgL_cdrzd255442zd2_5415
																																											=
																																											CDR
																																											(
																																											((obj_t) BgL_expz00_21));
																																										{

																																											{	/* Ast/sexp.scm 118 */
																																												bool_t
																																													BgL_test10230z00_27646;
																																												{	/* Ast/sexp.scm 118 */
																																													obj_t
																																														BgL_arg4598z00_5525;
																																													BgL_arg4598z00_5525
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													BgL_test10230z00_27646
																																														=
																																														CBOOL
																																														(BGl_letzd2symzf3z21zzast_letz00
																																														(BgL_arg4598z00_5525));
																																												}
																																												if (BgL_test10230z00_27646)
																																													{	/* Ast/sexp.scm 118 */
																																														if (PAIRP(BgL_cdrzd255442zd2_5415))
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_arg4600z00_5527;
																																																obj_t
																																																	BgL_arg4601z00_5528;
																																																BgL_arg4600z00_5527
																																																	=
																																																	CAR
																																																	(BgL_cdrzd255442zd2_5415);
																																																BgL_arg4601z00_5528
																																																	=
																																																	CDR
																																																	(BgL_cdrzd255442zd2_5415);
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_27655;
																																																	{
																																																		obj_t
																																																			BgL_exprz00_27657;
																																																		obj_t
																																																			BgL_bindingsz00_27656;
																																																		BgL_bindingsz00_27656
																																																			=
																																																			BgL_arg4600z00_5527;
																																																		BgL_exprz00_27657
																																																			=
																																																			BgL_arg4601z00_5528;
																																																		BgL_exprz00_1729
																																																			=
																																																			BgL_exprz00_27657;
																																																		BgL_bindingsz00_1728
																																																			=
																																																			BgL_bindingsz00_27656;
																																																		goto
																																																			BgL_tagzd2382zd2_1730;
																																																	}
																																																	BgL_auxz00_27628
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_27655);
																																																}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																bool_t
																																																	BgL_test10232z00_27659;
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_arg4665z00_5634;
																																																	BgL_arg4665z00_5634
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	BgL_test10232z00_27659
																																																		=
																																																		CBOOL
																																																		(BGl_labelszd2symzf3z21zzast_labelsz00
																																																		(BgL_arg4665z00_5634));
																																																}
																																																if (BgL_test10232z00_27659)
																																																	{
																																																		BgL_letzd2funzd2_bglt
																																																			BgL_auxz00_27664;
																																																		goto
																																																			BgL_tagzd2384zd2_1732;
																																																		BgL_auxz00_27628
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_27664);
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_carzd255506zd2_5531;
																																																		BgL_carzd255506zd2_5531
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_cdrzd255511zd2_5532;
																																																			BgL_cdrzd255511zd2_5532
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_carzd255506zd2_5531));
																																																			if ((CAR(((obj_t) BgL_carzd255506zd2_5531)) == CNST_TABLE_REF(((long) 3))))
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_arg4606z00_5535;
																																																					obj_t
																																																						BgL_arg4607z00_5536;
																																																					obj_t
																																																						BgL_arg4608z00_5537;
																																																					BgL_arg4606z00_5535
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd255511zd2_5532));
																																																					BgL_arg4607z00_5536
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd255511zd2_5532));
																																																					BgL_arg4608z00_5537
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_27681;
																																																						{
																																																							obj_t
																																																								BgL_argsz00_27684;
																																																							obj_t
																																																								BgL_bodyz00_27683;
																																																							obj_t
																																																								BgL_varsz00_27682;
																																																							BgL_varsz00_27682
																																																								=
																																																								BgL_arg4606z00_5535;
																																																							BgL_bodyz00_27683
																																																								=
																																																								BgL_arg4607z00_5536;
																																																							BgL_argsz00_27684
																																																								=
																																																								BgL_arg4608z00_5537;
																																																							BgL_argsz00_1739
																																																								=
																																																								BgL_argsz00_27684;
																																																							BgL_bodyz00_1738
																																																								=
																																																								BgL_bodyz00_27683;
																																																							BgL_varsz00_1737
																																																								=
																																																								BgL_varsz00_27682;
																																																							goto
																																																								BgL_tagzd2386zd2_1740;
																																																						}
																																																						BgL_auxz00_27628
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_27681);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_cdrzd255534zd2_5539;
																																																					BgL_cdrzd255534zd2_5539
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_cdrzd255540zd2_5540;
																																																						BgL_cdrzd255540zd2_5540
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_carzd255506zd2_5531));
																																																						if ((CAR(((obj_t) BgL_carzd255506zd2_5531)) == CNST_TABLE_REF(((long) 1))))
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_cdrzd255546zd2_5543;
																																																								BgL_cdrzd255546zd2_5543
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_cdrzd255540zd2_5540));
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_carzd255551zd2_5544;
																																																									obj_t
																																																										BgL_cdrzd255552zd2_5545;
																																																									BgL_carzd255551zd2_5544
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd255546zd2_5543));
																																																									BgL_cdrzd255552zd2_5545
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd255546zd2_5543));
																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd255551zd2_5544))
																																																										{	/* Ast/sexp.scm 118 */
																																																											if (PAIRP(BgL_cdrzd255552zd2_5545))
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_carzd255559zd2_5548;
																																																													BgL_carzd255559zd2_5548
																																																														=
																																																														CAR
																																																														(BgL_cdrzd255552zd2_5545);
																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd255559zd2_5548))
																																																														{	/* Ast/sexp.scm 118 */
																																																															if (NULLP(CDR(BgL_cdrzd255552zd2_5545)))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	bool_t
																																																																		BgL_test10239z00_27711;
																																																																	{
																																																																		obj_t
																																																																			BgL_l1460z00_5581;
																																																																		BgL_l1460z00_5581
																																																																			=
																																																																			BgL_cdrzd255534zd2_5539;
																																																																	BgL_zc3z04anonymousza34631ze3z87_5582:
																																																																		if (NULLP(BgL_l1460z00_5581))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				BgL_test10239z00_27711
																																																																					=
																																																																					(
																																																																					(bool_t)
																																																																					1);
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				bool_t
																																																																					BgL_test10241z00_27714;
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					bool_t
																																																																						BgL_test10242z00_27715;
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_tmpz00_27716;
																																																																						BgL_tmpz00_27716
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_l1460z00_5581));
																																																																						BgL_test10242z00_27715
																																																																							=
																																																																							PAIRP
																																																																							(BgL_tmpz00_27716);
																																																																					}
																																																																					if (BgL_test10242z00_27715)
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							BgL_test10241z00_27714
																																																																								=
																																																																								(
																																																																								(bool_t)
																																																																								0);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							BgL_test10241z00_27714
																																																																								=
																																																																								(
																																																																								(bool_t)
																																																																								1);
																																																																						}
																																																																				}
																																																																				if (BgL_test10241z00_27714)
																																																																					{
																																																																						obj_t
																																																																							BgL_l1460z00_27720;
																																																																						BgL_l1460z00_27720
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_l1460z00_5581));
																																																																						BgL_l1460z00_5581
																																																																							=
																																																																							BgL_l1460z00_27720;
																																																																						goto
																																																																							BgL_zc3z04anonymousza34631ze3z87_5582;
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						BgL_test10239z00_27711
																																																																							=
																																																																							(
																																																																							(bool_t)
																																																																							0);
																																																																					}
																																																																			}
																																																																	}
																																																																	if (BgL_test10239z00_27711)
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_arg4621z00_5564;
																																																																			BgL_arg4621z00_5564
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd255540zd2_5540));
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_27725;
																																																																				{
																																																																					obj_t
																																																																						BgL_argsz00_27729;
																																																																					obj_t
																																																																						BgL_proc2z00_27728;
																																																																					obj_t
																																																																						BgL_proc1z00_27727;
																																																																					obj_t
																																																																						BgL_testz00_27726;
																																																																					BgL_testz00_27726
																																																																						=
																																																																						BgL_arg4621z00_5564;
																																																																					BgL_proc1z00_27727
																																																																						=
																																																																						BgL_carzd255551zd2_5544;
																																																																					BgL_proc2z00_27728
																																																																						=
																																																																						BgL_carzd255559zd2_5548;
																																																																					BgL_argsz00_27729
																																																																						=
																																																																						BgL_cdrzd255534zd2_5539;
																																																																					BgL_argsz00_1744
																																																																						=
																																																																						BgL_argsz00_27729;
																																																																					BgL_proc2z00_1743
																																																																						=
																																																																						BgL_proc2z00_27728;
																																																																					BgL_proc1z00_1742
																																																																						=
																																																																						BgL_proc1z00_27727;
																																																																					BgL_testz00_1741
																																																																						=
																																																																						BgL_testz00_27726;
																																																																					goto
																																																																						BgL_tagzd2387zd2_1745;
																																																																				}
																																																																				BgL_auxz00_27628
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_27725);
																																																																			}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_cdrzd255583zd2_5565;
																																																																			BgL_cdrzd255583zd2_5565
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_expz00_21));
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_cdrzd255590zd2_5566;
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_pairz00_13148;
																																																																					BgL_pairz00_13148
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_expz00_21));
																																																																					BgL_cdrzd255590zd2_5566
																																																																						=
																																																																						CDR
																																																																						(BgL_pairz00_13148);
																																																																				}
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_cdrzd255597zd2_5567;
																																																																					BgL_cdrzd255597zd2_5567
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd255590zd2_5566));
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_carzd255603zd2_5568;
																																																																						BgL_carzd255603zd2_5568
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd255597zd2_5567));
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd255603zd2_5568))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_carzd255610zd2_5570;
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_pairz00_13152;
																																																																									BgL_pairz00_13152
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd255597zd2_5567));
																																																																									BgL_carzd255610zd2_5570
																																																																										=
																																																																										CAR
																																																																										(BgL_pairz00_13152);
																																																																								}
																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd255610zd2_5570))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd255583zd2_5565))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_arg4625z00_5573;
																																																																												BgL_arg4625z00_5573
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd255590zd2_5566));
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_27751;
																																																																													{
																																																																														obj_t
																																																																															BgL_argsz00_27755;
																																																																														obj_t
																																																																															BgL_proc2z00_27754;
																																																																														obj_t
																																																																															BgL_proc1z00_27753;
																																																																														obj_t
																																																																															BgL_testz00_27752;
																																																																														BgL_testz00_27752
																																																																															=
																																																																															BgL_arg4625z00_5573;
																																																																														BgL_proc1z00_27753
																																																																															=
																																																																															BgL_carzd255603zd2_5568;
																																																																														BgL_proc2z00_27754
																																																																															=
																																																																															BgL_carzd255610zd2_5570;
																																																																														BgL_argsz00_27755
																																																																															=
																																																																															BgL_cdrzd255583zd2_5565;
																																																																														BgL_argsz00_1749
																																																																															=
																																																																															BgL_argsz00_27755;
																																																																														BgL_proc2z00_1748
																																																																															=
																																																																															BgL_proc2z00_27754;
																																																																														BgL_proc1z00_1747
																																																																															=
																																																																															BgL_proc1z00_27753;
																																																																														BgL_testz00_1746
																																																																															=
																																																																															BgL_testz00_27752;
																																																																														goto
																																																																															BgL_tagzd2388zd2_1750;
																																																																													}
																																																																													BgL_auxz00_27628
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_27751);
																																																																												}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1774;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_27759;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1775;
																																																																														BgL_auxz00_27628
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_27759);
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1774;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_27763;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1775;
																																																																												BgL_auxz00_27628
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_27763);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1774;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_27767;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1775;
																																																																										BgL_auxz00_27628
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_27767);
																																																																									}
																																																																							}
																																																																					}
																																																																				}
																																																																			}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1774;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_27771;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1775;
																																																																			BgL_auxz00_27628
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_27771);
																																																																		}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_cdrzd255886zd2_5592;
																																																															BgL_cdrzd255886zd2_5592
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_cdrzd255892zd2_5593;
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_pairz00_13156;
																																																																	BgL_pairz00_13156
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_expz00_21));
																																																																	BgL_cdrzd255892zd2_5593
																																																																		=
																																																																		CDR
																																																																		(BgL_pairz00_13156);
																																																																}
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd255898zd2_5594;
																																																																	BgL_cdrzd255898zd2_5594
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd255892zd2_5593));
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_carzd255903zd2_5595;
																																																																		obj_t
																																																																			BgL_cdrzd255904zd2_5596;
																																																																		BgL_carzd255903zd2_5595
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd255898zd2_5594));
																																																																		BgL_cdrzd255904zd2_5596
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd255898zd2_5594));
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd255903zd2_5595))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_carzd255909zd2_5598;
																																																																				BgL_carzd255909zd2_5598
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd255904zd2_5596));
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd255909zd2_5598))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (NULLP(CDR(((obj_t) BgL_cdrzd255904zd2_5596))))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd255886zd2_5592))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_arg4640z00_5603;
																																																																										BgL_arg4640z00_5603
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd255892zd2_5593));
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_27798;
																																																																											{
																																																																												obj_t
																																																																													BgL_argsz00_27802;
																																																																												obj_t
																																																																													BgL_proc2z00_27801;
																																																																												obj_t
																																																																													BgL_proc1z00_27800;
																																																																												obj_t
																																																																													BgL_testz00_27799;
																																																																												BgL_testz00_27799
																																																																													=
																																																																													BgL_arg4640z00_5603;
																																																																												BgL_proc1z00_27800
																																																																													=
																																																																													BgL_carzd255903zd2_5595;
																																																																												BgL_proc2z00_27801
																																																																													=
																																																																													BgL_carzd255909zd2_5598;
																																																																												BgL_argsz00_27802
																																																																													=
																																																																													BgL_cdrzd255886zd2_5592;
																																																																												BgL_argsz00_1749
																																																																													=
																																																																													BgL_argsz00_27802;
																																																																												BgL_proc2z00_1748
																																																																													=
																																																																													BgL_proc2z00_27801;
																																																																												BgL_proc1z00_1747
																																																																													=
																																																																													BgL_proc1z00_27800;
																																																																												BgL_testz00_1746
																																																																													=
																																																																													BgL_testz00_27799;
																																																																												goto
																																																																													BgL_tagzd2388zd2_1750;
																																																																											}
																																																																											BgL_auxz00_27628
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_27798);
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1774;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_27806;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1775;
																																																																												BgL_auxz00_27628
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_27806);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1774;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_27810;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1775;
																																																																										BgL_auxz00_27628
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_27810);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1774;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_27814;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1775;
																																																																								BgL_auxz00_27628
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_27814);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1774;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_27818;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1775;
																																																																						BgL_auxz00_27628
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_27818);
																																																																					}
																																																																			}
																																																																	}
																																																																}
																																																															}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{	/* Ast/sexp.scm 118 */
																																																															goto
																																																																BgL_tagzd2403zd2_1774;
																																																														}
																																																													else
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_27822;
																																																															goto
																																																																BgL_tagzd2404zd2_1775;
																																																															BgL_auxz00_27628
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_27822);
																																																														}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_cdrzd256242zd2_5611;
																																																											BgL_cdrzd256242zd2_5611
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_cdrzd256249zd2_5612;
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_pairz00_13166;
																																																													BgL_pairz00_13166
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													BgL_cdrzd256249zd2_5612
																																																														=
																																																														CDR
																																																														(BgL_pairz00_13166);
																																																												}
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_cdrzd256256zd2_5613;
																																																													BgL_cdrzd256256zd2_5613
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd256249zd2_5612));
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_carzd256262zd2_5614;
																																																														obj_t
																																																															BgL_cdrzd256263zd2_5615;
																																																														BgL_carzd256262zd2_5614
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd256256zd2_5613));
																																																														BgL_cdrzd256263zd2_5615
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd256256zd2_5613));
																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd256262zd2_5614))
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (PAIRP(BgL_cdrzd256263zd2_5615))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_carzd256270zd2_5618;
																																																																		BgL_carzd256270zd2_5618
																																																																			=
																																																																			CAR
																																																																			(BgL_cdrzd256263zd2_5615);
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd256270zd2_5618))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (NULLP(CDR(BgL_cdrzd256263zd2_5615)))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd256242zd2_5611))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_arg4654z00_5623;
																																																																								BgL_arg4654z00_5623
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd256249zd2_5612));
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_27849;
																																																																									{
																																																																										obj_t
																																																																											BgL_argsz00_27853;
																																																																										obj_t
																																																																											BgL_proc2z00_27852;
																																																																										obj_t
																																																																											BgL_proc1z00_27851;
																																																																										obj_t
																																																																											BgL_testz00_27850;
																																																																										BgL_testz00_27850
																																																																											=
																																																																											BgL_arg4654z00_5623;
																																																																										BgL_proc1z00_27851
																																																																											=
																																																																											BgL_carzd256262zd2_5614;
																																																																										BgL_proc2z00_27852
																																																																											=
																																																																											BgL_carzd256270zd2_5618;
																																																																										BgL_argsz00_27853
																																																																											=
																																																																											BgL_cdrzd256242zd2_5611;
																																																																										BgL_argsz00_1749
																																																																											=
																																																																											BgL_argsz00_27853;
																																																																										BgL_proc2z00_1748
																																																																											=
																																																																											BgL_proc2z00_27852;
																																																																										BgL_proc1z00_1747
																																																																											=
																																																																											BgL_proc1z00_27851;
																																																																										BgL_testz00_1746
																																																																											=
																																																																											BgL_testz00_27850;
																																																																										goto
																																																																											BgL_tagzd2388zd2_1750;
																																																																									}
																																																																									BgL_auxz00_27628
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_27849);
																																																																								}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1774;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_27857;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1775;
																																																																										BgL_auxz00_27628
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_27857);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1774;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_27861;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1775;
																																																																								BgL_auxz00_27628
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_27861);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1774;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_27865;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1775;
																																																																						BgL_auxz00_27628
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_27865);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1774;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_27869;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1775;
																																																																				BgL_auxz00_27628
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_27869);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1774;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_27873;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1775;
																																																																		BgL_auxz00_27628
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_27873);
																																																																	}
																																																															}
																																																													}
																																																												}
																																																											}
																																																										}
																																																								}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 118 */
																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																									{	/* Ast/sexp.scm 118 */
																																																										goto
																																																											BgL_tagzd2403zd2_1774;
																																																									}
																																																								else
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_27877;
																																																										goto
																																																											BgL_tagzd2404zd2_1775;
																																																										BgL_auxz00_27628
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_27877);
																																																									}
																																																							}
																																																					}
																																																				}
																																																		}
																																																	}
																																															}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														bool_t
																																															BgL_test10270z00_27879;
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_arg4597z00_5524;
																																															BgL_arg4597z00_5524
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															BgL_test10270z00_27879
																																																=
																																																CBOOL
																																																(BGl_labelszd2symzf3z21zzast_labelsz00
																																																(BgL_arg4597z00_5524));
																																														}
																																														if (BgL_test10270z00_27879)
																																															{
																																																BgL_letzd2funzd2_bglt
																																																	BgL_auxz00_27884;
																																																goto
																																																	BgL_tagzd2384zd2_1732;
																																																BgL_auxz00_27628
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_27884);
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_carzd256702zd2_5421;
																																																BgL_carzd256702zd2_5421
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_cdrzd256707zd2_5422;
																																																	BgL_cdrzd256707zd2_5422
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_carzd256702zd2_5421));
																																																	if ((CAR(((obj_t) BgL_carzd256702zd2_5421)) == CNST_TABLE_REF(((long) 3))))
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_arg4538z00_5425;
																																																			obj_t
																																																				BgL_arg4539z00_5426;
																																																			obj_t
																																																				BgL_arg4540z00_5427;
																																																			BgL_arg4538z00_5425
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd256707zd2_5422));
																																																			BgL_arg4539z00_5426
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd256707zd2_5422));
																																																			BgL_arg4540z00_5427
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_27901;
																																																				{
																																																					obj_t
																																																						BgL_argsz00_27904;
																																																					obj_t
																																																						BgL_bodyz00_27903;
																																																					obj_t
																																																						BgL_varsz00_27902;
																																																					BgL_varsz00_27902
																																																						=
																																																						BgL_arg4538z00_5425;
																																																					BgL_bodyz00_27903
																																																						=
																																																						BgL_arg4539z00_5426;
																																																					BgL_argsz00_27904
																																																						=
																																																						BgL_arg4540z00_5427;
																																																					BgL_argsz00_1739
																																																						=
																																																						BgL_argsz00_27904;
																																																					BgL_bodyz00_1738
																																																						=
																																																						BgL_bodyz00_27903;
																																																					BgL_varsz00_1737
																																																						=
																																																						BgL_varsz00_27902;
																																																					goto
																																																						BgL_tagzd2386zd2_1740;
																																																				}
																																																				BgL_auxz00_27628
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_27901);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_cdrzd256730zd2_5429;
																																																			BgL_cdrzd256730zd2_5429
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_cdrzd256736zd2_5430;
																																																				BgL_cdrzd256736zd2_5430
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_carzd256702zd2_5421));
																																																				if ((CAR(((obj_t) BgL_carzd256702zd2_5421)) == CNST_TABLE_REF(((long) 1))))
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_cdrzd256742zd2_5433;
																																																						BgL_cdrzd256742zd2_5433
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_cdrzd256736zd2_5430));
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_carzd256747zd2_5434;
																																																							obj_t
																																																								BgL_cdrzd256748zd2_5435;
																																																							BgL_carzd256747zd2_5434
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd256742zd2_5433));
																																																							BgL_cdrzd256748zd2_5435
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd256742zd2_5433));
																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd256747zd2_5434))
																																																								{	/* Ast/sexp.scm 118 */
																																																									if (PAIRP(BgL_cdrzd256748zd2_5435))
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_carzd256755zd2_5438;
																																																											BgL_carzd256755zd2_5438
																																																												=
																																																												CAR
																																																												(BgL_cdrzd256748zd2_5435);
																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd256755zd2_5438))
																																																												{	/* Ast/sexp.scm 118 */
																																																													if (NULLP(CDR(BgL_cdrzd256748zd2_5435)))
																																																														{	/* Ast/sexp.scm 118 */
																																																															bool_t
																																																																BgL_test10277z00_27931;
																																																															{
																																																																obj_t
																																																																	BgL_l1463z00_5471;
																																																																BgL_l1463z00_5471
																																																																	=
																																																																	BgL_cdrzd256730zd2_5429;
																																																															BgL_zc3z04anonymousza34563ze3z87_5472:
																																																																if (NULLP(BgL_l1463z00_5471))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		BgL_test10277z00_27931
																																																																			=
																																																																			(
																																																																			(bool_t)
																																																																			1);
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		bool_t
																																																																			BgL_test10279z00_27934;
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			bool_t
																																																																				BgL_test10280z00_27935;
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_tmpz00_27936;
																																																																				BgL_tmpz00_27936
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_l1463z00_5471));
																																																																				BgL_test10280z00_27935
																																																																					=
																																																																					PAIRP
																																																																					(BgL_tmpz00_27936);
																																																																			}
																																																																			if (BgL_test10280z00_27935)
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					BgL_test10279z00_27934
																																																																						=
																																																																						(
																																																																						(bool_t)
																																																																						0);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					BgL_test10279z00_27934
																																																																						=
																																																																						(
																																																																						(bool_t)
																																																																						1);
																																																																				}
																																																																		}
																																																																		if (BgL_test10279z00_27934)
																																																																			{
																																																																				obj_t
																																																																					BgL_l1463z00_27940;
																																																																				BgL_l1463z00_27940
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_l1463z00_5471));
																																																																				BgL_l1463z00_5471
																																																																					=
																																																																					BgL_l1463z00_27940;
																																																																				goto
																																																																					BgL_zc3z04anonymousza34563ze3z87_5472;
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				BgL_test10277z00_27931
																																																																					=
																																																																					(
																																																																					(bool_t)
																																																																					0);
																																																																			}
																																																																	}
																																																															}
																																																															if (BgL_test10277z00_27931)
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_arg4553z00_5454;
																																																																	BgL_arg4553z00_5454
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd256736zd2_5430));
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_27945;
																																																																		{
																																																																			obj_t
																																																																				BgL_argsz00_27949;
																																																																			obj_t
																																																																				BgL_proc2z00_27948;
																																																																			obj_t
																																																																				BgL_proc1z00_27947;
																																																																			obj_t
																																																																				BgL_testz00_27946;
																																																																			BgL_testz00_27946
																																																																				=
																																																																				BgL_arg4553z00_5454;
																																																																			BgL_proc1z00_27947
																																																																				=
																																																																				BgL_carzd256747zd2_5434;
																																																																			BgL_proc2z00_27948
																																																																				=
																																																																				BgL_carzd256755zd2_5438;
																																																																			BgL_argsz00_27949
																																																																				=
																																																																				BgL_cdrzd256730zd2_5429;
																																																																			BgL_argsz00_1744
																																																																				=
																																																																				BgL_argsz00_27949;
																																																																			BgL_proc2z00_1743
																																																																				=
																																																																				BgL_proc2z00_27948;
																																																																			BgL_proc1z00_1742
																																																																				=
																																																																				BgL_proc1z00_27947;
																																																																			BgL_testz00_1741
																																																																				=
																																																																				BgL_testz00_27946;
																																																																			goto
																																																																				BgL_tagzd2387zd2_1745;
																																																																		}
																																																																		BgL_auxz00_27628
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_27945);
																																																																	}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd256779zd2_5455;
																																																																	BgL_cdrzd256779zd2_5455
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_expz00_21));
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_cdrzd256786zd2_5456;
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_pairz00_13201;
																																																																			BgL_pairz00_13201
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_expz00_21));
																																																																			BgL_cdrzd256786zd2_5456
																																																																				=
																																																																				CDR
																																																																				(BgL_pairz00_13201);
																																																																		}
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_cdrzd256793zd2_5457;
																																																																			BgL_cdrzd256793zd2_5457
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd256786zd2_5456));
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_carzd256799zd2_5458;
																																																																				BgL_carzd256799zd2_5458
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd256793zd2_5457));
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd256799zd2_5458))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_carzd256806zd2_5460;
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_pairz00_13205;
																																																																							BgL_pairz00_13205
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd256793zd2_5457));
																																																																							BgL_carzd256806zd2_5460
																																																																								=
																																																																								CAR
																																																																								(BgL_pairz00_13205);
																																																																						}
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd256806zd2_5460))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd256779zd2_5455))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_arg4557z00_5463;
																																																																										BgL_arg4557z00_5463
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd256786zd2_5456));
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_27971;
																																																																											{
																																																																												obj_t
																																																																													BgL_argsz00_27975;
																																																																												obj_t
																																																																													BgL_proc2z00_27974;
																																																																												obj_t
																																																																													BgL_proc1z00_27973;
																																																																												obj_t
																																																																													BgL_testz00_27972;
																																																																												BgL_testz00_27972
																																																																													=
																																																																													BgL_arg4557z00_5463;
																																																																												BgL_proc1z00_27973
																																																																													=
																																																																													BgL_carzd256799zd2_5458;
																																																																												BgL_proc2z00_27974
																																																																													=
																																																																													BgL_carzd256806zd2_5460;
																																																																												BgL_argsz00_27975
																																																																													=
																																																																													BgL_cdrzd256779zd2_5455;
																																																																												BgL_argsz00_1749
																																																																													=
																																																																													BgL_argsz00_27975;
																																																																												BgL_proc2z00_1748
																																																																													=
																																																																													BgL_proc2z00_27974;
																																																																												BgL_proc1z00_1747
																																																																													=
																																																																													BgL_proc1z00_27973;
																																																																												BgL_testz00_1746
																																																																													=
																																																																													BgL_testz00_27972;
																																																																												goto
																																																																													BgL_tagzd2388zd2_1750;
																																																																											}
																																																																											BgL_auxz00_27628
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_27971);
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1774;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_27979;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1775;
																																																																												BgL_auxz00_27628
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_27979);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1774;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_27983;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1775;
																																																																										BgL_auxz00_27628
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_27983);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1774;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_27987;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1775;
																																																																								BgL_auxz00_27628
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_27987);
																																																																							}
																																																																					}
																																																																			}
																																																																		}
																																																																	}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1774;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_27991;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1775;
																																																																	BgL_auxz00_27628
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_27991);
																																																																}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_cdrzd257082zd2_5482;
																																																													BgL_cdrzd257082zd2_5482
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_cdrzd257088zd2_5483;
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_pairz00_13209;
																																																															BgL_pairz00_13209
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															BgL_cdrzd257088zd2_5483
																																																																=
																																																																CDR
																																																																(BgL_pairz00_13209);
																																																														}
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_cdrzd257094zd2_5484;
																																																															BgL_cdrzd257094zd2_5484
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd257088zd2_5483));
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_carzd257099zd2_5485;
																																																																obj_t
																																																																	BgL_cdrzd257100zd2_5486;
																																																																BgL_carzd257099zd2_5485
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd257094zd2_5484));
																																																																BgL_cdrzd257100zd2_5486
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd257094zd2_5484));
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd257099zd2_5485))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_carzd257105zd2_5488;
																																																																		BgL_carzd257105zd2_5488
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd257100zd2_5486));
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd257105zd2_5488))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (NULLP(CDR(((obj_t) BgL_cdrzd257100zd2_5486))))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd257082zd2_5482))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_arg4572z00_5493;
																																																																								BgL_arg4572z00_5493
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd257088zd2_5483));
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_28018;
																																																																									{
																																																																										obj_t
																																																																											BgL_argsz00_28022;
																																																																										obj_t
																																																																											BgL_proc2z00_28021;
																																																																										obj_t
																																																																											BgL_proc1z00_28020;
																																																																										obj_t
																																																																											BgL_testz00_28019;
																																																																										BgL_testz00_28019
																																																																											=
																																																																											BgL_arg4572z00_5493;
																																																																										BgL_proc1z00_28020
																																																																											=
																																																																											BgL_carzd257099zd2_5485;
																																																																										BgL_proc2z00_28021
																																																																											=
																																																																											BgL_carzd257105zd2_5488;
																																																																										BgL_argsz00_28022
																																																																											=
																																																																											BgL_cdrzd257082zd2_5482;
																																																																										BgL_argsz00_1749
																																																																											=
																																																																											BgL_argsz00_28022;
																																																																										BgL_proc2z00_1748
																																																																											=
																																																																											BgL_proc2z00_28021;
																																																																										BgL_proc1z00_1747
																																																																											=
																																																																											BgL_proc1z00_28020;
																																																																										BgL_testz00_1746
																																																																											=
																																																																											BgL_testz00_28019;
																																																																										goto
																																																																											BgL_tagzd2388zd2_1750;
																																																																									}
																																																																									BgL_auxz00_27628
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_28018);
																																																																								}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1774;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_28026;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1775;
																																																																										BgL_auxz00_27628
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_28026);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1774;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_28030;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1775;
																																																																								BgL_auxz00_27628
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_28030);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1774;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_28034;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1775;
																																																																						BgL_auxz00_27628
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_28034);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1774;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_28038;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1775;
																																																																				BgL_auxz00_27628
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_28038);
																																																																			}
																																																																	}
																																																															}
																																																														}
																																																													}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{	/* Ast/sexp.scm 118 */
																																																													goto
																																																														BgL_tagzd2403zd2_1774;
																																																												}
																																																											else
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_28042;
																																																													goto
																																																														BgL_tagzd2404zd2_1775;
																																																													BgL_auxz00_27628
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_28042);
																																																												}
																																																										}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_cdrzd257438zd2_5501;
																																																									BgL_cdrzd257438zd2_5501
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_cdrzd257445zd2_5502;
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_pairz00_13219;
																																																											BgL_pairz00_13219
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											BgL_cdrzd257445zd2_5502
																																																												=
																																																												CDR
																																																												(BgL_pairz00_13219);
																																																										}
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_cdrzd257452zd2_5503;
																																																											BgL_cdrzd257452zd2_5503
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd257445zd2_5502));
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_carzd257458zd2_5504;
																																																												obj_t
																																																													BgL_cdrzd257459zd2_5505;
																																																												BgL_carzd257458zd2_5504
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_cdrzd257452zd2_5503));
																																																												BgL_cdrzd257459zd2_5505
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_cdrzd257452zd2_5503));
																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd257458zd2_5504))
																																																													{	/* Ast/sexp.scm 118 */
																																																														if (PAIRP(BgL_cdrzd257459zd2_5505))
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_carzd257466zd2_5508;
																																																																BgL_carzd257466zd2_5508
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd257459zd2_5505);
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd257466zd2_5508))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (NULLP(CDR(BgL_cdrzd257459zd2_5505)))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd257438zd2_5501))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_arg4586z00_5513;
																																																																						BgL_arg4586z00_5513
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd257445zd2_5502));
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_28069;
																																																																							{
																																																																								obj_t
																																																																									BgL_argsz00_28073;
																																																																								obj_t
																																																																									BgL_proc2z00_28072;
																																																																								obj_t
																																																																									BgL_proc1z00_28071;
																																																																								obj_t
																																																																									BgL_testz00_28070;
																																																																								BgL_testz00_28070
																																																																									=
																																																																									BgL_arg4586z00_5513;
																																																																								BgL_proc1z00_28071
																																																																									=
																																																																									BgL_carzd257458zd2_5504;
																																																																								BgL_proc2z00_28072
																																																																									=
																																																																									BgL_carzd257466zd2_5508;
																																																																								BgL_argsz00_28073
																																																																									=
																																																																									BgL_cdrzd257438zd2_5501;
																																																																								BgL_argsz00_1749
																																																																									=
																																																																									BgL_argsz00_28073;
																																																																								BgL_proc2z00_1748
																																																																									=
																																																																									BgL_proc2z00_28072;
																																																																								BgL_proc1z00_1747
																																																																									=
																																																																									BgL_proc1z00_28071;
																																																																								BgL_testz00_1746
																																																																									=
																																																																									BgL_testz00_28070;
																																																																								goto
																																																																									BgL_tagzd2388zd2_1750;
																																																																							}
																																																																							BgL_auxz00_27628
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_28069);
																																																																						}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1774;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_28077;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1775;
																																																																								BgL_auxz00_27628
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_28077);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1774;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_28081;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1775;
																																																																						BgL_auxz00_27628
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_28081);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1774;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_28085;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1775;
																																																																				BgL_auxz00_27628
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_28085);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1774;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_28089;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1775;
																																																																		BgL_auxz00_27628
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_28089);
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 118 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 118 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1774;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_28093;
																																																																goto
																																																																	BgL_tagzd2404zd2_1775;
																																																																BgL_auxz00_27628
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_28093);
																																																															}
																																																													}
																																																											}
																																																										}
																																																									}
																																																								}
																																																						}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 118 */
																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																							{	/* Ast/sexp.scm 118 */
																																																								goto
																																																									BgL_tagzd2403zd2_1774;
																																																							}
																																																						else
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_28097;
																																																								goto
																																																									BgL_tagzd2404zd2_1775;
																																																								BgL_auxz00_27628
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_28097);
																																																							}
																																																					}
																																																			}
																																																		}
																																																}
																																															}
																																													}
																																											}
																																										}
																																									}
																																							}
																																						else
																																							{	/* Ast/sexp.scm 118 */
																																								obj_t
																																									BgL_cdrzd257858zd2_5636;
																																								BgL_cdrzd257858zd2_5636
																																									=
																																									CDR
																																									(
																																									((obj_t) BgL_expz00_21));
																																								{

																																									{	/* Ast/sexp.scm 118 */
																																										bool_t
																																											BgL_test10308z00_28101;
																																										{	/* Ast/sexp.scm 118 */
																																											obj_t
																																												BgL_arg4679z00_5652;
																																											BgL_arg4679z00_5652
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_expz00_21));
																																											BgL_test10308z00_28101
																																												=
																																												CBOOL
																																												(BGl_letzd2symzf3z21zzast_letz00
																																												(BgL_arg4679z00_5652));
																																										}
																																										if (BgL_test10308z00_28101)
																																											{	/* Ast/sexp.scm 118 */
																																												if (PAIRP(BgL_cdrzd257858zd2_5636))
																																													{	/* Ast/sexp.scm 118 */
																																														obj_t
																																															BgL_arg4681z00_5654;
																																														obj_t
																																															BgL_arg4682z00_5655;
																																														BgL_arg4681z00_5654
																																															=
																																															CAR
																																															(BgL_cdrzd257858zd2_5636);
																																														BgL_arg4682z00_5655
																																															=
																																															CDR
																																															(BgL_cdrzd257858zd2_5636);
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_28110;
																																															{
																																																obj_t
																																																	BgL_exprz00_28112;
																																																obj_t
																																																	BgL_bindingsz00_28111;
																																																BgL_bindingsz00_28111
																																																	=
																																																	BgL_arg4681z00_5654;
																																																BgL_exprz00_28112
																																																	=
																																																	BgL_arg4682z00_5655;
																																																BgL_exprz00_1729
																																																	=
																																																	BgL_exprz00_28112;
																																																BgL_bindingsz00_1728
																																																	=
																																																	BgL_bindingsz00_28111;
																																																goto
																																																	BgL_tagzd2382zd2_1730;
																																															}
																																															BgL_auxz00_27628
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_28110);
																																														}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														bool_t
																																															BgL_test10310z00_28114;
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_arg4692z00_5667;
																																															BgL_arg4692z00_5667
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															BgL_test10310z00_28114
																																																=
																																																CBOOL
																																																(BGl_labelszd2symzf3z21zzast_labelsz00
																																																(BgL_arg4692z00_5667));
																																														}
																																														if (BgL_test10310z00_28114)
																																															{
																																																BgL_letzd2funzd2_bglt
																																																	BgL_auxz00_28119;
																																																goto
																																																	BgL_tagzd2384zd2_1732;
																																																BgL_auxz00_27628
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_28119);
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_carzd257921zd2_5658;
																																																BgL_carzd257921zd2_5658
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_cdrzd257926zd2_5659;
																																																	BgL_cdrzd257926zd2_5659
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_carzd257921zd2_5658));
																																																	if ((CAR(((obj_t) BgL_carzd257921zd2_5658)) == CNST_TABLE_REF(((long) 3))))
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_arg4687z00_5662;
																																																			obj_t
																																																				BgL_arg4688z00_5663;
																																																			obj_t
																																																				BgL_arg4689z00_5664;
																																																			BgL_arg4687z00_5662
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd257926zd2_5659));
																																																			BgL_arg4688z00_5663
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd257926zd2_5659));
																																																			BgL_arg4689z00_5664
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_28136;
																																																				{
																																																					obj_t
																																																						BgL_argsz00_28139;
																																																					obj_t
																																																						BgL_bodyz00_28138;
																																																					obj_t
																																																						BgL_varsz00_28137;
																																																					BgL_varsz00_28137
																																																						=
																																																						BgL_arg4687z00_5662;
																																																					BgL_bodyz00_28138
																																																						=
																																																						BgL_arg4688z00_5663;
																																																					BgL_argsz00_28139
																																																						=
																																																						BgL_arg4689z00_5664;
																																																					BgL_argsz00_1739
																																																						=
																																																						BgL_argsz00_28139;
																																																					BgL_bodyz00_1738
																																																						=
																																																						BgL_bodyz00_28138;
																																																					BgL_varsz00_1737
																																																						=
																																																						BgL_varsz00_28137;
																																																					goto
																																																						BgL_tagzd2386zd2_1740;
																																																				}
																																																				BgL_auxz00_27628
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_28136);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																				{	/* Ast/sexp.scm 118 */
																																																					goto
																																																						BgL_tagzd2403zd2_1774;
																																																				}
																																																			else
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_28143;
																																																					goto
																																																						BgL_tagzd2404zd2_1775;
																																																					BgL_auxz00_27628
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_28143);
																																																				}
																																																		}
																																																}
																																															}
																																													}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 118 */
																																												bool_t
																																													BgL_test10313z00_28145;
																																												{	/* Ast/sexp.scm 118 */
																																													obj_t
																																														BgL_arg4678z00_5651;
																																													BgL_arg4678z00_5651
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													BgL_test10313z00_28145
																																														=
																																														CBOOL
																																														(BGl_labelszd2symzf3z21zzast_labelsz00
																																														(BgL_arg4678z00_5651));
																																												}
																																												if (BgL_test10313z00_28145)
																																													{
																																														BgL_letzd2funzd2_bglt
																																															BgL_auxz00_28150;
																																														goto
																																															BgL_tagzd2384zd2_1732;
																																														BgL_auxz00_27628
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_28150);
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														obj_t
																																															BgL_carzd258075zd2_5642;
																																														BgL_carzd258075zd2_5642
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_cdrzd258080zd2_5643;
																																															BgL_cdrzd258080zd2_5643
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_carzd258075zd2_5642));
																																															if ((CAR(((obj_t) BgL_carzd258075zd2_5642)) == CNST_TABLE_REF(((long) 3))))
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_arg4673z00_5646;
																																																	obj_t
																																																		BgL_arg4674z00_5647;
																																																	obj_t
																																																		BgL_arg4675z00_5648;
																																																	BgL_arg4673z00_5646
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd258080zd2_5643));
																																																	BgL_arg4674z00_5647
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd258080zd2_5643));
																																																	BgL_arg4675z00_5648
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_28167;
																																																		{
																																																			obj_t
																																																				BgL_argsz00_28170;
																																																			obj_t
																																																				BgL_bodyz00_28169;
																																																			obj_t
																																																				BgL_varsz00_28168;
																																																			BgL_varsz00_28168
																																																				=
																																																				BgL_arg4673z00_5646;
																																																			BgL_bodyz00_28169
																																																				=
																																																				BgL_arg4674z00_5647;
																																																			BgL_argsz00_28170
																																																				=
																																																				BgL_arg4675z00_5648;
																																																			BgL_argsz00_1739
																																																				=
																																																				BgL_argsz00_28170;
																																																			BgL_bodyz00_1738
																																																				=
																																																				BgL_bodyz00_28169;
																																																			BgL_varsz00_1737
																																																				=
																																																				BgL_varsz00_28168;
																																																			goto
																																																				BgL_tagzd2386zd2_1740;
																																																		}
																																																		BgL_auxz00_27628
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_28167);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																		{	/* Ast/sexp.scm 118 */
																																																			goto
																																																				BgL_tagzd2403zd2_1774;
																																																		}
																																																	else
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_28174;
																																																			goto
																																																				BgL_tagzd2404zd2_1775;
																																																			BgL_auxz00_27628
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_28174);
																																																		}
																																																}
																																														}
																																													}
																																											}
																																									}
																																								}
																																							}
																																					}
																																				else
																																					{	/* Ast/sexp.scm 118 */
																																						obj_t
																																							BgL_cdrzd258190zd2_5668;
																																						BgL_cdrzd258190zd2_5668
																																							=
																																							CDR
																																							(((obj_t) BgL_expz00_21));
																																						{

																																							{	/* Ast/sexp.scm 118 */
																																								bool_t
																																									BgL_test10316z00_28178;
																																								{	/* Ast/sexp.scm 118 */
																																									obj_t
																																										BgL_arg4699z00_5676;
																																									BgL_arg4699z00_5676
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_expz00_21));
																																									BgL_test10316z00_28178
																																										=
																																										CBOOL
																																										(BGl_letzd2symzf3z21zzast_letz00
																																										(BgL_arg4699z00_5676));
																																								}
																																								if (BgL_test10316z00_28178)
																																									{	/* Ast/sexp.scm 118 */
																																										if (PAIRP(BgL_cdrzd258190zd2_5668))
																																											{	/* Ast/sexp.scm 118 */
																																												obj_t
																																													BgL_arg4701z00_5678;
																																												obj_t
																																													BgL_arg4702z00_5679;
																																												BgL_arg4701z00_5678
																																													=
																																													CAR
																																													(BgL_cdrzd258190zd2_5668);
																																												BgL_arg4702z00_5679
																																													=
																																													CDR
																																													(BgL_cdrzd258190zd2_5668);
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_28187;
																																													{
																																														obj_t
																																															BgL_exprz00_28189;
																																														obj_t
																																															BgL_bindingsz00_28188;
																																														BgL_bindingsz00_28188
																																															=
																																															BgL_arg4701z00_5678;
																																														BgL_exprz00_28189
																																															=
																																															BgL_arg4702z00_5679;
																																														BgL_exprz00_1729
																																															=
																																															BgL_exprz00_28189;
																																														BgL_bindingsz00_1728
																																															=
																																															BgL_bindingsz00_28188;
																																														goto
																																															BgL_tagzd2382zd2_1730;
																																													}
																																													BgL_auxz00_27628
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_28187);
																																												}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 118 */
																																												bool_t
																																													BgL_test10318z00_28191;
																																												{	/* Ast/sexp.scm 118 */
																																													obj_t
																																														BgL_arg4706z00_5683;
																																													BgL_arg4706z00_5683
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													BgL_test10318z00_28191
																																														=
																																														CBOOL
																																														(BGl_labelszd2symzf3z21zzast_labelsz00
																																														(BgL_arg4706z00_5683));
																																												}
																																												if (BgL_test10318z00_28191)
																																													{
																																														BgL_letzd2funzd2_bglt
																																															BgL_auxz00_28196;
																																														goto
																																															BgL_tagzd2384zd2_1732;
																																														BgL_auxz00_27628
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_28196);
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																															{	/* Ast/sexp.scm 118 */
																																																goto
																																																	BgL_tagzd2403zd2_1774;
																																															}
																																														else
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_28200;
																																																goto
																																																	BgL_tagzd2404zd2_1775;
																																																BgL_auxz00_27628
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_28200);
																																															}
																																													}
																																											}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 118 */
																																										bool_t
																																											BgL_test10320z00_28202;
																																										{	/* Ast/sexp.scm 118 */
																																											obj_t
																																												BgL_arg4698z00_5675;
																																											BgL_arg4698z00_5675
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_expz00_21));
																																											BgL_test10320z00_28202
																																												=
																																												CBOOL
																																												(BGl_labelszd2symzf3z21zzast_labelsz00
																																												(BgL_arg4698z00_5675));
																																										}
																																										if (BgL_test10320z00_28202)
																																											{
																																												BgL_letzd2funzd2_bglt
																																													BgL_auxz00_28207;
																																												goto
																																													BgL_tagzd2384zd2_1732;
																																												BgL_auxz00_27628
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_28207);
																																											}
																																										else
																																											{	/* Ast/sexp.scm 118 */
																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																													{	/* Ast/sexp.scm 118 */
																																														goto
																																															BgL_tagzd2403zd2_1774;
																																													}
																																												else
																																													{
																																														BgL_nodez00_bglt
																																															BgL_auxz00_28211;
																																														goto
																																															BgL_tagzd2404zd2_1775;
																																														BgL_auxz00_27628
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_28211);
																																													}
																																											}
																																									}
																																							}
																																						}
																																					}
																																				return
																																					(
																																					(BgL_nodez00_bglt)
																																					BgL_auxz00_27628);
																																			}
																																		else
																																			{	/* Ast/sexp.scm 118 */
																																				if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd255414zd2_5105)))
																																					{
																																						obj_t
																																							BgL_auxz00_28217;
																																						goto
																																							BgL_kapzd255416zd2_5107;
																																						return
																																							(
																																							(BgL_nodez00_bglt)
																																							BgL_auxz00_28217);
																																					}
																																				else
																																					{	/* Ast/sexp.scm 118 */
																																						if (
																																							(BgL_carzd255414zd2_5105
																																								==
																																								CNST_TABLE_REF
																																								(((long) 18))))
																																							{
																																								obj_t
																																									BgL_auxz00_28222;
																																								goto
																																									BgL_kapzd255416zd2_5107;
																																								return
																																									(
																																									(BgL_nodez00_bglt)
																																									BgL_auxz00_28222);
																																							}
																																						else
																																							{	/* Ast/sexp.scm 118 */
																																								if ((BgL_carzd255414zd2_5105 == CNST_TABLE_REF(((long) 19))))
																																									{
																																										obj_t
																																											BgL_auxz00_28227;
																																										goto
																																											BgL_kapzd255416zd2_5107;
																																										return
																																											(
																																											(BgL_nodez00_bglt)
																																											BgL_auxz00_28227);
																																									}
																																								else
																																									{	/* Ast/sexp.scm 118 */
																																										if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd255414zd2_5105)))
																																											{
																																												obj_t
																																													BgL_auxz00_28232;
																																												goto
																																													BgL_kapzd255416zd2_5107;
																																												return
																																													(
																																													(BgL_nodez00_bglt)
																																													BgL_auxz00_28232);
																																											}
																																										else
																																											{	/* Ast/sexp.scm 118 */
																																												obj_t
																																													BgL_cdrzd258499zd2_5113;
																																												BgL_cdrzd258499zd2_5113
																																													=
																																													CDR
																																													(BgL_expz00_21);
																																												{

																																													{	/* Ast/sexp.scm 118 */
																																														bool_t
																																															BgL_test10326z00_28235;
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_arg4452z00_5292;
																																															BgL_arg4452z00_5292
																																																=
																																																CAR
																																																(BgL_expz00_21);
																																															BgL_test10326z00_28235
																																																=
																																																CBOOL
																																																(BGl_letzd2symzf3z21zzast_letz00
																																																(BgL_arg4452z00_5292));
																																														}
																																														if (BgL_test10326z00_28235)
																																															{
																																																obj_t
																																																	BgL_auxz00_28239;
																																																if (PAIRP(BgL_cdrzd258499zd2_5113))
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_arg4454z00_5294;
																																																		obj_t
																																																			BgL_arg4455z00_5295;
																																																		BgL_arg4454z00_5294
																																																			=
																																																			CAR
																																																			(BgL_cdrzd258499zd2_5113);
																																																		BgL_arg4455z00_5295
																																																			=
																																																			CDR
																																																			(BgL_cdrzd258499zd2_5113);
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_28244;
																																																			{
																																																				obj_t
																																																					BgL_exprz00_28246;
																																																				obj_t
																																																					BgL_bindingsz00_28245;
																																																				BgL_bindingsz00_28245
																																																					=
																																																					BgL_arg4454z00_5294;
																																																				BgL_exprz00_28246
																																																					=
																																																					BgL_arg4455z00_5295;
																																																				BgL_exprz00_1729
																																																					=
																																																					BgL_exprz00_28246;
																																																				BgL_bindingsz00_1728
																																																					=
																																																					BgL_bindingsz00_28245;
																																																				goto
																																																					BgL_tagzd2382zd2_1730;
																																																			}
																																																			BgL_auxz00_28239
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_28244);
																																																		}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		bool_t
																																																			BgL_test10328z00_28248;
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_arg4525z00_5407;
																																																			BgL_arg4525z00_5407
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			BgL_test10328z00_28248
																																																				=
																																																				CBOOL
																																																				(BGl_labelszd2symzf3z21zzast_labelsz00
																																																				(BgL_arg4525z00_5407));
																																																		}
																																																		if (BgL_test10328z00_28248)
																																																			{
																																																				BgL_letzd2funzd2_bglt
																																																					BgL_auxz00_28253;
																																																				goto
																																																					BgL_tagzd2384zd2_1732;
																																																				BgL_auxz00_28239
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_28253);
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_carzd258562zd2_5298;
																																																				BgL_carzd258562zd2_5298
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_cdrzd258567zd2_5299;
																																																					BgL_cdrzd258567zd2_5299
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_carzd258562zd2_5298));
																																																					if ((CAR(((obj_t) BgL_carzd258562zd2_5298)) == CNST_TABLE_REF(((long) 3))))
																																																						{	/* Ast/sexp.scm 118 */
																																																							if (PAIRP(BgL_cdrzd258567zd2_5299))
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_arg4461z00_5303;
																																																									obj_t
																																																										BgL_arg4462z00_5304;
																																																									obj_t
																																																										BgL_arg4463z00_5305;
																																																									BgL_arg4461z00_5303
																																																										=
																																																										CAR
																																																										(BgL_cdrzd258567zd2_5299);
																																																									BgL_arg4462z00_5304
																																																										=
																																																										CDR
																																																										(BgL_cdrzd258567zd2_5299);
																																																									BgL_arg4463z00_5305
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_28270;
																																																										{
																																																											obj_t
																																																												BgL_argsz00_28273;
																																																											obj_t
																																																												BgL_bodyz00_28272;
																																																											obj_t
																																																												BgL_varsz00_28271;
																																																											BgL_varsz00_28271
																																																												=
																																																												BgL_arg4461z00_5303;
																																																											BgL_bodyz00_28272
																																																												=
																																																												BgL_arg4462z00_5304;
																																																											BgL_argsz00_28273
																																																												=
																																																												BgL_arg4463z00_5305;
																																																											BgL_argsz00_1739
																																																												=
																																																												BgL_argsz00_28273;
																																																											BgL_bodyz00_1738
																																																												=
																																																												BgL_bodyz00_28272;
																																																											BgL_varsz00_1737
																																																												=
																																																												BgL_varsz00_28271;
																																																											goto
																																																												BgL_tagzd2386zd2_1740;
																																																										}
																																																										BgL_auxz00_28239
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_28270);
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																										{	/* Ast/sexp.scm 118 */
																																																											goto
																																																												BgL_tagzd2403zd2_1774;
																																																										}
																																																									else
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_28277;
																																																											goto
																																																												BgL_tagzd2404zd2_1775;
																																																											BgL_auxz00_28239
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_28277);
																																																										}
																																																								}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_cdrzd258674zd2_5308;
																																																							BgL_cdrzd258674zd2_5308
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_cdrzd258679zd2_5309;
																																																								BgL_cdrzd258679zd2_5309
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_carzd258562zd2_5298));
																																																								if ((CAR(((obj_t) BgL_carzd258562zd2_5298)) == CNST_TABLE_REF(((long) 1))))
																																																									{	/* Ast/sexp.scm 118 */
																																																										if (PAIRP(BgL_cdrzd258679zd2_5309))
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_cdrzd258684zd2_5313;
																																																												BgL_cdrzd258684zd2_5313
																																																													=
																																																													CDR
																																																													(BgL_cdrzd258679zd2_5309);
																																																												if (PAIRP(BgL_cdrzd258684zd2_5313))
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_carzd258688zd2_5315;
																																																														obj_t
																																																															BgL_cdrzd258689zd2_5316;
																																																														BgL_carzd258688zd2_5315
																																																															=
																																																															CAR
																																																															(BgL_cdrzd258684zd2_5313);
																																																														BgL_cdrzd258689zd2_5316
																																																															=
																																																															CDR
																																																															(BgL_cdrzd258684zd2_5313);
																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd258688zd2_5315))
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (PAIRP(BgL_cdrzd258689zd2_5316))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_carzd258694zd2_5319;
																																																																		BgL_carzd258694zd2_5319
																																																																			=
																																																																			CAR
																																																																			(BgL_cdrzd258689zd2_5316);
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd258694zd2_5319))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (NULLP(CDR(BgL_cdrzd258689zd2_5316)))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						bool_t
																																																																							BgL_test10339z00_28305;
																																																																						{
																																																																							obj_t
																																																																								BgL_l1466z00_5352;
																																																																							BgL_l1466z00_5352
																																																																								=
																																																																								BgL_cdrzd258674zd2_5308;
																																																																						BgL_zc3z04anonymousza34489ze3z87_5353:
																																																																							if (NULLP(BgL_l1466z00_5352))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									BgL_test10339z00_28305
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										1);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									bool_t
																																																																										BgL_test10341z00_28308;
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										bool_t
																																																																											BgL_test10342z00_28309;
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_tmpz00_28310;
																																																																											BgL_tmpz00_28310
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_l1466z00_5352));
																																																																											BgL_test10342z00_28309
																																																																												=
																																																																												PAIRP
																																																																												(BgL_tmpz00_28310);
																																																																										}
																																																																										if (BgL_test10342z00_28309)
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												BgL_test10341z00_28308
																																																																													=
																																																																													(
																																																																													(bool_t)
																																																																													0);
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												BgL_test10341z00_28308
																																																																													=
																																																																													(
																																																																													(bool_t)
																																																																													1);
																																																																											}
																																																																									}
																																																																									if (BgL_test10341z00_28308)
																																																																										{
																																																																											obj_t
																																																																												BgL_l1466z00_28314;
																																																																											BgL_l1466z00_28314
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_l1466z00_5352));
																																																																											BgL_l1466z00_5352
																																																																												=
																																																																												BgL_l1466z00_28314;
																																																																											goto
																																																																												BgL_zc3z04anonymousza34489ze3z87_5353;
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											BgL_test10339z00_28305
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												0);
																																																																										}
																																																																								}
																																																																						}
																																																																						if (BgL_test10339z00_28305)
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_arg4479z00_5335;
																																																																								BgL_arg4479z00_5335
																																																																									=
																																																																									CAR
																																																																									(BgL_cdrzd258679zd2_5309);
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_28318;
																																																																									{
																																																																										obj_t
																																																																											BgL_argsz00_28322;
																																																																										obj_t
																																																																											BgL_proc2z00_28321;
																																																																										obj_t
																																																																											BgL_proc1z00_28320;
																																																																										obj_t
																																																																											BgL_testz00_28319;
																																																																										BgL_testz00_28319
																																																																											=
																																																																											BgL_arg4479z00_5335;
																																																																										BgL_proc1z00_28320
																																																																											=
																																																																											BgL_carzd258688zd2_5315;
																																																																										BgL_proc2z00_28321
																																																																											=
																																																																											BgL_carzd258694zd2_5319;
																																																																										BgL_argsz00_28322
																																																																											=
																																																																											BgL_cdrzd258674zd2_5308;
																																																																										BgL_argsz00_1744
																																																																											=
																																																																											BgL_argsz00_28322;
																																																																										BgL_proc2z00_1743
																																																																											=
																																																																											BgL_proc2z00_28321;
																																																																										BgL_proc1z00_1742
																																																																											=
																																																																											BgL_proc1z00_28320;
																																																																										BgL_testz00_1741
																																																																											=
																																																																											BgL_testz00_28319;
																																																																										goto
																																																																											BgL_tagzd2387zd2_1745;
																																																																									}
																																																																									BgL_auxz00_28239
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_28318);
																																																																								}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_cdrzd258719zd2_5336;
																																																																								BgL_cdrzd258719zd2_5336
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_cdrzd258727zd2_5337;
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_pairz00_13286;
																																																																										BgL_pairz00_13286
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										BgL_cdrzd258727zd2_5337
																																																																											=
																																																																											CDR
																																																																											(BgL_pairz00_13286);
																																																																									}
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_cdrzd258735zd2_5338;
																																																																										BgL_cdrzd258735zd2_5338
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd258727zd2_5337));
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_carzd258742zd2_5339;
																																																																											BgL_carzd258742zd2_5339
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd258735zd2_5338));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd258742zd2_5339))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_carzd258751zd2_5341;
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_pairz00_13290;
																																																																														BgL_pairz00_13290
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd258735zd2_5338));
																																																																														BgL_carzd258751zd2_5341
																																																																															=
																																																																															CAR
																																																																															(BgL_pairz00_13290);
																																																																													}
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd258751zd2_5341))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd258719zd2_5336))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_arg4483z00_5344;
																																																																																	BgL_arg4483z00_5344
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd258727zd2_5337));
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_28344;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_28348;
																																																																																			obj_t
																																																																																				BgL_proc2z00_28347;
																																																																																			obj_t
																																																																																				BgL_proc1z00_28346;
																																																																																			obj_t
																																																																																				BgL_testz00_28345;
																																																																																			BgL_testz00_28345
																																																																																				=
																																																																																				BgL_arg4483z00_5344;
																																																																																			BgL_proc1z00_28346
																																																																																				=
																																																																																				BgL_carzd258742zd2_5339;
																																																																																			BgL_proc2z00_28347
																																																																																				=
																																																																																				BgL_carzd258751zd2_5341;
																																																																																			BgL_argsz00_28348
																																																																																				=
																																																																																				BgL_cdrzd258719zd2_5336;
																																																																																			BgL_argsz00_1749
																																																																																				=
																																																																																				BgL_argsz00_28348;
																																																																																			BgL_proc2z00_1748
																																																																																				=
																																																																																				BgL_proc2z00_28347;
																																																																																			BgL_proc1z00_1747
																																																																																				=
																																																																																				BgL_proc1z00_28346;
																																																																																			BgL_testz00_1746
																																																																																				=
																																																																																				BgL_testz00_28345;
																																																																																			goto
																																																																																				BgL_tagzd2388zd2_1750;
																																																																																		}
																																																																																		BgL_auxz00_28239
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_28344);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1774;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_28352;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1775;
																																																																																			BgL_auxz00_28239
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_28352);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1774;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_28356;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1775;
																																																																																	BgL_auxz00_28239
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_28356);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1774;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_28360;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1775;
																																																																															BgL_auxz00_28239
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_28360);
																																																																														}
																																																																												}
																																																																										}
																																																																									}
																																																																								}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1774;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_28364;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1775;
																																																																								BgL_auxz00_28239
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_28364);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_cdrzd259029zd2_5363;
																																																																				BgL_cdrzd259029zd2_5363
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_cdrzd259036zd2_5364;
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_pairz00_13294;
																																																																						BgL_pairz00_13294
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						BgL_cdrzd259036zd2_5364
																																																																							=
																																																																							CDR
																																																																							(BgL_pairz00_13294);
																																																																					}
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_cdrzd259043zd2_5365;
																																																																						BgL_cdrzd259043zd2_5365
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd259036zd2_5364));
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_carzd259049zd2_5366;
																																																																							obj_t
																																																																								BgL_cdrzd259050zd2_5367;
																																																																							BgL_carzd259049zd2_5366
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd259043zd2_5365));
																																																																							BgL_cdrzd259050zd2_5367
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd259043zd2_5365));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd259049zd2_5366))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_carzd259057zd2_5369;
																																																																									BgL_carzd259057zd2_5369
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd259050zd2_5367));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd259057zd2_5369))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (NULLP(CDR(((obj_t) BgL_cdrzd259050zd2_5367))))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd259029zd2_5363))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_arg4498z00_5374;
																																																																															BgL_arg4498z00_5374
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd259036zd2_5364));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_28391;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_28395;
																																																																																	obj_t
																																																																																		BgL_proc2z00_28394;
																																																																																	obj_t
																																																																																		BgL_proc1z00_28393;
																																																																																	obj_t
																																																																																		BgL_testz00_28392;
																																																																																	BgL_testz00_28392
																																																																																		=
																																																																																		BgL_arg4498z00_5374;
																																																																																	BgL_proc1z00_28393
																																																																																		=
																																																																																		BgL_carzd259049zd2_5366;
																																																																																	BgL_proc2z00_28394
																																																																																		=
																																																																																		BgL_carzd259057zd2_5369;
																																																																																	BgL_argsz00_28395
																																																																																		=
																																																																																		BgL_cdrzd259029zd2_5363;
																																																																																	BgL_argsz00_1749
																																																																																		=
																																																																																		BgL_argsz00_28395;
																																																																																	BgL_proc2z00_1748
																																																																																		=
																																																																																		BgL_proc2z00_28394;
																																																																																	BgL_proc1z00_1747
																																																																																		=
																																																																																		BgL_proc1z00_28393;
																																																																																	BgL_testz00_1746
																																																																																		=
																																																																																		BgL_testz00_28392;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1750;
																																																																																}
																																																																																BgL_auxz00_28239
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_28391);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1774;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_28399;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1775;
																																																																																	BgL_auxz00_28239
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_28399);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1774;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_28403;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1775;
																																																																															BgL_auxz00_28239
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_28403);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1774;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_28407;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1775;
																																																																													BgL_auxz00_28239
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_28407);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1774;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_28411;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1775;
																																																																											BgL_auxz00_28239
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_28411);
																																																																										}
																																																																								}
																																																																						}
																																																																					}
																																																																				}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1774;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_28415;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1775;
																																																																				BgL_auxz00_28239
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_28415);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_cdrzd259390zd2_5382;
																																																																BgL_cdrzd259390zd2_5382
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd259396zd2_5383;
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_pairz00_13304;
																																																																		BgL_pairz00_13304
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		BgL_cdrzd259396zd2_5383
																																																																			=
																																																																			CDR
																																																																			(BgL_pairz00_13304);
																																																																	}
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_cdrzd259402zd2_5384;
																																																																		BgL_cdrzd259402zd2_5384
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd259396zd2_5383));
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_carzd259407zd2_5385;
																																																																			obj_t
																																																																				BgL_cdrzd259408zd2_5386;
																																																																			BgL_carzd259407zd2_5385
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd259402zd2_5384));
																																																																			BgL_cdrzd259408zd2_5386
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd259402zd2_5384));
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd259407zd2_5385))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (PAIRP(BgL_cdrzd259408zd2_5386))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_carzd259413zd2_5389;
																																																																							BgL_carzd259413zd2_5389
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd259408zd2_5386);
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd259413zd2_5389))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (NULLP(CDR(BgL_cdrzd259408zd2_5386)))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd259390zd2_5382))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_arg4512z00_5394;
																																																																													BgL_arg4512z00_5394
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd259396zd2_5383));
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_28442;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_28446;
																																																																															obj_t
																																																																																BgL_proc2z00_28445;
																																																																															obj_t
																																																																																BgL_proc1z00_28444;
																																																																															obj_t
																																																																																BgL_testz00_28443;
																																																																															BgL_testz00_28443
																																																																																=
																																																																																BgL_arg4512z00_5394;
																																																																															BgL_proc1z00_28444
																																																																																=
																																																																																BgL_carzd259407zd2_5385;
																																																																															BgL_proc2z00_28445
																																																																																=
																																																																																BgL_carzd259413zd2_5389;
																																																																															BgL_argsz00_28446
																																																																																=
																																																																																BgL_cdrzd259390zd2_5382;
																																																																															BgL_argsz00_1749
																																																																																=
																																																																																BgL_argsz00_28446;
																																																																															BgL_proc2z00_1748
																																																																																=
																																																																																BgL_proc2z00_28445;
																																																																															BgL_proc1z00_1747
																																																																																=
																																																																																BgL_proc1z00_28444;
																																																																															BgL_testz00_1746
																																																																																=
																																																																																BgL_testz00_28443;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1750;
																																																																														}
																																																																														BgL_auxz00_28239
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_28442);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1774;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_28450;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1775;
																																																																															BgL_auxz00_28239
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_28450);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1774;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_28454;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1775;
																																																																													BgL_auxz00_28239
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_28454);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1774;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_28458;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1775;
																																																																											BgL_auxz00_28239
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_28458);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1774;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_28462;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1775;
																																																																									BgL_auxz00_28239
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_28462);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1774;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_28466;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1775;
																																																																							BgL_auxz00_28239
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_28466);
																																																																						}
																																																																				}
																																																																		}
																																																																	}
																																																																}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 118 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 118 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1774;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_28470;
																																																																goto
																																																																	BgL_tagzd2404zd2_1775;
																																																																BgL_auxz00_28239
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_28470);
																																																															}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 118 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{	/* Ast/sexp.scm 118 */
																																																														goto
																																																															BgL_tagzd2403zd2_1774;
																																																													}
																																																												else
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_28474;
																																																														goto
																																																															BgL_tagzd2404zd2_1775;
																																																														BgL_auxz00_28239
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_28474);
																																																													}
																																																											}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 118 */
																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																											{	/* Ast/sexp.scm 118 */
																																																												goto
																																																													BgL_tagzd2403zd2_1774;
																																																											}
																																																										else
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_28478;
																																																												goto
																																																													BgL_tagzd2404zd2_1775;
																																																												BgL_auxz00_28239
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_28478);
																																																											}
																																																									}
																																																							}
																																																						}
																																																				}
																																																			}
																																																	}
																																																return
																																																	(
																																																	(BgL_nodez00_bglt)
																																																	BgL_auxz00_28239);
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																bool_t
																																																	BgL_test10372z00_28481;
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_arg4451z00_5291;
																																																	BgL_arg4451z00_5291
																																																		=
																																																		CAR
																																																		(BgL_expz00_21);
																																																	BgL_test10372z00_28481
																																																		=
																																																		CBOOL
																																																		(BGl_labelszd2symzf3z21zzast_labelsz00
																																																		(BgL_arg4451z00_5291));
																																																}
																																																if (BgL_test10372z00_28481)
																																																	{
																																																		BgL_letzd2funzd2_bglt
																																																			BgL_auxz00_28485;
																																																		goto
																																																			BgL_tagzd2384zd2_1732;
																																																		return
																																																			(
																																																			(BgL_nodez00_bglt)
																																																			BgL_auxz00_28485);
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_carzd259976zd2_5119;
																																																		obj_t
																																																			BgL_cdrzd259977zd2_5120;
																																																		BgL_carzd259976zd2_5119
																																																			=
																																																			CAR
																																																			(BgL_expz00_21);
																																																		BgL_cdrzd259977zd2_5120
																																																			=
																																																			CDR
																																																			(BgL_expz00_21);
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_cdrzd259981zd2_5121;
																																																			BgL_cdrzd259981zd2_5121
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_carzd259976zd2_5119));
																																																			if ((CAR(((obj_t) BgL_carzd259976zd2_5119)) == CNST_TABLE_REF(((long) 3))))
																																																				{	/* Ast/sexp.scm 118 */
																																																					if (PAIRP(BgL_cdrzd259981zd2_5121))
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_carzd259984zd2_5125;
																																																							obj_t
																																																								BgL_cdrzd259985zd2_5126;
																																																							BgL_carzd259984zd2_5125
																																																								=
																																																								CAR
																																																								(BgL_cdrzd259981zd2_5121);
																																																							BgL_cdrzd259985zd2_5126
																																																								=
																																																								CDR
																																																								(BgL_cdrzd259981zd2_5121);
																																																							if (PAIRP(BgL_carzd259984zd2_5125))
																																																								{	/* Ast/sexp.scm 118 */
																																																									if (NULLP(CDR(BgL_carzd259984zd2_5125)))
																																																										{	/* Ast/sexp.scm 118 */
																																																											if (PAIRP(BgL_cdrzd259985zd2_5126))
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_carzd259991zd2_5131;
																																																													BgL_carzd259991zd2_5131
																																																														=
																																																														CAR
																																																														(BgL_cdrzd259985zd2_5126);
																																																													if (PAIRP(BgL_carzd259991zd2_5131))
																																																														{	/* Ast/sexp.scm 118 */
																																																															if (BGl_castzd2sexpzf3z21zzast_privatez00(BgL_carzd259991zd2_5131))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if (NULLP(CDR(BgL_cdrzd259985zd2_5126)))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if (PAIRP(BgL_cdrzd259977zd2_5120))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_carzd259998zd2_5137;
																																																																					BgL_carzd259998zd2_5137
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd259977zd2_5120);
																																																																					if (PAIRP(BgL_carzd259998zd2_5137))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_cdrzd260022zd2_5139;
																																																																							BgL_cdrzd260022zd2_5139
																																																																								=
																																																																								CDR
																																																																								(CAR
																																																																								(BgL_expz00_21));
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_arg4348z00_5140;
																																																																								obj_t
																																																																									BgL_arg4349z00_5141;
																																																																								obj_t
																																																																									BgL_arg4350z00_5142;
																																																																								BgL_arg4348z00_5140
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd260022zd2_5139));
																																																																								BgL_arg4349z00_5141
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd260022zd2_5139));
																																																																								BgL_arg4350z00_5142
																																																																									=
																																																																									CDR
																																																																									(BgL_expz00_21);
																																																																								{
																																																																									obj_t
																																																																										BgL_argsz00_28529;
																																																																									obj_t
																																																																										BgL_bodyz00_28528;
																																																																									obj_t
																																																																										BgL_varsz00_28527;
																																																																									BgL_varsz00_28527
																																																																										=
																																																																										BgL_arg4348z00_5140;
																																																																									BgL_bodyz00_28528
																																																																										=
																																																																										BgL_arg4349z00_5141;
																																																																									BgL_argsz00_28529
																																																																										=
																																																																										BgL_arg4350z00_5142;
																																																																									BgL_argsz00_1739
																																																																										=
																																																																										BgL_argsz00_28529;
																																																																									BgL_bodyz00_1738
																																																																										=
																																																																										BgL_bodyz00_28528;
																																																																									BgL_varsz00_1737
																																																																										=
																																																																										BgL_varsz00_28527;
																																																																									goto
																																																																										BgL_tagzd2386zd2_1740;
																																																																								}
																																																																							}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (NULLP(CDR(BgL_cdrzd259977zd2_5120)))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_arg4354z00_5146;
																																																																									BgL_arg4354z00_5146
																																																																										=
																																																																										CAR
																																																																										(BgL_carzd259984zd2_5125);
																																																																									{
																																																																										BgL_castz00_bglt
																																																																											BgL_auxz00_28534;
																																																																										{
																																																																											obj_t
																																																																												BgL_argz00_28537;
																																																																											obj_t
																																																																												BgL_bodyz00_28536;
																																																																											obj_t
																																																																												BgL_varz00_28535;
																																																																											BgL_varz00_28535
																																																																												=
																																																																												BgL_arg4354z00_5146;
																																																																											BgL_bodyz00_28536
																																																																												=
																																																																												BgL_carzd259991zd2_5131;
																																																																											BgL_argz00_28537
																																																																												=
																																																																												BgL_carzd259998zd2_5137;
																																																																											BgL_argz00_1735
																																																																												=
																																																																												BgL_argz00_28537;
																																																																											BgL_bodyz00_1734
																																																																												=
																																																																												BgL_bodyz00_28536;
																																																																											BgL_varz00_1733
																																																																												=
																																																																												BgL_varz00_28535;
																																																																											goto
																																																																												BgL_tagzd2385zd2_1736;
																																																																										}
																																																																										return
																																																																											(
																																																																											(BgL_nodez00_bglt)
																																																																											BgL_auxz00_28534);
																																																																									}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_cdrzd260049zd2_5147;
																																																																									BgL_cdrzd260049zd2_5147
																																																																										=
																																																																										CDR
																																																																										(CAR
																																																																										(BgL_expz00_21));
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_arg4355z00_5148;
																																																																										obj_t
																																																																											BgL_arg4356z00_5149;
																																																																										obj_t
																																																																											BgL_arg4357z00_5150;
																																																																										BgL_arg4355z00_5148
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd260049zd2_5147));
																																																																										BgL_arg4356z00_5149
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd260049zd2_5147));
																																																																										BgL_arg4357z00_5150
																																																																											=
																																																																											CDR
																																																																											(BgL_expz00_21);
																																																																										{
																																																																											obj_t
																																																																												BgL_argsz00_28548;
																																																																											obj_t
																																																																												BgL_bodyz00_28547;
																																																																											obj_t
																																																																												BgL_varsz00_28546;
																																																																											BgL_varsz00_28546
																																																																												=
																																																																												BgL_arg4355z00_5148;
																																																																											BgL_bodyz00_28547
																																																																												=
																																																																												BgL_arg4356z00_5149;
																																																																											BgL_argsz00_28548
																																																																												=
																																																																												BgL_arg4357z00_5150;
																																																																											BgL_argsz00_1739
																																																																												=
																																																																												BgL_argsz00_28548;
																																																																											BgL_bodyz00_1738
																																																																												=
																																																																												BgL_bodyz00_28547;
																																																																											BgL_varsz00_1737
																																																																												=
																																																																												BgL_varsz00_28546;
																																																																											goto
																																																																												BgL_tagzd2386zd2_1740;
																																																																										}
																																																																									}
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_cdrzd260075zd2_5153;
																																																																					BgL_cdrzd260075zd2_5153
																																																																						=
																																																																						CDR
																																																																						(CAR
																																																																						(BgL_expz00_21));
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_arg4360z00_5154;
																																																																						obj_t
																																																																							BgL_arg4361z00_5155;
																																																																						obj_t
																																																																							BgL_arg4362z00_5156;
																																																																						BgL_arg4360z00_5154
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd260075zd2_5153));
																																																																						BgL_arg4361z00_5155
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd260075zd2_5153));
																																																																						BgL_arg4362z00_5156
																																																																							=
																																																																							CDR
																																																																							(BgL_expz00_21);
																																																																						{
																																																																							obj_t
																																																																								BgL_argsz00_28558;
																																																																							obj_t
																																																																								BgL_bodyz00_28557;
																																																																							obj_t
																																																																								BgL_varsz00_28556;
																																																																							BgL_varsz00_28556
																																																																								=
																																																																								BgL_arg4360z00_5154;
																																																																							BgL_bodyz00_28557
																																																																								=
																																																																								BgL_arg4361z00_5155;
																																																																							BgL_argsz00_28558
																																																																								=
																																																																								BgL_arg4362z00_5156;
																																																																							BgL_argsz00_1739
																																																																								=
																																																																								BgL_argsz00_28558;
																																																																							BgL_bodyz00_1738
																																																																								=
																																																																								BgL_bodyz00_28557;
																																																																							BgL_varsz00_1737
																																																																								=
																																																																								BgL_varsz00_28556;
																																																																							goto
																																																																								BgL_tagzd2386zd2_1740;
																																																																						}
																																																																					}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_cdrzd260101zd2_5158;
																																																																			BgL_cdrzd260101zd2_5158
																																																																				=
																																																																				CDR
																																																																				(CAR
																																																																				(BgL_expz00_21));
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_arg4364z00_5159;
																																																																				obj_t
																																																																					BgL_arg4365z00_5160;
																																																																				obj_t
																																																																					BgL_arg4366z00_5161;
																																																																				BgL_arg4364z00_5159
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd260101zd2_5158));
																																																																				BgL_arg4365z00_5160
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd260101zd2_5158));
																																																																				BgL_arg4366z00_5161
																																																																					=
																																																																					CDR
																																																																					(BgL_expz00_21);
																																																																				{
																																																																					obj_t
																																																																						BgL_argsz00_28568;
																																																																					obj_t
																																																																						BgL_bodyz00_28567;
																																																																					obj_t
																																																																						BgL_varsz00_28566;
																																																																					BgL_varsz00_28566
																																																																						=
																																																																						BgL_arg4364z00_5159;
																																																																					BgL_bodyz00_28567
																																																																						=
																																																																						BgL_arg4365z00_5160;
																																																																					BgL_argsz00_28568
																																																																						=
																																																																						BgL_arg4366z00_5161;
																																																																					BgL_argsz00_1739
																																																																						=
																																																																						BgL_argsz00_28568;
																																																																					BgL_bodyz00_1738
																																																																						=
																																																																						BgL_bodyz00_28567;
																																																																					BgL_varsz00_1737
																																																																						=
																																																																						BgL_varsz00_28566;
																																																																					goto
																																																																						BgL_tagzd2386zd2_1740;
																																																																				}
																																																																			}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd260127zd2_5164;
																																																																	BgL_cdrzd260127zd2_5164
																																																																		=
																																																																		CDR
																																																																		(CAR
																																																																		(BgL_expz00_21));
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_arg4369z00_5165;
																																																																		obj_t
																																																																			BgL_arg4370z00_5166;
																																																																		obj_t
																																																																			BgL_arg4371z00_5167;
																																																																		BgL_arg4369z00_5165
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd260127zd2_5164));
																																																																		BgL_arg4370z00_5166
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd260127zd2_5164));
																																																																		BgL_arg4371z00_5167
																																																																			=
																																																																			CDR
																																																																			(BgL_expz00_21);
																																																																		{
																																																																			obj_t
																																																																				BgL_argsz00_28578;
																																																																			obj_t
																																																																				BgL_bodyz00_28577;
																																																																			obj_t
																																																																				BgL_varsz00_28576;
																																																																			BgL_varsz00_28576
																																																																				=
																																																																				BgL_arg4369z00_5165;
																																																																			BgL_bodyz00_28577
																																																																				=
																																																																				BgL_arg4370z00_5166;
																																																																			BgL_argsz00_28578
																																																																				=
																																																																				BgL_arg4371z00_5167;
																																																																			BgL_argsz00_1739
																																																																				=
																																																																				BgL_argsz00_28578;
																																																																			BgL_bodyz00_1738
																																																																				=
																																																																				BgL_bodyz00_28577;
																																																																			BgL_varsz00_1737
																																																																				=
																																																																				BgL_varsz00_28576;
																																																																			goto
																																																																				BgL_tagzd2386zd2_1740;
																																																																		}
																																																																	}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_cdrzd260153zd2_5169;
																																																															BgL_cdrzd260153zd2_5169
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_carzd259976zd2_5119));
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_arg4373z00_5170;
																																																																obj_t
																																																																	BgL_arg4374z00_5171;
																																																																obj_t
																																																																	BgL_arg4375z00_5172;
																																																																BgL_arg4373z00_5170
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd260153zd2_5169));
																																																																BgL_arg4374z00_5171
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd260153zd2_5169));
																																																																BgL_arg4375z00_5172
																																																																	=
																																																																	CDR
																																																																	(BgL_expz00_21);
																																																																{
																																																																	obj_t
																																																																		BgL_argsz00_28588;
																																																																	obj_t
																																																																		BgL_bodyz00_28587;
																																																																	obj_t
																																																																		BgL_varsz00_28586;
																																																																	BgL_varsz00_28586
																																																																		=
																																																																		BgL_arg4373z00_5170;
																																																																	BgL_bodyz00_28587
																																																																		=
																																																																		BgL_arg4374z00_5171;
																																																																	BgL_argsz00_28588
																																																																		=
																																																																		BgL_arg4375z00_5172;
																																																																	BgL_argsz00_1739
																																																																		=
																																																																		BgL_argsz00_28588;
																																																																	BgL_bodyz00_1738
																																																																		=
																																																																		BgL_bodyz00_28587;
																																																																	BgL_varsz00_1737
																																																																		=
																																																																		BgL_varsz00_28586;
																																																																	goto
																																																																		BgL_tagzd2386zd2_1740;
																																																																}
																																																															}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_cdrzd260179zd2_5174;
																																																													BgL_cdrzd260179zd2_5174
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_carzd259976zd2_5119));
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_arg4377z00_5175;
																																																														obj_t
																																																															BgL_arg4378z00_5176;
																																																														obj_t
																																																															BgL_arg4379z00_5177;
																																																														BgL_arg4377z00_5175
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd260179zd2_5174));
																																																														BgL_arg4378z00_5176
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd260179zd2_5174));
																																																														BgL_arg4379z00_5177
																																																															=
																																																															CDR
																																																															(BgL_expz00_21);
																																																														{
																																																															obj_t
																																																																BgL_argsz00_28598;
																																																															obj_t
																																																																BgL_bodyz00_28597;
																																																															obj_t
																																																																BgL_varsz00_28596;
																																																															BgL_varsz00_28596
																																																																=
																																																																BgL_arg4377z00_5175;
																																																															BgL_bodyz00_28597
																																																																=
																																																																BgL_arg4378z00_5176;
																																																															BgL_argsz00_28598
																																																																=
																																																																BgL_arg4379z00_5177;
																																																															BgL_argsz00_1739
																																																																=
																																																																BgL_argsz00_28598;
																																																															BgL_bodyz00_1738
																																																																=
																																																																BgL_bodyz00_28597;
																																																															BgL_varsz00_1737
																																																																=
																																																																BgL_varsz00_28596;
																																																															goto
																																																																BgL_tagzd2386zd2_1740;
																																																														}
																																																													}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_cdrzd260205zd2_5179;
																																																											BgL_cdrzd260205zd2_5179
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_carzd259976zd2_5119));
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_arg4381z00_5180;
																																																												obj_t
																																																													BgL_arg4382z00_5181;
																																																												obj_t
																																																													BgL_arg4383z00_5182;
																																																												BgL_arg4381z00_5180
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_cdrzd260205zd2_5179));
																																																												BgL_arg4382z00_5181
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_cdrzd260205zd2_5179));
																																																												BgL_arg4383z00_5182
																																																													=
																																																													CDR
																																																													(BgL_expz00_21);
																																																												{
																																																													obj_t
																																																														BgL_argsz00_28608;
																																																													obj_t
																																																														BgL_bodyz00_28607;
																																																													obj_t
																																																														BgL_varsz00_28606;
																																																													BgL_varsz00_28606
																																																														=
																																																														BgL_arg4381z00_5180;
																																																													BgL_bodyz00_28607
																																																														=
																																																														BgL_arg4382z00_5181;
																																																													BgL_argsz00_28608
																																																														=
																																																														BgL_arg4383z00_5182;
																																																													BgL_argsz00_1739
																																																														=
																																																														BgL_argsz00_28608;
																																																													BgL_bodyz00_1738
																																																														=
																																																														BgL_bodyz00_28607;
																																																													BgL_varsz00_1737
																																																														=
																																																														BgL_varsz00_28606;
																																																													goto
																																																														BgL_tagzd2386zd2_1740;
																																																												}
																																																											}
																																																										}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_cdrzd260231zd2_5185;
																																																									BgL_cdrzd260231zd2_5185
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_carzd259976zd2_5119));
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_arg4386z00_5186;
																																																										obj_t
																																																											BgL_arg4387z00_5187;
																																																										obj_t
																																																											BgL_arg4388z00_5188;
																																																										BgL_arg4386z00_5186
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_cdrzd260231zd2_5185));
																																																										BgL_arg4387z00_5187
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_cdrzd260231zd2_5185));
																																																										BgL_arg4388z00_5188
																																																											=
																																																											CDR
																																																											(BgL_expz00_21);
																																																										{
																																																											obj_t
																																																												BgL_argsz00_28618;
																																																											obj_t
																																																												BgL_bodyz00_28617;
																																																											obj_t
																																																												BgL_varsz00_28616;
																																																											BgL_varsz00_28616
																																																												=
																																																												BgL_arg4386z00_5186;
																																																											BgL_bodyz00_28617
																																																												=
																																																												BgL_arg4387z00_5187;
																																																											BgL_argsz00_28618
																																																												=
																																																												BgL_arg4388z00_5188;
																																																											BgL_argsz00_1739
																																																												=
																																																												BgL_argsz00_28618;
																																																											BgL_bodyz00_1738
																																																												=
																																																												BgL_bodyz00_28617;
																																																											BgL_varsz00_1737
																																																												=
																																																												BgL_varsz00_28616;
																																																											goto
																																																												BgL_tagzd2386zd2_1740;
																																																										}
																																																									}
																																																								}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																								{
																																																									obj_t
																																																										BgL_auxz00_28621;
																																																									goto
																																																										BgL_tagzd2403zd2_1774;
																																																									return
																																																										(
																																																										(BgL_nodez00_bglt)
																																																										BgL_auxz00_28621);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									goto
																																																										BgL_tagzd2404zd2_1775;
																																																								}
																																																						}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_cdrzd260369zd2_5193;
																																																					BgL_cdrzd260369zd2_5193
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_carzd259976zd2_5119));
																																																					if ((CAR(((obj_t) BgL_carzd259976zd2_5119)) == CNST_TABLE_REF(((long) 1))))
																																																						{	/* Ast/sexp.scm 118 */
																																																							if (PAIRP(BgL_cdrzd260369zd2_5193))
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_cdrzd260374zd2_5197;
																																																									BgL_cdrzd260374zd2_5197
																																																										=
																																																										CDR
																																																										(BgL_cdrzd260369zd2_5193);
																																																									if (PAIRP(BgL_cdrzd260374zd2_5197))
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_carzd260378zd2_5199;
																																																											obj_t
																																																												BgL_cdrzd260379zd2_5200;
																																																											BgL_carzd260378zd2_5199
																																																												=
																																																												CAR
																																																												(BgL_cdrzd260374zd2_5197);
																																																											BgL_cdrzd260379zd2_5200
																																																												=
																																																												CDR
																																																												(BgL_cdrzd260374zd2_5197);
																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd260378zd2_5199))
																																																												{	/* Ast/sexp.scm 118 */
																																																													if (PAIRP(BgL_cdrzd260379zd2_5200))
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_carzd260384zd2_5203;
																																																															BgL_carzd260384zd2_5203
																																																																=
																																																																CAR
																																																																(BgL_cdrzd260379zd2_5200);
																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd260384zd2_5203))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if (NULLP(CDR(BgL_cdrzd260379zd2_5200)))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			bool_t
																																																																				BgL_test10392z00_28647;
																																																																			{
																																																																				obj_t
																																																																					BgL_l1469z00_5236;
																																																																				BgL_l1469z00_5236
																																																																					=
																																																																					BgL_cdrzd259977zd2_5120;
																																																																			BgL_zc3z04anonymousza34415ze3z87_5237:
																																																																				if (NULLP(BgL_l1469z00_5236))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						BgL_test10392z00_28647
																																																																							=
																																																																							(
																																																																							(bool_t)
																																																																							1);
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						bool_t
																																																																							BgL_test10394z00_28650;
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							bool_t
																																																																								BgL_test10395z00_28651;
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_tmpz00_28652;
																																																																								BgL_tmpz00_28652
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_l1469z00_5236));
																																																																								BgL_test10395z00_28651
																																																																									=
																																																																									PAIRP
																																																																									(BgL_tmpz00_28652);
																																																																							}
																																																																							if (BgL_test10395z00_28651)
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									BgL_test10394z00_28650
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										0);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									BgL_test10394z00_28650
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										1);
																																																																								}
																																																																						}
																																																																						if (BgL_test10394z00_28650)
																																																																							{
																																																																								obj_t
																																																																									BgL_l1469z00_28656;
																																																																								BgL_l1469z00_28656
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_l1469z00_5236));
																																																																								BgL_l1469z00_5236
																																																																									=
																																																																									BgL_l1469z00_28656;
																																																																								goto
																																																																									BgL_zc3z04anonymousza34415ze3z87_5237;
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								BgL_test10392z00_28647
																																																																									=
																																																																									(
																																																																									(bool_t)
																																																																									0);
																																																																							}
																																																																					}
																																																																			}
																																																																			if (BgL_test10392z00_28647)
																																																																				{
																																																																					obj_t
																																																																						BgL_argsz00_28663;
																																																																					obj_t
																																																																						BgL_proc2z00_28662;
																																																																					obj_t
																																																																						BgL_proc1z00_28661;
																																																																					obj_t
																																																																						BgL_testz00_28659;
																																																																					BgL_testz00_28659
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd260369zd2_5193);
																																																																					BgL_proc1z00_28661
																																																																						=
																																																																						BgL_carzd260378zd2_5199;
																																																																					BgL_proc2z00_28662
																																																																						=
																																																																						BgL_carzd260384zd2_5203;
																																																																					BgL_argsz00_28663
																																																																						=
																																																																						BgL_cdrzd259977zd2_5120;
																																																																					BgL_argsz00_1744
																																																																						=
																																																																						BgL_argsz00_28663;
																																																																					BgL_proc2z00_1743
																																																																						=
																																																																						BgL_proc2z00_28662;
																																																																					BgL_proc1z00_1742
																																																																						=
																																																																						BgL_proc1z00_28661;
																																																																					BgL_testz00_1741
																																																																						=
																																																																						BgL_testz00_28659;
																																																																					goto
																																																																						BgL_tagzd2387zd2_1745;
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_cdrzd260409zd2_5220;
																																																																					BgL_cdrzd260409zd2_5220
																																																																						=
																																																																						CDR
																																																																						(BgL_expz00_21);
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_cdrzd260417zd2_5221;
																																																																						BgL_cdrzd260417zd2_5221
																																																																							=
																																																																							CDR
																																																																							(CAR
																																																																							(BgL_expz00_21));
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_cdrzd260425zd2_5222;
																																																																							BgL_cdrzd260425zd2_5222
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd260417zd2_5221));
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_carzd260432zd2_5223;
																																																																								BgL_carzd260432zd2_5223
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd260425zd2_5222));
																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd260432zd2_5223))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_carzd260441zd2_5225;
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_pairz00_13405;
																																																																											BgL_pairz00_13405
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd260425zd2_5222));
																																																																											BgL_carzd260441zd2_5225
																																																																												=
																																																																												CAR
																																																																												(BgL_pairz00_13405);
																																																																										}
																																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd260441zd2_5225))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd260409zd2_5220))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_arg4409z00_5228;
																																																																														BgL_arg4409z00_5228
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd260417zd2_5221));
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_28685;
																																																																															obj_t
																																																																																BgL_proc2z00_28684;
																																																																															obj_t
																																																																																BgL_proc1z00_28683;
																																																																															obj_t
																																																																																BgL_testz00_28682;
																																																																															BgL_testz00_28682
																																																																																=
																																																																																BgL_arg4409z00_5228;
																																																																															BgL_proc1z00_28683
																																																																																=
																																																																																BgL_carzd260432zd2_5223;
																																																																															BgL_proc2z00_28684
																																																																																=
																																																																																BgL_carzd260441zd2_5225;
																																																																															BgL_argsz00_28685
																																																																																=
																																																																																BgL_cdrzd260409zd2_5220;
																																																																															BgL_argsz00_1749
																																																																																=
																																																																																BgL_argsz00_28685;
																																																																															BgL_proc2z00_1748
																																																																																=
																																																																																BgL_proc2z00_28684;
																																																																															BgL_proc1z00_1747
																																																																																=
																																																																																BgL_proc1z00_28683;
																																																																															BgL_testz00_1746
																																																																																=
																																																																																BgL_testz00_28682;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1750;
																																																																														}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{
																																																																																obj_t
																																																																																	BgL_auxz00_28688;
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1774;
																																																																																return
																																																																																	(
																																																																																	(BgL_nodez00_bglt)
																																																																																	BgL_auxz00_28688);
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1775;
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{
																																																																														obj_t
																																																																															BgL_auxz00_28692;
																																																																														goto
																																																																															BgL_tagzd2403zd2_1774;
																																																																														return
																																																																															(
																																																																															(BgL_nodez00_bglt)
																																																																															BgL_auxz00_28692);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														goto
																																																																															BgL_tagzd2404zd2_1775;
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{
																																																																												obj_t
																																																																													BgL_auxz00_28696;
																																																																												goto
																																																																													BgL_tagzd2403zd2_1774;
																																																																												return
																																																																													(
																																																																													(BgL_nodez00_bglt)
																																																																													BgL_auxz00_28696);
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												goto
																																																																													BgL_tagzd2404zd2_1775;
																																																																											}
																																																																									}
																																																																							}
																																																																						}
																																																																					}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{
																																																																					obj_t
																																																																						BgL_auxz00_28700;
																																																																					goto
																																																																						BgL_tagzd2403zd2_1774;
																																																																					return
																																																																						(
																																																																						(BgL_nodez00_bglt)
																																																																						BgL_auxz00_28700);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					goto
																																																																						BgL_tagzd2404zd2_1775;
																																																																				}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd260719zd2_5247;
																																																																	BgL_cdrzd260719zd2_5247
																																																																		=
																																																																		CDR
																																																																		(BgL_expz00_21);
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_cdrzd260726zd2_5248;
																																																																		BgL_cdrzd260726zd2_5248
																																																																			=
																																																																			CDR
																																																																			(CAR
																																																																			(BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_cdrzd260733zd2_5249;
																																																																			BgL_cdrzd260733zd2_5249
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd260726zd2_5248));
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_carzd260739zd2_5250;
																																																																				obj_t
																																																																					BgL_cdrzd260740zd2_5251;
																																																																				BgL_carzd260739zd2_5250
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd260733zd2_5249));
																																																																				BgL_cdrzd260740zd2_5251
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd260733zd2_5249));
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd260739zd2_5250))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_carzd260747zd2_5253;
																																																																						BgL_carzd260747zd2_5253
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd260740zd2_5251));
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd260747zd2_5253))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (NULLP(CDR(((obj_t) BgL_cdrzd260740zd2_5251))))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd260719zd2_5247))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_arg4424z00_5258;
																																																																												BgL_arg4424z00_5258
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd260726zd2_5248));
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_28728;
																																																																													obj_t
																																																																														BgL_proc2z00_28727;
																																																																													obj_t
																																																																														BgL_proc1z00_28726;
																																																																													obj_t
																																																																														BgL_testz00_28725;
																																																																													BgL_testz00_28725
																																																																														=
																																																																														BgL_arg4424z00_5258;
																																																																													BgL_proc1z00_28726
																																																																														=
																																																																														BgL_carzd260739zd2_5250;
																																																																													BgL_proc2z00_28727
																																																																														=
																																																																														BgL_carzd260747zd2_5253;
																																																																													BgL_argsz00_28728
																																																																														=
																																																																														BgL_cdrzd260719zd2_5247;
																																																																													BgL_argsz00_1749
																																																																														=
																																																																														BgL_argsz00_28728;
																																																																													BgL_proc2z00_1748
																																																																														=
																																																																														BgL_proc2z00_28727;
																																																																													BgL_proc1z00_1747
																																																																														=
																																																																														BgL_proc1z00_28726;
																																																																													BgL_testz00_1746
																																																																														=
																																																																														BgL_testz00_28725;
																																																																													goto
																																																																														BgL_tagzd2388zd2_1750;
																																																																												}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{
																																																																														obj_t
																																																																															BgL_auxz00_28731;
																																																																														goto
																																																																															BgL_tagzd2403zd2_1774;
																																																																														return
																																																																															(
																																																																															(BgL_nodez00_bglt)
																																																																															BgL_auxz00_28731);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														goto
																																																																															BgL_tagzd2404zd2_1775;
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{
																																																																												obj_t
																																																																													BgL_auxz00_28735;
																																																																												goto
																																																																													BgL_tagzd2403zd2_1774;
																																																																												return
																																																																													(
																																																																													(BgL_nodez00_bglt)
																																																																													BgL_auxz00_28735);
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												goto
																																																																													BgL_tagzd2404zd2_1775;
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{
																																																																										obj_t
																																																																											BgL_auxz00_28739;
																																																																										goto
																																																																											BgL_tagzd2403zd2_1774;
																																																																										return
																																																																											(
																																																																											(BgL_nodez00_bglt)
																																																																											BgL_auxz00_28739);
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										goto
																																																																											BgL_tagzd2404zd2_1775;
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{
																																																																								obj_t
																																																																									BgL_auxz00_28743;
																																																																								goto
																																																																									BgL_tagzd2403zd2_1774;
																																																																								return
																																																																									(
																																																																									(BgL_nodez00_bglt)
																																																																									BgL_auxz00_28743);
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								goto
																																																																									BgL_tagzd2404zd2_1775;
																																																																							}
																																																																					}
																																																																			}
																																																																		}
																																																																	}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{
																																																																	obj_t
																																																																		BgL_auxz00_28747;
																																																																	goto
																																																																		BgL_tagzd2403zd2_1774;
																																																																	return
																																																																		(
																																																																		(BgL_nodez00_bglt)
																																																																		BgL_auxz00_28747);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	goto
																																																																		BgL_tagzd2404zd2_1775;
																																																																}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_cdrzd261080zd2_5266;
																																																													BgL_cdrzd261080zd2_5266
																																																														=
																																																														CDR
																																																														(BgL_expz00_21);
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_cdrzd261086zd2_5267;
																																																														BgL_cdrzd261086zd2_5267
																																																															=
																																																															CDR
																																																															(CAR
																																																															(BgL_expz00_21));
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_cdrzd261092zd2_5268;
																																																															BgL_cdrzd261092zd2_5268
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd261086zd2_5267));
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_carzd261097zd2_5269;
																																																																obj_t
																																																																	BgL_cdrzd261098zd2_5270;
																																																																BgL_carzd261097zd2_5269
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd261092zd2_5268));
																																																																BgL_cdrzd261098zd2_5270
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd261092zd2_5268));
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd261097zd2_5269))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (PAIRP(BgL_cdrzd261098zd2_5270))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_carzd261103zd2_5273;
																																																																				BgL_carzd261103zd2_5273
																																																																					=
																																																																					CAR
																																																																					(BgL_cdrzd261098zd2_5270);
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd261103zd2_5273))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (NULLP(CDR(BgL_cdrzd261098zd2_5270)))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd261080zd2_5266))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_arg4438z00_5278;
																																																																										BgL_arg4438z00_5278
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd261086zd2_5267));
																																																																										{
																																																																											obj_t
																																																																												BgL_argsz00_28775;
																																																																											obj_t
																																																																												BgL_proc2z00_28774;
																																																																											obj_t
																																																																												BgL_proc1z00_28773;
																																																																											obj_t
																																																																												BgL_testz00_28772;
																																																																											BgL_testz00_28772
																																																																												=
																																																																												BgL_arg4438z00_5278;
																																																																											BgL_proc1z00_28773
																																																																												=
																																																																												BgL_carzd261097zd2_5269;
																																																																											BgL_proc2z00_28774
																																																																												=
																																																																												BgL_carzd261103zd2_5273;
																																																																											BgL_argsz00_28775
																																																																												=
																																																																												BgL_cdrzd261080zd2_5266;
																																																																											BgL_argsz00_1749
																																																																												=
																																																																												BgL_argsz00_28775;
																																																																											BgL_proc2z00_1748
																																																																												=
																																																																												BgL_proc2z00_28774;
																																																																											BgL_proc1z00_1747
																																																																												=
																																																																												BgL_proc1z00_28773;
																																																																											BgL_testz00_1746
																																																																												=
																																																																												BgL_testz00_28772;
																																																																											goto
																																																																												BgL_tagzd2388zd2_1750;
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{
																																																																												obj_t
																																																																													BgL_auxz00_28778;
																																																																												goto
																																																																													BgL_tagzd2403zd2_1774;
																																																																												return
																																																																													(
																																																																													(BgL_nodez00_bglt)
																																																																													BgL_auxz00_28778);
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												goto
																																																																													BgL_tagzd2404zd2_1775;
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{
																																																																										obj_t
																																																																											BgL_auxz00_28782;
																																																																										goto
																																																																											BgL_tagzd2403zd2_1774;
																																																																										return
																																																																											(
																																																																											(BgL_nodez00_bglt)
																																																																											BgL_auxz00_28782);
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										goto
																																																																											BgL_tagzd2404zd2_1775;
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{
																																																																								obj_t
																																																																									BgL_auxz00_28786;
																																																																								goto
																																																																									BgL_tagzd2403zd2_1774;
																																																																								return
																																																																									(
																																																																									(BgL_nodez00_bglt)
																																																																									BgL_auxz00_28786);
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								goto
																																																																									BgL_tagzd2404zd2_1775;
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{
																																																																						obj_t
																																																																							BgL_auxz00_28790;
																																																																						goto
																																																																							BgL_tagzd2403zd2_1774;
																																																																						return
																																																																							(
																																																																							(BgL_nodez00_bglt)
																																																																							BgL_auxz00_28790);
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						goto
																																																																							BgL_tagzd2404zd2_1775;
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{
																																																																				obj_t
																																																																					BgL_auxz00_28794;
																																																																				goto
																																																																					BgL_tagzd2403zd2_1774;
																																																																				return
																																																																					(
																																																																					(BgL_nodez00_bglt)
																																																																					BgL_auxz00_28794);
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				goto
																																																																					BgL_tagzd2404zd2_1775;
																																																																			}
																																																																	}
																																																															}
																																																														}
																																																													}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{
																																																													obj_t
																																																														BgL_auxz00_28798;
																																																													goto
																																																														BgL_tagzd2403zd2_1774;
																																																													return
																																																														(
																																																														(BgL_nodez00_bglt)
																																																														BgL_auxz00_28798);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													goto
																																																														BgL_tagzd2404zd2_1775;
																																																												}
																																																										}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																										{
																																																											obj_t
																																																												BgL_auxz00_28802;
																																																											goto
																																																												BgL_tagzd2403zd2_1774;
																																																											return
																																																												(
																																																												(BgL_nodez00_bglt)
																																																												BgL_auxz00_28802);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											goto
																																																												BgL_tagzd2404zd2_1775;
																																																										}
																																																								}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																								{
																																																									obj_t
																																																										BgL_auxz00_28806;
																																																									goto
																																																										BgL_tagzd2403zd2_1774;
																																																									return
																																																										(
																																																										(BgL_nodez00_bglt)
																																																										BgL_auxz00_28806);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									goto
																																																										BgL_tagzd2404zd2_1775;
																																																								}
																																																						}
																																																				}
																																																		}
																																																	}
																																															}
																																													}
																																												}
																																											}
																																									}
																																							}
																																					}
																																			}
																																	}
																																}
																															else
																																{

																																	if (
																																		(BgL_carzd255411zd2_5103
																																			==
																																			CNST_TABLE_REF
																																			(((long)
																																					17))))
																																		{
																																			obj_t
																																				BgL_auxz00_28811;
																																		BgL_kapzd261641zd2_5686:
																																			if (PAIRP
																																				(BgL_cdrzd255282zd2_5085))
																																				{	/* Ast/sexp.scm 118 */
																																					obj_t
																																						BgL_arg4792z00_5783;
																																					obj_t
																																						BgL_arg4793z00_5784;
																																					BgL_arg4792z00_5783
																																						=
																																						CAR
																																						(BgL_cdrzd255282zd2_5085);
																																					BgL_arg4793z00_5784
																																						=
																																						CDR
																																						(BgL_cdrzd255282zd2_5085);
																																					{
																																						BgL_nodez00_bglt
																																							BgL_auxz00_28816;
																																						{
																																							obj_t
																																								BgL_exprz00_28818;
																																							obj_t
																																								BgL_bindingsz00_28817;
																																							BgL_bindingsz00_28817
																																								=
																																								BgL_arg4792z00_5783;
																																							BgL_exprz00_28818
																																								=
																																								BgL_arg4793z00_5784;
																																							BgL_exprz00_1729
																																								=
																																								BgL_exprz00_28818;
																																							BgL_bindingsz00_1728
																																								=
																																								BgL_bindingsz00_28817;
																																							goto
																																								BgL_tagzd2382zd2_1730;
																																						}
																																						BgL_auxz00_28811
																																							=
																																							(
																																							(obj_t)
																																							BgL_auxz00_28816);
																																					}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 118 */
																																					if (
																																						(CAR
																																							(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_28825;
																																							goto
																																								BgL_tagzd2383zd2_1731;
																																							BgL_auxz00_28811
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_28825);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 118 */
																																							obj_t
																																								BgL_carzd261674zd2_5787;
																																							BgL_carzd261674zd2_5787
																																								=
																																								CAR
																																								(
																																								((obj_t) BgL_expz00_21));
																																							if ((BgL_carzd261674zd2_5787 == CNST_TABLE_REF(((long) 19))))
																																								{
																																									BgL_letzd2funzd2_bglt
																																										BgL_auxz00_28832;
																																									goto
																																										BgL_tagzd2384zd2_1732;
																																									BgL_auxz00_28811
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_28832);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 118 */
																																									if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd261674zd2_5787)))
																																										{
																																											BgL_letzd2funzd2_bglt
																																												BgL_auxz00_28837;
																																											goto
																																												BgL_tagzd2384zd2_1732;
																																											BgL_auxz00_28811
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_28837);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 118 */
																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_28844;
																																													goto
																																														BgL_tagzd2389zd2_1751;
																																													BgL_auxz00_28811
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_28844);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 118 */
																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_28851;
																																															goto
																																																BgL_tagzd2390zd2_1752;
																																															BgL_auxz00_28811
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_28851);
																																														}
																																													else
																																														{	/* Ast/sexp.scm 118 */
																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_28858;
																																																	goto
																																																		BgL_tagzd2392zd2_1756;
																																																	BgL_auxz00_28811
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_28858);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_28865;
																																																			goto
																																																				BgL_tagzd2393zd2_1757;
																																																			BgL_auxz00_28811
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_28865);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_28872;
																																																					goto
																																																						BgL_tagzd2395zd2_1761;
																																																					BgL_auxz00_28811
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_28872);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_28879;
																																																							goto
																																																								BgL_tagzd2396zd2_1762;
																																																							BgL_auxz00_28811
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_28879);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_28886;
																																																									goto
																																																										BgL_tagzd2397zd2_1763;
																																																									BgL_auxz00_28811
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_28886);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																										{
																																																											BgL_jumpzd2exzd2itz00_bglt
																																																												BgL_auxz00_28893;
																																																											goto
																																																												BgL_tagzd2398zd2_1764;
																																																											BgL_auxz00_28811
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_28893);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											if (BGl_equalzf3zf3zz__r4_equivalence_6_2z00(CAR(((obj_t) BgL_expz00_21)), BUNSPEC))
																																																												{	/* Ast/sexp.scm 118 */
																																																													if (NULLP(CDR(((obj_t) BgL_expz00_21))))
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_28903;
																																																															goto
																																																																BgL_tagzd2402zd2_1773;
																																																															BgL_auxz00_28811
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_28903);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1774;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_28907;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1775;
																																																																	BgL_auxz00_28811
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_28907);
																																																																}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{	/* Ast/sexp.scm 118 */
																																																															goto
																																																																BgL_tagzd2403zd2_1774;
																																																														}
																																																													else
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_28911;
																																																															goto
																																																																BgL_tagzd2404zd2_1775;
																																																															BgL_auxz00_28811
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_28911);
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																			return
																																				(
																																				(BgL_nodez00_bglt)
																																				BgL_auxz00_28811);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 118 */
																																			if (CBOOL
																																				(BGl_letzd2symzf3z21zzast_letz00
																																					(BgL_carzd255411zd2_5103)))
																																				{
																																					obj_t
																																						BgL_auxz00_28917;
																																					goto
																																						BgL_kapzd261641zd2_5686;
																																					return
																																						(
																																						(BgL_nodez00_bglt)
																																						BgL_auxz00_28917);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 118 */
																																					if (
																																						(BgL_carzd255411zd2_5103
																																							==
																																							CNST_TABLE_REF
																																							(((long) 18))))
																																						{
																																							obj_t
																																								BgL_auxz00_28922;
																																							goto
																																								BgL_kapzd261641zd2_5686;
																																							return
																																								(
																																								(BgL_nodez00_bglt)
																																								BgL_auxz00_28922);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 118 */
																																							if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 20))))
																																								{	/* Ast/sexp.scm 118 */
																																									goto
																																										BgL_tagzd2383zd2_1731;
																																								}
																																							else
																																								{	/* Ast/sexp.scm 118 */
																																									obj_t
																																										BgL_carzd261835zd2_5692;
																																									BgL_carzd261835zd2_5692
																																										=
																																										CAR
																																										(BgL_expz00_21);
																																									if ((BgL_carzd261835zd2_5692 == CNST_TABLE_REF(((long) 19))))
																																										{
																																											BgL_letzd2funzd2_bglt
																																												BgL_auxz00_28932;
																																											goto
																																												BgL_tagzd2384zd2_1732;
																																											return
																																												(
																																												(BgL_nodez00_bglt)
																																												BgL_auxz00_28932);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 118 */
																																											if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd261835zd2_5692)))
																																												{
																																													BgL_letzd2funzd2_bglt
																																														BgL_auxz00_28937;
																																													goto
																																														BgL_tagzd2384zd2_1732;
																																													return
																																														(
																																														(BgL_nodez00_bglt)
																																														BgL_auxz00_28937);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 118 */
																																													if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 3))))
																																														{	/* Ast/sexp.scm 118 */
																																															goto
																																																BgL_tagzd2389zd2_1751;
																																														}
																																													else
																																														{	/* Ast/sexp.scm 118 */
																																															if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 6))))
																																																{	/* Ast/sexp.scm 118 */
																																																	goto
																																																		BgL_tagzd2390zd2_1752;
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_cdrzd261914zd2_5699;
																																																	BgL_cdrzd261914zd2_5699
																																																		=
																																																		CDR
																																																		(BgL_expz00_21);
																																																	if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 21))))
																																																		{	/* Ast/sexp.scm 118 */
																																																			if (PAIRP(BgL_cdrzd261914zd2_5699))
																																																				{
																																																					obj_t
																																																						BgL_restz00_28956;
																																																					obj_t
																																																						BgL_effectz00_28954;
																																																					BgL_effectz00_28954
																																																						=
																																																						CAR
																																																						(BgL_cdrzd261914zd2_5699);
																																																					BgL_restz00_28956
																																																						=
																																																						CDR
																																																						(BgL_cdrzd261914zd2_5699);
																																																					BgL_restz00_1754
																																																						=
																																																						BgL_restz00_28956;
																																																					BgL_effectz00_1753
																																																						=
																																																						BgL_effectz00_28954;
																																																					goto
																																																						BgL_tagzd2391zd2_1755;
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																						{
																																																							obj_t
																																																								BgL_auxz00_28960;
																																																							goto
																																																								BgL_tagzd2403zd2_1774;
																																																							return
																																																								(
																																																								(BgL_nodez00_bglt)
																																																								BgL_auxz00_28960);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							goto
																																																								BgL_tagzd2404zd2_1775;
																																																						}
																																																				}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 22))))
																																																				{	/* Ast/sexp.scm 118 */
																																																					goto
																																																						BgL_tagzd2392zd2_1756;
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 23))))
																																																						{	/* Ast/sexp.scm 118 */
																																																							goto
																																																								BgL_tagzd2393zd2_1757;
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 24))))
																																																								{	/* Ast/sexp.scm 118 */
																																																									if (PAIRP(BgL_cdrzd261914zd2_5699))
																																																										{
																																																											obj_t
																																																												BgL_restz00_28978;
																																																											obj_t
																																																												BgL_effectz00_28976;
																																																											BgL_effectz00_28976
																																																												=
																																																												CAR
																																																												(BgL_cdrzd261914zd2_5699);
																																																											BgL_restz00_28978
																																																												=
																																																												CDR
																																																												(BgL_cdrzd261914zd2_5699);
																																																											BgL_restz00_1759
																																																												=
																																																												BgL_restz00_28978;
																																																											BgL_effectz00_1758
																																																												=
																																																												BgL_effectz00_28976;
																																																											goto
																																																												BgL_tagzd2394zd2_1760;
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{
																																																													obj_t
																																																														BgL_auxz00_28982;
																																																													goto
																																																														BgL_tagzd2403zd2_1774;
																																																													return
																																																														(
																																																														(BgL_nodez00_bglt)
																																																														BgL_auxz00_28982);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													goto
																																																														BgL_tagzd2404zd2_1775;
																																																												}
																																																										}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 25))))
																																																										{	/* Ast/sexp.scm 118 */
																																																											goto
																																																												BgL_tagzd2395zd2_1761;
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 26))))
																																																												{	/* Ast/sexp.scm 118 */
																																																													goto
																																																														BgL_tagzd2396zd2_1762;
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 27))))
																																																														{
																																																															BgL_letzd2funzd2_bglt
																																																																BgL_auxz00_28996;
																																																															goto
																																																																BgL_tagzd2397zd2_1763;
																																																															return
																																																																(
																																																																(BgL_nodez00_bglt)
																																																																BgL_auxz00_28996);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 28))))
																																																																{
																																																																	BgL_jumpzd2exzd2itz00_bglt
																																																																		BgL_auxz00_29002;
																																																																	goto
																																																																		BgL_tagzd2398zd2_1764;
																																																																	return
																																																																		(
																																																																		(BgL_nodez00_bglt)
																																																																		BgL_auxz00_29002);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd262041zd2_5725;
																																																																	BgL_cdrzd262041zd2_5725
																																																																		=
																																																																		CDR
																																																																		(BgL_expz00_21);
																																																																	if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 30))))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if (PAIRP(BgL_cdrzd262041zd2_5725))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_cdrzd262043zd2_5729;
																																																																					BgL_cdrzd262043zd2_5729
																																																																						=
																																																																						CDR
																																																																						(BgL_cdrzd262041zd2_5725);
																																																																					if (PAIRP(BgL_cdrzd262043zd2_5729))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (NULLP(CDR(BgL_cdrzd262043zd2_5729)))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2399zd2_1765;
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{
																																																																											obj_t
																																																																												BgL_auxz00_29019;
																																																																											goto
																																																																												BgL_tagzd2403zd2_1774;
																																																																											return
																																																																												(
																																																																												(BgL_nodez00_bglt)
																																																																												BgL_auxz00_29019);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2404zd2_1775;
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{
																																																																									obj_t
																																																																										BgL_auxz00_29023;
																																																																									goto
																																																																										BgL_tagzd2403zd2_1774;
																																																																									return
																																																																										(
																																																																										(BgL_nodez00_bglt)
																																																																										BgL_auxz00_29023);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2404zd2_1775;
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{
																																																																							obj_t
																																																																								BgL_auxz00_29027;
																																																																							goto
																																																																								BgL_tagzd2403zd2_1774;
																																																																							return
																																																																								(
																																																																								(BgL_nodez00_bglt)
																																																																								BgL_auxz00_29027);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							goto
																																																																								BgL_tagzd2404zd2_1775;
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 29))))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (PAIRP(BgL_cdrzd262041zd2_5725))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_cdrzd262088zd2_5741;
																																																																							BgL_cdrzd262088zd2_5741
																																																																								=
																																																																								CDR
																																																																								(BgL_cdrzd262041zd2_5725);
																																																																							if (PAIRP(BgL_cdrzd262088zd2_5741))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_cdrzd262093zd2_5743;
																																																																									BgL_cdrzd262093zd2_5743
																																																																										=
																																																																										CDR
																																																																										(BgL_cdrzd262088zd2_5741);
																																																																									if ((CAR(BgL_cdrzd262088zd2_5741) == CNST_TABLE_REF(((long) 31))))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (PAIRP(BgL_cdrzd262093zd2_5743))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_arg4759z00_5747;
																																																																													obj_t
																																																																														BgL_arg4760z00_5748;
																																																																													obj_t
																																																																														BgL_arg4761z00_5749;
																																																																													BgL_arg4759z00_5747
																																																																														=
																																																																														CAR
																																																																														(BgL_cdrzd262041zd2_5725);
																																																																													BgL_arg4760z00_5748
																																																																														=
																																																																														CAR
																																																																														(BgL_cdrzd262093zd2_5743);
																																																																													BgL_arg4761z00_5749
																																																																														=
																																																																														CDR
																																																																														(BgL_cdrzd262093zd2_5743);
																																																																													return
																																																																														BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																														(BgL_expz00_21,
																																																																														BgL_arg4759z00_5747,
																																																																														BgL_arg4760z00_5748,
																																																																														BgL_arg4761z00_5749,
																																																																														BgL_stackz00_22,
																																																																														BGl_findzd2locationzf2locz20zztools_locationz00
																																																																														(BgL_expz00_21,
																																																																															BgL_locz00_23),
																																																																														BgL_sitez00_24);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_cdrzd262106zd2_5750;
																																																																													BgL_cdrzd262106zd2_5750
																																																																														=
																																																																														CDR
																																																																														(BgL_expz00_21);
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_arg4762z00_5751;
																																																																														obj_t
																																																																															BgL_arg4763z00_5752;
																																																																														BgL_arg4762z00_5751
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd262106zd2_5750));
																																																																														BgL_arg4763z00_5752
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd262106zd2_5750));
																																																																														{	/* Ast/sexp.scm 551 */
																																																																															obj_t
																																																																																BgL_arg6989z00_13488;
																																																																															BgL_arg6989z00_13488
																																																																																=
																																																																																BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																(BgL_expz00_21,
																																																																																BgL_locz00_23);
																																																																															return
																																																																																BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																(BgL_expz00_21,
																																																																																BgL_arg4762z00_5751,
																																																																																CNST_TABLE_REF
																																																																																(((long) 4)), BgL_arg4763z00_5752, BgL_stackz00_22, BgL_arg6989z00_13488, BgL_sitez00_24);
																																																																										}}}}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_cdrzd262121zd2_5753;
																																																																											BgL_cdrzd262121zd2_5753
																																																																												=
																																																																												CDR
																																																																												(BgL_expz00_21);
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_arg4764z00_5754;
																																																																												obj_t
																																																																													BgL_arg4765z00_5755;
																																																																												BgL_arg4764z00_5754
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd262121zd2_5753));
																																																																												BgL_arg4765z00_5755
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd262121zd2_5753));
																																																																												{	/* Ast/sexp.scm 551 */
																																																																													obj_t
																																																																														BgL_arg6989z00_13492;
																																																																													BgL_arg6989z00_13492
																																																																														=
																																																																														BGl_findzd2locationzf2locz20zztools_locationz00
																																																																														(BgL_expz00_21,
																																																																														BgL_locz00_23);
																																																																													return
																																																																														BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																														(BgL_expz00_21,
																																																																														BgL_arg4764z00_5754,
																																																																														CNST_TABLE_REF
																																																																														(((long) 4)), BgL_arg4765z00_5755, BgL_stackz00_22, BgL_arg6989z00_13492, BgL_sitez00_24);
																																																																								}}}}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_cdrzd262136zd2_5757;
																																																																									BgL_cdrzd262136zd2_5757
																																																																										=
																																																																										CDR
																																																																										(BgL_expz00_21);
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_arg4767z00_5758;
																																																																										obj_t
																																																																											BgL_arg4768z00_5759;
																																																																										BgL_arg4767z00_5758
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd262136zd2_5757));
																																																																										BgL_arg4768z00_5759
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd262136zd2_5757));
																																																																										{	/* Ast/sexp.scm 551 */
																																																																											obj_t
																																																																												BgL_arg6989z00_13496;
																																																																											BgL_arg6989z00_13496
																																																																												=
																																																																												BGl_findzd2locationzf2locz20zztools_locationz00
																																																																												(BgL_expz00_21,
																																																																												BgL_locz00_23);
																																																																											return
																																																																												BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																												(BgL_expz00_21,
																																																																												BgL_arg4767z00_5758,
																																																																												CNST_TABLE_REF
																																																																												(((long) 4)), BgL_arg4768z00_5759, BgL_stackz00_22, BgL_arg6989z00_13496, BgL_sitez00_24);
																																																																						}}}}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{
																																																																									obj_t
																																																																										BgL_auxz00_29076;
																																																																									goto
																																																																										BgL_tagzd2403zd2_1774;
																																																																									return
																																																																										(
																																																																										(BgL_nodez00_bglt)
																																																																										BgL_auxz00_29076);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2404zd2_1775;
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (BGl_equalzf3zf3zz__r4_equivalence_6_2z00(CAR(BgL_expz00_21), BUNSPEC))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (NULLP(CDR(BgL_expz00_21)))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2402zd2_1773;
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{
																																																																											obj_t
																																																																												BgL_auxz00_29086;
																																																																											goto
																																																																												BgL_tagzd2403zd2_1774;
																																																																											return
																																																																												(
																																																																												(BgL_nodez00_bglt)
																																																																												BgL_auxz00_29086);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2404zd2_1775;
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{
																																																																									obj_t
																																																																										BgL_auxz00_29090;
																																																																									goto
																																																																										BgL_tagzd2403zd2_1774;
																																																																									return
																																																																										(
																																																																										(BgL_nodez00_bglt)
																																																																										BgL_auxz00_29090);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2404zd2_1775;
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																										}
																								}
																						}
																				}
																			}
																	}
															}
													}
											}
									}
								else
									{	/* Ast/sexp.scm 118 */
										BgL_atomz00_1706 = BgL_expz00_21;
										{	/* Ast/sexp.scm 134 */
											bool_t BgL_test10478z00_29092;

											if (BGl_isazf3zf3zz__objectz00(BgL_atomz00_1706,
													BGl_localz00zzast_varz00))
												{	/* Ast/sexp.scm 134 */
													BgL_test10478z00_29092 = ((bool_t) 1);
												}
											else
												{	/* Ast/sexp.scm 134 */
													BgL_test10478z00_29092 =
														BGl_isazf3zf3zz__objectz00(BgL_atomz00_1706,
														BGl_globalz00zzast_varz00);
												}
											if (BgL_test10478z00_29092)
												{	/* Ast/sexp.scm 134 */
													return
														BGl_variablezd2ze3nodez31zzast_sexpz00
														(BgL_atomz00_1706, BgL_locz00_23, BgL_sitez00_24);
												}
											else
												{	/* Ast/sexp.scm 136 */
													bool_t BgL_test10480z00_29097;

													if (STRUCTP(BgL_atomz00_1706))
														{	/* Ast/sexp.scm 136 */
															BgL_test10480z00_29097 = ((bool_t) 1);
														}
													else
														{	/* Ast/sexp.scm 136 */
															if (VECTORP(BgL_atomz00_1706))
																{	/* Ast/sexp.scm 136 */
																	BgL_test10480z00_29097 = ((bool_t) 1);
																}
															else
																{	/* Ast/sexp.scm 136 */
																	if (BGL_OBJECTP(BgL_atomz00_1706))
																		{	/* Ast/sexp.scm 136 */
																			BgL_test10480z00_29097 = ((bool_t) 1);
																		}
																	else
																		{	/* Ast/sexp.scm 136 */
																			BgL_test10480z00_29097 =
																				PROCEDUREP(BgL_atomz00_1706);
																		}
																}
														}
													if (BgL_test10480z00_29097)
														{	/* Ast/sexp.scm 137 */
															BgL_nodez00_bglt BgL_res7315z00_9606;

															{	/* Ast/sexp.scm 722 */
																obj_t BgL_arg7104z00_9602;
																BgL_nodez00_bglt BgL_arg7105z00_9603;

																BgL_arg7104z00_9602 =
																	BGl_shapez00zztools_shapez00
																	(BGl_currentzd2functionzd2zztools_errorz00());
																BgL_arg7105z00_9603 =
																	BGl_sexpzd2ze3nodez31zzast_sexpz00
																	(CNST_TABLE_REF(((long) 4)), BNIL,
																	BgL_locz00_23, CNST_TABLE_REF(((long) 2)));
																{	/* Ast/sexp.scm 721 */
																	obj_t BgL_list7106z00_9605;

																	BgL_list7106z00_9605 =
																		MAKE_YOUNG_PAIR(
																		((obj_t) BgL_arg7105z00_9603), BNIL);
																	BgL_res7315z00_9606 =
																		((BgL_nodez00_bglt)
																		BGl_userzd2errorzf2locationz20zztools_errorz00
																		(BgL_locz00_23, BgL_arg7104z00_9602,
																			BGl_string8003z00zzast_sexpz00,
																			BgL_expz00_21, BgL_list7106z00_9605));
															}}
															return BgL_res7315z00_9606;
														}
													else
														{	/* Ast/sexp.scm 136 */
															if (SYMBOLP(BgL_atomz00_1706))
																{	/* Ast/sexp.scm 143 */
																	obj_t BgL_g1116z00_8364;

																	BgL_g1116z00_8364 =
																		BGl_findzd2localzd2zzast_sexpz00
																		(BgL_atomz00_1706, BgL_stackz00_22);
																	if (CBOOL(BgL_g1116z00_8364))
																		{	/* Ast/sexp.scm 143 */
																			return
																				BGl_variablezd2ze3nodez31zzast_sexpz00
																				(BgL_g1116z00_8364, BgL_locz00_23,
																				BgL_sitez00_24);
																		}
																	else
																		{	/* Ast/sexp.scm 147 */
																			obj_t BgL_globalz00_8367;
																			obj_t BgL_locz00_8368;

																			BgL_globalz00_8367 =
																				BGl_findzd2globalzd2zzast_envz00
																				(BgL_atomz00_1706, BNIL);
																			BgL_locz00_8368 =
																				BGl_findzd2locationzf2locz20zztools_locationz00
																				(BgL_atomz00_1706, BgL_locz00_23);
																			if (BGl_isazf3zf3zz__objectz00
																				(BgL_globalz00_8367,
																					BGl_globalz00zzast_varz00))
																				{	/* Ast/sexp.scm 150 */
																					if (
																						((((BgL_globalz00_bglt) COBJECT(
																										((BgL_globalz00_bglt)
																											BgL_globalz00_8367)))->
																								BgL_importz00) ==
																							CNST_TABLE_REF(((long) 10))))
																						{	/* Ast/sexp.scm 153 */
																							obj_t BgL_arg6631z00_8372;

																							{	/* Ast/sexp.scm 153 */
																								obj_t BgL_arg6632z00_8373;

																								{	/* Ast/sexp.scm 153 */
																									obj_t BgL_arg6633z00_8374;

																									{	/* Ast/sexp.scm 153 */
																										obj_t BgL_arg6634z00_8375;

																										BgL_arg6634z00_8375 =
																											MAKE_YOUNG_PAIR
																											(BgL_atomz00_1706, BNIL);
																										BgL_arg6633z00_8374 =
																											MAKE_YOUNG_PAIR
																											(CNST_TABLE_REF(((long)
																													12)),
																											BgL_arg6634z00_8375);
																									}
																									BgL_arg6632z00_8373 =
																										MAKE_YOUNG_PAIR
																										(BgL_arg6633z00_8374, BNIL);
																								}
																								BgL_arg6631z00_8372 =
																									MAKE_YOUNG_PAIR(CNST_TABLE_REF
																									(((long) 10)),
																									BgL_arg6632z00_8373);
																							}
																							{
																								obj_t BgL_locz00_29136;
																								obj_t BgL_expz00_29135;

																								BgL_expz00_29135 =
																									BgL_arg6631z00_8372;
																								BgL_locz00_29136 =
																									BgL_locz00_8368;
																								BgL_locz00_23 =
																									BgL_locz00_29136;
																								BgL_expz00_21 =
																									BgL_expz00_29135;
																								goto
																									BGl_sexpzd2ze3nodez31zzast_sexpz00;
																							}
																						}
																					else
																						{	/* Ast/sexp.scm 152 */
																							return
																								BGl_variablezd2ze3nodez31zzast_sexpz00
																								(BgL_globalz00_8367,
																								BgL_locz00_8368,
																								BgL_sitez00_24);
																						}
																				}
																			else
																				{	/* Ast/sexp.scm 151 */
																					BgL_nodez00_bglt BgL_res7318z00_9615;

																					{	/* Ast/sexp.scm 722 */
																						obj_t BgL_arg7104z00_9611;
																						BgL_nodez00_bglt
																							BgL_arg7105z00_9612;
																						BgL_arg7104z00_9611 =
																							BGl_shapez00zztools_shapez00
																							(BGl_currentzd2functionzd2zztools_errorz00
																							());
																						BgL_arg7105z00_9612 =
																							BGl_sexpzd2ze3nodez31zzast_sexpz00
																							(CNST_TABLE_REF(((long) 4)), BNIL,
																							BgL_locz00_8368,
																							CNST_TABLE_REF(((long) 2)));
																						{	/* Ast/sexp.scm 721 */
																							obj_t BgL_list7106z00_9614;

																							BgL_list7106z00_9614 =
																								MAKE_YOUNG_PAIR(
																								((obj_t) BgL_arg7105z00_9612),
																								BNIL);
																							BgL_res7318z00_9615 =
																								((BgL_nodez00_bglt)
																								BGl_userzd2errorzf2locationz20zztools_errorz00
																								(BgL_locz00_8368,
																									BgL_arg7104z00_9611,
																									BGl_string8002z00zzast_sexpz00,
																									BgL_expz00_21,
																									BgL_list7106z00_9614));
																					}}
																					return BgL_res7318z00_9615;
																				}
																		}
																}
															else
																{	/* Ast/sexp.scm 139 */
																	BgL_literalz00_bglt BgL_new1115z00_8378;

																	{	/* Ast/sexp.scm 140 */
																		BgL_literalz00_bglt BgL_new1114z00_8379;

																		BgL_new1114z00_8379 =
																			((BgL_literalz00_bglt)
																			BOBJECT(GC_MALLOC(sizeof(struct
																						BgL_literalz00_bgl))));
																		{	/* Ast/sexp.scm 140 */
																			long BgL_arg6637z00_8380;

																			{	/* Ast/sexp.scm 140 */
																				long BgL_res7319z00_9617;

																				BgL_res7319z00_9617 =
																					BGL_CLASS_INDEX
																					(BGl_literalz00zzast_nodez00);
																				BgL_arg6637z00_8380 =
																					BgL_res7319z00_9617;
																			}
																			BGL_OBJECT_CLASS_NUM_SET(
																				((BgL_objectz00_bglt)
																					BgL_new1114z00_8379),
																				BgL_arg6637z00_8380);
																		}
																		{	/* Ast/sexp.scm 140 */
																			BgL_objectz00_bglt BgL_tmpz00_29151;

																			BgL_tmpz00_29151 =
																				((BgL_objectz00_bglt)
																				BgL_new1114z00_8379);
																			BGL_OBJECT_WIDENING_SET(BgL_tmpz00_29151,
																				BFALSE);
																		}
																		((BgL_objectz00_bglt) BgL_new1114z00_8379);
																		BgL_new1115z00_8378 = BgL_new1114z00_8379;
																	}
																	((((BgL_nodez00_bglt) COBJECT(
																					((BgL_nodez00_bglt)
																						BgL_new1115z00_8378)))->
																			BgL_locz00) =
																		((obj_t) BgL_locz00_23), BUNSPEC);
																	((((BgL_nodez00_bglt)
																				COBJECT(((BgL_nodez00_bglt)
																						BgL_new1115z00_8378)))->
																			BgL_typez00) =
																		((BgL_typez00_bglt)
																			BGl_getzd2typezd2atomz00zztype_typeofz00
																			(BgL_atomz00_1706)), BUNSPEC);
																	((((BgL_atomz00_bglt)
																				COBJECT(((BgL_atomz00_bglt)
																						BgL_new1115z00_8378)))->
																			BgL_valuez00) =
																		((obj_t) BgL_atomz00_1706), BUNSPEC);
																	return ((BgL_nodez00_bglt)
																		BgL_new1115z00_8378);
																}
														}
												}
										}
									}
							}
					}
			}
		}

	}



/* liip~0 */
	obj_t BGl_liipze70ze7zzast_sexpz00(obj_t BgL_argsz00_8790)
	{
		{	/* Ast/sexp.scm 395 */
			if (NULLP(BgL_argsz00_8790))
				{	/* Ast/sexp.scm 396 */
					return CNST_TABLE_REF(((long) 4));
				}
			else
				{	/* Ast/sexp.scm 398 */
					obj_t BgL_arg6880z00_8793;

					{	/* Ast/sexp.scm 398 */
						obj_t BgL_arg6881z00_8794;
						obj_t BgL_arg6882z00_8795;

						BgL_arg6881z00_8794 = CAR(((obj_t) BgL_argsz00_8790));
						{	/* Ast/sexp.scm 399 */
							obj_t BgL_arg6883z00_8796;

							{	/* Ast/sexp.scm 399 */
								obj_t BgL_arg6884z00_8797;

								BgL_arg6884z00_8797 = CDR(((obj_t) BgL_argsz00_8790));
								BgL_arg6883z00_8796 =
									BGl_liipze70ze7zzast_sexpz00(BgL_arg6884z00_8797);
							}
							BgL_arg6882z00_8795 = MAKE_YOUNG_PAIR(BgL_arg6883z00_8796, BNIL);
						}
						BgL_arg6880z00_8793 =
							MAKE_YOUNG_PAIR(BgL_arg6881z00_8794, BgL_arg6882z00_8795);
					}
					return
						MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 32)), BgL_arg6880z00_8793);
		}}

	}



/* loop~0 */
	obj_t BGl_loopze70ze7zzast_sexpz00(obj_t BgL_expz00_13792,
		obj_t BgL_locz00_13791, obj_t BgL_varsz00_8752, obj_t BgL_argsz00_8753)
	{
		{	/* Ast/sexp.scm 380 */
		BGl_loopze70ze7zzast_sexpz00:
			if (NULLP(BgL_varsz00_8752))
				{	/* Ast/sexp.scm 383 */
					if (NULLP(BgL_argsz00_8753))
						{	/* Ast/sexp.scm 384 */
							return BNIL;
						}
					else
						{	/* Ast/sexp.scm 384 */
							return
								BGl_userzd2errorzf2locationz20zztools_errorz00(BgL_locz00_13791,
								BGl_shapez00zztools_shapez00
								(BGl_currentzd2functionzd2zztools_errorz00()),
								BGl_string8005z00zzast_sexpz00, BgL_expz00_13792, BNIL);
						}
				}
			else
				{	/* Ast/sexp.scm 383 */
					if (PAIRP(BgL_varsz00_8752))
						{	/* Ast/sexp.scm 391 */
							if (BGl_dssslzd2namedzd2constantzf3zf3zz__dssslz00(CAR
									(BgL_varsz00_8752)))
								{	/* Ast/sexp.scm 401 */
									obj_t BgL_argz00_8763;

									BgL_argz00_8763 =
										BGl_dssslzd2findzd2firstzd2formalzd2zztools_dssslz00(CDR
										(BgL_varsz00_8752));
									if (CBOOL(BgL_argz00_8763))
										{
											obj_t BgL_varsz00_29191;

											BgL_varsz00_29191 = BgL_argz00_8763;
											BgL_varsz00_8752 = BgL_varsz00_29191;
											goto BGl_loopze70ze7zzast_sexpz00;
										}
									else
										{
											obj_t BgL_varsz00_29192;

											BgL_varsz00_29192 = BNIL;
											BgL_varsz00_8752 = BgL_varsz00_29192;
											goto BGl_loopze70ze7zzast_sexpz00;
										}
								}
							else
								{	/* Ast/sexp.scm 406 */
									bool_t BgL_test10494z00_29193;

									{	/* Ast/sexp.scm 406 */
										obj_t BgL_tmpz00_29194;

										BgL_tmpz00_29194 = CAR(BgL_varsz00_8752);
										BgL_test10494z00_29193 = SYMBOLP(BgL_tmpz00_29194);
									}
									if (BgL_test10494z00_29193)
										{	/* Ast/sexp.scm 406 */
											if (NULLP(BgL_argsz00_8753))
												{	/* Ast/sexp.scm 412 */
													return
														BGl_userzd2errorzf2locationz20zztools_errorz00
														(BgL_locz00_13791,
														BGl_shapez00zztools_shapez00
														(BGl_currentzd2functionzd2zztools_errorz00()),
														BGl_string8005z00zzast_sexpz00, BgL_expz00_13792,
														BNIL);
												}
											else
												{	/* Ast/sexp.scm 419 */
													obj_t BgL_arg6860z00_8771;
													obj_t BgL_arg6861z00_8772;

													{	/* Ast/sexp.scm 419 */
														obj_t BgL_arg6862z00_8773;
														obj_t BgL_arg6863z00_8774;

														BgL_arg6862z00_8773 = CAR(BgL_varsz00_8752);
														BgL_arg6863z00_8774 =
															CAR(((obj_t) BgL_argsz00_8753));
														{	/* Ast/sexp.scm 419 */
															obj_t BgL_list6864z00_8775;

															{	/* Ast/sexp.scm 419 */
																obj_t BgL_arg6865z00_8776;

																BgL_arg6865z00_8776 =
																	MAKE_YOUNG_PAIR(BgL_arg6863z00_8774, BNIL);
																BgL_list6864z00_8775 =
																	MAKE_YOUNG_PAIR(BgL_arg6862z00_8773,
																	BgL_arg6865z00_8776);
															}
															BgL_arg6860z00_8771 = BgL_list6864z00_8775;
														}
													}
													{	/* Ast/sexp.scm 420 */
														obj_t BgL_arg6866z00_8777;
														obj_t BgL_arg6867z00_8778;

														BgL_arg6866z00_8777 = CDR(BgL_varsz00_8752);
														BgL_arg6867z00_8778 =
															CDR(((obj_t) BgL_argsz00_8753));
														BgL_arg6861z00_8772 =
															BGl_loopze70ze7zzast_sexpz00(BgL_expz00_13792,
															BgL_locz00_13791, BgL_arg6866z00_8777,
															BgL_arg6867z00_8778);
													}
													return
														MAKE_YOUNG_PAIR(BgL_arg6860z00_8771,
														BgL_arg6861z00_8772);
												}
										}
									else
										{	/* Ast/sexp.scm 406 */
											return
												BGl_userzd2errorzf2locationz20zztools_errorz00
												(BgL_locz00_13791,
												BGl_shapez00zztools_shapez00
												(BGl_currentzd2functionzd2zztools_errorz00()),
												BGl_string8006z00zzast_sexpz00, BgL_expz00_13792, BNIL);
										}
								}
						}
					else
						{	/* Ast/sexp.scm 396 */
							obj_t BgL_arg6873z00_8784;

							{	/* Ast/sexp.scm 396 */
								obj_t BgL_arg6875z00_8786;

								BgL_arg6875z00_8786 =
									BGl_liipze70ze7zzast_sexpz00(BgL_argsz00_8753);
								{	/* Ast/sexp.scm 393 */
									obj_t BgL_list6876z00_8787;

									{	/* Ast/sexp.scm 393 */
										obj_t BgL_arg6877z00_8788;

										BgL_arg6877z00_8788 =
											MAKE_YOUNG_PAIR(BgL_arg6875z00_8786, BNIL);
										BgL_list6876z00_8787 =
											MAKE_YOUNG_PAIR(BgL_varsz00_8752, BgL_arg6877z00_8788);
									}
									BgL_arg6873z00_8784 = BgL_list6876z00_8787;
								}
							}
							{	/* Ast/sexp.scm 392 */
								obj_t BgL_list6874z00_8785;

								BgL_list6874z00_8785 =
									MAKE_YOUNG_PAIR(BgL_arg6873z00_8784, BNIL);
								return BgL_list6874z00_8785;
							}
						}
				}
		}

	}



/* &sexp->node */
	BgL_nodez00_bglt BGl_z62sexpzd2ze3nodez53zzast_sexpz00(obj_t BgL_envz00_13753,
		obj_t BgL_expz00_13754, obj_t BgL_stackz00_13755, obj_t BgL_locz00_13756,
		obj_t BgL_sitez00_13757)
	{
		{	/* Ast/sexp.scm 113 */
			return
				BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_expz00_13754, BgL_stackz00_13755,
				BgL_locz00_13756, BgL_sitez00_13757);
		}

	}



/* &<@anonymous:6890> */
	obj_t BGl_z62zc3z04anonymousza36890ze3ze5zzast_sexpz00(obj_t BgL_envz00_13758,
		obj_t BgL_objz00_13760, obj_t BgL_procz00_13761, obj_t BgL_msgz00_13762)
	{
		{	/* Ast/sexp.scm 425 */
			return
				BGl_userzd2errorzf2locationz20zztools_errorz00(PROCEDURE_REF
				(BgL_envz00_13758, (int) (((long) 0))), BgL_objz00_13760,
				BgL_procz00_13761, BgL_msgz00_13762, BNIL);
		}

	}



/* lambda->node */
	BgL_nodez00_bglt BGl_lambdazd2ze3nodez31zzast_sexpz00(obj_t BgL_expz00_25,
		obj_t BgL_stackz00_26, obj_t BgL_locz00_27, obj_t BgL_sitez00_28,
		obj_t BgL_prefnamez00_29)
	{
		{	/* Ast/sexp.scm 570 */
			{
				obj_t BgL_argsz00_8978;
				obj_t BgL_bodyz00_8979;

				if (PAIRP(BgL_expz00_25))
					{	/* Ast/sexp.scm 571 */
						obj_t BgL_cdrzd262408zd2_8984;

						BgL_cdrzd262408zd2_8984 = CDR(BgL_expz00_25);
						if (PAIRP(BgL_cdrzd262408zd2_8984))
							{	/* Ast/sexp.scm 571 */
								BgL_argsz00_8978 = CAR(BgL_cdrzd262408zd2_8984);
								BgL_bodyz00_8979 = CDR(BgL_cdrzd262408zd2_8984);
								{	/* Ast/sexp.scm 573 */
									obj_t BgL_locz00_8988;
									obj_t BgL_funz00_8989;

									BgL_locz00_8988 =
										BGl_findzd2locationzf2locz20zztools_locationz00
										(BgL_expz00_25, BgL_locz00_27);
									{	/* Ast/sexp.scm 574 */
										obj_t BgL_list7004z00_8999;

										BgL_list7004z00_8999 =
											MAKE_YOUNG_PAIR(BgL_prefnamez00_29, BNIL);
										BgL_funz00_8989 =
											BGl_makezd2anonymouszd2namez00zzast_sexpz00(BgL_locz00_27,
											BgL_list7004z00_8999);
									}
									{	/* Ast/sexp.scm 575 */
										obj_t BgL_arg6995z00_8990;

										{	/* Ast/sexp.scm 575 */
											obj_t BgL_arg6996z00_8991;
											obj_t BgL_arg6997z00_8992;

											BgL_arg6996z00_8991 =
												BGl_labelszd2symzd2zzast_labelsz00();
											{	/* Ast/sexp.scm 575 */
												obj_t BgL_arg6998z00_8993;
												obj_t BgL_arg6999z00_8994;

												{	/* Ast/sexp.scm 575 */
													obj_t BgL_arg7000z00_8995;

													{	/* Ast/sexp.scm 575 */
														obj_t BgL_arg7001z00_8996;

														{	/* Ast/sexp.scm 575 */
															obj_t BgL_arg7002z00_8997;

															BgL_arg7002z00_8997 =
																MAKE_YOUNG_PAIR
																(BGl_normaliza7ezd2prognz75zztools_prognz00
																(BgL_bodyz00_8979), BNIL);
															BgL_arg7001z00_8996 =
																MAKE_YOUNG_PAIR(BgL_argsz00_8978,
																BgL_arg7002z00_8997);
														}
														BgL_arg7000z00_8995 =
															MAKE_YOUNG_PAIR(BgL_funz00_8989,
															BgL_arg7001z00_8996);
													}
													BgL_arg6998z00_8993 =
														MAKE_YOUNG_PAIR(BgL_arg7000z00_8995, BNIL);
												}
												BgL_arg6999z00_8994 =
													MAKE_YOUNG_PAIR(BgL_funz00_8989, BNIL);
												BgL_arg6997z00_8992 =
													MAKE_YOUNG_PAIR(BgL_arg6998z00_8993,
													BgL_arg6999z00_8994);
											}
											BgL_arg6995z00_8990 =
												MAKE_YOUNG_PAIR(BgL_arg6996z00_8991,
												BgL_arg6997z00_8992);
										}
										return
											BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_arg6995z00_8990,
											BgL_stackz00_26, BgL_locz00_8988, BgL_sitez00_28);
									}
								}
							}
						else
							{	/* Ast/sexp.scm 571 */
							BgL_tagzd262401zd2_8981:
								{	/* Ast/sexp.scm 582 */
									obj_t BgL_arg7005z00_9000;

									BgL_arg7005z00_9000 =
										BGl_findzd2locationzf2locz20zztools_locationz00
										(BgL_expz00_25, BgL_locz00_27);
									{	/* Ast/sexp.scm 580 */
										BgL_nodez00_bglt BgL_res7914z00_13505;

										{	/* Ast/sexp.scm 722 */
											obj_t BgL_arg7104z00_13501;
											BgL_nodez00_bglt BgL_arg7105z00_13502;

											BgL_arg7104z00_13501 =
												BGl_shapez00zztools_shapez00
												(BGl_currentzd2functionzd2zztools_errorz00());
											BgL_arg7105z00_13502 =
												BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF((
														(long) 4)), BNIL, BgL_arg7005z00_9000,
												CNST_TABLE_REF(((long) 2)));
											{	/* Ast/sexp.scm 721 */
												obj_t BgL_list7106z00_13504;

												BgL_list7106z00_13504 =
													MAKE_YOUNG_PAIR(((obj_t) BgL_arg7105z00_13502), BNIL);
												BgL_res7914z00_13505 =
													((BgL_nodez00_bglt)
													BGl_userzd2errorzf2locationz20zztools_errorz00
													(BgL_arg7005z00_9000, BgL_arg7104z00_13501,
														BGl_string8007z00zzast_sexpz00, BgL_expz00_25,
														BgL_list7106z00_13504));
										}}
										return BgL_res7914z00_13505;
									}
								}
							}
					}
				else
					{	/* Ast/sexp.scm 571 */
						goto BgL_tagzd262401zd2_8981;
					}
			}
		}

	}



/* variable->node */
	BgL_nodez00_bglt BGl_variablezd2ze3nodez31zzast_sexpz00(obj_t BgL_vz00_30,
		obj_t BgL_locz00_31, obj_t BgL_sitez00_32)
	{
		{	/* Ast/sexp.scm 587 */
			BGl_usezd2variablez12zc0zzast_sexpz00(
				((BgL_variablez00_bglt) BgL_vz00_30), BgL_locz00_31, BgL_sitez00_32);
			{	/* Ast/sexp.scm 589 */
				bool_t BgL_test10498z00_29255;

				if ((BgL_sitez00_32 == CNST_TABLE_REF(((long) 33))))
					{	/* Ast/sexp.scm 589 */
						BgL_test10498z00_29255 = ((bool_t) 0);
					}
				else
					{	/* Ast/sexp.scm 589 */
						BgL_valuez00_bglt BgL_arg7028z00_9032;

						BgL_arg7028z00_9032 =
							(((BgL_variablez00_bglt) COBJECT(
									((BgL_variablez00_bglt) BgL_vz00_30)))->BgL_valuez00);
						{	/* Ast/sexp.scm 589 */
							bool_t BgL_res7917z00_13512;

							BgL_res7917z00_13512 =
								BGl_isazf3zf3zz__objectz00(
								((obj_t) BgL_arg7028z00_9032), BGl_funz00zzast_varz00);
							BgL_test10498z00_29255 = BgL_res7917z00_13512;
						}
					}
				if (BgL_test10498z00_29255)
					{	/* Ast/sexp.scm 590 */
						bool_t BgL_test10500z00_29263;

						if (BGl_isazf3zf3zz__objectz00(BgL_vz00_30,
								BGl_globalz00zzast_varz00))
							{	/* Ast/sexp.scm 591 */
								bool_t BgL_test10502z00_29266;

								{	/* Ast/sexp.scm 591 */
									BgL_valuez00_bglt BgL_arg7025z00_9026;

									BgL_arg7025z00_9026 =
										(((BgL_variablez00_bglt) COBJECT(
												((BgL_variablez00_bglt)
													((BgL_globalz00_bglt) BgL_vz00_30))))->BgL_valuez00);
									{	/* Ast/sexp.scm 591 */
										bool_t BgL_res7919z00_13515;

										BgL_res7919z00_13515 =
											BGl_isazf3zf3zz__objectz00(
											((obj_t) BgL_arg7025z00_9026), BGl_cfunz00zzast_varz00);
										BgL_test10502z00_29266 = BgL_res7919z00_13515;
									}
								}
								if (BgL_test10502z00_29266)
									{	/* Ast/sexp.scm 592 */
										bool_t BgL_test10503z00_29272;

										{	/* Ast/sexp.scm 592 */
											obj_t BgL_arg7024z00_9025;

											BgL_arg7024z00_9025 =
												BGl_thezd2backendzd2zzbackend_backendz00();
											BgL_test10503z00_29272 =
												(((BgL_backendz00_bglt) COBJECT(
														((BgL_backendz00_bglt) BgL_arg7024z00_9025)))->
												BgL_foreignzd2closurezd2);
										}
										if (BgL_test10503z00_29272)
											{	/* Ast/sexp.scm 592 */
												BgL_test10500z00_29263 = ((bool_t) 0);
											}
										else
											{	/* Ast/sexp.scm 592 */
												if ((BgL_sitez00_32 == CNST_TABLE_REF(((long) 30))))
													{	/* Ast/sexp.scm 593 */
														BgL_test10500z00_29263 = ((bool_t) 0);
													}
												else
													{	/* Ast/sexp.scm 593 */
														BgL_test10500z00_29263 = ((bool_t) 1);
													}
											}
									}
								else
									{	/* Ast/sexp.scm 591 */
										BgL_test10500z00_29263 = ((bool_t) 0);
									}
							}
						else
							{	/* Ast/sexp.scm 590 */
								BgL_test10500z00_29263 = ((bool_t) 0);
							}
						if (BgL_test10500z00_29263)
							{	/* Ast/sexp.scm 595 */
								obj_t BgL_arg7018z00_9013;

								{	/* Ast/sexp.scm 595 */
									obj_t BgL_arg7019z00_9014;

									{	/* Ast/sexp.scm 595 */
										obj_t BgL_arg7021z00_9016;

										BgL_arg7021z00_9016 =
											BGl_thezd2backendzd2zzbackend_backendz00();
										BgL_arg7019z00_9014 =
											(((BgL_backendz00_bglt) COBJECT(
													((BgL_backendz00_bglt) BgL_arg7021z00_9016)))->
											BgL_namez00);
									}
									{	/* Ast/sexp.scm 595 */
										obj_t BgL_list7020z00_9015;

										BgL_list7020z00_9015 =
											MAKE_YOUNG_PAIR(BgL_arg7019z00_9014, BNIL);
										BgL_arg7018z00_9013 =
											BGl_formatz00zz__r4_output_6_10_3z00
											(BGl_string8008z00zzast_sexpz00, BgL_list7020z00_9015);
									}
								}
								return
									BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
									(BgL_arg7018z00_9013, BGl_expzd2envzd2zz__r4_numbers_6_5z00,
									BgL_locz00_31);
							}
						else
							{	/* Ast/sexp.scm 596 */
								BgL_closurez00_bglt BgL_new1146z00_9017;

								{	/* Ast/sexp.scm 597 */
									BgL_closurez00_bglt BgL_new1145z00_9019;

									BgL_new1145z00_9019 =
										((BgL_closurez00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
													BgL_closurez00_bgl))));
									{	/* Ast/sexp.scm 597 */
										long BgL_arg7023z00_9020;

										{	/* Ast/sexp.scm 597 */
											long BgL_res7922z00_13523;

											BgL_res7922z00_13523 =
												BGL_CLASS_INDEX(BGl_closurez00zzast_nodez00);
											BgL_arg7023z00_9020 = BgL_res7922z00_13523;
										}
										BGL_OBJECT_CLASS_NUM_SET(
											((BgL_objectz00_bglt) BgL_new1145z00_9019),
											BgL_arg7023z00_9020);
									}
									BgL_new1146z00_9017 = BgL_new1145z00_9019;
								}
								((((BgL_nodez00_bglt) COBJECT(
												((BgL_nodez00_bglt) BgL_new1146z00_9017)))->
										BgL_locz00) = ((obj_t) BgL_locz00_31), BUNSPEC);
								{
									BgL_typez00_bglt BgL_auxz00_29291;

									{	/* Ast/sexp.scm 598 */
										BgL_typez00_bglt BgL_arg7022z00_9018;

										BgL_arg7022z00_9018 =
											(((BgL_variablez00_bglt) COBJECT(
													((BgL_variablez00_bglt) BgL_vz00_30)))->BgL_typez00);
										BgL_auxz00_29291 =
											BGl_strictzd2nodezd2typez00zzast_nodez00(
											((BgL_typez00_bglt)
												BGl_za2procedureza2z00zztype_cachez00),
											BgL_arg7022z00_9018);
									}
									((((BgL_nodez00_bglt) COBJECT(
													((BgL_nodez00_bglt) BgL_new1146z00_9017)))->
											BgL_typez00) =
										((BgL_typez00_bglt) BgL_auxz00_29291), BUNSPEC);
								}
								((((BgL_varz00_bglt) COBJECT(
												((BgL_varz00_bglt) BgL_new1146z00_9017)))->
										BgL_variablez00) =
									((BgL_variablez00_bglt) ((BgL_variablez00_bglt) BgL_vz00_30)),
									BUNSPEC);
								return ((BgL_nodez00_bglt) BgL_new1146z00_9017);
							}
					}
				else
					{	/* Ast/sexp.scm 600 */
						BgL_varz00_bglt BgL_new1148z00_9027;

						{	/* Ast/sexp.scm 601 */
							BgL_varz00_bglt BgL_new1147z00_9029;

							BgL_new1147z00_9029 =
								((BgL_varz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
											BgL_varz00_bgl))));
							{	/* Ast/sexp.scm 601 */
								long BgL_arg7027z00_9030;

								{	/* Ast/sexp.scm 601 */
									long BgL_res7923z00_13528;

									BgL_res7923z00_13528 =
										BGL_CLASS_INDEX(BGl_varz00zzast_nodez00);
									BgL_arg7027z00_9030 = BgL_res7923z00_13528;
								}
								BGL_OBJECT_CLASS_NUM_SET(
									((BgL_objectz00_bglt) BgL_new1147z00_9029),
									BgL_arg7027z00_9030);
							}
							BgL_new1148z00_9027 = BgL_new1147z00_9029;
						}
						((((BgL_nodez00_bglt) COBJECT(
										((BgL_nodez00_bglt) BgL_new1148z00_9027)))->BgL_locz00) =
							((obj_t) BgL_locz00_31), BUNSPEC);
						{
							BgL_typez00_bglt BgL_auxz00_29308;

							{	/* Ast/sexp.scm 602 */
								BgL_typez00_bglt BgL_arg7026z00_9028;

								BgL_arg7026z00_9028 =
									(((BgL_variablez00_bglt) COBJECT(
											((BgL_variablez00_bglt) BgL_vz00_30)))->BgL_typez00);
								BgL_auxz00_29308 =
									BGl_strictzd2nodezd2typez00zzast_nodez00(
									((BgL_typez00_bglt) BGl_za2_za2z00zztype_cachez00),
									BgL_arg7026z00_9028);
							}
							((((BgL_nodez00_bglt) COBJECT(
											((BgL_nodez00_bglt) BgL_new1148z00_9027)))->BgL_typez00) =
								((BgL_typez00_bglt) BgL_auxz00_29308), BUNSPEC);
						}
						((((BgL_varz00_bglt) COBJECT(BgL_new1148z00_9027))->
								BgL_variablez00) =
							((BgL_variablez00_bglt) ((BgL_variablez00_bglt) BgL_vz00_30)),
							BUNSPEC);
						return ((BgL_nodez00_bglt) BgL_new1148z00_9027);
					}
			}
		}

	}



/* call->node */
	BgL_nodez00_bglt BGl_callzd2ze3nodez31zzast_sexpz00(obj_t BgL_expz00_33,
		obj_t BgL_stackz00_34, obj_t BgL_locz00_35, obj_t BgL_sitez00_36)
	{
		{	/* Ast/sexp.scm 608 */
			{	/* Ast/sexp.scm 609 */
				obj_t BgL_callerz00_9033;
				obj_t BgL_locz00_9034;

				BgL_callerz00_9033 = CAR(((obj_t) BgL_expz00_33));
				BgL_locz00_9034 =
					BGl_findzd2locationzf2locz20zztools_locationz00(BgL_expz00_33,
					BgL_locz00_35);
				if (SYMBOLP(BgL_callerz00_9033))
					{	/* Ast/sexp.scm 613 */
						obj_t BgL_pidz00_9036;

						BgL_pidz00_9036 =
							BGl_parsezd2idzd2zzast_identz00(BgL_callerz00_9033,
							BgL_locz00_9034);
						{	/* Ast/sexp.scm 613 */
							obj_t BgL_idz00_9037;

							BgL_idz00_9037 = CAR(BgL_pidz00_9036);
							{	/* Ast/sexp.scm 614 */
								obj_t BgL_typez00_9038;

								BgL_typez00_9038 = CDR(BgL_pidz00_9036);
								{	/* Ast/sexp.scm 615 */

									if ((BgL_idz00_9037 == CNST_TABLE_REF(((long) 6))))
										{	/* Ast/sexp.scm 616 */
											return
												BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00(((bool_t)
													0), BFALSE, ((BgL_typez00_bglt) BgL_typez00_9038),
												BgL_expz00_33, BgL_stackz00_34, BgL_locz00_9034,
												BgL_sitez00_36);
										}
									else
										{	/* Ast/sexp.scm 616 */
											if ((BgL_idz00_9037 == CNST_TABLE_REF(((long) 21))))
												{	/* Ast/sexp.scm 620 */
													bool_t BgL_test10508z00_29334;

													{	/* Ast/sexp.scm 620 */
														obj_t BgL_tmpz00_29335;

														BgL_tmpz00_29335 = CDR(((obj_t) BgL_expz00_33));
														BgL_test10508z00_29334 = PAIRP(BgL_tmpz00_29335);
													}
													if (BgL_test10508z00_29334)
														{	/* Ast/sexp.scm 624 */
															BgL_feffectz00_bglt BgL_arg7034z00_9044;
															obj_t BgL_arg7035z00_9045;

															{	/* Ast/sexp.scm 624 */
																obj_t BgL_arg7036z00_9046;

																{	/* Ast/sexp.scm 624 */
																	obj_t BgL_pairz00_13545;

																	BgL_pairz00_13545 =
																		CDR(((obj_t) BgL_expz00_33));
																	BgL_arg7036z00_9046 = CAR(BgL_pairz00_13545);
																}
																BgL_arg7034z00_9044 =
																	BGl_parsezd2effectzd2zzeffect_feffectz00
																	(BgL_arg7036z00_9046);
															}
															{	/* Ast/sexp.scm 625 */
																obj_t BgL_arg7037z00_9047;
																obj_t BgL_arg7038z00_9048;

																{	/* Ast/sexp.scm 625 */
																	obj_t BgL_arg7039z00_9049;

																	BgL_arg7039z00_9049 =
																		MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 34)),
																		BNIL);
																	BgL_arg7037z00_9047 =
																		MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 35)),
																		BgL_arg7039z00_9049);
																}
																{	/* Ast/sexp.scm 625 */
																	obj_t BgL_auxz00_29347;

																	{	/* Ast/sexp.scm 625 */
																		obj_t BgL_pairz00_13549;

																		BgL_pairz00_13549 =
																			CDR(((obj_t) BgL_expz00_33));
																		BgL_auxz00_29347 = CDR(BgL_pairz00_13549);
																	}
																	BgL_arg7038z00_9048 =
																		BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																		(BgL_auxz00_29347, BNIL);
																}
																BgL_arg7035z00_9045 =
																	MAKE_YOUNG_PAIR(BgL_arg7037z00_9047,
																	BgL_arg7038z00_9048);
															}
															return
																BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00((
																	(bool_t) 0), ((obj_t) BgL_arg7034z00_9044),
																((BgL_typez00_bglt) BgL_typez00_9038),
																BgL_arg7035z00_9045, BgL_stackz00_34,
																BgL_locz00_9034, BgL_sitez00_36);
														}
													else
														{	/* Ast/sexp.scm 623 */
															obj_t BgL_arg7041z00_9051;

															BgL_arg7041z00_9051 =
																BGl_findzd2locationzf2locz20zztools_locationz00
																(BgL_expz00_33, BgL_locz00_9034);
															{	/* Ast/sexp.scm 621 */
																BgL_nodez00_bglt BgL_res7928z00_13555;

																{	/* Ast/sexp.scm 722 */
																	obj_t BgL_arg7104z00_13551;
																	BgL_nodez00_bglt BgL_arg7105z00_13552;

																	BgL_arg7104z00_13551 =
																		BGl_shapez00zztools_shapez00
																		(BGl_currentzd2functionzd2zztools_errorz00
																		());
																	BgL_arg7105z00_13552 =
																		BGl_sexpzd2ze3nodez31zzast_sexpz00
																		(CNST_TABLE_REF(((long) 4)), BNIL,
																		BgL_arg7041z00_9051,
																		CNST_TABLE_REF(((long) 2)));
																	{	/* Ast/sexp.scm 721 */
																		obj_t BgL_list7106z00_13554;

																		BgL_list7106z00_13554 =
																			MAKE_YOUNG_PAIR(
																			((obj_t) BgL_arg7105z00_13552), BNIL);
																		BgL_res7928z00_13555 =
																			((BgL_nodez00_bglt)
																			BGl_userzd2errorzf2locationz20zztools_errorz00
																			(BgL_arg7041z00_9051,
																				BgL_arg7104z00_13551,
																				BGl_string8009z00zzast_sexpz00,
																				BgL_expz00_33, BgL_list7106z00_13554));
																}}
																return BgL_res7928z00_13555;
															}
														}
												}
											else
												{	/* Ast/sexp.scm 616 */
													if ((BgL_idz00_9037 == CNST_TABLE_REF(((long) 22))))
														{	/* Ast/sexp.scm 616 */
															return
																BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00((
																	(bool_t) 1), BFALSE,
																((BgL_typez00_bglt) BgL_typez00_9038),
																BgL_expz00_33, BgL_stackz00_34, BgL_locz00_9034,
																BgL_sitez00_36);
														}
													else
														{	/* Ast/sexp.scm 616 */
															if (
																(BgL_idz00_9037 == CNST_TABLE_REF(((long) 24))))
																{	/* Ast/sexp.scm 630 */
																	bool_t BgL_test10511z00_29374;

																	{	/* Ast/sexp.scm 630 */
																		obj_t BgL_tmpz00_29375;

																		BgL_tmpz00_29375 =
																			CDR(((obj_t) BgL_expz00_33));
																		BgL_test10511z00_29374 =
																			PAIRP(BgL_tmpz00_29375);
																	}
																	if (BgL_test10511z00_29374)
																		{	/* Ast/sexp.scm 634 */
																			BgL_feffectz00_bglt BgL_arg7047z00_9057;
																			obj_t BgL_arg7048z00_9058;

																			{	/* Ast/sexp.scm 634 */
																				obj_t BgL_arg7049z00_9059;

																				{	/* Ast/sexp.scm 634 */
																					obj_t BgL_pairz00_13565;

																					BgL_pairz00_13565 =
																						CDR(((obj_t) BgL_expz00_33));
																					BgL_arg7049z00_9059 =
																						CAR(BgL_pairz00_13565);
																				}
																				BgL_arg7047z00_9057 =
																					BGl_parsezd2effectzd2zzeffect_feffectz00
																					(BgL_arg7049z00_9059);
																			}
																			{	/* Ast/sexp.scm 635 */
																				obj_t BgL_arg7050z00_9060;
																				obj_t BgL_arg7051z00_9061;

																				{	/* Ast/sexp.scm 635 */
																					obj_t BgL_arg7052z00_9062;

																					BgL_arg7052z00_9062 =
																						MAKE_YOUNG_PAIR(CNST_TABLE_REF((
																								(long) 34)), BNIL);
																					BgL_arg7050z00_9060 =
																						MAKE_YOUNG_PAIR(CNST_TABLE_REF((
																								(long) 35)),
																						BgL_arg7052z00_9062);
																				}
																				{	/* Ast/sexp.scm 635 */
																					obj_t BgL_auxz00_29387;

																					{	/* Ast/sexp.scm 635 */
																						obj_t BgL_pairz00_13569;

																						BgL_pairz00_13569 =
																							CDR(((obj_t) BgL_expz00_33));
																						BgL_auxz00_29387 =
																							CDR(BgL_pairz00_13569);
																					}
																					BgL_arg7051z00_9061 =
																						BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																						(BgL_auxz00_29387, BNIL);
																				}
																				BgL_arg7048z00_9058 =
																					MAKE_YOUNG_PAIR(BgL_arg7050z00_9060,
																					BgL_arg7051z00_9061);
																			}
																			return
																				BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00
																				(((bool_t) 1),
																				((obj_t) BgL_arg7047z00_9057),
																				((BgL_typez00_bglt) BgL_typez00_9038),
																				BgL_arg7048z00_9058, BgL_stackz00_34,
																				BgL_locz00_9034, BgL_sitez00_36);
																		}
																	else
																		{	/* Ast/sexp.scm 633 */
																			obj_t BgL_arg7054z00_9064;

																			BgL_arg7054z00_9064 =
																				BGl_findzd2locationzf2locz20zztools_locationz00
																				(BgL_expz00_33, BgL_locz00_9034);
																			{	/* Ast/sexp.scm 631 */
																				BgL_nodez00_bglt BgL_res7932z00_13575;

																				{	/* Ast/sexp.scm 722 */
																					obj_t BgL_arg7104z00_13571;
																					BgL_nodez00_bglt BgL_arg7105z00_13572;

																					BgL_arg7104z00_13571 =
																						BGl_shapez00zztools_shapez00
																						(BGl_currentzd2functionzd2zztools_errorz00
																						());
																					BgL_arg7105z00_13572 =
																						BGl_sexpzd2ze3nodez31zzast_sexpz00
																						(CNST_TABLE_REF(((long) 4)), BNIL,
																						BgL_arg7054z00_9064,
																						CNST_TABLE_REF(((long) 2)));
																					{	/* Ast/sexp.scm 721 */
																						obj_t BgL_list7106z00_13574;

																						BgL_list7106z00_13574 =
																							MAKE_YOUNG_PAIR(
																							((obj_t) BgL_arg7105z00_13572),
																							BNIL);
																						BgL_res7932z00_13575 =
																							((BgL_nodez00_bglt)
																							BGl_userzd2errorzf2locationz20zztools_errorz00
																							(BgL_arg7054z00_9064,
																								BgL_arg7104z00_13571,
																								BGl_string8010z00zzast_sexpz00,
																								BgL_expz00_33,
																								BgL_list7106z00_13574));
																				}}
																				return BgL_res7932z00_13575;
																			}
																		}
																}
															else
																{	/* Ast/sexp.scm 616 */
																	if (
																		(BgL_idz00_9037 ==
																			CNST_TABLE_REF(((long) 3))))
																		{
																			obj_t BgL_argsz00_9067;
																			obj_t BgL_bodyz00_9068;

																			if (PAIRP(BgL_expz00_33))
																				{	/* Ast/sexp.scm 638 */
																					obj_t BgL_cdrzd262423zd2_9073;

																					BgL_cdrzd262423zd2_9073 =
																						CDR(BgL_expz00_33);
																					if (PAIRP(BgL_cdrzd262423zd2_9073))
																						{	/* Ast/sexp.scm 638 */
																							BgL_argsz00_9067 =
																								CAR(BgL_cdrzd262423zd2_9073);
																							BgL_bodyz00_9068 =
																								CDR(BgL_cdrzd262423zd2_9073);
																							{	/* Ast/sexp.scm 640 */
																								obj_t BgL_locz00_9077;

																								BgL_locz00_9077 =
																									BGl_findzd2locationzf2locz20zztools_locationz00
																									(BgL_expz00_33,
																									BgL_locz00_9034);
																								{	/* Ast/sexp.scm 640 */
																									obj_t BgL_funz00_9078;

																									BgL_funz00_9078 =
																										BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
																										(BGl_gensymz00zz__r4_symbols_6_4z00
																										(CNST_TABLE_REF(((long)
																													3))));
																									{	/* Ast/sexp.scm 641 */
																										obj_t BgL_tfunz00_9079;

																										if (BGl_bigloozd2typezf3z21zztype_typez00(((BgL_typez00_bglt) BgL_typez00_9038)))
																											{	/* Ast/sexp.scm 643 */
																												obj_t
																													BgL_arg7071z00_9090;
																												BgL_arg7071z00_9090 =
																													(((BgL_typez00_bglt)
																														COBJECT((
																																(BgL_typez00_bglt)
																																BgL_typez00_9038)))->
																													BgL_idz00);
																												BgL_tfunz00_9079 =
																													BGl_makezd2typedzd2identz00zzast_identz00
																													(BgL_funz00_9078,
																													BgL_arg7071z00_9090);
																											}
																										else
																											{	/* Ast/sexp.scm 642 */
																												BgL_tfunz00_9079 =
																													BgL_funz00_9078;
																											}
																										{	/* Ast/sexp.scm 642 */

																											{	/* Ast/sexp.scm 646 */
																												obj_t
																													BgL_arg7061z00_9080;
																												{	/* Ast/sexp.scm 646 */
																													obj_t
																														BgL_arg7062z00_9081;
																													obj_t
																														BgL_arg7063z00_9082;
																													BgL_arg7062z00_9081 =
																														BGl_labelszd2symzd2zzast_labelsz00
																														();
																													{	/* Ast/sexp.scm 646 */
																														obj_t
																															BgL_arg7064z00_9083;
																														obj_t
																															BgL_arg7065z00_9084;
																														{	/* Ast/sexp.scm 646 */
																															obj_t
																																BgL_arg7066z00_9085;
																															{	/* Ast/sexp.scm 646 */
																																obj_t
																																	BgL_arg7067z00_9086;
																																{	/* Ast/sexp.scm 646 */
																																	obj_t
																																		BgL_arg7068z00_9087;
																																	BgL_arg7068z00_9087
																																		=
																																		MAKE_YOUNG_PAIR
																																		(BGl_normaliza7ezd2prognz75zztools_prognz00
																																		(BgL_bodyz00_9068),
																																		BNIL);
																																	BgL_arg7067z00_9086
																																		=
																																		MAKE_YOUNG_PAIR
																																		(BgL_argsz00_9067,
																																		BgL_arg7068z00_9087);
																																}
																																BgL_arg7066z00_9085
																																	=
																																	MAKE_YOUNG_PAIR
																																	(BgL_tfunz00_9079,
																																	BgL_arg7067z00_9086);
																															}
																															BgL_arg7064z00_9083
																																=
																																MAKE_YOUNG_PAIR
																																(BgL_arg7066z00_9085,
																																BNIL);
																														}
																														BgL_arg7065z00_9084
																															=
																															MAKE_YOUNG_PAIR
																															(BgL_funz00_9078,
																															BNIL);
																														BgL_arg7063z00_9082
																															=
																															MAKE_YOUNG_PAIR
																															(BgL_arg7064z00_9083,
																															BgL_arg7065z00_9084);
																													}
																													BgL_arg7061z00_9080 =
																														MAKE_YOUNG_PAIR
																														(BgL_arg7062z00_9081,
																														BgL_arg7063z00_9082);
																												}
																												return
																													BGl_sexpzd2ze3nodez31zzast_sexpz00
																													(BgL_arg7061z00_9080,
																													BgL_stackz00_34,
																													BgL_locz00_9077,
																													BgL_sitez00_36);
																											}
																										}
																									}
																								}
																							}
																						}
																					else
																						{	/* Ast/sexp.scm 638 */
																						BgL_tagzd262416zd2_9070:
																							{	/* Ast/sexp.scm 652 */
																								BgL_nodez00_bglt
																									BgL_res7934z00_13584;
																								{	/* Ast/sexp.scm 722 */
																									obj_t BgL_arg7104z00_13580;
																									BgL_nodez00_bglt
																										BgL_arg7105z00_13581;
																									BgL_arg7104z00_13580 =
																										BGl_shapez00zztools_shapez00
																										(BGl_currentzd2functionzd2zztools_errorz00
																										());
																									BgL_arg7105z00_13581 =
																										BGl_sexpzd2ze3nodez31zzast_sexpz00
																										(CNST_TABLE_REF(((long) 4)),
																										BNIL, BgL_locz00_9034,
																										CNST_TABLE_REF(((long) 2)));
																									{	/* Ast/sexp.scm 721 */
																										obj_t BgL_list7106z00_13583;

																										BgL_list7106z00_13583 =
																											MAKE_YOUNG_PAIR(
																											((obj_t)
																												BgL_arg7105z00_13581),
																											BNIL);
																										BgL_res7934z00_13584 =
																											((BgL_nodez00_bglt)
																											BGl_userzd2errorzf2locationz20zztools_errorz00
																											(BgL_locz00_9034,
																												BgL_arg7104z00_13580,
																												BGl_string8011z00zzast_sexpz00,
																												BgL_expz00_33,
																												BgL_list7106z00_13583));
																								}}
																								return BgL_res7934z00_13584;
																							}
																						}
																				}
																			else
																				{	/* Ast/sexp.scm 638 */
																					goto BgL_tagzd262416zd2_9070;
																				}
																		}
																	else
																		{	/* Ast/sexp.scm 616 */
																			return
																				BGl_applicationzd2ze3nodez31zzast_appz00
																				(BgL_expz00_33, BgL_stackz00_34,
																				BgL_locz00_9034, BgL_sitez00_36);
																		}
																}
														}
												}
										}
								}
							}
						}
					}
				else
					{	/* Ast/sexp.scm 611 */
						return
							BGl_applicationzd2ze3nodez31zzast_appz00(BgL_expz00_33,
							BgL_stackz00_34, BgL_locz00_9034, BgL_sitez00_36);
					}
			}
		}

	}



/* sexp*->node */
	BGL_EXPORTED_DEF obj_t BGl_sexpza2zd2ze3nodez93zzast_sexpz00(obj_t
		BgL_expza2za2_37, obj_t BgL_stackz00_38, obj_t BgL_locz00_39,
		obj_t BgL_sitez00_40)
	{
		{	/* Ast/sexp.scm 660 */
			{
				obj_t BgL_expsz00_9094;
				obj_t BgL_resz00_9095;
				obj_t BgL_locz00_9096;

				BgL_expsz00_9094 = BgL_expza2za2_37;
				BgL_resz00_9095 = BNIL;
				BgL_locz00_9096 = BgL_locz00_39;
			BgL_zc3z04anonymousza37073ze3z87_9097:
				if (NULLP(BgL_expsz00_9094))
					{	/* Ast/sexp.scm 666 */
						BgL_nodez00_bglt BgL_res7938z00_13596;

						{	/* Ast/sexp.scm 722 */
							obj_t BgL_arg7104z00_13592;
							BgL_nodez00_bglt BgL_arg7105z00_13593;

							BgL_arg7104z00_13592 =
								BGl_shapez00zztools_shapez00
								(BGl_currentzd2functionzd2zztools_errorz00());
							BgL_arg7105z00_13593 =
								BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 4)),
								BNIL, BgL_locz00_9096, CNST_TABLE_REF(((long) 2)));
							{	/* Ast/sexp.scm 721 */
								obj_t BgL_list7106z00_13595;

								BgL_list7106z00_13595 =
									MAKE_YOUNG_PAIR(((obj_t) BgL_arg7105z00_13593), BNIL);
								BgL_res7938z00_13596 =
									((BgL_nodez00_bglt)
									BGl_userzd2errorzf2locationz20zztools_errorz00
									(BgL_locz00_9096, BgL_arg7104z00_13592,
										BGl_string8012z00zzast_sexpz00, BgL_expsz00_9094,
										BgL_list7106z00_13595));
						}}
						return ((obj_t) BgL_res7938z00_13596);
					}
				else
					{	/* Ast/sexp.scm 665 */
						if (NULLP(CDR(((obj_t) BgL_expsz00_9094))))
							{	/* Ast/sexp.scm 668 */
								obj_t BgL_locz00_9101;
								obj_t BgL_nsitez00_9102;

								{	/* Ast/sexp.scm 668 */
									obj_t BgL_arg7080z00_9106;
									obj_t BgL_arg7081z00_9107;

									BgL_arg7080z00_9106 = CAR(((obj_t) BgL_expsz00_9094));
									BgL_arg7081z00_9107 =
										BGl_findzd2locationzf2locz20zztools_locationz00
										(BgL_expsz00_9094, BgL_locz00_9096);
									BgL_locz00_9101 =
										BGl_findzd2locationzf2locz20zztools_locationz00
										(BgL_arg7080z00_9106, BgL_arg7081z00_9107);
								}
								if ((BgL_sitez00_40 == CNST_TABLE_REF(((long) 33))))
									{	/* Ast/sexp.scm 670 */
										BgL_nsitez00_9102 = CNST_TABLE_REF(((long) 2));
									}
								else
									{	/* Ast/sexp.scm 670 */
										BgL_nsitez00_9102 = BgL_sitez00_40;
									}
								{	/* Ast/sexp.scm 671 */
									obj_t BgL_arg7077z00_9103;

									{	/* Ast/sexp.scm 671 */
										BgL_nodez00_bglt BgL_arg7078z00_9104;

										{	/* Ast/sexp.scm 671 */
											obj_t BgL_arg7079z00_9105;

											BgL_arg7079z00_9105 = CAR(((obj_t) BgL_expsz00_9094));
											BgL_arg7078z00_9104 =
												BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_arg7079z00_9105,
												BgL_stackz00_38, BgL_locz00_9101, BgL_nsitez00_9102);
										}
										BgL_arg7077z00_9103 =
											MAKE_YOUNG_PAIR(
											((obj_t) BgL_arg7078z00_9104), BgL_resz00_9095);
									}
									return bgl_reverse_bang(BgL_arg7077z00_9103);
								}
							}
						else
							{	/* Ast/sexp.scm 673 */
								obj_t BgL_locz00_9109;

								{	/* Ast/sexp.scm 673 */
									obj_t BgL_arg7087z00_9114;
									obj_t BgL_arg7088z00_9115;

									BgL_arg7087z00_9114 = CAR(((obj_t) BgL_expsz00_9094));
									BgL_arg7088z00_9115 =
										BGl_findzd2locationzf2locz20zztools_locationz00
										(BgL_expsz00_9094, BgL_locz00_9096);
									BgL_locz00_9109 =
										BGl_findzd2locationzf2locz20zztools_locationz00
										(BgL_arg7087z00_9114, BgL_arg7088z00_9115);
								}
								{	/* Ast/sexp.scm 675 */
									obj_t BgL_arg7083z00_9110;
									obj_t BgL_arg7084z00_9111;

									BgL_arg7083z00_9110 = CDR(((obj_t) BgL_expsz00_9094));
									{	/* Ast/sexp.scm 676 */
										BgL_nodez00_bglt BgL_arg7085z00_9112;

										{	/* Ast/sexp.scm 676 */
											obj_t BgL_arg7086z00_9113;

											BgL_arg7086z00_9113 = CAR(((obj_t) BgL_expsz00_9094));
											BgL_arg7085z00_9112 =
												BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_arg7086z00_9113,
												BgL_stackz00_38, BgL_locz00_9109,
												CNST_TABLE_REF(((long) 2)));
										}
										BgL_arg7084z00_9111 =
											MAKE_YOUNG_PAIR(
											((obj_t) BgL_arg7085z00_9112), BgL_resz00_9095);
									}
									{
										obj_t BgL_locz00_29491;
										obj_t BgL_resz00_29490;
										obj_t BgL_expsz00_29489;

										BgL_expsz00_29489 = BgL_arg7083z00_9110;
										BgL_resz00_29490 = BgL_arg7084z00_9111;
										BgL_locz00_29491 = BgL_locz00_9109;
										BgL_locz00_9096 = BgL_locz00_29491;
										BgL_resz00_9095 = BgL_resz00_29490;
										BgL_expsz00_9094 = BgL_expsz00_29489;
										goto BgL_zc3z04anonymousza37073ze3z87_9097;
									}
								}
							}
					}
			}
		}

	}



/* &sexp*->node */
	obj_t BGl_z62sexpza2zd2ze3nodezf1zzast_sexpz00(obj_t BgL_envz00_13765,
		obj_t BgL_expza2za2_13766, obj_t BgL_stackz00_13767, obj_t BgL_locz00_13768,
		obj_t BgL_sitez00_13769)
	{
		{	/* Ast/sexp.scm 660 */
			return
				BGl_sexpza2zd2ze3nodez93zzast_sexpz00(BgL_expza2za2_13766,
				BgL_stackz00_13767, BgL_locz00_13768, BgL_sitez00_13769);
		}

	}



/* find-local */
	BGL_EXPORTED_DEF obj_t BGl_findzd2localzd2zzast_sexpz00(obj_t BgL_namez00_41,
		obj_t BgL_stackz00_42)
	{
		{	/* Ast/sexp.scm 689 */
			{	/* Ast/sexp.scm 690 */
				bool_t BgL_test10519z00_29493;

				if ((BgL_namez00_41 == BGl_za2cachezd2nameza2zd2zzast_sexpz00))
					{	/* Ast/sexp.scm 690 */
						BgL_test10519z00_29493 =
							(BgL_stackz00_42 == BGl_za2cachezd2stackza2zd2zzast_sexpz00);
					}
				else
					{	/* Ast/sexp.scm 690 */
						BgL_test10519z00_29493 = ((bool_t) 0);
					}
				if (BgL_test10519z00_29493)
					{	/* Ast/sexp.scm 690 */
						return BGl_za2cachezd2resza2zd2zzast_sexpz00;
					}
				else
					{	/* Ast/sexp.scm 690 */
						BGl_za2cachezd2nameza2zd2zzast_sexpz00 = BgL_namez00_41;
						BGl_za2cachezd2stackza2zd2zzast_sexpz00 = BgL_stackz00_42;
						{
							obj_t BgL_stackz00_9121;

							BgL_stackz00_9121 = BgL_stackz00_42;
						BgL_zc3z04anonymousza37092ze3z87_9122:
							if (NULLP(BgL_stackz00_9121))
								{	/* Ast/sexp.scm 697 */
									BGl_za2cachezd2resza2zd2zzast_sexpz00 = BFALSE;
									return BFALSE;
								}
							else
								{	/* Ast/sexp.scm 697 */
									if (
										((((BgL_variablez00_bglt) COBJECT(
														((BgL_variablez00_bglt)
															((BgL_localz00_bglt)
																CAR(
																	((obj_t) BgL_stackz00_9121))))))->
												BgL_idz00) == BgL_namez00_41))
										{	/* Ast/sexp.scm 700 */
											BGl_za2cachezd2resza2zd2zzast_sexpz00 =
												CAR(((obj_t) BgL_stackz00_9121));
											return CAR(((obj_t) BgL_stackz00_9121));
										}
									else
										{	/* Ast/sexp.scm 704 */
											obj_t BgL_arg7097z00_9127;

											BgL_arg7097z00_9127 = CDR(((obj_t) BgL_stackz00_9121));
											{
												obj_t BgL_stackz00_29512;

												BgL_stackz00_29512 = BgL_arg7097z00_9127;
												BgL_stackz00_9121 = BgL_stackz00_29512;
												goto BgL_zc3z04anonymousza37092ze3z87_9122;
											}
										}
								}
						}
					}
			}
		}

	}



/* &find-local */
	obj_t BGl_z62findzd2localzb0zzast_sexpz00(obj_t BgL_envz00_13770,
		obj_t BgL_namez00_13771, obj_t BgL_stackz00_13772)
	{
		{	/* Ast/sexp.scm 689 */
			return
				BGl_findzd2localzd2zzast_sexpz00(BgL_namez00_13771, BgL_stackz00_13772);
		}

	}



/* use-variable! */
	BGL_EXPORTED_DEF obj_t
		BGl_usezd2variablez12zc0zzast_sexpz00(BgL_variablez00_bglt BgL_varz00_43,
		obj_t BgL_locz00_44, obj_t BgL_sitez00_45)
	{
		{	/* Ast/sexp.scm 709 */
			if ((BgL_sitez00_45 == CNST_TABLE_REF(((long) 7))))
				{	/* Ast/sexp.scm 712 */
					obj_t BgL_vz00_13611;

					BgL_vz00_13611 = CNST_TABLE_REF(((long) 36));
					((((BgL_variablez00_bglt) COBJECT(BgL_varz00_43))->BgL_accessz00) =
						((obj_t) BgL_vz00_13611), BUNSPEC);
				}
			else
				{	/* Ast/sexp.scm 711 */
					BFALSE;
				}
			{	/* Ast/sexp.scm 713 */
				BgL_valuez00_bglt BgL_valz00_9133;

				BgL_valz00_9133 =
					(((BgL_variablez00_bglt) COBJECT(BgL_varz00_43))->BgL_valuez00);
				{	/* Ast/sexp.scm 714 */
					bool_t BgL_test10524z00_29520;

					if ((BgL_sitez00_45 == CNST_TABLE_REF(((long) 7))))
						{	/* Ast/sexp.scm 714 */
							bool_t BgL_res7941z00_13613;

							BgL_res7941z00_13613 =
								BGl_isazf3zf3zz__objectz00(
								((obj_t) BgL_valz00_9133), BGl_funz00zzast_varz00);
							BgL_test10524z00_29520 = BgL_res7941z00_13613;
						}
					else
						{	/* Ast/sexp.scm 714 */
							BgL_test10524z00_29520 = ((bool_t) 0);
						}
					if (BgL_test10524z00_29520)
						{	/* Ast/sexp.scm 715 */
							obj_t BgL_arg7103z00_9136;

							BgL_arg7103z00_9136 =
								BGl_shapez00zztools_shapez00(((obj_t) BgL_varz00_43));
							{	/* Ast/sexp.scm 715 */
								BgL_nodez00_bglt BgL_res7942z00_13619;

								{	/* Ast/sexp.scm 722 */
									obj_t BgL_arg7104z00_13615;
									BgL_nodez00_bglt BgL_arg7105z00_13616;

									BgL_arg7104z00_13615 =
										BGl_shapez00zztools_shapez00
										(BGl_currentzd2functionzd2zztools_errorz00());
									BgL_arg7105z00_13616 =
										BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long)
												4)), BNIL, BgL_locz00_44, CNST_TABLE_REF(((long) 2)));
									{	/* Ast/sexp.scm 721 */
										obj_t BgL_list7106z00_13618;

										BgL_list7106z00_13618 =
											MAKE_YOUNG_PAIR(((obj_t) BgL_arg7105z00_13616), BNIL);
										BgL_res7942z00_13619 =
											((BgL_nodez00_bglt)
											BGl_userzd2errorzf2locationz20zztools_errorz00
											(BgL_locz00_44, BgL_arg7104z00_13615,
												BGl_string8013z00zzast_sexpz00, BgL_arg7103z00_9136,
												BgL_list7106z00_13618));
								}}
								return ((obj_t) BgL_res7942z00_13619);
							}
						}
					else
						{	/* Ast/sexp.scm 714 */
							return BFALSE;
						}
				}
			}
		}

	}



/* &use-variable! */
	obj_t BGl_z62usezd2variablez12za2zzast_sexpz00(obj_t BgL_envz00_13773,
		obj_t BgL_varz00_13774, obj_t BgL_locz00_13775, obj_t BgL_sitez00_13776)
	{
		{	/* Ast/sexp.scm 709 */
			return
				BGl_usezd2variablez12zc0zzast_sexpz00(
				((BgL_variablez00_bglt) BgL_varz00_13774), BgL_locz00_13775,
				BgL_sitez00_13776);
		}

	}



/* error-sexp->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(obj_t BgL_msgz00_46,
		obj_t BgL_expz00_47, obj_t BgL_locz00_48)
	{
		{	/* Ast/sexp.scm 720 */
			{	/* Ast/sexp.scm 722 */
				obj_t BgL_arg7104z00_9138;
				BgL_nodez00_bglt BgL_arg7105z00_9139;

				BgL_arg7104z00_9138 =
					BGl_shapez00zztools_shapez00(BGl_currentzd2functionzd2zztools_errorz00
					());
				BgL_arg7105z00_9139 =
					BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 4)), BNIL,
					BgL_locz00_48, CNST_TABLE_REF(((long) 2)));
				{	/* Ast/sexp.scm 721 */
					obj_t BgL_list7106z00_9140;

					BgL_list7106z00_9140 =
						MAKE_YOUNG_PAIR(((obj_t) BgL_arg7105z00_9139), BNIL);
					return
						((BgL_nodez00_bglt)
						BGl_userzd2errorzf2locationz20zztools_errorz00(BgL_locz00_48,
							BgL_arg7104z00_9138, BgL_msgz00_46, BgL_expz00_47,
							BgL_list7106z00_9140));
				}
			}
		}

	}



/* &error-sexp->node */
	BgL_nodez00_bglt BGl_z62errorzd2sexpzd2ze3nodez81zzast_sexpz00(obj_t
		BgL_envz00_13777, obj_t BgL_msgz00_13778, obj_t BgL_expz00_13779,
		obj_t BgL_locz00_13780)
	{
		{	/* Ast/sexp.scm 720 */
			return
				BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(BgL_msgz00_13778,
				BgL_expz00_13779, BgL_locz00_13780);
		}

	}



/* define-primop-ref->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_definezd2primopzd2refzd2ze3nodez31zzast_sexpz00(BgL_globalz00_bglt
		BgL_globalz00_49, BgL_nodez00_bglt BgL_refz00_50)
	{
		{	/* Ast/sexp.scm 730 */
			{	/* Ast/sexp.scm 731 */
				BgL_nodez00_bglt BgL_funz00_9142;

				BgL_funz00_9142 =
					BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 37)), BNIL,
					BFALSE, CNST_TABLE_REF(((long) 33)));
				{	/* Ast/sexp.scm 732 */
					bool_t BgL_test10526z00_29553;

					{	/* Ast/sexp.scm 732 */
						bool_t BgL_res7943z00_13620;

						BgL_res7943z00_13620 =
							BGl_isazf3zf3zz__objectz00(
							((obj_t) BgL_funz00_9142), BGl_varz00zzast_nodez00);
						BgL_test10526z00_29553 = BgL_res7943z00_13620;
					}
					if (BgL_test10526z00_29553)
						{	/* Ast/sexp.scm 733 */
							BgL_appz00_bglt BgL_new1152z00_9144;

							{	/* Ast/sexp.scm 733 */
								BgL_appz00_bglt BgL_new1151z00_9151;

								BgL_new1151z00_9151 =
									((BgL_appz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
												BgL_appz00_bgl))));
								{	/* Ast/sexp.scm 733 */
									long BgL_arg7115z00_9152;

									{	/* Ast/sexp.scm 733 */
										long BgL_res7944z00_13622;

										BgL_res7944z00_13622 =
											BGL_CLASS_INDEX(BGl_appz00zzast_nodez00);
										BgL_arg7115z00_9152 = BgL_res7944z00_13622;
									}
									BGL_OBJECT_CLASS_NUM_SET(
										((BgL_objectz00_bglt) BgL_new1151z00_9151),
										BgL_arg7115z00_9152);
								}
								{	/* Ast/sexp.scm 733 */
									BgL_objectz00_bglt BgL_tmpz00_29560;

									BgL_tmpz00_29560 = ((BgL_objectz00_bglt) BgL_new1151z00_9151);
									BGL_OBJECT_WIDENING_SET(BgL_tmpz00_29560, BFALSE);
								}
								((BgL_objectz00_bglt) BgL_new1151z00_9151);
								BgL_new1152z00_9144 = BgL_new1151z00_9151;
							}
							((((BgL_nodez00_bglt) COBJECT(
											((BgL_nodez00_bglt) BgL_new1152z00_9144)))->BgL_locz00) =
								((obj_t) BFALSE), BUNSPEC);
							((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
												BgL_new1152z00_9144)))->BgL_typez00) =
								((BgL_typez00_bglt) ((BgL_typez00_bglt)
										BGl_za2_za2z00zztype_cachez00)), BUNSPEC);
							((((BgL_nodezf2effectzf2_bglt)
										COBJECT(((BgL_nodezf2effectzf2_bglt)
												BgL_new1152z00_9144)))->BgL_sidezd2effectzd2) =
								((obj_t) BUNSPEC), BUNSPEC);
							((((BgL_nodezf2effectzf2_bglt)
										COBJECT(((BgL_nodezf2effectzf2_bglt)
												BgL_new1152z00_9144)))->BgL_keyz00) =
								((obj_t) BINT(((long) -1))), BUNSPEC);
							((((BgL_appz00_bglt) COBJECT(BgL_new1152z00_9144))->BgL_funz00) =
								((BgL_varz00_bglt) ((BgL_varz00_bglt) BgL_funz00_9142)),
								BUNSPEC);
							{
								obj_t BgL_auxz00_29576;

								{	/* Ast/sexp.scm 736 */
									BgL_nodez00_bglt BgL_arg7109z00_9145;

									{	/* Ast/sexp.scm 736 */
										obj_t BgL_arg7112z00_9148;

										{	/* Ast/sexp.scm 736 */
											obj_t BgL_arg7113z00_9149;

											{	/* Ast/sexp.scm 736 */
												obj_t BgL_arg7114z00_9150;

												BgL_arg7114z00_9150 =
													(((BgL_variablez00_bglt) COBJECT(
															((BgL_variablez00_bglt) BgL_globalz00_49)))->
													BgL_idz00);
												BgL_arg7113z00_9149 =
													MAKE_YOUNG_PAIR(BgL_arg7114z00_9150, BNIL);
											}
											BgL_arg7112z00_9148 =
												MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 12)),
												BgL_arg7113z00_9149);
										}
										BgL_arg7109z00_9145 =
											BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_arg7112z00_9148,
											BNIL, BFALSE, CNST_TABLE_REF(((long) 2)));
									}
									{	/* Ast/sexp.scm 736 */
										obj_t BgL_list7110z00_9146;

										{	/* Ast/sexp.scm 736 */
											obj_t BgL_arg7111z00_9147;

											BgL_arg7111z00_9147 =
												MAKE_YOUNG_PAIR(((obj_t) BgL_refz00_50), BNIL);
											BgL_list7110z00_9146 =
												MAKE_YOUNG_PAIR(
												((obj_t) BgL_arg7109z00_9145), BgL_arg7111z00_9147);
										}
										BgL_auxz00_29576 = BgL_list7110z00_9146;
								}}
								((((BgL_appz00_bglt) COBJECT(BgL_new1152z00_9144))->
										BgL_argsz00) = ((obj_t) BgL_auxz00_29576), BUNSPEC);
							}
							return ((BgL_nodez00_bglt) BgL_new1152z00_9144);
						}
					else
						{	/* Ast/sexp.scm 732 */
							return BgL_funz00_9142;
						}
				}
			}
		}

	}



/* &define-primop-ref->node */
	BgL_nodez00_bglt BGl_z62definezd2primopzd2refzd2ze3nodez53zzast_sexpz00(obj_t
		BgL_envz00_13781, obj_t BgL_globalz00_13782, obj_t BgL_refz00_13783)
	{
		{	/* Ast/sexp.scm 730 */
			return
				BGl_definezd2primopzd2refzd2ze3nodez31zzast_sexpz00(
				((BgL_globalz00_bglt) BgL_globalz00_13782),
				((BgL_nodez00_bglt) BgL_refz00_13783));
		}

	}



/* define-primop->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_definezd2primopzd2ze3nodeze3zzast_sexpz00(BgL_globalz00_bglt
		BgL_globalz00_51)
	{
		{	/* Ast/sexp.scm 742 */
			BGl_usezd2variablez12zc0zzast_sexpz00(
				((BgL_variablez00_bglt) BgL_globalz00_51), BFALSE,
				CNST_TABLE_REF(((long) 2)));
			{	/* Ast/sexp.scm 744 */
				BgL_nodez00_bglt BgL_funz00_9153;

				BgL_funz00_9153 =
					BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 38)), BNIL,
					BFALSE, CNST_TABLE_REF(((long) 33)));
				{	/* Ast/sexp.scm 745 */
					bool_t BgL_test10527z00_29599;

					{	/* Ast/sexp.scm 745 */
						bool_t BgL_res7946z00_13628;

						BgL_res7946z00_13628 =
							BGl_isazf3zf3zz__objectz00(
							((obj_t) BgL_funz00_9153), BGl_varz00zzast_nodez00);
						BgL_test10527z00_29599 = BgL_res7946z00_13628;
					}
					if (BgL_test10527z00_29599)
						{	/* Ast/sexp.scm 746 */
							BgL_appz00_bglt BgL_new1154z00_9155;

							{	/* Ast/sexp.scm 746 */
								BgL_appz00_bglt BgL_new1153z00_9163;

								BgL_new1153z00_9163 =
									((BgL_appz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
												BgL_appz00_bgl))));
								{	/* Ast/sexp.scm 746 */
									long BgL_arg7124z00_9164;

									{	/* Ast/sexp.scm 746 */
										long BgL_res7947z00_13630;

										BgL_res7947z00_13630 =
											BGL_CLASS_INDEX(BGl_appz00zzast_nodez00);
										BgL_arg7124z00_9164 = BgL_res7947z00_13630;
									}
									BGL_OBJECT_CLASS_NUM_SET(
										((BgL_objectz00_bglt) BgL_new1153z00_9163),
										BgL_arg7124z00_9164);
								}
								{	/* Ast/sexp.scm 746 */
									BgL_objectz00_bglt BgL_tmpz00_29606;

									BgL_tmpz00_29606 = ((BgL_objectz00_bglt) BgL_new1153z00_9163);
									BGL_OBJECT_WIDENING_SET(BgL_tmpz00_29606, BFALSE);
								}
								((BgL_objectz00_bglt) BgL_new1153z00_9163);
								BgL_new1154z00_9155 = BgL_new1153z00_9163;
							}
							((((BgL_nodez00_bglt) COBJECT(
											((BgL_nodez00_bglt) BgL_new1154z00_9155)))->BgL_locz00) =
								((obj_t) BFALSE), BUNSPEC);
							((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
												BgL_new1154z00_9155)))->BgL_typez00) =
								((BgL_typez00_bglt) ((BgL_typez00_bglt)
										BGl_za2_za2z00zztype_cachez00)), BUNSPEC);
							((((BgL_nodezf2effectzf2_bglt)
										COBJECT(((BgL_nodezf2effectzf2_bglt)
												BgL_new1154z00_9155)))->BgL_sidezd2effectzd2) =
								((obj_t) BUNSPEC), BUNSPEC);
							((((BgL_nodezf2effectzf2_bglt)
										COBJECT(((BgL_nodezf2effectzf2_bglt)
												BgL_new1154z00_9155)))->BgL_keyz00) =
								((obj_t) BINT(((long) -1))), BUNSPEC);
							((((BgL_appz00_bglt) COBJECT(BgL_new1154z00_9155))->BgL_funz00) =
								((BgL_varz00_bglt) ((BgL_varz00_bglt) BgL_funz00_9153)),
								BUNSPEC);
							{
								obj_t BgL_auxz00_29622;

								{	/* Ast/sexp.scm 749 */
									BgL_nodez00_bglt BgL_arg7117z00_9156;
									BgL_nodez00_bglt BgL_arg7118z00_9157;

									{	/* Ast/sexp.scm 749 */
										obj_t BgL_arg7121z00_9160;

										{	/* Ast/sexp.scm 749 */
											obj_t BgL_arg7122z00_9161;

											{	/* Ast/sexp.scm 749 */
												obj_t BgL_arg7123z00_9162;

												BgL_arg7123z00_9162 =
													(((BgL_variablez00_bglt) COBJECT(
															((BgL_variablez00_bglt) BgL_globalz00_51)))->
													BgL_idz00);
												BgL_arg7122z00_9161 =
													MAKE_YOUNG_PAIR(BgL_arg7123z00_9162, BNIL);
											}
											BgL_arg7121z00_9160 =
												MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 12)),
												BgL_arg7122z00_9161);
										}
										BgL_arg7117z00_9156 =
											BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_arg7121z00_9160,
											BNIL, BFALSE, CNST_TABLE_REF(((long) 2)));
									}
									BgL_arg7118z00_9157 =
										BGl_sexpzd2ze3nodez31zzast_sexpz00(
										((obj_t) BgL_globalz00_51), BNIL, BFALSE,
										CNST_TABLE_REF(((long) 2)));
									{	/* Ast/sexp.scm 749 */
										obj_t BgL_list7119z00_9158;

										{	/* Ast/sexp.scm 749 */
											obj_t BgL_arg7120z00_9159;

											BgL_arg7120z00_9159 =
												MAKE_YOUNG_PAIR(((obj_t) BgL_arg7118z00_9157), BNIL);
											BgL_list7119z00_9158 =
												MAKE_YOUNG_PAIR(
												((obj_t) BgL_arg7117z00_9156), BgL_arg7120z00_9159);
										}
										BgL_auxz00_29622 = BgL_list7119z00_9158;
								}}
								((((BgL_appz00_bglt) COBJECT(BgL_new1154z00_9155))->
										BgL_argsz00) = ((obj_t) BgL_auxz00_29622), BUNSPEC);
							}
							return ((BgL_nodez00_bglt) BgL_new1154z00_9155);
						}
					else
						{	/* Ast/sexp.scm 745 */
							return BgL_funz00_9153;
						}
				}
			}
		}

	}



/* &define-primop->node */
	BgL_nodez00_bglt BGl_z62definezd2primopzd2ze3nodez81zzast_sexpz00(obj_t
		BgL_envz00_13784, obj_t BgL_globalz00_13785)
	{
		{	/* Ast/sexp.scm 742 */
			return
				BGl_definezd2primopzd2ze3nodeze3zzast_sexpz00(
				((BgL_globalz00_bglt) BgL_globalz00_13785));
		}

	}



/* location->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_locationzd2ze3nodez31zzast_sexpz00(BgL_globalz00_bglt BgL_globalz00_52)
	{
		{	/* Ast/sexp.scm 756 */
			BGl_usezd2variablez12zc0zzast_sexpz00(
				((BgL_variablez00_bglt) BgL_globalz00_52), BFALSE,
				CNST_TABLE_REF(((long) 2)));
			{	/* Ast/sexp.scm 758 */
				BgL_nodez00_bglt BgL_funz00_9165;

				BgL_funz00_9165 =
					BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 39)), BNIL,
					BFALSE, CNST_TABLE_REF(((long) 33)));
				{	/* Ast/sexp.scm 759 */
					bool_t BgL_test10528z00_29647;

					{	/* Ast/sexp.scm 759 */
						bool_t BgL_res7949z00_13636;

						BgL_res7949z00_13636 =
							BGl_isazf3zf3zz__objectz00(
							((obj_t) BgL_funz00_9165), BGl_varz00zzast_nodez00);
						BgL_test10528z00_29647 = BgL_res7949z00_13636;
					}
					if (BgL_test10528z00_29647)
						{	/* Ast/sexp.scm 760 */
							obj_t BgL_exprz00_9167;

							{	/* Ast/sexp.scm 760 */
								bool_t BgL_test10529z00_29650;

								{	/* Ast/sexp.scm 760 */
									obj_t BgL_arg7133z00_9177;

									BgL_arg7133z00_9177 =
										BGl_thezd2backendzd2zzbackend_backendz00();
									BgL_test10529z00_29650 =
										(((BgL_backendz00_bglt) COBJECT(
												((BgL_backendz00_bglt) BgL_arg7133z00_9177)))->
										BgL_pragmazd2supportzd2);
								}
								if (BgL_test10529z00_29650)
									{	/* Ast/sexp.scm 761 */
										obj_t BgL_arg7131z00_9175;

										{	/* Ast/sexp.scm 761 */
											obj_t BgL_arg7132z00_9176;

											BgL_arg7132z00_9176 =
												MAKE_YOUNG_PAIR(((obj_t) BgL_globalz00_52), BNIL);
											BgL_arg7131z00_9175 =
												MAKE_YOUNG_PAIR(BGl_string8014z00zzast_sexpz00,
												BgL_arg7132z00_9176);
										}
										BgL_exprz00_9167 =
											MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 40)),
											BgL_arg7131z00_9175);
									}
								else
									{	/* Ast/sexp.scm 760 */
										BgL_exprz00_9167 = ((obj_t) BgL_globalz00_52);
									}
							}
							{	/* Ast/sexp.scm 763 */
								BgL_appz00_bglt BgL_new1157z00_9168;

								{	/* Ast/sexp.scm 763 */
									BgL_appz00_bglt BgL_new1156z00_9171;

									BgL_new1156z00_9171 =
										((BgL_appz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
													BgL_appz00_bgl))));
									{	/* Ast/sexp.scm 763 */
										long BgL_arg7128z00_9172;

										{	/* Ast/sexp.scm 763 */
											long BgL_res7951z00_13641;

											BgL_res7951z00_13641 =
												BGL_CLASS_INDEX(BGl_appz00zzast_nodez00);
											BgL_arg7128z00_9172 = BgL_res7951z00_13641;
										}
										BGL_OBJECT_CLASS_NUM_SET(
											((BgL_objectz00_bglt) BgL_new1156z00_9171),
											BgL_arg7128z00_9172);
									}
									{	/* Ast/sexp.scm 763 */
										BgL_objectz00_bglt BgL_tmpz00_29664;

										BgL_tmpz00_29664 =
											((BgL_objectz00_bglt) BgL_new1156z00_9171);
										BGL_OBJECT_WIDENING_SET(BgL_tmpz00_29664, BFALSE);
									}
									((BgL_objectz00_bglt) BgL_new1156z00_9171);
									BgL_new1157z00_9168 = BgL_new1156z00_9171;
								}
								((((BgL_nodez00_bglt) COBJECT(
												((BgL_nodez00_bglt) BgL_new1157z00_9168)))->
										BgL_locz00) = ((obj_t) BFALSE), BUNSPEC);
								((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
													BgL_new1157z00_9168)))->BgL_typez00) =
									((BgL_typez00_bglt)
										BGl_strictzd2nodezd2typez00zzast_nodez00(((BgL_typez00_bglt)
												BGl_za2_za2z00zztype_cachez00),
											((BgL_typez00_bglt) BGl_za2objza2z00zztype_cachez00))),
									BUNSPEC);
								((((BgL_nodezf2effectzf2_bglt)
											COBJECT(((BgL_nodezf2effectzf2_bglt)
													BgL_new1157z00_9168)))->BgL_sidezd2effectzd2) =
									((obj_t) BUNSPEC), BUNSPEC);
								((((BgL_nodezf2effectzf2_bglt)
											COBJECT(((BgL_nodezf2effectzf2_bglt)
													BgL_new1157z00_9168)))->BgL_keyz00) =
									((obj_t) BINT(((long) -1))), BUNSPEC);
								((((BgL_appz00_bglt) COBJECT(BgL_new1157z00_9168))->
										BgL_funz00) =
									((BgL_varz00_bglt) ((BgL_varz00_bglt) BgL_funz00_9165)),
									BUNSPEC);
								{
									obj_t BgL_auxz00_29682;

									{	/* Ast/sexp.scm 766 */
										BgL_nodez00_bglt BgL_arg7126z00_9169;

										BgL_arg7126z00_9169 =
											BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_exprz00_9167, BNIL,
											BFALSE, CNST_TABLE_REF(((long) 2)));
										{	/* Ast/sexp.scm 766 */
											obj_t BgL_list7127z00_9170;

											BgL_list7127z00_9170 =
												MAKE_YOUNG_PAIR(((obj_t) BgL_arg7126z00_9169), BNIL);
											BgL_auxz00_29682 = BgL_list7127z00_9170;
									}}
									((((BgL_appz00_bglt) COBJECT(BgL_new1157z00_9168))->
											BgL_argsz00) = ((obj_t) BgL_auxz00_29682), BUNSPEC);
								}
								return ((BgL_nodez00_bglt) BgL_new1157z00_9168);
							}
						}
					else
						{	/* Ast/sexp.scm 759 */
							return BgL_funz00_9165;
						}
				}
			}
		}

	}



/* &location->node */
	BgL_nodez00_bglt BGl_z62locationzd2ze3nodez53zzast_sexpz00(obj_t
		BgL_envz00_13786, obj_t BgL_globalz00_13787)
	{
		{	/* Ast/sexp.scm 756 */
			return
				BGl_locationzd2ze3nodez31zzast_sexpz00(
				((BgL_globalz00_bglt) BgL_globalz00_13787));
		}

	}



/* make-anonymous-name */
	BGL_EXPORTED_DEF obj_t BGl_makezd2anonymouszd2namez00zzast_sexpz00(obj_t
		BgL_locz00_53, obj_t BgL_prefz00_54)
	{
		{	/* Ast/sexp.scm 772 */
			{	/* Ast/sexp.scm 773 */
				obj_t BgL_prefz00_9178;

				{	/* Ast/sexp.scm 773 */
					bool_t BgL_test10530z00_29691;

					if (PAIRP(BgL_prefz00_54))
						{	/* Ast/sexp.scm 773 */
							obj_t BgL_tmpz00_29694;

							BgL_tmpz00_29694 = CAR(BgL_prefz00_54);
							BgL_test10530z00_29691 = STRINGP(BgL_tmpz00_29694);
						}
					else
						{	/* Ast/sexp.scm 773 */
							BgL_test10530z00_29691 = ((bool_t) 0);
						}
					if (BgL_test10530z00_29691)
						{	/* Ast/sexp.scm 773 */
							BgL_prefz00_9178 = CAR(BgL_prefz00_54);
						}
					else
						{	/* Ast/sexp.scm 773 */
							BgL_prefz00_9178 = BGl_string7992z00zzast_sexpz00;
						}
				}
				{	/* Ast/sexp.scm 776 */
					bool_t BgL_test10532z00_29698;

					if (STRUCTP(BgL_locz00_53))
						{	/* Ast/sexp.scm 776 */
							BgL_test10532z00_29698 =
								(STRUCT_KEY(BgL_locz00_53) == CNST_TABLE_REF(((long) 41)));
						}
					else
						{	/* Ast/sexp.scm 776 */
							BgL_test10532z00_29698 = ((bool_t) 0);
						}
					if (BgL_test10532z00_29698)
						{	/* Ast/sexp.scm 777 */
							obj_t BgL_filez00_9180;
							obj_t BgL_linez00_9181;
							obj_t BgL_basez00_9182;

							BgL_filez00_9180 =
								BGl_locationzd2fullzd2fnamez00zztools_locationz00
								(BgL_locz00_53);
							BgL_linez00_9181 = STRUCT_REF(BgL_locz00_53, (int) (((long) 2)));
							{	/* Ast/sexp.scm 779 */
								obj_t BgL_arg7163z00_9223;

								BgL_arg7163z00_9223 =
									BGl_gensymz00zz__r4_symbols_6_4z00(string_append_3
									(BGl_string8015z00zzast_sexpz00, BgL_prefz00_9178,
										BGl_string8016z00zzast_sexpz00));
								{	/* Ast/sexp.scm 779 */
									obj_t BgL_res7957z00_13658;

									{	/* Ast/sexp.scm 779 */
										obj_t BgL_arg1409z00_13657;

										BgL_arg1409z00_13657 =
											SYMBOL_TO_STRING(BgL_arg7163z00_9223);
										BgL_res7957z00_13658 =
											BGl_stringzd2copyzd2zz__r4_strings_6_7z00
											(BgL_arg1409z00_13657);
									}
									BgL_basez00_9182 = BgL_res7957z00_13658;
							}}
							{	/* Ast/sexp.scm 781 */
								bool_t BgL_test10534z00_29711;

								{	/* Ast/sexp.scm 781 */

									BgL_test10534z00_29711 =
										CBOOL(BGl_stringzd2containszd2zz__r4_strings_6_7z00
										(BgL_prefz00_9178, BGl_string8015z00zzast_sexpz00,
											(int) (((long) 0))));
								}
								if (BgL_test10534z00_29711)
									{	/* Ast/sexp.scm 782 */
										obj_t BgL_arg7136z00_9187;

										{	/* Ast/sexp.scm 782 */
											obj_t BgL_arg7137z00_9188;
											obj_t BgL_arg7138z00_9189;

											{	/* Ast/sexp.scm 782 */
												obj_t BgL_arg7139z00_9190;

												{	/* Ast/sexp.scm 782 */
													obj_t BgL_res7958z00_13660;

													BgL_res7958z00_13660 =
														bstring_to_symbol(((obj_t) BgL_prefz00_9178));
													BgL_arg7139z00_9190 = BgL_res7958z00_13660;
												}
												{	/* Ast/sexp.scm 782 */
													obj_t BgL_res7959z00_13663;

													{	/* Ast/sexp.scm 782 */
														obj_t BgL_arg1409z00_13662;

														BgL_arg1409z00_13662 =
															SYMBOL_TO_STRING(BgL_arg7139z00_9190);
														BgL_res7959z00_13663 =
															BGl_stringzd2copyzd2zz__r4_strings_6_7z00
															(BgL_arg1409z00_13662);
													}
													BgL_arg7137z00_9188 = BgL_res7959z00_13663;
												}
											}
											{	/* Ast/sexp.scm 782 */
												obj_t BgL_arg7140z00_9191;

												BgL_arg7140z00_9191 =
													BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF((
															(long) 42)));
												{	/* Ast/sexp.scm 782 */
													obj_t BgL_res7960z00_13666;

													{	/* Ast/sexp.scm 782 */
														obj_t BgL_arg1409z00_13665;

														BgL_arg1409z00_13665 =
															SYMBOL_TO_STRING(BgL_arg7140z00_9191);
														BgL_res7960z00_13666 =
															BGl_stringzd2copyzd2zz__r4_strings_6_7z00
															(BgL_arg1409z00_13665);
													}
													BgL_arg7138z00_9189 = BgL_res7960z00_13666;
											}}
											BgL_arg7136z00_9187 =
												string_append(BgL_arg7137z00_9188, BgL_arg7138z00_9189);
										}
										return bstring_to_symbol(BgL_arg7136z00_9187);
									}
								else
									{	/* Ast/sexp.scm 783 */
										bool_t BgL_test10535z00_29725;

										{	/* Ast/sexp.scm 783 */
											bool_t BgL_test10536z00_29726;

											if (
												((long) CINT(BGl_za2bdbzd2debugza2zd2zzengine_paramz00)
													>= ((long) 1)))
												{	/* Ast/sexp.scm 784 */
													obj_t BgL_arg7161z00_9218;

													{	/* Ast/sexp.scm 784 */
														obj_t BgL_arg7162z00_9219;

														BgL_arg7162z00_9219 =
															BGl_thezd2backendzd2zzbackend_backendz00();
														BgL_arg7161z00_9218 =
															(((BgL_backendz00_bglt) COBJECT(
																	((BgL_backendz00_bglt)
																		BgL_arg7162z00_9219)))->
															BgL_debugzd2supportzd2);
													}
													BgL_test10536z00_29726 =
														CBOOL(BGl_memqz00zz__r4_pairs_and_lists_6_3z00
														(CNST_TABLE_REF(((long) 43)), BgL_arg7161z00_9218));
												}
											else
												{	/* Ast/sexp.scm 783 */
													BgL_test10536z00_29726 = ((bool_t) 0);
												}
											if (BgL_test10536z00_29726)
												{	/* Ast/sexp.scm 783 */
													BgL_test10535z00_29725 = ((bool_t) 1);
												}
											else
												{	/* Ast/sexp.scm 783 */
													BgL_test10535z00_29725 =
														(
														(long)
														CINT(BGl_za2compilerzd2debugza2zd2zzengine_paramz00)
														>= ((long) 1));
										}}
										if (BgL_test10535z00_29725)
											{	/* Ast/sexp.scm 786 */
												obj_t BgL_filez00_9200;

												if (bigloo_strncmp(BgL_filez00_9180,
														BGl_string8017z00zzast_sexpz00, ((long) 2)))
													{	/* Ast/sexp.scm 786 */
														BgL_filez00_9200 =
															c_substring(BgL_filez00_9180, ((long) 2),
															STRING_LENGTH(BgL_filez00_9180));
													}
												else
													{	/* Ast/sexp.scm 786 */
														BgL_filez00_9200 = BgL_filez00_9180;
													}
												{	/* Ast/sexp.scm 791 */
													obj_t BgL_arg7148z00_9201;

													{	/* Ast/sexp.scm 791 */
														obj_t BgL_arg7149z00_9202;
														obj_t BgL_arg7150z00_9203;

														BgL_arg7149z00_9202 =
															BGl_stringzd2replacezd2zz__r4_strings_6_7z00
															(BgL_filez00_9200, (char) (((unsigned char) '.')),
															(char) (((unsigned char) ',')));
														{	/* Ast/sexp.scm 792 */

															BgL_arg7150z00_9203 =
																BGl_numberzd2ze3stringz31zz__r4_numbers_6_5z00
																(BgL_linez00_9181, BINT(((long) 10)));
														}
														{	/* Ast/sexp.scm 790 */
															obj_t BgL_list7151z00_9204;

															{	/* Ast/sexp.scm 790 */
																obj_t BgL_arg7152z00_9205;

																{	/* Ast/sexp.scm 790 */
																	obj_t BgL_arg7153z00_9206;

																	{	/* Ast/sexp.scm 790 */
																		obj_t BgL_arg7154z00_9207;

																		{	/* Ast/sexp.scm 790 */
																			obj_t BgL_arg7155z00_9208;

																			{	/* Ast/sexp.scm 790 */
																				obj_t BgL_arg7156z00_9209;

																				BgL_arg7156z00_9209 =
																					MAKE_YOUNG_PAIR
																					(BGl_string8018z00zzast_sexpz00,
																					BNIL);
																				BgL_arg7155z00_9208 =
																					MAKE_YOUNG_PAIR(BgL_arg7150z00_9203,
																					BgL_arg7156z00_9209);
																			}
																			BgL_arg7154z00_9207 =
																				MAKE_YOUNG_PAIR
																				(BGl_string8016z00zzast_sexpz00,
																				BgL_arg7155z00_9208);
																		}
																		BgL_arg7153z00_9206 =
																			MAKE_YOUNG_PAIR(BgL_arg7149z00_9202,
																			BgL_arg7154z00_9207);
																	}
																	BgL_arg7152z00_9205 =
																		MAKE_YOUNG_PAIR
																		(BGl_string8016z00zzast_sexpz00,
																		BgL_arg7153z00_9206);
																}
																BgL_list7151z00_9204 =
																	MAKE_YOUNG_PAIR(BgL_basez00_9182,
																	BgL_arg7152z00_9205);
															}
															BgL_arg7148z00_9201 =
																BGl_stringzd2appendzd2zz__r4_strings_6_7z00
																(BgL_list7151z00_9204);
													}}
													return bstring_to_symbol(BgL_arg7148z00_9201);
												}
											}
										else
											{	/* Ast/sexp.scm 795 */
												obj_t BgL_arg7159z00_9214;

												BgL_arg7159z00_9214 =
													BGl_stringzd2replacezd2zz__r4_strings_6_7z00
													(string_append(BgL_basez00_9182,
														BGl_string8019z00zzast_sexpz00),
													(char) (((unsigned char) '.')),
													(char) (((unsigned char) ',')));
												{	/* Ast/sexp.scm 795 */
													obj_t BgL_res7969z00_13687;

													BgL_res7969z00_13687 =
														bstring_to_symbol(((obj_t) BgL_arg7159z00_9214));
													return BgL_res7969z00_13687;
												}
											}
									}
							}
						}
					else
						{	/* Ast/sexp.scm 796 */
							obj_t BgL_arg7165z00_9225;

							{	/* Ast/sexp.scm 796 */
								obj_t BgL_arg7166z00_9226;
								obj_t BgL_arg7167z00_9227;

								{	/* Ast/sexp.scm 796 */
									obj_t BgL_arg7168z00_9228;

									BgL_arg7168z00_9228 =
										BGl_gensymz00zz__r4_symbols_6_4z00(string_append_3
										(BGl_string8015z00zzast_sexpz00, BgL_prefz00_9178,
											BGl_string8020z00zzast_sexpz00));
									{	/* Ast/sexp.scm 796 */
										obj_t BgL_res7970z00_13690;

										{	/* Ast/sexp.scm 796 */
											obj_t BgL_arg1409z00_13689;

											BgL_arg1409z00_13689 =
												SYMBOL_TO_STRING(BgL_arg7168z00_9228);
											BgL_res7970z00_13690 =
												BGl_stringzd2copyzd2zz__r4_strings_6_7z00
												(BgL_arg1409z00_13689);
										}
										BgL_arg7166z00_9226 = BgL_res7970z00_13690;
									}
								}
								{	/* Ast/sexp.scm 796 */
									obj_t BgL_res7971z00_13693;

									{	/* Ast/sexp.scm 796 */
										obj_t BgL_symbolz00_13691;

										BgL_symbolz00_13691 = CNST_TABLE_REF(((long) 44));
										{	/* Ast/sexp.scm 796 */
											obj_t BgL_arg1409z00_13692;

											BgL_arg1409z00_13692 =
												SYMBOL_TO_STRING(BgL_symbolz00_13691);
											BgL_res7971z00_13693 =
												BGl_stringzd2copyzd2zz__r4_strings_6_7z00
												(BgL_arg1409z00_13692);
									}}
									BgL_arg7167z00_9227 = BgL_res7971z00_13693;
								}
								BgL_arg7165z00_9225 =
									string_append(BgL_arg7166z00_9226, BgL_arg7167z00_9227);
							}
							return bstring_to_symbol(BgL_arg7165z00_9225);
						}
				}
			}
		}

	}



/* &make-anonymous-name */
	obj_t BGl_z62makezd2anonymouszd2namez62zzast_sexpz00(obj_t BgL_envz00_13788,
		obj_t BgL_locz00_13789, obj_t BgL_prefz00_13790)
	{
		{	/* Ast/sexp.scm 772 */
			return
				BGl_makezd2anonymouszd2namez00zzast_sexpz00(BgL_locz00_13789,
				BgL_prefz00_13790);
		}

	}



/* synchronize->node */
	BgL_nodez00_bglt BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00(obj_t
		BgL_expz00_55, obj_t BgL_mutexz00_56, obj_t BgL_prelockz00_57,
		obj_t BgL_bodyz00_58, obj_t BgL_stackz00_59, obj_t BgL_locz00_60,
		obj_t BgL_sitez00_61)
	{
		{	/* Ast/sexp.scm 801 */
			if (SYMBOLP(BgL_mutexz00_56))
				{	/* Ast/sexp.scm 803 */
					BgL_syncz00_bglt BgL_new1159z00_9236;

					{	/* Ast/sexp.scm 804 */
						BgL_syncz00_bglt BgL_new1158z00_9238;

						BgL_new1158z00_9238 =
							((BgL_syncz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
										BgL_syncz00_bgl))));
						{	/* Ast/sexp.scm 804 */
							long BgL_arg7176z00_9239;

							{	/* Ast/sexp.scm 804 */
								long BgL_res7974z00_13698;

								BgL_res7974z00_13698 =
									BGL_CLASS_INDEX(BGl_syncz00zzast_nodez00);
								BgL_arg7176z00_9239 = BgL_res7974z00_13698;
							}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt) BgL_new1158z00_9238),
								BgL_arg7176z00_9239);
						}
						{	/* Ast/sexp.scm 804 */
							BgL_objectz00_bglt BgL_tmpz00_29777;

							BgL_tmpz00_29777 = ((BgL_objectz00_bglt) BgL_new1158z00_9238);
							BGL_OBJECT_WIDENING_SET(BgL_tmpz00_29777, BFALSE);
						}
						((BgL_objectz00_bglt) BgL_new1158z00_9238);
						BgL_new1159z00_9236 = BgL_new1158z00_9238;
					}
					((((BgL_nodez00_bglt) COBJECT(
									((BgL_nodez00_bglt) BgL_new1159z00_9236)))->BgL_locz00) =
						((obj_t) BgL_locz00_60), BUNSPEC);
					((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
										BgL_new1159z00_9236)))->BgL_typez00) =
						((BgL_typez00_bglt) ((BgL_typez00_bglt)
								BGl_za2_za2z00zztype_cachez00)), BUNSPEC);
					((((BgL_syncz00_bglt) COBJECT(BgL_new1159z00_9236))->BgL_mutexz00) =
						((BgL_nodez00_bglt)
							BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_mutexz00_56,
								BgL_stackz00_59, BgL_locz00_60, CNST_TABLE_REF(((long) 2)))),
						BUNSPEC);
					((((BgL_syncz00_bglt) COBJECT(BgL_new1159z00_9236))->BgL_prelockz00) =
						((BgL_nodez00_bglt)
							BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_prelockz00_57,
								BgL_stackz00_59, BgL_locz00_60, CNST_TABLE_REF(((long) 2)))),
						BUNSPEC);
					{
						BgL_nodez00_bglt BgL_auxz00_29792;

						{	/* Ast/sexp.scm 808 */
							obj_t BgL_arg7175z00_9237;

							BgL_arg7175z00_9237 =
								BGl_normaliza7ezd2prognz75zztools_prognz00(BgL_bodyz00_58);
							BgL_auxz00_29792 =
								BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_arg7175z00_9237,
								BgL_stackz00_59, BgL_locz00_60, BgL_sitez00_61);
						}
						((((BgL_syncz00_bglt) COBJECT(BgL_new1159z00_9236))->BgL_bodyz00) =
							((BgL_nodez00_bglt) BgL_auxz00_29792), BUNSPEC);
					}
					return ((BgL_nodez00_bglt) BgL_new1159z00_9236);
				}
			else
				{	/* Ast/sexp.scm 809 */
					obj_t BgL_vz00_9240;

					BgL_vz00_9240 =
						BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
						(BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 45))));
					{	/* Ast/sexp.scm 809 */
						obj_t BgL_varz00_9241;

						BgL_varz00_9241 =
							BGl_makezd2typedzd2identz00zzast_identz00(BgL_vz00_9240,
							CNST_TABLE_REF(((long) 45)));
						{	/* Ast/sexp.scm 810 */
							obj_t BgL_nexpz00_9242;

							{	/* Ast/sexp.scm 811 */
								obj_t BgL_arg7184z00_9250;

								{	/* Ast/sexp.scm 811 */
									obj_t BgL_arg7185z00_9251;

									BgL_arg7185z00_9251 =
										MAKE_YOUNG_PAIR(BgL_vz00_9240,
										BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
										(BgL_bodyz00_58, BNIL));
									BgL_arg7184z00_9250 =
										MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 29)),
										BgL_arg7185z00_9251);
								}
								BgL_nexpz00_9242 =
									BGl_epairifyzd2reczd2zztools_miscz00(BgL_arg7184z00_9250,
									BgL_expz00_55);
							}
							{	/* Ast/sexp.scm 811 */

								{	/* Ast/sexp.scm 812 */
									obj_t BgL_arg7177z00_9243;

									{	/* Ast/sexp.scm 812 */
										obj_t BgL_arg7178z00_9244;
										obj_t BgL_arg7179z00_9245;

										BgL_arg7178z00_9244 = BGl_letzd2symzd2zzast_letz00();
										{	/* Ast/sexp.scm 812 */
											obj_t BgL_arg7180z00_9246;
											obj_t BgL_arg7181z00_9247;

											{	/* Ast/sexp.scm 812 */
												obj_t BgL_arg7182z00_9248;

												{	/* Ast/sexp.scm 812 */
													obj_t BgL_arg7183z00_9249;

													BgL_arg7183z00_9249 =
														MAKE_YOUNG_PAIR(BgL_mutexz00_56, BNIL);
													BgL_arg7182z00_9248 =
														MAKE_YOUNG_PAIR(BgL_varz00_9241,
														BgL_arg7183z00_9249);
												}
												BgL_arg7180z00_9246 =
													MAKE_YOUNG_PAIR(BgL_arg7182z00_9248, BNIL);
											}
											BgL_arg7181z00_9247 =
												MAKE_YOUNG_PAIR(BgL_nexpz00_9242, BNIL);
											BgL_arg7179z00_9245 =
												MAKE_YOUNG_PAIR(BgL_arg7180z00_9246,
												BgL_arg7181z00_9247);
										}
										BgL_arg7177z00_9243 =
											MAKE_YOUNG_PAIR(BgL_arg7178z00_9244, BgL_arg7179z00_9245);
									}
									BGl_replacez12z12zztools_miscz00(BgL_expz00_55,
										BgL_arg7177z00_9243);
								}
								return
									BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_expz00_55,
									BgL_stackz00_59, BgL_locz00_60, BgL_sitez00_61);
							}
						}
					}
				}
		}

	}



/* not-test */
	obj_t BGl_notzd2testzd2zzast_sexpz00(obj_t BgL_testz00_62)
	{
		{	/* Ast/sexp.scm 821 */
			{
				obj_t BgL_bindingsz00_9258;
				obj_t BgL_exprz00_9259;

				if (PAIRP(BgL_testz00_62))
					{	/* Ast/sexp.scm 822 */
						obj_t BgL_cdrzd262440zd2_9264;

						BgL_cdrzd262440zd2_9264 = CDR(BgL_testz00_62);
						if ((CAR(BgL_testz00_62) == CNST_TABLE_REF(((long) 1))))
							{	/* Ast/sexp.scm 822 */
								if (PAIRP(BgL_cdrzd262440zd2_9264))
									{	/* Ast/sexp.scm 822 */
										obj_t BgL_cdrzd262443zd2_9268;

										BgL_cdrzd262443zd2_9268 = CDR(BgL_cdrzd262440zd2_9264);
										if (PAIRP(BgL_cdrzd262443zd2_9268))
											{	/* Ast/sexp.scm 822 */
												obj_t BgL_cdrzd262446zd2_9270;

												BgL_cdrzd262446zd2_9270 = CDR(BgL_cdrzd262443zd2_9268);
												if ((CAR(BgL_cdrzd262443zd2_9268) == BFALSE))
													{	/* Ast/sexp.scm 822 */
														if (PAIRP(BgL_cdrzd262446zd2_9270))
															{	/* Ast/sexp.scm 822 */
																if ((CAR(BgL_cdrzd262446zd2_9270) == BTRUE))
																	{	/* Ast/sexp.scm 822 */
																		if (NULLP(CDR(BgL_cdrzd262446zd2_9270)))
																			{	/* Ast/sexp.scm 822 */
																				return CAR(BgL_cdrzd262440zd2_9264);
																			}
																		else
																			{	/* Ast/sexp.scm 822 */
																				return BFALSE;
																			}
																	}
																else
																	{	/* Ast/sexp.scm 822 */
																		return BFALSE;
																	}
															}
														else
															{	/* Ast/sexp.scm 822 */
																return BFALSE;
															}
													}
												else
													{	/* Ast/sexp.scm 822 */
														return BFALSE;
													}
											}
										else
											{	/* Ast/sexp.scm 822 */
												return BFALSE;
											}
									}
								else
									{	/* Ast/sexp.scm 822 */
										return BFALSE;
									}
							}
						else
							{	/* Ast/sexp.scm 822 */
								if ((CAR(BgL_testz00_62) == CNST_TABLE_REF(((long) 46))))
									{	/* Ast/sexp.scm 822 */
										if (PAIRP(BgL_cdrzd262440zd2_9264))
											{	/* Ast/sexp.scm 822 */
												if (NULLP(CDR(BgL_cdrzd262440zd2_9264)))
													{	/* Ast/sexp.scm 822 */
														return CAR(BgL_cdrzd262440zd2_9264);
													}
												else
													{	/* Ast/sexp.scm 822 */
														return BFALSE;
													}
											}
										else
											{	/* Ast/sexp.scm 822 */
												return BFALSE;
											}
									}
								else
									{	/* Ast/sexp.scm 822 */
										obj_t BgL_cdrzd262520zd2_9290;

										BgL_cdrzd262520zd2_9290 = CDR(BgL_testz00_62);
										if ((CAR(BgL_testz00_62) == CNST_TABLE_REF(((long) 17))))
											{	/* Ast/sexp.scm 822 */
												if (PAIRP(BgL_cdrzd262520zd2_9290))
													{	/* Ast/sexp.scm 822 */
														obj_t BgL_cdrzd262524zd2_9294;

														BgL_cdrzd262524zd2_9294 =
															CDR(BgL_cdrzd262520zd2_9290);
														if (PAIRP(BgL_cdrzd262524zd2_9294))
															{	/* Ast/sexp.scm 822 */
																if (NULLP(CDR(BgL_cdrzd262524zd2_9294)))
																	{	/* Ast/sexp.scm 822 */
																		BgL_bindingsz00_9258 =
																			CAR(BgL_cdrzd262520zd2_9290);
																		BgL_exprz00_9259 =
																			CAR(BgL_cdrzd262524zd2_9294);
																		{	/* Ast/sexp.scm 828 */
																			obj_t BgL_ntz00_9304;

																			BgL_ntz00_9304 =
																				BGl_notzd2testzd2zzast_sexpz00
																				(BgL_exprz00_9259);
																			if (CBOOL(BgL_ntz00_9304))
																				{	/* Ast/sexp.scm 830 */
																					obj_t BgL_arg7223z00_9305;

																					{	/* Ast/sexp.scm 830 */
																						obj_t BgL_arg7224z00_9306;

																						{	/* Ast/sexp.scm 830 */
																							obj_t BgL_arg7225z00_9307;

																							BgL_arg7225z00_9307 =
																								MAKE_YOUNG_PAIR(BgL_ntz00_9304,
																								BNIL);
																							BgL_arg7224z00_9306 =
																								MAKE_YOUNG_PAIR
																								(BgL_bindingsz00_9258,
																								BgL_arg7225z00_9307);
																						}
																						BgL_arg7223z00_9305 =
																							MAKE_YOUNG_PAIR(CNST_TABLE_REF((
																									(long) 17)),
																							BgL_arg7224z00_9306);
																					}
																					return
																						BGl_epairifyzd2reczd2zztools_miscz00
																						(BgL_arg7223z00_9305,
																						BgL_testz00_62);
																				}
																			else
																				{	/* Ast/sexp.scm 829 */
																					return BFALSE;
																				}
																		}
																	}
																else
																	{	/* Ast/sexp.scm 822 */
																		return BFALSE;
																	}
															}
														else
															{	/* Ast/sexp.scm 822 */
																return BFALSE;
															}
													}
												else
													{	/* Ast/sexp.scm 822 */
														return BFALSE;
													}
											}
										else
											{	/* Ast/sexp.scm 822 */
												return BFALSE;
											}
									}
							}
					}
				else
					{	/* Ast/sexp.scm 822 */
						return BFALSE;
					}
			}
		}

	}



/* used-in? */
	bool_t BGl_usedzd2inzf3z21zzast_sexpz00(obj_t BgL_idz00_63,
		obj_t BgL_exprz00_64)
	{
		{	/* Ast/sexp.scm 839 */
			if ((BgL_idz00_63 == BgL_exprz00_64))
				{	/* Ast/sexp.scm 841 */
					return ((bool_t) 1);
				}
			else
				{	/* Ast/sexp.scm 841 */
					if (PAIRP(BgL_exprz00_64))
						{	/* Ast/sexp.scm 842 */
							if ((CAR(BgL_exprz00_64) == CNST_TABLE_REF(((long) 12))))
								{	/* Ast/sexp.scm 843 */
									return ((bool_t) 0);
								}
							else
								{	/* Ast/sexp.scm 843 */
									if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00
										(BgL_exprz00_64))
										{
											obj_t BgL_list1473z00_9324;

											{	/* Ast/sexp.scm 845 */
												obj_t BgL_tmpz00_29884;

												BgL_list1473z00_9324 = BgL_exprz00_64;
											BgL_zc3z04anonymousza37236ze3z87_9325:
												if (PAIRP(BgL_list1473z00_9324))
													{	/* Ast/sexp.scm 845 */
														if (BGl_usedzd2inzf3z21zzast_sexpz00(BgL_idz00_63,
																CAR(BgL_list1473z00_9324)))
															{	/* Ast/sexp.scm 845 */
																BgL_tmpz00_29884 = CAR(BgL_list1473z00_9324);
															}
														else
															{
																obj_t BgL_list1473z00_29891;

																BgL_list1473z00_29891 =
																	CDR(BgL_list1473z00_9324);
																BgL_list1473z00_9324 = BgL_list1473z00_29891;
																goto BgL_zc3z04anonymousza37236ze3z87_9325;
															}
													}
												else
													{	/* Ast/sexp.scm 845 */
														BgL_tmpz00_29884 = BFALSE;
													}
												return CBOOL(BgL_tmpz00_29884);
											}
										}
									else
										{	/* Ast/sexp.scm 844 */
											return ((bool_t) 0);
										}
								}
						}
					else
						{	/* Ast/sexp.scm 842 */
							return ((bool_t) 0);
						}
				}
		}

	}



/* object-init */
	obj_t BGl_objectzd2initzd2zzast_sexpz00()
	{
		{	/* Ast/sexp.scm 14 */
			return BUNSPEC;
		}

	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzast_sexpz00()
	{
		{	/* Ast/sexp.scm 14 */
			return BUNSPEC;
		}

	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzast_sexpz00()
	{
		{	/* Ast/sexp.scm 14 */
			return BUNSPEC;
		}

	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzast_sexpz00()
	{
		{	/* Ast/sexp.scm 14 */
			BGl_modulezd2initializa7ationz75zztools_tracez00(((long) 54713316),
				BSTRING_TO_STRING(BGl_string8021z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 300504031),
				BSTRING_TO_STRING(BGl_string8021z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 365925558),
				BSTRING_TO_STRING(BGl_string8021z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_prognz00(((long) 301998274),
				BSTRING_TO_STRING(BGl_string8021z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_locationz00(((long) 462333240),
				BSTRING_TO_STRING(BGl_string8021z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_miscz00(((long) 9470071),
				BSTRING_TO_STRING(BGl_string8021z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_dssslz00(((long) 275867955),
				BSTRING_TO_STRING(BGl_string8021z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 515343395),
				BSTRING_TO_STRING(BGl_string8021z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztype_envz00(((long) 296457443),
				BSTRING_TO_STRING(BGl_string8021z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztype_miscz00(((long) 49975086),
				BSTRING_TO_STRING(BGl_string8021z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 346491734),
				BSTRING_TO_STRING(BGl_string8021z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzobject_classz00(((long) 502007119),
				BSTRING_TO_STRING(BGl_string8021z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztype_typeofz00(((long) 398780265),
				BSTRING_TO_STRING(BGl_string8021z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 476633989),
				BSTRING_TO_STRING(BGl_string8021z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzbackend_backendz00(((long) 216206620),
				BSTRING_TO_STRING(BGl_string8021z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_identz00(((long) 174885617),
				BSTRING_TO_STRING(BGl_string8021z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_envz00(((long) 146730773),
				BSTRING_TO_STRING(BGl_string8021z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 90839984),
				BSTRING_TO_STRING(BGl_string8021z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 506185397),
				BSTRING_TO_STRING(BGl_string8021z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_buildz00(((long) 428035925),
				BSTRING_TO_STRING(BGl_string8021z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_pragmaz00(((long) 156774043),
				BSTRING_TO_STRING(BGl_string8021z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_labelsz00(((long) 129879154),
				BSTRING_TO_STRING(BGl_string8021z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_letz00(((long) 469204197),
				BSTRING_TO_STRING(BGl_string8021z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_exitz00(((long) 419066125),
				BSTRING_TO_STRING(BGl_string8021z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_appz00(((long) 449859288),
				BSTRING_TO_STRING(BGl_string8021z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_applyz00(((long) 277780830),
				BSTRING_TO_STRING(BGl_string8021z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_privatez00(((long) 135263837),
				BSTRING_TO_STRING(BGl_string8021z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_objectz00(((long) 520121776),
				BSTRING_TO_STRING(BGl_string8021z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_dumpz00(((long) 271707717),
				BSTRING_TO_STRING(BGl_string8021z00zzast_sexpz00));
			return
				BGl_modulezd2initializa7ationz75zzeffect_feffectz00(((long) 516374368),
				BSTRING_TO_STRING(BGl_string8021z00zzast_sexpz00));
		}

	}

#ifdef __cplusplus
}
#endif
