/*===========================================================================*/
/*   (Cfa/closure.scm)                                                       */
/*   Bigloo (4.3g)                                                           */
/*   Inria -- Sophia Antipolis (c)       Wed 12 Feb 2020 07:45:41 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.3g -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Cfa/closure.scm) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		bool_t BgL_evalzf3zf3;
		obj_t BgL_libraryz00;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
		obj_t BgL_initz00;
		obj_t BgL_aliasz00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_funz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
	}             *BgL_funz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
		obj_t BgL_strengthz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_svarz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
	}              *BgL_svarz00_bglt;

	typedef struct BgL_scnstz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_nodez00;
		obj_t BgL_classz00;
		obj_t BgL_locz00;
	}               *BgL_scnstz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_funcallz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_strengthz00;
		obj_t BgL_functionsz00;
	}                 *BgL_funcallz00_bglt;

	typedef struct BgL_approxz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_typez00_bgl *BgL_typez00;
		bool_t BgL_typezd2lockedzf3z21;
		obj_t BgL_allocsz00;
		bool_t BgL_topzf3zf3;
		long BgL_lostzd2stampzd2;
		obj_t BgL_dupz00;
	}                *BgL_approxz00_bglt;

	typedef struct BgL_internzd2sfunzf2cinfoz20_bgl
	{
		bool_t BgL_polymorphiczf3zf3;
		struct BgL_approxz00_bgl *BgL_approxz00;
		long BgL_stampz00;
	}                               *BgL_internzd2sfunzf2cinfoz20_bglt;

	typedef struct BgL_svarzf2cinfozf2_bgl
	{
		struct BgL_approxz00_bgl *BgL_approxz00;
		bool_t BgL_clozd2envzf3z21;
		long BgL_stampz00;
	}                      *BgL_svarzf2cinfozf2_bglt;

	typedef struct BgL_makezd2procedurezd2appz00_bgl
	{
		struct BgL_approxz00_bgl *BgL_approxz00;
		obj_t BgL_valueszd2approxzd2;
		long BgL_lostzd2stampzd2;
		bool_t BgL_xzd2tzf3z21;
		bool_t BgL_xz00;
		bool_t BgL_tz00;
		struct BgL_variablez00_bgl *BgL_ownerz00;
		obj_t BgL_stackzd2stampzd2;
	}                                *BgL_makezd2procedurezd2appz00_bglt;


	static bool_t BGl_lightzd2makezd2procedurez12z12zzcfa_closurez00();
	extern obj_t BGl_setzd2lengthzd2zzcfa_setz00(obj_t);
	static bool_t BGl_mergezd2appzd2typesz12z12zzcfa_closurez00(obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_addzd2makezd2procedurez12z12zzcfa_closurez00(BgL_nodez00_bglt);
	static obj_t BGl_z62stopzd2closurezd2cachez62zzcfa_closurez00(obj_t);
	static obj_t BGl_objectzd2initzd2zzcfa_closurez00();
	BGL_EXPORTED_DECL obj_t
		BGl_addzd2funcallz12zc0zzcfa_closurez00(BgL_nodez00_bglt);
	extern obj_t BGl_forzd2eachzd2approxzd2alloczd2zzcfa_approxz00(obj_t,
		BgL_approxz00_bglt);
	static obj_t BGl_methodzd2initzd2zzcfa_closurez00();
	extern BgL_typez00_bglt
		BGl_getzd2bigloozd2typez00zztype_cachez00(BgL_typez00_bglt);
	BGL_EXPORTED_DECL obj_t BGl_typezd2closuresz12zc0zzcfa_closurez00();
	extern obj_t
		BGl_getzd2nodezd2atomzd2valuezd2zzcfa_approxz00(BgL_nodez00_bglt);
	BGL_EXPORTED_DECL obj_t BGl_getzd2procedurezd2listz00zzcfa_closurez00();
	static bool_t BGl_showze70ze7zzcfa_closurez00(obj_t, obj_t);
	extern obj_t BGl_lightzd2typez12zc0zzcfa_ltypez00(obj_t);
	static obj_t BGl_z62closurezd2optimiza7ationz12z05zzcfa_closurez00(obj_t,
		obj_t);
	static obj_t BGl_z62closurezd2optimiza7ationzf3ze4zzcfa_closurez00(obj_t);
	extern obj_t BGl_za2unsafezd2typeza2zd2zzengine_paramz00;
	static obj_t BGl_z62addzd2procedurezd2refz12z70zzcfa_closurez00(obj_t, obj_t);
	static bool_t BGl_lightzd2funcallz12zc0zzcfa_closurez00();
	extern obj_t BGl_makezd2procedurezd2appz00zzcfa_info2z00;
	extern bool_t BGl_bigloozd2typezf3z21zztype_typez00(BgL_typez00_bglt);
	static obj_t BGl_z62zc3z04anonymousza31656ze3ze5zzcfa_closurez00(obj_t,
		obj_t);
	static obj_t BGl_za2procedurezd2elzd2setz12za2z12zzcfa_closurez00 = BUNSPEC;
	extern obj_t BGl_verbosez00zztools_speekz00(obj_t, obj_t);
	extern BgL_typez00_bglt
		BGl_getzd2bigloozd2definedzd2typezd2zztype_cachez00(BgL_typez00_bglt);
	extern obj_t BGl_za2optimza2z00zzengine_paramz00;
	static obj_t BGl_za2makezd2elzd2procedureza2z00zzcfa_closurez00 = BUNSPEC;
	extern obj_t BGl_getzd2globalzf2modulez20zzast_envz00(obj_t, obj_t);
	static obj_t BGl_showzd2Xzd2Tz00zzcfa_closurez00(obj_t);
	static obj_t BGl_z62typezd2closuresz12za2zzcfa_closurez00(obj_t);
	extern obj_t BGl_shapez00zztools_shapez00(obj_t);
	BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_za2makezd2procedurezd2listza2z00zzcfa_closurez00 = BUNSPEC;
	static bool_t BGl_Xz12z12zzcfa_closurez00(obj_t);
	extern obj_t BGl_varz00zzast_nodez00;
	static obj_t BGl_Tzd2fixzd2pointz12z12zzcfa_closurez00(obj_t);
	extern obj_t BGl_za2procedureza2z00zztype_cachez00;
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zzcfa_closurez00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_ltypez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_setz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_approxz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_cfaz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_info2z00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_infoz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_speekz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	static obj_t BGl_za2procedurezd2lzd2refza2z00zzcfa_closurez00 = BUNSPEC;
	static obj_t BGl_za2procedurezd2refzd2listza2z00zzcfa_closurez00 = BUNSPEC;
	static bool_t BGl_lightzd2accessz12zc0zzcfa_closurez00();
	static obj_t BGl_importedzd2moduleszd2initz00zzcfa_closurez00();
	static obj_t BGl_startzd2closurezd2cachez00zzcfa_closurez00();
	static obj_t BGl_za2procedurezd2setz12za2zc0zzcfa_closurez00 = BUNSPEC;
	static obj_t BGl_za2procedurezd2elzd2refza2z00zzcfa_closurez00 = BUNSPEC;
	extern BgL_approxz00_bglt BGl_cfaz12z12zzcfa_cfaz00(BgL_nodez00_bglt);
	extern obj_t BGl_getzd2approxzd2typez00zzcfa_typez00(BgL_approxz00_bglt,
		obj_t);
	static obj_t BGl_z62getzd2procedurezd2listz62zzcfa_closurez00(obj_t);
	BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_closurezd2optimiza7ationz12z67zzcfa_closurez00(obj_t);
	BGL_EXPORTED_DECL obj_t BGl_closurezd2optimiza7ationzf3z86zzcfa_closurez00();
	extern obj_t
		BGl_za2optimzd2cfazd2unboxzd2closurezd2argsza2z00zzengine_paramz00;
	extern BgL_typez00_bglt
		BGl_strictzd2nodezd2typez00zzast_nodez00(BgL_typez00_bglt,
		BgL_typez00_bglt);
	static obj_t BGl_za2procedurezd2lzd2setz12za2z12zzcfa_closurez00 = BUNSPEC;
	BGL_EXPORTED_DECL obj_t BGl_stopzd2closurezd2cachez00zzcfa_closurez00();
	static obj_t BGl_z62addzd2funcallz12za2zzcfa_closurez00(obj_t, obj_t);
	static obj_t BGl_gczd2rootszd2initz00zzcfa_closurez00();
	static obj_t BGl_requirezd2initializa7ationz75zzcfa_closurez00 = BUNSPEC;
	BGL_EXPORTED_DECL obj_t
		BGl_addzd2procedurezd2refz12z12zzcfa_closurez00(BgL_nodez00_bglt);
	static obj_t BGl_toplevelzd2initzd2zzcfa_closurez00();
	extern obj_t BGl_setzd2ze3listz31zzcfa_setz00(obj_t);
	static obj_t BGl_genericzd2initzd2zzcfa_closurez00();
	static obj_t BGl_za2makezd2lzd2procedureza2z00zzcfa_closurez00 = BUNSPEC;
	static obj_t BGl_z62approxzd2procedurezd2elzf3z91zzcfa_closurez00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	BGL_EXPORTED_DECL bool_t
		BGl_approxzd2procedurezd2elzf3zf3zzcfa_closurez00(BgL_approxz00_bglt);
	static obj_t BGl_za2procedurezd2refza2zd2zzcfa_closurez00 = BUNSPEC;
	static obj_t BGl_cnstzd2initzd2zzcfa_closurez00();
	static obj_t BGl_libraryzd2moduleszd2initz00zzcfa_closurez00();
	extern obj_t BGl_scnstz00zzast_varz00;
	static obj_t BGl_za2funcallzd2listza2zd2zzcfa_closurez00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza31645ze3ze5zzcfa_closurez00(obj_t,
		obj_t);
	static obj_t BGl_z62addzd2makezd2procedurez12z70zzcfa_closurez00(obj_t,
		obj_t);
	extern obj_t BGl_za2procedurezd2elza2zd2zztype_cachez00;
	static bool_t BGl_mergezd2appzd2returnzd2typesz12zc0zzcfa_closurez00(obj_t,
		BgL_approxz00_bglt);
	extern obj_t BGl_globalz00zzast_varz00;
	static obj_t __cnst[20];


	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_addzd2makezd2procedurez12zd2envzc0zzcfa_closurez00,
		BgL_bgl_za762addza7d2makeza7d22220za7,
		BGl_z62addzd2makezd2procedurez12z70zzcfa_closurez00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_addzd2funcallz12zd2envz12zzcfa_closurez00,
		BgL_bgl_za762addza7d2funcall2221z00,
		BGl_z62addzd2funcallz12za2zzcfa_closurez00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2209z00zzcfa_closurez00,
		BgL_bgl_string2209za700za7za7c2222za7, "   . Light closures", 19);
	      DEFINE_STRING(BGl_string2212z00zzcfa_closurez00,
		BgL_bgl_string2212za700za7za7c2223za7, ": ", 2);
	      DEFINE_STRING(BGl_string2213z00zzcfa_closurez00,
		BgL_bgl_string2213za700za7za7c2224za7, "      ", 6);
	      DEFINE_STRING(BGl_string2214z00zzcfa_closurez00,
		BgL_bgl_string2214za700za7za7c2225za7, "        ", 8);
	      DEFINE_STRING(BGl_string2215z00zzcfa_closurez00,
		BgL_bgl_string2215za700za7za7c2226za7, "cfa_closure", 11);
	      DEFINE_STRING(BGl_string2216z00zzcfa_closurez00,
		BgL_bgl_string2216za700za7za7c2227za7,
		"make-l-procedure make-el-procedure procedure-el-set! procedure-el-ref procedure-l-set! procedure-l-ref procedure-set! foreign procedure-ref T X nothing-to-do slfun selfun done ok \077\077? light elight static ",
		203);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_addzd2procedurezd2refz12zd2envzc0zzcfa_closurez00,
		BgL_bgl_za762addza7d2procedu2228z00,
		BGl_z62addzd2procedurezd2refz12z70zzcfa_closurez00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_typezd2closuresz12zd2envz12zzcfa_closurez00,
		BgL_bgl_za762typeza7d2closur2229z00,
		BGl_z62typezd2closuresz12za2zzcfa_closurez00, 0L, BUNSPEC, 0);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_closurezd2optimiza7ationzf3zd2envz54zzcfa_closurez00,
		BgL_bgl_za762closureza7d2opt2230z00,
		BGl_z62closurezd2optimiza7ationzf3ze4zzcfa_closurez00, 0L, BUNSPEC, 0);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_closurezd2optimiza7ationz12zd2envzb5zzcfa_closurez00,
		BgL_bgl_za762closureza7d2opt2231z00,
		BGl_z62closurezd2optimiza7ationz12z05zzcfa_closurez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2210z00zzcfa_closurez00,
		BgL_bgl_za762za7c3za704anonymo2232za7,
		BGl_z62zc3z04anonymousza31645ze3ze5zzcfa_closurez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2211z00zzcfa_closurez00,
		BgL_bgl_za762za7c3za704anonymo2233za7,
		BGl_z62zc3z04anonymousza31656ze3ze5zzcfa_closurez00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_getzd2procedurezd2listzd2envzd2zzcfa_closurez00,
		BgL_bgl_za762getza7d2procedu2234z00,
		BGl_z62getzd2procedurezd2listz62zzcfa_closurez00, 0L, BUNSPEC, 0);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_stopzd2closurezd2cachezd2envzd2zzcfa_closurez00,
		BgL_bgl_za762stopza7d2closur2235z00,
		BGl_z62stopzd2closurezd2cachez62zzcfa_closurez00, 0L, BUNSPEC, 0);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_approxzd2procedurezd2elzf3zd2envz21zzcfa_closurez00,
		BgL_bgl_za762approxza7d2proc2236z00,
		BGl_z62approxzd2procedurezd2elzf3z91zzcfa_closurez00, 0L, BUNSPEC, 1);

/* GC roots registration */
	static obj_t bgl_gc_roots_register()
	{
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
		void *roots_min = (void *) ULONG_MAX, *roots_max = 0;
		   
			 ADD_ROOT((void
				*) (&BGl_za2procedurezd2elzd2setz12za2z12zzcfa_closurez00));
		     ADD_ROOT((void
				*) (&BGl_za2makezd2elzd2procedureza2z00zzcfa_closurez00));
		     ADD_ROOT((void
				*) (&BGl_za2makezd2procedurezd2listza2z00zzcfa_closurez00));
		     ADD_ROOT((void *) (&BGl_za2procedurezd2lzd2refza2z00zzcfa_closurez00));
		   
			 ADD_ROOT((void
				*) (&BGl_za2procedurezd2refzd2listza2z00zzcfa_closurez00));
		     ADD_ROOT((void *) (&BGl_za2procedurezd2setz12za2zc0zzcfa_closurez00));
		   
			 ADD_ROOT((void *) (&BGl_za2procedurezd2elzd2refza2z00zzcfa_closurez00));
		   
			 ADD_ROOT((void
				*) (&BGl_za2procedurezd2lzd2setz12za2z12zzcfa_closurez00));
		     ADD_ROOT((void
				*) (&BGl_requirezd2initializa7ationz75zzcfa_closurez00));
		     ADD_ROOT((void
				*) (&BGl_za2makezd2lzd2procedureza2z00zzcfa_closurez00));
		     ADD_ROOT((void *) (&BGl_za2procedurezd2refza2zd2zzcfa_closurez00));
		     ADD_ROOT((void *) (&BGl_za2funcallzd2listza2zd2zzcfa_closurez00));
#undef ADD_ROOT
		if   (roots_max > 0)
			     GC_add_roots(roots_min, ((void **) roots_max) + 1);
#endif
		     return BUNSPEC;
	}



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzcfa_closurez00(long
		BgL_checksumz00_4167, char *BgL_fromz00_4168)
	{
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzcfa_closurez00))
				{
					BGl_requirezd2initializa7ationz75zzcfa_closurez00 =
						BBOOL(((bool_t) 0));
					BGl_gczd2rootszd2initz00zzcfa_closurez00();
					BGl_libraryzd2moduleszd2initz00zzcfa_closurez00();
					BGl_cnstzd2initzd2zzcfa_closurez00();
					BGl_importedzd2moduleszd2initz00zzcfa_closurez00();
					return BGl_toplevelzd2initzd2zzcfa_closurez00();
				}
			else
				{
					return BUNSPEC;
				}
		}

	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzcfa_closurez00()
	{
		{	/* Cfa/closure.scm 25 */
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 0),
				"cfa_closure");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0), "cfa_closure");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0), "cfa_closure");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"cfa_closure");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"cfa_closure");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long) 0),
				"cfa_closure");
			return BUNSPEC;
		}

	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzcfa_closurez00()
	{
		{	/* Cfa/closure.scm 25 */
			{	/* Cfa/closure.scm 25 */
				obj_t BgL_cportz00_4154;

				{	/* Cfa/closure.scm 25 */
					obj_t BgL_stringz00_4162;

					BgL_stringz00_4162 = BGl_string2216z00zzcfa_closurez00;
					{	/* Cfa/closure.scm 25 */
						obj_t BgL_startz00_4163;

						BgL_startz00_4163 = BINT(((long) 0));
						{	/* Cfa/closure.scm 25 */
							obj_t BgL_endz00_4164;

							BgL_endz00_4164 =
								BINT(STRING_LENGTH(((obj_t) BgL_stringz00_4162)));
							{	/* Cfa/closure.scm 25 */

								BgL_cportz00_4154 =
									BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00
									(BgL_stringz00_4162, BgL_startz00_4163, BgL_endz00_4164);
				}}}}
				{
					long BgL_iz00_4155;

					BgL_iz00_4155 = ((long) 19);
				BgL_loopz00_4156:
					if ((BgL_iz00_4155 == ((long) -1)))
						{	/* Cfa/closure.scm 25 */
							return BUNSPEC;
						}
					else
						{	/* Cfa/closure.scm 25 */
							{	/* Cfa/closure.scm 25 */
								obj_t BgL_arg2218z00_4158;

								{	/* Cfa/closure.scm 25 */

									{	/* Cfa/closure.scm 25 */
										obj_t BgL_locationz00_4160;

										BgL_locationz00_4160 = BBOOL(((bool_t) 0));
										{	/* Cfa/closure.scm 25 */

											BgL_arg2218z00_4158 =
												BGl_readz00zz__readerz00(BgL_cportz00_4154,
												BgL_locationz00_4160);
										}
									}
								}
								{	/* Cfa/closure.scm 25 */
									int BgL_tmpz00_4192;

									BgL_tmpz00_4192 = (int) (BgL_iz00_4155);
									CNST_TABLE_SET(BgL_tmpz00_4192, BgL_arg2218z00_4158);
							}}
							{	/* Cfa/closure.scm 25 */
								int BgL_auxz00_4161;

								BgL_auxz00_4161 = (int) ((BgL_iz00_4155 - ((long) 1)));
								{
									long BgL_iz00_4197;

									BgL_iz00_4197 = (long) (BgL_auxz00_4161);
									BgL_iz00_4155 = BgL_iz00_4197;
									goto BgL_loopz00_4156;
								}
							}
						}
				}
			}
		}

	}



/* gc-roots-init */
	obj_t BGl_gczd2rootszd2initz00zzcfa_closurez00()
	{
		{	/* Cfa/closure.scm 25 */
			return bgl_gc_roots_register();
		}

	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzcfa_closurez00()
	{
		{	/* Cfa/closure.scm 25 */
			BGl_za2funcallzd2listza2zd2zzcfa_closurez00 = BNIL;
			BGl_za2makezd2procedurezd2listza2z00zzcfa_closurez00 = BNIL;
			BGl_za2procedurezd2refzd2listza2z00zzcfa_closurez00 = BNIL;
			BGl_za2procedurezd2refza2zd2zzcfa_closurez00 = BFALSE;
			BGl_za2procedurezd2setz12za2zc0zzcfa_closurez00 = BFALSE;
			BGl_za2procedurezd2lzd2refza2z00zzcfa_closurez00 = BFALSE;
			BGl_za2procedurezd2lzd2setz12za2z12zzcfa_closurez00 = BFALSE;
			BGl_za2procedurezd2elzd2refza2z00zzcfa_closurez00 = BFALSE;
			BGl_za2procedurezd2elzd2setz12za2z12zzcfa_closurez00 = BFALSE;
			BGl_za2makezd2elzd2procedureza2z00zzcfa_closurez00 = BFALSE;
			return (BGl_za2makezd2lzd2procedureza2z00zzcfa_closurez00 =
				BFALSE, BUNSPEC);
		}

	}



/* closure-optimization? */
	BGL_EXPORTED_DEF obj_t BGl_closurezd2optimiza7ationzf3z86zzcfa_closurez00()
	{
		{	/* Cfa/closure.scm 55 */
			{	/* Cfa/closure.scm 56 */
				long BgL_n1z00_3772;

				BgL_n1z00_3772 = (long) CINT(BGl_za2optimza2z00zzengine_paramz00);
				return BBOOL((BgL_n1z00_3772 >= ((long) 2)));
		}}

	}



/* &closure-optimization? */
	obj_t BGl_z62closurezd2optimiza7ationzf3ze4zzcfa_closurez00(obj_t
		BgL_envz00_4134)
	{
		{	/* Cfa/closure.scm 55 */
			return BGl_closurezd2optimiza7ationzf3z86zzcfa_closurez00();
		}

	}



/* closure-optimization! */
	BGL_EXPORTED_DEF obj_t
		BGl_closurezd2optimiza7ationz12z67zzcfa_closurez00(obj_t BgL_globalsz00_3)
	{
		{	/* Cfa/closure.scm 61 */
			if (((long) CINT(BGl_za2optimza2z00zzengine_paramz00) >= ((long) 2)))
				{	/* Cfa/closure.scm 62 */
					{	/* Cfa/closure.scm 63 */
						obj_t BgL_list1556z00_2770;

						{	/* Cfa/closure.scm 63 */
							obj_t BgL_arg1558z00_2771;

							BgL_arg1558z00_2771 =
								MAKE_YOUNG_PAIR(BCHAR(((unsigned char) 10)), BNIL);
							BgL_list1556z00_2770 =
								MAKE_YOUNG_PAIR(BGl_string2209z00zzcfa_closurez00,
								BgL_arg1558z00_2771);
						}
						BGl_verbosez00zztools_speekz00(BINT(((long) 1)),
							BgL_list1556z00_2770);
					}
					BGl_startzd2closurezd2cachez00zzcfa_closurez00();
					{
						obj_t BgL_l1510z00_2773;

						BgL_l1510z00_2773 =
							BGl_za2makezd2procedurezd2listza2z00zzcfa_closurez00;
					BgL_zc3z04anonymousza31559ze3z87_2774:
						if (PAIRP(BgL_l1510z00_2773))
							{	/* Cfa/closure.scm 72 */
								{	/* Cfa/closure.scm 74 */
									obj_t BgL_appz00_2776;

									BgL_appz00_2776 = CAR(BgL_l1510z00_2773);
									{	/* Cfa/closure.scm 75 */
										BgL_variablez00_bglt BgL_funz00_2778;

										{
											BgL_varz00_bglt BgL_auxz00_4216;

											{	/* Cfa/closure.scm 75 */
												obj_t BgL_pairz00_3778;

												BgL_pairz00_3778 =
													(((BgL_appz00_bglt) COBJECT(
															((BgL_appz00_bglt)
																((BgL_appz00_bglt) BgL_appz00_2776))))->
													BgL_argsz00);
												BgL_auxz00_4216 =
													((BgL_varz00_bglt) CAR(BgL_pairz00_3778));
											}
											BgL_funz00_2778 =
												(((BgL_varz00_bglt) COBJECT(BgL_auxz00_4216))->
												BgL_variablez00);
										}
										{	/* Cfa/closure.scm 75 */
											obj_t BgL_cloz00_2779;

											BgL_cloz00_2779 =
												(((BgL_funz00_bglt) COBJECT(
														((BgL_funz00_bglt)
															((BgL_sfunz00_bglt)
																(((BgL_variablez00_bglt) COBJECT(
																			((BgL_variablez00_bglt)
																				((BgL_globalz00_bglt)
																					BgL_funz00_2778))))->
																	BgL_valuez00)))))->BgL_thezd2closurezd2);
											{	/* Cfa/closure.scm 76 */
												bool_t BgL_lostzf3zf3_2780;

												{	/* Cfa/closure.scm 77 */
													long BgL_arg1609z00_2804;

													{
														BgL_makezd2procedurezd2appz00_bglt BgL_auxz00_4229;

														{
															obj_t BgL_auxz00_4230;

															{	/* Cfa/closure.scm 77 */
																BgL_objectz00_bglt BgL_tmpz00_4231;

																BgL_tmpz00_4231 =
																	((BgL_objectz00_bglt)
																	((BgL_appz00_bglt) BgL_appz00_2776));
																BgL_auxz00_4230 =
																	BGL_OBJECT_WIDENING(BgL_tmpz00_4231);
															}
															BgL_auxz00_4229 =
																((BgL_makezd2procedurezd2appz00_bglt)
																BgL_auxz00_4230);
														}
														BgL_arg1609z00_2804 =
															(((BgL_makezd2procedurezd2appz00_bglt)
																COBJECT(BgL_auxz00_4229))->BgL_lostzd2stampzd2);
													}
													BgL_lostzf3zf3_2780 =
														(BgL_arg1609z00_2804 > ((long) -1));
												}
												{	/* Cfa/closure.scm 77 */
													obj_t BgL_siza7eza7_2781;

													{	/* Cfa/closure.scm 78 */
														obj_t BgL_arg1598z00_2802;

														{	/* Cfa/closure.scm 78 */
															obj_t BgL_pairz00_3785;

															BgL_pairz00_3785 =
																(((BgL_appz00_bglt) COBJECT(
																		((BgL_appz00_bglt)
																			((BgL_appz00_bglt) BgL_appz00_2776))))->
																BgL_argsz00);
															BgL_arg1598z00_2802 =
																CAR(CDR(CDR(BgL_pairz00_3785)));
														}
														BgL_siza7eza7_2781 =
															BGl_getzd2nodezd2atomzd2valuezd2zzcfa_approxz00(
															((BgL_nodez00_bglt) BgL_arg1598z00_2802));
													}
													{	/* Cfa/closure.scm 78 */

														{	/* Cfa/closure.scm 80 */
															bool_t BgL_test2241z00_4246;

															if (BgL_lostzf3zf3_2780)
																{	/* Cfa/closure.scm 80 */
																	BgL_test2241z00_4246 = ((bool_t) 1);
																}
															else
																{	/* Cfa/closure.scm 81 */
																	bool_t BgL_test2243z00_4248;

																	{
																		BgL_makezd2procedurezd2appz00_bglt
																			BgL_auxz00_4249;
																		{
																			obj_t BgL_auxz00_4250;

																			{	/* Cfa/closure.scm 81 */
																				BgL_objectz00_bglt BgL_tmpz00_4251;

																				BgL_tmpz00_4251 =
																					((BgL_objectz00_bglt)
																					((BgL_appz00_bglt) BgL_appz00_2776));
																				BgL_auxz00_4250 =
																					BGL_OBJECT_WIDENING(BgL_tmpz00_4251);
																			}
																			BgL_auxz00_4249 =
																				((BgL_makezd2procedurezd2appz00_bglt)
																				BgL_auxz00_4250);
																		}
																		BgL_test2243z00_4248 =
																			(((BgL_makezd2procedurezd2appz00_bglt)
																				COBJECT(BgL_auxz00_4249))->
																			BgL_xzd2tzf3z21);
																	}
																	if (BgL_test2243z00_4248)
																		{	/* Cfa/closure.scm 81 */
																			if (
																				((((BgL_funz00_bglt) COBJECT(
																								((BgL_funz00_bglt)
																									((BgL_sfunz00_bglt)
																										(((BgL_variablez00_bglt)
																												COBJECT((
																														(BgL_variablez00_bglt)
																														((BgL_globalz00_bglt) BgL_funz00_2778))))->BgL_valuez00)))))->BgL_arityz00) < ((long) 0)))
																				{	/* Cfa/closure.scm 82 */
																					BgL_test2241z00_4246 = ((bool_t) 1);
																				}
																			else
																				{	/* Cfa/closure.scm 82 */
																					if (INTEGERP(BgL_siza7eza7_2781))
																						{	/* Cfa/closure.scm 83 */
																							if (BGl_isazf3zf3zz__objectz00
																								(BgL_cloz00_2779,
																									BGl_globalz00zzast_varz00))
																								{	/* Cfa/closure.scm 84 */
																									if (
																										((((BgL_globalz00_bglt)
																													COBJECT((
																															(BgL_globalz00_bglt)
																															BgL_cloz00_2779)))->
																												BgL_importz00) ==
																											CNST_TABLE_REF(((long)
																													0))))
																										{	/* Cfa/closure.scm 85 */
																											BgL_test2241z00_4246 =
																												((bool_t) 0);
																										}
																									else
																										{	/* Cfa/closure.scm 85 */
																											BgL_test2241z00_4246 =
																												((bool_t) 1);
																										}
																								}
																							else
																								{	/* Cfa/closure.scm 84 */
																									BgL_test2241z00_4246 =
																										((bool_t) 0);
																								}
																						}
																					else
																						{	/* Cfa/closure.scm 83 */
																							BgL_test2241z00_4246 =
																								((bool_t) 1);
																						}
																				}
																		}
																	else
																		{	/* Cfa/closure.scm 81 */
																			BgL_test2241z00_4246 = ((bool_t) 1);
																		}
																}
															if (BgL_test2241z00_4246)
																{	/* Cfa/closure.scm 80 */
																	BNIL;
																}
															else
																{	/* Cfa/closure.scm 80 */
																	{
																		BgL_makezd2procedurezd2appz00_bglt
																			BgL_auxz00_4274;
																		{
																			obj_t BgL_auxz00_4275;

																			{	/* Cfa/closure.scm 102 */
																				BgL_objectz00_bglt BgL_tmpz00_4276;

																				BgL_tmpz00_4276 =
																					((BgL_objectz00_bglt)
																					((BgL_appz00_bglt) BgL_appz00_2776));
																				BgL_auxz00_4275 =
																					BGL_OBJECT_WIDENING(BgL_tmpz00_4276);
																			}
																			BgL_auxz00_4274 =
																				((BgL_makezd2procedurezd2appz00_bglt)
																				BgL_auxz00_4275);
																		}
																		((((BgL_makezd2procedurezd2appz00_bglt)
																					COBJECT(BgL_auxz00_4274))->BgL_xz00) =
																			((bool_t) ((bool_t) 1)), BUNSPEC);
																	}
																	{
																		BgL_makezd2procedurezd2appz00_bglt
																			BgL_auxz00_4282;
																		{
																			obj_t BgL_auxz00_4283;

																			{	/* Cfa/closure.scm 103 */
																				BgL_objectz00_bglt BgL_tmpz00_4284;

																				BgL_tmpz00_4284 =
																					((BgL_objectz00_bglt)
																					((BgL_appz00_bglt) BgL_appz00_2776));
																				BgL_auxz00_4283 =
																					BGL_OBJECT_WIDENING(BgL_tmpz00_4284);
																			}
																			BgL_auxz00_4282 =
																				((BgL_makezd2procedurezd2appz00_bglt)
																				BgL_auxz00_4283);
																		}
																		((((BgL_makezd2procedurezd2appz00_bglt)
																					COBJECT(BgL_auxz00_4282))->BgL_tz00) =
																			((bool_t) ((bool_t) 1)), BUNSPEC);
																	}
																}
														}
													}
												}
											}
										}
									}
								}
								{
									obj_t BgL_l1510z00_4290;

									BgL_l1510z00_4290 = CDR(BgL_l1510z00_2773);
									BgL_l1510z00_2773 = BgL_l1510z00_4290;
									goto BgL_zc3z04anonymousza31559ze3z87_2774;
								}
							}
						else
							{	/* Cfa/closure.scm 72 */
								((bool_t) 1);
							}
					}
					BGl_Xz12z12zzcfa_closurez00
						(BGl_za2funcallzd2listza2zd2zzcfa_closurez00);
					BGl_Tzd2fixzd2pointz12z12zzcfa_closurez00
						(BGl_za2funcallzd2listza2zd2zzcfa_closurez00);
					{
						obj_t BgL_l1512z00_2811;

						BgL_l1512z00_2811 =
							BGl_za2makezd2procedurezd2listza2z00zzcfa_closurez00;
					BgL_zc3z04anonymousza31628ze3z87_2812:
						if (PAIRP(BgL_l1512z00_2811))
							{	/* Cfa/closure.scm 110 */
								{	/* Cfa/closure.scm 111 */
									obj_t BgL_allocz00_2814;

									BgL_allocz00_2814 = CAR(BgL_l1512z00_2811);
									{	/* Cfa/closure.scm 112 */
										BgL_valuez00_bglt BgL_fz00_2816;

										{
											BgL_variablez00_bglt BgL_auxz00_4297;

											{
												BgL_varz00_bglt BgL_auxz00_4298;

												{	/* Cfa/closure.scm 112 */
													obj_t BgL_pairz00_3804;

													BgL_pairz00_3804 =
														(((BgL_appz00_bglt) COBJECT(
																((BgL_appz00_bglt)
																	((BgL_appz00_bglt) BgL_allocz00_2814))))->
														BgL_argsz00);
													BgL_auxz00_4298 =
														((BgL_varz00_bglt) CAR(BgL_pairz00_3804));
												}
												BgL_auxz00_4297 =
													(((BgL_varz00_bglt) COBJECT(BgL_auxz00_4298))->
													BgL_variablez00);
											}
											BgL_fz00_2816 =
												(((BgL_variablez00_bglt) COBJECT(BgL_auxz00_4297))->
												BgL_valuez00);
										}
										{	/* Cfa/closure.scm 114 */
											bool_t BgL_test2249z00_4306;

											{
												BgL_makezd2procedurezd2appz00_bglt BgL_auxz00_4307;

												{
													obj_t BgL_auxz00_4308;

													{	/* Cfa/closure.scm 114 */
														BgL_objectz00_bglt BgL_tmpz00_4309;

														BgL_tmpz00_4309 =
															((BgL_objectz00_bglt)
															((BgL_appz00_bglt) BgL_allocz00_2814));
														BgL_auxz00_4308 =
															BGL_OBJECT_WIDENING(BgL_tmpz00_4309);
													}
													BgL_auxz00_4307 =
														((BgL_makezd2procedurezd2appz00_bglt)
														BgL_auxz00_4308);
												}
												BgL_test2249z00_4306 =
													(((BgL_makezd2procedurezd2appz00_bglt)
														COBJECT(BgL_auxz00_4307))->BgL_xz00);
											}
											if (BgL_test2249z00_4306)
												{	/* Cfa/closure.scm 114 */
													obj_t BgL_vz00_3809;

													BgL_vz00_3809 = CNST_TABLE_REF(((long) 1));
													((((BgL_sfunz00_bglt) COBJECT(
																	((BgL_sfunz00_bglt) BgL_fz00_2816)))->
															BgL_strengthz00) =
														((obj_t) BgL_vz00_3809), BUNSPEC);
												}
											else
												{	/* Cfa/closure.scm 115 */
													bool_t BgL_test2250z00_4318;

													{
														BgL_makezd2procedurezd2appz00_bglt BgL_auxz00_4319;

														{
															obj_t BgL_auxz00_4320;

															{	/* Cfa/closure.scm 115 */
																BgL_objectz00_bglt BgL_tmpz00_4321;

																BgL_tmpz00_4321 =
																	((BgL_objectz00_bglt)
																	((BgL_appz00_bglt) BgL_allocz00_2814));
																BgL_auxz00_4320 =
																	BGL_OBJECT_WIDENING(BgL_tmpz00_4321);
															}
															BgL_auxz00_4319 =
																((BgL_makezd2procedurezd2appz00_bglt)
																BgL_auxz00_4320);
														}
														BgL_test2250z00_4318 =
															(((BgL_makezd2procedurezd2appz00_bglt)
																COBJECT(BgL_auxz00_4319))->BgL_tz00);
													}
													if (BgL_test2250z00_4318)
														{	/* Cfa/closure.scm 115 */
															obj_t BgL_vz00_3812;

															BgL_vz00_3812 = CNST_TABLE_REF(((long) 2));
															((((BgL_sfunz00_bglt) COBJECT(
																			((BgL_sfunz00_bglt) BgL_fz00_2816)))->
																	BgL_strengthz00) =
																((obj_t) BgL_vz00_3812), BUNSPEC);
														}
													else
														{	/* Cfa/closure.scm 116 */
															obj_t BgL_vz00_3814;

															BgL_vz00_3814 = CNST_TABLE_REF(((long) 3));
															((((BgL_sfunz00_bglt) COBJECT(
																			((BgL_sfunz00_bglt) BgL_fz00_2816)))->
																	BgL_strengthz00) =
																((obj_t) BgL_vz00_3814), BUNSPEC);
								}}}}}
								{
									obj_t BgL_l1512z00_4333;

									BgL_l1512z00_4333 = CDR(BgL_l1512z00_2811);
									BgL_l1512z00_2811 = BgL_l1512z00_4333;
									goto BgL_zc3z04anonymousza31628ze3z87_2812;
								}
							}
						else
							{	/* Cfa/closure.scm 110 */
								((bool_t) 1);
							}
					}
					BGl_showzd2Xzd2Tz00zzcfa_closurez00
						(BGl_za2makezd2procedurezd2listza2z00zzcfa_closurez00);
					BGl_lightzd2funcallz12zc0zzcfa_closurez00();
					BGl_lightzd2accessz12zc0zzcfa_closurez00();
					BGl_lightzd2makezd2procedurez12z12zzcfa_closurez00();
					return BGl_lightzd2typez12zc0zzcfa_ltypez00(BgL_globalsz00_3);
				}
			else
				{	/* Cfa/closure.scm 62 */
					return BFALSE;
				}
		}

	}



/* &closure-optimization! */
	obj_t BGl_z62closurezd2optimiza7ationz12z05zzcfa_closurez00(obj_t
		BgL_envz00_4135, obj_t BgL_globalsz00_4136)
	{
		{	/* Cfa/closure.scm 61 */
			return
				BGl_closurezd2optimiza7ationz12z67zzcfa_closurez00(BgL_globalsz00_4136);
		}

	}



/* X! */
	bool_t BGl_Xz12z12zzcfa_closurez00(obj_t BgL_funcallzd2listzd2_4)
	{
		{	/* Cfa/closure.scm 132 */
			{
				obj_t BgL_l1514z00_2825;

				BgL_l1514z00_2825 = BgL_funcallzd2listzd2_4;
			BgL_zc3z04anonymousza31642ze3z87_2826:
				if (PAIRP(BgL_l1514z00_2825))
					{	/* Cfa/closure.scm 134 */
						{	/* Cfa/closure.scm 135 */
							BgL_funcallz00_bglt BgL_appz00_2828;

							BgL_appz00_2828 = ((BgL_funcallz00_bglt) CAR(BgL_l1514z00_2825));
							{	/* Cfa/closure.scm 136 */
								BgL_nodez00_bglt BgL_funz00_2829;

								BgL_funz00_2829 =
									(((BgL_funcallz00_bglt) COBJECT(BgL_appz00_2828))->
									BgL_funz00);
								{	/* Cfa/closure.scm 136 */
									BgL_approxz00_bglt BgL_approxz00_2830;

									BgL_approxz00_2830 =
										BGl_cfaz12z12zzcfa_cfaz00(BgL_funz00_2829);
									{	/* Cfa/closure.scm 137 */
										obj_t BgL_allocz00_2831;

										BgL_allocz00_2831 =
											(((BgL_approxz00_bglt) COBJECT(BgL_approxz00_2830))->
											BgL_allocsz00);
										{	/* Cfa/closure.scm 138 */
											BgL_typez00_bglt BgL_typez00_2832;

											BgL_typez00_2832 =
												(((BgL_approxz00_bglt) COBJECT(BgL_approxz00_2830))->
												BgL_typez00);
											{	/* Cfa/closure.scm 139 */
												bool_t BgL_topzf3zf3_2833;

												BgL_topzf3zf3_2833 =
													(((BgL_approxz00_bglt) COBJECT(BgL_approxz00_2830))->
													BgL_topzf3zf3);
												{	/* Cfa/closure.scm 140 */

													if (BgL_topzf3zf3_2833)
														{	/* Cfa/closure.scm 142 */
															BGl_forzd2eachzd2approxzd2alloczd2zzcfa_approxz00
																(BGl_proc2210z00zzcfa_closurez00,
																BgL_approxz00_2830);
														}
													else
														{	/* Cfa/closure.scm 153 */
															bool_t BgL_test2253z00_4352;

															{	/* Cfa/closure.scm 153 */
																obj_t BgL_arg1663z00_2854;

																BgL_arg1663z00_2854 =
																	BGl_setzd2lengthzd2zzcfa_setz00
																	(BgL_allocz00_2831);
																BgL_test2253z00_4352 =
																	((long) CINT(BgL_arg1663z00_2854) ==
																	((long) 0));
															}
															if (BgL_test2253z00_4352)
																{	/* Cfa/closure.scm 153 */
																	CNST_TABLE_REF(((long) 4));
																}
															else
																{	/* Cfa/closure.scm 156 */
																	bool_t BgL_test2254z00_4357;

																	{	/* Cfa/closure.scm 156 */
																		bool_t BgL_test2255z00_4358;

																		{	/* Cfa/closure.scm 156 */
																			obj_t BgL_arg1660z00_2853;

																			BgL_arg1660z00_2853 =
																				BGl_setzd2lengthzd2zzcfa_setz00
																				(BgL_allocz00_2831);
																			BgL_test2255z00_4358 =
																				((long) CINT(BgL_arg1660z00_2853) ==
																				((long) 1));
																		}
																		if (BgL_test2255z00_4358)
																			{	/* Cfa/closure.scm 157 */
																				obj_t BgL__ortest_1161z00_2852;

																				BgL__ortest_1161z00_2852 =
																					BGl_za2unsafezd2typeza2zd2zzengine_paramz00;
																				if (CBOOL(BgL__ortest_1161z00_2852))
																					{	/* Cfa/closure.scm 157 */
																						BgL_test2254z00_4357 =
																							CBOOL(BgL__ortest_1161z00_2852);
																					}
																				else
																					{	/* Cfa/closure.scm 157 */
																						BgL_test2254z00_4357 =
																							(
																							((obj_t) BgL_typez00_2832) ==
																							BGl_za2procedureza2z00zztype_cachez00);
																					}
																			}
																		else
																			{	/* Cfa/closure.scm 156 */
																				BgL_test2254z00_4357 = ((bool_t) 0);
																			}
																	}
																	if (BgL_test2254z00_4357)
																		{	/* Cfa/closure.scm 156 */
																			CNST_TABLE_REF(((long) 4));
																		}
																	else
																		{	/* Cfa/closure.scm 156 */
																			BGl_forzd2eachzd2approxzd2alloczd2zzcfa_approxz00
																				(BGl_proc2211z00zzcfa_closurez00,
																				BgL_approxz00_2830);
																		}
																}
														}
												}
											}
										}
									}
								}
							}
						}
						{
							obj_t BgL_l1514z00_4369;

							BgL_l1514z00_4369 = CDR(BgL_l1514z00_2825);
							BgL_l1514z00_2825 = BgL_l1514z00_4369;
							goto BgL_zc3z04anonymousza31642ze3z87_2826;
						}
					}
				else
					{	/* Cfa/closure.scm 134 */
						return ((bool_t) 1);
					}
			}
		}

	}



/* &<@anonymous:1645> */
	obj_t BGl_z62zc3z04anonymousza31645ze3ze5zzcfa_closurez00(obj_t
		BgL_envz00_4139, obj_t BgL_allocz00_4140)
	{
		{	/* Cfa/closure.scm 145 */
			if (BGl_isazf3zf3zz__objectz00(BgL_allocz00_4140,
					BGl_makezd2procedurezd2appz00zzcfa_info2z00))
				{	/* Cfa/closure.scm 146 */
					{
						BgL_makezd2procedurezd2appz00_bglt BgL_auxz00_4373;

						{
							obj_t BgL_auxz00_4374;

							{	/* Cfa/closure.scm 150 */
								BgL_objectz00_bglt BgL_tmpz00_4375;

								BgL_tmpz00_4375 =
									((BgL_objectz00_bglt) ((BgL_appz00_bglt) BgL_allocz00_4140));
								BgL_auxz00_4374 = BGL_OBJECT_WIDENING(BgL_tmpz00_4375);
							}
							BgL_auxz00_4373 =
								((BgL_makezd2procedurezd2appz00_bglt) BgL_auxz00_4374);
						}
						((((BgL_makezd2procedurezd2appz00_bglt) COBJECT(BgL_auxz00_4373))->
								BgL_tz00) = ((bool_t) ((bool_t) 0)), BUNSPEC);
					}
					{
						BgL_makezd2procedurezd2appz00_bglt BgL_auxz00_4381;

						{
							obj_t BgL_auxz00_4382;

							{	/* Cfa/closure.scm 151 */
								BgL_objectz00_bglt BgL_tmpz00_4383;

								BgL_tmpz00_4383 =
									((BgL_objectz00_bglt) ((BgL_appz00_bglt) BgL_allocz00_4140));
								BgL_auxz00_4382 = BGL_OBJECT_WIDENING(BgL_tmpz00_4383);
							}
							BgL_auxz00_4381 =
								((BgL_makezd2procedurezd2appz00_bglt) BgL_auxz00_4382);
						}
						return
							((((BgL_makezd2procedurezd2appz00_bglt)
									COBJECT(BgL_auxz00_4381))->BgL_xz00) =
							((bool_t) ((bool_t) 0)), BUNSPEC);
					}
				}
			else
				{	/* Cfa/closure.scm 146 */
					return BFALSE;
				}
		}

	}



/* &<@anonymous:1656> */
	obj_t BGl_z62zc3z04anonymousza31656ze3ze5zzcfa_closurez00(obj_t
		BgL_envz00_4141, obj_t BgL_allocz00_4142)
	{
		{	/* Cfa/closure.scm 164 */
			if (BGl_isazf3zf3zz__objectz00(BgL_allocz00_4142,
					BGl_makezd2procedurezd2appz00zzcfa_info2z00))
				{	/* Cfa/closure.scm 165 */
					{
						BgL_makezd2procedurezd2appz00_bglt BgL_auxz00_4391;

						{
							obj_t BgL_auxz00_4392;

							{	/* Cfa/closure.scm 169 */
								BgL_objectz00_bglt BgL_tmpz00_4393;

								BgL_tmpz00_4393 =
									((BgL_objectz00_bglt) ((BgL_appz00_bglt) BgL_allocz00_4142));
								BgL_auxz00_4392 = BGL_OBJECT_WIDENING(BgL_tmpz00_4393);
							}
							BgL_auxz00_4391 =
								((BgL_makezd2procedurezd2appz00_bglt) BgL_auxz00_4392);
						}
						return
							((((BgL_makezd2procedurezd2appz00_bglt)
									COBJECT(BgL_auxz00_4391))->BgL_xz00) =
							((bool_t) ((bool_t) 0)), BUNSPEC);
					}
				}
			else
				{	/* Cfa/closure.scm 165 */
					return BFALSE;
				}
		}

	}



/* T-fix-point! */
	obj_t BGl_Tzd2fixzd2pointz12z12zzcfa_closurez00(obj_t BgL_funcallzd2listzd2_5)
	{
		{	/* Cfa/closure.scm 182 */
			{
				bool_t BgL_continuezf3zf3_2858;

				BgL_continuezf3zf3_2858 = ((bool_t) 1);
			BgL_zc3z04anonymousza31666ze3z87_2859:
				if (BgL_continuezf3zf3_2858)
					{	/* Cfa/closure.scm 187 */
						bool_t BgL_continuezf3zf3_2860;

						BgL_continuezf3zf3_2860 = ((bool_t) 0);
						{
							obj_t BgL_l1518z00_2862;

							BgL_l1518z00_2862 = BgL_funcallzd2listzd2_5;
						BgL_zc3z04anonymousza31667ze3z87_2863:
							if (PAIRP(BgL_l1518z00_2862))
								{	/* Cfa/closure.scm 188 */
									{	/* Cfa/closure.scm 190 */
										obj_t BgL_appz00_2865;

										BgL_appz00_2865 = CAR(BgL_l1518z00_2862);
										{	/* Cfa/closure.scm 191 */
											BgL_nodez00_bglt BgL_funz00_2866;

											BgL_funz00_2866 =
												(((BgL_funcallz00_bglt) COBJECT(
														((BgL_funcallz00_bglt) BgL_appz00_2865)))->
												BgL_funz00);
											{	/* Cfa/closure.scm 191 */
												BgL_approxz00_bglt BgL_approxz00_2867;

												BgL_approxz00_2867 =
													BGl_cfaz12z12zzcfa_cfaz00(BgL_funz00_2866);
												{	/* Cfa/closure.scm 192 */
													obj_t BgL_allocz00_2868;

													BgL_allocz00_2868 =
														BGl_setzd2ze3listz31zzcfa_setz00(
														(((BgL_approxz00_bglt)
																COBJECT(BgL_approxz00_2867))->BgL_allocsz00));
													{	/* Cfa/closure.scm 193 */
														BgL_typez00_bglt BgL_typez00_2869;

														BgL_typez00_2869 =
															(((BgL_approxz00_bglt)
																COBJECT(BgL_approxz00_2867))->BgL_typez00);
														{	/* Cfa/closure.scm 194 */
															bool_t BgL_tzd2initzf3z21_2870;

															{	/* Cfa/closure.scm 195 */
																bool_t BgL__ortest_1162z00_2894;

																BgL__ortest_1162z00_2894 =
																	(((BgL_approxz00_bglt)
																		COBJECT(BgL_approxz00_2867))->
																	BgL_topzf3zf3);
																if (BgL__ortest_1162z00_2894)
																	{	/* Cfa/closure.scm 195 */
																		BgL_tzd2initzf3z21_2870 =
																			BgL__ortest_1162z00_2894;
																	}
																else
																	{	/* Cfa/closure.scm 196 */
																		bool_t BgL_test2262z00_4411;

																		if (
																			(((obj_t) BgL_typez00_2869) ==
																				BGl_za2procedureza2z00zztype_cachez00))
																			{	/* Cfa/closure.scm 196 */
																				BgL_test2262z00_4411 = ((bool_t) 1);
																			}
																		else
																			{	/* Cfa/closure.scm 196 */
																				BgL_test2262z00_4411 =
																					CBOOL
																					(BGl_za2unsafezd2typeza2zd2zzengine_paramz00);
																			}
																		if (BgL_test2262z00_4411)
																			{	/* Cfa/closure.scm 196 */
																				BgL_tzd2initzf3z21_2870 = ((bool_t) 0);
																			}
																		else
																			{	/* Cfa/closure.scm 196 */
																				BgL_tzd2initzf3z21_2870 = ((bool_t) 1);
																			}
																	}
															}
															{	/* Cfa/closure.scm 195 */

																{
																	bool_t BgL_onezd2nonzd2tzf3zf3_2872;
																	obj_t BgL_allocsz00_2873;

																	BgL_onezd2nonzd2tzf3zf3_2872 =
																		BgL_tzd2initzf3z21_2870;
																	BgL_allocsz00_2873 = BgL_allocz00_2868;
																BgL_zc3z04anonymousza31670ze3z87_2874:
																	if (NULLP(BgL_allocsz00_2873))
																		{	/* Cfa/closure.scm 204 */
																			CNST_TABLE_REF(((long) 5));
																		}
																	else
																		{	/* Cfa/closure.scm 204 */
																			if (BgL_onezd2nonzd2tzf3zf3_2872)
																				{
																					obj_t BgL_l1516z00_2877;

																					{	/* Cfa/closure.scm 207 */
																						bool_t BgL_tmpz00_4420;

																						BgL_l1516z00_2877 =
																							BgL_allocz00_2868;
																					BgL_zc3z04anonymousza31672ze3z87_2878:
																						if (PAIRP
																							(BgL_l1516z00_2877))
																							{	/* Cfa/closure.scm 207 */
																								{	/* Cfa/closure.scm 209 */
																									obj_t BgL_allocz00_2880;

																									BgL_allocz00_2880 =
																										CAR(BgL_l1516z00_2877);
																									if (BGl_isazf3zf3zz__objectz00
																										(BgL_allocz00_2880,
																											BGl_makezd2procedurezd2appz00zzcfa_info2z00))
																										{	/* Cfa/closure.scm 211 */
																											bool_t
																												BgL_test2268z00_4426;
																											{
																												BgL_makezd2procedurezd2appz00_bglt
																													BgL_auxz00_4427;
																												{
																													obj_t BgL_auxz00_4428;

																													{	/* Cfa/closure.scm 211 */
																														BgL_objectz00_bglt
																															BgL_tmpz00_4429;
																														BgL_tmpz00_4429 =
																															(
																															(BgL_objectz00_bglt)
																															((BgL_appz00_bglt)
																																BgL_allocz00_2880));
																														BgL_auxz00_4428 =
																															BGL_OBJECT_WIDENING
																															(BgL_tmpz00_4429);
																													}
																													BgL_auxz00_4427 =
																														(
																														(BgL_makezd2procedurezd2appz00_bglt)
																														BgL_auxz00_4428);
																												}
																												BgL_test2268z00_4426 =
																													(((BgL_makezd2procedurezd2appz00_bglt) COBJECT(BgL_auxz00_4427))->BgL_tz00);
																											}
																											if (BgL_test2268z00_4426)
																												{	/* Cfa/closure.scm 211 */
																													{
																														BgL_makezd2procedurezd2appz00_bglt
																															BgL_auxz00_4435;
																														{
																															obj_t
																																BgL_auxz00_4436;
																															{	/* Cfa/closure.scm 212 */
																																BgL_objectz00_bglt
																																	BgL_tmpz00_4437;
																																BgL_tmpz00_4437
																																	=
																																	(
																																	(BgL_objectz00_bglt)
																																	((BgL_appz00_bglt) BgL_allocz00_2880));
																																BgL_auxz00_4436
																																	=
																																	BGL_OBJECT_WIDENING
																																	(BgL_tmpz00_4437);
																															}
																															BgL_auxz00_4435 =
																																(
																																(BgL_makezd2procedurezd2appz00_bglt)
																																BgL_auxz00_4436);
																														}
																														((((BgL_makezd2procedurezd2appz00_bglt) COBJECT(BgL_auxz00_4435))->BgL_tz00) = ((bool_t) ((bool_t) 0)), BUNSPEC);
																													}
																													BgL_continuezf3zf3_2860
																														= ((bool_t) 1);
																												}
																											else
																												{	/* Cfa/closure.scm 211 */
																													BFALSE;
																												}
																										}
																									else
																										{	/* Cfa/closure.scm 209 */
																											BFALSE;
																										}
																								}
																								{
																									obj_t BgL_l1516z00_4443;

																									BgL_l1516z00_4443 =
																										CDR(BgL_l1516z00_2877);
																									BgL_l1516z00_2877 =
																										BgL_l1516z00_4443;
																									goto
																										BgL_zc3z04anonymousza31672ze3z87_2878;
																								}
																							}
																						else
																							{	/* Cfa/closure.scm 207 */
																								BgL_tmpz00_4420 = ((bool_t) 1);
																							}
																						BBOOL(BgL_tmpz00_4420);
																					}
																				}
																			else
																				{	/* Cfa/closure.scm 215 */
																					bool_t BgL_test2269z00_4446;

																					{	/* Cfa/closure.scm 215 */
																						obj_t BgL_arg1691z00_2892;

																						BgL_arg1691z00_2892 =
																							CAR(((obj_t) BgL_allocsz00_2873));
																						BgL_test2269z00_4446 =
																							BGl_isazf3zf3zz__objectz00
																							(BgL_arg1691z00_2892,
																							BGl_makezd2procedurezd2appz00zzcfa_info2z00);
																					}
																					if (BgL_test2269z00_4446)
																						{	/* Cfa/closure.scm 216 */
																							BgL_appz00_bglt BgL_i1164z00_2888;

																							BgL_i1164z00_2888 =
																								((BgL_appz00_bglt)
																								CAR(
																									((obj_t)
																										BgL_allocsz00_2873)));
																							{	/* Cfa/closure.scm 217 */
																								bool_t BgL_test2270z00_4453;

																								{
																									BgL_makezd2procedurezd2appz00_bglt
																										BgL_auxz00_4454;
																									{
																										obj_t BgL_auxz00_4455;

																										{	/* Cfa/closure.scm 217 */
																											BgL_objectz00_bglt
																												BgL_tmpz00_4456;
																											BgL_tmpz00_4456 =
																												((BgL_objectz00_bglt)
																												BgL_i1164z00_2888);
																											BgL_auxz00_4455 =
																												BGL_OBJECT_WIDENING
																												(BgL_tmpz00_4456);
																										}
																										BgL_auxz00_4454 =
																											(
																											(BgL_makezd2procedurezd2appz00_bglt)
																											BgL_auxz00_4455);
																									}
																									BgL_test2270z00_4453 =
																										(((BgL_makezd2procedurezd2appz00_bglt) COBJECT(BgL_auxz00_4454))->BgL_tz00);
																								}
																								if (BgL_test2270z00_4453)
																									{	/* Cfa/closure.scm 218 */
																										obj_t BgL_arg1687z00_2890;

																										BgL_arg1687z00_2890 =
																											CDR(
																											((obj_t)
																												BgL_allocsz00_2873));
																										{
																											obj_t BgL_allocsz00_4463;

																											BgL_allocsz00_4463 =
																												BgL_arg1687z00_2890;
																											BgL_allocsz00_2873 =
																												BgL_allocsz00_4463;
																											goto
																												BgL_zc3z04anonymousza31670ze3z87_2874;
																										}
																									}
																								else
																									{
																										bool_t
																											BgL_onezd2nonzd2tzf3zf3_4464;
																										BgL_onezd2nonzd2tzf3zf3_4464
																											= ((bool_t) 1);
																										BgL_onezd2nonzd2tzf3zf3_2872
																											=
																											BgL_onezd2nonzd2tzf3zf3_4464;
																										goto
																											BgL_zc3z04anonymousza31670ze3z87_2874;
																									}
																							}
																						}
																					else
																						{	/* Cfa/closure.scm 215 */
																							if (CBOOL
																								(BGl_za2unsafezd2typeza2zd2zzengine_paramz00))
																								{	/* Cfa/closure.scm 222 */
																									obj_t BgL_arg1688z00_2891;

																									BgL_arg1688z00_2891 =
																										CDR(
																										((obj_t)
																											BgL_allocsz00_2873));
																									{
																										obj_t BgL_allocsz00_4469;

																										BgL_allocsz00_4469 =
																											BgL_arg1688z00_2891;
																										BgL_allocsz00_2873 =
																											BgL_allocsz00_4469;
																										goto
																											BgL_zc3z04anonymousza31670ze3z87_2874;
																									}
																								}
																							else
																								{
																									bool_t
																										BgL_onezd2nonzd2tzf3zf3_4470;
																									BgL_onezd2nonzd2tzf3zf3_4470 =
																										((bool_t) 1);
																									BgL_onezd2nonzd2tzf3zf3_2872 =
																										BgL_onezd2nonzd2tzf3zf3_4470;
																									goto
																										BgL_zc3z04anonymousza31670ze3z87_2874;
																								}
																						}
																				}
																		}
																}
															}
														}
													}
												}
											}
										}
									}
									{
										obj_t BgL_l1518z00_4471;

										BgL_l1518z00_4471 = CDR(BgL_l1518z00_2862);
										BgL_l1518z00_2862 = BgL_l1518z00_4471;
										goto BgL_zc3z04anonymousza31667ze3z87_2863;
									}
								}
							else
								{	/* Cfa/closure.scm 188 */
									((bool_t) 1);
								}
						}
						{
							bool_t BgL_continuezf3zf3_4473;

							BgL_continuezf3zf3_4473 = BgL_continuezf3zf3_2860;
							BgL_continuezf3zf3_2858 = BgL_continuezf3zf3_4473;
							goto BgL_zc3z04anonymousza31666ze3z87_2859;
						}
					}
				else
					{	/* Cfa/closure.scm 185 */
						return BUNSPEC;
					}
			}
		}

	}



/* light-make-procedure! */
	bool_t BGl_lightzd2makezd2procedurez12z12zzcfa_closurez00()
	{
		{	/* Cfa/closure.scm 251 */
			{
				obj_t BgL_appz00_2947;
				obj_t BgL_appz00_2917;

				{
					obj_t BgL_l1520z00_2908;

					BgL_l1520z00_2908 =
						BGl_za2makezd2procedurezd2listza2z00zzcfa_closurez00;
				BgL_zc3z04anonymousza31703ze3z87_2909:
					if (PAIRP(BgL_l1520z00_2908))
						{	/* Cfa/closure.scm 293 */
							{	/* Cfa/closure.scm 294 */
								obj_t BgL_appz00_2911;

								BgL_appz00_2911 = CAR(BgL_l1520z00_2908);
								{	/* Cfa/closure.scm 296 */
									bool_t BgL_test2273z00_4477;

									{
										BgL_makezd2procedurezd2appz00_bglt BgL_auxz00_4478;

										{
											obj_t BgL_auxz00_4479;

											{	/* Cfa/closure.scm 296 */
												BgL_objectz00_bglt BgL_tmpz00_4480;

												BgL_tmpz00_4480 =
													((BgL_objectz00_bglt)
													((BgL_appz00_bglt) BgL_appz00_2911));
												BgL_auxz00_4479 = BGL_OBJECT_WIDENING(BgL_tmpz00_4480);
											}
											BgL_auxz00_4478 =
												((BgL_makezd2procedurezd2appz00_bglt) BgL_auxz00_4479);
										}
										BgL_test2273z00_4477 =
											(((BgL_makezd2procedurezd2appz00_bglt)
												COBJECT(BgL_auxz00_4478))->BgL_xz00);
									}
									if (BgL_test2273z00_4477)
										{	/* Cfa/closure.scm 296 */
											BgL_appz00_2917 = BgL_appz00_2911;
											{	/* Cfa/closure.scm 255 */
												obj_t BgL_siza7eza7_2920;

												{	/* Cfa/closure.scm 255 */
													obj_t BgL_arg1760z00_2944;

													{	/* Cfa/closure.scm 255 */
														obj_t BgL_pairz00_3858;

														BgL_pairz00_3858 =
															(((BgL_appz00_bglt) COBJECT(
																	((BgL_appz00_bglt)
																		((BgL_appz00_bglt) BgL_appz00_2917))))->
															BgL_argsz00);
														BgL_arg1760z00_2944 =
															CAR(CDR(CDR(BgL_pairz00_3858)));
													}
													BgL_siza7eza7_2920 =
														BGl_getzd2nodezd2atomzd2valuezd2zzcfa_approxz00(
														((BgL_nodez00_bglt) BgL_arg1760z00_2944));
												}
												{	/* Cfa/closure.scm 255 */
													BgL_variablez00_bglt BgL_ffunz00_2921;

													{
														BgL_varz00_bglt BgL_auxz00_4494;

														{	/* Cfa/closure.scm 256 */
															obj_t BgL_pairz00_3864;

															BgL_pairz00_3864 =
																(((BgL_appz00_bglt) COBJECT(
																		((BgL_appz00_bglt)
																			((BgL_appz00_bglt) BgL_appz00_2917))))->
																BgL_argsz00);
															BgL_auxz00_4494 =
																((BgL_varz00_bglt) CAR(BgL_pairz00_3864));
														}
														BgL_ffunz00_2921 =
															(((BgL_varz00_bglt) COBJECT(BgL_auxz00_4494))->
															BgL_variablez00);
													}
													{	/* Cfa/closure.scm 256 */
														BgL_valuez00_bglt BgL_sfunz00_2922;

														BgL_sfunz00_2922 =
															(((BgL_variablez00_bglt)
																COBJECT(BgL_ffunz00_2921))->BgL_valuez00);
														{	/* Cfa/closure.scm 257 */

															if (
																((long) CINT(BgL_siza7eza7_2920) < ((long) 1)))
																{	/* Cfa/closure.scm 259 */
																	{	/* Cfa/closure.scm 260 */
																		bool_t BgL_test2275z00_4505;

																		{	/* Cfa/closure.scm 260 */
																			bool_t BgL_test2276z00_4506;

																			{	/* Cfa/closure.scm 260 */
																				bool_t BgL_res2171z00_3869;

																				BgL_res2171z00_3869 =
																					BGl_isazf3zf3zz__objectz00(
																					((obj_t) BgL_ffunz00_2921),
																					BGl_globalz00zzast_varz00);
																				BgL_test2276z00_4506 =
																					BgL_res2171z00_3869;
																			}
																			if (BgL_test2276z00_4506)
																				{	/* Cfa/closure.scm 261 */
																					bool_t BgL_test2277z00_4509;

																					{	/* Cfa/closure.scm 261 */
																						obj_t BgL_arg1750z00_2937;

																						BgL_arg1750z00_2937 =
																							(((BgL_funz00_bglt) COBJECT(
																									((BgL_funz00_bglt)
																										((BgL_sfunz00_bglt)
																											BgL_sfunz00_2922))))->
																							BgL_thezd2closurezd2);
																						BgL_test2277z00_4509 =
																							BGl_isazf3zf3zz__objectz00
																							(BgL_arg1750z00_2937,
																							BGl_globalz00zzast_varz00);
																					}
																					if (BgL_test2277z00_4509)
																						{	/* Cfa/closure.scm 262 */
																							BgL_valuez00_bglt
																								BgL_arg1748z00_2935;
																							BgL_arg1748z00_2935 =
																								(((BgL_variablez00_bglt)
																									COBJECT((
																											(BgL_variablez00_bglt) (
																												(BgL_globalz00_bglt) ((
																														(BgL_funz00_bglt)
																														COBJECT((
																																(BgL_funz00_bglt)
																																((BgL_sfunz00_bglt) BgL_sfunz00_2922))))->BgL_thezd2closurezd2)))))->BgL_valuez00);
																							{	/* Cfa/closure.scm 262 */
																								bool_t BgL_res2173z00_3874;

																								BgL_res2173z00_3874 =
																									BGl_isazf3zf3zz__objectz00(
																									((obj_t) BgL_arg1748z00_2935),
																									BGl_scnstz00zzast_varz00);
																								BgL_test2275z00_4505 =
																									BgL_res2173z00_3874;
																							}
																						}
																					else
																						{	/* Cfa/closure.scm 261 */
																							BgL_test2275z00_4505 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Cfa/closure.scm 260 */
																					BgL_test2275z00_4505 = ((bool_t) 0);
																				}
																		}
																		if (BgL_test2275z00_4505)
																			{	/* Cfa/closure.scm 263 */
																				BgL_valuez00_bglt BgL_arg1736z00_2931;

																				BgL_arg1736z00_2931 =
																					(((BgL_variablez00_bglt) COBJECT(
																							((BgL_variablez00_bglt)
																								((BgL_globalz00_bglt)
																									(((BgL_funz00_bglt) COBJECT(
																												((BgL_funz00_bglt)
																													((BgL_sfunz00_bglt)
																														BgL_sfunz00_2922))))->
																										BgL_thezd2closurezd2)))))->
																					BgL_valuez00);
																				{	/* Cfa/closure.scm 263 */
																					obj_t BgL_vz00_3878;

																					BgL_vz00_3878 =
																						CNST_TABLE_REF(((long) 6));
																					((((BgL_scnstz00_bglt) COBJECT(
																									((BgL_scnstz00_bglt)
																										BgL_arg1736z00_2931)))->
																							BgL_classz00) =
																						((obj_t) BgL_vz00_3878), BUNSPEC);
																			}}
																		else
																			{	/* Cfa/closure.scm 260 */
																				BFALSE;
																			}
																	}
																	{	/* Cfa/closure.scm 265 */
																		BgL_varz00_bglt BgL_arg1751z00_2938;

																		BgL_arg1751z00_2938 =
																			(((BgL_appz00_bglt) COBJECT(
																					((BgL_appz00_bglt)
																						((BgL_appz00_bglt)
																							BgL_appz00_2917))))->BgL_funz00);
																		{	/* Cfa/closure.scm 265 */
																			BgL_variablez00_bglt BgL_vz00_3880;

																			BgL_vz00_3880 =
																				((BgL_variablez00_bglt)
																				BGl_za2makezd2elzd2procedureza2z00zzcfa_closurez00);
																			((((BgL_varz00_bglt)
																						COBJECT(BgL_arg1751z00_2938))->
																					BgL_variablez00) =
																				((BgL_variablez00_bglt) BgL_vz00_3880),
																				BUNSPEC);
																		}
																	}
																	{	/* Cfa/closure.scm 266 */
																		BgL_varz00_bglt BgL_arg1752z00_2939;

																		BgL_arg1752z00_2939 =
																			(((BgL_appz00_bglt) COBJECT(
																					((BgL_appz00_bglt)
																						((BgL_appz00_bglt)
																							BgL_appz00_2917))))->BgL_funz00);
																		{	/* Cfa/closure.scm 266 */
																			BgL_typez00_bglt BgL_vz00_3882;

																			BgL_vz00_3882 =
																				((BgL_typez00_bglt)
																				BGl_za2procedurezd2elza2zd2zztype_cachez00);
																			((((BgL_nodez00_bglt)
																						COBJECT(((BgL_nodez00_bglt)
																								BgL_arg1752z00_2939)))->
																					BgL_typez00) =
																				((BgL_typez00_bglt) BgL_vz00_3882),
																				BUNSPEC);
																		}
																	}
																	((((BgL_nodez00_bglt) COBJECT(
																					((BgL_nodez00_bglt)
																						((BgL_appz00_bglt)
																							BgL_appz00_2917))))->
																			BgL_typez00) =
																		((BgL_typez00_bglt) ((BgL_typez00_bglt)
																				BGl_za2procedurezd2elza2zd2zztype_cachez00)),
																		BUNSPEC);
																}
															else
																{	/* Cfa/closure.scm 259 */
																	{	/* Cfa/closure.scm 269 */
																		BgL_varz00_bglt BgL_arg1753z00_2940;

																		BgL_arg1753z00_2940 =
																			(((BgL_appz00_bglt) COBJECT(
																					((BgL_appz00_bglt)
																						((BgL_appz00_bglt)
																							BgL_appz00_2917))))->BgL_funz00);
																		{	/* Cfa/closure.scm 269 */
																			BgL_variablez00_bglt BgL_vz00_3884;

																			BgL_vz00_3884 =
																				((BgL_variablez00_bglt)
																				BGl_za2makezd2elzd2procedureza2z00zzcfa_closurez00);
																			((((BgL_varz00_bglt)
																						COBJECT(BgL_arg1753z00_2940))->
																					BgL_variablez00) =
																				((BgL_variablez00_bglt) BgL_vz00_3884),
																				BUNSPEC);
																		}
																	}
																	{	/* Cfa/closure.scm 270 */
																		BgL_varz00_bglt BgL_arg1756z00_2941;

																		BgL_arg1756z00_2941 =
																			(((BgL_appz00_bglt) COBJECT(
																					((BgL_appz00_bglt)
																						((BgL_appz00_bglt)
																							BgL_appz00_2917))))->BgL_funz00);
																		{	/* Cfa/closure.scm 270 */
																			BgL_typez00_bglt BgL_vz00_3886;

																			BgL_vz00_3886 =
																				((BgL_typez00_bglt)
																				BGl_za2procedurezd2elza2zd2zztype_cachez00);
																			((((BgL_nodez00_bglt)
																						COBJECT(((BgL_nodez00_bglt)
																								BgL_arg1756z00_2941)))->
																					BgL_typez00) =
																				((BgL_typez00_bglt) BgL_vz00_3886),
																				BUNSPEC);
																		}
																	}
																	((((BgL_nodez00_bglt) COBJECT(
																					((BgL_nodez00_bglt)
																						((BgL_appz00_bglt)
																							BgL_appz00_2917))))->
																			BgL_typez00) =
																		((BgL_typez00_bglt) ((BgL_typez00_bglt)
																				BGl_za2procedurezd2elza2zd2zztype_cachez00)),
																		BUNSPEC);
																}
														}
													}
												}
											}
											{
												obj_t BgL_auxz00_4561;

												{	/* Cfa/closure.scm 272 */
													obj_t BgL_pairz00_3887;

													BgL_pairz00_3887 =
														(((BgL_appz00_bglt) COBJECT(
																((BgL_appz00_bglt)
																	((BgL_appz00_bglt) BgL_appz00_2917))))->
														BgL_argsz00);
													{	/* Cfa/closure.scm 272 */
														obj_t BgL_pairz00_3890;

														BgL_pairz00_3890 = CDR(BgL_pairz00_3887);
														BgL_auxz00_4561 = CDR(BgL_pairz00_3890);
													}
												}
												((((BgL_appz00_bglt) COBJECT(
																((BgL_appz00_bglt)
																	((BgL_appz00_bglt) BgL_appz00_2917))))->
														BgL_argsz00) = ((obj_t) BgL_auxz00_4561), BUNSPEC);
											}
											BgL_appz00_2917;
										}
									else
										{	/* Cfa/closure.scm 297 */
											bool_t BgL_test2278z00_4570;

											{
												BgL_makezd2procedurezd2appz00_bglt BgL_auxz00_4571;

												{
													obj_t BgL_auxz00_4572;

													{	/* Cfa/closure.scm 297 */
														BgL_objectz00_bglt BgL_tmpz00_4573;

														BgL_tmpz00_4573 =
															((BgL_objectz00_bglt)
															((BgL_appz00_bglt) BgL_appz00_2911));
														BgL_auxz00_4572 =
															BGL_OBJECT_WIDENING(BgL_tmpz00_4573);
													}
													BgL_auxz00_4571 =
														((BgL_makezd2procedurezd2appz00_bglt)
														BgL_auxz00_4572);
												}
												BgL_test2278z00_4570 =
													(((BgL_makezd2procedurezd2appz00_bglt)
														COBJECT(BgL_auxz00_4571))->BgL_tz00);
											}
											if (BgL_test2278z00_4570)
												{	/* Cfa/closure.scm 297 */
													BgL_appz00_2947 = BgL_appz00_2911;
													{	/* Cfa/closure.scm 277 */
														obj_t BgL_siza7eza7_2950;

														{	/* Cfa/closure.scm 277 */
															obj_t BgL_arg1786z00_2974;

															{	/* Cfa/closure.scm 277 */
																obj_t BgL_pairz00_3891;

																BgL_pairz00_3891 =
																	(((BgL_appz00_bglt) COBJECT(
																			((BgL_appz00_bglt)
																				((BgL_appz00_bglt) BgL_appz00_2947))))->
																	BgL_argsz00);
																BgL_arg1786z00_2974 =
																	CAR(CDR(CDR(BgL_pairz00_3891)));
															}
															BgL_siza7eza7_2950 =
																BGl_getzd2nodezd2atomzd2valuezd2zzcfa_approxz00(
																((BgL_nodez00_bglt) BgL_arg1786z00_2974));
														}
														{	/* Cfa/closure.scm 277 */
															BgL_variablez00_bglt BgL_ffunz00_2951;

															{
																BgL_varz00_bglt BgL_auxz00_4587;

																{	/* Cfa/closure.scm 278 */
																	obj_t BgL_pairz00_3897;

																	BgL_pairz00_3897 =
																		(((BgL_appz00_bglt) COBJECT(
																				((BgL_appz00_bglt)
																					((BgL_appz00_bglt)
																						BgL_appz00_2947))))->BgL_argsz00);
																	BgL_auxz00_4587 =
																		((BgL_varz00_bglt) CAR(BgL_pairz00_3897));
																}
																BgL_ffunz00_2951 =
																	(((BgL_varz00_bglt)
																		COBJECT(BgL_auxz00_4587))->BgL_variablez00);
															}
															{	/* Cfa/closure.scm 278 */
																BgL_valuez00_bglt BgL_sfunz00_2952;

																BgL_sfunz00_2952 =
																	(((BgL_variablez00_bglt)
																		COBJECT(BgL_ffunz00_2951))->BgL_valuez00);
																{	/* Cfa/closure.scm 279 */

																	{	/* Cfa/closure.scm 280 */
																		bool_t BgL_test2279z00_4595;

																		{	/* Cfa/closure.scm 280 */
																			bool_t BgL_test2280z00_4596;

																			{	/* Cfa/closure.scm 280 */
																				bool_t BgL_res2174z00_3900;

																				BgL_res2174z00_3900 =
																					BGl_isazf3zf3zz__objectz00(
																					((obj_t) BgL_ffunz00_2951),
																					BGl_globalz00zzast_varz00);
																				BgL_test2280z00_4596 =
																					BgL_res2174z00_3900;
																			}
																			if (BgL_test2280z00_4596)
																				{	/* Cfa/closure.scm 281 */
																					bool_t BgL_test2281z00_4599;

																					{	/* Cfa/closure.scm 281 */
																						obj_t BgL_arg1776z00_2966;

																						BgL_arg1776z00_2966 =
																							(((BgL_funz00_bglt) COBJECT(
																									((BgL_funz00_bglt)
																										((BgL_sfunz00_bglt)
																											BgL_sfunz00_2952))))->
																							BgL_thezd2closurezd2);
																						BgL_test2281z00_4599 =
																							BGl_isazf3zf3zz__objectz00
																							(BgL_arg1776z00_2966,
																							BGl_globalz00zzast_varz00);
																					}
																					if (BgL_test2281z00_4599)
																						{	/* Cfa/closure.scm 282 */
																							BgL_valuez00_bglt
																								BgL_arg1774z00_2964;
																							BgL_arg1774z00_2964 =
																								(((BgL_variablez00_bglt)
																									COBJECT((
																											(BgL_variablez00_bglt) (
																												(BgL_globalz00_bglt) ((
																														(BgL_funz00_bglt)
																														COBJECT((
																																(BgL_funz00_bglt)
																																((BgL_sfunz00_bglt) BgL_sfunz00_2952))))->BgL_thezd2closurezd2)))))->BgL_valuez00);
																							{	/* Cfa/closure.scm 282 */
																								bool_t BgL_res2176z00_3905;

																								BgL_res2176z00_3905 =
																									BGl_isazf3zf3zz__objectz00(
																									((obj_t) BgL_arg1774z00_2964),
																									BGl_scnstz00zzast_varz00);
																								BgL_test2279z00_4595 =
																									BgL_res2176z00_3905;
																							}
																						}
																					else
																						{	/* Cfa/closure.scm 281 */
																							BgL_test2279z00_4595 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Cfa/closure.scm 280 */
																					BgL_test2279z00_4595 = ((bool_t) 0);
																				}
																		}
																		if (BgL_test2279z00_4595)
																			{	/* Cfa/closure.scm 283 */
																				BgL_valuez00_bglt BgL_arg1771z00_2960;

																				BgL_arg1771z00_2960 =
																					(((BgL_variablez00_bglt) COBJECT(
																							((BgL_variablez00_bglt)
																								((BgL_globalz00_bglt)
																									(((BgL_funz00_bglt) COBJECT(
																												((BgL_funz00_bglt)
																													((BgL_sfunz00_bglt)
																														BgL_sfunz00_2952))))->
																										BgL_thezd2closurezd2)))))->
																					BgL_valuez00);
																				{	/* Cfa/closure.scm 283 */
																					obj_t BgL_vz00_3909;

																					BgL_vz00_3909 =
																						CNST_TABLE_REF(((long) 7));
																					((((BgL_scnstz00_bglt) COBJECT(
																									((BgL_scnstz00_bglt)
																										BgL_arg1771z00_2960)))->
																							BgL_classz00) =
																						((obj_t) BgL_vz00_3909), BUNSPEC);
																			}}
																		else
																			{	/* Cfa/closure.scm 280 */
																				BFALSE;
																			}
																	}
																	{	/* Cfa/closure.scm 285 */
																		BgL_varz00_bglt BgL_arg1777z00_2967;

																		BgL_arg1777z00_2967 =
																			(((BgL_appz00_bglt) COBJECT(
																					((BgL_appz00_bglt)
																						((BgL_appz00_bglt)
																							BgL_appz00_2947))))->BgL_funz00);
																		{	/* Cfa/closure.scm 285 */
																			BgL_variablez00_bglt BgL_vz00_3911;

																			BgL_vz00_3911 =
																				((BgL_variablez00_bglt)
																				BGl_za2makezd2lzd2procedureza2z00zzcfa_closurez00);
																			((((BgL_varz00_bglt)
																						COBJECT(BgL_arg1777z00_2967))->
																					BgL_variablez00) =
																				((BgL_variablez00_bglt) BgL_vz00_3911),
																				BUNSPEC);
																		}
																	}
																	{	/* Cfa/closure.scm 287 */
																		BgL_varz00_bglt BgL_arg1778z00_2968;

																		BgL_arg1778z00_2968 =
																			(((BgL_appz00_bglt) COBJECT(
																					((BgL_appz00_bglt)
																						((BgL_appz00_bglt)
																							BgL_appz00_2947))))->BgL_funz00);
																		{	/* Cfa/closure.scm 287 */
																			BgL_typez00_bglt BgL_vz00_3913;

																			BgL_vz00_3913 =
																				((BgL_typez00_bglt)
																				BGl_za2procedureza2z00zztype_cachez00);
																			((((BgL_nodez00_bglt)
																						COBJECT(((BgL_nodez00_bglt)
																								BgL_arg1778z00_2968)))->
																					BgL_typez00) =
																				((BgL_typez00_bglt) BgL_vz00_3913),
																				BUNSPEC);
																		}
																	}
																	((((BgL_nodez00_bglt) COBJECT(
																					((BgL_nodez00_bglt)
																						((BgL_appz00_bglt)
																							BgL_appz00_2947))))->
																			BgL_typez00) =
																		((BgL_typez00_bglt) ((BgL_typez00_bglt)
																				BGl_za2procedureza2z00zztype_cachez00)),
																		BUNSPEC);
																	{	/* Cfa/closure.scm 289 */
																		obj_t BgL_arg1779z00_2969;
																		obj_t BgL_arg1781z00_2970;

																		BgL_arg1779z00_2969 =
																			(((BgL_appz00_bglt) COBJECT(
																					((BgL_appz00_bglt)
																						((BgL_appz00_bglt)
																							BgL_appz00_2947))))->BgL_argsz00);
																		{	/* Cfa/closure.scm 289 */
																			obj_t BgL_pairz00_3914;

																			BgL_pairz00_3914 =
																				(((BgL_appz00_bglt) COBJECT(
																						((BgL_appz00_bglt)
																							((BgL_appz00_bglt)
																								BgL_appz00_2947))))->
																				BgL_argsz00);
																			BgL_arg1781z00_2970 =
																				CDR(CDR(BgL_pairz00_3914));
																		}
																		{	/* Cfa/closure.scm 289 */
																			obj_t BgL_tmpz00_4644;

																			BgL_tmpz00_4644 =
																				((obj_t) BgL_arg1779z00_2969);
																			SET_CDR(BgL_tmpz00_4644,
																				BgL_arg1781z00_2970);
																		}
																	}
																	BgL_appz00_2947;
																}
															}
														}
													}
												}
											else
												{	/* Cfa/closure.scm 297 */
													BFALSE;
												}
										}
								}
							}
							{
								obj_t BgL_l1520z00_4647;

								BgL_l1520z00_4647 = CDR(BgL_l1520z00_2908);
								BgL_l1520z00_2908 = BgL_l1520z00_4647;
								goto BgL_zc3z04anonymousza31703ze3z87_2909;
							}
						}
					else
						{	/* Cfa/closure.scm 293 */
							return ((bool_t) 1);
						}
				}
			}
		}

	}



/* light-funcall! */
	bool_t BGl_lightzd2funcallz12zc0zzcfa_closurez00()
	{
		{	/* Cfa/closure.scm 303 */
			{
				obj_t BgL_l1527z00_2979;

				BgL_l1527z00_2979 = BGl_za2funcallzd2listza2zd2zzcfa_closurez00;
			BgL_zc3z04anonymousza31788ze3z87_2980:
				if (PAIRP(BgL_l1527z00_2979))
					{	/* Cfa/closure.scm 307 */
						{	/* Cfa/closure.scm 308 */
							BgL_funcallz00_bglt BgL_appz00_2982;

							BgL_appz00_2982 = ((BgL_funcallz00_bglt) CAR(BgL_l1527z00_2979));
							{	/* Cfa/closure.scm 309 */
								BgL_nodez00_bglt BgL_funz00_2983;

								BgL_funz00_2983 =
									(((BgL_funcallz00_bglt) COBJECT(BgL_appz00_2982))->
									BgL_funz00);
								{	/* Cfa/closure.scm 309 */
									BgL_approxz00_bglt BgL_approxz00_2984;

									BgL_approxz00_2984 =
										BGl_cfaz12z12zzcfa_cfaz00(BgL_funz00_2983);
									{	/* Cfa/closure.scm 310 */
										obj_t BgL_alloczd2listzd2_2985;

										BgL_alloczd2listzd2_2985 =
											BGl_setzd2ze3listz31zzcfa_setz00(
											(((BgL_approxz00_bglt) COBJECT(BgL_approxz00_2984))->
												BgL_allocsz00));
										{	/* Cfa/closure.scm 311 */

											{	/* Cfa/closure.scm 312 */
												bool_t BgL_test2283z00_4657;

												if (PAIRP(BgL_alloczd2listzd2_2985))
													{	/* Cfa/closure.scm 313 */
														bool_t BgL_test2285z00_4660;

														{	/* Cfa/closure.scm 313 */
															obj_t BgL_arg1822z00_3030;

															BgL_arg1822z00_3030 =
																CAR(BgL_alloczd2listzd2_2985);
															BgL_test2285z00_4660 =
																BGl_isazf3zf3zz__objectz00(BgL_arg1822z00_3030,
																BGl_makezd2procedurezd2appz00zzcfa_info2z00);
														}
														if (BgL_test2285z00_4660)
															{	/* Cfa/closure.scm 313 */
																BgL_test2283z00_4657 = ((bool_t) 0);
															}
														else
															{	/* Cfa/closure.scm 313 */
																BgL_test2283z00_4657 = ((bool_t) 1);
															}
													}
												else
													{	/* Cfa/closure.scm 312 */
														BgL_test2283z00_4657 = ((bool_t) 1);
													}
												if (BgL_test2283z00_4657)
													{	/* Cfa/closure.scm 312 */
														CNST_TABLE_REF(((long) 8));
													}
												else
													{	/* Cfa/closure.scm 317 */
														BgL_appz00_bglt BgL_allocz00_2991;

														BgL_allocz00_2991 =
															((BgL_appz00_bglt)
															CAR(((obj_t) BgL_alloczd2listzd2_2985)));
														{	/* Cfa/closure.scm 320 */
															bool_t BgL_test2286z00_4667;

															{
																BgL_makezd2procedurezd2appz00_bglt
																	BgL_auxz00_4668;
																{
																	obj_t BgL_auxz00_4669;

																	{	/* Cfa/closure.scm 320 */
																		BgL_objectz00_bglt BgL_tmpz00_4670;

																		BgL_tmpz00_4670 =
																			((BgL_objectz00_bglt)
																			((BgL_appz00_bglt) BgL_allocz00_2991));
																		BgL_auxz00_4669 =
																			BGL_OBJECT_WIDENING(BgL_tmpz00_4670);
																	}
																	BgL_auxz00_4668 =
																		((BgL_makezd2procedurezd2appz00_bglt)
																		BgL_auxz00_4669);
																}
																BgL_test2286z00_4667 =
																	(((BgL_makezd2procedurezd2appz00_bglt)
																		COBJECT(BgL_auxz00_4668))->BgL_xz00);
															}
															if (BgL_test2286z00_4667)
																{	/* Cfa/closure.scm 320 */
																	{	/* Cfa/closure.scm 325 */
																		BgL_varz00_bglt BgL_arg1797z00_2994;

																		{	/* Cfa/closure.scm 325 */
																			BgL_nodez00_bglt
																				BgL_duplicated1172z00_2995;
																			BgL_varz00_bglt BgL_new1170z00_2996;

																			{	/* Cfa/closure.scm 325 */
																				obj_t BgL_pairz00_3933;

																				BgL_pairz00_3933 =
																					(((BgL_appz00_bglt) COBJECT(
																							((BgL_appz00_bglt)
																								((BgL_appz00_bglt)
																									BgL_allocz00_2991))))->
																					BgL_argsz00);
																				BgL_duplicated1172z00_2995 =
																					((BgL_nodez00_bglt)
																					CAR(BgL_pairz00_3933));
																			}
																			{	/* Cfa/closure.scm 326 */
																				BgL_varz00_bglt BgL_new1174z00_3006;

																				BgL_new1174z00_3006 =
																					((BgL_varz00_bglt)
																					BOBJECT(GC_MALLOC(sizeof(struct
																								BgL_varz00_bgl))));
																				{	/* Cfa/closure.scm 326 */
																					long BgL_arg1807z00_3007;

																					{	/* Cfa/closure.scm 326 */
																						long BgL_res2181z00_3935;

																						BgL_res2181z00_3935 =
																							BGL_CLASS_INDEX
																							(BGl_varz00zzast_nodez00);
																						BgL_arg1807z00_3007 =
																							BgL_res2181z00_3935;
																					}
																					BGL_OBJECT_CLASS_NUM_SET(
																						((BgL_objectz00_bglt)
																							BgL_new1174z00_3006),
																						BgL_arg1807z00_3007);
																				}
																				BgL_new1170z00_2996 =
																					BgL_new1174z00_3006;
																			}
																			((((BgL_nodez00_bglt) COBJECT(
																							((BgL_nodez00_bglt)
																								BgL_new1170z00_2996)))->
																					BgL_locz00) =
																				((obj_t) (((BgL_nodez00_bglt)
																							COBJECT
																							(BgL_duplicated1172z00_2995))->
																						BgL_locz00)), BUNSPEC);
																			{
																				BgL_typez00_bglt BgL_auxz00_4688;

																				{	/* Cfa/closure.scm 327 */
																					obj_t BgL_arg1798z00_2997;
																					BgL_typez00_bglt BgL_arg1799z00_2998;

																					{	/* Cfa/closure.scm 327 */
																						BgL_approxz00_bglt
																							BgL_arg1800z00_2999;
																						obj_t BgL_arg1801z00_3000;

																						{
																							BgL_makezd2procedurezd2appz00_bglt
																								BgL_auxz00_4690;
																							{
																								obj_t BgL_auxz00_4691;

																								{	/* Cfa/closure.scm 327 */
																									BgL_objectz00_bglt
																										BgL_tmpz00_4692;
																									BgL_tmpz00_4692 =
																										((BgL_objectz00_bglt) (
																											(BgL_appz00_bglt)
																											BgL_allocz00_2991));
																									BgL_auxz00_4691 =
																										BGL_OBJECT_WIDENING
																										(BgL_tmpz00_4692);
																								}
																								BgL_auxz00_4690 =
																									(
																									(BgL_makezd2procedurezd2appz00_bglt)
																									BgL_auxz00_4691);
																							}
																							BgL_arg1800z00_2999 =
																								(((BgL_makezd2procedurezd2appz00_bglt) COBJECT(BgL_auxz00_4690))->BgL_approxz00);
																						}
																						{	/* Cfa/closure.scm 327 */
																							obj_t BgL_pairz00_3939;

																							BgL_pairz00_3939 =
																								(((BgL_appz00_bglt) COBJECT(
																										((BgL_appz00_bglt)
																											((BgL_appz00_bglt)
																												BgL_allocz00_2991))))->
																								BgL_argsz00);
																							BgL_arg1801z00_3000 =
																								CAR(BgL_pairz00_3939);
																						}
																						BgL_arg1798z00_2997 =
																							BGl_getzd2approxzd2typez00zzcfa_typez00
																							(BgL_arg1800z00_2999,
																							BgL_arg1801z00_3000);
																					}
																					{
																						BgL_nodez00_bglt BgL_auxz00_4703;

																						{
																							BgL_varz00_bglt BgL_auxz00_4704;

																							{	/* Cfa/closure.scm 328 */
																								obj_t BgL_pairz00_3940;

																								BgL_pairz00_3940 =
																									(((BgL_appz00_bglt) COBJECT(
																											((BgL_appz00_bglt)
																												((BgL_appz00_bglt)
																													BgL_allocz00_2991))))->
																									BgL_argsz00);
																								BgL_auxz00_4704 =
																									((BgL_varz00_bglt)
																									CAR(BgL_pairz00_3940));
																							}
																							BgL_auxz00_4703 =
																								((BgL_nodez00_bglt)
																								BgL_auxz00_4704);
																						}
																						BgL_arg1799z00_2998 =
																							(((BgL_nodez00_bglt)
																								COBJECT(BgL_auxz00_4703))->
																							BgL_typez00);
																					}
																					BgL_auxz00_4688 =
																						BGl_strictzd2nodezd2typez00zzast_nodez00
																						(((BgL_typez00_bglt)
																							BgL_arg1798z00_2997),
																						BgL_arg1799z00_2998);
																				}
																				((((BgL_nodez00_bglt) COBJECT(
																								((BgL_nodez00_bglt)
																									BgL_new1170z00_2996)))->
																						BgL_typez00) =
																					((BgL_typez00_bglt) BgL_auxz00_4688),
																					BUNSPEC);
																			}
																			((((BgL_varz00_bglt)
																						COBJECT(BgL_new1170z00_2996))->
																					BgL_variablez00) =
																				((BgL_variablez00_bglt) ((
																							(BgL_varz00_bglt)
																							COBJECT(((BgL_varz00_bglt)
																									BgL_duplicated1172z00_2995)))->
																						BgL_variablez00)), BUNSPEC);
																			BgL_arg1797z00_2994 = BgL_new1170z00_2996;
																		}
																		((((BgL_funcallz00_bglt)
																					COBJECT(BgL_appz00_2982))->
																				BgL_funz00) =
																			((BgL_nodez00_bglt) ((BgL_nodez00_bglt)
																					BgL_arg1797z00_2994)), BUNSPEC);
																	}
																	{	/* Cfa/closure.scm 329 */
																		obj_t BgL_arg1809z00_3008;

																		{	/* Cfa/closure.scm 329 */
																			obj_t BgL_arg1811z00_3009;

																			{	/* Cfa/closure.scm 329 */
																				obj_t BgL_pairz00_3944;

																				BgL_pairz00_3944 =
																					(((BgL_appz00_bglt) COBJECT(
																							((BgL_appz00_bglt)
																								((BgL_appz00_bglt)
																									BgL_allocz00_2991))))->
																					BgL_argsz00);
																				BgL_arg1811z00_3009 =
																					CAR(BgL_pairz00_3944);
																			}
																			{	/* Cfa/closure.scm 329 */
																				obj_t BgL_list1812z00_3010;

																				BgL_list1812z00_3010 =
																					MAKE_YOUNG_PAIR(BgL_arg1811z00_3009,
																					BNIL);
																				BgL_arg1809z00_3008 =
																					BgL_list1812z00_3010;
																		}}
																		((((BgL_funcallz00_bglt)
																					COBJECT(BgL_appz00_2982))->
																				BgL_functionsz00) =
																			((obj_t) BgL_arg1809z00_3008), BUNSPEC);
																	}
																	{	/* Cfa/closure.scm 330 */
																		obj_t BgL_vz00_3948;

																		BgL_vz00_3948 = CNST_TABLE_REF(((long) 1));
																		((((BgL_funcallz00_bglt)
																					COBJECT(BgL_appz00_2982))->
																				BgL_strengthz00) =
																			((obj_t) BgL_vz00_3948), BUNSPEC);
																}}
															else
																{	/* Cfa/closure.scm 331 */
																	bool_t BgL_test2287z00_4728;

																	{
																		BgL_makezd2procedurezd2appz00_bglt
																			BgL_auxz00_4729;
																		{
																			obj_t BgL_auxz00_4730;

																			{	/* Cfa/closure.scm 331 */
																				BgL_objectz00_bglt BgL_tmpz00_4731;

																				BgL_tmpz00_4731 =
																					((BgL_objectz00_bglt)
																					((BgL_appz00_bglt)
																						BgL_allocz00_2991));
																				BgL_auxz00_4730 =
																					BGL_OBJECT_WIDENING(BgL_tmpz00_4731);
																			}
																			BgL_auxz00_4729 =
																				((BgL_makezd2procedurezd2appz00_bglt)
																				BgL_auxz00_4730);
																		}
																		BgL_test2287z00_4728 =
																			(((BgL_makezd2procedurezd2appz00_bglt)
																				COBJECT(BgL_auxz00_4729))->BgL_tz00);
																	}
																	if (BgL_test2287z00_4728)
																		{	/* Cfa/closure.scm 331 */
																			{	/* Cfa/closure.scm 334 */
																				obj_t BgL_fz00_3013;

																				if (NULLP(BgL_alloczd2listzd2_2985))
																					{	/* Cfa/closure.scm 334 */
																						BgL_fz00_3013 = BNIL;
																					}
																				else
																					{	/* Cfa/closure.scm 334 */
																						obj_t BgL_head1524z00_3016;

																						{	/* Cfa/closure.scm 334 */
																							obj_t BgL_res2184z00_3951;

																							BgL_res2184z00_3951 =
																								MAKE_YOUNG_PAIR(BNIL, BNIL);
																							BgL_head1524z00_3016 =
																								BgL_res2184z00_3951;
																						}
																						{
																							obj_t BgL_l1522z00_3018;
																							obj_t BgL_tail1525z00_3019;

																							BgL_l1522z00_3018 =
																								BgL_alloczd2listzd2_2985;
																							BgL_tail1525z00_3019 =
																								BgL_head1524z00_3016;
																						BgL_zc3z04anonymousza31816ze3z87_3020:
																							if (NULLP
																								(BgL_l1522z00_3018))
																								{	/* Cfa/closure.scm 334 */
																									BgL_fz00_3013 =
																										CDR(BgL_head1524z00_3016);
																								}
																							else
																								{	/* Cfa/closure.scm 334 */
																									obj_t BgL_newtail1526z00_3022;

																									{	/* Cfa/closure.scm 334 */
																										obj_t BgL_arg1819z00_3024;

																										{	/* Cfa/closure.scm 335 */
																											obj_t BgL_pairz00_3956;

																											BgL_pairz00_3956 =
																												(((BgL_appz00_bglt)
																													COBJECT((
																															(BgL_appz00_bglt)
																															((BgL_appz00_bglt)
																																CAR(((obj_t)
																																		BgL_l1522z00_3018))))))->
																												BgL_argsz00);
																											BgL_arg1819z00_3024 =
																												CAR(BgL_pairz00_3956);
																										}
																										{	/* Cfa/closure.scm 334 */
																											obj_t BgL_res2186z00_3957;

																											BgL_res2186z00_3957 =
																												MAKE_YOUNG_PAIR
																												(BgL_arg1819z00_3024,
																												BNIL);
																											BgL_newtail1526z00_3022 =
																												BgL_res2186z00_3957;
																										}
																									}
																									SET_CDR(BgL_tail1525z00_3019,
																										BgL_newtail1526z00_3022);
																									{	/* Cfa/closure.scm 334 */
																										obj_t BgL_arg1818z00_3023;

																										BgL_arg1818z00_3023 =
																											CDR(
																											((obj_t)
																												BgL_l1522z00_3018));
																										{
																											obj_t
																												BgL_tail1525z00_4754;
																											obj_t BgL_l1522z00_4753;

																											BgL_l1522z00_4753 =
																												BgL_arg1818z00_3023;
																											BgL_tail1525z00_4754 =
																												BgL_newtail1526z00_3022;
																											BgL_tail1525z00_3019 =
																												BgL_tail1525z00_4754;
																											BgL_l1522z00_3018 =
																												BgL_l1522z00_4753;
																											goto
																												BgL_zc3z04anonymousza31816ze3z87_3020;
																										}
																									}
																								}
																						}
																					}
																				((((BgL_funcallz00_bglt)
																							COBJECT(BgL_appz00_2982))->
																						BgL_functionsz00) =
																					((obj_t) BgL_fz00_3013), BUNSPEC);
																				{	/* Cfa/closure.scm 338 */
																					obj_t BgL_vz00_3962;

																					BgL_vz00_3962 =
																						CNST_TABLE_REF(((long) 2));
																					((((BgL_funcallz00_bglt)
																								COBJECT(BgL_appz00_2982))->
																							BgL_strengthz00) =
																						((obj_t) BgL_vz00_3962), BUNSPEC);
																		}}}
																	else
																		{	/* Cfa/closure.scm 331 */
																			CNST_TABLE_REF(((long) 8));
						}}}}}}}}}}
						{
							obj_t BgL_l1527z00_4759;

							BgL_l1527z00_4759 = CDR(BgL_l1527z00_2979);
							BgL_l1527z00_2979 = BgL_l1527z00_4759;
							goto BgL_zc3z04anonymousza31788ze3z87_2980;
						}
					}
				else
					{	/* Cfa/closure.scm 307 */
						((bool_t) 1);
					}
			}
			if (CBOOL
				(BGl_za2optimzd2cfazd2unboxzd2closurezd2argsza2z00zzengine_paramz00))
				{	/* Cfa/closure.scm 343 */
					{	/* Cfa/closure.scm 349 */
						obj_t BgL_funcallzd2lzd2_3034;

						{	/* Cfa/closure.scm 349 */
							obj_t BgL_hook1533z00_3058;

							BgL_hook1533z00_3058 = MAKE_YOUNG_PAIR(BFALSE, BNIL);
							{
								obj_t BgL_l1530z00_3060;
								obj_t BgL_h1531z00_3061;

								BgL_l1530z00_3060 = BGl_za2funcallzd2listza2zd2zzcfa_closurez00;
								BgL_h1531z00_3061 = BgL_hook1533z00_3058;
							BgL_zc3z04anonymousza31836ze3z87_3062:
								if (NULLP(BgL_l1530z00_3060))
									{	/* Cfa/closure.scm 349 */
										BgL_funcallzd2lzd2_3034 = CDR(BgL_hook1533z00_3058);
									}
								else
									{	/* Cfa/closure.scm 349 */
										if (
											((((BgL_funcallz00_bglt) COBJECT(
															((BgL_funcallz00_bglt)
																CAR(
																	((obj_t) BgL_l1530z00_3060)))))->
													BgL_strengthz00) == CNST_TABLE_REF(((long) 2))))
											{	/* Cfa/closure.scm 349 */
												obj_t BgL_nh1532z00_3067;

												{	/* Cfa/closure.scm 349 */
													obj_t BgL_arg1842z00_3069;

													BgL_arg1842z00_3069 =
														CAR(((obj_t) BgL_l1530z00_3060));
													{	/* Cfa/closure.scm 349 */
														obj_t BgL_res2188z00_3969;

														BgL_res2188z00_3969 =
															MAKE_YOUNG_PAIR(BgL_arg1842z00_3069, BNIL);
														BgL_nh1532z00_3067 = BgL_res2188z00_3969;
												}}
												SET_CDR(BgL_h1531z00_3061, BgL_nh1532z00_3067);
												{	/* Cfa/closure.scm 349 */
													obj_t BgL_arg1840z00_3068;

													BgL_arg1840z00_3068 =
														CDR(((obj_t) BgL_l1530z00_3060));
													{
														obj_t BgL_h1531z00_4781;
														obj_t BgL_l1530z00_4780;

														BgL_l1530z00_4780 = BgL_arg1840z00_3068;
														BgL_h1531z00_4781 = BgL_nh1532z00_3067;
														BgL_h1531z00_3061 = BgL_h1531z00_4781;
														BgL_l1530z00_3060 = BgL_l1530z00_4780;
														goto BgL_zc3z04anonymousza31836ze3z87_3062;
													}
												}
											}
										else
											{	/* Cfa/closure.scm 349 */
												obj_t BgL_arg1846z00_3070;

												BgL_arg1846z00_3070 = CDR(((obj_t) BgL_l1530z00_3060));
												{
													obj_t BgL_l1530z00_4784;

													BgL_l1530z00_4784 = BgL_arg1846z00_3070;
													BgL_l1530z00_3060 = BgL_l1530z00_4784;
													goto BgL_zc3z04anonymousza31836ze3z87_3062;
												}
											}
									}
							}
						}
						{

						BgL_zc3z04anonymousza31825ze3z87_3036:
							{	/* Cfa/closure.scm 353 */
								bool_t BgL_contz00_3037;

								BgL_contz00_3037 = ((bool_t) 0);
								{
									obj_t BgL_l1534z00_3039;

									BgL_l1534z00_3039 = BgL_funcallzd2lzd2_3034;
								BgL_zc3z04anonymousza31826ze3z87_3040:
									if (PAIRP(BgL_l1534z00_3039))
										{	/* Cfa/closure.scm 354 */
											{	/* Cfa/closure.scm 355 */
												BgL_funcallz00_bglt BgL_appz00_3042;

												BgL_appz00_3042 =
													((BgL_funcallz00_bglt) CAR(BgL_l1534z00_3039));
												{	/* Cfa/closure.scm 355 */
													BgL_nodez00_bglt BgL_funz00_3043;

													BgL_funz00_3043 =
														(((BgL_funcallz00_bglt) COBJECT(BgL_appz00_3042))->
														BgL_funz00);
													{	/* Cfa/closure.scm 355 */
														BgL_approxz00_bglt BgL_approxz00_3044;

														BgL_approxz00_3044 =
															BGl_cfaz12z12zzcfa_cfaz00(BgL_funz00_3043);
														{	/* Cfa/closure.scm 356 */
															obj_t BgL_appsz00_3045;

															BgL_appsz00_3045 =
																BGl_setzd2ze3listz31zzcfa_setz00(
																(((BgL_approxz00_bglt)
																		COBJECT(BgL_approxz00_3044))->
																	BgL_allocsz00));
															{	/* Cfa/closure.scm 357 */

																if (PAIRP(BgL_appsz00_3045))
																	{	/* Cfa/closure.scm 358 */
																		{	/* Cfa/closure.scm 359 */
																			bool_t BgL_test2295z00_4795;

																			{	/* Cfa/closure.scm 359 */
																				obj_t BgL_tmpz00_4796;

																				BgL_tmpz00_4796 = CDR(BgL_appsz00_3045);
																				BgL_test2295z00_4795 =
																					PAIRP(BgL_tmpz00_4796);
																			}
																			if (BgL_test2295z00_4795)
																				{	/* Cfa/closure.scm 361 */
																					bool_t BgL__ortest_1175z00_3049;

																					BgL__ortest_1175z00_3049 =
																						BGl_mergezd2appzd2typesz12z12zzcfa_closurez00
																						(BgL_appsz00_3045);
																					if (BgL__ortest_1175z00_3049)
																						{	/* Cfa/closure.scm 361 */
																							BgL_contz00_3037 =
																								BgL__ortest_1175z00_3049;
																						}
																					else
																						{	/* Cfa/closure.scm 361 */
																							BgL_contz00_3037 =
																								BgL_contz00_3037;
																						}
																				}
																			else
																				{	/* Cfa/closure.scm 359 */
																					BFALSE;
																				}
																		}
																		{	/* Cfa/closure.scm 362 */
																			bool_t BgL_mz00_3051;

																			{	/* Cfa/closure.scm 363 */
																				BgL_approxz00_bglt BgL_arg1833z00_3053;

																				BgL_arg1833z00_3053 =
																					BGl_cfaz12z12zzcfa_cfaz00(
																					((BgL_nodez00_bglt) BgL_appz00_3042));
																				BgL_mz00_3051 =
																					BGl_mergezd2appzd2returnzd2typesz12zc0zzcfa_closurez00
																					(BgL_appsz00_3045,
																					BgL_arg1833z00_3053);
																			}
																			{	/* Cfa/closure.scm 364 */
																				bool_t BgL__ortest_1176z00_3052;

																				BgL__ortest_1176z00_3052 =
																					BgL_contz00_3037;
																				if (BgL__ortest_1176z00_3052)
																					{	/* Cfa/closure.scm 364 */
																						BgL_contz00_3037 =
																							BgL__ortest_1176z00_3052;
																					}
																				else
																					{	/* Cfa/closure.scm 364 */
																						BgL_contz00_3037 = BgL_mz00_3051;
																					}
																			}
																		}
																	}
																else
																	{	/* Cfa/closure.scm 358 */
																		BFALSE;
																	}
															}
														}
													}
												}
											}
											{
												obj_t BgL_l1534z00_4805;

												BgL_l1534z00_4805 = CDR(BgL_l1534z00_3039);
												BgL_l1534z00_3039 = BgL_l1534z00_4805;
												goto BgL_zc3z04anonymousza31826ze3z87_3040;
											}
										}
									else
										{	/* Cfa/closure.scm 354 */
											((bool_t) 1);
										}
								}
								if (BgL_contz00_3037)
									{	/* Cfa/closure.scm 366 */
										goto BgL_zc3z04anonymousza31825ze3z87_3036;
									}
								else
									{	/* Cfa/closure.scm 366 */
										return ((bool_t) 0);
									}
							}
						}
					}
				}
			else
				{	/* Cfa/closure.scm 343 */
					return ((bool_t) 0);
				}
		}

	}



/* merge-app-return-types! */
	bool_t BGl_mergezd2appzd2returnzd2typesz12zc0zzcfa_closurez00(obj_t
		BgL_appsz00_8, BgL_approxz00_bglt BgL_approxz00_9)
	{
		{	/* Cfa/closure.scm 372 */
			{	/* Cfa/closure.scm 373 */
				obj_t BgL_app0z00_3074;

				BgL_app0z00_3074 = CAR(BgL_appsz00_8);
				{	/* Cfa/closure.scm 373 */
					BgL_variablez00_bglt BgL_f0z00_3075;

					{
						BgL_varz00_bglt BgL_auxz00_4809;

						{	/* Cfa/closure.scm 374 */
							obj_t BgL_pairz00_3983;

							BgL_pairz00_3983 =
								(((BgL_appz00_bglt) COBJECT(
										((BgL_appz00_bglt)
											((BgL_appz00_bglt) BgL_app0z00_3074))))->BgL_argsz00);
							BgL_auxz00_4809 = ((BgL_varz00_bglt) CAR(BgL_pairz00_3983));
						}
						BgL_f0z00_3075 =
							(((BgL_varz00_bglt) COBJECT(BgL_auxz00_4809))->BgL_variablez00);
					}
					{	/* Cfa/closure.scm 374 */
						BgL_approxz00_bglt BgL_r0z00_3076;

						{	/* Cfa/closure.scm 375 */
							BgL_sfunz00_bglt BgL_oz00_3986;

							BgL_oz00_3986 =
								((BgL_sfunz00_bglt)
								(((BgL_variablez00_bglt) COBJECT(BgL_f0z00_3075))->
									BgL_valuez00));
							{
								BgL_internzd2sfunzf2cinfoz20_bglt BgL_auxz00_4818;

								{
									obj_t BgL_auxz00_4819;

									{	/* Cfa/closure.scm 375 */
										BgL_objectz00_bglt BgL_tmpz00_4820;

										BgL_tmpz00_4820 = ((BgL_objectz00_bglt) BgL_oz00_3986);
										BgL_auxz00_4819 = BGL_OBJECT_WIDENING(BgL_tmpz00_4820);
									}
									BgL_auxz00_4818 =
										((BgL_internzd2sfunzf2cinfoz20_bglt) BgL_auxz00_4819);
								}
								BgL_r0z00_3076 =
									(((BgL_internzd2sfunzf2cinfoz20_bglt)
										COBJECT(BgL_auxz00_4818))->BgL_approxz00);
							}
						}
						{	/* Cfa/closure.scm 375 */
							BgL_typez00_bglt BgL_rt0z00_3077;

							BgL_rt0z00_3077 =
								(((BgL_approxz00_bglt) COBJECT(BgL_r0z00_3076))->BgL_typez00);
							{	/* Cfa/closure.scm 376 */
								BgL_typez00_bglt BgL_brt0z00_3078;

								BgL_brt0z00_3078 =
									BGl_getzd2bigloozd2typez00zztype_cachez00(BgL_rt0z00_3077);
								{	/* Cfa/closure.scm 377 */
									BgL_typez00_bglt BgL_atz00_3079;

									BgL_atz00_3079 =
										(((BgL_approxz00_bglt) COBJECT(BgL_approxz00_9))->
										BgL_typez00);
									{	/* Cfa/closure.scm 378 */

										{	/* Cfa/closure.scm 379 */
											bool_t BgL_test2299z00_4828;

											if (
												(((obj_t) BgL_rt0z00_3077) == ((obj_t) BgL_atz00_3079)))
												{	/* Cfa/closure.scm 379 */
													BgL_test2299z00_4828 = ((bool_t) 1);
												}
											else
												{	/* Cfa/closure.scm 379 */
													if (BGl_bigloozd2typezf3z21zztype_typez00
														(BgL_rt0z00_3077))
														{	/* Cfa/closure.scm 379 */
															BgL_test2299z00_4828 =
																BGl_bigloozd2typezf3z21zztype_typez00
																(BgL_atz00_3079);
														}
													else
														{	/* Cfa/closure.scm 379 */
															BgL_test2299z00_4828 = ((bool_t) 0);
														}
												}
											if (BgL_test2299z00_4828)
												{	/* Cfa/closure.scm 379 */
													return ((bool_t) 0);
												}
											else
												{	/* Cfa/closure.scm 379 */
													((((BgL_approxz00_bglt) COBJECT(BgL_approxz00_9))->
															BgL_typez00) =
														((BgL_typez00_bglt) (((BgL_approxz00_bglt)
																	COBJECT(BgL_r0z00_3076))->BgL_typez00)),
														BUNSPEC);
													return ((bool_t) 1);
												}
										}
									}
								}
							}
						}
					}
				}
			}
		}

	}



/* merge-app-types! */
	bool_t BGl_mergezd2appzd2typesz12z12zzcfa_closurez00(obj_t BgL_apps0z00_10)
	{
		{	/* Cfa/closure.scm 386 */
			{
				BgL_appz00_bglt BgL_app0z00_3102;
				BgL_appz00_bglt BgL_app1z00_3103;

				{	/* Cfa/closure.scm 455 */
					obj_t BgL_g1182z00_3090;

					BgL_g1182z00_3090 = CDR(((obj_t) BgL_apps0z00_10));
					{
						obj_t BgL_appsz00_3092;
						bool_t BgL_contz00_3093;

						BgL_appsz00_3092 = BgL_g1182z00_3090;
						BgL_contz00_3093 = ((bool_t) 0);
					BgL_zc3z04anonymousza31854ze3z87_3094:
						if (NULLP(BgL_appsz00_3092))
							{	/* Cfa/closure.scm 457 */
								return BgL_contz00_3093;
							}
						else
							{	/* Cfa/closure.scm 459 */
								obj_t BgL_arg1856z00_3096;
								bool_t BgL_arg1857z00_3097;

								BgL_arg1856z00_3096 = CDR(((obj_t) BgL_appsz00_3092));
								{	/* Cfa/closure.scm 459 */
									bool_t BgL__ortest_1183z00_3098;

									{	/* Cfa/closure.scm 459 */
										obj_t BgL_arg1858z00_3099;
										obj_t BgL_arg1859z00_3100;

										BgL_arg1858z00_3099 = CAR(((obj_t) BgL_apps0z00_10));
										BgL_arg1859z00_3100 = CAR(((obj_t) BgL_appsz00_3092));
										BgL_app0z00_3102 = ((BgL_appz00_bglt) BgL_arg1858z00_3099);
										BgL_app1z00_3103 = ((BgL_appz00_bglt) BgL_arg1859z00_3100);
										{	/* Cfa/closure.scm 389 */
											BgL_variablez00_bglt BgL_f0z00_3105;

											{
												BgL_varz00_bglt BgL_auxz00_4848;

												{	/* Cfa/closure.scm 389 */
													obj_t BgL_pairz00_3994;

													BgL_pairz00_3994 =
														(((BgL_appz00_bglt) COBJECT(
																((BgL_appz00_bglt) BgL_app0z00_3102)))->
														BgL_argsz00);
													BgL_auxz00_4848 =
														((BgL_varz00_bglt) CAR(BgL_pairz00_3994));
												}
												BgL_f0z00_3105 =
													(((BgL_varz00_bglt) COBJECT(BgL_auxz00_4848))->
													BgL_variablez00);
											}
											{	/* Cfa/closure.scm 389 */
												BgL_variablez00_bglt BgL_f1z00_3106;

												{
													BgL_varz00_bglt BgL_auxz00_4854;

													{	/* Cfa/closure.scm 390 */
														obj_t BgL_pairz00_3997;

														BgL_pairz00_3997 =
															(((BgL_appz00_bglt) COBJECT(
																	((BgL_appz00_bglt) BgL_app1z00_3103)))->
															BgL_argsz00);
														BgL_auxz00_4854 =
															((BgL_varz00_bglt) CAR(BgL_pairz00_3997));
													}
													BgL_f1z00_3106 =
														(((BgL_varz00_bglt) COBJECT(BgL_auxz00_4854))->
														BgL_variablez00);
												}
												{	/* Cfa/closure.scm 390 */

													{	/* Cfa/closure.scm 392 */
														BgL_approxz00_bglt BgL_r0z00_3107;

														{	/* Cfa/closure.scm 392 */
															BgL_sfunz00_bglt BgL_oz00_4000;

															BgL_oz00_4000 =
																((BgL_sfunz00_bglt)
																(((BgL_variablez00_bglt)
																		COBJECT(BgL_f0z00_3105))->BgL_valuez00));
															{
																BgL_internzd2sfunzf2cinfoz20_bglt
																	BgL_auxz00_4862;
																{
																	obj_t BgL_auxz00_4863;

																	{	/* Cfa/closure.scm 392 */
																		BgL_objectz00_bglt BgL_tmpz00_4864;

																		BgL_tmpz00_4864 =
																			((BgL_objectz00_bglt) BgL_oz00_4000);
																		BgL_auxz00_4863 =
																			BGL_OBJECT_WIDENING(BgL_tmpz00_4864);
																	}
																	BgL_auxz00_4862 =
																		((BgL_internzd2sfunzf2cinfoz20_bglt)
																		BgL_auxz00_4863);
																}
																BgL_r0z00_3107 =
																	(((BgL_internzd2sfunzf2cinfoz20_bglt)
																		COBJECT(BgL_auxz00_4862))->BgL_approxz00);
															}
														}
														{	/* Cfa/closure.scm 392 */
															BgL_approxz00_bglt BgL_r1z00_3108;

															{	/* Cfa/closure.scm 393 */
																BgL_sfunz00_bglt BgL_oz00_4003;

																BgL_oz00_4003 =
																	((BgL_sfunz00_bglt)
																	(((BgL_variablez00_bglt)
																			COBJECT(BgL_f1z00_3106))->BgL_valuez00));
																{
																	BgL_internzd2sfunzf2cinfoz20_bglt
																		BgL_auxz00_4871;
																	{
																		obj_t BgL_auxz00_4872;

																		{	/* Cfa/closure.scm 393 */
																			BgL_objectz00_bglt BgL_tmpz00_4873;

																			BgL_tmpz00_4873 =
																				((BgL_objectz00_bglt) BgL_oz00_4003);
																			BgL_auxz00_4872 =
																				BGL_OBJECT_WIDENING(BgL_tmpz00_4873);
																		}
																		BgL_auxz00_4871 =
																			((BgL_internzd2sfunzf2cinfoz20_bglt)
																			BgL_auxz00_4872);
																	}
																	BgL_r1z00_3108 =
																		(((BgL_internzd2sfunzf2cinfoz20_bglt)
																			COBJECT(BgL_auxz00_4871))->BgL_approxz00);
																}
															}
															{	/* Cfa/closure.scm 393 */
																BgL_typez00_bglt BgL_rt0z00_3109;

																BgL_rt0z00_3109 =
																	(((BgL_approxz00_bglt)
																		COBJECT(BgL_r0z00_3107))->BgL_typez00);
																{	/* Cfa/closure.scm 394 */
																	BgL_typez00_bglt BgL_rt1z00_3110;

																	BgL_rt1z00_3110 =
																		(((BgL_approxz00_bglt)
																			COBJECT(BgL_r1z00_3108))->BgL_typez00);
																	{	/* Cfa/closure.scm 395 */
																		BgL_typez00_bglt BgL_brt0z00_3111;

																		BgL_brt0z00_3111 =
																			BGl_getzd2bigloozd2typez00zztype_cachez00
																			(BgL_rt0z00_3109);
																		{	/* Cfa/closure.scm 396 */
																			BgL_typez00_bglt BgL_brt1z00_3112;

																			BgL_brt1z00_3112 =
																				BGl_getzd2bigloozd2typez00zztype_cachez00
																				(BgL_rt1z00_3110);
																			{	/* Cfa/closure.scm 397 */

																				{	/* Cfa/closure.scm 398 */
																					bool_t BgL_test2303z00_4882;

																					if (
																						(((obj_t) BgL_rt0z00_3109) ==
																							((obj_t) BgL_rt1z00_3110)))
																						{	/* Cfa/closure.scm 398 */
																							BgL_test2303z00_4882 =
																								((bool_t) 1);
																						}
																					else
																						{	/* Cfa/closure.scm 398 */
																							if (BGl_bigloozd2typezf3z21zztype_typez00(BgL_rt0z00_3109))
																								{	/* Cfa/closure.scm 399 */
																									BgL_test2303z00_4882 =
																										BGl_bigloozd2typezf3z21zztype_typez00
																										(BgL_rt1z00_3110);
																								}
																							else
																								{	/* Cfa/closure.scm 399 */
																									BgL_test2303z00_4882 =
																										((bool_t) 0);
																								}
																						}
																					if (BgL_test2303z00_4882)
																						{	/* Cfa/closure.scm 398 */
																							BFALSE;
																						}
																					else
																						{	/* Cfa/closure.scm 398 */
																							if (
																								(((obj_t) BgL_rt0z00_3109) ==
																									((obj_t) BgL_brt0z00_3111)))
																								{	/* Cfa/closure.scm 400 */
																									BFALSE;
																								}
																							else
																								{	/* Cfa/closure.scm 400 */
																									((((BgL_approxz00_bglt)
																												COBJECT
																												(BgL_r0z00_3107))->
																											BgL_typez00) =
																										((BgL_typez00_bglt)
																											BgL_brt0z00_3111),
																										BUNSPEC);
																								}
																							if (
																								(((obj_t) BgL_rt1z00_3110) ==
																									((obj_t) BgL_brt1z00_3112)))
																								{	/* Cfa/closure.scm 402 */
																									BFALSE;
																								}
																							else
																								{	/* Cfa/closure.scm 402 */
																									((((BgL_approxz00_bglt)
																												COBJECT
																												(BgL_r1z00_3108))->
																											BgL_typez00) =
																										((BgL_typez00_bglt)
																											BgL_brt1z00_3112),
																										BUNSPEC);
																								}
																						}
																				}
																			}
																		}
																	}
																}
															}
														}
													}
													{	/* Cfa/closure.scm 404 */
														obj_t BgL_g1179z00_3122;
														obj_t BgL_g1180z00_3123;

														{	/* Cfa/closure.scm 404 */
															obj_t BgL_pairz00_4013;

															BgL_pairz00_4013 =
																(((BgL_sfunz00_bglt) COBJECT(
																		((BgL_sfunz00_bglt)
																			(((BgL_variablez00_bglt)
																					COBJECT(BgL_f0z00_3105))->
																				BgL_valuez00))))->BgL_argsz00);
															BgL_g1179z00_3122 = CDR(BgL_pairz00_4013);
														}
														{	/* Cfa/closure.scm 405 */
															obj_t BgL_pairz00_4016;

															BgL_pairz00_4016 =
																(((BgL_sfunz00_bglt) COBJECT(
																		((BgL_sfunz00_bglt)
																			(((BgL_variablez00_bglt)
																					COBJECT(BgL_f1z00_3106))->
																				BgL_valuez00))))->BgL_argsz00);
															BgL_g1180z00_3123 = CDR(BgL_pairz00_4016);
														}
														{
															obj_t BgL_a0z00_3125;
															obj_t BgL_a1z00_3126;
															bool_t BgL_contz00_3127;

															BgL_a0z00_3125 = BgL_g1179z00_3122;
															BgL_a1z00_3126 = BgL_g1180z00_3123;
															BgL_contz00_3127 = ((bool_t) 0);
														BgL_zc3z04anonymousza31867ze3z87_3128:
															{	/* Cfa/closure.scm 407 */
																bool_t BgL_test2308z00_4908;

																if (PAIRP(BgL_a0z00_3125))
																	{	/* Cfa/closure.scm 407 */
																		BgL_test2308z00_4908 =
																			PAIRP(BgL_a1z00_3126);
																	}
																else
																	{	/* Cfa/closure.scm 407 */
																		BgL_test2308z00_4908 = ((bool_t) 0);
																	}
																if (BgL_test2308z00_4908)
																	{	/* Cfa/closure.scm 408 */
																		BgL_approxz00_bglt BgL_p0z00_3131;

																		{	/* Cfa/closure.scm 408 */
																			BgL_svarz00_bglt BgL_oz00_4021;

																			BgL_oz00_4021 =
																				((BgL_svarz00_bglt)
																				(((BgL_variablez00_bglt) COBJECT(
																							((BgL_variablez00_bglt)
																								CAR(BgL_a0z00_3125))))->
																					BgL_valuez00));
																			{
																				BgL_svarzf2cinfozf2_bglt
																					BgL_auxz00_4916;
																				{
																					obj_t BgL_auxz00_4917;

																					{	/* Cfa/closure.scm 408 */
																						BgL_objectz00_bglt BgL_tmpz00_4918;

																						BgL_tmpz00_4918 =
																							((BgL_objectz00_bglt)
																							BgL_oz00_4021);
																						BgL_auxz00_4917 =
																							BGL_OBJECT_WIDENING
																							(BgL_tmpz00_4918);
																					}
																					BgL_auxz00_4916 =
																						((BgL_svarzf2cinfozf2_bglt)
																						BgL_auxz00_4917);
																				}
																				BgL_p0z00_3131 =
																					(((BgL_svarzf2cinfozf2_bglt)
																						COBJECT(BgL_auxz00_4916))->
																					BgL_approxz00);
																			}
																		}
																		{	/* Cfa/closure.scm 408 */
																			BgL_approxz00_bglt BgL_p1z00_3132;

																			{	/* Cfa/closure.scm 409 */
																				BgL_svarz00_bglt BgL_oz00_4025;

																				BgL_oz00_4025 =
																					((BgL_svarz00_bglt)
																					(((BgL_variablez00_bglt) COBJECT(
																								((BgL_variablez00_bglt)
																									CAR(BgL_a1z00_3126))))->
																						BgL_valuez00));
																				{
																					BgL_svarzf2cinfozf2_bglt
																						BgL_auxz00_4927;
																					{
																						obj_t BgL_auxz00_4928;

																						{	/* Cfa/closure.scm 409 */
																							BgL_objectz00_bglt
																								BgL_tmpz00_4929;
																							BgL_tmpz00_4929 =
																								((BgL_objectz00_bglt)
																								BgL_oz00_4025);
																							BgL_auxz00_4928 =
																								BGL_OBJECT_WIDENING
																								(BgL_tmpz00_4929);
																						}
																						BgL_auxz00_4927 =
																							((BgL_svarzf2cinfozf2_bglt)
																							BgL_auxz00_4928);
																					}
																					BgL_p1z00_3132 =
																						(((BgL_svarzf2cinfozf2_bglt)
																							COBJECT(BgL_auxz00_4927))->
																						BgL_approxz00);
																				}
																			}
																			{	/* Cfa/closure.scm 409 */
																				BgL_typez00_bglt BgL_t0z00_3133;

																				BgL_t0z00_3133 =
																					(((BgL_approxz00_bglt)
																						COBJECT(BgL_p0z00_3131))->
																					BgL_typez00);
																				{	/* Cfa/closure.scm 410 */
																					BgL_typez00_bglt BgL_t1z00_3134;

																					BgL_t1z00_3134 =
																						(((BgL_approxz00_bglt)
																							COBJECT(BgL_p1z00_3132))->
																						BgL_typez00);
																					{	/* Cfa/closure.scm 411 */

																						{	/* Cfa/closure.scm 412 */
																							bool_t BgL_test2310z00_4936;

																							if (
																								(((obj_t) BgL_t0z00_3133) ==
																									((obj_t) BgL_t1z00_3134)))
																								{	/* Cfa/closure.scm 412 */
																									BgL_test2310z00_4936 =
																										((bool_t) 1);
																								}
																							else
																								{	/* Cfa/closure.scm 412 */
																									if (BGl_bigloozd2typezf3z21zztype_typez00(BgL_t0z00_3133))
																										{	/* Cfa/closure.scm 412 */
																											BgL_test2310z00_4936 =
																												BGl_bigloozd2typezf3z21zztype_typez00
																												(BgL_t1z00_3134);
																										}
																									else
																										{	/* Cfa/closure.scm 412 */
																											BgL_test2310z00_4936 =
																												((bool_t) 0);
																										}
																								}
																							if (BgL_test2310z00_4936)
																								{
																									obj_t BgL_a1z00_4946;
																									obj_t BgL_a0z00_4944;

																									BgL_a0z00_4944 =
																										CDR(BgL_a0z00_3125);
																									BgL_a1z00_4946 =
																										CDR(BgL_a1z00_3126);
																									BgL_a1z00_3126 =
																										BgL_a1z00_4946;
																									BgL_a0z00_3125 =
																										BgL_a0z00_4944;
																									goto
																										BgL_zc3z04anonymousza31867ze3z87_3128;
																								}
																							else
																								{	/* Cfa/closure.scm 435 */
																									BgL_typez00_bglt
																										BgL_bt0z00_3140;
																									BgL_typez00_bglt
																										BgL_bt1z00_3141;
																									bool_t BgL_contz00_3142;

																									BgL_bt0z00_3140 =
																										BGl_getzd2bigloozd2typez00zztype_cachez00
																										(BgL_t0z00_3133);
																									BgL_bt1z00_3141 =
																										BGl_getzd2bigloozd2typez00zztype_cachez00
																										(BgL_t1z00_3134);
																									BgL_contz00_3142 =
																										((bool_t) 0);
																									if ((((obj_t) ((
																														(BgL_variablez00_bglt)
																														COBJECT((
																																(BgL_variablez00_bglt)
																																CAR
																																(BgL_a0z00_3125))))->
																													BgL_typez00)) ==
																											((obj_t)
																												BgL_bt0z00_3140)))
																										{	/* Cfa/closure.scm 438 */
																											BFALSE;
																										}
																									else
																										{	/* Cfa/closure.scm 438 */
																											{	/* Cfa/closure.scm 440 */
																												obj_t
																													BgL_arg1877z00_3146;
																												BgL_arg1877z00_3146 =
																													CAR(BgL_a0z00_3125);
																												((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt) BgL_arg1877z00_3146)))->BgL_typez00) = ((BgL_typez00_bglt) BgL_bt0z00_3140), BUNSPEC);
																											}
																											((((BgL_approxz00_bglt)
																														COBJECT
																														(BgL_p0z00_3131))->
																													BgL_typez00) =
																												((BgL_typez00_bglt)
																													BgL_bt0z00_3140),
																												BUNSPEC);
																											BgL_contz00_3142 =
																												((bool_t) 1);
																										}
																									if (
																										(((obj_t)
																												(((BgL_variablez00_bglt)
																														COBJECT((
																																(BgL_variablez00_bglt)
																																CAR
																																(BgL_a1z00_3126))))->
																													BgL_typez00)) ==
																											((obj_t)
																												BgL_bt1z00_3141)))
																										{	/* Cfa/closure.scm 444 */
																											BFALSE;
																										}
																									else
																										{	/* Cfa/closure.scm 444 */
																											{	/* Cfa/closure.scm 446 */
																												obj_t
																													BgL_arg1884z00_3152;
																												BgL_arg1884z00_3152 =
																													CAR(BgL_a1z00_3126);
																												((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt) BgL_arg1884z00_3152)))->BgL_typez00) = ((BgL_typez00_bglt) BgL_bt1z00_3141), BUNSPEC);
																											}
																											((((BgL_approxz00_bglt)
																														COBJECT
																														(BgL_p1z00_3132))->
																													BgL_typez00) =
																												((BgL_typez00_bglt)
																													BgL_bt1z00_3141),
																												BUNSPEC);
																											BgL_contz00_3142 =
																												((bool_t) 1);
																										}
																									{	/* Cfa/closure.scm 452 */
																										obj_t BgL_arg1887z00_3155;
																										obj_t BgL_arg1888z00_3156;

																										BgL_arg1887z00_3155 =
																											CDR(BgL_a0z00_3125);
																										BgL_arg1888z00_3156 =
																											CDR(BgL_a1z00_3126);
																										{
																											bool_t BgL_contz00_4976;
																											obj_t BgL_a1z00_4975;
																											obj_t BgL_a0z00_4974;

																											BgL_a0z00_4974 =
																												BgL_arg1887z00_3155;
																											BgL_a1z00_4975 =
																												BgL_arg1888z00_3156;
																											BgL_contz00_4976 =
																												BgL_contz00_3142;
																											BgL_contz00_3127 =
																												BgL_contz00_4976;
																											BgL_a1z00_3126 =
																												BgL_a1z00_4975;
																											BgL_a0z00_3125 =
																												BgL_a0z00_4974;
																											goto
																												BgL_zc3z04anonymousza31867ze3z87_3128;
																										}
																									}
																								}
																						}
																					}
																				}
																			}
																		}
																	}
																else
																	{	/* Cfa/closure.scm 407 */
																		BgL__ortest_1183z00_3098 = BgL_contz00_3127;
																	}
															}
														}
													}
												}
											}
										}
									}
									if (BgL__ortest_1183z00_3098)
										{	/* Cfa/closure.scm 459 */
											BgL_arg1857z00_3097 = BgL__ortest_1183z00_3098;
										}
									else
										{	/* Cfa/closure.scm 459 */
											BgL_arg1857z00_3097 = BgL_contz00_3093;
										}
								}
								{
									bool_t BgL_contz00_4981;
									obj_t BgL_appsz00_4980;

									BgL_appsz00_4980 = BgL_arg1856z00_3096;
									BgL_contz00_4981 = BgL_arg1857z00_3097;
									BgL_contz00_3093 = BgL_contz00_4981;
									BgL_appsz00_3092 = BgL_appsz00_4980;
									goto BgL_zc3z04anonymousza31854ze3z87_3094;
								}
							}
					}
				}
			}
		}

	}



/* type-closures! */
	BGL_EXPORTED_DEF obj_t BGl_typezd2closuresz12zc0zzcfa_closurez00()
	{
		{	/* Cfa/closure.scm 464 */
			{
				BgL_appz00_bglt BgL_appz00_3183;

				if (CBOOL
					(BGl_za2optimzd2cfazd2unboxzd2closurezd2argsza2z00zzengine_paramz00))
					{	/* Cfa/closure.scm 491 */
						obj_t BgL_g1541z00_3175;

						BgL_g1541z00_3175 =
							BGl_za2makezd2procedurezd2listza2z00zzcfa_closurez00;
						{
							obj_t BgL_l1539z00_3177;

							{	/* Cfa/closure.scm 491 */
								bool_t BgL_tmpz00_4984;

								BgL_l1539z00_3177 = BgL_g1541z00_3175;
							BgL_zc3z04anonymousza31902ze3z87_3178:
								if (PAIRP(BgL_l1539z00_3177))
									{	/* Cfa/closure.scm 491 */
										{	/* Cfa/closure.scm 491 */
											obj_t BgL_arg1904z00_3180;

											BgL_arg1904z00_3180 = CAR(BgL_l1539z00_3177);
											BgL_appz00_3183 = ((BgL_appz00_bglt) BgL_arg1904z00_3180);
											{	/* Cfa/closure.scm 475 */
												bool_t BgL_test2318z00_4988;

												{	/* Cfa/closure.scm 475 */
													bool_t BgL_test2319z00_4989;

													{
														BgL_makezd2procedurezd2appz00_bglt BgL_auxz00_4990;

														{
															obj_t BgL_auxz00_4991;

															{	/* Cfa/closure.scm 475 */
																BgL_objectz00_bglt BgL_tmpz00_4992;

																BgL_tmpz00_4992 =
																	((BgL_objectz00_bglt) BgL_appz00_3183);
																BgL_auxz00_4991 =
																	BGL_OBJECT_WIDENING(BgL_tmpz00_4992);
															}
															BgL_auxz00_4990 =
																((BgL_makezd2procedurezd2appz00_bglt)
																BgL_auxz00_4991);
														}
														BgL_test2319z00_4989 =
															(((BgL_makezd2procedurezd2appz00_bglt)
																COBJECT(BgL_auxz00_4990))->BgL_xz00);
													}
													if (BgL_test2319z00_4989)
														{	/* Cfa/closure.scm 475 */
															BgL_test2318z00_4988 = ((bool_t) 1);
														}
													else
														{
															BgL_makezd2procedurezd2appz00_bglt
																BgL_auxz00_4997;
															{
																obj_t BgL_auxz00_4998;

																{	/* Cfa/closure.scm 475 */
																	BgL_objectz00_bglt BgL_tmpz00_4999;

																	BgL_tmpz00_4999 =
																		((BgL_objectz00_bglt) BgL_appz00_3183);
																	BgL_auxz00_4998 =
																		BGL_OBJECT_WIDENING(BgL_tmpz00_4999);
																}
																BgL_auxz00_4997 =
																	((BgL_makezd2procedurezd2appz00_bglt)
																	BgL_auxz00_4998);
															}
															BgL_test2318z00_4988 =
																(((BgL_makezd2procedurezd2appz00_bglt)
																	COBJECT(BgL_auxz00_4997))->BgL_tz00);
														}
												}
												if (BgL_test2318z00_4988)
													{	/* Cfa/closure.scm 475 */
														((bool_t) 0);
													}
												else
													{	/* Cfa/closure.scm 477 */
														BgL_variablez00_bglt BgL_varz00_3188;

														{
															BgL_varz00_bglt BgL_auxz00_5004;

															{	/* Cfa/closure.scm 477 */
																obj_t BgL_pairz00_4054;

																BgL_pairz00_4054 =
																	(((BgL_appz00_bglt) COBJECT(
																			((BgL_appz00_bglt) BgL_appz00_3183)))->
																	BgL_argsz00);
																BgL_auxz00_5004 =
																	((BgL_varz00_bglt) CAR(BgL_pairz00_4054));
															}
															BgL_varz00_3188 =
																(((BgL_varz00_bglt) COBJECT(BgL_auxz00_5004))->
																BgL_variablez00);
														}
														{	/* Cfa/closure.scm 477 */
															BgL_valuez00_bglt BgL_sfunz00_3189;

															BgL_sfunz00_3189 =
																(((BgL_variablez00_bglt)
																	COBJECT(BgL_varz00_3188))->BgL_valuez00);
															{	/* Cfa/closure.scm 478 */

																((((BgL_variablez00_bglt)
																			COBJECT(BgL_varz00_3188))->BgL_typez00) =
																	((BgL_typez00_bglt)
																		BGl_getzd2bigloozd2definedzd2typezd2zztype_cachez00
																		((((BgL_variablez00_bglt)
																					COBJECT(BgL_varz00_3188))->
																				BgL_typez00))), BUNSPEC);
																{	/* Cfa/closure.scm 481 */
																	obj_t BgL_g1538z00_3192;

																	{	/* Cfa/closure.scm 488 */
																		obj_t BgL_pairz00_4061;

																		BgL_pairz00_4061 =
																			(((BgL_sfunz00_bglt) COBJECT(
																					((BgL_sfunz00_bglt)
																						BgL_sfunz00_3189)))->BgL_argsz00);
																		BgL_g1538z00_3192 = CDR(BgL_pairz00_4061);
																	}
																	{
																		obj_t BgL_l1536z00_3194;

																		BgL_l1536z00_3194 = BgL_g1538z00_3192;
																	BgL_zc3z04anonymousza31911ze3z87_3195:
																		if (PAIRP(BgL_l1536z00_3194))
																			{	/* Cfa/closure.scm 488 */
																				{	/* Cfa/closure.scm 482 */
																					obj_t BgL_az00_3197;

																					BgL_az00_3197 =
																						CAR(BgL_l1536z00_3194);
																					{	/* Cfa/closure.scm 482 */
																						BgL_approxz00_bglt BgL_pz00_3198;

																						{	/* Cfa/closure.scm 482 */
																							BgL_svarz00_bglt BgL_oz00_4065;

																							BgL_oz00_4065 =
																								((BgL_svarz00_bglt)
																								(((BgL_variablez00_bglt)
																										COBJECT((
																												(BgL_variablez00_bglt)
																												BgL_az00_3197)))->
																									BgL_valuez00));
																							{
																								BgL_svarzf2cinfozf2_bglt
																									BgL_auxz00_5023;
																								{
																									obj_t BgL_auxz00_5024;

																									{	/* Cfa/closure.scm 482 */
																										BgL_objectz00_bglt
																											BgL_tmpz00_5025;
																										BgL_tmpz00_5025 =
																											((BgL_objectz00_bglt)
																											BgL_oz00_4065);
																										BgL_auxz00_5024 =
																											BGL_OBJECT_WIDENING
																											(BgL_tmpz00_5025);
																									}
																									BgL_auxz00_5023 =
																										((BgL_svarzf2cinfozf2_bglt)
																										BgL_auxz00_5024);
																								}
																								BgL_pz00_3198 =
																									(((BgL_svarzf2cinfozf2_bglt)
																										COBJECT(BgL_auxz00_5023))->
																									BgL_approxz00);
																							}
																						}
																						{	/* Cfa/closure.scm 482 */
																							BgL_typez00_bglt BgL_tz00_3199;

																							BgL_tz00_3199 =
																								(((BgL_approxz00_bglt)
																									COBJECT(BgL_pz00_3198))->
																								BgL_typez00);
																							{	/* Cfa/closure.scm 483 */

																								{	/* Cfa/closure.scm 487 */
																									BgL_typez00_bglt
																										BgL_arg1913z00_3200;
																									BgL_arg1913z00_3200 =
																										BGl_getzd2bigloozd2definedzd2typezd2zztype_cachez00
																										(BgL_tz00_3199);
																									((((BgL_variablez00_bglt)
																												COBJECT((
																														(BgL_variablez00_bglt)
																														BgL_az00_3197)))->
																											BgL_typez00) =
																										((BgL_typez00_bglt)
																											BgL_arg1913z00_3200),
																										BUNSPEC);
																								}
																							}
																						}
																					}
																				}
																				{
																					obj_t BgL_l1536z00_5034;

																					BgL_l1536z00_5034 =
																						CDR(BgL_l1536z00_3194);
																					BgL_l1536z00_3194 = BgL_l1536z00_5034;
																					goto
																						BgL_zc3z04anonymousza31911ze3z87_3195;
																				}
																			}
																		else
																			{	/* Cfa/closure.scm 488 */
																				((bool_t) 1);
																			}
																	}
																}
															}
														}
													}
											}
										}
										{
											obj_t BgL_l1539z00_5037;

											BgL_l1539z00_5037 = CDR(BgL_l1539z00_3177);
											BgL_l1539z00_3177 = BgL_l1539z00_5037;
											goto BgL_zc3z04anonymousza31902ze3z87_3178;
										}
									}
								else
									{	/* Cfa/closure.scm 491 */
										BgL_tmpz00_4984 = ((bool_t) 1);
									}
								return BBOOL(BgL_tmpz00_4984);
							}
						}
					}
				else
					{	/* Cfa/closure.scm 490 */
						return BFALSE;
					}
			}
		}

	}



/* &type-closures! */
	obj_t BGl_z62typezd2closuresz12za2zzcfa_closurez00(obj_t BgL_envz00_4143)
	{
		{	/* Cfa/closure.scm 464 */
			return BGl_typezd2closuresz12zc0zzcfa_closurez00();
		}

	}



/* light-access! */
	bool_t BGl_lightzd2accessz12zc0zzcfa_closurez00()
	{
		{	/* Cfa/closure.scm 496 */
			{
				obj_t BgL_l1542z00_3210;

				BgL_l1542z00_3210 = BGl_za2procedurezd2refzd2listza2z00zzcfa_closurez00;
			BgL_zc3z04anonymousza31919ze3z87_3211:
				if (PAIRP(BgL_l1542z00_3210))
					{	/* Cfa/closure.scm 497 */
						{	/* Cfa/closure.scm 499 */
							obj_t BgL_appz00_3213;

							BgL_appz00_3213 = CAR(BgL_l1542z00_3210);
							{	/* Cfa/closure.scm 499 */
								BgL_approxz00_bglt BgL_approxz00_3215;

								{	/* Cfa/closure.scm 500 */
									obj_t BgL_arg1932z00_3234;

									{	/* Cfa/closure.scm 500 */
										obj_t BgL_pairz00_4079;

										BgL_pairz00_4079 =
											(((BgL_appz00_bglt) COBJECT(
													((BgL_appz00_bglt) BgL_appz00_3213)))->BgL_argsz00);
										BgL_arg1932z00_3234 = CAR(BgL_pairz00_4079);
									}
									BgL_approxz00_3215 =
										BGl_cfaz12z12zzcfa_cfaz00(
										((BgL_nodez00_bglt) BgL_arg1932z00_3234));
								}
								{	/* Cfa/closure.scm 500 */
									obj_t BgL_alloczd2listzd2_3216;

									BgL_alloczd2listzd2_3216 =
										BGl_setzd2ze3listz31zzcfa_setz00(
										(((BgL_approxz00_bglt) COBJECT(BgL_approxz00_3215))->
											BgL_allocsz00));
									{	/* Cfa/closure.scm 501 */
										BgL_varz00_bglt BgL_funz00_3217;

										BgL_funz00_3217 =
											(((BgL_appz00_bglt) COBJECT(
													((BgL_appz00_bglt) BgL_appz00_3213)))->BgL_funz00);
										{	/* Cfa/closure.scm 502 */
											BgL_variablez00_bglt BgL_vfunz00_3218;

											BgL_vfunz00_3218 =
												(((BgL_varz00_bglt) COBJECT(BgL_funz00_3217))->
												BgL_variablez00);
											{	/* Cfa/closure.scm 503 */

												{	/* Cfa/closure.scm 504 */
													bool_t BgL_test2322z00_5054;

													if (PAIRP(BgL_alloczd2listzd2_3216))
														{	/* Cfa/closure.scm 505 */
															bool_t BgL_test2324z00_5057;

															{	/* Cfa/closure.scm 505 */
																obj_t BgL_arg1930z00_3232;

																BgL_arg1930z00_3232 =
																	CAR(BgL_alloczd2listzd2_3216);
																BgL_test2324z00_5057 =
																	BGl_isazf3zf3zz__objectz00
																	(BgL_arg1930z00_3232,
																	BGl_makezd2procedurezd2appz00zzcfa_info2z00);
															}
															if (BgL_test2324z00_5057)
																{	/* Cfa/closure.scm 505 */
																	BgL_test2322z00_5054 = ((bool_t) 0);
																}
															else
																{	/* Cfa/closure.scm 505 */
																	BgL_test2322z00_5054 = ((bool_t) 1);
																}
														}
													else
														{	/* Cfa/closure.scm 504 */
															BgL_test2322z00_5054 = ((bool_t) 1);
														}
													if (BgL_test2322z00_5054)
														{	/* Cfa/closure.scm 504 */
															CNST_TABLE_REF(((long) 8));
														}
													else
														{	/* Cfa/closure.scm 507 */
															BgL_appz00_bglt BgL_allocz00_3224;

															BgL_allocz00_3224 =
																((BgL_appz00_bglt)
																CAR(((obj_t) BgL_alloczd2listzd2_3216)));
															{	/* Cfa/closure.scm 510 */
																bool_t BgL_test2325z00_5064;

																{
																	BgL_makezd2procedurezd2appz00_bglt
																		BgL_auxz00_5065;
																	{
																		obj_t BgL_auxz00_5066;

																		{	/* Cfa/closure.scm 510 */
																			BgL_objectz00_bglt BgL_tmpz00_5067;

																			BgL_tmpz00_5067 =
																				((BgL_objectz00_bglt)
																				((BgL_appz00_bglt) BgL_allocz00_3224));
																			BgL_auxz00_5066 =
																				BGL_OBJECT_WIDENING(BgL_tmpz00_5067);
																		}
																		BgL_auxz00_5065 =
																			((BgL_makezd2procedurezd2appz00_bglt)
																			BgL_auxz00_5066);
																	}
																	BgL_test2325z00_5064 =
																		(((BgL_makezd2procedurezd2appz00_bglt)
																			COBJECT(BgL_auxz00_5065))->BgL_xz00);
																}
																if (BgL_test2325z00_5064)
																	{	/* Cfa/closure.scm 510 */
																		if (
																			(((obj_t) BgL_vfunz00_3218) ==
																				BGl_za2procedurezd2refza2zd2zzcfa_closurez00))
																			{	/* Cfa/closure.scm 512 */
																				BgL_variablez00_bglt BgL_vz00_4089;

																				BgL_vz00_4089 =
																					((BgL_variablez00_bglt)
																					BGl_za2procedurezd2elzd2refza2z00zzcfa_closurez00);
																				((((BgL_varz00_bglt)
																							COBJECT(BgL_funz00_3217))->
																						BgL_variablez00) =
																					((BgL_variablez00_bglt)
																						BgL_vz00_4089), BUNSPEC);
																			}
																		else
																			{	/* Cfa/closure.scm 513 */
																				BgL_variablez00_bglt BgL_vz00_4091;

																				BgL_vz00_4091 =
																					((BgL_variablez00_bglt)
																					BGl_za2procedurezd2elzd2setz12za2z12zzcfa_closurez00);
																				((((BgL_varz00_bglt)
																							COBJECT(BgL_funz00_3217))->
																						BgL_variablez00) =
																					((BgL_variablez00_bglt)
																						BgL_vz00_4091), BUNSPEC);
																			}
																	}
																else
																	{	/* Cfa/closure.scm 514 */
																		bool_t BgL_test2327z00_5080;

																		{
																			BgL_makezd2procedurezd2appz00_bglt
																				BgL_auxz00_5081;
																			{
																				obj_t BgL_auxz00_5082;

																				{	/* Cfa/closure.scm 514 */
																					BgL_objectz00_bglt BgL_tmpz00_5083;

																					BgL_tmpz00_5083 =
																						((BgL_objectz00_bglt)
																						((BgL_appz00_bglt)
																							BgL_allocz00_3224));
																					BgL_auxz00_5082 =
																						BGL_OBJECT_WIDENING
																						(BgL_tmpz00_5083);
																				}
																				BgL_auxz00_5081 =
																					((BgL_makezd2procedurezd2appz00_bglt)
																					BgL_auxz00_5082);
																			}
																			BgL_test2327z00_5080 =
																				(((BgL_makezd2procedurezd2appz00_bglt)
																					COBJECT(BgL_auxz00_5081))->BgL_tz00);
																		}
																		if (BgL_test2327z00_5080)
																			{	/* Cfa/closure.scm 514 */
																				if (
																					(((obj_t) BgL_vfunz00_3218) ==
																						BGl_za2procedurezd2refza2zd2zzcfa_closurez00))
																					{	/* Cfa/closure.scm 516 */
																						BgL_variablez00_bglt BgL_vz00_4094;

																						BgL_vz00_4094 =
																							((BgL_variablez00_bglt)
																							BGl_za2procedurezd2lzd2refza2z00zzcfa_closurez00);
																						((((BgL_varz00_bglt)
																									COBJECT(BgL_funz00_3217))->
																								BgL_variablez00) =
																							((BgL_variablez00_bglt)
																								BgL_vz00_4094), BUNSPEC);
																					}
																				else
																					{	/* Cfa/closure.scm 517 */
																						BgL_variablez00_bglt BgL_vz00_4096;

																						BgL_vz00_4096 =
																							((BgL_variablez00_bglt)
																							BGl_za2procedurezd2lzd2setz12za2z12zzcfa_closurez00);
																						((((BgL_varz00_bglt)
																									COBJECT(BgL_funz00_3217))->
																								BgL_variablez00) =
																							((BgL_variablez00_bglt)
																								BgL_vz00_4096), BUNSPEC);
																					}
																			}
																		else
																			{	/* Cfa/closure.scm 514 */
																				BFALSE;
																			}
																	}
															}
														}
												}
											}
										}
									}
								}
							}
						}
						{
							obj_t BgL_l1542z00_5096;

							BgL_l1542z00_5096 = CDR(BgL_l1542z00_3210);
							BgL_l1542z00_3210 = BgL_l1542z00_5096;
							goto BgL_zc3z04anonymousza31919ze3z87_3211;
						}
					}
				else
					{	/* Cfa/closure.scm 497 */
						return ((bool_t) 1);
					}
			}
		}

	}



/* show-X-T */
	obj_t BGl_showzd2Xzd2Tz00zzcfa_closurez00(obj_t BgL_allocsz00_11)
	{
		{	/* Cfa/closure.scm 523 */
			{
				obj_t BgL_xpz00_3242;
				obj_t BgL_tpz00_3243;
				obj_t BgL_allocsz00_3244;

				BgL_xpz00_3242 = BNIL;
				BgL_tpz00_3243 = BNIL;
				BgL_allocsz00_3244 = BgL_allocsz00_11;
			BgL_zc3z04anonymousza31935ze3z87_3245:
				if (NULLP(BgL_allocsz00_3244))
					{	/* Cfa/closure.scm 534 */
						BGl_showze70ze7zzcfa_closurez00(CNST_TABLE_REF(((long) 9)),
							BgL_xpz00_3242);
						BGl_showze70ze7zzcfa_closurez00(CNST_TABLE_REF(((long) 10)),
							BgL_tpz00_3243);
						return BUNSPEC;
					}
				else
					{	/* Cfa/closure.scm 539 */
						BgL_appz00_bglt BgL_i1188z00_3247;

						BgL_i1188z00_3247 =
							((BgL_appz00_bglt) CAR(((obj_t) BgL_allocsz00_3244)));
						{	/* Cfa/closure.scm 541 */
							bool_t BgL_test2330z00_5107;

							{
								BgL_makezd2procedurezd2appz00_bglt BgL_auxz00_5108;

								{
									obj_t BgL_auxz00_5109;

									{	/* Cfa/closure.scm 541 */
										BgL_objectz00_bglt BgL_tmpz00_5110;

										BgL_tmpz00_5110 = ((BgL_objectz00_bglt) BgL_i1188z00_3247);
										BgL_auxz00_5109 = BGL_OBJECT_WIDENING(BgL_tmpz00_5110);
									}
									BgL_auxz00_5108 =
										((BgL_makezd2procedurezd2appz00_bglt) BgL_auxz00_5109);
								}
								BgL_test2330z00_5107 =
									(((BgL_makezd2procedurezd2appz00_bglt)
										COBJECT(BgL_auxz00_5108))->BgL_xz00);
							}
							if (BgL_test2330z00_5107)
								{	/* Cfa/closure.scm 542 */
									obj_t BgL_arg1938z00_3249;
									obj_t BgL_arg1939z00_3250;

									{	/* Cfa/closure.scm 542 */
										BgL_variablez00_bglt BgL_arg1940z00_3251;

										{
											BgL_varz00_bglt BgL_auxz00_5115;

											{	/* Cfa/closure.scm 542 */
												obj_t BgL_pairz00_4107;

												BgL_pairz00_4107 =
													(((BgL_appz00_bglt) COBJECT(
															((BgL_appz00_bglt) BgL_i1188z00_3247)))->
													BgL_argsz00);
												BgL_auxz00_5115 =
													((BgL_varz00_bglt) CAR(BgL_pairz00_4107));
											}
											BgL_arg1940z00_3251 =
												(((BgL_varz00_bglt) COBJECT(BgL_auxz00_5115))->
												BgL_variablez00);
										}
										BgL_arg1938z00_3249 =
											MAKE_YOUNG_PAIR(
											((obj_t) BgL_arg1940z00_3251), BgL_xpz00_3242);
									}
									BgL_arg1939z00_3250 = CDR(((obj_t) BgL_allocsz00_3244));
									{
										obj_t BgL_allocsz00_5126;
										obj_t BgL_xpz00_5125;

										BgL_xpz00_5125 = BgL_arg1938z00_3249;
										BgL_allocsz00_5126 = BgL_arg1939z00_3250;
										BgL_allocsz00_3244 = BgL_allocsz00_5126;
										BgL_xpz00_3242 = BgL_xpz00_5125;
										goto BgL_zc3z04anonymousza31935ze3z87_3245;
									}
								}
							else
								{	/* Cfa/closure.scm 543 */
									bool_t BgL_test2331z00_5127;

									{
										BgL_makezd2procedurezd2appz00_bglt BgL_auxz00_5128;

										{
											obj_t BgL_auxz00_5129;

											{	/* Cfa/closure.scm 543 */
												BgL_objectz00_bglt BgL_tmpz00_5130;

												BgL_tmpz00_5130 =
													((BgL_objectz00_bglt) BgL_i1188z00_3247);
												BgL_auxz00_5129 = BGL_OBJECT_WIDENING(BgL_tmpz00_5130);
											}
											BgL_auxz00_5128 =
												((BgL_makezd2procedurezd2appz00_bglt) BgL_auxz00_5129);
										}
										BgL_test2331z00_5127 =
											(((BgL_makezd2procedurezd2appz00_bglt)
												COBJECT(BgL_auxz00_5128))->BgL_tz00);
									}
									if (BgL_test2331z00_5127)
										{	/* Cfa/closure.scm 544 */
											obj_t BgL_arg1944z00_3255;
											obj_t BgL_arg1945z00_3256;

											{	/* Cfa/closure.scm 544 */
												BgL_variablez00_bglt BgL_arg1946z00_3257;

												{
													BgL_varz00_bglt BgL_auxz00_5135;

													{	/* Cfa/closure.scm 544 */
														obj_t BgL_pairz00_4111;

														BgL_pairz00_4111 =
															(((BgL_appz00_bglt) COBJECT(
																	((BgL_appz00_bglt) BgL_i1188z00_3247)))->
															BgL_argsz00);
														BgL_auxz00_5135 =
															((BgL_varz00_bglt) CAR(BgL_pairz00_4111));
													}
													BgL_arg1946z00_3257 =
														(((BgL_varz00_bglt) COBJECT(BgL_auxz00_5135))->
														BgL_variablez00);
												}
												BgL_arg1944z00_3255 =
													MAKE_YOUNG_PAIR(
													((obj_t) BgL_arg1946z00_3257), BgL_tpz00_3243);
											}
											BgL_arg1945z00_3256 = CDR(((obj_t) BgL_allocsz00_3244));
											{
												obj_t BgL_allocsz00_5146;
												obj_t BgL_tpz00_5145;

												BgL_tpz00_5145 = BgL_arg1944z00_3255;
												BgL_allocsz00_5146 = BgL_arg1945z00_3256;
												BgL_allocsz00_3244 = BgL_allocsz00_5146;
												BgL_tpz00_3243 = BgL_tpz00_5145;
												goto BgL_zc3z04anonymousza31935ze3z87_3245;
											}
										}
									else
										{	/* Cfa/closure.scm 546 */
											obj_t BgL_arg1949z00_3260;

											BgL_arg1949z00_3260 = CDR(((obj_t) BgL_allocsz00_3244));
											{
												obj_t BgL_allocsz00_5149;

												BgL_allocsz00_5149 = BgL_arg1949z00_3260;
												BgL_allocsz00_3244 = BgL_allocsz00_5149;
												goto BgL_zc3z04anonymousza31935ze3z87_3245;
											}
										}
								}
						}
					}
			}
		}

	}



/* show~0 */
	bool_t BGl_showze70ze7zzcfa_closurez00(obj_t BgL_propz00_3262,
		obj_t BgL_lz00_3263)
	{
		{	/* Cfa/closure.scm 530 */
			if (NULLP(BgL_lz00_3263))
				{	/* Cfa/closure.scm 525 */
					return ((bool_t) 0);
				}
			else
				{	/* Cfa/closure.scm 525 */
					{	/* Cfa/closure.scm 527 */
						obj_t BgL_arg1953z00_3266;

						BgL_arg1953z00_3266 =
							BGl_shapez00zztools_shapez00(CAR(BgL_lz00_3263));
						{	/* Cfa/closure.scm 527 */
							obj_t BgL_list1954z00_3267;

							{	/* Cfa/closure.scm 527 */
								obj_t BgL_arg1956z00_3268;

								{	/* Cfa/closure.scm 527 */
									obj_t BgL_arg1957z00_3269;

									{	/* Cfa/closure.scm 527 */
										obj_t BgL_arg1958z00_3270;

										{	/* Cfa/closure.scm 527 */
											obj_t BgL_arg1959z00_3271;

											BgL_arg1959z00_3271 =
												MAKE_YOUNG_PAIR(BCHAR(((unsigned char) 10)), BNIL);
											BgL_arg1958z00_3270 =
												MAKE_YOUNG_PAIR(BgL_arg1953z00_3266,
												BgL_arg1959z00_3271);
										}
										BgL_arg1957z00_3269 =
											MAKE_YOUNG_PAIR(BGl_string2212z00zzcfa_closurez00,
											BgL_arg1958z00_3270);
									}
									BgL_arg1956z00_3268 =
										MAKE_YOUNG_PAIR(BgL_propz00_3262, BgL_arg1957z00_3269);
								}
								BgL_list1954z00_3267 =
									MAKE_YOUNG_PAIR(BGl_string2213z00zzcfa_closurez00,
									BgL_arg1956z00_3268);
							}
							BGl_verbosez00zztools_speekz00(BINT(((long) 2)),
								BgL_list1954z00_3267);
					}}
					{	/* Cfa/closure.scm 528 */
						obj_t BgL_g1546z00_3273;

						BgL_g1546z00_3273 = CDR(BgL_lz00_3263);
						{
							obj_t BgL_l1544z00_3275;

							BgL_l1544z00_3275 = BgL_g1546z00_3273;
						BgL_zc3z04anonymousza31961ze3z87_3276:
							if (PAIRP(BgL_l1544z00_3275))
								{	/* Cfa/closure.scm 530 */
									{	/* Cfa/closure.scm 529 */
										obj_t BgL_xz00_3278;

										BgL_xz00_3278 = CAR(BgL_l1544z00_3275);
										{	/* Cfa/closure.scm 529 */
											obj_t BgL_arg1963z00_3279;

											BgL_arg1963z00_3279 =
												BGl_shapez00zztools_shapez00(BgL_xz00_3278);
											{	/* Cfa/closure.scm 529 */
												obj_t BgL_list1964z00_3280;

												{	/* Cfa/closure.scm 529 */
													obj_t BgL_arg1965z00_3281;

													{	/* Cfa/closure.scm 529 */
														obj_t BgL_arg1966z00_3282;

														BgL_arg1966z00_3282 =
															MAKE_YOUNG_PAIR(BCHAR(((unsigned char) 10)),
															BNIL);
														BgL_arg1965z00_3281 =
															MAKE_YOUNG_PAIR(BgL_arg1963z00_3279,
															BgL_arg1966z00_3282);
													}
													BgL_list1964z00_3280 =
														MAKE_YOUNG_PAIR(BGl_string2214z00zzcfa_closurez00,
														BgL_arg1965z00_3281);
												}
												BGl_verbosez00zztools_speekz00(BINT(((long) 2)),
													BgL_list1964z00_3280);
									}}}
									{
										obj_t BgL_l1544z00_5173;

										BgL_l1544z00_5173 = CDR(BgL_l1544z00_3275);
										BgL_l1544z00_3275 = BgL_l1544z00_5173;
										goto BgL_zc3z04anonymousza31961ze3z87_3276;
									}
								}
							else
								{	/* Cfa/closure.scm 530 */
									return ((bool_t) 1);
								}
						}
					}
				}
		}

	}



/* get-procedure-list */
	BGL_EXPORTED_DEF obj_t BGl_getzd2procedurezd2listz00zzcfa_closurez00()
	{
		{	/* Cfa/closure.scm 558 */
			return BGl_za2makezd2procedurezd2listza2z00zzcfa_closurez00;
		}

	}



/* &get-procedure-list */
	obj_t BGl_z62getzd2procedurezd2listz62zzcfa_closurez00(obj_t BgL_envz00_4144)
	{
		{	/* Cfa/closure.scm 558 */
			return BGl_getzd2procedurezd2listz00zzcfa_closurez00();
		}

	}



/* add-funcall! */
	BGL_EXPORTED_DEF obj_t
		BGl_addzd2funcallz12zc0zzcfa_closurez00(BgL_nodez00_bglt BgL_astz00_12)
	{
		{	/* Cfa/closure.scm 564 */
			if (((long) CINT(BGl_za2optimza2z00zzengine_paramz00) >= ((long) 2)))
				{	/* Cfa/closure.scm 565 */
					return (BGl_za2funcallzd2listza2zd2zzcfa_closurez00 =
						MAKE_YOUNG_PAIR(
							((obj_t) BgL_astz00_12),
							BGl_za2funcallzd2listza2zd2zzcfa_closurez00), BUNSPEC);
				}
			else
				{	/* Cfa/closure.scm 565 */
					return BFALSE;
				}
		}

	}



/* &add-funcall! */
	obj_t BGl_z62addzd2funcallz12za2zzcfa_closurez00(obj_t BgL_envz00_4145,
		obj_t BgL_astz00_4146)
	{
		{	/* Cfa/closure.scm 564 */
			return
				BGl_addzd2funcallz12zc0zzcfa_closurez00(
				((BgL_nodez00_bglt) BgL_astz00_4146));
		}

	}



/* add-make-procedure! */
	BGL_EXPORTED_DEF obj_t
		BGl_addzd2makezd2procedurez12z12zzcfa_closurez00(BgL_nodez00_bglt
		BgL_astz00_13)
	{
		{	/* Cfa/closure.scm 571 */
			return (BGl_za2makezd2procedurezd2listza2z00zzcfa_closurez00 =
				MAKE_YOUNG_PAIR(
					((obj_t) BgL_astz00_13),
					BGl_za2makezd2procedurezd2listza2z00zzcfa_closurez00), BUNSPEC);
		}

	}



/* &add-make-procedure! */
	obj_t BGl_z62addzd2makezd2procedurez12z70zzcfa_closurez00(obj_t
		BgL_envz00_4147, obj_t BgL_astz00_4148)
	{
		{	/* Cfa/closure.scm 571 */
			return
				BGl_addzd2makezd2procedurez12z12zzcfa_closurez00(
				((BgL_nodez00_bglt) BgL_astz00_4148));
		}

	}



/* add-procedure-ref! */
	BGL_EXPORTED_DEF obj_t
		BGl_addzd2procedurezd2refz12z12zzcfa_closurez00(BgL_nodez00_bglt
		BgL_astz00_14)
	{
		{	/* Cfa/closure.scm 577 */
			if (((long) CINT(BGl_za2optimza2z00zzengine_paramz00) >= ((long) 2)))
				{	/* Cfa/closure.scm 578 */
					return (BGl_za2procedurezd2refzd2listza2z00zzcfa_closurez00 =
						MAKE_YOUNG_PAIR(
							((obj_t) BgL_astz00_14),
							BGl_za2procedurezd2refzd2listza2z00zzcfa_closurez00), BUNSPEC);
				}
			else
				{	/* Cfa/closure.scm 578 */
					return BFALSE;
				}
		}

	}



/* &add-procedure-ref! */
	obj_t BGl_z62addzd2procedurezd2refz12z70zzcfa_closurez00(obj_t
		BgL_envz00_4149, obj_t BgL_astz00_4150)
	{
		{	/* Cfa/closure.scm 577 */
			return
				BGl_addzd2procedurezd2refz12z12zzcfa_closurez00(
				((BgL_nodez00_bglt) BgL_astz00_4150));
		}

	}



/* approx-procedure-el? */
	BGL_EXPORTED_DEF bool_t
		BGl_approxzd2procedurezd2elzf3zf3zzcfa_closurez00(BgL_approxz00_bglt
		BgL_approxz00_15)
	{
		{	/* Cfa/closure.scm 584 */
			{	/* Cfa/closure.scm 585 */
				BgL_typez00_bglt BgL_typez00_3288;
				obj_t BgL_alloczd2listzd2_3289;

				BgL_typez00_3288 =
					(((BgL_approxz00_bglt) COBJECT(BgL_approxz00_15))->BgL_typez00);
				BgL_alloczd2listzd2_3289 =
					BGl_setzd2ze3listz31zzcfa_setz00(
					(((BgL_approxz00_bglt) COBJECT(BgL_approxz00_15))->BgL_allocsz00));
				if (
					(((obj_t) BgL_typez00_3288) == BGl_za2procedureza2z00zztype_cachez00))
					{	/* Cfa/closure.scm 587 */
						if (PAIRP(BgL_alloczd2listzd2_3289))
							{	/* Cfa/closure.scm 588 */
								if (NULLP(CDR(BgL_alloczd2listzd2_3289)))
									{	/* Cfa/closure.scm 590 */
										bool_t BgL_test2339z00_5205;

										{	/* Cfa/closure.scm 590 */
											obj_t BgL_arg1971z00_3295;

											BgL_arg1971z00_3295 = CAR(BgL_alloczd2listzd2_3289);
											BgL_test2339z00_5205 =
												BGl_isazf3zf3zz__objectz00(BgL_arg1971z00_3295,
												BGl_makezd2procedurezd2appz00zzcfa_info2z00);
										}
										if (BgL_test2339z00_5205)
											{	/* Cfa/closure.scm 591 */
												BgL_appz00_bglt BgL_oz00_4127;

												BgL_oz00_4127 =
													((BgL_appz00_bglt) CAR(BgL_alloczd2listzd2_3289));
												{
													BgL_makezd2procedurezd2appz00_bglt BgL_auxz00_5210;

													{
														obj_t BgL_auxz00_5211;

														{	/* Cfa/closure.scm 591 */
															BgL_objectz00_bglt BgL_tmpz00_5212;

															BgL_tmpz00_5212 =
																((BgL_objectz00_bglt) BgL_oz00_4127);
															BgL_auxz00_5211 =
																BGL_OBJECT_WIDENING(BgL_tmpz00_5212);
														}
														BgL_auxz00_5210 =
															((BgL_makezd2procedurezd2appz00_bglt)
															BgL_auxz00_5211);
													}
													return
														(((BgL_makezd2procedurezd2appz00_bglt)
															COBJECT(BgL_auxz00_5210))->BgL_xz00);
												}
											}
										else
											{	/* Cfa/closure.scm 590 */
												return ((bool_t) 0);
											}
									}
								else
									{	/* Cfa/closure.scm 589 */
										return ((bool_t) 0);
									}
							}
						else
							{	/* Cfa/closure.scm 588 */
								return ((bool_t) 0);
							}
					}
				else
					{	/* Cfa/closure.scm 587 */
						return ((bool_t) 0);
					}
			}
		}

	}



/* &approx-procedure-el? */
	obj_t BGl_z62approxzd2procedurezd2elzf3z91zzcfa_closurez00(obj_t
		BgL_envz00_4151, obj_t BgL_approxz00_4152)
	{
		{	/* Cfa/closure.scm 584 */
			return
				BBOOL(BGl_approxzd2procedurezd2elzf3zf3zzcfa_closurez00(
					((BgL_approxz00_bglt) BgL_approxz00_4152)));
		}

	}



/* start-closure-cache */
	obj_t BGl_startzd2closurezd2cachez00zzcfa_closurez00()
	{
		{	/* Cfa/closure.scm 608 */
			BGl_za2procedurezd2refza2zd2zzcfa_closurez00 =
				BGl_getzd2globalzf2modulez20zzast_envz00(CNST_TABLE_REF(((long) 11)),
				CNST_TABLE_REF(((long) 12)));
			BGl_za2procedurezd2setz12za2zc0zzcfa_closurez00 =
				BGl_getzd2globalzf2modulez20zzast_envz00(CNST_TABLE_REF(((long) 13)),
				CNST_TABLE_REF(((long) 12)));
			BGl_za2procedurezd2lzd2refza2z00zzcfa_closurez00 =
				BGl_getzd2globalzf2modulez20zzast_envz00(CNST_TABLE_REF(((long) 14)),
				CNST_TABLE_REF(((long) 12)));
			BGl_za2procedurezd2lzd2setz12za2z12zzcfa_closurez00 =
				BGl_getzd2globalzf2modulez20zzast_envz00(CNST_TABLE_REF(((long) 15)),
				CNST_TABLE_REF(((long) 12)));
			BGl_za2procedurezd2elzd2refza2z00zzcfa_closurez00 =
				BGl_getzd2globalzf2modulez20zzast_envz00(CNST_TABLE_REF(((long) 16)),
				CNST_TABLE_REF(((long) 12)));
			BGl_za2procedurezd2elzd2setz12za2z12zzcfa_closurez00 =
				BGl_getzd2globalzf2modulez20zzast_envz00(CNST_TABLE_REF(((long) 17)),
				CNST_TABLE_REF(((long) 12)));
			BGl_za2makezd2elzd2procedureza2z00zzcfa_closurez00 =
				BGl_getzd2globalzf2modulez20zzast_envz00(CNST_TABLE_REF(((long) 18)),
				CNST_TABLE_REF(((long) 12)));
			return (BGl_za2makezd2lzd2procedureza2z00zzcfa_closurez00 =
				BGl_getzd2globalzf2modulez20zzast_envz00(CNST_TABLE_REF(((long) 19)),
					CNST_TABLE_REF(((long) 12))), BUNSPEC);
		}

	}



/* stop-closure-cache */
	BGL_EXPORTED_DEF obj_t BGl_stopzd2closurezd2cachez00zzcfa_closurez00()
	{
		{	/* Cfa/closure.scm 621 */
			BGl_za2procedurezd2refza2zd2zzcfa_closurez00 = BFALSE;
			BGl_za2procedurezd2setz12za2zc0zzcfa_closurez00 = BFALSE;
			BGl_za2procedurezd2lzd2refza2z00zzcfa_closurez00 = BFALSE;
			BGl_za2procedurezd2lzd2setz12za2z12zzcfa_closurez00 = BFALSE;
			BGl_za2procedurezd2elzd2refza2z00zzcfa_closurez00 = BFALSE;
			BGl_za2procedurezd2elzd2setz12za2z12zzcfa_closurez00 = BFALSE;
			BGl_za2makezd2elzd2procedureza2z00zzcfa_closurez00 = BFALSE;
			return (BGl_za2makezd2lzd2procedureza2z00zzcfa_closurez00 =
				BFALSE, BUNSPEC);
		}

	}



/* &stop-closure-cache */
	obj_t BGl_z62stopzd2closurezd2cachez62zzcfa_closurez00(obj_t BgL_envz00_4153)
	{
		{	/* Cfa/closure.scm 621 */
			return BGl_stopzd2closurezd2cachez00zzcfa_closurez00();
		}

	}



/* object-init */
	obj_t BGl_objectzd2initzd2zzcfa_closurez00()
	{
		{	/* Cfa/closure.scm 25 */
			return BUNSPEC;
		}

	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzcfa_closurez00()
	{
		{	/* Cfa/closure.scm 25 */
			return BUNSPEC;
		}

	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzcfa_closurez00()
	{
		{	/* Cfa/closure.scm 25 */
			return BUNSPEC;
		}

	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzcfa_closurez00()
	{
		{	/* Cfa/closure.scm 25 */
			BGl_modulezd2initializa7ationz75zztools_tracez00(((long) 54713316),
				BSTRING_TO_STRING(BGl_string2215z00zzcfa_closurez00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 476633989),
				BSTRING_TO_STRING(BGl_string2215z00zzcfa_closurez00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 515343395),
				BSTRING_TO_STRING(BGl_string2215z00zzcfa_closurez00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 346491734),
				BSTRING_TO_STRING(BGl_string2215z00zzcfa_closurez00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 365925558),
				BSTRING_TO_STRING(BGl_string2215z00zzcfa_closurez00));
			BGl_modulezd2initializa7ationz75zztools_speekz00(((long) 61247943),
				BSTRING_TO_STRING(BGl_string2215z00zzcfa_closurez00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 90839984),
				BSTRING_TO_STRING(BGl_string2215z00zzcfa_closurez00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 506185397),
				BSTRING_TO_STRING(BGl_string2215z00zzcfa_closurez00));
			BGl_modulezd2initializa7ationz75zzast_envz00(((long) 146730773),
				BSTRING_TO_STRING(BGl_string2215z00zzcfa_closurez00));
			BGl_modulezd2initializa7ationz75zzcfa_infoz00(((long) 3788352),
				BSTRING_TO_STRING(BGl_string2215z00zzcfa_closurez00));
			BGl_modulezd2initializa7ationz75zzcfa_info2z00(((long) 0),
				BSTRING_TO_STRING(BGl_string2215z00zzcfa_closurez00));
			BGl_modulezd2initializa7ationz75zzcfa_cfaz00(((long) 400853817),
				BSTRING_TO_STRING(BGl_string2215z00zzcfa_closurez00));
			BGl_modulezd2initializa7ationz75zzcfa_approxz00(((long) 468997863),
				BSTRING_TO_STRING(BGl_string2215z00zzcfa_closurez00));
			BGl_modulezd2initializa7ationz75zzcfa_setz00(((long) 21528182),
				BSTRING_TO_STRING(BGl_string2215z00zzcfa_closurez00));
			BGl_modulezd2initializa7ationz75zzcfa_ltypez00(((long) 315872512),
				BSTRING_TO_STRING(BGl_string2215z00zzcfa_closurez00));
			return
				BGl_modulezd2initializa7ationz75zzcfa_typez00(((long) 93933605),
				BSTRING_TO_STRING(BGl_string2215z00zzcfa_closurez00));
		}

	}

#ifdef __cplusplus
}
#endif
