/*===========================================================================*/
/*   (Coerce/coerce.scm)                                                     */
/*   Bigloo (4.3g)                                                           */
/*   Inria -- Sophia Antipolis (c)       Wed 12 Feb 2020 07:45:41 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.3g -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Coerce/coerce.scm) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_tclassz00_bgl
	{
		obj_t BgL_itszd2superzd2;
		obj_t BgL_slotsz00;
		struct BgL_globalz00_bgl *BgL_holderz00;
		obj_t BgL_wideningz00;
		long BgL_depthz00;
		bool_t BgL_finalzf3zf3;
		obj_t BgL_constructorz00;
		obj_t BgL_virtualzd2slotszd2numberz00;
		bool_t BgL_abstractzf3zf3;
		obj_t BgL_widezd2typezd2;
		obj_t BgL_subclassesz00;
	}                *BgL_tclassz00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		bool_t BgL_evalzf3zf3;
		obj_t BgL_libraryz00;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
		obj_t BgL_initz00;
		obj_t BgL_aliasz00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_localz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		long BgL_keyz00;
	}               *BgL_localz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
		obj_t BgL_strengthz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_atomz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}              *BgL_atomz00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_closurez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}                 *BgL_closurez00_bglt;

	typedef struct BgL_kwotez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}               *BgL_kwotez00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
		bool_t BgL_unsafez00;
		obj_t BgL_metaz00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_externz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
	}                *BgL_externz00_bglt;

	typedef struct BgL_getfieldz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
		obj_t BgL_czd2formatzd2;
		obj_t BgL_fnamez00;
		struct BgL_typez00_bgl *BgL_ftypez00;
		struct BgL_typez00_bgl *BgL_otypez00;
	}                  *BgL_getfieldz00_bglt;

	typedef struct BgL_setfieldz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
		obj_t BgL_czd2formatzd2;
		obj_t BgL_fnamez00;
		struct BgL_typez00_bgl *BgL_ftypez00;
		struct BgL_typez00_bgl *BgL_otypez00;
	}                  *BgL_setfieldz00_bglt;

	typedef struct BgL_wideningz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
		obj_t BgL_czd2formatzd2;
		struct BgL_typez00_bgl *BgL_otypez00;
	}                  *BgL_wideningz00_bglt;

	typedef struct BgL_newz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
		obj_t BgL_czd2formatzd2;
		obj_t BgL_argszd2typezd2;
	}             *BgL_newz00_bglt;

	typedef struct BgL_vallocz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
		obj_t BgL_czd2formatzd2;
		struct BgL_typez00_bgl *BgL_ftypez00;
		struct BgL_typez00_bgl *BgL_otypez00;
	}                *BgL_vallocz00_bglt;

	typedef struct BgL_vrefz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
		obj_t BgL_czd2formatzd2;
		struct BgL_typez00_bgl *BgL_ftypez00;
		struct BgL_typez00_bgl *BgL_otypez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
		bool_t BgL_unsafez00;
	}              *BgL_vrefz00_bglt;

	typedef struct BgL_vsetz12z12_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
		obj_t BgL_czd2formatzd2;
		struct BgL_typez00_bgl *BgL_ftypez00;
		struct BgL_typez00_bgl *BgL_otypez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
		bool_t BgL_unsafez00;
	}                 *BgL_vsetz12z12_bglt;

	typedef struct BgL_vlengthz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
		obj_t BgL_czd2formatzd2;
		struct BgL_typez00_bgl *BgL_vtypez00;
		obj_t BgL_ftypez00;
	}                 *BgL_vlengthz00_bglt;

	typedef struct BgL_castz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}              *BgL_castz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_failz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_procz00;
		struct BgL_nodez00_bgl *BgL_msgz00;
		struct BgL_nodez00_bgl *BgL_objz00;
	}              *BgL_failz00_bglt;

	typedef struct BgL_switchz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_switchz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;

	typedef struct BgL_setzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                       *BgL_setzd2exzd2itz00_bglt;

	typedef struct BgL_jumpzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_exitz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                        *BgL_jumpzd2exzd2itz00_bglt;

	typedef struct BgL_makezd2boxzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                    *BgL_makezd2boxzd2_bglt;

	typedef struct BgL_boxzd2refzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                   *BgL_boxzd2refzd2_bglt;

	typedef struct BgL_boxzd2setz12zc0_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                      *BgL_boxzd2setz12zc0_bglt;

	typedef struct BgL_syncz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_mutexz00;
		struct BgL_nodez00_bgl *BgL_prelockz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}              *BgL_syncz00_bglt;


	static BgL_nodez00_bglt BGl_z62coercez12z70zzcoerce_coercez00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_closurez00zzast_nodez00;
	static BgL_nodez00_bglt
		BGl_z62coercez12zd2setzd2exzd2it1330za2zzcoerce_coercez00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_za2pairzd2nilza2zd2zztype_cachez00;
	extern obj_t BGl_syncz00zzast_nodez00;
	extern obj_t BGl_sequencez00zzast_nodez00;
	static BgL_nodez00_bglt
		BGl_z62coercez12zd2vref1310za2zzcoerce_coercez00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	extern obj_t BGl_failz00zzast_nodez00;
	static BgL_castz00_bglt BGl_castzd2nodezd2zzcoerce_coercez00(BgL_nodez00_bglt,
		obj_t);
	extern obj_t BGl_deczd2ppmargez12zc0zzcoerce_pprotoz00();
	static obj_t BGl_objectzd2initzd2zzcoerce_coercez00();
	extern obj_t BGl_boxzd2refzd2zzast_nodez00;
	static BgL_nodez00_bglt
		BGl_z62coercez12zd2valloc1308za2zzcoerce_coercez00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_za2magicza2z00zztype_cachez00;
	extern obj_t BGl_pfunctionzd2protozd2zzcoerce_pprotoz00(long,
		BgL_variablez00_bglt);
	static BgL_nodez00_bglt
		BGl_z62coercez12zd2boxzd2ref1336z70zzcoerce_coercez00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_thezd2coercedzd2functionz00zzcoerce_coercez00 = BUNSPEC;
	BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	static obj_t BGl_methodzd2initzd2zzcoerce_coercez00();
	static obj_t BGl_z62coercez121283z70zzcoerce_coercez00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_externz00zzast_nodez00;
	static BgL_nodez00_bglt
		BGl_z62coercez12zd2kwote1288za2zzcoerce_coercez00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62coercezd2functionz12za2zzcoerce_coercez00(obj_t, obj_t,
		obj_t);
	static BgL_nodez00_bglt
		BGl_z62coercez12zd2getfield1302za2zzcoerce_coercez00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62coercez12zd2closure1292za2zzcoerce_coercez00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_za2_za2z00zztype_cachez00;
	extern BgL_typez00_bglt
		BGl_strictzd2nodezd2typez00zzast_nodez00(BgL_typez00_bglt,
		BgL_typez00_bglt);
	extern obj_t BGl_za2objza2z00zztype_cachez00;
	static BgL_nodez00_bglt
		BGl_z62coercez12zd2atom1286za2zzcoerce_coercez00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_coercez12z12zzcoerce_coercez00(BgL_nodez00_bglt, obj_t,
		BgL_typez00_bglt, bool_t);
	static BgL_nodez00_bglt
		BGl_z62coercez12zd2setfield1304za2zzcoerce_coercez00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_enterzd2functionzd2zztools_errorz00(obj_t);
	extern obj_t BGl_wideningz00zzast_nodez00;
	static BgL_nodez00_bglt
		BGl_z62coercez12zd2vsetz121312zb0zzcoerce_coercez00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	extern bool_t BGl_coercerzd2existszf3z21zztype_coercionz00(BgL_typez00_bglt,
		BgL_typez00_bglt);
	extern obj_t BGl_za2unsafezd2typeza2zd2zzengine_paramz00;
	static obj_t BGl_gczd2rootszd2initz00zzcoerce_coercez00();
	extern bool_t BGl_sidezd2effectzf3z21zzeffect_effectz00(BgL_nodez00_bglt);
	extern obj_t BGl_vallocz00zzast_nodez00;
	extern obj_t BGl_inczd2ppmargez12zc0zzcoerce_pprotoz00();
	static BgL_nodez00_bglt BGl_z62coercez12zd2var1290za2zzcoerce_coercez00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62coercez12zd2cast1316za2zzcoerce_coercez00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	static BgL_nodez00_bglt
		BGl_z62coercez12zd2boxzd2setz121338z62zzcoerce_coercez00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62coercez12zd2makezd2box1334z70zzcoerce_coercez00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62coercez12zd2setq1318za2zzcoerce_coercez00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_runtimezd2typezd2errorz00zzcoerce_convertz00(obj_t, obj_t,
		BgL_nodez00_bglt);
	static BgL_nodez00_bglt
		BGl_z62coercez12zd2letzd2fun1326z70zzcoerce_coercez00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_conditionalz00zzast_nodez00;
	extern BgL_nodez00_bglt BGl_convertz12z12zzcoerce_convertz00(BgL_nodez00_bglt,
		BgL_typez00_bglt, BgL_typez00_bglt, bool_t);
	extern obj_t BGl_setqz00zzast_nodez00;
	static obj_t BGl_requirezd2initializa7ationz75zzcoerce_coercez00 = BUNSPEC;
	static BgL_nodez00_bglt
		BGl_z62coercez12zd2sync1296za2zzcoerce_coercez00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_pvariablezd2protozd2zzcoerce_pprotoz00(long,
		BgL_variablez00_bglt);
	extern obj_t BGl_newz00zzast_nodez00;
	extern obj_t BGl_vlengthz00zzast_nodez00;
	extern obj_t BGl_setzd2exzd2itz00zzast_nodez00;
	extern obj_t BGl_tclassz00zzobject_classz00;
	BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_atomz00zzast_nodez00;
	static obj_t BGl_toplevelzd2initzd2zzcoerce_coercez00();
	extern obj_t BGl_internalzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_genericzd2initzd2zzcoerce_coercez00();
	extern obj_t BGl_leavezd2functionzd2zztools_errorz00();
	extern obj_t BGl_getfieldz00zzast_nodez00;
	BGL_EXPORTED_DECL obj_t
		BGl_coercezd2functionz12zc0zzcoerce_coercez00(BgL_variablez00_bglt, bool_t);
	static BgL_nodez00_bglt
		BGl_z62coercez12zd2letzd2var1328z70zzcoerce_coercez00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_za2boolza2z00zztype_cachez00;
	extern obj_t BGl_castz00zzast_nodez00;
	static BgL_nodez00_bglt
		BGl_z62coercez12zd2sequence1294za2zzcoerce_coercez00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_shapez00zztools_shapez00(obj_t);
	extern obj_t BGl_typez00zztype_typez00;
	static BgL_nodez00_bglt BGl_z62coercez12zd2new1306za2zzcoerce_coercez00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	extern obj_t BGl_za2exitza2z00zztype_cachez00;
	BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t,
		obj_t, obj_t);
	extern bool_t BGl_typezd2disjointzf3z21zztype_miscz00(BgL_typez00_bglt,
		BgL_typez00_bglt);
	extern obj_t BGl_za2mutexza2z00zztype_cachez00;
	extern obj_t BGl_varz00zzast_nodez00;
	extern BgL_typez00_bglt BGl_getzd2typezd2zztype_typeofz00(BgL_nodez00_bglt,
		bool_t);
	extern obj_t BGl_makezd2boxzd2zzast_nodez00;
	extern bool_t BGl_typezd2lesszd2specificzf3zf3zztype_miscz00(BgL_typez00_bglt,
		BgL_typez00_bglt);
	extern obj_t BGl_za2notifyzd2typezd2testza2z00zzcoerce_convertz00;
	extern obj_t BGl_boxzd2setz12zc0zzast_nodez00;
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zzcoerce_coercez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzeffect_effectz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcoerce_funcallz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcoerce_applyz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcoerce_appz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcoerce_convertz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcoerce_pprotoz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_dumpz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzobject_classz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_miscz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typeofz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_coercionz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	static BgL_nodez00_bglt
		BGl_z62coercez12zd2switch1324za2zzcoerce_coercez00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_appz00zzast_nodez00;
	extern obj_t BGl_appzd2predicatezd2ofz00zztype_miscz00(BgL_appz00_bglt);
	extern obj_t BGl_vrefz00zzast_nodez00;
	static BgL_nodez00_bglt
		BGl_z62coercez12zd2conditional1320za2zzcoerce_coercez00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	BGL_IMPORT obj_t BGl_tprintz00zz__r4_output_6_10_3z00(obj_t, obj_t);
	extern obj_t BGl_nodez00zzast_nodez00;
	extern obj_t BGl_kwotez00zzast_nodez00;
	extern obj_t BGl_jumpzd2exzd2itz00zzast_nodez00;
	static obj_t BGl_cnstzd2initzd2zzcoerce_coercez00();
	static obj_t BGl_libraryzd2moduleszd2initz00zzcoerce_coercez00();
	static BgL_nodez00_bglt
		BGl_z62coercez12zd2vlength1314za2zzcoerce_coercez00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zzcoerce_coercez00();
	static BgL_nodez00_bglt
		BGl_z62coercez12zd2extern1298za2zzcoerce_coercez00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_za2unsafezd2evalza2zd2zzengine_paramz00;
	extern obj_t BGl_letzd2funzd2zzast_nodez00;
	static BgL_nodez00_bglt
		BGl_z62coercez12zd2jumpzd2exzd2it1332za2zzcoerce_coercez00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_za2unspecza2z00zztype_cachez00;
	extern obj_t BGl_setfieldz00zzast_nodez00;
	static BgL_nodez00_bglt
		BGl_z62coercez12zd2fail1322za2zzcoerce_coercez00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_switchz00zzast_nodez00;
	extern obj_t BGl_isazd2ofzd2zztype_miscz00(BgL_nodez00_bglt);
	extern obj_t BGl_globalz00zzast_varz00;
	static BgL_nodez00_bglt
		BGl_z62coercez12zd2widening1300za2zzcoerce_coercez00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_vsetz12z12zzast_nodez00;
	static obj_t __cnst[3];


	   
		 
		DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2076z00zzcoerce_coercez00,
		BgL_bgl_za762coerceza71212832118z00,
		BGl_z62coercez121283z70zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2079z00zzcoerce_coercez00,
		BgL_bgl_za762coerceza712za7d2a2119za7,
		BGl_z62coercez12zd2atom1286za2zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2081z00zzcoerce_coercez00,
		BgL_bgl_za762coerceza712za7d2k2120za7,
		BGl_z62coercez12zd2kwote1288za2zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2082z00zzcoerce_coercez00,
		BgL_bgl_za762coerceza712za7d2v2121za7,
		BGl_z62coercez12zd2var1290za2zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2083z00zzcoerce_coercez00,
		BgL_bgl_za762coerceza712za7d2c2122za7,
		BGl_z62coercez12zd2closure1292za2zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2084z00zzcoerce_coercez00,
		BgL_bgl_za762coerceza712za7d2s2123za7,
		BGl_z62coercez12zd2sequence1294za2zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2085z00zzcoerce_coercez00,
		BgL_bgl_za762coerceza712za7d2s2124za7,
		BGl_z62coercez12zd2sync1296za2zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2086z00zzcoerce_coercez00,
		BgL_bgl_za762coerceza712za7d2e2125za7,
		BGl_z62coercez12zd2extern1298za2zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2087z00zzcoerce_coercez00,
		BgL_bgl_za762coerceza712za7d2w2126za7,
		BGl_z62coercez12zd2widening1300za2zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2088z00zzcoerce_coercez00,
		BgL_bgl_za762coerceza712za7d2g2127za7,
		BGl_z62coercez12zd2getfield1302za2zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2089z00zzcoerce_coercez00,
		BgL_bgl_za762coerceza712za7d2s2128za7,
		BGl_z62coercez12zd2setfield1304za2zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2090z00zzcoerce_coercez00,
		BgL_bgl_za762coerceza712za7d2n2129za7,
		BGl_z62coercez12zd2new1306za2zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2091z00zzcoerce_coercez00,
		BgL_bgl_za762coerceza712za7d2v2130za7,
		BGl_z62coercez12zd2valloc1308za2zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2092z00zzcoerce_coercez00,
		BgL_bgl_za762coerceza712za7d2v2131za7,
		BGl_z62coercez12zd2vref1310za2zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2093z00zzcoerce_coercez00,
		BgL_bgl_za762coerceza712za7d2v2132za7,
		BGl_z62coercez12zd2vsetz121312zb0zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2094z00zzcoerce_coercez00,
		BgL_bgl_za762coerceza712za7d2v2133za7,
		BGl_z62coercez12zd2vlength1314za2zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2095z00zzcoerce_coercez00,
		BgL_bgl_za762coerceza712za7d2c2134za7,
		BGl_z62coercez12zd2cast1316za2zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2096z00zzcoerce_coercez00,
		BgL_bgl_za762coerceza712za7d2s2135za7,
		BGl_z62coercez12zd2setq1318za2zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2097z00zzcoerce_coercez00,
		BgL_bgl_za762coerceza712za7d2c2136za7,
		BGl_z62coercez12zd2conditional1320za2zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2098z00zzcoerce_coercez00,
		BgL_bgl_za762coerceza712za7d2f2137za7,
		BGl_z62coercez12zd2fail1322za2zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2099z00zzcoerce_coercez00,
		BgL_bgl_za762coerceza712za7d2s2138za7,
		BGl_z62coercez12zd2switch1324za2zzcoerce_coercez00, 0L, BUNSPEC, 4);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_coercezd2functionz12zd2envz12zzcoerce_coercez00,
		BgL_bgl_za762coerceza7d2func2139z00,
		BGl_z62coercezd2functionz12za2zzcoerce_coercez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2100z00zzcoerce_coercez00,
		BgL_bgl_za762coerceza712za7d2l2140za7,
		BGl_z62coercez12zd2letzd2fun1326z70zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2101z00zzcoerce_coercez00,
		BgL_bgl_za762coerceza712za7d2l2141za7,
		BGl_z62coercez12zd2letzd2var1328z70zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2102z00zzcoerce_coercez00,
		BgL_bgl_za762coerceza712za7d2s2142za7,
		BGl_z62coercez12zd2setzd2exzd2it1330za2zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2103z00zzcoerce_coercez00,
		BgL_bgl_za762coerceza712za7d2j2143za7,
		BGl_z62coercez12zd2jumpzd2exzd2it1332za2zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2104z00zzcoerce_coercez00,
		BgL_bgl_za762coerceza712za7d2m2144za7,
		BGl_z62coercez12zd2makezd2box1334z70zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2105z00zzcoerce_coercez00,
		BgL_bgl_za762coerceza712za7d2b2145za7,
		BGl_z62coercez12zd2boxzd2ref1336z70zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2106z00zzcoerce_coercez00,
		BgL_bgl_za762coerceza712za7d2b2146za7,
		BGl_z62coercez12zd2boxzd2setz121338z62zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STRING(BGl_string2077z00zzcoerce_coercez00,
		BgL_bgl_string2077za700za7za7c2147za7, "coerce!1283", 11);
	      DEFINE_STRING(BGl_string2078z00zzcoerce_coercez00,
		BgL_bgl_string2078za700za7za7c2148za7, "No method for this object", 25);
	      DEFINE_STRING(BGl_string2080z00zzcoerce_coercez00,
		BgL_bgl_string2080za700za7za7c2149za7, "coerce!", 7);
	      DEFINE_EXPORT_BGL_GENERIC(BGl_coercez12zd2envzc0zzcoerce_coercez00,
		BgL_bgl_za762coerceza712za770za72150z00,
		BGl_z62coercez12z70zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STRING(BGl_string2107z00zzcoerce_coercez00,
		BgL_bgl_string2107za700za7za7c2151za7, " test-node-type=", 16);
	      DEFINE_STRING(BGl_string2108z00zzcoerce_coercez00,
		BgL_bgl_string2108za700za7za7c2152za7, "switch test-type=", 17);
	      DEFINE_STRING(BGl_string2109z00zzcoerce_coercez00,
		BgL_bgl_string2109za700za7za7c2153za7, ":", 1);
	      DEFINE_STRING(BGl_string2110z00zzcoerce_coercez00,
		BgL_bgl_string2110za700za7za7c2154za7, ",", 1);
	      DEFINE_STRING(BGl_string2111z00zzcoerce_coercez00,
		BgL_bgl_string2111za700za7za7c2155za7, "Coerce/coerce.scm", 17);
	      DEFINE_STRING(BGl_string2112z00zzcoerce_coercez00,
		BgL_bgl_string2112za700za7za7c2156za7, "Unexepected `closure' node", 26);
	      DEFINE_STRING(BGl_string2113z00zzcoerce_coercez00,
		BgL_bgl_string2113za700za7za7c2157za7, "coerce_coerce", 13);
	      DEFINE_STRING(BGl_string2114z00zzcoerce_coercez00,
		BgL_bgl_string2114za700za7za7c2158za7, "false true coerce!1283 ", 23);

/* GC roots registration */
	static obj_t bgl_gc_roots_register()
	{
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
		void *roots_min = (void *) ULONG_MAX, *roots_max = 0;
		   
			 ADD_ROOT((void *) (&BGl_thezd2coercedzd2functionz00zzcoerce_coercez00));
		   
			 ADD_ROOT((void
				*) (&BGl_requirezd2initializa7ationz75zzcoerce_coercez00));
#undef ADD_ROOT
		if   (roots_max > 0)
			     GC_add_roots(roots_min, ((void **) roots_max) + 1);
#endif
		     return BUNSPEC;
	}



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzcoerce_coercez00(long
		BgL_checksumz00_3084, char *BgL_fromz00_3085)
	{
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzcoerce_coercez00))
				{
					BGl_requirezd2initializa7ationz75zzcoerce_coercez00 =
						BBOOL(((bool_t) 0));
					BGl_gczd2rootszd2initz00zzcoerce_coercez00();
					BGl_libraryzd2moduleszd2initz00zzcoerce_coercez00();
					BGl_cnstzd2initzd2zzcoerce_coercez00();
					BGl_importedzd2moduleszd2initz00zzcoerce_coercez00();
					BGl_genericzd2initzd2zzcoerce_coercez00();
					BGl_methodzd2initzd2zzcoerce_coercez00();
					return BGl_toplevelzd2initzd2zzcoerce_coercez00();
				}
			else
				{
					return BUNSPEC;
				}
		}

	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzcoerce_coercez00()
	{
		{	/* Coerce/coerce.scm 15 */
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0),
				"coerce_coerce");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "coerce_coerce");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0),
				"coerce_coerce");
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 0),
				"coerce_coerce");
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long) 0),
				"coerce_coerce");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"coerce_coerce");
			BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long) 0),
				"coerce_coerce");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"coerce_coerce");
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 0),
				"coerce_coerce");
			BGl_modulezd2initializa7ationz75zz__bitz00(((long) 0), "coerce_coerce");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long) 0),
				"coerce_coerce");
			return BUNSPEC;
		}

	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzcoerce_coercez00()
	{
		{	/* Coerce/coerce.scm 15 */
			{	/* Coerce/coerce.scm 15 */
				obj_t BgL_cportz00_2819;

				{	/* Coerce/coerce.scm 15 */
					obj_t BgL_stringz00_2827;

					BgL_stringz00_2827 = BGl_string2114z00zzcoerce_coercez00;
					{	/* Coerce/coerce.scm 15 */
						obj_t BgL_startz00_2828;

						BgL_startz00_2828 = BINT(((long) 0));
						{	/* Coerce/coerce.scm 15 */
							obj_t BgL_endz00_2829;

							BgL_endz00_2829 =
								BINT(STRING_LENGTH(((obj_t) BgL_stringz00_2827)));
							{	/* Coerce/coerce.scm 15 */

								BgL_cportz00_2819 =
									BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00
									(BgL_stringz00_2827, BgL_startz00_2828, BgL_endz00_2829);
				}}}}
				{
					long BgL_iz00_2820;

					BgL_iz00_2820 = ((long) 2);
				BgL_loopz00_2821:
					if ((BgL_iz00_2820 == ((long) -1)))
						{	/* Coerce/coerce.scm 15 */
							return BUNSPEC;
						}
					else
						{	/* Coerce/coerce.scm 15 */
							{	/* Coerce/coerce.scm 15 */
								obj_t BgL_arg2116z00_2823;

								{	/* Coerce/coerce.scm 15 */

									{	/* Coerce/coerce.scm 15 */
										obj_t BgL_locationz00_2825;

										BgL_locationz00_2825 = BBOOL(((bool_t) 0));
										{	/* Coerce/coerce.scm 15 */

											BgL_arg2116z00_2823 =
												BGl_readz00zz__readerz00(BgL_cportz00_2819,
												BgL_locationz00_2825);
										}
									}
								}
								{	/* Coerce/coerce.scm 15 */
									int BgL_tmpz00_3116;

									BgL_tmpz00_3116 = (int) (BgL_iz00_2820);
									CNST_TABLE_SET(BgL_tmpz00_3116, BgL_arg2116z00_2823);
							}}
							{	/* Coerce/coerce.scm 15 */
								int BgL_auxz00_2826;

								BgL_auxz00_2826 = (int) ((BgL_iz00_2820 - ((long) 1)));
								{
									long BgL_iz00_3121;

									BgL_iz00_3121 = (long) (BgL_auxz00_2826);
									BgL_iz00_2820 = BgL_iz00_3121;
									goto BgL_loopz00_2821;
								}
							}
						}
				}
			}
		}

	}



/* gc-roots-init */
	obj_t BGl_gczd2rootszd2initz00zzcoerce_coercez00()
	{
		{	/* Coerce/coerce.scm 15 */
			return bgl_gc_roots_register();
		}

	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzcoerce_coercez00()
	{
		{	/* Coerce/coerce.scm 15 */
			BGl_thezd2coercedzd2functionz00zzcoerce_coercez00 = BUNSPEC;
			return BUNSPEC;
		}

	}



/* coerce-function! */
	BGL_EXPORTED_DEF obj_t
		BGl_coercezd2functionz12zc0zzcoerce_coercez00(BgL_variablez00_bglt
		BgL_variablez00_3, bool_t BgL_typezd2safezd2_4)
	{
		{	/* Coerce/coerce.scm 46 */
			BGl_enterzd2functionzd2zztools_errorz00(
				(((BgL_variablez00_bglt) COBJECT(BgL_variablez00_3))->BgL_idz00));
			{	/* Coerce/coerce.scm 49 */
				BgL_valuez00_bglt BgL_funz00_1638;

				BgL_funz00_1638 =
					(((BgL_variablez00_bglt) COBJECT(BgL_variablez00_3))->BgL_valuez00);
				{	/* Coerce/coerce.scm 49 */
					obj_t BgL_bodyz00_1639;

					BgL_bodyz00_1639 =
						(((BgL_sfunz00_bglt) COBJECT(
								((BgL_sfunz00_bglt) BgL_funz00_1638)))->BgL_bodyz00);
					{	/* Coerce/coerce.scm 50 */
						BgL_typez00_bglt BgL_tresz00_1640;

						BgL_tresz00_1640 =
							(((BgL_variablez00_bglt) COBJECT(BgL_variablez00_3))->
							BgL_typez00);
						{	/* Coerce/coerce.scm 51 */
							obj_t BgL_cloz00_1641;

							BgL_cloz00_1641 =
								(((BgL_sfunz00_bglt) COBJECT(
										((BgL_sfunz00_bglt) BgL_funz00_1638)))->
								BgL_thezd2closurezd2globalz00);
							{	/* Coerce/coerce.scm 52 */
								bool_t BgL_typezd2safetyzd2enforcedz00_1642;

								{	/* Coerce/coerce.scm 53 */
									obj_t BgL__andtest_1107z00_1652;

									BgL__andtest_1107z00_1652 =
										BGl_za2unsafezd2evalza2zd2zzengine_paramz00;
									if (CBOOL(BgL__andtest_1107z00_1652))
										{	/* Coerce/coerce.scm 53 */
											BgL_typezd2safetyzd2enforcedz00_1642 = ((bool_t) 0);
										}
									else
										{	/* Coerce/coerce.scm 54 */
											bool_t BgL_test2162z00_3134;

											{	/* Coerce/coerce.scm 54 */
												bool_t BgL_res2029z00_2432;

												BgL_res2029z00_2432 =
													BGl_isazf3zf3zz__objectz00(
													((obj_t) BgL_variablez00_3),
													BGl_globalz00zzast_varz00);
												BgL_test2162z00_3134 = BgL_res2029z00_2432;
											}
											if (BgL_test2162z00_3134)
												{	/* Coerce/coerce.scm 54 */
													if (BGl_isazf3zf3zz__objectz00(BgL_cloz00_1641,
															BGl_globalz00zzast_varz00))
														{	/* Coerce/coerce.scm 55 */
															if (
																(((BgL_globalz00_bglt) COBJECT(
																			((BgL_globalz00_bglt) BgL_cloz00_1641)))->
																	BgL_evaluablezf3zf3))
																{	/* Coerce/coerce.scm 56 */
																	BgL_typezd2safetyzd2enforcedz00_1642 =
																		(((BgL_variablez00_bglt) COBJECT(
																				((BgL_variablez00_bglt)
																					((BgL_globalz00_bglt)
																						BgL_cloz00_1641))))->
																		BgL_userzf3zf3);
																}
															else
																{	/* Coerce/coerce.scm 56 */
																	BgL_typezd2safetyzd2enforcedz00_1642 =
																		((bool_t) 0);
																}
														}
													else
														{	/* Coerce/coerce.scm 55 */
															BgL_typezd2safetyzd2enforcedz00_1642 =
																((bool_t) 0);
														}
												}
											else
												{	/* Coerce/coerce.scm 54 */
													BgL_typezd2safetyzd2enforcedz00_1642 = ((bool_t) 0);
												}
										}
								}
								{	/* Coerce/coerce.scm 58 */

									{	/* Coerce/coerce.scm 59 */
										bool_t BgL_test2165z00_3145;

										{	/* Coerce/coerce.scm 59 */
											bool_t BgL_res2031z00_2436;

											BgL_res2031z00_2436 =
												BGl_isazf3zf3zz__objectz00(
												((obj_t) BgL_variablez00_3), BGl_globalz00zzast_varz00);
											BgL_test2165z00_3145 = BgL_res2031z00_2436;
										}
										if (BgL_test2165z00_3145)
											{	/* Coerce/coerce.scm 59 */
												BNIL;
											}
										else
											{	/* Coerce/coerce.scm 59 */
												BNIL;
											}
									}
									{	/* Coerce/coerce.scm 67 */
										obj_t BgL_notifyz00_1645;

										BgL_notifyz00_1645 =
											BGl_za2notifyzd2typezd2testza2z00zzcoerce_convertz00;
										if ((((BgL_variablez00_bglt) COBJECT(BgL_variablez00_3))->
												BgL_userzf3zf3))
											{	/* Coerce/coerce.scm 70 */
												bool_t BgL_test2167z00_3150;

												{	/* Coerce/coerce.scm 70 */
													obj_t BgL_arg1399z00_1649;

													BgL_arg1399z00_1649 =
														(((BgL_sfunz00_bglt) COBJECT(
																((BgL_sfunz00_bglt) BgL_funz00_1638)))->
														BgL_thezd2closurezd2globalz00);
													BgL_test2167z00_3150 =
														BGl_isazf3zf3zz__objectz00(BgL_arg1399z00_1649,
														BGl_globalz00zzast_varz00);
												}
												if (BgL_test2167z00_3150)
													{	/* Coerce/coerce.scm 70 */
														BGl_za2notifyzd2typezd2testza2z00zzcoerce_convertz00
															= BFALSE;
													}
												else
													{	/* Coerce/coerce.scm 70 */
														BGl_za2notifyzd2typezd2testza2z00zzcoerce_convertz00
															= BTRUE;
													}
											}
										else
											{	/* Coerce/coerce.scm 69 */
												BGl_za2notifyzd2typezd2testza2z00zzcoerce_convertz00 =
													BFALSE;
											}
										BGl_pfunctionzd2protozd2zzcoerce_pprotoz00(((long) 3),
											BgL_variablez00_3);
										BGl_thezd2coercedzd2functionz00zzcoerce_coercez00 =
											((obj_t) BgL_variablez00_3);
										{	/* Coerce/coerce.scm 73 */
											BgL_nodez00_bglt BgL_arg1406z00_1650;

											{	/* Coerce/coerce.scm 73 */
												bool_t BgL_auxz00_3156;

												if (BgL_typezd2safezd2_4)
													{	/* Coerce/coerce.scm 58 */
														BgL_auxz00_3156 = BgL_typezd2safezd2_4;
													}
												else
													{	/* Coerce/coerce.scm 58 */
														BgL_auxz00_3156 =
															BgL_typezd2safetyzd2enforcedz00_1642;
													}
												BgL_arg1406z00_1650 =
													BGl_coercez12z12zzcoerce_coercez00(
													((BgL_nodez00_bglt) BgL_bodyz00_1639),
													((obj_t) BgL_variablez00_3), BgL_tresz00_1640,
													BgL_auxz00_3156);
											}
											((((BgL_sfunz00_bglt) COBJECT(
															((BgL_sfunz00_bglt) BgL_funz00_1638)))->
													BgL_bodyz00) =
												((obj_t) ((obj_t) BgL_arg1406z00_1650)), BUNSPEC);
										}
										BGl_za2notifyzd2typezd2testza2z00zzcoerce_convertz00 =
											BgL_notifyz00_1645;
									}
									return BGl_leavezd2functionzd2zztools_errorz00();
								}
							}
						}
					}
				}
			}
		}

	}



/* &coerce-function! */
	obj_t BGl_z62coercezd2functionz12za2zzcoerce_coercez00(obj_t BgL_envz00_2643,
		obj_t BgL_variablez00_2644, obj_t BgL_typezd2safezd2_2645)
	{
		{	/* Coerce/coerce.scm 46 */
			return
				BGl_coercezd2functionz12zc0zzcoerce_coercez00(
				((BgL_variablez00_bglt) BgL_variablez00_2644),
				CBOOL(BgL_typezd2safezd2_2645));
		}

	}



/* cast-node */
	BgL_castz00_bglt BGl_castzd2nodezd2zzcoerce_coercez00(BgL_nodez00_bglt
		BgL_nodez00_105, obj_t BgL_toz00_106)
	{
		{	/* Coerce/coerce.scm 490 */
			{	/* Coerce/coerce.scm 492 */
				BgL_castz00_bglt BgL_new1149z00_1657;

				{	/* Coerce/coerce.scm 493 */
					BgL_castz00_bglt BgL_new1148z00_1658;

					BgL_new1148z00_1658 =
						((BgL_castz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_castz00_bgl))));
					{	/* Coerce/coerce.scm 493 */
						long BgL_arg1408z00_1659;

						{	/* Coerce/coerce.scm 493 */
							long BgL_res2033z00_2442;

							BgL_res2033z00_2442 = BGL_CLASS_INDEX(BGl_castz00zzast_nodez00);
							BgL_arg1408z00_1659 = BgL_res2033z00_2442;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1148z00_1658), BgL_arg1408z00_1659);
					}
					{	/* Coerce/coerce.scm 493 */
						BgL_objectz00_bglt BgL_tmpz00_3172;

						BgL_tmpz00_3172 = ((BgL_objectz00_bglt) BgL_new1148z00_1658);
						BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3172, BFALSE);
					}
					((BgL_objectz00_bglt) BgL_new1148z00_1658);
					BgL_new1149z00_1657 = BgL_new1148z00_1658;
				}
				((((BgL_nodez00_bglt) COBJECT(
								((BgL_nodez00_bglt) BgL_new1149z00_1657)))->BgL_locz00) =
					((obj_t) (((BgL_nodez00_bglt) COBJECT(BgL_nodez00_105))->BgL_locz00)),
					BUNSPEC);
				((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
									BgL_new1149z00_1657)))->BgL_typez00) =
					((BgL_typez00_bglt) ((BgL_typez00_bglt) BgL_toz00_106)), BUNSPEC);
				((((BgL_castz00_bglt) COBJECT(BgL_new1149z00_1657))->BgL_argz00) =
					((BgL_nodez00_bglt) BgL_nodez00_105), BUNSPEC);
				return BgL_new1149z00_1657;
			}
		}

	}



/* object-init */
	obj_t BGl_objectzd2initzd2zzcoerce_coercez00()
	{
		{	/* Coerce/coerce.scm 15 */
			return BUNSPEC;
		}

	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzcoerce_coercez00()
	{
		{	/* Coerce/coerce.scm 15 */
			return
				BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00,
				BGl_proc2076z00zzcoerce_coercez00, BGl_nodez00zzast_nodez00,
				BGl_string2077z00zzcoerce_coercez00);
		}

	}



/* &coerce!1283 */
	obj_t BGl_z62coercez121283z70zzcoerce_coercez00(obj_t BgL_envz00_2647,
		obj_t BgL_nodez00_2648, obj_t BgL_callerz00_2649, obj_t BgL_toz00_2650,
		obj_t BgL_safez00_2651)
	{
		{	/* Coerce/coerce.scm 80 */
			return
				BGl_errorz00zz__errorz00(CNST_TABLE_REF(((long) 0)),
				BGl_string2078z00zzcoerce_coercez00,
				((obj_t) ((BgL_nodez00_bglt) BgL_nodez00_2648)));
		}

	}



/* coerce! */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_coercez12z12zzcoerce_coercez00(BgL_nodez00_bglt BgL_nodez00_5,
		obj_t BgL_callerz00_6, BgL_typez00_bglt BgL_toz00_7, bool_t BgL_safez00_8)
	{
		{	/* Coerce/coerce.scm 80 */
			{	/* Coerce/coerce.scm 80 */
				obj_t BgL_method1284z00_1667;

				{	/* Coerce/coerce.scm 80 */
					obj_t BgL_res2044z00_2482;

					{	/* Coerce/coerce.scm 80 */
						long BgL_objzd2classzd2numz00_2447;

						{	/* Coerce/coerce.scm 80 */
							long BgL_res2034z00_2450;

							BgL_res2034z00_2450 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nodez00_5));
							BgL_objzd2classzd2numz00_2447 = BgL_res2034z00_2450;
						}
						{	/* Coerce/coerce.scm 80 */
							obj_t BgL_arg1741z00_2448;

							BgL_arg1741z00_2448 =
								PROCEDURE_REF(BGl_coercez12zd2envzc0zzcoerce_coercez00,
								(int) (((long) 1)));
							{	/* Coerce/coerce.scm 80 */
								int BgL_offsetz00_2452;

								BgL_offsetz00_2452 = (int) (BgL_objzd2classzd2numz00_2447);
								{	/* Coerce/coerce.scm 80 */
									long BgL_offsetz00_2453;

									BgL_offsetz00_2453 =
										((long) (BgL_offsetz00_2452) - OBJECT_TYPE);
									{	/* Coerce/coerce.scm 80 */
										long BgL_modz00_2454;

										BgL_modz00_2454 =
											(BgL_offsetz00_2453 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Coerce/coerce.scm 80 */
											long BgL_restz00_2456;

											BgL_restz00_2456 =
												(BgL_offsetz00_2453 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Coerce/coerce.scm 80 */

												{	/* Coerce/coerce.scm 80 */
													obj_t BgL_bucketz00_2458;

													BgL_bucketz00_2458 =
														VECTOR_REF(
														((obj_t) BgL_arg1741z00_2448), BgL_modz00_2454);
													BgL_res2044z00_2482 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_2458), BgL_restz00_2456);
					}}}}}}}}
					BgL_method1284z00_1667 = BgL_res2044z00_2482;
				}
				return
					((BgL_nodez00_bglt)
					PROCEDURE_ENTRY(BgL_method1284z00_1667) (BgL_method1284z00_1667,
						((obj_t) BgL_nodez00_5), BgL_callerz00_6,
						((obj_t) BgL_toz00_7), BBOOL(BgL_safez00_8), BEOA));
			}
		}

	}



/* &coerce! */
	BgL_nodez00_bglt BGl_z62coercez12z70zzcoerce_coercez00(obj_t BgL_envz00_2652,
		obj_t BgL_nodez00_2653, obj_t BgL_callerz00_2654, obj_t BgL_toz00_2655,
		obj_t BgL_safez00_2656)
	{
		{	/* Coerce/coerce.scm 80 */
			return
				BGl_coercez12z12zzcoerce_coercez00(
				((BgL_nodez00_bglt) BgL_nodez00_2653), BgL_callerz00_2654,
				((BgL_typez00_bglt) BgL_toz00_2655), CBOOL(BgL_safez00_2656));
		}

	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzcoerce_coercez00()
	{
		{	/* Coerce/coerce.scm 15 */
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_atomz00zzast_nodez00,
				BGl_proc2079z00zzcoerce_coercez00, BGl_string2080z00zzcoerce_coercez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_kwotez00zzast_nodez00,
				BGl_proc2081z00zzcoerce_coercez00, BGl_string2080z00zzcoerce_coercez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_varz00zzast_nodez00,
				BGl_proc2082z00zzcoerce_coercez00, BGl_string2080z00zzcoerce_coercez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_closurez00zzast_nodez00,
				BGl_proc2083z00zzcoerce_coercez00, BGl_string2080z00zzcoerce_coercez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_sequencez00zzast_nodez00,
				BGl_proc2084z00zzcoerce_coercez00, BGl_string2080z00zzcoerce_coercez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_syncz00zzast_nodez00,
				BGl_proc2085z00zzcoerce_coercez00, BGl_string2080z00zzcoerce_coercez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_externz00zzast_nodez00,
				BGl_proc2086z00zzcoerce_coercez00, BGl_string2080z00zzcoerce_coercez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_wideningz00zzast_nodez00,
				BGl_proc2087z00zzcoerce_coercez00, BGl_string2080z00zzcoerce_coercez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_getfieldz00zzast_nodez00,
				BGl_proc2088z00zzcoerce_coercez00, BGl_string2080z00zzcoerce_coercez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_setfieldz00zzast_nodez00,
				BGl_proc2089z00zzcoerce_coercez00, BGl_string2080z00zzcoerce_coercez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_newz00zzast_nodez00,
				BGl_proc2090z00zzcoerce_coercez00, BGl_string2080z00zzcoerce_coercez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_vallocz00zzast_nodez00,
				BGl_proc2091z00zzcoerce_coercez00, BGl_string2080z00zzcoerce_coercez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_vrefz00zzast_nodez00,
				BGl_proc2092z00zzcoerce_coercez00, BGl_string2080z00zzcoerce_coercez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_vsetz12z12zzast_nodez00,
				BGl_proc2093z00zzcoerce_coercez00, BGl_string2080z00zzcoerce_coercez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_vlengthz00zzast_nodez00,
				BGl_proc2094z00zzcoerce_coercez00, BGl_string2080z00zzcoerce_coercez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_castz00zzast_nodez00,
				BGl_proc2095z00zzcoerce_coercez00, BGl_string2080z00zzcoerce_coercez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_setqz00zzast_nodez00,
				BGl_proc2096z00zzcoerce_coercez00, BGl_string2080z00zzcoerce_coercez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00,
				BGl_conditionalz00zzast_nodez00, BGl_proc2097z00zzcoerce_coercez00,
				BGl_string2080z00zzcoerce_coercez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_failz00zzast_nodez00,
				BGl_proc2098z00zzcoerce_coercez00, BGl_string2080z00zzcoerce_coercez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_switchz00zzast_nodez00,
				BGl_proc2099z00zzcoerce_coercez00, BGl_string2080z00zzcoerce_coercez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00,
				BGl_letzd2funzd2zzast_nodez00, BGl_proc2100z00zzcoerce_coercez00,
				BGl_string2080z00zzcoerce_coercez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc2101z00zzcoerce_coercez00,
				BGl_string2080z00zzcoerce_coercez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00,
				BGl_setzd2exzd2itz00zzast_nodez00, BGl_proc2102z00zzcoerce_coercez00,
				BGl_string2080z00zzcoerce_coercez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00,
				BGl_jumpzd2exzd2itz00zzast_nodez00, BGl_proc2103z00zzcoerce_coercez00,
				BGl_string2080z00zzcoerce_coercez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00,
				BGl_makezd2boxzd2zzast_nodez00, BGl_proc2104z00zzcoerce_coercez00,
				BGl_string2080z00zzcoerce_coercez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00,
				BGl_boxzd2refzd2zzast_nodez00, BGl_proc2105z00zzcoerce_coercez00,
				BGl_string2080z00zzcoerce_coercez00);
			return
				BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00,
				BGl_boxzd2setz12zc0zzast_nodez00, BGl_proc2106z00zzcoerce_coercez00,
				BGl_string2080z00zzcoerce_coercez00);
		}

	}



/* &coerce!-box-set!1338 */
	BgL_nodez00_bglt
		BGl_z62coercez12zd2boxzd2setz121338z62zzcoerce_coercez00(obj_t
		BgL_envz00_2684, obj_t BgL_nodez00_2685, obj_t BgL_callerz00_2686,
		obj_t BgL_toz00_2687, obj_t BgL_safez00_2688)
	{
		{	/* Coerce/coerce.scm 521 */
			{	/* Coerce/coerce.scm 523 */
				BgL_nodez00_bglt BgL_vtz00_2836;

				BgL_vtz00_2836 =
					BGl_coercez12z12zzcoerce_coercez00(
					(((BgL_boxzd2setz12zc0_bglt) COBJECT(
								((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_2685)))->BgL_valuez00),
					BgL_callerz00_2686,
					(((BgL_boxzd2setz12zc0_bglt) COBJECT(((BgL_boxzd2setz12zc0_bglt)
									BgL_nodez00_2685)))->BgL_vtypez00), CBOOL(BgL_safez00_2688));
				((((BgL_boxzd2setz12zc0_bglt) COBJECT(((BgL_boxzd2setz12zc0_bglt)
									BgL_nodez00_2685)))->BgL_valuez00) =
					((BgL_nodez00_bglt) BGl_coercez12z12zzcoerce_coercez00(BgL_vtz00_2836,
							BgL_callerz00_2686,
							((BgL_typez00_bglt) BGl_za2objza2z00zztype_cachez00),
							CBOOL(BgL_safez00_2688))), BUNSPEC);
			}
			{	/* Coerce/coerce.scm 525 */
				BgL_typez00_bglt BgL_arg1959z00_2837;

				BgL_arg1959z00_2837 =
					(((BgL_nodez00_bglt) COBJECT(
							((BgL_nodez00_bglt)
								((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_2685))))->BgL_typez00);
				return
					BGl_convertz12z12zzcoerce_convertz00(
					((BgL_nodez00_bglt)
						((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_2685)), BgL_arg1959z00_2837,
					((BgL_typez00_bglt) BgL_toz00_2687), CBOOL(BgL_safez00_2688));
			}
		}

	}



/* &coerce!-box-ref1336 */
	BgL_nodez00_bglt BGl_z62coercez12zd2boxzd2ref1336z70zzcoerce_coercez00(obj_t
		BgL_envz00_2689, obj_t BgL_nodez00_2690, obj_t BgL_callerz00_2691,
		obj_t BgL_toz00_2692, obj_t BgL_safez00_2693)
	{
		{	/* Coerce/coerce.scm 511 */
			{	/* Coerce/coerce.scm 513 */
				BgL_nodez00_bglt BgL_cnodez00_2839;

				{	/* Coerce/coerce.scm 513 */
					BgL_typez00_bglt BgL_arg1956z00_2840;

					BgL_arg1956z00_2840 =
						(((BgL_boxzd2refzd2_bglt) COBJECT(
								((BgL_boxzd2refzd2_bglt) BgL_nodez00_2690)))->BgL_vtypez00);
					BgL_cnodez00_2839 =
						BGl_convertz12z12zzcoerce_convertz00(
						((BgL_nodez00_bglt)
							((BgL_boxzd2refzd2_bglt) BgL_nodez00_2690)), BgL_arg1956z00_2840,
						((BgL_typez00_bglt) BgL_toz00_2692), CBOOL(BgL_safez00_2693));
				}
				if (BGl_isazf3zf3zz__objectz00(BgL_toz00_2692,
						BGl_tclassz00zzobject_classz00))
					{	/* Coerce/coerce.scm 514 */
						return
							((BgL_nodez00_bglt)
							BGl_castzd2nodezd2zzcoerce_coercez00(BgL_cnodez00_2839,
								BgL_toz00_2692));
					}
				else
					{	/* Coerce/coerce.scm 514 */
						return BgL_cnodez00_2839;
					}
			}
		}

	}



/* &coerce!-make-box1334 */
	BgL_nodez00_bglt BGl_z62coercez12zd2makezd2box1334z70zzcoerce_coercez00(obj_t
		BgL_envz00_2694, obj_t BgL_nodez00_2695, obj_t BgL_callerz00_2696,
		obj_t BgL_toz00_2697, obj_t BgL_safez00_2698)
	{
		{	/* Coerce/coerce.scm 500 */
			{	/* Coerce/coerce.scm 502 */
				BgL_nodez00_bglt BgL_nodevz00_2842;

				BgL_nodevz00_2842 =
					BGl_coercez12z12zzcoerce_coercez00(
					(((BgL_makezd2boxzd2_bglt) COBJECT(
								((BgL_makezd2boxzd2_bglt) BgL_nodez00_2695)))->BgL_valuez00),
					BgL_callerz00_2696,
					(((BgL_makezd2boxzd2_bglt) COBJECT(((BgL_makezd2boxzd2_bglt)
									BgL_nodez00_2695)))->BgL_vtypez00), CBOOL(BgL_safez00_2698));
				{	/* Coerce/coerce.scm 503 */
					bool_t BgL_test2170z00_3291;

					{	/* Coerce/coerce.scm 503 */
						BgL_typez00_bglt BgL_arg1950z00_2843;

						BgL_arg1950z00_2843 =
							BGl_getzd2typezd2zztype_typeofz00(BgL_nodevz00_2842,
							((bool_t) 0));
						{	/* Coerce/coerce.scm 503 */
							bool_t BgL_res2074z00_2844;

							BgL_res2074z00_2844 =
								BGl_isazf3zf3zz__objectz00(
								((obj_t) BgL_arg1950z00_2843), BGl_tclassz00zzobject_classz00);
							BgL_test2170z00_3291 = BgL_res2074z00_2844;
						}
					}
					if (BgL_test2170z00_3291)
						{	/* Coerce/coerce.scm 503 */
							((((BgL_makezd2boxzd2_bglt) COBJECT(
											((BgL_makezd2boxzd2_bglt) BgL_nodez00_2695)))->
									BgL_valuez00) =
								((BgL_nodez00_bglt) ((BgL_nodez00_bglt)
										BGl_castzd2nodezd2zzcoerce_coercez00(BgL_nodevz00_2842,
											BGl_za2objza2z00zztype_cachez00))), BUNSPEC);
						}
					else
						{	/* Coerce/coerce.scm 503 */
							((((BgL_makezd2boxzd2_bglt) COBJECT(
											((BgL_makezd2boxzd2_bglt) BgL_nodez00_2695)))->
									BgL_valuez00) =
								((BgL_nodez00_bglt) BgL_nodevz00_2842), BUNSPEC);
						}
				}
			}
			return ((BgL_nodez00_bglt) ((BgL_makezd2boxzd2_bglt) BgL_nodez00_2695));
		}

	}



/* &coerce!-jump-ex-it1332 */
	BgL_nodez00_bglt
		BGl_z62coercez12zd2jumpzd2exzd2it1332za2zzcoerce_coercez00(obj_t
		BgL_envz00_2699, obj_t BgL_nodez00_2700, obj_t BgL_callerz00_2701,
		obj_t BgL_toz00_2702, obj_t BgL_safez00_2703)
	{
		{	/* Coerce/coerce.scm 481 */
			{
				BgL_nodez00_bglt BgL_auxz00_3303;

				{	/* Coerce/coerce.scm 483 */
					BgL_nodez00_bglt BgL_arg1943z00_2846;

					BgL_arg1943z00_2846 =
						(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
								((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_2700)))->BgL_exitz00);
					BgL_auxz00_3303 =
						BGl_coercez12z12zzcoerce_coercez00(BgL_arg1943z00_2846,
						BgL_callerz00_2701,
						((BgL_typez00_bglt) BGl_za2exitza2z00zztype_cachez00),
						CBOOL(BgL_safez00_2703));
				}
				((((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
								((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_2700)))->
						BgL_exitz00) = ((BgL_nodez00_bglt) BgL_auxz00_3303), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_3311;

				{	/* Coerce/coerce.scm 484 */
					BgL_nodez00_bglt BgL_arg1944z00_2847;
					BgL_typez00_bglt BgL_arg1945z00_2848;

					BgL_arg1944z00_2847 =
						(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
								((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_2700)))->
						BgL_valuez00);
					{	/* Coerce/coerce.scm 484 */
						BgL_nodez00_bglt BgL_arg1946z00_2849;

						BgL_arg1946z00_2849 =
							(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
									((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_2700)))->
							BgL_valuez00);
						BgL_arg1945z00_2848 =
							BGl_getzd2typezd2zztype_typeofz00(BgL_arg1946z00_2849,
							((bool_t) 0));
					}
					BgL_auxz00_3311 =
						BGl_coercez12z12zzcoerce_coercez00(BgL_arg1944z00_2847,
						BgL_callerz00_2701, BgL_arg1945z00_2848, CBOOL(BgL_safez00_2703));
				}
				((((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
								((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_2700)))->
						BgL_valuez00) = ((BgL_nodez00_bglt) BgL_auxz00_3311), BUNSPEC);
			}
			{	/* Coerce/coerce.scm 485 */
				BgL_typez00_bglt BgL_arg1947z00_2850;

				BgL_arg1947z00_2850 =
					(((BgL_nodez00_bglt) COBJECT(
							((BgL_nodez00_bglt)
								((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_2700))))->
					BgL_typez00);
				return
					BGl_convertz12z12zzcoerce_convertz00(((BgL_nodez00_bglt) (
							(BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_2700)),
					BgL_arg1947z00_2850, ((BgL_typez00_bglt) BgL_toz00_2702),
					CBOOL(BgL_safez00_2703));
			}
		}

	}



/* &coerce!-set-ex-it1330 */
	BgL_nodez00_bglt
		BGl_z62coercez12zd2setzd2exzd2it1330za2zzcoerce_coercez00(obj_t
		BgL_envz00_2704, obj_t BgL_nodez00_2705, obj_t BgL_callerz00_2706,
		obj_t BgL_toz00_2707, obj_t BgL_safez00_2708)
	{
		{	/* Coerce/coerce.scm 471 */
			{
				BgL_varz00_bglt BgL_auxz00_3329;

				{	/* Coerce/coerce.scm 473 */
					BgL_varz00_bglt BgL_arg1939z00_2852;

					BgL_arg1939z00_2852 =
						(((BgL_setzd2exzd2itz00_bglt) COBJECT(
								((BgL_setzd2exzd2itz00_bglt) BgL_nodez00_2705)))->BgL_varz00);
					BgL_auxz00_3329 =
						((BgL_varz00_bglt)
						BGl_coercez12z12zzcoerce_coercez00(
							((BgL_nodez00_bglt) BgL_arg1939z00_2852), BgL_callerz00_2706,
							((BgL_typez00_bglt) BGl_za2exitza2z00zztype_cachez00),
							CBOOL(BgL_safez00_2708)));
				}
				((((BgL_setzd2exzd2itz00_bglt) COBJECT(
								((BgL_setzd2exzd2itz00_bglt) BgL_nodez00_2705)))->BgL_varz00) =
					((BgL_varz00_bglt) BgL_auxz00_3329), BUNSPEC);
			}
			BGl_pvariablezd2protozd2zzcoerce_pprotoz00(((long) 3),
				(((BgL_varz00_bglt) COBJECT(
							(((BgL_setzd2exzd2itz00_bglt) COBJECT(
										((BgL_setzd2exzd2itz00_bglt) BgL_nodez00_2705)))->
								BgL_varz00)))->BgL_variablez00));
			{
				BgL_nodez00_bglt BgL_auxz00_3343;

				{	/* Coerce/coerce.scm 475 */
					BgL_nodez00_bglt BgL_arg1942z00_2853;

					BgL_arg1942z00_2853 =
						(((BgL_setzd2exzd2itz00_bglt) COBJECT(
								((BgL_setzd2exzd2itz00_bglt) BgL_nodez00_2705)))->BgL_bodyz00);
					BgL_auxz00_3343 =
						BGl_coercez12z12zzcoerce_coercez00(BgL_arg1942z00_2853,
						BgL_callerz00_2706, ((BgL_typez00_bglt) BgL_toz00_2707),
						CBOOL(BgL_safez00_2708));
				}
				((((BgL_setzd2exzd2itz00_bglt) COBJECT(
								((BgL_setzd2exzd2itz00_bglt) BgL_nodez00_2705)))->BgL_bodyz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3343), BUNSPEC);
			}
			return
				((BgL_nodez00_bglt) ((BgL_setzd2exzd2itz00_bglt) BgL_nodez00_2705));
		}

	}



/* &coerce!-let-var1328 */
	BgL_nodez00_bglt BGl_z62coercez12zd2letzd2var1328z70zzcoerce_coercez00(obj_t
		BgL_envz00_2709, obj_t BgL_nodez00_2710, obj_t BgL_callerz00_2711,
		obj_t BgL_toz00_2712, obj_t BgL_safez00_2713)
	{
		{	/* Coerce/coerce.scm 451 */
			BGl_inczd2ppmargez12zc0zzcoerce_pprotoz00();
			{	/* Tools/trace.sch 53 */
				obj_t BgL_g1282z00_2855;

				BgL_g1282z00_2855 =
					(((BgL_letzd2varzd2_bglt) COBJECT(
							((BgL_letzd2varzd2_bglt) BgL_nodez00_2710)))->BgL_bindingsz00);
				{
					obj_t BgL_l1280z00_2857;

					BgL_l1280z00_2857 = BgL_g1282z00_2855;
				BgL_zc3z04anonymousza31927ze3z87_2856:
					if (PAIRP(BgL_l1280z00_2857))
						{	/* Tools/trace.sch 53 */
							{	/* Tools/trace.sch 53 */
								obj_t BgL_bindingz00_2858;

								BgL_bindingz00_2858 = CAR(BgL_l1280z00_2857);
								{	/* Tools/trace.sch 53 */
									obj_t BgL_arg1929z00_2859;

									BgL_arg1929z00_2859 = CAR(((obj_t) BgL_bindingz00_2858));
									BGl_pvariablezd2protozd2zzcoerce_pprotoz00(((long) 3),
										((BgL_variablez00_bglt) BgL_arg1929z00_2859));
								}
								{	/* Tools/trace.sch 53 */
									BgL_nodez00_bglt BgL_arg1930z00_2860;

									{	/* Tools/trace.sch 53 */
										obj_t BgL_arg1931z00_2861;
										BgL_typez00_bglt BgL_arg1932z00_2862;

										BgL_arg1931z00_2861 = CDR(((obj_t) BgL_bindingz00_2858));
										BgL_arg1932z00_2862 =
											(((BgL_variablez00_bglt) COBJECT(
													((BgL_variablez00_bglt)
														((BgL_localz00_bglt)
															CAR(
																((obj_t) BgL_bindingz00_2858))))))->
											BgL_typez00);
										BgL_arg1930z00_2860 =
											BGl_coercez12z12zzcoerce_coercez00(((BgL_nodez00_bglt)
												BgL_arg1931z00_2861), BgL_callerz00_2711,
											BgL_arg1932z00_2862, CBOOL(BgL_safez00_2713));
									}
									{	/* Tools/trace.sch 53 */
										obj_t BgL_auxz00_3375;
										obj_t BgL_tmpz00_3373;

										BgL_auxz00_3375 = ((obj_t) BgL_arg1930z00_2860);
										BgL_tmpz00_3373 = ((obj_t) BgL_bindingz00_2858);
										SET_CDR(BgL_tmpz00_3373, BgL_auxz00_3375);
							}}}
							{
								obj_t BgL_l1280z00_3378;

								BgL_l1280z00_3378 = CDR(BgL_l1280z00_2857);
								BgL_l1280z00_2857 = BgL_l1280z00_3378;
								goto BgL_zc3z04anonymousza31927ze3z87_2856;
							}
						}
					else
						{	/* Tools/trace.sch 53 */
							((bool_t) 1);
						}
				}
			}
			{
				BgL_nodez00_bglt BgL_auxz00_3380;

				{	/* Tools/trace.sch 53 */
					BgL_nodez00_bglt BgL_arg1935z00_2863;

					BgL_arg1935z00_2863 =
						(((BgL_letzd2varzd2_bglt) COBJECT(
								((BgL_letzd2varzd2_bglt) BgL_nodez00_2710)))->BgL_bodyz00);
					BgL_auxz00_3380 =
						BGl_coercez12z12zzcoerce_coercez00(BgL_arg1935z00_2863,
						BgL_callerz00_2711, ((BgL_typez00_bglt) BgL_toz00_2712),
						CBOOL(BgL_safez00_2713));
				}
				((((BgL_letzd2varzd2_bglt) COBJECT(
								((BgL_letzd2varzd2_bglt) BgL_nodez00_2710)))->BgL_bodyz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3380), BUNSPEC);
			}
			{
				BgL_typez00_bglt BgL_auxz00_3388;

				{	/* Tools/trace.sch 53 */
					BgL_typez00_bglt BgL_arg1936z00_2864;
					BgL_typez00_bglt BgL_arg1937z00_2865;

					BgL_arg1936z00_2864 =
						(((BgL_nodez00_bglt) COBJECT(
								(((BgL_letzd2varzd2_bglt) COBJECT(
											((BgL_letzd2varzd2_bglt) BgL_nodez00_2710)))->
									BgL_bodyz00)))->BgL_typez00);
					BgL_arg1937z00_2865 =
						(((BgL_nodez00_bglt)
							COBJECT(((BgL_nodez00_bglt) ((BgL_letzd2varzd2_bglt)
										BgL_nodez00_2710))))->BgL_typez00);
					BgL_auxz00_3388 =
						BGl_strictzd2nodezd2typez00zzast_nodez00(BgL_arg1936z00_2864,
						BgL_arg1937z00_2865);
				}
				((((BgL_nodez00_bglt) COBJECT(
								((BgL_nodez00_bglt)
									((BgL_letzd2varzd2_bglt) BgL_nodez00_2710))))->BgL_typez00) =
					((BgL_typez00_bglt) BgL_auxz00_3388), BUNSPEC);
			}
			BGl_deczd2ppmargez12zc0zzcoerce_pprotoz00();
			return ((BgL_nodez00_bglt) ((BgL_letzd2varzd2_bglt) BgL_nodez00_2710));
		}

	}



/* &coerce!-let-fun1326 */
	BgL_nodez00_bglt BGl_z62coercez12zd2letzd2fun1326z70zzcoerce_coercez00(obj_t
		BgL_envz00_2714, obj_t BgL_nodez00_2715, obj_t BgL_callerz00_2716,
		obj_t BgL_toz00_2717, obj_t BgL_safez00_2718)
	{
		{	/* Coerce/coerce.scm 439 */
			BGl_inczd2ppmargez12zc0zzcoerce_pprotoz00();
			{	/* Coerce/coerce.scm 442 */
				obj_t BgL_g1279z00_2867;

				BgL_g1279z00_2867 =
					(((BgL_letzd2funzd2_bglt) COBJECT(
							((BgL_letzd2funzd2_bglt) BgL_nodez00_2715)))->BgL_localsz00);
				{
					obj_t BgL_l1277z00_2869;

					BgL_l1277z00_2869 = BgL_g1279z00_2867;
				BgL_zc3z04anonymousza31919ze3z87_2868:
					if (PAIRP(BgL_l1277z00_2869))
						{	/* Coerce/coerce.scm 442 */
							{	/* Coerce/coerce.scm 442 */
								obj_t BgL_fz00_2870;

								BgL_fz00_2870 = CAR(BgL_l1277z00_2869);
								{	/* Coerce/coerce.scm 442 */
									bool_t BgL_arg1921z00_2871;

									if (CBOOL(BGl_za2unsafezd2typeza2zd2zzengine_paramz00))
										{	/* Coerce/coerce.scm 442 */
											BgL_arg1921z00_2871 = ((bool_t) 0);
										}
									else
										{	/* Coerce/coerce.scm 442 */
											BgL_arg1921z00_2871 = ((bool_t) 1);
										}
									BGl_coercezd2functionz12zc0zzcoerce_coercez00(
										((BgL_variablez00_bglt) BgL_fz00_2870),
										BgL_arg1921z00_2871);
								}
							}
							{
								obj_t BgL_l1277z00_3412;

								BgL_l1277z00_3412 = CDR(BgL_l1277z00_2869);
								BgL_l1277z00_2869 = BgL_l1277z00_3412;
								goto BgL_zc3z04anonymousza31919ze3z87_2868;
							}
						}
					else
						{	/* Coerce/coerce.scm 442 */
							((bool_t) 1);
						}
				}
			}
			{
				BgL_nodez00_bglt BgL_auxz00_3414;

				{	/* Coerce/coerce.scm 443 */
					BgL_nodez00_bglt BgL_arg1923z00_2872;

					BgL_arg1923z00_2872 =
						(((BgL_letzd2funzd2_bglt) COBJECT(
								((BgL_letzd2funzd2_bglt) BgL_nodez00_2715)))->BgL_bodyz00);
					BgL_auxz00_3414 =
						BGl_coercez12z12zzcoerce_coercez00(BgL_arg1923z00_2872,
						BgL_callerz00_2716, ((BgL_typez00_bglt) BgL_toz00_2717),
						CBOOL(BgL_safez00_2718));
				}
				((((BgL_letzd2funzd2_bglt) COBJECT(
								((BgL_letzd2funzd2_bglt) BgL_nodez00_2715)))->BgL_bodyz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3414), BUNSPEC);
			}
			{
				BgL_typez00_bglt BgL_auxz00_3422;

				{	/* Coerce/coerce.scm 444 */
					BgL_typez00_bglt BgL_arg1924z00_2873;
					BgL_typez00_bglt BgL_arg1925z00_2874;

					BgL_arg1924z00_2873 =
						(((BgL_nodez00_bglt) COBJECT(
								(((BgL_letzd2funzd2_bglt) COBJECT(
											((BgL_letzd2funzd2_bglt) BgL_nodez00_2715)))->
									BgL_bodyz00)))->BgL_typez00);
					BgL_arg1925z00_2874 =
						(((BgL_nodez00_bglt)
							COBJECT(((BgL_nodez00_bglt) ((BgL_letzd2funzd2_bglt)
										BgL_nodez00_2715))))->BgL_typez00);
					BgL_auxz00_3422 =
						BGl_strictzd2nodezd2typez00zzast_nodez00(BgL_arg1924z00_2873,
						BgL_arg1925z00_2874);
				}
				((((BgL_nodez00_bglt) COBJECT(
								((BgL_nodez00_bglt)
									((BgL_letzd2funzd2_bglt) BgL_nodez00_2715))))->BgL_typez00) =
					((BgL_typez00_bglt) BgL_auxz00_3422), BUNSPEC);
			}
			BGl_deczd2ppmargez12zc0zzcoerce_pprotoz00();
			return ((BgL_nodez00_bglt) ((BgL_letzd2funzd2_bglt) BgL_nodez00_2715));
		}

	}



/* &coerce!-switch1324 */
	BgL_nodez00_bglt BGl_z62coercez12zd2switch1324za2zzcoerce_coercez00(obj_t
		BgL_envz00_2719, obj_t BgL_nodez00_2720, obj_t BgL_callerz00_2721,
		obj_t BgL_toz00_2722, obj_t BgL_safez00_2723)
	{
		{	/* Coerce/coerce.scm 409 */
			((((BgL_nodez00_bglt) COBJECT(
							((BgL_nodez00_bglt)
								((BgL_switchz00_bglt) BgL_nodez00_2720))))->BgL_typez00) =
				((BgL_typez00_bglt) ((BgL_typez00_bglt) BgL_toz00_2722)), BUNSPEC);
			{	/* Coerce/coerce.scm 412 */
				obj_t BgL_clausesz00_2876;
				BgL_typez00_bglt BgL_testzd2typezd2_2877;
				BgL_typez00_bglt BgL_testzd2nodezd2typez00_2878;

				BgL_clausesz00_2876 =
					(((BgL_switchz00_bglt) COBJECT(
							((BgL_switchz00_bglt) BgL_nodez00_2720)))->BgL_clausesz00);
				BgL_testzd2typezd2_2877 =
					(((BgL_switchz00_bglt) COBJECT(
							((BgL_switchz00_bglt) BgL_nodez00_2720)))->BgL_itemzd2typezd2);
				BgL_testzd2nodezd2typez00_2878 =
					BGl_getzd2typezd2zztype_typeofz00(
					(((BgL_switchz00_bglt) COBJECT(
								((BgL_switchz00_bglt) BgL_nodez00_2720)))->BgL_testz00),
					((bool_t) 0));
				if (BGl_coercerzd2existszf3z21zztype_coercionz00
					(BgL_testzd2nodezd2typez00_2878, BgL_testzd2typezd2_2877))
					{	/* Coerce/coerce.scm 415 */
						BFALSE;
					}
				else
					{	/* Coerce/coerce.scm 416 */
						obj_t BgL_arg1894z00_2879;
						obj_t BgL_arg1895z00_2880;
						obj_t BgL_arg1896z00_2881;

						{	/* Coerce/coerce.scm 416 */
							obj_t BgL_res2070z00_2882;

							{	/* Coerce/coerce.scm 416 */
								obj_t BgL_tmpz00_3449;

								BgL_tmpz00_3449 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_res2070z00_2882 =
									BGL_ENV_CURRENT_ERROR_PORT(BgL_tmpz00_3449);
							}
							BgL_arg1894z00_2879 = BgL_res2070z00_2882;
						}
						BgL_arg1895z00_2880 =
							BGl_shapez00zztools_shapez00(((obj_t) BgL_testzd2typezd2_2877));
						BgL_arg1896z00_2881 =
							BGl_shapez00zztools_shapez00(
							((obj_t) BgL_testzd2nodezd2typez00_2878));
						{	/* Coerce/coerce.scm 416 */
							obj_t BgL_list1897z00_2883;

							{	/* Coerce/coerce.scm 416 */
								obj_t BgL_arg1898z00_2884;

								{	/* Coerce/coerce.scm 416 */
									obj_t BgL_arg1900z00_2885;

									{	/* Coerce/coerce.scm 416 */
										obj_t BgL_arg1901z00_2886;

										{	/* Coerce/coerce.scm 416 */
											obj_t BgL_arg1902z00_2887;

											{	/* Coerce/coerce.scm 416 */
												obj_t BgL_arg1903z00_2888;

												{	/* Coerce/coerce.scm 416 */
													obj_t BgL_arg1904z00_2889;

													{	/* Coerce/coerce.scm 416 */
														obj_t BgL_arg1905z00_2890;

														BgL_arg1905z00_2890 =
															MAKE_YOUNG_PAIR(BgL_arg1896z00_2881, BNIL);
														BgL_arg1904z00_2889 =
															MAKE_YOUNG_PAIR
															(BGl_string2107z00zzcoerce_coercez00,
															BgL_arg1905z00_2890);
													}
													BgL_arg1903z00_2888 =
														MAKE_YOUNG_PAIR(BgL_arg1895z00_2880,
														BgL_arg1904z00_2889);
												}
												BgL_arg1902z00_2887 =
													MAKE_YOUNG_PAIR(BGl_string2108z00zzcoerce_coercez00,
													BgL_arg1903z00_2888);
											}
											BgL_arg1901z00_2886 =
												MAKE_YOUNG_PAIR(BGl_string2109z00zzcoerce_coercez00,
												BgL_arg1902z00_2887);
										}
										BgL_arg1900z00_2885 =
											MAKE_YOUNG_PAIR(BINT(((long) 416)), BgL_arg1901z00_2886);
									}
									BgL_arg1898z00_2884 =
										MAKE_YOUNG_PAIR(BGl_string2110z00zzcoerce_coercez00,
										BgL_arg1900z00_2885);
								}
								BgL_list1897z00_2883 =
									MAKE_YOUNG_PAIR(BGl_string2111z00zzcoerce_coercez00,
									BgL_arg1898z00_2884);
							}
							BGl_tprintz00zz__r4_output_6_10_3z00(BgL_arg1894z00_2879,
								BgL_list1897z00_2883);
					}}
				if (BGl_coercerzd2existszf3z21zztype_coercionz00
					(BgL_testzd2nodezd2typez00_2878, BgL_testzd2typezd2_2877))
					{	/* Coerce/coerce.scm 425 */
						((((BgL_switchz00_bglt) COBJECT(
										((BgL_switchz00_bglt) BgL_nodez00_2720)))->BgL_testz00) =
							((BgL_nodez00_bglt)
								BGl_coercez12z12zzcoerce_coercez00((((BgL_switchz00_bglt)
											COBJECT(((BgL_switchz00_bglt) BgL_nodez00_2720)))->
										BgL_testz00), BgL_callerz00_2721, BgL_testzd2typezd2_2877,
									CBOOL(BgL_safez00_2723))), BUNSPEC);
						{
							obj_t BgL_l1275z00_2892;

							BgL_l1275z00_2892 = BgL_clausesz00_2876;
						BgL_zc3z04anonymousza31909ze3z87_2891:
							if (PAIRP(BgL_l1275z00_2892))
								{	/* Coerce/coerce.scm 428 */
									{	/* Coerce/coerce.scm 429 */
										obj_t BgL_clausez00_2893;

										BgL_clausez00_2893 = CAR(BgL_l1275z00_2892);
										{	/* Coerce/coerce.scm 430 */
											BgL_nodez00_bglt BgL_arg1911z00_2894;

											{	/* Coerce/coerce.scm 430 */
												obj_t BgL_arg1912z00_2895;

												BgL_arg1912z00_2895 = CDR(((obj_t) BgL_clausez00_2893));
												BgL_arg1911z00_2894 =
													BGl_coercez12z12zzcoerce_coercez00(
													((BgL_nodez00_bglt) BgL_arg1912z00_2895),
													BgL_callerz00_2721,
													((BgL_typez00_bglt) BgL_toz00_2722),
													CBOOL(BgL_safez00_2723));
											}
											{	/* Coerce/coerce.scm 429 */
												obj_t BgL_auxz00_3485;
												obj_t BgL_tmpz00_3483;

												BgL_auxz00_3485 = ((obj_t) BgL_arg1911z00_2894);
												BgL_tmpz00_3483 = ((obj_t) BgL_clausez00_2893);
												SET_CDR(BgL_tmpz00_3483, BgL_auxz00_3485);
											}
										}
									}
									{
										obj_t BgL_l1275z00_3488;

										BgL_l1275z00_3488 = CDR(BgL_l1275z00_2892);
										BgL_l1275z00_2892 = BgL_l1275z00_3488;
										goto BgL_zc3z04anonymousza31909ze3z87_2891;
									}
								}
							else
								{	/* Coerce/coerce.scm 428 */
									((bool_t) 1);
								}
						}
						return ((BgL_nodez00_bglt) ((BgL_switchz00_bglt) BgL_nodez00_2720));
					}
				else
					{	/* Coerce/coerce.scm 433 */
						obj_t BgL_arg1914z00_2896;

						{	/* Coerce/coerce.scm 433 */
							obj_t BgL_arg1915z00_2897;
							obj_t BgL_arg1916z00_2898;
							BgL_nodez00_bglt BgL_arg1917z00_2899;

							BgL_arg1915z00_2897 =
								(((BgL_nodez00_bglt) COBJECT(
										((BgL_nodez00_bglt)
											((BgL_switchz00_bglt) BgL_nodez00_2720))))->BgL_locz00);
							BgL_arg1916z00_2898 =
								(((BgL_typez00_bglt) COBJECT(BgL_testzd2typezd2_2877))->
								BgL_idz00);
							BgL_arg1917z00_2899 =
								(((BgL_switchz00_bglt) COBJECT(((BgL_switchz00_bglt)
											BgL_nodez00_2720)))->BgL_testz00);
							BgL_arg1914z00_2896 =
								BGl_runtimezd2typezd2errorz00zzcoerce_convertz00
								(BgL_arg1915z00_2897, BgL_arg1916z00_2898, BgL_arg1917z00_2899);
						}
						return
							BGl_coercez12z12zzcoerce_coercez00(
							((BgL_nodez00_bglt) BgL_arg1914z00_2896), BgL_callerz00_2721,
							((BgL_typez00_bglt) BgL_toz00_2722), CBOOL(BgL_safez00_2723));
					}
			}
		}

	}



/* &coerce!-fail1322 */
	BgL_nodez00_bglt BGl_z62coercez12zd2fail1322za2zzcoerce_coercez00(obj_t
		BgL_envz00_2724, obj_t BgL_nodez00_2725, obj_t BgL_callerz00_2726,
		obj_t BgL_toz00_2727, obj_t BgL_safez00_2728)
	{
		{	/* Coerce/coerce.scm 399 */
			{
				BgL_nodez00_bglt BgL_auxz00_3503;

				{	/* Coerce/coerce.scm 401 */
					BgL_nodez00_bglt BgL_arg1890z00_2901;

					BgL_arg1890z00_2901 =
						(((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nodez00_2725)))->BgL_procz00);
					BgL_auxz00_3503 =
						BGl_coercez12z12zzcoerce_coercez00(BgL_arg1890z00_2901,
						BgL_callerz00_2726,
						((BgL_typez00_bglt) BGl_za2objza2z00zztype_cachez00),
						CBOOL(BgL_safez00_2728));
				}
				((((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nodez00_2725)))->BgL_procz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3503), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_3511;

				{	/* Coerce/coerce.scm 402 */
					BgL_nodez00_bglt BgL_arg1891z00_2902;

					BgL_arg1891z00_2902 =
						(((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nodez00_2725)))->BgL_msgz00);
					BgL_auxz00_3511 =
						BGl_coercez12z12zzcoerce_coercez00(BgL_arg1891z00_2902,
						BgL_callerz00_2726,
						((BgL_typez00_bglt) BGl_za2objza2z00zztype_cachez00),
						CBOOL(BgL_safez00_2728));
				}
				((((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nodez00_2725)))->BgL_msgz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3511), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_3519;

				{	/* Coerce/coerce.scm 403 */
					BgL_nodez00_bglt BgL_arg1892z00_2903;

					BgL_arg1892z00_2903 =
						(((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nodez00_2725)))->BgL_objz00);
					BgL_auxz00_3519 =
						BGl_coercez12z12zzcoerce_coercez00(BgL_arg1892z00_2903,
						BgL_callerz00_2726,
						((BgL_typez00_bglt) BGl_za2objza2z00zztype_cachez00),
						CBOOL(BgL_safez00_2728));
				}
				((((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nodez00_2725)))->BgL_objz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3519), BUNSPEC);
			}
			return
				BGl_convertz12z12zzcoerce_convertz00(
				((BgL_nodez00_bglt)
					((BgL_failz00_bglt) BgL_nodez00_2725)),
				((BgL_typez00_bglt) BGl_za2magicza2z00zztype_cachez00),
				((BgL_typez00_bglt) BgL_toz00_2727), CBOOL(BgL_safez00_2728));
		}

	}



/* &coerce!-conditional1320 */
	BgL_nodez00_bglt BGl_z62coercez12zd2conditional1320za2zzcoerce_coercez00(obj_t
		BgL_envz00_2729, obj_t BgL_nodez00_2730, obj_t BgL_callerz00_2731,
		obj_t BgL_toz00_2732, obj_t BgL_safez00_2733)
	{
		{	/* Coerce/coerce.scm 288 */
			{
				BgL_appz00_bglt BgL_nodez00_2946;
				BgL_letzd2varzd2_bglt BgL_nodez00_2926;
				obj_t BgL_nodez00_2911;
				obj_t BgL_typecz00_2912;
				obj_t BgL_nodez00_2909;

				{
					BgL_nodez00_bglt BgL_auxz00_3533;

					{	/* Coerce/coerce.scm 384 */
						BgL_nodez00_bglt BgL_arg1761z00_2951;

						BgL_arg1761z00_2951 =
							(((BgL_conditionalz00_bglt) COBJECT(
									((BgL_conditionalz00_bglt) BgL_nodez00_2730)))->BgL_testz00);
						BgL_auxz00_3533 =
							BGl_coercez12z12zzcoerce_coercez00(BgL_arg1761z00_2951,
							BgL_callerz00_2731,
							((BgL_typez00_bglt) BGl_za2boolza2z00zztype_cachez00),
							CBOOL(BgL_safez00_2733));
					}
					((((BgL_conditionalz00_bglt) COBJECT(
									((BgL_conditionalz00_bglt) BgL_nodez00_2730)))->BgL_testz00) =
						((BgL_nodez00_bglt) BgL_auxz00_3533), BUNSPEC);
				}
				{	/* Coerce/coerce.scm 385 */
					obj_t BgL_casezd2valuezd2_2952;

					{	/* Coerce/coerce.scm 385 */
						BgL_nodez00_bglt BgL_arg1769z00_2953;

						BgL_arg1769z00_2953 =
							(((BgL_conditionalz00_bglt) COBJECT(
									((BgL_conditionalz00_bglt) BgL_nodez00_2730)))->BgL_testz00);
						BgL_nodez00_2909 = ((obj_t) BgL_arg1769z00_2953);
					BgL_testzd2staticzd2valuez00_2905:
						{	/* Coerce/coerce.scm 373 */
							obj_t BgL_g1138z00_2910;

							BgL_g1138z00_2910 =
								BGl_isazd2ofzd2zztype_miscz00(
								((BgL_nodez00_bglt) BgL_nodez00_2909));
							if (CBOOL(BgL_g1138z00_2910))
								{	/* Coerce/coerce.scm 373 */
									BgL_nodez00_2911 = BgL_nodez00_2909;
									BgL_typecz00_2912 = BgL_g1138z00_2910;
									{	/* Coerce/coerce.scm 355 */
										obj_t BgL_typevz00_2913;

										{	/* Coerce/coerce.scm 356 */
											bool_t BgL_test2178z00_3547;

											{	/* Coerce/coerce.scm 356 */
												obj_t BgL_arg1885z00_2914;

												{	/* Coerce/coerce.scm 356 */
													obj_t BgL_pairz00_2915;

													BgL_pairz00_2915 =
														(((BgL_appz00_bglt) COBJECT(
																((BgL_appz00_bglt) BgL_nodez00_2911)))->
														BgL_argsz00);
													BgL_arg1885z00_2914 = CAR(BgL_pairz00_2915);
												}
												BgL_test2178z00_3547 =
													BGl_isazf3zf3zz__objectz00(BgL_arg1885z00_2914,
													BGl_varz00zzast_nodez00);
											}
											if (BgL_test2178z00_3547)
												{	/* Coerce/coerce.scm 357 */
													obj_t BgL_arg1867z00_2916;

													{	/* Coerce/coerce.scm 357 */
														obj_t BgL_pairz00_2917;

														BgL_pairz00_2917 =
															(((BgL_appz00_bglt) COBJECT(
																	((BgL_appz00_bglt) BgL_nodez00_2911)))->
															BgL_argsz00);
														BgL_arg1867z00_2916 = CAR(BgL_pairz00_2917);
													}
													BgL_typevz00_2913 =
														((obj_t)
														BGl_getzd2typezd2zztype_typeofz00(
															((BgL_nodez00_bglt) BgL_arg1867z00_2916),
															((bool_t) 0)));
												}
											else
												{	/* Coerce/coerce.scm 358 */
													bool_t BgL_test2179z00_3558;

													{	/* Coerce/coerce.scm 358 */
														obj_t BgL_arg1882z00_2918;

														{	/* Coerce/coerce.scm 358 */
															obj_t BgL_pairz00_2919;

															BgL_pairz00_2919 =
																(((BgL_appz00_bglt) COBJECT(
																		((BgL_appz00_bglt) BgL_nodez00_2911)))->
																BgL_argsz00);
															BgL_arg1882z00_2918 = CAR(BgL_pairz00_2919);
														}
														BgL_test2179z00_3558 =
															BGl_isazf3zf3zz__objectz00(BgL_arg1882z00_2918,
															BGl_castz00zzast_nodez00);
													}
													if (BgL_test2179z00_3558)
														{	/* Coerce/coerce.scm 359 */
															BgL_castz00_bglt BgL_i1134z00_2920;

															{	/* Coerce/coerce.scm 359 */
																obj_t BgL_pairz00_2921;

																BgL_pairz00_2921 =
																	(((BgL_appz00_bglt) COBJECT(
																			((BgL_appz00_bglt) BgL_nodez00_2911)))->
																	BgL_argsz00);
																BgL_i1134z00_2920 =
																	((BgL_castz00_bglt) CAR(BgL_pairz00_2921));
															}
															{	/* Coerce/coerce.scm 360 */
																bool_t BgL_test2180z00_3567;

																{	/* Coerce/coerce.scm 360 */
																	bool_t BgL_test2181z00_3568;

																	{	/* Coerce/coerce.scm 360 */
																		BgL_typez00_bglt BgL_arg1880z00_2922;

																		BgL_arg1880z00_2922 =
																			(((BgL_nodez00_bglt) COBJECT(
																					((BgL_nodez00_bglt)
																						BgL_i1134z00_2920)))->BgL_typez00);
																		BgL_test2181z00_3568 =
																			(((obj_t) BgL_arg1880z00_2922) ==
																			BGl_za2objza2z00zztype_cachez00);
																	}
																	if (BgL_test2181z00_3568)
																		{	/* Coerce/coerce.scm 360 */
																			BgL_nodez00_bglt BgL_arg1879z00_2923;

																			BgL_arg1879z00_2923 =
																				(((BgL_castz00_bglt)
																					COBJECT(BgL_i1134z00_2920))->
																				BgL_argz00);
																			{	/* Coerce/coerce.scm 360 */
																				bool_t BgL_res2064z00_2924;

																				BgL_res2064z00_2924 =
																					BGl_isazf3zf3zz__objectz00(
																					((obj_t) BgL_arg1879z00_2923),
																					BGl_varz00zzast_nodez00);
																				BgL_test2180z00_3567 =
																					BgL_res2064z00_2924;
																			}
																		}
																	else
																		{	/* Coerce/coerce.scm 360 */
																			BgL_test2180z00_3567 = ((bool_t) 0);
																		}
																}
																if (BgL_test2180z00_3567)
																	{	/* Coerce/coerce.scm 361 */
																		BgL_nodez00_bglt BgL_arg1878z00_2925;

																		BgL_arg1878z00_2925 =
																			(((BgL_castz00_bglt)
																				COBJECT(BgL_i1134z00_2920))->
																			BgL_argz00);
																		BgL_typevz00_2913 =
																			((obj_t)
																			BGl_getzd2typezd2zztype_typeofz00
																			(BgL_arg1878z00_2925, ((bool_t) 0)));
																	}
																else
																	{	/* Coerce/coerce.scm 360 */
																		BgL_typevz00_2913 = BFALSE;
																	}
															}
														}
													else
														{	/* Coerce/coerce.scm 358 */
															BgL_typevz00_2913 = BFALSE;
														}
												}
										}
										if (BGl_isazf3zf3zz__objectz00(BgL_typevz00_2913,
												BGl_typez00zztype_typez00))
											{	/* Coerce/coerce.scm 363 */
												if (BGl_typezd2lesszd2specificzf3zf3zztype_miscz00(
														((BgL_typez00_bglt) BgL_typecz00_2912),
														((BgL_typez00_bglt) BgL_typevz00_2913)))
													{	/* Coerce/coerce.scm 365 */
														BgL_casezd2valuezd2_2952 =
															CNST_TABLE_REF(((long) 1));
													}
												else
													{	/* Coerce/coerce.scm 365 */
														if (BGl_typezd2disjointzf3z21zztype_miscz00(
																((BgL_typez00_bglt) BgL_typecz00_2912),
																((BgL_typez00_bglt) BgL_typevz00_2913)))
															{	/* Coerce/coerce.scm 367 */
																BgL_casezd2valuezd2_2952 =
																	CNST_TABLE_REF(((long) 2));
															}
														else
															{	/* Coerce/coerce.scm 367 */
																BgL_casezd2valuezd2_2952 = BFALSE;
															}
													}
											}
										else
											{	/* Coerce/coerce.scm 363 */
												BgL_casezd2valuezd2_2952 = BFALSE;
											}
									}
								}
							else
								{	/* Coerce/coerce.scm 373 */
									if (BGl_isazf3zf3zz__objectz00(BgL_nodez00_2909,
											BGl_appz00zzast_nodez00))
										{	/* Coerce/coerce.scm 377 */
											BgL_nodez00_2946 = ((BgL_appz00_bglt) BgL_nodez00_2909);
											{	/* Coerce/coerce.scm 291 */
												bool_t BgL_test2186z00_3593;

												{	/* Coerce/coerce.scm 291 */
													obj_t BgL_tmpz00_3594;

													BgL_tmpz00_3594 =
														(((BgL_appz00_bglt) COBJECT(BgL_nodez00_2946))->
														BgL_argsz00);
													BgL_test2186z00_3593 = PAIRP(BgL_tmpz00_3594);
												}
												if (BgL_test2186z00_3593)
													{	/* Coerce/coerce.scm 291 */
														if (NULLP(CDR(
																	(((BgL_appz00_bglt)
																			COBJECT(BgL_nodez00_2946))->
																		BgL_argsz00))))
															{	/* Coerce/coerce.scm 293 */
																bool_t BgL_test2188z00_3601;

																{	/* Coerce/coerce.scm 293 */
																	obj_t BgL_arg1777z00_2947;

																	BgL_arg1777z00_2947 =
																		CAR(
																		(((BgL_appz00_bglt)
																				COBJECT(BgL_nodez00_2946))->
																			BgL_argsz00));
																	BgL_test2188z00_3601 =
																		BGl_sidezd2effectzf3z21zzeffect_effectz00((
																			(BgL_nodez00_bglt) BgL_arg1777z00_2947));
																}
																if (BgL_test2188z00_3601)
																	{	/* Coerce/coerce.scm 293 */
																		BgL_casezd2valuezd2_2952 = BFALSE;
																	}
																else
																	{	/* Coerce/coerce.scm 294 */
																		obj_t BgL_typecz00_2948;

																		BgL_typecz00_2948 =
																			BGl_appzd2predicatezd2ofz00zztype_miscz00
																			(BgL_nodez00_2946);
																		{	/* Coerce/coerce.scm 294 */
																			BgL_typez00_bglt BgL_typevz00_2949;

																			{	/* Coerce/coerce.scm 295 */
																				obj_t BgL_arg1775z00_2950;

																				BgL_arg1775z00_2950 =
																					CAR(
																					(((BgL_appz00_bglt)
																							COBJECT(BgL_nodez00_2946))->
																						BgL_argsz00));
																				BgL_typevz00_2949 =
																					BGl_getzd2typezd2zztype_typeofz00((
																						(BgL_nodez00_bglt)
																						BgL_arg1775z00_2950), ((bool_t) 0));
																			}
																			{	/* Coerce/coerce.scm 295 */

																				if (BGl_isazf3zf3zz__objectz00
																					(BgL_typecz00_2948,
																						BGl_typez00zztype_typez00))
																					{	/* Coerce/coerce.scm 297 */
																						if (
																							(((obj_t) BgL_typevz00_2949) ==
																								BGl_za2objza2z00zztype_cachez00))
																							{	/* Coerce/coerce.scm 300 */
																								BgL_casezd2valuezd2_2952 =
																									BFALSE;
																							}
																						else
																							{	/* Coerce/coerce.scm 300 */
																								if (BGl_typezd2lesszd2specificzf3zf3zztype_miscz00(((BgL_typez00_bglt) BgL_typecz00_2948), BgL_typevz00_2949))
																									{	/* Coerce/coerce.scm 303 */
																										BgL_casezd2valuezd2_2952 =
																											CNST_TABLE_REF(((long)
																												1));
																									}
																								else
																									{	/* Coerce/coerce.scm 303 */
																										if (BGl_typezd2disjointzf3z21zztype_miscz00(((BgL_typez00_bglt) BgL_typecz00_2948), BgL_typevz00_2949))
																											{	/* Coerce/coerce.scm 305 */
																												BgL_casezd2valuezd2_2952
																													=
																													CNST_TABLE_REF(((long)
																														2));
																											}
																										else
																											{	/* Coerce/coerce.scm 305 */
																												BgL_casezd2valuezd2_2952
																													= BFALSE;
																											}
																									}
																							}
																					}
																				else
																					{	/* Coerce/coerce.scm 297 */
																						BgL_casezd2valuezd2_2952 = BFALSE;
																					}
																			}
																		}
																	}
															}
														else
															{	/* Coerce/coerce.scm 292 */
																BgL_casezd2valuezd2_2952 = BFALSE;
															}
													}
												else
													{	/* Coerce/coerce.scm 291 */
														BgL_casezd2valuezd2_2952 = BFALSE;
													}
											}
										}
									else
										{	/* Coerce/coerce.scm 377 */
											if (BGl_isazf3zf3zz__objectz00(BgL_nodez00_2909,
													BGl_letzd2varzd2zzast_nodez00))
												{	/* Coerce/coerce.scm 379 */
													BgL_nodez00_2926 =
														((BgL_letzd2varzd2_bglt) BgL_nodez00_2909);
													{	/* Coerce/coerce.scm 311 */
														bool_t BgL_test2194z00_3627;

														{	/* Coerce/coerce.scm 311 */
															bool_t BgL_test2195z00_3628;

															{	/* Coerce/coerce.scm 311 */
																obj_t BgL_tmpz00_3629;

																BgL_tmpz00_3629 =
																	(((BgL_letzd2varzd2_bglt)
																		COBJECT(BgL_nodez00_2926))->
																	BgL_bindingsz00);
																BgL_test2195z00_3628 = PAIRP(BgL_tmpz00_3629);
															}
															if (BgL_test2195z00_3628)
																{	/* Coerce/coerce.scm 311 */
																	BgL_test2194z00_3627 =
																		NULLP(CDR(
																			(((BgL_letzd2varzd2_bglt)
																					COBJECT(BgL_nodez00_2926))->
																				BgL_bindingsz00)));
																}
															else
																{	/* Coerce/coerce.scm 311 */
																	BgL_test2194z00_3627 = ((bool_t) 0);
																}
														}
														if (BgL_test2194z00_3627)
															{	/* Coerce/coerce.scm 313 */
																bool_t BgL_test2196z00_3635;

																{	/* Coerce/coerce.scm 313 */
																	BgL_nodez00_bglt BgL_arg1856z00_2927;

																	BgL_arg1856z00_2927 =
																		(((BgL_letzd2varzd2_bglt)
																			COBJECT(BgL_nodez00_2926))->BgL_bodyz00);
																	{	/* Coerce/coerce.scm 313 */
																		bool_t BgL_res2053z00_2928;

																		BgL_res2053z00_2928 =
																			BGl_isazf3zf3zz__objectz00(
																			((obj_t) BgL_arg1856z00_2927),
																			BGl_appz00zzast_nodez00);
																		BgL_test2196z00_3635 = BgL_res2053z00_2928;
																	}
																}
																if (BgL_test2196z00_3635)
																	{	/* Coerce/coerce.scm 314 */
																		obj_t BgL_varz00_2929;

																		{	/* Coerce/coerce.scm 314 */
																			obj_t BgL_argsz00_2930;

																			BgL_argsz00_2930 =
																				(((BgL_appz00_bglt) COBJECT(
																						((BgL_appz00_bglt)
																							(((BgL_letzd2varzd2_bglt)
																									COBJECT(BgL_nodez00_2926))->
																								BgL_bodyz00))))->BgL_argsz00);
																			if (PAIRP(BgL_argsz00_2930))
																				{	/* Coerce/coerce.scm 318 */
																					bool_t BgL_test2198z00_3644;

																					if (NULLP(CDR(BgL_argsz00_2930)))
																						{	/* Coerce/coerce.scm 318 */
																							obj_t BgL_arg1834z00_2931;

																							BgL_arg1834z00_2931 =
																								CAR(BgL_argsz00_2930);
																							BgL_test2198z00_3644 =
																								BGl_isazf3zf3zz__objectz00
																								(BgL_arg1834z00_2931,
																								BGl_varz00zzast_nodez00);
																						}
																					else
																						{	/* Coerce/coerce.scm 318 */
																							BgL_test2198z00_3644 =
																								((bool_t) 0);
																						}
																					if (BgL_test2198z00_3644)
																						{	/* Coerce/coerce.scm 318 */
																							BgL_varz00_2929 =
																								((obj_t)
																								(((BgL_varz00_bglt) COBJECT(
																											((BgL_varz00_bglt)
																												CAR
																												(BgL_argsz00_2930))))->
																									BgL_variablez00));
																						}
																					else
																						{	/* Coerce/coerce.scm 321 */
																							bool_t BgL_test2200z00_3654;

																							{	/* Coerce/coerce.scm 321 */
																								obj_t BgL_tmpz00_3655;

																								BgL_tmpz00_3655 =
																									CDR(BgL_argsz00_2930);
																								BgL_test2200z00_3654 =
																									PAIRP(BgL_tmpz00_3655);
																							}
																							if (BgL_test2200z00_3654)
																								{	/* Coerce/coerce.scm 323 */
																									bool_t BgL_test2201z00_3658;

																									if (NULLP(CDR(CDR
																												(BgL_argsz00_2930))))
																										{	/* Coerce/coerce.scm 323 */
																											obj_t BgL_arg1830z00_2932;

																											BgL_arg1830z00_2932 =
																												CAR(BgL_argsz00_2930);
																											BgL_test2201z00_3658 =
																												BGl_isazf3zf3zz__objectz00
																												(BgL_arg1830z00_2932,
																												BGl_varz00zzast_nodez00);
																										}
																									else
																										{	/* Coerce/coerce.scm 323 */
																											BgL_test2201z00_3658 =
																												((bool_t) 0);
																										}
																									if (BgL_test2201z00_3658)
																										{	/* Coerce/coerce.scm 323 */
																											BgL_varz00_2929 =
																												((obj_t)
																												(((BgL_varz00_bglt)
																														COBJECT((
																																(BgL_varz00_bglt)
																																CAR
																																(BgL_argsz00_2930))))->
																													BgL_variablez00));
																										}
																									else
																										{	/* Coerce/coerce.scm 323 */
																											BgL_varz00_2929 = BFALSE;
																										}
																								}
																							else
																								{	/* Coerce/coerce.scm 321 */
																									BgL_varz00_2929 = BFALSE;
																								}
																						}
																				}
																			else
																				{	/* Coerce/coerce.scm 316 */
																					BgL_varz00_2929 = BFALSE;
																				}
																		}
																		{	/* Coerce/coerce.scm 314 */
																			obj_t BgL_typecz00_2933;

																			{	/* Coerce/coerce.scm 328 */
																				BgL_nodez00_bglt BgL_arg1812z00_2934;

																				BgL_arg1812z00_2934 =
																					(((BgL_letzd2varzd2_bglt)
																						COBJECT(BgL_nodez00_2926))->
																					BgL_bodyz00);
																				BgL_typecz00_2933 =
																					BGl_appzd2predicatezd2ofz00zztype_miscz00
																					(((BgL_appz00_bglt)
																						BgL_arg1812z00_2934));
																			}
																			{	/* Coerce/coerce.scm 328 */
																				BgL_typez00_bglt BgL_typepz00_2935;

																				{
																					BgL_variablez00_bglt BgL_auxz00_3672;

																					{	/* Coerce/coerce.scm 329 */
																						obj_t BgL_pairz00_2936;

																						{	/* Coerce/coerce.scm 329 */
																							obj_t BgL_pairz00_2937;

																							BgL_pairz00_2937 =
																								(((BgL_letzd2varzd2_bglt)
																									COBJECT(BgL_nodez00_2926))->
																								BgL_bindingsz00);
																							BgL_pairz00_2936 =
																								CAR(BgL_pairz00_2937);
																						}
																						BgL_auxz00_3672 =
																							((BgL_variablez00_bglt)
																							CAR(BgL_pairz00_2936));
																					}
																					BgL_typepz00_2935 =
																						(((BgL_variablez00_bglt)
																							COBJECT(BgL_auxz00_3672))->
																						BgL_typez00);
																				}
																				{	/* Coerce/coerce.scm 329 */
																					BgL_typez00_bglt BgL_typevz00_2938;

																					if (
																						(((obj_t) BgL_typepz00_2935) ==
																							BGl_za2objza2z00zztype_cachez00))
																						{	/* Coerce/coerce.scm 331 */
																							obj_t BgL_arg1804z00_2939;

																							BgL_arg1804z00_2939 =
																								CDR(CAR(
																									(((BgL_letzd2varzd2_bglt)
																											COBJECT
																											(BgL_nodez00_2926))->
																										BgL_bindingsz00)));
																							BgL_typevz00_2938 =
																								BGl_getzd2typezd2zztype_typeofz00
																								(((BgL_nodez00_bglt)
																									BgL_arg1804z00_2939),
																								((bool_t) 0));
																						}
																					else
																						{	/* Coerce/coerce.scm 330 */
																							BgL_typevz00_2938 =
																								BgL_typepz00_2935;
																						}
																					{	/* Coerce/coerce.scm 330 */

																						if (BGl_isazf3zf3zz__objectz00
																							(BgL_typecz00_2933,
																								BGl_typez00zztype_typez00))
																							{	/* Coerce/coerce.scm 337 */
																								bool_t BgL_test2205z00_3688;

																								{	/* Coerce/coerce.scm 337 */
																									obj_t BgL_tmpz00_3689;

																									{	/* Coerce/coerce.scm 337 */
																										obj_t BgL_pairz00_2940;

																										BgL_pairz00_2940 =
																											(((BgL_letzd2varzd2_bglt)
																												COBJECT
																												(BgL_nodez00_2926))->
																											BgL_bindingsz00);
																										BgL_tmpz00_3689 =
																											CAR(CAR
																											(BgL_pairz00_2940));
																									}
																									BgL_test2205z00_3688 =
																										(BgL_varz00_2929 ==
																										BgL_tmpz00_3689);
																								}
																								if (BgL_test2205z00_3688)
																									{	/* Coerce/coerce.scm 337 */
																										if (
																											(((obj_t)
																													BgL_typevz00_2938) ==
																												BGl_za2objza2z00zztype_cachez00))
																											{	/* Coerce/coerce.scm 340 */
																												BgL_casezd2valuezd2_2952
																													= BFALSE;
																											}
																										else
																											{	/* Coerce/coerce.scm 340 */
																												if (BGl_typezd2lesszd2specificzf3zf3zztype_miscz00(((BgL_typez00_bglt) BgL_typecz00_2933), BgL_typevz00_2938))
																													{	/* Coerce/coerce.scm 343 */
																														BgL_casezd2valuezd2_2952
																															=
																															CNST_TABLE_REF((
																																(long) 1));
																													}
																												else
																													{	/* Coerce/coerce.scm 343 */
																														if (BGl_typezd2disjointzf3z21zztype_miscz00(((BgL_typez00_bglt) BgL_typecz00_2933), BgL_typevz00_2938))
																															{	/* Coerce/coerce.scm 345 */
																																BgL_casezd2valuezd2_2952
																																	=
																																	CNST_TABLE_REF
																																	(((long) 2));
																															}
																														else
																															{	/* Coerce/coerce.scm 345 */
																																BgL_casezd2valuezd2_2952
																																	= BFALSE;
																															}
																													}
																											}
																									}
																								else
																									{	/* Coerce/coerce.scm 337 */
																										BgL_casezd2valuezd2_2952 =
																											BFALSE;
																									}
																							}
																						else
																							{	/* Coerce/coerce.scm 334 */
																								BgL_casezd2valuezd2_2952 =
																									BFALSE;
																							}
																					}
																				}
																			}
																		}
																	}
																else
																	{	/* Coerce/coerce.scm 349 */
																		bool_t BgL_test2209z00_3705;

																		{	/* Coerce/coerce.scm 349 */
																			bool_t BgL_test2210z00_3706;

																			{	/* Coerce/coerce.scm 349 */
																				BgL_nodez00_bglt BgL_arg1855z00_2941;

																				BgL_arg1855z00_2941 =
																					(((BgL_letzd2varzd2_bglt)
																						COBJECT(BgL_nodez00_2926))->
																					BgL_bodyz00);
																				{	/* Coerce/coerce.scm 349 */
																					bool_t BgL_res2061z00_2942;

																					BgL_res2061z00_2942 =
																						BGl_isazf3zf3zz__objectz00(
																						((obj_t) BgL_arg1855z00_2941),
																						BGl_varz00zzast_nodez00);
																					BgL_test2210z00_3706 =
																						BgL_res2061z00_2942;
																				}
																			}
																			if (BgL_test2210z00_3706)
																				{	/* Coerce/coerce.scm 349 */
																					obj_t BgL_tmpz00_3710;

																					{	/* Coerce/coerce.scm 349 */
																						obj_t BgL_pairz00_2943;

																						BgL_pairz00_2943 =
																							(((BgL_letzd2varzd2_bglt)
																								COBJECT(BgL_nodez00_2926))->
																							BgL_bindingsz00);
																						BgL_tmpz00_3710 =
																							CAR(CAR(BgL_pairz00_2943));
																					}
																					BgL_test2209z00_3705 =
																						(
																						((obj_t)
																							(((BgL_varz00_bglt) COBJECT(
																										((BgL_varz00_bglt)
																											(((BgL_letzd2varzd2_bglt)
																													COBJECT
																													(BgL_nodez00_2926))->
																												BgL_bodyz00))))->
																								BgL_variablez00)) ==
																						BgL_tmpz00_3710);
																				}
																			else
																				{	/* Coerce/coerce.scm 349 */
																					BgL_test2209z00_3705 = ((bool_t) 0);
																				}
																		}
																		if (BgL_test2209z00_3705)
																			{	/* Coerce/coerce.scm 350 */
																				obj_t BgL_arg1849z00_2944;

																				{	/* Coerce/coerce.scm 350 */
																					obj_t BgL_pairz00_2945;

																					BgL_pairz00_2945 =
																						(((BgL_letzd2varzd2_bglt)
																							COBJECT(BgL_nodez00_2926))->
																						BgL_bindingsz00);
																					BgL_arg1849z00_2944 =
																						CDR(CAR(BgL_pairz00_2945));
																				}
																				{
																					obj_t BgL_nodez00_3722;

																					BgL_nodez00_3722 =
																						BgL_arg1849z00_2944;
																					BgL_nodez00_2909 = BgL_nodez00_3722;
																					goto
																						BgL_testzd2staticzd2valuez00_2905;
																				}
																			}
																		else
																			{	/* Coerce/coerce.scm 349 */
																				BgL_casezd2valuezd2_2952 = BFALSE;
																			}
																	}
															}
														else
															{	/* Coerce/coerce.scm 311 */
																BgL_casezd2valuezd2_2952 = BFALSE;
															}
													}
												}
											else
												{	/* Coerce/coerce.scm 379 */
													BgL_casezd2valuezd2_2952 = BFALSE;
												}
										}
								}
						}
					}
					if ((BgL_casezd2valuezd2_2952 == CNST_TABLE_REF(((long) 1))))
						{	/* Coerce/coerce.scm 387 */
							BgL_nodez00_bglt BgL_arg1763z00_2954;

							BgL_arg1763z00_2954 =
								(((BgL_conditionalz00_bglt) COBJECT(
										((BgL_conditionalz00_bglt) BgL_nodez00_2730)))->
								BgL_truez00);
							return BGl_coercez12z12zzcoerce_coercez00(BgL_arg1763z00_2954,
								BgL_callerz00_2731, ((BgL_typez00_bglt) BgL_toz00_2732),
								CBOOL(BgL_safez00_2733));
						}
					else
						{	/* Coerce/coerce.scm 385 */
							if ((BgL_casezd2valuezd2_2952 == CNST_TABLE_REF(((long) 2))))
								{	/* Coerce/coerce.scm 389 */
									BgL_nodez00_bglt BgL_arg1765z00_2955;

									BgL_arg1765z00_2955 =
										(((BgL_conditionalz00_bglt) COBJECT(
												((BgL_conditionalz00_bglt) BgL_nodez00_2730)))->
										BgL_falsez00);
									return BGl_coercez12z12zzcoerce_coercez00(BgL_arg1765z00_2955,
										BgL_callerz00_2731, ((BgL_typez00_bglt) BgL_toz00_2732),
										CBOOL(BgL_safez00_2733));
								}
							else
								{	/* Coerce/coerce.scm 385 */
									{
										BgL_nodez00_bglt BgL_auxz00_3741;

										{	/* Coerce/coerce.scm 391 */
											BgL_nodez00_bglt BgL_arg1767z00_2956;

											BgL_arg1767z00_2956 =
												(((BgL_conditionalz00_bglt) COBJECT(
														((BgL_conditionalz00_bglt) BgL_nodez00_2730)))->
												BgL_truez00);
											BgL_auxz00_3741 =
												BGl_coercez12z12zzcoerce_coercez00(BgL_arg1767z00_2956,
												BgL_callerz00_2731, ((BgL_typez00_bglt) BgL_toz00_2732),
												CBOOL(BgL_safez00_2733));
										}
										((((BgL_conditionalz00_bglt) COBJECT(
														((BgL_conditionalz00_bglt) BgL_nodez00_2730)))->
												BgL_truez00) =
											((BgL_nodez00_bglt) BgL_auxz00_3741), BUNSPEC);
									}
									{
										BgL_nodez00_bglt BgL_auxz00_3749;

										{	/* Coerce/coerce.scm 392 */
											BgL_nodez00_bglt BgL_arg1768z00_2957;

											BgL_arg1768z00_2957 =
												(((BgL_conditionalz00_bglt) COBJECT(
														((BgL_conditionalz00_bglt) BgL_nodez00_2730)))->
												BgL_falsez00);
											BgL_auxz00_3749 =
												BGl_coercez12z12zzcoerce_coercez00(BgL_arg1768z00_2957,
												BgL_callerz00_2731, ((BgL_typez00_bglt) BgL_toz00_2732),
												CBOOL(BgL_safez00_2733));
										}
										((((BgL_conditionalz00_bglt) COBJECT(
														((BgL_conditionalz00_bglt) BgL_nodez00_2730)))->
												BgL_falsez00) =
											((BgL_nodez00_bglt) BgL_auxz00_3749), BUNSPEC);
									}
									((((BgL_nodez00_bglt) COBJECT(
													((BgL_nodez00_bglt)
														((BgL_conditionalz00_bglt) BgL_nodez00_2730))))->
											BgL_typez00) =
										((BgL_typez00_bglt) ((BgL_typez00_bglt) BgL_toz00_2732)),
										BUNSPEC);
									return ((BgL_nodez00_bglt) ((BgL_conditionalz00_bglt)
											BgL_nodez00_2730));
								}
						}
				}
			}
		}

	}



/* &coerce!-setq1318 */
	BgL_nodez00_bglt BGl_z62coercez12zd2setq1318za2zzcoerce_coercez00(obj_t
		BgL_envz00_2734, obj_t BgL_nodez00_2735, obj_t BgL_callerz00_2736,
		obj_t BgL_toz00_2737, obj_t BgL_safez00_2738)
	{
		{	/* Coerce/coerce.scm 264 */
			{
				BgL_nodez00_bglt BgL_auxz00_3763;

				{	/* Coerce/coerce.scm 266 */
					BgL_nodez00_bglt BgL_arg1756z00_2959;
					BgL_typez00_bglt BgL_arg1758z00_2960;

					BgL_arg1756z00_2959 =
						(((BgL_setqz00_bglt) COBJECT(
								((BgL_setqz00_bglt) BgL_nodez00_2735)))->BgL_valuez00);
					BgL_arg1758z00_2960 =
						(((BgL_variablez00_bglt) COBJECT(
								(((BgL_varz00_bglt) COBJECT(
											(((BgL_setqz00_bglt) COBJECT(
														((BgL_setqz00_bglt) BgL_nodez00_2735)))->
												BgL_varz00)))->BgL_variablez00)))->BgL_typez00);
					BgL_auxz00_3763 =
						BGl_coercez12z12zzcoerce_coercez00(BgL_arg1756z00_2959,
						BgL_callerz00_2736, BgL_arg1758z00_2960, CBOOL(BgL_safez00_2738));
				}
				((((BgL_setqz00_bglt) COBJECT(
								((BgL_setqz00_bglt) BgL_nodez00_2735)))->BgL_valuez00) =
					((BgL_nodez00_bglt) BgL_auxz00_3763), BUNSPEC);
			}
			return
				BGl_convertz12z12zzcoerce_convertz00(
				((BgL_nodez00_bglt)
					((BgL_setqz00_bglt) BgL_nodez00_2735)),
				((BgL_typez00_bglt) BGl_za2unspecza2z00zztype_cachez00),
				((BgL_typez00_bglt) BgL_toz00_2737), CBOOL(BgL_safez00_2738));
		}

	}



/* &coerce!-cast1316 */
	BgL_nodez00_bglt BGl_z62coercez12zd2cast1316za2zzcoerce_coercez00(obj_t
		BgL_envz00_2739, obj_t BgL_nodez00_2740, obj_t BgL_callerz00_2741,
		obj_t BgL_toz00_2742, obj_t BgL_safez00_2743)
	{
		{	/* Coerce/coerce.scm 254 */
			{
				BgL_nodez00_bglt BgL_auxz00_3780;

				{	/* Coerce/coerce.scm 258 */
					BgL_nodez00_bglt BgL_arg1750z00_2962;
					BgL_typez00_bglt BgL_arg1751z00_2963;

					BgL_arg1750z00_2962 =
						(((BgL_castz00_bglt) COBJECT(
								((BgL_castz00_bglt) BgL_nodez00_2740)))->BgL_argz00);
					{	/* Coerce/coerce.scm 258 */
						BgL_nodez00_bglt BgL_arg1752z00_2964;

						BgL_arg1752z00_2964 =
							(((BgL_castz00_bglt) COBJECT(
									((BgL_castz00_bglt) BgL_nodez00_2740)))->BgL_argz00);
						BgL_arg1751z00_2963 =
							BGl_getzd2typezd2zztype_typeofz00(BgL_arg1752z00_2964,
							((bool_t) 0));
					}
					BgL_auxz00_3780 =
						BGl_coercez12z12zzcoerce_coercez00(BgL_arg1750z00_2962,
						BgL_callerz00_2741, BgL_arg1751z00_2963, CBOOL(BgL_safez00_2743));
				}
				((((BgL_castz00_bglt) COBJECT(
								((BgL_castz00_bglt) BgL_nodez00_2740)))->BgL_argz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3780), BUNSPEC);
			}
			{	/* Coerce/coerce.scm 259 */
				BgL_typez00_bglt BgL_arg1753z00_2965;

				BgL_arg1753z00_2965 =
					(((BgL_nodez00_bglt) COBJECT(
							((BgL_nodez00_bglt)
								((BgL_castz00_bglt) BgL_nodez00_2740))))->BgL_typez00);
				return
					BGl_convertz12z12zzcoerce_convertz00(
					((BgL_nodez00_bglt)
						((BgL_castz00_bglt) BgL_nodez00_2740)), BgL_arg1753z00_2965,
					((BgL_typez00_bglt) BgL_toz00_2742), CBOOL(BgL_safez00_2743));
			}
		}

	}



/* &coerce!-vlength1314 */
	BgL_nodez00_bglt BGl_z62coercez12zd2vlength1314za2zzcoerce_coercez00(obj_t
		BgL_envz00_2744, obj_t BgL_nodez00_2745, obj_t BgL_callerz00_2746,
		obj_t BgL_toz00_2747, obj_t BgL_safez00_2748)
	{
		{	/* Coerce/coerce.scm 246 */
			{	/* Coerce/coerce.scm 248 */
				obj_t BgL_arg1723z00_2967;
				BgL_nodez00_bglt BgL_arg1731z00_2968;

				BgL_arg1723z00_2967 =
					(((BgL_externz00_bglt) COBJECT(
							((BgL_externz00_bglt)
								((BgL_vlengthz00_bglt) BgL_nodez00_2745))))->BgL_exprza2za2);
				{	/* Coerce/coerce.scm 248 */
					obj_t BgL_arg1736z00_2969;
					BgL_typez00_bglt BgL_arg1737z00_2970;

					{	/* Coerce/coerce.scm 248 */
						obj_t BgL_pairz00_2971;

						BgL_pairz00_2971 =
							(((BgL_externz00_bglt) COBJECT(
									((BgL_externz00_bglt)
										((BgL_vlengthz00_bglt) BgL_nodez00_2745))))->
							BgL_exprza2za2);
						BgL_arg1736z00_2969 = CAR(BgL_pairz00_2971);
					}
					BgL_arg1737z00_2970 =
						(((BgL_vlengthz00_bglt) COBJECT(
								((BgL_vlengthz00_bglt) BgL_nodez00_2745)))->BgL_vtypez00);
					BgL_arg1731z00_2968 =
						BGl_coercez12z12zzcoerce_coercez00(
						((BgL_nodez00_bglt) BgL_arg1736z00_2969), BgL_callerz00_2746,
						BgL_arg1737z00_2970, CBOOL(BgL_safez00_2748));
				}
				{	/* Coerce/coerce.scm 248 */
					obj_t BgL_auxz00_3812;
					obj_t BgL_tmpz00_3810;

					BgL_auxz00_3812 = ((obj_t) BgL_arg1731z00_2968);
					BgL_tmpz00_3810 = ((obj_t) BgL_arg1723z00_2967);
					SET_CAR(BgL_tmpz00_3810, BgL_auxz00_3812);
				}
			}
			{	/* Coerce/coerce.scm 249 */
				BgL_typez00_bglt BgL_arg1749z00_2972;

				BgL_arg1749z00_2972 =
					(((BgL_nodez00_bglt) COBJECT(
							((BgL_nodez00_bglt)
								((BgL_vlengthz00_bglt) BgL_nodez00_2745))))->BgL_typez00);
				return
					BGl_convertz12z12zzcoerce_convertz00(
					((BgL_nodez00_bglt)
						((BgL_vlengthz00_bglt) BgL_nodez00_2745)), BgL_arg1749z00_2972,
					((BgL_typez00_bglt) BgL_toz00_2747), CBOOL(BgL_safez00_2748));
			}
		}

	}



/* &coerce!-vset!1312 */
	BgL_nodez00_bglt BGl_z62coercez12zd2vsetz121312zb0zzcoerce_coercez00(obj_t
		BgL_envz00_2749, obj_t BgL_nodez00_2750, obj_t BgL_callerz00_2751,
		obj_t BgL_toz00_2752, obj_t BgL_safez00_2753)
	{
		{	/* Coerce/coerce.scm 234 */
			{	/* Coerce/coerce.scm 237 */
				obj_t BgL_ftypez00_2974;

				{	/* Coerce/coerce.scm 237 */
					bool_t BgL_test2213z00_3823;

					{	/* Coerce/coerce.scm 237 */
						BgL_typez00_bglt BgL_arg1717z00_2975;

						BgL_arg1717z00_2975 =
							(((BgL_vsetz12z12_bglt) COBJECT(
									((BgL_vsetz12z12_bglt) BgL_nodez00_2750)))->BgL_ftypez00);
						BgL_test2213z00_3823 =
							(((obj_t) BgL_arg1717z00_2975) == BGl_za2_za2z00zztype_cachez00);
					}
					if (BgL_test2213z00_3823)
						{	/* Coerce/coerce.scm 237 */
							BgL_ftypez00_2974 = BGl_za2objza2z00zztype_cachez00;
						}
					else
						{	/* Coerce/coerce.scm 237 */
							BgL_ftypez00_2974 =
								((obj_t)
								(((BgL_vsetz12z12_bglt) COBJECT(
											((BgL_vsetz12z12_bglt) BgL_nodez00_2750)))->
									BgL_ftypez00));
						}
				}
				{	/* Coerce/coerce.scm 238 */
					obj_t BgL_arg1675z00_2976;
					BgL_nodez00_bglt BgL_arg1676z00_2977;

					BgL_arg1675z00_2976 =
						(((BgL_externz00_bglt) COBJECT(
								((BgL_externz00_bglt)
									((BgL_vsetz12z12_bglt) BgL_nodez00_2750))))->BgL_exprza2za2);
					{	/* Coerce/coerce.scm 238 */
						obj_t BgL_arg1677z00_2978;
						BgL_typez00_bglt BgL_arg1679z00_2979;

						{	/* Coerce/coerce.scm 238 */
							obj_t BgL_pairz00_2980;

							BgL_pairz00_2980 =
								(((BgL_externz00_bglt) COBJECT(
										((BgL_externz00_bglt)
											((BgL_vsetz12z12_bglt) BgL_nodez00_2750))))->
								BgL_exprza2za2);
							BgL_arg1677z00_2978 = CAR(BgL_pairz00_2980);
						}
						BgL_arg1679z00_2979 =
							(((BgL_vsetz12z12_bglt) COBJECT(
									((BgL_vsetz12z12_bglt) BgL_nodez00_2750)))->BgL_vtypez00);
						BgL_arg1676z00_2977 =
							BGl_coercez12z12zzcoerce_coercez00(
							((BgL_nodez00_bglt) BgL_arg1677z00_2978), BgL_callerz00_2751,
							BgL_arg1679z00_2979, CBOOL(BgL_safez00_2753));
					}
					{	/* Coerce/coerce.scm 238 */
						obj_t BgL_auxz00_3845;
						obj_t BgL_tmpz00_3843;

						BgL_auxz00_3845 = ((obj_t) BgL_arg1676z00_2977);
						BgL_tmpz00_3843 = ((obj_t) BgL_arg1675z00_2976);
						SET_CAR(BgL_tmpz00_3843, BgL_auxz00_3845);
					}
				}
				{	/* Coerce/coerce.scm 239 */
					obj_t BgL_arg1681z00_2981;
					BgL_nodez00_bglt BgL_arg1687z00_2982;

					{	/* Coerce/coerce.scm 239 */
						obj_t BgL_pairz00_2983;

						BgL_pairz00_2983 =
							(((BgL_externz00_bglt) COBJECT(
									((BgL_externz00_bglt)
										((BgL_vsetz12z12_bglt) BgL_nodez00_2750))))->
							BgL_exprza2za2);
						BgL_arg1681z00_2981 = CDR(BgL_pairz00_2983);
					}
					{	/* Coerce/coerce.scm 239 */
						obj_t BgL_arg1691z00_2984;
						BgL_typez00_bglt BgL_arg1692z00_2985;

						{	/* Coerce/coerce.scm 239 */
							obj_t BgL_pairz00_2986;

							BgL_pairz00_2986 =
								(((BgL_externz00_bglt) COBJECT(
										((BgL_externz00_bglt)
											((BgL_vsetz12z12_bglt) BgL_nodez00_2750))))->
								BgL_exprza2za2);
							BgL_arg1691z00_2984 = CAR(CDR(BgL_pairz00_2986));
						}
						BgL_arg1692z00_2985 =
							(((BgL_vsetz12z12_bglt) COBJECT(
									((BgL_vsetz12z12_bglt) BgL_nodez00_2750)))->BgL_otypez00);
						BgL_arg1687z00_2982 =
							BGl_coercez12z12zzcoerce_coercez00(
							((BgL_nodez00_bglt) BgL_arg1691z00_2984), BgL_callerz00_2751,
							BgL_arg1692z00_2985, CBOOL(BgL_safez00_2753));
					}
					{	/* Coerce/coerce.scm 239 */
						obj_t BgL_auxz00_3864;
						obj_t BgL_tmpz00_3862;

						BgL_auxz00_3864 = ((obj_t) BgL_arg1687z00_2982);
						BgL_tmpz00_3862 = ((obj_t) BgL_arg1681z00_2981);
						SET_CAR(BgL_tmpz00_3862, BgL_auxz00_3864);
					}
				}
				{	/* Coerce/coerce.scm 240 */
					obj_t BgL_arg1694z00_2987;
					BgL_nodez00_bglt BgL_arg1695z00_2988;

					{	/* Coerce/coerce.scm 240 */
						obj_t BgL_pairz00_2989;

						BgL_pairz00_2989 =
							(((BgL_externz00_bglt) COBJECT(
									((BgL_externz00_bglt)
										((BgL_vsetz12z12_bglt) BgL_nodez00_2750))))->
							BgL_exprza2za2);
						BgL_arg1694z00_2987 = CDR(CDR(BgL_pairz00_2989));
					}
					{	/* Coerce/coerce.scm 240 */
						obj_t BgL_arg1702z00_2990;

						{	/* Coerce/coerce.scm 240 */
							obj_t BgL_pairz00_2991;

							BgL_pairz00_2991 =
								(((BgL_externz00_bglt) COBJECT(
										((BgL_externz00_bglt)
											((BgL_vsetz12z12_bglt) BgL_nodez00_2750))))->
								BgL_exprza2za2);
							BgL_arg1702z00_2990 = CAR(CDR(CDR(BgL_pairz00_2991)));
						}
						BgL_arg1695z00_2988 =
							BGl_coercez12z12zzcoerce_coercez00(
							((BgL_nodez00_bglt) BgL_arg1702z00_2990), BgL_callerz00_2751,
							((BgL_typez00_bglt) BgL_ftypez00_2974), CBOOL(BgL_safez00_2753));
					}
					{	/* Coerce/coerce.scm 240 */
						obj_t BgL_auxz00_3884;
						obj_t BgL_tmpz00_3882;

						BgL_auxz00_3884 = ((obj_t) BgL_arg1695z00_2988);
						BgL_tmpz00_3882 = ((obj_t) BgL_arg1694z00_2987);
						SET_CAR(BgL_tmpz00_3882, BgL_auxz00_3884);
					}
				}
				{	/* Coerce/coerce.scm 241 */
					BgL_typez00_bglt BgL_arg1710z00_2992;

					BgL_arg1710z00_2992 =
						(((BgL_nodez00_bglt) COBJECT(
								((BgL_nodez00_bglt)
									((BgL_vsetz12z12_bglt) BgL_nodez00_2750))))->BgL_typez00);
					return
						BGl_convertz12z12zzcoerce_convertz00(
						((BgL_nodez00_bglt)
							((BgL_vsetz12z12_bglt) BgL_nodez00_2750)), BgL_arg1710z00_2992,
						((BgL_typez00_bglt) BgL_toz00_2752), CBOOL(BgL_safez00_2753));
				}
			}
		}

	}



/* &coerce!-vref1310 */
	BgL_nodez00_bglt BGl_z62coercez12zd2vref1310za2zzcoerce_coercez00(obj_t
		BgL_envz00_2754, obj_t BgL_nodez00_2755, obj_t BgL_callerz00_2756,
		obj_t BgL_toz00_2757, obj_t BgL_safez00_2758)
	{
		{	/* Coerce/coerce.scm 218 */
			{	/* Coerce/coerce.scm 226 */
				obj_t BgL_ftypez00_2994;

				{	/* Coerce/coerce.scm 226 */
					bool_t BgL_test2214z00_3895;

					{	/* Coerce/coerce.scm 226 */
						BgL_typez00_bglt BgL_arg1673z00_2995;

						BgL_arg1673z00_2995 =
							(((BgL_vrefz00_bglt) COBJECT(
									((BgL_vrefz00_bglt) BgL_nodez00_2755)))->BgL_ftypez00);
						BgL_test2214z00_3895 =
							(((obj_t) BgL_arg1673z00_2995) == BGl_za2_za2z00zztype_cachez00);
					}
					if (BgL_test2214z00_3895)
						{	/* Coerce/coerce.scm 226 */
							BgL_ftypez00_2994 = BGl_za2objza2z00zztype_cachez00;
						}
					else
						{	/* Coerce/coerce.scm 226 */
							BgL_ftypez00_2994 =
								((obj_t)
								(((BgL_vrefz00_bglt) COBJECT(
											((BgL_vrefz00_bglt) BgL_nodez00_2755)))->BgL_ftypez00));
						}
				}
				{	/* Coerce/coerce.scm 227 */
					obj_t BgL_arg1648z00_2996;
					BgL_nodez00_bglt BgL_arg1650z00_2997;

					BgL_arg1648z00_2996 =
						(((BgL_externz00_bglt) COBJECT(
								((BgL_externz00_bglt)
									((BgL_vrefz00_bglt) BgL_nodez00_2755))))->BgL_exprza2za2);
					{	/* Coerce/coerce.scm 227 */
						obj_t BgL_arg1651z00_2998;
						BgL_typez00_bglt BgL_arg1653z00_2999;

						{	/* Coerce/coerce.scm 227 */
							obj_t BgL_pairz00_3000;

							BgL_pairz00_3000 =
								(((BgL_externz00_bglt) COBJECT(
										((BgL_externz00_bglt)
											((BgL_vrefz00_bglt) BgL_nodez00_2755))))->BgL_exprza2za2);
							BgL_arg1651z00_2998 = CAR(BgL_pairz00_3000);
						}
						BgL_arg1653z00_2999 =
							(((BgL_vrefz00_bglt) COBJECT(
									((BgL_vrefz00_bglt) BgL_nodez00_2755)))->BgL_vtypez00);
						BgL_arg1650z00_2997 =
							BGl_coercez12z12zzcoerce_coercez00(
							((BgL_nodez00_bglt) BgL_arg1651z00_2998), BgL_callerz00_2756,
							BgL_arg1653z00_2999, CBOOL(BgL_safez00_2758));
					}
					{	/* Coerce/coerce.scm 227 */
						obj_t BgL_auxz00_3917;
						obj_t BgL_tmpz00_3915;

						BgL_auxz00_3917 = ((obj_t) BgL_arg1650z00_2997);
						BgL_tmpz00_3915 = ((obj_t) BgL_arg1648z00_2996);
						SET_CAR(BgL_tmpz00_3915, BgL_auxz00_3917);
					}
				}
				{	/* Coerce/coerce.scm 228 */
					obj_t BgL_arg1656z00_3001;
					BgL_nodez00_bglt BgL_arg1660z00_3002;

					{	/* Coerce/coerce.scm 228 */
						obj_t BgL_pairz00_3003;

						BgL_pairz00_3003 =
							(((BgL_externz00_bglt) COBJECT(
									((BgL_externz00_bglt)
										((BgL_vrefz00_bglt) BgL_nodez00_2755))))->BgL_exprza2za2);
						BgL_arg1656z00_3001 = CDR(BgL_pairz00_3003);
					}
					{	/* Coerce/coerce.scm 228 */
						obj_t BgL_arg1665z00_3004;
						BgL_typez00_bglt BgL_arg1668z00_3005;

						{	/* Coerce/coerce.scm 228 */
							obj_t BgL_pairz00_3006;

							BgL_pairz00_3006 =
								(((BgL_externz00_bglt) COBJECT(
										((BgL_externz00_bglt)
											((BgL_vrefz00_bglt) BgL_nodez00_2755))))->BgL_exprza2za2);
							BgL_arg1665z00_3004 = CAR(CDR(BgL_pairz00_3006));
						}
						BgL_arg1668z00_3005 =
							(((BgL_vrefz00_bglt) COBJECT(
									((BgL_vrefz00_bglt) BgL_nodez00_2755)))->BgL_otypez00);
						BgL_arg1660z00_3002 =
							BGl_coercez12z12zzcoerce_coercez00(
							((BgL_nodez00_bglt) BgL_arg1665z00_3004), BgL_callerz00_2756,
							BgL_arg1668z00_3005, CBOOL(BgL_safez00_2758));
					}
					{	/* Coerce/coerce.scm 228 */
						obj_t BgL_auxz00_3936;
						obj_t BgL_tmpz00_3934;

						BgL_auxz00_3936 = ((obj_t) BgL_arg1660z00_3002);
						BgL_tmpz00_3934 = ((obj_t) BgL_arg1656z00_3001);
						SET_CAR(BgL_tmpz00_3934, BgL_auxz00_3936);
					}
				}
				return
					BGl_convertz12z12zzcoerce_convertz00(
					((BgL_nodez00_bglt)
						((BgL_vrefz00_bglt) BgL_nodez00_2755)),
					((BgL_typez00_bglt) BgL_ftypez00_2994),
					((BgL_typez00_bglt) BgL_toz00_2757), CBOOL(BgL_safez00_2758));
			}
		}

	}



/* &coerce!-valloc1308 */
	BgL_nodez00_bglt BGl_z62coercez12zd2valloc1308za2zzcoerce_coercez00(obj_t
		BgL_envz00_2759, obj_t BgL_nodez00_2760, obj_t BgL_callerz00_2761,
		obj_t BgL_toz00_2762, obj_t BgL_safez00_2763)
	{
		{	/* Coerce/coerce.scm 210 */
			{	/* Coerce/coerce.scm 212 */
				obj_t BgL_arg1637z00_3008;
				BgL_nodez00_bglt BgL_arg1639z00_3009;

				BgL_arg1637z00_3008 =
					(((BgL_externz00_bglt) COBJECT(
							((BgL_externz00_bglt)
								((BgL_vallocz00_bglt) BgL_nodez00_2760))))->BgL_exprza2za2);
				{	/* Coerce/coerce.scm 212 */
					obj_t BgL_arg1641z00_3010;
					BgL_typez00_bglt BgL_arg1644z00_3011;

					{	/* Coerce/coerce.scm 212 */
						obj_t BgL_pairz00_3012;

						BgL_pairz00_3012 =
							(((BgL_externz00_bglt) COBJECT(
									((BgL_externz00_bglt)
										((BgL_vallocz00_bglt) BgL_nodez00_2760))))->BgL_exprza2za2);
						BgL_arg1641z00_3010 = CAR(BgL_pairz00_3012);
					}
					BgL_arg1644z00_3011 =
						(((BgL_vallocz00_bglt) COBJECT(
								((BgL_vallocz00_bglt) BgL_nodez00_2760)))->BgL_otypez00);
					BgL_arg1639z00_3009 =
						BGl_coercez12z12zzcoerce_coercez00(
						((BgL_nodez00_bglt) BgL_arg1641z00_3010), BgL_callerz00_2761,
						BgL_arg1644z00_3011, CBOOL(BgL_safez00_2763));
				}
				{	/* Coerce/coerce.scm 212 */
					obj_t BgL_auxz00_3959;
					obj_t BgL_tmpz00_3957;

					BgL_auxz00_3959 = ((obj_t) BgL_arg1639z00_3009);
					BgL_tmpz00_3957 = ((obj_t) BgL_arg1637z00_3008);
					SET_CAR(BgL_tmpz00_3957, BgL_auxz00_3959);
				}
			}
			{	/* Coerce/coerce.scm 213 */
				BgL_typez00_bglt BgL_arg1647z00_3013;

				BgL_arg1647z00_3013 =
					(((BgL_nodez00_bglt) COBJECT(
							((BgL_nodez00_bglt)
								((BgL_vallocz00_bglt) BgL_nodez00_2760))))->BgL_typez00);
				return
					BGl_convertz12z12zzcoerce_convertz00(
					((BgL_nodez00_bglt)
						((BgL_vallocz00_bglt) BgL_nodez00_2760)), BgL_arg1647z00_3013,
					((BgL_typez00_bglt) BgL_toz00_2762), CBOOL(BgL_safez00_2763));
			}
		}

	}



/* &coerce!-new1306 */
	BgL_nodez00_bglt BGl_z62coercez12zd2new1306za2zzcoerce_coercez00(obj_t
		BgL_envz00_2764, obj_t BgL_nodez00_2765, obj_t BgL_callerz00_2766,
		obj_t BgL_toz00_2767, obj_t BgL_safez00_2768)
	{
		{	/* Coerce/coerce.scm 196 */
			{
				obj_t BgL_lz00_3016;

				{	/* Coerce/coerce.scm 198 */
					obj_t BgL_arg1626z00_3022;

					BgL_arg1626z00_3022 =
						(((BgL_externz00_bglt) COBJECT(
								((BgL_externz00_bglt)
									((BgL_newz00_bglt) BgL_nodez00_2765))))->BgL_exprza2za2);
					BgL_lz00_3016 = BgL_arg1626z00_3022;
				BgL_loopz00_3015:
					if (NULLP(BgL_lz00_3016))
						{	/* Coerce/coerce.scm 200 */
							BgL_typez00_bglt BgL_arg1631z00_3017;

							BgL_arg1631z00_3017 =
								(((BgL_nodez00_bglt) COBJECT(
										((BgL_nodez00_bglt)
											((BgL_newz00_bglt) BgL_nodez00_2765))))->BgL_typez00);
							BGl_convertz12z12zzcoerce_convertz00(
								((BgL_nodez00_bglt)
									((BgL_newz00_bglt) BgL_nodez00_2765)), BgL_arg1631z00_3017,
								((BgL_typez00_bglt) BgL_toz00_2767), CBOOL(BgL_safez00_2768));
						}
					else
						{	/* Coerce/coerce.scm 201 */
							obj_t BgL_vz00_3018;

							BgL_vz00_3018 = CAR(((obj_t) BgL_lz00_3016));
							{	/* Coerce/coerce.scm 201 */
								BgL_nodez00_bglt BgL_nvz00_3019;

								{	/* Coerce/coerce.scm 202 */
									BgL_typez00_bglt BgL_arg1633z00_3020;

									BgL_arg1633z00_3020 =
										BGl_getzd2typezd2zztype_typeofz00(
										((BgL_nodez00_bglt) BgL_vz00_3018), ((bool_t) 0));
									BgL_nvz00_3019 =
										BGl_coercez12z12zzcoerce_coercez00(
										((BgL_nodez00_bglt) BgL_vz00_3018), BgL_callerz00_2766,
										BgL_arg1633z00_3020, CBOOL(BgL_safez00_2768));
								}
								{	/* Coerce/coerce.scm 202 */

									{	/* Coerce/coerce.scm 203 */
										obj_t BgL_auxz00_3992;
										obj_t BgL_tmpz00_3990;

										BgL_auxz00_3992 = ((obj_t) BgL_nvz00_3019);
										BgL_tmpz00_3990 = ((obj_t) BgL_lz00_3016);
										SET_CAR(BgL_tmpz00_3990, BgL_auxz00_3992);
									}
									{	/* Coerce/coerce.scm 204 */
										obj_t BgL_arg1632z00_3021;

										BgL_arg1632z00_3021 = CDR(((obj_t) BgL_lz00_3016));
										{
											obj_t BgL_lz00_3997;

											BgL_lz00_3997 = BgL_arg1632z00_3021;
											BgL_lz00_3016 = BgL_lz00_3997;
											goto BgL_loopz00_3015;
										}
									}
								}
							}
						}
				}
			}
			{	/* Coerce/coerce.scm 205 */
				BgL_typez00_bglt BgL_arg1636z00_3023;

				BgL_arg1636z00_3023 =
					(((BgL_nodez00_bglt) COBJECT(
							((BgL_nodez00_bglt)
								((BgL_newz00_bglt) BgL_nodez00_2765))))->BgL_typez00);
				return
					BGl_convertz12z12zzcoerce_convertz00(
					((BgL_nodez00_bglt)
						((BgL_newz00_bglt) BgL_nodez00_2765)), BgL_arg1636z00_3023,
					((BgL_typez00_bglt) BgL_toz00_2767), CBOOL(BgL_safez00_2768));
			}
		}

	}



/* &coerce!-setfield1304 */
	BgL_nodez00_bglt BGl_z62coercez12zd2setfield1304za2zzcoerce_coercez00(obj_t
		BgL_envz00_2769, obj_t BgL_nodez00_2770, obj_t BgL_callerz00_2771,
		obj_t BgL_toz00_2772, obj_t BgL_safez00_2773)
	{
		{	/* Coerce/coerce.scm 187 */
			{	/* Coerce/coerce.scm 189 */
				obj_t BgL_arg1574z00_3025;
				BgL_nodez00_bglt BgL_arg1578z00_3026;

				BgL_arg1574z00_3025 =
					(((BgL_externz00_bglt) COBJECT(
							((BgL_externz00_bglt)
								((BgL_setfieldz00_bglt) BgL_nodez00_2770))))->BgL_exprza2za2);
				{	/* Coerce/coerce.scm 189 */
					obj_t BgL_arg1579z00_3027;
					BgL_typez00_bglt BgL_arg1585z00_3028;

					{	/* Coerce/coerce.scm 189 */
						obj_t BgL_pairz00_3029;

						BgL_pairz00_3029 =
							(((BgL_externz00_bglt) COBJECT(
									((BgL_externz00_bglt)
										((BgL_setfieldz00_bglt) BgL_nodez00_2770))))->
							BgL_exprza2za2);
						BgL_arg1579z00_3027 = CAR(BgL_pairz00_3029);
					}
					BgL_arg1585z00_3028 =
						(((BgL_setfieldz00_bglt) COBJECT(
								((BgL_setfieldz00_bglt) BgL_nodez00_2770)))->BgL_otypez00);
					BgL_arg1578z00_3026 =
						BGl_coercez12z12zzcoerce_coercez00(
						((BgL_nodez00_bglt) BgL_arg1579z00_3027), BgL_callerz00_2771,
						BgL_arg1585z00_3028, CBOOL(BgL_safez00_2773));
				}
				{	/* Coerce/coerce.scm 189 */
					obj_t BgL_auxz00_4020;
					obj_t BgL_tmpz00_4018;

					BgL_auxz00_4020 = ((obj_t) BgL_arg1578z00_3026);
					BgL_tmpz00_4018 = ((obj_t) BgL_arg1574z00_3025);
					SET_CAR(BgL_tmpz00_4018, BgL_auxz00_4020);
				}
			}
			{	/* Coerce/coerce.scm 190 */
				obj_t BgL_arg1594z00_3030;
				BgL_nodez00_bglt BgL_arg1598z00_3031;

				{	/* Coerce/coerce.scm 190 */
					obj_t BgL_pairz00_3032;

					BgL_pairz00_3032 =
						(((BgL_externz00_bglt) COBJECT(
								((BgL_externz00_bglt)
									((BgL_setfieldz00_bglt) BgL_nodez00_2770))))->BgL_exprza2za2);
					BgL_arg1594z00_3030 = CDR(BgL_pairz00_3032);
				}
				{	/* Coerce/coerce.scm 190 */
					obj_t BgL_arg1609z00_3033;
					BgL_typez00_bglt BgL_arg1613z00_3034;

					{	/* Coerce/coerce.scm 190 */
						obj_t BgL_pairz00_3035;

						BgL_pairz00_3035 =
							(((BgL_externz00_bglt) COBJECT(
									((BgL_externz00_bglt)
										((BgL_setfieldz00_bglt) BgL_nodez00_2770))))->
							BgL_exprza2za2);
						BgL_arg1609z00_3033 = CAR(CDR(BgL_pairz00_3035));
					}
					BgL_arg1613z00_3034 =
						(((BgL_setfieldz00_bglt) COBJECT(
								((BgL_setfieldz00_bglt) BgL_nodez00_2770)))->BgL_ftypez00);
					BgL_arg1598z00_3031 =
						BGl_coercez12z12zzcoerce_coercez00(
						((BgL_nodez00_bglt) BgL_arg1609z00_3033), BgL_callerz00_2771,
						BgL_arg1613z00_3034, CBOOL(BgL_safez00_2773));
				}
				{	/* Coerce/coerce.scm 190 */
					obj_t BgL_auxz00_4039;
					obj_t BgL_tmpz00_4037;

					BgL_auxz00_4039 = ((obj_t) BgL_arg1598z00_3031);
					BgL_tmpz00_4037 = ((obj_t) BgL_arg1594z00_3030);
					SET_CAR(BgL_tmpz00_4037, BgL_auxz00_4039);
				}
			}
			return
				BGl_convertz12z12zzcoerce_convertz00(
				((BgL_nodez00_bglt)
					((BgL_setfieldz00_bglt) BgL_nodez00_2770)),
				((BgL_typez00_bglt) BGl_za2unspecza2z00zztype_cachez00),
				((BgL_typez00_bglt) BgL_toz00_2772), CBOOL(BgL_safez00_2773));
		}

	}



/* &coerce!-getfield1302 */
	BgL_nodez00_bglt BGl_z62coercez12zd2getfield1302za2zzcoerce_coercez00(obj_t
		BgL_envz00_2774, obj_t BgL_nodez00_2775, obj_t BgL_callerz00_2776,
		obj_t BgL_toz00_2777, obj_t BgL_safez00_2778)
	{
		{	/* Coerce/coerce.scm 179 */
			{	/* Coerce/coerce.scm 181 */
				obj_t BgL_arg1558z00_3037;
				BgL_nodez00_bglt BgL_arg1559z00_3038;

				BgL_arg1558z00_3037 =
					(((BgL_externz00_bglt) COBJECT(
							((BgL_externz00_bglt)
								((BgL_getfieldz00_bglt) BgL_nodez00_2775))))->BgL_exprza2za2);
				{	/* Coerce/coerce.scm 181 */
					obj_t BgL_arg1563z00_3039;
					BgL_typez00_bglt BgL_arg1564z00_3040;

					{	/* Coerce/coerce.scm 181 */
						obj_t BgL_pairz00_3041;

						BgL_pairz00_3041 =
							(((BgL_externz00_bglt) COBJECT(
									((BgL_externz00_bglt)
										((BgL_getfieldz00_bglt) BgL_nodez00_2775))))->
							BgL_exprza2za2);
						BgL_arg1563z00_3039 = CAR(BgL_pairz00_3041);
					}
					BgL_arg1564z00_3040 =
						(((BgL_getfieldz00_bglt) COBJECT(
								((BgL_getfieldz00_bglt) BgL_nodez00_2775)))->BgL_otypez00);
					BgL_arg1559z00_3038 =
						BGl_coercez12z12zzcoerce_coercez00(
						((BgL_nodez00_bglt) BgL_arg1563z00_3039), BgL_callerz00_2776,
						BgL_arg1564z00_3040, CBOOL(BgL_safez00_2778));
				}
				{	/* Coerce/coerce.scm 181 */
					obj_t BgL_auxz00_4062;
					obj_t BgL_tmpz00_4060;

					BgL_auxz00_4062 = ((obj_t) BgL_arg1559z00_3038);
					BgL_tmpz00_4060 = ((obj_t) BgL_arg1558z00_3037);
					SET_CAR(BgL_tmpz00_4060, BgL_auxz00_4062);
				}
			}
			{	/* Coerce/coerce.scm 182 */
				BgL_typez00_bglt BgL_arg1573z00_3042;

				BgL_arg1573z00_3042 =
					(((BgL_getfieldz00_bglt) COBJECT(
							((BgL_getfieldz00_bglt) BgL_nodez00_2775)))->BgL_ftypez00);
				return
					BGl_convertz12z12zzcoerce_convertz00(
					((BgL_nodez00_bglt)
						((BgL_getfieldz00_bglt) BgL_nodez00_2775)), BgL_arg1573z00_3042,
					((BgL_typez00_bglt) BgL_toz00_2777), CBOOL(BgL_safez00_2778));
			}
		}

	}



/* &coerce!-widening1300 */
	BgL_nodez00_bglt BGl_z62coercez12zd2widening1300za2zzcoerce_coercez00(obj_t
		BgL_envz00_2779, obj_t BgL_nodez00_2780, obj_t BgL_callerz00_2781,
		obj_t BgL_toz00_2782, obj_t BgL_safez00_2783)
	{
		{	/* Coerce/coerce.scm 168 */
			{	/* Coerce/coerce.scm 172 */
				obj_t BgL_superz00_3044;

				{	/* Coerce/coerce.scm 172 */
					BgL_typez00_bglt BgL_oz00_3045;

					BgL_oz00_3045 =
						((BgL_typez00_bglt)
						(((BgL_wideningz00_bglt) COBJECT(
									((BgL_wideningz00_bglt) BgL_nodez00_2780)))->BgL_otypez00));
					{
						BgL_tclassz00_bglt BgL_auxz00_4075;

						{
							obj_t BgL_auxz00_4076;

							{	/* Coerce/coerce.scm 172 */
								BgL_objectz00_bglt BgL_tmpz00_4077;

								BgL_tmpz00_4077 = ((BgL_objectz00_bglt) BgL_oz00_3045);
								BgL_auxz00_4076 = BGL_OBJECT_WIDENING(BgL_tmpz00_4077);
							}
							BgL_auxz00_4075 = ((BgL_tclassz00_bglt) BgL_auxz00_4076);
						}
						BgL_superz00_3044 =
							(((BgL_tclassz00_bglt) COBJECT(BgL_auxz00_4075))->
							BgL_itszd2superzd2);
					}
				}
				{	/* Coerce/coerce.scm 173 */
					obj_t BgL_arg1540z00_3046;
					BgL_nodez00_bglt BgL_arg1541z00_3047;

					BgL_arg1540z00_3046 =
						(((BgL_externz00_bglt) COBJECT(
								((BgL_externz00_bglt)
									((BgL_wideningz00_bglt) BgL_nodez00_2780))))->BgL_exprza2za2);
					{	/* Coerce/coerce.scm 173 */
						obj_t BgL_arg1544z00_3048;

						{	/* Coerce/coerce.scm 173 */
							obj_t BgL_pairz00_3049;

							BgL_pairz00_3049 =
								(((BgL_externz00_bglt) COBJECT(
										((BgL_externz00_bglt)
											((BgL_wideningz00_bglt) BgL_nodez00_2780))))->
								BgL_exprza2za2);
							BgL_arg1544z00_3048 = CAR(BgL_pairz00_3049);
						}
						BgL_arg1541z00_3047 =
							BGl_coercez12z12zzcoerce_coercez00(
							((BgL_nodez00_bglt) BgL_arg1544z00_3048), BgL_callerz00_2781,
							((BgL_typez00_bglt) BgL_superz00_3044), CBOOL(BgL_safez00_2783));
					}
					{	/* Coerce/coerce.scm 173 */
						obj_t BgL_auxz00_4095;
						obj_t BgL_tmpz00_4093;

						BgL_auxz00_4095 = ((obj_t) BgL_arg1541z00_3047);
						BgL_tmpz00_4093 = ((obj_t) BgL_arg1540z00_3046);
						SET_CAR(BgL_tmpz00_4093, BgL_auxz00_4095);
					}
				}
				return
					BGl_convertz12z12zzcoerce_convertz00(
					((BgL_nodez00_bglt)
						((BgL_wideningz00_bglt) BgL_nodez00_2780)),
					((BgL_typez00_bglt) BGl_za2objza2z00zztype_cachez00),
					((BgL_typez00_bglt) BgL_toz00_2782), CBOOL(BgL_safez00_2783));
			}
		}

	}



/* &coerce!-extern1298 */
	BgL_nodez00_bglt BGl_z62coercez12zd2extern1298za2zzcoerce_coercez00(obj_t
		BgL_envz00_2784, obj_t BgL_nodez00_2785, obj_t BgL_callerz00_2786,
		obj_t BgL_toz00_2787, obj_t BgL_safez00_2788)
	{
		{	/* Coerce/coerce.scm 155 */
			{
				obj_t BgL_valuesz00_3052;

				BgL_valuesz00_3052 =
					(((BgL_externz00_bglt) COBJECT(
							((BgL_externz00_bglt) BgL_nodez00_2785)))->BgL_exprza2za2);
			BgL_loopz00_3051:
				if (NULLP(BgL_valuesz00_3052))
					{	/* Coerce/coerce.scm 159 */
						BgL_typez00_bglt BgL_arg1524z00_3053;

						BgL_arg1524z00_3053 =
							BGl_getzd2typezd2zztype_typeofz00(
							((BgL_nodez00_bglt)
								((BgL_externz00_bglt) BgL_nodez00_2785)), ((bool_t) 0));
						return
							BGl_convertz12z12zzcoerce_convertz00(
							((BgL_nodez00_bglt)
								((BgL_externz00_bglt) BgL_nodez00_2785)), BgL_arg1524z00_3053,
							((BgL_typez00_bglt) BgL_toz00_2787), CBOOL(BgL_safez00_2788));
					}
				else
					{	/* Coerce/coerce.scm 160 */
						obj_t BgL_vz00_3054;

						BgL_vz00_3054 = CAR(((obj_t) BgL_valuesz00_3052));
						{	/* Coerce/coerce.scm 160 */
							BgL_nodez00_bglt BgL_nvz00_3055;

							{	/* Coerce/coerce.scm 161 */
								BgL_typez00_bglt BgL_arg1536z00_3056;

								BgL_arg1536z00_3056 =
									BGl_getzd2typezd2zztype_typeofz00(
									((BgL_nodez00_bglt) BgL_vz00_3054), ((bool_t) 0));
								BgL_nvz00_3055 =
									BGl_coercez12z12zzcoerce_coercez00(
									((BgL_nodez00_bglt) BgL_vz00_3054), BgL_callerz00_2786,
									BgL_arg1536z00_3056, CBOOL(BgL_safez00_2788));
							}
							{	/* Coerce/coerce.scm 161 */

								{	/* Coerce/coerce.scm 162 */
									obj_t BgL_auxz00_4123;
									obj_t BgL_tmpz00_4121;

									BgL_auxz00_4123 = ((obj_t) BgL_nvz00_3055);
									BgL_tmpz00_4121 = ((obj_t) BgL_valuesz00_3052);
									SET_CAR(BgL_tmpz00_4121, BgL_auxz00_4123);
								}
								{	/* Coerce/coerce.scm 163 */
									obj_t BgL_arg1530z00_3057;

									BgL_arg1530z00_3057 = CDR(((obj_t) BgL_valuesz00_3052));
									{
										obj_t BgL_valuesz00_4128;

										BgL_valuesz00_4128 = BgL_arg1530z00_3057;
										BgL_valuesz00_3052 = BgL_valuesz00_4128;
										goto BgL_loopz00_3051;
									}
								}
							}
						}
					}
			}
		}

	}



/* &coerce!-sync1296 */
	BgL_nodez00_bglt BGl_z62coercez12zd2sync1296za2zzcoerce_coercez00(obj_t
		BgL_envz00_2789, obj_t BgL_nodez00_2790, obj_t BgL_callerz00_2791,
		obj_t BgL_toz00_2792, obj_t BgL_safez00_2793)
	{
		{	/* Coerce/coerce.scm 144 */
			{
				BgL_nodez00_bglt BgL_auxz00_4131;

				{	/* Coerce/coerce.scm 146 */
					BgL_nodez00_bglt BgL_arg1506z00_3059;

					BgL_arg1506z00_3059 =
						(((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nodez00_2790)))->BgL_mutexz00);
					BgL_auxz00_4131 =
						BGl_coercez12z12zzcoerce_coercez00(BgL_arg1506z00_3059,
						BgL_callerz00_2791,
						((BgL_typez00_bglt) BGl_za2mutexza2z00zztype_cachez00),
						CBOOL(BgL_safez00_2793));
				}
				((((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nodez00_2790)))->BgL_mutexz00) =
					((BgL_nodez00_bglt) BgL_auxz00_4131), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_4139;

				{	/* Coerce/coerce.scm 147 */
					BgL_nodez00_bglt BgL_arg1507z00_3060;

					BgL_arg1507z00_3060 =
						(((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nodez00_2790)))->BgL_prelockz00);
					BgL_auxz00_4139 =
						BGl_coercez12z12zzcoerce_coercez00(BgL_arg1507z00_3060,
						BgL_callerz00_2791,
						((BgL_typez00_bglt) BGl_za2pairzd2nilza2zd2zztype_cachez00),
						CBOOL(BgL_safez00_2793));
				}
				((((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nodez00_2790)))->BgL_prelockz00) =
					((BgL_nodez00_bglt) BgL_auxz00_4139), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_4147;

				{	/* Coerce/coerce.scm 148 */
					BgL_nodez00_bglt BgL_arg1511z00_3061;

					BgL_arg1511z00_3061 =
						(((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nodez00_2790)))->BgL_bodyz00);
					BgL_auxz00_4147 =
						BGl_coercez12z12zzcoerce_coercez00(BgL_arg1511z00_3061,
						BgL_callerz00_2791, ((BgL_typez00_bglt) BgL_toz00_2792),
						CBOOL(BgL_safez00_2793));
				}
				((((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nodez00_2790)))->BgL_bodyz00) =
					((BgL_nodez00_bglt) BgL_auxz00_4147), BUNSPEC);
			}
			{
				BgL_typez00_bglt BgL_auxz00_4155;

				{	/* Coerce/coerce.scm 149 */
					BgL_typez00_bglt BgL_arg1514z00_3062;

					BgL_arg1514z00_3062 =
						(((BgL_nodez00_bglt) COBJECT(
								((BgL_nodez00_bglt)
									((BgL_syncz00_bglt) BgL_nodez00_2790))))->BgL_typez00);
					BgL_auxz00_4155 =
						BGl_strictzd2nodezd2typez00zzast_nodez00(
						((BgL_typez00_bglt) BgL_toz00_2792), BgL_arg1514z00_3062);
				}
				((((BgL_nodez00_bglt) COBJECT(
								((BgL_nodez00_bglt)
									((BgL_syncz00_bglt) BgL_nodez00_2790))))->BgL_typez00) =
					((BgL_typez00_bglt) BgL_auxz00_4155), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_syncz00_bglt) BgL_nodez00_2790));
		}

	}



/* &coerce!-sequence1294 */
	BgL_nodez00_bglt BGl_z62coercez12zd2sequence1294za2zzcoerce_coercez00(obj_t
		BgL_envz00_2794, obj_t BgL_nodez00_2795, obj_t BgL_callerz00_2796,
		obj_t BgL_toz00_2797, obj_t BgL_safez00_2798)
	{
		{	/* Coerce/coerce.scm 127 */
			{	/* Coerce/coerce.scm 129 */
				obj_t BgL_sz00_3064;

				if (
					(((BgL_sequencez00_bglt) COBJECT(
								((BgL_sequencez00_bglt) BgL_nodez00_2795)))->BgL_unsafez00))
					{	/* Coerce/coerce.scm 129 */
						BgL_sz00_3064 = BFALSE;
					}
				else
					{	/* Coerce/coerce.scm 129 */
						BgL_sz00_3064 = BgL_safez00_2798;
					}
				{
					obj_t BgL_nodesz00_3066;

					{	/* Coerce/coerce.scm 130 */
						obj_t BgL_arg1470z00_3073;

						BgL_arg1470z00_3073 =
							(((BgL_sequencez00_bglt) COBJECT(
									((BgL_sequencez00_bglt) BgL_nodez00_2795)))->BgL_nodesz00);
						{
							BgL_sequencez00_bglt BgL_auxz00_4171;

							BgL_nodesz00_3066 = BgL_arg1470z00_3073;
						BgL_loopz00_3065:
							{	/* Coerce/coerce.scm 131 */
								obj_t BgL_nz00_3067;

								BgL_nz00_3067 = CAR(((obj_t) BgL_nodesz00_3066));
								if (NULLP(CDR(((obj_t) BgL_nodesz00_3066))))
									{	/* Coerce/coerce.scm 132 */
										{	/* Coerce/coerce.scm 134 */
											BgL_nodez00_bglt BgL_arg1488z00_3068;

											BgL_arg1488z00_3068 =
												BGl_coercez12z12zzcoerce_coercez00(
												((BgL_nodez00_bglt) BgL_nz00_3067), BgL_callerz00_2796,
												((BgL_typez00_bglt) BgL_toz00_2797),
												CBOOL(BgL_sz00_3064));
											{	/* Coerce/coerce.scm 134 */
												obj_t BgL_auxz00_4184;
												obj_t BgL_tmpz00_4182;

												BgL_auxz00_4184 = ((obj_t) BgL_arg1488z00_3068);
												BgL_tmpz00_4182 = ((obj_t) BgL_nodesz00_3066);
												SET_CAR(BgL_tmpz00_4182, BgL_auxz00_4184);
											}
										}
										{
											BgL_typez00_bglt BgL_auxz00_4187;

											{	/* Coerce/coerce.scm 135 */
												BgL_typez00_bglt BgL_arg1489z00_3069;

												BgL_arg1489z00_3069 =
													(((BgL_nodez00_bglt) COBJECT(
															((BgL_nodez00_bglt)
																((BgL_sequencez00_bglt) BgL_nodez00_2795))))->
													BgL_typez00);
												BgL_auxz00_4187 =
													BGl_strictzd2nodezd2typez00zzast_nodez00((
														(BgL_typez00_bglt) BgL_toz00_2797),
													BgL_arg1489z00_3069);
											}
											((((BgL_nodez00_bglt) COBJECT(
															((BgL_nodez00_bglt)
																((BgL_sequencez00_bglt) BgL_nodez00_2795))))->
													BgL_typez00) =
												((BgL_typez00_bglt) BgL_auxz00_4187), BUNSPEC);
										}
										BgL_auxz00_4171 = ((BgL_sequencez00_bglt) BgL_nodez00_2795);
									}
								else
									{	/* Coerce/coerce.scm 132 */
										{	/* Coerce/coerce.scm 138 */
											BgL_nodez00_bglt BgL_arg1493z00_3070;

											{	/* Coerce/coerce.scm 138 */
												BgL_typez00_bglt BgL_arg1495z00_3071;

												BgL_arg1495z00_3071 =
													BGl_getzd2typezd2zztype_typeofz00(
													((BgL_nodez00_bglt) BgL_nz00_3067), ((bool_t) 0));
												BgL_arg1493z00_3070 =
													BGl_coercez12z12zzcoerce_coercez00(
													((BgL_nodez00_bglt) BgL_nz00_3067),
													BgL_callerz00_2796, BgL_arg1495z00_3071,
													CBOOL(BgL_sz00_3064));
											}
											{	/* Coerce/coerce.scm 138 */
												obj_t BgL_auxz00_4204;
												obj_t BgL_tmpz00_4202;

												BgL_auxz00_4204 = ((obj_t) BgL_arg1493z00_3070);
												BgL_tmpz00_4202 = ((obj_t) BgL_nodesz00_3066);
												SET_CAR(BgL_tmpz00_4202, BgL_auxz00_4204);
											}
										}
										{	/* Coerce/coerce.scm 139 */
											obj_t BgL_arg1499z00_3072;

											BgL_arg1499z00_3072 = CDR(((obj_t) BgL_nodesz00_3066));
											{
												obj_t BgL_nodesz00_4209;

												BgL_nodesz00_4209 = BgL_arg1499z00_3072;
												BgL_nodesz00_3066 = BgL_nodesz00_4209;
												goto BgL_loopz00_3065;
											}
										}
									}
							}
							return ((BgL_nodez00_bglt) BgL_auxz00_4171);
						}
					}
				}
			}
		}

	}



/* &coerce!-closure1292 */
	BgL_nodez00_bglt BGl_z62coercez12zd2closure1292za2zzcoerce_coercez00(obj_t
		BgL_envz00_2799, obj_t BgL_nodez00_2800, obj_t BgL_callerz00_2801,
		obj_t BgL_toz00_2802, obj_t BgL_safez00_2803)
	{
		{	/* Coerce/coerce.scm 121 */
			{	/* Coerce/coerce.scm 122 */
				obj_t BgL_arg1467z00_3075;

				BgL_arg1467z00_3075 =
					BGl_shapez00zztools_shapez00(
					((obj_t) ((BgL_closurez00_bglt) BgL_nodez00_2800)));
				return
					((BgL_nodez00_bglt)
					BGl_internalzd2errorzd2zztools_errorz00
					(BGl_string2080z00zzcoerce_coercez00,
						BGl_string2112z00zzcoerce_coercez00, BgL_arg1467z00_3075));
			}
		}

	}



/* &coerce!-var1290 */
	BgL_nodez00_bglt BGl_z62coercez12zd2var1290za2zzcoerce_coercez00(obj_t
		BgL_envz00_2804, obj_t BgL_nodez00_2805, obj_t BgL_callerz00_2806,
		obj_t BgL_toz00_2807, obj_t BgL_safez00_2808)
	{
		{	/* Coerce/coerce.scm 106 */
			{	/* Coerce/coerce.scm 108 */
				BgL_typez00_bglt BgL_ntypez00_3077;
				BgL_typez00_bglt BgL_vtypez00_3078;

				BgL_ntypez00_3077 =
					BGl_getzd2typezd2zztype_typeofz00(
					((BgL_nodez00_bglt)
						((BgL_varz00_bglt) BgL_nodez00_2805)), ((bool_t) 0));
				BgL_vtypez00_3078 =
					(((BgL_variablez00_bglt) COBJECT(
							(((BgL_varz00_bglt) COBJECT(
										((BgL_varz00_bglt) BgL_nodez00_2805)))->BgL_variablez00)))->
					BgL_typez00);
				if ((((obj_t) BgL_vtypez00_3078) == BgL_toz00_2807))
					{	/* Coerce/coerce.scm 111 */
						return ((BgL_nodez00_bglt) ((BgL_varz00_bglt) BgL_nodez00_2805));
					}
				else
					{	/* Coerce/coerce.scm 111 */
						if ((((obj_t) BgL_ntypez00_3077) == ((obj_t) BgL_vtypez00_3078)))
							{	/* Coerce/coerce.scm 113 */
								return
									BGl_convertz12z12zzcoerce_convertz00(
									((BgL_nodez00_bglt)
										((BgL_varz00_bglt) BgL_nodez00_2805)), BgL_ntypez00_3077,
									((BgL_typez00_bglt) BgL_toz00_2807), CBOOL(BgL_safez00_2808));
							}
						else
							{	/* Coerce/coerce.scm 116 */
								BgL_nodez00_bglt BgL_arg1452z00_3079;

								BgL_arg1452z00_3079 =
									BGl_convertz12z12zzcoerce_convertz00(
									((BgL_nodez00_bglt)
										((BgL_varz00_bglt) BgL_nodez00_2805)), BgL_vtypez00_3078,
									BgL_ntypez00_3077, ((bool_t) 0));
								return BGl_convertz12z12zzcoerce_convertz00(BgL_arg1452z00_3079,
									BgL_ntypez00_3077, ((BgL_typez00_bglt) BgL_toz00_2807),
									CBOOL(BgL_safez00_2808));
							}
					}
			}
		}

	}



/* &coerce!-kwote1288 */
	BgL_nodez00_bglt BGl_z62coercez12zd2kwote1288za2zzcoerce_coercez00(obj_t
		BgL_envz00_2809, obj_t BgL_nodez00_2810, obj_t BgL_callerz00_2811,
		obj_t BgL_toz00_2812, obj_t BgL_safez00_2813)
	{
		{	/* Coerce/coerce.scm 91 */
			{	/* Coerce/coerce.scm 92 */
				BgL_typez00_bglt BgL_arg1437z00_3081;

				BgL_arg1437z00_3081 =
					BGl_getzd2typezd2zztype_typeofz00(
					((BgL_nodez00_bglt)
						((BgL_kwotez00_bglt) BgL_nodez00_2810)), ((bool_t) 0));
				return
					BGl_convertz12z12zzcoerce_convertz00(
					((BgL_nodez00_bglt)
						((BgL_kwotez00_bglt) BgL_nodez00_2810)), BgL_arg1437z00_3081,
					((BgL_typez00_bglt) BgL_toz00_2812), CBOOL(BgL_safez00_2813));
			}
		}

	}



/* &coerce!-atom1286 */
	BgL_nodez00_bglt BGl_z62coercez12zd2atom1286za2zzcoerce_coercez00(obj_t
		BgL_envz00_2814, obj_t BgL_nodez00_2815, obj_t BgL_callerz00_2816,
		obj_t BgL_toz00_2817, obj_t BgL_safez00_2818)
	{
		{	/* Coerce/coerce.scm 85 */
			{	/* Coerce/coerce.scm 86 */
				BgL_typez00_bglt BgL_arg1430z00_3083;

				BgL_arg1430z00_3083 =
					BGl_getzd2typezd2zztype_typeofz00(
					((BgL_nodez00_bglt)
						((BgL_atomz00_bglt) BgL_nodez00_2815)), ((bool_t) 0));
				return
					BGl_convertz12z12zzcoerce_convertz00(
					((BgL_nodez00_bglt)
						((BgL_atomz00_bglt) BgL_nodez00_2815)), BgL_arg1430z00_3083,
					((BgL_typez00_bglt) BgL_toz00_2817), CBOOL(BgL_safez00_2818));
			}
		}

	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzcoerce_coercez00()
	{
		{	/* Coerce/coerce.scm 15 */
			BGl_modulezd2initializa7ationz75zztools_tracez00(((long) 54713316),
				BSTRING_TO_STRING(BGl_string2113z00zzcoerce_coercez00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 476633989),
				BSTRING_TO_STRING(BGl_string2113z00zzcoerce_coercez00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 365925558),
				BSTRING_TO_STRING(BGl_string2113z00zzcoerce_coercez00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 300504031),
				BSTRING_TO_STRING(BGl_string2113z00zzcoerce_coercez00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 515343395),
				BSTRING_TO_STRING(BGl_string2113z00zzcoerce_coercez00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 346491734),
				BSTRING_TO_STRING(BGl_string2113z00zzcoerce_coercez00));
			BGl_modulezd2initializa7ationz75zztype_coercionz00(((long) 116865673),
				BSTRING_TO_STRING(BGl_string2113z00zzcoerce_coercez00));
			BGl_modulezd2initializa7ationz75zztype_typeofz00(((long) 398780265),
				BSTRING_TO_STRING(BGl_string2113z00zzcoerce_coercez00));
			BGl_modulezd2initializa7ationz75zztype_miscz00(((long) 49975086),
				BSTRING_TO_STRING(BGl_string2113z00zzcoerce_coercez00));
			BGl_modulezd2initializa7ationz75zzobject_classz00(((long) 502007119),
				BSTRING_TO_STRING(BGl_string2113z00zzcoerce_coercez00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 90839984),
				BSTRING_TO_STRING(BGl_string2113z00zzcoerce_coercez00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 506185397),
				BSTRING_TO_STRING(BGl_string2113z00zzcoerce_coercez00));
			BGl_modulezd2initializa7ationz75zzast_dumpz00(((long) 271707717),
				BSTRING_TO_STRING(BGl_string2113z00zzcoerce_coercez00));
			BGl_modulezd2initializa7ationz75zzcoerce_pprotoz00(((long) 44915300),
				BSTRING_TO_STRING(BGl_string2113z00zzcoerce_coercez00));
			BGl_modulezd2initializa7ationz75zzcoerce_convertz00(((long) 87995645),
				BSTRING_TO_STRING(BGl_string2113z00zzcoerce_coercez00));
			BGl_modulezd2initializa7ationz75zzcoerce_appz00(((long) 419328946),
				BSTRING_TO_STRING(BGl_string2113z00zzcoerce_coercez00));
			BGl_modulezd2initializa7ationz75zzcoerce_applyz00(((long) 435902431),
				BSTRING_TO_STRING(BGl_string2113z00zzcoerce_coercez00));
			BGl_modulezd2initializa7ationz75zzcoerce_funcallz00(((long) 40876382),
				BSTRING_TO_STRING(BGl_string2113z00zzcoerce_coercez00));
			return
				BGl_modulezd2initializa7ationz75zzeffect_effectz00(((long) 460136018),
				BSTRING_TO_STRING(BGl_string2113z00zzcoerce_coercez00));
		}

	}

#ifdef __cplusplus
}
#endif
