/*===========================================================================*/
/*   (Dataflow/walk.scm)                                                     */
/*   Bigloo (4.3g)                                                           */
/*   Inria -- Sophia Antipolis (c)       Wed 12 Feb 2020 07:45:41 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.3g -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Dataflow/walk.scm) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		bool_t BgL_evalzf3zf3;
		obj_t BgL_libraryz00;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
		obj_t BgL_initz00;
		obj_t BgL_aliasz00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_localz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		long BgL_keyz00;
	}               *BgL_localz00_bglt;

	typedef struct BgL_funz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
	}             *BgL_funz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
		obj_t BgL_strengthz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_atomz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}              *BgL_atomz00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
		bool_t BgL_unsafez00;
		obj_t BgL_metaz00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_appzd2lyzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}                  *BgL_appzd2lyzd2_bglt;

	typedef struct BgL_funcallz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_strengthz00;
		obj_t BgL_functionsz00;
	}                 *BgL_funcallz00_bglt;

	typedef struct BgL_externz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
	}                *BgL_externz00_bglt;

	typedef struct BgL_instanceofz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
		obj_t BgL_czd2formatzd2;
		struct BgL_typez00_bgl *BgL_classz00;
	}                    *BgL_instanceofz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_failz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_procz00;
		struct BgL_nodez00_bgl *BgL_msgz00;
		struct BgL_nodez00_bgl *BgL_objz00;
	}              *BgL_failz00_bglt;

	typedef struct BgL_switchz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_switchz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;

	typedef struct BgL_setzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                       *BgL_setzd2exzd2itz00_bglt;

	typedef struct BgL_jumpzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_exitz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                        *BgL_jumpzd2exzd2itz00_bglt;

	typedef struct BgL_makezd2boxzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                    *BgL_makezd2boxzd2_bglt;

	typedef struct BgL_boxzd2setz12zc0_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                      *BgL_boxzd2setz12zc0_bglt;

	typedef struct BgL_syncz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_mutexz00;
		struct BgL_nodez00_bgl *BgL_prelockz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}              *BgL_syncz00_bglt;

	typedef struct BgL_localzf2valuezf2_bgl
	{
		int BgL_stampz00;
		struct BgL_nodez00_bgl *BgL_nodez00;
	}                       *BgL_localzf2valuezf2_bglt;


	static obj_t BGl_z62abortzf3zd2sync1441z43zzdataflow_walkz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_classzd2nilzd2initz12z12zz__objectz00(obj_t);
	extern obj_t BGl_closurez00zzast_nodez00;
	extern obj_t BGl_za2pairzd2nilza2zd2zztype_cachez00;
	BGL_IMPORT obj_t bgl_display_obj(obj_t, obj_t);
	extern obj_t BGl_syncz00zzast_nodez00;
	static obj_t
		BGl_z62dataflowzd2nodez12zd2appzd2l1387za2zzdataflow_walkz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_sequencez00zzast_nodez00;
	BGL_IMPORT bool_t BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(obj_t);
	BGL_IMPORT obj_t BGl_assqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	extern obj_t BGl_failz00zzast_nodez00;
	static obj_t BGl_objectzd2initzd2zzdataflow_walkz00();
	static obj_t BGl_z62dataflowzd2nodez12zd2funca1389z70zzdataflow_walkz00(obj_t,
		obj_t, obj_t);
	BGL_IMPORT bool_t BGl_2ze3ze3zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern obj_t BGl_boxzd2refzd2zzast_nodez00;
	static obj_t
		BGl_z62dataflowzd2nodez12zd2boxzd2r1414za2zzdataflow_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t
		BGl_dataflowzd2testzd2falsezd2envzd2zzdataflow_walkz00(BgL_nodez00_bglt);
	static obj_t
		BGl_z62dataflowzd2nodez12zd2letzd2f1404za2zzdataflow_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62dataflowzd2nodez12zd2sync1383z70zzdataflow_walkz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62dataflowzd2nodez12zd2fail1397z70zzdataflow_walkz00(obj_t,
		obj_t, obj_t);
	static obj_t
		BGl_z62dataflowzd2nodez12zd2letzd2v1406za2zzdataflow_walkz00(obj_t, obj_t,
		obj_t);
	BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_dataflowzd2walkz12zc0zzdataflow_walkz00(obj_t,
		obj_t);
	static obj_t BGl_appendzd221011zd2zzdataflow_walkz00(obj_t, obj_t);
	static obj_t BGl_methodzd2initzd2zzdataflow_walkz00();
	static obj_t
		BGl_z62dataflowzd2nodez12zd2jumpzd21410za2zzdataflow_walkz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_externz00zzast_nodez00;
	static obj_t
		BGl_z62dataflowzd2nodez12zd2boxzd2s1416za2zzdataflow_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62abortzf3zd2letzd2fun1445z91zzdataflow_walkz00(obj_t,
		obj_t);
	static obj_t BGl_z62dataflowzd2nodez121373za2zzdataflow_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_dataflowzd2nodeza2z12z62zzdataflow_walkz00(obj_t, obj_t);
	extern obj_t BGl_za2_za2z00zztype_cachez00;
	static obj_t BGl_z62dataflowzd2nodez12zd2app1385z70zzdataflow_walkz00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_za2objza2z00zztype_cachez00;
	static obj_t BGl_z62dataflowzd2testzd2envzd2ap1420zb0zzdataflow_walkz00(obj_t,
		obj_t);
	static obj_t BGl_za2z42pairzf3za2zb1zzdataflow_walkz00 = BUNSPEC;
	static obj_t
		BGl_z62dataflowzd2nodez12zd2makezd21412za2zzdataflow_walkz00(obj_t, obj_t,
		obj_t);
	extern bool_t BGl_typezd2subclasszf3z21zzobject_classz00(BgL_typez00_bglt,
		BgL_typez00_bglt);
	extern obj_t BGl_appzd2lyzd2zzast_nodez00;
	static obj_t BGl_z62dataflowzd2nodez12za2zzdataflow_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62abortzf3z91zzdataflow_walkz00(obj_t, obj_t);
	static obj_t BGl_z62dataflowzd2nodez12zd2closu1379z70zzdataflow_walkz00(obj_t,
		obj_t, obj_t);
	BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t,
		long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_gczd2rootszd2initz00zzdataflow_walkz00();
	static obj_t BGl_z62dataflowzd2testzd2envzd2co1424zb0zzdataflow_walkz00(obj_t,
		obj_t);
	static obj_t BGl_z62dataflowzd2testzd2falsezd2envzb0zzdataflow_walkz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1614z62zzdataflow_walkz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1615z62zzdataflow_walkz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62abortzf3zd2letzd2var1443z91zzdataflow_walkz00(obj_t,
		obj_t);
	static obj_t BGl_z62dataflowzd2testzd2falsezd21430zb0zzdataflow_walkz00(obj_t,
		obj_t);
	static obj_t BGl_z62abortzf3zd2sequence1439z43zzdataflow_walkz00(obj_t,
		obj_t);
	static obj_t BGl_z62dataflowzd2testzd2falsezd21433zb0zzdataflow_walkz00(obj_t,
		obj_t);
	static BgL_nodez00_bglt BGl_z62lambda1628z62zzdataflow_walkz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1629z62zzdataflow_walkz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_za2currentzd2passza2zd2zzengine_passz00;
	BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62dataflowzd2nodez12zd2seque1381z70zzdataflow_walkz00(obj_t,
		obj_t, obj_t);
	extern bool_t BGl_bigloozd2typezf3z21zztype_typez00(BgL_typez00_bglt);
	extern obj_t BGl_conditionalz00zzast_nodez00;
	static obj_t BGl_z62dataflowzd2testzd2envzd2le1429zb0zzdataflow_walkz00(obj_t,
		obj_t);
	extern obj_t BGl_verbosez00zztools_speekz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza31586ze3ze5zzdataflow_walkz00(obj_t,
		obj_t);
	extern obj_t BGl_setqz00zzast_nodez00;
	static obj_t BGl_requirezd2initializa7ationz75zzdataflow_walkz00 = BUNSPEC;
	extern obj_t BGl_funz00zzast_varz00;
	extern obj_t BGl_setzd2exzd2itz00zzast_nodez00;
	BGL_IMPORT obj_t BGl_za2classesza2z00zz__objectz00;
	extern obj_t BGl_tclassz00zzobject_classz00;
	BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_atomz00zzast_nodez00;
	static obj_t BGl_z62dataflowzd2testzd2envz62zzdataflow_walkz00(obj_t, obj_t);
	static obj_t BGl_toplevelzd2initzd2zzdataflow_walkz00();
	static obj_t BGl_z62dataflowzd2walkz12za2zzdataflow_walkz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_internalzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_genericzd2initzd2zzdataflow_walkz00();
	BGL_IMPORT obj_t BGl_filterzd2mapzd2zz__r4_control_features_6_9z00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t,
		bool_t, bool_t, obj_t, obj_t, obj_t);
	extern obj_t BGl_za2boolza2z00zztype_cachez00;
	static obj_t BGl_za2z42epairzf3za2zb1zzdataflow_walkz00 = BUNSPEC;
	static obj_t BGl_z62dataflowzd2nodez12zd2exter1391z70zzdataflow_walkz00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_typez00zztype_typez00;
	static obj_t BGl_z62dataflowzd2nodez12zd2setq1393z70zzdataflow_walkz00(obj_t,
		obj_t, obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	static obj_t BGl_z62dataflowzd2nodez12zd2var1377z70zzdataflow_walkz00(obj_t,
		obj_t, obj_t);
	BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_abortzf3zf3zzdataflow_walkz00(BgL_nodez00_bglt);
	static obj_t BGl_z62dataflowzd2nodez12zd2condi1395z70zzdataflow_walkz00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00;
	extern obj_t BGl_varz00zzast_nodez00;
	extern BgL_typez00_bglt BGl_getzd2typezd2zztype_typeofz00(BgL_nodez00_bglt,
		bool_t);
	extern obj_t BGl_makezd2boxzd2zzast_nodez00;
	extern obj_t BGl_za2pairza2z00zztype_cachez00;
	static long BGl_letzd2varzd2stampz00zzdataflow_walkz00;
	static obj_t BGl_z62abortzf31434z91zzdataflow_walkz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_exitz00zz__errorz00(obj_t);
	extern obj_t BGl_boxzd2setz12zc0zzast_nodez00;
	static obj_t BGl_z62dataflowzd2testzd2envzd2in1422zb0zzdataflow_walkz00(obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zzdataflow_walkz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzeffect_feffectz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzeffect_spreadz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzeffect_cgraphz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_dumpz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzobject_classz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_miscz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typeofz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_passz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_speekz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	extern obj_t BGl_appz00zzast_nodez00;
	extern obj_t BGl_nodez00zzast_nodez00;
	extern obj_t BGl_localz00zzast_varz00;
	extern obj_t BGl_jumpzd2exzd2itz00zzast_nodez00;
	static obj_t BGl_cnstzd2initzd2zzdataflow_walkz00();
	static obj_t BGl_libraryzd2moduleszd2initz00zzdataflow_walkz00();
	static obj_t BGl_z62dataflowzd2nodez12zd2switc1400z70zzdataflow_walkz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62dataflowzd2testzd2env1417z62zzdataflow_walkz00(obj_t,
		obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zzdataflow_walkz00();
	static obj_t BGl_za2z42nullzf3za2zb1zzdataflow_walkz00 = BUNSPEC;
	static obj_t BGl_z62abortzf3zd2app1449z43zzdataflow_walkz00(obj_t, obj_t);
	extern obj_t BGl_findzd2globalzf2modulez20zzast_envz00(obj_t, obj_t);
	static obj_t BGl_dataflowzd2testzd2envz00zzdataflow_walkz00(BgL_nodez00_bglt);
	extern obj_t BGl_za2bnilza2z00zztype_cachez00;
	extern obj_t BGl_instanceofz00zzast_nodez00;
	static obj_t BGl_z62zc3z04anonymousza31806ze3ze5zzdataflow_walkz00(obj_t,
		obj_t);
	extern obj_t BGl_letzd2funzd2zzast_nodez00;
	extern obj_t BGl_valuez00zzast_varz00;
	static obj_t BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(BgL_nodez00_bglt,
		obj_t);
	static obj_t BGl_localzf2valuezf2zzdataflow_walkz00 = BUNSPEC;
	static obj_t BGl_z62abortzf3zd2funcall1451z43zzdataflow_walkz00(obj_t, obj_t);
	extern obj_t BGl_switchz00zzast_nodez00;
	static obj_t BGl_z62abortzf3zd2conditional1447z43zzdataflow_walkz00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_classzd2superzd2zz__objectz00(obj_t);
	static BgL_localz00_bglt BGl_z62lambda1575z62zzdataflow_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_isazd2ofzd2zztype_miscz00(BgL_nodez00_bglt);
	static obj_t
		BGl_z62dataflowzd2nodez12zd2setzd2e1408za2zzdataflow_walkz00(obj_t, obj_t,
		obj_t);
	static BgL_localz00_bglt BGl_z62lambda1580z62zzdataflow_walkz00(obj_t, obj_t);
	static BgL_localz00_bglt BGl_z62lambda1587z62zzdataflow_walkz00(obj_t, obj_t);
	extern obj_t BGl_funcallz00zzast_nodez00;
	static obj_t BGl_z62abortzf3zd2appzd2ly1453z91zzdataflow_walkz00(obj_t,
		obj_t);
	extern obj_t BGl_globalz00zzast_varz00;
	static obj_t BGl_z62abortzf3zd2fail1437z43zzdataflow_walkz00(obj_t, obj_t);
	static obj_t BGl_z62dataflowzd2testzd2envzd2va1426zb0zzdataflow_walkz00(obj_t,
		obj_t);
	static obj_t __cnst[12];


	   
		 
		DEFINE_STRING(BGl_string2300z00zzdataflow_walkz00,
		BgL_bgl_string2300za700za7za7d2320za7, "dataflow-test-false-env", 23);
	      DEFINE_STRING(BGl_string2302z00zzdataflow_walkz00,
		BgL_bgl_string2302za700za7za7d2321za7, "abort?", 6);
	      DEFINE_STRING(BGl_string2311z00zzdataflow_walkz00,
		BgL_bgl_string2311za700za7za7d2322za7, "dataflow_walk", 13);
	      DEFINE_STRING(BGl_string2312z00zzdataflow_walkz00,
		BgL_bgl_string2312za700za7za7d2323za7,
		"read _ dataflow_walk local/value node int stamp $epair? $pair? foreign $null? pass-started ",
		91);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2257z00zzdataflow_walkz00,
		BgL_bgl_za762lambda1615za7622324z00, BGl_z62lambda1615z62zzdataflow_walkz00,
		0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2258z00zzdataflow_walkz00,
		BgL_bgl_za762lambda1614za7622325z00, BGl_z62lambda1614z62zzdataflow_walkz00,
		0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2259z00zzdataflow_walkz00,
		BgL_bgl_za762lambda1629za7622326z00, BGl_z62lambda1629z62zzdataflow_walkz00,
		0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2260z00zzdataflow_walkz00,
		BgL_bgl_za762lambda1628za7622327z00, BGl_z62lambda1628z62zzdataflow_walkz00,
		0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2261z00zzdataflow_walkz00,
		BgL_bgl_za762lambda1587za7622328z00, BGl_z62lambda1587z62zzdataflow_walkz00,
		0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2262z00zzdataflow_walkz00,
		BgL_bgl_za762za7c3za704anonymo2329za7,
		BGl_z62zc3z04anonymousza31586ze3ze5zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2263z00zzdataflow_walkz00,
		BgL_bgl_za762lambda1580za7622330z00, BGl_z62lambda1580z62zzdataflow_walkz00,
		0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2264z00zzdataflow_walkz00,
		BgL_bgl_za762lambda1575za7622331z00, BGl_z62lambda1575z62zzdataflow_walkz00,
		0L, BUNSPEC, 13);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2265z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2332z00,
		BGl_z62dataflowzd2nodez121373za2zzdataflow_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2267z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2te2333z00,
		BGl_z62dataflowzd2testzd2env1417z62zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2269z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2te2334z00,
		BGl_z62dataflowzd2testzd2falsezd21430zb0zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2271z00zzdataflow_walkz00,
		BgL_bgl_za762abortza7f31434za72335za7,
		BGl_z62abortzf31434z91zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2273z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2336z00,
		BGl_z62dataflowzd2nodez12zd2var1377z70zzdataflow_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2275z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2337z00,
		BGl_z62dataflowzd2nodez12zd2closu1379z70zzdataflow_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2276z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2338z00,
		BGl_z62dataflowzd2nodez12zd2seque1381z70zzdataflow_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2277z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2339z00,
		BGl_z62dataflowzd2nodez12zd2sync1383z70zzdataflow_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2278z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2340z00,
		BGl_z62dataflowzd2nodez12zd2app1385z70zzdataflow_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2279z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2341z00,
		BGl_z62dataflowzd2nodez12zd2appzd2l1387za2zzdataflow_walkz00, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2280z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2342z00,
		BGl_z62dataflowzd2nodez12zd2funca1389z70zzdataflow_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2281z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2343z00,
		BGl_z62dataflowzd2nodez12zd2exter1391z70zzdataflow_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2282z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2344z00,
		BGl_z62dataflowzd2nodez12zd2setq1393z70zzdataflow_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2283z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2345z00,
		BGl_z62dataflowzd2nodez12zd2condi1395z70zzdataflow_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2284z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2346z00,
		BGl_z62dataflowzd2nodez12zd2fail1397z70zzdataflow_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2285z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2347z00,
		BGl_z62dataflowzd2nodez12zd2switc1400z70zzdataflow_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2286z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2348z00,
		BGl_z62dataflowzd2nodez12zd2letzd2f1404za2zzdataflow_walkz00, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2287z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2349z00,
		BGl_z62dataflowzd2nodez12zd2letzd2v1406za2zzdataflow_walkz00, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2288z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2350z00,
		BGl_z62dataflowzd2nodez12zd2setzd2e1408za2zzdataflow_walkz00, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2289z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2351z00,
		BGl_z62dataflowzd2nodez12zd2jumpzd21410za2zzdataflow_walkz00, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2290z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2352z00,
		BGl_z62dataflowzd2nodez12zd2makezd21412za2zzdataflow_walkz00, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2291z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2353z00,
		BGl_z62dataflowzd2nodez12zd2boxzd2r1414za2zzdataflow_walkz00, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2292z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2354z00,
		BGl_z62dataflowzd2nodez12zd2boxzd2s1416za2zzdataflow_walkz00, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2293z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2te2355z00,
		BGl_z62dataflowzd2testzd2envzd2ap1420zb0zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2295z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2te2356z00,
		BGl_z62dataflowzd2testzd2envzd2in1422zb0zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2296z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2te2357z00,
		BGl_z62dataflowzd2testzd2envzd2co1424zb0zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2297z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2te2358z00,
		BGl_z62dataflowzd2testzd2envzd2va1426zb0zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2298z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2te2359z00,
		BGl_z62dataflowzd2testzd2envzd2le1429zb0zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2299z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2te2360z00,
		BGl_z62dataflowzd2testzd2falsezd21433zb0zzdataflow_walkz00, 0L, BUNSPEC, 1);
	     
		DEFINE_STATIC_BGL_GENERIC
		(BGl_dataflowzd2testzd2falsezd2envzd2envz00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2te2361z00,
		BGl_z62dataflowzd2testzd2falsezd2envzb0zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2301z00zzdataflow_walkz00,
		BgL_bgl_za762abortza7f3za7d2fa2362za7,
		BGl_z62abortzf3zd2fail1437z43zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2303z00zzdataflow_walkz00,
		BgL_bgl_za762abortza7f3za7d2se2363za7,
		BGl_z62abortzf3zd2sequence1439z43zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2304z00zzdataflow_walkz00,
		BgL_bgl_za762abortza7f3za7d2sy2364za7,
		BGl_z62abortzf3zd2sync1441z43zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2305z00zzdataflow_walkz00,
		BgL_bgl_za762abortza7f3za7d2le2365za7,
		BGl_z62abortzf3zd2letzd2var1443z91zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2306z00zzdataflow_walkz00,
		BgL_bgl_za762abortza7f3za7d2le2366za7,
		BGl_z62abortzf3zd2letzd2fun1445z91zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2307z00zzdataflow_walkz00,
		BgL_bgl_za762abortza7f3za7d2co2367za7,
		BGl_z62abortzf3zd2conditional1447z43zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2308z00zzdataflow_walkz00,
		BgL_bgl_za762abortza7f3za7d2ap2368za7,
		BGl_z62abortzf3zd2app1449z43zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2309z00zzdataflow_walkz00,
		BgL_bgl_za762abortza7f3za7d2fu2369za7,
		BGl_z62abortzf3zd2funcall1451z43zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2310z00zzdataflow_walkz00,
		BgL_bgl_za762abortza7f3za7d2ap2370za7,
		BGl_z62abortzf3zd2appzd2ly1453z91zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2250z00zzdataflow_walkz00,
		BgL_bgl_string2250za700za7za7d2371za7, "   . ", 5);
	      DEFINE_STRING(BGl_string2251z00zzdataflow_walkz00,
		BgL_bgl_string2251za700za7za7d2372za7, "failure during prelude hook", 27);
	      DEFINE_STRING(BGl_string2252z00zzdataflow_walkz00,
		BgL_bgl_string2252za700za7za7d2373za7, " error", 6);
	      DEFINE_STRING(BGl_string2253z00zzdataflow_walkz00,
		BgL_bgl_string2253za700za7za7d2374za7, "s", 1);
	      DEFINE_STRING(BGl_string2254z00zzdataflow_walkz00,
		BgL_bgl_string2254za700za7za7d2375za7, "", 0);
	      DEFINE_STRING(BGl_string2255z00zzdataflow_walkz00,
		BgL_bgl_string2255za700za7za7d2376za7, " occured, ending ...", 20);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_dataflowzd2walkz12zd2envz12zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2wa2377z00,
		BGl_z62dataflowzd2walkz12za2zzdataflow_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2256z00zzdataflow_walkz00,
		BgL_bgl_string2256za700za7za7d2378za7, "failure during postlude hook", 28);
	      DEFINE_STATIC_BGL_GENERIC(BGl_abortzf3zd2envz21zzdataflow_walkz00,
		BgL_bgl_za762abortza7f3za791za7za72379za7,
		BGl_z62abortzf3z91zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2266z00zzdataflow_walkz00,
		BgL_bgl_string2266za700za7za7d2380za7, "dataflow-node!1373", 18);
	      DEFINE_STRING(BGl_string2268z00zzdataflow_walkz00,
		BgL_bgl_string2268za700za7za7d2381za7, "dataflow-test-env1417", 21);
	      DEFINE_STRING(BGl_string2270z00zzdataflow_walkz00,
		BgL_bgl_string2270za700za7za7d2382za7, "dataflow-test-false-1430", 24);
	      DEFINE_STRING(BGl_string2272z00zzdataflow_walkz00,
		BgL_bgl_string2272za700za7za7d2383za7, "abort?1434", 10);
	      DEFINE_STRING(BGl_string2274z00zzdataflow_walkz00,
		BgL_bgl_string2274za700za7za7d2384za7, "dataflow-node!", 14);
	      DEFINE_STRING(BGl_string2294z00zzdataflow_walkz00,
		BgL_bgl_string2294za700za7za7d2385za7, "dataflow-test-env", 17);
	     
		DEFINE_STATIC_BGL_GENERIC
		(BGl_dataflowzd2testzd2envzd2envzd2zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2te2386z00,
		BGl_z62dataflowzd2testzd2envz62zzdataflow_walkz00, 0L, BUNSPEC, 1);
	     
		DEFINE_STATIC_BGL_GENERIC(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2387z00,
		BGl_z62dataflowzd2nodez12za2zzdataflow_walkz00, 0L, BUNSPEC, 2);

/* GC roots registration */
	static obj_t bgl_gc_roots_register()
	{
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
		void *roots_min = (void *) ULONG_MAX, *roots_max = 0;
		     ADD_ROOT((void *) (&BGl_za2z42pairzf3za2zb1zzdataflow_walkz00));
		   
			 ADD_ROOT((void
				*) (&BGl_requirezd2initializa7ationz75zzdataflow_walkz00));
		     ADD_ROOT((void *) (&BGl_za2z42epairzf3za2zb1zzdataflow_walkz00));
		     ADD_ROOT((void *) (&BGl_za2z42nullzf3za2zb1zzdataflow_walkz00));
		     ADD_ROOT((void *) (&BGl_localzf2valuezf2zzdataflow_walkz00));
#undef ADD_ROOT
		if   (roots_max > 0)
			     GC_add_roots(roots_min, ((void **) roots_max) + 1);
#endif
		     return BUNSPEC;
	}



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzdataflow_walkz00(long
		BgL_checksumz00_3719, char *BgL_fromz00_3720)
	{
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzdataflow_walkz00))
				{
					BGl_requirezd2initializa7ationz75zzdataflow_walkz00 =
						BBOOL(((bool_t) 0));
					BGl_gczd2rootszd2initz00zzdataflow_walkz00();
					BGl_libraryzd2moduleszd2initz00zzdataflow_walkz00();
					BGl_cnstzd2initzd2zzdataflow_walkz00();
					BGl_importedzd2moduleszd2initz00zzdataflow_walkz00();
					BGl_objectzd2initzd2zzdataflow_walkz00();
					BGl_genericzd2initzd2zzdataflow_walkz00();
					BGl_methodzd2initzd2zzdataflow_walkz00();
					return BGl_toplevelzd2initzd2zzdataflow_walkz00();
				}
			else
				{
					return BUNSPEC;
				}
		}

	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzdataflow_walkz00()
	{
		{	/* Dataflow/walk.scm 17 */
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0),
				"dataflow_walk");
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long) 0),
				"dataflow_walk");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long) 0),
				"dataflow_walk");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"dataflow_walk");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long) 0),
				"dataflow_walk");
			BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long) 0),
				"dataflow_walk");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0),
				"dataflow_walk");
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 0),
				"dataflow_walk");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "dataflow_walk");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"dataflow_walk");
			BGl_modulezd2initializa7ationz75zz__bitz00(((long) 0), "dataflow_walk");
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 0),
				"dataflow_walk");
			return BUNSPEC;
		}

	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzdataflow_walkz00()
	{
		{	/* Dataflow/walk.scm 17 */
			{	/* Dataflow/walk.scm 17 */
				obj_t BgL_cportz00_3421;

				{	/* Dataflow/walk.scm 17 */
					obj_t BgL_stringz00_3429;

					BgL_stringz00_3429 = BGl_string2312z00zzdataflow_walkz00;
					{	/* Dataflow/walk.scm 17 */
						obj_t BgL_startz00_3430;

						BgL_startz00_3430 = BINT(((long) 0));
						{	/* Dataflow/walk.scm 17 */
							obj_t BgL_endz00_3431;

							BgL_endz00_3431 =
								BINT(STRING_LENGTH(((obj_t) BgL_stringz00_3429)));
							{	/* Dataflow/walk.scm 17 */

								BgL_cportz00_3421 =
									BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00
									(BgL_stringz00_3429, BgL_startz00_3430, BgL_endz00_3431);
				}}}}
				{
					long BgL_iz00_3422;

					BgL_iz00_3422 = ((long) 11);
				BgL_loopz00_3423:
					if ((BgL_iz00_3422 == ((long) -1)))
						{	/* Dataflow/walk.scm 17 */
							return BUNSPEC;
						}
					else
						{	/* Dataflow/walk.scm 17 */
							{	/* Dataflow/walk.scm 17 */
								obj_t BgL_arg2314z00_3425;

								{	/* Dataflow/walk.scm 17 */

									{	/* Dataflow/walk.scm 17 */
										obj_t BgL_locationz00_3427;

										BgL_locationz00_3427 = BBOOL(((bool_t) 0));
										{	/* Dataflow/walk.scm 17 */

											BgL_arg2314z00_3425 =
												BGl_readz00zz__readerz00(BgL_cportz00_3421,
												BgL_locationz00_3427);
										}
									}
								}
								{	/* Dataflow/walk.scm 17 */
									int BgL_tmpz00_3753;

									BgL_tmpz00_3753 = (int) (BgL_iz00_3422);
									CNST_TABLE_SET(BgL_tmpz00_3753, BgL_arg2314z00_3425);
							}}
							{	/* Dataflow/walk.scm 17 */
								int BgL_auxz00_3428;

								BgL_auxz00_3428 = (int) ((BgL_iz00_3422 - ((long) 1)));
								{
									long BgL_iz00_3758;

									BgL_iz00_3758 = (long) (BgL_auxz00_3428);
									BgL_iz00_3422 = BgL_iz00_3758;
									goto BgL_loopz00_3423;
								}
							}
						}
				}
			}
		}

	}



/* gc-roots-init */
	obj_t BGl_gczd2rootszd2initz00zzdataflow_walkz00()
	{
		{	/* Dataflow/walk.scm 17 */
			return bgl_gc_roots_register();
		}

	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzdataflow_walkz00()
	{
		{	/* Dataflow/walk.scm 17 */
			BGl_za2z42nullzf3za2zb1zzdataflow_walkz00 = BFALSE;
			BGl_za2z42pairzf3za2zb1zzdataflow_walkz00 = BFALSE;
			BGl_za2z42epairzf3za2zb1zzdataflow_walkz00 = BFALSE;
			BGl_letzd2varzd2stampz00zzdataflow_walkz00 = ((long) 0);
			return BUNSPEC;
		}

	}



/* append-21011 */
	obj_t BGl_appendzd221011zd2zzdataflow_walkz00(obj_t BgL_l1z00_1,
		obj_t BgL_l2z00_2)
	{
		{
			{
				obj_t BgL_headz00_1757;

				BgL_headz00_1757 = MAKE_YOUNG_PAIR(BNIL, BgL_l2z00_2);
				{
					obj_t BgL_prevz00_1758;
					obj_t BgL_tailz00_1759;

					BgL_prevz00_1758 = BgL_headz00_1757;
					BgL_tailz00_1759 = BgL_l1z00_1;
				BgL_loopz00_1760:
					if (PAIRP(BgL_tailz00_1759))
						{
							obj_t BgL_newzd2prevzd2_1762;

							BgL_newzd2prevzd2_1762 =
								MAKE_YOUNG_PAIR(CAR(BgL_tailz00_1759), BgL_l2z00_2);
							SET_CDR(BgL_prevz00_1758, BgL_newzd2prevzd2_1762);
							{
								obj_t BgL_tailz00_3768;
								obj_t BgL_prevz00_3767;

								BgL_prevz00_3767 = BgL_newzd2prevzd2_1762;
								BgL_tailz00_3768 = CDR(BgL_tailz00_1759);
								BgL_tailz00_1759 = BgL_tailz00_3768;
								BgL_prevz00_1758 = BgL_prevz00_3767;
								goto BgL_loopz00_1760;
							}
						}
					else
						{
							BNIL;
						}
					return CDR(BgL_headz00_1757);
				}
			}
		}

	}



/* dataflow-walk! */
	BGL_EXPORTED_DEF obj_t BGl_dataflowzd2walkz12zc0zzdataflow_walkz00(obj_t
		BgL_globalsz00_56, obj_t BgL_namez00_57)
	{
		{	/* Dataflow/walk.scm 45 */
			{	/* Dataflow/walk.scm 46 */
				obj_t BgL_list1490z00_1771;

				{	/* Dataflow/walk.scm 46 */
					obj_t BgL_arg1493z00_1772;

					{	/* Dataflow/walk.scm 46 */
						obj_t BgL_arg1495z00_1773;

						BgL_arg1495z00_1773 =
							MAKE_YOUNG_PAIR(BCHAR(((unsigned char) 10)), BNIL);
						BgL_arg1493z00_1772 =
							MAKE_YOUNG_PAIR(BgL_namez00_57, BgL_arg1495z00_1773);
					}
					BgL_list1490z00_1771 =
						MAKE_YOUNG_PAIR(BGl_string2250z00zzdataflow_walkz00,
						BgL_arg1493z00_1772);
				}
				BGl_verbosez00zztools_speekz00(BINT(((long) 1)), BgL_list1490z00_1771);
			}
			BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00 = BINT(((long) 0));
			BGl_za2currentzd2passza2zd2zzengine_passz00 = BgL_namez00_57;
			{	/* Dataflow/walk.scm 46 */
				obj_t BgL_g1145z00_1774;

				BgL_g1145z00_1774 = BNIL;
				{
					obj_t BgL_hooksz00_1777;
					obj_t BgL_hnamesz00_1778;

					BgL_hooksz00_1777 = BgL_g1145z00_1774;
					BgL_hnamesz00_1778 = BNIL;
				BgL_zc3z04anonymousza31496ze3z87_1779:
					if (NULLP(BgL_hooksz00_1777))
						{	/* Dataflow/walk.scm 46 */
							CNST_TABLE_REF(((long) 0));
						}
					else
						{	/* Dataflow/walk.scm 46 */
							bool_t BgL_test2392z00_3781;

							{	/* Dataflow/walk.scm 46 */
								obj_t BgL_fun1508z00_1786;

								BgL_fun1508z00_1786 = CAR(((obj_t) BgL_hooksz00_1777));
								BgL_test2392z00_3781 =
									CBOOL(PROCEDURE_ENTRY(BgL_fun1508z00_1786)
									(BgL_fun1508z00_1786, BEOA));
							}
							if (BgL_test2392z00_3781)
								{	/* Dataflow/walk.scm 46 */
									obj_t BgL_arg1500z00_1783;
									obj_t BgL_arg1506z00_1784;

									BgL_arg1500z00_1783 = CDR(((obj_t) BgL_hooksz00_1777));
									BgL_arg1506z00_1784 = CDR(((obj_t) BgL_hnamesz00_1778));
									{
										obj_t BgL_hnamesz00_3793;
										obj_t BgL_hooksz00_3792;

										BgL_hooksz00_3792 = BgL_arg1500z00_1783;
										BgL_hnamesz00_3793 = BgL_arg1506z00_1784;
										BgL_hnamesz00_1778 = BgL_hnamesz00_3793;
										BgL_hooksz00_1777 = BgL_hooksz00_3792;
										goto BgL_zc3z04anonymousza31496ze3z87_1779;
									}
								}
							else
								{	/* Dataflow/walk.scm 46 */
									obj_t BgL_arg1507z00_1785;

									BgL_arg1507z00_1785 = CAR(((obj_t) BgL_hnamesz00_1778));
									BGl_internalzd2errorzd2zztools_errorz00(BgL_namez00_57,
										BGl_string2251z00zzdataflow_walkz00, BgL_arg1507z00_1785);
								}
						}
				}
			}
			BGl_za2z42nullzf3za2zb1zzdataflow_walkz00 =
				BGl_findzd2globalzf2modulez20zzast_envz00(CNST_TABLE_REF(((long) 1)),
				CNST_TABLE_REF(((long) 2)));
			BGl_za2z42pairzf3za2zb1zzdataflow_walkz00 =
				BGl_findzd2globalzf2modulez20zzast_envz00(CNST_TABLE_REF(((long) 3)),
				CNST_TABLE_REF(((long) 2)));
			BGl_za2z42epairzf3za2zb1zzdataflow_walkz00 =
				BGl_findzd2globalzf2modulez20zzast_envz00(CNST_TABLE_REF(((long) 4)),
				CNST_TABLE_REF(((long) 2)));
			{
				obj_t BgL_l1329z00_1790;

				BgL_l1329z00_1790 = BgL_globalsz00_56;
			BgL_zc3z04anonymousza31510ze3z87_1791:
				if (PAIRP(BgL_l1329z00_1790))
					{	/* Dataflow/walk.scm 50 */
						{	/* Dataflow/walk.scm 50 */
							obj_t BgL_arg1514z00_1793;

							BgL_arg1514z00_1793 = CAR(BgL_l1329z00_1790);
							{	/* Dataflow/walk.scm 64 */
								obj_t BgL_arg1550z00_2790;

								BgL_arg1550z00_2790 =
									(((BgL_sfunz00_bglt) COBJECT(
											((BgL_sfunz00_bglt)
												(((BgL_variablez00_bglt) COBJECT(
															((BgL_variablez00_bglt)
																((BgL_globalz00_bglt) BgL_arg1514z00_1793))))->
													BgL_valuez00))))->BgL_bodyz00);
								BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(((BgL_nodez00_bglt)
										BgL_arg1550z00_2790), BNIL);
							}
						}
						{
							obj_t BgL_l1329z00_3816;

							BgL_l1329z00_3816 = CDR(BgL_l1329z00_1790);
							BgL_l1329z00_1790 = BgL_l1329z00_3816;
							goto BgL_zc3z04anonymousza31510ze3z87_1791;
						}
					}
				else
					{	/* Dataflow/walk.scm 50 */
						((bool_t) 1);
					}
			}
			if (
				((long) CINT(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00) >
					((long) 0)))
				{	/* Dataflow/walk.scm 51 */
					{	/* Dataflow/walk.scm 51 */
						obj_t BgL_port1331z00_1798;

						{	/* Dataflow/walk.scm 51 */
							obj_t BgL_res2145z00_2798;

							{	/* Dataflow/walk.scm 51 */
								obj_t BgL_tmpz00_3821;

								BgL_tmpz00_3821 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_res2145z00_2798 =
									BGL_ENV_CURRENT_ERROR_PORT(BgL_tmpz00_3821);
							}
							BgL_port1331z00_1798 = BgL_res2145z00_2798;
						}
						bgl_display_obj(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00,
							BgL_port1331z00_1798);
						bgl_display_string(BGl_string2252z00zzdataflow_walkz00,
							BgL_port1331z00_1798);
						{	/* Dataflow/walk.scm 51 */
							obj_t BgL_arg1523z00_1799;

							{	/* Dataflow/walk.scm 51 */
								bool_t BgL_test2395z00_3826;

								if (BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00
									(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00))
									{	/* Dataflow/walk.scm 51 */
										if (INTEGERP
											(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00))
											{	/* Dataflow/walk.scm 51 */
												BgL_test2395z00_3826 =
													(
													(long)
													CINT
													(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00)
													> ((long) 1));
											}
										else
											{	/* Dataflow/walk.scm 51 */
												BgL_test2395z00_3826 =
													BGl_2ze3ze3zz__r4_numbers_6_5z00
													(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00,
													BINT(((long) 1)));
									}}
								else
									{	/* Dataflow/walk.scm 51 */
										BgL_test2395z00_3826 = ((bool_t) 0);
									}
								if (BgL_test2395z00_3826)
									{	/* Dataflow/walk.scm 51 */
										BgL_arg1523z00_1799 = BGl_string2253z00zzdataflow_walkz00;
									}
								else
									{	/* Dataflow/walk.scm 51 */
										BgL_arg1523z00_1799 = BGl_string2254z00zzdataflow_walkz00;
									}
							}
							bgl_display_obj(BgL_arg1523z00_1799, BgL_port1331z00_1798);
						}
						bgl_display_string(BGl_string2255z00zzdataflow_walkz00,
							BgL_port1331z00_1798);
						bgl_display_char(((unsigned char) 10), BgL_port1331z00_1798);
					}
					{	/* Dataflow/walk.scm 51 */
						obj_t BgL_list1528z00_1805;

						BgL_list1528z00_1805 = MAKE_YOUNG_PAIR(BINT(((long) -1)), BNIL);
						return BGl_exitz00zz__errorz00(BgL_list1528z00_1805);
					}
				}
			else
				{	/* Dataflow/walk.scm 51 */
					obj_t BgL_g1147z00_1806;

					BgL_g1147z00_1806 = BNIL;
					{
						obj_t BgL_hooksz00_1809;
						obj_t BgL_hnamesz00_1810;

						BgL_hooksz00_1809 = BgL_g1147z00_1806;
						BgL_hnamesz00_1810 = BNIL;
					BgL_zc3z04anonymousza31529ze3z87_1811:
						if (NULLP(BgL_hooksz00_1809))
							{	/* Dataflow/walk.scm 51 */
								return BgL_globalsz00_56;
							}
						else
							{	/* Dataflow/walk.scm 51 */
								bool_t BgL_test2399z00_3843;

								{	/* Dataflow/walk.scm 51 */
									obj_t BgL_fun1543z00_1818;

									BgL_fun1543z00_1818 = CAR(((obj_t) BgL_hooksz00_1809));
									BgL_test2399z00_3843 =
										CBOOL(PROCEDURE_ENTRY(BgL_fun1543z00_1818)
										(BgL_fun1543z00_1818, BEOA));
								}
								if (BgL_test2399z00_3843)
									{	/* Dataflow/walk.scm 51 */
										obj_t BgL_arg1536z00_1815;
										obj_t BgL_arg1540z00_1816;

										BgL_arg1536z00_1815 = CDR(((obj_t) BgL_hooksz00_1809));
										BgL_arg1540z00_1816 = CDR(((obj_t) BgL_hnamesz00_1810));
										{
											obj_t BgL_hnamesz00_3855;
											obj_t BgL_hooksz00_3854;

											BgL_hooksz00_3854 = BgL_arg1536z00_1815;
											BgL_hnamesz00_3855 = BgL_arg1540z00_1816;
											BgL_hnamesz00_1810 = BgL_hnamesz00_3855;
											BgL_hooksz00_1809 = BgL_hooksz00_3854;
											goto BgL_zc3z04anonymousza31529ze3z87_1811;
										}
									}
								else
									{	/* Dataflow/walk.scm 51 */
										obj_t BgL_arg1541z00_1817;

										BgL_arg1541z00_1817 = CAR(((obj_t) BgL_hnamesz00_1810));
										return
											BGl_internalzd2errorzd2zztools_errorz00
											(BGl_za2currentzd2passza2zd2zzengine_passz00,
											BGl_string2256z00zzdataflow_walkz00, BgL_arg1541z00_1817);
									}
							}
					}
				}
		}

	}



/* &dataflow-walk! */
	obj_t BGl_z62dataflowzd2walkz12za2zzdataflow_walkz00(obj_t BgL_envz00_3233,
		obj_t BgL_globalsz00_3234, obj_t BgL_namez00_3235)
	{
		{	/* Dataflow/walk.scm 45 */
			return
				BGl_dataflowzd2walkz12zc0zzdataflow_walkz00(BgL_globalsz00_3234,
				BgL_namez00_3235);
		}

	}



/* dataflow-node*! */
	obj_t BGl_dataflowzd2nodeza2z12z62zzdataflow_walkz00(obj_t BgL_nodeza2za2_99,
		obj_t BgL_envz00_100)
	{
		{	/* Dataflow/walk.scm 307 */
			{
				obj_t BgL_l1353z00_1824;

				BgL_l1353z00_1824 = BgL_nodeza2za2_99;
			BgL_zc3z04anonymousza31555ze3z87_1825:
				if (PAIRP(BgL_l1353z00_1824))
					{	/* Dataflow/walk.scm 308 */
						{	/* Dataflow/walk.scm 308 */
							obj_t BgL_nz00_1827;

							BgL_nz00_1827 = CAR(BgL_l1353z00_1824);
							BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
								((BgL_nodez00_bglt) BgL_nz00_1827), BgL_envz00_100);
						}
						{
							obj_t BgL_l1353z00_3865;

							BgL_l1353z00_3865 = CDR(BgL_l1353z00_1824);
							BgL_l1353z00_1824 = BgL_l1353z00_3865;
							goto BgL_zc3z04anonymousza31555ze3z87_1825;
						}
					}
				else
					{	/* Dataflow/walk.scm 308 */
						((bool_t) 1);
					}
			}
			return BgL_envz00_100;
		}

	}



/* object-init */
	obj_t BGl_objectzd2initzd2zzdataflow_walkz00()
	{
		{	/* Dataflow/walk.scm 17 */
			{	/* Dataflow/walk.scm 37 */
				obj_t BgL_arg1573z00_1834;
				obj_t BgL_arg1574z00_1835;

				{	/* Dataflow/walk.scm 37 */
					obj_t BgL_v1371z00_1869;

					BgL_v1371z00_1869 = create_vector(((long) 2));
					{	/* Dataflow/walk.scm 37 */
						obj_t BgL_arg1602z00_1870;

						BgL_arg1602z00_1870 =
							BGl_makezd2classzd2fieldz00zz__objectz00(CNST_TABLE_REF(((long)
									5)), BGl_proc2258z00zzdataflow_walkz00,
							BGl_proc2257z00zzdataflow_walkz00, ((bool_t) 1), ((bool_t) 0),
							BFALSE, BFALSE, CNST_TABLE_REF(((long) 6)));
						VECTOR_SET(BgL_v1371z00_1869, ((long) 0), BgL_arg1602z00_1870);
					}
					{	/* Dataflow/walk.scm 37 */
						obj_t BgL_arg1618z00_1880;

						BgL_arg1618z00_1880 =
							BGl_makezd2classzd2fieldz00zz__objectz00(CNST_TABLE_REF(((long)
									7)), BGl_proc2260z00zzdataflow_walkz00,
							BGl_proc2259z00zzdataflow_walkz00, ((bool_t) 1), ((bool_t) 0),
							BFALSE, BFALSE, BGl_nodez00zzast_nodez00);
						VECTOR_SET(BgL_v1371z00_1869, ((long) 1), BgL_arg1618z00_1880);
					}
					BgL_arg1573z00_1834 = BgL_v1371z00_1869;
				}
				{	/* Dataflow/walk.scm 37 */
					obj_t BgL_v1372z00_1890;

					BgL_v1372z00_1890 = create_vector(((long) 0));
					BgL_arg1574z00_1835 = BgL_v1372z00_1890;
				}
				return (BGl_localzf2valuezf2zzdataflow_walkz00 =
					BGl_registerzd2classz12zc0zz__objectz00(CNST_TABLE_REF(((long) 8)),
						CNST_TABLE_REF(((long) 9)), BGl_localz00zzast_varz00,
						((long) 51723), BGl_proc2264z00zzdataflow_walkz00,
						BGl_proc2263z00zzdataflow_walkz00, BFALSE,
						BGl_proc2262z00zzdataflow_walkz00,
						BGl_proc2261z00zzdataflow_walkz00, BgL_arg1573z00_1834,
						BgL_arg1574z00_1835), BUNSPEC);
		}}

	}



/* &lambda1587 */
	BgL_localz00_bglt BGl_z62lambda1587z62zzdataflow_walkz00(obj_t
		BgL_envz00_3244, obj_t BgL_o1123z00_3245)
	{
		{	/* Dataflow/walk.scm 37 */
			{	/* Dataflow/walk.scm 37 */
				long BgL_arg1590z00_3435;

				{	/* Dataflow/walk.scm 37 */
					obj_t BgL_arg1594z00_3436;

					{	/* Dataflow/walk.scm 37 */
						obj_t BgL_arg1598z00_3437;

						{	/* Dataflow/walk.scm 37 */
							long BgL_arg1744z00_3438;

							{	/* Dataflow/walk.scm 37 */
								long BgL_arg1745z00_3439;

								{	/* Dataflow/walk.scm 37 */
									long BgL_res2154z00_3440;

									BgL_res2154z00_3440 =
										BGL_OBJECT_CLASS_NUM(
										((BgL_objectz00_bglt)
											((BgL_localz00_bglt) BgL_o1123z00_3245)));
									BgL_arg1745z00_3439 = BgL_res2154z00_3440;
								}
								BgL_arg1744z00_3438 = (BgL_arg1745z00_3439 - OBJECT_TYPE);
							}
							BgL_arg1598z00_3437 =
								VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
								BgL_arg1744z00_3438);
						}
						BgL_arg1594z00_3436 =
							BGl_classzd2superzd2zz__objectz00(BgL_arg1598z00_3437);
					}
					{	/* Dataflow/walk.scm 37 */
						long BgL_res2156z00_3441;

						{	/* Dataflow/walk.scm 37 */
							obj_t BgL_tmpz00_3885;

							BgL_tmpz00_3885 = ((obj_t) BgL_arg1594z00_3436);
							BgL_res2156z00_3441 = BGL_CLASS_INDEX(BgL_tmpz00_3885);
						}
						BgL_arg1590z00_3435 = BgL_res2156z00_3441;
				}}
				BGL_OBJECT_CLASS_NUM_SET(
					((BgL_objectz00_bglt)
						((BgL_localz00_bglt) BgL_o1123z00_3245)), BgL_arg1590z00_3435);
			}
			{	/* Dataflow/walk.scm 37 */
				BgL_objectz00_bglt BgL_tmpz00_3891;

				BgL_tmpz00_3891 =
					((BgL_objectz00_bglt) ((BgL_localz00_bglt) BgL_o1123z00_3245));
				BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3891, BFALSE);
			}
			((BgL_objectz00_bglt) ((BgL_localz00_bglt) BgL_o1123z00_3245));
			return ((BgL_localz00_bglt) ((BgL_localz00_bglt) BgL_o1123z00_3245));
		}

	}



/* &<@anonymous:1586> */
	obj_t BGl_z62zc3z04anonymousza31586ze3ze5zzdataflow_walkz00(obj_t
		BgL_envz00_3246, obj_t BgL_new1122z00_3247)
	{
		{	/* Dataflow/walk.scm 37 */
			{
				BgL_localz00_bglt BgL_auxz00_3899;

				((((BgL_variablez00_bglt) COBJECT(
								((BgL_variablez00_bglt)
									((BgL_localz00_bglt) BgL_new1122z00_3247))))->BgL_idz00) =
					((obj_t) CNST_TABLE_REF(((long) 10))), BUNSPEC);
				((((BgL_variablez00_bglt)
							COBJECT(((BgL_variablez00_bglt) ((BgL_localz00_bglt)
										BgL_new1122z00_3247))))->BgL_namez00) =
					((obj_t) BUNSPEC), BUNSPEC);
				{
					BgL_typez00_bglt BgL_auxz00_3907;

					{	/* Dataflow/walk.scm 37 */
						obj_t BgL_classz00_3443;

						BgL_classz00_3443 = BGl_typez00zztype_typez00;
						{	/* Dataflow/walk.scm 37 */
							obj_t BgL__ortest_1106z00_3444;

							BgL__ortest_1106z00_3444 = BGL_CLASS_NIL(BgL_classz00_3443);
							if (CBOOL(BgL__ortest_1106z00_3444))
								{	/* Dataflow/walk.scm 37 */
									BgL_auxz00_3907 =
										((BgL_typez00_bglt) BgL__ortest_1106z00_3444);
								}
							else
								{	/* Dataflow/walk.scm 37 */
									BgL_auxz00_3907 =
										((BgL_typez00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_3443));
								}
						}
					}
					((((BgL_variablez00_bglt) COBJECT(
									((BgL_variablez00_bglt)
										((BgL_localz00_bglt) BgL_new1122z00_3247))))->BgL_typez00) =
						((BgL_typez00_bglt) BgL_auxz00_3907), BUNSPEC);
				}
				{
					BgL_valuez00_bglt BgL_auxz00_3917;

					{	/* Dataflow/walk.scm 37 */
						obj_t BgL_classz00_3445;

						BgL_classz00_3445 = BGl_valuez00zzast_varz00;
						{	/* Dataflow/walk.scm 37 */
							obj_t BgL__ortest_1106z00_3446;

							BgL__ortest_1106z00_3446 = BGL_CLASS_NIL(BgL_classz00_3445);
							if (CBOOL(BgL__ortest_1106z00_3446))
								{	/* Dataflow/walk.scm 37 */
									BgL_auxz00_3917 =
										((BgL_valuez00_bglt) BgL__ortest_1106z00_3446);
								}
							else
								{	/* Dataflow/walk.scm 37 */
									BgL_auxz00_3917 =
										((BgL_valuez00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_3445));
								}
						}
					}
					((((BgL_variablez00_bglt) COBJECT(
									((BgL_variablez00_bglt)
										((BgL_localz00_bglt) BgL_new1122z00_3247))))->
							BgL_valuez00) = ((BgL_valuez00_bglt) BgL_auxz00_3917), BUNSPEC);
				}
				((((BgL_variablez00_bglt) COBJECT(
								((BgL_variablez00_bglt)
									((BgL_localz00_bglt) BgL_new1122z00_3247))))->BgL_accessz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_variablez00_bglt)
							COBJECT(((BgL_variablez00_bglt) ((BgL_localz00_bglt)
										BgL_new1122z00_3247))))->BgL_fastzd2alphazd2) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_variablez00_bglt)
							COBJECT(((BgL_variablez00_bglt) ((BgL_localz00_bglt)
										BgL_new1122z00_3247))))->BgL_removablez00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_variablez00_bglt)
							COBJECT(((BgL_variablez00_bglt) ((BgL_localz00_bglt)
										BgL_new1122z00_3247))))->BgL_occurrencez00) =
					((long) ((long) 0)), BUNSPEC);
				((((BgL_variablez00_bglt)
							COBJECT(((BgL_variablez00_bglt) ((BgL_localz00_bglt)
										BgL_new1122z00_3247))))->BgL_occurrencewz00) =
					((long) ((long) 0)), BUNSPEC);
				((((BgL_variablez00_bglt)
							COBJECT(((BgL_variablez00_bglt) ((BgL_localz00_bglt)
										BgL_new1122z00_3247))))->BgL_userzf3zf3) =
					((bool_t) ((bool_t) 0)), BUNSPEC);
				((((BgL_localz00_bglt) COBJECT(((BgL_localz00_bglt) ((BgL_localz00_bglt)
										BgL_new1122z00_3247))))->BgL_keyz00) =
					((long) ((long) 0)), BUNSPEC);
				{
					BgL_localzf2valuezf2_bglt BgL_auxz00_3948;

					{
						obj_t BgL_auxz00_3949;

						{	/* Dataflow/walk.scm 37 */
							BgL_objectz00_bglt BgL_tmpz00_3950;

							BgL_tmpz00_3950 =
								((BgL_objectz00_bglt)
								((BgL_localz00_bglt) BgL_new1122z00_3247));
							BgL_auxz00_3949 = BGL_OBJECT_WIDENING(BgL_tmpz00_3950);
						}
						BgL_auxz00_3948 = ((BgL_localzf2valuezf2_bglt) BgL_auxz00_3949);
					}
					((((BgL_localzf2valuezf2_bglt) COBJECT(BgL_auxz00_3948))->
							BgL_stampz00) = ((int) (int) (((long) 0))), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_3964;
					BgL_localzf2valuezf2_bglt BgL_auxz00_3957;

					{	/* Dataflow/walk.scm 37 */
						obj_t BgL_classz00_3447;

						BgL_classz00_3447 = BGl_nodez00zzast_nodez00;
						{	/* Dataflow/walk.scm 37 */
							obj_t BgL__ortest_1106z00_3448;

							BgL__ortest_1106z00_3448 = BGL_CLASS_NIL(BgL_classz00_3447);
							if (CBOOL(BgL__ortest_1106z00_3448))
								{	/* Dataflow/walk.scm 37 */
									BgL_auxz00_3964 =
										((BgL_nodez00_bglt) BgL__ortest_1106z00_3448);
								}
							else
								{	/* Dataflow/walk.scm 37 */
									BgL_auxz00_3964 =
										((BgL_nodez00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_3447));
								}
						}
					}
					{
						obj_t BgL_auxz00_3958;

						{	/* Dataflow/walk.scm 37 */
							BgL_objectz00_bglt BgL_tmpz00_3959;

							BgL_tmpz00_3959 =
								((BgL_objectz00_bglt)
								((BgL_localz00_bglt) BgL_new1122z00_3247));
							BgL_auxz00_3958 = BGL_OBJECT_WIDENING(BgL_tmpz00_3959);
						}
						BgL_auxz00_3957 = ((BgL_localzf2valuezf2_bglt) BgL_auxz00_3958);
					}
					((((BgL_localzf2valuezf2_bglt) COBJECT(BgL_auxz00_3957))->
							BgL_nodez00) = ((BgL_nodez00_bglt) BgL_auxz00_3964), BUNSPEC);
				}
				BgL_auxz00_3899 = ((BgL_localz00_bglt) BgL_new1122z00_3247);
				return ((obj_t) BgL_auxz00_3899);
			}
		}

	}



/* &lambda1580 */
	BgL_localz00_bglt BGl_z62lambda1580z62zzdataflow_walkz00(obj_t
		BgL_envz00_3248, obj_t BgL_o1119z00_3249)
	{
		{	/* Dataflow/walk.scm 37 */
			{	/* Dataflow/walk.scm 37 */
				BgL_localzf2valuezf2_bglt BgL_wide1121z00_3450;

				BgL_wide1121z00_3450 =
					((BgL_localzf2valuezf2_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_localzf2valuezf2_bgl))));
				{	/* Dataflow/walk.scm 37 */
					obj_t BgL_auxz00_3979;
					BgL_objectz00_bglt BgL_tmpz00_3975;

					BgL_auxz00_3979 = ((obj_t) BgL_wide1121z00_3450);
					BgL_tmpz00_3975 =
						((BgL_objectz00_bglt)
						((BgL_localz00_bglt) ((BgL_localz00_bglt) BgL_o1119z00_3249)));
					BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3975, BgL_auxz00_3979);
				}
				((BgL_objectz00_bglt)
					((BgL_localz00_bglt) ((BgL_localz00_bglt) BgL_o1119z00_3249)));
				{	/* Dataflow/walk.scm 37 */
					long BgL_arg1585z00_3451;

					{	/* Dataflow/walk.scm 37 */
						long BgL_res2153z00_3452;

						BgL_res2153z00_3452 =
							BGL_CLASS_INDEX(BGl_localzf2valuezf2zzdataflow_walkz00);
						BgL_arg1585z00_3451 = BgL_res2153z00_3452;
					}
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt)
							((BgL_localz00_bglt)
								((BgL_localz00_bglt) BgL_o1119z00_3249))), BgL_arg1585z00_3451);
				}
				return
					((BgL_localz00_bglt)
					((BgL_localz00_bglt) ((BgL_localz00_bglt) BgL_o1119z00_3249)));
			}
		}

	}



/* &lambda1575 */
	BgL_localz00_bglt BGl_z62lambda1575z62zzdataflow_walkz00(obj_t
		BgL_envz00_3250, obj_t BgL_id1106z00_3251, obj_t BgL_name1107z00_3252,
		obj_t BgL_type1108z00_3253, obj_t BgL_value1109z00_3254,
		obj_t BgL_access1110z00_3255, obj_t BgL_fastzd2alpha1111zd2_3256,
		obj_t BgL_removable1112z00_3257, obj_t BgL_occurrence1113z00_3258,
		obj_t BgL_occurrencew1114z00_3259, obj_t BgL_userzf31115zf3_3260,
		obj_t BgL_key1116z00_3261, obj_t BgL_stamp1117z00_3262,
		obj_t BgL_node1118z00_3263)
	{
		{	/* Dataflow/walk.scm 37 */
			{	/* Dataflow/walk.scm 37 */
				long BgL_occurrence1113z00_3456;
				long BgL_occurrencew1114z00_3457;
				bool_t BgL_userzf31115zf3_3458;
				long BgL_key1116z00_3459;
				int BgL_stamp1117z00_3460;

				BgL_occurrence1113z00_3456 = (long) CINT(BgL_occurrence1113z00_3258);
				BgL_occurrencew1114z00_3457 = (long) CINT(BgL_occurrencew1114z00_3259);
				BgL_userzf31115zf3_3458 = CBOOL(BgL_userzf31115zf3_3260);
				BgL_key1116z00_3459 = (long) CINT(BgL_key1116z00_3261);
				BgL_stamp1117z00_3460 = CINT(BgL_stamp1117z00_3262);
				{	/* Dataflow/walk.scm 37 */
					BgL_localz00_bglt BgL_new1198z00_3462;

					{	/* Dataflow/walk.scm 37 */
						BgL_localz00_bglt BgL_tmp1196z00_3463;
						BgL_localzf2valuezf2_bglt BgL_wide1197z00_3464;

						{
							BgL_localz00_bglt BgL_auxz00_3998;

							{	/* Dataflow/walk.scm 37 */
								BgL_localz00_bglt BgL_new1195z00_3465;

								BgL_new1195z00_3465 =
									((BgL_localz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
												BgL_localz00_bgl))));
								{	/* Dataflow/walk.scm 37 */
									long BgL_arg1579z00_3466;

									{	/* Dataflow/walk.scm 37 */
										long BgL_res2151z00_3467;

										BgL_res2151z00_3467 =
											BGL_CLASS_INDEX(BGl_localz00zzast_varz00);
										BgL_arg1579z00_3466 = BgL_res2151z00_3467;
									}
									BGL_OBJECT_CLASS_NUM_SET(
										((BgL_objectz00_bglt) BgL_new1195z00_3465),
										BgL_arg1579z00_3466);
								}
								{	/* Dataflow/walk.scm 37 */
									BgL_objectz00_bglt BgL_tmpz00_4003;

									BgL_tmpz00_4003 = ((BgL_objectz00_bglt) BgL_new1195z00_3465);
									BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4003, BFALSE);
								}
								((BgL_objectz00_bglt) BgL_new1195z00_3465);
								BgL_auxz00_3998 = BgL_new1195z00_3465;
							}
							BgL_tmp1196z00_3463 = ((BgL_localz00_bglt) BgL_auxz00_3998);
						}
						BgL_wide1197z00_3464 =
							((BgL_localzf2valuezf2_bglt) BOBJECT(GC_MALLOC(sizeof(struct
										BgL_localzf2valuezf2_bgl))));
						{	/* Dataflow/walk.scm 37 */
							obj_t BgL_auxz00_4011;
							BgL_objectz00_bglt BgL_tmpz00_4009;

							BgL_auxz00_4011 = ((obj_t) BgL_wide1197z00_3464);
							BgL_tmpz00_4009 = ((BgL_objectz00_bglt) BgL_tmp1196z00_3463);
							BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4009, BgL_auxz00_4011);
						}
						((BgL_objectz00_bglt) BgL_tmp1196z00_3463);
						{	/* Dataflow/walk.scm 37 */
							long BgL_arg1578z00_3468;

							{	/* Dataflow/walk.scm 37 */
								long BgL_res2152z00_3469;

								BgL_res2152z00_3469 =
									BGL_CLASS_INDEX(BGl_localzf2valuezf2zzdataflow_walkz00);
								BgL_arg1578z00_3468 = BgL_res2152z00_3469;
							}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt) BgL_tmp1196z00_3463),
								BgL_arg1578z00_3468);
						}
						BgL_new1198z00_3462 = ((BgL_localz00_bglt) BgL_tmp1196z00_3463);
					}
					((((BgL_variablez00_bglt) COBJECT(
									((BgL_variablez00_bglt) BgL_new1198z00_3462)))->BgL_idz00) =
						((obj_t) ((obj_t) BgL_id1106z00_3251)), BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1198z00_3462)))->BgL_namez00) =
						((obj_t) BgL_name1107z00_3252), BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1198z00_3462)))->BgL_typez00) =
						((BgL_typez00_bglt) ((BgL_typez00_bglt) BgL_type1108z00_3253)),
						BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1198z00_3462)))->BgL_valuez00) =
						((BgL_valuez00_bglt) ((BgL_valuez00_bglt) BgL_value1109z00_3254)),
						BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1198z00_3462)))->BgL_accessz00) =
						((obj_t) BgL_access1110z00_3255), BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1198z00_3462)))->BgL_fastzd2alphazd2) =
						((obj_t) BgL_fastzd2alpha1111zd2_3256), BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1198z00_3462)))->BgL_removablez00) =
						((obj_t) BgL_removable1112z00_3257), BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1198z00_3462)))->BgL_occurrencez00) =
						((long) BgL_occurrence1113z00_3456), BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1198z00_3462)))->BgL_occurrencewz00) =
						((long) BgL_occurrencew1114z00_3457), BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1198z00_3462)))->BgL_userzf3zf3) =
						((bool_t) BgL_userzf31115zf3_3458), BUNSPEC);
					((((BgL_localz00_bglt) COBJECT(((BgL_localz00_bglt)
										BgL_new1198z00_3462)))->BgL_keyz00) =
						((long) BgL_key1116z00_3459), BUNSPEC);
					{
						BgL_localzf2valuezf2_bglt BgL_auxz00_4044;

						{
							obj_t BgL_auxz00_4045;

							{	/* Dataflow/walk.scm 37 */
								BgL_objectz00_bglt BgL_tmpz00_4046;

								BgL_tmpz00_4046 = ((BgL_objectz00_bglt) BgL_new1198z00_3462);
								BgL_auxz00_4045 = BGL_OBJECT_WIDENING(BgL_tmpz00_4046);
							}
							BgL_auxz00_4044 = ((BgL_localzf2valuezf2_bglt) BgL_auxz00_4045);
						}
						((((BgL_localzf2valuezf2_bglt) COBJECT(BgL_auxz00_4044))->
								BgL_stampz00) = ((int) BgL_stamp1117z00_3460), BUNSPEC);
					}
					{
						BgL_localzf2valuezf2_bglt BgL_auxz00_4051;

						{
							obj_t BgL_auxz00_4052;

							{	/* Dataflow/walk.scm 37 */
								BgL_objectz00_bglt BgL_tmpz00_4053;

								BgL_tmpz00_4053 = ((BgL_objectz00_bglt) BgL_new1198z00_3462);
								BgL_auxz00_4052 = BGL_OBJECT_WIDENING(BgL_tmpz00_4053);
							}
							BgL_auxz00_4051 = ((BgL_localzf2valuezf2_bglt) BgL_auxz00_4052);
						}
						((((BgL_localzf2valuezf2_bglt) COBJECT(BgL_auxz00_4051))->
								BgL_nodez00) =
							((BgL_nodez00_bglt) ((BgL_nodez00_bglt) BgL_node1118z00_3263)),
							BUNSPEC);
					}
					return BgL_new1198z00_3462;
				}
			}
		}

	}



/* &lambda1629 */
	obj_t BGl_z62lambda1629z62zzdataflow_walkz00(obj_t BgL_envz00_3264,
		obj_t BgL_oz00_3265, obj_t BgL_vz00_3266)
	{
		{	/* Dataflow/walk.scm 37 */
			{
				BgL_localzf2valuezf2_bglt BgL_auxz00_4059;

				{
					obj_t BgL_auxz00_4060;

					{	/* Dataflow/walk.scm 37 */
						BgL_objectz00_bglt BgL_tmpz00_4061;

						BgL_tmpz00_4061 =
							((BgL_objectz00_bglt) ((BgL_localz00_bglt) BgL_oz00_3265));
						BgL_auxz00_4060 = BGL_OBJECT_WIDENING(BgL_tmpz00_4061);
					}
					BgL_auxz00_4059 = ((BgL_localzf2valuezf2_bglt) BgL_auxz00_4060);
				}
				return
					((((BgL_localzf2valuezf2_bglt) COBJECT(BgL_auxz00_4059))->
						BgL_nodez00) =
					((BgL_nodez00_bglt) ((BgL_nodez00_bglt) BgL_vz00_3266)), BUNSPEC);
			}
		}

	}



/* &lambda1628 */
	BgL_nodez00_bglt BGl_z62lambda1628z62zzdataflow_walkz00(obj_t BgL_envz00_3267,
		obj_t BgL_oz00_3268)
	{
		{	/* Dataflow/walk.scm 37 */
			{
				BgL_localzf2valuezf2_bglt BgL_auxz00_4068;

				{
					obj_t BgL_auxz00_4069;

					{	/* Dataflow/walk.scm 37 */
						BgL_objectz00_bglt BgL_tmpz00_4070;

						BgL_tmpz00_4070 =
							((BgL_objectz00_bglt) ((BgL_localz00_bglt) BgL_oz00_3268));
						BgL_auxz00_4069 = BGL_OBJECT_WIDENING(BgL_tmpz00_4070);
					}
					BgL_auxz00_4068 = ((BgL_localzf2valuezf2_bglt) BgL_auxz00_4069);
				}
				return
					(((BgL_localzf2valuezf2_bglt) COBJECT(BgL_auxz00_4068))->BgL_nodez00);
			}
		}

	}



/* &lambda1615 */
	obj_t BGl_z62lambda1615z62zzdataflow_walkz00(obj_t BgL_envz00_3269,
		obj_t BgL_oz00_3270, obj_t BgL_vz00_3271)
	{
		{	/* Dataflow/walk.scm 37 */
			{	/* Dataflow/walk.scm 37 */
				int BgL_vz00_3474;

				BgL_vz00_3474 = CINT(BgL_vz00_3271);
				{
					BgL_localzf2valuezf2_bglt BgL_auxz00_4077;

					{
						obj_t BgL_auxz00_4078;

						{	/* Dataflow/walk.scm 37 */
							BgL_objectz00_bglt BgL_tmpz00_4079;

							BgL_tmpz00_4079 =
								((BgL_objectz00_bglt) ((BgL_localz00_bglt) BgL_oz00_3270));
							BgL_auxz00_4078 = BGL_OBJECT_WIDENING(BgL_tmpz00_4079);
						}
						BgL_auxz00_4077 = ((BgL_localzf2valuezf2_bglt) BgL_auxz00_4078);
					}
					return
						((((BgL_localzf2valuezf2_bglt) COBJECT(BgL_auxz00_4077))->
							BgL_stampz00) = ((int) BgL_vz00_3474), BUNSPEC);
		}}}

	}



/* &lambda1614 */
	obj_t BGl_z62lambda1614z62zzdataflow_walkz00(obj_t BgL_envz00_3272,
		obj_t BgL_oz00_3273)
	{
		{	/* Dataflow/walk.scm 37 */
			{	/* Dataflow/walk.scm 37 */
				int BgL_tmpz00_4085;

				{
					BgL_localzf2valuezf2_bglt BgL_auxz00_4086;

					{
						obj_t BgL_auxz00_4087;

						{	/* Dataflow/walk.scm 37 */
							BgL_objectz00_bglt BgL_tmpz00_4088;

							BgL_tmpz00_4088 =
								((BgL_objectz00_bglt) ((BgL_localz00_bglt) BgL_oz00_3273));
							BgL_auxz00_4087 = BGL_OBJECT_WIDENING(BgL_tmpz00_4088);
						}
						BgL_auxz00_4086 = ((BgL_localzf2valuezf2_bglt) BgL_auxz00_4087);
					}
					BgL_tmpz00_4085 =
						(((BgL_localzf2valuezf2_bglt) COBJECT(BgL_auxz00_4086))->
						BgL_stampz00);
				}
				return BINT(BgL_tmpz00_4085);
			}
		}

	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzdataflow_walkz00()
	{
		{	/* Dataflow/walk.scm 17 */
			BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_proc2265z00zzdataflow_walkz00, BGl_nodez00zzast_nodez00,
				BGl_string2266z00zzdataflow_walkz00);
			BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_dataflowzd2testzd2envzd2envzd2zzdataflow_walkz00,
				BGl_proc2267z00zzdataflow_walkz00, BGl_nodez00zzast_nodez00,
				BGl_string2268z00zzdataflow_walkz00);
			BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_dataflowzd2testzd2falsezd2envzd2envz00zzdataflow_walkz00,
				BGl_proc2269z00zzdataflow_walkz00, BGl_nodez00zzast_nodez00,
				BGl_string2270z00zzdataflow_walkz00);
			return
				BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_abortzf3zd2envz21zzdataflow_walkz00,
				BGl_proc2271z00zzdataflow_walkz00, BGl_nodez00zzast_nodez00,
				BGl_string2272z00zzdataflow_walkz00);
		}

	}



/* &abort?1434 */
	obj_t BGl_z62abortzf31434z91zzdataflow_walkz00(obj_t BgL_envz00_3278,
		obj_t BgL_nodez00_3279)
	{
		{	/* Dataflow/walk.scm 428 */
			return BBOOL(((bool_t) 0));
		}

	}



/* &dataflow-test-false-1430 */
	obj_t BGl_z62dataflowzd2testzd2falsezd21430zb0zzdataflow_walkz00(obj_t
		BgL_envz00_3280, obj_t BgL_nodez00_3281)
	{
		{	/* Dataflow/walk.scm 400 */
			return BNIL;
		}

	}



/* &dataflow-test-env1417 */
	obj_t BGl_z62dataflowzd2testzd2env1417z62zzdataflow_walkz00(obj_t
		BgL_envz00_3282, obj_t BgL_nodez00_3283)
	{
		{	/* Dataflow/walk.scm 314 */
			return BNIL;
		}

	}



/* &dataflow-node!1373 */
	obj_t BGl_z62dataflowzd2nodez121373za2zzdataflow_walkz00(obj_t
		BgL_envz00_3284, obj_t BgL_nodez00_3285, obj_t BgL_envz00_3286)
	{
		{	/* Dataflow/walk.scm 69 */
			return ((obj_t) BgL_envz00_3286);
		}

	}



/* dataflow-node! */
	obj_t BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(BgL_nodez00_bglt
		BgL_nodez00_59, obj_t BgL_envz00_60)
	{
		{	/* Dataflow/walk.scm 69 */
			{	/* Dataflow/walk.scm 69 */
				obj_t BgL_method1375z00_1912;

				{	/* Dataflow/walk.scm 69 */
					obj_t BgL_res2167z00_2903;

					{	/* Dataflow/walk.scm 69 */
						long BgL_objzd2classzd2numz00_2868;

						{	/* Dataflow/walk.scm 69 */
							long BgL_res2157z00_2871;

							BgL_res2157z00_2871 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nodez00_59));
							BgL_objzd2classzd2numz00_2868 = BgL_res2157z00_2871;
						}
						{	/* Dataflow/walk.scm 69 */
							obj_t BgL_arg1741z00_2869;

							BgL_arg1741z00_2869 =
								PROCEDURE_REF(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
								(int) (((long) 1)));
							{	/* Dataflow/walk.scm 69 */
								int BgL_offsetz00_2873;

								BgL_offsetz00_2873 = (int) (BgL_objzd2classzd2numz00_2868);
								{	/* Dataflow/walk.scm 69 */
									long BgL_offsetz00_2874;

									BgL_offsetz00_2874 =
										((long) (BgL_offsetz00_2873) - OBJECT_TYPE);
									{	/* Dataflow/walk.scm 69 */
										long BgL_modz00_2875;

										BgL_modz00_2875 =
											(BgL_offsetz00_2874 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Dataflow/walk.scm 69 */
											long BgL_restz00_2877;

											BgL_restz00_2877 =
												(BgL_offsetz00_2874 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Dataflow/walk.scm 69 */

												{	/* Dataflow/walk.scm 69 */
													obj_t BgL_bucketz00_2879;

													BgL_bucketz00_2879 =
														VECTOR_REF(
														((obj_t) BgL_arg1741z00_2869), BgL_modz00_2875);
													BgL_res2167z00_2903 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_2879), BgL_restz00_2877);
					}}}}}}}}
					BgL_method1375z00_1912 = BgL_res2167z00_2903;
				}
				return
					PROCEDURE_ENTRY(BgL_method1375z00_1912) (BgL_method1375z00_1912,
					((obj_t) BgL_nodez00_59), BgL_envz00_60, BEOA);
			}
		}

	}



/* &dataflow-node! */
	obj_t BGl_z62dataflowzd2nodez12za2zzdataflow_walkz00(obj_t BgL_envz00_3287,
		obj_t BgL_nodez00_3288, obj_t BgL_envz00_3289)
	{
		{	/* Dataflow/walk.scm 69 */
			return
				BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
				((BgL_nodez00_bglt) BgL_nodez00_3288), BgL_envz00_3289);
		}

	}



/* dataflow-test-env */
	obj_t BGl_dataflowzd2testzd2envz00zzdataflow_walkz00(BgL_nodez00_bglt
		BgL_nodez00_101)
	{
		{	/* Dataflow/walk.scm 314 */
			{	/* Dataflow/walk.scm 314 */
				obj_t BgL_method1418z00_1913;

				{	/* Dataflow/walk.scm 314 */
					obj_t BgL_res2178z00_2940;

					{	/* Dataflow/walk.scm 314 */
						long BgL_objzd2classzd2numz00_2905;

						{	/* Dataflow/walk.scm 314 */
							long BgL_res2168z00_2908;

							BgL_res2168z00_2908 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nodez00_101));
							BgL_objzd2classzd2numz00_2905 = BgL_res2168z00_2908;
						}
						{	/* Dataflow/walk.scm 314 */
							obj_t BgL_arg1741z00_2906;

							BgL_arg1741z00_2906 =
								PROCEDURE_REF
								(BGl_dataflowzd2testzd2envzd2envzd2zzdataflow_walkz00,
								(int) (((long) 1)));
							{	/* Dataflow/walk.scm 314 */
								int BgL_offsetz00_2910;

								BgL_offsetz00_2910 = (int) (BgL_objzd2classzd2numz00_2905);
								{	/* Dataflow/walk.scm 314 */
									long BgL_offsetz00_2911;

									BgL_offsetz00_2911 =
										((long) (BgL_offsetz00_2910) - OBJECT_TYPE);
									{	/* Dataflow/walk.scm 314 */
										long BgL_modz00_2912;

										BgL_modz00_2912 =
											(BgL_offsetz00_2911 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Dataflow/walk.scm 314 */
											long BgL_restz00_2914;

											BgL_restz00_2914 =
												(BgL_offsetz00_2911 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Dataflow/walk.scm 314 */

												{	/* Dataflow/walk.scm 314 */
													obj_t BgL_bucketz00_2916;

													BgL_bucketz00_2916 =
														VECTOR_REF(
														((obj_t) BgL_arg1741z00_2906), BgL_modz00_2912);
													BgL_res2178z00_2940 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_2916), BgL_restz00_2914);
					}}}}}}}}
					BgL_method1418z00_1913 = BgL_res2178z00_2940;
				}
				return
					PROCEDURE_ENTRY(BgL_method1418z00_1913) (BgL_method1418z00_1913,
					((obj_t) BgL_nodez00_101), BEOA);
			}
		}

	}



/* &dataflow-test-env */
	obj_t BGl_z62dataflowzd2testzd2envz62zzdataflow_walkz00(obj_t BgL_envz00_3290,
		obj_t BgL_nodez00_3291)
	{
		{	/* Dataflow/walk.scm 314 */
			return
				BGl_dataflowzd2testzd2envz00zzdataflow_walkz00(
				((BgL_nodez00_bglt) BgL_nodez00_3291));
		}

	}



/* dataflow-test-false-env */
	obj_t BGl_dataflowzd2testzd2falsezd2envzd2zzdataflow_walkz00(BgL_nodez00_bglt
		BgL_nodez00_107)
	{
		{	/* Dataflow/walk.scm 400 */
			{	/* Dataflow/walk.scm 400 */
				obj_t BgL_method1431z00_1914;

				{	/* Dataflow/walk.scm 400 */
					obj_t BgL_res2189z00_2977;

					{	/* Dataflow/walk.scm 400 */
						long BgL_objzd2classzd2numz00_2942;

						{	/* Dataflow/walk.scm 400 */
							long BgL_res2179z00_2945;

							BgL_res2179z00_2945 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nodez00_107));
							BgL_objzd2classzd2numz00_2942 = BgL_res2179z00_2945;
						}
						{	/* Dataflow/walk.scm 400 */
							obj_t BgL_arg1741z00_2943;

							BgL_arg1741z00_2943 =
								PROCEDURE_REF
								(BGl_dataflowzd2testzd2falsezd2envzd2envz00zzdataflow_walkz00,
								(int) (((long) 1)));
							{	/* Dataflow/walk.scm 400 */
								int BgL_offsetz00_2947;

								BgL_offsetz00_2947 = (int) (BgL_objzd2classzd2numz00_2942);
								{	/* Dataflow/walk.scm 400 */
									long BgL_offsetz00_2948;

									BgL_offsetz00_2948 =
										((long) (BgL_offsetz00_2947) - OBJECT_TYPE);
									{	/* Dataflow/walk.scm 400 */
										long BgL_modz00_2949;

										BgL_modz00_2949 =
											(BgL_offsetz00_2948 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Dataflow/walk.scm 400 */
											long BgL_restz00_2951;

											BgL_restz00_2951 =
												(BgL_offsetz00_2948 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Dataflow/walk.scm 400 */

												{	/* Dataflow/walk.scm 400 */
													obj_t BgL_bucketz00_2953;

													BgL_bucketz00_2953 =
														VECTOR_REF(
														((obj_t) BgL_arg1741z00_2943), BgL_modz00_2949);
													BgL_res2189z00_2977 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_2953), BgL_restz00_2951);
					}}}}}}}}
					BgL_method1431z00_1914 = BgL_res2189z00_2977;
				}
				return
					PROCEDURE_ENTRY(BgL_method1431z00_1914) (BgL_method1431z00_1914,
					((obj_t) BgL_nodez00_107), BEOA);
			}
		}

	}



/* &dataflow-test-false-env */
	obj_t BGl_z62dataflowzd2testzd2falsezd2envzb0zzdataflow_walkz00(obj_t
		BgL_envz00_3292, obj_t BgL_nodez00_3293)
	{
		{	/* Dataflow/walk.scm 400 */
			return
				BGl_dataflowzd2testzd2falsezd2envzd2zzdataflow_walkz00(
				((BgL_nodez00_bglt) BgL_nodez00_3293));
		}

	}



/* abort? */
	obj_t BGl_abortzf3zf3zzdataflow_walkz00(BgL_nodez00_bglt BgL_nodez00_109)
	{
		{	/* Dataflow/walk.scm 428 */
			{	/* Dataflow/walk.scm 428 */
				obj_t BgL_method1435z00_1915;

				{	/* Dataflow/walk.scm 428 */
					obj_t BgL_res2200z00_3014;

					{	/* Dataflow/walk.scm 428 */
						long BgL_objzd2classzd2numz00_2979;

						{	/* Dataflow/walk.scm 428 */
							long BgL_res2190z00_2982;

							BgL_res2190z00_2982 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nodez00_109));
							BgL_objzd2classzd2numz00_2979 = BgL_res2190z00_2982;
						}
						{	/* Dataflow/walk.scm 428 */
							obj_t BgL_arg1741z00_2980;

							BgL_arg1741z00_2980 =
								PROCEDURE_REF(BGl_abortzf3zd2envz21zzdataflow_walkz00,
								(int) (((long) 1)));
							{	/* Dataflow/walk.scm 428 */
								int BgL_offsetz00_2984;

								BgL_offsetz00_2984 = (int) (BgL_objzd2classzd2numz00_2979);
								{	/* Dataflow/walk.scm 428 */
									long BgL_offsetz00_2985;

									BgL_offsetz00_2985 =
										((long) (BgL_offsetz00_2984) - OBJECT_TYPE);
									{	/* Dataflow/walk.scm 428 */
										long BgL_modz00_2986;

										BgL_modz00_2986 =
											(BgL_offsetz00_2985 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Dataflow/walk.scm 428 */
											long BgL_restz00_2988;

											BgL_restz00_2988 =
												(BgL_offsetz00_2985 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Dataflow/walk.scm 428 */

												{	/* Dataflow/walk.scm 428 */
													obj_t BgL_bucketz00_2990;

													BgL_bucketz00_2990 =
														VECTOR_REF(
														((obj_t) BgL_arg1741z00_2980), BgL_modz00_2986);
													BgL_res2200z00_3014 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_2990), BgL_restz00_2988);
					}}}}}}}}
					BgL_method1435z00_1915 = BgL_res2200z00_3014;
				}
				return
					PROCEDURE_ENTRY(BgL_method1435z00_1915) (BgL_method1435z00_1915,
					((obj_t) BgL_nodez00_109), BEOA);
			}
		}

	}



/* &abort? */
	obj_t BGl_z62abortzf3z91zzdataflow_walkz00(obj_t BgL_envz00_3294,
		obj_t BgL_nodez00_3295)
	{
		{	/* Dataflow/walk.scm 428 */
			return
				BGl_abortzf3zf3zzdataflow_walkz00(
				((BgL_nodez00_bglt) BgL_nodez00_3295));
		}

	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzdataflow_walkz00()
	{
		{	/* Dataflow/walk.scm 17 */
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_varz00zzast_nodez00, BGl_proc2273z00zzdataflow_walkz00,
				BGl_string2274z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_closurez00zzast_nodez00, BGl_proc2275z00zzdataflow_walkz00,
				BGl_string2274z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_sequencez00zzast_nodez00, BGl_proc2276z00zzdataflow_walkz00,
				BGl_string2274z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_syncz00zzast_nodez00, BGl_proc2277z00zzdataflow_walkz00,
				BGl_string2274z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_appz00zzast_nodez00, BGl_proc2278z00zzdataflow_walkz00,
				BGl_string2274z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_appzd2lyzd2zzast_nodez00, BGl_proc2279z00zzdataflow_walkz00,
				BGl_string2274z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_funcallz00zzast_nodez00, BGl_proc2280z00zzdataflow_walkz00,
				BGl_string2274z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_externz00zzast_nodez00, BGl_proc2281z00zzdataflow_walkz00,
				BGl_string2274z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_setqz00zzast_nodez00, BGl_proc2282z00zzdataflow_walkz00,
				BGl_string2274z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_conditionalz00zzast_nodez00, BGl_proc2283z00zzdataflow_walkz00,
				BGl_string2274z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_failz00zzast_nodez00, BGl_proc2284z00zzdataflow_walkz00,
				BGl_string2274z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_switchz00zzast_nodez00, BGl_proc2285z00zzdataflow_walkz00,
				BGl_string2274z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_letzd2funzd2zzast_nodez00, BGl_proc2286z00zzdataflow_walkz00,
				BGl_string2274z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc2287z00zzdataflow_walkz00,
				BGl_string2274z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_setzd2exzd2itz00zzast_nodez00, BGl_proc2288z00zzdataflow_walkz00,
				BGl_string2274z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_jumpzd2exzd2itz00zzast_nodez00, BGl_proc2289z00zzdataflow_walkz00,
				BGl_string2274z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_makezd2boxzd2zzast_nodez00, BGl_proc2290z00zzdataflow_walkz00,
				BGl_string2274z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_boxzd2refzd2zzast_nodez00, BGl_proc2291z00zzdataflow_walkz00,
				BGl_string2274z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_boxzd2setz12zc0zzast_nodez00, BGl_proc2292z00zzdataflow_walkz00,
				BGl_string2274z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2testzd2envzd2envzd2zzdataflow_walkz00,
				BGl_appz00zzast_nodez00, BGl_proc2293z00zzdataflow_walkz00,
				BGl_string2294z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2testzd2envzd2envzd2zzdataflow_walkz00,
				BGl_instanceofz00zzast_nodez00, BGl_proc2295z00zzdataflow_walkz00,
				BGl_string2294z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2testzd2envzd2envzd2zzdataflow_walkz00,
				BGl_conditionalz00zzast_nodez00, BGl_proc2296z00zzdataflow_walkz00,
				BGl_string2294z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2testzd2envzd2envzd2zzdataflow_walkz00,
				BGl_varz00zzast_nodez00, BGl_proc2297z00zzdataflow_walkz00,
				BGl_string2294z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2testzd2envzd2envzd2zzdataflow_walkz00,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc2298z00zzdataflow_walkz00,
				BGl_string2294z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2testzd2falsezd2envzd2envz00zzdataflow_walkz00,
				BGl_appz00zzast_nodez00, BGl_proc2299z00zzdataflow_walkz00,
				BGl_string2300z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_abortzf3zd2envz21zzdataflow_walkz00, BGl_failz00zzast_nodez00,
				BGl_proc2301z00zzdataflow_walkz00, BGl_string2302z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_abortzf3zd2envz21zzdataflow_walkz00, BGl_sequencez00zzast_nodez00,
				BGl_proc2303z00zzdataflow_walkz00, BGl_string2302z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_abortzf3zd2envz21zzdataflow_walkz00, BGl_syncz00zzast_nodez00,
				BGl_proc2304z00zzdataflow_walkz00, BGl_string2302z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_abortzf3zd2envz21zzdataflow_walkz00, BGl_letzd2varzd2zzast_nodez00,
				BGl_proc2305z00zzdataflow_walkz00, BGl_string2302z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_abortzf3zd2envz21zzdataflow_walkz00, BGl_letzd2funzd2zzast_nodez00,
				BGl_proc2306z00zzdataflow_walkz00, BGl_string2302z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_abortzf3zd2envz21zzdataflow_walkz00,
				BGl_conditionalz00zzast_nodez00, BGl_proc2307z00zzdataflow_walkz00,
				BGl_string2302z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_abortzf3zd2envz21zzdataflow_walkz00, BGl_appz00zzast_nodez00,
				BGl_proc2308z00zzdataflow_walkz00, BGl_string2302z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_abortzf3zd2envz21zzdataflow_walkz00, BGl_funcallz00zzast_nodez00,
				BGl_proc2309z00zzdataflow_walkz00, BGl_string2302z00zzdataflow_walkz00);
			return
				BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_abortzf3zd2envz21zzdataflow_walkz00, BGl_appzd2lyzd2zzast_nodez00,
				BGl_proc2310z00zzdataflow_walkz00, BGl_string2302z00zzdataflow_walkz00);
		}

	}



/* &abort?-app-ly1453 */
	obj_t BGl_z62abortzf3zd2appzd2ly1453z91zzdataflow_walkz00(obj_t
		BgL_envz00_3331, obj_t BgL_nodez00_3332)
	{
		{	/* Dataflow/walk.scm 489 */
			{	/* Dataflow/walk.scm 491 */
				obj_t BgL__ortest_1194z00_3482;

				BgL__ortest_1194z00_3482 =
					BGl_abortzf3zf3zzdataflow_walkz00(
					(((BgL_appzd2lyzd2_bglt) COBJECT(
								((BgL_appzd2lyzd2_bglt) BgL_nodez00_3332)))->BgL_funz00));
				if (CBOOL(BgL__ortest_1194z00_3482))
					{	/* Dataflow/walk.scm 491 */
						return BgL__ortest_1194z00_3482;
					}
				else
					{	/* Dataflow/walk.scm 491 */
						return
							BGl_abortzf3zf3zzdataflow_walkz00(
							(((BgL_appzd2lyzd2_bglt) COBJECT(
										((BgL_appzd2lyzd2_bglt) BgL_nodez00_3332)))->BgL_argz00));
					}
			}
		}

	}



/* &abort?-funcall1451 */
	obj_t BGl_z62abortzf3zd2funcall1451z43zzdataflow_walkz00(obj_t
		BgL_envz00_3333, obj_t BgL_nodez00_3334)
	{
		{	/* Dataflow/walk.scm 482 */
			{	/* Dataflow/walk.scm 484 */
				obj_t BgL__ortest_1192z00_3484;

				BgL__ortest_1192z00_3484 =
					BGl_abortzf3zf3zzdataflow_walkz00(
					(((BgL_funcallz00_bglt) COBJECT(
								((BgL_funcallz00_bglt) BgL_nodez00_3334)))->BgL_funz00));
				if (CBOOL(BgL__ortest_1192z00_3484))
					{	/* Dataflow/walk.scm 484 */
						return BgL__ortest_1192z00_3484;
					}
				else
					{	/* Dataflow/walk.scm 484 */
						obj_t BgL_g1369z00_3485;

						BgL_g1369z00_3485 =
							(((BgL_funcallz00_bglt) COBJECT(
									((BgL_funcallz00_bglt) BgL_nodez00_3334)))->BgL_argsz00);
						{
							obj_t BgL_l1367z00_3487;

							BgL_l1367z00_3487 = BgL_g1369z00_3485;
						BgL_zc3z04anonymousza32061ze3z87_3486:
							if (NULLP(BgL_l1367z00_3487))
								{	/* Dataflow/walk.scm 484 */
									return BFALSE;
								}
							else
								{	/* Dataflow/walk.scm 484 */
									obj_t BgL__ortest_1370z00_3488;

									{	/* Dataflow/walk.scm 484 */
										obj_t BgL_arg2064z00_3489;

										BgL_arg2064z00_3489 = CAR(((obj_t) BgL_l1367z00_3487));
										BgL__ortest_1370z00_3488 =
											BGl_abortzf3zf3zzdataflow_walkz00(
											((BgL_nodez00_bglt) BgL_arg2064z00_3489));
									}
									if (CBOOL(BgL__ortest_1370z00_3488))
										{	/* Dataflow/walk.scm 484 */
											return BgL__ortest_1370z00_3488;
										}
									else
										{	/* Dataflow/walk.scm 484 */
											obj_t BgL_arg2063z00_3490;

											BgL_arg2063z00_3490 = CDR(((obj_t) BgL_l1367z00_3487));
											{
												obj_t BgL_l1367z00_4289;

												BgL_l1367z00_4289 = BgL_arg2063z00_3490;
												BgL_l1367z00_3487 = BgL_l1367z00_4289;
												goto BgL_zc3z04anonymousza32061ze3z87_3486;
											}
										}
								}
						}
					}
			}
		}

	}



/* &abort?-app1449 */
	obj_t BGl_z62abortzf3zd2app1449z43zzdataflow_walkz00(obj_t BgL_envz00_3335,
		obj_t BgL_nodez00_3336)
	{
		{	/* Dataflow/walk.scm 475 */
			{	/* Dataflow/walk.scm 477 */
				obj_t BgL__ortest_1190z00_3492;

				{	/* Dataflow/walk.scm 477 */
					BgL_varz00_bglt BgL_arg2060z00_3493;

					BgL_arg2060z00_3493 =
						(((BgL_appz00_bglt) COBJECT(
								((BgL_appz00_bglt) BgL_nodez00_3336)))->BgL_funz00);
					BgL__ortest_1190z00_3492 =
						BGl_abortzf3zf3zzdataflow_walkz00(
						((BgL_nodez00_bglt) BgL_arg2060z00_3493));
				}
				if (CBOOL(BgL__ortest_1190z00_3492))
					{	/* Dataflow/walk.scm 477 */
						return BgL__ortest_1190z00_3492;
					}
				else
					{	/* Dataflow/walk.scm 477 */
						obj_t BgL_g1365z00_3494;

						BgL_g1365z00_3494 =
							(((BgL_appz00_bglt) COBJECT(
									((BgL_appz00_bglt) BgL_nodez00_3336)))->BgL_argsz00);
						{
							obj_t BgL_l1363z00_3496;

							BgL_l1363z00_3496 = BgL_g1365z00_3494;
						BgL_zc3z04anonymousza32056ze3z87_3495:
							if (NULLP(BgL_l1363z00_3496))
								{	/* Dataflow/walk.scm 477 */
									return BFALSE;
								}
							else
								{	/* Dataflow/walk.scm 477 */
									obj_t BgL__ortest_1366z00_3497;

									{	/* Dataflow/walk.scm 477 */
										obj_t BgL_arg2059z00_3498;

										BgL_arg2059z00_3498 = CAR(((obj_t) BgL_l1363z00_3496));
										BgL__ortest_1366z00_3497 =
											BGl_abortzf3zf3zzdataflow_walkz00(
											((BgL_nodez00_bglt) BgL_arg2059z00_3498));
									}
									if (CBOOL(BgL__ortest_1366z00_3497))
										{	/* Dataflow/walk.scm 477 */
											return BgL__ortest_1366z00_3497;
										}
									else
										{	/* Dataflow/walk.scm 477 */
											obj_t BgL_arg2058z00_3499;

											BgL_arg2058z00_3499 = CDR(((obj_t) BgL_l1363z00_3496));
											{
												obj_t BgL_l1363z00_4308;

												BgL_l1363z00_4308 = BgL_arg2058z00_3499;
												BgL_l1363z00_3496 = BgL_l1363z00_4308;
												goto BgL_zc3z04anonymousza32056ze3z87_3495;
											}
										}
								}
						}
					}
			}
		}

	}



/* &abort?-conditional1447 */
	obj_t BGl_z62abortzf3zd2conditional1447z43zzdataflow_walkz00(obj_t
		BgL_envz00_3337, obj_t BgL_nodez00_3338)
	{
		{	/* Dataflow/walk.scm 468 */
			{	/* Dataflow/walk.scm 470 */
				obj_t BgL__ortest_1187z00_3501;

				BgL__ortest_1187z00_3501 =
					BGl_abortzf3zf3zzdataflow_walkz00(
					(((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nodez00_3338)))->BgL_testz00));
				if (CBOOL(BgL__ortest_1187z00_3501))
					{	/* Dataflow/walk.scm 470 */
						return BgL__ortest_1187z00_3501;
					}
				else
					{	/* Dataflow/walk.scm 470 */
						obj_t BgL__andtest_1188z00_3502;

						BgL__andtest_1188z00_3502 =
							BGl_abortzf3zf3zzdataflow_walkz00(
							(((BgL_conditionalz00_bglt) COBJECT(
										((BgL_conditionalz00_bglt) BgL_nodez00_3338)))->
								BgL_truez00));
						if (CBOOL(BgL__andtest_1188z00_3502))
							{	/* Dataflow/walk.scm 470 */
								return
									BGl_abortzf3zf3zzdataflow_walkz00(
									(((BgL_conditionalz00_bglt) COBJECT(
												((BgL_conditionalz00_bglt) BgL_nodez00_3338)))->
										BgL_falsez00));
							}
						else
							{	/* Dataflow/walk.scm 470 */
								return BFALSE;
							}
					}
			}
		}

	}



/* &abort?-let-fun1445 */
	obj_t BGl_z62abortzf3zd2letzd2fun1445z91zzdataflow_walkz00(obj_t
		BgL_envz00_3339, obj_t BgL_nodez00_3340)
	{
		{	/* Dataflow/walk.scm 461 */
			return
				BGl_abortzf3zf3zzdataflow_walkz00(
				(((BgL_letzd2funzd2_bglt) COBJECT(
							((BgL_letzd2funzd2_bglt) BgL_nodez00_3340)))->BgL_bodyz00));
		}

	}



/* &abort?-let-var1443 */
	obj_t BGl_z62abortzf3zd2letzd2var1443z91zzdataflow_walkz00(obj_t
		BgL_envz00_3341, obj_t BgL_nodez00_3342)
	{
		{	/* Dataflow/walk.scm 454 */
			{	/* Dataflow/walk.scm 456 */
				obj_t BgL__ortest_1184z00_3505;

				{	/* Dataflow/walk.scm 456 */
					obj_t BgL_g1361z00_3506;

					BgL_g1361z00_3506 =
						(((BgL_letzd2varzd2_bglt) COBJECT(
								((BgL_letzd2varzd2_bglt) BgL_nodez00_3342)))->BgL_bindingsz00);
					{
						obj_t BgL_l1359z00_3508;

						BgL_l1359z00_3508 = BgL_g1361z00_3506;
					BgL_zc3z04anonymousza32048ze3z87_3507:
						if (NULLP(BgL_l1359z00_3508))
							{	/* Dataflow/walk.scm 456 */
								BgL__ortest_1184z00_3505 = BFALSE;
							}
						else
							{	/* Dataflow/walk.scm 456 */
								obj_t BgL__ortest_1362z00_3509;

								{	/* Dataflow/walk.scm 456 */
									obj_t BgL_bz00_3510;

									BgL_bz00_3510 = CAR(((obj_t) BgL_l1359z00_3508));
									{	/* Dataflow/walk.scm 456 */
										obj_t BgL_arg2051z00_3511;

										BgL_arg2051z00_3511 = CDR(((obj_t) BgL_bz00_3510));
										BgL__ortest_1362z00_3509 =
											BGl_abortzf3zf3zzdataflow_walkz00(
											((BgL_nodez00_bglt) BgL_arg2051z00_3511));
									}
								}
								if (CBOOL(BgL__ortest_1362z00_3509))
									{	/* Dataflow/walk.scm 456 */
										BgL__ortest_1184z00_3505 = BgL__ortest_1362z00_3509;
									}
								else
									{	/* Dataflow/walk.scm 456 */
										obj_t BgL_arg2050z00_3512;

										BgL_arg2050z00_3512 = CDR(((obj_t) BgL_l1359z00_3508));
										{
											obj_t BgL_l1359z00_4339;

											BgL_l1359z00_4339 = BgL_arg2050z00_3512;
											BgL_l1359z00_3508 = BgL_l1359z00_4339;
											goto BgL_zc3z04anonymousza32048ze3z87_3507;
										}
									}
							}
					}
				}
				if (CBOOL(BgL__ortest_1184z00_3505))
					{	/* Dataflow/walk.scm 456 */
						return BgL__ortest_1184z00_3505;
					}
				else
					{	/* Dataflow/walk.scm 456 */
						return
							BGl_abortzf3zf3zzdataflow_walkz00(
							(((BgL_letzd2varzd2_bglt) COBJECT(
										((BgL_letzd2varzd2_bglt) BgL_nodez00_3342)))->BgL_bodyz00));
					}
			}
		}

	}



/* &abort?-sync1441 */
	obj_t BGl_z62abortzf3zd2sync1441z43zzdataflow_walkz00(obj_t BgL_envz00_3343,
		obj_t BgL_nodez00_3344)
	{
		{	/* Dataflow/walk.scm 446 */
			{	/* Dataflow/walk.scm 447 */
				obj_t BgL__ortest_1181z00_3514;

				BgL__ortest_1181z00_3514 =
					BGl_abortzf3zf3zzdataflow_walkz00(
					(((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nodez00_3344)))->BgL_mutexz00));
				if (CBOOL(BgL__ortest_1181z00_3514))
					{	/* Dataflow/walk.scm 447 */
						return BgL__ortest_1181z00_3514;
					}
				else
					{	/* Dataflow/walk.scm 448 */
						obj_t BgL__ortest_1182z00_3515;

						BgL__ortest_1182z00_3515 =
							BGl_abortzf3zf3zzdataflow_walkz00(
							(((BgL_syncz00_bglt) COBJECT(
										((BgL_syncz00_bglt) BgL_nodez00_3344)))->BgL_prelockz00));
						if (CBOOL(BgL__ortest_1182z00_3515))
							{	/* Dataflow/walk.scm 448 */
								return BgL__ortest_1182z00_3515;
							}
						else
							{	/* Dataflow/walk.scm 448 */
								return
									BGl_abortzf3zf3zzdataflow_walkz00(
									(((BgL_syncz00_bglt) COBJECT(
												((BgL_syncz00_bglt) BgL_nodez00_3344)))->BgL_bodyz00));
							}
					}
			}
		}

	}



/* &abort?-sequence1439 */
	obj_t BGl_z62abortzf3zd2sequence1439z43zzdataflow_walkz00(obj_t
		BgL_envz00_3345, obj_t BgL_nodez00_3346)
	{
		{	/* Dataflow/walk.scm 440 */
			{	/* Dataflow/walk.scm 441 */
				obj_t BgL_g1357z00_3517;

				BgL_g1357z00_3517 =
					(((BgL_sequencez00_bglt) COBJECT(
							((BgL_sequencez00_bglt) BgL_nodez00_3346)))->BgL_nodesz00);
				{
					obj_t BgL_l1355z00_3519;

					BgL_l1355z00_3519 = BgL_g1357z00_3517;
				BgL_zc3z04anonymousza32040ze3z87_3518:
					if (NULLP(BgL_l1355z00_3519))
						{	/* Dataflow/walk.scm 441 */
							return BFALSE;
						}
					else
						{	/* Dataflow/walk.scm 441 */
							obj_t BgL__ortest_1358z00_3520;

							{	/* Dataflow/walk.scm 441 */
								obj_t BgL_arg2043z00_3521;

								BgL_arg2043z00_3521 = CAR(((obj_t) BgL_l1355z00_3519));
								BgL__ortest_1358z00_3520 =
									BGl_abortzf3zf3zzdataflow_walkz00(
									((BgL_nodez00_bglt) BgL_arg2043z00_3521));
							}
							if (CBOOL(BgL__ortest_1358z00_3520))
								{	/* Dataflow/walk.scm 441 */
									return BgL__ortest_1358z00_3520;
								}
							else
								{	/* Dataflow/walk.scm 441 */
									obj_t BgL_arg2042z00_3522;

									BgL_arg2042z00_3522 = CDR(((obj_t) BgL_l1355z00_3519));
									{
										obj_t BgL_l1355z00_4370;

										BgL_l1355z00_4370 = BgL_arg2042z00_3522;
										BgL_l1355z00_3519 = BgL_l1355z00_4370;
										goto BgL_zc3z04anonymousza32040ze3z87_3518;
									}
								}
						}
				}
			}
		}

	}



/* &abort?-fail1437 */
	obj_t BGl_z62abortzf3zd2fail1437z43zzdataflow_walkz00(obj_t BgL_envz00_3347,
		obj_t BgL_nodez00_3348)
	{
		{	/* Dataflow/walk.scm 434 */
			return BBOOL(((bool_t) 1));
		}

	}



/* &dataflow-test-false-1433 */
	obj_t BGl_z62dataflowzd2testzd2falsezd21433zb0zzdataflow_walkz00(obj_t
		BgL_envz00_3349, obj_t BgL_nodez00_3350)
	{
		{	/* Dataflow/walk.scm 406 */
			{	/* Dataflow/walk.scm 408 */
				BgL_variablez00_bglt BgL_fz00_3525;

				BgL_fz00_3525 =
					(((BgL_varz00_bglt) COBJECT(
							(((BgL_appz00_bglt) COBJECT(
										((BgL_appz00_bglt) BgL_nodez00_3350)))->BgL_funz00)))->
					BgL_variablez00);
				{	/* Dataflow/walk.scm 409 */

					{	/* Dataflow/walk.scm 410 */
						bool_t BgL_test2420z00_4375;

						{	/* Dataflow/walk.scm 410 */
							bool_t BgL_test2421z00_4376;

							{	/* Dataflow/walk.scm 410 */
								obj_t BgL_tmpz00_4377;

								BgL_tmpz00_4377 =
									(((BgL_appz00_bglt) COBJECT(
											((BgL_appz00_bglt) BgL_nodez00_3350)))->BgL_argsz00);
								BgL_test2421z00_4376 = PAIRP(BgL_tmpz00_4377);
							}
							if (BgL_test2421z00_4376)
								{	/* Dataflow/walk.scm 410 */
									if (NULLP(CDR(
												(((BgL_appz00_bglt) COBJECT(
															((BgL_appz00_bglt) BgL_nodez00_3350)))->
													BgL_argsz00))))
										{	/* Dataflow/walk.scm 411 */
											bool_t BgL_test2423z00_4386;

											{	/* Dataflow/walk.scm 411 */
												obj_t BgL_arg2033z00_3526;

												BgL_arg2033z00_3526 =
													CAR(
													(((BgL_appz00_bglt) COBJECT(
																((BgL_appz00_bglt) BgL_nodez00_3350)))->
														BgL_argsz00));
												BgL_test2423z00_4386 =
													BGl_isazf3zf3zz__objectz00(BgL_arg2033z00_3526,
													BGl_varz00zzast_nodez00);
											}
											if (BgL_test2423z00_4386)
												{	/* Dataflow/walk.scm 412 */
													BgL_typez00_bglt BgL_arg2029z00_3527;

													{
														BgL_variablez00_bglt BgL_auxz00_4391;

														{
															BgL_varz00_bglt BgL_auxz00_4392;

															{	/* Dataflow/walk.scm 412 */
																obj_t BgL_pairz00_3528;

																BgL_pairz00_3528 =
																	(((BgL_appz00_bglt) COBJECT(
																			((BgL_appz00_bglt) BgL_nodez00_3350)))->
																	BgL_argsz00);
																BgL_auxz00_4392 =
																	((BgL_varz00_bglt) CAR(BgL_pairz00_3528));
															}
															BgL_auxz00_4391 =
																(((BgL_varz00_bglt) COBJECT(BgL_auxz00_4392))->
																BgL_variablez00);
														}
														BgL_arg2029z00_3527 =
															(((BgL_variablez00_bglt)
																COBJECT(BgL_auxz00_4391))->BgL_typez00);
													}
													BgL_test2420z00_4375 =
														(
														((obj_t) BgL_arg2029z00_3527) ==
														BGl_za2pairzd2nilza2zd2zztype_cachez00);
												}
											else
												{	/* Dataflow/walk.scm 411 */
													BgL_test2420z00_4375 = ((bool_t) 0);
												}
										}
									else
										{	/* Dataflow/walk.scm 410 */
											BgL_test2420z00_4375 = ((bool_t) 0);
										}
								}
							else
								{	/* Dataflow/walk.scm 410 */
									BgL_test2420z00_4375 = ((bool_t) 0);
								}
						}
						if (BgL_test2420z00_4375)
							{	/* Dataflow/walk.scm 410 */
								if (
									(((obj_t) BgL_fz00_3525) ==
										BGl_za2z42nullzf3za2zb1zzdataflow_walkz00))
									{	/* Dataflow/walk.scm 415 */
										obj_t BgL_arg2016z00_3529;

										{	/* Dataflow/walk.scm 415 */
											BgL_variablez00_bglt BgL_arg2018z00_3530;

											{
												BgL_varz00_bglt BgL_auxz00_4404;

												{	/* Dataflow/walk.scm 415 */
													obj_t BgL_pairz00_3531;

													BgL_pairz00_3531 =
														(((BgL_appz00_bglt) COBJECT(
																((BgL_appz00_bglt) BgL_nodez00_3350)))->
														BgL_argsz00);
													BgL_auxz00_4404 =
														((BgL_varz00_bglt) CAR(BgL_pairz00_3531));
												}
												BgL_arg2018z00_3530 =
													(((BgL_varz00_bglt) COBJECT(BgL_auxz00_4404))->
													BgL_variablez00);
											}
											BgL_arg2016z00_3529 =
												MAKE_YOUNG_PAIR(
												((obj_t) BgL_arg2018z00_3530),
												BGl_za2pairza2z00zztype_cachez00);
										}
										{	/* Dataflow/walk.scm 415 */
											obj_t BgL_list2017z00_3532;

											BgL_list2017z00_3532 =
												MAKE_YOUNG_PAIR(BgL_arg2016z00_3529, BNIL);
											return BgL_list2017z00_3532;
										}
									}
								else
									{	/* Dataflow/walk.scm 416 */
										bool_t BgL_test2425z00_4413;

										if (
											(((obj_t) BgL_fz00_3525) ==
												BGl_za2z42pairzf3za2zb1zzdataflow_walkz00))
											{	/* Dataflow/walk.scm 416 */
												BgL_test2425z00_4413 = ((bool_t) 1);
											}
										else
											{	/* Dataflow/walk.scm 416 */
												BgL_test2425z00_4413 =
													(
													((obj_t) BgL_fz00_3525) ==
													BGl_za2z42epairzf3za2zb1zzdataflow_walkz00);
											}
										if (BgL_test2425z00_4413)
											{	/* Dataflow/walk.scm 417 */
												obj_t BgL_arg2023z00_3533;

												{	/* Dataflow/walk.scm 417 */
													BgL_variablez00_bglt BgL_arg2025z00_3534;

													{
														BgL_varz00_bglt BgL_auxz00_4419;

														{	/* Dataflow/walk.scm 417 */
															obj_t BgL_pairz00_3535;

															BgL_pairz00_3535 =
																(((BgL_appz00_bglt) COBJECT(
																		((BgL_appz00_bglt) BgL_nodez00_3350)))->
																BgL_argsz00);
															BgL_auxz00_4419 =
																((BgL_varz00_bglt) CAR(BgL_pairz00_3535));
														}
														BgL_arg2025z00_3534 =
															(((BgL_varz00_bglt) COBJECT(BgL_auxz00_4419))->
															BgL_variablez00);
													}
													BgL_arg2023z00_3533 =
														MAKE_YOUNG_PAIR(
														((obj_t) BgL_arg2025z00_3534),
														BGl_za2bnilza2z00zztype_cachez00);
												}
												{	/* Dataflow/walk.scm 417 */
													obj_t BgL_list2024z00_3536;

													BgL_list2024z00_3536 =
														MAKE_YOUNG_PAIR(BgL_arg2023z00_3533, BNIL);
													return BgL_list2024z00_3536;
												}
											}
										else
											{	/* Dataflow/walk.scm 416 */
												return BNIL;
											}
									}
							}
						else
							{	/* Dataflow/walk.scm 410 */
								return BNIL;
							}
					}
				}
			}
		}

	}



/* &dataflow-test-env-le1429 */
	obj_t BGl_z62dataflowzd2testzd2envzd2le1429zb0zzdataflow_walkz00(obj_t
		BgL_envz00_3351, obj_t BgL_nodez00_3352)
	{
		{	/* Dataflow/walk.scm 378 */
			{	/* Dataflow/walk.scm 380 */
				bool_t BgL_test2427z00_4428;

				{	/* Dataflow/walk.scm 380 */
					bool_t BgL_test2428z00_4429;

					{	/* Dataflow/walk.scm 380 */
						obj_t BgL_tmpz00_4430;

						BgL_tmpz00_4430 =
							(((BgL_letzd2varzd2_bglt) COBJECT(
									((BgL_letzd2varzd2_bglt) BgL_nodez00_3352)))->
							BgL_bindingsz00);
						BgL_test2428z00_4429 = PAIRP(BgL_tmpz00_4430);
					}
					if (BgL_test2428z00_4429)
						{	/* Dataflow/walk.scm 380 */
							BgL_test2427z00_4428 =
								NULLP(CDR(
									(((BgL_letzd2varzd2_bglt) COBJECT(
												((BgL_letzd2varzd2_bglt) BgL_nodez00_3352)))->
										BgL_bindingsz00)));
						}
					else
						{	/* Dataflow/walk.scm 380 */
							BgL_test2427z00_4428 = ((bool_t) 0);
						}
				}
				if (BgL_test2427z00_4428)
					{	/* Dataflow/walk.scm 382 */
						bool_t BgL_test2429z00_4438;

						{	/* Dataflow/walk.scm 382 */
							obj_t BgL_arg1990z00_3538;

							{	/* Dataflow/walk.scm 382 */
								obj_t BgL_pairz00_3539;

								BgL_pairz00_3539 =
									(((BgL_letzd2varzd2_bglt) COBJECT(
											((BgL_letzd2varzd2_bglt) BgL_nodez00_3352)))->
									BgL_bindingsz00);
								BgL_arg1990z00_3538 = CDR(CAR(BgL_pairz00_3539));
							}
							BgL_test2429z00_4438 =
								BGl_isazf3zf3zz__objectz00(BgL_arg1990z00_3538,
								BGl_varz00zzast_nodez00);
						}
						if (BgL_test2429z00_4438)
							{	/* Dataflow/walk.scm 383 */
								obj_t BgL_envz00_3540;

								BgL_envz00_3540 =
									BGl_dataflowzd2testzd2envz00zzdataflow_walkz00(
									(((BgL_letzd2varzd2_bglt) COBJECT(
												((BgL_letzd2varzd2_bglt) BgL_nodez00_3352)))->
										BgL_bodyz00));
								{	/* Dataflow/walk.scm 384 */
									bool_t BgL_test2430z00_4447;

									if (NULLP(BgL_envz00_3540))
										{	/* Dataflow/walk.scm 384 */
											BgL_test2430z00_4447 = ((bool_t) 0);
										}
									else
										{	/* Dataflow/walk.scm 384 */
											if (NULLP(CDR(BgL_envz00_3540)))
												{	/* Dataflow/walk.scm 386 */
													obj_t BgL_tmpz00_4453;

													{	/* Dataflow/walk.scm 386 */
														obj_t BgL_pairz00_3541;

														BgL_pairz00_3541 =
															(((BgL_letzd2varzd2_bglt) COBJECT(
																	((BgL_letzd2varzd2_bglt) BgL_nodez00_3352)))->
															BgL_bindingsz00);
														BgL_tmpz00_4453 = CAR(CAR(BgL_pairz00_3541));
													}
													BgL_test2430z00_4447 =
														(CAR(CAR(BgL_envz00_3540)) == BgL_tmpz00_4453);
												}
											else
												{	/* Dataflow/walk.scm 385 */
													BgL_test2430z00_4447 = ((bool_t) 0);
												}
										}
									if (BgL_test2430z00_4447)
										{	/* Dataflow/walk.scm 387 */
											obj_t BgL_arg1946z00_3542;

											{	/* Dataflow/walk.scm 387 */
												BgL_variablez00_bglt BgL_arg1948z00_3543;
												obj_t BgL_arg1949z00_3544;

												{
													BgL_varz00_bglt BgL_auxz00_4461;

													{
														obj_t BgL_auxz00_4462;

														{	/* Dataflow/walk.scm 387 */
															obj_t BgL_pairz00_3545;

															BgL_pairz00_3545 =
																(((BgL_letzd2varzd2_bglt) COBJECT(
																		((BgL_letzd2varzd2_bglt)
																			BgL_nodez00_3352)))->BgL_bindingsz00);
															{	/* Dataflow/walk.scm 387 */
																obj_t BgL_pairz00_3546;

																BgL_pairz00_3546 = CAR(BgL_pairz00_3545);
																BgL_auxz00_4462 = CDR(BgL_pairz00_3546);
															}
														}
														BgL_auxz00_4461 =
															((BgL_varz00_bglt) BgL_auxz00_4462);
													}
													BgL_arg1948z00_3543 =
														(((BgL_varz00_bglt) COBJECT(BgL_auxz00_4461))->
														BgL_variablez00);
												}
												BgL_arg1949z00_3544 = CDR(CAR(BgL_envz00_3540));
												BgL_arg1946z00_3542 =
													MAKE_YOUNG_PAIR(
													((obj_t) BgL_arg1948z00_3543), BgL_arg1949z00_3544);
											}
											{	/* Dataflow/walk.scm 387 */
												obj_t BgL_list1947z00_3547;

												BgL_list1947z00_3547 =
													MAKE_YOUNG_PAIR(BgL_arg1946z00_3542, BNIL);
												return BgL_list1947z00_3547;
											}
										}
									else
										{	/* Dataflow/walk.scm 384 */
											return BNIL;
										}
								}
							}
						else
							{	/* Dataflow/walk.scm 389 */
								bool_t BgL_test2433z00_4474;

								{	/* Dataflow/walk.scm 389 */
									bool_t BgL_test2434z00_4475;

									{	/* Dataflow/walk.scm 389 */
										BgL_nodez00_bglt BgL_arg1989z00_3548;

										BgL_arg1989z00_3548 =
											(((BgL_letzd2varzd2_bglt) COBJECT(
													((BgL_letzd2varzd2_bglt) BgL_nodez00_3352)))->
											BgL_bodyz00);
										{	/* Dataflow/walk.scm 389 */
											bool_t BgL_res2240z00_3549;

											BgL_res2240z00_3549 =
												BGl_isazf3zf3zz__objectz00(
												((obj_t) BgL_arg1989z00_3548), BGl_varz00zzast_nodez00);
											BgL_test2434z00_4475 = BgL_res2240z00_3549;
										}
									}
									if (BgL_test2434z00_4475)
										{	/* Dataflow/walk.scm 390 */
											bool_t BgL_test2435z00_4480;

											{	/* Dataflow/walk.scm 390 */
												obj_t BgL_tmpz00_4481;

												{	/* Dataflow/walk.scm 390 */
													obj_t BgL_pairz00_3550;

													BgL_pairz00_3550 =
														(((BgL_letzd2varzd2_bglt) COBJECT(
																((BgL_letzd2varzd2_bglt) BgL_nodez00_3352)))->
														BgL_bindingsz00);
													BgL_tmpz00_4481 = CAR(CAR(BgL_pairz00_3550));
												}
												BgL_test2435z00_4480 =
													(
													((obj_t)
														(((BgL_varz00_bglt) COBJECT(
																	((BgL_varz00_bglt)
																		(((BgL_letzd2varzd2_bglt) COBJECT(
																					((BgL_letzd2varzd2_bglt)
																						BgL_nodez00_3352)))->
																			BgL_bodyz00))))->BgL_variablez00)) ==
													BgL_tmpz00_4481);
											}
											if (BgL_test2435z00_4480)
												{	/* Dataflow/walk.scm 391 */
													BgL_typez00_bglt BgL_arg1979z00_3551;

													{
														BgL_variablez00_bglt BgL_auxz00_4492;

														{
															obj_t BgL_auxz00_4493;

															{	/* Dataflow/walk.scm 391 */
																obj_t BgL_pairz00_3552;

																BgL_pairz00_3552 =
																	(((BgL_letzd2varzd2_bglt) COBJECT(
																			((BgL_letzd2varzd2_bglt)
																				BgL_nodez00_3352)))->BgL_bindingsz00);
																{	/* Dataflow/walk.scm 391 */
																	obj_t BgL_pairz00_3553;

																	BgL_pairz00_3553 = CAR(BgL_pairz00_3552);
																	BgL_auxz00_4493 = CAR(BgL_pairz00_3553);
																}
															}
															BgL_auxz00_4492 =
																((BgL_variablez00_bglt) BgL_auxz00_4493);
														}
														BgL_arg1979z00_3551 =
															(((BgL_variablez00_bglt)
																COBJECT(BgL_auxz00_4492))->BgL_typez00);
													}
													BgL_test2433z00_4474 =
														(
														((obj_t) BgL_arg1979z00_3551) ==
														BGl_za2boolza2z00zztype_cachez00);
												}
											else
												{	/* Dataflow/walk.scm 390 */
													BgL_test2433z00_4474 = ((bool_t) 0);
												}
										}
									else
										{	/* Dataflow/walk.scm 389 */
											BgL_test2433z00_4474 = ((bool_t) 0);
										}
								}
								if (BgL_test2433z00_4474)
									{	/* Dataflow/walk.scm 392 */
										obj_t BgL_arg1976z00_3554;

										{	/* Dataflow/walk.scm 392 */
											obj_t BgL_pairz00_3555;

											BgL_pairz00_3555 =
												(((BgL_letzd2varzd2_bglt) COBJECT(
														((BgL_letzd2varzd2_bglt) BgL_nodez00_3352)))->
												BgL_bindingsz00);
											BgL_arg1976z00_3554 = CDR(CAR(BgL_pairz00_3555));
										}
										return
											BGl_dataflowzd2testzd2envz00zzdataflow_walkz00(
											((BgL_nodez00_bglt) BgL_arg1976z00_3554));
									}
								else
									{	/* Dataflow/walk.scm 389 */
										return BNIL;
									}
							}
					}
				else
					{	/* Dataflow/walk.scm 380 */
						return BNIL;
					}
			}
		}

	}



/* &dataflow-test-env-va1426 */
	obj_t BGl_z62dataflowzd2testzd2envzd2va1426zb0zzdataflow_walkz00(obj_t
		BgL_envz00_3353, obj_t BgL_nodez00_3354)
	{
		{	/* Dataflow/walk.scm 361 */
			{	/* Dataflow/walk.scm 363 */
				bool_t BgL_test2436z00_4508;

				{	/* Dataflow/walk.scm 363 */
					BgL_variablez00_bglt BgL_arg1928z00_3557;

					BgL_arg1928z00_3557 =
						(((BgL_varz00_bglt) COBJECT(
								((BgL_varz00_bglt) BgL_nodez00_3354)))->BgL_variablez00);
					{	/* Dataflow/walk.scm 363 */
						bool_t BgL_res2233z00_3558;

						BgL_res2233z00_3558 =
							BGl_isazf3zf3zz__objectz00(
							((obj_t) BgL_arg1928z00_3557),
							BGl_localzf2valuezf2zzdataflow_walkz00);
						BgL_test2436z00_4508 = BgL_res2233z00_3558;
					}
				}
				if (BgL_test2436z00_4508)
					{	/* Dataflow/walk.scm 364 */
						BgL_nodez00_bglt BgL_arg1925z00_3559;

						{	/* Dataflow/walk.scm 364 */
							BgL_localz00_bglt BgL_oz00_3560;

							BgL_oz00_3560 =
								((BgL_localz00_bglt)
								(((BgL_varz00_bglt) COBJECT(
											((BgL_varz00_bglt) BgL_nodez00_3354)))->BgL_variablez00));
							{
								BgL_localzf2valuezf2_bglt BgL_auxz00_4516;

								{
									obj_t BgL_auxz00_4517;

									{	/* Dataflow/walk.scm 364 */
										BgL_objectz00_bglt BgL_tmpz00_4518;

										BgL_tmpz00_4518 = ((BgL_objectz00_bglt) BgL_oz00_3560);
										BgL_auxz00_4517 = BGL_OBJECT_WIDENING(BgL_tmpz00_4518);
									}
									BgL_auxz00_4516 =
										((BgL_localzf2valuezf2_bglt) BgL_auxz00_4517);
								}
								BgL_arg1925z00_3559 =
									(((BgL_localzf2valuezf2_bglt) COBJECT(BgL_auxz00_4516))->
									BgL_nodez00);
							}
						}
						return
							BGl_dataflowzd2testzd2envz00zzdataflow_walkz00
							(BgL_arg1925z00_3559);
					}
				else
					{	/* Dataflow/walk.scm 363 */
						return BNIL;
					}
			}
		}

	}



/* &dataflow-test-env-co1424 */
	obj_t BGl_z62dataflowzd2testzd2envzd2co1424zb0zzdataflow_walkz00(obj_t
		BgL_envz00_3355, obj_t BgL_nodez00_3356)
	{
		{	/* Dataflow/walk.scm 352 */
			{	/* Dataflow/walk.scm 354 */
				bool_t BgL_test2437z00_4524;

				{	/* Dataflow/walk.scm 354 */
					bool_t BgL_test2438z00_4525;

					{	/* Dataflow/walk.scm 354 */
						BgL_nodez00_bglt BgL_arg1922z00_3562;

						BgL_arg1922z00_3562 =
							(((BgL_conditionalz00_bglt) COBJECT(
									((BgL_conditionalz00_bglt) BgL_nodez00_3356)))->BgL_falsez00);
						{	/* Dataflow/walk.scm 354 */
							bool_t BgL_res2232z00_3563;

							BgL_res2232z00_3563 =
								BGl_isazf3zf3zz__objectz00(
								((obj_t) BgL_arg1922z00_3562), BGl_atomz00zzast_nodez00);
							BgL_test2438z00_4525 = BgL_res2232z00_3563;
						}
					}
					if (BgL_test2438z00_4525)
						{	/* Dataflow/walk.scm 354 */
							BgL_test2437z00_4524 =
								(
								(((BgL_atomz00_bglt) COBJECT(
											((BgL_atomz00_bglt)
												(((BgL_conditionalz00_bglt) COBJECT(
															((BgL_conditionalz00_bglt) BgL_nodez00_3356)))->
													BgL_falsez00))))->BgL_valuez00) == BFALSE);
						}
					else
						{	/* Dataflow/walk.scm 354 */
							BgL_test2437z00_4524 = ((bool_t) 0);
						}
				}
				if (BgL_test2437z00_4524)
					{	/* Dataflow/walk.scm 354 */
						return
							BGl_appendzd221011zd2zzdataflow_walkz00
							(BGl_dataflowzd2testzd2envz00zzdataflow_walkz00(((
										(BgL_conditionalz00_bglt) COBJECT(((BgL_conditionalz00_bglt)
												BgL_nodez00_3356)))->BgL_testz00)),
							BGl_dataflowzd2testzd2envz00zzdataflow_walkz00(((
										(BgL_conditionalz00_bglt) COBJECT(((BgL_conditionalz00_bglt)
												BgL_nodez00_3356)))->BgL_truez00)));
					}
				else
					{	/* Dataflow/walk.scm 354 */
						return BNIL;
					}
			}
		}

	}



/* &dataflow-test-env-in1422 */
	obj_t BGl_z62dataflowzd2testzd2envzd2in1422zb0zzdataflow_walkz00(obj_t
		BgL_envz00_3357, obj_t BgL_nodez00_3358)
	{
		{	/* Dataflow/walk.scm 343 */
			{	/* Dataflow/walk.scm 345 */
				bool_t BgL_test2439z00_4542;

				{	/* Dataflow/walk.scm 345 */
					obj_t BgL_arg1908z00_3565;

					{	/* Dataflow/walk.scm 345 */
						obj_t BgL_pairz00_3566;

						BgL_pairz00_3566 =
							(((BgL_externz00_bglt) COBJECT(
									((BgL_externz00_bglt)
										((BgL_instanceofz00_bglt) BgL_nodez00_3358))))->
							BgL_exprza2za2);
						BgL_arg1908z00_3565 = CAR(BgL_pairz00_3566);
					}
					BgL_test2439z00_4542 =
						BGl_isazf3zf3zz__objectz00(BgL_arg1908z00_3565,
						BGl_varz00zzast_nodez00);
				}
				if (BgL_test2439z00_4542)
					{	/* Dataflow/walk.scm 346 */
						obj_t BgL_arg1902z00_3567;

						{	/* Dataflow/walk.scm 346 */
							BgL_variablez00_bglt BgL_arg1904z00_3568;
							BgL_typez00_bglt BgL_arg1905z00_3569;

							{
								BgL_varz00_bglt BgL_auxz00_4548;

								{	/* Dataflow/walk.scm 346 */
									obj_t BgL_pairz00_3570;

									BgL_pairz00_3570 =
										(((BgL_externz00_bglt) COBJECT(
												((BgL_externz00_bglt)
													((BgL_instanceofz00_bglt) BgL_nodez00_3358))))->
										BgL_exprza2za2);
									BgL_auxz00_4548 = ((BgL_varz00_bglt) CAR(BgL_pairz00_3570));
								}
								BgL_arg1904z00_3568 =
									(((BgL_varz00_bglt) COBJECT(BgL_auxz00_4548))->
									BgL_variablez00);
							}
							BgL_arg1905z00_3569 =
								(((BgL_instanceofz00_bglt) COBJECT(
										((BgL_instanceofz00_bglt) BgL_nodez00_3358)))->
								BgL_classz00);
							BgL_arg1902z00_3567 =
								MAKE_YOUNG_PAIR(((obj_t) BgL_arg1904z00_3568),
								((obj_t) BgL_arg1905z00_3569));
						}
						{	/* Dataflow/walk.scm 346 */
							obj_t BgL_list1903z00_3571;

							BgL_list1903z00_3571 = MAKE_YOUNG_PAIR(BgL_arg1902z00_3567, BNIL);
							return BgL_list1903z00_3571;
						}
					}
				else
					{	/* Dataflow/walk.scm 345 */
						return BNIL;
					}
			}
		}

	}



/* &dataflow-test-env-ap1420 */
	obj_t BGl_z62dataflowzd2testzd2envzd2ap1420zb0zzdataflow_walkz00(obj_t
		BgL_envz00_3359, obj_t BgL_nodez00_3360)
	{
		{	/* Dataflow/walk.scm 320 */
			{	/* Dataflow/walk.scm 322 */
				BgL_variablez00_bglt BgL_fz00_3573;

				BgL_fz00_3573 =
					(((BgL_varz00_bglt) COBJECT(
							(((BgL_appz00_bglt) COBJECT(
										((BgL_appz00_bglt) BgL_nodez00_3360)))->BgL_funz00)))->
					BgL_variablez00);
				{	/* Dataflow/walk.scm 322 */
					BgL_valuez00_bglt BgL_funvz00_3574;

					BgL_funvz00_3574 =
						(((BgL_variablez00_bglt) COBJECT(BgL_fz00_3573))->BgL_valuez00);
					{	/* Dataflow/walk.scm 323 */

						{	/* Dataflow/walk.scm 325 */
							obj_t BgL_g1174z00_3575;

							BgL_g1174z00_3575 =
								BGl_isazd2ofzd2zztype_miscz00(
								((BgL_nodez00_bglt) ((BgL_appz00_bglt) BgL_nodez00_3360)));
							if (CBOOL(BgL_g1174z00_3575))
								{	/* Dataflow/walk.scm 328 */
									bool_t BgL_test2441z00_4570;

									{	/* Dataflow/walk.scm 328 */
										obj_t BgL_arg1858z00_3576;

										BgL_arg1858z00_3576 =
											CAR(
											(((BgL_appz00_bglt) COBJECT(
														((BgL_appz00_bglt) BgL_nodez00_3360)))->
												BgL_argsz00));
										BgL_test2441z00_4570 =
											BGl_isazf3zf3zz__objectz00(BgL_arg1858z00_3576,
											BGl_varz00zzast_nodez00);
									}
									if (BgL_test2441z00_4570)
										{	/* Dataflow/walk.scm 329 */
											obj_t BgL_arg1853z00_3577;

											{	/* Dataflow/walk.scm 329 */
												BgL_variablez00_bglt BgL_arg1855z00_3578;

												{
													BgL_varz00_bglt BgL_auxz00_4575;

													{	/* Dataflow/walk.scm 329 */
														obj_t BgL_pairz00_3579;

														BgL_pairz00_3579 =
															(((BgL_appz00_bglt) COBJECT(
																	((BgL_appz00_bglt) BgL_nodez00_3360)))->
															BgL_argsz00);
														BgL_auxz00_4575 =
															((BgL_varz00_bglt) CAR(BgL_pairz00_3579));
													}
													BgL_arg1855z00_3578 =
														(((BgL_varz00_bglt) COBJECT(BgL_auxz00_4575))->
														BgL_variablez00);
												}
												BgL_arg1853z00_3577 =
													MAKE_YOUNG_PAIR(
													((obj_t) BgL_arg1855z00_3578), BgL_g1174z00_3575);
											}
											{	/* Dataflow/walk.scm 329 */
												obj_t BgL_list1854z00_3580;

												BgL_list1854z00_3580 =
													MAKE_YOUNG_PAIR(BgL_arg1853z00_3577, BNIL);
												return BgL_list1854z00_3580;
											}
										}
									else
										{	/* Dataflow/walk.scm 328 */
											return BNIL;
										}
								}
							else
								{	/* Dataflow/walk.scm 331 */
									bool_t BgL_test2442z00_4584;

									{	/* Dataflow/walk.scm 331 */
										bool_t BgL_test2443z00_4585;

										{	/* Dataflow/walk.scm 331 */
											bool_t BgL_res2225z00_3581;

											BgL_res2225z00_3581 =
												BGl_isazf3zf3zz__objectz00(
												((obj_t) BgL_funvz00_3574), BGl_funz00zzast_varz00);
											BgL_test2443z00_4585 = BgL_res2225z00_3581;
										}
										if (BgL_test2443z00_4585)
											{	/* Dataflow/walk.scm 331 */
												if (CBOOL(
														(((BgL_funz00_bglt) COBJECT(
																	((BgL_funz00_bglt) BgL_funvz00_3574)))->
															BgL_predicatezd2ofzd2)))
													{	/* Dataflow/walk.scm 333 */
														bool_t BgL_test2445z00_4592;

														{	/* Dataflow/walk.scm 333 */
															obj_t BgL_tmpz00_4593;

															BgL_tmpz00_4593 =
																(((BgL_appz00_bglt) COBJECT(
																		((BgL_appz00_bglt) BgL_nodez00_3360)))->
																BgL_argsz00);
															BgL_test2445z00_4592 = PAIRP(BgL_tmpz00_4593);
														}
														if (BgL_test2445z00_4592)
															{	/* Dataflow/walk.scm 333 */
																if (NULLP(CDR(
																			(((BgL_appz00_bglt) COBJECT(
																						((BgL_appz00_bglt)
																							BgL_nodez00_3360)))->
																				BgL_argsz00))))
																	{	/* Dataflow/walk.scm 334 */
																		bool_t BgL_test2447z00_4602;

																		{	/* Dataflow/walk.scm 334 */
																			obj_t BgL_arg1892z00_3582;

																			BgL_arg1892z00_3582 =
																				CAR(
																				(((BgL_appz00_bglt) COBJECT(
																							((BgL_appz00_bglt)
																								BgL_nodez00_3360)))->
																					BgL_argsz00));
																			BgL_test2447z00_4602 =
																				BGl_isazf3zf3zz__objectz00
																				(BgL_arg1892z00_3582,
																				BGl_varz00zzast_nodez00);
																		}
																		if (BgL_test2447z00_4602)
																			{	/* Dataflow/walk.scm 335 */
																				BgL_typez00_bglt BgL_arg1888z00_3583;

																				{
																					BgL_variablez00_bglt BgL_auxz00_4607;

																					{
																						BgL_varz00_bglt BgL_auxz00_4608;

																						{	/* Dataflow/walk.scm 335 */
																							obj_t BgL_pairz00_3584;

																							BgL_pairz00_3584 =
																								(((BgL_appz00_bglt) COBJECT(
																										((BgL_appz00_bglt)
																											BgL_nodez00_3360)))->
																								BgL_argsz00);
																							BgL_auxz00_4608 =
																								((BgL_varz00_bglt)
																								CAR(BgL_pairz00_3584));
																						}
																						BgL_auxz00_4607 =
																							(((BgL_varz00_bglt)
																								COBJECT(BgL_auxz00_4608))->
																							BgL_variablez00);
																					}
																					BgL_arg1888z00_3583 =
																						(((BgL_variablez00_bglt)
																							COBJECT(BgL_auxz00_4607))->
																						BgL_typez00);
																				}
																				BgL_test2442z00_4584 =
																					BGl_bigloozd2typezf3z21zztype_typez00
																					(BgL_arg1888z00_3583);
																			}
																		else
																			{	/* Dataflow/walk.scm 334 */
																				BgL_test2442z00_4584 = ((bool_t) 0);
																			}
																	}
																else
																	{	/* Dataflow/walk.scm 333 */
																		BgL_test2442z00_4584 = ((bool_t) 0);
																	}
															}
														else
															{	/* Dataflow/walk.scm 333 */
																BgL_test2442z00_4584 = ((bool_t) 0);
															}
													}
												else
													{	/* Dataflow/walk.scm 332 */
														BgL_test2442z00_4584 = ((bool_t) 0);
													}
											}
										else
											{	/* Dataflow/walk.scm 331 */
												BgL_test2442z00_4584 = ((bool_t) 0);
											}
									}
									if (BgL_test2442z00_4584)
										{	/* Dataflow/walk.scm 336 */
											obj_t BgL_arg1882z00_3585;

											{	/* Dataflow/walk.scm 336 */
												BgL_variablez00_bglt BgL_arg1884z00_3586;
												obj_t BgL_arg1885z00_3587;

												{
													BgL_varz00_bglt BgL_auxz00_4616;

													{	/* Dataflow/walk.scm 336 */
														obj_t BgL_pairz00_3588;

														BgL_pairz00_3588 =
															(((BgL_appz00_bglt) COBJECT(
																	((BgL_appz00_bglt) BgL_nodez00_3360)))->
															BgL_argsz00);
														BgL_auxz00_4616 =
															((BgL_varz00_bglt) CAR(BgL_pairz00_3588));
													}
													BgL_arg1884z00_3586 =
														(((BgL_varz00_bglt) COBJECT(BgL_auxz00_4616))->
														BgL_variablez00);
												}
												BgL_arg1885z00_3587 =
													(((BgL_funz00_bglt) COBJECT(
															((BgL_funz00_bglt) BgL_funvz00_3574)))->
													BgL_predicatezd2ofzd2);
												BgL_arg1882z00_3585 =
													MAKE_YOUNG_PAIR(((obj_t) BgL_arg1884z00_3586),
													BgL_arg1885z00_3587);
											}
											{	/* Dataflow/walk.scm 336 */
												obj_t BgL_list1883z00_3589;

												BgL_list1883z00_3589 =
													MAKE_YOUNG_PAIR(BgL_arg1882z00_3585, BNIL);
												return BgL_list1883z00_3589;
											}
										}
									else
										{	/* Dataflow/walk.scm 331 */
											return BNIL;
										}
								}
						}
					}
				}
			}
		}

	}



/* &dataflow-node!-box-s1416 */
	obj_t BGl_z62dataflowzd2nodez12zd2boxzd2s1416za2zzdataflow_walkz00(obj_t
		BgL_envz00_3361, obj_t BgL_nodez00_3362, obj_t BgL_envz00_3363)
	{
		{	/* Dataflow/walk.scm 300 */
			return
				BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
				(((BgL_boxzd2setz12zc0_bglt) COBJECT(
							((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_3362)))->BgL_valuez00),
				BgL_envz00_3363);
		}

	}



/* &dataflow-node!-box-r1414 */
	obj_t BGl_z62dataflowzd2nodez12zd2boxzd2r1414za2zzdataflow_walkz00(obj_t
		BgL_envz00_3364, obj_t BgL_nodez00_3365, obj_t BgL_envz00_3366)
	{
		{	/* Dataflow/walk.scm 293 */
			return ((obj_t) BgL_envz00_3366);
		}

	}



/* &dataflow-node!-make-1412 */
	obj_t BGl_z62dataflowzd2nodez12zd2makezd21412za2zzdataflow_walkz00(obj_t
		BgL_envz00_3367, obj_t BgL_nodez00_3368, obj_t BgL_envz00_3369)
	{
		{	/* Dataflow/walk.scm 287 */
			return
				BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
				(((BgL_makezd2boxzd2_bglt) COBJECT(
							((BgL_makezd2boxzd2_bglt) BgL_nodez00_3368)))->BgL_valuez00),
				BgL_envz00_3369);
		}

	}



/* &dataflow-node!-jump-1410 */
	obj_t BGl_z62dataflowzd2nodez12zd2jumpzd21410za2zzdataflow_walkz00(obj_t
		BgL_envz00_3370, obj_t BgL_nodez00_3371, obj_t BgL_envz00_3372)
	{
		{	/* Dataflow/walk.scm 278 */
			BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
				(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
							((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_3371)))->BgL_exitz00),
				BgL_envz00_3372);
			BGl_dataflowzd2nodez12zc0zzdataflow_walkz00((((BgL_jumpzd2exzd2itz00_bglt)
						COBJECT(((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_3371)))->
					BgL_valuez00), BgL_envz00_3372);
			return BNIL;
		}

	}



/* &dataflow-node!-set-e1408 */
	obj_t BGl_z62dataflowzd2nodez12zd2setzd2e1408za2zzdataflow_walkz00(obj_t
		BgL_envz00_3373, obj_t BgL_nodez00_3374, obj_t BgL_envz00_3375)
	{
		{	/* Dataflow/walk.scm 270 */
			BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
				(((BgL_setzd2exzd2itz00_bglt) COBJECT(
							((BgL_setzd2exzd2itz00_bglt) BgL_nodez00_3374)))->BgL_bodyz00),
				BgL_envz00_3375);
			return BNIL;
		}

	}



/* &dataflow-node!-let-v1406 */
	obj_t BGl_z62dataflowzd2nodez12zd2letzd2v1406za2zzdataflow_walkz00(obj_t
		BgL_envz00_3376, obj_t BgL_nodez00_3377, obj_t BgL_envz00_3378)
	{
		{	/* Dataflow/walk.scm 238 */
			BGl_letzd2varzd2stampz00zzdataflow_walkz00 =
				(((long) 1) + BGl_letzd2varzd2stampz00zzdataflow_walkz00);
			{	/* Dataflow/walk.scm 241 */
				long BgL_stampz00_3597;

				BgL_stampz00_3597 = BGl_letzd2varzd2stampz00zzdataflow_walkz00;
				{	/* Dataflow/walk.scm 241 */
					obj_t BgL_envz00_3598;

					{
						obj_t BgL_bindingsz00_3600;
						obj_t BgL_envz00_3601;

						BgL_bindingsz00_3600 =
							(((BgL_letzd2varzd2_bglt) COBJECT(
									((BgL_letzd2varzd2_bglt) BgL_nodez00_3377)))->
							BgL_bindingsz00);
						BgL_envz00_3601 = BgL_envz00_3378;
					BgL_loopz00_3599:
						if (NULLP(BgL_bindingsz00_3600))
							{	/* Dataflow/walk.scm 244 */
								BgL_envz00_3598 = BgL_envz00_3601;
							}
						else
							{	/* Dataflow/walk.scm 246 */
								obj_t BgL_nodez00_3602;

								{	/* Dataflow/walk.scm 246 */
									obj_t BgL_pairz00_3603;

									BgL_pairz00_3603 = CAR(((obj_t) BgL_bindingsz00_3600));
									BgL_nodez00_3602 = CDR(BgL_pairz00_3603);
								}
								{	/* Dataflow/walk.scm 246 */
									obj_t BgL_envz00_3604;

									BgL_envz00_3604 =
										BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
										((BgL_nodez00_bglt) BgL_nodez00_3602), BgL_envz00_3601);
									{	/* Dataflow/walk.scm 247 */

										{	/* Dataflow/walk.scm 248 */
											obj_t BgL_lz00_3605;

											{	/* Dataflow/walk.scm 248 */
												obj_t BgL_pairz00_3606;

												BgL_pairz00_3606 = CAR(((obj_t) BgL_bindingsz00_3600));
												BgL_lz00_3605 = CAR(BgL_pairz00_3606);
											}
											if (
												((((BgL_variablez00_bglt) COBJECT(
																((BgL_variablez00_bglt) BgL_lz00_3605)))->
														BgL_accessz00) == CNST_TABLE_REF(((long) 11))))
												{	/* Dataflow/walk.scm 249 */
													{	/* Dataflow/walk.scm 250 */
														BgL_localzf2valuezf2_bglt BgL_wide1167z00_3607;

														BgL_wide1167z00_3607 =
															((BgL_localzf2valuezf2_bglt)
															BOBJECT(GC_MALLOC(sizeof(struct
																		BgL_localzf2valuezf2_bgl))));
														{	/* Dataflow/walk.scm 250 */
															obj_t BgL_auxz00_4664;
															BgL_objectz00_bglt BgL_tmpz00_4660;

															BgL_auxz00_4664 = ((obj_t) BgL_wide1167z00_3607);
															BgL_tmpz00_4660 =
																((BgL_objectz00_bglt)
																((BgL_localz00_bglt)
																	((BgL_localz00_bglt) BgL_lz00_3605)));
															BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4660,
																BgL_auxz00_4664);
														}
														((BgL_objectz00_bglt)
															((BgL_localz00_bglt)
																((BgL_localz00_bglt) BgL_lz00_3605)));
														{	/* Dataflow/walk.scm 250 */
															long BgL_arg1837z00_3608;

															{	/* Dataflow/walk.scm 250 */
																long BgL_res2219z00_3609;

																BgL_res2219z00_3609 =
																	BGL_CLASS_INDEX
																	(BGl_localzf2valuezf2zzdataflow_walkz00);
																BgL_arg1837z00_3608 = BgL_res2219z00_3609;
															}
															BGL_OBJECT_CLASS_NUM_SET(
																((BgL_objectz00_bglt)
																	((BgL_localz00_bglt)
																		((BgL_localz00_bglt) BgL_lz00_3605))),
																BgL_arg1837z00_3608);
														}
														((BgL_localz00_bglt)
															((BgL_localz00_bglt)
																((BgL_localz00_bglt) BgL_lz00_3605)));
													}
													{
														BgL_localzf2valuezf2_bglt BgL_auxz00_4678;

														{
															obj_t BgL_auxz00_4679;

															{	/* Dataflow/walk.scm 251 */
																BgL_objectz00_bglt BgL_tmpz00_4680;

																BgL_tmpz00_4680 =
																	((BgL_objectz00_bglt)
																	((BgL_localz00_bglt)
																		((BgL_localz00_bglt) BgL_lz00_3605)));
																BgL_auxz00_4679 =
																	BGL_OBJECT_WIDENING(BgL_tmpz00_4680);
															}
															BgL_auxz00_4678 =
																((BgL_localzf2valuezf2_bglt) BgL_auxz00_4679);
														}
														((((BgL_localzf2valuezf2_bglt)
																	COBJECT(BgL_auxz00_4678))->BgL_stampz00) =
															((int) (int) (BgL_stampz00_3597)), BUNSPEC);
													}
													{
														BgL_localzf2valuezf2_bglt BgL_auxz00_4688;

														{
															obj_t BgL_auxz00_4689;

															{	/* Dataflow/walk.scm 252 */
																BgL_objectz00_bglt BgL_tmpz00_4690;

																BgL_tmpz00_4690 =
																	((BgL_objectz00_bglt)
																	((BgL_localz00_bglt)
																		((BgL_localz00_bglt) BgL_lz00_3605)));
																BgL_auxz00_4689 =
																	BGL_OBJECT_WIDENING(BgL_tmpz00_4690);
															}
															BgL_auxz00_4688 =
																((BgL_localzf2valuezf2_bglt) BgL_auxz00_4689);
														}
														((((BgL_localzf2valuezf2_bglt)
																	COBJECT(BgL_auxz00_4688))->BgL_nodez00) =
															((BgL_nodez00_bglt) ((BgL_nodez00_bglt)
																	BgL_nodez00_3602)), BUNSPEC);
													}
													((obj_t)
														((BgL_localz00_bglt)
															((BgL_localz00_bglt) BgL_lz00_3605)));
												}
											else
												{	/* Dataflow/walk.scm 249 */
													BFALSE;
												}
										}
										{	/* Dataflow/walk.scm 253 */
											obj_t BgL_arg1839z00_3610;

											BgL_arg1839z00_3610 = CDR(((obj_t) BgL_bindingsz00_3600));
											{
												obj_t BgL_envz00_4704;
												obj_t BgL_bindingsz00_4703;

												BgL_bindingsz00_4703 = BgL_arg1839z00_3610;
												BgL_envz00_4704 = BgL_envz00_3604;
												BgL_envz00_3601 = BgL_envz00_4704;
												BgL_bindingsz00_3600 = BgL_bindingsz00_4703;
												goto BgL_loopz00_3599;
											}
										}
									}
								}
							}
					}
					{	/* Dataflow/walk.scm 242 */

						{	/* Dataflow/walk.scm 254 */
							obj_t BgL_arg1804z00_3611;

							BgL_arg1804z00_3611 =
								BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
								(((BgL_letzd2varzd2_bglt) COBJECT(
											((BgL_letzd2varzd2_bglt) BgL_nodez00_3377)))->
									BgL_bodyz00), BgL_envz00_3598);
							{	/* Dataflow/walk.scm 256 */
								obj_t BgL_zc3z04anonymousza31806ze3z87_3612;

								BgL_zc3z04anonymousza31806ze3z87_3612 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza31806ze3ze5zzdataflow_walkz00,
									(int) (((long) 1)), (int) (((long) 1)));
								PROCEDURE_SET(BgL_zc3z04anonymousza31806ze3z87_3612,
									(int) (((long) 0)), BINT(BgL_stampz00_3597));
								{	/* Dataflow/walk.scm 254 */
									obj_t BgL_list1805z00_3613;

									BgL_list1805z00_3613 =
										MAKE_YOUNG_PAIR(BgL_arg1804z00_3611, BNIL);
									return
										BGl_filterzd2mapzd2zz__r4_control_features_6_9z00
										(BgL_zc3z04anonymousza31806ze3z87_3612,
										BgL_list1805z00_3613);
								}
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:1806> */
	obj_t BGl_z62zc3z04anonymousza31806ze3ze5zzdataflow_walkz00(obj_t
		BgL_envz00_3379, obj_t BgL_bz00_3381)
	{
		{	/* Dataflow/walk.scm 254 */
			{	/* Dataflow/walk.scm 256 */
				long BgL_stampz00_3380;

				BgL_stampz00_3380 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_3379, (int) (((long) 0))));
				{	/* Dataflow/walk.scm 256 */
					bool_t BgL_test2450z00_4721;

					{	/* Dataflow/walk.scm 256 */
						bool_t BgL_test2451z00_4722;

						{	/* Dataflow/walk.scm 256 */
							obj_t BgL_arg1829z00_3614;

							BgL_arg1829z00_3614 = CAR(((obj_t) BgL_bz00_3381));
							BgL_test2451z00_4722 =
								BGl_isazf3zf3zz__objectz00(BgL_arg1829z00_3614,
								BGl_localzf2valuezf2zzdataflow_walkz00);
						}
						if (BgL_test2451z00_4722)
							{	/* Dataflow/walk.scm 257 */
								int BgL_arg1826z00_3615;

								{	/* Dataflow/walk.scm 257 */
									BgL_localz00_bglt BgL_oz00_3616;

									BgL_oz00_3616 =
										((BgL_localz00_bglt) CAR(((obj_t) BgL_bz00_3381)));
									{
										BgL_localzf2valuezf2_bglt BgL_auxz00_4729;

										{
											obj_t BgL_auxz00_4730;

											{	/* Dataflow/walk.scm 257 */
												BgL_objectz00_bglt BgL_tmpz00_4731;

												BgL_tmpz00_4731 = ((BgL_objectz00_bglt) BgL_oz00_3616);
												BgL_auxz00_4730 = BGL_OBJECT_WIDENING(BgL_tmpz00_4731);
											}
											BgL_auxz00_4729 =
												((BgL_localzf2valuezf2_bglt) BgL_auxz00_4730);
										}
										BgL_arg1826z00_3615 =
											(((BgL_localzf2valuezf2_bglt) COBJECT(BgL_auxz00_4729))->
											BgL_stampz00);
								}}
								BgL_test2450z00_4721 =
									((long) (BgL_arg1826z00_3615) < BgL_stampz00_3380);
							}
						else
							{	/* Dataflow/walk.scm 256 */
								BgL_test2450z00_4721 = ((bool_t) 1);
							}
					}
					if (BgL_test2450z00_4721)
						{	/* Dataflow/walk.scm 256 */
							return BgL_bz00_3381;
						}
					else
						{	/* Dataflow/walk.scm 259 */
							bool_t BgL_test2452z00_4738;

							{	/* Dataflow/walk.scm 259 */
								BgL_nodez00_bglt BgL_arg1824z00_3617;

								{	/* Dataflow/walk.scm 259 */
									BgL_localz00_bglt BgL_oz00_3618;

									BgL_oz00_3618 =
										((BgL_localz00_bglt) CAR(((obj_t) BgL_bz00_3381)));
									{
										BgL_localzf2valuezf2_bglt BgL_auxz00_4742;

										{
											obj_t BgL_auxz00_4743;

											{	/* Dataflow/walk.scm 259 */
												BgL_objectz00_bglt BgL_tmpz00_4744;

												BgL_tmpz00_4744 = ((BgL_objectz00_bglt) BgL_oz00_3618);
												BgL_auxz00_4743 = BGL_OBJECT_WIDENING(BgL_tmpz00_4744);
											}
											BgL_auxz00_4742 =
												((BgL_localzf2valuezf2_bglt) BgL_auxz00_4743);
										}
										BgL_arg1824z00_3617 =
											(((BgL_localzf2valuezf2_bglt) COBJECT(BgL_auxz00_4742))->
											BgL_nodez00);
									}
								}
								{	/* Dataflow/walk.scm 259 */
									bool_t BgL_res2222z00_3619;

									BgL_res2222z00_3619 =
										BGl_isazf3zf3zz__objectz00(
										((obj_t) BgL_arg1824z00_3617), BGl_varz00zzast_nodez00);
									BgL_test2452z00_4738 = BgL_res2222z00_3619;
								}
							}
							if (BgL_test2452z00_4738)
								{	/* Dataflow/walk.scm 260 */
									BgL_variablez00_bglt BgL_vz00_3620;

									{	/* Dataflow/walk.scm 260 */
										BgL_nodez00_bglt BgL_arg1822z00_3621;

										{	/* Dataflow/walk.scm 260 */
											BgL_localz00_bglt BgL_oz00_3622;

											BgL_oz00_3622 =
												((BgL_localz00_bglt) CAR(((obj_t) BgL_bz00_3381)));
											{
												BgL_localzf2valuezf2_bglt BgL_auxz00_4754;

												{
													obj_t BgL_auxz00_4755;

													{	/* Dataflow/walk.scm 260 */
														BgL_objectz00_bglt BgL_tmpz00_4756;

														BgL_tmpz00_4756 =
															((BgL_objectz00_bglt) BgL_oz00_3622);
														BgL_auxz00_4755 =
															BGL_OBJECT_WIDENING(BgL_tmpz00_4756);
													}
													BgL_auxz00_4754 =
														((BgL_localzf2valuezf2_bglt) BgL_auxz00_4755);
												}
												BgL_arg1822z00_3621 =
													(((BgL_localzf2valuezf2_bglt)
														COBJECT(BgL_auxz00_4754))->BgL_nodez00);
											}
										}
										BgL_vz00_3620 =
											(((BgL_varz00_bglt) COBJECT(
													((BgL_varz00_bglt) BgL_arg1822z00_3621)))->
											BgL_variablez00);
									}
									if (
										((((BgL_variablez00_bglt) COBJECT(BgL_vz00_3620))->
												BgL_accessz00) == CNST_TABLE_REF(((long) 11))))
										{	/* Dataflow/walk.scm 262 */
											obj_t BgL_arg1819z00_3623;

											BgL_arg1819z00_3623 = CDR(((obj_t) BgL_bz00_3381));
											return
												MAKE_YOUNG_PAIR(
												((obj_t) BgL_vz00_3620), BgL_arg1819z00_3623);
										}
									else
										{	/* Dataflow/walk.scm 261 */
											return BFALSE;
										}
								}
							else
								{	/* Dataflow/walk.scm 259 */
									return BFALSE;
								}
						}
				}
			}
		}

	}



/* &dataflow-node!-let-f1404 */
	obj_t BGl_z62dataflowzd2nodez12zd2letzd2f1404za2zzdataflow_walkz00(obj_t
		BgL_envz00_3382, obj_t BgL_nodez00_3383, obj_t BgL_envz00_3384)
	{
		{	/* Dataflow/walk.scm 223 */
			{	/* Dataflow/walk.scm 225 */
				obj_t BgL_g1352z00_3625;

				BgL_g1352z00_3625 =
					(((BgL_letzd2funzd2_bglt) COBJECT(
							((BgL_letzd2funzd2_bglt) BgL_nodez00_3383)))->BgL_localsz00);
				{
					obj_t BgL_l1350z00_3627;

					BgL_l1350z00_3627 = BgL_g1352z00_3625;
				BgL_zc3z04anonymousza31796ze3z87_3626:
					if (PAIRP(BgL_l1350z00_3627))
						{	/* Dataflow/walk.scm 225 */
							{	/* Dataflow/walk.scm 226 */
								obj_t BgL_localz00_3628;

								BgL_localz00_3628 = CAR(BgL_l1350z00_3627);
								{	/* Dataflow/walk.scm 226 */
									obj_t BgL_arg1798z00_3629;

									BgL_arg1798z00_3629 =
										(((BgL_sfunz00_bglt) COBJECT(
												((BgL_sfunz00_bglt)
													(((BgL_variablez00_bglt) COBJECT(
																((BgL_variablez00_bglt)
																	((BgL_localz00_bglt) BgL_localz00_3628))))->
														BgL_valuez00))))->BgL_bodyz00);
									BGl_dataflowzd2nodez12zc0zzdataflow_walkz00((
											(BgL_nodez00_bglt) BgL_arg1798z00_3629), BNIL);
								}
							}
							{
								obj_t BgL_l1350z00_4783;

								BgL_l1350z00_4783 = CDR(BgL_l1350z00_3627);
								BgL_l1350z00_3627 = BgL_l1350z00_4783;
								goto BgL_zc3z04anonymousza31796ze3z87_3626;
							}
						}
					else
						{	/* Dataflow/walk.scm 225 */
							((bool_t) 1);
						}
				}
			}
			return
				BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
				(((BgL_letzd2funzd2_bglt) COBJECT(
							((BgL_letzd2funzd2_bglt) BgL_nodez00_3383)))->BgL_bodyz00),
				BgL_envz00_3384);
		}

	}



/* &dataflow-node!-switc1400 */
	obj_t BGl_z62dataflowzd2nodez12zd2switc1400z70zzdataflow_walkz00(obj_t
		BgL_envz00_3385, obj_t BgL_nodez00_3386, obj_t BgL_envz00_3387)
	{
		{	/* Dataflow/walk.scm 212 */
			BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
				(((BgL_switchz00_bglt) COBJECT(
							((BgL_switchz00_bglt) BgL_nodez00_3386)))->BgL_testz00),
				BgL_envz00_3387);
			{	/* Dataflow/walk.scm 215 */
				obj_t BgL_g1349z00_3631;

				BgL_g1349z00_3631 =
					(((BgL_switchz00_bglt) COBJECT(
							((BgL_switchz00_bglt) BgL_nodez00_3386)))->BgL_clausesz00);
				{
					obj_t BgL_l1347z00_3633;

					BgL_l1347z00_3633 = BgL_g1349z00_3631;
				BgL_zc3z04anonymousza31790ze3z87_3632:
					if (PAIRP(BgL_l1347z00_3633))
						{	/* Dataflow/walk.scm 215 */
							{	/* Dataflow/walk.scm 216 */
								obj_t BgL_clausez00_3634;

								BgL_clausez00_3634 = CAR(BgL_l1347z00_3633);
								{	/* Dataflow/walk.scm 216 */
									obj_t BgL_arg1794z00_3635;

									BgL_arg1794z00_3635 = CDR(((obj_t) BgL_clausez00_3634));
									BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
										((BgL_nodez00_bglt) BgL_arg1794z00_3635), BgL_envz00_3387);
								}
							}
							{
								obj_t BgL_l1347z00_4800;

								BgL_l1347z00_4800 = CDR(BgL_l1347z00_3633);
								BgL_l1347z00_3633 = BgL_l1347z00_4800;
								goto BgL_zc3z04anonymousza31790ze3z87_3632;
							}
						}
					else
						{	/* Dataflow/walk.scm 215 */
							((bool_t) 1);
						}
				}
			}
			return BgL_envz00_3387;
		}

	}



/* &dataflow-node!-fail1397 */
	obj_t BGl_z62dataflowzd2nodez12zd2fail1397z70zzdataflow_walkz00(obj_t
		BgL_envz00_3388, obj_t BgL_nodez00_3389, obj_t BgL_envz00_3390)
	{
		{	/* Dataflow/walk.scm 202 */
			BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
				(((BgL_failz00_bglt) COBJECT(
							((BgL_failz00_bglt) BgL_nodez00_3389)))->BgL_procz00),
				BgL_envz00_3390);
			BGl_dataflowzd2nodez12zc0zzdataflow_walkz00((((BgL_failz00_bglt)
						COBJECT(((BgL_failz00_bglt) BgL_nodez00_3389)))->BgL_msgz00),
				BgL_envz00_3390);
			BGl_dataflowzd2nodez12zc0zzdataflow_walkz00((((BgL_failz00_bglt)
						COBJECT(((BgL_failz00_bglt) BgL_nodez00_3389)))->BgL_objz00),
				BgL_envz00_3390);
			return BgL_envz00_3390;
		}

	}



/* &dataflow-node!-condi1395 */
	obj_t BGl_z62dataflowzd2nodez12zd2condi1395z70zzdataflow_walkz00(obj_t
		BgL_envz00_3391, obj_t BgL_nodez00_3392, obj_t BgL_envz00_3393)
	{
		{	/* Dataflow/walk.scm 179 */
			{
				obj_t BgL_env1z00_3639;
				obj_t BgL_env2z00_3640;

				{	/* Dataflow/walk.scm 190 */
					obj_t BgL_tenvz00_3652;

					BgL_tenvz00_3652 =
						BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
						(((BgL_conditionalz00_bglt) COBJECT(
									((BgL_conditionalz00_bglt) BgL_nodez00_3392)))->BgL_testz00),
						BgL_envz00_3393);
					{	/* Dataflow/walk.scm 190 */
						obj_t BgL_truezd2envzd2_3653;

						BgL_truezd2envzd2_3653 =
							BGl_appendzd221011zd2zzdataflow_walkz00
							(BGl_dataflowzd2testzd2envz00zzdataflow_walkz00(((
										(BgL_conditionalz00_bglt) COBJECT(((BgL_conditionalz00_bglt)
												BgL_nodez00_3392)))->BgL_testz00)), BgL_tenvz00_3652);
						{	/* Dataflow/walk.scm 191 */
							obj_t BgL_falsezd2envzd2_3654;

							BgL_falsezd2envzd2_3654 =
								BGl_appendzd221011zd2zzdataflow_walkz00
								(BGl_dataflowzd2testzd2falsezd2envzd2zzdataflow_walkz00(((
											(BgL_conditionalz00_bglt)
											COBJECT(((BgL_conditionalz00_bglt) BgL_nodez00_3392)))->
										BgL_testz00)), BgL_tenvz00_3652);
							{	/* Dataflow/walk.scm 192 */

								{	/* Dataflow/walk.scm 193 */
									obj_t BgL_tenvz00_3655;
									obj_t BgL_fenvz00_3656;

									BgL_tenvz00_3655 =
										BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
										(((BgL_conditionalz00_bglt) COBJECT(
													((BgL_conditionalz00_bglt) BgL_nodez00_3392)))->
											BgL_falsez00), BgL_falsezd2envzd2_3654);
									BgL_fenvz00_3656 =
										BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(((
												(BgL_conditionalz00_bglt)
												COBJECT(((BgL_conditionalz00_bglt) BgL_nodez00_3392)))->
											BgL_truez00), BgL_truezd2envzd2_3653);
									{	/* Dataflow/walk.scm 195 */
										bool_t BgL_test2456z00_4828;

										{	/* Dataflow/walk.scm 195 */
											BgL_nodez00_bglt BgL_arg1767z00_3657;

											BgL_arg1767z00_3657 =
												(((BgL_conditionalz00_bglt) COBJECT(
														((BgL_conditionalz00_bglt) BgL_nodez00_3392)))->
												BgL_falsez00);
											BgL_test2456z00_4828 =
												CBOOL(BGl_abortzf3zf3zzdataflow_walkz00
												(BgL_arg1767z00_3657));
										}
										if (BgL_test2456z00_4828)
											{	/* Dataflow/walk.scm 195 */
												return BgL_tenvz00_3655;
											}
										else
											{	/* Dataflow/walk.scm 195 */
												BgL_env1z00_3639 = BgL_tenvz00_3655;
												BgL_env2z00_3640 = BgL_fenvz00_3656;
												{	/* Dataflow/walk.scm 182 */
													obj_t BgL_hook1346z00_3641;

													BgL_hook1346z00_3641 = MAKE_YOUNG_PAIR(BFALSE, BNIL);
													{
														obj_t BgL_l1343z00_3643;
														obj_t BgL_h1344z00_3644;

														BgL_l1343z00_3643 = BgL_env1z00_3639;
														BgL_h1344z00_3644 = BgL_hook1346z00_3641;
													BgL_zc3z04anonymousza31777ze3z87_3642:
														if (NULLP(BgL_l1343z00_3643))
															{	/* Dataflow/walk.scm 182 */
																return CDR(BgL_hook1346z00_3641);
															}
														else
															{	/* Dataflow/walk.scm 182 */
																bool_t BgL_test2458z00_4837;

																{	/* Dataflow/walk.scm 183 */
																	obj_t BgL_cz00_3645;

																	BgL_cz00_3645 =
																		CAR(((obj_t) BgL_l1343z00_3643));
																	{	/* Dataflow/walk.scm 184 */
																		obj_t BgL_c2z00_3646;

																		BgL_c2z00_3646 =
																			BGl_assqz00zz__r4_pairs_and_lists_6_3z00
																			(CAR(((obj_t) BgL_cz00_3645)),
																			BgL_env2z00_3640);
																		{	/* Dataflow/walk.scm 185 */

																			if (PAIRP(BgL_c2z00_3646))
																				{	/* Dataflow/walk.scm 186 */
																					BgL_test2458z00_4837 =
																						(CDR(BgL_c2z00_3646) ==
																						CDR(((obj_t) BgL_cz00_3645)));
																				}
																			else
																				{	/* Dataflow/walk.scm 186 */
																					BgL_test2458z00_4837 = ((bool_t) 0);
																				}
																		}
																	}
																}
																if (BgL_test2458z00_4837)
																	{	/* Dataflow/walk.scm 182 */
																		obj_t BgL_nh1345z00_3647;

																		{	/* Dataflow/walk.scm 182 */
																			obj_t BgL_arg1782z00_3648;

																			BgL_arg1782z00_3648 =
																				CAR(((obj_t) BgL_l1343z00_3643));
																			{	/* Dataflow/walk.scm 182 */
																				obj_t BgL_res2214z00_3649;

																				BgL_res2214z00_3649 =
																					MAKE_YOUNG_PAIR(BgL_arg1782z00_3648,
																					BNIL);
																				BgL_nh1345z00_3647 =
																					BgL_res2214z00_3649;
																			}
																		}
																		SET_CDR(BgL_h1344z00_3644,
																			BgL_nh1345z00_3647);
																		{	/* Dataflow/walk.scm 182 */
																			obj_t BgL_arg1781z00_3650;

																			BgL_arg1781z00_3650 =
																				CDR(((obj_t) BgL_l1343z00_3643));
																			{
																				obj_t BgL_h1344z00_4856;
																				obj_t BgL_l1343z00_4855;

																				BgL_l1343z00_4855 = BgL_arg1781z00_3650;
																				BgL_h1344z00_4856 = BgL_nh1345z00_3647;
																				BgL_h1344z00_3644 = BgL_h1344z00_4856;
																				BgL_l1343z00_3643 = BgL_l1343z00_4855;
																				goto
																					BgL_zc3z04anonymousza31777ze3z87_3642;
																			}
																		}
																	}
																else
																	{	/* Dataflow/walk.scm 182 */
																		obj_t BgL_arg1784z00_3651;

																		BgL_arg1784z00_3651 =
																			CDR(((obj_t) BgL_l1343z00_3643));
																		{
																			obj_t BgL_l1343z00_4859;

																			BgL_l1343z00_4859 = BgL_arg1784z00_3651;
																			BgL_l1343z00_3643 = BgL_l1343z00_4859;
																			goto
																				BgL_zc3z04anonymousza31777ze3z87_3642;
																		}
																	}
															}
													}
												}
											}
									}
								}
							}
						}
					}
				}
			}
		}

	}



/* &dataflow-node!-setq1393 */
	obj_t BGl_z62dataflowzd2nodez12zd2setq1393z70zzdataflow_walkz00(obj_t
		BgL_envz00_3394, obj_t BgL_nodez00_3395, obj_t BgL_envz00_3396)
	{
		{	/* Dataflow/walk.scm 159 */
			{
				BgL_variablez00_bglt BgL_variablez00_3660;
				obj_t BgL_envz00_3661;

				{	/* Dataflow/walk.scm 167 */
					obj_t BgL_nenvz00_3672;

					BgL_nenvz00_3672 =
						BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
						(((BgL_setqz00_bglt) COBJECT(
									((BgL_setqz00_bglt) BgL_nodez00_3395)))->BgL_valuez00),
						BgL_envz00_3396);
					{	/* Dataflow/walk.scm 168 */
						BgL_varz00_bglt BgL_i1158z00_3673;

						BgL_i1158z00_3673 =
							(((BgL_setqz00_bglt) COBJECT(
									((BgL_setqz00_bglt) BgL_nodez00_3395)))->BgL_varz00);
						{	/* Dataflow/walk.scm 169 */
							bool_t BgL_test2460z00_4865;

							{	/* Dataflow/walk.scm 169 */
								BgL_variablez00_bglt BgL_arg1750z00_3674;

								BgL_arg1750z00_3674 =
									(((BgL_varz00_bglt) COBJECT(BgL_i1158z00_3673))->
									BgL_variablez00);
								{	/* Dataflow/walk.scm 169 */
									bool_t BgL_res2211z00_3675;

									BgL_res2211z00_3675 =
										BGl_isazf3zf3zz__objectz00(
										((obj_t) BgL_arg1750z00_3674), BGl_globalz00zzast_varz00);
									BgL_test2460z00_4865 = BgL_res2211z00_3675;
								}
							}
							if (BgL_test2460z00_4865)
								{	/* Dataflow/walk.scm 169 */
									BgL_variablez00_3660 =
										(((BgL_varz00_bglt) COBJECT(BgL_i1158z00_3673))->
										BgL_variablez00);
									BgL_envz00_3661 = BgL_nenvz00_3672;
								BgL_removezd2variablezd2fromzd2envzd2_3659:
									{	/* Dataflow/walk.scm 162 */
										obj_t BgL_hook1341z00_3662;

										BgL_hook1341z00_3662 = MAKE_YOUNG_PAIR(BFALSE, BNIL);
										{
											obj_t BgL_l1338z00_3664;
											obj_t BgL_h1339z00_3665;

											BgL_l1338z00_3664 = BgL_envz00_3661;
											BgL_h1339z00_3665 = BgL_hook1341z00_3662;
										BgL_zc3z04anonymousza31753ze3z87_3663:
											if (NULLP(BgL_l1338z00_3664))
												{	/* Dataflow/walk.scm 162 */
													return CDR(BgL_hook1341z00_3662);
												}
											else
												{	/* Dataflow/walk.scm 162 */
													bool_t BgL_test2462z00_4873;

													{	/* Dataflow/walk.scm 163 */
														bool_t BgL_test2463z00_4874;

														{	/* Dataflow/walk.scm 163 */
															obj_t BgL_tmpz00_4875;

															{	/* Dataflow/walk.scm 163 */
																obj_t BgL_pairz00_3666;

																BgL_pairz00_3666 =
																	CAR(((obj_t) BgL_l1338z00_3664));
																BgL_tmpz00_4875 = CAR(BgL_pairz00_3666);
															}
															BgL_test2463z00_4874 =
																(BgL_tmpz00_4875 ==
																((obj_t) BgL_variablez00_3660));
														}
														if (BgL_test2463z00_4874)
															{	/* Dataflow/walk.scm 163 */
																BgL_test2462z00_4873 = ((bool_t) 0);
															}
														else
															{	/* Dataflow/walk.scm 163 */
																BgL_test2462z00_4873 = ((bool_t) 1);
															}
													}
													if (BgL_test2462z00_4873)
														{	/* Dataflow/walk.scm 162 */
															obj_t BgL_nh1340z00_3667;

															{	/* Dataflow/walk.scm 162 */
																obj_t BgL_arg1761z00_3668;

																BgL_arg1761z00_3668 =
																	CAR(((obj_t) BgL_l1338z00_3664));
																{	/* Dataflow/walk.scm 162 */
																	obj_t BgL_res2210z00_3669;

																	BgL_res2210z00_3669 =
																		MAKE_YOUNG_PAIR(BgL_arg1761z00_3668, BNIL);
																	BgL_nh1340z00_3667 = BgL_res2210z00_3669;
																}
															}
															SET_CDR(BgL_h1339z00_3665, BgL_nh1340z00_3667);
															{	/* Dataflow/walk.scm 162 */
																obj_t BgL_arg1760z00_3670;

																BgL_arg1760z00_3670 =
																	CDR(((obj_t) BgL_l1338z00_3664));
																{
																	obj_t BgL_h1339z00_4888;
																	obj_t BgL_l1338z00_4887;

																	BgL_l1338z00_4887 = BgL_arg1760z00_3670;
																	BgL_h1339z00_4888 = BgL_nh1340z00_3667;
																	BgL_h1339z00_3665 = BgL_h1339z00_4888;
																	BgL_l1338z00_3664 = BgL_l1338z00_4887;
																	goto BgL_zc3z04anonymousza31753ze3z87_3663;
																}
															}
														}
													else
														{	/* Dataflow/walk.scm 162 */
															obj_t BgL_arg1762z00_3671;

															BgL_arg1762z00_3671 =
																CDR(((obj_t) BgL_l1338z00_3664));
															{
																obj_t BgL_l1338z00_4891;

																BgL_l1338z00_4891 = BgL_arg1762z00_3671;
																BgL_l1338z00_3664 = BgL_l1338z00_4891;
																goto BgL_zc3z04anonymousza31753ze3z87_3663;
															}
														}
												}
										}
									}
								}
							else
								{	/* Dataflow/walk.scm 171 */
									BgL_typez00_bglt BgL_typz00_3676;

									BgL_typz00_3676 =
										BGl_getzd2typezd2zztype_typeofz00(
										(((BgL_setqz00_bglt) COBJECT(
													((BgL_setqz00_bglt) BgL_nodez00_3395)))->
											BgL_valuez00), ((bool_t) 1));
									{	/* Dataflow/walk.scm 172 */
										bool_t BgL_test2464z00_4896;

										if (
											(((obj_t) BgL_typz00_3676) ==
												BGl_za2_za2z00zztype_cachez00))
											{	/* Dataflow/walk.scm 172 */
												BgL_test2464z00_4896 = ((bool_t) 1);
											}
										else
											{	/* Dataflow/walk.scm 172 */
												BgL_test2464z00_4896 =
													(
													((obj_t) BgL_typz00_3676) ==
													BGl_za2objza2z00zztype_cachez00);
											}
										if (BgL_test2464z00_4896)
											{
												obj_t BgL_envz00_4904;
												BgL_variablez00_bglt BgL_variablez00_4902;

												BgL_variablez00_4902 =
													(((BgL_varz00_bglt) COBJECT(BgL_i1158z00_3673))->
													BgL_variablez00);
												BgL_envz00_4904 = BgL_nenvz00_3672;
												BgL_envz00_3661 = BgL_envz00_4904;
												BgL_variablez00_3660 = BgL_variablez00_4902;
												goto BgL_removezd2variablezd2fromzd2envzd2_3659;
											}
										else
											{	/* Dataflow/walk.scm 174 */
												obj_t BgL_arg1737z00_3677;

												{	/* Dataflow/walk.scm 174 */
													BgL_variablez00_bglt BgL_arg1748z00_3678;

													BgL_arg1748z00_3678 =
														(((BgL_varz00_bglt) COBJECT(BgL_i1158z00_3673))->
														BgL_variablez00);
													BgL_arg1737z00_3677 =
														MAKE_YOUNG_PAIR(((obj_t) BgL_arg1748z00_3678),
														((obj_t) BgL_typz00_3676));
												}
												return
													MAKE_YOUNG_PAIR(BgL_arg1737z00_3677,
													BgL_nenvz00_3672);
											}
									}
								}
						}
					}
				}
			}
		}

	}



/* &dataflow-node!-exter1391 */
	obj_t BGl_z62dataflowzd2nodez12zd2exter1391z70zzdataflow_walkz00(obj_t
		BgL_envz00_3397, obj_t BgL_nodez00_3398, obj_t BgL_envz00_3399)
	{
		{	/* Dataflow/walk.scm 152 */
			{	/* Dataflow/walk.scm 153 */
				obj_t BgL_res2317z00_3680;

				BgL_res2317z00_3680 =
					BGl_dataflowzd2nodeza2z12z62zzdataflow_walkz00(
					(((BgL_externz00_bglt) COBJECT(
								((BgL_externz00_bglt) BgL_nodez00_3398)))->BgL_exprza2za2),
					BgL_envz00_3399);
				return BgL_res2317z00_3680;
			}
		}

	}



/* &dataflow-node!-funca1389 */
	obj_t BGl_z62dataflowzd2nodez12zd2funca1389z70zzdataflow_walkz00(obj_t
		BgL_envz00_3400, obj_t BgL_nodez00_3401, obj_t BgL_envz00_3402)
	{
		{	/* Dataflow/walk.scm 144 */
			BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
				(((BgL_funcallz00_bglt) COBJECT(
							((BgL_funcallz00_bglt) BgL_nodez00_3401)))->BgL_funz00),
				BgL_envz00_3402);
			return
				BGl_dataflowzd2nodeza2z12z62zzdataflow_walkz00((((BgL_funcallz00_bglt)
						COBJECT(((BgL_funcallz00_bglt) BgL_nodez00_3401)))->BgL_argsz00),
				BgL_envz00_3402);
		}

	}



/* &dataflow-node!-app-l1387 */
	obj_t BGl_z62dataflowzd2nodez12zd2appzd2l1387za2zzdataflow_walkz00(obj_t
		BgL_envz00_3403, obj_t BgL_nodez00_3404, obj_t BgL_envz00_3405)
	{
		{	/* Dataflow/walk.scm 136 */
			BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
				(((BgL_appzd2lyzd2_bglt) COBJECT(
							((BgL_appzd2lyzd2_bglt) BgL_nodez00_3404)))->BgL_funz00),
				BgL_envz00_3405);
			return
				BGl_dataflowzd2nodez12zc0zzdataflow_walkz00((((BgL_appzd2lyzd2_bglt)
						COBJECT(((BgL_appzd2lyzd2_bglt) BgL_nodez00_3404)))->BgL_argz00),
				BgL_envz00_3405);
		}

	}



/* &dataflow-node!-app1385 */
	obj_t BGl_z62dataflowzd2nodez12zd2app1385z70zzdataflow_walkz00(obj_t
		BgL_envz00_3406, obj_t BgL_nodez00_3407, obj_t BgL_envz00_3408)
	{
		{	/* Dataflow/walk.scm 120 */
			{	/* Dataflow/walk.scm 122 */
				obj_t BgL_aenvz00_3684;

				BgL_aenvz00_3684 =
					BGl_dataflowzd2nodeza2z12z62zzdataflow_walkz00(
					(((BgL_appz00_bglt) COBJECT(
								((BgL_appz00_bglt) BgL_nodez00_3407)))->BgL_argsz00),
					BgL_envz00_3408);
				{	/* Dataflow/walk.scm 123 */
					bool_t BgL_test2466z00_4928;

					{	/* Dataflow/walk.scm 123 */
						BgL_variablez00_bglt BgL_arg1695z00_3685;

						BgL_arg1695z00_3685 =
							(((BgL_varz00_bglt) COBJECT(
									(((BgL_appz00_bglt) COBJECT(
												((BgL_appz00_bglt) BgL_nodez00_3407)))->BgL_funz00)))->
							BgL_variablez00);
						{	/* Dataflow/walk.scm 123 */
							bool_t BgL_res2205z00_3686;

							BgL_res2205z00_3686 =
								BGl_isazf3zf3zz__objectz00(
								((obj_t) BgL_arg1695z00_3685), BGl_localz00zzast_varz00);
							BgL_test2466z00_4928 = BgL_res2205z00_3686;
						}
					}
					if (BgL_test2466z00_4928)
						{	/* Dataflow/walk.scm 127 */
							obj_t BgL_hook1336z00_3687;

							BgL_hook1336z00_3687 = MAKE_YOUNG_PAIR(BFALSE, BNIL);
							{
								obj_t BgL_l1333z00_3689;
								obj_t BgL_h1334z00_3690;

								BgL_l1333z00_3689 = BgL_aenvz00_3684;
								BgL_h1334z00_3690 = BgL_hook1336z00_3687;
							BgL_zc3z04anonymousza31683ze3z87_3688:
								if (NULLP(BgL_l1333z00_3689))
									{	/* Dataflow/walk.scm 127 */
										return CDR(BgL_hook1336z00_3687);
									}
								else
									{	/* Dataflow/walk.scm 127 */
										bool_t BgL_test2468z00_4938;

										{	/* Dataflow/walk.scm 128 */
											obj_t BgL_vz00_3691;

											{	/* Dataflow/walk.scm 128 */
												obj_t BgL_pairz00_3692;

												BgL_pairz00_3692 = CAR(((obj_t) BgL_l1333z00_3689));
												BgL_vz00_3691 = CAR(BgL_pairz00_3692);
											}
											{	/* Dataflow/walk.scm 129 */
												bool_t BgL__ortest_1154z00_3693;

												BgL__ortest_1154z00_3693 =
													BGl_isazf3zf3zz__objectz00(BgL_vz00_3691,
													BGl_globalz00zzast_varz00);
												if (BgL__ortest_1154z00_3693)
													{	/* Dataflow/walk.scm 129 */
														BgL_test2468z00_4938 = BgL__ortest_1154z00_3693;
													}
												else
													{	/* Dataflow/walk.scm 129 */
														BgL_test2468z00_4938 =
															(
															(((BgL_variablez00_bglt) COBJECT(
																		((BgL_variablez00_bglt) BgL_vz00_3691)))->
																BgL_accessz00) == CNST_TABLE_REF(((long) 11)));
										}}}
										if (BgL_test2468z00_4938)
											{	/* Dataflow/walk.scm 127 */
												obj_t BgL_nh1335z00_3694;

												{	/* Dataflow/walk.scm 127 */
													obj_t BgL_arg1692z00_3695;

													BgL_arg1692z00_3695 =
														CAR(((obj_t) BgL_l1333z00_3689));
													{	/* Dataflow/walk.scm 127 */
														obj_t BgL_res2208z00_3696;

														BgL_res2208z00_3696 =
															MAKE_YOUNG_PAIR(BgL_arg1692z00_3695, BNIL);
														BgL_nh1335z00_3694 = BgL_res2208z00_3696;
													}
												}
												SET_CDR(BgL_h1334z00_3690, BgL_nh1335z00_3694);
												{	/* Dataflow/walk.scm 127 */
													obj_t BgL_arg1691z00_3697;

													BgL_arg1691z00_3697 =
														CDR(((obj_t) BgL_l1333z00_3689));
													{
														obj_t BgL_h1334z00_4955;
														obj_t BgL_l1333z00_4954;

														BgL_l1333z00_4954 = BgL_arg1691z00_3697;
														BgL_h1334z00_4955 = BgL_nh1335z00_3694;
														BgL_h1334z00_3690 = BgL_h1334z00_4955;
														BgL_l1333z00_3689 = BgL_l1333z00_4954;
														goto BgL_zc3z04anonymousza31683ze3z87_3688;
													}
												}
											}
										else
											{	/* Dataflow/walk.scm 127 */
												obj_t BgL_arg1693z00_3698;

												BgL_arg1693z00_3698 = CDR(((obj_t) BgL_l1333z00_3689));
												{
													obj_t BgL_l1333z00_4958;

													BgL_l1333z00_4958 = BgL_arg1693z00_3698;
													BgL_l1333z00_3689 = BgL_l1333z00_4958;
													goto BgL_zc3z04anonymousza31683ze3z87_3688;
												}
											}
									}
							}
						}
					else
						{	/* Dataflow/walk.scm 123 */
							return BgL_aenvz00_3684;
						}
				}
			}
		}

	}



/* &dataflow-node!-sync1383 */
	obj_t BGl_z62dataflowzd2nodez12zd2sync1383z70zzdataflow_walkz00(obj_t
		BgL_envz00_3409, obj_t BgL_nodez00_3410, obj_t BgL_envz00_3411)
	{
		{	/* Dataflow/walk.scm 111 */
			BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
				(((BgL_syncz00_bglt) COBJECT(
							((BgL_syncz00_bglt) BgL_nodez00_3410)))->BgL_mutexz00),
				BgL_envz00_3411);
			BGl_dataflowzd2nodez12zc0zzdataflow_walkz00((((BgL_syncz00_bglt)
						COBJECT(((BgL_syncz00_bglt) BgL_nodez00_3410)))->BgL_prelockz00),
				BgL_envz00_3411);
			BGl_dataflowzd2nodez12zc0zzdataflow_walkz00((((BgL_syncz00_bglt)
						COBJECT(((BgL_syncz00_bglt) BgL_nodez00_3410)))->BgL_bodyz00),
				BgL_envz00_3411);
			return BgL_envz00_3411;
		}

	}



/* &dataflow-node!-seque1381 */
	obj_t BGl_z62dataflowzd2nodez12zd2seque1381z70zzdataflow_walkz00(obj_t
		BgL_envz00_3412, obj_t BgL_nodez00_3413, obj_t BgL_envz00_3414)
	{
		{	/* Dataflow/walk.scm 101 */
			{	/* Dataflow/walk.scm 102 */
				obj_t BgL_res2318z00_3708;

				{	/* Dataflow/walk.scm 102 */
					obj_t BgL_g1152z00_3701;

					BgL_g1152z00_3701 =
						(((BgL_sequencez00_bglt) COBJECT(
								((BgL_sequencez00_bglt) BgL_nodez00_3413)))->BgL_nodesz00);
					{
						obj_t BgL_nodeza2za2_3703;
						obj_t BgL_envz00_3704;

						BgL_nodeza2za2_3703 = BgL_g1152z00_3701;
						BgL_envz00_3704 = BgL_envz00_3414;
					BgL_loopz00_3702:
						if (NULLP(BgL_nodeza2za2_3703))
							{	/* Dataflow/walk.scm 104 */
								BgL_res2318z00_3708 = BgL_envz00_3704;
							}
						else
							{	/* Dataflow/walk.scm 106 */
								obj_t BgL_arg1668z00_3705;
								obj_t BgL_arg1669z00_3706;

								BgL_arg1668z00_3705 = CDR(((obj_t) BgL_nodeza2za2_3703));
								{	/* Dataflow/walk.scm 106 */
									obj_t BgL_arg1670z00_3707;

									BgL_arg1670z00_3707 = CAR(((obj_t) BgL_nodeza2za2_3703));
									BgL_arg1669z00_3706 =
										BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
										((BgL_nodez00_bglt) BgL_arg1670z00_3707), BgL_envz00_3704);
								}
								{
									obj_t BgL_envz00_4979;
									obj_t BgL_nodeza2za2_4978;

									BgL_nodeza2za2_4978 = BgL_arg1668z00_3705;
									BgL_envz00_4979 = BgL_arg1669z00_3706;
									BgL_envz00_3704 = BgL_envz00_4979;
									BgL_nodeza2za2_3703 = BgL_nodeza2za2_4978;
									goto BgL_loopz00_3702;
								}
							}
					}
				}
				return BgL_res2318z00_3708;
			}
		}

	}



/* &dataflow-node!-closu1379 */
	obj_t BGl_z62dataflowzd2nodez12zd2closu1379z70zzdataflow_walkz00(obj_t
		BgL_envz00_3415, obj_t BgL_nodez00_3416, obj_t BgL_envz00_3417)
	{
		{	/* Dataflow/walk.scm 95 */
			return ((obj_t) BgL_envz00_3417);
		}

	}



/* &dataflow-node!-var1377 */
	obj_t BGl_z62dataflowzd2nodez12zd2var1377z70zzdataflow_walkz00(obj_t
		BgL_envz00_3418, obj_t BgL_nodez00_3419, obj_t BgL_envz00_3420)
	{
		{	/* Dataflow/walk.scm 81 */
			{	/* Dataflow/walk.scm 83 */
				BgL_variablez00_bglt BgL_i1150z00_3712;

				BgL_i1150z00_3712 =
					(((BgL_varz00_bglt) COBJECT(
							((BgL_varz00_bglt) BgL_nodez00_3419)))->BgL_variablez00);
				{	/* Dataflow/walk.scm 84 */
					bool_t BgL_test2471z00_4983;

					if (BGl_bigloozd2typezf3z21zztype_typez00(
							(((BgL_variablez00_bglt) COBJECT(BgL_i1150z00_3712))->
								BgL_typez00)))
						{	/* Dataflow/walk.scm 85 */
							bool_t BgL__ortest_1151z00_3713;

							{	/* Dataflow/walk.scm 85 */
								bool_t BgL_test2473z00_4987;

								{	/* Dataflow/walk.scm 85 */
									BgL_typez00_bglt BgL_arg1660z00_3714;

									BgL_arg1660z00_3714 =
										(((BgL_variablez00_bglt) COBJECT(BgL_i1150z00_3712))->
										BgL_typez00);
									{	/* Dataflow/walk.scm 85 */
										bool_t BgL_res2201z00_3715;

										BgL_res2201z00_3715 =
											BGl_isazf3zf3zz__objectz00(
											((obj_t) BgL_arg1660z00_3714),
											BGl_tclassz00zzobject_classz00);
										BgL_test2473z00_4987 = BgL_res2201z00_3715;
									}
								}
								if (BgL_test2473z00_4987)
									{	/* Dataflow/walk.scm 85 */
										BgL__ortest_1151z00_3713 = ((bool_t) 0);
									}
								else
									{	/* Dataflow/walk.scm 85 */
										BgL__ortest_1151z00_3713 = ((bool_t) 1);
									}
							}
							if (BgL__ortest_1151z00_3713)
								{	/* Dataflow/walk.scm 85 */
									BgL_test2471z00_4983 = BgL__ortest_1151z00_3713;
								}
							else
								{	/* Dataflow/walk.scm 85 */
									BgL_typez00_bglt BgL_arg1655z00_3716;
									BgL_typez00_bglt BgL_arg1656z00_3717;

									BgL_arg1655z00_3716 =
										(((BgL_variablez00_bglt) COBJECT(BgL_i1150z00_3712))->
										BgL_typez00);
									BgL_arg1656z00_3717 =
										(((BgL_nodez00_bglt)
											COBJECT(((BgL_nodez00_bglt) ((BgL_varz00_bglt)
														BgL_nodez00_3419))))->BgL_typez00);
									BgL_test2471z00_4983 =
										BGl_typezd2subclasszf3z21zzobject_classz00
										(BgL_arg1655z00_3716, BgL_arg1656z00_3717);
								}
						}
					else
						{	/* Dataflow/walk.scm 84 */
							BgL_test2471z00_4983 = ((bool_t) 0);
						}
					if (BgL_test2471z00_4983)
						{	/* Dataflow/walk.scm 86 */
							obj_t BgL_bz00_3718;

							BgL_bz00_3718 =
								BGl_assqz00zz__r4_pairs_and_lists_6_3z00(
								((obj_t)
									(((BgL_varz00_bglt) COBJECT(
												((BgL_varz00_bglt) BgL_nodez00_3419)))->
										BgL_variablez00)), BgL_envz00_3420);
							if (PAIRP(BgL_bz00_3718))
								{	/* Dataflow/walk.scm 87 */
									((((BgL_nodez00_bglt) COBJECT(
													((BgL_nodez00_bglt)
														((BgL_varz00_bglt) BgL_nodez00_3419))))->
											BgL_typez00) =
										((BgL_typez00_bglt) ((BgL_typez00_bglt)
												CDR(BgL_bz00_3718))), BUNSPEC);
								}
							else
								{	/* Dataflow/walk.scm 87 */
									((((BgL_nodez00_bglt) COBJECT(
													((BgL_nodez00_bglt)
														((BgL_varz00_bglt) BgL_nodez00_3419))))->
											BgL_typez00) =
										((BgL_typez00_bglt) (((BgL_variablez00_bglt)
													COBJECT((((BgL_varz00_bglt) COBJECT(((BgL_varz00_bglt)
																		BgL_nodez00_3419)))->BgL_variablez00)))->
												BgL_typez00)), BUNSPEC);
								}
						}
					else
						{	/* Dataflow/walk.scm 84 */
							BFALSE;
						}
				}
			}
			return BgL_envz00_3420;
		}

	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzdataflow_walkz00()
	{
		{	/* Dataflow/walk.scm 17 */
			BGl_modulezd2initializa7ationz75zztools_speekz00(((long) 61247943),
				BSTRING_TO_STRING(BGl_string2311z00zzdataflow_walkz00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 300504031),
				BSTRING_TO_STRING(BGl_string2311z00zzdataflow_walkz00));
			BGl_modulezd2initializa7ationz75zzengine_passz00(((long) 373082237),
				BSTRING_TO_STRING(BGl_string2311z00zzdataflow_walkz00));
			BGl_modulezd2initializa7ationz75zztools_tracez00(((long) 54713316),
				BSTRING_TO_STRING(BGl_string2311z00zzdataflow_walkz00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 365925558),
				BSTRING_TO_STRING(BGl_string2311z00zzdataflow_walkz00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 515343395),
				BSTRING_TO_STRING(BGl_string2311z00zzdataflow_walkz00));
			BGl_modulezd2initializa7ationz75zztype_typeofz00(((long) 398780265),
				BSTRING_TO_STRING(BGl_string2311z00zzdataflow_walkz00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 346491734),
				BSTRING_TO_STRING(BGl_string2311z00zzdataflow_walkz00));
			BGl_modulezd2initializa7ationz75zztype_miscz00(((long) 49975086),
				BSTRING_TO_STRING(BGl_string2311z00zzdataflow_walkz00));
			BGl_modulezd2initializa7ationz75zztype_envz00(((long) 296457443),
				BSTRING_TO_STRING(BGl_string2311z00zzdataflow_walkz00));
			BGl_modulezd2initializa7ationz75zzobject_classz00(((long) 502007119),
				BSTRING_TO_STRING(BGl_string2311z00zzdataflow_walkz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 90839984),
				BSTRING_TO_STRING(BGl_string2311z00zzdataflow_walkz00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 506185397),
				BSTRING_TO_STRING(BGl_string2311z00zzdataflow_walkz00));
			BGl_modulezd2initializa7ationz75zzast_envz00(((long) 146730773),
				BSTRING_TO_STRING(BGl_string2311z00zzdataflow_walkz00));
			BGl_modulezd2initializa7ationz75zzast_dumpz00(((long) 271707717),
				BSTRING_TO_STRING(BGl_string2311z00zzdataflow_walkz00));
			BGl_modulezd2initializa7ationz75zzeffect_cgraphz00(((long) 271385047),
				BSTRING_TO_STRING(BGl_string2311z00zzdataflow_walkz00));
			BGl_modulezd2initializa7ationz75zzeffect_spreadz00(((long) 348216764),
				BSTRING_TO_STRING(BGl_string2311z00zzdataflow_walkz00));
			BGl_modulezd2initializa7ationz75zzeffect_feffectz00(((long) 516374368),
				BSTRING_TO_STRING(BGl_string2311z00zzdataflow_walkz00));
			return
				BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 476633989),
				BSTRING_TO_STRING(BGl_string2311z00zzdataflow_walkz00));
		}

	}

#ifdef __cplusplus
}
#endif
