/*===========================================================================*/
/*   (Trace/walk.scm)                                                        */
/*   Bigloo (4.3g)                                                           */
/*   Inria -- Sophia Antipolis (c)       Wed 12 Feb 2020 07:45:41 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.3g -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Trace/walk.scm) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		bool_t BgL_evalzf3zf3;
		obj_t BgL_libraryz00;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
		obj_t BgL_initz00;
		obj_t BgL_aliasz00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_funz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
	}             *BgL_funz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
		obj_t BgL_strengthz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
		bool_t BgL_unsafez00;
		obj_t BgL_metaz00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_appzd2lyzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}                  *BgL_appzd2lyzd2_bglt;

	typedef struct BgL_funcallz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_strengthz00;
		obj_t BgL_functionsz00;
	}                 *BgL_funcallz00_bglt;

	typedef struct BgL_externz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
	}                *BgL_externz00_bglt;

	typedef struct BgL_castz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}              *BgL_castz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_failz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_procz00;
		struct BgL_nodez00_bgl *BgL_msgz00;
		struct BgL_nodez00_bgl *BgL_objz00;
	}              *BgL_failz00_bglt;

	typedef struct BgL_switchz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_switchz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;

	typedef struct BgL_setzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                       *BgL_setzd2exzd2itz00_bglt;

	typedef struct BgL_jumpzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_exitz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                        *BgL_jumpzd2exzd2itz00_bglt;

	typedef struct BgL_makezd2boxzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                    *BgL_makezd2boxzd2_bglt;

	typedef struct BgL_boxzd2refzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                   *BgL_boxzd2refzd2_bglt;

	typedef struct BgL_boxzd2setz12zc0_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                      *BgL_boxzd2setz12zc0_bglt;

	typedef struct BgL_syncz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_mutexz00;
		struct BgL_nodez00_bgl *BgL_prelockz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}              *BgL_syncz00_bglt;

	typedef struct BgL_backendz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_languagez00;
		obj_t BgL_srfi0z00;
		obj_t BgL_namez00;
		obj_t BgL_externzd2variableszd2;
		obj_t BgL_externzd2functionszd2;
		obj_t BgL_externzd2typeszd2;
		obj_t BgL_variablesz00;
		obj_t BgL_functionsz00;
		obj_t BgL_typesz00;
		bool_t BgL_typedz00;
		obj_t BgL_heapzd2suffixzd2;
		obj_t BgL_heapzd2compatiblezd2;
		bool_t BgL_callccz00;
		bool_t BgL_qualifiedzd2typeszd2;
		bool_t BgL_effectzb2zb2;
		bool_t BgL_removezd2emptyzd2letz00;
		bool_t BgL_foreignzd2closurezd2;
		bool_t BgL_typedzd2eqzd2;
		bool_t BgL_tracezd2supportzd2;
		obj_t BgL_foreignzd2clausezd2supportz00;
		obj_t BgL_debugzd2supportzd2;
		bool_t BgL_pragmazd2supportzd2;
		bool_t BgL_tvectorzd2descrzd2supportz00;
		bool_t BgL_requirezd2tailczd2;
		obj_t BgL_registersz00;
		obj_t BgL_pregistersz00;
		bool_t BgL_boundzd2checkzd2;
		bool_t BgL_typezd2checkzd2;
		bool_t BgL_typedzd2funcallzd2;
	}                 *BgL_backendz00_bglt;


	static obj_t BGl_z62findzd2lastzd2nodez62zztrace_walkz00(obj_t, obj_t);
	static obj_t BGl_z62findzd2lastzd2nodezd2setzd2e1342z62zztrace_walkz00(obj_t,
		obj_t);
	BGL_IMPORT obj_t bgl_display_obj(obj_t, obj_t);
	extern obj_t BGl_syncz00zzast_nodez00;
	static obj_t BGl_z62findzd2lastzd2nodezd2exter1328zb0zztrace_walkz00(obj_t,
		obj_t);
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2sequence1348z62zztrace_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_sequencez00zzast_nodez00;
	BGL_IMPORT obj_t BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(obj_t);
	BGL_IMPORT bool_t BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(obj_t);
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	extern obj_t BGl_failz00zzast_nodez00;
	static obj_t BGl_objectzd2initzd2zztrace_walkz00();
	static obj_t BGl_z62findzd2lastzd2nodezd2condi1332zb0zztrace_walkz00(obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t BGl_tracezd2walkz12zc0zztrace_walkz00(obj_t);
	BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	BGL_IMPORT bool_t BGl_2ze3ze3zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern obj_t BGl_boxzd2refzd2zzast_nodez00;
	BGL_IMPORT obj_t bstring_to_symbol(obj_t);
	extern obj_t BGl_thezd2backendzd2zzbackend_backendz00();
	BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	static obj_t BGl_methodzd2initzd2zztrace_walkz00();
	static obj_t BGl_tracezd2funz12zc0zztrace_walkz00(obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2condition1364z62zztrace_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_externz00zzast_nodez00;
	static BgL_letzd2varzd2_bglt
		BGl_makezd2tracedzd2nodez00zztrace_walkz00(BgL_nodez00_bglt,
		BgL_typez00_bglt, obj_t, obj_t, obj_t);
	static obj_t BGl_z62findzd2lastzd2nodezd2letzd2v1338z62zztrace_walkz00(obj_t,
		obj_t);
	static obj_t BGl_z62findzd2lastzd2nodezd2letzd2f1340z62zztrace_walkz00(obj_t,
		obj_t);
	static obj_t BGl_z62findzd2lastzd2nodezd2jumpzd21344z62zztrace_walkz00(obj_t,
		obj_t);
	static BgL_nodez00_bglt BGl_tracezd2nodezd2zztrace_walkz00(BgL_nodez00_bglt,
		obj_t, obj_t);
	static obj_t BGl_z62tracezd2walkz12za2zztrace_walkz00(obj_t, obj_t);
	extern obj_t BGl_pragmaz00zzast_nodez00;
	extern BgL_typez00_bglt
		BGl_strictzd2nodezd2typez00zzast_nodez00(BgL_typez00_bglt,
		BgL_typez00_bglt);
	static BgL_nodez00_bglt BGl_z62tracezd2nodezb0zztrace_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62toplevelzd2tracezd2nodez62zztrace_walkz00(obj_t, obj_t);
	extern obj_t BGl_findzd2locationzd2zztools_locationz00(obj_t);
	extern obj_t BGl_enterzd2functionzd2zztools_errorz00(obj_t);
	extern obj_t BGl_appzd2lyzd2zzast_nodez00;
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2jumpzd2exzd2i1379z62zztrace_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62findzd2lastzd2nodezd2setq1330zb0zztrace_walkz00(obj_t,
		obj_t);
	static obj_t BGl_findzd2lastzd2sexpz00zztrace_walkz00(obj_t);
	static obj_t BGl_gczd2rootszd2initz00zztrace_walkz00();
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2switch1370z62zztrace_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static BgL_nodez00_bglt
		BGl_z62toplevelzd2tracezd2nodezd21391zb0zztrace_walkz00(obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62toplevelzd2tracezd2nodezd21393zb0zztrace_walkz00(obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62toplevelzd2tracezd2nodezd21395zb0zztrace_walkz00(obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2funcall1356z62zztrace_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static BgL_nodez00_bglt
		BGl_toplevelzd2tracezd2nodez00zztrace_walkz00(BgL_nodez00_bglt);
	extern obj_t BGl_za2currentzd2passza2zd2zzengine_passz00;
	BGL_IMPORT obj_t BGl_gensymz00zz__r4_symbols_6_4z00(obj_t);
	BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_variablez00zzast_varz00;
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2cast1360z62zztrace_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_conditionalz00zzast_nodez00;
	extern obj_t BGl_za2compilerzd2debugzd2traceza2z00zzengine_paramz00;
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2boxzd2setz121385za2zztrace_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62toplevelzd2tracezd2node1386z62zztrace_walkz00(obj_t,
		obj_t);
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2makezd2box1381zb0zztrace_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2boxzd2ref1383zb0zztrace_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2setq1362z62zztrace_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_verbosez00zztools_speekz00(obj_t, obj_t);
	static obj_t BGl_z62findzd2lastzd2nodezd2appzd2l1324z62zztrace_walkz00(obj_t,
		obj_t);
	extern obj_t BGl_setqz00zzast_nodez00;
	extern obj_t BGl_locationzd2fullzd2fnamez00zztools_locationz00(obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zztrace_walkz00 = BUNSPEC;
	extern obj_t BGl_makezd2typedzd2identz00zzast_identz00(obj_t, obj_t);
	extern bool_t BGl_isloopzf3zf3zztrace_isloopz00(BgL_letzd2funzd2_bglt);
	extern obj_t BGl_setzd2exzd2itz00zzast_nodez00;
	static obj_t BGl_z62findzd2lastzd2nodezd2funca1326zb0zztrace_walkz00(obj_t,
		obj_t);
	static obj_t BGl_tracezd2idzd2zztrace_walkz00(obj_t);
	BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_atomz00zzast_nodez00;
	static bool_t BGl_toplevelzd2tracezd2nodeza2z12zb0zztrace_walkz00(obj_t);
	static obj_t BGl_toplevelzd2initzd2zztrace_walkz00();
	extern obj_t BGl_internalzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_genericzd2initzd2zztrace_walkz00();
	BGL_IMPORT obj_t BGl_stringzd2copyzd2zz__r4_strings_6_7z00(obj_t);
	extern obj_t BGl_leavezd2functionzd2zztools_errorz00();
	static obj_t BGl_findzd2lastzd2nodez00zztrace_walkz00(BgL_nodez00_bglt);
	extern obj_t BGl_castz00zzast_nodez00;
	static bool_t BGl_tracezd2nodeza2z12z62zztrace_walkz00(obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62tracezd2nodezd2app1352z62zztrace_walkz00(obj_t,
		obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00;
	extern obj_t BGl_findzd2globalzd2zzast_envz00(obj_t, obj_t);
	BGL_IMPORT obj_t string_append(obj_t, obj_t);
	extern obj_t BGl_varz00zzast_nodez00;
	static obj_t BGl_z62findzd2lastzd2nodezd2app1322zb0zztrace_walkz00(obj_t,
		obj_t);
	extern obj_t BGl_makezd2boxzd2zzast_nodez00;
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2letzd2fun1372zb0zztrace_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62findzd2lastzd2node1315z62zztrace_walkz00(obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2appzd2ly1354zb0zztrace_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_za2moduleza2z00zzmodule_modulez00;
	BGL_IMPORT obj_t BGl_exitz00zz__errorz00(obj_t);
	extern obj_t BGl_boxzd2setz12zc0zzast_nodez00;
	static obj_t BGl_fqnameze70ze7zztrace_walkz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zztrace_walkz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztrace_isloopz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzmodule_modulez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_identz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_sexpz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_backendz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_locationz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_miscz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_letz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_passz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_speekz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__structurez00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
	extern obj_t BGl_appz00zzast_nodez00;
	extern obj_t BGl_nodez00zzast_nodez00;
	extern obj_t BGl_kwotez00zzast_nodez00;
	extern obj_t BGl_localz00zzast_varz00;
	extern obj_t BGl_jumpzd2exzd2itz00zzast_nodez00;
	static obj_t BGl_cnstzd2initzd2zztrace_walkz00();
	static obj_t BGl_libraryzd2moduleszd2initz00zztrace_walkz00();
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2extern1358z62zztrace_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2setzd2exzd2it1377z62zztrace_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62findzd2lastzd2nodezd2sync1320zb0zztrace_walkz00(obj_t,
		obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zztrace_walkz00();
	static obj_t BGl_z62findzd2lastzd2nodezd2fail1334zb0zztrace_walkz00(obj_t,
		obj_t);
	static obj_t BGl_z62findzd2lastzd2nodezd2seque1318zb0zztrace_walkz00(obj_t,
		obj_t);
	extern BgL_nodez00_bglt BGl_sexpzd2ze3nodez31zzast_sexpz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62tracezd2node1345zb0zztrace_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_letzd2funzd2zzast_nodez00;
	static obj_t BGl_z62findzd2lastzd2nodezd2switc1336zb0zztrace_walkz00(obj_t,
		obj_t);
	extern bool_t BGl_userzd2symbolzf3z21zzast_identz00(obj_t);
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2letzd2var1375zb0zztrace_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_switchz00zzast_nodez00;
	extern obj_t BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00(obj_t);
	BGL_IMPORT obj_t BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(obj_t);
	extern obj_t BGl_funcallz00zzast_nodez00;
	extern obj_t BGl_globalz00zzast_varz00;
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2sync1350z62zztrace_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2fail1367z62zztrace_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t __cnst[21];


	   
		 
		DEFINE_STRING(BGl_string2120z00zztrace_walkz00,
		BgL_bgl_string2120za700za7za7t2168za7, "find-last-node1315", 18);
	      DEFINE_STRING(BGl_string2122z00zztrace_walkz00,
		BgL_bgl_string2122za700za7za7t2169za7, "trace-node1345", 14);
	      DEFINE_STRING(BGl_string2124z00zztrace_walkz00,
		BgL_bgl_string2124za700za7za7t2170za7, "toplevel-trace-node1386", 23);
	      DEFINE_STRING(BGl_string2126z00zztrace_walkz00,
		BgL_bgl_string2126za700za7za7t2171za7, "find-last-node", 14);
	      DEFINE_STRING(BGl_string2141z00zztrace_walkz00,
		BgL_bgl_string2141za700za7za7t2172za7, "trace-node", 10);
	      DEFINE_STRING(BGl_string2160z00zztrace_walkz00,
		BgL_bgl_string2160za700za7za7t2173za7, "toplevel-trace-node", 19);
	      DEFINE_STRING(BGl_string2163z00zztrace_walkz00,
		BgL_bgl_string2163za700za7za7t2174za7, "trace_walk", 10);
	      DEFINE_STRING(BGl_string2164z00zztrace_walkz00,
		BgL_bgl_string2164za700za7za7t2175za7,
		"|:| value let $env-pop-trace $env-push-trace current-dynamic-env dynamic-env quote at location env loc name aux generic-init method-init no-trace @ imported-modules-init toplevel-init pass-started ",
		197);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_tracezd2walkz12zd2envz12zztrace_walkz00,
		BgL_bgl_za762traceza7d2walkza72176za7,
		BGl_z62tracezd2walkz12za2zztrace_walkz00, 0L, BUNSPEC, 1);
	     
		DEFINE_STATIC_BGL_GENERIC(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2177za7,
		BGl_z62findzd2lastzd2nodez62zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2119z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2178za7,
		BGl_z62findzd2lastzd2node1315z62zztrace_walkz00, 0L, BUNSPEC, 1);
	     
		DEFINE_STATIC_BGL_GENERIC
		(BGl_toplevelzd2tracezd2nodezd2envzd2zztrace_walkz00,
		BgL_bgl_za762toplevelza7d2tr2179z00,
		BGl_z62toplevelzd2tracezd2nodez62zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2121z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2node12180z00,
		BGl_z62tracezd2node1345zb0zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2123z00zztrace_walkz00,
		BgL_bgl_za762toplevelza7d2tr2181z00,
		BGl_z62toplevelzd2tracezd2node1386z62zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2125z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2182za7,
		BGl_z62findzd2lastzd2nodezd2seque1318zb0zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2127z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2183za7,
		BGl_z62findzd2lastzd2nodezd2sync1320zb0zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2128z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2184za7,
		BGl_z62findzd2lastzd2nodezd2app1322zb0zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2129z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2185za7,
		BGl_z62findzd2lastzd2nodezd2appzd2l1324z62zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2130z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2186za7,
		BGl_z62findzd2lastzd2nodezd2funca1326zb0zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2131z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2187za7,
		BGl_z62findzd2lastzd2nodezd2exter1328zb0zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2132z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2188za7,
		BGl_z62findzd2lastzd2nodezd2setq1330zb0zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2133z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2189za7,
		BGl_z62findzd2lastzd2nodezd2condi1332zb0zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2134z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2190za7,
		BGl_z62findzd2lastzd2nodezd2fail1334zb0zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2135z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2191za7,
		BGl_z62findzd2lastzd2nodezd2switc1336zb0zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2136z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2192za7,
		BGl_z62findzd2lastzd2nodezd2letzd2v1338z62zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2137z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2193za7,
		BGl_z62findzd2lastzd2nodezd2letzd2f1340z62zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2138z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2194za7,
		BGl_z62findzd2lastzd2nodezd2setzd2e1342z62zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2139z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2195za7,
		BGl_z62findzd2lastzd2nodezd2jumpzd21344z62zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2140z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72196za7,
		BGl_z62tracezd2nodezd2sequence1348z62zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2142z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72197za7,
		BGl_z62tracezd2nodezd2sync1350z62zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2143z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72198za7,
		BGl_z62tracezd2nodezd2app1352z62zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2144z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72199za7,
		BGl_z62tracezd2nodezd2appzd2ly1354zb0zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2145z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72200za7,
		BGl_z62tracezd2nodezd2funcall1356z62zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2146z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72201za7,
		BGl_z62tracezd2nodezd2extern1358z62zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2147z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72202za7,
		BGl_z62tracezd2nodezd2cast1360z62zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2148z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72203za7,
		BGl_z62tracezd2nodezd2setq1362z62zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2149z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72204za7,
		BGl_z62tracezd2nodezd2condition1364z62zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2150z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72205za7,
		BGl_z62tracezd2nodezd2fail1367z62zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2151z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72206za7,
		BGl_z62tracezd2nodezd2switch1370z62zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2152z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72207za7,
		BGl_z62tracezd2nodezd2letzd2fun1372zb0zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2153z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72208za7,
		BGl_z62tracezd2nodezd2letzd2var1375zb0zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2154z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72209za7,
		BGl_z62tracezd2nodezd2setzd2exzd2it1377z62zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2155z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72210za7,
		BGl_z62tracezd2nodezd2jumpzd2exzd2i1379z62zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2156z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72211za7,
		BGl_z62tracezd2nodezd2makezd2box1381zb0zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2157z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72212za7,
		BGl_z62tracezd2nodezd2boxzd2ref1383zb0zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2158z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72213za7,
		BGl_z62tracezd2nodezd2boxzd2setz121385za2zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2159z00zztrace_walkz00,
		BgL_bgl_za762toplevelza7d2tr2214z00,
		BGl_z62toplevelzd2tracezd2nodezd21391zb0zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2161z00zztrace_walkz00,
		BgL_bgl_za762toplevelza7d2tr2215z00,
		BGl_z62toplevelzd2tracezd2nodezd21393zb0zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2162z00zztrace_walkz00,
		BgL_bgl_za762toplevelza7d2tr2216z00,
		BGl_z62toplevelzd2tracezd2nodezd21395zb0zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_GENERIC(BGl_tracezd2nodezd2envz00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72217za7,
		BGl_z62tracezd2nodezb0zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STRING(BGl_string2109z00zztrace_walkz00,
		BgL_bgl_string2109za700za7za7t2218za7, "Trace", 5);
	      DEFINE_STRING(BGl_string2110z00zztrace_walkz00,
		BgL_bgl_string2110za700za7za7t2219za7, "   . ", 5);
	      DEFINE_STRING(BGl_string2111z00zztrace_walkz00,
		BgL_bgl_string2111za700za7za7t2220za7, "failure during prelude hook", 27);
	      DEFINE_STRING(BGl_string2112z00zztrace_walkz00,
		BgL_bgl_string2112za700za7za7t2221za7, " error", 6);
	      DEFINE_STRING(BGl_string2113z00zztrace_walkz00,
		BgL_bgl_string2113za700za7za7t2222za7, "s", 1);
	      DEFINE_STRING(BGl_string2114z00zztrace_walkz00,
		BgL_bgl_string2114za700za7za7t2223za7, "", 0);
	      DEFINE_STRING(BGl_string2115z00zztrace_walkz00,
		BgL_bgl_string2115za700za7za7t2224za7, " occured, ending ...", 20);
	      DEFINE_STRING(BGl_string2116z00zztrace_walkz00,
		BgL_bgl_string2116za700za7za7t2225za7, "failure during postlude hook", 28);
	      DEFINE_STRING(BGl_string2117z00zztrace_walkz00,
		BgL_bgl_string2117za700za7za7t2226za7, "%toplevel@", 10);
	      DEFINE_STRING(BGl_string2118z00zztrace_walkz00,
		BgL_bgl_string2118za700za7za7t2227za7, "%import@", 8);

/* GC roots registration */
	static obj_t bgl_gc_roots_register()
	{
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
		void *roots_min = (void *) ULONG_MAX, *roots_max = 0;
		     ADD_ROOT((void *) (&BGl_requirezd2initializa7ationz75zztrace_walkz00));
#undef ADD_ROOT
		if   (roots_max > 0)
			     GC_add_roots(roots_min, ((void **) roots_max) + 1);
#endif
		     return BUNSPEC;
	}



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zztrace_walkz00(long
		BgL_checksumz00_2944, char *BgL_fromz00_2945)
	{
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zztrace_walkz00))
				{
					BGl_requirezd2initializa7ationz75zztrace_walkz00 =
						BBOOL(((bool_t) 0));
					BGl_gczd2rootszd2initz00zztrace_walkz00();
					BGl_libraryzd2moduleszd2initz00zztrace_walkz00();
					BGl_cnstzd2initzd2zztrace_walkz00();
					BGl_importedzd2moduleszd2initz00zztrace_walkz00();
					BGl_genericzd2initzd2zztrace_walkz00();
					BGl_methodzd2initzd2zztrace_walkz00();
					return BGl_toplevelzd2initzd2zztrace_walkz00();
				}
			else
				{
					return BUNSPEC;
				}
		}

	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zztrace_walkz00()
	{
		{	/* Trace/walk.scm 15 */
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long) 0),
				"trace_walk");
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 0),
				"trace_walk");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long) 0),
				"trace_walk");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"trace_walk");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long) 0),
				"trace_walk");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0), "trace_walk");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"trace_walk");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0), "trace_walk");
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 0),
				"trace_walk");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "trace_walk");
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 0),
				"trace_walk");
			BGl_modulezd2initializa7ationz75zz__bitz00(((long) 0), "trace_walk");
			BGl_modulezd2initializa7ationz75zz__structurez00(((long) 0),
				"trace_walk");
			BGl_modulezd2initializa7ationz75zz__biglooz00(((long) 0), "trace_walk");
			return BUNSPEC;
		}

	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zztrace_walkz00()
	{
		{	/* Trace/walk.scm 15 */
			{	/* Trace/walk.scm 15 */
				obj_t BgL_cportz00_2826;

				{	/* Trace/walk.scm 15 */
					obj_t BgL_stringz00_2834;

					BgL_stringz00_2834 = BGl_string2164z00zztrace_walkz00;
					{	/* Trace/walk.scm 15 */
						obj_t BgL_startz00_2835;

						BgL_startz00_2835 = BINT(((long) 0));
						{	/* Trace/walk.scm 15 */
							obj_t BgL_endz00_2836;

							BgL_endz00_2836 =
								BINT(STRING_LENGTH(((obj_t) BgL_stringz00_2834)));
							{	/* Trace/walk.scm 15 */

								BgL_cportz00_2826 =
									BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00
									(BgL_stringz00_2834, BgL_startz00_2835, BgL_endz00_2836);
				}}}}
				{
					long BgL_iz00_2827;

					BgL_iz00_2827 = ((long) 20);
				BgL_loopz00_2828:
					if ((BgL_iz00_2827 == ((long) -1)))
						{	/* Trace/walk.scm 15 */
							return BUNSPEC;
						}
					else
						{	/* Trace/walk.scm 15 */
							{	/* Trace/walk.scm 15 */
								obj_t BgL_arg2166z00_2830;

								{	/* Trace/walk.scm 15 */

									{	/* Trace/walk.scm 15 */
										obj_t BgL_locationz00_2832;

										BgL_locationz00_2832 = BBOOL(((bool_t) 0));
										{	/* Trace/walk.scm 15 */

											BgL_arg2166z00_2830 =
												BGl_readz00zz__readerz00(BgL_cportz00_2826,
												BgL_locationz00_2832);
										}
									}
								}
								{	/* Trace/walk.scm 15 */
									int BgL_tmpz00_2979;

									BgL_tmpz00_2979 = (int) (BgL_iz00_2827);
									CNST_TABLE_SET(BgL_tmpz00_2979, BgL_arg2166z00_2830);
							}}
							{	/* Trace/walk.scm 15 */
								int BgL_auxz00_2833;

								BgL_auxz00_2833 = (int) ((BgL_iz00_2827 - ((long) 1)));
								{
									long BgL_iz00_2984;

									BgL_iz00_2984 = (long) (BgL_auxz00_2833);
									BgL_iz00_2827 = BgL_iz00_2984;
									goto BgL_loopz00_2828;
								}
							}
						}
				}
			}
		}

	}



/* gc-roots-init */
	obj_t BGl_gczd2rootszd2initz00zztrace_walkz00()
	{
		{	/* Trace/walk.scm 15 */
			return bgl_gc_roots_register();
		}

	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zztrace_walkz00()
	{
		{	/* Trace/walk.scm 15 */
			return BUNSPEC;
		}

	}



/* trace-walk! */
	BGL_EXPORTED_DEF obj_t BGl_tracezd2walkz12zc0zztrace_walkz00(obj_t
		BgL_globalsz00_17)
	{
		{	/* Trace/walk.scm 39 */
			{	/* Trace/walk.scm 40 */
				obj_t BgL_list1453z00_1506;

				{	/* Trace/walk.scm 40 */
					obj_t BgL_arg1467z00_1507;

					{	/* Trace/walk.scm 40 */
						obj_t BgL_arg1470z00_1508;

						BgL_arg1470z00_1508 =
							MAKE_YOUNG_PAIR(BCHAR(((unsigned char) 10)), BNIL);
						BgL_arg1467z00_1507 =
							MAKE_YOUNG_PAIR(BGl_string2109z00zztrace_walkz00,
							BgL_arg1470z00_1508);
					}
					BgL_list1453z00_1506 =
						MAKE_YOUNG_PAIR(BGl_string2110z00zztrace_walkz00,
						BgL_arg1467z00_1507);
				}
				BGl_verbosez00zztools_speekz00(BINT(((long) 1)), BgL_list1453z00_1506);
			}
			BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00 = BINT(((long) 0));
			BGl_za2currentzd2passza2zd2zzengine_passz00 =
				BGl_string2109z00zztrace_walkz00;
			{	/* Trace/walk.scm 40 */
				obj_t BgL_g1106z00_1509;

				BgL_g1106z00_1509 = BNIL;
				{
					obj_t BgL_hooksz00_1512;
					obj_t BgL_hnamesz00_1513;

					BgL_hooksz00_1512 = BgL_g1106z00_1509;
					BgL_hnamesz00_1513 = BNIL;
				BgL_zc3z04anonymousza31471ze3z87_1514:
					if (NULLP(BgL_hooksz00_1512))
						{	/* Trace/walk.scm 40 */
							CNST_TABLE_REF(((long) 0));
						}
					else
						{	/* Trace/walk.scm 40 */
							bool_t BgL_test2231z00_2997;

							{	/* Trace/walk.scm 40 */
								obj_t BgL_fun1490z00_1521;

								BgL_fun1490z00_1521 = CAR(((obj_t) BgL_hooksz00_1512));
								BgL_test2231z00_2997 =
									CBOOL(PROCEDURE_ENTRY(BgL_fun1490z00_1521)
									(BgL_fun1490z00_1521, BEOA));
							}
							if (BgL_test2231z00_2997)
								{	/* Trace/walk.scm 40 */
									obj_t BgL_arg1486z00_1518;
									obj_t BgL_arg1488z00_1519;

									BgL_arg1486z00_1518 = CDR(((obj_t) BgL_hooksz00_1512));
									BgL_arg1488z00_1519 = CDR(((obj_t) BgL_hnamesz00_1513));
									{
										obj_t BgL_hnamesz00_3009;
										obj_t BgL_hooksz00_3008;

										BgL_hooksz00_3008 = BgL_arg1486z00_1518;
										BgL_hnamesz00_3009 = BgL_arg1488z00_1519;
										BgL_hnamesz00_1513 = BgL_hnamesz00_3009;
										BgL_hooksz00_1512 = BgL_hooksz00_3008;
										goto BgL_zc3z04anonymousza31471ze3z87_1514;
									}
								}
							else
								{	/* Trace/walk.scm 40 */
									obj_t BgL_arg1489z00_1520;

									BgL_arg1489z00_1520 = CAR(((obj_t) BgL_hnamesz00_1513));
									BGl_internalzd2errorzd2zztools_errorz00
										(BGl_string2109z00zztrace_walkz00,
										BGl_string2111z00zztrace_walkz00, BgL_arg1489z00_1520);
								}
						}
				}
			}
			{	/* Trace/walk.scm 46 */
				obj_t BgL_idz00_1524;

				BgL_idz00_1524 = CNST_TABLE_REF(((long) 1));
				{	/* Trace/walk.scm 46 */
					obj_t BgL_gloz00_1525;

					{	/* Trace/walk.scm 47 */
						obj_t BgL_list1494z00_1529;

						BgL_list1494z00_1529 =
							MAKE_YOUNG_PAIR(BGl_za2moduleza2z00zzmodule_modulez00, BNIL);
						BgL_gloz00_1525 =
							BGl_findzd2globalzd2zzast_envz00(BgL_idz00_1524,
							BgL_list1494z00_1529);
					}
					{	/* Trace/walk.scm 47 */

						if (BGl_isazf3zf3zz__objectz00(BgL_gloz00_1525,
								BGl_globalz00zzast_varz00))
							{	/* Trace/walk.scm 49 */
								BgL_sfunz00_bglt BgL_i1108z00_1527;

								BgL_i1108z00_1527 =
									((BgL_sfunz00_bglt)
									(((BgL_variablez00_bglt) COBJECT(
												((BgL_variablez00_bglt)
													((BgL_globalz00_bglt) BgL_gloz00_1525))))->
										BgL_valuez00));
								{
									obj_t BgL_auxz00_3022;

									{	/* Trace/walk.scm 50 */
										obj_t BgL_arg1493z00_1528;

										BgL_arg1493z00_1528 =
											(((BgL_sfunz00_bglt) COBJECT(BgL_i1108z00_1527))->
											BgL_bodyz00);
										BgL_auxz00_3022 =
											((obj_t)
											BGl_toplevelzd2tracezd2nodez00zztrace_walkz00((
													(BgL_nodez00_bglt) BgL_arg1493z00_1528)));
									}
									((((BgL_sfunz00_bglt) COBJECT(BgL_i1108z00_1527))->
											BgL_bodyz00) = ((obj_t) BgL_auxz00_3022), BUNSPEC);
								}
							}
						else
							{	/* Trace/walk.scm 48 */
								BFALSE;
							}
					}
				}
			}
			{
				obj_t BgL_l1303z00_1531;

				BgL_l1303z00_1531 = BgL_globalsz00_17;
			BgL_zc3z04anonymousza31495ze3z87_1532:
				if (PAIRP(BgL_l1303z00_1531))
					{	/* Trace/walk.scm 52 */
						{	/* Trace/walk.scm 52 */
							obj_t BgL_vz00_1534;

							BgL_vz00_1534 = CAR(BgL_l1303z00_1531);
							BGl_tracezd2funz12zc0zztrace_walkz00(BgL_vz00_1534, BNIL,
								BGl_za2compilerzd2debugzd2traceza2z00zzengine_paramz00);
						}
						{
							obj_t BgL_l1303z00_3032;

							BgL_l1303z00_3032 = CDR(BgL_l1303z00_1531);
							BgL_l1303z00_1531 = BgL_l1303z00_3032;
							goto BgL_zc3z04anonymousza31495ze3z87_1532;
						}
					}
				else
					{	/* Trace/walk.scm 52 */
						((bool_t) 1);
					}
			}
			if (
				((long) CINT(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00) >
					((long) 0)))
				{	/* Trace/walk.scm 53 */
					{	/* Trace/walk.scm 53 */
						obj_t BgL_port1305z00_1539;

						{	/* Trace/walk.scm 53 */
							obj_t BgL_res2027z00_2349;

							{	/* Trace/walk.scm 53 */
								obj_t BgL_tmpz00_3037;

								BgL_tmpz00_3037 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_res2027z00_2349 =
									BGL_ENV_CURRENT_ERROR_PORT(BgL_tmpz00_3037);
							}
							BgL_port1305z00_1539 = BgL_res2027z00_2349;
						}
						bgl_display_obj(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00,
							BgL_port1305z00_1539);
						bgl_display_string(BGl_string2112z00zztrace_walkz00,
							BgL_port1305z00_1539);
						{	/* Trace/walk.scm 53 */
							obj_t BgL_arg1506z00_1540;

							{	/* Trace/walk.scm 53 */
								bool_t BgL_test2235z00_3042;

								if (BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00
									(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00))
									{	/* Trace/walk.scm 53 */
										if (INTEGERP
											(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00))
											{	/* Trace/walk.scm 53 */
												BgL_test2235z00_3042 =
													(
													(long)
													CINT
													(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00)
													> ((long) 1));
											}
										else
											{	/* Trace/walk.scm 53 */
												BgL_test2235z00_3042 =
													BGl_2ze3ze3zz__r4_numbers_6_5z00
													(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00,
													BINT(((long) 1)));
									}}
								else
									{	/* Trace/walk.scm 53 */
										BgL_test2235z00_3042 = ((bool_t) 0);
									}
								if (BgL_test2235z00_3042)
									{	/* Trace/walk.scm 53 */
										BgL_arg1506z00_1540 = BGl_string2113z00zztrace_walkz00;
									}
								else
									{	/* Trace/walk.scm 53 */
										BgL_arg1506z00_1540 = BGl_string2114z00zztrace_walkz00;
									}
							}
							bgl_display_obj(BgL_arg1506z00_1540, BgL_port1305z00_1539);
						}
						bgl_display_string(BGl_string2115z00zztrace_walkz00,
							BgL_port1305z00_1539);
						bgl_display_char(((unsigned char) 10), BgL_port1305z00_1539);
					}
					{	/* Trace/walk.scm 53 */
						obj_t BgL_list1511z00_1546;

						BgL_list1511z00_1546 = MAKE_YOUNG_PAIR(BINT(((long) -1)), BNIL);
						return BGl_exitz00zz__errorz00(BgL_list1511z00_1546);
					}
				}
			else
				{	/* Trace/walk.scm 53 */
					obj_t BgL_g1112z00_1547;

					BgL_g1112z00_1547 = BNIL;
					{
						obj_t BgL_hooksz00_1550;
						obj_t BgL_hnamesz00_1551;

						BgL_hooksz00_1550 = BgL_g1112z00_1547;
						BgL_hnamesz00_1551 = BNIL;
					BgL_zc3z04anonymousza31512ze3z87_1552:
						if (NULLP(BgL_hooksz00_1550))
							{	/* Trace/walk.scm 53 */
								return BgL_globalsz00_17;
							}
						else
							{	/* Trace/walk.scm 53 */
								bool_t BgL_test2239z00_3059;

								{	/* Trace/walk.scm 53 */
									obj_t BgL_fun1526z00_1559;

									BgL_fun1526z00_1559 = CAR(((obj_t) BgL_hooksz00_1550));
									BgL_test2239z00_3059 =
										CBOOL(PROCEDURE_ENTRY(BgL_fun1526z00_1559)
										(BgL_fun1526z00_1559, BEOA));
								}
								if (BgL_test2239z00_3059)
									{	/* Trace/walk.scm 53 */
										obj_t BgL_arg1520z00_1556;
										obj_t BgL_arg1521z00_1557;

										BgL_arg1520z00_1556 = CDR(((obj_t) BgL_hooksz00_1550));
										BgL_arg1521z00_1557 = CDR(((obj_t) BgL_hnamesz00_1551));
										{
											obj_t BgL_hnamesz00_3071;
											obj_t BgL_hooksz00_3070;

											BgL_hooksz00_3070 = BgL_arg1520z00_1556;
											BgL_hnamesz00_3071 = BgL_arg1521z00_1557;
											BgL_hnamesz00_1551 = BgL_hnamesz00_3071;
											BgL_hooksz00_1550 = BgL_hooksz00_3070;
											goto BgL_zc3z04anonymousza31512ze3z87_1552;
										}
									}
								else
									{	/* Trace/walk.scm 53 */
										obj_t BgL_arg1523z00_1558;

										BgL_arg1523z00_1558 = CAR(((obj_t) BgL_hnamesz00_1551));
										return
											BGl_internalzd2errorzd2zztools_errorz00
											(BGl_za2currentzd2passza2zd2zzengine_passz00,
											BGl_string2116z00zztrace_walkz00, BgL_arg1523z00_1558);
									}
							}
					}
				}
		}

	}



/* &trace-walk! */
	obj_t BGl_z62tracezd2walkz12za2zztrace_walkz00(obj_t BgL_envz00_2663,
		obj_t BgL_globalsz00_2664)
	{
		{	/* Trace/walk.scm 39 */
			return BGl_tracezd2walkz12zc0zztrace_walkz00(BgL_globalsz00_2664);
		}

	}



/* trace-id */
	obj_t BGl_tracezd2idzd2zztrace_walkz00(obj_t BgL_vz00_18)
	{
		{	/* Trace/walk.scm 64 */
			{	/* Trace/walk.scm 66 */
				bool_t BgL_test2240z00_3076;

				if (BGl_isazf3zf3zz__objectz00(BgL_vz00_18, BGl_globalz00zzast_varz00))
					{	/* Trace/walk.scm 66 */
						BgL_test2240z00_3076 =
							(
							(((BgL_variablez00_bglt) COBJECT(
										((BgL_variablez00_bglt)
											((BgL_globalz00_bglt) BgL_vz00_18))))->BgL_idz00) ==
							CNST_TABLE_REF(((long) 1)));
					}
				else
					{	/* Trace/walk.scm 66 */
						BgL_test2240z00_3076 = ((bool_t) 0);
					}
				if (BgL_test2240z00_3076)
					{	/* Trace/walk.scm 67 */
						obj_t BgL_arg1536z00_1565;

						{	/* Trace/walk.scm 67 */
							obj_t BgL_arg1540z00_1566;
							obj_t BgL_arg1541z00_1567;

							{	/* Trace/walk.scm 67 */
								obj_t BgL_arg1544z00_1568;

								BgL_arg1544z00_1568 =
									bstring_to_symbol(BGl_string2117z00zztrace_walkz00);
								{	/* Trace/walk.scm 67 */
									obj_t BgL_res2034z00_2371;

									{	/* Trace/walk.scm 67 */
										obj_t BgL_arg1409z00_2370;

										BgL_arg1409z00_2370 = SYMBOL_TO_STRING(BgL_arg1544z00_1568);
										BgL_res2034z00_2371 =
											BGl_stringzd2copyzd2zz__r4_strings_6_7z00
											(BgL_arg1409z00_2370);
									}
									BgL_arg1540z00_1566 = BgL_res2034z00_2371;
								}
							}
							{	/* Trace/walk.scm 67 */
								obj_t BgL_arg1550z00_1569;

								BgL_arg1550z00_1569 =
									(((BgL_globalz00_bglt) COBJECT(
											((BgL_globalz00_bglt) BgL_vz00_18)))->BgL_modulez00);
								{	/* Trace/walk.scm 67 */
									obj_t BgL_res2035z00_2375;

									{	/* Trace/walk.scm 67 */
										obj_t BgL_arg1409z00_2374;

										BgL_arg1409z00_2374 = SYMBOL_TO_STRING(BgL_arg1550z00_1569);
										BgL_res2035z00_2375 =
											BGl_stringzd2copyzd2zz__r4_strings_6_7z00
											(BgL_arg1409z00_2374);
									}
									BgL_arg1541z00_1567 = BgL_res2035z00_2375;
								}
							}
							BgL_arg1536z00_1565 =
								string_append(BgL_arg1540z00_1566, BgL_arg1541z00_1567);
						}
						return bstring_to_symbol(BgL_arg1536z00_1565);
					}
				else
					{	/* Trace/walk.scm 68 */
						bool_t BgL_test2242z00_3093;

						if (BGl_isazf3zf3zz__objectz00(BgL_vz00_18,
								BGl_globalz00zzast_varz00))
							{	/* Trace/walk.scm 68 */
								BgL_test2242z00_3093 =
									(
									(((BgL_variablez00_bglt) COBJECT(
												((BgL_variablez00_bglt)
													((BgL_globalz00_bglt) BgL_vz00_18))))->BgL_idz00) ==
									CNST_TABLE_REF(((long) 2)));
							}
						else
							{	/* Trace/walk.scm 68 */
								BgL_test2242z00_3093 = ((bool_t) 0);
							}
						if (BgL_test2242z00_3093)
							{	/* Trace/walk.scm 69 */
								obj_t BgL_arg1558z00_1573;

								{	/* Trace/walk.scm 69 */
									obj_t BgL_arg1559z00_1574;
									obj_t BgL_arg1563z00_1575;

									{	/* Trace/walk.scm 69 */
										obj_t BgL_arg1564z00_1576;

										BgL_arg1564z00_1576 =
											bstring_to_symbol(BGl_string2118z00zztrace_walkz00);
										{	/* Trace/walk.scm 69 */
											obj_t BgL_res2039z00_2384;

											{	/* Trace/walk.scm 69 */
												obj_t BgL_arg1409z00_2383;

												BgL_arg1409z00_2383 =
													SYMBOL_TO_STRING(BgL_arg1564z00_1576);
												BgL_res2039z00_2384 =
													BGl_stringzd2copyzd2zz__r4_strings_6_7z00
													(BgL_arg1409z00_2383);
											}
											BgL_arg1559z00_1574 = BgL_res2039z00_2384;
										}
									}
									{	/* Trace/walk.scm 69 */
										obj_t BgL_arg1568z00_1577;

										BgL_arg1568z00_1577 =
											(((BgL_globalz00_bglt) COBJECT(
													((BgL_globalz00_bglt) BgL_vz00_18)))->BgL_modulez00);
										{	/* Trace/walk.scm 69 */
											obj_t BgL_res2040z00_2388;

											{	/* Trace/walk.scm 69 */
												obj_t BgL_arg1409z00_2387;

												BgL_arg1409z00_2387 =
													SYMBOL_TO_STRING(BgL_arg1568z00_1577);
												BgL_res2040z00_2388 =
													BGl_stringzd2copyzd2zz__r4_strings_6_7z00
													(BgL_arg1409z00_2387);
											}
											BgL_arg1563z00_1575 = BgL_res2040z00_2388;
										}
									}
									BgL_arg1558z00_1573 =
										string_append(BgL_arg1559z00_1574, BgL_arg1563z00_1575);
								}
								return bstring_to_symbol(BgL_arg1558z00_1573);
							}
						else
							{	/* Trace/walk.scm 68 */
								if (BGl_isazf3zf3zz__objectz00(BgL_vz00_18,
										BGl_globalz00zzast_varz00))
									{	/* Trace/walk.scm 71 */
										obj_t BgL_arg1573z00_1579;
										obj_t BgL_arg1574z00_1580;

										BgL_arg1573z00_1579 =
											(((BgL_variablez00_bglt) COBJECT(
													((BgL_variablez00_bglt)
														((BgL_globalz00_bglt) BgL_vz00_18))))->BgL_idz00);
										BgL_arg1574z00_1580 =
											(((BgL_globalz00_bglt) COBJECT(
													((BgL_globalz00_bglt) BgL_vz00_18)))->BgL_modulez00);
										{	/* Trace/walk.scm 71 */
											obj_t BgL_list1575z00_1581;

											{	/* Trace/walk.scm 71 */
												obj_t BgL_arg1578z00_1582;

												{	/* Trace/walk.scm 71 */
													obj_t BgL_arg1579z00_1583;

													BgL_arg1579z00_1583 =
														MAKE_YOUNG_PAIR(BgL_arg1574z00_1580, BNIL);
													BgL_arg1578z00_1582 =
														MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 3)),
														BgL_arg1579z00_1583);
												}
												BgL_list1575z00_1581 =
													MAKE_YOUNG_PAIR(BgL_arg1573z00_1579,
													BgL_arg1578z00_1582);
											}
											return
												BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00
												(BgL_list1575z00_1581);
										}
									}
								else
									{	/* Trace/walk.scm 70 */
										return
											(((BgL_variablez00_bglt) COBJECT(
													((BgL_variablez00_bglt) BgL_vz00_18)))->BgL_idz00);
									}
							}
					}
			}
		}

	}



/* trace-fun! */
	obj_t BGl_tracezd2funz12zc0zztrace_walkz00(obj_t BgL_varz00_19,
		obj_t BgL_stackz00_20, obj_t BgL_levelz00_21)
	{
		{	/* Trace/walk.scm 81 */
			{	/* Trace/walk.scm 82 */
				BgL_valuez00_bglt BgL_funz00_1588;

				BgL_funz00_1588 =
					(((BgL_variablez00_bglt) COBJECT(
							((BgL_variablez00_bglt) BgL_varz00_19)))->BgL_valuez00);
				{	/* Trace/walk.scm 82 */
					obj_t BgL_bodyz00_1589;

					BgL_bodyz00_1589 =
						(((BgL_sfunz00_bglt) COBJECT(
								((BgL_sfunz00_bglt) BgL_funz00_1588)))->BgL_bodyz00);
					{	/* Trace/walk.scm 83 */
						obj_t BgL_llocz00_1590;

						if (BGl_isazf3zf3zz__objectz00(BgL_varz00_19,
								BGl_globalz00zzast_varz00))
							{	/* Trace/walk.scm 85 */
								obj_t BgL_arg1663z00_1637;

								BgL_arg1663z00_1637 =
									BGl_findzd2lastzd2sexpz00zztrace_walkz00(
									(((BgL_globalz00_bglt) COBJECT(
												((BgL_globalz00_bglt) BgL_varz00_19)))->BgL_srcz00));
								BgL_llocz00_1590 =
									BGl_findzd2locationzd2zztools_locationz00
									(BgL_arg1663z00_1637);
							}
						else
							{	/* Trace/walk.scm 86 */
								obj_t BgL_arg1668z00_1639;

								BgL_arg1668z00_1639 =
									BGl_findzd2lastzd2nodez00zztrace_walkz00(
									((BgL_nodez00_bglt) BgL_bodyz00_1589));
								BgL_llocz00_1590 =
									(((BgL_nodez00_bglt) COBJECT(
											((BgL_nodez00_bglt) BgL_arg1668z00_1639)))->BgL_locz00);
							}
						{	/* Trace/walk.scm 84 */

							{	/* Trace/walk.scm 87 */
								bool_t BgL_test2246z00_3138;

								if (CBOOL(
										(((BgL_funz00_bglt) COBJECT(
													((BgL_funz00_bglt) BgL_funz00_1588)))->
											BgL_predicatezd2ofzd2)))
									{	/* Trace/walk.scm 87 */
										BgL_test2246z00_3138 = ((bool_t) 0);
									}
								else
									{	/* Trace/walk.scm 87 */
										if (CBOOL(BGl_memqz00zz__r4_pairs_and_lists_6_3z00
												(CNST_TABLE_REF(((long) 4)),
													(((BgL_sfunz00_bglt) COBJECT(((BgL_sfunz00_bglt)
																	BgL_funz00_1588)))->BgL_propertyz00))))
											{	/* Trace/walk.scm 88 */
												BgL_test2246z00_3138 = ((bool_t) 0);
											}
										else
											{	/* Trace/walk.scm 89 */
												obj_t BgL_arg1656z00_1634;

												BgL_arg1656z00_1634 =
													(((BgL_variablez00_bglt) COBJECT(
															((BgL_variablez00_bglt) BgL_varz00_19)))->
													BgL_idz00);
												BgL_test2246z00_3138 =
													BGl_userzd2symbolzf3z21zzast_identz00
													(BgL_arg1656z00_1634);
											}
									}
								if (BgL_test2246z00_3138)
									{	/* Trace/walk.scm 87 */
										BGl_enterzd2functionzd2zztools_errorz00
											(BGl_tracezd2idzd2zztrace_walkz00(BgL_varz00_19));
										{	/* Trace/walk.scm 91 */
											obj_t BgL_bdz00_1598;

											{	/* Trace/walk.scm 91 */
												bool_t BgL_test2249z00_3154;

												if (((long) CINT(BgL_levelz00_21) > ((long) 1)))
													{	/* Trace/walk.scm 91 */
														BgL_test2249z00_3154 = ((bool_t) 1);
													}
												else
													{	/* Trace/walk.scm 91 */
														if (BGl_isazf3zf3zz__objectz00(BgL_varz00_19,
																BGl_globalz00zzast_varz00))
															{	/* Trace/walk.scm 93 */
																bool_t BgL__ortest_1115z00_1627;

																BgL__ortest_1115z00_1627 =
																	(
																	(((BgL_variablez00_bglt) COBJECT(
																				((BgL_variablez00_bglt)
																					((BgL_globalz00_bglt)
																						BgL_varz00_19))))->BgL_idz00) ==
																	CNST_TABLE_REF(((long) 1)));
																if (BgL__ortest_1115z00_1627)
																	{	/* Trace/walk.scm 93 */
																		BgL_test2249z00_3154 =
																			BgL__ortest_1115z00_1627;
																	}
																else
																	{	/* Trace/walk.scm 94 */
																		bool_t BgL__ortest_1116z00_1628;

																		BgL__ortest_1116z00_1628 =
																			(
																			(((BgL_variablez00_bglt) COBJECT(
																						((BgL_variablez00_bglt)
																							((BgL_globalz00_bglt)
																								BgL_varz00_19))))->BgL_idz00) ==
																			CNST_TABLE_REF(((long) 5)));
																		if (BgL__ortest_1116z00_1628)
																			{	/* Trace/walk.scm 94 */
																				BgL_test2249z00_3154 =
																					BgL__ortest_1116z00_1628;
																			}
																		else
																			{	/* Trace/walk.scm 94 */
																				BgL_test2249z00_3154 =
																					(
																					(((BgL_variablez00_bglt) COBJECT(
																								((BgL_variablez00_bglt)
																									((BgL_globalz00_bglt)
																										BgL_varz00_19))))->
																						BgL_idz00) ==
																					CNST_TABLE_REF(((long) 6)));
															}}}
														else
															{	/* Trace/walk.scm 92 */
																BgL_test2249z00_3154 = ((bool_t) 0);
															}
													}
												if (BgL_test2249z00_3154)
													{	/* Trace/walk.scm 103 */
														bool_t BgL_test2254z00_3177;

														if (BGl_isazf3zf3zz__objectz00(BgL_varz00_19,
																BGl_localz00zzast_varz00))
															{	/* Trace/walk.scm 103 */
																BgL_test2254z00_3177 = ((bool_t) 1);
															}
														else
															{	/* Trace/walk.scm 103 */
																if (
																	((((BgL_variablez00_bglt) COBJECT(
																					((BgL_variablez00_bglt)
																						((BgL_globalz00_bglt)
																							BgL_varz00_19))))->BgL_idz00) ==
																		CNST_TABLE_REF(((long) 5))))
																	{	/* Trace/walk.scm 104 */
																		BgL_test2254z00_3177 = ((bool_t) 1);
																	}
																else
																	{	/* Trace/walk.scm 104 */
																		BgL_test2254z00_3177 =
																			(
																			(((BgL_variablez00_bglt) COBJECT(
																						((BgL_variablez00_bglt)
																							((BgL_globalz00_bglt)
																								BgL_varz00_19))))->BgL_idz00) ==
																			CNST_TABLE_REF(((long) 6)));
															}}
														if (BgL_test2254z00_3177)
															{	/* Trace/walk.scm 106 */
																long BgL_arg1644z00_1618;

																BgL_arg1644z00_1618 =
																	((long) CINT(BgL_levelz00_21) - ((long) 1));
																BgL_bdz00_1598 =
																	((obj_t)
																	BGl_tracezd2nodezd2zztrace_walkz00(
																		((BgL_nodez00_bglt) BgL_bodyz00_1589),
																		BgL_stackz00_20,
																		BINT(BgL_arg1644z00_1618)));
															}
														else
															{	/* Trace/walk.scm 107 */
																obj_t BgL_arg1645z00_1619;
																long BgL_arg1647z00_1620;

																BgL_arg1645z00_1619 =
																	MAKE_YOUNG_PAIR(BgL_varz00_19,
																	BgL_stackz00_20);
																BgL_arg1647z00_1620 =
																	((long) CINT(BgL_levelz00_21) - ((long) 1));
																BgL_bdz00_1598 =
																	((obj_t)
																	BGl_tracezd2nodezd2zztrace_walkz00((
																			(BgL_nodez00_bglt) BgL_bodyz00_1589),
																		BgL_arg1645z00_1619,
																		BINT(BgL_arg1647z00_1620)));
													}}
												else
													{	/* Trace/walk.scm 91 */
														BgL_bdz00_1598 = BgL_bodyz00_1589;
													}
											}
											{	/* Trace/walk.scm 91 */
												BgL_typez00_bglt BgL_tz00_1599;

												{	/* Trace/walk.scm 109 */
													BgL_typez00_bglt BgL_arg1613z00_1602;
													BgL_typez00_bglt BgL_arg1618z00_1603;

													BgL_arg1613z00_1602 =
														(((BgL_nodez00_bglt) COBJECT(
																((BgL_nodez00_bglt) BgL_bodyz00_1589)))->
														BgL_typez00);
													BgL_arg1618z00_1603 =
														(((BgL_variablez00_bglt)
															COBJECT(((BgL_variablez00_bglt) BgL_varz00_19)))->
														BgL_typez00);
													BgL_tz00_1599 =
														BGl_strictzd2nodezd2typez00zzast_nodez00
														(BgL_arg1613z00_1602, BgL_arg1618z00_1603);
												}
												{	/* Trace/walk.scm 109 */
													obj_t BgL_idz00_1600;

													BgL_idz00_1600 =
														BGl_tracezd2idzd2zztrace_walkz00(BgL_varz00_19);
													{	/* Trace/walk.scm 110 */
														BgL_letzd2varzd2_bglt BgL_nbodyz00_1601;

														BgL_nbodyz00_1601 =
															BGl_makezd2tracedzd2nodez00zztrace_walkz00(
															((BgL_nodez00_bglt) BgL_bdz00_1598),
															BgL_tz00_1599, BgL_idz00_1600, BgL_llocz00_1590,
															BgL_stackz00_20);
														{	/* Trace/walk.scm 111 */

															((((BgL_sfunz00_bglt) COBJECT(
																			((BgL_sfunz00_bglt) BgL_funz00_1588)))->
																	BgL_bodyz00) =
																((obj_t) ((obj_t) BgL_nbodyz00_1601)), BUNSPEC);
															return BGl_leavezd2functionzd2zztools_errorz00();
														}
													}
												}
											}
										}
									}
								else
									{	/* Trace/walk.scm 87 */
										return BFALSE;
									}
							}
						}
					}
				}
			}
		}

	}



/* find-last-sexp */
	obj_t BGl_findzd2lastzd2sexpz00zztrace_walkz00(obj_t BgL_sexpz00_22)
	{
		{	/* Trace/walk.scm 122 */
			{
				obj_t BgL_sexpz00_1641;
				obj_t BgL_resz00_1642;

				BgL_sexpz00_1641 = BgL_sexpz00_22;
				BgL_resz00_1642 = BgL_sexpz00_22;
			BgL_zc3z04anonymousza31669ze3z87_1643:
				if (PAIRP(BgL_sexpz00_1641))
					{	/* Trace/walk.scm 128 */
						bool_t BgL_test2258z00_3218;

						{	/* Trace/walk.scm 128 */
							obj_t BgL_tmpz00_3219;

							BgL_tmpz00_3219 = CDR(BgL_sexpz00_1641);
							BgL_test2258z00_3218 = PAIRP(BgL_tmpz00_3219);
						}
						if (BgL_test2258z00_3218)
							{
								obj_t BgL_resz00_3224;
								obj_t BgL_sexpz00_3222;

								BgL_sexpz00_3222 =
									BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00
									(BgL_sexpz00_1641);
								BgL_resz00_3224 = BgL_sexpz00_1641;
								BgL_resz00_1642 = BgL_resz00_3224;
								BgL_sexpz00_1641 = BgL_sexpz00_3222;
								goto BgL_zc3z04anonymousza31669ze3z87_1643;
							}
						else
							{
								obj_t BgL_resz00_3227;
								obj_t BgL_sexpz00_3225;

								BgL_sexpz00_3225 = CAR(BgL_sexpz00_1641);
								BgL_resz00_3227 = BgL_sexpz00_1641;
								BgL_resz00_1642 = BgL_resz00_3227;
								BgL_sexpz00_1641 = BgL_sexpz00_3225;
								goto BgL_zc3z04anonymousza31669ze3z87_1643;
							}
					}
				else
					{	/* Trace/walk.scm 126 */
						return BgL_resz00_1642;
					}
			}
		}

	}



/* make-traced-node */
	BgL_letzd2varzd2_bglt
		BGl_makezd2tracedzd2nodez00zztrace_walkz00(BgL_nodez00_bglt BgL_nodez00_38,
		BgL_typez00_bglt BgL_typez00_39, obj_t BgL_symbolz00_40,
		obj_t BgL_llocz00_41, obj_t BgL_stackz00_42)
	{
		{	/* Trace/walk.scm 245 */
			{	/* Trace/walk.scm 252 */
				obj_t BgL_locz00_1652;

				BgL_locz00_1652 =
					(((BgL_nodez00_bglt) COBJECT(BgL_nodez00_38))->BgL_locz00);
				{	/* Trace/walk.scm 252 */
					obj_t BgL_auxz00_1653;

					BgL_auxz00_1653 =
						BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
						(BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 7))));
					{	/* Trace/walk.scm 253 */
						obj_t BgL_tauxz00_1654;

						BgL_tauxz00_1654 =
							BGl_makezd2typedzd2identz00zzast_identz00(BgL_auxz00_1653,
							(((BgL_typez00_bglt) COBJECT(BgL_typez00_39))->BgL_idz00));
						{	/* Trace/walk.scm 254 */
							obj_t BgL_tmp1z00_1655;

							BgL_tmp1z00_1655 =
								BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
								(BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long)
											8))));
							{	/* Trace/walk.scm 255 */
								obj_t BgL_tmp2z00_1656;

								BgL_tmp2z00_1656 =
									BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
									(BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long)
												9))));
								{	/* Trace/walk.scm 256 */
									obj_t BgL_tmp3z00_1657;

									BgL_tmp3z00_1657 =
										BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
										(BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long)
													10))));
									{	/* Trace/walk.scm 257 */
										obj_t BgL_symz00_1658;

										{	/* Trace/walk.scm 258 */
											bool_t BgL_test2259z00_3243;

											if (PAIRP(BgL_stackz00_42))
												{	/* Trace/walk.scm 258 */
													obj_t BgL_arg1778z00_1709;

													BgL_arg1778z00_1709 = CAR(BgL_stackz00_42);
													BgL_test2259z00_3243 =
														BGl_isazf3zf3zz__objectz00(BgL_arg1778z00_1709,
														BGl_variablez00zzast_varz00);
												}
											else
												{	/* Trace/walk.scm 258 */
													BgL_test2259z00_3243 = ((bool_t) 0);
												}
											if (BgL_test2259z00_3243)
												{	/* Trace/walk.scm 258 */
													BgL_symz00_1658 =
														BGl_fqnameze70ze7zztrace_walkz00(BgL_symbolz00_40,
														BgL_stackz00_42);
												}
											else
												{	/* Trace/walk.scm 258 */
													BgL_symz00_1658 = BgL_symbolz00_40;
												}
										}
										{	/* Trace/walk.scm 258 */
											obj_t BgL_lz00_1659;

											{	/* Trace/walk.scm 262 */
												bool_t BgL_test2261z00_3249;

												if (STRUCTP(BgL_locz00_1652))
													{	/* Trace/walk.scm 262 */
														BgL_test2261z00_3249 =
															(STRUCT_KEY(BgL_locz00_1652) ==
															CNST_TABLE_REF(((long) 11)));
													}
												else
													{	/* Trace/walk.scm 262 */
														BgL_test2261z00_3249 = ((bool_t) 0);
													}
												if (BgL_test2261z00_3249)
													{	/* Trace/walk.scm 263 */
														obj_t BgL_arg1770z00_1701;

														{	/* Trace/walk.scm 263 */
															obj_t BgL_arg1771z00_1702;
															obj_t BgL_arg1772z00_1703;

															BgL_arg1771z00_1702 =
																BGl_locationzd2fullzd2fnamez00zztools_locationz00
																(BgL_locz00_1652);
															BgL_arg1772z00_1703 =
																MAKE_YOUNG_PAIR(STRUCT_REF(BgL_locz00_1652,
																	(int) (((long) 1))), BNIL);
															BgL_arg1770z00_1701 =
																MAKE_YOUNG_PAIR(BgL_arg1771z00_1702,
																BgL_arg1772z00_1703);
														}
														BgL_lz00_1659 =
															MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 12)),
															BgL_arg1770z00_1701);
													}
												else
													{	/* Trace/walk.scm 262 */
														BgL_lz00_1659 = BFALSE;
													}
											}
											{	/* Trace/walk.scm 262 */
												obj_t BgL_expz00_1660;

												{	/* Trace/walk.scm 264 */
													obj_t BgL_arg1681z00_1664;

													{	/* Trace/walk.scm 264 */
														obj_t BgL_arg1687z00_1665;
														obj_t BgL_arg1688z00_1666;

														{	/* Trace/walk.scm 264 */
															obj_t BgL_arg1691z00_1667;
															obj_t BgL_arg1692z00_1668;

															{	/* Trace/walk.scm 264 */
																obj_t BgL_arg1693z00_1669;

																{	/* Trace/walk.scm 264 */
																	obj_t BgL_arg1694z00_1670;

																	{	/* Trace/walk.scm 264 */
																		obj_t BgL_arg1695z00_1671;

																		BgL_arg1695z00_1671 =
																			MAKE_YOUNG_PAIR(BgL_symz00_1658, BNIL);
																		BgL_arg1694z00_1670 =
																			MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long)
																					13)), BgL_arg1695z00_1671);
																	}
																	BgL_arg1693z00_1669 =
																		MAKE_YOUNG_PAIR(BgL_arg1694z00_1670, BNIL);
																}
																BgL_arg1691z00_1667 =
																	MAKE_YOUNG_PAIR(BgL_tmp1z00_1655,
																	BgL_arg1693z00_1669);
															}
															{	/* Trace/walk.scm 265 */
																obj_t BgL_arg1697z00_1672;
																obj_t BgL_arg1702z00_1673;

																{	/* Trace/walk.scm 265 */
																	obj_t BgL_arg1703z00_1674;

																	{	/* Trace/walk.scm 265 */
																		obj_t BgL_arg1710z00_1675;

																		{	/* Trace/walk.scm 265 */
																			obj_t BgL_arg1713z00_1676;

																			BgL_arg1713z00_1676 =
																				MAKE_YOUNG_PAIR(BgL_lz00_1659, BNIL);
																			BgL_arg1710z00_1675 =
																				MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long)
																						13)), BgL_arg1713z00_1676);
																		}
																		BgL_arg1703z00_1674 =
																			MAKE_YOUNG_PAIR(BgL_arg1710z00_1675,
																			BNIL);
																	}
																	BgL_arg1697z00_1672 =
																		MAKE_YOUNG_PAIR(BgL_tmp2z00_1656,
																		BgL_arg1703z00_1674);
																}
																{	/* Trace/walk.scm 266 */
																	obj_t BgL_arg1714z00_1677;

																	{	/* Trace/walk.scm 266 */
																		obj_t BgL_arg1717z00_1678;
																		obj_t BgL_arg1723z00_1679;

																		BgL_arg1717z00_1678 =
																			BGl_makezd2typedzd2identz00zzast_identz00
																			(BgL_tmp3z00_1657,
																			CNST_TABLE_REF(((long) 14)));
																		{	/* Trace/walk.scm 266 */
																			obj_t BgL_arg1731z00_1680;

																			BgL_arg1731z00_1680 =
																				MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long)
																						15)), BNIL);
																			BgL_arg1723z00_1679 =
																				MAKE_YOUNG_PAIR(BgL_arg1731z00_1680,
																				BNIL);
																		}
																		BgL_arg1714z00_1677 =
																			MAKE_YOUNG_PAIR(BgL_arg1717z00_1678,
																			BgL_arg1723z00_1679);
																	}
																	BgL_arg1702z00_1673 =
																		MAKE_YOUNG_PAIR(BgL_arg1714z00_1677, BNIL);
																}
																BgL_arg1692z00_1668 =
																	MAKE_YOUNG_PAIR(BgL_arg1697z00_1672,
																	BgL_arg1702z00_1673);
															}
															BgL_arg1687z00_1665 =
																MAKE_YOUNG_PAIR(BgL_arg1691z00_1667,
																BgL_arg1692z00_1668);
														}
														{	/* Trace/walk.scm 268 */
															obj_t BgL_arg1736z00_1681;

															{	/* Trace/walk.scm 268 */
																obj_t BgL_arg1737z00_1682;

																{	/* Trace/walk.scm 268 */
																	obj_t BgL_arg1748z00_1683;

																	{	/* Trace/walk.scm 268 */
																		obj_t BgL_arg1749z00_1684;
																		obj_t BgL_arg1750z00_1685;

																		{	/* Trace/walk.scm 268 */
																			obj_t BgL_arg1751z00_1686;

																			{	/* Trace/walk.scm 268 */
																				obj_t BgL_arg1752z00_1687;

																				{	/* Trace/walk.scm 268 */
																					obj_t BgL_arg1753z00_1688;

																					BgL_arg1753z00_1688 =
																						MAKE_YOUNG_PAIR(BgL_tmp2z00_1656,
																						BNIL);
																					BgL_arg1752z00_1687 =
																						MAKE_YOUNG_PAIR(BgL_tmp1z00_1655,
																						BgL_arg1753z00_1688);
																				}
																				BgL_arg1751z00_1686 =
																					MAKE_YOUNG_PAIR(BgL_tmp3z00_1657,
																					BgL_arg1752z00_1687);
																			}
																			BgL_arg1749z00_1684 =
																				MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long)
																						16)), BgL_arg1751z00_1686);
																		}
																		{	/* Trace/walk.scm 269 */
																			obj_t BgL_arg1756z00_1689;

																			{	/* Trace/walk.scm 269 */
																				obj_t BgL_arg1758z00_1690;

																				{	/* Trace/walk.scm 269 */
																					obj_t BgL_arg1759z00_1691;
																					obj_t BgL_arg1760z00_1692;

																					{	/* Trace/walk.scm 269 */
																						obj_t BgL_arg1761z00_1693;

																						{	/* Trace/walk.scm 269 */
																							obj_t BgL_arg1762z00_1694;

																							BgL_arg1762z00_1694 =
																								MAKE_YOUNG_PAIR(
																								((obj_t) BgL_nodez00_38), BNIL);
																							BgL_arg1761z00_1693 =
																								MAKE_YOUNG_PAIR
																								(BgL_tauxz00_1654,
																								BgL_arg1762z00_1694);
																						}
																						BgL_arg1759z00_1691 =
																							MAKE_YOUNG_PAIR
																							(BgL_arg1761z00_1693, BNIL);
																					}
																					{	/* Trace/walk.scm 270 */
																						obj_t BgL_arg1763z00_1695;
																						obj_t BgL_arg1765z00_1696;

																						{	/* Trace/walk.scm 270 */
																							bool_t BgL_test2263z00_3290;

																							if (STRUCTP(BgL_llocz00_41))
																								{	/* Trace/walk.scm 270 */
																									BgL_test2263z00_3290 =
																										(STRUCT_KEY(BgL_llocz00_41)
																										==
																										CNST_TABLE_REF(((long)
																												11)));
																								}
																							else
																								{	/* Trace/walk.scm 270 */
																									BgL_test2263z00_3290 =
																										((bool_t) 0);
																								}
																							if (BgL_test2263z00_3290)
																								{	/* Trace/walk.scm 272 */
																									obj_t BgL_arg1767z00_1698;

																									{	/* Trace/walk.scm 272 */
																										obj_t BgL_res2058z00_2442;

																										BgL_res2058z00_2442 =
																											MAKE_YOUNG_EPAIR
																											(BgL_tmp3z00_1657, BNIL,
																											BgL_llocz00_41);
																										BgL_arg1767z00_1698 =
																											BgL_res2058z00_2442;
																									}
																									{	/* Trace/walk.scm 271 */
																										obj_t BgL_res2059z00_2444;

																										{	/* Trace/walk.scm 271 */
																											obj_t BgL_obj1z00_2443;

																											BgL_obj1z00_2443 =
																												CNST_TABLE_REF(((long)
																													17));
																											BgL_res2059z00_2444 =
																												MAKE_YOUNG_EPAIR
																												(BgL_obj1z00_2443,
																												BgL_arg1767z00_1698,
																												BgL_llocz00_41);
																										}
																										BgL_arg1763z00_1695 =
																											BgL_res2059z00_2444;
																								}}
																							else
																								{	/* Trace/walk.scm 274 */
																									obj_t BgL_arg1768z00_1699;

																									BgL_arg1768z00_1699 =
																										MAKE_YOUNG_PAIR
																										(BgL_tmp3z00_1657, BNIL);
																									BgL_arg1763z00_1695 =
																										MAKE_YOUNG_PAIR
																										(CNST_TABLE_REF(((long)
																												17)),
																										BgL_arg1768z00_1699);
																						}}
																						BgL_arg1765z00_1696 =
																							MAKE_YOUNG_PAIR(BgL_auxz00_1653,
																							BNIL);
																						BgL_arg1760z00_1692 =
																							MAKE_YOUNG_PAIR
																							(BgL_arg1763z00_1695,
																							BgL_arg1765z00_1696);
																					}
																					BgL_arg1758z00_1690 =
																						MAKE_YOUNG_PAIR(BgL_arg1759z00_1691,
																						BgL_arg1760z00_1692);
																				}
																				BgL_arg1756z00_1689 =
																					MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long)
																							18)), BgL_arg1758z00_1690);
																			}
																			BgL_arg1750z00_1685 =
																				MAKE_YOUNG_PAIR(BgL_arg1756z00_1689,
																				BNIL);
																		}
																		BgL_arg1748z00_1683 =
																			MAKE_YOUNG_PAIR(BgL_arg1749z00_1684,
																			BgL_arg1750z00_1685);
																	}
																	BgL_arg1737z00_1682 =
																		MAKE_YOUNG_PAIR(BNIL, BgL_arg1748z00_1683);
																}
																BgL_arg1736z00_1681 =
																	MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 18)),
																	BgL_arg1737z00_1682);
															}
															BgL_arg1688z00_1666 =
																MAKE_YOUNG_PAIR(BgL_arg1736z00_1681, BNIL);
														}
														BgL_arg1681z00_1664 =
															MAKE_YOUNG_PAIR(BgL_arg1687z00_1665,
															BgL_arg1688z00_1666);
													}
													BgL_expz00_1660 =
														MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 18)),
														BgL_arg1681z00_1664);
												}
												{	/* Trace/walk.scm 264 */
													BgL_nodez00_bglt BgL_nnodez00_1661;

													BgL_nnodez00_1661 =
														BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_expz00_1660,
														BNIL, BgL_locz00_1652, CNST_TABLE_REF(((long) 19)));
													{	/* Trace/walk.scm 276 */

														{	/* Trace/walk.scm 277 */
															bool_t BgL_arg1679z00_1662;

															{	/* Trace/walk.scm 277 */
																obj_t BgL_arg1680z00_1663;

																BgL_arg1680z00_1663 =
																	BGl_thezd2backendzd2zzbackend_backendz00();
																BgL_arg1679z00_1662 =
																	(((BgL_backendz00_bglt) COBJECT(
																			((BgL_backendz00_bglt)
																				BgL_arg1680z00_1663)))->
																	BgL_removezd2emptyzd2letz00);
															}
															((((BgL_letzd2varzd2_bglt) COBJECT(
																			((BgL_letzd2varzd2_bglt)
																				BgL_nnodez00_1661)))->
																	BgL_removablezf3zf3) =
																((bool_t) BgL_arg1679z00_1662), BUNSPEC);
														}
														return ((BgL_letzd2varzd2_bglt) BgL_nnodez00_1661);
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}

	}



/* fqname~0 */
	obj_t BGl_fqnameze70ze7zztrace_walkz00(obj_t BgL_symz00_1715,
		obj_t BgL_stackz00_1716)
	{
		{	/* Trace/walk.scm 250 */
			if (NULLP(BgL_stackz00_1716))
				{	/* Trace/walk.scm 248 */
					return BgL_symz00_1715;
				}
			else
				{	/* Trace/walk.scm 250 */
					obj_t BgL_arg1788z00_1719;

					{	/* Trace/walk.scm 250 */
						obj_t BgL_arg1794z00_1723;
						obj_t BgL_arg1795z00_1724;

						{	/* Trace/walk.scm 250 */
							obj_t BgL_arg1796z00_1725;

							BgL_arg1796z00_1725 = CAR(((obj_t) BgL_stackz00_1716));
							BgL_arg1794z00_1723 =
								BGl_tracezd2idzd2zztrace_walkz00(BgL_arg1796z00_1725);
						}
						BgL_arg1795z00_1724 = CDR(((obj_t) BgL_stackz00_1716));
						BgL_arg1788z00_1719 =
							BGl_fqnameze70ze7zztrace_walkz00(BgL_arg1794z00_1723,
							BgL_arg1795z00_1724);
					}
					{	/* Trace/walk.scm 250 */
						obj_t BgL_list1789z00_1720;

						{	/* Trace/walk.scm 250 */
							obj_t BgL_arg1790z00_1721;

							{	/* Trace/walk.scm 250 */
								obj_t BgL_arg1791z00_1722;

								BgL_arg1791z00_1722 =
									MAKE_YOUNG_PAIR(BgL_arg1788z00_1719, BNIL);
								BgL_arg1790z00_1721 =
									MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 20)),
									BgL_arg1791z00_1722);
							}
							BgL_list1789z00_1720 =
								MAKE_YOUNG_PAIR(BgL_symz00_1715, BgL_arg1790z00_1721);
						}
						return
							BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(BgL_list1789z00_1720);
					}
				}
		}

	}



/* trace-node*! */
	bool_t BGl_tracezd2nodeza2z12z62zztrace_walkz00(obj_t BgL_nodeza2za2_100,
		obj_t BgL_stackz00_101, obj_t BgL_levelz00_102)
	{
		{	/* Trace/walk.scm 449 */
		BGl_tracezd2nodeza2z12z62zztrace_walkz00:
			if (NULLP(BgL_nodeza2za2_100))
				{	/* Trace/walk.scm 450 */
					return ((bool_t) 0);
				}
			else
				{	/* Trace/walk.scm 450 */
					{	/* Trace/walk.scm 451 */
						BgL_nodez00_bglt BgL_arg1798z00_1728;

						{	/* Trace/walk.scm 451 */
							obj_t BgL_arg1799z00_1729;

							BgL_arg1799z00_1729 = CAR(((obj_t) BgL_nodeza2za2_100));
							BgL_arg1798z00_1728 =
								BGl_tracezd2nodezd2zztrace_walkz00(
								((BgL_nodez00_bglt) BgL_arg1799z00_1729), BgL_stackz00_101,
								BgL_levelz00_102);
						}
						{	/* Trace/walk.scm 451 */
							obj_t BgL_auxz00_3345;
							obj_t BgL_tmpz00_3343;

							BgL_auxz00_3345 = ((obj_t) BgL_arg1798z00_1728);
							BgL_tmpz00_3343 = ((obj_t) BgL_nodeza2za2_100);
							SET_CAR(BgL_tmpz00_3343, BgL_auxz00_3345);
						}
					}
					{	/* Trace/walk.scm 452 */
						obj_t BgL_arg1800z00_1730;

						BgL_arg1800z00_1730 = CDR(((obj_t) BgL_nodeza2za2_100));
						{
							obj_t BgL_nodeza2za2_3350;

							BgL_nodeza2za2_3350 = BgL_arg1800z00_1730;
							BgL_nodeza2za2_100 = BgL_nodeza2za2_3350;
							goto BGl_tracezd2nodeza2z12z62zztrace_walkz00;
						}
					}
				}
		}

	}



/* toplevel-trace-node*! */
	bool_t BGl_toplevelzd2tracezd2nodeza2z12zb0zztrace_walkz00(obj_t
		BgL_nodeza2za2_107)
	{
		{	/* Trace/walk.scm 500 */
		BGl_toplevelzd2tracezd2nodeza2z12zb0zztrace_walkz00:
			if (NULLP(BgL_nodeza2za2_107))
				{	/* Trace/walk.scm 501 */
					return ((bool_t) 0);
				}
			else
				{	/* Trace/walk.scm 501 */
					{	/* Trace/walk.scm 502 */
						BgL_nodez00_bglt BgL_arg1802z00_1732;

						{	/* Trace/walk.scm 502 */
							obj_t BgL_arg1804z00_1733;

							BgL_arg1804z00_1733 = CAR(((obj_t) BgL_nodeza2za2_107));
							BgL_arg1802z00_1732 =
								BGl_toplevelzd2tracezd2nodez00zztrace_walkz00(
								((BgL_nodez00_bglt) BgL_arg1804z00_1733));
						}
						{	/* Trace/walk.scm 502 */
							obj_t BgL_auxz00_3359;
							obj_t BgL_tmpz00_3357;

							BgL_auxz00_3359 = ((obj_t) BgL_arg1802z00_1732);
							BgL_tmpz00_3357 = ((obj_t) BgL_nodeza2za2_107);
							SET_CAR(BgL_tmpz00_3357, BgL_auxz00_3359);
						}
					}
					{	/* Trace/walk.scm 503 */
						obj_t BgL_arg1805z00_1734;

						BgL_arg1805z00_1734 = CDR(((obj_t) BgL_nodeza2za2_107));
						{
							obj_t BgL_nodeza2za2_3364;

							BgL_nodeza2za2_3364 = BgL_arg1805z00_1734;
							BgL_nodeza2za2_107 = BgL_nodeza2za2_3364;
							goto BGl_toplevelzd2tracezd2nodeza2z12zb0zztrace_walkz00;
						}
					}
				}
		}

	}



/* object-init */
	obj_t BGl_objectzd2initzd2zztrace_walkz00()
	{
		{	/* Trace/walk.scm 15 */
			return BUNSPEC;
		}

	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zztrace_walkz00()
	{
		{	/* Trace/walk.scm 15 */
			BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_proc2119z00zztrace_walkz00, BGl_nodez00zzast_nodez00,
				BGl_string2120z00zztrace_walkz00);
			BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_proc2121z00zztrace_walkz00, BGl_nodez00zzast_nodez00,
				BGl_string2122z00zztrace_walkz00);
			return
				BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_toplevelzd2tracezd2nodezd2envzd2zztrace_walkz00,
				BGl_proc2123z00zztrace_walkz00, BGl_nodez00zzast_nodez00,
				BGl_string2124z00zztrace_walkz00);
		}

	}



/* &toplevel-trace-node1386 */
	obj_t BGl_z62toplevelzd2tracezd2node1386z62zztrace_walkz00(obj_t
		BgL_envz00_2668, obj_t BgL_nodez00_2669)
	{
		{	/* Trace/walk.scm 457 */
			return ((obj_t) ((BgL_nodez00_bglt) BgL_nodez00_2669));
		}

	}



/* &trace-node1345 */
	obj_t BGl_z62tracezd2node1345zb0zztrace_walkz00(obj_t BgL_envz00_2670,
		obj_t BgL_nodez00_2671, obj_t BgL_stackz00_2672, obj_t BgL_levelz00_2673)
	{
		{	/* Trace/walk.scm 283 */
			return ((obj_t) ((BgL_nodez00_bglt) BgL_nodez00_2671));
		}

	}



/* &find-last-node1315 */
	obj_t BGl_z62findzd2lastzd2node1315z62zztrace_walkz00(obj_t BgL_envz00_2674,
		obj_t BgL_nodez00_2675)
	{
		{	/* Trace/walk.scm 139 */
			return ((obj_t) ((BgL_nodez00_bglt) BgL_nodez00_2675));
		}

	}



/* find-last-node */
	obj_t BGl_findzd2lastzd2nodez00zztrace_walkz00(BgL_nodez00_bglt
		BgL_nodez00_23)
	{
		{	/* Trace/walk.scm 139 */
			{	/* Trace/walk.scm 139 */
				obj_t BgL_method1316z00_1749;

				{	/* Trace/walk.scm 139 */
					obj_t BgL_res2073z00_2494;

					{	/* Trace/walk.scm 139 */
						long BgL_objzd2classzd2numz00_2459;

						{	/* Trace/walk.scm 139 */
							long BgL_res2063z00_2462;

							BgL_res2063z00_2462 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nodez00_23));
							BgL_objzd2classzd2numz00_2459 = BgL_res2063z00_2462;
						}
						{	/* Trace/walk.scm 139 */
							obj_t BgL_arg1741z00_2460;

							BgL_arg1741z00_2460 =
								PROCEDURE_REF(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
								(int) (((long) 1)));
							{	/* Trace/walk.scm 139 */
								int BgL_offsetz00_2464;

								BgL_offsetz00_2464 = (int) (BgL_objzd2classzd2numz00_2459);
								{	/* Trace/walk.scm 139 */
									long BgL_offsetz00_2465;

									BgL_offsetz00_2465 =
										((long) (BgL_offsetz00_2464) - OBJECT_TYPE);
									{	/* Trace/walk.scm 139 */
										long BgL_modz00_2466;

										BgL_modz00_2466 =
											(BgL_offsetz00_2465 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Trace/walk.scm 139 */
											long BgL_restz00_2468;

											BgL_restz00_2468 =
												(BgL_offsetz00_2465 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Trace/walk.scm 139 */

												{	/* Trace/walk.scm 139 */
													obj_t BgL_bucketz00_2470;

													BgL_bucketz00_2470 =
														VECTOR_REF(
														((obj_t) BgL_arg1741z00_2460), BgL_modz00_2466);
													BgL_res2073z00_2494 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_2470), BgL_restz00_2468);
					}}}}}}}}
					BgL_method1316z00_1749 = BgL_res2073z00_2494;
				}
				return
					PROCEDURE_ENTRY(BgL_method1316z00_1749) (BgL_method1316z00_1749,
					((obj_t) BgL_nodez00_23), BEOA);
			}
		}

	}



/* &find-last-node */
	obj_t BGl_z62findzd2lastzd2nodez62zztrace_walkz00(obj_t BgL_envz00_2676,
		obj_t BgL_nodez00_2677)
	{
		{	/* Trace/walk.scm 139 */
			return
				BGl_findzd2lastzd2nodez00zztrace_walkz00(
				((BgL_nodez00_bglt) BgL_nodez00_2677));
		}

	}



/* trace-node */
	BgL_nodez00_bglt BGl_tracezd2nodezd2zztrace_walkz00(BgL_nodez00_bglt
		BgL_nodez00_43, obj_t BgL_stackz00_44, obj_t BgL_levelz00_45)
	{
		{	/* Trace/walk.scm 283 */
			{	/* Trace/walk.scm 283 */
				obj_t BgL_method1346z00_1750;

				{	/* Trace/walk.scm 283 */
					obj_t BgL_res2084z00_2531;

					{	/* Trace/walk.scm 283 */
						long BgL_objzd2classzd2numz00_2496;

						{	/* Trace/walk.scm 283 */
							long BgL_res2074z00_2499;

							BgL_res2074z00_2499 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nodez00_43));
							BgL_objzd2classzd2numz00_2496 = BgL_res2074z00_2499;
						}
						{	/* Trace/walk.scm 283 */
							obj_t BgL_arg1741z00_2497;

							BgL_arg1741z00_2497 =
								PROCEDURE_REF(BGl_tracezd2nodezd2envz00zztrace_walkz00,
								(int) (((long) 1)));
							{	/* Trace/walk.scm 283 */
								int BgL_offsetz00_2501;

								BgL_offsetz00_2501 = (int) (BgL_objzd2classzd2numz00_2496);
								{	/* Trace/walk.scm 283 */
									long BgL_offsetz00_2502;

									BgL_offsetz00_2502 =
										((long) (BgL_offsetz00_2501) - OBJECT_TYPE);
									{	/* Trace/walk.scm 283 */
										long BgL_modz00_2503;

										BgL_modz00_2503 =
											(BgL_offsetz00_2502 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Trace/walk.scm 283 */
											long BgL_restz00_2505;

											BgL_restz00_2505 =
												(BgL_offsetz00_2502 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Trace/walk.scm 283 */

												{	/* Trace/walk.scm 283 */
													obj_t BgL_bucketz00_2507;

													BgL_bucketz00_2507 =
														VECTOR_REF(
														((obj_t) BgL_arg1741z00_2497), BgL_modz00_2503);
													BgL_res2084z00_2531 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_2507), BgL_restz00_2505);
					}}}}}}}}
					BgL_method1346z00_1750 = BgL_res2084z00_2531;
				}
				return
					((BgL_nodez00_bglt)
					PROCEDURE_ENTRY(BgL_method1346z00_1750) (BgL_method1346z00_1750,
						((obj_t) BgL_nodez00_43), BgL_stackz00_44, BgL_levelz00_45, BEOA));
			}
		}

	}



/* &trace-node */
	BgL_nodez00_bglt BGl_z62tracezd2nodezb0zztrace_walkz00(obj_t BgL_envz00_2678,
		obj_t BgL_nodez00_2679, obj_t BgL_stackz00_2680, obj_t BgL_levelz00_2681)
	{
		{	/* Trace/walk.scm 283 */
			return
				BGl_tracezd2nodezd2zztrace_walkz00(
				((BgL_nodez00_bglt) BgL_nodez00_2679), BgL_stackz00_2680,
				BgL_levelz00_2681);
		}

	}



/* toplevel-trace-node */
	BgL_nodez00_bglt
		BGl_toplevelzd2tracezd2nodez00zztrace_walkz00(BgL_nodez00_bglt
		BgL_nodez00_103)
	{
		{	/* Trace/walk.scm 457 */
			{	/* Trace/walk.scm 457 */
				obj_t BgL_method1388z00_1751;

				{	/* Trace/walk.scm 457 */
					obj_t BgL_res2095z00_2568;

					{	/* Trace/walk.scm 457 */
						long BgL_objzd2classzd2numz00_2533;

						{	/* Trace/walk.scm 457 */
							long BgL_res2085z00_2536;

							BgL_res2085z00_2536 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nodez00_103));
							BgL_objzd2classzd2numz00_2533 = BgL_res2085z00_2536;
						}
						{	/* Trace/walk.scm 457 */
							obj_t BgL_arg1741z00_2534;

							BgL_arg1741z00_2534 =
								PROCEDURE_REF
								(BGl_toplevelzd2tracezd2nodezd2envzd2zztrace_walkz00,
								(int) (((long) 1)));
							{	/* Trace/walk.scm 457 */
								int BgL_offsetz00_2538;

								BgL_offsetz00_2538 = (int) (BgL_objzd2classzd2numz00_2533);
								{	/* Trace/walk.scm 457 */
									long BgL_offsetz00_2539;

									BgL_offsetz00_2539 =
										((long) (BgL_offsetz00_2538) - OBJECT_TYPE);
									{	/* Trace/walk.scm 457 */
										long BgL_modz00_2540;

										BgL_modz00_2540 =
											(BgL_offsetz00_2539 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Trace/walk.scm 457 */
											long BgL_restz00_2542;

											BgL_restz00_2542 =
												(BgL_offsetz00_2539 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Trace/walk.scm 457 */

												{	/* Trace/walk.scm 457 */
													obj_t BgL_bucketz00_2544;

													BgL_bucketz00_2544 =
														VECTOR_REF(
														((obj_t) BgL_arg1741z00_2534), BgL_modz00_2540);
													BgL_res2095z00_2568 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_2544), BgL_restz00_2542);
					}}}}}}}}
					BgL_method1388z00_1751 = BgL_res2095z00_2568;
				}
				return
					((BgL_nodez00_bglt)
					PROCEDURE_ENTRY(BgL_method1388z00_1751) (BgL_method1388z00_1751,
						((obj_t) BgL_nodez00_103), BEOA));
			}
		}

	}



/* &toplevel-trace-node */
	BgL_nodez00_bglt BGl_z62toplevelzd2tracezd2nodez62zztrace_walkz00(obj_t
		BgL_envz00_2682, obj_t BgL_nodez00_2683)
	{
		{	/* Trace/walk.scm 457 */
			return
				BGl_toplevelzd2tracezd2nodez00zztrace_walkz00(
				((BgL_nodez00_bglt) BgL_nodez00_2683));
		}

	}



/* method-init */
	obj_t BGl_methodzd2initzd2zztrace_walkz00()
	{
		{	/* Trace/walk.scm 15 */
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_sequencez00zzast_nodez00, BGl_proc2125z00zztrace_walkz00,
				BGl_string2126z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_syncz00zzast_nodez00, BGl_proc2127z00zztrace_walkz00,
				BGl_string2126z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_appz00zzast_nodez00, BGl_proc2128z00zztrace_walkz00,
				BGl_string2126z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_appzd2lyzd2zzast_nodez00, BGl_proc2129z00zztrace_walkz00,
				BGl_string2126z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_funcallz00zzast_nodez00, BGl_proc2130z00zztrace_walkz00,
				BGl_string2126z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_externz00zzast_nodez00, BGl_proc2131z00zztrace_walkz00,
				BGl_string2126z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_setqz00zzast_nodez00, BGl_proc2132z00zztrace_walkz00,
				BGl_string2126z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_conditionalz00zzast_nodez00, BGl_proc2133z00zztrace_walkz00,
				BGl_string2126z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_failz00zzast_nodez00, BGl_proc2134z00zztrace_walkz00,
				BGl_string2126z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_switchz00zzast_nodez00, BGl_proc2135z00zztrace_walkz00,
				BGl_string2126z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc2136z00zztrace_walkz00,
				BGl_string2126z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_letzd2funzd2zzast_nodez00, BGl_proc2137z00zztrace_walkz00,
				BGl_string2126z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_setzd2exzd2itz00zzast_nodez00, BGl_proc2138z00zztrace_walkz00,
				BGl_string2126z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_jumpzd2exzd2itz00zzast_nodez00, BGl_proc2139z00zztrace_walkz00,
				BGl_string2126z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_sequencez00zzast_nodez00,
				BGl_proc2140z00zztrace_walkz00, BGl_string2141z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_syncz00zzast_nodez00,
				BGl_proc2142z00zztrace_walkz00, BGl_string2141z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_appz00zzast_nodez00,
				BGl_proc2143z00zztrace_walkz00, BGl_string2141z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_appzd2lyzd2zzast_nodez00,
				BGl_proc2144z00zztrace_walkz00, BGl_string2141z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_funcallz00zzast_nodez00,
				BGl_proc2145z00zztrace_walkz00, BGl_string2141z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_externz00zzast_nodez00,
				BGl_proc2146z00zztrace_walkz00, BGl_string2141z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_castz00zzast_nodez00,
				BGl_proc2147z00zztrace_walkz00, BGl_string2141z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_setqz00zzast_nodez00,
				BGl_proc2148z00zztrace_walkz00, BGl_string2141z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_conditionalz00zzast_nodez00, BGl_proc2149z00zztrace_walkz00,
				BGl_string2141z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_failz00zzast_nodez00,
				BGl_proc2150z00zztrace_walkz00, BGl_string2141z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_switchz00zzast_nodez00,
				BGl_proc2151z00zztrace_walkz00, BGl_string2141z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_letzd2funzd2zzast_nodez00, BGl_proc2152z00zztrace_walkz00,
				BGl_string2141z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc2153z00zztrace_walkz00,
				BGl_string2141z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_setzd2exzd2itz00zzast_nodez00, BGl_proc2154z00zztrace_walkz00,
				BGl_string2141z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_jumpzd2exzd2itz00zzast_nodez00, BGl_proc2155z00zztrace_walkz00,
				BGl_string2141z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_makezd2boxzd2zzast_nodez00, BGl_proc2156z00zztrace_walkz00,
				BGl_string2141z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_boxzd2refzd2zzast_nodez00, BGl_proc2157z00zztrace_walkz00,
				BGl_string2141z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_boxzd2setz12zc0zzast_nodez00, BGl_proc2158z00zztrace_walkz00,
				BGl_string2141z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_toplevelzd2tracezd2nodezd2envzd2zztrace_walkz00,
				BGl_sequencez00zzast_nodez00, BGl_proc2159z00zztrace_walkz00,
				BGl_string2160z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_toplevelzd2tracezd2nodezd2envzd2zztrace_walkz00,
				BGl_syncz00zzast_nodez00, BGl_proc2161z00zztrace_walkz00,
				BGl_string2160z00zztrace_walkz00);
			return
				BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_toplevelzd2tracezd2nodezd2envzd2zztrace_walkz00,
				BGl_setqz00zzast_nodez00, BGl_proc2162z00zztrace_walkz00,
				BGl_string2160z00zztrace_walkz00);
		}

	}



/* &toplevel-trace-node-1395 */
	BgL_nodez00_bglt BGl_z62toplevelzd2tracezd2nodezd21395zb0zztrace_walkz00(obj_t
		BgL_envz00_2719, obj_t BgL_nodez00_2720)
	{
		{	/* Trace/walk.scm 484 */
			{	/* Trace/walk.scm 486 */
				BgL_varz00_bglt BgL_i1135z00_2843;

				BgL_i1135z00_2843 =
					(((BgL_setqz00_bglt) COBJECT(
							((BgL_setqz00_bglt) BgL_nodez00_2720)))->BgL_varz00);
				{	/* Trace/walk.scm 487 */
					bool_t BgL_test2268z00_3511;

					{	/* Trace/walk.scm 487 */
						bool_t BgL_test2269z00_3512;

						{	/* Trace/walk.scm 487 */
							BgL_variablez00_bglt BgL_arg1954z00_2844;

							BgL_arg1954z00_2844 =
								(((BgL_varz00_bglt) COBJECT(BgL_i1135z00_2843))->
								BgL_variablez00);
							{	/* Trace/walk.scm 487 */
								bool_t BgL_res2104z00_2845;

								BgL_res2104z00_2845 =
									BGl_isazf3zf3zz__objectz00(
									((obj_t) BgL_arg1954z00_2844), BGl_globalz00zzast_varz00);
								BgL_test2269z00_3512 = BgL_res2104z00_2845;
							}
						}
						if (BgL_test2269z00_3512)
							{	/* Trace/walk.scm 488 */
								bool_t BgL_test2270z00_3516;

								{	/* Trace/walk.scm 488 */
									bool_t BgL_test2271z00_3517;

									{	/* Trace/walk.scm 488 */
										BgL_nodez00_bglt BgL_arg1953z00_2846;

										BgL_arg1953z00_2846 =
											(((BgL_setqz00_bglt) COBJECT(
													((BgL_setqz00_bglt) BgL_nodez00_2720)))->
											BgL_valuez00);
										{	/* Trace/walk.scm 488 */
											bool_t BgL_res2105z00_2847;

											BgL_res2105z00_2847 =
												BGl_isazf3zf3zz__objectz00(
												((obj_t) BgL_arg1953z00_2846),
												BGl_atomz00zzast_nodez00);
											BgL_test2271z00_3517 = BgL_res2105z00_2847;
										}
									}
									if (BgL_test2271z00_3517)
										{	/* Trace/walk.scm 488 */
											BgL_test2270z00_3516 = ((bool_t) 1);
										}
									else
										{	/* Trace/walk.scm 489 */
											bool_t BgL_test2272z00_3522;

											{	/* Trace/walk.scm 489 */
												BgL_nodez00_bglt BgL_arg1951z00_2848;

												BgL_arg1951z00_2848 =
													(((BgL_setqz00_bglt) COBJECT(
															((BgL_setqz00_bglt) BgL_nodez00_2720)))->
													BgL_valuez00);
												{	/* Trace/walk.scm 489 */
													bool_t BgL_res2106z00_2849;

													BgL_res2106z00_2849 =
														BGl_isazf3zf3zz__objectz00(
														((obj_t) BgL_arg1951z00_2848),
														BGl_varz00zzast_nodez00);
													BgL_test2272z00_3522 = BgL_res2106z00_2849;
												}
											}
											if (BgL_test2272z00_3522)
												{	/* Trace/walk.scm 489 */
													BgL_test2270z00_3516 = ((bool_t) 1);
												}
											else
												{	/* Trace/walk.scm 490 */
													bool_t BgL_test2273z00_3527;

													{	/* Trace/walk.scm 490 */
														BgL_nodez00_bglt BgL_arg1950z00_2850;

														BgL_arg1950z00_2850 =
															(((BgL_setqz00_bglt) COBJECT(
																	((BgL_setqz00_bglt) BgL_nodez00_2720)))->
															BgL_valuez00);
														{	/* Trace/walk.scm 490 */
															bool_t BgL_res2107z00_2851;

															BgL_res2107z00_2851 =
																BGl_isazf3zf3zz__objectz00(
																((obj_t) BgL_arg1950z00_2850),
																BGl_kwotez00zzast_nodez00);
															BgL_test2273z00_3527 = BgL_res2107z00_2851;
														}
													}
													if (BgL_test2273z00_3527)
														{	/* Trace/walk.scm 490 */
															BgL_test2270z00_3516 = ((bool_t) 1);
														}
													else
														{	/* Trace/walk.scm 491 */
															BgL_nodez00_bglt BgL_arg1949z00_2852;

															BgL_arg1949z00_2852 =
																(((BgL_setqz00_bglt) COBJECT(
																		((BgL_setqz00_bglt) BgL_nodez00_2720)))->
																BgL_valuez00);
															{	/* Trace/walk.scm 491 */
																bool_t BgL_res2108z00_2853;

																BgL_res2108z00_2853 =
																	BGl_isazf3zf3zz__objectz00(
																	((obj_t) BgL_arg1949z00_2852),
																	BGl_pragmaz00zzast_nodez00);
																BgL_test2270z00_3516 = BgL_res2108z00_2853;
															}
														}
												}
										}
								}
								if (BgL_test2270z00_3516)
									{	/* Trace/walk.scm 488 */
										BgL_test2268z00_3511 = ((bool_t) 0);
									}
								else
									{	/* Trace/walk.scm 488 */
										BgL_test2268z00_3511 = ((bool_t) 1);
									}
							}
						else
							{	/* Trace/walk.scm 487 */
								BgL_test2268z00_3511 = ((bool_t) 0);
							}
					}
					if (BgL_test2268z00_3511)
						{	/* Trace/walk.scm 492 */
							BgL_typez00_bglt BgL_tz00_2854;

							{	/* Trace/walk.scm 492 */
								BgL_typez00_bglt BgL_arg1945z00_2855;
								BgL_typez00_bglt BgL_arg1946z00_2856;

								BgL_arg1945z00_2855 =
									(((BgL_nodez00_bglt) COBJECT(
											(((BgL_setqz00_bglt) COBJECT(
														((BgL_setqz00_bglt) BgL_nodez00_2720)))->
												BgL_valuez00)))->BgL_typez00);
								BgL_arg1946z00_2856 =
									(((BgL_variablez00_bglt)
										COBJECT(((BgL_variablez00_bglt) ((BgL_globalz00_bglt) ((
															(BgL_varz00_bglt) COBJECT(BgL_i1135z00_2843))->
														BgL_variablez00)))))->BgL_typez00);
								BgL_tz00_2854 =
									BGl_strictzd2nodezd2typez00zzast_nodez00(BgL_arg1945z00_2855,
									BgL_arg1946z00_2856);
							}
							{	/* Trace/walk.scm 492 */
								BgL_letzd2varzd2_bglt BgL_tracez00_2857;

								{	/* Trace/walk.scm 493 */
									BgL_nodez00_bglt BgL_arg1941z00_2858;
									obj_t BgL_arg1942z00_2859;
									obj_t BgL_arg1943z00_2860;

									BgL_arg1941z00_2858 =
										(((BgL_setqz00_bglt) COBJECT(
												((BgL_setqz00_bglt) BgL_nodez00_2720)))->BgL_valuez00);
									{	/* Trace/walk.scm 493 */
										BgL_variablez00_bglt BgL_arg1944z00_2861;

										BgL_arg1944z00_2861 =
											(((BgL_varz00_bglt) COBJECT(BgL_i1135z00_2843))->
											BgL_variablez00);
										BgL_arg1942z00_2859 =
											BGl_tracezd2idzd2zztrace_walkz00(((obj_t)
												BgL_arg1944z00_2861));
									}
									BgL_arg1943z00_2860 =
										(((BgL_nodez00_bglt) COBJECT(
												((BgL_nodez00_bglt)
													((BgL_setqz00_bglt) BgL_nodez00_2720))))->BgL_locz00);
									BgL_tracez00_2857 =
										BGl_makezd2tracedzd2nodez00zztrace_walkz00
										(BgL_arg1941z00_2858, BgL_tz00_2854, BgL_arg1942z00_2859,
										BgL_arg1943z00_2860, BNIL);
								}
								{	/* Trace/walk.scm 493 */

									((((BgL_setqz00_bglt) COBJECT(
													((BgL_setqz00_bglt) BgL_nodez00_2720)))->
											BgL_valuez00) =
										((BgL_nodez00_bglt) ((BgL_nodez00_bglt) BgL_tracez00_2857)),
										BUNSPEC);
								}
							}
						}
					else
						{	/* Trace/walk.scm 487 */
							BFALSE;
						}
				}
			}
			return ((BgL_nodez00_bglt) ((BgL_setqz00_bglt) BgL_nodez00_2720));
		}

	}



/* &toplevel-trace-node-1393 */
	BgL_nodez00_bglt BGl_z62toplevelzd2tracezd2nodezd21393zb0zztrace_walkz00(obj_t
		BgL_envz00_2721, obj_t BgL_nodez00_2722)
	{
		{	/* Trace/walk.scm 470 */
			((((BgL_syncz00_bglt) COBJECT(
							((BgL_syncz00_bglt) BgL_nodez00_2722)))->BgL_mutexz00) =
				((BgL_nodez00_bglt)
					BGl_toplevelzd2tracezd2nodez00zztrace_walkz00((((BgL_syncz00_bglt)
								COBJECT(((BgL_syncz00_bglt) BgL_nodez00_2722)))->
							BgL_mutexz00))), BUNSPEC);
			((((BgL_syncz00_bglt) COBJECT(((BgL_syncz00_bglt) BgL_nodez00_2722)))->
					BgL_prelockz00) =
				((BgL_nodez00_bglt)
					BGl_toplevelzd2tracezd2nodez00zztrace_walkz00((((BgL_syncz00_bglt)
								COBJECT(((BgL_syncz00_bglt) BgL_nodez00_2722)))->
							BgL_prelockz00))), BUNSPEC);
			((((BgL_syncz00_bglt) COBJECT(((BgL_syncz00_bglt) BgL_nodez00_2722)))->
					BgL_bodyz00) =
				((BgL_nodez00_bglt)
					BGl_toplevelzd2tracezd2nodez00zztrace_walkz00((((BgL_syncz00_bglt)
								COBJECT(((BgL_syncz00_bglt) BgL_nodez00_2722)))->BgL_bodyz00))),
				BUNSPEC);
			return ((BgL_nodez00_bglt) ((BgL_syncz00_bglt) BgL_nodez00_2722));
		}

	}



/* &toplevel-trace-node-1391 */
	BgL_nodez00_bglt BGl_z62toplevelzd2tracezd2nodezd21391zb0zztrace_walkz00(obj_t
		BgL_envz00_2723, obj_t BgL_nodez00_2724)
	{
		{	/* Trace/walk.scm 463 */
			BGl_toplevelzd2tracezd2nodeza2z12zb0zztrace_walkz00(
				(((BgL_sequencez00_bglt) COBJECT(
							((BgL_sequencez00_bglt) BgL_nodez00_2724)))->BgL_nodesz00));
			return ((BgL_nodez00_bglt) ((BgL_sequencez00_bglt) BgL_nodez00_2724));
		}

	}



/* &trace-node-box-set!1385 */
	BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2boxzd2setz121385za2zztrace_walkz00(obj_t
		BgL_envz00_2725, obj_t BgL_nodez00_2726, obj_t BgL_stackz00_2727,
		obj_t BgL_levelz00_2728)
	{
		{	/* Trace/walk.scm 440 */
			{
				BgL_varz00_bglt BgL_auxz00_3580;

				{	/* Trace/walk.scm 442 */
					BgL_varz00_bglt BgL_arg1913z00_2865;

					BgL_arg1913z00_2865 =
						(((BgL_boxzd2setz12zc0_bglt) COBJECT(
								((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_2726)))->BgL_varz00);
					BgL_auxz00_3580 =
						((BgL_varz00_bglt)
						BGl_tracezd2nodezd2zztrace_walkz00(
							((BgL_nodez00_bglt) BgL_arg1913z00_2865), BgL_stackz00_2727,
							BgL_levelz00_2728));
				}
				((((BgL_boxzd2setz12zc0_bglt) COBJECT(
								((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_2726)))->BgL_varz00) =
					((BgL_varz00_bglt) BgL_auxz00_3580), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_3588;

				{	/* Trace/walk.scm 443 */
					BgL_nodez00_bglt BgL_arg1914z00_2866;

					BgL_arg1914z00_2866 =
						(((BgL_boxzd2setz12zc0_bglt) COBJECT(
								((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_2726)))->BgL_valuez00);
					BgL_auxz00_3588 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1914z00_2866,
						BgL_stackz00_2727, BgL_levelz00_2728);
				}
				((((BgL_boxzd2setz12zc0_bglt) COBJECT(
								((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_2726)))->BgL_valuez00) =
					((BgL_nodez00_bglt) BgL_auxz00_3588), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_2726));
		}

	}



/* &trace-node-box-ref1383 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2boxzd2ref1383zb0zztrace_walkz00(obj_t
		BgL_envz00_2729, obj_t BgL_nodez00_2730, obj_t BgL_stackz00_2731,
		obj_t BgL_levelz00_2732)
	{
		{	/* Trace/walk.scm 433 */
			{	/* Trace/walk.scm 434 */
				BgL_nodez00_bglt BgL_arg1911z00_2868;

				{	/* Trace/walk.scm 434 */
					BgL_varz00_bglt BgL_arg1912z00_2869;

					BgL_arg1912z00_2869 =
						(((BgL_boxzd2refzd2_bglt) COBJECT(
								((BgL_boxzd2refzd2_bglt) BgL_nodez00_2730)))->BgL_varz00);
					BgL_arg1911z00_2868 =
						BGl_tracezd2nodezd2zztrace_walkz00(
						((BgL_nodez00_bglt) BgL_arg1912z00_2869), BgL_stackz00_2731,
						BgL_levelz00_2732);
				}
				((((BgL_boxzd2refzd2_bglt) COBJECT(
								((BgL_boxzd2refzd2_bglt) BgL_nodez00_2730)))->BgL_varz00) =
					((BgL_varz00_bglt) ((BgL_varz00_bglt) BgL_arg1911z00_2868)), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_boxzd2refzd2_bglt) BgL_nodez00_2730));
		}

	}



/* &trace-node-make-box1381 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2makezd2box1381zb0zztrace_walkz00(obj_t
		BgL_envz00_2733, obj_t BgL_nodez00_2734, obj_t BgL_stackz00_2735,
		obj_t BgL_levelz00_2736)
	{
		{	/* Trace/walk.scm 426 */
			((((BgL_makezd2boxzd2_bglt) COBJECT(
							((BgL_makezd2boxzd2_bglt) BgL_nodez00_2734)))->BgL_valuez00) =
				((BgL_nodez00_bglt)
					BGl_tracezd2nodezd2zztrace_walkz00((((BgL_makezd2boxzd2_bglt)
								COBJECT(((BgL_makezd2boxzd2_bglt) BgL_nodez00_2734)))->
							BgL_valuez00), BgL_stackz00_2735, BgL_levelz00_2736)), BUNSPEC);
			return ((BgL_nodez00_bglt) ((BgL_makezd2boxzd2_bglt) BgL_nodez00_2734));
		}

	}



/* &trace-node-jump-ex-i1379 */
	BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2jumpzd2exzd2i1379z62zztrace_walkz00(obj_t
		BgL_envz00_2737, obj_t BgL_nodez00_2738, obj_t BgL_stackz00_2739,
		obj_t BgL_levelz00_2740)
	{
		{	/* Trace/walk.scm 417 */
			{
				BgL_nodez00_bglt BgL_auxz00_3612;

				{	/* Trace/walk.scm 419 */
					BgL_nodez00_bglt BgL_arg1907z00_2872;

					BgL_arg1907z00_2872 =
						(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
								((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_2738)))->BgL_exitz00);
					BgL_auxz00_3612 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1907z00_2872,
						BgL_stackz00_2739, BgL_levelz00_2740);
				}
				((((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
								((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_2738)))->
						BgL_exitz00) = ((BgL_nodez00_bglt) BgL_auxz00_3612), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_3618;

				{	/* Trace/walk.scm 420 */
					BgL_nodez00_bglt BgL_arg1908z00_2873;

					BgL_arg1908z00_2873 =
						(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
								((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_2738)))->
						BgL_valuez00);
					BgL_auxz00_3618 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1908z00_2873,
						BgL_stackz00_2739, BgL_levelz00_2740);
				}
				((((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
								((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_2738)))->
						BgL_valuez00) = ((BgL_nodez00_bglt) BgL_auxz00_3618), BUNSPEC);
			}
			return
				((BgL_nodez00_bglt) ((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_2738));
		}

	}



/* &trace-node-set-ex-it1377 */
	BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2setzd2exzd2it1377z62zztrace_walkz00(obj_t
		BgL_envz00_2741, obj_t BgL_nodez00_2742, obj_t BgL_stackz00_2743,
		obj_t BgL_levelz00_2744)
	{
		{	/* Trace/walk.scm 410 */
			((((BgL_setzd2exzd2itz00_bglt) COBJECT(
							((BgL_setzd2exzd2itz00_bglt) BgL_nodez00_2742)))->BgL_bodyz00) =
				((BgL_nodez00_bglt)
					BGl_tracezd2nodezd2zztrace_walkz00((((BgL_setzd2exzd2itz00_bglt)
								COBJECT(((BgL_setzd2exzd2itz00_bglt) BgL_nodez00_2742)))->
							BgL_bodyz00), BgL_stackz00_2743, BgL_levelz00_2744)), BUNSPEC);
			return ((BgL_nodez00_bglt) ((BgL_setzd2exzd2itz00_bglt)
					BgL_nodez00_2742));
		}

	}



/* &trace-node-let-var1375 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2letzd2var1375zb0zztrace_walkz00(obj_t
		BgL_envz00_2745, obj_t BgL_nodez00_2746, obj_t BgL_stackz00_2747,
		obj_t BgL_levelz00_2748)
	{
		{	/* Trace/walk.scm 399 */
			{	/* Trace/walk.scm 401 */
				obj_t BgL_g1314z00_2876;

				BgL_g1314z00_2876 =
					(((BgL_letzd2varzd2_bglt) COBJECT(
							((BgL_letzd2varzd2_bglt) BgL_nodez00_2746)))->BgL_bindingsz00);
				{
					obj_t BgL_l1312z00_2878;

					BgL_l1312z00_2878 = BgL_g1314z00_2876;
				BgL_zc3z04anonymousza31899ze3z87_2877:
					if (PAIRP(BgL_l1312z00_2878))
						{	/* Trace/walk.scm 401 */
							{	/* Trace/walk.scm 402 */
								obj_t BgL_bindingz00_2879;

								BgL_bindingz00_2879 = CAR(BgL_l1312z00_2878);
								{	/* Trace/walk.scm 402 */
									BgL_nodez00_bglt BgL_arg1901z00_2880;

									{	/* Trace/walk.scm 402 */
										obj_t BgL_arg1902z00_2881;

										BgL_arg1902z00_2881 = CDR(((obj_t) BgL_bindingz00_2879));
										BgL_arg1901z00_2880 =
											BGl_tracezd2nodezd2zztrace_walkz00(
											((BgL_nodez00_bglt) BgL_arg1902z00_2881),
											BgL_stackz00_2747, BgL_levelz00_2748);
									}
									{	/* Trace/walk.scm 402 */
										obj_t BgL_auxz00_3644;
										obj_t BgL_tmpz00_3642;

										BgL_auxz00_3644 = ((obj_t) BgL_arg1901z00_2880);
										BgL_tmpz00_3642 = ((obj_t) BgL_bindingz00_2879);
										SET_CDR(BgL_tmpz00_3642, BgL_auxz00_3644);
									}
								}
							}
							{
								obj_t BgL_l1312z00_3647;

								BgL_l1312z00_3647 = CDR(BgL_l1312z00_2878);
								BgL_l1312z00_2878 = BgL_l1312z00_3647;
								goto BgL_zc3z04anonymousza31899ze3z87_2877;
							}
						}
					else
						{	/* Trace/walk.scm 401 */
							((bool_t) 1);
						}
				}
			}
			{
				BgL_nodez00_bglt BgL_auxz00_3649;

				{	/* Trace/walk.scm 404 */
					BgL_nodez00_bglt BgL_arg1904z00_2882;

					BgL_arg1904z00_2882 =
						(((BgL_letzd2varzd2_bglt) COBJECT(
								((BgL_letzd2varzd2_bglt) BgL_nodez00_2746)))->BgL_bodyz00);
					BgL_auxz00_3649 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1904z00_2882,
						BgL_stackz00_2747, BgL_levelz00_2748);
				}
				((((BgL_letzd2varzd2_bglt) COBJECT(
								((BgL_letzd2varzd2_bglt) BgL_nodez00_2746)))->BgL_bodyz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3649), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_letzd2varzd2_bglt) BgL_nodez00_2746));
		}

	}



/* &trace-node-let-fun1372 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2letzd2fun1372zb0zztrace_walkz00(obj_t
		BgL_envz00_2749, obj_t BgL_nodez00_2750, obj_t BgL_stackz00_2751,
		obj_t BgL_levelz00_2752)
	{
		{	/* Trace/walk.scm 383 */
			if (BGl_isloopzf3zf3zztrace_isloopz00(
					((BgL_letzd2funzd2_bglt) BgL_nodez00_2750)))
				{	/* Trace/walk.scm 384 */
					{	/* Trace/walk.scm 386 */
						obj_t BgL_varz00_2884;

						BgL_varz00_2884 =
							CAR(
							(((BgL_letzd2funzd2_bglt) COBJECT(
										((BgL_letzd2funzd2_bglt) BgL_nodez00_2750)))->
								BgL_localsz00));
						{	/* Trace/walk.scm 386 */
							BgL_typez00_bglt BgL_tz00_2885;

							{	/* Trace/walk.scm 387 */
								BgL_typez00_bglt BgL_arg1891z00_2886;
								BgL_typez00_bglt BgL_arg1892z00_2887;

								BgL_arg1891z00_2886 =
									(((BgL_nodez00_bglt) COBJECT(
											(((BgL_letzd2funzd2_bglt) COBJECT(
														((BgL_letzd2funzd2_bglt) BgL_nodez00_2750)))->
												BgL_bodyz00)))->BgL_typez00);
								BgL_arg1892z00_2887 =
									(((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
												BgL_varz00_2884)))->BgL_typez00);
								BgL_tz00_2885 =
									BGl_strictzd2nodezd2typez00zzast_nodez00(BgL_arg1891z00_2886,
									BgL_arg1892z00_2887);
							}
							{	/* Trace/walk.scm 387 */
								obj_t BgL_idz00_2888;

								BgL_idz00_2888 =
									BGl_tracezd2idzd2zztrace_walkz00(BgL_varz00_2884);
								{	/* Trace/walk.scm 388 */

									{
										BgL_nodez00_bglt BgL_auxz00_3670;

										{	/* Trace/walk.scm 389 */
											BgL_nodez00_bglt BgL_arg1889z00_2889;
											obj_t BgL_arg1890z00_2890;

											BgL_arg1889z00_2889 =
												(((BgL_letzd2funzd2_bglt) COBJECT(
														((BgL_letzd2funzd2_bglt) BgL_nodez00_2750)))->
												BgL_bodyz00);
											BgL_arg1890z00_2890 =
												(((BgL_nodez00_bglt)
													COBJECT(((BgL_nodez00_bglt) ((BgL_letzd2funzd2_bglt)
																BgL_nodez00_2750))))->BgL_locz00);
											BgL_auxz00_3670 =
												((BgL_nodez00_bglt)
												BGl_makezd2tracedzd2nodez00zztrace_walkz00
												(BgL_arg1889z00_2889, BgL_tz00_2885, BgL_idz00_2888,
													BgL_arg1890z00_2890, BNIL));
										}
										((((BgL_letzd2funzd2_bglt) COBJECT(
														((BgL_letzd2funzd2_bglt) BgL_nodez00_2750)))->
												BgL_bodyz00) =
											((BgL_nodez00_bglt) BgL_auxz00_3670), BUNSPEC);
									}
								}
							}
						}
					}
					return
						((BgL_nodez00_bglt) ((BgL_letzd2funzd2_bglt) BgL_nodez00_2750));
				}
			else
				{	/* Trace/walk.scm 384 */
					{	/* Trace/walk.scm 392 */
						obj_t BgL_g1311z00_2891;

						BgL_g1311z00_2891 =
							(((BgL_letzd2funzd2_bglt) COBJECT(
									((BgL_letzd2funzd2_bglt) BgL_nodez00_2750)))->BgL_localsz00);
						{
							obj_t BgL_l1309z00_2893;

							BgL_l1309z00_2893 = BgL_g1311z00_2891;
						BgL_zc3z04anonymousza31895ze3z87_2892:
							if (PAIRP(BgL_l1309z00_2893))
								{	/* Trace/walk.scm 392 */
									BGl_tracezd2funz12zc0zztrace_walkz00(CAR(BgL_l1309z00_2893),
										BgL_stackz00_2751, BgL_levelz00_2752);
									{
										obj_t BgL_l1309z00_3688;

										BgL_l1309z00_3688 = CDR(BgL_l1309z00_2893);
										BgL_l1309z00_2893 = BgL_l1309z00_3688;
										goto BgL_zc3z04anonymousza31895ze3z87_2892;
									}
								}
							else
								{	/* Trace/walk.scm 392 */
									((bool_t) 1);
								}
						}
					}
					{
						BgL_nodez00_bglt BgL_auxz00_3690;

						{	/* Trace/walk.scm 393 */
							BgL_nodez00_bglt BgL_arg1898z00_2894;

							BgL_arg1898z00_2894 =
								(((BgL_letzd2funzd2_bglt) COBJECT(
										((BgL_letzd2funzd2_bglt) BgL_nodez00_2750)))->BgL_bodyz00);
							BgL_auxz00_3690 =
								BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1898z00_2894,
								BgL_stackz00_2751, BgL_levelz00_2752);
						}
						((((BgL_letzd2funzd2_bglt) COBJECT(
										((BgL_letzd2funzd2_bglt) BgL_nodez00_2750)))->BgL_bodyz00) =
							((BgL_nodez00_bglt) BgL_auxz00_3690), BUNSPEC);
					}
					return
						((BgL_nodez00_bglt) ((BgL_letzd2funzd2_bglt) BgL_nodez00_2750));
				}
		}

	}



/* &trace-node-switch1370 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2switch1370z62zztrace_walkz00(obj_t
		BgL_envz00_2753, obj_t BgL_nodez00_2754, obj_t BgL_stackz00_2755,
		obj_t BgL_levelz00_2756)
	{
		{	/* Trace/walk.scm 372 */
			{
				BgL_nodez00_bglt BgL_auxz00_3698;

				{	/* Trace/walk.scm 374 */
					BgL_nodez00_bglt BgL_arg1882z00_2896;

					BgL_arg1882z00_2896 =
						(((BgL_switchz00_bglt) COBJECT(
								((BgL_switchz00_bglt) BgL_nodez00_2754)))->BgL_testz00);
					BgL_auxz00_3698 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1882z00_2896,
						BgL_stackz00_2755, BgL_levelz00_2756);
				}
				((((BgL_switchz00_bglt) COBJECT(
								((BgL_switchz00_bglt) BgL_nodez00_2754)))->BgL_testz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3698), BUNSPEC);
			}
			{	/* Trace/walk.scm 375 */
				obj_t BgL_g1308z00_2897;

				BgL_g1308z00_2897 =
					(((BgL_switchz00_bglt) COBJECT(
							((BgL_switchz00_bglt) BgL_nodez00_2754)))->BgL_clausesz00);
				{
					obj_t BgL_l1306z00_2899;

					BgL_l1306z00_2899 = BgL_g1308z00_2897;
				BgL_zc3z04anonymousza31883ze3z87_2898:
					if (PAIRP(BgL_l1306z00_2899))
						{	/* Trace/walk.scm 375 */
							{	/* Trace/walk.scm 376 */
								obj_t BgL_clausez00_2900;

								BgL_clausez00_2900 = CAR(BgL_l1306z00_2899);
								{	/* Trace/walk.scm 376 */
									BgL_nodez00_bglt BgL_arg1885z00_2901;

									{	/* Trace/walk.scm 376 */
										obj_t BgL_arg1886z00_2902;

										BgL_arg1886z00_2902 = CDR(((obj_t) BgL_clausez00_2900));
										BgL_arg1885z00_2901 =
											BGl_tracezd2nodezd2zztrace_walkz00(
											((BgL_nodez00_bglt) BgL_arg1886z00_2902),
											BgL_stackz00_2755, BgL_levelz00_2756);
									}
									{	/* Trace/walk.scm 376 */
										obj_t BgL_auxz00_3715;
										obj_t BgL_tmpz00_3713;

										BgL_auxz00_3715 = ((obj_t) BgL_arg1885z00_2901);
										BgL_tmpz00_3713 = ((obj_t) BgL_clausez00_2900);
										SET_CDR(BgL_tmpz00_3713, BgL_auxz00_3715);
									}
								}
							}
							{
								obj_t BgL_l1306z00_3718;

								BgL_l1306z00_3718 = CDR(BgL_l1306z00_2899);
								BgL_l1306z00_2899 = BgL_l1306z00_3718;
								goto BgL_zc3z04anonymousza31883ze3z87_2898;
							}
						}
					else
						{	/* Trace/walk.scm 375 */
							((bool_t) 1);
						}
				}
			}
			return ((BgL_nodez00_bglt) ((BgL_switchz00_bglt) BgL_nodez00_2754));
		}

	}



/* &trace-node-fail1367 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2fail1367z62zztrace_walkz00(obj_t
		BgL_envz00_2757, obj_t BgL_nodez00_2758, obj_t BgL_stackz00_2759,
		obj_t BgL_levelz00_2760)
	{
		{	/* Trace/walk.scm 362 */
			{
				BgL_nodez00_bglt BgL_auxz00_3722;

				{	/* Trace/walk.scm 364 */
					BgL_nodez00_bglt BgL_arg1879z00_2904;

					BgL_arg1879z00_2904 =
						(((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nodez00_2758)))->BgL_procz00);
					BgL_auxz00_3722 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1879z00_2904,
						BgL_stackz00_2759, BgL_levelz00_2760);
				}
				((((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nodez00_2758)))->BgL_procz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3722), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_3728;

				{	/* Trace/walk.scm 365 */
					BgL_nodez00_bglt BgL_arg1880z00_2905;

					BgL_arg1880z00_2905 =
						(((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nodez00_2758)))->BgL_msgz00);
					BgL_auxz00_3728 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1880z00_2905,
						BgL_stackz00_2759, BgL_levelz00_2760);
				}
				((((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nodez00_2758)))->BgL_msgz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3728), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_3734;

				{	/* Trace/walk.scm 366 */
					BgL_nodez00_bglt BgL_arg1881z00_2906;

					BgL_arg1881z00_2906 =
						(((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nodez00_2758)))->BgL_objz00);
					BgL_auxz00_3734 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1881z00_2906,
						BgL_stackz00_2759, BgL_levelz00_2760);
				}
				((((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nodez00_2758)))->BgL_objz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3734), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_failz00_bglt) BgL_nodez00_2758));
		}

	}



/* &trace-node-condition1364 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2condition1364z62zztrace_walkz00(obj_t
		BgL_envz00_2761, obj_t BgL_nodez00_2762, obj_t BgL_stackz00_2763,
		obj_t BgL_levelz00_2764)
	{
		{	/* Trace/walk.scm 352 */
			{
				BgL_nodez00_bglt BgL_auxz00_3742;

				{	/* Trace/walk.scm 354 */
					BgL_nodez00_bglt BgL_arg1876z00_2908;

					BgL_arg1876z00_2908 =
						(((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nodez00_2762)))->BgL_testz00);
					BgL_auxz00_3742 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1876z00_2908,
						BgL_stackz00_2763, BgL_levelz00_2764);
				}
				((((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nodez00_2762)))->BgL_testz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3742), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_3748;

				{	/* Trace/walk.scm 355 */
					BgL_nodez00_bglt BgL_arg1877z00_2909;

					BgL_arg1877z00_2909 =
						(((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nodez00_2762)))->BgL_truez00);
					BgL_auxz00_3748 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1877z00_2909,
						BgL_stackz00_2763, BgL_levelz00_2764);
				}
				((((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nodez00_2762)))->BgL_truez00) =
					((BgL_nodez00_bglt) BgL_auxz00_3748), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_3754;

				{	/* Trace/walk.scm 356 */
					BgL_nodez00_bglt BgL_arg1878z00_2910;

					BgL_arg1878z00_2910 =
						(((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nodez00_2762)))->BgL_falsez00);
					BgL_auxz00_3754 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1878z00_2910,
						BgL_stackz00_2763, BgL_levelz00_2764);
				}
				((((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nodez00_2762)))->BgL_falsez00) =
					((BgL_nodez00_bglt) BgL_auxz00_3754), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_conditionalz00_bglt) BgL_nodez00_2762));
		}

	}



/* &trace-node-setq1362 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2setq1362z62zztrace_walkz00(obj_t
		BgL_envz00_2765, obj_t BgL_nodez00_2766, obj_t BgL_stackz00_2767,
		obj_t BgL_levelz00_2768)
	{
		{	/* Trace/walk.scm 345 */
			((((BgL_setqz00_bglt) COBJECT(
							((BgL_setqz00_bglt) BgL_nodez00_2766)))->BgL_valuez00) =
				((BgL_nodez00_bglt)
					BGl_tracezd2nodezd2zztrace_walkz00((((BgL_setqz00_bglt)
								COBJECT(((BgL_setqz00_bglt) BgL_nodez00_2766)))->BgL_valuez00),
						BgL_stackz00_2767, BgL_levelz00_2768)), BUNSPEC);
			return ((BgL_nodez00_bglt) ((BgL_setqz00_bglt) BgL_nodez00_2766));
		}

	}



/* &trace-node-cast1360 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2cast1360z62zztrace_walkz00(obj_t
		BgL_envz00_2769, obj_t BgL_nodez00_2770, obj_t BgL_stackz00_2771,
		obj_t BgL_levelz00_2772)
	{
		{	/* Trace/walk.scm 338 */
			((((BgL_castz00_bglt) COBJECT(
							((BgL_castz00_bglt) BgL_nodez00_2770)))->BgL_argz00) =
				((BgL_nodez00_bglt)
					BGl_tracezd2nodezd2zztrace_walkz00((((BgL_castz00_bglt)
								COBJECT(((BgL_castz00_bglt) BgL_nodez00_2770)))->BgL_argz00),
						BgL_stackz00_2771, BgL_levelz00_2772)), BUNSPEC);
			return ((BgL_nodez00_bglt) ((BgL_castz00_bglt) BgL_nodez00_2770));
		}

	}



/* &trace-node-extern1358 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2extern1358z62zztrace_walkz00(obj_t
		BgL_envz00_2773, obj_t BgL_nodez00_2774, obj_t BgL_stackz00_2775,
		obj_t BgL_levelz00_2776)
	{
		{	/* Trace/walk.scm 331 */
			BGl_tracezd2nodeza2z12z62zztrace_walkz00(
				(((BgL_externz00_bglt) COBJECT(
							((BgL_externz00_bglt) BgL_nodez00_2774)))->BgL_exprza2za2),
				BgL_stackz00_2775, BgL_levelz00_2776);
			return ((BgL_nodez00_bglt) ((BgL_externz00_bglt) BgL_nodez00_2774));
		}

	}



/* &trace-node-funcall1356 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2funcall1356z62zztrace_walkz00(obj_t
		BgL_envz00_2777, obj_t BgL_nodez00_2778, obj_t BgL_stackz00_2779,
		obj_t BgL_levelz00_2780)
	{
		{	/* Trace/walk.scm 322 */
			{
				BgL_nodez00_bglt BgL_auxz00_3781;

				{	/* Trace/walk.scm 324 */
					BgL_nodez00_bglt BgL_arg1868z00_2915;

					BgL_arg1868z00_2915 =
						(((BgL_funcallz00_bglt) COBJECT(
								((BgL_funcallz00_bglt) BgL_nodez00_2778)))->BgL_funz00);
					BgL_auxz00_3781 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1868z00_2915,
						BgL_stackz00_2779, BgL_levelz00_2780);
				}
				((((BgL_funcallz00_bglt) COBJECT(
								((BgL_funcallz00_bglt) BgL_nodez00_2778)))->BgL_funz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3781), BUNSPEC);
			}
			BGl_tracezd2nodeza2z12z62zztrace_walkz00(
				(((BgL_funcallz00_bglt) COBJECT(
							((BgL_funcallz00_bglt) BgL_nodez00_2778)))->BgL_argsz00),
				BgL_stackz00_2779, BgL_levelz00_2780);
			return ((BgL_nodez00_bglt) ((BgL_funcallz00_bglt) BgL_nodez00_2778));
		}

	}



/* &trace-node-app-ly1354 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2appzd2ly1354zb0zztrace_walkz00(obj_t
		BgL_envz00_2781, obj_t BgL_nodez00_2782, obj_t BgL_stackz00_2783,
		obj_t BgL_levelz00_2784)
	{
		{	/* Trace/walk.scm 313 */
			{
				BgL_nodez00_bglt BgL_auxz00_3792;

				{	/* Trace/walk.scm 315 */
					BgL_nodez00_bglt BgL_arg1866z00_2917;

					BgL_arg1866z00_2917 =
						(((BgL_appzd2lyzd2_bglt) COBJECT(
								((BgL_appzd2lyzd2_bglt) BgL_nodez00_2782)))->BgL_funz00);
					BgL_auxz00_3792 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1866z00_2917,
						BgL_stackz00_2783, BgL_levelz00_2784);
				}
				((((BgL_appzd2lyzd2_bglt) COBJECT(
								((BgL_appzd2lyzd2_bglt) BgL_nodez00_2782)))->BgL_funz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3792), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_3798;

				{	/* Trace/walk.scm 316 */
					BgL_nodez00_bglt BgL_arg1867z00_2918;

					BgL_arg1867z00_2918 =
						(((BgL_appzd2lyzd2_bglt) COBJECT(
								((BgL_appzd2lyzd2_bglt) BgL_nodez00_2782)))->BgL_argz00);
					BgL_auxz00_3798 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1867z00_2918,
						BgL_stackz00_2783, BgL_levelz00_2784);
				}
				((((BgL_appzd2lyzd2_bglt) COBJECT(
								((BgL_appzd2lyzd2_bglt) BgL_nodez00_2782)))->BgL_argz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3798), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_appzd2lyzd2_bglt) BgL_nodez00_2782));
		}

	}



/* &trace-node-app1352 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2app1352z62zztrace_walkz00(obj_t
		BgL_envz00_2785, obj_t BgL_nodez00_2786, obj_t BgL_stackz00_2787,
		obj_t BgL_levelz00_2788)
	{
		{	/* Trace/walk.scm 306 */
			BGl_tracezd2nodeza2z12z62zztrace_walkz00(
				(((BgL_appz00_bglt) COBJECT(
							((BgL_appz00_bglt) BgL_nodez00_2786)))->BgL_argsz00),
				BgL_stackz00_2787, BgL_levelz00_2788);
			return ((BgL_nodez00_bglt) ((BgL_appz00_bglt) BgL_nodez00_2786));
		}

	}



/* &trace-node-sync1350 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2sync1350z62zztrace_walkz00(obj_t
		BgL_envz00_2789, obj_t BgL_nodez00_2790, obj_t BgL_stackz00_2791,
		obj_t BgL_levelz00_2792)
	{
		{	/* Trace/walk.scm 296 */
			{
				BgL_nodez00_bglt BgL_auxz00_3811;

				{	/* Trace/walk.scm 298 */
					BgL_nodez00_bglt BgL_arg1861z00_2921;

					BgL_arg1861z00_2921 =
						(((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nodez00_2790)))->BgL_mutexz00);
					BgL_auxz00_3811 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1861z00_2921,
						BgL_stackz00_2791, BgL_levelz00_2792);
				}
				((((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nodez00_2790)))->BgL_mutexz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3811), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_3817;

				{	/* Trace/walk.scm 299 */
					BgL_nodez00_bglt BgL_arg1863z00_2922;

					BgL_arg1863z00_2922 =
						(((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nodez00_2790)))->BgL_prelockz00);
					BgL_auxz00_3817 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1863z00_2922,
						BgL_stackz00_2791, BgL_levelz00_2792);
				}
				((((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nodez00_2790)))->BgL_prelockz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3817), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_3823;

				{	/* Trace/walk.scm 300 */
					BgL_nodez00_bglt BgL_arg1864z00_2923;

					BgL_arg1864z00_2923 =
						(((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nodez00_2790)))->BgL_bodyz00);
					BgL_auxz00_3823 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1864z00_2923,
						BgL_stackz00_2791, BgL_levelz00_2792);
				}
				((((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nodez00_2790)))->BgL_bodyz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3823), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_syncz00_bglt) BgL_nodez00_2790));
		}

	}



/* &trace-node-sequence1348 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2sequence1348z62zztrace_walkz00(obj_t
		BgL_envz00_2793, obj_t BgL_nodez00_2794, obj_t BgL_stackz00_2795,
		obj_t BgL_levelz00_2796)
	{
		{	/* Trace/walk.scm 289 */
			BGl_tracezd2nodeza2z12z62zztrace_walkz00(
				(((BgL_sequencez00_bglt) COBJECT(
							((BgL_sequencez00_bglt) BgL_nodez00_2794)))->BgL_nodesz00),
				BgL_stackz00_2795, BgL_levelz00_2796);
			return ((BgL_nodez00_bglt) ((BgL_sequencez00_bglt) BgL_nodez00_2794));
		}

	}



/* &find-last-node-jump-1344 */
	obj_t BGl_z62findzd2lastzd2nodezd2jumpzd21344z62zztrace_walkz00(obj_t
		BgL_envz00_2797, obj_t BgL_nodez00_2798)
	{
		{	/* Trace/walk.scm 239 */
			return
				BGl_findzd2lastzd2nodez00zztrace_walkz00(
				(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
							((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_2798)))->BgL_valuez00));
		}

	}



/* &find-last-node-set-e1342 */
	obj_t BGl_z62findzd2lastzd2nodezd2setzd2e1342z62zztrace_walkz00(obj_t
		BgL_envz00_2799, obj_t BgL_nodez00_2800)
	{
		{	/* Trace/walk.scm 233 */
			return
				BGl_findzd2lastzd2nodez00zztrace_walkz00(
				(((BgL_setzd2exzd2itz00_bglt) COBJECT(
							((BgL_setzd2exzd2itz00_bglt) BgL_nodez00_2800)))->BgL_bodyz00));
		}

	}



/* &find-last-node-let-f1340 */
	obj_t BGl_z62findzd2lastzd2nodezd2letzd2f1340z62zztrace_walkz00(obj_t
		BgL_envz00_2801, obj_t BgL_nodez00_2802)
	{
		{	/* Trace/walk.scm 227 */
			return
				BGl_findzd2lastzd2nodez00zztrace_walkz00(
				(((BgL_letzd2funzd2_bglt) COBJECT(
							((BgL_letzd2funzd2_bglt) BgL_nodez00_2802)))->BgL_bodyz00));
		}

	}



/* &find-last-node-let-v1338 */
	obj_t BGl_z62findzd2lastzd2nodezd2letzd2v1338z62zztrace_walkz00(obj_t
		BgL_envz00_2803, obj_t BgL_nodez00_2804)
	{
		{	/* Trace/walk.scm 221 */
			return
				BGl_findzd2lastzd2nodez00zztrace_walkz00(
				(((BgL_letzd2varzd2_bglt) COBJECT(
							((BgL_letzd2varzd2_bglt) BgL_nodez00_2804)))->BgL_bodyz00));
		}

	}



/* &find-last-node-switc1336 */
	obj_t BGl_z62findzd2lastzd2nodezd2switc1336zb0zztrace_walkz00(obj_t
		BgL_envz00_2805, obj_t BgL_nodez00_2806)
	{
		{	/* Trace/walk.scm 212 */
			{	/* Trace/walk.scm 214 */
				bool_t BgL_test2278z00_3848;

				{	/* Trace/walk.scm 214 */
					obj_t BgL_tmpz00_3849;

					BgL_tmpz00_3849 =
						(((BgL_switchz00_bglt) COBJECT(
								((BgL_switchz00_bglt) BgL_nodez00_2806)))->BgL_clausesz00);
					BgL_test2278z00_3848 = PAIRP(BgL_tmpz00_3849);
				}
				if (BgL_test2278z00_3848)
					{	/* Trace/walk.scm 215 */
						obj_t BgL_arg1851z00_2930;

						BgL_arg1851z00_2930 =
							CDR(BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(
								(((BgL_switchz00_bglt) COBJECT(
											((BgL_switchz00_bglt) BgL_nodez00_2806)))->
									BgL_clausesz00)));
						return BGl_findzd2lastzd2nodez00zztrace_walkz00(((BgL_nodez00_bglt)
								BgL_arg1851z00_2930));
					}
				else
					{	/* Trace/walk.scm 214 */
						return
							BGl_findzd2lastzd2sexpz00zztrace_walkz00(
							((obj_t)
								(((BgL_switchz00_bglt) COBJECT(
											((BgL_switchz00_bglt) BgL_nodez00_2806)))->BgL_testz00)));
					}
			}
		}

	}



/* &find-last-node-fail1334 */
	obj_t BGl_z62findzd2lastzd2nodezd2fail1334zb0zztrace_walkz00(obj_t
		BgL_envz00_2807, obj_t BgL_nodez00_2808)
	{
		{	/* Trace/walk.scm 206 */
			return
				BGl_findzd2lastzd2nodez00zztrace_walkz00(
				(((BgL_failz00_bglt) COBJECT(
							((BgL_failz00_bglt) BgL_nodez00_2808)))->BgL_objz00));
		}

	}



/* &find-last-node-condi1332 */
	obj_t BGl_z62findzd2lastzd2nodezd2condi1332zb0zztrace_walkz00(obj_t
		BgL_envz00_2809, obj_t BgL_nodez00_2810)
	{
		{	/* Trace/walk.scm 200 */
			return
				BGl_findzd2lastzd2nodez00zztrace_walkz00(
				(((BgL_conditionalz00_bglt) COBJECT(
							((BgL_conditionalz00_bglt) BgL_nodez00_2810)))->BgL_falsez00));
		}

	}



/* &find-last-node-setq1330 */
	obj_t BGl_z62findzd2lastzd2nodezd2setq1330zb0zztrace_walkz00(obj_t
		BgL_envz00_2811, obj_t BgL_nodez00_2812)
	{
		{	/* Trace/walk.scm 194 */
			return
				BGl_findzd2lastzd2nodez00zztrace_walkz00(
				(((BgL_setqz00_bglt) COBJECT(
							((BgL_setqz00_bglt) BgL_nodez00_2812)))->BgL_valuez00));
		}

	}



/* &find-last-node-exter1328 */
	obj_t BGl_z62findzd2lastzd2nodezd2exter1328zb0zztrace_walkz00(obj_t
		BgL_envz00_2813, obj_t BgL_nodez00_2814)
	{
		{	/* Trace/walk.scm 185 */
			if (NULLP(
					(((BgL_externz00_bglt) COBJECT(
								((BgL_externz00_bglt) BgL_nodez00_2814)))->BgL_exprza2za2)))
				{	/* Trace/walk.scm 187 */
					return ((obj_t) ((BgL_externz00_bglt) BgL_nodez00_2814));
				}
			else
				{	/* Trace/walk.scm 188 */
					obj_t BgL_arg1837z00_2935;

					BgL_arg1837z00_2935 =
						CAR(BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(
							(((BgL_externz00_bglt) COBJECT(
										((BgL_externz00_bglt) BgL_nodez00_2814)))->
								BgL_exprza2za2)));
					return BGl_findzd2lastzd2nodez00zztrace_walkz00(((BgL_nodez00_bglt)
							BgL_arg1837z00_2935));
				}
		}

	}



/* &find-last-node-funca1326 */
	obj_t BGl_z62findzd2lastzd2nodezd2funca1326zb0zztrace_walkz00(obj_t
		BgL_envz00_2815, obj_t BgL_nodez00_2816)
	{
		{	/* Trace/walk.scm 176 */
			{	/* Trace/walk.scm 178 */
				bool_t BgL_test2280z00_3884;

				{	/* Trace/walk.scm 178 */
					obj_t BgL_tmpz00_3885;

					BgL_tmpz00_3885 =
						(((BgL_funcallz00_bglt) COBJECT(
								((BgL_funcallz00_bglt) BgL_nodez00_2816)))->BgL_argsz00);
					BgL_test2280z00_3884 = PAIRP(BgL_tmpz00_3885);
				}
				if (BgL_test2280z00_3884)
					{	/* Trace/walk.scm 179 */
						obj_t BgL_arg1829z00_2937;

						BgL_arg1829z00_2937 =
							CAR(BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(
								(((BgL_funcallz00_bglt) COBJECT(
											((BgL_funcallz00_bglt) BgL_nodez00_2816)))->
									BgL_argsz00)));
						return BGl_findzd2lastzd2nodez00zztrace_walkz00(((BgL_nodez00_bglt)
								BgL_arg1829z00_2937));
					}
				else
					{	/* Trace/walk.scm 178 */
						return
							BGl_findzd2lastzd2nodez00zztrace_walkz00(
							(((BgL_funcallz00_bglt) COBJECT(
										((BgL_funcallz00_bglt) BgL_nodez00_2816)))->BgL_funz00));
					}
			}
		}

	}



/* &find-last-node-app-l1324 */
	obj_t BGl_z62findzd2lastzd2nodezd2appzd2l1324z62zztrace_walkz00(obj_t
		BgL_envz00_2817, obj_t BgL_nodez00_2818)
	{
		{	/* Trace/walk.scm 170 */
			return
				BGl_findzd2lastzd2nodez00zztrace_walkz00(
				(((BgL_appzd2lyzd2_bglt) COBJECT(
							((BgL_appzd2lyzd2_bglt) BgL_nodez00_2818)))->BgL_argz00));
		}

	}



/* &find-last-node-app1322 */
	obj_t BGl_z62findzd2lastzd2nodezd2app1322zb0zztrace_walkz00(obj_t
		BgL_envz00_2819, obj_t BgL_nodez00_2820)
	{
		{	/* Trace/walk.scm 161 */
			{	/* Trace/walk.scm 163 */
				bool_t BgL_test2281z00_3901;

				{	/* Trace/walk.scm 163 */
					obj_t BgL_tmpz00_3902;

					BgL_tmpz00_3902 =
						(((BgL_appz00_bglt) COBJECT(
								((BgL_appz00_bglt) BgL_nodez00_2820)))->BgL_argsz00);
					BgL_test2281z00_3901 = PAIRP(BgL_tmpz00_3902);
				}
				if (BgL_test2281z00_3901)
					{	/* Trace/walk.scm 164 */
						obj_t BgL_arg1821z00_2940;

						BgL_arg1821z00_2940 =
							CAR(BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(
								(((BgL_appz00_bglt) COBJECT(
											((BgL_appz00_bglt) BgL_nodez00_2820)))->BgL_argsz00)));
						return
							BGl_findzd2lastzd2nodez00zztrace_walkz00(
							((BgL_nodez00_bglt) BgL_arg1821z00_2940));
					}
				else
					{	/* Trace/walk.scm 163 */
						return ((obj_t) ((BgL_appz00_bglt) BgL_nodez00_2820));
					}
			}
		}

	}



/* &find-last-node-sync1320 */
	obj_t BGl_z62findzd2lastzd2nodezd2sync1320zb0zztrace_walkz00(obj_t
		BgL_envz00_2821, obj_t BgL_nodez00_2822)
	{
		{	/* Trace/walk.scm 154 */
			return
				BGl_findzd2lastzd2nodez00zztrace_walkz00(
				(((BgL_syncz00_bglt) COBJECT(
							((BgL_syncz00_bglt) BgL_nodez00_2822)))->BgL_bodyz00));
		}

	}



/* &find-last-node-seque1318 */
	obj_t BGl_z62findzd2lastzd2nodezd2seque1318zb0zztrace_walkz00(obj_t
		BgL_envz00_2823, obj_t BgL_nodez00_2824)
	{
		{	/* Trace/walk.scm 145 */
			if (NULLP(
					(((BgL_sequencez00_bglt) COBJECT(
								((BgL_sequencez00_bglt) BgL_nodez00_2824)))->BgL_nodesz00)))
				{	/* Trace/walk.scm 147 */
					return ((obj_t) ((BgL_sequencez00_bglt) BgL_nodez00_2824));
				}
			else
				{	/* Trace/walk.scm 148 */
					obj_t BgL_arg1813z00_2943;

					BgL_arg1813z00_2943 =
						CAR(BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(
							(((BgL_sequencez00_bglt) COBJECT(
										((BgL_sequencez00_bglt) BgL_nodez00_2824)))->
								BgL_nodesz00)));
					return BGl_findzd2lastzd2nodez00zztrace_walkz00(((BgL_nodez00_bglt)
							BgL_arg1813z00_2943));
				}
		}

	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zztrace_walkz00()
	{
		{	/* Trace/walk.scm 15 */
			BGl_modulezd2initializa7ationz75zztools_speekz00(((long) 61247943),
				BSTRING_TO_STRING(BGl_string2163z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 300504031),
				BSTRING_TO_STRING(BGl_string2163z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzengine_passz00(((long) 373082237),
				BSTRING_TO_STRING(BGl_string2163z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 515343395),
				BSTRING_TO_STRING(BGl_string2163z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 90839984),
				BSTRING_TO_STRING(BGl_string2163z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 506185397),
				BSTRING_TO_STRING(BGl_string2163z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzast_letz00(((long) 469204197),
				BSTRING_TO_STRING(BGl_string2163z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 365925558),
				BSTRING_TO_STRING(BGl_string2163z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zztools_miscz00(((long) 9470071),
				BSTRING_TO_STRING(BGl_string2163z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zztools_locationz00(((long) 462333240),
				BSTRING_TO_STRING(BGl_string2163z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zztype_envz00(((long) 296457443),
				BSTRING_TO_STRING(BGl_string2163z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzbackend_backendz00(((long) 216206620),
				BSTRING_TO_STRING(BGl_string2163z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzast_sexpz00(((long) 36886173),
				BSTRING_TO_STRING(BGl_string2163z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzast_identz00(((long) 174885617),
				BSTRING_TO_STRING(BGl_string2163z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzmodule_modulez00(((long) 158397907),
				BSTRING_TO_STRING(BGl_string2163z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 476633989),
				BSTRING_TO_STRING(BGl_string2163z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zztrace_isloopz00(((long) 332486922),
				BSTRING_TO_STRING(BGl_string2163z00zztrace_walkz00));
			return
				BGl_modulezd2initializa7ationz75zzast_envz00(((long) 146730773),
				BSTRING_TO_STRING(BGl_string2163z00zztrace_walkz00));
		}

	}

#ifdef __cplusplus
}
#endif
