/*===========================================================================*/
/*   (Eval/evaluate_types.scm)                                               */
/*   Bigloo (4.3g)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu 27 Feb 2020 07:59:49 AM CET     */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo4.3g/bin/bigloo -srfi enable-resolv -srfi enable-unistring -srfi enable-pcre -srfi enable-gmp -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo4.3g/lib/bigloo/4.3g -rm -copt -w -lib-dir /builddir/build/BUILD/bigloo4.3g/lib/bigloo/4.3g -O4 -mklib -unsafe -safee -cc gcc -fsharing -q -no-hello -p -srfi bigloo-profile -c Eval/evaluate_types.scm -o objs/obj_p/Eval/evaluate_types.o) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_ev_exprz00_bgl {
   header_t header;
   obj_t widening;
} *BgL_ev_exprz00_bglt;

typedef struct BgL_ev_varz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_effz00;
   obj_t BgL_typez00;
} *BgL_ev_varz00_bglt;

typedef struct BgL_ev_globalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   obj_t BgL_namez00;
   obj_t BgL_modz00;
} *BgL_ev_globalz00_bglt;

typedef struct BgL_ev_littz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_valuez00;
} *BgL_ev_littz00_bglt;

typedef struct BgL_ev_ifz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_pz00;
   struct BgL_ev_exprz00_bgl * BgL_tz00;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
} *BgL_ev_ifz00_bglt;

typedef struct BgL_ev_listz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_argsz00;
} *BgL_ev_listz00_bglt;

typedef struct BgL_ev_orz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_argsz00;
} *BgL_ev_orz00_bglt;

typedef struct BgL_ev_andz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_argsz00;
} *BgL_ev_andz00_bglt;

typedef struct BgL_ev_prog2z00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_e1z00;
   struct BgL_ev_exprz00_bgl * BgL_e2z00;
} *BgL_ev_prog2z00_bglt;

typedef struct BgL_ev_hookz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
} *BgL_ev_hookz00_bglt;

typedef struct BgL_ev_trapz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
} *BgL_ev_trapz00_bglt;

typedef struct BgL_ev_setlocalz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
   struct BgL_ev_varz00_bgl * BgL_vz00;
} *BgL_ev_setlocalz00_bglt;

typedef struct BgL_ev_setglobalz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
   obj_t BgL_locz00;
   obj_t BgL_namez00;
   obj_t BgL_modz00;
} *BgL_ev_setglobalz00_bglt;

typedef struct BgL_ev_defglobalz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
   obj_t BgL_locz00;
   obj_t BgL_namez00;
   obj_t BgL_modz00;
} *BgL_ev_defglobalz00_bglt;

typedef struct BgL_ev_bindzd2exitzd2_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_varz00_bgl * BgL_varz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_bindzd2exitzd2_bglt;

typedef struct BgL_ev_unwindzd2protectzd2_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_unwindzd2protectzd2_bglt;

typedef struct BgL_ev_withzd2handlerzd2_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_handlerz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_withzd2handlerzd2_bglt;

typedef struct BgL_ev_synchroniza7eza7_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_ev_exprz00_bgl * BgL_mutexz00;
   struct BgL_ev_exprz00_bgl * BgL_prelockz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_synchroniza7eza7_bglt;

typedef struct BgL_ev_binderz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_binderz00_bglt;

typedef struct BgL_ev_letz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
   obj_t BgL_boxesz00;
} *BgL_ev_letz00_bglt;

typedef struct BgL_ev_letza2za2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
   obj_t BgL_boxesz00;
} *BgL_ev_letza2za2_bglt;

typedef struct BgL_ev_letrecz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_letrecz00_bglt;

typedef struct BgL_ev_labelsz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   obj_t BgL_envz00;
   obj_t BgL_stkz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
   obj_t BgL_boxesz00;
} *BgL_ev_labelsz00_bglt;

typedef struct BgL_ev_gotoz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_ev_varz00_bgl * BgL_labelz00;
   struct BgL_ev_labelsz00_bgl * BgL_labelsz00;
   obj_t BgL_argsz00;
} *BgL_ev_gotoz00_bglt;

typedef struct BgL_ev_appz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_ev_exprz00_bgl * BgL_funz00;
   obj_t BgL_argsz00;
   obj_t BgL_tailzf3zf3;
} *BgL_ev_appz00_bglt;

typedef struct BgL_ev_absz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   obj_t BgL_wherez00;
   obj_t BgL_arityz00;
   obj_t BgL_varsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
   int BgL_siza7eza7;
   obj_t BgL_bindz00;
   obj_t BgL_freez00;
   obj_t BgL_innerz00;
   obj_t BgL_boxesz00;
} *BgL_ev_absz00_bglt;


static obj_t BGl_z62lambda1927z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1928z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1767z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1768z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_symbol2561z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2565z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2569z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza31668ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1772z62zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_absz00_bglt BGl_z62lambda1934z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1773z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_absz00_bglt BGl_z62lambda1936z62zz__evaluate_typesz00(obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1777z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1778z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
extern obj_t BGl_classzd2nilzd2initz12z12zz__objectz00(obj_t);
static obj_t BGl_symbol2576z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda1942z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1943z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_letz00_bglt BGl_z62lambda1784z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1947z62zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_letz00_bglt BGl_z62lambda1786z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62lambda1948z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_symbol2581z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2586z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda1952z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31597ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1953z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1793z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1794z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1957z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1958z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_symbol2594z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2599z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza31970ze3ze5zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31938ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31849ze3ze5zz__evaluate_typesz00(obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1962z62zz__evaluate_typesz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_letrecz00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda1963z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1968z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1969z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1975z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1976z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_letz00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda1982z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1983z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1989z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_objectzd2initzd2zz__evaluate_typesz00();
static obj_t BGl_z62zc3z04anonymousza31795ze3ze5zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31868ze3ze5zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62lambda1990z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1996z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1997z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31991ze3ze5zz__evaluate_typesz00(obj_t);
extern obj_t bstring_to_symbol(obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_labelsz00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza31977ze3ze5zz__evaluate_typesz00(obj_t);
static obj_t BGl_methodzd2initzd2zz__evaluate_typesz00();
static obj_t BGl_z62zc3z04anonymousza31413ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_absz00zz__evaluate_typesz00 = BUNSPEC;
BGL_EXPORTED_DEF obj_t BGl_ev_ifz00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza31998ze3ze5zz__evaluate_typesz00(obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_gotoz00zz__evaluate_typesz00 = BUNSPEC;
static BgL_ev_exprz00_bglt BGl_z62lambda1401z62zz__evaluate_typesz00(obj_t);
static BgL_ev_varz00_bglt BGl_z62lambda1409z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t);
static BgL_ev_varz00_bglt BGl_z62lambda1411z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31470ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1417z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1418z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_orz00zz__evaluate_typesz00 = BUNSPEC;
BGL_EXPORTED_DEF obj_t BGl_ev_varz00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda1424z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1425z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
extern obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1430z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31812ze3ze5zz__evaluate_typesz00(obj_t);
static obj_t BGl_gczd2rootszd2initz00zz__evaluate_typesz00();
static obj_t BGl_z62lambda1431z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_globalz00_bglt BGl_z62lambda1438z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_andz00zz__evaluate_typesz00 = BUNSPEC;
static BgL_ev_globalz00_bglt BGl_z62lambda1440z62zz__evaluate_typesz00(obj_t);
static BgL_ev_setlocalz00_bglt BGl_z62lambda1603z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_setlocalz00_bglt BGl_z62lambda1605z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62lambda1448z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1449z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_symbol2401z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2405z00zz__evaluate_typesz00 = BUNSPEC;
static BgL_ev_varz00_bglt BGl_z62lambda1611z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1612z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1453z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31547ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1454z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_setglobalz00_bglt BGl_z62lambda1618z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1458z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1459z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_symbol2411z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2416z00zz__evaluate_typesz00 = BUNSPEC;
static BgL_ev_setglobalz00_bglt BGl_z62lambda1620z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62lambda1626z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1627z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_littz00_bglt BGl_z62lambda1466z62zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_littz00_bglt BGl_z62lambda1468z62zz__evaluate_typesz00(obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_appz00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2420z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2425z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2429z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza31832ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31581ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1631z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1632z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1475z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1476z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1639z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_symbol2433z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2437z00zz__evaluate_typesz00 = BUNSPEC;
static BgL_ev_letza2za2_bglt BGl_z62lambda1801z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1640z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_letza2za2_bglt BGl_z62lambda1803z62zz__evaluate_typesz00(obj_t);
static BgL_ev_ifz00_bglt BGl_z62lambda1482z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_synchroniza7eza7zz__evaluate_typesz00 = BUNSPEC;
static BgL_ev_ifz00_bglt BGl_z62lambda1484z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_profzd2initzd2zz__evaluate_typesz00();
static obj_t BGl_symbol2442z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2608z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2446z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda1810z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1811z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_defglobalz00_bglt BGl_z62lambda1652z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1492z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1493z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_defglobalz00_bglt BGl_z62lambda1655z62zz__evaluate_typesz00(obj_t);
static BgL_ev_letrecz00_bglt BGl_z62lambda1818z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1498z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1499z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_symbol2613z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2451z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2456z00zz__evaluate_typesz00 = BUNSPEC;
static BgL_ev_letrecz00_bglt BGl_z62lambda1820z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31908ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31657ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_bindzd2exitzd2_bglt BGl_z62lambda1664z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_bindzd2exitzd2_bglt BGl_z62lambda1666z62zz__evaluate_typesz00(obj_t);
static BgL_ev_labelsz00_bglt BGl_z62lambda1828z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_symbol2623z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2461z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2465z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2629z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2469z00zz__evaluate_typesz00 = BUNSPEC;
static BgL_ev_labelsz00_bglt BGl_z62lambda1830z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31763ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_varz00_bglt BGl_z62lambda1674z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1836z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1675z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1837z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1679z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_symbol2633z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2474z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda1841z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1680z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1842z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1847z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1848z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_unwindzd2protectzd2_bglt BGl_z62lambda1688z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_symbol2640z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2481z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2646z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2486z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza31692ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_unwindzd2protectzd2_bglt BGl_z62lambda1690z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62lambda1854z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1855z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_defglobalz00zz__evaluate_typesz00 = BUNSPEC;
static BgL_ev_exprz00_bglt BGl_z62lambda1696z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1697z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_symbol2652z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2490z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2657z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2495z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_requirezd2initializa7ationz75zz__evaluate_typesz00 = BUNSPEC;
static BgL_ev_exprz00_bglt BGl_z62lambda1860z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1861z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1866z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1867z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_symbol2663z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2667z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza31856ze3ze5zz__evaluate_typesz00(obj_t);
static BgL_ev_gotoz00_bglt BGl_z62lambda1874z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_ev_gotoz00_bglt BGl_z62lambda1876z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_symbol2676z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2678z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda1882z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1883z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_varz00_bglt BGl_z62lambda1887z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1888z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_symbol2683z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_toplevelzd2initzd2zz__evaluate_typesz00();
static obj_t BGl_symbol2688z00zz__evaluate_typesz00 = BUNSPEC;
static BgL_ev_labelsz00_bglt BGl_z62lambda1892z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1893z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1897z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1898z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_symbol2693z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_genericzd2initzd2zz__evaluate_typesz00();
BGL_EXPORTED_DEF obj_t BGl_ev_prog2z00zz__evaluate_typesz00 = BUNSPEC;
extern obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t, bool_t, bool_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_bindzd2exitzd2zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza31788ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31878ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza31403ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31984ze3ze5zz__evaluate_typesz00(obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_letza2za2zz__evaluate_typesz00 = BUNSPEC;
BGL_EXPORTED_DEF obj_t BGl_ev_trapz00zz__evaluate_typesz00 = BUNSPEC;
BGL_EXPORTED_DEF obj_t BGl_ev_setglobalz00zz__evaluate_typesz00 = BUNSPEC;
BGL_EXPORTED_DEF obj_t BGl_ev_hookz00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza31442ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31426ze3ze5zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31532ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31516ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31622ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__dssslz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__bignumz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__structurez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__tvectorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__typez00(long, char *);
BGL_EXPORTED_DEF obj_t BGl_ev_globalz00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza31712ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_binderz00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza31607ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_listz00zz__evaluate_typesz00 = BUNSPEC;
BGL_EXPORTED_DEF obj_t BGl_ev_littz00zz__evaluate_typesz00 = BUNSPEC;
static BgL_ev_exprz00_bglt BGl_z62lambda1503z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1504z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_cnstzd2initzd2zz__evaluate_typesz00();
static obj_t BGl_importedzd2moduleszd2initz00zz__evaluate_typesz00();
static BgL_ev_listz00_bglt BGl_z62lambda1510z62zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_listz00_bglt BGl_z62lambda1512z62zz__evaluate_typesz00(obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_withzd2handlerzd2zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda1521z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1522z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31805ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_orz00_bglt BGl_z62lambda1528z62zz__evaluate_typesz00(obj_t, obj_t);
extern obj_t BGl_objectz00zz__objectz00;
static BgL_ev_orz00_bglt BGl_z62lambda1530z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31822ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31733ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1701z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1702z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_andz00_bglt BGl_z62lambda1543z62zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_andz00_bglt BGl_z62lambda1545z62zz__evaluate_typesz00(obj_t);
static BgL_ev_withzd2handlerzd2_bglt BGl_z62lambda1708z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_exprz00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2506z00zz__evaluate_typesz00 = BUNSPEC;
static BgL_ev_withzd2handlerzd2_bglt BGl_z62lambda1710z62zz__evaluate_typesz00(obj_t);
static BgL_ev_prog2z00_bglt BGl_z62lambda1555z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1717z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1718z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_prog2z00_bglt BGl_z62lambda1557z62zz__evaluate_typesz00(obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1397z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_symbol2511z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2515z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2519z00zz__evaluate_typesz00 = BUNSPEC;
static BgL_ev_exprz00_bglt BGl_z62lambda1722z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1723z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1563z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1564z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_synchroniza7eza7_bglt BGl_z62lambda1729z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_symbol2524z00zz__evaluate_typesz00 = BUNSPEC;
static BgL_ev_synchroniza7eza7_bglt BGl_z62lambda1731z62zz__evaluate_typesz00(obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1570z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1571z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31486ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31559ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1737z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1738z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_hookz00_bglt BGl_z62lambda1577z62zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_hookz00_bglt BGl_z62lambda1579z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_symbol2533z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2537z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2377z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2379z00zz__evaluate_typesz00 = BUNSPEC;
static BgL_ev_exprz00_bglt BGl_z62lambda1742z62zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_appz00_bglt BGl_z62lambda1904z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1743z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_appz00_bglt BGl_z62lambda1906z62zz__evaluate_typesz00(obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1585z62zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1747z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1586z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1748z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_symbol2701z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2703z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2544z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2383z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2385z00zz__evaluate_typesz00 = BUNSPEC;
BGL_EXPORTED_DEF obj_t BGl_ev_setlocalz00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda1912z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1913z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1752z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1753z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_trapz00_bglt BGl_z62lambda1593z62zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1917z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1918z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_trapz00_bglt BGl_z62lambda1595z62zz__evaluate_typesz00(obj_t);
static BgL_ev_binderz00_bglt BGl_z62lambda1759z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_symbol2550z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2390z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2554z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2392z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2396z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda1922z62zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_binderz00_bglt BGl_z62lambda1761z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62lambda1923z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t *__cnst;


DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2400z00zz__evaluate_typesz00, BgL_bgl_za762lambda1409za7622705z00, BGl_z62lambda1409z62zz__evaluate_typesz00, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2403z00zz__evaluate_typesz00, BgL_bgl_za762lambda1449za7622706z00, BGl_z62lambda1449z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2404z00zz__evaluate_typesz00, BgL_bgl_za762lambda1448za7622707z00, BGl_z62lambda1448z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2407z00zz__evaluate_typesz00, BgL_bgl_za762lambda1454za7622708z00, BGl_z62lambda1454z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2408z00zz__evaluate_typesz00, BgL_bgl_za762lambda1453za7622709z00, BGl_z62lambda1453z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2409z00zz__evaluate_typesz00, BgL_bgl_za762lambda1459za7622710z00, BGl_z62lambda1459z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2410z00zz__evaluate_typesz00, BgL_bgl_za762lambda1458za7622711z00, BGl_z62lambda1458z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2413z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2712za7, BGl_z62zc3z04anonymousza31442ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2414z00zz__evaluate_typesz00, BgL_bgl_za762lambda1440za7622713z00, BGl_z62lambda1440z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2415z00zz__evaluate_typesz00, BgL_bgl_za762lambda1438za7622714z00, BGl_z62lambda1438z62zz__evaluate_typesz00, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2418z00zz__evaluate_typesz00, BgL_bgl_za762lambda1476za7622715z00, BGl_z62lambda1476z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2419z00zz__evaluate_typesz00, BgL_bgl_za762lambda1475za7622716z00, BGl_z62lambda1475z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2507z00zz__evaluate_typesz00, BgL_bgl_string2507za700za7za7_2717za7, "ev_setglobal", 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2422z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2718za7, BGl_z62zc3z04anonymousza31470ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2423z00zz__evaluate_typesz00, BgL_bgl_za762lambda1468za7622719z00, BGl_z62lambda1468z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2424z00zz__evaluate_typesz00, BgL_bgl_za762lambda1466za7622720z00, BGl_z62lambda1466z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2512z00zz__evaluate_typesz00, BgL_bgl_string2512za700za7za7_2721za7, "ev_defglobal", 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2427z00zz__evaluate_typesz00, BgL_bgl_za762lambda1493za7622722z00, BGl_z62lambda1493z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2428z00zz__evaluate_typesz00, BgL_bgl_za762lambda1492za7622723z00, BGl_z62lambda1492z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2516z00zz__evaluate_typesz00, BgL_bgl_string2516za700za7za7_2724za7, "var", 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2431z00zz__evaluate_typesz00, BgL_bgl_za762lambda1499za7622725z00, BGl_z62lambda1499z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2432z00zz__evaluate_typesz00, BgL_bgl_za762lambda1498za7622726z00, BGl_z62lambda1498z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2520z00zz__evaluate_typesz00, BgL_bgl_string2520za700za7za7_2727za7, "body", 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2435z00zz__evaluate_typesz00, BgL_bgl_za762lambda1504za7622728z00, BGl_z62lambda1504z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2436z00zz__evaluate_typesz00, BgL_bgl_za762lambda1503za7622729z00, BGl_z62lambda1503z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2525z00zz__evaluate_typesz00, BgL_bgl_string2525za700za7za7_2730za7, "ev_bind-exit", 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2439z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2731za7, BGl_z62zc3z04anonymousza31486ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2601z00zz__evaluate_typesz00, BgL_bgl_za762lambda1837za7622732z00, BGl_z62lambda1837z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2602z00zz__evaluate_typesz00, BgL_bgl_za762lambda1836za7622733z00, BGl_z62lambda1836z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2440z00zz__evaluate_typesz00, BgL_bgl_za762lambda1484za7622734z00, BGl_z62lambda1484z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2603z00zz__evaluate_typesz00, BgL_bgl_za762lambda1842za7622735z00, BGl_z62lambda1842z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2441z00zz__evaluate_typesz00, BgL_bgl_za762lambda1482za7622736z00, BGl_z62lambda1482z62zz__evaluate_typesz00, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2604z00zz__evaluate_typesz00, BgL_bgl_za762lambda1841za7622737z00, BGl_z62lambda1841z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2605z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2738za7, BGl_z62zc3z04anonymousza31849ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2606z00zz__evaluate_typesz00, BgL_bgl_za762lambda1848za7622739z00, BGl_z62lambda1848z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2444z00zz__evaluate_typesz00, BgL_bgl_za762lambda1522za7622740z00, BGl_z62lambda1522z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2607z00zz__evaluate_typesz00, BgL_bgl_za762lambda1847za7622741z00, BGl_z62lambda1847z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2445z00zz__evaluate_typesz00, BgL_bgl_za762lambda1521za7622742z00, BGl_z62lambda1521z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2534z00zz__evaluate_typesz00, BgL_bgl_string2534za700za7za7_2743za7, "ev_unwind-protect", 17 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2448z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2744za7, BGl_z62zc3z04anonymousza31516ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2449z00zz__evaluate_typesz00, BgL_bgl_za762lambda1512za7622745z00, BGl_z62lambda1512z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2538z00zz__evaluate_typesz00, BgL_bgl_string2538za700za7za7_2746za7, "handler", 7 );
DEFINE_STRING( BGl_string2378z00zz__evaluate_typesz00, BgL_bgl_string2378za700za7za7_2747za7, "ev_expr", 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2610z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2748za7, BGl_z62zc3z04anonymousza31856ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2611z00zz__evaluate_typesz00, BgL_bgl_za762lambda1855za7622749z00, BGl_z62lambda1855z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2612z00zz__evaluate_typesz00, BgL_bgl_za762lambda1854za7622750z00, BGl_z62lambda1854z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2450z00zz__evaluate_typesz00, BgL_bgl_za762lambda1510za7622751z00, BGl_z62lambda1510z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2702z00zz__evaluate_typesz00, BgL_bgl_string2702za700za7za7_2752za7, "ev_abs", 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2615z00zz__evaluate_typesz00, BgL_bgl_za762lambda1861za7622753z00, BGl_z62lambda1861z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2453z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2754za7, BGl_z62zc3z04anonymousza31532ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2616z00zz__evaluate_typesz00, BgL_bgl_za762lambda1860za7622755z00, BGl_z62lambda1860z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2454z00zz__evaluate_typesz00, BgL_bgl_za762lambda1530za7622756z00, BGl_z62lambda1530z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2704z00zz__evaluate_typesz00, BgL_bgl_string2704za700za7za7_2757za7, "_", 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2617z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2758za7, BGl_z62zc3z04anonymousza31868ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2455z00zz__evaluate_typesz00, BgL_bgl_za762lambda1528za7622759z00, BGl_z62lambda1528z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2380z00zz__evaluate_typesz00, BgL_bgl_string2380za700za7za7_2760za7, "__evaluate_types", 16 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2618z00zz__evaluate_typesz00, BgL_bgl_za762lambda1867za7622761z00, BGl_z62lambda1867z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2619z00zz__evaluate_typesz00, BgL_bgl_za762lambda1866za7622762z00, BGl_z62lambda1866z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2545z00zz__evaluate_typesz00, BgL_bgl_string2545za700za7za7_2763za7, "ev_with-handler", 15 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2458z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2764za7, BGl_z62zc3z04anonymousza31547ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2459z00zz__evaluate_typesz00, BgL_bgl_za762lambda1545za7622765z00, BGl_z62lambda1545z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2384z00zz__evaluate_typesz00, BgL_bgl_string2384za700za7za7_2766za7, "name", 4 );
DEFINE_STRING( BGl_string2386z00zz__evaluate_typesz00, BgL_bgl_string2386za700za7za7_2767za7, "symbol", 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2620z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2768za7, BGl_z62zc3z04anonymousza31832ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2621z00zz__evaluate_typesz00, BgL_bgl_za762lambda1830za7622769z00, BGl_z62lambda1830z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2622z00zz__evaluate_typesz00, BgL_bgl_za762lambda1828za7622770z00, BGl_z62lambda1828z62zz__evaluate_typesz00, 0L, BUNSPEC, 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2460z00zz__evaluate_typesz00, BgL_bgl_za762lambda1543za7622771z00, BGl_z62lambda1543z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2625z00zz__evaluate_typesz00, BgL_bgl_za762lambda1883za7622772z00, BGl_z62lambda1883z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2463z00zz__evaluate_typesz00, BgL_bgl_za762lambda1564za7622773z00, BGl_z62lambda1564z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2626z00zz__evaluate_typesz00, BgL_bgl_za762lambda1882za7622774z00, BGl_z62lambda1882z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2551z00zz__evaluate_typesz00, BgL_bgl_string2551za700za7za7_2775za7, "mutex", 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2464z00zz__evaluate_typesz00, BgL_bgl_za762lambda1563za7622776z00, BGl_z62lambda1563z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2627z00zz__evaluate_typesz00, BgL_bgl_za762lambda1888za7622777z00, BGl_z62lambda1888z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2628z00zz__evaluate_typesz00, BgL_bgl_za762lambda1887za7622778z00, BGl_z62lambda1887z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2391z00zz__evaluate_typesz00, BgL_bgl_string2391za700za7za7_2779za7, "eff", 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2467z00zz__evaluate_typesz00, BgL_bgl_za762lambda1571za7622780z00, BGl_z62lambda1571z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2555z00zz__evaluate_typesz00, BgL_bgl_string2555za700za7za7_2781za7, "prelock", 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2468z00zz__evaluate_typesz00, BgL_bgl_za762lambda1570za7622782z00, BGl_z62lambda1570z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2393z00zz__evaluate_typesz00, BgL_bgl_string2393za700za7za7_2783za7, "obj", 3 );
DEFINE_STRING( BGl_string2397z00zz__evaluate_typesz00, BgL_bgl_string2397za700za7za7_2784za7, "type", 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2631z00zz__evaluate_typesz00, BgL_bgl_za762lambda1893za7622785z00, BGl_z62lambda1893z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2632z00zz__evaluate_typesz00, BgL_bgl_za762lambda1892za7622786z00, BGl_z62lambda1892z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2471z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2787za7, BGl_z62zc3z04anonymousza31559ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2472z00zz__evaluate_typesz00, BgL_bgl_za762lambda1557za7622788z00, BGl_z62lambda1557z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2635z00zz__evaluate_typesz00, BgL_bgl_za762lambda1898za7622789z00, BGl_z62lambda1898z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2473z00zz__evaluate_typesz00, BgL_bgl_za762lambda1555za7622790z00, BGl_z62lambda1555z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2636z00zz__evaluate_typesz00, BgL_bgl_za762lambda1897za7622791z00, BGl_z62lambda1897z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2637z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2792za7, BGl_z62zc3z04anonymousza31878ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2562z00zz__evaluate_typesz00, BgL_bgl_string2562za700za7za7_2793za7, "ev_synchronize", 14 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2638z00zz__evaluate_typesz00, BgL_bgl_za762lambda1876za7622794z00, BGl_z62lambda1876z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2476z00zz__evaluate_typesz00, BgL_bgl_za762lambda1586za7622795z00, BGl_z62lambda1586z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2639z00zz__evaluate_typesz00, BgL_bgl_za762lambda1874za7622796z00, BGl_z62lambda1874z62zz__evaluate_typesz00, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2477z00zz__evaluate_typesz00, BgL_bgl_za762lambda1585za7622797z00, BGl_z62lambda1585z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2478z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2798za7, BGl_z62zc3z04anonymousza31581ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2566z00zz__evaluate_typesz00, BgL_bgl_string2566za700za7za7_2799za7, "vars", 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2479z00zz__evaluate_typesz00, BgL_bgl_za762lambda1579za7622800z00, BGl_z62lambda1579z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2642z00zz__evaluate_typesz00, BgL_bgl_za762lambda1913za7622801z00, BGl_z62lambda1913z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2480z00zz__evaluate_typesz00, BgL_bgl_za762lambda1577za7622802z00, BGl_z62lambda1577z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2643z00zz__evaluate_typesz00, BgL_bgl_za762lambda1912za7622803z00, BGl_z62lambda1912z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2644z00zz__evaluate_typesz00, BgL_bgl_za762lambda1918za7622804z00, BGl_z62lambda1918z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2645z00zz__evaluate_typesz00, BgL_bgl_za762lambda1917za7622805z00, BGl_z62lambda1917z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2570z00zz__evaluate_typesz00, BgL_bgl_string2570za700za7za7_2806za7, "vals", 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2483z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2807za7, BGl_z62zc3z04anonymousza31597ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2484z00zz__evaluate_typesz00, BgL_bgl_za762lambda1595za7622808z00, BGl_z62lambda1595z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2485z00zz__evaluate_typesz00, BgL_bgl_za762lambda1593za7622809z00, BGl_z62lambda1593z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2648z00zz__evaluate_typesz00, BgL_bgl_za762lambda1923za7622810z00, BGl_z62lambda1923z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2649z00zz__evaluate_typesz00, BgL_bgl_za762lambda1922za7622811z00, BGl_z62lambda1922z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2488z00zz__evaluate_typesz00, BgL_bgl_za762lambda1612za7622812z00, BGl_z62lambda1612z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2489z00zz__evaluate_typesz00, BgL_bgl_za762lambda1611za7622813z00, BGl_z62lambda1611z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2577z00zz__evaluate_typesz00, BgL_bgl_string2577za700za7za7_2814za7, "ev_binder", 9 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2650z00zz__evaluate_typesz00, BgL_bgl_za762lambda1928za7622815z00, BGl_z62lambda1928z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2651z00zz__evaluate_typesz00, BgL_bgl_za762lambda1927za7622816z00, BGl_z62lambda1927z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2654z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2817za7, BGl_z62zc3z04anonymousza31908ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2492z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2818za7, BGl_z62zc3z04anonymousza31607ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2655z00zz__evaluate_typesz00, BgL_bgl_za762lambda1906za7622819z00, BGl_z62lambda1906z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2493z00zz__evaluate_typesz00, BgL_bgl_za762lambda1605za7622820z00, BGl_z62lambda1605z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2656z00zz__evaluate_typesz00, BgL_bgl_za762lambda1904za7622821z00, BGl_z62lambda1904z62zz__evaluate_typesz00, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2494z00zz__evaluate_typesz00, BgL_bgl_za762lambda1603za7622822z00, BGl_z62lambda1603z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2582z00zz__evaluate_typesz00, BgL_bgl_string2582za700za7za7_2823za7, "boxes", 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2659z00zz__evaluate_typesz00, BgL_bgl_za762lambda1943za7622824z00, BGl_z62lambda1943z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2497z00zz__evaluate_typesz00, BgL_bgl_za762lambda1627za7622825z00, BGl_z62lambda1627z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2498z00zz__evaluate_typesz00, BgL_bgl_za762lambda1626za7622826z00, BGl_z62lambda1626z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2499z00zz__evaluate_typesz00, BgL_bgl_za762lambda1632za7622827z00, BGl_z62lambda1632z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2587z00zz__evaluate_typesz00, BgL_bgl_string2587za700za7za7_2828za7, "ev_let", 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2660z00zz__evaluate_typesz00, BgL_bgl_za762lambda1942za7622829z00, BGl_z62lambda1942z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2661z00zz__evaluate_typesz00, BgL_bgl_za762lambda1948za7622830z00, BGl_z62lambda1948z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2662z00zz__evaluate_typesz00, BgL_bgl_za762lambda1947za7622831z00, BGl_z62lambda1947z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2665z00zz__evaluate_typesz00, BgL_bgl_za762lambda1953za7622832z00, BGl_z62lambda1953z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2666z00zz__evaluate_typesz00, BgL_bgl_za762lambda1952za7622833z00, BGl_z62lambda1952z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2669z00zz__evaluate_typesz00, BgL_bgl_za762lambda1958za7622834z00, BGl_z62lambda1958z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2595z00zz__evaluate_typesz00, BgL_bgl_string2595za700za7za7_2835za7, "ev_let*", 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2670z00zz__evaluate_typesz00, BgL_bgl_za762lambda1957za7622836z00, BGl_z62lambda1957z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2671z00zz__evaluate_typesz00, BgL_bgl_za762lambda1963za7622837z00, BGl_z62lambda1963z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2672z00zz__evaluate_typesz00, BgL_bgl_za762lambda1962za7622838z00, BGl_z62lambda1962z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2673z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2839za7, BGl_z62zc3z04anonymousza31970ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2674z00zz__evaluate_typesz00, BgL_bgl_za762lambda1969za7622840z00, BGl_z62lambda1969z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2675z00zz__evaluate_typesz00, BgL_bgl_za762lambda1968za7622841z00, BGl_z62lambda1968z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2680z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2842za7, BGl_z62zc3z04anonymousza31977ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2681z00zz__evaluate_typesz00, BgL_bgl_za762lambda1976za7622843z00, BGl_z62lambda1976z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2682z00zz__evaluate_typesz00, BgL_bgl_za762lambda1975za7622844z00, BGl_z62lambda1975z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2685z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2845za7, BGl_z62zc3z04anonymousza31984ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2686z00zz__evaluate_typesz00, BgL_bgl_za762lambda1983za7622846z00, BGl_z62lambda1983z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2687z00zz__evaluate_typesz00, BgL_bgl_za762lambda1982za7622847z00, BGl_z62lambda1982z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2690z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2848za7, BGl_z62zc3z04anonymousza31991ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2691z00zz__evaluate_typesz00, BgL_bgl_za762lambda1990za7622849z00, BGl_z62lambda1990z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2692z00zz__evaluate_typesz00, BgL_bgl_za762lambda1989za7622850z00, BGl_z62lambda1989z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2695z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2851za7, BGl_z62zc3z04anonymousza31998ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2696z00zz__evaluate_typesz00, BgL_bgl_za762lambda1997za7622852z00, BGl_z62lambda1997z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2697z00zz__evaluate_typesz00, BgL_bgl_za762lambda1996za7622853z00, BGl_z62lambda1996z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2698z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2854za7, BGl_z62zc3z04anonymousza31938ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2699z00zz__evaluate_typesz00, BgL_bgl_za762lambda1936za7622855z00, BGl_z62lambda1936z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2402z00zz__evaluate_typesz00, BgL_bgl_string2402za700za7za7_2856za7, "ev_var", 6 );
DEFINE_STRING( BGl_string2406z00zz__evaluate_typesz00, BgL_bgl_string2406za700za7za7_2857za7, "loc", 3 );
DEFINE_STRING( BGl_string2412z00zz__evaluate_typesz00, BgL_bgl_string2412za700za7za7_2858za7, "mod", 3 );
DEFINE_STRING( BGl_string2417z00zz__evaluate_typesz00, BgL_bgl_string2417za700za7za7_2859za7, "ev_global", 9 );
DEFINE_STRING( BGl_string2421z00zz__evaluate_typesz00, BgL_bgl_string2421za700za7za7_2860za7, "value", 5 );
DEFINE_STRING( BGl_string2426z00zz__evaluate_typesz00, BgL_bgl_string2426za700za7za7_2861za7, "ev_litt", 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2500z00zz__evaluate_typesz00, BgL_bgl_za762lambda1631za7622862z00, BGl_z62lambda1631z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2501z00zz__evaluate_typesz00, BgL_bgl_za762lambda1640za7622863z00, BGl_z62lambda1640z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2502z00zz__evaluate_typesz00, BgL_bgl_za762lambda1639za7622864z00, BGl_z62lambda1639z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2503z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2865za7, BGl_z62zc3z04anonymousza31622ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2504z00zz__evaluate_typesz00, BgL_bgl_za762lambda1620za7622866z00, BGl_z62lambda1620z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2505z00zz__evaluate_typesz00, BgL_bgl_za762lambda1618za7622867z00, BGl_z62lambda1618z62zz__evaluate_typesz00, 0L, BUNSPEC, 4 );
DEFINE_STRING( BGl_string2430z00zz__evaluate_typesz00, BgL_bgl_string2430za700za7za7_2868za7, "p", 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2508z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2869za7, BGl_z62zc3z04anonymousza31657ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2509z00zz__evaluate_typesz00, BgL_bgl_za762lambda1655za7622870z00, BGl_z62lambda1655z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2434z00zz__evaluate_typesz00, BgL_bgl_string2434za700za7za7_2871za7, "t", 1 );
DEFINE_STRING( BGl_string2438z00zz__evaluate_typesz00, BgL_bgl_string2438za700za7za7_2872za7, "e", 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2510z00zz__evaluate_typesz00, BgL_bgl_za762lambda1652za7622873z00, BGl_z62lambda1652z62zz__evaluate_typesz00, 0L, BUNSPEC, 4 );
DEFINE_STRING( BGl_string2600z00zz__evaluate_typesz00, BgL_bgl_string2600za700za7za7_2874za7, "ev_letrec", 9 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2513z00zz__evaluate_typesz00, BgL_bgl_za762lambda1675za7622875z00, BGl_z62lambda1675z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2514z00zz__evaluate_typesz00, BgL_bgl_za762lambda1674za7622876z00, BGl_z62lambda1674z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2517z00zz__evaluate_typesz00, BgL_bgl_za762lambda1680za7622877z00, BGl_z62lambda1680z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2518z00zz__evaluate_typesz00, BgL_bgl_za762lambda1679za7622878z00, BGl_z62lambda1679z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2443z00zz__evaluate_typesz00, BgL_bgl_string2443za700za7za7_2879za7, "ev_if", 5 );
DEFINE_STRING( BGl_string2609z00zz__evaluate_typesz00, BgL_bgl_string2609za700za7za7_2880za7, "env", 3 );
DEFINE_STRING( BGl_string2447z00zz__evaluate_typesz00, BgL_bgl_string2447za700za7za7_2881za7, "args", 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2521z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2882za7, BGl_z62zc3z04anonymousza31668ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2522z00zz__evaluate_typesz00, BgL_bgl_za762lambda1666za7622883z00, BGl_z62lambda1666z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2523z00zz__evaluate_typesz00, BgL_bgl_za762lambda1664za7622884z00, BGl_z62lambda1664z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2526z00zz__evaluate_typesz00, BgL_bgl_za762lambda1697za7622885z00, BGl_z62lambda1697z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2614z00zz__evaluate_typesz00, BgL_bgl_string2614za700za7za7_2886za7, "stk", 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2527z00zz__evaluate_typesz00, BgL_bgl_za762lambda1696za7622887z00, BGl_z62lambda1696z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2452z00zz__evaluate_typesz00, BgL_bgl_string2452za700za7za7_2888za7, "ev_list", 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2528z00zz__evaluate_typesz00, BgL_bgl_za762lambda1702za7622889z00, BGl_z62lambda1702z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2529z00zz__evaluate_typesz00, BgL_bgl_za762lambda1701za7622890z00, BGl_z62lambda1701z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2457z00zz__evaluate_typesz00, BgL_bgl_string2457za700za7za7_2891za7, "ev_or", 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2530z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2892za7, BGl_z62zc3z04anonymousza31692ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2531z00zz__evaluate_typesz00, BgL_bgl_za762lambda1690za7622893z00, BGl_z62lambda1690z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2532z00zz__evaluate_typesz00, BgL_bgl_za762lambda1688za7622894z00, BGl_z62lambda1688z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2535z00zz__evaluate_typesz00, BgL_bgl_za762lambda1718za7622895z00, BGl_z62lambda1718z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2536z00zz__evaluate_typesz00, BgL_bgl_za762lambda1717za7622896z00, BGl_z62lambda1717z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2374z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2897za7, BGl_z62zc3z04anonymousza31403ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2624z00zz__evaluate_typesz00, BgL_bgl_string2624za700za7za7_2898za7, "ev_labels", 9 );
DEFINE_STRING( BGl_string2462z00zz__evaluate_typesz00, BgL_bgl_string2462za700za7za7_2899za7, "ev_and", 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2375z00zz__evaluate_typesz00, BgL_bgl_za762lambda1401za7622900z00, BGl_z62lambda1401z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2376z00zz__evaluate_typesz00, BgL_bgl_za762lambda1397za7622901z00, BGl_z62lambda1397z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2539z00zz__evaluate_typesz00, BgL_bgl_za762lambda1723za7622902z00, BGl_z62lambda1723z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2466z00zz__evaluate_typesz00, BgL_bgl_string2466za700za7za7_2903za7, "e1", 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2700z00zz__evaluate_typesz00, BgL_bgl_za762lambda1934za7622904z00, BGl_z62lambda1934z62zz__evaluate_typesz00, 0L, BUNSPEC, 10 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2540z00zz__evaluate_typesz00, BgL_bgl_za762lambda1722za7622905z00, BGl_z62lambda1722z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2541z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2906za7, BGl_z62zc3z04anonymousza31712ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2542z00zz__evaluate_typesz00, BgL_bgl_za762lambda1710za7622907z00, BGl_z62lambda1710z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2630z00zz__evaluate_typesz00, BgL_bgl_string2630za700za7za7_2908za7, "label", 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2543z00zz__evaluate_typesz00, BgL_bgl_za762lambda1708za7622909z00, BGl_z62lambda1708z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2381z00zz__evaluate_typesz00, BgL_bgl_za762lambda1418za7622910z00, BGl_z62lambda1418z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2382z00zz__evaluate_typesz00, BgL_bgl_za762lambda1417za7622911z00, BGl_z62lambda1417z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2470z00zz__evaluate_typesz00, BgL_bgl_string2470za700za7za7_2912za7, "e2", 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2546z00zz__evaluate_typesz00, BgL_bgl_za762lambda1738za7622913z00, BGl_z62lambda1738z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2634z00zz__evaluate_typesz00, BgL_bgl_string2634za700za7za7_2914za7, "labels", 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2547z00zz__evaluate_typesz00, BgL_bgl_za762lambda1737za7622915z00, BGl_z62lambda1737z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2548z00zz__evaluate_typesz00, BgL_bgl_za762lambda1743za7622916z00, BGl_z62lambda1743z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2549z00zz__evaluate_typesz00, BgL_bgl_za762lambda1742za7622917z00, BGl_z62lambda1742z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2387z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2918za7, BGl_z62zc3z04anonymousza31426ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2475z00zz__evaluate_typesz00, BgL_bgl_string2475za700za7za7_2919za7, "ev_prog2", 8 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2388z00zz__evaluate_typesz00, BgL_bgl_za762lambda1425za7622920z00, BGl_z62lambda1425z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2389z00zz__evaluate_typesz00, BgL_bgl_za762lambda1424za7622921z00, BGl_z62lambda1424z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2552z00zz__evaluate_typesz00, BgL_bgl_za762lambda1748za7622922z00, BGl_z62lambda1748z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2553z00zz__evaluate_typesz00, BgL_bgl_za762lambda1747za7622923z00, BGl_z62lambda1747z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2641z00zz__evaluate_typesz00, BgL_bgl_string2641za700za7za7_2924za7, "ev_goto", 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2556z00zz__evaluate_typesz00, BgL_bgl_za762lambda1753za7622925z00, BGl_z62lambda1753z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2394z00zz__evaluate_typesz00, BgL_bgl_za762lambda1431za7622926z00, BGl_z62lambda1431z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2557z00zz__evaluate_typesz00, BgL_bgl_za762lambda1752za7622927z00, BGl_z62lambda1752z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2482z00zz__evaluate_typesz00, BgL_bgl_string2482za700za7za7_2928za7, "ev_hook", 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2395z00zz__evaluate_typesz00, BgL_bgl_za762lambda1430za7622929z00, BGl_z62lambda1430z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2558z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2930za7, BGl_z62zc3z04anonymousza31733ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2559z00zz__evaluate_typesz00, BgL_bgl_za762lambda1731za7622931z00, BGl_z62lambda1731z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2647z00zz__evaluate_typesz00, BgL_bgl_string2647za700za7za7_2932za7, "fun", 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2398z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2933za7, BGl_z62zc3z04anonymousza31413ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2399z00zz__evaluate_typesz00, BgL_bgl_za762lambda1411za7622934z00, BGl_z62lambda1411z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2487z00zz__evaluate_typesz00, BgL_bgl_string2487za700za7za7_2935za7, "ev_trap", 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2560z00zz__evaluate_typesz00, BgL_bgl_za762lambda1729za7622936z00, BGl_z62lambda1729z62zz__evaluate_typesz00, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2563z00zz__evaluate_typesz00, BgL_bgl_za762lambda1768za7622937z00, BGl_z62lambda1768z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2564z00zz__evaluate_typesz00, BgL_bgl_za762lambda1767za7622938z00, BGl_z62lambda1767z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2653z00zz__evaluate_typesz00, BgL_bgl_string2653za700za7za7_2939za7, "tail?", 5 );
DEFINE_STRING( BGl_string2491z00zz__evaluate_typesz00, BgL_bgl_string2491za700za7za7_2940za7, "v", 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2567z00zz__evaluate_typesz00, BgL_bgl_za762lambda1773za7622941z00, BGl_z62lambda1773z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2568z00zz__evaluate_typesz00, BgL_bgl_za762lambda1772za7622942z00, BGl_z62lambda1772z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2658z00zz__evaluate_typesz00, BgL_bgl_string2658za700za7za7_2943za7, "ev_app", 6 );
DEFINE_STRING( BGl_string2496z00zz__evaluate_typesz00, BgL_bgl_string2496za700za7za7_2944za7, "ev_setlocal", 11 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2571z00zz__evaluate_typesz00, BgL_bgl_za762lambda1778za7622945z00, BGl_z62lambda1778z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2572z00zz__evaluate_typesz00, BgL_bgl_za762lambda1777za7622946z00, BGl_z62lambda1777z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2573z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2947za7, BGl_z62zc3z04anonymousza31763ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2574z00zz__evaluate_typesz00, BgL_bgl_za762lambda1761za7622948z00, BGl_z62lambda1761z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2575z00zz__evaluate_typesz00, BgL_bgl_za762lambda1759za7622949z00, BGl_z62lambda1759z62zz__evaluate_typesz00, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string2664z00zz__evaluate_typesz00, BgL_bgl_string2664za700za7za7_2950za7, "where", 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2578z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2951za7, BGl_z62zc3z04anonymousza31795ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2579z00zz__evaluate_typesz00, BgL_bgl_za762lambda1794za7622952z00, BGl_z62lambda1794z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2668z00zz__evaluate_typesz00, BgL_bgl_string2668za700za7za7_2953za7, "arity", 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2580z00zz__evaluate_typesz00, BgL_bgl_za762lambda1793za7622954z00, BGl_z62lambda1793z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2583z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2955za7, BGl_z62zc3z04anonymousza31788ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2584z00zz__evaluate_typesz00, BgL_bgl_za762lambda1786za7622956z00, BGl_z62lambda1786z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2585z00zz__evaluate_typesz00, BgL_bgl_za762lambda1784za7622957z00, BGl_z62lambda1784z62zz__evaluate_typesz00, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2588z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2958za7, BGl_z62zc3z04anonymousza31812ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2589z00zz__evaluate_typesz00, BgL_bgl_za762lambda1811za7622959z00, BGl_z62lambda1811z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2677z00zz__evaluate_typesz00, BgL_bgl_string2677za700za7za7_2960za7, "size", 4 );
DEFINE_STRING( BGl_string2679z00zz__evaluate_typesz00, BgL_bgl_string2679za700za7za7_2961za7, "int", 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2590z00zz__evaluate_typesz00, BgL_bgl_za762lambda1810za7622962z00, BGl_z62lambda1810z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2591z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2963za7, BGl_z62zc3z04anonymousza31805ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2592z00zz__evaluate_typesz00, BgL_bgl_za762lambda1803za7622964z00, BGl_z62lambda1803z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2593z00zz__evaluate_typesz00, BgL_bgl_za762lambda1801za7622965z00, BGl_z62lambda1801z62zz__evaluate_typesz00, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2596z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2966za7, BGl_z62zc3z04anonymousza31822ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2684z00zz__evaluate_typesz00, BgL_bgl_string2684za700za7za7_2967za7, "bind", 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2597z00zz__evaluate_typesz00, BgL_bgl_za762lambda1820za7622968z00, BGl_z62lambda1820z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2598z00zz__evaluate_typesz00, BgL_bgl_za762lambda1818za7622969z00, BGl_z62lambda1818z62zz__evaluate_typesz00, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string2689z00zz__evaluate_typesz00, BgL_bgl_string2689za700za7za7_2970za7, "free", 4 );
DEFINE_STRING( BGl_string2694z00zz__evaluate_typesz00, BgL_bgl_string2694za700za7za7_2971za7, "inner", 5 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_symbol2561z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2565z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2569z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2576z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2581z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2586z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2594z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2599z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_letrecz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_letz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_labelsz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_absz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_ifz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_gotoz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_orz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_varz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_andz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2401z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2405z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2411z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2416z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_appz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2420z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2425z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2429z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2433z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2437z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_synchroniza7eza7zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2442z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2608z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2446z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2613z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2451z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2456z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2623z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2461z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2465z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2629z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2469z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2633z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2474z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2640z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2481z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2646z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2486z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_defglobalz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2652z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2490z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2657z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2495z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2663z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2667z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2676z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2678z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2683z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2688z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2693z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_prog2z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_bindzd2exitzd2zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_letza2za2zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_trapz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_setglobalz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_hookz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_globalz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_binderz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_listz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_littz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_withzd2handlerzd2zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_exprz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2506z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2511z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2515z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2519z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2524z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2533z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2537z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2377z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2379z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2701z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2703z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2544z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2383z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2385z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_setlocalz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2550z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2390z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2554z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2392z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2396z00zz__evaluate_typesz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* prof association table */
static obj_t write_bprof_table() {
   extern obj_t bprof_port;
   if( bprof_port == BUNSPEC ) bprof_port = (obj_t)fopen( "bmon.out", "w" );
   if( bprof_port ) {
      fputs( "(\"module-initialization\" \"BGl_modulezd2initializa7ationz75zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"toplevel-init\" \"Eval/evaluate_types.scm\" 963) \"BGl_toplevelzd2initzd2zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1938>\" \"Eval/evaluate_types.scm\" 3347) \"BGl_z62zc3z04anonymousza31938ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1998>\" \"Eval/evaluate_types.scm\" 3347) \"BGl_z62zc3z04anonymousza31998ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1991>\" \"Eval/evaluate_types.scm\" 3347) \"BGl_z62zc3z04anonymousza31991ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1984>\" \"Eval/evaluate_types.scm\" 3347) \"BGl_z62zc3z04anonymousza31984ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1977>\" \"Eval/evaluate_types.scm\" 3347) \"BGl_z62zc3z04anonymousza31977ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1970>\" \"Eval/evaluate_types.scm\" 3347) \"BGl_z62zc3z04anonymousza31970ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1908>\" \"Eval/evaluate_types.scm\" 3265) \"BGl_z62zc3z04anonymousza31908ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1878>\" \"Eval/evaluate_types.scm\" 3154) \"BGl_z62zc3z04anonymousza31878ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1832>\" \"Eval/evaluate_types.scm\" 2941) \"BGl_z62zc3z04anonymousza31832ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1868>\" \"Eval/evaluate_types.scm\" 2941) \"BGl_z62zc3z04anonymousza31868ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1856>\" \"Eval/evaluate_types.scm\" 2941) \"BGl_z62zc3z04anonymousza31856ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1849>\" \"Eval/evaluate_types.scm\" 2941) \"BGl_z62zc3z04anonymousza31849ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1822>\" \"Eval/evaluate_types.scm\" 2908) \"BGl_z62zc3z04anonymousza31822ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1805>\" \"Eval/evaluate_types.scm\" 2848) \"BGl_z62zc3z04anonymousza31805ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1812>\" \"Eval/evaluate_types.scm\" 2848) \"BGl_z62zc3z04anonymousza31812ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1788>\" \"Eval/evaluate_types.scm\" 2789) \"BGl_z62zc3z04anonymousza31788ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1795>\" \"Eval/evaluate_types.scm\" 2789) \"BGl_z62zc3z04anonymousza31795ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1763>\" \"Eval/evaluate_types.scm\" 2713) \"BGl_z62zc3z04anonymousza31763ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1733>\" \"Eval/evaluate_types.scm\" 2587) \"BGl_z62zc3z04anonymousza31733ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1712>\" \"Eval/evaluate_types.scm\" 2505) \"BGl_z62zc3z04anonymousza31712ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1692>\" \"Eval/evaluate_types.scm\" 2427) \"BGl_z62zc3z04anonymousza31692ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1668>\" \"Eval/evaluate_types.scm\" 2353) \"BGl_z62zc3z04anonymousza31668ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1657>\" \"Eval/evaluate_types.scm\" 2314) \"BGl_z62zc3z04anonymousza31657ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1622>\" \"Eval/evaluate_types.scm\" 2226) \"BGl_z62zc3z04anonymousza31622ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1607>\" \"Eval/evaluate_types.scm\" 2176) \"BGl_z62zc3z04anonymousza31607ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1597>\" \"Eval/evaluate_types.scm\" 2147) \"BGl_z62zc3z04anonymousza31597ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1581>\" \"Eval/evaluate_types.scm\" 2100) \"BGl_z62zc3z04anonymousza31581ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1559>\" \"Eval/evaluate_types.scm\" 2032) \"BGl_z62zc3z04anonymousza31559ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1547>\" \"Eval/evaluate_types.scm\" 2004) \"BGl_z62zc3z04anonymousza31547ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1532>\" \"Eval/evaluate_types.scm\" 1977) \"BGl_z62zc3z04anonymousza31532ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1516>\" \"Eval/evaluate_types.scm\" 1936) \"BGl_z62zc3z04anonymousza31516ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1486>\" \"Eval/evaluate_types.scm\" 1855) \"BGl_z62zc3z04anonymousza31486ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1470>\" \"Eval/evaluate_types.scm\" 1813) \"BGl_z62zc3z04anonymousza31470ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1442>\" \"Eval/evaluate_types.scm\" 1723) \"BGl_z62zc3z04anonymousza31442ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1413>\" \"Eval/evaluate_types.scm\" 1637) \"BGl_z62zc3z04anonymousza31413ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1426>\" \"Eval/evaluate_types.scm\" 1637) \"BGl_z62zc3z04anonymousza31426ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1403>\" \"Eval/evaluate_types.scm\" 1612) \"BGl_z62zc3z04anonymousza31403ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "(\"CONS\" \"make_pair\")\n", (FILE *)bprof_port );
      fputs( "(\"%STRING->SYMBOL\" \"make_symbol\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-STRING\" \"string_to_bstring_len\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-OUTPUT-PORT\" \"bgl_make_output_port\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-INPUT-PORT\" \"bgl_make_input_port\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-ERROR-PORT\" \"make_error_port\")\n", (FILE *)bprof_port );
   }
   return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(long BgL_checksumz00_4292, char * BgL_fromz00_4293)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__evaluate_typesz00))
{ 
BGl_requirezd2initializa7ationz75zz__evaluate_typesz00 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__evaluate_typesz00(); 
BGl_cnstzd2initzd2zz__evaluate_typesz00(); 
BGl_importedzd2moduleszd2initz00zz__evaluate_typesz00(); 
BGl_objectzd2initzd2zz__evaluate_typesz00(); 
return 
BGl_profzd2initzd2zz__evaluate_typesz00();}  else 
{ 
return BUNSPEC;} } 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__evaluate_typesz00()
{
{ /* Eval/evaluate_types.scm 15 */
BGl_symbol2377z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2378z00zz__evaluate_typesz00); 
BGl_symbol2379z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2380z00zz__evaluate_typesz00); 
BGl_symbol2383z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2384z00zz__evaluate_typesz00); 
BGl_symbol2385z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2386z00zz__evaluate_typesz00); 
BGl_symbol2390z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2391z00zz__evaluate_typesz00); 
BGl_symbol2392z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2393z00zz__evaluate_typesz00); 
BGl_symbol2396z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2397z00zz__evaluate_typesz00); 
BGl_symbol2401z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2402z00zz__evaluate_typesz00); 
BGl_symbol2405z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2406z00zz__evaluate_typesz00); 
BGl_symbol2411z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2412z00zz__evaluate_typesz00); 
BGl_symbol2416z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2417z00zz__evaluate_typesz00); 
BGl_symbol2420z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2421z00zz__evaluate_typesz00); 
BGl_symbol2425z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2426z00zz__evaluate_typesz00); 
BGl_symbol2429z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2430z00zz__evaluate_typesz00); 
BGl_symbol2433z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2434z00zz__evaluate_typesz00); 
BGl_symbol2437z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2438z00zz__evaluate_typesz00); 
BGl_symbol2442z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2443z00zz__evaluate_typesz00); 
BGl_symbol2446z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2447z00zz__evaluate_typesz00); 
BGl_symbol2451z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2452z00zz__evaluate_typesz00); 
BGl_symbol2456z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2457z00zz__evaluate_typesz00); 
BGl_symbol2461z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2462z00zz__evaluate_typesz00); 
BGl_symbol2465z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2466z00zz__evaluate_typesz00); 
BGl_symbol2469z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2470z00zz__evaluate_typesz00); 
BGl_symbol2474z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2475z00zz__evaluate_typesz00); 
BGl_symbol2481z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2482z00zz__evaluate_typesz00); 
BGl_symbol2486z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2487z00zz__evaluate_typesz00); 
BGl_symbol2490z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2491z00zz__evaluate_typesz00); 
BGl_symbol2495z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2496z00zz__evaluate_typesz00); 
BGl_symbol2506z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2507z00zz__evaluate_typesz00); 
BGl_symbol2511z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2512z00zz__evaluate_typesz00); 
BGl_symbol2515z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2516z00zz__evaluate_typesz00); 
BGl_symbol2519z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2520z00zz__evaluate_typesz00); 
BGl_symbol2524z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2525z00zz__evaluate_typesz00); 
BGl_symbol2533z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2534z00zz__evaluate_typesz00); 
BGl_symbol2537z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2538z00zz__evaluate_typesz00); 
BGl_symbol2544z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2545z00zz__evaluate_typesz00); 
BGl_symbol2550z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2551z00zz__evaluate_typesz00); 
BGl_symbol2554z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2555z00zz__evaluate_typesz00); 
BGl_symbol2561z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2562z00zz__evaluate_typesz00); 
BGl_symbol2565z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2566z00zz__evaluate_typesz00); 
BGl_symbol2569z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2570z00zz__evaluate_typesz00); 
BGl_symbol2576z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2577z00zz__evaluate_typesz00); 
BGl_symbol2581z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2582z00zz__evaluate_typesz00); 
BGl_symbol2586z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2587z00zz__evaluate_typesz00); 
BGl_symbol2594z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2595z00zz__evaluate_typesz00); 
BGl_symbol2599z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2600z00zz__evaluate_typesz00); 
BGl_symbol2608z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2609z00zz__evaluate_typesz00); 
BGl_symbol2613z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2614z00zz__evaluate_typesz00); 
BGl_symbol2623z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2624z00zz__evaluate_typesz00); 
BGl_symbol2629z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2630z00zz__evaluate_typesz00); 
BGl_symbol2633z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2634z00zz__evaluate_typesz00); 
BGl_symbol2640z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2641z00zz__evaluate_typesz00); 
BGl_symbol2646z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2647z00zz__evaluate_typesz00); 
BGl_symbol2652z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2653z00zz__evaluate_typesz00); 
BGl_symbol2657z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2658z00zz__evaluate_typesz00); 
BGl_symbol2663z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2664z00zz__evaluate_typesz00); 
BGl_symbol2667z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2668z00zz__evaluate_typesz00); 
BGl_symbol2676z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2677z00zz__evaluate_typesz00); 
BGl_symbol2678z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2679z00zz__evaluate_typesz00); 
BGl_symbol2683z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2684z00zz__evaluate_typesz00); 
BGl_symbol2688z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2689z00zz__evaluate_typesz00); 
BGl_symbol2693z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2694z00zz__evaluate_typesz00); 
BGl_symbol2701z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2702z00zz__evaluate_typesz00); 
return ( 
BGl_symbol2703z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2704z00zz__evaluate_typesz00), BUNSPEC) ;} 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__evaluate_typesz00()
{
{ /* Eval/evaluate_types.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* prof-init */
obj_t BGl_profzd2initzd2zz__evaluate_typesz00()
{
{ /* Eval/evaluate_types.scm 15 */
return 
write_bprof_table();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__evaluate_typesz00()
{
{ /* Eval/evaluate_types.scm 15 */
return BUNSPEC;} 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__evaluate_typesz00()
{
{ /* Eval/evaluate_types.scm 15 */
{ /* Eval/evaluate_types.scm 49 */
obj_t BgL_arg1395z00_1060;obj_t BgL_arg1396z00_1061;
{ /* Eval/evaluate_types.scm 49 */
obj_t BgL_v1282z00_1071;
BgL_v1282z00_1071 = 
create_vector(((long)0)); 
BgL_arg1395z00_1060 = BgL_v1282z00_1071; } 
{ /* Eval/evaluate_types.scm 49 */
obj_t BgL_v1283z00_1072;
BgL_v1283z00_1072 = 
create_vector(((long)0)); 
BgL_arg1396z00_1061 = BgL_v1283z00_1072; } 
BGl_ev_exprz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2377z00zz__evaluate_typesz00, BGl_symbol2379z00zz__evaluate_typesz00, BGl_objectz00zz__objectz00, ((long)36682), BGl_proc2376z00zz__evaluate_typesz00, BGl_proc2375z00zz__evaluate_typesz00, BFALSE, BGl_proc2374z00zz__evaluate_typesz00, BFALSE, BgL_arg1395z00_1060, BgL_arg1396z00_1061); } 
{ /* Eval/evaluate_types.scm 51 */
obj_t BgL_arg1407z00_1079;obj_t BgL_arg1408z00_1080;
{ /* Eval/evaluate_types.scm 51 */
obj_t BgL_v1284z00_1093;
BgL_v1284z00_1093 = 
create_vector(((long)3)); 
VECTOR_SET(BgL_v1284z00_1093,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2383z00zz__evaluate_typesz00, BGl_proc2382z00zz__evaluate_typesz00, BGl_proc2381z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2385z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1284z00_1093,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2390z00zz__evaluate_typesz00, BGl_proc2389z00zz__evaluate_typesz00, BGl_proc2388z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2387z00zz__evaluate_typesz00, BGl_symbol2392z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1284z00_1093,((long)2),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2396z00zz__evaluate_typesz00, BGl_proc2395z00zz__evaluate_typesz00, BGl_proc2394z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2392z00zz__evaluate_typesz00)); 
BgL_arg1407z00_1079 = BgL_v1284z00_1093; } 
{ /* Eval/evaluate_types.scm 51 */
obj_t BgL_v1285z00_1127;
BgL_v1285z00_1127 = 
create_vector(((long)0)); 
BgL_arg1408z00_1080 = BgL_v1285z00_1127; } 
BGl_ev_varz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2401z00zz__evaluate_typesz00, BGl_symbol2379z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)7285), BGl_proc2400z00zz__evaluate_typesz00, BGl_proc2399z00zz__evaluate_typesz00, BFALSE, BGl_proc2398z00zz__evaluate_typesz00, BFALSE, BgL_arg1407z00_1079, BgL_arg1408z00_1080); } 
{ /* Eval/evaluate_types.scm 55 */
obj_t BgL_arg1436z00_1134;obj_t BgL_arg1437z00_1135;
{ /* Eval/evaluate_types.scm 55 */
obj_t BgL_v1286z00_1148;
BgL_v1286z00_1148 = 
create_vector(((long)3)); 
VECTOR_SET(BgL_v1286z00_1148,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2405z00zz__evaluate_typesz00, BGl_proc2404z00zz__evaluate_typesz00, BGl_proc2403z00zz__evaluate_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2392z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1286z00_1148,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2383z00zz__evaluate_typesz00, BGl_proc2408z00zz__evaluate_typesz00, BGl_proc2407z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2385z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1286z00_1148,((long)2),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2411z00zz__evaluate_typesz00, BGl_proc2410z00zz__evaluate_typesz00, BGl_proc2409z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2392z00zz__evaluate_typesz00)); 
BgL_arg1436z00_1134 = BgL_v1286z00_1148; } 
{ /* Eval/evaluate_types.scm 55 */
obj_t BgL_v1287z00_1179;
BgL_v1287z00_1179 = 
create_vector(((long)0)); 
BgL_arg1437z00_1135 = BgL_v1287z00_1179; } 
BGl_ev_globalz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2416z00zz__evaluate_typesz00, BGl_symbol2379z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)59175), BGl_proc2415z00zz__evaluate_typesz00, BGl_proc2414z00zz__evaluate_typesz00, BFALSE, BGl_proc2413z00zz__evaluate_typesz00, BFALSE, BgL_arg1436z00_1134, BgL_arg1437z00_1135); } 
{ /* Eval/evaluate_types.scm 60 */
obj_t BgL_arg1464z00_1186;obj_t BgL_arg1465z00_1187;
{ /* Eval/evaluate_types.scm 60 */
obj_t BgL_v1288z00_1198;
BgL_v1288z00_1198 = 
create_vector(((long)1)); 
VECTOR_SET(BgL_v1288z00_1198,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2420z00zz__evaluate_typesz00, BGl_proc2419z00zz__evaluate_typesz00, BGl_proc2418z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2392z00zz__evaluate_typesz00)); 
BgL_arg1464z00_1186 = BgL_v1288z00_1198; } 
{ /* Eval/evaluate_types.scm 60 */
obj_t BgL_v1289z00_1209;
BgL_v1289z00_1209 = 
create_vector(((long)0)); 
BgL_arg1465z00_1187 = BgL_v1289z00_1209; } 
BGl_ev_littz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2425z00zz__evaluate_typesz00, BGl_symbol2379z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)42418), BGl_proc2424z00zz__evaluate_typesz00, BGl_proc2423z00zz__evaluate_typesz00, BFALSE, BGl_proc2422z00zz__evaluate_typesz00, BFALSE, BgL_arg1464z00_1186, BgL_arg1465z00_1187); } 
{ /* Eval/evaluate_types.scm 62 */
obj_t BgL_arg1480z00_1216;obj_t BgL_arg1481z00_1217;
{ /* Eval/evaluate_types.scm 62 */
obj_t BgL_v1290z00_1230;
BgL_v1290z00_1230 = 
create_vector(((long)3)); 
VECTOR_SET(BgL_v1290z00_1230,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2429z00zz__evaluate_typesz00, BGl_proc2428z00zz__evaluate_typesz00, BGl_proc2427z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1290z00_1230,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2433z00zz__evaluate_typesz00, BGl_proc2432z00zz__evaluate_typesz00, BGl_proc2431z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1290z00_1230,((long)2),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2437z00zz__evaluate_typesz00, BGl_proc2436z00zz__evaluate_typesz00, BGl_proc2435z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
BgL_arg1480z00_1216 = BgL_v1290z00_1230; } 
{ /* Eval/evaluate_types.scm 62 */
obj_t BgL_v1291z00_1261;
BgL_v1291z00_1261 = 
create_vector(((long)0)); 
BgL_arg1481z00_1217 = BgL_v1291z00_1261; } 
BGl_ev_ifz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2442z00zz__evaluate_typesz00, BGl_symbol2379z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)19099), BGl_proc2441z00zz__evaluate_typesz00, BGl_proc2440z00zz__evaluate_typesz00, BFALSE, BGl_proc2439z00zz__evaluate_typesz00, BFALSE, BgL_arg1480z00_1216, BgL_arg1481z00_1217); } 
{ /* Eval/evaluate_types.scm 66 */
obj_t BgL_arg1508z00_1268;obj_t BgL_arg1509z00_1269;
{ /* Eval/evaluate_types.scm 66 */
obj_t BgL_v1292z00_1280;
BgL_v1292z00_1280 = 
create_vector(((long)1)); 
VECTOR_SET(BgL_v1292z00_1280,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2446z00zz__evaluate_typesz00, BGl_proc2445z00zz__evaluate_typesz00, BGl_proc2444z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2392z00zz__evaluate_typesz00)); 
BgL_arg1508z00_1268 = BgL_v1292z00_1280; } 
{ /* Eval/evaluate_types.scm 66 */
obj_t BgL_v1293z00_1291;
BgL_v1293z00_1291 = 
create_vector(((long)0)); 
BgL_arg1509z00_1269 = BgL_v1293z00_1291; } 
BGl_ev_listz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2451z00zz__evaluate_typesz00, BGl_symbol2379z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)39617), BGl_proc2450z00zz__evaluate_typesz00, BGl_proc2449z00zz__evaluate_typesz00, BFALSE, BGl_proc2448z00zz__evaluate_typesz00, BFALSE, BgL_arg1508z00_1268, BgL_arg1509z00_1269); } 
{ /* Eval/evaluate_types.scm 68 */
obj_t BgL_arg1526z00_1298;obj_t BgL_arg1527z00_1299;
{ /* Eval/evaluate_types.scm 68 */
obj_t BgL_v1294z00_1310;
BgL_v1294z00_1310 = 
create_vector(((long)0)); 
BgL_arg1526z00_1298 = BgL_v1294z00_1310; } 
{ /* Eval/evaluate_types.scm 68 */
obj_t BgL_v1295z00_1311;
BgL_v1295z00_1311 = 
create_vector(((long)0)); 
BgL_arg1527z00_1299 = BgL_v1295z00_1311; } 
BGl_ev_orz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2456z00zz__evaluate_typesz00, BGl_symbol2379z00zz__evaluate_typesz00, BGl_ev_listz00zz__evaluate_typesz00, ((long)50334), BGl_proc2455z00zz__evaluate_typesz00, BGl_proc2454z00zz__evaluate_typesz00, BFALSE, BGl_proc2453z00zz__evaluate_typesz00, BFALSE, BgL_arg1526z00_1298, BgL_arg1527z00_1299); } 
{ /* Eval/evaluate_types.scm 69 */
obj_t BgL_arg1540z00_1318;obj_t BgL_arg1542z00_1319;
{ /* Eval/evaluate_types.scm 69 */
obj_t BgL_v1296z00_1330;
BgL_v1296z00_1330 = 
create_vector(((long)0)); 
BgL_arg1540z00_1318 = BgL_v1296z00_1330; } 
{ /* Eval/evaluate_types.scm 69 */
obj_t BgL_v1297z00_1331;
BgL_v1297z00_1331 = 
create_vector(((long)0)); 
BgL_arg1542z00_1319 = BgL_v1297z00_1331; } 
BGl_ev_andz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2461z00zz__evaluate_typesz00, BGl_symbol2379z00zz__evaluate_typesz00, BGl_ev_listz00zz__evaluate_typesz00, ((long)26888), BGl_proc2460z00zz__evaluate_typesz00, BGl_proc2459z00zz__evaluate_typesz00, BFALSE, BGl_proc2458z00zz__evaluate_typesz00, BFALSE, BgL_arg1540z00_1318, BgL_arg1542z00_1319); } 
{ /* Eval/evaluate_types.scm 70 */
obj_t BgL_arg1553z00_1338;obj_t BgL_arg1554z00_1339;
{ /* Eval/evaluate_types.scm 70 */
obj_t BgL_v1298z00_1351;
BgL_v1298z00_1351 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1298z00_1351,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2465z00zz__evaluate_typesz00, BGl_proc2464z00zz__evaluate_typesz00, BGl_proc2463z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1298z00_1351,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2469z00zz__evaluate_typesz00, BGl_proc2468z00zz__evaluate_typesz00, BGl_proc2467z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
BgL_arg1553z00_1338 = BgL_v1298z00_1351; } 
{ /* Eval/evaluate_types.scm 70 */
obj_t BgL_v1299z00_1372;
BgL_v1299z00_1372 = 
create_vector(((long)0)); 
BgL_arg1554z00_1339 = BgL_v1299z00_1372; } 
BGl_ev_prog2z00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2474z00zz__evaluate_typesz00, BGl_symbol2379z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)14177), BGl_proc2473z00zz__evaluate_typesz00, BGl_proc2472z00zz__evaluate_typesz00, BFALSE, BGl_proc2471z00zz__evaluate_typesz00, BFALSE, BgL_arg1553z00_1338, BgL_arg1554z00_1339); } 
{ /* Eval/evaluate_types.scm 73 */
obj_t BgL_arg1575z00_1379;obj_t BgL_arg1576z00_1380;
{ /* Eval/evaluate_types.scm 73 */
obj_t BgL_v1300z00_1391;
BgL_v1300z00_1391 = 
create_vector(((long)1)); 
VECTOR_SET(BgL_v1300z00_1391,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2437z00zz__evaluate_typesz00, BGl_proc2477z00zz__evaluate_typesz00, BGl_proc2476z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
BgL_arg1575z00_1379 = BgL_v1300z00_1391; } 
{ /* Eval/evaluate_types.scm 73 */
obj_t BgL_v1301z00_1402;
BgL_v1301z00_1402 = 
create_vector(((long)0)); 
BgL_arg1576z00_1380 = BgL_v1301z00_1402; } 
BGl_ev_hookz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2481z00zz__evaluate_typesz00, BGl_symbol2379z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)32125), BGl_proc2480z00zz__evaluate_typesz00, BGl_proc2479z00zz__evaluate_typesz00, BFALSE, BGl_proc2478z00zz__evaluate_typesz00, BFALSE, BgL_arg1575z00_1379, BgL_arg1576z00_1380); } 
{ /* Eval/evaluate_types.scm 75 */
obj_t BgL_arg1591z00_1409;obj_t BgL_arg1592z00_1410;
{ /* Eval/evaluate_types.scm 75 */
obj_t BgL_v1302z00_1421;
BgL_v1302z00_1421 = 
create_vector(((long)0)); 
BgL_arg1591z00_1409 = BgL_v1302z00_1421; } 
{ /* Eval/evaluate_types.scm 75 */
obj_t BgL_v1303z00_1422;
BgL_v1303z00_1422 = 
create_vector(((long)0)); 
BgL_arg1592z00_1410 = BgL_v1303z00_1422; } 
BGl_ev_trapz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2486z00zz__evaluate_typesz00, BGl_symbol2379z00zz__evaluate_typesz00, BGl_ev_hookz00zz__evaluate_typesz00, ((long)24451), BGl_proc2485z00zz__evaluate_typesz00, BGl_proc2484z00zz__evaluate_typesz00, BFALSE, BGl_proc2483z00zz__evaluate_typesz00, BFALSE, BgL_arg1591z00_1409, BgL_arg1592z00_1410); } 
{ /* Eval/evaluate_types.scm 76 */
obj_t BgL_arg1601z00_1429;obj_t BgL_arg1602z00_1430;
{ /* Eval/evaluate_types.scm 76 */
obj_t BgL_v1304z00_1442;
BgL_v1304z00_1442 = 
create_vector(((long)1)); 
VECTOR_SET(BgL_v1304z00_1442,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2490z00zz__evaluate_typesz00, BGl_proc2489z00zz__evaluate_typesz00, BGl_proc2488z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_varz00zz__evaluate_typesz00)); 
BgL_arg1601z00_1429 = BgL_v1304z00_1442; } 
{ /* Eval/evaluate_types.scm 76 */
obj_t BgL_v1305z00_1453;
BgL_v1305z00_1453 = 
create_vector(((long)0)); 
BgL_arg1602z00_1430 = BgL_v1305z00_1453; } 
BGl_ev_setlocalz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2495z00zz__evaluate_typesz00, BGl_symbol2379z00zz__evaluate_typesz00, BGl_ev_hookz00zz__evaluate_typesz00, ((long)37950), BGl_proc2494z00zz__evaluate_typesz00, BGl_proc2493z00zz__evaluate_typesz00, BFALSE, BGl_proc2492z00zz__evaluate_typesz00, BFALSE, BgL_arg1601z00_1429, BgL_arg1602z00_1430); } 
{ /* Eval/evaluate_types.scm 78 */
obj_t BgL_arg1616z00_1460;obj_t BgL_arg1617z00_1461;
{ /* Eval/evaluate_types.scm 78 */
obj_t BgL_v1306z00_1475;
BgL_v1306z00_1475 = 
create_vector(((long)3)); 
VECTOR_SET(BgL_v1306z00_1475,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2405z00zz__evaluate_typesz00, BGl_proc2498z00zz__evaluate_typesz00, BGl_proc2497z00zz__evaluate_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2392z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1306z00_1475,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2383z00zz__evaluate_typesz00, BGl_proc2500z00zz__evaluate_typesz00, BGl_proc2499z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2385z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1306z00_1475,((long)2),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2411z00zz__evaluate_typesz00, BGl_proc2502z00zz__evaluate_typesz00, BGl_proc2501z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2392z00zz__evaluate_typesz00)); 
BgL_arg1616z00_1460 = BgL_v1306z00_1475; } 
{ /* Eval/evaluate_types.scm 78 */
obj_t BgL_v1307z00_1506;
BgL_v1307z00_1506 = 
create_vector(((long)0)); 
BgL_arg1617z00_1461 = BgL_v1307z00_1506; } 
BGl_ev_setglobalz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2506z00zz__evaluate_typesz00, BGl_symbol2379z00zz__evaluate_typesz00, BGl_ev_hookz00zz__evaluate_typesz00, ((long)62117), BGl_proc2505z00zz__evaluate_typesz00, BGl_proc2504z00zz__evaluate_typesz00, BFALSE, BGl_proc2503z00zz__evaluate_typesz00, BFALSE, BgL_arg1616z00_1460, BgL_arg1617z00_1461); } 
{ /* Eval/evaluate_types.scm 82 */
obj_t BgL_arg1650z00_1513;obj_t BgL_arg1651z00_1514;
{ /* Eval/evaluate_types.scm 82 */
obj_t BgL_v1308z00_1528;
BgL_v1308z00_1528 = 
create_vector(((long)0)); 
BgL_arg1650z00_1513 = BgL_v1308z00_1528; } 
{ /* Eval/evaluate_types.scm 82 */
obj_t BgL_v1309z00_1529;
BgL_v1309z00_1529 = 
create_vector(((long)0)); 
BgL_arg1651z00_1514 = BgL_v1309z00_1529; } 
BGl_ev_defglobalz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2511z00zz__evaluate_typesz00, BGl_symbol2379z00zz__evaluate_typesz00, BGl_ev_setglobalz00zz__evaluate_typesz00, ((long)36158), BGl_proc2510z00zz__evaluate_typesz00, BGl_proc2509z00zz__evaluate_typesz00, BFALSE, BGl_proc2508z00zz__evaluate_typesz00, BFALSE, BgL_arg1650z00_1513, BgL_arg1651z00_1514); } 
{ /* Eval/evaluate_types.scm 83 */
obj_t BgL_arg1662z00_1536;obj_t BgL_arg1663z00_1537;
{ /* Eval/evaluate_types.scm 83 */
obj_t BgL_v1310z00_1549;
BgL_v1310z00_1549 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1310z00_1549,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2515z00zz__evaluate_typesz00, BGl_proc2514z00zz__evaluate_typesz00, BGl_proc2513z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_varz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1310z00_1549,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2519z00zz__evaluate_typesz00, BGl_proc2518z00zz__evaluate_typesz00, BGl_proc2517z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
BgL_arg1662z00_1536 = BgL_v1310z00_1549; } 
{ /* Eval/evaluate_types.scm 83 */
obj_t BgL_v1311z00_1570;
BgL_v1311z00_1570 = 
create_vector(((long)0)); 
BgL_arg1663z00_1537 = BgL_v1311z00_1570; } 
BGl_ev_bindzd2exitzd2zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2524z00zz__evaluate_typesz00, BGl_symbol2379z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)10723), BGl_proc2523z00zz__evaluate_typesz00, BGl_proc2522z00zz__evaluate_typesz00, BFALSE, BGl_proc2521z00zz__evaluate_typesz00, BFALSE, BgL_arg1662z00_1536, BgL_arg1663z00_1537); } 
{ /* Eval/evaluate_types.scm 86 */
obj_t BgL_arg1686z00_1577;obj_t BgL_arg1687z00_1578;
{ /* Eval/evaluate_types.scm 86 */
obj_t BgL_v1312z00_1590;
BgL_v1312z00_1590 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1312z00_1590,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2437z00zz__evaluate_typesz00, BGl_proc2527z00zz__evaluate_typesz00, BGl_proc2526z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1312z00_1590,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2519z00zz__evaluate_typesz00, BGl_proc2529z00zz__evaluate_typesz00, BGl_proc2528z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
BgL_arg1686z00_1577 = BgL_v1312z00_1590; } 
{ /* Eval/evaluate_types.scm 86 */
obj_t BgL_v1313z00_1611;
BgL_v1313z00_1611 = 
create_vector(((long)0)); 
BgL_arg1687z00_1578 = BgL_v1313z00_1611; } 
BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2533z00zz__evaluate_typesz00, BGl_symbol2379z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)59644), BGl_proc2532z00zz__evaluate_typesz00, BGl_proc2531z00zz__evaluate_typesz00, BFALSE, BGl_proc2530z00zz__evaluate_typesz00, BFALSE, BgL_arg1686z00_1577, BgL_arg1687z00_1578); } 
{ /* Eval/evaluate_types.scm 89 */
obj_t BgL_arg1706z00_1618;obj_t BgL_arg1707z00_1619;
{ /* Eval/evaluate_types.scm 89 */
obj_t BgL_v1314z00_1631;
BgL_v1314z00_1631 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1314z00_1631,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2537z00zz__evaluate_typesz00, BGl_proc2536z00zz__evaluate_typesz00, BGl_proc2535z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1314z00_1631,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2519z00zz__evaluate_typesz00, BGl_proc2540z00zz__evaluate_typesz00, BGl_proc2539z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
BgL_arg1706z00_1618 = BgL_v1314z00_1631; } 
{ /* Eval/evaluate_types.scm 89 */
obj_t BgL_v1315z00_1652;
BgL_v1315z00_1652 = 
create_vector(((long)0)); 
BgL_arg1707z00_1619 = BgL_v1315z00_1652; } 
BGl_ev_withzd2handlerzd2zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2544z00zz__evaluate_typesz00, BGl_symbol2379z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)54033), BGl_proc2543z00zz__evaluate_typesz00, BGl_proc2542z00zz__evaluate_typesz00, BFALSE, BGl_proc2541z00zz__evaluate_typesz00, BFALSE, BgL_arg1706z00_1618, BgL_arg1707z00_1619); } 
{ /* Eval/evaluate_types.scm 92 */
obj_t BgL_arg1727z00_1659;obj_t BgL_arg1728z00_1660;
{ /* Eval/evaluate_types.scm 92 */
obj_t BgL_v1316z00_1674;
BgL_v1316z00_1674 = 
create_vector(((long)4)); 
VECTOR_SET(BgL_v1316z00_1674,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2405z00zz__evaluate_typesz00, BGl_proc2547z00zz__evaluate_typesz00, BGl_proc2546z00zz__evaluate_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2392z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1316z00_1674,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2550z00zz__evaluate_typesz00, BGl_proc2549z00zz__evaluate_typesz00, BGl_proc2548z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1316z00_1674,((long)2),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2554z00zz__evaluate_typesz00, BGl_proc2553z00zz__evaluate_typesz00, BGl_proc2552z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1316z00_1674,((long)3),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2519z00zz__evaluate_typesz00, BGl_proc2557z00zz__evaluate_typesz00, BGl_proc2556z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
BgL_arg1727z00_1659 = BgL_v1316z00_1674; } 
{ /* Eval/evaluate_types.scm 92 */
obj_t BgL_v1317z00_1715;
BgL_v1317z00_1715 = 
create_vector(((long)0)); 
BgL_arg1728z00_1660 = BgL_v1317z00_1715; } 
BGl_ev_synchroniza7eza7zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2561z00zz__evaluate_typesz00, BGl_symbol2379z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)40653), BGl_proc2560z00zz__evaluate_typesz00, BGl_proc2559z00zz__evaluate_typesz00, BFALSE, BGl_proc2558z00zz__evaluate_typesz00, BFALSE, BgL_arg1727z00_1659, BgL_arg1728z00_1660); } 
{ /* Eval/evaluate_types.scm 97 */
obj_t BgL_arg1757z00_1722;obj_t BgL_arg1758z00_1723;
{ /* Eval/evaluate_types.scm 97 */
obj_t BgL_v1318z00_1736;
BgL_v1318z00_1736 = 
create_vector(((long)3)); 
VECTOR_SET(BgL_v1318z00_1736,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2565z00zz__evaluate_typesz00, BGl_proc2564z00zz__evaluate_typesz00, BGl_proc2563z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2392z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1318z00_1736,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2569z00zz__evaluate_typesz00, BGl_proc2568z00zz__evaluate_typesz00, BGl_proc2567z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2392z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1318z00_1736,((long)2),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2519z00zz__evaluate_typesz00, BGl_proc2572z00zz__evaluate_typesz00, BGl_proc2571z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
BgL_arg1757z00_1722 = BgL_v1318z00_1736; } 
{ /* Eval/evaluate_types.scm 97 */
obj_t BgL_v1319z00_1767;
BgL_v1319z00_1767 = 
create_vector(((long)0)); 
BgL_arg1758z00_1723 = BgL_v1319z00_1767; } 
BGl_ev_binderz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2576z00zz__evaluate_typesz00, BGl_symbol2379z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)50341), BGl_proc2575z00zz__evaluate_typesz00, BGl_proc2574z00zz__evaluate_typesz00, BFALSE, BGl_proc2573z00zz__evaluate_typesz00, BFALSE, BgL_arg1757z00_1722, BgL_arg1758z00_1723); } 
{ /* Eval/evaluate_types.scm 101 */
obj_t BgL_arg1782z00_1774;obj_t BgL_arg1783z00_1775;
{ /* Eval/evaluate_types.scm 101 */
obj_t BgL_v1320z00_1789;
BgL_v1320z00_1789 = 
create_vector(((long)1)); 
VECTOR_SET(BgL_v1320z00_1789,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2581z00zz__evaluate_typesz00, BGl_proc2580z00zz__evaluate_typesz00, BGl_proc2579z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2578z00zz__evaluate_typesz00, BGl_symbol2392z00zz__evaluate_typesz00)); 
BgL_arg1782z00_1774 = BgL_v1320z00_1789; } 
{ /* Eval/evaluate_types.scm 101 */
obj_t BgL_v1321z00_1803;
BgL_v1321z00_1803 = 
create_vector(((long)0)); 
BgL_arg1783z00_1775 = BgL_v1321z00_1803; } 
BGl_ev_letz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2586z00zz__evaluate_typesz00, BGl_symbol2379z00zz__evaluate_typesz00, BGl_ev_binderz00zz__evaluate_typesz00, ((long)20484), BGl_proc2585z00zz__evaluate_typesz00, BGl_proc2584z00zz__evaluate_typesz00, BFALSE, BGl_proc2583z00zz__evaluate_typesz00, BFALSE, BgL_arg1782z00_1774, BgL_arg1783z00_1775); } 
{ /* Eval/evaluate_types.scm 103 */
obj_t BgL_arg1799z00_1810;obj_t BgL_arg1800z00_1811;
{ /* Eval/evaluate_types.scm 103 */
obj_t BgL_v1322z00_1825;
BgL_v1322z00_1825 = 
create_vector(((long)1)); 
VECTOR_SET(BgL_v1322z00_1825,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2581z00zz__evaluate_typesz00, BGl_proc2590z00zz__evaluate_typesz00, BGl_proc2589z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2588z00zz__evaluate_typesz00, BGl_symbol2392z00zz__evaluate_typesz00)); 
BgL_arg1799z00_1810 = BgL_v1322z00_1825; } 
{ /* Eval/evaluate_types.scm 103 */
obj_t BgL_v1323z00_1839;
BgL_v1323z00_1839 = 
create_vector(((long)0)); 
BgL_arg1800z00_1811 = BgL_v1323z00_1839; } 
BGl_ev_letza2za2zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2594z00zz__evaluate_typesz00, BGl_symbol2379z00zz__evaluate_typesz00, BGl_ev_binderz00zz__evaluate_typesz00, ((long)9906), BGl_proc2593z00zz__evaluate_typesz00, BGl_proc2592z00zz__evaluate_typesz00, BFALSE, BGl_proc2591z00zz__evaluate_typesz00, BFALSE, BgL_arg1799z00_1810, BgL_arg1800z00_1811); } 
{ /* Eval/evaluate_types.scm 105 */
obj_t BgL_arg1816z00_1846;obj_t BgL_arg1817z00_1847;
{ /* Eval/evaluate_types.scm 105 */
obj_t BgL_v1324z00_1860;
BgL_v1324z00_1860 = 
create_vector(((long)0)); 
BgL_arg1816z00_1846 = BgL_v1324z00_1860; } 
{ /* Eval/evaluate_types.scm 105 */
obj_t BgL_v1325z00_1861;
BgL_v1325z00_1861 = 
create_vector(((long)0)); 
BgL_arg1817z00_1847 = BgL_v1325z00_1861; } 
BGl_ev_letrecz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2599z00zz__evaluate_typesz00, BGl_symbol2379z00zz__evaluate_typesz00, BGl_ev_binderz00zz__evaluate_typesz00, ((long)43956), BGl_proc2598z00zz__evaluate_typesz00, BGl_proc2597z00zz__evaluate_typesz00, BFALSE, BGl_proc2596z00zz__evaluate_typesz00, BFALSE, BgL_arg1816z00_1846, BgL_arg1817z00_1847); } 
{ /* Eval/evaluate_types.scm 106 */
obj_t BgL_arg1826z00_1868;obj_t BgL_arg1827z00_1869;
{ /* Eval/evaluate_types.scm 106 */
obj_t BgL_v1326z00_1885;
BgL_v1326z00_1885 = 
create_vector(((long)6)); 
VECTOR_SET(BgL_v1326z00_1885,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2565z00zz__evaluate_typesz00, BGl_proc2602z00zz__evaluate_typesz00, BGl_proc2601z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2392z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1326z00_1885,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2569z00zz__evaluate_typesz00, BGl_proc2604z00zz__evaluate_typesz00, BGl_proc2603z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2392z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1326z00_1885,((long)2),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2608z00zz__evaluate_typesz00, BGl_proc2607z00zz__evaluate_typesz00, BGl_proc2606z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2605z00zz__evaluate_typesz00, BGl_symbol2392z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1326z00_1885,((long)3),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2613z00zz__evaluate_typesz00, BGl_proc2612z00zz__evaluate_typesz00, BGl_proc2611z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2610z00zz__evaluate_typesz00, BGl_symbol2392z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1326z00_1885,((long)4),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2519z00zz__evaluate_typesz00, BGl_proc2616z00zz__evaluate_typesz00, BGl_proc2615z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1326z00_1885,((long)5),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2581z00zz__evaluate_typesz00, BGl_proc2619z00zz__evaluate_typesz00, BGl_proc2618z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2617z00zz__evaluate_typesz00, BGl_symbol2392z00zz__evaluate_typesz00)); 
BgL_arg1826z00_1868 = BgL_v1326z00_1885; } 
{ /* Eval/evaluate_types.scm 106 */
obj_t BgL_v1327z00_1955;
BgL_v1327z00_1955 = 
create_vector(((long)0)); 
BgL_arg1827z00_1869 = BgL_v1327z00_1955; } 
BGl_ev_labelsz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2623z00zz__evaluate_typesz00, BGl_symbol2379z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)51941), BGl_proc2622z00zz__evaluate_typesz00, BGl_proc2621z00zz__evaluate_typesz00, BFALSE, BGl_proc2620z00zz__evaluate_typesz00, BFALSE, BgL_arg1826z00_1868, BgL_arg1827z00_1869); } 
{ /* Eval/evaluate_types.scm 114 */
obj_t BgL_arg1872z00_1962;obj_t BgL_arg1873z00_1963;
{ /* Eval/evaluate_types.scm 114 */
obj_t BgL_v1328z00_1977;
BgL_v1328z00_1977 = 
create_vector(((long)4)); 
VECTOR_SET(BgL_v1328z00_1977,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2405z00zz__evaluate_typesz00, BGl_proc2626z00zz__evaluate_typesz00, BGl_proc2625z00zz__evaluate_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2392z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1328z00_1977,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2629z00zz__evaluate_typesz00, BGl_proc2628z00zz__evaluate_typesz00, BGl_proc2627z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_varz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1328z00_1977,((long)2),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2633z00zz__evaluate_typesz00, BGl_proc2632z00zz__evaluate_typesz00, BGl_proc2631z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_labelsz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1328z00_1977,((long)3),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2446z00zz__evaluate_typesz00, BGl_proc2636z00zz__evaluate_typesz00, BGl_proc2635z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2392z00zz__evaluate_typesz00)); 
BgL_arg1872z00_1962 = BgL_v1328z00_1977; } 
{ /* Eval/evaluate_types.scm 114 */
obj_t BgL_v1329z00_2018;
BgL_v1329z00_2018 = 
create_vector(((long)0)); 
BgL_arg1873z00_1963 = BgL_v1329z00_2018; } 
BGl_ev_gotoz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2640z00zz__evaluate_typesz00, BGl_symbol2379z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)25746), BGl_proc2639z00zz__evaluate_typesz00, BGl_proc2638z00zz__evaluate_typesz00, BFALSE, BGl_proc2637z00zz__evaluate_typesz00, BFALSE, BgL_arg1872z00_1962, BgL_arg1873z00_1963); } 
{ /* Eval/evaluate_types.scm 119 */
obj_t BgL_arg1902z00_2025;obj_t BgL_arg1903z00_2026;
{ /* Eval/evaluate_types.scm 119 */
obj_t BgL_v1330z00_2040;
BgL_v1330z00_2040 = 
create_vector(((long)4)); 
VECTOR_SET(BgL_v1330z00_2040,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2405z00zz__evaluate_typesz00, BGl_proc2643z00zz__evaluate_typesz00, BGl_proc2642z00zz__evaluate_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2392z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1330z00_2040,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2646z00zz__evaluate_typesz00, BGl_proc2645z00zz__evaluate_typesz00, BGl_proc2644z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1330z00_2040,((long)2),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2446z00zz__evaluate_typesz00, BGl_proc2649z00zz__evaluate_typesz00, BGl_proc2648z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2392z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1330z00_2040,((long)3),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2652z00zz__evaluate_typesz00, BGl_proc2651z00zz__evaluate_typesz00, BGl_proc2650z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2392z00zz__evaluate_typesz00)); 
BgL_arg1902z00_2025 = BgL_v1330z00_2040; } 
{ /* Eval/evaluate_types.scm 119 */
obj_t BgL_v1331z00_2081;
BgL_v1331z00_2081 = 
create_vector(((long)0)); 
BgL_arg1903z00_2026 = BgL_v1331z00_2081; } 
BGl_ev_appz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2657z00zz__evaluate_typesz00, BGl_symbol2379z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)55822), BGl_proc2656z00zz__evaluate_typesz00, BGl_proc2655z00zz__evaluate_typesz00, BFALSE, BGl_proc2654z00zz__evaluate_typesz00, BFALSE, BgL_arg1902z00_2025, BgL_arg1903z00_2026); } 
{ /* Eval/evaluate_types.scm 122 */
obj_t BgL_arg1932z00_2088;obj_t BgL_arg1933z00_2089;
{ /* Eval/evaluate_types.scm 122 */
obj_t BgL_v1332z00_2109;
BgL_v1332z00_2109 = 
create_vector(((long)10)); 
VECTOR_SET(BgL_v1332z00_2109,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2405z00zz__evaluate_typesz00, BGl_proc2660z00zz__evaluate_typesz00, BGl_proc2659z00zz__evaluate_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2392z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1332z00_2109,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2663z00zz__evaluate_typesz00, BGl_proc2662z00zz__evaluate_typesz00, BGl_proc2661z00zz__evaluate_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2392z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1332z00_2109,((long)2),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2667z00zz__evaluate_typesz00, BGl_proc2666z00zz__evaluate_typesz00, BGl_proc2665z00zz__evaluate_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2392z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1332z00_2109,((long)3),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2565z00zz__evaluate_typesz00, BGl_proc2670z00zz__evaluate_typesz00, BGl_proc2669z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2392z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1332z00_2109,((long)4),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2519z00zz__evaluate_typesz00, BGl_proc2672z00zz__evaluate_typesz00, BGl_proc2671z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1332z00_2109,((long)5),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2676z00zz__evaluate_typesz00, BGl_proc2675z00zz__evaluate_typesz00, BGl_proc2674z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2673z00zz__evaluate_typesz00, BGl_symbol2678z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1332z00_2109,((long)6),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2683z00zz__evaluate_typesz00, BGl_proc2682z00zz__evaluate_typesz00, BGl_proc2681z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2680z00zz__evaluate_typesz00, BGl_symbol2392z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1332z00_2109,((long)7),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2688z00zz__evaluate_typesz00, BGl_proc2687z00zz__evaluate_typesz00, BGl_proc2686z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2685z00zz__evaluate_typesz00, BGl_symbol2392z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1332z00_2109,((long)8),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2693z00zz__evaluate_typesz00, BGl_proc2692z00zz__evaluate_typesz00, BGl_proc2691z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2690z00zz__evaluate_typesz00, BGl_symbol2392z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1332z00_2109,((long)9),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2581z00zz__evaluate_typesz00, BGl_proc2697z00zz__evaluate_typesz00, BGl_proc2696z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2695z00zz__evaluate_typesz00, BGl_symbol2392z00zz__evaluate_typesz00)); 
BgL_arg1932z00_2088 = BgL_v1332z00_2109; } 
{ /* Eval/evaluate_types.scm 122 */
obj_t BgL_v1333z00_2225;
BgL_v1333z00_2225 = 
create_vector(((long)0)); 
BgL_arg1933z00_2089 = BgL_v1333z00_2225; } 
return ( 
BGl_ev_absz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2701z00zz__evaluate_typesz00, BGl_symbol2379z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)22827), BGl_proc2700z00zz__evaluate_typesz00, BGl_proc2699z00zz__evaluate_typesz00, BFALSE, BGl_proc2698z00zz__evaluate_typesz00, BFALSE, BgL_arg1932z00_2088, BgL_arg1933z00_2089), BUNSPEC) ;} } 

}



/* &<@anonymous:1938> */
obj_t BGl_z62zc3z04anonymousza31938ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3377, obj_t BgL_new1190z00_3378)
{
{ /* Eval/evaluate_types.scm 122 */
{ 
BgL_ev_absz00_bglt BgL_auxz00_4560;
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_new1190z00_3378)))->BgL_locz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_new1190z00_3378)))->BgL_wherez00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_new1190z00_3378)))->BgL_arityz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_new1190z00_3378)))->BgL_varsz00)=((obj_t)BUNSPEC),BUNSPEC); 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_4569;
{ /* Eval/evaluate_types.scm 122 */
obj_t BgL_classz00_3853;
BgL_classz00_3853 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 122 */
obj_t BgL__ortest_1281z00_3854;
BgL__ortest_1281z00_3854 = 
BGL_CLASS_NIL(BgL_classz00_3853); 
if(
CBOOL(BgL__ortest_1281z00_3854))
{ /* Eval/evaluate_types.scm 122 */
BgL_auxz00_4569 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1281z00_3854)
; }  else 
{ /* Eval/evaluate_types.scm 122 */
BgL_auxz00_4569 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_3853))
; } } } 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_new1190z00_3378)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_4569),BUNSPEC); } 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_new1190z00_3378)))->BgL_siza7eza7)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_new1190z00_3378)))->BgL_bindz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_new1190z00_3378)))->BgL_freez00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_new1190z00_3378)))->BgL_innerz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_new1190z00_3378)))->BgL_boxesz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_4560 = 
((BgL_ev_absz00_bglt)BgL_new1190z00_3378); 
return 
((obj_t)BgL_auxz00_4560);} } 

}



/* &lambda1936 */
BgL_ev_absz00_bglt BGl_z62lambda1936z62zz__evaluate_typesz00(obj_t BgL_envz00_3379)
{
{ /* Eval/evaluate_types.scm 122 */
{ /* Eval/evaluate_types.scm 122 */
BgL_ev_absz00_bglt BgL_new1189z00_3855;
BgL_new1189z00_3855 = 
((BgL_ev_absz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_absz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 122 */
long BgL_arg1937z00_3856;
{ /* Eval/evaluate_types.scm 122 */
long BgL_res2323z00_3857;
BgL_res2323z00_3857 = 
BGL_CLASS_INDEX(BGl_ev_absz00zz__evaluate_typesz00); 
BgL_arg1937z00_3856 = BgL_res2323z00_3857; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1189z00_3855), BgL_arg1937z00_3856); } 
return BgL_new1189z00_3855;} } 

}



/* &lambda1934 */
BgL_ev_absz00_bglt BGl_z62lambda1934z62zz__evaluate_typesz00(obj_t BgL_envz00_3380, obj_t BgL_loc1179z00_3381, obj_t BgL_where1180z00_3382, obj_t BgL_arity1181z00_3383, obj_t BgL_vars1182z00_3384, obj_t BgL_body1183z00_3385, obj_t BgL_siza7e1184za7_3386, obj_t BgL_bind1185z00_3387, obj_t BgL_free1186z00_3388, obj_t BgL_inner1187z00_3389, obj_t BgL_boxes1188z00_3390)
{
{ /* Eval/evaluate_types.scm 122 */
{ /* Eval/evaluate_types.scm 122 */
int BgL_siza7e1184za7_3859;
BgL_siza7e1184za7_3859 = 
CINT(BgL_siza7e1184za7_3386); 
{ /* Eval/evaluate_types.scm 122 */
BgL_ev_absz00_bglt BgL_new1242z00_3860;
{ /* Eval/evaluate_types.scm 122 */
BgL_ev_absz00_bglt BgL_new1241z00_3861;
BgL_new1241z00_3861 = 
((BgL_ev_absz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_absz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 122 */
long BgL_arg1935z00_3862;
{ /* Eval/evaluate_types.scm 122 */
long BgL_res2322z00_3863;
BgL_res2322z00_3863 = 
BGL_CLASS_INDEX(BGl_ev_absz00zz__evaluate_typesz00); 
BgL_arg1935z00_3862 = BgL_res2322z00_3863; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1241z00_3861), BgL_arg1935z00_3862); } 
BgL_new1242z00_3860 = BgL_new1241z00_3861; } 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1242z00_3860))->BgL_locz00)=((obj_t)BgL_loc1179z00_3381),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1242z00_3860))->BgL_wherez00)=((obj_t)BgL_where1180z00_3382),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1242z00_3860))->BgL_arityz00)=((obj_t)BgL_arity1181z00_3383),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1242z00_3860))->BgL_varsz00)=((obj_t)BgL_vars1182z00_3384),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1242z00_3860))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_body1183z00_3385)),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1242z00_3860))->BgL_siza7eza7)=((int)BgL_siza7e1184za7_3859),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1242z00_3860))->BgL_bindz00)=((obj_t)BgL_bind1185z00_3387),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1242z00_3860))->BgL_freez00)=((obj_t)BgL_free1186z00_3388),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1242z00_3860))->BgL_innerz00)=((obj_t)BgL_inner1187z00_3389),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1242z00_3860))->BgL_boxesz00)=((obj_t)BgL_boxes1188z00_3390),BUNSPEC); 
return BgL_new1242z00_3860;} } } 

}



/* &<@anonymous:1998> */
obj_t BGl_z62zc3z04anonymousza31998ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3391)
{
{ /* Eval/evaluate_types.scm 122 */
return BNIL;} 

}



/* &lambda1997 */
obj_t BGl_z62lambda1997z62zz__evaluate_typesz00(obj_t BgL_envz00_3392, obj_t BgL_oz00_3393, obj_t BgL_vz00_3394)
{
{ /* Eval/evaluate_types.scm 122 */
return 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3393)))->BgL_boxesz00)=((obj_t)BgL_vz00_3394),BUNSPEC);} 

}



/* &lambda1996 */
obj_t BGl_z62lambda1996z62zz__evaluate_typesz00(obj_t BgL_envz00_3395, obj_t BgL_oz00_3396)
{
{ /* Eval/evaluate_types.scm 122 */
return 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3396)))->BgL_boxesz00);} 

}



/* &<@anonymous:1991> */
obj_t BGl_z62zc3z04anonymousza31991ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3397)
{
{ /* Eval/evaluate_types.scm 122 */
return BNIL;} 

}



/* &lambda1990 */
obj_t BGl_z62lambda1990z62zz__evaluate_typesz00(obj_t BgL_envz00_3398, obj_t BgL_oz00_3399, obj_t BgL_vz00_3400)
{
{ /* Eval/evaluate_types.scm 122 */
return 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3399)))->BgL_innerz00)=((obj_t)BgL_vz00_3400),BUNSPEC);} 

}



/* &lambda1989 */
obj_t BGl_z62lambda1989z62zz__evaluate_typesz00(obj_t BgL_envz00_3401, obj_t BgL_oz00_3402)
{
{ /* Eval/evaluate_types.scm 122 */
return 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3402)))->BgL_innerz00);} 

}



/* &<@anonymous:1984> */
obj_t BGl_z62zc3z04anonymousza31984ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3403)
{
{ /* Eval/evaluate_types.scm 122 */
return BNIL;} 

}



/* &lambda1983 */
obj_t BGl_z62lambda1983z62zz__evaluate_typesz00(obj_t BgL_envz00_3404, obj_t BgL_oz00_3405, obj_t BgL_vz00_3406)
{
{ /* Eval/evaluate_types.scm 122 */
return 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3405)))->BgL_freez00)=((obj_t)BgL_vz00_3406),BUNSPEC);} 

}



/* &lambda1982 */
obj_t BGl_z62lambda1982z62zz__evaluate_typesz00(obj_t BgL_envz00_3407, obj_t BgL_oz00_3408)
{
{ /* Eval/evaluate_types.scm 122 */
return 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3408)))->BgL_freez00);} 

}



/* &<@anonymous:1977> */
obj_t BGl_z62zc3z04anonymousza31977ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3409)
{
{ /* Eval/evaluate_types.scm 122 */
return BNIL;} 

}



/* &lambda1976 */
obj_t BGl_z62lambda1976z62zz__evaluate_typesz00(obj_t BgL_envz00_3410, obj_t BgL_oz00_3411, obj_t BgL_vz00_3412)
{
{ /* Eval/evaluate_types.scm 122 */
return 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3411)))->BgL_bindz00)=((obj_t)BgL_vz00_3412),BUNSPEC);} 

}



/* &lambda1975 */
obj_t BGl_z62lambda1975z62zz__evaluate_typesz00(obj_t BgL_envz00_3413, obj_t BgL_oz00_3414)
{
{ /* Eval/evaluate_types.scm 122 */
return 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3414)))->BgL_bindz00);} 

}



/* &<@anonymous:1970> */
obj_t BGl_z62zc3z04anonymousza31970ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3415)
{
{ /* Eval/evaluate_types.scm 122 */
return 
BINT(((long)0));} 

}



/* &lambda1969 */
obj_t BGl_z62lambda1969z62zz__evaluate_typesz00(obj_t BgL_envz00_3416, obj_t BgL_oz00_3417, obj_t BgL_vz00_3418)
{
{ /* Eval/evaluate_types.scm 122 */
{ /* Eval/evaluate_types.scm 122 */
int BgL_vz00_3873;
BgL_vz00_3873 = 
CINT(BgL_vz00_3418); 
return 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3417)))->BgL_siza7eza7)=((int)BgL_vz00_3873),BUNSPEC);} } 

}



/* &lambda1968 */
obj_t BGl_z62lambda1968z62zz__evaluate_typesz00(obj_t BgL_envz00_3419, obj_t BgL_oz00_3420)
{
{ /* Eval/evaluate_types.scm 122 */
return 
BINT(
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3420)))->BgL_siza7eza7));} 

}



/* &lambda1963 */
obj_t BGl_z62lambda1963z62zz__evaluate_typesz00(obj_t BgL_envz00_3421, obj_t BgL_oz00_3422, obj_t BgL_vz00_3423)
{
{ /* Eval/evaluate_types.scm 122 */
return 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3422)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3423)),BUNSPEC);} 

}



/* &lambda1962 */
BgL_ev_exprz00_bglt BGl_z62lambda1962z62zz__evaluate_typesz00(obj_t BgL_envz00_3424, obj_t BgL_oz00_3425)
{
{ /* Eval/evaluate_types.scm 122 */
return 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3425)))->BgL_bodyz00);} 

}



/* &lambda1958 */
obj_t BGl_z62lambda1958z62zz__evaluate_typesz00(obj_t BgL_envz00_3426, obj_t BgL_oz00_3427, obj_t BgL_vz00_3428)
{
{ /* Eval/evaluate_types.scm 122 */
return 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3427)))->BgL_varsz00)=((obj_t)BgL_vz00_3428),BUNSPEC);} 

}



/* &lambda1957 */
obj_t BGl_z62lambda1957z62zz__evaluate_typesz00(obj_t BgL_envz00_3429, obj_t BgL_oz00_3430)
{
{ /* Eval/evaluate_types.scm 122 */
return 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3430)))->BgL_varsz00);} 

}



/* &lambda1953 */
obj_t BGl_z62lambda1953z62zz__evaluate_typesz00(obj_t BgL_envz00_3431, obj_t BgL_oz00_3432, obj_t BgL_vz00_3433)
{
{ /* Eval/evaluate_types.scm 122 */
return 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3432)))->BgL_arityz00)=((obj_t)BgL_vz00_3433),BUNSPEC);} 

}



/* &lambda1952 */
obj_t BGl_z62lambda1952z62zz__evaluate_typesz00(obj_t BgL_envz00_3434, obj_t BgL_oz00_3435)
{
{ /* Eval/evaluate_types.scm 122 */
return 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3435)))->BgL_arityz00);} 

}



/* &lambda1948 */
obj_t BGl_z62lambda1948z62zz__evaluate_typesz00(obj_t BgL_envz00_3436, obj_t BgL_oz00_3437, obj_t BgL_vz00_3438)
{
{ /* Eval/evaluate_types.scm 122 */
return 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3437)))->BgL_wherez00)=((obj_t)BgL_vz00_3438),BUNSPEC);} 

}



/* &lambda1947 */
obj_t BGl_z62lambda1947z62zz__evaluate_typesz00(obj_t BgL_envz00_3439, obj_t BgL_oz00_3440)
{
{ /* Eval/evaluate_types.scm 122 */
return 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3440)))->BgL_wherez00);} 

}



/* &lambda1943 */
obj_t BGl_z62lambda1943z62zz__evaluate_typesz00(obj_t BgL_envz00_3441, obj_t BgL_oz00_3442, obj_t BgL_vz00_3443)
{
{ /* Eval/evaluate_types.scm 122 */
return 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3442)))->BgL_locz00)=((obj_t)BgL_vz00_3443),BUNSPEC);} 

}



/* &lambda1942 */
obj_t BGl_z62lambda1942z62zz__evaluate_typesz00(obj_t BgL_envz00_3444, obj_t BgL_oz00_3445)
{
{ /* Eval/evaluate_types.scm 122 */
return 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3445)))->BgL_locz00);} 

}



/* &<@anonymous:1908> */
obj_t BGl_z62zc3z04anonymousza31908ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3446, obj_t BgL_new1177z00_3447)
{
{ /* Eval/evaluate_types.scm 119 */
{ 
BgL_ev_appz00_bglt BgL_auxz00_4655;
((((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_new1177z00_3447)))->BgL_locz00)=((obj_t)BUNSPEC),BUNSPEC); 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_4658;
{ /* Eval/evaluate_types.scm 119 */
obj_t BgL_classz00_3887;
BgL_classz00_3887 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 119 */
obj_t BgL__ortest_1281z00_3888;
BgL__ortest_1281z00_3888 = 
BGL_CLASS_NIL(BgL_classz00_3887); 
if(
CBOOL(BgL__ortest_1281z00_3888))
{ /* Eval/evaluate_types.scm 119 */
BgL_auxz00_4658 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1281z00_3888)
; }  else 
{ /* Eval/evaluate_types.scm 119 */
BgL_auxz00_4658 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_3887))
; } } } 
((((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_new1177z00_3447)))->BgL_funz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_4658),BUNSPEC); } 
((((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_new1177z00_3447)))->BgL_argsz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_new1177z00_3447)))->BgL_tailzf3zf3)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_4655 = 
((BgL_ev_appz00_bglt)BgL_new1177z00_3447); 
return 
((obj_t)BgL_auxz00_4655);} } 

}



/* &lambda1906 */
BgL_ev_appz00_bglt BGl_z62lambda1906z62zz__evaluate_typesz00(obj_t BgL_envz00_3448)
{
{ /* Eval/evaluate_types.scm 119 */
{ /* Eval/evaluate_types.scm 119 */
BgL_ev_appz00_bglt BgL_new1176z00_3889;
BgL_new1176z00_3889 = 
((BgL_ev_appz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_appz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 119 */
long BgL_arg1907z00_3890;
{ /* Eval/evaluate_types.scm 119 */
long BgL_res2321z00_3891;
BgL_res2321z00_3891 = 
BGL_CLASS_INDEX(BGl_ev_appz00zz__evaluate_typesz00); 
BgL_arg1907z00_3890 = BgL_res2321z00_3891; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1176z00_3889), BgL_arg1907z00_3890); } 
return BgL_new1176z00_3889;} } 

}



/* &lambda1904 */
BgL_ev_appz00_bglt BGl_z62lambda1904z62zz__evaluate_typesz00(obj_t BgL_envz00_3449, obj_t BgL_loc1172z00_3450, obj_t BgL_fun1173z00_3451, obj_t BgL_args1174z00_3452, obj_t BgL_tailzf31175zf3_3453)
{
{ /* Eval/evaluate_types.scm 119 */
{ /* Eval/evaluate_types.scm 119 */
BgL_ev_appz00_bglt BgL_new1240z00_3893;
{ /* Eval/evaluate_types.scm 119 */
BgL_ev_appz00_bglt BgL_new1239z00_3894;
BgL_new1239z00_3894 = 
((BgL_ev_appz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_appz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 119 */
long BgL_arg1905z00_3895;
{ /* Eval/evaluate_types.scm 119 */
long BgL_res2320z00_3896;
BgL_res2320z00_3896 = 
BGL_CLASS_INDEX(BGl_ev_appz00zz__evaluate_typesz00); 
BgL_arg1905z00_3895 = BgL_res2320z00_3896; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1239z00_3894), BgL_arg1905z00_3895); } 
BgL_new1240z00_3893 = BgL_new1239z00_3894; } 
((((BgL_ev_appz00_bglt)COBJECT(BgL_new1240z00_3893))->BgL_locz00)=((obj_t)BgL_loc1172z00_3450),BUNSPEC); 
((((BgL_ev_appz00_bglt)COBJECT(BgL_new1240z00_3893))->BgL_funz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_fun1173z00_3451)),BUNSPEC); 
((((BgL_ev_appz00_bglt)COBJECT(BgL_new1240z00_3893))->BgL_argsz00)=((obj_t)BgL_args1174z00_3452),BUNSPEC); 
((((BgL_ev_appz00_bglt)COBJECT(BgL_new1240z00_3893))->BgL_tailzf3zf3)=((obj_t)BgL_tailzf31175zf3_3453),BUNSPEC); 
return BgL_new1240z00_3893;} } 

}



/* &lambda1928 */
obj_t BGl_z62lambda1928z62zz__evaluate_typesz00(obj_t BgL_envz00_3454, obj_t BgL_oz00_3455, obj_t BgL_vz00_3456)
{
{ /* Eval/evaluate_types.scm 119 */
return 
((((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_oz00_3455)))->BgL_tailzf3zf3)=((obj_t)BgL_vz00_3456),BUNSPEC);} 

}



/* &lambda1927 */
obj_t BGl_z62lambda1927z62zz__evaluate_typesz00(obj_t BgL_envz00_3457, obj_t BgL_oz00_3458)
{
{ /* Eval/evaluate_types.scm 119 */
return 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_oz00_3458)))->BgL_tailzf3zf3);} 

}



/* &lambda1923 */
obj_t BGl_z62lambda1923z62zz__evaluate_typesz00(obj_t BgL_envz00_3459, obj_t BgL_oz00_3460, obj_t BgL_vz00_3461)
{
{ /* Eval/evaluate_types.scm 119 */
return 
((((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_oz00_3460)))->BgL_argsz00)=((obj_t)BgL_vz00_3461),BUNSPEC);} 

}



/* &lambda1922 */
obj_t BGl_z62lambda1922z62zz__evaluate_typesz00(obj_t BgL_envz00_3462, obj_t BgL_oz00_3463)
{
{ /* Eval/evaluate_types.scm 119 */
return 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_oz00_3463)))->BgL_argsz00);} 

}



/* &lambda1918 */
obj_t BGl_z62lambda1918z62zz__evaluate_typesz00(obj_t BgL_envz00_3464, obj_t BgL_oz00_3465, obj_t BgL_vz00_3466)
{
{ /* Eval/evaluate_types.scm 119 */
return 
((((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_oz00_3465)))->BgL_funz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3466)),BUNSPEC);} 

}



/* &lambda1917 */
BgL_ev_exprz00_bglt BGl_z62lambda1917z62zz__evaluate_typesz00(obj_t BgL_envz00_3467, obj_t BgL_oz00_3468)
{
{ /* Eval/evaluate_types.scm 119 */
return 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_oz00_3468)))->BgL_funz00);} 

}



/* &lambda1913 */
obj_t BGl_z62lambda1913z62zz__evaluate_typesz00(obj_t BgL_envz00_3469, obj_t BgL_oz00_3470, obj_t BgL_vz00_3471)
{
{ /* Eval/evaluate_types.scm 119 */
return 
((((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_oz00_3470)))->BgL_locz00)=((obj_t)BgL_vz00_3471),BUNSPEC);} 

}



/* &lambda1912 */
obj_t BGl_z62lambda1912z62zz__evaluate_typesz00(obj_t BgL_envz00_3472, obj_t BgL_oz00_3473)
{
{ /* Eval/evaluate_types.scm 119 */
return 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_oz00_3473)))->BgL_locz00);} 

}



/* &<@anonymous:1878> */
obj_t BGl_z62zc3z04anonymousza31878ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3474, obj_t BgL_new1170z00_3475)
{
{ /* Eval/evaluate_types.scm 114 */
{ 
BgL_ev_gotoz00_bglt BgL_auxz00_4703;
((((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_new1170z00_3475)))->BgL_locz00)=((obj_t)BUNSPEC),BUNSPEC); 
{ 
BgL_ev_varz00_bglt BgL_auxz00_4706;
{ /* Eval/evaluate_types.scm 114 */
obj_t BgL_classz00_3907;
BgL_classz00_3907 = BGl_ev_varz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 114 */
obj_t BgL__ortest_1281z00_3908;
BgL__ortest_1281z00_3908 = 
BGL_CLASS_NIL(BgL_classz00_3907); 
if(
CBOOL(BgL__ortest_1281z00_3908))
{ /* Eval/evaluate_types.scm 114 */
BgL_auxz00_4706 = 
((BgL_ev_varz00_bglt)BgL__ortest_1281z00_3908)
; }  else 
{ /* Eval/evaluate_types.scm 114 */
BgL_auxz00_4706 = 
((BgL_ev_varz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_3907))
; } } } 
((((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_new1170z00_3475)))->BgL_labelz00)=((BgL_ev_varz00_bglt)BgL_auxz00_4706),BUNSPEC); } 
{ 
BgL_ev_labelsz00_bglt BgL_auxz00_4715;
{ /* Eval/evaluate_types.scm 114 */
obj_t BgL_classz00_3909;
BgL_classz00_3909 = BGl_ev_labelsz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 114 */
obj_t BgL__ortest_1281z00_3910;
BgL__ortest_1281z00_3910 = 
BGL_CLASS_NIL(BgL_classz00_3909); 
if(
CBOOL(BgL__ortest_1281z00_3910))
{ /* Eval/evaluate_types.scm 114 */
BgL_auxz00_4715 = 
((BgL_ev_labelsz00_bglt)BgL__ortest_1281z00_3910)
; }  else 
{ /* Eval/evaluate_types.scm 114 */
BgL_auxz00_4715 = 
((BgL_ev_labelsz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_3909))
; } } } 
((((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_new1170z00_3475)))->BgL_labelsz00)=((BgL_ev_labelsz00_bglt)BgL_auxz00_4715),BUNSPEC); } 
((((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_new1170z00_3475)))->BgL_argsz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_4703 = 
((BgL_ev_gotoz00_bglt)BgL_new1170z00_3475); 
return 
((obj_t)BgL_auxz00_4703);} } 

}



/* &lambda1876 */
BgL_ev_gotoz00_bglt BGl_z62lambda1876z62zz__evaluate_typesz00(obj_t BgL_envz00_3476)
{
{ /* Eval/evaluate_types.scm 114 */
{ /* Eval/evaluate_types.scm 114 */
BgL_ev_gotoz00_bglt BgL_new1169z00_3911;
BgL_new1169z00_3911 = 
((BgL_ev_gotoz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_gotoz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 114 */
long BgL_arg1877z00_3912;
{ /* Eval/evaluate_types.scm 114 */
long BgL_res2319z00_3913;
BgL_res2319z00_3913 = 
BGL_CLASS_INDEX(BGl_ev_gotoz00zz__evaluate_typesz00); 
BgL_arg1877z00_3912 = BgL_res2319z00_3913; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1169z00_3911), BgL_arg1877z00_3912); } 
return BgL_new1169z00_3911;} } 

}



/* &lambda1874 */
BgL_ev_gotoz00_bglt BGl_z62lambda1874z62zz__evaluate_typesz00(obj_t BgL_envz00_3477, obj_t BgL_loc1165z00_3478, obj_t BgL_label1166z00_3479, obj_t BgL_labels1167z00_3480, obj_t BgL_args1168z00_3481)
{
{ /* Eval/evaluate_types.scm 114 */
{ /* Eval/evaluate_types.scm 114 */
BgL_ev_gotoz00_bglt BgL_new1238z00_3916;
{ /* Eval/evaluate_types.scm 114 */
BgL_ev_gotoz00_bglt BgL_new1237z00_3917;
BgL_new1237z00_3917 = 
((BgL_ev_gotoz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_gotoz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 114 */
long BgL_arg1875z00_3918;
{ /* Eval/evaluate_types.scm 114 */
long BgL_res2318z00_3919;
BgL_res2318z00_3919 = 
BGL_CLASS_INDEX(BGl_ev_gotoz00zz__evaluate_typesz00); 
BgL_arg1875z00_3918 = BgL_res2318z00_3919; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1237z00_3917), BgL_arg1875z00_3918); } 
BgL_new1238z00_3916 = BgL_new1237z00_3917; } 
((((BgL_ev_gotoz00_bglt)COBJECT(BgL_new1238z00_3916))->BgL_locz00)=((obj_t)BgL_loc1165z00_3478),BUNSPEC); 
((((BgL_ev_gotoz00_bglt)COBJECT(BgL_new1238z00_3916))->BgL_labelz00)=((BgL_ev_varz00_bglt)
((BgL_ev_varz00_bglt)BgL_label1166z00_3479)),BUNSPEC); 
((((BgL_ev_gotoz00_bglt)COBJECT(BgL_new1238z00_3916))->BgL_labelsz00)=((BgL_ev_labelsz00_bglt)
((BgL_ev_labelsz00_bglt)BgL_labels1167z00_3480)),BUNSPEC); 
((((BgL_ev_gotoz00_bglt)COBJECT(BgL_new1238z00_3916))->BgL_argsz00)=((obj_t)BgL_args1168z00_3481),BUNSPEC); 
return BgL_new1238z00_3916;} } 

}



/* &lambda1898 */
obj_t BGl_z62lambda1898z62zz__evaluate_typesz00(obj_t BgL_envz00_3482, obj_t BgL_oz00_3483, obj_t BgL_vz00_3484)
{
{ /* Eval/evaluate_types.scm 114 */
return 
((((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_oz00_3483)))->BgL_argsz00)=((obj_t)BgL_vz00_3484),BUNSPEC);} 

}



/* &lambda1897 */
obj_t BGl_z62lambda1897z62zz__evaluate_typesz00(obj_t BgL_envz00_3485, obj_t BgL_oz00_3486)
{
{ /* Eval/evaluate_types.scm 114 */
return 
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_oz00_3486)))->BgL_argsz00);} 

}



/* &lambda1893 */
obj_t BGl_z62lambda1893z62zz__evaluate_typesz00(obj_t BgL_envz00_3487, obj_t BgL_oz00_3488, obj_t BgL_vz00_3489)
{
{ /* Eval/evaluate_types.scm 114 */
return 
((((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_oz00_3488)))->BgL_labelsz00)=((BgL_ev_labelsz00_bglt)
((BgL_ev_labelsz00_bglt)BgL_vz00_3489)),BUNSPEC);} 

}



/* &lambda1892 */
BgL_ev_labelsz00_bglt BGl_z62lambda1892z62zz__evaluate_typesz00(obj_t BgL_envz00_3490, obj_t BgL_oz00_3491)
{
{ /* Eval/evaluate_types.scm 114 */
return 
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_oz00_3491)))->BgL_labelsz00);} 

}



/* &lambda1888 */
obj_t BGl_z62lambda1888z62zz__evaluate_typesz00(obj_t BgL_envz00_3492, obj_t BgL_oz00_3493, obj_t BgL_vz00_3494)
{
{ /* Eval/evaluate_types.scm 114 */
return 
((((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_oz00_3493)))->BgL_labelz00)=((BgL_ev_varz00_bglt)
((BgL_ev_varz00_bglt)BgL_vz00_3494)),BUNSPEC);} 

}



/* &lambda1887 */
BgL_ev_varz00_bglt BGl_z62lambda1887z62zz__evaluate_typesz00(obj_t BgL_envz00_3495, obj_t BgL_oz00_3496)
{
{ /* Eval/evaluate_types.scm 114 */
return 
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_oz00_3496)))->BgL_labelz00);} 

}



/* &lambda1883 */
obj_t BGl_z62lambda1883z62zz__evaluate_typesz00(obj_t BgL_envz00_3497, obj_t BgL_oz00_3498, obj_t BgL_vz00_3499)
{
{ /* Eval/evaluate_types.scm 114 */
return 
((((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_oz00_3498)))->BgL_locz00)=((obj_t)BgL_vz00_3499),BUNSPEC);} 

}



/* &lambda1882 */
obj_t BGl_z62lambda1882z62zz__evaluate_typesz00(obj_t BgL_envz00_3500, obj_t BgL_oz00_3501)
{
{ /* Eval/evaluate_types.scm 114 */
return 
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_oz00_3501)))->BgL_locz00);} 

}



/* &<@anonymous:1832> */
obj_t BGl_z62zc3z04anonymousza31832ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3502, obj_t BgL_new1163z00_3503)
{
{ /* Eval/evaluate_types.scm 106 */
{ 
BgL_ev_labelsz00_bglt BgL_auxz00_4760;
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_new1163z00_3503)))->BgL_varsz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_new1163z00_3503)))->BgL_valsz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_new1163z00_3503)))->BgL_envz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_new1163z00_3503)))->BgL_stkz00)=((obj_t)BUNSPEC),BUNSPEC); 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_4769;
{ /* Eval/evaluate_types.scm 106 */
obj_t BgL_classz00_3931;
BgL_classz00_3931 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 106 */
obj_t BgL__ortest_1281z00_3932;
BgL__ortest_1281z00_3932 = 
BGL_CLASS_NIL(BgL_classz00_3931); 
if(
CBOOL(BgL__ortest_1281z00_3932))
{ /* Eval/evaluate_types.scm 106 */
BgL_auxz00_4769 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1281z00_3932)
; }  else 
{ /* Eval/evaluate_types.scm 106 */
BgL_auxz00_4769 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_3931))
; } } } 
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_new1163z00_3503)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_4769),BUNSPEC); } 
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_new1163z00_3503)))->BgL_boxesz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_4760 = 
((BgL_ev_labelsz00_bglt)BgL_new1163z00_3503); 
return 
((obj_t)BgL_auxz00_4760);} } 

}



/* &lambda1830 */
BgL_ev_labelsz00_bglt BGl_z62lambda1830z62zz__evaluate_typesz00(obj_t BgL_envz00_3504)
{
{ /* Eval/evaluate_types.scm 106 */
{ /* Eval/evaluate_types.scm 106 */
BgL_ev_labelsz00_bglt BgL_new1162z00_3933;
BgL_new1162z00_3933 = 
((BgL_ev_labelsz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_labelsz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 106 */
long BgL_arg1831z00_3934;
{ /* Eval/evaluate_types.scm 106 */
long BgL_res2317z00_3935;
BgL_res2317z00_3935 = 
BGL_CLASS_INDEX(BGl_ev_labelsz00zz__evaluate_typesz00); 
BgL_arg1831z00_3934 = BgL_res2317z00_3935; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1162z00_3933), BgL_arg1831z00_3934); } 
return BgL_new1162z00_3933;} } 

}



/* &lambda1828 */
BgL_ev_labelsz00_bglt BGl_z62lambda1828z62zz__evaluate_typesz00(obj_t BgL_envz00_3505, obj_t BgL_vars1156z00_3506, obj_t BgL_vals1157z00_3507, obj_t BgL_env1158z00_3508, obj_t BgL_stk1159z00_3509, obj_t BgL_body1160z00_3510, obj_t BgL_boxes1161z00_3511)
{
{ /* Eval/evaluate_types.scm 106 */
{ /* Eval/evaluate_types.scm 106 */
BgL_ev_labelsz00_bglt BgL_new1236z00_3937;
{ /* Eval/evaluate_types.scm 106 */
BgL_ev_labelsz00_bglt BgL_new1235z00_3938;
BgL_new1235z00_3938 = 
((BgL_ev_labelsz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_labelsz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 106 */
long BgL_arg1829z00_3939;
{ /* Eval/evaluate_types.scm 106 */
long BgL_res2316z00_3940;
BgL_res2316z00_3940 = 
BGL_CLASS_INDEX(BGl_ev_labelsz00zz__evaluate_typesz00); 
BgL_arg1829z00_3939 = BgL_res2316z00_3940; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1235z00_3938), BgL_arg1829z00_3939); } 
BgL_new1236z00_3937 = BgL_new1235z00_3938; } 
((((BgL_ev_labelsz00_bglt)COBJECT(BgL_new1236z00_3937))->BgL_varsz00)=((obj_t)BgL_vars1156z00_3506),BUNSPEC); 
((((BgL_ev_labelsz00_bglt)COBJECT(BgL_new1236z00_3937))->BgL_valsz00)=((obj_t)BgL_vals1157z00_3507),BUNSPEC); 
((((BgL_ev_labelsz00_bglt)COBJECT(BgL_new1236z00_3937))->BgL_envz00)=((obj_t)BgL_env1158z00_3508),BUNSPEC); 
((((BgL_ev_labelsz00_bglt)COBJECT(BgL_new1236z00_3937))->BgL_stkz00)=((obj_t)BgL_stk1159z00_3509),BUNSPEC); 
((((BgL_ev_labelsz00_bglt)COBJECT(BgL_new1236z00_3937))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_body1160z00_3510)),BUNSPEC); 
((((BgL_ev_labelsz00_bglt)COBJECT(BgL_new1236z00_3937))->BgL_boxesz00)=((obj_t)BgL_boxes1161z00_3511),BUNSPEC); 
return BgL_new1236z00_3937;} } 

}



/* &<@anonymous:1868> */
obj_t BGl_z62zc3z04anonymousza31868ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3512)
{
{ /* Eval/evaluate_types.scm 106 */
return BNIL;} 

}



/* &lambda1867 */
obj_t BGl_z62lambda1867z62zz__evaluate_typesz00(obj_t BgL_envz00_3513, obj_t BgL_oz00_3514, obj_t BgL_vz00_3515)
{
{ /* Eval/evaluate_types.scm 106 */
return 
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_oz00_3514)))->BgL_boxesz00)=((obj_t)BgL_vz00_3515),BUNSPEC);} 

}



/* &lambda1866 */
obj_t BGl_z62lambda1866z62zz__evaluate_typesz00(obj_t BgL_envz00_3516, obj_t BgL_oz00_3517)
{
{ /* Eval/evaluate_types.scm 106 */
return 
(((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_oz00_3517)))->BgL_boxesz00);} 

}



/* &lambda1861 */
obj_t BGl_z62lambda1861z62zz__evaluate_typesz00(obj_t BgL_envz00_3518, obj_t BgL_oz00_3519, obj_t BgL_vz00_3520)
{
{ /* Eval/evaluate_types.scm 106 */
return 
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_oz00_3519)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3520)),BUNSPEC);} 

}



/* &lambda1860 */
BgL_ev_exprz00_bglt BGl_z62lambda1860z62zz__evaluate_typesz00(obj_t BgL_envz00_3521, obj_t BgL_oz00_3522)
{
{ /* Eval/evaluate_types.scm 106 */
return 
(((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_oz00_3522)))->BgL_bodyz00);} 

}



/* &<@anonymous:1856> */
obj_t BGl_z62zc3z04anonymousza31856ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3523)
{
{ /* Eval/evaluate_types.scm 106 */
return BNIL;} 

}



/* &lambda1855 */
obj_t BGl_z62lambda1855z62zz__evaluate_typesz00(obj_t BgL_envz00_3524, obj_t BgL_oz00_3525, obj_t BgL_vz00_3526)
{
{ /* Eval/evaluate_types.scm 106 */
return 
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_oz00_3525)))->BgL_stkz00)=((obj_t)BgL_vz00_3526),BUNSPEC);} 

}



/* &lambda1854 */
obj_t BGl_z62lambda1854z62zz__evaluate_typesz00(obj_t BgL_envz00_3527, obj_t BgL_oz00_3528)
{
{ /* Eval/evaluate_types.scm 106 */
return 
(((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_oz00_3528)))->BgL_stkz00);} 

}



/* &<@anonymous:1849> */
obj_t BGl_z62zc3z04anonymousza31849ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3529)
{
{ /* Eval/evaluate_types.scm 106 */
return BNIL;} 

}



/* &lambda1848 */
obj_t BGl_z62lambda1848z62zz__evaluate_typesz00(obj_t BgL_envz00_3530, obj_t BgL_oz00_3531, obj_t BgL_vz00_3532)
{
{ /* Eval/evaluate_types.scm 106 */
return 
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_oz00_3531)))->BgL_envz00)=((obj_t)BgL_vz00_3532),BUNSPEC);} 

}



/* &lambda1847 */
obj_t BGl_z62lambda1847z62zz__evaluate_typesz00(obj_t BgL_envz00_3533, obj_t BgL_oz00_3534)
{
{ /* Eval/evaluate_types.scm 106 */
return 
(((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_oz00_3534)))->BgL_envz00);} 

}



/* &lambda1842 */
obj_t BGl_z62lambda1842z62zz__evaluate_typesz00(obj_t BgL_envz00_3535, obj_t BgL_oz00_3536, obj_t BgL_vz00_3537)
{
{ /* Eval/evaluate_types.scm 106 */
return 
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_oz00_3536)))->BgL_valsz00)=((obj_t)BgL_vz00_3537),BUNSPEC);} 

}



/* &lambda1841 */
obj_t BGl_z62lambda1841z62zz__evaluate_typesz00(obj_t BgL_envz00_3538, obj_t BgL_oz00_3539)
{
{ /* Eval/evaluate_types.scm 106 */
return 
(((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_oz00_3539)))->BgL_valsz00);} 

}



/* &lambda1837 */
obj_t BGl_z62lambda1837z62zz__evaluate_typesz00(obj_t BgL_envz00_3540, obj_t BgL_oz00_3541, obj_t BgL_vz00_3542)
{
{ /* Eval/evaluate_types.scm 106 */
return 
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_oz00_3541)))->BgL_varsz00)=((obj_t)BgL_vz00_3542),BUNSPEC);} 

}



/* &lambda1836 */
obj_t BGl_z62lambda1836z62zz__evaluate_typesz00(obj_t BgL_envz00_3543, obj_t BgL_oz00_3544)
{
{ /* Eval/evaluate_types.scm 106 */
return 
(((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_oz00_3544)))->BgL_varsz00);} 

}



/* &<@anonymous:1822> */
obj_t BGl_z62zc3z04anonymousza31822ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3545, obj_t BgL_new1154z00_3546)
{
{ /* Eval/evaluate_types.scm 105 */
{ 
BgL_ev_letrecz00_bglt BgL_auxz00_4822;
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letrecz00_bglt)BgL_new1154z00_3546))))->BgL_varsz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letrecz00_bglt)BgL_new1154z00_3546))))->BgL_valsz00)=((obj_t)BUNSPEC),BUNSPEC); 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_4829;
{ /* Eval/evaluate_types.scm 105 */
obj_t BgL_classz00_3955;
BgL_classz00_3955 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 105 */
obj_t BgL__ortest_1281z00_3956;
BgL__ortest_1281z00_3956 = 
BGL_CLASS_NIL(BgL_classz00_3955); 
if(
CBOOL(BgL__ortest_1281z00_3956))
{ /* Eval/evaluate_types.scm 105 */
BgL_auxz00_4829 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1281z00_3956)
; }  else 
{ /* Eval/evaluate_types.scm 105 */
BgL_auxz00_4829 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_3955))
; } } } 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letrecz00_bglt)BgL_new1154z00_3546))))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_4829),BUNSPEC); } 
BgL_auxz00_4822 = 
((BgL_ev_letrecz00_bglt)BgL_new1154z00_3546); 
return 
((obj_t)BgL_auxz00_4822);} } 

}



/* &lambda1820 */
BgL_ev_letrecz00_bglt BGl_z62lambda1820z62zz__evaluate_typesz00(obj_t BgL_envz00_3547)
{
{ /* Eval/evaluate_types.scm 105 */
{ /* Eval/evaluate_types.scm 105 */
BgL_ev_letrecz00_bglt BgL_new1153z00_3957;
BgL_new1153z00_3957 = 
((BgL_ev_letrecz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_letrecz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 105 */
long BgL_arg1821z00_3958;
{ /* Eval/evaluate_types.scm 105 */
long BgL_res2315z00_3959;
BgL_res2315z00_3959 = 
BGL_CLASS_INDEX(BGl_ev_letrecz00zz__evaluate_typesz00); 
BgL_arg1821z00_3958 = BgL_res2315z00_3959; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1153z00_3957), BgL_arg1821z00_3958); } 
return BgL_new1153z00_3957;} } 

}



/* &lambda1818 */
BgL_ev_letrecz00_bglt BGl_z62lambda1818z62zz__evaluate_typesz00(obj_t BgL_envz00_3548, obj_t BgL_vars1150z00_3549, obj_t BgL_vals1151z00_3550, obj_t BgL_body1152z00_3551)
{
{ /* Eval/evaluate_types.scm 105 */
{ /* Eval/evaluate_types.scm 105 */
BgL_ev_letrecz00_bglt BgL_new1234z00_3961;
{ /* Eval/evaluate_types.scm 105 */
BgL_ev_letrecz00_bglt BgL_new1233z00_3962;
BgL_new1233z00_3962 = 
((BgL_ev_letrecz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_letrecz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 105 */
long BgL_arg1819z00_3963;
{ /* Eval/evaluate_types.scm 105 */
long BgL_res2314z00_3964;
BgL_res2314z00_3964 = 
BGL_CLASS_INDEX(BGl_ev_letrecz00zz__evaluate_typesz00); 
BgL_arg1819z00_3963 = BgL_res2314z00_3964; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1233z00_3962), BgL_arg1819z00_3963); } 
BgL_new1234z00_3961 = BgL_new1233z00_3962; } 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1234z00_3961)))->BgL_varsz00)=((obj_t)BgL_vars1150z00_3549),BUNSPEC); 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1234z00_3961)))->BgL_valsz00)=((obj_t)BgL_vals1151z00_3550),BUNSPEC); 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1234z00_3961)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_body1152z00_3551)),BUNSPEC); 
return BgL_new1234z00_3961;} } 

}



/* &<@anonymous:1805> */
obj_t BGl_z62zc3z04anonymousza31805ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3552, obj_t BgL_new1148z00_3553)
{
{ /* Eval/evaluate_types.scm 103 */
{ 
BgL_ev_letza2za2_bglt BgL_auxz00_4856;
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letza2za2_bglt)BgL_new1148z00_3553))))->BgL_varsz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letza2za2_bglt)BgL_new1148z00_3553))))->BgL_valsz00)=((obj_t)BUNSPEC),BUNSPEC); 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_4863;
{ /* Eval/evaluate_types.scm 103 */
obj_t BgL_classz00_3966;
BgL_classz00_3966 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 103 */
obj_t BgL__ortest_1281z00_3967;
BgL__ortest_1281z00_3967 = 
BGL_CLASS_NIL(BgL_classz00_3966); 
if(
CBOOL(BgL__ortest_1281z00_3967))
{ /* Eval/evaluate_types.scm 103 */
BgL_auxz00_4863 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1281z00_3967)
; }  else 
{ /* Eval/evaluate_types.scm 103 */
BgL_auxz00_4863 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_3966))
; } } } 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letza2za2_bglt)BgL_new1148z00_3553))))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_4863),BUNSPEC); } 
((((BgL_ev_letza2za2_bglt)COBJECT(
((BgL_ev_letza2za2_bglt)BgL_new1148z00_3553)))->BgL_boxesz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_4856 = 
((BgL_ev_letza2za2_bglt)BgL_new1148z00_3553); 
return 
((obj_t)BgL_auxz00_4856);} } 

}



/* &lambda1803 */
BgL_ev_letza2za2_bglt BGl_z62lambda1803z62zz__evaluate_typesz00(obj_t BgL_envz00_3554)
{
{ /* Eval/evaluate_types.scm 103 */
{ /* Eval/evaluate_types.scm 103 */
BgL_ev_letza2za2_bglt BgL_new1147z00_3968;
BgL_new1147z00_3968 = 
((BgL_ev_letza2za2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_letza2za2_bgl) ))); 
{ /* Eval/evaluate_types.scm 103 */
long BgL_arg1804z00_3969;
{ /* Eval/evaluate_types.scm 103 */
long BgL_res2313z00_3970;
BgL_res2313z00_3970 = 
BGL_CLASS_INDEX(BGl_ev_letza2za2zz__evaluate_typesz00); 
BgL_arg1804z00_3969 = BgL_res2313z00_3970; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1147z00_3968), BgL_arg1804z00_3969); } 
return BgL_new1147z00_3968;} } 

}



/* &lambda1801 */
BgL_ev_letza2za2_bglt BGl_z62lambda1801z62zz__evaluate_typesz00(obj_t BgL_envz00_3555, obj_t BgL_vars1143z00_3556, obj_t BgL_vals1144z00_3557, obj_t BgL_body1145z00_3558, obj_t BgL_boxes1146z00_3559)
{
{ /* Eval/evaluate_types.scm 103 */
{ /* Eval/evaluate_types.scm 103 */
BgL_ev_letza2za2_bglt BgL_new1232z00_3972;
{ /* Eval/evaluate_types.scm 103 */
BgL_ev_letza2za2_bglt BgL_new1231z00_3973;
BgL_new1231z00_3973 = 
((BgL_ev_letza2za2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_letza2za2_bgl) ))); 
{ /* Eval/evaluate_types.scm 103 */
long BgL_arg1802z00_3974;
{ /* Eval/evaluate_types.scm 103 */
long BgL_res2312z00_3975;
BgL_res2312z00_3975 = 
BGL_CLASS_INDEX(BGl_ev_letza2za2zz__evaluate_typesz00); 
BgL_arg1802z00_3974 = BgL_res2312z00_3975; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1231z00_3973), BgL_arg1802z00_3974); } 
BgL_new1232z00_3972 = BgL_new1231z00_3973; } 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1232z00_3972)))->BgL_varsz00)=((obj_t)BgL_vars1143z00_3556),BUNSPEC); 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1232z00_3972)))->BgL_valsz00)=((obj_t)BgL_vals1144z00_3557),BUNSPEC); 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1232z00_3972)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_body1145z00_3558)),BUNSPEC); 
((((BgL_ev_letza2za2_bglt)COBJECT(BgL_new1232z00_3972))->BgL_boxesz00)=((obj_t)BgL_boxes1146z00_3559),BUNSPEC); 
return BgL_new1232z00_3972;} } 

}



/* &<@anonymous:1812> */
obj_t BGl_z62zc3z04anonymousza31812ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3560)
{
{ /* Eval/evaluate_types.scm 103 */
return BNIL;} 

}



/* &lambda1811 */
obj_t BGl_z62lambda1811z62zz__evaluate_typesz00(obj_t BgL_envz00_3561, obj_t BgL_oz00_3562, obj_t BgL_vz00_3563)
{
{ /* Eval/evaluate_types.scm 103 */
return 
((((BgL_ev_letza2za2_bglt)COBJECT(
((BgL_ev_letza2za2_bglt)BgL_oz00_3562)))->BgL_boxesz00)=((obj_t)BgL_vz00_3563),BUNSPEC);} 

}



/* &lambda1810 */
obj_t BGl_z62lambda1810z62zz__evaluate_typesz00(obj_t BgL_envz00_3564, obj_t BgL_oz00_3565)
{
{ /* Eval/evaluate_types.scm 103 */
return 
(((BgL_ev_letza2za2_bglt)COBJECT(
((BgL_ev_letza2za2_bglt)BgL_oz00_3565)))->BgL_boxesz00);} 

}



/* &<@anonymous:1788> */
obj_t BGl_z62zc3z04anonymousza31788ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3566, obj_t BgL_new1141z00_3567)
{
{ /* Eval/evaluate_types.scm 101 */
{ 
BgL_ev_letz00_bglt BgL_auxz00_4897;
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letz00_bglt)BgL_new1141z00_3567))))->BgL_varsz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letz00_bglt)BgL_new1141z00_3567))))->BgL_valsz00)=((obj_t)BUNSPEC),BUNSPEC); 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_4904;
{ /* Eval/evaluate_types.scm 101 */
obj_t BgL_classz00_3979;
BgL_classz00_3979 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 101 */
obj_t BgL__ortest_1281z00_3980;
BgL__ortest_1281z00_3980 = 
BGL_CLASS_NIL(BgL_classz00_3979); 
if(
CBOOL(BgL__ortest_1281z00_3980))
{ /* Eval/evaluate_types.scm 101 */
BgL_auxz00_4904 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1281z00_3980)
; }  else 
{ /* Eval/evaluate_types.scm 101 */
BgL_auxz00_4904 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_3979))
; } } } 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letz00_bglt)BgL_new1141z00_3567))))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_4904),BUNSPEC); } 
((((BgL_ev_letz00_bglt)COBJECT(
((BgL_ev_letz00_bglt)BgL_new1141z00_3567)))->BgL_boxesz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_4897 = 
((BgL_ev_letz00_bglt)BgL_new1141z00_3567); 
return 
((obj_t)BgL_auxz00_4897);} } 

}



/* &lambda1786 */
BgL_ev_letz00_bglt BGl_z62lambda1786z62zz__evaluate_typesz00(obj_t BgL_envz00_3568)
{
{ /* Eval/evaluate_types.scm 101 */
{ /* Eval/evaluate_types.scm 101 */
BgL_ev_letz00_bglt BgL_new1140z00_3981;
BgL_new1140z00_3981 = 
((BgL_ev_letz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_letz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 101 */
long BgL_arg1787z00_3982;
{ /* Eval/evaluate_types.scm 101 */
long BgL_res2311z00_3983;
BgL_res2311z00_3983 = 
BGL_CLASS_INDEX(BGl_ev_letz00zz__evaluate_typesz00); 
BgL_arg1787z00_3982 = BgL_res2311z00_3983; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1140z00_3981), BgL_arg1787z00_3982); } 
return BgL_new1140z00_3981;} } 

}



/* &lambda1784 */
BgL_ev_letz00_bglt BGl_z62lambda1784z62zz__evaluate_typesz00(obj_t BgL_envz00_3569, obj_t BgL_vars1136z00_3570, obj_t BgL_vals1137z00_3571, obj_t BgL_body1138z00_3572, obj_t BgL_boxes1139z00_3573)
{
{ /* Eval/evaluate_types.scm 101 */
{ /* Eval/evaluate_types.scm 101 */
BgL_ev_letz00_bglt BgL_new1230z00_3985;
{ /* Eval/evaluate_types.scm 101 */
BgL_ev_letz00_bglt BgL_new1229z00_3986;
BgL_new1229z00_3986 = 
((BgL_ev_letz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_letz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 101 */
long BgL_arg1785z00_3987;
{ /* Eval/evaluate_types.scm 101 */
long BgL_res2310z00_3988;
BgL_res2310z00_3988 = 
BGL_CLASS_INDEX(BGl_ev_letz00zz__evaluate_typesz00); 
BgL_arg1785z00_3987 = BgL_res2310z00_3988; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1229z00_3986), BgL_arg1785z00_3987); } 
BgL_new1230z00_3985 = BgL_new1229z00_3986; } 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1230z00_3985)))->BgL_varsz00)=((obj_t)BgL_vars1136z00_3570),BUNSPEC); 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1230z00_3985)))->BgL_valsz00)=((obj_t)BgL_vals1137z00_3571),BUNSPEC); 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1230z00_3985)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_body1138z00_3572)),BUNSPEC); 
((((BgL_ev_letz00_bglt)COBJECT(BgL_new1230z00_3985))->BgL_boxesz00)=((obj_t)BgL_boxes1139z00_3573),BUNSPEC); 
return BgL_new1230z00_3985;} } 

}



/* &<@anonymous:1795> */
obj_t BGl_z62zc3z04anonymousza31795ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3574)
{
{ /* Eval/evaluate_types.scm 101 */
return BNIL;} 

}



/* &lambda1794 */
obj_t BGl_z62lambda1794z62zz__evaluate_typesz00(obj_t BgL_envz00_3575, obj_t BgL_oz00_3576, obj_t BgL_vz00_3577)
{
{ /* Eval/evaluate_types.scm 101 */
return 
((((BgL_ev_letz00_bglt)COBJECT(
((BgL_ev_letz00_bglt)BgL_oz00_3576)))->BgL_boxesz00)=((obj_t)BgL_vz00_3577),BUNSPEC);} 

}



/* &lambda1793 */
obj_t BGl_z62lambda1793z62zz__evaluate_typesz00(obj_t BgL_envz00_3578, obj_t BgL_oz00_3579)
{
{ /* Eval/evaluate_types.scm 101 */
return 
(((BgL_ev_letz00_bglt)COBJECT(
((BgL_ev_letz00_bglt)BgL_oz00_3579)))->BgL_boxesz00);} 

}



/* &<@anonymous:1763> */
obj_t BGl_z62zc3z04anonymousza31763ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3580, obj_t BgL_new1134z00_3581)
{
{ /* Eval/evaluate_types.scm 97 */
{ 
BgL_ev_binderz00_bglt BgL_auxz00_4938;
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1134z00_3581)))->BgL_varsz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1134z00_3581)))->BgL_valsz00)=((obj_t)BUNSPEC),BUNSPEC); 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_4943;
{ /* Eval/evaluate_types.scm 97 */
obj_t BgL_classz00_3992;
BgL_classz00_3992 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 97 */
obj_t BgL__ortest_1281z00_3993;
BgL__ortest_1281z00_3993 = 
BGL_CLASS_NIL(BgL_classz00_3992); 
if(
CBOOL(BgL__ortest_1281z00_3993))
{ /* Eval/evaluate_types.scm 97 */
BgL_auxz00_4943 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1281z00_3993)
; }  else 
{ /* Eval/evaluate_types.scm 97 */
BgL_auxz00_4943 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_3992))
; } } } 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1134z00_3581)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_4943),BUNSPEC); } 
BgL_auxz00_4938 = 
((BgL_ev_binderz00_bglt)BgL_new1134z00_3581); 
return 
((obj_t)BgL_auxz00_4938);} } 

}



/* &lambda1761 */
BgL_ev_binderz00_bglt BGl_z62lambda1761z62zz__evaluate_typesz00(obj_t BgL_envz00_3582)
{
{ /* Eval/evaluate_types.scm 97 */
{ /* Eval/evaluate_types.scm 97 */
BgL_ev_binderz00_bglt BgL_new1133z00_3994;
BgL_new1133z00_3994 = 
((BgL_ev_binderz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_binderz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 97 */
long BgL_arg1762z00_3995;
{ /* Eval/evaluate_types.scm 97 */
long BgL_res2309z00_3996;
BgL_res2309z00_3996 = 
BGL_CLASS_INDEX(BGl_ev_binderz00zz__evaluate_typesz00); 
BgL_arg1762z00_3995 = BgL_res2309z00_3996; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1133z00_3994), BgL_arg1762z00_3995); } 
return BgL_new1133z00_3994;} } 

}



/* &lambda1759 */
BgL_ev_binderz00_bglt BGl_z62lambda1759z62zz__evaluate_typesz00(obj_t BgL_envz00_3583, obj_t BgL_vars1130z00_3584, obj_t BgL_vals1131z00_3585, obj_t BgL_body1132z00_3586)
{
{ /* Eval/evaluate_types.scm 97 */
{ /* Eval/evaluate_types.scm 97 */
BgL_ev_binderz00_bglt BgL_new1228z00_3998;
{ /* Eval/evaluate_types.scm 97 */
BgL_ev_binderz00_bglt BgL_new1227z00_3999;
BgL_new1227z00_3999 = 
((BgL_ev_binderz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_binderz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 97 */
long BgL_arg1760z00_4000;
{ /* Eval/evaluate_types.scm 97 */
long BgL_res2308z00_4001;
BgL_res2308z00_4001 = 
BGL_CLASS_INDEX(BGl_ev_binderz00zz__evaluate_typesz00); 
BgL_arg1760z00_4000 = BgL_res2308z00_4001; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1227z00_3999), BgL_arg1760z00_4000); } 
BgL_new1228z00_3998 = BgL_new1227z00_3999; } 
((((BgL_ev_binderz00_bglt)COBJECT(BgL_new1228z00_3998))->BgL_varsz00)=((obj_t)BgL_vars1130z00_3584),BUNSPEC); 
((((BgL_ev_binderz00_bglt)COBJECT(BgL_new1228z00_3998))->BgL_valsz00)=((obj_t)BgL_vals1131z00_3585),BUNSPEC); 
((((BgL_ev_binderz00_bglt)COBJECT(BgL_new1228z00_3998))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_body1132z00_3586)),BUNSPEC); 
return BgL_new1228z00_3998;} } 

}



/* &lambda1778 */
obj_t BGl_z62lambda1778z62zz__evaluate_typesz00(obj_t BgL_envz00_3587, obj_t BgL_oz00_3588, obj_t BgL_vz00_3589)
{
{ /* Eval/evaluate_types.scm 97 */
return 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_oz00_3588)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3589)),BUNSPEC);} 

}



/* &lambda1777 */
BgL_ev_exprz00_bglt BGl_z62lambda1777z62zz__evaluate_typesz00(obj_t BgL_envz00_3590, obj_t BgL_oz00_3591)
{
{ /* Eval/evaluate_types.scm 97 */
return 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_oz00_3591)))->BgL_bodyz00);} 

}



/* &lambda1773 */
obj_t BGl_z62lambda1773z62zz__evaluate_typesz00(obj_t BgL_envz00_3592, obj_t BgL_oz00_3593, obj_t BgL_vz00_3594)
{
{ /* Eval/evaluate_types.scm 97 */
return 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_oz00_3593)))->BgL_valsz00)=((obj_t)BgL_vz00_3594),BUNSPEC);} 

}



/* &lambda1772 */
obj_t BGl_z62lambda1772z62zz__evaluate_typesz00(obj_t BgL_envz00_3595, obj_t BgL_oz00_3596)
{
{ /* Eval/evaluate_types.scm 97 */
return 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_oz00_3596)))->BgL_valsz00);} 

}



/* &lambda1768 */
obj_t BGl_z62lambda1768z62zz__evaluate_typesz00(obj_t BgL_envz00_3597, obj_t BgL_oz00_3598, obj_t BgL_vz00_3599)
{
{ /* Eval/evaluate_types.scm 97 */
return 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_oz00_3598)))->BgL_varsz00)=((obj_t)BgL_vz00_3599),BUNSPEC);} 

}



/* &lambda1767 */
obj_t BGl_z62lambda1767z62zz__evaluate_typesz00(obj_t BgL_envz00_3600, obj_t BgL_oz00_3601)
{
{ /* Eval/evaluate_types.scm 97 */
return 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_oz00_3601)))->BgL_varsz00);} 

}



/* &<@anonymous:1733> */
obj_t BGl_z62zc3z04anonymousza31733ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3602, obj_t BgL_new1128z00_3603)
{
{ /* Eval/evaluate_types.scm 92 */
{ 
BgL_ev_synchroniza7eza7_bglt BgL_auxz00_4979;
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_new1128z00_3603)))->BgL_locz00)=((obj_t)BUNSPEC),BUNSPEC); 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_4982;
{ /* Eval/evaluate_types.scm 92 */
obj_t BgL_classz00_4010;
BgL_classz00_4010 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 92 */
obj_t BgL__ortest_1281z00_4011;
BgL__ortest_1281z00_4011 = 
BGL_CLASS_NIL(BgL_classz00_4010); 
if(
CBOOL(BgL__ortest_1281z00_4011))
{ /* Eval/evaluate_types.scm 92 */
BgL_auxz00_4982 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1281z00_4011)
; }  else 
{ /* Eval/evaluate_types.scm 92 */
BgL_auxz00_4982 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4010))
; } } } 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_new1128z00_3603)))->BgL_mutexz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_4982),BUNSPEC); } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_4991;
{ /* Eval/evaluate_types.scm 92 */
obj_t BgL_classz00_4012;
BgL_classz00_4012 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 92 */
obj_t BgL__ortest_1281z00_4013;
BgL__ortest_1281z00_4013 = 
BGL_CLASS_NIL(BgL_classz00_4012); 
if(
CBOOL(BgL__ortest_1281z00_4013))
{ /* Eval/evaluate_types.scm 92 */
BgL_auxz00_4991 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1281z00_4013)
; }  else 
{ /* Eval/evaluate_types.scm 92 */
BgL_auxz00_4991 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4012))
; } } } 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_new1128z00_3603)))->BgL_prelockz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_4991),BUNSPEC); } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5000;
{ /* Eval/evaluate_types.scm 92 */
obj_t BgL_classz00_4014;
BgL_classz00_4014 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 92 */
obj_t BgL__ortest_1281z00_4015;
BgL__ortest_1281z00_4015 = 
BGL_CLASS_NIL(BgL_classz00_4014); 
if(
CBOOL(BgL__ortest_1281z00_4015))
{ /* Eval/evaluate_types.scm 92 */
BgL_auxz00_5000 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1281z00_4015)
; }  else 
{ /* Eval/evaluate_types.scm 92 */
BgL_auxz00_5000 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4014))
; } } } 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_new1128z00_3603)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5000),BUNSPEC); } 
BgL_auxz00_4979 = 
((BgL_ev_synchroniza7eza7_bglt)BgL_new1128z00_3603); 
return 
((obj_t)BgL_auxz00_4979);} } 

}



/* &lambda1731 */
BgL_ev_synchroniza7eza7_bglt BGl_z62lambda1731z62zz__evaluate_typesz00(obj_t BgL_envz00_3604)
{
{ /* Eval/evaluate_types.scm 92 */
{ /* Eval/evaluate_types.scm 92 */
BgL_ev_synchroniza7eza7_bglt BgL_new1127z00_4016;
BgL_new1127z00_4016 = 
((BgL_ev_synchroniza7eza7_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_synchroniza7eza7_bgl) ))); 
{ /* Eval/evaluate_types.scm 92 */
long BgL_arg1732z00_4017;
{ /* Eval/evaluate_types.scm 92 */
long BgL_res2307z00_4018;
BgL_res2307z00_4018 = 
BGL_CLASS_INDEX(BGl_ev_synchroniza7eza7zz__evaluate_typesz00); 
BgL_arg1732z00_4017 = BgL_res2307z00_4018; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1127z00_4016), BgL_arg1732z00_4017); } 
return BgL_new1127z00_4016;} } 

}



/* &lambda1729 */
BgL_ev_synchroniza7eza7_bglt BGl_z62lambda1729z62zz__evaluate_typesz00(obj_t BgL_envz00_3605, obj_t BgL_loc1123z00_3606, obj_t BgL_mutex1124z00_3607, obj_t BgL_prelock1125z00_3608, obj_t BgL_body1126z00_3609)
{
{ /* Eval/evaluate_types.scm 92 */
{ /* Eval/evaluate_types.scm 92 */
BgL_ev_synchroniza7eza7_bglt BgL_new1226z00_4022;
{ /* Eval/evaluate_types.scm 92 */
BgL_ev_synchroniza7eza7_bglt BgL_new1225z00_4023;
BgL_new1225z00_4023 = 
((BgL_ev_synchroniza7eza7_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_synchroniza7eza7_bgl) ))); 
{ /* Eval/evaluate_types.scm 92 */
long BgL_arg1730z00_4024;
{ /* Eval/evaluate_types.scm 92 */
long BgL_res2306z00_4025;
BgL_res2306z00_4025 = 
BGL_CLASS_INDEX(BGl_ev_synchroniza7eza7zz__evaluate_typesz00); 
BgL_arg1730z00_4024 = BgL_res2306z00_4025; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1225z00_4023), BgL_arg1730z00_4024); } 
BgL_new1226z00_4022 = BgL_new1225z00_4023; } 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(BgL_new1226z00_4022))->BgL_locz00)=((obj_t)BgL_loc1123z00_3606),BUNSPEC); 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(BgL_new1226z00_4022))->BgL_mutexz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_mutex1124z00_3607)),BUNSPEC); 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(BgL_new1226z00_4022))->BgL_prelockz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_prelock1125z00_3608)),BUNSPEC); 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(BgL_new1226z00_4022))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_body1126z00_3609)),BUNSPEC); 
return BgL_new1226z00_4022;} } 

}



/* &lambda1753 */
obj_t BGl_z62lambda1753z62zz__evaluate_typesz00(obj_t BgL_envz00_3610, obj_t BgL_oz00_3611, obj_t BgL_vz00_3612)
{
{ /* Eval/evaluate_types.scm 92 */
return 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_oz00_3611)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3612)),BUNSPEC);} 

}



/* &lambda1752 */
BgL_ev_exprz00_bglt BGl_z62lambda1752z62zz__evaluate_typesz00(obj_t BgL_envz00_3613, obj_t BgL_oz00_3614)
{
{ /* Eval/evaluate_types.scm 92 */
return 
(((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_oz00_3614)))->BgL_bodyz00);} 

}



/* &lambda1748 */
obj_t BGl_z62lambda1748z62zz__evaluate_typesz00(obj_t BgL_envz00_3615, obj_t BgL_oz00_3616, obj_t BgL_vz00_3617)
{
{ /* Eval/evaluate_types.scm 92 */
return 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_oz00_3616)))->BgL_prelockz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3617)),BUNSPEC);} 

}



/* &lambda1747 */
BgL_ev_exprz00_bglt BGl_z62lambda1747z62zz__evaluate_typesz00(obj_t BgL_envz00_3618, obj_t BgL_oz00_3619)
{
{ /* Eval/evaluate_types.scm 92 */
return 
(((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_oz00_3619)))->BgL_prelockz00);} 

}



/* &lambda1743 */
obj_t BGl_z62lambda1743z62zz__evaluate_typesz00(obj_t BgL_envz00_3620, obj_t BgL_oz00_3621, obj_t BgL_vz00_3622)
{
{ /* Eval/evaluate_types.scm 92 */
return 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_oz00_3621)))->BgL_mutexz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3622)),BUNSPEC);} 

}



/* &lambda1742 */
BgL_ev_exprz00_bglt BGl_z62lambda1742z62zz__evaluate_typesz00(obj_t BgL_envz00_3623, obj_t BgL_oz00_3624)
{
{ /* Eval/evaluate_types.scm 92 */
return 
(((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_oz00_3624)))->BgL_mutexz00);} 

}



/* &lambda1738 */
obj_t BGl_z62lambda1738z62zz__evaluate_typesz00(obj_t BgL_envz00_3625, obj_t BgL_oz00_3626, obj_t BgL_vz00_3627)
{
{ /* Eval/evaluate_types.scm 92 */
return 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_oz00_3626)))->BgL_locz00)=((obj_t)BgL_vz00_3627),BUNSPEC);} 

}



/* &lambda1737 */
obj_t BGl_z62lambda1737z62zz__evaluate_typesz00(obj_t BgL_envz00_3628, obj_t BgL_oz00_3629)
{
{ /* Eval/evaluate_types.scm 92 */
return 
(((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_oz00_3629)))->BgL_locz00);} 

}



/* &<@anonymous:1712> */
obj_t BGl_z62zc3z04anonymousza31712ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3630, obj_t BgL_new1121z00_3631)
{
{ /* Eval/evaluate_types.scm 89 */
{ 
BgL_ev_withzd2handlerzd2_bglt BgL_auxz00_5045;
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5046;
{ /* Eval/evaluate_types.scm 89 */
obj_t BgL_classz00_4038;
BgL_classz00_4038 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 89 */
obj_t BgL__ortest_1281z00_4039;
BgL__ortest_1281z00_4039 = 
BGL_CLASS_NIL(BgL_classz00_4038); 
if(
CBOOL(BgL__ortest_1281z00_4039))
{ /* Eval/evaluate_types.scm 89 */
BgL_auxz00_5046 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1281z00_4039)
; }  else 
{ /* Eval/evaluate_types.scm 89 */
BgL_auxz00_5046 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4038))
; } } } 
((((BgL_ev_withzd2handlerzd2_bglt)COBJECT(
((BgL_ev_withzd2handlerzd2_bglt)BgL_new1121z00_3631)))->BgL_handlerz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5046),BUNSPEC); } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5055;
{ /* Eval/evaluate_types.scm 89 */
obj_t BgL_classz00_4040;
BgL_classz00_4040 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 89 */
obj_t BgL__ortest_1281z00_4041;
BgL__ortest_1281z00_4041 = 
BGL_CLASS_NIL(BgL_classz00_4040); 
if(
CBOOL(BgL__ortest_1281z00_4041))
{ /* Eval/evaluate_types.scm 89 */
BgL_auxz00_5055 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1281z00_4041)
; }  else 
{ /* Eval/evaluate_types.scm 89 */
BgL_auxz00_5055 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4040))
; } } } 
((((BgL_ev_withzd2handlerzd2_bglt)COBJECT(
((BgL_ev_withzd2handlerzd2_bglt)BgL_new1121z00_3631)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5055),BUNSPEC); } 
BgL_auxz00_5045 = 
((BgL_ev_withzd2handlerzd2_bglt)BgL_new1121z00_3631); 
return 
((obj_t)BgL_auxz00_5045);} } 

}



/* &lambda1710 */
BgL_ev_withzd2handlerzd2_bglt BGl_z62lambda1710z62zz__evaluate_typesz00(obj_t BgL_envz00_3632)
{
{ /* Eval/evaluate_types.scm 89 */
{ /* Eval/evaluate_types.scm 89 */
BgL_ev_withzd2handlerzd2_bglt BgL_new1120z00_4042;
BgL_new1120z00_4042 = 
((BgL_ev_withzd2handlerzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_withzd2handlerzd2_bgl) ))); 
{ /* Eval/evaluate_types.scm 89 */
long BgL_arg1711z00_4043;
{ /* Eval/evaluate_types.scm 89 */
long BgL_res2305z00_4044;
BgL_res2305z00_4044 = 
BGL_CLASS_INDEX(BGl_ev_withzd2handlerzd2zz__evaluate_typesz00); 
BgL_arg1711z00_4043 = BgL_res2305z00_4044; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1120z00_4042), BgL_arg1711z00_4043); } 
return BgL_new1120z00_4042;} } 

}



/* &lambda1708 */
BgL_ev_withzd2handlerzd2_bglt BGl_z62lambda1708z62zz__evaluate_typesz00(obj_t BgL_envz00_3633, obj_t BgL_handler1118z00_3634, obj_t BgL_body1119z00_3635)
{
{ /* Eval/evaluate_types.scm 89 */
{ /* Eval/evaluate_types.scm 89 */
BgL_ev_withzd2handlerzd2_bglt BgL_new1224z00_4047;
{ /* Eval/evaluate_types.scm 89 */
BgL_ev_withzd2handlerzd2_bglt BgL_new1223z00_4048;
BgL_new1223z00_4048 = 
((BgL_ev_withzd2handlerzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_withzd2handlerzd2_bgl) ))); 
{ /* Eval/evaluate_types.scm 89 */
long BgL_arg1709z00_4049;
{ /* Eval/evaluate_types.scm 89 */
long BgL_res2304z00_4050;
BgL_res2304z00_4050 = 
BGL_CLASS_INDEX(BGl_ev_withzd2handlerzd2zz__evaluate_typesz00); 
BgL_arg1709z00_4049 = BgL_res2304z00_4050; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1223z00_4048), BgL_arg1709z00_4049); } 
BgL_new1224z00_4047 = BgL_new1223z00_4048; } 
((((BgL_ev_withzd2handlerzd2_bglt)COBJECT(BgL_new1224z00_4047))->BgL_handlerz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_handler1118z00_3634)),BUNSPEC); 
((((BgL_ev_withzd2handlerzd2_bglt)COBJECT(BgL_new1224z00_4047))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_body1119z00_3635)),BUNSPEC); 
return BgL_new1224z00_4047;} } 

}



/* &lambda1723 */
obj_t BGl_z62lambda1723z62zz__evaluate_typesz00(obj_t BgL_envz00_3636, obj_t BgL_oz00_3637, obj_t BgL_vz00_3638)
{
{ /* Eval/evaluate_types.scm 89 */
return 
((((BgL_ev_withzd2handlerzd2_bglt)COBJECT(
((BgL_ev_withzd2handlerzd2_bglt)BgL_oz00_3637)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3638)),BUNSPEC);} 

}



/* &lambda1722 */
BgL_ev_exprz00_bglt BGl_z62lambda1722z62zz__evaluate_typesz00(obj_t BgL_envz00_3639, obj_t BgL_oz00_3640)
{
{ /* Eval/evaluate_types.scm 89 */
return 
(((BgL_ev_withzd2handlerzd2_bglt)COBJECT(
((BgL_ev_withzd2handlerzd2_bglt)BgL_oz00_3640)))->BgL_bodyz00);} 

}



/* &lambda1718 */
obj_t BGl_z62lambda1718z62zz__evaluate_typesz00(obj_t BgL_envz00_3641, obj_t BgL_oz00_3642, obj_t BgL_vz00_3643)
{
{ /* Eval/evaluate_types.scm 89 */
return 
((((BgL_ev_withzd2handlerzd2_bglt)COBJECT(
((BgL_ev_withzd2handlerzd2_bglt)BgL_oz00_3642)))->BgL_handlerz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3643)),BUNSPEC);} 

}



/* &lambda1717 */
BgL_ev_exprz00_bglt BGl_z62lambda1717z62zz__evaluate_typesz00(obj_t BgL_envz00_3644, obj_t BgL_oz00_3645)
{
{ /* Eval/evaluate_types.scm 89 */
return 
(((BgL_ev_withzd2handlerzd2_bglt)COBJECT(
((BgL_ev_withzd2handlerzd2_bglt)BgL_oz00_3645)))->BgL_handlerz00);} 

}



/* &<@anonymous:1692> */
obj_t BGl_z62zc3z04anonymousza31692ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3646, obj_t BgL_new1116z00_3647)
{
{ /* Eval/evaluate_types.scm 86 */
{ 
BgL_ev_unwindzd2protectzd2_bglt BgL_auxz00_5088;
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5089;
{ /* Eval/evaluate_types.scm 86 */
obj_t BgL_classz00_4058;
BgL_classz00_4058 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 86 */
obj_t BgL__ortest_1281z00_4059;
BgL__ortest_1281z00_4059 = 
BGL_CLASS_NIL(BgL_classz00_4058); 
if(
CBOOL(BgL__ortest_1281z00_4059))
{ /* Eval/evaluate_types.scm 86 */
BgL_auxz00_5089 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1281z00_4059)
; }  else 
{ /* Eval/evaluate_types.scm 86 */
BgL_auxz00_5089 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4058))
; } } } 
((((BgL_ev_unwindzd2protectzd2_bglt)COBJECT(
((BgL_ev_unwindzd2protectzd2_bglt)BgL_new1116z00_3647)))->BgL_ez00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5089),BUNSPEC); } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5098;
{ /* Eval/evaluate_types.scm 86 */
obj_t BgL_classz00_4060;
BgL_classz00_4060 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 86 */
obj_t BgL__ortest_1281z00_4061;
BgL__ortest_1281z00_4061 = 
BGL_CLASS_NIL(BgL_classz00_4060); 
if(
CBOOL(BgL__ortest_1281z00_4061))
{ /* Eval/evaluate_types.scm 86 */
BgL_auxz00_5098 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1281z00_4061)
; }  else 
{ /* Eval/evaluate_types.scm 86 */
BgL_auxz00_5098 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4060))
; } } } 
((((BgL_ev_unwindzd2protectzd2_bglt)COBJECT(
((BgL_ev_unwindzd2protectzd2_bglt)BgL_new1116z00_3647)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5098),BUNSPEC); } 
BgL_auxz00_5088 = 
((BgL_ev_unwindzd2protectzd2_bglt)BgL_new1116z00_3647); 
return 
((obj_t)BgL_auxz00_5088);} } 

}



/* &lambda1690 */
BgL_ev_unwindzd2protectzd2_bglt BGl_z62lambda1690z62zz__evaluate_typesz00(obj_t BgL_envz00_3648)
{
{ /* Eval/evaluate_types.scm 86 */
{ /* Eval/evaluate_types.scm 86 */
BgL_ev_unwindzd2protectzd2_bglt BgL_new1115z00_4062;
BgL_new1115z00_4062 = 
((BgL_ev_unwindzd2protectzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_unwindzd2protectzd2_bgl) ))); 
{ /* Eval/evaluate_types.scm 86 */
long BgL_arg1691z00_4063;
{ /* Eval/evaluate_types.scm 86 */
long BgL_res2303z00_4064;
BgL_res2303z00_4064 = 
BGL_CLASS_INDEX(BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00); 
BgL_arg1691z00_4063 = BgL_res2303z00_4064; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1115z00_4062), BgL_arg1691z00_4063); } 
return BgL_new1115z00_4062;} } 

}



/* &lambda1688 */
BgL_ev_unwindzd2protectzd2_bglt BGl_z62lambda1688z62zz__evaluate_typesz00(obj_t BgL_envz00_3649, obj_t BgL_e1113z00_3650, obj_t BgL_body1114z00_3651)
{
{ /* Eval/evaluate_types.scm 86 */
{ /* Eval/evaluate_types.scm 86 */
BgL_ev_unwindzd2protectzd2_bglt BgL_new1222z00_4067;
{ /* Eval/evaluate_types.scm 86 */
BgL_ev_unwindzd2protectzd2_bglt BgL_new1221z00_4068;
BgL_new1221z00_4068 = 
((BgL_ev_unwindzd2protectzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_unwindzd2protectzd2_bgl) ))); 
{ /* Eval/evaluate_types.scm 86 */
long BgL_arg1689z00_4069;
{ /* Eval/evaluate_types.scm 86 */
long BgL_res2302z00_4070;
BgL_res2302z00_4070 = 
BGL_CLASS_INDEX(BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00); 
BgL_arg1689z00_4069 = BgL_res2302z00_4070; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1221z00_4068), BgL_arg1689z00_4069); } 
BgL_new1222z00_4067 = BgL_new1221z00_4068; } 
((((BgL_ev_unwindzd2protectzd2_bglt)COBJECT(BgL_new1222z00_4067))->BgL_ez00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_e1113z00_3650)),BUNSPEC); 
((((BgL_ev_unwindzd2protectzd2_bglt)COBJECT(BgL_new1222z00_4067))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_body1114z00_3651)),BUNSPEC); 
return BgL_new1222z00_4067;} } 

}



/* &lambda1702 */
obj_t BGl_z62lambda1702z62zz__evaluate_typesz00(obj_t BgL_envz00_3652, obj_t BgL_oz00_3653, obj_t BgL_vz00_3654)
{
{ /* Eval/evaluate_types.scm 86 */
return 
((((BgL_ev_unwindzd2protectzd2_bglt)COBJECT(
((BgL_ev_unwindzd2protectzd2_bglt)BgL_oz00_3653)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3654)),BUNSPEC);} 

}



/* &lambda1701 */
BgL_ev_exprz00_bglt BGl_z62lambda1701z62zz__evaluate_typesz00(obj_t BgL_envz00_3655, obj_t BgL_oz00_3656)
{
{ /* Eval/evaluate_types.scm 86 */
return 
(((BgL_ev_unwindzd2protectzd2_bglt)COBJECT(
((BgL_ev_unwindzd2protectzd2_bglt)BgL_oz00_3656)))->BgL_bodyz00);} 

}



/* &lambda1697 */
obj_t BGl_z62lambda1697z62zz__evaluate_typesz00(obj_t BgL_envz00_3657, obj_t BgL_oz00_3658, obj_t BgL_vz00_3659)
{
{ /* Eval/evaluate_types.scm 86 */
return 
((((BgL_ev_unwindzd2protectzd2_bglt)COBJECT(
((BgL_ev_unwindzd2protectzd2_bglt)BgL_oz00_3658)))->BgL_ez00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3659)),BUNSPEC);} 

}



/* &lambda1696 */
BgL_ev_exprz00_bglt BGl_z62lambda1696z62zz__evaluate_typesz00(obj_t BgL_envz00_3660, obj_t BgL_oz00_3661)
{
{ /* Eval/evaluate_types.scm 86 */
return 
(((BgL_ev_unwindzd2protectzd2_bglt)COBJECT(
((BgL_ev_unwindzd2protectzd2_bglt)BgL_oz00_3661)))->BgL_ez00);} 

}



/* &<@anonymous:1668> */
obj_t BGl_z62zc3z04anonymousza31668ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3662, obj_t BgL_new1111z00_3663)
{
{ /* Eval/evaluate_types.scm 83 */
{ 
BgL_ev_bindzd2exitzd2_bglt BgL_auxz00_5131;
{ 
BgL_ev_varz00_bglt BgL_auxz00_5132;
{ /* Eval/evaluate_types.scm 83 */
obj_t BgL_classz00_4078;
BgL_classz00_4078 = BGl_ev_varz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 83 */
obj_t BgL__ortest_1281z00_4079;
BgL__ortest_1281z00_4079 = 
BGL_CLASS_NIL(BgL_classz00_4078); 
if(
CBOOL(BgL__ortest_1281z00_4079))
{ /* Eval/evaluate_types.scm 83 */
BgL_auxz00_5132 = 
((BgL_ev_varz00_bglt)BgL__ortest_1281z00_4079)
; }  else 
{ /* Eval/evaluate_types.scm 83 */
BgL_auxz00_5132 = 
((BgL_ev_varz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4078))
; } } } 
((((BgL_ev_bindzd2exitzd2_bglt)COBJECT(
((BgL_ev_bindzd2exitzd2_bglt)BgL_new1111z00_3663)))->BgL_varz00)=((BgL_ev_varz00_bglt)BgL_auxz00_5132),BUNSPEC); } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5141;
{ /* Eval/evaluate_types.scm 83 */
obj_t BgL_classz00_4080;
BgL_classz00_4080 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 83 */
obj_t BgL__ortest_1281z00_4081;
BgL__ortest_1281z00_4081 = 
BGL_CLASS_NIL(BgL_classz00_4080); 
if(
CBOOL(BgL__ortest_1281z00_4081))
{ /* Eval/evaluate_types.scm 83 */
BgL_auxz00_5141 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1281z00_4081)
; }  else 
{ /* Eval/evaluate_types.scm 83 */
BgL_auxz00_5141 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4080))
; } } } 
((((BgL_ev_bindzd2exitzd2_bglt)COBJECT(
((BgL_ev_bindzd2exitzd2_bglt)BgL_new1111z00_3663)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5141),BUNSPEC); } 
BgL_auxz00_5131 = 
((BgL_ev_bindzd2exitzd2_bglt)BgL_new1111z00_3663); 
return 
((obj_t)BgL_auxz00_5131);} } 

}



/* &lambda1666 */
BgL_ev_bindzd2exitzd2_bglt BGl_z62lambda1666z62zz__evaluate_typesz00(obj_t BgL_envz00_3664)
{
{ /* Eval/evaluate_types.scm 83 */
{ /* Eval/evaluate_types.scm 83 */
BgL_ev_bindzd2exitzd2_bglt BgL_new1110z00_4082;
BgL_new1110z00_4082 = 
((BgL_ev_bindzd2exitzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_bindzd2exitzd2_bgl) ))); 
{ /* Eval/evaluate_types.scm 83 */
long BgL_arg1667z00_4083;
{ /* Eval/evaluate_types.scm 83 */
long BgL_res2301z00_4084;
BgL_res2301z00_4084 = 
BGL_CLASS_INDEX(BGl_ev_bindzd2exitzd2zz__evaluate_typesz00); 
BgL_arg1667z00_4083 = BgL_res2301z00_4084; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1110z00_4082), BgL_arg1667z00_4083); } 
return BgL_new1110z00_4082;} } 

}



/* &lambda1664 */
BgL_ev_bindzd2exitzd2_bglt BGl_z62lambda1664z62zz__evaluate_typesz00(obj_t BgL_envz00_3665, obj_t BgL_var1108z00_3666, obj_t BgL_body1109z00_3667)
{
{ /* Eval/evaluate_types.scm 83 */
{ /* Eval/evaluate_types.scm 83 */
BgL_ev_bindzd2exitzd2_bglt BgL_new1220z00_4087;
{ /* Eval/evaluate_types.scm 83 */
BgL_ev_bindzd2exitzd2_bglt BgL_new1219z00_4088;
BgL_new1219z00_4088 = 
((BgL_ev_bindzd2exitzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_bindzd2exitzd2_bgl) ))); 
{ /* Eval/evaluate_types.scm 83 */
long BgL_arg1665z00_4089;
{ /* Eval/evaluate_types.scm 83 */
long BgL_res2300z00_4090;
BgL_res2300z00_4090 = 
BGL_CLASS_INDEX(BGl_ev_bindzd2exitzd2zz__evaluate_typesz00); 
BgL_arg1665z00_4089 = BgL_res2300z00_4090; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1219z00_4088), BgL_arg1665z00_4089); } 
BgL_new1220z00_4087 = BgL_new1219z00_4088; } 
((((BgL_ev_bindzd2exitzd2_bglt)COBJECT(BgL_new1220z00_4087))->BgL_varz00)=((BgL_ev_varz00_bglt)
((BgL_ev_varz00_bglt)BgL_var1108z00_3666)),BUNSPEC); 
((((BgL_ev_bindzd2exitzd2_bglt)COBJECT(BgL_new1220z00_4087))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_body1109z00_3667)),BUNSPEC); 
return BgL_new1220z00_4087;} } 

}



/* &lambda1680 */
obj_t BGl_z62lambda1680z62zz__evaluate_typesz00(obj_t BgL_envz00_3668, obj_t BgL_oz00_3669, obj_t BgL_vz00_3670)
{
{ /* Eval/evaluate_types.scm 83 */
return 
((((BgL_ev_bindzd2exitzd2_bglt)COBJECT(
((BgL_ev_bindzd2exitzd2_bglt)BgL_oz00_3669)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3670)),BUNSPEC);} 

}



/* &lambda1679 */
BgL_ev_exprz00_bglt BGl_z62lambda1679z62zz__evaluate_typesz00(obj_t BgL_envz00_3671, obj_t BgL_oz00_3672)
{
{ /* Eval/evaluate_types.scm 83 */
return 
(((BgL_ev_bindzd2exitzd2_bglt)COBJECT(
((BgL_ev_bindzd2exitzd2_bglt)BgL_oz00_3672)))->BgL_bodyz00);} 

}



/* &lambda1675 */
obj_t BGl_z62lambda1675z62zz__evaluate_typesz00(obj_t BgL_envz00_3673, obj_t BgL_oz00_3674, obj_t BgL_vz00_3675)
{
{ /* Eval/evaluate_types.scm 83 */
return 
((((BgL_ev_bindzd2exitzd2_bglt)COBJECT(
((BgL_ev_bindzd2exitzd2_bglt)BgL_oz00_3674)))->BgL_varz00)=((BgL_ev_varz00_bglt)
((BgL_ev_varz00_bglt)BgL_vz00_3675)),BUNSPEC);} 

}



/* &lambda1674 */
BgL_ev_varz00_bglt BGl_z62lambda1674z62zz__evaluate_typesz00(obj_t BgL_envz00_3676, obj_t BgL_oz00_3677)
{
{ /* Eval/evaluate_types.scm 83 */
return 
(((BgL_ev_bindzd2exitzd2_bglt)COBJECT(
((BgL_ev_bindzd2exitzd2_bglt)BgL_oz00_3677)))->BgL_varz00);} 

}



/* &<@anonymous:1657> */
obj_t BGl_z62zc3z04anonymousza31657ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3678, obj_t BgL_new1106z00_3679)
{
{ /* Eval/evaluate_types.scm 82 */
{ 
BgL_ev_defglobalz00_bglt BgL_auxz00_5174;
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5175;
{ /* Eval/evaluate_types.scm 82 */
obj_t BgL_classz00_4098;
BgL_classz00_4098 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 82 */
obj_t BgL__ortest_1281z00_4099;
BgL__ortest_1281z00_4099 = 
BGL_CLASS_NIL(BgL_classz00_4098); 
if(
CBOOL(BgL__ortest_1281z00_4099))
{ /* Eval/evaluate_types.scm 82 */
BgL_auxz00_5175 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1281z00_4099)
; }  else 
{ /* Eval/evaluate_types.scm 82 */
BgL_auxz00_5175 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4098))
; } } } 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)
((BgL_ev_defglobalz00_bglt)BgL_new1106z00_3679))))->BgL_ez00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5175),BUNSPEC); } 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)
((BgL_ev_defglobalz00_bglt)BgL_new1106z00_3679))))->BgL_locz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)
((BgL_ev_defglobalz00_bglt)BgL_new1106z00_3679))))->BgL_namez00)=((obj_t)BGl_symbol2703z00zz__evaluate_typesz00),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)
((BgL_ev_defglobalz00_bglt)BgL_new1106z00_3679))))->BgL_modz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_5174 = 
((BgL_ev_defglobalz00_bglt)BgL_new1106z00_3679); 
return 
((obj_t)BgL_auxz00_5174);} } 

}



/* &lambda1655 */
BgL_ev_defglobalz00_bglt BGl_z62lambda1655z62zz__evaluate_typesz00(obj_t BgL_envz00_3680)
{
{ /* Eval/evaluate_types.scm 82 */
{ /* Eval/evaluate_types.scm 82 */
BgL_ev_defglobalz00_bglt BgL_new1105z00_4100;
BgL_new1105z00_4100 = 
((BgL_ev_defglobalz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_defglobalz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 82 */
long BgL_arg1656z00_4101;
{ /* Eval/evaluate_types.scm 82 */
long BgL_res2299z00_4102;
BgL_res2299z00_4102 = 
BGL_CLASS_INDEX(BGl_ev_defglobalz00zz__evaluate_typesz00); 
BgL_arg1656z00_4101 = BgL_res2299z00_4102; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1105z00_4100), BgL_arg1656z00_4101); } 
return BgL_new1105z00_4100;} } 

}



/* &lambda1652 */
BgL_ev_defglobalz00_bglt BGl_z62lambda1652z62zz__evaluate_typesz00(obj_t BgL_envz00_3681, obj_t BgL_e1101z00_3682, obj_t BgL_loc1102z00_3683, obj_t BgL_name1103z00_3684, obj_t BgL_mod1104z00_3685)
{
{ /* Eval/evaluate_types.scm 82 */
{ /* Eval/evaluate_types.scm 82 */
BgL_ev_defglobalz00_bglt BgL_new1218z00_4105;
{ /* Eval/evaluate_types.scm 82 */
BgL_ev_defglobalz00_bglt BgL_new1217z00_4106;
BgL_new1217z00_4106 = 
((BgL_ev_defglobalz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_defglobalz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 82 */
long BgL_arg1654z00_4107;
{ /* Eval/evaluate_types.scm 82 */
long BgL_res2298z00_4108;
BgL_res2298z00_4108 = 
BGL_CLASS_INDEX(BGl_ev_defglobalz00zz__evaluate_typesz00); 
BgL_arg1654z00_4107 = BgL_res2298z00_4108; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1217z00_4106), BgL_arg1654z00_4107); } 
BgL_new1218z00_4105 = BgL_new1217z00_4106; } 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)BgL_new1218z00_4105)))->BgL_ez00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_e1101z00_3682)),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_new1218z00_4105)))->BgL_locz00)=((obj_t)BgL_loc1102z00_3683),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_new1218z00_4105)))->BgL_namez00)=((obj_t)
((obj_t)BgL_name1103z00_3684)),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_new1218z00_4105)))->BgL_modz00)=((obj_t)BgL_mod1104z00_3685),BUNSPEC); 
return BgL_new1218z00_4105;} } 

}



/* &<@anonymous:1622> */
obj_t BGl_z62zc3z04anonymousza31622ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3686, obj_t BgL_new1099z00_3687)
{
{ /* Eval/evaluate_types.scm 78 */
{ 
BgL_ev_setglobalz00_bglt BgL_auxz00_5214;
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5215;
{ /* Eval/evaluate_types.scm 78 */
obj_t BgL_classz00_4110;
BgL_classz00_4110 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 78 */
obj_t BgL__ortest_1281z00_4111;
BgL__ortest_1281z00_4111 = 
BGL_CLASS_NIL(BgL_classz00_4110); 
if(
CBOOL(BgL__ortest_1281z00_4111))
{ /* Eval/evaluate_types.scm 78 */
BgL_auxz00_5215 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1281z00_4111)
; }  else 
{ /* Eval/evaluate_types.scm 78 */
BgL_auxz00_5215 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4110))
; } } } 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)
((BgL_ev_setglobalz00_bglt)BgL_new1099z00_3687))))->BgL_ez00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5215),BUNSPEC); } 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_new1099z00_3687)))->BgL_locz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_new1099z00_3687)))->BgL_namez00)=((obj_t)BGl_symbol2703z00zz__evaluate_typesz00),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_new1099z00_3687)))->BgL_modz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_5214 = 
((BgL_ev_setglobalz00_bglt)BgL_new1099z00_3687); 
return 
((obj_t)BgL_auxz00_5214);} } 

}



/* &lambda1620 */
BgL_ev_setglobalz00_bglt BGl_z62lambda1620z62zz__evaluate_typesz00(obj_t BgL_envz00_3688)
{
{ /* Eval/evaluate_types.scm 78 */
{ /* Eval/evaluate_types.scm 78 */
BgL_ev_setglobalz00_bglt BgL_new1098z00_4112;
BgL_new1098z00_4112 = 
((BgL_ev_setglobalz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_setglobalz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 78 */
long BgL_arg1621z00_4113;
{ /* Eval/evaluate_types.scm 78 */
long BgL_res2297z00_4114;
BgL_res2297z00_4114 = 
BGL_CLASS_INDEX(BGl_ev_setglobalz00zz__evaluate_typesz00); 
BgL_arg1621z00_4113 = BgL_res2297z00_4114; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1098z00_4112), BgL_arg1621z00_4113); } 
return BgL_new1098z00_4112;} } 

}



/* &lambda1618 */
BgL_ev_setglobalz00_bglt BGl_z62lambda1618z62zz__evaluate_typesz00(obj_t BgL_envz00_3689, obj_t BgL_e1094z00_3690, obj_t BgL_loc1095z00_3691, obj_t BgL_name1096z00_3692, obj_t BgL_mod1097z00_3693)
{
{ /* Eval/evaluate_types.scm 78 */
{ /* Eval/evaluate_types.scm 78 */
BgL_ev_setglobalz00_bglt BgL_new1216z00_4117;
{ /* Eval/evaluate_types.scm 78 */
BgL_ev_setglobalz00_bglt BgL_new1215z00_4118;
BgL_new1215z00_4118 = 
((BgL_ev_setglobalz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_setglobalz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 78 */
long BgL_arg1619z00_4119;
{ /* Eval/evaluate_types.scm 78 */
long BgL_res2296z00_4120;
BgL_res2296z00_4120 = 
BGL_CLASS_INDEX(BGl_ev_setglobalz00zz__evaluate_typesz00); 
BgL_arg1619z00_4119 = BgL_res2296z00_4120; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1215z00_4118), BgL_arg1619z00_4119); } 
BgL_new1216z00_4117 = BgL_new1215z00_4118; } 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)BgL_new1216z00_4117)))->BgL_ez00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_e1094z00_3690)),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(BgL_new1216z00_4117))->BgL_locz00)=((obj_t)BgL_loc1095z00_3691),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(BgL_new1216z00_4117))->BgL_namez00)=((obj_t)
((obj_t)BgL_name1096z00_3692)),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(BgL_new1216z00_4117))->BgL_modz00)=((obj_t)BgL_mod1097z00_3693),BUNSPEC); 
return BgL_new1216z00_4117;} } 

}



/* &lambda1640 */
obj_t BGl_z62lambda1640z62zz__evaluate_typesz00(obj_t BgL_envz00_3694, obj_t BgL_oz00_3695, obj_t BgL_vz00_3696)
{
{ /* Eval/evaluate_types.scm 78 */
return 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_oz00_3695)))->BgL_modz00)=((obj_t)BgL_vz00_3696),BUNSPEC);} 

}



/* &lambda1639 */
obj_t BGl_z62lambda1639z62zz__evaluate_typesz00(obj_t BgL_envz00_3697, obj_t BgL_oz00_3698)
{
{ /* Eval/evaluate_types.scm 78 */
return 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_oz00_3698)))->BgL_modz00);} 

}



/* &lambda1632 */
obj_t BGl_z62lambda1632z62zz__evaluate_typesz00(obj_t BgL_envz00_3699, obj_t BgL_oz00_3700, obj_t BgL_vz00_3701)
{
{ /* Eval/evaluate_types.scm 78 */
return 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_oz00_3700)))->BgL_namez00)=((obj_t)
((obj_t)BgL_vz00_3701)),BUNSPEC);} 

}



/* &lambda1631 */
obj_t BGl_z62lambda1631z62zz__evaluate_typesz00(obj_t BgL_envz00_3702, obj_t BgL_oz00_3703)
{
{ /* Eval/evaluate_types.scm 78 */
return 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_oz00_3703)))->BgL_namez00);} 

}



/* &lambda1627 */
obj_t BGl_z62lambda1627z62zz__evaluate_typesz00(obj_t BgL_envz00_3704, obj_t BgL_oz00_3705, obj_t BgL_vz00_3706)
{
{ /* Eval/evaluate_types.scm 78 */
return 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_oz00_3705)))->BgL_locz00)=((obj_t)BgL_vz00_3706),BUNSPEC);} 

}



/* &lambda1626 */
obj_t BGl_z62lambda1626z62zz__evaluate_typesz00(obj_t BgL_envz00_3707, obj_t BgL_oz00_3708)
{
{ /* Eval/evaluate_types.scm 78 */
return 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_oz00_3708)))->BgL_locz00);} 

}



/* &<@anonymous:1607> */
obj_t BGl_z62zc3z04anonymousza31607ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3709, obj_t BgL_new1092z00_3710)
{
{ /* Eval/evaluate_types.scm 76 */
{ 
BgL_ev_setlocalz00_bglt BgL_auxz00_5261;
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5262;
{ /* Eval/evaluate_types.scm 76 */
obj_t BgL_classz00_4129;
BgL_classz00_4129 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 76 */
obj_t BgL__ortest_1281z00_4130;
BgL__ortest_1281z00_4130 = 
BGL_CLASS_NIL(BgL_classz00_4129); 
if(
CBOOL(BgL__ortest_1281z00_4130))
{ /* Eval/evaluate_types.scm 76 */
BgL_auxz00_5262 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1281z00_4130)
; }  else 
{ /* Eval/evaluate_types.scm 76 */
BgL_auxz00_5262 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4129))
; } } } 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)
((BgL_ev_setlocalz00_bglt)BgL_new1092z00_3710))))->BgL_ez00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5262),BUNSPEC); } 
{ 
BgL_ev_varz00_bglt BgL_auxz00_5272;
{ /* Eval/evaluate_types.scm 76 */
obj_t BgL_classz00_4131;
BgL_classz00_4131 = BGl_ev_varz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 76 */
obj_t BgL__ortest_1281z00_4132;
BgL__ortest_1281z00_4132 = 
BGL_CLASS_NIL(BgL_classz00_4131); 
if(
CBOOL(BgL__ortest_1281z00_4132))
{ /* Eval/evaluate_types.scm 76 */
BgL_auxz00_5272 = 
((BgL_ev_varz00_bglt)BgL__ortest_1281z00_4132)
; }  else 
{ /* Eval/evaluate_types.scm 76 */
BgL_auxz00_5272 = 
((BgL_ev_varz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4131))
; } } } 
((((BgL_ev_setlocalz00_bglt)COBJECT(
((BgL_ev_setlocalz00_bglt)BgL_new1092z00_3710)))->BgL_vz00)=((BgL_ev_varz00_bglt)BgL_auxz00_5272),BUNSPEC); } 
BgL_auxz00_5261 = 
((BgL_ev_setlocalz00_bglt)BgL_new1092z00_3710); 
return 
((obj_t)BgL_auxz00_5261);} } 

}



/* &lambda1605 */
BgL_ev_setlocalz00_bglt BGl_z62lambda1605z62zz__evaluate_typesz00(obj_t BgL_envz00_3711)
{
{ /* Eval/evaluate_types.scm 76 */
{ /* Eval/evaluate_types.scm 76 */
BgL_ev_setlocalz00_bglt BgL_new1091z00_4133;
BgL_new1091z00_4133 = 
((BgL_ev_setlocalz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_setlocalz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 76 */
long BgL_arg1606z00_4134;
{ /* Eval/evaluate_types.scm 76 */
long BgL_res2295z00_4135;
BgL_res2295z00_4135 = 
BGL_CLASS_INDEX(BGl_ev_setlocalz00zz__evaluate_typesz00); 
BgL_arg1606z00_4134 = BgL_res2295z00_4135; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1091z00_4133), BgL_arg1606z00_4134); } 
return BgL_new1091z00_4133;} } 

}



/* &lambda1603 */
BgL_ev_setlocalz00_bglt BGl_z62lambda1603z62zz__evaluate_typesz00(obj_t BgL_envz00_3712, obj_t BgL_e1089z00_3713, obj_t BgL_v1090z00_3714)
{
{ /* Eval/evaluate_types.scm 76 */
{ /* Eval/evaluate_types.scm 76 */
BgL_ev_setlocalz00_bglt BgL_new1214z00_4138;
{ /* Eval/evaluate_types.scm 76 */
BgL_ev_setlocalz00_bglt BgL_new1213z00_4139;
BgL_new1213z00_4139 = 
((BgL_ev_setlocalz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_setlocalz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 76 */
long BgL_arg1604z00_4140;
{ /* Eval/evaluate_types.scm 76 */
long BgL_res2294z00_4141;
BgL_res2294z00_4141 = 
BGL_CLASS_INDEX(BGl_ev_setlocalz00zz__evaluate_typesz00); 
BgL_arg1604z00_4140 = BgL_res2294z00_4141; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1213z00_4139), BgL_arg1604z00_4140); } 
BgL_new1214z00_4138 = BgL_new1213z00_4139; } 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)BgL_new1214z00_4138)))->BgL_ez00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_e1089z00_3713)),BUNSPEC); 
((((BgL_ev_setlocalz00_bglt)COBJECT(BgL_new1214z00_4138))->BgL_vz00)=((BgL_ev_varz00_bglt)
((BgL_ev_varz00_bglt)BgL_v1090z00_3714)),BUNSPEC); 
return BgL_new1214z00_4138;} } 

}



/* &lambda1612 */
obj_t BGl_z62lambda1612z62zz__evaluate_typesz00(obj_t BgL_envz00_3715, obj_t BgL_oz00_3716, obj_t BgL_vz00_3717)
{
{ /* Eval/evaluate_types.scm 76 */
return 
((((BgL_ev_setlocalz00_bglt)COBJECT(
((BgL_ev_setlocalz00_bglt)BgL_oz00_3716)))->BgL_vz00)=((BgL_ev_varz00_bglt)
((BgL_ev_varz00_bglt)BgL_vz00_3717)),BUNSPEC);} 

}



/* &lambda1611 */
BgL_ev_varz00_bglt BGl_z62lambda1611z62zz__evaluate_typesz00(obj_t BgL_envz00_3718, obj_t BgL_oz00_3719)
{
{ /* Eval/evaluate_types.scm 76 */
return 
(((BgL_ev_setlocalz00_bglt)COBJECT(
((BgL_ev_setlocalz00_bglt)BgL_oz00_3719)))->BgL_vz00);} 

}



/* &<@anonymous:1597> */
obj_t BGl_z62zc3z04anonymousza31597ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3720, obj_t BgL_new1087z00_3721)
{
{ /* Eval/evaluate_types.scm 75 */
{ 
BgL_ev_trapz00_bglt BgL_auxz00_5301;
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5302;
{ /* Eval/evaluate_types.scm 75 */
obj_t BgL_classz00_4146;
BgL_classz00_4146 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 75 */
obj_t BgL__ortest_1281z00_4147;
BgL__ortest_1281z00_4147 = 
BGL_CLASS_NIL(BgL_classz00_4146); 
if(
CBOOL(BgL__ortest_1281z00_4147))
{ /* Eval/evaluate_types.scm 75 */
BgL_auxz00_5302 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1281z00_4147)
; }  else 
{ /* Eval/evaluate_types.scm 75 */
BgL_auxz00_5302 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4146))
; } } } 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)
((BgL_ev_trapz00_bglt)BgL_new1087z00_3721))))->BgL_ez00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5302),BUNSPEC); } 
BgL_auxz00_5301 = 
((BgL_ev_trapz00_bglt)BgL_new1087z00_3721); 
return 
((obj_t)BgL_auxz00_5301);} } 

}



/* &lambda1595 */
BgL_ev_trapz00_bglt BGl_z62lambda1595z62zz__evaluate_typesz00(obj_t BgL_envz00_3722)
{
{ /* Eval/evaluate_types.scm 75 */
{ /* Eval/evaluate_types.scm 75 */
BgL_ev_trapz00_bglt BgL_new1086z00_4148;
BgL_new1086z00_4148 = 
((BgL_ev_trapz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_trapz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 75 */
long BgL_arg1596z00_4149;
{ /* Eval/evaluate_types.scm 75 */
long BgL_res2293z00_4150;
BgL_res2293z00_4150 = 
BGL_CLASS_INDEX(BGl_ev_trapz00zz__evaluate_typesz00); 
BgL_arg1596z00_4149 = BgL_res2293z00_4150; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1086z00_4148), BgL_arg1596z00_4149); } 
return BgL_new1086z00_4148;} } 

}



/* &lambda1593 */
BgL_ev_trapz00_bglt BGl_z62lambda1593z62zz__evaluate_typesz00(obj_t BgL_envz00_3723, obj_t BgL_e1085z00_3724)
{
{ /* Eval/evaluate_types.scm 75 */
{ /* Eval/evaluate_types.scm 75 */
BgL_ev_trapz00_bglt BgL_new1212z00_4152;
{ /* Eval/evaluate_types.scm 75 */
BgL_ev_trapz00_bglt BgL_new1211z00_4153;
BgL_new1211z00_4153 = 
((BgL_ev_trapz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_trapz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 75 */
long BgL_arg1594z00_4154;
{ /* Eval/evaluate_types.scm 75 */
long BgL_res2292z00_4155;
BgL_res2292z00_4155 = 
BGL_CLASS_INDEX(BGl_ev_trapz00zz__evaluate_typesz00); 
BgL_arg1594z00_4154 = BgL_res2292z00_4155; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1211z00_4153), BgL_arg1594z00_4154); } 
BgL_new1212z00_4152 = BgL_new1211z00_4153; } 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)BgL_new1212z00_4152)))->BgL_ez00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_e1085z00_3724)),BUNSPEC); 
return BgL_new1212z00_4152;} } 

}



/* &<@anonymous:1581> */
obj_t BGl_z62zc3z04anonymousza31581ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3725, obj_t BgL_new1083z00_3726)
{
{ /* Eval/evaluate_types.scm 73 */
{ 
BgL_ev_hookz00_bglt BgL_auxz00_5325;
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5326;
{ /* Eval/evaluate_types.scm 73 */
obj_t BgL_classz00_4157;
BgL_classz00_4157 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 73 */
obj_t BgL__ortest_1281z00_4158;
BgL__ortest_1281z00_4158 = 
BGL_CLASS_NIL(BgL_classz00_4157); 
if(
CBOOL(BgL__ortest_1281z00_4158))
{ /* Eval/evaluate_types.scm 73 */
BgL_auxz00_5326 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1281z00_4158)
; }  else 
{ /* Eval/evaluate_types.scm 73 */
BgL_auxz00_5326 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4157))
; } } } 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)BgL_new1083z00_3726)))->BgL_ez00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5326),BUNSPEC); } 
BgL_auxz00_5325 = 
((BgL_ev_hookz00_bglt)BgL_new1083z00_3726); 
return 
((obj_t)BgL_auxz00_5325);} } 

}



/* &lambda1579 */
BgL_ev_hookz00_bglt BGl_z62lambda1579z62zz__evaluate_typesz00(obj_t BgL_envz00_3727)
{
{ /* Eval/evaluate_types.scm 73 */
{ /* Eval/evaluate_types.scm 73 */
BgL_ev_hookz00_bglt BgL_new1082z00_4159;
BgL_new1082z00_4159 = 
((BgL_ev_hookz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_hookz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 73 */
long BgL_arg1580z00_4160;
{ /* Eval/evaluate_types.scm 73 */
long BgL_res2291z00_4161;
BgL_res2291z00_4161 = 
BGL_CLASS_INDEX(BGl_ev_hookz00zz__evaluate_typesz00); 
BgL_arg1580z00_4160 = BgL_res2291z00_4161; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1082z00_4159), BgL_arg1580z00_4160); } 
return BgL_new1082z00_4159;} } 

}



/* &lambda1577 */
BgL_ev_hookz00_bglt BGl_z62lambda1577z62zz__evaluate_typesz00(obj_t BgL_envz00_3728, obj_t BgL_e1081z00_3729)
{
{ /* Eval/evaluate_types.scm 73 */
{ /* Eval/evaluate_types.scm 73 */
BgL_ev_hookz00_bglt BgL_new1210z00_4163;
{ /* Eval/evaluate_types.scm 73 */
BgL_ev_hookz00_bglt BgL_new1209z00_4164;
BgL_new1209z00_4164 = 
((BgL_ev_hookz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_hookz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 73 */
long BgL_arg1578z00_4165;
{ /* Eval/evaluate_types.scm 73 */
long BgL_res2290z00_4166;
BgL_res2290z00_4166 = 
BGL_CLASS_INDEX(BGl_ev_hookz00zz__evaluate_typesz00); 
BgL_arg1578z00_4165 = BgL_res2290z00_4166; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1209z00_4164), BgL_arg1578z00_4165); } 
BgL_new1210z00_4163 = BgL_new1209z00_4164; } 
((((BgL_ev_hookz00_bglt)COBJECT(BgL_new1210z00_4163))->BgL_ez00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_e1081z00_3729)),BUNSPEC); 
return BgL_new1210z00_4163;} } 

}



/* &lambda1586 */
obj_t BGl_z62lambda1586z62zz__evaluate_typesz00(obj_t BgL_envz00_3730, obj_t BgL_oz00_3731, obj_t BgL_vz00_3732)
{
{ /* Eval/evaluate_types.scm 73 */
return 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)BgL_oz00_3731)))->BgL_ez00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3732)),BUNSPEC);} 

}



/* &lambda1585 */
BgL_ev_exprz00_bglt BGl_z62lambda1585z62zz__evaluate_typesz00(obj_t BgL_envz00_3733, obj_t BgL_oz00_3734)
{
{ /* Eval/evaluate_types.scm 73 */
return 
(((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)BgL_oz00_3734)))->BgL_ez00);} 

}



/* &<@anonymous:1559> */
obj_t BGl_z62zc3z04anonymousza31559ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3735, obj_t BgL_new1079z00_3736)
{
{ /* Eval/evaluate_types.scm 70 */
{ 
BgL_ev_prog2z00_bglt BgL_auxz00_5352;
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5353;
{ /* Eval/evaluate_types.scm 70 */
obj_t BgL_classz00_4171;
BgL_classz00_4171 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 70 */
obj_t BgL__ortest_1281z00_4172;
BgL__ortest_1281z00_4172 = 
BGL_CLASS_NIL(BgL_classz00_4171); 
if(
CBOOL(BgL__ortest_1281z00_4172))
{ /* Eval/evaluate_types.scm 70 */
BgL_auxz00_5353 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1281z00_4172)
; }  else 
{ /* Eval/evaluate_types.scm 70 */
BgL_auxz00_5353 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4171))
; } } } 
((((BgL_ev_prog2z00_bglt)COBJECT(
((BgL_ev_prog2z00_bglt)BgL_new1079z00_3736)))->BgL_e1z00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5353),BUNSPEC); } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5362;
{ /* Eval/evaluate_types.scm 70 */
obj_t BgL_classz00_4173;
BgL_classz00_4173 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 70 */
obj_t BgL__ortest_1281z00_4174;
BgL__ortest_1281z00_4174 = 
BGL_CLASS_NIL(BgL_classz00_4173); 
if(
CBOOL(BgL__ortest_1281z00_4174))
{ /* Eval/evaluate_types.scm 70 */
BgL_auxz00_5362 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1281z00_4174)
; }  else 
{ /* Eval/evaluate_types.scm 70 */
BgL_auxz00_5362 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4173))
; } } } 
((((BgL_ev_prog2z00_bglt)COBJECT(
((BgL_ev_prog2z00_bglt)BgL_new1079z00_3736)))->BgL_e2z00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5362),BUNSPEC); } 
BgL_auxz00_5352 = 
((BgL_ev_prog2z00_bglt)BgL_new1079z00_3736); 
return 
((obj_t)BgL_auxz00_5352);} } 

}



/* &lambda1557 */
BgL_ev_prog2z00_bglt BGl_z62lambda1557z62zz__evaluate_typesz00(obj_t BgL_envz00_3737)
{
{ /* Eval/evaluate_types.scm 70 */
{ /* Eval/evaluate_types.scm 70 */
BgL_ev_prog2z00_bglt BgL_new1078z00_4175;
BgL_new1078z00_4175 = 
((BgL_ev_prog2z00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_prog2z00_bgl) ))); 
{ /* Eval/evaluate_types.scm 70 */
long BgL_arg1558z00_4176;
{ /* Eval/evaluate_types.scm 70 */
long BgL_res2289z00_4177;
BgL_res2289z00_4177 = 
BGL_CLASS_INDEX(BGl_ev_prog2z00zz__evaluate_typesz00); 
BgL_arg1558z00_4176 = BgL_res2289z00_4177; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1078z00_4175), BgL_arg1558z00_4176); } 
return BgL_new1078z00_4175;} } 

}



/* &lambda1555 */
BgL_ev_prog2z00_bglt BGl_z62lambda1555z62zz__evaluate_typesz00(obj_t BgL_envz00_3738, obj_t BgL_e11076z00_3739, obj_t BgL_e21077z00_3740)
{
{ /* Eval/evaluate_types.scm 70 */
{ /* Eval/evaluate_types.scm 70 */
BgL_ev_prog2z00_bglt BgL_new1208z00_4180;
{ /* Eval/evaluate_types.scm 70 */
BgL_ev_prog2z00_bglt BgL_new1207z00_4181;
BgL_new1207z00_4181 = 
((BgL_ev_prog2z00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_prog2z00_bgl) ))); 
{ /* Eval/evaluate_types.scm 70 */
long BgL_arg1556z00_4182;
{ /* Eval/evaluate_types.scm 70 */
long BgL_res2288z00_4183;
BgL_res2288z00_4183 = 
BGL_CLASS_INDEX(BGl_ev_prog2z00zz__evaluate_typesz00); 
BgL_arg1556z00_4182 = BgL_res2288z00_4183; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1207z00_4181), BgL_arg1556z00_4182); } 
BgL_new1208z00_4180 = BgL_new1207z00_4181; } 
((((BgL_ev_prog2z00_bglt)COBJECT(BgL_new1208z00_4180))->BgL_e1z00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_e11076z00_3739)),BUNSPEC); 
((((BgL_ev_prog2z00_bglt)COBJECT(BgL_new1208z00_4180))->BgL_e2z00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_e21077z00_3740)),BUNSPEC); 
return BgL_new1208z00_4180;} } 

}



/* &lambda1571 */
obj_t BGl_z62lambda1571z62zz__evaluate_typesz00(obj_t BgL_envz00_3741, obj_t BgL_oz00_3742, obj_t BgL_vz00_3743)
{
{ /* Eval/evaluate_types.scm 70 */
return 
((((BgL_ev_prog2z00_bglt)COBJECT(
((BgL_ev_prog2z00_bglt)BgL_oz00_3742)))->BgL_e2z00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3743)),BUNSPEC);} 

}



/* &lambda1570 */
BgL_ev_exprz00_bglt BGl_z62lambda1570z62zz__evaluate_typesz00(obj_t BgL_envz00_3744, obj_t BgL_oz00_3745)
{
{ /* Eval/evaluate_types.scm 70 */
return 
(((BgL_ev_prog2z00_bglt)COBJECT(
((BgL_ev_prog2z00_bglt)BgL_oz00_3745)))->BgL_e2z00);} 

}



/* &lambda1564 */
obj_t BGl_z62lambda1564z62zz__evaluate_typesz00(obj_t BgL_envz00_3746, obj_t BgL_oz00_3747, obj_t BgL_vz00_3748)
{
{ /* Eval/evaluate_types.scm 70 */
return 
((((BgL_ev_prog2z00_bglt)COBJECT(
((BgL_ev_prog2z00_bglt)BgL_oz00_3747)))->BgL_e1z00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3748)),BUNSPEC);} 

}



/* &lambda1563 */
BgL_ev_exprz00_bglt BGl_z62lambda1563z62zz__evaluate_typesz00(obj_t BgL_envz00_3749, obj_t BgL_oz00_3750)
{
{ /* Eval/evaluate_types.scm 70 */
return 
(((BgL_ev_prog2z00_bglt)COBJECT(
((BgL_ev_prog2z00_bglt)BgL_oz00_3750)))->BgL_e1z00);} 

}



/* &<@anonymous:1547> */
obj_t BGl_z62zc3z04anonymousza31547ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3751, obj_t BgL_new1074z00_3752)
{
{ /* Eval/evaluate_types.scm 69 */
{ 
BgL_ev_andz00_bglt BgL_auxz00_5395;
((((BgL_ev_listz00_bglt)COBJECT(
((BgL_ev_listz00_bglt)
((BgL_ev_andz00_bglt)BgL_new1074z00_3752))))->BgL_argsz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_5395 = 
((BgL_ev_andz00_bglt)BgL_new1074z00_3752); 
return 
((obj_t)BgL_auxz00_5395);} } 

}



/* &lambda1545 */
BgL_ev_andz00_bglt BGl_z62lambda1545z62zz__evaluate_typesz00(obj_t BgL_envz00_3753)
{
{ /* Eval/evaluate_types.scm 69 */
{ /* Eval/evaluate_types.scm 69 */
BgL_ev_andz00_bglt BgL_new1073z00_4191;
BgL_new1073z00_4191 = 
((BgL_ev_andz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_andz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 69 */
long BgL_arg1546z00_4192;
{ /* Eval/evaluate_types.scm 69 */
long BgL_res2287z00_4193;
BgL_res2287z00_4193 = 
BGL_CLASS_INDEX(BGl_ev_andz00zz__evaluate_typesz00); 
BgL_arg1546z00_4192 = BgL_res2287z00_4193; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1073z00_4191), BgL_arg1546z00_4192); } 
return BgL_new1073z00_4191;} } 

}



/* &lambda1543 */
BgL_ev_andz00_bglt BGl_z62lambda1543z62zz__evaluate_typesz00(obj_t BgL_envz00_3754, obj_t BgL_args1072z00_3755)
{
{ /* Eval/evaluate_types.scm 69 */
{ /* Eval/evaluate_types.scm 69 */
BgL_ev_andz00_bglt BgL_new1206z00_4194;
{ /* Eval/evaluate_types.scm 69 */
BgL_ev_andz00_bglt BgL_new1205z00_4195;
BgL_new1205z00_4195 = 
((BgL_ev_andz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_andz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 69 */
long BgL_arg1544z00_4196;
{ /* Eval/evaluate_types.scm 69 */
long BgL_res2286z00_4197;
BgL_res2286z00_4197 = 
BGL_CLASS_INDEX(BGl_ev_andz00zz__evaluate_typesz00); 
BgL_arg1544z00_4196 = BgL_res2286z00_4197; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1205z00_4195), BgL_arg1544z00_4196); } 
BgL_new1206z00_4194 = BgL_new1205z00_4195; } 
((((BgL_ev_listz00_bglt)COBJECT(
((BgL_ev_listz00_bglt)BgL_new1206z00_4194)))->BgL_argsz00)=((obj_t)BgL_args1072z00_3755),BUNSPEC); 
return BgL_new1206z00_4194;} } 

}



/* &<@anonymous:1532> */
obj_t BGl_z62zc3z04anonymousza31532ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3756, obj_t BgL_new1070z00_3757)
{
{ /* Eval/evaluate_types.scm 68 */
{ 
BgL_ev_orz00_bglt BgL_auxz00_5411;
((((BgL_ev_listz00_bglt)COBJECT(
((BgL_ev_listz00_bglt)
((BgL_ev_orz00_bglt)BgL_new1070z00_3757))))->BgL_argsz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_5411 = 
((BgL_ev_orz00_bglt)BgL_new1070z00_3757); 
return 
((obj_t)BgL_auxz00_5411);} } 

}



/* &lambda1530 */
BgL_ev_orz00_bglt BGl_z62lambda1530z62zz__evaluate_typesz00(obj_t BgL_envz00_3758)
{
{ /* Eval/evaluate_types.scm 68 */
{ /* Eval/evaluate_types.scm 68 */
BgL_ev_orz00_bglt BgL_new1069z00_4199;
BgL_new1069z00_4199 = 
((BgL_ev_orz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_orz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 68 */
long BgL_arg1531z00_4200;
{ /* Eval/evaluate_types.scm 68 */
long BgL_res2285z00_4201;
BgL_res2285z00_4201 = 
BGL_CLASS_INDEX(BGl_ev_orz00zz__evaluate_typesz00); 
BgL_arg1531z00_4200 = BgL_res2285z00_4201; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1069z00_4199), BgL_arg1531z00_4200); } 
return BgL_new1069z00_4199;} } 

}



/* &lambda1528 */
BgL_ev_orz00_bglt BGl_z62lambda1528z62zz__evaluate_typesz00(obj_t BgL_envz00_3759, obj_t BgL_args1068z00_3760)
{
{ /* Eval/evaluate_types.scm 68 */
{ /* Eval/evaluate_types.scm 68 */
BgL_ev_orz00_bglt BgL_new1204z00_4202;
{ /* Eval/evaluate_types.scm 68 */
BgL_ev_orz00_bglt BgL_new1203z00_4203;
BgL_new1203z00_4203 = 
((BgL_ev_orz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_orz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 68 */
long BgL_arg1529z00_4204;
{ /* Eval/evaluate_types.scm 68 */
long BgL_res2284z00_4205;
BgL_res2284z00_4205 = 
BGL_CLASS_INDEX(BGl_ev_orz00zz__evaluate_typesz00); 
BgL_arg1529z00_4204 = BgL_res2284z00_4205; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1203z00_4203), BgL_arg1529z00_4204); } 
BgL_new1204z00_4202 = BgL_new1203z00_4203; } 
((((BgL_ev_listz00_bglt)COBJECT(
((BgL_ev_listz00_bglt)BgL_new1204z00_4202)))->BgL_argsz00)=((obj_t)BgL_args1068z00_3760),BUNSPEC); 
return BgL_new1204z00_4202;} } 

}



/* &<@anonymous:1516> */
obj_t BGl_z62zc3z04anonymousza31516ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3761, obj_t BgL_new1066z00_3762)
{
{ /* Eval/evaluate_types.scm 66 */
{ 
BgL_ev_listz00_bglt BgL_auxz00_5427;
((((BgL_ev_listz00_bglt)COBJECT(
((BgL_ev_listz00_bglt)BgL_new1066z00_3762)))->BgL_argsz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_5427 = 
((BgL_ev_listz00_bglt)BgL_new1066z00_3762); 
return 
((obj_t)BgL_auxz00_5427);} } 

}



/* &lambda1512 */
BgL_ev_listz00_bglt BGl_z62lambda1512z62zz__evaluate_typesz00(obj_t BgL_envz00_3763)
{
{ /* Eval/evaluate_types.scm 66 */
{ /* Eval/evaluate_types.scm 66 */
BgL_ev_listz00_bglt BgL_new1065z00_4207;
BgL_new1065z00_4207 = 
((BgL_ev_listz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_listz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 66 */
long BgL_arg1515z00_4208;
{ /* Eval/evaluate_types.scm 66 */
long BgL_res2283z00_4209;
BgL_res2283z00_4209 = 
BGL_CLASS_INDEX(BGl_ev_listz00zz__evaluate_typesz00); 
BgL_arg1515z00_4208 = BgL_res2283z00_4209; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1065z00_4207), BgL_arg1515z00_4208); } 
return BgL_new1065z00_4207;} } 

}



/* &lambda1510 */
BgL_ev_listz00_bglt BGl_z62lambda1510z62zz__evaluate_typesz00(obj_t BgL_envz00_3764, obj_t BgL_args1064z00_3765)
{
{ /* Eval/evaluate_types.scm 66 */
{ /* Eval/evaluate_types.scm 66 */
BgL_ev_listz00_bglt BgL_new1202z00_4210;
{ /* Eval/evaluate_types.scm 66 */
BgL_ev_listz00_bglt BgL_new1201z00_4211;
BgL_new1201z00_4211 = 
((BgL_ev_listz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_listz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 66 */
long BgL_arg1511z00_4212;
{ /* Eval/evaluate_types.scm 66 */
long BgL_res2282z00_4213;
BgL_res2282z00_4213 = 
BGL_CLASS_INDEX(BGl_ev_listz00zz__evaluate_typesz00); 
BgL_arg1511z00_4212 = BgL_res2282z00_4213; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1201z00_4211), BgL_arg1511z00_4212); } 
BgL_new1202z00_4210 = BgL_new1201z00_4211; } 
((((BgL_ev_listz00_bglt)COBJECT(BgL_new1202z00_4210))->BgL_argsz00)=((obj_t)BgL_args1064z00_3765),BUNSPEC); 
return BgL_new1202z00_4210;} } 

}



/* &lambda1522 */
obj_t BGl_z62lambda1522z62zz__evaluate_typesz00(obj_t BgL_envz00_3766, obj_t BgL_oz00_3767, obj_t BgL_vz00_3768)
{
{ /* Eval/evaluate_types.scm 66 */
return 
((((BgL_ev_listz00_bglt)COBJECT(
((BgL_ev_listz00_bglt)BgL_oz00_3767)))->BgL_argsz00)=((obj_t)BgL_vz00_3768),BUNSPEC);} 

}



/* &lambda1521 */
obj_t BGl_z62lambda1521z62zz__evaluate_typesz00(obj_t BgL_envz00_3769, obj_t BgL_oz00_3770)
{
{ /* Eval/evaluate_types.scm 66 */
return 
(((BgL_ev_listz00_bglt)COBJECT(
((BgL_ev_listz00_bglt)BgL_oz00_3770)))->BgL_argsz00);} 

}



/* &<@anonymous:1486> */
obj_t BGl_z62zc3z04anonymousza31486ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3771, obj_t BgL_new1062z00_3772)
{
{ /* Eval/evaluate_types.scm 62 */
{ 
BgL_ev_ifz00_bglt BgL_auxz00_5445;
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5446;
{ /* Eval/evaluate_types.scm 62 */
obj_t BgL_classz00_4217;
BgL_classz00_4217 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 62 */
obj_t BgL__ortest_1281z00_4218;
BgL__ortest_1281z00_4218 = 
BGL_CLASS_NIL(BgL_classz00_4217); 
if(
CBOOL(BgL__ortest_1281z00_4218))
{ /* Eval/evaluate_types.scm 62 */
BgL_auxz00_5446 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1281z00_4218)
; }  else 
{ /* Eval/evaluate_types.scm 62 */
BgL_auxz00_5446 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4217))
; } } } 
((((BgL_ev_ifz00_bglt)COBJECT(
((BgL_ev_ifz00_bglt)BgL_new1062z00_3772)))->BgL_pz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5446),BUNSPEC); } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5455;
{ /* Eval/evaluate_types.scm 62 */
obj_t BgL_classz00_4219;
BgL_classz00_4219 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 62 */
obj_t BgL__ortest_1281z00_4220;
BgL__ortest_1281z00_4220 = 
BGL_CLASS_NIL(BgL_classz00_4219); 
if(
CBOOL(BgL__ortest_1281z00_4220))
{ /* Eval/evaluate_types.scm 62 */
BgL_auxz00_5455 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1281z00_4220)
; }  else 
{ /* Eval/evaluate_types.scm 62 */
BgL_auxz00_5455 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4219))
; } } } 
((((BgL_ev_ifz00_bglt)COBJECT(
((BgL_ev_ifz00_bglt)BgL_new1062z00_3772)))->BgL_tz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5455),BUNSPEC); } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5464;
{ /* Eval/evaluate_types.scm 62 */
obj_t BgL_classz00_4221;
BgL_classz00_4221 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 62 */
obj_t BgL__ortest_1281z00_4222;
BgL__ortest_1281z00_4222 = 
BGL_CLASS_NIL(BgL_classz00_4221); 
if(
CBOOL(BgL__ortest_1281z00_4222))
{ /* Eval/evaluate_types.scm 62 */
BgL_auxz00_5464 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1281z00_4222)
; }  else 
{ /* Eval/evaluate_types.scm 62 */
BgL_auxz00_5464 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4221))
; } } } 
((((BgL_ev_ifz00_bglt)COBJECT(
((BgL_ev_ifz00_bglt)BgL_new1062z00_3772)))->BgL_ez00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5464),BUNSPEC); } 
BgL_auxz00_5445 = 
((BgL_ev_ifz00_bglt)BgL_new1062z00_3772); 
return 
((obj_t)BgL_auxz00_5445);} } 

}



/* &lambda1484 */
BgL_ev_ifz00_bglt BGl_z62lambda1484z62zz__evaluate_typesz00(obj_t BgL_envz00_3773)
{
{ /* Eval/evaluate_types.scm 62 */
{ /* Eval/evaluate_types.scm 62 */
BgL_ev_ifz00_bglt BgL_new1061z00_4223;
BgL_new1061z00_4223 = 
((BgL_ev_ifz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_ifz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 62 */
long BgL_arg1485z00_4224;
{ /* Eval/evaluate_types.scm 62 */
long BgL_res2281z00_4225;
BgL_res2281z00_4225 = 
BGL_CLASS_INDEX(BGl_ev_ifz00zz__evaluate_typesz00); 
BgL_arg1485z00_4224 = BgL_res2281z00_4225; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1061z00_4223), BgL_arg1485z00_4224); } 
return BgL_new1061z00_4223;} } 

}



/* &lambda1482 */
BgL_ev_ifz00_bglt BGl_z62lambda1482z62zz__evaluate_typesz00(obj_t BgL_envz00_3774, obj_t BgL_p1058z00_3775, obj_t BgL_t1059z00_3776, obj_t BgL_e1060z00_3777)
{
{ /* Eval/evaluate_types.scm 62 */
{ /* Eval/evaluate_types.scm 62 */
BgL_ev_ifz00_bglt BgL_new1200z00_4229;
{ /* Eval/evaluate_types.scm 62 */
BgL_ev_ifz00_bglt BgL_new1199z00_4230;
BgL_new1199z00_4230 = 
((BgL_ev_ifz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_ifz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 62 */
long BgL_arg1483z00_4231;
{ /* Eval/evaluate_types.scm 62 */
long BgL_res2280z00_4232;
BgL_res2280z00_4232 = 
BGL_CLASS_INDEX(BGl_ev_ifz00zz__evaluate_typesz00); 
BgL_arg1483z00_4231 = BgL_res2280z00_4232; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1199z00_4230), BgL_arg1483z00_4231); } 
BgL_new1200z00_4229 = BgL_new1199z00_4230; } 
((((BgL_ev_ifz00_bglt)COBJECT(BgL_new1200z00_4229))->BgL_pz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_p1058z00_3775)),BUNSPEC); 
((((BgL_ev_ifz00_bglt)COBJECT(BgL_new1200z00_4229))->BgL_tz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_t1059z00_3776)),BUNSPEC); 
((((BgL_ev_ifz00_bglt)COBJECT(BgL_new1200z00_4229))->BgL_ez00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_e1060z00_3777)),BUNSPEC); 
return BgL_new1200z00_4229;} } 

}



/* &lambda1504 */
obj_t BGl_z62lambda1504z62zz__evaluate_typesz00(obj_t BgL_envz00_3778, obj_t BgL_oz00_3779, obj_t BgL_vz00_3780)
{
{ /* Eval/evaluate_types.scm 62 */
return 
((((BgL_ev_ifz00_bglt)COBJECT(
((BgL_ev_ifz00_bglt)BgL_oz00_3779)))->BgL_ez00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3780)),BUNSPEC);} 

}



/* &lambda1503 */
BgL_ev_exprz00_bglt BGl_z62lambda1503z62zz__evaluate_typesz00(obj_t BgL_envz00_3781, obj_t BgL_oz00_3782)
{
{ /* Eval/evaluate_types.scm 62 */
return 
(((BgL_ev_ifz00_bglt)COBJECT(
((BgL_ev_ifz00_bglt)BgL_oz00_3782)))->BgL_ez00);} 

}



/* &lambda1499 */
obj_t BGl_z62lambda1499z62zz__evaluate_typesz00(obj_t BgL_envz00_3783, obj_t BgL_oz00_3784, obj_t BgL_vz00_3785)
{
{ /* Eval/evaluate_types.scm 62 */
return 
((((BgL_ev_ifz00_bglt)COBJECT(
((BgL_ev_ifz00_bglt)BgL_oz00_3784)))->BgL_tz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3785)),BUNSPEC);} 

}



/* &lambda1498 */
BgL_ev_exprz00_bglt BGl_z62lambda1498z62zz__evaluate_typesz00(obj_t BgL_envz00_3786, obj_t BgL_oz00_3787)
{
{ /* Eval/evaluate_types.scm 62 */
return 
(((BgL_ev_ifz00_bglt)COBJECT(
((BgL_ev_ifz00_bglt)BgL_oz00_3787)))->BgL_tz00);} 

}



/* &lambda1493 */
obj_t BGl_z62lambda1493z62zz__evaluate_typesz00(obj_t BgL_envz00_3788, obj_t BgL_oz00_3789, obj_t BgL_vz00_3790)
{
{ /* Eval/evaluate_types.scm 62 */
return 
((((BgL_ev_ifz00_bglt)COBJECT(
((BgL_ev_ifz00_bglt)BgL_oz00_3789)))->BgL_pz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3790)),BUNSPEC);} 

}



/* &lambda1492 */
BgL_ev_exprz00_bglt BGl_z62lambda1492z62zz__evaluate_typesz00(obj_t BgL_envz00_3791, obj_t BgL_oz00_3792)
{
{ /* Eval/evaluate_types.scm 62 */
return 
(((BgL_ev_ifz00_bglt)COBJECT(
((BgL_ev_ifz00_bglt)BgL_oz00_3792)))->BgL_pz00);} 

}



/* &<@anonymous:1470> */
obj_t BGl_z62zc3z04anonymousza31470ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3793, obj_t BgL_new1056z00_3794)
{
{ /* Eval/evaluate_types.scm 60 */
{ 
BgL_ev_littz00_bglt BgL_auxz00_5504;
((((BgL_ev_littz00_bglt)COBJECT(
((BgL_ev_littz00_bglt)BgL_new1056z00_3794)))->BgL_valuez00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_5504 = 
((BgL_ev_littz00_bglt)BgL_new1056z00_3794); 
return 
((obj_t)BgL_auxz00_5504);} } 

}



/* &lambda1468 */
BgL_ev_littz00_bglt BGl_z62lambda1468z62zz__evaluate_typesz00(obj_t BgL_envz00_3795)
{
{ /* Eval/evaluate_types.scm 60 */
{ /* Eval/evaluate_types.scm 60 */
BgL_ev_littz00_bglt BgL_new1055z00_4243;
BgL_new1055z00_4243 = 
((BgL_ev_littz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_littz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 60 */
long BgL_arg1469z00_4244;
{ /* Eval/evaluate_types.scm 60 */
long BgL_res2279z00_4245;
BgL_res2279z00_4245 = 
BGL_CLASS_INDEX(BGl_ev_littz00zz__evaluate_typesz00); 
BgL_arg1469z00_4244 = BgL_res2279z00_4245; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1055z00_4243), BgL_arg1469z00_4244); } 
return BgL_new1055z00_4243;} } 

}



/* &lambda1466 */
BgL_ev_littz00_bglt BGl_z62lambda1466z62zz__evaluate_typesz00(obj_t BgL_envz00_3796, obj_t BgL_value1054z00_3797)
{
{ /* Eval/evaluate_types.scm 60 */
{ /* Eval/evaluate_types.scm 60 */
BgL_ev_littz00_bglt BgL_new1198z00_4246;
{ /* Eval/evaluate_types.scm 60 */
BgL_ev_littz00_bglt BgL_new1197z00_4247;
BgL_new1197z00_4247 = 
((BgL_ev_littz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_littz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 60 */
long BgL_arg1467z00_4248;
{ /* Eval/evaluate_types.scm 60 */
long BgL_res2278z00_4249;
BgL_res2278z00_4249 = 
BGL_CLASS_INDEX(BGl_ev_littz00zz__evaluate_typesz00); 
BgL_arg1467z00_4248 = BgL_res2278z00_4249; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1197z00_4247), BgL_arg1467z00_4248); } 
BgL_new1198z00_4246 = BgL_new1197z00_4247; } 
((((BgL_ev_littz00_bglt)COBJECT(BgL_new1198z00_4246))->BgL_valuez00)=((obj_t)BgL_value1054z00_3797),BUNSPEC); 
return BgL_new1198z00_4246;} } 

}



/* &lambda1476 */
obj_t BGl_z62lambda1476z62zz__evaluate_typesz00(obj_t BgL_envz00_3798, obj_t BgL_oz00_3799, obj_t BgL_vz00_3800)
{
{ /* Eval/evaluate_types.scm 60 */
return 
((((BgL_ev_littz00_bglt)COBJECT(
((BgL_ev_littz00_bglt)BgL_oz00_3799)))->BgL_valuez00)=((obj_t)BgL_vz00_3800),BUNSPEC);} 

}



/* &lambda1475 */
obj_t BGl_z62lambda1475z62zz__evaluate_typesz00(obj_t BgL_envz00_3801, obj_t BgL_oz00_3802)
{
{ /* Eval/evaluate_types.scm 60 */
return 
(((BgL_ev_littz00_bglt)COBJECT(
((BgL_ev_littz00_bglt)BgL_oz00_3802)))->BgL_valuez00);} 

}



/* &<@anonymous:1442> */
obj_t BGl_z62zc3z04anonymousza31442ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3803, obj_t BgL_new1052z00_3804)
{
{ /* Eval/evaluate_types.scm 55 */
{ 
BgL_ev_globalz00_bglt BgL_auxz00_5522;
((((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_new1052z00_3804)))->BgL_locz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_new1052z00_3804)))->BgL_namez00)=((obj_t)BGl_symbol2703z00zz__evaluate_typesz00),BUNSPEC); 
((((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_new1052z00_3804)))->BgL_modz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_5522 = 
((BgL_ev_globalz00_bglt)BgL_new1052z00_3804); 
return 
((obj_t)BgL_auxz00_5522);} } 

}



/* &lambda1440 */
BgL_ev_globalz00_bglt BGl_z62lambda1440z62zz__evaluate_typesz00(obj_t BgL_envz00_3805)
{
{ /* Eval/evaluate_types.scm 55 */
{ /* Eval/evaluate_types.scm 55 */
BgL_ev_globalz00_bglt BgL_new1051z00_4253;
BgL_new1051z00_4253 = 
((BgL_ev_globalz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_globalz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 55 */
long BgL_arg1441z00_4254;
{ /* Eval/evaluate_types.scm 55 */
long BgL_res2277z00_4255;
BgL_res2277z00_4255 = 
BGL_CLASS_INDEX(BGl_ev_globalz00zz__evaluate_typesz00); 
BgL_arg1441z00_4254 = BgL_res2277z00_4255; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1051z00_4253), BgL_arg1441z00_4254); } 
return BgL_new1051z00_4253;} } 

}



/* &lambda1438 */
BgL_ev_globalz00_bglt BGl_z62lambda1438z62zz__evaluate_typesz00(obj_t BgL_envz00_3806, obj_t BgL_loc1048z00_3807, obj_t BgL_name1049z00_3808, obj_t BgL_mod1050z00_3809)
{
{ /* Eval/evaluate_types.scm 55 */
{ /* Eval/evaluate_types.scm 55 */
BgL_ev_globalz00_bglt BgL_new1196z00_4257;
{ /* Eval/evaluate_types.scm 55 */
BgL_ev_globalz00_bglt BgL_new1195z00_4258;
BgL_new1195z00_4258 = 
((BgL_ev_globalz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_globalz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 55 */
long BgL_arg1439z00_4259;
{ /* Eval/evaluate_types.scm 55 */
long BgL_res2276z00_4260;
BgL_res2276z00_4260 = 
BGL_CLASS_INDEX(BGl_ev_globalz00zz__evaluate_typesz00); 
BgL_arg1439z00_4259 = BgL_res2276z00_4260; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1195z00_4258), BgL_arg1439z00_4259); } 
BgL_new1196z00_4257 = BgL_new1195z00_4258; } 
((((BgL_ev_globalz00_bglt)COBJECT(BgL_new1196z00_4257))->BgL_locz00)=((obj_t)BgL_loc1048z00_3807),BUNSPEC); 
((((BgL_ev_globalz00_bglt)COBJECT(BgL_new1196z00_4257))->BgL_namez00)=((obj_t)
((obj_t)BgL_name1049z00_3808)),BUNSPEC); 
((((BgL_ev_globalz00_bglt)COBJECT(BgL_new1196z00_4257))->BgL_modz00)=((obj_t)BgL_mod1050z00_3809),BUNSPEC); 
return BgL_new1196z00_4257;} } 

}



/* &lambda1459 */
obj_t BGl_z62lambda1459z62zz__evaluate_typesz00(obj_t BgL_envz00_3810, obj_t BgL_oz00_3811, obj_t BgL_vz00_3812)
{
{ /* Eval/evaluate_types.scm 55 */
return 
((((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_oz00_3811)))->BgL_modz00)=((obj_t)BgL_vz00_3812),BUNSPEC);} 

}



/* &lambda1458 */
obj_t BGl_z62lambda1458z62zz__evaluate_typesz00(obj_t BgL_envz00_3813, obj_t BgL_oz00_3814)
{
{ /* Eval/evaluate_types.scm 55 */
return 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_oz00_3814)))->BgL_modz00);} 

}



/* &lambda1454 */
obj_t BGl_z62lambda1454z62zz__evaluate_typesz00(obj_t BgL_envz00_3815, obj_t BgL_oz00_3816, obj_t BgL_vz00_3817)
{
{ /* Eval/evaluate_types.scm 55 */
return 
((((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_oz00_3816)))->BgL_namez00)=((obj_t)
((obj_t)BgL_vz00_3817)),BUNSPEC);} 

}



/* &lambda1453 */
obj_t BGl_z62lambda1453z62zz__evaluate_typesz00(obj_t BgL_envz00_3818, obj_t BgL_oz00_3819)
{
{ /* Eval/evaluate_types.scm 55 */
return 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_oz00_3819)))->BgL_namez00);} 

}



/* &lambda1449 */
obj_t BGl_z62lambda1449z62zz__evaluate_typesz00(obj_t BgL_envz00_3820, obj_t BgL_oz00_3821, obj_t BgL_vz00_3822)
{
{ /* Eval/evaluate_types.scm 55 */
return 
((((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_oz00_3821)))->BgL_locz00)=((obj_t)BgL_vz00_3822),BUNSPEC);} 

}



/* &lambda1448 */
obj_t BGl_z62lambda1448z62zz__evaluate_typesz00(obj_t BgL_envz00_3823, obj_t BgL_oz00_3824)
{
{ /* Eval/evaluate_types.scm 55 */
return 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_oz00_3824)))->BgL_locz00);} 

}



/* &<@anonymous:1413> */
obj_t BGl_z62zc3z04anonymousza31413ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3825, obj_t BgL_new1046z00_3826)
{
{ /* Eval/evaluate_types.scm 51 */
{ 
BgL_ev_varz00_bglt BgL_auxz00_5556;
((((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_new1046z00_3826)))->BgL_namez00)=((obj_t)BGl_symbol2703z00zz__evaluate_typesz00),BUNSPEC); 
((((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_new1046z00_3826)))->BgL_effz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_new1046z00_3826)))->BgL_typez00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_5556 = 
((BgL_ev_varz00_bglt)BgL_new1046z00_3826); 
return 
((obj_t)BgL_auxz00_5556);} } 

}



/* &lambda1411 */
BgL_ev_varz00_bglt BGl_z62lambda1411z62zz__evaluate_typesz00(obj_t BgL_envz00_3827)
{
{ /* Eval/evaluate_types.scm 51 */
{ /* Eval/evaluate_types.scm 51 */
BgL_ev_varz00_bglt BgL_new1045z00_4269;
BgL_new1045z00_4269 = 
((BgL_ev_varz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_varz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 51 */
long BgL_arg1412z00_4270;
{ /* Eval/evaluate_types.scm 51 */
long BgL_res2275z00_4271;
BgL_res2275z00_4271 = 
BGL_CLASS_INDEX(BGl_ev_varz00zz__evaluate_typesz00); 
BgL_arg1412z00_4270 = BgL_res2275z00_4271; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1045z00_4269), BgL_arg1412z00_4270); } 
return BgL_new1045z00_4269;} } 

}



/* &lambda1409 */
BgL_ev_varz00_bglt BGl_z62lambda1409z62zz__evaluate_typesz00(obj_t BgL_envz00_3828, obj_t BgL_name1042z00_3829, obj_t BgL_eff1043z00_3830, obj_t BgL_type1044z00_3831)
{
{ /* Eval/evaluate_types.scm 51 */
{ /* Eval/evaluate_types.scm 51 */
BgL_ev_varz00_bglt BgL_new1194z00_4273;
{ /* Eval/evaluate_types.scm 51 */
BgL_ev_varz00_bglt BgL_new1193z00_4274;
BgL_new1193z00_4274 = 
((BgL_ev_varz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_varz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 51 */
long BgL_arg1410z00_4275;
{ /* Eval/evaluate_types.scm 51 */
long BgL_res2274z00_4276;
BgL_res2274z00_4276 = 
BGL_CLASS_INDEX(BGl_ev_varz00zz__evaluate_typesz00); 
BgL_arg1410z00_4275 = BgL_res2274z00_4276; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1193z00_4274), BgL_arg1410z00_4275); } 
BgL_new1194z00_4273 = BgL_new1193z00_4274; } 
((((BgL_ev_varz00_bglt)COBJECT(BgL_new1194z00_4273))->BgL_namez00)=((obj_t)
((obj_t)BgL_name1042z00_3829)),BUNSPEC); 
((((BgL_ev_varz00_bglt)COBJECT(BgL_new1194z00_4273))->BgL_effz00)=((obj_t)BgL_eff1043z00_3830),BUNSPEC); 
((((BgL_ev_varz00_bglt)COBJECT(BgL_new1194z00_4273))->BgL_typez00)=((obj_t)BgL_type1044z00_3831),BUNSPEC); 
return BgL_new1194z00_4273;} } 

}



/* &lambda1431 */
obj_t BGl_z62lambda1431z62zz__evaluate_typesz00(obj_t BgL_envz00_3832, obj_t BgL_oz00_3833, obj_t BgL_vz00_3834)
{
{ /* Eval/evaluate_types.scm 51 */
return 
((((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_oz00_3833)))->BgL_typez00)=((obj_t)BgL_vz00_3834),BUNSPEC);} 

}



/* &lambda1430 */
obj_t BGl_z62lambda1430z62zz__evaluate_typesz00(obj_t BgL_envz00_3835, obj_t BgL_oz00_3836)
{
{ /* Eval/evaluate_types.scm 51 */
return 
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_oz00_3836)))->BgL_typez00);} 

}



/* &<@anonymous:1426> */
obj_t BGl_z62zc3z04anonymousza31426ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3837)
{
{ /* Eval/evaluate_types.scm 51 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda1425 */
obj_t BGl_z62lambda1425z62zz__evaluate_typesz00(obj_t BgL_envz00_3838, obj_t BgL_oz00_3839, obj_t BgL_vz00_3840)
{
{ /* Eval/evaluate_types.scm 51 */
return 
((((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_oz00_3839)))->BgL_effz00)=((obj_t)BgL_vz00_3840),BUNSPEC);} 

}



/* &lambda1424 */
obj_t BGl_z62lambda1424z62zz__evaluate_typesz00(obj_t BgL_envz00_3841, obj_t BgL_oz00_3842)
{
{ /* Eval/evaluate_types.scm 51 */
return 
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_oz00_3842)))->BgL_effz00);} 

}



/* &lambda1418 */
obj_t BGl_z62lambda1418z62zz__evaluate_typesz00(obj_t BgL_envz00_3843, obj_t BgL_oz00_3844, obj_t BgL_vz00_3845)
{
{ /* Eval/evaluate_types.scm 51 */
return 
((((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_oz00_3844)))->BgL_namez00)=((obj_t)
((obj_t)BgL_vz00_3845)),BUNSPEC);} 

}



/* &lambda1417 */
obj_t BGl_z62lambda1417z62zz__evaluate_typesz00(obj_t BgL_envz00_3846, obj_t BgL_oz00_3847)
{
{ /* Eval/evaluate_types.scm 51 */
return 
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_oz00_3847)))->BgL_namez00);} 

}



/* &<@anonymous:1403> */
obj_t BGl_z62zc3z04anonymousza31403ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3848, obj_t BgL_new1040z00_3849)
{
{ /* Eval/evaluate_types.scm 49 */
return 
((obj_t)
((BgL_ev_exprz00_bglt)BgL_new1040z00_3849));} 

}



/* &lambda1401 */
BgL_ev_exprz00_bglt BGl_z62lambda1401z62zz__evaluate_typesz00(obj_t BgL_envz00_3850)
{
{ /* Eval/evaluate_types.scm 49 */
{ /* Eval/evaluate_types.scm 49 */
BgL_ev_exprz00_bglt BgL_new1039z00_4285;
BgL_new1039z00_4285 = 
((BgL_ev_exprz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_exprz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 49 */
long BgL_arg1402z00_4286;
{ /* Eval/evaluate_types.scm 49 */
long BgL_res2273z00_4287;
BgL_res2273z00_4287 = 
BGL_CLASS_INDEX(BGl_ev_exprz00zz__evaluate_typesz00); 
BgL_arg1402z00_4286 = BgL_res2273z00_4287; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1039z00_4285), BgL_arg1402z00_4286); } 
return BgL_new1039z00_4285;} } 

}



/* &lambda1397 */
BgL_ev_exprz00_bglt BGl_z62lambda1397z62zz__evaluate_typesz00(obj_t BgL_envz00_3851)
{
{ /* Eval/evaluate_types.scm 49 */
{ /* Eval/evaluate_types.scm 49 */
BgL_ev_exprz00_bglt BgL_new1192z00_4288;
{ /* Eval/evaluate_types.scm 49 */
BgL_ev_exprz00_bglt BgL_new1191z00_4289;
BgL_new1191z00_4289 = 
((BgL_ev_exprz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_exprz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 49 */
long BgL_arg1400z00_4290;
{ /* Eval/evaluate_types.scm 49 */
long BgL_res2272z00_4291;
BgL_res2272z00_4291 = 
BGL_CLASS_INDEX(BGl_ev_exprz00zz__evaluate_typesz00); 
BgL_arg1400z00_4290 = BgL_res2272z00_4291; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1191z00_4289), BgL_arg1400z00_4290); } 
BgL_new1192z00_4288 = BgL_new1191z00_4289; } 
return BgL_new1192z00_4288;} } 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__evaluate_typesz00()
{
{ /* Eval/evaluate_types.scm 15 */
return BUNSPEC;} 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__evaluate_typesz00()
{
{ /* Eval/evaluate_types.scm 15 */
return BUNSPEC;} 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__evaluate_typesz00()
{
{ /* Eval/evaluate_types.scm 15 */
BGl_modulezd2initializa7ationz75zz__typez00(((long)121046086), 
BSTRING_TO_STRING(BGl_string2380z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)330490148), 
BSTRING_TO_STRING(BGl_string2380z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__biglooz00(((long)180158922), 
BSTRING_TO_STRING(BGl_string2380z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__tvectorz00(((long)135276775), 
BSTRING_TO_STRING(BGl_string2380z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__structurez00(((long)128218210), 
BSTRING_TO_STRING(BGl_string2380z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__bexitz00(((long)340267792), 
BSTRING_TO_STRING(BGl_string2380z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__bignumz00(((long)6519932), 
BSTRING_TO_STRING(BGl_string2380z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__osz00(((long)251314740), 
BSTRING_TO_STRING(BGl_string2380z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__dssslz00(((long)443936801), 
BSTRING_TO_STRING(BGl_string2380z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__bitz00(((long)439353001), 
BSTRING_TO_STRING(BGl_string2380z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__paramz00(((long)453939141), 
BSTRING_TO_STRING(BGl_string2380z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)193422112), 
BSTRING_TO_STRING(BGl_string2380z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__threadz00(((long)224967693), 
BSTRING_TO_STRING(BGl_string2380z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long)68574988), 
BSTRING_TO_STRING(BGl_string2380z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)93454137), 
BSTRING_TO_STRING(BGl_string2380z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(((long)437057797), 
BSTRING_TO_STRING(BGl_string2380z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(((long)268155843), 
BSTRING_TO_STRING(BGl_string2380z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long)198620800), 
BSTRING_TO_STRING(BGl_string2380z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)473309430), 
BSTRING_TO_STRING(BGl_string2380z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(((long)459519430), 
BSTRING_TO_STRING(BGl_string2380z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long)460262918), 
BSTRING_TO_STRING(BGl_string2380z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)-400105135), 
BSTRING_TO_STRING(BGl_string2380z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)9614678), 
BSTRING_TO_STRING(BGl_string2380z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long)376927882), 
BSTRING_TO_STRING(BGl_string2380z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(((long)228151370), 
BSTRING_TO_STRING(BGl_string2380z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)127905250), 
BSTRING_TO_STRING(BGl_string2380z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)331540577), 
BSTRING_TO_STRING(BGl_string2380z00zz__evaluate_typesz00)); 
return 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)86988580), 
BSTRING_TO_STRING(BGl_string2380z00zz__evaluate_typesz00));} 

}

#ifdef __cplusplus
}
#endif
