/*===========================================================================*/
/*   (Eval/evaluate.scm)                                                     */
/*   Bigloo (4.3g)                                                           */
/*   Inria -- Sophia Antipolis (c)       Wed 12 Feb 2020 07:45:41 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bigloo/bin/bigloo -srfi enable-gmp -srfi bigloo-unsafe -O3 -fcfa-arithmetic -q -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.3g -rm -copt -w -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.3g -mklib -cc gcc -fsharing -q -no-hello -unsafe -safee -O4 -c Eval/evaluate.scm -indent -o objs/obj_u/Eval/evaluate.c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* object type definitions */
	typedef struct BgL_ev_exprz00_bgl
	{
		header_t header;
		obj_t widening;
	}                 *BgL_ev_exprz00_bglt;

	typedef struct BgL_ev_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_namez00;
		obj_t BgL_effz00;
		obj_t BgL_typez00;
	}                *BgL_ev_varz00_bglt;

	typedef struct BgL_ev_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		obj_t BgL_modz00;
	}                   *BgL_ev_globalz00_bglt;

	typedef struct BgL_ev_littz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_valuez00;
	}                 *BgL_ev_littz00_bglt;

	typedef struct BgL_ev_ifz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_pz00;
		struct BgL_ev_exprz00_bgl *BgL_tz00;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
	}               *BgL_ev_ifz00_bglt;

	typedef struct BgL_ev_listz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_argsz00;
	}                 *BgL_ev_listz00_bglt;

	typedef struct BgL_ev_orz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_argsz00;
	}               *BgL_ev_orz00_bglt;

	typedef struct BgL_ev_andz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_argsz00;
	}                *BgL_ev_andz00_bglt;

	typedef struct BgL_ev_prog2z00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_e1z00;
		struct BgL_ev_exprz00_bgl *BgL_e2z00;
	}                  *BgL_ev_prog2z00_bglt;

	typedef struct BgL_ev_hookz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
	}                 *BgL_ev_hookz00_bglt;

	typedef struct BgL_ev_trapz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
	}                 *BgL_ev_trapz00_bglt;

	typedef struct BgL_ev_setlocalz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		struct BgL_ev_varz00_bgl *BgL_vz00;
	}                     *BgL_ev_setlocalz00_bglt;

	typedef struct BgL_ev_setglobalz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		obj_t BgL_modz00;
	}                      *BgL_ev_setglobalz00_bglt;

	typedef struct BgL_ev_defglobalz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		obj_t BgL_modz00;
	}                      *BgL_ev_defglobalz00_bglt;

	typedef struct BgL_ev_bindzd2exitzd2_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_varz00_bgl *BgL_varz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                        *BgL_ev_bindzd2exitzd2_bglt;

	typedef struct BgL_ev_unwindzd2protectzd2_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                             *BgL_ev_unwindzd2protectzd2_bglt;

	typedef struct BgL_ev_withzd2handlerzd2_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_handlerz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                           *BgL_ev_withzd2handlerzd2_bglt;

	typedef struct BgL_ev_synchroniza7eza7_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_ev_exprz00_bgl *BgL_mutexz00;
		struct BgL_ev_exprz00_bgl *BgL_prelockz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                          *BgL_ev_synchroniza7eza7_bglt;

	typedef struct BgL_ev_binderz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                   *BgL_ev_binderz00_bglt;

	typedef struct BgL_ev_letz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		obj_t BgL_boxesz00;
	}                *BgL_ev_letz00_bglt;

	typedef struct BgL_ev_letza2za2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		obj_t BgL_boxesz00;
	}                   *BgL_ev_letza2za2_bglt;

	typedef struct BgL_ev_letrecz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                   *BgL_ev_letrecz00_bglt;

	typedef struct BgL_ev_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_ev_exprz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_tailzf3zf3;
	}                *BgL_ev_appz00_bglt;

	typedef struct BgL_ev_absz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		obj_t BgL_wherez00;
		obj_t BgL_arityz00;
		obj_t BgL_varsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		int BgL_siza7eza7;
		obj_t BgL_bindz00;
		obj_t BgL_freez00;
		obj_t BgL_innerz00;
		obj_t BgL_boxesz00;
	}                *BgL_ev_absz00_bglt;


	extern obj_t BGl_compilez00zz__evaluate_compz00(BgL_ev_exprz00_bglt);
	extern bool_t BGl_classzd2fieldzf3z21zz__objectz00(obj_t);
	static BgL_ev_absz00_bglt BGl_convzd2lambdaze70z35zz__evaluatez00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
	extern BgL_ev_exprz00_bglt
		BGl_extractzd2loopszd2zz__evaluate_fsiza7eza7(BgL_ev_exprz00_bglt);
	BGL_EXPORTED_DECL obj_t
		BGl_setzd2evaluationzd2contextz12z12zz__evaluatez00(obj_t);
	static obj_t BGl_getzd2locationzd2zz__evaluatez00(obj_t, obj_t);
	extern obj_t BGl_ev_letrecz00zz__evaluate_typesz00;
	extern obj_t BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(obj_t);
	extern obj_t BGl_ev_letz00zz__evaluate_typesz00;
	extern obj_t BGl_classzd2existszd2zz__objectz00(obj_t);
	extern int BGl_framezd2siza7ez75zz__evaluate_fsiza7eza7(BgL_ev_exprz00_bglt);
	static obj_t BGl_objectzd2initzd2zz__evaluatez00();
	extern bool_t BGl_classzd2fieldzd2mutablezf3zf3zz__objectz00(obj_t);
	static obj_t BGl_z62getzd2evaluationzd2contextz62zz__evaluatez00(obj_t);
	extern obj_t bstring_to_symbol(obj_t);
	extern bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	static obj_t BGl_convzd2fieldzd2setz00zz__evaluatez00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, bool_t);
	extern obj_t make_vector(long, obj_t);
	static obj_t BGl_z62evaluate2zd2restorezd2statez12z70zz__evaluatez00(obj_t,
		obj_t);
	static obj_t BGl_appendzd221011zd2zz__evaluatez00(obj_t, obj_t);
	static obj_t BGl_methodzd2initzd2zz__evaluatez00();
	extern obj_t BGl_ev_absz00zz__evaluate_typesz00;
	extern obj_t BGl_classzd2fieldzd2accessorz00zz__objectz00(obj_t);
	extern obj_t BGl_ev_ifz00zz__evaluate_typesz00;
	extern obj_t BGl_analysezd2varszd2zz__evaluate_avarz00(BgL_ev_exprz00_bglt);
	extern obj_t BGl_evmodulez00zz__evmodulez00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza31346ze3ze5zz__evaluatez00(obj_t);
	extern obj_t BGl_classzd2fieldzd2typez00zz__objectz00(obj_t);
	static obj_t BGl_z62setzd2evaluationzd2contextz12z70zz__evaluatez00(obj_t,
		obj_t);
	extern bool_t BGl_classzf3zf3zz__objectz00(obj_t);
	extern int bgl_debug();
	extern obj_t BGl_ev_orz00zz__evaluate_typesz00;
	extern obj_t BGl_ev_varz00zz__evaluate_typesz00;
	extern obj_t BGl_makezd2dssslzd2functionzd2preludezd2zz__dssslz00(obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_gczd2rootszd2initz00zz__evaluatez00();
	extern obj_t BGl_ev_andz00zz__evaluate_typesz00;
	extern obj_t BGl_ev_appz00zz__evaluate_typesz00;
	extern obj_t
		BGl_dssslzd2formalszd2ze3schemezd2typedzd2formalsze3zz__dssslz00(obj_t,
		obj_t, bool_t);
	extern obj_t c_substring(obj_t, long, long);
	extern obj_t BGl_gensymz00zz__r4_symbols_6_4z00(obj_t);
	extern obj_t BGl_evcompilezd2errorzd2zz__evcompilez00(obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_exitdzd2popzd2protectz12z12zz__bexitz00(obj_t);
	extern obj_t BGl_ev_synchroniza7eza7zz__evaluate_typesz00;
	static obj_t BGl_symbol3176z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_loopze70ze7zz__evaluatez00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_loopze71ze7zz__evaluatez00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_symbol3184z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3186z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3188z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3189z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3191z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3193z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3195z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3197z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3199z00zz__evaluatez00 = BUNSPEC;
	extern obj_t BGl_ev_defglobalz00zz__evaluate_typesz00;
	static obj_t BGl_convzd2beginzd2zz__evaluatez00(obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t, bool_t);
	static obj_t BGl_requirezd2initializa7ationz75zz__evaluatez00 = BUNSPEC;
	extern obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
	extern obj_t BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(obj_t, obj_t);
	extern obj_t bgl_reverse(obj_t);
	static obj_t BGl_genericzd2initzd2zz__evaluatez00();
	extern obj_t BGl_stringzd2copyzd2zz__r4_strings_6_7z00(obj_t);
	extern obj_t BGl_ev_prog2z00zz__evaluate_typesz00;
	extern obj_t BGl_ev_bindzd2exitzd2zz__evaluate_typesz00;
	static obj_t BGl_convzd2fieldzd2refz00zz__evaluatez00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t, bool_t);
	extern obj_t bgl_reverse_bang(obj_t);
	extern obj_t BGl_findzd2classzd2fieldz00zz__objectz00(obj_t, obj_t);
	extern obj_t BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00;
	extern obj_t BGl_classzd2fieldzd2mutatorz00zz__objectz00(obj_t);
	extern obj_t BGl_ev_letza2za2zz__evaluate_typesz00;
	static obj_t BGl_convzd2varzd2zz__evaluatez00(obj_t, obj_t);
	static obj_t BGl_typezd2checkszd2zz__evaluatez00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_ev_trapz00zz__evaluate_typesz00;
	extern obj_t BGl_ev_setglobalz00zz__evaluate_typesz00;
	extern obj_t string_append(obj_t, obj_t);
	extern obj_t BGl_substringz00zz__r4_strings_6_7z00(obj_t, long, long);
	extern obj_t BGl_findzd2statezd2zz__evaluate_compz00();
	static obj_t BGl_untypezd2identzd2zz__evaluatez00(obj_t);
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__evaluatez00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_compz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_uncompz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_fsiza7eza7(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_avarz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evmodulez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__everrorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evcompilez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evenvz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__expandz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__prognz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__ppz00(long, char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(long, char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__dssslz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bignumz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__structurez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__tvectorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__typez00(long, char *);
	extern obj_t BGl_expandz00zz__expandz00(obj_t);
	extern obj_t BGl_ev_globalz00zz__evaluate_typesz00;
	BGL_EXPORTED_DECL obj_t
		BGl_evaluate2zd2restorezd2statez12z12zz__evaluatez00(obj_t);
	extern obj_t BGl_ev_littz00zz__evaluate_typesz00;
	static obj_t BGl_typezd2checkzd2zz__evaluatez00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62evaluate2z62zz__evaluatez00(obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_cnstzd2initzd2zz__evaluatez00();
	static obj_t BGl_importedzd2moduleszd2initz00zz__evaluatez00();
	static obj_t BGl_symbol3201z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3202z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3204z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3206z00zz__evaluatez00 = BUNSPEC;
	extern obj_t BGl_ev_withzd2handlerzd2zz__evaluate_typesz00;
	static obj_t BGl_symbol3208z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3210z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3212z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3214z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3216z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3218z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_uconvzf2locze70z15zz__evaluatez00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_convzd2valsze70z35zz__evaluatez00(obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_symbol3220z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3222z00zz__evaluatez00 = BUNSPEC;
	extern bool_t BGl_evmodulezf3zf3zz__evmodulez00(obj_t);
	static obj_t BGl_symbol3224z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3226z00zz__evaluatez00 = BUNSPEC;
	extern obj_t BGl_getzd2sourcezd2locationz00zz__readerz00(obj_t);
	static obj_t BGl_symbol3228z00zz__evaluatez00 = BUNSPEC;
	BGL_EXPORTED_DECL obj_t BGl_evaluate2z00zz__evaluatez00(obj_t, obj_t, obj_t);
	static obj_t BGl_symbol3230z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3232z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3234z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3236z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3238z00zz__evaluatez00 = BUNSPEC;
	extern obj_t BGl_evalzd2findzd2modulez00zz__evmodulez00(obj_t);
	static obj_t BGl_typezd2resultzd2zz__evaluatez00(obj_t, obj_t, obj_t);
	static obj_t BGl_keyword3287z00zz__evaluatez00 = BUNSPEC;
	BGL_EXPORTED_DECL obj_t
		BGl_evaluate2zd2restorezd2bpz12z12zz__evaluatez00(int);
	static obj_t BGl_symbol3240z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3242z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3244z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3246z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3248z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3250z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3254z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3256z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3259z00zz__evaluatez00 = BUNSPEC;
	extern obj_t bstring_to_keyword(obj_t);
	static obj_t BGl_symbol3261z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3263z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3265z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3267z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3269z00zz__evaluatez00 = BUNSPEC;
	BGL_EXPORTED_DECL obj_t BGl_getzd2evaluationzd2contextz00zz__evaluatez00();
	static obj_t BGl_symbol3271z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3273z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3275z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3277z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3279z00zz__evaluatez00 = BUNSPEC;
	extern obj_t BGl_ev_setlocalz00zz__evaluate_typesz00;
	static obj_t BGl_convz00zz__evaluatez00(obj_t, obj_t, obj_t, obj_t, obj_t,
		obj_t, bool_t);
	static obj_t BGl_z62evaluate2zd2restorezd2bpz12z70zz__evaluatez00(obj_t,
		obj_t);
	static obj_t BGl_symbol3281z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3283z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3285z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3289z00zz__evaluatez00 = BUNSPEC;
	static obj_t *__cnst;


	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_evaluate2zd2restorezd2bpz12zd2envzc0zz__evaluatez00,
		BgL_bgl_za762evaluate2za7d2r3292z00,
		BGl_z62evaluate2zd2restorezd2bpz12z70zz__evaluatez00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string3200z00zz__evaluatez00,
		BgL_bgl_string3200za700za7za7_3293za7, "int", 3);
	      DEFINE_STRING(BGl_string3203z00zz__evaluatez00,
		BgL_bgl_string3203za700za7za7_3294za7, "integer?", 8);
	      DEFINE_STRING(BGl_string3205z00zz__evaluatez00,
		BgL_bgl_string3205za700za7za7_3295za7, "real", 4);
	      DEFINE_STRING(BGl_string3207z00zz__evaluatez00,
		BgL_bgl_string3207za700za7za7_3296za7, "breal", 5);
	      DEFINE_STRING(BGl_string3209z00zz__evaluatez00,
		BgL_bgl_string3209za700za7za7_3297za7, "real?", 5);
	      DEFINE_STRING(BGl_string3211z00zz__evaluatez00,
		BgL_bgl_string3211za700za7za7_3298za7, "bool", 4);
	      DEFINE_STRING(BGl_string3213z00zz__evaluatez00,
		BgL_bgl_string3213za700za7za7_3299za7, "boolean?", 8);
	      DEFINE_STRING(BGl_string3215z00zz__evaluatez00,
		BgL_bgl_string3215za700za7za7_3300za7, "struct", 6);
	      DEFINE_STRING(BGl_string3217z00zz__evaluatez00,
		BgL_bgl_string3217za700za7za7_3301za7, "struct?", 7);
	      DEFINE_STRING(BGl_string3219z00zz__evaluatez00,
		BgL_bgl_string3219za700za7za7_3302za7, "class", 5);
	      DEFINE_STRING(BGl_string3221z00zz__evaluatez00,
		BgL_bgl_string3221za700za7za7_3303za7, "class?", 6);
	      DEFINE_STRING(BGl_string3223z00zz__evaluatez00,
		BgL_bgl_string3223za700za7za7_3304za7, "string", 6);
	      DEFINE_STRING(BGl_string3225z00zz__evaluatez00,
		BgL_bgl_string3225za700za7za7_3305za7, "bstring", 7);
	      DEFINE_STRING(BGl_string3227z00zz__evaluatez00,
		BgL_bgl_string3227za700za7za7_3306za7, "string?", 7);
	      DEFINE_STRING(BGl_string3229z00zz__evaluatez00,
		BgL_bgl_string3229za700za7za7_3307za7, "o", 1);
	      DEFINE_STRING(BGl_string3231z00zz__evaluatez00,
		BgL_bgl_string3231za700za7za7_3308za7, "quote", 5);
	      DEFINE_STRING(BGl_string3233z00zz__evaluatez00,
		BgL_bgl_string3233za700za7za7_3309za7, "class-exists", 12);
	      DEFINE_STRING(BGl_string3235z00zz__evaluatez00,
		BgL_bgl_string3235za700za7za7_3310za7, "c", 1);
	      DEFINE_STRING(BGl_string3237z00zz__evaluatez00,
		BgL_bgl_string3237za700za7za7_3311za7, "isa?", 4);
	      DEFINE_STRING(BGl_string3239z00zz__evaluatez00,
		BgL_bgl_string3239za700za7za7_3312za7, "if", 2);
	      DEFINE_STRING(BGl_string3241z00zz__evaluatez00,
		BgL_bgl_string3241za700za7za7_3313za7, "let", 3);
	      DEFINE_STRING(BGl_string3243z00zz__evaluatez00,
		BgL_bgl_string3243za700za7za7_3314za7, "lambda", 6);
	      DEFINE_STRING(BGl_string3245z00zz__evaluatez00,
		BgL_bgl_string3245za700za7za7_3315za7, "bigloo-type-error/location", 26);
	      DEFINE_STRING(BGl_string3247z00zz__evaluatez00,
		BgL_bgl_string3247za700za7za7_3316za7, "bigloo-type-error", 17);
	      DEFINE_STRING(BGl_string3249z00zz__evaluatez00,
		BgL_bgl_string3249za700za7za7_3317za7, "at", 2);
	      DEFINE_STRING(BGl_string3251z00zz__evaluatez00,
		BgL_bgl_string3251za700za7za7_3318za7, "tmp", 3);
	      DEFINE_STRING(BGl_string3252z00zz__evaluatez00,
		BgL_bgl_string3252za700za7za7_3319za7, "~a::~a", 6);
	      DEFINE_STRING(BGl_string3253z00zz__evaluatez00,
		BgL_bgl_string3253za700za7za7_3320za7, "Illegal form", 12);
	      DEFINE_STRING(BGl_string3255z00zz__evaluatez00,
		BgL_bgl_string3255za700za7za7_3321za7, "begin", 5);
	      DEFINE_STRING(BGl_string3257z00zz__evaluatez00,
		BgL_bgl_string3257za700za7za7_3322za7, " ", 1);
	      DEFINE_STRING(BGl_string3258z00zz__evaluatez00,
		BgL_bgl_string3258za700za7za7_3323za7,
		"Illegal non toplevel module declaration", 39);
	      DEFINE_STRING(BGl_string3260z00zz__evaluatez00,
		BgL_bgl_string3260za700za7za7_3324za7, "module", 6);
	      DEFINE_STRING(BGl_string3262z00zz__evaluatez00,
		BgL_bgl_string3262za700za7za7_3325za7, "@", 1);
	      DEFINE_STRING(BGl_string3264z00zz__evaluatez00,
		BgL_bgl_string3264za700za7za7_3326za7, "->", 2);
	      DEFINE_STRING(BGl_string3266z00zz__evaluatez00,
		BgL_bgl_string3266za700za7za7_3327za7, "trap", 4);
	      DEFINE_STRING(BGl_string3268z00zz__evaluatez00,
		BgL_bgl_string3268za700za7za7_3328za7, "or", 2);
	      DEFINE_STRING(BGl_string3270z00zz__evaluatez00,
		BgL_bgl_string3270za700za7za7_3329za7, "and", 3);
	      DEFINE_STRING(BGl_string3272z00zz__evaluatez00,
		BgL_bgl_string3272za700za7za7_3330za7, "let*", 4);
	      DEFINE_STRING(BGl_string3274z00zz__evaluatez00,
		BgL_bgl_string3274za700za7za7_3331za7, "letrec", 6);
	      DEFINE_STRING(BGl_string3276z00zz__evaluatez00,
		BgL_bgl_string3276za700za7za7_3332za7, "set!", 4);
	      DEFINE_STRING(BGl_string3278z00zz__evaluatez00,
		BgL_bgl_string3278za700za7za7_3333za7, "define", 6);
	      DEFINE_STRING(BGl_string3280z00zz__evaluatez00,
		BgL_bgl_string3280za700za7za7_3334za7, "bind-exit", 9);
	      DEFINE_STRING(BGl_string3282z00zz__evaluatez00,
		BgL_bgl_string3282za700za7za7_3335za7, "unwind-protect", 14);
	      DEFINE_STRING(BGl_string3284z00zz__evaluatez00,
		BgL_bgl_string3284za700za7za7_3336za7, "with-handler", 12);
	      DEFINE_STRING(BGl_string3286z00zz__evaluatez00,
		BgL_bgl_string3286za700za7za7_3337za7, "synchronize", 11);
	      DEFINE_STRING(BGl_string3288z00zz__evaluatez00,
		BgL_bgl_string3288za700za7za7_3338za7, "prelock", 7);
	      DEFINE_STRING(BGl_string3290z00zz__evaluatez00,
		BgL_bgl_string3290za700za7za7_3339za7, "\\@", 2);
	      DEFINE_STRING(BGl_string3291z00zz__evaluatez00,
		BgL_bgl_string3291za700za7za7_3340za7, "__evaluate", 10);
	extern obj_t BGl_errorzd2envzd2zz__errorz00;
	   
		 
		DEFINE_STRING(BGl_string3170z00zz__evaluatez00,
		BgL_bgl_string3170za700za7za7_3341za7, "", 0);
	      DEFINE_STRING(BGl_string3171z00zz__evaluatez00,
		BgL_bgl_string3171za700za7za7_3342za7,
		"/tmp/bigloo/runtime/Eval/evaluate.scm", 37);
	      DEFINE_STRING(BGl_string3172z00zz__evaluatez00,
		BgL_bgl_string3172za700za7za7_3343za7, "&evaluate2-restore-bp!", 22);
	      DEFINE_STRING(BGl_string3173z00zz__evaluatez00,
		BgL_bgl_string3173za700za7za7_3344za7, "bint", 4);
	      DEFINE_STRING(BGl_string3174z00zz__evaluatez00,
		BgL_bgl_string3174za700za7za7_3345za7, "&evaluate2-restore-state!", 25);
	      DEFINE_STRING(BGl_string3175z00zz__evaluatez00,
		BgL_bgl_string3175za700za7za7_3346za7, "vector", 6);
	      DEFINE_STRING(BGl_string3177z00zz__evaluatez00,
		BgL_bgl_string3177za700za7za7_3347za7, "toplevel", 8);
	      DEFINE_STRING(BGl_string3178z00zz__evaluatez00,
		BgL_bgl_string3178za700za7za7_3348za7, "eval", 4);
	      DEFINE_STRING(BGl_string3179z00zz__evaluatez00,
		BgL_bgl_string3179za700za7za7_3349za7, "Bad syntax", 10);
	      DEFINE_STRING(BGl_string3180z00zz__evaluatez00,
		BgL_bgl_string3180za700za7za7_3350za7, "Class \"~a\" has no field \"~a\"",
		28);
	      DEFINE_STRING(BGl_string3181z00zz__evaluatez00,
		BgL_bgl_string3181za700za7za7_3351za7, "Static type not a class", 23);
	      DEFINE_STRING(BGl_string3182z00zz__evaluatez00,
		BgL_bgl_string3182za700za7za7_3352za7, "Variable unbound", 16);
	      DEFINE_STRING(BGl_string3183z00zz__evaluatez00,
		BgL_bgl_string3183za700za7za7_3353za7, "Field read-only", 15);
	      DEFINE_STRING(BGl_string3185z00zz__evaluatez00,
		BgL_bgl_string3185za700za7za7_3354za7, "pair", 4);
	      DEFINE_STRING(BGl_string3187z00zz__evaluatez00,
		BgL_bgl_string3187za700za7za7_3355za7, "pair?", 5);
	      DEFINE_STRING(BGl_string3190z00zz__evaluatez00,
		BgL_bgl_string3190za700za7za7_3356za7, "vector?", 7);
	      DEFINE_STRING(BGl_string3192z00zz__evaluatez00,
		BgL_bgl_string3192za700za7za7_3357za7, "symbol", 6);
	      DEFINE_STRING(BGl_string3194z00zz__evaluatez00,
		BgL_bgl_string3194za700za7za7_3358za7, "symbol?", 7);
	      DEFINE_STRING(BGl_string3196z00zz__evaluatez00,
		BgL_bgl_string3196za700za7za7_3359za7, "char", 4);
	      DEFINE_STRING(BGl_string3198z00zz__evaluatez00,
		BgL_bgl_string3198za700za7za7_3360za7, "char?", 5);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_setzd2evaluationzd2contextz12zd2envzc0zz__evaluatez00,
		BgL_bgl_za762setza7d2evaluat3361z00,
		BGl_z62setzd2evaluationzd2contextz12z70zz__evaluatez00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_evaluate2zd2restorezd2statez12zd2envzc0zz__evaluatez00,
		BgL_bgl_za762evaluate2za7d2r3362z00,
		BGl_z62evaluate2zd2restorezd2statez12z70zz__evaluatez00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_getzd2evaluationzd2contextzd2envzd2zz__evaluatez00,
		BgL_bgl_za762getza7d2evaluat3363z00,
		BGl_z62getzd2evaluationzd2contextz62zz__evaluatez00, 0L, BUNSPEC, 0);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_evaluate2zd2envzd2zz__evaluatez00,
		BgL_bgl_za762evaluate2za762za73364za7, BGl_z62evaluate2z62zz__evaluatez00,
		0L, BUNSPEC, 3);

/* GC roots registration */
	static obj_t bgl_gc_roots_register()
	{
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
		void *roots_min = (void *) ULONG_MAX, *roots_max = 0;
		     ADD_ROOT((void *) (&BGl_symbol3176z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3184z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3186z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3188z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3189z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3191z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3193z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3195z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3197z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3199z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_requirezd2initializa7ationz75zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3201z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3202z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3204z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3206z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3208z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3210z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3212z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3214z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3216z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3218z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3220z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3222z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3224z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3226z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3228z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3230z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3232z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3234z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3236z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3238z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_keyword3287z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3240z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3242z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3244z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3246z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3248z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3250z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3254z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3256z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3259z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3261z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3263z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3265z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3267z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3269z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3271z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3273z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3275z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3277z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3279z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3281z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3283z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3285z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3289z00zz__evaluatez00));
#undef ADD_ROOT
		if   (roots_max > 0)
			     GC_add_roots(roots_min, ((void **) roots_max) + 1);
#endif
		     return BUNSPEC;
	}



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__evaluatez00(long
		BgL_checksumz00_4956, char *BgL_fromz00_4957)
	{
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zz__evaluatez00))
				{
					BGl_requirezd2initializa7ationz75zz__evaluatez00 =
						BBOOL(((bool_t) 0));
					BGl_gczd2rootszd2initz00zz__evaluatez00();
					BGl_cnstzd2initzd2zz__evaluatez00();
					BGl_importedzd2moduleszd2initz00zz__evaluatez00();
					return BGl_methodzd2initzd2zz__evaluatez00();
				}
			else
				{
					return BUNSPEC;
				}
		}

	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zz__evaluatez00()
	{
		{	/* Eval/evaluate.scm 15 */
			BGl_symbol3176z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3177z00zz__evaluatez00);
			BGl_symbol3184z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3185z00zz__evaluatez00);
			BGl_symbol3186z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3187z00zz__evaluatez00);
			BGl_symbol3188z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3175z00zz__evaluatez00);
			BGl_symbol3189z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3190z00zz__evaluatez00);
			BGl_symbol3191z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3192z00zz__evaluatez00);
			BGl_symbol3193z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3194z00zz__evaluatez00);
			BGl_symbol3195z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3196z00zz__evaluatez00);
			BGl_symbol3197z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3198z00zz__evaluatez00);
			BGl_symbol3199z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3200z00zz__evaluatez00);
			BGl_symbol3201z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3173z00zz__evaluatez00);
			BGl_symbol3202z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3203z00zz__evaluatez00);
			BGl_symbol3204z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3205z00zz__evaluatez00);
			BGl_symbol3206z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3207z00zz__evaluatez00);
			BGl_symbol3208z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3209z00zz__evaluatez00);
			BGl_symbol3210z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3211z00zz__evaluatez00);
			BGl_symbol3212z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3213z00zz__evaluatez00);
			BGl_symbol3214z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3215z00zz__evaluatez00);
			BGl_symbol3216z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3217z00zz__evaluatez00);
			BGl_symbol3218z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3219z00zz__evaluatez00);
			BGl_symbol3220z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3221z00zz__evaluatez00);
			BGl_symbol3222z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3223z00zz__evaluatez00);
			BGl_symbol3224z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3225z00zz__evaluatez00);
			BGl_symbol3226z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3227z00zz__evaluatez00);
			BGl_symbol3228z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3229z00zz__evaluatez00);
			BGl_symbol3230z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3231z00zz__evaluatez00);
			BGl_symbol3232z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3233z00zz__evaluatez00);
			BGl_symbol3234z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3235z00zz__evaluatez00);
			BGl_symbol3236z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3237z00zz__evaluatez00);
			BGl_symbol3238z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3239z00zz__evaluatez00);
			BGl_symbol3240z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3241z00zz__evaluatez00);
			BGl_symbol3242z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3243z00zz__evaluatez00);
			BGl_symbol3244z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3245z00zz__evaluatez00);
			BGl_symbol3246z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3247z00zz__evaluatez00);
			BGl_symbol3248z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3249z00zz__evaluatez00);
			BGl_symbol3250z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3251z00zz__evaluatez00);
			BGl_symbol3254z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3255z00zz__evaluatez00);
			BGl_symbol3256z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3257z00zz__evaluatez00);
			BGl_symbol3259z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3260z00zz__evaluatez00);
			BGl_symbol3261z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3262z00zz__evaluatez00);
			BGl_symbol3263z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3264z00zz__evaluatez00);
			BGl_symbol3265z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3266z00zz__evaluatez00);
			BGl_symbol3267z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3268z00zz__evaluatez00);
			BGl_symbol3269z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3270z00zz__evaluatez00);
			BGl_symbol3271z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3272z00zz__evaluatez00);
			BGl_symbol3273z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3274z00zz__evaluatez00);
			BGl_symbol3275z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3276z00zz__evaluatez00);
			BGl_symbol3277z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3278z00zz__evaluatez00);
			BGl_symbol3279z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3280z00zz__evaluatez00);
			BGl_symbol3281z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3282z00zz__evaluatez00);
			BGl_symbol3283z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3284z00zz__evaluatez00);
			BGl_symbol3285z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3286z00zz__evaluatez00);
			BGl_keyword3287z00zz__evaluatez00 =
				bstring_to_keyword(BGl_string3288z00zz__evaluatez00);
			return (BGl_symbol3289z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3290z00zz__evaluatez00), BUNSPEC);
		}

	}



/* gc-roots-init */
	obj_t BGl_gczd2rootszd2initz00zz__evaluatez00()
	{
		{	/* Eval/evaluate.scm 15 */
			return bgl_gc_roots_register();
		}

	}



/* append-21011 */
	obj_t BGl_appendzd221011zd2zz__evaluatez00(obj_t BgL_l1z00_1,
		obj_t BgL_l2z00_2)
	{
		{
			{
				obj_t BgL_headz00_1137;

				BgL_headz00_1137 = MAKE_YOUNG_PAIR(BNIL, BgL_l2z00_2);
				{
					obj_t BgL_prevz00_3129;
					obj_t BgL_tailz00_3130;

					BgL_prevz00_3129 = BgL_headz00_1137;
					BgL_tailz00_3130 = BgL_l1z00_1;
				BgL_loopz00_3128:
					if (PAIRP(BgL_tailz00_3130))
						{
							obj_t BgL_newzd2prevzd2_3136;

							BgL_newzd2prevzd2_3136 =
								MAKE_YOUNG_PAIR(CAR(BgL_tailz00_3130), BgL_l2z00_2);
							SET_CDR(BgL_prevz00_3129, BgL_newzd2prevzd2_3136);
							{
								obj_t BgL_tailz00_5027;
								obj_t BgL_prevz00_5026;

								BgL_prevz00_5026 = BgL_newzd2prevzd2_3136;
								BgL_tailz00_5027 = CDR(BgL_tailz00_3130);
								BgL_tailz00_3130 = BgL_tailz00_5027;
								BgL_prevz00_3129 = BgL_prevz00_5026;
								goto BgL_loopz00_3128;
							}
						}
					else
						{
							BNIL;
						}
				}
				return CDR(BgL_headz00_1137);
			}
		}

	}



/* untype-ident */
	obj_t BGl_untypezd2identzd2zz__evaluatez00(obj_t BgL_idz00_3)
	{
		{	/* Eval/evaluate.scm 73 */
			{	/* Eval/evaluate.scm 74 */
				obj_t BgL_stringz00_1145;

				{	/* Eval/evaluate.scm 74 */
					obj_t BgL_res2792z00_3146;

					{	/* Eval/evaluate.scm 74 */
						obj_t BgL_arg2602z00_3145;

						BgL_arg2602z00_3145 = SYMBOL_TO_STRING(BgL_idz00_3);
						BgL_res2792z00_3146 =
							BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg2602z00_3145);
					}
					BgL_stringz00_1145 = BgL_res2792z00_3146;
				}
				{	/* Eval/evaluate.scm 74 */
					long BgL_lenz00_1146;

					BgL_lenz00_1146 = STRING_LENGTH(BgL_stringz00_1145);
					{	/* Eval/evaluate.scm 75 */

						{
							long BgL_walkerz00_1148;

							BgL_walkerz00_1148 = ((long) 0);
						BgL_zc3z04anonymousza31311ze3z87_1149:
							if ((BgL_walkerz00_1148 == BgL_lenz00_1146))
								{	/* Eval/evaluate.scm 78 */
									return MAKE_YOUNG_PAIR(BgL_idz00_3, BFALSE);
								}
							else
								{	/* Eval/evaluate.scm 80 */
									bool_t BgL_test3368z00_5036;

									if (
										(STRING_REF(BgL_stringz00_1145,
												BgL_walkerz00_1148) == ((unsigned char) ':')))
										{	/* Eval/evaluate.scm 80 */
											if ((BgL_walkerz00_1148 < (BgL_lenz00_1146 - ((long) 1))))
												{	/* Eval/evaluate.scm 81 */
													BgL_test3368z00_5036 =
														(STRING_REF(BgL_stringz00_1145,
															(BgL_walkerz00_1148 + ((long) 1))) ==
														((unsigned char) ':'));
												}
											else
												{	/* Eval/evaluate.scm 81 */
													BgL_test3368z00_5036 = ((bool_t) 0);
												}
										}
									else
										{	/* Eval/evaluate.scm 80 */
											BgL_test3368z00_5036 = ((bool_t) 0);
										}
									if (BgL_test3368z00_5036)
										{	/* Eval/evaluate.scm 83 */
											obj_t BgL_arg1324z00_1160;
											obj_t BgL_arg1325z00_1161;

											BgL_arg1324z00_1160 =
												bstring_to_symbol(c_substring(BgL_stringz00_1145,
													((long) 0), BgL_walkerz00_1148));
											{	/* Eval/evaluate.scm 84 */
												obj_t BgL_arg1327z00_1163;

												{	/* Eval/evaluate.scm 84 */
													long BgL_arg1329z00_1164;

													BgL_arg1329z00_1164 =
														(BgL_walkerz00_1148 + ((long) 2));
													{	/* Ieee/string.scm 189 */
														long BgL_endz00_1167;

														BgL_endz00_1167 = STRING_LENGTH(BgL_stringz00_1145);
														{	/* Ieee/string.scm 189 */

															BgL_arg1327z00_1163 =
																BGl_substringz00zz__r4_strings_6_7z00
																(BgL_stringz00_1145, BgL_arg1329z00_1164,
																BgL_endz00_1167);
												}}}
												BgL_arg1325z00_1161 =
													bstring_to_symbol(BgL_arg1327z00_1163);
											}
											return
												MAKE_YOUNG_PAIR(BgL_arg1324z00_1160,
												BgL_arg1325z00_1161);
										}
									else
										{
											long BgL_walkerz00_5053;

											BgL_walkerz00_5053 = (BgL_walkerz00_1148 + ((long) 1));
											BgL_walkerz00_1148 = BgL_walkerz00_5053;
											goto BgL_zc3z04anonymousza31311ze3z87_1149;
										}
								}
						}
					}
				}
			}
		}

	}



/* get-evaluation-context */
	BGL_EXPORTED_DEF obj_t BGl_getzd2evaluationzd2contextz00zz__evaluatez00()
	{
		{	/* Eval/evaluate.scm 91 */
			{	/* Eval/evaluate.scm 92 */
				obj_t BgL_sz00_1176;

				BgL_sz00_1176 = BGl_findzd2statezd2zz__evaluate_compz00();
				{	/* Eval/evaluate.scm 93 */
					obj_t BgL_bpz00_1177;

					BgL_bpz00_1177 = VECTOR_REF(((obj_t) BgL_sz00_1176), ((long) 0));
					{	/* Eval/evaluate.scm 94 */
						obj_t BgL_rz00_1178;

						BgL_rz00_1178 =
							make_vector(
							(long) CINT(BgL_bpz00_1177), BGl_string3170z00zz__evaluatez00);
						{
							long BgL_iz00_3195;

							BgL_iz00_3195 = ((long) 0);
						BgL_recz00_3194:
							if ((BgL_iz00_3195 < (long) CINT(BgL_bpz00_1177)))
								{	/* Eval/evaluate.scm 96 */
									{	/* Eval/evaluate.scm 97 */
										obj_t BgL_arg1339z00_3200;

										BgL_arg1339z00_3200 =
											VECTOR_REF(((obj_t) BgL_sz00_1176), BgL_iz00_3195);
										VECTOR_SET(BgL_rz00_1178, BgL_iz00_3195,
											BgL_arg1339z00_3200);
									}
									{
										long BgL_iz00_5066;

										BgL_iz00_5066 = (BgL_iz00_3195 + ((long) 1));
										BgL_iz00_3195 = BgL_iz00_5066;
										goto BgL_recz00_3194;
									}
								}
							else
								{	/* Eval/evaluate.scm 96 */
									((bool_t) 0);
								}
						}
						return BgL_rz00_1178;
					}
				}
			}
		}

	}



/* &get-evaluation-context */
	obj_t BGl_z62getzd2evaluationzd2contextz62zz__evaluatez00(obj_t
		BgL_envz00_4913)
	{
		{	/* Eval/evaluate.scm 91 */
			return BGl_getzd2evaluationzd2contextz00zz__evaluatez00();
		}

	}



/* set-evaluation-context! */
	BGL_EXPORTED_DEF obj_t
		BGl_setzd2evaluationzd2contextz12z12zz__evaluatez00(obj_t BgL_vz00_4)
	{
		{	/* Eval/evaluate.scm 104 */
			{	/* Eval/evaluate.scm 105 */
				obj_t BgL_sz00_1186;

				BgL_sz00_1186 = BGl_findzd2statezd2zz__evaluate_compz00();
				{	/* Eval/evaluate.scm 106 */
					obj_t BgL_bpz00_1187;

					BgL_bpz00_1187 = VECTOR_REF(((obj_t) BgL_vz00_4), ((long) 0));
					{
						long BgL_iz00_3219;

						{	/* Eval/evaluate.scm 107 */
							bool_t BgL_tmpz00_5072;

							BgL_iz00_3219 = ((long) 0);
						BgL_recz00_3218:
							if ((BgL_iz00_3219 < (long) CINT(BgL_bpz00_1187)))
								{	/* Eval/evaluate.scm 108 */
									{	/* Eval/evaluate.scm 109 */
										obj_t BgL_arg1343z00_3224;

										BgL_arg1343z00_3224 =
											VECTOR_REF(((obj_t) BgL_vz00_4), BgL_iz00_3219);
										VECTOR_SET(
											((obj_t) BgL_sz00_1186), BgL_iz00_3219,
											BgL_arg1343z00_3224);
									}
									{
										long BgL_iz00_5080;

										BgL_iz00_5080 = (BgL_iz00_3219 + ((long) 1));
										BgL_iz00_3219 = BgL_iz00_5080;
										goto BgL_recz00_3218;
									}
								}
							else
								{	/* Eval/evaluate.scm 108 */
									BgL_tmpz00_5072 = ((bool_t) 0);
								}
							return BBOOL(BgL_tmpz00_5072);
						}
					}
				}
			}
		}

	}



/* &set-evaluation-context! */
	obj_t BGl_z62setzd2evaluationzd2contextz12z70zz__evaluatez00(obj_t
		BgL_envz00_4914, obj_t BgL_vz00_4915)
	{
		{	/* Eval/evaluate.scm 104 */
			return BGl_setzd2evaluationzd2contextz12z12zz__evaluatez00(BgL_vz00_4915);
		}

	}



/* evaluate2-restore-bp! */
	BGL_EXPORTED_DEF obj_t BGl_evaluate2zd2restorezd2bpz12z12zz__evaluatez00(int
		BgL_bpz00_5)
	{
		{	/* Eval/evaluate.scm 115 */
			{	/* Eval/evaluate.scm 116 */
				obj_t BgL_sz00_3232;

				{	/* Eval/evaluate.scm 116 */
					obj_t BgL_tmpz00_5084;

					BgL_tmpz00_5084 = BGL_CURRENT_DYNAMIC_ENV();
					BgL_sz00_3232 = BGL_ENV_EVSTATE(BgL_tmpz00_5084);
				}
				return
					VECTOR_SET(((obj_t) BgL_sz00_3232), ((long) 0), BINT(BgL_bpz00_5));
		}}

	}



/* &evaluate2-restore-bp! */
	obj_t BGl_z62evaluate2zd2restorezd2bpz12z70zz__evaluatez00(obj_t
		BgL_envz00_4916, obj_t BgL_bpz00_4917)
	{
		{	/* Eval/evaluate.scm 115 */
			{	/* Eval/evaluate.scm 116 */
				int BgL_auxz00_5090;

				{	/* Eval/evaluate.scm 116 */
					obj_t BgL_tmpz00_5091;

					if (INTEGERP(BgL_bpz00_4917))
						{	/* Eval/evaluate.scm 116 */
							BgL_tmpz00_5091 = BgL_bpz00_4917;
						}
					else
						{
							obj_t BgL_auxz00_5094;

							BgL_auxz00_5094 =
								BGl_typezd2errorzd2zz__errorz00
								(BGl_string3171z00zz__evaluatez00, BINT(((long) 3890)),
								BGl_string3172z00zz__evaluatez00,
								BGl_string3173z00zz__evaluatez00, BgL_bpz00_4917);
							FAILURE(BgL_auxz00_5094, BFALSE, BFALSE);
						}
					BgL_auxz00_5090 = CINT(BgL_tmpz00_5091);
				}
				return
					BGl_evaluate2zd2restorezd2bpz12z12zz__evaluatez00(BgL_auxz00_5090);
			}
		}

	}



/* evaluate2-restore-state! */
	BGL_EXPORTED_DEF obj_t
		BGl_evaluate2zd2restorezd2statez12z12zz__evaluatez00(obj_t BgL_statez00_6)
	{
		{	/* Eval/evaluate.scm 122 */
			{	/* Eval/evaluate.scm 124 */
				obj_t BgL_tmpz00_5100;

				BgL_tmpz00_5100 = BGL_CURRENT_DYNAMIC_ENV();
				return BGL_ENV_EVSTATE_SET(BgL_tmpz00_5100, BgL_statez00_6);
			}
		}

	}



/* &evaluate2-restore-state! */
	obj_t BGl_z62evaluate2zd2restorezd2statez12z70zz__evaluatez00(obj_t
		BgL_envz00_4918, obj_t BgL_statez00_4919)
	{
		{	/* Eval/evaluate.scm 122 */
			{	/* Eval/evaluate.scm 123 */
				obj_t BgL_auxz00_5103;

				if (VECTORP(BgL_statez00_4919))
					{	/* Eval/evaluate.scm 123 */
						BgL_auxz00_5103 = BgL_statez00_4919;
					}
				else
					{
						obj_t BgL_auxz00_5106;

						BgL_auxz00_5106 =
							BGl_typezd2errorzd2zz__errorz00(BGl_string3171z00zz__evaluatez00,
							BINT(((long) 4240)), BGl_string3174z00zz__evaluatez00,
							BGl_string3175z00zz__evaluatez00, BgL_statez00_4919);
						FAILURE(BgL_auxz00_5106, BFALSE, BFALSE);
					}
				return
					BGl_evaluate2zd2restorezd2statez12z12zz__evaluatez00(BgL_auxz00_5103);
			}
		}

	}



/* evaluate2 */
	BGL_EXPORTED_DEF obj_t BGl_evaluate2z00zz__evaluatez00(obj_t BgL_sexpz00_7,
		obj_t BgL_envz00_8, obj_t BgL_locz00_9)
	{
		{	/* Eval/evaluate.scm 129 */
			{	/* Eval/evaluate.scm 130 */
				BgL_ev_exprz00_bglt BgL_astz00_1198;

				{	/* Eval/evaluate.scm 130 */
					obj_t BgL_arg1347z00_1208;

					BgL_arg1347z00_1208 =
						BGl_convz00zz__evaluatez00(BgL_sexpz00_7, BNIL, BgL_envz00_8,
						BFALSE, BGl_symbol3176z00zz__evaluatez00, BgL_locz00_9,
						((bool_t) 1));
					BgL_astz00_1198 =
						BGl_extractzd2loopszd2zz__evaluate_fsiza7eza7(((BgL_ev_exprz00_bglt)
							BgL_arg1347z00_1208));
				}
				BGl_analysezd2varszd2zz__evaluate_avarz00(BgL_astz00_1198);
				{	/* Eval/evaluate.scm 132 */
					int BgL_nz00_1199;

					BgL_nz00_1199 =
						BGl_framezd2siza7ez75zz__evaluate_fsiza7eza7(BgL_astz00_1198);
					{	/* Eval/evaluate.scm 133 */
						obj_t BgL_fz00_1200;

						BgL_fz00_1200 = BGl_compilez00zz__evaluate_compz00(BgL_astz00_1198);
						{	/* Eval/evaluate.scm 134 */
							obj_t BgL_sz00_1201;

							BgL_sz00_1201 = BGl_findzd2statezd2zz__evaluate_compz00();
							{	/* Eval/evaluate.scm 135 */
								obj_t BgL_bpz00_1202;

								BgL_bpz00_1202 =
									VECTOR_REF(((obj_t) BgL_sz00_1201), ((long) 0));
								{	/* Eval/evaluate.scm 136 */
									obj_t BgL_exitd1065z00_1203;

									BgL_exitd1065z00_1203 = BGL_EXITD_TOP_AS_OBJ();
									{	/* Eval/evaluate.scm 138 */
										obj_t BgL_zc3z04anonymousza31346ze3z87_4920;

										BgL_zc3z04anonymousza31346ze3z87_4920 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza31346ze3ze5zz__evaluatez00,
											(int) (((long) 0)), (int) (((long) 2)));
										PROCEDURE_SET(BgL_zc3z04anonymousza31346ze3z87_4920,
											(int) (((long) 0)), BgL_sz00_1201);
										PROCEDURE_SET(BgL_zc3z04anonymousza31346ze3z87_4920,
											(int) (((long) 1)), BgL_bpz00_1202);
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
											(BgL_exitd1065z00_1203,
											BgL_zc3z04anonymousza31346ze3z87_4920);
										{	/* Eval/evaluate.scm 137 */
											obj_t BgL_tmp1067z00_1205;

											BgL_tmp1067z00_1205 =
												PROCEDURE_ENTRY(BgL_fz00_1200) (BgL_fz00_1200,
												BgL_sz00_1201, BEOA);
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_exitd1065z00_1203);
											VECTOR_SET(((obj_t) BgL_sz00_1201), ((long) 0),
												BgL_bpz00_1202);
											return BgL_tmp1067z00_1205;
										}
									}
								}
							}
						}
					}
				}
			}
		}

	}



/* &evaluate2 */
	obj_t BGl_z62evaluate2z62zz__evaluatez00(obj_t BgL_envz00_4921,
		obj_t BgL_sexpz00_4922, obj_t BgL_envz00_4923, obj_t BgL_locz00_4924)
	{
		{	/* Eval/evaluate.scm 129 */
			return
				BGl_evaluate2z00zz__evaluatez00(BgL_sexpz00_4922, BgL_envz00_4923,
				BgL_locz00_4924);
		}

	}



/* &<@anonymous:1346> */
	obj_t BGl_z62zc3z04anonymousza31346ze3ze5zz__evaluatez00(obj_t
		BgL_envz00_4925)
	{
		{	/* Eval/evaluate.scm 136 */
			{	/* Eval/evaluate.scm 138 */
				obj_t BgL_sz00_4926;
				obj_t BgL_bpz00_4927;

				BgL_sz00_4926 = PROCEDURE_REF(BgL_envz00_4925, (int) (((long) 0)));
				BgL_bpz00_4927 = PROCEDURE_REF(BgL_envz00_4925, (int) (((long) 1)));
				return VECTOR_SET(((obj_t) BgL_sz00_4926), ((long) 0), BgL_bpz00_4927);
		}}

	}



/* get-location */
	obj_t BGl_getzd2locationzd2zz__evaluatez00(obj_t BgL_expz00_10,
		obj_t BgL_locz00_11)
	{
		{	/* Eval/evaluate.scm 143 */
			{	/* Eval/evaluate.scm 144 */
				obj_t BgL__ortest_1068z00_3241;

				BgL__ortest_1068z00_3241 =
					BGl_getzd2sourcezd2locationz00zz__readerz00(BgL_expz00_10);
				if (CBOOL(BgL__ortest_1068z00_3241))
					{	/* Eval/evaluate.scm 144 */
						return BgL__ortest_1068z00_3241;
					}
				else
					{	/* Eval/evaluate.scm 144 */
						return BgL_locz00_11;
					}
			}
		}

	}



/* conv-var */
	obj_t BGl_convzd2varzd2zz__evaluatez00(obj_t BgL_vz00_18,
		obj_t BgL_localsz00_19)
	{
		{	/* Eval/evaluate.scm 163 */
			{
				obj_t BgL_lz00_1213;

				BgL_lz00_1213 = BgL_localsz00_19;
			BgL_zc3z04anonymousza31348ze3z87_1214:
				if (NULLP(BgL_lz00_1213))
					{	/* Eval/evaluate.scm 165 */
						return BFALSE;
					}
				else
					{	/* Eval/evaluate.scm 167 */
						obj_t BgL_rvz00_1216;

						BgL_rvz00_1216 = CAR(((obj_t) BgL_lz00_1213));
						if (
							(BgL_vz00_18 ==
								(((BgL_ev_varz00_bglt) COBJECT(
											((BgL_ev_varz00_bglt) BgL_rvz00_1216)))->BgL_namez00)))
							{	/* Eval/evaluate.scm 169 */
								return BgL_rvz00_1216;
							}
						else
							{
								obj_t BgL_lz00_5154;

								BgL_lz00_5154 = CDR(((obj_t) BgL_lz00_1213));
								BgL_lz00_1213 = BgL_lz00_5154;
								goto BgL_zc3z04anonymousza31348ze3z87_1214;
							}
					}
			}
		}

	}



/* conv-begin */
	obj_t BGl_convzd2beginzd2zz__evaluatez00(obj_t BgL_lz00_20,
		obj_t BgL_localsz00_21, obj_t BgL_globalsz00_22, obj_t BgL_tailzf3zf3_23,
		obj_t BgL_wherez00_24, obj_t BgL_locz00_25, bool_t BgL_topzf3zf3_26)
	{
		{	/* Eval/evaluate.scm 176 */
			{	/* Eval/evaluate.scm 177 */
				obj_t BgL_locz00_1223;

				{	/* Eval/evaluate.scm 144 */
					obj_t BgL__ortest_1068z00_3247;

					BgL__ortest_1068z00_3247 =
						BGl_getzd2sourcezd2locationz00zz__readerz00(BgL_lz00_20);
					if (CBOOL(BgL__ortest_1068z00_3247))
						{	/* Eval/evaluate.scm 144 */
							BgL_locz00_1223 = BgL__ortest_1068z00_3247;
						}
					else
						{	/* Eval/evaluate.scm 144 */
							BgL_locz00_1223 = BgL_locz00_25;
						}
				}
				{
					obj_t BgL_e1z00_1227;
					obj_t BgL_rz00_1228;

					if (NULLP(BgL_lz00_20))
						{
							BgL_ev_littz00_bglt BgL_auxz00_5162;

							{	/* Eval/evaluate.scm 180 */
								BgL_ev_littz00_bglt BgL_new1073z00_1240;

								{	/* Eval/evaluate.scm 181 */
									BgL_ev_littz00_bglt BgL_new1072z00_1241;

									BgL_new1072z00_1241 =
										((BgL_ev_littz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
													BgL_ev_littz00_bgl))));
									{	/* Eval/evaluate.scm 181 */
										long BgL_arg1362z00_1242;

										{	/* Eval/evaluate.scm 181 */
											long BgL_res2815z00_3249;

											BgL_res2815z00_3249 =
												BGL_CLASS_INDEX(BGl_ev_littz00zz__evaluate_typesz00);
											BgL_arg1362z00_1242 = BgL_res2815z00_3249;
										}
										BGL_OBJECT_CLASS_NUM_SET(
											((BgL_objectz00_bglt) BgL_new1072z00_1241),
											BgL_arg1362z00_1242);
									}
									BgL_new1073z00_1240 = BgL_new1072z00_1241;
								}
								((((BgL_ev_littz00_bglt) COBJECT(BgL_new1073z00_1240))->
										BgL_valuez00) = ((obj_t) BUNSPEC), BUNSPEC);
								BgL_auxz00_5162 = BgL_new1073z00_1240;
							}
							return ((obj_t) BgL_auxz00_5162);
						}
					else
						{	/* Eval/evaluate.scm 178 */
							if (PAIRP(BgL_lz00_20))
								{	/* Eval/evaluate.scm 178 */
									if (NULLP(CDR(BgL_lz00_20)))
										{	/* Eval/evaluate.scm 178 */
											obj_t BgL_arg1358z00_1236;

											BgL_arg1358z00_1236 = CAR(BgL_lz00_20);
											{	/* Eval/evaluate.scm 183 */
												obj_t BgL_arg1363z00_3264;

												{	/* Eval/evaluate.scm 144 */
													obj_t BgL__ortest_1068z00_3265;

													BgL__ortest_1068z00_3265 =
														BGl_getzd2sourcezd2locationz00zz__readerz00
														(BgL_arg1358z00_1236);
													if (CBOOL(BgL__ortest_1068z00_3265))
														{	/* Eval/evaluate.scm 144 */
															BgL_arg1363z00_3264 = BgL__ortest_1068z00_3265;
														}
													else
														{	/* Eval/evaluate.scm 144 */
															BgL_arg1363z00_3264 = BgL_locz00_1223;
														}
												}
												return
													BGl_convz00zz__evaluatez00(BgL_arg1358z00_1236,
													BgL_localsz00_21, BgL_globalsz00_22,
													BgL_tailzf3zf3_23, BgL_wherez00_24,
													BgL_arg1363z00_3264, BgL_topzf3zf3_26);
											}
										}
									else
										{	/* Eval/evaluate.scm 178 */
											obj_t BgL_arg1359z00_1237;
											obj_t BgL_arg1360z00_1238;

											BgL_arg1359z00_1237 = CAR(BgL_lz00_20);
											BgL_arg1360z00_1238 = CDR(BgL_lz00_20);
											{
												BgL_ev_prog2z00_bglt BgL_auxz00_5181;

												BgL_e1z00_1227 = BgL_arg1359z00_1237;
												BgL_rz00_1228 = BgL_arg1360z00_1238;
												{	/* Eval/evaluate.scm 185 */
													BgL_ev_prog2z00_bglt BgL_new1075z00_1244;

													{	/* Eval/evaluate.scm 186 */
														BgL_ev_prog2z00_bglt BgL_new1074z00_1246;

														BgL_new1074z00_1246 =
															((BgL_ev_prog2z00_bglt)
															BOBJECT(GC_MALLOC(sizeof(struct
																		BgL_ev_prog2z00_bgl))));
														{	/* Eval/evaluate.scm 186 */
															long BgL_arg1365z00_1247;

															{	/* Eval/evaluate.scm 186 */
																long BgL_res2816z00_3255;

																BgL_res2816z00_3255 =
																	BGL_CLASS_INDEX
																	(BGl_ev_prog2z00zz__evaluate_typesz00);
																BgL_arg1365z00_1247 = BgL_res2816z00_3255;
															}
															BGL_OBJECT_CLASS_NUM_SET(
																((BgL_objectz00_bglt) BgL_new1074z00_1246),
																BgL_arg1365z00_1247);
														}
														BgL_new1075z00_1244 = BgL_new1074z00_1246;
													}
													{
														BgL_ev_exprz00_bglt BgL_auxz00_5186;

														{	/* Eval/evaluate.scm 186 */
															obj_t BgL_arg1364z00_1245;

															{	/* Eval/evaluate.scm 144 */
																obj_t BgL__ortest_1068z00_3258;

																BgL__ortest_1068z00_3258 =
																	BGl_getzd2sourcezd2locationz00zz__readerz00
																	(BgL_e1z00_1227);
																if (CBOOL(BgL__ortest_1068z00_3258))
																	{	/* Eval/evaluate.scm 144 */
																		BgL_arg1364z00_1245 =
																			BgL__ortest_1068z00_3258;
																	}
																else
																	{	/* Eval/evaluate.scm 144 */
																		BgL_arg1364z00_1245 = BgL_locz00_1223;
																	}
															}
															BgL_auxz00_5186 =
																((BgL_ev_exprz00_bglt)
																BGl_convz00zz__evaluatez00(BgL_e1z00_1227,
																	BgL_localsz00_21, BgL_globalsz00_22, BFALSE,
																	BgL_wherez00_24, BgL_arg1364z00_1245,
																	BgL_topzf3zf3_26));
														}
														((((BgL_ev_prog2z00_bglt)
																	COBJECT(BgL_new1075z00_1244))->BgL_e1z00) =
															((BgL_ev_exprz00_bglt) BgL_auxz00_5186), BUNSPEC);
													}
													((((BgL_ev_prog2z00_bglt)
																COBJECT(BgL_new1075z00_1244))->BgL_e2z00) =
														((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt)
																BGl_convzd2beginzd2zz__evaluatez00
																(BgL_rz00_1228, BgL_localsz00_21,
																	BgL_globalsz00_22, BgL_tailzf3zf3_23,
																	BgL_wherez00_24, BgL_locz00_1223,
																	BgL_topzf3zf3_26))), BUNSPEC);
													BgL_auxz00_5181 = BgL_new1075z00_1244;
												}
												return ((obj_t) BgL_auxz00_5181);
											}
										}
								}
							else
								{	/* Eval/evaluate.scm 178 */
									return
										BGl_evcompilezd2errorzd2zz__evcompilez00(BgL_locz00_1223,
										BGl_string3178z00zz__evaluatez00,
										BGl_string3179z00zz__evaluatez00, BgL_lz00_20);
								}
						}
				}
			}
		}

	}



/* conv-field-ref */
	obj_t BGl_convzd2fieldzd2refz00zz__evaluatez00(obj_t BgL_ez00_30,
		obj_t BgL_localsz00_31, obj_t BgL_globalsz00_32, obj_t BgL_tailzf3zf3_33,
		obj_t BgL_wherez00_34, obj_t BgL_locz00_35, bool_t BgL_topzf3zf3_36)
	{
		{	/* Eval/evaluate.scm 203 */
			{	/* Eval/evaluate.scm 204 */
				obj_t BgL_lz00_1252;

				BgL_lz00_1252 = CDR(((obj_t) BgL_ez00_30));
				{	/* Eval/evaluate.scm 204 */
					obj_t BgL_vz00_1253;

					BgL_vz00_1253 =
						BGl_convzd2varzd2zz__evaluatez00(CAR(
							((obj_t) BgL_lz00_1252)), BgL_localsz00_31);
					{	/* Eval/evaluate.scm 205 */

						if (BGl_isazf3zf3zz__objectz00(BgL_vz00_1253,
								BGl_ev_varz00zz__evaluate_typesz00))
							{	/* Eval/evaluate.scm 208 */
								obj_t BgL_g1079z00_1256;
								obj_t BgL_g1080z00_1257;

								{	/* Eval/evaluate.scm 209 */
									obj_t BgL_arg1383z00_1280;

									BgL_arg1383z00_1280 =
										(((BgL_ev_varz00_bglt) COBJECT(
												((BgL_ev_varz00_bglt) BgL_vz00_1253)))->BgL_typez00);
									BgL_g1079z00_1256 =
										BGl_classzd2existszd2zz__objectz00(BgL_arg1383z00_1280);
								}
								BgL_g1080z00_1257 = CDR(((obj_t) BgL_lz00_1252));
								{
									BgL_ev_exprz00_bglt BgL_nodez00_1259;
									obj_t BgL_klassz00_1260;
									obj_t BgL_fieldsz00_1261;

									BgL_nodez00_1259 =
										((BgL_ev_exprz00_bglt)
										((BgL_ev_varz00_bglt) BgL_vz00_1253));
									BgL_klassz00_1260 = BgL_g1079z00_1256;
									BgL_fieldsz00_1261 = BgL_g1080z00_1257;
								BgL_zc3z04anonymousza31369ze3z87_1262:
									if (NULLP(BgL_fieldsz00_1261))
										{	/* Eval/evaluate.scm 212 */
											return ((obj_t) BgL_nodez00_1259);
										}
									else
										{	/* Eval/evaluate.scm 212 */
											if (BGl_classzf3zf3zz__objectz00(BgL_klassz00_1260))
												{	/* Eval/evaluate.scm 215 */
													obj_t BgL_fieldz00_1265;

													{	/* Eval/evaluate.scm 215 */
														obj_t BgL_arg1381z00_1276;

														BgL_arg1381z00_1276 =
															CAR(((obj_t) BgL_fieldsz00_1261));
														BgL_fieldz00_1265 =
															BGl_findzd2classzd2fieldz00zz__objectz00
															(BgL_klassz00_1260, BgL_arg1381z00_1276);
													}
													if (BGl_classzd2fieldzf3z21zz__objectz00
														(BgL_fieldz00_1265))
														{	/* Eval/evaluate.scm 217 */
															BgL_ev_appz00_bglt BgL_nodez00_1267;

															{	/* Eval/evaluate.scm 271 */
																obj_t BgL_getz00_3281;

																BgL_getz00_3281 =
																	BGl_classzd2fieldzd2accessorz00zz__objectz00
																	(BgL_fieldz00_1265);
																{	/* Eval/evaluate.scm 272 */
																	BgL_ev_appz00_bglt BgL_new1087z00_3282;

																	{	/* Eval/evaluate.scm 273 */
																		BgL_ev_appz00_bglt BgL_new1086z00_3283;

																		BgL_new1086z00_3283 =
																			((BgL_ev_appz00_bglt)
																			BOBJECT(GC_MALLOC(sizeof(struct
																						BgL_ev_appz00_bgl))));
																		{	/* Eval/evaluate.scm 273 */
																			long BgL_arg1420z00_3284;

																			{	/* Eval/evaluate.scm 273 */
																				long BgL_res2822z00_3290;

																				BgL_res2822z00_3290 =
																					BGL_CLASS_INDEX
																					(BGl_ev_appz00zz__evaluate_typesz00);
																				BgL_arg1420z00_3284 =
																					BgL_res2822z00_3290;
																			}
																			BGL_OBJECT_CLASS_NUM_SET(
																				((BgL_objectz00_bglt)
																					BgL_new1086z00_3283),
																				BgL_arg1420z00_3284);
																		}
																		BgL_new1087z00_3282 = BgL_new1086z00_3283;
																	}
																	((((BgL_ev_appz00_bglt)
																				COBJECT(BgL_new1087z00_3282))->
																			BgL_locz00) =
																		((obj_t) BgL_locz00_35), BUNSPEC);
																	{
																		BgL_ev_exprz00_bglt BgL_auxz00_5226;

																		{	/* Eval/evaluate.scm 274 */
																			BgL_ev_littz00_bglt BgL_new1089z00_3285;

																			{	/* Eval/evaluate.scm 274 */
																				BgL_ev_littz00_bglt BgL_new1088z00_3286;

																				BgL_new1088z00_3286 =
																					((BgL_ev_littz00_bglt)
																					BOBJECT(GC_MALLOC(sizeof(struct
																								BgL_ev_littz00_bgl))));
																				{	/* Eval/evaluate.scm 274 */
																					long BgL_arg1418z00_3287;

																					{	/* Eval/evaluate.scm 274 */
																						long BgL_res2823z00_3294;

																						{	/* Eval/evaluate.scm 274 */
																							obj_t BgL_classz00_3293;

																							BgL_classz00_3293 =
																								BGl_ev_littz00zz__evaluate_typesz00;
																							BgL_res2823z00_3294 =
																								BGL_CLASS_INDEX
																								(BgL_classz00_3293);
																						}
																						BgL_arg1418z00_3287 =
																							BgL_res2823z00_3294;
																					}
																					BGL_OBJECT_CLASS_NUM_SET(
																						((BgL_objectz00_bglt)
																							BgL_new1088z00_3286),
																						BgL_arg1418z00_3287);
																				}
																				BgL_new1089z00_3285 =
																					BgL_new1088z00_3286;
																			}
																			((((BgL_ev_littz00_bglt)
																						COBJECT(BgL_new1089z00_3285))->
																					BgL_valuez00) =
																				((obj_t) BgL_getz00_3281), BUNSPEC);
																			BgL_auxz00_5226 =
																				((BgL_ev_exprz00_bglt)
																				BgL_new1089z00_3285);
																		}
																		((((BgL_ev_appz00_bglt)
																					COBJECT(BgL_new1087z00_3282))->
																				BgL_funz00) =
																			((BgL_ev_exprz00_bglt) BgL_auxz00_5226),
																			BUNSPEC);
																	}
																	{
																		obj_t BgL_auxz00_5234;

																		{	/* Eval/evaluate.scm 275 */
																			obj_t BgL_list1419z00_3288;

																			BgL_list1419z00_3288 =
																				MAKE_YOUNG_PAIR(
																				((obj_t) BgL_nodez00_1259), BNIL);
																			BgL_auxz00_5234 = BgL_list1419z00_3288;
																		}
																		((((BgL_ev_appz00_bglt)
																					COBJECT(BgL_new1087z00_3282))->
																				BgL_argsz00) =
																			((obj_t) BgL_auxz00_5234), BUNSPEC);
																	}
																	((((BgL_ev_appz00_bglt)
																				COBJECT(BgL_new1087z00_3282))->
																			BgL_tailzf3zf3) =
																		((obj_t) BgL_tailzf3zf3_33), BUNSPEC);
																	BgL_nodez00_1267 = BgL_new1087z00_3282;
															}}
															{	/* Eval/evaluate.scm 220 */
																obj_t BgL_arg1373z00_1268;
																obj_t BgL_arg1374z00_1269;

																BgL_arg1373z00_1268 =
																	BGl_classzd2fieldzd2typez00zz__objectz00
																	(BgL_fieldz00_1265);
																BgL_arg1374z00_1269 =
																	CDR(((obj_t) BgL_fieldsz00_1261));
																{
																	obj_t BgL_fieldsz00_5245;
																	obj_t BgL_klassz00_5244;
																	BgL_ev_exprz00_bglt BgL_nodez00_5242;

																	BgL_nodez00_5242 =
																		((BgL_ev_exprz00_bglt) BgL_nodez00_1267);
																	BgL_klassz00_5244 = BgL_arg1373z00_1268;
																	BgL_fieldsz00_5245 = BgL_arg1374z00_1269;
																	BgL_fieldsz00_1261 = BgL_fieldsz00_5245;
																	BgL_klassz00_1260 = BgL_klassz00_5244;
																	BgL_nodez00_1259 = BgL_nodez00_5242;
																	goto BgL_zc3z04anonymousza31369ze3z87_1262;
																}
															}
														}
													else
														{	/* Eval/evaluate.scm 222 */
															obj_t BgL_arg1375z00_1270;
															obj_t BgL_arg1376z00_1271;

															BgL_arg1375z00_1270 =
																(((BgL_ev_varz00_bglt) COBJECT(
																		((BgL_ev_varz00_bglt) BgL_vz00_1253)))->
																BgL_typez00);
															{	/* Eval/evaluate.scm 223 */
																obj_t BgL_arg1377z00_1272;
																obj_t BgL_arg1378z00_1273;

																BgL_arg1377z00_1272 =
																	(((BgL_ev_varz00_bglt) COBJECT(
																			((BgL_ev_varz00_bglt) BgL_vz00_1253)))->
																	BgL_typez00);
																BgL_arg1378z00_1273 =
																	CAR(((obj_t) BgL_fieldsz00_1261));
																{	/* Eval/evaluate.scm 223 */
																	obj_t BgL_list1379z00_1274;

																	{	/* Eval/evaluate.scm 223 */
																		obj_t BgL_arg1380z00_1275;

																		BgL_arg1380z00_1275 =
																			MAKE_YOUNG_PAIR(BgL_arg1378z00_1273,
																			BNIL);
																		BgL_list1379z00_1274 =
																			MAKE_YOUNG_PAIR(BgL_arg1377z00_1272,
																			BgL_arg1380z00_1275);
																	}
																	BgL_arg1376z00_1271 =
																		BGl_formatz00zz__r4_output_6_10_3z00
																		(BGl_string3180z00zz__evaluatez00,
																		BgL_list1379z00_1274);
																}
															}
															return
																BGl_evcompilezd2errorzd2zz__evcompilez00
																(BgL_locz00_35, BgL_arg1375z00_1270,
																BgL_arg1376z00_1271, BgL_ez00_30);
														}
												}
											else
												{	/* Eval/evaluate.scm 226 */
													obj_t BgL_arg1382z00_1277;

													{	/* Eval/evaluate.scm 226 */
														obj_t BgL__ortest_1081z00_1278;

														BgL__ortest_1081z00_1278 =
															(((BgL_ev_varz00_bglt) COBJECT(
																	((BgL_ev_varz00_bglt) BgL_vz00_1253)))->
															BgL_typez00);
														if (CBOOL(BgL__ortest_1081z00_1278))
															{	/* Eval/evaluate.scm 226 */
																BgL_arg1382z00_1277 = BgL__ortest_1081z00_1278;
															}
														else
															{	/* Eval/evaluate.scm 226 */
																BgL_arg1382z00_1277 =
																	(((BgL_ev_varz00_bglt) COBJECT(
																			((BgL_ev_varz00_bglt) BgL_vz00_1253)))->
																	BgL_namez00);
															}
													}
													return
														BGl_evcompilezd2errorzd2zz__evcompilez00
														(BgL_locz00_35, BgL_arg1382z00_1277,
														BGl_string3181z00zz__evaluatez00, BgL_ez00_30);
												}
										}
								}
							}
						else
							{	/* Eval/evaluate.scm 228 */
								obj_t BgL_arg1384z00_1281;

								{	/* Eval/evaluate.scm 228 */
									obj_t BgL_pairz00_3303;

									BgL_pairz00_3303 = CDR(((obj_t) BgL_ez00_30));
									BgL_arg1384z00_1281 = CAR(BgL_pairz00_3303);
								}
								return
									BGl_evcompilezd2errorzd2zz__evcompilez00(BgL_locz00_35,
									BgL_arg1384z00_1281, BGl_string3182z00zz__evaluatez00,
									BgL_ez00_30);
							}
					}
				}
			}
		}

	}



/* conv-field-set */
	obj_t BGl_convzd2fieldzd2setz00zz__evaluatez00(obj_t BgL_lz00_37,
		obj_t BgL_e2z00_38, obj_t BgL_ez00_39, obj_t BgL_localsz00_40,
		obj_t BgL_globalsz00_41, obj_t BgL_tailzf3zf3_42, obj_t BgL_wherez00_43,
		obj_t BgL_locz00_44, bool_t BgL_topzf3zf3_45)
	{
		{	/* Eval/evaluate.scm 233 */
			{	/* Eval/evaluate.scm 234 */
				obj_t BgL_vz00_1283;

				BgL_vz00_1283 =
					BGl_convzd2varzd2zz__evaluatez00(CAR(BgL_lz00_37), BgL_localsz00_40);
				{	/* Eval/evaluate.scm 234 */
					obj_t BgL_e2z00_1284;

					BgL_e2z00_1284 =
						BGl_convz00zz__evaluatez00(BgL_e2z00_38, BgL_localsz00_40,
						BgL_globalsz00_41, BFALSE, BgL_wherez00_43, BgL_locz00_44,
						((bool_t) 0));
					{	/* Eval/evaluate.scm 235 */

						if (BGl_isazf3zf3zz__objectz00(BgL_vz00_1283,
								BGl_ev_varz00zz__evaluate_typesz00))
							{	/* Eval/evaluate.scm 238 */
								obj_t BgL_g1083z00_1287;
								obj_t BgL_g1084z00_1288;

								{	/* Eval/evaluate.scm 239 */
									obj_t BgL_arg1415z00_1319;

									BgL_arg1415z00_1319 =
										(((BgL_ev_varz00_bglt) COBJECT(
												((BgL_ev_varz00_bglt) BgL_vz00_1283)))->BgL_typez00);
									BgL_g1083z00_1287 =
										BGl_classzd2existszd2zz__objectz00(BgL_arg1415z00_1319);
								}
								BgL_g1084z00_1288 = CDR(BgL_lz00_37);
								{
									BgL_ev_exprz00_bglt BgL_nodez00_1290;
									obj_t BgL_klassz00_1291;
									obj_t BgL_fieldsz00_1292;

									BgL_nodez00_1290 =
										((BgL_ev_exprz00_bglt)
										((BgL_ev_varz00_bglt) BgL_vz00_1283));
									BgL_klassz00_1291 = BgL_g1083z00_1287;
									BgL_fieldsz00_1292 = BgL_g1084z00_1288;
								BgL_zc3z04anonymousza31387ze3z87_1293:
									if (NULLP(BgL_fieldsz00_1292))
										{	/* Eval/evaluate.scm 242 */
											return ((obj_t) BgL_nodez00_1290);
										}
									else
										{	/* Eval/evaluate.scm 242 */
											if (BGl_classzf3zf3zz__objectz00(BgL_klassz00_1291))
												{	/* Eval/evaluate.scm 245 */
													obj_t BgL_fieldz00_1296;

													{	/* Eval/evaluate.scm 245 */
														obj_t BgL_arg1413z00_1315;

														BgL_arg1413z00_1315 =
															CAR(((obj_t) BgL_fieldsz00_1292));
														BgL_fieldz00_1296 =
															BGl_findzd2classzd2fieldz00zz__objectz00
															(BgL_klassz00_1291, BgL_arg1413z00_1315);
													}
													if (BGl_classzd2fieldzf3z21zz__objectz00
														(BgL_fieldz00_1296))
														{	/* Eval/evaluate.scm 246 */
															if (NULLP(CDR(((obj_t) BgL_fieldsz00_1292))))
																{	/* Eval/evaluate.scm 247 */
																	if (BGl_classzd2fieldzd2mutablezf3zf3zz__objectz00(BgL_fieldz00_1296))
																		{	/* Eval/evaluate.scm 250 */
																			obj_t BgL_arg1395z00_1301;

																			{	/* Eval/evaluate.scm 250 */
																				obj_t BgL_list1396z00_1302;

																				{	/* Eval/evaluate.scm 250 */
																					obj_t BgL_arg1397z00_1303;

																					BgL_arg1397z00_1303 =
																						MAKE_YOUNG_PAIR(BgL_e2z00_1284,
																						BNIL);
																					BgL_list1396z00_1302 =
																						MAKE_YOUNG_PAIR(((obj_t)
																							BgL_nodez00_1290),
																						BgL_arg1397z00_1303);
																				}
																				BgL_arg1395z00_1301 =
																					BgL_list1396z00_1302;
																			}
																			{	/* Eval/evaluate.scm 282 */
																				obj_t BgL_setz00_3311;

																				BgL_setz00_3311 =
																					BGl_classzd2fieldzd2mutatorz00zz__objectz00
																					(BgL_fieldz00_1296);
																				{	/* Eval/evaluate.scm 283 */
																					BgL_ev_appz00_bglt
																						BgL_new1091z00_3312;
																					{	/* Eval/evaluate.scm 284 */
																						BgL_ev_appz00_bglt
																							BgL_new1090z00_3313;
																						BgL_new1090z00_3313 =
																							((BgL_ev_appz00_bglt)
																							BOBJECT(GC_MALLOC(sizeof(struct
																										BgL_ev_appz00_bgl))));
																						{	/* Eval/evaluate.scm 284 */
																							long BgL_arg1422z00_3314;

																							{	/* Eval/evaluate.scm 284 */
																								long BgL_res2828z00_3319;

																								BgL_res2828z00_3319 =
																									BGL_CLASS_INDEX
																									(BGl_ev_appz00zz__evaluate_typesz00);
																								BgL_arg1422z00_3314 =
																									BgL_res2828z00_3319;
																							}
																							BGL_OBJECT_CLASS_NUM_SET(
																								((BgL_objectz00_bglt)
																									BgL_new1090z00_3313),
																								BgL_arg1422z00_3314);
																						}
																						BgL_new1091z00_3312 =
																							BgL_new1090z00_3313;
																					}
																					((((BgL_ev_appz00_bglt)
																								COBJECT(BgL_new1091z00_3312))->
																							BgL_locz00) =
																						((obj_t) BgL_locz00_44), BUNSPEC);
																					{
																						BgL_ev_exprz00_bglt BgL_auxz00_5303;

																						{	/* Eval/evaluate.scm 285 */
																							BgL_ev_littz00_bglt
																								BgL_new1093z00_3315;
																							{	/* Eval/evaluate.scm 285 */
																								BgL_ev_littz00_bglt
																									BgL_new1092z00_3316;
																								BgL_new1092z00_3316 =
																									((BgL_ev_littz00_bglt)
																									BOBJECT(GC_MALLOC(sizeof
																											(struct
																												BgL_ev_littz00_bgl))));
																								{	/* Eval/evaluate.scm 285 */
																									long BgL_arg1421z00_3317;

																									{	/* Eval/evaluate.scm 285 */
																										long BgL_res2829z00_3323;

																										{	/* Eval/evaluate.scm 285 */
																											obj_t BgL_classz00_3322;

																											BgL_classz00_3322 =
																												BGl_ev_littz00zz__evaluate_typesz00;
																											BgL_res2829z00_3323 =
																												BGL_CLASS_INDEX
																												(BgL_classz00_3322);
																										}
																										BgL_arg1421z00_3317 =
																											BgL_res2829z00_3323;
																									}
																									BGL_OBJECT_CLASS_NUM_SET(
																										((BgL_objectz00_bglt)
																											BgL_new1092z00_3316),
																										BgL_arg1421z00_3317);
																								}
																								BgL_new1093z00_3315 =
																									BgL_new1092z00_3316;
																							}
																							((((BgL_ev_littz00_bglt)
																										COBJECT
																										(BgL_new1093z00_3315))->
																									BgL_valuez00) =
																								((obj_t) BgL_setz00_3311),
																								BUNSPEC);
																							BgL_auxz00_5303 =
																								((BgL_ev_exprz00_bglt)
																								BgL_new1093z00_3315);
																						}
																						((((BgL_ev_appz00_bglt)
																									COBJECT
																									(BgL_new1091z00_3312))->
																								BgL_funz00) =
																							((BgL_ev_exprz00_bglt)
																								BgL_auxz00_5303), BUNSPEC);
																					}
																					((((BgL_ev_appz00_bglt)
																								COBJECT(BgL_new1091z00_3312))->
																							BgL_argsz00) =
																						((obj_t) BgL_arg1395z00_1301),
																						BUNSPEC);
																					((((BgL_ev_appz00_bglt)
																								COBJECT(BgL_new1091z00_3312))->
																							BgL_tailzf3zf3) =
																						((obj_t) BgL_tailzf3zf3_42),
																						BUNSPEC);
																					return ((obj_t) BgL_new1091z00_3312);
																				}
																			}
																		}
																	else
																		{	/* Eval/evaluate.scm 251 */
																			obj_t BgL_arg1398z00_1304;

																			BgL_arg1398z00_1304 =
																				CAR(((obj_t) BgL_fieldsz00_1292));
																			return
																				BGl_evcompilezd2errorzd2zz__evcompilez00
																				(BgL_locz00_44, BgL_arg1398z00_1304,
																				BGl_string3183z00zz__evaluatez00,
																				BgL_ez00_39);
																		}
																}
															else
																{	/* Eval/evaluate.scm 254 */
																	BgL_ev_appz00_bglt BgL_nodez00_1305;

																	{	/* Eval/evaluate.scm 271 */
																		obj_t BgL_getz00_3327;

																		BgL_getz00_3327 =
																			BGl_classzd2fieldzd2accessorz00zz__objectz00
																			(BgL_fieldz00_1296);
																		{	/* Eval/evaluate.scm 272 */
																			BgL_ev_appz00_bglt BgL_new1087z00_3328;

																			{	/* Eval/evaluate.scm 273 */
																				BgL_ev_appz00_bglt BgL_new1086z00_3329;

																				BgL_new1086z00_3329 =
																					((BgL_ev_appz00_bglt)
																					BOBJECT(GC_MALLOC(sizeof(struct
																								BgL_ev_appz00_bgl))));
																				{	/* Eval/evaluate.scm 273 */
																					long BgL_arg1420z00_3330;

																					{	/* Eval/evaluate.scm 273 */
																						long BgL_res2830z00_3336;

																						BgL_res2830z00_3336 =
																							BGL_CLASS_INDEX
																							(BGl_ev_appz00zz__evaluate_typesz00);
																						BgL_arg1420z00_3330 =
																							BgL_res2830z00_3336;
																					}
																					BGL_OBJECT_CLASS_NUM_SET(
																						((BgL_objectz00_bglt)
																							BgL_new1086z00_3329),
																						BgL_arg1420z00_3330);
																				}
																				BgL_new1087z00_3328 =
																					BgL_new1086z00_3329;
																			}
																			((((BgL_ev_appz00_bglt)
																						COBJECT(BgL_new1087z00_3328))->
																					BgL_locz00) =
																				((obj_t) BgL_locz00_44), BUNSPEC);
																			{
																				BgL_ev_exprz00_bglt BgL_auxz00_5323;

																				{	/* Eval/evaluate.scm 274 */
																					BgL_ev_littz00_bglt
																						BgL_new1089z00_3331;
																					{	/* Eval/evaluate.scm 274 */
																						BgL_ev_littz00_bglt
																							BgL_new1088z00_3332;
																						BgL_new1088z00_3332 =
																							((BgL_ev_littz00_bglt)
																							BOBJECT(GC_MALLOC(sizeof(struct
																										BgL_ev_littz00_bgl))));
																						{	/* Eval/evaluate.scm 274 */
																							long BgL_arg1418z00_3333;

																							{	/* Eval/evaluate.scm 274 */
																								long BgL_res2831z00_3340;

																								{	/* Eval/evaluate.scm 274 */
																									obj_t BgL_classz00_3339;

																									BgL_classz00_3339 =
																										BGl_ev_littz00zz__evaluate_typesz00;
																									BgL_res2831z00_3340 =
																										BGL_CLASS_INDEX
																										(BgL_classz00_3339);
																								}
																								BgL_arg1418z00_3333 =
																									BgL_res2831z00_3340;
																							}
																							BGL_OBJECT_CLASS_NUM_SET(
																								((BgL_objectz00_bglt)
																									BgL_new1088z00_3332),
																								BgL_arg1418z00_3333);
																						}
																						BgL_new1089z00_3331 =
																							BgL_new1088z00_3332;
																					}
																					((((BgL_ev_littz00_bglt)
																								COBJECT(BgL_new1089z00_3331))->
																							BgL_valuez00) =
																						((obj_t) BgL_getz00_3327), BUNSPEC);
																					BgL_auxz00_5323 =
																						((BgL_ev_exprz00_bglt)
																						BgL_new1089z00_3331);
																				}
																				((((BgL_ev_appz00_bglt)
																							COBJECT(BgL_new1087z00_3328))->
																						BgL_funz00) =
																					((BgL_ev_exprz00_bglt)
																						BgL_auxz00_5323), BUNSPEC);
																			}
																			{
																				obj_t BgL_auxz00_5331;

																				{	/* Eval/evaluate.scm 275 */
																					obj_t BgL_list1419z00_3334;

																					BgL_list1419z00_3334 =
																						MAKE_YOUNG_PAIR(
																						((obj_t) BgL_nodez00_1290), BNIL);
																					BgL_auxz00_5331 =
																						BgL_list1419z00_3334;
																				}
																				((((BgL_ev_appz00_bglt)
																							COBJECT(BgL_new1087z00_3328))->
																						BgL_argsz00) =
																					((obj_t) BgL_auxz00_5331), BUNSPEC);
																			}
																			((((BgL_ev_appz00_bglt)
																						COBJECT(BgL_new1087z00_3328))->
																					BgL_tailzf3zf3) =
																				((obj_t) BgL_tailzf3zf3_42), BUNSPEC);
																			BgL_nodez00_1305 = BgL_new1087z00_3328;
																	}}
																	{	/* Eval/evaluate.scm 257 */
																		obj_t BgL_arg1399z00_1306;
																		obj_t BgL_arg1400z00_1307;

																		BgL_arg1399z00_1306 =
																			BGl_classzd2fieldzd2typez00zz__objectz00
																			(BgL_fieldz00_1296);
																		BgL_arg1400z00_1307 =
																			CDR(((obj_t) BgL_fieldsz00_1292));
																		{
																			obj_t BgL_fieldsz00_5342;
																			obj_t BgL_klassz00_5341;
																			BgL_ev_exprz00_bglt BgL_nodez00_5339;

																			BgL_nodez00_5339 =
																				((BgL_ev_exprz00_bglt)
																				BgL_nodez00_1305);
																			BgL_klassz00_5341 = BgL_arg1399z00_1306;
																			BgL_fieldsz00_5342 = BgL_arg1400z00_1307;
																			BgL_fieldsz00_1292 = BgL_fieldsz00_5342;
																			BgL_klassz00_1291 = BgL_klassz00_5341;
																			BgL_nodez00_1290 = BgL_nodez00_5339;
																			goto
																				BgL_zc3z04anonymousza31387ze3z87_1293;
																		}
																	}
																}
														}
													else
														{	/* Eval/evaluate.scm 259 */
															obj_t BgL_arg1405z00_1309;
															obj_t BgL_arg1406z00_1310;

															BgL_arg1405z00_1309 =
																(((BgL_ev_varz00_bglt) COBJECT(
																		((BgL_ev_varz00_bglt) BgL_vz00_1283)))->
																BgL_typez00);
															{	/* Eval/evaluate.scm 260 */
																obj_t BgL_arg1408z00_1311;
																obj_t BgL_arg1409z00_1312;

																BgL_arg1408z00_1311 =
																	(((BgL_ev_varz00_bglt) COBJECT(
																			((BgL_ev_varz00_bglt) BgL_vz00_1283)))->
																	BgL_typez00);
																BgL_arg1409z00_1312 =
																	CAR(((obj_t) BgL_fieldsz00_1292));
																{	/* Eval/evaluate.scm 260 */
																	obj_t BgL_list1410z00_1313;

																	{	/* Eval/evaluate.scm 260 */
																		obj_t BgL_arg1412z00_1314;

																		BgL_arg1412z00_1314 =
																			MAKE_YOUNG_PAIR(BgL_arg1409z00_1312,
																			BNIL);
																		BgL_list1410z00_1313 =
																			MAKE_YOUNG_PAIR(BgL_arg1408z00_1311,
																			BgL_arg1412z00_1314);
																	}
																	BgL_arg1406z00_1310 =
																		BGl_formatz00zz__r4_output_6_10_3z00
																		(BGl_string3180z00zz__evaluatez00,
																		BgL_list1410z00_1313);
																}
															}
															return
																BGl_evcompilezd2errorzd2zz__evcompilez00
																(BgL_locz00_44, BgL_arg1405z00_1309,
																BgL_arg1406z00_1310, BgL_ez00_39);
														}
												}
											else
												{	/* Eval/evaluate.scm 264 */
													obj_t BgL_arg1414z00_1316;

													{	/* Eval/evaluate.scm 264 */
														obj_t BgL__ortest_1085z00_1317;

														BgL__ortest_1085z00_1317 =
															(((BgL_ev_varz00_bglt) COBJECT(
																	((BgL_ev_varz00_bglt) BgL_vz00_1283)))->
															BgL_typez00);
														if (CBOOL(BgL__ortest_1085z00_1317))
															{	/* Eval/evaluate.scm 264 */
																BgL_arg1414z00_1316 = BgL__ortest_1085z00_1317;
															}
														else
															{	/* Eval/evaluate.scm 264 */
																BgL_arg1414z00_1316 =
																	(((BgL_ev_varz00_bglt) COBJECT(
																			((BgL_ev_varz00_bglt) BgL_vz00_1283)))->
																	BgL_namez00);
															}
													}
													return
														BGl_evcompilezd2errorzd2zz__evcompilez00
														(BgL_locz00_44, BgL_arg1414z00_1316,
														BGl_string3181z00zz__evaluatez00, BgL_ez00_39);
												}
										}
								}
							}
						else
							{	/* Eval/evaluate.scm 236 */
								return
									BGl_evcompilezd2errorzd2zz__evcompilez00(BgL_locz00_44,
									CAR(BgL_lz00_37), BGl_string3182z00zz__evaluatez00,
									BgL_ez00_39);
							}
					}
				}
			}
		}

	}



/* type-check */
	obj_t BGl_typezd2checkzd2zz__evaluatez00(obj_t BgL_varz00_56,
		obj_t BgL_tnamez00_57, obj_t BgL_locz00_58, obj_t BgL_procnamez00_59,
		obj_t BgL_bodyz00_60)
	{
		{	/* Eval/evaluate.scm 298 */
			if (SYMBOLP(BgL_tnamez00_57))
				{	/* Eval/evaluate.scm 301 */
					obj_t BgL_predz00_1340;

					if ((BgL_tnamez00_57 == BGl_symbol3184z00zz__evaluatez00))
						{	/* Eval/evaluate.scm 301 */
							BgL_predz00_1340 = BGl_symbol3186z00zz__evaluatez00;
						}
					else
						{	/* Eval/evaluate.scm 301 */
							if ((BgL_tnamez00_57 == BGl_symbol3188z00zz__evaluatez00))
								{	/* Eval/evaluate.scm 301 */
									BgL_predz00_1340 = BGl_symbol3189z00zz__evaluatez00;
								}
							else
								{	/* Eval/evaluate.scm 301 */
									if ((BgL_tnamez00_57 == BGl_symbol3191z00zz__evaluatez00))
										{	/* Eval/evaluate.scm 301 */
											BgL_predz00_1340 = BGl_symbol3193z00zz__evaluatez00;
										}
									else
										{	/* Eval/evaluate.scm 301 */
											if ((BgL_tnamez00_57 == BGl_symbol3195z00zz__evaluatez00))
												{	/* Eval/evaluate.scm 301 */
													BgL_predz00_1340 = BGl_symbol3197z00zz__evaluatez00;
												}
											else
												{	/* Eval/evaluate.scm 301 */
													bool_t BgL_test3401z00_5374;

													{	/* Eval/evaluate.scm 301 */
														bool_t BgL__ortest_1094z00_1416;

														BgL__ortest_1094z00_1416 =
															(BgL_tnamez00_57 ==
															BGl_symbol3199z00zz__evaluatez00);
														if (BgL__ortest_1094z00_1416)
															{	/* Eval/evaluate.scm 301 */
																BgL_test3401z00_5374 = BgL__ortest_1094z00_1416;
															}
														else
															{	/* Eval/evaluate.scm 301 */
																BgL_test3401z00_5374 =
																	(BgL_tnamez00_57 ==
																	BGl_symbol3201z00zz__evaluatez00);
															}
													}
													if (BgL_test3401z00_5374)
														{	/* Eval/evaluate.scm 301 */
															BgL_predz00_1340 =
																BGl_symbol3202z00zz__evaluatez00;
														}
													else
														{	/* Eval/evaluate.scm 301 */
															bool_t BgL_test3403z00_5378;

															{	/* Eval/evaluate.scm 301 */
																bool_t BgL__ortest_1095z00_1415;

																BgL__ortest_1095z00_1415 =
																	(BgL_tnamez00_57 ==
																	BGl_symbol3204z00zz__evaluatez00);
																if (BgL__ortest_1095z00_1415)
																	{	/* Eval/evaluate.scm 301 */
																		BgL_test3403z00_5378 =
																			BgL__ortest_1095z00_1415;
																	}
																else
																	{	/* Eval/evaluate.scm 301 */
																		BgL_test3403z00_5378 =
																			(BgL_tnamez00_57 ==
																			BGl_symbol3206z00zz__evaluatez00);
																	}
															}
															if (BgL_test3403z00_5378)
																{	/* Eval/evaluate.scm 301 */
																	BgL_predz00_1340 =
																		BGl_symbol3208z00zz__evaluatez00;
																}
															else
																{	/* Eval/evaluate.scm 301 */
																	if (
																		(BgL_tnamez00_57 ==
																			BGl_symbol3210z00zz__evaluatez00))
																		{	/* Eval/evaluate.scm 301 */
																			BgL_predz00_1340 =
																				BGl_symbol3212z00zz__evaluatez00;
																		}
																	else
																		{	/* Eval/evaluate.scm 301 */
																			if (
																				(BgL_tnamez00_57 ==
																					BGl_symbol3214z00zz__evaluatez00))
																				{	/* Eval/evaluate.scm 301 */
																					BgL_predz00_1340 =
																						BGl_symbol3216z00zz__evaluatez00;
																				}
																			else
																				{	/* Eval/evaluate.scm 301 */
																					if (
																						(BgL_tnamez00_57 ==
																							BGl_symbol3218z00zz__evaluatez00))
																						{	/* Eval/evaluate.scm 301 */
																							BgL_predz00_1340 =
																								BGl_symbol3220z00zz__evaluatez00;
																						}
																					else
																						{	/* Eval/evaluate.scm 301 */
																							bool_t BgL_test3408z00_5388;

																							{	/* Eval/evaluate.scm 301 */
																								bool_t BgL__ortest_1096z00_1414;

																								BgL__ortest_1096z00_1414 =
																									(BgL_tnamez00_57 ==
																									BGl_symbol3222z00zz__evaluatez00);
																								if (BgL__ortest_1096z00_1414)
																									{	/* Eval/evaluate.scm 301 */
																										BgL_test3408z00_5388 =
																											BgL__ortest_1096z00_1414;
																									}
																								else
																									{	/* Eval/evaluate.scm 301 */
																										BgL_test3408z00_5388 =
																											(BgL_tnamez00_57 ==
																											BGl_symbol3224z00zz__evaluatez00);
																									}
																							}
																							if (BgL_test3408z00_5388)
																								{	/* Eval/evaluate.scm 301 */
																									BgL_predz00_1340 =
																										BGl_symbol3226z00zz__evaluatez00;
																								}
																							else
																								{	/* Eval/evaluate.scm 312 */
																									obj_t BgL_arg1473z00_1394;

																									{	/* Eval/evaluate.scm 312 */
																										obj_t BgL_arg1474z00_1395;
																										obj_t BgL_arg1476z00_1396;

																										BgL_arg1474z00_1395 =
																											MAKE_YOUNG_PAIR
																											(BGl_symbol3228z00zz__evaluatez00,
																											BNIL);
																										{	/* Eval/evaluate.scm 313 */
																											obj_t BgL_arg1477z00_1397;

																											{	/* Eval/evaluate.scm 313 */
																												obj_t
																													BgL_arg1478z00_1398;
																												{	/* Eval/evaluate.scm 313 */
																													obj_t
																														BgL_arg1479z00_1399;
																													obj_t
																														BgL_arg1480z00_1400;
																													{	/* Eval/evaluate.scm 313 */
																														obj_t
																															BgL_arg1481z00_1401;
																														{	/* Eval/evaluate.scm 313 */
																															obj_t
																																BgL_arg1482z00_1402;
																															{	/* Eval/evaluate.scm 313 */
																																obj_t
																																	BgL_arg1483z00_1403;
																																{	/* Eval/evaluate.scm 313 */
																																	obj_t
																																		BgL_arg1485z00_1404;
																																	{	/* Eval/evaluate.scm 313 */
																																		obj_t
																																			BgL_arg1486z00_1405;
																																		{	/* Eval/evaluate.scm 313 */
																																			obj_t
																																				BgL_arg1488z00_1406;
																																			BgL_arg1488z00_1406
																																				=
																																				MAKE_YOUNG_PAIR
																																				(BgL_tnamez00_57,
																																				BNIL);
																																			BgL_arg1486z00_1405
																																				=
																																				MAKE_YOUNG_PAIR
																																				(BGl_symbol3230z00zz__evaluatez00,
																																				BgL_arg1488z00_1406);
																																		}
																																		BgL_arg1485z00_1404
																																			=
																																			MAKE_YOUNG_PAIR
																																			(BgL_arg1486z00_1405,
																																			BNIL);
																																	}
																																	BgL_arg1483z00_1403
																																		=
																																		MAKE_YOUNG_PAIR
																																		(BGl_symbol3232z00zz__evaluatez00,
																																		BgL_arg1485z00_1404);
																																}
																																BgL_arg1482z00_1402
																																	=
																																	MAKE_YOUNG_PAIR
																																	(BgL_arg1483z00_1403,
																																	BNIL);
																															}
																															BgL_arg1481z00_1401
																																=
																																MAKE_YOUNG_PAIR
																																(BGl_symbol3234z00zz__evaluatez00,
																																BgL_arg1482z00_1402);
																														}
																														BgL_arg1479z00_1399
																															=
																															MAKE_YOUNG_PAIR
																															(BgL_arg1481z00_1401,
																															BNIL);
																													}
																													{	/* Eval/evaluate.scm 314 */
																														obj_t
																															BgL_arg1489z00_1407;
																														{	/* Eval/evaluate.scm 314 */
																															obj_t
																																BgL_arg1490z00_1408;
																															{	/* Eval/evaluate.scm 314 */
																																obj_t
																																	BgL_arg1491z00_1409;
																																{	/* Eval/evaluate.scm 314 */
																																	obj_t
																																		BgL_arg1493z00_1410;
																																	obj_t
																																		BgL_arg1494z00_1411;
																																	{	/* Eval/evaluate.scm 314 */
																																		obj_t
																																			BgL_arg1495z00_1412;
																																		{	/* Eval/evaluate.scm 314 */
																																			obj_t
																																				BgL_arg1497z00_1413;
																																			BgL_arg1497z00_1413
																																				=
																																				MAKE_YOUNG_PAIR
																																				(BGl_symbol3234z00zz__evaluatez00,
																																				BNIL);
																																			BgL_arg1495z00_1412
																																				=
																																				MAKE_YOUNG_PAIR
																																				(BGl_symbol3228z00zz__evaluatez00,
																																				BgL_arg1497z00_1413);
																																		}
																																		BgL_arg1493z00_1410
																																			=
																																			MAKE_YOUNG_PAIR
																																			(BGl_symbol3236z00zz__evaluatez00,
																																			BgL_arg1495z00_1412);
																																	}
																																	BgL_arg1494z00_1411
																																		=
																																		MAKE_YOUNG_PAIR
																																		(BTRUE,
																																		BNIL);
																																	BgL_arg1491z00_1409
																																		=
																																		MAKE_YOUNG_PAIR
																																		(BgL_arg1493z00_1410,
																																		BgL_arg1494z00_1411);
																																}
																																BgL_arg1490z00_1408
																																	=
																																	MAKE_YOUNG_PAIR
																																	(BGl_symbol3234z00zz__evaluatez00,
																																	BgL_arg1491z00_1409);
																															}
																															BgL_arg1489z00_1407
																																=
																																MAKE_YOUNG_PAIR
																																(BGl_symbol3238z00zz__evaluatez00,
																																BgL_arg1490z00_1408);
																														}
																														BgL_arg1480z00_1400
																															=
																															MAKE_YOUNG_PAIR
																															(BgL_arg1489z00_1407,
																															BNIL);
																													}
																													BgL_arg1478z00_1398 =
																														MAKE_YOUNG_PAIR
																														(BgL_arg1479z00_1399,
																														BgL_arg1480z00_1400);
																												}
																												BgL_arg1477z00_1397 =
																													MAKE_YOUNG_PAIR
																													(BGl_symbol3240z00zz__evaluatez00,
																													BgL_arg1478z00_1398);
																											}
																											BgL_arg1476z00_1396 =
																												MAKE_YOUNG_PAIR
																												(BgL_arg1477z00_1397,
																												BNIL);
																										}
																										BgL_arg1473z00_1394 =
																											MAKE_YOUNG_PAIR
																											(BgL_arg1474z00_1395,
																											BgL_arg1476z00_1396);
																									}
																									BgL_predz00_1340 =
																										MAKE_YOUNG_PAIR
																										(BGl_symbol3242z00zz__evaluatez00,
																										BgL_arg1473z00_1394);
																								}
																						}
																				}
																		}
																}
														}
												}
										}
								}
						}
					{	/* Eval/evaluate.scm 316 */
						obj_t BgL_arg1428z00_1341;

						{	/* Eval/evaluate.scm 316 */
							obj_t BgL_arg1429z00_1342;

							{	/* Eval/evaluate.scm 316 */
								obj_t BgL_arg1430z00_1343;
								obj_t BgL_arg1431z00_1344;

								{	/* Eval/evaluate.scm 316 */
									obj_t BgL_arg1432z00_1345;

									BgL_arg1432z00_1345 = MAKE_YOUNG_PAIR(BgL_varz00_56, BNIL);
									BgL_arg1430z00_1343 =
										MAKE_YOUNG_PAIR(BgL_predz00_1340, BgL_arg1432z00_1345);
								}
								{	/* Eval/evaluate.scm 316 */
									obj_t BgL_arg1433z00_1346;

									{	/* Eval/evaluate.scm 316 */
										obj_t BgL_arg1434z00_1347;

										{
											obj_t BgL_fnamez00_1348;
											obj_t BgL_posz00_1349;

											if (PAIRP(BgL_locz00_58))
												{	/* Eval/evaluate.scm 316 */
													obj_t BgL_cdrzd2138zd2_1354;

													BgL_cdrzd2138zd2_1354 = CDR(BgL_locz00_58);
													if (
														(CAR(BgL_locz00_58) ==
															BGl_symbol3248z00zz__evaluatez00))
														{	/* Eval/evaluate.scm 316 */
															if (PAIRP(BgL_cdrzd2138zd2_1354))
																{	/* Eval/evaluate.scm 316 */
																	obj_t BgL_cdrzd2142zd2_1358;

																	BgL_cdrzd2142zd2_1358 =
																		CDR(BgL_cdrzd2138zd2_1354);
																	if (PAIRP(BgL_cdrzd2142zd2_1358))
																		{	/* Eval/evaluate.scm 316 */
																			if (NULLP(CDR(BgL_cdrzd2142zd2_1358)))
																				{	/* Eval/evaluate.scm 316 */
																					BgL_fnamez00_1348 =
																						CAR(BgL_cdrzd2138zd2_1354);
																					BgL_posz00_1349 =
																						CAR(BgL_cdrzd2142zd2_1358);
																					{	/* Eval/evaluate.scm 321 */
																						obj_t BgL_arg1447z00_1366;

																						{	/* Eval/evaluate.scm 321 */
																							obj_t BgL_arg1449z00_1367;
																							obj_t BgL_arg1450z00_1368;

																							if (SYMBOLP(BgL_procnamez00_59))
																								{	/* Eval/evaluate.scm 321 */
																									obj_t BgL_res2848z00_3402;

																									{	/* Eval/evaluate.scm 321 */
																										obj_t BgL_arg2602z00_3401;

																										BgL_arg2602z00_3401 =
																											SYMBOL_TO_STRING
																											(BgL_procnamez00_59);
																										BgL_res2848z00_3402 =
																											BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																											(BgL_arg2602z00_3401);
																									}
																									BgL_arg1449z00_1367 =
																										BgL_res2848z00_3402;
																								}
																							else
																								{	/* Eval/evaluate.scm 321 */
																									BgL_arg1449z00_1367 = BFALSE;
																								}
																							{	/* Eval/evaluate.scm 322 */
																								obj_t BgL_arg1452z00_1370;
																								obj_t BgL_arg1453z00_1371;

																								{	/* Eval/evaluate.scm 322 */
																									obj_t BgL_res2849z00_3405;

																									{	/* Eval/evaluate.scm 322 */
																										obj_t BgL_arg2602z00_3404;

																										BgL_arg2602z00_3404 =
																											SYMBOL_TO_STRING(
																											((obj_t)
																												BgL_tnamez00_57));
																										BgL_res2849z00_3405 =
																											BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																											(BgL_arg2602z00_3404);
																									}
																									BgL_arg1452z00_1370 =
																										BgL_res2849z00_3405;
																								}
																								{	/* Eval/evaluate.scm 320 */
																									obj_t BgL_arg1454z00_1372;

																									{	/* Eval/evaluate.scm 320 */
																										obj_t BgL_arg1455z00_1373;

																										BgL_arg1455z00_1373 =
																											MAKE_YOUNG_PAIR
																											(BgL_posz00_1349, BNIL);
																										BgL_arg1454z00_1372 =
																											MAKE_YOUNG_PAIR
																											(BgL_fnamez00_1348,
																											BgL_arg1455z00_1373);
																									}
																									BgL_arg1453z00_1371 =
																										MAKE_YOUNG_PAIR
																										(BgL_varz00_56,
																										BgL_arg1454z00_1372);
																								}
																								BgL_arg1450z00_1368 =
																									MAKE_YOUNG_PAIR
																									(BgL_arg1452z00_1370,
																									BgL_arg1453z00_1371);
																							}
																							BgL_arg1447z00_1366 =
																								MAKE_YOUNG_PAIR
																								(BgL_arg1449z00_1367,
																								BgL_arg1450z00_1368);
																						}
																						BgL_arg1434z00_1347 =
																							MAKE_YOUNG_PAIR
																							(BGl_symbol3244z00zz__evaluatez00,
																							BgL_arg1447z00_1366);
																					}
																				}
																			else
																				{	/* Eval/evaluate.scm 316 */
																				BgL_tagzd2131zd2_1351:
																					{	/* Eval/evaluate.scm 326 */
																						obj_t BgL_arg1456z00_1374;

																						{	/* Eval/evaluate.scm 326 */
																							obj_t BgL_arg1457z00_1375;
																							obj_t BgL_arg1458z00_1376;

																							if (SYMBOLP(BgL_procnamez00_59))
																								{	/* Eval/evaluate.scm 326 */
																									obj_t BgL_res2851z00_3409;

																									{	/* Eval/evaluate.scm 326 */
																										obj_t BgL_arg2602z00_3408;

																										BgL_arg2602z00_3408 =
																											SYMBOL_TO_STRING
																											(BgL_procnamez00_59);
																										BgL_res2851z00_3409 =
																											BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																											(BgL_arg2602z00_3408);
																									}
																									BgL_arg1457z00_1375 =
																										BgL_res2851z00_3409;
																								}
																							else
																								{	/* Eval/evaluate.scm 326 */
																									BgL_arg1457z00_1375 = BFALSE;
																								}
																							{	/* Eval/evaluate.scm 327 */
																								obj_t BgL_arg1460z00_1378;
																								obj_t BgL_arg1461z00_1379;

																								{	/* Eval/evaluate.scm 327 */
																									obj_t BgL_res2852z00_3412;

																									{	/* Eval/evaluate.scm 327 */
																										obj_t BgL_arg2602z00_3411;

																										BgL_arg2602z00_3411 =
																											SYMBOL_TO_STRING(
																											((obj_t)
																												BgL_tnamez00_57));
																										BgL_res2852z00_3412 =
																											BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																											(BgL_arg2602z00_3411);
																									}
																									BgL_arg1460z00_1378 =
																										BgL_res2852z00_3412;
																								}
																								BgL_arg1461z00_1379 =
																									MAKE_YOUNG_PAIR(BgL_varz00_56,
																									BNIL);
																								BgL_arg1458z00_1376 =
																									MAKE_YOUNG_PAIR
																									(BgL_arg1460z00_1378,
																									BgL_arg1461z00_1379);
																							}
																							BgL_arg1456z00_1374 =
																								MAKE_YOUNG_PAIR
																								(BgL_arg1457z00_1375,
																								BgL_arg1458z00_1376);
																						}
																						BgL_arg1434z00_1347 =
																							MAKE_YOUNG_PAIR
																							(BGl_symbol3246z00zz__evaluatez00,
																							BgL_arg1456z00_1374);
																					}
																				}
																		}
																	else
																		{	/* Eval/evaluate.scm 316 */
																			goto BgL_tagzd2131zd2_1351;
																		}
																}
															else
																{	/* Eval/evaluate.scm 316 */
																	goto BgL_tagzd2131zd2_1351;
																}
														}
													else
														{	/* Eval/evaluate.scm 316 */
															goto BgL_tagzd2131zd2_1351;
														}
												}
											else
												{	/* Eval/evaluate.scm 316 */
													goto BgL_tagzd2131zd2_1351;
												}
										}
										BgL_arg1433z00_1346 =
											MAKE_YOUNG_PAIR(BgL_arg1434z00_1347, BNIL);
									}
									BgL_arg1431z00_1344 =
										MAKE_YOUNG_PAIR(BgL_bodyz00_60, BgL_arg1433z00_1346);
								}
								BgL_arg1429z00_1342 =
									MAKE_YOUNG_PAIR(BgL_arg1430z00_1343, BgL_arg1431z00_1344);
							}
							BgL_arg1428z00_1341 =
								MAKE_YOUNG_PAIR(BGl_symbol3238z00zz__evaluatez00,
								BgL_arg1429z00_1342);
						}
						{	/* Eval/evaluate.scm 293 */
							obj_t BgL_arg1425z00_3423;
							obj_t BgL_arg1426z00_3424;

							BgL_arg1425z00_3423 = CAR(BgL_arg1428z00_1341);
							BgL_arg1426z00_3424 = CDR(BgL_arg1428z00_1341);
							{	/* Eval/evaluate.scm 293 */
								obj_t BgL_res2857z00_3427;

								BgL_res2857z00_3427 =
									MAKE_YOUNG_EPAIR(BgL_arg1425z00_3423, BgL_arg1426z00_3424,
									BgL_locz00_58);
								return BgL_res2857z00_3427;
							}
						}
					}
				}
			else
				{	/* Eval/evaluate.scm 300 */
					return BgL_bodyz00_60;
				}
		}

	}



/* type-checks */
	obj_t BGl_typezd2checkszd2zz__evaluatez00(obj_t BgL_varsz00_61,
		obj_t BgL_srcsz00_62, obj_t BgL_bodyz00_63, obj_t BgL_locz00_64,
		obj_t BgL_procnamez00_65)
	{
		{	/* Eval/evaluate.scm 334 */
			{	/* Eval/evaluate.scm 335 */
				bool_t BgL_test3417z00_5462;

				{	/* Eval/evaluate.scm 335 */
					int BgL_arg1508z00_1435;

					BgL_arg1508z00_1435 = bgl_debug();
					BgL_test3417z00_5462 = ((long) (BgL_arg1508z00_1435) <= ((long) 0));
				}
				if (BgL_test3417z00_5462)
					{	/* Eval/evaluate.scm 335 */
						return BgL_bodyz00_63;
					}
				else
					{	/* Eval/evaluate.scm 335 */
						return
							BGl_loopze71ze7zz__evaluatez00(BgL_bodyz00_63, BgL_procnamez00_65,
							BgL_locz00_64, BgL_varsz00_61, BgL_srcsz00_62);
					}
			}
		}

	}



/* loop~1 */
	obj_t BGl_loopze71ze7zz__evaluatez00(obj_t BgL_bodyz00_4951,
		obj_t BgL_procnamez00_4950, obj_t BgL_locz00_4949, obj_t BgL_varsz00_1420,
		obj_t BgL_srcsz00_1421)
	{
		{	/* Eval/evaluate.scm 337 */
		BGl_loopze71ze7zz__evaluatez00:
			if (NULLP(BgL_varsz00_1420))
				{	/* Eval/evaluate.scm 339 */
					return BgL_bodyz00_4951;
				}
			else
				{	/* Eval/evaluate.scm 341 */
					obj_t BgL_vz00_1424;

					BgL_vz00_1424 = CAR(((obj_t) BgL_varsz00_1420));
					{	/* Eval/evaluate.scm 341 */
						obj_t BgL_idz00_1425;

						BgL_idz00_1425 = CAR(((obj_t) BgL_vz00_1424));
						{	/* Eval/evaluate.scm 342 */
							obj_t BgL_tnamez00_1426;

							BgL_tnamez00_1426 = CDR(((obj_t) BgL_vz00_1424));
							{	/* Eval/evaluate.scm 343 */

								if (CBOOL(BgL_tnamez00_1426))
									{	/* Eval/evaluate.scm 345 */
										obj_t BgL_locz00_1427;

										{	/* Eval/evaluate.scm 345 */
											obj_t BgL_arg1505z00_1431;

											BgL_arg1505z00_1431 = CAR(((obj_t) BgL_srcsz00_1421));
											{	/* Eval/evaluate.scm 150 */
												obj_t BgL__ortest_1069z00_3435;

												BgL__ortest_1069z00_3435 =
													BGl_getzd2sourcezd2locationz00zz__readerz00
													(BgL_arg1505z00_1431);
												if (CBOOL(BgL__ortest_1069z00_3435))
													{	/* Eval/evaluate.scm 150 */
														BgL_locz00_1427 = BgL__ortest_1069z00_3435;
													}
												else
													{	/* Eval/evaluate.scm 151 */
														obj_t BgL__ortest_1070z00_3436;

														BgL__ortest_1070z00_3436 =
															BGl_getzd2sourcezd2locationz00zz__readerz00
															(BgL_srcsz00_1421);
														if (CBOOL(BgL__ortest_1070z00_3436))
															{	/* Eval/evaluate.scm 151 */
																BgL_locz00_1427 = BgL__ortest_1070z00_3436;
															}
														else
															{	/* Eval/evaluate.scm 151 */
																BgL_locz00_1427 = BgL_locz00_4949;
															}
													}
											}
										}
										{	/* Eval/evaluate.scm 347 */
											obj_t BgL_arg1502z00_1428;

											{	/* Eval/evaluate.scm 347 */
												obj_t BgL_arg1503z00_1429;
												obj_t BgL_arg1504z00_1430;

												BgL_arg1503z00_1429 = CDR(((obj_t) BgL_varsz00_1420));
												BgL_arg1504z00_1430 = CDR(((obj_t) BgL_srcsz00_1421));
												BgL_arg1502z00_1428 =
													BGl_loopze71ze7zz__evaluatez00(BgL_bodyz00_4951,
													BgL_procnamez00_4950, BgL_locz00_4949,
													BgL_arg1503z00_1429, BgL_arg1504z00_1430);
											}
											return
												BGl_typezd2checkzd2zz__evaluatez00(BgL_idz00_1425,
												BgL_tnamez00_1426, BgL_locz00_1427,
												BgL_procnamez00_4950, BgL_arg1502z00_1428);
										}
									}
								else
									{	/* Eval/evaluate.scm 348 */
										obj_t BgL_arg1506z00_1432;
										obj_t BgL_arg1507z00_1433;

										BgL_arg1506z00_1432 = CDR(((obj_t) BgL_varsz00_1420));
										BgL_arg1507z00_1433 = CDR(((obj_t) BgL_srcsz00_1421));
										{
											obj_t BgL_srcsz00_5496;
											obj_t BgL_varsz00_5495;

											BgL_varsz00_5495 = BgL_arg1506z00_1432;
											BgL_srcsz00_5496 = BgL_arg1507z00_1433;
											BgL_srcsz00_1421 = BgL_srcsz00_5496;
											BgL_varsz00_1420 = BgL_varsz00_5495;
											goto BGl_loopze71ze7zz__evaluatez00;
										}
									}
							}
						}
					}
				}
		}

	}



/* type-result */
	obj_t BGl_typezd2resultzd2zz__evaluatez00(obj_t BgL_typez00_66,
		obj_t BgL_bodyz00_67, obj_t BgL_locz00_68)
	{
		{	/* Eval/evaluate.scm 353 */
			{	/* Eval/evaluate.scm 354 */
				bool_t BgL_test3422z00_5497;

				if (CBOOL(BgL_typez00_66))
					{	/* Eval/evaluate.scm 354 */
						int BgL_arg1530z00_1450;

						BgL_arg1530z00_1450 = bgl_debug();
						BgL_test3422z00_5497 = ((long) (BgL_arg1530z00_1450) >= ((long) 1));
					}
				else
					{	/* Eval/evaluate.scm 354 */
						BgL_test3422z00_5497 = ((bool_t) 0);
					}
				if (BgL_test3422z00_5497)
					{	/* Eval/evaluate.scm 355 */
						obj_t BgL_tmpz00_1438;

						BgL_tmpz00_1438 =
							BGl_gensymz00zz__r4_symbols_6_4z00
							(BGl_symbol3250z00zz__evaluatez00);
						{	/* Eval/evaluate.scm 357 */
							obj_t BgL_arg1513z00_1439;
							obj_t BgL_arg1514z00_1440;

							{	/* Eval/evaluate.scm 357 */
								obj_t BgL_arg1516z00_1441;

								{	/* Eval/evaluate.scm 357 */
									obj_t BgL_arg1517z00_1442;
									obj_t BgL_arg1519z00_1443;

									{	/* Eval/evaluate.scm 357 */
										obj_t BgL_arg1520z00_1444;

										{	/* Eval/evaluate.scm 357 */
											obj_t BgL_arg1521z00_1445;
											obj_t BgL_arg1523z00_1446;

											{	/* Eval/evaluate.scm 357 */
												obj_t BgL_arg1524z00_1447;

												{	/* Eval/evaluate.scm 357 */
													obj_t BgL_list1525z00_1448;

													{	/* Eval/evaluate.scm 357 */
														obj_t BgL_arg1528z00_1449;

														BgL_arg1528z00_1449 =
															MAKE_YOUNG_PAIR(BgL_typez00_66, BNIL);
														BgL_list1525z00_1448 =
															MAKE_YOUNG_PAIR(BgL_tmpz00_1438,
															BgL_arg1528z00_1449);
													}
													BgL_arg1524z00_1447 =
														BGl_formatz00zz__r4_output_6_10_3z00
														(BGl_string3252z00zz__evaluatez00,
														BgL_list1525z00_1448);
												}
												BgL_arg1521z00_1445 =
													bstring_to_symbol(BgL_arg1524z00_1447);
											}
											BgL_arg1523z00_1446 =
												MAKE_YOUNG_PAIR(BgL_bodyz00_67, BNIL);
											BgL_arg1520z00_1444 =
												MAKE_YOUNG_PAIR(BgL_arg1521z00_1445,
												BgL_arg1523z00_1446);
										}
										BgL_arg1517z00_1442 =
											MAKE_YOUNG_PAIR(BgL_arg1520z00_1444, BNIL);
									}
									BgL_arg1519z00_1443 = MAKE_YOUNG_PAIR(BgL_tmpz00_1438, BNIL);
									BgL_arg1516z00_1441 =
										MAKE_YOUNG_PAIR(BgL_arg1517z00_1442, BgL_arg1519z00_1443);
								}
								BgL_arg1513z00_1439 =
									MAKE_YOUNG_PAIR(BGl_symbol3240z00zz__evaluatez00,
									BgL_arg1516z00_1441);
							}
							{	/* Eval/evaluate.scm 144 */
								obj_t BgL__ortest_1068z00_3445;

								BgL__ortest_1068z00_3445 =
									BGl_getzd2sourcezd2locationz00zz__readerz00(BgL_bodyz00_67);
								if (CBOOL(BgL__ortest_1068z00_3445))
									{	/* Eval/evaluate.scm 144 */
										BgL_arg1514z00_1440 = BgL__ortest_1068z00_3445;
									}
								else
									{	/* Eval/evaluate.scm 144 */
										BgL_arg1514z00_1440 = BgL_locz00_68;
									}
							}
							{	/* Eval/evaluate.scm 293 */
								obj_t BgL_arg1425z00_3446;
								obj_t BgL_arg1426z00_3447;

								BgL_arg1425z00_3446 = CAR(BgL_arg1513z00_1439);
								BgL_arg1426z00_3447 = CDR(BgL_arg1513z00_1439);
								{	/* Eval/evaluate.scm 293 */
									obj_t BgL_res2862z00_3450;

									BgL_res2862z00_3450 =
										MAKE_YOUNG_EPAIR(BgL_arg1425z00_3446, BgL_arg1426z00_3447,
										BgL_arg1514z00_1440);
									return BgL_res2862z00_3450;
								}
							}
						}
					}
				else
					{	/* Eval/evaluate.scm 354 */
						return BgL_bodyz00_67;
					}
			}
		}

	}



/* conv */
	obj_t BGl_convz00zz__evaluatez00(obj_t BgL_ez00_69, obj_t BgL_localsz00_70,
		obj_t BgL_globalsz00_71, obj_t BgL_tailzf3zf3_72, obj_t BgL_wherez00_73,
		obj_t BgL_locz00_74, bool_t BgL_topzf3zf3_75)
	{
		{	/* Eval/evaluate.scm 365 */
		BGl_convz00zz__evaluatez00:
			{
				obj_t BgL_xz00_1459;
				obj_t BgL_bahz00_1461;
				obj_t BgL_lz00_1466;
				obj_t BgL_funz00_1468;
				obj_t BgL_argsz00_1469;
				obj_t BgL_pz00_1475;
				obj_t BgL_tz00_1476;
				obj_t BgL_oz00_1477;
				obj_t BgL_pz00_1479;
				obj_t BgL_tz00_1480;
				obj_t BgL_bindsz00_1488;
				obj_t BgL_bodyz00_1489;
				obj_t BgL_bindsz00_1491;
				obj_t BgL_bodyz00_1492;
				obj_t BgL_bindsz00_1494;
				obj_t BgL_bodyz00_1495;
				obj_t BgL_lz00_1501;
				obj_t BgL_e2z00_1502;
				obj_t BgL_vz00_1504;
				obj_t BgL_ez00_1505;
				obj_t BgL_gvz00_1508;
				obj_t BgL_formalsz00_1509;
				obj_t BgL_bodyz00_1510;
				obj_t BgL_gvz00_1512;
				obj_t BgL_gez00_1513;
				obj_t BgL_vz00_1515;
				obj_t BgL_bodyz00_1516;
				obj_t BgL_mz00_1528;
				obj_t BgL_bodyz00_1529;
				obj_t BgL_fz00_1534;
				obj_t BgL_argsz00_1535;

				if (PAIRP(BgL_ez00_69))
					{	/* Eval/evaluate.scm 424 */
						if ((CAR(BgL_ez00_69) == BGl_symbol3259z00zz__evaluatez00))
							{	/* Eval/evaluate.scm 424 */
								BgL_bahz00_1461 = CDR(BgL_ez00_69);
								if (BgL_topzf3zf3_75)
									{	/* Eval/evaluate.scm 432 */
										obj_t BgL_formsz00_2319;

										{	/* Eval/evaluate.scm 432 */
											obj_t BgL_arg2241z00_2322;

											{	/* Eval/evaluate.scm 144 */
												obj_t BgL__ortest_1068z00_3502;

												BgL__ortest_1068z00_3502 =
													BGl_getzd2sourcezd2locationz00zz__readerz00
													(BgL_ez00_69);
												if (CBOOL(BgL__ortest_1068z00_3502))
													{	/* Eval/evaluate.scm 144 */
														BgL_arg2241z00_2322 = BgL__ortest_1068z00_3502;
													}
												else
													{	/* Eval/evaluate.scm 144 */
														BgL_arg2241z00_2322 = BgL_locz00_74;
													}
											}
											BgL_formsz00_2319 =
												BGl_evmodulez00zz__evmodulez00(BgL_ez00_69,
												BgL_arg2241z00_2322);
										}
										{	/* Eval/evaluate.scm 433 */
											obj_t BgL_arg2238z00_2320;
											obj_t BgL_arg2239z00_2321;

											BgL_arg2238z00_2320 =
												BGl_expandz00zz__expandz00(BgL_formsz00_2319);
											BgL_arg2239z00_2321 = BGL_MODULE();
											{
												bool_t BgL_topzf3zf3_5536;
												obj_t BgL_wherez00_5535;
												obj_t BgL_tailzf3zf3_5534;
												obj_t BgL_globalsz00_5533;
												obj_t BgL_ez00_5532;

												BgL_ez00_5532 = BgL_arg2238z00_2320;
												BgL_globalsz00_5533 = BgL_arg2239z00_2321;
												BgL_tailzf3zf3_5534 = BgL_wherez00_73;
												BgL_wherez00_5535 = BFALSE;
												BgL_topzf3zf3_5536 = ((bool_t) 1);
												BgL_topzf3zf3_75 = BgL_topzf3zf3_5536;
												BgL_wherez00_73 = BgL_wherez00_5535;
												BgL_tailzf3zf3_72 = BgL_tailzf3zf3_5534;
												BgL_globalsz00_71 = BgL_globalsz00_5533;
												BgL_ez00_69 = BgL_ez00_5532;
												goto BGl_convz00zz__evaluatez00;
											}
										}
									}
								else
									{	/* Eval/evaluate.scm 431 */
										return
											BGl_evcompilezd2errorzd2zz__evcompilez00(BgL_locz00_74,
											BGl_string3178z00zz__evaluatez00,
											BGl_string3258z00zz__evaluatez00, BgL_ez00_69);
									}
							}
						else
							{	/* Eval/evaluate.scm 424 */
								obj_t BgL_cdrzd2249zd2_1543;

								BgL_cdrzd2249zd2_1543 = CDR(BgL_ez00_69);
								if ((CAR(BgL_ez00_69) == BGl_symbol3261z00zz__evaluatez00))
									{	/* Eval/evaluate.scm 424 */
										if (PAIRP(BgL_cdrzd2249zd2_1543))
											{	/* Eval/evaluate.scm 424 */
												obj_t BgL_carzd2252zd2_1547;
												obj_t BgL_cdrzd2253zd2_1548;

												BgL_carzd2252zd2_1547 = CAR(BgL_cdrzd2249zd2_1543);
												BgL_cdrzd2253zd2_1548 = CDR(BgL_cdrzd2249zd2_1543);
												if (SYMBOLP(BgL_carzd2252zd2_1547))
													{	/* Eval/evaluate.scm 424 */
														if (PAIRP(BgL_cdrzd2253zd2_1548))
															{	/* Eval/evaluate.scm 424 */
																obj_t BgL_carzd2257zd2_1551;

																BgL_carzd2257zd2_1551 =
																	CAR(BgL_cdrzd2253zd2_1548);
																if (SYMBOLP(BgL_carzd2257zd2_1551))
																	{	/* Eval/evaluate.scm 424 */
																		if (NULLP(CDR(BgL_cdrzd2253zd2_1548)))
																			{	/* Eval/evaluate.scm 437 */
																				BgL_ev_globalz00_bglt
																					BgL_new1106z00_3901;
																				{	/* Eval/evaluate.scm 438 */
																					BgL_ev_globalz00_bglt
																						BgL_new1105z00_3902;
																					BgL_new1105z00_3902 =
																						((BgL_ev_globalz00_bglt)
																						BOBJECT(GC_MALLOC(sizeof(struct
																									BgL_ev_globalz00_bgl))));
																					{	/* Eval/evaluate.scm 438 */
																						long BgL_arg2242z00_3903;

																						{	/* Eval/evaluate.scm 438 */
																							long BgL_res2963z00_3905;

																							BgL_res2963z00_3905 =
																								BGL_CLASS_INDEX
																								(BGl_ev_globalz00zz__evaluate_typesz00);
																							BgL_arg2242z00_3903 =
																								BgL_res2963z00_3905;
																						}
																						BGL_OBJECT_CLASS_NUM_SET(
																							((BgL_objectz00_bglt)
																								BgL_new1105z00_3902),
																							BgL_arg2242z00_3903);
																					}
																					BgL_new1106z00_3901 =
																						BgL_new1105z00_3902;
																				}
																				((((BgL_ev_globalz00_bglt)
																							COBJECT(BgL_new1106z00_3901))->
																						BgL_locz00) =
																					((obj_t) BgL_locz00_74), BUNSPEC);
																				((((BgL_ev_globalz00_bglt)
																							COBJECT(BgL_new1106z00_3901))->
																						BgL_namez00) =
																					((obj_t) BgL_carzd2252zd2_1547),
																					BUNSPEC);
																				((((BgL_ev_globalz00_bglt)
																							COBJECT(BgL_new1106z00_3901))->
																						BgL_modz00) =
																					((obj_t)
																						BGl_evalzd2findzd2modulez00zz__evmodulez00
																						(BgL_carzd2257zd2_1551)), BUNSPEC);
																				return ((obj_t) BgL_new1106z00_3901);
																			}
																		else
																			{	/* Eval/evaluate.scm 424 */
																				obj_t BgL_carzd2302zd2_1555;

																				BgL_carzd2302zd2_1555 =
																					CAR(BgL_ez00_69);
																				if (SYMBOLP(BgL_carzd2302zd2_1555))
																					{	/* Eval/evaluate.scm 424 */
																						if (CBOOL
																							(BGl_convzd2varzd2zz__evaluatez00
																								(BgL_carzd2302zd2_1555,
																									BgL_localsz00_70)))
																							{
																								BgL_ev_appz00_bglt
																									BgL_auxz00_5572;
																								BgL_funz00_1468 =
																									BgL_carzd2302zd2_1555;
																								BgL_argsz00_1469 =
																									BgL_cdrzd2249zd2_1543;
																							BgL_tagzd2152zd2_1470:
																								{	/* Eval/evaluate.scm 449 */
																									obj_t BgL_funz00_2352;
																									obj_t BgL_argsz00_2353;

																									{	/* Eval/evaluate.scm 380 */
																										obj_t BgL_arg2395z00_3517;

																										{	/* Eval/evaluate.scm 144 */
																											obj_t
																												BgL__ortest_1068z00_3518;
																											BgL__ortest_1068z00_3518 =
																												BGl_getzd2sourcezd2locationz00zz__readerz00
																												(BgL_funz00_1468);
																											if (CBOOL
																												(BgL__ortest_1068z00_3518))
																												{	/* Eval/evaluate.scm 144 */
																													BgL_arg2395z00_3517 =
																														BgL__ortest_1068z00_3518;
																												}
																											else
																												{	/* Eval/evaluate.scm 144 */
																													BgL_arg2395z00_3517 =
																														BgL_locz00_74;
																												}
																										}
																										BgL_funz00_2352 =
																											BGl_convz00zz__evaluatez00
																											(BgL_funz00_1468,
																											BgL_localsz00_70,
																											BgL_globalsz00_71, BFALSE,
																											BgL_wherez00_73,
																											BgL_arg2395z00_3517,
																											((bool_t) 0));
																									}
																									BgL_argsz00_2353 =
																										BGl_loopze70ze7zz__evaluatez00
																										(BgL_wherez00_73,
																										BgL_globalsz00_71,
																										BgL_localsz00_70,
																										BgL_locz00_74,
																										BgL_argsz00_1469);
																									{	/* Eval/evaluate.scm 450 */
																										BgL_ev_appz00_bglt
																											BgL_new1108z00_2354;
																										{	/* Eval/evaluate.scm 451 */
																											BgL_ev_appz00_bglt
																												BgL_new1107z00_2355;
																											BgL_new1107z00_2355 =
																												((BgL_ev_appz00_bglt)
																												BOBJECT(GC_MALLOC(sizeof
																														(struct
																															BgL_ev_appz00_bgl))));
																											{	/* Eval/evaluate.scm 451 */
																												long
																													BgL_arg2257z00_2356;
																												{	/* Eval/evaluate.scm 451 */
																													long
																														BgL_res2884z00_3520;
																													BgL_res2884z00_3520 =
																														BGL_CLASS_INDEX
																														(BGl_ev_appz00zz__evaluate_typesz00);
																													BgL_arg2257z00_2356 =
																														BgL_res2884z00_3520;
																												}
																												BGL_OBJECT_CLASS_NUM_SET
																													(((BgL_objectz00_bglt)
																														BgL_new1107z00_2355),
																													BgL_arg2257z00_2356);
																											}
																											BgL_new1108z00_2354 =
																												BgL_new1107z00_2355;
																										}
																										((((BgL_ev_appz00_bglt)
																													COBJECT
																													(BgL_new1108z00_2354))->
																												BgL_locz00) =
																											((obj_t) BgL_locz00_74),
																											BUNSPEC);
																										((((BgL_ev_appz00_bglt)
																													COBJECT
																													(BgL_new1108z00_2354))->
																												BgL_funz00) =
																											((BgL_ev_exprz00_bglt) (
																													(BgL_ev_exprz00_bglt)
																													BgL_funz00_2352)),
																											BUNSPEC);
																										((((BgL_ev_appz00_bglt)
																													COBJECT
																													(BgL_new1108z00_2354))->
																												BgL_argsz00) =
																											((obj_t)
																												BgL_argsz00_2353),
																											BUNSPEC);
																										((((BgL_ev_appz00_bglt)
																													COBJECT
																													(BgL_new1108z00_2354))->
																												BgL_tailzf3zf3) =
																											((obj_t)
																												BgL_tailzf3zf3_72),
																											BUNSPEC);
																										BgL_auxz00_5572 =
																											BgL_new1108z00_2354;
																								}}
																								return
																									((obj_t) BgL_auxz00_5572);
																							}
																						else
																							{
																								BgL_ev_appz00_bglt
																									BgL_auxz00_5588;
																								BgL_fz00_1534 =
																									BgL_carzd2302zd2_1555;
																								BgL_argsz00_1535 =
																									BgL_cdrzd2249zd2_1543;
																							BgL_tagzd2175zd2_1536:
																								{	/* Eval/evaluate.scm 597 */
																									obj_t BgL_funz00_2618;
																									obj_t BgL_argsz00_2619;

																									{	/* Eval/evaluate.scm 380 */
																										obj_t BgL_arg2395z00_3881;

																										{	/* Eval/evaluate.scm 144 */
																											obj_t
																												BgL__ortest_1068z00_3882;
																											BgL__ortest_1068z00_3882 =
																												BGl_getzd2sourcezd2locationz00zz__readerz00
																												(BgL_fz00_1534);
																											if (CBOOL
																												(BgL__ortest_1068z00_3882))
																												{	/* Eval/evaluate.scm 144 */
																													BgL_arg2395z00_3881 =
																														BgL__ortest_1068z00_3882;
																												}
																											else
																												{	/* Eval/evaluate.scm 144 */
																													BgL_arg2395z00_3881 =
																														BgL_locz00_74;
																												}
																										}
																										BgL_funz00_2618 =
																											BGl_convz00zz__evaluatez00
																											(BgL_fz00_1534,
																											BgL_localsz00_70,
																											BgL_globalsz00_71, BFALSE,
																											BgL_wherez00_73,
																											BgL_arg2395z00_3881,
																											((bool_t) 0));
																									}
																									BgL_argsz00_2619 =
																										BGl_loopze70ze7zz__evaluatez00
																										(BgL_wherez00_73,
																										BgL_globalsz00_71,
																										BgL_localsz00_70,
																										BgL_locz00_74,
																										BgL_argsz00_1535);
																									{	/* Eval/evaluate.scm 598 */
																										BgL_ev_appz00_bglt
																											BgL_new1161z00_2620;
																										{	/* Eval/evaluate.scm 599 */
																											BgL_ev_appz00_bglt
																												BgL_new1160z00_2621;
																											BgL_new1160z00_2621 =
																												((BgL_ev_appz00_bglt)
																												BOBJECT(GC_MALLOC(sizeof
																														(struct
																															BgL_ev_appz00_bgl))));
																											{	/* Eval/evaluate.scm 599 */
																												long
																													BgL_arg2388z00_2622;
																												{	/* Eval/evaluate.scm 599 */
																													long
																														BgL_res2956z00_3884;
																													BgL_res2956z00_3884 =
																														BGL_CLASS_INDEX
																														(BGl_ev_appz00zz__evaluate_typesz00);
																													BgL_arg2388z00_2622 =
																														BgL_res2956z00_3884;
																												}
																												BGL_OBJECT_CLASS_NUM_SET
																													(((BgL_objectz00_bglt)
																														BgL_new1160z00_2621),
																													BgL_arg2388z00_2622);
																											}
																											BgL_new1161z00_2620 =
																												BgL_new1160z00_2621;
																										}
																										((((BgL_ev_appz00_bglt)
																													COBJECT
																													(BgL_new1161z00_2620))->
																												BgL_locz00) =
																											((obj_t) BgL_locz00_74),
																											BUNSPEC);
																										((((BgL_ev_appz00_bglt)
																													COBJECT
																													(BgL_new1161z00_2620))->
																												BgL_funz00) =
																											((BgL_ev_exprz00_bglt) (
																													(BgL_ev_exprz00_bglt)
																													BgL_funz00_2618)),
																											BUNSPEC);
																										((((BgL_ev_appz00_bglt)
																													COBJECT
																													(BgL_new1161z00_2620))->
																												BgL_argsz00) =
																											((obj_t)
																												BgL_argsz00_2619),
																											BUNSPEC);
																										((((BgL_ev_appz00_bglt)
																													COBJECT
																													(BgL_new1161z00_2620))->
																												BgL_tailzf3zf3) =
																											((obj_t)
																												BgL_tailzf3zf3_72),
																											BUNSPEC);
																										BgL_auxz00_5588 =
																											BgL_new1161z00_2620;
																								}}
																								return
																									((obj_t) BgL_auxz00_5588);
																							}
																					}
																				else
																					{
																						BgL_ev_appz00_bglt BgL_auxz00_5604;

																						{
																							obj_t BgL_argsz00_5606;
																							obj_t BgL_fz00_5605;

																							BgL_fz00_5605 =
																								BgL_carzd2302zd2_1555;
																							BgL_argsz00_5606 =
																								BgL_cdrzd2249zd2_1543;
																							BgL_argsz00_1535 =
																								BgL_argsz00_5606;
																							BgL_fz00_1534 = BgL_fz00_5605;
																							goto BgL_tagzd2175zd2_1536;
																						}
																						return ((obj_t) BgL_auxz00_5604);
																					}
																			}
																	}
																else
																	{	/* Eval/evaluate.scm 424 */
																		obj_t BgL_carzd21005zd2_1566;

																		BgL_carzd21005zd2_1566 = CAR(BgL_ez00_69);
																		if (SYMBOLP(BgL_carzd21005zd2_1566))
																			{	/* Eval/evaluate.scm 424 */
																				if (CBOOL
																					(BGl_convzd2varzd2zz__evaluatez00
																						(BgL_carzd21005zd2_1566,
																							BgL_localsz00_70)))
																					{
																						BgL_ev_appz00_bglt BgL_auxz00_5614;

																						{
																							obj_t BgL_argsz00_5616;
																							obj_t BgL_funz00_5615;

																							BgL_funz00_5615 =
																								BgL_carzd21005zd2_1566;
																							BgL_argsz00_5616 =
																								BgL_cdrzd2249zd2_1543;
																							BgL_argsz00_1469 =
																								BgL_argsz00_5616;
																							BgL_funz00_1468 = BgL_funz00_5615;
																							goto BgL_tagzd2152zd2_1470;
																						}
																						return ((obj_t) BgL_auxz00_5614);
																					}
																				else
																					{
																						BgL_ev_appz00_bglt BgL_auxz00_5618;

																						{
																							obj_t BgL_argsz00_5620;
																							obj_t BgL_fz00_5619;

																							BgL_fz00_5619 =
																								BgL_carzd21005zd2_1566;
																							BgL_argsz00_5620 =
																								BgL_cdrzd2249zd2_1543;
																							BgL_argsz00_1535 =
																								BgL_argsz00_5620;
																							BgL_fz00_1534 = BgL_fz00_5619;
																							goto BgL_tagzd2175zd2_1536;
																						}
																						return ((obj_t) BgL_auxz00_5618);
																					}
																			}
																		else
																			{
																				BgL_ev_appz00_bglt BgL_auxz00_5622;

																				{
																					obj_t BgL_argsz00_5624;
																					obj_t BgL_fz00_5623;

																					BgL_fz00_5623 =
																						BgL_carzd21005zd2_1566;
																					BgL_argsz00_5624 =
																						BgL_cdrzd2249zd2_1543;
																					BgL_argsz00_1535 = BgL_argsz00_5624;
																					BgL_fz00_1534 = BgL_fz00_5623;
																					goto BgL_tagzd2175zd2_1536;
																				}
																				return ((obj_t) BgL_auxz00_5622);
																			}
																	}
															}
														else
															{	/* Eval/evaluate.scm 424 */
																obj_t BgL_carzd21708zd2_1576;

																BgL_carzd21708zd2_1576 = CAR(BgL_ez00_69);
																if (SYMBOLP(BgL_carzd21708zd2_1576))
																	{	/* Eval/evaluate.scm 424 */
																		if (CBOOL(BGl_convzd2varzd2zz__evaluatez00
																				(BgL_carzd21708zd2_1576,
																					BgL_localsz00_70)))
																			{
																				BgL_ev_appz00_bglt BgL_auxz00_5632;

																				{
																					obj_t BgL_argsz00_5634;
																					obj_t BgL_funz00_5633;

																					BgL_funz00_5633 =
																						BgL_carzd21708zd2_1576;
																					BgL_argsz00_5634 =
																						BgL_cdrzd2249zd2_1543;
																					BgL_argsz00_1469 = BgL_argsz00_5634;
																					BgL_funz00_1468 = BgL_funz00_5633;
																					goto BgL_tagzd2152zd2_1470;
																				}
																				return ((obj_t) BgL_auxz00_5632);
																			}
																		else
																			{
																				BgL_ev_appz00_bglt BgL_auxz00_5636;

																				{
																					obj_t BgL_argsz00_5638;
																					obj_t BgL_fz00_5637;

																					BgL_fz00_5637 =
																						BgL_carzd21708zd2_1576;
																					BgL_argsz00_5638 =
																						BgL_cdrzd2249zd2_1543;
																					BgL_argsz00_1535 = BgL_argsz00_5638;
																					BgL_fz00_1534 = BgL_fz00_5637;
																					goto BgL_tagzd2175zd2_1536;
																				}
																				return ((obj_t) BgL_auxz00_5636);
																			}
																	}
																else
																	{
																		BgL_ev_appz00_bglt BgL_auxz00_5640;

																		{
																			obj_t BgL_argsz00_5642;
																			obj_t BgL_fz00_5641;

																			BgL_fz00_5641 = BgL_carzd21708zd2_1576;
																			BgL_argsz00_5642 = BgL_cdrzd2249zd2_1543;
																			BgL_argsz00_1535 = BgL_argsz00_5642;
																			BgL_fz00_1534 = BgL_fz00_5641;
																			goto BgL_tagzd2175zd2_1536;
																		}
																		return ((obj_t) BgL_auxz00_5640);
																	}
															}
													}
												else
													{	/* Eval/evaluate.scm 424 */
														obj_t BgL_carzd22411zd2_1586;

														BgL_carzd22411zd2_1586 = CAR(BgL_ez00_69);
														if (SYMBOLP(BgL_carzd22411zd2_1586))
															{	/* Eval/evaluate.scm 424 */
																if (CBOOL(BGl_convzd2varzd2zz__evaluatez00
																		(BgL_carzd22411zd2_1586, BgL_localsz00_70)))
																	{
																		BgL_ev_appz00_bglt BgL_auxz00_5650;

																		{
																			obj_t BgL_argsz00_5652;
																			obj_t BgL_funz00_5651;

																			BgL_funz00_5651 = BgL_carzd22411zd2_1586;
																			BgL_argsz00_5652 = BgL_cdrzd2249zd2_1543;
																			BgL_argsz00_1469 = BgL_argsz00_5652;
																			BgL_funz00_1468 = BgL_funz00_5651;
																			goto BgL_tagzd2152zd2_1470;
																		}
																		return ((obj_t) BgL_auxz00_5650);
																	}
																else
																	{
																		BgL_ev_appz00_bglt BgL_auxz00_5654;

																		{
																			obj_t BgL_argsz00_5656;
																			obj_t BgL_fz00_5655;

																			BgL_fz00_5655 = BgL_carzd22411zd2_1586;
																			BgL_argsz00_5656 = BgL_cdrzd2249zd2_1543;
																			BgL_argsz00_1535 = BgL_argsz00_5656;
																			BgL_fz00_1534 = BgL_fz00_5655;
																			goto BgL_tagzd2175zd2_1536;
																		}
																		return ((obj_t) BgL_auxz00_5654);
																	}
															}
														else
															{
																BgL_ev_appz00_bglt BgL_auxz00_5658;

																{
																	obj_t BgL_argsz00_5660;
																	obj_t BgL_fz00_5659;

																	BgL_fz00_5659 = BgL_carzd22411zd2_1586;
																	BgL_argsz00_5660 = BgL_cdrzd2249zd2_1543;
																	BgL_argsz00_1535 = BgL_argsz00_5660;
																	BgL_fz00_1534 = BgL_fz00_5659;
																	goto BgL_tagzd2175zd2_1536;
																}
																return ((obj_t) BgL_auxz00_5658);
															}
													}
											}
										else
											{	/* Eval/evaluate.scm 424 */
												obj_t BgL_carzd23114zd2_1596;

												BgL_carzd23114zd2_1596 = CAR(BgL_ez00_69);
												if (SYMBOLP(BgL_carzd23114zd2_1596))
													{	/* Eval/evaluate.scm 424 */
														if (CBOOL(BGl_convzd2varzd2zz__evaluatez00
																(BgL_carzd23114zd2_1596, BgL_localsz00_70)))
															{
																BgL_ev_appz00_bglt BgL_auxz00_5668;

																{
																	obj_t BgL_argsz00_5670;
																	obj_t BgL_funz00_5669;

																	BgL_funz00_5669 = BgL_carzd23114zd2_1596;
																	BgL_argsz00_5670 = BgL_cdrzd2249zd2_1543;
																	BgL_argsz00_1469 = BgL_argsz00_5670;
																	BgL_funz00_1468 = BgL_funz00_5669;
																	goto BgL_tagzd2152zd2_1470;
																}
																return ((obj_t) BgL_auxz00_5668);
															}
														else
															{
																BgL_ev_appz00_bglt BgL_auxz00_5672;

																{
																	obj_t BgL_argsz00_5674;
																	obj_t BgL_fz00_5673;

																	BgL_fz00_5673 = BgL_carzd23114zd2_1596;
																	BgL_argsz00_5674 = BgL_cdrzd2249zd2_1543;
																	BgL_argsz00_1535 = BgL_argsz00_5674;
																	BgL_fz00_1534 = BgL_fz00_5673;
																	goto BgL_tagzd2175zd2_1536;
																}
																return ((obj_t) BgL_auxz00_5672);
															}
													}
												else
													{
														BgL_ev_appz00_bglt BgL_auxz00_5676;

														{
															obj_t BgL_argsz00_5678;
															obj_t BgL_fz00_5677;

															BgL_fz00_5677 = BgL_carzd23114zd2_1596;
															BgL_argsz00_5678 = BgL_cdrzd2249zd2_1543;
															BgL_argsz00_1535 = BgL_argsz00_5678;
															BgL_fz00_1534 = BgL_fz00_5677;
															goto BgL_tagzd2175zd2_1536;
														}
														return ((obj_t) BgL_auxz00_5676);
													}
											}
									}
								else
									{	/* Eval/evaluate.scm 424 */
										if ((CAR(BgL_ez00_69) == BGl_symbol3263z00zz__evaluatez00))
											{	/* Eval/evaluate.scm 424 */
												BgL_lz00_1466 = BgL_cdrzd2249zd2_1543;
												{	/* Eval/evaluate.scm 442 */
													bool_t BgL_test3448z00_5683;

													if (PAIRP(BgL_lz00_1466))
														{	/* Eval/evaluate.scm 442 */
															bool_t BgL_test3450z00_5686;

															{	/* Eval/evaluate.scm 442 */
																obj_t BgL_tmpz00_5687;

																BgL_tmpz00_5687 = CDR(BgL_lz00_1466);
																BgL_test3450z00_5686 = PAIRP(BgL_tmpz00_5687);
															}
															if (BgL_test3450z00_5686)
																{
																	obj_t BgL_l1210z00_2343;

																	BgL_l1210z00_2343 = BgL_lz00_1466;
																BgL_zc3z04anonymousza32252ze3z87_2344:
																	if (NULLP(BgL_l1210z00_2343))
																		{	/* Eval/evaluate.scm 442 */
																			BgL_test3448z00_5683 = ((bool_t) 1);
																		}
																	else
																		{	/* Eval/evaluate.scm 442 */
																			bool_t BgL_test3452z00_5692;

																			{	/* Eval/evaluate.scm 442 */
																				obj_t BgL_tmpz00_5693;

																				BgL_tmpz00_5693 =
																					CAR(((obj_t) BgL_l1210z00_2343));
																				BgL_test3452z00_5692 =
																					SYMBOLP(BgL_tmpz00_5693);
																			}
																			if (BgL_test3452z00_5692)
																				{
																					obj_t BgL_l1210z00_5697;

																					BgL_l1210z00_5697 =
																						CDR(((obj_t) BgL_l1210z00_2343));
																					BgL_l1210z00_2343 = BgL_l1210z00_5697;
																					goto
																						BgL_zc3z04anonymousza32252ze3z87_2344;
																				}
																			else
																				{	/* Eval/evaluate.scm 442 */
																					BgL_test3448z00_5683 = ((bool_t) 0);
																				}
																		}
																}
															else
																{	/* Eval/evaluate.scm 442 */
																	BgL_test3448z00_5683 = ((bool_t) 0);
																}
														}
													else
														{	/* Eval/evaluate.scm 442 */
															BgL_test3448z00_5683 = ((bool_t) 0);
														}
													if (BgL_test3448z00_5683)
														{	/* Eval/evaluate.scm 442 */
															return
																BGl_convzd2fieldzd2refz00zz__evaluatez00
																(BgL_ez00_69, BgL_localsz00_70,
																BgL_globalsz00_71, BgL_tailzf3zf3_72,
																BgL_wherez00_73, BgL_locz00_74,
																BgL_topzf3zf3_75);
														}
													else
														{	/* Eval/evaluate.scm 442 */
															return
																BGl_evcompilezd2errorzd2zz__evcompilez00
																(BgL_locz00_74,
																BGl_string3178z00zz__evaluatez00,
																BGl_string3253z00zz__evaluatez00, BgL_ez00_69);
														}
												}
											}
										else
											{	/* Eval/evaluate.scm 424 */
												obj_t BgL_carzd23820zd2_1609;

												BgL_carzd23820zd2_1609 = CAR(BgL_ez00_69);
												if (SYMBOLP(BgL_carzd23820zd2_1609))
													{	/* Eval/evaluate.scm 424 */
														if (CBOOL(BGl_convzd2varzd2zz__evaluatez00
																(BgL_carzd23820zd2_1609, BgL_localsz00_70)))
															{
																BgL_ev_appz00_bglt BgL_auxz00_5708;

																{
																	obj_t BgL_argsz00_5710;
																	obj_t BgL_funz00_5709;

																	BgL_funz00_5709 = BgL_carzd23820zd2_1609;
																	BgL_argsz00_5710 = BgL_cdrzd2249zd2_1543;
																	BgL_argsz00_1469 = BgL_argsz00_5710;
																	BgL_funz00_1468 = BgL_funz00_5709;
																	goto BgL_tagzd2152zd2_1470;
																}
																return ((obj_t) BgL_auxz00_5708);
															}
														else
															{	/* Eval/evaluate.scm 424 */
																if (
																	(BgL_carzd23820zd2_1609 ==
																		BGl_symbol3265z00zz__evaluatez00))
																	{	/* Eval/evaluate.scm 424 */
																		if (PAIRP(BgL_cdrzd2249zd2_1543))
																			{	/* Eval/evaluate.scm 424 */
																				if (NULLP(CDR(BgL_cdrzd2249zd2_1543)))
																					{	/* Eval/evaluate.scm 424 */
																						obj_t BgL_arg1596z00_1620;

																						BgL_arg1596z00_1620 =
																							CAR(BgL_cdrzd2249zd2_1543);
																						{	/* Eval/evaluate.scm 456 */
																							BgL_ev_trapz00_bglt
																								BgL_new1110z00_3954;
																							{	/* Eval/evaluate.scm 457 */
																								BgL_ev_trapz00_bglt
																									BgL_new1109z00_3955;
																								BgL_new1109z00_3955 =
																									((BgL_ev_trapz00_bglt)
																									BOBJECT(GC_MALLOC(sizeof
																											(struct
																												BgL_ev_trapz00_bgl))));
																								{	/* Eval/evaluate.scm 457 */
																									long BgL_arg2258z00_3956;

																									{	/* Eval/evaluate.scm 457 */
																										long BgL_res2972z00_3958;

																										BgL_res2972z00_3958 =
																											BGL_CLASS_INDEX
																											(BGl_ev_trapz00zz__evaluate_typesz00);
																										BgL_arg2258z00_3956 =
																											BgL_res2972z00_3958;
																									}
																									BGL_OBJECT_CLASS_NUM_SET(
																										((BgL_objectz00_bglt)
																											BgL_new1109z00_3955),
																										BgL_arg2258z00_3956);
																								}
																								BgL_new1110z00_3954 =
																									BgL_new1109z00_3955;
																							}
																							{
																								BgL_ev_exprz00_bglt
																									BgL_auxz00_5724;
																								{	/* Eval/evaluate.scm 380 */
																									obj_t BgL_arg2395z00_3961;

																									BgL_arg2395z00_3961 =
																										BGl_getzd2locationzd2zz__evaluatez00
																										(BgL_arg1596z00_1620,
																										BgL_locz00_74);
																									BgL_auxz00_5724 =
																										((BgL_ev_exprz00_bglt)
																										BGl_uconvzf2locze70z15zz__evaluatez00
																										(BgL_wherez00_73,
																											BgL_globalsz00_71,
																											BgL_localsz00_70,
																											BgL_arg1596z00_1620,
																											BgL_arg2395z00_3961));
																								}
																								((((BgL_ev_hookz00_bglt)
																											COBJECT((
																													(BgL_ev_hookz00_bglt)
																													BgL_new1110z00_3954)))->
																										BgL_ez00) =
																									((BgL_ev_exprz00_bglt)
																										BgL_auxz00_5724), BUNSPEC);
																							}
																							return
																								((obj_t) BgL_new1110z00_3954);
																						}
																					}
																				else
																					{	/* Eval/evaluate.scm 424 */
																						obj_t BgL_arg1597z00_1621;
																						obj_t BgL_arg1598z00_1622;

																						BgL_arg1597z00_1621 =
																							CAR(BgL_ez00_69);
																						BgL_arg1598z00_1622 =
																							CDR(BgL_ez00_69);
																						{
																							BgL_ev_appz00_bglt
																								BgL_auxz00_5733;
																							{
																								obj_t BgL_argsz00_5735;
																								obj_t BgL_fz00_5734;

																								BgL_fz00_5734 =
																									BgL_arg1597z00_1621;
																								BgL_argsz00_5735 =
																									BgL_arg1598z00_1622;
																								BgL_argsz00_1535 =
																									BgL_argsz00_5735;
																								BgL_fz00_1534 = BgL_fz00_5734;
																								goto BgL_tagzd2175zd2_1536;
																							}
																							return ((obj_t) BgL_auxz00_5733);
																						}
																					}
																			}
																		else
																			{	/* Eval/evaluate.scm 424 */
																				obj_t BgL_arg1601z00_1624;
																				obj_t BgL_arg1602z00_1625;

																				BgL_arg1601z00_1624 = CAR(BgL_ez00_69);
																				BgL_arg1602z00_1625 = CDR(BgL_ez00_69);
																				{
																					BgL_ev_appz00_bglt BgL_auxz00_5739;

																					{
																						obj_t BgL_argsz00_5741;
																						obj_t BgL_fz00_5740;

																						BgL_fz00_5740 = BgL_arg1601z00_1624;
																						BgL_argsz00_5741 =
																							BgL_arg1602z00_1625;
																						BgL_argsz00_1535 = BgL_argsz00_5741;
																						BgL_fz00_1534 = BgL_fz00_5740;
																						goto BgL_tagzd2175zd2_1536;
																					}
																					return ((obj_t) BgL_auxz00_5739);
																				}
																			}
																	}
																else
																	{	/* Eval/evaluate.scm 424 */
																		obj_t BgL_cdrzd24489zd2_1626;

																		BgL_cdrzd24489zd2_1626 = CDR(BgL_ez00_69);
																		if (
																			(CAR(BgL_ez00_69) ==
																				BGl_symbol3230z00zz__evaluatez00))
																			{	/* Eval/evaluate.scm 424 */
																				if (PAIRP(BgL_cdrzd24489zd2_1626))
																					{	/* Eval/evaluate.scm 424 */
																						if (NULLP(CDR
																								(BgL_cdrzd24489zd2_1626)))
																							{	/* Eval/evaluate.scm 424 */
																								obj_t BgL_arg1608z00_1632;

																								BgL_arg1608z00_1632 =
																									CAR(BgL_cdrzd24489zd2_1626);
																								{	/* Eval/evaluate.scm 459 */
																									BgL_ev_littz00_bglt
																										BgL_new1112z00_3972;
																									{	/* Eval/evaluate.scm 460 */
																										BgL_ev_littz00_bglt
																											BgL_new1111z00_3973;
																										BgL_new1111z00_3973 =
																											((BgL_ev_littz00_bglt)
																											BOBJECT(GC_MALLOC(sizeof
																													(struct
																														BgL_ev_littz00_bgl))));
																										{	/* Eval/evaluate.scm 460 */
																											long BgL_arg2259z00_3974;

																											{	/* Eval/evaluate.scm 460 */
																												long
																													BgL_res2975z00_3976;
																												BgL_res2975z00_3976 =
																													BGL_CLASS_INDEX
																													(BGl_ev_littz00zz__evaluate_typesz00);
																												BgL_arg2259z00_3974 =
																													BgL_res2975z00_3976;
																											}
																											BGL_OBJECT_CLASS_NUM_SET(
																												((BgL_objectz00_bglt)
																													BgL_new1111z00_3973),
																												BgL_arg2259z00_3974);
																										}
																										BgL_new1112z00_3972 =
																											BgL_new1111z00_3973;
																									}
																									((((BgL_ev_littz00_bglt)
																												COBJECT
																												(BgL_new1112z00_3972))->
																											BgL_valuez00) =
																										((obj_t)
																											BgL_arg1608z00_1632),
																										BUNSPEC);
																									return ((obj_t)
																										BgL_new1112z00_3972);
																								}
																							}
																						else
																							{	/* Eval/evaluate.scm 424 */
																								obj_t BgL_arg1609z00_1633;

																								BgL_arg1609z00_1633 =
																									CAR(BgL_ez00_69);
																								{
																									BgL_ev_appz00_bglt
																										BgL_auxz00_5760;
																									{
																										obj_t BgL_argsz00_5762;
																										obj_t BgL_fz00_5761;

																										BgL_fz00_5761 =
																											BgL_arg1609z00_1633;
																										BgL_argsz00_5762 =
																											BgL_cdrzd24489zd2_1626;
																										BgL_argsz00_1535 =
																											BgL_argsz00_5762;
																										BgL_fz00_1534 =
																											BgL_fz00_5761;
																										goto BgL_tagzd2175zd2_1536;
																									}
																									return
																										((obj_t) BgL_auxz00_5760);
																								}
																							}
																					}
																				else
																					{	/* Eval/evaluate.scm 424 */
																						obj_t BgL_arg1614z00_1636;

																						BgL_arg1614z00_1636 =
																							CAR(BgL_ez00_69);
																						{
																							BgL_ev_appz00_bglt
																								BgL_auxz00_5765;
																							{
																								obj_t BgL_argsz00_5767;
																								obj_t BgL_fz00_5766;

																								BgL_fz00_5766 =
																									BgL_arg1614z00_1636;
																								BgL_argsz00_5767 =
																									BgL_cdrzd24489zd2_1626;
																								BgL_argsz00_1535 =
																									BgL_argsz00_5767;
																								BgL_fz00_1534 = BgL_fz00_5766;
																								goto BgL_tagzd2175zd2_1536;
																							}
																							return ((obj_t) BgL_auxz00_5765);
																						}
																					}
																			}
																		else
																			{	/* Eval/evaluate.scm 424 */
																				if (
																					(CAR(BgL_ez00_69) ==
																						BGl_symbol3238z00zz__evaluatez00))
																					{	/* Eval/evaluate.scm 424 */
																						if (PAIRP(BgL_cdrzd24489zd2_1626))
																							{	/* Eval/evaluate.scm 424 */
																								obj_t BgL_cdrzd25099zd2_1642;

																								BgL_cdrzd25099zd2_1642 =
																									CDR(BgL_cdrzd24489zd2_1626);
																								if (PAIRP
																									(BgL_cdrzd25099zd2_1642))
																									{	/* Eval/evaluate.scm 424 */
																										obj_t
																											BgL_cdrzd25104zd2_1644;
																										BgL_cdrzd25104zd2_1644 =
																											CDR
																											(BgL_cdrzd25099zd2_1642);
																										if (PAIRP
																											(BgL_cdrzd25104zd2_1644))
																											{	/* Eval/evaluate.scm 424 */
																												if (NULLP(CDR
																														(BgL_cdrzd25104zd2_1644)))
																													{	/* Eval/evaluate.scm 424 */
																														obj_t
																															BgL_arg1631z00_1648;
																														obj_t
																															BgL_arg1632z00_1649;
																														obj_t
																															BgL_arg1633z00_1650;
																														BgL_arg1631z00_1648
																															=
																															CAR
																															(BgL_cdrzd24489zd2_1626);
																														BgL_arg1632z00_1649
																															=
																															CAR
																															(BgL_cdrzd25099zd2_1642);
																														BgL_arg1633z00_1650
																															=
																															CAR
																															(BgL_cdrzd25104zd2_1644);
																														{
																															BgL_ev_ifz00_bglt
																																BgL_auxz00_5786;
																															BgL_pz00_1475 =
																																BgL_arg1631z00_1648;
																															BgL_tz00_1476 =
																																BgL_arg1632z00_1649;
																															BgL_oz00_1477 =
																																BgL_arg1633z00_1650;
																														BgL_tagzd2155zd2_1478:
																															{	/* Eval/evaluate.scm 462 */
																																BgL_ev_ifz00_bglt
																																	BgL_new1114z00_2363;
																																{	/* Eval/evaluate.scm 463 */
																																	BgL_ev_ifz00_bglt
																																		BgL_new1113z00_2367;
																																	BgL_new1113z00_2367
																																		=
																																		(
																																		(BgL_ev_ifz00_bglt)
																																		BOBJECT
																																		(GC_MALLOC
																																			(sizeof
																																				(struct
																																					BgL_ev_ifz00_bgl))));
																																	{	/* Eval/evaluate.scm 463 */
																																		long
																																			BgL_arg2263z00_2368;
																																		{	/* Eval/evaluate.scm 463 */
																																			long
																																				BgL_res2887z00_3540;
																																			BgL_res2887z00_3540
																																				=
																																				BGL_CLASS_INDEX
																																				(BGl_ev_ifz00zz__evaluate_typesz00);
																																			BgL_arg2263z00_2368
																																				=
																																				BgL_res2887z00_3540;
																																		}
																																		BGL_OBJECT_CLASS_NUM_SET
																																			(((BgL_objectz00_bglt) BgL_new1113z00_2367), BgL_arg2263z00_2368);
																																	}
																																	BgL_new1114z00_2363
																																		=
																																		BgL_new1113z00_2367;
																																}
																																{
																																	BgL_ev_exprz00_bglt
																																		BgL_auxz00_5791;
																																	{	/* Eval/evaluate.scm 463 */
																																		obj_t
																																			BgL_arg2260z00_2364;
																																		{	/* Eval/evaluate.scm 144 */
																																			obj_t
																																				BgL__ortest_1068z00_3543;
																																			BgL__ortest_1068z00_3543
																																				=
																																				BGl_getzd2sourcezd2locationz00zz__readerz00
																																				(BgL_pz00_1475);
																																			if (CBOOL
																																				(BgL__ortest_1068z00_3543))
																																				{	/* Eval/evaluate.scm 144 */
																																					BgL_arg2260z00_2364
																																						=
																																						BgL__ortest_1068z00_3543;
																																				}
																																			else
																																				{	/* Eval/evaluate.scm 144 */
																																					BgL_arg2260z00_2364
																																						=
																																						BgL_locz00_74;
																																				}
																																		}
																																		BgL_auxz00_5791
																																			=
																																			(
																																			(BgL_ev_exprz00_bglt)
																																			BGl_convz00zz__evaluatez00
																																			(BgL_pz00_1475,
																																				BgL_localsz00_70,
																																				BgL_globalsz00_71,
																																				BFALSE,
																																				BgL_wherez00_73,
																																				BgL_arg2260z00_2364,
																																				((bool_t) 0)));
																																	}
																																	((((BgL_ev_ifz00_bglt) COBJECT(BgL_new1114z00_2363))->BgL_pz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5791), BUNSPEC);
																																}
																																{
																																	BgL_ev_exprz00_bglt
																																		BgL_auxz00_5798;
																																	{	/* Eval/evaluate.scm 464 */
																																		obj_t
																																			BgL_arg2261z00_2365;
																																		{	/* Eval/evaluate.scm 144 */
																																			obj_t
																																				BgL__ortest_1068z00_3544;
																																			BgL__ortest_1068z00_3544
																																				=
																																				BGl_getzd2sourcezd2locationz00zz__readerz00
																																				(BgL_tz00_1476);
																																			if (CBOOL
																																				(BgL__ortest_1068z00_3544))
																																				{	/* Eval/evaluate.scm 144 */
																																					BgL_arg2261z00_2365
																																						=
																																						BgL__ortest_1068z00_3544;
																																				}
																																			else
																																				{	/* Eval/evaluate.scm 144 */
																																					BgL_arg2261z00_2365
																																						=
																																						BgL_locz00_74;
																																				}
																																		}
																																		BgL_auxz00_5798
																																			=
																																			(
																																			(BgL_ev_exprz00_bglt)
																																			BGl_convz00zz__evaluatez00
																																			(BgL_tz00_1476,
																																				BgL_localsz00_70,
																																				BgL_globalsz00_71,
																																				BgL_tailzf3zf3_72,
																																				BgL_wherez00_73,
																																				BgL_arg2261z00_2365,
																																				((bool_t) 0)));
																																	}
																																	((((BgL_ev_ifz00_bglt) COBJECT(BgL_new1114z00_2363))->BgL_tz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5798), BUNSPEC);
																																}
																																{
																																	BgL_ev_exprz00_bglt
																																		BgL_auxz00_5805;
																																	{	/* Eval/evaluate.scm 465 */
																																		obj_t
																																			BgL_arg2262z00_2366;
																																		{	/* Eval/evaluate.scm 144 */
																																			obj_t
																																				BgL__ortest_1068z00_3545;
																																			BgL__ortest_1068z00_3545
																																				=
																																				BGl_getzd2sourcezd2locationz00zz__readerz00
																																				(BgL_oz00_1477);
																																			if (CBOOL
																																				(BgL__ortest_1068z00_3545))
																																				{	/* Eval/evaluate.scm 144 */
																																					BgL_arg2262z00_2366
																																						=
																																						BgL__ortest_1068z00_3545;
																																				}
																																			else
																																				{	/* Eval/evaluate.scm 144 */
																																					BgL_arg2262z00_2366
																																						=
																																						BgL_locz00_74;
																																				}
																																		}
																																		BgL_auxz00_5805
																																			=
																																			(
																																			(BgL_ev_exprz00_bglt)
																																			BGl_convz00zz__evaluatez00
																																			(BgL_oz00_1477,
																																				BgL_localsz00_70,
																																				BgL_globalsz00_71,
																																				BgL_tailzf3zf3_72,
																																				BgL_wherez00_73,
																																				BgL_arg2262z00_2366,
																																				((bool_t) 0)));
																																	}
																																	((((BgL_ev_ifz00_bglt) COBJECT(BgL_new1114z00_2363))->BgL_ez00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5805), BUNSPEC);
																																}
																																BgL_auxz00_5786
																																	=
																																	BgL_new1114z00_2363;
																															}
																															return
																																((obj_t)
																																BgL_auxz00_5786);
																														}
																													}
																												else
																													{	/* Eval/evaluate.scm 424 */
																														obj_t
																															BgL_arg1636z00_1651;
																														obj_t
																															BgL_arg1637z00_1652;
																														BgL_arg1636z00_1651
																															=
																															CAR(BgL_ez00_69);
																														BgL_arg1637z00_1652
																															=
																															CDR(BgL_ez00_69);
																														{
																															BgL_ev_appz00_bglt
																																BgL_auxz00_5815;
																															{
																																obj_t
																																	BgL_argsz00_5817;
																																obj_t
																																	BgL_fz00_5816;
																																BgL_fz00_5816 =
																																	BgL_arg1636z00_1651;
																																BgL_argsz00_5817
																																	=
																																	BgL_arg1637z00_1652;
																																BgL_argsz00_1535
																																	=
																																	BgL_argsz00_5817;
																																BgL_fz00_1534 =
																																	BgL_fz00_5816;
																																goto
																																	BgL_tagzd2175zd2_1536;
																															}
																															return
																																((obj_t)
																																BgL_auxz00_5815);
																														}
																													}
																											}
																										else
																											{	/* Eval/evaluate.scm 424 */
																												obj_t
																													BgL_cdrzd25402zd2_1654;
																												BgL_cdrzd25402zd2_1654 =
																													CDR(BgL_ez00_69);
																												{	/* Eval/evaluate.scm 424 */
																													obj_t
																														BgL_cdrzd25408zd2_1655;
																													BgL_cdrzd25408zd2_1655
																														=
																														CDR(((obj_t)
																															BgL_cdrzd25402zd2_1654));
																													if (NULLP(CDR(((obj_t)
																																	BgL_cdrzd25408zd2_1655))))
																														{	/* Eval/evaluate.scm 424 */
																															obj_t
																																BgL_arg1644z00_1658;
																															obj_t
																																BgL_arg1645z00_1659;
																															BgL_arg1644z00_1658
																																=
																																CAR(((obj_t)
																																	BgL_cdrzd25402zd2_1654));
																															BgL_arg1645z00_1659
																																=
																																CAR(((obj_t)
																																	BgL_cdrzd25408zd2_1655));
																															{
																																BgL_ev_ifz00_bglt
																																	BgL_auxz00_5830;
																																BgL_pz00_1479 =
																																	BgL_arg1644z00_1658;
																																BgL_tz00_1480 =
																																	BgL_arg1645z00_1659;
																															BgL_tagzd2156zd2_1481:
																																{	/* Eval/evaluate.scm 467 */
																																	BgL_ev_ifz00_bglt
																																		BgL_new1116z00_2369;
																																	{	/* Eval/evaluate.scm 468 */
																																		BgL_ev_ifz00_bglt
																																			BgL_new1115z00_2373;
																																		BgL_new1115z00_2373
																																			=
																																			(
																																			(BgL_ev_ifz00_bglt)
																																			BOBJECT
																																			(GC_MALLOC
																																				(sizeof
																																					(struct
																																						BgL_ev_ifz00_bgl))));
																																		{	/* Eval/evaluate.scm 468 */
																																			long
																																				BgL_arg2267z00_2374;
																																			{	/* Eval/evaluate.scm 468 */
																																				long
																																					BgL_res2888z00_3547;
																																				BgL_res2888z00_3547
																																					=
																																					BGL_CLASS_INDEX
																																					(BGl_ev_ifz00zz__evaluate_typesz00);
																																				BgL_arg2267z00_2374
																																					=
																																					BgL_res2888z00_3547;
																																			}
																																			BGL_OBJECT_CLASS_NUM_SET
																																				(((BgL_objectz00_bglt) BgL_new1115z00_2373), BgL_arg2267z00_2374);
																																		}
																																		BgL_new1116z00_2369
																																			=
																																			BgL_new1115z00_2373;
																																	}
																																	{
																																		BgL_ev_exprz00_bglt
																																			BgL_auxz00_5835;
																																		{	/* Eval/evaluate.scm 468 */
																																			obj_t
																																				BgL_arg2264z00_2370;
																																			{	/* Eval/evaluate.scm 144 */
																																				obj_t
																																					BgL__ortest_1068z00_3550;
																																				BgL__ortest_1068z00_3550
																																					=
																																					BGl_getzd2sourcezd2locationz00zz__readerz00
																																					(BgL_pz00_1479);
																																				if (CBOOL(BgL__ortest_1068z00_3550))
																																					{	/* Eval/evaluate.scm 144 */
																																						BgL_arg2264z00_2370
																																							=
																																							BgL__ortest_1068z00_3550;
																																					}
																																				else
																																					{	/* Eval/evaluate.scm 144 */
																																						BgL_arg2264z00_2370
																																							=
																																							BgL_locz00_74;
																																					}
																																			}
																																			BgL_auxz00_5835
																																				=
																																				(
																																				(BgL_ev_exprz00_bglt)
																																				BGl_convz00zz__evaluatez00
																																				(BgL_pz00_1479,
																																					BgL_localsz00_70,
																																					BgL_globalsz00_71,
																																					BFALSE,
																																					BgL_wherez00_73,
																																					BgL_arg2264z00_2370,
																																					((bool_t) 0)));
																																		}
																																		((((BgL_ev_ifz00_bglt) COBJECT(BgL_new1116z00_2369))->BgL_pz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5835), BUNSPEC);
																																	}
																																	{
																																		BgL_ev_exprz00_bglt
																																			BgL_auxz00_5842;
																																		{	/* Eval/evaluate.scm 469 */
																																			obj_t
																																				BgL_arg2265z00_2371;
																																			{	/* Eval/evaluate.scm 144 */
																																				obj_t
																																					BgL__ortest_1068z00_3551;
																																				BgL__ortest_1068z00_3551
																																					=
																																					BGl_getzd2sourcezd2locationz00zz__readerz00
																																					(BgL_tz00_1480);
																																				if (CBOOL(BgL__ortest_1068z00_3551))
																																					{	/* Eval/evaluate.scm 144 */
																																						BgL_arg2265z00_2371
																																							=
																																							BgL__ortest_1068z00_3551;
																																					}
																																				else
																																					{	/* Eval/evaluate.scm 144 */
																																						BgL_arg2265z00_2371
																																							=
																																							BgL_locz00_74;
																																					}
																																			}
																																			BgL_auxz00_5842
																																				=
																																				(
																																				(BgL_ev_exprz00_bglt)
																																				BGl_convz00zz__evaluatez00
																																				(BgL_tz00_1480,
																																					BgL_localsz00_70,
																																					BgL_globalsz00_71,
																																					BgL_tailzf3zf3_72,
																																					BgL_wherez00_73,
																																					BgL_arg2265z00_2371,
																																					((bool_t) 0)));
																																		}
																																		((((BgL_ev_ifz00_bglt) COBJECT(BgL_new1116z00_2369))->BgL_tz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5842), BUNSPEC);
																																	}
																																	{
																																		BgL_ev_exprz00_bglt
																																			BgL_auxz00_5849;
																																		{	/* Eval/evaluate.scm 470 */
																																			obj_t
																																				BgL_arg2266z00_2372;
																																			{	/* Eval/evaluate.scm 144 */
																																				obj_t
																																					BgL__ortest_1068z00_3552;
																																				BgL__ortest_1068z00_3552
																																					=
																																					BGl_getzd2sourcezd2locationz00zz__readerz00
																																					(BFALSE);
																																				if (CBOOL(BgL__ortest_1068z00_3552))
																																					{	/* Eval/evaluate.scm 144 */
																																						BgL_arg2266z00_2372
																																							=
																																							BgL__ortest_1068z00_3552;
																																					}
																																				else
																																					{	/* Eval/evaluate.scm 144 */
																																						BgL_arg2266z00_2372
																																							=
																																							BgL_locz00_74;
																																					}
																																			}
																																			BgL_auxz00_5849
																																				=
																																				(
																																				(BgL_ev_exprz00_bglt)
																																				BGl_convz00zz__evaluatez00
																																				(BgL_ez00_69,
																																					BgL_localsz00_70,
																																					BgL_globalsz00_71,
																																					BgL_tailzf3zf3_72,
																																					BgL_wherez00_73,
																																					BgL_arg2266z00_2372,
																																					((bool_t) 0)));
																																		}
																																		((((BgL_ev_ifz00_bglt) COBJECT(BgL_new1116z00_2369))->BgL_ez00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5849), BUNSPEC);
																																	}
																																	BgL_auxz00_5830
																																		=
																																		BgL_new1116z00_2369;
																																}
																																return
																																	((obj_t)
																																	BgL_auxz00_5830);
																															}
																														}
																													else
																														{	/* Eval/evaluate.scm 424 */
																															obj_t
																																BgL_arg1647z00_1660;
																															BgL_arg1647z00_1660
																																=
																																CAR
																																(BgL_ez00_69);
																															{
																																BgL_ev_appz00_bglt
																																	BgL_auxz00_5858;
																																{
																																	obj_t
																																		BgL_argsz00_5860;
																																	obj_t
																																		BgL_fz00_5859;
																																	BgL_fz00_5859
																																		=
																																		BgL_arg1647z00_1660;
																																	BgL_argsz00_5860
																																		=
																																		BgL_cdrzd25402zd2_1654;
																																	BgL_argsz00_1535
																																		=
																																		BgL_argsz00_5860;
																																	BgL_fz00_1534
																																		=
																																		BgL_fz00_5859;
																																	goto
																																		BgL_tagzd2175zd2_1536;
																																}
																																return
																																	((obj_t)
																																	BgL_auxz00_5858);
																															}
																														}
																												}
																											}
																									}
																								else
																									{	/* Eval/evaluate.scm 424 */
																										obj_t BgL_arg1650z00_1663;
																										obj_t BgL_arg1651z00_1664;

																										BgL_arg1650z00_1663 =
																											CAR(BgL_ez00_69);
																										BgL_arg1651z00_1664 =
																											CDR(BgL_ez00_69);
																										{
																											BgL_ev_appz00_bglt
																												BgL_auxz00_5864;
																											{
																												obj_t BgL_argsz00_5866;
																												obj_t BgL_fz00_5865;

																												BgL_fz00_5865 =
																													BgL_arg1650z00_1663;
																												BgL_argsz00_5866 =
																													BgL_arg1651z00_1664;
																												BgL_argsz00_1535 =
																													BgL_argsz00_5866;
																												BgL_fz00_1534 =
																													BgL_fz00_5865;
																												goto
																													BgL_tagzd2175zd2_1536;
																											}
																											return
																												((obj_t)
																												BgL_auxz00_5864);
																										}
																									}
																							}
																						else
																							{	/* Eval/evaluate.scm 424 */
																								obj_t BgL_arg1653z00_1665;
																								obj_t BgL_arg1654z00_1666;

																								BgL_arg1653z00_1665 =
																									CAR(BgL_ez00_69);
																								BgL_arg1654z00_1666 =
																									CDR(BgL_ez00_69);
																								{
																									BgL_ev_appz00_bglt
																										BgL_auxz00_5870;
																									{
																										obj_t BgL_argsz00_5872;
																										obj_t BgL_fz00_5871;

																										BgL_fz00_5871 =
																											BgL_arg1653z00_1665;
																										BgL_argsz00_5872 =
																											BgL_arg1654z00_1666;
																										BgL_argsz00_1535 =
																											BgL_argsz00_5872;
																										BgL_fz00_1534 =
																											BgL_fz00_5871;
																										goto BgL_tagzd2175zd2_1536;
																									}
																									return
																										((obj_t) BgL_auxz00_5870);
																								}
																							}
																					}
																				else
																					{	/* Eval/evaluate.scm 424 */
																						if (
																							(CAR(BgL_ez00_69) ==
																								BGl_symbol3267z00zz__evaluatez00))
																							{	/* Eval/evaluate.scm 424 */
																								obj_t BgL_arg1657z00_1669;

																								BgL_arg1657z00_1669 =
																									CDR(BgL_ez00_69);
																								{	/* Eval/evaluate.scm 472 */
																									BgL_ev_orz00_bglt
																										BgL_new1119z00_4011;
																									{	/* Eval/evaluate.scm 473 */
																										BgL_ev_orz00_bglt
																											BgL_new1117z00_4012;
																										BgL_new1117z00_4012 =
																											((BgL_ev_orz00_bglt)
																											BOBJECT(GC_MALLOC(sizeof
																													(struct
																														BgL_ev_orz00_bgl))));
																										{	/* Eval/evaluate.scm 473 */
																											long BgL_arg2268z00_4013;

																											{	/* Eval/evaluate.scm 473 */
																												long
																													BgL_res2981z00_4015;
																												BgL_res2981z00_4015 =
																													BGL_CLASS_INDEX
																													(BGl_ev_orz00zz__evaluate_typesz00);
																												BgL_arg2268z00_4013 =
																													BgL_res2981z00_4015;
																											}
																											BGL_OBJECT_CLASS_NUM_SET(
																												((BgL_objectz00_bglt)
																													BgL_new1117z00_4012),
																												BgL_arg2268z00_4013);
																										}
																										BgL_new1119z00_4011 =
																											BgL_new1117z00_4012;
																									}
																									((((BgL_ev_listz00_bglt)
																												COBJECT((
																														(BgL_ev_listz00_bglt)
																														BgL_new1119z00_4011)))->
																											BgL_argsz00) =
																										((obj_t)
																											BGl_loopze70ze7zz__evaluatez00
																											(BgL_wherez00_73,
																												BgL_globalsz00_71,
																												BgL_localsz00_70,
																												BgL_locz00_74,
																												BgL_arg1657z00_1669)),
																										BUNSPEC);
																									return ((obj_t)
																										BgL_new1119z00_4011);
																								}
																							}
																						else
																							{	/* Eval/evaluate.scm 424 */
																								if (
																									(CAR(BgL_ez00_69) ==
																										BGl_symbol3269z00zz__evaluatez00))
																									{	/* Eval/evaluate.scm 424 */
																										obj_t BgL_arg1663z00_1672;

																										BgL_arg1663z00_1672 =
																											CDR(BgL_ez00_69);
																										{	/* Eval/evaluate.scm 475 */
																											BgL_ev_andz00_bglt
																												BgL_new1121z00_4020;
																											{	/* Eval/evaluate.scm 476 */
																												BgL_ev_andz00_bglt
																													BgL_new1120z00_4021;
																												BgL_new1120z00_4021 =
																													((BgL_ev_andz00_bglt)
																													BOBJECT(GC_MALLOC
																														(sizeof(struct
																																BgL_ev_andz00_bgl))));
																												{	/* Eval/evaluate.scm 476 */
																													long
																														BgL_arg2269z00_4022;
																													{	/* Eval/evaluate.scm 476 */
																														long
																															BgL_res2982z00_4024;
																														BgL_res2982z00_4024
																															=
																															BGL_CLASS_INDEX
																															(BGl_ev_andz00zz__evaluate_typesz00);
																														BgL_arg2269z00_4022
																															=
																															BgL_res2982z00_4024;
																													}
																													BGL_OBJECT_CLASS_NUM_SET
																														(((BgL_objectz00_bglt) BgL_new1120z00_4021), BgL_arg2269z00_4022);
																												}
																												BgL_new1121z00_4020 =
																													BgL_new1120z00_4021;
																											}
																											((((BgL_ev_listz00_bglt)
																														COBJECT((
																																(BgL_ev_listz00_bglt)
																																BgL_new1121z00_4020)))->
																													BgL_argsz00) =
																												((obj_t)
																													BGl_loopze70ze7zz__evaluatez00
																													(BgL_wherez00_73,
																														BgL_globalsz00_71,
																														BgL_localsz00_70,
																														BgL_locz00_74,
																														BgL_arg1663z00_1672)),
																												BUNSPEC);
																											return ((obj_t)
																												BgL_new1121z00_4020);
																										}
																									}
																								else
																									{	/* Eval/evaluate.scm 424 */
																										if (
																											(CAR(BgL_ez00_69) ==
																												BGl_symbol3254z00zz__evaluatez00))
																											{	/* Eval/evaluate.scm 424 */
																												return
																													BGl_convzd2beginzd2zz__evaluatez00
																													(CDR(BgL_ez00_69),
																													BgL_localsz00_70,
																													BgL_globalsz00_71,
																													BgL_tailzf3zf3_72,
																													BgL_wherez00_73,
																													BgL_locz00_74,
																													BgL_topzf3zf3_75);
																											}
																										else
																											{	/* Eval/evaluate.scm 424 */
																												obj_t
																													BgL_cdrzd26301zd2_1676;
																												BgL_cdrzd26301zd2_1676 =
																													CDR(BgL_ez00_69);
																												if ((CAR(BgL_ez00_69) ==
																														BGl_symbol3240z00zz__evaluatez00))
																													{	/* Eval/evaluate.scm 424 */
																														if (PAIRP
																															(BgL_cdrzd26301zd2_1676))
																															{	/* Eval/evaluate.scm 424 */
																																obj_t
																																	BgL_arg1671z00_1680;
																																obj_t
																																	BgL_arg1672z00_1681;
																																BgL_arg1671z00_1680
																																	=
																																	CAR
																																	(BgL_cdrzd26301zd2_1676);
																																BgL_arg1672z00_1681
																																	=
																																	CDR
																																	(BgL_cdrzd26301zd2_1676);
																																{
																																	BgL_ev_letz00_bglt
																																		BgL_auxz00_5911;
																																	BgL_bindsz00_1488
																																		=
																																		BgL_arg1671z00_1680;
																																	BgL_bodyz00_1489
																																		=
																																		BgL_arg1672z00_1681;
																																BgL_tagzd2160zd2_1490:
																																	{	/* Eval/evaluate.scm 480 */
																																		obj_t
																																			BgL_ubindsz00_2381;
																																		if (NULLP
																																			(BgL_bindsz00_1488))
																																			{	/* Eval/evaluate.scm 480 */
																																				BgL_ubindsz00_2381
																																					=
																																					BNIL;
																																			}
																																		else
																																			{	/* Eval/evaluate.scm 480 */
																																				obj_t
																																					BgL_head1215z00_2426;
																																				{	/* Eval/evaluate.scm 480 */
																																					obj_t
																																						BgL_res2892z00_3568;
																																					BgL_res2892z00_3568
																																						=
																																						MAKE_YOUNG_PAIR
																																						(BNIL,
																																						BNIL);
																																					BgL_head1215z00_2426
																																						=
																																						BgL_res2892z00_3568;
																																				}
																																				{
																																					obj_t
																																						BgL_l1213z00_3596;
																																					obj_t
																																						BgL_tail1216z00_3597;
																																					BgL_l1213z00_3596
																																						=
																																						BgL_bindsz00_1488;
																																					BgL_tail1216z00_3597
																																						=
																																						BgL_head1215z00_2426;
																																				BgL_zc3z04anonymousza32290ze3z87_3595:
																																					if (NULLP(BgL_l1213z00_3596))
																																						{	/* Eval/evaluate.scm 480 */
																																							BgL_ubindsz00_2381
																																								=
																																								CDR
																																								(BgL_head1215z00_2426);
																																						}
																																					else
																																						{	/* Eval/evaluate.scm 480 */
																																							obj_t
																																								BgL_newtail1217z00_3605;
																																							{	/* Eval/evaluate.scm 480 */
																																								obj_t
																																									BgL_arg2293z00_3606;
																																								{	/* Eval/evaluate.scm 480 */
																																									obj_t
																																										BgL_bz00_3607;
																																									BgL_bz00_3607
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_l1213z00_3596));
																																									{	/* Eval/evaluate.scm 480 */
																																										obj_t
																																											BgL_arg2294z00_3608;
																																										BgL_arg2294z00_3608
																																											=
																																											CAR
																																											(
																																											((obj_t) BgL_bz00_3607));
																																										BgL_arg2293z00_3606
																																											=
																																											BGl_untypezd2identzd2zz__evaluatez00
																																											(BgL_arg2294z00_3608);
																																									}
																																								}
																																								{	/* Eval/evaluate.scm 480 */
																																									obj_t
																																										BgL_res2898z00_3614;
																																									BgL_res2898z00_3614
																																										=
																																										MAKE_YOUNG_PAIR
																																										(BgL_arg2293z00_3606,
																																										BNIL);
																																									BgL_newtail1217z00_3605
																																										=
																																										BgL_res2898z00_3614;
																																								}
																																							}
																																							SET_CDR
																																								(BgL_tail1216z00_3597,
																																								BgL_newtail1217z00_3605);
																																							{	/* Eval/evaluate.scm 480 */
																																								obj_t
																																									BgL_arg2292z00_3609;
																																								BgL_arg2292z00_3609
																																									=
																																									CDR
																																									(
																																									((obj_t) BgL_l1213z00_3596));
																																								{
																																									obj_t
																																										BgL_tail1216z00_5928;
																																									obj_t
																																										BgL_l1213z00_5927;
																																									BgL_l1213z00_5927
																																										=
																																										BgL_arg2292z00_3609;
																																									BgL_tail1216z00_5928
																																										=
																																										BgL_newtail1217z00_3605;
																																									BgL_tail1216z00_3597
																																										=
																																										BgL_tail1216z00_5928;
																																									BgL_l1213z00_3596
																																										=
																																										BgL_l1213z00_5927;
																																									goto
																																										BgL_zc3z04anonymousza32290ze3z87_3595;
																																								}
																																							}
																																						}
																																				}
																																			}
																																		{	/* Eval/evaluate.scm 480 */
																																			obj_t
																																				BgL_varsz00_2382;
																																			if (NULLP
																																				(BgL_ubindsz00_2381))
																																				{	/* Eval/evaluate.scm 481 */
																																					BgL_varsz00_2382
																																						=
																																						BNIL;
																																				}
																																			else
																																				{	/* Eval/evaluate.scm 481 */
																																					obj_t
																																						BgL_head1220z00_2410;
																																					{	/* Eval/evaluate.scm 481 */
																																						obj_t
																																							BgL_res2900z00_3618;
																																						BgL_res2900z00_3618
																																							=
																																							MAKE_YOUNG_PAIR
																																							(BNIL,
																																							BNIL);
																																						BgL_head1220z00_2410
																																							=
																																							BgL_res2900z00_3618;
																																					}
																																					{
																																						obj_t
																																							BgL_l1218z00_2412;
																																						obj_t
																																							BgL_tail1221z00_2413;
																																						BgL_l1218z00_2412
																																							=
																																							BgL_ubindsz00_2381;
																																						BgL_tail1221z00_2413
																																							=
																																							BgL_head1220z00_2410;
																																					BgL_zc3z04anonymousza32284ze3z87_2414:
																																						if (NULLP(BgL_l1218z00_2412))
																																							{	/* Eval/evaluate.scm 481 */
																																								BgL_varsz00_2382
																																									=
																																									CDR
																																									(BgL_head1220z00_2410);
																																							}
																																						else
																																							{	/* Eval/evaluate.scm 481 */
																																								obj_t
																																									BgL_newtail1222z00_2416;
																																								{	/* Eval/evaluate.scm 481 */
																																									BgL_ev_varz00_bglt
																																										BgL_arg2287z00_2418;
																																									{	/* Eval/evaluate.scm 481 */
																																										obj_t
																																											BgL_iz00_2419;
																																										BgL_iz00_2419
																																											=
																																											CAR
																																											(
																																											((obj_t) BgL_l1218z00_2412));
																																										{	/* Eval/evaluate.scm 482 */
																																											BgL_ev_varz00_bglt
																																												BgL_new1123z00_2420;
																																											{	/* Eval/evaluate.scm 484 */
																																												BgL_ev_varz00_bglt
																																													BgL_new1122z00_2421;
																																												BgL_new1122z00_2421
																																													=
																																													(
																																													(BgL_ev_varz00_bglt)
																																													BOBJECT
																																													(GC_MALLOC
																																														(sizeof
																																															(struct
																																																BgL_ev_varz00_bgl))));
																																												{	/* Eval/evaluate.scm 484 */
																																													long
																																														BgL_arg2288z00_2422;
																																													{	/* Eval/evaluate.scm 484 */
																																														long
																																															BgL_res2902z00_3623;
																																														BgL_res2902z00_3623
																																															=
																																															BGL_CLASS_INDEX
																																															(BGl_ev_varz00zz__evaluate_typesz00);
																																														BgL_arg2288z00_2422
																																															=
																																															BgL_res2902z00_3623;
																																													}
																																													BGL_OBJECT_CLASS_NUM_SET
																																														(
																																														((BgL_objectz00_bglt) BgL_new1122z00_2421), BgL_arg2288z00_2422);
																																												}
																																												BgL_new1123z00_2420
																																													=
																																													BgL_new1122z00_2421;
																																											}
																																											((((BgL_ev_varz00_bglt) COBJECT(BgL_new1123z00_2420))->BgL_namez00) = ((obj_t) CAR(((obj_t) BgL_iz00_2419))), BUNSPEC);
																																											((((BgL_ev_varz00_bglt) COBJECT(BgL_new1123z00_2420))->BgL_effz00) = ((obj_t) BFALSE), BUNSPEC);
																																											((((BgL_ev_varz00_bglt) COBJECT(BgL_new1123z00_2420))->BgL_typez00) = ((obj_t) CDR(((obj_t) BgL_iz00_2419))), BUNSPEC);
																																											BgL_arg2287z00_2418
																																												=
																																												BgL_new1123z00_2420;
																																									}}
																																									{	/* Eval/evaluate.scm 481 */
																																										obj_t
																																											BgL_res2903z00_3628;
																																										BgL_res2903z00_3628
																																											=
																																											MAKE_YOUNG_PAIR
																																											(
																																											((obj_t) BgL_arg2287z00_2418), BNIL);
																																										BgL_newtail1222z00_2416
																																											=
																																											BgL_res2903z00_3628;
																																								}}
																																								SET_CDR
																																									(BgL_tail1221z00_2413,
																																									BgL_newtail1222z00_2416);
																																								{	/* Eval/evaluate.scm 481 */
																																									obj_t
																																										BgL_arg2286z00_2417;
																																									BgL_arg2286z00_2417
																																										=
																																										CDR
																																										(
																																										((obj_t) BgL_l1218z00_2412));
																																									{
																																										obj_t
																																											BgL_tail1221z00_5954;
																																										obj_t
																																											BgL_l1218z00_5953;
																																										BgL_l1218z00_5953
																																											=
																																											BgL_arg2286z00_2417;
																																										BgL_tail1221z00_5954
																																											=
																																											BgL_newtail1222z00_2416;
																																										BgL_tail1221z00_2413
																																											=
																																											BgL_tail1221z00_5954;
																																										BgL_l1218z00_2412
																																											=
																																											BgL_l1218z00_5953;
																																										goto
																																											BgL_zc3z04anonymousza32284ze3z87_2414;
																																									}
																																								}
																																							}
																																					}
																																				}
																																			{	/* Eval/evaluate.scm 481 */
																																				obj_t
																																					BgL_bodyz00_2383;
																																				{	/* Eval/evaluate.scm 486 */
																																					bool_t
																																						BgL_test3482z00_5955;
																																					{	/* Eval/evaluate.scm 486 */
																																						obj_t
																																							BgL_tmpz00_5956;
																																						BgL_tmpz00_5956
																																							=
																																							CDR
																																							(((obj_t) BgL_bodyz00_1489));
																																						BgL_test3482z00_5955
																																							=
																																							PAIRP
																																							(BgL_tmpz00_5956);
																																					}
																																					if (BgL_test3482z00_5955)
																																						{	/* Eval/evaluate.scm 486 */
																																							obj_t
																																								BgL_res2905z00_3634;
																																							BgL_res2905z00_3634
																																								=
																																								MAKE_YOUNG_EPAIR
																																								(BGl_symbol3254z00zz__evaluatez00,
																																								BgL_bodyz00_1489,
																																								BgL_locz00_74);
																																							BgL_bodyz00_2383
																																								=
																																								BgL_res2905z00_3634;
																																						}
																																					else
																																						{	/* Eval/evaluate.scm 486 */
																																							BgL_bodyz00_2383
																																								=
																																								CAR
																																								(
																																								((obj_t) BgL_bodyz00_1489));
																																						}
																																				}
																																				{	/* Eval/evaluate.scm 486 */
																																					obj_t
																																						BgL_tbodyz00_2384;
																																					BgL_tbodyz00_2384
																																						=
																																						BGl_typezd2checkszd2zz__evaluatez00
																																						(BgL_ubindsz00_2381,
																																						BgL_bindsz00_1488,
																																						BgL_bodyz00_2383,
																																						BgL_locz00_74,
																																						BgL_wherez00_73);
																																					{	/* Eval/evaluate.scm 487 */

																																						{	/* Eval/evaluate.scm 488 */
																																							obj_t
																																								BgL_blocz00_2385;
																																							{	/* Eval/evaluate.scm 144 */
																																								obj_t
																																									BgL__ortest_1068z00_3636;
																																								BgL__ortest_1068z00_3636
																																									=
																																									BGl_getzd2sourcezd2locationz00zz__readerz00
																																									(BgL_bindsz00_1488);
																																								if (CBOOL(BgL__ortest_1068z00_3636))
																																									{	/* Eval/evaluate.scm 144 */
																																										BgL_blocz00_2385
																																											=
																																											BgL__ortest_1068z00_3636;
																																									}
																																								else
																																									{	/* Eval/evaluate.scm 144 */
																																										BgL_blocz00_2385
																																											=
																																											BgL_locz00_74;
																																									}
																																							}
																																							{	/* Eval/evaluate.scm 489 */
																																								BgL_ev_letz00_bglt
																																									BgL_new1126z00_2386;
																																								{	/* Eval/evaluate.scm 490 */
																																									BgL_ev_letz00_bglt
																																										BgL_new1125z00_2403;
																																									BgL_new1125z00_2403
																																										=
																																										(
																																										(BgL_ev_letz00_bglt)
																																										BOBJECT
																																										(GC_MALLOC
																																											(sizeof
																																												(struct
																																													BgL_ev_letz00_bgl))));
																																									{	/* Eval/evaluate.scm 490 */
																																										long
																																											BgL_arg2278z00_2404;
																																										{	/* Eval/evaluate.scm 490 */
																																											long
																																												BgL_res2906z00_3638;
																																											BgL_res2906z00_3638
																																												=
																																												BGL_CLASS_INDEX
																																												(BGl_ev_letz00zz__evaluate_typesz00);
																																											BgL_arg2278z00_2404
																																												=
																																												BgL_res2906z00_3638;
																																										}
																																										BGL_OBJECT_CLASS_NUM_SET
																																											(
																																											((BgL_objectz00_bglt) BgL_new1125z00_2403), BgL_arg2278z00_2404);
																																									}
																																									BgL_new1126z00_2386
																																										=
																																										BgL_new1125z00_2403;
																																								}
																																								((((BgL_ev_binderz00_bglt) COBJECT(((BgL_ev_binderz00_bglt) BgL_new1126z00_2386)))->BgL_varsz00) = ((obj_t) BgL_varsz00_2382), BUNSPEC);
																																								{
																																									obj_t
																																										BgL_auxz00_5973;
																																									if (NULLP(BgL_bindsz00_1488))
																																										{	/* Eval/evaluate.scm 491 */
																																											BgL_auxz00_5973
																																												=
																																												BNIL;
																																										}
																																									else
																																										{	/* Eval/evaluate.scm 491 */
																																											obj_t
																																												BgL_head1225z00_2389;
																																											{	/* Eval/evaluate.scm 491 */
																																												obj_t
																																													BgL_res2908z00_3642;
																																												BgL_res2908z00_3642
																																													=
																																													MAKE_YOUNG_PAIR
																																													(BNIL,
																																													BNIL);
																																												BgL_head1225z00_2389
																																													=
																																													BgL_res2908z00_3642;
																																											}
																																											{
																																												obj_t
																																													BgL_l1223z00_2391;
																																												obj_t
																																													BgL_tail1226z00_2392;
																																												BgL_l1223z00_2391
																																													=
																																													BgL_bindsz00_1488;
																																												BgL_tail1226z00_2392
																																													=
																																													BgL_head1225z00_2389;
																																											BgL_zc3z04anonymousza32271ze3z87_2393:
																																												if (NULLP(BgL_l1223z00_2391))
																																													{	/* Eval/evaluate.scm 491 */
																																														BgL_auxz00_5973
																																															=
																																															CDR
																																															(BgL_head1225z00_2389);
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 491 */
																																														obj_t
																																															BgL_newtail1227z00_2395;
																																														{	/* Eval/evaluate.scm 491 */
																																															obj_t
																																																BgL_arg2274z00_2397;
																																															{	/* Eval/evaluate.scm 491 */
																																																obj_t
																																																	BgL_bz00_2398;
																																																BgL_bz00_2398
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_l1223z00_2391));
																																																{	/* Eval/evaluate.scm 492 */
																																																	obj_t
																																																		BgL_locz00_2399;
																																																	{	/* Eval/evaluate.scm 144 */
																																																		obj_t
																																																			BgL__ortest_1068z00_3646;
																																																		BgL__ortest_1068z00_3646
																																																			=
																																																			BGl_getzd2sourcezd2locationz00zz__readerz00
																																																			(BgL_bz00_2398);
																																																		if (CBOOL(BgL__ortest_1068z00_3646))
																																																			{	/* Eval/evaluate.scm 144 */
																																																				BgL_locz00_2399
																																																					=
																																																					BgL__ortest_1068z00_3646;
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 144 */
																																																				BgL_locz00_2399
																																																					=
																																																					BgL_blocz00_2385;
																																																			}
																																																	}
																																																	{	/* Eval/evaluate.scm 493 */
																																																		obj_t
																																																			BgL_arg2275z00_2400;
																																																		{	/* Eval/evaluate.scm 493 */
																																																			obj_t
																																																				BgL_pairz00_3650;
																																																			BgL_pairz00_3650
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_bz00_2398));
																																																			BgL_arg2275z00_2400
																																																				=
																																																				CAR
																																																				(BgL_pairz00_3650);
																																																		}
																																																		BgL_arg2274z00_2397
																																																			=
																																																			BGl_convz00zz__evaluatez00
																																																			(BgL_arg2275z00_2400,
																																																			BgL_localsz00_70,
																																																			BgL_globalsz00_71,
																																																			BFALSE,
																																																			BgL_wherez00_73,
																																																			BgL_locz00_2399,
																																																			((bool_t) 0));
																																																	}
																																																}
																																															}
																																															{	/* Eval/evaluate.scm 491 */
																																																obj_t
																																																	BgL_res2910z00_3651;
																																																BgL_res2910z00_3651
																																																	=
																																																	MAKE_YOUNG_PAIR
																																																	(BgL_arg2274z00_2397,
																																																	BNIL);
																																																BgL_newtail1227z00_2395
																																																	=
																																																	BgL_res2910z00_3651;
																																															}
																																														}
																																														SET_CDR
																																															(BgL_tail1226z00_2392,
																																															BgL_newtail1227z00_2395);
																																														{	/* Eval/evaluate.scm 491 */
																																															obj_t
																																																BgL_arg2273z00_2396;
																																															BgL_arg2273z00_2396
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_l1223z00_2391));
																																															{
																																																obj_t
																																																	BgL_tail1226z00_5995;
																																																obj_t
																																																	BgL_l1223z00_5994;
																																																BgL_l1223z00_5994
																																																	=
																																																	BgL_arg2273z00_2396;
																																																BgL_tail1226z00_5995
																																																	=
																																																	BgL_newtail1227z00_2395;
																																																BgL_tail1226z00_2392
																																																	=
																																																	BgL_tail1226z00_5995;
																																																BgL_l1223z00_2391
																																																	=
																																																	BgL_l1223z00_5994;
																																																goto
																																																	BgL_zc3z04anonymousza32271ze3z87_2393;
																																															}
																																														}
																																													}
																																											}
																																										}
																																									((((BgL_ev_binderz00_bglt) COBJECT(((BgL_ev_binderz00_bglt) BgL_new1126z00_2386)))->BgL_valsz00) = ((obj_t) BgL_auxz00_5973), BUNSPEC);
																																								}
																																								{
																																									BgL_ev_exprz00_bglt
																																										BgL_auxz00_5997;
																																									{	/* Eval/evaluate.scm 495 */
																																										obj_t
																																											BgL_arg2277z00_2402;
																																										BgL_arg2277z00_2402
																																											=
																																											BGl_appendzd221011zd2zz__evaluatez00
																																											(BgL_varsz00_2382,
																																											BgL_localsz00_70);
																																										BgL_auxz00_5997
																																											=
																																											(
																																											(BgL_ev_exprz00_bglt)
																																											BGl_convz00zz__evaluatez00
																																											(BgL_tbodyz00_2384,
																																												BgL_arg2277z00_2402,
																																												BgL_globalsz00_71,
																																												BgL_tailzf3zf3_72,
																																												BgL_wherez00_73,
																																												BgL_locz00_74,
																																												((bool_t) 0)));
																																									}
																																									((((BgL_ev_binderz00_bglt) COBJECT(((BgL_ev_binderz00_bglt) BgL_new1126z00_2386)))->BgL_bodyz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5997), BUNSPEC);
																																								}
																																								((((BgL_ev_letz00_bglt) COBJECT(BgL_new1126z00_2386))->BgL_boxesz00) = ((obj_t) BNIL), BUNSPEC);
																																								BgL_auxz00_5911
																																									=
																																									BgL_new1126z00_2386;
																																							}
																																						}
																																					}
																																				}
																																			}
																																		}
																																	}
																																	return
																																		((obj_t)
																																		BgL_auxz00_5911);
																																}
																															}
																														else
																															{	/* Eval/evaluate.scm 424 */
																																obj_t
																																	BgL_arg1673z00_1682;
																																BgL_arg1673z00_1682
																																	=
																																	CAR
																																	(BgL_ez00_69);
																																{
																																	BgL_ev_appz00_bglt
																																		BgL_auxz00_6006;
																																	{
																																		obj_t
																																			BgL_argsz00_6008;
																																		obj_t
																																			BgL_fz00_6007;
																																		BgL_fz00_6007
																																			=
																																			BgL_arg1673z00_1682;
																																		BgL_argsz00_6008
																																			=
																																			BgL_cdrzd26301zd2_1676;
																																		BgL_argsz00_1535
																																			=
																																			BgL_argsz00_6008;
																																		BgL_fz00_1534
																																			=
																																			BgL_fz00_6007;
																																		goto
																																			BgL_tagzd2175zd2_1536;
																																	}
																																	return
																																		((obj_t)
																																		BgL_auxz00_6006);
																																}
																															}
																													}
																												else
																													{	/* Eval/evaluate.scm 424 */
																														if (
																															(CAR(BgL_ez00_69)
																																==
																																BGl_symbol3271z00zz__evaluatez00))
																															{	/* Eval/evaluate.scm 424 */
																																if (PAIRP
																																	(BgL_cdrzd26301zd2_1676))
																																	{	/* Eval/evaluate.scm 424 */
																																		obj_t
																																			BgL_arg1679z00_1688;
																																		obj_t
																																			BgL_arg1680z00_1689;
																																		BgL_arg1679z00_1688
																																			=
																																			CAR
																																			(BgL_cdrzd26301zd2_1676);
																																		BgL_arg1680z00_1689
																																			=
																																			CDR
																																			(BgL_cdrzd26301zd2_1676);
																																		{
																																			BgL_ev_letza2za2_bglt
																																				BgL_auxz00_6017;
																																			BgL_bindsz00_1491
																																				=
																																				BgL_arg1679z00_1688;
																																			BgL_bodyz00_1492
																																				=
																																				BgL_arg1680z00_1689;
																																		BgL_tagzd2161zd2_1493:
																																			{	/* Eval/evaluate.scm 503 */
																																				obj_t
																																					BgL_varsz00_2439;
																																				obj_t
																																					BgL_blocz00_2440;
																																				if (NULLP(BgL_bindsz00_1491))
																																					{	/* Eval/evaluate.scm 503 */
																																						BgL_varsz00_2439
																																							=
																																							BNIL;
																																					}
																																				else
																																					{	/* Eval/evaluate.scm 503 */
																																						obj_t
																																							BgL_head1230z00_2448;
																																						{	/* Eval/evaluate.scm 503 */
																																							obj_t
																																								BgL_res2913z00_3677;
																																							BgL_res2913z00_3677
																																								=
																																								MAKE_YOUNG_PAIR
																																								(BNIL,
																																								BNIL);
																																							BgL_head1230z00_2448
																																								=
																																								BgL_res2913z00_3677;
																																						}
																																						{
																																							obj_t
																																								BgL_l1228z00_2450;
																																							obj_t
																																								BgL_tail1231z00_2451;
																																							BgL_l1228z00_2450
																																								=
																																								BgL_bindsz00_1491;
																																							BgL_tail1231z00_2451
																																								=
																																								BgL_head1230z00_2448;
																																						BgL_zc3z04anonymousza32300ze3z87_2452:
																																							if (NULLP(BgL_l1228z00_2450))
																																								{	/* Eval/evaluate.scm 503 */
																																									BgL_varsz00_2439
																																										=
																																										CDR
																																										(BgL_head1230z00_2448);
																																								}
																																							else
																																								{	/* Eval/evaluate.scm 503 */
																																									obj_t
																																										BgL_newtail1232z00_2454;
																																									{	/* Eval/evaluate.scm 503 */
																																										BgL_ev_varz00_bglt
																																											BgL_arg2303z00_2456;
																																										{	/* Eval/evaluate.scm 503 */
																																											obj_t
																																												BgL_bz00_2457;
																																											BgL_bz00_2457
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_l1228z00_2450));
																																											{	/* Eval/evaluate.scm 504 */
																																												obj_t
																																													BgL_iz00_2458;
																																												{	/* Eval/evaluate.scm 504 */
																																													obj_t
																																														BgL_arg2305z00_2462;
																																													BgL_arg2305z00_2462
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_bz00_2457));
																																													BgL_iz00_2458
																																														=
																																														BGl_untypezd2identzd2zz__evaluatez00
																																														(BgL_arg2305z00_2462);
																																												}
																																												{	/* Eval/evaluate.scm 505 */
																																													BgL_ev_varz00_bglt
																																														BgL_new1129z00_2459;
																																													{	/* Eval/evaluate.scm 507 */
																																														BgL_ev_varz00_bglt
																																															BgL_new1127z00_2460;
																																														BgL_new1127z00_2460
																																															=
																																															(
																																															(BgL_ev_varz00_bglt)
																																															BOBJECT
																																															(GC_MALLOC
																																																(sizeof
																																																	(struct
																																																		BgL_ev_varz00_bgl))));
																																														{	/* Eval/evaluate.scm 507 */
																																															long
																																																BgL_arg2304z00_2461;
																																															{	/* Eval/evaluate.scm 507 */
																																																long
																																																	BgL_res2915z00_3683;
																																																BgL_res2915z00_3683
																																																	=
																																																	BGL_CLASS_INDEX
																																																	(BGl_ev_varz00zz__evaluate_typesz00);
																																																BgL_arg2304z00_2461
																																																	=
																																																	BgL_res2915z00_3683;
																																															}
																																															BGL_OBJECT_CLASS_NUM_SET
																																																(
																																																((BgL_objectz00_bglt) BgL_new1127z00_2460), BgL_arg2304z00_2461);
																																														}
																																														BgL_new1129z00_2459
																																															=
																																															BgL_new1127z00_2460;
																																													}
																																													((((BgL_ev_varz00_bglt) COBJECT(BgL_new1129z00_2459))->BgL_namez00) = ((obj_t) CAR(BgL_iz00_2458)), BUNSPEC);
																																													((((BgL_ev_varz00_bglt) COBJECT(BgL_new1129z00_2459))->BgL_effz00) = ((obj_t) BFALSE), BUNSPEC);
																																													((((BgL_ev_varz00_bglt) COBJECT(BgL_new1129z00_2459))->BgL_typez00) = ((obj_t) CDR(BgL_iz00_2458)), BUNSPEC);
																																													BgL_arg2303z00_2456
																																														=
																																														BgL_new1129z00_2459;
																																										}}}
																																										{	/* Eval/evaluate.scm 503 */
																																											obj_t
																																												BgL_res2916z00_3688;
																																											BgL_res2916z00_3688
																																												=
																																												MAKE_YOUNG_PAIR
																																												(
																																												((obj_t) BgL_arg2303z00_2456), BNIL);
																																											BgL_newtail1232z00_2454
																																												=
																																												BgL_res2916z00_3688;
																																									}}
																																									SET_CDR
																																										(BgL_tail1231z00_2451,
																																										BgL_newtail1232z00_2454);
																																									{	/* Eval/evaluate.scm 503 */
																																										obj_t
																																											BgL_arg2302z00_2455;
																																										BgL_arg2302z00_2455
																																											=
																																											CDR
																																											(
																																											((obj_t) BgL_l1228z00_2450));
																																										{
																																											obj_t
																																												BgL_tail1231z00_6044;
																																											obj_t
																																												BgL_l1228z00_6043;
																																											BgL_l1228z00_6043
																																												=
																																												BgL_arg2302z00_2455;
																																											BgL_tail1231z00_6044
																																												=
																																												BgL_newtail1232z00_2454;
																																											BgL_tail1231z00_2451
																																												=
																																												BgL_tail1231z00_6044;
																																											BgL_l1228z00_2450
																																												=
																																												BgL_l1228z00_6043;
																																											goto
																																												BgL_zc3z04anonymousza32300ze3z87_2452;
																																										}
																																									}
																																								}
																																						}
																																					}
																																				{	/* Eval/evaluate.scm 144 */
																																					obj_t
																																						BgL__ortest_1068z00_3691;
																																					BgL__ortest_1068z00_3691
																																						=
																																						BGl_getzd2sourcezd2locationz00zz__readerz00
																																						(BgL_bindsz00_1491);
																																					if (CBOOL(BgL__ortest_1068z00_3691))
																																						{	/* Eval/evaluate.scm 144 */
																																							BgL_blocz00_2440
																																								=
																																								BgL__ortest_1068z00_3691;
																																						}
																																					else
																																						{	/* Eval/evaluate.scm 144 */
																																							BgL_blocz00_2440
																																								=
																																								BgL_locz00_74;
																																						}
																																				}
																																				{	/* Eval/evaluate.scm 510 */
																																					BgL_ev_letza2za2_bglt
																																						BgL_new1131z00_2441;
																																					{	/* Eval/evaluate.scm 511 */
																																						BgL_ev_letza2za2_bglt
																																							BgL_new1130z00_2444;
																																						BgL_new1130z00_2444
																																							=
																																							(
																																							(BgL_ev_letza2za2_bglt)
																																							BOBJECT
																																							(GC_MALLOC
																																								(sizeof
																																									(struct
																																										BgL_ev_letza2za2_bgl))));
																																						{	/* Eval/evaluate.scm 511 */
																																							long
																																								BgL_arg2298z00_2445;
																																							{	/* Eval/evaluate.scm 511 */
																																								long
																																									BgL_res2917z00_3693;
																																								BgL_res2917z00_3693
																																									=
																																									BGL_CLASS_INDEX
																																									(BGl_ev_letza2za2zz__evaluate_typesz00);
																																								BgL_arg2298z00_2445
																																									=
																																									BgL_res2917z00_3693;
																																							}
																																							BGL_OBJECT_CLASS_NUM_SET
																																								(
																																								((BgL_objectz00_bglt) BgL_new1130z00_2444), BgL_arg2298z00_2445);
																																						}
																																						BgL_new1131z00_2441
																																							=
																																							BgL_new1130z00_2444;
																																					}
																																					((((BgL_ev_binderz00_bglt) COBJECT(((BgL_ev_binderz00_bglt) BgL_new1131z00_2441)))->BgL_varsz00) = ((obj_t) BgL_varsz00_2439), BUNSPEC);
																																					((((BgL_ev_binderz00_bglt) COBJECT(((BgL_ev_binderz00_bglt) BgL_new1131z00_2441)))->BgL_valsz00) = ((obj_t) BGl_convzd2valsze70z35zz__evaluatez00(BgL_wherez00_73, BgL_globalsz00_71, BgL_bindsz00_1491, BgL_varsz00_2439, BgL_localsz00_70, BgL_blocz00_2440)), BUNSPEC);
																																					{
																																						BgL_ev_exprz00_bglt
																																							BgL_auxz00_6057;
																																						{	/* Eval/evaluate.scm 513 */
																																							obj_t
																																								BgL_arg2296z00_2442;
																																							{	/* Eval/evaluate.scm 513 */
																																								obj_t
																																									BgL_arg2297z00_2443;
																																								BgL_arg2297z00_2443
																																									=
																																									bgl_reverse
																																									(BgL_varsz00_2439);
																																								BgL_arg2296z00_2442
																																									=
																																									BGl_appendzd221011zd2zz__evaluatez00
																																									(BgL_arg2297z00_2443,
																																									BgL_localsz00_70);
																																							}
																																							BgL_auxz00_6057
																																								=
																																								(
																																								(BgL_ev_exprz00_bglt)
																																								BGl_convzd2beginzd2zz__evaluatez00
																																								(BgL_bodyz00_1492,
																																									BgL_arg2296z00_2442,
																																									BgL_globalsz00_71,
																																									BgL_tailzf3zf3_72,
																																									BgL_wherez00_73,
																																									BgL_locz00_74,
																																									((bool_t) 0)));
																																						}
																																						((((BgL_ev_binderz00_bglt) COBJECT(((BgL_ev_binderz00_bglt) BgL_new1131z00_2441)))->BgL_bodyz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_6057), BUNSPEC);
																																					}
																																					((((BgL_ev_letza2za2_bglt) COBJECT(BgL_new1131z00_2441))->BgL_boxesz00) = ((obj_t) BNIL), BUNSPEC);
																																					BgL_auxz00_6017
																																						=
																																						BgL_new1131z00_2441;
																																			}}
																																			return
																																				((obj_t)
																																				BgL_auxz00_6017);
																																		}
																																	}
																																else
																																	{	/* Eval/evaluate.scm 424 */
																																		obj_t
																																			BgL_arg1681z00_1690;
																																		obj_t
																																			BgL_arg1682z00_1691;
																																		BgL_arg1681z00_1690
																																			=
																																			CAR
																																			(BgL_ez00_69);
																																		BgL_arg1682z00_1691
																																			=
																																			CDR
																																			(BgL_ez00_69);
																																		{
																																			BgL_ev_appz00_bglt
																																				BgL_auxz00_6068;
																																			{
																																				obj_t
																																					BgL_argsz00_6070;
																																				obj_t
																																					BgL_fz00_6069;
																																				BgL_fz00_6069
																																					=
																																					BgL_arg1681z00_1690;
																																				BgL_argsz00_6070
																																					=
																																					BgL_arg1682z00_1691;
																																				BgL_argsz00_1535
																																					=
																																					BgL_argsz00_6070;
																																				BgL_fz00_1534
																																					=
																																					BgL_fz00_6069;
																																				goto
																																					BgL_tagzd2175zd2_1536;
																																			}
																																			return
																																				((obj_t)
																																				BgL_auxz00_6068);
																																		}
																																	}
																															}
																														else
																															{	/* Eval/evaluate.scm 424 */
																																obj_t
																																	BgL_cdrzd26695zd2_1692;
																																BgL_cdrzd26695zd2_1692
																																	=
																																	CDR
																																	(BgL_ez00_69);
																																if ((CAR
																																		(BgL_ez00_69)
																																		==
																																		BGl_symbol3273z00zz__evaluatez00))
																																	{	/* Eval/evaluate.scm 424 */
																																		if (PAIRP
																																			(BgL_cdrzd26695zd2_1692))
																																			{	/* Eval/evaluate.scm 424 */
																																				obj_t
																																					BgL_arg1686z00_1696;
																																				obj_t
																																					BgL_arg1687z00_1697;
																																				BgL_arg1686z00_1696
																																					=
																																					CAR
																																					(BgL_cdrzd26695zd2_1692);
																																				BgL_arg1687z00_1697
																																					=
																																					CDR
																																					(BgL_cdrzd26695zd2_1692);
																																				{
																																					BgL_ev_letrecz00_bglt
																																						BgL_auxz00_6080;
																																					BgL_bindsz00_1494
																																						=
																																						BgL_arg1686z00_1696;
																																					BgL_bodyz00_1495
																																						=
																																						BgL_arg1687z00_1697;
																																				BgL_tagzd2162zd2_1496:
																																					{	/* Eval/evaluate.scm 515 */
																																						obj_t
																																							BgL_ubindsz00_2480;
																																						if (NULLP(BgL_bindsz00_1494))
																																							{	/* Eval/evaluate.scm 515 */
																																								BgL_ubindsz00_2480
																																									=
																																									BNIL;
																																							}
																																						else
																																							{	/* Eval/evaluate.scm 515 */
																																								obj_t
																																									BgL_head1235z00_2530;
																																								{	/* Eval/evaluate.scm 515 */
																																									obj_t
																																										BgL_res2919z00_3697;
																																									BgL_res2919z00_3697
																																										=
																																										MAKE_YOUNG_PAIR
																																										(BNIL,
																																										BNIL);
																																									BgL_head1235z00_2530
																																										=
																																										BgL_res2919z00_3697;
																																								}
																																								{
																																									obj_t
																																										BgL_l1233z00_3725;
																																									obj_t
																																										BgL_tail1236z00_3726;
																																									BgL_l1233z00_3725
																																										=
																																										BgL_bindsz00_1494;
																																									BgL_tail1236z00_3726
																																										=
																																										BgL_head1235z00_2530;
																																								BgL_zc3z04anonymousza32342ze3z87_3724:
																																									if (NULLP(BgL_l1233z00_3725))
																																										{	/* Eval/evaluate.scm 515 */
																																											BgL_ubindsz00_2480
																																												=
																																												CDR
																																												(BgL_head1235z00_2530);
																																										}
																																									else
																																										{	/* Eval/evaluate.scm 515 */
																																											obj_t
																																												BgL_newtail1237z00_3734;
																																											{	/* Eval/evaluate.scm 515 */
																																												obj_t
																																													BgL_arg2345z00_3735;
																																												{	/* Eval/evaluate.scm 515 */
																																													obj_t
																																														BgL_bz00_3736;
																																													BgL_bz00_3736
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_l1233z00_3725));
																																													{	/* Eval/evaluate.scm 515 */
																																														obj_t
																																															BgL_arg2346z00_3737;
																																														BgL_arg2346z00_3737
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_bz00_3736));
																																														BgL_arg2345z00_3735
																																															=
																																															BGl_untypezd2identzd2zz__evaluatez00
																																															(BgL_arg2346z00_3737);
																																													}
																																												}
																																												{	/* Eval/evaluate.scm 515 */
																																													obj_t
																																														BgL_res2925z00_3743;
																																													BgL_res2925z00_3743
																																														=
																																														MAKE_YOUNG_PAIR
																																														(BgL_arg2345z00_3735,
																																														BNIL);
																																													BgL_newtail1237z00_3734
																																														=
																																														BgL_res2925z00_3743;
																																												}
																																											}
																																											SET_CDR
																																												(BgL_tail1236z00_3726,
																																												BgL_newtail1237z00_3734);
																																											{	/* Eval/evaluate.scm 515 */
																																												obj_t
																																													BgL_arg2344z00_3738;
																																												BgL_arg2344z00_3738
																																													=
																																													CDR
																																													(
																																													((obj_t) BgL_l1233z00_3725));
																																												{
																																													obj_t
																																														BgL_tail1236z00_6097;
																																													obj_t
																																														BgL_l1233z00_6096;
																																													BgL_l1233z00_6096
																																														=
																																														BgL_arg2344z00_3738;
																																													BgL_tail1236z00_6097
																																														=
																																														BgL_newtail1237z00_3734;
																																													BgL_tail1236z00_3726
																																														=
																																														BgL_tail1236z00_6097;
																																													BgL_l1233z00_3725
																																														=
																																														BgL_l1233z00_6096;
																																													goto
																																														BgL_zc3z04anonymousza32342ze3z87_3724;
																																												}
																																											}
																																										}
																																								}
																																							}
																																						{	/* Eval/evaluate.scm 515 */
																																							obj_t
																																								BgL_varsz00_2481;
																																							if (NULLP(BgL_ubindsz00_2480))
																																								{	/* Eval/evaluate.scm 516 */
																																									BgL_varsz00_2481
																																										=
																																										BNIL;
																																								}
																																							else
																																								{	/* Eval/evaluate.scm 516 */
																																									obj_t
																																										BgL_head1240z00_2514;
																																									{	/* Eval/evaluate.scm 516 */
																																										obj_t
																																											BgL_res2927z00_3747;
																																										BgL_res2927z00_3747
																																											=
																																											MAKE_YOUNG_PAIR
																																											(BNIL,
																																											BNIL);
																																										BgL_head1240z00_2514
																																											=
																																											BgL_res2927z00_3747;
																																									}
																																									{
																																										obj_t
																																											BgL_l1238z00_2516;
																																										obj_t
																																											BgL_tail1241z00_2517;
																																										BgL_l1238z00_2516
																																											=
																																											BgL_ubindsz00_2480;
																																										BgL_tail1241z00_2517
																																											=
																																											BgL_head1240z00_2514;
																																									BgL_zc3z04anonymousza32336ze3z87_2518:
																																										if (NULLP(BgL_l1238z00_2516))
																																											{	/* Eval/evaluate.scm 516 */
																																												BgL_varsz00_2481
																																													=
																																													CDR
																																													(BgL_head1240z00_2514);
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 516 */
																																												obj_t
																																													BgL_newtail1242z00_2520;
																																												{	/* Eval/evaluate.scm 516 */
																																													BgL_ev_varz00_bglt
																																														BgL_arg2339z00_2522;
																																													{	/* Eval/evaluate.scm 516 */
																																														obj_t
																																															BgL_iz00_2523;
																																														BgL_iz00_2523
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_l1238z00_2516));
																																														{	/* Eval/evaluate.scm 517 */
																																															BgL_ev_varz00_bglt
																																																BgL_new1134z00_2524;
																																															{	/* Eval/evaluate.scm 519 */
																																																BgL_ev_varz00_bglt
																																																	BgL_new1133z00_2525;
																																																BgL_new1133z00_2525
																																																	=
																																																	(
																																																	(BgL_ev_varz00_bglt)
																																																	BOBJECT
																																																	(GC_MALLOC
																																																		(sizeof
																																																			(struct
																																																				BgL_ev_varz00_bgl))));
																																																{	/* Eval/evaluate.scm 519 */
																																																	long
																																																		BgL_arg2340z00_2526;
																																																	{	/* Eval/evaluate.scm 519 */
																																																		long
																																																			BgL_res2929z00_3752;
																																																		BgL_res2929z00_3752
																																																			=
																																																			BGL_CLASS_INDEX
																																																			(BGl_ev_varz00zz__evaluate_typesz00);
																																																		BgL_arg2340z00_2526
																																																			=
																																																			BgL_res2929z00_3752;
																																																	}
																																																	BGL_OBJECT_CLASS_NUM_SET
																																																		(
																																																		((BgL_objectz00_bglt) BgL_new1133z00_2525), BgL_arg2340z00_2526);
																																																}
																																																BgL_new1134z00_2524
																																																	=
																																																	BgL_new1133z00_2525;
																																															}
																																															((((BgL_ev_varz00_bglt) COBJECT(BgL_new1134z00_2524))->BgL_namez00) = ((obj_t) CAR(((obj_t) BgL_iz00_2523))), BUNSPEC);
																																															((((BgL_ev_varz00_bglt) COBJECT(BgL_new1134z00_2524))->BgL_effz00) = ((obj_t) BFALSE), BUNSPEC);
																																															((((BgL_ev_varz00_bglt) COBJECT(BgL_new1134z00_2524))->BgL_typez00) = ((obj_t) CDR(((obj_t) BgL_iz00_2523))), BUNSPEC);
																																															BgL_arg2339z00_2522
																																																=
																																																BgL_new1134z00_2524;
																																													}}
																																													{	/* Eval/evaluate.scm 516 */
																																														obj_t
																																															BgL_res2930z00_3757;
																																														BgL_res2930z00_3757
																																															=
																																															MAKE_YOUNG_PAIR
																																															(
																																															((obj_t) BgL_arg2339z00_2522), BNIL);
																																														BgL_newtail1242z00_2520
																																															=
																																															BgL_res2930z00_3757;
																																												}}
																																												SET_CDR
																																													(BgL_tail1241z00_2517,
																																													BgL_newtail1242z00_2520);
																																												{	/* Eval/evaluate.scm 516 */
																																													obj_t
																																														BgL_arg2338z00_2521;
																																													BgL_arg2338z00_2521
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_l1238z00_2516));
																																													{
																																														obj_t
																																															BgL_tail1241z00_6123;
																																														obj_t
																																															BgL_l1238z00_6122;
																																														BgL_l1238z00_6122
																																															=
																																															BgL_arg2338z00_2521;
																																														BgL_tail1241z00_6123
																																															=
																																															BgL_newtail1242z00_2520;
																																														BgL_tail1241z00_2517
																																															=
																																															BgL_tail1241z00_6123;
																																														BgL_l1238z00_2516
																																															=
																																															BgL_l1238z00_6122;
																																														goto
																																															BgL_zc3z04anonymousza32336ze3z87_2518;
																																													}
																																												}
																																											}
																																									}
																																								}
																																							{	/* Eval/evaluate.scm 516 */
																																								obj_t
																																									BgL_localsz00_2482;
																																								BgL_localsz00_2482
																																									=
																																									BGl_appendzd221011zd2zz__evaluatez00
																																									(BgL_varsz00_2481,
																																									BgL_localsz00_70);
																																								{	/* Eval/evaluate.scm 521 */
																																									obj_t
																																										BgL_bodyz00_2483;
																																									{	/* Eval/evaluate.scm 522 */
																																										bool_t
																																											BgL_test3498z00_6125;
																																										{	/* Eval/evaluate.scm 522 */
																																											obj_t
																																												BgL_tmpz00_6126;
																																											BgL_tmpz00_6126
																																												=
																																												CDR
																																												(
																																												((obj_t) BgL_bodyz00_1495));
																																											BgL_test3498z00_6125
																																												=
																																												PAIRP
																																												(BgL_tmpz00_6126);
																																										}
																																										if (BgL_test3498z00_6125)
																																											{	/* Eval/evaluate.scm 522 */
																																												obj_t
																																													BgL_res2932z00_3763;
																																												BgL_res2932z00_3763
																																													=
																																													MAKE_YOUNG_EPAIR
																																													(BGl_symbol3254z00zz__evaluatez00,
																																													BgL_bodyz00_1495,
																																													BgL_locz00_74);
																																												BgL_bodyz00_2483
																																													=
																																													BgL_res2932z00_3763;
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 522 */
																																												BgL_bodyz00_2483
																																													=
																																													CAR
																																													(
																																													((obj_t) BgL_bodyz00_1495));
																																											}
																																									}
																																									{	/* Eval/evaluate.scm 522 */
																																										obj_t
																																											BgL_tbodyz00_2484;
																																										BgL_tbodyz00_2484
																																											=
																																											BGl_typezd2checkszd2zz__evaluatez00
																																											(BgL_ubindsz00_2480,
																																											BgL_bindsz00_1494,
																																											BgL_bodyz00_2483,
																																											BgL_locz00_74,
																																											BgL_wherez00_73);
																																										{	/* Eval/evaluate.scm 523 */
																																											obj_t
																																												BgL_blocz00_2485;
																																											{	/* Eval/evaluate.scm 144 */
																																												obj_t
																																													BgL__ortest_1068z00_3765;
																																												BgL__ortest_1068z00_3765
																																													=
																																													BGl_getzd2sourcezd2locationz00zz__readerz00
																																													(BgL_bindsz00_1494);
																																												if (CBOOL(BgL__ortest_1068z00_3765))
																																													{	/* Eval/evaluate.scm 144 */
																																														BgL_blocz00_2485
																																															=
																																															BgL__ortest_1068z00_3765;
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 144 */
																																														BgL_blocz00_2485
																																															=
																																															BgL_locz00_74;
																																													}
																																											}
																																											{	/* Eval/evaluate.scm 524 */

																																												{	/* Eval/evaluate.scm 525 */
																																													BgL_ev_letrecz00_bglt
																																														BgL_new1136z00_2486;
																																													{	/* Eval/evaluate.scm 526 */
																																														BgL_ev_letrecz00_bglt
																																															BgL_new1135z00_2507;
																																														BgL_new1135z00_2507
																																															=
																																															(
																																															(BgL_ev_letrecz00_bglt)
																																															BOBJECT
																																															(GC_MALLOC
																																																(sizeof
																																																	(struct
																																																		BgL_ev_letrecz00_bgl))));
																																														{	/* Eval/evaluate.scm 526 */
																																															long
																																																BgL_arg2331z00_2508;
																																															{	/* Eval/evaluate.scm 526 */
																																																long
																																																	BgL_res2933z00_3767;
																																																BgL_res2933z00_3767
																																																	=
																																																	BGL_CLASS_INDEX
																																																	(BGl_ev_letrecz00zz__evaluate_typesz00);
																																																BgL_arg2331z00_2508
																																																	=
																																																	BgL_res2933z00_3767;
																																															}
																																															BGL_OBJECT_CLASS_NUM_SET
																																																(
																																																((BgL_objectz00_bglt) BgL_new1135z00_2507), BgL_arg2331z00_2508);
																																														}
																																														BgL_new1136z00_2486
																																															=
																																															BgL_new1135z00_2507;
																																													}
																																													((((BgL_ev_binderz00_bglt) COBJECT(((BgL_ev_binderz00_bglt) BgL_new1136z00_2486)))->BgL_varsz00) = ((obj_t) BgL_varsz00_2481), BUNSPEC);
																																													{
																																														obj_t
																																															BgL_auxz00_6143;
																																														if (NULLP(BgL_bindsz00_1494))
																																															{	/* Eval/evaluate.scm 527 */
																																																BgL_auxz00_6143
																																																	=
																																																	BNIL;
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 527 */
																																																obj_t
																																																	BgL_head1245z00_2489;
																																																{	/* Eval/evaluate.scm 527 */
																																																	obj_t
																																																		BgL_res2935z00_3771;
																																																	BgL_res2935z00_3771
																																																		=
																																																		MAKE_YOUNG_PAIR
																																																		(BNIL,
																																																		BNIL);
																																																	BgL_head1245z00_2489
																																																		=
																																																		BgL_res2935z00_3771;
																																																}
																																																{
																																																	obj_t
																																																		BgL_l1243z00_2491;
																																																	obj_t
																																																		BgL_tail1246z00_2492;
																																																	BgL_l1243z00_2491
																																																		=
																																																		BgL_bindsz00_1494;
																																																	BgL_tail1246z00_2492
																																																		=
																																																		BgL_head1245z00_2489;
																																																BgL_zc3z04anonymousza32320ze3z87_2493:
																																																	if (NULLP(BgL_l1243z00_2491))
																																																		{	/* Eval/evaluate.scm 527 */
																																																			BgL_auxz00_6143
																																																				=
																																																				CDR
																																																				(BgL_head1245z00_2489);
																																																		}
																																																	else
																																																		{	/* Eval/evaluate.scm 527 */
																																																			obj_t
																																																				BgL_newtail1247z00_2495;
																																																			{	/* Eval/evaluate.scm 527 */
																																																				obj_t
																																																					BgL_arg2323z00_2497;
																																																				{	/* Eval/evaluate.scm 527 */
																																																					obj_t
																																																						BgL_bz00_2498;
																																																					BgL_bz00_2498
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_l1243z00_2491));
																																																					{	/* Eval/evaluate.scm 528 */
																																																						obj_t
																																																							BgL_arg2324z00_2499;
																																																						obj_t
																																																							BgL_arg2325z00_2500;
																																																						obj_t
																																																							BgL_arg2326z00_2501;
																																																						{	/* Eval/evaluate.scm 528 */
																																																							obj_t
																																																								BgL_pairz00_3778;
																																																							BgL_pairz00_3778
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_bz00_2498));
																																																							BgL_arg2324z00_2499
																																																								=
																																																								CAR
																																																								(BgL_pairz00_3778);
																																																						}
																																																						{	/* Eval/evaluate.scm 528 */
																																																							obj_t
																																																								BgL_arg2327z00_2502;
																																																							BgL_arg2327z00_2502
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_bz00_2498));
																																																							{	/* Eval/evaluate.scm 528 */
																																																								obj_t
																																																									BgL_list2328z00_2503;
																																																								{	/* Eval/evaluate.scm 528 */
																																																									obj_t
																																																										BgL_arg2329z00_2504;
																																																									{	/* Eval/evaluate.scm 528 */
																																																										obj_t
																																																											BgL_arg2330z00_2505;
																																																										BgL_arg2330z00_2505
																																																											=
																																																											MAKE_YOUNG_PAIR
																																																											(BgL_wherez00_73,
																																																											BNIL);
																																																										BgL_arg2329z00_2504
																																																											=
																																																											MAKE_YOUNG_PAIR
																																																											(BGl_symbol3256z00zz__evaluatez00,
																																																											BgL_arg2330z00_2505);
																																																									}
																																																									BgL_list2328z00_2503
																																																										=
																																																										MAKE_YOUNG_PAIR
																																																										(BgL_arg2327z00_2502,
																																																										BgL_arg2329z00_2504);
																																																								}
																																																								BgL_arg2325z00_2500
																																																									=
																																																									BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00
																																																									(BgL_list2328z00_2503);
																																																							}
																																																						}
																																																						{	/* Eval/evaluate.scm 144 */
																																																							obj_t
																																																								BgL__ortest_1068z00_3780;
																																																							BgL__ortest_1068z00_3780
																																																								=
																																																								BGl_getzd2sourcezd2locationz00zz__readerz00
																																																								(BgL_bz00_2498);
																																																							if (CBOOL(BgL__ortest_1068z00_3780))
																																																								{	/* Eval/evaluate.scm 144 */
																																																									BgL_arg2326z00_2501
																																																										=
																																																										BgL__ortest_1068z00_3780;
																																																								}
																																																							else
																																																								{	/* Eval/evaluate.scm 144 */
																																																									BgL_arg2326z00_2501
																																																										=
																																																										BgL_blocz00_2485;
																																																								}
																																																						}
																																																						BgL_arg2323z00_2497
																																																							=
																																																							BGl_convz00zz__evaluatez00
																																																							(BgL_arg2324z00_2499,
																																																							BgL_localsz00_2482,
																																																							BgL_globalsz00_71,
																																																							BFALSE,
																																																							BgL_arg2325z00_2500,
																																																							BgL_arg2326z00_2501,
																																																							((bool_t) 0));
																																																					}
																																																				}
																																																				{	/* Eval/evaluate.scm 527 */
																																																					obj_t
																																																						BgL_res2937z00_3781;
																																																					BgL_res2937z00_3781
																																																						=
																																																						MAKE_YOUNG_PAIR
																																																						(BgL_arg2323z00_2497,
																																																						BNIL);
																																																					BgL_newtail1247z00_2495
																																																						=
																																																						BgL_res2937z00_3781;
																																																				}
																																																			}
																																																			SET_CDR
																																																				(BgL_tail1246z00_2492,
																																																				BgL_newtail1247z00_2495);
																																																			{	/* Eval/evaluate.scm 527 */
																																																				obj_t
																																																					BgL_arg2322z00_2496;
																																																				BgL_arg2322z00_2496
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_l1243z00_2491));
																																																				{
																																																					obj_t
																																																						BgL_tail1246z00_6171;
																																																					obj_t
																																																						BgL_l1243z00_6170;
																																																					BgL_l1243z00_6170
																																																						=
																																																						BgL_arg2322z00_2496;
																																																					BgL_tail1246z00_6171
																																																						=
																																																						BgL_newtail1247z00_2495;
																																																					BgL_tail1246z00_2492
																																																						=
																																																						BgL_tail1246z00_6171;
																																																					BgL_l1243z00_2491
																																																						=
																																																						BgL_l1243z00_6170;
																																																					goto
																																																						BgL_zc3z04anonymousza32320ze3z87_2493;
																																																				}
																																																			}
																																																		}
																																																}
																																															}
																																														((((BgL_ev_binderz00_bglt) COBJECT(((BgL_ev_binderz00_bglt) BgL_new1136z00_2486)))->BgL_valsz00) = ((obj_t) BgL_auxz00_6143), BUNSPEC);
																																													}
																																													((((BgL_ev_binderz00_bglt) COBJECT(((BgL_ev_binderz00_bglt) BgL_new1136z00_2486)))->BgL_bodyz00) = ((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BGl_convz00zz__evaluatez00(BgL_tbodyz00_2484, BgL_localsz00_2482, BgL_globalsz00_71, BgL_tailzf3zf3_72, BgL_wherez00_73, BgL_locz00_74, ((bool_t) 0)))), BUNSPEC);
																																													BgL_auxz00_6080
																																														=
																																														BgL_new1136z00_2486;
																																												}
																																											}
																																										}
																																									}
																																								}
																																							}
																																						}
																																					}
																																					return
																																						(
																																						(obj_t)
																																						BgL_auxz00_6080);
																																				}
																																			}
																																		else
																																			{	/* Eval/evaluate.scm 424 */
																																				obj_t
																																					BgL_arg1688z00_1698;
																																				BgL_arg1688z00_1698
																																					=
																																					CAR
																																					(BgL_ez00_69);
																																				{
																																					BgL_ev_appz00_bglt
																																						BgL_auxz00_6179;
																																					{
																																						obj_t
																																							BgL_argsz00_6181;
																																						obj_t
																																							BgL_fz00_6180;
																																						BgL_fz00_6180
																																							=
																																							BgL_arg1688z00_1698;
																																						BgL_argsz00_6181
																																							=
																																							BgL_cdrzd26695zd2_1692;
																																						BgL_argsz00_1535
																																							=
																																							BgL_argsz00_6181;
																																						BgL_fz00_1534
																																							=
																																							BgL_fz00_6180;
																																						goto
																																							BgL_tagzd2175zd2_1536;
																																					}
																																					return
																																						(
																																						(obj_t)
																																						BgL_auxz00_6179);
																																				}
																																			}
																																	}
																																else
																																	{	/* Eval/evaluate.scm 424 */
																																		if (
																																			(CAR
																																				(BgL_ez00_69)
																																				==
																																				BGl_symbol3275z00zz__evaluatez00))
																																			{	/* Eval/evaluate.scm 424 */
																																				if (PAIRP(BgL_cdrzd26695zd2_1692))
																																					{	/* Eval/evaluate.scm 424 */
																																						obj_t
																																							BgL_carzd26869zd2_1704;
																																						obj_t
																																							BgL_cdrzd26870zd2_1705;
																																						BgL_carzd26869zd2_1704
																																							=
																																							CAR
																																							(BgL_cdrzd26695zd2_1692);
																																						BgL_cdrzd26870zd2_1705
																																							=
																																							CDR
																																							(BgL_cdrzd26695zd2_1692);
																																						if (PAIRP(BgL_carzd26869zd2_1704))
																																							{	/* Eval/evaluate.scm 424 */
																																								obj_t
																																									BgL_cdrzd26874zd2_1707;
																																								BgL_cdrzd26874zd2_1707
																																									=
																																									CDR
																																									(BgL_carzd26869zd2_1704);
																																								if ((CAR(BgL_carzd26869zd2_1704) == BGl_symbol3261z00zz__evaluatez00))
																																									{	/* Eval/evaluate.scm 424 */
																																										if (PAIRP(BgL_cdrzd26874zd2_1707))
																																											{	/* Eval/evaluate.scm 424 */
																																												obj_t
																																													BgL_carzd26877zd2_1711;
																																												obj_t
																																													BgL_cdrzd26878zd2_1712;
																																												BgL_carzd26877zd2_1711
																																													=
																																													CAR
																																													(BgL_cdrzd26874zd2_1707);
																																												BgL_cdrzd26878zd2_1712
																																													=
																																													CDR
																																													(BgL_cdrzd26874zd2_1707);
																																												if (SYMBOLP(BgL_carzd26877zd2_1711))
																																													{	/* Eval/evaluate.scm 424 */
																																														if (PAIRP(BgL_cdrzd26878zd2_1712))
																																															{	/* Eval/evaluate.scm 424 */
																																																obj_t
																																																	BgL_carzd26882zd2_1715;
																																																BgL_carzd26882zd2_1715
																																																	=
																																																	CAR
																																																	(BgL_cdrzd26878zd2_1712);
																																																if (SYMBOLP(BgL_carzd26882zd2_1715))
																																																	{	/* Eval/evaluate.scm 424 */
																																																		if (NULLP(CDR(BgL_cdrzd26878zd2_1712)))
																																																			{	/* Eval/evaluate.scm 424 */
																																																				if (PAIRP(BgL_cdrzd26870zd2_1705))
																																																					{	/* Eval/evaluate.scm 424 */
																																																						if (NULLP(CDR(BgL_cdrzd26870zd2_1705)))
																																																							{	/* Eval/evaluate.scm 424 */
																																																								obj_t
																																																									BgL_arg1709z00_1722;
																																																								BgL_arg1709z00_1722
																																																									=
																																																									CAR
																																																									(BgL_cdrzd26870zd2_1705);
																																																								{	/* Eval/evaluate.scm 531 */
																																																									BgL_ev_setglobalz00_bglt
																																																										BgL_new1138z00_4071;
																																																									{	/* Eval/evaluate.scm 535 */
																																																										BgL_ev_setglobalz00_bglt
																																																											BgL_new1137z00_4072;
																																																										BgL_new1137z00_4072
																																																											=
																																																											(
																																																											(BgL_ev_setglobalz00_bglt)
																																																											BOBJECT
																																																											(GC_MALLOC
																																																												(sizeof
																																																													(struct
																																																														BgL_ev_setglobalz00_bgl))));
																																																										{	/* Eval/evaluate.scm 535 */
																																																											long
																																																												BgL_arg2347z00_4073;
																																																											{	/* Eval/evaluate.scm 535 */
																																																												long
																																																													BgL_res2995z00_4075;
																																																												BgL_res2995z00_4075
																																																													=
																																																													BGL_CLASS_INDEX
																																																													(BGl_ev_setglobalz00zz__evaluate_typesz00);
																																																												BgL_arg2347z00_4073
																																																													=
																																																													BgL_res2995z00_4075;
																																																											}
																																																											BGL_OBJECT_CLASS_NUM_SET
																																																												(
																																																												((BgL_objectz00_bglt) BgL_new1137z00_4072), BgL_arg2347z00_4073);
																																																										}
																																																										BgL_new1138z00_4071
																																																											=
																																																											BgL_new1137z00_4072;
																																																									}
																																																									{
																																																										BgL_ev_exprz00_bglt
																																																											BgL_auxz00_6220;
																																																										{	/* Eval/evaluate.scm 380 */
																																																											obj_t
																																																												BgL_arg2395z00_4078;
																																																											BgL_arg2395z00_4078
																																																												=
																																																												BGl_getzd2locationzd2zz__evaluatez00
																																																												(BgL_arg1709z00_1722,
																																																												BgL_locz00_74);
																																																											BgL_auxz00_6220
																																																												=
																																																												(
																																																												(BgL_ev_exprz00_bglt)
																																																												BGl_uconvzf2locze70z15zz__evaluatez00
																																																												(BgL_wherez00_73,
																																																													BgL_globalsz00_71,
																																																													BgL_localsz00_70,
																																																													BgL_arg1709z00_1722,
																																																													BgL_arg2395z00_4078));
																																																										}
																																																										((((BgL_ev_hookz00_bglt) COBJECT(((BgL_ev_hookz00_bglt) BgL_new1138z00_4071)))->BgL_ez00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_6220), BUNSPEC);
																																																									}
																																																									((((BgL_ev_setglobalz00_bglt) COBJECT(BgL_new1138z00_4071))->BgL_locz00) = ((obj_t) BgL_locz00_74), BUNSPEC);
																																																									((((BgL_ev_setglobalz00_bglt) COBJECT(BgL_new1138z00_4071))->BgL_namez00) = ((obj_t) BgL_carzd26877zd2_1711), BUNSPEC);
																																																									((((BgL_ev_setglobalz00_bglt) COBJECT(BgL_new1138z00_4071))->BgL_modz00) = ((obj_t) BGl_evalzd2findzd2modulez00zz__evmodulez00(BgL_carzd26882zd2_1715)), BUNSPEC);
																																																									return
																																																										(
																																																										(obj_t)
																																																										BgL_new1138z00_4071);
																																																								}
																																																							}
																																																						else
																																																							{	/* Eval/evaluate.scm 424 */
																																																								return
																																																									BGl_evcompilezd2errorzd2zz__evcompilez00
																																																									(BgL_locz00_74,
																																																									BGl_string3178z00zz__evaluatez00,
																																																									BGl_string3253z00zz__evaluatez00,
																																																									BgL_ez00_69);
																																																							}
																																																					}
																																																				else
																																																					{	/* Eval/evaluate.scm 424 */
																																																						return
																																																							BGl_evcompilezd2errorzd2zz__evcompilez00
																																																							(BgL_locz00_74,
																																																							BGl_string3178z00zz__evaluatez00,
																																																							BGl_string3253z00zz__evaluatez00,
																																																							BgL_ez00_69);
																																																					}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 424 */
																																																				obj_t
																																																					BgL_cdrzd26998zd2_1724;
																																																				BgL_cdrzd26998zd2_1724
																																																					=
																																																					CDR
																																																					(BgL_ez00_69);
																																																				{	/* Eval/evaluate.scm 424 */
																																																					obj_t
																																																						BgL_cdrzd27002zd2_1725;
																																																					BgL_cdrzd27002zd2_1725
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd26998zd2_1724));
																																																					if (PAIRP(BgL_cdrzd27002zd2_1725))
																																																						{	/* Eval/evaluate.scm 424 */
																																																							if (NULLP(CDR(BgL_cdrzd27002zd2_1725)))
																																																								{	/* Eval/evaluate.scm 424 */
																																																									obj_t
																																																										BgL_arg1714z00_1729;
																																																									obj_t
																																																										BgL_arg1715z00_1730;
																																																									BgL_arg1714z00_1729
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd26998zd2_1724));
																																																									BgL_arg1715z00_1730
																																																										=
																																																										CAR
																																																										(BgL_cdrzd27002zd2_1725);
																																																									{
																																																										BgL_ev_hookz00_bglt
																																																											BgL_auxz00_6244;
																																																										BgL_vz00_1504
																																																											=
																																																											BgL_arg1714z00_1729;
																																																										BgL_ez00_1505
																																																											=
																																																											BgL_arg1715z00_1730;
																																																									BgL_tagzd2165zd2_1506:
																																																										{	/* Eval/evaluate.scm 541 */
																																																											obj_t
																																																												BgL_cvz00_2571;
																																																											obj_t
																																																												BgL_ez00_2572;
																																																											BgL_cvz00_2571
																																																												=
																																																												BGl_convzd2varzd2zz__evaluatez00
																																																												(BgL_vz00_1504,
																																																												BgL_localsz00_70);
																																																											{	/* Eval/evaluate.scm 380 */
																																																												obj_t
																																																													BgL_arg2395z00_3800;
																																																												{	/* Eval/evaluate.scm 144 */
																																																													obj_t
																																																														BgL__ortest_1068z00_3801;
																																																													BgL__ortest_1068z00_3801
																																																														=
																																																														BGl_getzd2sourcezd2locationz00zz__readerz00
																																																														(BgL_ez00_1505);
																																																													if (CBOOL(BgL__ortest_1068z00_3801))
																																																														{	/* Eval/evaluate.scm 144 */
																																																															BgL_arg2395z00_3800
																																																																=
																																																																BgL__ortest_1068z00_3801;
																																																														}
																																																													else
																																																														{	/* Eval/evaluate.scm 144 */
																																																															BgL_arg2395z00_3800
																																																																=
																																																																BgL_locz00_74;
																																																														}
																																																												}
																																																												BgL_ez00_2572
																																																													=
																																																													BGl_convz00zz__evaluatez00
																																																													(BgL_ez00_1505,
																																																													BgL_localsz00_70,
																																																													BgL_globalsz00_71,
																																																													BFALSE,
																																																													BgL_wherez00_73,
																																																													BgL_arg2395z00_3800,
																																																													((bool_t) 0));
																																																											}
																																																											if (CBOOL(BgL_cvz00_2571))
																																																												{	/* Eval/evaluate.scm 543 */
																																																													BgL_ev_setlocalz00_bglt
																																																														BgL_new1140z00_2573;
																																																													{	/* Eval/evaluate.scm 545 */
																																																														BgL_ev_setlocalz00_bglt
																																																															BgL_new1139z00_2574;
																																																														BgL_new1139z00_2574
																																																															=
																																																															(
																																																															(BgL_ev_setlocalz00_bglt)
																																																															BOBJECT
																																																															(GC_MALLOC
																																																																(sizeof
																																																																	(struct
																																																																		BgL_ev_setlocalz00_bgl))));
																																																														{	/* Eval/evaluate.scm 545 */
																																																															long
																																																																BgL_arg2363z00_2575;
																																																															{	/* Eval/evaluate.scm 545 */
																																																																long
																																																																	BgL_res2943z00_3803;
																																																																BgL_res2943z00_3803
																																																																	=
																																																																	BGL_CLASS_INDEX
																																																																	(BGl_ev_setlocalz00zz__evaluate_typesz00);
																																																																BgL_arg2363z00_2575
																																																																	=
																																																																	BgL_res2943z00_3803;
																																																															}
																																																															BGL_OBJECT_CLASS_NUM_SET
																																																																(
																																																																((BgL_objectz00_bglt) BgL_new1139z00_2574), BgL_arg2363z00_2575);
																																																														}
																																																														BgL_new1140z00_2573
																																																															=
																																																															BgL_new1139z00_2574;
																																																													}
																																																													((((BgL_ev_hookz00_bglt) COBJECT(((BgL_ev_hookz00_bglt) BgL_new1140z00_2573)))->BgL_ez00) = ((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_ez00_2572)), BUNSPEC);
																																																													((((BgL_ev_setlocalz00_bglt) COBJECT(BgL_new1140z00_2573))->BgL_vz00) = ((BgL_ev_varz00_bglt) ((BgL_ev_varz00_bglt) BgL_cvz00_2571)), BUNSPEC);
																																																													BgL_auxz00_6244
																																																														=
																																																														(
																																																														(BgL_ev_hookz00_bglt)
																																																														BgL_new1140z00_2573);
																																																												}
																																																											else
																																																												{	/* Eval/evaluate.scm 546 */
																																																													BgL_ev_setglobalz00_bglt
																																																														BgL_new1142z00_2576;
																																																													{	/* Eval/evaluate.scm 550 */
																																																														BgL_ev_setglobalz00_bglt
																																																															BgL_new1141z00_2578;
																																																														BgL_new1141z00_2578
																																																															=
																																																															(
																																																															(BgL_ev_setglobalz00_bglt)
																																																															BOBJECT
																																																															(GC_MALLOC
																																																																(sizeof
																																																																	(struct
																																																																		BgL_ev_setglobalz00_bgl))));
																																																														{	/* Eval/evaluate.scm 550 */
																																																															long
																																																																BgL_arg2365z00_2579;
																																																															{	/* Eval/evaluate.scm 550 */
																																																																long
																																																																	BgL_res2944z00_3807;
																																																																BgL_res2944z00_3807
																																																																	=
																																																																	BGL_CLASS_INDEX
																																																																	(BGl_ev_setglobalz00zz__evaluate_typesz00);
																																																																BgL_arg2365z00_2579
																																																																	=
																																																																	BgL_res2944z00_3807;
																																																															}
																																																															BGL_OBJECT_CLASS_NUM_SET
																																																																(
																																																																((BgL_objectz00_bglt) BgL_new1141z00_2578), BgL_arg2365z00_2579);
																																																														}
																																																														BgL_new1142z00_2576
																																																															=
																																																															BgL_new1141z00_2578;
																																																													}
																																																													((((BgL_ev_hookz00_bglt) COBJECT(((BgL_ev_hookz00_bglt) BgL_new1142z00_2576)))->BgL_ez00) = ((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_ez00_2572)), BUNSPEC);
																																																													((((BgL_ev_setglobalz00_bglt) COBJECT(BgL_new1142z00_2576))->BgL_locz00) = ((obj_t) BgL_locz00_74), BUNSPEC);
																																																													((((BgL_ev_setglobalz00_bglt) COBJECT(BgL_new1142z00_2576))->BgL_namez00) = ((obj_t) BgL_vz00_1504), BUNSPEC);
																																																													{
																																																														obj_t
																																																															BgL_auxz00_6271;
																																																														if (BGl_evmodulezf3zf3zz__evmodulez00(BgL_globalsz00_71))
																																																															{	/* Eval/evaluate.scm 549 */
																																																																BgL_auxz00_6271
																																																																	=
																																																																	BgL_globalsz00_71;
																																																															}
																																																														else
																																																															{	/* Eval/evaluate.scm 549 */
																																																																BgL_auxz00_6271
																																																																	=
																																																																	BGL_MODULE
																																																																	();
																																																															}
																																																														((((BgL_ev_setglobalz00_bglt) COBJECT(BgL_new1142z00_2576))->BgL_modz00) = ((obj_t) BgL_auxz00_6271), BUNSPEC);
																																																													}
																																																													BgL_auxz00_6244
																																																														=
																																																														(
																																																														(BgL_ev_hookz00_bglt)
																																																														BgL_new1142z00_2576);
																																																												}
																																																										}
																																																										return
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_6244);
																																																									}
																																																								}
																																																							else
																																																								{	/* Eval/evaluate.scm 424 */
																																																									return
																																																										BGl_evcompilezd2errorzd2zz__evcompilez00
																																																										(BgL_locz00_74,
																																																										BGl_string3178z00zz__evaluatez00,
																																																										BGl_string3253z00zz__evaluatez00,
																																																										BgL_ez00_69);
																																																								}
																																																						}
																																																					else
																																																						{	/* Eval/evaluate.scm 424 */
																																																							return
																																																								BGl_evcompilezd2errorzd2zz__evcompilez00
																																																								(BgL_locz00_74,
																																																								BGl_string3178z00zz__evaluatez00,
																																																								BGl_string3253z00zz__evaluatez00,
																																																								BgL_ez00_69);
																																																						}
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Eval/evaluate.scm 424 */
																																																		obj_t
																																																			BgL_cdrzd27059zd2_1733;
																																																		BgL_cdrzd27059zd2_1733
																																																			=
																																																			CDR
																																																			(BgL_ez00_69);
																																																		{	/* Eval/evaluate.scm 424 */
																																																			obj_t
																																																				BgL_cdrzd27063zd2_1734;
																																																			BgL_cdrzd27063zd2_1734
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd27059zd2_1733));
																																																			if (PAIRP(BgL_cdrzd27063zd2_1734))
																																																				{	/* Eval/evaluate.scm 424 */
																																																					if (NULLP(CDR(BgL_cdrzd27063zd2_1734)))
																																																						{	/* Eval/evaluate.scm 424 */
																																																							obj_t
																																																								BgL_arg1721z00_1738;
																																																							obj_t
																																																								BgL_arg1722z00_1739;
																																																							BgL_arg1721z00_1738
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd27059zd2_1733));
																																																							BgL_arg1722z00_1739
																																																								=
																																																								CAR
																																																								(BgL_cdrzd27063zd2_1734);
																																																							{
																																																								BgL_ev_hookz00_bglt
																																																									BgL_auxz00_6291;
																																																								{
																																																									obj_t
																																																										BgL_ez00_6293;
																																																									obj_t
																																																										BgL_vz00_6292;
																																																									BgL_vz00_6292
																																																										=
																																																										BgL_arg1721z00_1738;
																																																									BgL_ez00_6293
																																																										=
																																																										BgL_arg1722z00_1739;
																																																									BgL_ez00_1505
																																																										=
																																																										BgL_ez00_6293;
																																																									BgL_vz00_1504
																																																										=
																																																										BgL_vz00_6292;
																																																									goto
																																																										BgL_tagzd2165zd2_1506;
																																																								}
																																																								return
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_6291);
																																																							}
																																																						}
																																																					else
																																																						{	/* Eval/evaluate.scm 424 */
																																																							return
																																																								BGl_evcompilezd2errorzd2zz__evcompilez00
																																																								(BgL_locz00_74,
																																																								BGl_string3178z00zz__evaluatez00,
																																																								BGl_string3253z00zz__evaluatez00,
																																																								BgL_ez00_69);
																																																						}
																																																				}
																																																			else
																																																				{	/* Eval/evaluate.scm 424 */
																																																					return
																																																						BGl_evcompilezd2errorzd2zz__evcompilez00
																																																						(BgL_locz00_74,
																																																						BGl_string3178z00zz__evaluatez00,
																																																						BGl_string3253z00zz__evaluatez00,
																																																						BgL_ez00_69);
																																																				}
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 424 */
																																																obj_t
																																																	BgL_cdrzd27120zd2_1741;
																																																BgL_cdrzd27120zd2_1741
																																																	=
																																																	CDR
																																																	(BgL_ez00_69);
																																																{	/* Eval/evaluate.scm 424 */
																																																	obj_t
																																																		BgL_cdrzd27124zd2_1742;
																																																	BgL_cdrzd27124zd2_1742
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd27120zd2_1741));
																																																	if (PAIRP(BgL_cdrzd27124zd2_1742))
																																																		{	/* Eval/evaluate.scm 424 */
																																																			if (NULLP(CDR(BgL_cdrzd27124zd2_1742)))
																																																				{	/* Eval/evaluate.scm 424 */
																																																					obj_t
																																																						BgL_arg1727z00_1746;
																																																					obj_t
																																																						BgL_arg1728z00_1747;
																																																					BgL_arg1727z00_1746
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd27120zd2_1741));
																																																					BgL_arg1728z00_1747
																																																						=
																																																						CAR
																																																						(BgL_cdrzd27124zd2_1742);
																																																					{
																																																						BgL_ev_hookz00_bglt
																																																							BgL_auxz00_6308;
																																																						{
																																																							obj_t
																																																								BgL_ez00_6310;
																																																							obj_t
																																																								BgL_vz00_6309;
																																																							BgL_vz00_6309
																																																								=
																																																								BgL_arg1727z00_1746;
																																																							BgL_ez00_6310
																																																								=
																																																								BgL_arg1728z00_1747;
																																																							BgL_ez00_1505
																																																								=
																																																								BgL_ez00_6310;
																																																							BgL_vz00_1504
																																																								=
																																																								BgL_vz00_6309;
																																																							goto
																																																								BgL_tagzd2165zd2_1506;
																																																						}
																																																						return
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_6308);
																																																					}
																																																				}
																																																			else
																																																				{	/* Eval/evaluate.scm 424 */
																																																					return
																																																						BGl_evcompilezd2errorzd2zz__evcompilez00
																																																						(BgL_locz00_74,
																																																						BGl_string3178z00zz__evaluatez00,
																																																						BGl_string3253z00zz__evaluatez00,
																																																						BgL_ez00_69);
																																																				}
																																																		}
																																																	else
																																																		{	/* Eval/evaluate.scm 424 */
																																																			return
																																																				BGl_evcompilezd2errorzd2zz__evcompilez00
																																																				(BgL_locz00_74,
																																																				BGl_string3178z00zz__evaluatez00,
																																																				BGl_string3253z00zz__evaluatez00,
																																																				BgL_ez00_69);
																																																		}
																																																}
																																															}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 424 */
																																														obj_t
																																															BgL_cdrzd27181zd2_1749;
																																														BgL_cdrzd27181zd2_1749
																																															=
																																															CDR
																																															(BgL_ez00_69);
																																														{	/* Eval/evaluate.scm 424 */
																																															obj_t
																																																BgL_cdrzd27185zd2_1750;
																																															BgL_cdrzd27185zd2_1750
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd27181zd2_1749));
																																															if (PAIRP(BgL_cdrzd27185zd2_1750))
																																																{	/* Eval/evaluate.scm 424 */
																																																	if (NULLP(CDR(BgL_cdrzd27185zd2_1750)))
																																																		{	/* Eval/evaluate.scm 424 */
																																																			obj_t
																																																				BgL_arg1733z00_1754;
																																																			obj_t
																																																				BgL_arg1734z00_1755;
																																																			BgL_arg1733z00_1754
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd27181zd2_1749));
																																																			BgL_arg1734z00_1755
																																																				=
																																																				CAR
																																																				(BgL_cdrzd27185zd2_1750);
																																																			{
																																																				BgL_ev_hookz00_bglt
																																																					BgL_auxz00_6325;
																																																				{
																																																					obj_t
																																																						BgL_ez00_6327;
																																																					obj_t
																																																						BgL_vz00_6326;
																																																					BgL_vz00_6326
																																																						=
																																																						BgL_arg1733z00_1754;
																																																					BgL_ez00_6327
																																																						=
																																																						BgL_arg1734z00_1755;
																																																					BgL_ez00_1505
																																																						=
																																																						BgL_ez00_6327;
																																																					BgL_vz00_1504
																																																						=
																																																						BgL_vz00_6326;
																																																					goto
																																																						BgL_tagzd2165zd2_1506;
																																																				}
																																																				return
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_6325);
																																																			}
																																																		}
																																																	else
																																																		{	/* Eval/evaluate.scm 424 */
																																																			return
																																																				BGl_evcompilezd2errorzd2zz__evcompilez00
																																																				(BgL_locz00_74,
																																																				BGl_string3178z00zz__evaluatez00,
																																																				BGl_string3253z00zz__evaluatez00,
																																																				BgL_ez00_69);
																																																		}
																																																}
																																															else
																																																{	/* Eval/evaluate.scm 424 */
																																																	return
																																																		BGl_evcompilezd2errorzd2zz__evcompilez00
																																																		(BgL_locz00_74,
																																																		BGl_string3178z00zz__evaluatez00,
																																																		BGl_string3253z00zz__evaluatez00,
																																																		BgL_ez00_69);
																																																}
																																														}
																																													}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 424 */
																																												obj_t
																																													BgL_cdrzd27242zd2_1757;
																																												BgL_cdrzd27242zd2_1757
																																													=
																																													CDR
																																													(BgL_ez00_69);
																																												{	/* Eval/evaluate.scm 424 */
																																													obj_t
																																														BgL_cdrzd27246zd2_1758;
																																													BgL_cdrzd27246zd2_1758
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_cdrzd27242zd2_1757));
																																													if (PAIRP(BgL_cdrzd27246zd2_1758))
																																														{	/* Eval/evaluate.scm 424 */
																																															if (NULLP(CDR(BgL_cdrzd27246zd2_1758)))
																																																{	/* Eval/evaluate.scm 424 */
																																																	obj_t
																																																		BgL_arg1740z00_1762;
																																																	obj_t
																																																		BgL_arg1741z00_1763;
																																																	BgL_arg1740z00_1762
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd27242zd2_1757));
																																																	BgL_arg1741z00_1763
																																																		=
																																																		CAR
																																																		(BgL_cdrzd27246zd2_1758);
																																																	{
																																																		BgL_ev_hookz00_bglt
																																																			BgL_auxz00_6342;
																																																		{
																																																			obj_t
																																																				BgL_ez00_6344;
																																																			obj_t
																																																				BgL_vz00_6343;
																																																			BgL_vz00_6343
																																																				=
																																																				BgL_arg1740z00_1762;
																																																			BgL_ez00_6344
																																																				=
																																																				BgL_arg1741z00_1763;
																																																			BgL_ez00_1505
																																																				=
																																																				BgL_ez00_6344;
																																																			BgL_vz00_1504
																																																				=
																																																				BgL_vz00_6343;
																																																			goto
																																																				BgL_tagzd2165zd2_1506;
																																																		}
																																																		return
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_6342);
																																																	}
																																																}
																																															else
																																																{	/* Eval/evaluate.scm 424 */
																																																	return
																																																		BGl_evcompilezd2errorzd2zz__evcompilez00
																																																		(BgL_locz00_74,
																																																		BGl_string3178z00zz__evaluatez00,
																																																		BGl_string3253z00zz__evaluatez00,
																																																		BgL_ez00_69);
																																																}
																																														}
																																													else
																																														{	/* Eval/evaluate.scm 424 */
																																															return
																																																BGl_evcompilezd2errorzd2zz__evcompilez00
																																																(BgL_locz00_74,
																																																BGl_string3178z00zz__evaluatez00,
																																																BGl_string3253z00zz__evaluatez00,
																																																BgL_ez00_69);
																																														}
																																												}
																																											}
																																									}
																																								else
																																									{	/* Eval/evaluate.scm 424 */
																																										obj_t
																																											BgL_cdrzd27290zd2_1765;
																																										BgL_cdrzd27290zd2_1765
																																											=
																																											CDR
																																											(BgL_ez00_69);
																																										{	/* Eval/evaluate.scm 424 */
																																											obj_t
																																												BgL_carzd27293zd2_1766;
																																											obj_t
																																												BgL_cdrzd27294zd2_1767;
																																											BgL_carzd27293zd2_1766
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_cdrzd27290zd2_1765));
																																											BgL_cdrzd27294zd2_1767
																																												=
																																												CDR
																																												(
																																												((obj_t) BgL_cdrzd27290zd2_1765));
																																											if ((CAR(((obj_t) BgL_carzd27293zd2_1766)) == BGl_symbol3263z00zz__evaluatez00))
																																												{	/* Eval/evaluate.scm 424 */
																																													if (PAIRP(BgL_cdrzd27294zd2_1767))
																																														{	/* Eval/evaluate.scm 424 */
																																															if (NULLP(CDR(BgL_cdrzd27294zd2_1767)))
																																																{	/* Eval/evaluate.scm 424 */
																																																	obj_t
																																																		BgL_arg1748z00_1773;
																																																	obj_t
																																																		BgL_arg1749z00_1774;
																																																	BgL_arg1748z00_1773
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_carzd27293zd2_1766));
																																																	BgL_arg1749z00_1774
																																																		=
																																																		CAR
																																																		(BgL_cdrzd27294zd2_1767);
																																																	BgL_lz00_1501
																																																		=
																																																		BgL_arg1748z00_1773;
																																																	BgL_e2z00_1502
																																																		=
																																																		BgL_arg1749z00_1774;
																																																BgL_tagzd2164zd2_1503:
																																																	{	/* Eval/evaluate.scm 537 */
																																																		bool_t
																																																			BgL_test3530z00_6365;
																																																		if (PAIRP(BgL_lz00_1501))
																																																			{	/* Eval/evaluate.scm 537 */
																																																				bool_t
																																																					BgL_test3532z00_6368;
																																																				{	/* Eval/evaluate.scm 537 */
																																																					obj_t
																																																						BgL_tmpz00_6369;
																																																					BgL_tmpz00_6369
																																																						=
																																																						CDR
																																																						(BgL_lz00_1501);
																																																					BgL_test3532z00_6368
																																																						=
																																																						PAIRP
																																																						(BgL_tmpz00_6369);
																																																				}
																																																				if (BgL_test3532z00_6368)
																																																					{
																																																						obj_t
																																																							BgL_l1248z00_2562;
																																																						BgL_l1248z00_2562
																																																							=
																																																							BgL_lz00_1501;
																																																					BgL_zc3z04anonymousza32358ze3z87_2563:
																																																						if (NULLP(BgL_l1248z00_2562))
																																																							{	/* Eval/evaluate.scm 537 */
																																																								BgL_test3530z00_6365
																																																									=
																																																									(
																																																									(bool_t)
																																																									1);
																																																							}
																																																						else
																																																							{	/* Eval/evaluate.scm 537 */
																																																								bool_t
																																																									BgL_test3534z00_6374;
																																																								{	/* Eval/evaluate.scm 537 */
																																																									obj_t
																																																										BgL_tmpz00_6375;
																																																									BgL_tmpz00_6375
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_l1248z00_2562));
																																																									BgL_test3534z00_6374
																																																										=
																																																										SYMBOLP
																																																										(BgL_tmpz00_6375);
																																																								}
																																																								if (BgL_test3534z00_6374)
																																																									{
																																																										obj_t
																																																											BgL_l1248z00_6379;
																																																										BgL_l1248z00_6379
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_l1248z00_2562));
																																																										BgL_l1248z00_2562
																																																											=
																																																											BgL_l1248z00_6379;
																																																										goto
																																																											BgL_zc3z04anonymousza32358ze3z87_2563;
																																																									}
																																																								else
																																																									{	/* Eval/evaluate.scm 537 */
																																																										BgL_test3530z00_6365
																																																											=
																																																											(
																																																											(bool_t)
																																																											0);
																																																									}
																																																							}
																																																					}
																																																				else
																																																					{	/* Eval/evaluate.scm 537 */
																																																						BgL_test3530z00_6365
																																																							=
																																																							(
																																																							(bool_t)
																																																							0);
																																																					}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 537 */
																																																				BgL_test3530z00_6365
																																																					=
																																																					(
																																																					(bool_t)
																																																					0);
																																																			}
																																																		if (BgL_test3530z00_6365)
																																																			{	/* Eval/evaluate.scm 537 */
																																																				return
																																																					BGl_convzd2fieldzd2setz00zz__evaluatez00
																																																					(BgL_lz00_1501,
																																																					BgL_e2z00_1502,
																																																					BgL_ez00_69,
																																																					BgL_localsz00_70,
																																																					BgL_globalsz00_71,
																																																					BgL_tailzf3zf3_72,
																																																					BgL_wherez00_73,
																																																					BgL_locz00_74,
																																																					BgL_topzf3zf3_75);
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 537 */
																																																				return
																																																					BGl_evcompilezd2errorzd2zz__evcompilez00
																																																					(BgL_locz00_74,
																																																					BGl_string3178z00zz__evaluatez00,
																																																					BGl_string3253z00zz__evaluatez00,
																																																					BgL_ez00_69);
																																																			}
																																																	}
																																																}
																																															else
																																																{	/* Eval/evaluate.scm 424 */
																																																	return
																																																		BGl_evcompilezd2errorzd2zz__evcompilez00
																																																		(BgL_locz00_74,
																																																		BGl_string3178z00zz__evaluatez00,
																																																		BGl_string3253z00zz__evaluatez00,
																																																		BgL_ez00_69);
																																																}
																																														}
																																													else
																																														{	/* Eval/evaluate.scm 424 */
																																															return
																																																BGl_evcompilezd2errorzd2zz__evcompilez00
																																																(BgL_locz00_74,
																																																BGl_string3178z00zz__evaluatez00,
																																																BGl_string3253z00zz__evaluatez00,
																																																BgL_ez00_69);
																																														}
																																												}
																																											else
																																												{	/* Eval/evaluate.scm 424 */
																																													obj_t
																																														BgL_cdrzd27370zd2_1777;
																																													BgL_cdrzd27370zd2_1777
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_cdrzd27290zd2_1765));
																																													if (PAIRP(BgL_cdrzd27370zd2_1777))
																																														{	/* Eval/evaluate.scm 424 */
																																															if (NULLP(CDR(BgL_cdrzd27370zd2_1777)))
																																																{	/* Eval/evaluate.scm 424 */
																																																	obj_t
																																																		BgL_arg1756z00_1781;
																																																	obj_t
																																																		BgL_arg1758z00_1782;
																																																	BgL_arg1756z00_1781
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd27290zd2_1765));
																																																	BgL_arg1758z00_1782
																																																		=
																																																		CAR
																																																		(BgL_cdrzd27370zd2_1777);
																																																	{
																																																		BgL_ev_hookz00_bglt
																																																			BgL_auxz00_6396;
																																																		{
																																																			obj_t
																																																				BgL_ez00_6398;
																																																			obj_t
																																																				BgL_vz00_6397;
																																																			BgL_vz00_6397
																																																				=
																																																				BgL_arg1756z00_1781;
																																																			BgL_ez00_6398
																																																				=
																																																				BgL_arg1758z00_1782;
																																																			BgL_ez00_1505
																																																				=
																																																				BgL_ez00_6398;
																																																			BgL_vz00_1504
																																																				=
																																																				BgL_vz00_6397;
																																																			goto
																																																				BgL_tagzd2165zd2_1506;
																																																		}
																																																		return
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_6396);
																																																	}
																																																}
																																															else
																																																{	/* Eval/evaluate.scm 424 */
																																																	return
																																																		BGl_evcompilezd2errorzd2zz__evcompilez00
																																																		(BgL_locz00_74,
																																																		BGl_string3178z00zz__evaluatez00,
																																																		BGl_string3253z00zz__evaluatez00,
																																																		BgL_ez00_69);
																																																}
																																														}
																																													else
																																														{	/* Eval/evaluate.scm 424 */
																																															return
																																																BGl_evcompilezd2errorzd2zz__evcompilez00
																																																(BgL_locz00_74,
																																																BGl_string3178z00zz__evaluatez00,
																																																BGl_string3253z00zz__evaluatez00,
																																																BgL_ez00_69);
																																														}
																																												}
																																										}
																																									}
																																							}
																																						else
																																							{	/* Eval/evaluate.scm 424 */
																																								obj_t
																																									BgL_cdrzd27427zd2_1786;
																																								BgL_cdrzd27427zd2_1786
																																									=
																																									CDR
																																									(BgL_ez00_69);
																																								{	/* Eval/evaluate.scm 424 */
																																									obj_t
																																										BgL_cdrzd27431zd2_1787;
																																									BgL_cdrzd27431zd2_1787
																																										=
																																										CDR
																																										(
																																										((obj_t) BgL_cdrzd27427zd2_1786));
																																									if (PAIRP(BgL_cdrzd27431zd2_1787))
																																										{	/* Eval/evaluate.scm 424 */
																																											if (NULLP(CDR(BgL_cdrzd27431zd2_1787)))
																																												{	/* Eval/evaluate.scm 424 */
																																													obj_t
																																														BgL_arg1765z00_1791;
																																													obj_t
																																														BgL_arg1767z00_1792;
																																													BgL_arg1765z00_1791
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_cdrzd27427zd2_1786));
																																													BgL_arg1767z00_1792
																																														=
																																														CAR
																																														(BgL_cdrzd27431zd2_1787);
																																													{
																																														BgL_ev_hookz00_bglt
																																															BgL_auxz00_6413;
																																														{
																																															obj_t
																																																BgL_ez00_6415;
																																															obj_t
																																																BgL_vz00_6414;
																																															BgL_vz00_6414
																																																=
																																																BgL_arg1765z00_1791;
																																															BgL_ez00_6415
																																																=
																																																BgL_arg1767z00_1792;
																																															BgL_ez00_1505
																																																=
																																																BgL_ez00_6415;
																																															BgL_vz00_1504
																																																=
																																																BgL_vz00_6414;
																																															goto
																																																BgL_tagzd2165zd2_1506;
																																														}
																																														return
																																															(
																																															(obj_t)
																																															BgL_auxz00_6413);
																																													}
																																												}
																																											else
																																												{	/* Eval/evaluate.scm 424 */
																																													return
																																														BGl_evcompilezd2errorzd2zz__evcompilez00
																																														(BgL_locz00_74,
																																														BGl_string3178z00zz__evaluatez00,
																																														BGl_string3253z00zz__evaluatez00,
																																														BgL_ez00_69);
																																												}
																																										}
																																									else
																																										{	/* Eval/evaluate.scm 424 */
																																											return
																																												BGl_evcompilezd2errorzd2zz__evcompilez00
																																												(BgL_locz00_74,
																																												BGl_string3178z00zz__evaluatez00,
																																												BGl_string3253z00zz__evaluatez00,
																																												BgL_ez00_69);
																																										}
																																								}
																																							}
																																					}
																																				else
																																					{	/* Eval/evaluate.scm 424 */
																																						return
																																							BGl_evcompilezd2errorzd2zz__evcompilez00
																																							(BgL_locz00_74,
																																							BGl_string3178z00zz__evaluatez00,
																																							BGl_string3253z00zz__evaluatez00,
																																							BgL_ez00_69);
																																					}
																																			}
																																		else
																																			{	/* Eval/evaluate.scm 424 */
																																				obj_t
																																					BgL_cdrzd27552zd2_1794;
																																				BgL_cdrzd27552zd2_1794
																																					=
																																					CDR
																																					(BgL_ez00_69);
																																				if ((CAR
																																						(BgL_ez00_69)
																																						==
																																						BGl_symbol3277z00zz__evaluatez00))
																																					{	/* Eval/evaluate.scm 424 */
																																						if (PAIRP(BgL_cdrzd27552zd2_1794))
																																							{	/* Eval/evaluate.scm 424 */
																																								obj_t
																																									BgL_cdrzd27557zd2_1798;
																																								BgL_cdrzd27557zd2_1798
																																									=
																																									CDR
																																									(BgL_cdrzd27552zd2_1794);
																																								if (PAIRP(BgL_cdrzd27557zd2_1798))
																																									{	/* Eval/evaluate.scm 424 */
																																										obj_t
																																											BgL_carzd27561zd2_1800;
																																										BgL_carzd27561zd2_1800
																																											=
																																											CAR
																																											(BgL_cdrzd27557zd2_1798);
																																										if (PAIRP(BgL_carzd27561zd2_1800))
																																											{	/* Eval/evaluate.scm 424 */
																																												obj_t
																																													BgL_cdrzd27566zd2_1802;
																																												BgL_cdrzd27566zd2_1802
																																													=
																																													CDR
																																													(BgL_carzd27561zd2_1800);
																																												if ((CAR(BgL_carzd27561zd2_1800) == BGl_symbol3242z00zz__evaluatez00))
																																													{	/* Eval/evaluate.scm 424 */
																																														if (PAIRP(BgL_cdrzd27566zd2_1802))
																																															{	/* Eval/evaluate.scm 424 */
																																																obj_t
																																																	BgL_cdrzd27570zd2_1806;
																																																BgL_cdrzd27570zd2_1806
																																																	=
																																																	CDR
																																																	(BgL_cdrzd27566zd2_1802);
																																																if (PAIRP(BgL_cdrzd27570zd2_1806))
																																																	{	/* Eval/evaluate.scm 424 */
																																																		if (NULLP(CDR(BgL_cdrzd27570zd2_1806)))
																																																			{	/* Eval/evaluate.scm 424 */
																																																				if (NULLP(CDR(BgL_cdrzd27557zd2_1798)))
																																																					{	/* Eval/evaluate.scm 424 */
																																																						obj_t
																																																							BgL_arg1784z00_1812;
																																																						obj_t
																																																							BgL_arg1785z00_1813;
																																																						obj_t
																																																							BgL_arg1786z00_1814;
																																																						BgL_arg1784z00_1812
																																																							=
																																																							CAR
																																																							(BgL_cdrzd27552zd2_1794);
																																																						BgL_arg1785z00_1813
																																																							=
																																																							CAR
																																																							(BgL_cdrzd27566zd2_1802);
																																																						BgL_arg1786z00_1814
																																																							=
																																																							CAR
																																																							(BgL_cdrzd27570zd2_1806);
																																																						{
																																																							BgL_ev_defglobalz00_bglt
																																																								BgL_auxz00_6450;
																																																							BgL_gvz00_1508
																																																								=
																																																								BgL_arg1784z00_1812;
																																																							BgL_formalsz00_1509
																																																								=
																																																								BgL_arg1785z00_1813;
																																																							BgL_bodyz00_1510
																																																								=
																																																								BgL_arg1786z00_1814;
																																																						BgL_tagzd2167zd2_1511:
																																																							{	/* Eval/evaluate.scm 554 */
																																																								obj_t
																																																									BgL_tidz00_2580;
																																																								BgL_tidz00_2580
																																																									=
																																																									BGl_untypezd2identzd2zz__evaluatez00
																																																									(BgL_gvz00_1508);
																																																								{	/* Eval/evaluate.scm 555 */
																																																									BgL_ev_defglobalz00_bglt
																																																										BgL_new1144z00_2581;
																																																									{	/* Eval/evaluate.scm 559 */
																																																										BgL_ev_defglobalz00_bglt
																																																											BgL_new1143z00_2584;
																																																										BgL_new1143z00_2584
																																																											=
																																																											(
																																																											(BgL_ev_defglobalz00_bglt)
																																																											BOBJECT
																																																											(GC_MALLOC
																																																												(sizeof
																																																													(struct
																																																														BgL_ev_defglobalz00_bgl))));
																																																										{	/* Eval/evaluate.scm 559 */
																																																											long
																																																												BgL_arg2368z00_2585;
																																																											{	/* Eval/evaluate.scm 559 */
																																																												long
																																																													BgL_res2945z00_3811;
																																																												BgL_res2945z00_3811
																																																													=
																																																													BGL_CLASS_INDEX
																																																													(BGl_ev_defglobalz00zz__evaluate_typesz00);
																																																												BgL_arg2368z00_2585
																																																													=
																																																													BgL_res2945z00_3811;
																																																											}
																																																											BGL_OBJECT_CLASS_NUM_SET
																																																												(
																																																												((BgL_objectz00_bglt) BgL_new1143z00_2584), BgL_arg2368z00_2585);
																																																										}
																																																										BgL_new1144z00_2581
																																																											=
																																																											BgL_new1143z00_2584;
																																																									}
																																																									{
																																																										BgL_ev_exprz00_bglt
																																																											BgL_auxz00_6456;
																																																										{	/* Eval/evaluate.scm 559 */
																																																											obj_t
																																																												BgL_arg2366z00_2582;
																																																											BgL_arg2366z00_2582
																																																												=
																																																												CDR
																																																												(BgL_tidz00_2580);
																																																											BgL_auxz00_6456
																																																												=
																																																												(
																																																												(BgL_ev_exprz00_bglt)
																																																												BGl_convzd2lambdaze70z35zz__evaluatez00
																																																												(BgL_globalsz00_71,
																																																													BgL_localsz00_70,
																																																													BgL_ez00_69,
																																																													BgL_locz00_74,
																																																													BgL_formalsz00_1509,
																																																													BgL_bodyz00_1510,
																																																													BgL_gvz00_1508,
																																																													BgL_arg2366z00_2582));
																																																										}
																																																										((((BgL_ev_hookz00_bglt) COBJECT(((BgL_ev_hookz00_bglt) BgL_new1144z00_2581)))->BgL_ez00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_6456), BUNSPEC);
																																																									}
																																																									((((BgL_ev_setglobalz00_bglt) COBJECT(((BgL_ev_setglobalz00_bglt) BgL_new1144z00_2581)))->BgL_locz00) = ((obj_t) BgL_locz00_74), BUNSPEC);
																																																									((((BgL_ev_setglobalz00_bglt) COBJECT(((BgL_ev_setglobalz00_bglt) BgL_new1144z00_2581)))->BgL_namez00) = ((obj_t) CAR(BgL_tidz00_2580)), BUNSPEC);
																																																									{
																																																										obj_t
																																																											BgL_auxz00_6467;
																																																										if (BGl_evmodulezf3zf3zz__evmodulez00(BgL_globalsz00_71))
																																																											{	/* Eval/evaluate.scm 558 */
																																																												BgL_auxz00_6467
																																																													=
																																																													BgL_globalsz00_71;
																																																											}
																																																										else
																																																											{	/* Eval/evaluate.scm 558 */
																																																												BgL_auxz00_6467
																																																													=
																																																													BGL_MODULE
																																																													();
																																																											}
																																																										((((BgL_ev_setglobalz00_bglt) COBJECT(((BgL_ev_setglobalz00_bglt) BgL_new1144z00_2581)))->BgL_modz00) = ((obj_t) BgL_auxz00_6467), BUNSPEC);
																																																									}
																																																									BgL_auxz00_6450
																																																										=
																																																										BgL_new1144z00_2581;
																																																								}
																																																							}
																																																							return
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_6450);
																																																						}
																																																					}
																																																				else
																																																					{	/* Eval/evaluate.scm 424 */
																																																						obj_t
																																																							BgL_arg1787z00_1815;
																																																						BgL_arg1787z00_1815
																																																							=
																																																							CAR
																																																							(BgL_ez00_69);
																																																						{
																																																							BgL_ev_appz00_bglt
																																																								BgL_auxz00_6475;
																																																							{
																																																								obj_t
																																																									BgL_argsz00_6477;
																																																								obj_t
																																																									BgL_fz00_6476;
																																																								BgL_fz00_6476
																																																									=
																																																									BgL_arg1787z00_1815;
																																																								BgL_argsz00_6477
																																																									=
																																																									BgL_cdrzd27552zd2_1794;
																																																								BgL_argsz00_1535
																																																									=
																																																									BgL_argsz00_6477;
																																																								BgL_fz00_1534
																																																									=
																																																									BgL_fz00_6476;
																																																								goto
																																																									BgL_tagzd2175zd2_1536;
																																																							}
																																																							return
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_6475);
																																																						}
																																																					}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 424 */
																																																				obj_t
																																																					BgL_cdrzd27670zd2_1819;
																																																				BgL_cdrzd27670zd2_1819
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_cdrzd27552zd2_1794));
																																																				if (NULLP(CDR(((obj_t) BgL_cdrzd27670zd2_1819))))
																																																					{	/* Eval/evaluate.scm 424 */
																																																						obj_t
																																																							BgL_arg1794z00_1822;
																																																						obj_t
																																																							BgL_arg1795z00_1823;
																																																						BgL_arg1794z00_1822
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_cdrzd27552zd2_1794));
																																																						BgL_arg1795z00_1823
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_cdrzd27670zd2_1819));
																																																						{
																																																							BgL_ev_defglobalz00_bglt
																																																								BgL_auxz00_6489;
																																																							BgL_gvz00_1512
																																																								=
																																																								BgL_arg1794z00_1822;
																																																							BgL_gez00_1513
																																																								=
																																																								BgL_arg1795z00_1823;
																																																						BgL_tagzd2168zd2_1514:
																																																							{	/* Eval/evaluate.scm 561 */
																																																								obj_t
																																																									BgL_tidz00_2586;
																																																								BgL_tidz00_2586
																																																									=
																																																									BGl_untypezd2identzd2zz__evaluatez00
																																																									(BgL_gvz00_1512);
																																																								{	/* Eval/evaluate.scm 562 */
																																																									BgL_ev_defglobalz00_bglt
																																																										BgL_new1146z00_2587;
																																																									{	/* Eval/evaluate.scm 566 */
																																																										BgL_ev_defglobalz00_bglt
																																																											BgL_new1145z00_2592;
																																																										BgL_new1145z00_2592
																																																											=
																																																											(
																																																											(BgL_ev_defglobalz00_bglt)
																																																											BOBJECT
																																																											(GC_MALLOC
																																																												(sizeof
																																																													(struct
																																																														BgL_ev_defglobalz00_bgl))));
																																																										{	/* Eval/evaluate.scm 566 */
																																																											long
																																																												BgL_arg2373z00_2593;
																																																											{	/* Eval/evaluate.scm 566 */
																																																												long
																																																													BgL_res2946z00_3817;
																																																												BgL_res2946z00_3817
																																																													=
																																																													BGL_CLASS_INDEX
																																																													(BGl_ev_defglobalz00zz__evaluate_typesz00);
																																																												BgL_arg2373z00_2593
																																																													=
																																																													BgL_res2946z00_3817;
																																																											}
																																																											BGL_OBJECT_CLASS_NUM_SET
																																																												(
																																																												((BgL_objectz00_bglt) BgL_new1145z00_2592), BgL_arg2373z00_2593);
																																																										}
																																																										BgL_new1146z00_2587
																																																											=
																																																											BgL_new1145z00_2592;
																																																									}
																																																									{
																																																										BgL_ev_exprz00_bglt
																																																											BgL_auxz00_6495;
																																																										{	/* Eval/evaluate.scm 567 */
																																																											obj_t
																																																												BgL_arg2369z00_2588;
																																																											{	/* Eval/evaluate.scm 567 */
																																																												obj_t
																																																													BgL_arg2371z00_2590;
																																																												BgL_arg2371z00_2590
																																																													=
																																																													CDR
																																																													(BgL_tidz00_2586);
																																																												BgL_arg2369z00_2588
																																																													=
																																																													BGl_typezd2resultzd2zz__evaluatez00
																																																													(BgL_arg2371z00_2590,
																																																													BgL_gez00_1513,
																																																													BgL_locz00_74);
																																																											}
																																																											{	/* Eval/evaluate.scm 383 */
																																																												obj_t
																																																													BgL_arg2397z00_3821;
																																																												{	/* Eval/evaluate.scm 144 */
																																																													obj_t
																																																														BgL__ortest_1068z00_3822;
																																																													BgL__ortest_1068z00_3822
																																																														=
																																																														BGl_getzd2sourcezd2locationz00zz__readerz00
																																																														(BgL_arg2369z00_2588);
																																																													if (CBOOL(BgL__ortest_1068z00_3822))
																																																														{	/* Eval/evaluate.scm 144 */
																																																															BgL_arg2397z00_3821
																																																																=
																																																																BgL__ortest_1068z00_3822;
																																																														}
																																																													else
																																																														{	/* Eval/evaluate.scm 144 */
																																																															BgL_arg2397z00_3821
																																																																=
																																																																BgL_locz00_74;
																																																														}
																																																												}
																																																												{
																																																													obj_t
																																																														BgL_auxz00_6502;
																																																													{	/* Eval/evaluate.scm 374 */
																																																														obj_t
																																																															BgL_auxz00_6503;
																																																														if (BgL_topzf3zf3_75)
																																																															{	/* Eval/evaluate.scm 568 */
																																																																BgL_auxz00_6503
																																																																	=
																																																																	BgL_gvz00_1512;
																																																															}
																																																														else
																																																															{	/* Eval/evaluate.scm 568 */
																																																																BgL_auxz00_6503
																																																																	=
																																																																	BgL_wherez00_73;
																																																															}
																																																														BgL_auxz00_6502
																																																															=
																																																															BGl_convz00zz__evaluatez00
																																																															(BgL_arg2369z00_2588,
																																																															BgL_localsz00_70,
																																																															BgL_globalsz00_71,
																																																															BFALSE,
																																																															BgL_auxz00_6503,
																																																															BgL_arg2397z00_3821,
																																																															((bool_t) 0));
																																																													}
																																																													BgL_auxz00_6495
																																																														=
																																																														(
																																																														(BgL_ev_exprz00_bglt)
																																																														BgL_auxz00_6502);
																																																												}
																																																											}
																																																										}
																																																										((((BgL_ev_hookz00_bglt) COBJECT(((BgL_ev_hookz00_bglt) BgL_new1146z00_2587)))->BgL_ez00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_6495), BUNSPEC);
																																																									}
																																																									((((BgL_ev_setglobalz00_bglt) COBJECT(((BgL_ev_setglobalz00_bglt) BgL_new1146z00_2587)))->BgL_locz00) = ((obj_t) BgL_locz00_74), BUNSPEC);
																																																									((((BgL_ev_setglobalz00_bglt) COBJECT(((BgL_ev_setglobalz00_bglt) BgL_new1146z00_2587)))->BgL_namez00) = ((obj_t) CAR(BgL_tidz00_2586)), BUNSPEC);
																																																									{
																																																										obj_t
																																																											BgL_auxz00_6513;
																																																										if (BGl_evmodulezf3zf3zz__evmodulez00(BgL_globalsz00_71))
																																																											{	/* Eval/evaluate.scm 565 */
																																																												BgL_auxz00_6513
																																																													=
																																																													BgL_globalsz00_71;
																																																											}
																																																										else
																																																											{	/* Eval/evaluate.scm 565 */
																																																												BgL_auxz00_6513
																																																													=
																																																													BGL_MODULE
																																																													();
																																																											}
																																																										((((BgL_ev_setglobalz00_bglt) COBJECT(((BgL_ev_setglobalz00_bglt) BgL_new1146z00_2587)))->BgL_modz00) = ((obj_t) BgL_auxz00_6513), BUNSPEC);
																																																									}
																																																									BgL_auxz00_6489
																																																										=
																																																										BgL_new1146z00_2587;
																																																								}
																																																							}
																																																							return
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_6489);
																																																						}
																																																					}
																																																				else
																																																					{	/* Eval/evaluate.scm 424 */
																																																						obj_t
																																																							BgL_arg1796z00_1824;
																																																						obj_t
																																																							BgL_arg1797z00_1825;
																																																						BgL_arg1796z00_1824
																																																							=
																																																							CAR
																																																							(BgL_ez00_69);
																																																						BgL_arg1797z00_1825
																																																							=
																																																							CDR
																																																							(BgL_ez00_69);
																																																						{
																																																							BgL_ev_appz00_bglt
																																																								BgL_auxz00_6522;
																																																							{
																																																								obj_t
																																																									BgL_argsz00_6524;
																																																								obj_t
																																																									BgL_fz00_6523;
																																																								BgL_fz00_6523
																																																									=
																																																									BgL_arg1796z00_1824;
																																																								BgL_argsz00_6524
																																																									=
																																																									BgL_arg1797z00_1825;
																																																								BgL_argsz00_1535
																																																									=
																																																									BgL_argsz00_6524;
																																																								BgL_fz00_1534
																																																									=
																																																									BgL_fz00_6523;
																																																								goto
																																																									BgL_tagzd2175zd2_1536;
																																																							}
																																																							return
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_6522);
																																																						}
																																																					}
																																																			}
																																																	}
																																																else
																																																	{	/* Eval/evaluate.scm 424 */
																																																		obj_t
																																																			BgL_cdrzd27757zd2_1829;
																																																		BgL_cdrzd27757zd2_1829
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_cdrzd27552zd2_1794));
																																																		if (NULLP(CDR(((obj_t) BgL_cdrzd27757zd2_1829))))
																																																			{	/* Eval/evaluate.scm 424 */
																																																				obj_t
																																																					BgL_arg1802z00_1832;
																																																				obj_t
																																																					BgL_arg1804z00_1833;
																																																				BgL_arg1802z00_1832
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_cdrzd27552zd2_1794));
																																																				BgL_arg1804z00_1833
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_cdrzd27757zd2_1829));
																																																				{
																																																					BgL_ev_defglobalz00_bglt
																																																						BgL_auxz00_6536;
																																																					{
																																																						obj_t
																																																							BgL_gez00_6538;
																																																						obj_t
																																																							BgL_gvz00_6537;
																																																						BgL_gvz00_6537
																																																							=
																																																							BgL_arg1802z00_1832;
																																																						BgL_gez00_6538
																																																							=
																																																							BgL_arg1804z00_1833;
																																																						BgL_gez00_1513
																																																							=
																																																							BgL_gez00_6538;
																																																						BgL_gvz00_1512
																																																							=
																																																							BgL_gvz00_6537;
																																																						goto
																																																							BgL_tagzd2168zd2_1514;
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_6536);
																																																				}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 424 */
																																																				obj_t
																																																					BgL_arg1805z00_1834;
																																																				obj_t
																																																					BgL_arg1806z00_1835;
																																																				BgL_arg1805z00_1834
																																																					=
																																																					CAR
																																																					(BgL_ez00_69);
																																																				BgL_arg1806z00_1835
																																																					=
																																																					CDR
																																																					(BgL_ez00_69);
																																																				{
																																																					BgL_ev_appz00_bglt
																																																						BgL_auxz00_6542;
																																																					{
																																																						obj_t
																																																							BgL_argsz00_6544;
																																																						obj_t
																																																							BgL_fz00_6543;
																																																						BgL_fz00_6543
																																																							=
																																																							BgL_arg1805z00_1834;
																																																						BgL_argsz00_6544
																																																							=
																																																							BgL_arg1806z00_1835;
																																																						BgL_argsz00_1535
																																																							=
																																																							BgL_argsz00_6544;
																																																						BgL_fz00_1534
																																																							=
																																																							BgL_fz00_6543;
																																																						goto
																																																							BgL_tagzd2175zd2_1536;
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_6542);
																																																				}
																																																			}
																																																	}
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 424 */
																																																obj_t
																																																	BgL_cdrzd27844zd2_1838;
																																																BgL_cdrzd27844zd2_1838
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_cdrzd27552zd2_1794));
																																																if (NULLP(CDR(((obj_t) BgL_cdrzd27844zd2_1838))))
																																																	{	/* Eval/evaluate.scm 424 */
																																																		obj_t
																																																			BgL_arg1811z00_1841;
																																																		obj_t
																																																			BgL_arg1812z00_1842;
																																																		BgL_arg1811z00_1841
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_cdrzd27552zd2_1794));
																																																		BgL_arg1812z00_1842
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_cdrzd27844zd2_1838));
																																																		{
																																																			BgL_ev_defglobalz00_bglt
																																																				BgL_auxz00_6556;
																																																			{
																																																				obj_t
																																																					BgL_gez00_6558;
																																																				obj_t
																																																					BgL_gvz00_6557;
																																																				BgL_gvz00_6557
																																																					=
																																																					BgL_arg1811z00_1841;
																																																				BgL_gez00_6558
																																																					=
																																																					BgL_arg1812z00_1842;
																																																				BgL_gez00_1513
																																																					=
																																																					BgL_gez00_6558;
																																																				BgL_gvz00_1512
																																																					=
																																																					BgL_gvz00_6557;
																																																				goto
																																																					BgL_tagzd2168zd2_1514;
																																																			}
																																																			return
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_6556);
																																																		}
																																																	}
																																																else
																																																	{	/* Eval/evaluate.scm 424 */
																																																		obj_t
																																																			BgL_arg1813z00_1843;
																																																		obj_t
																																																			BgL_arg1814z00_1844;
																																																		BgL_arg1813z00_1843
																																																			=
																																																			CAR
																																																			(BgL_ez00_69);
																																																		BgL_arg1814z00_1844
																																																			=
																																																			CDR
																																																			(BgL_ez00_69);
																																																		{
																																																			BgL_ev_appz00_bglt
																																																				BgL_auxz00_6562;
																																																			{
																																																				obj_t
																																																					BgL_argsz00_6564;
																																																				obj_t
																																																					BgL_fz00_6563;
																																																				BgL_fz00_6563
																																																					=
																																																					BgL_arg1813z00_1843;
																																																				BgL_argsz00_6564
																																																					=
																																																					BgL_arg1814z00_1844;
																																																				BgL_argsz00_1535
																																																					=
																																																					BgL_argsz00_6564;
																																																				BgL_fz00_1534
																																																					=
																																																					BgL_fz00_6563;
																																																				goto
																																																					BgL_tagzd2175zd2_1536;
																																																			}
																																																			return
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_6562);
																																																		}
																																																	}
																																															}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 424 */
																																														obj_t
																																															BgL_cdrzd27931zd2_1847;
																																														BgL_cdrzd27931zd2_1847
																																															=
																																															CDR
																																															(
																																															((obj_t) BgL_cdrzd27552zd2_1794));
																																														if (NULLP(CDR(((obj_t) BgL_cdrzd27931zd2_1847))))
																																															{	/* Eval/evaluate.scm 424 */
																																																obj_t
																																																	BgL_arg1819z00_1850;
																																																obj_t
																																																	BgL_arg1821z00_1851;
																																																BgL_arg1819z00_1850
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_cdrzd27552zd2_1794));
																																																BgL_arg1821z00_1851
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_cdrzd27931zd2_1847));
																																																{
																																																	BgL_ev_defglobalz00_bglt
																																																		BgL_auxz00_6576;
																																																	{
																																																		obj_t
																																																			BgL_gez00_6578;
																																																		obj_t
																																																			BgL_gvz00_6577;
																																																		BgL_gvz00_6577
																																																			=
																																																			BgL_arg1819z00_1850;
																																																		BgL_gez00_6578
																																																			=
																																																			BgL_arg1821z00_1851;
																																																		BgL_gez00_1513
																																																			=
																																																			BgL_gez00_6578;
																																																		BgL_gvz00_1512
																																																			=
																																																			BgL_gvz00_6577;
																																																		goto
																																																			BgL_tagzd2168zd2_1514;
																																																	}
																																																	return
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_6576);
																																																}
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 424 */
																																																obj_t
																																																	BgL_arg1822z00_1852;
																																																obj_t
																																																	BgL_arg1823z00_1853;
																																																BgL_arg1822z00_1852
																																																	=
																																																	CAR
																																																	(BgL_ez00_69);
																																																BgL_arg1823z00_1853
																																																	=
																																																	CDR
																																																	(BgL_ez00_69);
																																																{
																																																	BgL_ev_appz00_bglt
																																																		BgL_auxz00_6582;
																																																	{
																																																		obj_t
																																																			BgL_argsz00_6584;
																																																		obj_t
																																																			BgL_fz00_6583;
																																																		BgL_fz00_6583
																																																			=
																																																			BgL_arg1822z00_1852;
																																																		BgL_argsz00_6584
																																																			=
																																																			BgL_arg1823z00_1853;
																																																		BgL_argsz00_1535
																																																			=
																																																			BgL_argsz00_6584;
																																																		BgL_fz00_1534
																																																			=
																																																			BgL_fz00_6583;
																																																		goto
																																																			BgL_tagzd2175zd2_1536;
																																																	}
																																																	return
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_6582);
																																																}
																																															}
																																													}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 424 */
																																												obj_t
																																													BgL_cdrzd28018zd2_1857;
																																												BgL_cdrzd28018zd2_1857
																																													=
																																													CDR
																																													(
																																													((obj_t) BgL_cdrzd27552zd2_1794));
																																												if (NULLP(CDR(((obj_t) BgL_cdrzd28018zd2_1857))))
																																													{	/* Eval/evaluate.scm 424 */
																																														obj_t
																																															BgL_arg1829z00_1860;
																																														obj_t
																																															BgL_arg1830z00_1861;
																																														BgL_arg1829z00_1860
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_cdrzd27552zd2_1794));
																																														BgL_arg1830z00_1861
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_cdrzd28018zd2_1857));
																																														{
																																															BgL_ev_defglobalz00_bglt
																																																BgL_auxz00_6596;
																																															{
																																																obj_t
																																																	BgL_gez00_6598;
																																																obj_t
																																																	BgL_gvz00_6597;
																																																BgL_gvz00_6597
																																																	=
																																																	BgL_arg1829z00_1860;
																																																BgL_gez00_6598
																																																	=
																																																	BgL_arg1830z00_1861;
																																																BgL_gez00_1513
																																																	=
																																																	BgL_gez00_6598;
																																																BgL_gvz00_1512
																																																	=
																																																	BgL_gvz00_6597;
																																																goto
																																																	BgL_tagzd2168zd2_1514;
																																															}
																																															return
																																																(
																																																(obj_t)
																																																BgL_auxz00_6596);
																																														}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 424 */
																																														obj_t
																																															BgL_arg1832z00_1862;
																																														obj_t
																																															BgL_arg1833z00_1863;
																																														BgL_arg1832z00_1862
																																															=
																																															CAR
																																															(BgL_ez00_69);
																																														BgL_arg1833z00_1863
																																															=
																																															CDR
																																															(BgL_ez00_69);
																																														{
																																															BgL_ev_appz00_bglt
																																																BgL_auxz00_6602;
																																															{
																																																obj_t
																																																	BgL_argsz00_6604;
																																																obj_t
																																																	BgL_fz00_6603;
																																																BgL_fz00_6603
																																																	=
																																																	BgL_arg1832z00_1862;
																																																BgL_argsz00_6604
																																																	=
																																																	BgL_arg1833z00_1863;
																																																BgL_argsz00_1535
																																																	=
																																																	BgL_argsz00_6604;
																																																BgL_fz00_1534
																																																	=
																																																	BgL_fz00_6603;
																																																goto
																																																	BgL_tagzd2175zd2_1536;
																																															}
																																															return
																																																(
																																																(obj_t)
																																																BgL_auxz00_6602);
																																														}
																																													}
																																											}
																																									}
																																								else
																																									{	/* Eval/evaluate.scm 424 */
																																										obj_t
																																											BgL_arg1835z00_1865;
																																										BgL_arg1835z00_1865
																																											=
																																											CAR
																																											(BgL_ez00_69);
																																										{
																																											BgL_ev_appz00_bglt
																																												BgL_auxz00_6607;
																																											{
																																												obj_t
																																													BgL_argsz00_6609;
																																												obj_t
																																													BgL_fz00_6608;
																																												BgL_fz00_6608
																																													=
																																													BgL_arg1835z00_1865;
																																												BgL_argsz00_6609
																																													=
																																													BgL_cdrzd27552zd2_1794;
																																												BgL_argsz00_1535
																																													=
																																													BgL_argsz00_6609;
																																												BgL_fz00_1534
																																													=
																																													BgL_fz00_6608;
																																												goto
																																													BgL_tagzd2175zd2_1536;
																																											}
																																											return
																																												(
																																												(obj_t)
																																												BgL_auxz00_6607);
																																										}
																																									}
																																							}
																																						else
																																							{	/* Eval/evaluate.scm 424 */
																																								obj_t
																																									BgL_arg1837z00_1867;
																																								BgL_arg1837z00_1867
																																									=
																																									CAR
																																									(BgL_ez00_69);
																																								{
																																									BgL_ev_appz00_bglt
																																										BgL_auxz00_6612;
																																									{
																																										obj_t
																																											BgL_argsz00_6614;
																																										obj_t
																																											BgL_fz00_6613;
																																										BgL_fz00_6613
																																											=
																																											BgL_arg1837z00_1867;
																																										BgL_argsz00_6614
																																											=
																																											BgL_cdrzd27552zd2_1794;
																																										BgL_argsz00_1535
																																											=
																																											BgL_argsz00_6614;
																																										BgL_fz00_1534
																																											=
																																											BgL_fz00_6613;
																																										goto
																																											BgL_tagzd2175zd2_1536;
																																									}
																																									return
																																										(
																																										(obj_t)
																																										BgL_auxz00_6612);
																																								}
																																							}
																																					}
																																				else
																																					{	/* Eval/evaluate.scm 424 */
																																						if (
																																							(CAR
																																								(BgL_ez00_69)
																																								==
																																								BGl_symbol3279z00zz__evaluatez00))
																																							{	/* Eval/evaluate.scm 424 */
																																								if (PAIRP(BgL_cdrzd27552zd2_1794))
																																									{	/* Eval/evaluate.scm 424 */
																																										obj_t
																																											BgL_carzd28260zd2_1873;
																																										BgL_carzd28260zd2_1873
																																											=
																																											CAR
																																											(BgL_cdrzd27552zd2_1794);
																																										if (PAIRP(BgL_carzd28260zd2_1873))
																																											{	/* Eval/evaluate.scm 424 */
																																												if (NULLP(CDR(BgL_carzd28260zd2_1873)))
																																													{	/* Eval/evaluate.scm 424 */
																																														obj_t
																																															BgL_arg1849z00_1877;
																																														obj_t
																																															BgL_arg1850z00_1878;
																																														BgL_arg1849z00_1877
																																															=
																																															CAR
																																															(BgL_carzd28260zd2_1873);
																																														BgL_arg1850z00_1878
																																															=
																																															CDR
																																															(BgL_cdrzd27552zd2_1794);
																																														{
																																															BgL_ev_bindzd2exitzd2_bglt
																																																BgL_auxz00_6629;
																																															BgL_vz00_1515
																																																=
																																																BgL_arg1849z00_1877;
																																															BgL_bodyz00_1516
																																																=
																																																BgL_arg1850z00_1878;
																																														BgL_tagzd2169zd2_1517:
																																															{	/* Eval/evaluate.scm 570 */
																																																BgL_ev_varz00_bglt
																																																	BgL_varz00_2594;
																																																{	/* Eval/evaluate.scm 570 */
																																																	BgL_ev_varz00_bglt
																																																		BgL_new1148z00_2599;
																																																	{	/* Eval/evaluate.scm 570 */
																																																		BgL_ev_varz00_bglt
																																																			BgL_new1147z00_2600;
																																																		BgL_new1147z00_2600
																																																			=
																																																			(
																																																			(BgL_ev_varz00_bglt)
																																																			BOBJECT
																																																			(GC_MALLOC
																																																				(sizeof
																																																					(struct
																																																						BgL_ev_varz00_bgl))));
																																																		{	/* Eval/evaluate.scm 570 */
																																																			long
																																																				BgL_arg2376z00_2601;
																																																			{	/* Eval/evaluate.scm 570 */
																																																				long
																																																					BgL_res2947z00_3825;
																																																				BgL_res2947z00_3825
																																																					=
																																																					BGL_CLASS_INDEX
																																																					(BGl_ev_varz00zz__evaluate_typesz00);
																																																				BgL_arg2376z00_2601
																																																					=
																																																					BgL_res2947z00_3825;
																																																			}
																																																			BGL_OBJECT_CLASS_NUM_SET
																																																				(
																																																				((BgL_objectz00_bglt) BgL_new1147z00_2600), BgL_arg2376z00_2601);
																																																		}
																																																		BgL_new1148z00_2599
																																																			=
																																																			BgL_new1147z00_2600;
																																																	}
																																																	((((BgL_ev_varz00_bglt) COBJECT(BgL_new1148z00_2599))->BgL_namez00) = ((obj_t) BgL_vz00_1515), BUNSPEC);
																																																	((((BgL_ev_varz00_bglt) COBJECT(BgL_new1148z00_2599))->BgL_effz00) = ((obj_t) BFALSE), BUNSPEC);
																																																	((((BgL_ev_varz00_bglt) COBJECT(BgL_new1148z00_2599))->BgL_typez00) = ((obj_t) BFALSE), BUNSPEC);
																																																	BgL_varz00_2594
																																																		=
																																																		BgL_new1148z00_2599;
																																																}
																																																{	/* Eval/evaluate.scm 571 */
																																																	BgL_ev_bindzd2exitzd2_bglt
																																																		BgL_new1150z00_2595;
																																																	{	/* Eval/evaluate.scm 572 */
																																																		BgL_ev_bindzd2exitzd2_bglt
																																																			BgL_new1149z00_2597;
																																																		BgL_new1149z00_2597
																																																			=
																																																			(
																																																			(BgL_ev_bindzd2exitzd2_bglt)
																																																			BOBJECT
																																																			(GC_MALLOC
																																																				(sizeof
																																																					(struct
																																																						BgL_ev_bindzd2exitzd2_bgl))));
																																																		{	/* Eval/evaluate.scm 572 */
																																																			long
																																																				BgL_arg2375z00_2598;
																																																			{	/* Eval/evaluate.scm 572 */
																																																				long
																																																					BgL_res2948z00_3829;
																																																				BgL_res2948z00_3829
																																																					=
																																																					BGL_CLASS_INDEX
																																																					(BGl_ev_bindzd2exitzd2zz__evaluate_typesz00);
																																																				BgL_arg2375z00_2598
																																																					=
																																																					BgL_res2948z00_3829;
																																																			}
																																																			BGL_OBJECT_CLASS_NUM_SET
																																																				(
																																																				((BgL_objectz00_bglt) BgL_new1149z00_2597), BgL_arg2375z00_2598);
																																																		}
																																																		BgL_new1150z00_2595
																																																			=
																																																			BgL_new1149z00_2597;
																																																	}
																																																	((((BgL_ev_bindzd2exitzd2_bglt) COBJECT(BgL_new1150z00_2595))->BgL_varz00) = ((BgL_ev_varz00_bglt) BgL_varz00_2594), BUNSPEC);
																																																	{
																																																		BgL_ev_exprz00_bglt
																																																			BgL_auxz00_6642;
																																																		{	/* Eval/evaluate.scm 573 */
																																																			obj_t
																																																				BgL_arg2374z00_2596;
																																																			BgL_arg2374z00_2596
																																																				=
																																																				MAKE_YOUNG_PAIR
																																																				(
																																																				((obj_t) BgL_varz00_2594), BgL_localsz00_70);
																																																			BgL_auxz00_6642
																																																				=
																																																				(
																																																				(BgL_ev_exprz00_bglt)
																																																				BGl_convzd2beginzd2zz__evaluatez00
																																																				(BgL_bodyz00_1516,
																																																					BgL_arg2374z00_2596,
																																																					BgL_globalsz00_71,
																																																					BFALSE,
																																																					BgL_wherez00_73,
																																																					BgL_locz00_74,
																																																					((bool_t) 0)));
																																																		}
																																																		((((BgL_ev_bindzd2exitzd2_bglt) COBJECT(BgL_new1150z00_2595))->BgL_bodyz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_6642), BUNSPEC);
																																																	}
																																																	BgL_auxz00_6629
																																																		=
																																																		BgL_new1150z00_2595;
																																															}}
																																															return
																																																(
																																																(obj_t)
																																																BgL_auxz00_6629);
																																														}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 424 */
																																														obj_t
																																															BgL_arg1851z00_1879;
																																														obj_t
																																															BgL_arg1852z00_1880;
																																														BgL_arg1851z00_1879
																																															=
																																															CAR
																																															(BgL_ez00_69);
																																														BgL_arg1852z00_1880
																																															=
																																															CDR
																																															(BgL_ez00_69);
																																														{
																																															BgL_ev_appz00_bglt
																																																BgL_auxz00_6651;
																																															{
																																																obj_t
																																																	BgL_argsz00_6653;
																																																obj_t
																																																	BgL_fz00_6652;
																																																BgL_fz00_6652
																																																	=
																																																	BgL_arg1851z00_1879;
																																																BgL_argsz00_6653
																																																	=
																																																	BgL_arg1852z00_1880;
																																																BgL_argsz00_1535
																																																	=
																																																	BgL_argsz00_6653;
																																																BgL_fz00_1534
																																																	=
																																																	BgL_fz00_6652;
																																																goto
																																																	BgL_tagzd2175zd2_1536;
																																															}
																																															return
																																																(
																																																(obj_t)
																																																BgL_auxz00_6651);
																																														}
																																													}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 424 */
																																												obj_t
																																													BgL_arg1854z00_1882;
																																												obj_t
																																													BgL_arg1855z00_1883;
																																												BgL_arg1854z00_1882
																																													=
																																													CAR
																																													(BgL_ez00_69);
																																												BgL_arg1855z00_1883
																																													=
																																													CDR
																																													(BgL_ez00_69);
																																												{
																																													BgL_ev_appz00_bglt
																																														BgL_auxz00_6657;
																																													{
																																														obj_t
																																															BgL_argsz00_6659;
																																														obj_t
																																															BgL_fz00_6658;
																																														BgL_fz00_6658
																																															=
																																															BgL_arg1854z00_1882;
																																														BgL_argsz00_6659
																																															=
																																															BgL_arg1855z00_1883;
																																														BgL_argsz00_1535
																																															=
																																															BgL_argsz00_6659;
																																														BgL_fz00_1534
																																															=
																																															BgL_fz00_6658;
																																														goto
																																															BgL_tagzd2175zd2_1536;
																																													}
																																													return
																																														(
																																														(obj_t)
																																														BgL_auxz00_6657);
																																												}
																																											}
																																									}
																																								else
																																									{	/* Eval/evaluate.scm 424 */
																																										obj_t
																																											BgL_arg1856z00_1884;
																																										obj_t
																																											BgL_arg1857z00_1885;
																																										BgL_arg1856z00_1884
																																											=
																																											CAR
																																											(BgL_ez00_69);
																																										BgL_arg1857z00_1885
																																											=
																																											CDR
																																											(BgL_ez00_69);
																																										{
																																											BgL_ev_appz00_bglt
																																												BgL_auxz00_6663;
																																											{
																																												obj_t
																																													BgL_argsz00_6665;
																																												obj_t
																																													BgL_fz00_6664;
																																												BgL_fz00_6664
																																													=
																																													BgL_arg1856z00_1884;
																																												BgL_argsz00_6665
																																													=
																																													BgL_arg1857z00_1885;
																																												BgL_argsz00_1535
																																													=
																																													BgL_argsz00_6665;
																																												BgL_fz00_1534
																																													=
																																													BgL_fz00_6664;
																																												goto
																																													BgL_tagzd2175zd2_1536;
																																											}
																																											return
																																												(
																																												(obj_t)
																																												BgL_auxz00_6663);
																																										}
																																									}
																																							}
																																						else
																																							{	/* Eval/evaluate.scm 424 */
																																								obj_t
																																									BgL_cdrzd28425zd2_1886;
																																								BgL_cdrzd28425zd2_1886
																																									=
																																									CDR
																																									(BgL_ez00_69);
																																								if ((CAR(BgL_ez00_69) == BGl_symbol3281z00zz__evaluatez00))
																																									{	/* Eval/evaluate.scm 424 */
																																										if (PAIRP(BgL_cdrzd28425zd2_1886))
																																											{	/* Eval/evaluate.scm 424 */
																																												obj_t
																																													BgL_arg1861z00_1890;
																																												obj_t
																																													BgL_arg1863z00_1891;
																																												BgL_arg1861z00_1890
																																													=
																																													CAR
																																													(BgL_cdrzd28425zd2_1886);
																																												BgL_arg1863z00_1891
																																													=
																																													CDR
																																													(BgL_cdrzd28425zd2_1886);
																																												{	/* Eval/evaluate.scm 575 */
																																													BgL_ev_unwindzd2protectzd2_bglt
																																														BgL_new1152z00_4222;
																																													{	/* Eval/evaluate.scm 576 */
																																														BgL_ev_unwindzd2protectzd2_bglt
																																															BgL_new1151z00_4223;
																																														BgL_new1151z00_4223
																																															=
																																															(
																																															(BgL_ev_unwindzd2protectzd2_bglt)
																																															BOBJECT
																																															(GC_MALLOC
																																																(sizeof
																																																	(struct
																																																		BgL_ev_unwindzd2protectzd2_bgl))));
																																														{	/* Eval/evaluate.scm 576 */
																																															long
																																																BgL_arg2378z00_4224;
																																															{	/* Eval/evaluate.scm 576 */
																																																long
																																																	BgL_res3028z00_4226;
																																																BgL_res3028z00_4226
																																																	=
																																																	BGL_CLASS_INDEX
																																																	(BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00);
																																																BgL_arg2378z00_4224
																																																	=
																																																	BgL_res3028z00_4226;
																																															}
																																															BGL_OBJECT_CLASS_NUM_SET
																																																(
																																																((BgL_objectz00_bglt) BgL_new1151z00_4223), BgL_arg2378z00_4224);
																																														}
																																														BgL_new1152z00_4222
																																															=
																																															BgL_new1151z00_4223;
																																													}
																																													{
																																														BgL_ev_exprz00_bglt
																																															BgL_auxz00_6679;
																																														{	/* Eval/evaluate.scm 380 */
																																															obj_t
																																																BgL_arg2395z00_4229;
																																															BgL_arg2395z00_4229
																																																=
																																																BGl_getzd2locationzd2zz__evaluatez00
																																																(BgL_arg1861z00_1890,
																																																BgL_locz00_74);
																																															BgL_auxz00_6679
																																																=
																																																(
																																																(BgL_ev_exprz00_bglt)
																																																BGl_uconvzf2locze70z15zz__evaluatez00
																																																(BgL_wherez00_73,
																																																	BgL_globalsz00_71,
																																																	BgL_localsz00_70,
																																																	BgL_arg1861z00_1890,
																																																	BgL_arg2395z00_4229));
																																														}
																																														((((BgL_ev_unwindzd2protectzd2_bglt) COBJECT(BgL_new1152z00_4222))->BgL_ez00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_6679), BUNSPEC);
																																													}
																																													((((BgL_ev_unwindzd2protectzd2_bglt) COBJECT(BgL_new1152z00_4222))->BgL_bodyz00) = ((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BGl_convzd2beginzd2zz__evaluatez00(BgL_arg1863z00_1891, BgL_localsz00_70, BgL_globalsz00_71, BFALSE, BgL_wherez00_73, BgL_locz00_74, ((bool_t) 0)))), BUNSPEC);
																																													return
																																														(
																																														(obj_t)
																																														BgL_new1152z00_4222);
																																												}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 424 */
																																												obj_t
																																													BgL_arg1864z00_1892;
																																												BgL_arg1864z00_1892
																																													=
																																													CAR
																																													(BgL_ez00_69);
																																												{
																																													BgL_ev_appz00_bglt
																																														BgL_auxz00_6689;
																																													{
																																														obj_t
																																															BgL_argsz00_6691;
																																														obj_t
																																															BgL_fz00_6690;
																																														BgL_fz00_6690
																																															=
																																															BgL_arg1864z00_1892;
																																														BgL_argsz00_6691
																																															=
																																															BgL_cdrzd28425zd2_1886;
																																														BgL_argsz00_1535
																																															=
																																															BgL_argsz00_6691;
																																														BgL_fz00_1534
																																															=
																																															BgL_fz00_6690;
																																														goto
																																															BgL_tagzd2175zd2_1536;
																																													}
																																													return
																																														(
																																														(obj_t)
																																														BgL_auxz00_6689);
																																												}
																																											}
																																									}
																																								else
																																									{	/* Eval/evaluate.scm 424 */
																																										if ((CAR(BgL_ez00_69) == BGl_symbol3283z00zz__evaluatez00))
																																											{	/* Eval/evaluate.scm 424 */
																																												if (PAIRP(BgL_cdrzd28425zd2_1886))
																																													{	/* Eval/evaluate.scm 424 */
																																														obj_t
																																															BgL_arg1870z00_1898;
																																														obj_t
																																															BgL_arg1871z00_1899;
																																														BgL_arg1870z00_1898
																																															=
																																															CAR
																																															(BgL_cdrzd28425zd2_1886);
																																														BgL_arg1871z00_1899
																																															=
																																															CDR
																																															(BgL_cdrzd28425zd2_1886);
																																														{	/* Eval/evaluate.scm 579 */
																																															BgL_ev_withzd2handlerzd2_bglt
																																																BgL_new1154z00_4237;
																																															{	/* Eval/evaluate.scm 580 */
																																																BgL_ev_withzd2handlerzd2_bglt
																																																	BgL_new1153z00_4238;
																																																BgL_new1153z00_4238
																																																	=
																																																	(
																																																	(BgL_ev_withzd2handlerzd2_bglt)
																																																	BOBJECT
																																																	(GC_MALLOC
																																																		(sizeof
																																																			(struct
																																																				BgL_ev_withzd2handlerzd2_bgl))));
																																																{	/* Eval/evaluate.scm 580 */
																																																	long
																																																		BgL_arg2379z00_4239;
																																																	{	/* Eval/evaluate.scm 580 */
																																																		long
																																																			BgL_res3030z00_4241;
																																																		BgL_res3030z00_4241
																																																			=
																																																			BGL_CLASS_INDEX
																																																			(BGl_ev_withzd2handlerzd2zz__evaluate_typesz00);
																																																		BgL_arg2379z00_4239
																																																			=
																																																			BgL_res3030z00_4241;
																																																	}
																																																	BGL_OBJECT_CLASS_NUM_SET
																																																		(
																																																		((BgL_objectz00_bglt) BgL_new1153z00_4238), BgL_arg2379z00_4239);
																																																}
																																																BgL_new1154z00_4237
																																																	=
																																																	BgL_new1153z00_4238;
																																															}
																																															{
																																																BgL_ev_exprz00_bglt
																																																	BgL_auxz00_6704;
																																																{	/* Eval/evaluate.scm 380 */
																																																	obj_t
																																																		BgL_arg2395z00_4244;
																																																	BgL_arg2395z00_4244
																																																		=
																																																		BGl_getzd2locationzd2zz__evaluatez00
																																																		(BgL_arg1870z00_1898,
																																																		BgL_locz00_74);
																																																	BgL_auxz00_6704
																																																		=
																																																		(
																																																		(BgL_ev_exprz00_bglt)
																																																		BGl_uconvzf2locze70z15zz__evaluatez00
																																																		(BgL_wherez00_73,
																																																			BgL_globalsz00_71,
																																																			BgL_localsz00_70,
																																																			BgL_arg1870z00_1898,
																																																			BgL_arg2395z00_4244));
																																																}
																																																((((BgL_ev_withzd2handlerzd2_bglt) COBJECT(BgL_new1154z00_4237))->BgL_handlerz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_6704), BUNSPEC);
																																															}
																																															((((BgL_ev_withzd2handlerzd2_bglt) COBJECT(BgL_new1154z00_4237))->BgL_bodyz00) = ((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BGl_convzd2beginzd2zz__evaluatez00(BgL_arg1871z00_1899, BgL_localsz00_70, BgL_globalsz00_71, BFALSE, BgL_wherez00_73, BgL_locz00_74, ((bool_t) 0)))), BUNSPEC);
																																															return
																																																(
																																																(obj_t)
																																																BgL_new1154z00_4237);
																																														}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 424 */
																																														obj_t
																																															BgL_arg1872z00_1900;
																																														obj_t
																																															BgL_arg1873z00_1901;
																																														BgL_arg1872z00_1900
																																															=
																																															CAR
																																															(BgL_ez00_69);
																																														BgL_arg1873z00_1901
																																															=
																																															CDR
																																															(BgL_ez00_69);
																																														{
																																															BgL_ev_appz00_bglt
																																																BgL_auxz00_6715;
																																															{
																																																obj_t
																																																	BgL_argsz00_6717;
																																																obj_t
																																																	BgL_fz00_6716;
																																																BgL_fz00_6716
																																																	=
																																																	BgL_arg1872z00_1900;
																																																BgL_argsz00_6717
																																																	=
																																																	BgL_arg1873z00_1901;
																																																BgL_argsz00_1535
																																																	=
																																																	BgL_argsz00_6717;
																																																BgL_fz00_1534
																																																	=
																																																	BgL_fz00_6716;
																																																goto
																																																	BgL_tagzd2175zd2_1536;
																																															}
																																															return
																																																(
																																																(obj_t)
																																																BgL_auxz00_6715);
																																														}
																																													}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 424 */
																																												obj_t
																																													BgL_cdrzd28528zd2_1902;
																																												BgL_cdrzd28528zd2_1902
																																													=
																																													CDR
																																													(BgL_ez00_69);
																																												if ((CAR(BgL_ez00_69) == BGl_symbol3285z00zz__evaluatez00))
																																													{	/* Eval/evaluate.scm 424 */
																																														if (PAIRP(BgL_cdrzd28528zd2_1902))
																																															{	/* Eval/evaluate.scm 424 */
																																																obj_t
																																																	BgL_cdrzd28533zd2_1906;
																																																BgL_cdrzd28533zd2_1906
																																																	=
																																																	CDR
																																																	(BgL_cdrzd28528zd2_1902);
																																																if (PAIRP(BgL_cdrzd28533zd2_1906))
																																																	{	/* Eval/evaluate.scm 424 */
																																																		obj_t
																																																			BgL_cdrzd28538zd2_1908;
																																																		BgL_cdrzd28538zd2_1908
																																																			=
																																																			CDR
																																																			(BgL_cdrzd28533zd2_1906);
																																																		if ((CAR(BgL_cdrzd28533zd2_1906) == BGl_keyword3287z00zz__evaluatez00))
																																																			{	/* Eval/evaluate.scm 424 */
																																																				if (PAIRP(BgL_cdrzd28538zd2_1908))
																																																					{	/* Eval/evaluate.scm 424 */
																																																						obj_t
																																																							BgL_arg1881z00_1912;
																																																						obj_t
																																																							BgL_arg1882z00_1913;
																																																						obj_t
																																																							BgL_arg1884z00_1914;
																																																						BgL_arg1881z00_1912
																																																							=
																																																							CAR
																																																							(BgL_cdrzd28528zd2_1902);
																																																						BgL_arg1882z00_1913
																																																							=
																																																							CAR
																																																							(BgL_cdrzd28538zd2_1908);
																																																						BgL_arg1884z00_1914
																																																							=
																																																							CDR
																																																							(BgL_cdrzd28538zd2_1908);
																																																						{	/* Eval/evaluate.scm 583 */
																																																							BgL_ev_synchroniza7eza7_bglt
																																																								BgL_new1157z00_4258;
																																																							{	/* Eval/evaluate.scm 584 */
																																																								BgL_ev_synchroniza7eza7_bglt
																																																									BgL_new1156z00_4259;
																																																								BgL_new1156z00_4259
																																																									=
																																																									(
																																																									(BgL_ev_synchroniza7eza7_bglt)
																																																									BOBJECT
																																																									(GC_MALLOC
																																																										(sizeof
																																																											(struct
																																																												BgL_ev_synchroniza7eza7_bgl))));
																																																								{	/* Eval/evaluate.scm 584 */
																																																									long
																																																										BgL_arg2381z00_4260;
																																																									{	/* Eval/evaluate.scm 584 */
																																																										long
																																																											BgL_res3034z00_4262;
																																																										BgL_res3034z00_4262
																																																											=
																																																											BGL_CLASS_INDEX
																																																											(BGl_ev_synchroniza7eza7zz__evaluate_typesz00);
																																																										BgL_arg2381z00_4260
																																																											=
																																																											BgL_res3034z00_4262;
																																																									}
																																																									BGL_OBJECT_CLASS_NUM_SET
																																																										(
																																																										((BgL_objectz00_bglt) BgL_new1156z00_4259), BgL_arg2381z00_4260);
																																																								}
																																																								BgL_new1157z00_4258
																																																									=
																																																									BgL_new1156z00_4259;
																																																							}
																																																							((((BgL_ev_synchroniza7eza7_bglt) COBJECT(BgL_new1157z00_4258))->BgL_locz00) = ((obj_t) BgL_locz00_74), BUNSPEC);
																																																							{
																																																								BgL_ev_exprz00_bglt
																																																									BgL_auxz00_6742;
																																																								{	/* Eval/evaluate.scm 380 */
																																																									obj_t
																																																										BgL_arg2395z00_4265;
																																																									BgL_arg2395z00_4265
																																																										=
																																																										BGl_getzd2locationzd2zz__evaluatez00
																																																										(BgL_arg1881z00_1912,
																																																										BgL_locz00_74);
																																																									BgL_auxz00_6742
																																																										=
																																																										(
																																																										(BgL_ev_exprz00_bglt)
																																																										BGl_uconvzf2locze70z15zz__evaluatez00
																																																										(BgL_wherez00_73,
																																																											BgL_globalsz00_71,
																																																											BgL_localsz00_70,
																																																											BgL_arg1881z00_1912,
																																																											BgL_arg2395z00_4265));
																																																								}
																																																								((((BgL_ev_synchroniza7eza7_bglt) COBJECT(BgL_new1157z00_4258))->BgL_mutexz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_6742), BUNSPEC);
																																																							}
																																																							{
																																																								BgL_ev_exprz00_bglt
																																																									BgL_auxz00_6747;
																																																								{	/* Eval/evaluate.scm 380 */
																																																									obj_t
																																																										BgL_arg2395z00_4266;
																																																									BgL_arg2395z00_4266
																																																										=
																																																										BGl_getzd2locationzd2zz__evaluatez00
																																																										(BgL_arg1882z00_1913,
																																																										BgL_locz00_74);
																																																									BgL_auxz00_6747
																																																										=
																																																										(
																																																										(BgL_ev_exprz00_bglt)
																																																										BGl_uconvzf2locze70z15zz__evaluatez00
																																																										(BgL_wherez00_73,
																																																											BgL_globalsz00_71,
																																																											BgL_localsz00_70,
																																																											BgL_arg1882z00_1913,
																																																											BgL_arg2395z00_4266));
																																																								}
																																																								((((BgL_ev_synchroniza7eza7_bglt) COBJECT(BgL_new1157z00_4258))->BgL_prelockz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_6747), BUNSPEC);
																																																							}
																																																							((((BgL_ev_synchroniza7eza7_bglt) COBJECT(BgL_new1157z00_4258))->BgL_bodyz00) = ((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BGl_convzd2beginzd2zz__evaluatez00(BgL_arg1884z00_1914, BgL_localsz00_70, BgL_globalsz00_71, BFALSE, BgL_wherez00_73, BgL_locz00_74, ((bool_t) 0)))), BUNSPEC);
																																																							return
																																																								(
																																																								(obj_t)
																																																								BgL_new1157z00_4258);
																																																						}
																																																					}
																																																				else
																																																					{	/* Eval/evaluate.scm 424 */
																																																						obj_t
																																																							BgL_arg1885z00_1916;
																																																						obj_t
																																																							BgL_arg1886z00_1917;
																																																						BgL_arg1885z00_1916
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_cdrzd28528zd2_1902));
																																																						BgL_arg1886z00_1917
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_cdrzd28528zd2_1902));
																																																						{
																																																							BgL_ev_synchroniza7eza7_bglt
																																																								BgL_auxz00_6760;
																																																							BgL_mz00_1528
																																																								=
																																																								BgL_arg1885z00_1916;
																																																							BgL_bodyz00_1529
																																																								=
																																																								BgL_arg1886z00_1917;
																																																						BgL_tagzd2173zd2_1530:
																																																							{	/* Eval/evaluate.scm 589 */
																																																								BgL_ev_synchroniza7eza7_bglt
																																																									BgL_new1159z00_2611;
																																																								{	/* Eval/evaluate.scm 590 */
																																																									BgL_ev_synchroniza7eza7_bglt
																																																										BgL_new1158z00_2612;
																																																									BgL_new1158z00_2612
																																																										=
																																																										(
																																																										(BgL_ev_synchroniza7eza7_bglt)
																																																										BOBJECT
																																																										(GC_MALLOC
																																																											(sizeof
																																																												(struct
																																																													BgL_ev_synchroniza7eza7_bgl))));
																																																									{	/* Eval/evaluate.scm 590 */
																																																										long
																																																											BgL_arg2382z00_2613;
																																																										{	/* Eval/evaluate.scm 590 */
																																																											long
																																																												BgL_res2952z00_3862;
																																																											BgL_res2952z00_3862
																																																												=
																																																												BGL_CLASS_INDEX
																																																												(BGl_ev_synchroniza7eza7zz__evaluate_typesz00);
																																																											BgL_arg2382z00_2613
																																																												=
																																																												BgL_res2952z00_3862;
																																																										}
																																																										BGL_OBJECT_CLASS_NUM_SET
																																																											(
																																																											((BgL_objectz00_bglt) BgL_new1158z00_2612), BgL_arg2382z00_2613);
																																																									}
																																																									BgL_new1159z00_2611
																																																										=
																																																										BgL_new1158z00_2612;
																																																								}
																																																								((((BgL_ev_synchroniza7eza7_bglt) COBJECT(BgL_new1159z00_2611))->BgL_locz00) = ((obj_t) BgL_locz00_74), BUNSPEC);
																																																								{
																																																									BgL_ev_exprz00_bglt
																																																										BgL_auxz00_6766;
																																																									{	/* Eval/evaluate.scm 380 */
																																																										obj_t
																																																											BgL_arg2395z00_3865;
																																																										{	/* Eval/evaluate.scm 144 */
																																																											obj_t
																																																												BgL__ortest_1068z00_3866;
																																																											BgL__ortest_1068z00_3866
																																																												=
																																																												BGl_getzd2sourcezd2locationz00zz__readerz00
																																																												(BgL_mz00_1528);
																																																											if (CBOOL(BgL__ortest_1068z00_3866))
																																																												{	/* Eval/evaluate.scm 144 */
																																																													BgL_arg2395z00_3865
																																																														=
																																																														BgL__ortest_1068z00_3866;
																																																												}
																																																											else
																																																												{	/* Eval/evaluate.scm 144 */
																																																													BgL_arg2395z00_3865
																																																														=
																																																														BgL_locz00_74;
																																																												}
																																																										}
																																																										BgL_auxz00_6766
																																																											=
																																																											(
																																																											(BgL_ev_exprz00_bglt)
																																																											BGl_convz00zz__evaluatez00
																																																											(BgL_mz00_1528,
																																																												BgL_localsz00_70,
																																																												BgL_globalsz00_71,
																																																												BFALSE,
																																																												BgL_wherez00_73,
																																																												BgL_arg2395z00_3865,
																																																												((bool_t) 0)));
																																																									}
																																																									((((BgL_ev_synchroniza7eza7_bglt) COBJECT(BgL_new1159z00_2611))->BgL_mutexz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_6766), BUNSPEC);
																																																								}
																																																								{
																																																									BgL_ev_exprz00_bglt
																																																										BgL_auxz00_6773;
																																																									{	/* Eval/evaluate.scm 380 */
																																																										obj_t
																																																											BgL_arg2395z00_3867;
																																																										{	/* Eval/evaluate.scm 144 */
																																																											obj_t
																																																												BgL__ortest_1068z00_3868;
																																																											BgL__ortest_1068z00_3868
																																																												=
																																																												BGl_getzd2sourcezd2locationz00zz__readerz00
																																																												(BNIL);
																																																											if (CBOOL(BgL__ortest_1068z00_3868))
																																																												{	/* Eval/evaluate.scm 144 */
																																																													BgL_arg2395z00_3867
																																																														=
																																																														BgL__ortest_1068z00_3868;
																																																												}
																																																											else
																																																												{	/* Eval/evaluate.scm 144 */
																																																													BgL_arg2395z00_3867
																																																														=
																																																														BgL_locz00_74;
																																																												}
																																																										}
																																																										BgL_auxz00_6773
																																																											=
																																																											(
																																																											(BgL_ev_exprz00_bglt)
																																																											BGl_convz00zz__evaluatez00
																																																											(BNIL,
																																																												BgL_localsz00_70,
																																																												BgL_globalsz00_71,
																																																												BFALSE,
																																																												BgL_wherez00_73,
																																																												BgL_arg2395z00_3867,
																																																												((bool_t) 0)));
																																																									}
																																																									((((BgL_ev_synchroniza7eza7_bglt) COBJECT(BgL_new1159z00_2611))->BgL_prelockz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_6773), BUNSPEC);
																																																								}
																																																								((((BgL_ev_synchroniza7eza7_bglt) COBJECT(BgL_new1159z00_2611))->BgL_bodyz00) = ((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BGl_convzd2beginzd2zz__evaluatez00(BgL_bodyz00_1529, BgL_localsz00_70, BgL_globalsz00_71, BFALSE, BgL_wherez00_73, BgL_locz00_74, ((bool_t) 0)))), BUNSPEC);
																																																								BgL_auxz00_6760
																																																									=
																																																									BgL_new1159z00_2611;
																																																							}
																																																							return
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_6760);
																																																						}
																																																					}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 424 */
																																																				obj_t
																																																					BgL_arg1887z00_1919;
																																																				obj_t
																																																					BgL_arg1888z00_1920;
																																																				BgL_arg1887z00_1919
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_cdrzd28528zd2_1902));
																																																				BgL_arg1888z00_1920
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_cdrzd28528zd2_1902));
																																																				{
																																																					BgL_ev_synchroniza7eza7_bglt
																																																						BgL_auxz00_6788;
																																																					{
																																																						obj_t
																																																							BgL_bodyz00_6790;
																																																						obj_t
																																																							BgL_mz00_6789;
																																																						BgL_mz00_6789
																																																							=
																																																							BgL_arg1887z00_1919;
																																																						BgL_bodyz00_6790
																																																							=
																																																							BgL_arg1888z00_1920;
																																																						BgL_bodyz00_1529
																																																							=
																																																							BgL_bodyz00_6790;
																																																						BgL_mz00_1528
																																																							=
																																																							BgL_mz00_6789;
																																																						goto
																																																							BgL_tagzd2173zd2_1530;
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_6788);
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Eval/evaluate.scm 424 */
																																																		obj_t
																																																			BgL_arg1890z00_1923;
																																																		obj_t
																																																			BgL_arg1891z00_1924;
																																																		BgL_arg1890z00_1923
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_cdrzd28528zd2_1902));
																																																		BgL_arg1891z00_1924
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_cdrzd28528zd2_1902));
																																																		{
																																																			BgL_ev_synchroniza7eza7_bglt
																																																				BgL_auxz00_6796;
																																																			{
																																																				obj_t
																																																					BgL_bodyz00_6798;
																																																				obj_t
																																																					BgL_mz00_6797;
																																																				BgL_mz00_6797
																																																					=
																																																					BgL_arg1890z00_1923;
																																																				BgL_bodyz00_6798
																																																					=
																																																					BgL_arg1891z00_1924;
																																																				BgL_bodyz00_1529
																																																					=
																																																					BgL_bodyz00_6798;
																																																				BgL_mz00_1528
																																																					=
																																																					BgL_mz00_6797;
																																																				goto
																																																					BgL_tagzd2173zd2_1530;
																																																			}
																																																			return
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_6796);
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 424 */
																																																obj_t
																																																	BgL_arg1892z00_1925;
																																																BgL_arg1892z00_1925
																																																	=
																																																	CAR
																																																	(BgL_ez00_69);
																																																{
																																																	BgL_ev_appz00_bglt
																																																		BgL_auxz00_6801;
																																																	{
																																																		obj_t
																																																			BgL_argsz00_6803;
																																																		obj_t
																																																			BgL_fz00_6802;
																																																		BgL_fz00_6802
																																																			=
																																																			BgL_arg1892z00_1925;
																																																		BgL_argsz00_6803
																																																			=
																																																			BgL_cdrzd28528zd2_1902;
																																																		BgL_argsz00_1535
																																																			=
																																																			BgL_argsz00_6803;
																																																		BgL_fz00_1534
																																																			=
																																																			BgL_fz00_6802;
																																																		goto
																																																			BgL_tagzd2175zd2_1536;
																																																	}
																																																	return
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_6801);
																																																}
																																															}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 424 */
																																														if ((CAR(BgL_ez00_69) == BGl_symbol3242z00zz__evaluatez00))
																																															{	/* Eval/evaluate.scm 424 */
																																																if (PAIRP(BgL_cdrzd28528zd2_1902))
																																																	{	/* Eval/evaluate.scm 424 */
																																																		obj_t
																																																			BgL_cdrzd28638zd2_1931;
																																																		BgL_cdrzd28638zd2_1931
																																																			=
																																																			CDR
																																																			(BgL_cdrzd28528zd2_1902);
																																																		if (PAIRP(BgL_cdrzd28638zd2_1931))
																																																			{	/* Eval/evaluate.scm 424 */
																																																				if (NULLP(CDR(BgL_cdrzd28638zd2_1931)))
																																																					{	/* Eval/evaluate.scm 424 */
																																																						obj_t
																																																							BgL_arg1900z00_1935;
																																																						obj_t
																																																							BgL_arg1901z00_1936;
																																																						BgL_arg1900z00_1935
																																																							=
																																																							CAR
																																																							(BgL_cdrzd28528zd2_1902);
																																																						BgL_arg1901z00_1936
																																																							=
																																																							CAR
																																																							(BgL_cdrzd28638zd2_1931);
																																																						{	/* Eval/evaluate.scm 595 */
																																																							obj_t
																																																								BgL_arg2383z00_4287;
																																																							{	/* Eval/evaluate.scm 595 */
																																																								obj_t
																																																									BgL_arg2385z00_4288;
																																																								{	/* Eval/evaluate.scm 595 */
																																																									obj_t
																																																										BgL_arg2386z00_4289;
																																																									obj_t
																																																										BgL_arg2387z00_4290;
																																																									{	/* Eval/evaluate.scm 595 */
																																																										obj_t
																																																											BgL_res3038z00_4293;
																																																										{	/* Eval/evaluate.scm 595 */
																																																											obj_t
																																																												BgL_symbolz00_4291;
																																																											BgL_symbolz00_4291
																																																												=
																																																												BGl_symbol3289z00zz__evaluatez00;
																																																											{	/* Eval/evaluate.scm 595 */
																																																												obj_t
																																																													BgL_arg2602z00_4292;
																																																												BgL_arg2602z00_4292
																																																													=
																																																													SYMBOL_TO_STRING
																																																													(BgL_symbolz00_4291);
																																																												BgL_res3038z00_4293
																																																													=
																																																													BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																																																													(BgL_arg2602z00_4292);
																																																											}
																																																										}
																																																										BgL_arg2386z00_4289
																																																											=
																																																											BgL_res3038z00_4293;
																																																									}
																																																									{	/* Eval/evaluate.scm 595 */
																																																										obj_t
																																																											BgL_res3039z00_4296;
																																																										{	/* Eval/evaluate.scm 595 */
																																																											obj_t
																																																												BgL_arg2602z00_4295;
																																																											BgL_arg2602z00_4295
																																																												=
																																																												SYMBOL_TO_STRING
																																																												(
																																																												((obj_t) BgL_wherez00_73));
																																																											BgL_res3039z00_4296
																																																												=
																																																												BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																																																												(BgL_arg2602z00_4295);
																																																										}
																																																										BgL_arg2387z00_4290
																																																											=
																																																											BgL_res3039z00_4296;
																																																									}
																																																									BgL_arg2385z00_4288
																																																										=
																																																										string_append
																																																										(BgL_arg2386z00_4289,
																																																										BgL_arg2387z00_4290);
																																																								}
																																																								BgL_arg2383z00_4287
																																																									=
																																																									bstring_to_symbol
																																																									(BgL_arg2385z00_4288);
																																																							}
																																																							return
																																																								(
																																																								(obj_t)
																																																								BGl_convzd2lambdaze70z35zz__evaluatez00
																																																								(BgL_globalsz00_71,
																																																									BgL_localsz00_70,
																																																									BgL_ez00_69,
																																																									BgL_locz00_74,
																																																									BgL_arg1900z00_1935,
																																																									BgL_arg1901z00_1936,
																																																									BgL_arg2383z00_4287,
																																																									BFALSE));
																																																						}
																																																					}
																																																				else
																																																					{	/* Eval/evaluate.scm 424 */
																																																						obj_t
																																																							BgL_arg1902z00_1937;
																																																						obj_t
																																																							BgL_arg1903z00_1938;
																																																						BgL_arg1902z00_1937
																																																							=
																																																							CAR
																																																							(BgL_ez00_69);
																																																						BgL_arg1903z00_1938
																																																							=
																																																							CDR
																																																							(BgL_ez00_69);
																																																						{
																																																							BgL_ev_appz00_bglt
																																																								BgL_auxz00_6829;
																																																							{
																																																								obj_t
																																																									BgL_argsz00_6831;
																																																								obj_t
																																																									BgL_fz00_6830;
																																																								BgL_fz00_6830
																																																									=
																																																									BgL_arg1902z00_1937;
																																																								BgL_argsz00_6831
																																																									=
																																																									BgL_arg1903z00_1938;
																																																								BgL_argsz00_1535
																																																									=
																																																									BgL_argsz00_6831;
																																																								BgL_fz00_1534
																																																									=
																																																									BgL_fz00_6830;
																																																								goto
																																																									BgL_tagzd2175zd2_1536;
																																																							}
																																																							return
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_6829);
																																																						}
																																																					}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 424 */
																																																				obj_t
																																																					BgL_arg1905z00_1940;
																																																				obj_t
																																																					BgL_arg1906z00_1941;
																																																				BgL_arg1905z00_1940
																																																					=
																																																					CAR
																																																					(BgL_ez00_69);
																																																				BgL_arg1906z00_1941
																																																					=
																																																					CDR
																																																					(BgL_ez00_69);
																																																				{
																																																					BgL_ev_appz00_bglt
																																																						BgL_auxz00_6835;
																																																					{
																																																						obj_t
																																																							BgL_argsz00_6837;
																																																						obj_t
																																																							BgL_fz00_6836;
																																																						BgL_fz00_6836
																																																							=
																																																							BgL_arg1905z00_1940;
																																																						BgL_argsz00_6837
																																																							=
																																																							BgL_arg1906z00_1941;
																																																						BgL_argsz00_1535
																																																							=
																																																							BgL_argsz00_6837;
																																																						BgL_fz00_1534
																																																							=
																																																							BgL_fz00_6836;
																																																						goto
																																																							BgL_tagzd2175zd2_1536;
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_6835);
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Eval/evaluate.scm 424 */
																																																		obj_t
																																																			BgL_arg1907z00_1942;
																																																		obj_t
																																																			BgL_arg1908z00_1943;
																																																		BgL_arg1907z00_1942
																																																			=
																																																			CAR
																																																			(BgL_ez00_69);
																																																		BgL_arg1908z00_1943
																																																			=
																																																			CDR
																																																			(BgL_ez00_69);
																																																		{
																																																			BgL_ev_appz00_bglt
																																																				BgL_auxz00_6841;
																																																			{
																																																				obj_t
																																																					BgL_argsz00_6843;
																																																				obj_t
																																																					BgL_fz00_6842;
																																																				BgL_fz00_6842
																																																					=
																																																					BgL_arg1907z00_1942;
																																																				BgL_argsz00_6843
																																																					=
																																																					BgL_arg1908z00_1943;
																																																				BgL_argsz00_1535
																																																					=
																																																					BgL_argsz00_6843;
																																																				BgL_fz00_1534
																																																					=
																																																					BgL_fz00_6842;
																																																				goto
																																																					BgL_tagzd2175zd2_1536;
																																																			}
																																																			return
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_6841);
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 424 */
																																																obj_t
																																																	BgL_arg1909z00_1944;
																																																obj_t
																																																	BgL_arg1910z00_1945;
																																																BgL_arg1909z00_1944
																																																	=
																																																	CAR
																																																	(BgL_ez00_69);
																																																BgL_arg1910z00_1945
																																																	=
																																																	CDR
																																																	(BgL_ez00_69);
																																																{
																																																	BgL_ev_appz00_bglt
																																																		BgL_auxz00_6847;
																																																	{
																																																		obj_t
																																																			BgL_argsz00_6849;
																																																		obj_t
																																																			BgL_fz00_6848;
																																																		BgL_fz00_6848
																																																			=
																																																			BgL_arg1909z00_1944;
																																																		BgL_argsz00_6849
																																																			=
																																																			BgL_arg1910z00_1945;
																																																		BgL_argsz00_1535
																																																			=
																																																			BgL_argsz00_6849;
																																																		BgL_fz00_1534
																																																			=
																																																			BgL_fz00_6848;
																																																		goto
																																																			BgL_tagzd2175zd2_1536;
																																																	}
																																																	return
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_6847);
																																																}
																																															}
																																													}
																																											}
																																									}
																																							}
																																					}
																																			}
																																	}
																															}
																													}
																											}
																									}
																							}
																					}
																			}
																	}
															}
													}
												else
													{	/* Eval/evaluate.scm 424 */
														if (
															(BgL_carzd23820zd2_1609 ==
																BGl_symbol3265z00zz__evaluatez00))
															{	/* Eval/evaluate.scm 424 */
																if (PAIRP(BgL_cdrzd2249zd2_1543))
																	{	/* Eval/evaluate.scm 424 */
																		if (NULLP(CDR(BgL_cdrzd2249zd2_1543)))
																			{	/* Eval/evaluate.scm 424 */
																				obj_t BgL_arg1933z00_1969;

																				BgL_arg1933z00_1969 =
																					CAR(BgL_cdrzd2249zd2_1543);
																				{	/* Eval/evaluate.scm 456 */
																					BgL_ev_trapz00_bglt
																						BgL_new1110z00_4313;
																					{	/* Eval/evaluate.scm 457 */
																						BgL_ev_trapz00_bglt
																							BgL_new1109z00_4314;
																						BgL_new1109z00_4314 =
																							((BgL_ev_trapz00_bglt)
																							BOBJECT(GC_MALLOC(sizeof(struct
																										BgL_ev_trapz00_bgl))));
																						{	/* Eval/evaluate.scm 457 */
																							long BgL_arg2258z00_4315;

																							{	/* Eval/evaluate.scm 457 */
																								long BgL_res3043z00_4317;

																								BgL_res3043z00_4317 =
																									BGL_CLASS_INDEX
																									(BGl_ev_trapz00zz__evaluate_typesz00);
																								BgL_arg2258z00_4315 =
																									BgL_res3043z00_4317;
																							}
																							BGL_OBJECT_CLASS_NUM_SET(
																								((BgL_objectz00_bglt)
																									BgL_new1109z00_4314),
																								BgL_arg2258z00_4315);
																						}
																						BgL_new1110z00_4313 =
																							BgL_new1109z00_4314;
																					}
																					{
																						BgL_ev_exprz00_bglt BgL_auxz00_6863;

																						{	/* Eval/evaluate.scm 380 */
																							obj_t BgL_arg2395z00_4320;

																							BgL_arg2395z00_4320 =
																								BGl_getzd2locationzd2zz__evaluatez00
																								(BgL_arg1933z00_1969,
																								BgL_locz00_74);
																							BgL_auxz00_6863 =
																								((BgL_ev_exprz00_bglt)
																								BGl_uconvzf2locze70z15zz__evaluatez00
																								(BgL_wherez00_73,
																									BgL_globalsz00_71,
																									BgL_localsz00_70,
																									BgL_arg1933z00_1969,
																									BgL_arg2395z00_4320));
																						}
																						((((BgL_ev_hookz00_bglt) COBJECT(
																										((BgL_ev_hookz00_bglt)
																											BgL_new1110z00_4313)))->
																								BgL_ez00) =
																							((BgL_ev_exprz00_bglt)
																								BgL_auxz00_6863), BUNSPEC);
																					}
																					return ((obj_t) BgL_new1110z00_4313);
																				}
																			}
																		else
																			{	/* Eval/evaluate.scm 424 */
																				obj_t BgL_arg1934z00_1970;
																				obj_t BgL_arg1935z00_1971;

																				BgL_arg1934z00_1970 = CAR(BgL_ez00_69);
																				BgL_arg1935z00_1971 = CDR(BgL_ez00_69);
																				{
																					BgL_ev_appz00_bglt BgL_auxz00_6872;

																					{
																						obj_t BgL_argsz00_6874;
																						obj_t BgL_fz00_6873;

																						BgL_fz00_6873 = BgL_arg1934z00_1970;
																						BgL_argsz00_6874 =
																							BgL_arg1935z00_1971;
																						BgL_argsz00_1535 = BgL_argsz00_6874;
																						BgL_fz00_1534 = BgL_fz00_6873;
																						goto BgL_tagzd2175zd2_1536;
																					}
																					return ((obj_t) BgL_auxz00_6872);
																				}
																			}
																	}
																else
																	{	/* Eval/evaluate.scm 424 */
																		obj_t BgL_arg1937z00_1973;
																		obj_t BgL_arg1938z00_1974;

																		BgL_arg1937z00_1973 = CAR(BgL_ez00_69);
																		BgL_arg1938z00_1974 = CDR(BgL_ez00_69);
																		{
																			BgL_ev_appz00_bglt BgL_auxz00_6878;

																			{
																				obj_t BgL_argsz00_6880;
																				obj_t BgL_fz00_6879;

																				BgL_fz00_6879 = BgL_arg1937z00_1973;
																				BgL_argsz00_6880 = BgL_arg1938z00_1974;
																				BgL_argsz00_1535 = BgL_argsz00_6880;
																				BgL_fz00_1534 = BgL_fz00_6879;
																				goto BgL_tagzd2175zd2_1536;
																			}
																			return ((obj_t) BgL_auxz00_6878);
																		}
																	}
															}
														else
															{	/* Eval/evaluate.scm 424 */
																obj_t BgL_cdrzd29337zd2_1975;

																BgL_cdrzd29337zd2_1975 = CDR(BgL_ez00_69);
																if (
																	(CAR(BgL_ez00_69) ==
																		BGl_symbol3230z00zz__evaluatez00))
																	{	/* Eval/evaluate.scm 424 */
																		if (PAIRP(BgL_cdrzd29337zd2_1975))
																			{	/* Eval/evaluate.scm 424 */
																				if (NULLP(CDR(BgL_cdrzd29337zd2_1975)))
																					{	/* Eval/evaluate.scm 424 */
																						obj_t BgL_arg1944z00_1981;

																						BgL_arg1944z00_1981 =
																							CAR(BgL_cdrzd29337zd2_1975);
																						{	/* Eval/evaluate.scm 459 */
																							BgL_ev_littz00_bglt
																								BgL_new1112z00_4331;
																							{	/* Eval/evaluate.scm 460 */
																								BgL_ev_littz00_bglt
																									BgL_new1111z00_4332;
																								BgL_new1111z00_4332 =
																									((BgL_ev_littz00_bglt)
																									BOBJECT(GC_MALLOC(sizeof
																											(struct
																												BgL_ev_littz00_bgl))));
																								{	/* Eval/evaluate.scm 460 */
																									long BgL_arg2259z00_4333;

																									{	/* Eval/evaluate.scm 460 */
																										long BgL_res3046z00_4335;

																										BgL_res3046z00_4335 =
																											BGL_CLASS_INDEX
																											(BGl_ev_littz00zz__evaluate_typesz00);
																										BgL_arg2259z00_4333 =
																											BgL_res3046z00_4335;
																									}
																									BGL_OBJECT_CLASS_NUM_SET(
																										((BgL_objectz00_bglt)
																											BgL_new1111z00_4332),
																										BgL_arg2259z00_4333);
																								}
																								BgL_new1112z00_4331 =
																									BgL_new1111z00_4332;
																							}
																							((((BgL_ev_littz00_bglt)
																										COBJECT
																										(BgL_new1112z00_4331))->
																									BgL_valuez00) =
																								((obj_t) BgL_arg1944z00_1981),
																								BUNSPEC);
																							return ((obj_t)
																								BgL_new1112z00_4331);
																						}
																					}
																				else
																					{	/* Eval/evaluate.scm 424 */
																						obj_t BgL_arg1945z00_1982;

																						BgL_arg1945z00_1982 =
																							CAR(BgL_ez00_69);
																						{
																							BgL_ev_appz00_bglt
																								BgL_auxz00_6899;
																							{
																								obj_t BgL_argsz00_6901;
																								obj_t BgL_fz00_6900;

																								BgL_fz00_6900 =
																									BgL_arg1945z00_1982;
																								BgL_argsz00_6901 =
																									BgL_cdrzd29337zd2_1975;
																								BgL_argsz00_1535 =
																									BgL_argsz00_6901;
																								BgL_fz00_1534 = BgL_fz00_6900;
																								goto BgL_tagzd2175zd2_1536;
																							}
																							return ((obj_t) BgL_auxz00_6899);
																						}
																					}
																			}
																		else
																			{	/* Eval/evaluate.scm 424 */
																				obj_t BgL_arg1948z00_1985;

																				BgL_arg1948z00_1985 = CAR(BgL_ez00_69);
																				{
																					BgL_ev_appz00_bglt BgL_auxz00_6904;

																					{
																						obj_t BgL_argsz00_6906;
																						obj_t BgL_fz00_6905;

																						BgL_fz00_6905 = BgL_arg1948z00_1985;
																						BgL_argsz00_6906 =
																							BgL_cdrzd29337zd2_1975;
																						BgL_argsz00_1535 = BgL_argsz00_6906;
																						BgL_fz00_1534 = BgL_fz00_6905;
																						goto BgL_tagzd2175zd2_1536;
																					}
																					return ((obj_t) BgL_auxz00_6904);
																				}
																			}
																	}
																else
																	{	/* Eval/evaluate.scm 424 */
																		if (
																			(CAR(BgL_ez00_69) ==
																				BGl_symbol3238z00zz__evaluatez00))
																			{	/* Eval/evaluate.scm 424 */
																				if (PAIRP(BgL_cdrzd29337zd2_1975))
																					{	/* Eval/evaluate.scm 424 */
																						obj_t BgL_cdrzd29947zd2_1991;

																						BgL_cdrzd29947zd2_1991 =
																							CDR(BgL_cdrzd29337zd2_1975);
																						if (PAIRP(BgL_cdrzd29947zd2_1991))
																							{	/* Eval/evaluate.scm 424 */
																								obj_t BgL_cdrzd29952zd2_1993;

																								BgL_cdrzd29952zd2_1993 =
																									CDR(BgL_cdrzd29947zd2_1991);
																								if (PAIRP
																									(BgL_cdrzd29952zd2_1993))
																									{	/* Eval/evaluate.scm 424 */
																										if (NULLP(CDR
																												(BgL_cdrzd29952zd2_1993)))
																											{	/* Eval/evaluate.scm 424 */
																												obj_t
																													BgL_arg1958z00_1997;
																												obj_t
																													BgL_arg1959z00_1998;
																												obj_t
																													BgL_arg1960z00_1999;
																												BgL_arg1958z00_1997 =
																													CAR
																													(BgL_cdrzd29337zd2_1975);
																												BgL_arg1959z00_1998 =
																													CAR
																													(BgL_cdrzd29947zd2_1991);
																												BgL_arg1960z00_1999 =
																													CAR
																													(BgL_cdrzd29952zd2_1993);
																												{
																													BgL_ev_ifz00_bglt
																														BgL_auxz00_6925;
																													{
																														obj_t BgL_oz00_6928;
																														obj_t BgL_tz00_6927;
																														obj_t BgL_pz00_6926;

																														BgL_pz00_6926 =
																															BgL_arg1958z00_1997;
																														BgL_tz00_6927 =
																															BgL_arg1959z00_1998;
																														BgL_oz00_6928 =
																															BgL_arg1960z00_1999;
																														BgL_oz00_1477 =
																															BgL_oz00_6928;
																														BgL_tz00_1476 =
																															BgL_tz00_6927;
																														BgL_pz00_1475 =
																															BgL_pz00_6926;
																														goto
																															BgL_tagzd2155zd2_1478;
																													}
																													return
																														((obj_t)
																														BgL_auxz00_6925);
																												}
																											}
																										else
																											{	/* Eval/evaluate.scm 424 */
																												obj_t
																													BgL_arg1961z00_2000;
																												obj_t
																													BgL_arg1962z00_2001;
																												BgL_arg1961z00_2000 =
																													CAR(BgL_ez00_69);
																												BgL_arg1962z00_2001 =
																													CDR(BgL_ez00_69);
																												{
																													BgL_ev_appz00_bglt
																														BgL_auxz00_6932;
																													{
																														obj_t
																															BgL_argsz00_6934;
																														obj_t BgL_fz00_6933;

																														BgL_fz00_6933 =
																															BgL_arg1961z00_2000;
																														BgL_argsz00_6934 =
																															BgL_arg1962z00_2001;
																														BgL_argsz00_1535 =
																															BgL_argsz00_6934;
																														BgL_fz00_1534 =
																															BgL_fz00_6933;
																														goto
																															BgL_tagzd2175zd2_1536;
																													}
																													return
																														((obj_t)
																														BgL_auxz00_6932);
																												}
																											}
																									}
																								else
																									{	/* Eval/evaluate.scm 424 */
																										obj_t
																											BgL_cdrzd210250zd2_2003;
																										BgL_cdrzd210250zd2_2003 =
																											CDR(BgL_ez00_69);
																										{	/* Eval/evaluate.scm 424 */
																											obj_t
																												BgL_cdrzd210256zd2_2004;
																											BgL_cdrzd210256zd2_2004 =
																												CDR(((obj_t)
																													BgL_cdrzd210250zd2_2003));
																											if (NULLP(CDR(((obj_t)
																															BgL_cdrzd210256zd2_2004))))
																												{	/* Eval/evaluate.scm 424 */
																													obj_t
																														BgL_arg1966z00_2007;
																													obj_t
																														BgL_arg1967z00_2008;
																													BgL_arg1966z00_2007 =
																														CAR(((obj_t)
																															BgL_cdrzd210250zd2_2003));
																													BgL_arg1967z00_2008 =
																														CAR(((obj_t)
																															BgL_cdrzd210256zd2_2004));
																													{
																														BgL_ev_ifz00_bglt
																															BgL_auxz00_6947;
																														{
																															obj_t
																																BgL_tz00_6949;
																															obj_t
																																BgL_pz00_6948;
																															BgL_pz00_6948 =
																																BgL_arg1966z00_2007;
																															BgL_tz00_6949 =
																																BgL_arg1967z00_2008;
																															BgL_tz00_1480 =
																																BgL_tz00_6949;
																															BgL_pz00_1479 =
																																BgL_pz00_6948;
																															goto
																																BgL_tagzd2156zd2_1481;
																														}
																														return
																															((obj_t)
																															BgL_auxz00_6947);
																													}
																												}
																											else
																												{	/* Eval/evaluate.scm 424 */
																													obj_t
																														BgL_arg1968z00_2009;
																													BgL_arg1968z00_2009 =
																														CAR(BgL_ez00_69);
																													{
																														BgL_ev_appz00_bglt
																															BgL_auxz00_6952;
																														{
																															obj_t
																																BgL_argsz00_6954;
																															obj_t
																																BgL_fz00_6953;
																															BgL_fz00_6953 =
																																BgL_arg1968z00_2009;
																															BgL_argsz00_6954 =
																																BgL_cdrzd210250zd2_2003;
																															BgL_argsz00_1535 =
																																BgL_argsz00_6954;
																															BgL_fz00_1534 =
																																BgL_fz00_6953;
																															goto
																																BgL_tagzd2175zd2_1536;
																														}
																														return
																															((obj_t)
																															BgL_auxz00_6952);
																													}
																												}
																										}
																									}
																							}
																						else
																							{	/* Eval/evaluate.scm 424 */
																								obj_t BgL_arg1971z00_2012;
																								obj_t BgL_arg1973z00_2013;

																								BgL_arg1971z00_2012 =
																									CAR(BgL_ez00_69);
																								BgL_arg1973z00_2013 =
																									CDR(BgL_ez00_69);
																								{
																									BgL_ev_appz00_bglt
																										BgL_auxz00_6958;
																									{
																										obj_t BgL_argsz00_6960;
																										obj_t BgL_fz00_6959;

																										BgL_fz00_6959 =
																											BgL_arg1971z00_2012;
																										BgL_argsz00_6960 =
																											BgL_arg1973z00_2013;
																										BgL_argsz00_1535 =
																											BgL_argsz00_6960;
																										BgL_fz00_1534 =
																											BgL_fz00_6959;
																										goto BgL_tagzd2175zd2_1536;
																									}
																									return
																										((obj_t) BgL_auxz00_6958);
																								}
																							}
																					}
																				else
																					{	/* Eval/evaluate.scm 424 */
																						obj_t BgL_arg1974z00_2014;
																						obj_t BgL_arg1975z00_2015;

																						BgL_arg1974z00_2014 =
																							CAR(BgL_ez00_69);
																						BgL_arg1975z00_2015 =
																							CDR(BgL_ez00_69);
																						{
																							BgL_ev_appz00_bglt
																								BgL_auxz00_6964;
																							{
																								obj_t BgL_argsz00_6966;
																								obj_t BgL_fz00_6965;

																								BgL_fz00_6965 =
																									BgL_arg1974z00_2014;
																								BgL_argsz00_6966 =
																									BgL_arg1975z00_2015;
																								BgL_argsz00_1535 =
																									BgL_argsz00_6966;
																								BgL_fz00_1534 = BgL_fz00_6965;
																								goto BgL_tagzd2175zd2_1536;
																							}
																							return ((obj_t) BgL_auxz00_6964);
																						}
																					}
																			}
																		else
																			{	/* Eval/evaluate.scm 424 */
																				if (
																					(CAR(BgL_ez00_69) ==
																						BGl_symbol3267z00zz__evaluatez00))
																					{	/* Eval/evaluate.scm 424 */
																						obj_t BgL_arg1978z00_2018;

																						BgL_arg1978z00_2018 =
																							CDR(BgL_ez00_69);
																						{	/* Eval/evaluate.scm 472 */
																							BgL_ev_orz00_bglt
																								BgL_new1119z00_4370;
																							{	/* Eval/evaluate.scm 473 */
																								BgL_ev_orz00_bglt
																									BgL_new1117z00_4371;
																								BgL_new1117z00_4371 =
																									((BgL_ev_orz00_bglt)
																									BOBJECT(GC_MALLOC(sizeof
																											(struct
																												BgL_ev_orz00_bgl))));
																								{	/* Eval/evaluate.scm 473 */
																									long BgL_arg2268z00_4372;

																									{	/* Eval/evaluate.scm 473 */
																										long BgL_res3052z00_4374;

																										BgL_res3052z00_4374 =
																											BGL_CLASS_INDEX
																											(BGl_ev_orz00zz__evaluate_typesz00);
																										BgL_arg2268z00_4372 =
																											BgL_res3052z00_4374;
																									}
																									BGL_OBJECT_CLASS_NUM_SET(
																										((BgL_objectz00_bglt)
																											BgL_new1117z00_4371),
																										BgL_arg2268z00_4372);
																								}
																								BgL_new1119z00_4370 =
																									BgL_new1117z00_4371;
																							}
																							((((BgL_ev_listz00_bglt) COBJECT(
																											((BgL_ev_listz00_bglt)
																												BgL_new1119z00_4370)))->
																									BgL_argsz00) =
																								((obj_t)
																									BGl_loopze70ze7zz__evaluatez00
																									(BgL_wherez00_73,
																										BgL_globalsz00_71,
																										BgL_localsz00_70,
																										BgL_locz00_74,
																										BgL_arg1978z00_2018)),
																								BUNSPEC);
																							return ((obj_t)
																								BgL_new1119z00_4370);
																						}
																					}
																				else
																					{	/* Eval/evaluate.scm 424 */
																						if (
																							(CAR(BgL_ez00_69) ==
																								BGl_symbol3269z00zz__evaluatez00))
																							{	/* Eval/evaluate.scm 424 */
																								obj_t BgL_arg1982z00_2021;

																								BgL_arg1982z00_2021 =
																									CDR(BgL_ez00_69);
																								{	/* Eval/evaluate.scm 475 */
																									BgL_ev_andz00_bglt
																										BgL_new1121z00_4379;
																									{	/* Eval/evaluate.scm 476 */
																										BgL_ev_andz00_bglt
																											BgL_new1120z00_4380;
																										BgL_new1120z00_4380 =
																											((BgL_ev_andz00_bglt)
																											BOBJECT(GC_MALLOC(sizeof
																													(struct
																														BgL_ev_andz00_bgl))));
																										{	/* Eval/evaluate.scm 476 */
																											long BgL_arg2269z00_4381;

																											{	/* Eval/evaluate.scm 476 */
																												long
																													BgL_res3053z00_4383;
																												BgL_res3053z00_4383 =
																													BGL_CLASS_INDEX
																													(BGl_ev_andz00zz__evaluate_typesz00);
																												BgL_arg2269z00_4381 =
																													BgL_res3053z00_4383;
																											}
																											BGL_OBJECT_CLASS_NUM_SET(
																												((BgL_objectz00_bglt)
																													BgL_new1120z00_4380),
																												BgL_arg2269z00_4381);
																										}
																										BgL_new1121z00_4379 =
																											BgL_new1120z00_4380;
																									}
																									((((BgL_ev_listz00_bglt)
																												COBJECT((
																														(BgL_ev_listz00_bglt)
																														BgL_new1121z00_4379)))->
																											BgL_argsz00) =
																										((obj_t)
																											BGl_loopze70ze7zz__evaluatez00
																											(BgL_wherez00_73,
																												BgL_globalsz00_71,
																												BgL_localsz00_70,
																												BgL_locz00_74,
																												BgL_arg1982z00_2021)),
																										BUNSPEC);
																									return ((obj_t)
																										BgL_new1121z00_4379);
																								}
																							}
																						else
																							{	/* Eval/evaluate.scm 424 */
																								if (
																									(CAR(BgL_ez00_69) ==
																										BGl_symbol3254z00zz__evaluatez00))
																									{	/* Eval/evaluate.scm 424 */
																										return
																											BGl_convzd2beginzd2zz__evaluatez00
																											(CDR(BgL_ez00_69),
																											BgL_localsz00_70,
																											BgL_globalsz00_71,
																											BgL_tailzf3zf3_72,
																											BgL_wherez00_73,
																											BgL_locz00_74,
																											BgL_topzf3zf3_75);
																									}
																								else
																									{	/* Eval/evaluate.scm 424 */
																										obj_t
																											BgL_cdrzd211149zd2_2025;
																										BgL_cdrzd211149zd2_2025 =
																											CDR(BgL_ez00_69);
																										if ((CAR(BgL_ez00_69) ==
																												BGl_symbol3240z00zz__evaluatez00))
																											{	/* Eval/evaluate.scm 424 */
																												if (PAIRP
																													(BgL_cdrzd211149zd2_2025))
																													{	/* Eval/evaluate.scm 424 */
																														obj_t
																															BgL_arg1990z00_2029;
																														obj_t
																															BgL_arg1991z00_2030;
																														BgL_arg1990z00_2029
																															=
																															CAR
																															(BgL_cdrzd211149zd2_2025);
																														BgL_arg1991z00_2030
																															=
																															CDR
																															(BgL_cdrzd211149zd2_2025);
																														{
																															BgL_ev_letz00_bglt
																																BgL_auxz00_7005;
																															{
																																obj_t
																																	BgL_bodyz00_7007;
																																obj_t
																																	BgL_bindsz00_7006;
																																BgL_bindsz00_7006
																																	=
																																	BgL_arg1990z00_2029;
																																BgL_bodyz00_7007
																																	=
																																	BgL_arg1991z00_2030;
																																BgL_bodyz00_1489
																																	=
																																	BgL_bodyz00_7007;
																																BgL_bindsz00_1488
																																	=
																																	BgL_bindsz00_7006;
																																goto
																																	BgL_tagzd2160zd2_1490;
																															}
																															return
																																((obj_t)
																																BgL_auxz00_7005);
																														}
																													}
																												else
																													{	/* Eval/evaluate.scm 424 */
																														obj_t
																															BgL_arg1992z00_2031;
																														BgL_arg1992z00_2031
																															=
																															CAR(BgL_ez00_69);
																														{
																															BgL_ev_appz00_bglt
																																BgL_auxz00_7010;
																															{
																																obj_t
																																	BgL_argsz00_7012;
																																obj_t
																																	BgL_fz00_7011;
																																BgL_fz00_7011 =
																																	BgL_arg1992z00_2031;
																																BgL_argsz00_7012
																																	=
																																	BgL_cdrzd211149zd2_2025;
																																BgL_argsz00_1535
																																	=
																																	BgL_argsz00_7012;
																																BgL_fz00_1534 =
																																	BgL_fz00_7011;
																																goto
																																	BgL_tagzd2175zd2_1536;
																															}
																															return
																																((obj_t)
																																BgL_auxz00_7010);
																														}
																													}
																											}
																										else
																											{	/* Eval/evaluate.scm 424 */
																												if (
																													(CAR(BgL_ez00_69) ==
																														BGl_symbol3271z00zz__evaluatez00))
																													{	/* Eval/evaluate.scm 424 */
																														if (PAIRP
																															(BgL_cdrzd211149zd2_2025))
																															{	/* Eval/evaluate.scm 424 */
																																obj_t
																																	BgL_arg1998z00_2037;
																																obj_t
																																	BgL_arg1999z00_2038;
																																BgL_arg1998z00_2037
																																	=
																																	CAR
																																	(BgL_cdrzd211149zd2_2025);
																																BgL_arg1999z00_2038
																																	=
																																	CDR
																																	(BgL_cdrzd211149zd2_2025);
																																{
																																	BgL_ev_letza2za2_bglt
																																		BgL_auxz00_7021;
																																	{
																																		obj_t
																																			BgL_bodyz00_7023;
																																		obj_t
																																			BgL_bindsz00_7022;
																																		BgL_bindsz00_7022
																																			=
																																			BgL_arg1998z00_2037;
																																		BgL_bodyz00_7023
																																			=
																																			BgL_arg1999z00_2038;
																																		BgL_bodyz00_1492
																																			=
																																			BgL_bodyz00_7023;
																																		BgL_bindsz00_1491
																																			=
																																			BgL_bindsz00_7022;
																																		goto
																																			BgL_tagzd2161zd2_1493;
																																	}
																																	return
																																		((obj_t)
																																		BgL_auxz00_7021);
																																}
																															}
																														else
																															{	/* Eval/evaluate.scm 424 */
																																obj_t
																																	BgL_arg2000z00_2039;
																																obj_t
																																	BgL_arg2001z00_2040;
																																BgL_arg2000z00_2039
																																	=
																																	CAR
																																	(BgL_ez00_69);
																																BgL_arg2001z00_2040
																																	=
																																	CDR
																																	(BgL_ez00_69);
																																{
																																	BgL_ev_appz00_bglt
																																		BgL_auxz00_7027;
																																	{
																																		obj_t
																																			BgL_argsz00_7029;
																																		obj_t
																																			BgL_fz00_7028;
																																		BgL_fz00_7028
																																			=
																																			BgL_arg2000z00_2039;
																																		BgL_argsz00_7029
																																			=
																																			BgL_arg2001z00_2040;
																																		BgL_argsz00_1535
																																			=
																																			BgL_argsz00_7029;
																																		BgL_fz00_1534
																																			=
																																			BgL_fz00_7028;
																																		goto
																																			BgL_tagzd2175zd2_1536;
																																	}
																																	return
																																		((obj_t)
																																		BgL_auxz00_7027);
																																}
																															}
																													}
																												else
																													{	/* Eval/evaluate.scm 424 */
																														obj_t
																															BgL_cdrzd211543zd2_2041;
																														BgL_cdrzd211543zd2_2041
																															=
																															CDR(BgL_ez00_69);
																														if ((CAR
																																(BgL_ez00_69) ==
																																BGl_symbol3273z00zz__evaluatez00))
																															{	/* Eval/evaluate.scm 424 */
																																if (PAIRP
																																	(BgL_cdrzd211543zd2_2041))
																																	{	/* Eval/evaluate.scm 424 */
																																		obj_t
																																			BgL_arg2005z00_2045;
																																		obj_t
																																			BgL_arg2006z00_2046;
																																		BgL_arg2005z00_2045
																																			=
																																			CAR
																																			(BgL_cdrzd211543zd2_2041);
																																		BgL_arg2006z00_2046
																																			=
																																			CDR
																																			(BgL_cdrzd211543zd2_2041);
																																		{
																																			BgL_ev_letrecz00_bglt
																																				BgL_auxz00_7039;
																																			{
																																				obj_t
																																					BgL_bodyz00_7041;
																																				obj_t
																																					BgL_bindsz00_7040;
																																				BgL_bindsz00_7040
																																					=
																																					BgL_arg2005z00_2045;
																																				BgL_bodyz00_7041
																																					=
																																					BgL_arg2006z00_2046;
																																				BgL_bodyz00_1495
																																					=
																																					BgL_bodyz00_7041;
																																				BgL_bindsz00_1494
																																					=
																																					BgL_bindsz00_7040;
																																				goto
																																					BgL_tagzd2162zd2_1496;
																																			}
																																			return
																																				((obj_t)
																																				BgL_auxz00_7039);
																																		}
																																	}
																																else
																																	{	/* Eval/evaluate.scm 424 */
																																		obj_t
																																			BgL_arg2008z00_2047;
																																		BgL_arg2008z00_2047
																																			=
																																			CAR
																																			(BgL_ez00_69);
																																		{
																																			BgL_ev_appz00_bglt
																																				BgL_auxz00_7044;
																																			{
																																				obj_t
																																					BgL_argsz00_7046;
																																				obj_t
																																					BgL_fz00_7045;
																																				BgL_fz00_7045
																																					=
																																					BgL_arg2008z00_2047;
																																				BgL_argsz00_7046
																																					=
																																					BgL_cdrzd211543zd2_2041;
																																				BgL_argsz00_1535
																																					=
																																					BgL_argsz00_7046;
																																				BgL_fz00_1534
																																					=
																																					BgL_fz00_7045;
																																				goto
																																					BgL_tagzd2175zd2_1536;
																																			}
																																			return
																																				((obj_t)
																																				BgL_auxz00_7044);
																																		}
																																	}
																															}
																														else
																															{	/* Eval/evaluate.scm 424 */
																																if (
																																	(CAR
																																		(BgL_ez00_69)
																																		==
																																		BGl_symbol3275z00zz__evaluatez00))
																																	{	/* Eval/evaluate.scm 424 */
																																		if (PAIRP
																																			(BgL_cdrzd211543zd2_2041))
																																			{	/* Eval/evaluate.scm 424 */
																																				obj_t
																																					BgL_carzd211717zd2_2053;
																																				obj_t
																																					BgL_cdrzd211718zd2_2054;
																																				BgL_carzd211717zd2_2053
																																					=
																																					CAR
																																					(BgL_cdrzd211543zd2_2041);
																																				BgL_cdrzd211718zd2_2054
																																					=
																																					CDR
																																					(BgL_cdrzd211543zd2_2041);
																																				if (PAIRP(BgL_carzd211717zd2_2053))
																																					{	/* Eval/evaluate.scm 424 */
																																						obj_t
																																							BgL_cdrzd211722zd2_2056;
																																						BgL_cdrzd211722zd2_2056
																																							=
																																							CDR
																																							(BgL_carzd211717zd2_2053);
																																						if (
																																							(CAR
																																								(BgL_carzd211717zd2_2053)
																																								==
																																								BGl_symbol3261z00zz__evaluatez00))
																																							{	/* Eval/evaluate.scm 424 */
																																								if (PAIRP(BgL_cdrzd211722zd2_2056))
																																									{	/* Eval/evaluate.scm 424 */
																																										obj_t
																																											BgL_carzd211725zd2_2060;
																																										obj_t
																																											BgL_cdrzd211726zd2_2061;
																																										BgL_carzd211725zd2_2060
																																											=
																																											CAR
																																											(BgL_cdrzd211722zd2_2056);
																																										BgL_cdrzd211726zd2_2061
																																											=
																																											CDR
																																											(BgL_cdrzd211722zd2_2056);
																																										if (SYMBOLP(BgL_carzd211725zd2_2060))
																																											{	/* Eval/evaluate.scm 424 */
																																												if (PAIRP(BgL_cdrzd211726zd2_2061))
																																													{	/* Eval/evaluate.scm 424 */
																																														obj_t
																																															BgL_carzd211730zd2_2064;
																																														BgL_carzd211730zd2_2064
																																															=
																																															CAR
																																															(BgL_cdrzd211726zd2_2061);
																																														if (SYMBOLP(BgL_carzd211730zd2_2064))
																																															{	/* Eval/evaluate.scm 424 */
																																																if (NULLP(CDR(BgL_cdrzd211726zd2_2061)))
																																																	{	/* Eval/evaluate.scm 424 */
																																																		if (PAIRP(BgL_cdrzd211718zd2_2054))
																																																			{	/* Eval/evaluate.scm 424 */
																																																				if (NULLP(CDR(BgL_cdrzd211718zd2_2054)))
																																																					{	/* Eval/evaluate.scm 424 */
																																																						obj_t
																																																							BgL_arg2025z00_2071;
																																																						BgL_arg2025z00_2071
																																																							=
																																																							CAR
																																																							(BgL_cdrzd211718zd2_2054);
																																																						{	/* Eval/evaluate.scm 531 */
																																																							BgL_ev_setglobalz00_bglt
																																																								BgL_new1138z00_4430;
																																																							{	/* Eval/evaluate.scm 535 */
																																																								BgL_ev_setglobalz00_bglt
																																																									BgL_new1137z00_4431;
																																																								BgL_new1137z00_4431
																																																									=
																																																									(
																																																									(BgL_ev_setglobalz00_bglt)
																																																									BOBJECT
																																																									(GC_MALLOC
																																																										(sizeof
																																																											(struct
																																																												BgL_ev_setglobalz00_bgl))));
																																																								{	/* Eval/evaluate.scm 535 */
																																																									long
																																																										BgL_arg2347z00_4432;
																																																									{	/* Eval/evaluate.scm 535 */
																																																										long
																																																											BgL_res3066z00_4434;
																																																										BgL_res3066z00_4434
																																																											=
																																																											BGL_CLASS_INDEX
																																																											(BGl_ev_setglobalz00zz__evaluate_typesz00);
																																																										BgL_arg2347z00_4432
																																																											=
																																																											BgL_res3066z00_4434;
																																																									}
																																																									BGL_OBJECT_CLASS_NUM_SET
																																																										(
																																																										((BgL_objectz00_bglt) BgL_new1137z00_4431), BgL_arg2347z00_4432);
																																																								}
																																																								BgL_new1138z00_4430
																																																									=
																																																									BgL_new1137z00_4431;
																																																							}
																																																							{
																																																								BgL_ev_exprz00_bglt
																																																									BgL_auxz00_7085;
																																																								{	/* Eval/evaluate.scm 380 */
																																																									obj_t
																																																										BgL_arg2395z00_4437;
																																																									BgL_arg2395z00_4437
																																																										=
																																																										BGl_getzd2locationzd2zz__evaluatez00
																																																										(BgL_arg2025z00_2071,
																																																										BgL_locz00_74);
																																																									BgL_auxz00_7085
																																																										=
																																																										(
																																																										(BgL_ev_exprz00_bglt)
																																																										BGl_uconvzf2locze70z15zz__evaluatez00
																																																										(BgL_wherez00_73,
																																																											BgL_globalsz00_71,
																																																											BgL_localsz00_70,
																																																											BgL_arg2025z00_2071,
																																																											BgL_arg2395z00_4437));
																																																								}
																																																								((((BgL_ev_hookz00_bglt) COBJECT(((BgL_ev_hookz00_bglt) BgL_new1138z00_4430)))->BgL_ez00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_7085), BUNSPEC);
																																																							}
																																																							((((BgL_ev_setglobalz00_bglt) COBJECT(BgL_new1138z00_4430))->BgL_locz00) = ((obj_t) BgL_locz00_74), BUNSPEC);
																																																							((((BgL_ev_setglobalz00_bglt) COBJECT(BgL_new1138z00_4430))->BgL_namez00) = ((obj_t) BgL_carzd211725zd2_2060), BUNSPEC);
																																																							((((BgL_ev_setglobalz00_bglt) COBJECT(BgL_new1138z00_4430))->BgL_modz00) = ((obj_t) BGl_evalzd2findzd2modulez00zz__evmodulez00(BgL_carzd211730zd2_2064)), BUNSPEC);
																																																							return
																																																								(
																																																								(obj_t)
																																																								BgL_new1138z00_4430);
																																																						}
																																																					}
																																																				else
																																																					{	/* Eval/evaluate.scm 424 */
																																																						return
																																																							BGl_evcompilezd2errorzd2zz__evcompilez00
																																																							(BgL_locz00_74,
																																																							BGl_string3178z00zz__evaluatez00,
																																																							BGl_string3253z00zz__evaluatez00,
																																																							BgL_ez00_69);
																																																					}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 424 */
																																																				return
																																																					BGl_evcompilezd2errorzd2zz__evcompilez00
																																																					(BgL_locz00_74,
																																																					BGl_string3178z00zz__evaluatez00,
																																																					BGl_string3253z00zz__evaluatez00,
																																																					BgL_ez00_69);
																																																			}
																																																	}
																																																else
																																																	{	/* Eval/evaluate.scm 424 */
																																																		obj_t
																																																			BgL_cdrzd211846zd2_2073;
																																																		BgL_cdrzd211846zd2_2073
																																																			=
																																																			CDR
																																																			(BgL_ez00_69);
																																																		{	/* Eval/evaluate.scm 424 */
																																																			obj_t
																																																				BgL_cdrzd211850zd2_2074;
																																																			BgL_cdrzd211850zd2_2074
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd211846zd2_2073));
																																																			if (PAIRP(BgL_cdrzd211850zd2_2074))
																																																				{	/* Eval/evaluate.scm 424 */
																																																					if (NULLP(CDR(BgL_cdrzd211850zd2_2074)))
																																																						{	/* Eval/evaluate.scm 424 */
																																																							obj_t
																																																								BgL_arg2030z00_2078;
																																																							obj_t
																																																								BgL_arg2031z00_2079;
																																																							BgL_arg2030z00_2078
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd211846zd2_2073));
																																																							BgL_arg2031z00_2079
																																																								=
																																																								CAR
																																																								(BgL_cdrzd211850zd2_2074);
																																																							{
																																																								BgL_ev_hookz00_bglt
																																																									BgL_auxz00_7109;
																																																								{
																																																									obj_t
																																																										BgL_ez00_7111;
																																																									obj_t
																																																										BgL_vz00_7110;
																																																									BgL_vz00_7110
																																																										=
																																																										BgL_arg2030z00_2078;
																																																									BgL_ez00_7111
																																																										=
																																																										BgL_arg2031z00_2079;
																																																									BgL_ez00_1505
																																																										=
																																																										BgL_ez00_7111;
																																																									BgL_vz00_1504
																																																										=
																																																										BgL_vz00_7110;
																																																									goto
																																																										BgL_tagzd2165zd2_1506;
																																																								}
																																																								return
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_7109);
																																																							}
																																																						}
																																																					else
																																																						{	/* Eval/evaluate.scm 424 */
																																																							return
																																																								BGl_evcompilezd2errorzd2zz__evcompilez00
																																																								(BgL_locz00_74,
																																																								BGl_string3178z00zz__evaluatez00,
																																																								BGl_string3253z00zz__evaluatez00,
																																																								BgL_ez00_69);
																																																						}
																																																				}
																																																			else
																																																				{	/* Eval/evaluate.scm 424 */
																																																					return
																																																						BGl_evcompilezd2errorzd2zz__evcompilez00
																																																						(BgL_locz00_74,
																																																						BGl_string3178z00zz__evaluatez00,
																																																						BGl_string3253z00zz__evaluatez00,
																																																						BgL_ez00_69);
																																																				}
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 424 */
																																																obj_t
																																																	BgL_cdrzd211907zd2_2082;
																																																BgL_cdrzd211907zd2_2082
																																																	=
																																																	CDR
																																																	(BgL_ez00_69);
																																																{	/* Eval/evaluate.scm 424 */
																																																	obj_t
																																																		BgL_cdrzd211911zd2_2083;
																																																	BgL_cdrzd211911zd2_2083
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd211907zd2_2082));
																																																	if (PAIRP(BgL_cdrzd211911zd2_2083))
																																																		{	/* Eval/evaluate.scm 424 */
																																																			if (NULLP(CDR(BgL_cdrzd211911zd2_2083)))
																																																				{	/* Eval/evaluate.scm 424 */
																																																					obj_t
																																																						BgL_arg2038z00_2087;
																																																					obj_t
																																																						BgL_arg2039z00_2088;
																																																					BgL_arg2038z00_2087
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd211907zd2_2082));
																																																					BgL_arg2039z00_2088
																																																						=
																																																						CAR
																																																						(BgL_cdrzd211911zd2_2083);
																																																					{
																																																						BgL_ev_hookz00_bglt
																																																							BgL_auxz00_7126;
																																																						{
																																																							obj_t
																																																								BgL_ez00_7128;
																																																							obj_t
																																																								BgL_vz00_7127;
																																																							BgL_vz00_7127
																																																								=
																																																								BgL_arg2038z00_2087;
																																																							BgL_ez00_7128
																																																								=
																																																								BgL_arg2039z00_2088;
																																																							BgL_ez00_1505
																																																								=
																																																								BgL_ez00_7128;
																																																							BgL_vz00_1504
																																																								=
																																																								BgL_vz00_7127;
																																																							goto
																																																								BgL_tagzd2165zd2_1506;
																																																						}
																																																						return
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_7126);
																																																					}
																																																				}
																																																			else
																																																				{	/* Eval/evaluate.scm 424 */
																																																					return
																																																						BGl_evcompilezd2errorzd2zz__evcompilez00
																																																						(BgL_locz00_74,
																																																						BGl_string3178z00zz__evaluatez00,
																																																						BGl_string3253z00zz__evaluatez00,
																																																						BgL_ez00_69);
																																																				}
																																																		}
																																																	else
																																																		{	/* Eval/evaluate.scm 424 */
																																																			return
																																																				BGl_evcompilezd2errorzd2zz__evcompilez00
																																																				(BgL_locz00_74,
																																																				BGl_string3178z00zz__evaluatez00,
																																																				BGl_string3253z00zz__evaluatez00,
																																																				BgL_ez00_69);
																																																		}
																																																}
																																															}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 424 */
																																														obj_t
																																															BgL_cdrzd211968zd2_2090;
																																														BgL_cdrzd211968zd2_2090
																																															=
																																															CDR
																																															(BgL_ez00_69);
																																														{	/* Eval/evaluate.scm 424 */
																																															obj_t
																																																BgL_cdrzd211972zd2_2091;
																																															BgL_cdrzd211972zd2_2091
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd211968zd2_2090));
																																															if (PAIRP(BgL_cdrzd211972zd2_2091))
																																																{	/* Eval/evaluate.scm 424 */
																																																	if (NULLP(CDR(BgL_cdrzd211972zd2_2091)))
																																																		{	/* Eval/evaluate.scm 424 */
																																																			obj_t
																																																				BgL_arg2044z00_2095;
																																																			obj_t
																																																				BgL_arg2045z00_2096;
																																																			BgL_arg2044z00_2095
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd211968zd2_2090));
																																																			BgL_arg2045z00_2096
																																																				=
																																																				CAR
																																																				(BgL_cdrzd211972zd2_2091);
																																																			{
																																																				BgL_ev_hookz00_bglt
																																																					BgL_auxz00_7143;
																																																				{
																																																					obj_t
																																																						BgL_ez00_7145;
																																																					obj_t
																																																						BgL_vz00_7144;
																																																					BgL_vz00_7144
																																																						=
																																																						BgL_arg2044z00_2095;
																																																					BgL_ez00_7145
																																																						=
																																																						BgL_arg2045z00_2096;
																																																					BgL_ez00_1505
																																																						=
																																																						BgL_ez00_7145;
																																																					BgL_vz00_1504
																																																						=
																																																						BgL_vz00_7144;
																																																					goto
																																																						BgL_tagzd2165zd2_1506;
																																																				}
																																																				return
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_7143);
																																																			}
																																																		}
																																																	else
																																																		{	/* Eval/evaluate.scm 424 */
																																																			return
																																																				BGl_evcompilezd2errorzd2zz__evcompilez00
																																																				(BgL_locz00_74,
																																																				BGl_string3178z00zz__evaluatez00,
																																																				BGl_string3253z00zz__evaluatez00,
																																																				BgL_ez00_69);
																																																		}
																																																}
																																															else
																																																{	/* Eval/evaluate.scm 424 */
																																																	return
																																																		BGl_evcompilezd2errorzd2zz__evcompilez00
																																																		(BgL_locz00_74,
																																																		BGl_string3178z00zz__evaluatez00,
																																																		BGl_string3253z00zz__evaluatez00,
																																																		BgL_ez00_69);
																																																}
																																														}
																																													}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 424 */
																																												obj_t
																																													BgL_cdrzd212029zd2_2098;
																																												BgL_cdrzd212029zd2_2098
																																													=
																																													CDR
																																													(BgL_ez00_69);
																																												{	/* Eval/evaluate.scm 424 */
																																													obj_t
																																														BgL_cdrzd212033zd2_2099;
																																													BgL_cdrzd212033zd2_2099
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_cdrzd212029zd2_2098));
																																													if (PAIRP(BgL_cdrzd212033zd2_2099))
																																														{	/* Eval/evaluate.scm 424 */
																																															if (NULLP(CDR(BgL_cdrzd212033zd2_2099)))
																																																{	/* Eval/evaluate.scm 424 */
																																																	obj_t
																																																		BgL_arg2050z00_2103;
																																																	obj_t
																																																		BgL_arg2051z00_2104;
																																																	BgL_arg2050z00_2103
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd212029zd2_2098));
																																																	BgL_arg2051z00_2104
																																																		=
																																																		CAR
																																																		(BgL_cdrzd212033zd2_2099);
																																																	{
																																																		BgL_ev_hookz00_bglt
																																																			BgL_auxz00_7160;
																																																		{
																																																			obj_t
																																																				BgL_ez00_7162;
																																																			obj_t
																																																				BgL_vz00_7161;
																																																			BgL_vz00_7161
																																																				=
																																																				BgL_arg2050z00_2103;
																																																			BgL_ez00_7162
																																																				=
																																																				BgL_arg2051z00_2104;
																																																			BgL_ez00_1505
																																																				=
																																																				BgL_ez00_7162;
																																																			BgL_vz00_1504
																																																				=
																																																				BgL_vz00_7161;
																																																			goto
																																																				BgL_tagzd2165zd2_1506;
																																																		}
																																																		return
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_7160);
																																																	}
																																																}
																																															else
																																																{	/* Eval/evaluate.scm 424 */
																																																	return
																																																		BGl_evcompilezd2errorzd2zz__evcompilez00
																																																		(BgL_locz00_74,
																																																		BGl_string3178z00zz__evaluatez00,
																																																		BGl_string3253z00zz__evaluatez00,
																																																		BgL_ez00_69);
																																																}
																																														}
																																													else
																																														{	/* Eval/evaluate.scm 424 */
																																															return
																																																BGl_evcompilezd2errorzd2zz__evcompilez00
																																																(BgL_locz00_74,
																																																BGl_string3178z00zz__evaluatez00,
																																																BGl_string3253z00zz__evaluatez00,
																																																BgL_ez00_69);
																																														}
																																												}
																																											}
																																									}
																																								else
																																									{	/* Eval/evaluate.scm 424 */
																																										obj_t
																																											BgL_cdrzd212090zd2_2106;
																																										BgL_cdrzd212090zd2_2106
																																											=
																																											CDR
																																											(BgL_ez00_69);
																																										{	/* Eval/evaluate.scm 424 */
																																											obj_t
																																												BgL_cdrzd212094zd2_2107;
																																											BgL_cdrzd212094zd2_2107
																																												=
																																												CDR
																																												(
																																												((obj_t) BgL_cdrzd212090zd2_2106));
																																											if (PAIRP(BgL_cdrzd212094zd2_2107))
																																												{	/* Eval/evaluate.scm 424 */
																																													if (NULLP(CDR(BgL_cdrzd212094zd2_2107)))
																																														{	/* Eval/evaluate.scm 424 */
																																															obj_t
																																																BgL_arg2056z00_2111;
																																															obj_t
																																																BgL_arg2057z00_2112;
																																															BgL_arg2056z00_2111
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd212090zd2_2106));
																																															BgL_arg2057z00_2112
																																																=
																																																CAR
																																																(BgL_cdrzd212094zd2_2107);
																																															{
																																																BgL_ev_hookz00_bglt
																																																	BgL_auxz00_7177;
																																																{
																																																	obj_t
																																																		BgL_ez00_7179;
																																																	obj_t
																																																		BgL_vz00_7178;
																																																	BgL_vz00_7178
																																																		=
																																																		BgL_arg2056z00_2111;
																																																	BgL_ez00_7179
																																																		=
																																																		BgL_arg2057z00_2112;
																																																	BgL_ez00_1505
																																																		=
																																																		BgL_ez00_7179;
																																																	BgL_vz00_1504
																																																		=
																																																		BgL_vz00_7178;
																																																	goto
																																																		BgL_tagzd2165zd2_1506;
																																																}
																																																return
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_7177);
																																															}
																																														}
																																													else
																																														{	/* Eval/evaluate.scm 424 */
																																															return
																																																BGl_evcompilezd2errorzd2zz__evcompilez00
																																																(BgL_locz00_74,
																																																BGl_string3178z00zz__evaluatez00,
																																																BGl_string3253z00zz__evaluatez00,
																																																BgL_ez00_69);
																																														}
																																												}
																																											else
																																												{	/* Eval/evaluate.scm 424 */
																																													return
																																														BGl_evcompilezd2errorzd2zz__evcompilez00
																																														(BgL_locz00_74,
																																														BGl_string3178z00zz__evaluatez00,
																																														BGl_string3253z00zz__evaluatez00,
																																														BgL_ez00_69);
																																												}
																																										}
																																									}
																																							}
																																						else
																																							{	/* Eval/evaluate.scm 424 */
																																								obj_t
																																									BgL_cdrzd212138zd2_2114;
																																								BgL_cdrzd212138zd2_2114
																																									=
																																									CDR
																																									(BgL_ez00_69);
																																								{	/* Eval/evaluate.scm 424 */
																																									obj_t
																																										BgL_carzd212141zd2_2115;
																																									obj_t
																																										BgL_cdrzd212142zd2_2116;
																																									BgL_carzd212141zd2_2115
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_cdrzd212138zd2_2114));
																																									BgL_cdrzd212142zd2_2116
																																										=
																																										CDR
																																										(
																																										((obj_t) BgL_cdrzd212138zd2_2114));
																																									if ((CAR(((obj_t) BgL_carzd212141zd2_2115)) == BGl_symbol3263z00zz__evaluatez00))
																																										{	/* Eval/evaluate.scm 424 */
																																											if (PAIRP(BgL_cdrzd212142zd2_2116))
																																												{	/* Eval/evaluate.scm 424 */
																																													if (NULLP(CDR(BgL_cdrzd212142zd2_2116)))
																																														{	/* Eval/evaluate.scm 424 */
																																															obj_t
																																																BgL_arg2064z00_2122;
																																															obj_t
																																																BgL_arg2065z00_2123;
																																															BgL_arg2064z00_2122
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_carzd212141zd2_2115));
																																															BgL_arg2065z00_2123
																																																=
																																																CAR
																																																(BgL_cdrzd212142zd2_2116);
																																															{
																																																obj_t
																																																	BgL_e2z00_7201;
																																																obj_t
																																																	BgL_lz00_7200;
																																																BgL_lz00_7200
																																																	=
																																																	BgL_arg2064z00_2122;
																																																BgL_e2z00_7201
																																																	=
																																																	BgL_arg2065z00_2123;
																																																BgL_e2z00_1502
																																																	=
																																																	BgL_e2z00_7201;
																																																BgL_lz00_1501
																																																	=
																																																	BgL_lz00_7200;
																																																goto
																																																	BgL_tagzd2164zd2_1503;
																																															}
																																														}
																																													else
																																														{	/* Eval/evaluate.scm 424 */
																																															return
																																																BGl_evcompilezd2errorzd2zz__evcompilez00
																																																(BgL_locz00_74,
																																																BGl_string3178z00zz__evaluatez00,
																																																BGl_string3253z00zz__evaluatez00,
																																																BgL_ez00_69);
																																														}
																																												}
																																											else
																																												{	/* Eval/evaluate.scm 424 */
																																													return
																																														BGl_evcompilezd2errorzd2zz__evcompilez00
																																														(BgL_locz00_74,
																																														BGl_string3178z00zz__evaluatez00,
																																														BGl_string3253z00zz__evaluatez00,
																																														BgL_ez00_69);
																																												}
																																										}
																																									else
																																										{	/* Eval/evaluate.scm 424 */
																																											obj_t
																																												BgL_cdrzd212218zd2_2126;
																																											BgL_cdrzd212218zd2_2126
																																												=
																																												CDR
																																												(
																																												((obj_t) BgL_cdrzd212138zd2_2114));
																																											if (PAIRP(BgL_cdrzd212218zd2_2126))
																																												{	/* Eval/evaluate.scm 424 */
																																													if (NULLP(CDR(BgL_cdrzd212218zd2_2126)))
																																														{	/* Eval/evaluate.scm 424 */
																																															obj_t
																																																BgL_arg2071z00_2130;
																																															obj_t
																																																BgL_arg2072z00_2131;
																																															BgL_arg2071z00_2130
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd212138zd2_2114));
																																															BgL_arg2072z00_2131
																																																=
																																																CAR
																																																(BgL_cdrzd212218zd2_2126);
																																															{
																																																BgL_ev_hookz00_bglt
																																																	BgL_auxz00_7214;
																																																{
																																																	obj_t
																																																		BgL_ez00_7216;
																																																	obj_t
																																																		BgL_vz00_7215;
																																																	BgL_vz00_7215
																																																		=
																																																		BgL_arg2071z00_2130;
																																																	BgL_ez00_7216
																																																		=
																																																		BgL_arg2072z00_2131;
																																																	BgL_ez00_1505
																																																		=
																																																		BgL_ez00_7216;
																																																	BgL_vz00_1504
																																																		=
																																																		BgL_vz00_7215;
																																																	goto
																																																		BgL_tagzd2165zd2_1506;
																																																}
																																																return
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_7214);
																																															}
																																														}
																																													else
																																														{	/* Eval/evaluate.scm 424 */
																																															return
																																																BGl_evcompilezd2errorzd2zz__evcompilez00
																																																(BgL_locz00_74,
																																																BGl_string3178z00zz__evaluatez00,
																																																BGl_string3253z00zz__evaluatez00,
																																																BgL_ez00_69);
																																														}
																																												}
																																											else
																																												{	/* Eval/evaluate.scm 424 */
																																													return
																																														BGl_evcompilezd2errorzd2zz__evcompilez00
																																														(BgL_locz00_74,
																																														BGl_string3178z00zz__evaluatez00,
																																														BGl_string3253z00zz__evaluatez00,
																																														BgL_ez00_69);
																																												}
																																										}
																																								}
																																							}
																																					}
																																				else
																																					{	/* Eval/evaluate.scm 424 */
																																						obj_t
																																							BgL_cdrzd212275zd2_2135;
																																						BgL_cdrzd212275zd2_2135
																																							=
																																							CDR
																																							(BgL_ez00_69);
																																						{	/* Eval/evaluate.scm 424 */
																																							obj_t
																																								BgL_cdrzd212279zd2_2136;
																																							BgL_cdrzd212279zd2_2136
																																								=
																																								CDR
																																								(
																																								((obj_t) BgL_cdrzd212275zd2_2135));
																																							if (PAIRP(BgL_cdrzd212279zd2_2136))
																																								{	/* Eval/evaluate.scm 424 */
																																									if (NULLP(CDR(BgL_cdrzd212279zd2_2136)))
																																										{	/* Eval/evaluate.scm 424 */
																																											obj_t
																																												BgL_arg2080z00_2140;
																																											obj_t
																																												BgL_arg2082z00_2141;
																																											BgL_arg2080z00_2140
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_cdrzd212275zd2_2135));
																																											BgL_arg2082z00_2141
																																												=
																																												CAR
																																												(BgL_cdrzd212279zd2_2136);
																																											{
																																												BgL_ev_hookz00_bglt
																																													BgL_auxz00_7231;
																																												{
																																													obj_t
																																														BgL_ez00_7233;
																																													obj_t
																																														BgL_vz00_7232;
																																													BgL_vz00_7232
																																														=
																																														BgL_arg2080z00_2140;
																																													BgL_ez00_7233
																																														=
																																														BgL_arg2082z00_2141;
																																													BgL_ez00_1505
																																														=
																																														BgL_ez00_7233;
																																													BgL_vz00_1504
																																														=
																																														BgL_vz00_7232;
																																													goto
																																														BgL_tagzd2165zd2_1506;
																																												}
																																												return
																																													(
																																													(obj_t)
																																													BgL_auxz00_7231);
																																											}
																																										}
																																									else
																																										{	/* Eval/evaluate.scm 424 */
																																											return
																																												BGl_evcompilezd2errorzd2zz__evcompilez00
																																												(BgL_locz00_74,
																																												BGl_string3178z00zz__evaluatez00,
																																												BGl_string3253z00zz__evaluatez00,
																																												BgL_ez00_69);
																																										}
																																								}
																																							else
																																								{	/* Eval/evaluate.scm 424 */
																																									return
																																										BGl_evcompilezd2errorzd2zz__evcompilez00
																																										(BgL_locz00_74,
																																										BGl_string3178z00zz__evaluatez00,
																																										BGl_string3253z00zz__evaluatez00,
																																										BgL_ez00_69);
																																								}
																																						}
																																					}
																																			}
																																		else
																																			{	/* Eval/evaluate.scm 424 */
																																				return
																																					BGl_evcompilezd2errorzd2zz__evcompilez00
																																					(BgL_locz00_74,
																																					BGl_string3178z00zz__evaluatez00,
																																					BGl_string3253z00zz__evaluatez00,
																																					BgL_ez00_69);
																																			}
																																	}
																																else
																																	{	/* Eval/evaluate.scm 424 */
																																		obj_t
																																			BgL_cdrzd212400zd2_2143;
																																		BgL_cdrzd212400zd2_2143
																																			=
																																			CDR
																																			(BgL_ez00_69);
																																		if ((CAR
																																				(BgL_ez00_69)
																																				==
																																				BGl_symbol3277z00zz__evaluatez00))
																																			{	/* Eval/evaluate.scm 424 */
																																				if (PAIRP(BgL_cdrzd212400zd2_2143))
																																					{	/* Eval/evaluate.scm 424 */
																																						obj_t
																																							BgL_cdrzd212405zd2_2147;
																																						BgL_cdrzd212405zd2_2147
																																							=
																																							CDR
																																							(BgL_cdrzd212400zd2_2143);
																																						if (PAIRP(BgL_cdrzd212405zd2_2147))
																																							{	/* Eval/evaluate.scm 424 */
																																								obj_t
																																									BgL_carzd212409zd2_2149;
																																								BgL_carzd212409zd2_2149
																																									=
																																									CAR
																																									(BgL_cdrzd212405zd2_2147);
																																								if (PAIRP(BgL_carzd212409zd2_2149))
																																									{	/* Eval/evaluate.scm 424 */
																																										obj_t
																																											BgL_cdrzd212414zd2_2151;
																																										BgL_cdrzd212414zd2_2151
																																											=
																																											CDR
																																											(BgL_carzd212409zd2_2149);
																																										if ((CAR(BgL_carzd212409zd2_2149) == BGl_symbol3242z00zz__evaluatez00))
																																											{	/* Eval/evaluate.scm 424 */
																																												if (PAIRP(BgL_cdrzd212414zd2_2151))
																																													{	/* Eval/evaluate.scm 424 */
																																														obj_t
																																															BgL_cdrzd212418zd2_2155;
																																														BgL_cdrzd212418zd2_2155
																																															=
																																															CDR
																																															(BgL_cdrzd212414zd2_2151);
																																														if (PAIRP(BgL_cdrzd212418zd2_2155))
																																															{	/* Eval/evaluate.scm 424 */
																																																if (NULLP(CDR(BgL_cdrzd212418zd2_2155)))
																																																	{	/* Eval/evaluate.scm 424 */
																																																		if (NULLP(CDR(BgL_cdrzd212405zd2_2147)))
																																																			{	/* Eval/evaluate.scm 424 */
																																																				obj_t
																																																					BgL_arg2098z00_2161;
																																																				obj_t
																																																					BgL_arg2099z00_2162;
																																																				obj_t
																																																					BgL_arg2100z00_2163;
																																																				BgL_arg2098z00_2161
																																																					=
																																																					CAR
																																																					(BgL_cdrzd212400zd2_2143);
																																																				BgL_arg2099z00_2162
																																																					=
																																																					CAR
																																																					(BgL_cdrzd212414zd2_2151);
																																																				BgL_arg2100z00_2163
																																																					=
																																																					CAR
																																																					(BgL_cdrzd212418zd2_2155);
																																																				{
																																																					BgL_ev_defglobalz00_bglt
																																																						BgL_auxz00_7268;
																																																					{
																																																						obj_t
																																																							BgL_bodyz00_7271;
																																																						obj_t
																																																							BgL_formalsz00_7270;
																																																						obj_t
																																																							BgL_gvz00_7269;
																																																						BgL_gvz00_7269
																																																							=
																																																							BgL_arg2098z00_2161;
																																																						BgL_formalsz00_7270
																																																							=
																																																							BgL_arg2099z00_2162;
																																																						BgL_bodyz00_7271
																																																							=
																																																							BgL_arg2100z00_2163;
																																																						BgL_bodyz00_1510
																																																							=
																																																							BgL_bodyz00_7271;
																																																						BgL_formalsz00_1509
																																																							=
																																																							BgL_formalsz00_7270;
																																																						BgL_gvz00_1508
																																																							=
																																																							BgL_gvz00_7269;
																																																						goto
																																																							BgL_tagzd2167zd2_1511;
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_7268);
																																																				}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 424 */
																																																				obj_t
																																																					BgL_arg2101z00_2164;
																																																				BgL_arg2101z00_2164
																																																					=
																																																					CAR
																																																					(BgL_ez00_69);
																																																				{
																																																					BgL_ev_appz00_bglt
																																																						BgL_auxz00_7274;
																																																					{
																																																						obj_t
																																																							BgL_argsz00_7276;
																																																						obj_t
																																																							BgL_fz00_7275;
																																																						BgL_fz00_7275
																																																							=
																																																							BgL_arg2101z00_2164;
																																																						BgL_argsz00_7276
																																																							=
																																																							BgL_cdrzd212400zd2_2143;
																																																						BgL_argsz00_1535
																																																							=
																																																							BgL_argsz00_7276;
																																																						BgL_fz00_1534
																																																							=
																																																							BgL_fz00_7275;
																																																						goto
																																																							BgL_tagzd2175zd2_1536;
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_7274);
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Eval/evaluate.scm 424 */
																																																		obj_t
																																																			BgL_cdrzd212518zd2_2168;
																																																		BgL_cdrzd212518zd2_2168
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_cdrzd212400zd2_2143));
																																																		if (NULLP(CDR(((obj_t) BgL_cdrzd212518zd2_2168))))
																																																			{	/* Eval/evaluate.scm 424 */
																																																				obj_t
																																																					BgL_arg2107z00_2171;
																																																				obj_t
																																																					BgL_arg2108z00_2172;
																																																				BgL_arg2107z00_2171
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_cdrzd212400zd2_2143));
																																																				BgL_arg2108z00_2172
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_cdrzd212518zd2_2168));
																																																				{
																																																					BgL_ev_defglobalz00_bglt
																																																						BgL_auxz00_7288;
																																																					{
																																																						obj_t
																																																							BgL_gez00_7290;
																																																						obj_t
																																																							BgL_gvz00_7289;
																																																						BgL_gvz00_7289
																																																							=
																																																							BgL_arg2107z00_2171;
																																																						BgL_gez00_7290
																																																							=
																																																							BgL_arg2108z00_2172;
																																																						BgL_gez00_1513
																																																							=
																																																							BgL_gez00_7290;
																																																						BgL_gvz00_1512
																																																							=
																																																							BgL_gvz00_7289;
																																																						goto
																																																							BgL_tagzd2168zd2_1514;
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_7288);
																																																				}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 424 */
																																																				obj_t
																																																					BgL_arg2109z00_2173;
																																																				obj_t
																																																					BgL_arg2110z00_2174;
																																																				BgL_arg2109z00_2173
																																																					=
																																																					CAR
																																																					(BgL_ez00_69);
																																																				BgL_arg2110z00_2174
																																																					=
																																																					CDR
																																																					(BgL_ez00_69);
																																																				{
																																																					BgL_ev_appz00_bglt
																																																						BgL_auxz00_7294;
																																																					{
																																																						obj_t
																																																							BgL_argsz00_7296;
																																																						obj_t
																																																							BgL_fz00_7295;
																																																						BgL_fz00_7295
																																																							=
																																																							BgL_arg2109z00_2173;
																																																						BgL_argsz00_7296
																																																							=
																																																							BgL_arg2110z00_2174;
																																																						BgL_argsz00_1535
																																																							=
																																																							BgL_argsz00_7296;
																																																						BgL_fz00_1534
																																																							=
																																																							BgL_fz00_7295;
																																																						goto
																																																							BgL_tagzd2175zd2_1536;
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_7294);
																																																				}
																																																			}
																																																	}
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 424 */
																																																obj_t
																																																	BgL_cdrzd212605zd2_2178;
																																																BgL_cdrzd212605zd2_2178
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_cdrzd212400zd2_2143));
																																																if (NULLP(CDR(((obj_t) BgL_cdrzd212605zd2_2178))))
																																																	{	/* Eval/evaluate.scm 424 */
																																																		obj_t
																																																			BgL_arg2115z00_2181;
																																																		obj_t
																																																			BgL_arg2116z00_2182;
																																																		BgL_arg2115z00_2181
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_cdrzd212400zd2_2143));
																																																		BgL_arg2116z00_2182
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_cdrzd212605zd2_2178));
																																																		{
																																																			BgL_ev_defglobalz00_bglt
																																																				BgL_auxz00_7308;
																																																			{
																																																				obj_t
																																																					BgL_gez00_7310;
																																																				obj_t
																																																					BgL_gvz00_7309;
																																																				BgL_gvz00_7309
																																																					=
																																																					BgL_arg2115z00_2181;
																																																				BgL_gez00_7310
																																																					=
																																																					BgL_arg2116z00_2182;
																																																				BgL_gez00_1513
																																																					=
																																																					BgL_gez00_7310;
																																																				BgL_gvz00_1512
																																																					=
																																																					BgL_gvz00_7309;
																																																				goto
																																																					BgL_tagzd2168zd2_1514;
																																																			}
																																																			return
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_7308);
																																																		}
																																																	}
																																																else
																																																	{	/* Eval/evaluate.scm 424 */
																																																		obj_t
																																																			BgL_arg2117z00_2183;
																																																		obj_t
																																																			BgL_arg2118z00_2184;
																																																		BgL_arg2117z00_2183
																																																			=
																																																			CAR
																																																			(BgL_ez00_69);
																																																		BgL_arg2118z00_2184
																																																			=
																																																			CDR
																																																			(BgL_ez00_69);
																																																		{
																																																			BgL_ev_appz00_bglt
																																																				BgL_auxz00_7314;
																																																			{
																																																				obj_t
																																																					BgL_argsz00_7316;
																																																				obj_t
																																																					BgL_fz00_7315;
																																																				BgL_fz00_7315
																																																					=
																																																					BgL_arg2117z00_2183;
																																																				BgL_argsz00_7316
																																																					=
																																																					BgL_arg2118z00_2184;
																																																				BgL_argsz00_1535
																																																					=
																																																					BgL_argsz00_7316;
																																																				BgL_fz00_1534
																																																					=
																																																					BgL_fz00_7315;
																																																				goto
																																																					BgL_tagzd2175zd2_1536;
																																																			}
																																																			return
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_7314);
																																																		}
																																																	}
																																															}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 424 */
																																														obj_t
																																															BgL_cdrzd212692zd2_2187;
																																														BgL_cdrzd212692zd2_2187
																																															=
																																															CDR
																																															(
																																															((obj_t) BgL_cdrzd212400zd2_2143));
																																														if (NULLP(CDR(((obj_t) BgL_cdrzd212692zd2_2187))))
																																															{	/* Eval/evaluate.scm 424 */
																																																obj_t
																																																	BgL_arg2122z00_2190;
																																																obj_t
																																																	BgL_arg2123z00_2191;
																																																BgL_arg2122z00_2190
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_cdrzd212400zd2_2143));
																																																BgL_arg2123z00_2191
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_cdrzd212692zd2_2187));
																																																{
																																																	BgL_ev_defglobalz00_bglt
																																																		BgL_auxz00_7328;
																																																	{
																																																		obj_t
																																																			BgL_gez00_7330;
																																																		obj_t
																																																			BgL_gvz00_7329;
																																																		BgL_gvz00_7329
																																																			=
																																																			BgL_arg2122z00_2190;
																																																		BgL_gez00_7330
																																																			=
																																																			BgL_arg2123z00_2191;
																																																		BgL_gez00_1513
																																																			=
																																																			BgL_gez00_7330;
																																																		BgL_gvz00_1512
																																																			=
																																																			BgL_gvz00_7329;
																																																		goto
																																																			BgL_tagzd2168zd2_1514;
																																																	}
																																																	return
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_7328);
																																																}
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 424 */
																																																obj_t
																																																	BgL_arg2124z00_2192;
																																																obj_t
																																																	BgL_arg2125z00_2193;
																																																BgL_arg2124z00_2192
																																																	=
																																																	CAR
																																																	(BgL_ez00_69);
																																																BgL_arg2125z00_2193
																																																	=
																																																	CDR
																																																	(BgL_ez00_69);
																																																{
																																																	BgL_ev_appz00_bglt
																																																		BgL_auxz00_7334;
																																																	{
																																																		obj_t
																																																			BgL_argsz00_7336;
																																																		obj_t
																																																			BgL_fz00_7335;
																																																		BgL_fz00_7335
																																																			=
																																																			BgL_arg2124z00_2192;
																																																		BgL_argsz00_7336
																																																			=
																																																			BgL_arg2125z00_2193;
																																																		BgL_argsz00_1535
																																																			=
																																																			BgL_argsz00_7336;
																																																		BgL_fz00_1534
																																																			=
																																																			BgL_fz00_7335;
																																																		goto
																																																			BgL_tagzd2175zd2_1536;
																																																	}
																																																	return
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_7334);
																																																}
																																															}
																																													}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 424 */
																																												obj_t
																																													BgL_cdrzd212779zd2_2196;
																																												BgL_cdrzd212779zd2_2196
																																													=
																																													CDR
																																													(
																																													((obj_t) BgL_cdrzd212400zd2_2143));
																																												if (NULLP(CDR(((obj_t) BgL_cdrzd212779zd2_2196))))
																																													{	/* Eval/evaluate.scm 424 */
																																														obj_t
																																															BgL_arg2130z00_2199;
																																														obj_t
																																															BgL_arg2132z00_2200;
																																														BgL_arg2130z00_2199
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_cdrzd212400zd2_2143));
																																														BgL_arg2132z00_2200
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_cdrzd212779zd2_2196));
																																														{
																																															BgL_ev_defglobalz00_bglt
																																																BgL_auxz00_7348;
																																															{
																																																obj_t
																																																	BgL_gez00_7350;
																																																obj_t
																																																	BgL_gvz00_7349;
																																																BgL_gvz00_7349
																																																	=
																																																	BgL_arg2130z00_2199;
																																																BgL_gez00_7350
																																																	=
																																																	BgL_arg2132z00_2200;
																																																BgL_gez00_1513
																																																	=
																																																	BgL_gez00_7350;
																																																BgL_gvz00_1512
																																																	=
																																																	BgL_gvz00_7349;
																																																goto
																																																	BgL_tagzd2168zd2_1514;
																																															}
																																															return
																																																(
																																																(obj_t)
																																																BgL_auxz00_7348);
																																														}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 424 */
																																														obj_t
																																															BgL_arg2133z00_2201;
																																														obj_t
																																															BgL_arg2134z00_2202;
																																														BgL_arg2133z00_2201
																																															=
																																															CAR
																																															(BgL_ez00_69);
																																														BgL_arg2134z00_2202
																																															=
																																															CDR
																																															(BgL_ez00_69);
																																														{
																																															BgL_ev_appz00_bglt
																																																BgL_auxz00_7354;
																																															{
																																																obj_t
																																																	BgL_argsz00_7356;
																																																obj_t
																																																	BgL_fz00_7355;
																																																BgL_fz00_7355
																																																	=
																																																	BgL_arg2133z00_2201;
																																																BgL_argsz00_7356
																																																	=
																																																	BgL_arg2134z00_2202;
																																																BgL_argsz00_1535
																																																	=
																																																	BgL_argsz00_7356;
																																																BgL_fz00_1534
																																																	=
																																																	BgL_fz00_7355;
																																																goto
																																																	BgL_tagzd2175zd2_1536;
																																															}
																																															return
																																																(
																																																(obj_t)
																																																BgL_auxz00_7354);
																																														}
																																													}
																																											}
																																									}
																																								else
																																									{	/* Eval/evaluate.scm 424 */
																																										obj_t
																																											BgL_cdrzd212866zd2_2206;
																																										BgL_cdrzd212866zd2_2206
																																											=
																																											CDR
																																											(
																																											((obj_t) BgL_cdrzd212400zd2_2143));
																																										if (NULLP(CDR(((obj_t) BgL_cdrzd212866zd2_2206))))
																																											{	/* Eval/evaluate.scm 424 */
																																												obj_t
																																													BgL_arg2139z00_2209;
																																												obj_t
																																													BgL_arg2140z00_2210;
																																												BgL_arg2139z00_2209
																																													=
																																													CAR
																																													(
																																													((obj_t) BgL_cdrzd212400zd2_2143));
																																												BgL_arg2140z00_2210
																																													=
																																													CAR
																																													(
																																													((obj_t) BgL_cdrzd212866zd2_2206));
																																												{
																																													BgL_ev_defglobalz00_bglt
																																														BgL_auxz00_7368;
																																													{
																																														obj_t
																																															BgL_gez00_7370;
																																														obj_t
																																															BgL_gvz00_7369;
																																														BgL_gvz00_7369
																																															=
																																															BgL_arg2139z00_2209;
																																														BgL_gez00_7370
																																															=
																																															BgL_arg2140z00_2210;
																																														BgL_gez00_1513
																																															=
																																															BgL_gez00_7370;
																																														BgL_gvz00_1512
																																															=
																																															BgL_gvz00_7369;
																																														goto
																																															BgL_tagzd2168zd2_1514;
																																													}
																																													return
																																														(
																																														(obj_t)
																																														BgL_auxz00_7368);
																																												}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 424 */
																																												obj_t
																																													BgL_arg2141z00_2211;
																																												obj_t
																																													BgL_arg2142z00_2212;
																																												BgL_arg2141z00_2211
																																													=
																																													CAR
																																													(BgL_ez00_69);
																																												BgL_arg2142z00_2212
																																													=
																																													CDR
																																													(BgL_ez00_69);
																																												{
																																													BgL_ev_appz00_bglt
																																														BgL_auxz00_7374;
																																													{
																																														obj_t
																																															BgL_argsz00_7376;
																																														obj_t
																																															BgL_fz00_7375;
																																														BgL_fz00_7375
																																															=
																																															BgL_arg2141z00_2211;
																																														BgL_argsz00_7376
																																															=
																																															BgL_arg2142z00_2212;
																																														BgL_argsz00_1535
																																															=
																																															BgL_argsz00_7376;
																																														BgL_fz00_1534
																																															=
																																															BgL_fz00_7375;
																																														goto
																																															BgL_tagzd2175zd2_1536;
																																													}
																																													return
																																														(
																																														(obj_t)
																																														BgL_auxz00_7374);
																																												}
																																											}
																																									}
																																							}
																																						else
																																							{	/* Eval/evaluate.scm 424 */
																																								obj_t
																																									BgL_arg2144z00_2214;
																																								BgL_arg2144z00_2214
																																									=
																																									CAR
																																									(BgL_ez00_69);
																																								{
																																									BgL_ev_appz00_bglt
																																										BgL_auxz00_7379;
																																									{
																																										obj_t
																																											BgL_argsz00_7381;
																																										obj_t
																																											BgL_fz00_7380;
																																										BgL_fz00_7380
																																											=
																																											BgL_arg2144z00_2214;
																																										BgL_argsz00_7381
																																											=
																																											BgL_cdrzd212400zd2_2143;
																																										BgL_argsz00_1535
																																											=
																																											BgL_argsz00_7381;
																																										BgL_fz00_1534
																																											=
																																											BgL_fz00_7380;
																																										goto
																																											BgL_tagzd2175zd2_1536;
																																									}
																																									return
																																										(
																																										(obj_t)
																																										BgL_auxz00_7379);
																																								}
																																							}
																																					}
																																				else
																																					{	/* Eval/evaluate.scm 424 */
																																						obj_t
																																							BgL_arg2146z00_2216;
																																						BgL_arg2146z00_2216
																																							=
																																							CAR
																																							(BgL_ez00_69);
																																						{
																																							BgL_ev_appz00_bglt
																																								BgL_auxz00_7384;
																																							{
																																								obj_t
																																									BgL_argsz00_7386;
																																								obj_t
																																									BgL_fz00_7385;
																																								BgL_fz00_7385
																																									=
																																									BgL_arg2146z00_2216;
																																								BgL_argsz00_7386
																																									=
																																									BgL_cdrzd212400zd2_2143;
																																								BgL_argsz00_1535
																																									=
																																									BgL_argsz00_7386;
																																								BgL_fz00_1534
																																									=
																																									BgL_fz00_7385;
																																								goto
																																									BgL_tagzd2175zd2_1536;
																																							}
																																							return
																																								(
																																								(obj_t)
																																								BgL_auxz00_7384);
																																						}
																																					}
																																			}
																																		else
																																			{	/* Eval/evaluate.scm 424 */
																																				if (
																																					(CAR
																																						(BgL_ez00_69)
																																						==
																																						BGl_symbol3279z00zz__evaluatez00))
																																					{	/* Eval/evaluate.scm 424 */
																																						if (PAIRP(BgL_cdrzd212400zd2_2143))
																																							{	/* Eval/evaluate.scm 424 */
																																								obj_t
																																									BgL_carzd213108zd2_2222;
																																								BgL_carzd213108zd2_2222
																																									=
																																									CAR
																																									(BgL_cdrzd212400zd2_2143);
																																								if (PAIRP(BgL_carzd213108zd2_2222))
																																									{	/* Eval/evaluate.scm 424 */
																																										if (NULLP(CDR(BgL_carzd213108zd2_2222)))
																																											{	/* Eval/evaluate.scm 424 */
																																												obj_t
																																													BgL_arg2154z00_2226;
																																												obj_t
																																													BgL_arg2155z00_2227;
																																												BgL_arg2154z00_2226
																																													=
																																													CAR
																																													(BgL_carzd213108zd2_2222);
																																												BgL_arg2155z00_2227
																																													=
																																													CDR
																																													(BgL_cdrzd212400zd2_2143);
																																												{
																																													BgL_ev_bindzd2exitzd2_bglt
																																														BgL_auxz00_7401;
																																													{
																																														obj_t
																																															BgL_bodyz00_7403;
																																														obj_t
																																															BgL_vz00_7402;
																																														BgL_vz00_7402
																																															=
																																															BgL_arg2154z00_2226;
																																														BgL_bodyz00_7403
																																															=
																																															BgL_arg2155z00_2227;
																																														BgL_bodyz00_1516
																																															=
																																															BgL_bodyz00_7403;
																																														BgL_vz00_1515
																																															=
																																															BgL_vz00_7402;
																																														goto
																																															BgL_tagzd2169zd2_1517;
																																													}
																																													return
																																														(
																																														(obj_t)
																																														BgL_auxz00_7401);
																																												}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 424 */
																																												obj_t
																																													BgL_arg2156z00_2228;
																																												obj_t
																																													BgL_arg2157z00_2229;
																																												BgL_arg2156z00_2228
																																													=
																																													CAR
																																													(BgL_ez00_69);
																																												BgL_arg2157z00_2229
																																													=
																																													CDR
																																													(BgL_ez00_69);
																																												{
																																													BgL_ev_appz00_bglt
																																														BgL_auxz00_7407;
																																													{
																																														obj_t
																																															BgL_argsz00_7409;
																																														obj_t
																																															BgL_fz00_7408;
																																														BgL_fz00_7408
																																															=
																																															BgL_arg2156z00_2228;
																																														BgL_argsz00_7409
																																															=
																																															BgL_arg2157z00_2229;
																																														BgL_argsz00_1535
																																															=
																																															BgL_argsz00_7409;
																																														BgL_fz00_1534
																																															=
																																															BgL_fz00_7408;
																																														goto
																																															BgL_tagzd2175zd2_1536;
																																													}
																																													return
																																														(
																																														(obj_t)
																																														BgL_auxz00_7407);
																																												}
																																											}
																																									}
																																								else
																																									{	/* Eval/evaluate.scm 424 */
																																										obj_t
																																											BgL_arg2159z00_2231;
																																										obj_t
																																											BgL_arg2160z00_2232;
																																										BgL_arg2159z00_2231
																																											=
																																											CAR
																																											(BgL_ez00_69);
																																										BgL_arg2160z00_2232
																																											=
																																											CDR
																																											(BgL_ez00_69);
																																										{
																																											BgL_ev_appz00_bglt
																																												BgL_auxz00_7413;
																																											{
																																												obj_t
																																													BgL_argsz00_7415;
																																												obj_t
																																													BgL_fz00_7414;
																																												BgL_fz00_7414
																																													=
																																													BgL_arg2159z00_2231;
																																												BgL_argsz00_7415
																																													=
																																													BgL_arg2160z00_2232;
																																												BgL_argsz00_1535
																																													=
																																													BgL_argsz00_7415;
																																												BgL_fz00_1534
																																													=
																																													BgL_fz00_7414;
																																												goto
																																													BgL_tagzd2175zd2_1536;
																																											}
																																											return
																																												(
																																												(obj_t)
																																												BgL_auxz00_7413);
																																										}
																																									}
																																							}
																																						else
																																							{	/* Eval/evaluate.scm 424 */
																																								obj_t
																																									BgL_arg2161z00_2233;
																																								obj_t
																																									BgL_arg2163z00_2234;
																																								BgL_arg2161z00_2233
																																									=
																																									CAR
																																									(BgL_ez00_69);
																																								BgL_arg2163z00_2234
																																									=
																																									CDR
																																									(BgL_ez00_69);
																																								{
																																									BgL_ev_appz00_bglt
																																										BgL_auxz00_7419;
																																									{
																																										obj_t
																																											BgL_argsz00_7421;
																																										obj_t
																																											BgL_fz00_7420;
																																										BgL_fz00_7420
																																											=
																																											BgL_arg2161z00_2233;
																																										BgL_argsz00_7421
																																											=
																																											BgL_arg2163z00_2234;
																																										BgL_argsz00_1535
																																											=
																																											BgL_argsz00_7421;
																																										BgL_fz00_1534
																																											=
																																											BgL_fz00_7420;
																																										goto
																																											BgL_tagzd2175zd2_1536;
																																									}
																																									return
																																										(
																																										(obj_t)
																																										BgL_auxz00_7419);
																																								}
																																							}
																																					}
																																				else
																																					{	/* Eval/evaluate.scm 424 */
																																						obj_t
																																							BgL_cdrzd213273zd2_2235;
																																						BgL_cdrzd213273zd2_2235
																																							=
																																							CDR
																																							(BgL_ez00_69);
																																						if (
																																							(CAR
																																								(BgL_ez00_69)
																																								==
																																								BGl_symbol3281z00zz__evaluatez00))
																																							{	/* Eval/evaluate.scm 424 */
																																								if (PAIRP(BgL_cdrzd213273zd2_2235))
																																									{	/* Eval/evaluate.scm 424 */
																																										obj_t
																																											BgL_arg2167z00_2239;
																																										obj_t
																																											BgL_arg2168z00_2240;
																																										BgL_arg2167z00_2239
																																											=
																																											CAR
																																											(BgL_cdrzd213273zd2_2235);
																																										BgL_arg2168z00_2240
																																											=
																																											CDR
																																											(BgL_cdrzd213273zd2_2235);
																																										{	/* Eval/evaluate.scm 575 */
																																											BgL_ev_unwindzd2protectzd2_bglt
																																												BgL_new1152z00_4581;
																																											{	/* Eval/evaluate.scm 576 */
																																												BgL_ev_unwindzd2protectzd2_bglt
																																													BgL_new1151z00_4582;
																																												BgL_new1151z00_4582
																																													=
																																													(
																																													(BgL_ev_unwindzd2protectzd2_bglt)
																																													BOBJECT
																																													(GC_MALLOC
																																														(sizeof
																																															(struct
																																																BgL_ev_unwindzd2protectzd2_bgl))));
																																												{	/* Eval/evaluate.scm 576 */
																																													long
																																														BgL_arg2378z00_4583;
																																													{	/* Eval/evaluate.scm 576 */
																																														long
																																															BgL_res3099z00_4585;
																																														BgL_res3099z00_4585
																																															=
																																															BGL_CLASS_INDEX
																																															(BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00);
																																														BgL_arg2378z00_4583
																																															=
																																															BgL_res3099z00_4585;
																																													}
																																													BGL_OBJECT_CLASS_NUM_SET
																																														(
																																														((BgL_objectz00_bglt) BgL_new1151z00_4582), BgL_arg2378z00_4583);
																																												}
																																												BgL_new1152z00_4581
																																													=
																																													BgL_new1151z00_4582;
																																											}
																																											{
																																												BgL_ev_exprz00_bglt
																																													BgL_auxz00_7435;
																																												{	/* Eval/evaluate.scm 380 */
																																													obj_t
																																														BgL_arg2395z00_4588;
																																													BgL_arg2395z00_4588
																																														=
																																														BGl_getzd2locationzd2zz__evaluatez00
																																														(BgL_arg2167z00_2239,
																																														BgL_locz00_74);
																																													BgL_auxz00_7435
																																														=
																																														(
																																														(BgL_ev_exprz00_bglt)
																																														BGl_uconvzf2locze70z15zz__evaluatez00
																																														(BgL_wherez00_73,
																																															BgL_globalsz00_71,
																																															BgL_localsz00_70,
																																															BgL_arg2167z00_2239,
																																															BgL_arg2395z00_4588));
																																												}
																																												((((BgL_ev_unwindzd2protectzd2_bglt) COBJECT(BgL_new1152z00_4581))->BgL_ez00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_7435), BUNSPEC);
																																											}
																																											((((BgL_ev_unwindzd2protectzd2_bglt) COBJECT(BgL_new1152z00_4581))->BgL_bodyz00) = ((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BGl_convzd2beginzd2zz__evaluatez00(BgL_arg2168z00_2240, BgL_localsz00_70, BgL_globalsz00_71, BFALSE, BgL_wherez00_73, BgL_locz00_74, ((bool_t) 0)))), BUNSPEC);
																																											return
																																												(
																																												(obj_t)
																																												BgL_new1152z00_4581);
																																										}
																																									}
																																								else
																																									{	/* Eval/evaluate.scm 424 */
																																										obj_t
																																											BgL_arg2169z00_2241;
																																										BgL_arg2169z00_2241
																																											=
																																											CAR
																																											(BgL_ez00_69);
																																										{
																																											BgL_ev_appz00_bglt
																																												BgL_auxz00_7445;
																																											{
																																												obj_t
																																													BgL_argsz00_7447;
																																												obj_t
																																													BgL_fz00_7446;
																																												BgL_fz00_7446
																																													=
																																													BgL_arg2169z00_2241;
																																												BgL_argsz00_7447
																																													=
																																													BgL_cdrzd213273zd2_2235;
																																												BgL_argsz00_1535
																																													=
																																													BgL_argsz00_7447;
																																												BgL_fz00_1534
																																													=
																																													BgL_fz00_7446;
																																												goto
																																													BgL_tagzd2175zd2_1536;
																																											}
																																											return
																																												(
																																												(obj_t)
																																												BgL_auxz00_7445);
																																										}
																																									}
																																							}
																																						else
																																							{	/* Eval/evaluate.scm 424 */
																																								if ((CAR(BgL_ez00_69) == BGl_symbol3283z00zz__evaluatez00))
																																									{	/* Eval/evaluate.scm 424 */
																																										if (PAIRP(BgL_cdrzd213273zd2_2235))
																																											{	/* Eval/evaluate.scm 424 */
																																												obj_t
																																													BgL_arg2174z00_2247;
																																												obj_t
																																													BgL_arg2175z00_2248;
																																												BgL_arg2174z00_2247
																																													=
																																													CAR
																																													(BgL_cdrzd213273zd2_2235);
																																												BgL_arg2175z00_2248
																																													=
																																													CDR
																																													(BgL_cdrzd213273zd2_2235);
																																												{	/* Eval/evaluate.scm 579 */
																																													BgL_ev_withzd2handlerzd2_bglt
																																														BgL_new1154z00_4596;
																																													{	/* Eval/evaluate.scm 580 */
																																														BgL_ev_withzd2handlerzd2_bglt
																																															BgL_new1153z00_4597;
																																														BgL_new1153z00_4597
																																															=
																																															(
																																															(BgL_ev_withzd2handlerzd2_bglt)
																																															BOBJECT
																																															(GC_MALLOC
																																																(sizeof
																																																	(struct
																																																		BgL_ev_withzd2handlerzd2_bgl))));
																																														{	/* Eval/evaluate.scm 580 */
																																															long
																																																BgL_arg2379z00_4598;
																																															{	/* Eval/evaluate.scm 580 */
																																																long
																																																	BgL_res3101z00_4600;
																																																BgL_res3101z00_4600
																																																	=
																																																	BGL_CLASS_INDEX
																																																	(BGl_ev_withzd2handlerzd2zz__evaluate_typesz00);
																																																BgL_arg2379z00_4598
																																																	=
																																																	BgL_res3101z00_4600;
																																															}
																																															BGL_OBJECT_CLASS_NUM_SET
																																																(
																																																((BgL_objectz00_bglt) BgL_new1153z00_4597), BgL_arg2379z00_4598);
																																														}
																																														BgL_new1154z00_4596
																																															=
																																															BgL_new1153z00_4597;
																																													}
																																													{
																																														BgL_ev_exprz00_bglt
																																															BgL_auxz00_7460;
																																														{	/* Eval/evaluate.scm 380 */
																																															obj_t
																																																BgL_arg2395z00_4603;
																																															BgL_arg2395z00_4603
																																																=
																																																BGl_getzd2locationzd2zz__evaluatez00
																																																(BgL_arg2174z00_2247,
																																																BgL_locz00_74);
																																															BgL_auxz00_7460
																																																=
																																																(
																																																(BgL_ev_exprz00_bglt)
																																																BGl_uconvzf2locze70z15zz__evaluatez00
																																																(BgL_wherez00_73,
																																																	BgL_globalsz00_71,
																																																	BgL_localsz00_70,
																																																	BgL_arg2174z00_2247,
																																																	BgL_arg2395z00_4603));
																																														}
																																														((((BgL_ev_withzd2handlerzd2_bglt) COBJECT(BgL_new1154z00_4596))->BgL_handlerz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_7460), BUNSPEC);
																																													}
																																													((((BgL_ev_withzd2handlerzd2_bglt) COBJECT(BgL_new1154z00_4596))->BgL_bodyz00) = ((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BGl_convzd2beginzd2zz__evaluatez00(BgL_arg2175z00_2248, BgL_localsz00_70, BgL_globalsz00_71, BFALSE, BgL_wherez00_73, BgL_locz00_74, ((bool_t) 0)))), BUNSPEC);
																																													return
																																														(
																																														(obj_t)
																																														BgL_new1154z00_4596);
																																												}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 424 */
																																												obj_t
																																													BgL_arg2176z00_2249;
																																												obj_t
																																													BgL_arg2177z00_2250;
																																												BgL_arg2176z00_2249
																																													=
																																													CAR
																																													(BgL_ez00_69);
																																												BgL_arg2177z00_2250
																																													=
																																													CDR
																																													(BgL_ez00_69);
																																												{
																																													BgL_ev_appz00_bglt
																																														BgL_auxz00_7471;
																																													{
																																														obj_t
																																															BgL_argsz00_7473;
																																														obj_t
																																															BgL_fz00_7472;
																																														BgL_fz00_7472
																																															=
																																															BgL_arg2176z00_2249;
																																														BgL_argsz00_7473
																																															=
																																															BgL_arg2177z00_2250;
																																														BgL_argsz00_1535
																																															=
																																															BgL_argsz00_7473;
																																														BgL_fz00_1534
																																															=
																																															BgL_fz00_7472;
																																														goto
																																															BgL_tagzd2175zd2_1536;
																																													}
																																													return
																																														(
																																														(obj_t)
																																														BgL_auxz00_7471);
																																												}
																																											}
																																									}
																																								else
																																									{	/* Eval/evaluate.scm 424 */
																																										obj_t
																																											BgL_cdrzd213376zd2_2251;
																																										BgL_cdrzd213376zd2_2251
																																											=
																																											CDR
																																											(BgL_ez00_69);
																																										if ((CAR(BgL_ez00_69) == BGl_symbol3285z00zz__evaluatez00))
																																											{	/* Eval/evaluate.scm 424 */
																																												if (PAIRP(BgL_cdrzd213376zd2_2251))
																																													{	/* Eval/evaluate.scm 424 */
																																														obj_t
																																															BgL_cdrzd213381zd2_2255;
																																														BgL_cdrzd213381zd2_2255
																																															=
																																															CDR
																																															(BgL_cdrzd213376zd2_2251);
																																														if (PAIRP(BgL_cdrzd213381zd2_2255))
																																															{	/* Eval/evaluate.scm 424 */
																																																obj_t
																																																	BgL_cdrzd213386zd2_2257;
																																																BgL_cdrzd213386zd2_2257
																																																	=
																																																	CDR
																																																	(BgL_cdrzd213381zd2_2255);
																																																if ((CAR(BgL_cdrzd213381zd2_2255) == BGl_keyword3287z00zz__evaluatez00))
																																																	{	/* Eval/evaluate.scm 424 */
																																																		if (PAIRP(BgL_cdrzd213386zd2_2257))
																																																			{	/* Eval/evaluate.scm 424 */
																																																				obj_t
																																																					BgL_arg2185z00_2261;
																																																				obj_t
																																																					BgL_arg2186z00_2262;
																																																				obj_t
																																																					BgL_arg2187z00_2263;
																																																				BgL_arg2185z00_2261
																																																					=
																																																					CAR
																																																					(BgL_cdrzd213376zd2_2251);
																																																				BgL_arg2186z00_2262
																																																					=
																																																					CAR
																																																					(BgL_cdrzd213386zd2_2257);
																																																				BgL_arg2187z00_2263
																																																					=
																																																					CDR
																																																					(BgL_cdrzd213386zd2_2257);
																																																				{	/* Eval/evaluate.scm 583 */
																																																					BgL_ev_synchroniza7eza7_bglt
																																																						BgL_new1157z00_4617;
																																																					{	/* Eval/evaluate.scm 584 */
																																																						BgL_ev_synchroniza7eza7_bglt
																																																							BgL_new1156z00_4618;
																																																						BgL_new1156z00_4618
																																																							=
																																																							(
																																																							(BgL_ev_synchroniza7eza7_bglt)
																																																							BOBJECT
																																																							(GC_MALLOC
																																																								(sizeof
																																																									(struct
																																																										BgL_ev_synchroniza7eza7_bgl))));
																																																						{	/* Eval/evaluate.scm 584 */
																																																							long
																																																								BgL_arg2381z00_4619;
																																																							{	/* Eval/evaluate.scm 584 */
																																																								long
																																																									BgL_res3105z00_4621;
																																																								BgL_res3105z00_4621
																																																									=
																																																									BGL_CLASS_INDEX
																																																									(BGl_ev_synchroniza7eza7zz__evaluate_typesz00);
																																																								BgL_arg2381z00_4619
																																																									=
																																																									BgL_res3105z00_4621;
																																																							}
																																																							BGL_OBJECT_CLASS_NUM_SET
																																																								(
																																																								((BgL_objectz00_bglt) BgL_new1156z00_4618), BgL_arg2381z00_4619);
																																																						}
																																																						BgL_new1157z00_4617
																																																							=
																																																							BgL_new1156z00_4618;
																																																					}
																																																					((((BgL_ev_synchroniza7eza7_bglt) COBJECT(BgL_new1157z00_4617))->BgL_locz00) = ((obj_t) BgL_locz00_74), BUNSPEC);
																																																					{
																																																						BgL_ev_exprz00_bglt
																																																							BgL_auxz00_7498;
																																																						{	/* Eval/evaluate.scm 380 */
																																																							obj_t
																																																								BgL_arg2395z00_4624;
																																																							BgL_arg2395z00_4624
																																																								=
																																																								BGl_getzd2locationzd2zz__evaluatez00
																																																								(BgL_arg2185z00_2261,
																																																								BgL_locz00_74);
																																																							BgL_auxz00_7498
																																																								=
																																																								(
																																																								(BgL_ev_exprz00_bglt)
																																																								BGl_uconvzf2locze70z15zz__evaluatez00
																																																								(BgL_wherez00_73,
																																																									BgL_globalsz00_71,
																																																									BgL_localsz00_70,
																																																									BgL_arg2185z00_2261,
																																																									BgL_arg2395z00_4624));
																																																						}
																																																						((((BgL_ev_synchroniza7eza7_bglt) COBJECT(BgL_new1157z00_4617))->BgL_mutexz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_7498), BUNSPEC);
																																																					}
																																																					{
																																																						BgL_ev_exprz00_bglt
																																																							BgL_auxz00_7503;
																																																						{	/* Eval/evaluate.scm 380 */
																																																							obj_t
																																																								BgL_arg2395z00_4625;
																																																							BgL_arg2395z00_4625
																																																								=
																																																								BGl_getzd2locationzd2zz__evaluatez00
																																																								(BgL_arg2186z00_2262,
																																																								BgL_locz00_74);
																																																							BgL_auxz00_7503
																																																								=
																																																								(
																																																								(BgL_ev_exprz00_bglt)
																																																								BGl_uconvzf2locze70z15zz__evaluatez00
																																																								(BgL_wherez00_73,
																																																									BgL_globalsz00_71,
																																																									BgL_localsz00_70,
																																																									BgL_arg2186z00_2262,
																																																									BgL_arg2395z00_4625));
																																																						}
																																																						((((BgL_ev_synchroniza7eza7_bglt) COBJECT(BgL_new1157z00_4617))->BgL_prelockz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_7503), BUNSPEC);
																																																					}
																																																					((((BgL_ev_synchroniza7eza7_bglt) COBJECT(BgL_new1157z00_4617))->BgL_bodyz00) = ((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BGl_convzd2beginzd2zz__evaluatez00(BgL_arg2187z00_2263, BgL_localsz00_70, BgL_globalsz00_71, BFALSE, BgL_wherez00_73, BgL_locz00_74, ((bool_t) 0)))), BUNSPEC);
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_new1157z00_4617);
																																																				}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 424 */
																																																				obj_t
																																																					BgL_arg2188z00_2265;
																																																				obj_t
																																																					BgL_arg2189z00_2266;
																																																				BgL_arg2188z00_2265
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_cdrzd213376zd2_2251));
																																																				BgL_arg2189z00_2266
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_cdrzd213376zd2_2251));
																																																				{
																																																					BgL_ev_synchroniza7eza7_bglt
																																																						BgL_auxz00_7516;
																																																					{
																																																						obj_t
																																																							BgL_bodyz00_7518;
																																																						obj_t
																																																							BgL_mz00_7517;
																																																						BgL_mz00_7517
																																																							=
																																																							BgL_arg2188z00_2265;
																																																						BgL_bodyz00_7518
																																																							=
																																																							BgL_arg2189z00_2266;
																																																						BgL_bodyz00_1529
																																																							=
																																																							BgL_bodyz00_7518;
																																																						BgL_mz00_1528
																																																							=
																																																							BgL_mz00_7517;
																																																						goto
																																																							BgL_tagzd2173zd2_1530;
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_7516);
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Eval/evaluate.scm 424 */
																																																		obj_t
																																																			BgL_arg2190z00_2268;
																																																		obj_t
																																																			BgL_arg2191z00_2269;
																																																		BgL_arg2190z00_2268
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_cdrzd213376zd2_2251));
																																																		BgL_arg2191z00_2269
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_cdrzd213376zd2_2251));
																																																		{
																																																			BgL_ev_synchroniza7eza7_bglt
																																																				BgL_auxz00_7524;
																																																			{
																																																				obj_t
																																																					BgL_bodyz00_7526;
																																																				obj_t
																																																					BgL_mz00_7525;
																																																				BgL_mz00_7525
																																																					=
																																																					BgL_arg2190z00_2268;
																																																				BgL_bodyz00_7526
																																																					=
																																																					BgL_arg2191z00_2269;
																																																				BgL_bodyz00_1529
																																																					=
																																																					BgL_bodyz00_7526;
																																																				BgL_mz00_1528
																																																					=
																																																					BgL_mz00_7525;
																																																				goto
																																																					BgL_tagzd2173zd2_1530;
																																																			}
																																																			return
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_7524);
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 424 */
																																																obj_t
																																																	BgL_arg2193z00_2272;
																																																obj_t
																																																	BgL_arg2195z00_2273;
																																																BgL_arg2193z00_2272
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_cdrzd213376zd2_2251));
																																																BgL_arg2195z00_2273
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_cdrzd213376zd2_2251));
																																																{
																																																	BgL_ev_synchroniza7eza7_bglt
																																																		BgL_auxz00_7532;
																																																	{
																																																		obj_t
																																																			BgL_bodyz00_7534;
																																																		obj_t
																																																			BgL_mz00_7533;
																																																		BgL_mz00_7533
																																																			=
																																																			BgL_arg2193z00_2272;
																																																		BgL_bodyz00_7534
																																																			=
																																																			BgL_arg2195z00_2273;
																																																		BgL_bodyz00_1529
																																																			=
																																																			BgL_bodyz00_7534;
																																																		BgL_mz00_1528
																																																			=
																																																			BgL_mz00_7533;
																																																		goto
																																																			BgL_tagzd2173zd2_1530;
																																																	}
																																																	return
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_7532);
																																																}
																																															}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 424 */
																																														obj_t
																																															BgL_arg2196z00_2274;
																																														BgL_arg2196z00_2274
																																															=
																																															CAR
																																															(BgL_ez00_69);
																																														{
																																															BgL_ev_appz00_bglt
																																																BgL_auxz00_7537;
																																															{
																																																obj_t
																																																	BgL_argsz00_7539;
																																																obj_t
																																																	BgL_fz00_7538;
																																																BgL_fz00_7538
																																																	=
																																																	BgL_arg2196z00_2274;
																																																BgL_argsz00_7539
																																																	=
																																																	BgL_cdrzd213376zd2_2251;
																																																BgL_argsz00_1535
																																																	=
																																																	BgL_argsz00_7539;
																																																BgL_fz00_1534
																																																	=
																																																	BgL_fz00_7538;
																																																goto
																																																	BgL_tagzd2175zd2_1536;
																																															}
																																															return
																																																(
																																																(obj_t)
																																																BgL_auxz00_7537);
																																														}
																																													}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 424 */
																																												if ((CAR(BgL_ez00_69) == BGl_symbol3242z00zz__evaluatez00))
																																													{	/* Eval/evaluate.scm 424 */
																																														if (PAIRP(BgL_cdrzd213376zd2_2251))
																																															{	/* Eval/evaluate.scm 424 */
																																																obj_t
																																																	BgL_cdrzd213486zd2_2280;
																																																BgL_cdrzd213486zd2_2280
																																																	=
																																																	CDR
																																																	(BgL_cdrzd213376zd2_2251);
																																																if (PAIRP(BgL_cdrzd213486zd2_2280))
																																																	{	/* Eval/evaluate.scm 424 */
																																																		if (NULLP(CDR(BgL_cdrzd213486zd2_2280)))
																																																			{	/* Eval/evaluate.scm 424 */
																																																				obj_t
																																																					BgL_arg2204z00_2284;
																																																				obj_t
																																																					BgL_arg2205z00_2285;
																																																				BgL_arg2204z00_2284
																																																					=
																																																					CAR
																																																					(BgL_cdrzd213376zd2_2251);
																																																				BgL_arg2205z00_2285
																																																					=
																																																					CAR
																																																					(BgL_cdrzd213486zd2_2280);
																																																				{	/* Eval/evaluate.scm 595 */
																																																					obj_t
																																																						BgL_arg2383z00_4646;
																																																					{	/* Eval/evaluate.scm 595 */
																																																						obj_t
																																																							BgL_arg2385z00_4647;
																																																						{	/* Eval/evaluate.scm 595 */
																																																							obj_t
																																																								BgL_arg2386z00_4648;
																																																							obj_t
																																																								BgL_arg2387z00_4649;
																																																							{	/* Eval/evaluate.scm 595 */
																																																								obj_t
																																																									BgL_res3109z00_4652;
																																																								{	/* Eval/evaluate.scm 595 */
																																																									obj_t
																																																										BgL_symbolz00_4650;
																																																									BgL_symbolz00_4650
																																																										=
																																																										BGl_symbol3289z00zz__evaluatez00;
																																																									{	/* Eval/evaluate.scm 595 */
																																																										obj_t
																																																											BgL_arg2602z00_4651;
																																																										BgL_arg2602z00_4651
																																																											=
																																																											SYMBOL_TO_STRING
																																																											(BgL_symbolz00_4650);
																																																										BgL_res3109z00_4652
																																																											=
																																																											BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																																																											(BgL_arg2602z00_4651);
																																																									}
																																																								}
																																																								BgL_arg2386z00_4648
																																																									=
																																																									BgL_res3109z00_4652;
																																																							}
																																																							{	/* Eval/evaluate.scm 595 */
																																																								obj_t
																																																									BgL_res3110z00_4655;
																																																								{	/* Eval/evaluate.scm 595 */
																																																									obj_t
																																																										BgL_arg2602z00_4654;
																																																									BgL_arg2602z00_4654
																																																										=
																																																										SYMBOL_TO_STRING
																																																										(
																																																										((obj_t) BgL_wherez00_73));
																																																									BgL_res3110z00_4655
																																																										=
																																																										BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																																																										(BgL_arg2602z00_4654);
																																																								}
																																																								BgL_arg2387z00_4649
																																																									=
																																																									BgL_res3110z00_4655;
																																																							}
																																																							BgL_arg2385z00_4647
																																																								=
																																																								string_append
																																																								(BgL_arg2386z00_4648,
																																																								BgL_arg2387z00_4649);
																																																						}
																																																						BgL_arg2383z00_4646
																																																							=
																																																							bstring_to_symbol
																																																							(BgL_arg2385z00_4647);
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BGl_convzd2lambdaze70z35zz__evaluatez00
																																																						(BgL_globalsz00_71,
																																																							BgL_localsz00_70,
																																																							BgL_ez00_69,
																																																							BgL_locz00_74,
																																																							BgL_arg2204z00_2284,
																																																							BgL_arg2205z00_2285,
																																																							BgL_arg2383z00_4646,
																																																							BFALSE));
																																																				}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 424 */
																																																				obj_t
																																																					BgL_arg2206z00_2286;
																																																				obj_t
																																																					BgL_arg2207z00_2287;
																																																				BgL_arg2206z00_2286
																																																					=
																																																					CAR
																																																					(BgL_ez00_69);
																																																				BgL_arg2207z00_2287
																																																					=
																																																					CDR
																																																					(BgL_ez00_69);
																																																				{
																																																					BgL_ev_appz00_bglt
																																																						BgL_auxz00_7565;
																																																					{
																																																						obj_t
																																																							BgL_argsz00_7567;
																																																						obj_t
																																																							BgL_fz00_7566;
																																																						BgL_fz00_7566
																																																							=
																																																							BgL_arg2206z00_2286;
																																																						BgL_argsz00_7567
																																																							=
																																																							BgL_arg2207z00_2287;
																																																						BgL_argsz00_1535
																																																							=
																																																							BgL_argsz00_7567;
																																																						BgL_fz00_1534
																																																							=
																																																							BgL_fz00_7566;
																																																						goto
																																																							BgL_tagzd2175zd2_1536;
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_7565);
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Eval/evaluate.scm 424 */
																																																		obj_t
																																																			BgL_arg2209z00_2289;
																																																		obj_t
																																																			BgL_arg2210z00_2290;
																																																		BgL_arg2209z00_2289
																																																			=
																																																			CAR
																																																			(BgL_ez00_69);
																																																		BgL_arg2210z00_2290
																																																			=
																																																			CDR
																																																			(BgL_ez00_69);
																																																		{
																																																			BgL_ev_appz00_bglt
																																																				BgL_auxz00_7571;
																																																			{
																																																				obj_t
																																																					BgL_argsz00_7573;
																																																				obj_t
																																																					BgL_fz00_7572;
																																																				BgL_fz00_7572
																																																					=
																																																					BgL_arg2209z00_2289;
																																																				BgL_argsz00_7573
																																																					=
																																																					BgL_arg2210z00_2290;
																																																				BgL_argsz00_1535
																																																					=
																																																					BgL_argsz00_7573;
																																																				BgL_fz00_1534
																																																					=
																																																					BgL_fz00_7572;
																																																				goto
																																																					BgL_tagzd2175zd2_1536;
																																																			}
																																																			return
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_7571);
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 424 */
																																																obj_t
																																																	BgL_arg2211z00_2291;
																																																obj_t
																																																	BgL_arg2212z00_2292;
																																																BgL_arg2211z00_2291
																																																	=
																																																	CAR
																																																	(BgL_ez00_69);
																																																BgL_arg2212z00_2292
																																																	=
																																																	CDR
																																																	(BgL_ez00_69);
																																																{
																																																	BgL_ev_appz00_bglt
																																																		BgL_auxz00_7577;
																																																	{
																																																		obj_t
																																																			BgL_argsz00_7579;
																																																		obj_t
																																																			BgL_fz00_7578;
																																																		BgL_fz00_7578
																																																			=
																																																			BgL_arg2211z00_2291;
																																																		BgL_argsz00_7579
																																																			=
																																																			BgL_arg2212z00_2292;
																																																		BgL_argsz00_1535
																																																			=
																																																			BgL_argsz00_7579;
																																																		BgL_fz00_1534
																																																			=
																																																			BgL_fz00_7578;
																																																		goto
																																																			BgL_tagzd2175zd2_1536;
																																																	}
																																																	return
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_7577);
																																																}
																																															}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 424 */
																																														obj_t
																																															BgL_arg2213z00_2293;
																																														obj_t
																																															BgL_arg2214z00_2294;
																																														BgL_arg2213z00_2293
																																															=
																																															CAR
																																															(BgL_ez00_69);
																																														BgL_arg2214z00_2294
																																															=
																																															CDR
																																															(BgL_ez00_69);
																																														{
																																															BgL_ev_appz00_bglt
																																																BgL_auxz00_7583;
																																															{
																																																obj_t
																																																	BgL_argsz00_7585;
																																																obj_t
																																																	BgL_fz00_7584;
																																																BgL_fz00_7584
																																																	=
																																																	BgL_arg2213z00_2293;
																																																BgL_argsz00_7585
																																																	=
																																																	BgL_arg2214z00_2294;
																																																BgL_argsz00_1535
																																																	=
																																																	BgL_argsz00_7585;
																																																BgL_fz00_1534
																																																	=
																																																	BgL_fz00_7584;
																																																goto
																																																	BgL_tagzd2175zd2_1536;
																																															}
																																															return
																																																(
																																																(obj_t)
																																																BgL_auxz00_7583);
																																														}
																																													}
																																											}
																																									}
																																							}
																																					}
																																			}
																																	}
																															}
																													}
																											}
																									}
																							}
																					}
																			}
																	}
															}
													}
											}
									}
							}
					}
				else
					{	/* Eval/evaluate.scm 424 */
						BgL_xz00_1459 = BgL_ez00_69;
						if (SYMBOLP(BgL_xz00_1459))
							{	/* Eval/evaluate.scm 427 */
								obj_t BgL__ortest_1102z00_2315;

								BgL__ortest_1102z00_2315 =
									BGl_convzd2varzd2zz__evaluatez00(BgL_xz00_1459,
									BgL_localsz00_70);
								if (CBOOL(BgL__ortest_1102z00_2315))
									{	/* Eval/evaluate.scm 427 */
										return BgL__ortest_1102z00_2315;
									}
								else
									{	/* Eval/evaluate.scm 195 */
										BgL_ev_globalz00_bglt BgL_new1077z00_3490;

										{	/* Eval/evaluate.scm 196 */
											BgL_ev_globalz00_bglt BgL_new1076z00_3491;

											BgL_new1076z00_3491 =
												((BgL_ev_globalz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
															BgL_ev_globalz00_bgl))));
											{	/* Eval/evaluate.scm 196 */
												long BgL_arg1367z00_3492;

												{	/* Eval/evaluate.scm 196 */
													long BgL_res2877z00_3495;

													BgL_res2877z00_3495 =
														BGL_CLASS_INDEX
														(BGl_ev_globalz00zz__evaluate_typesz00);
													BgL_arg1367z00_3492 = BgL_res2877z00_3495;
												}
												BGL_OBJECT_CLASS_NUM_SET(
													((BgL_objectz00_bglt) BgL_new1076z00_3491),
													BgL_arg1367z00_3492);
											}
											BgL_new1077z00_3490 = BgL_new1076z00_3491;
										}
										((((BgL_ev_globalz00_bglt) COBJECT(BgL_new1077z00_3490))->
												BgL_locz00) = ((obj_t) BgL_locz00_74), BUNSPEC);
										((((BgL_ev_globalz00_bglt) COBJECT(BgL_new1077z00_3490))->
												BgL_namez00) = ((obj_t) BgL_xz00_1459), BUNSPEC);
										{
											obj_t BgL_auxz00_7598;

											if (BGl_evmodulezf3zf3zz__evmodulez00(BgL_globalsz00_71))
												{	/* Eval/evaluate.scm 198 */
													BgL_auxz00_7598 = BgL_globalsz00_71;
												}
											else
												{	/* Eval/evaluate.scm 198 */
													BgL_auxz00_7598 = BGL_MODULE();
												}
											((((BgL_ev_globalz00_bglt) COBJECT(BgL_new1077z00_3490))->
													BgL_modz00) = ((obj_t) BgL_auxz00_7598), BUNSPEC);
										}
										return ((obj_t) BgL_new1077z00_3490);
									}
							}
						else
							{	/* Eval/evaluate.scm 428 */
								BgL_ev_littz00_bglt BgL_new1104z00_2316;

								{	/* Eval/evaluate.scm 429 */
									BgL_ev_littz00_bglt BgL_new1103z00_2317;

									BgL_new1103z00_2317 =
										((BgL_ev_littz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
													BgL_ev_littz00_bgl))));
									{	/* Eval/evaluate.scm 429 */
										long BgL_arg2237z00_2318;

										{	/* Eval/evaluate.scm 429 */
											long BgL_res2878z00_3499;

											BgL_res2878z00_3499 =
												BGL_CLASS_INDEX(BGl_ev_littz00zz__evaluate_typesz00);
											BgL_arg2237z00_2318 = BgL_res2878z00_3499;
										}
										BGL_OBJECT_CLASS_NUM_SET(
											((BgL_objectz00_bglt) BgL_new1103z00_2317),
											BgL_arg2237z00_2318);
									}
									BgL_new1104z00_2316 = BgL_new1103z00_2317;
								}
								((((BgL_ev_littz00_bglt) COBJECT(BgL_new1104z00_2316))->
										BgL_valuez00) = ((obj_t) BgL_xz00_1459), BUNSPEC);
								return ((obj_t) BgL_new1104z00_2316);
							}
					}
			}
		}

	}



/* loop~0 */
	obj_t BGl_loopze70ze7zz__evaluatez00(obj_t BgL_wherez00_4935,
		obj_t BgL_globalsz00_4934, obj_t BgL_localsz00_4933, obj_t BgL_locz00_4932,
		obj_t BgL_esz00_2646)
	{
		{	/* Eval/evaluate.scm 386 */
			if (NULLP(BgL_esz00_2646))
				{	/* Eval/evaluate.scm 387 */
					return BNIL;
				}
			else
				{	/* Eval/evaluate.scm 389 */
					obj_t BgL_ez00_2649;

					BgL_ez00_2649 = CAR(((obj_t) BgL_esz00_2646));
					{	/* Eval/evaluate.scm 390 */
						obj_t BgL_arg2401z00_2650;
						obj_t BgL_arg2402z00_2651;

						{	/* Eval/evaluate.scm 390 */
							obj_t BgL_arg2403z00_2652;

							{	/* Eval/evaluate.scm 150 */
								obj_t BgL__ortest_1069z00_3457;

								BgL__ortest_1069z00_3457 =
									BGl_getzd2sourcezd2locationz00zz__readerz00(BgL_ez00_2649);
								if (CBOOL(BgL__ortest_1069z00_3457))
									{	/* Eval/evaluate.scm 150 */
										BgL_arg2403z00_2652 = BgL__ortest_1069z00_3457;
									}
								else
									{	/* Eval/evaluate.scm 151 */
										obj_t BgL__ortest_1070z00_3458;

										BgL__ortest_1070z00_3458 =
											BGl_getzd2sourcezd2locationz00zz__readerz00
											(BgL_esz00_2646);
										if (CBOOL(BgL__ortest_1070z00_3458))
											{	/* Eval/evaluate.scm 151 */
												BgL_arg2403z00_2652 = BgL__ortest_1070z00_3458;
											}
										else
											{	/* Eval/evaluate.scm 151 */
												BgL_arg2403z00_2652 = BgL_locz00_4932;
											}
									}
							}
							BgL_arg2401z00_2650 =
								BGl_convz00zz__evaluatez00(BgL_ez00_2649, BgL_localsz00_4933,
								BgL_globalsz00_4934, BFALSE, BgL_wherez00_4935,
								BgL_arg2403z00_2652, ((bool_t) 0));
						}
						{	/* Eval/evaluate.scm 391 */
							obj_t BgL_arg2404z00_2653;

							BgL_arg2404z00_2653 = CDR(((obj_t) BgL_esz00_2646));
							BgL_arg2402z00_2651 =
								BGl_loopze70ze7zz__evaluatez00(BgL_wherez00_4935,
								BgL_globalsz00_4934, BgL_localsz00_4933, BgL_locz00_4932,
								BgL_arg2404z00_2653);
						}
						return MAKE_YOUNG_PAIR(BgL_arg2401z00_2650, BgL_arg2402z00_2651);
					}
				}
		}

	}



/* conv-vals~0 */
	obj_t BGl_convzd2valsze70z35zz__evaluatez00(obj_t BgL_wherez00_4937,
		obj_t BgL_globalsz00_4936, obj_t BgL_lz00_2464, obj_t BgL_varsz00_2465,
		obj_t BgL_localsz00_2466, obj_t BgL_locz00_2467)
	{
		{	/* Eval/evaluate.scm 502 */
			if (NULLP(BgL_lz00_2464))
				{	/* Eval/evaluate.scm 498 */
					return BNIL;
				}
			else
				{	/* Eval/evaluate.scm 500 */
					obj_t BgL_locz00_3655;

					{	/* Eval/evaluate.scm 500 */
						obj_t BgL_arg2318z00_3656;

						BgL_arg2318z00_3656 = CAR(((obj_t) BgL_lz00_2464));
						{	/* Eval/evaluate.scm 144 */
							obj_t BgL__ortest_1068z00_3666;

							BgL__ortest_1068z00_3666 =
								BGl_getzd2sourcezd2locationz00zz__readerz00
								(BgL_arg2318z00_3656);
							if (CBOOL(BgL__ortest_1068z00_3666))
								{	/* Eval/evaluate.scm 144 */
									BgL_locz00_3655 = BgL__ortest_1068z00_3666;
								}
							else
								{	/* Eval/evaluate.scm 144 */
									BgL_locz00_3655 = BgL_locz00_2467;
								}
						}
					}
					{	/* Eval/evaluate.scm 501 */
						obj_t BgL_arg2308z00_3657;
						obj_t BgL_arg2309z00_3658;

						{	/* Eval/evaluate.scm 501 */
							obj_t BgL_arg2311z00_3659;

							{	/* Eval/evaluate.scm 501 */
								obj_t BgL_pairz00_3672;

								{	/* Eval/evaluate.scm 501 */
									obj_t BgL_pairz00_3671;

									BgL_pairz00_3671 = CAR(((obj_t) BgL_lz00_2464));
									BgL_pairz00_3672 = CDR(BgL_pairz00_3671);
								}
								BgL_arg2311z00_3659 = CAR(BgL_pairz00_3672);
							}
							BgL_arg2308z00_3657 =
								BGl_convz00zz__evaluatez00(BgL_arg2311z00_3659,
								BgL_localsz00_2466, BgL_globalsz00_4936, BFALSE,
								BgL_wherez00_4937, BgL_locz00_3655, ((bool_t) 0));
						}
						{	/* Eval/evaluate.scm 502 */
							obj_t BgL_arg2314z00_3660;
							obj_t BgL_arg2315z00_3661;
							obj_t BgL_arg2316z00_3662;

							BgL_arg2314z00_3660 = CDR(((obj_t) BgL_lz00_2464));
							BgL_arg2315z00_3661 = CDR(((obj_t) BgL_varsz00_2465));
							{	/* Eval/evaluate.scm 502 */
								obj_t BgL_arg2317z00_3663;

								BgL_arg2317z00_3663 = CAR(((obj_t) BgL_varsz00_2465));
								BgL_arg2316z00_3662 =
									MAKE_YOUNG_PAIR(BgL_arg2317z00_3663, BgL_localsz00_2466);
							}
							BgL_arg2309z00_3658 =
								BGl_convzd2valsze70z35zz__evaluatez00(BgL_wherez00_4937,
								BgL_globalsz00_4936, BgL_arg2314z00_3660, BgL_arg2315z00_3661,
								BgL_arg2316z00_3662, BgL_locz00_3655);
						}
						return MAKE_YOUNG_PAIR(BgL_arg2308z00_3657, BgL_arg2309z00_3658);
					}
				}
		}

	}



/* conv-lambda~0 */
	BgL_ev_absz00_bglt BGl_convzd2lambdaze70z35zz__evaluatez00(obj_t
		BgL_globalsz00_4941, obj_t BgL_localsz00_4940, obj_t BgL_ez00_4939,
		obj_t BgL_locz00_4938, obj_t BgL_formalsz00_2655, obj_t BgL_bodyz00_2656,
		obj_t BgL_wherez00_2657, obj_t BgL_typez00_2658)
	{
		{	/* Eval/evaluate.scm 404 */
			{
				obj_t BgL_lz00_2689;

				{	/* Eval/evaluate.scm 406 */
					obj_t BgL_argsz00_2661;

					BgL_lz00_2689 =
						BGl_dssslzd2formalszd2ze3schemezd2typedzd2formalsze3zz__dssslz00
						(BgL_formalsz00_2655, BGl_errorzd2envzd2zz__errorz00, ((bool_t) 1));
					{
						obj_t BgL_rz00_2693;
						obj_t BgL_flatz00_2694;
						long BgL_arityz00_2695;

						BgL_rz00_2693 = BgL_lz00_2689;
						BgL_flatz00_2694 = BNIL;
						BgL_arityz00_2695 = ((long) 0);
					BgL_zc3z04anonymousza32421ze3z87_2696:
						if (NULLP(BgL_rz00_2693))
							{	/* Eval/evaluate.scm 399 */
								obj_t BgL_val0_1201z00_2698;

								BgL_val0_1201z00_2698 = bgl_reverse_bang(BgL_flatz00_2694);
								{	/* Eval/evaluate.scm 399 */
									int BgL_res2865z00_3461;

									{	/* Eval/evaluate.scm 399 */
										int BgL_tmpz00_7649;

										BgL_tmpz00_7649 = (int) (((long) 2));
										BgL_res2865z00_3461 =
											BGL_MVALUES_NUMBER_SET(BgL_tmpz00_7649);
									} BgL_res2865z00_3461;
								}
								{	/* Eval/evaluate.scm 399 */
									obj_t BgL_auxz00_7654;
									int BgL_tmpz00_7652;

									BgL_auxz00_7654 = BINT(BgL_arityz00_2695);
									BgL_tmpz00_7652 = (int) (((long) 1));
									BGL_MVALUES_VAL_SET(BgL_tmpz00_7652, BgL_auxz00_7654);
								}
								BgL_argsz00_2661 = BgL_val0_1201z00_2698;
							}
						else
							{	/* Eval/evaluate.scm 398 */
								if (PAIRP(BgL_rz00_2693))
									{	/* Eval/evaluate.scm 403 */
										obj_t BgL_arg2424z00_2701;
										obj_t BgL_arg2425z00_2702;
										long BgL_arg2428z00_2703;

										BgL_arg2424z00_2701 = CDR(BgL_rz00_2693);
										BgL_arg2425z00_2702 =
											MAKE_YOUNG_PAIR(BGl_untypezd2identzd2zz__evaluatez00(CAR
												(BgL_rz00_2693)), BgL_flatz00_2694);
										BgL_arg2428z00_2703 = (BgL_arityz00_2695 + ((long) 1));
										{
											long BgL_arityz00_7666;
											obj_t BgL_flatz00_7665;
											obj_t BgL_rz00_7664;

											BgL_rz00_7664 = BgL_arg2424z00_2701;
											BgL_flatz00_7665 = BgL_arg2425z00_2702;
											BgL_arityz00_7666 = BgL_arg2428z00_2703;
											BgL_arityz00_2695 = BgL_arityz00_7666;
											BgL_flatz00_2694 = BgL_flatz00_7665;
											BgL_rz00_2693 = BgL_rz00_7664;
											goto BgL_zc3z04anonymousza32421ze3z87_2696;
										}
									}
								else
									{	/* Eval/evaluate.scm 401 */
										obj_t BgL_val0_1203z00_2706;
										long BgL_val1_1204z00_2707;

										{	/* Eval/evaluate.scm 401 */
											obj_t BgL_arg2431z00_2708;

											BgL_arg2431z00_2708 =
												MAKE_YOUNG_PAIR(BGl_untypezd2identzd2zz__evaluatez00
												(BgL_rz00_2693), BgL_flatz00_2694);
											BgL_val0_1203z00_2706 =
												bgl_reverse_bang(BgL_arg2431z00_2708);
										}
										BgL_val1_1204z00_2707 = (((long) -1) - BgL_arityz00_2695);
										{	/* Eval/evaluate.scm 401 */
											int BgL_res2869z00_3469;

											{	/* Eval/evaluate.scm 401 */
												int BgL_tmpz00_7671;

												BgL_tmpz00_7671 = (int) (((long) 2));
												BgL_res2869z00_3469 =
													BGL_MVALUES_NUMBER_SET(BgL_tmpz00_7671);
											} BgL_res2869z00_3469;
										}
										{	/* Eval/evaluate.scm 401 */
											obj_t BgL_auxz00_7676;
											int BgL_tmpz00_7674;

											BgL_auxz00_7676 = BINT(BgL_val1_1204z00_2707);
											BgL_tmpz00_7674 = (int) (((long) 1));
											BGL_MVALUES_VAL_SET(BgL_tmpz00_7674, BgL_auxz00_7676);
										}
										BgL_argsz00_2661 = BgL_val0_1203z00_2706;
					}}}
					{	/* Eval/evaluate.scm 407 */
						obj_t BgL_arityz00_2662;

						{	/* Eval/evaluate.scm 408 */
							int BgL_tmpz00_7680;

							BgL_tmpz00_7680 = (int) (((long) 1));
							BgL_arityz00_2662 = BGL_MVALUES_VAL(BgL_tmpz00_7680);
						}
						{	/* Eval/evaluate.scm 408 */
							obj_t BgL_varsz00_2663;
							obj_t BgL_bodyz00_2664;
							obj_t BgL_nlocz00_2665;

							if (NULLP(BgL_argsz00_2661))
								{	/* Eval/evaluate.scm 408 */
									BgL_varsz00_2663 = BNIL;
								}
							else
								{	/* Eval/evaluate.scm 408 */
									obj_t BgL_head1207z00_2672;

									{	/* Eval/evaluate.scm 408 */
										obj_t BgL_res2871z00_3471;

										BgL_res2871z00_3471 = MAKE_YOUNG_PAIR(BNIL, BNIL);
										BgL_head1207z00_2672 = BgL_res2871z00_3471;
									}
									{
										obj_t BgL_l1205z00_2674;
										obj_t BgL_tail1208z00_2675;

										BgL_l1205z00_2674 = BgL_argsz00_2661;
										BgL_tail1208z00_2675 = BgL_head1207z00_2672;
									BgL_zc3z04anonymousza32410ze3z87_2676:
										if (NULLP(BgL_l1205z00_2674))
											{	/* Eval/evaluate.scm 408 */
												BgL_varsz00_2663 = CDR(BgL_head1207z00_2672);
											}
										else
											{	/* Eval/evaluate.scm 408 */
												obj_t BgL_newtail1209z00_2678;

												{	/* Eval/evaluate.scm 408 */
													BgL_ev_varz00_bglt BgL_arg2414z00_2680;

													{	/* Eval/evaluate.scm 408 */
														obj_t BgL_vz00_2681;

														BgL_vz00_2681 = CAR(((obj_t) BgL_l1205z00_2674));
														{	/* Eval/evaluate.scm 409 */
															BgL_ev_varz00_bglt BgL_new1099z00_2682;

															{	/* Eval/evaluate.scm 411 */
																BgL_ev_varz00_bglt BgL_new1098z00_2683;

																BgL_new1098z00_2683 =
																	((BgL_ev_varz00_bglt)
																	BOBJECT(GC_MALLOC(sizeof(struct
																				BgL_ev_varz00_bgl))));
																{	/* Eval/evaluate.scm 411 */
																	long BgL_arg2416z00_2684;

																	{	/* Eval/evaluate.scm 411 */
																		long BgL_res2873z00_3476;

																		BgL_res2873z00_3476 =
																			BGL_CLASS_INDEX
																			(BGl_ev_varz00zz__evaluate_typesz00);
																		BgL_arg2416z00_2684 = BgL_res2873z00_3476;
																	}
																	BGL_OBJECT_CLASS_NUM_SET(
																		((BgL_objectz00_bglt) BgL_new1098z00_2683),
																		BgL_arg2416z00_2684);
																}
																BgL_new1099z00_2682 = BgL_new1098z00_2683;
															}
															((((BgL_ev_varz00_bglt)
																		COBJECT(BgL_new1099z00_2682))->
																	BgL_namez00) =
																((obj_t) CAR(((obj_t) BgL_vz00_2681))),
																BUNSPEC);
															((((BgL_ev_varz00_bglt)
																		COBJECT(BgL_new1099z00_2682))->BgL_effz00) =
																((obj_t) BFALSE), BUNSPEC);
															((((BgL_ev_varz00_bglt)
																		COBJECT(BgL_new1099z00_2682))->
																	BgL_typez00) =
																((obj_t) CDR(((obj_t) BgL_vz00_2681))),
																BUNSPEC);
															BgL_arg2414z00_2680 = BgL_new1099z00_2682;
													}}
													{	/* Eval/evaluate.scm 408 */
														obj_t BgL_res2874z00_3481;

														BgL_res2874z00_3481 =
															MAKE_YOUNG_PAIR(
															((obj_t) BgL_arg2414z00_2680), BNIL);
														BgL_newtail1209z00_2678 = BgL_res2874z00_3481;
												}}
												SET_CDR(BgL_tail1208z00_2675, BgL_newtail1209z00_2678);
												{	/* Eval/evaluate.scm 408 */
													obj_t BgL_arg2413z00_2679;

													BgL_arg2413z00_2679 =
														CDR(((obj_t) BgL_l1205z00_2674));
													{
														obj_t BgL_tail1208z00_7708;
														obj_t BgL_l1205z00_7707;

														BgL_l1205z00_7707 = BgL_arg2413z00_2679;
														BgL_tail1208z00_7708 = BgL_newtail1209z00_2678;
														BgL_tail1208z00_2675 = BgL_tail1208z00_7708;
														BgL_l1205z00_2674 = BgL_l1205z00_7707;
														goto BgL_zc3z04anonymousza32410ze3z87_2676;
													}
												}
											}
									}
								}
							BgL_bodyz00_2664 =
								BGl_makezd2dssslzd2functionzd2preludezd2zz__dssslz00
								(BgL_ez00_4939, BgL_formalsz00_2655,
								BGl_typezd2checkszd2zz__evaluatez00(BgL_argsz00_2661,
									BgL_argsz00_2661,
									BGl_typezd2resultzd2zz__evaluatez00(BgL_typez00_2658,
										BgL_bodyz00_2656, BgL_locz00_4938), BgL_locz00_4938,
									BgL_wherez00_2657), BGl_errorzd2envzd2zz__errorz00);
							{	/* Eval/evaluate.scm 144 */
								obj_t BgL__ortest_1068z00_3484;

								BgL__ortest_1068z00_3484 =
									BGl_getzd2sourcezd2locationz00zz__readerz00(BgL_bodyz00_2656);
								if (CBOOL(BgL__ortest_1068z00_3484))
									{	/* Eval/evaluate.scm 144 */
										BgL_nlocz00_2665 = BgL__ortest_1068z00_3484;
									}
								else
									{	/* Eval/evaluate.scm 144 */
										BgL_nlocz00_2665 = BgL_locz00_4938;
									}
							}
							{	/* Eval/evaluate.scm 417 */
								BgL_ev_absz00_bglt BgL_new1101z00_2666;

								{	/* Eval/evaluate.scm 418 */
									BgL_ev_absz00_bglt BgL_new1100z00_2668;

									BgL_new1100z00_2668 =
										((BgL_ev_absz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
													BgL_ev_absz00_bgl))));
									{	/* Eval/evaluate.scm 418 */
										long BgL_arg2408z00_2669;

										{	/* Eval/evaluate.scm 418 */
											long BgL_res2875z00_3486;

											BgL_res2875z00_3486 =
												BGL_CLASS_INDEX(BGl_ev_absz00zz__evaluate_typesz00);
											BgL_arg2408z00_2669 = BgL_res2875z00_3486;
										}
										BGL_OBJECT_CLASS_NUM_SET(
											((BgL_objectz00_bglt) BgL_new1100z00_2668),
											BgL_arg2408z00_2669);
									}
									BgL_new1101z00_2666 = BgL_new1100z00_2668;
								}
								((((BgL_ev_absz00_bglt) COBJECT(BgL_new1101z00_2666))->
										BgL_locz00) = ((obj_t) BgL_locz00_4938), BUNSPEC);
								((((BgL_ev_absz00_bglt) COBJECT(BgL_new1101z00_2666))->
										BgL_wherez00) = ((obj_t) BgL_wherez00_2657), BUNSPEC);
								((((BgL_ev_absz00_bglt) COBJECT(BgL_new1101z00_2666))->
										BgL_arityz00) = ((obj_t) BgL_arityz00_2662), BUNSPEC);
								((((BgL_ev_absz00_bglt) COBJECT(BgL_new1101z00_2666))->
										BgL_varsz00) = ((obj_t) BgL_varsz00_2663), BUNSPEC);
								{
									BgL_ev_exprz00_bglt BgL_auxz00_7723;

									{	/* Eval/evaluate.scm 422 */
										obj_t BgL_arg2407z00_2667;

										BgL_arg2407z00_2667 =
											BGl_appendzd221011zd2zz__evaluatez00(BgL_varsz00_2663,
											BgL_localsz00_4940);
										BgL_auxz00_7723 =
											((BgL_ev_exprz00_bglt)
											BGl_convz00zz__evaluatez00(BgL_bodyz00_2664,
												BgL_arg2407z00_2667, BgL_globalsz00_4941, BTRUE,
												BgL_wherez00_2657, BgL_nlocz00_2665, ((bool_t) 0)));
									}
									((((BgL_ev_absz00_bglt) COBJECT(BgL_new1101z00_2666))->
											BgL_bodyz00) =
										((BgL_ev_exprz00_bglt) BgL_auxz00_7723), BUNSPEC);
								}
								((((BgL_ev_absz00_bglt) COBJECT(BgL_new1101z00_2666))->
										BgL_siza7eza7) = ((int) (int) (((long) 0))), BUNSPEC);
								((((BgL_ev_absz00_bglt) COBJECT(BgL_new1101z00_2666))->
										BgL_bindz00) = ((obj_t) BNIL), BUNSPEC);
								((((BgL_ev_absz00_bglt) COBJECT(BgL_new1101z00_2666))->
										BgL_freez00) = ((obj_t) BNIL), BUNSPEC);
								((((BgL_ev_absz00_bglt) COBJECT(BgL_new1101z00_2666))->
										BgL_innerz00) = ((obj_t) BNIL), BUNSPEC);
								((((BgL_ev_absz00_bglt) COBJECT(BgL_new1101z00_2666))->
										BgL_boxesz00) = ((obj_t) BNIL), BUNSPEC);
								return BgL_new1101z00_2666;
							}
						}
					}
				}
			}
		}

	}



/* uconv/loc~0 */
	obj_t BGl_uconvzf2locze70z15zz__evaluatez00(obj_t BgL_wherez00_4948,
		obj_t BgL_globalsz00_4947, obj_t BgL_localsz00_4946, obj_t BgL_ez00_2633,
		obj_t BgL_locz00_2634)
	{
		{	/* Eval/evaluate.scm 377 */
			return
				BGl_convz00zz__evaluatez00(BgL_ez00_2633, BgL_localsz00_4946,
				BgL_globalsz00_4947, BFALSE, BgL_wherez00_4948, BgL_locz00_2634,
				((bool_t) 0));
		}

	}



/* object-init */
	obj_t BGl_objectzd2initzd2zz__evaluatez00()
	{
		{	/* Eval/evaluate.scm 15 */
			return BUNSPEC;
		}

	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zz__evaluatez00()
	{
		{	/* Eval/evaluate.scm 15 */
			return BUNSPEC;
		}

	}



/* method-init */
	obj_t BGl_methodzd2initzd2zz__evaluatez00()
	{
		{	/* Eval/evaluate.scm 15 */
			return BUNSPEC;
		}

	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zz__evaluatez00()
	{
		{	/* Eval/evaluate.scm 15 */
			BGl_modulezd2initializa7ationz75zz__typez00(((long) 121046086),
				BSTRING_TO_STRING(BGl_string3291z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 330490148),
				BSTRING_TO_STRING(BGl_string3291z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__biglooz00(((long) 180158922),
				BSTRING_TO_STRING(BGl_string3291z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__tvectorz00(((long) 135276775),
				BSTRING_TO_STRING(BGl_string3291z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__structurez00(((long) 128218210),
				BSTRING_TO_STRING(BGl_string3291z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__bexitz00(((long) 340267792),
				BSTRING_TO_STRING(BGl_string3291z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__bignumz00(((long) 6519932),
				BSTRING_TO_STRING(BGl_string3291z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__osz00(((long) 251314740),
				BSTRING_TO_STRING(BGl_string3291z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__dssslz00(((long) 443936801),
				BSTRING_TO_STRING(BGl_string3291z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__bitz00(((long) 439353001),
				BSTRING_TO_STRING(BGl_string3291z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__paramz00(((long) 453939141),
				BSTRING_TO_STRING(BGl_string3291z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 193422112),
				BSTRING_TO_STRING(BGl_string3291z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__threadz00(((long) 224967693),
				BSTRING_TO_STRING(BGl_string3291z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long) 68574988),
				BSTRING_TO_STRING(BGl_string3291z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)
					93454137), BSTRING_TO_STRING(BGl_string3291z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(((long)
					437057797), BSTRING_TO_STRING(BGl_string3291z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(((long)
					268155843), BSTRING_TO_STRING(BGl_string3291z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long)
					198620800), BSTRING_TO_STRING(BGl_string3291z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)
					473309430), BSTRING_TO_STRING(BGl_string3291z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(((long) 459519430),
				BSTRING_TO_STRING(BGl_string3291z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 460262918),
				BSTRING_TO_STRING(BGl_string3291z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) -400105135),
				BSTRING_TO_STRING(BGl_string3291z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)
					9614678), BSTRING_TO_STRING(BGl_string3291z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long)
					376927882), BSTRING_TO_STRING(BGl_string3291z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 127905250),
				BSTRING_TO_STRING(BGl_string3291z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 331540577),
				BSTRING_TO_STRING(BGl_string3291z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long) 86988580),
				BSTRING_TO_STRING(BGl_string3291z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(((long)
					228151370), BSTRING_TO_STRING(BGl_string3291z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__ppz00(((long) 233942021),
				BSTRING_TO_STRING(BGl_string3291z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 220648206),
				BSTRING_TO_STRING(BGl_string3291z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__prognz00(((long) 177147622),
				BSTRING_TO_STRING(BGl_string3291z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__expandz00(((long) 414007149),
				BSTRING_TO_STRING(BGl_string3291z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__evenvz00(((long) 23062368),
				BSTRING_TO_STRING(BGl_string3291z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__evcompilez00(((long) 492754569),
				BSTRING_TO_STRING(BGl_string3291z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__everrorz00(((long) 375872221),
				BSTRING_TO_STRING(BGl_string3291z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__evmodulez00(((long) 6183155),
				BSTRING_TO_STRING(BGl_string3291z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(((long) 0),
				BSTRING_TO_STRING(BGl_string3291z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__evaluate_avarz00(((long) 483789130),
				BSTRING_TO_STRING(BGl_string3291z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__evaluate_fsiza7eza7(((long)
					121298760), BSTRING_TO_STRING(BGl_string3291z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__evaluate_uncompz00(((long) 193509656),
				BSTRING_TO_STRING(BGl_string3291z00zz__evaluatez00));
			return BGl_modulezd2initializa7ationz75zz__evaluate_compz00(((long)
					444000678), BSTRING_TO_STRING(BGl_string3291z00zz__evaluatez00));
		}

	}

#ifdef __cplusplus
}
#endif
