/*===========================================================================*/
/*   (Eval/evaluate_comp.scm)                                                */
/*   Bigloo (4.3g)                                                           */
/*   Inria -- Sophia Antipolis (c)       Wed 12 Feb 2020 07:45:41 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bigloo/bin/bigloo -srfi enable-gmp -srfi bigloo-unsafe -O3 -fcfa-arithmetic -q -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.3g -rm -copt -w -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.3g -mklib -cc gcc -fsharing -q -no-hello -unsafe -safee -O4 -c Eval/evaluate_comp.scm -indent -o objs/obj_u/Eval/evaluate_comp.c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* object type definitions */
	typedef struct BgL_ev_exprz00_bgl
	{
		header_t header;
		obj_t widening;
	}                 *BgL_ev_exprz00_bglt;

	typedef struct BgL_ev_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_namez00;
		obj_t BgL_effz00;
		obj_t BgL_typez00;
	}                *BgL_ev_varz00_bglt;

	typedef struct BgL_ev_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		obj_t BgL_modz00;
	}                   *BgL_ev_globalz00_bglt;

	typedef struct BgL_ev_littz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_valuez00;
	}                 *BgL_ev_littz00_bglt;

	typedef struct BgL_ev_ifz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_pz00;
		struct BgL_ev_exprz00_bgl *BgL_tz00;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
	}               *BgL_ev_ifz00_bglt;

	typedef struct BgL_ev_listz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_argsz00;
	}                 *BgL_ev_listz00_bglt;

	typedef struct BgL_ev_orz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_argsz00;
	}               *BgL_ev_orz00_bglt;

	typedef struct BgL_ev_andz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_argsz00;
	}                *BgL_ev_andz00_bglt;

	typedef struct BgL_ev_prog2z00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_e1z00;
		struct BgL_ev_exprz00_bgl *BgL_e2z00;
	}                  *BgL_ev_prog2z00_bglt;

	typedef struct BgL_ev_hookz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
	}                 *BgL_ev_hookz00_bglt;

	typedef struct BgL_ev_trapz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
	}                 *BgL_ev_trapz00_bglt;

	typedef struct BgL_ev_setlocalz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		struct BgL_ev_varz00_bgl *BgL_vz00;
	}                     *BgL_ev_setlocalz00_bglt;

	typedef struct BgL_ev_setglobalz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		obj_t BgL_modz00;
	}                      *BgL_ev_setglobalz00_bglt;

	typedef struct BgL_ev_defglobalz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		obj_t BgL_modz00;
	}                      *BgL_ev_defglobalz00_bglt;

	typedef struct BgL_ev_bindzd2exitzd2_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_varz00_bgl *BgL_varz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                        *BgL_ev_bindzd2exitzd2_bglt;

	typedef struct BgL_ev_unwindzd2protectzd2_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                             *BgL_ev_unwindzd2protectzd2_bglt;

	typedef struct BgL_ev_withzd2handlerzd2_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_handlerz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                           *BgL_ev_withzd2handlerzd2_bglt;

	typedef struct BgL_ev_synchroniza7eza7_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_ev_exprz00_bgl *BgL_mutexz00;
		struct BgL_ev_exprz00_bgl *BgL_prelockz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                          *BgL_ev_synchroniza7eza7_bglt;

	typedef struct BgL_ev_binderz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                   *BgL_ev_binderz00_bglt;

	typedef struct BgL_ev_letz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		obj_t BgL_boxesz00;
	}                *BgL_ev_letz00_bglt;

	typedef struct BgL_ev_letza2za2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		obj_t BgL_boxesz00;
	}                   *BgL_ev_letza2za2_bglt;

	typedef struct BgL_ev_letrecz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                   *BgL_ev_letrecz00_bglt;

	typedef struct BgL_ev_labelsz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		obj_t BgL_envz00;
		obj_t BgL_stkz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		obj_t BgL_boxesz00;
	}                   *BgL_ev_labelsz00_bglt;

	typedef struct BgL_ev_gotoz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_ev_varz00_bgl *BgL_labelz00;
		struct BgL_ev_labelsz00_bgl *BgL_labelsz00;
		obj_t BgL_argsz00;
	}                 *BgL_ev_gotoz00_bglt;

	typedef struct BgL_ev_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_ev_exprz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_tailzf3zf3;
	}                *BgL_ev_appz00_bglt;

	typedef struct BgL_ev_absz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		obj_t BgL_wherez00;
		obj_t BgL_arityz00;
		obj_t BgL_varsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		int BgL_siza7eza7;
		obj_t BgL_bindz00;
		obj_t BgL_freez00;
		obj_t BgL_innerz00;
		obj_t BgL_boxesz00;
	}                *BgL_ev_absz00_bglt;


	static obj_t BGl_z62zc3z04anonymousza33482ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33377ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32486ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_compilez00zz__evaluate_compz00(BgL_ev_exprz00_bglt);
	static obj_t BGl_z62zc3z04anonymousza32843ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32827ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33467ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33751ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32771ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33573ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32755ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33557ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_compzd2oldzd2callz00zz__evaluate_compz00(BgL_ev_appz00_bglt,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33841ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza31881ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_letrecz00zz__evaluate_typesz00;
	extern obj_t BGl_ev_letz00zz__evaluate_typesz00;
	static obj_t BGl_subzd2stkzd2zz__evaluate_compz00(obj_t, obj_t);
	extern bool_t BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(obj_t);
	static obj_t BGl_z62zc3z04anonymousza32863ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32847ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_assqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32210ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_Eze70ze7zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32791ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33828ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32775ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_objectzd2initzd2zz__evaluate_compz00();
	static obj_t BGl_z62zc3z04anonymousza32759ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_2za2za2zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern obj_t BGl_2zb2zb2zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern obj_t BGl_2zd2zd2zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern obj_t BGl_2zf2zf2zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern bool_t BGl_2zc3zc3zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern bool_t BGl_2zd3zd3zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern bool_t BGl_2ze3ze3zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32970ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33594ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_or1412zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32123ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol5800z00zz__evaluate_compz00 = BUNSPEC;
	extern obj_t bstring_to_symbol(obj_t);
	static obj_t BGl_symbol5808z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza33790ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32867ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33669ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	extern obj_t make_vector(long, obj_t);
	static obj_t BGl_symbol5810z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5812z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5815z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza33032ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol5818z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza32214ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_labelsz00zz__evaluate_typesz00;
	static obj_t BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_bindzd2framezd2zz__evaluate_compz00(obj_t, obj_t, long, long,
		obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33880ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32973ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32957ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32795ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_appendzd221011zd2zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32779ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_methodzd2initzd2zz__evaluate_compz00();
	static obj_t BGl_symbol5820z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5822z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_recze70ze7zz__evaluate_compz00(obj_t, obj_t, long);
	static obj_t BGl_symbol5824z00zz__evaluate_compz00 = BUNSPEC;
	static bool_t BGl_recze71ze7zz__evaluate_compz00(obj_t);
	static obj_t BGl_symbol5826z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5828z00zz__evaluate_compz00 = BUNSPEC;
	extern obj_t BGl_ev_absz00zz__evaluate_typesz00;
	static obj_t BGl_z62zc3z04anonymousza32990ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32869ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_everrorz00zz__everrorz00(obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_symbol5830z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5832z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5834z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5836z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5838z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza33777ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol5840z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5842z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5844z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5846z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5848z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_reset_profilez00zz__evaluate_compz00();
	static obj_t BGl_freezd2collectzd2zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza31996ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol5850z00zz__evaluate_compz00 = BUNSPEC;
	extern obj_t BGl_ev_ifz00zz__evaluate_typesz00;
	static obj_t BGl_symbol5852z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5854z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5856z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5858z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza32799ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol5860z00zz__evaluate_compz00 = BUNSPEC;
	extern obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_symbol5862z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5864z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5866z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5868z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62compzd2ev_labels1433zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(obj_t, long, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32978ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33869ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62exitz62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_symbol5870z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5872z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza32430ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol5874z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5876z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5878z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza32995ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza31999ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol5880z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_catchzd2trampolinezd2zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_symbol5882z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5884z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza33144ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33306ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32253ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32091ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_gotoz00zz__evaluate_typesz00;
	static obj_t BGl_z62zc3lexintza1zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33307ze3ze5zz__evaluate_compz00(obj_t);
	static obj_t BGl_ozd2ze3sze70zd6zz__evaluate_compz00(obj_t);
	static obj_t BGl_z62runz62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33324ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_unwindzd2untilz12zc0zz__bexitz00(obj_t, obj_t);
	extern bool_t BGl_numberzf3zf3zz__r4_numbers_6_5z00(obj_t);
	static obj_t BGl_z62zc3z04anonymousza31810ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33503ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33325ze3ze5zz__evaluate_compz00(obj_t);
	static double BGl_evalzd2floatzd2arithz00zz__evaluate_compz00(obj_t, obj_t);
	extern int bgl_debug();
	extern obj_t BGl_ev_orz00zz__evaluate_typesz00;
	static obj_t BGl_pushzd2boxeszd2argszd2onzd2spz00zz__evaluate_compz00(obj_t,
		obj_t, obj_t, long, obj_t);
	extern obj_t BGl_ev_varz00zz__evaluate_typesz00;
	extern obj_t create_struct(obj_t, int);
	static obj_t BGl_z62compzd2ev_bindzd2exit1424z62zz__evaluate_compz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33253ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_get_profilez00zz__evaluate_compz00();
	static obj_t BGl_z62zc3z04anonymousza33237ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_evarityzd2errorzd2zz__everrorz00(obj_t, obj_t, int, int);
	extern long bgl_list_length(obj_t);
	static obj_t BGl_z62run5701z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5703z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5705z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5707z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_gczd2rootszd2initz00zz__evaluate_compz00();
	static obj_t BGl_z62run5709z62zz__evaluate_compz00(obj_t, obj_t);
	extern obj_t BGl_evwarningz00zz__everrorz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32096ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static bool_t BGl_needzd2shiftzd2zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5711z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5713z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5715z62zz__evaluate_compz00(obj_t, obj_t);
	extern obj_t BGl_evmodulezd2findzd2globalz00zz__evmodulez00(obj_t, obj_t);
	extern obj_t BGl_ev_andz00zz__evaluate_typesz00;
	static obj_t BGl_z62run5717z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5719z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62compzd2ev_withzd2handler1429z62zz__evaluate_compz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33328ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33077ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62run5721z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5723z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5725z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33450ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62run5727z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza31903ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62run5729z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5731z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62mainz62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62run5733z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5735z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33702ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32811ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62run5737z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5739z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32293ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_appz00zz__evaluate_typesz00;
	static obj_t BGl_z62run5741z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_lnamez00zz__evaluate_compz00(obj_t);
	static obj_t BGl_z62run5743z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5745z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62compzd2ev_letza21420z12zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62run5747z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5749z62zz__evaluate_compz00(obj_t, obj_t);
	extern obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_bigloozd2typezd2errorz00zz__errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62compzd2ev_litt1408zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_exitdzd2popzd2protectz12z12zz__bexitz00(obj_t);
	static obj_t BGl_z62run5751z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5753z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33720ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62run5755z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5757z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5759z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62compz62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_ev_synchroniza7eza7zz__evaluate_typesz00;
	extern obj_t BGl_uncompilez00zz__evaluate_uncompz00(BgL_ev_exprz00_bglt);
	static obj_t BGl_z62run5761z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5763z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33632ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62run5765z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5767z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5769z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62main5700z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62main5702z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62main5704z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62main5706z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62main5708z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62run5771z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5773z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32831ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62run5775z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32815ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33366ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62run5777z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33528ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62run5779z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62main5710z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62main5712z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62main5714z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62main5716z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62main5718z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_evmodulezd2bindzd2globalz12z12zz__evmodulez00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_usez00zz__evaluate_usez00(BgL_ev_exprz00_bglt, obj_t);
	static obj_t BGl_z62run5781z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5783z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5785z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza31836ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main5720z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62main5722z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5724z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5726z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5728z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza31926ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_za2za2azd2labelza2za2zd2zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62main5730z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5732z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5734z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5736z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5738z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t
		BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_ev_exprz00_bglt, long,
		obj_t, obj_t);
	static obj_t BGl_makezd2statezd2zz__evaluate_compz00();
	static obj_t BGl_z62zc3z04anonymousza33741ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33652ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_defglobalz00zz__evaluate_typesz00;
	static obj_t BGl_z62main5740z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62main5742z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62main5744z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62main5746z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62compzd2ev_trap1393zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5748z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32003ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza32851ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33491ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32835ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33548ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32819ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main5750z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62main5752z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62main5754z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62main5756z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62main5758z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32763ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza31783ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza31929ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33298ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5760z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62main5762z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62main5764z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62main5766z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62main5768z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_zc3z04exitza33319ze3ze70z60zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_prog21416zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33906ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33582ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_listzd2ze3vectorz31zz__r4_vectors_6_8z00(obj_t);
	static obj_t BGl_z62main5770z62zz__evaluate_compz00(obj_t);
	static obj_t BGl_z62main5772z62zz__evaluate_compz00(obj_t);
	static obj_t BGl_z62main5774z62zz__evaluate_compz00(obj_t);
	static obj_t BGl_z62main5776z62zz__evaluate_compz00(obj_t);
	static obj_t BGl_z62main5778z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_toplevelzd2initzd2zz__evaluate_compz00();
	static obj_t BGl_z62zc3z04anonymousza33818ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33729ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza31947ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main5780z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62main5782z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62main5784z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33003ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32960ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33924ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza31980ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32855ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza31964ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32839ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza31859ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(obj_t, obj_t);
	static obj_t BGl_genericzd2initzd2zz__evaluate_compz00();
	extern obj_t BGl_stringzd2copyzd2zz__r4_strings_6_7z00(obj_t);
	extern obj_t BGl_ev_prog2z00zz__evaluate_typesz00;
	static obj_t BGl_z62zc3z04anonymousza32024ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_evtypezd2errorzd2zz__everrorz00(obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33852ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32872ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32783ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32767ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_bindzd2exitzd2zz__evaluate_typesz00;
	static obj_t BGl_z62zc3z04anonymousza32946ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t bgl_reverse_bang(obj_t);
	static long BGl_za2za2siza7ezd2stackza2za2z75zz__evaluate_compz00;
	static obj_t BGl_z62zc3z04anonymousza33006ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32963ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33692ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00;
	static obj_t BGl_z62zc3z04anonymousza33944ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32875ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32859ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_letza2za2zz__evaluate_typesz00;
	static obj_t BGl_z62compzd2ev_let1418zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32981ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33767ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33678ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32787ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_goto1435zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_ev_trapz00zz__evaluate_typesz00;
	static obj_t BGl_symbol5915z00zz__evaluate_compz00 = BUNSPEC;
	extern obj_t BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static bool_t BGl_makezd2boxeszd2zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32208ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32046ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_indexz00zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32967ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32878ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32152ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t
		BGl_globalzd2funzd2valuez00zz__evaluate_compz00(BgL_ev_exprz00_bglt);
	static obj_t BGl_z62compzd2ev_global1400zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static bool_t BGl_freezd2restorezd2zz__evaluate_compz00(obj_t, obj_t, long);
	extern obj_t BGl_ev_setglobalz00zz__evaluate_typesz00;
	static obj_t BGl_z62zc3z04anonymousza32984ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol5932z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5934z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza33060ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32331ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol5936z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5938z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62compzd2ev_synchroniza7e1431z17zz__evaluate_compz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33312ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32065ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl__indexz00zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_inlinezd2callzd2zz__evaluate_compz00(obj_t,
		BgL_ev_exprz00_bglt, obj_t, obj_t);
	static obj_t BGl_symbol5790z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5792z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5794z00zz__evaluate_compz00 = BUNSPEC;
	BGL_EXPORTED_DECL obj_t BGl_findzd2statezd2zz__evaluate_compz00();
	static obj_t BGl_z62zc3z04anonymousza33208ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_var1395zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33894ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33967ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32987ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_compzd2withzd2pushz00zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62compzd2ev_app1437zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62compilez62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33136ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern bool_t bigloo_string_lt(obj_t, obj_t);
	static obj_t BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza33137ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33048ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62findzd2statezb0zz__evaluate_compz00(obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zz__evaluate_compz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_usez00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_uncompz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evmodulez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__everrorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evcompilez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evenvz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__expandz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__prognz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__ppz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(long, char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__srfi4z00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__dssslz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bignumz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__structurez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__tvectorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__typez00(long, char *);
	extern obj_t BGl_sortz00zz__r4_vectors_6_8z00(obj_t, obj_t);
	extern obj_t BGl_ev_globalz00zz__evaluate_typesz00;
	static obj_t BGl_z62zc3z04anonymousza33154ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33171ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_integerzd2ze3stringz31zz__r4_numbers_6_5_fixnumz00(long,
		long);
	extern obj_t BGl_ev_littz00zz__evaluate_typesz00;
	static obj_t BGl_z62compzd2ev_and1414zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_loczd2typezd2errorz00zz__evaluate_compz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33512ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_cnstzd2initzd2zz__evaluate_compz00();
	static obj_t BGl_z62zc3z04anonymousza33988ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zz__evaluate_compz00();
	static obj_t BGl_z62zc3z04anonymousza32371ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_withzd2handlerzd2zz__evaluate_typesz00;
	static obj_t BGl_z62compzd2ev_abs1439zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32550ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32089ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_letrec1422zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32373ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33175ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32179ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern bool_t BGl_evmodulezf3zf3zz__evmodulez00(obj_t);
	static obj_t BGl_compzd2call0zd2zz__evaluate_compz00(obj_t,
		BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long);
	static obj_t BGl_compzd2call1zd2zz__evaluate_compz00(obj_t,
		BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long, obj_t);
	static obj_t BGl_compzd2call2zd2zz__evaluate_compz00(obj_t,
		BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long, obj_t, obj_t);
	static obj_t BGl_compzd2call3zd2zz__evaluate_compz00(obj_t,
		BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t);
	static obj_t BGl_compzd2call4zd2zz__evaluate_compz00(obj_t,
		BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32803ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_if1410zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33605ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_exprz00zz__evaluate_typesz00;
	static obj_t BGl_z62zc3z04anonymousza33460ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33371ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33444ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33088ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62comp1389z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33801ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33623ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_setlocal1397zb0zz__evaluate_compz00(obj_t,
		obj_t, obj_t);
	extern bool_t BGl_2zc3zd3z10zz__r4_numbers_6_5z00(obj_t, obj_t);
	static obj_t BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32377ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62compzd2ev_defglobal1406zb0zz__evaluate_compz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_compz00zz__evaluate_compz00(BgL_ev_exprz00_bglt, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32823ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33536ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32807ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_unwindzd2prote1426z62zz__evaluate_compz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62compzd2ev_setglobal1404zb0zz__evaluate_compz00(obj_t,
		obj_t, obj_t);
	extern bool_t BGl_2ze3zd3z30zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern obj_t BGl_ev_setlocalz00zz__evaluate_typesz00;
	static obj_t BGl_zc3z04exitza33299ze3ze70z60zz__evaluate_compz00(obj_t, obj_t,
		obj_t, long, obj_t);
	static obj_t BGl_z62zc3z04anonymousza31933ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_arithzd2expressionzd2zz__evaluate_compz00(BgL_ev_appz00_bglt,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33643ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t *__cnst;


	   
		 
		DEFINE_STATIC_BGL_PROCEDURE(BGl_zc3lexintzd2envz11zz__evaluate_compz00,
		BgL_bgl_za762za7c3lexintza7a1za75942z00,
		BGl_z62zc3lexintza1zz__evaluate_compz00, 0L, BUNSPEC, 2);
	extern obj_t BGl_zd2zd2envz00zz__r4_numbers_6_5z00;
	extern obj_t BGl_zd3zd2envz01zz__r4_numbers_6_5z00;
	extern obj_t BGl_f64vectorzd2refzd2envz00zz__srfi4z00;
	extern obj_t BGl_ze3zd3fxzd2envze2zz__r4_numbers_6_5_fixnumz00;
	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_compilezd2envzd2zz__evaluate_compz00,
		BgL_bgl_za762compileza762za7za7_5943z00,
		BGl_z62compilez62zz__evaluate_compz00, 0L, BUNSPEC, 1);
	extern obj_t BGl_zc3fxzd2envz11zz__r4_numbers_6_5_fixnumz00;
	extern obj_t BGl_zc3zd3flzd2envzc2zz__r4_numbers_6_5_flonumz00;
	extern obj_t BGl_ze3zd2envz31zz__r4_numbers_6_5z00;
	extern obj_t BGl_zf2zd2envz20zz__r4_numbers_6_5z00;
	extern obj_t BGl_zd2fxzd2envz00zz__r4_numbers_6_5_fixnumz00;
	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_findzd2statezd2envz00zz__evaluate_compz00,
		BgL_bgl_za762findza7d2stateza75944za7,
		BGl_z62findzd2statezb0zz__evaluate_compz00, 0L, BUNSPEC, 0);
	extern obj_t BGl_zb2flzd2envz60zz__r4_numbers_6_5_flonumz00;
	extern obj_t BGl_ze3fxzd2envz31zz__r4_numbers_6_5_fixnumz00;
	extern obj_t BGl_ze3zd3flzd2envze2zz__r4_numbers_6_5_flonumz00;
	extern obj_t BGl_zc3flzd2envz11zz__r4_numbers_6_5_flonumz00;
	extern obj_t BGl_zc3zd3zd2envzc2zz__r4_numbers_6_5z00;
	   
		 
		DEFINE_STRING(BGl_string5801z00zz__evaluate_compz00,
		BgL_bgl_string5801za700za7za7_5945za7, "at", 2);
	      DEFINE_STRING(BGl_string5802z00zz__evaluate_compz00,
		BgL_bgl_string5802za700za7za7_5946za7, "", 0);
	      DEFINE_STRING(BGl_string5803z00zz__evaluate_compz00,
		BgL_bgl_string5803za700za7za7_5947za7,
		"/tmp/bigloo/runtime/Eval/evaluate_comp.scm", 42);
	      DEFINE_STRING(BGl_string5804z00zz__evaluate_compz00,
		BgL_bgl_string5804za700za7za7_5948za7, "&compile", 8);
	      DEFINE_STRING(BGl_string5805z00zz__evaluate_compz00,
		BgL_bgl_string5805za700za7za7_5949za7, "ev_expr", 7);
	      DEFINE_STRING(BGl_string5806z00zz__evaluate_compz00,
		BgL_bgl_string5806za700za7za7_5950za7, "expecting ~a, got ~a", 20);
	      DEFINE_STRING(BGl_string5807z00zz__evaluate_compz00,
		BgL_bgl_string5807za700za7za7_5951za7, "wrong number of argument", 24);
	      DEFINE_STRING(BGl_string5809z00zz__evaluate_compz00,
		BgL_bgl_string5809za700za7za7_5952za7, "mcell", 5);
	extern obj_t BGl_zf2fxzd2envz20zz__r4_numbers_6_5_fixnumz00;
	   
		 
		DEFINE_STRING(BGl_string5811z00zz__evaluate_compz00,
		BgL_bgl_string5811za700za7za7_5953za7, "internal", 8);
	      DEFINE_STRING(BGl_string5813z00zz__evaluate_compz00,
		BgL_bgl_string5813za700za7za7_5954za7, "impossible", 10);
	      DEFINE_STRING(BGl_string5814z00zz__evaluate_compz00,
		BgL_bgl_string5814za700za7za7_5955za7, "procedure", 9);
	      DEFINE_STRING(BGl_string5816z00zz__evaluate_compz00,
		BgL_bgl_string5816za700za7za7_5956za7, "user", 4);
	      DEFINE_STRING(BGl_string5817z00zz__evaluate_compz00,
		BgL_bgl_string5817za700za7za7_5957za7, "invalid byte code", 17);
	      DEFINE_STRING(BGl_string5819z00zz__evaluate_compz00,
		BgL_bgl_string5819za700za7za7_5958za7, "+", 1);
	      DEFINE_STRING(BGl_string5821z00zz__evaluate_compz00,
		BgL_bgl_string5821za700za7za7_5959za7, "number", 6);
	      DEFINE_STRING(BGl_string5823z00zz__evaluate_compz00,
		BgL_bgl_string5823za700za7za7_5960za7, "-", 1);
	      DEFINE_STRING(BGl_string5825z00zz__evaluate_compz00,
		BgL_bgl_string5825za700za7za7_5961za7, "*", 1);
	      DEFINE_STRING(BGl_string5827z00zz__evaluate_compz00,
		BgL_bgl_string5827za700za7za7_5962za7, "/", 1);
	      DEFINE_STRING(BGl_string5829z00zz__evaluate_compz00,
		BgL_bgl_string5829za700za7za7_5963za7, "<", 1);
	extern obj_t BGl_za2fxzd2envz70zz__r4_numbers_6_5_fixnumz00;
	   
		 
		DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5900z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_and5964z00,
		BGl_z62compzd2ev_and1414zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5901z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_pro5965z00,
		BGl_z62compzd2ev_prog21416zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5902z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_let5966z00,
		BGl_z62compzd2ev_let1418zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5903z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_let5967z00,
		BGl_z62compzd2ev_letza21420z12zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_GENERIC(BGl_compzd2envzd2zz__evaluate_compz00,
		BgL_bgl_za762compza762za7za7__ev5968z00, BGl_z62compz62zz__evaluate_compz00,
		0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5904z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_let5969z00,
		BGl_z62compzd2ev_letrec1422zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5905z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_bin5970z00,
		BGl_z62compzd2ev_bindzd2exit1424z62zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5906z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_unw5971z00,
		BGl_z62compzd2ev_unwindzd2prote1426z62zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string5831z00zz__evaluate_compz00,
		BgL_bgl_string5831za700za7za7_5972za7, ">", 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5907z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_wit5973z00,
		BGl_z62compzd2ev_withzd2handler1429z62zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5908z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_syn5974z00,
		BGl_z62compzd2ev_synchroniza7e1431z17zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string5833z00zz__evaluate_compz00,
		BgL_bgl_string5833za700za7za7_5975za7, "<=", 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5909z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_lab5976z00,
		BGl_z62compzd2ev_labels1433zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string5835z00zz__evaluate_compz00,
		BgL_bgl_string5835za700za7za7_5977za7, ">=", 2);
	      DEFINE_STRING(BGl_string5837z00zz__evaluate_compz00,
		BgL_bgl_string5837za700za7za7_5978za7, "=", 1);
	      DEFINE_STRING(BGl_string5839z00zz__evaluate_compz00,
		BgL_bgl_string5839za700za7za7_5979za7, "+fx", 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5910z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_got5980z00,
		BGl_z62compzd2ev_goto1435zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5911z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_app5981z00,
		BGl_z62compzd2ev_app1437zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5912z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_abs5982z00,
		BGl_z62compzd2ev_abs1439zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string5841z00zz__evaluate_compz00,
		BgL_bgl_string5841za700za7za7_5983za7, "fixnum", 6);
	      DEFINE_STRING(BGl_string5843z00zz__evaluate_compz00,
		BgL_bgl_string5843za700za7za7_5984za7, "-fx", 3);
	      DEFINE_STRING(BGl_string5845z00zz__evaluate_compz00,
		BgL_bgl_string5845za700za7za7_5985za7, "*fx", 3);
	      DEFINE_STRING(BGl_string5847z00zz__evaluate_compz00,
		BgL_bgl_string5847za700za7za7_5986za7, "/fx", 3);
	      DEFINE_STRING(BGl_string5849z00zz__evaluate_compz00,
		BgL_bgl_string5849za700za7za7_5987za7, "<fx", 3);
	extern obj_t BGl_zd2flzd2envz00zz__r4_numbers_6_5_flonumz00;
	   
		 
		DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5924z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3za704anonymo5988za7,
		BGl_z62zc3z04anonymousza32957ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5925z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3za704anonymo5989za7,
		BGl_z62zc3z04anonymousza32960ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5926z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3za704anonymo5990za7,
		BGl_z62zc3z04anonymousza32963ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string5851z00zz__evaluate_compz00,
		BgL_bgl_string5851za700za7za7_5991za7, ">fx", 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5927z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3za704anonymo5992za7,
		BGl_z62zc3z04anonymousza32967ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5928z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3za704anonymo5993za7,
		BGl_z62zc3z04anonymousza32970ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string5853z00zz__evaluate_compz00,
		BgL_bgl_string5853za700za7za7_5994za7, "<=fx", 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5929z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3za704anonymo5995za7,
		BGl_z62zc3z04anonymousza32973ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string5855z00zz__evaluate_compz00,
		BgL_bgl_string5855za700za7za7_5996za7, ">=fx", 4);
	      DEFINE_STRING(BGl_string5857z00zz__evaluate_compz00,
		BgL_bgl_string5857za700za7za7_5997za7, "=fx", 3);
	      DEFINE_STRING(BGl_string5859z00zz__evaluate_compz00,
		BgL_bgl_string5859za700za7za7_5998za7, "+fl", 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5930z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3za704anonymo5999za7,
		BGl_z62zc3z04anonymousza32978ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5931z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3za704anonymo6000za7,
		BGl_z62zc3z04anonymousza32981ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string5861z00zz__evaluate_compz00,
		BgL_bgl_string5861za700za7za7_6001za7, "flonum", 6);
	      DEFINE_STRING(BGl_string5863z00zz__evaluate_compz00,
		BgL_bgl_string5863za700za7za7_6002za7, "-fl", 3);
	      DEFINE_STRING(BGl_string5865z00zz__evaluate_compz00,
		BgL_bgl_string5865za700za7za7_6003za7, "*fl", 3);
	      DEFINE_STRING(BGl_string5867z00zz__evaluate_compz00,
		BgL_bgl_string5867za700za7za7_6004za7, "/fl", 3);
	      DEFINE_STRING(BGl_string5869z00zz__evaluate_compz00,
		BgL_bgl_string5869za700za7za7_6005za7, "<fl", 3);
	      DEFINE_STRING(BGl_string5871z00zz__evaluate_compz00,
		BgL_bgl_string5871za700za7za7_6006za7, ">fl", 3);
	      DEFINE_STRING(BGl_string5873z00zz__evaluate_compz00,
		BgL_bgl_string5873za700za7za7_6007za7, "<=fl", 4);
	      DEFINE_STRING(BGl_string5875z00zz__evaluate_compz00,
		BgL_bgl_string5875za700za7za7_6008za7, ">=fl", 4);
	      DEFINE_STRING(BGl_string5877z00zz__evaluate_compz00,
		BgL_bgl_string5877za700za7za7_6009za7, "=fl", 3);
	      DEFINE_STRING(BGl_string5879z00zz__evaluate_compz00,
		BgL_bgl_string5879za700za7za7_6010za7, "car", 3);
	      DEFINE_STRING(BGl_string5881z00zz__evaluate_compz00,
		BgL_bgl_string5881za700za7za7_6011za7, "pair", 4);
	      DEFINE_STRING(BGl_string5883z00zz__evaluate_compz00,
		BgL_bgl_string5883za700za7za7_6012za7, "cdr", 3);
	      DEFINE_STRING(BGl_string5885z00zz__evaluate_compz00,
		BgL_bgl_string5885za700za7za7_6013za7, "cadr", 4);
	      DEFINE_STRING(BGl_string5887z00zz__evaluate_compz00,
		BgL_bgl_string5887za700za7za7_6014za7, "comp1389", 8);
	      DEFINE_STRING(BGl_string5888z00zz__evaluate_compz00,
		BgL_bgl_string5888za700za7za7_6015za7, "internal error: not defined for",
		31);
	      DEFINE_STRING(BGl_string5889z00zz__evaluate_compz00,
		BgL_bgl_string5889za700za7za7_6016za7, "&comp", 5);
	extern obj_t BGl_carzd2envzd2zz__r4_pairs_and_lists_6_3z00;
	   
		 
		DEFINE_STRING(BGl_string5891z00zz__evaluate_compz00,
		BgL_bgl_string5891za700za7za7_6017za7, "comp", 4);
	extern obj_t BGl_cadrzd2envzd2zz__r4_pairs_and_lists_6_3z00;
	extern obj_t BGl_ze3zd3zd2envze2zz__r4_numbers_6_5z00;
	extern obj_t BGl_ze3flzd2envz31zz__r4_numbers_6_5_flonumz00;
	extern obj_t BGl_zf2flzd2envz20zz__r4_numbers_6_5_flonumz00;
	extern obj_t BGl_za2flzd2envz70zz__r4_numbers_6_5_flonumz00;
	extern obj_t BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00;
	extern obj_t BGl_zd3fxzd2envz01zz__r4_numbers_6_5_fixnumz00;
	extern obj_t BGl_eqzf3zd2envz21zz__r4_equivalence_6_2z00;
	extern obj_t BGl_cdrzd2envzd2zz__r4_pairs_and_lists_6_3z00;
	extern obj_t BGl_fixnumzd2ze3flonumzd2envze3zz__r4_numbers_6_5z00;
	extern obj_t BGl_za2zd2envz70zz__r4_numbers_6_5z00;
	extern obj_t BGl_zc3zd3fxzd2envzc2zz__r4_numbers_6_5_fixnumz00;
	   
		 
		DEFINE_STRING(BGl_string5913z00zz__evaluate_compz00,
		BgL_bgl_string5913za700za7za7_6018za7, "internal error", 14);
	      DEFINE_STRING(BGl_string5914z00zz__evaluate_compz00,
		BgL_bgl_string5914za700za7za7_6019za7, "must be dead code", 17);
	      DEFINE_STRING(BGl_string5916z00zz__evaluate_compz00,
		BgL_bgl_string5916za700za7za7_6020za7, "notyet", 6);
	      DEFINE_STRING(BGl_string5917z00zz__evaluate_compz00,
		BgL_bgl_string5917za700za7za7_6021za7, "synchronize", 11);
	      DEFINE_STRING(BGl_string5918z00zz__evaluate_compz00,
		BgL_bgl_string5918za700za7za7_6022za7, "mutex", 5);
	      DEFINE_STRING(BGl_string5919z00zz__evaluate_compz00,
		BgL_bgl_string5919za700za7za7_6023za7, "set!", 4);
	extern obj_t BGl_zb2zd2envz60zz__r4_numbers_6_5z00;
	   
		 
		DEFINE_STRING(BGl_string5920z00zz__evaluate_compz00,
		BgL_bgl_string5920za700za7za7_6024za7, "read-only variable", 18);
	      DEFINE_STRING(BGl_string5921z00zz__evaluate_compz00,
		BgL_bgl_string5921za700za7za7_6025za7,
		"\nRedefinition of compiled variable -- ", 38);
	      DEFINE_STRING(BGl_string5922z00zz__evaluate_compz00,
		BgL_bgl_string5922za700za7za7_6026za7, "Unbound variable", 16);
	      DEFINE_STRING(BGl_string5923z00zz__evaluate_compz00,
		BgL_bgl_string5923za700za7za7_6027za7, "Uninitialized variable", 22);
	extern obj_t BGl_zd3flzd2envz01zz__r4_numbers_6_5_flonumz00;
	   
		 
		DEFINE_STRING(BGl_string5933z00zz__evaluate_compz00,
		BgL_bgl_string5933za700za7za7_6028za7, "get_sp", 6);
	      DEFINE_STRING(BGl_string5935z00zz__evaluate_compz00,
		BgL_bgl_string5935za700za7za7_6029za7, "reset_profile", 13);
	      DEFINE_STRING(BGl_string5937z00zz__evaluate_compz00,
		BgL_bgl_string5937za700za7za7_6030za7, "get_profile", 11);
	      DEFINE_STRING(BGl_string5939z00zz__evaluate_compz00,
		BgL_bgl_string5939za700za7za7_6031za7, "reset_stack", 11);
	      DEFINE_STRING(BGl_string5940z00zz__evaluate_compz00,
		BgL_bgl_string5940za700za7za7_6032za7, "internal error: unknown command",
		31);
	      DEFINE_STRING(BGl_string5941z00zz__evaluate_compz00,
		BgL_bgl_string5941za700za7za7_6033za7, "__evaluate_comp", 15);
	      DEFINE_STRING(BGl_string5791z00zz__evaluate_compz00,
		BgL_bgl_string5791za700za7za7_6034za7, "all", 3);
	      DEFINE_STRING(BGl_string5793z00zz__evaluate_compz00,
		BgL_bgl_string5793za700za7za7_6035za7, "label-tag", 9);
	      DEFINE_STRING(BGl_string5795z00zz__evaluate_compz00,
		BgL_bgl_string5795za700za7za7_6036za7, "bounce", 6);
	      DEFINE_STRING(BGl_string5796z00zz__evaluate_compz00,
		BgL_bgl_string5796za700za7za7_6037za7, "non non non", 11);
	      DEFINE_STRING(BGl_string5797z00zz__evaluate_compz00,
		BgL_bgl_string5797za700za7za7_6038za7, " in ", 4);
	      DEFINE_STRING(BGl_string5798z00zz__evaluate_compz00,
		BgL_bgl_string5798za700za7za7_6039za7, "eval", 4);
	      DEFINE_STRING(BGl_string5799z00zz__evaluate_compz00,
		BgL_bgl_string5799za700za7za7_6040za7, "internal error: not found", 25);
	extern obj_t BGl_zc3zd2envz11zz__r4_numbers_6_5z00;
	extern obj_t BGl_zb2fxzd2envz60zz__r4_numbers_6_5_fixnumz00;
	   
		 
		DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5886z00zz__evaluate_compz00,
		BgL_bgl_za762comp1389za762za7za76041z00,
		BGl_z62comp1389z62zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5890z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_tra6042z00,
		BGl_z62compzd2ev_trap1393zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5892z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_var6043z00,
		BGl_z62compzd2ev_var1395zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5893z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_set6044z00,
		BGl_z62compzd2ev_setlocal1397zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5894z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_glo6045z00,
		BGl_z62compzd2ev_global1400zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5895z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_set6046z00,
		BGl_z62compzd2ev_setglobal1404zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5896z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_def6047z00,
		BGl_z62compzd2ev_defglobal1406zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5897z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_lit6048z00,
		BGl_z62compzd2ev_litt1408zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5898z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_if16049z00,
		BGl_z62compzd2ev_if1410zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5899z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_or16050z00,
		BGl_z62compzd2ev_or1412zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);

/* GC roots registration */
	static obj_t bgl_gc_roots_register()
	{
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
		void *roots_min = (void *) ULONG_MAX, *roots_max = 0;
		     ADD_ROOT((void *) (&BGl_symbol5800z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5808z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5810z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5812z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5815z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5818z00zz__evaluate_compz00));
		   
			 ADD_ROOT((void *) (&BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5820z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5822z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5824z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5826z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5828z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5830z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5832z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5834z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5836z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5838z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5840z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5842z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5844z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5846z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5848z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5850z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5852z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5854z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5856z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5858z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5860z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5862z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5864z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5866z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5868z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5870z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5872z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5874z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5876z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5878z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5880z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5882z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5884z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_za2za2azd2labelza2za2zd2zz__evaluate_compz00));
		   
			 ADD_ROOT((void
				*) (&BGl_requirezd2initializa7ationz75zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5915z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5932z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5934z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5936z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5938z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5790z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5792z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5794z00zz__evaluate_compz00));
		   
			 ADD_ROOT((void
				*) (&BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00));
#undef ADD_ROOT
		if   (roots_max > 0)
			     GC_add_roots(roots_min, ((void **) roots_max) + 1);
#endif
		     return BUNSPEC;
	}



/* module-initialization */
	BGL_EXPORTED_DEF obj_t
		BGl_modulezd2initializa7ationz75zz__evaluate_compz00(long
		BgL_checksumz00_18355, char *BgL_fromz00_18356)
	{
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zz__evaluate_compz00))
				{
					BGl_requirezd2initializa7ationz75zz__evaluate_compz00 =
						BBOOL(((bool_t) 0));
					BGl_gczd2rootszd2initz00zz__evaluate_compz00();
					BGl_cnstzd2initzd2zz__evaluate_compz00();
					BGl_importedzd2moduleszd2initz00zz__evaluate_compz00();
					BGl_genericzd2initzd2zz__evaluate_compz00();
					BGl_methodzd2initzd2zz__evaluate_compz00();
					return BGl_toplevelzd2initzd2zz__evaluate_compz00();
				}
			else
				{
					return BUNSPEC;
				}
		}

	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zz__evaluate_compz00()
	{
		{	/* Eval/evaluate_comp.scm 15 */
			BGl_symbol5790z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5791z00zz__evaluate_compz00);
			BGl_symbol5792z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5793z00zz__evaluate_compz00);
			BGl_symbol5794z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5795z00zz__evaluate_compz00);
			BGl_symbol5800z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5801z00zz__evaluate_compz00);
			BGl_symbol5808z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5809z00zz__evaluate_compz00);
			BGl_symbol5810z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5811z00zz__evaluate_compz00);
			BGl_symbol5812z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5813z00zz__evaluate_compz00);
			BGl_symbol5815z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5816z00zz__evaluate_compz00);
			BGl_symbol5818z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5819z00zz__evaluate_compz00);
			BGl_symbol5820z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5821z00zz__evaluate_compz00);
			BGl_symbol5822z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5823z00zz__evaluate_compz00);
			BGl_symbol5824z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5825z00zz__evaluate_compz00);
			BGl_symbol5826z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5827z00zz__evaluate_compz00);
			BGl_symbol5828z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5829z00zz__evaluate_compz00);
			BGl_symbol5830z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5831z00zz__evaluate_compz00);
			BGl_symbol5832z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5833z00zz__evaluate_compz00);
			BGl_symbol5834z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5835z00zz__evaluate_compz00);
			BGl_symbol5836z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5837z00zz__evaluate_compz00);
			BGl_symbol5838z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5839z00zz__evaluate_compz00);
			BGl_symbol5840z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5841z00zz__evaluate_compz00);
			BGl_symbol5842z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5843z00zz__evaluate_compz00);
			BGl_symbol5844z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5845z00zz__evaluate_compz00);
			BGl_symbol5846z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5847z00zz__evaluate_compz00);
			BGl_symbol5848z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5849z00zz__evaluate_compz00);
			BGl_symbol5850z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5851z00zz__evaluate_compz00);
			BGl_symbol5852z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5853z00zz__evaluate_compz00);
			BGl_symbol5854z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5855z00zz__evaluate_compz00);
			BGl_symbol5856z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5857z00zz__evaluate_compz00);
			BGl_symbol5858z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5859z00zz__evaluate_compz00);
			BGl_symbol5860z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5861z00zz__evaluate_compz00);
			BGl_symbol5862z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5863z00zz__evaluate_compz00);
			BGl_symbol5864z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5865z00zz__evaluate_compz00);
			BGl_symbol5866z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5867z00zz__evaluate_compz00);
			BGl_symbol5868z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5869z00zz__evaluate_compz00);
			BGl_symbol5870z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5871z00zz__evaluate_compz00);
			BGl_symbol5872z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5873z00zz__evaluate_compz00);
			BGl_symbol5874z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5875z00zz__evaluate_compz00);
			BGl_symbol5876z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5877z00zz__evaluate_compz00);
			BGl_symbol5878z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5879z00zz__evaluate_compz00);
			BGl_symbol5880z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5881z00zz__evaluate_compz00);
			BGl_symbol5882z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5883z00zz__evaluate_compz00);
			BGl_symbol5884z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5885z00zz__evaluate_compz00);
			BGl_symbol5915z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5916z00zz__evaluate_compz00);
			BGl_symbol5932z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5933z00zz__evaluate_compz00);
			BGl_symbol5934z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5935z00zz__evaluate_compz00);
			BGl_symbol5936z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5937z00zz__evaluate_compz00);
			return (BGl_symbol5938z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5939z00zz__evaluate_compz00), BUNSPEC);
		}

	}



/* gc-roots-init */
	obj_t BGl_gczd2rootszd2initz00zz__evaluate_compz00()
	{
		{	/* Eval/evaluate_comp.scm 15 */
			return bgl_gc_roots_register();
		}

	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zz__evaluate_compz00()
	{
		{	/* Eval/evaluate_comp.scm 15 */
			{	/* Eval/evaluate_comp.scm 114 */
				BGL_LONGLONG_T BgL_arg1483z00_1352;

				{	/* Eval/evaluate_comp.scm 114 */
					BGL_LONGLONG_T BgL_res4312z00_6396;

					BgL_res4312z00_6396 = LONG_TO_LLONG(((long) 0));
					BgL_arg1483z00_1352 = BgL_res4312z00_6396;
				}
				{	/* Eval/evaluate_comp.scm 114 */
					obj_t BgL_list1484z00_1353;

					{	/* Eval/evaluate_comp.scm 114 */
						obj_t BgL_arg1485z00_1354;

						BgL_arg1485z00_1354 =
							MAKE_YOUNG_PAIR(make_bllong(BgL_arg1483z00_1352), BNIL);
						BgL_list1484z00_1353 =
							MAKE_YOUNG_PAIR(BGl_symbol5790z00zz__evaluate_compz00,
							BgL_arg1485z00_1354);
					}
					BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00 =
						BgL_list1484z00_1353;
			}}
			BGl_za2za2siza7ezd2stackza2za2z75zz__evaluate_compz00 = ((long) 8192);
			BGl_za2za2azd2labelza2za2zd2zz__evaluate_compz00 =
				create_struct(BGl_symbol5792z00zz__evaluate_compz00,
				(int) (((long) 0)));
			BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00 =
				create_struct(BGl_symbol5794z00zz__evaluate_compz00,
				(int) (((long) 0)));
			return BUNSPEC;
		}

	}



/* append-21011 */
	obj_t BGl_appendzd221011zd2zz__evaluate_compz00(obj_t BgL_l1z00_1,
		obj_t BgL_l2z00_2)
	{
		{
			{
				obj_t BgL_headz00_1355;

				BgL_headz00_1355 = MAKE_YOUNG_PAIR(BNIL, BgL_l2z00_2);
				{
					obj_t BgL_prevz00_6421;
					obj_t BgL_tailz00_6422;

					BgL_prevz00_6421 = BgL_headz00_1355;
					BgL_tailz00_6422 = BgL_l1z00_1;
				BgL_loopz00_6420:
					if (PAIRP(BgL_tailz00_6422))
						{
							obj_t BgL_newzd2prevzd2_6428;

							BgL_newzd2prevzd2_6428 =
								MAKE_YOUNG_PAIR(CAR(BgL_tailz00_6422), BgL_l2z00_2);
							SET_CDR(BgL_prevz00_6421, BgL_newzd2prevzd2_6428);
							{
								obj_t BgL_tailz00_18429;
								obj_t BgL_prevz00_18428;

								BgL_prevz00_18428 = BgL_newzd2prevzd2_6428;
								BgL_tailz00_18429 = CDR(BgL_tailz00_6422);
								BgL_tailz00_6422 = BgL_tailz00_18429;
								BgL_prevz00_6421 = BgL_prevz00_18428;
								goto BgL_loopz00_6420;
							}
						}
					else
						{
							BNIL;
						}
				}
				return CDR(BgL_headz00_1355);
			}
		}

	}



/* reset_profile */
	obj_t BGl_reset_profilez00zz__evaluate_compz00()
	{
		{	/* Eval/evaluate_comp.scm 132 */
			{	/* Eval/evaluate_comp.scm 133 */
				BGL_LONGLONG_T BgL_arg1507z00_1383;

				{	/* Eval/evaluate_comp.scm 133 */
					BGL_LONGLONG_T BgL_res4321z00_6436;

					BgL_res4321z00_6436 = LONG_TO_LLONG(((long) 0));
					BgL_arg1507z00_1383 = BgL_res4321z00_6436;
				}
				{	/* Eval/evaluate_comp.scm 133 */
					obj_t BgL_list1508z00_1384;

					{	/* Eval/evaluate_comp.scm 133 */
						obj_t BgL_arg1511z00_1385;

						BgL_arg1511z00_1385 =
							MAKE_YOUNG_PAIR(make_bllong(BgL_arg1507z00_1383), BNIL);
						BgL_list1508z00_1384 =
							MAKE_YOUNG_PAIR(BGl_symbol5790z00zz__evaluate_compz00,
							BgL_arg1511z00_1385);
					}
					return (BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00 =
						BgL_list1508z00_1384, BUNSPEC);
				}
			}
		}

	}



/* o->s~0 */
	obj_t BGl_ozd2ze3sze70zd6zz__evaluate_compz00(obj_t BgL_vz00_1394)
	{
		{	/* Eval/evaluate_comp.scm 141 */
			if (BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(BgL_vz00_1394))
				{	/* Ieee/fixnum.scm 979 */

					return
						BGl_integerzd2ze3stringz31zz__r4_numbers_6_5_fixnumz00(
						(long) CINT(BgL_vz00_1394), ((long) 10));
				}
			else
				{	/* Eval/evaluate_comp.scm 138 */
					if (SYMBOLP(BgL_vz00_1394))
						{	/* Eval/evaluate_comp.scm 139 */
							obj_t BgL_res4324z00_6441;

							{	/* Eval/evaluate_comp.scm 139 */
								obj_t BgL_arg4159z00_6440;

								BgL_arg4159z00_6440 = SYMBOL_TO_STRING(BgL_vz00_1394);
								BgL_res4324z00_6441 =
									BGl_stringzd2copyzd2zz__r4_strings_6_7z00
									(BgL_arg4159z00_6440);
							}
							return BgL_res4324z00_6441;
						}
					else
						{	/* Eval/evaluate_comp.scm 139 */
							if (STRINGP(BgL_vz00_1394))
								{	/* Eval/evaluate_comp.scm 140 */
									return BgL_vz00_1394;
								}
							else
								{	/* Eval/evaluate_comp.scm 140 */
									return BGl_string5796z00zz__evaluate_compz00;
								}
						}
				}
		}

	}



/* &<lexint */
	obj_t BGl_z62zc3lexintza1zz__evaluate_compz00(obj_t BgL_envz00_13541,
		obj_t BgL_t1z00_13542, obj_t BgL_t2z00_13543)
	{
		{	/* Eval/evaluate_comp.scm 135 */
			{	/* Eval/evaluate_comp.scm 138 */
				bool_t BgL_tmpz00_18446;

				{	/* Eval/evaluate_comp.scm 142 */
					obj_t BgL_v1z00_15532;
					obj_t BgL_v2z00_15533;

					BgL_v1z00_15532 = CAR(((obj_t) BgL_t1z00_13542));
					BgL_v2z00_15533 = CAR(((obj_t) BgL_t2z00_13543));
					{	/* Eval/evaluate_comp.scm 143 */
						bool_t BgL_test6056z00_18451;

						if (BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(BgL_v1z00_15532))
							{	/* Eval/evaluate_comp.scm 143 */
								BgL_test6056z00_18451 =
									BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00
									(BgL_v2z00_15533);
							}
						else
							{	/* Eval/evaluate_comp.scm 143 */
								BgL_test6056z00_18451 = ((bool_t) 0);
							}
						if (BgL_test6056z00_18451)
							{	/* Eval/evaluate_comp.scm 143 */
								BgL_tmpz00_18446 =
									BGl_2zc3zc3zz__r4_numbers_6_5z00(BgL_v1z00_15532,
									BgL_v2z00_15533);
							}
						else
							{	/* Eval/evaluate_comp.scm 143 */
								BgL_tmpz00_18446 =
									bigloo_string_lt(BGl_ozd2ze3sze70zd6zz__evaluate_compz00
									(BgL_v1z00_15532),
									BGl_ozd2ze3sze70zd6zz__evaluate_compz00(BgL_v2z00_15533));
							}
					}
				}
				return BBOOL(BgL_tmpz00_18446);
			}
		}

	}



/* get_profile */
	obj_t BGl_get_profilez00zz__evaluate_compz00()
	{
		{	/* Eval/evaluate_comp.scm 147 */
			BGl_recze71ze7zz__evaluate_compz00
				(BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00);
			return BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00;
		}

	}



/* rec~1 */
	bool_t BGl_recze71ze7zz__evaluate_compz00(obj_t BgL_tz00_1403)
	{
		{	/* Eval/evaluate_comp.scm 148 */
			{	/* Eval/evaluate_comp.scm 149 */
				obj_t BgL_arg1523z00_1405;
				obj_t BgL_arg1524z00_1406;

				BgL_arg1523z00_1405 = CDR(((obj_t) BgL_tz00_1403));
				{	/* Eval/evaluate_comp.scm 149 */
					obj_t BgL_arg1528z00_1407;

					{	/* Eval/evaluate_comp.scm 149 */
						obj_t BgL_pairz00_6452;

						BgL_pairz00_6452 = CDR(((obj_t) BgL_tz00_1403));
						BgL_arg1528z00_1407 = CDR(BgL_pairz00_6452);
					}
					BgL_arg1524z00_1406 =
						BGl_sortz00zz__r4_vectors_6_8z00
						(BGl_zc3lexintzd2envz11zz__evaluate_compz00, BgL_arg1528z00_1407);
				}
				{	/* Eval/evaluate_comp.scm 149 */
					obj_t BgL_tmpz00_18467;

					BgL_tmpz00_18467 = ((obj_t) BgL_arg1523z00_1405);
					SET_CDR(BgL_tmpz00_18467, BgL_arg1524z00_1406);
				}
			}
			{	/* Eval/evaluate_comp.scm 150 */
				obj_t BgL_g1291z00_1408;

				{	/* Eval/evaluate_comp.scm 150 */
					obj_t BgL_pairz00_6457;

					BgL_pairz00_6457 = CDR(((obj_t) BgL_tz00_1403));
					BgL_g1291z00_1408 = CDR(BgL_pairz00_6457);
				}
				{
					obj_t BgL_l1289z00_6471;

					BgL_l1289z00_6471 = BgL_g1291z00_1408;
				BgL_zc3z04anonymousza31529ze3z87_6470:
					if (PAIRP(BgL_l1289z00_6471))
						{	/* Eval/evaluate_comp.scm 150 */
							BGl_recze71ze7zz__evaluate_compz00(CAR(BgL_l1289z00_6471));
							{
								obj_t BgL_l1289z00_18477;

								BgL_l1289z00_18477 = CDR(BgL_l1289z00_6471);
								BgL_l1289z00_6471 = BgL_l1289z00_18477;
								goto BgL_zc3z04anonymousza31529ze3z87_6470;
							}
						}
					else
						{	/* Eval/evaluate_comp.scm 150 */
							return ((bool_t) 1);
						}
				}
			}
		}

	}



/* index */
	obj_t BGl_indexz00zz__evaluate_compz00(obj_t BgL_xz00_6, obj_t BgL_lz00_7)
	{
		{	/* Eval/evaluate_comp.scm 156 */
			{
				obj_t BgL_lz00_6502;
				long BgL_nz00_6503;

				BgL_lz00_6502 = BgL_lz00_7;
				BgL_nz00_6503 = ((long) 0);
			BgL_walkz00_6501:
				if (NULLP(BgL_lz00_6502))
					{	/* Eval/evaluate_comp.scm 158 */
						return BFALSE;
					}
				else
					{	/* Eval/evaluate_comp.scm 158 */
						if ((BgL_xz00_6 == CAR(((obj_t) BgL_lz00_6502))))
							{	/* Eval/evaluate_comp.scm 159 */
								return BINT(BgL_nz00_6503);
							}
						else
							{
								long BgL_nz00_18489;
								obj_t BgL_lz00_18486;

								BgL_lz00_18486 = CDR(((obj_t) BgL_lz00_6502));
								BgL_nz00_18489 = (BgL_nz00_6503 + ((long) 1));
								BgL_nz00_6503 = BgL_nz00_18489;
								BgL_lz00_6502 = BgL_lz00_18486;
								goto BgL_walkz00_6501;
							}
					}
			}
		}

	}



/* _index */
	obj_t BGl__indexz00zz__evaluate_compz00(obj_t BgL_xz00_8, obj_t BgL_lz00_9)
	{
		{	/* Eval/evaluate_comp.scm 163 */
			{	/* Eval/evaluate_comp.scm 164 */
				obj_t BgL__ortest_1079z00_1428;

				BgL__ortest_1079z00_1428 =
					BGl_indexz00zz__evaluate_compz00(BgL_xz00_8, BgL_lz00_9);
				if (CBOOL(BgL__ortest_1079z00_1428))
					{	/* Eval/evaluate_comp.scm 164 */
						return BgL__ortest_1079z00_1428;
					}
				else
					{	/* Eval/evaluate_comp.scm 164 */
						obj_t BgL_arg1541z00_1429;

						{	/* Eval/evaluate_comp.scm 164 */
							obj_t BgL_arg1544z00_1430;

							if (NULLP(BgL_lz00_9))
								{	/* Eval/evaluate_comp.scm 164 */
									BgL_arg1544z00_1430 = BNIL;
								}
							else
								{	/* Eval/evaluate_comp.scm 164 */
									obj_t BgL_head1294z00_1436;

									{	/* Eval/evaluate_comp.scm 164 */
										obj_t BgL_arg1555z00_1448;

										{	/* Eval/evaluate_comp.scm 164 */
											obj_t BgL_arg1556z00_1449;

											BgL_arg1556z00_1449 = CAR(((obj_t) BgL_lz00_9));
											if (BGl_isazf3zf3zz__objectz00(BgL_arg1556z00_1449,
													BGl_ev_varz00zz__evaluate_typesz00))
												{	/* Eval/evaluate_comp.scm 189 */
													BgL_arg1555z00_1448 =
														(((BgL_ev_varz00_bglt) COBJECT(
																((BgL_ev_varz00_bglt) BgL_arg1556z00_1449)))->
														BgL_namez00);
												}
											else
												{	/* Eval/evaluate_comp.scm 189 */
													BgL_arg1555z00_1448 = BgL_arg1556z00_1449;
												}
										}
										{	/* Eval/evaluate_comp.scm 164 */
											obj_t BgL_res4337z00_6523;

											BgL_res4337z00_6523 =
												MAKE_YOUNG_PAIR(BgL_arg1555z00_1448, BNIL);
											BgL_head1294z00_1436 = BgL_res4337z00_6523;
										}
									}
									{	/* Eval/evaluate_comp.scm 164 */
										obj_t BgL_g1297z00_1437;

										BgL_g1297z00_1437 = CDR(((obj_t) BgL_lz00_9));
										{
											obj_t BgL_l1292z00_6548;
											obj_t BgL_tail1295z00_6549;

											BgL_l1292z00_6548 = BgL_g1297z00_1437;
											BgL_tail1295z00_6549 = BgL_head1294z00_1436;
										BgL_zc3z04anonymousza31550ze3z87_6547:
											if (NULLP(BgL_l1292z00_6548))
												{	/* Eval/evaluate_comp.scm 164 */
													BgL_arg1544z00_1430 = BgL_head1294z00_1436;
												}
											else
												{	/* Eval/evaluate_comp.scm 164 */
													obj_t BgL_newtail1296z00_6556;

													{	/* Eval/evaluate_comp.scm 164 */
														obj_t BgL_arg1553z00_6557;

														BgL_arg1553z00_6557 =
															BGl_lnamez00zz__evaluate_compz00(CAR(
																((obj_t) BgL_l1292z00_6548)));
														{	/* Eval/evaluate_comp.scm 164 */
															obj_t BgL_res4343z00_6562;

															BgL_res4343z00_6562 =
																MAKE_YOUNG_PAIR(BgL_arg1553z00_6557, BNIL);
															BgL_newtail1296z00_6556 = BgL_res4343z00_6562;
														}
													}
													SET_CDR(BgL_tail1295z00_6549,
														BgL_newtail1296z00_6556);
													{	/* Eval/evaluate_comp.scm 164 */
														obj_t BgL_arg1552z00_6559;

														BgL_arg1552z00_6559 =
															CDR(((obj_t) BgL_l1292z00_6548));
														{
															obj_t BgL_tail1295z00_18515;
															obj_t BgL_l1292z00_18514;

															BgL_l1292z00_18514 = BgL_arg1552z00_6559;
															BgL_tail1295z00_18515 = BgL_newtail1296z00_6556;
															BgL_tail1295z00_6549 = BgL_tail1295z00_18515;
															BgL_l1292z00_6548 = BgL_l1292z00_18514;
															goto BgL_zc3z04anonymousza31550ze3z87_6547;
														}
													}
												}
										}
									}
								}
							{	/* Eval/evaluate_comp.scm 164 */
								obj_t BgL_list1545z00_1431;

								{	/* Eval/evaluate_comp.scm 164 */
									obj_t BgL_arg1546z00_1432;

									{	/* Eval/evaluate_comp.scm 164 */
										obj_t BgL_arg1548z00_1433;

										BgL_arg1548z00_1433 =
											MAKE_YOUNG_PAIR(BgL_arg1544z00_1430, BNIL);
										BgL_arg1546z00_1432 =
											MAKE_YOUNG_PAIR(BGl_string5797z00zz__evaluate_compz00,
											BgL_arg1548z00_1433);
									}
									BgL_list1545z00_1431 =
										MAKE_YOUNG_PAIR(BgL_xz00_8, BgL_arg1546z00_1432);
								}
								BgL_arg1541z00_1429 = BgL_list1545z00_1431;
							}
						}
						return
							BGl_errorz00zz__errorz00(BGl_string5798z00zz__evaluate_compz00,
							BGl_string5799z00zz__evaluate_compz00, BgL_arg1541z00_1429);
					}
			}
		}

	}



/* lname */
	obj_t BGl_lnamez00zz__evaluate_compz00(obj_t BgL_vz00_16)
	{
		{	/* Eval/evaluate_comp.scm 188 */
			if (BGl_isazf3zf3zz__objectz00(BgL_vz00_16,
					BGl_ev_varz00zz__evaluate_typesz00))
				{	/* Eval/evaluate_comp.scm 189 */
					return
						(((BgL_ev_varz00_bglt) COBJECT(
								((BgL_ev_varz00_bglt) BgL_vz00_16)))->BgL_namez00);
				}
			else
				{	/* Eval/evaluate_comp.scm 189 */
					return BgL_vz00_16;
				}
		}

	}



/* loc-type-error */
	obj_t BGl_loczd2typezd2errorz00zz__evaluate_compz00(obj_t BgL_fz00_17,
		obj_t BgL_mz00_18, obj_t BgL_vz00_19, obj_t BgL_locz00_20)
	{
		{	/* Eval/evaluate_comp.scm 193 */
			if (PAIRP(BgL_locz00_20))
				{	/* Eval/evaluate_comp.scm 194 */
					obj_t BgL_cdrzd2194zd2_1475;

					BgL_cdrzd2194zd2_1475 = CDR(BgL_locz00_20);
					if ((CAR(BgL_locz00_20) == BGl_symbol5800z00zz__evaluate_compz00))
						{	/* Eval/evaluate_comp.scm 194 */
							if (PAIRP(BgL_cdrzd2194zd2_1475))
								{	/* Eval/evaluate_comp.scm 194 */
									obj_t BgL_cdrzd2198zd2_1479;

									BgL_cdrzd2198zd2_1479 = CDR(BgL_cdrzd2194zd2_1475);
									if (PAIRP(BgL_cdrzd2198zd2_1479))
										{	/* Eval/evaluate_comp.scm 194 */
											if (NULLP(CDR(BgL_cdrzd2198zd2_1479)))
												{	/* Eval/evaluate_comp.scm 194 */
													return
														BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
														(BgL_fz00_17, BgL_mz00_18, BgL_vz00_19,
														CAR(BgL_cdrzd2194zd2_1475),
														CAR(BgL_cdrzd2198zd2_1479));
												}
											else
												{	/* Eval/evaluate_comp.scm 194 */
													return
														BGl_bigloozd2typezd2errorz00zz__errorz00
														(BgL_fz00_17, BgL_mz00_18, BgL_vz00_19);
												}
										}
									else
										{	/* Eval/evaluate_comp.scm 194 */
											return
												BGl_bigloozd2typezd2errorz00zz__errorz00(BgL_fz00_17,
												BgL_mz00_18, BgL_vz00_19);
										}
								}
							else
								{	/* Eval/evaluate_comp.scm 194 */
									return
										BGl_bigloozd2typezd2errorz00zz__errorz00(BgL_fz00_17,
										BgL_mz00_18, BgL_vz00_19);
								}
						}
					else
						{	/* Eval/evaluate_comp.scm 194 */
							return
								BGl_bigloozd2typezd2errorz00zz__errorz00(BgL_fz00_17,
								BgL_mz00_18, BgL_vz00_19);
						}
				}
			else
				{	/* Eval/evaluate_comp.scm 194 */
					return
						BGl_bigloozd2typezd2errorz00zz__errorz00(BgL_fz00_17, BgL_mz00_18,
						BgL_vz00_19);
				}
		}

	}



/* make-state */
	obj_t BGl_makezd2statezd2zz__evaluate_compz00()
	{
		{	/* Eval/evaluate_comp.scm 206 */
			{	/* Eval/evaluate_comp.scm 207 */
				obj_t BgL_stkz00_1495;

				BgL_stkz00_1495 =
					make_vector(((long) 8192), BGl_string5802z00zz__evaluate_compz00);
				VECTOR_SET(BgL_stkz00_1495, ((long) 0), BINT(((long) 2)));
				return BgL_stkz00_1495;
			}
		}

	}



/* find-state */
	BGL_EXPORTED_DEF obj_t BGl_findzd2statezd2zz__evaluate_compz00()
	{
		{	/* Eval/evaluate_comp.scm 211 */
			{	/* Eval/evaluate_comp.scm 212 */
				obj_t BgL_sz00_1496;

				{	/* Eval/evaluate_comp.scm 212 */
					obj_t BgL_tmpz00_18549;

					BgL_tmpz00_18549 = BGL_CURRENT_DYNAMIC_ENV();
					BgL_sz00_1496 = BGL_ENV_EVSTATE(BgL_tmpz00_18549);
				}
				if (VECTORP(BgL_sz00_1496))
					{	/* Eval/evaluate_comp.scm 213 */
						return BgL_sz00_1496;
					}
				else
					{	/* Eval/evaluate_comp.scm 214 */
						obj_t BgL_statez00_1498;

						BgL_statez00_1498 = BGl_makezd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 215 */
							obj_t BgL_tmpz00_18555;

							BgL_tmpz00_18555 = BGL_CURRENT_DYNAMIC_ENV();
							BGL_ENV_EVSTATE_SET(BgL_tmpz00_18555, BgL_statez00_1498);
						}
						return BgL_statez00_1498;
					}
			}
		}

	}



/* &find-state */
	obj_t BGl_z62findzd2statezb0zz__evaluate_compz00(obj_t BgL_envz00_13544)
	{
		{	/* Eval/evaluate_comp.scm 211 */
			return BGl_findzd2statezd2zz__evaluate_compz00();
		}

	}



/* compile */
	BGL_EXPORTED_DEF obj_t BGl_compilez00zz__evaluate_compz00(BgL_ev_exprz00_bglt
		BgL_ez00_34)
	{
		{	/* Eval/evaluate_comp.scm 273 */
			return BGl_compz00zz__evaluate_compz00(BgL_ez00_34, BNIL);
		}

	}



/* &compile */
	obj_t BGl_z62compilez62zz__evaluate_compz00(obj_t BgL_envz00_13545,
		obj_t BgL_ez00_13546)
	{
		{	/* Eval/evaluate_comp.scm 273 */
			{	/* Eval/evaluate_comp.scm 274 */
				BgL_ev_exprz00_bglt BgL_auxz00_18560;

				if (BGl_isazf3zf3zz__objectz00(BgL_ez00_13546,
						BGl_ev_exprz00zz__evaluate_typesz00))
					{	/* Eval/evaluate_comp.scm 274 */
						BgL_auxz00_18560 = ((BgL_ev_exprz00_bglt) BgL_ez00_13546);
					}
				else
					{
						obj_t BgL_auxz00_18564;

						BgL_auxz00_18564 =
							BGl_typezd2errorzd2zz__errorz00
							(BGl_string5803z00zz__evaluate_compz00, BINT(((long) 7006)),
							BGl_string5804z00zz__evaluate_compz00,
							BGl_string5805z00zz__evaluate_compz00, BgL_ez00_13546);
						FAILURE(BgL_auxz00_18564, BFALSE, BFALSE);
					}
				return BGl_compilez00zz__evaluate_compz00(BgL_auxz00_18560);
			}
		}

	}



/* global-fun-value */
	obj_t BGl_globalzd2funzd2valuez00zz__evaluate_compz00(BgL_ev_exprz00_bglt
		BgL_ez00_43)
	{
		{	/* Eval/evaluate_comp.scm 332 */
			if (BGl_isazf3zf3zz__objectz00(
					((obj_t) BgL_ez00_43), BGl_ev_globalz00zz__evaluate_typesz00))
				{	/* Eval/evaluate_comp.scm 335 */
					obj_t BgL_gz00_1554;

					{	/* Eval/evaluate_comp.scm 335 */
						obj_t BgL_arg1645z00_1555;
						obj_t BgL_arg1647z00_1556;

						BgL_arg1645z00_1555 =
							(((BgL_ev_globalz00_bglt) COBJECT(
									((BgL_ev_globalz00_bglt) BgL_ez00_43)))->BgL_modz00);
						BgL_arg1647z00_1556 =
							(((BgL_ev_globalz00_bglt) COBJECT(
									((BgL_ev_globalz00_bglt) BgL_ez00_43)))->BgL_namez00);
						BgL_gz00_1554 =
							BGl_evmodulezd2findzd2globalz00zz__evmodulez00
							(BgL_arg1645z00_1555, BgL_arg1647z00_1556);
					}
					if (CBOOL(BgL_gz00_1554))
						{	/* Eval/evaluate_comp.scm 336 */
							return VECTOR_REF(((obj_t) BgL_gz00_1554), ((long) 2));
						}
					else
						{	/* Eval/evaluate_comp.scm 336 */
							return BFALSE;
						}
				}
			else
				{	/* Eval/evaluate_comp.scm 333 */
					return BFALSE;
				}
		}

	}



/* push-boxes-args-on-sp */
	obj_t BGl_pushzd2boxeszd2argszd2onzd2spz00zz__evaluate_compz00(obj_t
		BgL_sz00_82, obj_t BgL_argsz00_83, obj_t BgL_boxesz00_84, long BgL_spz00_85,
		obj_t BgL_locz00_86)
	{
		{	/* Eval/evaluate_comp.scm 616 */
			{
				obj_t BgL_lz00_1576;
				obj_t BgL_bsz00_1577;
				long BgL_spz00_1578;

				BgL_lz00_1576 = BgL_argsz00_83;
				BgL_bsz00_1577 = BgL_boxesz00_84;
				BgL_spz00_1578 = BgL_spz00_85;
			BgL_zc3z04anonymousza31664ze3z87_1579:
				if (NULLP(BgL_lz00_1576))
					{	/* Eval/evaluate_comp.scm 618 */
						if (NULLP(BgL_bsz00_1577))
							{	/* Eval/evaluate_comp.scm 619 */
								return BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 622 */
								obj_t BgL_arg1667z00_1582;

								{	/* Eval/evaluate_comp.scm 622 */
									long BgL_arg1668z00_1583;
									long BgL_arg1669z00_1584;

									BgL_arg1668z00_1583 = bgl_list_length(BgL_boxesz00_84);
									BgL_arg1669z00_1584 = bgl_list_length(BgL_argsz00_83);
									{	/* Eval/evaluate_comp.scm 621 */
										obj_t BgL_list1670z00_1585;

										{	/* Eval/evaluate_comp.scm 621 */
											obj_t BgL_arg1671z00_1586;

											BgL_arg1671z00_1586 =
												MAKE_YOUNG_PAIR(BINT(BgL_arg1669z00_1584), BNIL);
											BgL_list1670z00_1585 =
												MAKE_YOUNG_PAIR(BINT(BgL_arg1668z00_1583),
												BgL_arg1671z00_1586);
										}
										BgL_arg1667z00_1582 =
											BGl_formatz00zz__r4_output_6_10_3z00
											(BGl_string5806z00zz__evaluate_compz00,
											BgL_list1670z00_1585);
								}}
								return
									BGl_everrorz00zz__everrorz00(BgL_locz00_86,
									BGl_string5798z00zz__evaluate_compz00,
									BGl_string5807z00zz__evaluate_compz00, BgL_arg1667z00_1582);
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 618 */
						if (NULLP(BgL_bsz00_1577))
							{	/* Eval/evaluate_comp.scm 626 */
								obj_t BgL_arg1673z00_1588;

								{	/* Eval/evaluate_comp.scm 626 */
									long BgL_arg1675z00_1589;
									long BgL_arg1676z00_1590;

									BgL_arg1675z00_1589 = bgl_list_length(BgL_boxesz00_84);
									BgL_arg1676z00_1590 = bgl_list_length(BgL_argsz00_83);
									{	/* Eval/evaluate_comp.scm 625 */
										obj_t BgL_list1677z00_1591;

										{	/* Eval/evaluate_comp.scm 625 */
											obj_t BgL_arg1679z00_1592;

											BgL_arg1679z00_1592 =
												MAKE_YOUNG_PAIR(BINT(BgL_arg1676z00_1590), BNIL);
											BgL_list1677z00_1591 =
												MAKE_YOUNG_PAIR(BINT(BgL_arg1675z00_1589),
												BgL_arg1679z00_1592);
										}
										BgL_arg1673z00_1588 =
											BGl_formatz00zz__r4_output_6_10_3z00
											(BGl_string5806z00zz__evaluate_compz00,
											BgL_list1677z00_1591);
								}}
								return
									BGl_everrorz00zz__everrorz00(BgL_locz00_86,
									BGl_string5798z00zz__evaluate_compz00,
									BGl_string5807z00zz__evaluate_compz00, BgL_arg1673z00_1588);
							}
						else
							{	/* Eval/evaluate_comp.scm 623 */
								{	/* Eval/evaluate_comp.scm 629 */
									obj_t BgL_arg1680z00_1593;

									{	/* Eval/evaluate_comp.scm 629 */
										obj_t BgL_vz00_1594;

										{	/* Eval/evaluate_comp.scm 629 */
											obj_t BgL_fun1682z00_1596;

											BgL_fun1682z00_1596 = CAR(((obj_t) BgL_lz00_1576));
											BgL_vz00_1594 =
												PROCEDURE_ENTRY(BgL_fun1682z00_1596)
												(BgL_fun1682z00_1596, BgL_sz00_82, BEOA);
										}
										if (CBOOL(CAR(((obj_t) BgL_bsz00_1577))))
											{	/* Eval/evaluate_comp.scm 202 */
												obj_t BgL_newz00_6612;

												BgL_newz00_6612 =
													create_struct(BGl_symbol5808z00zz__evaluate_compz00,
													(int) (((long) 1)));
												{	/* Eval/evaluate_comp.scm 202 */
													int BgL_tmpz00_18615;

													BgL_tmpz00_18615 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_6612, BgL_tmpz00_18615,
														BgL_vz00_1594);
												}
												BgL_arg1680z00_1593 = BgL_newz00_6612;
											}
										else
											{	/* Eval/evaluate_comp.scm 630 */
												BgL_arg1680z00_1593 = BgL_vz00_1594;
											}
									}
									VECTOR_SET(
										((obj_t) BgL_sz00_82), BgL_spz00_1578, BgL_arg1680z00_1593);
								}
								{	/* Eval/evaluate_comp.scm 633 */
									obj_t BgL_arg1683z00_1597;
									obj_t BgL_arg1684z00_1598;
									long BgL_arg1685z00_1599;

									BgL_arg1683z00_1597 = CDR(((obj_t) BgL_lz00_1576));
									BgL_arg1684z00_1598 = CDR(((obj_t) BgL_bsz00_1577));
									BgL_arg1685z00_1599 = (BgL_spz00_1578 + ((long) 1));
									{
										long BgL_spz00_18627;
										obj_t BgL_bsz00_18626;
										obj_t BgL_lz00_18625;

										BgL_lz00_18625 = BgL_arg1683z00_1597;
										BgL_bsz00_18626 = BgL_arg1684z00_1598;
										BgL_spz00_18627 = BgL_arg1685z00_1599;
										BgL_spz00_1578 = BgL_spz00_18627;
										BgL_bsz00_1577 = BgL_bsz00_18626;
										BgL_lz00_1576 = BgL_lz00_18625;
										goto BgL_zc3z04anonymousza31664ze3z87_1579;
									}
								}
							}
					}
			}
		}

	}



/* sub-stk */
	obj_t BGl_subzd2stkzd2zz__evaluate_compz00(obj_t BgL_l1z00_88,
		obj_t BgL_l2z00_89)
	{
		{	/* Eval/evaluate_comp.scm 638 */
		BGl_subzd2stkzd2zz__evaluate_compz00:
			if (NULLP(BgL_l1z00_88))
				{	/* Eval/evaluate_comp.scm 639 */
					return BgL_l2z00_89;
				}
			else
				{	/* Eval/evaluate_comp.scm 639 */
					if ((CAR(((obj_t) BgL_l1z00_88)) == CAR(((obj_t) BgL_l2z00_89))))
						{	/* Eval/evaluate_comp.scm 642 */
							obj_t BgL_arg1691z00_1605;
							obj_t BgL_arg1692z00_1606;

							BgL_arg1691z00_1605 = CDR(((obj_t) BgL_l1z00_88));
							BgL_arg1692z00_1606 = CDR(((obj_t) BgL_l2z00_89));
							{
								obj_t BgL_l2z00_18641;
								obj_t BgL_l1z00_18640;

								BgL_l1z00_18640 = BgL_arg1691z00_1605;
								BgL_l2z00_18641 = BgL_arg1692z00_1606;
								BgL_l2z00_89 = BgL_l2z00_18641;
								BgL_l1z00_88 = BgL_l1z00_18640;
								goto BGl_subzd2stkzd2zz__evaluate_compz00;
							}
						}
					else
						{	/* Eval/evaluate_comp.scm 640 */
							return
								BGl_errorz00zz__errorz00(BGl_string5798z00zz__evaluate_compz00,
								BGl_symbol5810z00zz__evaluate_compz00,
								BGl_symbol5812z00zz__evaluate_compz00);
						}
				}
		}

	}



/* catch-trampoline */
	obj_t BGl_catchzd2trampolinezd2zz__evaluate_compz00(obj_t BgL_fz00_93,
		obj_t BgL_sz00_94, obj_t BgL_bpz00_95)
	{
		{	/* Eval/evaluate_comp.scm 662 */
			{	/* Eval/evaluate_comp.scm 663 */
				obj_t BgL_savedzd2bpzd2_1617;

				BgL_savedzd2bpzd2_1617 = VECTOR_REF(((obj_t) BgL_sz00_94), ((long) 0));
				VECTOR_SET(((obj_t) BgL_sz00_94), ((long) 0), BgL_bpz00_95);
				{
					obj_t BgL_fz00_1619;

					BgL_fz00_1619 = BgL_fz00_93;
				BgL_zc3z04anonymousza31703ze3z87_1620:
					{	/* Eval/evaluate_comp.scm 666 */
						obj_t BgL_rz00_1621;

						BgL_rz00_1621 =
							PROCEDURE_ENTRY(BgL_fz00_1619) (BgL_fz00_1619, BgL_sz00_94, BEOA);
						{	/* Eval/evaluate_comp.scm 667 */
							bool_t BgL_test6081z00_18651;

							if (PROCEDUREP(BgL_rz00_1621))
								{	/* Eval/evaluate_comp.scm 667 */
									obj_t BgL_arg1707z00_1626;

									BgL_arg1707z00_1626 = PROCEDURE_ATTR(BgL_rz00_1621);
									if (STRUCTP(BgL_arg1707z00_1626))
										{	/* Eval/evaluate_comp.scm 647 */
											BgL_test6081z00_18651 =
												(STRUCT_KEY(BgL_arg1707z00_1626) ==
												BGl_symbol5794z00zz__evaluate_compz00);
										}
									else
										{	/* Eval/evaluate_comp.scm 647 */
											BgL_test6081z00_18651 = ((bool_t) 0);
										}
								}
							else
								{	/* Eval/evaluate_comp.scm 667 */
									BgL_test6081z00_18651 = ((bool_t) 0);
								}
							if (BgL_test6081z00_18651)
								{
									obj_t BgL_fz00_18659;

									BgL_fz00_18659 = BgL_rz00_1621;
									BgL_fz00_1619 = BgL_fz00_18659;
									goto BgL_zc3z04anonymousza31703ze3z87_1620;
								}
							else
								{	/* Eval/evaluate_comp.scm 667 */
									VECTOR_SET(
										((obj_t) BgL_sz00_94), ((long) 0), BgL_savedzd2bpzd2_1617);
									return BgL_rz00_1621;
								}
						}
					}
				}
			}
		}

	}



/* comp-with-push */
	obj_t BGl_compzd2withzd2pushz00zz__evaluate_compz00(obj_t BgL_eza2za2_117,
		obj_t BgL_stkz00_118)
	{
		{	/* Eval/evaluate_comp.scm 681 */
			if (NULLP(BgL_eza2za2_117))
				{	/* Eval/evaluate_comp.scm 683 */
					return BNIL;
				}
			else
				{	/* Eval/evaluate_comp.scm 685 */
					obj_t BgL_arg1718z00_1639;
					obj_t BgL_arg1719z00_1640;

					{	/* Eval/evaluate_comp.scm 685 */
						obj_t BgL_arg1720z00_1641;

						BgL_arg1720z00_1641 = CAR(((obj_t) BgL_eza2za2_117));
						BgL_arg1718z00_1639 =
							BGl_compz00zz__evaluate_compz00(
							((BgL_ev_exprz00_bglt) BgL_arg1720z00_1641), BgL_stkz00_118);
					}
					{	/* Eval/evaluate_comp.scm 686 */
						obj_t BgL_arg1721z00_1642;
						obj_t BgL_arg1722z00_1643;

						BgL_arg1721z00_1642 = CDR(((obj_t) BgL_eza2za2_117));
						{	/* Eval/evaluate_comp.scm 686 */
							obj_t BgL_arg1723z00_1644;

							BgL_arg1723z00_1644 = MAKE_YOUNG_PAIR(BFALSE, BNIL);
							BgL_arg1722z00_1643 =
								BGl_appendzd221011zd2zz__evaluate_compz00(BgL_stkz00_118,
								BgL_arg1723z00_1644);
						}
						BgL_arg1719z00_1640 =
							BGl_compzd2withzd2pushz00zz__evaluate_compz00(BgL_arg1721z00_1642,
							BgL_arg1722z00_1643);
					}
					return MAKE_YOUNG_PAIR(BgL_arg1718z00_1639, BgL_arg1719z00_1640);
				}
		}

	}



/* rec~0 */
	obj_t BGl_recze70ze7zz__evaluate_compz00(obj_t BgL_stkz00_15517,
		obj_t BgL_lz00_1646, long BgL_iz00_1647)
	{
		{	/* Eval/evaluate_comp.scm 689 */
			if (NULLP(BgL_lz00_1646))
				{	/* Eval/evaluate_comp.scm 690 */
					return BNIL;
				}
			else
				{	/* Eval/evaluate_comp.scm 690 */
					if ((BgL_iz00_1647 == ((long) 0)))
						{	/* Eval/evaluate_comp.scm 691 */
							return
								BGl_compzd2withzd2pushz00zz__evaluate_compz00(BgL_lz00_1646,
								BgL_stkz00_15517);
						}
					else
						{	/* Eval/evaluate_comp.scm 692 */
							obj_t BgL_arg1727z00_1651;
							obj_t BgL_arg1728z00_1652;

							{	/* Eval/evaluate_comp.scm 692 */
								obj_t BgL_arg1729z00_1653;

								BgL_arg1729z00_1653 = CAR(((obj_t) BgL_lz00_1646));
								BgL_arg1727z00_1651 =
									BGl_compz00zz__evaluate_compz00(
									((BgL_ev_exprz00_bglt) BgL_arg1729z00_1653),
									BgL_stkz00_15517);
							}
							{	/* Eval/evaluate_comp.scm 693 */
								obj_t BgL_arg1730z00_1654;
								long BgL_arg1731z00_1655;

								BgL_arg1730z00_1654 = CDR(((obj_t) BgL_lz00_1646));
								BgL_arg1731z00_1655 = (BgL_iz00_1647 - ((long) 1));
								BgL_arg1728z00_1652 =
									BGl_recze70ze7zz__evaluate_compz00(BgL_stkz00_15517,
									BgL_arg1730z00_1654, BgL_arg1731z00_1655);
							}
							return MAKE_YOUNG_PAIR(BgL_arg1727z00_1651, BgL_arg1728z00_1652);
						}
				}
		}

	}



/* subr-call-with-push */
	obj_t BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00(obj_t BgL_sz00_122,
		obj_t BgL_fz00_123, obj_t BgL_argsz00_124, obj_t BgL_bpz00_125,
		obj_t BgL_siza7eza7_126)
	{
		{	/* Eval/evaluate_comp.scm 695 */
			{	/* Eval/evaluate_comp.scm 697 */
				obj_t BgL_argsz00_1657;

				if (NULLP(BgL_argsz00_124))
					{	/* Eval/evaluate_comp.scm 697 */
						BgL_argsz00_1657 = BNIL;
					}
				else
					{	/* Eval/evaluate_comp.scm 697 */
						obj_t BgL_head1343z00_1662;

						{	/* Eval/evaluate_comp.scm 697 */
							obj_t BgL_res4376z00_6679;

							BgL_res4376z00_6679 = MAKE_YOUNG_PAIR(BNIL, BNIL);
							BgL_head1343z00_1662 = BgL_res4376z00_6679;
						}
						{
							obj_t BgL_l1341z00_6703;
							obj_t BgL_tail1344z00_6704;

							BgL_l1341z00_6703 = BgL_argsz00_124;
							BgL_tail1344z00_6704 = BgL_head1343z00_1662;
						BgL_zc3z04anonymousza31734ze3z87_6702:
							if (NULLP(BgL_l1341z00_6703))
								{	/* Eval/evaluate_comp.scm 697 */
									BgL_argsz00_1657 = CDR(BgL_head1343z00_1662);
								}
							else
								{	/* Eval/evaluate_comp.scm 697 */
									obj_t BgL_newtail1345z00_6711;

									{	/* Eval/evaluate_comp.scm 697 */
										obj_t BgL_arg1737z00_6712;

										{	/* Eval/evaluate_comp.scm 697 */
											obj_t BgL_az00_6713;

											BgL_az00_6713 = CAR(((obj_t) BgL_l1341z00_6703));
											BgL_arg1737z00_6712 =
												PROCEDURE_ENTRY(BgL_az00_6713) (BgL_az00_6713,
												BgL_sz00_122, BEOA);
										}
										{	/* Eval/evaluate_comp.scm 697 */
											obj_t BgL_res4382z00_6718;

											BgL_res4382z00_6718 =
												MAKE_YOUNG_PAIR(BgL_arg1737z00_6712, BNIL);
											BgL_newtail1345z00_6711 = BgL_res4382z00_6718;
										}
									}
									SET_CDR(BgL_tail1344z00_6704, BgL_newtail1345z00_6711);
									{	/* Eval/evaluate_comp.scm 697 */
										obj_t BgL_arg1736z00_6714;

										BgL_arg1736z00_6714 = CDR(((obj_t) BgL_l1341z00_6703));
										{
											obj_t BgL_tail1344z00_18705;
											obj_t BgL_l1341z00_18704;

											BgL_l1341z00_18704 = BgL_arg1736z00_6714;
											BgL_tail1344z00_18705 = BgL_newtail1345z00_6711;
											BgL_tail1344z00_6704 = BgL_tail1344z00_18705;
											BgL_l1341z00_6703 = BgL_l1341z00_18704;
											goto BgL_zc3z04anonymousza31734ze3z87_6702;
										}
									}
								}
						}
					}
				{	/* Eval/evaluate_comp.scm 698 */
					long BgL_arg1732z00_1658;

					BgL_arg1732z00_1658 =
						((long) CINT(BgL_bpz00_125) + (long) CINT(BgL_siza7eza7_126));
					VECTOR_SET(
						((obj_t) BgL_sz00_122), ((long) 0), BINT(BgL_arg1732z00_1658));
				}
				{	/* Eval/evaluate_comp.scm 699 */
					obj_t BgL_za2za2resza2za2z00_1659;

					BgL_za2za2resza2za2z00_1659 = apply(BgL_fz00_123, BgL_argsz00_1657);
					VECTOR_SET(((obj_t) BgL_sz00_122), ((long) 0), BgL_bpz00_125);
					return BgL_za2za2resza2za2z00_1659;
				}
			}
		}

	}



/* push-nargs-on-sp */
	obj_t BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00(obj_t
		BgL_arityz00_130, obj_t BgL_sz00_131, obj_t BgL_argsz00_132,
		obj_t BgL_spz00_133)
	{
		{	/* Eval/evaluate_comp.scm 708 */
			{	/* Eval/evaluate_comp.scm 709 */
				long BgL_g1149z00_1683;

				BgL_g1149z00_1683 = (((long) -1) - (long) CINT(BgL_arityz00_130));
				{
					obj_t BgL_lz00_1685;
					obj_t BgL_spz00_1686;
					long BgL_nz00_1687;

					BgL_lz00_1685 = BgL_argsz00_132;
					BgL_spz00_1686 = BgL_spz00_133;
					BgL_nz00_1687 = BgL_g1149z00_1683;
				BgL_zc3z04anonymousza31744ze3z87_1688:
					if ((BgL_nz00_1687 == ((long) 0)))
						{
							obj_t BgL_lz00_6805;
							obj_t BgL_rz00_6806;

							BgL_lz00_6805 = BgL_lz00_1685;
							BgL_rz00_6806 = BNIL;
						BgL_rec2z00_6804:
							if (NULLP(BgL_lz00_6805))
								{	/* Eval/evaluate_comp.scm 713 */
									obj_t BgL_arg1748z00_6814;

									BgL_arg1748z00_6814 = bgl_reverse_bang(BgL_rz00_6806);
									{	/* Eval/evaluate_comp.scm 713 */
										long BgL_kz00_6821;

										BgL_kz00_6821 = (long) CINT(BgL_spz00_1686);
										return
											VECTOR_SET(
											((obj_t) BgL_sz00_131), BgL_kz00_6821,
											BgL_arg1748z00_6814);
									}
								}
							else
								{	/* Eval/evaluate_comp.scm 714 */
									obj_t BgL_arg1749z00_6815;
									obj_t BgL_arg1750z00_6816;

									BgL_arg1749z00_6815 = CDR(((obj_t) BgL_lz00_6805));
									{	/* Eval/evaluate_comp.scm 714 */
										obj_t BgL_arg1751z00_6817;

										{	/* Eval/evaluate_comp.scm 714 */
											obj_t BgL_fun1752z00_6818;

											BgL_fun1752z00_6818 = CAR(((obj_t) BgL_lz00_6805));
											BgL_arg1751z00_6817 =
												PROCEDURE_ENTRY(BgL_fun1752z00_6818)
												(BgL_fun1752z00_6818, BgL_sz00_131, BEOA);
										}
										BgL_arg1750z00_6816 =
											MAKE_YOUNG_PAIR(BgL_arg1751z00_6817, BgL_rz00_6806);
									}
									{
										obj_t BgL_rz00_18736;
										obj_t BgL_lz00_18735;

										BgL_lz00_18735 = BgL_arg1749z00_6815;
										BgL_rz00_18736 = BgL_arg1750z00_6816;
										BgL_rz00_6806 = BgL_rz00_18736;
										BgL_lz00_6805 = BgL_lz00_18735;
										goto BgL_rec2z00_6804;
									}
								}
						}
					else
						{	/* Eval/evaluate_comp.scm 710 */
							{	/* Eval/evaluate_comp.scm 715 */
								obj_t BgL_arg1753z00_1702;

								{	/* Eval/evaluate_comp.scm 715 */
									obj_t BgL_fun1754z00_1703;

									BgL_fun1754z00_1703 = CAR(((obj_t) BgL_lz00_1685));
									BgL_arg1753z00_1702 =
										PROCEDURE_ENTRY(BgL_fun1754z00_1703) (BgL_fun1754z00_1703,
										BgL_sz00_131, BEOA);
								}
								{	/* Eval/evaluate_comp.scm 715 */
									long BgL_kz00_6826;

									BgL_kz00_6826 = (long) CINT(BgL_spz00_1686);
									VECTOR_SET(
										((obj_t) BgL_sz00_131), BgL_kz00_6826, BgL_arg1753z00_1702);
							}}
							{	/* Eval/evaluate_comp.scm 716 */
								obj_t BgL_arg1756z00_1704;
								long BgL_arg1758z00_1705;
								long BgL_arg1759z00_1706;

								BgL_arg1756z00_1704 = CDR(((obj_t) BgL_lz00_1685));
								BgL_arg1758z00_1705 =
									((long) CINT(BgL_spz00_1686) + ((long) 1));
								BgL_arg1759z00_1706 = (BgL_nz00_1687 - ((long) 1));
								{
									long BgL_nz00_18754;
									obj_t BgL_spz00_18752;
									obj_t BgL_lz00_18751;

									BgL_lz00_18751 = BgL_arg1756z00_1704;
									BgL_spz00_18752 = BINT(BgL_arg1758z00_1705);
									BgL_nz00_18754 = BgL_arg1759z00_1706;
									BgL_nz00_1687 = BgL_nz00_18754;
									BgL_spz00_1686 = BgL_spz00_18752;
									BgL_lz00_1685 = BgL_lz00_18751;
									goto BgL_zc3z04anonymousza31744ze3z87_1688;
								}
							}
						}
				}
			}
		}

	}



/* need-shift */
	bool_t BGl_needzd2shiftzd2zz__evaluate_compz00(obj_t BgL_argsz00_134,
		obj_t BgL_stkz00_135)
	{
		{	/* Eval/evaluate_comp.scm 759 */
			{
				obj_t BgL_lz00_1709;
				obj_t BgL_stkz00_1710;

				BgL_lz00_1709 = BgL_argsz00_134;
				BgL_stkz00_1710 = BgL_stkz00_135;
			BgL_zc3z04anonymousza31760ze3z87_1711:
				{	/* Eval/evaluate_comp.scm 763 */
					bool_t BgL_test6091z00_18755;

					if (NULLP(BgL_lz00_1709))
						{	/* Eval/evaluate_comp.scm 763 */
							BgL_test6091z00_18755 = ((bool_t) 1);
						}
					else
						{	/* Eval/evaluate_comp.scm 763 */
							BgL_test6091z00_18755 = NULLP(BgL_stkz00_1710);
						}
					if (BgL_test6091z00_18755)
						{	/* Eval/evaluate_comp.scm 763 */
							return ((bool_t) 0);
						}
					else
						{	/* Eval/evaluate_comp.scm 765 */
							bool_t BgL_test6093z00_18759;

							{	/* Eval/evaluate_comp.scm 765 */
								obj_t BgL_g1348z00_1728;

								BgL_g1348z00_1728 = CDR(((obj_t) BgL_lz00_1709));
								{
									obj_t BgL_l1346z00_1730;

									{	/* Eval/evaluate_comp.scm 765 */
										obj_t BgL_tmpz00_18762;

										BgL_l1346z00_1730 = BgL_g1348z00_1728;
									BgL_zc3z04anonymousza31772ze3z87_1731:
										if (NULLP(BgL_l1346z00_1730))
											{	/* Eval/evaluate_comp.scm 765 */
												BgL_tmpz00_18762 = BFALSE;
											}
										else
											{	/* Eval/evaluate_comp.scm 765 */
												obj_t BgL__ortest_1349z00_1733;

												{	/* Eval/evaluate_comp.scm 765 */
													obj_t BgL_ez00_1735;

													BgL_ez00_1735 = CAR(((obj_t) BgL_l1346z00_1730));
													{	/* Eval/evaluate_comp.scm 765 */
														obj_t BgL_arg1775z00_1736;
														obj_t BgL_arg1776z00_1737;

														BgL_arg1775z00_1736 =
															CAR(((obj_t) BgL_stkz00_1710));
														BgL_arg1776z00_1737 =
															BGl_usez00zz__evaluate_usez00(
															((BgL_ev_exprz00_bglt) BgL_ez00_1735), BNIL);
														BgL__ortest_1349z00_1733 =
															BGl_memqz00zz__r4_pairs_and_lists_6_3z00
															(BgL_arg1775z00_1736, BgL_arg1776z00_1737);
													}
												}
												if (CBOOL(BgL__ortest_1349z00_1733))
													{	/* Eval/evaluate_comp.scm 765 */
														BgL_tmpz00_18762 = BgL__ortest_1349z00_1733;
													}
												else
													{	/* Eval/evaluate_comp.scm 765 */
														obj_t BgL_arg1774z00_1734;

														BgL_arg1774z00_1734 =
															CDR(((obj_t) BgL_l1346z00_1730));
														{
															obj_t BgL_l1346z00_18776;

															BgL_l1346z00_18776 = BgL_arg1774z00_1734;
															BgL_l1346z00_1730 = BgL_l1346z00_18776;
															goto BgL_zc3z04anonymousza31772ze3z87_1731;
														}
													}
											}
										BgL_test6093z00_18759 = CBOOL(BgL_tmpz00_18762);
									}
								}
							}
							if (BgL_test6093z00_18759)
								{	/* Eval/evaluate_comp.scm 765 */
									return ((bool_t) 1);
								}
							else
								{	/* Eval/evaluate_comp.scm 767 */
									obj_t BgL_arg1770z00_1726;
									obj_t BgL_arg1771z00_1727;

									BgL_arg1770z00_1726 = CDR(((obj_t) BgL_lz00_1709));
									BgL_arg1771z00_1727 = CDR(((obj_t) BgL_stkz00_1710));
									{
										obj_t BgL_stkz00_18783;
										obj_t BgL_lz00_18782;

										BgL_lz00_18782 = BgL_arg1770z00_1726;
										BgL_stkz00_18783 = BgL_arg1771z00_1727;
										BgL_stkz00_1710 = BgL_stkz00_18783;
										BgL_lz00_1709 = BgL_lz00_18782;
										goto BgL_zc3z04anonymousza31760ze3z87_1711;
									}
								}
						}
				}
			}
		}

	}



/* comp-old-call */
	obj_t BGl_compzd2oldzd2callz00zz__evaluate_compz00(BgL_ev_appz00_bglt
		BgL_ez00_136, obj_t BgL_stkz00_137)
	{
		{	/* Eval/evaluate_comp.scm 769 */
			{	/* Eval/evaluate_comp.scm 771 */
				long BgL_siza7eza7_1742;
				long BgL_nbargsz00_1743;
				obj_t BgL_fz00_1744;
				obj_t BgL_symbzd2funzd2_1745;

				BgL_siza7eza7_1742 = bgl_list_length(BgL_stkz00_137);
				BgL_nbargsz00_1743 =
					bgl_list_length(
					(((BgL_ev_appz00_bglt) COBJECT(BgL_ez00_136))->BgL_argsz00));
				BgL_fz00_1744 =
					BGl_compz00zz__evaluate_compz00(
					(((BgL_ev_appz00_bglt) COBJECT(BgL_ez00_136))->BgL_funz00),
					BgL_stkz00_137);
				BgL_symbzd2funzd2_1745 =
					BGl_uncompilez00zz__evaluate_uncompz00((((BgL_ev_appz00_bglt)
							COBJECT(BgL_ez00_136))->BgL_funz00));
				if (CBOOL((((BgL_ev_appz00_bglt) COBJECT(BgL_ez00_136))->
							BgL_tailzf3zf3)))
					{	/* Eval/evaluate_comp.scm 773 */
						if (BGl_needzd2shiftzd2zz__evaluate_compz00(
								(((BgL_ev_appz00_bglt) COBJECT(BgL_ez00_136))->BgL_argsz00),
								BgL_stkz00_137))
							{	/* Eval/evaluate_comp.scm 780 */
								bool_t BgL_test6098z00_18797;

								{	/* Eval/evaluate_comp.scm 780 */
									int BgL_arg1833z00_1824;

									BgL_arg1833z00_1824 = bgl_debug();
									BgL_test6098z00_18797 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg1833z00_1824),
										BINT(((long) 0)));
								}
								if (BgL_test6098z00_18797)
									{	/* Eval/evaluate_comp.scm 780 */
										obj_t BgL_argsz00_1751;

										BgL_argsz00_1751 =
											BGl_compzd2withzd2pushz00zz__evaluate_compz00(
											(((BgL_ev_appz00_bglt) COBJECT(BgL_ez00_136))->
												BgL_argsz00), BgL_stkz00_137);
										{	/* Eval/evaluate_comp.scm 780 */
											obj_t BgL_zc3z04anonymousza31783ze3z87_13547;

											BgL_zc3z04anonymousza31783ze3z87_13547 =
												MAKE_FX_PROCEDURE
												(BGl_z62zc3z04anonymousza31783ze3ze5zz__evaluate_compz00,
												(int) (((long) 1)), (int) (((long) 6)));
											PROCEDURE_SET(BgL_zc3z04anonymousza31783ze3z87_13547,
												(int) (((long) 0)), BgL_fz00_1744);
											PROCEDURE_SET(BgL_zc3z04anonymousza31783ze3z87_13547,
												(int) (((long) 1)), ((obj_t) BgL_ez00_136));
											PROCEDURE_SET(BgL_zc3z04anonymousza31783ze3z87_13547,
												(int) (((long) 2)), BgL_symbzd2funzd2_1745);
											PROCEDURE_SET(BgL_zc3z04anonymousza31783ze3z87_13547,
												(int) (((long) 3)), BINT(BgL_nbargsz00_1743));
											PROCEDURE_SET(BgL_zc3z04anonymousza31783ze3z87_13547,
												(int) (((long) 4)), BgL_argsz00_1751);
											PROCEDURE_SET(BgL_zc3z04anonymousza31783ze3z87_13547,
												(int) (((long) 5)), BINT(BgL_siza7eza7_1742));
											return BgL_zc3z04anonymousza31783ze3z87_13547;
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 780 */
										obj_t BgL_argsz00_1789;

										BgL_argsz00_1789 =
											BGl_compzd2withzd2pushz00zz__evaluate_compz00(
											(((BgL_ev_appz00_bglt) COBJECT(BgL_ez00_136))->
												BgL_argsz00), BgL_stkz00_137);
										{	/* Eval/evaluate_comp.scm 780 */
											obj_t BgL_zc3z04anonymousza31810ze3z87_13548;

											BgL_zc3z04anonymousza31810ze3z87_13548 =
												MAKE_FX_PROCEDURE
												(BGl_z62zc3z04anonymousza31810ze3ze5zz__evaluate_compz00,
												(int) (((long) 1)), (int) (((long) 6)));
											PROCEDURE_SET(BgL_zc3z04anonymousza31810ze3z87_13548,
												(int) (((long) 0)), BgL_fz00_1744);
											PROCEDURE_SET(BgL_zc3z04anonymousza31810ze3z87_13548,
												(int) (((long) 1)), ((obj_t) BgL_ez00_136));
											PROCEDURE_SET(BgL_zc3z04anonymousza31810ze3z87_13548,
												(int) (((long) 2)), BgL_symbzd2funzd2_1745);
											PROCEDURE_SET(BgL_zc3z04anonymousza31810ze3z87_13548,
												(int) (((long) 3)), BINT(BgL_nbargsz00_1743));
											PROCEDURE_SET(BgL_zc3z04anonymousza31810ze3z87_13548,
												(int) (((long) 4)), BgL_argsz00_1789);
											PROCEDURE_SET(BgL_zc3z04anonymousza31810ze3z87_13548,
												(int) (((long) 5)), BINT(BgL_siza7eza7_1742));
											return BgL_zc3z04anonymousza31810ze3z87_13548;
										}
									}
							}
						else
							{	/* Eval/evaluate_comp.scm 788 */
								bool_t BgL_test6099z00_18842;

								{	/* Eval/evaluate_comp.scm 788 */
									int BgL_arg1877z00_1894;

									BgL_arg1877z00_1894 = bgl_debug();
									BgL_test6099z00_18842 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg1877z00_1894),
										BINT(((long) 0)));
								}
								if (BgL_test6099z00_18842)
									{	/* Eval/evaluate_comp.scm 788 */
										obj_t BgL_argsz00_1827;

										BgL_argsz00_1827 =
											BGl_recze70ze7zz__evaluate_compz00(BgL_stkz00_137,
											(((BgL_ev_appz00_bglt) COBJECT(BgL_ez00_136))->
												BgL_argsz00), BgL_siza7eza7_1742);
										{	/* Eval/evaluate_comp.scm 788 */
											obj_t BgL_zc3z04anonymousza31836ze3z87_13549;

											BgL_zc3z04anonymousza31836ze3z87_13549 =
												MAKE_FX_PROCEDURE
												(BGl_z62zc3z04anonymousza31836ze3ze5zz__evaluate_compz00,
												(int) (((long) 1)), (int) (((long) 5)));
											PROCEDURE_SET(BgL_zc3z04anonymousza31836ze3z87_13549,
												(int) (((long) 0)), BgL_fz00_1744);
											PROCEDURE_SET(BgL_zc3z04anonymousza31836ze3z87_13549,
												(int) (((long) 1)), ((obj_t) BgL_ez00_136));
											PROCEDURE_SET(BgL_zc3z04anonymousza31836ze3z87_13549,
												(int) (((long) 2)), BgL_symbzd2funzd2_1745);
											PROCEDURE_SET(BgL_zc3z04anonymousza31836ze3z87_13549,
												(int) (((long) 3)), BINT(BgL_nbargsz00_1743));
											PROCEDURE_SET(BgL_zc3z04anonymousza31836ze3z87_13549,
												(int) (((long) 4)), BgL_argsz00_1827);
											return BgL_zc3z04anonymousza31836ze3z87_13549;
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 788 */
										obj_t BgL_argsz00_1862;

										BgL_argsz00_1862 =
											BGl_recze70ze7zz__evaluate_compz00(BgL_stkz00_137,
											(((BgL_ev_appz00_bglt) COBJECT(BgL_ez00_136))->
												BgL_argsz00), BgL_siza7eza7_1742);
										{	/* Eval/evaluate_comp.scm 788 */
											obj_t BgL_zc3z04anonymousza31859ze3z87_13550;

											BgL_zc3z04anonymousza31859ze3z87_13550 =
												MAKE_FX_PROCEDURE
												(BGl_z62zc3z04anonymousza31859ze3ze5zz__evaluate_compz00,
												(int) (((long) 1)), (int) (((long) 5)));
											PROCEDURE_SET(BgL_zc3z04anonymousza31859ze3z87_13550,
												(int) (((long) 0)), BgL_fz00_1744);
											PROCEDURE_SET(BgL_zc3z04anonymousza31859ze3z87_13550,
												(int) (((long) 1)), ((obj_t) BgL_ez00_136));
											PROCEDURE_SET(BgL_zc3z04anonymousza31859ze3z87_13550,
												(int) (((long) 2)), BgL_symbzd2funzd2_1745);
											PROCEDURE_SET(BgL_zc3z04anonymousza31859ze3z87_13550,
												(int) (((long) 3)), BINT(BgL_nbargsz00_1743));
											PROCEDURE_SET(BgL_zc3z04anonymousza31859ze3z87_13550,
												(int) (((long) 4)), BgL_argsz00_1862);
											return BgL_zc3z04anonymousza31859ze3z87_13550;
										}
									}
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 774 */
						bool_t BgL_test6100z00_18881;

						{	/* Eval/evaluate_comp.scm 774 */
							int BgL_arg1920z00_1965;

							BgL_arg1920z00_1965 = bgl_debug();
							BgL_test6100z00_18881 =
								BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg1920z00_1965),
								BINT(((long) 0)));
						}
						if (BgL_test6100z00_18881)
							{	/* Eval/evaluate_comp.scm 774 */
								obj_t BgL_argsz00_1898;

								BgL_argsz00_1898 =
									BGl_compzd2withzd2pushz00zz__evaluate_compz00(
									(((BgL_ev_appz00_bglt) COBJECT(BgL_ez00_136))->BgL_argsz00),
									BgL_stkz00_137);
								{	/* Eval/evaluate_comp.scm 774 */
									obj_t BgL_zc3z04anonymousza31881ze3z87_13551;

									BgL_zc3z04anonymousza31881ze3z87_13551 =
										MAKE_FX_PROCEDURE
										(BGl_z62zc3z04anonymousza31881ze3ze5zz__evaluate_compz00,
										(int) (((long) 1)), (int) (((long) 6)));
									PROCEDURE_SET(BgL_zc3z04anonymousza31881ze3z87_13551,
										(int) (((long) 0)), BgL_fz00_1744);
									PROCEDURE_SET(BgL_zc3z04anonymousza31881ze3z87_13551,
										(int) (((long) 1)), ((obj_t) BgL_ez00_136));
									PROCEDURE_SET(BgL_zc3z04anonymousza31881ze3z87_13551,
										(int) (((long) 2)), BgL_symbzd2funzd2_1745);
									PROCEDURE_SET(BgL_zc3z04anonymousza31881ze3z87_13551,
										(int) (((long) 3)), BINT(BgL_nbargsz00_1743));
									PROCEDURE_SET(BgL_zc3z04anonymousza31881ze3z87_13551,
										(int) (((long) 4)), BgL_argsz00_1898);
									PROCEDURE_SET(BgL_zc3z04anonymousza31881ze3z87_13551,
										(int) (((long) 5)), BINT(BgL_siza7eza7_1742));
									return BgL_zc3z04anonymousza31881ze3z87_13551;
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 774 */
								obj_t BgL_argsz00_1933;

								BgL_argsz00_1933 =
									BGl_compzd2withzd2pushz00zz__evaluate_compz00(
									(((BgL_ev_appz00_bglt) COBJECT(BgL_ez00_136))->BgL_argsz00),
									BgL_stkz00_137);
								{	/* Eval/evaluate_comp.scm 774 */
									obj_t BgL_zc3z04anonymousza31903ze3z87_13552;

									BgL_zc3z04anonymousza31903ze3z87_13552 =
										MAKE_FX_PROCEDURE
										(BGl_z62zc3z04anonymousza31903ze3ze5zz__evaluate_compz00,
										(int) (((long) 1)), (int) (((long) 6)));
									PROCEDURE_SET(BgL_zc3z04anonymousza31903ze3z87_13552,
										(int) (((long) 0)), BgL_fz00_1744);
									PROCEDURE_SET(BgL_zc3z04anonymousza31903ze3z87_13552,
										(int) (((long) 1)), ((obj_t) BgL_ez00_136));
									PROCEDURE_SET(BgL_zc3z04anonymousza31903ze3z87_13552,
										(int) (((long) 2)), BgL_symbzd2funzd2_1745);
									PROCEDURE_SET(BgL_zc3z04anonymousza31903ze3z87_13552,
										(int) (((long) 3)), BINT(BgL_nbargsz00_1743));
									PROCEDURE_SET(BgL_zc3z04anonymousza31903ze3z87_13552,
										(int) (((long) 4)), BgL_argsz00_1933);
									PROCEDURE_SET(BgL_zc3z04anonymousza31903ze3z87_13552,
										(int) (((long) 5)), BINT(BgL_siza7eza7_1742));
									return BgL_zc3z04anonymousza31903ze3z87_13552;
								}
							}
					}
			}
		}

	}



/* &<@anonymous:1783> */
	obj_t BGl_z62zc3z04anonymousza31783ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13553, obj_t BgL_sz00_13560)
	{
		{	/* Eval/evaluate_comp.scm 780 */
			{	/* Eval/evaluate_comp.scm 780 */
				obj_t BgL_fz00_13554;
				BgL_ev_appz00_bglt BgL_i1157z00_13555;
				obj_t BgL_symbzd2funzd2_13556;
				long BgL_nbargsz00_13557;
				obj_t BgL_argsz00_13558;
				long BgL_siza7eza7_13559;

				BgL_fz00_13554 = PROCEDURE_REF(BgL_envz00_13553, (int) (((long) 0)));
				BgL_i1157z00_13555 =
					((BgL_ev_appz00_bglt)
					PROCEDURE_REF(BgL_envz00_13553, (int) (((long) 1))));
				BgL_symbzd2funzd2_13556 =
					PROCEDURE_REF(BgL_envz00_13553, (int) (((long) 2)));
				BgL_nbargsz00_13557 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13553, (int) (((long) 3))));
				BgL_argsz00_13558 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13553, (int) (((long) 4))));
				BgL_siza7eza7_13559 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13553, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 780 */
					obj_t BgL_bpz00_15538;

					BgL_bpz00_15538 = VECTOR_REF(((obj_t) BgL_sz00_13560), ((long) 0));
					{	/* Eval/evaluate_comp.scm 780 */
						obj_t BgL_fz00_15539;

						BgL_fz00_15539 =
							PROCEDURE_ENTRY(BgL_fz00_13554) (BgL_fz00_13554, BgL_sz00_13560,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15539))
							{	/* Eval/evaluate_comp.scm 780 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 780 */
								BGl_evtypezd2errorzd2zz__everrorz00(
									(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_13555))->
										BgL_locz00), BGl_string5798z00zz__evaluate_compz00,
									BGl_string5814z00zz__evaluate_compz00, BgL_fz00_15539);
							}
						{	/* Eval/evaluate_comp.scm 780 */
							obj_t BgL_ufz00_15540;

							{	/* Eval/evaluate_comp.scm 780 */
								obj_t BgL_tmpz00_18952;

								BgL_tmpz00_18952 = ((obj_t) BgL_fz00_15539);
								BgL_ufz00_15540 = PROCEDURE_ATTR(BgL_tmpz00_18952);
							}
							{	/* Eval/evaluate_comp.scm 780 */
								bool_t BgL_test6102z00_18955;

								if (STRUCTP(BgL_ufz00_15540))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6102z00_18955 =
											(STRUCT_KEY(BgL_ufz00_15540) ==
											BGl_symbol5815z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6102z00_18955 = ((bool_t) 0);
									}
								if (BgL_test6102z00_18955)
									{	/* Eval/evaluate_comp.scm 780 */
										obj_t BgL_arityz00_15541;
										obj_t BgL_runz00_15542;
										obj_t BgL_sfz00_15543;

										BgL_arityz00_15541 =
											STRUCT_REF(BgL_ufz00_15540, (int) (((long) 0)));
										BgL_runz00_15542 =
											STRUCT_REF(BgL_ufz00_15540, (int) (((long) 1)));
										BgL_sfz00_15543 =
											STRUCT_REF(BgL_ufz00_15540, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 780 */
											long BgL_spz00_15544;

											BgL_spz00_15544 =
												((long) CINT(BgL_bpz00_15538) + BgL_siza7eza7_13559);
											if (
												((long) CINT(BgL_arityz00_15541) ==
													BgL_nbargsz00_13557))
												{	/* Eval/evaluate_comp.scm 780 */
													{
														obj_t BgL_lz00_15546;
														long BgL_spz00_15547;

														BgL_lz00_15546 = BgL_argsz00_13558;
														BgL_spz00_15547 = BgL_spz00_15544;
													BgL_recz00_15545:
														if (NULLP(BgL_lz00_15546))
															{	/* Eval/evaluate_comp.scm 704 */
																((bool_t) 0);
															}
														else
															{	/* Eval/evaluate_comp.scm 704 */
																{	/* Eval/evaluate_comp.scm 705 */
																	obj_t BgL_arg1740z00_15548;

																	{	/* Eval/evaluate_comp.scm 705 */
																		obj_t BgL_fun1741z00_15549;

																		BgL_fun1741z00_15549 =
																			CAR(((obj_t) BgL_lz00_15546));
																		BgL_arg1740z00_15548 =
																			PROCEDURE_ENTRY(BgL_fun1741z00_15549)
																			(BgL_fun1741z00_15549, BgL_sz00_13560,
																			BEOA);
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13560), BgL_spz00_15547,
																		BgL_arg1740z00_15548);
																}
																{	/* Eval/evaluate_comp.scm 706 */
																	obj_t BgL_arg1742z00_15550;
																	long BgL_arg1743z00_15551;

																	BgL_arg1742z00_15550 =
																		CDR(((obj_t) BgL_lz00_15546));
																	BgL_arg1743z00_15551 =
																		(BgL_spz00_15547 + ((long) 1));
																	{
																		long BgL_spz00_18985;
																		obj_t BgL_lz00_18984;

																		BgL_lz00_18984 = BgL_arg1742z00_15550;
																		BgL_spz00_18985 = BgL_arg1743z00_15551;
																		BgL_spz00_15547 = BgL_spz00_18985;
																		BgL_lz00_15546 = BgL_lz00_18984;
																		goto BgL_recz00_15545;
																	}
																}
															}
													}
													{	/* Eval/evaluate_comp.scm 784 */
														long BgL_arg1788z00_15552;

														BgL_arg1788z00_15552 =
															(BgL_spz00_15544 + BgL_nbargsz00_13557);
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_sz00_13560, (long) CINT(BgL_bpz00_15538),
															BgL_sz00_13560, BINT(BgL_spz00_15544),
															BINT(BgL_arg1788z00_15552));
												}}
											else
												{	/* Eval/evaluate_comp.scm 780 */
													bool_t BgL_test6106z00_18991;

													if (((long) CINT(BgL_arityz00_15541) >= ((long) 0)))
														{	/* Eval/evaluate_comp.scm 780 */
															BgL_test6106z00_18991 = ((bool_t) 1);
														}
													else
														{	/* Eval/evaluate_comp.scm 780 */
															BgL_test6106z00_18991 =
																(
																(long) CINT(BgL_arityz00_15541) <
																(((long) -1) - BgL_nbargsz00_13557));
														}
													if (BgL_test6106z00_18991)
														{	/* Eval/evaluate_comp.scm 780 */
															BGl_evarityzd2errorzd2zz__everrorz00(
																(((BgL_ev_appz00_bglt)
																		COBJECT(BgL_i1157z00_13555))->BgL_locz00),
																STRUCT_REF(BgL_ufz00_15540, (int) (((long) 3))),
																(int) (BgL_nbargsz00_13557),
																CINT(BgL_arityz00_15541));
														}
													else
														{	/* Eval/evaluate_comp.scm 780 */
															BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00
																(BgL_arityz00_15541, BgL_sz00_13560,
																BgL_argsz00_13558, BINT(BgL_spz00_15544));
															{	/* Eval/evaluate_comp.scm 786 */
																long BgL_arg1796z00_15553;

																BgL_arg1796z00_15553 =
																	(BgL_spz00_15544 +
																	(((long) 0) -
																		(long) CINT(BgL_arityz00_15541)));
																BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																	(BgL_sz00_13560, (long) CINT(BgL_bpz00_15538),
																	BgL_sz00_13560, BINT(BgL_spz00_15544),
																	BINT(BgL_arg1796z00_15553));
												}}}
											{	/* Eval/evaluate_comp.scm 780 */
												obj_t BgL_z12denvz12_15554;

												BgL_z12denvz12_15554 = BGL_CURRENT_DYNAMIC_ENV();
												{	/* Eval/evaluate_comp.scm 780 */
													obj_t BgL_tmpz00_19014;

													BgL_tmpz00_19014 =
														(((BgL_ev_appz00_bglt)
															COBJECT(BgL_i1157z00_13555))->BgL_locz00);
													BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_15554,
														BgL_tmpz00_19014);
												}
												if (
													(((long) CINT(BgL_bpz00_15538) +
															(long) CINT(BgL_sfz00_15543)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13560))))
													{	/* Eval/evaluate_comp.scm 780 */
														return BgL_runz00_15542;
													}
												else
													{	/* Eval/evaluate_comp.scm 780 */
														obj_t BgL_nsz00_15555;

														BgL_nsz00_15555 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 780 */
															long BgL_arg1801z00_15556;

															BgL_arg1801z00_15556 =
																(
																(long) CINT(BgL_bpz00_15538) +
																BgL_nbargsz00_13557);
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_15555, ((long) 2), BgL_sz00_13560,
																BgL_bpz00_15538, BINT(BgL_arg1801z00_15556));
														}
														VECTOR_SET(BgL_nsz00_15555, ((long) 1),
															BgL_sz00_13560);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15554,
															BgL_nsz00_15555);
														{	/* Eval/evaluate_comp.scm 780 */
															obj_t BgL_ez00_15557;

															BgL_ez00_15557 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_15557, BgL_sz00_13560);
															{	/* Eval/evaluate_comp.scm 780 */
																obj_t BgL_____rz00_15558;

																{	/* Eval/evaluate_comp.scm 663 */
																	obj_t BgL_savedzd2bpzd2_15559;

																	BgL_savedzd2bpzd2_15559 =
																		VECTOR_REF(BgL_nsz00_15555, ((long) 0));
																	VECTOR_SET(BgL_nsz00_15555, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_15561;

																		BgL_fz00_15561 = BgL_runz00_15542;
																	BgL_recz00_15560:
																		{	/* Eval/evaluate_comp.scm 666 */
																			obj_t BgL_rz00_15562;

																			BgL_rz00_15562 =
																				PROCEDURE_ENTRY(BgL_fz00_15561)
																				(BgL_fz00_15561, BgL_nsz00_15555, BEOA);
																			{	/* Eval/evaluate_comp.scm 667 */
																				bool_t BgL_test6109z00_19040;

																				if (PROCEDUREP(BgL_rz00_15562))
																					{	/* Eval/evaluate_comp.scm 667 */
																						obj_t BgL_arg1707z00_15563;

																						BgL_arg1707z00_15563 =
																							PROCEDURE_ATTR(BgL_rz00_15562);
																						if (STRUCTP(BgL_arg1707z00_15563))
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_test6109z00_19040 =
																									(STRUCT_KEY
																									(BgL_arg1707z00_15563) ==
																									BGl_symbol5794z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_test6109z00_19040 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						BgL_test6109z00_19040 =
																							((bool_t) 0);
																					}
																				if (BgL_test6109z00_19040)
																					{
																						obj_t BgL_fz00_19048;

																						BgL_fz00_19048 = BgL_rz00_15562;
																						BgL_fz00_15561 = BgL_fz00_19048;
																						goto BgL_recz00_15560;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						VECTOR_SET(BgL_nsz00_15555,
																							((long) 0),
																							BgL_savedzd2bpzd2_15559);
																						BgL_____rz00_15558 = BgL_rz00_15562;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_15557);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15554,
																	BgL_sz00_13560);
																return BgL_____rz00_15558;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 780 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15539,
												(int) (BgL_nbargsz00_13557)))
											{	/* Eval/evaluate_comp.scm 780 */
												{	/* Eval/evaluate_comp.scm 780 */
													obj_t BgL_auxz00_19057;
													obj_t BgL_tmpz00_19055;

													BgL_auxz00_19057 =
														(((BgL_ev_appz00_bglt)
															COBJECT(BgL_i1157z00_13555))->BgL_locz00);
													BgL_tmpz00_19055 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_19055,
														BgL_auxz00_19057);
												}
												return
													BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00
													(BgL_sz00_13560, BgL_fz00_15539, BgL_argsz00_13558,
													BgL_bpz00_15538, BINT(BgL_siza7eza7_13559));
											}
										else
											{	/* Eval/evaluate_comp.scm 780 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(
													(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_13555))->
														BgL_locz00), BgL_symbzd2funzd2_13556,
													(int) (BgL_nbargsz00_13557),
													PROCEDURE_ARITY(BgL_fz00_15539));
		}}}}}}}}

	}



/* &<@anonymous:1810> */
	obj_t BGl_z62zc3z04anonymousza31810ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13561, obj_t BgL_sz00_13568)
	{
		{	/* Eval/evaluate_comp.scm 780 */
			{	/* Eval/evaluate_comp.scm 780 */
				obj_t BgL_fz00_13562;
				BgL_ev_appz00_bglt BgL_i1157z00_13563;
				obj_t BgL_symbzd2funzd2_13564;
				long BgL_nbargsz00_13565;
				obj_t BgL_argsz00_13566;
				long BgL_siza7eza7_13567;

				BgL_fz00_13562 = PROCEDURE_REF(BgL_envz00_13561, (int) (((long) 0)));
				BgL_i1157z00_13563 =
					((BgL_ev_appz00_bglt)
					PROCEDURE_REF(BgL_envz00_13561, (int) (((long) 1))));
				BgL_symbzd2funzd2_13564 =
					PROCEDURE_REF(BgL_envz00_13561, (int) (((long) 2)));
				BgL_nbargsz00_13565 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13561, (int) (((long) 3))));
				BgL_argsz00_13566 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13561, (int) (((long) 4))));
				BgL_siza7eza7_13567 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13561, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 780 */
					obj_t BgL_bpz00_15564;

					BgL_bpz00_15564 = VECTOR_REF(((obj_t) BgL_sz00_13568), ((long) 0));
					{	/* Eval/evaluate_comp.scm 780 */
						obj_t BgL_fz00_15565;

						BgL_fz00_15565 =
							PROCEDURE_ENTRY(BgL_fz00_13562) (BgL_fz00_13562, BgL_sz00_13568,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15565))
							{	/* Eval/evaluate_comp.scm 780 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 780 */
								BGl_evtypezd2errorzd2zz__everrorz00(
									(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_13563))->
										BgL_locz00), BGl_string5798z00zz__evaluate_compz00,
									BGl_string5814z00zz__evaluate_compz00, BgL_fz00_15565);
							}
						{	/* Eval/evaluate_comp.scm 780 */
							obj_t BgL_ufz00_15566;

							{	/* Eval/evaluate_comp.scm 780 */
								obj_t BgL_tmpz00_19092;

								BgL_tmpz00_19092 = ((obj_t) BgL_fz00_15565);
								BgL_ufz00_15566 = PROCEDURE_ATTR(BgL_tmpz00_19092);
							}
							{	/* Eval/evaluate_comp.scm 780 */
								bool_t BgL_test6114z00_19095;

								if (STRUCTP(BgL_ufz00_15566))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6114z00_19095 =
											(STRUCT_KEY(BgL_ufz00_15566) ==
											BGl_symbol5815z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6114z00_19095 = ((bool_t) 0);
									}
								if (BgL_test6114z00_19095)
									{	/* Eval/evaluate_comp.scm 780 */
										obj_t BgL_arityz00_15567;
										obj_t BgL_runz00_15568;
										obj_t BgL_sfz00_15569;

										BgL_arityz00_15567 =
											STRUCT_REF(BgL_ufz00_15566, (int) (((long) 0)));
										BgL_runz00_15568 =
											STRUCT_REF(BgL_ufz00_15566, (int) (((long) 1)));
										BgL_sfz00_15569 =
											STRUCT_REF(BgL_ufz00_15566, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 780 */
											long BgL_spz00_15570;

											BgL_spz00_15570 =
												((long) CINT(BgL_bpz00_15564) + BgL_siza7eza7_13567);
											if (
												((long) CINT(BgL_arityz00_15567) ==
													BgL_nbargsz00_13565))
												{	/* Eval/evaluate_comp.scm 780 */
													{
														obj_t BgL_lz00_15572;
														long BgL_spz00_15573;

														BgL_lz00_15572 = BgL_argsz00_13566;
														BgL_spz00_15573 = BgL_spz00_15570;
													BgL_recz00_15571:
														if (NULLP(BgL_lz00_15572))
															{	/* Eval/evaluate_comp.scm 704 */
																((bool_t) 0);
															}
														else
															{	/* Eval/evaluate_comp.scm 704 */
																{	/* Eval/evaluate_comp.scm 705 */
																	obj_t BgL_arg1740z00_15574;

																	{	/* Eval/evaluate_comp.scm 705 */
																		obj_t BgL_fun1741z00_15575;

																		BgL_fun1741z00_15575 =
																			CAR(((obj_t) BgL_lz00_15572));
																		BgL_arg1740z00_15574 =
																			PROCEDURE_ENTRY(BgL_fun1741z00_15575)
																			(BgL_fun1741z00_15575, BgL_sz00_13568,
																			BEOA);
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13568), BgL_spz00_15573,
																		BgL_arg1740z00_15574);
																}
																{	/* Eval/evaluate_comp.scm 706 */
																	obj_t BgL_arg1742z00_15576;
																	long BgL_arg1743z00_15577;

																	BgL_arg1742z00_15576 =
																		CDR(((obj_t) BgL_lz00_15572));
																	BgL_arg1743z00_15577 =
																		(BgL_spz00_15573 + ((long) 1));
																	{
																		long BgL_spz00_19125;
																		obj_t BgL_lz00_19124;

																		BgL_lz00_19124 = BgL_arg1742z00_15576;
																		BgL_spz00_19125 = BgL_arg1743z00_15577;
																		BgL_spz00_15573 = BgL_spz00_19125;
																		BgL_lz00_15572 = BgL_lz00_19124;
																		goto BgL_recz00_15571;
																	}
																}
															}
													}
													{	/* Eval/evaluate_comp.scm 784 */
														long BgL_arg1815z00_15578;

														BgL_arg1815z00_15578 =
															(BgL_spz00_15570 + BgL_nbargsz00_13565);
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_sz00_13568, (long) CINT(BgL_bpz00_15564),
															BgL_sz00_13568, BINT(BgL_spz00_15570),
															BINT(BgL_arg1815z00_15578));
												}}
											else
												{	/* Eval/evaluate_comp.scm 780 */
													bool_t BgL_test6118z00_19131;

													if (((long) CINT(BgL_arityz00_15567) >= ((long) 0)))
														{	/* Eval/evaluate_comp.scm 780 */
															BgL_test6118z00_19131 = ((bool_t) 1);
														}
													else
														{	/* Eval/evaluate_comp.scm 780 */
															BgL_test6118z00_19131 =
																(
																(long) CINT(BgL_arityz00_15567) <
																(((long) -1) - BgL_nbargsz00_13565));
														}
													if (BgL_test6118z00_19131)
														{	/* Eval/evaluate_comp.scm 780 */
															BGl_evarityzd2errorzd2zz__everrorz00(
																(((BgL_ev_appz00_bglt)
																		COBJECT(BgL_i1157z00_13563))->BgL_locz00),
																STRUCT_REF(BgL_ufz00_15566, (int) (((long) 3))),
																(int) (BgL_nbargsz00_13565),
																CINT(BgL_arityz00_15567));
														}
													else
														{	/* Eval/evaluate_comp.scm 780 */
															BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00
																(BgL_arityz00_15567, BgL_sz00_13568,
																BgL_argsz00_13566, BINT(BgL_spz00_15570));
															{	/* Eval/evaluate_comp.scm 786 */
																long BgL_arg1822z00_15579;

																BgL_arg1822z00_15579 =
																	(BgL_spz00_15570 +
																	(((long) 0) -
																		(long) CINT(BgL_arityz00_15567)));
																BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																	(BgL_sz00_13568, (long) CINT(BgL_bpz00_15564),
																	BgL_sz00_13568, BINT(BgL_spz00_15570),
																	BINT(BgL_arg1822z00_15579));
												}}}
											{	/* Eval/evaluate_comp.scm 780 */
												obj_t BgL_z12denvz12_15580;

												BgL_z12denvz12_15580 = BGL_CURRENT_DYNAMIC_ENV();
												if (
													(((long) CINT(BgL_bpz00_15564) +
															(long) CINT(BgL_sfz00_15569)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13568))))
													{	/* Eval/evaluate_comp.scm 780 */
														return BgL_runz00_15568;
													}
												else
													{	/* Eval/evaluate_comp.scm 780 */
														obj_t BgL_nsz00_15581;

														BgL_nsz00_15581 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 780 */
															long BgL_arg1826z00_15582;

															BgL_arg1826z00_15582 =
																(
																(long) CINT(BgL_bpz00_15564) +
																BgL_nbargsz00_13565);
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_15581, ((long) 2), BgL_sz00_13568,
																BgL_bpz00_15564, BINT(BgL_arg1826z00_15582));
														}
														VECTOR_SET(BgL_nsz00_15581, ((long) 1),
															BgL_sz00_13568);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15580,
															BgL_nsz00_15581);
														{	/* Eval/evaluate_comp.scm 780 */
															obj_t BgL_ez00_15583;

															BgL_ez00_15583 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_15583, BgL_sz00_13568);
															{	/* Eval/evaluate_comp.scm 780 */
																obj_t BgL_____rz00_15584;

																{	/* Eval/evaluate_comp.scm 663 */
																	obj_t BgL_savedzd2bpzd2_15585;

																	BgL_savedzd2bpzd2_15585 =
																		VECTOR_REF(BgL_nsz00_15581, ((long) 0));
																	VECTOR_SET(BgL_nsz00_15581, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_15587;

																		BgL_fz00_15587 = BgL_runz00_15568;
																	BgL_recz00_15586:
																		{	/* Eval/evaluate_comp.scm 666 */
																			obj_t BgL_rz00_15588;

																			BgL_rz00_15588 =
																				PROCEDURE_ENTRY(BgL_fz00_15587)
																				(BgL_fz00_15587, BgL_nsz00_15581, BEOA);
																			{	/* Eval/evaluate_comp.scm 667 */
																				bool_t BgL_test6121z00_19177;

																				if (PROCEDUREP(BgL_rz00_15588))
																					{	/* Eval/evaluate_comp.scm 667 */
																						obj_t BgL_arg1707z00_15589;

																						BgL_arg1707z00_15589 =
																							PROCEDURE_ATTR(BgL_rz00_15588);
																						if (STRUCTP(BgL_arg1707z00_15589))
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_test6121z00_19177 =
																									(STRUCT_KEY
																									(BgL_arg1707z00_15589) ==
																									BGl_symbol5794z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_test6121z00_19177 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						BgL_test6121z00_19177 =
																							((bool_t) 0);
																					}
																				if (BgL_test6121z00_19177)
																					{
																						obj_t BgL_fz00_19185;

																						BgL_fz00_19185 = BgL_rz00_15588;
																						BgL_fz00_15587 = BgL_fz00_19185;
																						goto BgL_recz00_15586;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						VECTOR_SET(BgL_nsz00_15581,
																							((long) 0),
																							BgL_savedzd2bpzd2_15585);
																						BgL_____rz00_15584 = BgL_rz00_15588;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_15583);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15580,
																	BgL_sz00_13568);
																return BgL_____rz00_15584;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 780 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15565,
												(int) (BgL_nbargsz00_13565)))
											{	/* Eval/evaluate_comp.scm 780 */
												return
													BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00
													(BgL_sz00_13568, BgL_fz00_15565, BgL_argsz00_13566,
													BgL_bpz00_15564, BINT(BgL_siza7eza7_13567));
											}
										else
											{	/* Eval/evaluate_comp.scm 780 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(
													(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_13563))->
														BgL_locz00), BgL_symbzd2funzd2_13564,
													(int) (BgL_nbargsz00_13565),
													PROCEDURE_ARITY(BgL_fz00_15565));
		}}}}}}}}

	}



/* &<@anonymous:1836> */
	obj_t BGl_z62zc3z04anonymousza31836ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13569, obj_t BgL_sz00_13575)
	{
		{	/* Eval/evaluate_comp.scm 788 */
			{	/* Eval/evaluate_comp.scm 788 */
				obj_t BgL_fz00_13570;
				BgL_ev_appz00_bglt BgL_i1157z00_13571;
				obj_t BgL_symbzd2funzd2_13572;
				long BgL_nbargsz00_13573;
				obj_t BgL_argsz00_13574;

				BgL_fz00_13570 = PROCEDURE_REF(BgL_envz00_13569, (int) (((long) 0)));
				BgL_i1157z00_13571 =
					((BgL_ev_appz00_bglt)
					PROCEDURE_REF(BgL_envz00_13569, (int) (((long) 1))));
				BgL_symbzd2funzd2_13572 =
					PROCEDURE_REF(BgL_envz00_13569, (int) (((long) 2)));
				BgL_nbargsz00_13573 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13569, (int) (((long) 3))));
				BgL_argsz00_13574 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13569, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 788 */
					obj_t BgL_bpz00_15590;

					BgL_bpz00_15590 = VECTOR_REF(((obj_t) BgL_sz00_13575), ((long) 0));
					{	/* Eval/evaluate_comp.scm 788 */
						obj_t BgL_fz00_15591;

						BgL_fz00_15591 =
							PROCEDURE_ENTRY(BgL_fz00_13570) (BgL_fz00_13570, BgL_sz00_13575,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15591))
							{	/* Eval/evaluate_comp.scm 788 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 788 */
								BGl_evtypezd2errorzd2zz__everrorz00(
									(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_13571))->
										BgL_locz00), BGl_string5798z00zz__evaluate_compz00,
									BGl_string5814z00zz__evaluate_compz00, BgL_fz00_15591);
							}
						{	/* Eval/evaluate_comp.scm 788 */
							obj_t BgL_ufz00_15592;

							{	/* Eval/evaluate_comp.scm 788 */
								obj_t BgL_tmpz00_19221;

								BgL_tmpz00_19221 = ((obj_t) BgL_fz00_15591);
								BgL_ufz00_15592 = PROCEDURE_ATTR(BgL_tmpz00_19221);
							}
							{	/* Eval/evaluate_comp.scm 788 */
								bool_t BgL_test6126z00_19224;

								if (STRUCTP(BgL_ufz00_15592))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6126z00_19224 =
											(STRUCT_KEY(BgL_ufz00_15592) ==
											BGl_symbol5815z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6126z00_19224 = ((bool_t) 0);
									}
								if (BgL_test6126z00_19224)
									{	/* Eval/evaluate_comp.scm 788 */
										obj_t BgL_arityz00_15593;
										obj_t BgL_runz00_15594;
										obj_t BgL_sfz00_15595;

										BgL_arityz00_15593 =
											STRUCT_REF(BgL_ufz00_15592, (int) (((long) 0)));
										BgL_runz00_15594 =
											STRUCT_REF(BgL_ufz00_15592, (int) (((long) 1)));
										BgL_sfz00_15595 =
											STRUCT_REF(BgL_ufz00_15592, (int) (((long) 2)));
										if (
											((long) CINT(BgL_arityz00_15593) == BgL_nbargsz00_13573))
											{
												obj_t BgL_lz00_15597;
												obj_t BgL_spz00_15598;

												{	/* Eval/evaluate_comp.scm 703 */
													bool_t BgL_tmpz00_19238;

													BgL_lz00_15597 = BgL_argsz00_13574;
													BgL_spz00_15598 = BgL_bpz00_15590;
												BgL_recz00_15596:
													if (NULLP(BgL_lz00_15597))
														{	/* Eval/evaluate_comp.scm 704 */
															BgL_tmpz00_19238 = ((bool_t) 0);
														}
													else
														{	/* Eval/evaluate_comp.scm 704 */
															{	/* Eval/evaluate_comp.scm 705 */
																obj_t BgL_arg1740z00_15599;

																{	/* Eval/evaluate_comp.scm 705 */
																	obj_t BgL_fun1741z00_15600;

																	BgL_fun1741z00_15600 =
																		CAR(((obj_t) BgL_lz00_15597));
																	BgL_arg1740z00_15599 =
																		PROCEDURE_ENTRY(BgL_fun1741z00_15600)
																		(BgL_fun1741z00_15600, BgL_sz00_13575,
																		BEOA);
																}
																{	/* Eval/evaluate_comp.scm 705 */
																	long BgL_kz00_15601;

																	BgL_kz00_15601 = (long) CINT(BgL_spz00_15598);
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13575), BgL_kz00_15601,
																		BgL_arg1740z00_15599);
															}}
															{	/* Eval/evaluate_comp.scm 706 */
																obj_t BgL_arg1742z00_15602;
																long BgL_arg1743z00_15603;

																BgL_arg1742z00_15602 =
																	CDR(((obj_t) BgL_lz00_15597));
																BgL_arg1743z00_15603 =
																	((long) CINT(BgL_spz00_15598) + ((long) 1));
																{
																	obj_t BgL_spz00_19255;
																	obj_t BgL_lz00_19254;

																	BgL_lz00_19254 = BgL_arg1742z00_15602;
																	BgL_spz00_19255 = BINT(BgL_arg1743z00_15603);
																	BgL_spz00_15598 = BgL_spz00_19255;
																	BgL_lz00_15597 = BgL_lz00_19254;
																	goto BgL_recz00_15596;
																}
															}
														}
													BBOOL(BgL_tmpz00_19238);
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 788 */
												bool_t BgL_test6130z00_19258;

												if (((long) CINT(BgL_arityz00_15593) >= ((long) 0)))
													{	/* Eval/evaluate_comp.scm 788 */
														BgL_test6130z00_19258 = ((bool_t) 1);
													}
												else
													{	/* Eval/evaluate_comp.scm 788 */
														BgL_test6130z00_19258 =
															(
															(long) CINT(BgL_arityz00_15593) <
															(((long) -1) - BgL_nbargsz00_13573));
													}
												if (BgL_test6130z00_19258)
													{	/* Eval/evaluate_comp.scm 788 */
														BGl_evarityzd2errorzd2zz__everrorz00(
															(((BgL_ev_appz00_bglt)
																	COBJECT(BgL_i1157z00_13571))->BgL_locz00),
															STRUCT_REF(BgL_ufz00_15592, (int) (((long) 3))),
															(int) (BgL_nbargsz00_13573),
															CINT(BgL_arityz00_15593));
													}
												else
													{	/* Eval/evaluate_comp.scm 788 */
														BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00
															(BgL_arityz00_15593, BgL_sz00_13575,
															BgL_argsz00_13574, BgL_bpz00_15590);
													}
											}
										{	/* Eval/evaluate_comp.scm 788 */
											obj_t BgL_z12denvz12_15604;

											BgL_z12denvz12_15604 = BGL_CURRENT_DYNAMIC_ENV();
											{	/* Eval/evaluate_comp.scm 788 */
												obj_t BgL_tmpz00_19273;

												BgL_tmpz00_19273 =
													(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_13571))->
													BgL_locz00);
												BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_15604,
													BgL_tmpz00_19273);
											}
											if (
												(((long) CINT(BgL_bpz00_15590) +
														(long) CINT(BgL_sfz00_15595)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_13575))))
												{	/* Eval/evaluate_comp.scm 788 */
													return BgL_runz00_15594;
												}
											else
												{	/* Eval/evaluate_comp.scm 788 */
													obj_t BgL_nsz00_15605;

													BgL_nsz00_15605 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 788 */
														long BgL_arg1852z00_15606;

														BgL_arg1852z00_15606 =
															(
															(long) CINT(BgL_bpz00_15590) +
															BgL_nbargsz00_13573);
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_15605, ((long) 2), BgL_sz00_13575,
															BgL_bpz00_15590, BINT(BgL_arg1852z00_15606));
													}
													VECTOR_SET(BgL_nsz00_15605, ((long) 1),
														BgL_sz00_13575);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15604,
														BgL_nsz00_15605);
													{	/* Eval/evaluate_comp.scm 788 */
														obj_t BgL_ez00_15607;

														BgL_ez00_15607 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_15607, BgL_sz00_13575);
														{	/* Eval/evaluate_comp.scm 788 */
															obj_t BgL_____rz00_15608;

															{	/* Eval/evaluate_comp.scm 663 */
																obj_t BgL_savedzd2bpzd2_15609;

																BgL_savedzd2bpzd2_15609 =
																	VECTOR_REF(BgL_nsz00_15605, ((long) 0));
																VECTOR_SET(BgL_nsz00_15605, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_15611;

																	BgL_fz00_15611 = BgL_runz00_15594;
																BgL_recz00_15610:
																	{	/* Eval/evaluate_comp.scm 666 */
																		obj_t BgL_rz00_15612;

																		BgL_rz00_15612 =
																			PROCEDURE_ENTRY(BgL_fz00_15611)
																			(BgL_fz00_15611, BgL_nsz00_15605, BEOA);
																		{	/* Eval/evaluate_comp.scm 667 */
																			bool_t BgL_test6133z00_19299;

																			if (PROCEDUREP(BgL_rz00_15612))
																				{	/* Eval/evaluate_comp.scm 667 */
																					obj_t BgL_arg1707z00_15613;

																					BgL_arg1707z00_15613 =
																						PROCEDURE_ATTR(BgL_rz00_15612);
																					if (STRUCTP(BgL_arg1707z00_15613))
																						{	/* Eval/evaluate_comp.scm 647 */
																							BgL_test6133z00_19299 =
																								(STRUCT_KEY
																								(BgL_arg1707z00_15613) ==
																								BGl_symbol5794z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 647 */
																							BgL_test6133z00_19299 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 667 */
																					BgL_test6133z00_19299 = ((bool_t) 0);
																				}
																			if (BgL_test6133z00_19299)
																				{
																					obj_t BgL_fz00_19307;

																					BgL_fz00_19307 = BgL_rz00_15612;
																					BgL_fz00_15611 = BgL_fz00_19307;
																					goto BgL_recz00_15610;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 667 */
																					VECTOR_SET(BgL_nsz00_15605,
																						((long) 0),
																						BgL_savedzd2bpzd2_15609);
																					BgL_____rz00_15608 = BgL_rz00_15612;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_15607);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15604,
																BgL_sz00_13575);
															return BgL_____rz00_15608;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 788 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15591,
												(int) (BgL_nbargsz00_13573)))
											{	/* Eval/evaluate_comp.scm 788 */
												{	/* Eval/evaluate_comp.scm 788 */
													obj_t BgL_auxz00_19316;
													obj_t BgL_tmpz00_19314;

													BgL_auxz00_19316 =
														(((BgL_ev_appz00_bglt)
															COBJECT(BgL_i1157z00_13571))->BgL_locz00);
													BgL_tmpz00_19314 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_19314,
														BgL_auxz00_19316);
												}
												return
													BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00
													(BgL_sz00_13575, BgL_fz00_15591, BgL_argsz00_13574,
													BgL_bpz00_15590, BINT(BgL_nbargsz00_13573));
											}
										else
											{	/* Eval/evaluate_comp.scm 788 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(
													(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_13571))->
														BgL_locz00), BgL_symbzd2funzd2_13572,
													(int) (BgL_nbargsz00_13573),
													PROCEDURE_ARITY(BgL_fz00_15591));
		}}}}}}}}

	}



/* &<@anonymous:1859> */
	obj_t BGl_z62zc3z04anonymousza31859ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13576, obj_t BgL_sz00_13582)
	{
		{	/* Eval/evaluate_comp.scm 788 */
			{	/* Eval/evaluate_comp.scm 788 */
				obj_t BgL_fz00_13577;
				BgL_ev_appz00_bglt BgL_i1157z00_13578;
				obj_t BgL_symbzd2funzd2_13579;
				long BgL_nbargsz00_13580;
				obj_t BgL_argsz00_13581;

				BgL_fz00_13577 = PROCEDURE_REF(BgL_envz00_13576, (int) (((long) 0)));
				BgL_i1157z00_13578 =
					((BgL_ev_appz00_bglt)
					PROCEDURE_REF(BgL_envz00_13576, (int) (((long) 1))));
				BgL_symbzd2funzd2_13579 =
					PROCEDURE_REF(BgL_envz00_13576, (int) (((long) 2)));
				BgL_nbargsz00_13580 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13576, (int) (((long) 3))));
				BgL_argsz00_13581 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13576, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 788 */
					obj_t BgL_bpz00_15614;

					BgL_bpz00_15614 = VECTOR_REF(((obj_t) BgL_sz00_13582), ((long) 0));
					{	/* Eval/evaluate_comp.scm 788 */
						obj_t BgL_fz00_15615;

						BgL_fz00_15615 =
							PROCEDURE_ENTRY(BgL_fz00_13577) (BgL_fz00_13577, BgL_sz00_13582,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15615))
							{	/* Eval/evaluate_comp.scm 788 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 788 */
								BGl_evtypezd2errorzd2zz__everrorz00(
									(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_13578))->
										BgL_locz00), BGl_string5798z00zz__evaluate_compz00,
									BGl_string5814z00zz__evaluate_compz00, BgL_fz00_15615);
							}
						{	/* Eval/evaluate_comp.scm 788 */
							obj_t BgL_ufz00_15616;

							{	/* Eval/evaluate_comp.scm 788 */
								obj_t BgL_tmpz00_19348;

								BgL_tmpz00_19348 = ((obj_t) BgL_fz00_15615);
								BgL_ufz00_15616 = PROCEDURE_ATTR(BgL_tmpz00_19348);
							}
							{	/* Eval/evaluate_comp.scm 788 */
								bool_t BgL_test6138z00_19351;

								if (STRUCTP(BgL_ufz00_15616))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6138z00_19351 =
											(STRUCT_KEY(BgL_ufz00_15616) ==
											BGl_symbol5815z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6138z00_19351 = ((bool_t) 0);
									}
								if (BgL_test6138z00_19351)
									{	/* Eval/evaluate_comp.scm 788 */
										obj_t BgL_arityz00_15617;
										obj_t BgL_runz00_15618;
										obj_t BgL_sfz00_15619;

										BgL_arityz00_15617 =
											STRUCT_REF(BgL_ufz00_15616, (int) (((long) 0)));
										BgL_runz00_15618 =
											STRUCT_REF(BgL_ufz00_15616, (int) (((long) 1)));
										BgL_sfz00_15619 =
											STRUCT_REF(BgL_ufz00_15616, (int) (((long) 2)));
										if (
											((long) CINT(BgL_arityz00_15617) == BgL_nbargsz00_13580))
											{
												obj_t BgL_lz00_15621;
												obj_t BgL_spz00_15622;

												{	/* Eval/evaluate_comp.scm 703 */
													bool_t BgL_tmpz00_19365;

													BgL_lz00_15621 = BgL_argsz00_13581;
													BgL_spz00_15622 = BgL_bpz00_15614;
												BgL_recz00_15620:
													if (NULLP(BgL_lz00_15621))
														{	/* Eval/evaluate_comp.scm 704 */
															BgL_tmpz00_19365 = ((bool_t) 0);
														}
													else
														{	/* Eval/evaluate_comp.scm 704 */
															{	/* Eval/evaluate_comp.scm 705 */
																obj_t BgL_arg1740z00_15623;

																{	/* Eval/evaluate_comp.scm 705 */
																	obj_t BgL_fun1741z00_15624;

																	BgL_fun1741z00_15624 =
																		CAR(((obj_t) BgL_lz00_15621));
																	BgL_arg1740z00_15623 =
																		PROCEDURE_ENTRY(BgL_fun1741z00_15624)
																		(BgL_fun1741z00_15624, BgL_sz00_13582,
																		BEOA);
																}
																{	/* Eval/evaluate_comp.scm 705 */
																	long BgL_kz00_15625;

																	BgL_kz00_15625 = (long) CINT(BgL_spz00_15622);
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13582), BgL_kz00_15625,
																		BgL_arg1740z00_15623);
															}}
															{	/* Eval/evaluate_comp.scm 706 */
																obj_t BgL_arg1742z00_15626;
																long BgL_arg1743z00_15627;

																BgL_arg1742z00_15626 =
																	CDR(((obj_t) BgL_lz00_15621));
																BgL_arg1743z00_15627 =
																	((long) CINT(BgL_spz00_15622) + ((long) 1));
																{
																	obj_t BgL_spz00_19382;
																	obj_t BgL_lz00_19381;

																	BgL_lz00_19381 = BgL_arg1742z00_15626;
																	BgL_spz00_19382 = BINT(BgL_arg1743z00_15627);
																	BgL_spz00_15622 = BgL_spz00_19382;
																	BgL_lz00_15621 = BgL_lz00_19381;
																	goto BgL_recz00_15620;
																}
															}
														}
													BBOOL(BgL_tmpz00_19365);
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 788 */
												bool_t BgL_test6142z00_19385;

												if (((long) CINT(BgL_arityz00_15617) >= ((long) 0)))
													{	/* Eval/evaluate_comp.scm 788 */
														BgL_test6142z00_19385 = ((bool_t) 1);
													}
												else
													{	/* Eval/evaluate_comp.scm 788 */
														BgL_test6142z00_19385 =
															(
															(long) CINT(BgL_arityz00_15617) <
															(((long) -1) - BgL_nbargsz00_13580));
													}
												if (BgL_test6142z00_19385)
													{	/* Eval/evaluate_comp.scm 788 */
														BGl_evarityzd2errorzd2zz__everrorz00(
															(((BgL_ev_appz00_bglt)
																	COBJECT(BgL_i1157z00_13578))->BgL_locz00),
															STRUCT_REF(BgL_ufz00_15616, (int) (((long) 3))),
															(int) (BgL_nbargsz00_13580),
															CINT(BgL_arityz00_15617));
													}
												else
													{	/* Eval/evaluate_comp.scm 788 */
														BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00
															(BgL_arityz00_15617, BgL_sz00_13582,
															BgL_argsz00_13581, BgL_bpz00_15614);
													}
											}
										{	/* Eval/evaluate_comp.scm 788 */
											obj_t BgL_z12denvz12_15628;

											BgL_z12denvz12_15628 = BGL_CURRENT_DYNAMIC_ENV();
											if (
												(((long) CINT(BgL_bpz00_15614) +
														(long) CINT(BgL_sfz00_15619)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_13582))))
												{	/* Eval/evaluate_comp.scm 788 */
													return BgL_runz00_15618;
												}
											else
												{	/* Eval/evaluate_comp.scm 788 */
													obj_t BgL_nsz00_15629;

													BgL_nsz00_15629 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 788 */
														long BgL_arg1872z00_15630;

														BgL_arg1872z00_15630 =
															(
															(long) CINT(BgL_bpz00_15614) +
															BgL_nbargsz00_13580);
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_15629, ((long) 2), BgL_sz00_13582,
															BgL_bpz00_15614, BINT(BgL_arg1872z00_15630));
													}
													VECTOR_SET(BgL_nsz00_15629, ((long) 1),
														BgL_sz00_13582);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15628,
														BgL_nsz00_15629);
													{	/* Eval/evaluate_comp.scm 788 */
														obj_t BgL_ez00_15631;

														BgL_ez00_15631 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_15631, BgL_sz00_13582);
														{	/* Eval/evaluate_comp.scm 788 */
															obj_t BgL_____rz00_15632;

															{	/* Eval/evaluate_comp.scm 663 */
																obj_t BgL_savedzd2bpzd2_15633;

																BgL_savedzd2bpzd2_15633 =
																	VECTOR_REF(BgL_nsz00_15629, ((long) 0));
																VECTOR_SET(BgL_nsz00_15629, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_15635;

																	BgL_fz00_15635 = BgL_runz00_15618;
																BgL_recz00_15634:
																	{	/* Eval/evaluate_comp.scm 666 */
																		obj_t BgL_rz00_15636;

																		BgL_rz00_15636 =
																			PROCEDURE_ENTRY(BgL_fz00_15635)
																			(BgL_fz00_15635, BgL_nsz00_15629, BEOA);
																		{	/* Eval/evaluate_comp.scm 667 */
																			bool_t BgL_test6145z00_19423;

																			if (PROCEDUREP(BgL_rz00_15636))
																				{	/* Eval/evaluate_comp.scm 667 */
																					obj_t BgL_arg1707z00_15637;

																					BgL_arg1707z00_15637 =
																						PROCEDURE_ATTR(BgL_rz00_15636);
																					if (STRUCTP(BgL_arg1707z00_15637))
																						{	/* Eval/evaluate_comp.scm 647 */
																							BgL_test6145z00_19423 =
																								(STRUCT_KEY
																								(BgL_arg1707z00_15637) ==
																								BGl_symbol5794z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 647 */
																							BgL_test6145z00_19423 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 667 */
																					BgL_test6145z00_19423 = ((bool_t) 0);
																				}
																			if (BgL_test6145z00_19423)
																				{
																					obj_t BgL_fz00_19431;

																					BgL_fz00_19431 = BgL_rz00_15636;
																					BgL_fz00_15635 = BgL_fz00_19431;
																					goto BgL_recz00_15634;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 667 */
																					VECTOR_SET(BgL_nsz00_15629,
																						((long) 0),
																						BgL_savedzd2bpzd2_15633);
																					BgL_____rz00_15632 = BgL_rz00_15636;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_15631);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15628,
																BgL_sz00_13582);
															return BgL_____rz00_15632;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 788 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15615,
												(int) (BgL_nbargsz00_13580)))
											{	/* Eval/evaluate_comp.scm 788 */
												return
													BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00
													(BgL_sz00_13582, BgL_fz00_15615, BgL_argsz00_13581,
													BgL_bpz00_15614, BINT(BgL_nbargsz00_13580));
											}
										else
											{	/* Eval/evaluate_comp.scm 788 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(
													(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_13578))->
														BgL_locz00), BgL_symbzd2funzd2_13579,
													(int) (BgL_nbargsz00_13580),
													PROCEDURE_ARITY(BgL_fz00_15615));
		}}}}}}}}

	}



/* &<@anonymous:1881> */
	obj_t BGl_z62zc3z04anonymousza31881ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13583, obj_t BgL_sz00_13590)
	{
		{	/* Eval/evaluate_comp.scm 774 */
			{	/* Eval/evaluate_comp.scm 774 */
				obj_t BgL_fz00_13584;
				BgL_ev_appz00_bglt BgL_i1157z00_13585;
				obj_t BgL_symbzd2funzd2_13586;
				long BgL_nbargsz00_13587;
				obj_t BgL_argsz00_13588;
				long BgL_siza7eza7_13589;

				BgL_fz00_13584 = PROCEDURE_REF(BgL_envz00_13583, (int) (((long) 0)));
				BgL_i1157z00_13585 =
					((BgL_ev_appz00_bglt)
					PROCEDURE_REF(BgL_envz00_13583, (int) (((long) 1))));
				BgL_symbzd2funzd2_13586 =
					PROCEDURE_REF(BgL_envz00_13583, (int) (((long) 2)));
				BgL_nbargsz00_13587 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13583, (int) (((long) 3))));
				BgL_argsz00_13588 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13583, (int) (((long) 4))));
				BgL_siza7eza7_13589 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13583, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 774 */
					obj_t BgL_bpz00_15638;

					BgL_bpz00_15638 = VECTOR_REF(((obj_t) BgL_sz00_13590), ((long) 0));
					{	/* Eval/evaluate_comp.scm 774 */
						obj_t BgL_fz00_15639;

						BgL_fz00_15639 =
							PROCEDURE_ENTRY(BgL_fz00_13584) (BgL_fz00_13584, BgL_sz00_13590,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15639))
							{	/* Eval/evaluate_comp.scm 774 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 774 */
								BGl_evtypezd2errorzd2zz__everrorz00(
									(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_13585))->
										BgL_locz00), BGl_string5798z00zz__evaluate_compz00,
									BGl_string5814z00zz__evaluate_compz00, BgL_fz00_15639);
							}
						{	/* Eval/evaluate_comp.scm 774 */
							obj_t BgL_ufz00_15640;

							{	/* Eval/evaluate_comp.scm 774 */
								obj_t BgL_tmpz00_19470;

								BgL_tmpz00_19470 = ((obj_t) BgL_fz00_15639);
								BgL_ufz00_15640 = PROCEDURE_ATTR(BgL_tmpz00_19470);
							}
							{	/* Eval/evaluate_comp.scm 774 */
								bool_t BgL_test6150z00_19473;

								if (STRUCTP(BgL_ufz00_15640))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6150z00_19473 =
											(STRUCT_KEY(BgL_ufz00_15640) ==
											BGl_symbol5815z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6150z00_19473 = ((bool_t) 0);
									}
								if (BgL_test6150z00_19473)
									{	/* Eval/evaluate_comp.scm 774 */
										obj_t BgL_arityz00_15641;
										obj_t BgL_runz00_15642;
										obj_t BgL_sfz00_15643;

										BgL_arityz00_15641 =
											STRUCT_REF(BgL_ufz00_15640, (int) (((long) 0)));
										BgL_runz00_15642 =
											STRUCT_REF(BgL_ufz00_15640, (int) (((long) 1)));
										BgL_sfz00_15643 =
											STRUCT_REF(BgL_ufz00_15640, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 774 */
											long BgL_spz00_15644;

											BgL_spz00_15644 =
												((long) CINT(BgL_bpz00_15638) + BgL_siza7eza7_13589);
											if (
												((long) CINT(BgL_arityz00_15641) ==
													BgL_nbargsz00_13587))
												{
													obj_t BgL_lz00_15646;
													long BgL_spz00_15647;

													{	/* Eval/evaluate_comp.scm 703 */
														bool_t BgL_tmpz00_19489;

														BgL_lz00_15646 = BgL_argsz00_13588;
														BgL_spz00_15647 = BgL_spz00_15644;
													BgL_recz00_15645:
														if (NULLP(BgL_lz00_15646))
															{	/* Eval/evaluate_comp.scm 704 */
																BgL_tmpz00_19489 = ((bool_t) 0);
															}
														else
															{	/* Eval/evaluate_comp.scm 704 */
																{	/* Eval/evaluate_comp.scm 705 */
																	obj_t BgL_arg1740z00_15648;

																	{	/* Eval/evaluate_comp.scm 705 */
																		obj_t BgL_fun1741z00_15649;

																		BgL_fun1741z00_15649 =
																			CAR(((obj_t) BgL_lz00_15646));
																		BgL_arg1740z00_15648 =
																			PROCEDURE_ENTRY(BgL_fun1741z00_15649)
																			(BgL_fun1741z00_15649, BgL_sz00_13590,
																			BEOA);
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13590), BgL_spz00_15647,
																		BgL_arg1740z00_15648);
																}
																{	/* Eval/evaluate_comp.scm 706 */
																	obj_t BgL_arg1742z00_15650;
																	long BgL_arg1743z00_15651;

																	BgL_arg1742z00_15650 =
																		CDR(((obj_t) BgL_lz00_15646));
																	BgL_arg1743z00_15651 =
																		(BgL_spz00_15647 + ((long) 1));
																	{
																		long BgL_spz00_19504;
																		obj_t BgL_lz00_19503;

																		BgL_lz00_19503 = BgL_arg1742z00_15650;
																		BgL_spz00_19504 = BgL_arg1743z00_15651;
																		BgL_spz00_15647 = BgL_spz00_19504;
																		BgL_lz00_15646 = BgL_lz00_19503;
																		goto BgL_recz00_15645;
																	}
																}
															}
														BBOOL(BgL_tmpz00_19489);
													}
												}
											else
												{	/* Eval/evaluate_comp.scm 774 */
													bool_t BgL_test6154z00_19506;

													if (((long) CINT(BgL_arityz00_15641) >= ((long) 0)))
														{	/* Eval/evaluate_comp.scm 774 */
															BgL_test6154z00_19506 = ((bool_t) 1);
														}
													else
														{	/* Eval/evaluate_comp.scm 774 */
															BgL_test6154z00_19506 =
																(
																(long) CINT(BgL_arityz00_15641) <
																(((long) -1) - BgL_nbargsz00_13587));
														}
													if (BgL_test6154z00_19506)
														{	/* Eval/evaluate_comp.scm 774 */
															BGl_evarityzd2errorzd2zz__everrorz00(
																(((BgL_ev_appz00_bglt)
																		COBJECT(BgL_i1157z00_13585))->BgL_locz00),
																STRUCT_REF(BgL_ufz00_15640, (int) (((long) 3))),
																(int) (BgL_nbargsz00_13587),
																CINT(BgL_arityz00_15641));
														}
													else
														{	/* Eval/evaluate_comp.scm 774 */
															BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00
																(BgL_arityz00_15641, BgL_sz00_13590,
																BgL_argsz00_13588, BINT(BgL_spz00_15644));
														}
												}
											{	/* Eval/evaluate_comp.scm 774 */
												obj_t BgL_z12denvz12_15652;

												BgL_z12denvz12_15652 = BGL_CURRENT_DYNAMIC_ENV();
												{	/* Eval/evaluate_comp.scm 774 */
													obj_t BgL_tmpz00_19522;

													BgL_tmpz00_19522 =
														(((BgL_ev_appz00_bglt)
															COBJECT(BgL_i1157z00_13585))->BgL_locz00);
													BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_15652,
														BgL_tmpz00_19522);
												}
												if (
													((BgL_spz00_15644 +
															(long) CINT(BgL_sfz00_15643)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13590))))
													{	/* Eval/evaluate_comp.scm 774 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_15642, BgL_sz00_13590,
															BINT(BgL_spz00_15644));
													}
												else
													{	/* Eval/evaluate_comp.scm 774 */
														obj_t BgL_nsz00_15653;

														BgL_nsz00_15653 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 774 */
															long BgL_arg1895z00_15654;

															BgL_arg1895z00_15654 =
																(BgL_spz00_15644 + BgL_nbargsz00_13587);
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_15653, ((long) 2), BgL_sz00_13590,
																BINT(BgL_spz00_15644),
																BINT(BgL_arg1895z00_15654));
														}
														VECTOR_SET(BgL_nsz00_15653, ((long) 1),
															BgL_sz00_13590);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15652,
															BgL_nsz00_15653);
														{	/* Eval/evaluate_comp.scm 774 */
															obj_t BgL_ez00_15655;

															BgL_ez00_15655 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_15655, BgL_sz00_13590);
															{	/* Eval/evaluate_comp.scm 774 */
																obj_t BgL_____rz00_15656;

																{	/* Eval/evaluate_comp.scm 663 */
																	obj_t BgL_savedzd2bpzd2_15657;

																	BgL_savedzd2bpzd2_15657 =
																		VECTOR_REF(BgL_nsz00_15653, ((long) 0));
																	VECTOR_SET(BgL_nsz00_15653, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_15659;

																		BgL_fz00_15659 = BgL_runz00_15642;
																	BgL_recz00_15658:
																		{	/* Eval/evaluate_comp.scm 666 */
																			obj_t BgL_rz00_15660;

																			BgL_rz00_15660 =
																				PROCEDURE_ENTRY(BgL_fz00_15659)
																				(BgL_fz00_15659, BgL_nsz00_15653, BEOA);
																			{	/* Eval/evaluate_comp.scm 667 */
																				bool_t BgL_test6157z00_19549;

																				if (PROCEDUREP(BgL_rz00_15660))
																					{	/* Eval/evaluate_comp.scm 667 */
																						obj_t BgL_arg1707z00_15661;

																						BgL_arg1707z00_15661 =
																							PROCEDURE_ATTR(BgL_rz00_15660);
																						if (STRUCTP(BgL_arg1707z00_15661))
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_test6157z00_19549 =
																									(STRUCT_KEY
																									(BgL_arg1707z00_15661) ==
																									BGl_symbol5794z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_test6157z00_19549 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						BgL_test6157z00_19549 =
																							((bool_t) 0);
																					}
																				if (BgL_test6157z00_19549)
																					{
																						obj_t BgL_fz00_19557;

																						BgL_fz00_19557 = BgL_rz00_15660;
																						BgL_fz00_15659 = BgL_fz00_19557;
																						goto BgL_recz00_15658;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						VECTOR_SET(BgL_nsz00_15653,
																							((long) 0),
																							BgL_savedzd2bpzd2_15657);
																						BgL_____rz00_15656 = BgL_rz00_15660;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_15655);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15652,
																	BgL_sz00_13590);
																return BgL_____rz00_15656;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 774 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15639,
												(int) (BgL_nbargsz00_13587)))
											{	/* Eval/evaluate_comp.scm 774 */
												{	/* Eval/evaluate_comp.scm 774 */
													obj_t BgL_auxz00_19566;
													obj_t BgL_tmpz00_19564;

													BgL_auxz00_19566 =
														(((BgL_ev_appz00_bglt)
															COBJECT(BgL_i1157z00_13585))->BgL_locz00);
													BgL_tmpz00_19564 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_19564,
														BgL_auxz00_19566);
												}
												return
													BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00
													(BgL_sz00_13590, BgL_fz00_15639, BgL_argsz00_13588,
													BgL_bpz00_15638, BINT(BgL_siza7eza7_13589));
											}
										else
											{	/* Eval/evaluate_comp.scm 774 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(
													(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_13585))->
														BgL_locz00), BgL_symbzd2funzd2_13586,
													(int) (BgL_nbargsz00_13587),
													PROCEDURE_ARITY(BgL_fz00_15639));
		}}}}}}}}

	}



/* &<@anonymous:1903> */
	obj_t BGl_z62zc3z04anonymousza31903ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13591, obj_t BgL_sz00_13598)
	{
		{	/* Eval/evaluate_comp.scm 774 */
			{	/* Eval/evaluate_comp.scm 774 */
				obj_t BgL_fz00_13592;
				BgL_ev_appz00_bglt BgL_i1157z00_13593;
				obj_t BgL_symbzd2funzd2_13594;
				long BgL_nbargsz00_13595;
				obj_t BgL_argsz00_13596;
				long BgL_siza7eza7_13597;

				BgL_fz00_13592 = PROCEDURE_REF(BgL_envz00_13591, (int) (((long) 0)));
				BgL_i1157z00_13593 =
					((BgL_ev_appz00_bglt)
					PROCEDURE_REF(BgL_envz00_13591, (int) (((long) 1))));
				BgL_symbzd2funzd2_13594 =
					PROCEDURE_REF(BgL_envz00_13591, (int) (((long) 2)));
				BgL_nbargsz00_13595 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13591, (int) (((long) 3))));
				BgL_argsz00_13596 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13591, (int) (((long) 4))));
				BgL_siza7eza7_13597 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13591, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 774 */
					obj_t BgL_bpz00_15662;

					BgL_bpz00_15662 = VECTOR_REF(((obj_t) BgL_sz00_13598), ((long) 0));
					{	/* Eval/evaluate_comp.scm 774 */
						obj_t BgL_fz00_15663;

						BgL_fz00_15663 =
							PROCEDURE_ENTRY(BgL_fz00_13592) (BgL_fz00_13592, BgL_sz00_13598,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15663))
							{	/* Eval/evaluate_comp.scm 774 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 774 */
								BGl_evtypezd2errorzd2zz__everrorz00(
									(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_13593))->
										BgL_locz00), BGl_string5798z00zz__evaluate_compz00,
									BGl_string5814z00zz__evaluate_compz00, BgL_fz00_15663);
							}
						{	/* Eval/evaluate_comp.scm 774 */
							obj_t BgL_ufz00_15664;

							{	/* Eval/evaluate_comp.scm 774 */
								obj_t BgL_tmpz00_19601;

								BgL_tmpz00_19601 = ((obj_t) BgL_fz00_15663);
								BgL_ufz00_15664 = PROCEDURE_ATTR(BgL_tmpz00_19601);
							}
							{	/* Eval/evaluate_comp.scm 774 */
								bool_t BgL_test6162z00_19604;

								if (STRUCTP(BgL_ufz00_15664))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6162z00_19604 =
											(STRUCT_KEY(BgL_ufz00_15664) ==
											BGl_symbol5815z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6162z00_19604 = ((bool_t) 0);
									}
								if (BgL_test6162z00_19604)
									{	/* Eval/evaluate_comp.scm 774 */
										obj_t BgL_arityz00_15665;
										obj_t BgL_runz00_15666;
										obj_t BgL_sfz00_15667;

										BgL_arityz00_15665 =
											STRUCT_REF(BgL_ufz00_15664, (int) (((long) 0)));
										BgL_runz00_15666 =
											STRUCT_REF(BgL_ufz00_15664, (int) (((long) 1)));
										BgL_sfz00_15667 =
											STRUCT_REF(BgL_ufz00_15664, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 774 */
											long BgL_spz00_15668;

											BgL_spz00_15668 =
												((long) CINT(BgL_bpz00_15662) + BgL_siza7eza7_13597);
											if (
												((long) CINT(BgL_arityz00_15665) ==
													BgL_nbargsz00_13595))
												{
													obj_t BgL_lz00_15670;
													long BgL_spz00_15671;

													{	/* Eval/evaluate_comp.scm 703 */
														bool_t BgL_tmpz00_19620;

														BgL_lz00_15670 = BgL_argsz00_13596;
														BgL_spz00_15671 = BgL_spz00_15668;
													BgL_recz00_15669:
														if (NULLP(BgL_lz00_15670))
															{	/* Eval/evaluate_comp.scm 704 */
																BgL_tmpz00_19620 = ((bool_t) 0);
															}
														else
															{	/* Eval/evaluate_comp.scm 704 */
																{	/* Eval/evaluate_comp.scm 705 */
																	obj_t BgL_arg1740z00_15672;

																	{	/* Eval/evaluate_comp.scm 705 */
																		obj_t BgL_fun1741z00_15673;

																		BgL_fun1741z00_15673 =
																			CAR(((obj_t) BgL_lz00_15670));
																		BgL_arg1740z00_15672 =
																			PROCEDURE_ENTRY(BgL_fun1741z00_15673)
																			(BgL_fun1741z00_15673, BgL_sz00_13598,
																			BEOA);
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13598), BgL_spz00_15671,
																		BgL_arg1740z00_15672);
																}
																{	/* Eval/evaluate_comp.scm 706 */
																	obj_t BgL_arg1742z00_15674;
																	long BgL_arg1743z00_15675;

																	BgL_arg1742z00_15674 =
																		CDR(((obj_t) BgL_lz00_15670));
																	BgL_arg1743z00_15675 =
																		(BgL_spz00_15671 + ((long) 1));
																	{
																		long BgL_spz00_19635;
																		obj_t BgL_lz00_19634;

																		BgL_lz00_19634 = BgL_arg1742z00_15674;
																		BgL_spz00_19635 = BgL_arg1743z00_15675;
																		BgL_spz00_15671 = BgL_spz00_19635;
																		BgL_lz00_15670 = BgL_lz00_19634;
																		goto BgL_recz00_15669;
																	}
																}
															}
														BBOOL(BgL_tmpz00_19620);
													}
												}
											else
												{	/* Eval/evaluate_comp.scm 774 */
													bool_t BgL_test6166z00_19637;

													if (((long) CINT(BgL_arityz00_15665) >= ((long) 0)))
														{	/* Eval/evaluate_comp.scm 774 */
															BgL_test6166z00_19637 = ((bool_t) 1);
														}
													else
														{	/* Eval/evaluate_comp.scm 774 */
															BgL_test6166z00_19637 =
																(
																(long) CINT(BgL_arityz00_15665) <
																(((long) -1) - BgL_nbargsz00_13595));
														}
													if (BgL_test6166z00_19637)
														{	/* Eval/evaluate_comp.scm 774 */
															BGl_evarityzd2errorzd2zz__everrorz00(
																(((BgL_ev_appz00_bglt)
																		COBJECT(BgL_i1157z00_13593))->BgL_locz00),
																STRUCT_REF(BgL_ufz00_15664, (int) (((long) 3))),
																(int) (BgL_nbargsz00_13595),
																CINT(BgL_arityz00_15665));
														}
													else
														{	/* Eval/evaluate_comp.scm 774 */
															BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00
																(BgL_arityz00_15665, BgL_sz00_13598,
																BgL_argsz00_13596, BINT(BgL_spz00_15668));
														}
												}
											{	/* Eval/evaluate_comp.scm 774 */
												obj_t BgL_z12denvz12_15676;

												BgL_z12denvz12_15676 = BGL_CURRENT_DYNAMIC_ENV();
												if (
													((BgL_spz00_15668 +
															(long) CINT(BgL_sfz00_15667)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13598))))
													{	/* Eval/evaluate_comp.scm 774 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_15666, BgL_sz00_13598,
															BINT(BgL_spz00_15668));
													}
												else
													{	/* Eval/evaluate_comp.scm 774 */
														obj_t BgL_nsz00_15677;

														BgL_nsz00_15677 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 774 */
															long BgL_arg1915z00_15678;

															BgL_arg1915z00_15678 =
																(BgL_spz00_15668 + BgL_nbargsz00_13595);
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_15677, ((long) 2), BgL_sz00_13598,
																BINT(BgL_spz00_15668),
																BINT(BgL_arg1915z00_15678));
														}
														VECTOR_SET(BgL_nsz00_15677, ((long) 1),
															BgL_sz00_13598);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15676,
															BgL_nsz00_15677);
														{	/* Eval/evaluate_comp.scm 774 */
															obj_t BgL_ez00_15679;

															BgL_ez00_15679 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_15679, BgL_sz00_13598);
															{	/* Eval/evaluate_comp.scm 774 */
																obj_t BgL_____rz00_15680;

																{	/* Eval/evaluate_comp.scm 663 */
																	obj_t BgL_savedzd2bpzd2_15681;

																	BgL_savedzd2bpzd2_15681 =
																		VECTOR_REF(BgL_nsz00_15677, ((long) 0));
																	VECTOR_SET(BgL_nsz00_15677, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_15683;

																		BgL_fz00_15683 = BgL_runz00_15666;
																	BgL_recz00_15682:
																		{	/* Eval/evaluate_comp.scm 666 */
																			obj_t BgL_rz00_15684;

																			BgL_rz00_15684 =
																				PROCEDURE_ENTRY(BgL_fz00_15683)
																				(BgL_fz00_15683, BgL_nsz00_15677, BEOA);
																			{	/* Eval/evaluate_comp.scm 667 */
																				bool_t BgL_test6169z00_19677;

																				if (PROCEDUREP(BgL_rz00_15684))
																					{	/* Eval/evaluate_comp.scm 667 */
																						obj_t BgL_arg1707z00_15685;

																						BgL_arg1707z00_15685 =
																							PROCEDURE_ATTR(BgL_rz00_15684);
																						if (STRUCTP(BgL_arg1707z00_15685))
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_test6169z00_19677 =
																									(STRUCT_KEY
																									(BgL_arg1707z00_15685) ==
																									BGl_symbol5794z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_test6169z00_19677 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						BgL_test6169z00_19677 =
																							((bool_t) 0);
																					}
																				if (BgL_test6169z00_19677)
																					{
																						obj_t BgL_fz00_19685;

																						BgL_fz00_19685 = BgL_rz00_15684;
																						BgL_fz00_15683 = BgL_fz00_19685;
																						goto BgL_recz00_15682;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						VECTOR_SET(BgL_nsz00_15677,
																							((long) 0),
																							BgL_savedzd2bpzd2_15681);
																						BgL_____rz00_15680 = BgL_rz00_15684;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_15679);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15676,
																	BgL_sz00_13598);
																return BgL_____rz00_15680;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 774 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15663,
												(int) (BgL_nbargsz00_13595)))
											{	/* Eval/evaluate_comp.scm 774 */
												return
													BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00
													(BgL_sz00_13598, BgL_fz00_15663, BgL_argsz00_13596,
													BgL_bpz00_15662, BINT(BgL_siza7eza7_13597));
											}
										else
											{	/* Eval/evaluate_comp.scm 774 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(
													(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_13593))->
														BgL_locz00), BgL_symbzd2funzd2_13594,
													(int) (BgL_nbargsz00_13595),
													PROCEDURE_ARITY(BgL_fz00_15663));
		}}}}}}}}

	}



/* comp-call0 */
	obj_t BGl_compzd2call0zd2zz__evaluate_compz00(obj_t BgL_locz00_138,
		BgL_ev_exprz00_bglt BgL_vfunz00_139, obj_t BgL_symbzd2funzd2_140,
		obj_t BgL_funz00_141, obj_t BgL_tailzf3zf3_142, obj_t BgL_stkz00_143,
		long BgL_siza7eza7_144)
	{
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_cfunz00_1969;

				BgL_cfunz00_1969 =
					BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_139,
					((long) 0), BgL_locz00_138, BgL_symbzd2funzd2_140);
				if (CBOOL(BgL_cfunz00_1969))
					{	/* Eval/evaluate_comp.scm 889 */
						bool_t BgL_test6174z00_19701;

						{	/* Eval/evaluate_comp.scm 889 */
							int BgL_arg1930z00_1983;

							BgL_arg1930z00_1983 = bgl_debug();
							BgL_test6174z00_19701 =
								BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg1930z00_1983),
								BINT(((long) 0)));
						}
						if (BgL_test6174z00_19701)
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_zc3z04anonymousza31926ze3z87_13599;

								BgL_zc3z04anonymousza31926ze3z87_13599 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza31926ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 3)));
								PROCEDURE_SET(BgL_zc3z04anonymousza31926ze3z87_13599,
									(int) (((long) 0)), BINT(BgL_siza7eza7_144));
								PROCEDURE_SET(BgL_zc3z04anonymousza31926ze3z87_13599,
									(int) (((long) 1)), BgL_locz00_138);
								PROCEDURE_SET(BgL_zc3z04anonymousza31926ze3z87_13599,
									(int) (((long) 2)), BgL_cfunz00_1969);
								return BgL_zc3z04anonymousza31926ze3z87_13599;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_zc3z04anonymousza31929ze3z87_13600;

								BgL_zc3z04anonymousza31929ze3z87_13600 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza31929ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 2)));
								PROCEDURE_SET(BgL_zc3z04anonymousza31929ze3z87_13600,
									(int) (((long) 0)), BINT(BgL_siza7eza7_144));
								PROCEDURE_SET(BgL_zc3z04anonymousza31929ze3z87_13600,
									(int) (((long) 1)), BgL_cfunz00_1969);
								return BgL_zc3z04anonymousza31929ze3z87_13600;
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 889 */
						if (CBOOL(BgL_tailzf3zf3_142))
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_test6176z00_19726;

								{	/* Eval/evaluate_comp.scm 889 */
									int BgL_arg1961z00_2047;

									BgL_arg1961z00_2047 = bgl_debug();
									BgL_test6176z00_19726 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg1961z00_2047),
										BINT(((long) 0)));
								}
								if (BgL_test6176z00_19726)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3z04anonymousza31933ze3z87_13601;

										BgL_zc3z04anonymousza31933ze3z87_13601 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza31933ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 4)));
										PROCEDURE_SET(BgL_zc3z04anonymousza31933ze3z87_13601,
											(int) (((long) 0)), BgL_funz00_141);
										PROCEDURE_SET(BgL_zc3z04anonymousza31933ze3z87_13601,
											(int) (((long) 1)), BgL_locz00_138);
										PROCEDURE_SET(BgL_zc3z04anonymousza31933ze3z87_13601,
											(int) (((long) 2)), BgL_symbzd2funzd2_140);
										PROCEDURE_SET(BgL_zc3z04anonymousza31933ze3z87_13601,
											(int) (((long) 3)), BINT(BgL_siza7eza7_144));
										return BgL_zc3z04anonymousza31933ze3z87_13601;
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3z04anonymousza31947ze3z87_13602;

										BgL_zc3z04anonymousza31947ze3z87_13602 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza31947ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 4)));
										PROCEDURE_SET(BgL_zc3z04anonymousza31947ze3z87_13602,
											(int) (((long) 0)), BgL_funz00_141);
										PROCEDURE_SET(BgL_zc3z04anonymousza31947ze3z87_13602,
											(int) (((long) 1)), BgL_locz00_138);
										PROCEDURE_SET(BgL_zc3z04anonymousza31947ze3z87_13602,
											(int) (((long) 2)), BgL_symbzd2funzd2_140);
										PROCEDURE_SET(BgL_zc3z04anonymousza31947ze3z87_13602,
											(int) (((long) 3)), BINT(BgL_siza7eza7_144));
										return BgL_zc3z04anonymousza31947ze3z87_13602;
									}
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_test6177z00_19755;

								{	/* Eval/evaluate_comp.scm 889 */
									int BgL_arg1993z00_2111;

									BgL_arg1993z00_2111 = bgl_debug();
									BgL_test6177z00_19755 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg1993z00_2111),
										BINT(((long) 0)));
								}
								if (BgL_test6177z00_19755)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3z04anonymousza31964ze3z87_13603;

										BgL_zc3z04anonymousza31964ze3z87_13603 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza31964ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 4)));
										PROCEDURE_SET(BgL_zc3z04anonymousza31964ze3z87_13603,
											(int) (((long) 0)), BgL_funz00_141);
										PROCEDURE_SET(BgL_zc3z04anonymousza31964ze3z87_13603,
											(int) (((long) 1)), BgL_locz00_138);
										PROCEDURE_SET(BgL_zc3z04anonymousza31964ze3z87_13603,
											(int) (((long) 2)), BgL_symbzd2funzd2_140);
										PROCEDURE_SET(BgL_zc3z04anonymousza31964ze3z87_13603,
											(int) (((long) 3)), BINT(BgL_siza7eza7_144));
										return BgL_zc3z04anonymousza31964ze3z87_13603;
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3z04anonymousza31980ze3z87_13604;

										BgL_zc3z04anonymousza31980ze3z87_13604 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza31980ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 4)));
										PROCEDURE_SET(BgL_zc3z04anonymousza31980ze3z87_13604,
											(int) (((long) 0)), BgL_funz00_141);
										PROCEDURE_SET(BgL_zc3z04anonymousza31980ze3z87_13604,
											(int) (((long) 1)), BgL_locz00_138);
										PROCEDURE_SET(BgL_zc3z04anonymousza31980ze3z87_13604,
											(int) (((long) 2)), BgL_symbzd2funzd2_140);
										PROCEDURE_SET(BgL_zc3z04anonymousza31980ze3z87_13604,
											(int) (((long) 3)), BINT(BgL_siza7eza7_144));
										return BgL_zc3z04anonymousza31980ze3z87_13604;
									}
							}
					}
			}
		}

	}



/* &<@anonymous:1926> */
	obj_t BGl_z62zc3z04anonymousza31926ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13605, obj_t BgL_sz00_13609)
	{
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				long BgL_siza7eza7_13606;
				obj_t BgL_locz00_13607;
				obj_t BgL_cfunz00_13608;

				BgL_siza7eza7_13606 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13605, (int) (((long) 0))));
				BgL_locz00_13607 = PROCEDURE_REF(BgL_envz00_13605, (int) (((long) 1)));
				BgL_cfunz00_13608 = PROCEDURE_REF(BgL_envz00_13605, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_15686;

					BgL_bpz00_15686 = VECTOR_REF(((obj_t) BgL_sz00_13609), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */

						{	/* Eval/evaluate_comp.scm 889 */
							long BgL_nbpz00_15687;

							BgL_nbpz00_15687 =
								((long) CINT(BgL_bpz00_15686) + BgL_siza7eza7_13606);
							VECTOR_SET(
								((obj_t) BgL_sz00_13609), ((long) 0), BINT(BgL_nbpz00_15687));
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_tmpz00_19798;

								BgL_tmpz00_19798 = BGL_CURRENT_DYNAMIC_ENV();
								BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_19798, BgL_locz00_13607);
							}
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_rz00_15688;

								BgL_rz00_15688 =
									PROCEDURE_ENTRY(BgL_cfunz00_13608) (BgL_cfunz00_13608, BEOA);
								VECTOR_SET(
									((obj_t) BgL_sz00_13609), ((long) 0), BgL_bpz00_15686);
								return BgL_rz00_15688;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:1929> */
	obj_t BGl_z62zc3z04anonymousza31929ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13610, obj_t BgL_sz00_13613)
	{
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				long BgL_siza7eza7_13611;
				obj_t BgL_cfunz00_13612;

				BgL_siza7eza7_13611 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13610, (int) (((long) 0))));
				BgL_cfunz00_13612 = PROCEDURE_REF(BgL_envz00_13610, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_15689;

					BgL_bpz00_15689 = VECTOR_REF(((obj_t) BgL_sz00_13613), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */

						{	/* Eval/evaluate_comp.scm 889 */
							long BgL_nbpz00_15690;

							BgL_nbpz00_15690 =
								((long) CINT(BgL_bpz00_15689) + BgL_siza7eza7_13611);
							VECTOR_SET(
								((obj_t) BgL_sz00_13613), ((long) 0), BINT(BgL_nbpz00_15690));
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_rz00_15691;

								BgL_rz00_15691 =
									PROCEDURE_ENTRY(BgL_cfunz00_13612) (BgL_cfunz00_13612, BEOA);
								VECTOR_SET(
									((obj_t) BgL_sz00_13613), ((long) 0), BgL_bpz00_15689);
								return BgL_rz00_15691;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:1933> */
	obj_t BGl_z62zc3z04anonymousza31933ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13614, obj_t BgL_sz00_13619)
	{
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_13615;
				obj_t BgL_locz00_13616;
				obj_t BgL_symbzd2funzd2_13617;
				long BgL_siza7eza7_13618;

				BgL_funz00_13615 = PROCEDURE_REF(BgL_envz00_13614, (int) (((long) 0)));
				BgL_locz00_13616 = PROCEDURE_REF(BgL_envz00_13614, (int) (((long) 1)));
				BgL_symbzd2funzd2_13617 =
					PROCEDURE_REF(BgL_envz00_13614, (int) (((long) 2)));
				BgL_siza7eza7_13618 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13614, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_15692;

					BgL_bpz00_15692 = VECTOR_REF(((obj_t) BgL_sz00_13619), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_fz00_15693;

						BgL_fz00_15693 =
							PROCEDURE_ENTRY(BgL_funz00_13615) (BgL_funz00_13615,
							BgL_sz00_13619, BEOA);
						if (PROCEDUREP(BgL_fz00_15693))
							{	/* Eval/evaluate_comp.scm 889 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13616,
									BGl_string5798z00zz__evaluate_compz00,
									BGl_string5814z00zz__evaluate_compz00, BgL_fz00_15693);
							}
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_ufz00_15694;

							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_tmpz00_19841;

								BgL_tmpz00_19841 = ((obj_t) BgL_fz00_15693);
								BgL_ufz00_15694 = PROCEDURE_ATTR(BgL_tmpz00_19841);
							}
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_test6179z00_19844;

								if (STRUCTP(BgL_ufz00_15694))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6179z00_19844 =
											(STRUCT_KEY(BgL_ufz00_15694) ==
											BGl_symbol5815z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6179z00_19844 = ((bool_t) 0);
									}
								if (BgL_test6179z00_19844)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_arityz00_15695;
										obj_t BgL_runz00_15696;
										obj_t BgL_sfz00_15697;

										BgL_arityz00_15695 =
											STRUCT_REF(BgL_ufz00_15694, (int) (((long) 0)));
										BgL_runz00_15696 =
											STRUCT_REF(BgL_ufz00_15694, (int) (((long) 1)));
										BgL_sfz00_15697 =
											STRUCT_REF(BgL_ufz00_15694, (int) (((long) 2)));
										if (((long) CINT(BgL_arityz00_15695) == ((long) 0)))
											{	/* Eval/evaluate_comp.scm 889 */
												BUNSPEC;
											}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												if (INTEGERP(BgL_arityz00_15695))
													{	/* Eval/evaluate_comp.scm 889 */
														switch ((long) CINT(BgL_arityz00_15695))
															{
															case ((long) -1):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg1938z00_15698;
																	obj_t BgL_arg1939z00_15699;

																	BgL_arg1938z00_15698 =
																		((long) CINT(BgL_bpz00_15692) + ((long) 0));
																	BgL_arg1939z00_15699 = BNIL;
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13619),
																		BgL_arg1938z00_15698, BgL_arg1939z00_15699);
																} break;
															default:
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_13616, STRUCT_REF(BgL_ufz00_15694,
																		(int) (((long) 3))), (int) (((long) 0)),
																	CINT(BgL_arityz00_15695));
													}}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														BGl_evarityzd2errorzd2zz__everrorz00
															(BgL_locz00_13616, STRUCT_REF(BgL_ufz00_15694,
																(int) (((long) 3))), (int) (((long) 0)),
															CINT(BgL_arityz00_15695));
											}}
										{	/* Eval/evaluate_comp.scm 889 */
											obj_t BgL_z12denvz12_15700;

											BgL_z12denvz12_15700 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_15700,
												BgL_locz00_13616);
											if ((((long) CINT(BgL_bpz00_15692) +
														(long) CINT(BgL_sfz00_15697)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_13619))))
												{	/* Eval/evaluate_comp.scm 889 */
													return BgL_runz00_15696;
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_nsz00_15701;

													BgL_nsz00_15701 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg1943z00_15702;

														BgL_arg1943z00_15702 =
															((long) CINT(BgL_bpz00_15692) + ((long) 0));
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_15701, ((long) 2), BgL_sz00_13619,
															BgL_bpz00_15692, BINT(BgL_arg1943z00_15702));
													}
													VECTOR_SET(BgL_nsz00_15701, ((long) 1),
														BgL_sz00_13619);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15700,
														BgL_nsz00_15701);
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_ez00_15703;

														BgL_ez00_15703 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_15703, BgL_sz00_13619);
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_____rz00_15704;

															{	/* Eval/evaluate_comp.scm 663 */
																obj_t BgL_savedzd2bpzd2_15705;

																BgL_savedzd2bpzd2_15705 =
																	VECTOR_REF(BgL_nsz00_15701, ((long) 0));
																VECTOR_SET(BgL_nsz00_15701, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_15707;

																	BgL_fz00_15707 = BgL_runz00_15696;
																BgL_recz00_15706:
																	{	/* Eval/evaluate_comp.scm 666 */
																		obj_t BgL_rz00_15708;

																		BgL_rz00_15708 =
																			PROCEDURE_ENTRY(BgL_fz00_15707)
																			(BgL_fz00_15707, BgL_nsz00_15701, BEOA);
																		{	/* Eval/evaluate_comp.scm 667 */
																			bool_t BgL_test6184z00_19901;

																			if (PROCEDUREP(BgL_rz00_15708))
																				{	/* Eval/evaluate_comp.scm 667 */
																					obj_t BgL_arg1707z00_15709;

																					BgL_arg1707z00_15709 =
																						PROCEDURE_ATTR(BgL_rz00_15708);
																					if (STRUCTP(BgL_arg1707z00_15709))
																						{	/* Eval/evaluate_comp.scm 647 */
																							BgL_test6184z00_19901 =
																								(STRUCT_KEY
																								(BgL_arg1707z00_15709) ==
																								BGl_symbol5794z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 647 */
																							BgL_test6184z00_19901 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 667 */
																					BgL_test6184z00_19901 = ((bool_t) 0);
																				}
																			if (BgL_test6184z00_19901)
																				{
																					obj_t BgL_fz00_19909;

																					BgL_fz00_19909 = BgL_rz00_15708;
																					BgL_fz00_15707 = BgL_fz00_19909;
																					goto BgL_recz00_15706;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 667 */
																					VECTOR_SET(BgL_nsz00_15701,
																						((long) 0),
																						BgL_savedzd2bpzd2_15705);
																					BgL_____rz00_15704 = BgL_rz00_15708;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_15703);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15700,
																BgL_sz00_13619);
															return BgL_____rz00_15704;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15693,
												(int) (((long) 0))))
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_nbpz00_15710;

												BgL_nbpz00_15710 =
													((long) CINT(BgL_bpz00_15692) + BgL_siza7eza7_13618);
												VECTOR_SET(
													((obj_t) BgL_sz00_13619), ((long) 0),
													BINT(BgL_nbpz00_15710));
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_tmpz00_19921;

													BgL_tmpz00_19921 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_19921,
														BgL_locz00_13616);
												}
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_rz00_15711;

													BgL_rz00_15711 =
														PROCEDURE_ENTRY(BgL_fz00_15693) (BgL_fz00_15693,
														BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13619), ((long) 0),
														BgL_bpz00_15692);
													return BgL_rz00_15711;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13616,
													BgL_symbzd2funzd2_13617, (int) (((long) 0)),
													PROCEDURE_ARITY(BgL_fz00_15693));
		}}}}}}}}

	}



/* &<@anonymous:1947> */
	obj_t BGl_z62zc3z04anonymousza31947ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13620, obj_t BgL_sz00_13625)
	{
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_13621;
				obj_t BgL_locz00_13622;
				obj_t BgL_symbzd2funzd2_13623;
				long BgL_siza7eza7_13624;

				BgL_funz00_13621 = PROCEDURE_REF(BgL_envz00_13620, (int) (((long) 0)));
				BgL_locz00_13622 = PROCEDURE_REF(BgL_envz00_13620, (int) (((long) 1)));
				BgL_symbzd2funzd2_13623 =
					PROCEDURE_REF(BgL_envz00_13620, (int) (((long) 2)));
				BgL_siza7eza7_13624 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13620, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_15712;

					BgL_bpz00_15712 = VECTOR_REF(((obj_t) BgL_sz00_13625), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_fz00_15713;

						BgL_fz00_15713 =
							PROCEDURE_ENTRY(BgL_funz00_13621) (BgL_funz00_13621,
							BgL_sz00_13625, BEOA);
						if (PROCEDUREP(BgL_fz00_15713))
							{	/* Eval/evaluate_comp.scm 889 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13622,
									BGl_string5798z00zz__evaluate_compz00,
									BGl_string5814z00zz__evaluate_compz00, BgL_fz00_15713);
							}
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_ufz00_15714;

							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_tmpz00_19950;

								BgL_tmpz00_19950 = ((obj_t) BgL_fz00_15713);
								BgL_ufz00_15714 = PROCEDURE_ATTR(BgL_tmpz00_19950);
							}
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_test6189z00_19953;

								if (STRUCTP(BgL_ufz00_15714))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6189z00_19953 =
											(STRUCT_KEY(BgL_ufz00_15714) ==
											BGl_symbol5815z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6189z00_19953 = ((bool_t) 0);
									}
								if (BgL_test6189z00_19953)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_arityz00_15715;
										obj_t BgL_runz00_15716;
										obj_t BgL_sfz00_15717;

										BgL_arityz00_15715 =
											STRUCT_REF(BgL_ufz00_15714, (int) (((long) 0)));
										BgL_runz00_15716 =
											STRUCT_REF(BgL_ufz00_15714, (int) (((long) 1)));
										BgL_sfz00_15717 =
											STRUCT_REF(BgL_ufz00_15714, (int) (((long) 2)));
										if (((long) CINT(BgL_arityz00_15715) == ((long) 0)))
											{	/* Eval/evaluate_comp.scm 889 */
												BUNSPEC;
											}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												if (INTEGERP(BgL_arityz00_15715))
													{	/* Eval/evaluate_comp.scm 889 */
														switch ((long) CINT(BgL_arityz00_15715))
															{
															case ((long) -1):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg1953z00_15718;
																	obj_t BgL_arg1954z00_15719;

																	BgL_arg1953z00_15718 =
																		((long) CINT(BgL_bpz00_15712) + ((long) 0));
																	BgL_arg1954z00_15719 = BNIL;
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13625),
																		BgL_arg1953z00_15718, BgL_arg1954z00_15719);
																} break;
															default:
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_13622, STRUCT_REF(BgL_ufz00_15714,
																		(int) (((long) 3))), (int) (((long) 0)),
																	CINT(BgL_arityz00_15715));
													}}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														BGl_evarityzd2errorzd2zz__everrorz00
															(BgL_locz00_13622, STRUCT_REF(BgL_ufz00_15714,
																(int) (((long) 3))), (int) (((long) 0)),
															CINT(BgL_arityz00_15715));
											}}
										{	/* Eval/evaluate_comp.scm 889 */
											obj_t BgL_z12denvz12_15720;

											BgL_z12denvz12_15720 = BGL_CURRENT_DYNAMIC_ENV();
											if (
												(((long) CINT(BgL_bpz00_15712) +
														(long) CINT(BgL_sfz00_15717)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_13625))))
												{	/* Eval/evaluate_comp.scm 889 */
													return BgL_runz00_15716;
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_nsz00_15721;

													BgL_nsz00_15721 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg1958z00_15722;

														BgL_arg1958z00_15722 =
															((long) CINT(BgL_bpz00_15712) + ((long) 0));
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_15721, ((long) 2), BgL_sz00_13625,
															BgL_bpz00_15712, BINT(BgL_arg1958z00_15722));
													}
													VECTOR_SET(BgL_nsz00_15721, ((long) 1),
														BgL_sz00_13625);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15720,
														BgL_nsz00_15721);
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_ez00_15723;

														BgL_ez00_15723 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_15723, BgL_sz00_13625);
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_____rz00_15724;

															{	/* Eval/evaluate_comp.scm 663 */
																obj_t BgL_savedzd2bpzd2_15725;

																BgL_savedzd2bpzd2_15725 =
																	VECTOR_REF(BgL_nsz00_15721, ((long) 0));
																VECTOR_SET(BgL_nsz00_15721, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_15727;

																	BgL_fz00_15727 = BgL_runz00_15716;
																BgL_recz00_15726:
																	{	/* Eval/evaluate_comp.scm 666 */
																		obj_t BgL_rz00_15728;

																		BgL_rz00_15728 =
																			PROCEDURE_ENTRY(BgL_fz00_15727)
																			(BgL_fz00_15727, BgL_nsz00_15721, BEOA);
																		{	/* Eval/evaluate_comp.scm 667 */
																			bool_t BgL_test6194z00_20009;

																			if (PROCEDUREP(BgL_rz00_15728))
																				{	/* Eval/evaluate_comp.scm 667 */
																					obj_t BgL_arg1707z00_15729;

																					BgL_arg1707z00_15729 =
																						PROCEDURE_ATTR(BgL_rz00_15728);
																					if (STRUCTP(BgL_arg1707z00_15729))
																						{	/* Eval/evaluate_comp.scm 647 */
																							BgL_test6194z00_20009 =
																								(STRUCT_KEY
																								(BgL_arg1707z00_15729) ==
																								BGl_symbol5794z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 647 */
																							BgL_test6194z00_20009 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 667 */
																					BgL_test6194z00_20009 = ((bool_t) 0);
																				}
																			if (BgL_test6194z00_20009)
																				{
																					obj_t BgL_fz00_20017;

																					BgL_fz00_20017 = BgL_rz00_15728;
																					BgL_fz00_15727 = BgL_fz00_20017;
																					goto BgL_recz00_15726;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 667 */
																					VECTOR_SET(BgL_nsz00_15721,
																						((long) 0),
																						BgL_savedzd2bpzd2_15725);
																					BgL_____rz00_15724 = BgL_rz00_15728;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_15723);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15720,
																BgL_sz00_13625);
															return BgL_____rz00_15724;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15713,
												(int) (((long) 0))))
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_nbpz00_15730;

												BgL_nbpz00_15730 =
													((long) CINT(BgL_bpz00_15712) + BgL_siza7eza7_13624);
												VECTOR_SET(
													((obj_t) BgL_sz00_13625), ((long) 0),
													BINT(BgL_nbpz00_15730));
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_rz00_15731;

													BgL_rz00_15731 =
														PROCEDURE_ENTRY(BgL_fz00_15713) (BgL_fz00_15713,
														BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13625), ((long) 0),
														BgL_bpz00_15712);
													return BgL_rz00_15731;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13622,
													BgL_symbzd2funzd2_13623, (int) (((long) 0)),
													PROCEDURE_ARITY(BgL_fz00_15713));
		}}}}}}}}

	}



/* &<@anonymous:1964> */
	obj_t BGl_z62zc3z04anonymousza31964ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13626, obj_t BgL_sz00_13631)
	{
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_13627;
				obj_t BgL_locz00_13628;
				obj_t BgL_symbzd2funzd2_13629;
				long BgL_siza7eza7_13630;

				BgL_funz00_13627 = PROCEDURE_REF(BgL_envz00_13626, (int) (((long) 0)));
				BgL_locz00_13628 = PROCEDURE_REF(BgL_envz00_13626, (int) (((long) 1)));
				BgL_symbzd2funzd2_13629 =
					PROCEDURE_REF(BgL_envz00_13626, (int) (((long) 2)));
				BgL_siza7eza7_13630 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13626, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_15732;

					BgL_bpz00_15732 = VECTOR_REF(((obj_t) BgL_sz00_13631), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_fz00_15733;

						BgL_fz00_15733 =
							PROCEDURE_ENTRY(BgL_funz00_13627) (BgL_funz00_13627,
							BgL_sz00_13631, BEOA);
						if (PROCEDUREP(BgL_fz00_15733))
							{	/* Eval/evaluate_comp.scm 889 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13628,
									BGl_string5798z00zz__evaluate_compz00,
									BGl_string5814z00zz__evaluate_compz00, BgL_fz00_15733);
							}
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_ufz00_15734;

							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_tmpz00_20055;

								BgL_tmpz00_20055 = ((obj_t) BgL_fz00_15733);
								BgL_ufz00_15734 = PROCEDURE_ATTR(BgL_tmpz00_20055);
							}
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_test6199z00_20058;

								if (STRUCTP(BgL_ufz00_15734))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6199z00_20058 =
											(STRUCT_KEY(BgL_ufz00_15734) ==
											BGl_symbol5815z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6199z00_20058 = ((bool_t) 0);
									}
								if (BgL_test6199z00_20058)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_arityz00_15735;
										obj_t BgL_runz00_15736;
										obj_t BgL_sfz00_15737;

										BgL_arityz00_15735 =
											STRUCT_REF(BgL_ufz00_15734, (int) (((long) 0)));
										BgL_runz00_15736 =
											STRUCT_REF(BgL_ufz00_15734, (int) (((long) 1)));
										BgL_sfz00_15737 =
											STRUCT_REF(BgL_ufz00_15734, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 889 */
											long BgL_spz00_15738;

											BgL_spz00_15738 =
												((long) CINT(BgL_bpz00_15732) + BgL_siza7eza7_13630);
											if (((long) CINT(BgL_arityz00_15735) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 889 */
													BUNSPEC;
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													if (INTEGERP(BgL_arityz00_15735))
														{	/* Eval/evaluate_comp.scm 889 */
															switch ((long) CINT(BgL_arityz00_15735))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg1969z00_15739;
																		obj_t BgL_arg1970z00_15740;

																		BgL_arg1969z00_15739 =
																			(BgL_spz00_15738 + ((long) 0));
																		BgL_arg1970z00_15740 = BNIL;
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13631),
																			BgL_arg1969z00_15739,
																			BgL_arg1970z00_15740);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_13628,
																		STRUCT_REF(BgL_ufz00_15734,
																			(int) (((long) 3))), (int) (((long) 0)),
																		CINT(BgL_arityz00_15735));
														}}
													else
														{	/* Eval/evaluate_comp.scm 889 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_13628, STRUCT_REF(BgL_ufz00_15734,
																	(int) (((long) 3))), (int) (((long) 0)),
																CINT(BgL_arityz00_15735));
												}}
											{	/* Eval/evaluate_comp.scm 889 */
												obj_t BgL_z12denvz12_15741;

												BgL_z12denvz12_15741 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_15741,
													BgL_locz00_13628);
												if (((BgL_spz00_15738 + (long) CINT(BgL_sfz00_15737)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13631))))
													{	/* Eval/evaluate_comp.scm 889 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_15736, BgL_sz00_13631,
															BINT(BgL_spz00_15738));
													}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_nsz00_15742;

														BgL_nsz00_15742 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 889 */
															long BgL_arg1975z00_15743;

															BgL_arg1975z00_15743 =
																(BgL_spz00_15738 + ((long) 0));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_15742, ((long) 2), BgL_sz00_13631,
																BINT(BgL_spz00_15738),
																BINT(BgL_arg1975z00_15743));
														}
														VECTOR_SET(BgL_nsz00_15742, ((long) 1),
															BgL_sz00_13631);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15741,
															BgL_nsz00_15742);
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_ez00_15744;

															BgL_ez00_15744 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_15744, BgL_sz00_13631);
															{	/* Eval/evaluate_comp.scm 889 */
																obj_t BgL_____rz00_15745;

																{	/* Eval/evaluate_comp.scm 663 */
																	obj_t BgL_savedzd2bpzd2_15746;

																	BgL_savedzd2bpzd2_15746 =
																		VECTOR_REF(BgL_nsz00_15742, ((long) 0));
																	VECTOR_SET(BgL_nsz00_15742, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_15748;

																		BgL_fz00_15748 = BgL_runz00_15736;
																	BgL_recz00_15747:
																		{	/* Eval/evaluate_comp.scm 666 */
																			obj_t BgL_rz00_15749;

																			BgL_rz00_15749 =
																				PROCEDURE_ENTRY(BgL_fz00_15748)
																				(BgL_fz00_15748, BgL_nsz00_15742, BEOA);
																			{	/* Eval/evaluate_comp.scm 667 */
																				bool_t BgL_test6204z00_20117;

																				if (PROCEDUREP(BgL_rz00_15749))
																					{	/* Eval/evaluate_comp.scm 667 */
																						obj_t BgL_arg1707z00_15750;

																						BgL_arg1707z00_15750 =
																							PROCEDURE_ATTR(BgL_rz00_15749);
																						if (STRUCTP(BgL_arg1707z00_15750))
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_test6204z00_20117 =
																									(STRUCT_KEY
																									(BgL_arg1707z00_15750) ==
																									BGl_symbol5794z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_test6204z00_20117 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						BgL_test6204z00_20117 =
																							((bool_t) 0);
																					}
																				if (BgL_test6204z00_20117)
																					{
																						obj_t BgL_fz00_20125;

																						BgL_fz00_20125 = BgL_rz00_15749;
																						BgL_fz00_15748 = BgL_fz00_20125;
																						goto BgL_recz00_15747;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						VECTOR_SET(BgL_nsz00_15742,
																							((long) 0),
																							BgL_savedzd2bpzd2_15746);
																						BgL_____rz00_15745 = BgL_rz00_15749;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_15744);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15741,
																	BgL_sz00_13631);
																return BgL_____rz00_15745;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15733,
												(int) (((long) 0))))
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_nbpz00_15751;

												BgL_nbpz00_15751 =
													((long) CINT(BgL_bpz00_15732) + BgL_siza7eza7_13630);
												VECTOR_SET(
													((obj_t) BgL_sz00_13631), ((long) 0),
													BINT(BgL_nbpz00_15751));
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_tmpz00_20137;

													BgL_tmpz00_20137 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_20137,
														BgL_locz00_13628);
												}
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_rz00_15752;

													BgL_rz00_15752 =
														PROCEDURE_ENTRY(BgL_fz00_15733) (BgL_fz00_15733,
														BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13631), ((long) 0),
														BgL_bpz00_15732);
													return BgL_rz00_15752;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13628,
													BgL_symbzd2funzd2_13629, (int) (((long) 0)),
													PROCEDURE_ARITY(BgL_fz00_15733));
		}}}}}}}}

	}



/* &<@anonymous:1980> */
	obj_t BGl_z62zc3z04anonymousza31980ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13632, obj_t BgL_sz00_13637)
	{
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_13633;
				obj_t BgL_locz00_13634;
				obj_t BgL_symbzd2funzd2_13635;
				long BgL_siza7eza7_13636;

				BgL_funz00_13633 = PROCEDURE_REF(BgL_envz00_13632, (int) (((long) 0)));
				BgL_locz00_13634 = PROCEDURE_REF(BgL_envz00_13632, (int) (((long) 1)));
				BgL_symbzd2funzd2_13635 =
					PROCEDURE_REF(BgL_envz00_13632, (int) (((long) 2)));
				BgL_siza7eza7_13636 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13632, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_15753;

					BgL_bpz00_15753 = VECTOR_REF(((obj_t) BgL_sz00_13637), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_fz00_15754;

						BgL_fz00_15754 =
							PROCEDURE_ENTRY(BgL_funz00_13633) (BgL_funz00_13633,
							BgL_sz00_13637, BEOA);
						if (PROCEDUREP(BgL_fz00_15754))
							{	/* Eval/evaluate_comp.scm 889 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13634,
									BGl_string5798z00zz__evaluate_compz00,
									BGl_string5814z00zz__evaluate_compz00, BgL_fz00_15754);
							}
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_ufz00_15755;

							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_tmpz00_20166;

								BgL_tmpz00_20166 = ((obj_t) BgL_fz00_15754);
								BgL_ufz00_15755 = PROCEDURE_ATTR(BgL_tmpz00_20166);
							}
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_test6209z00_20169;

								if (STRUCTP(BgL_ufz00_15755))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6209z00_20169 =
											(STRUCT_KEY(BgL_ufz00_15755) ==
											BGl_symbol5815z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6209z00_20169 = ((bool_t) 0);
									}
								if (BgL_test6209z00_20169)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_arityz00_15756;
										obj_t BgL_runz00_15757;
										obj_t BgL_sfz00_15758;

										BgL_arityz00_15756 =
											STRUCT_REF(BgL_ufz00_15755, (int) (((long) 0)));
										BgL_runz00_15757 =
											STRUCT_REF(BgL_ufz00_15755, (int) (((long) 1)));
										BgL_sfz00_15758 =
											STRUCT_REF(BgL_ufz00_15755, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 889 */
											long BgL_spz00_15759;

											BgL_spz00_15759 =
												((long) CINT(BgL_bpz00_15753) + BgL_siza7eza7_13636);
											if (((long) CINT(BgL_arityz00_15756) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 889 */
													BUNSPEC;
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													if (INTEGERP(BgL_arityz00_15756))
														{	/* Eval/evaluate_comp.scm 889 */
															switch ((long) CINT(BgL_arityz00_15756))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg1985z00_15760;
																		obj_t BgL_arg1986z00_15761;

																		BgL_arg1985z00_15760 =
																			(BgL_spz00_15759 + ((long) 0));
																		BgL_arg1986z00_15761 = BNIL;
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13637),
																			BgL_arg1985z00_15760,
																			BgL_arg1986z00_15761);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_13634,
																		STRUCT_REF(BgL_ufz00_15755,
																			(int) (((long) 3))), (int) (((long) 0)),
																		CINT(BgL_arityz00_15756));
														}}
													else
														{	/* Eval/evaluate_comp.scm 889 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_13634, STRUCT_REF(BgL_ufz00_15755,
																	(int) (((long) 3))), (int) (((long) 0)),
																CINT(BgL_arityz00_15756));
												}}
											{	/* Eval/evaluate_comp.scm 889 */
												obj_t BgL_z12denvz12_15762;

												BgL_z12denvz12_15762 = BGL_CURRENT_DYNAMIC_ENV();
												if (
													((BgL_spz00_15759 +
															(long) CINT(BgL_sfz00_15758)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13637))))
													{	/* Eval/evaluate_comp.scm 889 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_15757, BgL_sz00_13637,
															BINT(BgL_spz00_15759));
													}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_nsz00_15763;

														BgL_nsz00_15763 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 889 */
															long BgL_arg1990z00_15764;

															BgL_arg1990z00_15764 =
																(BgL_spz00_15759 + ((long) 0));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_15763, ((long) 2), BgL_sz00_13637,
																BINT(BgL_spz00_15759),
																BINT(BgL_arg1990z00_15764));
														}
														VECTOR_SET(BgL_nsz00_15763, ((long) 1),
															BgL_sz00_13637);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15762,
															BgL_nsz00_15763);
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_ez00_15765;

															BgL_ez00_15765 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_15765, BgL_sz00_13637);
															{	/* Eval/evaluate_comp.scm 889 */
																obj_t BgL_____rz00_15766;

																{	/* Eval/evaluate_comp.scm 663 */
																	obj_t BgL_savedzd2bpzd2_15767;

																	BgL_savedzd2bpzd2_15767 =
																		VECTOR_REF(BgL_nsz00_15763, ((long) 0));
																	VECTOR_SET(BgL_nsz00_15763, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_15769;

																		BgL_fz00_15769 = BgL_runz00_15757;
																	BgL_recz00_15768:
																		{	/* Eval/evaluate_comp.scm 666 */
																			obj_t BgL_rz00_15770;

																			BgL_rz00_15770 =
																				PROCEDURE_ENTRY(BgL_fz00_15769)
																				(BgL_fz00_15769, BgL_nsz00_15763, BEOA);
																			{	/* Eval/evaluate_comp.scm 667 */
																				bool_t BgL_test6214z00_20227;

																				if (PROCEDUREP(BgL_rz00_15770))
																					{	/* Eval/evaluate_comp.scm 667 */
																						obj_t BgL_arg1707z00_15771;

																						BgL_arg1707z00_15771 =
																							PROCEDURE_ATTR(BgL_rz00_15770);
																						if (STRUCTP(BgL_arg1707z00_15771))
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_test6214z00_20227 =
																									(STRUCT_KEY
																									(BgL_arg1707z00_15771) ==
																									BGl_symbol5794z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_test6214z00_20227 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						BgL_test6214z00_20227 =
																							((bool_t) 0);
																					}
																				if (BgL_test6214z00_20227)
																					{
																						obj_t BgL_fz00_20235;

																						BgL_fz00_20235 = BgL_rz00_15770;
																						BgL_fz00_15769 = BgL_fz00_20235;
																						goto BgL_recz00_15768;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						VECTOR_SET(BgL_nsz00_15763,
																							((long) 0),
																							BgL_savedzd2bpzd2_15767);
																						BgL_____rz00_15766 = BgL_rz00_15770;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_15765);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15762,
																	BgL_sz00_13637);
																return BgL_____rz00_15766;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15754,
												(int) (((long) 0))))
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_nbpz00_15772;

												BgL_nbpz00_15772 =
													((long) CINT(BgL_bpz00_15753) + BgL_siza7eza7_13636);
												VECTOR_SET(
													((obj_t) BgL_sz00_13637), ((long) 0),
													BINT(BgL_nbpz00_15772));
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_rz00_15773;

													BgL_rz00_15773 =
														PROCEDURE_ENTRY(BgL_fz00_15754) (BgL_fz00_15754,
														BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13637), ((long) 0),
														BgL_bpz00_15753);
													return BgL_rz00_15773;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13634,
													BgL_symbzd2funzd2_13635, (int) (((long) 0)),
													PROCEDURE_ARITY(BgL_fz00_15754));
		}}}}}}}}

	}



/* comp-call1 */
	obj_t BGl_compzd2call1zd2zz__evaluate_compz00(obj_t BgL_locz00_145,
		BgL_ev_exprz00_bglt BgL_vfunz00_146, obj_t BgL_symbzd2funzd2_147,
		obj_t BgL_funz00_148, obj_t BgL_tailzf3zf3_149, obj_t BgL_stkz00_150,
		long BgL_siza7eza7_151, obj_t BgL_a1z00_152)
	{
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_cfunz00_2112;

				BgL_cfunz00_2112 =
					BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_146,
					((long) 1), BgL_locz00_145, BgL_symbzd2funzd2_147);
				if (CBOOL(BgL_cfunz00_2112))
					{	/* Eval/evaluate_comp.scm 889 */
						bool_t BgL_test6219z00_20258;

						{	/* Eval/evaluate_comp.scm 889 */
							int BgL_arg2000z00_2128;

							BgL_arg2000z00_2128 = bgl_debug();
							BgL_test6219z00_20258 =
								BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2000z00_2128),
								BINT(((long) 0)));
						}
						if (BgL_test6219z00_20258)
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_zc3z04anonymousza31996ze3z87_13638;

								BgL_zc3z04anonymousza31996ze3z87_13638 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza31996ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_zc3z04anonymousza31996ze3z87_13638,
									(int) (((long) 0)), BgL_a1z00_152);
								PROCEDURE_SET(BgL_zc3z04anonymousza31996ze3z87_13638,
									(int) (((long) 1)), BINT(BgL_siza7eza7_151));
								PROCEDURE_SET(BgL_zc3z04anonymousza31996ze3z87_13638,
									(int) (((long) 2)), BgL_locz00_145);
								PROCEDURE_SET(BgL_zc3z04anonymousza31996ze3z87_13638,
									(int) (((long) 3)), BgL_cfunz00_2112);
								return BgL_zc3z04anonymousza31996ze3z87_13638;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_zc3z04anonymousza31999ze3z87_13639;

								BgL_zc3z04anonymousza31999ze3z87_13639 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza31999ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 3)));
								PROCEDURE_SET(BgL_zc3z04anonymousza31999ze3z87_13639,
									(int) (((long) 0)), BgL_a1z00_152);
								PROCEDURE_SET(BgL_zc3z04anonymousza31999ze3z87_13639,
									(int) (((long) 1)), BINT(BgL_siza7eza7_151));
								PROCEDURE_SET(BgL_zc3z04anonymousza31999ze3z87_13639,
									(int) (((long) 2)), BgL_cfunz00_2112);
								return BgL_zc3z04anonymousza31999ze3z87_13639;
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 889 */
						if (CBOOL(BgL_tailzf3zf3_149))
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_test6221z00_20287;

								{	/* Eval/evaluate_comp.scm 889 */
									int BgL_arg2043z00_2204;

									BgL_arg2043z00_2204 = bgl_debug();
									BgL_test6221z00_20287 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2043z00_2204),
										BINT(((long) 0)));
								}
								if (BgL_test6221z00_20287)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3z04anonymousza32003ze3z87_13640;

										BgL_zc3z04anonymousza32003ze3z87_13640 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32003ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 5)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32003ze3z87_13640,
											(int) (((long) 0)), BgL_funz00_148);
										PROCEDURE_SET(BgL_zc3z04anonymousza32003ze3z87_13640,
											(int) (((long) 1)), BgL_a1z00_152);
										PROCEDURE_SET(BgL_zc3z04anonymousza32003ze3z87_13640,
											(int) (((long) 2)), BgL_locz00_145);
										PROCEDURE_SET(BgL_zc3z04anonymousza32003ze3z87_13640,
											(int) (((long) 3)), BgL_symbzd2funzd2_147);
										PROCEDURE_SET(BgL_zc3z04anonymousza32003ze3z87_13640,
											(int) (((long) 4)), BINT(BgL_siza7eza7_151));
										return BgL_zc3z04anonymousza32003ze3z87_13640;
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3z04anonymousza32024ze3z87_13641;

										BgL_zc3z04anonymousza32024ze3z87_13641 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32024ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 5)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32024ze3z87_13641,
											(int) (((long) 0)), BgL_funz00_148);
										PROCEDURE_SET(BgL_zc3z04anonymousza32024ze3z87_13641,
											(int) (((long) 1)), BgL_a1z00_152);
										PROCEDURE_SET(BgL_zc3z04anonymousza32024ze3z87_13641,
											(int) (((long) 2)), BgL_locz00_145);
										PROCEDURE_SET(BgL_zc3z04anonymousza32024ze3z87_13641,
											(int) (((long) 3)), BgL_symbzd2funzd2_147);
										PROCEDURE_SET(BgL_zc3z04anonymousza32024ze3z87_13641,
											(int) (((long) 4)), BINT(BgL_siza7eza7_151));
										return BgL_zc3z04anonymousza32024ze3z87_13641;
									}
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_test6222z00_20320;

								{	/* Eval/evaluate_comp.scm 889 */
									int BgL_arg2085z00_2280;

									BgL_arg2085z00_2280 = bgl_debug();
									BgL_test6222z00_20320 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2085z00_2280),
										BINT(((long) 0)));
								}
								if (BgL_test6222z00_20320)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3z04anonymousza32046ze3z87_13642;

										BgL_zc3z04anonymousza32046ze3z87_13642 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32046ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 5)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32046ze3z87_13642,
											(int) (((long) 0)), BgL_funz00_148);
										PROCEDURE_SET(BgL_zc3z04anonymousza32046ze3z87_13642,
											(int) (((long) 1)), BgL_a1z00_152);
										PROCEDURE_SET(BgL_zc3z04anonymousza32046ze3z87_13642,
											(int) (((long) 2)), BgL_locz00_145);
										PROCEDURE_SET(BgL_zc3z04anonymousza32046ze3z87_13642,
											(int) (((long) 3)), BgL_symbzd2funzd2_147);
										PROCEDURE_SET(BgL_zc3z04anonymousza32046ze3z87_13642,
											(int) (((long) 4)), BINT(BgL_siza7eza7_151));
										return BgL_zc3z04anonymousza32046ze3z87_13642;
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3z04anonymousza32065ze3z87_13643;

										BgL_zc3z04anonymousza32065ze3z87_13643 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32065ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 5)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32065ze3z87_13643,
											(int) (((long) 0)), BgL_funz00_148);
										PROCEDURE_SET(BgL_zc3z04anonymousza32065ze3z87_13643,
											(int) (((long) 1)), BgL_a1z00_152);
										PROCEDURE_SET(BgL_zc3z04anonymousza32065ze3z87_13643,
											(int) (((long) 2)), BgL_locz00_145);
										PROCEDURE_SET(BgL_zc3z04anonymousza32065ze3z87_13643,
											(int) (((long) 3)), BgL_symbzd2funzd2_147);
										PROCEDURE_SET(BgL_zc3z04anonymousza32065ze3z87_13643,
											(int) (((long) 4)), BINT(BgL_siza7eza7_151));
										return BgL_zc3z04anonymousza32065ze3z87_13643;
									}
							}
					}
			}
		}

	}



/* &<@anonymous:1996> */
	obj_t BGl_z62zc3z04anonymousza31996ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13644, obj_t BgL_sz00_13649)
	{
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_a1z00_13645;
				long BgL_siza7eza7_13646;
				obj_t BgL_locz00_13647;
				obj_t BgL_cfunz00_13648;

				BgL_a1z00_13645 = PROCEDURE_REF(BgL_envz00_13644, (int) (((long) 0)));
				BgL_siza7eza7_13646 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13644, (int) (((long) 1))));
				BgL_locz00_13647 = PROCEDURE_REF(BgL_envz00_13644, (int) (((long) 2)));
				BgL_cfunz00_13648 = PROCEDURE_REF(BgL_envz00_13644, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_15774;

					BgL_bpz00_15774 = VECTOR_REF(((obj_t) BgL_sz00_13649), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_a1z00_15775;

						BgL_a1z00_15775 =
							PROCEDURE_ENTRY(BgL_a1z00_13645) (BgL_a1z00_13645, BgL_sz00_13649,
							BEOA);
						{	/* Eval/evaluate_comp.scm 889 */
							long BgL_nbpz00_15776;

							BgL_nbpz00_15776 =
								((long) CINT(BgL_bpz00_15774) + BgL_siza7eza7_13646);
							VECTOR_SET(
								((obj_t) BgL_sz00_13649), ((long) 0), BINT(BgL_nbpz00_15776));
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_tmpz00_20373;

								BgL_tmpz00_20373 = BGL_CURRENT_DYNAMIC_ENV();
								BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_20373, BgL_locz00_13647);
							}
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_rz00_15777;

								BgL_rz00_15777 =
									PROCEDURE_ENTRY(BgL_cfunz00_13648) (BgL_cfunz00_13648,
									BgL_a1z00_15775, BEOA);
								VECTOR_SET(((obj_t) BgL_sz00_13649), ((long) 0),
									BgL_bpz00_15774);
								return BgL_rz00_15777;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:1999> */
	obj_t BGl_z62zc3z04anonymousza31999ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13650, obj_t BgL_sz00_13654)
	{
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_a1z00_13651;
				long BgL_siza7eza7_13652;
				obj_t BgL_cfunz00_13653;

				BgL_a1z00_13651 = PROCEDURE_REF(BgL_envz00_13650, (int) (((long) 0)));
				BgL_siza7eza7_13652 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13650, (int) (((long) 1))));
				BgL_cfunz00_13653 = PROCEDURE_REF(BgL_envz00_13650, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_15778;

					BgL_bpz00_15778 = VECTOR_REF(((obj_t) BgL_sz00_13654), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_a1z00_15779;

						BgL_a1z00_15779 =
							PROCEDURE_ENTRY(BgL_a1z00_13651) (BgL_a1z00_13651, BgL_sz00_13654,
							BEOA);
						{	/* Eval/evaluate_comp.scm 889 */
							long BgL_nbpz00_15780;

							BgL_nbpz00_15780 =
								((long) CINT(BgL_bpz00_15778) + BgL_siza7eza7_13652);
							VECTOR_SET(
								((obj_t) BgL_sz00_13654), ((long) 0), BINT(BgL_nbpz00_15780));
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_rz00_15781;

								BgL_rz00_15781 =
									PROCEDURE_ENTRY(BgL_cfunz00_13653) (BgL_cfunz00_13653,
									BgL_a1z00_15779, BEOA);
								VECTOR_SET(((obj_t) BgL_sz00_13654), ((long) 0),
									BgL_bpz00_15778);
								return BgL_rz00_15781;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:2003> */
	obj_t BGl_z62zc3z04anonymousza32003ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13655, obj_t BgL_sz00_13661)
	{
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_13656;
				obj_t BgL_a1z00_13657;
				obj_t BgL_locz00_13658;
				obj_t BgL_symbzd2funzd2_13659;
				long BgL_siza7eza7_13660;

				BgL_funz00_13656 = PROCEDURE_REF(BgL_envz00_13655, (int) (((long) 0)));
				BgL_a1z00_13657 = PROCEDURE_REF(BgL_envz00_13655, (int) (((long) 1)));
				BgL_locz00_13658 = PROCEDURE_REF(BgL_envz00_13655, (int) (((long) 2)));
				BgL_symbzd2funzd2_13659 =
					PROCEDURE_REF(BgL_envz00_13655, (int) (((long) 3)));
				BgL_siza7eza7_13660 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13655, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_15782;

					BgL_bpz00_15782 = VECTOR_REF(((obj_t) BgL_sz00_13661), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_fz00_15783;
						obj_t BgL_a1z00_15784;

						BgL_fz00_15783 =
							PROCEDURE_ENTRY(BgL_funz00_13656) (BgL_funz00_13656,
							BgL_sz00_13661, BEOA);
						BgL_a1z00_15784 =
							PROCEDURE_ENTRY(BgL_a1z00_13657) (BgL_a1z00_13657, BgL_sz00_13661,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15783))
							{	/* Eval/evaluate_comp.scm 889 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13658,
									BGl_string5798z00zz__evaluate_compz00,
									BGl_string5814z00zz__evaluate_compz00, BgL_fz00_15783);
							}
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_ufz00_15785;

							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_tmpz00_20430;

								BgL_tmpz00_20430 = ((obj_t) BgL_fz00_15783);
								BgL_ufz00_15785 = PROCEDURE_ATTR(BgL_tmpz00_20430);
							}
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_test6224z00_20433;

								if (STRUCTP(BgL_ufz00_15785))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6224z00_20433 =
											(STRUCT_KEY(BgL_ufz00_15785) ==
											BGl_symbol5815z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6224z00_20433 = ((bool_t) 0);
									}
								if (BgL_test6224z00_20433)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_arityz00_15786;
										obj_t BgL_runz00_15787;
										obj_t BgL_sfz00_15788;

										BgL_arityz00_15786 =
											STRUCT_REF(BgL_ufz00_15785, (int) (((long) 0)));
										BgL_runz00_15787 =
											STRUCT_REF(BgL_ufz00_15785, (int) (((long) 1)));
										BgL_sfz00_15788 =
											STRUCT_REF(BgL_ufz00_15785, (int) (((long) 2)));
										if (((long) CINT(BgL_arityz00_15786) == ((long) 1)))
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_arg2008z00_15789;

												BgL_arg2008z00_15789 =
													((long) CINT(BgL_bpz00_15782) + ((long) 0));
												VECTOR_SET(
													((obj_t) BgL_sz00_13661), BgL_arg2008z00_15789,
													BgL_a1z00_15784);
											}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												if (INTEGERP(BgL_arityz00_15786))
													{	/* Eval/evaluate_comp.scm 889 */
														switch ((long) CINT(BgL_arityz00_15786))
															{
															case ((long) -1):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2010z00_15790;
																	obj_t BgL_arg2011z00_15791;

																	BgL_arg2010z00_15790 =
																		((long) CINT(BgL_bpz00_15782) + ((long) 0));
																	{	/* Eval/evaluate_comp.scm 889 */
																		obj_t BgL_list2012z00_15792;

																		BgL_list2012z00_15792 =
																			MAKE_YOUNG_PAIR(BgL_a1z00_15784, BNIL);
																		BgL_arg2011z00_15791 =
																			BgL_list2012z00_15792;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13661),
																		BgL_arg2010z00_15790, BgL_arg2011z00_15791);
																} break;
															case ((long) -2):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2013z00_15793;

																	BgL_arg2013z00_15793 =
																		((long) CINT(BgL_bpz00_15782) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13661),
																		BgL_arg2013z00_15793, BgL_a1z00_15784);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2014z00_15794;
																	obj_t BgL_arg2016z00_15795;

																	BgL_arg2014z00_15794 =
																		((long) CINT(BgL_bpz00_15782) + ((long) 1));
																	BgL_arg2016z00_15795 = BNIL;
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13661),
																		BgL_arg2014z00_15794, BgL_arg2016z00_15795);
																} break;
															default:
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_13658, STRUCT_REF(BgL_ufz00_15785,
																		(int) (((long) 3))), (int) (((long) 1)),
																	CINT(BgL_arityz00_15786));
													}}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														BGl_evarityzd2errorzd2zz__everrorz00
															(BgL_locz00_13658, STRUCT_REF(BgL_ufz00_15785,
																(int) (((long) 3))), (int) (((long) 1)),
															CINT(BgL_arityz00_15786));
											}}
										{	/* Eval/evaluate_comp.scm 889 */
											obj_t BgL_z12denvz12_15796;

											BgL_z12denvz12_15796 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_15796,
												BgL_locz00_13658);
											if ((((long) CINT(BgL_bpz00_15782) +
														(long) CINT(BgL_sfz00_15788)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_13661))))
												{	/* Eval/evaluate_comp.scm 889 */
													return BgL_runz00_15787;
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_nsz00_15797;

													BgL_nsz00_15797 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2020z00_15798;

														BgL_arg2020z00_15798 =
															((long) CINT(BgL_bpz00_15782) + ((long) 1));
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_15797, ((long) 2), BgL_sz00_13661,
															BgL_bpz00_15782, BINT(BgL_arg2020z00_15798));
													}
													VECTOR_SET(BgL_nsz00_15797, ((long) 1),
														BgL_sz00_13661);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15796,
														BgL_nsz00_15797);
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_ez00_15799;

														BgL_ez00_15799 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_15799, BgL_sz00_13661);
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_____rz00_15800;

															{	/* Eval/evaluate_comp.scm 663 */
																obj_t BgL_savedzd2bpzd2_15801;

																BgL_savedzd2bpzd2_15801 =
																	VECTOR_REF(BgL_nsz00_15797, ((long) 0));
																VECTOR_SET(BgL_nsz00_15797, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_15803;

																	BgL_fz00_15803 = BgL_runz00_15787;
																BgL_recz00_15802:
																	{	/* Eval/evaluate_comp.scm 666 */
																		obj_t BgL_rz00_15804;

																		BgL_rz00_15804 =
																			PROCEDURE_ENTRY(BgL_fz00_15803)
																			(BgL_fz00_15803, BgL_nsz00_15797, BEOA);
																		{	/* Eval/evaluate_comp.scm 667 */
																			bool_t BgL_test6229z00_20503;

																			if (PROCEDUREP(BgL_rz00_15804))
																				{	/* Eval/evaluate_comp.scm 667 */
																					obj_t BgL_arg1707z00_15805;

																					BgL_arg1707z00_15805 =
																						PROCEDURE_ATTR(BgL_rz00_15804);
																					if (STRUCTP(BgL_arg1707z00_15805))
																						{	/* Eval/evaluate_comp.scm 647 */
																							BgL_test6229z00_20503 =
																								(STRUCT_KEY
																								(BgL_arg1707z00_15805) ==
																								BGl_symbol5794z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 647 */
																							BgL_test6229z00_20503 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 667 */
																					BgL_test6229z00_20503 = ((bool_t) 0);
																				}
																			if (BgL_test6229z00_20503)
																				{
																					obj_t BgL_fz00_20511;

																					BgL_fz00_20511 = BgL_rz00_15804;
																					BgL_fz00_15803 = BgL_fz00_20511;
																					goto BgL_recz00_15802;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 667 */
																					VECTOR_SET(BgL_nsz00_15797,
																						((long) 0),
																						BgL_savedzd2bpzd2_15801);
																					BgL_____rz00_15800 = BgL_rz00_15804;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_15799);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15796,
																BgL_sz00_13661);
															return BgL_____rz00_15800;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15783,
												(int) (((long) 1))))
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_nbpz00_15806;

												BgL_nbpz00_15806 =
													((long) CINT(BgL_bpz00_15782) + BgL_siza7eza7_13660);
												VECTOR_SET(
													((obj_t) BgL_sz00_13661), ((long) 0),
													BINT(BgL_nbpz00_15806));
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_tmpz00_20523;

													BgL_tmpz00_20523 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_20523,
														BgL_locz00_13658);
												}
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_rz00_15807;

													BgL_rz00_15807 =
														PROCEDURE_ENTRY(BgL_fz00_15783) (BgL_fz00_15783,
														BgL_a1z00_15784, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13661), ((long) 0),
														BgL_bpz00_15782);
													return BgL_rz00_15807;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13658,
													BgL_symbzd2funzd2_13659, (int) (((long) 1)),
													PROCEDURE_ARITY(BgL_fz00_15783));
		}}}}}}}}

	}



/* &<@anonymous:2024> */
	obj_t BGl_z62zc3z04anonymousza32024ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13662, obj_t BgL_sz00_13668)
	{
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_13663;
				obj_t BgL_a1z00_13664;
				obj_t BgL_locz00_13665;
				obj_t BgL_symbzd2funzd2_13666;
				long BgL_siza7eza7_13667;

				BgL_funz00_13663 = PROCEDURE_REF(BgL_envz00_13662, (int) (((long) 0)));
				BgL_a1z00_13664 = PROCEDURE_REF(BgL_envz00_13662, (int) (((long) 1)));
				BgL_locz00_13665 = PROCEDURE_REF(BgL_envz00_13662, (int) (((long) 2)));
				BgL_symbzd2funzd2_13666 =
					PROCEDURE_REF(BgL_envz00_13662, (int) (((long) 3)));
				BgL_siza7eza7_13667 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13662, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_15808;

					BgL_bpz00_15808 = VECTOR_REF(((obj_t) BgL_sz00_13668), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_fz00_15809;
						obj_t BgL_a1z00_15810;

						BgL_fz00_15809 =
							PROCEDURE_ENTRY(BgL_funz00_13663) (BgL_funz00_13663,
							BgL_sz00_13668, BEOA);
						BgL_a1z00_15810 =
							PROCEDURE_ENTRY(BgL_a1z00_13664) (BgL_a1z00_13664, BgL_sz00_13668,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15809))
							{	/* Eval/evaluate_comp.scm 889 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13665,
									BGl_string5798z00zz__evaluate_compz00,
									BGl_string5814z00zz__evaluate_compz00, BgL_fz00_15809);
							}
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_ufz00_15811;

							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_tmpz00_20559;

								BgL_tmpz00_20559 = ((obj_t) BgL_fz00_15809);
								BgL_ufz00_15811 = PROCEDURE_ATTR(BgL_tmpz00_20559);
							}
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_test6234z00_20562;

								if (STRUCTP(BgL_ufz00_15811))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6234z00_20562 =
											(STRUCT_KEY(BgL_ufz00_15811) ==
											BGl_symbol5815z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6234z00_20562 = ((bool_t) 0);
									}
								if (BgL_test6234z00_20562)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_arityz00_15812;
										obj_t BgL_runz00_15813;
										obj_t BgL_sfz00_15814;

										BgL_arityz00_15812 =
											STRUCT_REF(BgL_ufz00_15811, (int) (((long) 0)));
										BgL_runz00_15813 =
											STRUCT_REF(BgL_ufz00_15811, (int) (((long) 1)));
										BgL_sfz00_15814 =
											STRUCT_REF(BgL_ufz00_15811, (int) (((long) 2)));
										if (((long) CINT(BgL_arityz00_15812) == ((long) 1)))
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_arg2028z00_15815;

												BgL_arg2028z00_15815 =
													((long) CINT(BgL_bpz00_15808) + ((long) 0));
												VECTOR_SET(
													((obj_t) BgL_sz00_13668), BgL_arg2028z00_15815,
													BgL_a1z00_15810);
											}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												if (INTEGERP(BgL_arityz00_15812))
													{	/* Eval/evaluate_comp.scm 889 */
														switch ((long) CINT(BgL_arityz00_15812))
															{
															case ((long) -1):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2030z00_15816;
																	obj_t BgL_arg2031z00_15817;

																	BgL_arg2030z00_15816 =
																		((long) CINT(BgL_bpz00_15808) + ((long) 0));
																	{	/* Eval/evaluate_comp.scm 889 */
																		obj_t BgL_list2032z00_15818;

																		BgL_list2032z00_15818 =
																			MAKE_YOUNG_PAIR(BgL_a1z00_15810, BNIL);
																		BgL_arg2031z00_15817 =
																			BgL_list2032z00_15818;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13668),
																		BgL_arg2030z00_15816, BgL_arg2031z00_15817);
																} break;
															case ((long) -2):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2033z00_15819;

																	BgL_arg2033z00_15819 =
																		((long) CINT(BgL_bpz00_15808) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13668),
																		BgL_arg2033z00_15819, BgL_a1z00_15810);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2034z00_15820;
																	obj_t BgL_arg2035z00_15821;

																	BgL_arg2034z00_15820 =
																		((long) CINT(BgL_bpz00_15808) + ((long) 1));
																	BgL_arg2035z00_15821 = BNIL;
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13668),
																		BgL_arg2034z00_15820, BgL_arg2035z00_15821);
																} break;
															default:
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_13665, STRUCT_REF(BgL_ufz00_15811,
																		(int) (((long) 3))), (int) (((long) 1)),
																	CINT(BgL_arityz00_15812));
													}}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														BGl_evarityzd2errorzd2zz__everrorz00
															(BgL_locz00_13665, STRUCT_REF(BgL_ufz00_15811,
																(int) (((long) 3))), (int) (((long) 1)),
															CINT(BgL_arityz00_15812));
											}}
										{	/* Eval/evaluate_comp.scm 889 */
											obj_t BgL_z12denvz12_15822;

											BgL_z12denvz12_15822 = BGL_CURRENT_DYNAMIC_ENV();
											if (
												(((long) CINT(BgL_bpz00_15808) +
														(long) CINT(BgL_sfz00_15814)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_13668))))
												{	/* Eval/evaluate_comp.scm 889 */
													return BgL_runz00_15813;
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_nsz00_15823;

													BgL_nsz00_15823 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2040z00_15824;

														BgL_arg2040z00_15824 =
															((long) CINT(BgL_bpz00_15808) + ((long) 1));
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_15823, ((long) 2), BgL_sz00_13668,
															BgL_bpz00_15808, BINT(BgL_arg2040z00_15824));
													}
													VECTOR_SET(BgL_nsz00_15823, ((long) 1),
														BgL_sz00_13668);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15822,
														BgL_nsz00_15823);
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_ez00_15825;

														BgL_ez00_15825 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_15825, BgL_sz00_13668);
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_____rz00_15826;

															{	/* Eval/evaluate_comp.scm 663 */
																obj_t BgL_savedzd2bpzd2_15827;

																BgL_savedzd2bpzd2_15827 =
																	VECTOR_REF(BgL_nsz00_15823, ((long) 0));
																VECTOR_SET(BgL_nsz00_15823, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_15829;

																	BgL_fz00_15829 = BgL_runz00_15813;
																BgL_recz00_15828:
																	{	/* Eval/evaluate_comp.scm 666 */
																		obj_t BgL_rz00_15830;

																		BgL_rz00_15830 =
																			PROCEDURE_ENTRY(BgL_fz00_15829)
																			(BgL_fz00_15829, BgL_nsz00_15823, BEOA);
																		{	/* Eval/evaluate_comp.scm 667 */
																			bool_t BgL_test6239z00_20631;

																			if (PROCEDUREP(BgL_rz00_15830))
																				{	/* Eval/evaluate_comp.scm 667 */
																					obj_t BgL_arg1707z00_15831;

																					BgL_arg1707z00_15831 =
																						PROCEDURE_ATTR(BgL_rz00_15830);
																					if (STRUCTP(BgL_arg1707z00_15831))
																						{	/* Eval/evaluate_comp.scm 647 */
																							BgL_test6239z00_20631 =
																								(STRUCT_KEY
																								(BgL_arg1707z00_15831) ==
																								BGl_symbol5794z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 647 */
																							BgL_test6239z00_20631 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 667 */
																					BgL_test6239z00_20631 = ((bool_t) 0);
																				}
																			if (BgL_test6239z00_20631)
																				{
																					obj_t BgL_fz00_20639;

																					BgL_fz00_20639 = BgL_rz00_15830;
																					BgL_fz00_15829 = BgL_fz00_20639;
																					goto BgL_recz00_15828;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 667 */
																					VECTOR_SET(BgL_nsz00_15823,
																						((long) 0),
																						BgL_savedzd2bpzd2_15827);
																					BgL_____rz00_15826 = BgL_rz00_15830;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_15825);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15822,
																BgL_sz00_13668);
															return BgL_____rz00_15826;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15809,
												(int) (((long) 1))))
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_nbpz00_15832;

												BgL_nbpz00_15832 =
													((long) CINT(BgL_bpz00_15808) + BgL_siza7eza7_13667);
												VECTOR_SET(
													((obj_t) BgL_sz00_13668), ((long) 0),
													BINT(BgL_nbpz00_15832));
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_rz00_15833;

													BgL_rz00_15833 =
														PROCEDURE_ENTRY(BgL_fz00_15809) (BgL_fz00_15809,
														BgL_a1z00_15810, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13668), ((long) 0),
														BgL_bpz00_15808);
													return BgL_rz00_15833;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13665,
													BgL_symbzd2funzd2_13666, (int) (((long) 1)),
													PROCEDURE_ARITY(BgL_fz00_15809));
		}}}}}}}}

	}



/* &<@anonymous:2046> */
	obj_t BGl_z62zc3z04anonymousza32046ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13669, obj_t BgL_sz00_13675)
	{
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_13670;
				obj_t BgL_a1z00_13671;
				obj_t BgL_locz00_13672;
				obj_t BgL_symbzd2funzd2_13673;
				long BgL_siza7eza7_13674;

				BgL_funz00_13670 = PROCEDURE_REF(BgL_envz00_13669, (int) (((long) 0)));
				BgL_a1z00_13671 = PROCEDURE_REF(BgL_envz00_13669, (int) (((long) 1)));
				BgL_locz00_13672 = PROCEDURE_REF(BgL_envz00_13669, (int) (((long) 2)));
				BgL_symbzd2funzd2_13673 =
					PROCEDURE_REF(BgL_envz00_13669, (int) (((long) 3)));
				BgL_siza7eza7_13674 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13669, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_15834;

					BgL_bpz00_15834 = VECTOR_REF(((obj_t) BgL_sz00_13675), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_fz00_15835;
						obj_t BgL_a1z00_15836;

						BgL_fz00_15835 =
							PROCEDURE_ENTRY(BgL_funz00_13670) (BgL_funz00_13670,
							BgL_sz00_13675, BEOA);
						BgL_a1z00_15836 =
							PROCEDURE_ENTRY(BgL_a1z00_13671) (BgL_a1z00_13671, BgL_sz00_13675,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15835))
							{	/* Eval/evaluate_comp.scm 889 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13672,
									BGl_string5798z00zz__evaluate_compz00,
									BGl_string5814z00zz__evaluate_compz00, BgL_fz00_15835);
							}
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_ufz00_15837;

							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_tmpz00_20684;

								BgL_tmpz00_20684 = ((obj_t) BgL_fz00_15835);
								BgL_ufz00_15837 = PROCEDURE_ATTR(BgL_tmpz00_20684);
							}
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_test6244z00_20687;

								if (STRUCTP(BgL_ufz00_15837))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6244z00_20687 =
											(STRUCT_KEY(BgL_ufz00_15837) ==
											BGl_symbol5815z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6244z00_20687 = ((bool_t) 0);
									}
								if (BgL_test6244z00_20687)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_arityz00_15838;
										obj_t BgL_runz00_15839;
										obj_t BgL_sfz00_15840;

										BgL_arityz00_15838 =
											STRUCT_REF(BgL_ufz00_15837, (int) (((long) 0)));
										BgL_runz00_15839 =
											STRUCT_REF(BgL_ufz00_15837, (int) (((long) 1)));
										BgL_sfz00_15840 =
											STRUCT_REF(BgL_ufz00_15837, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 889 */
											long BgL_spz00_15841;

											BgL_spz00_15841 =
												((long) CINT(BgL_bpz00_15834) + BgL_siza7eza7_13674);
											if (((long) CINT(BgL_arityz00_15838) == ((long) 1)))
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_arg2050z00_15842;

													BgL_arg2050z00_15842 = (BgL_spz00_15841 + ((long) 0));
													VECTOR_SET(
														((obj_t) BgL_sz00_13675), BgL_arg2050z00_15842,
														BgL_a1z00_15836);
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													if (INTEGERP(BgL_arityz00_15838))
														{	/* Eval/evaluate_comp.scm 889 */
															switch ((long) CINT(BgL_arityz00_15838))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2052z00_15843;
																		obj_t BgL_arg2053z00_15844;

																		BgL_arg2052z00_15843 =
																			(BgL_spz00_15841 + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2054z00_15845;

																			BgL_list2054z00_15845 =
																				MAKE_YOUNG_PAIR(BgL_a1z00_15836, BNIL);
																			BgL_arg2053z00_15844 =
																				BgL_list2054z00_15845;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13675),
																			BgL_arg2052z00_15843,
																			BgL_arg2053z00_15844);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2055z00_15846;

																		BgL_arg2055z00_15846 =
																			(BgL_spz00_15841 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13675),
																			BgL_arg2055z00_15846, BgL_a1z00_15836);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2056z00_15847;
																		obj_t BgL_arg2057z00_15848;

																		BgL_arg2056z00_15847 =
																			(BgL_spz00_15841 + ((long) 1));
																		BgL_arg2057z00_15848 = BNIL;
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13675),
																			BgL_arg2056z00_15847,
																			BgL_arg2057z00_15848);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_13672,
																		STRUCT_REF(BgL_ufz00_15837,
																			(int) (((long) 3))), (int) (((long) 1)),
																		CINT(BgL_arityz00_15838));
														}}
													else
														{	/* Eval/evaluate_comp.scm 889 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_13672, STRUCT_REF(BgL_ufz00_15837,
																	(int) (((long) 3))), (int) (((long) 1)),
																CINT(BgL_arityz00_15838));
												}}
											{	/* Eval/evaluate_comp.scm 889 */
												obj_t BgL_z12denvz12_15849;

												BgL_z12denvz12_15849 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_15849,
													BgL_locz00_13672);
												if (((BgL_spz00_15841 + (long) CINT(BgL_sfz00_15840)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13675))))
													{	/* Eval/evaluate_comp.scm 889 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_15839, BgL_sz00_13675,
															BINT(BgL_spz00_15841));
													}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_nsz00_15850;

														BgL_nsz00_15850 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 889 */
															long BgL_arg2061z00_15851;

															BgL_arg2061z00_15851 =
																(BgL_spz00_15841 + ((long) 1));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_15850, ((long) 2), BgL_sz00_13675,
																BINT(BgL_spz00_15841),
																BINT(BgL_arg2061z00_15851));
														}
														VECTOR_SET(BgL_nsz00_15850, ((long) 1),
															BgL_sz00_13675);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15849,
															BgL_nsz00_15850);
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_ez00_15852;

															BgL_ez00_15852 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_15852, BgL_sz00_13675);
															{	/* Eval/evaluate_comp.scm 889 */
																obj_t BgL_____rz00_15853;

																{	/* Eval/evaluate_comp.scm 663 */
																	obj_t BgL_savedzd2bpzd2_15854;

																	BgL_savedzd2bpzd2_15854 =
																		VECTOR_REF(BgL_nsz00_15850, ((long) 0));
																	VECTOR_SET(BgL_nsz00_15850, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_15856;

																		BgL_fz00_15856 = BgL_runz00_15839;
																	BgL_recz00_15855:
																		{	/* Eval/evaluate_comp.scm 666 */
																			obj_t BgL_rz00_15857;

																			BgL_rz00_15857 =
																				PROCEDURE_ENTRY(BgL_fz00_15856)
																				(BgL_fz00_15856, BgL_nsz00_15850, BEOA);
																			{	/* Eval/evaluate_comp.scm 667 */
																				bool_t BgL_test6249z00_20756;

																				if (PROCEDUREP(BgL_rz00_15857))
																					{	/* Eval/evaluate_comp.scm 667 */
																						obj_t BgL_arg1707z00_15858;

																						BgL_arg1707z00_15858 =
																							PROCEDURE_ATTR(BgL_rz00_15857);
																						if (STRUCTP(BgL_arg1707z00_15858))
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_test6249z00_20756 =
																									(STRUCT_KEY
																									(BgL_arg1707z00_15858) ==
																									BGl_symbol5794z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_test6249z00_20756 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						BgL_test6249z00_20756 =
																							((bool_t) 0);
																					}
																				if (BgL_test6249z00_20756)
																					{
																						obj_t BgL_fz00_20764;

																						BgL_fz00_20764 = BgL_rz00_15857;
																						BgL_fz00_15856 = BgL_fz00_20764;
																						goto BgL_recz00_15855;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						VECTOR_SET(BgL_nsz00_15850,
																							((long) 0),
																							BgL_savedzd2bpzd2_15854);
																						BgL_____rz00_15853 = BgL_rz00_15857;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_15852);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15849,
																	BgL_sz00_13675);
																return BgL_____rz00_15853;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15835,
												(int) (((long) 1))))
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_nbpz00_15859;

												BgL_nbpz00_15859 =
													((long) CINT(BgL_bpz00_15834) + BgL_siza7eza7_13674);
												VECTOR_SET(
													((obj_t) BgL_sz00_13675), ((long) 0),
													BINT(BgL_nbpz00_15859));
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_tmpz00_20776;

													BgL_tmpz00_20776 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_20776,
														BgL_locz00_13672);
												}
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_rz00_15860;

													BgL_rz00_15860 =
														PROCEDURE_ENTRY(BgL_fz00_15835) (BgL_fz00_15835,
														BgL_a1z00_15836, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13675), ((long) 0),
														BgL_bpz00_15834);
													return BgL_rz00_15860;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13672,
													BgL_symbzd2funzd2_13673, (int) (((long) 1)),
													PROCEDURE_ARITY(BgL_fz00_15835));
		}}}}}}}}

	}



/* &<@anonymous:2065> */
	obj_t BGl_z62zc3z04anonymousza32065ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13676, obj_t BgL_sz00_13682)
	{
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_13677;
				obj_t BgL_a1z00_13678;
				obj_t BgL_locz00_13679;
				obj_t BgL_symbzd2funzd2_13680;
				long BgL_siza7eza7_13681;

				BgL_funz00_13677 = PROCEDURE_REF(BgL_envz00_13676, (int) (((long) 0)));
				BgL_a1z00_13678 = PROCEDURE_REF(BgL_envz00_13676, (int) (((long) 1)));
				BgL_locz00_13679 = PROCEDURE_REF(BgL_envz00_13676, (int) (((long) 2)));
				BgL_symbzd2funzd2_13680 =
					PROCEDURE_REF(BgL_envz00_13676, (int) (((long) 3)));
				BgL_siza7eza7_13681 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13676, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_15861;

					BgL_bpz00_15861 = VECTOR_REF(((obj_t) BgL_sz00_13682), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_fz00_15862;
						obj_t BgL_a1z00_15863;

						BgL_fz00_15862 =
							PROCEDURE_ENTRY(BgL_funz00_13677) (BgL_funz00_13677,
							BgL_sz00_13682, BEOA);
						BgL_a1z00_15863 =
							PROCEDURE_ENTRY(BgL_a1z00_13678) (BgL_a1z00_13678, BgL_sz00_13682,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15862))
							{	/* Eval/evaluate_comp.scm 889 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13679,
									BGl_string5798z00zz__evaluate_compz00,
									BGl_string5814z00zz__evaluate_compz00, BgL_fz00_15862);
							}
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_ufz00_15864;

							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_tmpz00_20812;

								BgL_tmpz00_20812 = ((obj_t) BgL_fz00_15862);
								BgL_ufz00_15864 = PROCEDURE_ATTR(BgL_tmpz00_20812);
							}
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_test6254z00_20815;

								if (STRUCTP(BgL_ufz00_15864))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6254z00_20815 =
											(STRUCT_KEY(BgL_ufz00_15864) ==
											BGl_symbol5815z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6254z00_20815 = ((bool_t) 0);
									}
								if (BgL_test6254z00_20815)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_arityz00_15865;
										obj_t BgL_runz00_15866;
										obj_t BgL_sfz00_15867;

										BgL_arityz00_15865 =
											STRUCT_REF(BgL_ufz00_15864, (int) (((long) 0)));
										BgL_runz00_15866 =
											STRUCT_REF(BgL_ufz00_15864, (int) (((long) 1)));
										BgL_sfz00_15867 =
											STRUCT_REF(BgL_ufz00_15864, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 889 */
											long BgL_spz00_15868;

											BgL_spz00_15868 =
												((long) CINT(BgL_bpz00_15861) + BgL_siza7eza7_13681);
											if (((long) CINT(BgL_arityz00_15865) == ((long) 1)))
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_arg2069z00_15869;

													BgL_arg2069z00_15869 = (BgL_spz00_15868 + ((long) 0));
													VECTOR_SET(
														((obj_t) BgL_sz00_13682), BgL_arg2069z00_15869,
														BgL_a1z00_15863);
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													if (INTEGERP(BgL_arityz00_15865))
														{	/* Eval/evaluate_comp.scm 889 */
															switch ((long) CINT(BgL_arityz00_15865))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2071z00_15870;
																		obj_t BgL_arg2072z00_15871;

																		BgL_arg2071z00_15870 =
																			(BgL_spz00_15868 + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2073z00_15872;

																			BgL_list2073z00_15872 =
																				MAKE_YOUNG_PAIR(BgL_a1z00_15863, BNIL);
																			BgL_arg2072z00_15871 =
																				BgL_list2073z00_15872;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13682),
																			BgL_arg2071z00_15870,
																			BgL_arg2072z00_15871);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2074z00_15873;

																		BgL_arg2074z00_15873 =
																			(BgL_spz00_15868 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13682),
																			BgL_arg2074z00_15873, BgL_a1z00_15863);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2076z00_15874;
																		obj_t BgL_arg2077z00_15875;

																		BgL_arg2076z00_15874 =
																			(BgL_spz00_15868 + ((long) 1));
																		BgL_arg2077z00_15875 = BNIL;
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13682),
																			BgL_arg2076z00_15874,
																			BgL_arg2077z00_15875);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_13679,
																		STRUCT_REF(BgL_ufz00_15864,
																			(int) (((long) 3))), (int) (((long) 1)),
																		CINT(BgL_arityz00_15865));
														}}
													else
														{	/* Eval/evaluate_comp.scm 889 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_13679, STRUCT_REF(BgL_ufz00_15864,
																	(int) (((long) 3))), (int) (((long) 1)),
																CINT(BgL_arityz00_15865));
												}}
											{	/* Eval/evaluate_comp.scm 889 */
												obj_t BgL_z12denvz12_15876;

												BgL_z12denvz12_15876 = BGL_CURRENT_DYNAMIC_ENV();
												if (
													((BgL_spz00_15868 +
															(long) CINT(BgL_sfz00_15867)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13682))))
													{	/* Eval/evaluate_comp.scm 889 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_15866, BgL_sz00_13682,
															BINT(BgL_spz00_15868));
													}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_nsz00_15877;

														BgL_nsz00_15877 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 889 */
															long BgL_arg2082z00_15878;

															BgL_arg2082z00_15878 =
																(BgL_spz00_15868 + ((long) 1));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_15877, ((long) 2), BgL_sz00_13682,
																BINT(BgL_spz00_15868),
																BINT(BgL_arg2082z00_15878));
														}
														VECTOR_SET(BgL_nsz00_15877, ((long) 1),
															BgL_sz00_13682);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15876,
															BgL_nsz00_15877);
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_ez00_15879;

															BgL_ez00_15879 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_15879, BgL_sz00_13682);
															{	/* Eval/evaluate_comp.scm 889 */
																obj_t BgL_____rz00_15880;

																{	/* Eval/evaluate_comp.scm 663 */
																	obj_t BgL_savedzd2bpzd2_15881;

																	BgL_savedzd2bpzd2_15881 =
																		VECTOR_REF(BgL_nsz00_15877, ((long) 0));
																	VECTOR_SET(BgL_nsz00_15877, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_15883;

																		BgL_fz00_15883 = BgL_runz00_15866;
																	BgL_recz00_15882:
																		{	/* Eval/evaluate_comp.scm 666 */
																			obj_t BgL_rz00_15884;

																			BgL_rz00_15884 =
																				PROCEDURE_ENTRY(BgL_fz00_15883)
																				(BgL_fz00_15883, BgL_nsz00_15877, BEOA);
																			{	/* Eval/evaluate_comp.scm 667 */
																				bool_t BgL_test6259z00_20883;

																				if (PROCEDUREP(BgL_rz00_15884))
																					{	/* Eval/evaluate_comp.scm 667 */
																						obj_t BgL_arg1707z00_15885;

																						BgL_arg1707z00_15885 =
																							PROCEDURE_ATTR(BgL_rz00_15884);
																						if (STRUCTP(BgL_arg1707z00_15885))
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_test6259z00_20883 =
																									(STRUCT_KEY
																									(BgL_arg1707z00_15885) ==
																									BGl_symbol5794z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_test6259z00_20883 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						BgL_test6259z00_20883 =
																							((bool_t) 0);
																					}
																				if (BgL_test6259z00_20883)
																					{
																						obj_t BgL_fz00_20891;

																						BgL_fz00_20891 = BgL_rz00_15884;
																						BgL_fz00_15883 = BgL_fz00_20891;
																						goto BgL_recz00_15882;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						VECTOR_SET(BgL_nsz00_15877,
																							((long) 0),
																							BgL_savedzd2bpzd2_15881);
																						BgL_____rz00_15880 = BgL_rz00_15884;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_15879);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15876,
																	BgL_sz00_13682);
																return BgL_____rz00_15880;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15862,
												(int) (((long) 1))))
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_nbpz00_15886;

												BgL_nbpz00_15886 =
													((long) CINT(BgL_bpz00_15861) + BgL_siza7eza7_13681);
												VECTOR_SET(
													((obj_t) BgL_sz00_13682), ((long) 0),
													BINT(BgL_nbpz00_15886));
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_rz00_15887;

													BgL_rz00_15887 =
														PROCEDURE_ENTRY(BgL_fz00_15862) (BgL_fz00_15862,
														BgL_a1z00_15863, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13682), ((long) 0),
														BgL_bpz00_15861);
													return BgL_rz00_15887;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13679,
													BgL_symbzd2funzd2_13680, (int) (((long) 1)),
													PROCEDURE_ARITY(BgL_fz00_15862));
		}}}}}}}}

	}



/* comp-call2 */
	obj_t BGl_compzd2call2zd2zz__evaluate_compz00(obj_t BgL_locz00_153,
		BgL_ev_exprz00_bglt BgL_vfunz00_154, obj_t BgL_symbzd2funzd2_155,
		obj_t BgL_funz00_156, obj_t BgL_tailzf3zf3_157, obj_t BgL_stkz00_158,
		long BgL_siza7eza7_159, obj_t BgL_a1z00_160, obj_t BgL_a2z00_161)
	{
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_cfunz00_2281;

				BgL_cfunz00_2281 =
					BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_154,
					((long) 2), BgL_locz00_153, BgL_symbzd2funzd2_155);
				if (CBOOL(BgL_cfunz00_2281))
					{	/* Eval/evaluate_comp.scm 889 */
						bool_t BgL_test6264z00_20915;

						{	/* Eval/evaluate_comp.scm 889 */
							int BgL_arg2093z00_2299;

							BgL_arg2093z00_2299 = bgl_debug();
							BgL_test6264z00_20915 =
								BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2093z00_2299),
								BINT(((long) 0)));
						}
						if (BgL_test6264z00_20915)
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_zc3z04anonymousza32089ze3z87_13683;

								BgL_zc3z04anonymousza32089ze3z87_13683 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza32089ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_zc3z04anonymousza32089ze3z87_13683,
									(int) (((long) 0)), BgL_a1z00_160);
								PROCEDURE_SET(BgL_zc3z04anonymousza32089ze3z87_13683,
									(int) (((long) 1)), BgL_a2z00_161);
								PROCEDURE_SET(BgL_zc3z04anonymousza32089ze3z87_13683,
									(int) (((long) 2)), BINT(BgL_siza7eza7_159));
								PROCEDURE_SET(BgL_zc3z04anonymousza32089ze3z87_13683,
									(int) (((long) 3)), BgL_locz00_153);
								PROCEDURE_SET(BgL_zc3z04anonymousza32089ze3z87_13683,
									(int) (((long) 4)), BgL_cfunz00_2281);
								return BgL_zc3z04anonymousza32089ze3z87_13683;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_zc3z04anonymousza32091ze3z87_13684;

								BgL_zc3z04anonymousza32091ze3z87_13684 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza32091ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_zc3z04anonymousza32091ze3z87_13684,
									(int) (((long) 0)), BgL_a1z00_160);
								PROCEDURE_SET(BgL_zc3z04anonymousza32091ze3z87_13684,
									(int) (((long) 1)), BgL_a2z00_161);
								PROCEDURE_SET(BgL_zc3z04anonymousza32091ze3z87_13684,
									(int) (((long) 2)), BINT(BgL_siza7eza7_159));
								PROCEDURE_SET(BgL_zc3z04anonymousza32091ze3z87_13684,
									(int) (((long) 3)), BgL_cfunz00_2281);
								return BgL_zc3z04anonymousza32091ze3z87_13684;
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 889 */
						if (CBOOL(BgL_tailzf3zf3_157))
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_test6266z00_20948;

								{	/* Eval/evaluate_comp.scm 889 */
									int BgL_arg2149z00_2391;

									BgL_arg2149z00_2391 = bgl_debug();
									BgL_test6266z00_20948 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2149z00_2391),
										BINT(((long) 0)));
								}
								if (BgL_test6266z00_20948)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3z04anonymousza32096ze3z87_13685;

										BgL_zc3z04anonymousza32096ze3z87_13685 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32096ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 6)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32096ze3z87_13685,
											(int) (((long) 0)), BgL_funz00_156);
										PROCEDURE_SET(BgL_zc3z04anonymousza32096ze3z87_13685,
											(int) (((long) 1)), BgL_a1z00_160);
										PROCEDURE_SET(BgL_zc3z04anonymousza32096ze3z87_13685,
											(int) (((long) 2)), BgL_a2z00_161);
										PROCEDURE_SET(BgL_zc3z04anonymousza32096ze3z87_13685,
											(int) (((long) 3)), BgL_locz00_153);
										PROCEDURE_SET(BgL_zc3z04anonymousza32096ze3z87_13685,
											(int) (((long) 4)), BgL_symbzd2funzd2_155);
										PROCEDURE_SET(BgL_zc3z04anonymousza32096ze3z87_13685,
											(int) (((long) 5)), BINT(BgL_siza7eza7_159));
										return BgL_zc3z04anonymousza32096ze3z87_13685;
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3z04anonymousza32123ze3z87_13686;

										BgL_zc3z04anonymousza32123ze3z87_13686 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32123ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 6)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32123ze3z87_13686,
											(int) (((long) 0)), BgL_funz00_156);
										PROCEDURE_SET(BgL_zc3z04anonymousza32123ze3z87_13686,
											(int) (((long) 1)), BgL_a1z00_160);
										PROCEDURE_SET(BgL_zc3z04anonymousza32123ze3z87_13686,
											(int) (((long) 2)), BgL_a2z00_161);
										PROCEDURE_SET(BgL_zc3z04anonymousza32123ze3z87_13686,
											(int) (((long) 3)), BgL_locz00_153);
										PROCEDURE_SET(BgL_zc3z04anonymousza32123ze3z87_13686,
											(int) (((long) 4)), BgL_symbzd2funzd2_155);
										PROCEDURE_SET(BgL_zc3z04anonymousza32123ze3z87_13686,
											(int) (((long) 5)), BINT(BgL_siza7eza7_159));
										return BgL_zc3z04anonymousza32123ze3z87_13686;
									}
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_test6267z00_20985;

								{	/* Eval/evaluate_comp.scm 889 */
									int BgL_arg2205z00_2483;

									BgL_arg2205z00_2483 = bgl_debug();
									BgL_test6267z00_20985 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2205z00_2483),
										BINT(((long) 0)));
								}
								if (BgL_test6267z00_20985)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3z04anonymousza32152ze3z87_13687;

										BgL_zc3z04anonymousza32152ze3z87_13687 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32152ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 6)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32152ze3z87_13687,
											(int) (((long) 0)), BgL_funz00_156);
										PROCEDURE_SET(BgL_zc3z04anonymousza32152ze3z87_13687,
											(int) (((long) 1)), BgL_a1z00_160);
										PROCEDURE_SET(BgL_zc3z04anonymousza32152ze3z87_13687,
											(int) (((long) 2)), BgL_a2z00_161);
										PROCEDURE_SET(BgL_zc3z04anonymousza32152ze3z87_13687,
											(int) (((long) 3)), BgL_locz00_153);
										PROCEDURE_SET(BgL_zc3z04anonymousza32152ze3z87_13687,
											(int) (((long) 4)), BgL_symbzd2funzd2_155);
										PROCEDURE_SET(BgL_zc3z04anonymousza32152ze3z87_13687,
											(int) (((long) 5)), BINT(BgL_siza7eza7_159));
										return BgL_zc3z04anonymousza32152ze3z87_13687;
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3z04anonymousza32179ze3z87_13688;

										BgL_zc3z04anonymousza32179ze3z87_13688 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32179ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 6)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32179ze3z87_13688,
											(int) (((long) 0)), BgL_funz00_156);
										PROCEDURE_SET(BgL_zc3z04anonymousza32179ze3z87_13688,
											(int) (((long) 1)), BgL_a1z00_160);
										PROCEDURE_SET(BgL_zc3z04anonymousza32179ze3z87_13688,
											(int) (((long) 2)), BgL_a2z00_161);
										PROCEDURE_SET(BgL_zc3z04anonymousza32179ze3z87_13688,
											(int) (((long) 3)), BgL_locz00_153);
										PROCEDURE_SET(BgL_zc3z04anonymousza32179ze3z87_13688,
											(int) (((long) 4)), BgL_symbzd2funzd2_155);
										PROCEDURE_SET(BgL_zc3z04anonymousza32179ze3z87_13688,
											(int) (((long) 5)), BINT(BgL_siza7eza7_159));
										return BgL_zc3z04anonymousza32179ze3z87_13688;
									}
							}
					}
			}
		}

	}



/* &<@anonymous:2089> */
	obj_t BGl_z62zc3z04anonymousza32089ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13689, obj_t BgL_sz00_13695)
	{
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_a1z00_13690;
				obj_t BgL_a2z00_13691;
				long BgL_siza7eza7_13692;
				obj_t BgL_locz00_13693;
				obj_t BgL_cfunz00_13694;

				BgL_a1z00_13690 = PROCEDURE_REF(BgL_envz00_13689, (int) (((long) 0)));
				BgL_a2z00_13691 = PROCEDURE_REF(BgL_envz00_13689, (int) (((long) 1)));
				BgL_siza7eza7_13692 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13689, (int) (((long) 2))));
				BgL_locz00_13693 = PROCEDURE_REF(BgL_envz00_13689, (int) (((long) 3)));
				BgL_cfunz00_13694 = PROCEDURE_REF(BgL_envz00_13689, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_15888;

					BgL_bpz00_15888 = VECTOR_REF(((obj_t) BgL_sz00_13695), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_a1z00_15889;
						obj_t BgL_a2z00_15890;

						BgL_a1z00_15889 =
							PROCEDURE_ENTRY(BgL_a1z00_13690) (BgL_a1z00_13690, BgL_sz00_13695,
							BEOA);
						BgL_a2z00_15890 =
							PROCEDURE_ENTRY(BgL_a2z00_13691) (BgL_a2z00_13691, BgL_sz00_13695,
							BEOA);
						{	/* Eval/evaluate_comp.scm 889 */
							long BgL_nbpz00_15891;

							BgL_nbpz00_15891 =
								((long) CINT(BgL_bpz00_15888) + BgL_siza7eza7_13692);
							VECTOR_SET(
								((obj_t) BgL_sz00_13695), ((long) 0), BINT(BgL_nbpz00_15891));
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_tmpz00_21048;

								BgL_tmpz00_21048 = BGL_CURRENT_DYNAMIC_ENV();
								BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_21048, BgL_locz00_13693);
							}
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_rz00_15892;

								BgL_rz00_15892 =
									PROCEDURE_ENTRY(BgL_cfunz00_13694) (BgL_cfunz00_13694,
									BgL_a1z00_15889, BgL_a2z00_15890, BEOA);
								VECTOR_SET(((obj_t) BgL_sz00_13695), ((long) 0),
									BgL_bpz00_15888);
								return BgL_rz00_15892;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:2091> */
	obj_t BGl_z62zc3z04anonymousza32091ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13696, obj_t BgL_sz00_13701)
	{
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_a1z00_13697;
				obj_t BgL_a2z00_13698;
				long BgL_siza7eza7_13699;
				obj_t BgL_cfunz00_13700;

				BgL_a1z00_13697 = PROCEDURE_REF(BgL_envz00_13696, (int) (((long) 0)));
				BgL_a2z00_13698 = PROCEDURE_REF(BgL_envz00_13696, (int) (((long) 1)));
				BgL_siza7eza7_13699 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13696, (int) (((long) 2))));
				BgL_cfunz00_13700 = PROCEDURE_REF(BgL_envz00_13696, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_15893;

					BgL_bpz00_15893 = VECTOR_REF(((obj_t) BgL_sz00_13701), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_a1z00_15894;
						obj_t BgL_a2z00_15895;

						BgL_a1z00_15894 =
							PROCEDURE_ENTRY(BgL_a1z00_13697) (BgL_a1z00_13697, BgL_sz00_13701,
							BEOA);
						BgL_a2z00_15895 =
							PROCEDURE_ENTRY(BgL_a2z00_13698) (BgL_a2z00_13698, BgL_sz00_13701,
							BEOA);
						{	/* Eval/evaluate_comp.scm 889 */
							long BgL_nbpz00_15896;

							BgL_nbpz00_15896 =
								((long) CINT(BgL_bpz00_15893) + BgL_siza7eza7_13699);
							VECTOR_SET(
								((obj_t) BgL_sz00_13701), ((long) 0), BINT(BgL_nbpz00_15896));
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_rz00_15897;

								BgL_rz00_15897 =
									PROCEDURE_ENTRY(BgL_cfunz00_13700) (BgL_cfunz00_13700,
									BgL_a1z00_15894, BgL_a2z00_15895, BEOA);
								VECTOR_SET(((obj_t) BgL_sz00_13701), ((long) 0),
									BgL_bpz00_15893);
								return BgL_rz00_15897;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:2096> */
	obj_t BGl_z62zc3z04anonymousza32096ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13702, obj_t BgL_sz00_13709)
	{
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_13703;
				obj_t BgL_a1z00_13704;
				obj_t BgL_a2z00_13705;
				obj_t BgL_locz00_13706;
				obj_t BgL_symbzd2funzd2_13707;
				long BgL_siza7eza7_13708;

				BgL_funz00_13703 = PROCEDURE_REF(BgL_envz00_13702, (int) (((long) 0)));
				BgL_a1z00_13704 = PROCEDURE_REF(BgL_envz00_13702, (int) (((long) 1)));
				BgL_a2z00_13705 = PROCEDURE_REF(BgL_envz00_13702, (int) (((long) 2)));
				BgL_locz00_13706 = PROCEDURE_REF(BgL_envz00_13702, (int) (((long) 3)));
				BgL_symbzd2funzd2_13707 =
					PROCEDURE_REF(BgL_envz00_13702, (int) (((long) 4)));
				BgL_siza7eza7_13708 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13702, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_15898;

					BgL_bpz00_15898 = VECTOR_REF(((obj_t) BgL_sz00_13709), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_fz00_15899;
						obj_t BgL_a1z00_15900;
						obj_t BgL_a2z00_15901;

						BgL_fz00_15899 =
							PROCEDURE_ENTRY(BgL_funz00_13703) (BgL_funz00_13703,
							BgL_sz00_13709, BEOA);
						BgL_a1z00_15900 =
							PROCEDURE_ENTRY(BgL_a1z00_13704) (BgL_a1z00_13704, BgL_sz00_13709,
							BEOA);
						BgL_a2z00_15901 =
							PROCEDURE_ENTRY(BgL_a2z00_13705) (BgL_a2z00_13705, BgL_sz00_13709,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15899))
							{	/* Eval/evaluate_comp.scm 889 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13706,
									BGl_string5798z00zz__evaluate_compz00,
									BGl_string5814z00zz__evaluate_compz00, BgL_fz00_15899);
							}
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_ufz00_15902;

							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_tmpz00_21119;

								BgL_tmpz00_21119 = ((obj_t) BgL_fz00_15899);
								BgL_ufz00_15902 = PROCEDURE_ATTR(BgL_tmpz00_21119);
							}
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_test6269z00_21122;

								if (STRUCTP(BgL_ufz00_15902))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6269z00_21122 =
											(STRUCT_KEY(BgL_ufz00_15902) ==
											BGl_symbol5815z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6269z00_21122 = ((bool_t) 0);
									}
								if (BgL_test6269z00_21122)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_arityz00_15903;
										obj_t BgL_runz00_15904;
										obj_t BgL_sfz00_15905;

										BgL_arityz00_15903 =
											STRUCT_REF(BgL_ufz00_15902, (int) (((long) 0)));
										BgL_runz00_15904 =
											STRUCT_REF(BgL_ufz00_15902, (int) (((long) 1)));
										BgL_sfz00_15905 =
											STRUCT_REF(BgL_ufz00_15902, (int) (((long) 2)));
										if (((long) CINT(BgL_arityz00_15903) == ((long) 2)))
											{	/* Eval/evaluate_comp.scm 889 */
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_arg2100z00_15906;

													BgL_arg2100z00_15906 =
														((long) CINT(BgL_bpz00_15898) + ((long) 0));
													VECTOR_SET(
														((obj_t) BgL_sz00_13709), BgL_arg2100z00_15906,
														BgL_a1z00_15900);
												}
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_arg2101z00_15907;

													BgL_arg2101z00_15907 =
														((long) CINT(BgL_bpz00_15898) + ((long) 1));
													VECTOR_SET(
														((obj_t) BgL_sz00_13709), BgL_arg2101z00_15907,
														BgL_a2z00_15901);
											}}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												if (INTEGERP(BgL_arityz00_15903))
													{	/* Eval/evaluate_comp.scm 889 */
														switch ((long) CINT(BgL_arityz00_15903))
															{
															case ((long) -1):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2103z00_15908;
																	obj_t BgL_arg2105z00_15909;

																	BgL_arg2103z00_15908 =
																		((long) CINT(BgL_bpz00_15898) + ((long) 0));
																	{	/* Eval/evaluate_comp.scm 889 */
																		obj_t BgL_list2106z00_15910;

																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_arg2107z00_15911;

																			BgL_arg2107z00_15911 =
																				MAKE_YOUNG_PAIR(BgL_a2z00_15901, BNIL);
																			BgL_list2106z00_15910 =
																				MAKE_YOUNG_PAIR(BgL_a1z00_15900,
																				BgL_arg2107z00_15911);
																		}
																		BgL_arg2105z00_15909 =
																			BgL_list2106z00_15910;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13709),
																		BgL_arg2103z00_15908, BgL_arg2105z00_15909);
																} break;
															case ((long) -2):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2108z00_15912;

																	BgL_arg2108z00_15912 =
																		((long) CINT(BgL_bpz00_15898) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13709),
																		BgL_arg2108z00_15912, BgL_a1z00_15900);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2109z00_15913;
																	obj_t BgL_arg2110z00_15914;

																	BgL_arg2109z00_15913 =
																		((long) CINT(BgL_bpz00_15898) + ((long) 1));
																	{	/* Eval/evaluate_comp.scm 889 */
																		obj_t BgL_list2111z00_15915;

																		BgL_list2111z00_15915 =
																			MAKE_YOUNG_PAIR(BgL_a2z00_15901, BNIL);
																		BgL_arg2110z00_15914 =
																			BgL_list2111z00_15915;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13709),
																		BgL_arg2109z00_15913, BgL_arg2110z00_15914);
																} break;
															case ((long) -3):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2112z00_15916;

																	BgL_arg2112z00_15916 =
																		((long) CINT(BgL_bpz00_15898) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13709),
																		BgL_arg2112z00_15916, BgL_a1z00_15900);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2113z00_15917;

																	BgL_arg2113z00_15917 =
																		((long) CINT(BgL_bpz00_15898) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13709),
																		BgL_arg2113z00_15917, BgL_a2z00_15901);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2114z00_15918;
																	obj_t BgL_arg2115z00_15919;

																	BgL_arg2114z00_15918 =
																		((long) CINT(BgL_bpz00_15898) + ((long) 2));
																	BgL_arg2115z00_15919 = BNIL;
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13709),
																		BgL_arg2114z00_15918, BgL_arg2115z00_15919);
																} break;
															default:
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_13706, STRUCT_REF(BgL_ufz00_15902,
																		(int) (((long) 3))), (int) (((long) 2)),
																	CINT(BgL_arityz00_15903));
													}}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														BGl_evarityzd2errorzd2zz__everrorz00
															(BgL_locz00_13706, STRUCT_REF(BgL_ufz00_15902,
																(int) (((long) 3))), (int) (((long) 2)),
															CINT(BgL_arityz00_15903));
											}}
										{	/* Eval/evaluate_comp.scm 889 */
											obj_t BgL_z12denvz12_15920;

											BgL_z12denvz12_15920 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_15920,
												BgL_locz00_13706);
											if ((((long) CINT(BgL_bpz00_15898) +
														(long) CINT(BgL_sfz00_15905)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_13709))))
												{	/* Eval/evaluate_comp.scm 889 */
													return BgL_runz00_15904;
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_nsz00_15921;

													BgL_nsz00_15921 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2119z00_15922;

														BgL_arg2119z00_15922 =
															((long) CINT(BgL_bpz00_15898) + ((long) 2));
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_15921, ((long) 2), BgL_sz00_13709,
															BgL_bpz00_15898, BINT(BgL_arg2119z00_15922));
													}
													VECTOR_SET(BgL_nsz00_15921, ((long) 1),
														BgL_sz00_13709);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15920,
														BgL_nsz00_15921);
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_ez00_15923;

														BgL_ez00_15923 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_15923, BgL_sz00_13709);
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_____rz00_15924;

															{	/* Eval/evaluate_comp.scm 663 */
																obj_t BgL_savedzd2bpzd2_15925;

																BgL_savedzd2bpzd2_15925 =
																	VECTOR_REF(BgL_nsz00_15921, ((long) 0));
																VECTOR_SET(BgL_nsz00_15921, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_15927;

																	BgL_fz00_15927 = BgL_runz00_15904;
																BgL_recz00_15926:
																	{	/* Eval/evaluate_comp.scm 666 */
																		obj_t BgL_rz00_15928;

																		BgL_rz00_15928 =
																			PROCEDURE_ENTRY(BgL_fz00_15927)
																			(BgL_fz00_15927, BgL_nsz00_15921, BEOA);
																		{	/* Eval/evaluate_comp.scm 667 */
																			bool_t BgL_test6274z00_21210;

																			if (PROCEDUREP(BgL_rz00_15928))
																				{	/* Eval/evaluate_comp.scm 667 */
																					obj_t BgL_arg1707z00_15929;

																					BgL_arg1707z00_15929 =
																						PROCEDURE_ATTR(BgL_rz00_15928);
																					if (STRUCTP(BgL_arg1707z00_15929))
																						{	/* Eval/evaluate_comp.scm 647 */
																							BgL_test6274z00_21210 =
																								(STRUCT_KEY
																								(BgL_arg1707z00_15929) ==
																								BGl_symbol5794z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 647 */
																							BgL_test6274z00_21210 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 667 */
																					BgL_test6274z00_21210 = ((bool_t) 0);
																				}
																			if (BgL_test6274z00_21210)
																				{
																					obj_t BgL_fz00_21218;

																					BgL_fz00_21218 = BgL_rz00_15928;
																					BgL_fz00_15927 = BgL_fz00_21218;
																					goto BgL_recz00_15926;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 667 */
																					VECTOR_SET(BgL_nsz00_15921,
																						((long) 0),
																						BgL_savedzd2bpzd2_15925);
																					BgL_____rz00_15924 = BgL_rz00_15928;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_15923);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15920,
																BgL_sz00_13709);
															return BgL_____rz00_15924;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15899,
												(int) (((long) 2))))
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_nbpz00_15930;

												BgL_nbpz00_15930 =
													((long) CINT(BgL_bpz00_15898) + BgL_siza7eza7_13708);
												VECTOR_SET(
													((obj_t) BgL_sz00_13709), ((long) 0),
													BINT(BgL_nbpz00_15930));
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_tmpz00_21230;

													BgL_tmpz00_21230 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_21230,
														BgL_locz00_13706);
												}
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_rz00_15931;

													BgL_rz00_15931 =
														PROCEDURE_ENTRY(BgL_fz00_15899) (BgL_fz00_15899,
														BgL_a1z00_15900, BgL_a2z00_15901, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13709), ((long) 0),
														BgL_bpz00_15898);
													return BgL_rz00_15931;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13706,
													BgL_symbzd2funzd2_13707, (int) (((long) 2)),
													PROCEDURE_ARITY(BgL_fz00_15899));
		}}}}}}}}

	}



/* &<@anonymous:2123> */
	obj_t BGl_z62zc3z04anonymousza32123ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13710, obj_t BgL_sz00_13717)
	{
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_13711;
				obj_t BgL_a1z00_13712;
				obj_t BgL_a2z00_13713;
				obj_t BgL_locz00_13714;
				obj_t BgL_symbzd2funzd2_13715;
				long BgL_siza7eza7_13716;

				BgL_funz00_13711 = PROCEDURE_REF(BgL_envz00_13710, (int) (((long) 0)));
				BgL_a1z00_13712 = PROCEDURE_REF(BgL_envz00_13710, (int) (((long) 1)));
				BgL_a2z00_13713 = PROCEDURE_REF(BgL_envz00_13710, (int) (((long) 2)));
				BgL_locz00_13714 = PROCEDURE_REF(BgL_envz00_13710, (int) (((long) 3)));
				BgL_symbzd2funzd2_13715 =
					PROCEDURE_REF(BgL_envz00_13710, (int) (((long) 4)));
				BgL_siza7eza7_13716 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13710, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_15932;

					BgL_bpz00_15932 = VECTOR_REF(((obj_t) BgL_sz00_13717), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_fz00_15933;
						obj_t BgL_a1z00_15934;
						obj_t BgL_a2z00_15935;

						BgL_fz00_15933 =
							PROCEDURE_ENTRY(BgL_funz00_13711) (BgL_funz00_13711,
							BgL_sz00_13717, BEOA);
						BgL_a1z00_15934 =
							PROCEDURE_ENTRY(BgL_a1z00_13712) (BgL_a1z00_13712, BgL_sz00_13717,
							BEOA);
						BgL_a2z00_15935 =
							PROCEDURE_ENTRY(BgL_a2z00_13713) (BgL_a2z00_13713, BgL_sz00_13717,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15933))
							{	/* Eval/evaluate_comp.scm 889 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13714,
									BGl_string5798z00zz__evaluate_compz00,
									BGl_string5814z00zz__evaluate_compz00, BgL_fz00_15933);
							}
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_ufz00_15936;

							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_tmpz00_21273;

								BgL_tmpz00_21273 = ((obj_t) BgL_fz00_15933);
								BgL_ufz00_15936 = PROCEDURE_ATTR(BgL_tmpz00_21273);
							}
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_test6279z00_21276;

								if (STRUCTP(BgL_ufz00_15936))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6279z00_21276 =
											(STRUCT_KEY(BgL_ufz00_15936) ==
											BGl_symbol5815z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6279z00_21276 = ((bool_t) 0);
									}
								if (BgL_test6279z00_21276)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_arityz00_15937;
										obj_t BgL_runz00_15938;
										obj_t BgL_sfz00_15939;

										BgL_arityz00_15937 =
											STRUCT_REF(BgL_ufz00_15936, (int) (((long) 0)));
										BgL_runz00_15938 =
											STRUCT_REF(BgL_ufz00_15936, (int) (((long) 1)));
										BgL_sfz00_15939 =
											STRUCT_REF(BgL_ufz00_15936, (int) (((long) 2)));
										if (((long) CINT(BgL_arityz00_15937) == ((long) 2)))
											{	/* Eval/evaluate_comp.scm 889 */
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_arg2127z00_15940;

													BgL_arg2127z00_15940 =
														((long) CINT(BgL_bpz00_15932) + ((long) 0));
													VECTOR_SET(
														((obj_t) BgL_sz00_13717), BgL_arg2127z00_15940,
														BgL_a1z00_15934);
												}
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_arg2128z00_15941;

													BgL_arg2128z00_15941 =
														((long) CINT(BgL_bpz00_15932) + ((long) 1));
													VECTOR_SET(
														((obj_t) BgL_sz00_13717), BgL_arg2128z00_15941,
														BgL_a2z00_15935);
											}}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												if (INTEGERP(BgL_arityz00_15937))
													{	/* Eval/evaluate_comp.scm 889 */
														switch ((long) CINT(BgL_arityz00_15937))
															{
															case ((long) -1):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2130z00_15942;
																	obj_t BgL_arg2132z00_15943;

																	BgL_arg2130z00_15942 =
																		((long) CINT(BgL_bpz00_15932) + ((long) 0));
																	{	/* Eval/evaluate_comp.scm 889 */
																		obj_t BgL_list2133z00_15944;

																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_arg2134z00_15945;

																			BgL_arg2134z00_15945 =
																				MAKE_YOUNG_PAIR(BgL_a2z00_15935, BNIL);
																			BgL_list2133z00_15944 =
																				MAKE_YOUNG_PAIR(BgL_a1z00_15934,
																				BgL_arg2134z00_15945);
																		}
																		BgL_arg2132z00_15943 =
																			BgL_list2133z00_15944;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13717),
																		BgL_arg2130z00_15942, BgL_arg2132z00_15943);
																} break;
															case ((long) -2):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2135z00_15946;

																	BgL_arg2135z00_15946 =
																		((long) CINT(BgL_bpz00_15932) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13717),
																		BgL_arg2135z00_15946, BgL_a1z00_15934);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2136z00_15947;
																	obj_t BgL_arg2137z00_15948;

																	BgL_arg2136z00_15947 =
																		((long) CINT(BgL_bpz00_15932) + ((long) 1));
																	{	/* Eval/evaluate_comp.scm 889 */
																		obj_t BgL_list2138z00_15949;

																		BgL_list2138z00_15949 =
																			MAKE_YOUNG_PAIR(BgL_a2z00_15935, BNIL);
																		BgL_arg2137z00_15948 =
																			BgL_list2138z00_15949;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13717),
																		BgL_arg2136z00_15947, BgL_arg2137z00_15948);
																} break;
															case ((long) -3):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2139z00_15950;

																	BgL_arg2139z00_15950 =
																		((long) CINT(BgL_bpz00_15932) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13717),
																		BgL_arg2139z00_15950, BgL_a1z00_15934);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2140z00_15951;

																	BgL_arg2140z00_15951 =
																		((long) CINT(BgL_bpz00_15932) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13717),
																		BgL_arg2140z00_15951, BgL_a2z00_15935);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2141z00_15952;
																	obj_t BgL_arg2142z00_15953;

																	BgL_arg2141z00_15952 =
																		((long) CINT(BgL_bpz00_15932) + ((long) 2));
																	BgL_arg2142z00_15953 = BNIL;
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13717),
																		BgL_arg2141z00_15952, BgL_arg2142z00_15953);
																} break;
															default:
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_13714, STRUCT_REF(BgL_ufz00_15936,
																		(int) (((long) 3))), (int) (((long) 2)),
																	CINT(BgL_arityz00_15937));
													}}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														BGl_evarityzd2errorzd2zz__everrorz00
															(BgL_locz00_13714, STRUCT_REF(BgL_ufz00_15936,
																(int) (((long) 3))), (int) (((long) 2)),
															CINT(BgL_arityz00_15937));
											}}
										{	/* Eval/evaluate_comp.scm 889 */
											obj_t BgL_z12denvz12_15954;

											BgL_z12denvz12_15954 = BGL_CURRENT_DYNAMIC_ENV();
											if (
												(((long) CINT(BgL_bpz00_15932) +
														(long) CINT(BgL_sfz00_15939)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_13717))))
												{	/* Eval/evaluate_comp.scm 889 */
													return BgL_runz00_15938;
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_nsz00_15955;

													BgL_nsz00_15955 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2146z00_15956;

														BgL_arg2146z00_15956 =
															((long) CINT(BgL_bpz00_15932) + ((long) 2));
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_15955, ((long) 2), BgL_sz00_13717,
															BgL_bpz00_15932, BINT(BgL_arg2146z00_15956));
													}
													VECTOR_SET(BgL_nsz00_15955, ((long) 1),
														BgL_sz00_13717);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15954,
														BgL_nsz00_15955);
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_ez00_15957;

														BgL_ez00_15957 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_15957, BgL_sz00_13717);
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_____rz00_15958;

															{	/* Eval/evaluate_comp.scm 663 */
																obj_t BgL_savedzd2bpzd2_15959;

																BgL_savedzd2bpzd2_15959 =
																	VECTOR_REF(BgL_nsz00_15955, ((long) 0));
																VECTOR_SET(BgL_nsz00_15955, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_15961;

																	BgL_fz00_15961 = BgL_runz00_15938;
																BgL_recz00_15960:
																	{	/* Eval/evaluate_comp.scm 666 */
																		obj_t BgL_rz00_15962;

																		BgL_rz00_15962 =
																			PROCEDURE_ENTRY(BgL_fz00_15961)
																			(BgL_fz00_15961, BgL_nsz00_15955, BEOA);
																		{	/* Eval/evaluate_comp.scm 667 */
																			bool_t BgL_test6284z00_21363;

																			if (PROCEDUREP(BgL_rz00_15962))
																				{	/* Eval/evaluate_comp.scm 667 */
																					obj_t BgL_arg1707z00_15963;

																					BgL_arg1707z00_15963 =
																						PROCEDURE_ATTR(BgL_rz00_15962);
																					if (STRUCTP(BgL_arg1707z00_15963))
																						{	/* Eval/evaluate_comp.scm 647 */
																							BgL_test6284z00_21363 =
																								(STRUCT_KEY
																								(BgL_arg1707z00_15963) ==
																								BGl_symbol5794z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 647 */
																							BgL_test6284z00_21363 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 667 */
																					BgL_test6284z00_21363 = ((bool_t) 0);
																				}
																			if (BgL_test6284z00_21363)
																				{
																					obj_t BgL_fz00_21371;

																					BgL_fz00_21371 = BgL_rz00_15962;
																					BgL_fz00_15961 = BgL_fz00_21371;
																					goto BgL_recz00_15960;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 667 */
																					VECTOR_SET(BgL_nsz00_15955,
																						((long) 0),
																						BgL_savedzd2bpzd2_15959);
																					BgL_____rz00_15958 = BgL_rz00_15962;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_15957);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15954,
																BgL_sz00_13717);
															return BgL_____rz00_15958;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15933,
												(int) (((long) 2))))
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_nbpz00_15964;

												BgL_nbpz00_15964 =
													((long) CINT(BgL_bpz00_15932) + BgL_siza7eza7_13716);
												VECTOR_SET(
													((obj_t) BgL_sz00_13717), ((long) 0),
													BINT(BgL_nbpz00_15964));
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_rz00_15965;

													BgL_rz00_15965 =
														PROCEDURE_ENTRY(BgL_fz00_15933) (BgL_fz00_15933,
														BgL_a1z00_15934, BgL_a2z00_15935, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13717), ((long) 0),
														BgL_bpz00_15932);
													return BgL_rz00_15965;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13714,
													BgL_symbzd2funzd2_13715, (int) (((long) 2)),
													PROCEDURE_ARITY(BgL_fz00_15933));
		}}}}}}}}

	}



/* &<@anonymous:2152> */
	obj_t BGl_z62zc3z04anonymousza32152ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13718, obj_t BgL_sz00_13725)
	{
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_13719;
				obj_t BgL_a1z00_13720;
				obj_t BgL_a2z00_13721;
				obj_t BgL_locz00_13722;
				obj_t BgL_symbzd2funzd2_13723;
				long BgL_siza7eza7_13724;

				BgL_funz00_13719 = PROCEDURE_REF(BgL_envz00_13718, (int) (((long) 0)));
				BgL_a1z00_13720 = PROCEDURE_REF(BgL_envz00_13718, (int) (((long) 1)));
				BgL_a2z00_13721 = PROCEDURE_REF(BgL_envz00_13718, (int) (((long) 2)));
				BgL_locz00_13722 = PROCEDURE_REF(BgL_envz00_13718, (int) (((long) 3)));
				BgL_symbzd2funzd2_13723 =
					PROCEDURE_REF(BgL_envz00_13718, (int) (((long) 4)));
				BgL_siza7eza7_13724 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13718, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_15966;

					BgL_bpz00_15966 = VECTOR_REF(((obj_t) BgL_sz00_13725), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_fz00_15967;
						obj_t BgL_a1z00_15968;
						obj_t BgL_a2z00_15969;

						BgL_fz00_15967 =
							PROCEDURE_ENTRY(BgL_funz00_13719) (BgL_funz00_13719,
							BgL_sz00_13725, BEOA);
						BgL_a1z00_15968 =
							PROCEDURE_ENTRY(BgL_a1z00_13720) (BgL_a1z00_13720, BgL_sz00_13725,
							BEOA);
						BgL_a2z00_15969 =
							PROCEDURE_ENTRY(BgL_a2z00_13721) (BgL_a2z00_13721, BgL_sz00_13725,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15967))
							{	/* Eval/evaluate_comp.scm 889 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13722,
									BGl_string5798z00zz__evaluate_compz00,
									BGl_string5814z00zz__evaluate_compz00, BgL_fz00_15967);
							}
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_ufz00_15970;

							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_tmpz00_21423;

								BgL_tmpz00_21423 = ((obj_t) BgL_fz00_15967);
								BgL_ufz00_15970 = PROCEDURE_ATTR(BgL_tmpz00_21423);
							}
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_test6289z00_21426;

								if (STRUCTP(BgL_ufz00_15970))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6289z00_21426 =
											(STRUCT_KEY(BgL_ufz00_15970) ==
											BGl_symbol5815z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6289z00_21426 = ((bool_t) 0);
									}
								if (BgL_test6289z00_21426)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_arityz00_15971;
										obj_t BgL_runz00_15972;
										obj_t BgL_sfz00_15973;

										BgL_arityz00_15971 =
											STRUCT_REF(BgL_ufz00_15970, (int) (((long) 0)));
										BgL_runz00_15972 =
											STRUCT_REF(BgL_ufz00_15970, (int) (((long) 1)));
										BgL_sfz00_15973 =
											STRUCT_REF(BgL_ufz00_15970, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 889 */
											long BgL_spz00_15974;

											BgL_spz00_15974 =
												((long) CINT(BgL_bpz00_15966) + BgL_siza7eza7_13724);
											if (((long) CINT(BgL_arityz00_15971) == ((long) 2)))
												{	/* Eval/evaluate_comp.scm 889 */
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2156z00_15975;

														BgL_arg2156z00_15975 =
															(BgL_spz00_15974 + ((long) 0));
														VECTOR_SET(
															((obj_t) BgL_sz00_13725), BgL_arg2156z00_15975,
															BgL_a1z00_15968);
													}
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2157z00_15976;

														BgL_arg2157z00_15976 =
															(BgL_spz00_15974 + ((long) 1));
														VECTOR_SET(
															((obj_t) BgL_sz00_13725), BgL_arg2157z00_15976,
															BgL_a2z00_15969);
												}}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													if (INTEGERP(BgL_arityz00_15971))
														{	/* Eval/evaluate_comp.scm 889 */
															switch ((long) CINT(BgL_arityz00_15971))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2159z00_15977;
																		obj_t BgL_arg2160z00_15978;

																		BgL_arg2159z00_15977 =
																			(BgL_spz00_15974 + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2161z00_15979;

																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_arg2163z00_15980;

																				BgL_arg2163z00_15980 =
																					MAKE_YOUNG_PAIR(BgL_a2z00_15969,
																					BNIL);
																				BgL_list2161z00_15979 =
																					MAKE_YOUNG_PAIR(BgL_a1z00_15968,
																					BgL_arg2163z00_15980);
																			}
																			BgL_arg2160z00_15978 =
																				BgL_list2161z00_15979;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13725),
																			BgL_arg2159z00_15977,
																			BgL_arg2160z00_15978);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2164z00_15981;

																		BgL_arg2164z00_15981 =
																			(BgL_spz00_15974 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13725),
																			BgL_arg2164z00_15981, BgL_a1z00_15968);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2165z00_15982;
																		obj_t BgL_arg2166z00_15983;

																		BgL_arg2165z00_15982 =
																			(BgL_spz00_15974 + ((long) 1));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2167z00_15984;

																			BgL_list2167z00_15984 =
																				MAKE_YOUNG_PAIR(BgL_a2z00_15969, BNIL);
																			BgL_arg2166z00_15983 =
																				BgL_list2167z00_15984;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13725),
																			BgL_arg2165z00_15982,
																			BgL_arg2166z00_15983);
																	} break;
																case ((long) -3):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2168z00_15985;

																		BgL_arg2168z00_15985 =
																			(BgL_spz00_15974 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13725),
																			BgL_arg2168z00_15985, BgL_a1z00_15968);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2169z00_15986;

																		BgL_arg2169z00_15986 =
																			(BgL_spz00_15974 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13725),
																			BgL_arg2169z00_15986, BgL_a2z00_15969);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2170z00_15987;
																		obj_t BgL_arg2171z00_15988;

																		BgL_arg2170z00_15987 =
																			(BgL_spz00_15974 + ((long) 2));
																		BgL_arg2171z00_15988 = BNIL;
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13725),
																			BgL_arg2170z00_15987,
																			BgL_arg2171z00_15988);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_13722,
																		STRUCT_REF(BgL_ufz00_15970,
																			(int) (((long) 3))), (int) (((long) 2)),
																		CINT(BgL_arityz00_15971));
														}}
													else
														{	/* Eval/evaluate_comp.scm 889 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_13722, STRUCT_REF(BgL_ufz00_15970,
																	(int) (((long) 3))), (int) (((long) 2)),
																CINT(BgL_arityz00_15971));
												}}
											{	/* Eval/evaluate_comp.scm 889 */
												obj_t BgL_z12denvz12_15989;

												BgL_z12denvz12_15989 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_15989,
													BgL_locz00_13722);
												if (((BgL_spz00_15974 + (long) CINT(BgL_sfz00_15973)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13725))))
													{	/* Eval/evaluate_comp.scm 889 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_15972, BgL_sz00_13725,
															BINT(BgL_spz00_15974));
													}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_nsz00_15990;

														BgL_nsz00_15990 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 889 */
															long BgL_arg2175z00_15991;

															BgL_arg2175z00_15991 =
																(BgL_spz00_15974 + ((long) 2));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_15990, ((long) 2), BgL_sz00_13725,
																BINT(BgL_spz00_15974),
																BINT(BgL_arg2175z00_15991));
														}
														VECTOR_SET(BgL_nsz00_15990, ((long) 1),
															BgL_sz00_13725);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15989,
															BgL_nsz00_15990);
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_ez00_15992;

															BgL_ez00_15992 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_15992, BgL_sz00_13725);
															{	/* Eval/evaluate_comp.scm 889 */
																obj_t BgL_____rz00_15993;

																{	/* Eval/evaluate_comp.scm 663 */
																	obj_t BgL_savedzd2bpzd2_15994;

																	BgL_savedzd2bpzd2_15994 =
																		VECTOR_REF(BgL_nsz00_15990, ((long) 0));
																	VECTOR_SET(BgL_nsz00_15990, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_15996;

																		BgL_fz00_15996 = BgL_runz00_15972;
																	BgL_recz00_15995:
																		{	/* Eval/evaluate_comp.scm 666 */
																			obj_t BgL_rz00_15997;

																			BgL_rz00_15997 =
																				PROCEDURE_ENTRY(BgL_fz00_15996)
																				(BgL_fz00_15996, BgL_nsz00_15990, BEOA);
																			{	/* Eval/evaluate_comp.scm 667 */
																				bool_t BgL_test6294z00_21509;

																				if (PROCEDUREP(BgL_rz00_15997))
																					{	/* Eval/evaluate_comp.scm 667 */
																						obj_t BgL_arg1707z00_15998;

																						BgL_arg1707z00_15998 =
																							PROCEDURE_ATTR(BgL_rz00_15997);
																						if (STRUCTP(BgL_arg1707z00_15998))
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_test6294z00_21509 =
																									(STRUCT_KEY
																									(BgL_arg1707z00_15998) ==
																									BGl_symbol5794z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_test6294z00_21509 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						BgL_test6294z00_21509 =
																							((bool_t) 0);
																					}
																				if (BgL_test6294z00_21509)
																					{
																						obj_t BgL_fz00_21517;

																						BgL_fz00_21517 = BgL_rz00_15997;
																						BgL_fz00_15996 = BgL_fz00_21517;
																						goto BgL_recz00_15995;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						VECTOR_SET(BgL_nsz00_15990,
																							((long) 0),
																							BgL_savedzd2bpzd2_15994);
																						BgL_____rz00_15993 = BgL_rz00_15997;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_15992);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15989,
																	BgL_sz00_13725);
																return BgL_____rz00_15993;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15967,
												(int) (((long) 2))))
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_nbpz00_15999;

												BgL_nbpz00_15999 =
													((long) CINT(BgL_bpz00_15966) + BgL_siza7eza7_13724);
												VECTOR_SET(
													((obj_t) BgL_sz00_13725), ((long) 0),
													BINT(BgL_nbpz00_15999));
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_tmpz00_21529;

													BgL_tmpz00_21529 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_21529,
														BgL_locz00_13722);
												}
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_rz00_16000;

													BgL_rz00_16000 =
														PROCEDURE_ENTRY(BgL_fz00_15967) (BgL_fz00_15967,
														BgL_a1z00_15968, BgL_a2z00_15969, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13725), ((long) 0),
														BgL_bpz00_15966);
													return BgL_rz00_16000;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13722,
													BgL_symbzd2funzd2_13723, (int) (((long) 2)),
													PROCEDURE_ARITY(BgL_fz00_15967));
		}}}}}}}}

	}



/* &<@anonymous:2179> */
	obj_t BGl_z62zc3z04anonymousza32179ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13726, obj_t BgL_sz00_13733)
	{
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_13727;
				obj_t BgL_a1z00_13728;
				obj_t BgL_a2z00_13729;
				obj_t BgL_locz00_13730;
				obj_t BgL_symbzd2funzd2_13731;
				long BgL_siza7eza7_13732;

				BgL_funz00_13727 = PROCEDURE_REF(BgL_envz00_13726, (int) (((long) 0)));
				BgL_a1z00_13728 = PROCEDURE_REF(BgL_envz00_13726, (int) (((long) 1)));
				BgL_a2z00_13729 = PROCEDURE_REF(BgL_envz00_13726, (int) (((long) 2)));
				BgL_locz00_13730 = PROCEDURE_REF(BgL_envz00_13726, (int) (((long) 3)));
				BgL_symbzd2funzd2_13731 =
					PROCEDURE_REF(BgL_envz00_13726, (int) (((long) 4)));
				BgL_siza7eza7_13732 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13726, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_16001;

					BgL_bpz00_16001 = VECTOR_REF(((obj_t) BgL_sz00_13733), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_fz00_16002;
						obj_t BgL_a1z00_16003;
						obj_t BgL_a2z00_16004;

						BgL_fz00_16002 =
							PROCEDURE_ENTRY(BgL_funz00_13727) (BgL_funz00_13727,
							BgL_sz00_13733, BEOA);
						BgL_a1z00_16003 =
							PROCEDURE_ENTRY(BgL_a1z00_13728) (BgL_a1z00_13728, BgL_sz00_13733,
							BEOA);
						BgL_a2z00_16004 =
							PROCEDURE_ENTRY(BgL_a2z00_13729) (BgL_a2z00_13729, BgL_sz00_13733,
							BEOA);
						if (PROCEDUREP(BgL_fz00_16002))
							{	/* Eval/evaluate_comp.scm 889 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13730,
									BGl_string5798z00zz__evaluate_compz00,
									BGl_string5814z00zz__evaluate_compz00, BgL_fz00_16002);
							}
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_ufz00_16005;

							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_tmpz00_21572;

								BgL_tmpz00_21572 = ((obj_t) BgL_fz00_16002);
								BgL_ufz00_16005 = PROCEDURE_ATTR(BgL_tmpz00_21572);
							}
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_test6299z00_21575;

								if (STRUCTP(BgL_ufz00_16005))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6299z00_21575 =
											(STRUCT_KEY(BgL_ufz00_16005) ==
											BGl_symbol5815z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6299z00_21575 = ((bool_t) 0);
									}
								if (BgL_test6299z00_21575)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_arityz00_16006;
										obj_t BgL_runz00_16007;
										obj_t BgL_sfz00_16008;

										BgL_arityz00_16006 =
											STRUCT_REF(BgL_ufz00_16005, (int) (((long) 0)));
										BgL_runz00_16007 =
											STRUCT_REF(BgL_ufz00_16005, (int) (((long) 1)));
										BgL_sfz00_16008 =
											STRUCT_REF(BgL_ufz00_16005, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 889 */
											long BgL_spz00_16009;

											BgL_spz00_16009 =
												((long) CINT(BgL_bpz00_16001) + BgL_siza7eza7_13732);
											if (((long) CINT(BgL_arityz00_16006) == ((long) 2)))
												{	/* Eval/evaluate_comp.scm 889 */
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2183z00_16010;

														BgL_arg2183z00_16010 =
															(BgL_spz00_16009 + ((long) 0));
														VECTOR_SET(
															((obj_t) BgL_sz00_13733), BgL_arg2183z00_16010,
															BgL_a1z00_16003);
													}
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2184z00_16011;

														BgL_arg2184z00_16011 =
															(BgL_spz00_16009 + ((long) 1));
														VECTOR_SET(
															((obj_t) BgL_sz00_13733), BgL_arg2184z00_16011,
															BgL_a2z00_16004);
												}}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													if (INTEGERP(BgL_arityz00_16006))
														{	/* Eval/evaluate_comp.scm 889 */
															switch ((long) CINT(BgL_arityz00_16006))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2186z00_16012;
																		obj_t BgL_arg2187z00_16013;

																		BgL_arg2186z00_16012 =
																			(BgL_spz00_16009 + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2188z00_16014;

																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_arg2189z00_16015;

																				BgL_arg2189z00_16015 =
																					MAKE_YOUNG_PAIR(BgL_a2z00_16004,
																					BNIL);
																				BgL_list2188z00_16014 =
																					MAKE_YOUNG_PAIR(BgL_a1z00_16003,
																					BgL_arg2189z00_16015);
																			}
																			BgL_arg2187z00_16013 =
																				BgL_list2188z00_16014;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13733),
																			BgL_arg2186z00_16012,
																			BgL_arg2187z00_16013);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2190z00_16016;

																		BgL_arg2190z00_16016 =
																			(BgL_spz00_16009 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13733),
																			BgL_arg2190z00_16016, BgL_a1z00_16003);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2191z00_16017;
																		obj_t BgL_arg2192z00_16018;

																		BgL_arg2191z00_16017 =
																			(BgL_spz00_16009 + ((long) 1));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2193z00_16019;

																			BgL_list2193z00_16019 =
																				MAKE_YOUNG_PAIR(BgL_a2z00_16004, BNIL);
																			BgL_arg2192z00_16018 =
																				BgL_list2193z00_16019;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13733),
																			BgL_arg2191z00_16017,
																			BgL_arg2192z00_16018);
																	} break;
																case ((long) -3):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2195z00_16020;

																		BgL_arg2195z00_16020 =
																			(BgL_spz00_16009 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13733),
																			BgL_arg2195z00_16020, BgL_a1z00_16003);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2196z00_16021;

																		BgL_arg2196z00_16021 =
																			(BgL_spz00_16009 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13733),
																			BgL_arg2196z00_16021, BgL_a2z00_16004);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2197z00_16022;
																		obj_t BgL_arg2198z00_16023;

																		BgL_arg2197z00_16022 =
																			(BgL_spz00_16009 + ((long) 2));
																		BgL_arg2198z00_16023 = BNIL;
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13733),
																			BgL_arg2197z00_16022,
																			BgL_arg2198z00_16023);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_13730,
																		STRUCT_REF(BgL_ufz00_16005,
																			(int) (((long) 3))), (int) (((long) 2)),
																		CINT(BgL_arityz00_16006));
														}}
													else
														{	/* Eval/evaluate_comp.scm 889 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_13730, STRUCT_REF(BgL_ufz00_16005,
																	(int) (((long) 3))), (int) (((long) 2)),
																CINT(BgL_arityz00_16006));
												}}
											{	/* Eval/evaluate_comp.scm 889 */
												obj_t BgL_z12denvz12_16024;

												BgL_z12denvz12_16024 = BGL_CURRENT_DYNAMIC_ENV();
												if (
													((BgL_spz00_16009 +
															(long) CINT(BgL_sfz00_16008)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13733))))
													{	/* Eval/evaluate_comp.scm 889 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_16007, BgL_sz00_13733,
															BINT(BgL_spz00_16009));
													}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_nsz00_16025;

														BgL_nsz00_16025 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 889 */
															long BgL_arg2202z00_16026;

															BgL_arg2202z00_16026 =
																(BgL_spz00_16009 + ((long) 2));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_16025, ((long) 2), BgL_sz00_13733,
																BINT(BgL_spz00_16009),
																BINT(BgL_arg2202z00_16026));
														}
														VECTOR_SET(BgL_nsz00_16025, ((long) 1),
															BgL_sz00_13733);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16024,
															BgL_nsz00_16025);
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_ez00_16027;

															BgL_ez00_16027 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_16027, BgL_sz00_13733);
															{	/* Eval/evaluate_comp.scm 889 */
																obj_t BgL_____rz00_16028;

																{	/* Eval/evaluate_comp.scm 663 */
																	obj_t BgL_savedzd2bpzd2_16029;

																	BgL_savedzd2bpzd2_16029 =
																		VECTOR_REF(BgL_nsz00_16025, ((long) 0));
																	VECTOR_SET(BgL_nsz00_16025, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_16031;

																		BgL_fz00_16031 = BgL_runz00_16007;
																	BgL_recz00_16030:
																		{	/* Eval/evaluate_comp.scm 666 */
																			obj_t BgL_rz00_16032;

																			BgL_rz00_16032 =
																				PROCEDURE_ENTRY(BgL_fz00_16031)
																				(BgL_fz00_16031, BgL_nsz00_16025, BEOA);
																			{	/* Eval/evaluate_comp.scm 667 */
																				bool_t BgL_test6304z00_21657;

																				if (PROCEDUREP(BgL_rz00_16032))
																					{	/* Eval/evaluate_comp.scm 667 */
																						obj_t BgL_arg1707z00_16033;

																						BgL_arg1707z00_16033 =
																							PROCEDURE_ATTR(BgL_rz00_16032);
																						if (STRUCTP(BgL_arg1707z00_16033))
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_test6304z00_21657 =
																									(STRUCT_KEY
																									(BgL_arg1707z00_16033) ==
																									BGl_symbol5794z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_test6304z00_21657 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						BgL_test6304z00_21657 =
																							((bool_t) 0);
																					}
																				if (BgL_test6304z00_21657)
																					{
																						obj_t BgL_fz00_21665;

																						BgL_fz00_21665 = BgL_rz00_16032;
																						BgL_fz00_16031 = BgL_fz00_21665;
																						goto BgL_recz00_16030;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						VECTOR_SET(BgL_nsz00_16025,
																							((long) 0),
																							BgL_savedzd2bpzd2_16029);
																						BgL_____rz00_16028 = BgL_rz00_16032;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_16027);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16024,
																	BgL_sz00_13733);
																return BgL_____rz00_16028;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_16002,
												(int) (((long) 2))))
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_nbpz00_16034;

												BgL_nbpz00_16034 =
													((long) CINT(BgL_bpz00_16001) + BgL_siza7eza7_13732);
												VECTOR_SET(
													((obj_t) BgL_sz00_13733), ((long) 0),
													BINT(BgL_nbpz00_16034));
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_rz00_16035;

													BgL_rz00_16035 =
														PROCEDURE_ENTRY(BgL_fz00_16002) (BgL_fz00_16002,
														BgL_a1z00_16003, BgL_a2z00_16004, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13733), ((long) 0),
														BgL_bpz00_16001);
													return BgL_rz00_16035;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13730,
													BgL_symbzd2funzd2_13731, (int) (((long) 2)),
													PROCEDURE_ARITY(BgL_fz00_16002));
		}}}}}}}}

	}



/* comp-call3 */
	obj_t BGl_compzd2call3zd2zz__evaluate_compz00(obj_t BgL_locz00_162,
		BgL_ev_exprz00_bglt BgL_vfunz00_163, obj_t BgL_symbzd2funzd2_164,
		obj_t BgL_funz00_165, obj_t BgL_tailzf3zf3_166, obj_t BgL_stkz00_167,
		long BgL_siza7eza7_168, obj_t BgL_a1z00_169, obj_t BgL_a2z00_170,
		obj_t BgL_a3z00_171)
	{
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_cfunz00_2484;

				BgL_cfunz00_2484 =
					BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_163,
					((long) 3), BgL_locz00_162, BgL_symbzd2funzd2_164);
				if (CBOOL(BgL_cfunz00_2484))
					{	/* Eval/evaluate_comp.scm 889 */
						bool_t BgL_test6309z00_21690;

						{	/* Eval/evaluate_comp.scm 889 */
							int BgL_arg2211z00_2504;

							BgL_arg2211z00_2504 = bgl_debug();
							BgL_test6309z00_21690 =
								BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2211z00_2504),
								BINT(((long) 0)));
						}
						if (BgL_test6309z00_21690)
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_zc3z04anonymousza32208ze3z87_13734;

								BgL_zc3z04anonymousza32208ze3z87_13734 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza32208ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_zc3z04anonymousza32208ze3z87_13734,
									(int) (((long) 0)), BgL_a1z00_169);
								PROCEDURE_SET(BgL_zc3z04anonymousza32208ze3z87_13734,
									(int) (((long) 1)), BgL_a2z00_170);
								PROCEDURE_SET(BgL_zc3z04anonymousza32208ze3z87_13734,
									(int) (((long) 2)), BgL_a3z00_171);
								PROCEDURE_SET(BgL_zc3z04anonymousza32208ze3z87_13734,
									(int) (((long) 3)), BINT(BgL_siza7eza7_168));
								PROCEDURE_SET(BgL_zc3z04anonymousza32208ze3z87_13734,
									(int) (((long) 4)), BgL_locz00_162);
								PROCEDURE_SET(BgL_zc3z04anonymousza32208ze3z87_13734,
									(int) (((long) 5)), BgL_cfunz00_2484);
								return BgL_zc3z04anonymousza32208ze3z87_13734;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_zc3z04anonymousza32210ze3z87_13735;

								BgL_zc3z04anonymousza32210ze3z87_13735 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza32210ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_zc3z04anonymousza32210ze3z87_13735,
									(int) (((long) 0)), BgL_a1z00_169);
								PROCEDURE_SET(BgL_zc3z04anonymousza32210ze3z87_13735,
									(int) (((long) 1)), BgL_a2z00_170);
								PROCEDURE_SET(BgL_zc3z04anonymousza32210ze3z87_13735,
									(int) (((long) 2)), BgL_a3z00_171);
								PROCEDURE_SET(BgL_zc3z04anonymousza32210ze3z87_13735,
									(int) (((long) 3)), BINT(BgL_siza7eza7_168));
								PROCEDURE_SET(BgL_zc3z04anonymousza32210ze3z87_13735,
									(int) (((long) 4)), BgL_cfunz00_2484);
								return BgL_zc3z04anonymousza32210ze3z87_13735;
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 889 */
						if (CBOOL(BgL_tailzf3zf3_166))
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_test6311z00_21727;

								{	/* Eval/evaluate_comp.scm 889 */
									int BgL_arg2290z00_2616;

									BgL_arg2290z00_2616 = bgl_debug();
									BgL_test6311z00_21727 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2290z00_2616),
										BINT(((long) 0)));
								}
								if (BgL_test6311z00_21727)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3z04anonymousza32214ze3z87_13736;

										BgL_zc3z04anonymousza32214ze3z87_13736 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32214ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 7)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32214ze3z87_13736,
											(int) (((long) 0)), BgL_funz00_165);
										PROCEDURE_SET(BgL_zc3z04anonymousza32214ze3z87_13736,
											(int) (((long) 1)), BgL_a1z00_169);
										PROCEDURE_SET(BgL_zc3z04anonymousza32214ze3z87_13736,
											(int) (((long) 2)), BgL_a2z00_170);
										PROCEDURE_SET(BgL_zc3z04anonymousza32214ze3z87_13736,
											(int) (((long) 3)), BgL_a3z00_171);
										PROCEDURE_SET(BgL_zc3z04anonymousza32214ze3z87_13736,
											(int) (((long) 4)), BgL_locz00_162);
										PROCEDURE_SET(BgL_zc3z04anonymousza32214ze3z87_13736,
											(int) (((long) 5)), BgL_symbzd2funzd2_164);
										PROCEDURE_SET(BgL_zc3z04anonymousza32214ze3z87_13736,
											(int) (((long) 6)), BINT(BgL_siza7eza7_168));
										return BgL_zc3z04anonymousza32214ze3z87_13736;
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3z04anonymousza32253ze3z87_13737;

										BgL_zc3z04anonymousza32253ze3z87_13737 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32253ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 7)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32253ze3z87_13737,
											(int) (((long) 0)), BgL_funz00_165);
										PROCEDURE_SET(BgL_zc3z04anonymousza32253ze3z87_13737,
											(int) (((long) 1)), BgL_a1z00_169);
										PROCEDURE_SET(BgL_zc3z04anonymousza32253ze3z87_13737,
											(int) (((long) 2)), BgL_a2z00_170);
										PROCEDURE_SET(BgL_zc3z04anonymousza32253ze3z87_13737,
											(int) (((long) 3)), BgL_a3z00_171);
										PROCEDURE_SET(BgL_zc3z04anonymousza32253ze3z87_13737,
											(int) (((long) 4)), BgL_locz00_162);
										PROCEDURE_SET(BgL_zc3z04anonymousza32253ze3z87_13737,
											(int) (((long) 5)), BgL_symbzd2funzd2_164);
										PROCEDURE_SET(BgL_zc3z04anonymousza32253ze3z87_13737,
											(int) (((long) 6)), BINT(BgL_siza7eza7_168));
										return BgL_zc3z04anonymousza32253ze3z87_13737;
									}
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_test6312z00_21768;

								{	/* Eval/evaluate_comp.scm 889 */
									int BgL_arg2368z00_2728;

									BgL_arg2368z00_2728 = bgl_debug();
									BgL_test6312z00_21768 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2368z00_2728),
										BINT(((long) 0)));
								}
								if (BgL_test6312z00_21768)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3z04anonymousza32293ze3z87_13738;

										BgL_zc3z04anonymousza32293ze3z87_13738 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32293ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 7)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32293ze3z87_13738,
											(int) (((long) 0)), BgL_funz00_165);
										PROCEDURE_SET(BgL_zc3z04anonymousza32293ze3z87_13738,
											(int) (((long) 1)), BgL_a1z00_169);
										PROCEDURE_SET(BgL_zc3z04anonymousza32293ze3z87_13738,
											(int) (((long) 2)), BgL_a2z00_170);
										PROCEDURE_SET(BgL_zc3z04anonymousza32293ze3z87_13738,
											(int) (((long) 3)), BgL_a3z00_171);
										PROCEDURE_SET(BgL_zc3z04anonymousza32293ze3z87_13738,
											(int) (((long) 4)), BgL_locz00_162);
										PROCEDURE_SET(BgL_zc3z04anonymousza32293ze3z87_13738,
											(int) (((long) 5)), BgL_symbzd2funzd2_164);
										PROCEDURE_SET(BgL_zc3z04anonymousza32293ze3z87_13738,
											(int) (((long) 6)), BINT(BgL_siza7eza7_168));
										return BgL_zc3z04anonymousza32293ze3z87_13738;
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3z04anonymousza32331ze3z87_13739;

										BgL_zc3z04anonymousza32331ze3z87_13739 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32331ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 7)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32331ze3z87_13739,
											(int) (((long) 0)), BgL_funz00_165);
										PROCEDURE_SET(BgL_zc3z04anonymousza32331ze3z87_13739,
											(int) (((long) 1)), BgL_a1z00_169);
										PROCEDURE_SET(BgL_zc3z04anonymousza32331ze3z87_13739,
											(int) (((long) 2)), BgL_a2z00_170);
										PROCEDURE_SET(BgL_zc3z04anonymousza32331ze3z87_13739,
											(int) (((long) 3)), BgL_a3z00_171);
										PROCEDURE_SET(BgL_zc3z04anonymousza32331ze3z87_13739,
											(int) (((long) 4)), BgL_locz00_162);
										PROCEDURE_SET(BgL_zc3z04anonymousza32331ze3z87_13739,
											(int) (((long) 5)), BgL_symbzd2funzd2_164);
										PROCEDURE_SET(BgL_zc3z04anonymousza32331ze3z87_13739,
											(int) (((long) 6)), BINT(BgL_siza7eza7_168));
										return BgL_zc3z04anonymousza32331ze3z87_13739;
									}
							}
					}
			}
		}

	}



/* &<@anonymous:2208> */
	obj_t BGl_z62zc3z04anonymousza32208ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13740, obj_t BgL_sz00_13747)
	{
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_a1z00_13741;
				obj_t BgL_a2z00_13742;
				obj_t BgL_a3z00_13743;
				long BgL_siza7eza7_13744;
				obj_t BgL_locz00_13745;
				obj_t BgL_cfunz00_13746;

				BgL_a1z00_13741 = PROCEDURE_REF(BgL_envz00_13740, (int) (((long) 0)));
				BgL_a2z00_13742 = PROCEDURE_REF(BgL_envz00_13740, (int) (((long) 1)));
				BgL_a3z00_13743 = PROCEDURE_REF(BgL_envz00_13740, (int) (((long) 2)));
				BgL_siza7eza7_13744 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13740, (int) (((long) 3))));
				BgL_locz00_13745 = PROCEDURE_REF(BgL_envz00_13740, (int) (((long) 4)));
				BgL_cfunz00_13746 = PROCEDURE_REF(BgL_envz00_13740, (int) (((long) 5)));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_16036;

					BgL_bpz00_16036 = VECTOR_REF(((obj_t) BgL_sz00_13747), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_a1z00_16037;
						obj_t BgL_a2z00_16038;
						obj_t BgL_a3z00_16039;

						BgL_a1z00_16037 =
							PROCEDURE_ENTRY(BgL_a1z00_13741) (BgL_a1z00_13741, BgL_sz00_13747,
							BEOA);
						BgL_a2z00_16038 =
							PROCEDURE_ENTRY(BgL_a2z00_13742) (BgL_a2z00_13742, BgL_sz00_13747,
							BEOA);
						BgL_a3z00_16039 =
							PROCEDURE_ENTRY(BgL_a3z00_13743) (BgL_a3z00_13743, BgL_sz00_13747,
							BEOA);
						{	/* Eval/evaluate_comp.scm 889 */
							long BgL_nbpz00_16040;

							BgL_nbpz00_16040 =
								((long) CINT(BgL_bpz00_16036) + BgL_siza7eza7_13744);
							VECTOR_SET(
								((obj_t) BgL_sz00_13747), ((long) 0), BINT(BgL_nbpz00_16040));
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_tmpz00_21841;

								BgL_tmpz00_21841 = BGL_CURRENT_DYNAMIC_ENV();
								BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_21841, BgL_locz00_13745);
							}
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_rz00_16041;

								BgL_rz00_16041 =
									PROCEDURE_ENTRY(BgL_cfunz00_13746) (BgL_cfunz00_13746,
									BgL_a1z00_16037, BgL_a2z00_16038, BgL_a3z00_16039, BEOA);
								VECTOR_SET(((obj_t) BgL_sz00_13747), ((long) 0),
									BgL_bpz00_16036);
								return BgL_rz00_16041;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:2210> */
	obj_t BGl_z62zc3z04anonymousza32210ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13748, obj_t BgL_sz00_13754)
	{
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_a1z00_13749;
				obj_t BgL_a2z00_13750;
				obj_t BgL_a3z00_13751;
				long BgL_siza7eza7_13752;
				obj_t BgL_cfunz00_13753;

				BgL_a1z00_13749 = PROCEDURE_REF(BgL_envz00_13748, (int) (((long) 0)));
				BgL_a2z00_13750 = PROCEDURE_REF(BgL_envz00_13748, (int) (((long) 1)));
				BgL_a3z00_13751 = PROCEDURE_REF(BgL_envz00_13748, (int) (((long) 2)));
				BgL_siza7eza7_13752 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13748, (int) (((long) 3))));
				BgL_cfunz00_13753 = PROCEDURE_REF(BgL_envz00_13748, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_16042;

					BgL_bpz00_16042 = VECTOR_REF(((obj_t) BgL_sz00_13754), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_a1z00_16043;
						obj_t BgL_a2z00_16044;
						obj_t BgL_a3z00_16045;

						BgL_a1z00_16043 =
							PROCEDURE_ENTRY(BgL_a1z00_13749) (BgL_a1z00_13749, BgL_sz00_13754,
							BEOA);
						BgL_a2z00_16044 =
							PROCEDURE_ENTRY(BgL_a2z00_13750) (BgL_a2z00_13750, BgL_sz00_13754,
							BEOA);
						BgL_a3z00_16045 =
							PROCEDURE_ENTRY(BgL_a3z00_13751) (BgL_a3z00_13751, BgL_sz00_13754,
							BEOA);
						{	/* Eval/evaluate_comp.scm 889 */
							long BgL_nbpz00_16046;

							BgL_nbpz00_16046 =
								((long) CINT(BgL_bpz00_16042) + BgL_siza7eza7_13752);
							VECTOR_SET(
								((obj_t) BgL_sz00_13754), ((long) 0), BINT(BgL_nbpz00_16046));
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_rz00_16047;

								BgL_rz00_16047 =
									PROCEDURE_ENTRY(BgL_cfunz00_13753) (BgL_cfunz00_13753,
									BgL_a1z00_16043, BgL_a2z00_16044, BgL_a3z00_16045, BEOA);
								VECTOR_SET(((obj_t) BgL_sz00_13754), ((long) 0),
									BgL_bpz00_16042);
								return BgL_rz00_16047;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:2214> */
	obj_t BGl_z62zc3z04anonymousza32214ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13755, obj_t BgL_sz00_13763)
	{
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_13756;
				obj_t BgL_a1z00_13757;
				obj_t BgL_a2z00_13758;
				obj_t BgL_a3z00_13759;
				obj_t BgL_locz00_13760;
				obj_t BgL_symbzd2funzd2_13761;
				long BgL_siza7eza7_13762;

				BgL_funz00_13756 = PROCEDURE_REF(BgL_envz00_13755, (int) (((long) 0)));
				BgL_a1z00_13757 = PROCEDURE_REF(BgL_envz00_13755, (int) (((long) 1)));
				BgL_a2z00_13758 = PROCEDURE_REF(BgL_envz00_13755, (int) (((long) 2)));
				BgL_a3z00_13759 = PROCEDURE_REF(BgL_envz00_13755, (int) (((long) 3)));
				BgL_locz00_13760 = PROCEDURE_REF(BgL_envz00_13755, (int) (((long) 4)));
				BgL_symbzd2funzd2_13761 =
					PROCEDURE_REF(BgL_envz00_13755, (int) (((long) 5)));
				BgL_siza7eza7_13762 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13755, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_16048;

					BgL_bpz00_16048 = VECTOR_REF(((obj_t) BgL_sz00_13763), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_fz00_16049;
						obj_t BgL_a1z00_16050;
						obj_t BgL_a2z00_16051;
						obj_t BgL_a3z00_16052;

						BgL_fz00_16049 =
							PROCEDURE_ENTRY(BgL_funz00_13756) (BgL_funz00_13756,
							BgL_sz00_13763, BEOA);
						BgL_a1z00_16050 =
							PROCEDURE_ENTRY(BgL_a1z00_13757) (BgL_a1z00_13757, BgL_sz00_13763,
							BEOA);
						BgL_a2z00_16051 =
							PROCEDURE_ENTRY(BgL_a2z00_13758) (BgL_a2z00_13758, BgL_sz00_13763,
							BEOA);
						BgL_a3z00_16052 =
							PROCEDURE_ENTRY(BgL_a3z00_13759) (BgL_a3z00_13759, BgL_sz00_13763,
							BEOA);
						if (PROCEDUREP(BgL_fz00_16049))
							{	/* Eval/evaluate_comp.scm 889 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13760,
									BGl_string5798z00zz__evaluate_compz00,
									BGl_string5814z00zz__evaluate_compz00, BgL_fz00_16049);
							}
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_ufz00_16053;

							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_tmpz00_21926;

								BgL_tmpz00_21926 = ((obj_t) BgL_fz00_16049);
								BgL_ufz00_16053 = PROCEDURE_ATTR(BgL_tmpz00_21926);
							}
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_test6314z00_21929;

								if (STRUCTP(BgL_ufz00_16053))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6314z00_21929 =
											(STRUCT_KEY(BgL_ufz00_16053) ==
											BGl_symbol5815z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6314z00_21929 = ((bool_t) 0);
									}
								if (BgL_test6314z00_21929)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_arityz00_16054;
										obj_t BgL_runz00_16055;
										obj_t BgL_sfz00_16056;

										BgL_arityz00_16054 =
											STRUCT_REF(BgL_ufz00_16053, (int) (((long) 0)));
										BgL_runz00_16055 =
											STRUCT_REF(BgL_ufz00_16053, (int) (((long) 1)));
										BgL_sfz00_16056 =
											STRUCT_REF(BgL_ufz00_16053, (int) (((long) 2)));
										if (((long) CINT(BgL_arityz00_16054) == ((long) 3)))
											{	/* Eval/evaluate_comp.scm 889 */
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_arg2218z00_16057;

													BgL_arg2218z00_16057 =
														((long) CINT(BgL_bpz00_16048) + ((long) 0));
													VECTOR_SET(
														((obj_t) BgL_sz00_13763), BgL_arg2218z00_16057,
														BgL_a1z00_16050);
												}
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_arg2220z00_16058;

													BgL_arg2220z00_16058 =
														((long) CINT(BgL_bpz00_16048) + ((long) 1));
													VECTOR_SET(
														((obj_t) BgL_sz00_13763), BgL_arg2220z00_16058,
														BgL_a2z00_16051);
												}
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_arg2221z00_16059;

													BgL_arg2221z00_16059 =
														((long) CINT(BgL_bpz00_16048) + ((long) 2));
													VECTOR_SET(
														((obj_t) BgL_sz00_13763), BgL_arg2221z00_16059,
														BgL_a3z00_16052);
											}}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												if (INTEGERP(BgL_arityz00_16054))
													{	/* Eval/evaluate_comp.scm 889 */
														switch ((long) CINT(BgL_arityz00_16054))
															{
															case ((long) -1):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2223z00_16060;
																	obj_t BgL_arg2224z00_16061;

																	BgL_arg2223z00_16060 =
																		((long) CINT(BgL_bpz00_16048) + ((long) 0));
																	{	/* Eval/evaluate_comp.scm 889 */
																		obj_t BgL_list2225z00_16062;

																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_arg2226z00_16063;

																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_arg2227z00_16064;

																				BgL_arg2227z00_16064 =
																					MAKE_YOUNG_PAIR(BgL_a3z00_16052,
																					BNIL);
																				BgL_arg2226z00_16063 =
																					MAKE_YOUNG_PAIR(BgL_a2z00_16051,
																					BgL_arg2227z00_16064);
																			}
																			BgL_list2225z00_16062 =
																				MAKE_YOUNG_PAIR(BgL_a1z00_16050,
																				BgL_arg2226z00_16063);
																		}
																		BgL_arg2224z00_16061 =
																			BgL_list2225z00_16062;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13763),
																		BgL_arg2223z00_16060, BgL_arg2224z00_16061);
																} break;
															case ((long) -2):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2228z00_16065;

																	BgL_arg2228z00_16065 =
																		((long) CINT(BgL_bpz00_16048) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13763),
																		BgL_arg2228z00_16065, BgL_a1z00_16050);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2229z00_16066;
																	obj_t BgL_arg2230z00_16067;

																	BgL_arg2229z00_16066 =
																		((long) CINT(BgL_bpz00_16048) + ((long) 1));
																	{	/* Eval/evaluate_comp.scm 889 */
																		obj_t BgL_list2231z00_16068;

																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_arg2232z00_16069;

																			BgL_arg2232z00_16069 =
																				MAKE_YOUNG_PAIR(BgL_a3z00_16052, BNIL);
																			BgL_list2231z00_16068 =
																				MAKE_YOUNG_PAIR(BgL_a2z00_16051,
																				BgL_arg2232z00_16069);
																		}
																		BgL_arg2230z00_16067 =
																			BgL_list2231z00_16068;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13763),
																		BgL_arg2229z00_16066, BgL_arg2230z00_16067);
																} break;
															case ((long) -3):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2233z00_16070;

																	BgL_arg2233z00_16070 =
																		((long) CINT(BgL_bpz00_16048) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13763),
																		BgL_arg2233z00_16070, BgL_a1z00_16050);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2234z00_16071;

																	BgL_arg2234z00_16071 =
																		((long) CINT(BgL_bpz00_16048) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13763),
																		BgL_arg2234z00_16071, BgL_a2z00_16051);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2235z00_16072;
																	obj_t BgL_arg2237z00_16073;

																	BgL_arg2235z00_16072 =
																		((long) CINT(BgL_bpz00_16048) + ((long) 2));
																	{	/* Eval/evaluate_comp.scm 889 */
																		obj_t BgL_list2238z00_16074;

																		BgL_list2238z00_16074 =
																			MAKE_YOUNG_PAIR(BgL_a3z00_16052, BNIL);
																		BgL_arg2237z00_16073 =
																			BgL_list2238z00_16074;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13763),
																		BgL_arg2235z00_16072, BgL_arg2237z00_16073);
																} break;
															case ((long) -4):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2239z00_16075;

																	BgL_arg2239z00_16075 =
																		((long) CINT(BgL_bpz00_16048) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13763),
																		BgL_arg2239z00_16075, BgL_a1z00_16050);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2241z00_16076;

																	BgL_arg2241z00_16076 =
																		((long) CINT(BgL_bpz00_16048) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13763),
																		BgL_arg2241z00_16076, BgL_a2z00_16051);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2242z00_16077;

																	BgL_arg2242z00_16077 =
																		((long) CINT(BgL_bpz00_16048) + ((long) 2));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13763),
																		BgL_arg2242z00_16077, BgL_a3z00_16052);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2243z00_16078;
																	obj_t BgL_arg2244z00_16079;

																	BgL_arg2243z00_16078 =
																		((long) CINT(BgL_bpz00_16048) + ((long) 3));
																	BgL_arg2244z00_16079 = BNIL;
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13763),
																		BgL_arg2243z00_16078, BgL_arg2244z00_16079);
																} break;
															default:
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_13760, STRUCT_REF(BgL_ufz00_16053,
																		(int) (((long) 3))), (int) (((long) 3)),
																	CINT(BgL_arityz00_16054));
													}}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														BGl_evarityzd2errorzd2zz__everrorz00
															(BgL_locz00_13760, STRUCT_REF(BgL_ufz00_16053,
																(int) (((long) 3))), (int) (((long) 3)),
															CINT(BgL_arityz00_16054));
											}}
										{	/* Eval/evaluate_comp.scm 889 */
											obj_t BgL_z12denvz12_16080;

											BgL_z12denvz12_16080 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_16080,
												BgL_locz00_13760);
											if ((((long) CINT(BgL_bpz00_16048) +
														(long) CINT(BgL_sfz00_16056)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_13763))))
												{	/* Eval/evaluate_comp.scm 889 */
													return BgL_runz00_16055;
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_nsz00_16081;

													BgL_nsz00_16081 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2248z00_16082;

														BgL_arg2248z00_16082 =
															((long) CINT(BgL_bpz00_16048) + ((long) 3));
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_16081, ((long) 2), BgL_sz00_13763,
															BgL_bpz00_16048, BINT(BgL_arg2248z00_16082));
													}
													VECTOR_SET(BgL_nsz00_16081, ((long) 1),
														BgL_sz00_13763);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16080,
														BgL_nsz00_16081);
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_ez00_16083;

														BgL_ez00_16083 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_16083, BgL_sz00_13763);
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_____rz00_16084;

															{	/* Eval/evaluate_comp.scm 663 */
																obj_t BgL_savedzd2bpzd2_16085;

																BgL_savedzd2bpzd2_16085 =
																	VECTOR_REF(BgL_nsz00_16081, ((long) 0));
																VECTOR_SET(BgL_nsz00_16081, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_16087;

																	BgL_fz00_16087 = BgL_runz00_16055;
																BgL_recz00_16086:
																	{	/* Eval/evaluate_comp.scm 666 */
																		obj_t BgL_rz00_16088;

																		BgL_rz00_16088 =
																			PROCEDURE_ENTRY(BgL_fz00_16087)
																			(BgL_fz00_16087, BgL_nsz00_16081, BEOA);
																		{	/* Eval/evaluate_comp.scm 667 */
																			bool_t BgL_test6319z00_22040;

																			if (PROCEDUREP(BgL_rz00_16088))
																				{	/* Eval/evaluate_comp.scm 667 */
																					obj_t BgL_arg1707z00_16089;

																					BgL_arg1707z00_16089 =
																						PROCEDURE_ATTR(BgL_rz00_16088);
																					if (STRUCTP(BgL_arg1707z00_16089))
																						{	/* Eval/evaluate_comp.scm 647 */
																							BgL_test6319z00_22040 =
																								(STRUCT_KEY
																								(BgL_arg1707z00_16089) ==
																								BGl_symbol5794z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 647 */
																							BgL_test6319z00_22040 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 667 */
																					BgL_test6319z00_22040 = ((bool_t) 0);
																				}
																			if (BgL_test6319z00_22040)
																				{
																					obj_t BgL_fz00_22048;

																					BgL_fz00_22048 = BgL_rz00_16088;
																					BgL_fz00_16087 = BgL_fz00_22048;
																					goto BgL_recz00_16086;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 667 */
																					VECTOR_SET(BgL_nsz00_16081,
																						((long) 0),
																						BgL_savedzd2bpzd2_16085);
																					BgL_____rz00_16084 = BgL_rz00_16088;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_16083);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16080,
																BgL_sz00_13763);
															return BgL_____rz00_16084;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_16049,
												(int) (((long) 3))))
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_nbpz00_16090;

												BgL_nbpz00_16090 =
													((long) CINT(BgL_bpz00_16048) + BgL_siza7eza7_13762);
												VECTOR_SET(
													((obj_t) BgL_sz00_13763), ((long) 0),
													BINT(BgL_nbpz00_16090));
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_tmpz00_22060;

													BgL_tmpz00_22060 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_22060,
														BgL_locz00_13760);
												}
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_rz00_16091;

													BgL_rz00_16091 =
														PROCEDURE_ENTRY(BgL_fz00_16049) (BgL_fz00_16049,
														BgL_a1z00_16050, BgL_a2z00_16051, BgL_a3z00_16052,
														BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13763), ((long) 0),
														BgL_bpz00_16048);
													return BgL_rz00_16091;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13760,
													BgL_symbzd2funzd2_13761, (int) (((long) 3)),
													PROCEDURE_ARITY(BgL_fz00_16049));
		}}}}}}}}

	}



/* &<@anonymous:2253> */
	obj_t BGl_z62zc3z04anonymousza32253ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13764, obj_t BgL_sz00_13772)
	{
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_13765;
				obj_t BgL_a1z00_13766;
				obj_t BgL_a2z00_13767;
				obj_t BgL_a3z00_13768;
				obj_t BgL_locz00_13769;
				obj_t BgL_symbzd2funzd2_13770;
				long BgL_siza7eza7_13771;

				BgL_funz00_13765 = PROCEDURE_REF(BgL_envz00_13764, (int) (((long) 0)));
				BgL_a1z00_13766 = PROCEDURE_REF(BgL_envz00_13764, (int) (((long) 1)));
				BgL_a2z00_13767 = PROCEDURE_REF(BgL_envz00_13764, (int) (((long) 2)));
				BgL_a3z00_13768 = PROCEDURE_REF(BgL_envz00_13764, (int) (((long) 3)));
				BgL_locz00_13769 = PROCEDURE_REF(BgL_envz00_13764, (int) (((long) 4)));
				BgL_symbzd2funzd2_13770 =
					PROCEDURE_REF(BgL_envz00_13764, (int) (((long) 5)));
				BgL_siza7eza7_13771 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13764, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_16092;

					BgL_bpz00_16092 = VECTOR_REF(((obj_t) BgL_sz00_13772), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_fz00_16093;
						obj_t BgL_a1z00_16094;
						obj_t BgL_a2z00_16095;
						obj_t BgL_a3z00_16096;

						BgL_fz00_16093 =
							PROCEDURE_ENTRY(BgL_funz00_13765) (BgL_funz00_13765,
							BgL_sz00_13772, BEOA);
						BgL_a1z00_16094 =
							PROCEDURE_ENTRY(BgL_a1z00_13766) (BgL_a1z00_13766, BgL_sz00_13772,
							BEOA);
						BgL_a2z00_16095 =
							PROCEDURE_ENTRY(BgL_a2z00_13767) (BgL_a2z00_13767, BgL_sz00_13772,
							BEOA);
						BgL_a3z00_16096 =
							PROCEDURE_ENTRY(BgL_a3z00_13768) (BgL_a3z00_13768, BgL_sz00_13772,
							BEOA);
						if (PROCEDUREP(BgL_fz00_16093))
							{	/* Eval/evaluate_comp.scm 889 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13769,
									BGl_string5798z00zz__evaluate_compz00,
									BGl_string5814z00zz__evaluate_compz00, BgL_fz00_16093);
							}
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_ufz00_16097;

							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_tmpz00_22110;

								BgL_tmpz00_22110 = ((obj_t) BgL_fz00_16093);
								BgL_ufz00_16097 = PROCEDURE_ATTR(BgL_tmpz00_22110);
							}
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_test6324z00_22113;

								if (STRUCTP(BgL_ufz00_16097))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6324z00_22113 =
											(STRUCT_KEY(BgL_ufz00_16097) ==
											BGl_symbol5815z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6324z00_22113 = ((bool_t) 0);
									}
								if (BgL_test6324z00_22113)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_arityz00_16098;
										obj_t BgL_runz00_16099;
										obj_t BgL_sfz00_16100;

										BgL_arityz00_16098 =
											STRUCT_REF(BgL_ufz00_16097, (int) (((long) 0)));
										BgL_runz00_16099 =
											STRUCT_REF(BgL_ufz00_16097, (int) (((long) 1)));
										BgL_sfz00_16100 =
											STRUCT_REF(BgL_ufz00_16097, (int) (((long) 2)));
										if (((long) CINT(BgL_arityz00_16098) == ((long) 3)))
											{	/* Eval/evaluate_comp.scm 889 */
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_arg2257z00_16101;

													BgL_arg2257z00_16101 =
														((long) CINT(BgL_bpz00_16092) + ((long) 0));
													VECTOR_SET(
														((obj_t) BgL_sz00_13772), BgL_arg2257z00_16101,
														BgL_a1z00_16094);
												}
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_arg2258z00_16102;

													BgL_arg2258z00_16102 =
														((long) CINT(BgL_bpz00_16092) + ((long) 1));
													VECTOR_SET(
														((obj_t) BgL_sz00_13772), BgL_arg2258z00_16102,
														BgL_a2z00_16095);
												}
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_arg2259z00_16103;

													BgL_arg2259z00_16103 =
														((long) CINT(BgL_bpz00_16092) + ((long) 2));
													VECTOR_SET(
														((obj_t) BgL_sz00_13772), BgL_arg2259z00_16103,
														BgL_a3z00_16096);
											}}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												if (INTEGERP(BgL_arityz00_16098))
													{	/* Eval/evaluate_comp.scm 889 */
														switch ((long) CINT(BgL_arityz00_16098))
															{
															case ((long) -1):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2261z00_16104;
																	obj_t BgL_arg2262z00_16105;

																	BgL_arg2261z00_16104 =
																		((long) CINT(BgL_bpz00_16092) + ((long) 0));
																	{	/* Eval/evaluate_comp.scm 889 */
																		obj_t BgL_list2263z00_16106;

																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_arg2264z00_16107;

																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_arg2265z00_16108;

																				BgL_arg2265z00_16108 =
																					MAKE_YOUNG_PAIR(BgL_a3z00_16096,
																					BNIL);
																				BgL_arg2264z00_16107 =
																					MAKE_YOUNG_PAIR(BgL_a2z00_16095,
																					BgL_arg2265z00_16108);
																			}
																			BgL_list2263z00_16106 =
																				MAKE_YOUNG_PAIR(BgL_a1z00_16094,
																				BgL_arg2264z00_16107);
																		}
																		BgL_arg2262z00_16105 =
																			BgL_list2263z00_16106;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13772),
																		BgL_arg2261z00_16104, BgL_arg2262z00_16105);
																} break;
															case ((long) -2):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2266z00_16109;

																	BgL_arg2266z00_16109 =
																		((long) CINT(BgL_bpz00_16092) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13772),
																		BgL_arg2266z00_16109, BgL_a1z00_16094);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2267z00_16110;
																	obj_t BgL_arg2268z00_16111;

																	BgL_arg2267z00_16110 =
																		((long) CINT(BgL_bpz00_16092) + ((long) 1));
																	{	/* Eval/evaluate_comp.scm 889 */
																		obj_t BgL_list2269z00_16112;

																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_arg2270z00_16113;

																			BgL_arg2270z00_16113 =
																				MAKE_YOUNG_PAIR(BgL_a3z00_16096, BNIL);
																			BgL_list2269z00_16112 =
																				MAKE_YOUNG_PAIR(BgL_a2z00_16095,
																				BgL_arg2270z00_16113);
																		}
																		BgL_arg2268z00_16111 =
																			BgL_list2269z00_16112;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13772),
																		BgL_arg2267z00_16110, BgL_arg2268z00_16111);
																} break;
															case ((long) -3):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2271z00_16114;

																	BgL_arg2271z00_16114 =
																		((long) CINT(BgL_bpz00_16092) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13772),
																		BgL_arg2271z00_16114, BgL_a1z00_16094);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2272z00_16115;

																	BgL_arg2272z00_16115 =
																		((long) CINT(BgL_bpz00_16092) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13772),
																		BgL_arg2272z00_16115, BgL_a2z00_16095);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2273z00_16116;
																	obj_t BgL_arg2274z00_16117;

																	BgL_arg2273z00_16116 =
																		((long) CINT(BgL_bpz00_16092) + ((long) 2));
																	{	/* Eval/evaluate_comp.scm 889 */
																		obj_t BgL_list2275z00_16118;

																		BgL_list2275z00_16118 =
																			MAKE_YOUNG_PAIR(BgL_a3z00_16096, BNIL);
																		BgL_arg2274z00_16117 =
																			BgL_list2275z00_16118;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13772),
																		BgL_arg2273z00_16116, BgL_arg2274z00_16117);
																} break;
															case ((long) -4):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2277z00_16119;

																	BgL_arg2277z00_16119 =
																		((long) CINT(BgL_bpz00_16092) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13772),
																		BgL_arg2277z00_16119, BgL_a1z00_16094);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2278z00_16120;

																	BgL_arg2278z00_16120 =
																		((long) CINT(BgL_bpz00_16092) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13772),
																		BgL_arg2278z00_16120, BgL_a2z00_16095);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2279z00_16121;

																	BgL_arg2279z00_16121 =
																		((long) CINT(BgL_bpz00_16092) + ((long) 2));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13772),
																		BgL_arg2279z00_16121, BgL_a3z00_16096);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2280z00_16122;
																	obj_t BgL_arg2282z00_16123;

																	BgL_arg2280z00_16122 =
																		((long) CINT(BgL_bpz00_16092) + ((long) 3));
																	BgL_arg2282z00_16123 = BNIL;
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13772),
																		BgL_arg2280z00_16122, BgL_arg2282z00_16123);
																} break;
															default:
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_13769, STRUCT_REF(BgL_ufz00_16097,
																		(int) (((long) 3))), (int) (((long) 3)),
																	CINT(BgL_arityz00_16098));
													}}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														BGl_evarityzd2errorzd2zz__everrorz00
															(BgL_locz00_13769, STRUCT_REF(BgL_ufz00_16097,
																(int) (((long) 3))), (int) (((long) 3)),
															CINT(BgL_arityz00_16098));
											}}
										{	/* Eval/evaluate_comp.scm 889 */
											obj_t BgL_z12denvz12_16124;

											BgL_z12denvz12_16124 = BGL_CURRENT_DYNAMIC_ENV();
											if (
												(((long) CINT(BgL_bpz00_16092) +
														(long) CINT(BgL_sfz00_16100)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_13772))))
												{	/* Eval/evaluate_comp.scm 889 */
													return BgL_runz00_16099;
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_nsz00_16125;

													BgL_nsz00_16125 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2287z00_16126;

														BgL_arg2287z00_16126 =
															((long) CINT(BgL_bpz00_16092) + ((long) 3));
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_16125, ((long) 2), BgL_sz00_13772,
															BgL_bpz00_16092, BINT(BgL_arg2287z00_16126));
													}
													VECTOR_SET(BgL_nsz00_16125, ((long) 1),
														BgL_sz00_13772);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16124,
														BgL_nsz00_16125);
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_ez00_16127;

														BgL_ez00_16127 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_16127, BgL_sz00_13772);
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_____rz00_16128;

															{	/* Eval/evaluate_comp.scm 663 */
																obj_t BgL_savedzd2bpzd2_16129;

																BgL_savedzd2bpzd2_16129 =
																	VECTOR_REF(BgL_nsz00_16125, ((long) 0));
																VECTOR_SET(BgL_nsz00_16125, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_16131;

																	BgL_fz00_16131 = BgL_runz00_16099;
																BgL_recz00_16130:
																	{	/* Eval/evaluate_comp.scm 666 */
																		obj_t BgL_rz00_16132;

																		BgL_rz00_16132 =
																			PROCEDURE_ENTRY(BgL_fz00_16131)
																			(BgL_fz00_16131, BgL_nsz00_16125, BEOA);
																		{	/* Eval/evaluate_comp.scm 667 */
																			bool_t BgL_test6329z00_22223;

																			if (PROCEDUREP(BgL_rz00_16132))
																				{	/* Eval/evaluate_comp.scm 667 */
																					obj_t BgL_arg1707z00_16133;

																					BgL_arg1707z00_16133 =
																						PROCEDURE_ATTR(BgL_rz00_16132);
																					if (STRUCTP(BgL_arg1707z00_16133))
																						{	/* Eval/evaluate_comp.scm 647 */
																							BgL_test6329z00_22223 =
																								(STRUCT_KEY
																								(BgL_arg1707z00_16133) ==
																								BGl_symbol5794z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 647 */
																							BgL_test6329z00_22223 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 667 */
																					BgL_test6329z00_22223 = ((bool_t) 0);
																				}
																			if (BgL_test6329z00_22223)
																				{
																					obj_t BgL_fz00_22231;

																					BgL_fz00_22231 = BgL_rz00_16132;
																					BgL_fz00_16131 = BgL_fz00_22231;
																					goto BgL_recz00_16130;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 667 */
																					VECTOR_SET(BgL_nsz00_16125,
																						((long) 0),
																						BgL_savedzd2bpzd2_16129);
																					BgL_____rz00_16128 = BgL_rz00_16132;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_16127);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16124,
																BgL_sz00_13772);
															return BgL_____rz00_16128;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_16093,
												(int) (((long) 3))))
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_nbpz00_16134;

												BgL_nbpz00_16134 =
													((long) CINT(BgL_bpz00_16092) + BgL_siza7eza7_13771);
												VECTOR_SET(
													((obj_t) BgL_sz00_13772), ((long) 0),
													BINT(BgL_nbpz00_16134));
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_rz00_16135;

													BgL_rz00_16135 =
														PROCEDURE_ENTRY(BgL_fz00_16093) (BgL_fz00_16093,
														BgL_a1z00_16094, BgL_a2z00_16095, BgL_a3z00_16096,
														BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13772), ((long) 0),
														BgL_bpz00_16092);
													return BgL_rz00_16135;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13769,
													BgL_symbzd2funzd2_13770, (int) (((long) 3)),
													PROCEDURE_ARITY(BgL_fz00_16093));
		}}}}}}}}

	}



/* &<@anonymous:2293> */
	obj_t BGl_z62zc3z04anonymousza32293ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13773, obj_t BgL_sz00_13781)
	{
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_13774;
				obj_t BgL_a1z00_13775;
				obj_t BgL_a2z00_13776;
				obj_t BgL_a3z00_13777;
				obj_t BgL_locz00_13778;
				obj_t BgL_symbzd2funzd2_13779;
				long BgL_siza7eza7_13780;

				BgL_funz00_13774 = PROCEDURE_REF(BgL_envz00_13773, (int) (((long) 0)));
				BgL_a1z00_13775 = PROCEDURE_REF(BgL_envz00_13773, (int) (((long) 1)));
				BgL_a2z00_13776 = PROCEDURE_REF(BgL_envz00_13773, (int) (((long) 2)));
				BgL_a3z00_13777 = PROCEDURE_REF(BgL_envz00_13773, (int) (((long) 3)));
				BgL_locz00_13778 = PROCEDURE_REF(BgL_envz00_13773, (int) (((long) 4)));
				BgL_symbzd2funzd2_13779 =
					PROCEDURE_REF(BgL_envz00_13773, (int) (((long) 5)));
				BgL_siza7eza7_13780 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13773, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_16136;

					BgL_bpz00_16136 = VECTOR_REF(((obj_t) BgL_sz00_13781), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_fz00_16137;
						obj_t BgL_a1z00_16138;
						obj_t BgL_a2z00_16139;
						obj_t BgL_a3z00_16140;

						BgL_fz00_16137 =
							PROCEDURE_ENTRY(BgL_funz00_13774) (BgL_funz00_13774,
							BgL_sz00_13781, BEOA);
						BgL_a1z00_16138 =
							PROCEDURE_ENTRY(BgL_a1z00_13775) (BgL_a1z00_13775, BgL_sz00_13781,
							BEOA);
						BgL_a2z00_16139 =
							PROCEDURE_ENTRY(BgL_a2z00_13776) (BgL_a2z00_13776, BgL_sz00_13781,
							BEOA);
						BgL_a3z00_16140 =
							PROCEDURE_ENTRY(BgL_a3z00_13777) (BgL_a3z00_13777, BgL_sz00_13781,
							BEOA);
						if (PROCEDUREP(BgL_fz00_16137))
							{	/* Eval/evaluate_comp.scm 889 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13778,
									BGl_string5798z00zz__evaluate_compz00,
									BGl_string5814z00zz__evaluate_compz00, BgL_fz00_16137);
							}
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_ufz00_16141;

							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_tmpz00_22290;

								BgL_tmpz00_22290 = ((obj_t) BgL_fz00_16137);
								BgL_ufz00_16141 = PROCEDURE_ATTR(BgL_tmpz00_22290);
							}
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_test6334z00_22293;

								if (STRUCTP(BgL_ufz00_16141))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6334z00_22293 =
											(STRUCT_KEY(BgL_ufz00_16141) ==
											BGl_symbol5815z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6334z00_22293 = ((bool_t) 0);
									}
								if (BgL_test6334z00_22293)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_arityz00_16142;
										obj_t BgL_runz00_16143;
										obj_t BgL_sfz00_16144;

										BgL_arityz00_16142 =
											STRUCT_REF(BgL_ufz00_16141, (int) (((long) 0)));
										BgL_runz00_16143 =
											STRUCT_REF(BgL_ufz00_16141, (int) (((long) 1)));
										BgL_sfz00_16144 =
											STRUCT_REF(BgL_ufz00_16141, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 889 */
											long BgL_spz00_16145;

											BgL_spz00_16145 =
												((long) CINT(BgL_bpz00_16136) + BgL_siza7eza7_13780);
											if (((long) CINT(BgL_arityz00_16142) == ((long) 3)))
												{	/* Eval/evaluate_comp.scm 889 */
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2297z00_16146;

														BgL_arg2297z00_16146 =
															(BgL_spz00_16145 + ((long) 0));
														VECTOR_SET(
															((obj_t) BgL_sz00_13781), BgL_arg2297z00_16146,
															BgL_a1z00_16138);
													}
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2298z00_16147;

														BgL_arg2298z00_16147 =
															(BgL_spz00_16145 + ((long) 1));
														VECTOR_SET(
															((obj_t) BgL_sz00_13781), BgL_arg2298z00_16147,
															BgL_a2z00_16139);
													}
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2299z00_16148;

														BgL_arg2299z00_16148 =
															(BgL_spz00_16145 + ((long) 2));
														VECTOR_SET(
															((obj_t) BgL_sz00_13781), BgL_arg2299z00_16148,
															BgL_a3z00_16140);
												}}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													if (INTEGERP(BgL_arityz00_16142))
														{	/* Eval/evaluate_comp.scm 889 */
															switch ((long) CINT(BgL_arityz00_16142))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2301z00_16149;
																		obj_t BgL_arg2302z00_16150;

																		BgL_arg2301z00_16149 =
																			(BgL_spz00_16145 + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2303z00_16151;

																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_arg2304z00_16152;

																				{	/* Eval/evaluate_comp.scm 889 */
																					obj_t BgL_arg2305z00_16153;

																					BgL_arg2305z00_16153 =
																						MAKE_YOUNG_PAIR(BgL_a3z00_16140,
																						BNIL);
																					BgL_arg2304z00_16152 =
																						MAKE_YOUNG_PAIR(BgL_a2z00_16139,
																						BgL_arg2305z00_16153);
																				}
																				BgL_list2303z00_16151 =
																					MAKE_YOUNG_PAIR(BgL_a1z00_16138,
																					BgL_arg2304z00_16152);
																			}
																			BgL_arg2302z00_16150 =
																				BgL_list2303z00_16151;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13781),
																			BgL_arg2301z00_16149,
																			BgL_arg2302z00_16150);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2307z00_16154;

																		BgL_arg2307z00_16154 =
																			(BgL_spz00_16145 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13781),
																			BgL_arg2307z00_16154, BgL_a1z00_16138);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2308z00_16155;
																		obj_t BgL_arg2309z00_16156;

																		BgL_arg2308z00_16155 =
																			(BgL_spz00_16145 + ((long) 1));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2310z00_16157;

																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_arg2311z00_16158;

																				BgL_arg2311z00_16158 =
																					MAKE_YOUNG_PAIR(BgL_a3z00_16140,
																					BNIL);
																				BgL_list2310z00_16157 =
																					MAKE_YOUNG_PAIR(BgL_a2z00_16139,
																					BgL_arg2311z00_16158);
																			}
																			BgL_arg2309z00_16156 =
																				BgL_list2310z00_16157;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13781),
																			BgL_arg2308z00_16155,
																			BgL_arg2309z00_16156);
																	} break;
																case ((long) -3):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2314z00_16159;

																		BgL_arg2314z00_16159 =
																			(BgL_spz00_16145 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13781),
																			BgL_arg2314z00_16159, BgL_a1z00_16138);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2315z00_16160;

																		BgL_arg2315z00_16160 =
																			(BgL_spz00_16145 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13781),
																			BgL_arg2315z00_16160, BgL_a2z00_16139);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2316z00_16161;
																		obj_t BgL_arg2317z00_16162;

																		BgL_arg2316z00_16161 =
																			(BgL_spz00_16145 + ((long) 2));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2318z00_16163;

																			BgL_list2318z00_16163 =
																				MAKE_YOUNG_PAIR(BgL_a3z00_16140, BNIL);
																			BgL_arg2317z00_16162 =
																				BgL_list2318z00_16163;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13781),
																			BgL_arg2316z00_16161,
																			BgL_arg2317z00_16162);
																	} break;
																case ((long) -4):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2319z00_16164;

																		BgL_arg2319z00_16164 =
																			(BgL_spz00_16145 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13781),
																			BgL_arg2319z00_16164, BgL_a1z00_16138);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2320z00_16165;

																		BgL_arg2320z00_16165 =
																			(BgL_spz00_16145 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13781),
																			BgL_arg2320z00_16165, BgL_a2z00_16139);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2321z00_16166;

																		BgL_arg2321z00_16166 =
																			(BgL_spz00_16145 + ((long) 2));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13781),
																			BgL_arg2321z00_16166, BgL_a3z00_16140);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2322z00_16167;
																		obj_t BgL_arg2323z00_16168;

																		BgL_arg2322z00_16167 =
																			(BgL_spz00_16145 + ((long) 3));
																		BgL_arg2323z00_16168 = BNIL;
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13781),
																			BgL_arg2322z00_16167,
																			BgL_arg2323z00_16168);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_13778,
																		STRUCT_REF(BgL_ufz00_16141,
																			(int) (((long) 3))), (int) (((long) 3)),
																		CINT(BgL_arityz00_16142));
														}}
													else
														{	/* Eval/evaluate_comp.scm 889 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_13778, STRUCT_REF(BgL_ufz00_16141,
																	(int) (((long) 3))), (int) (((long) 3)),
																CINT(BgL_arityz00_16142));
												}}
											{	/* Eval/evaluate_comp.scm 889 */
												obj_t BgL_z12denvz12_16169;

												BgL_z12denvz12_16169 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_16169,
													BgL_locz00_13778);
												if (((BgL_spz00_16145 + (long) CINT(BgL_sfz00_16144)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13781))))
													{	/* Eval/evaluate_comp.scm 889 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_16143, BgL_sz00_13781,
															BINT(BgL_spz00_16145));
													}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_nsz00_16170;

														BgL_nsz00_16170 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 889 */
															long BgL_arg2327z00_16171;

															BgL_arg2327z00_16171 =
																(BgL_spz00_16145 + ((long) 3));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_16170, ((long) 2), BgL_sz00_13781,
																BINT(BgL_spz00_16145),
																BINT(BgL_arg2327z00_16171));
														}
														VECTOR_SET(BgL_nsz00_16170, ((long) 1),
															BgL_sz00_13781);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16169,
															BgL_nsz00_16170);
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_ez00_16172;

															BgL_ez00_16172 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_16172, BgL_sz00_13781);
															{	/* Eval/evaluate_comp.scm 889 */
																obj_t BgL_____rz00_16173;

																{	/* Eval/evaluate_comp.scm 663 */
																	obj_t BgL_savedzd2bpzd2_16174;

																	BgL_savedzd2bpzd2_16174 =
																		VECTOR_REF(BgL_nsz00_16170, ((long) 0));
																	VECTOR_SET(BgL_nsz00_16170, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_16176;

																		BgL_fz00_16176 = BgL_runz00_16143;
																	BgL_recz00_16175:
																		{	/* Eval/evaluate_comp.scm 666 */
																			obj_t BgL_rz00_16177;

																			BgL_rz00_16177 =
																				PROCEDURE_ENTRY(BgL_fz00_16176)
																				(BgL_fz00_16176, BgL_nsz00_16170, BEOA);
																			{	/* Eval/evaluate_comp.scm 667 */
																				bool_t BgL_test6339z00_22394;

																				if (PROCEDUREP(BgL_rz00_16177))
																					{	/* Eval/evaluate_comp.scm 667 */
																						obj_t BgL_arg1707z00_16178;

																						BgL_arg1707z00_16178 =
																							PROCEDURE_ATTR(BgL_rz00_16177);
																						if (STRUCTP(BgL_arg1707z00_16178))
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_test6339z00_22394 =
																									(STRUCT_KEY
																									(BgL_arg1707z00_16178) ==
																									BGl_symbol5794z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_test6339z00_22394 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						BgL_test6339z00_22394 =
																							((bool_t) 0);
																					}
																				if (BgL_test6339z00_22394)
																					{
																						obj_t BgL_fz00_22402;

																						BgL_fz00_22402 = BgL_rz00_16177;
																						BgL_fz00_16176 = BgL_fz00_22402;
																						goto BgL_recz00_16175;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						VECTOR_SET(BgL_nsz00_16170,
																							((long) 0),
																							BgL_savedzd2bpzd2_16174);
																						BgL_____rz00_16173 = BgL_rz00_16177;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_16172);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16169,
																	BgL_sz00_13781);
																return BgL_____rz00_16173;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_16137,
												(int) (((long) 3))))
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_nbpz00_16179;

												BgL_nbpz00_16179 =
													((long) CINT(BgL_bpz00_16136) + BgL_siza7eza7_13780);
												VECTOR_SET(
													((obj_t) BgL_sz00_13781), ((long) 0),
													BINT(BgL_nbpz00_16179));
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_tmpz00_22414;

													BgL_tmpz00_22414 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_22414,
														BgL_locz00_13778);
												}
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_rz00_16180;

													BgL_rz00_16180 =
														PROCEDURE_ENTRY(BgL_fz00_16137) (BgL_fz00_16137,
														BgL_a1z00_16138, BgL_a2z00_16139, BgL_a3z00_16140,
														BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13781), ((long) 0),
														BgL_bpz00_16136);
													return BgL_rz00_16180;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13778,
													BgL_symbzd2funzd2_13779, (int) (((long) 3)),
													PROCEDURE_ARITY(BgL_fz00_16137));
		}}}}}}}}

	}



/* &<@anonymous:2331> */
	obj_t BGl_z62zc3z04anonymousza32331ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13782, obj_t BgL_sz00_13790)
	{
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_13783;
				obj_t BgL_a1z00_13784;
				obj_t BgL_a2z00_13785;
				obj_t BgL_a3z00_13786;
				obj_t BgL_locz00_13787;
				obj_t BgL_symbzd2funzd2_13788;
				long BgL_siza7eza7_13789;

				BgL_funz00_13783 = PROCEDURE_REF(BgL_envz00_13782, (int) (((long) 0)));
				BgL_a1z00_13784 = PROCEDURE_REF(BgL_envz00_13782, (int) (((long) 1)));
				BgL_a2z00_13785 = PROCEDURE_REF(BgL_envz00_13782, (int) (((long) 2)));
				BgL_a3z00_13786 = PROCEDURE_REF(BgL_envz00_13782, (int) (((long) 3)));
				BgL_locz00_13787 = PROCEDURE_REF(BgL_envz00_13782, (int) (((long) 4)));
				BgL_symbzd2funzd2_13788 =
					PROCEDURE_REF(BgL_envz00_13782, (int) (((long) 5)));
				BgL_siza7eza7_13789 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13782, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_16181;

					BgL_bpz00_16181 = VECTOR_REF(((obj_t) BgL_sz00_13790), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_fz00_16182;
						obj_t BgL_a1z00_16183;
						obj_t BgL_a2z00_16184;
						obj_t BgL_a3z00_16185;

						BgL_fz00_16182 =
							PROCEDURE_ENTRY(BgL_funz00_13783) (BgL_funz00_13783,
							BgL_sz00_13790, BEOA);
						BgL_a1z00_16183 =
							PROCEDURE_ENTRY(BgL_a1z00_13784) (BgL_a1z00_13784, BgL_sz00_13790,
							BEOA);
						BgL_a2z00_16184 =
							PROCEDURE_ENTRY(BgL_a2z00_13785) (BgL_a2z00_13785, BgL_sz00_13790,
							BEOA);
						BgL_a3z00_16185 =
							PROCEDURE_ENTRY(BgL_a3z00_13786) (BgL_a3z00_13786, BgL_sz00_13790,
							BEOA);
						if (PROCEDUREP(BgL_fz00_16182))
							{	/* Eval/evaluate_comp.scm 889 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13787,
									BGl_string5798z00zz__evaluate_compz00,
									BGl_string5814z00zz__evaluate_compz00, BgL_fz00_16182);
							}
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_ufz00_16186;

							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_tmpz00_22464;

								BgL_tmpz00_22464 = ((obj_t) BgL_fz00_16182);
								BgL_ufz00_16186 = PROCEDURE_ATTR(BgL_tmpz00_22464);
							}
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_test6344z00_22467;

								if (STRUCTP(BgL_ufz00_16186))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6344z00_22467 =
											(STRUCT_KEY(BgL_ufz00_16186) ==
											BGl_symbol5815z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6344z00_22467 = ((bool_t) 0);
									}
								if (BgL_test6344z00_22467)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_arityz00_16187;
										obj_t BgL_runz00_16188;
										obj_t BgL_sfz00_16189;

										BgL_arityz00_16187 =
											STRUCT_REF(BgL_ufz00_16186, (int) (((long) 0)));
										BgL_runz00_16188 =
											STRUCT_REF(BgL_ufz00_16186, (int) (((long) 1)));
										BgL_sfz00_16189 =
											STRUCT_REF(BgL_ufz00_16186, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 889 */
											long BgL_spz00_16190;

											BgL_spz00_16190 =
												((long) CINT(BgL_bpz00_16181) + BgL_siza7eza7_13789);
											if (((long) CINT(BgL_arityz00_16187) == ((long) 3)))
												{	/* Eval/evaluate_comp.scm 889 */
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2335z00_16191;

														BgL_arg2335z00_16191 =
															(BgL_spz00_16190 + ((long) 0));
														VECTOR_SET(
															((obj_t) BgL_sz00_13790), BgL_arg2335z00_16191,
															BgL_a1z00_16183);
													}
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2337z00_16192;

														BgL_arg2337z00_16192 =
															(BgL_spz00_16190 + ((long) 1));
														VECTOR_SET(
															((obj_t) BgL_sz00_13790), BgL_arg2337z00_16192,
															BgL_a2z00_16184);
													}
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2338z00_16193;

														BgL_arg2338z00_16193 =
															(BgL_spz00_16190 + ((long) 2));
														VECTOR_SET(
															((obj_t) BgL_sz00_13790), BgL_arg2338z00_16193,
															BgL_a3z00_16185);
												}}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													if (INTEGERP(BgL_arityz00_16187))
														{	/* Eval/evaluate_comp.scm 889 */
															switch ((long) CINT(BgL_arityz00_16187))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2340z00_16194;
																		obj_t BgL_arg2341z00_16195;

																		BgL_arg2340z00_16194 =
																			(BgL_spz00_16190 + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2342z00_16196;

																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_arg2343z00_16197;

																				{	/* Eval/evaluate_comp.scm 889 */
																					obj_t BgL_arg2344z00_16198;

																					BgL_arg2344z00_16198 =
																						MAKE_YOUNG_PAIR(BgL_a3z00_16185,
																						BNIL);
																					BgL_arg2343z00_16197 =
																						MAKE_YOUNG_PAIR(BgL_a2z00_16184,
																						BgL_arg2344z00_16198);
																				}
																				BgL_list2342z00_16196 =
																					MAKE_YOUNG_PAIR(BgL_a1z00_16183,
																					BgL_arg2343z00_16197);
																			}
																			BgL_arg2341z00_16195 =
																				BgL_list2342z00_16196;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13790),
																			BgL_arg2340z00_16194,
																			BgL_arg2341z00_16195);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2345z00_16199;

																		BgL_arg2345z00_16199 =
																			(BgL_spz00_16190 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13790),
																			BgL_arg2345z00_16199, BgL_a1z00_16183);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2346z00_16200;
																		obj_t BgL_arg2347z00_16201;

																		BgL_arg2346z00_16200 =
																			(BgL_spz00_16190 + ((long) 1));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2348z00_16202;

																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_arg2349z00_16203;

																				BgL_arg2349z00_16203 =
																					MAKE_YOUNG_PAIR(BgL_a3z00_16185,
																					BNIL);
																				BgL_list2348z00_16202 =
																					MAKE_YOUNG_PAIR(BgL_a2z00_16184,
																					BgL_arg2349z00_16203);
																			}
																			BgL_arg2347z00_16201 =
																				BgL_list2348z00_16202;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13790),
																			BgL_arg2346z00_16200,
																			BgL_arg2347z00_16201);
																	} break;
																case ((long) -3):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2350z00_16204;

																		BgL_arg2350z00_16204 =
																			(BgL_spz00_16190 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13790),
																			BgL_arg2350z00_16204, BgL_a1z00_16183);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2351z00_16205;

																		BgL_arg2351z00_16205 =
																			(BgL_spz00_16190 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13790),
																			BgL_arg2351z00_16205, BgL_a2z00_16184);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2353z00_16206;
																		obj_t BgL_arg2354z00_16207;

																		BgL_arg2353z00_16206 =
																			(BgL_spz00_16190 + ((long) 2));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2355z00_16208;

																			BgL_list2355z00_16208 =
																				MAKE_YOUNG_PAIR(BgL_a3z00_16185, BNIL);
																			BgL_arg2354z00_16207 =
																				BgL_list2355z00_16208;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13790),
																			BgL_arg2353z00_16206,
																			BgL_arg2354z00_16207);
																	} break;
																case ((long) -4):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2356z00_16209;

																		BgL_arg2356z00_16209 =
																			(BgL_spz00_16190 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13790),
																			BgL_arg2356z00_16209, BgL_a1z00_16183);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2357z00_16210;

																		BgL_arg2357z00_16210 =
																			(BgL_spz00_16190 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13790),
																			BgL_arg2357z00_16210, BgL_a2z00_16184);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2358z00_16211;

																		BgL_arg2358z00_16211 =
																			(BgL_spz00_16190 + ((long) 2));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13790),
																			BgL_arg2358z00_16211, BgL_a3z00_16185);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2360z00_16212;
																		obj_t BgL_arg2361z00_16213;

																		BgL_arg2360z00_16212 =
																			(BgL_spz00_16190 + ((long) 3));
																		BgL_arg2361z00_16213 = BNIL;
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13790),
																			BgL_arg2360z00_16212,
																			BgL_arg2361z00_16213);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_13787,
																		STRUCT_REF(BgL_ufz00_16186,
																			(int) (((long) 3))), (int) (((long) 3)),
																		CINT(BgL_arityz00_16187));
														}}
													else
														{	/* Eval/evaluate_comp.scm 889 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_13787, STRUCT_REF(BgL_ufz00_16186,
																	(int) (((long) 3))), (int) (((long) 3)),
																CINT(BgL_arityz00_16187));
												}}
											{	/* Eval/evaluate_comp.scm 889 */
												obj_t BgL_z12denvz12_16214;

												BgL_z12denvz12_16214 = BGL_CURRENT_DYNAMIC_ENV();
												if (
													((BgL_spz00_16190 +
															(long) CINT(BgL_sfz00_16189)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13790))))
													{	/* Eval/evaluate_comp.scm 889 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_16188, BgL_sz00_13790,
															BINT(BgL_spz00_16190));
													}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_nsz00_16215;

														BgL_nsz00_16215 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 889 */
															long BgL_arg2365z00_16216;

															BgL_arg2365z00_16216 =
																(BgL_spz00_16190 + ((long) 3));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_16215, ((long) 2), BgL_sz00_13790,
																BINT(BgL_spz00_16190),
																BINT(BgL_arg2365z00_16216));
														}
														VECTOR_SET(BgL_nsz00_16215, ((long) 1),
															BgL_sz00_13790);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16214,
															BgL_nsz00_16215);
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_ez00_16217;

															BgL_ez00_16217 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_16217, BgL_sz00_13790);
															{	/* Eval/evaluate_comp.scm 889 */
																obj_t BgL_____rz00_16218;

																{	/* Eval/evaluate_comp.scm 663 */
																	obj_t BgL_savedzd2bpzd2_16219;

																	BgL_savedzd2bpzd2_16219 =
																		VECTOR_REF(BgL_nsz00_16215, ((long) 0));
																	VECTOR_SET(BgL_nsz00_16215, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_16221;

																		BgL_fz00_16221 = BgL_runz00_16188;
																	BgL_recz00_16220:
																		{	/* Eval/evaluate_comp.scm 666 */
																			obj_t BgL_rz00_16222;

																			BgL_rz00_16222 =
																				PROCEDURE_ENTRY(BgL_fz00_16221)
																				(BgL_fz00_16221, BgL_nsz00_16215, BEOA);
																			{	/* Eval/evaluate_comp.scm 667 */
																				bool_t BgL_test6349z00_22567;

																				if (PROCEDUREP(BgL_rz00_16222))
																					{	/* Eval/evaluate_comp.scm 667 */
																						obj_t BgL_arg1707z00_16223;

																						BgL_arg1707z00_16223 =
																							PROCEDURE_ATTR(BgL_rz00_16222);
																						if (STRUCTP(BgL_arg1707z00_16223))
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_test6349z00_22567 =
																									(STRUCT_KEY
																									(BgL_arg1707z00_16223) ==
																									BGl_symbol5794z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_test6349z00_22567 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						BgL_test6349z00_22567 =
																							((bool_t) 0);
																					}
																				if (BgL_test6349z00_22567)
																					{
																						obj_t BgL_fz00_22575;

																						BgL_fz00_22575 = BgL_rz00_16222;
																						BgL_fz00_16221 = BgL_fz00_22575;
																						goto BgL_recz00_16220;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						VECTOR_SET(BgL_nsz00_16215,
																							((long) 0),
																							BgL_savedzd2bpzd2_16219);
																						BgL_____rz00_16218 = BgL_rz00_16222;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_16217);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16214,
																	BgL_sz00_13790);
																return BgL_____rz00_16218;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_16182,
												(int) (((long) 3))))
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_nbpz00_16224;

												BgL_nbpz00_16224 =
													((long) CINT(BgL_bpz00_16181) + BgL_siza7eza7_13789);
												VECTOR_SET(
													((obj_t) BgL_sz00_13790), ((long) 0),
													BINT(BgL_nbpz00_16224));
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_rz00_16225;

													BgL_rz00_16225 =
														PROCEDURE_ENTRY(BgL_fz00_16182) (BgL_fz00_16182,
														BgL_a1z00_16183, BgL_a2z00_16184, BgL_a3z00_16185,
														BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13790), ((long) 0),
														BgL_bpz00_16181);
													return BgL_rz00_16225;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13787,
													BgL_symbzd2funzd2_13788, (int) (((long) 3)),
													PROCEDURE_ARITY(BgL_fz00_16182));
		}}}}}}}}

	}



/* comp-call4 */
	obj_t BGl_compzd2call4zd2zz__evaluate_compz00(obj_t BgL_locz00_172,
		BgL_ev_exprz00_bglt BgL_vfunz00_173, obj_t BgL_symbzd2funzd2_174,
		obj_t BgL_funz00_175, obj_t BgL_tailzf3zf3_176, obj_t BgL_stkz00_177,
		long BgL_siza7eza7_178, obj_t BgL_a1z00_179, obj_t BgL_a2z00_180,
		obj_t BgL_a3z00_181, obj_t BgL_a4z00_182)
	{
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_cfunz00_2729;

				BgL_cfunz00_2729 =
					BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_173,
					((long) 4), BgL_locz00_172, BgL_symbzd2funzd2_174);
				if (CBOOL(BgL_cfunz00_2729))
					{	/* Eval/evaluate_comp.scm 889 */
						bool_t BgL_test6354z00_22601;

						{	/* Eval/evaluate_comp.scm 889 */
							int BgL_arg2374z00_2751;

							BgL_arg2374z00_2751 = bgl_debug();
							BgL_test6354z00_22601 =
								BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2374z00_2751),
								BINT(((long) 0)));
						}
						if (BgL_test6354z00_22601)
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_zc3z04anonymousza32371ze3z87_13791;

								BgL_zc3z04anonymousza32371ze3z87_13791 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza32371ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_zc3z04anonymousza32371ze3z87_13791,
									(int) (((long) 0)), BgL_a1z00_179);
								PROCEDURE_SET(BgL_zc3z04anonymousza32371ze3z87_13791,
									(int) (((long) 1)), BgL_a2z00_180);
								PROCEDURE_SET(BgL_zc3z04anonymousza32371ze3z87_13791,
									(int) (((long) 2)), BgL_a3z00_181);
								PROCEDURE_SET(BgL_zc3z04anonymousza32371ze3z87_13791,
									(int) (((long) 3)), BgL_a4z00_182);
								PROCEDURE_SET(BgL_zc3z04anonymousza32371ze3z87_13791,
									(int) (((long) 4)), BINT(BgL_siza7eza7_178));
								PROCEDURE_SET(BgL_zc3z04anonymousza32371ze3z87_13791,
									(int) (((long) 5)), BgL_locz00_172);
								PROCEDURE_SET(BgL_zc3z04anonymousza32371ze3z87_13791,
									(int) (((long) 6)), BgL_cfunz00_2729);
								return BgL_zc3z04anonymousza32371ze3z87_13791;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_zc3z04anonymousza32373ze3z87_13792;

								BgL_zc3z04anonymousza32373ze3z87_13792 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza32373ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_zc3z04anonymousza32373ze3z87_13792,
									(int) (((long) 0)), BgL_a1z00_179);
								PROCEDURE_SET(BgL_zc3z04anonymousza32373ze3z87_13792,
									(int) (((long) 1)), BgL_a2z00_180);
								PROCEDURE_SET(BgL_zc3z04anonymousza32373ze3z87_13792,
									(int) (((long) 2)), BgL_a3z00_181);
								PROCEDURE_SET(BgL_zc3z04anonymousza32373ze3z87_13792,
									(int) (((long) 3)), BgL_a4z00_182);
								PROCEDURE_SET(BgL_zc3z04anonymousza32373ze3z87_13792,
									(int) (((long) 4)), BINT(BgL_siza7eza7_178));
								PROCEDURE_SET(BgL_zc3z04anonymousza32373ze3z87_13792,
									(int) (((long) 5)), BgL_cfunz00_2729);
								return BgL_zc3z04anonymousza32373ze3z87_13792;
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 889 */
						if (CBOOL(BgL_tailzf3zf3_176))
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_test6356z00_22642;

								{	/* Eval/evaluate_comp.scm 889 */
									int BgL_arg2482z00_2887;

									BgL_arg2482z00_2887 = bgl_debug();
									BgL_test6356z00_22642 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2482z00_2887),
										BINT(((long) 0)));
								}
								if (BgL_test6356z00_22642)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3z04anonymousza32377ze3z87_13793;

										BgL_zc3z04anonymousza32377ze3z87_13793 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32377ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 8)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32377ze3z87_13793,
											(int) (((long) 0)), BgL_funz00_175);
										PROCEDURE_SET(BgL_zc3z04anonymousza32377ze3z87_13793,
											(int) (((long) 1)), BgL_a1z00_179);
										PROCEDURE_SET(BgL_zc3z04anonymousza32377ze3z87_13793,
											(int) (((long) 2)), BgL_a2z00_180);
										PROCEDURE_SET(BgL_zc3z04anonymousza32377ze3z87_13793,
											(int) (((long) 3)), BgL_a3z00_181);
										PROCEDURE_SET(BgL_zc3z04anonymousza32377ze3z87_13793,
											(int) (((long) 4)), BgL_a4z00_182);
										PROCEDURE_SET(BgL_zc3z04anonymousza32377ze3z87_13793,
											(int) (((long) 5)), BgL_locz00_172);
										PROCEDURE_SET(BgL_zc3z04anonymousza32377ze3z87_13793,
											(int) (((long) 6)), BgL_symbzd2funzd2_174);
										PROCEDURE_SET(BgL_zc3z04anonymousza32377ze3z87_13793,
											(int) (((long) 7)), BINT(BgL_siza7eza7_178));
										return BgL_zc3z04anonymousza32377ze3z87_13793;
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3z04anonymousza32430ze3z87_13794;

										BgL_zc3z04anonymousza32430ze3z87_13794 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32430ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 8)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32430ze3z87_13794,
											(int) (((long) 0)), BgL_funz00_175);
										PROCEDURE_SET(BgL_zc3z04anonymousza32430ze3z87_13794,
											(int) (((long) 1)), BgL_a1z00_179);
										PROCEDURE_SET(BgL_zc3z04anonymousza32430ze3z87_13794,
											(int) (((long) 2)), BgL_a2z00_180);
										PROCEDURE_SET(BgL_zc3z04anonymousza32430ze3z87_13794,
											(int) (((long) 3)), BgL_a3z00_181);
										PROCEDURE_SET(BgL_zc3z04anonymousza32430ze3z87_13794,
											(int) (((long) 4)), BgL_a4z00_182);
										PROCEDURE_SET(BgL_zc3z04anonymousza32430ze3z87_13794,
											(int) (((long) 5)), BgL_locz00_172);
										PROCEDURE_SET(BgL_zc3z04anonymousza32430ze3z87_13794,
											(int) (((long) 6)), BgL_symbzd2funzd2_174);
										PROCEDURE_SET(BgL_zc3z04anonymousza32430ze3z87_13794,
											(int) (((long) 7)), BINT(BgL_siza7eza7_178));
										return BgL_zc3z04anonymousza32430ze3z87_13794;
									}
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_test6357z00_22687;

								{	/* Eval/evaluate_comp.scm 889 */
									int BgL_arg2608z00_3023;

									BgL_arg2608z00_3023 = bgl_debug();
									BgL_test6357z00_22687 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2608z00_3023),
										BINT(((long) 0)));
								}
								if (BgL_test6357z00_22687)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3z04anonymousza32486ze3z87_13795;

										BgL_zc3z04anonymousza32486ze3z87_13795 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32486ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 8)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32486ze3z87_13795,
											(int) (((long) 0)), BgL_funz00_175);
										PROCEDURE_SET(BgL_zc3z04anonymousza32486ze3z87_13795,
											(int) (((long) 1)), BgL_a1z00_179);
										PROCEDURE_SET(BgL_zc3z04anonymousza32486ze3z87_13795,
											(int) (((long) 2)), BgL_a2z00_180);
										PROCEDURE_SET(BgL_zc3z04anonymousza32486ze3z87_13795,
											(int) (((long) 3)), BgL_a3z00_181);
										PROCEDURE_SET(BgL_zc3z04anonymousza32486ze3z87_13795,
											(int) (((long) 4)), BgL_a4z00_182);
										PROCEDURE_SET(BgL_zc3z04anonymousza32486ze3z87_13795,
											(int) (((long) 5)), BgL_locz00_172);
										PROCEDURE_SET(BgL_zc3z04anonymousza32486ze3z87_13795,
											(int) (((long) 6)), BgL_symbzd2funzd2_174);
										PROCEDURE_SET(BgL_zc3z04anonymousza32486ze3z87_13795,
											(int) (((long) 7)), BINT(BgL_siza7eza7_178));
										return BgL_zc3z04anonymousza32486ze3z87_13795;
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3z04anonymousza32550ze3z87_13796;

										BgL_zc3z04anonymousza32550ze3z87_13796 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32550ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 8)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32550ze3z87_13796,
											(int) (((long) 0)), BgL_funz00_175);
										PROCEDURE_SET(BgL_zc3z04anonymousza32550ze3z87_13796,
											(int) (((long) 1)), BgL_a1z00_179);
										PROCEDURE_SET(BgL_zc3z04anonymousza32550ze3z87_13796,
											(int) (((long) 2)), BgL_a2z00_180);
										PROCEDURE_SET(BgL_zc3z04anonymousza32550ze3z87_13796,
											(int) (((long) 3)), BgL_a3z00_181);
										PROCEDURE_SET(BgL_zc3z04anonymousza32550ze3z87_13796,
											(int) (((long) 4)), BgL_a4z00_182);
										PROCEDURE_SET(BgL_zc3z04anonymousza32550ze3z87_13796,
											(int) (((long) 5)), BgL_locz00_172);
										PROCEDURE_SET(BgL_zc3z04anonymousza32550ze3z87_13796,
											(int) (((long) 6)), BgL_symbzd2funzd2_174);
										PROCEDURE_SET(BgL_zc3z04anonymousza32550ze3z87_13796,
											(int) (((long) 7)), BINT(BgL_siza7eza7_178));
										return BgL_zc3z04anonymousza32550ze3z87_13796;
									}
							}
					}
			}
		}

	}



/* &<@anonymous:2371> */
	obj_t BGl_z62zc3z04anonymousza32371ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13797, obj_t BgL_sz00_13805)
	{
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_a1z00_13798;
				obj_t BgL_a2z00_13799;
				obj_t BgL_a3z00_13800;
				obj_t BgL_a4z00_13801;
				long BgL_siza7eza7_13802;
				obj_t BgL_locz00_13803;
				obj_t BgL_cfunz00_13804;

				BgL_a1z00_13798 = PROCEDURE_REF(BgL_envz00_13797, (int) (((long) 0)));
				BgL_a2z00_13799 = PROCEDURE_REF(BgL_envz00_13797, (int) (((long) 1)));
				BgL_a3z00_13800 = PROCEDURE_REF(BgL_envz00_13797, (int) (((long) 2)));
				BgL_a4z00_13801 = PROCEDURE_REF(BgL_envz00_13797, (int) (((long) 3)));
				BgL_siza7eza7_13802 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13797, (int) (((long) 4))));
				BgL_locz00_13803 = PROCEDURE_REF(BgL_envz00_13797, (int) (((long) 5)));
				BgL_cfunz00_13804 = PROCEDURE_REF(BgL_envz00_13797, (int) (((long) 6)));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_16226;

					BgL_bpz00_16226 = VECTOR_REF(((obj_t) BgL_sz00_13805), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_a1z00_16227;
						obj_t BgL_a2z00_16228;
						obj_t BgL_a3z00_16229;
						obj_t BgL_a4z00_16230;

						BgL_a1z00_16227 =
							PROCEDURE_ENTRY(BgL_a1z00_13798) (BgL_a1z00_13798, BgL_sz00_13805,
							BEOA);
						BgL_a2z00_16228 =
							PROCEDURE_ENTRY(BgL_a2z00_13799) (BgL_a2z00_13799, BgL_sz00_13805,
							BEOA);
						BgL_a3z00_16229 =
							PROCEDURE_ENTRY(BgL_a3z00_13800) (BgL_a3z00_13800, BgL_sz00_13805,
							BEOA);
						BgL_a4z00_16230 =
							PROCEDURE_ENTRY(BgL_a4z00_13801) (BgL_a4z00_13801, BgL_sz00_13805,
							BEOA);
						{	/* Eval/evaluate_comp.scm 889 */
							long BgL_nbpz00_16231;

							BgL_nbpz00_16231 =
								((long) CINT(BgL_bpz00_16226) + BgL_siza7eza7_13802);
							VECTOR_SET(
								((obj_t) BgL_sz00_13805), ((long) 0), BINT(BgL_nbpz00_16231));
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_tmpz00_22770;

								BgL_tmpz00_22770 = BGL_CURRENT_DYNAMIC_ENV();
								BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_22770, BgL_locz00_13803);
							}
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_rz00_16232;

								BgL_rz00_16232 =
									PROCEDURE_ENTRY(BgL_cfunz00_13804) (BgL_cfunz00_13804,
									BgL_a1z00_16227, BgL_a2z00_16228, BgL_a3z00_16229,
									BgL_a4z00_16230, BEOA);
								VECTOR_SET(((obj_t) BgL_sz00_13805), ((long) 0),
									BgL_bpz00_16226);
								return BgL_rz00_16232;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:2373> */
	obj_t BGl_z62zc3z04anonymousza32373ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13806, obj_t BgL_sz00_13813)
	{
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_a1z00_13807;
				obj_t BgL_a2z00_13808;
				obj_t BgL_a3z00_13809;
				obj_t BgL_a4z00_13810;
				long BgL_siza7eza7_13811;
				obj_t BgL_cfunz00_13812;

				BgL_a1z00_13807 = PROCEDURE_REF(BgL_envz00_13806, (int) (((long) 0)));
				BgL_a2z00_13808 = PROCEDURE_REF(BgL_envz00_13806, (int) (((long) 1)));
				BgL_a3z00_13809 = PROCEDURE_REF(BgL_envz00_13806, (int) (((long) 2)));
				BgL_a4z00_13810 = PROCEDURE_REF(BgL_envz00_13806, (int) (((long) 3)));
				BgL_siza7eza7_13811 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13806, (int) (((long) 4))));
				BgL_cfunz00_13812 = PROCEDURE_REF(BgL_envz00_13806, (int) (((long) 5)));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_16233;

					BgL_bpz00_16233 = VECTOR_REF(((obj_t) BgL_sz00_13813), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_a1z00_16234;
						obj_t BgL_a2z00_16235;
						obj_t BgL_a3z00_16236;
						obj_t BgL_a4z00_16237;

						BgL_a1z00_16234 =
							PROCEDURE_ENTRY(BgL_a1z00_13807) (BgL_a1z00_13807, BgL_sz00_13813,
							BEOA);
						BgL_a2z00_16235 =
							PROCEDURE_ENTRY(BgL_a2z00_13808) (BgL_a2z00_13808, BgL_sz00_13813,
							BEOA);
						BgL_a3z00_16236 =
							PROCEDURE_ENTRY(BgL_a3z00_13809) (BgL_a3z00_13809, BgL_sz00_13813,
							BEOA);
						BgL_a4z00_16237 =
							PROCEDURE_ENTRY(BgL_a4z00_13810) (BgL_a4z00_13810, BgL_sz00_13813,
							BEOA);
						{	/* Eval/evaluate_comp.scm 889 */
							long BgL_nbpz00_16238;

							BgL_nbpz00_16238 =
								((long) CINT(BgL_bpz00_16233) + BgL_siza7eza7_13811);
							VECTOR_SET(
								((obj_t) BgL_sz00_13813), ((long) 0), BINT(BgL_nbpz00_16238));
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_rz00_16239;

								BgL_rz00_16239 =
									PROCEDURE_ENTRY(BgL_cfunz00_13812) (BgL_cfunz00_13812,
									BgL_a1z00_16234, BgL_a2z00_16235, BgL_a3z00_16236,
									BgL_a4z00_16237, BEOA);
								VECTOR_SET(((obj_t) BgL_sz00_13813), ((long) 0),
									BgL_bpz00_16233);
								return BgL_rz00_16239;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:2377> */
	obj_t BGl_z62zc3z04anonymousza32377ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13814, obj_t BgL_sz00_13823)
	{
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_13815;
				obj_t BgL_a1z00_13816;
				obj_t BgL_a2z00_13817;
				obj_t BgL_a3z00_13818;
				obj_t BgL_a4z00_13819;
				obj_t BgL_locz00_13820;
				obj_t BgL_symbzd2funzd2_13821;
				long BgL_siza7eza7_13822;

				BgL_funz00_13815 = PROCEDURE_REF(BgL_envz00_13814, (int) (((long) 0)));
				BgL_a1z00_13816 = PROCEDURE_REF(BgL_envz00_13814, (int) (((long) 1)));
				BgL_a2z00_13817 = PROCEDURE_REF(BgL_envz00_13814, (int) (((long) 2)));
				BgL_a3z00_13818 = PROCEDURE_REF(BgL_envz00_13814, (int) (((long) 3)));
				BgL_a4z00_13819 = PROCEDURE_REF(BgL_envz00_13814, (int) (((long) 4)));
				BgL_locz00_13820 = PROCEDURE_REF(BgL_envz00_13814, (int) (((long) 5)));
				BgL_symbzd2funzd2_13821 =
					PROCEDURE_REF(BgL_envz00_13814, (int) (((long) 6)));
				BgL_siza7eza7_13822 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13814, (int) (((long) 7))));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_16240;

					BgL_bpz00_16240 = VECTOR_REF(((obj_t) BgL_sz00_13823), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_fz00_16241;
						obj_t BgL_a1z00_16242;
						obj_t BgL_a2z00_16243;
						obj_t BgL_a3z00_16244;
						obj_t BgL_a4z00_16245;

						BgL_fz00_16241 =
							PROCEDURE_ENTRY(BgL_funz00_13815) (BgL_funz00_13815,
							BgL_sz00_13823, BEOA);
						BgL_a1z00_16242 =
							PROCEDURE_ENTRY(BgL_a1z00_13816) (BgL_a1z00_13816, BgL_sz00_13823,
							BEOA);
						BgL_a2z00_16243 =
							PROCEDURE_ENTRY(BgL_a2z00_13817) (BgL_a2z00_13817, BgL_sz00_13823,
							BEOA);
						BgL_a3z00_16244 =
							PROCEDURE_ENTRY(BgL_a3z00_13818) (BgL_a3z00_13818, BgL_sz00_13823,
							BEOA);
						BgL_a4z00_16245 =
							PROCEDURE_ENTRY(BgL_a4z00_13819) (BgL_a4z00_13819, BgL_sz00_13823,
							BEOA);
						if (PROCEDUREP(BgL_fz00_16241))
							{	/* Eval/evaluate_comp.scm 889 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13820,
									BGl_string5798z00zz__evaluate_compz00,
									BGl_string5814z00zz__evaluate_compz00, BgL_fz00_16241);
							}
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_ufz00_16246;

							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_tmpz00_22869;

								BgL_tmpz00_22869 = ((obj_t) BgL_fz00_16241);
								BgL_ufz00_16246 = PROCEDURE_ATTR(BgL_tmpz00_22869);
							}
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_test6359z00_22872;

								if (STRUCTP(BgL_ufz00_16246))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6359z00_22872 =
											(STRUCT_KEY(BgL_ufz00_16246) ==
											BGl_symbol5815z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6359z00_22872 = ((bool_t) 0);
									}
								if (BgL_test6359z00_22872)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_arityz00_16247;
										obj_t BgL_runz00_16248;
										obj_t BgL_sfz00_16249;

										BgL_arityz00_16247 =
											STRUCT_REF(BgL_ufz00_16246, (int) (((long) 0)));
										BgL_runz00_16248 =
											STRUCT_REF(BgL_ufz00_16246, (int) (((long) 1)));
										BgL_sfz00_16249 =
											STRUCT_REF(BgL_ufz00_16246, (int) (((long) 2)));
										if (((long) CINT(BgL_arityz00_16247) == ((long) 4)))
											{	/* Eval/evaluate_comp.scm 889 */
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_arg2381z00_16250;

													BgL_arg2381z00_16250 =
														((long) CINT(BgL_bpz00_16240) + ((long) 0));
													VECTOR_SET(
														((obj_t) BgL_sz00_13823), BgL_arg2381z00_16250,
														BgL_a1z00_16242);
												}
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_arg2382z00_16251;

													BgL_arg2382z00_16251 =
														((long) CINT(BgL_bpz00_16240) + ((long) 1));
													VECTOR_SET(
														((obj_t) BgL_sz00_13823), BgL_arg2382z00_16251,
														BgL_a2z00_16243);
												}
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_arg2383z00_16252;

													BgL_arg2383z00_16252 =
														((long) CINT(BgL_bpz00_16240) + ((long) 2));
													VECTOR_SET(
														((obj_t) BgL_sz00_13823), BgL_arg2383z00_16252,
														BgL_a3z00_16244);
												}
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_arg2385z00_16253;

													BgL_arg2385z00_16253 =
														((long) CINT(BgL_bpz00_16240) + ((long) 3));
													VECTOR_SET(
														((obj_t) BgL_sz00_13823), BgL_arg2385z00_16253,
														BgL_a4z00_16245);
											}}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												if (INTEGERP(BgL_arityz00_16247))
													{	/* Eval/evaluate_comp.scm 889 */
														switch ((long) CINT(BgL_arityz00_16247))
															{
															case ((long) -1):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2387z00_16254;
																	obj_t BgL_arg2388z00_16255;

																	BgL_arg2387z00_16254 =
																		((long) CINT(BgL_bpz00_16240) + ((long) 0));
																	{	/* Eval/evaluate_comp.scm 889 */
																		obj_t BgL_list2389z00_16256;

																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_arg2390z00_16257;

																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_arg2391z00_16258;

																				{	/* Eval/evaluate_comp.scm 889 */
																					obj_t BgL_arg2393z00_16259;

																					BgL_arg2393z00_16259 =
																						MAKE_YOUNG_PAIR(BgL_a4z00_16245,
																						BNIL);
																					BgL_arg2391z00_16258 =
																						MAKE_YOUNG_PAIR(BgL_a3z00_16244,
																						BgL_arg2393z00_16259);
																				}
																				BgL_arg2390z00_16257 =
																					MAKE_YOUNG_PAIR(BgL_a2z00_16243,
																					BgL_arg2391z00_16258);
																			}
																			BgL_list2389z00_16256 =
																				MAKE_YOUNG_PAIR(BgL_a1z00_16242,
																				BgL_arg2390z00_16257);
																		}
																		BgL_arg2388z00_16255 =
																			BgL_list2389z00_16256;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13823),
																		BgL_arg2387z00_16254, BgL_arg2388z00_16255);
																} break;
															case ((long) -2):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2394z00_16260;

																	BgL_arg2394z00_16260 =
																		((long) CINT(BgL_bpz00_16240) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13823),
																		BgL_arg2394z00_16260, BgL_a1z00_16242);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2395z00_16261;
																	obj_t BgL_arg2396z00_16262;

																	BgL_arg2395z00_16261 =
																		((long) CINT(BgL_bpz00_16240) + ((long) 1));
																	{	/* Eval/evaluate_comp.scm 889 */
																		obj_t BgL_list2397z00_16263;

																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_arg2399z00_16264;

																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_arg2400z00_16265;

																				BgL_arg2400z00_16265 =
																					MAKE_YOUNG_PAIR(BgL_a4z00_16245,
																					BNIL);
																				BgL_arg2399z00_16264 =
																					MAKE_YOUNG_PAIR(BgL_a3z00_16244,
																					BgL_arg2400z00_16265);
																			}
																			BgL_list2397z00_16263 =
																				MAKE_YOUNG_PAIR(BgL_a2z00_16243,
																				BgL_arg2399z00_16264);
																		}
																		BgL_arg2396z00_16262 =
																			BgL_list2397z00_16263;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13823),
																		BgL_arg2395z00_16261, BgL_arg2396z00_16262);
																} break;
															case ((long) -3):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2401z00_16266;

																	BgL_arg2401z00_16266 =
																		((long) CINT(BgL_bpz00_16240) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13823),
																		BgL_arg2401z00_16266, BgL_a1z00_16242);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2402z00_16267;

																	BgL_arg2402z00_16267 =
																		((long) CINT(BgL_bpz00_16240) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13823),
																		BgL_arg2402z00_16267, BgL_a2z00_16243);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2403z00_16268;
																	obj_t BgL_arg2404z00_16269;

																	BgL_arg2403z00_16268 =
																		((long) CINT(BgL_bpz00_16240) + ((long) 2));
																	{	/* Eval/evaluate_comp.scm 889 */
																		obj_t BgL_list2405z00_16270;

																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_arg2407z00_16271;

																			BgL_arg2407z00_16271 =
																				MAKE_YOUNG_PAIR(BgL_a4z00_16245, BNIL);
																			BgL_list2405z00_16270 =
																				MAKE_YOUNG_PAIR(BgL_a3z00_16244,
																				BgL_arg2407z00_16271);
																		}
																		BgL_arg2404z00_16269 =
																			BgL_list2405z00_16270;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13823),
																		BgL_arg2403z00_16268, BgL_arg2404z00_16269);
																} break;
															case ((long) -4):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2408z00_16272;

																	BgL_arg2408z00_16272 =
																		((long) CINT(BgL_bpz00_16240) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13823),
																		BgL_arg2408z00_16272, BgL_a1z00_16242);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2409z00_16273;

																	BgL_arg2409z00_16273 =
																		((long) CINT(BgL_bpz00_16240) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13823),
																		BgL_arg2409z00_16273, BgL_a2z00_16243);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2410z00_16274;

																	BgL_arg2410z00_16274 =
																		((long) CINT(BgL_bpz00_16240) + ((long) 2));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13823),
																		BgL_arg2410z00_16274, BgL_a3z00_16244);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2413z00_16275;
																	obj_t BgL_arg2414z00_16276;

																	BgL_arg2413z00_16275 =
																		((long) CINT(BgL_bpz00_16240) + ((long) 3));
																	{	/* Eval/evaluate_comp.scm 889 */
																		obj_t BgL_list2415z00_16277;

																		BgL_list2415z00_16277 =
																			MAKE_YOUNG_PAIR(BgL_a4z00_16245, BNIL);
																		BgL_arg2414z00_16276 =
																			BgL_list2415z00_16277;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13823),
																		BgL_arg2413z00_16275, BgL_arg2414z00_16276);
																} break;
															case ((long) -5):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2416z00_16278;

																	BgL_arg2416z00_16278 =
																		((long) CINT(BgL_bpz00_16240) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13823),
																		BgL_arg2416z00_16278, BgL_a1z00_16242);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2417z00_16279;

																	BgL_arg2417z00_16279 =
																		((long) CINT(BgL_bpz00_16240) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13823),
																		BgL_arg2417z00_16279, BgL_a2z00_16243);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2418z00_16280;

																	BgL_arg2418z00_16280 =
																		((long) CINT(BgL_bpz00_16240) + ((long) 2));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13823),
																		BgL_arg2418z00_16280, BgL_a3z00_16244);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2419z00_16281;

																	BgL_arg2419z00_16281 =
																		((long) CINT(BgL_bpz00_16240) + ((long) 3));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13823),
																		BgL_arg2419z00_16281, BgL_a4z00_16245);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2420z00_16282;
																	obj_t BgL_arg2421z00_16283;

																	BgL_arg2420z00_16282 =
																		((long) CINT(BgL_bpz00_16240) + ((long) 4));
																	BgL_arg2421z00_16283 = BNIL;
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13823),
																		BgL_arg2420z00_16282, BgL_arg2421z00_16283);
																} break;
															default:
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_13820, STRUCT_REF(BgL_ufz00_16246,
																		(int) (((long) 3))), (int) (((long) 4)),
																	CINT(BgL_arityz00_16247));
													}}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														BGl_evarityzd2errorzd2zz__everrorz00
															(BgL_locz00_13820, STRUCT_REF(BgL_ufz00_16246,
																(int) (((long) 3))), (int) (((long) 4)),
															CINT(BgL_arityz00_16247));
											}}
										{	/* Eval/evaluate_comp.scm 889 */
											obj_t BgL_z12denvz12_16284;

											BgL_z12denvz12_16284 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_16284,
												BgL_locz00_13820);
											if ((((long) CINT(BgL_bpz00_16240) +
														(long) CINT(BgL_sfz00_16249)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_13823))))
												{	/* Eval/evaluate_comp.scm 889 */
													return BgL_runz00_16248;
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_nsz00_16285;

													BgL_nsz00_16285 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2425z00_16286;

														BgL_arg2425z00_16286 =
															((long) CINT(BgL_bpz00_16240) + ((long) 4));
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_16285, ((long) 2), BgL_sz00_13823,
															BgL_bpz00_16240, BINT(BgL_arg2425z00_16286));
													}
													VECTOR_SET(BgL_nsz00_16285, ((long) 1),
														BgL_sz00_13823);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16284,
														BgL_nsz00_16285);
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_ez00_16287;

														BgL_ez00_16287 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_16287, BgL_sz00_13823);
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_____rz00_16288;

															{	/* Eval/evaluate_comp.scm 663 */
																obj_t BgL_savedzd2bpzd2_16289;

																BgL_savedzd2bpzd2_16289 =
																	VECTOR_REF(BgL_nsz00_16285, ((long) 0));
																VECTOR_SET(BgL_nsz00_16285, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_16291;

																	BgL_fz00_16291 = BgL_runz00_16248;
																BgL_recz00_16290:
																	{	/* Eval/evaluate_comp.scm 666 */
																		obj_t BgL_rz00_16292;

																		BgL_rz00_16292 =
																			PROCEDURE_ENTRY(BgL_fz00_16291)
																			(BgL_fz00_16291, BgL_nsz00_16285, BEOA);
																		{	/* Eval/evaluate_comp.scm 667 */
																			bool_t BgL_test6364z00_23011;

																			if (PROCEDUREP(BgL_rz00_16292))
																				{	/* Eval/evaluate_comp.scm 667 */
																					obj_t BgL_arg1707z00_16293;

																					BgL_arg1707z00_16293 =
																						PROCEDURE_ATTR(BgL_rz00_16292);
																					if (STRUCTP(BgL_arg1707z00_16293))
																						{	/* Eval/evaluate_comp.scm 647 */
																							BgL_test6364z00_23011 =
																								(STRUCT_KEY
																								(BgL_arg1707z00_16293) ==
																								BGl_symbol5794z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 647 */
																							BgL_test6364z00_23011 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 667 */
																					BgL_test6364z00_23011 = ((bool_t) 0);
																				}
																			if (BgL_test6364z00_23011)
																				{
																					obj_t BgL_fz00_23019;

																					BgL_fz00_23019 = BgL_rz00_16292;
																					BgL_fz00_16291 = BgL_fz00_23019;
																					goto BgL_recz00_16290;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 667 */
																					VECTOR_SET(BgL_nsz00_16285,
																						((long) 0),
																						BgL_savedzd2bpzd2_16289);
																					BgL_____rz00_16288 = BgL_rz00_16292;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_16287);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16284,
																BgL_sz00_13823);
															return BgL_____rz00_16288;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_16241,
												(int) (((long) 4))))
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_nbpz00_16294;

												BgL_nbpz00_16294 =
													((long) CINT(BgL_bpz00_16240) + BgL_siza7eza7_13822);
												VECTOR_SET(
													((obj_t) BgL_sz00_13823), ((long) 0),
													BINT(BgL_nbpz00_16294));
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_tmpz00_23031;

													BgL_tmpz00_23031 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_23031,
														BgL_locz00_13820);
												}
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_rz00_16295;

													BgL_rz00_16295 =
														PROCEDURE_ENTRY(BgL_fz00_16241) (BgL_fz00_16241,
														BgL_a1z00_16242, BgL_a2z00_16243, BgL_a3z00_16244,
														BgL_a4z00_16245, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13823), ((long) 0),
														BgL_bpz00_16240);
													return BgL_rz00_16295;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13820,
													BgL_symbzd2funzd2_13821, (int) (((long) 4)),
													PROCEDURE_ARITY(BgL_fz00_16241));
		}}}}}}}}

	}



/* &<@anonymous:2430> */
	obj_t BGl_z62zc3z04anonymousza32430ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13824, obj_t BgL_sz00_13833)
	{
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_13825;
				obj_t BgL_a1z00_13826;
				obj_t BgL_a2z00_13827;
				obj_t BgL_a3z00_13828;
				obj_t BgL_a4z00_13829;
				obj_t BgL_locz00_13830;
				obj_t BgL_symbzd2funzd2_13831;
				long BgL_siza7eza7_13832;

				BgL_funz00_13825 = PROCEDURE_REF(BgL_envz00_13824, (int) (((long) 0)));
				BgL_a1z00_13826 = PROCEDURE_REF(BgL_envz00_13824, (int) (((long) 1)));
				BgL_a2z00_13827 = PROCEDURE_REF(BgL_envz00_13824, (int) (((long) 2)));
				BgL_a3z00_13828 = PROCEDURE_REF(BgL_envz00_13824, (int) (((long) 3)));
				BgL_a4z00_13829 = PROCEDURE_REF(BgL_envz00_13824, (int) (((long) 4)));
				BgL_locz00_13830 = PROCEDURE_REF(BgL_envz00_13824, (int) (((long) 5)));
				BgL_symbzd2funzd2_13831 =
					PROCEDURE_REF(BgL_envz00_13824, (int) (((long) 6)));
				BgL_siza7eza7_13832 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13824, (int) (((long) 7))));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_16296;

					BgL_bpz00_16296 = VECTOR_REF(((obj_t) BgL_sz00_13833), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_fz00_16297;
						obj_t BgL_a1z00_16298;
						obj_t BgL_a2z00_16299;
						obj_t BgL_a3z00_16300;
						obj_t BgL_a4z00_16301;

						BgL_fz00_16297 =
							PROCEDURE_ENTRY(BgL_funz00_13825) (BgL_funz00_13825,
							BgL_sz00_13833, BEOA);
						BgL_a1z00_16298 =
							PROCEDURE_ENTRY(BgL_a1z00_13826) (BgL_a1z00_13826, BgL_sz00_13833,
							BEOA);
						BgL_a2z00_16299 =
							PROCEDURE_ENTRY(BgL_a2z00_13827) (BgL_a2z00_13827, BgL_sz00_13833,
							BEOA);
						BgL_a3z00_16300 =
							PROCEDURE_ENTRY(BgL_a3z00_13828) (BgL_a3z00_13828, BgL_sz00_13833,
							BEOA);
						BgL_a4z00_16301 =
							PROCEDURE_ENTRY(BgL_a4z00_13829) (BgL_a4z00_13829, BgL_sz00_13833,
							BEOA);
						if (PROCEDUREP(BgL_fz00_16297))
							{	/* Eval/evaluate_comp.scm 889 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13830,
									BGl_string5798z00zz__evaluate_compz00,
									BGl_string5814z00zz__evaluate_compz00, BgL_fz00_16297);
							}
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_ufz00_16302;

							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_tmpz00_23088;

								BgL_tmpz00_23088 = ((obj_t) BgL_fz00_16297);
								BgL_ufz00_16302 = PROCEDURE_ATTR(BgL_tmpz00_23088);
							}
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_test6369z00_23091;

								if (STRUCTP(BgL_ufz00_16302))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6369z00_23091 =
											(STRUCT_KEY(BgL_ufz00_16302) ==
											BGl_symbol5815z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6369z00_23091 = ((bool_t) 0);
									}
								if (BgL_test6369z00_23091)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_arityz00_16303;
										obj_t BgL_runz00_16304;
										obj_t BgL_sfz00_16305;

										BgL_arityz00_16303 =
											STRUCT_REF(BgL_ufz00_16302, (int) (((long) 0)));
										BgL_runz00_16304 =
											STRUCT_REF(BgL_ufz00_16302, (int) (((long) 1)));
										BgL_sfz00_16305 =
											STRUCT_REF(BgL_ufz00_16302, (int) (((long) 2)));
										if (((long) CINT(BgL_arityz00_16303) == ((long) 4)))
											{	/* Eval/evaluate_comp.scm 889 */
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_arg2434z00_16306;

													BgL_arg2434z00_16306 =
														((long) CINT(BgL_bpz00_16296) + ((long) 0));
													VECTOR_SET(
														((obj_t) BgL_sz00_13833), BgL_arg2434z00_16306,
														BgL_a1z00_16298);
												}
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_arg2435z00_16307;

													BgL_arg2435z00_16307 =
														((long) CINT(BgL_bpz00_16296) + ((long) 1));
													VECTOR_SET(
														((obj_t) BgL_sz00_13833), BgL_arg2435z00_16307,
														BgL_a2z00_16299);
												}
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_arg2436z00_16308;

													BgL_arg2436z00_16308 =
														((long) CINT(BgL_bpz00_16296) + ((long) 2));
													VECTOR_SET(
														((obj_t) BgL_sz00_13833), BgL_arg2436z00_16308,
														BgL_a3z00_16300);
												}
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_arg2437z00_16309;

													BgL_arg2437z00_16309 =
														((long) CINT(BgL_bpz00_16296) + ((long) 3));
													VECTOR_SET(
														((obj_t) BgL_sz00_13833), BgL_arg2437z00_16309,
														BgL_a4z00_16301);
											}}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												if (INTEGERP(BgL_arityz00_16303))
													{	/* Eval/evaluate_comp.scm 889 */
														switch ((long) CINT(BgL_arityz00_16303))
															{
															case ((long) -1):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2439z00_16310;
																	obj_t BgL_arg2441z00_16311;

																	BgL_arg2439z00_16310 =
																		((long) CINT(BgL_bpz00_16296) + ((long) 0));
																	{	/* Eval/evaluate_comp.scm 889 */
																		obj_t BgL_list2442z00_16312;

																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_arg2443z00_16313;

																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_arg2444z00_16314;

																				{	/* Eval/evaluate_comp.scm 889 */
																					obj_t BgL_arg2445z00_16315;

																					BgL_arg2445z00_16315 =
																						MAKE_YOUNG_PAIR(BgL_a4z00_16301,
																						BNIL);
																					BgL_arg2444z00_16314 =
																						MAKE_YOUNG_PAIR(BgL_a3z00_16300,
																						BgL_arg2445z00_16315);
																				}
																				BgL_arg2443z00_16313 =
																					MAKE_YOUNG_PAIR(BgL_a2z00_16299,
																					BgL_arg2444z00_16314);
																			}
																			BgL_list2442z00_16312 =
																				MAKE_YOUNG_PAIR(BgL_a1z00_16298,
																				BgL_arg2443z00_16313);
																		}
																		BgL_arg2441z00_16311 =
																			BgL_list2442z00_16312;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13833),
																		BgL_arg2439z00_16310, BgL_arg2441z00_16311);
																} break;
															case ((long) -2):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2447z00_16316;

																	BgL_arg2447z00_16316 =
																		((long) CINT(BgL_bpz00_16296) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13833),
																		BgL_arg2447z00_16316, BgL_a1z00_16298);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2448z00_16317;
																	obj_t BgL_arg2451z00_16318;

																	BgL_arg2448z00_16317 =
																		((long) CINT(BgL_bpz00_16296) + ((long) 1));
																	{	/* Eval/evaluate_comp.scm 889 */
																		obj_t BgL_list2452z00_16319;

																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_arg2453z00_16320;

																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_arg2454z00_16321;

																				BgL_arg2454z00_16321 =
																					MAKE_YOUNG_PAIR(BgL_a4z00_16301,
																					BNIL);
																				BgL_arg2453z00_16320 =
																					MAKE_YOUNG_PAIR(BgL_a3z00_16300,
																					BgL_arg2454z00_16321);
																			}
																			BgL_list2452z00_16319 =
																				MAKE_YOUNG_PAIR(BgL_a2z00_16299,
																				BgL_arg2453z00_16320);
																		}
																		BgL_arg2451z00_16318 =
																			BgL_list2452z00_16319;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13833),
																		BgL_arg2448z00_16317, BgL_arg2451z00_16318);
																} break;
															case ((long) -3):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2455z00_16322;

																	BgL_arg2455z00_16322 =
																		((long) CINT(BgL_bpz00_16296) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13833),
																		BgL_arg2455z00_16322, BgL_a1z00_16298);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2456z00_16323;

																	BgL_arg2456z00_16323 =
																		((long) CINT(BgL_bpz00_16296) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13833),
																		BgL_arg2456z00_16323, BgL_a2z00_16299);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2457z00_16324;
																	obj_t BgL_arg2458z00_16325;

																	BgL_arg2457z00_16324 =
																		((long) CINT(BgL_bpz00_16296) + ((long) 2));
																	{	/* Eval/evaluate_comp.scm 889 */
																		obj_t BgL_list2459z00_16326;

																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_arg2460z00_16327;

																			BgL_arg2460z00_16327 =
																				MAKE_YOUNG_PAIR(BgL_a4z00_16301, BNIL);
																			BgL_list2459z00_16326 =
																				MAKE_YOUNG_PAIR(BgL_a3z00_16300,
																				BgL_arg2460z00_16327);
																		}
																		BgL_arg2458z00_16325 =
																			BgL_list2459z00_16326;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13833),
																		BgL_arg2457z00_16324, BgL_arg2458z00_16325);
																} break;
															case ((long) -4):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2462z00_16328;

																	BgL_arg2462z00_16328 =
																		((long) CINT(BgL_bpz00_16296) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13833),
																		BgL_arg2462z00_16328, BgL_a1z00_16298);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2463z00_16329;

																	BgL_arg2463z00_16329 =
																		((long) CINT(BgL_bpz00_16296) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13833),
																		BgL_arg2463z00_16329, BgL_a2z00_16299);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2464z00_16330;

																	BgL_arg2464z00_16330 =
																		((long) CINT(BgL_bpz00_16296) + ((long) 2));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13833),
																		BgL_arg2464z00_16330, BgL_a3z00_16300);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2465z00_16331;
																	obj_t BgL_arg2466z00_16332;

																	BgL_arg2465z00_16331 =
																		((long) CINT(BgL_bpz00_16296) + ((long) 3));
																	{	/* Eval/evaluate_comp.scm 889 */
																		obj_t BgL_list2467z00_16333;

																		BgL_list2467z00_16333 =
																			MAKE_YOUNG_PAIR(BgL_a4z00_16301, BNIL);
																		BgL_arg2466z00_16332 =
																			BgL_list2467z00_16333;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13833),
																		BgL_arg2465z00_16331, BgL_arg2466z00_16332);
																} break;
															case ((long) -5):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2468z00_16334;

																	BgL_arg2468z00_16334 =
																		((long) CINT(BgL_bpz00_16296) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13833),
																		BgL_arg2468z00_16334, BgL_a1z00_16298);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2469z00_16335;

																	BgL_arg2469z00_16335 =
																		((long) CINT(BgL_bpz00_16296) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13833),
																		BgL_arg2469z00_16335, BgL_a2z00_16299);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2470z00_16336;

																	BgL_arg2470z00_16336 =
																		((long) CINT(BgL_bpz00_16296) + ((long) 2));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13833),
																		BgL_arg2470z00_16336, BgL_a3z00_16300);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2472z00_16337;

																	BgL_arg2472z00_16337 =
																		((long) CINT(BgL_bpz00_16296) + ((long) 3));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13833),
																		BgL_arg2472z00_16337, BgL_a4z00_16301);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2473z00_16338;
																	obj_t BgL_arg2474z00_16339;

																	BgL_arg2473z00_16338 =
																		((long) CINT(BgL_bpz00_16296) + ((long) 4));
																	BgL_arg2474z00_16339 = BNIL;
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13833),
																		BgL_arg2473z00_16338, BgL_arg2474z00_16339);
																} break;
															default:
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_13830, STRUCT_REF(BgL_ufz00_16302,
																		(int) (((long) 3))), (int) (((long) 4)),
																	CINT(BgL_arityz00_16303));
													}}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														BGl_evarityzd2errorzd2zz__everrorz00
															(BgL_locz00_13830, STRUCT_REF(BgL_ufz00_16302,
																(int) (((long) 3))), (int) (((long) 4)),
															CINT(BgL_arityz00_16303));
											}}
										{	/* Eval/evaluate_comp.scm 889 */
											obj_t BgL_z12denvz12_16340;

											BgL_z12denvz12_16340 = BGL_CURRENT_DYNAMIC_ENV();
											if (
												(((long) CINT(BgL_bpz00_16296) +
														(long) CINT(BgL_sfz00_16305)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_13833))))
												{	/* Eval/evaluate_comp.scm 889 */
													return BgL_runz00_16304;
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_nsz00_16341;

													BgL_nsz00_16341 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2478z00_16342;

														BgL_arg2478z00_16342 =
															((long) CINT(BgL_bpz00_16296) + ((long) 4));
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_16341, ((long) 2), BgL_sz00_13833,
															BgL_bpz00_16296, BINT(BgL_arg2478z00_16342));
													}
													VECTOR_SET(BgL_nsz00_16341, ((long) 1),
														BgL_sz00_13833);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16340,
														BgL_nsz00_16341);
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_ez00_16343;

														BgL_ez00_16343 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_16343, BgL_sz00_13833);
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_____rz00_16344;

															{	/* Eval/evaluate_comp.scm 663 */
																obj_t BgL_savedzd2bpzd2_16345;

																BgL_savedzd2bpzd2_16345 =
																	VECTOR_REF(BgL_nsz00_16341, ((long) 0));
																VECTOR_SET(BgL_nsz00_16341, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_16347;

																	BgL_fz00_16347 = BgL_runz00_16304;
																BgL_recz00_16346:
																	{	/* Eval/evaluate_comp.scm 666 */
																		obj_t BgL_rz00_16348;

																		BgL_rz00_16348 =
																			PROCEDURE_ENTRY(BgL_fz00_16347)
																			(BgL_fz00_16347, BgL_nsz00_16341, BEOA);
																		{	/* Eval/evaluate_comp.scm 667 */
																			bool_t BgL_test6374z00_23229;

																			if (PROCEDUREP(BgL_rz00_16348))
																				{	/* Eval/evaluate_comp.scm 667 */
																					obj_t BgL_arg1707z00_16349;

																					BgL_arg1707z00_16349 =
																						PROCEDURE_ATTR(BgL_rz00_16348);
																					if (STRUCTP(BgL_arg1707z00_16349))
																						{	/* Eval/evaluate_comp.scm 647 */
																							BgL_test6374z00_23229 =
																								(STRUCT_KEY
																								(BgL_arg1707z00_16349) ==
																								BGl_symbol5794z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 647 */
																							BgL_test6374z00_23229 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 667 */
																					BgL_test6374z00_23229 = ((bool_t) 0);
																				}
																			if (BgL_test6374z00_23229)
																				{
																					obj_t BgL_fz00_23237;

																					BgL_fz00_23237 = BgL_rz00_16348;
																					BgL_fz00_16347 = BgL_fz00_23237;
																					goto BgL_recz00_16346;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 667 */
																					VECTOR_SET(BgL_nsz00_16341,
																						((long) 0),
																						BgL_savedzd2bpzd2_16345);
																					BgL_____rz00_16344 = BgL_rz00_16348;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_16343);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16340,
																BgL_sz00_13833);
															return BgL_____rz00_16344;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_16297,
												(int) (((long) 4))))
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_nbpz00_16350;

												BgL_nbpz00_16350 =
													((long) CINT(BgL_bpz00_16296) + BgL_siza7eza7_13832);
												VECTOR_SET(
													((obj_t) BgL_sz00_13833), ((long) 0),
													BINT(BgL_nbpz00_16350));
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_rz00_16351;

													BgL_rz00_16351 =
														PROCEDURE_ENTRY(BgL_fz00_16297) (BgL_fz00_16297,
														BgL_a1z00_16298, BgL_a2z00_16299, BgL_a3z00_16300,
														BgL_a4z00_16301, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13833), ((long) 0),
														BgL_bpz00_16296);
													return BgL_rz00_16351;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13830,
													BgL_symbzd2funzd2_13831, (int) (((long) 4)),
													PROCEDURE_ARITY(BgL_fz00_16297));
		}}}}}}}}

	}



/* &<@anonymous:2486> */
	obj_t BGl_z62zc3z04anonymousza32486ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13834, obj_t BgL_sz00_13843)
	{
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_13835;
				obj_t BgL_a1z00_13836;
				obj_t BgL_a2z00_13837;
				obj_t BgL_a3z00_13838;
				obj_t BgL_a4z00_13839;
				obj_t BgL_locz00_13840;
				obj_t BgL_symbzd2funzd2_13841;
				long BgL_siza7eza7_13842;

				BgL_funz00_13835 = PROCEDURE_REF(BgL_envz00_13834, (int) (((long) 0)));
				BgL_a1z00_13836 = PROCEDURE_REF(BgL_envz00_13834, (int) (((long) 1)));
				BgL_a2z00_13837 = PROCEDURE_REF(BgL_envz00_13834, (int) (((long) 2)));
				BgL_a3z00_13838 = PROCEDURE_REF(BgL_envz00_13834, (int) (((long) 3)));
				BgL_a4z00_13839 = PROCEDURE_REF(BgL_envz00_13834, (int) (((long) 4)));
				BgL_locz00_13840 = PROCEDURE_REF(BgL_envz00_13834, (int) (((long) 5)));
				BgL_symbzd2funzd2_13841 =
					PROCEDURE_REF(BgL_envz00_13834, (int) (((long) 6)));
				BgL_siza7eza7_13842 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13834, (int) (((long) 7))));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_16352;

					BgL_bpz00_16352 = VECTOR_REF(((obj_t) BgL_sz00_13843), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_fz00_16353;
						obj_t BgL_a1z00_16354;
						obj_t BgL_a2z00_16355;
						obj_t BgL_a3z00_16356;
						obj_t BgL_a4z00_16357;

						BgL_fz00_16353 =
							PROCEDURE_ENTRY(BgL_funz00_13835) (BgL_funz00_13835,
							BgL_sz00_13843, BEOA);
						BgL_a1z00_16354 =
							PROCEDURE_ENTRY(BgL_a1z00_13836) (BgL_a1z00_13836, BgL_sz00_13843,
							BEOA);
						BgL_a2z00_16355 =
							PROCEDURE_ENTRY(BgL_a2z00_13837) (BgL_a2z00_13837, BgL_sz00_13843,
							BEOA);
						BgL_a3z00_16356 =
							PROCEDURE_ENTRY(BgL_a3z00_13838) (BgL_a3z00_13838, BgL_sz00_13843,
							BEOA);
						BgL_a4z00_16357 =
							PROCEDURE_ENTRY(BgL_a4z00_13839) (BgL_a4z00_13839, BgL_sz00_13843,
							BEOA);
						if (PROCEDUREP(BgL_fz00_16353))
							{	/* Eval/evaluate_comp.scm 889 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13840,
									BGl_string5798z00zz__evaluate_compz00,
									BGl_string5814z00zz__evaluate_compz00, BgL_fz00_16353);
							}
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_ufz00_16358;

							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_tmpz00_23303;

								BgL_tmpz00_23303 = ((obj_t) BgL_fz00_16353);
								BgL_ufz00_16358 = PROCEDURE_ATTR(BgL_tmpz00_23303);
							}
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_test6379z00_23306;

								if (STRUCTP(BgL_ufz00_16358))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6379z00_23306 =
											(STRUCT_KEY(BgL_ufz00_16358) ==
											BGl_symbol5815z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6379z00_23306 = ((bool_t) 0);
									}
								if (BgL_test6379z00_23306)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_arityz00_16359;
										obj_t BgL_runz00_16360;
										obj_t BgL_sfz00_16361;

										BgL_arityz00_16359 =
											STRUCT_REF(BgL_ufz00_16358, (int) (((long) 0)));
										BgL_runz00_16360 =
											STRUCT_REF(BgL_ufz00_16358, (int) (((long) 1)));
										BgL_sfz00_16361 =
											STRUCT_REF(BgL_ufz00_16358, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 889 */
											long BgL_spz00_16362;

											BgL_spz00_16362 =
												((long) CINT(BgL_bpz00_16352) + BgL_siza7eza7_13842);
											if (((long) CINT(BgL_arityz00_16359) == ((long) 4)))
												{	/* Eval/evaluate_comp.scm 889 */
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2491z00_16363;

														BgL_arg2491z00_16363 =
															(BgL_spz00_16362 + ((long) 0));
														VECTOR_SET(
															((obj_t) BgL_sz00_13843), BgL_arg2491z00_16363,
															BgL_a1z00_16354);
													}
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2492z00_16364;

														BgL_arg2492z00_16364 =
															(BgL_spz00_16362 + ((long) 1));
														VECTOR_SET(
															((obj_t) BgL_sz00_13843), BgL_arg2492z00_16364,
															BgL_a2z00_16355);
													}
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2494z00_16365;

														BgL_arg2494z00_16365 =
															(BgL_spz00_16362 + ((long) 2));
														VECTOR_SET(
															((obj_t) BgL_sz00_13843), BgL_arg2494z00_16365,
															BgL_a3z00_16356);
													}
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2495z00_16366;

														BgL_arg2495z00_16366 =
															(BgL_spz00_16362 + ((long) 3));
														VECTOR_SET(
															((obj_t) BgL_sz00_13843), BgL_arg2495z00_16366,
															BgL_a4z00_16357);
												}}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													if (INTEGERP(BgL_arityz00_16359))
														{	/* Eval/evaluate_comp.scm 889 */
															switch ((long) CINT(BgL_arityz00_16359))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2497z00_16367;
																		obj_t BgL_arg2498z00_16368;

																		BgL_arg2497z00_16367 =
																			(BgL_spz00_16362 + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2499z00_16369;

																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_arg2500z00_16370;

																				{	/* Eval/evaluate_comp.scm 889 */
																					obj_t BgL_arg2501z00_16371;

																					{	/* Eval/evaluate_comp.scm 889 */
																						obj_t BgL_arg2503z00_16372;

																						BgL_arg2503z00_16372 =
																							MAKE_YOUNG_PAIR(BgL_a4z00_16357,
																							BNIL);
																						BgL_arg2501z00_16371 =
																							MAKE_YOUNG_PAIR(BgL_a3z00_16356,
																							BgL_arg2503z00_16372);
																					}
																					BgL_arg2500z00_16370 =
																						MAKE_YOUNG_PAIR(BgL_a2z00_16355,
																						BgL_arg2501z00_16371);
																				}
																				BgL_list2499z00_16369 =
																					MAKE_YOUNG_PAIR(BgL_a1z00_16354,
																					BgL_arg2500z00_16370);
																			}
																			BgL_arg2498z00_16368 =
																				BgL_list2499z00_16369;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13843),
																			BgL_arg2497z00_16367,
																			BgL_arg2498z00_16368);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2504z00_16373;

																		BgL_arg2504z00_16373 =
																			(BgL_spz00_16362 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13843),
																			BgL_arg2504z00_16373, BgL_a1z00_16354);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2506z00_16374;
																		obj_t BgL_arg2507z00_16375;

																		BgL_arg2506z00_16374 =
																			(BgL_spz00_16362 + ((long) 1));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2508z00_16376;

																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_arg2509z00_16377;

																				{	/* Eval/evaluate_comp.scm 889 */
																					obj_t BgL_arg2510z00_16378;

																					BgL_arg2510z00_16378 =
																						MAKE_YOUNG_PAIR(BgL_a4z00_16357,
																						BNIL);
																					BgL_arg2509z00_16377 =
																						MAKE_YOUNG_PAIR(BgL_a3z00_16356,
																						BgL_arg2510z00_16378);
																				}
																				BgL_list2508z00_16376 =
																					MAKE_YOUNG_PAIR(BgL_a2z00_16355,
																					BgL_arg2509z00_16377);
																			}
																			BgL_arg2507z00_16375 =
																				BgL_list2508z00_16376;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13843),
																			BgL_arg2506z00_16374,
																			BgL_arg2507z00_16375);
																	} break;
																case ((long) -3):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2511z00_16379;

																		BgL_arg2511z00_16379 =
																			(BgL_spz00_16362 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13843),
																			BgL_arg2511z00_16379, BgL_a1z00_16354);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2512z00_16380;

																		BgL_arg2512z00_16380 =
																			(BgL_spz00_16362 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13843),
																			BgL_arg2512z00_16380, BgL_a2z00_16355);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2514z00_16381;
																		obj_t BgL_arg2516z00_16382;

																		BgL_arg2514z00_16381 =
																			(BgL_spz00_16362 + ((long) 2));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2517z00_16383;

																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_arg2520z00_16384;

																				BgL_arg2520z00_16384 =
																					MAKE_YOUNG_PAIR(BgL_a4z00_16357,
																					BNIL);
																				BgL_list2517z00_16383 =
																					MAKE_YOUNG_PAIR(BgL_a3z00_16356,
																					BgL_arg2520z00_16384);
																			}
																			BgL_arg2516z00_16382 =
																				BgL_list2517z00_16383;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13843),
																			BgL_arg2514z00_16381,
																			BgL_arg2516z00_16382);
																	} break;
																case ((long) -4):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2521z00_16385;

																		BgL_arg2521z00_16385 =
																			(BgL_spz00_16362 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13843),
																			BgL_arg2521z00_16385, BgL_a1z00_16354);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2526z00_16386;

																		BgL_arg2526z00_16386 =
																			(BgL_spz00_16362 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13843),
																			BgL_arg2526z00_16386, BgL_a2z00_16355);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2527z00_16387;

																		BgL_arg2527z00_16387 =
																			(BgL_spz00_16362 + ((long) 2));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13843),
																			BgL_arg2527z00_16387, BgL_a3z00_16356);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2528z00_16388;
																		obj_t BgL_arg2531z00_16389;

																		BgL_arg2528z00_16388 =
																			(BgL_spz00_16362 + ((long) 3));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2532z00_16390;

																			BgL_list2532z00_16390 =
																				MAKE_YOUNG_PAIR(BgL_a4z00_16357, BNIL);
																			BgL_arg2531z00_16389 =
																				BgL_list2532z00_16390;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13843),
																			BgL_arg2528z00_16388,
																			BgL_arg2531z00_16389);
																	} break;
																case ((long) -5):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2533z00_16391;

																		BgL_arg2533z00_16391 =
																			(BgL_spz00_16362 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13843),
																			BgL_arg2533z00_16391, BgL_a1z00_16354);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2534z00_16392;

																		BgL_arg2534z00_16392 =
																			(BgL_spz00_16362 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13843),
																			BgL_arg2534z00_16392, BgL_a2z00_16355);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2537z00_16393;

																		BgL_arg2537z00_16393 =
																			(BgL_spz00_16362 + ((long) 2));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13843),
																			BgL_arg2537z00_16393, BgL_a3z00_16356);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2538z00_16394;

																		BgL_arg2538z00_16394 =
																			(BgL_spz00_16362 + ((long) 3));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13843),
																			BgL_arg2538z00_16394, BgL_a4z00_16357);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2539z00_16395;
																		obj_t BgL_arg2540z00_16396;

																		BgL_arg2539z00_16395 =
																			(BgL_spz00_16362 + ((long) 4));
																		BgL_arg2540z00_16396 = BNIL;
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13843),
																			BgL_arg2539z00_16395,
																			BgL_arg2540z00_16396);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_13840,
																		STRUCT_REF(BgL_ufz00_16358,
																			(int) (((long) 3))), (int) (((long) 4)),
																		CINT(BgL_arityz00_16359));
														}}
													else
														{	/* Eval/evaluate_comp.scm 889 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_13840, STRUCT_REF(BgL_ufz00_16358,
																	(int) (((long) 3))), (int) (((long) 4)),
																CINT(BgL_arityz00_16359));
												}}
											{	/* Eval/evaluate_comp.scm 889 */
												obj_t BgL_z12denvz12_16397;

												BgL_z12denvz12_16397 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_16397,
													BgL_locz00_13840);
												if (((BgL_spz00_16362 + (long) CINT(BgL_sfz00_16361)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13843))))
													{	/* Eval/evaluate_comp.scm 889 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_16360, BgL_sz00_13843,
															BINT(BgL_spz00_16362));
													}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_nsz00_16398;

														BgL_nsz00_16398 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 889 */
															long BgL_arg2545z00_16399;

															BgL_arg2545z00_16399 =
																(BgL_spz00_16362 + ((long) 4));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_16398, ((long) 2), BgL_sz00_13843,
																BINT(BgL_spz00_16362),
																BINT(BgL_arg2545z00_16399));
														}
														VECTOR_SET(BgL_nsz00_16398, ((long) 1),
															BgL_sz00_13843);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16397,
															BgL_nsz00_16398);
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_ez00_16400;

															BgL_ez00_16400 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_16400, BgL_sz00_13843);
															{	/* Eval/evaluate_comp.scm 889 */
																obj_t BgL_____rz00_16401;

																{	/* Eval/evaluate_comp.scm 663 */
																	obj_t BgL_savedzd2bpzd2_16402;

																	BgL_savedzd2bpzd2_16402 =
																		VECTOR_REF(BgL_nsz00_16398, ((long) 0));
																	VECTOR_SET(BgL_nsz00_16398, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_16404;

																		BgL_fz00_16404 = BgL_runz00_16360;
																	BgL_recz00_16403:
																		{	/* Eval/evaluate_comp.scm 666 */
																			obj_t BgL_rz00_16405;

																			BgL_rz00_16405 =
																				PROCEDURE_ENTRY(BgL_fz00_16404)
																				(BgL_fz00_16404, BgL_nsz00_16398, BEOA);
																			{	/* Eval/evaluate_comp.scm 667 */
																				bool_t BgL_test6384z00_23429;

																				if (PROCEDUREP(BgL_rz00_16405))
																					{	/* Eval/evaluate_comp.scm 667 */
																						obj_t BgL_arg1707z00_16406;

																						BgL_arg1707z00_16406 =
																							PROCEDURE_ATTR(BgL_rz00_16405);
																						if (STRUCTP(BgL_arg1707z00_16406))
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_test6384z00_23429 =
																									(STRUCT_KEY
																									(BgL_arg1707z00_16406) ==
																									BGl_symbol5794z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_test6384z00_23429 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						BgL_test6384z00_23429 =
																							((bool_t) 0);
																					}
																				if (BgL_test6384z00_23429)
																					{
																						obj_t BgL_fz00_23437;

																						BgL_fz00_23437 = BgL_rz00_16405;
																						BgL_fz00_16404 = BgL_fz00_23437;
																						goto BgL_recz00_16403;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						VECTOR_SET(BgL_nsz00_16398,
																							((long) 0),
																							BgL_savedzd2bpzd2_16402);
																						BgL_____rz00_16401 = BgL_rz00_16405;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_16400);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16397,
																	BgL_sz00_13843);
																return BgL_____rz00_16401;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_16353,
												(int) (((long) 4))))
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_nbpz00_16407;

												BgL_nbpz00_16407 =
													((long) CINT(BgL_bpz00_16352) + BgL_siza7eza7_13842);
												VECTOR_SET(
													((obj_t) BgL_sz00_13843), ((long) 0),
													BINT(BgL_nbpz00_16407));
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_tmpz00_23449;

													BgL_tmpz00_23449 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_23449,
														BgL_locz00_13840);
												}
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_rz00_16408;

													BgL_rz00_16408 =
														PROCEDURE_ENTRY(BgL_fz00_16353) (BgL_fz00_16353,
														BgL_a1z00_16354, BgL_a2z00_16355, BgL_a3z00_16356,
														BgL_a4z00_16357, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13843), ((long) 0),
														BgL_bpz00_16352);
													return BgL_rz00_16408;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13840,
													BgL_symbzd2funzd2_13841, (int) (((long) 4)),
													PROCEDURE_ARITY(BgL_fz00_16353));
		}}}}}}}}

	}



/* &<@anonymous:2550> */
	obj_t BGl_z62zc3z04anonymousza32550ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13844, obj_t BgL_sz00_13853)
	{
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_13845;
				obj_t BgL_a1z00_13846;
				obj_t BgL_a2z00_13847;
				obj_t BgL_a3z00_13848;
				obj_t BgL_a4z00_13849;
				obj_t BgL_locz00_13850;
				obj_t BgL_symbzd2funzd2_13851;
				long BgL_siza7eza7_13852;

				BgL_funz00_13845 = PROCEDURE_REF(BgL_envz00_13844, (int) (((long) 0)));
				BgL_a1z00_13846 = PROCEDURE_REF(BgL_envz00_13844, (int) (((long) 1)));
				BgL_a2z00_13847 = PROCEDURE_REF(BgL_envz00_13844, (int) (((long) 2)));
				BgL_a3z00_13848 = PROCEDURE_REF(BgL_envz00_13844, (int) (((long) 3)));
				BgL_a4z00_13849 = PROCEDURE_REF(BgL_envz00_13844, (int) (((long) 4)));
				BgL_locz00_13850 = PROCEDURE_REF(BgL_envz00_13844, (int) (((long) 5)));
				BgL_symbzd2funzd2_13851 =
					PROCEDURE_REF(BgL_envz00_13844, (int) (((long) 6)));
				BgL_siza7eza7_13852 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13844, (int) (((long) 7))));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_16409;

					BgL_bpz00_16409 = VECTOR_REF(((obj_t) BgL_sz00_13853), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_fz00_16410;
						obj_t BgL_a1z00_16411;
						obj_t BgL_a2z00_16412;
						obj_t BgL_a3z00_16413;
						obj_t BgL_a4z00_16414;

						BgL_fz00_16410 =
							PROCEDURE_ENTRY(BgL_funz00_13845) (BgL_funz00_13845,
							BgL_sz00_13853, BEOA);
						BgL_a1z00_16411 =
							PROCEDURE_ENTRY(BgL_a1z00_13846) (BgL_a1z00_13846, BgL_sz00_13853,
							BEOA);
						BgL_a2z00_16412 =
							PROCEDURE_ENTRY(BgL_a2z00_13847) (BgL_a2z00_13847, BgL_sz00_13853,
							BEOA);
						BgL_a3z00_16413 =
							PROCEDURE_ENTRY(BgL_a3z00_13848) (BgL_a3z00_13848, BgL_sz00_13853,
							BEOA);
						BgL_a4z00_16414 =
							PROCEDURE_ENTRY(BgL_a4z00_13849) (BgL_a4z00_13849, BgL_sz00_13853,
							BEOA);
						if (PROCEDUREP(BgL_fz00_16410))
							{	/* Eval/evaluate_comp.scm 889 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13850,
									BGl_string5798z00zz__evaluate_compz00,
									BGl_string5814z00zz__evaluate_compz00, BgL_fz00_16410);
							}
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_ufz00_16415;

							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_tmpz00_23506;

								BgL_tmpz00_23506 = ((obj_t) BgL_fz00_16410);
								BgL_ufz00_16415 = PROCEDURE_ATTR(BgL_tmpz00_23506);
							}
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_test6389z00_23509;

								if (STRUCTP(BgL_ufz00_16415))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6389z00_23509 =
											(STRUCT_KEY(BgL_ufz00_16415) ==
											BGl_symbol5815z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_test6389z00_23509 = ((bool_t) 0);
									}
								if (BgL_test6389z00_23509)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_arityz00_16416;
										obj_t BgL_runz00_16417;
										obj_t BgL_sfz00_16418;

										BgL_arityz00_16416 =
											STRUCT_REF(BgL_ufz00_16415, (int) (((long) 0)));
										BgL_runz00_16417 =
											STRUCT_REF(BgL_ufz00_16415, (int) (((long) 1)));
										BgL_sfz00_16418 =
											STRUCT_REF(BgL_ufz00_16415, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 889 */
											long BgL_spz00_16419;

											BgL_spz00_16419 =
												((long) CINT(BgL_bpz00_16409) + BgL_siza7eza7_13852);
											if (((long) CINT(BgL_arityz00_16416) == ((long) 4)))
												{	/* Eval/evaluate_comp.scm 889 */
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2554z00_16420;

														BgL_arg2554z00_16420 =
															(BgL_spz00_16419 + ((long) 0));
														VECTOR_SET(
															((obj_t) BgL_sz00_13853), BgL_arg2554z00_16420,
															BgL_a1z00_16411);
													}
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2556z00_16421;

														BgL_arg2556z00_16421 =
															(BgL_spz00_16419 + ((long) 1));
														VECTOR_SET(
															((obj_t) BgL_sz00_13853), BgL_arg2556z00_16421,
															BgL_a2z00_16412);
													}
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2557z00_16422;

														BgL_arg2557z00_16422 =
															(BgL_spz00_16419 + ((long) 2));
														VECTOR_SET(
															((obj_t) BgL_sz00_13853), BgL_arg2557z00_16422,
															BgL_a3z00_16413);
													}
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2558z00_16423;

														BgL_arg2558z00_16423 =
															(BgL_spz00_16419 + ((long) 3));
														VECTOR_SET(
															((obj_t) BgL_sz00_13853), BgL_arg2558z00_16423,
															BgL_a4z00_16414);
												}}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													if (INTEGERP(BgL_arityz00_16416))
														{	/* Eval/evaluate_comp.scm 889 */
															switch ((long) CINT(BgL_arityz00_16416))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2562z00_16424;
																		obj_t BgL_arg2566z00_16425;

																		BgL_arg2562z00_16424 =
																			(BgL_spz00_16419 + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2567z00_16426;

																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_arg2568z00_16427;

																				{	/* Eval/evaluate_comp.scm 889 */
																					obj_t BgL_arg2569z00_16428;

																					{	/* Eval/evaluate_comp.scm 889 */
																						obj_t BgL_arg2571z00_16429;

																						BgL_arg2571z00_16429 =
																							MAKE_YOUNG_PAIR(BgL_a4z00_16414,
																							BNIL);
																						BgL_arg2569z00_16428 =
																							MAKE_YOUNG_PAIR(BgL_a3z00_16413,
																							BgL_arg2571z00_16429);
																					}
																					BgL_arg2568z00_16427 =
																						MAKE_YOUNG_PAIR(BgL_a2z00_16412,
																						BgL_arg2569z00_16428);
																				}
																				BgL_list2567z00_16426 =
																					MAKE_YOUNG_PAIR(BgL_a1z00_16411,
																					BgL_arg2568z00_16427);
																			}
																			BgL_arg2566z00_16425 =
																				BgL_list2567z00_16426;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13853),
																			BgL_arg2562z00_16424,
																			BgL_arg2566z00_16425);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2572z00_16430;

																		BgL_arg2572z00_16430 =
																			(BgL_spz00_16419 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13853),
																			BgL_arg2572z00_16430, BgL_a1z00_16411);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2573z00_16431;
																		obj_t BgL_arg2574z00_16432;

																		BgL_arg2573z00_16431 =
																			(BgL_spz00_16419 + ((long) 1));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2575z00_16433;

																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_arg2577z00_16434;

																				{	/* Eval/evaluate_comp.scm 889 */
																					obj_t BgL_arg2578z00_16435;

																					BgL_arg2578z00_16435 =
																						MAKE_YOUNG_PAIR(BgL_a4z00_16414,
																						BNIL);
																					BgL_arg2577z00_16434 =
																						MAKE_YOUNG_PAIR(BgL_a3z00_16413,
																						BgL_arg2578z00_16435);
																				}
																				BgL_list2575z00_16433 =
																					MAKE_YOUNG_PAIR(BgL_a2z00_16412,
																					BgL_arg2577z00_16434);
																			}
																			BgL_arg2574z00_16432 =
																				BgL_list2575z00_16433;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13853),
																			BgL_arg2573z00_16431,
																			BgL_arg2574z00_16432);
																	} break;
																case ((long) -3):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2579z00_16436;

																		BgL_arg2579z00_16436 =
																			(BgL_spz00_16419 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13853),
																			BgL_arg2579z00_16436, BgL_a1z00_16411);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2580z00_16437;

																		BgL_arg2580z00_16437 =
																			(BgL_spz00_16419 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13853),
																			BgL_arg2580z00_16437, BgL_a2z00_16412);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2582z00_16438;
																		obj_t BgL_arg2583z00_16439;

																		BgL_arg2582z00_16438 =
																			(BgL_spz00_16419 + ((long) 2));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2584z00_16440;

																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_arg2585z00_16441;

																				BgL_arg2585z00_16441 =
																					MAKE_YOUNG_PAIR(BgL_a4z00_16414,
																					BNIL);
																				BgL_list2584z00_16440 =
																					MAKE_YOUNG_PAIR(BgL_a3z00_16413,
																					BgL_arg2585z00_16441);
																			}
																			BgL_arg2583z00_16439 =
																				BgL_list2584z00_16440;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13853),
																			BgL_arg2582z00_16438,
																			BgL_arg2583z00_16439);
																	} break;
																case ((long) -4):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2586z00_16442;

																		BgL_arg2586z00_16442 =
																			(BgL_spz00_16419 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13853),
																			BgL_arg2586z00_16442, BgL_a1z00_16411);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2587z00_16443;

																		BgL_arg2587z00_16443 =
																			(BgL_spz00_16419 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13853),
																			BgL_arg2587z00_16443, BgL_a2z00_16412);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2589z00_16444;

																		BgL_arg2589z00_16444 =
																			(BgL_spz00_16419 + ((long) 2));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13853),
																			BgL_arg2589z00_16444, BgL_a3z00_16413);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2590z00_16445;
																		obj_t BgL_arg2591z00_16446;

																		BgL_arg2590z00_16445 =
																			(BgL_spz00_16419 + ((long) 3));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2592z00_16447;

																			BgL_list2592z00_16447 =
																				MAKE_YOUNG_PAIR(BgL_a4z00_16414, BNIL);
																			BgL_arg2591z00_16446 =
																				BgL_list2592z00_16447;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13853),
																			BgL_arg2590z00_16445,
																			BgL_arg2591z00_16446);
																	} break;
																case ((long) -5):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2593z00_16448;

																		BgL_arg2593z00_16448 =
																			(BgL_spz00_16419 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13853),
																			BgL_arg2593z00_16448, BgL_a1z00_16411);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2594z00_16449;

																		BgL_arg2594z00_16449 =
																			(BgL_spz00_16419 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13853),
																			BgL_arg2594z00_16449, BgL_a2z00_16412);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2595z00_16450;

																		BgL_arg2595z00_16450 =
																			(BgL_spz00_16419 + ((long) 2));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13853),
																			BgL_arg2595z00_16450, BgL_a3z00_16413);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2596z00_16451;

																		BgL_arg2596z00_16451 =
																			(BgL_spz00_16419 + ((long) 3));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13853),
																			BgL_arg2596z00_16451, BgL_a4z00_16414);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2598z00_16452;
																		obj_t BgL_arg2599z00_16453;

																		BgL_arg2598z00_16452 =
																			(BgL_spz00_16419 + ((long) 4));
																		BgL_arg2599z00_16453 = BNIL;
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13853),
																			BgL_arg2598z00_16452,
																			BgL_arg2599z00_16453);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_13850,
																		STRUCT_REF(BgL_ufz00_16415,
																			(int) (((long) 3))), (int) (((long) 4)),
																		CINT(BgL_arityz00_16416));
														}}
													else
														{	/* Eval/evaluate_comp.scm 889 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_13850, STRUCT_REF(BgL_ufz00_16415,
																	(int) (((long) 3))), (int) (((long) 4)),
																CINT(BgL_arityz00_16416));
												}}
											{	/* Eval/evaluate_comp.scm 889 */
												obj_t BgL_z12denvz12_16454;

												BgL_z12denvz12_16454 = BGL_CURRENT_DYNAMIC_ENV();
												if (
													((BgL_spz00_16419 +
															(long) CINT(BgL_sfz00_16418)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13853))))
													{	/* Eval/evaluate_comp.scm 889 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_16417, BgL_sz00_13853,
															BINT(BgL_spz00_16419));
													}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_nsz00_16455;

														BgL_nsz00_16455 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 889 */
															long BgL_arg2603z00_16456;

															BgL_arg2603z00_16456 =
																(BgL_spz00_16419 + ((long) 4));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_16455, ((long) 2), BgL_sz00_13853,
																BINT(BgL_spz00_16419),
																BINT(BgL_arg2603z00_16456));
														}
														VECTOR_SET(BgL_nsz00_16455, ((long) 1),
															BgL_sz00_13853);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16454,
															BgL_nsz00_16455);
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_ez00_16457;

															BgL_ez00_16457 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_16457, BgL_sz00_13853);
															{	/* Eval/evaluate_comp.scm 889 */
																obj_t BgL_____rz00_16458;

																{	/* Eval/evaluate_comp.scm 663 */
																	obj_t BgL_savedzd2bpzd2_16459;

																	BgL_savedzd2bpzd2_16459 =
																		VECTOR_REF(BgL_nsz00_16455, ((long) 0));
																	VECTOR_SET(BgL_nsz00_16455, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_16461;

																		BgL_fz00_16461 = BgL_runz00_16417;
																	BgL_recz00_16460:
																		{	/* Eval/evaluate_comp.scm 666 */
																			obj_t BgL_rz00_16462;

																			BgL_rz00_16462 =
																				PROCEDURE_ENTRY(BgL_fz00_16461)
																				(BgL_fz00_16461, BgL_nsz00_16455, BEOA);
																			{	/* Eval/evaluate_comp.scm 667 */
																				bool_t BgL_test6394z00_23631;

																				if (PROCEDUREP(BgL_rz00_16462))
																					{	/* Eval/evaluate_comp.scm 667 */
																						obj_t BgL_arg1707z00_16463;

																						BgL_arg1707z00_16463 =
																							PROCEDURE_ATTR(BgL_rz00_16462);
																						if (STRUCTP(BgL_arg1707z00_16463))
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_test6394z00_23631 =
																									(STRUCT_KEY
																									(BgL_arg1707z00_16463) ==
																									BGl_symbol5794z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_test6394z00_23631 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						BgL_test6394z00_23631 =
																							((bool_t) 0);
																					}
																				if (BgL_test6394z00_23631)
																					{
																						obj_t BgL_fz00_23639;

																						BgL_fz00_23639 = BgL_rz00_16462;
																						BgL_fz00_16461 = BgL_fz00_23639;
																						goto BgL_recz00_16460;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						VECTOR_SET(BgL_nsz00_16455,
																							((long) 0),
																							BgL_savedzd2bpzd2_16459);
																						BgL_____rz00_16458 = BgL_rz00_16462;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_16457);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16454,
																	BgL_sz00_13853);
																return BgL_____rz00_16458;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_16410,
												(int) (((long) 4))))
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_nbpz00_16464;

												BgL_nbpz00_16464 =
													((long) CINT(BgL_bpz00_16409) + BgL_siza7eza7_13852);
												VECTOR_SET(
													((obj_t) BgL_sz00_13853), ((long) 0),
													BINT(BgL_nbpz00_16464));
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_rz00_16465;

													BgL_rz00_16465 =
														PROCEDURE_ENTRY(BgL_fz00_16410) (BgL_fz00_16410,
														BgL_a1z00_16411, BgL_a2z00_16412, BgL_a3z00_16413,
														BgL_a4z00_16414, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13853), ((long) 0),
														BgL_bpz00_16409);
													return BgL_rz00_16465;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13850,
													BgL_symbzd2funzd2_13851, (int) (((long) 4)),
													PROCEDURE_ARITY(BgL_fz00_16410));
		}}}}}}}}

	}



/* is-constant-fun? */
	obj_t BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_ev_exprz00_bglt
		BgL_funz00_183, long BgL_nbargsz00_184, obj_t BgL_locz00_185,
		obj_t BgL_symbzd2funzd2_186)
	{
		{	/* Eval/evaluate_comp.scm 892 */
			if (BGl_isazf3zf3zz__objectz00(
					((obj_t) BgL_funz00_183), BGl_ev_globalz00zz__evaluate_typesz00))
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_gz00_3026;

					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_arg2615z00_3034;
						obj_t BgL_arg2617z00_3035;

						BgL_arg2615z00_3034 =
							(((BgL_ev_globalz00_bglt) COBJECT(
									((BgL_ev_globalz00_bglt) BgL_funz00_183)))->BgL_modz00);
						BgL_arg2617z00_3035 =
							(((BgL_ev_globalz00_bglt) COBJECT(
									((BgL_ev_globalz00_bglt) BgL_funz00_183)))->BgL_namez00);
						BgL_gz00_3026 =
							BGl_evmodulezd2findzd2globalz00zz__evmodulez00
							(BgL_arg2615z00_3034, BgL_arg2617z00_3035);
					}
					if (CBOOL(BgL_gz00_3026))
						{	/* Eval/evaluate_comp.scm 898 */
							bool_t BgL_test6400z00_23673;

							{	/* Eval/evaluate_comp.scm 898 */
								int BgL_arg2614z00_3033;

								{	/* Eval/evaluate_comp.scm 898 */
									int BgL_res4958z00_9313;

									BgL_res4958z00_9313 =
										CINT(VECTOR_REF(((obj_t) BgL_gz00_3026), ((long) 0)));
									BgL_arg2614z00_3033 = BgL_res4958z00_9313;
								}
								BgL_test6400z00_23673 =
									((long) (BgL_arg2614z00_3033) == ((long) 0));
							}
							if (BgL_test6400z00_23673)
								{	/* Eval/evaluate_comp.scm 899 */
									obj_t BgL_valz00_3029;

									BgL_valz00_3029 =
										VECTOR_REF(((obj_t) BgL_gz00_3026), ((long) 2));
									{	/* Eval/evaluate_comp.scm 900 */
										bool_t BgL_test6401z00_23681;

										if (PROCEDUREP(BgL_valz00_3029))
											{	/* Eval/evaluate_comp.scm 900 */
												BgL_test6401z00_23681 =
													PROCEDURE_CORRECT_ARITYP(BgL_valz00_3029,
													(int) (BgL_nbargsz00_184));
											}
										else
											{	/* Eval/evaluate_comp.scm 900 */
												BgL_test6401z00_23681 = ((bool_t) 0);
											}
										if (BgL_test6401z00_23681)
											{	/* Eval/evaluate_comp.scm 900 */
												return BgL_valz00_3029;
											}
										else
											{	/* Eval/evaluate_comp.scm 900 */
												return BFALSE;
											}
									}
								}
							else
								{	/* Eval/evaluate_comp.scm 898 */
									return BFALSE;
								}
						}
					else
						{	/* Eval/evaluate_comp.scm 897 */
							return BFALSE;
						}
				}
			else
				{	/* Eval/evaluate_comp.scm 903 */
					bool_t BgL_test6403z00_23686;

					if (BGl_isazf3zf3zz__objectz00(
							((obj_t) BgL_funz00_183), BGl_ev_littz00zz__evaluate_typesz00))
						{	/* Eval/evaluate_comp.scm 904 */
							obj_t BgL_tmpz00_23690;

							BgL_tmpz00_23690 =
								(((BgL_ev_littz00_bglt) COBJECT(
										((BgL_ev_littz00_bglt) BgL_funz00_183)))->BgL_valuez00);
							BgL_test6403z00_23686 = PROCEDUREP(BgL_tmpz00_23690);
						}
					else
						{	/* Eval/evaluate_comp.scm 903 */
							BgL_test6403z00_23686 = ((bool_t) 0);
						}
					if (BgL_test6403z00_23686)
						{	/* Eval/evaluate_comp.scm 906 */
							bool_t BgL_test6405z00_23694;

							{	/* Eval/evaluate_comp.scm 906 */
								obj_t BgL_arg2626z00_3045;

								BgL_arg2626z00_3045 =
									(((BgL_ev_littz00_bglt) COBJECT(
											((BgL_ev_littz00_bglt) BgL_funz00_183)))->BgL_valuez00);
								BgL_test6405z00_23694 =
									PROCEDURE_CORRECT_ARITYP(BgL_arg2626z00_3045,
									(int) (BgL_nbargsz00_184));
							}
							if (BgL_test6405z00_23694)
								{	/* Eval/evaluate_comp.scm 906 */
									return
										(((BgL_ev_littz00_bglt) COBJECT(
												((BgL_ev_littz00_bglt) BgL_funz00_183)))->BgL_valuez00);
								}
							else
								{	/* Eval/evaluate_comp.scm 908 */
									int BgL_arg2624z00_3043;

									{	/* Eval/evaluate_comp.scm 908 */
										obj_t BgL_arg2625z00_3044;

										BgL_arg2625z00_3044 =
											(((BgL_ev_littz00_bglt) COBJECT(
													((BgL_ev_littz00_bglt) BgL_funz00_183)))->
											BgL_valuez00);
										BgL_arg2624z00_3043 = PROCEDURE_ARITY(BgL_arg2625z00_3044);
									}
									return
										BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_185,
										BgL_symbzd2funzd2_186, (int) (BgL_nbargsz00_184),
										BgL_arg2624z00_3043);
						}}
					else
						{	/* Eval/evaluate_comp.scm 903 */
							return BFALSE;
						}
				}
		}

	}



/* compile-float-arith */
	obj_t BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(obj_t
		BgL_exprz00_187, obj_t BgL_stkz00_188)
	{
		{	/* Eval/evaluate_comp.scm 911 */
			if (BGl_isazf3zf3zz__objectz00(BgL_exprz00_187,
					BGl_ev_littz00zz__evaluate_typesz00))
				{	/* Eval/evaluate_comp.scm 915 */
					if (INTEGERP(
							(((BgL_ev_littz00_bglt) COBJECT(
										((BgL_ev_littz00_bglt) BgL_exprz00_187)))->BgL_valuez00)))
						{	/* Eval/evaluate_comp.scm 917 */
							obj_t BgL_v1350z00_3054;

							BgL_v1350z00_3054 = create_vector(((long) 2));
							VECTOR_SET(BgL_v1350z00_3054, ((long) 0), BINT(((long) 1)));
							{	/* Eval/evaluate_comp.scm 917 */
								double BgL_arg2631z00_3055;

								BgL_arg2631z00_3055 =
									(double) (
									(long) CINT(
										(((BgL_ev_littz00_bglt) COBJECT(
													((BgL_ev_littz00_bglt) BgL_exprz00_187)))->
											BgL_valuez00)));
								VECTOR_SET(BgL_v1350z00_3054, ((long) 1),
									DOUBLE_TO_REAL(BgL_arg2631z00_3055));
							}
							return BgL_v1350z00_3054;
						}
					else
						{	/* Eval/evaluate_comp.scm 918 */
							bool_t BgL_test6408z00_23721;

							{	/* Eval/evaluate_comp.scm 918 */
								obj_t BgL_tmpz00_23722;

								BgL_tmpz00_23722 =
									(((BgL_ev_littz00_bglt) COBJECT(
											((BgL_ev_littz00_bglt) BgL_exprz00_187)))->BgL_valuez00);
								BgL_test6408z00_23721 = REALP(BgL_tmpz00_23722);
							}
							if (BgL_test6408z00_23721)
								{	/* Eval/evaluate_comp.scm 918 */
									obj_t BgL_v1351z00_3059;

									BgL_v1351z00_3059 = create_vector(((long) 2));
									VECTOR_SET(BgL_v1351z00_3059, ((long) 0), BINT(((long) 1)));
									{	/* Eval/evaluate_comp.scm 918 */
										obj_t BgL_arg2636z00_3060;

										BgL_arg2636z00_3060 =
											(((BgL_ev_littz00_bglt) COBJECT(
													((BgL_ev_littz00_bglt) BgL_exprz00_187)))->
											BgL_valuez00);
										VECTOR_SET(BgL_v1351z00_3059, ((long) 1),
											BgL_arg2636z00_3060);
									}
									return BgL_v1351z00_3059;
								}
							else
								{	/* Eval/evaluate_comp.scm 919 */
									obj_t BgL_v1352z00_3061;

									BgL_v1352z00_3061 = create_vector(((long) 2));
									VECTOR_SET(BgL_v1352z00_3061, ((long) 0), BINT(((long) 0)));
									{	/* Eval/evaluate_comp.scm 919 */
										obj_t BgL_arg2637z00_3062;

										BgL_arg2637z00_3062 =
											BGl_compz00zz__evaluate_compz00(
											((BgL_ev_exprz00_bglt)
												((BgL_ev_littz00_bglt) BgL_exprz00_187)),
											BgL_stkz00_188);
										VECTOR_SET(BgL_v1352z00_3061, ((long) 1),
											BgL_arg2637z00_3062);
									}
									return BgL_v1352z00_3061;
								}
						}
				}
			else
				{	/* Eval/evaluate_comp.scm 915 */
					if (BGl_isazf3zf3zz__objectz00(BgL_exprz00_187,
							BGl_ev_varz00zz__evaluate_typesz00))
						{	/* Eval/evaluate_comp.scm 920 */
							if (CBOOL(
									(((BgL_ev_varz00_bglt) COBJECT(
												((BgL_ev_varz00_bglt) BgL_exprz00_187)))->BgL_effz00)))
								{	/* Eval/evaluate_comp.scm 923 */
									obj_t BgL_v1353z00_3068;

									BgL_v1353z00_3068 = create_vector(((long) 2));
									VECTOR_SET(BgL_v1353z00_3068, ((long) 0), BINT(((long) 3)));
									VECTOR_SET(BgL_v1353z00_3068, ((long) 1),
										BGl__indexz00zz__evaluate_compz00(BgL_exprz00_187,
											BgL_stkz00_188));
									return BgL_v1353z00_3068;
								}
							else
								{	/* Eval/evaluate_comp.scm 924 */
									obj_t BgL_v1354z00_3070;

									BgL_v1354z00_3070 = create_vector(((long) 2));
									VECTOR_SET(BgL_v1354z00_3070, ((long) 0), BINT(((long) 2)));
									VECTOR_SET(BgL_v1354z00_3070, ((long) 1),
										BGl__indexz00zz__evaluate_compz00(BgL_exprz00_187,
											BgL_stkz00_188));
									return BgL_v1354z00_3070;
								}
						}
					else
						{	/* Eval/evaluate_comp.scm 920 */
							if (BGl_isazf3zf3zz__objectz00(BgL_exprz00_187,
									BGl_ev_globalz00zz__evaluate_typesz00))
								{	/* Eval/evaluate_comp.scm 927 */
									obj_t BgL_gz00_3074;

									{	/* Eval/evaluate_comp.scm 927 */
										obj_t BgL_arg2653z00_3082;
										obj_t BgL_arg2655z00_3083;

										BgL_arg2653z00_3082 =
											(((BgL_ev_globalz00_bglt) COBJECT(
													((BgL_ev_globalz00_bglt) BgL_exprz00_187)))->
											BgL_modz00);
										BgL_arg2655z00_3083 =
											(((BgL_ev_globalz00_bglt) COBJECT(((BgL_ev_globalz00_bglt)
														BgL_exprz00_187)))->BgL_namez00);
										BgL_gz00_3074 =
											BGl_evmodulezd2findzd2globalz00zz__evmodulez00
											(BgL_arg2653z00_3082, BgL_arg2655z00_3083);
									}
									if (CBOOL(BgL_gz00_3074))
										{	/* Eval/evaluate_comp.scm 929 */
											bool_t BgL_test6413z00_23764;

											{	/* Eval/evaluate_comp.scm 929 */
												int BgL_arg2651z00_3079;

												{	/* Eval/evaluate_comp.scm 929 */
													int BgL_res4965z00_9336;

													BgL_res4965z00_9336 =
														CINT(VECTOR_REF(
															((obj_t) BgL_gz00_3074), ((long) 0)));
													BgL_arg2651z00_3079 = BgL_res4965z00_9336;
												}
												BgL_test6413z00_23764 =
													(BINT(BgL_arg2651z00_3079) == BINT(((long) 1)));
											}
											if (BgL_test6413z00_23764)
												{	/* Eval/evaluate_comp.scm 930 */
													obj_t BgL_v1355z00_3077;

													BgL_v1355z00_3077 = create_vector(((long) 2));
													VECTOR_SET(BgL_v1355z00_3077, ((long) 0),
														BINT(((long) 4)));
													VECTOR_SET(BgL_v1355z00_3077, ((long) 1),
														BgL_gz00_3074);
													return BgL_v1355z00_3077;
												}
											else
												{	/* Eval/evaluate_comp.scm 931 */
													obj_t BgL_v1356z00_3078;

													BgL_v1356z00_3078 = create_vector(((long) 2));
													VECTOR_SET(BgL_v1356z00_3078, ((long) 0),
														BINT(((long) 5)));
													VECTOR_SET(BgL_v1356z00_3078, ((long) 1),
														BgL_gz00_3074);
													return BgL_v1356z00_3078;
												}
										}
									else
										{	/* Eval/evaluate_comp.scm 932 */
											obj_t BgL_v1357z00_3080;

											BgL_v1357z00_3080 = create_vector(((long) 2));
											VECTOR_SET(BgL_v1357z00_3080, ((long) 0),
												BINT(((long) 0)));
											{	/* Eval/evaluate_comp.scm 932 */
												obj_t BgL_arg2652z00_3081;

												BgL_arg2652z00_3081 =
													BGl_compz00zz__evaluate_compz00(
													((BgL_ev_exprz00_bglt)
														((BgL_ev_globalz00_bglt) BgL_exprz00_187)),
													BgL_stkz00_188);
												VECTOR_SET(BgL_v1357z00_3080, ((long) 1),
													BgL_arg2652z00_3081);
											}
											return BgL_v1357z00_3080;
										}
								}
							else
								{	/* Eval/evaluate_comp.scm 925 */
									if (BGl_isazf3zf3zz__objectz00(BgL_exprz00_187,
											BGl_ev_appz00zz__evaluate_typesz00))
										{	/* Eval/evaluate_comp.scm 935 */
											obj_t BgL_fvalz00_3086;

											{	/* Eval/evaluate_comp.scm 935 */
												BgL_ev_exprz00_bglt BgL_arg2698z00_3134;

												BgL_arg2698z00_3134 =
													(((BgL_ev_appz00_bglt) COBJECT(
															((BgL_ev_appz00_bglt) BgL_exprz00_187)))->
													BgL_funz00);
												BgL_fvalz00_3086 =
													BGl_globalzd2funzd2valuez00zz__evaluate_compz00
													(BgL_arg2698z00_3134);
											}
											if (
												(BgL_fvalz00_3086 ==
													BGl_zb2flzd2envz60zz__r4_numbers_6_5_flonumz00))
												{	/* Eval/evaluate_comp.scm 938 */
													obj_t BgL_v1358z00_3088;

													BgL_v1358z00_3088 = create_vector(((long) 3));
													VECTOR_SET(BgL_v1358z00_3088, ((long) 0),
														BINT(((long) 6)));
													{	/* Eval/evaluate_comp.scm 938 */
														obj_t BgL_arg2658z00_3089;

														{	/* Eval/evaluate_comp.scm 938 */
															obj_t BgL_arg2659z00_3090;

															{	/* Eval/evaluate_comp.scm 938 */
																obj_t BgL_pairz00_9344;

																BgL_pairz00_9344 =
																	(((BgL_ev_appz00_bglt) COBJECT(
																			((BgL_ev_appz00_bglt) BgL_exprz00_187)))->
																	BgL_argsz00);
																BgL_arg2659z00_3090 = CAR(BgL_pairz00_9344);
															}
															BgL_arg2658z00_3089 =
																BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																(BgL_arg2659z00_3090, BgL_stkz00_188);
														}
														VECTOR_SET(BgL_v1358z00_3088, ((long) 1),
															BgL_arg2658z00_3089);
													}
													{	/* Eval/evaluate_comp.scm 938 */
														obj_t BgL_arg2661z00_3092;

														{	/* Eval/evaluate_comp.scm 938 */
															obj_t BgL_arg2662z00_3093;

															{	/* Eval/evaluate_comp.scm 938 */
																obj_t BgL_pairz00_9346;

																BgL_pairz00_9346 =
																	(((BgL_ev_appz00_bglt) COBJECT(
																			((BgL_ev_appz00_bglt) BgL_exprz00_187)))->
																	BgL_argsz00);
																BgL_arg2662z00_3093 =
																	CAR(CDR(BgL_pairz00_9346));
															}
															BgL_arg2661z00_3092 =
																BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																(BgL_arg2662z00_3093, BgL_stkz00_188);
														}
														VECTOR_SET(BgL_v1358z00_3088, ((long) 2),
															BgL_arg2661z00_3092);
													}
													return BgL_v1358z00_3088;
												}
											else
												{	/* Eval/evaluate_comp.scm 937 */
													if (
														(BgL_fvalz00_3086 ==
															BGl_zd2flzd2envz00zz__r4_numbers_6_5_flonumz00))
														{	/* Eval/evaluate_comp.scm 940 */
															obj_t BgL_v1359z00_3096;

															BgL_v1359z00_3096 = create_vector(((long) 3));
															VECTOR_SET(BgL_v1359z00_3096, ((long) 0),
																BINT(((long) 7)));
															{	/* Eval/evaluate_comp.scm 940 */
																obj_t BgL_arg2666z00_3097;

																{	/* Eval/evaluate_comp.scm 940 */
																	obj_t BgL_arg2667z00_3098;

																	{	/* Eval/evaluate_comp.scm 940 */
																		obj_t BgL_pairz00_9352;

																		BgL_pairz00_9352 =
																			(((BgL_ev_appz00_bglt) COBJECT(
																					((BgL_ev_appz00_bglt)
																						BgL_exprz00_187)))->BgL_argsz00);
																		BgL_arg2667z00_3098 = CAR(BgL_pairz00_9352);
																	}
																	BgL_arg2666z00_3097 =
																		BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																		(BgL_arg2667z00_3098, BgL_stkz00_188);
																}
																VECTOR_SET(BgL_v1359z00_3096, ((long) 1),
																	BgL_arg2666z00_3097);
															}
															{	/* Eval/evaluate_comp.scm 940 */
																obj_t BgL_arg2669z00_3100;

																{	/* Eval/evaluate_comp.scm 940 */
																	obj_t BgL_arg2670z00_3101;

																	{	/* Eval/evaluate_comp.scm 940 */
																		obj_t BgL_pairz00_9354;

																		BgL_pairz00_9354 =
																			(((BgL_ev_appz00_bglt) COBJECT(
																					((BgL_ev_appz00_bglt)
																						BgL_exprz00_187)))->BgL_argsz00);
																		BgL_arg2670z00_3101 =
																			CAR(CDR(BgL_pairz00_9354));
																	}
																	BgL_arg2669z00_3100 =
																		BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																		(BgL_arg2670z00_3101, BgL_stkz00_188);
																}
																VECTOR_SET(BgL_v1359z00_3096, ((long) 2),
																	BgL_arg2669z00_3100);
															}
															return BgL_v1359z00_3096;
														}
													else
														{	/* Eval/evaluate_comp.scm 939 */
															if (
																(BgL_fvalz00_3086 ==
																	BGl_za2flzd2envz70zz__r4_numbers_6_5_flonumz00))
																{	/* Eval/evaluate_comp.scm 942 */
																	obj_t BgL_v1360z00_3104;

																	BgL_v1360z00_3104 = create_vector(((long) 3));
																	VECTOR_SET(BgL_v1360z00_3104, ((long) 0),
																		BINT(((long) 8)));
																	{	/* Eval/evaluate_comp.scm 942 */
																		obj_t BgL_arg2673z00_3105;

																		{	/* Eval/evaluate_comp.scm 942 */
																			obj_t BgL_arg2674z00_3106;

																			{	/* Eval/evaluate_comp.scm 942 */
																				obj_t BgL_pairz00_9360;

																				BgL_pairz00_9360 =
																					(((BgL_ev_appz00_bglt) COBJECT(
																							((BgL_ev_appz00_bglt)
																								BgL_exprz00_187)))->
																					BgL_argsz00);
																				BgL_arg2674z00_3106 =
																					CAR(BgL_pairz00_9360);
																			}
																			BgL_arg2673z00_3105 =
																				BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																				(BgL_arg2674z00_3106, BgL_stkz00_188);
																		}
																		VECTOR_SET(BgL_v1360z00_3104, ((long) 1),
																			BgL_arg2673z00_3105);
																	}
																	{	/* Eval/evaluate_comp.scm 942 */
																		obj_t BgL_arg2676z00_3108;

																		{	/* Eval/evaluate_comp.scm 942 */
																			obj_t BgL_arg2677z00_3109;

																			{	/* Eval/evaluate_comp.scm 942 */
																				obj_t BgL_pairz00_9362;

																				BgL_pairz00_9362 =
																					(((BgL_ev_appz00_bglt) COBJECT(
																							((BgL_ev_appz00_bglt)
																								BgL_exprz00_187)))->
																					BgL_argsz00);
																				BgL_arg2677z00_3109 =
																					CAR(CDR(BgL_pairz00_9362));
																			}
																			BgL_arg2676z00_3108 =
																				BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																				(BgL_arg2677z00_3109, BgL_stkz00_188);
																		}
																		VECTOR_SET(BgL_v1360z00_3104, ((long) 2),
																			BgL_arg2676z00_3108);
																	}
																	return BgL_v1360z00_3104;
																}
															else
																{	/* Eval/evaluate_comp.scm 941 */
																	if (
																		(BgL_fvalz00_3086 ==
																			BGl_zf2flzd2envz20zz__r4_numbers_6_5_flonumz00))
																		{	/* Eval/evaluate_comp.scm 944 */
																			obj_t BgL_v1361z00_3112;

																			BgL_v1361z00_3112 =
																				create_vector(((long) 3));
																			VECTOR_SET(BgL_v1361z00_3112, ((long) 0),
																				BINT(((long) 9)));
																			{	/* Eval/evaluate_comp.scm 944 */
																				obj_t BgL_arg2680z00_3113;

																				{	/* Eval/evaluate_comp.scm 944 */
																					obj_t BgL_arg2681z00_3114;

																					{	/* Eval/evaluate_comp.scm 944 */
																						obj_t BgL_pairz00_9368;

																						BgL_pairz00_9368 =
																							(((BgL_ev_appz00_bglt) COBJECT(
																									((BgL_ev_appz00_bglt)
																										BgL_exprz00_187)))->
																							BgL_argsz00);
																						BgL_arg2681z00_3114 =
																							CAR(BgL_pairz00_9368);
																					}
																					BgL_arg2680z00_3113 =
																						BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																						(BgL_arg2681z00_3114,
																						BgL_stkz00_188);
																				}
																				VECTOR_SET(BgL_v1361z00_3112,
																					((long) 1), BgL_arg2680z00_3113);
																			}
																			{	/* Eval/evaluate_comp.scm 944 */
																				obj_t BgL_arg2683z00_3116;

																				{	/* Eval/evaluate_comp.scm 944 */
																					obj_t BgL_arg2684z00_3117;

																					{	/* Eval/evaluate_comp.scm 944 */
																						obj_t BgL_pairz00_9370;

																						BgL_pairz00_9370 =
																							(((BgL_ev_appz00_bglt) COBJECT(
																									((BgL_ev_appz00_bglt)
																										BgL_exprz00_187)))->
																							BgL_argsz00);
																						BgL_arg2684z00_3117 =
																							CAR(CDR(BgL_pairz00_9370));
																					}
																					BgL_arg2683z00_3116 =
																						BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																						(BgL_arg2684z00_3117,
																						BgL_stkz00_188);
																				}
																				VECTOR_SET(BgL_v1361z00_3112,
																					((long) 2), BgL_arg2683z00_3116);
																			}
																			return BgL_v1361z00_3112;
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 943 */
																			if (
																				(BgL_fvalz00_3086 ==
																					BGl_fixnumzd2ze3flonumzd2envze3zz__r4_numbers_6_5z00))
																				{	/* Eval/evaluate_comp.scm 946 */
																					obj_t BgL_v1362z00_3120;

																					BgL_v1362z00_3120 =
																						create_vector(((long) 2));
																					VECTOR_SET(BgL_v1362z00_3120,
																						((long) 0), BINT(((long) 10)));
																					{	/* Eval/evaluate_comp.scm 946 */
																						obj_t BgL_arg2687z00_3121;

																						{	/* Eval/evaluate_comp.scm 946 */
																							obj_t BgL_arg2688z00_3122;

																							{	/* Eval/evaluate_comp.scm 946 */
																								obj_t BgL_pairz00_9376;

																								BgL_pairz00_9376 =
																									(((BgL_ev_appz00_bglt)
																										COBJECT((
																												(BgL_ev_appz00_bglt)
																												BgL_exprz00_187)))->
																									BgL_argsz00);
																								BgL_arg2688z00_3122 =
																									CAR(BgL_pairz00_9376);
																							}
																							BgL_arg2687z00_3121 =
																								BGl_compz00zz__evaluate_compz00(
																								((BgL_ev_exprz00_bglt)
																									BgL_arg2688z00_3122),
																								BgL_stkz00_188);
																						}
																						VECTOR_SET(BgL_v1362z00_3120,
																							((long) 1), BgL_arg2687z00_3121);
																					}
																					return BgL_v1362z00_3120;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 945 */
																					if (
																						(BgL_fvalz00_3086 ==
																							BGl_f64vectorzd2refzd2envz00zz__srfi4z00))
																						{	/* Eval/evaluate_comp.scm 948 */
																							obj_t BgL_v1363z00_3125;

																							BgL_v1363z00_3125 =
																								create_vector(((long) 3));
																							VECTOR_SET(BgL_v1363z00_3125,
																								((long) 0), BINT(((long) 11)));
																							{	/* Eval/evaluate_comp.scm 948 */
																								obj_t BgL_arg2691z00_3126;

																								{	/* Eval/evaluate_comp.scm 948 */
																									obj_t BgL_arg2692z00_3127;

																									{	/* Eval/evaluate_comp.scm 948 */
																										obj_t BgL_pairz00_9379;

																										BgL_pairz00_9379 =
																											(((BgL_ev_appz00_bglt)
																												COBJECT((
																														(BgL_ev_appz00_bglt)
																														BgL_exprz00_187)))->
																											BgL_argsz00);
																										BgL_arg2692z00_3127 =
																											CAR(BgL_pairz00_9379);
																									}
																									BgL_arg2691z00_3126 =
																										BGl_compz00zz__evaluate_compz00
																										(((BgL_ev_exprz00_bglt)
																											BgL_arg2692z00_3127),
																										BgL_stkz00_188);
																								}
																								VECTOR_SET(BgL_v1363z00_3125,
																									((long) 1),
																									BgL_arg2691z00_3126);
																							}
																							{	/* Eval/evaluate_comp.scm 948 */
																								obj_t BgL_arg2694z00_3129;

																								{	/* Eval/evaluate_comp.scm 948 */
																									obj_t BgL_arg2695z00_3130;

																									{	/* Eval/evaluate_comp.scm 948 */
																										obj_t BgL_pairz00_9381;

																										BgL_pairz00_9381 =
																											(((BgL_ev_appz00_bglt)
																												COBJECT((
																														(BgL_ev_appz00_bglt)
																														BgL_exprz00_187)))->
																											BgL_argsz00);
																										BgL_arg2695z00_3130 =
																											CAR(CDR
																											(BgL_pairz00_9381));
																									}
																									BgL_arg2694z00_3129 =
																										BGl_compz00zz__evaluate_compz00
																										(((BgL_ev_exprz00_bglt)
																											BgL_arg2695z00_3130),
																										BgL_stkz00_188);
																								}
																								VECTOR_SET(BgL_v1363z00_3125,
																									((long) 2),
																									BgL_arg2694z00_3129);
																							}
																							return BgL_v1363z00_3125;
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 950 */
																							obj_t BgL_v1364z00_3132;

																							BgL_v1364z00_3132 =
																								create_vector(((long) 2));
																							VECTOR_SET(BgL_v1364z00_3132,
																								((long) 0), BINT(((long) 0)));
																							{	/* Eval/evaluate_comp.scm 950 */
																								obj_t BgL_arg2697z00_3133;

																								BgL_arg2697z00_3133 =
																									BGl_compz00zz__evaluate_compz00
																									(((BgL_ev_exprz00_bglt) (
																											(BgL_ev_appz00_bglt)
																											BgL_exprz00_187)),
																									BgL_stkz00_188);
																								VECTOR_SET(BgL_v1364z00_3132,
																									((long) 1),
																									BgL_arg2697z00_3133);
																							}
																							return BgL_v1364z00_3132;
																						}
																				}
																		}
																}
														}
												}
										}
									else
										{	/* Eval/evaluate_comp.scm 951 */
											obj_t BgL_v1365z00_3135;

											BgL_v1365z00_3135 = create_vector(((long) 2));
											VECTOR_SET(BgL_v1365z00_3135, ((long) 0),
												BINT(((long) 0)));
											{	/* Eval/evaluate_comp.scm 951 */
												obj_t BgL_arg2699z00_3136;

												BgL_arg2699z00_3136 =
													BGl_compz00zz__evaluate_compz00(
													((BgL_ev_exprz00_bglt) BgL_exprz00_187),
													BgL_stkz00_188);
												VECTOR_SET(BgL_v1365z00_3135, ((long) 1),
													BgL_arg2699z00_3136);
											}
											return BgL_v1365z00_3135;
										}
								}
						}
				}
		}

	}



/* eval-float-arith */
	double BGl_evalzd2floatzd2arithz00zz__evaluate_compz00(obj_t BgL_bcz00_189,
		obj_t BgL_sz00_190)
	{
		{	/* Eval/evaluate_comp.scm 953 */
			return
				REAL_TO_DOUBLE(BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_190,
					BgL_bcz00_189));
		}

	}



/* E~0 */
	obj_t BGl_Eze70ze7zz__evaluate_compz00(obj_t BgL_sz00_15516,
		obj_t BgL_bcz00_3141)
	{
		{	/* Eval/evaluate_comp.scm 968 */
			{	/* Eval/evaluate_comp.scm 955 */
				obj_t BgL_aux1221z00_3144;

				BgL_aux1221z00_3144 = VECTOR_REF(((obj_t) BgL_bcz00_3141), ((long) 0));
				if (INTEGERP(BgL_aux1221z00_3144))
					{	/* Eval/evaluate_comp.scm 955 */
						switch ((long) CINT(BgL_aux1221z00_3144))
							{
							case ((long) 0):

								{	/* Eval/evaluate_comp.scm 956 */
									obj_t BgL_fun2703z00_3146;

									BgL_fun2703z00_3146 =
										VECTOR_REF(((obj_t) BgL_bcz00_3141), ((long) 1));
									return
										PROCEDURE_ENTRY(BgL_fun2703z00_3146) (BgL_fun2703z00_3146,
										BgL_sz00_15516, BEOA);
								}
								break;
							case ((long) 1):

								return VECTOR_REF(((obj_t) BgL_bcz00_3141), ((long) 1));
								break;
							case ((long) 2):

								{	/* Eval/evaluate_comp.scm 958 */
									long BgL_arg2704z00_3147;

									{	/* Eval/evaluate_comp.scm 958 */
										obj_t BgL_arg2706z00_3148;
										obj_t BgL_arg2708z00_3149;

										BgL_arg2706z00_3148 =
											VECTOR_REF(((obj_t) BgL_sz00_15516), ((long) 0));
										BgL_arg2708z00_3149 =
											VECTOR_REF(((obj_t) BgL_bcz00_3141), ((long) 1));
										BgL_arg2704z00_3147 =
											(
											(long) CINT(BgL_arg2706z00_3148) +
											(long) CINT(BgL_arg2708z00_3149));
									}
									return
										VECTOR_REF(((obj_t) BgL_sz00_15516), BgL_arg2704z00_3147);
								}
								break;
							case ((long) 3):

								{	/* Eval/evaluate_comp.scm 959 */
									obj_t BgL_arg2709z00_3150;

									{	/* Eval/evaluate_comp.scm 959 */
										long BgL_arg2712z00_3151;

										{	/* Eval/evaluate_comp.scm 959 */
											obj_t BgL_arg2713z00_3152;
											obj_t BgL_arg2714z00_3153;

											BgL_arg2713z00_3152 =
												VECTOR_REF(((obj_t) BgL_sz00_15516), ((long) 0));
											BgL_arg2714z00_3153 =
												VECTOR_REF(((obj_t) BgL_bcz00_3141), ((long) 1));
											BgL_arg2712z00_3151 =
												(
												(long) CINT(BgL_arg2713z00_3152) +
												(long) CINT(BgL_arg2714z00_3153));
										}
										BgL_arg2709z00_3150 =
											VECTOR_REF(((obj_t) BgL_sz00_15516), BgL_arg2712z00_3151);
									}
									return
										STRUCT_REF(
										((obj_t) BgL_arg2709z00_3150), (int) (((long) 0)));
								} break;
							case ((long) 4):

								{	/* Eval/evaluate_comp.scm 960 */
									obj_t BgL_arg2715z00_3154;

									{	/* Eval/evaluate_comp.scm 960 */
										obj_t BgL_arg2716z00_3155;

										BgL_arg2716z00_3155 =
											VECTOR_REF(((obj_t) BgL_bcz00_3141), ((long) 1));
										BgL_arg2715z00_3154 =
											VECTOR_REF(((obj_t) BgL_arg2716z00_3155), ((long) 2));
									}
									return __EVMEANING_ADDRESS_REF(BgL_arg2715z00_3154);
								}
								break;
							case ((long) 5):

								{	/* Eval/evaluate_comp.scm 961 */
									obj_t BgL_arg2719z00_3156;

									BgL_arg2719z00_3156 =
										VECTOR_REF(((obj_t) BgL_bcz00_3141), ((long) 1));
									return VECTOR_REF(((obj_t) BgL_arg2719z00_3156), ((long) 2));
								} break;
							case ((long) 6):

								{	/* Eval/evaluate_comp.scm 962 */
									obj_t BgL_arg2720z00_3157;
									obj_t BgL_arg2721z00_3158;

									{	/* Eval/evaluate_comp.scm 962 */
										obj_t BgL_arg2722z00_3159;

										BgL_arg2722z00_3159 =
											VECTOR_REF(((obj_t) BgL_bcz00_3141), ((long) 1));
										BgL_arg2720z00_3157 =
											BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_15516,
											BgL_arg2722z00_3159);
									}
									{	/* Eval/evaluate_comp.scm 962 */
										obj_t BgL_arg2723z00_3160;

										BgL_arg2723z00_3160 =
											VECTOR_REF(((obj_t) BgL_bcz00_3141), ((long) 2));
										BgL_arg2721z00_3158 =
											BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_15516,
											BgL_arg2723z00_3160);
									}
									return
										DOUBLE_TO_REAL(
										(REAL_TO_DOUBLE(BgL_arg2720z00_3157) +
											REAL_TO_DOUBLE(BgL_arg2721z00_3158)));
								}
								break;
							case ((long) 7):

								{	/* Eval/evaluate_comp.scm 963 */
									obj_t BgL_arg2724z00_3161;
									obj_t BgL_arg2725z00_3162;

									{	/* Eval/evaluate_comp.scm 963 */
										obj_t BgL_arg2727z00_3163;

										BgL_arg2727z00_3163 =
											VECTOR_REF(((obj_t) BgL_bcz00_3141), ((long) 1));
										BgL_arg2724z00_3161 =
											BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_15516,
											BgL_arg2727z00_3163);
									}
									{	/* Eval/evaluate_comp.scm 963 */
										obj_t BgL_arg2731z00_3164;

										BgL_arg2731z00_3164 =
											VECTOR_REF(((obj_t) BgL_bcz00_3141), ((long) 2));
										BgL_arg2725z00_3162 =
											BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_15516,
											BgL_arg2731z00_3164);
									}
									return
										DOUBLE_TO_REAL(
										(REAL_TO_DOUBLE(BgL_arg2724z00_3161) -
											REAL_TO_DOUBLE(BgL_arg2725z00_3162)));
								}
								break;
							case ((long) 8):

								{	/* Eval/evaluate_comp.scm 964 */
									obj_t BgL_arg2733z00_3165;
									obj_t BgL_arg2734z00_3166;

									{	/* Eval/evaluate_comp.scm 964 */
										obj_t BgL_arg2735z00_3167;

										BgL_arg2735z00_3167 =
											VECTOR_REF(((obj_t) BgL_bcz00_3141), ((long) 1));
										BgL_arg2733z00_3165 =
											BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_15516,
											BgL_arg2735z00_3167);
									}
									{	/* Eval/evaluate_comp.scm 964 */
										obj_t BgL_arg2736z00_3168;

										BgL_arg2736z00_3168 =
											VECTOR_REF(((obj_t) BgL_bcz00_3141), ((long) 2));
										BgL_arg2734z00_3166 =
											BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_15516,
											BgL_arg2736z00_3168);
									}
									return
										DOUBLE_TO_REAL(
										(REAL_TO_DOUBLE(BgL_arg2733z00_3165) *
											REAL_TO_DOUBLE(BgL_arg2734z00_3166)));
								}
								break;
							case ((long) 9):

								{	/* Eval/evaluate_comp.scm 965 */
									obj_t BgL_arg2737z00_3169;
									obj_t BgL_arg2738z00_3170;

									{	/* Eval/evaluate_comp.scm 965 */
										obj_t BgL_arg2739z00_3171;

										BgL_arg2739z00_3171 =
											VECTOR_REF(((obj_t) BgL_bcz00_3141), ((long) 1));
										BgL_arg2737z00_3169 =
											BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_15516,
											BgL_arg2739z00_3171);
									}
									{	/* Eval/evaluate_comp.scm 965 */
										obj_t BgL_arg2740z00_3172;

										BgL_arg2740z00_3172 =
											VECTOR_REF(((obj_t) BgL_bcz00_3141), ((long) 2));
										BgL_arg2738z00_3170 =
											BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_15516,
											BgL_arg2740z00_3172);
									}
									return
										DOUBLE_TO_REAL(
										(REAL_TO_DOUBLE(BgL_arg2737z00_3169) /
											REAL_TO_DOUBLE(BgL_arg2738z00_3170)));
								}
								break;
							case ((long) 10):

								{	/* Eval/evaluate_comp.scm 966 */
									obj_t BgL_arg2742z00_3173;

									{	/* Eval/evaluate_comp.scm 966 */
										obj_t BgL_fun2743z00_3174;

										BgL_fun2743z00_3174 =
											VECTOR_REF(((obj_t) BgL_bcz00_3141), ((long) 1));
										BgL_arg2742z00_3173 =
											PROCEDURE_ENTRY(BgL_fun2743z00_3174) (BgL_fun2743z00_3174,
											BgL_sz00_15516, BEOA);
									}
									return
										DOUBLE_TO_REAL((double) ((long) CINT(BgL_arg2742z00_3173)));
								} break;
							case ((long) 11):

								{	/* Eval/evaluate_comp.scm 967 */
									obj_t BgL_arg2744z00_3175;
									obj_t BgL_arg2746z00_3176;

									{	/* Eval/evaluate_comp.scm 967 */
										obj_t BgL_fun2747z00_3177;

										BgL_fun2747z00_3177 =
											VECTOR_REF(((obj_t) BgL_bcz00_3141), ((long) 1));
										BgL_arg2744z00_3175 =
											PROCEDURE_ENTRY(BgL_fun2747z00_3177) (BgL_fun2747z00_3177,
											BgL_sz00_15516, BEOA);
									}
									{	/* Eval/evaluate_comp.scm 967 */
										obj_t BgL_fun2748z00_3178;

										BgL_fun2748z00_3178 =
											VECTOR_REF(((obj_t) BgL_bcz00_3141), ((long) 2));
										BgL_arg2746z00_3176 =
											PROCEDURE_ENTRY(BgL_fun2748z00_3178) (BgL_fun2748z00_3178,
											BgL_sz00_15516, BEOA);
									}
									{	/* Eval/evaluate_comp.scm 967 */
										double BgL_tmpz00_24002;

										{	/* Eval/evaluate_comp.scm 967 */
											long BgL_tmpz00_24003;

											BgL_tmpz00_24003 = (long) CINT(BgL_arg2746z00_3176);
											BgL_tmpz00_24002 =
												BGL_F64VREF(BgL_arg2744z00_3175, BgL_tmpz00_24003);
										}
										return DOUBLE_TO_REAL(BgL_tmpz00_24002);
									}
								}
								break;
							default:
								{	/* Eval/evaluate_comp.scm 968 */
									obj_t BgL_arg2750z00_9441;

									BgL_arg2750z00_9441 =
										VECTOR_REF(((obj_t) BgL_bcz00_3141), ((long) 0));
									return
										BGl_errorz00zz__errorz00
										(BGl_string5798z00zz__evaluate_compz00,
										BGl_string5817z00zz__evaluate_compz00, BgL_arg2750z00_9441);
								}
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 968 */
						obj_t BgL_arg2750z00_9443;

						BgL_arg2750z00_9443 =
							VECTOR_REF(((obj_t) BgL_bcz00_3141), ((long) 0));
						return
							BGl_errorz00zz__errorz00(BGl_string5798z00zz__evaluate_compz00,
							BGl_string5817z00zz__evaluate_compz00, BgL_arg2750z00_9443);
					}
			}
		}

	}



/* arith-expression */
	obj_t BGl_arithzd2expressionzd2zz__evaluate_compz00(BgL_ev_appz00_bglt
		BgL_exprz00_191, obj_t BgL_stkz00_192)
	{
		{	/* Eval/evaluate_comp.scm 971 */
			{	/* Eval/evaluate_comp.scm 973 */
				obj_t BgL_fvalz00_3182;

				BgL_fvalz00_3182 =
					BGl_globalzd2funzd2valuez00zz__evaluate_compz00(
					(((BgL_ev_appz00_bglt) COBJECT(BgL_exprz00_191))->BgL_funz00));
				{	/* Eval/evaluate_comp.scm 974 */
					bool_t BgL_test6422z00_24017;

					if (
						(BgL_fvalz00_3182 ==
							BGl_zb2flzd2envz60zz__r4_numbers_6_5_flonumz00))
						{	/* Eval/evaluate_comp.scm 974 */
							BgL_test6422z00_24017 = ((bool_t) 1);
						}
					else
						{	/* Eval/evaluate_comp.scm 974 */
							if (
								(BgL_fvalz00_3182 ==
									BGl_zd2flzd2envz00zz__r4_numbers_6_5_flonumz00))
								{	/* Eval/evaluate_comp.scm 974 */
									BgL_test6422z00_24017 = ((bool_t) 1);
								}
							else
								{	/* Eval/evaluate_comp.scm 974 */
									if (
										(BgL_fvalz00_3182 ==
											BGl_za2flzd2envz70zz__r4_numbers_6_5_flonumz00))
										{	/* Eval/evaluate_comp.scm 974 */
											BgL_test6422z00_24017 = ((bool_t) 1);
										}
									else
										{	/* Eval/evaluate_comp.scm 974 */
											BgL_test6422z00_24017 =
												(BgL_fvalz00_3182 ==
												BGl_zf2flzd2envz20zz__r4_numbers_6_5_flonumz00);
										}
								}
						}
					if (BgL_test6422z00_24017)
						{	/* Eval/evaluate_comp.scm 975 */
							obj_t BgL_bcz00_3187;

							BgL_bcz00_3187 =
								BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(
								((obj_t) BgL_exprz00_191), BgL_stkz00_192);
							{	/* Eval/evaluate_comp.scm 976 */
								obj_t BgL_zc3z04anonymousza32755ze3z87_13871;

								BgL_zc3z04anonymousza32755ze3z87_13871 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza32755ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 1)));
								PROCEDURE_SET(BgL_zc3z04anonymousza32755ze3z87_13871,
									(int) (((long) 0)), BgL_bcz00_3187);
								return BgL_zc3z04anonymousza32755ze3z87_13871;
							}
						}
					else
						{	/* Eval/evaluate_comp.scm 974 */
							return BFALSE;
						}
				}
			}
		}

	}



/* &<@anonymous:2755> */
	obj_t BGl_z62zc3z04anonymousza32755ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13872, obj_t BgL_sz00_13874)
	{
		{	/* Eval/evaluate_comp.scm 976 */
			{	/* Eval/evaluate_comp.scm 976 */
				obj_t BgL_bcz00_13873;

				BgL_bcz00_13873 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13872, (int) (((long) 0))));
				{	/* Eval/evaluate_comp.scm 976 */
					double BgL_tmpz00_24035;

					{	/* Eval/evaluate_comp.scm 976 */
						obj_t BgL_bpz00_16466;

						BgL_bpz00_16466 = VECTOR_REF(((obj_t) BgL_sz00_13874), ((long) 0));
						BgL_tmpz00_24035 =
							BGl_evalzd2floatzd2arithz00zz__evaluate_compz00(BgL_bcz00_13873,
							BgL_sz00_13874);
					}
					return DOUBLE_TO_REAL(BgL_tmpz00_24035);
				}
			}
		}

	}



/* inline-call */
	obj_t BGl_inlinezd2callzd2zz__evaluate_compz00(obj_t BgL_locz00_193,
		BgL_ev_exprz00_bglt BgL_funz00_194, obj_t BgL_argsz00_195,
		obj_t BgL_stkz00_196)
	{
		{	/* Eval/evaluate_comp.scm 1005 */
			{	/* Eval/evaluate_comp.scm 1006 */
				obj_t BgL_valz00_3195;

				BgL_valz00_3195 =
					BGl_globalzd2funzd2valuez00zz__evaluate_compz00(BgL_funz00_194);
				if (CBOOL(BgL_valz00_3195))
					{	/* Eval/evaluate_comp.scm 1008 */
						long BgL_nz00_3196;

						BgL_nz00_3196 = bgl_list_length(BgL_argsz00_195);
						{	/* Eval/evaluate_comp.scm 1009 */
							obj_t BgL__ortest_1227z00_3197;

							if ((BgL_nz00_3196 == ((long) 1)))
								{	/* Eval/evaluate_comp.scm 1010 */
									obj_t BgL_a1z00_3488;

									BgL_a1z00_3488 = CAR(((obj_t) BgL_argsz00_195));
									if (
										(BgL_valz00_3195 ==
											BGl_carzd2envzd2zz__r4_pairs_and_lists_6_3z00))
										{	/* Eval/evaluate_comp.scm 1011 */
											obj_t BgL_a1z00_3490;

											BgL_a1z00_3490 =
												BGl_compz00zz__evaluate_compz00(
												((BgL_ev_exprz00_bglt) BgL_a1z00_3488), BgL_stkz00_196);
											{	/* Eval/evaluate_comp.scm 1011 */
												obj_t BgL_zc3z04anonymousza32872ze3z87_13904;

												BgL_zc3z04anonymousza32872ze3z87_13904 =
													MAKE_FX_PROCEDURE
													(BGl_z62zc3z04anonymousza32872ze3ze5zz__evaluate_compz00,
													(int) (((long) 1)), (int) (((long) 2)));
												PROCEDURE_SET(BgL_zc3z04anonymousza32872ze3z87_13904,
													(int) (((long) 0)), BgL_a1z00_3490);
												PROCEDURE_SET(BgL_zc3z04anonymousza32872ze3z87_13904,
													(int) (((long) 1)), BgL_locz00_193);
												BgL__ortest_1227z00_3197 =
													BgL_zc3z04anonymousza32872ze3z87_13904;
										}}
									else
										{	/* Eval/evaluate_comp.scm 1011 */
											if (
												(BgL_valz00_3195 ==
													BGl_cdrzd2envzd2zz__r4_pairs_and_lists_6_3z00))
												{	/* Eval/evaluate_comp.scm 1011 */
													obj_t BgL_a1z00_3497;

													BgL_a1z00_3497 =
														BGl_compz00zz__evaluate_compz00(
														((BgL_ev_exprz00_bglt) BgL_a1z00_3488),
														BgL_stkz00_196);
													{	/* Eval/evaluate_comp.scm 1011 */
														obj_t BgL_zc3z04anonymousza32875ze3z87_13905;

														BgL_zc3z04anonymousza32875ze3z87_13905 =
															MAKE_FX_PROCEDURE
															(BGl_z62zc3z04anonymousza32875ze3ze5zz__evaluate_compz00,
															(int) (((long) 1)), (int) (((long) 2)));
														PROCEDURE_SET
															(BgL_zc3z04anonymousza32875ze3z87_13905,
															(int) (((long) 0)), BgL_a1z00_3497);
														PROCEDURE_SET
															(BgL_zc3z04anonymousza32875ze3z87_13905,
															(int) (((long) 1)), BgL_locz00_193);
														BgL__ortest_1227z00_3197 =
															BgL_zc3z04anonymousza32875ze3z87_13905;
												}}
											else
												{	/* Eval/evaluate_comp.scm 1011 */
													if (
														(BgL_valz00_3195 ==
															BGl_cadrzd2envzd2zz__r4_pairs_and_lists_6_3z00))
														{	/* Eval/evaluate_comp.scm 1011 */
															obj_t BgL_a1z00_3504;

															BgL_a1z00_3504 =
																BGl_compz00zz__evaluate_compz00(
																((BgL_ev_exprz00_bglt) BgL_a1z00_3488),
																BgL_stkz00_196);
															{	/* Eval/evaluate_comp.scm 1011 */
																obj_t BgL_zc3z04anonymousza32878ze3z87_13906;

																BgL_zc3z04anonymousza32878ze3z87_13906 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3z04anonymousza32878ze3ze5zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 2)));
																PROCEDURE_SET
																	(BgL_zc3z04anonymousza32878ze3z87_13906,
																	(int) (((long) 0)), BgL_a1z00_3504);
																PROCEDURE_SET
																	(BgL_zc3z04anonymousza32878ze3z87_13906,
																	(int) (((long) 1)), BgL_locz00_193);
																BgL__ortest_1227z00_3197 =
																	BgL_zc3z04anonymousza32878ze3z87_13906;
														}}
													else
														{	/* Eval/evaluate_comp.scm 1011 */
															BgL__ortest_1227z00_3197 = BFALSE;
														}
												}
										}
								}
							else
								{	/* Eval/evaluate_comp.scm 1009 */
									BgL__ortest_1227z00_3197 = BFALSE;
								}
							if (CBOOL(BgL__ortest_1227z00_3197))
								{	/* Eval/evaluate_comp.scm 1009 */
									return BgL__ortest_1227z00_3197;
								}
							else
								{	/* Eval/evaluate_comp.scm 1009 */
									if ((BgL_nz00_3196 == ((long) 2)))
										{	/* Eval/evaluate_comp.scm 1013 */
											obj_t BgL_a1z00_3199;
											obj_t BgL_a2z00_3200;

											BgL_a1z00_3199 = CAR(((obj_t) BgL_argsz00_195));
											{	/* Eval/evaluate_comp.scm 1013 */
												obj_t BgL_pairz00_9475;

												BgL_pairz00_9475 = CDR(((obj_t) BgL_argsz00_195));
												BgL_a2z00_3200 = CAR(BgL_pairz00_9475);
											}
											if (
												(BgL_valz00_3195 ==
													BGl_zb2zd2envz60zz__r4_numbers_6_5z00))
												{	/* Eval/evaluate_comp.scm 1014 */
													obj_t BgL_a1z00_3202;
													obj_t BgL_a2z00_3203;

													BgL_a1z00_3202 =
														BGl_compz00zz__evaluate_compz00(
														((BgL_ev_exprz00_bglt) BgL_a1z00_3199),
														BgL_stkz00_196);
													BgL_a2z00_3203 =
														BGl_compz00zz__evaluate_compz00((
															(BgL_ev_exprz00_bglt) BgL_a2z00_3200),
														BgL_stkz00_196);
													{	/* Eval/evaluate_comp.scm 1014 */
														obj_t BgL_zc3z04anonymousza32759ze3z87_13875;

														BgL_zc3z04anonymousza32759ze3z87_13875 =
															MAKE_FX_PROCEDURE
															(BGl_z62zc3z04anonymousza32759ze3ze5zz__evaluate_compz00,
															(int) (((long) 1)), (int) (((long) 3)));
														PROCEDURE_SET
															(BgL_zc3z04anonymousza32759ze3z87_13875,
															(int) (((long) 0)), BgL_a1z00_3202);
														PROCEDURE_SET
															(BgL_zc3z04anonymousza32759ze3z87_13875,
															(int) (((long) 1)), BgL_a2z00_3203);
														PROCEDURE_SET
															(BgL_zc3z04anonymousza32759ze3z87_13875,
															(int) (((long) 2)), BgL_locz00_193);
														return BgL_zc3z04anonymousza32759ze3z87_13875;
													}
												}
											else
												{	/* Eval/evaluate_comp.scm 1014 */
													if (
														(BgL_valz00_3195 ==
															BGl_zd2zd2envz00zz__r4_numbers_6_5z00))
														{	/* Eval/evaluate_comp.scm 1014 */
															obj_t BgL_a1z00_3212;
															obj_t BgL_a2z00_3213;

															BgL_a1z00_3212 =
																BGl_compz00zz__evaluate_compz00(
																((BgL_ev_exprz00_bglt) BgL_a1z00_3199),
																BgL_stkz00_196);
															BgL_a2z00_3213 =
																BGl_compz00zz__evaluate_compz00((
																	(BgL_ev_exprz00_bglt) BgL_a2z00_3200),
																BgL_stkz00_196);
															{	/* Eval/evaluate_comp.scm 1014 */
																obj_t BgL_zc3z04anonymousza32763ze3z87_13876;

																BgL_zc3z04anonymousza32763ze3z87_13876 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3z04anonymousza32763ze3ze5zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 3)));
																PROCEDURE_SET
																	(BgL_zc3z04anonymousza32763ze3z87_13876,
																	(int) (((long) 0)), BgL_a1z00_3212);
																PROCEDURE_SET
																	(BgL_zc3z04anonymousza32763ze3z87_13876,
																	(int) (((long) 1)), BgL_a2z00_3213);
																PROCEDURE_SET
																	(BgL_zc3z04anonymousza32763ze3z87_13876,
																	(int) (((long) 2)), BgL_locz00_193);
																return BgL_zc3z04anonymousza32763ze3z87_13876;
															}
														}
													else
														{	/* Eval/evaluate_comp.scm 1014 */
															if (
																(BgL_valz00_3195 ==
																	BGl_za2zd2envz70zz__r4_numbers_6_5z00))
																{	/* Eval/evaluate_comp.scm 1014 */
																	obj_t BgL_a1z00_3222;
																	obj_t BgL_a2z00_3223;

																	BgL_a1z00_3222 =
																		BGl_compz00zz__evaluate_compz00(
																		((BgL_ev_exprz00_bglt) BgL_a1z00_3199),
																		BgL_stkz00_196);
																	BgL_a2z00_3223 =
																		BGl_compz00zz__evaluate_compz00((
																			(BgL_ev_exprz00_bglt) BgL_a2z00_3200),
																		BgL_stkz00_196);
																	{	/* Eval/evaluate_comp.scm 1014 */
																		obj_t
																			BgL_zc3z04anonymousza32767ze3z87_13877;
																		BgL_zc3z04anonymousza32767ze3z87_13877 =
																			MAKE_FX_PROCEDURE
																			(BGl_z62zc3z04anonymousza32767ze3ze5zz__evaluate_compz00,
																			(int) (((long) 1)), (int) (((long) 3)));
																		PROCEDURE_SET
																			(BgL_zc3z04anonymousza32767ze3z87_13877,
																			(int) (((long) 0)), BgL_a1z00_3222);
																		PROCEDURE_SET
																			(BgL_zc3z04anonymousza32767ze3z87_13877,
																			(int) (((long) 1)), BgL_a2z00_3223);
																		PROCEDURE_SET
																			(BgL_zc3z04anonymousza32767ze3z87_13877,
																			(int) (((long) 2)), BgL_locz00_193);
																		return
																			BgL_zc3z04anonymousza32767ze3z87_13877;
																	}
																}
															else
																{	/* Eval/evaluate_comp.scm 1014 */
																	if (
																		(BgL_valz00_3195 ==
																			BGl_zf2zd2envz20zz__r4_numbers_6_5z00))
																		{	/* Eval/evaluate_comp.scm 1014 */
																			obj_t BgL_a1z00_3232;
																			obj_t BgL_a2z00_3233;

																			BgL_a1z00_3232 =
																				BGl_compz00zz__evaluate_compz00(
																				((BgL_ev_exprz00_bglt) BgL_a1z00_3199),
																				BgL_stkz00_196);
																			BgL_a2z00_3233 =
																				BGl_compz00zz__evaluate_compz00((
																					(BgL_ev_exprz00_bglt) BgL_a2z00_3200),
																				BgL_stkz00_196);
																			{	/* Eval/evaluate_comp.scm 1014 */
																				obj_t
																					BgL_zc3z04anonymousza32771ze3z87_13878;
																				BgL_zc3z04anonymousza32771ze3z87_13878 =
																					MAKE_FX_PROCEDURE
																					(BGl_z62zc3z04anonymousza32771ze3ze5zz__evaluate_compz00,
																					(int) (((long) 1)),
																					(int) (((long) 3)));
																				PROCEDURE_SET
																					(BgL_zc3z04anonymousza32771ze3z87_13878,
																					(int) (((long) 0)), BgL_a1z00_3232);
																				PROCEDURE_SET
																					(BgL_zc3z04anonymousza32771ze3z87_13878,
																					(int) (((long) 1)), BgL_a2z00_3233);
																				PROCEDURE_SET
																					(BgL_zc3z04anonymousza32771ze3z87_13878,
																					(int) (((long) 2)), BgL_locz00_193);
																				return
																					BgL_zc3z04anonymousza32771ze3z87_13878;
																			}
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 1014 */
																			if (
																				(BgL_valz00_3195 ==
																					BGl_zc3zd2envz11zz__r4_numbers_6_5z00))
																				{	/* Eval/evaluate_comp.scm 1014 */
																					obj_t BgL_a1z00_3242;
																					obj_t BgL_a2z00_3243;

																					BgL_a1z00_3242 =
																						BGl_compz00zz__evaluate_compz00(
																						((BgL_ev_exprz00_bglt)
																							BgL_a1z00_3199), BgL_stkz00_196);
																					BgL_a2z00_3243 =
																						BGl_compz00zz__evaluate_compz00((
																							(BgL_ev_exprz00_bglt)
																							BgL_a2z00_3200), BgL_stkz00_196);
																					{	/* Eval/evaluate_comp.scm 1014 */
																						obj_t
																							BgL_zc3z04anonymousza32775ze3z87_13879;
																						BgL_zc3z04anonymousza32775ze3z87_13879
																							=
																							MAKE_FX_PROCEDURE
																							(BGl_z62zc3z04anonymousza32775ze3ze5zz__evaluate_compz00,
																							(int) (((long) 1)),
																							(int) (((long) 3)));
																						PROCEDURE_SET
																							(BgL_zc3z04anonymousza32775ze3z87_13879,
																							(int) (((long) 0)),
																							BgL_a1z00_3242);
																						PROCEDURE_SET
																							(BgL_zc3z04anonymousza32775ze3z87_13879,
																							(int) (((long) 1)),
																							BgL_a2z00_3243);
																						PROCEDURE_SET
																							(BgL_zc3z04anonymousza32775ze3z87_13879,
																							(int) (((long) 2)),
																							BgL_locz00_193);
																						return
																							BgL_zc3z04anonymousza32775ze3z87_13879;
																					}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 1014 */
																					if (
																						(BgL_valz00_3195 ==
																							BGl_ze3zd2envz31zz__r4_numbers_6_5z00))
																						{	/* Eval/evaluate_comp.scm 1014 */
																							obj_t BgL_a1z00_3252;
																							obj_t BgL_a2z00_3253;

																							BgL_a1z00_3252 =
																								BGl_compz00zz__evaluate_compz00(
																								((BgL_ev_exprz00_bglt)
																									BgL_a1z00_3199),
																								BgL_stkz00_196);
																							BgL_a2z00_3253 =
																								BGl_compz00zz__evaluate_compz00(
																								((BgL_ev_exprz00_bglt)
																									BgL_a2z00_3200),
																								BgL_stkz00_196);
																							{	/* Eval/evaluate_comp.scm 1014 */
																								obj_t
																									BgL_zc3z04anonymousza32779ze3z87_13880;
																								BgL_zc3z04anonymousza32779ze3z87_13880
																									=
																									MAKE_FX_PROCEDURE
																									(BGl_z62zc3z04anonymousza32779ze3ze5zz__evaluate_compz00,
																									(int) (((long) 1)),
																									(int) (((long) 3)));
																								PROCEDURE_SET
																									(BgL_zc3z04anonymousza32779ze3z87_13880,
																									(int) (((long) 0)),
																									BgL_a1z00_3252);
																								PROCEDURE_SET
																									(BgL_zc3z04anonymousza32779ze3z87_13880,
																									(int) (((long) 1)),
																									BgL_a2z00_3253);
																								PROCEDURE_SET
																									(BgL_zc3z04anonymousza32779ze3z87_13880,
																									(int) (((long) 2)),
																									BgL_locz00_193);
																								return
																									BgL_zc3z04anonymousza32779ze3z87_13880;
																							}
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 1014 */
																							if (
																								(BgL_valz00_3195 ==
																									BGl_zc3zd3zd2envzc2zz__r4_numbers_6_5z00))
																								{	/* Eval/evaluate_comp.scm 1014 */
																									obj_t BgL_a1z00_3262;
																									obj_t BgL_a2z00_3263;

																									BgL_a1z00_3262 =
																										BGl_compz00zz__evaluate_compz00
																										(((BgL_ev_exprz00_bglt)
																											BgL_a1z00_3199),
																										BgL_stkz00_196);
																									BgL_a2z00_3263 =
																										BGl_compz00zz__evaluate_compz00
																										(((BgL_ev_exprz00_bglt)
																											BgL_a2z00_3200),
																										BgL_stkz00_196);
																									{	/* Eval/evaluate_comp.scm 1014 */
																										obj_t
																											BgL_zc3z04anonymousza32783ze3z87_13881;
																										BgL_zc3z04anonymousza32783ze3z87_13881
																											=
																											MAKE_FX_PROCEDURE
																											(BGl_z62zc3z04anonymousza32783ze3ze5zz__evaluate_compz00,
																											(int) (((long) 1)),
																											(int) (((long) 3)));
																										PROCEDURE_SET
																											(BgL_zc3z04anonymousza32783ze3z87_13881,
																											(int) (((long) 0)),
																											BgL_a1z00_3262);
																										PROCEDURE_SET
																											(BgL_zc3z04anonymousza32783ze3z87_13881,
																											(int) (((long) 1)),
																											BgL_a2z00_3263);
																										PROCEDURE_SET
																											(BgL_zc3z04anonymousza32783ze3z87_13881,
																											(int) (((long) 2)),
																											BgL_locz00_193);
																										return
																											BgL_zc3z04anonymousza32783ze3z87_13881;
																									}
																								}
																							else
																								{	/* Eval/evaluate_comp.scm 1014 */
																									if (
																										(BgL_valz00_3195 ==
																											BGl_ze3zd3zd2envze2zz__r4_numbers_6_5z00))
																										{	/* Eval/evaluate_comp.scm 1014 */
																											obj_t BgL_a1z00_3272;
																											obj_t BgL_a2z00_3273;

																											BgL_a1z00_3272 =
																												BGl_compz00zz__evaluate_compz00
																												(((BgL_ev_exprz00_bglt)
																													BgL_a1z00_3199),
																												BgL_stkz00_196);
																											BgL_a2z00_3273 =
																												BGl_compz00zz__evaluate_compz00
																												(((BgL_ev_exprz00_bglt)
																													BgL_a2z00_3200),
																												BgL_stkz00_196);
																											{	/* Eval/evaluate_comp.scm 1014 */
																												obj_t
																													BgL_zc3z04anonymousza32787ze3z87_13882;
																												BgL_zc3z04anonymousza32787ze3z87_13882
																													=
																													MAKE_FX_PROCEDURE
																													(BGl_z62zc3z04anonymousza32787ze3ze5zz__evaluate_compz00,
																													(int) (((long) 1)),
																													(int) (((long) 3)));
																												PROCEDURE_SET
																													(BgL_zc3z04anonymousza32787ze3z87_13882,
																													(int) (((long) 0)),
																													BgL_a1z00_3272);
																												PROCEDURE_SET
																													(BgL_zc3z04anonymousza32787ze3z87_13882,
																													(int) (((long) 1)),
																													BgL_a2z00_3273);
																												PROCEDURE_SET
																													(BgL_zc3z04anonymousza32787ze3z87_13882,
																													(int) (((long) 2)),
																													BgL_locz00_193);
																												return
																													BgL_zc3z04anonymousza32787ze3z87_13882;
																											}
																										}
																									else
																										{	/* Eval/evaluate_comp.scm 1014 */
																											if (
																												(BgL_valz00_3195 ==
																													BGl_zd3zd2envz01zz__r4_numbers_6_5z00))
																												{	/* Eval/evaluate_comp.scm 1014 */
																													obj_t BgL_a1z00_3282;
																													obj_t BgL_a2z00_3283;

																													BgL_a1z00_3282 =
																														BGl_compz00zz__evaluate_compz00
																														(((BgL_ev_exprz00_bglt) BgL_a1z00_3199), BgL_stkz00_196);
																													BgL_a2z00_3283 =
																														BGl_compz00zz__evaluate_compz00
																														(((BgL_ev_exprz00_bglt) BgL_a2z00_3200), BgL_stkz00_196);
																													{	/* Eval/evaluate_comp.scm 1014 */
																														obj_t
																															BgL_zc3z04anonymousza32791ze3z87_13883;
																														BgL_zc3z04anonymousza32791ze3z87_13883
																															=
																															MAKE_FX_PROCEDURE
																															(BGl_z62zc3z04anonymousza32791ze3ze5zz__evaluate_compz00,
																															(int) (((long)
																																	1)),
																															(int) (((long)
																																	3)));
																														PROCEDURE_SET
																															(BgL_zc3z04anonymousza32791ze3z87_13883,
																															(int) (((long)
																																	0)),
																															BgL_a1z00_3282);
																														PROCEDURE_SET
																															(BgL_zc3z04anonymousza32791ze3z87_13883,
																															(int) (((long)
																																	1)),
																															BgL_a2z00_3283);
																														PROCEDURE_SET
																															(BgL_zc3z04anonymousza32791ze3z87_13883,
																															(int) (((long)
																																	2)),
																															BgL_locz00_193);
																														return
																															BgL_zc3z04anonymousza32791ze3z87_13883;
																													}
																												}
																											else
																												{	/* Eval/evaluate_comp.scm 1014 */
																													if (
																														(BgL_valz00_3195 ==
																															BGl_zb2fxzd2envz60zz__r4_numbers_6_5_fixnumz00))
																														{	/* Eval/evaluate_comp.scm 1014 */
																															obj_t
																																BgL_a1z00_3292;
																															obj_t
																																BgL_a2z00_3293;
																															BgL_a1z00_3292 =
																																BGl_compz00zz__evaluate_compz00
																																(((BgL_ev_exprz00_bglt) BgL_a1z00_3199), BgL_stkz00_196);
																															BgL_a2z00_3293 =
																																BGl_compz00zz__evaluate_compz00
																																(((BgL_ev_exprz00_bglt) BgL_a2z00_3200), BgL_stkz00_196);
																															{	/* Eval/evaluate_comp.scm 1014 */
																																obj_t
																																	BgL_zc3z04anonymousza32795ze3z87_13884;
																																BgL_zc3z04anonymousza32795ze3z87_13884
																																	=
																																	MAKE_FX_PROCEDURE
																																	(BGl_z62zc3z04anonymousza32795ze3ze5zz__evaluate_compz00,
																																	(int) (((long)
																																			1)),
																																	(int) (((long)
																																			3)));
																																PROCEDURE_SET
																																	(BgL_zc3z04anonymousza32795ze3z87_13884,
																																	(int) (((long)
																																			0)),
																																	BgL_a1z00_3292);
																																PROCEDURE_SET
																																	(BgL_zc3z04anonymousza32795ze3z87_13884,
																																	(int) (((long)
																																			1)),
																																	BgL_a2z00_3293);
																																PROCEDURE_SET
																																	(BgL_zc3z04anonymousza32795ze3z87_13884,
																																	(int) (((long)
																																			2)),
																																	BgL_locz00_193);
																																return
																																	BgL_zc3z04anonymousza32795ze3z87_13884;
																															}
																														}
																													else
																														{	/* Eval/evaluate_comp.scm 1014 */
																															if (
																																(BgL_valz00_3195
																																	==
																																	BGl_zd2fxzd2envz00zz__r4_numbers_6_5_fixnumz00))
																																{	/* Eval/evaluate_comp.scm 1014 */
																																	obj_t
																																		BgL_a1z00_3302;
																																	obj_t
																																		BgL_a2z00_3303;
																																	BgL_a1z00_3302
																																		=
																																		BGl_compz00zz__evaluate_compz00
																																		(((BgL_ev_exprz00_bglt) BgL_a1z00_3199), BgL_stkz00_196);
																																	BgL_a2z00_3303
																																		=
																																		BGl_compz00zz__evaluate_compz00
																																		(((BgL_ev_exprz00_bglt) BgL_a2z00_3200), BgL_stkz00_196);
																																	{	/* Eval/evaluate_comp.scm 1014 */
																																		obj_t
																																			BgL_zc3z04anonymousza32799ze3z87_13885;
																																		BgL_zc3z04anonymousza32799ze3z87_13885
																																			=
																																			MAKE_FX_PROCEDURE
																																			(BGl_z62zc3z04anonymousza32799ze3ze5zz__evaluate_compz00,
																																			(int) ((
																																					(long)
																																					1)),
																																			(int) ((
																																					(long)
																																					3)));
																																		PROCEDURE_SET
																																			(BgL_zc3z04anonymousza32799ze3z87_13885,
																																			(int) ((
																																					(long)
																																					0)),
																																			BgL_a1z00_3302);
																																		PROCEDURE_SET
																																			(BgL_zc3z04anonymousza32799ze3z87_13885,
																																			(int) ((
																																					(long)
																																					1)),
																																			BgL_a2z00_3303);
																																		PROCEDURE_SET
																																			(BgL_zc3z04anonymousza32799ze3z87_13885,
																																			(int) ((
																																					(long)
																																					2)),
																																			BgL_locz00_193);
																																		return
																																			BgL_zc3z04anonymousza32799ze3z87_13885;
																																	}
																																}
																															else
																																{	/* Eval/evaluate_comp.scm 1014 */
																																	if (
																																		(BgL_valz00_3195
																																			==
																																			BGl_za2fxzd2envz70zz__r4_numbers_6_5_fixnumz00))
																																		{	/* Eval/evaluate_comp.scm 1014 */
																																			obj_t
																																				BgL_a1z00_3312;
																																			obj_t
																																				BgL_a2z00_3313;
																																			BgL_a1z00_3312
																																				=
																																				BGl_compz00zz__evaluate_compz00
																																				(((BgL_ev_exprz00_bglt) BgL_a1z00_3199), BgL_stkz00_196);
																																			BgL_a2z00_3313
																																				=
																																				BGl_compz00zz__evaluate_compz00
																																				(((BgL_ev_exprz00_bglt) BgL_a2z00_3200), BgL_stkz00_196);
																																			{	/* Eval/evaluate_comp.scm 1014 */
																																				obj_t
																																					BgL_zc3z04anonymousza32803ze3z87_13886;
																																				BgL_zc3z04anonymousza32803ze3z87_13886
																																					=
																																					MAKE_FX_PROCEDURE
																																					(BGl_z62zc3z04anonymousza32803ze3ze5zz__evaluate_compz00,
																																					(int)
																																					(((long) 1)), (int) (((long) 3)));
																																				PROCEDURE_SET
																																					(BgL_zc3z04anonymousza32803ze3z87_13886,
																																					(int)
																																					(((long) 0)), BgL_a1z00_3312);
																																				PROCEDURE_SET
																																					(BgL_zc3z04anonymousza32803ze3z87_13886,
																																					(int)
																																					(((long) 1)), BgL_a2z00_3313);
																																				PROCEDURE_SET
																																					(BgL_zc3z04anonymousza32803ze3z87_13886,
																																					(int)
																																					(((long) 2)), BgL_locz00_193);
																																				return
																																					BgL_zc3z04anonymousza32803ze3z87_13886;
																																			}
																																		}
																																	else
																																		{	/* Eval/evaluate_comp.scm 1014 */
																																			if (
																																				(BgL_valz00_3195
																																					==
																																					BGl_zf2fxzd2envz20zz__r4_numbers_6_5_fixnumz00))
																																				{	/* Eval/evaluate_comp.scm 1014 */
																																					obj_t
																																						BgL_a1z00_3322;
																																					obj_t
																																						BgL_a2z00_3323;
																																					BgL_a1z00_3322
																																						=
																																						BGl_compz00zz__evaluate_compz00
																																						(((BgL_ev_exprz00_bglt) BgL_a1z00_3199), BgL_stkz00_196);
																																					BgL_a2z00_3323
																																						=
																																						BGl_compz00zz__evaluate_compz00
																																						(((BgL_ev_exprz00_bglt) BgL_a2z00_3200), BgL_stkz00_196);
																																					{	/* Eval/evaluate_comp.scm 1014 */
																																						obj_t
																																							BgL_zc3z04anonymousza32807ze3z87_13887;
																																						BgL_zc3z04anonymousza32807ze3z87_13887
																																							=
																																							MAKE_FX_PROCEDURE
																																							(BGl_z62zc3z04anonymousza32807ze3ze5zz__evaluate_compz00,
																																							(int)
																																							(((long) 1)), (int) (((long) 3)));
																																						PROCEDURE_SET
																																							(BgL_zc3z04anonymousza32807ze3z87_13887,
																																							(int)
																																							(((long) 0)), BgL_a1z00_3322);
																																						PROCEDURE_SET
																																							(BgL_zc3z04anonymousza32807ze3z87_13887,
																																							(int)
																																							(((long) 1)), BgL_a2z00_3323);
																																						PROCEDURE_SET
																																							(BgL_zc3z04anonymousza32807ze3z87_13887,
																																							(int)
																																							(((long) 2)), BgL_locz00_193);
																																						return
																																							BgL_zc3z04anonymousza32807ze3z87_13887;
																																					}
																																				}
																																			else
																																				{	/* Eval/evaluate_comp.scm 1014 */
																																					if (
																																						(BgL_valz00_3195
																																							==
																																							BGl_zc3fxzd2envz11zz__r4_numbers_6_5_fixnumz00))
																																						{	/* Eval/evaluate_comp.scm 1014 */
																																							obj_t
																																								BgL_a1z00_3332;
																																							obj_t
																																								BgL_a2z00_3333;
																																							BgL_a1z00_3332
																																								=
																																								BGl_compz00zz__evaluate_compz00
																																								(
																																								((BgL_ev_exprz00_bglt) BgL_a1z00_3199), BgL_stkz00_196);
																																							BgL_a2z00_3333
																																								=
																																								BGl_compz00zz__evaluate_compz00
																																								(
																																								((BgL_ev_exprz00_bglt) BgL_a2z00_3200), BgL_stkz00_196);
																																							{	/* Eval/evaluate_comp.scm 1014 */
																																								obj_t
																																									BgL_zc3z04anonymousza32811ze3z87_13888;
																																								BgL_zc3z04anonymousza32811ze3z87_13888
																																									=
																																									MAKE_FX_PROCEDURE
																																									(BGl_z62zc3z04anonymousza32811ze3ze5zz__evaluate_compz00,
																																									(int)
																																									(((long) 1)), (int) (((long) 3)));
																																								PROCEDURE_SET
																																									(BgL_zc3z04anonymousza32811ze3z87_13888,
																																									(int)
																																									(((long) 0)), BgL_a1z00_3332);
																																								PROCEDURE_SET
																																									(BgL_zc3z04anonymousza32811ze3z87_13888,
																																									(int)
																																									(((long) 1)), BgL_a2z00_3333);
																																								PROCEDURE_SET
																																									(BgL_zc3z04anonymousza32811ze3z87_13888,
																																									(int)
																																									(((long) 2)), BgL_locz00_193);
																																								return
																																									BgL_zc3z04anonymousza32811ze3z87_13888;
																																							}
																																						}
																																					else
																																						{	/* Eval/evaluate_comp.scm 1014 */
																																							if ((BgL_valz00_3195 == BGl_ze3fxzd2envz31zz__r4_numbers_6_5_fixnumz00))
																																								{	/* Eval/evaluate_comp.scm 1014 */
																																									obj_t
																																										BgL_a1z00_3342;
																																									obj_t
																																										BgL_a2z00_3343;
																																									BgL_a1z00_3342
																																										=
																																										BGl_compz00zz__evaluate_compz00
																																										(
																																										((BgL_ev_exprz00_bglt) BgL_a1z00_3199), BgL_stkz00_196);
																																									BgL_a2z00_3343
																																										=
																																										BGl_compz00zz__evaluate_compz00
																																										(
																																										((BgL_ev_exprz00_bglt) BgL_a2z00_3200), BgL_stkz00_196);
																																									{	/* Eval/evaluate_comp.scm 1014 */
																																										obj_t
																																											BgL_zc3z04anonymousza32815ze3z87_13889;
																																										BgL_zc3z04anonymousza32815ze3z87_13889
																																											=
																																											MAKE_FX_PROCEDURE
																																											(BGl_z62zc3z04anonymousza32815ze3ze5zz__evaluate_compz00,
																																											(int)
																																											(((long) 1)), (int) (((long) 3)));
																																										PROCEDURE_SET
																																											(BgL_zc3z04anonymousza32815ze3z87_13889,
																																											(int)
																																											(((long) 0)), BgL_a1z00_3342);
																																										PROCEDURE_SET
																																											(BgL_zc3z04anonymousza32815ze3z87_13889,
																																											(int)
																																											(((long) 1)), BgL_a2z00_3343);
																																										PROCEDURE_SET
																																											(BgL_zc3z04anonymousza32815ze3z87_13889,
																																											(int)
																																											(((long) 2)), BgL_locz00_193);
																																										return
																																											BgL_zc3z04anonymousza32815ze3z87_13889;
																																									}
																																								}
																																							else
																																								{	/* Eval/evaluate_comp.scm 1014 */
																																									if ((BgL_valz00_3195 == BGl_zc3zd3fxzd2envzc2zz__r4_numbers_6_5_fixnumz00))
																																										{	/* Eval/evaluate_comp.scm 1014 */
																																											obj_t
																																												BgL_a1z00_3352;
																																											obj_t
																																												BgL_a2z00_3353;
																																											BgL_a1z00_3352
																																												=
																																												BGl_compz00zz__evaluate_compz00
																																												(
																																												((BgL_ev_exprz00_bglt) BgL_a1z00_3199), BgL_stkz00_196);
																																											BgL_a2z00_3353
																																												=
																																												BGl_compz00zz__evaluate_compz00
																																												(
																																												((BgL_ev_exprz00_bglt) BgL_a2z00_3200), BgL_stkz00_196);
																																											{	/* Eval/evaluate_comp.scm 1014 */
																																												obj_t
																																													BgL_zc3z04anonymousza32819ze3z87_13890;
																																												BgL_zc3z04anonymousza32819ze3z87_13890
																																													=
																																													MAKE_FX_PROCEDURE
																																													(BGl_z62zc3z04anonymousza32819ze3ze5zz__evaluate_compz00,
																																													(int)
																																													(((long) 1)), (int) (((long) 3)));
																																												PROCEDURE_SET
																																													(BgL_zc3z04anonymousza32819ze3z87_13890,
																																													(int)
																																													(((long) 0)), BgL_a1z00_3352);
																																												PROCEDURE_SET
																																													(BgL_zc3z04anonymousza32819ze3z87_13890,
																																													(int)
																																													(((long) 1)), BgL_a2z00_3353);
																																												PROCEDURE_SET
																																													(BgL_zc3z04anonymousza32819ze3z87_13890,
																																													(int)
																																													(((long) 2)), BgL_locz00_193);
																																												return
																																													BgL_zc3z04anonymousza32819ze3z87_13890;
																																											}
																																										}
																																									else
																																										{	/* Eval/evaluate_comp.scm 1014 */
																																											if ((BgL_valz00_3195 == BGl_ze3zd3fxzd2envze2zz__r4_numbers_6_5_fixnumz00))
																																												{	/* Eval/evaluate_comp.scm 1014 */
																																													obj_t
																																														BgL_a1z00_3362;
																																													obj_t
																																														BgL_a2z00_3363;
																																													BgL_a1z00_3362
																																														=
																																														BGl_compz00zz__evaluate_compz00
																																														(
																																														((BgL_ev_exprz00_bglt) BgL_a1z00_3199), BgL_stkz00_196);
																																													BgL_a2z00_3363
																																														=
																																														BGl_compz00zz__evaluate_compz00
																																														(
																																														((BgL_ev_exprz00_bglt) BgL_a2z00_3200), BgL_stkz00_196);
																																													{	/* Eval/evaluate_comp.scm 1014 */
																																														obj_t
																																															BgL_zc3z04anonymousza32823ze3z87_13891;
																																														BgL_zc3z04anonymousza32823ze3z87_13891
																																															=
																																															MAKE_FX_PROCEDURE
																																															(BGl_z62zc3z04anonymousza32823ze3ze5zz__evaluate_compz00,
																																															(int)
																																															(((long) 1)), (int) (((long) 3)));
																																														PROCEDURE_SET
																																															(BgL_zc3z04anonymousza32823ze3z87_13891,
																																															(int)
																																															(((long) 0)), BgL_a1z00_3362);
																																														PROCEDURE_SET
																																															(BgL_zc3z04anonymousza32823ze3z87_13891,
																																															(int)
																																															(((long) 1)), BgL_a2z00_3363);
																																														PROCEDURE_SET
																																															(BgL_zc3z04anonymousza32823ze3z87_13891,
																																															(int)
																																															(((long) 2)), BgL_locz00_193);
																																														return
																																															BgL_zc3z04anonymousza32823ze3z87_13891;
																																													}
																																												}
																																											else
																																												{	/* Eval/evaluate_comp.scm 1014 */
																																													if ((BgL_valz00_3195 == BGl_zd3fxzd2envz01zz__r4_numbers_6_5_fixnumz00))
																																														{	/* Eval/evaluate_comp.scm 1014 */
																																															obj_t
																																																BgL_a1z00_3372;
																																															obj_t
																																																BgL_a2z00_3373;
																																															BgL_a1z00_3372
																																																=
																																																BGl_compz00zz__evaluate_compz00
																																																(
																																																((BgL_ev_exprz00_bglt) BgL_a1z00_3199), BgL_stkz00_196);
																																															BgL_a2z00_3373
																																																=
																																																BGl_compz00zz__evaluate_compz00
																																																(
																																																((BgL_ev_exprz00_bglt) BgL_a2z00_3200), BgL_stkz00_196);
																																															{	/* Eval/evaluate_comp.scm 1014 */
																																																obj_t
																																																	BgL_zc3z04anonymousza32827ze3z87_13892;
																																																BgL_zc3z04anonymousza32827ze3z87_13892
																																																	=
																																																	MAKE_FX_PROCEDURE
																																																	(BGl_z62zc3z04anonymousza32827ze3ze5zz__evaluate_compz00,
																																																	(int)
																																																	(((long) 1)), (int) (((long) 3)));
																																																PROCEDURE_SET
																																																	(BgL_zc3z04anonymousza32827ze3z87_13892,
																																																	(int)
																																																	(((long) 0)), BgL_a1z00_3372);
																																																PROCEDURE_SET
																																																	(BgL_zc3z04anonymousza32827ze3z87_13892,
																																																	(int)
																																																	(((long) 1)), BgL_a2z00_3373);
																																																PROCEDURE_SET
																																																	(BgL_zc3z04anonymousza32827ze3z87_13892,
																																																	(int)
																																																	(((long) 2)), BgL_locz00_193);
																																																return
																																																	BgL_zc3z04anonymousza32827ze3z87_13892;
																																															}
																																														}
																																													else
																																														{	/* Eval/evaluate_comp.scm 1014 */
																																															if ((BgL_valz00_3195 == BGl_zb2flzd2envz60zz__r4_numbers_6_5_flonumz00))
																																																{	/* Eval/evaluate_comp.scm 1014 */
																																																	obj_t
																																																		BgL_a1z00_3382;
																																																	obj_t
																																																		BgL_a2z00_3383;
																																																	BgL_a1z00_3382
																																																		=
																																																		BGl_compz00zz__evaluate_compz00
																																																		(
																																																		((BgL_ev_exprz00_bglt) BgL_a1z00_3199), BgL_stkz00_196);
																																																	BgL_a2z00_3383
																																																		=
																																																		BGl_compz00zz__evaluate_compz00
																																																		(
																																																		((BgL_ev_exprz00_bglt) BgL_a2z00_3200), BgL_stkz00_196);
																																																	{	/* Eval/evaluate_comp.scm 1014 */
																																																		obj_t
																																																			BgL_zc3z04anonymousza32831ze3z87_13893;
																																																		BgL_zc3z04anonymousza32831ze3z87_13893
																																																			=
																																																			MAKE_FX_PROCEDURE
																																																			(BGl_z62zc3z04anonymousza32831ze3ze5zz__evaluate_compz00,
																																																			(int)
																																																			(((long) 1)), (int) (((long) 3)));
																																																		PROCEDURE_SET
																																																			(BgL_zc3z04anonymousza32831ze3z87_13893,
																																																			(int)
																																																			(((long) 0)), BgL_a1z00_3382);
																																																		PROCEDURE_SET
																																																			(BgL_zc3z04anonymousza32831ze3z87_13893,
																																																			(int)
																																																			(((long) 1)), BgL_a2z00_3383);
																																																		PROCEDURE_SET
																																																			(BgL_zc3z04anonymousza32831ze3z87_13893,
																																																			(int)
																																																			(((long) 2)), BgL_locz00_193);
																																																		return
																																																			BgL_zc3z04anonymousza32831ze3z87_13893;
																																																	}
																																																}
																																															else
																																																{	/* Eval/evaluate_comp.scm 1014 */
																																																	if ((BgL_valz00_3195 == BGl_zd2flzd2envz00zz__r4_numbers_6_5_flonumz00))
																																																		{	/* Eval/evaluate_comp.scm 1014 */
																																																			obj_t
																																																				BgL_a1z00_3392;
																																																			obj_t
																																																				BgL_a2z00_3393;
																																																			BgL_a1z00_3392
																																																				=
																																																				BGl_compz00zz__evaluate_compz00
																																																				(
																																																				((BgL_ev_exprz00_bglt) BgL_a1z00_3199), BgL_stkz00_196);
																																																			BgL_a2z00_3393
																																																				=
																																																				BGl_compz00zz__evaluate_compz00
																																																				(
																																																				((BgL_ev_exprz00_bglt) BgL_a2z00_3200), BgL_stkz00_196);
																																																			{	/* Eval/evaluate_comp.scm 1014 */
																																																				obj_t
																																																					BgL_zc3z04anonymousza32835ze3z87_13894;
																																																				BgL_zc3z04anonymousza32835ze3z87_13894
																																																					=
																																																					MAKE_FX_PROCEDURE
																																																					(BGl_z62zc3z04anonymousza32835ze3ze5zz__evaluate_compz00,
																																																					(int)
																																																					(((long) 1)), (int) (((long) 3)));
																																																				PROCEDURE_SET
																																																					(BgL_zc3z04anonymousza32835ze3z87_13894,
																																																					(int)
																																																					(((long) 0)), BgL_a1z00_3392);
																																																				PROCEDURE_SET
																																																					(BgL_zc3z04anonymousza32835ze3z87_13894,
																																																					(int)
																																																					(((long) 1)), BgL_a2z00_3393);
																																																				PROCEDURE_SET
																																																					(BgL_zc3z04anonymousza32835ze3z87_13894,
																																																					(int)
																																																					(((long) 2)), BgL_locz00_193);
																																																				return
																																																					BgL_zc3z04anonymousza32835ze3z87_13894;
																																																			}
																																																		}
																																																	else
																																																		{	/* Eval/evaluate_comp.scm 1014 */
																																																			if ((BgL_valz00_3195 == BGl_za2flzd2envz70zz__r4_numbers_6_5_flonumz00))
																																																				{	/* Eval/evaluate_comp.scm 1014 */
																																																					obj_t
																																																						BgL_a1z00_3402;
																																																					obj_t
																																																						BgL_a2z00_3403;
																																																					BgL_a1z00_3402
																																																						=
																																																						BGl_compz00zz__evaluate_compz00
																																																						(
																																																						((BgL_ev_exprz00_bglt) BgL_a1z00_3199), BgL_stkz00_196);
																																																					BgL_a2z00_3403
																																																						=
																																																						BGl_compz00zz__evaluate_compz00
																																																						(
																																																						((BgL_ev_exprz00_bglt) BgL_a2z00_3200), BgL_stkz00_196);
																																																					{	/* Eval/evaluate_comp.scm 1014 */
																																																						obj_t
																																																							BgL_zc3z04anonymousza32839ze3z87_13895;
																																																						BgL_zc3z04anonymousza32839ze3z87_13895
																																																							=
																																																							MAKE_FX_PROCEDURE
																																																							(BGl_z62zc3z04anonymousza32839ze3ze5zz__evaluate_compz00,
																																																							(int)
																																																							(((long) 1)), (int) (((long) 3)));
																																																						PROCEDURE_SET
																																																							(BgL_zc3z04anonymousza32839ze3z87_13895,
																																																							(int)
																																																							(((long) 0)), BgL_a1z00_3402);
																																																						PROCEDURE_SET
																																																							(BgL_zc3z04anonymousza32839ze3z87_13895,
																																																							(int)
																																																							(((long) 1)), BgL_a2z00_3403);
																																																						PROCEDURE_SET
																																																							(BgL_zc3z04anonymousza32839ze3z87_13895,
																																																							(int)
																																																							(((long) 2)), BgL_locz00_193);
																																																						return
																																																							BgL_zc3z04anonymousza32839ze3z87_13895;
																																																					}
																																																				}
																																																			else
																																																				{	/* Eval/evaluate_comp.scm 1014 */
																																																					if ((BgL_valz00_3195 == BGl_zf2flzd2envz20zz__r4_numbers_6_5_flonumz00))
																																																						{	/* Eval/evaluate_comp.scm 1014 */
																																																							obj_t
																																																								BgL_a1z00_3412;
																																																							obj_t
																																																								BgL_a2z00_3413;
																																																							BgL_a1z00_3412
																																																								=
																																																								BGl_compz00zz__evaluate_compz00
																																																								(
																																																								((BgL_ev_exprz00_bglt) BgL_a1z00_3199), BgL_stkz00_196);
																																																							BgL_a2z00_3413
																																																								=
																																																								BGl_compz00zz__evaluate_compz00
																																																								(
																																																								((BgL_ev_exprz00_bglt) BgL_a2z00_3200), BgL_stkz00_196);
																																																							{	/* Eval/evaluate_comp.scm 1014 */
																																																								obj_t
																																																									BgL_zc3z04anonymousza32843ze3z87_13896;
																																																								BgL_zc3z04anonymousza32843ze3z87_13896
																																																									=
																																																									MAKE_FX_PROCEDURE
																																																									(BGl_z62zc3z04anonymousza32843ze3ze5zz__evaluate_compz00,
																																																									(int)
																																																									(((long) 1)), (int) (((long) 3)));
																																																								PROCEDURE_SET
																																																									(BgL_zc3z04anonymousza32843ze3z87_13896,
																																																									(int)
																																																									(((long) 0)), BgL_a1z00_3412);
																																																								PROCEDURE_SET
																																																									(BgL_zc3z04anonymousza32843ze3z87_13896,
																																																									(int)
																																																									(((long) 1)), BgL_a2z00_3413);
																																																								PROCEDURE_SET
																																																									(BgL_zc3z04anonymousza32843ze3z87_13896,
																																																									(int)
																																																									(((long) 2)), BgL_locz00_193);
																																																								return
																																																									BgL_zc3z04anonymousza32843ze3z87_13896;
																																																							}
																																																						}
																																																					else
																																																						{	/* Eval/evaluate_comp.scm 1014 */
																																																							if ((BgL_valz00_3195 == BGl_zc3flzd2envz11zz__r4_numbers_6_5_flonumz00))
																																																								{	/* Eval/evaluate_comp.scm 1014 */
																																																									obj_t
																																																										BgL_a1z00_3422;
																																																									obj_t
																																																										BgL_a2z00_3423;
																																																									BgL_a1z00_3422
																																																										=
																																																										BGl_compz00zz__evaluate_compz00
																																																										(
																																																										((BgL_ev_exprz00_bglt) BgL_a1z00_3199), BgL_stkz00_196);
																																																									BgL_a2z00_3423
																																																										=
																																																										BGl_compz00zz__evaluate_compz00
																																																										(
																																																										((BgL_ev_exprz00_bglt) BgL_a2z00_3200), BgL_stkz00_196);
																																																									{	/* Eval/evaluate_comp.scm 1014 */
																																																										obj_t
																																																											BgL_zc3z04anonymousza32847ze3z87_13897;
																																																										BgL_zc3z04anonymousza32847ze3z87_13897
																																																											=
																																																											MAKE_FX_PROCEDURE
																																																											(BGl_z62zc3z04anonymousza32847ze3ze5zz__evaluate_compz00,
																																																											(int)
																																																											(((long) 1)), (int) (((long) 3)));
																																																										PROCEDURE_SET
																																																											(BgL_zc3z04anonymousza32847ze3z87_13897,
																																																											(int)
																																																											(((long) 0)), BgL_a1z00_3422);
																																																										PROCEDURE_SET
																																																											(BgL_zc3z04anonymousza32847ze3z87_13897,
																																																											(int)
																																																											(((long) 1)), BgL_a2z00_3423);
																																																										PROCEDURE_SET
																																																											(BgL_zc3z04anonymousza32847ze3z87_13897,
																																																											(int)
																																																											(((long) 2)), BgL_locz00_193);
																																																										return
																																																											BgL_zc3z04anonymousza32847ze3z87_13897;
																																																									}
																																																								}
																																																							else
																																																								{	/* Eval/evaluate_comp.scm 1014 */
																																																									if ((BgL_valz00_3195 == BGl_ze3flzd2envz31zz__r4_numbers_6_5_flonumz00))
																																																										{	/* Eval/evaluate_comp.scm 1014 */
																																																											obj_t
																																																												BgL_a1z00_3432;
																																																											obj_t
																																																												BgL_a2z00_3433;
																																																											BgL_a1z00_3432
																																																												=
																																																												BGl_compz00zz__evaluate_compz00
																																																												(
																																																												((BgL_ev_exprz00_bglt) BgL_a1z00_3199), BgL_stkz00_196);
																																																											BgL_a2z00_3433
																																																												=
																																																												BGl_compz00zz__evaluate_compz00
																																																												(
																																																												((BgL_ev_exprz00_bglt) BgL_a2z00_3200), BgL_stkz00_196);
																																																											{	/* Eval/evaluate_comp.scm 1014 */
																																																												obj_t
																																																													BgL_zc3z04anonymousza32851ze3z87_13898;
																																																												BgL_zc3z04anonymousza32851ze3z87_13898
																																																													=
																																																													MAKE_FX_PROCEDURE
																																																													(BGl_z62zc3z04anonymousza32851ze3ze5zz__evaluate_compz00,
																																																													(int)
																																																													(((long) 1)), (int) (((long) 3)));
																																																												PROCEDURE_SET
																																																													(BgL_zc3z04anonymousza32851ze3z87_13898,
																																																													(int)
																																																													(((long) 0)), BgL_a1z00_3432);
																																																												PROCEDURE_SET
																																																													(BgL_zc3z04anonymousza32851ze3z87_13898,
																																																													(int)
																																																													(((long) 1)), BgL_a2z00_3433);
																																																												PROCEDURE_SET
																																																													(BgL_zc3z04anonymousza32851ze3z87_13898,
																																																													(int)
																																																													(((long) 2)), BgL_locz00_193);
																																																												return
																																																													BgL_zc3z04anonymousza32851ze3z87_13898;
																																																											}
																																																										}
																																																									else
																																																										{	/* Eval/evaluate_comp.scm 1014 */
																																																											if ((BgL_valz00_3195 == BGl_zc3zd3flzd2envzc2zz__r4_numbers_6_5_flonumz00))
																																																												{	/* Eval/evaluate_comp.scm 1014 */
																																																													obj_t
																																																														BgL_a1z00_3442;
																																																													obj_t
																																																														BgL_a2z00_3443;
																																																													BgL_a1z00_3442
																																																														=
																																																														BGl_compz00zz__evaluate_compz00
																																																														(
																																																														((BgL_ev_exprz00_bglt) BgL_a1z00_3199), BgL_stkz00_196);
																																																													BgL_a2z00_3443
																																																														=
																																																														BGl_compz00zz__evaluate_compz00
																																																														(
																																																														((BgL_ev_exprz00_bglt) BgL_a2z00_3200), BgL_stkz00_196);
																																																													{	/* Eval/evaluate_comp.scm 1014 */
																																																														obj_t
																																																															BgL_zc3z04anonymousza32855ze3z87_13899;
																																																														BgL_zc3z04anonymousza32855ze3z87_13899
																																																															=
																																																															MAKE_FX_PROCEDURE
																																																															(BGl_z62zc3z04anonymousza32855ze3ze5zz__evaluate_compz00,
																																																															(int)
																																																															(((long) 1)), (int) (((long) 3)));
																																																														PROCEDURE_SET
																																																															(BgL_zc3z04anonymousza32855ze3z87_13899,
																																																															(int)
																																																															(((long) 0)), BgL_a1z00_3442);
																																																														PROCEDURE_SET
																																																															(BgL_zc3z04anonymousza32855ze3z87_13899,
																																																															(int)
																																																															(((long) 1)), BgL_a2z00_3443);
																																																														PROCEDURE_SET
																																																															(BgL_zc3z04anonymousza32855ze3z87_13899,
																																																															(int)
																																																															(((long) 2)), BgL_locz00_193);
																																																														return
																																																															BgL_zc3z04anonymousza32855ze3z87_13899;
																																																													}
																																																												}
																																																											else
																																																												{	/* Eval/evaluate_comp.scm 1014 */
																																																													if ((BgL_valz00_3195 == BGl_ze3zd3flzd2envze2zz__r4_numbers_6_5_flonumz00))
																																																														{	/* Eval/evaluate_comp.scm 1014 */
																																																															obj_t
																																																																BgL_a1z00_3452;
																																																															obj_t
																																																																BgL_a2z00_3453;
																																																															BgL_a1z00_3452
																																																																=
																																																																BGl_compz00zz__evaluate_compz00
																																																																(
																																																																((BgL_ev_exprz00_bglt) BgL_a1z00_3199), BgL_stkz00_196);
																																																															BgL_a2z00_3453
																																																																=
																																																																BGl_compz00zz__evaluate_compz00
																																																																(
																																																																((BgL_ev_exprz00_bglt) BgL_a2z00_3200), BgL_stkz00_196);
																																																															{	/* Eval/evaluate_comp.scm 1014 */
																																																																obj_t
																																																																	BgL_zc3z04anonymousza32859ze3z87_13900;
																																																																BgL_zc3z04anonymousza32859ze3z87_13900
																																																																	=
																																																																	MAKE_FX_PROCEDURE
																																																																	(BGl_z62zc3z04anonymousza32859ze3ze5zz__evaluate_compz00,
																																																																	(int)
																																																																	(((long) 1)), (int) (((long) 3)));
																																																																PROCEDURE_SET
																																																																	(BgL_zc3z04anonymousza32859ze3z87_13900,
																																																																	(int)
																																																																	(((long) 0)), BgL_a1z00_3452);
																																																																PROCEDURE_SET
																																																																	(BgL_zc3z04anonymousza32859ze3z87_13900,
																																																																	(int)
																																																																	(((long) 1)), BgL_a2z00_3453);
																																																																PROCEDURE_SET
																																																																	(BgL_zc3z04anonymousza32859ze3z87_13900,
																																																																	(int)
																																																																	(((long) 2)), BgL_locz00_193);
																																																																return
																																																																	BgL_zc3z04anonymousza32859ze3z87_13900;
																																																															}
																																																														}
																																																													else
																																																														{	/* Eval/evaluate_comp.scm 1014 */
																																																															if ((BgL_valz00_3195 == BGl_zd3flzd2envz01zz__r4_numbers_6_5_flonumz00))
																																																																{	/* Eval/evaluate_comp.scm 1014 */
																																																																	obj_t
																																																																		BgL_a1z00_3462;
																																																																	obj_t
																																																																		BgL_a2z00_3463;
																																																																	BgL_a1z00_3462
																																																																		=
																																																																		BGl_compz00zz__evaluate_compz00
																																																																		(
																																																																		((BgL_ev_exprz00_bglt) BgL_a1z00_3199), BgL_stkz00_196);
																																																																	BgL_a2z00_3463
																																																																		=
																																																																		BGl_compz00zz__evaluate_compz00
																																																																		(
																																																																		((BgL_ev_exprz00_bglt) BgL_a2z00_3200), BgL_stkz00_196);
																																																																	{	/* Eval/evaluate_comp.scm 1014 */
																																																																		obj_t
																																																																			BgL_zc3z04anonymousza32863ze3z87_13901;
																																																																		BgL_zc3z04anonymousza32863ze3z87_13901
																																																																			=
																																																																			MAKE_FX_PROCEDURE
																																																																			(BGl_z62zc3z04anonymousza32863ze3ze5zz__evaluate_compz00,
																																																																			(int)
																																																																			(((long) 1)), (int) (((long) 3)));
																																																																		PROCEDURE_SET
																																																																			(BgL_zc3z04anonymousza32863ze3z87_13901,
																																																																			(int)
																																																																			(((long) 0)), BgL_a1z00_3462);
																																																																		PROCEDURE_SET
																																																																			(BgL_zc3z04anonymousza32863ze3z87_13901,
																																																																			(int)
																																																																			(((long) 1)), BgL_a2z00_3463);
																																																																		PROCEDURE_SET
																																																																			(BgL_zc3z04anonymousza32863ze3z87_13901,
																																																																			(int)
																																																																			(((long) 2)), BgL_locz00_193);
																																																																		return
																																																																			BgL_zc3z04anonymousza32863ze3z87_13901;
																																																																	}
																																																																}
																																																															else
																																																																{	/* Eval/evaluate_comp.scm 1014 */
																																																																	if ((BgL_valz00_3195 == BGl_eqzf3zd2envz21zz__r4_equivalence_6_2z00))
																																																																		{	/* Eval/evaluate_comp.scm 1014 */
																																																																			obj_t
																																																																				BgL_a1z00_3472;
																																																																			obj_t
																																																																				BgL_a2z00_3473;
																																																																			BgL_a1z00_3472
																																																																				=
																																																																				BGl_compz00zz__evaluate_compz00
																																																																				(
																																																																				((BgL_ev_exprz00_bglt) BgL_a1z00_3199), BgL_stkz00_196);
																																																																			BgL_a2z00_3473
																																																																				=
																																																																				BGl_compz00zz__evaluate_compz00
																																																																				(
																																																																				((BgL_ev_exprz00_bglt) BgL_a2z00_3200), BgL_stkz00_196);
																																																																			{	/* Eval/evaluate_comp.scm 1014 */
																																																																				obj_t
																																																																					BgL_zc3z04anonymousza32867ze3z87_13902;
																																																																				BgL_zc3z04anonymousza32867ze3z87_13902
																																																																					=
																																																																					MAKE_FX_PROCEDURE
																																																																					(BGl_z62zc3z04anonymousza32867ze3ze5zz__evaluate_compz00,
																																																																					(int)
																																																																					(((long) 1)), (int) (((long) 2)));
																																																																				PROCEDURE_SET
																																																																					(BgL_zc3z04anonymousza32867ze3z87_13902,
																																																																					(int)
																																																																					(((long) 0)), BgL_a1z00_3472);
																																																																				PROCEDURE_SET
																																																																					(BgL_zc3z04anonymousza32867ze3z87_13902,
																																																																					(int)
																																																																					(((long) 1)), BgL_a2z00_3473);
																																																																				return
																																																																					BgL_zc3z04anonymousza32867ze3z87_13902;
																																																																			}
																																																																		}
																																																																	else
																																																																		{	/* Eval/evaluate_comp.scm 1014 */
																																																																			if ((BgL_valz00_3195 == BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00))
																																																																				{	/* Eval/evaluate_comp.scm 1014 */
																																																																					obj_t
																																																																						BgL_a1z00_3480;
																																																																					obj_t
																																																																						BgL_a2z00_3481;
																																																																					BgL_a1z00_3480
																																																																						=
																																																																						BGl_compz00zz__evaluate_compz00
																																																																						(
																																																																						((BgL_ev_exprz00_bglt) BgL_a1z00_3199), BgL_stkz00_196);
																																																																					BgL_a2z00_3481
																																																																						=
																																																																						BGl_compz00zz__evaluate_compz00
																																																																						(
																																																																						((BgL_ev_exprz00_bglt) BgL_a2z00_3200), BgL_stkz00_196);
																																																																					{	/* Eval/evaluate_comp.scm 1014 */
																																																																						obj_t
																																																																							BgL_zc3z04anonymousza32869ze3z87_13903;
																																																																						BgL_zc3z04anonymousza32869ze3z87_13903
																																																																							=
																																																																							MAKE_FX_PROCEDURE
																																																																							(BGl_z62zc3z04anonymousza32869ze3ze5zz__evaluate_compz00,
																																																																							(int)
																																																																							(((long) 1)), (int) (((long) 2)));
																																																																						PROCEDURE_SET
																																																																							(BgL_zc3z04anonymousza32869ze3z87_13903,
																																																																							(int)
																																																																							(((long) 0)), BgL_a1z00_3480);
																																																																						PROCEDURE_SET
																																																																							(BgL_zc3z04anonymousza32869ze3z87_13903,
																																																																							(int)
																																																																							(((long) 1)), BgL_a2z00_3481);
																																																																						return
																																																																							BgL_zc3z04anonymousza32869ze3z87_13903;
																																																																					}
																																																																				}
																																																																			else
																																																																				{	/* Eval/evaluate_comp.scm 1014 */
																																																																					return
																																																																						BFALSE;
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																										}
																								}
																						}
																				}
																		}
																}
														}
												}
										}
									else
										{	/* Eval/evaluate_comp.scm 1012 */
											return BFALSE;
										}
								}
						}
					}
				else
					{	/* Eval/evaluate_comp.scm 1007 */
						return BFALSE;
					}
			}
		}

	}



/* &<@anonymous:2759> */
	obj_t BGl_z62zc3z04anonymousza32759ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13907, obj_t BgL_sz00_13911)
	{
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_13908;
				obj_t BgL_a2z00_13909;
				obj_t BgL_locz00_13910;

				BgL_a1z00_13908 = PROCEDURE_REF(BgL_envz00_13907, (int) (((long) 0)));
				BgL_a2z00_13909 = PROCEDURE_REF(BgL_envz00_13907, (int) (((long) 1)));
				BgL_locz00_13910 = PROCEDURE_REF(BgL_envz00_13907, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					obj_t BgL_bpz00_16467;

					BgL_bpz00_16467 = VECTOR_REF(((obj_t) BgL_sz00_13911), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_a1z00_16468;
						obj_t BgL_a2z00_16469;

						BgL_a1z00_16468 =
							PROCEDURE_ENTRY(BgL_a1z00_13908) (BgL_a1z00_13908, BgL_sz00_13911,
							BEOA);
						BgL_a2z00_16469 =
							PROCEDURE_ENTRY(BgL_a2z00_13909) (BgL_a2z00_13909, BgL_sz00_13911,
							BEOA);
						if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_16468))
							{	/* Eval/evaluate_comp.scm 1014 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 1014 */
								BGl_loczd2typezd2errorz00zz__evaluate_compz00
									(BGl_symbol5818z00zz__evaluate_compz00,
									BGl_symbol5820z00zz__evaluate_compz00, BgL_a1z00_16468,
									BgL_locz00_13910);
							}
						if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_16469))
							{	/* Eval/evaluate_comp.scm 1014 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 1014 */
								BGl_loczd2typezd2errorz00zz__evaluate_compz00
									(BGl_symbol5818z00zz__evaluate_compz00,
									BGl_symbol5820z00zz__evaluate_compz00, BgL_a2z00_16469,
									BgL_locz00_13910);
							}
						return
							BGl_2zb2zb2zz__r4_numbers_6_5z00(BgL_a1z00_16468,
							BgL_a2z00_16469);
					}
				}
			}
		}

	}



/* &<@anonymous:2763> */
	obj_t BGl_z62zc3z04anonymousza32763ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13912, obj_t BgL_sz00_13916)
	{
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_13913;
				obj_t BgL_a2z00_13914;
				obj_t BgL_locz00_13915;

				BgL_a1z00_13913 = PROCEDURE_REF(BgL_envz00_13912, (int) (((long) 0)));
				BgL_a2z00_13914 = PROCEDURE_REF(BgL_envz00_13912, (int) (((long) 1)));
				BgL_locz00_13915 = PROCEDURE_REF(BgL_envz00_13912, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					obj_t BgL_bpz00_16470;

					BgL_bpz00_16470 = VECTOR_REF(((obj_t) BgL_sz00_13916), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_a1z00_16471;
						obj_t BgL_a2z00_16472;

						BgL_a1z00_16471 =
							PROCEDURE_ENTRY(BgL_a1z00_13913) (BgL_a1z00_13913, BgL_sz00_13916,
							BEOA);
						BgL_a2z00_16472 =
							PROCEDURE_ENTRY(BgL_a2z00_13914) (BgL_a2z00_13914, BgL_sz00_13916,
							BEOA);
						if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_16471))
							{	/* Eval/evaluate_comp.scm 1014 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 1014 */
								BGl_loczd2typezd2errorz00zz__evaluate_compz00
									(BGl_symbol5822z00zz__evaluate_compz00,
									BGl_symbol5820z00zz__evaluate_compz00, BgL_a1z00_16471,
									BgL_locz00_13915);
							}
						if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_16472))
							{	/* Eval/evaluate_comp.scm 1014 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 1014 */
								BGl_loczd2typezd2errorz00zz__evaluate_compz00
									(BGl_symbol5822z00zz__evaluate_compz00,
									BGl_symbol5820z00zz__evaluate_compz00, BgL_a2z00_16472,
									BgL_locz00_13915);
							}
						return
							BGl_2zd2zd2zz__r4_numbers_6_5z00(BgL_a1z00_16471,
							BgL_a2z00_16472);
					}
				}
			}
		}

	}



/* &<@anonymous:2767> */
	obj_t BGl_z62zc3z04anonymousza32767ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13917, obj_t BgL_sz00_13921)
	{
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_13918;
				obj_t BgL_a2z00_13919;
				obj_t BgL_locz00_13920;

				BgL_a1z00_13918 = PROCEDURE_REF(BgL_envz00_13917, (int) (((long) 0)));
				BgL_a2z00_13919 = PROCEDURE_REF(BgL_envz00_13917, (int) (((long) 1)));
				BgL_locz00_13920 = PROCEDURE_REF(BgL_envz00_13917, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					obj_t BgL_bpz00_16473;

					BgL_bpz00_16473 = VECTOR_REF(((obj_t) BgL_sz00_13921), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_a1z00_16474;
						obj_t BgL_a2z00_16475;

						BgL_a1z00_16474 =
							PROCEDURE_ENTRY(BgL_a1z00_13918) (BgL_a1z00_13918, BgL_sz00_13921,
							BEOA);
						BgL_a2z00_16475 =
							PROCEDURE_ENTRY(BgL_a2z00_13919) (BgL_a2z00_13919, BgL_sz00_13921,
							BEOA);
						if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_16474))
							{	/* Eval/evaluate_comp.scm 1014 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 1014 */
								BGl_loczd2typezd2errorz00zz__evaluate_compz00
									(BGl_symbol5824z00zz__evaluate_compz00,
									BGl_symbol5820z00zz__evaluate_compz00, BgL_a1z00_16474,
									BgL_locz00_13920);
							}
						if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_16475))
							{	/* Eval/evaluate_comp.scm 1014 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 1014 */
								BGl_loczd2typezd2errorz00zz__evaluate_compz00
									(BGl_symbol5824z00zz__evaluate_compz00,
									BGl_symbol5820z00zz__evaluate_compz00, BgL_a2z00_16475,
									BgL_locz00_13920);
							}
						return
							BGl_2za2za2zz__r4_numbers_6_5z00(BgL_a1z00_16474,
							BgL_a2z00_16475);
					}
				}
			}
		}

	}



/* &<@anonymous:2771> */
	obj_t BGl_z62zc3z04anonymousza32771ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13922, obj_t BgL_sz00_13926)
	{
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_13923;
				obj_t BgL_a2z00_13924;
				obj_t BgL_locz00_13925;

				BgL_a1z00_13923 = PROCEDURE_REF(BgL_envz00_13922, (int) (((long) 0)));
				BgL_a2z00_13924 = PROCEDURE_REF(BgL_envz00_13922, (int) (((long) 1)));
				BgL_locz00_13925 = PROCEDURE_REF(BgL_envz00_13922, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					obj_t BgL_bpz00_16476;

					BgL_bpz00_16476 = VECTOR_REF(((obj_t) BgL_sz00_13926), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_a1z00_16477;
						obj_t BgL_a2z00_16478;

						BgL_a1z00_16477 =
							PROCEDURE_ENTRY(BgL_a1z00_13923) (BgL_a1z00_13923, BgL_sz00_13926,
							BEOA);
						BgL_a2z00_16478 =
							PROCEDURE_ENTRY(BgL_a2z00_13924) (BgL_a2z00_13924, BgL_sz00_13926,
							BEOA);
						if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_16477))
							{	/* Eval/evaluate_comp.scm 1014 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 1014 */
								BGl_loczd2typezd2errorz00zz__evaluate_compz00
									(BGl_symbol5826z00zz__evaluate_compz00,
									BGl_symbol5820z00zz__evaluate_compz00, BgL_a1z00_16477,
									BgL_locz00_13925);
							}
						if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_16478))
							{	/* Eval/evaluate_comp.scm 1014 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 1014 */
								BGl_loczd2typezd2errorz00zz__evaluate_compz00
									(BGl_symbol5826z00zz__evaluate_compz00,
									BGl_symbol5820z00zz__evaluate_compz00, BgL_a2z00_16478,
									BgL_locz00_13925);
							}
						return
							BGl_2zf2zf2zz__r4_numbers_6_5z00(BgL_a1z00_16477,
							BgL_a2z00_16478);
					}
				}
			}
		}

	}



/* &<@anonymous:2775> */
	obj_t BGl_z62zc3z04anonymousza32775ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13927, obj_t BgL_sz00_13931)
	{
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_13928;
				obj_t BgL_a2z00_13929;
				obj_t BgL_locz00_13930;

				BgL_a1z00_13928 = PROCEDURE_REF(BgL_envz00_13927, (int) (((long) 0)));
				BgL_a2z00_13929 = PROCEDURE_REF(BgL_envz00_13927, (int) (((long) 1)));
				BgL_locz00_13930 = PROCEDURE_REF(BgL_envz00_13927, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					bool_t BgL_tmpz00_24619;

					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_bpz00_16479;

						BgL_bpz00_16479 = VECTOR_REF(((obj_t) BgL_sz00_13931), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1014 */
							obj_t BgL_a1z00_16480;
							obj_t BgL_a2z00_16481;

							BgL_a1z00_16480 =
								PROCEDURE_ENTRY(BgL_a1z00_13928) (BgL_a1z00_13928,
								BgL_sz00_13931, BEOA);
							BgL_a2z00_16481 =
								PROCEDURE_ENTRY(BgL_a2z00_13929) (BgL_a2z00_13929,
								BgL_sz00_13931, BEOA);
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_16480))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5828z00zz__evaluate_compz00,
										BGl_symbol5820z00zz__evaluate_compz00, BgL_a1z00_16480,
										BgL_locz00_13930);
								}
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_16481))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5828z00zz__evaluate_compz00,
										BGl_symbol5820z00zz__evaluate_compz00, BgL_a2z00_16481,
										BgL_locz00_13930);
								}
							BgL_tmpz00_24619 =
								BGl_2zc3zc3zz__r4_numbers_6_5z00(BgL_a1z00_16480,
								BgL_a2z00_16481);
						}
					}
					return BBOOL(BgL_tmpz00_24619);
				}
			}
		}

	}



/* &<@anonymous:2779> */
	obj_t BGl_z62zc3z04anonymousza32779ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13932, obj_t BgL_sz00_13936)
	{
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_13933;
				obj_t BgL_a2z00_13934;
				obj_t BgL_locz00_13935;

				BgL_a1z00_13933 = PROCEDURE_REF(BgL_envz00_13932, (int) (((long) 0)));
				BgL_a2z00_13934 = PROCEDURE_REF(BgL_envz00_13932, (int) (((long) 1)));
				BgL_locz00_13935 = PROCEDURE_REF(BgL_envz00_13932, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					bool_t BgL_tmpz00_24644;

					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_bpz00_16482;

						BgL_bpz00_16482 = VECTOR_REF(((obj_t) BgL_sz00_13936), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1014 */
							obj_t BgL_a1z00_16483;
							obj_t BgL_a2z00_16484;

							BgL_a1z00_16483 =
								PROCEDURE_ENTRY(BgL_a1z00_13933) (BgL_a1z00_13933,
								BgL_sz00_13936, BEOA);
							BgL_a2z00_16484 =
								PROCEDURE_ENTRY(BgL_a2z00_13934) (BgL_a2z00_13934,
								BgL_sz00_13936, BEOA);
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_16483))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5830z00zz__evaluate_compz00,
										BGl_symbol5820z00zz__evaluate_compz00, BgL_a1z00_16483,
										BgL_locz00_13935);
								}
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_16484))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5830z00zz__evaluate_compz00,
										BGl_symbol5820z00zz__evaluate_compz00, BgL_a2z00_16484,
										BgL_locz00_13935);
								}
							BgL_tmpz00_24644 =
								BGl_2ze3ze3zz__r4_numbers_6_5z00(BgL_a1z00_16483,
								BgL_a2z00_16484);
						}
					}
					return BBOOL(BgL_tmpz00_24644);
				}
			}
		}

	}



/* &<@anonymous:2783> */
	obj_t BGl_z62zc3z04anonymousza32783ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13937, obj_t BgL_sz00_13941)
	{
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_13938;
				obj_t BgL_a2z00_13939;
				obj_t BgL_locz00_13940;

				BgL_a1z00_13938 = PROCEDURE_REF(BgL_envz00_13937, (int) (((long) 0)));
				BgL_a2z00_13939 = PROCEDURE_REF(BgL_envz00_13937, (int) (((long) 1)));
				BgL_locz00_13940 = PROCEDURE_REF(BgL_envz00_13937, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					bool_t BgL_tmpz00_24669;

					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_bpz00_16485;

						BgL_bpz00_16485 = VECTOR_REF(((obj_t) BgL_sz00_13941), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1014 */
							obj_t BgL_a1z00_16486;
							obj_t BgL_a2z00_16487;

							BgL_a1z00_16486 =
								PROCEDURE_ENTRY(BgL_a1z00_13938) (BgL_a1z00_13938,
								BgL_sz00_13941, BEOA);
							BgL_a2z00_16487 =
								PROCEDURE_ENTRY(BgL_a2z00_13939) (BgL_a2z00_13939,
								BgL_sz00_13941, BEOA);
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_16486))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5832z00zz__evaluate_compz00,
										BGl_symbol5820z00zz__evaluate_compz00, BgL_a1z00_16486,
										BgL_locz00_13940);
								}
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_16487))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5832z00zz__evaluate_compz00,
										BGl_symbol5820z00zz__evaluate_compz00, BgL_a2z00_16487,
										BgL_locz00_13940);
								}
							BgL_tmpz00_24669 =
								BGl_2zc3zd3z10zz__r4_numbers_6_5z00(BgL_a1z00_16486,
								BgL_a2z00_16487);
						}
					}
					return BBOOL(BgL_tmpz00_24669);
				}
			}
		}

	}



/* &<@anonymous:2787> */
	obj_t BGl_z62zc3z04anonymousza32787ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13942, obj_t BgL_sz00_13946)
	{
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_13943;
				obj_t BgL_a2z00_13944;
				obj_t BgL_locz00_13945;

				BgL_a1z00_13943 = PROCEDURE_REF(BgL_envz00_13942, (int) (((long) 0)));
				BgL_a2z00_13944 = PROCEDURE_REF(BgL_envz00_13942, (int) (((long) 1)));
				BgL_locz00_13945 = PROCEDURE_REF(BgL_envz00_13942, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					bool_t BgL_tmpz00_24694;

					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_bpz00_16488;

						BgL_bpz00_16488 = VECTOR_REF(((obj_t) BgL_sz00_13946), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1014 */
							obj_t BgL_a1z00_16489;
							obj_t BgL_a2z00_16490;

							BgL_a1z00_16489 =
								PROCEDURE_ENTRY(BgL_a1z00_13943) (BgL_a1z00_13943,
								BgL_sz00_13946, BEOA);
							BgL_a2z00_16490 =
								PROCEDURE_ENTRY(BgL_a2z00_13944) (BgL_a2z00_13944,
								BgL_sz00_13946, BEOA);
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_16489))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5834z00zz__evaluate_compz00,
										BGl_symbol5820z00zz__evaluate_compz00, BgL_a1z00_16489,
										BgL_locz00_13945);
								}
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_16490))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5834z00zz__evaluate_compz00,
										BGl_symbol5820z00zz__evaluate_compz00, BgL_a2z00_16490,
										BgL_locz00_13945);
								}
							BgL_tmpz00_24694 =
								BGl_2ze3zd3z30zz__r4_numbers_6_5z00(BgL_a1z00_16489,
								BgL_a2z00_16490);
						}
					}
					return BBOOL(BgL_tmpz00_24694);
				}
			}
		}

	}



/* &<@anonymous:2791> */
	obj_t BGl_z62zc3z04anonymousza32791ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13947, obj_t BgL_sz00_13951)
	{
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_13948;
				obj_t BgL_a2z00_13949;
				obj_t BgL_locz00_13950;

				BgL_a1z00_13948 = PROCEDURE_REF(BgL_envz00_13947, (int) (((long) 0)));
				BgL_a2z00_13949 = PROCEDURE_REF(BgL_envz00_13947, (int) (((long) 1)));
				BgL_locz00_13950 = PROCEDURE_REF(BgL_envz00_13947, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					bool_t BgL_tmpz00_24719;

					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_bpz00_16491;

						BgL_bpz00_16491 = VECTOR_REF(((obj_t) BgL_sz00_13951), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1014 */
							obj_t BgL_a1z00_16492;
							obj_t BgL_a2z00_16493;

							BgL_a1z00_16492 =
								PROCEDURE_ENTRY(BgL_a1z00_13948) (BgL_a1z00_13948,
								BgL_sz00_13951, BEOA);
							BgL_a2z00_16493 =
								PROCEDURE_ENTRY(BgL_a2z00_13949) (BgL_a2z00_13949,
								BgL_sz00_13951, BEOA);
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_16492))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5836z00zz__evaluate_compz00,
										BGl_symbol5820z00zz__evaluate_compz00, BgL_a1z00_16492,
										BgL_locz00_13950);
								}
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_16493))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5836z00zz__evaluate_compz00,
										BGl_symbol5820z00zz__evaluate_compz00, BgL_a2z00_16493,
										BgL_locz00_13950);
								}
							BgL_tmpz00_24719 =
								BGl_2zd3zd3zz__r4_numbers_6_5z00(BgL_a1z00_16492,
								BgL_a2z00_16493);
						}
					}
					return BBOOL(BgL_tmpz00_24719);
				}
			}
		}

	}



/* &<@anonymous:2795> */
	obj_t BGl_z62zc3z04anonymousza32795ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13952, obj_t BgL_sz00_13956)
	{
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_13953;
				obj_t BgL_a2z00_13954;
				obj_t BgL_locz00_13955;

				BgL_a1z00_13953 = PROCEDURE_REF(BgL_envz00_13952, (int) (((long) 0)));
				BgL_a2z00_13954 = PROCEDURE_REF(BgL_envz00_13952, (int) (((long) 1)));
				BgL_locz00_13955 = PROCEDURE_REF(BgL_envz00_13952, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					long BgL_tmpz00_24744;

					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_bpz00_16494;

						BgL_bpz00_16494 = VECTOR_REF(((obj_t) BgL_sz00_13956), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1014 */
							obj_t BgL_a1z00_16495;
							obj_t BgL_a2z00_16496;

							BgL_a1z00_16495 =
								PROCEDURE_ENTRY(BgL_a1z00_13953) (BgL_a1z00_13953,
								BgL_sz00_13956, BEOA);
							BgL_a2z00_16496 =
								PROCEDURE_ENTRY(BgL_a2z00_13954) (BgL_a2z00_13954,
								BgL_sz00_13956, BEOA);
							if (INTEGERP(BgL_a1z00_16495))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5838z00zz__evaluate_compz00,
										BGl_symbol5840z00zz__evaluate_compz00, BgL_a1z00_16495,
										BgL_locz00_13955);
								}
							if (INTEGERP(BgL_a2z00_16496))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5838z00zz__evaluate_compz00,
										BGl_symbol5840z00zz__evaluate_compz00, BgL_a2z00_16496,
										BgL_locz00_13955);
								}
							BgL_tmpz00_24744 =
								((long) CINT(BgL_a1z00_16495) + (long) CINT(BgL_a2z00_16496));
					}}
					return BINT(BgL_tmpz00_24744);
				}
			}
		}

	}



/* &<@anonymous:2799> */
	obj_t BGl_z62zc3z04anonymousza32799ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13957, obj_t BgL_sz00_13961)
	{
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_13958;
				obj_t BgL_a2z00_13959;
				obj_t BgL_locz00_13960;

				BgL_a1z00_13958 = PROCEDURE_REF(BgL_envz00_13957, (int) (((long) 0)));
				BgL_a2z00_13959 = PROCEDURE_REF(BgL_envz00_13957, (int) (((long) 1)));
				BgL_locz00_13960 = PROCEDURE_REF(BgL_envz00_13957, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					long BgL_tmpz00_24771;

					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_bpz00_16497;

						BgL_bpz00_16497 = VECTOR_REF(((obj_t) BgL_sz00_13961), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1014 */
							obj_t BgL_a1z00_16498;
							obj_t BgL_a2z00_16499;

							BgL_a1z00_16498 =
								PROCEDURE_ENTRY(BgL_a1z00_13958) (BgL_a1z00_13958,
								BgL_sz00_13961, BEOA);
							BgL_a2z00_16499 =
								PROCEDURE_ENTRY(BgL_a2z00_13959) (BgL_a2z00_13959,
								BgL_sz00_13961, BEOA);
							if (INTEGERP(BgL_a1z00_16498))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5842z00zz__evaluate_compz00,
										BGl_symbol5840z00zz__evaluate_compz00, BgL_a1z00_16498,
										BgL_locz00_13960);
								}
							if (INTEGERP(BgL_a2z00_16499))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5842z00zz__evaluate_compz00,
										BGl_symbol5840z00zz__evaluate_compz00, BgL_a2z00_16499,
										BgL_locz00_13960);
								}
							BgL_tmpz00_24771 =
								((long) CINT(BgL_a1z00_16498) - (long) CINT(BgL_a2z00_16499));
					}}
					return BINT(BgL_tmpz00_24771);
				}
			}
		}

	}



/* &<@anonymous:2803> */
	obj_t BGl_z62zc3z04anonymousza32803ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13962, obj_t BgL_sz00_13966)
	{
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_13963;
				obj_t BgL_a2z00_13964;
				obj_t BgL_locz00_13965;

				BgL_a1z00_13963 = PROCEDURE_REF(BgL_envz00_13962, (int) (((long) 0)));
				BgL_a2z00_13964 = PROCEDURE_REF(BgL_envz00_13962, (int) (((long) 1)));
				BgL_locz00_13965 = PROCEDURE_REF(BgL_envz00_13962, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					long BgL_tmpz00_24798;

					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_bpz00_16500;

						BgL_bpz00_16500 = VECTOR_REF(((obj_t) BgL_sz00_13966), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1014 */
							obj_t BgL_a1z00_16501;
							obj_t BgL_a2z00_16502;

							BgL_a1z00_16501 =
								PROCEDURE_ENTRY(BgL_a1z00_13963) (BgL_a1z00_13963,
								BgL_sz00_13966, BEOA);
							BgL_a2z00_16502 =
								PROCEDURE_ENTRY(BgL_a2z00_13964) (BgL_a2z00_13964,
								BgL_sz00_13966, BEOA);
							if (INTEGERP(BgL_a1z00_16501))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5844z00zz__evaluate_compz00,
										BGl_symbol5840z00zz__evaluate_compz00, BgL_a1z00_16501,
										BgL_locz00_13965);
								}
							if (INTEGERP(BgL_a2z00_16502))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5844z00zz__evaluate_compz00,
										BGl_symbol5840z00zz__evaluate_compz00, BgL_a2z00_16502,
										BgL_locz00_13965);
								}
							BgL_tmpz00_24798 =
								((long) CINT(BgL_a1z00_16501) * (long) CINT(BgL_a2z00_16502));
					}}
					return BINT(BgL_tmpz00_24798);
				}
			}
		}

	}



/* &<@anonymous:2807> */
	obj_t BGl_z62zc3z04anonymousza32807ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13967, obj_t BgL_sz00_13971)
	{
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_13968;
				obj_t BgL_a2z00_13969;
				obj_t BgL_locz00_13970;

				BgL_a1z00_13968 = PROCEDURE_REF(BgL_envz00_13967, (int) (((long) 0)));
				BgL_a2z00_13969 = PROCEDURE_REF(BgL_envz00_13967, (int) (((long) 1)));
				BgL_locz00_13970 = PROCEDURE_REF(BgL_envz00_13967, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					long BgL_tmpz00_24825;

					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_bpz00_16503;

						BgL_bpz00_16503 = VECTOR_REF(((obj_t) BgL_sz00_13971), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1014 */
							obj_t BgL_a1z00_16504;
							obj_t BgL_a2z00_16505;

							BgL_a1z00_16504 =
								PROCEDURE_ENTRY(BgL_a1z00_13968) (BgL_a1z00_13968,
								BgL_sz00_13971, BEOA);
							BgL_a2z00_16505 =
								PROCEDURE_ENTRY(BgL_a2z00_13969) (BgL_a2z00_13969,
								BgL_sz00_13971, BEOA);
							if (INTEGERP(BgL_a1z00_16504))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5846z00zz__evaluate_compz00,
										BGl_symbol5840z00zz__evaluate_compz00, BgL_a1z00_16504,
										BgL_locz00_13970);
								}
							if (INTEGERP(BgL_a2z00_16505))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5846z00zz__evaluate_compz00,
										BGl_symbol5840z00zz__evaluate_compz00, BgL_a2z00_16505,
										BgL_locz00_13970);
								}
							BgL_tmpz00_24825 =
								((long) CINT(BgL_a1z00_16504) / (long) CINT(BgL_a2z00_16505));
					}}
					return BINT(BgL_tmpz00_24825);
				}
			}
		}

	}



/* &<@anonymous:2811> */
	obj_t BGl_z62zc3z04anonymousza32811ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13972, obj_t BgL_sz00_13976)
	{
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_13973;
				obj_t BgL_a2z00_13974;
				obj_t BgL_locz00_13975;

				BgL_a1z00_13973 = PROCEDURE_REF(BgL_envz00_13972, (int) (((long) 0)));
				BgL_a2z00_13974 = PROCEDURE_REF(BgL_envz00_13972, (int) (((long) 1)));
				BgL_locz00_13975 = PROCEDURE_REF(BgL_envz00_13972, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					bool_t BgL_tmpz00_24852;

					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_bpz00_16506;

						BgL_bpz00_16506 = VECTOR_REF(((obj_t) BgL_sz00_13976), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1014 */
							obj_t BgL_a1z00_16507;
							obj_t BgL_a2z00_16508;

							BgL_a1z00_16507 =
								PROCEDURE_ENTRY(BgL_a1z00_13973) (BgL_a1z00_13973,
								BgL_sz00_13976, BEOA);
							BgL_a2z00_16508 =
								PROCEDURE_ENTRY(BgL_a2z00_13974) (BgL_a2z00_13974,
								BgL_sz00_13976, BEOA);
							if (INTEGERP(BgL_a1z00_16507))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5848z00zz__evaluate_compz00,
										BGl_symbol5840z00zz__evaluate_compz00, BgL_a1z00_16507,
										BgL_locz00_13975);
								}
							if (INTEGERP(BgL_a2z00_16508))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5848z00zz__evaluate_compz00,
										BGl_symbol5840z00zz__evaluate_compz00, BgL_a2z00_16508,
										BgL_locz00_13975);
								}
							BgL_tmpz00_24852 =
								((long) CINT(BgL_a1z00_16507) < (long) CINT(BgL_a2z00_16508));
					}}
					return BBOOL(BgL_tmpz00_24852);
				}
			}
		}

	}



/* &<@anonymous:2815> */
	obj_t BGl_z62zc3z04anonymousza32815ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13977, obj_t BgL_sz00_13981)
	{
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_13978;
				obj_t BgL_a2z00_13979;
				obj_t BgL_locz00_13980;

				BgL_a1z00_13978 = PROCEDURE_REF(BgL_envz00_13977, (int) (((long) 0)));
				BgL_a2z00_13979 = PROCEDURE_REF(BgL_envz00_13977, (int) (((long) 1)));
				BgL_locz00_13980 = PROCEDURE_REF(BgL_envz00_13977, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					bool_t BgL_tmpz00_24879;

					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_bpz00_16509;

						BgL_bpz00_16509 = VECTOR_REF(((obj_t) BgL_sz00_13981), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1014 */
							obj_t BgL_a1z00_16510;
							obj_t BgL_a2z00_16511;

							BgL_a1z00_16510 =
								PROCEDURE_ENTRY(BgL_a1z00_13978) (BgL_a1z00_13978,
								BgL_sz00_13981, BEOA);
							BgL_a2z00_16511 =
								PROCEDURE_ENTRY(BgL_a2z00_13979) (BgL_a2z00_13979,
								BgL_sz00_13981, BEOA);
							if (INTEGERP(BgL_a1z00_16510))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5850z00zz__evaluate_compz00,
										BGl_symbol5840z00zz__evaluate_compz00, BgL_a1z00_16510,
										BgL_locz00_13980);
								}
							if (INTEGERP(BgL_a2z00_16511))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5850z00zz__evaluate_compz00,
										BGl_symbol5840z00zz__evaluate_compz00, BgL_a2z00_16511,
										BgL_locz00_13980);
								}
							BgL_tmpz00_24879 =
								((long) CINT(BgL_a1z00_16510) > (long) CINT(BgL_a2z00_16511));
					}}
					return BBOOL(BgL_tmpz00_24879);
				}
			}
		}

	}



/* &<@anonymous:2819> */
	obj_t BGl_z62zc3z04anonymousza32819ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13982, obj_t BgL_sz00_13986)
	{
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_13983;
				obj_t BgL_a2z00_13984;
				obj_t BgL_locz00_13985;

				BgL_a1z00_13983 = PROCEDURE_REF(BgL_envz00_13982, (int) (((long) 0)));
				BgL_a2z00_13984 = PROCEDURE_REF(BgL_envz00_13982, (int) (((long) 1)));
				BgL_locz00_13985 = PROCEDURE_REF(BgL_envz00_13982, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					bool_t BgL_tmpz00_24906;

					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_bpz00_16512;

						BgL_bpz00_16512 = VECTOR_REF(((obj_t) BgL_sz00_13986), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1014 */
							obj_t BgL_a1z00_16513;
							obj_t BgL_a2z00_16514;

							BgL_a1z00_16513 =
								PROCEDURE_ENTRY(BgL_a1z00_13983) (BgL_a1z00_13983,
								BgL_sz00_13986, BEOA);
							BgL_a2z00_16514 =
								PROCEDURE_ENTRY(BgL_a2z00_13984) (BgL_a2z00_13984,
								BgL_sz00_13986, BEOA);
							if (INTEGERP(BgL_a1z00_16513))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5852z00zz__evaluate_compz00,
										BGl_symbol5840z00zz__evaluate_compz00, BgL_a1z00_16513,
										BgL_locz00_13985);
								}
							if (INTEGERP(BgL_a2z00_16514))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5852z00zz__evaluate_compz00,
										BGl_symbol5840z00zz__evaluate_compz00, BgL_a2z00_16514,
										BgL_locz00_13985);
								}
							BgL_tmpz00_24906 =
								((long) CINT(BgL_a1z00_16513) <= (long) CINT(BgL_a2z00_16514));
					}}
					return BBOOL(BgL_tmpz00_24906);
				}
			}
		}

	}



/* &<@anonymous:2823> */
	obj_t BGl_z62zc3z04anonymousza32823ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13987, obj_t BgL_sz00_13991)
	{
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_13988;
				obj_t BgL_a2z00_13989;
				obj_t BgL_locz00_13990;

				BgL_a1z00_13988 = PROCEDURE_REF(BgL_envz00_13987, (int) (((long) 0)));
				BgL_a2z00_13989 = PROCEDURE_REF(BgL_envz00_13987, (int) (((long) 1)));
				BgL_locz00_13990 = PROCEDURE_REF(BgL_envz00_13987, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					bool_t BgL_tmpz00_24933;

					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_bpz00_16515;

						BgL_bpz00_16515 = VECTOR_REF(((obj_t) BgL_sz00_13991), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1014 */
							obj_t BgL_a1z00_16516;
							obj_t BgL_a2z00_16517;

							BgL_a1z00_16516 =
								PROCEDURE_ENTRY(BgL_a1z00_13988) (BgL_a1z00_13988,
								BgL_sz00_13991, BEOA);
							BgL_a2z00_16517 =
								PROCEDURE_ENTRY(BgL_a2z00_13989) (BgL_a2z00_13989,
								BgL_sz00_13991, BEOA);
							if (INTEGERP(BgL_a1z00_16516))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5854z00zz__evaluate_compz00,
										BGl_symbol5840z00zz__evaluate_compz00, BgL_a1z00_16516,
										BgL_locz00_13990);
								}
							if (INTEGERP(BgL_a2z00_16517))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5854z00zz__evaluate_compz00,
										BGl_symbol5840z00zz__evaluate_compz00, BgL_a2z00_16517,
										BgL_locz00_13990);
								}
							BgL_tmpz00_24933 =
								((long) CINT(BgL_a1z00_16516) >= (long) CINT(BgL_a2z00_16517));
					}}
					return BBOOL(BgL_tmpz00_24933);
				}
			}
		}

	}



/* &<@anonymous:2827> */
	obj_t BGl_z62zc3z04anonymousza32827ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13992, obj_t BgL_sz00_13996)
	{
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_13993;
				obj_t BgL_a2z00_13994;
				obj_t BgL_locz00_13995;

				BgL_a1z00_13993 = PROCEDURE_REF(BgL_envz00_13992, (int) (((long) 0)));
				BgL_a2z00_13994 = PROCEDURE_REF(BgL_envz00_13992, (int) (((long) 1)));
				BgL_locz00_13995 = PROCEDURE_REF(BgL_envz00_13992, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					bool_t BgL_tmpz00_24960;

					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_bpz00_16518;

						BgL_bpz00_16518 = VECTOR_REF(((obj_t) BgL_sz00_13996), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1014 */
							obj_t BgL_a1z00_16519;
							obj_t BgL_a2z00_16520;

							BgL_a1z00_16519 =
								PROCEDURE_ENTRY(BgL_a1z00_13993) (BgL_a1z00_13993,
								BgL_sz00_13996, BEOA);
							BgL_a2z00_16520 =
								PROCEDURE_ENTRY(BgL_a2z00_13994) (BgL_a2z00_13994,
								BgL_sz00_13996, BEOA);
							if (INTEGERP(BgL_a1z00_16519))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5856z00zz__evaluate_compz00,
										BGl_symbol5840z00zz__evaluate_compz00, BgL_a1z00_16519,
										BgL_locz00_13995);
								}
							if (INTEGERP(BgL_a2z00_16520))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5856z00zz__evaluate_compz00,
										BGl_symbol5840z00zz__evaluate_compz00, BgL_a2z00_16520,
										BgL_locz00_13995);
								}
							BgL_tmpz00_24960 =
								((long) CINT(BgL_a1z00_16519) == (long) CINT(BgL_a2z00_16520));
					}}
					return BBOOL(BgL_tmpz00_24960);
				}
			}
		}

	}



/* &<@anonymous:2831> */
	obj_t BGl_z62zc3z04anonymousza32831ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13997, obj_t BgL_sz00_14001)
	{
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_13998;
				obj_t BgL_a2z00_13999;
				obj_t BgL_locz00_14000;

				BgL_a1z00_13998 = PROCEDURE_REF(BgL_envz00_13997, (int) (((long) 0)));
				BgL_a2z00_13999 = PROCEDURE_REF(BgL_envz00_13997, (int) (((long) 1)));
				BgL_locz00_14000 = PROCEDURE_REF(BgL_envz00_13997, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					double BgL_tmpz00_24987;

					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_bpz00_16521;

						BgL_bpz00_16521 = VECTOR_REF(((obj_t) BgL_sz00_14001), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1014 */
							obj_t BgL_a1z00_16522;
							obj_t BgL_a2z00_16523;

							BgL_a1z00_16522 =
								PROCEDURE_ENTRY(BgL_a1z00_13998) (BgL_a1z00_13998,
								BgL_sz00_14001, BEOA);
							BgL_a2z00_16523 =
								PROCEDURE_ENTRY(BgL_a2z00_13999) (BgL_a2z00_13999,
								BgL_sz00_14001, BEOA);
							if (REALP(BgL_a1z00_16522))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5858z00zz__evaluate_compz00,
										BGl_symbol5860z00zz__evaluate_compz00, BgL_a1z00_16522,
										BgL_locz00_14000);
								}
							if (REALP(BgL_a2z00_16523))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5858z00zz__evaluate_compz00,
										BGl_symbol5860z00zz__evaluate_compz00, BgL_a2z00_16523,
										BgL_locz00_14000);
								}
							BgL_tmpz00_24987 =
								(REAL_TO_DOUBLE(BgL_a1z00_16522) +
								REAL_TO_DOUBLE(BgL_a2z00_16523));
						}
					}
					return DOUBLE_TO_REAL(BgL_tmpz00_24987);
				}
			}
		}

	}



/* &<@anonymous:2835> */
	obj_t BGl_z62zc3z04anonymousza32835ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14002, obj_t BgL_sz00_14006)
	{
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_14003;
				obj_t BgL_a2z00_14004;
				obj_t BgL_locz00_14005;

				BgL_a1z00_14003 = PROCEDURE_REF(BgL_envz00_14002, (int) (((long) 0)));
				BgL_a2z00_14004 = PROCEDURE_REF(BgL_envz00_14002, (int) (((long) 1)));
				BgL_locz00_14005 = PROCEDURE_REF(BgL_envz00_14002, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					double BgL_tmpz00_25014;

					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_bpz00_16524;

						BgL_bpz00_16524 = VECTOR_REF(((obj_t) BgL_sz00_14006), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1014 */
							obj_t BgL_a1z00_16525;
							obj_t BgL_a2z00_16526;

							BgL_a1z00_16525 =
								PROCEDURE_ENTRY(BgL_a1z00_14003) (BgL_a1z00_14003,
								BgL_sz00_14006, BEOA);
							BgL_a2z00_16526 =
								PROCEDURE_ENTRY(BgL_a2z00_14004) (BgL_a2z00_14004,
								BgL_sz00_14006, BEOA);
							if (REALP(BgL_a1z00_16525))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5862z00zz__evaluate_compz00,
										BGl_symbol5860z00zz__evaluate_compz00, BgL_a1z00_16525,
										BgL_locz00_14005);
								}
							if (REALP(BgL_a2z00_16526))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5862z00zz__evaluate_compz00,
										BGl_symbol5860z00zz__evaluate_compz00, BgL_a2z00_16526,
										BgL_locz00_14005);
								}
							BgL_tmpz00_25014 =
								(REAL_TO_DOUBLE(BgL_a1z00_16525) -
								REAL_TO_DOUBLE(BgL_a2z00_16526));
						}
					}
					return DOUBLE_TO_REAL(BgL_tmpz00_25014);
				}
			}
		}

	}



/* &<@anonymous:2839> */
	obj_t BGl_z62zc3z04anonymousza32839ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14007, obj_t BgL_sz00_14011)
	{
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_14008;
				obj_t BgL_a2z00_14009;
				obj_t BgL_locz00_14010;

				BgL_a1z00_14008 = PROCEDURE_REF(BgL_envz00_14007, (int) (((long) 0)));
				BgL_a2z00_14009 = PROCEDURE_REF(BgL_envz00_14007, (int) (((long) 1)));
				BgL_locz00_14010 = PROCEDURE_REF(BgL_envz00_14007, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					double BgL_tmpz00_25041;

					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_bpz00_16527;

						BgL_bpz00_16527 = VECTOR_REF(((obj_t) BgL_sz00_14011), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1014 */
							obj_t BgL_a1z00_16528;
							obj_t BgL_a2z00_16529;

							BgL_a1z00_16528 =
								PROCEDURE_ENTRY(BgL_a1z00_14008) (BgL_a1z00_14008,
								BgL_sz00_14011, BEOA);
							BgL_a2z00_16529 =
								PROCEDURE_ENTRY(BgL_a2z00_14009) (BgL_a2z00_14009,
								BgL_sz00_14011, BEOA);
							if (REALP(BgL_a1z00_16528))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5864z00zz__evaluate_compz00,
										BGl_symbol5860z00zz__evaluate_compz00, BgL_a1z00_16528,
										BgL_locz00_14010);
								}
							if (REALP(BgL_a2z00_16529))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5864z00zz__evaluate_compz00,
										BGl_symbol5860z00zz__evaluate_compz00, BgL_a2z00_16529,
										BgL_locz00_14010);
								}
							BgL_tmpz00_25041 =
								(REAL_TO_DOUBLE(BgL_a1z00_16528) *
								REAL_TO_DOUBLE(BgL_a2z00_16529));
						}
					}
					return DOUBLE_TO_REAL(BgL_tmpz00_25041);
				}
			}
		}

	}



/* &<@anonymous:2843> */
	obj_t BGl_z62zc3z04anonymousza32843ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14012, obj_t BgL_sz00_14016)
	{
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_14013;
				obj_t BgL_a2z00_14014;
				obj_t BgL_locz00_14015;

				BgL_a1z00_14013 = PROCEDURE_REF(BgL_envz00_14012, (int) (((long) 0)));
				BgL_a2z00_14014 = PROCEDURE_REF(BgL_envz00_14012, (int) (((long) 1)));
				BgL_locz00_14015 = PROCEDURE_REF(BgL_envz00_14012, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					double BgL_tmpz00_25068;

					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_bpz00_16530;

						BgL_bpz00_16530 = VECTOR_REF(((obj_t) BgL_sz00_14016), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1014 */
							obj_t BgL_a1z00_16531;
							obj_t BgL_a2z00_16532;

							BgL_a1z00_16531 =
								PROCEDURE_ENTRY(BgL_a1z00_14013) (BgL_a1z00_14013,
								BgL_sz00_14016, BEOA);
							BgL_a2z00_16532 =
								PROCEDURE_ENTRY(BgL_a2z00_14014) (BgL_a2z00_14014,
								BgL_sz00_14016, BEOA);
							if (REALP(BgL_a1z00_16531))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5866z00zz__evaluate_compz00,
										BGl_symbol5860z00zz__evaluate_compz00, BgL_a1z00_16531,
										BgL_locz00_14015);
								}
							if (REALP(BgL_a2z00_16532))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5866z00zz__evaluate_compz00,
										BGl_symbol5860z00zz__evaluate_compz00, BgL_a2z00_16532,
										BgL_locz00_14015);
								}
							BgL_tmpz00_25068 =
								(REAL_TO_DOUBLE(BgL_a1z00_16531) /
								REAL_TO_DOUBLE(BgL_a2z00_16532));
						}
					}
					return DOUBLE_TO_REAL(BgL_tmpz00_25068);
				}
			}
		}

	}



/* &<@anonymous:2847> */
	obj_t BGl_z62zc3z04anonymousza32847ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14017, obj_t BgL_sz00_14021)
	{
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_14018;
				obj_t BgL_a2z00_14019;
				obj_t BgL_locz00_14020;

				BgL_a1z00_14018 = PROCEDURE_REF(BgL_envz00_14017, (int) (((long) 0)));
				BgL_a2z00_14019 = PROCEDURE_REF(BgL_envz00_14017, (int) (((long) 1)));
				BgL_locz00_14020 = PROCEDURE_REF(BgL_envz00_14017, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					bool_t BgL_tmpz00_25095;

					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_bpz00_16533;

						BgL_bpz00_16533 = VECTOR_REF(((obj_t) BgL_sz00_14021), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1014 */
							obj_t BgL_a1z00_16534;
							obj_t BgL_a2z00_16535;

							BgL_a1z00_16534 =
								PROCEDURE_ENTRY(BgL_a1z00_14018) (BgL_a1z00_14018,
								BgL_sz00_14021, BEOA);
							BgL_a2z00_16535 =
								PROCEDURE_ENTRY(BgL_a2z00_14019) (BgL_a2z00_14019,
								BgL_sz00_14021, BEOA);
							if (REALP(BgL_a1z00_16534))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5868z00zz__evaluate_compz00,
										BGl_symbol5860z00zz__evaluate_compz00, BgL_a1z00_16534,
										BgL_locz00_14020);
								}
							if (REALP(BgL_a2z00_16535))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5868z00zz__evaluate_compz00,
										BGl_symbol5860z00zz__evaluate_compz00, BgL_a2z00_16535,
										BgL_locz00_14020);
								}
							BgL_tmpz00_25095 =
								(REAL_TO_DOUBLE(BgL_a1z00_16534) <
								REAL_TO_DOUBLE(BgL_a2z00_16535));
						}
					}
					return BBOOL(BgL_tmpz00_25095);
				}
			}
		}

	}



/* &<@anonymous:2851> */
	obj_t BGl_z62zc3z04anonymousza32851ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14022, obj_t BgL_sz00_14026)
	{
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_14023;
				obj_t BgL_a2z00_14024;
				obj_t BgL_locz00_14025;

				BgL_a1z00_14023 = PROCEDURE_REF(BgL_envz00_14022, (int) (((long) 0)));
				BgL_a2z00_14024 = PROCEDURE_REF(BgL_envz00_14022, (int) (((long) 1)));
				BgL_locz00_14025 = PROCEDURE_REF(BgL_envz00_14022, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					bool_t BgL_tmpz00_25122;

					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_bpz00_16536;

						BgL_bpz00_16536 = VECTOR_REF(((obj_t) BgL_sz00_14026), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1014 */
							obj_t BgL_a1z00_16537;
							obj_t BgL_a2z00_16538;

							BgL_a1z00_16537 =
								PROCEDURE_ENTRY(BgL_a1z00_14023) (BgL_a1z00_14023,
								BgL_sz00_14026, BEOA);
							BgL_a2z00_16538 =
								PROCEDURE_ENTRY(BgL_a2z00_14024) (BgL_a2z00_14024,
								BgL_sz00_14026, BEOA);
							if (REALP(BgL_a1z00_16537))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5870z00zz__evaluate_compz00,
										BGl_symbol5860z00zz__evaluate_compz00, BgL_a1z00_16537,
										BgL_locz00_14025);
								}
							if (REALP(BgL_a2z00_16538))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5870z00zz__evaluate_compz00,
										BGl_symbol5860z00zz__evaluate_compz00, BgL_a2z00_16538,
										BgL_locz00_14025);
								}
							BgL_tmpz00_25122 =
								(REAL_TO_DOUBLE(BgL_a1z00_16537) >
								REAL_TO_DOUBLE(BgL_a2z00_16538));
						}
					}
					return BBOOL(BgL_tmpz00_25122);
				}
			}
		}

	}



/* &<@anonymous:2855> */
	obj_t BGl_z62zc3z04anonymousza32855ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14027, obj_t BgL_sz00_14031)
	{
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_14028;
				obj_t BgL_a2z00_14029;
				obj_t BgL_locz00_14030;

				BgL_a1z00_14028 = PROCEDURE_REF(BgL_envz00_14027, (int) (((long) 0)));
				BgL_a2z00_14029 = PROCEDURE_REF(BgL_envz00_14027, (int) (((long) 1)));
				BgL_locz00_14030 = PROCEDURE_REF(BgL_envz00_14027, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					bool_t BgL_tmpz00_25149;

					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_bpz00_16539;

						BgL_bpz00_16539 = VECTOR_REF(((obj_t) BgL_sz00_14031), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1014 */
							obj_t BgL_a1z00_16540;
							obj_t BgL_a2z00_16541;

							BgL_a1z00_16540 =
								PROCEDURE_ENTRY(BgL_a1z00_14028) (BgL_a1z00_14028,
								BgL_sz00_14031, BEOA);
							BgL_a2z00_16541 =
								PROCEDURE_ENTRY(BgL_a2z00_14029) (BgL_a2z00_14029,
								BgL_sz00_14031, BEOA);
							if (REALP(BgL_a1z00_16540))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5872z00zz__evaluate_compz00,
										BGl_symbol5860z00zz__evaluate_compz00, BgL_a1z00_16540,
										BgL_locz00_14030);
								}
							if (REALP(BgL_a2z00_16541))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5872z00zz__evaluate_compz00,
										BGl_symbol5860z00zz__evaluate_compz00, BgL_a2z00_16541,
										BgL_locz00_14030);
								}
							BgL_tmpz00_25149 =
								(REAL_TO_DOUBLE(BgL_a1z00_16540) <=
								REAL_TO_DOUBLE(BgL_a2z00_16541));
						}
					}
					return BBOOL(BgL_tmpz00_25149);
				}
			}
		}

	}



/* &<@anonymous:2859> */
	obj_t BGl_z62zc3z04anonymousza32859ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14032, obj_t BgL_sz00_14036)
	{
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_14033;
				obj_t BgL_a2z00_14034;
				obj_t BgL_locz00_14035;

				BgL_a1z00_14033 = PROCEDURE_REF(BgL_envz00_14032, (int) (((long) 0)));
				BgL_a2z00_14034 = PROCEDURE_REF(BgL_envz00_14032, (int) (((long) 1)));
				BgL_locz00_14035 = PROCEDURE_REF(BgL_envz00_14032, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					bool_t BgL_tmpz00_25176;

					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_bpz00_16542;

						BgL_bpz00_16542 = VECTOR_REF(((obj_t) BgL_sz00_14036), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1014 */
							obj_t BgL_a1z00_16543;
							obj_t BgL_a2z00_16544;

							BgL_a1z00_16543 =
								PROCEDURE_ENTRY(BgL_a1z00_14033) (BgL_a1z00_14033,
								BgL_sz00_14036, BEOA);
							BgL_a2z00_16544 =
								PROCEDURE_ENTRY(BgL_a2z00_14034) (BgL_a2z00_14034,
								BgL_sz00_14036, BEOA);
							if (REALP(BgL_a1z00_16543))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5874z00zz__evaluate_compz00,
										BGl_symbol5860z00zz__evaluate_compz00, BgL_a1z00_16543,
										BgL_locz00_14035);
								}
							if (REALP(BgL_a2z00_16544))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5874z00zz__evaluate_compz00,
										BGl_symbol5860z00zz__evaluate_compz00, BgL_a2z00_16544,
										BgL_locz00_14035);
								}
							BgL_tmpz00_25176 =
								(REAL_TO_DOUBLE(BgL_a1z00_16543) >=
								REAL_TO_DOUBLE(BgL_a2z00_16544));
						}
					}
					return BBOOL(BgL_tmpz00_25176);
				}
			}
		}

	}



/* &<@anonymous:2863> */
	obj_t BGl_z62zc3z04anonymousza32863ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14037, obj_t BgL_sz00_14041)
	{
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_14038;
				obj_t BgL_a2z00_14039;
				obj_t BgL_locz00_14040;

				BgL_a1z00_14038 = PROCEDURE_REF(BgL_envz00_14037, (int) (((long) 0)));
				BgL_a2z00_14039 = PROCEDURE_REF(BgL_envz00_14037, (int) (((long) 1)));
				BgL_locz00_14040 = PROCEDURE_REF(BgL_envz00_14037, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					bool_t BgL_tmpz00_25203;

					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_bpz00_16545;

						BgL_bpz00_16545 = VECTOR_REF(((obj_t) BgL_sz00_14041), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1014 */
							obj_t BgL_a1z00_16546;
							obj_t BgL_a2z00_16547;

							BgL_a1z00_16546 =
								PROCEDURE_ENTRY(BgL_a1z00_14038) (BgL_a1z00_14038,
								BgL_sz00_14041, BEOA);
							BgL_a2z00_16547 =
								PROCEDURE_ENTRY(BgL_a2z00_14039) (BgL_a2z00_14039,
								BgL_sz00_14041, BEOA);
							if (REALP(BgL_a1z00_16546))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5876z00zz__evaluate_compz00,
										BGl_symbol5860z00zz__evaluate_compz00, BgL_a1z00_16546,
										BgL_locz00_14040);
								}
							if (REALP(BgL_a2z00_16547))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5876z00zz__evaluate_compz00,
										BGl_symbol5860z00zz__evaluate_compz00, BgL_a2z00_16547,
										BgL_locz00_14040);
								}
							BgL_tmpz00_25203 =
								(REAL_TO_DOUBLE(BgL_a1z00_16546) ==
								REAL_TO_DOUBLE(BgL_a2z00_16547));
						}
					}
					return BBOOL(BgL_tmpz00_25203);
				}
			}
		}

	}



/* &<@anonymous:2867> */
	obj_t BGl_z62zc3z04anonymousza32867ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14042, obj_t BgL_sz00_14045)
	{
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_14043;
				obj_t BgL_a2z00_14044;

				BgL_a1z00_14043 = PROCEDURE_REF(BgL_envz00_14042, (int) (((long) 0)));
				BgL_a2z00_14044 = PROCEDURE_REF(BgL_envz00_14042, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1014 */
					bool_t BgL_tmpz00_25228;

					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_bpz00_16548;

						BgL_bpz00_16548 = VECTOR_REF(((obj_t) BgL_sz00_14045), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1014 */
							obj_t BgL_a1z00_16549;
							obj_t BgL_a2z00_16550;

							BgL_a1z00_16549 =
								PROCEDURE_ENTRY(BgL_a1z00_14043) (BgL_a1z00_14043,
								BgL_sz00_14045, BEOA);
							BgL_a2z00_16550 =
								PROCEDURE_ENTRY(BgL_a2z00_14044) (BgL_a2z00_14044,
								BgL_sz00_14045, BEOA);
							BgL_tmpz00_25228 = (BgL_a1z00_16549 == BgL_a2z00_16550);
					}}
					return BBOOL(BgL_tmpz00_25228);
				}
			}
		}

	}



/* &<@anonymous:2869> */
	obj_t BGl_z62zc3z04anonymousza32869ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14046, obj_t BgL_sz00_14049)
	{
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_14047;
				obj_t BgL_a2z00_14048;

				BgL_a1z00_14047 = PROCEDURE_REF(BgL_envz00_14046, (int) (((long) 0)));
				BgL_a2z00_14048 = PROCEDURE_REF(BgL_envz00_14046, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1014 */
					obj_t BgL_bpz00_16551;

					BgL_bpz00_16551 = VECTOR_REF(((obj_t) BgL_sz00_14049), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_a1z00_16552;
						obj_t BgL_a2z00_16553;

						BgL_a1z00_16552 =
							PROCEDURE_ENTRY(BgL_a1z00_14047) (BgL_a1z00_14047, BgL_sz00_14049,
							BEOA);
						BgL_a2z00_16553 =
							PROCEDURE_ENTRY(BgL_a2z00_14048) (BgL_a2z00_14048, BgL_sz00_14049,
							BEOA);
						return MAKE_YOUNG_PAIR(BgL_a1z00_16552, BgL_a2z00_16553);
					}
				}
			}
		}

	}



/* &<@anonymous:2872> */
	obj_t BGl_z62zc3z04anonymousza32872ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14050, obj_t BgL_sz00_14053)
	{
		{	/* Eval/evaluate_comp.scm 1011 */
			{	/* Eval/evaluate_comp.scm 1011 */
				obj_t BgL_a1z00_14051;
				obj_t BgL_locz00_14052;

				BgL_a1z00_14051 = PROCEDURE_REF(BgL_envz00_14050, (int) (((long) 0)));
				BgL_locz00_14052 = PROCEDURE_REF(BgL_envz00_14050, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1011 */
					obj_t BgL_bpz00_16554;

					BgL_bpz00_16554 = VECTOR_REF(((obj_t) BgL_sz00_14053), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1011 */
						obj_t BgL_a1z00_16555;

						BgL_a1z00_16555 =
							PROCEDURE_ENTRY(BgL_a1z00_14051) (BgL_a1z00_14051, BgL_sz00_14053,
							BEOA);
						if (PAIRP(BgL_a1z00_16555))
							{	/* Eval/evaluate_comp.scm 1011 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 1011 */
								BGl_loczd2typezd2errorz00zz__evaluate_compz00
									(BGl_symbol5878z00zz__evaluate_compz00,
									BGl_symbol5880z00zz__evaluate_compz00, BgL_a1z00_16555,
									BgL_locz00_14052);
							}
						return CAR(((obj_t) BgL_a1z00_16555));
					}
				}
			}
		}

	}



/* &<@anonymous:2875> */
	obj_t BGl_z62zc3z04anonymousza32875ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14054, obj_t BgL_sz00_14057)
	{
		{	/* Eval/evaluate_comp.scm 1011 */
			{	/* Eval/evaluate_comp.scm 1011 */
				obj_t BgL_a1z00_14055;
				obj_t BgL_locz00_14056;

				BgL_a1z00_14055 = PROCEDURE_REF(BgL_envz00_14054, (int) (((long) 0)));
				BgL_locz00_14056 = PROCEDURE_REF(BgL_envz00_14054, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1011 */
					obj_t BgL_bpz00_16556;

					BgL_bpz00_16556 = VECTOR_REF(((obj_t) BgL_sz00_14057), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1011 */
						obj_t BgL_a1z00_16557;

						BgL_a1z00_16557 =
							PROCEDURE_ENTRY(BgL_a1z00_14055) (BgL_a1z00_14055, BgL_sz00_14057,
							BEOA);
						if (PAIRP(BgL_a1z00_16557))
							{	/* Eval/evaluate_comp.scm 1011 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 1011 */
								BGl_loczd2typezd2errorz00zz__evaluate_compz00
									(BGl_symbol5882z00zz__evaluate_compz00,
									BGl_symbol5880z00zz__evaluate_compz00, BgL_a1z00_16557,
									BgL_locz00_14056);
							}
						return CDR(((obj_t) BgL_a1z00_16557));
					}
				}
			}
		}

	}



/* &<@anonymous:2878> */
	obj_t BGl_z62zc3z04anonymousza32878ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14058, obj_t BgL_sz00_14061)
	{
		{	/* Eval/evaluate_comp.scm 1011 */
			{	/* Eval/evaluate_comp.scm 1011 */
				obj_t BgL_a1z00_14059;
				obj_t BgL_locz00_14060;

				BgL_a1z00_14059 = PROCEDURE_REF(BgL_envz00_14058, (int) (((long) 0)));
				BgL_locz00_14060 = PROCEDURE_REF(BgL_envz00_14058, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1011 */
					obj_t BgL_bpz00_16558;

					BgL_bpz00_16558 = VECTOR_REF(((obj_t) BgL_sz00_14061), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1011 */
						obj_t BgL_a1z00_16559;

						BgL_a1z00_16559 =
							PROCEDURE_ENTRY(BgL_a1z00_14059) (BgL_a1z00_14059, BgL_sz00_14061,
							BEOA);
						{	/* Eval/evaluate_comp.scm 1011 */
							bool_t BgL_test6518z00_25296;

							if (PAIRP(BgL_a1z00_16559))
								{	/* Eval/evaluate_comp.scm 1020 */
									obj_t BgL_tmpz00_25299;

									BgL_tmpz00_25299 = CDR(BgL_a1z00_16559);
									BgL_test6518z00_25296 = PAIRP(BgL_tmpz00_25299);
								}
							else
								{	/* Eval/evaluate_comp.scm 1020 */
									BgL_test6518z00_25296 = ((bool_t) 0);
								}
							if (BgL_test6518z00_25296)
								{	/* Eval/evaluate_comp.scm 1011 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1011 */
									obj_t BgL_arg2881z00_16560;

									if (PAIRP(BgL_a1z00_16559))
										{	/* Eval/evaluate_comp.scm 1023 */
											BgL_arg2881z00_16560 = CDR(BgL_a1z00_16559);
										}
									else
										{	/* Eval/evaluate_comp.scm 1023 */
											BgL_arg2881z00_16560 = BgL_a1z00_16559;
										}
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5884z00zz__evaluate_compz00,
										BGl_symbol5880z00zz__evaluate_compz00, BgL_arg2881z00_16560,
										BgL_locz00_14060);
								}
						}
						{	/* Eval/evaluate_comp.scm 1011 */
							obj_t BgL_pairz00_16561;

							BgL_pairz00_16561 = CDR(((obj_t) BgL_a1z00_16559));
							return CAR(BgL_pairz00_16561);
						}
					}
				}
			}
		}

	}



/* bind-frame */
	obj_t BGl_bindzd2framezd2zz__evaluate_compz00(obj_t BgL_sz00_203,
		obj_t BgL_wherez00_204, long BgL_spz00_205, long BgL_arityz00_206,
		obj_t BgL_valsz00_207, obj_t BgL_locz00_208)
	{
		{	/* Eval/evaluate_comp.scm 1056 */
			if ((BgL_arityz00_206 < ((long) 0)))
				{	/* Eval/evaluate_comp.scm 1058 */
					long BgL_g1237z00_3516;

					BgL_g1237z00_3516 = (((long) -1) - BgL_arityz00_206);
					{
						long BgL_rz00_3518;
						long BgL_spz00_3519;
						obj_t BgL_lz00_3520;

						BgL_rz00_3518 = BgL_g1237z00_3516;
						BgL_spz00_3519 = BgL_spz00_205;
						BgL_lz00_3520 = BgL_valsz00_207;
					BgL_zc3z04anonymousza32886ze3z87_3521:
						if ((BgL_rz00_3518 == ((long) 0)))
							{	/* Eval/evaluate_comp.scm 1060 */
								return
									VECTOR_SET(
									((obj_t) BgL_sz00_203), BgL_spz00_3519, BgL_lz00_3520);
							}
						else
							{	/* Eval/evaluate_comp.scm 1060 */
								if (PAIRP(BgL_lz00_3520))
									{	/* Eval/evaluate_comp.scm 1062 */
										{	/* Eval/evaluate_comp.scm 1065 */
											obj_t BgL_arg2889z00_3524;

											BgL_arg2889z00_3524 = CAR(BgL_lz00_3520);
											VECTOR_SET(
												((obj_t) BgL_sz00_203), BgL_spz00_3519,
												BgL_arg2889z00_3524);
										}
										{
											obj_t BgL_lz00_25325;
											long BgL_spz00_25323;
											long BgL_rz00_25321;

											BgL_rz00_25321 = (BgL_rz00_3518 - ((long) 1));
											BgL_spz00_25323 = (BgL_spz00_3519 + ((long) 1));
											BgL_lz00_25325 = CDR(BgL_lz00_3520);
											BgL_lz00_3520 = BgL_lz00_25325;
											BgL_spz00_3519 = BgL_spz00_25323;
											BgL_rz00_3518 = BgL_rz00_25321;
											goto BgL_zc3z04anonymousza32886ze3z87_3521;
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1063 */
										long BgL_arg2893z00_3528;

										BgL_arg2893z00_3528 = bgl_list_length(BgL_valsz00_207);
										return
											BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_208,
											BgL_wherez00_204, (int) (BgL_arityz00_206),
											(int) (BgL_arg2893z00_3528));
				}}}}
			else
				{
					long BgL_rz00_3531;
					long BgL_spz00_3532;
					obj_t BgL_lz00_3533;

					BgL_rz00_3531 = BgL_arityz00_206;
					BgL_spz00_3532 = BgL_spz00_205;
					BgL_lz00_3533 = BgL_valsz00_207;
				BgL_zc3z04anonymousza32894ze3z87_3534:
					if ((BgL_rz00_3531 == ((long) 0)))
						{	/* Eval/evaluate_comp.scm 1069 */
							if (NULLP(BgL_lz00_3533))
								{	/* Eval/evaluate_comp.scm 1070 */
									return BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1071 */
									long BgL_arg2898z00_3537;

									BgL_arg2898z00_3537 = bgl_list_length(BgL_valsz00_207);
									return
										BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_208,
										BgL_wherez00_204, (int) (BgL_arityz00_206),
										(int) (BgL_arg2898z00_3537));
						}}
					else
						{	/* Eval/evaluate_comp.scm 1069 */
							if (PAIRP(BgL_lz00_3533))
								{	/* Eval/evaluate_comp.scm 1072 */
									{	/* Eval/evaluate_comp.scm 1075 */
										obj_t BgL_arg2900z00_3539;

										BgL_arg2900z00_3539 = CAR(BgL_lz00_3533);
										VECTOR_SET(
											((obj_t) BgL_sz00_203), BgL_spz00_3532,
											BgL_arg2900z00_3539);
									}
									{
										obj_t BgL_lz00_25348;
										long BgL_spz00_25346;
										long BgL_rz00_25344;

										BgL_rz00_25344 = (BgL_rz00_3531 - ((long) 1));
										BgL_spz00_25346 = (BgL_spz00_3532 + ((long) 1));
										BgL_lz00_25348 = CDR(BgL_lz00_3533);
										BgL_lz00_3533 = BgL_lz00_25348;
										BgL_spz00_3532 = BgL_spz00_25346;
										BgL_rz00_3531 = BgL_rz00_25344;
										goto BgL_zc3z04anonymousza32894ze3z87_3534;
									}
								}
							else
								{	/* Eval/evaluate_comp.scm 1073 */
									long BgL_arg2904z00_3543;

									BgL_arg2904z00_3543 = bgl_list_length(BgL_valsz00_207);
									return
										BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_208,
										BgL_wherez00_204, (int) (BgL_arityz00_206),
										(int) (BgL_arg2904z00_3543));
		}}}}

	}



/* make-boxes */
	bool_t BGl_makezd2boxeszd2zz__evaluate_compz00(obj_t BgL_sz00_211,
		obj_t BgL_ibza2za2_212, obj_t BgL_bpz00_213)
	{
		{	/* Eval/evaluate_comp.scm 1170 */
			{
				long BgL_iz00_3547;

				BgL_iz00_3547 = ((long) 0);
			BgL_zc3z04anonymousza32905ze3z87_3548:
				{	/* Eval/evaluate_comp.scm 1173 */
					long BgL_spz00_3549;

					{	/* Eval/evaluate_comp.scm 1173 */
						obj_t BgL_arg2909z00_3554;

						BgL_arg2909z00_3554 =
							VECTOR_REF(((obj_t) BgL_ibza2za2_212), BgL_iz00_3547);
						BgL_spz00_3549 =
							((long) CINT(BgL_bpz00_213) + (long) CINT(BgL_arg2909z00_3554));
					}
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_arg2906z00_3550;

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_arg2907z00_3551;

							BgL_arg2907z00_3551 =
								VECTOR_REF(((obj_t) BgL_sz00_211), BgL_spz00_3549);
							{	/* Eval/evaluate_comp.scm 202 */
								obj_t BgL_newz00_9655;

								BgL_newz00_9655 =
									create_struct(BGl_symbol5808z00zz__evaluate_compz00,
									(int) (((long) 1)));
								{	/* Eval/evaluate_comp.scm 202 */
									int BgL_tmpz00_25363;

									BgL_tmpz00_25363 = (int) (((long) 0));
									STRUCT_SET(BgL_newz00_9655, BgL_tmpz00_25363,
										BgL_arg2907z00_3551);
								}
								BgL_arg2906z00_3550 = BgL_newz00_9655;
						}}
						VECTOR_SET(
							((obj_t) BgL_sz00_211), BgL_spz00_3549, BgL_arg2906z00_3550);
					}
					{	/* Eval/evaluate_comp.scm 1175 */
						long BgL_niz00_3552;

						BgL_niz00_3552 = (BgL_iz00_3547 + ((long) 1));
						if ((BgL_niz00_3552 < VECTOR_LENGTH(((obj_t) BgL_ibza2za2_212))))
							{
								long BgL_iz00_25373;

								BgL_iz00_25373 = BgL_niz00_3552;
								BgL_iz00_3547 = BgL_iz00_25373;
								goto BgL_zc3z04anonymousza32905ze3z87_3548;
							}
						else
							{	/* Eval/evaluate_comp.scm 1176 */
								return ((bool_t) 0);
							}
					}
				}
			}
		}

	}



/* free-collect */
	obj_t BGl_freezd2collectzd2zz__evaluate_compz00(obj_t BgL_sz00_214,
		obj_t BgL_bpz00_215, obj_t BgL_iza2za2_216)
	{
		{	/* Eval/evaluate_comp.scm 1178 */
			{	/* Eval/evaluate_comp.scm 1179 */
				obj_t BgL_rz00_3557;

				BgL_rz00_3557 =
					make_vector(VECTOR_LENGTH(((obj_t) BgL_iza2za2_216)), BUNSPEC);
				{	/* Eval/evaluate_comp.scm 1179 */

					{
						long BgL_iz00_3559;

						BgL_iz00_3559 = ((long) 0);
					BgL_zc3z04anonymousza32910ze3z87_3560:
						if ((BgL_iz00_3559 >= VECTOR_LENGTH(((obj_t) BgL_iza2za2_216))))
							{	/* Eval/evaluate_comp.scm 1181 */
								return BgL_rz00_3557;
							}
						else
							{	/* Eval/evaluate_comp.scm 1181 */
								{	/* Eval/evaluate_comp.scm 1184 */
									obj_t BgL_arg2912z00_3562;

									{	/* Eval/evaluate_comp.scm 1184 */
										long BgL_arg2913z00_3563;

										{	/* Eval/evaluate_comp.scm 1184 */
											obj_t BgL_arg2914z00_3564;

											BgL_arg2914z00_3564 =
												VECTOR_REF(((obj_t) BgL_iza2za2_216), BgL_iz00_3559);
											BgL_arg2913z00_3563 =
												(
												(long) CINT(BgL_bpz00_215) +
												(long) CINT(BgL_arg2914z00_3564));
										}
										BgL_arg2912z00_3562 =
											VECTOR_REF(((obj_t) BgL_sz00_214), BgL_arg2913z00_3563);
									}
									VECTOR_SET(BgL_rz00_3557, BgL_iz00_3559, BgL_arg2912z00_3562);
								}
								{
									long BgL_iz00_25389;

									BgL_iz00_25389 = (BgL_iz00_3559 + ((long) 1));
									BgL_iz00_3559 = BgL_iz00_25389;
									goto BgL_zc3z04anonymousza32910ze3z87_3560;
								}
							}
					}
				}
			}
		}

	}



/* free-restore */
	bool_t BGl_freezd2restorezd2zz__evaluate_compz00(obj_t BgL_sz00_217,
		obj_t BgL_valza2za2_218, long BgL_spz00_219)
	{
		{	/* Eval/evaluate_comp.scm 1187 */
			{	/* Eval/evaluate_comp.scm 1188 */
				long BgL_stopz00_3568;

				BgL_stopz00_3568 =
					(BgL_spz00_219 + VECTOR_LENGTH(((obj_t) BgL_valza2za2_218)));
				{
					long BgL_iz00_9715;
					long BgL_spz00_9716;

					BgL_iz00_9715 = ((long) 0);
					BgL_spz00_9716 = BgL_spz00_219;
				BgL_recz00_9714:
					if ((BgL_spz00_9716 < BgL_stopz00_3568))
						{	/* Eval/evaluate_comp.scm 1190 */
							{	/* Eval/evaluate_comp.scm 1191 */
								obj_t BgL_arg2941z00_9722;

								BgL_arg2941z00_9722 =
									VECTOR_REF(((obj_t) BgL_valza2za2_218), BgL_iz00_9715);
								VECTOR_SET(
									((obj_t) BgL_sz00_217), BgL_spz00_9716, BgL_arg2941z00_9722);
							}
							{
								long BgL_spz00_25402;
								long BgL_iz00_25400;

								BgL_iz00_25400 = (BgL_iz00_9715 + ((long) 1));
								BgL_spz00_25402 = (BgL_spz00_9716 + ((long) 1));
								BgL_spz00_9716 = BgL_spz00_25402;
								BgL_iz00_9715 = BgL_iz00_25400;
								goto BgL_recz00_9714;
							}
						}
					else
						{	/* Eval/evaluate_comp.scm 1190 */
							return ((bool_t) 0);
						}
				}
			}
		}

	}



/* object-init */
	obj_t BGl_objectzd2initzd2zz__evaluate_compz00()
	{
		{	/* Eval/evaluate_comp.scm 15 */
			return BUNSPEC;
		}

	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zz__evaluate_compz00()
	{
		{	/* Eval/evaluate_comp.scm 15 */
			return
				BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_proc5886z00zz__evaluate_compz00,
				BGl_ev_exprz00zz__evaluate_typesz00,
				BGl_string5887z00zz__evaluate_compz00);
		}

	}



/* &comp1389 */
	obj_t BGl_z62comp1389z62zz__evaluate_compz00(obj_t BgL_envz00_14147,
		obj_t BgL_ez00_14148, obj_t BgL_stkz00_14149)
	{
		{	/* Eval/evaluate_comp.scm 276 */
			return
				BGl_errorz00zz__errorz00(BGl_string5798z00zz__evaluate_compz00,
				BGl_string5888z00zz__evaluate_compz00,
				((obj_t) ((BgL_ev_exprz00_bglt) BgL_ez00_14148)));
		}

	}



/* comp */
	obj_t BGl_compz00zz__evaluate_compz00(BgL_ev_exprz00_bglt BgL_ez00_35,
		obj_t BgL_stkz00_36)
	{
		{	/* Eval/evaluate_comp.scm 276 */
			{	/* Eval/evaluate_comp.scm 276 */
				obj_t BgL_method1391z00_3584;

				{	/* Eval/evaluate_comp.scm 276 */
					obj_t BgL_res5078z00_9772;

					{	/* Eval/evaluate_comp.scm 276 */
						long BgL_objzd2classzd2numz00_9737;

						{	/* Eval/evaluate_comp.scm 276 */
							long BgL_res5068z00_9740;

							BgL_res5068z00_9740 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_ez00_35));
							BgL_objzd2classzd2numz00_9737 = BgL_res5068z00_9740;
						}
						{	/* Eval/evaluate_comp.scm 276 */
							obj_t BgL_arg4304z00_9738;

							BgL_arg4304z00_9738 =
								PROCEDURE_REF(BGl_compzd2envzd2zz__evaluate_compz00,
								(int) (((long) 1)));
							{	/* Eval/evaluate_comp.scm 276 */
								int BgL_offsetz00_9742;

								BgL_offsetz00_9742 = (int) (BgL_objzd2classzd2numz00_9737);
								{	/* Eval/evaluate_comp.scm 276 */
									long BgL_offsetz00_9743;

									BgL_offsetz00_9743 =
										((long) (BgL_offsetz00_9742) - OBJECT_TYPE);
									{	/* Eval/evaluate_comp.scm 276 */
										long BgL_modz00_9744;

										BgL_modz00_9744 =
											(BgL_offsetz00_9743 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Eval/evaluate_comp.scm 276 */
											long BgL_restz00_9746;

											BgL_restz00_9746 =
												(BgL_offsetz00_9743 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Eval/evaluate_comp.scm 276 */

												{	/* Eval/evaluate_comp.scm 276 */
													obj_t BgL_bucketz00_9748;

													BgL_bucketz00_9748 =
														VECTOR_REF(
														((obj_t) BgL_arg4304z00_9738), BgL_modz00_9744);
													BgL_res5078z00_9772 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_9748), BgL_restz00_9746);
					}}}}}}}}
					BgL_method1391z00_3584 = BgL_res5078z00_9772;
				}
				return
					PROCEDURE_ENTRY(BgL_method1391z00_3584) (BgL_method1391z00_3584,
					((obj_t) BgL_ez00_35), BgL_stkz00_36, BEOA);
			}
		}

	}



/* &comp */
	obj_t BGl_z62compz62zz__evaluate_compz00(obj_t BgL_envz00_14150,
		obj_t BgL_ez00_14151, obj_t BgL_stkz00_14152)
	{
		{	/* Eval/evaluate_comp.scm 276 */
			{	/* Eval/evaluate_comp.scm 276 */
				BgL_ev_exprz00_bglt BgL_auxz00_25439;

				if (BGl_isazf3zf3zz__objectz00(BgL_ez00_14151,
						BGl_ev_exprz00zz__evaluate_typesz00))
					{	/* Eval/evaluate_comp.scm 276 */
						BgL_auxz00_25439 = ((BgL_ev_exprz00_bglt) BgL_ez00_14151);
					}
				else
					{
						obj_t BgL_auxz00_25443;

						BgL_auxz00_25443 =
							BGl_typezd2errorzd2zz__errorz00
							(BGl_string5803z00zz__evaluate_compz00, BINT(((long) 7022)),
							BGl_string5889z00zz__evaluate_compz00,
							BGl_string5805z00zz__evaluate_compz00, BgL_ez00_14151);
						FAILURE(BgL_auxz00_25443, BFALSE, BFALSE);
					}
				return
					BGl_compz00zz__evaluate_compz00(BgL_auxz00_25439, BgL_stkz00_14152);
			}
		}

	}



/* method-init */
	obj_t BGl_methodzd2initzd2zz__evaluate_compz00()
	{
		{	/* Eval/evaluate_comp.scm 15 */
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_trapz00zz__evaluate_typesz00,
				BGl_proc5890z00zz__evaluate_compz00,
				BGl_string5891z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_varz00zz__evaluate_typesz00, BGl_proc5892z00zz__evaluate_compz00,
				BGl_string5891z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_setlocalz00zz__evaluate_typesz00,
				BGl_proc5893z00zz__evaluate_compz00,
				BGl_string5891z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_globalz00zz__evaluate_typesz00,
				BGl_proc5894z00zz__evaluate_compz00,
				BGl_string5891z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_setglobalz00zz__evaluate_typesz00,
				BGl_proc5895z00zz__evaluate_compz00,
				BGl_string5891z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_defglobalz00zz__evaluate_typesz00,
				BGl_proc5896z00zz__evaluate_compz00,
				BGl_string5891z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_littz00zz__evaluate_typesz00,
				BGl_proc5897z00zz__evaluate_compz00,
				BGl_string5891z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_ifz00zz__evaluate_typesz00, BGl_proc5898z00zz__evaluate_compz00,
				BGl_string5891z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_orz00zz__evaluate_typesz00, BGl_proc5899z00zz__evaluate_compz00,
				BGl_string5891z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_andz00zz__evaluate_typesz00, BGl_proc5900z00zz__evaluate_compz00,
				BGl_string5891z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_prog2z00zz__evaluate_typesz00,
				BGl_proc5901z00zz__evaluate_compz00,
				BGl_string5891z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_letz00zz__evaluate_typesz00, BGl_proc5902z00zz__evaluate_compz00,
				BGl_string5891z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_letza2za2zz__evaluate_typesz00,
				BGl_proc5903z00zz__evaluate_compz00,
				BGl_string5891z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_letrecz00zz__evaluate_typesz00,
				BGl_proc5904z00zz__evaluate_compz00,
				BGl_string5891z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_bindzd2exitzd2zz__evaluate_typesz00,
				BGl_proc5905z00zz__evaluate_compz00,
				BGl_string5891z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00,
				BGl_proc5906z00zz__evaluate_compz00,
				BGl_string5891z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_withzd2handlerzd2zz__evaluate_typesz00,
				BGl_proc5907z00zz__evaluate_compz00,
				BGl_string5891z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_synchroniza7eza7zz__evaluate_typesz00,
				BGl_proc5908z00zz__evaluate_compz00,
				BGl_string5891z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_labelsz00zz__evaluate_typesz00,
				BGl_proc5909z00zz__evaluate_compz00,
				BGl_string5891z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_gotoz00zz__evaluate_typesz00,
				BGl_proc5910z00zz__evaluate_compz00,
				BGl_string5891z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_appz00zz__evaluate_typesz00, BGl_proc5911z00zz__evaluate_compz00,
				BGl_string5891z00zz__evaluate_compz00);
			return
				BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_absz00zz__evaluate_typesz00, BGl_proc5912z00zz__evaluate_compz00,
				BGl_string5891z00zz__evaluate_compz00);
		}

	}



/* &comp-ev_abs1439 */
	obj_t BGl_z62compzd2ev_abs1439zb0zz__evaluate_compz00(obj_t BgL_envz00_14347,
		obj_t BgL_ez00_14348, obj_t BgL_stkz00_14349)
	{
		{	/* Eval/evaluate_comp.scm 1158 */
			{	/* Eval/evaluate_comp.scm 1160 */
				obj_t BgL_ifreesz00_16564;
				obj_t BgL_iboxesz00_16565;
				long BgL_siza7eza7_16566;
				long BgL_siza7ezd2framez75_16567;
				obj_t BgL_nstkz00_16568;

				{	/* Eval/evaluate_comp.scm 1160 */
					obj_t BgL_arg4012z00_16569;

					{	/* Eval/evaluate_comp.scm 1160 */
						obj_t BgL_l1366z00_16570;

						BgL_l1366z00_16570 =
							(((BgL_ev_absz00_bglt) COBJECT(
									((BgL_ev_absz00_bglt) BgL_ez00_14348)))->BgL_freez00);
						if (NULLP(BgL_l1366z00_16570))
							{	/* Eval/evaluate_comp.scm 1160 */
								BgL_arg4012z00_16569 = BNIL;
							}
						else
							{	/* Eval/evaluate_comp.scm 1160 */
								obj_t BgL_head1368z00_16571;

								{	/* Eval/evaluate_comp.scm 1160 */
									obj_t BgL_res5217z00_16572;

									BgL_res5217z00_16572 = MAKE_YOUNG_PAIR(BNIL, BNIL);
									BgL_head1368z00_16571 = BgL_res5217z00_16572;
								}
								{
									obj_t BgL_l1366z00_16574;
									obj_t BgL_tail1369z00_16575;

									BgL_l1366z00_16574 = BgL_l1366z00_16570;
									BgL_tail1369z00_16575 = BgL_head1368z00_16571;
								BgL_zc3z04anonymousza34014ze3z87_16573:
									if (NULLP(BgL_l1366z00_16574))
										{	/* Eval/evaluate_comp.scm 1160 */
											BgL_arg4012z00_16569 = CDR(BgL_head1368z00_16571);
										}
									else
										{	/* Eval/evaluate_comp.scm 1160 */
											obj_t BgL_newtail1370z00_16576;

											{	/* Eval/evaluate_comp.scm 1160 */
												obj_t BgL_arg4017z00_16577;

												{	/* Eval/evaluate_comp.scm 1160 */
													obj_t BgL_vz00_16578;

													BgL_vz00_16578 = CAR(((obj_t) BgL_l1366z00_16574));
													BgL_arg4017z00_16577 =
														BGl__indexz00zz__evaluate_compz00(BgL_vz00_16578,
														BgL_stkz00_14349);
												}
												{	/* Eval/evaluate_comp.scm 1160 */
													obj_t BgL_res5223z00_16579;

													BgL_res5223z00_16579 =
														MAKE_YOUNG_PAIR(BgL_arg4017z00_16577, BNIL);
													BgL_newtail1370z00_16576 = BgL_res5223z00_16579;
												}
											}
											SET_CDR(BgL_tail1369z00_16575, BgL_newtail1370z00_16576);
											{	/* Eval/evaluate_comp.scm 1160 */
												obj_t BgL_arg4016z00_16580;

												BgL_arg4016z00_16580 =
													CDR(((obj_t) BgL_l1366z00_16574));
												{
													obj_t BgL_tail1369z00_25486;
													obj_t BgL_l1366z00_25485;

													BgL_l1366z00_25485 = BgL_arg4016z00_16580;
													BgL_tail1369z00_25486 = BgL_newtail1370z00_16576;
													BgL_tail1369z00_16575 = BgL_tail1369z00_25486;
													BgL_l1366z00_16574 = BgL_l1366z00_25485;
													goto BgL_zc3z04anonymousza34014ze3z87_16573;
												}
											}
										}
								}
							}
					}
					BgL_ifreesz00_16564 =
						BGl_listzd2ze3vectorz31zz__r4_vectors_6_8z00(BgL_arg4012z00_16569);
				}
				{	/* Eval/evaluate_comp.scm 1161 */
					obj_t BgL_arg4018z00_16581;

					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_l1371z00_16582;

						BgL_l1371z00_16582 =
							(((BgL_ev_absz00_bglt) COBJECT(
									((BgL_ev_absz00_bglt) BgL_ez00_14348)))->BgL_boxesz00);
						if (NULLP(BgL_l1371z00_16582))
							{	/* Eval/evaluate_comp.scm 1161 */
								BgL_arg4018z00_16581 = BNIL;
							}
						else
							{	/* Eval/evaluate_comp.scm 1161 */
								obj_t BgL_head1373z00_16583;

								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_res5225z00_16584;

									BgL_res5225z00_16584 = MAKE_YOUNG_PAIR(BNIL, BNIL);
									BgL_head1373z00_16583 = BgL_res5225z00_16584;
								}
								{
									obj_t BgL_l1371z00_16586;
									obj_t BgL_tail1374z00_16587;

									BgL_l1371z00_16586 = BgL_l1371z00_16582;
									BgL_tail1374z00_16587 = BgL_head1373z00_16583;
								BgL_zc3z04anonymousza34020ze3z87_16585:
									if (NULLP(BgL_l1371z00_16586))
										{	/* Eval/evaluate_comp.scm 1161 */
											BgL_arg4018z00_16581 = CDR(BgL_head1373z00_16583);
										}
									else
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_newtail1375z00_16588;

											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_arg4023z00_16589;

												{	/* Eval/evaluate_comp.scm 1161 */
													obj_t BgL_vz00_16590;

													BgL_vz00_16590 = CAR(((obj_t) BgL_l1371z00_16586));
													BgL_arg4023z00_16589 =
														BGl__indexz00zz__evaluate_compz00(BgL_vz00_16590,
														(((BgL_ev_absz00_bglt) COBJECT(
																	((BgL_ev_absz00_bglt) BgL_ez00_14348)))->
															BgL_varsz00));
												}
												{	/* Eval/evaluate_comp.scm 1161 */
													obj_t BgL_res5227z00_16591;

													BgL_res5227z00_16591 =
														MAKE_YOUNG_PAIR(BgL_arg4023z00_16589, BNIL);
													BgL_newtail1375z00_16588 = BgL_res5227z00_16591;
												}
											}
											SET_CDR(BgL_tail1374z00_16587, BgL_newtail1375z00_16588);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_arg4022z00_16592;

												BgL_arg4022z00_16592 =
													CDR(((obj_t) BgL_l1371z00_16586));
												{
													obj_t BgL_tail1374z00_25506;
													obj_t BgL_l1371z00_25505;

													BgL_l1371z00_25505 = BgL_arg4022z00_16592;
													BgL_tail1374z00_25506 = BgL_newtail1375z00_16588;
													BgL_tail1374z00_16587 = BgL_tail1374z00_25506;
													BgL_l1371z00_16586 = BgL_l1371z00_25505;
													goto BgL_zc3z04anonymousza34020ze3z87_16585;
												}
											}
										}
								}
							}
					}
					BgL_iboxesz00_16565 =
						BGl_listzd2ze3vectorz31zz__r4_vectors_6_8z00(BgL_arg4018z00_16581);
				}
				BgL_siza7eza7_16566 =
					bgl_list_length(
					(((BgL_ev_absz00_bglt) COBJECT(
								((BgL_ev_absz00_bglt) BgL_ez00_14348)))->BgL_varsz00));
				BgL_siza7ezd2framez75_16567 =
					(
					(long) (
						(((BgL_ev_absz00_bglt) COBJECT(
									((BgL_ev_absz00_bglt) BgL_ez00_14348)))->BgL_siza7eza7)) +
					bgl_list_length(
						(((BgL_ev_absz00_bglt) COBJECT(
									((BgL_ev_absz00_bglt) BgL_ez00_14348)))->BgL_freez00)));
				BgL_nstkz00_16568 =
					BGl_appendzd221011zd2zz__evaluate_compz00(
					(((BgL_ev_absz00_bglt) COBJECT(
								((BgL_ev_absz00_bglt) BgL_ez00_14348)))->BgL_varsz00),
					(((BgL_ev_absz00_bglt) COBJECT(
								((BgL_ev_absz00_bglt) BgL_ez00_14348)))->BgL_freez00));
				{	/* Eval/evaluate_comp.scm 1165 */
					obj_t BgL_bodyz00_16593;

					BgL_bodyz00_16593 =
						BGl_compz00zz__evaluate_compz00(
						(((BgL_ev_absz00_bglt) COBJECT(
									((BgL_ev_absz00_bglt) BgL_ez00_14348)))->BgL_bodyz00),
						BgL_nstkz00_16568);
					{

						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_aux1249z00_16599;

							BgL_aux1249z00_16599 =
								(((BgL_ev_absz00_bglt) COBJECT(
										((BgL_ev_absz00_bglt) BgL_ez00_14348)))->BgL_arityz00);
							if (INTEGERP(BgL_aux1249z00_16599))
								{	/* Eval/evaluate_comp.scm 1167 */
									switch ((long) CINT(BgL_aux1249z00_16599))
										{
										case ((long) 0):

											if ((VECTOR_LENGTH(BgL_ifreesz00_16564) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1167 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16565) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3z04anonymousza33444ze3z87_16600;

															BgL_zc3z04anonymousza33444ze3z87_16600 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33444ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33444ze3z87_16600,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14348)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33444ze3z87_16600,
																(int) (((long) 1)), BgL_bodyz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33444ze3z87_16600,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_16567));
															return BgL_zc3z04anonymousza33444ze3z87_16600;
														}
													else
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3z04anonymousza33450ze3z87_16601;

															BgL_zc3z04anonymousza33450ze3z87_16601 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33450ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33450ze3z87_16601,
																(int) (((long) 0)), BgL_iboxesz00_16565);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33450ze3z87_16601,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14348)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33450ze3z87_16601,
																(int) (((long) 2)), BgL_bodyz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33450ze3z87_16601,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_16567));
															return BgL_zc3z04anonymousza33450ze3z87_16601;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1167 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16565) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3z04anonymousza33460ze3z87_16602;

															BgL_zc3z04anonymousza33460ze3z87_16602 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33460ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33460ze3z87_16602,
																(int) (((long) 0)), BgL_ifreesz00_16564);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33460ze3z87_16602,
																(int) (((long) 1)), BINT(BgL_siza7eza7_16566));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33460ze3z87_16602,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14348)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33460ze3z87_16602,
																(int) (((long) 3)), BgL_bodyz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33460ze3z87_16602,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_16567));
															return BgL_zc3z04anonymousza33460ze3z87_16602;
														}
													else
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3z04anonymousza33467ze3z87_16603;

															BgL_zc3z04anonymousza33467ze3z87_16603 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33467ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33467ze3z87_16603,
																(int) (((long) 0)), BgL_ifreesz00_16564);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33467ze3z87_16603,
																(int) (((long) 1)), BgL_iboxesz00_16565);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33467ze3z87_16603,
																(int) (((long) 2)), BINT(BgL_siza7eza7_16566));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33467ze3z87_16603,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14348)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33467ze3z87_16603,
																(int) (((long) 4)), BgL_bodyz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33467ze3z87_16603,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_16567));
															return BgL_zc3z04anonymousza33467ze3z87_16603;
														}
												}
											break;
										case ((long) -1):

											if ((VECTOR_LENGTH(BgL_ifreesz00_16564) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1167 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16565) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3z04anonymousza33482ze3z87_16604;

															BgL_zc3z04anonymousza33482ze3z87_16604 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33482ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33482ze3z87_16604,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14348)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33482ze3z87_16604,
																(int) (((long) 1)), BgL_bodyz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33482ze3z87_16604,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_16567));
															return BgL_zc3z04anonymousza33482ze3z87_16604;
														}
													else
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3z04anonymousza33491ze3z87_16605;

															BgL_zc3z04anonymousza33491ze3z87_16605 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33491ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33491ze3z87_16605,
																(int) (((long) 0)), BgL_iboxesz00_16565);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33491ze3z87_16605,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14348)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33491ze3z87_16605,
																(int) (((long) 2)), BgL_bodyz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33491ze3z87_16605,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_16567));
															return BgL_zc3z04anonymousza33491ze3z87_16605;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1167 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16565) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3z04anonymousza33503ze3z87_16606;

															BgL_zc3z04anonymousza33503ze3z87_16606 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33503ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33503ze3z87_16606,
																(int) (((long) 0)), BgL_ifreesz00_16564);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33503ze3z87_16606,
																(int) (((long) 1)), BINT(BgL_siza7eza7_16566));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33503ze3z87_16606,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14348)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33503ze3z87_16606,
																(int) (((long) 3)), BgL_bodyz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33503ze3z87_16606,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_16567));
															return BgL_zc3z04anonymousza33503ze3z87_16606;
														}
													else
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3z04anonymousza33512ze3z87_16607;

															BgL_zc3z04anonymousza33512ze3z87_16607 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33512ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33512ze3z87_16607,
																(int) (((long) 0)), BgL_ifreesz00_16564);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33512ze3z87_16607,
																(int) (((long) 1)), BgL_iboxesz00_16565);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33512ze3z87_16607,
																(int) (((long) 2)), BINT(BgL_siza7eza7_16566));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33512ze3z87_16607,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14348)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33512ze3z87_16607,
																(int) (((long) 4)), BgL_bodyz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33512ze3z87_16607,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_16567));
															return BgL_zc3z04anonymousza33512ze3z87_16607;
														}
												}
											break;
										case ((long) 1):

											if ((VECTOR_LENGTH(BgL_ifreesz00_16564) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1167 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16565) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3z04anonymousza33528ze3z87_16608;

															BgL_zc3z04anonymousza33528ze3z87_16608 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33528ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33528ze3z87_16608,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14348)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33528ze3z87_16608,
																(int) (((long) 1)), BgL_bodyz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33528ze3z87_16608,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_16567));
															return BgL_zc3z04anonymousza33528ze3z87_16608;
														}
													else
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3z04anonymousza33536ze3z87_16609;

															BgL_zc3z04anonymousza33536ze3z87_16609 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33536ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33536ze3z87_16609,
																(int) (((long) 0)), BgL_iboxesz00_16565);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33536ze3z87_16609,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14348)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33536ze3z87_16609,
																(int) (((long) 2)), BgL_bodyz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33536ze3z87_16609,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_16567));
															return BgL_zc3z04anonymousza33536ze3z87_16609;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1167 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16565) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3z04anonymousza33548ze3z87_16610;

															BgL_zc3z04anonymousza33548ze3z87_16610 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33548ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33548ze3z87_16610,
																(int) (((long) 0)), BgL_ifreesz00_16564);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33548ze3z87_16610,
																(int) (((long) 1)), BINT(BgL_siza7eza7_16566));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33548ze3z87_16610,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14348)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33548ze3z87_16610,
																(int) (((long) 3)), BgL_bodyz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33548ze3z87_16610,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_16567));
															return BgL_zc3z04anonymousza33548ze3z87_16610;
														}
													else
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3z04anonymousza33557ze3z87_16611;

															BgL_zc3z04anonymousza33557ze3z87_16611 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33557ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33557ze3z87_16611,
																(int) (((long) 0)), BgL_ifreesz00_16564);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33557ze3z87_16611,
																(int) (((long) 1)), BgL_iboxesz00_16565);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33557ze3z87_16611,
																(int) (((long) 2)), BINT(BgL_siza7eza7_16566));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33557ze3z87_16611,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14348)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33557ze3z87_16611,
																(int) (((long) 4)), BgL_bodyz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33557ze3z87_16611,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_16567));
															return BgL_zc3z04anonymousza33557ze3z87_16611;
														}
												}
											break;
										case ((long) -2):

											if ((VECTOR_LENGTH(BgL_ifreesz00_16564) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1167 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16565) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3z04anonymousza33573ze3z87_16612;

															BgL_zc3z04anonymousza33573ze3z87_16612 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33573ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33573ze3z87_16612,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14348)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33573ze3z87_16612,
																(int) (((long) 1)), BgL_bodyz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33573ze3z87_16612,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_16567));
															return BgL_zc3z04anonymousza33573ze3z87_16612;
														}
													else
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3z04anonymousza33582ze3z87_16613;

															BgL_zc3z04anonymousza33582ze3z87_16613 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33582ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33582ze3z87_16613,
																(int) (((long) 0)), BgL_iboxesz00_16565);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33582ze3z87_16613,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14348)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33582ze3z87_16613,
																(int) (((long) 2)), BgL_bodyz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33582ze3z87_16613,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_16567));
															return BgL_zc3z04anonymousza33582ze3z87_16613;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1167 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16565) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3z04anonymousza33594ze3z87_16614;

															BgL_zc3z04anonymousza33594ze3z87_16614 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33594ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33594ze3z87_16614,
																(int) (((long) 0)), BgL_ifreesz00_16564);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33594ze3z87_16614,
																(int) (((long) 1)), BINT(BgL_siza7eza7_16566));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33594ze3z87_16614,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14348)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33594ze3z87_16614,
																(int) (((long) 3)), BgL_bodyz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33594ze3z87_16614,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_16567));
															return BgL_zc3z04anonymousza33594ze3z87_16614;
														}
													else
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3z04anonymousza33605ze3z87_16615;

															BgL_zc3z04anonymousza33605ze3z87_16615 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33605ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33605ze3z87_16615,
																(int) (((long) 0)), BgL_ifreesz00_16564);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33605ze3z87_16615,
																(int) (((long) 1)), BgL_iboxesz00_16565);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33605ze3z87_16615,
																(int) (((long) 2)), BINT(BgL_siza7eza7_16566));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33605ze3z87_16615,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14348)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33605ze3z87_16615,
																(int) (((long) 4)), BgL_bodyz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33605ze3z87_16615,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_16567));
															return BgL_zc3z04anonymousza33605ze3z87_16615;
														}
												}
											break;
										case ((long) 2):

											if ((VECTOR_LENGTH(BgL_ifreesz00_16564) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1167 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16565) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3z04anonymousza33623ze3z87_16616;

															BgL_zc3z04anonymousza33623ze3z87_16616 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33623ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33623ze3z87_16616,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14348)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33623ze3z87_16616,
																(int) (((long) 1)), BgL_bodyz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33623ze3z87_16616,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_16567));
															return BgL_zc3z04anonymousza33623ze3z87_16616;
														}
													else
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3z04anonymousza33632ze3z87_16617;

															BgL_zc3z04anonymousza33632ze3z87_16617 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33632ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33632ze3z87_16617,
																(int) (((long) 0)), BgL_iboxesz00_16565);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33632ze3z87_16617,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14348)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33632ze3z87_16617,
																(int) (((long) 2)), BgL_bodyz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33632ze3z87_16617,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_16567));
															return BgL_zc3z04anonymousza33632ze3z87_16617;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1167 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16565) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3z04anonymousza33643ze3z87_16618;

															BgL_zc3z04anonymousza33643ze3z87_16618 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33643ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33643ze3z87_16618,
																(int) (((long) 0)), BgL_ifreesz00_16564);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33643ze3z87_16618,
																(int) (((long) 1)), BINT(BgL_siza7eza7_16566));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33643ze3z87_16618,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14348)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33643ze3z87_16618,
																(int) (((long) 3)), BgL_bodyz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33643ze3z87_16618,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_16567));
															return BgL_zc3z04anonymousza33643ze3z87_16618;
														}
													else
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3z04anonymousza33652ze3z87_16619;

															BgL_zc3z04anonymousza33652ze3z87_16619 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33652ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33652ze3z87_16619,
																(int) (((long) 0)), BgL_ifreesz00_16564);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33652ze3z87_16619,
																(int) (((long) 1)), BgL_iboxesz00_16565);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33652ze3z87_16619,
																(int) (((long) 2)), BINT(BgL_siza7eza7_16566));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33652ze3z87_16619,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14348)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33652ze3z87_16619,
																(int) (((long) 4)), BgL_bodyz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33652ze3z87_16619,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_16567));
															return BgL_zc3z04anonymousza33652ze3z87_16619;
														}
												}
											break;
										case ((long) -3):

											if ((VECTOR_LENGTH(BgL_ifreesz00_16564) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1167 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16565) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3z04anonymousza33669ze3z87_16620;

															BgL_zc3z04anonymousza33669ze3z87_16620 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33669ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33669ze3z87_16620,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14348)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33669ze3z87_16620,
																(int) (((long) 1)), BgL_bodyz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33669ze3z87_16620,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_16567));
															return BgL_zc3z04anonymousza33669ze3z87_16620;
														}
													else
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3z04anonymousza33678ze3z87_16621;

															BgL_zc3z04anonymousza33678ze3z87_16621 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33678ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33678ze3z87_16621,
																(int) (((long) 0)), BgL_iboxesz00_16565);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33678ze3z87_16621,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14348)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33678ze3z87_16621,
																(int) (((long) 2)), BgL_bodyz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33678ze3z87_16621,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_16567));
															return BgL_zc3z04anonymousza33678ze3z87_16621;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1167 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16565) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3z04anonymousza33692ze3z87_16622;

															BgL_zc3z04anonymousza33692ze3z87_16622 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33692ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33692ze3z87_16622,
																(int) (((long) 0)), BgL_ifreesz00_16564);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33692ze3z87_16622,
																(int) (((long) 1)), BINT(BgL_siza7eza7_16566));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33692ze3z87_16622,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14348)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33692ze3z87_16622,
																(int) (((long) 3)), BgL_bodyz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33692ze3z87_16622,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_16567));
															return BgL_zc3z04anonymousza33692ze3z87_16622;
														}
													else
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3z04anonymousza33702ze3z87_16623;

															BgL_zc3z04anonymousza33702ze3z87_16623 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33702ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33702ze3z87_16623,
																(int) (((long) 0)), BgL_ifreesz00_16564);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33702ze3z87_16623,
																(int) (((long) 1)), BgL_iboxesz00_16565);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33702ze3z87_16623,
																(int) (((long) 2)), BINT(BgL_siza7eza7_16566));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33702ze3z87_16623,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14348)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33702ze3z87_16623,
																(int) (((long) 4)), BgL_bodyz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33702ze3z87_16623,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_16567));
															return BgL_zc3z04anonymousza33702ze3z87_16623;
														}
												}
											break;
										case ((long) 3):

											if ((VECTOR_LENGTH(BgL_ifreesz00_16564) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1167 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16565) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3z04anonymousza33720ze3z87_16624;

															BgL_zc3z04anonymousza33720ze3z87_16624 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33720ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33720ze3z87_16624,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14348)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33720ze3z87_16624,
																(int) (((long) 1)), BgL_bodyz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33720ze3z87_16624,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_16567));
															return BgL_zc3z04anonymousza33720ze3z87_16624;
														}
													else
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3z04anonymousza33729ze3z87_16625;

															BgL_zc3z04anonymousza33729ze3z87_16625 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33729ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33729ze3z87_16625,
																(int) (((long) 0)), BgL_iboxesz00_16565);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33729ze3z87_16625,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14348)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33729ze3z87_16625,
																(int) (((long) 2)), BgL_bodyz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33729ze3z87_16625,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_16567));
															return BgL_zc3z04anonymousza33729ze3z87_16625;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1167 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16565) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3z04anonymousza33741ze3z87_16626;

															BgL_zc3z04anonymousza33741ze3z87_16626 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33741ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33741ze3z87_16626,
																(int) (((long) 0)), BgL_ifreesz00_16564);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33741ze3z87_16626,
																(int) (((long) 1)), BINT(BgL_siza7eza7_16566));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33741ze3z87_16626,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14348)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33741ze3z87_16626,
																(int) (((long) 3)), BgL_bodyz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33741ze3z87_16626,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_16567));
															return BgL_zc3z04anonymousza33741ze3z87_16626;
														}
													else
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3z04anonymousza33751ze3z87_16627;

															BgL_zc3z04anonymousza33751ze3z87_16627 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33751ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33751ze3z87_16627,
																(int) (((long) 0)), BgL_ifreesz00_16564);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33751ze3z87_16627,
																(int) (((long) 1)), BgL_iboxesz00_16565);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33751ze3z87_16627,
																(int) (((long) 2)), BINT(BgL_siza7eza7_16566));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33751ze3z87_16627,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14348)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33751ze3z87_16627,
																(int) (((long) 4)), BgL_bodyz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33751ze3z87_16627,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_16567));
															return BgL_zc3z04anonymousza33751ze3z87_16627;
														}
												}
											break;
										case ((long) -4):

											if ((VECTOR_LENGTH(BgL_ifreesz00_16564) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1167 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16565) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3z04anonymousza33767ze3z87_16628;

															BgL_zc3z04anonymousza33767ze3z87_16628 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33767ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33767ze3z87_16628,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14348)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33767ze3z87_16628,
																(int) (((long) 1)), BgL_bodyz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33767ze3z87_16628,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_16567));
															return BgL_zc3z04anonymousza33767ze3z87_16628;
														}
													else
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3z04anonymousza33777ze3z87_16629;

															BgL_zc3z04anonymousza33777ze3z87_16629 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33777ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33777ze3z87_16629,
																(int) (((long) 0)), BgL_iboxesz00_16565);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33777ze3z87_16629,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14348)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33777ze3z87_16629,
																(int) (((long) 2)), BgL_bodyz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33777ze3z87_16629,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_16567));
															return BgL_zc3z04anonymousza33777ze3z87_16629;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1167 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16565) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3z04anonymousza33790ze3z87_16630;

															BgL_zc3z04anonymousza33790ze3z87_16630 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33790ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33790ze3z87_16630,
																(int) (((long) 0)), BgL_ifreesz00_16564);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33790ze3z87_16630,
																(int) (((long) 1)), BINT(BgL_siza7eza7_16566));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33790ze3z87_16630,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14348)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33790ze3z87_16630,
																(int) (((long) 3)), BgL_bodyz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33790ze3z87_16630,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_16567));
															return BgL_zc3z04anonymousza33790ze3z87_16630;
														}
													else
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3z04anonymousza33801ze3z87_16631;

															BgL_zc3z04anonymousza33801ze3z87_16631 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33801ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33801ze3z87_16631,
																(int) (((long) 0)), BgL_ifreesz00_16564);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33801ze3z87_16631,
																(int) (((long) 1)), BgL_iboxesz00_16565);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33801ze3z87_16631,
																(int) (((long) 2)), BINT(BgL_siza7eza7_16566));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33801ze3z87_16631,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14348)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33801ze3z87_16631,
																(int) (((long) 4)), BgL_bodyz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33801ze3z87_16631,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_16567));
															return BgL_zc3z04anonymousza33801ze3z87_16631;
														}
												}
											break;
										case ((long) 4):

											if ((VECTOR_LENGTH(BgL_ifreesz00_16564) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1167 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16565) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3z04anonymousza33818ze3z87_16632;

															BgL_zc3z04anonymousza33818ze3z87_16632 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33818ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33818ze3z87_16632,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14348)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33818ze3z87_16632,
																(int) (((long) 1)), BgL_bodyz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33818ze3z87_16632,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_16567));
															return BgL_zc3z04anonymousza33818ze3z87_16632;
														}
													else
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3z04anonymousza33828ze3z87_16633;

															BgL_zc3z04anonymousza33828ze3z87_16633 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33828ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33828ze3z87_16633,
																(int) (((long) 0)), BgL_iboxesz00_16565);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33828ze3z87_16633,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14348)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33828ze3z87_16633,
																(int) (((long) 2)), BgL_bodyz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33828ze3z87_16633,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_16567));
															return BgL_zc3z04anonymousza33828ze3z87_16633;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1167 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16565) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3z04anonymousza33841ze3z87_16634;

															BgL_zc3z04anonymousza33841ze3z87_16634 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33841ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33841ze3z87_16634,
																(int) (((long) 0)), BgL_ifreesz00_16564);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33841ze3z87_16634,
																(int) (((long) 1)), BINT(BgL_siza7eza7_16566));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33841ze3z87_16634,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14348)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33841ze3z87_16634,
																(int) (((long) 3)), BgL_bodyz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33841ze3z87_16634,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_16567));
															return BgL_zc3z04anonymousza33841ze3z87_16634;
														}
													else
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3z04anonymousza33852ze3z87_16635;

															BgL_zc3z04anonymousza33852ze3z87_16635 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33852ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33852ze3z87_16635,
																(int) (((long) 0)), BgL_ifreesz00_16564);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33852ze3z87_16635,
																(int) (((long) 1)), BgL_iboxesz00_16565);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33852ze3z87_16635,
																(int) (((long) 2)), BINT(BgL_siza7eza7_16566));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33852ze3z87_16635,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14348)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33852ze3z87_16635,
																(int) (((long) 4)), BgL_bodyz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33852ze3z87_16635,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_16567));
															return BgL_zc3z04anonymousza33852ze3z87_16635;
														}
												}
											break;
										case ((long) -5):

											if ((VECTOR_LENGTH(BgL_ifreesz00_16564) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1167 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16565) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3z04anonymousza33869ze3z87_16636;

															BgL_zc3z04anonymousza33869ze3z87_16636 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33869ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33869ze3z87_16636,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14348)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33869ze3z87_16636,
																(int) (((long) 1)), BgL_bodyz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33869ze3z87_16636,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_16567));
															return BgL_zc3z04anonymousza33869ze3z87_16636;
														}
													else
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3z04anonymousza33880ze3z87_16637;

															BgL_zc3z04anonymousza33880ze3z87_16637 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33880ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33880ze3z87_16637,
																(int) (((long) 0)), BgL_iboxesz00_16565);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33880ze3z87_16637,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14348)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33880ze3z87_16637,
																(int) (((long) 2)), BgL_bodyz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33880ze3z87_16637,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_16567));
															return BgL_zc3z04anonymousza33880ze3z87_16637;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1167 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16565) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3z04anonymousza33894ze3z87_16638;

															BgL_zc3z04anonymousza33894ze3z87_16638 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33894ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33894ze3z87_16638,
																(int) (((long) 0)), BgL_ifreesz00_16564);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33894ze3z87_16638,
																(int) (((long) 1)), BINT(BgL_siza7eza7_16566));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33894ze3z87_16638,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14348)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33894ze3z87_16638,
																(int) (((long) 3)), BgL_bodyz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33894ze3z87_16638,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_16567));
															return BgL_zc3z04anonymousza33894ze3z87_16638;
														}
													else
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3z04anonymousza33906ze3z87_16639;

															BgL_zc3z04anonymousza33906ze3z87_16639 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33906ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33906ze3z87_16639,
																(int) (((long) 0)), BgL_ifreesz00_16564);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33906ze3z87_16639,
																(int) (((long) 1)), BgL_iboxesz00_16565);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33906ze3z87_16639,
																(int) (((long) 2)), BINT(BgL_siza7eza7_16566));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33906ze3z87_16639,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14348)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33906ze3z87_16639,
																(int) (((long) 4)), BgL_bodyz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33906ze3z87_16639,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_16567));
															return BgL_zc3z04anonymousza33906ze3z87_16639;
														}
												}
											break;
										default:
										BgL_case_else1248z00_16594:
											if ((VECTOR_LENGTH(BgL_ifreesz00_16564) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1167 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16565) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3z04anonymousza33924ze3z87_16595;

															BgL_zc3z04anonymousza33924ze3z87_16595 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33924ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33924ze3z87_16595,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14348)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33924ze3z87_16595,
																(int) (((long) 1)), BgL_bodyz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33924ze3z87_16595,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_16567));
															return BgL_zc3z04anonymousza33924ze3z87_16595;
														}
													else
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3z04anonymousza33944ze3z87_16596;

															BgL_zc3z04anonymousza33944ze3z87_16596 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33944ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33944ze3z87_16596,
																(int) (((long) 0)), BgL_iboxesz00_16565);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33944ze3z87_16596,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14348)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33944ze3z87_16596,
																(int) (((long) 2)), BgL_bodyz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33944ze3z87_16596,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_16567));
															return BgL_zc3z04anonymousza33944ze3z87_16596;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1167 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16565) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3z04anonymousza33967ze3z87_16597;

															BgL_zc3z04anonymousza33967ze3z87_16597 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33967ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33967ze3z87_16597,
																(int) (((long) 0)), BgL_ifreesz00_16564);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33967ze3z87_16597,
																(int) (((long) 1)), BINT(BgL_siza7eza7_16566));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33967ze3z87_16597,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14348)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33967ze3z87_16597,
																(int) (((long) 3)), BgL_bodyz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33967ze3z87_16597,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_16567));
															return BgL_zc3z04anonymousza33967ze3z87_16597;
														}
													else
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3z04anonymousza33988ze3z87_16598;

															BgL_zc3z04anonymousza33988ze3z87_16598 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33988ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33988ze3z87_16598,
																(int) (((long) 0)), BgL_ifreesz00_16564);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33988ze3z87_16598,
																(int) (((long) 1)), BgL_iboxesz00_16565);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33988ze3z87_16598,
																(int) (((long) 2)), BINT(BgL_siza7eza7_16566));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33988ze3z87_16598,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14348)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33988ze3z87_16598,
																(int) (((long) 4)), BgL_bodyz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33988ze3z87_16598,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_16567));
															return BgL_zc3z04anonymousza33988ze3z87_16598;
														}
												}
										}
								}
							else
								{	/* Eval/evaluate_comp.scm 1167 */
									goto BgL_case_else1248z00_16594;
								}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3869> */
	obj_t BGl_z62zc3z04anonymousza33869ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14350, obj_t BgL_sz00_14354)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1247z00_14351;
				obj_t BgL_bodyz00_14352;
				long BgL_siza7ezd2framez75_14353;

				BgL_i1247z00_14351 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14350, (int) (((long) 0))));
				BgL_bodyz00_14352 = PROCEDURE_REF(BgL_envz00_14350, (int) (((long) 1)));
				BgL_siza7ezd2framez75_14353 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14350, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_16640;

					BgL_bpz00_16640 = VECTOR_REF(((obj_t) BgL_sz00_14354), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */

						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_16641;

							BgL_runz00_16641 =
								MAKE_FX_PROCEDURE(BGl_z62runz62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_16641,
								(int) (((long) 0)), ((obj_t) BgL_i1247z00_14351));
							PROCEDURE_SET(BgL_runz00_16641,
								(int) (((long) 1)), BgL_bodyz00_14352);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_16642;

								BgL_mainz00_16642 =
									MAKE_VA_PROCEDURE(BGl_z62mainz62zz__evaluate_compz00,
									(int) (((long) -5)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_16642,
									(int) (((long) 0)), ((obj_t) BgL_i1247z00_14351));
								PROCEDURE_SET(BgL_mainz00_16642,
									(int) (((long) 1)), BgL_bodyz00_14352);
								PROCEDURE_SET(BgL_mainz00_16642,
									(int) (((long) 2)), BgL_runz00_16641);
								PROCEDURE_SET(BgL_mainz00_16642,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_14353));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_16643;

									BgL_objz00_16643 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16641, BgL_objz00_16643);
									BgL_objz00_16643;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3870z00_16644;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3871z00_16645;

										BgL_arg3871z00_16645 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14351))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_16646;

											BgL_newz00_16646 =
												create_struct(BGl_symbol5815z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_26348;

												BgL_tmpz00_26348 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16646, BgL_tmpz00_26348,
													BgL_arg3871z00_16645);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_26353;
												int BgL_tmpz00_26351;

												BgL_auxz00_26353 = BINT(BgL_siza7ezd2framez75_14353);
												BgL_tmpz00_26351 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16646, BgL_tmpz00_26351,
													BgL_auxz00_26353);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_26356;

												BgL_tmpz00_26356 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16646, BgL_tmpz00_26356,
													BgL_runz00_16641);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_26361;
												int BgL_tmpz00_26359;

												BgL_auxz00_26361 = BINT(((long) -5));
												BgL_tmpz00_26359 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16646, BgL_tmpz00_26359,
													BgL_auxz00_26361);
											}
											BgL_arg3870z00_16644 = BgL_newz00_16646;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16642, BgL_arg3870z00_16644);
									BgL_arg3870z00_16644;
								}
								return BgL_mainz00_16642;
							}
						}
					}
				}
			}
		}

	}



/* &main */
	obj_t BGl_z62mainz62zz__evaluate_compz00(obj_t BgL_envz00_14355,
		obj_t BgL_az00_14360, obj_t BgL_bz00_14361, obj_t BgL_cz00_14362,
		obj_t BgL_dz00_14363, obj_t BgL_lastz00_14364)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14358;
				long BgL_siza7ezd2framez75_14359;

				BgL_runz00_14358 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14355, (int) (((long) 2))));
				BgL_siza7ezd2framez75_14359 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14355, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_16647;

					BgL_sz00_16647 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_16648;

						BgL_bpz00_16648 = VECTOR_REF(((obj_t) BgL_sz00_16647), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16648) + BgL_siza7ezd2framez75_14359) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16647))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3874z00_16649;

									BgL_arg3874z00_16649 =
										((long) CINT(BgL_bpz00_16648) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16647), BgL_arg3874z00_16649,
										BgL_az00_14360);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3875z00_16650;

									BgL_arg3875z00_16650 =
										((long) CINT(BgL_bpz00_16648) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16647), BgL_arg3875z00_16650,
										BgL_bz00_14361);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3876z00_16651;

									BgL_arg3876z00_16651 =
										((long) CINT(BgL_bpz00_16648) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_16647), BgL_arg3876z00_16651,
										BgL_cz00_14362);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3877z00_16652;

									BgL_arg3877z00_16652 =
										((long) CINT(BgL_bpz00_16648) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_16647), BgL_arg3877z00_16652,
										BgL_dz00_14363);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3878z00_16653;

									BgL_arg3878z00_16653 =
										((long) CINT(BgL_bpz00_16648) + ((long) 4));
									VECTOR_SET(
										((obj_t) BgL_sz00_16647), BgL_arg3878z00_16653,
										BgL_lastz00_14364);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_16654;

									BgL_ez00_16654 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16654,
										BgL_bpz00_16648);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_16655;

										BgL_accz00_16655 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14358, BgL_sz00_16647, BgL_bpz00_16648);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16654);
										VECTOR_SET(
											((obj_t) BgL_sz00_16647), ((long) 0), BgL_bpz00_16648);
										return BgL_accz00_16655;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_16656;

								BgL_nsz00_16656 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16656, ((long) 1), BgL_sz00_16647);
								VECTOR_SET(BgL_nsz00_16656, ((long) 2), BgL_az00_14360);
								VECTOR_SET(BgL_nsz00_16656, ((long) 3), BgL_bz00_14361);
								VECTOR_SET(BgL_nsz00_16656, ((long) 4), BgL_cz00_14362);
								VECTOR_SET(BgL_nsz00_16656, ((long) 5), BgL_dz00_14363);
								VECTOR_SET(BgL_nsz00_16656, ((long) 6), BgL_lastz00_14364);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_16657;

									BgL_z12denvz12_16657 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16657, BgL_nsz00_16656);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_16658;

										BgL_ez00_16658 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16658,
											BgL_sz00_16647);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_16659;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_16660;

												BgL_savedzd2bpzd2_16660 =
													VECTOR_REF(BgL_nsz00_16656, ((long) 0));
												VECTOR_SET(BgL_nsz00_16656, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16662;

													BgL_fz00_16662 = BgL_runz00_14358;
												BgL_recz00_16661:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_16663;

														BgL_rz00_16663 =
															PROCEDURE_ENTRY(BgL_fz00_16662) (BgL_fz00_16662,
															BgL_nsz00_16656, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_test6570z00_26424;

															if (PROCEDUREP(BgL_rz00_16663))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1707z00_16664;

																	BgL_arg1707z00_16664 =
																		PROCEDURE_ATTR(BgL_rz00_16663);
																	if (STRUCTP(BgL_arg1707z00_16664))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6570z00_26424 =
																				(STRUCT_KEY(BgL_arg1707z00_16664) ==
																				BGl_symbol5794z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6570z00_26424 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_test6570z00_26424 = ((bool_t) 0);
																}
															if (BgL_test6570z00_26424)
																{
																	obj_t BgL_fz00_26432;

																	BgL_fz00_26432 = BgL_rz00_16663;
																	BgL_fz00_16662 = BgL_fz00_26432;
																	goto BgL_recz00_16661;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_16656, ((long) 0),
																		BgL_savedzd2bpzd2_16660);
																	BgL_____rz00_16659 = BgL_rz00_16663;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16658);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16657, BgL_sz00_16647);
											return BgL_____rz00_16659;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run */
	obj_t BGl_z62runz62zz__evaluate_compz00(obj_t BgL_envz00_14365,
		obj_t BgL_sz00_14368)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1247z00_14366;
				obj_t BgL_bodyz00_14367;

				BgL_i1247z00_14366 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14365, (int) (((long) 0))));
				BgL_bodyz00_14367 = PROCEDURE_REF(BgL_envz00_14365, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_16665;

					BgL_bpz00_16665 = VECTOR_REF(((obj_t) BgL_sz00_14368), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_z12denvz12_16666;
						obj_t BgL_wherez00_16667;
						obj_t BgL_locz00_16668;

						BgL_z12denvz12_16666 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16667 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14366))->
							BgL_wherez00);
						BgL_locz00_16668 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14366))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1167 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16666, BgL_wherez00_16667,
								BgL_locz00_16668);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_za2za2resza2za2z00_16669;

								BgL_za2za2resza2za2z00_16669 =
									PROCEDURE_ENTRY(BgL_bodyz00_14367) (BgL_bodyz00_14367,
									BgL_sz00_14368, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16666);
								return BgL_za2za2resza2za2z00_16669;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3880> */
	obj_t BGl_z62zc3z04anonymousza33880ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14369, obj_t BgL_sz00_14374)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_14370;
				BgL_ev_absz00_bglt BgL_i1247z00_14371;
				obj_t BgL_bodyz00_14372;
				long BgL_siza7ezd2framez75_14373;

				BgL_iboxesz00_14370 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14369, (int) (((long) 0))));
				BgL_i1247z00_14371 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14369, (int) (((long) 1))));
				BgL_bodyz00_14372 = PROCEDURE_REF(BgL_envz00_14369, (int) (((long) 2)));
				BgL_siza7ezd2framez75_14373 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14369, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_16670;

					BgL_bpz00_16670 = VECTOR_REF(((obj_t) BgL_sz00_14374), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */

						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_16671;

							BgL_runz00_16671 =
								MAKE_FX_PROCEDURE(BGl_z62run5701z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_16671,
								(int) (((long) 0)), BgL_iboxesz00_14370);
							PROCEDURE_SET(BgL_runz00_16671,
								(int) (((long) 1)), ((obj_t) BgL_i1247z00_14371));
							PROCEDURE_SET(BgL_runz00_16671,
								(int) (((long) 2)), BgL_bodyz00_14372);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_16672;

								BgL_mainz00_16672 =
									MAKE_VA_PROCEDURE(BGl_z62main5700z62zz__evaluate_compz00,
									(int) (((long) -5)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_16672,
									(int) (((long) 0)), BgL_iboxesz00_14370);
								PROCEDURE_SET(BgL_mainz00_16672,
									(int) (((long) 1)), ((obj_t) BgL_i1247z00_14371));
								PROCEDURE_SET(BgL_mainz00_16672,
									(int) (((long) 2)), BgL_bodyz00_14372);
								PROCEDURE_SET(BgL_mainz00_16672,
									(int) (((long) 3)), BgL_runz00_16671);
								PROCEDURE_SET(BgL_mainz00_16672,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_14373));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_16673;

									BgL_objz00_16673 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16671, BgL_objz00_16673);
									BgL_objz00_16673;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3881z00_16674;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3882z00_16675;

										BgL_arg3882z00_16675 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14371))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_16676;

											BgL_newz00_16676 =
												create_struct(BGl_symbol5815z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_26494;

												BgL_tmpz00_26494 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16676, BgL_tmpz00_26494,
													BgL_arg3882z00_16675);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_26499;
												int BgL_tmpz00_26497;

												BgL_auxz00_26499 = BINT(BgL_siza7ezd2framez75_14373);
												BgL_tmpz00_26497 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16676, BgL_tmpz00_26497,
													BgL_auxz00_26499);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_26502;

												BgL_tmpz00_26502 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16676, BgL_tmpz00_26502,
													BgL_runz00_16671);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_26507;
												int BgL_tmpz00_26505;

												BgL_auxz00_26507 = BINT(((long) -5));
												BgL_tmpz00_26505 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16676, BgL_tmpz00_26505,
													BgL_auxz00_26507);
											}
											BgL_arg3881z00_16674 = BgL_newz00_16676;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16672, BgL_arg3881z00_16674);
									BgL_arg3881z00_16674;
								}
								return BgL_mainz00_16672;
							}
						}
					}
				}
			}
		}

	}



/* &main5700 */
	obj_t BGl_z62main5700z62zz__evaluate_compz00(obj_t BgL_envz00_14375,
		obj_t BgL_az00_14381, obj_t BgL_bz00_14382, obj_t BgL_cz00_14383,
		obj_t BgL_dz00_14384, obj_t BgL_lastz00_14385)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14379;
				long BgL_siza7ezd2framez75_14380;

				BgL_runz00_14379 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14375, (int) (((long) 3))));
				BgL_siza7ezd2framez75_14380 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14375, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_16677;

					BgL_sz00_16677 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_16678;

						BgL_bpz00_16678 = VECTOR_REF(((obj_t) BgL_sz00_16677), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16678) + BgL_siza7ezd2framez75_14380) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16677))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3885z00_16679;

									BgL_arg3885z00_16679 =
										((long) CINT(BgL_bpz00_16678) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16677), BgL_arg3885z00_16679,
										BgL_az00_14381);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3886z00_16680;

									BgL_arg3886z00_16680 =
										((long) CINT(BgL_bpz00_16678) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16677), BgL_arg3886z00_16680,
										BgL_bz00_14382);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3887z00_16681;

									BgL_arg3887z00_16681 =
										((long) CINT(BgL_bpz00_16678) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_16677), BgL_arg3887z00_16681,
										BgL_cz00_14383);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3888z00_16682;

									BgL_arg3888z00_16682 =
										((long) CINT(BgL_bpz00_16678) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_16677), BgL_arg3888z00_16682,
										BgL_dz00_14384);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3889z00_16683;

									BgL_arg3889z00_16683 =
										((long) CINT(BgL_bpz00_16678) + ((long) 4));
									VECTOR_SET(
										((obj_t) BgL_sz00_16677), BgL_arg3889z00_16683,
										BgL_lastz00_14385);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_16684;

									BgL_ez00_16684 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16684,
										BgL_bpz00_16678);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_16685;

										BgL_accz00_16685 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14379, BgL_sz00_16677, BgL_bpz00_16678);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16684);
										VECTOR_SET(
											((obj_t) BgL_sz00_16677), ((long) 0), BgL_bpz00_16678);
										return BgL_accz00_16685;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_16686;

								BgL_nsz00_16686 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16686, ((long) 1), BgL_sz00_16677);
								VECTOR_SET(BgL_nsz00_16686, ((long) 2), BgL_az00_14381);
								VECTOR_SET(BgL_nsz00_16686, ((long) 3), BgL_bz00_14382);
								VECTOR_SET(BgL_nsz00_16686, ((long) 4), BgL_cz00_14383);
								VECTOR_SET(BgL_nsz00_16686, ((long) 5), BgL_dz00_14384);
								VECTOR_SET(BgL_nsz00_16686, ((long) 6), BgL_lastz00_14385);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_16687;

									BgL_z12denvz12_16687 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16687, BgL_nsz00_16686);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_16688;

										BgL_ez00_16688 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16688,
											BgL_sz00_16677);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_16689;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_16690;

												BgL_savedzd2bpzd2_16690 =
													VECTOR_REF(BgL_nsz00_16686, ((long) 0));
												VECTOR_SET(BgL_nsz00_16686, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16692;

													BgL_fz00_16692 = BgL_runz00_14379;
												BgL_recz00_16691:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_16693;

														BgL_rz00_16693 =
															PROCEDURE_ENTRY(BgL_fz00_16692) (BgL_fz00_16692,
															BgL_nsz00_16686, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_test6574z00_26570;

															if (PROCEDUREP(BgL_rz00_16693))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1707z00_16694;

																	BgL_arg1707z00_16694 =
																		PROCEDURE_ATTR(BgL_rz00_16693);
																	if (STRUCTP(BgL_arg1707z00_16694))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6574z00_26570 =
																				(STRUCT_KEY(BgL_arg1707z00_16694) ==
																				BGl_symbol5794z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6574z00_26570 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_test6574z00_26570 = ((bool_t) 0);
																}
															if (BgL_test6574z00_26570)
																{
																	obj_t BgL_fz00_26578;

																	BgL_fz00_26578 = BgL_rz00_16693;
																	BgL_fz00_16692 = BgL_fz00_26578;
																	goto BgL_recz00_16691;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_16686, ((long) 0),
																		BgL_savedzd2bpzd2_16690);
																	BgL_____rz00_16689 = BgL_rz00_16693;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16688);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16687, BgL_sz00_16677);
											return BgL_____rz00_16689;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5701 */
	obj_t BGl_z62run5701z62zz__evaluate_compz00(obj_t BgL_envz00_14386,
		obj_t BgL_sz00_14390)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_14387;
				BgL_ev_absz00_bglt BgL_i1247z00_14388;
				obj_t BgL_bodyz00_14389;

				BgL_iboxesz00_14387 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14386, (int) (((long) 0))));
				BgL_i1247z00_14388 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14386, (int) (((long) 1))));
				BgL_bodyz00_14389 = PROCEDURE_REF(BgL_envz00_14386, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_16695;

					BgL_bpz00_16695 = VECTOR_REF(((obj_t) BgL_sz00_14390), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14390,
						BgL_iboxesz00_14387, BgL_bpz00_16695);
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_z12denvz12_16696;
						obj_t BgL_wherez00_16697;
						obj_t BgL_locz00_16698;

						BgL_z12denvz12_16696 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16697 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14388))->
							BgL_wherez00);
						BgL_locz00_16698 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14388))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1167 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16696, BgL_wherez00_16697,
								BgL_locz00_16698);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_za2za2resza2za2z00_16699;

								BgL_za2za2resza2za2z00_16699 =
									PROCEDURE_ENTRY(BgL_bodyz00_14389) (BgL_bodyz00_14389,
									BgL_sz00_14390, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16696);
								return BgL_za2za2resza2za2z00_16699;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3894> */
	obj_t BGl_z62zc3z04anonymousza33894ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14391, obj_t BgL_sz00_14397)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_ifreesz00_14392;
				long BgL_siza7eza7_14393;
				BgL_ev_absz00_bglt BgL_i1247z00_14394;
				obj_t BgL_bodyz00_14395;
				long BgL_siza7ezd2framez75_14396;

				BgL_ifreesz00_14392 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14391, (int) (((long) 0))));
				BgL_siza7eza7_14393 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14391, (int) (((long) 1))));
				BgL_i1247z00_14394 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14391, (int) (((long) 2))));
				BgL_bodyz00_14395 = PROCEDURE_REF(BgL_envz00_14391, (int) (((long) 3)));
				BgL_siza7ezd2framez75_14396 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14391, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_16700;

					BgL_bpz00_16700 = VECTOR_REF(((obj_t) BgL_sz00_14397), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_valza2za2_16701;

						BgL_valza2za2_16701 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14397,
							BgL_bpz00_16700, BgL_ifreesz00_14392);
						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_16702;

							BgL_runz00_16702 =
								MAKE_FX_PROCEDURE(BGl_z62run5703z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_16702,
								(int) (((long) 0)), BINT(BgL_siza7eza7_14393));
							PROCEDURE_SET(BgL_runz00_16702,
								(int) (((long) 1)), BgL_valza2za2_16701);
							PROCEDURE_SET(BgL_runz00_16702,
								(int) (((long) 2)), ((obj_t) BgL_i1247z00_14394));
							PROCEDURE_SET(BgL_runz00_16702,
								(int) (((long) 3)), BgL_bodyz00_14395);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_16703;

								BgL_mainz00_16703 =
									MAKE_VA_PROCEDURE(BGl_z62main5702z62zz__evaluate_compz00,
									(int) (((long) -5)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_16703,
									(int) (((long) 0)), BINT(BgL_siza7eza7_14393));
								PROCEDURE_SET(BgL_mainz00_16703,
									(int) (((long) 1)), BgL_valza2za2_16701);
								PROCEDURE_SET(BgL_mainz00_16703,
									(int) (((long) 2)), ((obj_t) BgL_i1247z00_14394));
								PROCEDURE_SET(BgL_mainz00_16703,
									(int) (((long) 3)), BgL_bodyz00_14395);
								PROCEDURE_SET(BgL_mainz00_16703,
									(int) (((long) 4)), BgL_runz00_16702);
								PROCEDURE_SET(BgL_mainz00_16703,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_14396));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_16704;

									BgL_objz00_16704 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16702, BgL_objz00_16704);
									BgL_objz00_16704;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3895z00_16705;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3896z00_16706;

										BgL_arg3896z00_16706 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14394))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_16707;

											BgL_newz00_16707 =
												create_struct(BGl_symbol5815z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_26654;

												BgL_tmpz00_26654 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16707, BgL_tmpz00_26654,
													BgL_arg3896z00_16706);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_26659;
												int BgL_tmpz00_26657;

												BgL_auxz00_26659 = BINT(BgL_siza7ezd2framez75_14396);
												BgL_tmpz00_26657 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16707, BgL_tmpz00_26657,
													BgL_auxz00_26659);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_26662;

												BgL_tmpz00_26662 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16707, BgL_tmpz00_26662,
													BgL_runz00_16702);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_26667;
												int BgL_tmpz00_26665;

												BgL_auxz00_26667 = BINT(((long) -5));
												BgL_tmpz00_26665 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16707, BgL_tmpz00_26665,
													BgL_auxz00_26667);
											}
											BgL_arg3895z00_16705 = BgL_newz00_16707;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16703, BgL_arg3895z00_16705);
									BgL_arg3895z00_16705;
								}
								return BgL_mainz00_16703;
							}
						}
					}
				}
			}
		}

	}



/* &main5702 */
	obj_t BGl_z62main5702z62zz__evaluate_compz00(obj_t BgL_envz00_14398,
		obj_t BgL_az00_14405, obj_t BgL_bz00_14406, obj_t BgL_cz00_14407,
		obj_t BgL_dz00_14408, obj_t BgL_lastz00_14409)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14403;
				long BgL_siza7ezd2framez75_14404;

				BgL_runz00_14403 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14398, (int) (((long) 4))));
				BgL_siza7ezd2framez75_14404 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14398, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_16708;

					BgL_sz00_16708 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_16709;

						BgL_bpz00_16709 = VECTOR_REF(((obj_t) BgL_sz00_16708), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16709) + BgL_siza7ezd2framez75_14404) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16708))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3899z00_16710;

									BgL_arg3899z00_16710 =
										((long) CINT(BgL_bpz00_16709) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16708), BgL_arg3899z00_16710,
										BgL_az00_14405);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3900z00_16711;

									BgL_arg3900z00_16711 =
										((long) CINT(BgL_bpz00_16709) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16708), BgL_arg3900z00_16711,
										BgL_bz00_14406);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3901z00_16712;

									BgL_arg3901z00_16712 =
										((long) CINT(BgL_bpz00_16709) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_16708), BgL_arg3901z00_16712,
										BgL_cz00_14407);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3902z00_16713;

									BgL_arg3902z00_16713 =
										((long) CINT(BgL_bpz00_16709) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_16708), BgL_arg3902z00_16713,
										BgL_dz00_14408);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3903z00_16714;

									BgL_arg3903z00_16714 =
										((long) CINT(BgL_bpz00_16709) + ((long) 4));
									VECTOR_SET(
										((obj_t) BgL_sz00_16708), BgL_arg3903z00_16714,
										BgL_lastz00_14409);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_16715;

									BgL_ez00_16715 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16715,
										BgL_bpz00_16709);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_16716;

										BgL_accz00_16716 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14403, BgL_sz00_16708, BgL_bpz00_16709);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16715);
										VECTOR_SET(
											((obj_t) BgL_sz00_16708), ((long) 0), BgL_bpz00_16709);
										return BgL_accz00_16716;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_16717;

								BgL_nsz00_16717 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16717, ((long) 1), BgL_sz00_16708);
								VECTOR_SET(BgL_nsz00_16717, ((long) 2), BgL_az00_14405);
								VECTOR_SET(BgL_nsz00_16717, ((long) 3), BgL_bz00_14406);
								VECTOR_SET(BgL_nsz00_16717, ((long) 4), BgL_cz00_14407);
								VECTOR_SET(BgL_nsz00_16717, ((long) 5), BgL_dz00_14408);
								VECTOR_SET(BgL_nsz00_16717, ((long) 6), BgL_lastz00_14409);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_16718;

									BgL_z12denvz12_16718 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16718, BgL_nsz00_16717);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_16719;

										BgL_ez00_16719 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16719,
											BgL_sz00_16708);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_16720;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_16721;

												BgL_savedzd2bpzd2_16721 =
													VECTOR_REF(BgL_nsz00_16717, ((long) 0));
												VECTOR_SET(BgL_nsz00_16717, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16723;

													BgL_fz00_16723 = BgL_runz00_14403;
												BgL_recz00_16722:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_16724;

														BgL_rz00_16724 =
															PROCEDURE_ENTRY(BgL_fz00_16723) (BgL_fz00_16723,
															BgL_nsz00_16717, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_test6578z00_26730;

															if (PROCEDUREP(BgL_rz00_16724))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1707z00_16725;

																	BgL_arg1707z00_16725 =
																		PROCEDURE_ATTR(BgL_rz00_16724);
																	if (STRUCTP(BgL_arg1707z00_16725))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6578z00_26730 =
																				(STRUCT_KEY(BgL_arg1707z00_16725) ==
																				BGl_symbol5794z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6578z00_26730 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_test6578z00_26730 = ((bool_t) 0);
																}
															if (BgL_test6578z00_26730)
																{
																	obj_t BgL_fz00_26738;

																	BgL_fz00_26738 = BgL_rz00_16724;
																	BgL_fz00_16723 = BgL_fz00_26738;
																	goto BgL_recz00_16722;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_16717, ((long) 0),
																		BgL_savedzd2bpzd2_16721);
																	BgL_____rz00_16720 = BgL_rz00_16724;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16719);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16718, BgL_sz00_16708);
											return BgL_____rz00_16720;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5703 */
	obj_t BGl_z62run5703z62zz__evaluate_compz00(obj_t BgL_envz00_14410,
		obj_t BgL_sz00_14415)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				long BgL_siza7eza7_14411;
				obj_t BgL_valza2za2_14412;
				BgL_ev_absz00_bglt BgL_i1247z00_14413;
				obj_t BgL_bodyz00_14414;

				BgL_siza7eza7_14411 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14410, (int) (((long) 0))));
				BgL_valza2za2_14412 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14410, (int) (((long) 1))));
				BgL_i1247z00_14413 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14410, (int) (((long) 2))));
				BgL_bodyz00_14414 = PROCEDURE_REF(BgL_envz00_14410, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_16726;

					BgL_bpz00_16726 = VECTOR_REF(((obj_t) BgL_sz00_14415), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14415,
						BgL_valza2za2_14412,
						((long) CINT(BgL_bpz00_16726) + BgL_siza7eza7_14411));
					{	/* Eval/evaluate_comp.scm 1088 */
						obj_t BgL_z12denvz12_16727;
						obj_t BgL_wherez00_16728;
						obj_t BgL_locz00_16729;

						BgL_z12denvz12_16727 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16728 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14413))->
							BgL_wherez00);
						BgL_locz00_16729 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14413))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1088 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16727, BgL_wherez00_16728,
								BgL_locz00_16729);
							{	/* Eval/evaluate_comp.scm 1088 */
								obj_t BgL_za2za2resza2za2z00_16730;

								BgL_za2za2resza2za2z00_16730 =
									PROCEDURE_ENTRY(BgL_bodyz00_14414) (BgL_bodyz00_14414,
									BgL_sz00_14415, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16727);
								return BgL_za2za2resza2za2z00_16730;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3906> */
	obj_t BGl_z62zc3z04anonymousza33906ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14416, obj_t BgL_sz00_14423)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_ifreesz00_14417;
				obj_t BgL_iboxesz00_14418;
				long BgL_siza7eza7_14419;
				BgL_ev_absz00_bglt BgL_i1247z00_14420;
				obj_t BgL_bodyz00_14421;
				long BgL_siza7ezd2framez75_14422;

				BgL_ifreesz00_14417 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14416, (int) (((long) 0))));
				BgL_iboxesz00_14418 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14416, (int) (((long) 1))));
				BgL_siza7eza7_14419 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14416, (int) (((long) 2))));
				BgL_i1247z00_14420 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14416, (int) (((long) 3))));
				BgL_bodyz00_14421 = PROCEDURE_REF(BgL_envz00_14416, (int) (((long) 4)));
				BgL_siza7ezd2framez75_14422 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14416, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_16731;

					BgL_bpz00_16731 = VECTOR_REF(((obj_t) BgL_sz00_14423), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_valza2za2_16732;

						BgL_valza2za2_16732 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14423,
							BgL_bpz00_16731, BgL_ifreesz00_14417);
						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_16733;

							BgL_runz00_16733 =
								MAKE_FX_PROCEDURE(BGl_z62run5705z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_16733,
								(int) (((long) 0)), BgL_iboxesz00_14418);
							PROCEDURE_SET(BgL_runz00_16733,
								(int) (((long) 1)), BINT(BgL_siza7eza7_14419));
							PROCEDURE_SET(BgL_runz00_16733,
								(int) (((long) 2)), BgL_valza2za2_16732);
							PROCEDURE_SET(BgL_runz00_16733,
								(int) (((long) 3)), ((obj_t) BgL_i1247z00_14420));
							PROCEDURE_SET(BgL_runz00_16733,
								(int) (((long) 4)), BgL_bodyz00_14421);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_16734;

								BgL_mainz00_16734 =
									MAKE_VA_PROCEDURE(BGl_z62main5704z62zz__evaluate_compz00,
									(int) (((long) -5)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_16734,
									(int) (((long) 0)), BgL_iboxesz00_14418);
								PROCEDURE_SET(BgL_mainz00_16734,
									(int) (((long) 1)), BINT(BgL_siza7eza7_14419));
								PROCEDURE_SET(BgL_mainz00_16734,
									(int) (((long) 2)), BgL_valza2za2_16732);
								PROCEDURE_SET(BgL_mainz00_16734,
									(int) (((long) 3)), ((obj_t) BgL_i1247z00_14420));
								PROCEDURE_SET(BgL_mainz00_16734,
									(int) (((long) 4)), BgL_bodyz00_14421);
								PROCEDURE_SET(BgL_mainz00_16734,
									(int) (((long) 5)), BgL_runz00_16733);
								PROCEDURE_SET(BgL_mainz00_16734,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_14422));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_16735;

									BgL_objz00_16735 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16733, BgL_objz00_16735);
									BgL_objz00_16735;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3907z00_16736;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3908z00_16737;

										BgL_arg3908z00_16737 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14420))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_16738;

											BgL_newz00_16738 =
												create_struct(BGl_symbol5815z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_26826;

												BgL_tmpz00_26826 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16738, BgL_tmpz00_26826,
													BgL_arg3908z00_16737);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_26831;
												int BgL_tmpz00_26829;

												BgL_auxz00_26831 = BINT(BgL_siza7ezd2framez75_14422);
												BgL_tmpz00_26829 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16738, BgL_tmpz00_26829,
													BgL_auxz00_26831);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_26834;

												BgL_tmpz00_26834 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16738, BgL_tmpz00_26834,
													BgL_runz00_16733);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_26839;
												int BgL_tmpz00_26837;

												BgL_auxz00_26839 = BINT(((long) -5));
												BgL_tmpz00_26837 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16738, BgL_tmpz00_26837,
													BgL_auxz00_26839);
											}
											BgL_arg3907z00_16736 = BgL_newz00_16738;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16734, BgL_arg3907z00_16736);
									BgL_arg3907z00_16736;
								}
								return BgL_mainz00_16734;
							}
						}
					}
				}
			}
		}

	}



/* &main5704 */
	obj_t BGl_z62main5704z62zz__evaluate_compz00(obj_t BgL_envz00_14424,
		obj_t BgL_az00_14432, obj_t BgL_bz00_14433, obj_t BgL_cz00_14434,
		obj_t BgL_dz00_14435, obj_t BgL_lastz00_14436)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14430;
				long BgL_siza7ezd2framez75_14431;

				BgL_runz00_14430 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14424, (int) (((long) 5))));
				BgL_siza7ezd2framez75_14431 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14424, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_16739;

					BgL_sz00_16739 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_16740;

						BgL_bpz00_16740 = VECTOR_REF(((obj_t) BgL_sz00_16739), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16740) + BgL_siza7ezd2framez75_14431) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16739))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3911z00_16741;

									BgL_arg3911z00_16741 =
										((long) CINT(BgL_bpz00_16740) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16739), BgL_arg3911z00_16741,
										BgL_az00_14432);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3912z00_16742;

									BgL_arg3912z00_16742 =
										((long) CINT(BgL_bpz00_16740) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16739), BgL_arg3912z00_16742,
										BgL_bz00_14433);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3913z00_16743;

									BgL_arg3913z00_16743 =
										((long) CINT(BgL_bpz00_16740) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_16739), BgL_arg3913z00_16743,
										BgL_cz00_14434);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3914z00_16744;

									BgL_arg3914z00_16744 =
										((long) CINT(BgL_bpz00_16740) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_16739), BgL_arg3914z00_16744,
										BgL_dz00_14435);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3915z00_16745;

									BgL_arg3915z00_16745 =
										((long) CINT(BgL_bpz00_16740) + ((long) 4));
									VECTOR_SET(
										((obj_t) BgL_sz00_16739), BgL_arg3915z00_16745,
										BgL_lastz00_14436);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_16746;

									BgL_ez00_16746 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16746,
										BgL_bpz00_16740);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_16747;

										BgL_accz00_16747 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14430, BgL_sz00_16739, BgL_bpz00_16740);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16746);
										VECTOR_SET(
											((obj_t) BgL_sz00_16739), ((long) 0), BgL_bpz00_16740);
										return BgL_accz00_16747;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_16748;

								BgL_nsz00_16748 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16748, ((long) 1), BgL_sz00_16739);
								VECTOR_SET(BgL_nsz00_16748, ((long) 2), BgL_az00_14432);
								VECTOR_SET(BgL_nsz00_16748, ((long) 3), BgL_bz00_14433);
								VECTOR_SET(BgL_nsz00_16748, ((long) 4), BgL_cz00_14434);
								VECTOR_SET(BgL_nsz00_16748, ((long) 5), BgL_dz00_14435);
								VECTOR_SET(BgL_nsz00_16748, ((long) 6), BgL_lastz00_14436);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_16749;

									BgL_z12denvz12_16749 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16749, BgL_nsz00_16748);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_16750;

										BgL_ez00_16750 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16750,
											BgL_sz00_16739);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_16751;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_16752;

												BgL_savedzd2bpzd2_16752 =
													VECTOR_REF(BgL_nsz00_16748, ((long) 0));
												VECTOR_SET(BgL_nsz00_16748, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16754;

													BgL_fz00_16754 = BgL_runz00_14430;
												BgL_recz00_16753:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_16755;

														BgL_rz00_16755 =
															PROCEDURE_ENTRY(BgL_fz00_16754) (BgL_fz00_16754,
															BgL_nsz00_16748, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_test6582z00_26902;

															if (PROCEDUREP(BgL_rz00_16755))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1707z00_16756;

																	BgL_arg1707z00_16756 =
																		PROCEDURE_ATTR(BgL_rz00_16755);
																	if (STRUCTP(BgL_arg1707z00_16756))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6582z00_26902 =
																				(STRUCT_KEY(BgL_arg1707z00_16756) ==
																				BGl_symbol5794z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6582z00_26902 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_test6582z00_26902 = ((bool_t) 0);
																}
															if (BgL_test6582z00_26902)
																{
																	obj_t BgL_fz00_26910;

																	BgL_fz00_26910 = BgL_rz00_16755;
																	BgL_fz00_16754 = BgL_fz00_26910;
																	goto BgL_recz00_16753;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_16748, ((long) 0),
																		BgL_savedzd2bpzd2_16752);
																	BgL_____rz00_16751 = BgL_rz00_16755;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16750);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16749, BgL_sz00_16739);
											return BgL_____rz00_16751;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5705 */
	obj_t BGl_z62run5705z62zz__evaluate_compz00(obj_t BgL_envz00_14437,
		obj_t BgL_sz00_14443)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_14438;
				long BgL_siza7eza7_14439;
				obj_t BgL_valza2za2_14440;
				BgL_ev_absz00_bglt BgL_i1247z00_14441;
				obj_t BgL_bodyz00_14442;

				BgL_iboxesz00_14438 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14437, (int) (((long) 0))));
				BgL_siza7eza7_14439 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14437, (int) (((long) 1))));
				BgL_valza2za2_14440 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14437, (int) (((long) 2))));
				BgL_i1247z00_14441 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14437, (int) (((long) 3))));
				BgL_bodyz00_14442 = PROCEDURE_REF(BgL_envz00_14437, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_16757;

					BgL_bpz00_16757 = VECTOR_REF(((obj_t) BgL_sz00_14443), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14443,
						BgL_iboxesz00_14438, BgL_bpz00_16757);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14443,
						BgL_valza2za2_14440,
						((long) CINT(BgL_bpz00_16757) + BgL_siza7eza7_14439));
					{	/* Eval/evaluate_comp.scm 1088 */
						obj_t BgL_z12denvz12_16758;
						obj_t BgL_wherez00_16759;
						obj_t BgL_locz00_16760;

						BgL_z12denvz12_16758 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16759 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14441))->
							BgL_wherez00);
						BgL_locz00_16760 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14441))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1088 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16758, BgL_wherez00_16759,
								BgL_locz00_16760);
							{	/* Eval/evaluate_comp.scm 1088 */
								obj_t BgL_za2za2resza2za2z00_16761;

								BgL_za2za2resza2za2z00_16761 =
									PROCEDURE_ENTRY(BgL_bodyz00_14442) (BgL_bodyz00_14442,
									BgL_sz00_14443, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16758);
								return BgL_za2za2resza2za2z00_16761;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3818> */
	obj_t BGl_z62zc3z04anonymousza33818ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14444, obj_t BgL_sz00_14448)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1247z00_14445;
				obj_t BgL_bodyz00_14446;
				long BgL_siza7ezd2framez75_14447;

				BgL_i1247z00_14445 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14444, (int) (((long) 0))));
				BgL_bodyz00_14446 = PROCEDURE_REF(BgL_envz00_14444, (int) (((long) 1)));
				BgL_siza7ezd2framez75_14447 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14444, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_16762;

					BgL_bpz00_16762 = VECTOR_REF(((obj_t) BgL_sz00_14448), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */

						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_16763;

							BgL_runz00_16763 =
								MAKE_FX_PROCEDURE(BGl_z62run5707z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_16763,
								(int) (((long) 0)), ((obj_t) BgL_i1247z00_14445));
							PROCEDURE_SET(BgL_runz00_16763,
								(int) (((long) 1)), BgL_bodyz00_14446);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_16764;

								BgL_mainz00_16764 =
									MAKE_FX_PROCEDURE(BGl_z62main5706z62zz__evaluate_compz00,
									(int) (((long) 4)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_16764,
									(int) (((long) 0)), ((obj_t) BgL_i1247z00_14445));
								PROCEDURE_SET(BgL_mainz00_16764,
									(int) (((long) 1)), BgL_bodyz00_14446);
								PROCEDURE_SET(BgL_mainz00_16764,
									(int) (((long) 2)), BgL_runz00_16763);
								PROCEDURE_SET(BgL_mainz00_16764,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_14447));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_16765;

									BgL_objz00_16765 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16763, BgL_objz00_16765);
									BgL_objz00_16765;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3819z00_16766;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3820z00_16767;

										BgL_arg3820z00_16767 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14445))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_16768;

											BgL_newz00_16768 =
												create_struct(BGl_symbol5815z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_26978;

												BgL_tmpz00_26978 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16768, BgL_tmpz00_26978,
													BgL_arg3820z00_16767);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_26983;
												int BgL_tmpz00_26981;

												BgL_auxz00_26983 = BINT(BgL_siza7ezd2framez75_14447);
												BgL_tmpz00_26981 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16768, BgL_tmpz00_26981,
													BgL_auxz00_26983);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_26986;

												BgL_tmpz00_26986 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16768, BgL_tmpz00_26986,
													BgL_runz00_16763);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_26991;
												int BgL_tmpz00_26989;

												BgL_auxz00_26991 = BINT(((long) 4));
												BgL_tmpz00_26989 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16768, BgL_tmpz00_26989,
													BgL_auxz00_26991);
											}
											BgL_arg3819z00_16766 = BgL_newz00_16768;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16764, BgL_arg3819z00_16766);
									BgL_arg3819z00_16766;
								}
								return BgL_mainz00_16764;
							}
						}
					}
				}
			}
		}

	}



/* &main5706 */
	obj_t BGl_z62main5706z62zz__evaluate_compz00(obj_t BgL_envz00_14449,
		obj_t BgL_az00_14454, obj_t BgL_bz00_14455, obj_t BgL_cz00_14456,
		obj_t BgL_dz00_14457)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14452;
				long BgL_siza7ezd2framez75_14453;

				BgL_runz00_14452 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14449, (int) (((long) 2))));
				BgL_siza7ezd2framez75_14453 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14449, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_16769;

					BgL_sz00_16769 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_16770;

						BgL_bpz00_16770 = VECTOR_REF(((obj_t) BgL_sz00_16769), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16770) + BgL_siza7ezd2framez75_14453) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16769))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3823z00_16771;

									BgL_arg3823z00_16771 =
										((long) CINT(BgL_bpz00_16770) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16769), BgL_arg3823z00_16771,
										BgL_az00_14454);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3824z00_16772;

									BgL_arg3824z00_16772 =
										((long) CINT(BgL_bpz00_16770) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16769), BgL_arg3824z00_16772,
										BgL_bz00_14455);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3825z00_16773;

									BgL_arg3825z00_16773 =
										((long) CINT(BgL_bpz00_16770) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_16769), BgL_arg3825z00_16773,
										BgL_cz00_14456);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3826z00_16774;

									BgL_arg3826z00_16774 =
										((long) CINT(BgL_bpz00_16770) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_16769), BgL_arg3826z00_16774,
										BgL_dz00_14457);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_16775;

									BgL_ez00_16775 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16775,
										BgL_bpz00_16770);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_16776;

										BgL_accz00_16776 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14452, BgL_sz00_16769, BgL_bpz00_16770);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16775);
										VECTOR_SET(
											((obj_t) BgL_sz00_16769), ((long) 0), BgL_bpz00_16770);
										return BgL_accz00_16776;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_16777;

								BgL_nsz00_16777 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16777, ((long) 1), BgL_sz00_16769);
								VECTOR_SET(BgL_nsz00_16777, ((long) 2), BgL_az00_14454);
								VECTOR_SET(BgL_nsz00_16777, ((long) 3), BgL_bz00_14455);
								VECTOR_SET(BgL_nsz00_16777, ((long) 4), BgL_cz00_14456);
								VECTOR_SET(BgL_nsz00_16777, ((long) 5), BgL_dz00_14457);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_16778;

									BgL_z12denvz12_16778 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16778, BgL_nsz00_16777);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_16779;

										BgL_ez00_16779 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16779,
											BgL_sz00_16769);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_16780;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_16781;

												BgL_savedzd2bpzd2_16781 =
													VECTOR_REF(BgL_nsz00_16777, ((long) 0));
												VECTOR_SET(BgL_nsz00_16777, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16783;

													BgL_fz00_16783 = BgL_runz00_14452;
												BgL_recz00_16782:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_16784;

														BgL_rz00_16784 =
															PROCEDURE_ENTRY(BgL_fz00_16783) (BgL_fz00_16783,
															BgL_nsz00_16777, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_test6586z00_27049;

															if (PROCEDUREP(BgL_rz00_16784))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1707z00_16785;

																	BgL_arg1707z00_16785 =
																		PROCEDURE_ATTR(BgL_rz00_16784);
																	if (STRUCTP(BgL_arg1707z00_16785))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6586z00_27049 =
																				(STRUCT_KEY(BgL_arg1707z00_16785) ==
																				BGl_symbol5794z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6586z00_27049 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_test6586z00_27049 = ((bool_t) 0);
																}
															if (BgL_test6586z00_27049)
																{
																	obj_t BgL_fz00_27057;

																	BgL_fz00_27057 = BgL_rz00_16784;
																	BgL_fz00_16783 = BgL_fz00_27057;
																	goto BgL_recz00_16782;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_16777, ((long) 0),
																		BgL_savedzd2bpzd2_16781);
																	BgL_____rz00_16780 = BgL_rz00_16784;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16779);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16778, BgL_sz00_16769);
											return BgL_____rz00_16780;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5707 */
	obj_t BGl_z62run5707z62zz__evaluate_compz00(obj_t BgL_envz00_14458,
		obj_t BgL_sz00_14461)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1247z00_14459;
				obj_t BgL_bodyz00_14460;

				BgL_i1247z00_14459 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14458, (int) (((long) 0))));
				BgL_bodyz00_14460 = PROCEDURE_REF(BgL_envz00_14458, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_16786;

					BgL_bpz00_16786 = VECTOR_REF(((obj_t) BgL_sz00_14461), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_z12denvz12_16787;
						obj_t BgL_wherez00_16788;
						obj_t BgL_locz00_16789;

						BgL_z12denvz12_16787 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16788 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14459))->
							BgL_wherez00);
						BgL_locz00_16789 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14459))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1167 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16787, BgL_wherez00_16788,
								BgL_locz00_16789);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_za2za2resza2za2z00_16790;

								BgL_za2za2resza2za2z00_16790 =
									PROCEDURE_ENTRY(BgL_bodyz00_14460) (BgL_bodyz00_14460,
									BgL_sz00_14461, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16787);
								return BgL_za2za2resza2za2z00_16790;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3828> */
	obj_t BGl_z62zc3z04anonymousza33828ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14462, obj_t BgL_sz00_14467)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_14463;
				BgL_ev_absz00_bglt BgL_i1247z00_14464;
				obj_t BgL_bodyz00_14465;
				long BgL_siza7ezd2framez75_14466;

				BgL_iboxesz00_14463 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14462, (int) (((long) 0))));
				BgL_i1247z00_14464 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14462, (int) (((long) 1))));
				BgL_bodyz00_14465 = PROCEDURE_REF(BgL_envz00_14462, (int) (((long) 2)));
				BgL_siza7ezd2framez75_14466 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14462, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_16791;

					BgL_bpz00_16791 = VECTOR_REF(((obj_t) BgL_sz00_14467), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */

						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_16792;

							BgL_runz00_16792 =
								MAKE_FX_PROCEDURE(BGl_z62run5709z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_16792,
								(int) (((long) 0)), BgL_iboxesz00_14463);
							PROCEDURE_SET(BgL_runz00_16792,
								(int) (((long) 1)), ((obj_t) BgL_i1247z00_14464));
							PROCEDURE_SET(BgL_runz00_16792,
								(int) (((long) 2)), BgL_bodyz00_14465);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_16793;

								BgL_mainz00_16793 =
									MAKE_FX_PROCEDURE(BGl_z62main5708z62zz__evaluate_compz00,
									(int) (((long) 4)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_16793,
									(int) (((long) 0)), BgL_iboxesz00_14463);
								PROCEDURE_SET(BgL_mainz00_16793,
									(int) (((long) 1)), ((obj_t) BgL_i1247z00_14464));
								PROCEDURE_SET(BgL_mainz00_16793,
									(int) (((long) 2)), BgL_bodyz00_14465);
								PROCEDURE_SET(BgL_mainz00_16793,
									(int) (((long) 3)), BgL_runz00_16792);
								PROCEDURE_SET(BgL_mainz00_16793,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_14466));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_16794;

									BgL_objz00_16794 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16792, BgL_objz00_16794);
									BgL_objz00_16794;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3829z00_16795;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3830z00_16796;

										BgL_arg3830z00_16796 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14464))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_16797;

											BgL_newz00_16797 =
												create_struct(BGl_symbol5815z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_27119;

												BgL_tmpz00_27119 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16797, BgL_tmpz00_27119,
													BgL_arg3830z00_16796);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_27124;
												int BgL_tmpz00_27122;

												BgL_auxz00_27124 = BINT(BgL_siza7ezd2framez75_14466);
												BgL_tmpz00_27122 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16797, BgL_tmpz00_27122,
													BgL_auxz00_27124);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_27127;

												BgL_tmpz00_27127 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16797, BgL_tmpz00_27127,
													BgL_runz00_16792);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_27132;
												int BgL_tmpz00_27130;

												BgL_auxz00_27132 = BINT(((long) 4));
												BgL_tmpz00_27130 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16797, BgL_tmpz00_27130,
													BgL_auxz00_27132);
											}
											BgL_arg3829z00_16795 = BgL_newz00_16797;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16793, BgL_arg3829z00_16795);
									BgL_arg3829z00_16795;
								}
								return BgL_mainz00_16793;
							}
						}
					}
				}
			}
		}

	}



/* &main5708 */
	obj_t BGl_z62main5708z62zz__evaluate_compz00(obj_t BgL_envz00_14468,
		obj_t BgL_az00_14474, obj_t BgL_bz00_14475, obj_t BgL_cz00_14476,
		obj_t BgL_dz00_14477)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14472;
				long BgL_siza7ezd2framez75_14473;

				BgL_runz00_14472 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14468, (int) (((long) 3))));
				BgL_siza7ezd2framez75_14473 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14468, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_16798;

					BgL_sz00_16798 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_16799;

						BgL_bpz00_16799 = VECTOR_REF(((obj_t) BgL_sz00_16798), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16799) + BgL_siza7ezd2framez75_14473) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16798))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3833z00_16800;

									BgL_arg3833z00_16800 =
										((long) CINT(BgL_bpz00_16799) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16798), BgL_arg3833z00_16800,
										BgL_az00_14474);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3834z00_16801;

									BgL_arg3834z00_16801 =
										((long) CINT(BgL_bpz00_16799) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16798), BgL_arg3834z00_16801,
										BgL_bz00_14475);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3835z00_16802;

									BgL_arg3835z00_16802 =
										((long) CINT(BgL_bpz00_16799) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_16798), BgL_arg3835z00_16802,
										BgL_cz00_14476);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3836z00_16803;

									BgL_arg3836z00_16803 =
										((long) CINT(BgL_bpz00_16799) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_16798), BgL_arg3836z00_16803,
										BgL_dz00_14477);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_16804;

									BgL_ez00_16804 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16804,
										BgL_bpz00_16799);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_16805;

										BgL_accz00_16805 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14472, BgL_sz00_16798, BgL_bpz00_16799);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16804);
										VECTOR_SET(
											((obj_t) BgL_sz00_16798), ((long) 0), BgL_bpz00_16799);
										return BgL_accz00_16805;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_16806;

								BgL_nsz00_16806 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16806, ((long) 1), BgL_sz00_16798);
								VECTOR_SET(BgL_nsz00_16806, ((long) 2), BgL_az00_14474);
								VECTOR_SET(BgL_nsz00_16806, ((long) 3), BgL_bz00_14475);
								VECTOR_SET(BgL_nsz00_16806, ((long) 4), BgL_cz00_14476);
								VECTOR_SET(BgL_nsz00_16806, ((long) 5), BgL_dz00_14477);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_16807;

									BgL_z12denvz12_16807 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16807, BgL_nsz00_16806);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_16808;

										BgL_ez00_16808 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16808,
											BgL_sz00_16798);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_16809;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_16810;

												BgL_savedzd2bpzd2_16810 =
													VECTOR_REF(BgL_nsz00_16806, ((long) 0));
												VECTOR_SET(BgL_nsz00_16806, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16812;

													BgL_fz00_16812 = BgL_runz00_14472;
												BgL_recz00_16811:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_16813;

														BgL_rz00_16813 =
															PROCEDURE_ENTRY(BgL_fz00_16812) (BgL_fz00_16812,
															BgL_nsz00_16806, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_test6590z00_27190;

															if (PROCEDUREP(BgL_rz00_16813))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1707z00_16814;

																	BgL_arg1707z00_16814 =
																		PROCEDURE_ATTR(BgL_rz00_16813);
																	if (STRUCTP(BgL_arg1707z00_16814))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6590z00_27190 =
																				(STRUCT_KEY(BgL_arg1707z00_16814) ==
																				BGl_symbol5794z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6590z00_27190 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_test6590z00_27190 = ((bool_t) 0);
																}
															if (BgL_test6590z00_27190)
																{
																	obj_t BgL_fz00_27198;

																	BgL_fz00_27198 = BgL_rz00_16813;
																	BgL_fz00_16812 = BgL_fz00_27198;
																	goto BgL_recz00_16811;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_16806, ((long) 0),
																		BgL_savedzd2bpzd2_16810);
																	BgL_____rz00_16809 = BgL_rz00_16813;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16808);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16807, BgL_sz00_16798);
											return BgL_____rz00_16809;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5709 */
	obj_t BGl_z62run5709z62zz__evaluate_compz00(obj_t BgL_envz00_14478,
		obj_t BgL_sz00_14482)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_14479;
				BgL_ev_absz00_bglt BgL_i1247z00_14480;
				obj_t BgL_bodyz00_14481;

				BgL_iboxesz00_14479 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14478, (int) (((long) 0))));
				BgL_i1247z00_14480 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14478, (int) (((long) 1))));
				BgL_bodyz00_14481 = PROCEDURE_REF(BgL_envz00_14478, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_16815;

					BgL_bpz00_16815 = VECTOR_REF(((obj_t) BgL_sz00_14482), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14482,
						BgL_iboxesz00_14479, BgL_bpz00_16815);
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_z12denvz12_16816;
						obj_t BgL_wherez00_16817;
						obj_t BgL_locz00_16818;

						BgL_z12denvz12_16816 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16817 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14480))->
							BgL_wherez00);
						BgL_locz00_16818 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14480))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1167 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16816, BgL_wherez00_16817,
								BgL_locz00_16818);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_za2za2resza2za2z00_16819;

								BgL_za2za2resza2za2z00_16819 =
									PROCEDURE_ENTRY(BgL_bodyz00_14481) (BgL_bodyz00_14481,
									BgL_sz00_14482, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16816);
								return BgL_za2za2resza2za2z00_16819;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3841> */
	obj_t BGl_z62zc3z04anonymousza33841ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14483, obj_t BgL_sz00_14489)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_ifreesz00_14484;
				long BgL_siza7eza7_14485;
				BgL_ev_absz00_bglt BgL_i1247z00_14486;
				obj_t BgL_bodyz00_14487;
				long BgL_siza7ezd2framez75_14488;

				BgL_ifreesz00_14484 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14483, (int) (((long) 0))));
				BgL_siza7eza7_14485 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14483, (int) (((long) 1))));
				BgL_i1247z00_14486 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14483, (int) (((long) 2))));
				BgL_bodyz00_14487 = PROCEDURE_REF(BgL_envz00_14483, (int) (((long) 3)));
				BgL_siza7ezd2framez75_14488 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14483, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_16820;

					BgL_bpz00_16820 = VECTOR_REF(((obj_t) BgL_sz00_14489), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_valza2za2_16821;

						BgL_valza2za2_16821 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14489,
							BgL_bpz00_16820, BgL_ifreesz00_14484);
						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_16822;

							BgL_runz00_16822 =
								MAKE_FX_PROCEDURE(BGl_z62run5711z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_16822,
								(int) (((long) 0)), BINT(BgL_siza7eza7_14485));
							PROCEDURE_SET(BgL_runz00_16822,
								(int) (((long) 1)), BgL_valza2za2_16821);
							PROCEDURE_SET(BgL_runz00_16822,
								(int) (((long) 2)), ((obj_t) BgL_i1247z00_14486));
							PROCEDURE_SET(BgL_runz00_16822,
								(int) (((long) 3)), BgL_bodyz00_14487);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_16823;

								BgL_mainz00_16823 =
									MAKE_FX_PROCEDURE(BGl_z62main5710z62zz__evaluate_compz00,
									(int) (((long) 4)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_16823,
									(int) (((long) 0)), BINT(BgL_siza7eza7_14485));
								PROCEDURE_SET(BgL_mainz00_16823,
									(int) (((long) 1)), BgL_valza2za2_16821);
								PROCEDURE_SET(BgL_mainz00_16823,
									(int) (((long) 2)), ((obj_t) BgL_i1247z00_14486));
								PROCEDURE_SET(BgL_mainz00_16823,
									(int) (((long) 3)), BgL_bodyz00_14487);
								PROCEDURE_SET(BgL_mainz00_16823,
									(int) (((long) 4)), BgL_runz00_16822);
								PROCEDURE_SET(BgL_mainz00_16823,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_14488));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_16824;

									BgL_objz00_16824 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16822, BgL_objz00_16824);
									BgL_objz00_16824;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3842z00_16825;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3843z00_16826;

										BgL_arg3843z00_16826 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14486))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_16827;

											BgL_newz00_16827 =
												create_struct(BGl_symbol5815z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_27274;

												BgL_tmpz00_27274 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16827, BgL_tmpz00_27274,
													BgL_arg3843z00_16826);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_27279;
												int BgL_tmpz00_27277;

												BgL_auxz00_27279 = BINT(BgL_siza7ezd2framez75_14488);
												BgL_tmpz00_27277 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16827, BgL_tmpz00_27277,
													BgL_auxz00_27279);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_27282;

												BgL_tmpz00_27282 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16827, BgL_tmpz00_27282,
													BgL_runz00_16822);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_27287;
												int BgL_tmpz00_27285;

												BgL_auxz00_27287 = BINT(((long) 4));
												BgL_tmpz00_27285 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16827, BgL_tmpz00_27285,
													BgL_auxz00_27287);
											}
											BgL_arg3842z00_16825 = BgL_newz00_16827;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16823, BgL_arg3842z00_16825);
									BgL_arg3842z00_16825;
								}
								return BgL_mainz00_16823;
							}
						}
					}
				}
			}
		}

	}



/* &main5710 */
	obj_t BGl_z62main5710z62zz__evaluate_compz00(obj_t BgL_envz00_14490,
		obj_t BgL_az00_14497, obj_t BgL_bz00_14498, obj_t BgL_cz00_14499,
		obj_t BgL_dz00_14500)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14495;
				long BgL_siza7ezd2framez75_14496;

				BgL_runz00_14495 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14490, (int) (((long) 4))));
				BgL_siza7ezd2framez75_14496 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14490, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_16828;

					BgL_sz00_16828 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_16829;

						BgL_bpz00_16829 = VECTOR_REF(((obj_t) BgL_sz00_16828), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16829) + BgL_siza7ezd2framez75_14496) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16828))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3846z00_16830;

									BgL_arg3846z00_16830 =
										((long) CINT(BgL_bpz00_16829) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16828), BgL_arg3846z00_16830,
										BgL_az00_14497);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3847z00_16831;

									BgL_arg3847z00_16831 =
										((long) CINT(BgL_bpz00_16829) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16828), BgL_arg3847z00_16831,
										BgL_bz00_14498);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3848z00_16832;

									BgL_arg3848z00_16832 =
										((long) CINT(BgL_bpz00_16829) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_16828), BgL_arg3848z00_16832,
										BgL_cz00_14499);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3849z00_16833;

									BgL_arg3849z00_16833 =
										((long) CINT(BgL_bpz00_16829) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_16828), BgL_arg3849z00_16833,
										BgL_dz00_14500);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_16834;

									BgL_ez00_16834 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16834,
										BgL_bpz00_16829);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_16835;

										BgL_accz00_16835 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14495, BgL_sz00_16828, BgL_bpz00_16829);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16834);
										VECTOR_SET(
											((obj_t) BgL_sz00_16828), ((long) 0), BgL_bpz00_16829);
										return BgL_accz00_16835;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_16836;

								BgL_nsz00_16836 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16836, ((long) 1), BgL_sz00_16828);
								VECTOR_SET(BgL_nsz00_16836, ((long) 2), BgL_az00_14497);
								VECTOR_SET(BgL_nsz00_16836, ((long) 3), BgL_bz00_14498);
								VECTOR_SET(BgL_nsz00_16836, ((long) 4), BgL_cz00_14499);
								VECTOR_SET(BgL_nsz00_16836, ((long) 5), BgL_dz00_14500);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_16837;

									BgL_z12denvz12_16837 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16837, BgL_nsz00_16836);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_16838;

										BgL_ez00_16838 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16838,
											BgL_sz00_16828);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_16839;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_16840;

												BgL_savedzd2bpzd2_16840 =
													VECTOR_REF(BgL_nsz00_16836, ((long) 0));
												VECTOR_SET(BgL_nsz00_16836, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16842;

													BgL_fz00_16842 = BgL_runz00_14495;
												BgL_recz00_16841:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_16843;

														BgL_rz00_16843 =
															PROCEDURE_ENTRY(BgL_fz00_16842) (BgL_fz00_16842,
															BgL_nsz00_16836, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_test6594z00_27345;

															if (PROCEDUREP(BgL_rz00_16843))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1707z00_16844;

																	BgL_arg1707z00_16844 =
																		PROCEDURE_ATTR(BgL_rz00_16843);
																	if (STRUCTP(BgL_arg1707z00_16844))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6594z00_27345 =
																				(STRUCT_KEY(BgL_arg1707z00_16844) ==
																				BGl_symbol5794z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6594z00_27345 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_test6594z00_27345 = ((bool_t) 0);
																}
															if (BgL_test6594z00_27345)
																{
																	obj_t BgL_fz00_27353;

																	BgL_fz00_27353 = BgL_rz00_16843;
																	BgL_fz00_16842 = BgL_fz00_27353;
																	goto BgL_recz00_16841;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_16836, ((long) 0),
																		BgL_savedzd2bpzd2_16840);
																	BgL_____rz00_16839 = BgL_rz00_16843;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16838);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16837, BgL_sz00_16828);
											return BgL_____rz00_16839;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5711 */
	obj_t BGl_z62run5711z62zz__evaluate_compz00(obj_t BgL_envz00_14501,
		obj_t BgL_sz00_14506)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				long BgL_siza7eza7_14502;
				obj_t BgL_valza2za2_14503;
				BgL_ev_absz00_bglt BgL_i1247z00_14504;
				obj_t BgL_bodyz00_14505;

				BgL_siza7eza7_14502 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14501, (int) (((long) 0))));
				BgL_valza2za2_14503 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14501, (int) (((long) 1))));
				BgL_i1247z00_14504 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14501, (int) (((long) 2))));
				BgL_bodyz00_14505 = PROCEDURE_REF(BgL_envz00_14501, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_16845;

					BgL_bpz00_16845 = VECTOR_REF(((obj_t) BgL_sz00_14506), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14506,
						BgL_valza2za2_14503,
						((long) CINT(BgL_bpz00_16845) + BgL_siza7eza7_14502));
					{	/* Eval/evaluate_comp.scm 1088 */
						obj_t BgL_z12denvz12_16846;
						obj_t BgL_wherez00_16847;
						obj_t BgL_locz00_16848;

						BgL_z12denvz12_16846 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16847 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14504))->
							BgL_wherez00);
						BgL_locz00_16848 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14504))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1088 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16846, BgL_wherez00_16847,
								BgL_locz00_16848);
							{	/* Eval/evaluate_comp.scm 1088 */
								obj_t BgL_za2za2resza2za2z00_16849;

								BgL_za2za2resza2za2z00_16849 =
									PROCEDURE_ENTRY(BgL_bodyz00_14505) (BgL_bodyz00_14505,
									BgL_sz00_14506, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16846);
								return BgL_za2za2resza2za2z00_16849;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3852> */
	obj_t BGl_z62zc3z04anonymousza33852ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14507, obj_t BgL_sz00_14514)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_ifreesz00_14508;
				obj_t BgL_iboxesz00_14509;
				long BgL_siza7eza7_14510;
				BgL_ev_absz00_bglt BgL_i1247z00_14511;
				obj_t BgL_bodyz00_14512;
				long BgL_siza7ezd2framez75_14513;

				BgL_ifreesz00_14508 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14507, (int) (((long) 0))));
				BgL_iboxesz00_14509 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14507, (int) (((long) 1))));
				BgL_siza7eza7_14510 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14507, (int) (((long) 2))));
				BgL_i1247z00_14511 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14507, (int) (((long) 3))));
				BgL_bodyz00_14512 = PROCEDURE_REF(BgL_envz00_14507, (int) (((long) 4)));
				BgL_siza7ezd2framez75_14513 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14507, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_16850;

					BgL_bpz00_16850 = VECTOR_REF(((obj_t) BgL_sz00_14514), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_valza2za2_16851;

						BgL_valza2za2_16851 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14514,
							BgL_bpz00_16850, BgL_ifreesz00_14508);
						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_16852;

							BgL_runz00_16852 =
								MAKE_FX_PROCEDURE(BGl_z62run5713z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_16852,
								(int) (((long) 0)), BgL_iboxesz00_14509);
							PROCEDURE_SET(BgL_runz00_16852,
								(int) (((long) 1)), BINT(BgL_siza7eza7_14510));
							PROCEDURE_SET(BgL_runz00_16852,
								(int) (((long) 2)), BgL_valza2za2_16851);
							PROCEDURE_SET(BgL_runz00_16852,
								(int) (((long) 3)), ((obj_t) BgL_i1247z00_14511));
							PROCEDURE_SET(BgL_runz00_16852,
								(int) (((long) 4)), BgL_bodyz00_14512);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_16853;

								BgL_mainz00_16853 =
									MAKE_FX_PROCEDURE(BGl_z62main5712z62zz__evaluate_compz00,
									(int) (((long) 4)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_16853,
									(int) (((long) 0)), BgL_iboxesz00_14509);
								PROCEDURE_SET(BgL_mainz00_16853,
									(int) (((long) 1)), BINT(BgL_siza7eza7_14510));
								PROCEDURE_SET(BgL_mainz00_16853,
									(int) (((long) 2)), BgL_valza2za2_16851);
								PROCEDURE_SET(BgL_mainz00_16853,
									(int) (((long) 3)), ((obj_t) BgL_i1247z00_14511));
								PROCEDURE_SET(BgL_mainz00_16853,
									(int) (((long) 4)), BgL_bodyz00_14512);
								PROCEDURE_SET(BgL_mainz00_16853,
									(int) (((long) 5)), BgL_runz00_16852);
								PROCEDURE_SET(BgL_mainz00_16853,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_14513));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_16854;

									BgL_objz00_16854 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16852, BgL_objz00_16854);
									BgL_objz00_16854;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3853z00_16855;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3854z00_16856;

										BgL_arg3854z00_16856 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14511))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_16857;

											BgL_newz00_16857 =
												create_struct(BGl_symbol5815z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_27441;

												BgL_tmpz00_27441 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16857, BgL_tmpz00_27441,
													BgL_arg3854z00_16856);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_27446;
												int BgL_tmpz00_27444;

												BgL_auxz00_27446 = BINT(BgL_siza7ezd2framez75_14513);
												BgL_tmpz00_27444 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16857, BgL_tmpz00_27444,
													BgL_auxz00_27446);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_27449;

												BgL_tmpz00_27449 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16857, BgL_tmpz00_27449,
													BgL_runz00_16852);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_27454;
												int BgL_tmpz00_27452;

												BgL_auxz00_27454 = BINT(((long) 4));
												BgL_tmpz00_27452 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16857, BgL_tmpz00_27452,
													BgL_auxz00_27454);
											}
											BgL_arg3853z00_16855 = BgL_newz00_16857;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16853, BgL_arg3853z00_16855);
									BgL_arg3853z00_16855;
								}
								return BgL_mainz00_16853;
							}
						}
					}
				}
			}
		}

	}



/* &main5712 */
	obj_t BGl_z62main5712z62zz__evaluate_compz00(obj_t BgL_envz00_14515,
		obj_t BgL_az00_14523, obj_t BgL_bz00_14524, obj_t BgL_cz00_14525,
		obj_t BgL_dz00_14526)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14521;
				long BgL_siza7ezd2framez75_14522;

				BgL_runz00_14521 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14515, (int) (((long) 5))));
				BgL_siza7ezd2framez75_14522 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14515, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_16858;

					BgL_sz00_16858 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_16859;

						BgL_bpz00_16859 = VECTOR_REF(((obj_t) BgL_sz00_16858), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16859) + BgL_siza7ezd2framez75_14522) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16858))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3857z00_16860;

									BgL_arg3857z00_16860 =
										((long) CINT(BgL_bpz00_16859) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16858), BgL_arg3857z00_16860,
										BgL_az00_14523);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3858z00_16861;

									BgL_arg3858z00_16861 =
										((long) CINT(BgL_bpz00_16859) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16858), BgL_arg3858z00_16861,
										BgL_bz00_14524);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3859z00_16862;

									BgL_arg3859z00_16862 =
										((long) CINT(BgL_bpz00_16859) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_16858), BgL_arg3859z00_16862,
										BgL_cz00_14525);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3860z00_16863;

									BgL_arg3860z00_16863 =
										((long) CINT(BgL_bpz00_16859) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_16858), BgL_arg3860z00_16863,
										BgL_dz00_14526);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_16864;

									BgL_ez00_16864 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16864,
										BgL_bpz00_16859);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_16865;

										BgL_accz00_16865 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14521, BgL_sz00_16858, BgL_bpz00_16859);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16864);
										VECTOR_SET(
											((obj_t) BgL_sz00_16858), ((long) 0), BgL_bpz00_16859);
										return BgL_accz00_16865;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_16866;

								BgL_nsz00_16866 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16866, ((long) 1), BgL_sz00_16858);
								VECTOR_SET(BgL_nsz00_16866, ((long) 2), BgL_az00_14523);
								VECTOR_SET(BgL_nsz00_16866, ((long) 3), BgL_bz00_14524);
								VECTOR_SET(BgL_nsz00_16866, ((long) 4), BgL_cz00_14525);
								VECTOR_SET(BgL_nsz00_16866, ((long) 5), BgL_dz00_14526);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_16867;

									BgL_z12denvz12_16867 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16867, BgL_nsz00_16866);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_16868;

										BgL_ez00_16868 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16868,
											BgL_sz00_16858);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_16869;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_16870;

												BgL_savedzd2bpzd2_16870 =
													VECTOR_REF(BgL_nsz00_16866, ((long) 0));
												VECTOR_SET(BgL_nsz00_16866, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16872;

													BgL_fz00_16872 = BgL_runz00_14521;
												BgL_recz00_16871:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_16873;

														BgL_rz00_16873 =
															PROCEDURE_ENTRY(BgL_fz00_16872) (BgL_fz00_16872,
															BgL_nsz00_16866, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_test6598z00_27512;

															if (PROCEDUREP(BgL_rz00_16873))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1707z00_16874;

																	BgL_arg1707z00_16874 =
																		PROCEDURE_ATTR(BgL_rz00_16873);
																	if (STRUCTP(BgL_arg1707z00_16874))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6598z00_27512 =
																				(STRUCT_KEY(BgL_arg1707z00_16874) ==
																				BGl_symbol5794z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6598z00_27512 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_test6598z00_27512 = ((bool_t) 0);
																}
															if (BgL_test6598z00_27512)
																{
																	obj_t BgL_fz00_27520;

																	BgL_fz00_27520 = BgL_rz00_16873;
																	BgL_fz00_16872 = BgL_fz00_27520;
																	goto BgL_recz00_16871;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_16866, ((long) 0),
																		BgL_savedzd2bpzd2_16870);
																	BgL_____rz00_16869 = BgL_rz00_16873;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16868);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16867, BgL_sz00_16858);
											return BgL_____rz00_16869;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5713 */
	obj_t BGl_z62run5713z62zz__evaluate_compz00(obj_t BgL_envz00_14527,
		obj_t BgL_sz00_14533)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_14528;
				long BgL_siza7eza7_14529;
				obj_t BgL_valza2za2_14530;
				BgL_ev_absz00_bglt BgL_i1247z00_14531;
				obj_t BgL_bodyz00_14532;

				BgL_iboxesz00_14528 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14527, (int) (((long) 0))));
				BgL_siza7eza7_14529 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14527, (int) (((long) 1))));
				BgL_valza2za2_14530 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14527, (int) (((long) 2))));
				BgL_i1247z00_14531 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14527, (int) (((long) 3))));
				BgL_bodyz00_14532 = PROCEDURE_REF(BgL_envz00_14527, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_16875;

					BgL_bpz00_16875 = VECTOR_REF(((obj_t) BgL_sz00_14533), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14533,
						BgL_iboxesz00_14528, BgL_bpz00_16875);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14533,
						BgL_valza2za2_14530,
						((long) CINT(BgL_bpz00_16875) + BgL_siza7eza7_14529));
					{	/* Eval/evaluate_comp.scm 1088 */
						obj_t BgL_z12denvz12_16876;
						obj_t BgL_wherez00_16877;
						obj_t BgL_locz00_16878;

						BgL_z12denvz12_16876 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16877 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14531))->
							BgL_wherez00);
						BgL_locz00_16878 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14531))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1088 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16876, BgL_wherez00_16877,
								BgL_locz00_16878);
							{	/* Eval/evaluate_comp.scm 1088 */
								obj_t BgL_za2za2resza2za2z00_16879;

								BgL_za2za2resza2za2z00_16879 =
									PROCEDURE_ENTRY(BgL_bodyz00_14532) (BgL_bodyz00_14532,
									BgL_sz00_14533, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16876);
								return BgL_za2za2resza2za2z00_16879;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3767> */
	obj_t BGl_z62zc3z04anonymousza33767ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14534, obj_t BgL_sz00_14538)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1247z00_14535;
				obj_t BgL_bodyz00_14536;
				long BgL_siza7ezd2framez75_14537;

				BgL_i1247z00_14535 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14534, (int) (((long) 0))));
				BgL_bodyz00_14536 = PROCEDURE_REF(BgL_envz00_14534, (int) (((long) 1)));
				BgL_siza7ezd2framez75_14537 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14534, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_16880;

					BgL_bpz00_16880 = VECTOR_REF(((obj_t) BgL_sz00_14538), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */

						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_16881;

							BgL_runz00_16881 =
								MAKE_FX_PROCEDURE(BGl_z62run5715z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_16881,
								(int) (((long) 0)), ((obj_t) BgL_i1247z00_14535));
							PROCEDURE_SET(BgL_runz00_16881,
								(int) (((long) 1)), BgL_bodyz00_14536);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_16882;

								BgL_mainz00_16882 =
									MAKE_VA_PROCEDURE(BGl_z62main5714z62zz__evaluate_compz00,
									(int) (((long) -4)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_16882,
									(int) (((long) 0)), ((obj_t) BgL_i1247z00_14535));
								PROCEDURE_SET(BgL_mainz00_16882,
									(int) (((long) 1)), BgL_bodyz00_14536);
								PROCEDURE_SET(BgL_mainz00_16882,
									(int) (((long) 2)), BgL_runz00_16881);
								PROCEDURE_SET(BgL_mainz00_16882,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_14537));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_16883;

									BgL_objz00_16883 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16881, BgL_objz00_16883);
									BgL_objz00_16883;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3768z00_16884;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3769z00_16885;

										BgL_arg3769z00_16885 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14535))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_16886;

											BgL_newz00_16886 =
												create_struct(BGl_symbol5815z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_27588;

												BgL_tmpz00_27588 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16886, BgL_tmpz00_27588,
													BgL_arg3769z00_16885);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_27593;
												int BgL_tmpz00_27591;

												BgL_auxz00_27593 = BINT(BgL_siza7ezd2framez75_14537);
												BgL_tmpz00_27591 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16886, BgL_tmpz00_27591,
													BgL_auxz00_27593);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_27596;

												BgL_tmpz00_27596 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16886, BgL_tmpz00_27596,
													BgL_runz00_16881);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_27601;
												int BgL_tmpz00_27599;

												BgL_auxz00_27601 = BINT(((long) -4));
												BgL_tmpz00_27599 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16886, BgL_tmpz00_27599,
													BgL_auxz00_27601);
											}
											BgL_arg3768z00_16884 = BgL_newz00_16886;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16882, BgL_arg3768z00_16884);
									BgL_arg3768z00_16884;
								}
								return BgL_mainz00_16882;
							}
						}
					}
				}
			}
		}

	}



/* &main5714 */
	obj_t BGl_z62main5714z62zz__evaluate_compz00(obj_t BgL_envz00_14539,
		obj_t BgL_bz00_14544, obj_t BgL_cz00_14545, obj_t BgL_dz00_14546,
		obj_t BgL_lastz00_14547)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14542;
				long BgL_siza7ezd2framez75_14543;

				BgL_runz00_14542 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14539, (int) (((long) 2))));
				BgL_siza7ezd2framez75_14543 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14539, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_16887;

					BgL_sz00_16887 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_16888;

						BgL_bpz00_16888 = VECTOR_REF(((obj_t) BgL_sz00_16887), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16888) + BgL_siza7ezd2framez75_14543) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16887))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3772z00_16889;

									BgL_arg3772z00_16889 =
										((long) CINT(BgL_bpz00_16888) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16887), BgL_arg3772z00_16889,
										BgL_bz00_14544);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3773z00_16890;

									BgL_arg3773z00_16890 =
										((long) CINT(BgL_bpz00_16888) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16887), BgL_arg3773z00_16890,
										BgL_cz00_14545);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3774z00_16891;

									BgL_arg3774z00_16891 =
										((long) CINT(BgL_bpz00_16888) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_16887), BgL_arg3774z00_16891,
										BgL_dz00_14546);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3775z00_16892;

									BgL_arg3775z00_16892 =
										((long) CINT(BgL_bpz00_16888) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_16887), BgL_arg3775z00_16892,
										BgL_lastz00_14547);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_16893;

									BgL_ez00_16893 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16893,
										BgL_bpz00_16888);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_16894;

										BgL_accz00_16894 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14542, BgL_sz00_16887, BgL_bpz00_16888);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16893);
										VECTOR_SET(
											((obj_t) BgL_sz00_16887), ((long) 0), BgL_bpz00_16888);
										return BgL_accz00_16894;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_16895;

								BgL_nsz00_16895 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16895, ((long) 1), BgL_sz00_16887);
								VECTOR_SET(BgL_nsz00_16895, ((long) 2), BgL_bz00_14544);
								VECTOR_SET(BgL_nsz00_16895, ((long) 3), BgL_cz00_14545);
								VECTOR_SET(BgL_nsz00_16895, ((long) 4), BgL_dz00_14546);
								VECTOR_SET(BgL_nsz00_16895, ((long) 5), BgL_lastz00_14547);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_16896;

									BgL_z12denvz12_16896 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16896, BgL_nsz00_16895);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_16897;

										BgL_ez00_16897 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16897,
											BgL_sz00_16887);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_16898;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_16899;

												BgL_savedzd2bpzd2_16899 =
													VECTOR_REF(BgL_nsz00_16895, ((long) 0));
												VECTOR_SET(BgL_nsz00_16895, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16901;

													BgL_fz00_16901 = BgL_runz00_14542;
												BgL_recz00_16900:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_16902;

														BgL_rz00_16902 =
															PROCEDURE_ENTRY(BgL_fz00_16901) (BgL_fz00_16901,
															BgL_nsz00_16895, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_test6602z00_27659;

															if (PROCEDUREP(BgL_rz00_16902))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1707z00_16903;

																	BgL_arg1707z00_16903 =
																		PROCEDURE_ATTR(BgL_rz00_16902);
																	if (STRUCTP(BgL_arg1707z00_16903))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6602z00_27659 =
																				(STRUCT_KEY(BgL_arg1707z00_16903) ==
																				BGl_symbol5794z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6602z00_27659 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_test6602z00_27659 = ((bool_t) 0);
																}
															if (BgL_test6602z00_27659)
																{
																	obj_t BgL_fz00_27667;

																	BgL_fz00_27667 = BgL_rz00_16902;
																	BgL_fz00_16901 = BgL_fz00_27667;
																	goto BgL_recz00_16900;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_16895, ((long) 0),
																		BgL_savedzd2bpzd2_16899);
																	BgL_____rz00_16898 = BgL_rz00_16902;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16897);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16896, BgL_sz00_16887);
											return BgL_____rz00_16898;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5715 */
	obj_t BGl_z62run5715z62zz__evaluate_compz00(obj_t BgL_envz00_14548,
		obj_t BgL_sz00_14551)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1247z00_14549;
				obj_t BgL_bodyz00_14550;

				BgL_i1247z00_14549 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14548, (int) (((long) 0))));
				BgL_bodyz00_14550 = PROCEDURE_REF(BgL_envz00_14548, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_16904;

					BgL_bpz00_16904 = VECTOR_REF(((obj_t) BgL_sz00_14551), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_z12denvz12_16905;
						obj_t BgL_wherez00_16906;
						obj_t BgL_locz00_16907;

						BgL_z12denvz12_16905 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16906 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14549))->
							BgL_wherez00);
						BgL_locz00_16907 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14549))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1167 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16905, BgL_wherez00_16906,
								BgL_locz00_16907);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_za2za2resza2za2z00_16908;

								BgL_za2za2resza2za2z00_16908 =
									PROCEDURE_ENTRY(BgL_bodyz00_14550) (BgL_bodyz00_14550,
									BgL_sz00_14551, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16905);
								return BgL_za2za2resza2za2z00_16908;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3777> */
	obj_t BGl_z62zc3z04anonymousza33777ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14552, obj_t BgL_sz00_14557)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_14553;
				BgL_ev_absz00_bglt BgL_i1247z00_14554;
				obj_t BgL_bodyz00_14555;
				long BgL_siza7ezd2framez75_14556;

				BgL_iboxesz00_14553 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14552, (int) (((long) 0))));
				BgL_i1247z00_14554 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14552, (int) (((long) 1))));
				BgL_bodyz00_14555 = PROCEDURE_REF(BgL_envz00_14552, (int) (((long) 2)));
				BgL_siza7ezd2framez75_14556 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14552, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_16909;

					BgL_bpz00_16909 = VECTOR_REF(((obj_t) BgL_sz00_14557), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */

						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_16910;

							BgL_runz00_16910 =
								MAKE_FX_PROCEDURE(BGl_z62run5717z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_16910,
								(int) (((long) 0)), BgL_iboxesz00_14553);
							PROCEDURE_SET(BgL_runz00_16910,
								(int) (((long) 1)), ((obj_t) BgL_i1247z00_14554));
							PROCEDURE_SET(BgL_runz00_16910,
								(int) (((long) 2)), BgL_bodyz00_14555);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_16911;

								BgL_mainz00_16911 =
									MAKE_VA_PROCEDURE(BGl_z62main5716z62zz__evaluate_compz00,
									(int) (((long) -4)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_16911,
									(int) (((long) 0)), BgL_iboxesz00_14553);
								PROCEDURE_SET(BgL_mainz00_16911,
									(int) (((long) 1)), ((obj_t) BgL_i1247z00_14554));
								PROCEDURE_SET(BgL_mainz00_16911,
									(int) (((long) 2)), BgL_bodyz00_14555);
								PROCEDURE_SET(BgL_mainz00_16911,
									(int) (((long) 3)), BgL_runz00_16910);
								PROCEDURE_SET(BgL_mainz00_16911,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_14556));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_16912;

									BgL_objz00_16912 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16910, BgL_objz00_16912);
									BgL_objz00_16912;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3778z00_16913;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3779z00_16914;

										BgL_arg3779z00_16914 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14554))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_16915;

											BgL_newz00_16915 =
												create_struct(BGl_symbol5815z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_27729;

												BgL_tmpz00_27729 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16915, BgL_tmpz00_27729,
													BgL_arg3779z00_16914);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_27734;
												int BgL_tmpz00_27732;

												BgL_auxz00_27734 = BINT(BgL_siza7ezd2framez75_14556);
												BgL_tmpz00_27732 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16915, BgL_tmpz00_27732,
													BgL_auxz00_27734);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_27737;

												BgL_tmpz00_27737 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16915, BgL_tmpz00_27737,
													BgL_runz00_16910);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_27742;
												int BgL_tmpz00_27740;

												BgL_auxz00_27742 = BINT(((long) -4));
												BgL_tmpz00_27740 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16915, BgL_tmpz00_27740,
													BgL_auxz00_27742);
											}
											BgL_arg3778z00_16913 = BgL_newz00_16915;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16911, BgL_arg3778z00_16913);
									BgL_arg3778z00_16913;
								}
								return BgL_mainz00_16911;
							}
						}
					}
				}
			}
		}

	}



/* &main5716 */
	obj_t BGl_z62main5716z62zz__evaluate_compz00(obj_t BgL_envz00_14558,
		obj_t BgL_bz00_14564, obj_t BgL_cz00_14565, obj_t BgL_dz00_14566,
		obj_t BgL_lastz00_14567)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14562;
				long BgL_siza7ezd2framez75_14563;

				BgL_runz00_14562 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14558, (int) (((long) 3))));
				BgL_siza7ezd2framez75_14563 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14558, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_16916;

					BgL_sz00_16916 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_16917;

						BgL_bpz00_16917 = VECTOR_REF(((obj_t) BgL_sz00_16916), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16917) + BgL_siza7ezd2framez75_14563) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16916))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3782z00_16918;

									BgL_arg3782z00_16918 =
										((long) CINT(BgL_bpz00_16917) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16916), BgL_arg3782z00_16918,
										BgL_bz00_14564);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3783z00_16919;

									BgL_arg3783z00_16919 =
										((long) CINT(BgL_bpz00_16917) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16916), BgL_arg3783z00_16919,
										BgL_cz00_14565);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3784z00_16920;

									BgL_arg3784z00_16920 =
										((long) CINT(BgL_bpz00_16917) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_16916), BgL_arg3784z00_16920,
										BgL_dz00_14566);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3785z00_16921;

									BgL_arg3785z00_16921 =
										((long) CINT(BgL_bpz00_16917) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_16916), BgL_arg3785z00_16921,
										BgL_lastz00_14567);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_16922;

									BgL_ez00_16922 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16922,
										BgL_bpz00_16917);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_16923;

										BgL_accz00_16923 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14562, BgL_sz00_16916, BgL_bpz00_16917);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16922);
										VECTOR_SET(
											((obj_t) BgL_sz00_16916), ((long) 0), BgL_bpz00_16917);
										return BgL_accz00_16923;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_16924;

								BgL_nsz00_16924 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16924, ((long) 1), BgL_sz00_16916);
								VECTOR_SET(BgL_nsz00_16924, ((long) 2), BgL_bz00_14564);
								VECTOR_SET(BgL_nsz00_16924, ((long) 3), BgL_cz00_14565);
								VECTOR_SET(BgL_nsz00_16924, ((long) 4), BgL_dz00_14566);
								VECTOR_SET(BgL_nsz00_16924, ((long) 5), BgL_lastz00_14567);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_16925;

									BgL_z12denvz12_16925 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16925, BgL_nsz00_16924);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_16926;

										BgL_ez00_16926 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16926,
											BgL_sz00_16916);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_16927;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_16928;

												BgL_savedzd2bpzd2_16928 =
													VECTOR_REF(BgL_nsz00_16924, ((long) 0));
												VECTOR_SET(BgL_nsz00_16924, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16930;

													BgL_fz00_16930 = BgL_runz00_14562;
												BgL_recz00_16929:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_16931;

														BgL_rz00_16931 =
															PROCEDURE_ENTRY(BgL_fz00_16930) (BgL_fz00_16930,
															BgL_nsz00_16924, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_test6606z00_27800;

															if (PROCEDUREP(BgL_rz00_16931))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1707z00_16932;

																	BgL_arg1707z00_16932 =
																		PROCEDURE_ATTR(BgL_rz00_16931);
																	if (STRUCTP(BgL_arg1707z00_16932))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6606z00_27800 =
																				(STRUCT_KEY(BgL_arg1707z00_16932) ==
																				BGl_symbol5794z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6606z00_27800 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_test6606z00_27800 = ((bool_t) 0);
																}
															if (BgL_test6606z00_27800)
																{
																	obj_t BgL_fz00_27808;

																	BgL_fz00_27808 = BgL_rz00_16931;
																	BgL_fz00_16930 = BgL_fz00_27808;
																	goto BgL_recz00_16929;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_16924, ((long) 0),
																		BgL_savedzd2bpzd2_16928);
																	BgL_____rz00_16927 = BgL_rz00_16931;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16926);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16925, BgL_sz00_16916);
											return BgL_____rz00_16927;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5717 */
	obj_t BGl_z62run5717z62zz__evaluate_compz00(obj_t BgL_envz00_14568,
		obj_t BgL_sz00_14572)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_14569;
				BgL_ev_absz00_bglt BgL_i1247z00_14570;
				obj_t BgL_bodyz00_14571;

				BgL_iboxesz00_14569 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14568, (int) (((long) 0))));
				BgL_i1247z00_14570 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14568, (int) (((long) 1))));
				BgL_bodyz00_14571 = PROCEDURE_REF(BgL_envz00_14568, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_16933;

					BgL_bpz00_16933 = VECTOR_REF(((obj_t) BgL_sz00_14572), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14572,
						BgL_iboxesz00_14569, BgL_bpz00_16933);
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_z12denvz12_16934;
						obj_t BgL_wherez00_16935;
						obj_t BgL_locz00_16936;

						BgL_z12denvz12_16934 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16935 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14570))->
							BgL_wherez00);
						BgL_locz00_16936 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14570))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1167 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16934, BgL_wherez00_16935,
								BgL_locz00_16936);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_za2za2resza2za2z00_16937;

								BgL_za2za2resza2za2z00_16937 =
									PROCEDURE_ENTRY(BgL_bodyz00_14571) (BgL_bodyz00_14571,
									BgL_sz00_14572, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16934);
								return BgL_za2za2resza2za2z00_16937;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3790> */
	obj_t BGl_z62zc3z04anonymousza33790ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14573, obj_t BgL_sz00_14579)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_ifreesz00_14574;
				long BgL_siza7eza7_14575;
				BgL_ev_absz00_bglt BgL_i1247z00_14576;
				obj_t BgL_bodyz00_14577;
				long BgL_siza7ezd2framez75_14578;

				BgL_ifreesz00_14574 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14573, (int) (((long) 0))));
				BgL_siza7eza7_14575 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14573, (int) (((long) 1))));
				BgL_i1247z00_14576 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14573, (int) (((long) 2))));
				BgL_bodyz00_14577 = PROCEDURE_REF(BgL_envz00_14573, (int) (((long) 3)));
				BgL_siza7ezd2framez75_14578 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14573, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_16938;

					BgL_bpz00_16938 = VECTOR_REF(((obj_t) BgL_sz00_14579), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_valza2za2_16939;

						BgL_valza2za2_16939 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14579,
							BgL_bpz00_16938, BgL_ifreesz00_14574);
						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_16940;

							BgL_runz00_16940 =
								MAKE_FX_PROCEDURE(BGl_z62run5719z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_16940,
								(int) (((long) 0)), BINT(BgL_siza7eza7_14575));
							PROCEDURE_SET(BgL_runz00_16940,
								(int) (((long) 1)), BgL_valza2za2_16939);
							PROCEDURE_SET(BgL_runz00_16940,
								(int) (((long) 2)), ((obj_t) BgL_i1247z00_14576));
							PROCEDURE_SET(BgL_runz00_16940,
								(int) (((long) 3)), BgL_bodyz00_14577);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_16941;

								BgL_mainz00_16941 =
									MAKE_VA_PROCEDURE(BGl_z62main5718z62zz__evaluate_compz00,
									(int) (((long) -4)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_16941,
									(int) (((long) 0)), BINT(BgL_siza7eza7_14575));
								PROCEDURE_SET(BgL_mainz00_16941,
									(int) (((long) 1)), BgL_valza2za2_16939);
								PROCEDURE_SET(BgL_mainz00_16941,
									(int) (((long) 2)), ((obj_t) BgL_i1247z00_14576));
								PROCEDURE_SET(BgL_mainz00_16941,
									(int) (((long) 3)), BgL_bodyz00_14577);
								PROCEDURE_SET(BgL_mainz00_16941,
									(int) (((long) 4)), BgL_runz00_16940);
								PROCEDURE_SET(BgL_mainz00_16941,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_14578));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_16942;

									BgL_objz00_16942 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16940, BgL_objz00_16942);
									BgL_objz00_16942;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3791z00_16943;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3792z00_16944;

										BgL_arg3792z00_16944 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14576))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_16945;

											BgL_newz00_16945 =
												create_struct(BGl_symbol5815z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_27884;

												BgL_tmpz00_27884 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16945, BgL_tmpz00_27884,
													BgL_arg3792z00_16944);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_27889;
												int BgL_tmpz00_27887;

												BgL_auxz00_27889 = BINT(BgL_siza7ezd2framez75_14578);
												BgL_tmpz00_27887 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16945, BgL_tmpz00_27887,
													BgL_auxz00_27889);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_27892;

												BgL_tmpz00_27892 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16945, BgL_tmpz00_27892,
													BgL_runz00_16940);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_27897;
												int BgL_tmpz00_27895;

												BgL_auxz00_27897 = BINT(((long) -4));
												BgL_tmpz00_27895 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16945, BgL_tmpz00_27895,
													BgL_auxz00_27897);
											}
											BgL_arg3791z00_16943 = BgL_newz00_16945;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16941, BgL_arg3791z00_16943);
									BgL_arg3791z00_16943;
								}
								return BgL_mainz00_16941;
							}
						}
					}
				}
			}
		}

	}



/* &main5718 */
	obj_t BGl_z62main5718z62zz__evaluate_compz00(obj_t BgL_envz00_14580,
		obj_t BgL_bz00_14587, obj_t BgL_cz00_14588, obj_t BgL_dz00_14589,
		obj_t BgL_lastz00_14590)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14585;
				long BgL_siza7ezd2framez75_14586;

				BgL_runz00_14585 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14580, (int) (((long) 4))));
				BgL_siza7ezd2framez75_14586 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14580, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_16946;

					BgL_sz00_16946 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_16947;

						BgL_bpz00_16947 = VECTOR_REF(((obj_t) BgL_sz00_16946), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16947) + BgL_siza7ezd2framez75_14586) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16946))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3795z00_16948;

									BgL_arg3795z00_16948 =
										((long) CINT(BgL_bpz00_16947) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16946), BgL_arg3795z00_16948,
										BgL_bz00_14587);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3796z00_16949;

									BgL_arg3796z00_16949 =
										((long) CINT(BgL_bpz00_16947) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16946), BgL_arg3796z00_16949,
										BgL_cz00_14588);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3797z00_16950;

									BgL_arg3797z00_16950 =
										((long) CINT(BgL_bpz00_16947) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_16946), BgL_arg3797z00_16950,
										BgL_dz00_14589);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3798z00_16951;

									BgL_arg3798z00_16951 =
										((long) CINT(BgL_bpz00_16947) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_16946), BgL_arg3798z00_16951,
										BgL_lastz00_14590);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_16952;

									BgL_ez00_16952 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16952,
										BgL_bpz00_16947);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_16953;

										BgL_accz00_16953 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14585, BgL_sz00_16946, BgL_bpz00_16947);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16952);
										VECTOR_SET(
											((obj_t) BgL_sz00_16946), ((long) 0), BgL_bpz00_16947);
										return BgL_accz00_16953;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_16954;

								BgL_nsz00_16954 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16954, ((long) 1), BgL_sz00_16946);
								VECTOR_SET(BgL_nsz00_16954, ((long) 2), BgL_bz00_14587);
								VECTOR_SET(BgL_nsz00_16954, ((long) 3), BgL_cz00_14588);
								VECTOR_SET(BgL_nsz00_16954, ((long) 4), BgL_dz00_14589);
								VECTOR_SET(BgL_nsz00_16954, ((long) 5), BgL_lastz00_14590);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_16955;

									BgL_z12denvz12_16955 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16955, BgL_nsz00_16954);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_16956;

										BgL_ez00_16956 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16956,
											BgL_sz00_16946);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_16957;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_16958;

												BgL_savedzd2bpzd2_16958 =
													VECTOR_REF(BgL_nsz00_16954, ((long) 0));
												VECTOR_SET(BgL_nsz00_16954, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16960;

													BgL_fz00_16960 = BgL_runz00_14585;
												BgL_recz00_16959:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_16961;

														BgL_rz00_16961 =
															PROCEDURE_ENTRY(BgL_fz00_16960) (BgL_fz00_16960,
															BgL_nsz00_16954, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_test6610z00_27955;

															if (PROCEDUREP(BgL_rz00_16961))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1707z00_16962;

																	BgL_arg1707z00_16962 =
																		PROCEDURE_ATTR(BgL_rz00_16961);
																	if (STRUCTP(BgL_arg1707z00_16962))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6610z00_27955 =
																				(STRUCT_KEY(BgL_arg1707z00_16962) ==
																				BGl_symbol5794z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6610z00_27955 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_test6610z00_27955 = ((bool_t) 0);
																}
															if (BgL_test6610z00_27955)
																{
																	obj_t BgL_fz00_27963;

																	BgL_fz00_27963 = BgL_rz00_16961;
																	BgL_fz00_16960 = BgL_fz00_27963;
																	goto BgL_recz00_16959;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_16954, ((long) 0),
																		BgL_savedzd2bpzd2_16958);
																	BgL_____rz00_16957 = BgL_rz00_16961;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16956);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16955, BgL_sz00_16946);
											return BgL_____rz00_16957;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5719 */
	obj_t BGl_z62run5719z62zz__evaluate_compz00(obj_t BgL_envz00_14591,
		obj_t BgL_sz00_14596)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				long BgL_siza7eza7_14592;
				obj_t BgL_valza2za2_14593;
				BgL_ev_absz00_bglt BgL_i1247z00_14594;
				obj_t BgL_bodyz00_14595;

				BgL_siza7eza7_14592 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14591, (int) (((long) 0))));
				BgL_valza2za2_14593 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14591, (int) (((long) 1))));
				BgL_i1247z00_14594 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14591, (int) (((long) 2))));
				BgL_bodyz00_14595 = PROCEDURE_REF(BgL_envz00_14591, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_16963;

					BgL_bpz00_16963 = VECTOR_REF(((obj_t) BgL_sz00_14596), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14596,
						BgL_valza2za2_14593,
						((long) CINT(BgL_bpz00_16963) + BgL_siza7eza7_14592));
					{	/* Eval/evaluate_comp.scm 1088 */
						obj_t BgL_z12denvz12_16964;
						obj_t BgL_wherez00_16965;
						obj_t BgL_locz00_16966;

						BgL_z12denvz12_16964 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16965 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14594))->
							BgL_wherez00);
						BgL_locz00_16966 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14594))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1088 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16964, BgL_wherez00_16965,
								BgL_locz00_16966);
							{	/* Eval/evaluate_comp.scm 1088 */
								obj_t BgL_za2za2resza2za2z00_16967;

								BgL_za2za2resza2za2z00_16967 =
									PROCEDURE_ENTRY(BgL_bodyz00_14595) (BgL_bodyz00_14595,
									BgL_sz00_14596, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16964);
								return BgL_za2za2resza2za2z00_16967;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3801> */
	obj_t BGl_z62zc3z04anonymousza33801ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14597, obj_t BgL_sz00_14604)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_ifreesz00_14598;
				obj_t BgL_iboxesz00_14599;
				long BgL_siza7eza7_14600;
				BgL_ev_absz00_bglt BgL_i1247z00_14601;
				obj_t BgL_bodyz00_14602;
				long BgL_siza7ezd2framez75_14603;

				BgL_ifreesz00_14598 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14597, (int) (((long) 0))));
				BgL_iboxesz00_14599 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14597, (int) (((long) 1))));
				BgL_siza7eza7_14600 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14597, (int) (((long) 2))));
				BgL_i1247z00_14601 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14597, (int) (((long) 3))));
				BgL_bodyz00_14602 = PROCEDURE_REF(BgL_envz00_14597, (int) (((long) 4)));
				BgL_siza7ezd2framez75_14603 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14597, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_16968;

					BgL_bpz00_16968 = VECTOR_REF(((obj_t) BgL_sz00_14604), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_valza2za2_16969;

						BgL_valza2za2_16969 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14604,
							BgL_bpz00_16968, BgL_ifreesz00_14598);
						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_16970;

							BgL_runz00_16970 =
								MAKE_FX_PROCEDURE(BGl_z62run5721z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_16970,
								(int) (((long) 0)), BgL_iboxesz00_14599);
							PROCEDURE_SET(BgL_runz00_16970,
								(int) (((long) 1)), BINT(BgL_siza7eza7_14600));
							PROCEDURE_SET(BgL_runz00_16970,
								(int) (((long) 2)), BgL_valza2za2_16969);
							PROCEDURE_SET(BgL_runz00_16970,
								(int) (((long) 3)), ((obj_t) BgL_i1247z00_14601));
							PROCEDURE_SET(BgL_runz00_16970,
								(int) (((long) 4)), BgL_bodyz00_14602);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_16971;

								BgL_mainz00_16971 =
									MAKE_VA_PROCEDURE(BGl_z62main5720z62zz__evaluate_compz00,
									(int) (((long) -4)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_16971,
									(int) (((long) 0)), BgL_iboxesz00_14599);
								PROCEDURE_SET(BgL_mainz00_16971,
									(int) (((long) 1)), BINT(BgL_siza7eza7_14600));
								PROCEDURE_SET(BgL_mainz00_16971,
									(int) (((long) 2)), BgL_valza2za2_16969);
								PROCEDURE_SET(BgL_mainz00_16971,
									(int) (((long) 3)), ((obj_t) BgL_i1247z00_14601));
								PROCEDURE_SET(BgL_mainz00_16971,
									(int) (((long) 4)), BgL_bodyz00_14602);
								PROCEDURE_SET(BgL_mainz00_16971,
									(int) (((long) 5)), BgL_runz00_16970);
								PROCEDURE_SET(BgL_mainz00_16971,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_14603));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_16972;

									BgL_objz00_16972 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16970, BgL_objz00_16972);
									BgL_objz00_16972;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3802z00_16973;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3803z00_16974;

										BgL_arg3803z00_16974 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14601))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_16975;

											BgL_newz00_16975 =
												create_struct(BGl_symbol5815z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_28051;

												BgL_tmpz00_28051 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16975, BgL_tmpz00_28051,
													BgL_arg3803z00_16974);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_28056;
												int BgL_tmpz00_28054;

												BgL_auxz00_28056 = BINT(BgL_siza7ezd2framez75_14603);
												BgL_tmpz00_28054 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16975, BgL_tmpz00_28054,
													BgL_auxz00_28056);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_28059;

												BgL_tmpz00_28059 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16975, BgL_tmpz00_28059,
													BgL_runz00_16970);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_28064;
												int BgL_tmpz00_28062;

												BgL_auxz00_28064 = BINT(((long) -4));
												BgL_tmpz00_28062 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16975, BgL_tmpz00_28062,
													BgL_auxz00_28064);
											}
											BgL_arg3802z00_16973 = BgL_newz00_16975;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16971, BgL_arg3802z00_16973);
									BgL_arg3802z00_16973;
								}
								return BgL_mainz00_16971;
							}
						}
					}
				}
			}
		}

	}



/* &main5720 */
	obj_t BGl_z62main5720z62zz__evaluate_compz00(obj_t BgL_envz00_14605,
		obj_t BgL_bz00_14613, obj_t BgL_cz00_14614, obj_t BgL_dz00_14615,
		obj_t BgL_lastz00_14616)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14611;
				long BgL_siza7ezd2framez75_14612;

				BgL_runz00_14611 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14605, (int) (((long) 5))));
				BgL_siza7ezd2framez75_14612 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14605, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_16976;

					BgL_sz00_16976 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_16977;

						BgL_bpz00_16977 = VECTOR_REF(((obj_t) BgL_sz00_16976), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16977) + BgL_siza7ezd2framez75_14612) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16976))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3806z00_16978;

									BgL_arg3806z00_16978 =
										((long) CINT(BgL_bpz00_16977) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16976), BgL_arg3806z00_16978,
										BgL_bz00_14613);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3807z00_16979;

									BgL_arg3807z00_16979 =
										((long) CINT(BgL_bpz00_16977) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16976), BgL_arg3807z00_16979,
										BgL_cz00_14614);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3808z00_16980;

									BgL_arg3808z00_16980 =
										((long) CINT(BgL_bpz00_16977) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_16976), BgL_arg3808z00_16980,
										BgL_dz00_14615);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3809z00_16981;

									BgL_arg3809z00_16981 =
										((long) CINT(BgL_bpz00_16977) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_16976), BgL_arg3809z00_16981,
										BgL_lastz00_14616);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_16982;

									BgL_ez00_16982 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16982,
										BgL_bpz00_16977);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_16983;

										BgL_accz00_16983 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14611, BgL_sz00_16976, BgL_bpz00_16977);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16982);
										VECTOR_SET(
											((obj_t) BgL_sz00_16976), ((long) 0), BgL_bpz00_16977);
										return BgL_accz00_16983;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_16984;

								BgL_nsz00_16984 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16984, ((long) 1), BgL_sz00_16976);
								VECTOR_SET(BgL_nsz00_16984, ((long) 2), BgL_bz00_14613);
								VECTOR_SET(BgL_nsz00_16984, ((long) 3), BgL_cz00_14614);
								VECTOR_SET(BgL_nsz00_16984, ((long) 4), BgL_dz00_14615);
								VECTOR_SET(BgL_nsz00_16984, ((long) 5), BgL_lastz00_14616);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_16985;

									BgL_z12denvz12_16985 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16985, BgL_nsz00_16984);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_16986;

										BgL_ez00_16986 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16986,
											BgL_sz00_16976);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_16987;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_16988;

												BgL_savedzd2bpzd2_16988 =
													VECTOR_REF(BgL_nsz00_16984, ((long) 0));
												VECTOR_SET(BgL_nsz00_16984, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16990;

													BgL_fz00_16990 = BgL_runz00_14611;
												BgL_recz00_16989:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_16991;

														BgL_rz00_16991 =
															PROCEDURE_ENTRY(BgL_fz00_16990) (BgL_fz00_16990,
															BgL_nsz00_16984, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_test6614z00_28122;

															if (PROCEDUREP(BgL_rz00_16991))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1707z00_16992;

																	BgL_arg1707z00_16992 =
																		PROCEDURE_ATTR(BgL_rz00_16991);
																	if (STRUCTP(BgL_arg1707z00_16992))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6614z00_28122 =
																				(STRUCT_KEY(BgL_arg1707z00_16992) ==
																				BGl_symbol5794z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6614z00_28122 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_test6614z00_28122 = ((bool_t) 0);
																}
															if (BgL_test6614z00_28122)
																{
																	obj_t BgL_fz00_28130;

																	BgL_fz00_28130 = BgL_rz00_16991;
																	BgL_fz00_16990 = BgL_fz00_28130;
																	goto BgL_recz00_16989;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_16984, ((long) 0),
																		BgL_savedzd2bpzd2_16988);
																	BgL_____rz00_16987 = BgL_rz00_16991;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16986);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16985, BgL_sz00_16976);
											return BgL_____rz00_16987;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5721 */
	obj_t BGl_z62run5721z62zz__evaluate_compz00(obj_t BgL_envz00_14617,
		obj_t BgL_sz00_14623)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_14618;
				long BgL_siza7eza7_14619;
				obj_t BgL_valza2za2_14620;
				BgL_ev_absz00_bglt BgL_i1247z00_14621;
				obj_t BgL_bodyz00_14622;

				BgL_iboxesz00_14618 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14617, (int) (((long) 0))));
				BgL_siza7eza7_14619 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14617, (int) (((long) 1))));
				BgL_valza2za2_14620 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14617, (int) (((long) 2))));
				BgL_i1247z00_14621 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14617, (int) (((long) 3))));
				BgL_bodyz00_14622 = PROCEDURE_REF(BgL_envz00_14617, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_16993;

					BgL_bpz00_16993 = VECTOR_REF(((obj_t) BgL_sz00_14623), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14623,
						BgL_iboxesz00_14618, BgL_bpz00_16993);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14623,
						BgL_valza2za2_14620,
						((long) CINT(BgL_bpz00_16993) + BgL_siza7eza7_14619));
					{	/* Eval/evaluate_comp.scm 1088 */
						obj_t BgL_z12denvz12_16994;
						obj_t BgL_wherez00_16995;
						obj_t BgL_locz00_16996;

						BgL_z12denvz12_16994 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16995 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14621))->
							BgL_wherez00);
						BgL_locz00_16996 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14621))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1088 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16994, BgL_wherez00_16995,
								BgL_locz00_16996);
							{	/* Eval/evaluate_comp.scm 1088 */
								obj_t BgL_za2za2resza2za2z00_16997;

								BgL_za2za2resza2za2z00_16997 =
									PROCEDURE_ENTRY(BgL_bodyz00_14622) (BgL_bodyz00_14622,
									BgL_sz00_14623, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16994);
								return BgL_za2za2resza2za2z00_16997;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3720> */
	obj_t BGl_z62zc3z04anonymousza33720ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14624, obj_t BgL_sz00_14628)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1247z00_14625;
				obj_t BgL_bodyz00_14626;
				long BgL_siza7ezd2framez75_14627;

				BgL_i1247z00_14625 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14624, (int) (((long) 0))));
				BgL_bodyz00_14626 = PROCEDURE_REF(BgL_envz00_14624, (int) (((long) 1)));
				BgL_siza7ezd2framez75_14627 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14624, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_16998;

					BgL_bpz00_16998 = VECTOR_REF(((obj_t) BgL_sz00_14628), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */

						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_16999;

							BgL_runz00_16999 =
								MAKE_FX_PROCEDURE(BGl_z62run5723z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_16999,
								(int) (((long) 0)), ((obj_t) BgL_i1247z00_14625));
							PROCEDURE_SET(BgL_runz00_16999,
								(int) (((long) 1)), BgL_bodyz00_14626);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17000;

								BgL_mainz00_17000 =
									MAKE_FX_PROCEDURE(BGl_z62main5722z62zz__evaluate_compz00,
									(int) (((long) 3)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_17000,
									(int) (((long) 0)), ((obj_t) BgL_i1247z00_14625));
								PROCEDURE_SET(BgL_mainz00_17000,
									(int) (((long) 1)), BgL_bodyz00_14626);
								PROCEDURE_SET(BgL_mainz00_17000,
									(int) (((long) 2)), BgL_runz00_16999);
								PROCEDURE_SET(BgL_mainz00_17000,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_14627));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17001;

									BgL_objz00_17001 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16999, BgL_objz00_17001);
									BgL_objz00_17001;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3721z00_17002;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3722z00_17003;

										BgL_arg3722z00_17003 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14625))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17004;

											BgL_newz00_17004 =
												create_struct(BGl_symbol5815z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_28198;

												BgL_tmpz00_28198 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17004, BgL_tmpz00_28198,
													BgL_arg3722z00_17003);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_28203;
												int BgL_tmpz00_28201;

												BgL_auxz00_28203 = BINT(BgL_siza7ezd2framez75_14627);
												BgL_tmpz00_28201 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17004, BgL_tmpz00_28201,
													BgL_auxz00_28203);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_28206;

												BgL_tmpz00_28206 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17004, BgL_tmpz00_28206,
													BgL_runz00_16999);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_28211;
												int BgL_tmpz00_28209;

												BgL_auxz00_28211 = BINT(((long) 3));
												BgL_tmpz00_28209 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17004, BgL_tmpz00_28209,
													BgL_auxz00_28211);
											}
											BgL_arg3721z00_17002 = BgL_newz00_17004;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17000, BgL_arg3721z00_17002);
									BgL_arg3721z00_17002;
								}
								return BgL_mainz00_17000;
							}
						}
					}
				}
			}
		}

	}



/* &main5722 */
	obj_t BGl_z62main5722z62zz__evaluate_compz00(obj_t BgL_envz00_14629,
		obj_t BgL_bz00_14634, obj_t BgL_cz00_14635, obj_t BgL_dz00_14636)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14632;
				long BgL_siza7ezd2framez75_14633;

				BgL_runz00_14632 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14629, (int) (((long) 2))));
				BgL_siza7ezd2framez75_14633 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14629, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17005;

					BgL_sz00_17005 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17006;

						BgL_bpz00_17006 = VECTOR_REF(((obj_t) BgL_sz00_17005), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17006) + BgL_siza7ezd2framez75_14633) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17005))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3725z00_17007;

									BgL_arg3725z00_17007 =
										((long) CINT(BgL_bpz00_17006) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17005), BgL_arg3725z00_17007,
										BgL_bz00_14634);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3726z00_17008;

									BgL_arg3726z00_17008 =
										((long) CINT(BgL_bpz00_17006) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17005), BgL_arg3726z00_17008,
										BgL_cz00_14635);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3727z00_17009;

									BgL_arg3727z00_17009 =
										((long) CINT(BgL_bpz00_17006) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_17005), BgL_arg3727z00_17009,
										BgL_dz00_14636);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17010;

									BgL_ez00_17010 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17010,
										BgL_bpz00_17006);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17011;

										BgL_accz00_17011 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14632, BgL_sz00_17005, BgL_bpz00_17006);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17010);
										VECTOR_SET(
											((obj_t) BgL_sz00_17005), ((long) 0), BgL_bpz00_17006);
										return BgL_accz00_17011;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17012;

								BgL_nsz00_17012 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17012, ((long) 1), BgL_sz00_17005);
								VECTOR_SET(BgL_nsz00_17012, ((long) 2), BgL_bz00_14634);
								VECTOR_SET(BgL_nsz00_17012, ((long) 3), BgL_cz00_14635);
								VECTOR_SET(BgL_nsz00_17012, ((long) 4), BgL_dz00_14636);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17013;

									BgL_z12denvz12_17013 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17013, BgL_nsz00_17012);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17014;

										BgL_ez00_17014 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17014,
											BgL_sz00_17005);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17015;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17016;

												BgL_savedzd2bpzd2_17016 =
													VECTOR_REF(BgL_nsz00_17012, ((long) 0));
												VECTOR_SET(BgL_nsz00_17012, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17018;

													BgL_fz00_17018 = BgL_runz00_14632;
												BgL_recz00_17017:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17019;

														BgL_rz00_17019 =
															PROCEDURE_ENTRY(BgL_fz00_17018) (BgL_fz00_17018,
															BgL_nsz00_17012, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_test6618z00_28264;

															if (PROCEDUREP(BgL_rz00_17019))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1707z00_17020;

																	BgL_arg1707z00_17020 =
																		PROCEDURE_ATTR(BgL_rz00_17019);
																	if (STRUCTP(BgL_arg1707z00_17020))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6618z00_28264 =
																				(STRUCT_KEY(BgL_arg1707z00_17020) ==
																				BGl_symbol5794z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6618z00_28264 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_test6618z00_28264 = ((bool_t) 0);
																}
															if (BgL_test6618z00_28264)
																{
																	obj_t BgL_fz00_28272;

																	BgL_fz00_28272 = BgL_rz00_17019;
																	BgL_fz00_17018 = BgL_fz00_28272;
																	goto BgL_recz00_17017;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17012, ((long) 0),
																		BgL_savedzd2bpzd2_17016);
																	BgL_____rz00_17015 = BgL_rz00_17019;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17014);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17013, BgL_sz00_17005);
											return BgL_____rz00_17015;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5723 */
	obj_t BGl_z62run5723z62zz__evaluate_compz00(obj_t BgL_envz00_14637,
		obj_t BgL_sz00_14640)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1247z00_14638;
				obj_t BgL_bodyz00_14639;

				BgL_i1247z00_14638 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14637, (int) (((long) 0))));
				BgL_bodyz00_14639 = PROCEDURE_REF(BgL_envz00_14637, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17021;

					BgL_bpz00_17021 = VECTOR_REF(((obj_t) BgL_sz00_14640), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_z12denvz12_17022;
						obj_t BgL_wherez00_17023;
						obj_t BgL_locz00_17024;

						BgL_z12denvz12_17022 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17023 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14638))->
							BgL_wherez00);
						BgL_locz00_17024 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14638))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1167 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17022, BgL_wherez00_17023,
								BgL_locz00_17024);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_za2za2resza2za2z00_17025;

								BgL_za2za2resza2za2z00_17025 =
									PROCEDURE_ENTRY(BgL_bodyz00_14639) (BgL_bodyz00_14639,
									BgL_sz00_14640, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17022);
								return BgL_za2za2resza2za2z00_17025;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3729> */
	obj_t BGl_z62zc3z04anonymousza33729ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14641, obj_t BgL_sz00_14646)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_14642;
				BgL_ev_absz00_bglt BgL_i1247z00_14643;
				obj_t BgL_bodyz00_14644;
				long BgL_siza7ezd2framez75_14645;

				BgL_iboxesz00_14642 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14641, (int) (((long) 0))));
				BgL_i1247z00_14643 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14641, (int) (((long) 1))));
				BgL_bodyz00_14644 = PROCEDURE_REF(BgL_envz00_14641, (int) (((long) 2)));
				BgL_siza7ezd2framez75_14645 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14641, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17026;

					BgL_bpz00_17026 = VECTOR_REF(((obj_t) BgL_sz00_14646), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */

						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17027;

							BgL_runz00_17027 =
								MAKE_FX_PROCEDURE(BGl_z62run5725z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_17027,
								(int) (((long) 0)), BgL_iboxesz00_14642);
							PROCEDURE_SET(BgL_runz00_17027,
								(int) (((long) 1)), ((obj_t) BgL_i1247z00_14643));
							PROCEDURE_SET(BgL_runz00_17027,
								(int) (((long) 2)), BgL_bodyz00_14644);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17028;

								BgL_mainz00_17028 =
									MAKE_FX_PROCEDURE(BGl_z62main5724z62zz__evaluate_compz00,
									(int) (((long) 3)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_17028,
									(int) (((long) 0)), BgL_iboxesz00_14642);
								PROCEDURE_SET(BgL_mainz00_17028,
									(int) (((long) 1)), ((obj_t) BgL_i1247z00_14643));
								PROCEDURE_SET(BgL_mainz00_17028,
									(int) (((long) 2)), BgL_bodyz00_14644);
								PROCEDURE_SET(BgL_mainz00_17028,
									(int) (((long) 3)), BgL_runz00_17027);
								PROCEDURE_SET(BgL_mainz00_17028,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_14645));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17029;

									BgL_objz00_17029 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17027, BgL_objz00_17029);
									BgL_objz00_17029;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3730z00_17030;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3731z00_17031;

										BgL_arg3731z00_17031 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14643))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17032;

											BgL_newz00_17032 =
												create_struct(BGl_symbol5815z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_28334;

												BgL_tmpz00_28334 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17032, BgL_tmpz00_28334,
													BgL_arg3731z00_17031);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_28339;
												int BgL_tmpz00_28337;

												BgL_auxz00_28339 = BINT(BgL_siza7ezd2framez75_14645);
												BgL_tmpz00_28337 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17032, BgL_tmpz00_28337,
													BgL_auxz00_28339);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_28342;

												BgL_tmpz00_28342 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17032, BgL_tmpz00_28342,
													BgL_runz00_17027);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_28347;
												int BgL_tmpz00_28345;

												BgL_auxz00_28347 = BINT(((long) 3));
												BgL_tmpz00_28345 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17032, BgL_tmpz00_28345,
													BgL_auxz00_28347);
											}
											BgL_arg3730z00_17030 = BgL_newz00_17032;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17028, BgL_arg3730z00_17030);
									BgL_arg3730z00_17030;
								}
								return BgL_mainz00_17028;
							}
						}
					}
				}
			}
		}

	}



/* &main5724 */
	obj_t BGl_z62main5724z62zz__evaluate_compz00(obj_t BgL_envz00_14647,
		obj_t BgL_bz00_14653, obj_t BgL_cz00_14654, obj_t BgL_dz00_14655)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14651;
				long BgL_siza7ezd2framez75_14652;

				BgL_runz00_14651 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14647, (int) (((long) 3))));
				BgL_siza7ezd2framez75_14652 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14647, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17033;

					BgL_sz00_17033 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17034;

						BgL_bpz00_17034 = VECTOR_REF(((obj_t) BgL_sz00_17033), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17034) + BgL_siza7ezd2framez75_14652) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17033))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3734z00_17035;

									BgL_arg3734z00_17035 =
										((long) CINT(BgL_bpz00_17034) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17033), BgL_arg3734z00_17035,
										BgL_bz00_14653);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3735z00_17036;

									BgL_arg3735z00_17036 =
										((long) CINT(BgL_bpz00_17034) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17033), BgL_arg3735z00_17036,
										BgL_cz00_14654);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3736z00_17037;

									BgL_arg3736z00_17037 =
										((long) CINT(BgL_bpz00_17034) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_17033), BgL_arg3736z00_17037,
										BgL_dz00_14655);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17038;

									BgL_ez00_17038 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17038,
										BgL_bpz00_17034);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17039;

										BgL_accz00_17039 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14651, BgL_sz00_17033, BgL_bpz00_17034);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17038);
										VECTOR_SET(
											((obj_t) BgL_sz00_17033), ((long) 0), BgL_bpz00_17034);
										return BgL_accz00_17039;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17040;

								BgL_nsz00_17040 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17040, ((long) 1), BgL_sz00_17033);
								VECTOR_SET(BgL_nsz00_17040, ((long) 2), BgL_bz00_14653);
								VECTOR_SET(BgL_nsz00_17040, ((long) 3), BgL_cz00_14654);
								VECTOR_SET(BgL_nsz00_17040, ((long) 4), BgL_dz00_14655);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17041;

									BgL_z12denvz12_17041 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17041, BgL_nsz00_17040);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17042;

										BgL_ez00_17042 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17042,
											BgL_sz00_17033);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17043;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17044;

												BgL_savedzd2bpzd2_17044 =
													VECTOR_REF(BgL_nsz00_17040, ((long) 0));
												VECTOR_SET(BgL_nsz00_17040, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17046;

													BgL_fz00_17046 = BgL_runz00_14651;
												BgL_recz00_17045:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17047;

														BgL_rz00_17047 =
															PROCEDURE_ENTRY(BgL_fz00_17046) (BgL_fz00_17046,
															BgL_nsz00_17040, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_test6622z00_28400;

															if (PROCEDUREP(BgL_rz00_17047))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1707z00_17048;

																	BgL_arg1707z00_17048 =
																		PROCEDURE_ATTR(BgL_rz00_17047);
																	if (STRUCTP(BgL_arg1707z00_17048))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6622z00_28400 =
																				(STRUCT_KEY(BgL_arg1707z00_17048) ==
																				BGl_symbol5794z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6622z00_28400 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_test6622z00_28400 = ((bool_t) 0);
																}
															if (BgL_test6622z00_28400)
																{
																	obj_t BgL_fz00_28408;

																	BgL_fz00_28408 = BgL_rz00_17047;
																	BgL_fz00_17046 = BgL_fz00_28408;
																	goto BgL_recz00_17045;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17040, ((long) 0),
																		BgL_savedzd2bpzd2_17044);
																	BgL_____rz00_17043 = BgL_rz00_17047;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17042);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17041, BgL_sz00_17033);
											return BgL_____rz00_17043;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5725 */
	obj_t BGl_z62run5725z62zz__evaluate_compz00(obj_t BgL_envz00_14656,
		obj_t BgL_sz00_14660)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_14657;
				BgL_ev_absz00_bglt BgL_i1247z00_14658;
				obj_t BgL_bodyz00_14659;

				BgL_iboxesz00_14657 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14656, (int) (((long) 0))));
				BgL_i1247z00_14658 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14656, (int) (((long) 1))));
				BgL_bodyz00_14659 = PROCEDURE_REF(BgL_envz00_14656, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17049;

					BgL_bpz00_17049 = VECTOR_REF(((obj_t) BgL_sz00_14660), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14660,
						BgL_iboxesz00_14657, BgL_bpz00_17049);
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_z12denvz12_17050;
						obj_t BgL_wherez00_17051;
						obj_t BgL_locz00_17052;

						BgL_z12denvz12_17050 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17051 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14658))->
							BgL_wherez00);
						BgL_locz00_17052 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14658))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1167 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17050, BgL_wherez00_17051,
								BgL_locz00_17052);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_za2za2resza2za2z00_17053;

								BgL_za2za2resza2za2z00_17053 =
									PROCEDURE_ENTRY(BgL_bodyz00_14659) (BgL_bodyz00_14659,
									BgL_sz00_14660, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17050);
								return BgL_za2za2resza2za2z00_17053;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3741> */
	obj_t BGl_z62zc3z04anonymousza33741ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14661, obj_t BgL_sz00_14667)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_ifreesz00_14662;
				long BgL_siza7eza7_14663;
				BgL_ev_absz00_bglt BgL_i1247z00_14664;
				obj_t BgL_bodyz00_14665;
				long BgL_siza7ezd2framez75_14666;

				BgL_ifreesz00_14662 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14661, (int) (((long) 0))));
				BgL_siza7eza7_14663 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14661, (int) (((long) 1))));
				BgL_i1247z00_14664 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14661, (int) (((long) 2))));
				BgL_bodyz00_14665 = PROCEDURE_REF(BgL_envz00_14661, (int) (((long) 3)));
				BgL_siza7ezd2framez75_14666 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14661, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17054;

					BgL_bpz00_17054 = VECTOR_REF(((obj_t) BgL_sz00_14667), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_valza2za2_17055;

						BgL_valza2za2_17055 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14667,
							BgL_bpz00_17054, BgL_ifreesz00_14662);
						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17056;

							BgL_runz00_17056 =
								MAKE_FX_PROCEDURE(BGl_z62run5727z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_17056,
								(int) (((long) 0)), BINT(BgL_siza7eza7_14663));
							PROCEDURE_SET(BgL_runz00_17056,
								(int) (((long) 1)), BgL_valza2za2_17055);
							PROCEDURE_SET(BgL_runz00_17056,
								(int) (((long) 2)), ((obj_t) BgL_i1247z00_14664));
							PROCEDURE_SET(BgL_runz00_17056,
								(int) (((long) 3)), BgL_bodyz00_14665);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17057;

								BgL_mainz00_17057 =
									MAKE_FX_PROCEDURE(BGl_z62main5726z62zz__evaluate_compz00,
									(int) (((long) 3)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_17057,
									(int) (((long) 0)), BINT(BgL_siza7eza7_14663));
								PROCEDURE_SET(BgL_mainz00_17057,
									(int) (((long) 1)), BgL_valza2za2_17055);
								PROCEDURE_SET(BgL_mainz00_17057,
									(int) (((long) 2)), ((obj_t) BgL_i1247z00_14664));
								PROCEDURE_SET(BgL_mainz00_17057,
									(int) (((long) 3)), BgL_bodyz00_14665);
								PROCEDURE_SET(BgL_mainz00_17057,
									(int) (((long) 4)), BgL_runz00_17056);
								PROCEDURE_SET(BgL_mainz00_17057,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_14666));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17058;

									BgL_objz00_17058 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17056, BgL_objz00_17058);
									BgL_objz00_17058;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3742z00_17059;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3743z00_17060;

										BgL_arg3743z00_17060 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14664))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17061;

											BgL_newz00_17061 =
												create_struct(BGl_symbol5815z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_28484;

												BgL_tmpz00_28484 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17061, BgL_tmpz00_28484,
													BgL_arg3743z00_17060);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_28489;
												int BgL_tmpz00_28487;

												BgL_auxz00_28489 = BINT(BgL_siza7ezd2framez75_14666);
												BgL_tmpz00_28487 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17061, BgL_tmpz00_28487,
													BgL_auxz00_28489);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_28492;

												BgL_tmpz00_28492 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17061, BgL_tmpz00_28492,
													BgL_runz00_17056);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_28497;
												int BgL_tmpz00_28495;

												BgL_auxz00_28497 = BINT(((long) 3));
												BgL_tmpz00_28495 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17061, BgL_tmpz00_28495,
													BgL_auxz00_28497);
											}
											BgL_arg3742z00_17059 = BgL_newz00_17061;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17057, BgL_arg3742z00_17059);
									BgL_arg3742z00_17059;
								}
								return BgL_mainz00_17057;
							}
						}
					}
				}
			}
		}

	}



/* &main5726 */
	obj_t BGl_z62main5726z62zz__evaluate_compz00(obj_t BgL_envz00_14668,
		obj_t BgL_bz00_14675, obj_t BgL_cz00_14676, obj_t BgL_dz00_14677)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14673;
				long BgL_siza7ezd2framez75_14674;

				BgL_runz00_14673 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14668, (int) (((long) 4))));
				BgL_siza7ezd2framez75_14674 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14668, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17062;

					BgL_sz00_17062 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17063;

						BgL_bpz00_17063 = VECTOR_REF(((obj_t) BgL_sz00_17062), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17063) + BgL_siza7ezd2framez75_14674) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17062))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3746z00_17064;

									BgL_arg3746z00_17064 =
										((long) CINT(BgL_bpz00_17063) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17062), BgL_arg3746z00_17064,
										BgL_bz00_14675);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3747z00_17065;

									BgL_arg3747z00_17065 =
										((long) CINT(BgL_bpz00_17063) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17062), BgL_arg3747z00_17065,
										BgL_cz00_14676);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3748z00_17066;

									BgL_arg3748z00_17066 =
										((long) CINT(BgL_bpz00_17063) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_17062), BgL_arg3748z00_17066,
										BgL_dz00_14677);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17067;

									BgL_ez00_17067 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17067,
										BgL_bpz00_17063);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17068;

										BgL_accz00_17068 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14673, BgL_sz00_17062, BgL_bpz00_17063);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17067);
										VECTOR_SET(
											((obj_t) BgL_sz00_17062), ((long) 0), BgL_bpz00_17063);
										return BgL_accz00_17068;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17069;

								BgL_nsz00_17069 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17069, ((long) 1), BgL_sz00_17062);
								VECTOR_SET(BgL_nsz00_17069, ((long) 2), BgL_bz00_14675);
								VECTOR_SET(BgL_nsz00_17069, ((long) 3), BgL_cz00_14676);
								VECTOR_SET(BgL_nsz00_17069, ((long) 4), BgL_dz00_14677);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17070;

									BgL_z12denvz12_17070 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17070, BgL_nsz00_17069);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17071;

										BgL_ez00_17071 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17071,
											BgL_sz00_17062);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17072;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17073;

												BgL_savedzd2bpzd2_17073 =
													VECTOR_REF(BgL_nsz00_17069, ((long) 0));
												VECTOR_SET(BgL_nsz00_17069, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17075;

													BgL_fz00_17075 = BgL_runz00_14673;
												BgL_recz00_17074:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17076;

														BgL_rz00_17076 =
															PROCEDURE_ENTRY(BgL_fz00_17075) (BgL_fz00_17075,
															BgL_nsz00_17069, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_test6626z00_28550;

															if (PROCEDUREP(BgL_rz00_17076))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1707z00_17077;

																	BgL_arg1707z00_17077 =
																		PROCEDURE_ATTR(BgL_rz00_17076);
																	if (STRUCTP(BgL_arg1707z00_17077))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6626z00_28550 =
																				(STRUCT_KEY(BgL_arg1707z00_17077) ==
																				BGl_symbol5794z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6626z00_28550 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_test6626z00_28550 = ((bool_t) 0);
																}
															if (BgL_test6626z00_28550)
																{
																	obj_t BgL_fz00_28558;

																	BgL_fz00_28558 = BgL_rz00_17076;
																	BgL_fz00_17075 = BgL_fz00_28558;
																	goto BgL_recz00_17074;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17069, ((long) 0),
																		BgL_savedzd2bpzd2_17073);
																	BgL_____rz00_17072 = BgL_rz00_17076;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17071);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17070, BgL_sz00_17062);
											return BgL_____rz00_17072;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5727 */
	obj_t BGl_z62run5727z62zz__evaluate_compz00(obj_t BgL_envz00_14678,
		obj_t BgL_sz00_14683)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				long BgL_siza7eza7_14679;
				obj_t BgL_valza2za2_14680;
				BgL_ev_absz00_bglt BgL_i1247z00_14681;
				obj_t BgL_bodyz00_14682;

				BgL_siza7eza7_14679 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14678, (int) (((long) 0))));
				BgL_valza2za2_14680 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14678, (int) (((long) 1))));
				BgL_i1247z00_14681 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14678, (int) (((long) 2))));
				BgL_bodyz00_14682 = PROCEDURE_REF(BgL_envz00_14678, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17078;

					BgL_bpz00_17078 = VECTOR_REF(((obj_t) BgL_sz00_14683), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14683,
						BgL_valza2za2_14680,
						((long) CINT(BgL_bpz00_17078) + BgL_siza7eza7_14679));
					{	/* Eval/evaluate_comp.scm 1088 */
						obj_t BgL_z12denvz12_17079;
						obj_t BgL_wherez00_17080;
						obj_t BgL_locz00_17081;

						BgL_z12denvz12_17079 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17080 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14681))->
							BgL_wherez00);
						BgL_locz00_17081 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14681))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1088 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17079, BgL_wherez00_17080,
								BgL_locz00_17081);
							{	/* Eval/evaluate_comp.scm 1088 */
								obj_t BgL_za2za2resza2za2z00_17082;

								BgL_za2za2resza2za2z00_17082 =
									PROCEDURE_ENTRY(BgL_bodyz00_14682) (BgL_bodyz00_14682,
									BgL_sz00_14683, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17079);
								return BgL_za2za2resza2za2z00_17082;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3751> */
	obj_t BGl_z62zc3z04anonymousza33751ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14684, obj_t BgL_sz00_14691)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_ifreesz00_14685;
				obj_t BgL_iboxesz00_14686;
				long BgL_siza7eza7_14687;
				BgL_ev_absz00_bglt BgL_i1247z00_14688;
				obj_t BgL_bodyz00_14689;
				long BgL_siza7ezd2framez75_14690;

				BgL_ifreesz00_14685 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14684, (int) (((long) 0))));
				BgL_iboxesz00_14686 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14684, (int) (((long) 1))));
				BgL_siza7eza7_14687 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14684, (int) (((long) 2))));
				BgL_i1247z00_14688 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14684, (int) (((long) 3))));
				BgL_bodyz00_14689 = PROCEDURE_REF(BgL_envz00_14684, (int) (((long) 4)));
				BgL_siza7ezd2framez75_14690 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14684, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17083;

					BgL_bpz00_17083 = VECTOR_REF(((obj_t) BgL_sz00_14691), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_valza2za2_17084;

						BgL_valza2za2_17084 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14691,
							BgL_bpz00_17083, BgL_ifreesz00_14685);
						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17085;

							BgL_runz00_17085 =
								MAKE_FX_PROCEDURE(BGl_z62run5729z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_17085,
								(int) (((long) 0)), BgL_iboxesz00_14686);
							PROCEDURE_SET(BgL_runz00_17085,
								(int) (((long) 1)), BINT(BgL_siza7eza7_14687));
							PROCEDURE_SET(BgL_runz00_17085,
								(int) (((long) 2)), BgL_valza2za2_17084);
							PROCEDURE_SET(BgL_runz00_17085,
								(int) (((long) 3)), ((obj_t) BgL_i1247z00_14688));
							PROCEDURE_SET(BgL_runz00_17085,
								(int) (((long) 4)), BgL_bodyz00_14689);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17086;

								BgL_mainz00_17086 =
									MAKE_FX_PROCEDURE(BGl_z62main5728z62zz__evaluate_compz00,
									(int) (((long) 3)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_17086,
									(int) (((long) 0)), BgL_iboxesz00_14686);
								PROCEDURE_SET(BgL_mainz00_17086,
									(int) (((long) 1)), BINT(BgL_siza7eza7_14687));
								PROCEDURE_SET(BgL_mainz00_17086,
									(int) (((long) 2)), BgL_valza2za2_17084);
								PROCEDURE_SET(BgL_mainz00_17086,
									(int) (((long) 3)), ((obj_t) BgL_i1247z00_14688));
								PROCEDURE_SET(BgL_mainz00_17086,
									(int) (((long) 4)), BgL_bodyz00_14689);
								PROCEDURE_SET(BgL_mainz00_17086,
									(int) (((long) 5)), BgL_runz00_17085);
								PROCEDURE_SET(BgL_mainz00_17086,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_14690));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17087;

									BgL_objz00_17087 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17085, BgL_objz00_17087);
									BgL_objz00_17087;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3752z00_17088;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3753z00_17089;

										BgL_arg3753z00_17089 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14688))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17090;

											BgL_newz00_17090 =
												create_struct(BGl_symbol5815z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_28646;

												BgL_tmpz00_28646 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17090, BgL_tmpz00_28646,
													BgL_arg3753z00_17089);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_28651;
												int BgL_tmpz00_28649;

												BgL_auxz00_28651 = BINT(BgL_siza7ezd2framez75_14690);
												BgL_tmpz00_28649 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17090, BgL_tmpz00_28649,
													BgL_auxz00_28651);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_28654;

												BgL_tmpz00_28654 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17090, BgL_tmpz00_28654,
													BgL_runz00_17085);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_28659;
												int BgL_tmpz00_28657;

												BgL_auxz00_28659 = BINT(((long) 3));
												BgL_tmpz00_28657 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17090, BgL_tmpz00_28657,
													BgL_auxz00_28659);
											}
											BgL_arg3752z00_17088 = BgL_newz00_17090;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17086, BgL_arg3752z00_17088);
									BgL_arg3752z00_17088;
								}
								return BgL_mainz00_17086;
							}
						}
					}
				}
			}
		}

	}



/* &main5728 */
	obj_t BGl_z62main5728z62zz__evaluate_compz00(obj_t BgL_envz00_14692,
		obj_t BgL_bz00_14700, obj_t BgL_cz00_14701, obj_t BgL_dz00_14702)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14698;
				long BgL_siza7ezd2framez75_14699;

				BgL_runz00_14698 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14692, (int) (((long) 5))));
				BgL_siza7ezd2framez75_14699 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14692, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17091;

					BgL_sz00_17091 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17092;

						BgL_bpz00_17092 = VECTOR_REF(((obj_t) BgL_sz00_17091), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17092) + BgL_siza7ezd2framez75_14699) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17091))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3756z00_17093;

									BgL_arg3756z00_17093 =
										((long) CINT(BgL_bpz00_17092) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17091), BgL_arg3756z00_17093,
										BgL_bz00_14700);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3757z00_17094;

									BgL_arg3757z00_17094 =
										((long) CINT(BgL_bpz00_17092) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17091), BgL_arg3757z00_17094,
										BgL_cz00_14701);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3758z00_17095;

									BgL_arg3758z00_17095 =
										((long) CINT(BgL_bpz00_17092) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_17091), BgL_arg3758z00_17095,
										BgL_dz00_14702);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17096;

									BgL_ez00_17096 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17096,
										BgL_bpz00_17092);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17097;

										BgL_accz00_17097 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14698, BgL_sz00_17091, BgL_bpz00_17092);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17096);
										VECTOR_SET(
											((obj_t) BgL_sz00_17091), ((long) 0), BgL_bpz00_17092);
										return BgL_accz00_17097;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17098;

								BgL_nsz00_17098 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17098, ((long) 1), BgL_sz00_17091);
								VECTOR_SET(BgL_nsz00_17098, ((long) 2), BgL_bz00_14700);
								VECTOR_SET(BgL_nsz00_17098, ((long) 3), BgL_cz00_14701);
								VECTOR_SET(BgL_nsz00_17098, ((long) 4), BgL_dz00_14702);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17099;

									BgL_z12denvz12_17099 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17099, BgL_nsz00_17098);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17100;

										BgL_ez00_17100 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17100,
											BgL_sz00_17091);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17101;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17102;

												BgL_savedzd2bpzd2_17102 =
													VECTOR_REF(BgL_nsz00_17098, ((long) 0));
												VECTOR_SET(BgL_nsz00_17098, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17104;

													BgL_fz00_17104 = BgL_runz00_14698;
												BgL_recz00_17103:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17105;

														BgL_rz00_17105 =
															PROCEDURE_ENTRY(BgL_fz00_17104) (BgL_fz00_17104,
															BgL_nsz00_17098, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_test6630z00_28712;

															if (PROCEDUREP(BgL_rz00_17105))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1707z00_17106;

																	BgL_arg1707z00_17106 =
																		PROCEDURE_ATTR(BgL_rz00_17105);
																	if (STRUCTP(BgL_arg1707z00_17106))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6630z00_28712 =
																				(STRUCT_KEY(BgL_arg1707z00_17106) ==
																				BGl_symbol5794z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6630z00_28712 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_test6630z00_28712 = ((bool_t) 0);
																}
															if (BgL_test6630z00_28712)
																{
																	obj_t BgL_fz00_28720;

																	BgL_fz00_28720 = BgL_rz00_17105;
																	BgL_fz00_17104 = BgL_fz00_28720;
																	goto BgL_recz00_17103;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17098, ((long) 0),
																		BgL_savedzd2bpzd2_17102);
																	BgL_____rz00_17101 = BgL_rz00_17105;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17100);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17099, BgL_sz00_17091);
											return BgL_____rz00_17101;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5729 */
	obj_t BGl_z62run5729z62zz__evaluate_compz00(obj_t BgL_envz00_14703,
		obj_t BgL_sz00_14709)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_14704;
				long BgL_siza7eza7_14705;
				obj_t BgL_valza2za2_14706;
				BgL_ev_absz00_bglt BgL_i1247z00_14707;
				obj_t BgL_bodyz00_14708;

				BgL_iboxesz00_14704 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14703, (int) (((long) 0))));
				BgL_siza7eza7_14705 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14703, (int) (((long) 1))));
				BgL_valza2za2_14706 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14703, (int) (((long) 2))));
				BgL_i1247z00_14707 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14703, (int) (((long) 3))));
				BgL_bodyz00_14708 = PROCEDURE_REF(BgL_envz00_14703, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17107;

					BgL_bpz00_17107 = VECTOR_REF(((obj_t) BgL_sz00_14709), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14709,
						BgL_iboxesz00_14704, BgL_bpz00_17107);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14709,
						BgL_valza2za2_14706,
						((long) CINT(BgL_bpz00_17107) + BgL_siza7eza7_14705));
					{	/* Eval/evaluate_comp.scm 1088 */
						obj_t BgL_z12denvz12_17108;
						obj_t BgL_wherez00_17109;
						obj_t BgL_locz00_17110;

						BgL_z12denvz12_17108 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17109 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14707))->
							BgL_wherez00);
						BgL_locz00_17110 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14707))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1088 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17108, BgL_wherez00_17109,
								BgL_locz00_17110);
							{	/* Eval/evaluate_comp.scm 1088 */
								obj_t BgL_za2za2resza2za2z00_17111;

								BgL_za2za2resza2za2z00_17111 =
									PROCEDURE_ENTRY(BgL_bodyz00_14708) (BgL_bodyz00_14708,
									BgL_sz00_14709, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17108);
								return BgL_za2za2resza2za2z00_17111;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3669> */
	obj_t BGl_z62zc3z04anonymousza33669ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14710, obj_t BgL_sz00_14714)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1247z00_14711;
				obj_t BgL_bodyz00_14712;
				long BgL_siza7ezd2framez75_14713;

				BgL_i1247z00_14711 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14710, (int) (((long) 0))));
				BgL_bodyz00_14712 = PROCEDURE_REF(BgL_envz00_14710, (int) (((long) 1)));
				BgL_siza7ezd2framez75_14713 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14710, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17112;

					BgL_bpz00_17112 = VECTOR_REF(((obj_t) BgL_sz00_14714), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */

						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17113;

							BgL_runz00_17113 =
								MAKE_FX_PROCEDURE(BGl_z62run5731z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_17113,
								(int) (((long) 0)), ((obj_t) BgL_i1247z00_14711));
							PROCEDURE_SET(BgL_runz00_17113,
								(int) (((long) 1)), BgL_bodyz00_14712);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17114;

								BgL_mainz00_17114 =
									MAKE_VA_PROCEDURE(BGl_z62main5730z62zz__evaluate_compz00,
									(int) (((long) -3)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_17114,
									(int) (((long) 0)), ((obj_t) BgL_i1247z00_14711));
								PROCEDURE_SET(BgL_mainz00_17114,
									(int) (((long) 1)), BgL_bodyz00_14712);
								PROCEDURE_SET(BgL_mainz00_17114,
									(int) (((long) 2)), BgL_runz00_17113);
								PROCEDURE_SET(BgL_mainz00_17114,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_14713));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17115;

									BgL_objz00_17115 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17113, BgL_objz00_17115);
									BgL_objz00_17115;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3670z00_17116;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3671z00_17117;

										BgL_arg3671z00_17117 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14711))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17118;

											BgL_newz00_17118 =
												create_struct(BGl_symbol5815z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_28788;

												BgL_tmpz00_28788 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17118, BgL_tmpz00_28788,
													BgL_arg3671z00_17117);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_28793;
												int BgL_tmpz00_28791;

												BgL_auxz00_28793 = BINT(BgL_siza7ezd2framez75_14713);
												BgL_tmpz00_28791 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17118, BgL_tmpz00_28791,
													BgL_auxz00_28793);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_28796;

												BgL_tmpz00_28796 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17118, BgL_tmpz00_28796,
													BgL_runz00_17113);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_28801;
												int BgL_tmpz00_28799;

												BgL_auxz00_28801 = BINT(((long) -3));
												BgL_tmpz00_28799 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17118, BgL_tmpz00_28799,
													BgL_auxz00_28801);
											}
											BgL_arg3670z00_17116 = BgL_newz00_17118;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17114, BgL_arg3670z00_17116);
									BgL_arg3670z00_17116;
								}
								return BgL_mainz00_17114;
							}
						}
					}
				}
			}
		}

	}



/* &main5730 */
	obj_t BGl_z62main5730z62zz__evaluate_compz00(obj_t BgL_envz00_14715,
		obj_t BgL_cz00_14720, obj_t BgL_dz00_14721, obj_t BgL_lastz00_14722)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14718;
				long BgL_siza7ezd2framez75_14719;

				BgL_runz00_14718 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14715, (int) (((long) 2))));
				BgL_siza7ezd2framez75_14719 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14715, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17119;

					BgL_sz00_17119 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17120;

						BgL_bpz00_17120 = VECTOR_REF(((obj_t) BgL_sz00_17119), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17120) + BgL_siza7ezd2framez75_14719) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17119))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3674z00_17121;

									BgL_arg3674z00_17121 =
										((long) CINT(BgL_bpz00_17120) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17119), BgL_arg3674z00_17121,
										BgL_cz00_14720);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3675z00_17122;

									BgL_arg3675z00_17122 =
										((long) CINT(BgL_bpz00_17120) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17119), BgL_arg3675z00_17122,
										BgL_dz00_14721);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3676z00_17123;

									BgL_arg3676z00_17123 =
										((long) CINT(BgL_bpz00_17120) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_17119), BgL_arg3676z00_17123,
										BgL_lastz00_14722);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17124;

									BgL_ez00_17124 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17124,
										BgL_bpz00_17120);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17125;

										BgL_accz00_17125 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14718, BgL_sz00_17119, BgL_bpz00_17120);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17124);
										VECTOR_SET(
											((obj_t) BgL_sz00_17119), ((long) 0), BgL_bpz00_17120);
										return BgL_accz00_17125;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17126;

								BgL_nsz00_17126 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17126, ((long) 1), BgL_sz00_17119);
								VECTOR_SET(BgL_nsz00_17126, ((long) 2), BgL_cz00_14720);
								VECTOR_SET(BgL_nsz00_17126, ((long) 3), BgL_dz00_14721);
								VECTOR_SET(BgL_nsz00_17126, ((long) 4), BgL_lastz00_14722);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17127;

									BgL_z12denvz12_17127 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17127, BgL_nsz00_17126);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17128;

										BgL_ez00_17128 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17128,
											BgL_sz00_17119);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17129;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17130;

												BgL_savedzd2bpzd2_17130 =
													VECTOR_REF(BgL_nsz00_17126, ((long) 0));
												VECTOR_SET(BgL_nsz00_17126, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17132;

													BgL_fz00_17132 = BgL_runz00_14718;
												BgL_recz00_17131:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17133;

														BgL_rz00_17133 =
															PROCEDURE_ENTRY(BgL_fz00_17132) (BgL_fz00_17132,
															BgL_nsz00_17126, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_test6634z00_28854;

															if (PROCEDUREP(BgL_rz00_17133))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1707z00_17134;

																	BgL_arg1707z00_17134 =
																		PROCEDURE_ATTR(BgL_rz00_17133);
																	if (STRUCTP(BgL_arg1707z00_17134))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6634z00_28854 =
																				(STRUCT_KEY(BgL_arg1707z00_17134) ==
																				BGl_symbol5794z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6634z00_28854 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_test6634z00_28854 = ((bool_t) 0);
																}
															if (BgL_test6634z00_28854)
																{
																	obj_t BgL_fz00_28862;

																	BgL_fz00_28862 = BgL_rz00_17133;
																	BgL_fz00_17132 = BgL_fz00_28862;
																	goto BgL_recz00_17131;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17126, ((long) 0),
																		BgL_savedzd2bpzd2_17130);
																	BgL_____rz00_17129 = BgL_rz00_17133;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17128);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17127, BgL_sz00_17119);
											return BgL_____rz00_17129;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5731 */
	obj_t BGl_z62run5731z62zz__evaluate_compz00(obj_t BgL_envz00_14723,
		obj_t BgL_sz00_14726)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1247z00_14724;
				obj_t BgL_bodyz00_14725;

				BgL_i1247z00_14724 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14723, (int) (((long) 0))));
				BgL_bodyz00_14725 = PROCEDURE_REF(BgL_envz00_14723, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17135;

					BgL_bpz00_17135 = VECTOR_REF(((obj_t) BgL_sz00_14726), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_z12denvz12_17136;
						obj_t BgL_wherez00_17137;
						obj_t BgL_locz00_17138;

						BgL_z12denvz12_17136 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17137 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14724))->
							BgL_wherez00);
						BgL_locz00_17138 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14724))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1167 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17136, BgL_wherez00_17137,
								BgL_locz00_17138);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_za2za2resza2za2z00_17139;

								BgL_za2za2resza2za2z00_17139 =
									PROCEDURE_ENTRY(BgL_bodyz00_14725) (BgL_bodyz00_14725,
									BgL_sz00_14726, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17136);
								return BgL_za2za2resza2za2z00_17139;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3678> */
	obj_t BGl_z62zc3z04anonymousza33678ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14727, obj_t BgL_sz00_14732)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_14728;
				BgL_ev_absz00_bglt BgL_i1247z00_14729;
				obj_t BgL_bodyz00_14730;
				long BgL_siza7ezd2framez75_14731;

				BgL_iboxesz00_14728 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14727, (int) (((long) 0))));
				BgL_i1247z00_14729 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14727, (int) (((long) 1))));
				BgL_bodyz00_14730 = PROCEDURE_REF(BgL_envz00_14727, (int) (((long) 2)));
				BgL_siza7ezd2framez75_14731 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14727, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17140;

					BgL_bpz00_17140 = VECTOR_REF(((obj_t) BgL_sz00_14732), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */

						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17141;

							BgL_runz00_17141 =
								MAKE_FX_PROCEDURE(BGl_z62run5733z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_17141,
								(int) (((long) 0)), BgL_iboxesz00_14728);
							PROCEDURE_SET(BgL_runz00_17141,
								(int) (((long) 1)), ((obj_t) BgL_i1247z00_14729));
							PROCEDURE_SET(BgL_runz00_17141,
								(int) (((long) 2)), BgL_bodyz00_14730);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17142;

								BgL_mainz00_17142 =
									MAKE_VA_PROCEDURE(BGl_z62main5732z62zz__evaluate_compz00,
									(int) (((long) -3)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_17142,
									(int) (((long) 0)), BgL_iboxesz00_14728);
								PROCEDURE_SET(BgL_mainz00_17142,
									(int) (((long) 1)), ((obj_t) BgL_i1247z00_14729));
								PROCEDURE_SET(BgL_mainz00_17142,
									(int) (((long) 2)), BgL_bodyz00_14730);
								PROCEDURE_SET(BgL_mainz00_17142,
									(int) (((long) 3)), BgL_runz00_17141);
								PROCEDURE_SET(BgL_mainz00_17142,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_14731));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17143;

									BgL_objz00_17143 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17141, BgL_objz00_17143);
									BgL_objz00_17143;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3679z00_17144;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3681z00_17145;

										BgL_arg3681z00_17145 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14729))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17146;

											BgL_newz00_17146 =
												create_struct(BGl_symbol5815z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_28924;

												BgL_tmpz00_28924 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17146, BgL_tmpz00_28924,
													BgL_arg3681z00_17145);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_28929;
												int BgL_tmpz00_28927;

												BgL_auxz00_28929 = BINT(BgL_siza7ezd2framez75_14731);
												BgL_tmpz00_28927 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17146, BgL_tmpz00_28927,
													BgL_auxz00_28929);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_28932;

												BgL_tmpz00_28932 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17146, BgL_tmpz00_28932,
													BgL_runz00_17141);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_28937;
												int BgL_tmpz00_28935;

												BgL_auxz00_28937 = BINT(((long) -3));
												BgL_tmpz00_28935 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17146, BgL_tmpz00_28935,
													BgL_auxz00_28937);
											}
											BgL_arg3679z00_17144 = BgL_newz00_17146;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17142, BgL_arg3679z00_17144);
									BgL_arg3679z00_17144;
								}
								return BgL_mainz00_17142;
							}
						}
					}
				}
			}
		}

	}



/* &main5732 */
	obj_t BGl_z62main5732z62zz__evaluate_compz00(obj_t BgL_envz00_14733,
		obj_t BgL_cz00_14739, obj_t BgL_dz00_14740, obj_t BgL_lastz00_14741)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14737;
				long BgL_siza7ezd2framez75_14738;

				BgL_runz00_14737 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14733, (int) (((long) 3))));
				BgL_siza7ezd2framez75_14738 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14733, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17147;

					BgL_sz00_17147 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17148;

						BgL_bpz00_17148 = VECTOR_REF(((obj_t) BgL_sz00_17147), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17148) + BgL_siza7ezd2framez75_14738) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17147))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3685z00_17149;

									BgL_arg3685z00_17149 =
										((long) CINT(BgL_bpz00_17148) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17147), BgL_arg3685z00_17149,
										BgL_cz00_14739);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3686z00_17150;

									BgL_arg3686z00_17150 =
										((long) CINT(BgL_bpz00_17148) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17147), BgL_arg3686z00_17150,
										BgL_dz00_14740);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3687z00_17151;

									BgL_arg3687z00_17151 =
										((long) CINT(BgL_bpz00_17148) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_17147), BgL_arg3687z00_17151,
										BgL_lastz00_14741);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17152;

									BgL_ez00_17152 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17152,
										BgL_bpz00_17148);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17153;

										BgL_accz00_17153 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14737, BgL_sz00_17147, BgL_bpz00_17148);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17152);
										VECTOR_SET(
											((obj_t) BgL_sz00_17147), ((long) 0), BgL_bpz00_17148);
										return BgL_accz00_17153;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17154;

								BgL_nsz00_17154 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17154, ((long) 1), BgL_sz00_17147);
								VECTOR_SET(BgL_nsz00_17154, ((long) 2), BgL_cz00_14739);
								VECTOR_SET(BgL_nsz00_17154, ((long) 3), BgL_dz00_14740);
								VECTOR_SET(BgL_nsz00_17154, ((long) 4), BgL_lastz00_14741);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17155;

									BgL_z12denvz12_17155 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17155, BgL_nsz00_17154);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17156;

										BgL_ez00_17156 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17156,
											BgL_sz00_17147);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17157;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17158;

												BgL_savedzd2bpzd2_17158 =
													VECTOR_REF(BgL_nsz00_17154, ((long) 0));
												VECTOR_SET(BgL_nsz00_17154, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17160;

													BgL_fz00_17160 = BgL_runz00_14737;
												BgL_recz00_17159:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17161;

														BgL_rz00_17161 =
															PROCEDURE_ENTRY(BgL_fz00_17160) (BgL_fz00_17160,
															BgL_nsz00_17154, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_test6638z00_28990;

															if (PROCEDUREP(BgL_rz00_17161))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1707z00_17162;

																	BgL_arg1707z00_17162 =
																		PROCEDURE_ATTR(BgL_rz00_17161);
																	if (STRUCTP(BgL_arg1707z00_17162))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6638z00_28990 =
																				(STRUCT_KEY(BgL_arg1707z00_17162) ==
																				BGl_symbol5794z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6638z00_28990 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_test6638z00_28990 = ((bool_t) 0);
																}
															if (BgL_test6638z00_28990)
																{
																	obj_t BgL_fz00_28998;

																	BgL_fz00_28998 = BgL_rz00_17161;
																	BgL_fz00_17160 = BgL_fz00_28998;
																	goto BgL_recz00_17159;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17154, ((long) 0),
																		BgL_savedzd2bpzd2_17158);
																	BgL_____rz00_17157 = BgL_rz00_17161;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17156);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17155, BgL_sz00_17147);
											return BgL_____rz00_17157;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5733 */
	obj_t BGl_z62run5733z62zz__evaluate_compz00(obj_t BgL_envz00_14742,
		obj_t BgL_sz00_14746)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_14743;
				BgL_ev_absz00_bglt BgL_i1247z00_14744;
				obj_t BgL_bodyz00_14745;

				BgL_iboxesz00_14743 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14742, (int) (((long) 0))));
				BgL_i1247z00_14744 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14742, (int) (((long) 1))));
				BgL_bodyz00_14745 = PROCEDURE_REF(BgL_envz00_14742, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17163;

					BgL_bpz00_17163 = VECTOR_REF(((obj_t) BgL_sz00_14746), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14746,
						BgL_iboxesz00_14743, BgL_bpz00_17163);
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_z12denvz12_17164;
						obj_t BgL_wherez00_17165;
						obj_t BgL_locz00_17166;

						BgL_z12denvz12_17164 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17165 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14744))->
							BgL_wherez00);
						BgL_locz00_17166 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14744))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1167 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17164, BgL_wherez00_17165,
								BgL_locz00_17166);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_za2za2resza2za2z00_17167;

								BgL_za2za2resza2za2z00_17167 =
									PROCEDURE_ENTRY(BgL_bodyz00_14745) (BgL_bodyz00_14745,
									BgL_sz00_14746, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17164);
								return BgL_za2za2resza2za2z00_17167;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3692> */
	obj_t BGl_z62zc3z04anonymousza33692ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14747, obj_t BgL_sz00_14753)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_ifreesz00_14748;
				long BgL_siza7eza7_14749;
				BgL_ev_absz00_bglt BgL_i1247z00_14750;
				obj_t BgL_bodyz00_14751;
				long BgL_siza7ezd2framez75_14752;

				BgL_ifreesz00_14748 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14747, (int) (((long) 0))));
				BgL_siza7eza7_14749 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14747, (int) (((long) 1))));
				BgL_i1247z00_14750 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14747, (int) (((long) 2))));
				BgL_bodyz00_14751 = PROCEDURE_REF(BgL_envz00_14747, (int) (((long) 3)));
				BgL_siza7ezd2framez75_14752 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14747, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17168;

					BgL_bpz00_17168 = VECTOR_REF(((obj_t) BgL_sz00_14753), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_valza2za2_17169;

						BgL_valza2za2_17169 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14753,
							BgL_bpz00_17168, BgL_ifreesz00_14748);
						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17170;

							BgL_runz00_17170 =
								MAKE_FX_PROCEDURE(BGl_z62run5735z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_17170,
								(int) (((long) 0)), BINT(BgL_siza7eza7_14749));
							PROCEDURE_SET(BgL_runz00_17170,
								(int) (((long) 1)), BgL_valza2za2_17169);
							PROCEDURE_SET(BgL_runz00_17170,
								(int) (((long) 2)), ((obj_t) BgL_i1247z00_14750));
							PROCEDURE_SET(BgL_runz00_17170,
								(int) (((long) 3)), BgL_bodyz00_14751);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17171;

								BgL_mainz00_17171 =
									MAKE_VA_PROCEDURE(BGl_z62main5734z62zz__evaluate_compz00,
									(int) (((long) -3)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_17171,
									(int) (((long) 0)), BINT(BgL_siza7eza7_14749));
								PROCEDURE_SET(BgL_mainz00_17171,
									(int) (((long) 1)), BgL_valza2za2_17169);
								PROCEDURE_SET(BgL_mainz00_17171,
									(int) (((long) 2)), ((obj_t) BgL_i1247z00_14750));
								PROCEDURE_SET(BgL_mainz00_17171,
									(int) (((long) 3)), BgL_bodyz00_14751);
								PROCEDURE_SET(BgL_mainz00_17171,
									(int) (((long) 4)), BgL_runz00_17170);
								PROCEDURE_SET(BgL_mainz00_17171,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_14752));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17172;

									BgL_objz00_17172 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17170, BgL_objz00_17172);
									BgL_objz00_17172;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3693z00_17173;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3694z00_17174;

										BgL_arg3694z00_17174 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14750))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17175;

											BgL_newz00_17175 =
												create_struct(BGl_symbol5815z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_29074;

												BgL_tmpz00_29074 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17175, BgL_tmpz00_29074,
													BgL_arg3694z00_17174);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_29079;
												int BgL_tmpz00_29077;

												BgL_auxz00_29079 = BINT(BgL_siza7ezd2framez75_14752);
												BgL_tmpz00_29077 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17175, BgL_tmpz00_29077,
													BgL_auxz00_29079);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_29082;

												BgL_tmpz00_29082 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17175, BgL_tmpz00_29082,
													BgL_runz00_17170);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_29087;
												int BgL_tmpz00_29085;

												BgL_auxz00_29087 = BINT(((long) -3));
												BgL_tmpz00_29085 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17175, BgL_tmpz00_29085,
													BgL_auxz00_29087);
											}
											BgL_arg3693z00_17173 = BgL_newz00_17175;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17171, BgL_arg3693z00_17173);
									BgL_arg3693z00_17173;
								}
								return BgL_mainz00_17171;
							}
						}
					}
				}
			}
		}

	}



/* &main5734 */
	obj_t BGl_z62main5734z62zz__evaluate_compz00(obj_t BgL_envz00_14754,
		obj_t BgL_cz00_14761, obj_t BgL_dz00_14762, obj_t BgL_lastz00_14763)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14759;
				long BgL_siza7ezd2framez75_14760;

				BgL_runz00_14759 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14754, (int) (((long) 4))));
				BgL_siza7ezd2framez75_14760 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14754, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17176;

					BgL_sz00_17176 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17177;

						BgL_bpz00_17177 = VECTOR_REF(((obj_t) BgL_sz00_17176), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17177) + BgL_siza7ezd2framez75_14760) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17176))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3697z00_17178;

									BgL_arg3697z00_17178 =
										((long) CINT(BgL_bpz00_17177) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17176), BgL_arg3697z00_17178,
										BgL_cz00_14761);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3698z00_17179;

									BgL_arg3698z00_17179 =
										((long) CINT(BgL_bpz00_17177) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17176), BgL_arg3698z00_17179,
										BgL_dz00_14762);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3699z00_17180;

									BgL_arg3699z00_17180 =
										((long) CINT(BgL_bpz00_17177) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_17176), BgL_arg3699z00_17180,
										BgL_lastz00_14763);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17181;

									BgL_ez00_17181 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17181,
										BgL_bpz00_17177);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17182;

										BgL_accz00_17182 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14759, BgL_sz00_17176, BgL_bpz00_17177);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17181);
										VECTOR_SET(
											((obj_t) BgL_sz00_17176), ((long) 0), BgL_bpz00_17177);
										return BgL_accz00_17182;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17183;

								BgL_nsz00_17183 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17183, ((long) 1), BgL_sz00_17176);
								VECTOR_SET(BgL_nsz00_17183, ((long) 2), BgL_cz00_14761);
								VECTOR_SET(BgL_nsz00_17183, ((long) 3), BgL_dz00_14762);
								VECTOR_SET(BgL_nsz00_17183, ((long) 4), BgL_lastz00_14763);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17184;

									BgL_z12denvz12_17184 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17184, BgL_nsz00_17183);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17185;

										BgL_ez00_17185 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17185,
											BgL_sz00_17176);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17186;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17187;

												BgL_savedzd2bpzd2_17187 =
													VECTOR_REF(BgL_nsz00_17183, ((long) 0));
												VECTOR_SET(BgL_nsz00_17183, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17189;

													BgL_fz00_17189 = BgL_runz00_14759;
												BgL_recz00_17188:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17190;

														BgL_rz00_17190 =
															PROCEDURE_ENTRY(BgL_fz00_17189) (BgL_fz00_17189,
															BgL_nsz00_17183, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_test6642z00_29140;

															if (PROCEDUREP(BgL_rz00_17190))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1707z00_17191;

																	BgL_arg1707z00_17191 =
																		PROCEDURE_ATTR(BgL_rz00_17190);
																	if (STRUCTP(BgL_arg1707z00_17191))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6642z00_29140 =
																				(STRUCT_KEY(BgL_arg1707z00_17191) ==
																				BGl_symbol5794z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6642z00_29140 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_test6642z00_29140 = ((bool_t) 0);
																}
															if (BgL_test6642z00_29140)
																{
																	obj_t BgL_fz00_29148;

																	BgL_fz00_29148 = BgL_rz00_17190;
																	BgL_fz00_17189 = BgL_fz00_29148;
																	goto BgL_recz00_17188;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17183, ((long) 0),
																		BgL_savedzd2bpzd2_17187);
																	BgL_____rz00_17186 = BgL_rz00_17190;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17185);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17184, BgL_sz00_17176);
											return BgL_____rz00_17186;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5735 */
	obj_t BGl_z62run5735z62zz__evaluate_compz00(obj_t BgL_envz00_14764,
		obj_t BgL_sz00_14769)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				long BgL_siza7eza7_14765;
				obj_t BgL_valza2za2_14766;
				BgL_ev_absz00_bglt BgL_i1247z00_14767;
				obj_t BgL_bodyz00_14768;

				BgL_siza7eza7_14765 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14764, (int) (((long) 0))));
				BgL_valza2za2_14766 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14764, (int) (((long) 1))));
				BgL_i1247z00_14767 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14764, (int) (((long) 2))));
				BgL_bodyz00_14768 = PROCEDURE_REF(BgL_envz00_14764, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17192;

					BgL_bpz00_17192 = VECTOR_REF(((obj_t) BgL_sz00_14769), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14769,
						BgL_valza2za2_14766,
						((long) CINT(BgL_bpz00_17192) + BgL_siza7eza7_14765));
					{	/* Eval/evaluate_comp.scm 1088 */
						obj_t BgL_z12denvz12_17193;
						obj_t BgL_wherez00_17194;
						obj_t BgL_locz00_17195;

						BgL_z12denvz12_17193 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17194 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14767))->
							BgL_wherez00);
						BgL_locz00_17195 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14767))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1088 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17193, BgL_wherez00_17194,
								BgL_locz00_17195);
							{	/* Eval/evaluate_comp.scm 1088 */
								obj_t BgL_za2za2resza2za2z00_17196;

								BgL_za2za2resza2za2z00_17196 =
									PROCEDURE_ENTRY(BgL_bodyz00_14768) (BgL_bodyz00_14768,
									BgL_sz00_14769, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17193);
								return BgL_za2za2resza2za2z00_17196;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3702> */
	obj_t BGl_z62zc3z04anonymousza33702ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14770, obj_t BgL_sz00_14777)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_ifreesz00_14771;
				obj_t BgL_iboxesz00_14772;
				long BgL_siza7eza7_14773;
				BgL_ev_absz00_bglt BgL_i1247z00_14774;
				obj_t BgL_bodyz00_14775;
				long BgL_siza7ezd2framez75_14776;

				BgL_ifreesz00_14771 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14770, (int) (((long) 0))));
				BgL_iboxesz00_14772 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14770, (int) (((long) 1))));
				BgL_siza7eza7_14773 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14770, (int) (((long) 2))));
				BgL_i1247z00_14774 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14770, (int) (((long) 3))));
				BgL_bodyz00_14775 = PROCEDURE_REF(BgL_envz00_14770, (int) (((long) 4)));
				BgL_siza7ezd2framez75_14776 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14770, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17197;

					BgL_bpz00_17197 = VECTOR_REF(((obj_t) BgL_sz00_14777), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_valza2za2_17198;

						BgL_valza2za2_17198 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14777,
							BgL_bpz00_17197, BgL_ifreesz00_14771);
						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17199;

							BgL_runz00_17199 =
								MAKE_FX_PROCEDURE(BGl_z62run5737z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_17199,
								(int) (((long) 0)), BgL_iboxesz00_14772);
							PROCEDURE_SET(BgL_runz00_17199,
								(int) (((long) 1)), BINT(BgL_siza7eza7_14773));
							PROCEDURE_SET(BgL_runz00_17199,
								(int) (((long) 2)), BgL_valza2za2_17198);
							PROCEDURE_SET(BgL_runz00_17199,
								(int) (((long) 3)), ((obj_t) BgL_i1247z00_14774));
							PROCEDURE_SET(BgL_runz00_17199,
								(int) (((long) 4)), BgL_bodyz00_14775);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17200;

								BgL_mainz00_17200 =
									MAKE_VA_PROCEDURE(BGl_z62main5736z62zz__evaluate_compz00,
									(int) (((long) -3)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_17200,
									(int) (((long) 0)), BgL_iboxesz00_14772);
								PROCEDURE_SET(BgL_mainz00_17200,
									(int) (((long) 1)), BINT(BgL_siza7eza7_14773));
								PROCEDURE_SET(BgL_mainz00_17200,
									(int) (((long) 2)), BgL_valza2za2_17198);
								PROCEDURE_SET(BgL_mainz00_17200,
									(int) (((long) 3)), ((obj_t) BgL_i1247z00_14774));
								PROCEDURE_SET(BgL_mainz00_17200,
									(int) (((long) 4)), BgL_bodyz00_14775);
								PROCEDURE_SET(BgL_mainz00_17200,
									(int) (((long) 5)), BgL_runz00_17199);
								PROCEDURE_SET(BgL_mainz00_17200,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_14776));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17201;

									BgL_objz00_17201 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17199, BgL_objz00_17201);
									BgL_objz00_17201;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3703z00_17202;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3704z00_17203;

										BgL_arg3704z00_17203 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14774))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17204;

											BgL_newz00_17204 =
												create_struct(BGl_symbol5815z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_29236;

												BgL_tmpz00_29236 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17204, BgL_tmpz00_29236,
													BgL_arg3704z00_17203);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_29241;
												int BgL_tmpz00_29239;

												BgL_auxz00_29241 = BINT(BgL_siza7ezd2framez75_14776);
												BgL_tmpz00_29239 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17204, BgL_tmpz00_29239,
													BgL_auxz00_29241);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_29244;

												BgL_tmpz00_29244 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17204, BgL_tmpz00_29244,
													BgL_runz00_17199);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_29249;
												int BgL_tmpz00_29247;

												BgL_auxz00_29249 = BINT(((long) -3));
												BgL_tmpz00_29247 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17204, BgL_tmpz00_29247,
													BgL_auxz00_29249);
											}
											BgL_arg3703z00_17202 = BgL_newz00_17204;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17200, BgL_arg3703z00_17202);
									BgL_arg3703z00_17202;
								}
								return BgL_mainz00_17200;
							}
						}
					}
				}
			}
		}

	}



/* &main5736 */
	obj_t BGl_z62main5736z62zz__evaluate_compz00(obj_t BgL_envz00_14778,
		obj_t BgL_cz00_14786, obj_t BgL_dz00_14787, obj_t BgL_lastz00_14788)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14784;
				long BgL_siza7ezd2framez75_14785;

				BgL_runz00_14784 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14778, (int) (((long) 5))));
				BgL_siza7ezd2framez75_14785 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14778, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17205;

					BgL_sz00_17205 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17206;

						BgL_bpz00_17206 = VECTOR_REF(((obj_t) BgL_sz00_17205), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17206) + BgL_siza7ezd2framez75_14785) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17205))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3707z00_17207;

									BgL_arg3707z00_17207 =
										((long) CINT(BgL_bpz00_17206) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17205), BgL_arg3707z00_17207,
										BgL_cz00_14786);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3708z00_17208;

									BgL_arg3708z00_17208 =
										((long) CINT(BgL_bpz00_17206) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17205), BgL_arg3708z00_17208,
										BgL_dz00_14787);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3709z00_17209;

									BgL_arg3709z00_17209 =
										((long) CINT(BgL_bpz00_17206) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_17205), BgL_arg3709z00_17209,
										BgL_lastz00_14788);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17210;

									BgL_ez00_17210 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17210,
										BgL_bpz00_17206);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17211;

										BgL_accz00_17211 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14784, BgL_sz00_17205, BgL_bpz00_17206);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17210);
										VECTOR_SET(
											((obj_t) BgL_sz00_17205), ((long) 0), BgL_bpz00_17206);
										return BgL_accz00_17211;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17212;

								BgL_nsz00_17212 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17212, ((long) 1), BgL_sz00_17205);
								VECTOR_SET(BgL_nsz00_17212, ((long) 2), BgL_cz00_14786);
								VECTOR_SET(BgL_nsz00_17212, ((long) 3), BgL_dz00_14787);
								VECTOR_SET(BgL_nsz00_17212, ((long) 4), BgL_lastz00_14788);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17213;

									BgL_z12denvz12_17213 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17213, BgL_nsz00_17212);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17214;

										BgL_ez00_17214 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17214,
											BgL_sz00_17205);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17215;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17216;

												BgL_savedzd2bpzd2_17216 =
													VECTOR_REF(BgL_nsz00_17212, ((long) 0));
												VECTOR_SET(BgL_nsz00_17212, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17218;

													BgL_fz00_17218 = BgL_runz00_14784;
												BgL_recz00_17217:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17219;

														BgL_rz00_17219 =
															PROCEDURE_ENTRY(BgL_fz00_17218) (BgL_fz00_17218,
															BgL_nsz00_17212, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_test6646z00_29302;

															if (PROCEDUREP(BgL_rz00_17219))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1707z00_17220;

																	BgL_arg1707z00_17220 =
																		PROCEDURE_ATTR(BgL_rz00_17219);
																	if (STRUCTP(BgL_arg1707z00_17220))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6646z00_29302 =
																				(STRUCT_KEY(BgL_arg1707z00_17220) ==
																				BGl_symbol5794z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6646z00_29302 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_test6646z00_29302 = ((bool_t) 0);
																}
															if (BgL_test6646z00_29302)
																{
																	obj_t BgL_fz00_29310;

																	BgL_fz00_29310 = BgL_rz00_17219;
																	BgL_fz00_17218 = BgL_fz00_29310;
																	goto BgL_recz00_17217;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17212, ((long) 0),
																		BgL_savedzd2bpzd2_17216);
																	BgL_____rz00_17215 = BgL_rz00_17219;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17214);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17213, BgL_sz00_17205);
											return BgL_____rz00_17215;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5737 */
	obj_t BGl_z62run5737z62zz__evaluate_compz00(obj_t BgL_envz00_14789,
		obj_t BgL_sz00_14795)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_14790;
				long BgL_siza7eza7_14791;
				obj_t BgL_valza2za2_14792;
				BgL_ev_absz00_bglt BgL_i1247z00_14793;
				obj_t BgL_bodyz00_14794;

				BgL_iboxesz00_14790 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14789, (int) (((long) 0))));
				BgL_siza7eza7_14791 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14789, (int) (((long) 1))));
				BgL_valza2za2_14792 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14789, (int) (((long) 2))));
				BgL_i1247z00_14793 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14789, (int) (((long) 3))));
				BgL_bodyz00_14794 = PROCEDURE_REF(BgL_envz00_14789, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17221;

					BgL_bpz00_17221 = VECTOR_REF(((obj_t) BgL_sz00_14795), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14795,
						BgL_iboxesz00_14790, BgL_bpz00_17221);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14795,
						BgL_valza2za2_14792,
						((long) CINT(BgL_bpz00_17221) + BgL_siza7eza7_14791));
					{	/* Eval/evaluate_comp.scm 1088 */
						obj_t BgL_z12denvz12_17222;
						obj_t BgL_wherez00_17223;
						obj_t BgL_locz00_17224;

						BgL_z12denvz12_17222 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17223 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14793))->
							BgL_wherez00);
						BgL_locz00_17224 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14793))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1088 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17222, BgL_wherez00_17223,
								BgL_locz00_17224);
							{	/* Eval/evaluate_comp.scm 1088 */
								obj_t BgL_za2za2resza2za2z00_17225;

								BgL_za2za2resza2za2z00_17225 =
									PROCEDURE_ENTRY(BgL_bodyz00_14794) (BgL_bodyz00_14794,
									BgL_sz00_14795, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17222);
								return BgL_za2za2resza2za2z00_17225;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3623> */
	obj_t BGl_z62zc3z04anonymousza33623ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14796, obj_t BgL_sz00_14800)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1247z00_14797;
				obj_t BgL_bodyz00_14798;
				long BgL_siza7ezd2framez75_14799;

				BgL_i1247z00_14797 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14796, (int) (((long) 0))));
				BgL_bodyz00_14798 = PROCEDURE_REF(BgL_envz00_14796, (int) (((long) 1)));
				BgL_siza7ezd2framez75_14799 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14796, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17226;

					BgL_bpz00_17226 = VECTOR_REF(((obj_t) BgL_sz00_14800), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */

						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17227;

							BgL_runz00_17227 =
								MAKE_FX_PROCEDURE(BGl_z62run5739z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_17227,
								(int) (((long) 0)), ((obj_t) BgL_i1247z00_14797));
							PROCEDURE_SET(BgL_runz00_17227,
								(int) (((long) 1)), BgL_bodyz00_14798);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17228;

								BgL_mainz00_17228 =
									MAKE_FX_PROCEDURE(BGl_z62main5738z62zz__evaluate_compz00,
									(int) (((long) 2)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_17228,
									(int) (((long) 0)), ((obj_t) BgL_i1247z00_14797));
								PROCEDURE_SET(BgL_mainz00_17228,
									(int) (((long) 1)), BgL_bodyz00_14798);
								PROCEDURE_SET(BgL_mainz00_17228,
									(int) (((long) 2)), BgL_runz00_17227);
								PROCEDURE_SET(BgL_mainz00_17228,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_14799));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17229;

									BgL_objz00_17229 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17227, BgL_objz00_17229);
									BgL_objz00_17229;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3624z00_17230;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3625z00_17231;

										BgL_arg3625z00_17231 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14797))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17232;

											BgL_newz00_17232 =
												create_struct(BGl_symbol5815z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_29378;

												BgL_tmpz00_29378 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17232, BgL_tmpz00_29378,
													BgL_arg3625z00_17231);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_29383;
												int BgL_tmpz00_29381;

												BgL_auxz00_29383 = BINT(BgL_siza7ezd2framez75_14799);
												BgL_tmpz00_29381 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17232, BgL_tmpz00_29381,
													BgL_auxz00_29383);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_29386;

												BgL_tmpz00_29386 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17232, BgL_tmpz00_29386,
													BgL_runz00_17227);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_29391;
												int BgL_tmpz00_29389;

												BgL_auxz00_29391 = BINT(((long) 2));
												BgL_tmpz00_29389 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17232, BgL_tmpz00_29389,
													BgL_auxz00_29391);
											}
											BgL_arg3624z00_17230 = BgL_newz00_17232;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17228, BgL_arg3624z00_17230);
									BgL_arg3624z00_17230;
								}
								return BgL_mainz00_17228;
							}
						}
					}
				}
			}
		}

	}



/* &main5738 */
	obj_t BGl_z62main5738z62zz__evaluate_compz00(obj_t BgL_envz00_14801,
		obj_t BgL_cz00_14806, obj_t BgL_dz00_14807)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14804;
				long BgL_siza7ezd2framez75_14805;

				BgL_runz00_14804 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14801, (int) (((long) 2))));
				BgL_siza7ezd2framez75_14805 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14801, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17233;

					BgL_sz00_17233 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17234;

						BgL_bpz00_17234 = VECTOR_REF(((obj_t) BgL_sz00_17233), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17234) + BgL_siza7ezd2framez75_14805) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17233))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3629z00_17235;

									BgL_arg3629z00_17235 =
										((long) CINT(BgL_bpz00_17234) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17233), BgL_arg3629z00_17235,
										BgL_cz00_14806);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3630z00_17236;

									BgL_arg3630z00_17236 =
										((long) CINT(BgL_bpz00_17234) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17233), BgL_arg3630z00_17236,
										BgL_dz00_14807);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17237;

									BgL_ez00_17237 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17237,
										BgL_bpz00_17234);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17238;

										BgL_accz00_17238 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14804, BgL_sz00_17233, BgL_bpz00_17234);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17237);
										VECTOR_SET(
											((obj_t) BgL_sz00_17233), ((long) 0), BgL_bpz00_17234);
										return BgL_accz00_17238;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17239;

								BgL_nsz00_17239 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17239, ((long) 1), BgL_sz00_17233);
								VECTOR_SET(BgL_nsz00_17239, ((long) 2), BgL_cz00_14806);
								VECTOR_SET(BgL_nsz00_17239, ((long) 3), BgL_dz00_14807);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17240;

									BgL_z12denvz12_17240 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17240, BgL_nsz00_17239);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17241;

										BgL_ez00_17241 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17241,
											BgL_sz00_17233);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17242;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17243;

												BgL_savedzd2bpzd2_17243 =
													VECTOR_REF(BgL_nsz00_17239, ((long) 0));
												VECTOR_SET(BgL_nsz00_17239, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17245;

													BgL_fz00_17245 = BgL_runz00_14804;
												BgL_recz00_17244:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17246;

														BgL_rz00_17246 =
															PROCEDURE_ENTRY(BgL_fz00_17245) (BgL_fz00_17245,
															BgL_nsz00_17239, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_test6650z00_29439;

															if (PROCEDUREP(BgL_rz00_17246))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1707z00_17247;

																	BgL_arg1707z00_17247 =
																		PROCEDURE_ATTR(BgL_rz00_17246);
																	if (STRUCTP(BgL_arg1707z00_17247))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6650z00_29439 =
																				(STRUCT_KEY(BgL_arg1707z00_17247) ==
																				BGl_symbol5794z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6650z00_29439 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_test6650z00_29439 = ((bool_t) 0);
																}
															if (BgL_test6650z00_29439)
																{
																	obj_t BgL_fz00_29447;

																	BgL_fz00_29447 = BgL_rz00_17246;
																	BgL_fz00_17245 = BgL_fz00_29447;
																	goto BgL_recz00_17244;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17239, ((long) 0),
																		BgL_savedzd2bpzd2_17243);
																	BgL_____rz00_17242 = BgL_rz00_17246;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17241);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17240, BgL_sz00_17233);
											return BgL_____rz00_17242;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5739 */
	obj_t BGl_z62run5739z62zz__evaluate_compz00(obj_t BgL_envz00_14808,
		obj_t BgL_sz00_14811)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1247z00_14809;
				obj_t BgL_bodyz00_14810;

				BgL_i1247z00_14809 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14808, (int) (((long) 0))));
				BgL_bodyz00_14810 = PROCEDURE_REF(BgL_envz00_14808, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17248;

					BgL_bpz00_17248 = VECTOR_REF(((obj_t) BgL_sz00_14811), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_z12denvz12_17249;
						obj_t BgL_wherez00_17250;
						obj_t BgL_locz00_17251;

						BgL_z12denvz12_17249 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17250 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14809))->
							BgL_wherez00);
						BgL_locz00_17251 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14809))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1167 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17249, BgL_wherez00_17250,
								BgL_locz00_17251);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_za2za2resza2za2z00_17252;

								BgL_za2za2resza2za2z00_17252 =
									PROCEDURE_ENTRY(BgL_bodyz00_14810) (BgL_bodyz00_14810,
									BgL_sz00_14811, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17249);
								return BgL_za2za2resza2za2z00_17252;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3632> */
	obj_t BGl_z62zc3z04anonymousza33632ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14812, obj_t BgL_sz00_14817)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_14813;
				BgL_ev_absz00_bglt BgL_i1247z00_14814;
				obj_t BgL_bodyz00_14815;
				long BgL_siza7ezd2framez75_14816;

				BgL_iboxesz00_14813 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14812, (int) (((long) 0))));
				BgL_i1247z00_14814 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14812, (int) (((long) 1))));
				BgL_bodyz00_14815 = PROCEDURE_REF(BgL_envz00_14812, (int) (((long) 2)));
				BgL_siza7ezd2framez75_14816 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14812, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17253;

					BgL_bpz00_17253 = VECTOR_REF(((obj_t) BgL_sz00_14817), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */

						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17254;

							BgL_runz00_17254 =
								MAKE_FX_PROCEDURE(BGl_z62run5741z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_17254,
								(int) (((long) 0)), BgL_iboxesz00_14813);
							PROCEDURE_SET(BgL_runz00_17254,
								(int) (((long) 1)), ((obj_t) BgL_i1247z00_14814));
							PROCEDURE_SET(BgL_runz00_17254,
								(int) (((long) 2)), BgL_bodyz00_14815);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17255;

								BgL_mainz00_17255 =
									MAKE_FX_PROCEDURE(BGl_z62main5740z62zz__evaluate_compz00,
									(int) (((long) 2)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_17255,
									(int) (((long) 0)), BgL_iboxesz00_14813);
								PROCEDURE_SET(BgL_mainz00_17255,
									(int) (((long) 1)), ((obj_t) BgL_i1247z00_14814));
								PROCEDURE_SET(BgL_mainz00_17255,
									(int) (((long) 2)), BgL_bodyz00_14815);
								PROCEDURE_SET(BgL_mainz00_17255,
									(int) (((long) 3)), BgL_runz00_17254);
								PROCEDURE_SET(BgL_mainz00_17255,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_14816));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17256;

									BgL_objz00_17256 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17254, BgL_objz00_17256);
									BgL_objz00_17256;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3633z00_17257;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3634z00_17258;

										BgL_arg3634z00_17258 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14814))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17259;

											BgL_newz00_17259 =
												create_struct(BGl_symbol5815z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_29509;

												BgL_tmpz00_29509 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17259, BgL_tmpz00_29509,
													BgL_arg3634z00_17258);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_29514;
												int BgL_tmpz00_29512;

												BgL_auxz00_29514 = BINT(BgL_siza7ezd2framez75_14816);
												BgL_tmpz00_29512 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17259, BgL_tmpz00_29512,
													BgL_auxz00_29514);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_29517;

												BgL_tmpz00_29517 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17259, BgL_tmpz00_29517,
													BgL_runz00_17254);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_29522;
												int BgL_tmpz00_29520;

												BgL_auxz00_29522 = BINT(((long) 2));
												BgL_tmpz00_29520 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17259, BgL_tmpz00_29520,
													BgL_auxz00_29522);
											}
											BgL_arg3633z00_17257 = BgL_newz00_17259;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17255, BgL_arg3633z00_17257);
									BgL_arg3633z00_17257;
								}
								return BgL_mainz00_17255;
							}
						}
					}
				}
			}
		}

	}



/* &main5740 */
	obj_t BGl_z62main5740z62zz__evaluate_compz00(obj_t BgL_envz00_14818,
		obj_t BgL_cz00_14824, obj_t BgL_dz00_14825)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14822;
				long BgL_siza7ezd2framez75_14823;

				BgL_runz00_14822 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14818, (int) (((long) 3))));
				BgL_siza7ezd2framez75_14823 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14818, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17260;

					BgL_sz00_17260 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17261;

						BgL_bpz00_17261 = VECTOR_REF(((obj_t) BgL_sz00_17260), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17261) + BgL_siza7ezd2framez75_14823) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17260))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3637z00_17262;

									BgL_arg3637z00_17262 =
										((long) CINT(BgL_bpz00_17261) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17260), BgL_arg3637z00_17262,
										BgL_cz00_14824);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3638z00_17263;

									BgL_arg3638z00_17263 =
										((long) CINT(BgL_bpz00_17261) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17260), BgL_arg3638z00_17263,
										BgL_dz00_14825);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17264;

									BgL_ez00_17264 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17264,
										BgL_bpz00_17261);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17265;

										BgL_accz00_17265 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14822, BgL_sz00_17260, BgL_bpz00_17261);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17264);
										VECTOR_SET(
											((obj_t) BgL_sz00_17260), ((long) 0), BgL_bpz00_17261);
										return BgL_accz00_17265;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17266;

								BgL_nsz00_17266 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17266, ((long) 1), BgL_sz00_17260);
								VECTOR_SET(BgL_nsz00_17266, ((long) 2), BgL_cz00_14824);
								VECTOR_SET(BgL_nsz00_17266, ((long) 3), BgL_dz00_14825);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17267;

									BgL_z12denvz12_17267 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17267, BgL_nsz00_17266);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17268;

										BgL_ez00_17268 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17268,
											BgL_sz00_17260);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17269;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17270;

												BgL_savedzd2bpzd2_17270 =
													VECTOR_REF(BgL_nsz00_17266, ((long) 0));
												VECTOR_SET(BgL_nsz00_17266, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17272;

													BgL_fz00_17272 = BgL_runz00_14822;
												BgL_recz00_17271:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17273;

														BgL_rz00_17273 =
															PROCEDURE_ENTRY(BgL_fz00_17272) (BgL_fz00_17272,
															BgL_nsz00_17266, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_test6654z00_29570;

															if (PROCEDUREP(BgL_rz00_17273))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1707z00_17274;

																	BgL_arg1707z00_17274 =
																		PROCEDURE_ATTR(BgL_rz00_17273);
																	if (STRUCTP(BgL_arg1707z00_17274))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6654z00_29570 =
																				(STRUCT_KEY(BgL_arg1707z00_17274) ==
																				BGl_symbol5794z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6654z00_29570 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_test6654z00_29570 = ((bool_t) 0);
																}
															if (BgL_test6654z00_29570)
																{
																	obj_t BgL_fz00_29578;

																	BgL_fz00_29578 = BgL_rz00_17273;
																	BgL_fz00_17272 = BgL_fz00_29578;
																	goto BgL_recz00_17271;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17266, ((long) 0),
																		BgL_savedzd2bpzd2_17270);
																	BgL_____rz00_17269 = BgL_rz00_17273;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17268);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17267, BgL_sz00_17260);
											return BgL_____rz00_17269;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5741 */
	obj_t BGl_z62run5741z62zz__evaluate_compz00(obj_t BgL_envz00_14826,
		obj_t BgL_sz00_14830)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_14827;
				BgL_ev_absz00_bglt BgL_i1247z00_14828;
				obj_t BgL_bodyz00_14829;

				BgL_iboxesz00_14827 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14826, (int) (((long) 0))));
				BgL_i1247z00_14828 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14826, (int) (((long) 1))));
				BgL_bodyz00_14829 = PROCEDURE_REF(BgL_envz00_14826, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17275;

					BgL_bpz00_17275 = VECTOR_REF(((obj_t) BgL_sz00_14830), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14830,
						BgL_iboxesz00_14827, BgL_bpz00_17275);
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_z12denvz12_17276;
						obj_t BgL_wherez00_17277;
						obj_t BgL_locz00_17278;

						BgL_z12denvz12_17276 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17277 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14828))->
							BgL_wherez00);
						BgL_locz00_17278 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14828))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1167 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17276, BgL_wherez00_17277,
								BgL_locz00_17278);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_za2za2resza2za2z00_17279;

								BgL_za2za2resza2za2z00_17279 =
									PROCEDURE_ENTRY(BgL_bodyz00_14829) (BgL_bodyz00_14829,
									BgL_sz00_14830, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17276);
								return BgL_za2za2resza2za2z00_17279;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3643> */
	obj_t BGl_z62zc3z04anonymousza33643ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14831, obj_t BgL_sz00_14837)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_ifreesz00_14832;
				long BgL_siza7eza7_14833;
				BgL_ev_absz00_bglt BgL_i1247z00_14834;
				obj_t BgL_bodyz00_14835;
				long BgL_siza7ezd2framez75_14836;

				BgL_ifreesz00_14832 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14831, (int) (((long) 0))));
				BgL_siza7eza7_14833 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14831, (int) (((long) 1))));
				BgL_i1247z00_14834 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14831, (int) (((long) 2))));
				BgL_bodyz00_14835 = PROCEDURE_REF(BgL_envz00_14831, (int) (((long) 3)));
				BgL_siza7ezd2framez75_14836 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14831, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17280;

					BgL_bpz00_17280 = VECTOR_REF(((obj_t) BgL_sz00_14837), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_valza2za2_17281;

						BgL_valza2za2_17281 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14837,
							BgL_bpz00_17280, BgL_ifreesz00_14832);
						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17282;

							BgL_runz00_17282 =
								MAKE_FX_PROCEDURE(BGl_z62run5743z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_17282,
								(int) (((long) 0)), BINT(BgL_siza7eza7_14833));
							PROCEDURE_SET(BgL_runz00_17282,
								(int) (((long) 1)), BgL_valza2za2_17281);
							PROCEDURE_SET(BgL_runz00_17282,
								(int) (((long) 2)), ((obj_t) BgL_i1247z00_14834));
							PROCEDURE_SET(BgL_runz00_17282,
								(int) (((long) 3)), BgL_bodyz00_14835);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17283;

								BgL_mainz00_17283 =
									MAKE_FX_PROCEDURE(BGl_z62main5742z62zz__evaluate_compz00,
									(int) (((long) 2)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_17283,
									(int) (((long) 0)), BINT(BgL_siza7eza7_14833));
								PROCEDURE_SET(BgL_mainz00_17283,
									(int) (((long) 1)), BgL_valza2za2_17281);
								PROCEDURE_SET(BgL_mainz00_17283,
									(int) (((long) 2)), ((obj_t) BgL_i1247z00_14834));
								PROCEDURE_SET(BgL_mainz00_17283,
									(int) (((long) 3)), BgL_bodyz00_14835);
								PROCEDURE_SET(BgL_mainz00_17283,
									(int) (((long) 4)), BgL_runz00_17282);
								PROCEDURE_SET(BgL_mainz00_17283,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_14836));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17284;

									BgL_objz00_17284 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17282, BgL_objz00_17284);
									BgL_objz00_17284;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3644z00_17285;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3645z00_17286;

										BgL_arg3645z00_17286 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14834))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17287;

											BgL_newz00_17287 =
												create_struct(BGl_symbol5815z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_29654;

												BgL_tmpz00_29654 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17287, BgL_tmpz00_29654,
													BgL_arg3645z00_17286);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_29659;
												int BgL_tmpz00_29657;

												BgL_auxz00_29659 = BINT(BgL_siza7ezd2framez75_14836);
												BgL_tmpz00_29657 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17287, BgL_tmpz00_29657,
													BgL_auxz00_29659);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_29662;

												BgL_tmpz00_29662 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17287, BgL_tmpz00_29662,
													BgL_runz00_17282);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_29667;
												int BgL_tmpz00_29665;

												BgL_auxz00_29667 = BINT(((long) 2));
												BgL_tmpz00_29665 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17287, BgL_tmpz00_29665,
													BgL_auxz00_29667);
											}
											BgL_arg3644z00_17285 = BgL_newz00_17287;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17283, BgL_arg3644z00_17285);
									BgL_arg3644z00_17285;
								}
								return BgL_mainz00_17283;
							}
						}
					}
				}
			}
		}

	}



/* &main5742 */
	obj_t BGl_z62main5742z62zz__evaluate_compz00(obj_t BgL_envz00_14838,
		obj_t BgL_cz00_14845, obj_t BgL_dz00_14846)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14843;
				long BgL_siza7ezd2framez75_14844;

				BgL_runz00_14843 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14838, (int) (((long) 4))));
				BgL_siza7ezd2framez75_14844 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14838, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17288;

					BgL_sz00_17288 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17289;

						BgL_bpz00_17289 = VECTOR_REF(((obj_t) BgL_sz00_17288), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17289) + BgL_siza7ezd2framez75_14844) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17288))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3648z00_17290;

									BgL_arg3648z00_17290 =
										((long) CINT(BgL_bpz00_17289) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17288), BgL_arg3648z00_17290,
										BgL_cz00_14845);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3649z00_17291;

									BgL_arg3649z00_17291 =
										((long) CINT(BgL_bpz00_17289) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17288), BgL_arg3649z00_17291,
										BgL_dz00_14846);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17292;

									BgL_ez00_17292 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17292,
										BgL_bpz00_17289);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17293;

										BgL_accz00_17293 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14843, BgL_sz00_17288, BgL_bpz00_17289);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17292);
										VECTOR_SET(
											((obj_t) BgL_sz00_17288), ((long) 0), BgL_bpz00_17289);
										return BgL_accz00_17293;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17294;

								BgL_nsz00_17294 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17294, ((long) 1), BgL_sz00_17288);
								VECTOR_SET(BgL_nsz00_17294, ((long) 2), BgL_cz00_14845);
								VECTOR_SET(BgL_nsz00_17294, ((long) 3), BgL_dz00_14846);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17295;

									BgL_z12denvz12_17295 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17295, BgL_nsz00_17294);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17296;

										BgL_ez00_17296 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17296,
											BgL_sz00_17288);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17297;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17298;

												BgL_savedzd2bpzd2_17298 =
													VECTOR_REF(BgL_nsz00_17294, ((long) 0));
												VECTOR_SET(BgL_nsz00_17294, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17300;

													BgL_fz00_17300 = BgL_runz00_14843;
												BgL_recz00_17299:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17301;

														BgL_rz00_17301 =
															PROCEDURE_ENTRY(BgL_fz00_17300) (BgL_fz00_17300,
															BgL_nsz00_17294, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_test6658z00_29715;

															if (PROCEDUREP(BgL_rz00_17301))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1707z00_17302;

																	BgL_arg1707z00_17302 =
																		PROCEDURE_ATTR(BgL_rz00_17301);
																	if (STRUCTP(BgL_arg1707z00_17302))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6658z00_29715 =
																				(STRUCT_KEY(BgL_arg1707z00_17302) ==
																				BGl_symbol5794z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6658z00_29715 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_test6658z00_29715 = ((bool_t) 0);
																}
															if (BgL_test6658z00_29715)
																{
																	obj_t BgL_fz00_29723;

																	BgL_fz00_29723 = BgL_rz00_17301;
																	BgL_fz00_17300 = BgL_fz00_29723;
																	goto BgL_recz00_17299;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17294, ((long) 0),
																		BgL_savedzd2bpzd2_17298);
																	BgL_____rz00_17297 = BgL_rz00_17301;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17296);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17295, BgL_sz00_17288);
											return BgL_____rz00_17297;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5743 */
	obj_t BGl_z62run5743z62zz__evaluate_compz00(obj_t BgL_envz00_14847,
		obj_t BgL_sz00_14852)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				long BgL_siza7eza7_14848;
				obj_t BgL_valza2za2_14849;
				BgL_ev_absz00_bglt BgL_i1247z00_14850;
				obj_t BgL_bodyz00_14851;

				BgL_siza7eza7_14848 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14847, (int) (((long) 0))));
				BgL_valza2za2_14849 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14847, (int) (((long) 1))));
				BgL_i1247z00_14850 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14847, (int) (((long) 2))));
				BgL_bodyz00_14851 = PROCEDURE_REF(BgL_envz00_14847, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17303;

					BgL_bpz00_17303 = VECTOR_REF(((obj_t) BgL_sz00_14852), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14852,
						BgL_valza2za2_14849,
						((long) CINT(BgL_bpz00_17303) + BgL_siza7eza7_14848));
					{	/* Eval/evaluate_comp.scm 1088 */
						obj_t BgL_z12denvz12_17304;
						obj_t BgL_wherez00_17305;
						obj_t BgL_locz00_17306;

						BgL_z12denvz12_17304 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17305 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14850))->
							BgL_wherez00);
						BgL_locz00_17306 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14850))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1088 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17304, BgL_wherez00_17305,
								BgL_locz00_17306);
							{	/* Eval/evaluate_comp.scm 1088 */
								obj_t BgL_za2za2resza2za2z00_17307;

								BgL_za2za2resza2za2z00_17307 =
									PROCEDURE_ENTRY(BgL_bodyz00_14851) (BgL_bodyz00_14851,
									BgL_sz00_14852, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17304);
								return BgL_za2za2resza2za2z00_17307;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3652> */
	obj_t BGl_z62zc3z04anonymousza33652ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14853, obj_t BgL_sz00_14860)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_ifreesz00_14854;
				obj_t BgL_iboxesz00_14855;
				long BgL_siza7eza7_14856;
				BgL_ev_absz00_bglt BgL_i1247z00_14857;
				obj_t BgL_bodyz00_14858;
				long BgL_siza7ezd2framez75_14859;

				BgL_ifreesz00_14854 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14853, (int) (((long) 0))));
				BgL_iboxesz00_14855 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14853, (int) (((long) 1))));
				BgL_siza7eza7_14856 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14853, (int) (((long) 2))));
				BgL_i1247z00_14857 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14853, (int) (((long) 3))));
				BgL_bodyz00_14858 = PROCEDURE_REF(BgL_envz00_14853, (int) (((long) 4)));
				BgL_siza7ezd2framez75_14859 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14853, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17308;

					BgL_bpz00_17308 = VECTOR_REF(((obj_t) BgL_sz00_14860), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_valza2za2_17309;

						BgL_valza2za2_17309 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14860,
							BgL_bpz00_17308, BgL_ifreesz00_14854);
						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17310;

							BgL_runz00_17310 =
								MAKE_FX_PROCEDURE(BGl_z62run5745z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_17310,
								(int) (((long) 0)), BgL_iboxesz00_14855);
							PROCEDURE_SET(BgL_runz00_17310,
								(int) (((long) 1)), BINT(BgL_siza7eza7_14856));
							PROCEDURE_SET(BgL_runz00_17310,
								(int) (((long) 2)), BgL_valza2za2_17309);
							PROCEDURE_SET(BgL_runz00_17310,
								(int) (((long) 3)), ((obj_t) BgL_i1247z00_14857));
							PROCEDURE_SET(BgL_runz00_17310,
								(int) (((long) 4)), BgL_bodyz00_14858);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17311;

								BgL_mainz00_17311 =
									MAKE_FX_PROCEDURE(BGl_z62main5744z62zz__evaluate_compz00,
									(int) (((long) 2)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_17311,
									(int) (((long) 0)), BgL_iboxesz00_14855);
								PROCEDURE_SET(BgL_mainz00_17311,
									(int) (((long) 1)), BINT(BgL_siza7eza7_14856));
								PROCEDURE_SET(BgL_mainz00_17311,
									(int) (((long) 2)), BgL_valza2za2_17309);
								PROCEDURE_SET(BgL_mainz00_17311,
									(int) (((long) 3)), ((obj_t) BgL_i1247z00_14857));
								PROCEDURE_SET(BgL_mainz00_17311,
									(int) (((long) 4)), BgL_bodyz00_14858);
								PROCEDURE_SET(BgL_mainz00_17311,
									(int) (((long) 5)), BgL_runz00_17310);
								PROCEDURE_SET(BgL_mainz00_17311,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_14859));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17312;

									BgL_objz00_17312 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17310, BgL_objz00_17312);
									BgL_objz00_17312;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3653z00_17313;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3654z00_17314;

										BgL_arg3654z00_17314 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14857))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17315;

											BgL_newz00_17315 =
												create_struct(BGl_symbol5815z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_29811;

												BgL_tmpz00_29811 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17315, BgL_tmpz00_29811,
													BgL_arg3654z00_17314);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_29816;
												int BgL_tmpz00_29814;

												BgL_auxz00_29816 = BINT(BgL_siza7ezd2framez75_14859);
												BgL_tmpz00_29814 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17315, BgL_tmpz00_29814,
													BgL_auxz00_29816);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_29819;

												BgL_tmpz00_29819 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17315, BgL_tmpz00_29819,
													BgL_runz00_17310);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_29824;
												int BgL_tmpz00_29822;

												BgL_auxz00_29824 = BINT(((long) 2));
												BgL_tmpz00_29822 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17315, BgL_tmpz00_29822,
													BgL_auxz00_29824);
											}
											BgL_arg3653z00_17313 = BgL_newz00_17315;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17311, BgL_arg3653z00_17313);
									BgL_arg3653z00_17313;
								}
								return BgL_mainz00_17311;
							}
						}
					}
				}
			}
		}

	}



/* &main5744 */
	obj_t BGl_z62main5744z62zz__evaluate_compz00(obj_t BgL_envz00_14861,
		obj_t BgL_cz00_14869, obj_t BgL_dz00_14870)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14867;
				long BgL_siza7ezd2framez75_14868;

				BgL_runz00_14867 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14861, (int) (((long) 5))));
				BgL_siza7ezd2framez75_14868 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14861, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17316;

					BgL_sz00_17316 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17317;

						BgL_bpz00_17317 = VECTOR_REF(((obj_t) BgL_sz00_17316), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17317) + BgL_siza7ezd2framez75_14868) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17316))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3657z00_17318;

									BgL_arg3657z00_17318 =
										((long) CINT(BgL_bpz00_17317) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17316), BgL_arg3657z00_17318,
										BgL_cz00_14869);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3659z00_17319;

									BgL_arg3659z00_17319 =
										((long) CINT(BgL_bpz00_17317) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17316), BgL_arg3659z00_17319,
										BgL_dz00_14870);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17320;

									BgL_ez00_17320 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17320,
										BgL_bpz00_17317);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17321;

										BgL_accz00_17321 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14867, BgL_sz00_17316, BgL_bpz00_17317);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17320);
										VECTOR_SET(
											((obj_t) BgL_sz00_17316), ((long) 0), BgL_bpz00_17317);
										return BgL_accz00_17321;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17322;

								BgL_nsz00_17322 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17322, ((long) 1), BgL_sz00_17316);
								VECTOR_SET(BgL_nsz00_17322, ((long) 2), BgL_cz00_14869);
								VECTOR_SET(BgL_nsz00_17322, ((long) 3), BgL_dz00_14870);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17323;

									BgL_z12denvz12_17323 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17323, BgL_nsz00_17322);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17324;

										BgL_ez00_17324 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17324,
											BgL_sz00_17316);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17325;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17326;

												BgL_savedzd2bpzd2_17326 =
													VECTOR_REF(BgL_nsz00_17322, ((long) 0));
												VECTOR_SET(BgL_nsz00_17322, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17328;

													BgL_fz00_17328 = BgL_runz00_14867;
												BgL_recz00_17327:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17329;

														BgL_rz00_17329 =
															PROCEDURE_ENTRY(BgL_fz00_17328) (BgL_fz00_17328,
															BgL_nsz00_17322, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_test6662z00_29872;

															if (PROCEDUREP(BgL_rz00_17329))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1707z00_17330;

																	BgL_arg1707z00_17330 =
																		PROCEDURE_ATTR(BgL_rz00_17329);
																	if (STRUCTP(BgL_arg1707z00_17330))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6662z00_29872 =
																				(STRUCT_KEY(BgL_arg1707z00_17330) ==
																				BGl_symbol5794z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6662z00_29872 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_test6662z00_29872 = ((bool_t) 0);
																}
															if (BgL_test6662z00_29872)
																{
																	obj_t BgL_fz00_29880;

																	BgL_fz00_29880 = BgL_rz00_17329;
																	BgL_fz00_17328 = BgL_fz00_29880;
																	goto BgL_recz00_17327;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17322, ((long) 0),
																		BgL_savedzd2bpzd2_17326);
																	BgL_____rz00_17325 = BgL_rz00_17329;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17324);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17323, BgL_sz00_17316);
											return BgL_____rz00_17325;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5745 */
	obj_t BGl_z62run5745z62zz__evaluate_compz00(obj_t BgL_envz00_14871,
		obj_t BgL_sz00_14877)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_14872;
				long BgL_siza7eza7_14873;
				obj_t BgL_valza2za2_14874;
				BgL_ev_absz00_bglt BgL_i1247z00_14875;
				obj_t BgL_bodyz00_14876;

				BgL_iboxesz00_14872 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14871, (int) (((long) 0))));
				BgL_siza7eza7_14873 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14871, (int) (((long) 1))));
				BgL_valza2za2_14874 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14871, (int) (((long) 2))));
				BgL_i1247z00_14875 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14871, (int) (((long) 3))));
				BgL_bodyz00_14876 = PROCEDURE_REF(BgL_envz00_14871, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17331;

					BgL_bpz00_17331 = VECTOR_REF(((obj_t) BgL_sz00_14877), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14877,
						BgL_iboxesz00_14872, BgL_bpz00_17331);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14877,
						BgL_valza2za2_14874,
						((long) CINT(BgL_bpz00_17331) + BgL_siza7eza7_14873));
					{	/* Eval/evaluate_comp.scm 1088 */
						obj_t BgL_z12denvz12_17332;
						obj_t BgL_wherez00_17333;
						obj_t BgL_locz00_17334;

						BgL_z12denvz12_17332 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17333 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14875))->
							BgL_wherez00);
						BgL_locz00_17334 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14875))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1088 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17332, BgL_wherez00_17333,
								BgL_locz00_17334);
							{	/* Eval/evaluate_comp.scm 1088 */
								obj_t BgL_za2za2resza2za2z00_17335;

								BgL_za2za2resza2za2z00_17335 =
									PROCEDURE_ENTRY(BgL_bodyz00_14876) (BgL_bodyz00_14876,
									BgL_sz00_14877, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17332);
								return BgL_za2za2resza2za2z00_17335;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3573> */
	obj_t BGl_z62zc3z04anonymousza33573ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14878, obj_t BgL_sz00_14882)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1247z00_14879;
				obj_t BgL_bodyz00_14880;
				long BgL_siza7ezd2framez75_14881;

				BgL_i1247z00_14879 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14878, (int) (((long) 0))));
				BgL_bodyz00_14880 = PROCEDURE_REF(BgL_envz00_14878, (int) (((long) 1)));
				BgL_siza7ezd2framez75_14881 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14878, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17336;

					BgL_bpz00_17336 = VECTOR_REF(((obj_t) BgL_sz00_14882), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */

						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17337;

							BgL_runz00_17337 =
								MAKE_FX_PROCEDURE(BGl_z62run5747z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_17337,
								(int) (((long) 0)), ((obj_t) BgL_i1247z00_14879));
							PROCEDURE_SET(BgL_runz00_17337,
								(int) (((long) 1)), BgL_bodyz00_14880);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17338;

								BgL_mainz00_17338 =
									MAKE_VA_PROCEDURE(BGl_z62main5746z62zz__evaluate_compz00,
									(int) (((long) -2)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_17338,
									(int) (((long) 0)), ((obj_t) BgL_i1247z00_14879));
								PROCEDURE_SET(BgL_mainz00_17338,
									(int) (((long) 1)), BgL_bodyz00_14880);
								PROCEDURE_SET(BgL_mainz00_17338,
									(int) (((long) 2)), BgL_runz00_17337);
								PROCEDURE_SET(BgL_mainz00_17338,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_14881));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17339;

									BgL_objz00_17339 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17337, BgL_objz00_17339);
									BgL_objz00_17339;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3574z00_17340;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3576z00_17341;

										BgL_arg3576z00_17341 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14879))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17342;

											BgL_newz00_17342 =
												create_struct(BGl_symbol5815z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_29948;

												BgL_tmpz00_29948 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17342, BgL_tmpz00_29948,
													BgL_arg3576z00_17341);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_29953;
												int BgL_tmpz00_29951;

												BgL_auxz00_29953 = BINT(BgL_siza7ezd2framez75_14881);
												BgL_tmpz00_29951 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17342, BgL_tmpz00_29951,
													BgL_auxz00_29953);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_29956;

												BgL_tmpz00_29956 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17342, BgL_tmpz00_29956,
													BgL_runz00_17337);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_29961;
												int BgL_tmpz00_29959;

												BgL_auxz00_29961 = BINT(((long) -2));
												BgL_tmpz00_29959 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17342, BgL_tmpz00_29959,
													BgL_auxz00_29961);
											}
											BgL_arg3574z00_17340 = BgL_newz00_17342;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17338, BgL_arg3574z00_17340);
									BgL_arg3574z00_17340;
								}
								return BgL_mainz00_17338;
							}
						}
					}
				}
			}
		}

	}



/* &main5746 */
	obj_t BGl_z62main5746z62zz__evaluate_compz00(obj_t BgL_envz00_14883,
		obj_t BgL_dz00_14888, obj_t BgL_lastz00_14889)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14886;
				long BgL_siza7ezd2framez75_14887;

				BgL_runz00_14886 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14883, (int) (((long) 2))));
				BgL_siza7ezd2framez75_14887 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14883, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17343;

					BgL_sz00_17343 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17344;

						BgL_bpz00_17344 = VECTOR_REF(((obj_t) BgL_sz00_17343), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17344) + BgL_siza7ezd2framez75_14887) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17343))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3579z00_17345;

									BgL_arg3579z00_17345 =
										((long) CINT(BgL_bpz00_17344) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17343), BgL_arg3579z00_17345,
										BgL_dz00_14888);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3580z00_17346;

									BgL_arg3580z00_17346 =
										((long) CINT(BgL_bpz00_17344) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17343), BgL_arg3580z00_17346,
										BgL_lastz00_14889);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17347;

									BgL_ez00_17347 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17347,
										BgL_bpz00_17344);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17348;

										BgL_accz00_17348 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14886, BgL_sz00_17343, BgL_bpz00_17344);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17347);
										VECTOR_SET(
											((obj_t) BgL_sz00_17343), ((long) 0), BgL_bpz00_17344);
										return BgL_accz00_17348;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17349;

								BgL_nsz00_17349 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17349, ((long) 1), BgL_sz00_17343);
								VECTOR_SET(BgL_nsz00_17349, ((long) 2), BgL_dz00_14888);
								VECTOR_SET(BgL_nsz00_17349, ((long) 3), BgL_lastz00_14889);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17350;

									BgL_z12denvz12_17350 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17350, BgL_nsz00_17349);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17351;

										BgL_ez00_17351 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17351,
											BgL_sz00_17343);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17352;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17353;

												BgL_savedzd2bpzd2_17353 =
													VECTOR_REF(BgL_nsz00_17349, ((long) 0));
												VECTOR_SET(BgL_nsz00_17349, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17355;

													BgL_fz00_17355 = BgL_runz00_14886;
												BgL_recz00_17354:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17356;

														BgL_rz00_17356 =
															PROCEDURE_ENTRY(BgL_fz00_17355) (BgL_fz00_17355,
															BgL_nsz00_17349, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_test6666z00_30009;

															if (PROCEDUREP(BgL_rz00_17356))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1707z00_17357;

																	BgL_arg1707z00_17357 =
																		PROCEDURE_ATTR(BgL_rz00_17356);
																	if (STRUCTP(BgL_arg1707z00_17357))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6666z00_30009 =
																				(STRUCT_KEY(BgL_arg1707z00_17357) ==
																				BGl_symbol5794z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6666z00_30009 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_test6666z00_30009 = ((bool_t) 0);
																}
															if (BgL_test6666z00_30009)
																{
																	obj_t BgL_fz00_30017;

																	BgL_fz00_30017 = BgL_rz00_17356;
																	BgL_fz00_17355 = BgL_fz00_30017;
																	goto BgL_recz00_17354;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17349, ((long) 0),
																		BgL_savedzd2bpzd2_17353);
																	BgL_____rz00_17352 = BgL_rz00_17356;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17351);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17350, BgL_sz00_17343);
											return BgL_____rz00_17352;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5747 */
	obj_t BGl_z62run5747z62zz__evaluate_compz00(obj_t BgL_envz00_14890,
		obj_t BgL_sz00_14893)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1247z00_14891;
				obj_t BgL_bodyz00_14892;

				BgL_i1247z00_14891 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14890, (int) (((long) 0))));
				BgL_bodyz00_14892 = PROCEDURE_REF(BgL_envz00_14890, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17358;

					BgL_bpz00_17358 = VECTOR_REF(((obj_t) BgL_sz00_14893), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_z12denvz12_17359;
						obj_t BgL_wherez00_17360;
						obj_t BgL_locz00_17361;

						BgL_z12denvz12_17359 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17360 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14891))->
							BgL_wherez00);
						BgL_locz00_17361 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14891))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1167 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17359, BgL_wherez00_17360,
								BgL_locz00_17361);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_za2za2resza2za2z00_17362;

								BgL_za2za2resza2za2z00_17362 =
									PROCEDURE_ENTRY(BgL_bodyz00_14892) (BgL_bodyz00_14892,
									BgL_sz00_14893, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17359);
								return BgL_za2za2resza2za2z00_17362;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3582> */
	obj_t BGl_z62zc3z04anonymousza33582ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14894, obj_t BgL_sz00_14899)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_14895;
				BgL_ev_absz00_bglt BgL_i1247z00_14896;
				obj_t BgL_bodyz00_14897;
				long BgL_siza7ezd2framez75_14898;

				BgL_iboxesz00_14895 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14894, (int) (((long) 0))));
				BgL_i1247z00_14896 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14894, (int) (((long) 1))));
				BgL_bodyz00_14897 = PROCEDURE_REF(BgL_envz00_14894, (int) (((long) 2)));
				BgL_siza7ezd2framez75_14898 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14894, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17363;

					BgL_bpz00_17363 = VECTOR_REF(((obj_t) BgL_sz00_14899), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */

						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17364;

							BgL_runz00_17364 =
								MAKE_FX_PROCEDURE(BGl_z62run5749z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_17364,
								(int) (((long) 0)), BgL_iboxesz00_14895);
							PROCEDURE_SET(BgL_runz00_17364,
								(int) (((long) 1)), ((obj_t) BgL_i1247z00_14896));
							PROCEDURE_SET(BgL_runz00_17364,
								(int) (((long) 2)), BgL_bodyz00_14897);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17365;

								BgL_mainz00_17365 =
									MAKE_VA_PROCEDURE(BGl_z62main5748z62zz__evaluate_compz00,
									(int) (((long) -2)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_17365,
									(int) (((long) 0)), BgL_iboxesz00_14895);
								PROCEDURE_SET(BgL_mainz00_17365,
									(int) (((long) 1)), ((obj_t) BgL_i1247z00_14896));
								PROCEDURE_SET(BgL_mainz00_17365,
									(int) (((long) 2)), BgL_bodyz00_14897);
								PROCEDURE_SET(BgL_mainz00_17365,
									(int) (((long) 3)), BgL_runz00_17364);
								PROCEDURE_SET(BgL_mainz00_17365,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_14898));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17366;

									BgL_objz00_17366 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17364, BgL_objz00_17366);
									BgL_objz00_17366;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3583z00_17367;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3584z00_17368;

										BgL_arg3584z00_17368 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14896))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17369;

											BgL_newz00_17369 =
												create_struct(BGl_symbol5815z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_30079;

												BgL_tmpz00_30079 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17369, BgL_tmpz00_30079,
													BgL_arg3584z00_17368);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_30084;
												int BgL_tmpz00_30082;

												BgL_auxz00_30084 = BINT(BgL_siza7ezd2framez75_14898);
												BgL_tmpz00_30082 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17369, BgL_tmpz00_30082,
													BgL_auxz00_30084);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_30087;

												BgL_tmpz00_30087 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17369, BgL_tmpz00_30087,
													BgL_runz00_17364);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_30092;
												int BgL_tmpz00_30090;

												BgL_auxz00_30092 = BINT(((long) -2));
												BgL_tmpz00_30090 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17369, BgL_tmpz00_30090,
													BgL_auxz00_30092);
											}
											BgL_arg3583z00_17367 = BgL_newz00_17369;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17365, BgL_arg3583z00_17367);
									BgL_arg3583z00_17367;
								}
								return BgL_mainz00_17365;
							}
						}
					}
				}
			}
		}

	}



/* &main5748 */
	obj_t BGl_z62main5748z62zz__evaluate_compz00(obj_t BgL_envz00_14900,
		obj_t BgL_dz00_14906, obj_t BgL_lastz00_14907)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14904;
				long BgL_siza7ezd2framez75_14905;

				BgL_runz00_14904 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14900, (int) (((long) 3))));
				BgL_siza7ezd2framez75_14905 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14900, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17370;

					BgL_sz00_17370 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17371;

						BgL_bpz00_17371 = VECTOR_REF(((obj_t) BgL_sz00_17370), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17371) + BgL_siza7ezd2framez75_14905) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17370))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3587z00_17372;

									BgL_arg3587z00_17372 =
										((long) CINT(BgL_bpz00_17371) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17370), BgL_arg3587z00_17372,
										BgL_dz00_14906);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3589z00_17373;

									BgL_arg3589z00_17373 =
										((long) CINT(BgL_bpz00_17371) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17370), BgL_arg3589z00_17373,
										BgL_lastz00_14907);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17374;

									BgL_ez00_17374 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17374,
										BgL_bpz00_17371);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17375;

										BgL_accz00_17375 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14904, BgL_sz00_17370, BgL_bpz00_17371);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17374);
										VECTOR_SET(
											((obj_t) BgL_sz00_17370), ((long) 0), BgL_bpz00_17371);
										return BgL_accz00_17375;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17376;

								BgL_nsz00_17376 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17376, ((long) 1), BgL_sz00_17370);
								VECTOR_SET(BgL_nsz00_17376, ((long) 2), BgL_dz00_14906);
								VECTOR_SET(BgL_nsz00_17376, ((long) 3), BgL_lastz00_14907);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17377;

									BgL_z12denvz12_17377 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17377, BgL_nsz00_17376);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17378;

										BgL_ez00_17378 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17378,
											BgL_sz00_17370);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17379;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17380;

												BgL_savedzd2bpzd2_17380 =
													VECTOR_REF(BgL_nsz00_17376, ((long) 0));
												VECTOR_SET(BgL_nsz00_17376, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17382;

													BgL_fz00_17382 = BgL_runz00_14904;
												BgL_recz00_17381:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17383;

														BgL_rz00_17383 =
															PROCEDURE_ENTRY(BgL_fz00_17382) (BgL_fz00_17382,
															BgL_nsz00_17376, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_test6670z00_30140;

															if (PROCEDUREP(BgL_rz00_17383))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1707z00_17384;

																	BgL_arg1707z00_17384 =
																		PROCEDURE_ATTR(BgL_rz00_17383);
																	if (STRUCTP(BgL_arg1707z00_17384))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6670z00_30140 =
																				(STRUCT_KEY(BgL_arg1707z00_17384) ==
																				BGl_symbol5794z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6670z00_30140 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_test6670z00_30140 = ((bool_t) 0);
																}
															if (BgL_test6670z00_30140)
																{
																	obj_t BgL_fz00_30148;

																	BgL_fz00_30148 = BgL_rz00_17383;
																	BgL_fz00_17382 = BgL_fz00_30148;
																	goto BgL_recz00_17381;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17376, ((long) 0),
																		BgL_savedzd2bpzd2_17380);
																	BgL_____rz00_17379 = BgL_rz00_17383;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17378);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17377, BgL_sz00_17370);
											return BgL_____rz00_17379;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5749 */
	obj_t BGl_z62run5749z62zz__evaluate_compz00(obj_t BgL_envz00_14908,
		obj_t BgL_sz00_14912)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_14909;
				BgL_ev_absz00_bglt BgL_i1247z00_14910;
				obj_t BgL_bodyz00_14911;

				BgL_iboxesz00_14909 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14908, (int) (((long) 0))));
				BgL_i1247z00_14910 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14908, (int) (((long) 1))));
				BgL_bodyz00_14911 = PROCEDURE_REF(BgL_envz00_14908, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17385;

					BgL_bpz00_17385 = VECTOR_REF(((obj_t) BgL_sz00_14912), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14912,
						BgL_iboxesz00_14909, BgL_bpz00_17385);
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_z12denvz12_17386;
						obj_t BgL_wherez00_17387;
						obj_t BgL_locz00_17388;

						BgL_z12denvz12_17386 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17387 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14910))->
							BgL_wherez00);
						BgL_locz00_17388 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14910))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1167 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17386, BgL_wherez00_17387,
								BgL_locz00_17388);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_za2za2resza2za2z00_17389;

								BgL_za2za2resza2za2z00_17389 =
									PROCEDURE_ENTRY(BgL_bodyz00_14911) (BgL_bodyz00_14911,
									BgL_sz00_14912, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17386);
								return BgL_za2za2resza2za2z00_17389;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3594> */
	obj_t BGl_z62zc3z04anonymousza33594ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14913, obj_t BgL_sz00_14919)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_ifreesz00_14914;
				long BgL_siza7eza7_14915;
				BgL_ev_absz00_bglt BgL_i1247z00_14916;
				obj_t BgL_bodyz00_14917;
				long BgL_siza7ezd2framez75_14918;

				BgL_ifreesz00_14914 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14913, (int) (((long) 0))));
				BgL_siza7eza7_14915 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14913, (int) (((long) 1))));
				BgL_i1247z00_14916 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14913, (int) (((long) 2))));
				BgL_bodyz00_14917 = PROCEDURE_REF(BgL_envz00_14913, (int) (((long) 3)));
				BgL_siza7ezd2framez75_14918 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14913, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17390;

					BgL_bpz00_17390 = VECTOR_REF(((obj_t) BgL_sz00_14919), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_valza2za2_17391;

						BgL_valza2za2_17391 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14919,
							BgL_bpz00_17390, BgL_ifreesz00_14914);
						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17392;

							BgL_runz00_17392 =
								MAKE_FX_PROCEDURE(BGl_z62run5751z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_17392,
								(int) (((long) 0)), BINT(BgL_siza7eza7_14915));
							PROCEDURE_SET(BgL_runz00_17392,
								(int) (((long) 1)), BgL_valza2za2_17391);
							PROCEDURE_SET(BgL_runz00_17392,
								(int) (((long) 2)), ((obj_t) BgL_i1247z00_14916));
							PROCEDURE_SET(BgL_runz00_17392,
								(int) (((long) 3)), BgL_bodyz00_14917);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17393;

								BgL_mainz00_17393 =
									MAKE_VA_PROCEDURE(BGl_z62main5750z62zz__evaluate_compz00,
									(int) (((long) -2)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_17393,
									(int) (((long) 0)), BINT(BgL_siza7eza7_14915));
								PROCEDURE_SET(BgL_mainz00_17393,
									(int) (((long) 1)), BgL_valza2za2_17391);
								PROCEDURE_SET(BgL_mainz00_17393,
									(int) (((long) 2)), ((obj_t) BgL_i1247z00_14916));
								PROCEDURE_SET(BgL_mainz00_17393,
									(int) (((long) 3)), BgL_bodyz00_14917);
								PROCEDURE_SET(BgL_mainz00_17393,
									(int) (((long) 4)), BgL_runz00_17392);
								PROCEDURE_SET(BgL_mainz00_17393,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_14918));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17394;

									BgL_objz00_17394 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17392, BgL_objz00_17394);
									BgL_objz00_17394;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3596z00_17395;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3597z00_17396;

										BgL_arg3597z00_17396 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14916))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17397;

											BgL_newz00_17397 =
												create_struct(BGl_symbol5815z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_30224;

												BgL_tmpz00_30224 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17397, BgL_tmpz00_30224,
													BgL_arg3597z00_17396);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_30229;
												int BgL_tmpz00_30227;

												BgL_auxz00_30229 = BINT(BgL_siza7ezd2framez75_14918);
												BgL_tmpz00_30227 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17397, BgL_tmpz00_30227,
													BgL_auxz00_30229);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_30232;

												BgL_tmpz00_30232 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17397, BgL_tmpz00_30232,
													BgL_runz00_17392);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_30237;
												int BgL_tmpz00_30235;

												BgL_auxz00_30237 = BINT(((long) -2));
												BgL_tmpz00_30235 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17397, BgL_tmpz00_30235,
													BgL_auxz00_30237);
											}
											BgL_arg3596z00_17395 = BgL_newz00_17397;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17393, BgL_arg3596z00_17395);
									BgL_arg3596z00_17395;
								}
								return BgL_mainz00_17393;
							}
						}
					}
				}
			}
		}

	}



/* &main5750 */
	obj_t BGl_z62main5750z62zz__evaluate_compz00(obj_t BgL_envz00_14920,
		obj_t BgL_dz00_14927, obj_t BgL_lastz00_14928)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14925;
				long BgL_siza7ezd2framez75_14926;

				BgL_runz00_14925 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14920, (int) (((long) 4))));
				BgL_siza7ezd2framez75_14926 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14920, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17398;

					BgL_sz00_17398 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17399;

						BgL_bpz00_17399 = VECTOR_REF(((obj_t) BgL_sz00_17398), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17399) + BgL_siza7ezd2framez75_14926) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17398))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3600z00_17400;

									BgL_arg3600z00_17400 =
										((long) CINT(BgL_bpz00_17399) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17398), BgL_arg3600z00_17400,
										BgL_dz00_14927);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3601z00_17401;

									BgL_arg3601z00_17401 =
										((long) CINT(BgL_bpz00_17399) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17398), BgL_arg3601z00_17401,
										BgL_lastz00_14928);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17402;

									BgL_ez00_17402 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17402,
										BgL_bpz00_17399);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17403;

										BgL_accz00_17403 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14925, BgL_sz00_17398, BgL_bpz00_17399);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17402);
										VECTOR_SET(
											((obj_t) BgL_sz00_17398), ((long) 0), BgL_bpz00_17399);
										return BgL_accz00_17403;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17404;

								BgL_nsz00_17404 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17404, ((long) 1), BgL_sz00_17398);
								VECTOR_SET(BgL_nsz00_17404, ((long) 2), BgL_dz00_14927);
								VECTOR_SET(BgL_nsz00_17404, ((long) 3), BgL_lastz00_14928);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17405;

									BgL_z12denvz12_17405 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17405, BgL_nsz00_17404);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17406;

										BgL_ez00_17406 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17406,
											BgL_sz00_17398);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17407;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17408;

												BgL_savedzd2bpzd2_17408 =
													VECTOR_REF(BgL_nsz00_17404, ((long) 0));
												VECTOR_SET(BgL_nsz00_17404, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17410;

													BgL_fz00_17410 = BgL_runz00_14925;
												BgL_recz00_17409:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17411;

														BgL_rz00_17411 =
															PROCEDURE_ENTRY(BgL_fz00_17410) (BgL_fz00_17410,
															BgL_nsz00_17404, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_test6674z00_30285;

															if (PROCEDUREP(BgL_rz00_17411))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1707z00_17412;

																	BgL_arg1707z00_17412 =
																		PROCEDURE_ATTR(BgL_rz00_17411);
																	if (STRUCTP(BgL_arg1707z00_17412))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6674z00_30285 =
																				(STRUCT_KEY(BgL_arg1707z00_17412) ==
																				BGl_symbol5794z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6674z00_30285 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_test6674z00_30285 = ((bool_t) 0);
																}
															if (BgL_test6674z00_30285)
																{
																	obj_t BgL_fz00_30293;

																	BgL_fz00_30293 = BgL_rz00_17411;
																	BgL_fz00_17410 = BgL_fz00_30293;
																	goto BgL_recz00_17409;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17404, ((long) 0),
																		BgL_savedzd2bpzd2_17408);
																	BgL_____rz00_17407 = BgL_rz00_17411;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17406);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17405, BgL_sz00_17398);
											return BgL_____rz00_17407;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5751 */
	obj_t BGl_z62run5751z62zz__evaluate_compz00(obj_t BgL_envz00_14929,
		obj_t BgL_sz00_14934)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				long BgL_siza7eza7_14930;
				obj_t BgL_valza2za2_14931;
				BgL_ev_absz00_bglt BgL_i1247z00_14932;
				obj_t BgL_bodyz00_14933;

				BgL_siza7eza7_14930 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14929, (int) (((long) 0))));
				BgL_valza2za2_14931 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14929, (int) (((long) 1))));
				BgL_i1247z00_14932 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14929, (int) (((long) 2))));
				BgL_bodyz00_14933 = PROCEDURE_REF(BgL_envz00_14929, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17413;

					BgL_bpz00_17413 = VECTOR_REF(((obj_t) BgL_sz00_14934), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14934,
						BgL_valza2za2_14931,
						((long) CINT(BgL_bpz00_17413) + BgL_siza7eza7_14930));
					{	/* Eval/evaluate_comp.scm 1088 */
						obj_t BgL_z12denvz12_17414;
						obj_t BgL_wherez00_17415;
						obj_t BgL_locz00_17416;

						BgL_z12denvz12_17414 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17415 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14932))->
							BgL_wherez00);
						BgL_locz00_17416 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14932))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1088 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17414, BgL_wherez00_17415,
								BgL_locz00_17416);
							{	/* Eval/evaluate_comp.scm 1088 */
								obj_t BgL_za2za2resza2za2z00_17417;

								BgL_za2za2resza2za2z00_17417 =
									PROCEDURE_ENTRY(BgL_bodyz00_14933) (BgL_bodyz00_14933,
									BgL_sz00_14934, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17414);
								return BgL_za2za2resza2za2z00_17417;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3605> */
	obj_t BGl_z62zc3z04anonymousza33605ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14935, obj_t BgL_sz00_14942)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_ifreesz00_14936;
				obj_t BgL_iboxesz00_14937;
				long BgL_siza7eza7_14938;
				BgL_ev_absz00_bglt BgL_i1247z00_14939;
				obj_t BgL_bodyz00_14940;
				long BgL_siza7ezd2framez75_14941;

				BgL_ifreesz00_14936 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14935, (int) (((long) 0))));
				BgL_iboxesz00_14937 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14935, (int) (((long) 1))));
				BgL_siza7eza7_14938 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14935, (int) (((long) 2))));
				BgL_i1247z00_14939 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14935, (int) (((long) 3))));
				BgL_bodyz00_14940 = PROCEDURE_REF(BgL_envz00_14935, (int) (((long) 4)));
				BgL_siza7ezd2framez75_14941 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14935, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17418;

					BgL_bpz00_17418 = VECTOR_REF(((obj_t) BgL_sz00_14942), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_valza2za2_17419;

						BgL_valza2za2_17419 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14942,
							BgL_bpz00_17418, BgL_ifreesz00_14936);
						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17420;

							BgL_runz00_17420 =
								MAKE_FX_PROCEDURE(BGl_z62run5753z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_17420,
								(int) (((long) 0)), BgL_iboxesz00_14937);
							PROCEDURE_SET(BgL_runz00_17420,
								(int) (((long) 1)), BINT(BgL_siza7eza7_14938));
							PROCEDURE_SET(BgL_runz00_17420,
								(int) (((long) 2)), BgL_valza2za2_17419);
							PROCEDURE_SET(BgL_runz00_17420,
								(int) (((long) 3)), ((obj_t) BgL_i1247z00_14939));
							PROCEDURE_SET(BgL_runz00_17420,
								(int) (((long) 4)), BgL_bodyz00_14940);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17421;

								BgL_mainz00_17421 =
									MAKE_VA_PROCEDURE(BGl_z62main5752z62zz__evaluate_compz00,
									(int) (((long) -2)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_17421,
									(int) (((long) 0)), BgL_iboxesz00_14937);
								PROCEDURE_SET(BgL_mainz00_17421,
									(int) (((long) 1)), BINT(BgL_siza7eza7_14938));
								PROCEDURE_SET(BgL_mainz00_17421,
									(int) (((long) 2)), BgL_valza2za2_17419);
								PROCEDURE_SET(BgL_mainz00_17421,
									(int) (((long) 3)), ((obj_t) BgL_i1247z00_14939));
								PROCEDURE_SET(BgL_mainz00_17421,
									(int) (((long) 4)), BgL_bodyz00_14940);
								PROCEDURE_SET(BgL_mainz00_17421,
									(int) (((long) 5)), BgL_runz00_17420);
								PROCEDURE_SET(BgL_mainz00_17421,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_14941));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17422;

									BgL_objz00_17422 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17420, BgL_objz00_17422);
									BgL_objz00_17422;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3607z00_17423;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3608z00_17424;

										BgL_arg3608z00_17424 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14939))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17425;

											BgL_newz00_17425 =
												create_struct(BGl_symbol5815z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_30381;

												BgL_tmpz00_30381 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17425, BgL_tmpz00_30381,
													BgL_arg3608z00_17424);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_30386;
												int BgL_tmpz00_30384;

												BgL_auxz00_30386 = BINT(BgL_siza7ezd2framez75_14941);
												BgL_tmpz00_30384 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17425, BgL_tmpz00_30384,
													BgL_auxz00_30386);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_30389;

												BgL_tmpz00_30389 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17425, BgL_tmpz00_30389,
													BgL_runz00_17420);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_30394;
												int BgL_tmpz00_30392;

												BgL_auxz00_30394 = BINT(((long) -2));
												BgL_tmpz00_30392 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17425, BgL_tmpz00_30392,
													BgL_auxz00_30394);
											}
											BgL_arg3607z00_17423 = BgL_newz00_17425;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17421, BgL_arg3607z00_17423);
									BgL_arg3607z00_17423;
								}
								return BgL_mainz00_17421;
							}
						}
					}
				}
			}
		}

	}



/* &main5752 */
	obj_t BGl_z62main5752z62zz__evaluate_compz00(obj_t BgL_envz00_14943,
		obj_t BgL_dz00_14951, obj_t BgL_lastz00_14952)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14949;
				long BgL_siza7ezd2framez75_14950;

				BgL_runz00_14949 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14943, (int) (((long) 5))));
				BgL_siza7ezd2framez75_14950 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14943, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17426;

					BgL_sz00_17426 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17427;

						BgL_bpz00_17427 = VECTOR_REF(((obj_t) BgL_sz00_17426), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17427) + BgL_siza7ezd2framez75_14950) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17426))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3611z00_17428;

									BgL_arg3611z00_17428 =
										((long) CINT(BgL_bpz00_17427) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17426), BgL_arg3611z00_17428,
										BgL_dz00_14951);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3612z00_17429;

									BgL_arg3612z00_17429 =
										((long) CINT(BgL_bpz00_17427) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17426), BgL_arg3612z00_17429,
										BgL_lastz00_14952);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17430;

									BgL_ez00_17430 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17430,
										BgL_bpz00_17427);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17431;

										BgL_accz00_17431 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14949, BgL_sz00_17426, BgL_bpz00_17427);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17430);
										VECTOR_SET(
											((obj_t) BgL_sz00_17426), ((long) 0), BgL_bpz00_17427);
										return BgL_accz00_17431;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17432;

								BgL_nsz00_17432 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17432, ((long) 1), BgL_sz00_17426);
								VECTOR_SET(BgL_nsz00_17432, ((long) 2), BgL_dz00_14951);
								VECTOR_SET(BgL_nsz00_17432, ((long) 3), BgL_lastz00_14952);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17433;

									BgL_z12denvz12_17433 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17433, BgL_nsz00_17432);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17434;

										BgL_ez00_17434 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17434,
											BgL_sz00_17426);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17435;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17436;

												BgL_savedzd2bpzd2_17436 =
													VECTOR_REF(BgL_nsz00_17432, ((long) 0));
												VECTOR_SET(BgL_nsz00_17432, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17438;

													BgL_fz00_17438 = BgL_runz00_14949;
												BgL_recz00_17437:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17439;

														BgL_rz00_17439 =
															PROCEDURE_ENTRY(BgL_fz00_17438) (BgL_fz00_17438,
															BgL_nsz00_17432, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_test6678z00_30442;

															if (PROCEDUREP(BgL_rz00_17439))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1707z00_17440;

																	BgL_arg1707z00_17440 =
																		PROCEDURE_ATTR(BgL_rz00_17439);
																	if (STRUCTP(BgL_arg1707z00_17440))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6678z00_30442 =
																				(STRUCT_KEY(BgL_arg1707z00_17440) ==
																				BGl_symbol5794z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6678z00_30442 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_test6678z00_30442 = ((bool_t) 0);
																}
															if (BgL_test6678z00_30442)
																{
																	obj_t BgL_fz00_30450;

																	BgL_fz00_30450 = BgL_rz00_17439;
																	BgL_fz00_17438 = BgL_fz00_30450;
																	goto BgL_recz00_17437;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17432, ((long) 0),
																		BgL_savedzd2bpzd2_17436);
																	BgL_____rz00_17435 = BgL_rz00_17439;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17434);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17433, BgL_sz00_17426);
											return BgL_____rz00_17435;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5753 */
	obj_t BGl_z62run5753z62zz__evaluate_compz00(obj_t BgL_envz00_14953,
		obj_t BgL_sz00_14959)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_14954;
				long BgL_siza7eza7_14955;
				obj_t BgL_valza2za2_14956;
				BgL_ev_absz00_bglt BgL_i1247z00_14957;
				obj_t BgL_bodyz00_14958;

				BgL_iboxesz00_14954 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14953, (int) (((long) 0))));
				BgL_siza7eza7_14955 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14953, (int) (((long) 1))));
				BgL_valza2za2_14956 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14953, (int) (((long) 2))));
				BgL_i1247z00_14957 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14953, (int) (((long) 3))));
				BgL_bodyz00_14958 = PROCEDURE_REF(BgL_envz00_14953, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17441;

					BgL_bpz00_17441 = VECTOR_REF(((obj_t) BgL_sz00_14959), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14959,
						BgL_iboxesz00_14954, BgL_bpz00_17441);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14959,
						BgL_valza2za2_14956,
						((long) CINT(BgL_bpz00_17441) + BgL_siza7eza7_14955));
					{	/* Eval/evaluate_comp.scm 1088 */
						obj_t BgL_z12denvz12_17442;
						obj_t BgL_wherez00_17443;
						obj_t BgL_locz00_17444;

						BgL_z12denvz12_17442 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17443 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14957))->
							BgL_wherez00);
						BgL_locz00_17444 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14957))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1088 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17442, BgL_wherez00_17443,
								BgL_locz00_17444);
							{	/* Eval/evaluate_comp.scm 1088 */
								obj_t BgL_za2za2resza2za2z00_17445;

								BgL_za2za2resza2za2z00_17445 =
									PROCEDURE_ENTRY(BgL_bodyz00_14958) (BgL_bodyz00_14958,
									BgL_sz00_14959, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17442);
								return BgL_za2za2resza2za2z00_17445;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3528> */
	obj_t BGl_z62zc3z04anonymousza33528ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14960, obj_t BgL_sz00_14964)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1247z00_14961;
				obj_t BgL_bodyz00_14962;
				long BgL_siza7ezd2framez75_14963;

				BgL_i1247z00_14961 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14960, (int) (((long) 0))));
				BgL_bodyz00_14962 = PROCEDURE_REF(BgL_envz00_14960, (int) (((long) 1)));
				BgL_siza7ezd2framez75_14963 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14960, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17446;

					BgL_bpz00_17446 = VECTOR_REF(((obj_t) BgL_sz00_14964), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */

						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17447;

							BgL_runz00_17447 =
								MAKE_FX_PROCEDURE(BGl_z62run5755z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_17447,
								(int) (((long) 0)), ((obj_t) BgL_i1247z00_14961));
							PROCEDURE_SET(BgL_runz00_17447,
								(int) (((long) 1)), BgL_bodyz00_14962);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17448;

								BgL_mainz00_17448 =
									MAKE_FX_PROCEDURE(BGl_z62main5754z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_17448,
									(int) (((long) 0)), ((obj_t) BgL_i1247z00_14961));
								PROCEDURE_SET(BgL_mainz00_17448,
									(int) (((long) 1)), BgL_bodyz00_14962);
								PROCEDURE_SET(BgL_mainz00_17448,
									(int) (((long) 2)), BgL_runz00_17447);
								PROCEDURE_SET(BgL_mainz00_17448,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_14963));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17449;

									BgL_objz00_17449 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17447, BgL_objz00_17449);
									BgL_objz00_17449;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3529z00_17450;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3530z00_17451;

										BgL_arg3530z00_17451 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14961))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17452;

											BgL_newz00_17452 =
												create_struct(BGl_symbol5815z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_30518;

												BgL_tmpz00_30518 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17452, BgL_tmpz00_30518,
													BgL_arg3530z00_17451);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_30523;
												int BgL_tmpz00_30521;

												BgL_auxz00_30523 = BINT(BgL_siza7ezd2framez75_14963);
												BgL_tmpz00_30521 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17452, BgL_tmpz00_30521,
													BgL_auxz00_30523);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_30526;

												BgL_tmpz00_30526 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17452, BgL_tmpz00_30526,
													BgL_runz00_17447);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_30531;
												int BgL_tmpz00_30529;

												BgL_auxz00_30531 = BINT(((long) 1));
												BgL_tmpz00_30529 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17452, BgL_tmpz00_30529,
													BgL_auxz00_30531);
											}
											BgL_arg3529z00_17450 = BgL_newz00_17452;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17448, BgL_arg3529z00_17450);
									BgL_arg3529z00_17450;
								}
								return BgL_mainz00_17448;
							}
						}
					}
				}
			}
		}

	}



/* &main5754 */
	obj_t BGl_z62main5754z62zz__evaluate_compz00(obj_t BgL_envz00_14965,
		obj_t BgL_dz00_14970)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14968;
				long BgL_siza7ezd2framez75_14969;

				BgL_runz00_14968 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14965, (int) (((long) 2))));
				BgL_siza7ezd2framez75_14969 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14965, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17453;

					BgL_sz00_17453 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17454;

						BgL_bpz00_17454 = VECTOR_REF(((obj_t) BgL_sz00_17453), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17454) + BgL_siza7ezd2framez75_14969) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17453))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3534z00_17455;

									BgL_arg3534z00_17455 =
										((long) CINT(BgL_bpz00_17454) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17453), BgL_arg3534z00_17455,
										BgL_dz00_14970);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17456;

									BgL_ez00_17456 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17456,
										BgL_bpz00_17454);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17457;

										BgL_accz00_17457 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14968, BgL_sz00_17453, BgL_bpz00_17454);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17456);
										VECTOR_SET(
											((obj_t) BgL_sz00_17453), ((long) 0), BgL_bpz00_17454);
										return BgL_accz00_17457;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17458;

								BgL_nsz00_17458 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17458, ((long) 1), BgL_sz00_17453);
								VECTOR_SET(BgL_nsz00_17458, ((long) 2), BgL_dz00_14970);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17459;

									BgL_z12denvz12_17459 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17459, BgL_nsz00_17458);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17460;

										BgL_ez00_17460 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17460,
											BgL_sz00_17453);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17461;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17462;

												BgL_savedzd2bpzd2_17462 =
													VECTOR_REF(BgL_nsz00_17458, ((long) 0));
												VECTOR_SET(BgL_nsz00_17458, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17464;

													BgL_fz00_17464 = BgL_runz00_14968;
												BgL_recz00_17463:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17465;

														BgL_rz00_17465 =
															PROCEDURE_ENTRY(BgL_fz00_17464) (BgL_fz00_17464,
															BgL_nsz00_17458, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_test6682z00_30574;

															if (PROCEDUREP(BgL_rz00_17465))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1707z00_17466;

																	BgL_arg1707z00_17466 =
																		PROCEDURE_ATTR(BgL_rz00_17465);
																	if (STRUCTP(BgL_arg1707z00_17466))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6682z00_30574 =
																				(STRUCT_KEY(BgL_arg1707z00_17466) ==
																				BGl_symbol5794z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6682z00_30574 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_test6682z00_30574 = ((bool_t) 0);
																}
															if (BgL_test6682z00_30574)
																{
																	obj_t BgL_fz00_30582;

																	BgL_fz00_30582 = BgL_rz00_17465;
																	BgL_fz00_17464 = BgL_fz00_30582;
																	goto BgL_recz00_17463;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17458, ((long) 0),
																		BgL_savedzd2bpzd2_17462);
																	BgL_____rz00_17461 = BgL_rz00_17465;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17460);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17459, BgL_sz00_17453);
											return BgL_____rz00_17461;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5755 */
	obj_t BGl_z62run5755z62zz__evaluate_compz00(obj_t BgL_envz00_14971,
		obj_t BgL_sz00_14974)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1247z00_14972;
				obj_t BgL_bodyz00_14973;

				BgL_i1247z00_14972 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14971, (int) (((long) 0))));
				BgL_bodyz00_14973 = PROCEDURE_REF(BgL_envz00_14971, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17467;

					BgL_bpz00_17467 = VECTOR_REF(((obj_t) BgL_sz00_14974), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_z12denvz12_17468;
						obj_t BgL_wherez00_17469;
						obj_t BgL_locz00_17470;

						BgL_z12denvz12_17468 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17469 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14972))->
							BgL_wherez00);
						BgL_locz00_17470 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14972))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1167 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17468, BgL_wherez00_17469,
								BgL_locz00_17470);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_za2za2resza2za2z00_17471;

								BgL_za2za2resza2za2z00_17471 =
									PROCEDURE_ENTRY(BgL_bodyz00_14973) (BgL_bodyz00_14973,
									BgL_sz00_14974, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17468);
								return BgL_za2za2resza2za2z00_17471;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3536> */
	obj_t BGl_z62zc3z04anonymousza33536ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14975, obj_t BgL_sz00_14980)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_14976;
				BgL_ev_absz00_bglt BgL_i1247z00_14977;
				obj_t BgL_bodyz00_14978;
				long BgL_siza7ezd2framez75_14979;

				BgL_iboxesz00_14976 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14975, (int) (((long) 0))));
				BgL_i1247z00_14977 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14975, (int) (((long) 1))));
				BgL_bodyz00_14978 = PROCEDURE_REF(BgL_envz00_14975, (int) (((long) 2)));
				BgL_siza7ezd2framez75_14979 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14975, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17472;

					BgL_bpz00_17472 = VECTOR_REF(((obj_t) BgL_sz00_14980), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */

						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17473;

							BgL_runz00_17473 =
								MAKE_FX_PROCEDURE(BGl_z62run5757z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_17473,
								(int) (((long) 0)), BgL_iboxesz00_14976);
							PROCEDURE_SET(BgL_runz00_17473,
								(int) (((long) 1)), ((obj_t) BgL_i1247z00_14977));
							PROCEDURE_SET(BgL_runz00_17473,
								(int) (((long) 2)), BgL_bodyz00_14978);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17474;

								BgL_mainz00_17474 =
									MAKE_FX_PROCEDURE(BGl_z62main5756z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_17474,
									(int) (((long) 0)), BgL_iboxesz00_14976);
								PROCEDURE_SET(BgL_mainz00_17474,
									(int) (((long) 1)), ((obj_t) BgL_i1247z00_14977));
								PROCEDURE_SET(BgL_mainz00_17474,
									(int) (((long) 2)), BgL_bodyz00_14978);
								PROCEDURE_SET(BgL_mainz00_17474,
									(int) (((long) 3)), BgL_runz00_17473);
								PROCEDURE_SET(BgL_mainz00_17474,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_14979));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17475;

									BgL_objz00_17475 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17473, BgL_objz00_17475);
									BgL_objz00_17475;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3538z00_17476;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3539z00_17477;

										BgL_arg3539z00_17477 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14977))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17478;

											BgL_newz00_17478 =
												create_struct(BGl_symbol5815z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_30644;

												BgL_tmpz00_30644 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17478, BgL_tmpz00_30644,
													BgL_arg3539z00_17477);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_30649;
												int BgL_tmpz00_30647;

												BgL_auxz00_30649 = BINT(BgL_siza7ezd2framez75_14979);
												BgL_tmpz00_30647 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17478, BgL_tmpz00_30647,
													BgL_auxz00_30649);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_30652;

												BgL_tmpz00_30652 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17478, BgL_tmpz00_30652,
													BgL_runz00_17473);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_30657;
												int BgL_tmpz00_30655;

												BgL_auxz00_30657 = BINT(((long) 1));
												BgL_tmpz00_30655 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17478, BgL_tmpz00_30655,
													BgL_auxz00_30657);
											}
											BgL_arg3538z00_17476 = BgL_newz00_17478;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17474, BgL_arg3538z00_17476);
									BgL_arg3538z00_17476;
								}
								return BgL_mainz00_17474;
							}
						}
					}
				}
			}
		}

	}



/* &main5756 */
	obj_t BGl_z62main5756z62zz__evaluate_compz00(obj_t BgL_envz00_14981,
		obj_t BgL_dz00_14987)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14985;
				long BgL_siza7ezd2framez75_14986;

				BgL_runz00_14985 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14981, (int) (((long) 3))));
				BgL_siza7ezd2framez75_14986 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14981, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17479;

					BgL_sz00_17479 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17480;

						BgL_bpz00_17480 = VECTOR_REF(((obj_t) BgL_sz00_17479), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17480) + BgL_siza7ezd2framez75_14986) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17479))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3542z00_17481;

									BgL_arg3542z00_17481 =
										((long) CINT(BgL_bpz00_17480) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17479), BgL_arg3542z00_17481,
										BgL_dz00_14987);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17482;

									BgL_ez00_17482 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17482,
										BgL_bpz00_17480);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17483;

										BgL_accz00_17483 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14985, BgL_sz00_17479, BgL_bpz00_17480);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17482);
										VECTOR_SET(
											((obj_t) BgL_sz00_17479), ((long) 0), BgL_bpz00_17480);
										return BgL_accz00_17483;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17484;

								BgL_nsz00_17484 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17484, ((long) 1), BgL_sz00_17479);
								VECTOR_SET(BgL_nsz00_17484, ((long) 2), BgL_dz00_14987);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17485;

									BgL_z12denvz12_17485 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17485, BgL_nsz00_17484);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17486;

										BgL_ez00_17486 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17486,
											BgL_sz00_17479);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17487;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17488;

												BgL_savedzd2bpzd2_17488 =
													VECTOR_REF(BgL_nsz00_17484, ((long) 0));
												VECTOR_SET(BgL_nsz00_17484, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17490;

													BgL_fz00_17490 = BgL_runz00_14985;
												BgL_recz00_17489:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17491;

														BgL_rz00_17491 =
															PROCEDURE_ENTRY(BgL_fz00_17490) (BgL_fz00_17490,
															BgL_nsz00_17484, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_test6686z00_30700;

															if (PROCEDUREP(BgL_rz00_17491))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1707z00_17492;

																	BgL_arg1707z00_17492 =
																		PROCEDURE_ATTR(BgL_rz00_17491);
																	if (STRUCTP(BgL_arg1707z00_17492))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6686z00_30700 =
																				(STRUCT_KEY(BgL_arg1707z00_17492) ==
																				BGl_symbol5794z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6686z00_30700 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_test6686z00_30700 = ((bool_t) 0);
																}
															if (BgL_test6686z00_30700)
																{
																	obj_t BgL_fz00_30708;

																	BgL_fz00_30708 = BgL_rz00_17491;
																	BgL_fz00_17490 = BgL_fz00_30708;
																	goto BgL_recz00_17489;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17484, ((long) 0),
																		BgL_savedzd2bpzd2_17488);
																	BgL_____rz00_17487 = BgL_rz00_17491;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17486);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17485, BgL_sz00_17479);
											return BgL_____rz00_17487;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5757 */
	obj_t BGl_z62run5757z62zz__evaluate_compz00(obj_t BgL_envz00_14988,
		obj_t BgL_sz00_14992)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_14989;
				BgL_ev_absz00_bglt BgL_i1247z00_14990;
				obj_t BgL_bodyz00_14991;

				BgL_iboxesz00_14989 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14988, (int) (((long) 0))));
				BgL_i1247z00_14990 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14988, (int) (((long) 1))));
				BgL_bodyz00_14991 = PROCEDURE_REF(BgL_envz00_14988, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17493;

					BgL_bpz00_17493 = VECTOR_REF(((obj_t) BgL_sz00_14992), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14992,
						BgL_iboxesz00_14989, BgL_bpz00_17493);
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_z12denvz12_17494;
						obj_t BgL_wherez00_17495;
						obj_t BgL_locz00_17496;

						BgL_z12denvz12_17494 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17495 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14990))->
							BgL_wherez00);
						BgL_locz00_17496 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14990))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1167 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17494, BgL_wherez00_17495,
								BgL_locz00_17496);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_za2za2resza2za2z00_17497;

								BgL_za2za2resza2za2z00_17497 =
									PROCEDURE_ENTRY(BgL_bodyz00_14991) (BgL_bodyz00_14991,
									BgL_sz00_14992, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17494);
								return BgL_za2za2resza2za2z00_17497;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3548> */
	obj_t BGl_z62zc3z04anonymousza33548ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14993, obj_t BgL_sz00_14999)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_ifreesz00_14994;
				long BgL_siza7eza7_14995;
				BgL_ev_absz00_bglt BgL_i1247z00_14996;
				obj_t BgL_bodyz00_14997;
				long BgL_siza7ezd2framez75_14998;

				BgL_ifreesz00_14994 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14993, (int) (((long) 0))));
				BgL_siza7eza7_14995 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14993, (int) (((long) 1))));
				BgL_i1247z00_14996 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14993, (int) (((long) 2))));
				BgL_bodyz00_14997 = PROCEDURE_REF(BgL_envz00_14993, (int) (((long) 3)));
				BgL_siza7ezd2framez75_14998 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14993, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17498;

					BgL_bpz00_17498 = VECTOR_REF(((obj_t) BgL_sz00_14999), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_valza2za2_17499;

						BgL_valza2za2_17499 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14999,
							BgL_bpz00_17498, BgL_ifreesz00_14994);
						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17500;

							BgL_runz00_17500 =
								MAKE_FX_PROCEDURE(BGl_z62run5759z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_17500,
								(int) (((long) 0)), BINT(BgL_siza7eza7_14995));
							PROCEDURE_SET(BgL_runz00_17500,
								(int) (((long) 1)), BgL_valza2za2_17499);
							PROCEDURE_SET(BgL_runz00_17500,
								(int) (((long) 2)), ((obj_t) BgL_i1247z00_14996));
							PROCEDURE_SET(BgL_runz00_17500,
								(int) (((long) 3)), BgL_bodyz00_14997);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17501;

								BgL_mainz00_17501 =
									MAKE_FX_PROCEDURE(BGl_z62main5758z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_17501,
									(int) (((long) 0)), BINT(BgL_siza7eza7_14995));
								PROCEDURE_SET(BgL_mainz00_17501,
									(int) (((long) 1)), BgL_valza2za2_17499);
								PROCEDURE_SET(BgL_mainz00_17501,
									(int) (((long) 2)), ((obj_t) BgL_i1247z00_14996));
								PROCEDURE_SET(BgL_mainz00_17501,
									(int) (((long) 3)), BgL_bodyz00_14997);
								PROCEDURE_SET(BgL_mainz00_17501,
									(int) (((long) 4)), BgL_runz00_17500);
								PROCEDURE_SET(BgL_mainz00_17501,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_14998));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17502;

									BgL_objz00_17502 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17500, BgL_objz00_17502);
									BgL_objz00_17502;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3550z00_17503;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3551z00_17504;

										BgL_arg3551z00_17504 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14996))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17505;

											BgL_newz00_17505 =
												create_struct(BGl_symbol5815z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_30784;

												BgL_tmpz00_30784 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17505, BgL_tmpz00_30784,
													BgL_arg3551z00_17504);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_30789;
												int BgL_tmpz00_30787;

												BgL_auxz00_30789 = BINT(BgL_siza7ezd2framez75_14998);
												BgL_tmpz00_30787 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17505, BgL_tmpz00_30787,
													BgL_auxz00_30789);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_30792;

												BgL_tmpz00_30792 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17505, BgL_tmpz00_30792,
													BgL_runz00_17500);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_30797;
												int BgL_tmpz00_30795;

												BgL_auxz00_30797 = BINT(((long) 1));
												BgL_tmpz00_30795 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17505, BgL_tmpz00_30795,
													BgL_auxz00_30797);
											}
											BgL_arg3550z00_17503 = BgL_newz00_17505;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17501, BgL_arg3550z00_17503);
									BgL_arg3550z00_17503;
								}
								return BgL_mainz00_17501;
							}
						}
					}
				}
			}
		}

	}



/* &main5758 */
	obj_t BGl_z62main5758z62zz__evaluate_compz00(obj_t BgL_envz00_15000,
		obj_t BgL_dz00_15007)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_15005;
				long BgL_siza7ezd2framez75_15006;

				BgL_runz00_15005 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15000, (int) (((long) 4))));
				BgL_siza7ezd2framez75_15006 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15000, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17506;

					BgL_sz00_17506 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17507;

						BgL_bpz00_17507 = VECTOR_REF(((obj_t) BgL_sz00_17506), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17507) + BgL_siza7ezd2framez75_15006) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17506))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3554z00_17508;

									BgL_arg3554z00_17508 =
										((long) CINT(BgL_bpz00_17507) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17506), BgL_arg3554z00_17508,
										BgL_dz00_15007);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17509;

									BgL_ez00_17509 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17509,
										BgL_bpz00_17507);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17510;

										BgL_accz00_17510 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_15005, BgL_sz00_17506, BgL_bpz00_17507);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17509);
										VECTOR_SET(
											((obj_t) BgL_sz00_17506), ((long) 0), BgL_bpz00_17507);
										return BgL_accz00_17510;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17511;

								BgL_nsz00_17511 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17511, ((long) 1), BgL_sz00_17506);
								VECTOR_SET(BgL_nsz00_17511, ((long) 2), BgL_dz00_15007);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17512;

									BgL_z12denvz12_17512 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17512, BgL_nsz00_17511);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17513;

										BgL_ez00_17513 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17513,
											BgL_sz00_17506);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17514;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17515;

												BgL_savedzd2bpzd2_17515 =
													VECTOR_REF(BgL_nsz00_17511, ((long) 0));
												VECTOR_SET(BgL_nsz00_17511, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17517;

													BgL_fz00_17517 = BgL_runz00_15005;
												BgL_recz00_17516:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17518;

														BgL_rz00_17518 =
															PROCEDURE_ENTRY(BgL_fz00_17517) (BgL_fz00_17517,
															BgL_nsz00_17511, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_test6690z00_30840;

															if (PROCEDUREP(BgL_rz00_17518))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1707z00_17519;

																	BgL_arg1707z00_17519 =
																		PROCEDURE_ATTR(BgL_rz00_17518);
																	if (STRUCTP(BgL_arg1707z00_17519))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6690z00_30840 =
																				(STRUCT_KEY(BgL_arg1707z00_17519) ==
																				BGl_symbol5794z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6690z00_30840 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_test6690z00_30840 = ((bool_t) 0);
																}
															if (BgL_test6690z00_30840)
																{
																	obj_t BgL_fz00_30848;

																	BgL_fz00_30848 = BgL_rz00_17518;
																	BgL_fz00_17517 = BgL_fz00_30848;
																	goto BgL_recz00_17516;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17511, ((long) 0),
																		BgL_savedzd2bpzd2_17515);
																	BgL_____rz00_17514 = BgL_rz00_17518;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17513);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17512, BgL_sz00_17506);
											return BgL_____rz00_17514;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5759 */
	obj_t BGl_z62run5759z62zz__evaluate_compz00(obj_t BgL_envz00_15008,
		obj_t BgL_sz00_15013)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				long BgL_siza7eza7_15009;
				obj_t BgL_valza2za2_15010;
				BgL_ev_absz00_bglt BgL_i1247z00_15011;
				obj_t BgL_bodyz00_15012;

				BgL_siza7eza7_15009 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15008, (int) (((long) 0))));
				BgL_valza2za2_15010 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15008, (int) (((long) 1))));
				BgL_i1247z00_15011 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15008, (int) (((long) 2))));
				BgL_bodyz00_15012 = PROCEDURE_REF(BgL_envz00_15008, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17520;

					BgL_bpz00_17520 = VECTOR_REF(((obj_t) BgL_sz00_15013), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_15013,
						BgL_valza2za2_15010,
						((long) CINT(BgL_bpz00_17520) + BgL_siza7eza7_15009));
					{	/* Eval/evaluate_comp.scm 1088 */
						obj_t BgL_z12denvz12_17521;
						obj_t BgL_wherez00_17522;
						obj_t BgL_locz00_17523;

						BgL_z12denvz12_17521 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17522 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15011))->
							BgL_wherez00);
						BgL_locz00_17523 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15011))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1088 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17521, BgL_wherez00_17522,
								BgL_locz00_17523);
							{	/* Eval/evaluate_comp.scm 1088 */
								obj_t BgL_za2za2resza2za2z00_17524;

								BgL_za2za2resza2za2z00_17524 =
									PROCEDURE_ENTRY(BgL_bodyz00_15012) (BgL_bodyz00_15012,
									BgL_sz00_15013, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17521);
								return BgL_za2za2resza2za2z00_17524;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3557> */
	obj_t BGl_z62zc3z04anonymousza33557ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15014, obj_t BgL_sz00_15021)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_ifreesz00_15015;
				obj_t BgL_iboxesz00_15016;
				long BgL_siza7eza7_15017;
				BgL_ev_absz00_bglt BgL_i1247z00_15018;
				obj_t BgL_bodyz00_15019;
				long BgL_siza7ezd2framez75_15020;

				BgL_ifreesz00_15015 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15014, (int) (((long) 0))));
				BgL_iboxesz00_15016 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15014, (int) (((long) 1))));
				BgL_siza7eza7_15017 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15014, (int) (((long) 2))));
				BgL_i1247z00_15018 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15014, (int) (((long) 3))));
				BgL_bodyz00_15019 = PROCEDURE_REF(BgL_envz00_15014, (int) (((long) 4)));
				BgL_siza7ezd2framez75_15020 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15014, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17525;

					BgL_bpz00_17525 = VECTOR_REF(((obj_t) BgL_sz00_15021), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_valza2za2_17526;

						BgL_valza2za2_17526 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_15021,
							BgL_bpz00_17525, BgL_ifreesz00_15015);
						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17527;

							BgL_runz00_17527 =
								MAKE_FX_PROCEDURE(BGl_z62run5761z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_17527,
								(int) (((long) 0)), BgL_iboxesz00_15016);
							PROCEDURE_SET(BgL_runz00_17527,
								(int) (((long) 1)), BINT(BgL_siza7eza7_15017));
							PROCEDURE_SET(BgL_runz00_17527,
								(int) (((long) 2)), BgL_valza2za2_17526);
							PROCEDURE_SET(BgL_runz00_17527,
								(int) (((long) 3)), ((obj_t) BgL_i1247z00_15018));
							PROCEDURE_SET(BgL_runz00_17527,
								(int) (((long) 4)), BgL_bodyz00_15019);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17528;

								BgL_mainz00_17528 =
									MAKE_FX_PROCEDURE(BGl_z62main5760z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_17528,
									(int) (((long) 0)), BgL_iboxesz00_15016);
								PROCEDURE_SET(BgL_mainz00_17528,
									(int) (((long) 1)), BINT(BgL_siza7eza7_15017));
								PROCEDURE_SET(BgL_mainz00_17528,
									(int) (((long) 2)), BgL_valza2za2_17526);
								PROCEDURE_SET(BgL_mainz00_17528,
									(int) (((long) 3)), ((obj_t) BgL_i1247z00_15018));
								PROCEDURE_SET(BgL_mainz00_17528,
									(int) (((long) 4)), BgL_bodyz00_15019);
								PROCEDURE_SET(BgL_mainz00_17528,
									(int) (((long) 5)), BgL_runz00_17527);
								PROCEDURE_SET(BgL_mainz00_17528,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_15020));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17529;

									BgL_objz00_17529 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17527, BgL_objz00_17529);
									BgL_objz00_17529;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3558z00_17530;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3559z00_17531;

										BgL_arg3559z00_17531 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15018))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17532;

											BgL_newz00_17532 =
												create_struct(BGl_symbol5815z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_30936;

												BgL_tmpz00_30936 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17532, BgL_tmpz00_30936,
													BgL_arg3559z00_17531);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_30941;
												int BgL_tmpz00_30939;

												BgL_auxz00_30941 = BINT(BgL_siza7ezd2framez75_15020);
												BgL_tmpz00_30939 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17532, BgL_tmpz00_30939,
													BgL_auxz00_30941);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_30944;

												BgL_tmpz00_30944 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17532, BgL_tmpz00_30944,
													BgL_runz00_17527);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_30949;
												int BgL_tmpz00_30947;

												BgL_auxz00_30949 = BINT(((long) 1));
												BgL_tmpz00_30947 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17532, BgL_tmpz00_30947,
													BgL_auxz00_30949);
											}
											BgL_arg3558z00_17530 = BgL_newz00_17532;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17528, BgL_arg3558z00_17530);
									BgL_arg3558z00_17530;
								}
								return BgL_mainz00_17528;
							}
						}
					}
				}
			}
		}

	}



/* &main5760 */
	obj_t BGl_z62main5760z62zz__evaluate_compz00(obj_t BgL_envz00_15022,
		obj_t BgL_dz00_15030)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_15028;
				long BgL_siza7ezd2framez75_15029;

				BgL_runz00_15028 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15022, (int) (((long) 5))));
				BgL_siza7ezd2framez75_15029 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15022, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17533;

					BgL_sz00_17533 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17534;

						BgL_bpz00_17534 = VECTOR_REF(((obj_t) BgL_sz00_17533), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17534) + BgL_siza7ezd2framez75_15029) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17533))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3562z00_17535;

									BgL_arg3562z00_17535 =
										((long) CINT(BgL_bpz00_17534) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17533), BgL_arg3562z00_17535,
										BgL_dz00_15030);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17536;

									BgL_ez00_17536 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17536,
										BgL_bpz00_17534);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17537;

										BgL_accz00_17537 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_15028, BgL_sz00_17533, BgL_bpz00_17534);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17536);
										VECTOR_SET(
											((obj_t) BgL_sz00_17533), ((long) 0), BgL_bpz00_17534);
										return BgL_accz00_17537;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17538;

								BgL_nsz00_17538 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17538, ((long) 1), BgL_sz00_17533);
								VECTOR_SET(BgL_nsz00_17538, ((long) 2), BgL_dz00_15030);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17539;

									BgL_z12denvz12_17539 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17539, BgL_nsz00_17538);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17540;

										BgL_ez00_17540 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17540,
											BgL_sz00_17533);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17541;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17542;

												BgL_savedzd2bpzd2_17542 =
													VECTOR_REF(BgL_nsz00_17538, ((long) 0));
												VECTOR_SET(BgL_nsz00_17538, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17544;

													BgL_fz00_17544 = BgL_runz00_15028;
												BgL_recz00_17543:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17545;

														BgL_rz00_17545 =
															PROCEDURE_ENTRY(BgL_fz00_17544) (BgL_fz00_17544,
															BgL_nsz00_17538, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_test6694z00_30992;

															if (PROCEDUREP(BgL_rz00_17545))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1707z00_17546;

																	BgL_arg1707z00_17546 =
																		PROCEDURE_ATTR(BgL_rz00_17545);
																	if (STRUCTP(BgL_arg1707z00_17546))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6694z00_30992 =
																				(STRUCT_KEY(BgL_arg1707z00_17546) ==
																				BGl_symbol5794z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6694z00_30992 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_test6694z00_30992 = ((bool_t) 0);
																}
															if (BgL_test6694z00_30992)
																{
																	obj_t BgL_fz00_31000;

																	BgL_fz00_31000 = BgL_rz00_17545;
																	BgL_fz00_17544 = BgL_fz00_31000;
																	goto BgL_recz00_17543;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17538, ((long) 0),
																		BgL_savedzd2bpzd2_17542);
																	BgL_____rz00_17541 = BgL_rz00_17545;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17540);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17539, BgL_sz00_17533);
											return BgL_____rz00_17541;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5761 */
	obj_t BGl_z62run5761z62zz__evaluate_compz00(obj_t BgL_envz00_15031,
		obj_t BgL_sz00_15037)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_15032;
				long BgL_siza7eza7_15033;
				obj_t BgL_valza2za2_15034;
				BgL_ev_absz00_bglt BgL_i1247z00_15035;
				obj_t BgL_bodyz00_15036;

				BgL_iboxesz00_15032 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15031, (int) (((long) 0))));
				BgL_siza7eza7_15033 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15031, (int) (((long) 1))));
				BgL_valza2za2_15034 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15031, (int) (((long) 2))));
				BgL_i1247z00_15035 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15031, (int) (((long) 3))));
				BgL_bodyz00_15036 = PROCEDURE_REF(BgL_envz00_15031, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17547;

					BgL_bpz00_17547 = VECTOR_REF(((obj_t) BgL_sz00_15037), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_15037,
						BgL_iboxesz00_15032, BgL_bpz00_17547);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_15037,
						BgL_valza2za2_15034,
						((long) CINT(BgL_bpz00_17547) + BgL_siza7eza7_15033));
					{	/* Eval/evaluate_comp.scm 1088 */
						obj_t BgL_z12denvz12_17548;
						obj_t BgL_wherez00_17549;
						obj_t BgL_locz00_17550;

						BgL_z12denvz12_17548 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17549 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15035))->
							BgL_wherez00);
						BgL_locz00_17550 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15035))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1088 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17548, BgL_wherez00_17549,
								BgL_locz00_17550);
							{	/* Eval/evaluate_comp.scm 1088 */
								obj_t BgL_za2za2resza2za2z00_17551;

								BgL_za2za2resza2za2z00_17551 =
									PROCEDURE_ENTRY(BgL_bodyz00_15036) (BgL_bodyz00_15036,
									BgL_sz00_15037, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17548);
								return BgL_za2za2resza2za2z00_17551;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3482> */
	obj_t BGl_z62zc3z04anonymousza33482ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15038, obj_t BgL_sz00_15042)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1247z00_15039;
				obj_t BgL_bodyz00_15040;
				long BgL_siza7ezd2framez75_15041;

				BgL_i1247z00_15039 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15038, (int) (((long) 0))));
				BgL_bodyz00_15040 = PROCEDURE_REF(BgL_envz00_15038, (int) (((long) 1)));
				BgL_siza7ezd2framez75_15041 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15038, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17552;

					BgL_bpz00_17552 = VECTOR_REF(((obj_t) BgL_sz00_15042), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */

						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17553;

							BgL_runz00_17553 =
								MAKE_FX_PROCEDURE(BGl_z62run5763z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_17553,
								(int) (((long) 0)), ((obj_t) BgL_i1247z00_15039));
							PROCEDURE_SET(BgL_runz00_17553,
								(int) (((long) 1)), BgL_bodyz00_15040);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17554;

								BgL_mainz00_17554 =
									MAKE_VA_PROCEDURE(BGl_z62main5762z62zz__evaluate_compz00,
									(int) (((long) -1)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_17554,
									(int) (((long) 0)), ((obj_t) BgL_i1247z00_15039));
								PROCEDURE_SET(BgL_mainz00_17554,
									(int) (((long) 1)), BgL_bodyz00_15040);
								PROCEDURE_SET(BgL_mainz00_17554,
									(int) (((long) 2)), BgL_runz00_17553);
								PROCEDURE_SET(BgL_mainz00_17554,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_15041));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17555;

									BgL_objz00_17555 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17553, BgL_objz00_17555);
									BgL_objz00_17555;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3483z00_17556;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3485z00_17557;

										BgL_arg3485z00_17557 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15039))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17558;

											BgL_newz00_17558 =
												create_struct(BGl_symbol5815z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_31068;

												BgL_tmpz00_31068 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17558, BgL_tmpz00_31068,
													BgL_arg3485z00_17557);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_31073;
												int BgL_tmpz00_31071;

												BgL_auxz00_31073 = BINT(BgL_siza7ezd2framez75_15041);
												BgL_tmpz00_31071 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17558, BgL_tmpz00_31071,
													BgL_auxz00_31073);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_31076;

												BgL_tmpz00_31076 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17558, BgL_tmpz00_31076,
													BgL_runz00_17553);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_31081;
												int BgL_tmpz00_31079;

												BgL_auxz00_31081 = BINT(((long) -1));
												BgL_tmpz00_31079 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17558, BgL_tmpz00_31079,
													BgL_auxz00_31081);
											}
											BgL_arg3483z00_17556 = BgL_newz00_17558;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17554, BgL_arg3483z00_17556);
									BgL_arg3483z00_17556;
								}
								return BgL_mainz00_17554;
							}
						}
					}
				}
			}
		}

	}



/* &main5762 */
	obj_t BGl_z62main5762z62zz__evaluate_compz00(obj_t BgL_envz00_15043,
		obj_t BgL_lastz00_15048)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_15046;
				long BgL_siza7ezd2framez75_15047;

				BgL_runz00_15046 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15043, (int) (((long) 2))));
				BgL_siza7ezd2framez75_15047 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15043, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17559;

					BgL_sz00_17559 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17560;

						BgL_bpz00_17560 = VECTOR_REF(((obj_t) BgL_sz00_17559), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17560) + BgL_siza7ezd2framez75_15047) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17559))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3489z00_17561;

									BgL_arg3489z00_17561 =
										((long) CINT(BgL_bpz00_17560) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17559), BgL_arg3489z00_17561,
										BgL_lastz00_15048);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17562;

									BgL_ez00_17562 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17562,
										BgL_bpz00_17560);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17563;

										BgL_accz00_17563 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_15046, BgL_sz00_17559, BgL_bpz00_17560);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17562);
										VECTOR_SET(
											((obj_t) BgL_sz00_17559), ((long) 0), BgL_bpz00_17560);
										return BgL_accz00_17563;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17564;

								BgL_nsz00_17564 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17564, ((long) 1), BgL_sz00_17559);
								VECTOR_SET(BgL_nsz00_17564, ((long) 2), BgL_lastz00_15048);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17565;

									BgL_z12denvz12_17565 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17565, BgL_nsz00_17564);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17566;

										BgL_ez00_17566 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17566,
											BgL_sz00_17559);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17567;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17568;

												BgL_savedzd2bpzd2_17568 =
													VECTOR_REF(BgL_nsz00_17564, ((long) 0));
												VECTOR_SET(BgL_nsz00_17564, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17570;

													BgL_fz00_17570 = BgL_runz00_15046;
												BgL_recz00_17569:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17571;

														BgL_rz00_17571 =
															PROCEDURE_ENTRY(BgL_fz00_17570) (BgL_fz00_17570,
															BgL_nsz00_17564, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_test6698z00_31124;

															if (PROCEDUREP(BgL_rz00_17571))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1707z00_17572;

																	BgL_arg1707z00_17572 =
																		PROCEDURE_ATTR(BgL_rz00_17571);
																	if (STRUCTP(BgL_arg1707z00_17572))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6698z00_31124 =
																				(STRUCT_KEY(BgL_arg1707z00_17572) ==
																				BGl_symbol5794z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6698z00_31124 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_test6698z00_31124 = ((bool_t) 0);
																}
															if (BgL_test6698z00_31124)
																{
																	obj_t BgL_fz00_31132;

																	BgL_fz00_31132 = BgL_rz00_17571;
																	BgL_fz00_17570 = BgL_fz00_31132;
																	goto BgL_recz00_17569;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17564, ((long) 0),
																		BgL_savedzd2bpzd2_17568);
																	BgL_____rz00_17567 = BgL_rz00_17571;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17566);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17565, BgL_sz00_17559);
											return BgL_____rz00_17567;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5763 */
	obj_t BGl_z62run5763z62zz__evaluate_compz00(obj_t BgL_envz00_15049,
		obj_t BgL_sz00_15052)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1247z00_15050;
				obj_t BgL_bodyz00_15051;

				BgL_i1247z00_15050 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15049, (int) (((long) 0))));
				BgL_bodyz00_15051 = PROCEDURE_REF(BgL_envz00_15049, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17573;

					BgL_bpz00_17573 = VECTOR_REF(((obj_t) BgL_sz00_15052), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_z12denvz12_17574;
						obj_t BgL_wherez00_17575;
						obj_t BgL_locz00_17576;

						BgL_z12denvz12_17574 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17575 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15050))->
							BgL_wherez00);
						BgL_locz00_17576 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15050))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1167 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17574, BgL_wherez00_17575,
								BgL_locz00_17576);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_za2za2resza2za2z00_17577;

								BgL_za2za2resza2za2z00_17577 =
									PROCEDURE_ENTRY(BgL_bodyz00_15051) (BgL_bodyz00_15051,
									BgL_sz00_15052, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17574);
								return BgL_za2za2resza2za2z00_17577;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3491> */
	obj_t BGl_z62zc3z04anonymousza33491ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15053, obj_t BgL_sz00_15058)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_15054;
				BgL_ev_absz00_bglt BgL_i1247z00_15055;
				obj_t BgL_bodyz00_15056;
				long BgL_siza7ezd2framez75_15057;

				BgL_iboxesz00_15054 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15053, (int) (((long) 0))));
				BgL_i1247z00_15055 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15053, (int) (((long) 1))));
				BgL_bodyz00_15056 = PROCEDURE_REF(BgL_envz00_15053, (int) (((long) 2)));
				BgL_siza7ezd2framez75_15057 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15053, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17578;

					BgL_bpz00_17578 = VECTOR_REF(((obj_t) BgL_sz00_15058), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */

						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17579;

							BgL_runz00_17579 =
								MAKE_FX_PROCEDURE(BGl_z62run5765z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_17579,
								(int) (((long) 0)), BgL_iboxesz00_15054);
							PROCEDURE_SET(BgL_runz00_17579,
								(int) (((long) 1)), ((obj_t) BgL_i1247z00_15055));
							PROCEDURE_SET(BgL_runz00_17579,
								(int) (((long) 2)), BgL_bodyz00_15056);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17580;

								BgL_mainz00_17580 =
									MAKE_VA_PROCEDURE(BGl_z62main5764z62zz__evaluate_compz00,
									(int) (((long) -1)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_17580,
									(int) (((long) 0)), BgL_iboxesz00_15054);
								PROCEDURE_SET(BgL_mainz00_17580,
									(int) (((long) 1)), ((obj_t) BgL_i1247z00_15055));
								PROCEDURE_SET(BgL_mainz00_17580,
									(int) (((long) 2)), BgL_bodyz00_15056);
								PROCEDURE_SET(BgL_mainz00_17580,
									(int) (((long) 3)), BgL_runz00_17579);
								PROCEDURE_SET(BgL_mainz00_17580,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_15057));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17581;

									BgL_objz00_17581 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17579, BgL_objz00_17581);
									BgL_objz00_17581;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3492z00_17582;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3493z00_17583;

										BgL_arg3493z00_17583 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15055))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17584;

											BgL_newz00_17584 =
												create_struct(BGl_symbol5815z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_31194;

												BgL_tmpz00_31194 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17584, BgL_tmpz00_31194,
													BgL_arg3493z00_17583);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_31199;
												int BgL_tmpz00_31197;

												BgL_auxz00_31199 = BINT(BgL_siza7ezd2framez75_15057);
												BgL_tmpz00_31197 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17584, BgL_tmpz00_31197,
													BgL_auxz00_31199);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_31202;

												BgL_tmpz00_31202 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17584, BgL_tmpz00_31202,
													BgL_runz00_17579);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_31207;
												int BgL_tmpz00_31205;

												BgL_auxz00_31207 = BINT(((long) -1));
												BgL_tmpz00_31205 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17584, BgL_tmpz00_31205,
													BgL_auxz00_31207);
											}
											BgL_arg3492z00_17582 = BgL_newz00_17584;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17580, BgL_arg3492z00_17582);
									BgL_arg3492z00_17582;
								}
								return BgL_mainz00_17580;
							}
						}
					}
				}
			}
		}

	}



/* &main5764 */
	obj_t BGl_z62main5764z62zz__evaluate_compz00(obj_t BgL_envz00_15059,
		obj_t BgL_lastz00_15065)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_15063;
				long BgL_siza7ezd2framez75_15064;

				BgL_runz00_15063 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15059, (int) (((long) 3))));
				BgL_siza7ezd2framez75_15064 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15059, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17585;

					BgL_sz00_17585 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17586;

						BgL_bpz00_17586 = VECTOR_REF(((obj_t) BgL_sz00_17585), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17586) + BgL_siza7ezd2framez75_15064) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17585))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3497z00_17587;

									BgL_arg3497z00_17587 =
										((long) CINT(BgL_bpz00_17586) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17585), BgL_arg3497z00_17587,
										BgL_lastz00_15065);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17588;

									BgL_ez00_17588 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17588,
										BgL_bpz00_17586);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17589;

										BgL_accz00_17589 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_15063, BgL_sz00_17585, BgL_bpz00_17586);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17588);
										VECTOR_SET(
											((obj_t) BgL_sz00_17585), ((long) 0), BgL_bpz00_17586);
										return BgL_accz00_17589;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17590;

								BgL_nsz00_17590 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17590, ((long) 1), BgL_sz00_17585);
								VECTOR_SET(BgL_nsz00_17590, ((long) 2), BgL_lastz00_15065);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17591;

									BgL_z12denvz12_17591 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17591, BgL_nsz00_17590);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17592;

										BgL_ez00_17592 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17592,
											BgL_sz00_17585);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17593;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17594;

												BgL_savedzd2bpzd2_17594 =
													VECTOR_REF(BgL_nsz00_17590, ((long) 0));
												VECTOR_SET(BgL_nsz00_17590, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17596;

													BgL_fz00_17596 = BgL_runz00_15063;
												BgL_recz00_17595:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17597;

														BgL_rz00_17597 =
															PROCEDURE_ENTRY(BgL_fz00_17596) (BgL_fz00_17596,
															BgL_nsz00_17590, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_test6702z00_31250;

															if (PROCEDUREP(BgL_rz00_17597))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1707z00_17598;

																	BgL_arg1707z00_17598 =
																		PROCEDURE_ATTR(BgL_rz00_17597);
																	if (STRUCTP(BgL_arg1707z00_17598))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6702z00_31250 =
																				(STRUCT_KEY(BgL_arg1707z00_17598) ==
																				BGl_symbol5794z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6702z00_31250 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_test6702z00_31250 = ((bool_t) 0);
																}
															if (BgL_test6702z00_31250)
																{
																	obj_t BgL_fz00_31258;

																	BgL_fz00_31258 = BgL_rz00_17597;
																	BgL_fz00_17596 = BgL_fz00_31258;
																	goto BgL_recz00_17595;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17590, ((long) 0),
																		BgL_savedzd2bpzd2_17594);
																	BgL_____rz00_17593 = BgL_rz00_17597;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17592);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17591, BgL_sz00_17585);
											return BgL_____rz00_17593;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5765 */
	obj_t BGl_z62run5765z62zz__evaluate_compz00(obj_t BgL_envz00_15066,
		obj_t BgL_sz00_15070)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_15067;
				BgL_ev_absz00_bglt BgL_i1247z00_15068;
				obj_t BgL_bodyz00_15069;

				BgL_iboxesz00_15067 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15066, (int) (((long) 0))));
				BgL_i1247z00_15068 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15066, (int) (((long) 1))));
				BgL_bodyz00_15069 = PROCEDURE_REF(BgL_envz00_15066, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17599;

					BgL_bpz00_17599 = VECTOR_REF(((obj_t) BgL_sz00_15070), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_15070,
						BgL_iboxesz00_15067, BgL_bpz00_17599);
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_z12denvz12_17600;
						obj_t BgL_wherez00_17601;
						obj_t BgL_locz00_17602;

						BgL_z12denvz12_17600 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17601 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15068))->
							BgL_wherez00);
						BgL_locz00_17602 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15068))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1167 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17600, BgL_wherez00_17601,
								BgL_locz00_17602);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_za2za2resza2za2z00_17603;

								BgL_za2za2resza2za2z00_17603 =
									PROCEDURE_ENTRY(BgL_bodyz00_15069) (BgL_bodyz00_15069,
									BgL_sz00_15070, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17600);
								return BgL_za2za2resza2za2z00_17603;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3503> */
	obj_t BGl_z62zc3z04anonymousza33503ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15071, obj_t BgL_sz00_15077)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_ifreesz00_15072;
				long BgL_siza7eza7_15073;
				BgL_ev_absz00_bglt BgL_i1247z00_15074;
				obj_t BgL_bodyz00_15075;
				long BgL_siza7ezd2framez75_15076;

				BgL_ifreesz00_15072 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15071, (int) (((long) 0))));
				BgL_siza7eza7_15073 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15071, (int) (((long) 1))));
				BgL_i1247z00_15074 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15071, (int) (((long) 2))));
				BgL_bodyz00_15075 = PROCEDURE_REF(BgL_envz00_15071, (int) (((long) 3)));
				BgL_siza7ezd2framez75_15076 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15071, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17604;

					BgL_bpz00_17604 = VECTOR_REF(((obj_t) BgL_sz00_15077), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_valza2za2_17605;

						BgL_valza2za2_17605 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_15077,
							BgL_bpz00_17604, BgL_ifreesz00_15072);
						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17606;

							BgL_runz00_17606 =
								MAKE_FX_PROCEDURE(BGl_z62run5767z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_17606,
								(int) (((long) 0)), BINT(BgL_siza7eza7_15073));
							PROCEDURE_SET(BgL_runz00_17606,
								(int) (((long) 1)), BgL_valza2za2_17605);
							PROCEDURE_SET(BgL_runz00_17606,
								(int) (((long) 2)), ((obj_t) BgL_i1247z00_15074));
							PROCEDURE_SET(BgL_runz00_17606,
								(int) (((long) 3)), BgL_bodyz00_15075);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17607;

								BgL_mainz00_17607 =
									MAKE_VA_PROCEDURE(BGl_z62main5766z62zz__evaluate_compz00,
									(int) (((long) -1)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_17607,
									(int) (((long) 0)), BINT(BgL_siza7eza7_15073));
								PROCEDURE_SET(BgL_mainz00_17607,
									(int) (((long) 1)), BgL_valza2za2_17605);
								PROCEDURE_SET(BgL_mainz00_17607,
									(int) (((long) 2)), ((obj_t) BgL_i1247z00_15074));
								PROCEDURE_SET(BgL_mainz00_17607,
									(int) (((long) 3)), BgL_bodyz00_15075);
								PROCEDURE_SET(BgL_mainz00_17607,
									(int) (((long) 4)), BgL_runz00_17606);
								PROCEDURE_SET(BgL_mainz00_17607,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_15076));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17608;

									BgL_objz00_17608 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17606, BgL_objz00_17608);
									BgL_objz00_17608;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3504z00_17609;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3506z00_17610;

										BgL_arg3506z00_17610 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15074))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17611;

											BgL_newz00_17611 =
												create_struct(BGl_symbol5815z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_31334;

												BgL_tmpz00_31334 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17611, BgL_tmpz00_31334,
													BgL_arg3506z00_17610);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_31339;
												int BgL_tmpz00_31337;

												BgL_auxz00_31339 = BINT(BgL_siza7ezd2framez75_15076);
												BgL_tmpz00_31337 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17611, BgL_tmpz00_31337,
													BgL_auxz00_31339);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_31342;

												BgL_tmpz00_31342 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17611, BgL_tmpz00_31342,
													BgL_runz00_17606);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_31347;
												int BgL_tmpz00_31345;

												BgL_auxz00_31347 = BINT(((long) -1));
												BgL_tmpz00_31345 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17611, BgL_tmpz00_31345,
													BgL_auxz00_31347);
											}
											BgL_arg3504z00_17609 = BgL_newz00_17611;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17607, BgL_arg3504z00_17609);
									BgL_arg3504z00_17609;
								}
								return BgL_mainz00_17607;
							}
						}
					}
				}
			}
		}

	}



/* &main5766 */
	obj_t BGl_z62main5766z62zz__evaluate_compz00(obj_t BgL_envz00_15078,
		obj_t BgL_lastz00_15085)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_15083;
				long BgL_siza7ezd2framez75_15084;

				BgL_runz00_15083 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15078, (int) (((long) 4))));
				BgL_siza7ezd2framez75_15084 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15078, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17612;

					BgL_sz00_17612 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17613;

						BgL_bpz00_17613 = VECTOR_REF(((obj_t) BgL_sz00_17612), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17613) + BgL_siza7ezd2framez75_15084) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17612))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3509z00_17614;

									BgL_arg3509z00_17614 =
										((long) CINT(BgL_bpz00_17613) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17612), BgL_arg3509z00_17614,
										BgL_lastz00_15085);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17615;

									BgL_ez00_17615 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17615,
										BgL_bpz00_17613);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17616;

										BgL_accz00_17616 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_15083, BgL_sz00_17612, BgL_bpz00_17613);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17615);
										VECTOR_SET(
											((obj_t) BgL_sz00_17612), ((long) 0), BgL_bpz00_17613);
										return BgL_accz00_17616;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17617;

								BgL_nsz00_17617 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17617, ((long) 1), BgL_sz00_17612);
								VECTOR_SET(BgL_nsz00_17617, ((long) 2), BgL_lastz00_15085);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17618;

									BgL_z12denvz12_17618 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17618, BgL_nsz00_17617);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17619;

										BgL_ez00_17619 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17619,
											BgL_sz00_17612);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17620;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17621;

												BgL_savedzd2bpzd2_17621 =
													VECTOR_REF(BgL_nsz00_17617, ((long) 0));
												VECTOR_SET(BgL_nsz00_17617, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17623;

													BgL_fz00_17623 = BgL_runz00_15083;
												BgL_recz00_17622:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17624;

														BgL_rz00_17624 =
															PROCEDURE_ENTRY(BgL_fz00_17623) (BgL_fz00_17623,
															BgL_nsz00_17617, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_test6706z00_31390;

															if (PROCEDUREP(BgL_rz00_17624))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1707z00_17625;

																	BgL_arg1707z00_17625 =
																		PROCEDURE_ATTR(BgL_rz00_17624);
																	if (STRUCTP(BgL_arg1707z00_17625))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6706z00_31390 =
																				(STRUCT_KEY(BgL_arg1707z00_17625) ==
																				BGl_symbol5794z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6706z00_31390 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_test6706z00_31390 = ((bool_t) 0);
																}
															if (BgL_test6706z00_31390)
																{
																	obj_t BgL_fz00_31398;

																	BgL_fz00_31398 = BgL_rz00_17624;
																	BgL_fz00_17623 = BgL_fz00_31398;
																	goto BgL_recz00_17622;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17617, ((long) 0),
																		BgL_savedzd2bpzd2_17621);
																	BgL_____rz00_17620 = BgL_rz00_17624;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17619);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17618, BgL_sz00_17612);
											return BgL_____rz00_17620;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5767 */
	obj_t BGl_z62run5767z62zz__evaluate_compz00(obj_t BgL_envz00_15086,
		obj_t BgL_sz00_15091)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				long BgL_siza7eza7_15087;
				obj_t BgL_valza2za2_15088;
				BgL_ev_absz00_bglt BgL_i1247z00_15089;
				obj_t BgL_bodyz00_15090;

				BgL_siza7eza7_15087 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15086, (int) (((long) 0))));
				BgL_valza2za2_15088 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15086, (int) (((long) 1))));
				BgL_i1247z00_15089 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15086, (int) (((long) 2))));
				BgL_bodyz00_15090 = PROCEDURE_REF(BgL_envz00_15086, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17626;

					BgL_bpz00_17626 = VECTOR_REF(((obj_t) BgL_sz00_15091), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_15091,
						BgL_valza2za2_15088,
						((long) CINT(BgL_bpz00_17626) + BgL_siza7eza7_15087));
					{	/* Eval/evaluate_comp.scm 1088 */
						obj_t BgL_z12denvz12_17627;
						obj_t BgL_wherez00_17628;
						obj_t BgL_locz00_17629;

						BgL_z12denvz12_17627 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17628 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15089))->
							BgL_wherez00);
						BgL_locz00_17629 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15089))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1088 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17627, BgL_wherez00_17628,
								BgL_locz00_17629);
							{	/* Eval/evaluate_comp.scm 1088 */
								obj_t BgL_za2za2resza2za2z00_17630;

								BgL_za2za2resza2za2z00_17630 =
									PROCEDURE_ENTRY(BgL_bodyz00_15090) (BgL_bodyz00_15090,
									BgL_sz00_15091, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17627);
								return BgL_za2za2resza2za2z00_17630;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3512> */
	obj_t BGl_z62zc3z04anonymousza33512ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15092, obj_t BgL_sz00_15099)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_ifreesz00_15093;
				obj_t BgL_iboxesz00_15094;
				long BgL_siza7eza7_15095;
				BgL_ev_absz00_bglt BgL_i1247z00_15096;
				obj_t BgL_bodyz00_15097;
				long BgL_siza7ezd2framez75_15098;

				BgL_ifreesz00_15093 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15092, (int) (((long) 0))));
				BgL_iboxesz00_15094 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15092, (int) (((long) 1))));
				BgL_siza7eza7_15095 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15092, (int) (((long) 2))));
				BgL_i1247z00_15096 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15092, (int) (((long) 3))));
				BgL_bodyz00_15097 = PROCEDURE_REF(BgL_envz00_15092, (int) (((long) 4)));
				BgL_siza7ezd2framez75_15098 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15092, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17631;

					BgL_bpz00_17631 = VECTOR_REF(((obj_t) BgL_sz00_15099), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_valza2za2_17632;

						BgL_valza2za2_17632 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_15099,
							BgL_bpz00_17631, BgL_ifreesz00_15093);
						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17633;

							BgL_runz00_17633 =
								MAKE_FX_PROCEDURE(BGl_z62run5769z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_17633,
								(int) (((long) 0)), BgL_iboxesz00_15094);
							PROCEDURE_SET(BgL_runz00_17633,
								(int) (((long) 1)), BINT(BgL_siza7eza7_15095));
							PROCEDURE_SET(BgL_runz00_17633,
								(int) (((long) 2)), BgL_valza2za2_17632);
							PROCEDURE_SET(BgL_runz00_17633,
								(int) (((long) 3)), ((obj_t) BgL_i1247z00_15096));
							PROCEDURE_SET(BgL_runz00_17633,
								(int) (((long) 4)), BgL_bodyz00_15097);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17634;

								BgL_mainz00_17634 =
									MAKE_VA_PROCEDURE(BGl_z62main5768z62zz__evaluate_compz00,
									(int) (((long) -1)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_17634,
									(int) (((long) 0)), BgL_iboxesz00_15094);
								PROCEDURE_SET(BgL_mainz00_17634,
									(int) (((long) 1)), BINT(BgL_siza7eza7_15095));
								PROCEDURE_SET(BgL_mainz00_17634,
									(int) (((long) 2)), BgL_valza2za2_17632);
								PROCEDURE_SET(BgL_mainz00_17634,
									(int) (((long) 3)), ((obj_t) BgL_i1247z00_15096));
								PROCEDURE_SET(BgL_mainz00_17634,
									(int) (((long) 4)), BgL_bodyz00_15097);
								PROCEDURE_SET(BgL_mainz00_17634,
									(int) (((long) 5)), BgL_runz00_17633);
								PROCEDURE_SET(BgL_mainz00_17634,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_15098));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17635;

									BgL_objz00_17635 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17633, BgL_objz00_17635);
									BgL_objz00_17635;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3514z00_17636;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3515z00_17637;

										BgL_arg3515z00_17637 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15096))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17638;

											BgL_newz00_17638 =
												create_struct(BGl_symbol5815z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_31486;

												BgL_tmpz00_31486 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17638, BgL_tmpz00_31486,
													BgL_arg3515z00_17637);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_31491;
												int BgL_tmpz00_31489;

												BgL_auxz00_31491 = BINT(BgL_siza7ezd2framez75_15098);
												BgL_tmpz00_31489 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17638, BgL_tmpz00_31489,
													BgL_auxz00_31491);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_31494;

												BgL_tmpz00_31494 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17638, BgL_tmpz00_31494,
													BgL_runz00_17633);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_31499;
												int BgL_tmpz00_31497;

												BgL_auxz00_31499 = BINT(((long) -1));
												BgL_tmpz00_31497 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17638, BgL_tmpz00_31497,
													BgL_auxz00_31499);
											}
											BgL_arg3514z00_17636 = BgL_newz00_17638;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17634, BgL_arg3514z00_17636);
									BgL_arg3514z00_17636;
								}
								return BgL_mainz00_17634;
							}
						}
					}
				}
			}
		}

	}



/* &main5768 */
	obj_t BGl_z62main5768z62zz__evaluate_compz00(obj_t BgL_envz00_15100,
		obj_t BgL_lastz00_15108)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_15106;
				long BgL_siza7ezd2framez75_15107;

				BgL_runz00_15106 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15100, (int) (((long) 5))));
				BgL_siza7ezd2framez75_15107 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15100, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17639;

					BgL_sz00_17639 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17640;

						BgL_bpz00_17640 = VECTOR_REF(((obj_t) BgL_sz00_17639), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17640) + BgL_siza7ezd2framez75_15107) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17639))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3518z00_17641;

									BgL_arg3518z00_17641 =
										((long) CINT(BgL_bpz00_17640) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17639), BgL_arg3518z00_17641,
										BgL_lastz00_15108);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17642;

									BgL_ez00_17642 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17642,
										BgL_bpz00_17640);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17643;

										BgL_accz00_17643 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_15106, BgL_sz00_17639, BgL_bpz00_17640);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17642);
										VECTOR_SET(
											((obj_t) BgL_sz00_17639), ((long) 0), BgL_bpz00_17640);
										return BgL_accz00_17643;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17644;

								BgL_nsz00_17644 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17644, ((long) 1), BgL_sz00_17639);
								VECTOR_SET(BgL_nsz00_17644, ((long) 2), BgL_lastz00_15108);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17645;

									BgL_z12denvz12_17645 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17645, BgL_nsz00_17644);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17646;

										BgL_ez00_17646 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17646,
											BgL_sz00_17639);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17647;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17648;

												BgL_savedzd2bpzd2_17648 =
													VECTOR_REF(BgL_nsz00_17644, ((long) 0));
												VECTOR_SET(BgL_nsz00_17644, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17650;

													BgL_fz00_17650 = BgL_runz00_15106;
												BgL_recz00_17649:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17651;

														BgL_rz00_17651 =
															PROCEDURE_ENTRY(BgL_fz00_17650) (BgL_fz00_17650,
															BgL_nsz00_17644, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_test6710z00_31542;

															if (PROCEDUREP(BgL_rz00_17651))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1707z00_17652;

																	BgL_arg1707z00_17652 =
																		PROCEDURE_ATTR(BgL_rz00_17651);
																	if (STRUCTP(BgL_arg1707z00_17652))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6710z00_31542 =
																				(STRUCT_KEY(BgL_arg1707z00_17652) ==
																				BGl_symbol5794z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6710z00_31542 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_test6710z00_31542 = ((bool_t) 0);
																}
															if (BgL_test6710z00_31542)
																{
																	obj_t BgL_fz00_31550;

																	BgL_fz00_31550 = BgL_rz00_17651;
																	BgL_fz00_17650 = BgL_fz00_31550;
																	goto BgL_recz00_17649;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17644, ((long) 0),
																		BgL_savedzd2bpzd2_17648);
																	BgL_____rz00_17647 = BgL_rz00_17651;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17646);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17645, BgL_sz00_17639);
											return BgL_____rz00_17647;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5769 */
	obj_t BGl_z62run5769z62zz__evaluate_compz00(obj_t BgL_envz00_15109,
		obj_t BgL_sz00_15115)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_15110;
				long BgL_siza7eza7_15111;
				obj_t BgL_valza2za2_15112;
				BgL_ev_absz00_bglt BgL_i1247z00_15113;
				obj_t BgL_bodyz00_15114;

				BgL_iboxesz00_15110 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15109, (int) (((long) 0))));
				BgL_siza7eza7_15111 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15109, (int) (((long) 1))));
				BgL_valza2za2_15112 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15109, (int) (((long) 2))));
				BgL_i1247z00_15113 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15109, (int) (((long) 3))));
				BgL_bodyz00_15114 = PROCEDURE_REF(BgL_envz00_15109, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17653;

					BgL_bpz00_17653 = VECTOR_REF(((obj_t) BgL_sz00_15115), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_15115,
						BgL_iboxesz00_15110, BgL_bpz00_17653);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_15115,
						BgL_valza2za2_15112,
						((long) CINT(BgL_bpz00_17653) + BgL_siza7eza7_15111));
					{	/* Eval/evaluate_comp.scm 1088 */
						obj_t BgL_z12denvz12_17654;
						obj_t BgL_wherez00_17655;
						obj_t BgL_locz00_17656;

						BgL_z12denvz12_17654 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17655 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15113))->
							BgL_wherez00);
						BgL_locz00_17656 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15113))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1088 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17654, BgL_wherez00_17655,
								BgL_locz00_17656);
							{	/* Eval/evaluate_comp.scm 1088 */
								obj_t BgL_za2za2resza2za2z00_17657;

								BgL_za2za2resza2za2z00_17657 =
									PROCEDURE_ENTRY(BgL_bodyz00_15114) (BgL_bodyz00_15114,
									BgL_sz00_15115, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17654);
								return BgL_za2za2resza2za2z00_17657;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3444> */
	obj_t BGl_z62zc3z04anonymousza33444ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15116, obj_t BgL_sz00_15120)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1247z00_15117;
				obj_t BgL_bodyz00_15118;
				long BgL_siza7ezd2framez75_15119;

				BgL_i1247z00_15117 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15116, (int) (((long) 0))));
				BgL_bodyz00_15118 = PROCEDURE_REF(BgL_envz00_15116, (int) (((long) 1)));
				BgL_siza7ezd2framez75_15119 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15116, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17658;

					BgL_bpz00_17658 = VECTOR_REF(((obj_t) BgL_sz00_15120), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */

						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17659;

							BgL_runz00_17659 =
								MAKE_FX_PROCEDURE(BGl_z62run5771z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_17659,
								(int) (((long) 0)), ((obj_t) BgL_i1247z00_15117));
							PROCEDURE_SET(BgL_runz00_17659,
								(int) (((long) 1)), BgL_bodyz00_15118);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17660;

								BgL_mainz00_17660 =
									MAKE_FX_PROCEDURE(BGl_z62main5770z62zz__evaluate_compz00,
									(int) (((long) 0)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_17660,
									(int) (((long) 0)), ((obj_t) BgL_i1247z00_15117));
								PROCEDURE_SET(BgL_mainz00_17660,
									(int) (((long) 1)), BgL_bodyz00_15118);
								PROCEDURE_SET(BgL_mainz00_17660,
									(int) (((long) 2)), BgL_runz00_17659);
								PROCEDURE_SET(BgL_mainz00_17660,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_15119));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17661;

									BgL_objz00_17661 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17659, BgL_objz00_17661);
									BgL_objz00_17661;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3445z00_17662;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3446z00_17663;

										BgL_arg3446z00_17663 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15117))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17664;

											BgL_newz00_17664 =
												create_struct(BGl_symbol5815z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_31618;

												BgL_tmpz00_31618 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17664, BgL_tmpz00_31618,
													BgL_arg3446z00_17663);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_31623;
												int BgL_tmpz00_31621;

												BgL_auxz00_31623 = BINT(BgL_siza7ezd2framez75_15119);
												BgL_tmpz00_31621 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17664, BgL_tmpz00_31621,
													BgL_auxz00_31623);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_31626;

												BgL_tmpz00_31626 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17664, BgL_tmpz00_31626,
													BgL_runz00_17659);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_31631;
												int BgL_tmpz00_31629;

												BgL_auxz00_31631 = BINT(((long) 0));
												BgL_tmpz00_31629 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17664, BgL_tmpz00_31629,
													BgL_auxz00_31631);
											}
											BgL_arg3445z00_17662 = BgL_newz00_17664;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17660, BgL_arg3445z00_17662);
									BgL_arg3445z00_17662;
								}
								return BgL_mainz00_17660;
							}
						}
					}
				}
			}
		}

	}



/* &main5770 */
	obj_t BGl_z62main5770z62zz__evaluate_compz00(obj_t BgL_envz00_15121)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_15124;
				long BgL_siza7ezd2framez75_15125;

				BgL_runz00_15124 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15121, (int) (((long) 2))));
				BgL_siza7ezd2framez75_15125 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15121, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17665;

					BgL_sz00_17665 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17666;

						BgL_bpz00_17666 = VECTOR_REF(((obj_t) BgL_sz00_17665), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17666) + BgL_siza7ezd2framez75_15125) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17665))))
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_ez00_17667;

								BgL_ez00_17667 = BGL_EXITD_TOP_AS_OBJ();
								BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17667,
									BgL_bpz00_17666);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_accz00_17668;

									BgL_accz00_17668 =
										BGl_catchzd2trampolinezd2zz__evaluate_compz00
										(BgL_runz00_15124, BgL_sz00_17665, BgL_bpz00_17666);
									BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17667);
									VECTOR_SET(
										((obj_t) BgL_sz00_17665), ((long) 0), BgL_bpz00_17666);
									return BgL_accz00_17668;
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17669;

								BgL_nsz00_17669 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17669, ((long) 1), BgL_sz00_17665);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17670;

									BgL_z12denvz12_17670 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17670, BgL_nsz00_17669);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17671;

										BgL_ez00_17671 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17671,
											BgL_sz00_17665);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17672;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17673;

												BgL_savedzd2bpzd2_17673 =
													VECTOR_REF(BgL_nsz00_17669, ((long) 0));
												VECTOR_SET(BgL_nsz00_17669, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17675;

													BgL_fz00_17675 = BgL_runz00_15124;
												BgL_recz00_17674:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17676;

														BgL_rz00_17676 =
															PROCEDURE_ENTRY(BgL_fz00_17675) (BgL_fz00_17675,
															BgL_nsz00_17669, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_test6714z00_31669;

															if (PROCEDUREP(BgL_rz00_17676))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1707z00_17677;

																	BgL_arg1707z00_17677 =
																		PROCEDURE_ATTR(BgL_rz00_17676);
																	if (STRUCTP(BgL_arg1707z00_17677))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6714z00_31669 =
																				(STRUCT_KEY(BgL_arg1707z00_17677) ==
																				BGl_symbol5794z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6714z00_31669 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_test6714z00_31669 = ((bool_t) 0);
																}
															if (BgL_test6714z00_31669)
																{
																	obj_t BgL_fz00_31677;

																	BgL_fz00_31677 = BgL_rz00_17676;
																	BgL_fz00_17675 = BgL_fz00_31677;
																	goto BgL_recz00_17674;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17669, ((long) 0),
																		BgL_savedzd2bpzd2_17673);
																	BgL_____rz00_17672 = BgL_rz00_17676;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17671);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17670, BgL_sz00_17665);
											return BgL_____rz00_17672;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5771 */
	obj_t BGl_z62run5771z62zz__evaluate_compz00(obj_t BgL_envz00_15126,
		obj_t BgL_sz00_15129)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1247z00_15127;
				obj_t BgL_bodyz00_15128;

				BgL_i1247z00_15127 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15126, (int) (((long) 0))));
				BgL_bodyz00_15128 = PROCEDURE_REF(BgL_envz00_15126, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17678;

					BgL_bpz00_17678 = VECTOR_REF(((obj_t) BgL_sz00_15129), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_z12denvz12_17679;
						obj_t BgL_wherez00_17680;
						obj_t BgL_locz00_17681;

						BgL_z12denvz12_17679 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17680 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15127))->
							BgL_wherez00);
						BgL_locz00_17681 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15127))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1167 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17679, BgL_wherez00_17680,
								BgL_locz00_17681);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_za2za2resza2za2z00_17682;

								BgL_za2za2resza2za2z00_17682 =
									PROCEDURE_ENTRY(BgL_bodyz00_15128) (BgL_bodyz00_15128,
									BgL_sz00_15129, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17679);
								return BgL_za2za2resza2za2z00_17682;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3450> */
	obj_t BGl_z62zc3z04anonymousza33450ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15130, obj_t BgL_sz00_15135)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_15131;
				BgL_ev_absz00_bglt BgL_i1247z00_15132;
				obj_t BgL_bodyz00_15133;
				long BgL_siza7ezd2framez75_15134;

				BgL_iboxesz00_15131 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15130, (int) (((long) 0))));
				BgL_i1247z00_15132 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15130, (int) (((long) 1))));
				BgL_bodyz00_15133 = PROCEDURE_REF(BgL_envz00_15130, (int) (((long) 2)));
				BgL_siza7ezd2framez75_15134 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15130, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17683;

					BgL_bpz00_17683 = VECTOR_REF(((obj_t) BgL_sz00_15135), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */

						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17684;

							BgL_runz00_17684 =
								MAKE_FX_PROCEDURE(BGl_z62run5773z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_17684,
								(int) (((long) 0)), BgL_iboxesz00_15131);
							PROCEDURE_SET(BgL_runz00_17684,
								(int) (((long) 1)), ((obj_t) BgL_i1247z00_15132));
							PROCEDURE_SET(BgL_runz00_17684,
								(int) (((long) 2)), BgL_bodyz00_15133);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17685;

								BgL_mainz00_17685 =
									MAKE_FX_PROCEDURE(BGl_z62main5772z62zz__evaluate_compz00,
									(int) (((long) 0)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_17685,
									(int) (((long) 0)), BgL_iboxesz00_15131);
								PROCEDURE_SET(BgL_mainz00_17685,
									(int) (((long) 1)), ((obj_t) BgL_i1247z00_15132));
								PROCEDURE_SET(BgL_mainz00_17685,
									(int) (((long) 2)), BgL_bodyz00_15133);
								PROCEDURE_SET(BgL_mainz00_17685,
									(int) (((long) 3)), BgL_runz00_17684);
								PROCEDURE_SET(BgL_mainz00_17685,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_15134));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17686;

									BgL_objz00_17686 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17684, BgL_objz00_17686);
									BgL_objz00_17686;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3452z00_17687;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3453z00_17688;

										BgL_arg3453z00_17688 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15132))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17689;

											BgL_newz00_17689 =
												create_struct(BGl_symbol5815z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_31739;

												BgL_tmpz00_31739 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17689, BgL_tmpz00_31739,
													BgL_arg3453z00_17688);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_31744;
												int BgL_tmpz00_31742;

												BgL_auxz00_31744 = BINT(BgL_siza7ezd2framez75_15134);
												BgL_tmpz00_31742 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17689, BgL_tmpz00_31742,
													BgL_auxz00_31744);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_31747;

												BgL_tmpz00_31747 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17689, BgL_tmpz00_31747,
													BgL_runz00_17684);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_31752;
												int BgL_tmpz00_31750;

												BgL_auxz00_31752 = BINT(((long) 0));
												BgL_tmpz00_31750 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17689, BgL_tmpz00_31750,
													BgL_auxz00_31752);
											}
											BgL_arg3452z00_17687 = BgL_newz00_17689;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17685, BgL_arg3452z00_17687);
									BgL_arg3452z00_17687;
								}
								return BgL_mainz00_17685;
							}
						}
					}
				}
			}
		}

	}



/* &main5772 */
	obj_t BGl_z62main5772z62zz__evaluate_compz00(obj_t BgL_envz00_15136)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_15140;
				long BgL_siza7ezd2framez75_15141;

				BgL_runz00_15140 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15136, (int) (((long) 3))));
				BgL_siza7ezd2framez75_15141 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15136, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17690;

					BgL_sz00_17690 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17691;

						BgL_bpz00_17691 = VECTOR_REF(((obj_t) BgL_sz00_17690), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17691) + BgL_siza7ezd2framez75_15141) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17690))))
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_ez00_17692;

								BgL_ez00_17692 = BGL_EXITD_TOP_AS_OBJ();
								BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17692,
									BgL_bpz00_17691);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_accz00_17693;

									BgL_accz00_17693 =
										BGl_catchzd2trampolinezd2zz__evaluate_compz00
										(BgL_runz00_15140, BgL_sz00_17690, BgL_bpz00_17691);
									BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17692);
									VECTOR_SET(
										((obj_t) BgL_sz00_17690), ((long) 0), BgL_bpz00_17691);
									return BgL_accz00_17693;
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17694;

								BgL_nsz00_17694 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17694, ((long) 1), BgL_sz00_17690);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17695;

									BgL_z12denvz12_17695 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17695, BgL_nsz00_17694);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17696;

										BgL_ez00_17696 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17696,
											BgL_sz00_17690);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17697;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17698;

												BgL_savedzd2bpzd2_17698 =
													VECTOR_REF(BgL_nsz00_17694, ((long) 0));
												VECTOR_SET(BgL_nsz00_17694, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17700;

													BgL_fz00_17700 = BgL_runz00_15140;
												BgL_recz00_17699:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17701;

														BgL_rz00_17701 =
															PROCEDURE_ENTRY(BgL_fz00_17700) (BgL_fz00_17700,
															BgL_nsz00_17694, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_test6718z00_31790;

															if (PROCEDUREP(BgL_rz00_17701))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1707z00_17702;

																	BgL_arg1707z00_17702 =
																		PROCEDURE_ATTR(BgL_rz00_17701);
																	if (STRUCTP(BgL_arg1707z00_17702))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6718z00_31790 =
																				(STRUCT_KEY(BgL_arg1707z00_17702) ==
																				BGl_symbol5794z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6718z00_31790 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_test6718z00_31790 = ((bool_t) 0);
																}
															if (BgL_test6718z00_31790)
																{
																	obj_t BgL_fz00_31798;

																	BgL_fz00_31798 = BgL_rz00_17701;
																	BgL_fz00_17700 = BgL_fz00_31798;
																	goto BgL_recz00_17699;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17694, ((long) 0),
																		BgL_savedzd2bpzd2_17698);
																	BgL_____rz00_17697 = BgL_rz00_17701;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17696);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17695, BgL_sz00_17690);
											return BgL_____rz00_17697;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5773 */
	obj_t BGl_z62run5773z62zz__evaluate_compz00(obj_t BgL_envz00_15142,
		obj_t BgL_sz00_15146)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_15143;
				BgL_ev_absz00_bglt BgL_i1247z00_15144;
				obj_t BgL_bodyz00_15145;

				BgL_iboxesz00_15143 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15142, (int) (((long) 0))));
				BgL_i1247z00_15144 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15142, (int) (((long) 1))));
				BgL_bodyz00_15145 = PROCEDURE_REF(BgL_envz00_15142, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17703;

					BgL_bpz00_17703 = VECTOR_REF(((obj_t) BgL_sz00_15146), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_15146,
						BgL_iboxesz00_15143, BgL_bpz00_17703);
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_z12denvz12_17704;
						obj_t BgL_wherez00_17705;
						obj_t BgL_locz00_17706;

						BgL_z12denvz12_17704 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17705 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15144))->
							BgL_wherez00);
						BgL_locz00_17706 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15144))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1167 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17704, BgL_wherez00_17705,
								BgL_locz00_17706);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_za2za2resza2za2z00_17707;

								BgL_za2za2resza2za2z00_17707 =
									PROCEDURE_ENTRY(BgL_bodyz00_15145) (BgL_bodyz00_15145,
									BgL_sz00_15146, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17704);
								return BgL_za2za2resza2za2z00_17707;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3460> */
	obj_t BGl_z62zc3z04anonymousza33460ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15147, obj_t BgL_sz00_15153)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_ifreesz00_15148;
				long BgL_siza7eza7_15149;
				BgL_ev_absz00_bglt BgL_i1247z00_15150;
				obj_t BgL_bodyz00_15151;
				long BgL_siza7ezd2framez75_15152;

				BgL_ifreesz00_15148 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15147, (int) (((long) 0))));
				BgL_siza7eza7_15149 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15147, (int) (((long) 1))));
				BgL_i1247z00_15150 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15147, (int) (((long) 2))));
				BgL_bodyz00_15151 = PROCEDURE_REF(BgL_envz00_15147, (int) (((long) 3)));
				BgL_siza7ezd2framez75_15152 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15147, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17708;

					BgL_bpz00_17708 = VECTOR_REF(((obj_t) BgL_sz00_15153), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_valza2za2_17709;

						BgL_valza2za2_17709 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_15153,
							BgL_bpz00_17708, BgL_ifreesz00_15148);
						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17710;

							BgL_runz00_17710 =
								MAKE_FX_PROCEDURE(BGl_z62run5775z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_17710,
								(int) (((long) 0)), BINT(BgL_siza7eza7_15149));
							PROCEDURE_SET(BgL_runz00_17710,
								(int) (((long) 1)), BgL_valza2za2_17709);
							PROCEDURE_SET(BgL_runz00_17710,
								(int) (((long) 2)), ((obj_t) BgL_i1247z00_15150));
							PROCEDURE_SET(BgL_runz00_17710,
								(int) (((long) 3)), BgL_bodyz00_15151);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17711;

								BgL_mainz00_17711 =
									MAKE_FX_PROCEDURE(BGl_z62main5774z62zz__evaluate_compz00,
									(int) (((long) 0)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_17711,
									(int) (((long) 0)), BINT(BgL_siza7eza7_15149));
								PROCEDURE_SET(BgL_mainz00_17711,
									(int) (((long) 1)), BgL_valza2za2_17709);
								PROCEDURE_SET(BgL_mainz00_17711,
									(int) (((long) 2)), ((obj_t) BgL_i1247z00_15150));
								PROCEDURE_SET(BgL_mainz00_17711,
									(int) (((long) 3)), BgL_bodyz00_15151);
								PROCEDURE_SET(BgL_mainz00_17711,
									(int) (((long) 4)), BgL_runz00_17710);
								PROCEDURE_SET(BgL_mainz00_17711,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_15152));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17712;

									BgL_objz00_17712 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17710, BgL_objz00_17712);
									BgL_objz00_17712;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3461z00_17713;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3462z00_17714;

										BgL_arg3462z00_17714 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15150))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17715;

											BgL_newz00_17715 =
												create_struct(BGl_symbol5815z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_31874;

												BgL_tmpz00_31874 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17715, BgL_tmpz00_31874,
													BgL_arg3462z00_17714);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_31879;
												int BgL_tmpz00_31877;

												BgL_auxz00_31879 = BINT(BgL_siza7ezd2framez75_15152);
												BgL_tmpz00_31877 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17715, BgL_tmpz00_31877,
													BgL_auxz00_31879);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_31882;

												BgL_tmpz00_31882 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17715, BgL_tmpz00_31882,
													BgL_runz00_17710);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_31887;
												int BgL_tmpz00_31885;

												BgL_auxz00_31887 = BINT(((long) 0));
												BgL_tmpz00_31885 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17715, BgL_tmpz00_31885,
													BgL_auxz00_31887);
											}
											BgL_arg3461z00_17713 = BgL_newz00_17715;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17711, BgL_arg3461z00_17713);
									BgL_arg3461z00_17713;
								}
								return BgL_mainz00_17711;
							}
						}
					}
				}
			}
		}

	}



/* &main5774 */
	obj_t BGl_z62main5774z62zz__evaluate_compz00(obj_t BgL_envz00_15154)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_15159;
				long BgL_siza7ezd2framez75_15160;

				BgL_runz00_15159 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15154, (int) (((long) 4))));
				BgL_siza7ezd2framez75_15160 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15154, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17716;

					BgL_sz00_17716 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17717;

						BgL_bpz00_17717 = VECTOR_REF(((obj_t) BgL_sz00_17716), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17717) + BgL_siza7ezd2framez75_15160) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17716))))
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_ez00_17718;

								BgL_ez00_17718 = BGL_EXITD_TOP_AS_OBJ();
								BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17718,
									BgL_bpz00_17717);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_accz00_17719;

									BgL_accz00_17719 =
										BGl_catchzd2trampolinezd2zz__evaluate_compz00
										(BgL_runz00_15159, BgL_sz00_17716, BgL_bpz00_17717);
									BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17718);
									VECTOR_SET(
										((obj_t) BgL_sz00_17716), ((long) 0), BgL_bpz00_17717);
									return BgL_accz00_17719;
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17720;

								BgL_nsz00_17720 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17720, ((long) 1), BgL_sz00_17716);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17721;

									BgL_z12denvz12_17721 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17721, BgL_nsz00_17720);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17722;

										BgL_ez00_17722 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17722,
											BgL_sz00_17716);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17723;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17724;

												BgL_savedzd2bpzd2_17724 =
													VECTOR_REF(BgL_nsz00_17720, ((long) 0));
												VECTOR_SET(BgL_nsz00_17720, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17726;

													BgL_fz00_17726 = BgL_runz00_15159;
												BgL_recz00_17725:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17727;

														BgL_rz00_17727 =
															PROCEDURE_ENTRY(BgL_fz00_17726) (BgL_fz00_17726,
															BgL_nsz00_17720, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_test6722z00_31925;

															if (PROCEDUREP(BgL_rz00_17727))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1707z00_17728;

																	BgL_arg1707z00_17728 =
																		PROCEDURE_ATTR(BgL_rz00_17727);
																	if (STRUCTP(BgL_arg1707z00_17728))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6722z00_31925 =
																				(STRUCT_KEY(BgL_arg1707z00_17728) ==
																				BGl_symbol5794z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6722z00_31925 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_test6722z00_31925 = ((bool_t) 0);
																}
															if (BgL_test6722z00_31925)
																{
																	obj_t BgL_fz00_31933;

																	BgL_fz00_31933 = BgL_rz00_17727;
																	BgL_fz00_17726 = BgL_fz00_31933;
																	goto BgL_recz00_17725;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17720, ((long) 0),
																		BgL_savedzd2bpzd2_17724);
																	BgL_____rz00_17723 = BgL_rz00_17727;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17722);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17721, BgL_sz00_17716);
											return BgL_____rz00_17723;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5775 */
	obj_t BGl_z62run5775z62zz__evaluate_compz00(obj_t BgL_envz00_15161,
		obj_t BgL_sz00_15166)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				long BgL_siza7eza7_15162;
				obj_t BgL_valza2za2_15163;
				BgL_ev_absz00_bglt BgL_i1247z00_15164;
				obj_t BgL_bodyz00_15165;

				BgL_siza7eza7_15162 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15161, (int) (((long) 0))));
				BgL_valza2za2_15163 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15161, (int) (((long) 1))));
				BgL_i1247z00_15164 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15161, (int) (((long) 2))));
				BgL_bodyz00_15165 = PROCEDURE_REF(BgL_envz00_15161, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17729;

					BgL_bpz00_17729 = VECTOR_REF(((obj_t) BgL_sz00_15166), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_15166,
						BgL_valza2za2_15163,
						((long) CINT(BgL_bpz00_17729) + BgL_siza7eza7_15162));
					{	/* Eval/evaluate_comp.scm 1088 */
						obj_t BgL_z12denvz12_17730;
						obj_t BgL_wherez00_17731;
						obj_t BgL_locz00_17732;

						BgL_z12denvz12_17730 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17731 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15164))->
							BgL_wherez00);
						BgL_locz00_17732 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15164))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1088 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17730, BgL_wherez00_17731,
								BgL_locz00_17732);
							{	/* Eval/evaluate_comp.scm 1088 */
								obj_t BgL_za2za2resza2za2z00_17733;

								BgL_za2za2resza2za2z00_17733 =
									PROCEDURE_ENTRY(BgL_bodyz00_15165) (BgL_bodyz00_15165,
									BgL_sz00_15166, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17730);
								return BgL_za2za2resza2za2z00_17733;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3467> */
	obj_t BGl_z62zc3z04anonymousza33467ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15167, obj_t BgL_sz00_15174)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_ifreesz00_15168;
				obj_t BgL_iboxesz00_15169;
				long BgL_siza7eza7_15170;
				BgL_ev_absz00_bglt BgL_i1247z00_15171;
				obj_t BgL_bodyz00_15172;
				long BgL_siza7ezd2framez75_15173;

				BgL_ifreesz00_15168 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15167, (int) (((long) 0))));
				BgL_iboxesz00_15169 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15167, (int) (((long) 1))));
				BgL_siza7eza7_15170 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15167, (int) (((long) 2))));
				BgL_i1247z00_15171 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15167, (int) (((long) 3))));
				BgL_bodyz00_15172 = PROCEDURE_REF(BgL_envz00_15167, (int) (((long) 4)));
				BgL_siza7ezd2framez75_15173 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15167, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17734;

					BgL_bpz00_17734 = VECTOR_REF(((obj_t) BgL_sz00_15174), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_valza2za2_17735;

						BgL_valza2za2_17735 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_15174,
							BgL_bpz00_17734, BgL_ifreesz00_15168);
						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17736;

							BgL_runz00_17736 =
								MAKE_FX_PROCEDURE(BGl_z62run5777z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_17736,
								(int) (((long) 0)), BgL_iboxesz00_15169);
							PROCEDURE_SET(BgL_runz00_17736,
								(int) (((long) 1)), BINT(BgL_siza7eza7_15170));
							PROCEDURE_SET(BgL_runz00_17736,
								(int) (((long) 2)), BgL_valza2za2_17735);
							PROCEDURE_SET(BgL_runz00_17736,
								(int) (((long) 3)), ((obj_t) BgL_i1247z00_15171));
							PROCEDURE_SET(BgL_runz00_17736,
								(int) (((long) 4)), BgL_bodyz00_15172);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17737;

								BgL_mainz00_17737 =
									MAKE_FX_PROCEDURE(BGl_z62main5776z62zz__evaluate_compz00,
									(int) (((long) 0)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_17737,
									(int) (((long) 0)), BgL_iboxesz00_15169);
								PROCEDURE_SET(BgL_mainz00_17737,
									(int) (((long) 1)), BINT(BgL_siza7eza7_15170));
								PROCEDURE_SET(BgL_mainz00_17737,
									(int) (((long) 2)), BgL_valza2za2_17735);
								PROCEDURE_SET(BgL_mainz00_17737,
									(int) (((long) 3)), ((obj_t) BgL_i1247z00_15171));
								PROCEDURE_SET(BgL_mainz00_17737,
									(int) (((long) 4)), BgL_bodyz00_15172);
								PROCEDURE_SET(BgL_mainz00_17737,
									(int) (((long) 5)), BgL_runz00_17736);
								PROCEDURE_SET(BgL_mainz00_17737,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_15173));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17738;

									BgL_objz00_17738 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17736, BgL_objz00_17738);
									BgL_objz00_17738;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3468z00_17739;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3470z00_17740;

										BgL_arg3470z00_17740 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15171))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17741;

											BgL_newz00_17741 =
												create_struct(BGl_symbol5815z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_32021;

												BgL_tmpz00_32021 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17741, BgL_tmpz00_32021,
													BgL_arg3470z00_17740);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_32026;
												int BgL_tmpz00_32024;

												BgL_auxz00_32026 = BINT(BgL_siza7ezd2framez75_15173);
												BgL_tmpz00_32024 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17741, BgL_tmpz00_32024,
													BgL_auxz00_32026);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_32029;

												BgL_tmpz00_32029 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17741, BgL_tmpz00_32029,
													BgL_runz00_17736);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_32034;
												int BgL_tmpz00_32032;

												BgL_auxz00_32034 = BINT(((long) 0));
												BgL_tmpz00_32032 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17741, BgL_tmpz00_32032,
													BgL_auxz00_32034);
											}
											BgL_arg3468z00_17739 = BgL_newz00_17741;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17737, BgL_arg3468z00_17739);
									BgL_arg3468z00_17739;
								}
								return BgL_mainz00_17737;
							}
						}
					}
				}
			}
		}

	}



/* &main5776 */
	obj_t BGl_z62main5776z62zz__evaluate_compz00(obj_t BgL_envz00_15175)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_15181;
				long BgL_siza7ezd2framez75_15182;

				BgL_runz00_15181 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15175, (int) (((long) 5))));
				BgL_siza7ezd2framez75_15182 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15175, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17742;

					BgL_sz00_17742 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17743;

						BgL_bpz00_17743 = VECTOR_REF(((obj_t) BgL_sz00_17742), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17743) + BgL_siza7ezd2framez75_15182) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17742))))
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_ez00_17744;

								BgL_ez00_17744 = BGL_EXITD_TOP_AS_OBJ();
								BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17744,
									BgL_bpz00_17743);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_accz00_17745;

									BgL_accz00_17745 =
										BGl_catchzd2trampolinezd2zz__evaluate_compz00
										(BgL_runz00_15181, BgL_sz00_17742, BgL_bpz00_17743);
									BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17744);
									VECTOR_SET(
										((obj_t) BgL_sz00_17742), ((long) 0), BgL_bpz00_17743);
									return BgL_accz00_17745;
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17746;

								BgL_nsz00_17746 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17746, ((long) 1), BgL_sz00_17742);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17747;

									BgL_z12denvz12_17747 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17747, BgL_nsz00_17746);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17748;

										BgL_ez00_17748 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17748,
											BgL_sz00_17742);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17749;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17750;

												BgL_savedzd2bpzd2_17750 =
													VECTOR_REF(BgL_nsz00_17746, ((long) 0));
												VECTOR_SET(BgL_nsz00_17746, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17752;

													BgL_fz00_17752 = BgL_runz00_15181;
												BgL_recz00_17751:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17753;

														BgL_rz00_17753 =
															PROCEDURE_ENTRY(BgL_fz00_17752) (BgL_fz00_17752,
															BgL_nsz00_17746, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_test6726z00_32072;

															if (PROCEDUREP(BgL_rz00_17753))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1707z00_17754;

																	BgL_arg1707z00_17754 =
																		PROCEDURE_ATTR(BgL_rz00_17753);
																	if (STRUCTP(BgL_arg1707z00_17754))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6726z00_32072 =
																				(STRUCT_KEY(BgL_arg1707z00_17754) ==
																				BGl_symbol5794z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6726z00_32072 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_test6726z00_32072 = ((bool_t) 0);
																}
															if (BgL_test6726z00_32072)
																{
																	obj_t BgL_fz00_32080;

																	BgL_fz00_32080 = BgL_rz00_17753;
																	BgL_fz00_17752 = BgL_fz00_32080;
																	goto BgL_recz00_17751;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17746, ((long) 0),
																		BgL_savedzd2bpzd2_17750);
																	BgL_____rz00_17749 = BgL_rz00_17753;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17748);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17747, BgL_sz00_17742);
											return BgL_____rz00_17749;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5777 */
	obj_t BGl_z62run5777z62zz__evaluate_compz00(obj_t BgL_envz00_15183,
		obj_t BgL_sz00_15189)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_15184;
				long BgL_siza7eza7_15185;
				obj_t BgL_valza2za2_15186;
				BgL_ev_absz00_bglt BgL_i1247z00_15187;
				obj_t BgL_bodyz00_15188;

				BgL_iboxesz00_15184 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15183, (int) (((long) 0))));
				BgL_siza7eza7_15185 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15183, (int) (((long) 1))));
				BgL_valza2za2_15186 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15183, (int) (((long) 2))));
				BgL_i1247z00_15187 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15183, (int) (((long) 3))));
				BgL_bodyz00_15188 = PROCEDURE_REF(BgL_envz00_15183, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17755;

					BgL_bpz00_17755 = VECTOR_REF(((obj_t) BgL_sz00_15189), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_15189,
						BgL_iboxesz00_15184, BgL_bpz00_17755);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_15189,
						BgL_valza2za2_15186,
						((long) CINT(BgL_bpz00_17755) + BgL_siza7eza7_15185));
					{	/* Eval/evaluate_comp.scm 1088 */
						obj_t BgL_z12denvz12_17756;
						obj_t BgL_wherez00_17757;
						obj_t BgL_locz00_17758;

						BgL_z12denvz12_17756 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17757 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15187))->
							BgL_wherez00);
						BgL_locz00_17758 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15187))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1088 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17756, BgL_wherez00_17757,
								BgL_locz00_17758);
							{	/* Eval/evaluate_comp.scm 1088 */
								obj_t BgL_za2za2resza2za2z00_17759;

								BgL_za2za2resza2za2z00_17759 =
									PROCEDURE_ENTRY(BgL_bodyz00_15188) (BgL_bodyz00_15188,
									BgL_sz00_15189, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17756);
								return BgL_za2za2resza2za2z00_17759;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3924> */
	obj_t BGl_z62zc3z04anonymousza33924ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15190, obj_t BgL_sz00_15194)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1247z00_15191;
				obj_t BgL_bodyz00_15192;
				long BgL_siza7ezd2framez75_15193;

				BgL_i1247z00_15191 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15190, (int) (((long) 0))));
				BgL_bodyz00_15192 = PROCEDURE_REF(BgL_envz00_15190, (int) (((long) 1)));
				BgL_siza7ezd2framez75_15193 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15190, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17760;

					BgL_bpz00_17760 = VECTOR_REF(((obj_t) BgL_sz00_15194), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */

						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17761;

							BgL_runz00_17761 =
								MAKE_FX_PROCEDURE(BGl_z62run5779z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_17761,
								(int) (((long) 0)), ((obj_t) BgL_i1247z00_15191));
							PROCEDURE_SET(BgL_runz00_17761,
								(int) (((long) 1)), BgL_bodyz00_15192);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17762;

								BgL_mainz00_17762 =
									MAKE_VA_PROCEDURE(BGl_z62main5778z62zz__evaluate_compz00,
									(int) (((long) -5)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_17762,
									(int) (((long) 0)), BgL_bodyz00_15192);
								PROCEDURE_SET(BgL_mainz00_17762,
									(int) (((long) 1)), ((obj_t) BgL_i1247z00_15191));
								PROCEDURE_SET(BgL_mainz00_17762,
									(int) (((long) 2)), BgL_runz00_17761);
								PROCEDURE_SET(BgL_mainz00_17762,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_15193));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17763;

									BgL_objz00_17763 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17761, BgL_objz00_17763);
									BgL_objz00_17763;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3925z00_17764;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3926z00_17765;
										obj_t BgL_arg3927z00_17766;

										BgL_arg3926z00_17765 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15191))->
											BgL_arityz00);
										BgL_arg3927z00_17766 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15191))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17767;

											BgL_newz00_17767 =
												create_struct(BGl_symbol5815z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_32149;

												BgL_tmpz00_32149 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17767, BgL_tmpz00_32149,
													BgL_arg3927z00_17766);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_32154;
												int BgL_tmpz00_32152;

												BgL_auxz00_32154 = BINT(BgL_siza7ezd2framez75_15193);
												BgL_tmpz00_32152 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17767, BgL_tmpz00_32152,
													BgL_auxz00_32154);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_32157;

												BgL_tmpz00_32157 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17767, BgL_tmpz00_32157,
													BgL_runz00_17761);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_32160;

												BgL_tmpz00_32160 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17767, BgL_tmpz00_32160,
													BgL_arg3926z00_17765);
											}
											BgL_arg3925z00_17764 = BgL_newz00_17767;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17762, BgL_arg3925z00_17764);
									BgL_arg3925z00_17764;
								}
								return BgL_mainz00_17762;
							}
						}
					}
				}
			}
		}

	}



/* &main5778 */
	obj_t BGl_z62main5778z62zz__evaluate_compz00(obj_t BgL_envz00_15195,
		obj_t BgL_az00_15200, obj_t BgL_bz00_15201, obj_t BgL_cz00_15202,
		obj_t BgL_dz00_15203, obj_t BgL_restz00_15204)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1247z00_15197;
				obj_t BgL_runz00_15198;
				long BgL_siza7ezd2framez75_15199;

				BgL_i1247z00_15197 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15195, (int) (((long) 1))));
				BgL_runz00_15198 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15195, (int) (((long) 2))));
				BgL_siza7ezd2framez75_15199 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15195, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17768;

					BgL_sz00_17768 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17769;

						BgL_bpz00_17769 = VECTOR_REF(((obj_t) BgL_sz00_17768), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17769) + BgL_siza7ezd2framez75_15199) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17768))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3930z00_17770;

									BgL_arg3930z00_17770 =
										((long) CINT(BgL_bpz00_17769) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17768), BgL_arg3930z00_17770,
										BgL_az00_15200);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3931z00_17771;

									BgL_arg3931z00_17771 =
										((long) CINT(BgL_bpz00_17769) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17768), BgL_arg3931z00_17771,
										BgL_bz00_15201);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3932z00_17772;

									BgL_arg3932z00_17772 =
										((long) CINT(BgL_bpz00_17769) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_17768), BgL_arg3932z00_17772,
										BgL_cz00_15202);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3933z00_17773;

									BgL_arg3933z00_17773 =
										((long) CINT(BgL_bpz00_17769) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_17768), BgL_arg3933z00_17773,
										BgL_dz00_15203);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3934z00_17774;
									long BgL_arg3935z00_17775;
									long BgL_arg3936z00_17776;
									obj_t BgL_arg3937z00_17777;

									BgL_arg3934z00_17774 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15197))->
										BgL_wherez00);
									BgL_arg3935z00_17775 =
										((long) CINT(BgL_bpz00_17769) + ((long) 4));
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3938z00_17778;

										BgL_arg3938z00_17778 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15197))->
											BgL_arityz00);
										if (((long) CINT(BgL_arg3938z00_17778) < ((long) 0)))
											{	/* Eval/evaluate_comp.scm 1052 */
												BgL_arg3936z00_17776 =
													((long) CINT(BgL_arg3938z00_17778) + ((long) 4));
											}
										else
											{	/* Eval/evaluate_comp.scm 1052 */
												BgL_arg3936z00_17776 =
													((long) CINT(BgL_arg3938z00_17778) - ((long) 4));
									}}
									BgL_arg3937z00_17777 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15197))->
										BgL_locz00);
									BGl_bindzd2framezd2zz__evaluate_compz00(BgL_sz00_17768,
										BgL_arg3934z00_17774, BgL_arg3935z00_17775,
										BgL_arg3936z00_17776, BgL_restz00_15204,
										BgL_arg3937z00_17777);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17779;

									BgL_ez00_17779 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17779,
										BgL_bpz00_17769);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17780;

										BgL_accz00_17780 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_15198, BgL_sz00_17768, BgL_bpz00_17769);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17779);
										VECTOR_SET(
											((obj_t) BgL_sz00_17768), ((long) 0), BgL_bpz00_17769);
										return BgL_accz00_17780;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17781;

								BgL_nsz00_17781 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17781, ((long) 1), BgL_sz00_17768);
								VECTOR_SET(BgL_nsz00_17781, ((long) 2), BgL_az00_15200);
								VECTOR_SET(BgL_nsz00_17781, ((long) 3), BgL_bz00_15201);
								VECTOR_SET(BgL_nsz00_17781, ((long) 4), BgL_cz00_15202);
								VECTOR_SET(BgL_nsz00_17781, ((long) 5), BgL_dz00_15203);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3939z00_17782;
									long BgL_arg3940z00_17783;
									obj_t BgL_arg3941z00_17784;

									BgL_arg3939z00_17782 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15197))->
										BgL_wherez00);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3942z00_17785;

										BgL_arg3942z00_17785 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15197))->
											BgL_arityz00);
										if (((long) CINT(BgL_arg3942z00_17785) < ((long) 0)))
											{	/* Eval/evaluate_comp.scm 1052 */
												BgL_arg3940z00_17783 =
													((long) CINT(BgL_arg3942z00_17785) + ((long) 4));
											}
										else
											{	/* Eval/evaluate_comp.scm 1052 */
												BgL_arg3940z00_17783 =
													((long) CINT(BgL_arg3942z00_17785) - ((long) 4));
									}}
									BgL_arg3941z00_17784 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15197))->
										BgL_locz00);
									BGl_bindzd2framezd2zz__evaluate_compz00(BgL_nsz00_17781,
										BgL_arg3939z00_17782, ((long) 6), BgL_arg3940z00_17783,
										BgL_restz00_15204, BgL_arg3941z00_17784);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17786;

									BgL_z12denvz12_17786 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17786, BgL_nsz00_17781);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17787;

										BgL_ez00_17787 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17787,
											BgL_sz00_17768);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17788;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17789;

												BgL_savedzd2bpzd2_17789 =
													VECTOR_REF(BgL_nsz00_17781, ((long) 0));
												VECTOR_SET(BgL_nsz00_17781, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17791;

													BgL_fz00_17791 = BgL_runz00_15198;
												BgL_recz00_17790:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17792;

														BgL_rz00_17792 =
															PROCEDURE_ENTRY(BgL_fz00_17791) (BgL_fz00_17791,
															BgL_nsz00_17781, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_test6732z00_32245;

															if (PROCEDUREP(BgL_rz00_17792))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1707z00_17793;

																	BgL_arg1707z00_17793 =
																		PROCEDURE_ATTR(BgL_rz00_17792);
																	if (STRUCTP(BgL_arg1707z00_17793))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6732z00_32245 =
																				(STRUCT_KEY(BgL_arg1707z00_17793) ==
																				BGl_symbol5794z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6732z00_32245 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_test6732z00_32245 = ((bool_t) 0);
																}
															if (BgL_test6732z00_32245)
																{
																	obj_t BgL_fz00_32253;

																	BgL_fz00_32253 = BgL_rz00_17792;
																	BgL_fz00_17791 = BgL_fz00_32253;
																	goto BgL_recz00_17790;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17781, ((long) 0),
																		BgL_savedzd2bpzd2_17789);
																	BgL_____rz00_17788 = BgL_rz00_17792;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17787);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17786, BgL_sz00_17768);
											return BgL_____rz00_17788;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5779 */
	obj_t BGl_z62run5779z62zz__evaluate_compz00(obj_t BgL_envz00_15205,
		obj_t BgL_sz00_15208)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1247z00_15206;
				obj_t BgL_bodyz00_15207;

				BgL_i1247z00_15206 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15205, (int) (((long) 0))));
				BgL_bodyz00_15207 = PROCEDURE_REF(BgL_envz00_15205, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17794;

					BgL_bpz00_17794 = VECTOR_REF(((obj_t) BgL_sz00_15208), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_z12denvz12_17795;
						obj_t BgL_wherez00_17796;
						obj_t BgL_locz00_17797;

						BgL_z12denvz12_17795 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17796 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15206))->
							BgL_wherez00);
						BgL_locz00_17797 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15206))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1167 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17795, BgL_wherez00_17796,
								BgL_locz00_17797);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_za2za2resza2za2z00_17798;

								BgL_za2za2resza2za2z00_17798 =
									PROCEDURE_ENTRY(BgL_bodyz00_15207) (BgL_bodyz00_15207,
									BgL_sz00_15208, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17795);
								return BgL_za2za2resza2za2z00_17798;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3944> */
	obj_t BGl_z62zc3z04anonymousza33944ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15209, obj_t BgL_sz00_15214)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_15210;
				BgL_ev_absz00_bglt BgL_i1247z00_15211;
				obj_t BgL_bodyz00_15212;
				long BgL_siza7ezd2framez75_15213;

				BgL_iboxesz00_15210 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15209, (int) (((long) 0))));
				BgL_i1247z00_15211 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15209, (int) (((long) 1))));
				BgL_bodyz00_15212 = PROCEDURE_REF(BgL_envz00_15209, (int) (((long) 2)));
				BgL_siza7ezd2framez75_15213 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15209, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17799;

					BgL_bpz00_17799 = VECTOR_REF(((obj_t) BgL_sz00_15214), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */

						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17800;

							BgL_runz00_17800 =
								MAKE_FX_PROCEDURE(BGl_z62run5781z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_17800,
								(int) (((long) 0)), BgL_iboxesz00_15210);
							PROCEDURE_SET(BgL_runz00_17800,
								(int) (((long) 1)), ((obj_t) BgL_i1247z00_15211));
							PROCEDURE_SET(BgL_runz00_17800,
								(int) (((long) 2)), BgL_bodyz00_15212);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17801;

								BgL_mainz00_17801 =
									MAKE_VA_PROCEDURE(BGl_z62main5780z62zz__evaluate_compz00,
									(int) (((long) -5)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_17801,
									(int) (((long) 0)), BgL_iboxesz00_15210);
								PROCEDURE_SET(BgL_mainz00_17801,
									(int) (((long) 1)), BgL_bodyz00_15212);
								PROCEDURE_SET(BgL_mainz00_17801,
									(int) (((long) 2)), ((obj_t) BgL_i1247z00_15211));
								PROCEDURE_SET(BgL_mainz00_17801,
									(int) (((long) 3)), BgL_runz00_17800);
								PROCEDURE_SET(BgL_mainz00_17801,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_15213));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17802;

									BgL_objz00_17802 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17800, BgL_objz00_17802);
									BgL_objz00_17802;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3945z00_17803;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3946z00_17804;
										obj_t BgL_arg3947z00_17805;

										BgL_arg3946z00_17804 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15211))->
											BgL_arityz00);
										BgL_arg3947z00_17805 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15211))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17806;

											BgL_newz00_17806 =
												create_struct(BGl_symbol5815z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_32316;

												BgL_tmpz00_32316 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17806, BgL_tmpz00_32316,
													BgL_arg3947z00_17805);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_32321;
												int BgL_tmpz00_32319;

												BgL_auxz00_32321 = BINT(BgL_siza7ezd2framez75_15213);
												BgL_tmpz00_32319 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17806, BgL_tmpz00_32319,
													BgL_auxz00_32321);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_32324;

												BgL_tmpz00_32324 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17806, BgL_tmpz00_32324,
													BgL_runz00_17800);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_32327;

												BgL_tmpz00_32327 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17806, BgL_tmpz00_32327,
													BgL_arg3946z00_17804);
											}
											BgL_arg3945z00_17803 = BgL_newz00_17806;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17801, BgL_arg3945z00_17803);
									BgL_arg3945z00_17803;
								}
								return BgL_mainz00_17801;
							}
						}
					}
				}
			}
		}

	}



/* &main5780 */
	obj_t BGl_z62main5780z62zz__evaluate_compz00(obj_t BgL_envz00_15215,
		obj_t BgL_az00_15221, obj_t BgL_bz00_15222, obj_t BgL_cz00_15223,
		obj_t BgL_dz00_15224, obj_t BgL_restz00_15225)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1247z00_15218;
				obj_t BgL_runz00_15219;
				long BgL_siza7ezd2framez75_15220;

				BgL_i1247z00_15218 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15215, (int) (((long) 2))));
				BgL_runz00_15219 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15215, (int) (((long) 3))));
				BgL_siza7ezd2framez75_15220 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15215, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17807;

					BgL_sz00_17807 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17808;

						BgL_bpz00_17808 = VECTOR_REF(((obj_t) BgL_sz00_17807), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17808) + BgL_siza7ezd2framez75_15220) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17807))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3950z00_17809;

									BgL_arg3950z00_17809 =
										((long) CINT(BgL_bpz00_17808) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17807), BgL_arg3950z00_17809,
										BgL_az00_15221);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3951z00_17810;

									BgL_arg3951z00_17810 =
										((long) CINT(BgL_bpz00_17808) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17807), BgL_arg3951z00_17810,
										BgL_bz00_15222);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3952z00_17811;

									BgL_arg3952z00_17811 =
										((long) CINT(BgL_bpz00_17808) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_17807), BgL_arg3952z00_17811,
										BgL_cz00_15223);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3953z00_17812;

									BgL_arg3953z00_17812 =
										((long) CINT(BgL_bpz00_17808) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_17807), BgL_arg3953z00_17812,
										BgL_dz00_15224);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3954z00_17813;
									long BgL_arg3955z00_17814;
									long BgL_arg3956z00_17815;
									obj_t BgL_arg3957z00_17816;

									BgL_arg3954z00_17813 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15218))->
										BgL_wherez00);
									BgL_arg3955z00_17814 =
										((long) CINT(BgL_bpz00_17808) + ((long) 4));
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3958z00_17817;

										BgL_arg3958z00_17817 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15218))->
											BgL_arityz00);
										if (((long) CINT(BgL_arg3958z00_17817) < ((long) 0)))
											{	/* Eval/evaluate_comp.scm 1052 */
												BgL_arg3956z00_17815 =
													((long) CINT(BgL_arg3958z00_17817) + ((long) 4));
											}
										else
											{	/* Eval/evaluate_comp.scm 1052 */
												BgL_arg3956z00_17815 =
													((long) CINT(BgL_arg3958z00_17817) - ((long) 4));
									}}
									BgL_arg3957z00_17816 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15218))->
										BgL_locz00);
									BGl_bindzd2framezd2zz__evaluate_compz00(BgL_sz00_17807,
										BgL_arg3954z00_17813, BgL_arg3955z00_17814,
										BgL_arg3956z00_17815, BgL_restz00_15225,
										BgL_arg3957z00_17816);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17818;

									BgL_ez00_17818 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17818,
										BgL_bpz00_17808);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17819;

										BgL_accz00_17819 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_15219, BgL_sz00_17807, BgL_bpz00_17808);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17818);
										VECTOR_SET(
											((obj_t) BgL_sz00_17807), ((long) 0), BgL_bpz00_17808);
										return BgL_accz00_17819;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17820;

								BgL_nsz00_17820 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17820, ((long) 1), BgL_sz00_17807);
								VECTOR_SET(BgL_nsz00_17820, ((long) 2), BgL_az00_15221);
								VECTOR_SET(BgL_nsz00_17820, ((long) 3), BgL_bz00_15222);
								VECTOR_SET(BgL_nsz00_17820, ((long) 4), BgL_cz00_15223);
								VECTOR_SET(BgL_nsz00_17820, ((long) 5), BgL_dz00_15224);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3959z00_17821;
									long BgL_arg3960z00_17822;
									obj_t BgL_arg3961z00_17823;

									BgL_arg3959z00_17821 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15218))->
										BgL_wherez00);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3962z00_17824;

										BgL_arg3962z00_17824 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15218))->
											BgL_arityz00);
										if (((long) CINT(BgL_arg3962z00_17824) < ((long) 0)))
											{	/* Eval/evaluate_comp.scm 1052 */
												BgL_arg3960z00_17822 =
													((long) CINT(BgL_arg3962z00_17824) + ((long) 4));
											}
										else
											{	/* Eval/evaluate_comp.scm 1052 */
												BgL_arg3960z00_17822 =
													((long) CINT(BgL_arg3962z00_17824) - ((long) 4));
									}}
									BgL_arg3961z00_17823 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15218))->
										BgL_locz00);
									BGl_bindzd2framezd2zz__evaluate_compz00(BgL_nsz00_17820,
										BgL_arg3959z00_17821, ((long) 6), BgL_arg3960z00_17822,
										BgL_restz00_15225, BgL_arg3961z00_17823);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17825;

									BgL_z12denvz12_17825 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17825, BgL_nsz00_17820);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17826;

										BgL_ez00_17826 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17826,
											BgL_sz00_17807);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17827;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17828;

												BgL_savedzd2bpzd2_17828 =
													VECTOR_REF(BgL_nsz00_17820, ((long) 0));
												VECTOR_SET(BgL_nsz00_17820, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17830;

													BgL_fz00_17830 = BgL_runz00_15219;
												BgL_recz00_17829:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17831;

														BgL_rz00_17831 =
															PROCEDURE_ENTRY(BgL_fz00_17830) (BgL_fz00_17830,
															BgL_nsz00_17820, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_test6738z00_32412;

															if (PROCEDUREP(BgL_rz00_17831))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1707z00_17832;

																	BgL_arg1707z00_17832 =
																		PROCEDURE_ATTR(BgL_rz00_17831);
																	if (STRUCTP(BgL_arg1707z00_17832))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6738z00_32412 =
																				(STRUCT_KEY(BgL_arg1707z00_17832) ==
																				BGl_symbol5794z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6738z00_32412 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_test6738z00_32412 = ((bool_t) 0);
																}
															if (BgL_test6738z00_32412)
																{
																	obj_t BgL_fz00_32420;

																	BgL_fz00_32420 = BgL_rz00_17831;
																	BgL_fz00_17830 = BgL_fz00_32420;
																	goto BgL_recz00_17829;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17820, ((long) 0),
																		BgL_savedzd2bpzd2_17828);
																	BgL_____rz00_17827 = BgL_rz00_17831;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17826);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17825, BgL_sz00_17807);
											return BgL_____rz00_17827;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5781 */
	obj_t BGl_z62run5781z62zz__evaluate_compz00(obj_t BgL_envz00_15226,
		obj_t BgL_sz00_15230)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_15227;
				BgL_ev_absz00_bglt BgL_i1247z00_15228;
				obj_t BgL_bodyz00_15229;

				BgL_iboxesz00_15227 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15226, (int) (((long) 0))));
				BgL_i1247z00_15228 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15226, (int) (((long) 1))));
				BgL_bodyz00_15229 = PROCEDURE_REF(BgL_envz00_15226, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17833;

					BgL_bpz00_17833 = VECTOR_REF(((obj_t) BgL_sz00_15230), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_15230,
						BgL_iboxesz00_15227, BgL_bpz00_17833);
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_z12denvz12_17834;
						obj_t BgL_wherez00_17835;
						obj_t BgL_locz00_17836;

						BgL_z12denvz12_17834 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17835 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15228))->
							BgL_wherez00);
						BgL_locz00_17836 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15228))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1167 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17834, BgL_wherez00_17835,
								BgL_locz00_17836);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_za2za2resza2za2z00_17837;

								BgL_za2za2resza2za2z00_17837 =
									PROCEDURE_ENTRY(BgL_bodyz00_15229) (BgL_bodyz00_15229,
									BgL_sz00_15230, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17834);
								return BgL_za2za2resza2za2z00_17837;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3967> */
	obj_t BGl_z62zc3z04anonymousza33967ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15231, obj_t BgL_sz00_15237)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_ifreesz00_15232;
				long BgL_siza7eza7_15233;
				BgL_ev_absz00_bglt BgL_i1247z00_15234;
				obj_t BgL_bodyz00_15235;
				long BgL_siza7ezd2framez75_15236;

				BgL_ifreesz00_15232 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15231, (int) (((long) 0))));
				BgL_siza7eza7_15233 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15231, (int) (((long) 1))));
				BgL_i1247z00_15234 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15231, (int) (((long) 2))));
				BgL_bodyz00_15235 = PROCEDURE_REF(BgL_envz00_15231, (int) (((long) 3)));
				BgL_siza7ezd2framez75_15236 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15231, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17838;

					BgL_bpz00_17838 = VECTOR_REF(((obj_t) BgL_sz00_15237), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_valza2za2_17839;

						BgL_valza2za2_17839 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_15237,
							BgL_bpz00_17838, BgL_ifreesz00_15232);
						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17840;

							BgL_runz00_17840 =
								MAKE_FX_PROCEDURE(BGl_z62run5783z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_17840,
								(int) (((long) 0)), BINT(BgL_siza7eza7_15233));
							PROCEDURE_SET(BgL_runz00_17840,
								(int) (((long) 1)), BgL_valza2za2_17839);
							PROCEDURE_SET(BgL_runz00_17840,
								(int) (((long) 2)), ((obj_t) BgL_i1247z00_15234));
							PROCEDURE_SET(BgL_runz00_17840,
								(int) (((long) 3)), BgL_bodyz00_15235);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17841;

								BgL_mainz00_17841 =
									MAKE_VA_PROCEDURE(BGl_z62main5782z62zz__evaluate_compz00,
									(int) (((long) -5)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_17841,
									(int) (((long) 0)), BINT(BgL_siza7eza7_15233));
								PROCEDURE_SET(BgL_mainz00_17841,
									(int) (((long) 1)), BgL_valza2za2_17839);
								PROCEDURE_SET(BgL_mainz00_17841,
									(int) (((long) 2)), BgL_bodyz00_15235);
								PROCEDURE_SET(BgL_mainz00_17841,
									(int) (((long) 3)), ((obj_t) BgL_i1247z00_15234));
								PROCEDURE_SET(BgL_mainz00_17841,
									(int) (((long) 4)), BgL_runz00_17840);
								PROCEDURE_SET(BgL_mainz00_17841,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_15236));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17842;

									BgL_objz00_17842 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17840, BgL_objz00_17842);
									BgL_objz00_17842;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3968z00_17843;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3969z00_17844;
										obj_t BgL_arg3970z00_17845;

										BgL_arg3969z00_17844 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15234))->
											BgL_arityz00);
										BgL_arg3970z00_17845 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15234))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17846;

											BgL_newz00_17846 =
												create_struct(BGl_symbol5815z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_32497;

												BgL_tmpz00_32497 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17846, BgL_tmpz00_32497,
													BgL_arg3970z00_17845);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_32502;
												int BgL_tmpz00_32500;

												BgL_auxz00_32502 = BINT(BgL_siza7ezd2framez75_15236);
												BgL_tmpz00_32500 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17846, BgL_tmpz00_32500,
													BgL_auxz00_32502);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_32505;

												BgL_tmpz00_32505 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17846, BgL_tmpz00_32505,
													BgL_runz00_17840);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_32508;

												BgL_tmpz00_32508 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17846, BgL_tmpz00_32508,
													BgL_arg3969z00_17844);
											}
											BgL_arg3968z00_17843 = BgL_newz00_17846;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17841, BgL_arg3968z00_17843);
									BgL_arg3968z00_17843;
								}
								return BgL_mainz00_17841;
							}
						}
					}
				}
			}
		}

	}



/* &main5782 */
	obj_t BGl_z62main5782z62zz__evaluate_compz00(obj_t BgL_envz00_15238,
		obj_t BgL_az00_15245, obj_t BgL_bz00_15246, obj_t BgL_cz00_15247,
		obj_t BgL_dz00_15248, obj_t BgL_restz00_15249)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1247z00_15242;
				obj_t BgL_runz00_15243;
				long BgL_siza7ezd2framez75_15244;

				BgL_i1247z00_15242 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15238, (int) (((long) 3))));
				BgL_runz00_15243 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15238, (int) (((long) 4))));
				BgL_siza7ezd2framez75_15244 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15238, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17847;

					BgL_sz00_17847 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17848;

						BgL_bpz00_17848 = VECTOR_REF(((obj_t) BgL_sz00_17847), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17848) + BgL_siza7ezd2framez75_15244) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17847))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3973z00_17849;

									BgL_arg3973z00_17849 =
										((long) CINT(BgL_bpz00_17848) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17847), BgL_arg3973z00_17849,
										BgL_az00_15245);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3974z00_17850;

									BgL_arg3974z00_17850 =
										((long) CINT(BgL_bpz00_17848) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17847), BgL_arg3974z00_17850,
										BgL_bz00_15246);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3975z00_17851;

									BgL_arg3975z00_17851 =
										((long) CINT(BgL_bpz00_17848) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_17847), BgL_arg3975z00_17851,
										BgL_cz00_15247);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3976z00_17852;

									BgL_arg3976z00_17852 =
										((long) CINT(BgL_bpz00_17848) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_17847), BgL_arg3976z00_17852,
										BgL_dz00_15248);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3977z00_17853;
									long BgL_arg3978z00_17854;
									long BgL_arg3979z00_17855;
									obj_t BgL_arg3980z00_17856;

									BgL_arg3977z00_17853 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15242))->
										BgL_wherez00);
									BgL_arg3978z00_17854 =
										((long) CINT(BgL_bpz00_17848) + ((long) 4));
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3981z00_17857;

										BgL_arg3981z00_17857 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15242))->
											BgL_arityz00);
										if (((long) CINT(BgL_arg3981z00_17857) < ((long) 0)))
											{	/* Eval/evaluate_comp.scm 1052 */
												BgL_arg3979z00_17855 =
													((long) CINT(BgL_arg3981z00_17857) + ((long) 4));
											}
										else
											{	/* Eval/evaluate_comp.scm 1052 */
												BgL_arg3979z00_17855 =
													((long) CINT(BgL_arg3981z00_17857) - ((long) 4));
									}}
									BgL_arg3980z00_17856 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15242))->
										BgL_locz00);
									BGl_bindzd2framezd2zz__evaluate_compz00(BgL_sz00_17847,
										BgL_arg3977z00_17853, BgL_arg3978z00_17854,
										BgL_arg3979z00_17855, BgL_restz00_15249,
										BgL_arg3980z00_17856);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17858;

									BgL_ez00_17858 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17858,
										BgL_bpz00_17848);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17859;

										BgL_accz00_17859 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_15243, BgL_sz00_17847, BgL_bpz00_17848);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17858);
										VECTOR_SET(
											((obj_t) BgL_sz00_17847), ((long) 0), BgL_bpz00_17848);
										return BgL_accz00_17859;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17860;

								BgL_nsz00_17860 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17860, ((long) 1), BgL_sz00_17847);
								VECTOR_SET(BgL_nsz00_17860, ((long) 2), BgL_az00_15245);
								VECTOR_SET(BgL_nsz00_17860, ((long) 3), BgL_bz00_15246);
								VECTOR_SET(BgL_nsz00_17860, ((long) 4), BgL_cz00_15247);
								VECTOR_SET(BgL_nsz00_17860, ((long) 5), BgL_dz00_15248);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3982z00_17861;
									long BgL_arg3983z00_17862;
									obj_t BgL_arg3984z00_17863;

									BgL_arg3982z00_17861 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15242))->
										BgL_wherez00);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3985z00_17864;

										BgL_arg3985z00_17864 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15242))->
											BgL_arityz00);
										if (((long) CINT(BgL_arg3985z00_17864) < ((long) 0)))
											{	/* Eval/evaluate_comp.scm 1052 */
												BgL_arg3983z00_17862 =
													((long) CINT(BgL_arg3985z00_17864) + ((long) 4));
											}
										else
											{	/* Eval/evaluate_comp.scm 1052 */
												BgL_arg3983z00_17862 =
													((long) CINT(BgL_arg3985z00_17864) - ((long) 4));
									}}
									BgL_arg3984z00_17863 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15242))->
										BgL_locz00);
									BGl_bindzd2framezd2zz__evaluate_compz00(BgL_nsz00_17860,
										BgL_arg3982z00_17861, ((long) 6), BgL_arg3983z00_17862,
										BgL_restz00_15249, BgL_arg3984z00_17863);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17865;

									BgL_z12denvz12_17865 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17865, BgL_nsz00_17860);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17866;

										BgL_ez00_17866 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17866,
											BgL_sz00_17847);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17867;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17868;

												BgL_savedzd2bpzd2_17868 =
													VECTOR_REF(BgL_nsz00_17860, ((long) 0));
												VECTOR_SET(BgL_nsz00_17860, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17870;

													BgL_fz00_17870 = BgL_runz00_15243;
												BgL_recz00_17869:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17871;

														BgL_rz00_17871 =
															PROCEDURE_ENTRY(BgL_fz00_17870) (BgL_fz00_17870,
															BgL_nsz00_17860, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_test6744z00_32593;

															if (PROCEDUREP(BgL_rz00_17871))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1707z00_17872;

																	BgL_arg1707z00_17872 =
																		PROCEDURE_ATTR(BgL_rz00_17871);
																	if (STRUCTP(BgL_arg1707z00_17872))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6744z00_32593 =
																				(STRUCT_KEY(BgL_arg1707z00_17872) ==
																				BGl_symbol5794z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6744z00_32593 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_test6744z00_32593 = ((bool_t) 0);
																}
															if (BgL_test6744z00_32593)
																{
																	obj_t BgL_fz00_32601;

																	BgL_fz00_32601 = BgL_rz00_17871;
																	BgL_fz00_17870 = BgL_fz00_32601;
																	goto BgL_recz00_17869;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17860, ((long) 0),
																		BgL_savedzd2bpzd2_17868);
																	BgL_____rz00_17867 = BgL_rz00_17871;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17866);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17865, BgL_sz00_17847);
											return BgL_____rz00_17867;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5783 */
	obj_t BGl_z62run5783z62zz__evaluate_compz00(obj_t BgL_envz00_15250,
		obj_t BgL_sz00_15255)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				long BgL_siza7eza7_15251;
				obj_t BgL_valza2za2_15252;
				BgL_ev_absz00_bglt BgL_i1247z00_15253;
				obj_t BgL_bodyz00_15254;

				BgL_siza7eza7_15251 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15250, (int) (((long) 0))));
				BgL_valza2za2_15252 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15250, (int) (((long) 1))));
				BgL_i1247z00_15253 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15250, (int) (((long) 2))));
				BgL_bodyz00_15254 = PROCEDURE_REF(BgL_envz00_15250, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17873;

					BgL_bpz00_17873 = VECTOR_REF(((obj_t) BgL_sz00_15255), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_15255,
						BgL_valza2za2_15252,
						((long) CINT(BgL_bpz00_17873) + BgL_siza7eza7_15251));
					{	/* Eval/evaluate_comp.scm 1088 */
						obj_t BgL_z12denvz12_17874;
						obj_t BgL_wherez00_17875;
						obj_t BgL_locz00_17876;

						BgL_z12denvz12_17874 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17875 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15253))->
							BgL_wherez00);
						BgL_locz00_17876 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15253))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1088 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17874, BgL_wherez00_17875,
								BgL_locz00_17876);
							{	/* Eval/evaluate_comp.scm 1088 */
								obj_t BgL_za2za2resza2za2z00_17877;

								BgL_za2za2resza2za2z00_17877 =
									PROCEDURE_ENTRY(BgL_bodyz00_15254) (BgL_bodyz00_15254,
									BgL_sz00_15255, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17874);
								return BgL_za2za2resza2za2z00_17877;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3988> */
	obj_t BGl_z62zc3z04anonymousza33988ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15256, obj_t BgL_sz00_15263)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_ifreesz00_15257;
				obj_t BgL_iboxesz00_15258;
				long BgL_siza7eza7_15259;
				BgL_ev_absz00_bglt BgL_i1247z00_15260;
				obj_t BgL_bodyz00_15261;
				long BgL_siza7ezd2framez75_15262;

				BgL_ifreesz00_15257 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15256, (int) (((long) 0))));
				BgL_iboxesz00_15258 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15256, (int) (((long) 1))));
				BgL_siza7eza7_15259 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15256, (int) (((long) 2))));
				BgL_i1247z00_15260 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15256, (int) (((long) 3))));
				BgL_bodyz00_15261 = PROCEDURE_REF(BgL_envz00_15256, (int) (((long) 4)));
				BgL_siza7ezd2framez75_15262 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15256, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17878;

					BgL_bpz00_17878 = VECTOR_REF(((obj_t) BgL_sz00_15263), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_valza2za2_17879;

						BgL_valza2za2_17879 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_15263,
							BgL_bpz00_17878, BgL_ifreesz00_15257);
						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17880;

							BgL_runz00_17880 =
								MAKE_FX_PROCEDURE(BGl_z62run5785z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_17880,
								(int) (((long) 0)), BgL_iboxesz00_15258);
							PROCEDURE_SET(BgL_runz00_17880,
								(int) (((long) 1)), BINT(BgL_siza7eza7_15259));
							PROCEDURE_SET(BgL_runz00_17880,
								(int) (((long) 2)), BgL_valza2za2_17879);
							PROCEDURE_SET(BgL_runz00_17880,
								(int) (((long) 3)), ((obj_t) BgL_i1247z00_15260));
							PROCEDURE_SET(BgL_runz00_17880,
								(int) (((long) 4)), BgL_bodyz00_15261);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17881;

								BgL_mainz00_17881 =
									MAKE_VA_PROCEDURE(BGl_z62main5784z62zz__evaluate_compz00,
									(int) (((long) -5)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_17881,
									(int) (((long) 0)), BgL_iboxesz00_15258);
								PROCEDURE_SET(BgL_mainz00_17881,
									(int) (((long) 1)), BINT(BgL_siza7eza7_15259));
								PROCEDURE_SET(BgL_mainz00_17881,
									(int) (((long) 2)), BgL_valza2za2_17879);
								PROCEDURE_SET(BgL_mainz00_17881,
									(int) (((long) 3)), BgL_bodyz00_15261);
								PROCEDURE_SET(BgL_mainz00_17881,
									(int) (((long) 4)), ((obj_t) BgL_i1247z00_15260));
								PROCEDURE_SET(BgL_mainz00_17881,
									(int) (((long) 5)), BgL_runz00_17880);
								PROCEDURE_SET(BgL_mainz00_17881,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_15262));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17882;

									BgL_objz00_17882 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17880, BgL_objz00_17882);
									BgL_objz00_17882;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3989z00_17883;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3990z00_17884;
										obj_t BgL_arg3991z00_17885;

										BgL_arg3990z00_17884 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15260))->
											BgL_arityz00);
										BgL_arg3991z00_17885 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15260))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17886;

											BgL_newz00_17886 =
												create_struct(BGl_symbol5815z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_32690;

												BgL_tmpz00_32690 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17886, BgL_tmpz00_32690,
													BgL_arg3991z00_17885);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_32695;
												int BgL_tmpz00_32693;

												BgL_auxz00_32695 = BINT(BgL_siza7ezd2framez75_15262);
												BgL_tmpz00_32693 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17886, BgL_tmpz00_32693,
													BgL_auxz00_32695);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_32698;

												BgL_tmpz00_32698 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17886, BgL_tmpz00_32698,
													BgL_runz00_17880);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_32701;

												BgL_tmpz00_32701 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17886, BgL_tmpz00_32701,
													BgL_arg3990z00_17884);
											}
											BgL_arg3989z00_17883 = BgL_newz00_17886;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17881, BgL_arg3989z00_17883);
									BgL_arg3989z00_17883;
								}
								return BgL_mainz00_17881;
							}
						}
					}
				}
			}
		}

	}



/* &main5784 */
	obj_t BGl_z62main5784z62zz__evaluate_compz00(obj_t BgL_envz00_15264,
		obj_t BgL_az00_15272, obj_t BgL_bz00_15273, obj_t BgL_cz00_15274,
		obj_t BgL_dz00_15275, obj_t BgL_restz00_15276)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1247z00_15269;
				obj_t BgL_runz00_15270;
				long BgL_siza7ezd2framez75_15271;

				BgL_i1247z00_15269 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15264, (int) (((long) 4))));
				BgL_runz00_15270 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15264, (int) (((long) 5))));
				BgL_siza7ezd2framez75_15271 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15264, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17887;

					BgL_sz00_17887 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17888;

						BgL_bpz00_17888 = VECTOR_REF(((obj_t) BgL_sz00_17887), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17888) + BgL_siza7ezd2framez75_15271) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17887))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3994z00_17889;

									BgL_arg3994z00_17889 =
										((long) CINT(BgL_bpz00_17888) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17887), BgL_arg3994z00_17889,
										BgL_az00_15272);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3995z00_17890;

									BgL_arg3995z00_17890 =
										((long) CINT(BgL_bpz00_17888) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17887), BgL_arg3995z00_17890,
										BgL_bz00_15273);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3996z00_17891;

									BgL_arg3996z00_17891 =
										((long) CINT(BgL_bpz00_17888) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_17887), BgL_arg3996z00_17891,
										BgL_cz00_15274);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3997z00_17892;

									BgL_arg3997z00_17892 =
										((long) CINT(BgL_bpz00_17888) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_17887), BgL_arg3997z00_17892,
										BgL_dz00_15275);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3998z00_17893;
									long BgL_arg3999z00_17894;
									long BgL_arg4000z00_17895;
									obj_t BgL_arg4001z00_17896;

									BgL_arg3998z00_17893 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15269))->
										BgL_wherez00);
									BgL_arg3999z00_17894 =
										((long) CINT(BgL_bpz00_17888) + ((long) 4));
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg4002z00_17897;

										BgL_arg4002z00_17897 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15269))->
											BgL_arityz00);
										if (((long) CINT(BgL_arg4002z00_17897) < ((long) 0)))
											{	/* Eval/evaluate_comp.scm 1052 */
												BgL_arg4000z00_17895 =
													((long) CINT(BgL_arg4002z00_17897) + ((long) 4));
											}
										else
											{	/* Eval/evaluate_comp.scm 1052 */
												BgL_arg4000z00_17895 =
													((long) CINT(BgL_arg4002z00_17897) - ((long) 4));
									}}
									BgL_arg4001z00_17896 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15269))->
										BgL_locz00);
									BGl_bindzd2framezd2zz__evaluate_compz00(BgL_sz00_17887,
										BgL_arg3998z00_17893, BgL_arg3999z00_17894,
										BgL_arg4000z00_17895, BgL_restz00_15276,
										BgL_arg4001z00_17896);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17898;

									BgL_ez00_17898 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17898,
										BgL_bpz00_17888);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17899;

										BgL_accz00_17899 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_15270, BgL_sz00_17887, BgL_bpz00_17888);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17898);
										VECTOR_SET(
											((obj_t) BgL_sz00_17887), ((long) 0), BgL_bpz00_17888);
										return BgL_accz00_17899;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17900;

								BgL_nsz00_17900 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17900, ((long) 1), BgL_sz00_17887);
								VECTOR_SET(BgL_nsz00_17900, ((long) 2), BgL_az00_15272);
								VECTOR_SET(BgL_nsz00_17900, ((long) 3), BgL_bz00_15273);
								VECTOR_SET(BgL_nsz00_17900, ((long) 4), BgL_cz00_15274);
								VECTOR_SET(BgL_nsz00_17900, ((long) 5), BgL_dz00_15275);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg4003z00_17901;
									long BgL_arg4004z00_17902;
									obj_t BgL_arg4005z00_17903;

									BgL_arg4003z00_17901 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15269))->
										BgL_wherez00);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg4006z00_17904;

										BgL_arg4006z00_17904 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15269))->
											BgL_arityz00);
										if (((long) CINT(BgL_arg4006z00_17904) < ((long) 0)))
											{	/* Eval/evaluate_comp.scm 1052 */
												BgL_arg4004z00_17902 =
													((long) CINT(BgL_arg4006z00_17904) + ((long) 4));
											}
										else
											{	/* Eval/evaluate_comp.scm 1052 */
												BgL_arg4004z00_17902 =
													((long) CINT(BgL_arg4006z00_17904) - ((long) 4));
									}}
									BgL_arg4005z00_17903 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15269))->
										BgL_locz00);
									BGl_bindzd2framezd2zz__evaluate_compz00(BgL_nsz00_17900,
										BgL_arg4003z00_17901, ((long) 6), BgL_arg4004z00_17902,
										BgL_restz00_15276, BgL_arg4005z00_17903);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17905;

									BgL_z12denvz12_17905 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17905, BgL_nsz00_17900);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17906;

										BgL_ez00_17906 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17906,
											BgL_sz00_17887);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17907;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17908;

												BgL_savedzd2bpzd2_17908 =
													VECTOR_REF(BgL_nsz00_17900, ((long) 0));
												VECTOR_SET(BgL_nsz00_17900, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17910;

													BgL_fz00_17910 = BgL_runz00_15270;
												BgL_recz00_17909:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17911;

														BgL_rz00_17911 =
															PROCEDURE_ENTRY(BgL_fz00_17910) (BgL_fz00_17910,
															BgL_nsz00_17900, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_test6750z00_32786;

															if (PROCEDUREP(BgL_rz00_17911))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1707z00_17912;

																	BgL_arg1707z00_17912 =
																		PROCEDURE_ATTR(BgL_rz00_17911);
																	if (STRUCTP(BgL_arg1707z00_17912))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6750z00_32786 =
																				(STRUCT_KEY(BgL_arg1707z00_17912) ==
																				BGl_symbol5794z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_test6750z00_32786 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_test6750z00_32786 = ((bool_t) 0);
																}
															if (BgL_test6750z00_32786)
																{
																	obj_t BgL_fz00_32794;

																	BgL_fz00_32794 = BgL_rz00_17911;
																	BgL_fz00_17910 = BgL_fz00_32794;
																	goto BgL_recz00_17909;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17900, ((long) 0),
																		BgL_savedzd2bpzd2_17908);
																	BgL_____rz00_17907 = BgL_rz00_17911;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17906);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17905, BgL_sz00_17887);
											return BgL_____rz00_17907;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5785 */
	obj_t BGl_z62run5785z62zz__evaluate_compz00(obj_t BgL_envz00_15277,
		obj_t BgL_sz00_15283)
	{
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_15278;
				long BgL_siza7eza7_15279;
				obj_t BgL_valza2za2_15280;
				BgL_ev_absz00_bglt BgL_i1247z00_15281;
				obj_t BgL_bodyz00_15282;

				BgL_iboxesz00_15278 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15277, (int) (((long) 0))));
				BgL_siza7eza7_15279 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15277, (int) (((long) 1))));
				BgL_valza2za2_15280 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15277, (int) (((long) 2))));
				BgL_i1247z00_15281 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15277, (int) (((long) 3))));
				BgL_bodyz00_15282 = PROCEDURE_REF(BgL_envz00_15277, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17913;

					BgL_bpz00_17913 = VECTOR_REF(((obj_t) BgL_sz00_15283), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_15283,
						BgL_iboxesz00_15278, BgL_bpz00_17913);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_15283,
						BgL_valza2za2_15280,
						((long) CINT(BgL_bpz00_17913) + BgL_siza7eza7_15279));
					{	/* Eval/evaluate_comp.scm 1088 */
						obj_t BgL_z12denvz12_17914;
						obj_t BgL_wherez00_17915;
						obj_t BgL_locz00_17916;

						BgL_z12denvz12_17914 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17915 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15281))->
							BgL_wherez00);
						BgL_locz00_17916 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15281))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1088 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17914, BgL_wherez00_17915,
								BgL_locz00_17916);
							{	/* Eval/evaluate_comp.scm 1088 */
								obj_t BgL_za2za2resza2za2z00_17917;

								BgL_za2za2resza2za2z00_17917 =
									PROCEDURE_ENTRY(BgL_bodyz00_15282) (BgL_bodyz00_15282,
									BgL_sz00_15283, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17914);
								return BgL_za2za2resza2za2z00_17917;
							}
						}
					}
				}
			}
		}

	}



/* &comp-ev_app1437 */
	obj_t BGl_z62compzd2ev_app1437zb0zz__evaluate_compz00(obj_t BgL_envz00_15284,
		obj_t BgL_ez00_15285, obj_t BgL_stkz00_15286)
	{
		{	/* Eval/evaluate_comp.scm 1037 */
			{	/* Eval/evaluate_comp.scm 1039 */
				obj_t BgL__ortest_1233z00_17919;

				BgL__ortest_1233z00_17919 =
					BGl_arithzd2expressionzd2zz__evaluate_compz00(
					((BgL_ev_appz00_bglt) BgL_ez00_15285), BgL_stkz00_15286);
				if (CBOOL(BgL__ortest_1233z00_17919))
					{	/* Eval/evaluate_comp.scm 1039 */
						return BgL__ortest_1233z00_17919;
					}
				else
					{	/* Eval/evaluate_comp.scm 1040 */
						obj_t BgL__ortest_1234z00_17920;

						BgL__ortest_1234z00_17920 =
							BGl_inlinezd2callzd2zz__evaluate_compz00(
							(((BgL_ev_appz00_bglt) COBJECT(
										((BgL_ev_appz00_bglt) BgL_ez00_15285)))->BgL_locz00),
							(((BgL_ev_appz00_bglt) COBJECT(
										((BgL_ev_appz00_bglt) BgL_ez00_15285)))->BgL_funz00),
							(((BgL_ev_appz00_bglt) COBJECT(
										((BgL_ev_appz00_bglt) BgL_ez00_15285)))->BgL_argsz00),
							BgL_stkz00_15286);
						if (CBOOL(BgL__ortest_1234z00_17920))
							{	/* Eval/evaluate_comp.scm 1040 */
								return BgL__ortest_1234z00_17920;
							}
						else
							{	/* Eval/evaluate_comp.scm 1040 */
								if (
									(bgl_list_length(
											(((BgL_ev_appz00_bglt) COBJECT(
														((BgL_ev_appz00_bglt) BgL_ez00_15285)))->
												BgL_argsz00)) > ((long) 4)))
									{	/* Eval/evaluate_comp.scm 1041 */
										return
											BGl_compzd2oldzd2callz00zz__evaluate_compz00(
											((BgL_ev_appz00_bglt) BgL_ez00_15285), BgL_stkz00_15286);
									}
								else
									{	/* Eval/evaluate_comp.scm 1043 */
										obj_t BgL_fz00_17921;
										long BgL_siza7eza7_17922;
										obj_t BgL_symbzd2funzd2_17923;

										BgL_fz00_17921 =
											BGl_compz00zz__evaluate_compz00(
											(((BgL_ev_appz00_bglt) COBJECT(
														((BgL_ev_appz00_bglt) BgL_ez00_15285)))->
												BgL_funz00), BgL_stkz00_15286);
										BgL_siza7eza7_17922 = bgl_list_length(BgL_stkz00_15286);
										BgL_symbzd2funzd2_17923 =
											BGl_uncompilez00zz__evaluate_uncompz00(
											(((BgL_ev_appz00_bglt) COBJECT(
														((BgL_ev_appz00_bglt) BgL_ez00_15285)))->
												BgL_funz00));
										if (NULLP((((BgL_ev_appz00_bglt)
														COBJECT(((BgL_ev_appz00_bglt) BgL_ez00_15285)))->
													BgL_argsz00)))
											{	/* Eval/evaluate_comp.scm 1044 */
												return
													BGl_compzd2call0zd2zz__evaluate_compz00(
													(((BgL_ev_appz00_bglt) COBJECT(
																((BgL_ev_appz00_bglt) BgL_ez00_15285)))->
														BgL_locz00),
													(((BgL_ev_appz00_bglt) COBJECT(((BgL_ev_appz00_bglt)
																	BgL_ez00_15285)))->BgL_funz00),
													BgL_symbzd2funzd2_17923, BgL_fz00_17921,
													(((BgL_ev_appz00_bglt) COBJECT(((BgL_ev_appz00_bglt)
																	BgL_ez00_15285)))->BgL_tailzf3zf3),
													BgL_stkz00_15286, BgL_siza7eza7_17922);
											}
										else
											{	/* Eval/evaluate_comp.scm 1046 */
												obj_t BgL_a1z00_17924;
												obj_t BgL_argsz00_17925;

												{	/* Eval/evaluate_comp.scm 1046 */
													obj_t BgL_arg3426z00_17926;

													BgL_arg3426z00_17926 =
														CAR(
														(((BgL_ev_appz00_bglt) COBJECT(
																	((BgL_ev_appz00_bglt) BgL_ez00_15285)))->
															BgL_argsz00));
													BgL_a1z00_17924 =
														BGl_compz00zz__evaluate_compz00((
															(BgL_ev_exprz00_bglt) BgL_arg3426z00_17926),
														BgL_stkz00_15286);
												}
												BgL_argsz00_17925 =
													CDR(
													(((BgL_ev_appz00_bglt) COBJECT(
																((BgL_ev_appz00_bglt) BgL_ez00_15285)))->
														BgL_argsz00));
												if (NULLP(BgL_argsz00_17925))
													{	/* Eval/evaluate_comp.scm 1046 */
														return
															BGl_compzd2call1zd2zz__evaluate_compz00(
															(((BgL_ev_appz00_bglt) COBJECT(
																		((BgL_ev_appz00_bglt) BgL_ez00_15285)))->
																BgL_locz00),
															(((BgL_ev_appz00_bglt)
																	COBJECT(((BgL_ev_appz00_bglt)
																			BgL_ez00_15285)))->BgL_funz00),
															BgL_symbzd2funzd2_17923, BgL_fz00_17921,
															(((BgL_ev_appz00_bglt)
																	COBJECT(((BgL_ev_appz00_bglt)
																			BgL_ez00_15285)))->BgL_tailzf3zf3),
															BgL_stkz00_15286, BgL_siza7eza7_17922,
															BgL_a1z00_17924);
													}
												else
													{	/* Eval/evaluate_comp.scm 1046 */
														obj_t BgL_a2z00_17927;
														obj_t BgL_argsz00_17928;

														{	/* Eval/evaluate_comp.scm 1046 */
															obj_t BgL_arg3425z00_17929;

															BgL_arg3425z00_17929 =
																CAR(((obj_t) BgL_argsz00_17925));
															BgL_a2z00_17927 =
																BGl_compz00zz__evaluate_compz00(
																((BgL_ev_exprz00_bglt) BgL_arg3425z00_17929),
																BgL_stkz00_15286);
														}
														BgL_argsz00_17928 =
															CDR(((obj_t) BgL_argsz00_17925));
														if (NULLP(BgL_argsz00_17928))
															{	/* Eval/evaluate_comp.scm 1046 */
																return
																	BGl_compzd2call2zd2zz__evaluate_compz00(
																	(((BgL_ev_appz00_bglt) COBJECT(
																				((BgL_ev_appz00_bglt)
																					BgL_ez00_15285)))->BgL_locz00),
																	(((BgL_ev_appz00_bglt)
																			COBJECT(((BgL_ev_appz00_bglt)
																					BgL_ez00_15285)))->BgL_funz00),
																	BgL_symbzd2funzd2_17923, BgL_fz00_17921,
																	(((BgL_ev_appz00_bglt)
																			COBJECT(((BgL_ev_appz00_bglt)
																					BgL_ez00_15285)))->BgL_tailzf3zf3),
																	BgL_stkz00_15286, BgL_siza7eza7_17922,
																	BgL_a1z00_17924, BgL_a2z00_17927);
															}
														else
															{	/* Eval/evaluate_comp.scm 1046 */
																obj_t BgL_a3z00_17930;
																obj_t BgL_argsz00_17931;

																{	/* Eval/evaluate_comp.scm 1046 */
																	obj_t BgL_arg3424z00_17932;

																	BgL_arg3424z00_17932 =
																		CAR(((obj_t) BgL_argsz00_17928));
																	BgL_a3z00_17930 =
																		BGl_compz00zz__evaluate_compz00(
																		((BgL_ev_exprz00_bglt)
																			BgL_arg3424z00_17932), BgL_stkz00_15286);
																}
																BgL_argsz00_17931 =
																	CDR(((obj_t) BgL_argsz00_17928));
																if (NULLP(BgL_argsz00_17931))
																	{	/* Eval/evaluate_comp.scm 1046 */
																		return
																			BGl_compzd2call3zd2zz__evaluate_compz00(
																			(((BgL_ev_appz00_bglt) COBJECT(
																						((BgL_ev_appz00_bglt)
																							BgL_ez00_15285)))->BgL_locz00),
																			(((BgL_ev_appz00_bglt)
																					COBJECT(((BgL_ev_appz00_bglt)
																							BgL_ez00_15285)))->BgL_funz00),
																			BgL_symbzd2funzd2_17923, BgL_fz00_17921,
																			(((BgL_ev_appz00_bglt)
																					COBJECT(((BgL_ev_appz00_bglt)
																							BgL_ez00_15285)))->
																				BgL_tailzf3zf3), BgL_stkz00_15286,
																			BgL_siza7eza7_17922, BgL_a1z00_17924,
																			BgL_a2z00_17927, BgL_a3z00_17930);
																	}
																else
																	{	/* Eval/evaluate_comp.scm 1046 */
																		obj_t BgL_a4z00_17933;
																		obj_t BgL_argsz00_17934;

																		{	/* Eval/evaluate_comp.scm 1046 */
																			obj_t BgL_arg3423z00_17935;

																			BgL_arg3423z00_17935 =
																				CAR(((obj_t) BgL_argsz00_17931));
																			BgL_a4z00_17933 =
																				BGl_compz00zz__evaluate_compz00(
																				((BgL_ev_exprz00_bglt)
																					BgL_arg3423z00_17935),
																				BgL_stkz00_15286);
																		}
																		BgL_argsz00_17934 =
																			CDR(((obj_t) BgL_argsz00_17931));
																		if (NULLP(BgL_argsz00_17934))
																			{	/* Eval/evaluate_comp.scm 1046 */
																				return
																					BGl_compzd2call4zd2zz__evaluate_compz00
																					((((BgL_ev_appz00_bglt)
																							COBJECT(((BgL_ev_appz00_bglt)
																									BgL_ez00_15285)))->
																						BgL_locz00),
																					(((BgL_ev_appz00_bglt)
																							COBJECT(((BgL_ev_appz00_bglt)
																									BgL_ez00_15285)))->
																						BgL_funz00),
																					BgL_symbzd2funzd2_17923,
																					BgL_fz00_17921,
																					(((BgL_ev_appz00_bglt)
																							COBJECT(((BgL_ev_appz00_bglt)
																									BgL_ez00_15285)))->
																						BgL_tailzf3zf3), BgL_stkz00_15286,
																					BgL_siza7eza7_17922, BgL_a1z00_17924,
																					BgL_a2z00_17927, BgL_a3z00_17930,
																					BgL_a4z00_17933);
																			}
																		else
																			{	/* Eval/evaluate_comp.scm 1046 */
																				return
																					BGl_errorz00zz__errorz00
																					(BGl_string5798z00zz__evaluate_compz00,
																					BGl_string5913z00zz__evaluate_compz00,
																					BGl_string5914z00zz__evaluate_compz00);
																			}
																	}
															}
													}
											}
									}
							}
					}
			}
		}

	}



/* &comp-ev_goto1435 */
	obj_t BGl_z62compzd2ev_goto1435zb0zz__evaluate_compz00(obj_t BgL_envz00_15287,
		obj_t BgL_ez00_15288, obj_t BgL_stkz00_15289)
	{
		{	/* Eval/evaluate_comp.scm 597 */
			{	/* Eval/evaluate_comp.scm 600 */
				obj_t BgL_slotz00_17939;
				long BgL_siza7eza7_17940;
				obj_t BgL_lstkz00_17941;

				BgL_slotz00_17939 =
					BGl_assqz00zz__r4_pairs_and_lists_6_3z00(
					((obj_t)
						(((BgL_ev_gotoz00_bglt) COBJECT(
									((BgL_ev_gotoz00_bglt) BgL_ez00_15288)))->BgL_labelz00)),
					(((BgL_ev_labelsz00_bglt) COBJECT(
								(((BgL_ev_gotoz00_bglt) COBJECT(
											((BgL_ev_gotoz00_bglt) BgL_ez00_15288)))->
									BgL_labelsz00)))->BgL_envz00));
				BgL_siza7eza7_17940 = bgl_list_length(BgL_stkz00_15289);
				BgL_lstkz00_17941 =
					(((BgL_ev_labelsz00_bglt) COBJECT(
							(((BgL_ev_gotoz00_bglt) COBJECT(
										((BgL_ev_gotoz00_bglt) BgL_ez00_15288)))->BgL_labelsz00)))->
					BgL_stkz00);
				{	/* Eval/evaluate_comp.scm 602 */
					long BgL_llstkz00_17942;
					obj_t BgL_substkz00_17943;
					obj_t BgL_boxesz00_17944;

					BgL_llstkz00_17942 = bgl_list_length(BgL_lstkz00_17941);
					BgL_substkz00_17943 =
						BGl_subzd2stkzd2zz__evaluate_compz00(BgL_lstkz00_17941,
						BgL_stkz00_15289);
					{	/* Eval/evaluate_comp.scm 602 */
						obj_t BgL_pairz00_17945;

						BgL_pairz00_17945 =
							BGl_assqz00zz__r4_pairs_and_lists_6_3z00(
							((obj_t)
								(((BgL_ev_gotoz00_bglt) COBJECT(
											((BgL_ev_gotoz00_bglt) BgL_ez00_15288)))->BgL_labelz00)),
							(((BgL_ev_labelsz00_bglt) COBJECT(
										(((BgL_ev_gotoz00_bglt) COBJECT(
													((BgL_ev_gotoz00_bglt) BgL_ez00_15288)))->
											BgL_labelsz00)))->BgL_boxesz00));
						BgL_boxesz00_17944 = CDR(BgL_pairz00_17945);
					}
					if (BGl_needzd2shiftzd2zz__evaluate_compz00(
							(((BgL_ev_gotoz00_bglt) COBJECT(
										((BgL_ev_gotoz00_bglt) BgL_ez00_15288)))->BgL_argsz00),
							BgL_substkz00_17943))
						{	/* Eval/evaluate_comp.scm 605 */
							obj_t BgL_argsz00_17946;
							long BgL_nbargsz00_17947;

							BgL_argsz00_17946 =
								BGl_compzd2withzd2pushz00zz__evaluate_compz00(
								(((BgL_ev_gotoz00_bglt) COBJECT(
											((BgL_ev_gotoz00_bglt) BgL_ez00_15288)))->BgL_argsz00),
								BgL_stkz00_15289);
							BgL_nbargsz00_17947 =
								bgl_list_length((((BgL_ev_gotoz00_bglt)
										COBJECT(((BgL_ev_gotoz00_bglt) BgL_ez00_15288)))->
									BgL_argsz00));
							{	/* Eval/evaluate_comp.scm 606 */
								obj_t BgL_zc3z04anonymousza33371ze3z87_17948;

								BgL_zc3z04anonymousza33371ze3z87_17948 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza33371ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_zc3z04anonymousza33371ze3z87_17948,
									(int) (((long) 0)), BINT(BgL_siza7eza7_17940));
								PROCEDURE_SET(BgL_zc3z04anonymousza33371ze3z87_17948,
									(int) (((long) 1)), BINT(BgL_llstkz00_17942));
								PROCEDURE_SET(BgL_zc3z04anonymousza33371ze3z87_17948,
									(int) (((long) 2)),
									((obj_t) ((BgL_ev_gotoz00_bglt) BgL_ez00_15288)));
								PROCEDURE_SET(BgL_zc3z04anonymousza33371ze3z87_17948,
									(int) (((long) 3)), BgL_argsz00_17946);
								PROCEDURE_SET(BgL_zc3z04anonymousza33371ze3z87_17948,
									(int) (((long) 4)), BgL_boxesz00_17944);
								PROCEDURE_SET(BgL_zc3z04anonymousza33371ze3z87_17948,
									(int) (((long) 5)), BINT(BgL_nbargsz00_17947));
								PROCEDURE_SET(BgL_zc3z04anonymousza33371ze3z87_17948,
									(int) (((long) 6)), BgL_slotz00_17939);
								return BgL_zc3z04anonymousza33371ze3z87_17948;
							}
						}
					else
						{	/* Eval/evaluate_comp.scm 611 */
							obj_t BgL_argsz00_17949;

							{	/* Eval/evaluate_comp.scm 611 */
								obj_t BgL_lz00_17950;
								long BgL_nz00_17951;

								BgL_lz00_17950 =
									(((BgL_ev_gotoz00_bglt) COBJECT(
											((BgL_ev_gotoz00_bglt) BgL_ez00_15288)))->BgL_argsz00);
								BgL_nz00_17951 = (BgL_siza7eza7_17940 - BgL_llstkz00_17942);
								BgL_argsz00_17949 =
									BGl_recze70ze7zz__evaluate_compz00(BgL_stkz00_15289,
									BgL_lz00_17950, BgL_nz00_17951);
							}
							{	/* Eval/evaluate_comp.scm 612 */
								obj_t BgL_zc3z04anonymousza33377ze3z87_17952;

								BgL_zc3z04anonymousza33377ze3z87_17952 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza33377ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_zc3z04anonymousza33377ze3z87_17952,
									(int) (((long) 0)), BINT(BgL_llstkz00_17942));
								PROCEDURE_SET(BgL_zc3z04anonymousza33377ze3z87_17952,
									(int) (((long) 1)),
									((obj_t) ((BgL_ev_gotoz00_bglt) BgL_ez00_15288)));
								PROCEDURE_SET(BgL_zc3z04anonymousza33377ze3z87_17952,
									(int) (((long) 2)), BgL_argsz00_17949);
								PROCEDURE_SET(BgL_zc3z04anonymousza33377ze3z87_17952,
									(int) (((long) 3)), BgL_boxesz00_17944);
								PROCEDURE_SET(BgL_zc3z04anonymousza33377ze3z87_17952,
									(int) (((long) 4)), BgL_slotz00_17939);
								return BgL_zc3z04anonymousza33377ze3z87_17952;
							}
						}
				}
			}
		}

	}



/* &<@anonymous:3371> */
	obj_t BGl_z62zc3z04anonymousza33371ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15290, obj_t BgL_sz00_15298)
	{
		{	/* Eval/evaluate_comp.scm 606 */
			{	/* Eval/evaluate_comp.scm 606 */
				long BgL_siza7eza7_15291;
				long BgL_llstkz00_15292;
				BgL_ev_gotoz00_bglt BgL_i1145z00_15293;
				obj_t BgL_argsz00_15294;
				obj_t BgL_boxesz00_15295;
				long BgL_nbargsz00_15296;
				obj_t BgL_slotz00_15297;

				BgL_siza7eza7_15291 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15290, (int) (((long) 0))));
				BgL_llstkz00_15292 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15290, (int) (((long) 1))));
				BgL_i1145z00_15293 =
					((BgL_ev_gotoz00_bglt)
					PROCEDURE_REF(BgL_envz00_15290, (int) (((long) 2))));
				BgL_argsz00_15294 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15290, (int) (((long) 3))));
				BgL_boxesz00_15295 =
					PROCEDURE_REF(BgL_envz00_15290, (int) (((long) 4)));
				BgL_nbargsz00_15296 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15290, (int) (((long) 5))));
				BgL_slotz00_15297 = PROCEDURE_REF(BgL_envz00_15290, (int) (((long) 6)));
				{	/* Eval/evaluate_comp.scm 606 */
					obj_t BgL_bpz00_17953;

					BgL_bpz00_17953 = VECTOR_REF(((obj_t) BgL_sz00_15298), ((long) 0));
					{	/* Eval/evaluate_comp.scm 607 */
						long BgL_spz00_17954;
						long BgL_lspz00_17955;

						BgL_spz00_17954 =
							((long) CINT(BgL_bpz00_17953) + BgL_siza7eza7_15291);
						BgL_lspz00_17955 =
							((long) CINT(BgL_bpz00_17953) + BgL_llstkz00_15292);
						BGl_pushzd2boxeszd2argszd2onzd2spz00zz__evaluate_compz00
							(BgL_sz00_15298, BgL_argsz00_15294, BgL_boxesz00_15295,
							BgL_spz00_17954,
							(((BgL_ev_gotoz00_bglt) COBJECT(BgL_i1145z00_15293))->
								BgL_locz00));
						{	/* Eval/evaluate_comp.scm 609 */
							long BgL_arg3373z00_17956;

							BgL_arg3373z00_17956 = (BgL_spz00_17954 + BgL_nbargsz00_15296);
							BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_sz00_15298,
								BgL_lspz00_17955, BgL_sz00_15298, BINT(BgL_spz00_17954),
								BINT(BgL_arg3373z00_17956));
						}
						return CDR(((obj_t) BgL_slotz00_15297));
					}
				}
			}
		}

	}



/* &<@anonymous:3377> */
	obj_t BGl_z62zc3z04anonymousza33377ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15299, obj_t BgL_sz00_15305)
	{
		{	/* Eval/evaluate_comp.scm 612 */
			{	/* Eval/evaluate_comp.scm 612 */
				long BgL_llstkz00_15300;
				BgL_ev_gotoz00_bglt BgL_i1145z00_15301;
				obj_t BgL_argsz00_15302;
				obj_t BgL_boxesz00_15303;
				obj_t BgL_slotz00_15304;

				BgL_llstkz00_15300 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15299, (int) (((long) 0))));
				BgL_i1145z00_15301 =
					((BgL_ev_gotoz00_bglt)
					PROCEDURE_REF(BgL_envz00_15299, (int) (((long) 1))));
				BgL_argsz00_15302 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15299, (int) (((long) 2))));
				BgL_boxesz00_15303 =
					PROCEDURE_REF(BgL_envz00_15299, (int) (((long) 3)));
				BgL_slotz00_15304 = PROCEDURE_REF(BgL_envz00_15299, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 612 */
					obj_t BgL_bpz00_17957;

					BgL_bpz00_17957 = VECTOR_REF(((obj_t) BgL_sz00_15305), ((long) 0));
					BGl_pushzd2boxeszd2argszd2onzd2spz00zz__evaluate_compz00
						(BgL_sz00_15305, BgL_argsz00_15302, BgL_boxesz00_15303,
						((long) CINT(BgL_bpz00_17957) + BgL_llstkz00_15300),
						(((BgL_ev_gotoz00_bglt) COBJECT(BgL_i1145z00_15301))->BgL_locz00));
					return CDR(((obj_t) BgL_slotz00_15304));
				}
			}
		}

	}



/* &comp-ev_labels1433 */
	obj_t BGl_z62compzd2ev_labels1433zb0zz__evaluate_compz00(obj_t
		BgL_envz00_15306, obj_t BgL_ez00_15307, obj_t BgL_stkz00_15308)
	{
		{	/* Eval/evaluate_comp.scm 565 */
			((((BgL_ev_labelsz00_bglt) COBJECT(
							((BgL_ev_labelsz00_bglt) BgL_ez00_15307)))->BgL_stkz00) =
				((obj_t) BgL_stkz00_15308), BUNSPEC);
			{	/* Eval/evaluate_comp.scm 572 */
				obj_t BgL_envz00_17959;

				{	/* Eval/evaluate_comp.scm 572 */
					obj_t BgL_l1332z00_17960;

					BgL_l1332z00_17960 =
						(((BgL_ev_labelsz00_bglt) COBJECT(
								((BgL_ev_labelsz00_bglt) BgL_ez00_15307)))->BgL_varsz00);
					if (NULLP(BgL_l1332z00_17960))
						{	/* Eval/evaluate_comp.scm 572 */
							BgL_envz00_17959 = BNIL;
						}
					else
						{	/* Eval/evaluate_comp.scm 572 */
							obj_t BgL_head1334z00_17961;

							{	/* Eval/evaluate_comp.scm 572 */
								obj_t BgL_res5194z00_17962;

								BgL_res5194z00_17962 = MAKE_YOUNG_PAIR(BNIL, BNIL);
								BgL_head1334z00_17961 = BgL_res5194z00_17962;
							}
							{
								obj_t BgL_l1332z00_17964;
								obj_t BgL_tail1335z00_17965;

								BgL_l1332z00_17964 = BgL_l1332z00_17960;
								BgL_tail1335z00_17965 = BgL_head1334z00_17961;
							BgL_zc3z04anonymousza33351ze3z87_17963:
								if (NULLP(BgL_l1332z00_17964))
									{	/* Eval/evaluate_comp.scm 572 */
										BgL_envz00_17959 = CDR(BgL_head1334z00_17961);
									}
								else
									{	/* Eval/evaluate_comp.scm 572 */
										obj_t BgL_newtail1336z00_17966;

										{	/* Eval/evaluate_comp.scm 572 */
											obj_t BgL_arg3365z00_17967;

											{	/* Eval/evaluate_comp.scm 572 */
												obj_t BgL_vz00_17968;

												BgL_vz00_17968 = CAR(((obj_t) BgL_l1332z00_17964));
												BgL_arg3365z00_17967 =
													MAKE_YOUNG_PAIR(BgL_vz00_17968,
													BGl_symbol5915z00zz__evaluate_compz00);
											}
											{	/* Eval/evaluate_comp.scm 572 */
												obj_t BgL_res5200z00_17969;

												BgL_res5200z00_17969 =
													MAKE_YOUNG_PAIR(BgL_arg3365z00_17967, BNIL);
												BgL_newtail1336z00_17966 = BgL_res5200z00_17969;
											}
										}
										SET_CDR(BgL_tail1335z00_17965, BgL_newtail1336z00_17966);
										{	/* Eval/evaluate_comp.scm 572 */
											obj_t BgL_arg3364z00_17970;

											BgL_arg3364z00_17970 = CDR(((obj_t) BgL_l1332z00_17964));
											{
												obj_t BgL_tail1335z00_33073;
												obj_t BgL_l1332z00_33072;

												BgL_l1332z00_33072 = BgL_arg3364z00_17970;
												BgL_tail1335z00_33073 = BgL_newtail1336z00_17966;
												BgL_tail1335z00_17965 = BgL_tail1335z00_33073;
												BgL_l1332z00_17964 = BgL_l1332z00_33072;
												goto BgL_zc3z04anonymousza33351ze3z87_17963;
											}
										}
									}
							}
						}
				}
				((((BgL_ev_labelsz00_bglt) COBJECT(
								((BgL_ev_labelsz00_bglt) BgL_ez00_15307)))->BgL_envz00) =
					((obj_t) BgL_envz00_17959), BUNSPEC);
				{	/* Eval/evaluate_comp.scm 575 */
					obj_t BgL_g1340z00_17971;

					BgL_g1340z00_17971 =
						(((BgL_ev_labelsz00_bglt) COBJECT(
								((BgL_ev_labelsz00_bglt) BgL_ez00_15307)))->BgL_valsz00);
					{
						obj_t BgL_ll1337z00_17973;
						obj_t BgL_ll1338z00_17974;

						BgL_ll1337z00_17973 = BgL_envz00_17959;
						BgL_ll1338z00_17974 = BgL_g1340z00_17971;
					BgL_zc3z04anonymousza33337ze3z87_17972:
						if (NULLP(BgL_ll1337z00_17973))
							{	/* Eval/evaluate_comp.scm 575 */
								((bool_t) 1);
							}
						else
							{	/* Eval/evaluate_comp.scm 575 */
								{	/* Eval/evaluate_comp.scm 577 */
									obj_t BgL_slotz00_17975;
									obj_t BgL_valz00_17976;

									BgL_slotz00_17975 = CAR(((obj_t) BgL_ll1337z00_17973));
									BgL_valz00_17976 = CAR(((obj_t) BgL_ll1338z00_17974));
									{	/* Eval/evaluate_comp.scm 578 */
										obj_t BgL_arg3339z00_17977;

										{	/* Eval/evaluate_comp.scm 578 */
											obj_t BgL_arg3341z00_17978;

											{	/* Eval/evaluate_comp.scm 578 */
												obj_t BgL_arg3342z00_17979;
												obj_t BgL_arg3343z00_17980;

												BgL_arg3342z00_17979 = CDR(((obj_t) BgL_valz00_17976));
												{	/* Eval/evaluate_comp.scm 578 */
													obj_t BgL_arg3345z00_17981;

													BgL_arg3345z00_17981 =
														CAR(((obj_t) BgL_valz00_17976));
													BgL_arg3343z00_17980 =
														BGl_appendzd221011zd2zz__evaluate_compz00
														(BgL_stkz00_15308, BgL_arg3345z00_17981);
												}
												BgL_arg3341z00_17978 =
													BGl_compz00zz__evaluate_compz00(
													((BgL_ev_exprz00_bglt) BgL_arg3342z00_17979),
													BgL_arg3343z00_17980);
											}
											{	/* Eval/evaluate_comp.scm 567 */
												obj_t BgL_objz00_17982;

												BgL_objz00_17982 =
													BGl_za2za2azd2labelza2za2zd2zz__evaluate_compz00;
												{	/* Eval/evaluate_comp.scm 567 */
													obj_t BgL_tmpz00_33091;

													BgL_tmpz00_33091 = ((obj_t) BgL_arg3341z00_17978);
													PROCEDURE_ATTR_SET(BgL_tmpz00_33091,
														BgL_objz00_17982);
												}
												BgL_objz00_17982;
											}
											BgL_arg3339z00_17977 = BgL_arg3341z00_17978;
										}
										{	/* Eval/evaluate_comp.scm 577 */
											obj_t BgL_tmpz00_33094;

											BgL_tmpz00_33094 = ((obj_t) BgL_slotz00_17975);
											SET_CDR(BgL_tmpz00_33094, BgL_arg3339z00_17977);
										}
									}
								}
								{	/* Eval/evaluate_comp.scm 575 */
									obj_t BgL_arg3348z00_17983;
									obj_t BgL_arg3349z00_17984;

									BgL_arg3348z00_17983 = CDR(((obj_t) BgL_ll1337z00_17973));
									BgL_arg3349z00_17984 = CDR(((obj_t) BgL_ll1338z00_17974));
									{
										obj_t BgL_ll1338z00_33102;
										obj_t BgL_ll1337z00_33101;

										BgL_ll1337z00_33101 = BgL_arg3348z00_17983;
										BgL_ll1338z00_33102 = BgL_arg3349z00_17984;
										BgL_ll1338z00_17974 = BgL_ll1338z00_33102;
										BgL_ll1337z00_17973 = BgL_ll1337z00_33101;
										goto BgL_zc3z04anonymousza33337ze3z87_17972;
									}
								}
							}
					}
				}
			}
			{	/* Eval/evaluate_comp.scm 582 */
				obj_t BgL_bodyz00_17985;

				BgL_bodyz00_17985 =
					BGl_compz00zz__evaluate_compz00(
					(((BgL_ev_labelsz00_bglt) COBJECT(
								((BgL_ev_labelsz00_bglt) BgL_ez00_15307)))->BgL_bodyz00),
					BgL_stkz00_15308);
				{	/* Eval/evaluate_comp.scm 583 */
					obj_t BgL_zc3z04anonymousza33366ze3z87_17986;

					BgL_zc3z04anonymousza33366ze3z87_17986 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3z04anonymousza33366ze3ze5zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 1)));
					PROCEDURE_SET(BgL_zc3z04anonymousza33366ze3z87_17986,
						(int) (((long) 0)), BgL_bodyz00_17985);
					return BgL_zc3z04anonymousza33366ze3z87_17986;
				}
			}
		}

	}



/* &<@anonymous:3366> */
	obj_t BGl_z62zc3z04anonymousza33366ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15309, obj_t BgL_sz00_15311)
	{
		{	/* Eval/evaluate_comp.scm 583 */
			{	/* Eval/evaluate_comp.scm 583 */
				obj_t BgL_bodyz00_15310;

				BgL_bodyz00_15310 = PROCEDURE_REF(BgL_envz00_15309, (int) (((long) 0)));
				{	/* Eval/evaluate_comp.scm 583 */
					obj_t BgL_bpz00_17987;

					BgL_bpz00_17987 = VECTOR_REF(((obj_t) BgL_sz00_15311), ((long) 0));
					{
						obj_t BgL_fz00_17989;

						BgL_fz00_17989 = BgL_bodyz00_15310;
					BgL_recz00_17988:
						{	/* Eval/evaluate_comp.scm 590 */
							obj_t BgL_rz00_17990;

							BgL_rz00_17990 =
								PROCEDURE_ENTRY(BgL_fz00_17989) (BgL_fz00_17989, BgL_sz00_15311,
								BEOA);
							{	/* Eval/evaluate_comp.scm 592 */
								bool_t BgL_test6765z00_33119;

								if (PROCEDUREP(BgL_rz00_17990))
									{	/* Eval/evaluate_comp.scm 592 */
										obj_t BgL_arg1663z00_17991;

										BgL_arg1663z00_17991 = PROCEDURE_ATTR(BgL_rz00_17990);
										if (STRUCTP(BgL_arg1663z00_17991))
											{	/* Eval/evaluate_comp.scm 562 */
												BgL_test6765z00_33119 =
													(STRUCT_KEY(BgL_arg1663z00_17991) ==
													BGl_symbol5792z00zz__evaluate_compz00);
											}
										else
											{	/* Eval/evaluate_comp.scm 562 */
												BgL_test6765z00_33119 = ((bool_t) 0);
											}
									}
								else
									{	/* Eval/evaluate_comp.scm 592 */
										BgL_test6765z00_33119 = ((bool_t) 0);
									}
								if (BgL_test6765z00_33119)
									{
										obj_t BgL_fz00_33127;

										BgL_fz00_33127 = BgL_rz00_17990;
										BgL_fz00_17989 = BgL_fz00_33127;
										goto BgL_recz00_17988;
									}
								else
									{	/* Eval/evaluate_comp.scm 592 */
										return BgL_rz00_17990;
									}
							}
						}
					}
				}
			}
		}

	}



/* &comp-ev_synchronize1431 */
	obj_t BGl_z62compzd2ev_synchroniza7e1431z17zz__evaluate_compz00(obj_t
		BgL_envz00_15312, obj_t BgL_ez00_15313, obj_t BgL_stkz00_15314)
	{
		{	/* Eval/evaluate_comp.scm 545 */
			{	/* Eval/evaluate_comp.scm 547 */
				obj_t BgL_mutexz00_17993;
				obj_t BgL_prelockz00_17994;
				obj_t BgL_bodyz00_17995;

				BgL_mutexz00_17993 =
					BGl_compz00zz__evaluate_compz00(
					(((BgL_ev_synchroniza7eza7_bglt) COBJECT(
								((BgL_ev_synchroniza7eza7_bglt) BgL_ez00_15313)))->
						BgL_mutexz00), BgL_stkz00_15314);
				BgL_prelockz00_17994 =
					BGl_compz00zz__evaluate_compz00((((BgL_ev_synchroniza7eza7_bglt)
							COBJECT(((BgL_ev_synchroniza7eza7_bglt) BgL_ez00_15313)))->
						BgL_prelockz00), BgL_stkz00_15314);
				BgL_bodyz00_17995 =
					BGl_compz00zz__evaluate_compz00((((BgL_ev_synchroniza7eza7_bglt)
							COBJECT(((BgL_ev_synchroniza7eza7_bglt) BgL_ez00_15313)))->
						BgL_bodyz00), BgL_stkz00_15314);
				{	/* Eval/evaluate_comp.scm 550 */
					obj_t BgL_zc3z04anonymousza33328ze3z87_17996;

					BgL_zc3z04anonymousza33328ze3z87_17996 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3z04anonymousza33328ze3ze5zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 4)));
					PROCEDURE_SET(BgL_zc3z04anonymousza33328ze3z87_17996,
						(int) (((long) 0)), BgL_mutexz00_17993);
					PROCEDURE_SET(BgL_zc3z04anonymousza33328ze3z87_17996,
						(int) (((long) 1)),
						((obj_t) ((BgL_ev_synchroniza7eza7_bglt) BgL_ez00_15313)));
					PROCEDURE_SET(BgL_zc3z04anonymousza33328ze3z87_17996,
						(int) (((long) 2)), BgL_prelockz00_17994);
					PROCEDURE_SET(BgL_zc3z04anonymousza33328ze3z87_17996,
						(int) (((long) 3)), BgL_bodyz00_17995);
					return BgL_zc3z04anonymousza33328ze3z87_17996;
				}
			}
		}

	}



/* &<@anonymous:3328> */
	obj_t BGl_z62zc3z04anonymousza33328ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15315, obj_t BgL_sz00_15320)
	{
		{	/* Eval/evaluate_comp.scm 550 */
			{	/* Eval/evaluate_comp.scm 550 */
				obj_t BgL_mutexz00_15316;
				BgL_ev_synchroniza7eza7_bglt BgL_i1142z00_15317;
				obj_t BgL_prelockz00_15318;
				obj_t BgL_bodyz00_15319;

				BgL_mutexz00_15316 =
					PROCEDURE_REF(BgL_envz00_15315, (int) (((long) 0)));
				BgL_i1142z00_15317 =
					((BgL_ev_synchroniza7eza7_bglt)
					PROCEDURE_REF(BgL_envz00_15315, (int) (((long) 1))));
				BgL_prelockz00_15318 =
					PROCEDURE_REF(BgL_envz00_15315, (int) (((long) 2)));
				BgL_bodyz00_15319 = PROCEDURE_REF(BgL_envz00_15315, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 550 */
					obj_t BgL_bpz00_17997;

					BgL_bpz00_17997 = VECTOR_REF(((obj_t) BgL_sz00_15320), ((long) 0));
					{	/* Eval/evaluate_comp.scm 551 */
						obj_t BgL_mz00_17998;

						BgL_mz00_17998 =
							PROCEDURE_ENTRY(BgL_mutexz00_15316) (BgL_mutexz00_15316,
							BgL_sz00_15320, BEOA);
						{	/* Eval/evaluate_comp.scm 552 */
							bool_t BgL_test6768z00_33165;

							{	/* Eval/evaluate_comp.scm 552 */
								bool_t BgL_res5191z00_17999;

								BgL_res5191z00_17999 = BGL_MUTEXP(BgL_mz00_17998);
								BgL_test6768z00_33165 = BgL_res5191z00_17999;
							}
							if (BgL_test6768z00_33165)
								{	/* Eval/evaluate_comp.scm 553 */
									obj_t BgL_pz00_18000;

									BgL_pz00_18000 =
										PROCEDURE_ENTRY(BgL_prelockz00_15318) (BgL_prelockz00_15318,
										BgL_sz00_15320, BEOA);
									{	/* Eval/evaluate_comp.scm 555 */
										obj_t BgL_za2za2resza2za2z00_18001;

										if (PAIRP(BgL_pz00_18000))
											{	/* Eval/evaluate_comp.scm 556 */
												obj_t BgL_top6771z00_33174;

												BgL_top6771z00_33174 = BGL_EXITD_TOP_AS_OBJ();
												BGL_MUTEX_LOCK_PRELOCK(BgL_mz00_17998, BgL_pz00_18000);
												BGL_EXITD_PUSH_PROTECT(BgL_top6771z00_33174,
													BgL_mz00_17998);
												BUNSPEC;
												{	/* Eval/evaluate_comp.scm 556 */
													obj_t BgL_tmp6770z00_33173;

													BgL_tmp6770z00_33173 =
														PROCEDURE_ENTRY(BgL_bodyz00_15319)
														(BgL_bodyz00_15319, BgL_sz00_15320, BEOA);
													BGL_EXITD_POP_PROTECT(BgL_top6771z00_33174);
													BUNSPEC;
													BGL_MUTEX_UNLOCK(BgL_mz00_17998);
													BgL_za2za2resza2za2z00_18001 = BgL_tmp6770z00_33173;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 557 */
												obj_t BgL_top6773z00_33185;

												BgL_top6773z00_33185 = BGL_EXITD_TOP_AS_OBJ();
												BGL_MUTEX_LOCK(BgL_mz00_17998);
												BGL_EXITD_PUSH_PROTECT(BgL_top6773z00_33185,
													BgL_mz00_17998);
												BUNSPEC;
												{	/* Eval/evaluate_comp.scm 557 */
													obj_t BgL_tmp6772z00_33184;

													BgL_tmp6772z00_33184 =
														PROCEDURE_ENTRY(BgL_bodyz00_15319)
														(BgL_bodyz00_15319, BgL_sz00_15320, BEOA);
													BGL_EXITD_POP_PROTECT(BgL_top6773z00_33185);
													BUNSPEC;
													BGL_MUTEX_UNLOCK(BgL_mz00_17998);
													BgL_za2za2resza2za2z00_18001 = BgL_tmp6772z00_33184;
												}
											}
										VECTOR_SET(
											((obj_t) BgL_sz00_15320), ((long) 0), BgL_bpz00_17997);
										return BgL_za2za2resza2za2z00_18001;
									}
								}
							else
								{	/* Eval/evaluate_comp.scm 552 */
									return
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_string5917z00zz__evaluate_compz00,
										BGl_string5918z00zz__evaluate_compz00, BgL_mz00_17998,
										(((BgL_ev_synchroniza7eza7_bglt)
												COBJECT(BgL_i1142z00_15317))->BgL_locz00));
								}
						}
					}
				}
			}
		}

	}



/* &comp-ev_with-handler1429 */
	obj_t BGl_z62compzd2ev_withzd2handler1429z62zz__evaluate_compz00(obj_t
		BgL_envz00_15321, obj_t BgL_ez00_15322, obj_t BgL_stkz00_15323)
	{
		{	/* Eval/evaluate_comp.scm 536 */
			{	/* Eval/evaluate_comp.scm 538 */
				obj_t BgL_handlerz00_18003;
				obj_t BgL_bodyz00_18004;

				BgL_handlerz00_18003 =
					BGl_compz00zz__evaluate_compz00(
					(((BgL_ev_withzd2handlerzd2_bglt) COBJECT(
								((BgL_ev_withzd2handlerzd2_bglt) BgL_ez00_15322)))->
						BgL_handlerz00), BgL_stkz00_15323);
				BgL_bodyz00_18004 =
					BGl_compz00zz__evaluate_compz00((((BgL_ev_withzd2handlerzd2_bglt)
							COBJECT(((BgL_ev_withzd2handlerzd2_bglt) BgL_ez00_15322)))->
						BgL_bodyz00), BgL_stkz00_15323);
				{	/* Eval/evaluate_comp.scm 539 */
					obj_t BgL_zc3z04anonymousza33312ze3z87_18005;

					BgL_zc3z04anonymousza33312ze3z87_18005 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3z04anonymousza33312ze3ze5zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 2)));
					PROCEDURE_SET(BgL_zc3z04anonymousza33312ze3z87_18005,
						(int) (((long) 0)), BgL_handlerz00_18003);
					PROCEDURE_SET(BgL_zc3z04anonymousza33312ze3z87_18005,
						(int) (((long) 1)), BgL_bodyz00_18004);
					return BgL_zc3z04anonymousza33312ze3z87_18005;
				}
			}
		}

	}



/* &<@anonymous:3312> */
	obj_t BGl_z62zc3z04anonymousza33312ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15324, obj_t BgL_sz00_15327)
	{
		{	/* Eval/evaluate_comp.scm 539 */
			{	/* Eval/evaluate_comp.scm 539 */
				obj_t BgL_handlerz00_15325;
				obj_t BgL_bodyz00_15326;

				BgL_handlerz00_15325 =
					PROCEDURE_REF(BgL_envz00_15324, (int) (((long) 0)));
				BgL_bodyz00_15326 = PROCEDURE_REF(BgL_envz00_15324, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 539 */
					obj_t BgL_bpz00_18006;

					BgL_bpz00_18006 = VECTOR_REF(((obj_t) BgL_sz00_15327), ((long) 0));
					{	/* Eval/evaluate_comp.scm 540 */
						obj_t BgL_hz00_18007;

						BgL_hz00_18007 =
							PROCEDURE_ENTRY(BgL_handlerz00_15325) (BgL_handlerz00_15325,
							BgL_sz00_15327, BEOA);
						{	/* Eval/evaluate_comp.scm 542 */
							obj_t BgL_za2za2resza2za2z00_18008;

							{	/* Eval/evaluate_comp.scm 542 */
								obj_t BgL_res1132z00_18009;

								BgL_res1132z00_18009 = MAKE_CELL(BUNSPEC);
								if (CBOOL(BGl_zc3z04exitza33319ze3ze70z60zz__evaluate_compz00
										(BgL_sz00_15327, BgL_bodyz00_15326, BgL_res1132z00_18009)))
									{	/* Eval/evaluate_comp.scm 542 */
										BgL_za2za2resza2za2z00_18008 =
											PROCEDURE_ENTRY(BgL_hz00_18007) (BgL_hz00_18007,
											CELL_REF(BgL_res1132z00_18009), BEOA);
									}
								else
									{	/* Eval/evaluate_comp.scm 542 */
										BgL_za2za2resza2za2z00_18008 =
											CELL_REF(BgL_res1132z00_18009);
									}
							}
							VECTOR_SET(((obj_t) BgL_sz00_15327), ((long) 0), BgL_bpz00_18006);
							return BgL_za2za2resza2za2z00_18008;
						}
					}
				}
			}
		}

	}



/* <@exit:3319>~0 */
	obj_t BGl_zc3z04exitza33319ze3ze70z60zz__evaluate_compz00(obj_t
		BgL_sz00_15515, obj_t BgL_bodyz00_15514, obj_t BgL_res1132z00_15513)
	{
		{	/* Eval/evaluate_comp.scm 542 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1138z00_4200;

			if (SET_EXIT(BgL_an_exit1138z00_4200))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1138z00_4200 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 542 */

						PUSH_EXIT(BgL_an_exit1138z00_4200, ((long) 1));
						{	/* Eval/evaluate_comp.scm 542 */
							obj_t BgL_an_exitd1139z00_4201;

							BgL_an_exitd1139z00_4201 = ((obj_t) (&exitd));
							{	/* Eval/evaluate_comp.scm 542 */
								bool_t BgL_res1141z00_4204;

								{	/* Eval/evaluate_comp.scm 542 */
									obj_t BgL_ohs1130z00_4205;

									BgL_ohs1130z00_4205 = BGL_ERROR_HANDLER_GET();
									{	/* Eval/evaluate_comp.scm 542 */
										obj_t BgL_exitd1135z00_4206;

										BgL_exitd1135z00_4206 = ((obj_t) (&exitd));
										{
											obj_t BgL_zc3z04anonymousza33325ze3z87_14294;

											BgL_zc3z04anonymousza33325ze3z87_14294 =
												MAKE_FX_PROCEDURE
												(BGl_z62zc3z04anonymousza33325ze3ze5zz__evaluate_compz00,
												(int) (((long) 0)), (int) (((long) 1)));
											PROCEDURE_SET(BgL_zc3z04anonymousza33325ze3z87_14294,
												(int) (((long) 0)), BgL_ohs1130z00_4205);
											BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
												(BgL_exitd1135z00_4206,
												BgL_zc3z04anonymousza33325ze3z87_14294);
											{	/* Eval/evaluate_comp.scm 542 */
												bool_t BgL_tmp1137z00_4208;

												{	/* Eval/evaluate_comp.scm 542 */
													obj_t BgL_arg3322z00_4209;

													{	/* Eval/evaluate_comp.scm 542 */
														obj_t BgL_zc3z04anonymousza33324ze3z87_14295;

														BgL_zc3z04anonymousza33324ze3z87_14295 =
															MAKE_FX_PROCEDURE
															(BGl_z62zc3z04anonymousza33324ze3ze5zz__evaluate_compz00,
															(int) (((long) 1)), (int) (((long) 2)));
														PROCEDURE_SET
															(BgL_zc3z04anonymousza33324ze3z87_14295,
															(int) (((long) 0)),
															((obj_t) BgL_res1132z00_15513));
														PROCEDURE_SET
															(BgL_zc3z04anonymousza33324ze3z87_14295,
															(int) (((long) 1)), BgL_an_exitd1139z00_4201);
														BgL_arg3322z00_4209 =
															MAKE_YOUNG_PAIR
															(BgL_zc3z04anonymousza33324ze3z87_14295,
															BgL_ohs1130z00_4205);
													}
													BGL_ERROR_HANDLER_SET(BgL_arg3322z00_4209);
													BUNSPEC;
												}
												{	/* Eval/evaluate_comp.scm 542 */
													obj_t BgL_auxz00_15329;

													BgL_auxz00_15329 =
														PROCEDURE_ENTRY(BgL_bodyz00_15514)
														(BgL_bodyz00_15514, BgL_sz00_15515, BEOA);
													CELL_SET(BgL_res1132z00_15513, BgL_auxz00_15329);
												}
												BgL_tmp1137z00_4208 = ((bool_t) 0);
												BGl_exitdzd2popzd2protectz12z12zz__bexitz00
													(BgL_exitd1135z00_4206);
												BGL_ERROR_HANDLER_SET(BgL_ohs1130z00_4205);
												BUNSPEC;
												BgL_res1141z00_4204 = BgL_tmp1137z00_4208;
								}}}}
								POP_EXIT();
								return BBOOL(BgL_res1141z00_4204);
							}
						}
					}
				}
		}

	}



/* &<@anonymous:3324> */
	obj_t BGl_z62zc3z04anonymousza33324ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15331, obj_t BgL_ez00_15334)
	{
		{	/* Eval/evaluate_comp.scm 542 */
			{	/* Eval/evaluate_comp.scm 542 */
				obj_t BgL_res1132z00_15332;
				obj_t BgL_an_exitd1139z00_15333;

				BgL_res1132z00_15332 =
					PROCEDURE_REF(BgL_envz00_15331, (int) (((long) 0)));
				BgL_an_exitd1139z00_15333 =
					PROCEDURE_REF(BgL_envz00_15331, (int) (((long) 1)));
				CELL_SET(BgL_res1132z00_15332, BgL_ez00_15334);
				return
					BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd1139z00_15333,
					BTRUE);
			}
		}

	}



/* &<@anonymous:3325> */
	obj_t BGl_z62zc3z04anonymousza33325ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15336)
	{
		{	/* Eval/evaluate_comp.scm 542 */
			{
				obj_t BgL_ohs1130z00_15337;

				BgL_ohs1130z00_15337 =
					PROCEDURE_REF(BgL_envz00_15336, (int) (((long) 0)));
				BGL_ERROR_HANDLER_SET(BgL_ohs1130z00_15337);
				return BUNSPEC;
			}
		}

	}



/* &comp-ev_unwind-prote1426 */
	obj_t BGl_z62compzd2ev_unwindzd2prote1426z62zz__evaluate_compz00(obj_t
		BgL_envz00_15338, obj_t BgL_ez00_15339, obj_t BgL_stkz00_15340)
	{
		{	/* Eval/evaluate_comp.scm 527 */
			{	/* Eval/evaluate_comp.scm 529 */
				obj_t BgL_ez00_18011;
				obj_t BgL_bodyz00_18012;

				BgL_ez00_18011 =
					BGl_compz00zz__evaluate_compz00(
					(((BgL_ev_unwindzd2protectzd2_bglt) COBJECT(
								((BgL_ev_unwindzd2protectzd2_bglt) BgL_ez00_15339)))->BgL_ez00),
					BgL_stkz00_15340);
				BgL_bodyz00_18012 =
					BGl_compz00zz__evaluate_compz00((((BgL_ev_unwindzd2protectzd2_bglt)
							COBJECT(((BgL_ev_unwindzd2protectzd2_bglt) BgL_ez00_15339)))->
						BgL_bodyz00), BgL_stkz00_15340);
				{	/* Eval/evaluate_comp.scm 530 */
					obj_t BgL_zc3z04anonymousza33306ze3z87_18013;

					BgL_zc3z04anonymousza33306ze3z87_18013 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3z04anonymousza33306ze3ze5zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 2)));
					PROCEDURE_SET(BgL_zc3z04anonymousza33306ze3z87_18013,
						(int) (((long) 0)), BgL_bodyz00_18012);
					PROCEDURE_SET(BgL_zc3z04anonymousza33306ze3z87_18013,
						(int) (((long) 1)), BgL_ez00_18011);
					return BgL_zc3z04anonymousza33306ze3z87_18013;
				}
			}
		}

	}



/* &<@anonymous:3306> */
	obj_t BGl_z62zc3z04anonymousza33306ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15341, obj_t BgL_sz00_15344)
	{
		{	/* Eval/evaluate_comp.scm 530 */
			{	/* Eval/evaluate_comp.scm 530 */
				obj_t BgL_bodyz00_15342;
				obj_t BgL_ez00_15343;

				BgL_bodyz00_15342 = PROCEDURE_REF(BgL_envz00_15341, (int) (((long) 0)));
				BgL_ez00_15343 = PROCEDURE_REF(BgL_envz00_15341, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 530 */
					obj_t BgL_bpz00_18014;

					BgL_bpz00_18014 = VECTOR_REF(((obj_t) BgL_sz00_15344), ((long) 0));
					{	/* Eval/evaluate_comp.scm 532 */
						obj_t BgL_exitd1126z00_18015;

						BgL_exitd1126z00_18015 = BGL_EXITD_TOP_AS_OBJ();
						{	/* Eval/evaluate_comp.scm 533 */
							obj_t BgL_zc3z04anonymousza33307ze3z87_18016;

							BgL_zc3z04anonymousza33307ze3z87_18016 =
								MAKE_FX_PROCEDURE
								(BGl_z62zc3z04anonymousza33307ze3ze5zz__evaluate_compz00,
								(int) (((long) 0)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_zc3z04anonymousza33307ze3z87_18016,
								(int) (((long) 0)), BgL_sz00_15344);
							PROCEDURE_SET(BgL_zc3z04anonymousza33307ze3z87_18016,
								(int) (((long) 1)), BgL_bpz00_18014);
							PROCEDURE_SET(BgL_zc3z04anonymousza33307ze3z87_18016,
								(int) (((long) 2)), BgL_bodyz00_15342);
							BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
								(BgL_exitd1126z00_18015,
								BgL_zc3z04anonymousza33307ze3z87_18016);
							{	/* Eval/evaluate_comp.scm 532 */
								obj_t BgL_tmp1128z00_18017;

								BgL_tmp1128z00_18017 =
									PROCEDURE_ENTRY(BgL_ez00_15343) (BgL_ez00_15343,
									BgL_sz00_15344, BEOA);
								BGl_exitdzd2popzd2protectz12z12zz__bexitz00
									(BgL_exitd1126z00_18015);
								VECTOR_SET(((obj_t) BgL_sz00_15344), ((long) 0),
									BgL_bpz00_18014);
								PROCEDURE_ENTRY(BgL_bodyz00_15342) (BgL_bodyz00_15342,
									BgL_sz00_15344, BEOA);
								return BgL_tmp1128z00_18017;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3307> */
	obj_t BGl_z62zc3z04anonymousza33307ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15345)
	{
		{	/* Eval/evaluate_comp.scm 532 */
			{	/* Eval/evaluate_comp.scm 533 */
				obj_t BgL_sz00_15346;
				obj_t BgL_savedzd2bpzd2_15347;
				obj_t BgL_bodyz00_15348;

				BgL_sz00_15346 = PROCEDURE_REF(BgL_envz00_15345, (int) (((long) 0)));
				BgL_savedzd2bpzd2_15347 =
					PROCEDURE_REF(BgL_envz00_15345, (int) (((long) 1)));
				BgL_bodyz00_15348 = PROCEDURE_REF(BgL_envz00_15345, (int) (((long) 2)));
				VECTOR_SET(
					((obj_t) BgL_sz00_15346), ((long) 0), BgL_savedzd2bpzd2_15347);
				return
					PROCEDURE_ENTRY(BgL_bodyz00_15348) (BgL_bodyz00_15348, BgL_sz00_15346,
					BEOA);
			}
		}

	}



/* &comp-ev_bind-exit1424 */
	obj_t BGl_z62compzd2ev_bindzd2exit1424z62zz__evaluate_compz00(obj_t
		BgL_envz00_15349, obj_t BgL_ez00_15350, obj_t BgL_stkz00_15351)
	{
		{	/* Eval/evaluate_comp.scm 516 */
			{	/* Eval/evaluate_comp.scm 518 */
				long BgL_siza7eza7_18019;
				obj_t BgL_nstkz00_18020;

				BgL_siza7eza7_18019 = bgl_list_length(BgL_stkz00_15351);
				{	/* Eval/evaluate_comp.scm 518 */
					obj_t BgL_arg3303z00_18021;

					{	/* Eval/evaluate_comp.scm 518 */
						BgL_ev_varz00_bglt BgL_arg3305z00_18022;

						BgL_arg3305z00_18022 =
							(((BgL_ev_bindzd2exitzd2_bglt) COBJECT(
									((BgL_ev_bindzd2exitzd2_bglt) BgL_ez00_15350)))->BgL_varz00);
						BgL_arg3303z00_18021 =
							MAKE_YOUNG_PAIR(((obj_t) BgL_arg3305z00_18022), BNIL);
					}
					BgL_nstkz00_18020 =
						BGl_appendzd221011zd2zz__evaluate_compz00(BgL_stkz00_15351,
						BgL_arg3303z00_18021);
				}
				{	/* Eval/evaluate_comp.scm 519 */
					obj_t BgL_bodyz00_18023;
					obj_t BgL_effzf3zf3_18024;

					BgL_bodyz00_18023 =
						BGl_compz00zz__evaluate_compz00(
						(((BgL_ev_bindzd2exitzd2_bglt) COBJECT(
									((BgL_ev_bindzd2exitzd2_bglt) BgL_ez00_15350)))->BgL_bodyz00),
						BgL_nstkz00_18020);
					BgL_effzf3zf3_18024 =
						(((BgL_ev_varz00_bglt) COBJECT((((BgL_ev_bindzd2exitzd2_bglt)
										COBJECT(((BgL_ev_bindzd2exitzd2_bglt) BgL_ez00_15350)))->
									BgL_varz00)))->BgL_effz00);
					{	/* Eval/evaluate_comp.scm 520 */
						obj_t BgL_zc3z04anonymousza33298ze3z87_18025;

						BgL_zc3z04anonymousza33298ze3z87_18025 =
							MAKE_FX_PROCEDURE
							(BGl_z62zc3z04anonymousza33298ze3ze5zz__evaluate_compz00,
							(int) (((long) 1)), (int) (((long) 3)));
						PROCEDURE_SET(BgL_zc3z04anonymousza33298ze3z87_18025,
							(int) (((long) 0)), BINT(BgL_siza7eza7_18019));
						PROCEDURE_SET(BgL_zc3z04anonymousza33298ze3z87_18025,
							(int) (((long) 1)), BgL_effzf3zf3_18024);
						PROCEDURE_SET(BgL_zc3z04anonymousza33298ze3z87_18025,
							(int) (((long) 2)), BgL_bodyz00_18023);
						return BgL_zc3z04anonymousza33298ze3z87_18025;
					}
				}
			}
		}

	}



/* &<@anonymous:3298> */
	obj_t BGl_z62zc3z04anonymousza33298ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15352, obj_t BgL_sz00_15356)
	{
		{	/* Eval/evaluate_comp.scm 520 */
			{	/* Eval/evaluate_comp.scm 520 */
				long BgL_siza7eza7_15353;
				obj_t BgL_effzf3zf3_15354;
				obj_t BgL_bodyz00_15355;

				BgL_siza7eza7_15353 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15352, (int) (((long) 0))));
				BgL_effzf3zf3_15354 =
					PROCEDURE_REF(BgL_envz00_15352, (int) (((long) 1)));
				BgL_bodyz00_15355 = PROCEDURE_REF(BgL_envz00_15352, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 520 */
					obj_t BgL_bpz00_18026;

					BgL_bpz00_18026 = VECTOR_REF(((obj_t) BgL_sz00_15356), ((long) 0));
					{	/* Eval/evaluate_comp.scm 522 */
						obj_t BgL_za2za2resza2za2z00_18027;

						BgL_za2za2resza2za2z00_18027 =
							BGl_zc3z04exitza33299ze3ze70z60zz__evaluate_compz00
							(BgL_bodyz00_15355, BgL_sz00_15356, BgL_effzf3zf3_15354,
							BgL_siza7eza7_15353, BgL_bpz00_18026);
						VECTOR_SET(((obj_t) BgL_sz00_15356), ((long) 0), BgL_bpz00_18026);
						return BgL_za2za2resza2za2z00_18027;
					}
				}
			}
		}

	}



/* <@exit:3299>~0 */
	obj_t BGl_zc3z04exitza33299ze3ze70z60zz__evaluate_compz00(obj_t
		BgL_bodyz00_15512, obj_t BgL_sz00_15511, obj_t BgL_effzf3zf3_15510,
		long BgL_siza7eza7_15509, obj_t BgL_bpz00_15508)
	{
		{	/* Eval/evaluate_comp.scm 522 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1121z00_4135;

			if (SET_EXIT(BgL_an_exit1121z00_4135))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1121z00_4135 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 522 */

						PUSH_EXIT(BgL_an_exit1121z00_4135, ((long) 1));
						{	/* Eval/evaluate_comp.scm 522 */
							obj_t BgL_an_exitd1122z00_4136;

							BgL_an_exitd1122z00_4136 = ((obj_t) (&exitd));
							{	/* Eval/evaluate_comp.scm 522 */
								obj_t BgL_exitz00_14301;

								BgL_exitz00_14301 =
									MAKE_FX_PROCEDURE(BGl_z62exitz62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 1)));
								PROCEDURE_SET(BgL_exitz00_14301,
									(int) (((long) 0)), BgL_an_exitd1122z00_4136);
								{	/* Eval/evaluate_comp.scm 522 */
									obj_t BgL_res1124z00_4139;

									{	/* Eval/evaluate_comp.scm 523 */
										long BgL_arg3300z00_4140;
										obj_t BgL_arg3301z00_4141;

										BgL_arg3300z00_4140 =
											((long) CINT(BgL_bpz00_15508) + BgL_siza7eza7_15509);
										if (CBOOL(BgL_effzf3zf3_15510))
											{	/* Eval/evaluate_comp.scm 202 */
												obj_t BgL_newz00_10510;

												BgL_newz00_10510 =
													create_struct(BGl_symbol5808z00zz__evaluate_compz00,
													(int) (((long) 1)));
												{	/* Eval/evaluate_comp.scm 202 */
													int BgL_tmpz00_33368;

													BgL_tmpz00_33368 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_10510, BgL_tmpz00_33368,
														BgL_exitz00_14301);
												}
												BgL_arg3301z00_4141 = BgL_newz00_10510;
											}
										else
											{	/* Eval/evaluate_comp.scm 523 */
												BgL_arg3301z00_4141 = BgL_exitz00_14301;
											}
										VECTOR_SET(
											((obj_t) BgL_sz00_15511), BgL_arg3300z00_4140,
											BgL_arg3301z00_4141);
									}
									BgL_res1124z00_4139 =
										PROCEDURE_ENTRY(BgL_bodyz00_15512) (BgL_bodyz00_15512,
										BgL_sz00_15511, BEOA);
									POP_EXIT();
									return BgL_res1124z00_4139;
								}
							}
						}
					}
				}
		}

	}



/* &exit */
	obj_t BGl_z62exitz62zz__evaluate_compz00(obj_t BgL_envz00_15357,
		obj_t BgL_val1123z00_15359)
	{
		{	/* Eval/evaluate_comp.scm 522 */
			return
				BGl_unwindzd2untilz12zc0zz__bexitz00(PROCEDURE_REF(BgL_envz00_15357,
					(int) (((long) 0))), BgL_val1123z00_15359);
		}

	}



/* &comp-ev_letrec1422 */
	obj_t BGl_z62compzd2ev_letrec1422zb0zz__evaluate_compz00(obj_t
		BgL_envz00_15360, obj_t BgL_ez00_15361, obj_t BgL_stkz00_15362)
	{
		{	/* Eval/evaluate_comp.scm 487 */
			{	/* Eval/evaluate_comp.scm 489 */
				long BgL_siza7eza7_18029;
				obj_t BgL_nstkz00_18030;

				BgL_siza7eza7_18029 = bgl_list_length(BgL_stkz00_15362);
				{	/* Eval/evaluate_comp.scm 489 */
					obj_t BgL_arg3297z00_18031;

					BgL_arg3297z00_18031 =
						(((BgL_ev_binderz00_bglt) COBJECT(
								((BgL_ev_binderz00_bglt)
									((BgL_ev_letrecz00_bglt) BgL_ez00_15361))))->BgL_varsz00);
					BgL_nstkz00_18030 =
						BGl_appendzd221011zd2zz__evaluate_compz00(BgL_stkz00_15362,
						BgL_arg3297z00_18031);
				}
				{	/* Eval/evaluate_comp.scm 490 */
					obj_t BgL_cvalsz00_18032;
					obj_t BgL_bodyz00_18033;

					{	/* Eval/evaluate_comp.scm 490 */
						obj_t BgL_l1318z00_18034;

						BgL_l1318z00_18034 =
							(((BgL_ev_binderz00_bglt) COBJECT(
									((BgL_ev_binderz00_bglt)
										((BgL_ev_letrecz00_bglt) BgL_ez00_15361))))->BgL_valsz00);
						if (NULLP(BgL_l1318z00_18034))
							{	/* Eval/evaluate_comp.scm 490 */
								BgL_cvalsz00_18032 = BNIL;
							}
						else
							{	/* Eval/evaluate_comp.scm 490 */
								obj_t BgL_head1320z00_18035;

								{	/* Eval/evaluate_comp.scm 490 */
									obj_t BgL_res5150z00_18036;

									BgL_res5150z00_18036 = MAKE_YOUNG_PAIR(BNIL, BNIL);
									BgL_head1320z00_18035 = BgL_res5150z00_18036;
								}
								{
									obj_t BgL_l1318z00_18038;
									obj_t BgL_tail1321z00_18039;

									BgL_l1318z00_18038 = BgL_l1318z00_18034;
									BgL_tail1321z00_18039 = BgL_head1320z00_18035;
								BgL_zc3z04anonymousza33285ze3z87_18037:
									if (NULLP(BgL_l1318z00_18038))
										{	/* Eval/evaluate_comp.scm 490 */
											BgL_cvalsz00_18032 = CDR(BgL_head1320z00_18035);
										}
									else
										{	/* Eval/evaluate_comp.scm 490 */
											obj_t BgL_newtail1322z00_18040;

											{	/* Eval/evaluate_comp.scm 490 */
												obj_t BgL_arg3295z00_18041;

												{	/* Eval/evaluate_comp.scm 490 */
													obj_t BgL_vz00_18042;

													BgL_vz00_18042 = CAR(((obj_t) BgL_l1318z00_18038));
													BgL_arg3295z00_18041 =
														BGl_compz00zz__evaluate_compz00(
														((BgL_ev_exprz00_bglt) BgL_vz00_18042),
														BgL_nstkz00_18030);
												}
												{	/* Eval/evaluate_comp.scm 490 */
													obj_t BgL_res5156z00_18043;

													BgL_res5156z00_18043 =
														MAKE_YOUNG_PAIR(BgL_arg3295z00_18041, BNIL);
													BgL_newtail1322z00_18040 = BgL_res5156z00_18043;
												}
											}
											SET_CDR(BgL_tail1321z00_18039, BgL_newtail1322z00_18040);
											{	/* Eval/evaluate_comp.scm 490 */
												obj_t BgL_arg3291z00_18044;

												BgL_arg3291z00_18044 =
													CDR(((obj_t) BgL_l1318z00_18038));
												{
													obj_t BgL_tail1321z00_33404;
													obj_t BgL_l1318z00_33403;

													BgL_l1318z00_33403 = BgL_arg3291z00_18044;
													BgL_tail1321z00_33404 = BgL_newtail1322z00_18040;
													BgL_tail1321z00_18039 = BgL_tail1321z00_33404;
													BgL_l1318z00_18038 = BgL_l1318z00_33403;
													goto BgL_zc3z04anonymousza33285ze3z87_18037;
												}
											}
										}
								}
							}
					}
					{	/* Eval/evaluate_comp.scm 491 */
						BgL_ev_exprz00_bglt BgL_arg3296z00_18045;

						BgL_arg3296z00_18045 =
							(((BgL_ev_binderz00_bglt) COBJECT(
									((BgL_ev_binderz00_bglt)
										((BgL_ev_letrecz00_bglt) BgL_ez00_15361))))->BgL_bodyz00);
						BgL_bodyz00_18033 =
							BGl_compz00zz__evaluate_compz00(BgL_arg3296z00_18045,
							BgL_nstkz00_18030);
					}
					{	/* Eval/evaluate_comp.scm 492 */
						bool_t BgL_test6778z00_33409;

						{
							obj_t BgL_l1323z00_18047;

							BgL_l1323z00_18047 =
								(((BgL_ev_binderz00_bglt) COBJECT(
										((BgL_ev_binderz00_bglt)
											((BgL_ev_letrecz00_bglt) BgL_ez00_15361))))->BgL_valsz00);
						BgL_zc3z04anonymousza33281ze3z87_18046:
							if (NULLP(BgL_l1323z00_18047))
								{	/* Eval/evaluate_comp.scm 492 */
									BgL_test6778z00_33409 = ((bool_t) 1);
								}
							else
								{	/* Eval/evaluate_comp.scm 492 */
									bool_t BgL_test6780z00_33412;

									{	/* Eval/evaluate_comp.scm 492 */
										obj_t BgL_vz00_18048;

										BgL_vz00_18048 = CAR(((obj_t) BgL_l1323z00_18047));
										BgL_test6780z00_33412 =
											BGl_isazf3zf3zz__objectz00(BgL_vz00_18048,
											BGl_ev_absz00zz__evaluate_typesz00);
									}
									if (BgL_test6780z00_33412)
										{
											obj_t BgL_l1323z00_33416;

											BgL_l1323z00_33416 = CDR(((obj_t) BgL_l1323z00_18047));
											BgL_l1323z00_18047 = BgL_l1323z00_33416;
											goto BgL_zc3z04anonymousza33281ze3z87_18046;
										}
									else
										{	/* Eval/evaluate_comp.scm 492 */
											BgL_test6778z00_33409 = ((bool_t) 0);
										}
								}
						}
						if (BgL_test6778z00_33409)
							{	/* Eval/evaluate_comp.scm 493 */
								obj_t BgL_zc3z04anonymousza33237ze3z87_18049;

								BgL_zc3z04anonymousza33237ze3z87_18049 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza33237ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 3)));
								PROCEDURE_SET(BgL_zc3z04anonymousza33237ze3z87_18049,
									(int) (((long) 0)), BINT(BgL_siza7eza7_18029));
								PROCEDURE_SET(BgL_zc3z04anonymousza33237ze3z87_18049,
									(int) (((long) 1)), BgL_cvalsz00_18032);
								PROCEDURE_SET(BgL_zc3z04anonymousza33237ze3z87_18049,
									(int) (((long) 2)), BgL_bodyz00_18033);
								return BgL_zc3z04anonymousza33237ze3z87_18049;
							}
						else
							{	/* Eval/evaluate_comp.scm 503 */
								obj_t BgL_zc3z04anonymousza33253ze3z87_18050;

								BgL_zc3z04anonymousza33253ze3z87_18050 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza33253ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 3)));
								PROCEDURE_SET(BgL_zc3z04anonymousza33253ze3z87_18050,
									(int) (((long) 0)), BINT(BgL_siza7eza7_18029));
								PROCEDURE_SET(BgL_zc3z04anonymousza33253ze3z87_18050,
									(int) (((long) 1)), BgL_cvalsz00_18032);
								PROCEDURE_SET(BgL_zc3z04anonymousza33253ze3z87_18050,
									(int) (((long) 2)), BgL_bodyz00_18033);
								return BgL_zc3z04anonymousza33253ze3z87_18050;
							}
					}
				}
			}
		}

	}



/* &<@anonymous:3237> */
	obj_t BGl_z62zc3z04anonymousza33237ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15363, obj_t BgL_sz00_15367)
	{
		{	/* Eval/evaluate_comp.scm 493 */
			{	/* Eval/evaluate_comp.scm 493 */
				long BgL_siza7eza7_15364;
				obj_t BgL_cvalsz00_15365;
				obj_t BgL_bodyz00_15366;

				BgL_siza7eza7_15364 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15363, (int) (((long) 0))));
				BgL_cvalsz00_15365 =
					PROCEDURE_REF(BgL_envz00_15363, (int) (((long) 1)));
				BgL_bodyz00_15366 = PROCEDURE_REF(BgL_envz00_15363, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 493 */
					obj_t BgL_bpz00_18051;

					BgL_bpz00_18051 = VECTOR_REF(((obj_t) BgL_sz00_15367), ((long) 0));
					{	/* Eval/evaluate_comp.scm 494 */
						long BgL_g1115z00_18052;

						BgL_g1115z00_18052 =
							((long) CINT(BgL_bpz00_18051) + BgL_siza7eza7_15364);
						{
							obj_t BgL_lz00_18054;
							long BgL_iz00_18055;

							BgL_lz00_18054 = BgL_cvalsz00_15365;
							BgL_iz00_18055 = BgL_g1115z00_18052;
						BgL_recz00_18053:
							if (NULLP(BgL_lz00_18054))
								{	/* Eval/evaluate_comp.scm 495 */
									((bool_t) 0);
								}
							else
								{	/* Eval/evaluate_comp.scm 495 */
									{	/* Eval/evaluate_comp.scm 496 */
										obj_t BgL_arg3240z00_18056;

										{	/* Eval/evaluate_comp.scm 202 */
											obj_t BgL_newz00_18057;

											BgL_newz00_18057 =
												create_struct(BGl_symbol5808z00zz__evaluate_compz00,
												(int) (((long) 1)));
											{	/* Eval/evaluate_comp.scm 202 */
												int BgL_tmpz00_33457;

												BgL_tmpz00_33457 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_18057, BgL_tmpz00_33457, BUNSPEC);
											}
											BgL_arg3240z00_18056 = BgL_newz00_18057;
										}
										VECTOR_SET(
											((obj_t) BgL_sz00_15367), BgL_iz00_18055,
											BgL_arg3240z00_18056);
									}
									{	/* Eval/evaluate_comp.scm 497 */
										obj_t BgL_arg3241z00_18058;
										long BgL_arg3242z00_18059;

										BgL_arg3241z00_18058 = CDR(((obj_t) BgL_lz00_18054));
										BgL_arg3242z00_18059 = (BgL_iz00_18055 + ((long) 1));
										{
											long BgL_iz00_33466;
											obj_t BgL_lz00_33465;

											BgL_lz00_33465 = BgL_arg3241z00_18058;
											BgL_iz00_33466 = BgL_arg3242z00_18059;
											BgL_iz00_18055 = BgL_iz00_33466;
											BgL_lz00_18054 = BgL_lz00_33465;
											goto BgL_recz00_18053;
										}
									}
								}
						}
					}
					{	/* Eval/evaluate_comp.scm 498 */
						long BgL_g1116z00_18060;

						BgL_g1116z00_18060 =
							((long) CINT(BgL_bpz00_18051) + BgL_siza7eza7_15364);
						{
							obj_t BgL_lz00_18062;
							long BgL_iz00_18063;

							BgL_lz00_18062 = BgL_cvalsz00_15365;
							BgL_iz00_18063 = BgL_g1116z00_18060;
						BgL_recz00_18061:
							if (NULLP(BgL_lz00_18062))
								{	/* Eval/evaluate_comp.scm 499 */
									((bool_t) 0);
								}
							else
								{	/* Eval/evaluate_comp.scm 499 */
									{	/* Eval/evaluate_comp.scm 500 */
										obj_t BgL_arg3246z00_18064;
										obj_t BgL_arg3247z00_18065;

										BgL_arg3246z00_18064 =
											VECTOR_REF(((obj_t) BgL_sz00_15367), BgL_iz00_18063);
										{	/* Eval/evaluate_comp.scm 500 */
											obj_t BgL_fun3248z00_18066;

											BgL_fun3248z00_18066 = CAR(((obj_t) BgL_lz00_18062));
											BgL_arg3247z00_18065 =
												PROCEDURE_ENTRY(BgL_fun3248z00_18066)
												(BgL_fun3248z00_18066, BgL_sz00_15367, BEOA);
										}
										{	/* Eval/evaluate_comp.scm 202 */
											int BgL_auxz00_33481;
											obj_t BgL_tmpz00_33479;

											BgL_auxz00_33481 = (int) (((long) 0));
											BgL_tmpz00_33479 = ((obj_t) BgL_arg3246z00_18064);
											STRUCT_SET(BgL_tmpz00_33479, BgL_auxz00_33481,
												BgL_arg3247z00_18065);
									}}
									{	/* Eval/evaluate_comp.scm 501 */
										obj_t BgL_arg3250z00_18067;
										long BgL_arg3252z00_18068;

										BgL_arg3250z00_18067 = CDR(((obj_t) BgL_lz00_18062));
										BgL_arg3252z00_18068 = (BgL_iz00_18063 + ((long) 1));
										{
											long BgL_iz00_33488;
											obj_t BgL_lz00_33487;

											BgL_lz00_33487 = BgL_arg3250z00_18067;
											BgL_iz00_33488 = BgL_arg3252z00_18068;
											BgL_iz00_18063 = BgL_iz00_33488;
											BgL_lz00_18062 = BgL_lz00_33487;
											goto BgL_recz00_18061;
										}
									}
								}
						}
					}
					return
						PROCEDURE_ENTRY(BgL_bodyz00_15366) (BgL_bodyz00_15366,
						BgL_sz00_15367, BEOA);
				}
			}
		}

	}



/* &<@anonymous:3253> */
	obj_t BGl_z62zc3z04anonymousza33253ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15368, obj_t BgL_sz00_15372)
	{
		{	/* Eval/evaluate_comp.scm 503 */
			{	/* Eval/evaluate_comp.scm 503 */
				long BgL_siza7eza7_15369;
				obj_t BgL_cvalsz00_15370;
				obj_t BgL_bodyz00_15371;

				BgL_siza7eza7_15369 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15368, (int) (((long) 0))));
				BgL_cvalsz00_15370 =
					PROCEDURE_REF(BgL_envz00_15368, (int) (((long) 1)));
				BgL_bodyz00_15371 = PROCEDURE_REF(BgL_envz00_15368, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 503 */
					obj_t BgL_bpz00_18069;

					BgL_bpz00_18069 = VECTOR_REF(((obj_t) BgL_sz00_15372), ((long) 0));
					{	/* Eval/evaluate_comp.scm 504 */
						long BgL_g1117z00_18070;

						BgL_g1117z00_18070 =
							((long) CINT(BgL_bpz00_18069) + BgL_siza7eza7_15369);
						{
							obj_t BgL_lz00_18072;
							long BgL_iz00_18073;

							BgL_lz00_18072 = BgL_cvalsz00_15370;
							BgL_iz00_18073 = BgL_g1117z00_18070;
						BgL_recz00_18071:
							if (NULLP(BgL_lz00_18072))
								{	/* Eval/evaluate_comp.scm 505 */
									((bool_t) 0);
								}
							else
								{	/* Eval/evaluate_comp.scm 505 */
									{	/* Eval/evaluate_comp.scm 506 */
										obj_t BgL_arg3256z00_18074;

										{	/* Eval/evaluate_comp.scm 202 */
											obj_t BgL_newz00_18075;

											BgL_newz00_18075 =
												create_struct(BGl_symbol5808z00zz__evaluate_compz00,
												(int) (((long) 1)));
											{	/* Eval/evaluate_comp.scm 202 */
												int BgL_tmpz00_33508;

												BgL_tmpz00_33508 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_18075, BgL_tmpz00_33508, BUNSPEC);
											}
											BgL_arg3256z00_18074 = BgL_newz00_18075;
										}
										VECTOR_SET(
											((obj_t) BgL_sz00_15372), BgL_iz00_18073,
											BgL_arg3256z00_18074);
									}
									{	/* Eval/evaluate_comp.scm 507 */
										obj_t BgL_arg3257z00_18076;
										long BgL_arg3258z00_18077;

										BgL_arg3257z00_18076 = CDR(((obj_t) BgL_lz00_18072));
										BgL_arg3258z00_18077 = (BgL_iz00_18073 + ((long) 1));
										{
											long BgL_iz00_33517;
											obj_t BgL_lz00_33516;

											BgL_lz00_33516 = BgL_arg3257z00_18076;
											BgL_iz00_33517 = BgL_arg3258z00_18077;
											BgL_iz00_18073 = BgL_iz00_33517;
											BgL_lz00_18072 = BgL_lz00_33516;
											goto BgL_recz00_18071;
										}
									}
								}
						}
					}
					{	/* Eval/evaluate_comp.scm 508 */
						obj_t BgL_rvalsz00_18078;

						if (NULLP(BgL_cvalsz00_15370))
							{	/* Eval/evaluate_comp.scm 508 */
								BgL_rvalsz00_18078 = BNIL;
							}
						else
							{	/* Eval/evaluate_comp.scm 508 */
								obj_t BgL_head1329z00_18079;

								{	/* Eval/evaluate_comp.scm 508 */
									obj_t BgL_res5176z00_18080;

									BgL_res5176z00_18080 = MAKE_YOUNG_PAIR(BNIL, BNIL);
									BgL_head1329z00_18079 = BgL_res5176z00_18080;
								}
								{
									obj_t BgL_l1327z00_18082;
									obj_t BgL_tail1330z00_18083;

									BgL_l1327z00_18082 = BgL_cvalsz00_15370;
									BgL_tail1330z00_18083 = BgL_head1329z00_18079;
								BgL_zc3z04anonymousza33275ze3z87_18081:
									if (NULLP(BgL_l1327z00_18082))
										{	/* Eval/evaluate_comp.scm 508 */
											BgL_rvalsz00_18078 = CDR(BgL_head1329z00_18079);
										}
									else
										{	/* Eval/evaluate_comp.scm 508 */
											obj_t BgL_newtail1331z00_18084;

											{	/* Eval/evaluate_comp.scm 508 */
												obj_t BgL_arg3280z00_18085;

												{	/* Eval/evaluate_comp.scm 508 */
													obj_t BgL_vz00_18086;

													BgL_vz00_18086 = CAR(((obj_t) BgL_l1327z00_18082));
													BgL_arg3280z00_18085 =
														PROCEDURE_ENTRY(BgL_vz00_18086) (BgL_vz00_18086,
														BgL_sz00_15372, BEOA);
												}
												{	/* Eval/evaluate_comp.scm 508 */
													obj_t BgL_res5182z00_18087;

													BgL_res5182z00_18087 =
														MAKE_YOUNG_PAIR(BgL_arg3280z00_18085, BNIL);
													BgL_newtail1331z00_18084 = BgL_res5182z00_18087;
												}
											}
											SET_CDR(BgL_tail1330z00_18083, BgL_newtail1331z00_18084);
											{	/* Eval/evaluate_comp.scm 508 */
												obj_t BgL_arg3279z00_18088;

												BgL_arg3279z00_18088 =
													CDR(((obj_t) BgL_l1327z00_18082));
												{
													obj_t BgL_tail1330z00_33535;
													obj_t BgL_l1327z00_33534;

													BgL_l1327z00_33534 = BgL_arg3279z00_18088;
													BgL_tail1330z00_33535 = BgL_newtail1331z00_18084;
													BgL_tail1330z00_18083 = BgL_tail1330z00_33535;
													BgL_l1327z00_18082 = BgL_l1327z00_33534;
													goto BgL_zc3z04anonymousza33275ze3z87_18081;
												}
											}
										}
								}
							}
						{	/* Eval/evaluate_comp.scm 509 */
							long BgL_g1118z00_18089;

							BgL_g1118z00_18089 =
								((long) CINT(BgL_bpz00_18069) + BgL_siza7eza7_15369);
							{
								obj_t BgL_lz00_18091;
								long BgL_iz00_18092;

								BgL_lz00_18091 = BgL_rvalsz00_18078;
								BgL_iz00_18092 = BgL_g1118z00_18089;
							BgL_recz00_18090:
								if (NULLP(BgL_lz00_18091))
									{	/* Eval/evaluate_comp.scm 510 */
										((bool_t) 0);
									}
								else
									{	/* Eval/evaluate_comp.scm 510 */
										{	/* Eval/evaluate_comp.scm 511 */
											obj_t BgL_arg3263z00_18093;
											obj_t BgL_arg3264z00_18094;

											BgL_arg3263z00_18093 =
												VECTOR_REF(((obj_t) BgL_sz00_15372), BgL_iz00_18092);
											BgL_arg3264z00_18094 = CAR(((obj_t) BgL_lz00_18091));
											{	/* Eval/evaluate_comp.scm 202 */
												int BgL_auxz00_33546;
												obj_t BgL_tmpz00_33544;

												BgL_auxz00_33546 = (int) (((long) 0));
												BgL_tmpz00_33544 = ((obj_t) BgL_arg3263z00_18093);
												STRUCT_SET(BgL_tmpz00_33544, BgL_auxz00_33546,
													BgL_arg3264z00_18094);
										}}
										{	/* Eval/evaluate_comp.scm 512 */
											obj_t BgL_arg3272z00_18095;
											long BgL_arg3273z00_18096;

											BgL_arg3272z00_18095 = CDR(((obj_t) BgL_lz00_18091));
											BgL_arg3273z00_18096 = (BgL_iz00_18092 + ((long) 1));
											{
												long BgL_iz00_33553;
												obj_t BgL_lz00_33552;

												BgL_lz00_33552 = BgL_arg3272z00_18095;
												BgL_iz00_33553 = BgL_arg3273z00_18096;
												BgL_iz00_18092 = BgL_iz00_33553;
												BgL_lz00_18091 = BgL_lz00_33552;
												goto BgL_recz00_18090;
											}
										}
									}
							}
						}
						return
							PROCEDURE_ENTRY(BgL_bodyz00_15371) (BgL_bodyz00_15371,
							BgL_sz00_15372, BEOA);
					}
				}
			}
		}

	}



/* &comp-ev_let*1420 */
	obj_t BGl_z62compzd2ev_letza21420z12zz__evaluate_compz00(obj_t
		BgL_envz00_15373, obj_t BgL_ez00_15374, obj_t BgL_stkz00_15375)
	{
		{	/* Eval/evaluate_comp.scm 474 */
			{	/* Eval/evaluate_comp.scm 476 */
				long BgL_siza7eza7_18098;
				obj_t BgL_nstkz00_18099;

				BgL_siza7eza7_18098 = bgl_list_length(BgL_stkz00_15375);
				{	/* Eval/evaluate_comp.scm 476 */
					obj_t BgL_arg3232z00_18100;

					BgL_arg3232z00_18100 =
						(((BgL_ev_binderz00_bglt) COBJECT(
								((BgL_ev_binderz00_bglt)
									((BgL_ev_letza2za2_bglt) BgL_ez00_15374))))->BgL_varsz00);
					BgL_nstkz00_18099 =
						BGl_appendzd221011zd2zz__evaluate_compz00(BgL_stkz00_15375,
						BgL_arg3232z00_18100);
				}
				{	/* Eval/evaluate_comp.scm 477 */
					obj_t BgL_valsz00_18101;
					obj_t BgL_bodyz00_18102;

					{	/* Eval/evaluate_comp.scm 477 */
						obj_t BgL_l1313z00_18103;

						BgL_l1313z00_18103 =
							(((BgL_ev_binderz00_bglt) COBJECT(
									((BgL_ev_binderz00_bglt)
										((BgL_ev_letza2za2_bglt) BgL_ez00_15374))))->BgL_valsz00);
						if (NULLP(BgL_l1313z00_18103))
							{	/* Eval/evaluate_comp.scm 477 */
								BgL_valsz00_18101 = BNIL;
							}
						else
							{	/* Eval/evaluate_comp.scm 477 */
								obj_t BgL_head1315z00_18104;

								{	/* Eval/evaluate_comp.scm 477 */
									obj_t BgL_res5139z00_18105;

									BgL_res5139z00_18105 = MAKE_YOUNG_PAIR(BNIL, BNIL);
									BgL_head1315z00_18104 = BgL_res5139z00_18105;
								}
								{
									obj_t BgL_l1313z00_18107;
									obj_t BgL_tail1316z00_18108;

									BgL_l1313z00_18107 = BgL_l1313z00_18103;
									BgL_tail1316z00_18108 = BgL_head1315z00_18104;
								BgL_zc3z04anonymousza33222ze3z87_18106:
									if (NULLP(BgL_l1313z00_18107))
										{	/* Eval/evaluate_comp.scm 477 */
											BgL_valsz00_18101 = CDR(BgL_head1315z00_18104);
										}
									else
										{	/* Eval/evaluate_comp.scm 477 */
											obj_t BgL_newtail1317z00_18109;

											{	/* Eval/evaluate_comp.scm 477 */
												obj_t BgL_arg3230z00_18110;

												{	/* Eval/evaluate_comp.scm 477 */
													obj_t BgL_vz00_18111;

													BgL_vz00_18111 = CAR(((obj_t) BgL_l1313z00_18107));
													BgL_arg3230z00_18110 =
														BGl_compz00zz__evaluate_compz00(
														((BgL_ev_exprz00_bglt) BgL_vz00_18111),
														BgL_nstkz00_18099);
												}
												{	/* Eval/evaluate_comp.scm 477 */
													obj_t BgL_res5145z00_18112;

													BgL_res5145z00_18112 =
														MAKE_YOUNG_PAIR(BgL_arg3230z00_18110, BNIL);
													BgL_newtail1317z00_18109 = BgL_res5145z00_18112;
												}
											}
											SET_CDR(BgL_tail1316z00_18108, BgL_newtail1317z00_18109);
											{	/* Eval/evaluate_comp.scm 477 */
												obj_t BgL_arg3228z00_18113;

												BgL_arg3228z00_18113 =
													CDR(((obj_t) BgL_l1313z00_18107));
												{
													obj_t BgL_tail1316z00_33581;
													obj_t BgL_l1313z00_33580;

													BgL_l1313z00_33580 = BgL_arg3228z00_18113;
													BgL_tail1316z00_33581 = BgL_newtail1317z00_18109;
													BgL_tail1316z00_18108 = BgL_tail1316z00_33581;
													BgL_l1313z00_18107 = BgL_l1313z00_33580;
													goto BgL_zc3z04anonymousza33222ze3z87_18106;
												}
											}
										}
								}
							}
					}
					{	/* Eval/evaluate_comp.scm 478 */
						BgL_ev_exprz00_bglt BgL_arg3231z00_18114;

						BgL_arg3231z00_18114 =
							(((BgL_ev_binderz00_bglt) COBJECT(
									((BgL_ev_binderz00_bglt)
										((BgL_ev_letza2za2_bglt) BgL_ez00_15374))))->BgL_bodyz00);
						BgL_bodyz00_18102 =
							BGl_compz00zz__evaluate_compz00(BgL_arg3231z00_18114,
							BgL_nstkz00_18099);
					}
					{	/* Eval/evaluate_comp.scm 479 */
						obj_t BgL_zc3z04anonymousza33208ze3z87_18115;

						BgL_zc3z04anonymousza33208ze3z87_18115 =
							MAKE_FX_PROCEDURE
							(BGl_z62zc3z04anonymousza33208ze3ze5zz__evaluate_compz00,
							(int) (((long) 1)), (int) (((long) 4)));
						PROCEDURE_SET(BgL_zc3z04anonymousza33208ze3z87_18115,
							(int) (((long) 0)), BINT(BgL_siza7eza7_18098));
						PROCEDURE_SET(BgL_zc3z04anonymousza33208ze3z87_18115,
							(int) (((long) 1)),
							((obj_t) ((BgL_ev_letza2za2_bglt) BgL_ez00_15374)));
						PROCEDURE_SET(BgL_zc3z04anonymousza33208ze3z87_18115,
							(int) (((long) 2)), BgL_valsz00_18101);
						PROCEDURE_SET(BgL_zc3z04anonymousza33208ze3z87_18115,
							(int) (((long) 3)), BgL_bodyz00_18102);
						return BgL_zc3z04anonymousza33208ze3z87_18115;
					}
				}
			}
		}

	}



/* &<@anonymous:3208> */
	obj_t BGl_z62zc3z04anonymousza33208ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15376, obj_t BgL_sz00_15381)
	{
		{	/* Eval/evaluate_comp.scm 479 */
			{	/* Eval/evaluate_comp.scm 479 */
				long BgL_siza7eza7_15377;
				BgL_ev_letza2za2_bglt BgL_i1112z00_15378;
				obj_t BgL_valsz00_15379;
				obj_t BgL_bodyz00_15380;

				BgL_siza7eza7_15377 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15376, (int) (((long) 0))));
				BgL_i1112z00_15378 =
					((BgL_ev_letza2za2_bglt)
					PROCEDURE_REF(BgL_envz00_15376, (int) (((long) 1))));
				BgL_valsz00_15379 = PROCEDURE_REF(BgL_envz00_15376, (int) (((long) 2)));
				BgL_bodyz00_15380 = PROCEDURE_REF(BgL_envz00_15376, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 479 */
					obj_t BgL_bpz00_18116;

					BgL_bpz00_18116 = VECTOR_REF(((obj_t) BgL_sz00_15381), ((long) 0));
					{	/* Eval/evaluate_comp.scm 480 */
						long BgL_g1113z00_18117;

						BgL_g1113z00_18117 =
							((long) CINT(BgL_bpz00_18116) + BgL_siza7eza7_15377);
						{
							obj_t BgL_lz00_18119;
							long BgL_iz00_18120;
							obj_t BgL_bza2za2_18121;

							BgL_lz00_18119 = BgL_valsz00_15379;
							BgL_iz00_18120 = BgL_g1113z00_18117;
							BgL_bza2za2_18121 =
								(((BgL_ev_letza2za2_bglt) COBJECT(BgL_i1112z00_15378))->
								BgL_boxesz00);
						BgL_recz00_18118:
							if (NULLP(BgL_lz00_18119))
								{	/* Eval/evaluate_comp.scm 481 */
									((bool_t) 0);
								}
							else
								{	/* Eval/evaluate_comp.scm 481 */
									{	/* Eval/evaluate_comp.scm 482 */
										obj_t BgL_valz00_18122;

										{	/* Eval/evaluate_comp.scm 482 */
											obj_t BgL_fun3214z00_18123;

											BgL_fun3214z00_18123 = CAR(((obj_t) BgL_lz00_18119));
											BgL_valz00_18122 =
												PROCEDURE_ENTRY(BgL_fun3214z00_18123)
												(BgL_fun3214z00_18123, BgL_sz00_15381, BEOA);
										}
										{	/* Eval/evaluate_comp.scm 483 */
											obj_t BgL_arg3212z00_18124;

											if (CBOOL(CAR(((obj_t) BgL_bza2za2_18121))))
												{	/* Eval/evaluate_comp.scm 202 */
													obj_t BgL_newz00_18125;

													BgL_newz00_18125 =
														create_struct(BGl_symbol5808z00zz__evaluate_compz00,
														(int) (((long) 1)));
													{	/* Eval/evaluate_comp.scm 202 */
														int BgL_tmpz00_33628;

														BgL_tmpz00_33628 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_18125, BgL_tmpz00_33628,
															BgL_valz00_18122);
													}
													BgL_arg3212z00_18124 = BgL_newz00_18125;
												}
											else
												{	/* Eval/evaluate_comp.scm 483 */
													BgL_arg3212z00_18124 = BgL_valz00_18122;
												}
											VECTOR_SET(
												((obj_t) BgL_sz00_15381), BgL_iz00_18120,
												BgL_arg3212z00_18124);
										}
									}
									{	/* Eval/evaluate_comp.scm 484 */
										obj_t BgL_arg3217z00_18126;
										long BgL_arg3218z00_18127;
										obj_t BgL_arg3220z00_18128;

										BgL_arg3217z00_18126 = CDR(((obj_t) BgL_lz00_18119));
										BgL_arg3218z00_18127 = (BgL_iz00_18120 + ((long) 1));
										BgL_arg3220z00_18128 = CDR(((obj_t) BgL_bza2za2_18121));
										{
											obj_t BgL_bza2za2_33640;
											long BgL_iz00_33639;
											obj_t BgL_lz00_33638;

											BgL_lz00_33638 = BgL_arg3217z00_18126;
											BgL_iz00_33639 = BgL_arg3218z00_18127;
											BgL_bza2za2_33640 = BgL_arg3220z00_18128;
											BgL_bza2za2_18121 = BgL_bza2za2_33640;
											BgL_iz00_18120 = BgL_iz00_33639;
											BgL_lz00_18119 = BgL_lz00_33638;
											goto BgL_recz00_18118;
										}
									}
								}
						}
					}
					return
						PROCEDURE_ENTRY(BgL_bodyz00_15380) (BgL_bodyz00_15380,
						BgL_sz00_15381, BEOA);
				}
			}
		}

	}



/* &comp-ev_let1418 */
	obj_t BGl_z62compzd2ev_let1418zb0zz__evaluate_compz00(obj_t BgL_envz00_15382,
		obj_t BgL_ez00_15383, obj_t BgL_stkz00_15384)
	{
		{	/* Eval/evaluate_comp.scm 455 */
			{	/* Eval/evaluate_comp.scm 457 */
				long BgL_siza7eza7_18130;
				obj_t BgL_nstkz00_18131;

				BgL_siza7eza7_18130 = bgl_list_length(BgL_stkz00_15384);
				{	/* Eval/evaluate_comp.scm 457 */
					obj_t BgL_arg3207z00_18132;

					BgL_arg3207z00_18132 =
						(((BgL_ev_binderz00_bglt) COBJECT(
								((BgL_ev_binderz00_bglt)
									((BgL_ev_letz00_bglt) BgL_ez00_15383))))->BgL_varsz00);
					BgL_nstkz00_18131 =
						BGl_appendzd221011zd2zz__evaluate_compz00(BgL_stkz00_15384,
						BgL_arg3207z00_18132);
				}
				{	/* Eval/evaluate_comp.scm 458 */
					obj_t BgL_valsz00_18133;
					obj_t BgL_iboxesz00_18134;
					obj_t BgL_bodyz00_18135;

					{	/* Eval/evaluate_comp.scm 459 */
						obj_t BgL_arg3198z00_18136;

						BgL_arg3198z00_18136 =
							(((BgL_ev_binderz00_bglt) COBJECT(
									((BgL_ev_binderz00_bglt)
										((BgL_ev_letz00_bglt) BgL_ez00_15383))))->BgL_valsz00);
						BgL_valsz00_18133 =
							BGl_compzd2withzd2pushz00zz__evaluate_compz00
							(BgL_arg3198z00_18136, BgL_stkz00_15384);
					}
					{	/* Eval/evaluate_comp.scm 460 */
						obj_t BgL_l1308z00_18137;

						BgL_l1308z00_18137 =
							(((BgL_ev_letz00_bglt) COBJECT(
									((BgL_ev_letz00_bglt) BgL_ez00_15383)))->BgL_boxesz00);
						if (NULLP(BgL_l1308z00_18137))
							{	/* Eval/evaluate_comp.scm 460 */
								BgL_iboxesz00_18134 = BNIL;
							}
						else
							{	/* Eval/evaluate_comp.scm 460 */
								obj_t BgL_head1310z00_18138;

								{	/* Eval/evaluate_comp.scm 460 */
									obj_t BgL_res5122z00_18139;

									BgL_res5122z00_18139 = MAKE_YOUNG_PAIR(BNIL, BNIL);
									BgL_head1310z00_18138 = BgL_res5122z00_18139;
								}
								{
									obj_t BgL_l1308z00_18141;
									obj_t BgL_tail1311z00_18142;

									BgL_l1308z00_18141 = BgL_l1308z00_18137;
									BgL_tail1311z00_18142 = BgL_head1310z00_18138;
								BgL_zc3z04anonymousza33200ze3z87_18140:
									if (NULLP(BgL_l1308z00_18141))
										{	/* Eval/evaluate_comp.scm 460 */
											BgL_iboxesz00_18134 = CDR(BgL_head1310z00_18138);
										}
									else
										{	/* Eval/evaluate_comp.scm 460 */
											obj_t BgL_newtail1312z00_18143;

											{	/* Eval/evaluate_comp.scm 460 */
												obj_t BgL_arg3204z00_18144;

												{	/* Eval/evaluate_comp.scm 460 */
													obj_t BgL_vz00_18145;

													BgL_vz00_18145 = CAR(((obj_t) BgL_l1308z00_18141));
													BgL_arg3204z00_18144 =
														BGl__indexz00zz__evaluate_compz00(BgL_vz00_18145,
														BgL_nstkz00_18131);
												}
												{	/* Eval/evaluate_comp.scm 460 */
													obj_t BgL_res5128z00_18146;

													BgL_res5128z00_18146 =
														MAKE_YOUNG_PAIR(BgL_arg3204z00_18144, BNIL);
													BgL_newtail1312z00_18143 = BgL_res5128z00_18146;
												}
											}
											SET_CDR(BgL_tail1311z00_18142, BgL_newtail1312z00_18143);
											{	/* Eval/evaluate_comp.scm 460 */
												obj_t BgL_arg3203z00_18147;

												BgL_arg3203z00_18147 =
													CDR(((obj_t) BgL_l1308z00_18141));
												{
													obj_t BgL_tail1311z00_33671;
													obj_t BgL_l1308z00_33670;

													BgL_l1308z00_33670 = BgL_arg3203z00_18147;
													BgL_tail1311z00_33671 = BgL_newtail1312z00_18143;
													BgL_tail1311z00_18142 = BgL_tail1311z00_33671;
													BgL_l1308z00_18141 = BgL_l1308z00_33670;
													goto BgL_zc3z04anonymousza33200ze3z87_18140;
												}
											}
										}
								}
							}
					}
					{	/* Eval/evaluate_comp.scm 461 */
						BgL_ev_exprz00_bglt BgL_arg3206z00_18148;

						BgL_arg3206z00_18148 =
							(((BgL_ev_binderz00_bglt) COBJECT(
									((BgL_ev_binderz00_bglt)
										((BgL_ev_letz00_bglt) BgL_ez00_15383))))->BgL_bodyz00);
						BgL_bodyz00_18135 =
							BGl_compz00zz__evaluate_compz00(BgL_arg3206z00_18148,
							BgL_nstkz00_18131);
					}
					{	/* Eval/evaluate_comp.scm 462 */
						obj_t BgL_zc3z04anonymousza33175ze3z87_18149;

						BgL_zc3z04anonymousza33175ze3z87_18149 =
							MAKE_FX_PROCEDURE
							(BGl_z62zc3z04anonymousza33175ze3ze5zz__evaluate_compz00,
							(int) (((long) 1)), (int) (((long) 4)));
						PROCEDURE_SET(BgL_zc3z04anonymousza33175ze3z87_18149,
							(int) (((long) 0)), BINT(BgL_siza7eza7_18130));
						PROCEDURE_SET(BgL_zc3z04anonymousza33175ze3z87_18149,
							(int) (((long) 1)), BgL_valsz00_18133);
						PROCEDURE_SET(BgL_zc3z04anonymousza33175ze3z87_18149,
							(int) (((long) 2)), BgL_iboxesz00_18134);
						PROCEDURE_SET(BgL_zc3z04anonymousza33175ze3z87_18149,
							(int) (((long) 3)), BgL_bodyz00_18135);
						return BgL_zc3z04anonymousza33175ze3z87_18149;
					}
				}
			}
		}

	}



/* &<@anonymous:3175> */
	obj_t BGl_z62zc3z04anonymousza33175ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15385, obj_t BgL_sz00_15390)
	{
		{	/* Eval/evaluate_comp.scm 462 */
			{	/* Eval/evaluate_comp.scm 462 */
				long BgL_siza7eza7_15386;
				obj_t BgL_valsz00_15387;
				obj_t BgL_iboxesz00_15388;
				obj_t BgL_bodyz00_15389;

				BgL_siza7eza7_15386 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15385, (int) (((long) 0))));
				BgL_valsz00_15387 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15385, (int) (((long) 1))));
				BgL_iboxesz00_15388 =
					PROCEDURE_REF(BgL_envz00_15385, (int) (((long) 2)));
				BgL_bodyz00_15389 = PROCEDURE_REF(BgL_envz00_15385, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 462 */
					obj_t BgL_bpz00_18150;

					BgL_bpz00_18150 = VECTOR_REF(((obj_t) BgL_sz00_15390), ((long) 0));
					{	/* Eval/evaluate_comp.scm 463 */
						long BgL_g1111z00_18151;

						BgL_g1111z00_18151 =
							((long) CINT(BgL_bpz00_18150) + BgL_siza7eza7_15386);
						{
							obj_t BgL_lz00_18153;
							long BgL_iz00_18154;

							BgL_lz00_18153 = BgL_valsz00_15387;
							BgL_iz00_18154 = BgL_g1111z00_18151;
						BgL_recz00_18152:
							if (NULLP(BgL_lz00_18153))
								{	/* Eval/evaluate_comp.scm 464 */
									((bool_t) 0);
								}
							else
								{	/* Eval/evaluate_comp.scm 464 */
									{	/* Eval/evaluate_comp.scm 465 */
										obj_t BgL_arg3178z00_18155;

										{	/* Eval/evaluate_comp.scm 465 */
											obj_t BgL_fun3179z00_18156;

											BgL_fun3179z00_18156 = CAR(((obj_t) BgL_lz00_18153));
											BgL_arg3178z00_18155 =
												PROCEDURE_ENTRY(BgL_fun3179z00_18156)
												(BgL_fun3179z00_18156, BgL_sz00_15390, BEOA);
										}
										VECTOR_SET(
											((obj_t) BgL_sz00_15390), BgL_iz00_18154,
											BgL_arg3178z00_18155);
									}
									{	/* Eval/evaluate_comp.scm 466 */
										obj_t BgL_arg3181z00_18157;
										long BgL_arg3182z00_18158;

										BgL_arg3181z00_18157 = CDR(((obj_t) BgL_lz00_18153));
										BgL_arg3182z00_18158 = (BgL_iz00_18154 + ((long) 1));
										{
											long BgL_iz00_33716;
											obj_t BgL_lz00_33715;

											BgL_lz00_33715 = BgL_arg3181z00_18157;
											BgL_iz00_33716 = BgL_arg3182z00_18158;
											BgL_iz00_18154 = BgL_iz00_33716;
											BgL_lz00_18153 = BgL_lz00_33715;
											goto BgL_recz00_18152;
										}
									}
								}
						}
					}
					{
						obj_t BgL_lz00_18160;

						BgL_lz00_18160 = BgL_iboxesz00_15388;
					BgL_recz00_18159:
						if (NULLP(BgL_lz00_18160))
							{	/* Eval/evaluate_comp.scm 468 */
								((bool_t) 0);
							}
						else
							{	/* Eval/evaluate_comp.scm 468 */
								{	/* Eval/evaluate_comp.scm 469 */
									long BgL_iz00_18161;

									BgL_iz00_18161 =
										(
										(long) CINT(BgL_bpz00_18150) +
										(long) CINT(CAR(((obj_t) BgL_lz00_18160))));
									{	/* Eval/evaluate_comp.scm 470 */
										obj_t BgL_arg3185z00_18162;

										{	/* Eval/evaluate_comp.scm 470 */
											obj_t BgL_arg3193z00_18163;

											BgL_arg3193z00_18163 =
												VECTOR_REF(((obj_t) BgL_sz00_15390), BgL_iz00_18161);
											{	/* Eval/evaluate_comp.scm 202 */
												obj_t BgL_newz00_18164;

												BgL_newz00_18164 =
													create_struct(BGl_symbol5808z00zz__evaluate_compz00,
													(int) (((long) 1)));
												{	/* Eval/evaluate_comp.scm 202 */
													int BgL_tmpz00_33728;

													BgL_tmpz00_33728 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_18164, BgL_tmpz00_33728,
														BgL_arg3193z00_18163);
												}
												BgL_arg3185z00_18162 = BgL_newz00_18164;
										}}
										VECTOR_SET(
											((obj_t) BgL_sz00_15390), BgL_iz00_18161,
											BgL_arg3185z00_18162);
								}}
								{	/* Eval/evaluate_comp.scm 471 */
									obj_t BgL_arg3197z00_18165;

									BgL_arg3197z00_18165 = CDR(((obj_t) BgL_lz00_18160));
									{
										obj_t BgL_lz00_33735;

										BgL_lz00_33735 = BgL_arg3197z00_18165;
										BgL_lz00_18160 = BgL_lz00_33735;
										goto BgL_recz00_18159;
									}
								}
							}
					}
					return
						PROCEDURE_ENTRY(BgL_bodyz00_15389) (BgL_bodyz00_15389,
						BgL_sz00_15390, BEOA);
				}
			}
		}

	}



/* &comp-ev_prog21416 */
	obj_t BGl_z62compzd2ev_prog21416zb0zz__evaluate_compz00(obj_t
		BgL_envz00_15391, obj_t BgL_ez00_15392, obj_t BgL_stkz00_15393)
	{
		{	/* Eval/evaluate_comp.scm 449 */
			{	/* Eval/evaluate_comp.scm 451 */
				obj_t BgL_e1z00_18167;
				obj_t BgL_e2z00_18168;

				BgL_e1z00_18167 =
					BGl_compz00zz__evaluate_compz00(
					(((BgL_ev_prog2z00_bglt) COBJECT(
								((BgL_ev_prog2z00_bglt) BgL_ez00_15392)))->BgL_e1z00),
					BgL_stkz00_15393);
				BgL_e2z00_18168 =
					BGl_compz00zz__evaluate_compz00((((BgL_ev_prog2z00_bglt)
							COBJECT(((BgL_ev_prog2z00_bglt) BgL_ez00_15392)))->BgL_e2z00),
					BgL_stkz00_15393);
				{	/* Eval/evaluate_comp.scm 452 */
					obj_t BgL_zc3z04anonymousza33171ze3z87_18169;

					BgL_zc3z04anonymousza33171ze3z87_18169 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3z04anonymousza33171ze3ze5zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 2)));
					PROCEDURE_SET(BgL_zc3z04anonymousza33171ze3z87_18169,
						(int) (((long) 0)), BgL_e1z00_18167);
					PROCEDURE_SET(BgL_zc3z04anonymousza33171ze3z87_18169,
						(int) (((long) 1)), BgL_e2z00_18168);
					return BgL_zc3z04anonymousza33171ze3z87_18169;
				}
			}
		}

	}



/* &<@anonymous:3171> */
	obj_t BGl_z62zc3z04anonymousza33171ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15394, obj_t BgL_sz00_15397)
	{
		{	/* Eval/evaluate_comp.scm 452 */
			{	/* Eval/evaluate_comp.scm 452 */
				obj_t BgL_e1z00_15395;
				obj_t BgL_e2z00_15396;

				BgL_e1z00_15395 = PROCEDURE_REF(BgL_envz00_15394, (int) (((long) 0)));
				BgL_e2z00_15396 = PROCEDURE_REF(BgL_envz00_15394, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 452 */
					obj_t BgL_bpz00_18170;

					BgL_bpz00_18170 = VECTOR_REF(((obj_t) BgL_sz00_15397), ((long) 0));
					PROCEDURE_ENTRY(BgL_e1z00_15395) (BgL_e1z00_15395, BgL_sz00_15397,
						BEOA);
					return PROCEDURE_ENTRY(BgL_e2z00_15396) (BgL_e2z00_15396,
						BgL_sz00_15397, BEOA);
				}
			}
		}

	}



/* &comp-ev_and1414 */
	obj_t BGl_z62compzd2ev_and1414zb0zz__evaluate_compz00(obj_t BgL_envz00_15398,
		obj_t BgL_ez00_15399, obj_t BgL_stkz00_15400)
	{
		{	/* Eval/evaluate_comp.scm 439 */
			{	/* Eval/evaluate_comp.scm 441 */
				obj_t BgL_argsz00_18172;

				{	/* Eval/evaluate_comp.scm 441 */
					obj_t BgL_l1303z00_18173;

					BgL_l1303z00_18173 =
						(((BgL_ev_listz00_bglt) COBJECT(
								((BgL_ev_listz00_bglt)
									((BgL_ev_andz00_bglt) BgL_ez00_15399))))->BgL_argsz00);
					if (NULLP(BgL_l1303z00_18173))
						{	/* Eval/evaluate_comp.scm 441 */
							BgL_argsz00_18172 = BNIL;
						}
					else
						{	/* Eval/evaluate_comp.scm 441 */
							obj_t BgL_head1305z00_18174;

							{	/* Eval/evaluate_comp.scm 441 */
								obj_t BgL_res5111z00_18175;

								BgL_res5111z00_18175 = MAKE_YOUNG_PAIR(BNIL, BNIL);
								BgL_head1305z00_18174 = BgL_res5111z00_18175;
							}
							{
								obj_t BgL_l1303z00_18177;
								obj_t BgL_tail1306z00_18178;

								BgL_l1303z00_18177 = BgL_l1303z00_18173;
								BgL_tail1306z00_18178 = BgL_head1305z00_18174;
							BgL_zc3z04anonymousza33163ze3z87_18176:
								if (NULLP(BgL_l1303z00_18177))
									{	/* Eval/evaluate_comp.scm 441 */
										BgL_argsz00_18172 = CDR(BgL_head1305z00_18174);
									}
								else
									{	/* Eval/evaluate_comp.scm 441 */
										obj_t BgL_newtail1307z00_18179;

										{	/* Eval/evaluate_comp.scm 441 */
											obj_t BgL_arg3170z00_18180;

											{	/* Eval/evaluate_comp.scm 441 */
												obj_t BgL_ez00_18181;

												BgL_ez00_18181 = CAR(((obj_t) BgL_l1303z00_18177));
												BgL_arg3170z00_18180 =
													BGl_compz00zz__evaluate_compz00(
													((BgL_ev_exprz00_bglt) BgL_ez00_18181),
													BgL_stkz00_15400);
											}
											{	/* Eval/evaluate_comp.scm 441 */
												obj_t BgL_res5117z00_18182;

												BgL_res5117z00_18182 =
													MAKE_YOUNG_PAIR(BgL_arg3170z00_18180, BNIL);
												BgL_newtail1307z00_18179 = BgL_res5117z00_18182;
											}
										}
										SET_CDR(BgL_tail1306z00_18178, BgL_newtail1307z00_18179);
										{	/* Eval/evaluate_comp.scm 441 */
											obj_t BgL_arg3168z00_18183;

											BgL_arg3168z00_18183 = CDR(((obj_t) BgL_l1303z00_18177));
											{
												obj_t BgL_tail1306z00_33785;
												obj_t BgL_l1303z00_33784;

												BgL_l1303z00_33784 = BgL_arg3168z00_18183;
												BgL_tail1306z00_33785 = BgL_newtail1307z00_18179;
												BgL_tail1306z00_18178 = BgL_tail1306z00_33785;
												BgL_l1303z00_18177 = BgL_l1303z00_33784;
												goto BgL_zc3z04anonymousza33163ze3z87_18176;
											}
										}
									}
							}
						}
				}
				{	/* Eval/evaluate_comp.scm 442 */
					obj_t BgL_zc3z04anonymousza33154ze3z87_18184;

					BgL_zc3z04anonymousza33154ze3z87_18184 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3z04anonymousza33154ze3ze5zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 1)));
					PROCEDURE_SET(BgL_zc3z04anonymousza33154ze3z87_18184,
						(int) (((long) 0)), BgL_argsz00_18172);
					return BgL_zc3z04anonymousza33154ze3z87_18184;
				}
			}
		}

	}



/* &<@anonymous:3154> */
	obj_t BGl_z62zc3z04anonymousza33154ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15401, obj_t BgL_sz00_15403)
	{
		{	/* Eval/evaluate_comp.scm 442 */
			{	/* Eval/evaluate_comp.scm 442 */
				obj_t BgL_argsz00_15402;

				BgL_argsz00_15402 = PROCEDURE_REF(BgL_envz00_15401, (int) (((long) 0)));
				{	/* Eval/evaluate_comp.scm 442 */
					obj_t BgL_bpz00_18185;

					BgL_bpz00_18185 = VECTOR_REF(((obj_t) BgL_sz00_15403), ((long) 0));
					{
						obj_t BgL_lz00_18187;
						obj_t BgL_rz00_18188;

						BgL_lz00_18187 = BgL_argsz00_15402;
						BgL_rz00_18188 = BTRUE;
					BgL_recz00_18186:
						if (NULLP(BgL_lz00_18187))
							{	/* Eval/evaluate_comp.scm 444 */
								return BgL_rz00_18188;
							}
						else
							{	/* Eval/evaluate_comp.scm 446 */
								obj_t BgL_vz00_18189;

								{	/* Eval/evaluate_comp.scm 446 */
									obj_t BgL_fun3161z00_18190;

									BgL_fun3161z00_18190 = CAR(((obj_t) BgL_lz00_18187));
									BgL_vz00_18189 =
										PROCEDURE_ENTRY(BgL_fun3161z00_18190) (BgL_fun3161z00_18190,
										BgL_sz00_15403, BEOA);
								}
								if (CBOOL(BgL_vz00_18189))
									{	/* Eval/evaluate_comp.scm 447 */
										obj_t BgL_arg3160z00_18191;

										BgL_arg3160z00_18191 = CDR(((obj_t) BgL_lz00_18187));
										{
											obj_t BgL_rz00_33808;
											obj_t BgL_lz00_33807;

											BgL_lz00_33807 = BgL_arg3160z00_18191;
											BgL_rz00_33808 = BgL_vz00_18189;
											BgL_rz00_18188 = BgL_rz00_33808;
											BgL_lz00_18187 = BgL_lz00_33807;
											goto BgL_recz00_18186;
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 447 */
										return BFALSE;
									}
							}
					}
				}
			}
		}

	}



/* &comp-ev_or1412 */
	obj_t BGl_z62compzd2ev_or1412zb0zz__evaluate_compz00(obj_t BgL_envz00_15404,
		obj_t BgL_ez00_15405, obj_t BgL_stkz00_15406)
	{
		{	/* Eval/evaluate_comp.scm 430 */
			{	/* Eval/evaluate_comp.scm 432 */
				obj_t BgL_argsz00_18193;

				{	/* Eval/evaluate_comp.scm 432 */
					obj_t BgL_l1298z00_18194;

					BgL_l1298z00_18194 =
						(((BgL_ev_listz00_bglt) COBJECT(
								((BgL_ev_listz00_bglt)
									((BgL_ev_orz00_bglt) BgL_ez00_15405))))->BgL_argsz00);
					if (NULLP(BgL_l1298z00_18194))
						{	/* Eval/evaluate_comp.scm 432 */
							BgL_argsz00_18193 = BNIL;
						}
					else
						{	/* Eval/evaluate_comp.scm 432 */
							obj_t BgL_head1300z00_18195;

							{	/* Eval/evaluate_comp.scm 432 */
								obj_t BgL_res5102z00_18196;

								BgL_res5102z00_18196 = MAKE_YOUNG_PAIR(BNIL, BNIL);
								BgL_head1300z00_18195 = BgL_res5102z00_18196;
							}
							{
								obj_t BgL_l1298z00_18198;
								obj_t BgL_tail1301z00_18199;

								BgL_l1298z00_18198 = BgL_l1298z00_18194;
								BgL_tail1301z00_18199 = BgL_head1300z00_18195;
							BgL_zc3z04anonymousza33150ze3z87_18197:
								if (NULLP(BgL_l1298z00_18198))
									{	/* Eval/evaluate_comp.scm 432 */
										BgL_argsz00_18193 = CDR(BgL_head1300z00_18195);
									}
								else
									{	/* Eval/evaluate_comp.scm 432 */
										obj_t BgL_newtail1302z00_18200;

										{	/* Eval/evaluate_comp.scm 432 */
											obj_t BgL_arg3153z00_18201;

											{	/* Eval/evaluate_comp.scm 432 */
												obj_t BgL_ez00_18202;

												BgL_ez00_18202 = CAR(((obj_t) BgL_l1298z00_18198));
												BgL_arg3153z00_18201 =
													BGl_compz00zz__evaluate_compz00(
													((BgL_ev_exprz00_bglt) BgL_ez00_18202),
													BgL_stkz00_15406);
											}
											{	/* Eval/evaluate_comp.scm 432 */
												obj_t BgL_res5108z00_18203;

												BgL_res5108z00_18203 =
													MAKE_YOUNG_PAIR(BgL_arg3153z00_18201, BNIL);
												BgL_newtail1302z00_18200 = BgL_res5108z00_18203;
											}
										}
										SET_CDR(BgL_tail1301z00_18199, BgL_newtail1302z00_18200);
										{	/* Eval/evaluate_comp.scm 432 */
											obj_t BgL_arg3152z00_18204;

											BgL_arg3152z00_18204 = CDR(((obj_t) BgL_l1298z00_18198));
											{
												obj_t BgL_tail1301z00_33827;
												obj_t BgL_l1298z00_33826;

												BgL_l1298z00_33826 = BgL_arg3152z00_18204;
												BgL_tail1301z00_33827 = BgL_newtail1302z00_18200;
												BgL_tail1301z00_18199 = BgL_tail1301z00_33827;
												BgL_l1298z00_18198 = BgL_l1298z00_33826;
												goto BgL_zc3z04anonymousza33150ze3z87_18197;
											}
										}
									}
							}
						}
				}
				{	/* Eval/evaluate_comp.scm 433 */
					obj_t BgL_zc3z04anonymousza33144ze3z87_18205;

					BgL_zc3z04anonymousza33144ze3z87_18205 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3z04anonymousza33144ze3ze5zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 1)));
					PROCEDURE_SET(BgL_zc3z04anonymousza33144ze3z87_18205,
						(int) (((long) 0)), BgL_argsz00_18193);
					return BgL_zc3z04anonymousza33144ze3z87_18205;
				}
			}
		}

	}



/* &<@anonymous:3144> */
	obj_t BGl_z62zc3z04anonymousza33144ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15407, obj_t BgL_sz00_15409)
	{
		{	/* Eval/evaluate_comp.scm 433 */
			{	/* Eval/evaluate_comp.scm 433 */
				obj_t BgL_argsz00_15408;

				BgL_argsz00_15408 = PROCEDURE_REF(BgL_envz00_15407, (int) (((long) 0)));
				{	/* Eval/evaluate_comp.scm 433 */
					obj_t BgL_bpz00_18206;

					BgL_bpz00_18206 = VECTOR_REF(((obj_t) BgL_sz00_15409), ((long) 0));
					{
						obj_t BgL_lz00_18208;

						BgL_lz00_18208 = BgL_argsz00_15408;
					BgL_recz00_18207:
						if (NULLP(BgL_lz00_18208))
							{	/* Eval/evaluate_comp.scm 435 */
								return BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 437 */
								obj_t BgL__ortest_1106z00_18209;

								{	/* Eval/evaluate_comp.scm 437 */
									obj_t BgL_fun3148z00_18210;

									BgL_fun3148z00_18210 = CAR(((obj_t) BgL_lz00_18208));
									BgL__ortest_1106z00_18209 =
										PROCEDURE_ENTRY(BgL_fun3148z00_18210) (BgL_fun3148z00_18210,
										BgL_sz00_15409, BEOA);
								}
								if (CBOOL(BgL__ortest_1106z00_18209))
									{	/* Eval/evaluate_comp.scm 437 */
										return BgL__ortest_1106z00_18209;
									}
								else
									{	/* Eval/evaluate_comp.scm 437 */
										obj_t BgL_arg3147z00_18211;

										BgL_arg3147z00_18211 = CDR(((obj_t) BgL_lz00_18208));
										{
											obj_t BgL_lz00_33849;

											BgL_lz00_33849 = BgL_arg3147z00_18211;
											BgL_lz00_18208 = BgL_lz00_33849;
											goto BgL_recz00_18207;
										}
									}
							}
					}
				}
			}
		}

	}



/* &comp-ev_if1410 */
	obj_t BGl_z62compzd2ev_if1410zb0zz__evaluate_compz00(obj_t BgL_envz00_15410,
		obj_t BgL_ez00_15411, obj_t BgL_stkz00_15412)
	{
		{	/* Eval/evaluate_comp.scm 424 */
			{	/* Eval/evaluate_comp.scm 426 */
				obj_t BgL_pz00_18213;
				obj_t BgL_tz00_18214;
				obj_t BgL_ez00_18215;

				BgL_pz00_18213 =
					BGl_compz00zz__evaluate_compz00(
					(((BgL_ev_ifz00_bglt) COBJECT(
								((BgL_ev_ifz00_bglt) BgL_ez00_15411)))->BgL_pz00),
					BgL_stkz00_15412);
				BgL_tz00_18214 =
					BGl_compz00zz__evaluate_compz00((((BgL_ev_ifz00_bglt)
							COBJECT(((BgL_ev_ifz00_bglt) BgL_ez00_15411)))->BgL_tz00),
					BgL_stkz00_15412);
				BgL_ez00_18215 =
					BGl_compz00zz__evaluate_compz00((((BgL_ev_ifz00_bglt)
							COBJECT(((BgL_ev_ifz00_bglt) BgL_ez00_15411)))->BgL_ez00),
					BgL_stkz00_15412);
				{	/* Eval/evaluate_comp.scm 427 */
					obj_t BgL_zc3z04anonymousza33137ze3z87_18216;

					BgL_zc3z04anonymousza33137ze3z87_18216 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3z04anonymousza33137ze3ze5zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 3)));
					PROCEDURE_SET(BgL_zc3z04anonymousza33137ze3z87_18216,
						(int) (((long) 0)), BgL_ez00_18215);
					PROCEDURE_SET(BgL_zc3z04anonymousza33137ze3z87_18216,
						(int) (((long) 1)), BgL_tz00_18214);
					PROCEDURE_SET(BgL_zc3z04anonymousza33137ze3z87_18216,
						(int) (((long) 2)), BgL_pz00_18213);
					return BgL_zc3z04anonymousza33137ze3z87_18216;
				}
			}
		}

	}



/* &<@anonymous:3137> */
	obj_t BGl_z62zc3z04anonymousza33137ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15413, obj_t BgL_sz00_15417)
	{
		{	/* Eval/evaluate_comp.scm 427 */
			{	/* Eval/evaluate_comp.scm 427 */
				obj_t BgL_ez00_15414;
				obj_t BgL_tz00_15415;
				obj_t BgL_pz00_15416;

				BgL_ez00_15414 = PROCEDURE_REF(BgL_envz00_15413, (int) (((long) 0)));
				BgL_tz00_15415 = PROCEDURE_REF(BgL_envz00_15413, (int) (((long) 1)));
				BgL_pz00_15416 = PROCEDURE_REF(BgL_envz00_15413, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 427 */
					obj_t BgL_bpz00_18217;

					BgL_bpz00_18217 = VECTOR_REF(((obj_t) BgL_sz00_15417), ((long) 0));
					if (CBOOL(PROCEDURE_ENTRY(BgL_pz00_15416) (BgL_pz00_15416,
								BgL_sz00_15417, BEOA)))
						{	/* Eval/evaluate_comp.scm 428 */
							return
								PROCEDURE_ENTRY(BgL_tz00_15415) (BgL_tz00_15415, BgL_sz00_15417,
								BEOA);
						}
					else
						{	/* Eval/evaluate_comp.scm 428 */
							return
								PROCEDURE_ENTRY(BgL_ez00_15414) (BgL_ez00_15414, BgL_sz00_15417,
								BEOA);
						}
				}
			}
		}

	}



/* &comp-ev_litt1408 */
	obj_t BGl_z62compzd2ev_litt1408zb0zz__evaluate_compz00(obj_t BgL_envz00_15418,
		obj_t BgL_ez00_15419, obj_t BgL_stkz00_15420)
	{
		{	/* Eval/evaluate_comp.scm 419 */
			{	/* Eval/evaluate_comp.scm 421 */
				obj_t BgL_zc3z04anonymousza33136ze3z87_18219;

				BgL_zc3z04anonymousza33136ze3z87_18219 =
					MAKE_FX_PROCEDURE
					(BGl_z62zc3z04anonymousza33136ze3ze5zz__evaluate_compz00,
					(int) (((long) 1)), (int) (((long) 1)));
				PROCEDURE_SET(BgL_zc3z04anonymousza33136ze3z87_18219,
					(int) (((long) 0)), ((obj_t) ((BgL_ev_littz00_bglt) BgL_ez00_15419)));
				return BgL_zc3z04anonymousza33136ze3z87_18219;
			}
		}

	}



/* &<@anonymous:3136> */
	obj_t BGl_z62zc3z04anonymousza33136ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15421, obj_t BgL_sz00_15423)
	{
		{	/* Eval/evaluate_comp.scm 421 */
			{	/* Eval/evaluate_comp.scm 421 */
				BgL_ev_littz00_bglt BgL_i1103z00_15422;

				BgL_i1103z00_15422 =
					((BgL_ev_littz00_bglt)
					PROCEDURE_REF(BgL_envz00_15421, (int) (((long) 0))));
				{	/* Eval/evaluate_comp.scm 421 */
					obj_t BgL_bpz00_18220;

					BgL_bpz00_18220 = VECTOR_REF(((obj_t) BgL_sz00_15423), ((long) 0));
					return
						(((BgL_ev_littz00_bglt) COBJECT(BgL_i1103z00_15422))->BgL_valuez00);
				}
			}
		}

	}



/* &comp-ev_defglobal1406 */
	obj_t BGl_z62compzd2ev_defglobal1406zb0zz__evaluate_compz00(obj_t
		BgL_envz00_15424, obj_t BgL_ez00_15425, obj_t BgL_stkz00_15426)
	{
		{	/* Eval/evaluate_comp.scm 388 */
			{	/* Eval/evaluate_comp.scm 390 */
				obj_t BgL_ez00_18222;

				{	/* Eval/evaluate_comp.scm 390 */
					BgL_ev_exprz00_bglt BgL_arg3135z00_18223;

					BgL_arg3135z00_18223 =
						(((BgL_ev_hookz00_bglt) COBJECT(
								((BgL_ev_hookz00_bglt)
									((BgL_ev_defglobalz00_bglt) BgL_ez00_15425))))->BgL_ez00);
					BgL_ez00_18222 =
						BGl_compz00zz__evaluate_compz00(BgL_arg3135z00_18223,
						BgL_stkz00_15426);
				}
				{	/* Eval/evaluate_comp.scm 391 */
					obj_t BgL_zc3z04anonymousza33088ze3z87_18224;

					BgL_zc3z04anonymousza33088ze3z87_18224 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3z04anonymousza33088ze3ze5zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 2)));
					PROCEDURE_SET(BgL_zc3z04anonymousza33088ze3z87_18224,
						(int) (((long) 0)),
						((obj_t) ((BgL_ev_defglobalz00_bglt) BgL_ez00_15425)));
					PROCEDURE_SET(BgL_zc3z04anonymousza33088ze3z87_18224,
						(int) (((long) 1)), BgL_ez00_18222);
					return BgL_zc3z04anonymousza33088ze3z87_18224;
				}
			}
		}

	}



/* &<@anonymous:3088> */
	obj_t BGl_z62zc3z04anonymousza33088ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15427, obj_t BgL_sz00_15430)
	{
		{	/* Eval/evaluate_comp.scm 391 */
			{	/* Eval/evaluate_comp.scm 391 */
				BgL_ev_defglobalz00_bglt BgL_i1100z00_15428;
				obj_t BgL_ez00_15429;

				BgL_i1100z00_15428 =
					((BgL_ev_defglobalz00_bglt)
					PROCEDURE_REF(BgL_envz00_15427, (int) (((long) 0))));
				BgL_ez00_15429 = PROCEDURE_REF(BgL_envz00_15427, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 391 */
					obj_t BgL_bpz00_18225;

					BgL_bpz00_18225 = VECTOR_REF(((obj_t) BgL_sz00_15430), ((long) 0));
					{	/* Eval/evaluate_comp.scm 392 */
						obj_t BgL_gz00_18226;

						{	/* Eval/evaluate_comp.scm 392 */
							obj_t BgL_arg3133z00_18227;
							obj_t BgL_arg3134z00_18228;

							BgL_arg3133z00_18227 =
								(((BgL_ev_setglobalz00_bglt) COBJECT(
										((BgL_ev_setglobalz00_bglt) BgL_i1100z00_15428)))->
								BgL_modz00);
							BgL_arg3134z00_18228 =
								(((BgL_ev_setglobalz00_bglt) COBJECT(((BgL_ev_setglobalz00_bglt)
											BgL_i1100z00_15428)))->BgL_namez00);
							BgL_gz00_18226 =
								BGl_evmodulezd2findzd2globalz00zz__evmodulez00
								(BgL_arg3133z00_18227, BgL_arg3134z00_18228);
						}
						if (CBOOL(BgL_gz00_18226))
							{	/* Eval/evaluate_comp.scm 394 */
								{

									{	/* Eval/evaluate_comp.scm 396 */
										int BgL_aux1102z00_18232;

										{	/* Eval/evaluate_comp.scm 396 */
											int BgL_res5100z00_18233;

											BgL_res5100z00_18233 =
												CINT(VECTOR_REF(((obj_t) BgL_gz00_18226), ((long) 0)));
											BgL_aux1102z00_18232 = BgL_res5100z00_18233;
										}
										switch ((long) (BgL_aux1102z00_18232))
											{
											case ((long) 0):

												{	/* Eval/evaluate_comp.scm 398 */
													obj_t BgL_arg3090z00_18234;
													obj_t BgL_arg3091z00_18235;

													BgL_arg3090z00_18234 =
														(((BgL_ev_setglobalz00_bglt) COBJECT(
																((BgL_ev_setglobalz00_bglt)
																	BgL_i1100z00_15428)))->BgL_locz00);
													BgL_arg3091z00_18235 =
														(((BgL_ev_setglobalz00_bglt)
															COBJECT(((BgL_ev_setglobalz00_bglt)
																	BgL_i1100z00_15428)))->BgL_namez00);
													BGl_everrorz00zz__everrorz00(BgL_arg3090z00_18234,
														BGl_string5919z00zz__evaluate_compz00,
														BGl_string5920z00zz__evaluate_compz00,
														BgL_arg3091z00_18235);
												} break;
											case ((long) 1):

												{	/* Eval/evaluate_comp.scm 400 */
													obj_t BgL_arg3092z00_18236;
													obj_t BgL_arg3093z00_18237;

													BgL_arg3092z00_18236 =
														(((BgL_ev_setglobalz00_bglt) COBJECT(
																((BgL_ev_setglobalz00_bglt)
																	BgL_i1100z00_15428)))->BgL_locz00);
													BgL_arg3093z00_18237 =
														(((BgL_ev_setglobalz00_bglt)
															COBJECT(((BgL_ev_setglobalz00_bglt)
																	BgL_i1100z00_15428)))->BgL_namez00);
													{	/* Eval/evaluate_comp.scm 400 */
														obj_t BgL_list3094z00_18238;

														{	/* Eval/evaluate_comp.scm 400 */
															obj_t BgL_arg3096z00_18239;

															{	/* Eval/evaluate_comp.scm 400 */
																obj_t BgL_arg3108z00_18240;

																BgL_arg3108z00_18240 =
																	MAKE_YOUNG_PAIR(BgL_arg3093z00_18237, BNIL);
																BgL_arg3096z00_18239 =
																	MAKE_YOUNG_PAIR
																	(BGl_string5921z00zz__evaluate_compz00,
																	BgL_arg3108z00_18240);
															}
															BgL_list3094z00_18238 =
																MAKE_YOUNG_PAIR
																(BGl_string5798z00zz__evaluate_compz00,
																BgL_arg3096z00_18239);
														}
														BGl_evwarningz00zz__everrorz00(BgL_arg3092z00_18236,
															BgL_list3094z00_18238);
												}}
												{	/* Eval/evaluate_comp.scm 402 */
													obj_t BgL_arg3110z00_18241;
													obj_t BgL_arg3111z00_18242;

													BgL_arg3110z00_18241 =
														VECTOR_REF(((obj_t) BgL_gz00_18226), ((long) 2));
													BgL_arg3111z00_18242 =
														PROCEDURE_ENTRY(BgL_ez00_15429) (BgL_ez00_15429,
														BgL_sz00_15430, BEOA);
													__EVMEANING_ADDRESS_SET(BgL_arg3110z00_18241,
														BgL_arg3111z00_18242);
												} break;
											case ((long) 2):

												{	/* Eval/evaluate_comp.scm 404 */
													obj_t BgL_arg3113z00_18243;

													BgL_arg3113z00_18243 =
														PROCEDURE_ENTRY(BgL_ez00_15429) (BgL_ez00_15429,
														BgL_sz00_15430, BEOA);
													VECTOR_SET(((obj_t) BgL_gz00_18226), ((long) 2),
														BgL_arg3113z00_18243);
												} break;
											case ((long) 3):

												{	/* Eval/evaluate_comp.scm 406 */
													obj_t BgL_arg3114z00_18244;

													BgL_arg3114z00_18244 =
														PROCEDURE_ENTRY(BgL_ez00_15429) (BgL_ez00_15429,
														BgL_sz00_15430, BEOA);
													VECTOR_SET(((obj_t) BgL_gz00_18226), ((long) 2),
														BgL_arg3114z00_18244);
												}
												VECTOR_SET(
													((obj_t) BgL_gz00_18226), ((long) 0),
													BINT(((long) 2)));
												break;
											case ((long) 4):

												{	/* Eval/evaluate_comp.scm 409 */
													obj_t BgL_arg3116z00_18245;

													BgL_arg3116z00_18245 =
														PROCEDURE_ENTRY(BgL_ez00_15429) (BgL_ez00_15429,
														BgL_sz00_15430, BEOA);
													VECTOR_SET(((obj_t) BgL_gz00_18226), ((long) 2),
														BgL_arg3116z00_18245);
												}
												VECTOR_SET(
													((obj_t) BgL_gz00_18226), ((long) 0),
													BINT(((long) 5)));
												break;
											default:
												{	/* Eval/evaluate_comp.scm 412 */
													obj_t BgL_arg3117z00_18230;
													obj_t BgL_arg3118z00_18231;

													BgL_arg3117z00_18230 =
														(((BgL_ev_setglobalz00_bglt) COBJECT(
																((BgL_ev_setglobalz00_bglt)
																	BgL_i1100z00_15428)))->BgL_locz00);
													BgL_arg3118z00_18231 =
														(((BgL_ev_setglobalz00_bglt)
															COBJECT(((BgL_ev_setglobalz00_bglt)
																	BgL_i1100z00_15428)))->BgL_namez00);
													BGl_everrorz00zz__everrorz00(BgL_arg3117z00_18230,
														BGl_string5919z00zz__evaluate_compz00,
														BGl_string5920z00zz__evaluate_compz00,
														BgL_arg3118z00_18231);
												}
											}
									}
								}
								return
									(((BgL_ev_setglobalz00_bglt) COBJECT(
											((BgL_ev_setglobalz00_bglt) BgL_i1100z00_15428)))->
									BgL_namez00);
							}
						else
							{	/* Eval/evaluate_comp.scm 414 */
								obj_t BgL_gz00_18246;

								{	/* Eval/evaluate_comp.scm 414 */
									obj_t BgL_arg3124z00_18247;
									obj_t BgL_arg3125z00_18248;
									obj_t BgL_arg3126z00_18249;

									BgL_arg3124z00_18247 =
										(((BgL_ev_setglobalz00_bglt) COBJECT(
												((BgL_ev_setglobalz00_bglt) BgL_i1100z00_15428)))->
										BgL_namez00);
									BgL_arg3125z00_18248 =
										(((BgL_ev_setglobalz00_bglt)
											COBJECT(((BgL_ev_setglobalz00_bglt)
													BgL_i1100z00_15428)))->BgL_modz00);
									BgL_arg3126z00_18249 =
										(((BgL_ev_setglobalz00_bglt)
											COBJECT(((BgL_ev_setglobalz00_bglt)
													BgL_i1100z00_15428)))->BgL_locz00);
									{	/* Eval/evaluate_comp.scm 414 */
										obj_t BgL_v1376z00_18250;

										BgL_v1376z00_18250 = create_vector(((long) 5));
										VECTOR_SET(BgL_v1376z00_18250, ((long) 0),
											BINT(((long) 2)));
										VECTOR_SET(BgL_v1376z00_18250, ((long) 1),
											BgL_arg3124z00_18247);
										VECTOR_SET(BgL_v1376z00_18250, ((long) 2), BUNSPEC);
										VECTOR_SET(BgL_v1376z00_18250, ((long) 3),
											BgL_arg3125z00_18248);
										VECTOR_SET(BgL_v1376z00_18250, ((long) 4),
											BgL_arg3126z00_18249);
										BgL_gz00_18246 = BgL_v1376z00_18250;
								}}
								{	/* Eval/evaluate_comp.scm 415 */
									obj_t BgL_arg3119z00_18251;

									BgL_arg3119z00_18251 =
										PROCEDURE_ENTRY(BgL_ez00_15429) (BgL_ez00_15429,
										BgL_sz00_15430, BEOA);
									VECTOR_SET(BgL_gz00_18246, ((long) 2), BgL_arg3119z00_18251);
								}
								{	/* Eval/evaluate_comp.scm 416 */
									obj_t BgL_arg3121z00_18252;
									obj_t BgL_arg3122z00_18253;
									obj_t BgL_arg3123z00_18254;

									BgL_arg3121z00_18252 =
										(((BgL_ev_setglobalz00_bglt) COBJECT(
												((BgL_ev_setglobalz00_bglt) BgL_i1100z00_15428)))->
										BgL_modz00);
									BgL_arg3122z00_18253 =
										(((BgL_ev_setglobalz00_bglt)
											COBJECT(((BgL_ev_setglobalz00_bglt)
													BgL_i1100z00_15428)))->BgL_namez00);
									BgL_arg3123z00_18254 =
										(((BgL_ev_setglobalz00_bglt)
											COBJECT(((BgL_ev_setglobalz00_bglt)
													BgL_i1100z00_15428)))->BgL_locz00);
									BGl_evmodulezd2bindzd2globalz12z12zz__evmodulez00
										(BgL_arg3121z00_18252, BgL_arg3122z00_18253, BgL_gz00_18246,
										BgL_arg3123z00_18254);
								}
								return
									(((BgL_ev_setglobalz00_bglt) COBJECT(
											((BgL_ev_setglobalz00_bglt) BgL_i1100z00_15428)))->
									BgL_namez00);
							}
					}
				}
			}
		}

	}



/* &comp-ev_setglobal1404 */
	obj_t BGl_z62compzd2ev_setglobal1404zb0zz__evaluate_compz00(obj_t
		BgL_envz00_15431, obj_t BgL_ez00_15432, obj_t BgL_stkz00_15433)
	{
		{	/* Eval/evaluate_comp.scm 365 */
			{	/* Eval/evaluate_comp.scm 367 */
				obj_t BgL_gz00_18256;
				obj_t BgL_ez00_18257;

				BgL_gz00_18256 =
					BGl_evmodulezd2findzd2globalz00zz__evmodulez00(
					(((BgL_ev_setglobalz00_bglt) COBJECT(
								((BgL_ev_setglobalz00_bglt) BgL_ez00_15432)))->BgL_modz00),
					(((BgL_ev_setglobalz00_bglt) COBJECT(
								((BgL_ev_setglobalz00_bglt) BgL_ez00_15432)))->BgL_namez00));
				{	/* Eval/evaluate_comp.scm 367 */
					BgL_ev_exprz00_bglt BgL_arg3087z00_18258;

					BgL_arg3087z00_18258 =
						(((BgL_ev_hookz00_bglt) COBJECT(
								((BgL_ev_hookz00_bglt)
									((BgL_ev_setglobalz00_bglt) BgL_ez00_15432))))->BgL_ez00);
					BgL_ez00_18257 =
						BGl_compz00zz__evaluate_compz00(BgL_arg3087z00_18258,
						BgL_stkz00_15433);
				}
				if (CBOOL(BgL_gz00_18256))
					{

						{	/* Eval/evaluate_comp.scm 369 */
							int BgL_aux1099z00_18261;

							{	/* Eval/evaluate_comp.scm 369 */
								int BgL_res5099z00_18262;

								BgL_res5099z00_18262 =
									CINT(VECTOR_REF(((obj_t) BgL_gz00_18256), ((long) 0)));
								BgL_aux1099z00_18261 = BgL_res5099z00_18262;
							}
							switch ((long) (BgL_aux1099z00_18261))
								{
								case ((long) 1):

									{	/* Eval/evaluate_comp.scm 371 */
										obj_t BgL_zc3z04anonymousza33048ze3z87_18263;

										BgL_zc3z04anonymousza33048ze3z87_18263 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza33048ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 2)));
										PROCEDURE_SET(BgL_zc3z04anonymousza33048ze3z87_18263,
											(int) (((long) 0)), BgL_gz00_18256);
										PROCEDURE_SET(BgL_zc3z04anonymousza33048ze3z87_18263,
											(int) (((long) 1)), BgL_ez00_18257);
										return BgL_zc3z04anonymousza33048ze3z87_18263;
									}
									break;
								case ((long) 0):
								case ((long) 4):
								case ((long) 5):

									return
										BGl_everrorz00zz__everrorz00(
										(((BgL_ev_setglobalz00_bglt) COBJECT(
													((BgL_ev_setglobalz00_bglt) BgL_ez00_15432)))->
											BgL_locz00), BGl_string5919z00zz__evaluate_compz00,
										BGl_string5920z00zz__evaluate_compz00,
										(((BgL_ev_setglobalz00_bglt)
												COBJECT(((BgL_ev_setglobalz00_bglt) BgL_ez00_15432)))->
											BgL_namez00));
									break;
								default:
									{	/* Eval/evaluate_comp.scm 376 */
										obj_t BgL_zc3z04anonymousza33060ze3z87_18260;

										BgL_zc3z04anonymousza33060ze3z87_18260 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza33060ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 2)));
										PROCEDURE_SET(BgL_zc3z04anonymousza33060ze3z87_18260,
											(int) (((long) 0)), BgL_ez00_18257);
										PROCEDURE_SET(BgL_zc3z04anonymousza33060ze3z87_18260,
											(int) (((long) 1)), BgL_gz00_18256);
										return BgL_zc3z04anonymousza33060ze3z87_18260;
									}
								}
						}
					}
				else
					{	/* Eval/evaluate_comp.scm 377 */
						obj_t BgL_slotz00_18264;

						BgL_slotz00_18264 = MAKE_CELL(BFALSE);
						if (BGl_evmodulezf3zf3zz__evmodulez00(
								(((BgL_ev_setglobalz00_bglt) COBJECT(
											((BgL_ev_setglobalz00_bglt) BgL_ez00_15432)))->
									BgL_modz00)))
							{	/* Eval/evaluate_comp.scm 379 */
								obj_t BgL_gz00_18265;

								{	/* Eval/evaluate_comp.scm 379 */
									obj_t BgL_arg3071z00_18266;
									obj_t BgL_arg3072z00_18267;
									obj_t BgL_arg3075z00_18268;

									BgL_arg3071z00_18266 =
										(((BgL_ev_setglobalz00_bglt) COBJECT(
												((BgL_ev_setglobalz00_bglt) BgL_ez00_15432)))->
										BgL_namez00);
									BgL_arg3072z00_18267 =
										(((BgL_ev_setglobalz00_bglt)
											COBJECT(((BgL_ev_setglobalz00_bglt) BgL_ez00_15432)))->
										BgL_modz00);
									BgL_arg3075z00_18268 =
										(((BgL_ev_setglobalz00_bglt)
											COBJECT(((BgL_ev_setglobalz00_bglt) BgL_ez00_15432)))->
										BgL_locz00);
									{	/* Eval/evaluate_comp.scm 379 */
										obj_t BgL_v1376z00_18269;

										BgL_v1376z00_18269 = create_vector(((long) 5));
										VECTOR_SET(BgL_v1376z00_18269, ((long) 0),
											BINT(((long) 2)));
										VECTOR_SET(BgL_v1376z00_18269, ((long) 1),
											BgL_arg3071z00_18266);
										VECTOR_SET(BgL_v1376z00_18269, ((long) 2), BUNSPEC);
										VECTOR_SET(BgL_v1376z00_18269, ((long) 3),
											BgL_arg3072z00_18267);
										VECTOR_SET(BgL_v1376z00_18269, ((long) 4),
											BgL_arg3075z00_18268);
										BgL_gz00_18265 = BgL_v1376z00_18269;
								}}
								VECTOR_SET(BgL_gz00_18265, ((long) 0), BINT(((long) 3)));
								BGl_evmodulezd2bindzd2globalz12z12zz__evmodulez00(
									(((BgL_ev_setglobalz00_bglt) COBJECT(
												((BgL_ev_setglobalz00_bglt) BgL_ez00_15432)))->
										BgL_modz00),
									(((BgL_ev_setglobalz00_bglt)
											COBJECT(((BgL_ev_setglobalz00_bglt) BgL_ez00_15432)))->
										BgL_namez00), BgL_gz00_18265,
									(((BgL_ev_setglobalz00_bglt)
											COBJECT(((BgL_ev_setglobalz00_bglt) BgL_ez00_15432)))->
										BgL_locz00));
							}
						else
							{	/* Eval/evaluate_comp.scm 378 */
								BFALSE;
							}
						{	/* Eval/evaluate_comp.scm 382 */
							obj_t BgL_zc3z04anonymousza33077ze3z87_18270;

							BgL_zc3z04anonymousza33077ze3z87_18270 =
								MAKE_FX_PROCEDURE
								(BGl_z62zc3z04anonymousza33077ze3ze5zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_zc3z04anonymousza33077ze3z87_18270,
								(int) (((long) 0)),
								((obj_t) ((BgL_ev_setglobalz00_bglt) BgL_ez00_15432)));
							PROCEDURE_SET(BgL_zc3z04anonymousza33077ze3z87_18270,
								(int) (((long) 1)), ((obj_t) BgL_slotz00_18264));
							PROCEDURE_SET(BgL_zc3z04anonymousza33077ze3z87_18270,
								(int) (((long) 2)), BgL_ez00_18257);
							return BgL_zc3z04anonymousza33077ze3z87_18270;
						}
					}
			}
		}

	}



/* &<@anonymous:3048> */
	obj_t BGl_z62zc3z04anonymousza33048ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15436, obj_t BgL_sz00_15439)
	{
		{	/* Eval/evaluate_comp.scm 371 */
			{	/* Eval/evaluate_comp.scm 371 */
				obj_t BgL_gz00_15437;
				obj_t BgL_ez00_15438;

				BgL_gz00_15437 = PROCEDURE_REF(BgL_envz00_15436, (int) (((long) 0)));
				BgL_ez00_15438 = PROCEDURE_REF(BgL_envz00_15436, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 371 */
					obj_t BgL_bpz00_18271;

					BgL_bpz00_18271 = VECTOR_REF(((obj_t) BgL_sz00_15439), ((long) 0));
					{	/* Eval/evaluate_comp.scm 372 */
						obj_t BgL_arg3049z00_18272;
						obj_t BgL_arg3050z00_18273;

						BgL_arg3049z00_18272 =
							VECTOR_REF(((obj_t) BgL_gz00_15437), ((long) 2));
						BgL_arg3050z00_18273 =
							PROCEDURE_ENTRY(BgL_ez00_15438) (BgL_ez00_15438, BgL_sz00_15439,
							BEOA);
						return __EVMEANING_ADDRESS_SET(BgL_arg3049z00_18272,
							BgL_arg3050z00_18273);
					}
				}
			}
		}

	}



/* &<@anonymous:3060> */
	obj_t BGl_z62zc3z04anonymousza33060ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15440, obj_t BgL_sz00_15443)
	{
		{	/* Eval/evaluate_comp.scm 376 */
			{	/* Eval/evaluate_comp.scm 376 */
				obj_t BgL_ez00_15441;
				obj_t BgL_gz00_15442;

				BgL_ez00_15441 = PROCEDURE_REF(BgL_envz00_15440, (int) (((long) 0)));
				BgL_gz00_15442 = PROCEDURE_REF(BgL_envz00_15440, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 376 */
					obj_t BgL_bpz00_18274;

					BgL_bpz00_18274 = VECTOR_REF(((obj_t) BgL_sz00_15443), ((long) 0));
					{	/* Eval/evaluate_comp.scm 376 */
						obj_t BgL_arg3063z00_18275;

						BgL_arg3063z00_18275 =
							PROCEDURE_ENTRY(BgL_ez00_15441) (BgL_ez00_15441, BgL_sz00_15443,
							BEOA);
						return VECTOR_SET(((obj_t) BgL_gz00_15442), ((long) 2),
							BgL_arg3063z00_18275);
		}}}}

	}



/* &<@anonymous:3077> */
	obj_t BGl_z62zc3z04anonymousza33077ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15444, obj_t BgL_sz00_15448)
	{
		{	/* Eval/evaluate_comp.scm 382 */
			{	/* Eval/evaluate_comp.scm 382 */
				BgL_ev_setglobalz00_bglt BgL_i1097z00_15445;
				obj_t BgL_slotz00_15446;
				obj_t BgL_ez00_15447;

				BgL_i1097z00_15445 =
					((BgL_ev_setglobalz00_bglt)
					PROCEDURE_REF(BgL_envz00_15444, (int) (((long) 0))));
				BgL_slotz00_15446 = PROCEDURE_REF(BgL_envz00_15444, (int) (((long) 1)));
				BgL_ez00_15447 = PROCEDURE_REF(BgL_envz00_15444, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 382 */
					obj_t BgL_bpz00_18276;

					BgL_bpz00_18276 = VECTOR_REF(((obj_t) BgL_sz00_15448), ((long) 0));
					if (CBOOL(CELL_REF(BgL_slotz00_15446)))
						{	/* Eval/evaluate_comp.scm 383 */
							BFALSE;
						}
					else
						{	/* Eval/evaluate_comp.scm 383 */
							{	/* Eval/evaluate_comp.scm 384 */
								obj_t BgL_auxz00_18277;

								BgL_auxz00_18277 =
									BGl_evmodulezd2findzd2globalz00zz__evmodulez00(
									(((BgL_ev_setglobalz00_bglt) COBJECT(BgL_i1097z00_15445))->
										BgL_modz00),
									(((BgL_ev_setglobalz00_bglt) COBJECT(BgL_i1097z00_15445))->
										BgL_namez00));
								CELL_SET(BgL_slotz00_15446, BgL_auxz00_18277);
							}
							if (CBOOL(CELL_REF(BgL_slotz00_15446)))
								{	/* Eval/evaluate_comp.scm 385 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 385 */
									BGl_everrorz00zz__everrorz00(
										(((BgL_ev_setglobalz00_bglt) COBJECT(BgL_i1097z00_15445))->
											BgL_locz00), BGl_string5798z00zz__evaluate_compz00,
										BGl_string5922z00zz__evaluate_compz00,
										(((BgL_ev_setglobalz00_bglt) COBJECT(BgL_i1097z00_15445))->
											BgL_namez00));
								}
						}
					{	/* Eval/evaluate_comp.scm 386 */
						obj_t BgL_arg3084z00_18278;

						BgL_arg3084z00_18278 =
							PROCEDURE_ENTRY(BgL_ez00_15447) (BgL_ez00_15447, BgL_sz00_15448,
							BEOA);
						{	/* Eval/evaluate_comp.scm 386 */
							obj_t BgL_evalzd2globalzd2_18279;

							BgL_evalzd2globalzd2_18279 = CELL_REF(BgL_slotz00_15446);
							return
								VECTOR_SET(BgL_evalzd2globalzd2_18279, ((long) 2),
								BgL_arg3084z00_18278);
		}}}}}

	}



/* &comp-ev_global1400 */
	obj_t BGl_z62compzd2ev_global1400zb0zz__evaluate_compz00(obj_t
		BgL_envz00_15450, obj_t BgL_varz00_15451, obj_t BgL_stkz00_15452)
	{
		{	/* Eval/evaluate_comp.scm 339 */
			{	/* Eval/evaluate_comp.scm 341 */
				obj_t BgL_gz00_18281;

				BgL_gz00_18281 =
					BGl_evmodulezd2findzd2globalz00zz__evmodulez00(
					(((BgL_ev_globalz00_bglt) COBJECT(
								((BgL_ev_globalz00_bglt) BgL_varz00_15451)))->BgL_modz00),
					(((BgL_ev_globalz00_bglt) COBJECT(
								((BgL_ev_globalz00_bglt) BgL_varz00_15451)))->BgL_namez00));
				if (CBOOL(BgL_gz00_18281))
					{	/* Eval/evaluate_comp.scm 343 */
						bool_t BgL_test6810z00_34142;

						{	/* Eval/evaluate_comp.scm 343 */
							int BgL_arg3014z00_18282;

							{	/* Eval/evaluate_comp.scm 343 */
								int BgL_res5095z00_18283;

								BgL_res5095z00_18283 =
									CINT(VECTOR_REF(((obj_t) BgL_gz00_18281), ((long) 0)));
								BgL_arg3014z00_18282 = BgL_res5095z00_18283;
							}
							BgL_test6810z00_34142 =
								(BINT(BgL_arg3014z00_18282) == BINT(((long) 1)));
						}
						if (BgL_test6810z00_34142)
							{	/* Eval/evaluate_comp.scm 344 */
								obj_t BgL_zc3z04anonymousza33003ze3z87_18284;

								BgL_zc3z04anonymousza33003ze3z87_18284 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza33003ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 1)));
								PROCEDURE_SET(BgL_zc3z04anonymousza33003ze3z87_18284,
									(int) (((long) 0)), BgL_gz00_18281);
								return BgL_zc3z04anonymousza33003ze3z87_18284;
							}
						else
							{	/* Eval/evaluate_comp.scm 346 */
								obj_t BgL_zc3z04anonymousza33006ze3z87_18285;

								BgL_zc3z04anonymousza33006ze3z87_18285 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza33006ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 1)));
								PROCEDURE_SET(BgL_zc3z04anonymousza33006ze3z87_18285,
									(int) (((long) 0)), BgL_gz00_18281);
								return BgL_zc3z04anonymousza33006ze3z87_18285;
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 348 */
						obj_t BgL_slotz00_18286;

						BgL_slotz00_18286 = MAKE_CELL(BFALSE);
						if (BGl_evmodulezf3zf3zz__evmodulez00(
								(((BgL_ev_globalz00_bglt) COBJECT(
											((BgL_ev_globalz00_bglt) BgL_varz00_15451)))->
									BgL_modz00)))
							{	/* Eval/evaluate_comp.scm 350 */
								obj_t BgL_gz00_18287;

								{	/* Eval/evaluate_comp.scm 350 */
									obj_t BgL_arg3027z00_18288;
									obj_t BgL_arg3028z00_18289;
									obj_t BgL_arg3030z00_18290;

									BgL_arg3027z00_18288 =
										(((BgL_ev_globalz00_bglt) COBJECT(
												((BgL_ev_globalz00_bglt) BgL_varz00_15451)))->
										BgL_namez00);
									BgL_arg3028z00_18289 =
										(((BgL_ev_globalz00_bglt) COBJECT(((BgL_ev_globalz00_bglt)
													BgL_varz00_15451)))->BgL_modz00);
									BgL_arg3030z00_18290 =
										(((BgL_ev_globalz00_bglt) COBJECT(((BgL_ev_globalz00_bglt)
													BgL_varz00_15451)))->BgL_locz00);
									{	/* Eval/evaluate_comp.scm 350 */
										obj_t BgL_v1376z00_18291;

										BgL_v1376z00_18291 = create_vector(((long) 5));
										VECTOR_SET(BgL_v1376z00_18291, ((long) 0),
											BINT(((long) 2)));
										VECTOR_SET(BgL_v1376z00_18291, ((long) 1),
											BgL_arg3027z00_18288);
										VECTOR_SET(BgL_v1376z00_18291, ((long) 2), BUNSPEC);
										VECTOR_SET(BgL_v1376z00_18291, ((long) 3),
											BgL_arg3028z00_18289);
										VECTOR_SET(BgL_v1376z00_18291, ((long) 4),
											BgL_arg3030z00_18290);
										BgL_gz00_18287 = BgL_v1376z00_18291;
								}}
								VECTOR_SET(BgL_gz00_18287, ((long) 0), BINT(((long) 3)));
								BGl_evmodulezd2bindzd2globalz12z12zz__evmodulez00(
									(((BgL_ev_globalz00_bglt) COBJECT(
												((BgL_ev_globalz00_bglt) BgL_varz00_15451)))->
										BgL_modz00),
									(((BgL_ev_globalz00_bglt) COBJECT(((BgL_ev_globalz00_bglt)
													BgL_varz00_15451)))->BgL_namez00), BgL_gz00_18287,
									(((BgL_ev_globalz00_bglt) COBJECT(((BgL_ev_globalz00_bglt)
													BgL_varz00_15451)))->BgL_locz00));
							}
						else
							{	/* Eval/evaluate_comp.scm 349 */
								BFALSE;
							}
						{	/* Eval/evaluate_comp.scm 353 */
							obj_t BgL_zc3z04anonymousza33032ze3z87_18292;

							BgL_zc3z04anonymousza33032ze3z87_18292 =
								MAKE_FX_PROCEDURE
								(BGl_z62zc3z04anonymousza33032ze3ze5zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_zc3z04anonymousza33032ze3z87_18292,
								(int) (((long) 0)),
								((obj_t) ((BgL_ev_globalz00_bglt) BgL_varz00_15451)));
							PROCEDURE_SET(BgL_zc3z04anonymousza33032ze3z87_18292,
								(int) (((long) 1)), ((obj_t) BgL_slotz00_18286));
							return BgL_zc3z04anonymousza33032ze3z87_18292;
						}
					}
			}
		}

	}



/* &<@anonymous:3003> */
	obj_t BGl_z62zc3z04anonymousza33003ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15455, obj_t BgL_sz00_15457)
	{
		{	/* Eval/evaluate_comp.scm 344 */
			{	/* Eval/evaluate_comp.scm 344 */
				obj_t BgL_gz00_15456;

				BgL_gz00_15456 = PROCEDURE_REF(BgL_envz00_15455, (int) (((long) 0)));
				{	/* Eval/evaluate_comp.scm 344 */
					obj_t BgL_bpz00_18293;

					BgL_bpz00_18293 = VECTOR_REF(((obj_t) BgL_sz00_15457), ((long) 0));
					{	/* Eval/evaluate_comp.scm 345 */
						obj_t BgL_arg3005z00_18294;

						BgL_arg3005z00_18294 =
							VECTOR_REF(((obj_t) BgL_gz00_15456), ((long) 2));
						return __EVMEANING_ADDRESS_REF(BgL_arg3005z00_18294);
					}
				}
			}
		}

	}



/* &<@anonymous:3006> */
	obj_t BGl_z62zc3z04anonymousza33006ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15458, obj_t BgL_sz00_15460)
	{
		{	/* Eval/evaluate_comp.scm 346 */
			{	/* Eval/evaluate_comp.scm 346 */
				obj_t BgL_gz00_15459;

				BgL_gz00_15459 = PROCEDURE_REF(BgL_envz00_15458, (int) (((long) 0)));
				{	/* Eval/evaluate_comp.scm 346 */
					obj_t BgL_bpz00_18295;

					BgL_bpz00_18295 = VECTOR_REF(((obj_t) BgL_sz00_15460), ((long) 0));
					return VECTOR_REF(((obj_t) BgL_gz00_15459), ((long) 2));
		}}}

	}



/* &<@anonymous:3032> */
	obj_t BGl_z62zc3z04anonymousza33032ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15461, obj_t BgL_sz00_15464)
	{
		{	/* Eval/evaluate_comp.scm 353 */
			{	/* Eval/evaluate_comp.scm 353 */
				BgL_ev_globalz00_bglt BgL_i1096z00_15462;
				obj_t BgL_slotz00_15463;

				BgL_i1096z00_15462 =
					((BgL_ev_globalz00_bglt)
					PROCEDURE_REF(BgL_envz00_15461, (int) (((long) 0))));
				BgL_slotz00_15463 = PROCEDURE_REF(BgL_envz00_15461, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 353 */
					obj_t BgL_bpz00_18296;

					BgL_bpz00_18296 = VECTOR_REF(((obj_t) BgL_sz00_15464), ((long) 0));
					if (CBOOL(CELL_REF(BgL_slotz00_15463)))
						{	/* Eval/evaluate_comp.scm 354 */
							BFALSE;
						}
					else
						{	/* Eval/evaluate_comp.scm 354 */
							{	/* Eval/evaluate_comp.scm 355 */
								obj_t BgL_auxz00_18297;

								BgL_auxz00_18297 =
									BGl_evmodulezd2findzd2globalz00zz__evmodulez00(
									(((BgL_ev_globalz00_bglt) COBJECT(BgL_i1096z00_15462))->
										BgL_modz00),
									(((BgL_ev_globalz00_bglt) COBJECT(BgL_i1096z00_15462))->
										BgL_namez00));
								CELL_SET(BgL_slotz00_15463, BgL_auxz00_18297);
							}
							if (CBOOL(CELL_REF(BgL_slotz00_15463)))
								{	/* Eval/evaluate_comp.scm 356 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 356 */
									BGl_everrorz00zz__everrorz00(
										(((BgL_ev_globalz00_bglt) COBJECT(BgL_i1096z00_15462))->
											BgL_locz00), BGl_string5798z00zz__evaluate_compz00,
										BGl_string5922z00zz__evaluate_compz00,
										(((BgL_ev_globalz00_bglt) COBJECT(BgL_i1096z00_15462))->
											BgL_namez00));
								}
						}
					{	/* Eval/evaluate_comp.scm 357 */
						obj_t BgL_vz00_18298;

						{	/* Eval/evaluate_comp.scm 357 */
							obj_t BgL_evalzd2globalzd2_18299;

							BgL_evalzd2globalzd2_18299 = CELL_REF(BgL_slotz00_15463);
							BgL_vz00_18298 =
								VECTOR_REF(BgL_evalzd2globalzd2_18299, ((long) 2));
						}
						if ((BgL_vz00_18298 == BUNSPEC))
							{	/* Eval/evaluate_comp.scm 359 */
								int BgL_tz00_18300;

								{	/* Eval/evaluate_comp.scm 359 */
									int BgL_res5096z00_18301;

									{	/* Eval/evaluate_comp.scm 359 */
										obj_t BgL_evalzd2globalzd2_18302;

										BgL_evalzd2globalzd2_18302 = CELL_REF(BgL_slotz00_15463);
										BgL_res5096z00_18301 =
											CINT(VECTOR_REF(BgL_evalzd2globalzd2_18302, ((long) 0)));
									}
									BgL_tz00_18300 = BgL_res5096z00_18301;
								}
								{	/* Eval/evaluate_comp.scm 360 */
									bool_t BgL_test6815z00_34230;

									if (((long) (BgL_tz00_18300) == ((long) 3)))
										{	/* Eval/evaluate_comp.scm 360 */
											BgL_test6815z00_34230 = ((bool_t) 1);
										}
									else
										{	/* Eval/evaluate_comp.scm 360 */
											BgL_test6815z00_34230 =
												((long) (BgL_tz00_18300) == ((long) 4));
										}
									if (BgL_test6815z00_34230)
										{	/* Eval/evaluate_comp.scm 360 */
											return
												BGl_everrorz00zz__everrorz00(
												(((BgL_ev_globalz00_bglt) COBJECT(BgL_i1096z00_15462))->
													BgL_locz00), BGl_string5798z00zz__evaluate_compz00,
												BGl_string5923z00zz__evaluate_compz00,
												(((BgL_ev_globalz00_bglt) COBJECT(BgL_i1096z00_15462))->
													BgL_namez00));
										}
									else
										{	/* Eval/evaluate_comp.scm 360 */
											return BgL_vz00_18298;
										}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 358 */
								return BgL_vz00_18298;
							}
					}
				}
			}
		}

	}



/* &comp-ev_setlocal1397 */
	obj_t BGl_z62compzd2ev_setlocal1397zb0zz__evaluate_compz00(obj_t
		BgL_envz00_15466, obj_t BgL_ez00_15467, obj_t BgL_stkz00_15468)
	{
		{	/* Eval/evaluate_comp.scm 321 */
			{	/* Eval/evaluate_comp.scm 323 */
				obj_t BgL_iz00_18304;
				obj_t BgL_ez00_18305;

				{	/* Eval/evaluate_comp.scm 323 */
					BgL_ev_varz00_bglt BgL_arg2999z00_18306;

					BgL_arg2999z00_18306 =
						(((BgL_ev_setlocalz00_bglt) COBJECT(
								((BgL_ev_setlocalz00_bglt) BgL_ez00_15467)))->BgL_vz00);
					BgL_iz00_18304 =
						BGl__indexz00zz__evaluate_compz00(
						((obj_t) BgL_arg2999z00_18306), BgL_stkz00_15468);
				}
				{	/* Eval/evaluate_comp.scm 323 */
					BgL_ev_exprz00_bglt BgL_arg3000z00_18307;

					BgL_arg3000z00_18307 =
						(((BgL_ev_hookz00_bglt) COBJECT(
								((BgL_ev_hookz00_bglt)
									((BgL_ev_setlocalz00_bglt) BgL_ez00_15467))))->BgL_ez00);
					BgL_ez00_18305 =
						BGl_compz00zz__evaluate_compz00(BgL_arg3000z00_18307,
						BgL_stkz00_15468);
				}
				if (CBOOL(
						(((BgL_ev_varz00_bglt) COBJECT(
									(((BgL_ev_setlocalz00_bglt) COBJECT(
												((BgL_ev_setlocalz00_bglt) BgL_ez00_15467)))->
										BgL_vz00)))->BgL_effz00)))
					{	/* Eval/evaluate_comp.scm 326 */
						obj_t BgL_zc3z04anonymousza32990ze3z87_18308;

						BgL_zc3z04anonymousza32990ze3z87_18308 =
							MAKE_FX_PROCEDURE
							(BGl_z62zc3z04anonymousza32990ze3ze5zz__evaluate_compz00,
							(int) (((long) 1)), (int) (((long) 2)));
						PROCEDURE_SET(BgL_zc3z04anonymousza32990ze3z87_18308,
							(int) (((long) 0)), BgL_iz00_18304);
						PROCEDURE_SET(BgL_zc3z04anonymousza32990ze3z87_18308,
							(int) (((long) 1)), BgL_ez00_18305);
						return BgL_zc3z04anonymousza32990ze3z87_18308;
					}
				else
					{	/* Eval/evaluate_comp.scm 328 */
						obj_t BgL_zc3z04anonymousza32995ze3z87_18309;

						BgL_zc3z04anonymousza32995ze3z87_18309 =
							MAKE_FX_PROCEDURE
							(BGl_z62zc3z04anonymousza32995ze3ze5zz__evaluate_compz00,
							(int) (((long) 1)), (int) (((long) 2)));
						PROCEDURE_SET(BgL_zc3z04anonymousza32995ze3z87_18309,
							(int) (((long) 0)), BgL_iz00_18304);
						PROCEDURE_SET(BgL_zc3z04anonymousza32995ze3z87_18309,
							(int) (((long) 1)), BgL_ez00_18305);
						return BgL_zc3z04anonymousza32995ze3z87_18309;
					}
			}
		}

	}



/* &<@anonymous:2990> */
	obj_t BGl_z62zc3z04anonymousza32990ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15469, obj_t BgL_sz00_15472)
	{
		{	/* Eval/evaluate_comp.scm 326 */
			{	/* Eval/evaluate_comp.scm 326 */
				obj_t BgL_iz00_15470;
				obj_t BgL_ez00_15471;

				BgL_iz00_15470 = PROCEDURE_REF(BgL_envz00_15469, (int) (((long) 0)));
				BgL_ez00_15471 = PROCEDURE_REF(BgL_envz00_15469, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 326 */
					obj_t BgL_bpz00_18310;

					BgL_bpz00_18310 = VECTOR_REF(((obj_t) BgL_sz00_15472), ((long) 0));
					{	/* Eval/evaluate_comp.scm 327 */
						obj_t BgL_arg2991z00_18311;
						obj_t BgL_arg2992z00_18312;

						{	/* Eval/evaluate_comp.scm 327 */
							long BgL_arg2994z00_18313;

							BgL_arg2994z00_18313 =
								((long) CINT(BgL_bpz00_18310) + (long) CINT(BgL_iz00_15470));
							BgL_arg2991z00_18311 =
								VECTOR_REF(((obj_t) BgL_sz00_15472), BgL_arg2994z00_18313);
						}
						BgL_arg2992z00_18312 =
							PROCEDURE_ENTRY(BgL_ez00_15471) (BgL_ez00_15471, BgL_sz00_15472,
							BEOA);
						{	/* Eval/evaluate_comp.scm 202 */
							obj_t BgL_xz00_18314;

							{	/* Eval/evaluate_comp.scm 202 */
								int BgL_auxz00_34283;
								obj_t BgL_tmpz00_34281;

								BgL_auxz00_34283 = (int) (((long) 0));
								BgL_tmpz00_34281 = ((obj_t) BgL_arg2991z00_18311);
								BgL_xz00_18314 =
									STRUCT_SET(BgL_tmpz00_34281, BgL_auxz00_34283,
									BgL_arg2992z00_18312);
							}
							return BUNSPEC;
						}
					}
				}
			}
		}

	}



/* &<@anonymous:2995> */
	obj_t BGl_z62zc3z04anonymousza32995ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15473, obj_t BgL_sz00_15476)
	{
		{	/* Eval/evaluate_comp.scm 328 */
			{	/* Eval/evaluate_comp.scm 328 */
				obj_t BgL_iz00_15474;
				obj_t BgL_ez00_15475;

				BgL_iz00_15474 = PROCEDURE_REF(BgL_envz00_15473, (int) (((long) 0)));
				BgL_ez00_15475 = PROCEDURE_REF(BgL_envz00_15473, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 328 */
					obj_t BgL_bpz00_18315;

					BgL_bpz00_18315 = VECTOR_REF(((obj_t) BgL_sz00_15476), ((long) 0));
					{	/* Eval/evaluate_comp.scm 329 */
						long BgL_arg2996z00_18316;
						obj_t BgL_arg2997z00_18317;

						BgL_arg2996z00_18316 =
							((long) CINT(BgL_bpz00_18315) + (long) CINT(BgL_iz00_15474));
						BgL_arg2997z00_18317 =
							PROCEDURE_ENTRY(BgL_ez00_15475) (BgL_ez00_15475, BgL_sz00_15476,
							BEOA);
						return VECTOR_SET(((obj_t) BgL_sz00_15476), BgL_arg2996z00_18316,
							BgL_arg2997z00_18317);
					}
				}
			}
		}

	}



/* &comp-ev_var1395 */
	obj_t BGl_z62compzd2ev_var1395zb0zz__evaluate_compz00(obj_t BgL_envz00_15477,
		obj_t BgL_varz00_15478, obj_t BgL_stkz00_15479)
	{
		{	/* Eval/evaluate_comp.scm 316 */
			{	/* Eval/evaluate_comp.scm 317 */
				obj_t BgL_iz00_18319;

				BgL_iz00_18319 =
					BGl__indexz00zz__evaluate_compz00(
					((obj_t) ((BgL_ev_varz00_bglt) BgL_varz00_15478)), BgL_stkz00_15479);
				{

					if (INTEGERP(BgL_iz00_18319))
						{	/* Eval/evaluate_comp.scm 319 */
							switch ((long) CINT(BgL_iz00_18319))
								{
								case ((long) 0):

									if (CBOOL(
											(((BgL_ev_varz00_bglt) COBJECT(
														((BgL_ev_varz00_bglt) BgL_varz00_15478)))->
												BgL_effz00)))
										{	/* Eval/evaluate_comp.scm 319 */
											return BGl_proc5924z00zz__evaluate_compz00;
										}
									else
										{	/* Eval/evaluate_comp.scm 319 */
											return BGl_proc5925z00zz__evaluate_compz00;
										}
									break;
								case ((long) 1):

									if (CBOOL(
											(((BgL_ev_varz00_bglt) COBJECT(
														((BgL_ev_varz00_bglt) BgL_varz00_15478)))->
												BgL_effz00)))
										{	/* Eval/evaluate_comp.scm 319 */
											return BGl_proc5926z00zz__evaluate_compz00;
										}
									else
										{	/* Eval/evaluate_comp.scm 319 */
											return BGl_proc5927z00zz__evaluate_compz00;
										}
									break;
								case ((long) 2):

									if (CBOOL(
											(((BgL_ev_varz00_bglt) COBJECT(
														((BgL_ev_varz00_bglt) BgL_varz00_15478)))->
												BgL_effz00)))
										{	/* Eval/evaluate_comp.scm 319 */
											return BGl_proc5928z00zz__evaluate_compz00;
										}
									else
										{	/* Eval/evaluate_comp.scm 319 */
											return BGl_proc5929z00zz__evaluate_compz00;
										}
									break;
								case ((long) 3):

									if (CBOOL(
											(((BgL_ev_varz00_bglt) COBJECT(
														((BgL_ev_varz00_bglt) BgL_varz00_15478)))->
												BgL_effz00)))
										{	/* Eval/evaluate_comp.scm 319 */
											return BGl_proc5930z00zz__evaluate_compz00;
										}
									else
										{	/* Eval/evaluate_comp.scm 319 */
											return BGl_proc5931z00zz__evaluate_compz00;
										}
									break;
								default:
								BgL_case_else1091z00_18320:
									if (CBOOL(
											(((BgL_ev_varz00_bglt) COBJECT(
														((BgL_ev_varz00_bglt) BgL_varz00_15478)))->
												BgL_effz00)))
										{	/* Eval/evaluate_comp.scm 319 */
											obj_t BgL_zc3z04anonymousza32984ze3z87_18321;

											BgL_zc3z04anonymousza32984ze3z87_18321 =
												MAKE_FX_PROCEDURE
												(BGl_z62zc3z04anonymousza32984ze3ze5zz__evaluate_compz00,
												(int) (((long) 1)), (int) (((long) 1)));
											PROCEDURE_SET(BgL_zc3z04anonymousza32984ze3z87_18321,
												(int) (((long) 0)), BgL_iz00_18319);
											return BgL_zc3z04anonymousza32984ze3z87_18321;
										}
									else
										{	/* Eval/evaluate_comp.scm 319 */
											obj_t BgL_zc3z04anonymousza32987ze3z87_18322;

											BgL_zc3z04anonymousza32987ze3z87_18322 =
												MAKE_FX_PROCEDURE
												(BGl_z62zc3z04anonymousza32987ze3ze5zz__evaluate_compz00,
												(int) (((long) 1)), (int) (((long) 1)));
											PROCEDURE_SET(BgL_zc3z04anonymousza32987ze3z87_18322,
												(int) (((long) 0)), BgL_iz00_18319);
											return BgL_zc3z04anonymousza32987ze3z87_18322;
										}
								}
						}
					else
						{	/* Eval/evaluate_comp.scm 319 */
							goto BgL_case_else1091z00_18320;
						}
				}
			}
		}

	}



/* &<@anonymous:2978> */
	obj_t BGl_z62zc3z04anonymousza32978ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15480, obj_t BgL_sz00_15481)
	{
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_bpz00_18323;

				BgL_bpz00_18323 = VECTOR_REF(((obj_t) BgL_sz00_15481), ((long) 0));
				{	/* Eval/evaluate_comp.scm 319 */
					obj_t BgL_arg2979z00_18324;

					{	/* Eval/evaluate_comp.scm 319 */
						long BgL_arg2980z00_18325;

						BgL_arg2980z00_18325 = ((long) CINT(BgL_bpz00_18323) + ((long) 3));
						BgL_arg2979z00_18324 =
							VECTOR_REF(((obj_t) BgL_sz00_15481), BgL_arg2980z00_18325);
					}
					return STRUCT_REF(((obj_t) BgL_arg2979z00_18324), (int) (((long) 0)));
		}}}

	}



/* &<@anonymous:2981> */
	obj_t BGl_z62zc3z04anonymousza32981ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15482, obj_t BgL_sz00_15483)
	{
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_bpz00_18326;

				BgL_bpz00_18326 = VECTOR_REF(((obj_t) BgL_sz00_15483), ((long) 0));
				{	/* Eval/evaluate_comp.scm 319 */
					long BgL_arg2982z00_18327;

					BgL_arg2982z00_18327 = ((long) CINT(BgL_bpz00_18326) + ((long) 3));
					return VECTOR_REF(((obj_t) BgL_sz00_15483), BgL_arg2982z00_18327);
				}
			}
		}

	}



/* &<@anonymous:2970> */
	obj_t BGl_z62zc3z04anonymousza32970ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15484, obj_t BgL_sz00_15485)
	{
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_bpz00_18328;

				BgL_bpz00_18328 = VECTOR_REF(((obj_t) BgL_sz00_15485), ((long) 0));
				{	/* Eval/evaluate_comp.scm 319 */
					obj_t BgL_arg2971z00_18329;

					{	/* Eval/evaluate_comp.scm 319 */
						long BgL_arg2972z00_18330;

						BgL_arg2972z00_18330 = ((long) CINT(BgL_bpz00_18328) + ((long) 2));
						BgL_arg2971z00_18329 =
							VECTOR_REF(((obj_t) BgL_sz00_15485), BgL_arg2972z00_18330);
					}
					return STRUCT_REF(((obj_t) BgL_arg2971z00_18329), (int) (((long) 0)));
		}}}

	}



/* &<@anonymous:2973> */
	obj_t BGl_z62zc3z04anonymousza32973ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15486, obj_t BgL_sz00_15487)
	{
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_bpz00_18331;

				BgL_bpz00_18331 = VECTOR_REF(((obj_t) BgL_sz00_15487), ((long) 0));
				{	/* Eval/evaluate_comp.scm 319 */
					long BgL_arg2976z00_18332;

					BgL_arg2976z00_18332 = ((long) CINT(BgL_bpz00_18331) + ((long) 2));
					return VECTOR_REF(((obj_t) BgL_sz00_15487), BgL_arg2976z00_18332);
				}
			}
		}

	}



/* &<@anonymous:2963> */
	obj_t BGl_z62zc3z04anonymousza32963ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15488, obj_t BgL_sz00_15489)
	{
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_bpz00_18333;

				BgL_bpz00_18333 = VECTOR_REF(((obj_t) BgL_sz00_15489), ((long) 0));
				{	/* Eval/evaluate_comp.scm 319 */
					obj_t BgL_arg2965z00_18334;

					{	/* Eval/evaluate_comp.scm 319 */
						long BgL_arg2966z00_18335;

						BgL_arg2966z00_18335 = ((long) CINT(BgL_bpz00_18333) + ((long) 1));
						BgL_arg2965z00_18334 =
							VECTOR_REF(((obj_t) BgL_sz00_15489), BgL_arg2966z00_18335);
					}
					return STRUCT_REF(((obj_t) BgL_arg2965z00_18334), (int) (((long) 0)));
		}}}

	}



/* &<@anonymous:2967> */
	obj_t BGl_z62zc3z04anonymousza32967ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15490, obj_t BgL_sz00_15491)
	{
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_bpz00_18336;

				BgL_bpz00_18336 = VECTOR_REF(((obj_t) BgL_sz00_15491), ((long) 0));
				{	/* Eval/evaluate_comp.scm 319 */
					long BgL_arg2968z00_18337;

					BgL_arg2968z00_18337 = ((long) CINT(BgL_bpz00_18336) + ((long) 1));
					return VECTOR_REF(((obj_t) BgL_sz00_15491), BgL_arg2968z00_18337);
				}
			}
		}

	}



/* &<@anonymous:2957> */
	obj_t BGl_z62zc3z04anonymousza32957ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15492, obj_t BgL_sz00_15493)
	{
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_bpz00_18338;

				BgL_bpz00_18338 = VECTOR_REF(((obj_t) BgL_sz00_15493), ((long) 0));
				{	/* Eval/evaluate_comp.scm 319 */
					obj_t BgL_arg2958z00_18339;

					{	/* Eval/evaluate_comp.scm 319 */
						long BgL_arg2959z00_18340;

						BgL_arg2959z00_18340 = ((long) CINT(BgL_bpz00_18338) + ((long) 0));
						BgL_arg2958z00_18339 =
							VECTOR_REF(((obj_t) BgL_sz00_15493), BgL_arg2959z00_18340);
					}
					return STRUCT_REF(((obj_t) BgL_arg2958z00_18339), (int) (((long) 0)));
		}}}

	}



/* &<@anonymous:2960> */
	obj_t BGl_z62zc3z04anonymousza32960ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15494, obj_t BgL_sz00_15495)
	{
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_bpz00_18341;

				BgL_bpz00_18341 = VECTOR_REF(((obj_t) BgL_sz00_15495), ((long) 0));
				{	/* Eval/evaluate_comp.scm 319 */
					long BgL_arg2961z00_18342;

					BgL_arg2961z00_18342 = ((long) CINT(BgL_bpz00_18341) + ((long) 0));
					return VECTOR_REF(((obj_t) BgL_sz00_15495), BgL_arg2961z00_18342);
				}
			}
		}

	}



/* &<@anonymous:2984> */
	obj_t BGl_z62zc3z04anonymousza32984ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15496, obj_t BgL_sz00_15498)
	{
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_iz00_15497;

				BgL_iz00_15497 = PROCEDURE_REF(BgL_envz00_15496, (int) (((long) 0)));
				{	/* Eval/evaluate_comp.scm 319 */
					obj_t BgL_bpz00_18343;

					BgL_bpz00_18343 = VECTOR_REF(((obj_t) BgL_sz00_15498), ((long) 0));
					{	/* Eval/evaluate_comp.scm 319 */
						obj_t BgL_arg2985z00_18344;

						{	/* Eval/evaluate_comp.scm 319 */
							long BgL_arg2986z00_18345;

							BgL_arg2986z00_18345 =
								((long) CINT(BgL_bpz00_18343) + (long) CINT(BgL_iz00_15497));
							BgL_arg2985z00_18344 =
								VECTOR_REF(((obj_t) BgL_sz00_15498), BgL_arg2986z00_18345);
						}
						return
							STRUCT_REF(((obj_t) BgL_arg2985z00_18344), (int) (((long) 0)));
		}}}}

	}



/* &<@anonymous:2987> */
	obj_t BGl_z62zc3z04anonymousza32987ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15499, obj_t BgL_sz00_15501)
	{
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_iz00_15500;

				BgL_iz00_15500 = PROCEDURE_REF(BgL_envz00_15499, (int) (((long) 0)));
				{	/* Eval/evaluate_comp.scm 319 */
					obj_t BgL_bpz00_18346;

					BgL_bpz00_18346 = VECTOR_REF(((obj_t) BgL_sz00_15501), ((long) 0));
					{	/* Eval/evaluate_comp.scm 319 */
						long BgL_arg2988z00_18347;

						BgL_arg2988z00_18347 =
							((long) CINT(BgL_bpz00_18346) + (long) CINT(BgL_iz00_15500));
						return VECTOR_REF(((obj_t) BgL_sz00_15501), BgL_arg2988z00_18347);
					}
				}
			}
		}

	}



/* &comp-ev_trap1393 */
	obj_t BGl_z62compzd2ev_trap1393zb0zz__evaluate_compz00(obj_t BgL_envz00_15502,
		obj_t BgL_ez00_15503, obj_t BgL_stkz00_15504)
	{
		{	/* Eval/evaluate_comp.scm 289 */
			{	/* Eval/evaluate_comp.scm 291 */
				obj_t BgL_ez00_18349;

				{	/* Eval/evaluate_comp.scm 291 */
					BgL_ev_exprz00_bglt BgL_arg2954z00_18350;

					BgL_arg2954z00_18350 =
						(((BgL_ev_hookz00_bglt) COBJECT(
								((BgL_ev_hookz00_bglt)
									((BgL_ev_trapz00_bglt) BgL_ez00_15503))))->BgL_ez00);
					BgL_ez00_18349 =
						BGl_compz00zz__evaluate_compz00(BgL_arg2954z00_18350,
						BgL_stkz00_15504);
				}
				{	/* Eval/evaluate_comp.scm 292 */
					obj_t BgL_zc3z04anonymousza32946ze3z87_18351;

					BgL_zc3z04anonymousza32946ze3z87_18351 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3z04anonymousza32946ze3ze5zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 1)));
					PROCEDURE_SET(BgL_zc3z04anonymousza32946ze3z87_18351,
						(int) (((long) 0)), BgL_ez00_18349);
					return BgL_zc3z04anonymousza32946ze3z87_18351;
				}
			}
		}

	}



/* &<@anonymous:2946> */
	obj_t BGl_z62zc3z04anonymousza32946ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15505, obj_t BgL_sz00_15507)
	{
		{	/* Eval/evaluate_comp.scm 292 */
			{	/* Eval/evaluate_comp.scm 292 */
				obj_t BgL_ez00_15506;

				BgL_ez00_15506 = PROCEDURE_REF(BgL_envz00_15505, (int) (((long) 0)));
				{	/* Eval/evaluate_comp.scm 292 */
					obj_t BgL_bpz00_18352;

					BgL_bpz00_18352 = VECTOR_REF(((obj_t) BgL_sz00_15507), ((long) 0));
					{	/* Eval/evaluate_comp.scm 293 */
						obj_t BgL_cmdz00_18353;

						BgL_cmdz00_18353 =
							PROCEDURE_ENTRY(BgL_ez00_15506) (BgL_ez00_15506, BgL_sz00_15507,
							BEOA);
						if ((BgL_cmdz00_18353 == BGl_symbol5932z00zz__evaluate_compz00))
							{	/* Eval/evaluate_comp.scm 294 */
								return BgL_bpz00_18352;
							}
						else
							{	/* Eval/evaluate_comp.scm 294 */
								if ((BgL_cmdz00_18353 == BGl_symbol5934z00zz__evaluate_compz00))
									{	/* Eval/evaluate_comp.scm 294 */
										return BGl_reset_profilez00zz__evaluate_compz00();
									}
								else
									{	/* Eval/evaluate_comp.scm 294 */
										if (
											(BgL_cmdz00_18353 ==
												BGl_symbol5936z00zz__evaluate_compz00))
											{	/* Eval/evaluate_comp.scm 294 */
												return BGl_get_profilez00zz__evaluate_compz00();
											}
										else
											{	/* Eval/evaluate_comp.scm 294 */
												if (
													(BgL_cmdz00_18353 ==
														BGl_symbol5938z00zz__evaluate_compz00))
													{	/* Eval/evaluate_comp.scm 302 */
														obj_t BgL_arg2953z00_18354;

														BgL_arg2953z00_18354 =
															BGl_findzd2statezd2zz__evaluate_compz00();
														return
															VECTOR_SET(
															((obj_t) BgL_arg2953z00_18354), ((long) 0),
															BINT(((long) 2)));
													}
												else
													{	/* Eval/evaluate_comp.scm 294 */
														return
															BGl_errorz00zz__errorz00
															(BGl_string5798z00zz__evaluate_compz00,
															BGl_string5940z00zz__evaluate_compz00,
															BgL_cmdz00_18353);
													}
											}
									}
							}
					}
				}
			}
		}

	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zz__evaluate_compz00()
	{
		{	/* Eval/evaluate_comp.scm 15 */
			BGl_modulezd2initializa7ationz75zz__typez00(((long) 121046086),
				BSTRING_TO_STRING(BGl_string5941z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 330490148),
				BSTRING_TO_STRING(BGl_string5941z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__biglooz00(((long) 180158922),
				BSTRING_TO_STRING(BGl_string5941z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__tvectorz00(((long) 135276775),
				BSTRING_TO_STRING(BGl_string5941z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__structurez00(((long) 128218210),
				BSTRING_TO_STRING(BGl_string5941z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__bexitz00(((long) 340267792),
				BSTRING_TO_STRING(BGl_string5941z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__bignumz00(((long) 6519932),
				BSTRING_TO_STRING(BGl_string5941z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__osz00(((long) 251314740),
				BSTRING_TO_STRING(BGl_string5941z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__dssslz00(((long) 443936801),
				BSTRING_TO_STRING(BGl_string5941z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__bitz00(((long) 439353001),
				BSTRING_TO_STRING(BGl_string5941z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__paramz00(((long) 453939141),
				BSTRING_TO_STRING(BGl_string5941z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 193422112),
				BSTRING_TO_STRING(BGl_string5941z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__threadz00(((long) 224967693),
				BSTRING_TO_STRING(BGl_string5941z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__srfi4z00(((long) 467924964),
				BSTRING_TO_STRING(BGl_string5941z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long) 68574988),
				BSTRING_TO_STRING(BGl_string5941z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)
					93454137), BSTRING_TO_STRING(BGl_string5941z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(((long)
					437057797), BSTRING_TO_STRING(BGl_string5941z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(((long)
					268155843), BSTRING_TO_STRING(BGl_string5941z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long)
					198620800), BSTRING_TO_STRING(BGl_string5941z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)
					473309430), BSTRING_TO_STRING(BGl_string5941z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(((long) 459519430),
				BSTRING_TO_STRING(BGl_string5941z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 460262918),
				BSTRING_TO_STRING(BGl_string5941z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) -400105135),
				BSTRING_TO_STRING(BGl_string5941z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)
					9614678), BSTRING_TO_STRING(BGl_string5941z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long)
					376927882), BSTRING_TO_STRING(BGl_string5941z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(((long)
					228151370), BSTRING_TO_STRING(BGl_string5941z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 127905250),
				BSTRING_TO_STRING(BGl_string5941z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 331540577),
				BSTRING_TO_STRING(BGl_string5941z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long) 86988580),
				BSTRING_TO_STRING(BGl_string5941z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__ppz00(((long) 233942021),
				BSTRING_TO_STRING(BGl_string5941z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 220648206),
				BSTRING_TO_STRING(BGl_string5941z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__prognz00(((long) 177147622),
				BSTRING_TO_STRING(BGl_string5941z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__expandz00(((long) 414007149),
				BSTRING_TO_STRING(BGl_string5941z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__evenvz00(((long) 23062368),
				BSTRING_TO_STRING(BGl_string5941z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__evcompilez00(((long) 492754569),
				BSTRING_TO_STRING(BGl_string5941z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__everrorz00(((long) 375872221),
				BSTRING_TO_STRING(BGl_string5941z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__evmodulez00(((long) 6183155),
				BSTRING_TO_STRING(BGl_string5941z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(((long) 0),
				BSTRING_TO_STRING(BGl_string5941z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__evaluate_uncompz00(((long) 193509656),
				BSTRING_TO_STRING(BGl_string5941z00zz__evaluate_compz00));
			return BGl_modulezd2initializa7ationz75zz__evaluate_usez00(((long)
					20669940), BSTRING_TO_STRING(BGl_string5941z00zz__evaluate_compz00));
		}

	}

#ifdef __cplusplus
}
#endif
